#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 12478
#define SYMBOL_COUNT 269
#define ALIAS_COUNT 3
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_identifier = 1,
  anon_sym___END__ = 2,
  sym_uninterpreted = 3,
  anon_sym_BEGIN = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym_END = 7,
  anon_sym_def = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_DOT = 11,
  anon_sym_COLON_COLON = 12,
  anon_sym_COMMA = 13,
  anon_sym_PIPE = 14,
  anon_sym_SEMI = 15,
  anon_sym_STAR = 16,
  anon_sym_STAR_STAR = 17,
  anon_sym_AMP = 18,
  anon_sym_COLON = 19,
  anon_sym_EQ = 20,
  anon_sym_class = 21,
  anon_sym_LT = 22,
  anon_sym_module = 23,
  anon_sym_end = 24,
  anon_sym_return = 25,
  anon_sym_yield = 26,
  anon_sym_break = 27,
  anon_sym_next = 28,
  sym_redo = 29,
  sym_retry = 30,
  anon_sym_if = 31,
  anon_sym_unless = 32,
  anon_sym_while = 33,
  anon_sym_until = 34,
  anon_sym_rescue = 35,
  anon_sym_for = 36,
  anon_sym_in = 37,
  anon_sym_do = 38,
  anon_sym_case = 39,
  anon_sym_when = 40,
  anon_sym_elsif = 41,
  anon_sym_else = 42,
  anon_sym_then = 43,
  anon_sym_begin = 44,
  anon_sym_ensure = 45,
  anon_sym_EQ_GT = 46,
  anon_sym_LBRACK = 47,
  anon_sym_RBRACK = 48,
  anon_sym_COLON_COLON2 = 49,
  anon_sym_AMP_DOT = 50,
  anon_sym_LPAREN2 = 51,
  anon_sym_PLUS_EQ = 52,
  anon_sym_DASH_EQ = 53,
  anon_sym_STAR_EQ = 54,
  anon_sym_STAR_STAR_EQ = 55,
  anon_sym_SLASH_EQ = 56,
  anon_sym_PIPE_PIPE_EQ = 57,
  anon_sym_PIPE_EQ = 58,
  anon_sym_AMP_AMP_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PERCENT_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_LT_LT_EQ = 63,
  anon_sym_CARET_EQ = 64,
  anon_sym_QMARK = 65,
  anon_sym_COLON2 = 66,
  anon_sym_DOT_DOT = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_and = 69,
  anon_sym_or = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_LT_LT = 73,
  anon_sym_GT_GT = 74,
  anon_sym_EQ_EQ = 75,
  anon_sym_BANG_EQ = 76,
  anon_sym_EQ_EQ_EQ = 77,
  anon_sym_LT_EQ_GT = 78,
  anon_sym_EQ_TILDE = 79,
  anon_sym_BANG_TILDE = 80,
  anon_sym_LT_EQ = 81,
  anon_sym_GT = 82,
  anon_sym_GT_EQ = 83,
  anon_sym_CARET = 84,
  anon_sym_PLUS = 85,
  anon_sym_SLASH = 86,
  anon_sym_PERCENT = 87,
  anon_sym_defined_QMARK = 88,
  anon_sym_not = 89,
  anon_sym_BANG = 90,
  anon_sym_TILDE = 91,
  sym_constant = 92,
  sym_instance_variable = 93,
  sym_class_variable = 94,
  sym_global_variable = 95,
  anon_sym_DASH = 96,
  anon_sym_PLUS_AT = 97,
  anon_sym_DASH_AT = 98,
  anon_sym_LBRACK_RBRACK = 99,
  anon_sym_LBRACK_RBRACK_EQ = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_undef = 102,
  anon_sym_alias = 103,
  sym_comment = 104,
  sym_integer = 105,
  sym_float = 106,
  sym_complex = 107,
  anon_sym_r = 108,
  sym_super = 109,
  anon_sym_true = 110,
  anon_sym_TRUE = 111,
  anon_sym_false = 112,
  anon_sym_FALSE = 113,
  sym_self = 114,
  anon_sym_nil = 115,
  anon_sym_NIL = 116,
  sym_character = 117,
  anon_sym_POUND_LBRACE = 118,
  aux_sym_string_array_token1 = 119,
  sym_escape_sequence = 120,
  anon_sym_LBRACK2 = 121,
  anon_sym_DASH_GT = 122,
  sym__line_break = 123,
  sym__simple_symbol = 124,
  sym__string_start = 125,
  sym__symbol_start = 126,
  sym__subshell_start = 127,
  sym__regex_start = 128,
  sym__string_array_start = 129,
  sym__symbol_array_start = 130,
  sym__heredoc_body_start = 131,
  sym__string_content = 132,
  sym__heredoc_content = 133,
  sym__string_end = 134,
  sym_heredoc_end = 135,
  sym_heredoc_beginning = 136,
  sym__block_ampersand = 137,
  sym__splat_star = 138,
  sym__unary_minus = 139,
  sym__binary_minus = 140,
  sym__binary_star = 141,
  sym__singleton_class_left_angle_left_langle = 142,
  sym__identifier_hash_key = 143,
  sym_program = 144,
  sym__statements = 145,
  sym_begin_block = 146,
  sym_end_block = 147,
  sym__statement = 148,
  sym_method = 149,
  sym_singleton_method = 150,
  sym__method_rest = 151,
  sym_method_parameters = 152,
  sym_lambda_parameters = 153,
  sym_block_parameters = 154,
  sym__formal_parameter = 155,
  sym__simple_formal_parameter = 156,
  sym_destructured_parameter = 157,
  sym_splat_parameter = 158,
  sym_hash_splat_parameter = 159,
  sym_block_parameter = 160,
  sym_keyword_parameter = 161,
  sym_optional_parameter = 162,
  sym_class = 163,
  sym_superclass = 164,
  sym_singleton_class = 165,
  sym_module = 166,
  sym_return = 167,
  sym_yield = 168,
  sym_break = 169,
  sym_next = 170,
  sym_if_modifier = 171,
  sym_unless_modifier = 172,
  sym_while_modifier = 173,
  sym_until_modifier = 174,
  sym_rescue_modifier = 175,
  sym_while = 176,
  sym_until = 177,
  sym_for = 178,
  sym_in = 179,
  sym__do = 180,
  sym_case = 181,
  sym_when = 182,
  sym_pattern = 183,
  sym_if = 184,
  sym_unless = 185,
  sym_elsif = 186,
  sym_else = 187,
  sym_then = 188,
  sym_begin = 189,
  sym_ensure = 190,
  sym_rescue = 191,
  sym_exceptions = 192,
  sym_exception_variable = 193,
  sym__body_statement = 194,
  sym__arg = 195,
  sym__primary = 196,
  sym_parenthesized_statements = 197,
  sym_element_reference = 198,
  sym_scope_resolution = 199,
  sym_call = 200,
  sym_method_call = 201,
  sym_argument_list = 202,
  sym_argument_list_with_parens = 203,
  sym__argument_list_with_parens = 204,
  sym__argument_list_with_trailing_comma = 205,
  sym__argument = 206,
  sym_splat_argument = 207,
  sym_hash_splat_argument = 208,
  sym_block_argument = 209,
  sym_do_block = 210,
  sym_block = 211,
  sym_assignment = 212,
  sym_operator_assignment = 213,
  sym_conditional = 214,
  sym_range = 215,
  sym_binary = 216,
  sym_unary = 217,
  sym_right_assignment_list = 218,
  sym__arg_or_splat_arg = 219,
  sym_left_assignment_list = 220,
  sym__mlhs = 221,
  sym_destructured_left_assignment = 222,
  sym_rest_assignment = 223,
  sym__lhs = 224,
  sym__variable = 225,
  sym_operator = 226,
  sym__method_name = 227,
  sym_setter = 228,
  sym_undef = 229,
  sym_alias = 230,
  sym_rational = 231,
  sym_true = 232,
  sym_false = 233,
  sym_nil = 234,
  sym_chained_string = 235,
  sym_interpolation = 236,
  sym_string = 237,
  sym_subshell = 238,
  sym_string_array = 239,
  sym_symbol_array = 240,
  sym_symbol = 241,
  sym_regex = 242,
  sym_heredoc_body = 243,
  sym__literal_contents = 244,
  sym_array = 245,
  sym_hash = 246,
  sym__hash_items = 247,
  sym_pair = 248,
  sym_lambda = 249,
  sym_empty_statement = 250,
  sym__terminator = 251,
  aux_sym__statements_repeat1 = 252,
  aux_sym_method_parameters_repeat1 = 253,
  aux_sym_lambda_parameters_repeat1 = 254,
  aux_sym_block_parameters_repeat1 = 255,
  aux_sym_case_repeat1 = 256,
  aux_sym_case_repeat2 = 257,
  aux_sym_when_repeat1 = 258,
  aux_sym_exceptions_repeat1 = 259,
  aux_sym_call_repeat1 = 260,
  aux_sym_argument_list_repeat1 = 261,
  aux_sym__mlhs_repeat1 = 262,
  aux_sym_undef_repeat1 = 263,
  aux_sym_chained_string_repeat1 = 264,
  aux_sym_string_array_repeat1 = 265,
  aux_sym_symbol_array_repeat1 = 266,
  aux_sym_heredoc_body_repeat1 = 267,
  aux_sym__literal_contents_repeat1 = 268,
  anon_alias_sym_DQUOTE = 269,
  alias_sym_bare_symbol = 270,
  alias_sym_bare_string = 271,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__simple_symbol] = "_simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym__string_content] = "_string_content",
  [sym__heredoc_content] = "_heredoc_content",
  [sym__string_end] = "_string_end",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "_block_ampersand",
  [sym__splat_star] = "_splat_star",
  [sym__unary_minus] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym__identifier_hash_key] = "symbol",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_method_parameters] = "method_parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_destructured_parameter] = "destructured_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_method_call] = "method_call",
  [sym_argument_list] = "argument_list",
  [sym_argument_list_with_parens] = "argument_list_with_parens",
  [sym__argument_list_with_parens] = "_argument_list_with_parens",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_unary] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym__arg_or_splat_arg] = "_arg_or_splat_arg",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym__hash_items] = "_hash_items",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_method_parameters_repeat1] = "method_parameters_repeat1",
  [aux_sym_lambda_parameters_repeat1] = "lambda_parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_repeat2] = "case_repeat2",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym_call_repeat1] = "call_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_contents_repeat1] = "_literal_contents_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_bare_string] = "bare_string",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = false,
    .named = true,
  },
  [sym__splat_star] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym__identifier_hash_key] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list_with_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_or_splat_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_contents] = {
    .visible = false,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_items] = {
    .visible = false,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_contents_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[25][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = anon_sym_RPAREN,
  },
  [2] = {
    [1] = anon_alias_sym_DQUOTE,
  },
  [3] = {
    [1] = anon_sym_BQUOTE,
  },
  [4] = {
    [1] = anon_sym_SLASH,
  },
  [5] = {
    [2] = anon_sym_RPAREN,
  },
  [6] = {
    [1] = alias_sym_bare_symbol,
    [2] = anon_sym_RPAREN,
  },
  [7] = {
    [2] = anon_alias_sym_DQUOTE,
  },
  [8] = {
    [2] = anon_sym_BQUOTE,
  },
  [9] = {
    [2] = anon_sym_SLASH,
  },
  [10] = {
    [1] = alias_sym_bare_string,
    [2] = anon_sym_RPAREN,
  },
  [11] = {
    [3] = anon_sym_RPAREN,
  },
  [12] = {
    [2] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [13] = {
    [1] = alias_sym_bare_symbol,
    [3] = anon_sym_RPAREN,
  },
  [14] = {
    [1] = alias_sym_bare_symbol,
  },
  [15] = {
    [0] = sym_symbol,
  },
  [16] = {
    [2] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [17] = {
    [1] = alias_sym_bare_string,
    [3] = anon_sym_RPAREN,
  },
  [18] = {
    [1] = alias_sym_bare_string,
  },
  [19] = {
    [2] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [20] = {
    [1] = alias_sym_bare_symbol,
    [4] = anon_sym_RPAREN,
  },
  [21] = {
    [2] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [22] = {
    [1] = alias_sym_bare_string,
    [4] = anon_sym_RPAREN,
  },
  [23] = {
    [2] = alias_sym_bare_symbol,
    [5] = anon_sym_RPAREN,
  },
  [24] = {
    [2] = alias_sym_bare_string,
    [5] = anon_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(12);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'B')
        ADVANCE(23);
      if (lookahead == 'E')
        ADVANCE(24);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(29);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '`')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(37);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(41);
      if (lookahead == '~')
        ADVANCE(42);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{')
        ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(44);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-')
        ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(46);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(47);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(48);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(50);
      if (lookahead == '.')
        ADVANCE(51);
      if (lookahead == '=')
        ADVANCE(52);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '@')
        ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(61);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=')
        ADVANCE(62);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(63);
      if (lookahead == '-')
        ADVANCE(63);
      if (lookahead == '.')
        ADVANCE(64);
      if (lookahead == '_')
        ADVANCE(65);
      if (lookahead == 'i')
        ADVANCE(66);
      if (lookahead == 'x')
        ADVANCE(67);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(38);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(68);
      if (lookahead == 'D' ||
          lookahead == 'd')
        ADVANCE(69);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(72);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(73);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(74);
      if (lookahead == '=')
        ADVANCE(75);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(77);
      if (lookahead == '~')
        ADVANCE(78);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(82);
      END_STATE();
    case 22:
      if (lookahead == '@')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(84);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'E')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'N')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'A')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'I')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'R')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(37);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(91);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(92);
      if (lookahead == '|')
        ADVANCE(93);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 37:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(12);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(95);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'B')
        ADVANCE(23);
      if (lookahead == 'E')
        ADVANCE(24);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(29);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '`')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(37);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(63);
      if (lookahead == '-')
        ADVANCE(63);
      if (lookahead == '.')
        ADVANCE(64);
      if (lookahead == '_')
        ADVANCE(65);
      if (lookahead == 'i')
        ADVANCE(66);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(97);
      if (lookahead == '?')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(46);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(47);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(48);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(46);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(48);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=')
        ADVANCE(98);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(99);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 57:
      if (lookahead == 'i')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.')
        ADVANCE(100);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(101);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(102);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(103);
      END_STATE();
    case 68:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(104);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(105);
      END_STATE();
    case 70:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(107);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(108);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(63);
      if (lookahead == '-')
        ADVANCE(63);
      if (lookahead == '.')
        ADVANCE(64);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == 'i')
        ADVANCE(66);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(110);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>')
        ADVANCE(111);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(112);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(113);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(114);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 83:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(115);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'G')
        ADVANCE(116);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'D')
        ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'L')
        ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'L')
        ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'U')
        ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=')
        ADVANCE(121);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(122);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(64);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(64);
      if (lookahead == '_')
        ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(102);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(103);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(68);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(105);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(108);
      END_STATE();
    case 109:
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(123);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-')
        ADVANCE(124);
      if (lookahead == '{')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(126);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(115);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'I')
        ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'S')
        ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'E')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(64);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(102);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(123);
      END_STATE();
    case 124:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(130);
      END_STATE();
    case 125:
      if (lookahead == '}')
        ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'N')
        ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead == 'E')
        ADVANCE(132);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M')
        ADVANCE(133);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(39);
      END_STATE();
    case 133:
      if (lookahead == '-')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(82);
      END_STATE();
    case 135:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(137);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'B')
        ADVANCE(23);
      if (lookahead == 'E')
        ADVANCE(24);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(143);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 139:
      if (lookahead == '>')
        ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 140:
      if (lookahead == ':')
        ADVANCE(122);
      END_STATE();
    case 141:
      if (lookahead == 'b')
        ADVANCE(145);
      END_STATE();
    case 142:
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(82);
      END_STATE();
    case 143:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(135);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 145:
      if (lookahead == 'e')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'g')
        ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'i')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'n')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        ADVANCE(150);
      if (lookahead == '\r')
        ADVANCE(149);
      if (lookahead != 0)
        ADVANCE(149);
      END_STATE();
    case 150:
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 151:
      if (lookahead == 'e')
        ADVANCE(152);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 152:
      if (lookahead == 'n')
        ADVANCE(153);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 153:
      if (lookahead == 'd')
        ADVANCE(154);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 154:
      if (lookahead == '\n')
        ADVANCE(155);
      if (lookahead == '\r')
        ADVANCE(156);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 156:
      if (lookahead == '\n')
        ADVANCE(155);
      END_STATE();
    case 157:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(162);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(157);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(163);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(157);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 164:
      if (lookahead == '!')
        ADVANCE(165);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(167);
      if (lookahead == '-')
        ADVANCE(168);
      if (lookahead == '.')
        ADVANCE(169);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(174);
      if (lookahead == '\\')
        SKIP(175);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '`')
        ADVANCE(32);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~')
        ADVANCE(42);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@')
        ADVANCE(56);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@')
        ADVANCE(60);
      END_STATE();
    case 169:
      if (lookahead == '.')
        ADVANCE(177);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(178);
      if (lookahead == '=')
        ADVANCE(75);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '~')
        ADVANCE(78);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(179);
      END_STATE();
    case 174:
      if (lookahead == ']')
        ADVANCE(180);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(164);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=')
        ADVANCE(181);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 182:
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        ADVANCE(185);
      if (lookahead == 'u')
        ADVANCE(186);
      if (lookahead == 'x')
        ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(188);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      END_STATE();
    case 186:
      if (lookahead == '{')
        ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(191);
      END_STATE();
    case 187:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(192);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(193);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 190:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(194);
      END_STATE();
    case 191:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(195);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(189);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(189);
      END_STATE();
    case 194:
      if (lookahead == '}')
        ADVANCE(189);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(194);
      END_STATE();
    case 195:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(196);
      END_STATE();
    case 196:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(189);
      END_STATE();
    case 197:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(203);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 198:
      if (lookahead == '=')
        ADVANCE(41);
      if (lookahead == '~')
        ADVANCE(42);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(206);
      if (lookahead == '.')
        ADVANCE(51);
      END_STATE();
    case 200:
      if (lookahead == '*')
        ADVANCE(163);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 203:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(205);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(207);
      END_STATE();
    case 205:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(203);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 208:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 209:
      if (lookahead == '*')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(55);
      END_STATE();
    case 211:
      if (lookahead == '=')
        ADVANCE(58);
      END_STATE();
    case 212:
      if (lookahead == ':')
        ADVANCE(73);
      END_STATE();
    case 213:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(214);
      END_STATE();
    case 214:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 215:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(216);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        SKIP(215);
      END_STATE();
    case 217:
      if (lookahead == '#')
        ADVANCE(3);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(218);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        ADVANCE(219);
      if (lookahead == 'u')
        ADVANCE(186);
      if (lookahead == 'x')
        ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(188);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\')
        ADVANCE(218);
      END_STATE();
    case 220:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 221:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(222);
      END_STATE();
    case 222:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 223:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(226);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 225:
      if (lookahead == '=')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(57);
      END_STATE();
    case 226:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(227);
      END_STATE();
    case 227:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(226);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 228:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(229);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 230:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(231);
      END_STATE();
    case 231:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 232:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'B')
        ADVANCE(23);
      if (lookahead == 'E')
        ADVANCE(24);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(232);
      END_STATE();
    case 234:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(236);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(234);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(236);
      END_STATE();
    case 237:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(73);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 240:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 242:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(244);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 245:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 247:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 248:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 249:
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(77);
      if (lookahead == 'b')
        ADVANCE(145);
      if (lookahead == '~')
        ADVANCE(78);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(251);
      END_STATE();
    case 251:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 252:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(253);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        SKIP(254);
      END_STATE();
    case 254:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(253);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 255:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 257:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 258:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(260);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 259:
      if (lookahead == '.')
        ADVANCE(51);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        SKIP(262);
      END_STATE();
    case 262:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(260);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 263:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        SKIP(265);
      END_STATE();
    case 265:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 266:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 268:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(269);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 269:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(270);
      END_STATE();
    case 270:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(269);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 271:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(272);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 272:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(273);
      END_STATE();
    case 273:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(272);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 274:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(275);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        SKIP(276);
      END_STATE();
    case 276:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(275);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 277:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(278);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 278:
      if (lookahead == '\n')
        SKIP(279);
      END_STATE();
    case 279:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(278);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 280:
      if (lookahead == '!')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(137);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '=')
        ADVANCE(281);
      if (lookahead == '?')
        ADVANCE(142);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(282);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(280);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 281:
      if (lookahead == '>')
        ADVANCE(77);
      if (lookahead == 'b')
        ADVANCE(145);
      END_STATE();
    case 282:
      if (lookahead == '\n')
        SKIP(280);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(283);
      if (lookahead == '#')
        ADVANCE(284);
      if (lookahead == '=')
        ADVANCE(285);
      if (lookahead == '\\')
        ADVANCE(286);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(283);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(284);
      if (lookahead != 0)
        ADVANCE(284);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == 'b')
        ADVANCE(288);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(283);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == 'e')
        ADVANCE(289);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == 'g')
        ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == 'i')
        ADVANCE(291);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == 'n')
        ADVANCE(292);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(293);
      if (lookahead == '\r')
        ADVANCE(292);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(292);
      if (lookahead != 0)
        ADVANCE(292);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(293);
      if (lookahead == '=')
        ADVANCE(294);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      if (lookahead != 0)
        ADVANCE(293);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(293);
      if (lookahead == 'e')
        ADVANCE(295);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      if (lookahead != 0)
        ADVANCE(293);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(293);
      if (lookahead == 'n')
        ADVANCE(296);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      if (lookahead != 0)
        ADVANCE(293);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(293);
      if (lookahead == 'd')
        ADVANCE(297);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      if (lookahead != 0)
        ADVANCE(293);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(298);
      if (lookahead == '\r')
        ADVANCE(299);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(298);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(287);
      if (lookahead != 0)
        ADVANCE(287);
      END_STATE();
    case 300:
      if (lookahead == '!')
        ADVANCE(165);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(167);
      if (lookahead == '-')
        ADVANCE(168);
      if (lookahead == '.')
        ADVANCE(169);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(301);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '[')
        ADVANCE(174);
      if (lookahead == '\\')
        SKIP(302);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '`')
        ADVANCE(32);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 301:
      if (lookahead == '=')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(145);
      if (lookahead == '~')
        ADVANCE(78);
      END_STATE();
    case 302:
      if (lookahead == '\n')
        SKIP(303);
      END_STATE();
    case 303:
      if (lookahead == '!')
        ADVANCE(165);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(158);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(167);
      if (lookahead == '-')
        ADVANCE(168);
      if (lookahead == '.')
        ADVANCE(169);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(301);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '[')
        ADVANCE(174);
      if (lookahead == '\\')
        SKIP(302);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '`')
        ADVANCE(32);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 304:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(305);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(306);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        SKIP(306);
      END_STATE();
    case 306:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(305);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(306);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 307:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(308);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(309);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 308:
      if (lookahead == '\n')
        SKIP(309);
      END_STATE();
    case 309:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(308);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(309);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 310:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(311);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(312);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 311:
      if (lookahead == '\n')
        SKIP(312);
      END_STATE();
    case 312:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(311);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(312);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 313:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(315);
      END_STATE();
    case 315:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 316:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(317);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 317:
      if (lookahead == '\n')
        SKIP(318);
      END_STATE();
    case 318:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(317);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 319:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(320);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(321);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 320:
      if (lookahead == '\n')
        SKIP(321);
      END_STATE();
    case 321:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(320);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(321);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 322:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 323:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 324:
      if (lookahead == '\n')
        SKIP(325);
      END_STATE();
    case 325:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 326:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(327);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 327:
      if (lookahead == '\n')
        SKIP(328);
      END_STATE();
    case 328:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(327);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 329:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(330);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(331);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 330:
      if (lookahead == '\n')
        SKIP(331);
      END_STATE();
    case 331:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(330);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(331);
      if (lookahead != 0 &&
          (lookahead < '"' || '[' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 332:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(333);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(334);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 333:
      if (lookahead == '\n')
        SKIP(334);
      END_STATE();
    case 334:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(333);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(334);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ';' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 335:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 336:
      if (lookahead == '\n')
        SKIP(337);
      END_STATE();
    case 337:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '&')
        ADVANCE(259);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (lookahead != 0 &&
          (lookahead < '!' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 338:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(339);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 339:
      if (lookahead == '\n')
        SKIP(340);
      END_STATE();
    case 340:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(339);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || '\'' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 341:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == ':')
        ADVANCE(229);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(342);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      END_STATE();
    case 342:
      if (lookahead == '\n')
        SKIP(343);
      END_STATE();
    case 343:
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '\\')
        SKIP(342);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      END_STATE();
    case 344:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(345);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 345:
      if (lookahead == '\n')
        SKIP(346);
      END_STATE();
    case 346:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(345);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 347:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        SKIP(349);
      END_STATE();
    case 349:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`')
        ADVANCE(40);
      END_STATE();
    case 350:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 351:
      if (lookahead == '\n')
        SKIP(352);
      END_STATE();
    case 352:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 353:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 354:
      if (lookahead == '\n')
        SKIP(355);
      END_STATE();
    case 355:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(95);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 356:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        SKIP(358);
      END_STATE();
    case 358:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 359:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(360);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(361);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(301);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(359);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(206);
      END_STATE();
    case 361:
      if (lookahead == '.')
        ADVANCE(61);
      END_STATE();
    case 362:
      if (lookahead == '\n')
        SKIP(359);
      END_STATE();
    case 363:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 364:
      if (lookahead == '\n')
        SKIP(365);
      END_STATE();
    case 365:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 366:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(367);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(368);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 367:
      if (lookahead == '\n')
        SKIP(368);
      END_STATE();
    case 368:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(95);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(367);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(368);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 369:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(360);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(361);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(301);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(370);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(369);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 370:
      if (lookahead == '\n')
        SKIP(369);
      END_STATE();
    case 371:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(30);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          (lookahead < '"' || 'Z' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 372:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(373);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 373:
      if (lookahead == '\n')
        SKIP(374);
      END_STATE();
    case 374:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(373);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 375:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(376);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 376:
      if (lookahead == '\n')
        SKIP(377);
      END_STATE();
    case 377:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(95);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(376);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 378:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(379);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 379:
      if (lookahead == '\n')
        SKIP(380);
      END_STATE();
    case 380:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(379);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 381:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(224);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(225);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(376);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 382:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(200);
      if (lookahead == '+')
        ADVANCE(201);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(249);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(364);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(365);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(40);
      END_STATE();
    case 383:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(379);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 384:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(385);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 385:
      if (lookahead == '\n')
        SKIP(386);
      END_STATE();
    case 386:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(209);
      if (lookahead == '+')
        ADVANCE(210);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(211);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(241);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(202);
      if (lookahead == '\\')
        SKIP(385);
      if (lookahead == '^')
        ADVANCE(31);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(34);
      if (lookahead == '}')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(40);
      END_STATE();
    case 387:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(212);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(28);
      if (lookahead == '\\')
        SKIP(388);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(389);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    case 388:
      if (lookahead == '\n')
        SKIP(389);
      END_STATE();
    case 389:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(44);
      if (lookahead == '$')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(166);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '+')
        ADVANCE(138);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(139);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(170);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '=')
        ADVANCE(172);
      if (lookahead == '>')
        ADVANCE(173);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == 'F')
        ADVANCE(25);
      if (lookahead == 'N')
        ADVANCE(26);
      if (lookahead == 'T')
        ADVANCE(27);
      if (lookahead == '[')
        ADVANCE(96);
      if (lookahead == '\\')
        SKIP(388);
      if (lookahead == '^')
        ADVANCE(176);
      if (lookahead == '{')
        ADVANCE(33);
      if (lookahead == '|')
        ADVANCE(204);
      if (lookahead == '~')
        ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(389);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(39);
      if (lookahead != 0 &&
          (lookahead < '"' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}')
        ADVANCE(40);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '\\')
        SKIP(1);
      if (lookahead == '_')
        ADVANCE(2);
      if (lookahead == 'a')
        ADVANCE(3);
      if (lookahead == 'b')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(5);
      if (lookahead == 'd')
        ADVANCE(6);
      if (lookahead == 'e')
        ADVANCE(7);
      if (lookahead == 'f')
        ADVANCE(8);
      if (lookahead == 'i')
        ADVANCE(9);
      if (lookahead == 'm')
        ADVANCE(10);
      if (lookahead == 'n')
        ADVANCE(11);
      if (lookahead == 'o')
        ADVANCE(12);
      if (lookahead == 'r')
        ADVANCE(13);
      if (lookahead == 's')
        ADVANCE(14);
      if (lookahead == 't')
        ADVANCE(15);
      if (lookahead == 'u')
        ADVANCE(16);
      if (lookahead == 'w')
        ADVANCE(17);
      if (lookahead == 'y')
        ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 2:
      if (lookahead == '_')
        ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'l')
        ADVANCE(20);
      if (lookahead == 'n')
        ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(22);
      if (lookahead == 'r')
        ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'a')
        ADVANCE(24);
      if (lookahead == 'l')
        ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'e')
        ADVANCE(26);
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(28);
      if (lookahead == 'n')
        ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(30);
      if (lookahead == 'o')
        ADVANCE(31);
      END_STATE();
    case 9:
      if (lookahead == 'f')
        ADVANCE(32);
      if (lookahead == 'n')
        ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'o')
        ADVANCE(34);
      END_STATE();
    case 11:
      if (lookahead == 'e')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(36);
      if (lookahead == 'o')
        ADVANCE(37);
      END_STATE();
    case 12:
      if (lookahead == 'r')
        ADVANCE(38);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e')
        ADVANCE(39);
      END_STATE();
    case 14:
      if (lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'u')
        ADVANCE(41);
      END_STATE();
    case 15:
      if (lookahead == 'h')
        ADVANCE(42);
      if (lookahead == 'r')
        ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'n')
        ADVANCE(44);
      END_STATE();
    case 17:
      if (lookahead == 'h')
        ADVANCE(45);
      END_STATE();
    case 18:
      if (lookahead == 'i')
        ADVANCE(46);
      END_STATE();
    case 19:
      if (lookahead == 'E')
        ADVANCE(47);
      END_STATE();
    case 20:
      if (lookahead == 'i')
        ADVANCE(48);
      END_STATE();
    case 21:
      if (lookahead == 'd')
        ADVANCE(49);
      END_STATE();
    case 22:
      if (lookahead == 'g')
        ADVANCE(50);
      END_STATE();
    case 23:
      if (lookahead == 'e')
        ADVANCE(51);
      END_STATE();
    case 24:
      if (lookahead == 's')
        ADVANCE(52);
      END_STATE();
    case 25:
      if (lookahead == 'a')
        ADVANCE(53);
      END_STATE();
    case 26:
      if (lookahead == 'f')
        ADVANCE(54);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 28:
      if (lookahead == 's')
        ADVANCE(55);
      END_STATE();
    case 29:
      if (lookahead == 'd')
        ADVANCE(56);
      if (lookahead == 's')
        ADVANCE(57);
      END_STATE();
    case 30:
      if (lookahead == 'l')
        ADVANCE(58);
      END_STATE();
    case 31:
      if (lookahead == 'r')
        ADVANCE(59);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 34:
      if (lookahead == 'd')
        ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'x')
        ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l')
        ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 't')
        ADVANCE(63);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 39:
      if (lookahead == 'd')
        ADVANCE(64);
      if (lookahead == 's')
        ADVANCE(65);
      if (lookahead == 't')
        ADVANCE(66);
      END_STATE();
    case 40:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 41:
      if (lookahead == 'p')
        ADVANCE(68);
      END_STATE();
    case 42:
      if (lookahead == 'e')
        ADVANCE(69);
      END_STATE();
    case 43:
      if (lookahead == 'u')
        ADVANCE(70);
      END_STATE();
    case 44:
      if (lookahead == 'd')
        ADVANCE(71);
      if (lookahead == 'l')
        ADVANCE(72);
      if (lookahead == 't')
        ADVANCE(73);
      END_STATE();
    case 45:
      if (lookahead == 'e')
        ADVANCE(74);
      if (lookahead == 'i')
        ADVANCE(75);
      END_STATE();
    case 46:
      if (lookahead == 'e')
        ADVANCE(76);
      END_STATE();
    case 47:
      if (lookahead == 'N')
        ADVANCE(77);
      END_STATE();
    case 48:
      if (lookahead == 'a')
        ADVANCE(78);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 50:
      if (lookahead == 'i')
        ADVANCE(79);
      END_STATE();
    case 51:
      if (lookahead == 'a')
        ADVANCE(80);
      END_STATE();
    case 52:
      if (lookahead == 'e')
        ADVANCE(81);
      END_STATE();
    case 53:
      if (lookahead == 's')
        ADVANCE(82);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i')
        ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead == 'e')
        ADVANCE(84);
      if (lookahead == 'i')
        ADVANCE(85);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 57:
      if (lookahead == 'u')
        ADVANCE(86);
      END_STATE();
    case 58:
      if (lookahead == 's')
        ADVANCE(87);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'u')
        ADVANCE(88);
      END_STATE();
    case 61:
      if (lookahead == 't')
        ADVANCE(89);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 64:
      if (lookahead == 'o')
        ADVANCE(90);
      END_STATE();
    case 65:
      if (lookahead == 'c')
        ADVANCE(91);
      END_STATE();
    case 66:
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 'u')
        ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 'f')
        ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'e')
        ADVANCE(95);
      END_STATE();
    case 69:
      if (lookahead == 'n')
        ADVANCE(96);
      END_STATE();
    case 70:
      if (lookahead == 'e')
        ADVANCE(97);
      END_STATE();
    case 71:
      if (lookahead == 'e')
        ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'e')
        ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'i')
        ADVANCE(100);
      END_STATE();
    case 74:
      if (lookahead == 'n')
        ADVANCE(101);
      END_STATE();
    case 75:
      if (lookahead == 'l')
        ADVANCE(102);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(103);
      END_STATE();
    case 77:
      if (lookahead == 'D')
        ADVANCE(104);
      END_STATE();
    case 78:
      if (lookahead == 's')
        ADVANCE(105);
      END_STATE();
    case 79:
      if (lookahead == 'n')
        ADVANCE(106);
      END_STATE();
    case 80:
      if (lookahead == 'k')
        ADVANCE(107);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 82:
      if (lookahead == 's')
        ADVANCE(108);
      END_STATE();
    case 83:
      if (lookahead == 'n')
        ADVANCE(109);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 85:
      if (lookahead == 'f')
        ADVANCE(110);
      END_STATE();
    case 86:
      if (lookahead == 'r')
        ADVANCE(111);
      END_STATE();
    case 87:
      if (lookahead == 'e')
        ADVANCE(112);
      END_STATE();
    case 88:
      if (lookahead == 'l')
        ADVANCE(113);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_redo);
      END_STATE();
    case 91:
      if (lookahead == 'u')
        ADVANCE(114);
      END_STATE();
    case 92:
      if (lookahead == 'y')
        ADVANCE(115);
      END_STATE();
    case 93:
      if (lookahead == 'r')
        ADVANCE(116);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 95:
      if (lookahead == 'r')
        ADVANCE(117);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 98:
      if (lookahead == 'f')
        ADVANCE(118);
      END_STATE();
    case 99:
      if (lookahead == 's')
        ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 'l')
        ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 102:
      if (lookahead == 'e')
        ADVANCE(121);
      END_STATE();
    case 103:
      if (lookahead == 'd')
        ADVANCE(122);
      END_STATE();
    case 104:
      if (lookahead == '_')
        ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 109:
      if (lookahead == 'e')
        ADVANCE(124);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 111:
      if (lookahead == 'e')
        ADVANCE(125);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 113:
      if (lookahead == 'e')
        ADVANCE(126);
      END_STATE();
    case 114:
      if (lookahead == 'e')
        ADVANCE(127);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_retry);
      END_STATE();
    case 116:
      if (lookahead == 'n')
        ADVANCE(128);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 119:
      if (lookahead == 's')
        ADVANCE(129);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 123:
      if (lookahead == '_')
        ADVANCE(130);
      END_STATE();
    case 124:
      if (lookahead == 'd')
        ADVANCE(131);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 131:
      if (lookahead == '?')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 135, .external_lex_state = 2},
  [2] = {.lex_state = 157, .external_lex_state = 2},
  [3] = {.lex_state = 164, .external_lex_state = 3},
  [4] = {.lex_state = 135},
  [5] = {.lex_state = 135, .external_lex_state = 2},
  [6] = {.lex_state = 157, .external_lex_state = 2},
  [7] = {.lex_state = 157, .external_lex_state = 2},
  [8] = {.lex_state = 182, .external_lex_state = 4},
  [9] = {.lex_state = 197, .external_lex_state = 5},
  [10] = {.lex_state = 164, .external_lex_state = 3},
  [11] = {.lex_state = 157, .external_lex_state = 6},
  [12] = {.lex_state = 208, .external_lex_state = 5},
  [13] = {.lex_state = 215, .external_lex_state = 7},
  [14] = {.lex_state = 135},
  [15] = {.lex_state = 157, .external_lex_state = 2},
  [16] = {.lex_state = 157, .external_lex_state = 2},
  [17] = {.lex_state = 217, .external_lex_state = 4},
  [18] = {.lex_state = 208, .external_lex_state = 5},
  [19] = {.lex_state = 157, .external_lex_state = 8},
  [20] = {.lex_state = 157},
  [21] = {.lex_state = 164},
  [22] = {.lex_state = 164, .external_lex_state = 3},
  [23] = {.lex_state = 220, .external_lex_state = 9},
  [24] = {.lex_state = 217, .external_lex_state = 4},
  [25] = {.lex_state = 215, .external_lex_state = 10},
  [26] = {.lex_state = 135, .external_lex_state = 2},
  [27] = {.lex_state = 135, .external_lex_state = 2},
  [28] = {.lex_state = 220, .external_lex_state = 9},
  [29] = {.lex_state = 157, .external_lex_state = 11},
  [30] = {.lex_state = 217, .external_lex_state = 4},
  [31] = {.lex_state = 157, .external_lex_state = 8},
  [32] = {.lex_state = 135, .external_lex_state = 10},
  [33] = {.lex_state = 208, .external_lex_state = 5},
  [34] = {.lex_state = 157, .external_lex_state = 8},
  [35] = {.lex_state = 135, .external_lex_state = 12},
  [36] = {.lex_state = 220, .external_lex_state = 9},
  [37] = {.lex_state = 217, .external_lex_state = 4},
  [38] = {.lex_state = 197, .external_lex_state = 5},
  [39] = {.lex_state = 135, .external_lex_state = 2},
  [40] = {.lex_state = 182, .external_lex_state = 4},
  [41] = {.lex_state = 220, .external_lex_state = 9},
  [42] = {.lex_state = 135, .external_lex_state = 13},
  [43] = {.lex_state = 157},
  [44] = {.lex_state = 197, .external_lex_state = 5},
  [45] = {.lex_state = 157},
  [46] = {.lex_state = 157},
  [47] = {.lex_state = 223, .external_lex_state = 9},
  [48] = {.lex_state = 208, .external_lex_state = 5},
  [49] = {.lex_state = 197, .external_lex_state = 5},
  [50] = {.lex_state = 135},
  [51] = {.lex_state = 197, .external_lex_state = 14},
  [52] = {.lex_state = 135},
  [53] = {.lex_state = 135, .external_lex_state = 2},
  [54] = {.lex_state = 220, .external_lex_state = 9},
  [55] = {.lex_state = 220, .external_lex_state = 9},
  [56] = {.lex_state = 157, .external_lex_state = 2},
  [57] = {.lex_state = 157, .external_lex_state = 2},
  [58] = {.lex_state = 220, .external_lex_state = 9},
  [59] = {.lex_state = 157, .external_lex_state = 2},
  [60] = {.lex_state = 164},
  [61] = {.lex_state = 220, .external_lex_state = 9},
  [62] = {.lex_state = 208, .external_lex_state = 5},
  [63] = {.lex_state = 197, .external_lex_state = 5},
  [64] = {.lex_state = 197, .external_lex_state = 5},
  [65] = {.lex_state = 223, .external_lex_state = 9},
  [66] = {.lex_state = 157},
  [67] = {.lex_state = 197, .external_lex_state = 14},
  [68] = {.lex_state = 197, .external_lex_state = 13},
  [69] = {.lex_state = 217, .external_lex_state = 4},
  [70] = {.lex_state = 197, .external_lex_state = 13},
  [71] = {.lex_state = 228, .external_lex_state = 13},
  [72] = {.lex_state = 197, .external_lex_state = 13},
  [73] = {.lex_state = 232, .external_lex_state = 2},
  [74] = {.lex_state = 164, .external_lex_state = 3},
  [75] = {.lex_state = 157, .external_lex_state = 2},
  [76] = {.lex_state = 157, .external_lex_state = 2},
  [77] = {.lex_state = 157, .external_lex_state = 2},
  [78] = {.lex_state = 164},
  [79] = {.lex_state = 220, .external_lex_state = 9},
  [80] = {.lex_state = 220, .external_lex_state = 9},
  [81] = {.lex_state = 220, .external_lex_state = 9},
  [82] = {.lex_state = 220, .external_lex_state = 9},
  [83] = {.lex_state = 135, .external_lex_state = 13},
  [84] = {.lex_state = 197, .external_lex_state = 5},
  [85] = {.lex_state = 157},
  [86] = {.lex_state = 223, .external_lex_state = 9},
  [87] = {.lex_state = 208, .external_lex_state = 5},
  [88] = {.lex_state = 197, .external_lex_state = 5},
  [89] = {.lex_state = 197, .external_lex_state = 14},
  [90] = {.lex_state = 197, .external_lex_state = 5},
  [91] = {.lex_state = 197, .external_lex_state = 5},
  [92] = {.lex_state = 197, .external_lex_state = 5},
  [93] = {.lex_state = 182, .external_lex_state = 4},
  [94] = {.lex_state = 135, .external_lex_state = 2},
  [95] = {.lex_state = 234, .external_lex_state = 15},
  [96] = {.lex_state = 182, .external_lex_state = 4},
  [97] = {.lex_state = 164, .external_lex_state = 3},
  [98] = {.lex_state = 217, .external_lex_state = 4},
  [99] = {.lex_state = 164, .external_lex_state = 3},
  [100] = {.lex_state = 164, .external_lex_state = 3},
  [101] = {.lex_state = 164, .external_lex_state = 3},
  [102] = {.lex_state = 197, .external_lex_state = 5},
  [103] = {.lex_state = 157, .external_lex_state = 2},
  [104] = {.lex_state = 135, .external_lex_state = 2},
  [105] = {.lex_state = 157, .external_lex_state = 2},
  [106] = {.lex_state = 157, .external_lex_state = 2},
  [107] = {.lex_state = 182, .external_lex_state = 4},
  [108] = {.lex_state = 237, .external_lex_state = 16},
  [109] = {.lex_state = 157, .external_lex_state = 6},
  [110] = {.lex_state = 242, .external_lex_state = 16},
  [111] = {.lex_state = 215, .external_lex_state = 7},
  [112] = {.lex_state = 245, .external_lex_state = 17},
  [113] = {.lex_state = 157, .external_lex_state = 2},
  [114] = {.lex_state = 157, .external_lex_state = 2},
  [115] = {.lex_state = 217, .external_lex_state = 4},
  [116] = {.lex_state = 242, .external_lex_state = 16},
  [117] = {.lex_state = 157, .external_lex_state = 8},
  [118] = {.lex_state = 157},
  [119] = {.lex_state = 164},
  [120] = {.lex_state = 228},
  [121] = {.lex_state = 164, .external_lex_state = 3},
  [122] = {.lex_state = 248, .external_lex_state = 17},
  [123] = {.lex_state = 157, .external_lex_state = 2},
  [124] = {.lex_state = 217, .external_lex_state = 4},
  [125] = {.lex_state = 215, .external_lex_state = 10},
  [126] = {.lex_state = 135, .external_lex_state = 2},
  [127] = {.lex_state = 157, .external_lex_state = 2},
  [128] = {.lex_state = 248, .external_lex_state = 17},
  [129] = {.lex_state = 157, .external_lex_state = 11},
  [130] = {.lex_state = 217, .external_lex_state = 4},
  [131] = {.lex_state = 157, .external_lex_state = 8},
  [132] = {.lex_state = 135, .external_lex_state = 10},
  [133] = {.lex_state = 242, .external_lex_state = 16},
  [134] = {.lex_state = 248, .external_lex_state = 17},
  [135] = {.lex_state = 217, .external_lex_state = 4},
  [136] = {.lex_state = 237, .external_lex_state = 16},
  [137] = {.lex_state = 157, .external_lex_state = 2},
  [138] = {.lex_state = 135, .external_lex_state = 2},
  [139] = {.lex_state = 182, .external_lex_state = 4},
  [140] = {.lex_state = 248, .external_lex_state = 17},
  [141] = {.lex_state = 157, .external_lex_state = 18},
  [142] = {.lex_state = 252, .external_lex_state = 16},
  [143] = {.lex_state = 255, .external_lex_state = 16},
  [144] = {.lex_state = 255, .external_lex_state = 16},
  [145] = {.lex_state = 245, .external_lex_state = 17},
  [146] = {.lex_state = 157},
  [147] = {.lex_state = 255, .external_lex_state = 19},
  [148] = {.lex_state = 157},
  [149] = {.lex_state = 157, .external_lex_state = 2},
  [150] = {.lex_state = 197, .external_lex_state = 5},
  [151] = {.lex_state = 135, .external_lex_state = 2},
  [152] = {.lex_state = 157, .external_lex_state = 2},
  [153] = {.lex_state = 157, .external_lex_state = 2},
  [154] = {.lex_state = 182, .external_lex_state = 4},
  [155] = {.lex_state = 197, .external_lex_state = 20},
  [156] = {.lex_state = 157, .external_lex_state = 6},
  [157] = {.lex_state = 242, .external_lex_state = 20},
  [158] = {.lex_state = 215, .external_lex_state = 7},
  [159] = {.lex_state = 245, .external_lex_state = 21},
  [160] = {.lex_state = 157, .external_lex_state = 2},
  [161] = {.lex_state = 217, .external_lex_state = 22},
  [162] = {.lex_state = 157, .external_lex_state = 2},
  [163] = {.lex_state = 217, .external_lex_state = 4},
  [164] = {.lex_state = 242, .external_lex_state = 20},
  [165] = {.lex_state = 157, .external_lex_state = 8},
  [166] = {.lex_state = 157},
  [167] = {.lex_state = 164},
  [168] = {.lex_state = 228},
  [169] = {.lex_state = 164, .external_lex_state = 3},
  [170] = {.lex_state = 220, .external_lex_state = 21},
  [171] = {.lex_state = 217, .external_lex_state = 4},
  [172] = {.lex_state = 215, .external_lex_state = 10},
  [173] = {.lex_state = 135, .external_lex_state = 2},
  [174] = {.lex_state = 220, .external_lex_state = 21},
  [175] = {.lex_state = 157, .external_lex_state = 11},
  [176] = {.lex_state = 217, .external_lex_state = 4},
  [177] = {.lex_state = 157, .external_lex_state = 8},
  [178] = {.lex_state = 135, .external_lex_state = 10},
  [179] = {.lex_state = 242, .external_lex_state = 20},
  [180] = {.lex_state = 220, .external_lex_state = 21},
  [181] = {.lex_state = 217, .external_lex_state = 4},
  [182] = {.lex_state = 197, .external_lex_state = 20},
  [183] = {.lex_state = 157, .external_lex_state = 2},
  [184] = {.lex_state = 135, .external_lex_state = 2},
  [185] = {.lex_state = 182, .external_lex_state = 4},
  [186] = {.lex_state = 220, .external_lex_state = 21},
  [187] = {.lex_state = 242, .external_lex_state = 20},
  [188] = {.lex_state = 197, .external_lex_state = 20},
  [189] = {.lex_state = 197, .external_lex_state = 20},
  [190] = {.lex_state = 215, .external_lex_state = 18},
  [191] = {.lex_state = 215, .external_lex_state = 18},
  [192] = {.lex_state = 215, .external_lex_state = 18},
  [193] = {.lex_state = 245, .external_lex_state = 21},
  [194] = {.lex_state = 157},
  [195] = {.lex_state = 197, .external_lex_state = 23},
  [196] = {.lex_state = 215},
  [197] = {.lex_state = 232, .external_lex_state = 2},
  [198] = {.lex_state = 197, .external_lex_state = 5},
  [199] = {.lex_state = 197, .external_lex_state = 5},
  [200] = {.lex_state = 197, .external_lex_state = 14},
  [201] = {.lex_state = 135, .external_lex_state = 2},
  [202] = {.lex_state = 135, .external_lex_state = 15},
  [203] = {.lex_state = 217, .external_lex_state = 4},
  [204] = {.lex_state = 258, .external_lex_state = 6},
  [205] = {.lex_state = 258},
  [206] = {.lex_state = 182, .external_lex_state = 4},
  [207] = {.lex_state = 157, .external_lex_state = 2},
  [208] = {.lex_state = 215, .external_lex_state = 10},
  [209] = {.lex_state = 217, .external_lex_state = 4},
  [210] = {.lex_state = 135, .external_lex_state = 2},
  [211] = {.lex_state = 258, .external_lex_state = 6},
  [212] = {.lex_state = 135, .external_lex_state = 2},
  [213] = {.lex_state = 157, .external_lex_state = 11},
  [214] = {.lex_state = 157, .external_lex_state = 8},
  [215] = {.lex_state = 135, .external_lex_state = 10},
  [216] = {.lex_state = 258},
  [217] = {.lex_state = 217, .external_lex_state = 4},
  [218] = {.lex_state = 182, .external_lex_state = 4},
  [219] = {.lex_state = 263},
  [220] = {.lex_state = 258},
  [221] = {.lex_state = 157, .external_lex_state = 6},
  [222] = {.lex_state = 157, .external_lex_state = 8},
  [223] = {.lex_state = 215, .external_lex_state = 7},
  [224] = {.lex_state = 258, .external_lex_state = 6},
  [225] = {.lex_state = 157, .external_lex_state = 2},
  [226] = {.lex_state = 217, .external_lex_state = 4},
  [227] = {.lex_state = 258},
  [228] = {.lex_state = 157, .external_lex_state = 8},
  [229] = {.lex_state = 217, .external_lex_state = 4},
  [230] = {.lex_state = 157},
  [231] = {.lex_state = 164},
  [232] = {.lex_state = 164, .external_lex_state = 3},
  [233] = {.lex_state = 258, .external_lex_state = 6},
  [234] = {.lex_state = 135, .external_lex_state = 2},
  [235] = {.lex_state = 157},
  [236] = {.lex_state = 258},
  [237] = {.lex_state = 258},
  [238] = {.lex_state = 258, .external_lex_state = 6},
  [239] = {.lex_state = 258, .external_lex_state = 24},
  [240] = {.lex_state = 135},
  [241] = {.lex_state = 157},
  [242] = {.lex_state = 135, .external_lex_state = 10},
  [243] = {.lex_state = 157},
  [244] = {.lex_state = 228},
  [245] = {.lex_state = 135},
  [246] = {.lex_state = 232, .external_lex_state = 2},
  [247] = {.lex_state = 266},
  [248] = {.lex_state = 197, .external_lex_state = 5},
  [249] = {.lex_state = 135},
  [250] = {.lex_state = 157},
  [251] = {.lex_state = 223, .external_lex_state = 9},
  [252] = {.lex_state = 215, .external_lex_state = 13},
  [253] = {.lex_state = 217, .external_lex_state = 4},
  [254] = {.lex_state = 157, .external_lex_state = 2},
  [255] = {.lex_state = 215, .external_lex_state = 13},
  [256] = {.lex_state = 215, .external_lex_state = 13},
  [257] = {.lex_state = 215, .external_lex_state = 13},
  [258] = {.lex_state = 215, .external_lex_state = 13},
  [259] = {.lex_state = 197, .external_lex_state = 5},
  [260] = {.lex_state = 157},
  [261] = {.lex_state = 157, .external_lex_state = 2},
  [262] = {.lex_state = 135, .external_lex_state = 2},
  [263] = {.lex_state = 157, .external_lex_state = 2},
  [264] = {.lex_state = 157, .external_lex_state = 2},
  [265] = {.lex_state = 182, .external_lex_state = 4},
  [266] = {.lex_state = 197, .external_lex_state = 5},
  [267] = {.lex_state = 157, .external_lex_state = 6},
  [268] = {.lex_state = 268, .external_lex_state = 5},
  [269] = {.lex_state = 215, .external_lex_state = 7},
  [270] = {.lex_state = 271, .external_lex_state = 9},
  [271] = {.lex_state = 157, .external_lex_state = 2},
  [272] = {.lex_state = 157, .external_lex_state = 2},
  [273] = {.lex_state = 217, .external_lex_state = 4},
  [274] = {.lex_state = 268, .external_lex_state = 5},
  [275] = {.lex_state = 157, .external_lex_state = 8},
  [276] = {.lex_state = 157},
  [277] = {.lex_state = 164},
  [278] = {.lex_state = 228},
  [279] = {.lex_state = 164, .external_lex_state = 3},
  [280] = {.lex_state = 220, .external_lex_state = 9},
  [281] = {.lex_state = 157, .external_lex_state = 2},
  [282] = {.lex_state = 217, .external_lex_state = 4},
  [283] = {.lex_state = 215, .external_lex_state = 10},
  [284] = {.lex_state = 266, .external_lex_state = 6},
  [285] = {.lex_state = 135, .external_lex_state = 2},
  [286] = {.lex_state = 157, .external_lex_state = 2},
  [287] = {.lex_state = 220, .external_lex_state = 9},
  [288] = {.lex_state = 157, .external_lex_state = 11},
  [289] = {.lex_state = 217, .external_lex_state = 4},
  [290] = {.lex_state = 157, .external_lex_state = 8},
  [291] = {.lex_state = 135, .external_lex_state = 10},
  [292] = {.lex_state = 268, .external_lex_state = 5},
  [293] = {.lex_state = 220, .external_lex_state = 9},
  [294] = {.lex_state = 217, .external_lex_state = 4},
  [295] = {.lex_state = 197, .external_lex_state = 5},
  [296] = {.lex_state = 157, .external_lex_state = 2},
  [297] = {.lex_state = 135, .external_lex_state = 2},
  [298] = {.lex_state = 182, .external_lex_state = 4},
  [299] = {.lex_state = 220, .external_lex_state = 9},
  [300] = {.lex_state = 197, .external_lex_state = 5},
  [301] = {.lex_state = 268, .external_lex_state = 5},
  [302] = {.lex_state = 197, .external_lex_state = 5},
  [303] = {.lex_state = 197, .external_lex_state = 5},
  [304] = {.lex_state = 271, .external_lex_state = 9},
  [305] = {.lex_state = 157},
  [306] = {.lex_state = 197, .external_lex_state = 14},
  [307] = {.lex_state = 197, .external_lex_state = 5},
  [308] = {.lex_state = 197, .external_lex_state = 5},
  [309] = {.lex_state = 197, .external_lex_state = 5},
  [310] = {.lex_state = 135, .external_lex_state = 15},
  [311] = {.lex_state = 220, .external_lex_state = 9},
  [312] = {.lex_state = 220, .external_lex_state = 9},
  [313] = {.lex_state = 157, .external_lex_state = 2},
  [314] = {.lex_state = 157, .external_lex_state = 2},
  [315] = {.lex_state = 220, .external_lex_state = 9},
  [316] = {.lex_state = 157, .external_lex_state = 2},
  [317] = {.lex_state = 220, .external_lex_state = 9},
  [318] = {.lex_state = 208, .external_lex_state = 5},
  [319] = {.lex_state = 197, .external_lex_state = 5},
  [320] = {.lex_state = 223, .external_lex_state = 9},
  [321] = {.lex_state = 157},
  [322] = {.lex_state = 197, .external_lex_state = 14},
  [323] = {.lex_state = 135},
  [324] = {.lex_state = 164, .external_lex_state = 3},
  [325] = {.lex_state = 197, .external_lex_state = 5},
  [326] = {.lex_state = 157, .external_lex_state = 2},
  [327] = {.lex_state = 157, .external_lex_state = 2},
  [328] = {.lex_state = 157, .external_lex_state = 2},
  [329] = {.lex_state = 164},
  [330] = {.lex_state = 220, .external_lex_state = 9},
  [331] = {.lex_state = 135, .external_lex_state = 2},
  [332] = {.lex_state = 220, .external_lex_state = 9},
  [333] = {.lex_state = 266, .external_lex_state = 8},
  [334] = {.lex_state = 220, .external_lex_state = 9},
  [335] = {.lex_state = 220, .external_lex_state = 9},
  [336] = {.lex_state = 135, .external_lex_state = 13},
  [337] = {.lex_state = 258},
  [338] = {.lex_state = 274, .external_lex_state = 5},
  [339] = {.lex_state = 157},
  [340] = {.lex_state = 258},
  [341] = {.lex_state = 223, .external_lex_state = 9},
  [342] = {.lex_state = 277, .external_lex_state = 5},
  [343] = {.lex_state = 274, .external_lex_state = 5},
  [344] = {.lex_state = 274, .external_lex_state = 14},
  [345] = {.lex_state = 135},
  [346] = {.lex_state = 135, .external_lex_state = 2},
  [347] = {.lex_state = 197, .external_lex_state = 5},
  [348] = {.lex_state = 135, .external_lex_state = 2},
  [349] = {.lex_state = 157, .external_lex_state = 2},
  [350] = {.lex_state = 258, .external_lex_state = 25},
  [351] = {.lex_state = 164},
  [352] = {.lex_state = 258},
  [353] = {.lex_state = 258, .external_lex_state = 6},
  [354] = {.lex_state = 258, .external_lex_state = 25},
  [355] = {.lex_state = 197, .external_lex_state = 5},
  [356] = {.lex_state = 135, .external_lex_state = 15},
  [357] = {.lex_state = 258, .external_lex_state = 25},
  [358] = {.lex_state = 164},
  [359] = {.lex_state = 258},
  [360] = {.lex_state = 258, .external_lex_state = 25},
  [361] = {.lex_state = 164, .external_lex_state = 3},
  [362] = {.lex_state = 157, .external_lex_state = 2},
  [363] = {.lex_state = 157, .external_lex_state = 2},
  [364] = {.lex_state = 280, .external_lex_state = 26},
  [365] = {.lex_state = 217, .external_lex_state = 22},
  [366] = {.lex_state = 157, .external_lex_state = 2},
  [367] = {.lex_state = 135, .external_lex_state = 10},
  [368] = {.lex_state = 164},
  [369] = {.lex_state = 220, .external_lex_state = 9},
  [370] = {.lex_state = 220, .external_lex_state = 9},
  [371] = {.lex_state = 220, .external_lex_state = 9},
  [372] = {.lex_state = 135, .external_lex_state = 2},
  [373] = {.lex_state = 220, .external_lex_state = 9},
  [374] = {.lex_state = 135, .external_lex_state = 13},
  [375] = {.lex_state = 135},
  [376] = {.lex_state = 197, .external_lex_state = 5},
  [377] = {.lex_state = 157},
  [378] = {.lex_state = 135},
  [379] = {.lex_state = 135, .external_lex_state = 2},
  [380] = {.lex_state = 197, .external_lex_state = 5},
  [381] = {.lex_state = 223, .external_lex_state = 9},
  [382] = {.lex_state = 208, .external_lex_state = 5},
  [383] = {.lex_state = 197, .external_lex_state = 5},
  [384] = {.lex_state = 197, .external_lex_state = 14},
  [385] = {.lex_state = 135},
  [386] = {.lex_state = 135},
  [387] = {.lex_state = 135, .external_lex_state = 2},
  [388] = {.lex_state = 164},
  [389] = {.lex_state = 258},
  [390] = {.lex_state = 258},
  [391] = {.lex_state = 258, .external_lex_state = 6},
  [392] = {.lex_state = 283},
  [393] = {.lex_state = 197, .external_lex_state = 5},
  [394] = {.lex_state = 197, .external_lex_state = 5},
  [395] = {.lex_state = 135, .external_lex_state = 15},
  [396] = {.lex_state = 197, .external_lex_state = 5},
  [397] = {.lex_state = 135, .external_lex_state = 13},
  [398] = {.lex_state = 197, .external_lex_state = 5},
  [399] = {.lex_state = 182, .external_lex_state = 4},
  [400] = {.lex_state = 234, .external_lex_state = 15},
  [401] = {.lex_state = 197, .external_lex_state = 5},
  [402] = {.lex_state = 157, .external_lex_state = 2},
  [403] = {.lex_state = 157, .external_lex_state = 2},
  [404] = {.lex_state = 157, .external_lex_state = 2},
  [405] = {.lex_state = 217, .external_lex_state = 22},
  [406] = {.lex_state = 157, .external_lex_state = 2},
  [407] = {.lex_state = 157, .external_lex_state = 2},
  [408] = {.lex_state = 135, .external_lex_state = 2},
  [409] = {.lex_state = 157, .external_lex_state = 8},
  [410] = {.lex_state = 157},
  [411] = {.lex_state = 300, .external_lex_state = 27},
  [412] = {.lex_state = 157, .external_lex_state = 6},
  [413] = {.lex_state = 164},
  [414] = {.lex_state = 157, .external_lex_state = 28},
  [415] = {.lex_state = 157, .external_lex_state = 2},
  [416] = {.lex_state = 135, .external_lex_state = 2},
  [417] = {.lex_state = 157, .external_lex_state = 2},
  [418] = {.lex_state = 157, .external_lex_state = 2},
  [419] = {.lex_state = 182, .external_lex_state = 4},
  [420] = {.lex_state = 268, .external_lex_state = 5},
  [421] = {.lex_state = 157, .external_lex_state = 6},
  [422] = {.lex_state = 232, .external_lex_state = 7},
  [423] = {.lex_state = 271, .external_lex_state = 9},
  [424] = {.lex_state = 157, .external_lex_state = 2},
  [425] = {.lex_state = 157, .external_lex_state = 2},
  [426] = {.lex_state = 217, .external_lex_state = 4},
  [427] = {.lex_state = 157, .external_lex_state = 8},
  [428] = {.lex_state = 135, .external_lex_state = 10},
  [429] = {.lex_state = 157},
  [430] = {.lex_state = 228},
  [431] = {.lex_state = 164, .external_lex_state = 3},
  [432] = {.lex_state = 271, .external_lex_state = 9},
  [433] = {.lex_state = 157, .external_lex_state = 2},
  [434] = {.lex_state = 217, .external_lex_state = 4},
  [435] = {.lex_state = 215, .external_lex_state = 10},
  [436] = {.lex_state = 266, .external_lex_state = 6},
  [437] = {.lex_state = 135, .external_lex_state = 2},
  [438] = {.lex_state = 157, .external_lex_state = 2},
  [439] = {.lex_state = 271, .external_lex_state = 9},
  [440] = {.lex_state = 157, .external_lex_state = 11},
  [441] = {.lex_state = 217, .external_lex_state = 4},
  [442] = {.lex_state = 157, .external_lex_state = 8},
  [443] = {.lex_state = 135, .external_lex_state = 10},
  [444] = {.lex_state = 271, .external_lex_state = 9},
  [445] = {.lex_state = 217, .external_lex_state = 4},
  [446] = {.lex_state = 268, .external_lex_state = 5},
  [447] = {.lex_state = 157, .external_lex_state = 2},
  [448] = {.lex_state = 135, .external_lex_state = 2},
  [449] = {.lex_state = 182, .external_lex_state = 4},
  [450] = {.lex_state = 271, .external_lex_state = 9},
  [451] = {.lex_state = 208, .external_lex_state = 5},
  [452] = {.lex_state = 268, .external_lex_state = 5},
  [453] = {.lex_state = 208, .external_lex_state = 5},
  [454] = {.lex_state = 157},
  [455] = {.lex_state = 271, .external_lex_state = 9},
  [456] = {.lex_state = 208, .external_lex_state = 5},
  [457] = {.lex_state = 268, .external_lex_state = 5},
  [458] = {.lex_state = 268, .external_lex_state = 5},
  [459] = {.lex_state = 268, .external_lex_state = 14},
  [460] = {.lex_state = 208, .external_lex_state = 5},
  [461] = {.lex_state = 157, .external_lex_state = 2},
  [462] = {.lex_state = 157, .external_lex_state = 2},
  [463] = {.lex_state = 157, .external_lex_state = 2},
  [464] = {.lex_state = 157, .external_lex_state = 2},
  [465] = {.lex_state = 157, .external_lex_state = 2},
  [466] = {.lex_state = 157, .external_lex_state = 2},
  [467] = {.lex_state = 157, .external_lex_state = 2},
  [468] = {.lex_state = 157, .external_lex_state = 2},
  [469] = {.lex_state = 157, .external_lex_state = 2},
  [470] = {.lex_state = 157, .external_lex_state = 2},
  [471] = {.lex_state = 157, .external_lex_state = 2},
  [472] = {.lex_state = 197, .external_lex_state = 14},
  [473] = {.lex_state = 135, .external_lex_state = 12},
  [474] = {.lex_state = 135, .external_lex_state = 13},
  [475] = {.lex_state = 135, .external_lex_state = 2},
  [476] = {.lex_state = 157, .external_lex_state = 2},
  [477] = {.lex_state = 157, .external_lex_state = 2},
  [478] = {.lex_state = 271, .external_lex_state = 9},
  [479] = {.lex_state = 157, .external_lex_state = 2},
  [480] = {.lex_state = 164},
  [481] = {.lex_state = 228},
  [482] = {.lex_state = 220, .external_lex_state = 9},
  [483] = {.lex_state = 157, .external_lex_state = 2},
  [484] = {.lex_state = 157, .external_lex_state = 2},
  [485] = {.lex_state = 220, .external_lex_state = 9},
  [486] = {.lex_state = 220, .external_lex_state = 9},
  [487] = {.lex_state = 157, .external_lex_state = 2},
  [488] = {.lex_state = 220, .external_lex_state = 9},
  [489] = {.lex_state = 197, .external_lex_state = 5},
  [490] = {.lex_state = 268, .external_lex_state = 5},
  [491] = {.lex_state = 197, .external_lex_state = 5},
  [492] = {.lex_state = 197, .external_lex_state = 5},
  [493] = {.lex_state = 271, .external_lex_state = 9},
  [494] = {.lex_state = 157},
  [495] = {.lex_state = 197, .external_lex_state = 14},
  [496] = {.lex_state = 197, .external_lex_state = 5},
  [497] = {.lex_state = 197, .external_lex_state = 5},
  [498] = {.lex_state = 197, .external_lex_state = 5},
  [499] = {.lex_state = 223, .external_lex_state = 9},
  [500] = {.lex_state = 157, .external_lex_state = 2},
  [501] = {.lex_state = 157, .external_lex_state = 28},
  [502] = {.lex_state = 157, .external_lex_state = 2},
  [503] = {.lex_state = 157, .external_lex_state = 2},
  [504] = {.lex_state = 157, .external_lex_state = 2},
  [505] = {.lex_state = 157, .external_lex_state = 2},
  [506] = {.lex_state = 157, .external_lex_state = 2},
  [507] = {.lex_state = 157, .external_lex_state = 2},
  [508] = {.lex_state = 157, .external_lex_state = 2},
  [509] = {.lex_state = 157, .external_lex_state = 2},
  [510] = {.lex_state = 157, .external_lex_state = 2},
  [511] = {.lex_state = 217, .external_lex_state = 22},
  [512] = {.lex_state = 157, .external_lex_state = 2},
  [513] = {.lex_state = 135, .external_lex_state = 2},
  [514] = {.lex_state = 300, .external_lex_state = 27},
  [515] = {.lex_state = 164},
  [516] = {.lex_state = 157, .external_lex_state = 2},
  [517] = {.lex_state = 157, .external_lex_state = 2},
  [518] = {.lex_state = 232, .external_lex_state = 7},
  [519] = {.lex_state = 271, .external_lex_state = 9},
  [520] = {.lex_state = 157, .external_lex_state = 2},
  [521] = {.lex_state = 228},
  [522] = {.lex_state = 271, .external_lex_state = 9},
  [523] = {.lex_state = 157, .external_lex_state = 2},
  [524] = {.lex_state = 157, .external_lex_state = 2},
  [525] = {.lex_state = 271, .external_lex_state = 9},
  [526] = {.lex_state = 271, .external_lex_state = 9},
  [527] = {.lex_state = 157, .external_lex_state = 2},
  [528] = {.lex_state = 271, .external_lex_state = 9},
  [529] = {.lex_state = 268, .external_lex_state = 5},
  [530] = {.lex_state = 208, .external_lex_state = 5},
  [531] = {.lex_state = 157},
  [532] = {.lex_state = 271, .external_lex_state = 9},
  [533] = {.lex_state = 208, .external_lex_state = 5},
  [534] = {.lex_state = 268, .external_lex_state = 5},
  [535] = {.lex_state = 268, .external_lex_state = 5},
  [536] = {.lex_state = 268, .external_lex_state = 14},
  [537] = {.lex_state = 208, .external_lex_state = 5},
  [538] = {.lex_state = 197, .external_lex_state = 14},
  [539] = {.lex_state = 197, .external_lex_state = 13},
  [540] = {.lex_state = 135, .external_lex_state = 15},
  [541] = {.lex_state = 197, .external_lex_state = 13},
  [542] = {.lex_state = 164, .external_lex_state = 3},
  [543] = {.lex_state = 197, .external_lex_state = 13},
  [544] = {.lex_state = 164, .external_lex_state = 3},
  [545] = {.lex_state = 197, .external_lex_state = 13},
  [546] = {.lex_state = 157, .external_lex_state = 2},
  [547] = {.lex_state = 157, .external_lex_state = 2},
  [548] = {.lex_state = 157, .external_lex_state = 2},
  [549] = {.lex_state = 164},
  [550] = {.lex_state = 304, .external_lex_state = 9},
  [551] = {.lex_state = 232, .external_lex_state = 2},
  [552] = {.lex_state = 304, .external_lex_state = 9},
  [553] = {.lex_state = 304, .external_lex_state = 9},
  [554] = {.lex_state = 304, .external_lex_state = 9},
  [555] = {.lex_state = 215, .external_lex_state = 13},
  [556] = {.lex_state = 307, .external_lex_state = 5},
  [557] = {.lex_state = 157},
  [558] = {.lex_state = 310, .external_lex_state = 9},
  [559] = {.lex_state = 313, .external_lex_state = 5},
  [560] = {.lex_state = 307, .external_lex_state = 5},
  [561] = {.lex_state = 307, .external_lex_state = 14},
  [562] = {.lex_state = 215},
  [563] = {.lex_state = 232, .external_lex_state = 2},
  [564] = {.lex_state = 197, .external_lex_state = 13},
  [565] = {.lex_state = 197, .external_lex_state = 5},
  [566] = {.lex_state = 197, .external_lex_state = 5},
  [567] = {.lex_state = 223, .external_lex_state = 9},
  [568] = {.lex_state = 157, .external_lex_state = 2},
  [569] = {.lex_state = 157, .external_lex_state = 2},
  [570] = {.lex_state = 271, .external_lex_state = 9},
  [571] = {.lex_state = 157, .external_lex_state = 2},
  [572] = {.lex_state = 164},
  [573] = {.lex_state = 228},
  [574] = {.lex_state = 220, .external_lex_state = 9},
  [575] = {.lex_state = 157, .external_lex_state = 2},
  [576] = {.lex_state = 157, .external_lex_state = 2},
  [577] = {.lex_state = 220, .external_lex_state = 9},
  [578] = {.lex_state = 220, .external_lex_state = 9},
  [579] = {.lex_state = 157, .external_lex_state = 2},
  [580] = {.lex_state = 220, .external_lex_state = 9},
  [581] = {.lex_state = 197, .external_lex_state = 5},
  [582] = {.lex_state = 268, .external_lex_state = 5},
  [583] = {.lex_state = 197, .external_lex_state = 5},
  [584] = {.lex_state = 197, .external_lex_state = 5},
  [585] = {.lex_state = 271, .external_lex_state = 9},
  [586] = {.lex_state = 157},
  [587] = {.lex_state = 197, .external_lex_state = 14},
  [588] = {.lex_state = 197, .external_lex_state = 5},
  [589] = {.lex_state = 135, .external_lex_state = 2},
  [590] = {.lex_state = 157, .external_lex_state = 2},
  [591] = {.lex_state = 157, .external_lex_state = 2},
  [592] = {.lex_state = 157, .external_lex_state = 2},
  [593] = {.lex_state = 217, .external_lex_state = 22},
  [594] = {.lex_state = 157, .external_lex_state = 2},
  [595] = {.lex_state = 157, .external_lex_state = 2},
  [596] = {.lex_state = 135, .external_lex_state = 2},
  [597] = {.lex_state = 135},
  [598] = {.lex_state = 300, .external_lex_state = 27},
  [599] = {.lex_state = 164},
  [600] = {.lex_state = 157, .external_lex_state = 28},
  [601] = {.lex_state = 157, .external_lex_state = 2},
  [602] = {.lex_state = 157, .external_lex_state = 2},
  [603] = {.lex_state = 271, .external_lex_state = 9},
  [604] = {.lex_state = 157, .external_lex_state = 2},
  [605] = {.lex_state = 228},
  [606] = {.lex_state = 271, .external_lex_state = 9},
  [607] = {.lex_state = 157, .external_lex_state = 2},
  [608] = {.lex_state = 157, .external_lex_state = 2},
  [609] = {.lex_state = 271, .external_lex_state = 9},
  [610] = {.lex_state = 271, .external_lex_state = 9},
  [611] = {.lex_state = 157, .external_lex_state = 2},
  [612] = {.lex_state = 271, .external_lex_state = 9},
  [613] = {.lex_state = 268, .external_lex_state = 5},
  [614] = {.lex_state = 157},
  [615] = {.lex_state = 271, .external_lex_state = 9},
  [616] = {.lex_state = 208, .external_lex_state = 5},
  [617] = {.lex_state = 268, .external_lex_state = 5},
  [618] = {.lex_state = 268, .external_lex_state = 5},
  [619] = {.lex_state = 268, .external_lex_state = 14},
  [620] = {.lex_state = 208, .external_lex_state = 5},
  [621] = {.lex_state = 157, .external_lex_state = 2},
  [622] = {.lex_state = 157, .external_lex_state = 2},
  [623] = {.lex_state = 157, .external_lex_state = 2},
  [624] = {.lex_state = 157, .external_lex_state = 2},
  [625] = {.lex_state = 157, .external_lex_state = 2},
  [626] = {.lex_state = 157, .external_lex_state = 2},
  [627] = {.lex_state = 157, .external_lex_state = 2},
  [628] = {.lex_state = 157, .external_lex_state = 2},
  [629] = {.lex_state = 157, .external_lex_state = 2},
  [630] = {.lex_state = 157, .external_lex_state = 2},
  [631] = {.lex_state = 157, .external_lex_state = 2},
  [632] = {.lex_state = 197, .external_lex_state = 14},
  [633] = {.lex_state = 197, .external_lex_state = 5},
  [634] = {.lex_state = 135, .external_lex_state = 15},
  [635] = {.lex_state = 234, .external_lex_state = 15},
  [636] = {.lex_state = 157, .external_lex_state = 2},
  [637] = {.lex_state = 164, .external_lex_state = 3},
  [638] = {.lex_state = 135},
  [639] = {.lex_state = 135, .external_lex_state = 2},
  [640] = {.lex_state = 157, .external_lex_state = 2},
  [641] = {.lex_state = 157, .external_lex_state = 2},
  [642] = {.lex_state = 182, .external_lex_state = 4},
  [643] = {.lex_state = 316, .external_lex_state = 20},
  [644] = {.lex_state = 164, .external_lex_state = 3},
  [645] = {.lex_state = 157, .external_lex_state = 6},
  [646] = {.lex_state = 319, .external_lex_state = 20},
  [647] = {.lex_state = 215, .external_lex_state = 7},
  [648] = {.lex_state = 135},
  [649] = {.lex_state = 157, .external_lex_state = 2},
  [650] = {.lex_state = 157, .external_lex_state = 2},
  [651] = {.lex_state = 217, .external_lex_state = 4},
  [652] = {.lex_state = 319, .external_lex_state = 20},
  [653] = {.lex_state = 157, .external_lex_state = 8},
  [654] = {.lex_state = 157},
  [655] = {.lex_state = 164},
  [656] = {.lex_state = 164, .external_lex_state = 3},
  [657] = {.lex_state = 304, .external_lex_state = 21},
  [658] = {.lex_state = 217, .external_lex_state = 4},
  [659] = {.lex_state = 215, .external_lex_state = 10},
  [660] = {.lex_state = 135, .external_lex_state = 2},
  [661] = {.lex_state = 304, .external_lex_state = 21},
  [662] = {.lex_state = 157, .external_lex_state = 11},
  [663] = {.lex_state = 217, .external_lex_state = 4},
  [664] = {.lex_state = 157, .external_lex_state = 8},
  [665] = {.lex_state = 135, .external_lex_state = 10},
  [666] = {.lex_state = 319, .external_lex_state = 20},
  [667] = {.lex_state = 304, .external_lex_state = 21},
  [668] = {.lex_state = 217, .external_lex_state = 4},
  [669] = {.lex_state = 316, .external_lex_state = 20},
  [670] = {.lex_state = 135, .external_lex_state = 2},
  [671] = {.lex_state = 182, .external_lex_state = 4},
  [672] = {.lex_state = 304, .external_lex_state = 21},
  [673] = {.lex_state = 215},
  [674] = {.lex_state = 307, .external_lex_state = 20},
  [675] = {.lex_state = 157},
  [676] = {.lex_state = 310, .external_lex_state = 21},
  [677] = {.lex_state = 313, .external_lex_state = 20},
  [678] = {.lex_state = 307, .external_lex_state = 20},
  [679] = {.lex_state = 307, .external_lex_state = 23},
  [680] = {.lex_state = 217, .external_lex_state = 4},
  [681] = {.lex_state = 197, .external_lex_state = 5},
  [682] = {.lex_state = 234, .external_lex_state = 15},
  [683] = {.lex_state = 182, .external_lex_state = 4},
  [684] = {.lex_state = 164, .external_lex_state = 3},
  [685] = {.lex_state = 135, .external_lex_state = 15},
  [686] = {.lex_state = 164, .external_lex_state = 3},
  [687] = {.lex_state = 197, .external_lex_state = 13},
  [688] = {.lex_state = 197, .external_lex_state = 5},
  [689] = {.lex_state = 135, .external_lex_state = 13},
  [690] = {.lex_state = 255, .external_lex_state = 16},
  [691] = {.lex_state = 255, .external_lex_state = 19},
  [692] = {.lex_state = 237, .external_lex_state = 16},
  [693] = {.lex_state = 237, .external_lex_state = 16},
  [694] = {.lex_state = 182, .external_lex_state = 4},
  [695] = {.lex_state = 234, .external_lex_state = 15},
  [696] = {.lex_state = 237, .external_lex_state = 16},
  [697] = {.lex_state = 157},
  [698] = {.lex_state = 237, .external_lex_state = 16},
  [699] = {.lex_state = 215, .external_lex_state = 18},
  [700] = {.lex_state = 215},
  [701] = {.lex_state = 157, .external_lex_state = 2},
  [702] = {.lex_state = 197, .external_lex_state = 5},
  [703] = {.lex_state = 255, .external_lex_state = 16},
  [704] = {.lex_state = 322, .external_lex_state = 19},
  [705] = {.lex_state = 135, .external_lex_state = 15},
  [706] = {.lex_state = 135},
  [707] = {.lex_state = 135, .external_lex_state = 10},
  [708] = {.lex_state = 232, .external_lex_state = 2},
  [709] = {.lex_state = 237, .external_lex_state = 16},
  [710] = {.lex_state = 135},
  [711] = {.lex_state = 245, .external_lex_state = 17},
  [712] = {.lex_state = 157, .external_lex_state = 2},
  [713] = {.lex_state = 157, .external_lex_state = 2},
  [714] = {.lex_state = 215, .external_lex_state = 13},
  [715] = {.lex_state = 237, .external_lex_state = 16},
  [716] = {.lex_state = 157},
  [717] = {.lex_state = 157, .external_lex_state = 2},
  [718] = {.lex_state = 157, .external_lex_state = 2},
  [719] = {.lex_state = 245, .external_lex_state = 17},
  [720] = {.lex_state = 157, .external_lex_state = 2},
  [721] = {.lex_state = 228},
  [722] = {.lex_state = 157, .external_lex_state = 2},
  [723] = {.lex_state = 266, .external_lex_state = 6},
  [724] = {.lex_state = 157, .external_lex_state = 2},
  [725] = {.lex_state = 157, .external_lex_state = 2},
  [726] = {.lex_state = 255, .external_lex_state = 16},
  [727] = {.lex_state = 252, .external_lex_state = 16},
  [728] = {.lex_state = 255, .external_lex_state = 16},
  [729] = {.lex_state = 157},
  [730] = {.lex_state = 255, .external_lex_state = 19},
  [731] = {.lex_state = 237, .external_lex_state = 16},
  [732] = {.lex_state = 255, .external_lex_state = 16},
  [733] = {.lex_state = 248, .external_lex_state = 17},
  [734] = {.lex_state = 157, .external_lex_state = 2},
  [735] = {.lex_state = 215, .external_lex_state = 10},
  [736] = {.lex_state = 323, .external_lex_state = 16},
  [737] = {.lex_state = 182, .external_lex_state = 4},
  [738] = {.lex_state = 217, .external_lex_state = 4},
  [739] = {.lex_state = 135, .external_lex_state = 2},
  [740] = {.lex_state = 248, .external_lex_state = 17},
  [741] = {.lex_state = 135, .external_lex_state = 2},
  [742] = {.lex_state = 157, .external_lex_state = 11},
  [743] = {.lex_state = 157, .external_lex_state = 8},
  [744] = {.lex_state = 135, .external_lex_state = 10},
  [745] = {.lex_state = 157, .external_lex_state = 2},
  [746] = {.lex_state = 157, .external_lex_state = 2},
  [747] = {.lex_state = 323, .external_lex_state = 16},
  [748] = {.lex_state = 217, .external_lex_state = 4},
  [749] = {.lex_state = 323, .external_lex_state = 16},
  [750] = {.lex_state = 182, .external_lex_state = 4},
  [751] = {.lex_state = 326, .external_lex_state = 16},
  [752] = {.lex_state = 157, .external_lex_state = 6},
  [753] = {.lex_state = 215, .external_lex_state = 7},
  [754] = {.lex_state = 248, .external_lex_state = 17},
  [755] = {.lex_state = 157, .external_lex_state = 2},
  [756] = {.lex_state = 157, .external_lex_state = 2},
  [757] = {.lex_state = 326, .external_lex_state = 16},
  [758] = {.lex_state = 157, .external_lex_state = 8},
  [759] = {.lex_state = 217, .external_lex_state = 4},
  [760] = {.lex_state = 217, .external_lex_state = 4},
  [761] = {.lex_state = 157},
  [762] = {.lex_state = 164},
  [763] = {.lex_state = 164, .external_lex_state = 3},
  [764] = {.lex_state = 248, .external_lex_state = 17},
  [765] = {.lex_state = 135, .external_lex_state = 2},
  [766] = {.lex_state = 329, .external_lex_state = 16},
  [767] = {.lex_state = 255, .external_lex_state = 16},
  [768] = {.lex_state = 255, .external_lex_state = 16},
  [769] = {.lex_state = 332, .external_lex_state = 17},
  [770] = {.lex_state = 157},
  [771] = {.lex_state = 255, .external_lex_state = 19},
  [772] = {.lex_state = 237, .external_lex_state = 16},
  [773] = {.lex_state = 135, .external_lex_state = 15},
  [774] = {.lex_state = 197, .external_lex_state = 5},
  [775] = {.lex_state = 135},
  [776] = {.lex_state = 237, .external_lex_state = 16},
  [777] = {.lex_state = 135},
  [778] = {.lex_state = 255, .external_lex_state = 16},
  [779] = {.lex_state = 237, .external_lex_state = 16},
  [780] = {.lex_state = 157, .external_lex_state = 2},
  [781] = {.lex_state = 258, .external_lex_state = 25},
  [782] = {.lex_state = 258, .external_lex_state = 25},
  [783] = {.lex_state = 237, .external_lex_state = 16},
  [784] = {.lex_state = 135, .external_lex_state = 15},
  [785] = {.lex_state = 258, .external_lex_state = 25},
  [786] = {.lex_state = 258, .external_lex_state = 25},
  [787] = {.lex_state = 135},
  [788] = {.lex_state = 135},
  [789] = {.lex_state = 135, .external_lex_state = 2},
  [790] = {.lex_state = 237, .external_lex_state = 16},
  [791] = {.lex_state = 135},
  [792] = {.lex_state = 135},
  [793] = {.lex_state = 237, .external_lex_state = 16},
  [794] = {.lex_state = 237, .external_lex_state = 16},
  [795] = {.lex_state = 135, .external_lex_state = 15},
  [796] = {.lex_state = 237, .external_lex_state = 16},
  [797] = {.lex_state = 255, .external_lex_state = 16},
  [798] = {.lex_state = 135, .external_lex_state = 13},
  [799] = {.lex_state = 237, .external_lex_state = 16},
  [800] = {.lex_state = 182, .external_lex_state = 4},
  [801] = {.lex_state = 234, .external_lex_state = 15},
  [802] = {.lex_state = 237, .external_lex_state = 16},
  [803] = {.lex_state = 157, .external_lex_state = 29},
  [804] = {.lex_state = 335},
  [805] = {.lex_state = 157, .external_lex_state = 18},
  [806] = {.lex_state = 157, .external_lex_state = 2},
  [807] = {.lex_state = 157, .external_lex_state = 28},
  [808] = {.lex_state = 157, .external_lex_state = 2},
  [809] = {.lex_state = 157, .external_lex_state = 2},
  [810] = {.lex_state = 157, .external_lex_state = 2},
  [811] = {.lex_state = 157, .external_lex_state = 2},
  [812] = {.lex_state = 157, .external_lex_state = 2},
  [813] = {.lex_state = 157, .external_lex_state = 2},
  [814] = {.lex_state = 157, .external_lex_state = 2},
  [815] = {.lex_state = 157, .external_lex_state = 2},
  [816] = {.lex_state = 157, .external_lex_state = 2},
  [817] = {.lex_state = 157, .external_lex_state = 2},
  [818] = {.lex_state = 300, .external_lex_state = 27},
  [819] = {.lex_state = 157, .external_lex_state = 6},
  [820] = {.lex_state = 164},
  [821] = {.lex_state = 157, .external_lex_state = 2},
  [822] = {.lex_state = 135, .external_lex_state = 2},
  [823] = {.lex_state = 157, .external_lex_state = 2},
  [824] = {.lex_state = 157, .external_lex_state = 2},
  [825] = {.lex_state = 182, .external_lex_state = 4},
  [826] = {.lex_state = 242, .external_lex_state = 16},
  [827] = {.lex_state = 157, .external_lex_state = 6},
  [828] = {.lex_state = 232, .external_lex_state = 7},
  [829] = {.lex_state = 245, .external_lex_state = 17},
  [830] = {.lex_state = 157, .external_lex_state = 2},
  [831] = {.lex_state = 157, .external_lex_state = 2},
  [832] = {.lex_state = 217, .external_lex_state = 4},
  [833] = {.lex_state = 157, .external_lex_state = 8},
  [834] = {.lex_state = 135, .external_lex_state = 10},
  [835] = {.lex_state = 157},
  [836] = {.lex_state = 228},
  [837] = {.lex_state = 164, .external_lex_state = 3},
  [838] = {.lex_state = 245, .external_lex_state = 17},
  [839] = {.lex_state = 157, .external_lex_state = 2},
  [840] = {.lex_state = 217, .external_lex_state = 4},
  [841] = {.lex_state = 215, .external_lex_state = 10},
  [842] = {.lex_state = 266, .external_lex_state = 6},
  [843] = {.lex_state = 135, .external_lex_state = 2},
  [844] = {.lex_state = 157, .external_lex_state = 2},
  [845] = {.lex_state = 245, .external_lex_state = 17},
  [846] = {.lex_state = 157, .external_lex_state = 11},
  [847] = {.lex_state = 217, .external_lex_state = 4},
  [848] = {.lex_state = 157, .external_lex_state = 8},
  [849] = {.lex_state = 135, .external_lex_state = 10},
  [850] = {.lex_state = 245, .external_lex_state = 17},
  [851] = {.lex_state = 217, .external_lex_state = 4},
  [852] = {.lex_state = 242, .external_lex_state = 16},
  [853] = {.lex_state = 157, .external_lex_state = 2},
  [854] = {.lex_state = 135, .external_lex_state = 2},
  [855] = {.lex_state = 182, .external_lex_state = 4},
  [856] = {.lex_state = 245, .external_lex_state = 17},
  [857] = {.lex_state = 242, .external_lex_state = 16},
  [858] = {.lex_state = 252, .external_lex_state = 16},
  [859] = {.lex_state = 242, .external_lex_state = 16},
  [860] = {.lex_state = 157},
  [861] = {.lex_state = 245, .external_lex_state = 17},
  [862] = {.lex_state = 252, .external_lex_state = 16},
  [863] = {.lex_state = 252, .external_lex_state = 16},
  [864] = {.lex_state = 252, .external_lex_state = 16},
  [865] = {.lex_state = 252, .external_lex_state = 19},
  [866] = {.lex_state = 252, .external_lex_state = 16},
  [867] = {.lex_state = 255, .external_lex_state = 19},
  [868] = {.lex_state = 197, .external_lex_state = 5},
  [869] = {.lex_state = 197, .external_lex_state = 5},
  [870] = {.lex_state = 135, .external_lex_state = 13},
  [871] = {.lex_state = 197, .external_lex_state = 20},
  [872] = {.lex_state = 197, .external_lex_state = 23},
  [873] = {.lex_state = 197, .external_lex_state = 20},
  [874] = {.lex_state = 197, .external_lex_state = 20},
  [875] = {.lex_state = 182, .external_lex_state = 4},
  [876] = {.lex_state = 234, .external_lex_state = 15},
  [877] = {.lex_state = 197, .external_lex_state = 20},
  [878] = {.lex_state = 157},
  [879] = {.lex_state = 197, .external_lex_state = 20},
  [880] = {.lex_state = 215, .external_lex_state = 18},
  [881] = {.lex_state = 215},
  [882] = {.lex_state = 157, .external_lex_state = 2},
  [883] = {.lex_state = 197, .external_lex_state = 5},
  [884] = {.lex_state = 338},
  [885] = {.lex_state = 135, .external_lex_state = 2},
  [886] = {.lex_state = 217, .external_lex_state = 22},
  [887] = {.lex_state = 197, .external_lex_state = 20},
  [888] = {.lex_state = 197, .external_lex_state = 23},
  [889] = {.lex_state = 135, .external_lex_state = 15},
  [890] = {.lex_state = 135},
  [891] = {.lex_state = 135, .external_lex_state = 10},
  [892] = {.lex_state = 232, .external_lex_state = 2},
  [893] = {.lex_state = 197, .external_lex_state = 20},
  [894] = {.lex_state = 135},
  [895] = {.lex_state = 245, .external_lex_state = 21},
  [896] = {.lex_state = 157, .external_lex_state = 2},
  [897] = {.lex_state = 157, .external_lex_state = 2},
  [898] = {.lex_state = 215, .external_lex_state = 13},
  [899] = {.lex_state = 197, .external_lex_state = 20},
  [900] = {.lex_state = 157},
  [901] = {.lex_state = 157, .external_lex_state = 2},
  [902] = {.lex_state = 157, .external_lex_state = 2},
  [903] = {.lex_state = 245, .external_lex_state = 17},
  [904] = {.lex_state = 157, .external_lex_state = 2},
  [905] = {.lex_state = 164},
  [906] = {.lex_state = 228},
  [907] = {.lex_state = 220, .external_lex_state = 17},
  [908] = {.lex_state = 157, .external_lex_state = 2},
  [909] = {.lex_state = 157, .external_lex_state = 2},
  [910] = {.lex_state = 220, .external_lex_state = 17},
  [911] = {.lex_state = 220, .external_lex_state = 17},
  [912] = {.lex_state = 157, .external_lex_state = 2},
  [913] = {.lex_state = 220, .external_lex_state = 17},
  [914] = {.lex_state = 197, .external_lex_state = 16},
  [915] = {.lex_state = 242, .external_lex_state = 16},
  [916] = {.lex_state = 197, .external_lex_state = 16},
  [917] = {.lex_state = 197, .external_lex_state = 16},
  [918] = {.lex_state = 245, .external_lex_state = 17},
  [919] = {.lex_state = 157},
  [920] = {.lex_state = 197, .external_lex_state = 19},
  [921] = {.lex_state = 197, .external_lex_state = 20},
  [922] = {.lex_state = 197, .external_lex_state = 16},
  [923] = {.lex_state = 197, .external_lex_state = 20},
  [924] = {.lex_state = 135, .external_lex_state = 15},
  [925] = {.lex_state = 197, .external_lex_state = 5},
  [926] = {.lex_state = 135},
  [927] = {.lex_state = 197, .external_lex_state = 20},
  [928] = {.lex_state = 135},
  [929] = {.lex_state = 197, .external_lex_state = 20},
  [930] = {.lex_state = 157, .external_lex_state = 2},
  [931] = {.lex_state = 258, .external_lex_state = 25},
  [932] = {.lex_state = 258, .external_lex_state = 25},
  [933] = {.lex_state = 197, .external_lex_state = 20},
  [934] = {.lex_state = 135, .external_lex_state = 15},
  [935] = {.lex_state = 258, .external_lex_state = 25},
  [936] = {.lex_state = 258, .external_lex_state = 25},
  [937] = {.lex_state = 135},
  [938] = {.lex_state = 135},
  [939] = {.lex_state = 135, .external_lex_state = 2},
  [940] = {.lex_state = 197, .external_lex_state = 20},
  [941] = {.lex_state = 135},
  [942] = {.lex_state = 135},
  [943] = {.lex_state = 197, .external_lex_state = 20},
  [944] = {.lex_state = 197, .external_lex_state = 20},
  [945] = {.lex_state = 135, .external_lex_state = 15},
  [946] = {.lex_state = 197, .external_lex_state = 20},
  [947] = {.lex_state = 304, .external_lex_state = 17},
  [948] = {.lex_state = 304, .external_lex_state = 17},
  [949] = {.lex_state = 157, .external_lex_state = 2},
  [950] = {.lex_state = 157, .external_lex_state = 2},
  [951] = {.lex_state = 304, .external_lex_state = 17},
  [952] = {.lex_state = 157, .external_lex_state = 2},
  [953] = {.lex_state = 164},
  [954] = {.lex_state = 304, .external_lex_state = 17},
  [955] = {.lex_state = 313, .external_lex_state = 16},
  [956] = {.lex_state = 307, .external_lex_state = 16},
  [957] = {.lex_state = 307, .external_lex_state = 16},
  [958] = {.lex_state = 310, .external_lex_state = 17},
  [959] = {.lex_state = 157},
  [960] = {.lex_state = 307, .external_lex_state = 19},
  [961] = {.lex_state = 135, .external_lex_state = 13},
  [962] = {.lex_state = 197, .external_lex_state = 20},
  [963] = {.lex_state = 182, .external_lex_state = 4},
  [964] = {.lex_state = 234, .external_lex_state = 15},
  [965] = {.lex_state = 197, .external_lex_state = 20},
  [966] = {.lex_state = 157, .external_lex_state = 2},
  [967] = {.lex_state = 157, .external_lex_state = 28},
  [968] = {.lex_state = 157, .external_lex_state = 2},
  [969] = {.lex_state = 157, .external_lex_state = 2},
  [970] = {.lex_state = 157, .external_lex_state = 2},
  [971] = {.lex_state = 157, .external_lex_state = 2},
  [972] = {.lex_state = 157, .external_lex_state = 2},
  [973] = {.lex_state = 157, .external_lex_state = 2},
  [974] = {.lex_state = 157, .external_lex_state = 2},
  [975] = {.lex_state = 157, .external_lex_state = 2},
  [976] = {.lex_state = 157, .external_lex_state = 2},
  [977] = {.lex_state = 157, .external_lex_state = 2},
  [978] = {.lex_state = 300, .external_lex_state = 27},
  [979] = {.lex_state = 157, .external_lex_state = 6},
  [980] = {.lex_state = 164},
  [981] = {.lex_state = 215, .external_lex_state = 7},
  [982] = {.lex_state = 197, .external_lex_state = 5},
  [983] = {.lex_state = 215},
  [984] = {.lex_state = 157, .external_lex_state = 2},
  [985] = {.lex_state = 157, .external_lex_state = 2},
  [986] = {.lex_state = 232, .external_lex_state = 7},
  [987] = {.lex_state = 245, .external_lex_state = 17},
  [988] = {.lex_state = 157, .external_lex_state = 2},
  [989] = {.lex_state = 135, .external_lex_state = 10},
  [990] = {.lex_state = 228},
  [991] = {.lex_state = 245, .external_lex_state = 17},
  [992] = {.lex_state = 157, .external_lex_state = 2},
  [993] = {.lex_state = 157, .external_lex_state = 2},
  [994] = {.lex_state = 245, .external_lex_state = 17},
  [995] = {.lex_state = 245, .external_lex_state = 17},
  [996] = {.lex_state = 157, .external_lex_state = 2},
  [997] = {.lex_state = 245, .external_lex_state = 17},
  [998] = {.lex_state = 242, .external_lex_state = 20},
  [999] = {.lex_state = 242, .external_lex_state = 16},
  [1000] = {.lex_state = 242, .external_lex_state = 20},
  [1001] = {.lex_state = 157},
  [1002] = {.lex_state = 245, .external_lex_state = 17},
  [1003] = {.lex_state = 242, .external_lex_state = 16},
  [1004] = {.lex_state = 242, .external_lex_state = 16},
  [1005] = {.lex_state = 242, .external_lex_state = 16},
  [1006] = {.lex_state = 252, .external_lex_state = 19},
  [1007] = {.lex_state = 242, .external_lex_state = 16},
  [1008] = {.lex_state = 197, .external_lex_state = 23},
  [1009] = {.lex_state = 197, .external_lex_state = 13},
  [1010] = {.lex_state = 215},
  [1011] = {.lex_state = 135, .external_lex_state = 2},
  [1012] = {.lex_state = 215},
  [1013] = {.lex_state = 197, .external_lex_state = 14},
  [1014] = {.lex_state = 217, .external_lex_state = 4},
  [1015] = {.lex_state = 245, .external_lex_state = 17},
  [1016] = {.lex_state = 228},
  [1017] = {.lex_state = 157, .external_lex_state = 2},
  [1018] = {.lex_state = 266, .external_lex_state = 6},
  [1019] = {.lex_state = 157, .external_lex_state = 2},
  [1020] = {.lex_state = 157, .external_lex_state = 2},
  [1021] = {.lex_state = 258, .external_lex_state = 18},
  [1022] = {.lex_state = 197, .external_lex_state = 16},
  [1023] = {.lex_state = 197, .external_lex_state = 19},
  [1024] = {.lex_state = 258},
  [1025] = {.lex_state = 258, .external_lex_state = 18},
  [1026] = {.lex_state = 258},
  [1027] = {.lex_state = 182, .external_lex_state = 4},
  [1028] = {.lex_state = 234, .external_lex_state = 15},
  [1029] = {.lex_state = 197, .external_lex_state = 5},
  [1030] = {.lex_state = 197, .external_lex_state = 5},
  [1031] = {.lex_state = 135},
  [1032] = {.lex_state = 263},
  [1033] = {.lex_state = 135, .external_lex_state = 15},
  [1034] = {.lex_state = 258},
  [1035] = {.lex_state = 135},
  [1036] = {.lex_state = 258},
  [1037] = {.lex_state = 135, .external_lex_state = 13},
  [1038] = {.lex_state = 157, .external_lex_state = 2},
  [1039] = {.lex_state = 258, .external_lex_state = 25},
  [1040] = {.lex_state = 258, .external_lex_state = 25},
  [1041] = {.lex_state = 258, .external_lex_state = 25},
  [1042] = {.lex_state = 258, .external_lex_state = 25},
  [1043] = {.lex_state = 135},
  [1044] = {.lex_state = 135},
  [1045] = {.lex_state = 135, .external_lex_state = 2},
  [1046] = {.lex_state = 258},
  [1047] = {.lex_state = 135},
  [1048] = {.lex_state = 135},
  [1049] = {.lex_state = 258},
  [1050] = {.lex_state = 135, .external_lex_state = 15},
  [1051] = {.lex_state = 258},
  [1052] = {.lex_state = 182, .external_lex_state = 4},
  [1053] = {.lex_state = 234, .external_lex_state = 15},
  [1054] = {.lex_state = 258},
  [1055] = {.lex_state = 157},
  [1056] = {.lex_state = 258},
  [1057] = {.lex_state = 215, .external_lex_state = 18},
  [1058] = {.lex_state = 215},
  [1059] = {.lex_state = 258},
  [1060] = {.lex_state = 197, .external_lex_state = 5},
  [1061] = {.lex_state = 258, .external_lex_state = 24},
  [1062] = {.lex_state = 135, .external_lex_state = 15},
  [1063] = {.lex_state = 258},
  [1064] = {.lex_state = 135},
  [1065] = {.lex_state = 258},
  [1066] = {.lex_state = 135, .external_lex_state = 15},
  [1067] = {.lex_state = 135, .external_lex_state = 10},
  [1068] = {.lex_state = 232, .external_lex_state = 2},
  [1069] = {.lex_state = 258},
  [1070] = {.lex_state = 135},
  [1071] = {.lex_state = 258, .external_lex_state = 6},
  [1072] = {.lex_state = 157, .external_lex_state = 2},
  [1073] = {.lex_state = 215, .external_lex_state = 13},
  [1074] = {.lex_state = 258},
  [1075] = {.lex_state = 157},
  [1076] = {.lex_state = 258},
  [1077] = {.lex_state = 135, .external_lex_state = 13},
  [1078] = {.lex_state = 157, .external_lex_state = 8},
  [1079] = {.lex_state = 157},
  [1080] = {.lex_state = 300, .external_lex_state = 27},
  [1081] = {.lex_state = 157, .external_lex_state = 6},
  [1082] = {.lex_state = 164},
  [1083] = {.lex_state = 157, .external_lex_state = 2},
  [1084] = {.lex_state = 157, .external_lex_state = 2},
  [1085] = {.lex_state = 232, .external_lex_state = 7},
  [1086] = {.lex_state = 245, .external_lex_state = 17},
  [1087] = {.lex_state = 157, .external_lex_state = 2},
  [1088] = {.lex_state = 164},
  [1089] = {.lex_state = 228},
  [1090] = {.lex_state = 220, .external_lex_state = 17},
  [1091] = {.lex_state = 157, .external_lex_state = 2},
  [1092] = {.lex_state = 157, .external_lex_state = 2},
  [1093] = {.lex_state = 220, .external_lex_state = 17},
  [1094] = {.lex_state = 220, .external_lex_state = 17},
  [1095] = {.lex_state = 157, .external_lex_state = 2},
  [1096] = {.lex_state = 220, .external_lex_state = 17},
  [1097] = {.lex_state = 258},
  [1098] = {.lex_state = 197, .external_lex_state = 16},
  [1099] = {.lex_state = 258},
  [1100] = {.lex_state = 157},
  [1101] = {.lex_state = 245, .external_lex_state = 17},
  [1102] = {.lex_state = 258, .external_lex_state = 18},
  [1103] = {.lex_state = 242, .external_lex_state = 16},
  [1104] = {.lex_state = 197, .external_lex_state = 16},
  [1105] = {.lex_state = 197, .external_lex_state = 19},
  [1106] = {.lex_state = 258, .external_lex_state = 18},
  [1107] = {.lex_state = 258, .external_lex_state = 24},
  [1108] = {.lex_state = 157, .external_lex_state = 2},
  [1109] = {.lex_state = 135, .external_lex_state = 13},
  [1110] = {.lex_state = 220},
  [1111] = {.lex_state = 164, .external_lex_state = 3},
  [1112] = {.lex_state = 157, .external_lex_state = 2},
  [1113] = {.lex_state = 157, .external_lex_state = 2},
  [1114] = {.lex_state = 217, .external_lex_state = 22},
  [1115] = {.lex_state = 157, .external_lex_state = 2},
  [1116] = {.lex_state = 164},
  [1117] = {.lex_state = 215},
  [1118] = {.lex_state = 220, .external_lex_state = 9},
  [1119] = {.lex_state = 220, .external_lex_state = 9},
  [1120] = {.lex_state = 220, .external_lex_state = 9},
  [1121] = {.lex_state = 197, .external_lex_state = 5},
  [1122] = {.lex_state = 220, .external_lex_state = 9},
  [1123] = {.lex_state = 135, .external_lex_state = 13},
  [1124] = {.lex_state = 135, .external_lex_state = 10},
  [1125] = {.lex_state = 197, .external_lex_state = 5},
  [1126] = {.lex_state = 157},
  [1127] = {.lex_state = 135, .external_lex_state = 2},
  [1128] = {.lex_state = 223, .external_lex_state = 9},
  [1129] = {.lex_state = 208, .external_lex_state = 5},
  [1130] = {.lex_state = 197, .external_lex_state = 5},
  [1131] = {.lex_state = 197, .external_lex_state = 14},
  [1132] = {.lex_state = 135},
  [1133] = {.lex_state = 135, .external_lex_state = 2},
  [1134] = {.lex_state = 220},
  [1135] = {.lex_state = 157, .external_lex_state = 2},
  [1136] = {.lex_state = 157, .external_lex_state = 2},
  [1137] = {.lex_state = 220},
  [1138] = {.lex_state = 197, .external_lex_state = 5},
  [1139] = {.lex_state = 215},
  [1140] = {.lex_state = 232, .external_lex_state = 2},
  [1141] = {.lex_state = 215},
  [1142] = {.lex_state = 220},
  [1143] = {.lex_state = 220},
  [1144] = {.lex_state = 341},
  [1145] = {.lex_state = 135},
  [1146] = {.lex_state = 157},
  [1147] = {.lex_state = 220},
  [1148] = {.lex_state = 197, .external_lex_state = 5},
  [1149] = {.lex_state = 157},
  [1150] = {.lex_state = 157},
  [1151] = {.lex_state = 215, .external_lex_state = 13},
  [1152] = {.lex_state = 135, .external_lex_state = 15},
  [1153] = {.lex_state = 220, .external_lex_state = 21},
  [1154] = {.lex_state = 220, .external_lex_state = 21},
  [1155] = {.lex_state = 157, .external_lex_state = 2},
  [1156] = {.lex_state = 157, .external_lex_state = 2},
  [1157] = {.lex_state = 220, .external_lex_state = 21},
  [1158] = {.lex_state = 157, .external_lex_state = 2},
  [1159] = {.lex_state = 164},
  [1160] = {.lex_state = 220, .external_lex_state = 21},
  [1161] = {.lex_state = 277, .external_lex_state = 20},
  [1162] = {.lex_state = 274, .external_lex_state = 20},
  [1163] = {.lex_state = 274, .external_lex_state = 20},
  [1164] = {.lex_state = 223, .external_lex_state = 21},
  [1165] = {.lex_state = 157},
  [1166] = {.lex_state = 274, .external_lex_state = 23},
  [1167] = {.lex_state = 215, .external_lex_state = 13},
  [1168] = {.lex_state = 197, .external_lex_state = 13},
  [1169] = {.lex_state = 135},
  [1170] = {.lex_state = 197, .external_lex_state = 13},
  [1171] = {.lex_state = 228, .external_lex_state = 13},
  [1172] = {.lex_state = 266},
  [1173] = {.lex_state = 135, .external_lex_state = 2},
  [1174] = {.lex_state = 197, .external_lex_state = 13},
  [1175] = {.lex_state = 164, .external_lex_state = 3},
  [1176] = {.lex_state = 197, .external_lex_state = 5},
  [1177] = {.lex_state = 135, .external_lex_state = 13},
  [1178] = {.lex_state = 197, .external_lex_state = 5},
  [1179] = {.lex_state = 197, .external_lex_state = 14},
  [1180] = {.lex_state = 197, .external_lex_state = 5},
  [1181] = {.lex_state = 197, .external_lex_state = 5},
  [1182] = {.lex_state = 182, .external_lex_state = 4},
  [1183] = {.lex_state = 234, .external_lex_state = 15},
  [1184] = {.lex_state = 197, .external_lex_state = 5},
  [1185] = {.lex_state = 157},
  [1186] = {.lex_state = 197, .external_lex_state = 5},
  [1187] = {.lex_state = 215, .external_lex_state = 18},
  [1188] = {.lex_state = 215},
  [1189] = {.lex_state = 157, .external_lex_state = 2},
  [1190] = {.lex_state = 197, .external_lex_state = 5},
  [1191] = {.lex_state = 197, .external_lex_state = 5},
  [1192] = {.lex_state = 197, .external_lex_state = 14},
  [1193] = {.lex_state = 135, .external_lex_state = 15},
  [1194] = {.lex_state = 135},
  [1195] = {.lex_state = 135, .external_lex_state = 10},
  [1196] = {.lex_state = 232, .external_lex_state = 2},
  [1197] = {.lex_state = 197, .external_lex_state = 5},
  [1198] = {.lex_state = 135},
  [1199] = {.lex_state = 271, .external_lex_state = 9},
  [1200] = {.lex_state = 157, .external_lex_state = 2},
  [1201] = {.lex_state = 157, .external_lex_state = 2},
  [1202] = {.lex_state = 215, .external_lex_state = 13},
  [1203] = {.lex_state = 197, .external_lex_state = 5},
  [1204] = {.lex_state = 157},
  [1205] = {.lex_state = 271, .external_lex_state = 9},
  [1206] = {.lex_state = 228},
  [1207] = {.lex_state = 157, .external_lex_state = 2},
  [1208] = {.lex_state = 266, .external_lex_state = 6},
  [1209] = {.lex_state = 157, .external_lex_state = 2},
  [1210] = {.lex_state = 157, .external_lex_state = 2},
  [1211] = {.lex_state = 197, .external_lex_state = 5},
  [1212] = {.lex_state = 197, .external_lex_state = 5},
  [1213] = {.lex_state = 197, .external_lex_state = 14},
  [1214] = {.lex_state = 197, .external_lex_state = 5},
  [1215] = {.lex_state = 197, .external_lex_state = 5},
  [1216] = {.lex_state = 220, .external_lex_state = 9},
  [1217] = {.lex_state = 220, .external_lex_state = 9},
  [1218] = {.lex_state = 157, .external_lex_state = 2},
  [1219] = {.lex_state = 157, .external_lex_state = 2},
  [1220] = {.lex_state = 220, .external_lex_state = 9},
  [1221] = {.lex_state = 157, .external_lex_state = 2},
  [1222] = {.lex_state = 220, .external_lex_state = 9},
  [1223] = {.lex_state = 208, .external_lex_state = 5},
  [1224] = {.lex_state = 197, .external_lex_state = 5},
  [1225] = {.lex_state = 157},
  [1226] = {.lex_state = 197, .external_lex_state = 14},
  [1227] = {.lex_state = 197, .external_lex_state = 5},
  [1228] = {.lex_state = 135, .external_lex_state = 15},
  [1229] = {.lex_state = 197, .external_lex_state = 5},
  [1230] = {.lex_state = 135},
  [1231] = {.lex_state = 197, .external_lex_state = 5},
  [1232] = {.lex_state = 157, .external_lex_state = 2},
  [1233] = {.lex_state = 157, .external_lex_state = 2},
  [1234] = {.lex_state = 271, .external_lex_state = 17},
  [1235] = {.lex_state = 157, .external_lex_state = 2},
  [1236] = {.lex_state = 164},
  [1237] = {.lex_state = 228},
  [1238] = {.lex_state = 220, .external_lex_state = 17},
  [1239] = {.lex_state = 157, .external_lex_state = 2},
  [1240] = {.lex_state = 157, .external_lex_state = 2},
  [1241] = {.lex_state = 220, .external_lex_state = 17},
  [1242] = {.lex_state = 220, .external_lex_state = 17},
  [1243] = {.lex_state = 157, .external_lex_state = 2},
  [1244] = {.lex_state = 220, .external_lex_state = 17},
  [1245] = {.lex_state = 220, .external_lex_state = 18},
  [1246] = {.lex_state = 344, .external_lex_state = 16},
  [1247] = {.lex_state = 274, .external_lex_state = 16},
  [1248] = {.lex_state = 274, .external_lex_state = 16},
  [1249] = {.lex_state = 271, .external_lex_state = 17},
  [1250] = {.lex_state = 157},
  [1251] = {.lex_state = 274, .external_lex_state = 19},
  [1252] = {.lex_state = 135},
  [1253] = {.lex_state = 197, .external_lex_state = 5},
  [1254] = {.lex_state = 135},
  [1255] = {.lex_state = 197, .external_lex_state = 5},
  [1256] = {.lex_state = 197, .external_lex_state = 5},
  [1257] = {.lex_state = 157, .external_lex_state = 2},
  [1258] = {.lex_state = 258, .external_lex_state = 25},
  [1259] = {.lex_state = 258, .external_lex_state = 25},
  [1260] = {.lex_state = 197, .external_lex_state = 5},
  [1261] = {.lex_state = 135, .external_lex_state = 15},
  [1262] = {.lex_state = 258, .external_lex_state = 25},
  [1263] = {.lex_state = 258, .external_lex_state = 25},
  [1264] = {.lex_state = 135},
  [1265] = {.lex_state = 135},
  [1266] = {.lex_state = 135, .external_lex_state = 2},
  [1267] = {.lex_state = 197, .external_lex_state = 5},
  [1268] = {.lex_state = 135},
  [1269] = {.lex_state = 135},
  [1270] = {.lex_state = 197, .external_lex_state = 5},
  [1271] = {.lex_state = 197, .external_lex_state = 5},
  [1272] = {.lex_state = 135, .external_lex_state = 15},
  [1273] = {.lex_state = 197, .external_lex_state = 5},
  [1274] = {.lex_state = 197, .external_lex_state = 5},
  [1275] = {.lex_state = 135, .external_lex_state = 13},
  [1276] = {.lex_state = 197, .external_lex_state = 5},
  [1277] = {.lex_state = 182, .external_lex_state = 4},
  [1278] = {.lex_state = 234, .external_lex_state = 15},
  [1279] = {.lex_state = 197, .external_lex_state = 5},
  [1280] = {.lex_state = 217, .external_lex_state = 22},
  [1281] = {.lex_state = 157, .external_lex_state = 29},
  [1282] = {.lex_state = 197, .external_lex_state = 5},
  [1283] = {.lex_state = 197, .external_lex_state = 5},
  [1284] = {.lex_state = 157, .external_lex_state = 2},
  [1285] = {.lex_state = 157, .external_lex_state = 28},
  [1286] = {.lex_state = 157, .external_lex_state = 2},
  [1287] = {.lex_state = 157, .external_lex_state = 2},
  [1288] = {.lex_state = 157, .external_lex_state = 2},
  [1289] = {.lex_state = 157, .external_lex_state = 2},
  [1290] = {.lex_state = 157, .external_lex_state = 2},
  [1291] = {.lex_state = 157, .external_lex_state = 2},
  [1292] = {.lex_state = 157, .external_lex_state = 2},
  [1293] = {.lex_state = 157, .external_lex_state = 2},
  [1294] = {.lex_state = 157, .external_lex_state = 2},
  [1295] = {.lex_state = 300, .external_lex_state = 27},
  [1296] = {.lex_state = 157, .external_lex_state = 6},
  [1297] = {.lex_state = 164},
  [1298] = {.lex_state = 232, .external_lex_state = 7},
  [1299] = {.lex_state = 271, .external_lex_state = 9},
  [1300] = {.lex_state = 135, .external_lex_state = 10},
  [1301] = {.lex_state = 228},
  [1302] = {.lex_state = 157, .external_lex_state = 2},
  [1303] = {.lex_state = 266, .external_lex_state = 6},
  [1304] = {.lex_state = 157, .external_lex_state = 2},
  [1305] = {.lex_state = 157, .external_lex_state = 2},
  [1306] = {.lex_state = 268, .external_lex_state = 5},
  [1307] = {.lex_state = 268, .external_lex_state = 5},
  [1308] = {.lex_state = 268, .external_lex_state = 5},
  [1309] = {.lex_state = 268, .external_lex_state = 5},
  [1310] = {.lex_state = 268, .external_lex_state = 14},
  [1311] = {.lex_state = 268, .external_lex_state = 5},
  [1312] = {.lex_state = 197, .external_lex_state = 14},
  [1313] = {.lex_state = 197, .external_lex_state = 5},
  [1314] = {.lex_state = 157, .external_lex_state = 2},
  [1315] = {.lex_state = 157, .external_lex_state = 2},
  [1316] = {.lex_state = 271, .external_lex_state = 9},
  [1317] = {.lex_state = 157, .external_lex_state = 2},
  [1318] = {.lex_state = 228},
  [1319] = {.lex_state = 220, .external_lex_state = 9},
  [1320] = {.lex_state = 157, .external_lex_state = 2},
  [1321] = {.lex_state = 157, .external_lex_state = 2},
  [1322] = {.lex_state = 220, .external_lex_state = 9},
  [1323] = {.lex_state = 220, .external_lex_state = 9},
  [1324] = {.lex_state = 157, .external_lex_state = 2},
  [1325] = {.lex_state = 220, .external_lex_state = 9},
  [1326] = {.lex_state = 197, .external_lex_state = 5},
  [1327] = {.lex_state = 268, .external_lex_state = 5},
  [1328] = {.lex_state = 197, .external_lex_state = 5},
  [1329] = {.lex_state = 271, .external_lex_state = 9},
  [1330] = {.lex_state = 157},
  [1331] = {.lex_state = 197, .external_lex_state = 14},
  [1332] = {.lex_state = 197, .external_lex_state = 5},
  [1333] = {.lex_state = 197, .external_lex_state = 5},
  [1334] = {.lex_state = 197, .external_lex_state = 5},
  [1335] = {.lex_state = 157, .external_lex_state = 2},
  [1336] = {.lex_state = 157, .external_lex_state = 28},
  [1337] = {.lex_state = 157, .external_lex_state = 2},
  [1338] = {.lex_state = 157, .external_lex_state = 2},
  [1339] = {.lex_state = 157, .external_lex_state = 2},
  [1340] = {.lex_state = 157, .external_lex_state = 2},
  [1341] = {.lex_state = 157, .external_lex_state = 2},
  [1342] = {.lex_state = 157, .external_lex_state = 2},
  [1343] = {.lex_state = 157, .external_lex_state = 2},
  [1344] = {.lex_state = 157, .external_lex_state = 2},
  [1345] = {.lex_state = 157, .external_lex_state = 2},
  [1346] = {.lex_state = 157, .external_lex_state = 2},
  [1347] = {.lex_state = 135},
  [1348] = {.lex_state = 197, .external_lex_state = 14},
  [1349] = {.lex_state = 157, .external_lex_state = 28},
  [1350] = {.lex_state = 197, .external_lex_state = 5},
  [1351] = {.lex_state = 135, .external_lex_state = 10},
  [1352] = {.lex_state = 135},
  [1353] = {.lex_state = 135},
  [1354] = {.lex_state = 135},
  [1355] = {.lex_state = 220, .external_lex_state = 13},
  [1356] = {.lex_state = 277, .external_lex_state = 5},
  [1357] = {.lex_state = 274, .external_lex_state = 5},
  [1358] = {.lex_state = 274, .external_lex_state = 5},
  [1359] = {.lex_state = 223, .external_lex_state = 9},
  [1360] = {.lex_state = 157, .external_lex_state = 2},
  [1361] = {.lex_state = 157, .external_lex_state = 2},
  [1362] = {.lex_state = 271, .external_lex_state = 9},
  [1363] = {.lex_state = 157, .external_lex_state = 2},
  [1364] = {.lex_state = 164},
  [1365] = {.lex_state = 228},
  [1366] = {.lex_state = 220, .external_lex_state = 9},
  [1367] = {.lex_state = 157, .external_lex_state = 2},
  [1368] = {.lex_state = 157, .external_lex_state = 2},
  [1369] = {.lex_state = 220, .external_lex_state = 9},
  [1370] = {.lex_state = 220, .external_lex_state = 9},
  [1371] = {.lex_state = 157, .external_lex_state = 2},
  [1372] = {.lex_state = 220, .external_lex_state = 9},
  [1373] = {.lex_state = 274, .external_lex_state = 5},
  [1374] = {.lex_state = 344, .external_lex_state = 5},
  [1375] = {.lex_state = 274, .external_lex_state = 5},
  [1376] = {.lex_state = 274, .external_lex_state = 5},
  [1377] = {.lex_state = 271, .external_lex_state = 9},
  [1378] = {.lex_state = 157},
  [1379] = {.lex_state = 274, .external_lex_state = 14},
  [1380] = {.lex_state = 274, .external_lex_state = 5},
  [1381] = {.lex_state = 164},
  [1382] = {.lex_state = 258},
  [1383] = {.lex_state = 258, .external_lex_state = 6},
  [1384] = {.lex_state = 157, .external_lex_state = 2},
  [1385] = {.lex_state = 157, .external_lex_state = 2},
  [1386] = {.lex_state = 157, .external_lex_state = 2},
  [1387] = {.lex_state = 217, .external_lex_state = 22},
  [1388] = {.lex_state = 157, .external_lex_state = 2},
  [1389] = {.lex_state = 157, .external_lex_state = 2},
  [1390] = {.lex_state = 135, .external_lex_state = 2},
  [1391] = {.lex_state = 266, .external_lex_state = 8},
  [1392] = {.lex_state = 258},
  [1393] = {.lex_state = 300, .external_lex_state = 27},
  [1394] = {.lex_state = 164},
  [1395] = {.lex_state = 157, .external_lex_state = 28},
  [1396] = {.lex_state = 258},
  [1397] = {.lex_state = 157, .external_lex_state = 2},
  [1398] = {.lex_state = 157, .external_lex_state = 2},
  [1399] = {.lex_state = 271, .external_lex_state = 9},
  [1400] = {.lex_state = 157, .external_lex_state = 2},
  [1401] = {.lex_state = 228},
  [1402] = {.lex_state = 271, .external_lex_state = 9},
  [1403] = {.lex_state = 157, .external_lex_state = 2},
  [1404] = {.lex_state = 157, .external_lex_state = 2},
  [1405] = {.lex_state = 271, .external_lex_state = 9},
  [1406] = {.lex_state = 271, .external_lex_state = 9},
  [1407] = {.lex_state = 157, .external_lex_state = 2},
  [1408] = {.lex_state = 271, .external_lex_state = 9},
  [1409] = {.lex_state = 344, .external_lex_state = 5},
  [1410] = {.lex_state = 157},
  [1411] = {.lex_state = 271, .external_lex_state = 9},
  [1412] = {.lex_state = 277, .external_lex_state = 5},
  [1413] = {.lex_state = 344, .external_lex_state = 5},
  [1414] = {.lex_state = 344, .external_lex_state = 5},
  [1415] = {.lex_state = 344, .external_lex_state = 14},
  [1416] = {.lex_state = 277, .external_lex_state = 5},
  [1417] = {.lex_state = 157, .external_lex_state = 2},
  [1418] = {.lex_state = 157, .external_lex_state = 2},
  [1419] = {.lex_state = 157, .external_lex_state = 2},
  [1420] = {.lex_state = 157, .external_lex_state = 2},
  [1421] = {.lex_state = 157, .external_lex_state = 2},
  [1422] = {.lex_state = 157, .external_lex_state = 2},
  [1423] = {.lex_state = 157, .external_lex_state = 2},
  [1424] = {.lex_state = 157, .external_lex_state = 2},
  [1425] = {.lex_state = 157, .external_lex_state = 2},
  [1426] = {.lex_state = 157, .external_lex_state = 2},
  [1427] = {.lex_state = 157, .external_lex_state = 2},
  [1428] = {.lex_state = 274, .external_lex_state = 14},
  [1429] = {.lex_state = 197, .external_lex_state = 5},
  [1430] = {.lex_state = 135, .external_lex_state = 13},
  [1431] = {.lex_state = 135, .external_lex_state = 2},
  [1432] = {.lex_state = 197, .external_lex_state = 5},
  [1433] = {.lex_state = 157, .external_lex_state = 2},
  [1434] = {.lex_state = 135, .external_lex_state = 2},
  [1435] = {.lex_state = 135, .external_lex_state = 13},
  [1436] = {.lex_state = 258, .external_lex_state = 25},
  [1437] = {.lex_state = 300, .external_lex_state = 27},
  [1438] = {.lex_state = 164},
  [1439] = {.lex_state = 157, .external_lex_state = 2},
  [1440] = {.lex_state = 157, .external_lex_state = 2},
  [1441] = {.lex_state = 232, .external_lex_state = 7},
  [1442] = {.lex_state = 245, .external_lex_state = 17},
  [1443] = {.lex_state = 157, .external_lex_state = 2},
  [1444] = {.lex_state = 228},
  [1445] = {.lex_state = 220, .external_lex_state = 17},
  [1446] = {.lex_state = 157, .external_lex_state = 2},
  [1447] = {.lex_state = 157, .external_lex_state = 2},
  [1448] = {.lex_state = 220, .external_lex_state = 17},
  [1449] = {.lex_state = 220, .external_lex_state = 17},
  [1450] = {.lex_state = 157, .external_lex_state = 2},
  [1451] = {.lex_state = 220, .external_lex_state = 17},
  [1452] = {.lex_state = 157},
  [1453] = {.lex_state = 258, .external_lex_state = 18},
  [1454] = {.lex_state = 242, .external_lex_state = 16},
  [1455] = {.lex_state = 197, .external_lex_state = 16},
  [1456] = {.lex_state = 197, .external_lex_state = 19},
  [1457] = {.lex_state = 258, .external_lex_state = 18},
  [1458] = {.lex_state = 197, .external_lex_state = 5},
  [1459] = {.lex_state = 197, .external_lex_state = 5},
  [1460] = {.lex_state = 135, .external_lex_state = 2},
  [1461] = {.lex_state = 258, .external_lex_state = 25},
  [1462] = {.lex_state = 164},
  [1463] = {.lex_state = 197, .external_lex_state = 13},
  [1464] = {.lex_state = 197, .external_lex_state = 5},
  [1465] = {.lex_state = 157, .external_lex_state = 2},
  [1466] = {.lex_state = 157, .external_lex_state = 2},
  [1467] = {.lex_state = 217, .external_lex_state = 22},
  [1468] = {.lex_state = 157, .external_lex_state = 2},
  [1469] = {.lex_state = 164},
  [1470] = {.lex_state = 220, .external_lex_state = 9},
  [1471] = {.lex_state = 135, .external_lex_state = 2},
  [1472] = {.lex_state = 157, .external_lex_state = 2},
  [1473] = {.lex_state = 220, .external_lex_state = 9},
  [1474] = {.lex_state = 157, .external_lex_state = 8},
  [1475] = {.lex_state = 220, .external_lex_state = 9},
  [1476] = {.lex_state = 220, .external_lex_state = 9},
  [1477] = {.lex_state = 135},
  [1478] = {.lex_state = 135, .external_lex_state = 13},
  [1479] = {.lex_state = 268, .external_lex_state = 5},
  [1480] = {.lex_state = 197, .external_lex_state = 5},
  [1481] = {.lex_state = 197, .external_lex_state = 5},
  [1482] = {.lex_state = 197, .external_lex_state = 13},
  [1483] = {.lex_state = 271, .external_lex_state = 9},
  [1484] = {.lex_state = 197, .external_lex_state = 14},
  [1485] = {.lex_state = 157},
  [1486] = {.lex_state = 197, .external_lex_state = 13},
  [1487] = {.lex_state = 135, .external_lex_state = 2},
  [1488] = {.lex_state = 135, .external_lex_state = 2},
  [1489] = {.lex_state = 217, .external_lex_state = 22},
  [1490] = {.lex_state = 197, .external_lex_state = 5},
  [1491] = {.lex_state = 164, .external_lex_state = 3},
  [1492] = {.lex_state = 157, .external_lex_state = 2},
  [1493] = {.lex_state = 157, .external_lex_state = 2},
  [1494] = {.lex_state = 217, .external_lex_state = 22},
  [1495] = {.lex_state = 157, .external_lex_state = 2},
  [1496] = {.lex_state = 164},
  [1497] = {.lex_state = 220, .external_lex_state = 9},
  [1498] = {.lex_state = 220, .external_lex_state = 9},
  [1499] = {.lex_state = 220, .external_lex_state = 9},
  [1500] = {.lex_state = 220, .external_lex_state = 9},
  [1501] = {.lex_state = 135, .external_lex_state = 13},
  [1502] = {.lex_state = 197, .external_lex_state = 5},
  [1503] = {.lex_state = 157},
  [1504] = {.lex_state = 135, .external_lex_state = 2},
  [1505] = {.lex_state = 223, .external_lex_state = 9},
  [1506] = {.lex_state = 208, .external_lex_state = 5},
  [1507] = {.lex_state = 197, .external_lex_state = 5},
  [1508] = {.lex_state = 197, .external_lex_state = 14},
  [1509] = {.lex_state = 135},
  [1510] = {.lex_state = 135, .external_lex_state = 2},
  [1511] = {.lex_state = 223, .external_lex_state = 9},
  [1512] = {.lex_state = 157, .external_lex_state = 2},
  [1513] = {.lex_state = 157, .external_lex_state = 2},
  [1514] = {.lex_state = 271, .external_lex_state = 9},
  [1515] = {.lex_state = 157, .external_lex_state = 2},
  [1516] = {.lex_state = 164},
  [1517] = {.lex_state = 228},
  [1518] = {.lex_state = 220, .external_lex_state = 9},
  [1519] = {.lex_state = 157, .external_lex_state = 2},
  [1520] = {.lex_state = 157, .external_lex_state = 2},
  [1521] = {.lex_state = 220, .external_lex_state = 9},
  [1522] = {.lex_state = 220, .external_lex_state = 9},
  [1523] = {.lex_state = 157, .external_lex_state = 2},
  [1524] = {.lex_state = 220, .external_lex_state = 9},
  [1525] = {.lex_state = 197, .external_lex_state = 5},
  [1526] = {.lex_state = 268, .external_lex_state = 5},
  [1527] = {.lex_state = 197, .external_lex_state = 5},
  [1528] = {.lex_state = 197, .external_lex_state = 5},
  [1529] = {.lex_state = 271, .external_lex_state = 9},
  [1530] = {.lex_state = 157},
  [1531] = {.lex_state = 197, .external_lex_state = 14},
  [1532] = {.lex_state = 197, .external_lex_state = 5},
  [1533] = {.lex_state = 135, .external_lex_state = 2},
  [1534] = {.lex_state = 135},
  [1535] = {.lex_state = 157, .external_lex_state = 2},
  [1536] = {.lex_state = 157, .external_lex_state = 2},
  [1537] = {.lex_state = 157, .external_lex_state = 2},
  [1538] = {.lex_state = 157, .external_lex_state = 2},
  [1539] = {.lex_state = 157, .external_lex_state = 2},
  [1540] = {.lex_state = 135, .external_lex_state = 2},
  [1541] = {.lex_state = 197, .external_lex_state = 5},
  [1542] = {.lex_state = 300, .external_lex_state = 27},
  [1543] = {.lex_state = 164},
  [1544] = {.lex_state = 157, .external_lex_state = 28},
  [1545] = {.lex_state = 135},
  [1546] = {.lex_state = 135},
  [1547] = {.lex_state = 135, .external_lex_state = 2},
  [1548] = {.lex_state = 197, .external_lex_state = 5},
  [1549] = {.lex_state = 157, .external_lex_state = 2},
  [1550] = {.lex_state = 157, .external_lex_state = 2},
  [1551] = {.lex_state = 271, .external_lex_state = 9},
  [1552] = {.lex_state = 157, .external_lex_state = 2},
  [1553] = {.lex_state = 228},
  [1554] = {.lex_state = 271, .external_lex_state = 9},
  [1555] = {.lex_state = 157, .external_lex_state = 2},
  [1556] = {.lex_state = 157, .external_lex_state = 2},
  [1557] = {.lex_state = 271, .external_lex_state = 9},
  [1558] = {.lex_state = 271, .external_lex_state = 9},
  [1559] = {.lex_state = 157, .external_lex_state = 2},
  [1560] = {.lex_state = 271, .external_lex_state = 9},
  [1561] = {.lex_state = 268, .external_lex_state = 5},
  [1562] = {.lex_state = 157},
  [1563] = {.lex_state = 271, .external_lex_state = 9},
  [1564] = {.lex_state = 208, .external_lex_state = 5},
  [1565] = {.lex_state = 268, .external_lex_state = 5},
  [1566] = {.lex_state = 268, .external_lex_state = 5},
  [1567] = {.lex_state = 268, .external_lex_state = 14},
  [1568] = {.lex_state = 208, .external_lex_state = 5},
  [1569] = {.lex_state = 157, .external_lex_state = 2},
  [1570] = {.lex_state = 157, .external_lex_state = 2},
  [1571] = {.lex_state = 157, .external_lex_state = 2},
  [1572] = {.lex_state = 157, .external_lex_state = 2},
  [1573] = {.lex_state = 157, .external_lex_state = 2},
  [1574] = {.lex_state = 157, .external_lex_state = 2},
  [1575] = {.lex_state = 157, .external_lex_state = 2},
  [1576] = {.lex_state = 157, .external_lex_state = 2},
  [1577] = {.lex_state = 157, .external_lex_state = 2},
  [1578] = {.lex_state = 157, .external_lex_state = 2},
  [1579] = {.lex_state = 157, .external_lex_state = 2},
  [1580] = {.lex_state = 197, .external_lex_state = 14},
  [1581] = {.lex_state = 135},
  [1582] = {.lex_state = 135, .external_lex_state = 13},
  [1583] = {.lex_state = 135, .external_lex_state = 2},
  [1584] = {.lex_state = 258, .external_lex_state = 6},
  [1585] = {.lex_state = 300, .external_lex_state = 27},
  [1586] = {.lex_state = 164},
  [1587] = {.lex_state = 157, .external_lex_state = 2},
  [1588] = {.lex_state = 157, .external_lex_state = 2},
  [1589] = {.lex_state = 245, .external_lex_state = 17},
  [1590] = {.lex_state = 157, .external_lex_state = 2},
  [1591] = {.lex_state = 228},
  [1592] = {.lex_state = 220, .external_lex_state = 17},
  [1593] = {.lex_state = 157, .external_lex_state = 2},
  [1594] = {.lex_state = 157, .external_lex_state = 2},
  [1595] = {.lex_state = 220, .external_lex_state = 17},
  [1596] = {.lex_state = 220, .external_lex_state = 17},
  [1597] = {.lex_state = 157, .external_lex_state = 2},
  [1598] = {.lex_state = 220, .external_lex_state = 17},
  [1599] = {.lex_state = 157},
  [1600] = {.lex_state = 258, .external_lex_state = 18},
  [1601] = {.lex_state = 242, .external_lex_state = 16},
  [1602] = {.lex_state = 197, .external_lex_state = 16},
  [1603] = {.lex_state = 197, .external_lex_state = 19},
  [1604] = {.lex_state = 258, .external_lex_state = 18},
  [1605] = {.lex_state = 135},
  [1606] = {.lex_state = 197, .external_lex_state = 5},
  [1607] = {.lex_state = 135, .external_lex_state = 2},
  [1608] = {.lex_state = 217, .external_lex_state = 22},
  [1609] = {.lex_state = 135, .external_lex_state = 2},
  [1610] = {.lex_state = 135},
  [1611] = {.lex_state = 197, .external_lex_state = 5},
  [1612] = {.lex_state = 135, .external_lex_state = 15},
  [1613] = {.lex_state = 234, .external_lex_state = 15},
  [1614] = {.lex_state = 217, .external_lex_state = 4},
  [1615] = {.lex_state = 197, .external_lex_state = 5},
  [1616] = {.lex_state = 234, .external_lex_state = 15},
  [1617] = {.lex_state = 197, .external_lex_state = 5},
  [1618] = {.lex_state = 197, .external_lex_state = 5},
  [1619] = {.lex_state = 197, .external_lex_state = 5},
  [1620] = {.lex_state = 135, .external_lex_state = 2},
  [1621] = {.lex_state = 217, .external_lex_state = 22},
  [1622] = {.lex_state = 197, .external_lex_state = 5},
  [1623] = {.lex_state = 197, .external_lex_state = 5},
  [1624] = {.lex_state = 258},
  [1625] = {.lex_state = 258},
  [1626] = {.lex_state = 157, .external_lex_state = 8},
  [1627] = {.lex_state = 157},
  [1628] = {.lex_state = 223, .external_lex_state = 9},
  [1629] = {.lex_state = 266, .external_lex_state = 6},
  [1630] = {.lex_state = 223, .external_lex_state = 9},
  [1631] = {.lex_state = 217, .external_lex_state = 22},
  [1632] = {.lex_state = 223, .external_lex_state = 9},
  [1633] = {.lex_state = 300, .external_lex_state = 27},
  [1634] = {.lex_state = 208, .external_lex_state = 5},
  [1635] = {.lex_state = 157},
  [1636] = {.lex_state = 223, .external_lex_state = 9},
  [1637] = {.lex_state = 157, .external_lex_state = 2},
  [1638] = {.lex_state = 157, .external_lex_state = 2},
  [1639] = {.lex_state = 157, .external_lex_state = 2},
  [1640] = {.lex_state = 157, .external_lex_state = 2},
  [1641] = {.lex_state = 197, .external_lex_state = 5},
  [1642] = {.lex_state = 208, .external_lex_state = 5},
  [1643] = {.lex_state = 197, .external_lex_state = 5},
  [1644] = {.lex_state = 157},
  [1645] = {.lex_state = 197, .external_lex_state = 5},
  [1646] = {.lex_state = 197, .external_lex_state = 5},
  [1647] = {.lex_state = 135, .external_lex_state = 13},
  [1648] = {.lex_state = 215, .external_lex_state = 7},
  [1649] = {.lex_state = 268, .external_lex_state = 5},
  [1650] = {.lex_state = 268, .external_lex_state = 14},
  [1651] = {.lex_state = 268, .external_lex_state = 5},
  [1652] = {.lex_state = 268, .external_lex_state = 5},
  [1653] = {.lex_state = 182, .external_lex_state = 4},
  [1654] = {.lex_state = 234, .external_lex_state = 15},
  [1655] = {.lex_state = 268, .external_lex_state = 5},
  [1656] = {.lex_state = 157},
  [1657] = {.lex_state = 268, .external_lex_state = 5},
  [1658] = {.lex_state = 157, .external_lex_state = 2},
  [1659] = {.lex_state = 157, .external_lex_state = 2},
  [1660] = {.lex_state = 347, .external_lex_state = 9},
  [1661] = {.lex_state = 157, .external_lex_state = 2},
  [1662] = {.lex_state = 164},
  [1663] = {.lex_state = 304, .external_lex_state = 9},
  [1664] = {.lex_state = 304, .external_lex_state = 9},
  [1665] = {.lex_state = 304, .external_lex_state = 9},
  [1666] = {.lex_state = 304, .external_lex_state = 9},
  [1667] = {.lex_state = 232, .external_lex_state = 2},
  [1668] = {.lex_state = 215, .external_lex_state = 18},
  [1669] = {.lex_state = 307, .external_lex_state = 5},
  [1670] = {.lex_state = 157},
  [1671] = {.lex_state = 347, .external_lex_state = 9},
  [1672] = {.lex_state = 350, .external_lex_state = 5},
  [1673] = {.lex_state = 307, .external_lex_state = 5},
  [1674] = {.lex_state = 307, .external_lex_state = 14},
  [1675] = {.lex_state = 215},
  [1676] = {.lex_state = 215},
  [1677] = {.lex_state = 157, .external_lex_state = 2},
  [1678] = {.lex_state = 197, .external_lex_state = 5},
  [1679] = {.lex_state = 268, .external_lex_state = 5},
  [1680] = {.lex_state = 268, .external_lex_state = 14},
  [1681] = {.lex_state = 135, .external_lex_state = 15},
  [1682] = {.lex_state = 135},
  [1683] = {.lex_state = 208, .external_lex_state = 5},
  [1684] = {.lex_state = 135, .external_lex_state = 10},
  [1685] = {.lex_state = 135, .external_lex_state = 2},
  [1686] = {.lex_state = 135},
  [1687] = {.lex_state = 232, .external_lex_state = 2},
  [1688] = {.lex_state = 268, .external_lex_state = 5},
  [1689] = {.lex_state = 135},
  [1690] = {.lex_state = 157, .external_lex_state = 2},
  [1691] = {.lex_state = 157, .external_lex_state = 2},
  [1692] = {.lex_state = 215, .external_lex_state = 13},
  [1693] = {.lex_state = 268, .external_lex_state = 5},
  [1694] = {.lex_state = 157},
  [1695] = {.lex_state = 268, .external_lex_state = 5},
  [1696] = {.lex_state = 223, .external_lex_state = 9},
  [1697] = {.lex_state = 157, .external_lex_state = 2},
  [1698] = {.lex_state = 215, .external_lex_state = 10},
  [1699] = {.lex_state = 182, .external_lex_state = 4},
  [1700] = {.lex_state = 217, .external_lex_state = 4},
  [1701] = {.lex_state = 135, .external_lex_state = 2},
  [1702] = {.lex_state = 223, .external_lex_state = 9},
  [1703] = {.lex_state = 135, .external_lex_state = 2},
  [1704] = {.lex_state = 157, .external_lex_state = 11},
  [1705] = {.lex_state = 157, .external_lex_state = 8},
  [1706] = {.lex_state = 135, .external_lex_state = 10},
  [1707] = {.lex_state = 157, .external_lex_state = 2},
  [1708] = {.lex_state = 157, .external_lex_state = 2},
  [1709] = {.lex_state = 217, .external_lex_state = 4},
  [1710] = {.lex_state = 182, .external_lex_state = 4},
  [1711] = {.lex_state = 208, .external_lex_state = 5},
  [1712] = {.lex_state = 157, .external_lex_state = 6},
  [1713] = {.lex_state = 215, .external_lex_state = 7},
  [1714] = {.lex_state = 223, .external_lex_state = 9},
  [1715] = {.lex_state = 157, .external_lex_state = 2},
  [1716] = {.lex_state = 157, .external_lex_state = 2},
  [1717] = {.lex_state = 208, .external_lex_state = 5},
  [1718] = {.lex_state = 157, .external_lex_state = 8},
  [1719] = {.lex_state = 217, .external_lex_state = 4},
  [1720] = {.lex_state = 217, .external_lex_state = 4},
  [1721] = {.lex_state = 157},
  [1722] = {.lex_state = 164, .external_lex_state = 3},
  [1723] = {.lex_state = 223, .external_lex_state = 9},
  [1724] = {.lex_state = 135, .external_lex_state = 2},
  [1725] = {.lex_state = 208, .external_lex_state = 5},
  [1726] = {.lex_state = 208, .external_lex_state = 5},
  [1727] = {.lex_state = 208, .external_lex_state = 5},
  [1728] = {.lex_state = 223, .external_lex_state = 9},
  [1729] = {.lex_state = 157},
  [1730] = {.lex_state = 208, .external_lex_state = 14},
  [1731] = {.lex_state = 268, .external_lex_state = 5},
  [1732] = {.lex_state = 135, .external_lex_state = 15},
  [1733] = {.lex_state = 197, .external_lex_state = 5},
  [1734] = {.lex_state = 135},
  [1735] = {.lex_state = 208, .external_lex_state = 5},
  [1736] = {.lex_state = 135},
  [1737] = {.lex_state = 268, .external_lex_state = 5},
  [1738] = {.lex_state = 135},
  [1739] = {.lex_state = 208, .external_lex_state = 5},
  [1740] = {.lex_state = 268, .external_lex_state = 5},
  [1741] = {.lex_state = 157, .external_lex_state = 2},
  [1742] = {.lex_state = 258, .external_lex_state = 25},
  [1743] = {.lex_state = 258, .external_lex_state = 25},
  [1744] = {.lex_state = 268, .external_lex_state = 5},
  [1745] = {.lex_state = 135, .external_lex_state = 15},
  [1746] = {.lex_state = 258, .external_lex_state = 25},
  [1747] = {.lex_state = 258, .external_lex_state = 25},
  [1748] = {.lex_state = 135},
  [1749] = {.lex_state = 135},
  [1750] = {.lex_state = 135, .external_lex_state = 2},
  [1751] = {.lex_state = 268, .external_lex_state = 5},
  [1752] = {.lex_state = 135},
  [1753] = {.lex_state = 135},
  [1754] = {.lex_state = 268, .external_lex_state = 5},
  [1755] = {.lex_state = 268, .external_lex_state = 5},
  [1756] = {.lex_state = 135, .external_lex_state = 15},
  [1757] = {.lex_state = 268, .external_lex_state = 5},
  [1758] = {.lex_state = 208, .external_lex_state = 5},
  [1759] = {.lex_state = 135, .external_lex_state = 13},
  [1760] = {.lex_state = 268, .external_lex_state = 5},
  [1761] = {.lex_state = 182, .external_lex_state = 4},
  [1762] = {.lex_state = 234, .external_lex_state = 15},
  [1763] = {.lex_state = 268, .external_lex_state = 5},
  [1764] = {.lex_state = 232, .external_lex_state = 2},
  [1765] = {.lex_state = 208, .external_lex_state = 5},
  [1766] = {.lex_state = 157, .external_lex_state = 28},
  [1767] = {.lex_state = 232, .external_lex_state = 7},
  [1768] = {.lex_state = 268, .external_lex_state = 5},
  [1769] = {.lex_state = 217, .external_lex_state = 22},
  [1770] = {.lex_state = 157, .external_lex_state = 29},
  [1771] = {.lex_state = 208, .external_lex_state = 5},
  [1772] = {.lex_state = 208, .external_lex_state = 5},
  [1773] = {.lex_state = 157, .external_lex_state = 2},
  [1774] = {.lex_state = 157, .external_lex_state = 2},
  [1775] = {.lex_state = 157, .external_lex_state = 2},
  [1776] = {.lex_state = 157, .external_lex_state = 2},
  [1777] = {.lex_state = 157, .external_lex_state = 2},
  [1778] = {.lex_state = 157, .external_lex_state = 2},
  [1779] = {.lex_state = 157, .external_lex_state = 2},
  [1780] = {.lex_state = 157, .external_lex_state = 2},
  [1781] = {.lex_state = 157, .external_lex_state = 2},
  [1782] = {.lex_state = 157, .external_lex_state = 2},
  [1783] = {.lex_state = 268, .external_lex_state = 14},
  [1784] = {.lex_state = 197, .external_lex_state = 5},
  [1785] = {.lex_state = 197, .external_lex_state = 5},
  [1786] = {.lex_state = 197, .external_lex_state = 5},
  [1787] = {.lex_state = 197, .external_lex_state = 5},
  [1788] = {.lex_state = 197, .external_lex_state = 5},
  [1789] = {.lex_state = 353, .external_lex_state = 21},
  [1790] = {.lex_state = 353, .external_lex_state = 21},
  [1791] = {.lex_state = 157, .external_lex_state = 2},
  [1792] = {.lex_state = 157, .external_lex_state = 2},
  [1793] = {.lex_state = 353, .external_lex_state = 21},
  [1794] = {.lex_state = 157, .external_lex_state = 2},
  [1795] = {.lex_state = 164},
  [1796] = {.lex_state = 353, .external_lex_state = 21},
  [1797] = {.lex_state = 356, .external_lex_state = 20},
  [1798] = {.lex_state = 359, .external_lex_state = 20},
  [1799] = {.lex_state = 363, .external_lex_state = 20},
  [1800] = {.lex_state = 366, .external_lex_state = 21},
  [1801] = {.lex_state = 157},
  [1802] = {.lex_state = 363, .external_lex_state = 23},
  [1803] = {.lex_state = 197, .external_lex_state = 5},
  [1804] = {.lex_state = 197, .external_lex_state = 5},
  [1805] = {.lex_state = 197, .external_lex_state = 5},
  [1806] = {.lex_state = 197, .external_lex_state = 5},
  [1807] = {.lex_state = 197, .external_lex_state = 5},
  [1808] = {.lex_state = 197, .external_lex_state = 14},
  [1809] = {.lex_state = 283},
  [1810] = {.lex_state = 164, .external_lex_state = 3},
  [1811] = {.lex_state = 157, .external_lex_state = 2},
  [1812] = {.lex_state = 157, .external_lex_state = 2},
  [1813] = {.lex_state = 157, .external_lex_state = 2},
  [1814] = {.lex_state = 164},
  [1815] = {.lex_state = 220, .external_lex_state = 9},
  [1816] = {.lex_state = 220, .external_lex_state = 9},
  [1817] = {.lex_state = 220, .external_lex_state = 9},
  [1818] = {.lex_state = 220, .external_lex_state = 9},
  [1819] = {.lex_state = 135, .external_lex_state = 13},
  [1820] = {.lex_state = 197, .external_lex_state = 5},
  [1821] = {.lex_state = 157},
  [1822] = {.lex_state = 223, .external_lex_state = 9},
  [1823] = {.lex_state = 208, .external_lex_state = 5},
  [1824] = {.lex_state = 197, .external_lex_state = 5},
  [1825] = {.lex_state = 197, .external_lex_state = 14},
  [1826] = {.lex_state = 197, .external_lex_state = 5},
  [1827] = {.lex_state = 197, .external_lex_state = 14},
  [1828] = {.lex_state = 157, .external_lex_state = 2},
  [1829] = {.lex_state = 197, .external_lex_state = 5},
  [1830] = {.lex_state = 271, .external_lex_state = 9},
  [1831] = {.lex_state = 157, .external_lex_state = 2},
  [1832] = {.lex_state = 271, .external_lex_state = 9},
  [1833] = {.lex_state = 228},
  [1834] = {.lex_state = 157, .external_lex_state = 2},
  [1835] = {.lex_state = 157, .external_lex_state = 2},
  [1836] = {.lex_state = 157, .external_lex_state = 2},
  [1837] = {.lex_state = 197, .external_lex_state = 5},
  [1838] = {.lex_state = 197, .external_lex_state = 5},
  [1839] = {.lex_state = 197, .external_lex_state = 14},
  [1840] = {.lex_state = 197, .external_lex_state = 5},
  [1841] = {.lex_state = 220, .external_lex_state = 9},
  [1842] = {.lex_state = 220, .external_lex_state = 9},
  [1843] = {.lex_state = 157, .external_lex_state = 2},
  [1844] = {.lex_state = 157, .external_lex_state = 2},
  [1845] = {.lex_state = 220, .external_lex_state = 9},
  [1846] = {.lex_state = 157, .external_lex_state = 2},
  [1847] = {.lex_state = 220, .external_lex_state = 9},
  [1848] = {.lex_state = 208, .external_lex_state = 5},
  [1849] = {.lex_state = 197, .external_lex_state = 5},
  [1850] = {.lex_state = 157},
  [1851] = {.lex_state = 197, .external_lex_state = 14},
  [1852] = {.lex_state = 197, .external_lex_state = 5},
  [1853] = {.lex_state = 197, .external_lex_state = 5},
  [1854] = {.lex_state = 157, .external_lex_state = 29},
  [1855] = {.lex_state = 197, .external_lex_state = 5},
  [1856] = {.lex_state = 197, .external_lex_state = 5},
  [1857] = {.lex_state = 157, .external_lex_state = 2},
  [1858] = {.lex_state = 157, .external_lex_state = 28},
  [1859] = {.lex_state = 157, .external_lex_state = 2},
  [1860] = {.lex_state = 157, .external_lex_state = 2},
  [1861] = {.lex_state = 157, .external_lex_state = 2},
  [1862] = {.lex_state = 157, .external_lex_state = 2},
  [1863] = {.lex_state = 157, .external_lex_state = 2},
  [1864] = {.lex_state = 157, .external_lex_state = 2},
  [1865] = {.lex_state = 157, .external_lex_state = 2},
  [1866] = {.lex_state = 157, .external_lex_state = 2},
  [1867] = {.lex_state = 157, .external_lex_state = 2},
  [1868] = {.lex_state = 300, .external_lex_state = 27},
  [1869] = {.lex_state = 164},
  [1870] = {.lex_state = 232, .external_lex_state = 7},
  [1871] = {.lex_state = 271, .external_lex_state = 9},
  [1872] = {.lex_state = 228},
  [1873] = {.lex_state = 157, .external_lex_state = 2},
  [1874] = {.lex_state = 157, .external_lex_state = 2},
  [1875] = {.lex_state = 157, .external_lex_state = 2},
  [1876] = {.lex_state = 268, .external_lex_state = 5},
  [1877] = {.lex_state = 268, .external_lex_state = 5},
  [1878] = {.lex_state = 268, .external_lex_state = 14},
  [1879] = {.lex_state = 268, .external_lex_state = 5},
  [1880] = {.lex_state = 197, .external_lex_state = 14},
  [1881] = {.lex_state = 197, .external_lex_state = 5},
  [1882] = {.lex_state = 157, .external_lex_state = 2},
  [1883] = {.lex_state = 157, .external_lex_state = 2},
  [1884] = {.lex_state = 157, .external_lex_state = 2},
  [1885] = {.lex_state = 157, .external_lex_state = 2},
  [1886] = {.lex_state = 208, .external_lex_state = 5},
  [1887] = {.lex_state = 197, .external_lex_state = 5},
  [1888] = {.lex_state = 157},
  [1889] = {.lex_state = 197, .external_lex_state = 5},
  [1890] = {.lex_state = 197, .external_lex_state = 5},
  [1891] = {.lex_state = 197, .external_lex_state = 5},
  [1892] = {.lex_state = 359, .external_lex_state = 20},
  [1893] = {.lex_state = 197, .external_lex_state = 5},
  [1894] = {.lex_state = 197, .external_lex_state = 5},
  [1895] = {.lex_state = 197, .external_lex_state = 5},
  [1896] = {.lex_state = 197, .external_lex_state = 5},
  [1897] = {.lex_state = 197, .external_lex_state = 5},
  [1898] = {.lex_state = 197, .external_lex_state = 5},
  [1899] = {.lex_state = 135, .external_lex_state = 2},
  [1900] = {.lex_state = 217, .external_lex_state = 22},
  [1901] = {.lex_state = 197, .external_lex_state = 5},
  [1902] = {.lex_state = 197, .external_lex_state = 5},
  [1903] = {.lex_state = 135},
  [1904] = {.lex_state = 223, .external_lex_state = 9},
  [1905] = {.lex_state = 266, .external_lex_state = 6},
  [1906] = {.lex_state = 223, .external_lex_state = 9},
  [1907] = {.lex_state = 223, .external_lex_state = 9},
  [1908] = {.lex_state = 300, .external_lex_state = 27},
  [1909] = {.lex_state = 223, .external_lex_state = 9},
  [1910] = {.lex_state = 268, .external_lex_state = 5},
  [1911] = {.lex_state = 268, .external_lex_state = 14},
  [1912] = {.lex_state = 268, .external_lex_state = 5},
  [1913] = {.lex_state = 157, .external_lex_state = 2},
  [1914] = {.lex_state = 268, .external_lex_state = 5},
  [1915] = {.lex_state = 157, .external_lex_state = 2},
  [1916] = {.lex_state = 223, .external_lex_state = 9},
  [1917] = {.lex_state = 223, .external_lex_state = 9},
  [1918] = {.lex_state = 157, .external_lex_state = 2},
  [1919] = {.lex_state = 157, .external_lex_state = 2},
  [1920] = {.lex_state = 223, .external_lex_state = 9},
  [1921] = {.lex_state = 157, .external_lex_state = 2},
  [1922] = {.lex_state = 223, .external_lex_state = 9},
  [1923] = {.lex_state = 208, .external_lex_state = 5},
  [1924] = {.lex_state = 208, .external_lex_state = 5},
  [1925] = {.lex_state = 208, .external_lex_state = 5},
  [1926] = {.lex_state = 223, .external_lex_state = 9},
  [1927] = {.lex_state = 157},
  [1928] = {.lex_state = 208, .external_lex_state = 14},
  [1929] = {.lex_state = 208, .external_lex_state = 5},
  [1930] = {.lex_state = 208, .external_lex_state = 5},
  [1931] = {.lex_state = 157, .external_lex_state = 28},
  [1932] = {.lex_state = 157, .external_lex_state = 29},
  [1933] = {.lex_state = 208, .external_lex_state = 5},
  [1934] = {.lex_state = 208, .external_lex_state = 5},
  [1935] = {.lex_state = 157, .external_lex_state = 2},
  [1936] = {.lex_state = 157, .external_lex_state = 2},
  [1937] = {.lex_state = 157, .external_lex_state = 2},
  [1938] = {.lex_state = 157, .external_lex_state = 2},
  [1939] = {.lex_state = 157, .external_lex_state = 2},
  [1940] = {.lex_state = 157, .external_lex_state = 2},
  [1941] = {.lex_state = 157, .external_lex_state = 2},
  [1942] = {.lex_state = 157, .external_lex_state = 2},
  [1943] = {.lex_state = 157, .external_lex_state = 2},
  [1944] = {.lex_state = 157, .external_lex_state = 2},
  [1945] = {.lex_state = 268, .external_lex_state = 14},
  [1946] = {.lex_state = 197, .external_lex_state = 14},
  [1947] = {.lex_state = 197, .external_lex_state = 13},
  [1948] = {.lex_state = 197, .external_lex_state = 13},
  [1949] = {.lex_state = 197, .external_lex_state = 13},
  [1950] = {.lex_state = 215, .external_lex_state = 13},
  [1951] = {.lex_state = 307, .external_lex_state = 5},
  [1952] = {.lex_state = 307, .external_lex_state = 5},
  [1953] = {.lex_state = 310, .external_lex_state = 9},
  [1954] = {.lex_state = 157, .external_lex_state = 2},
  [1955] = {.lex_state = 157, .external_lex_state = 2},
  [1956] = {.lex_state = 347, .external_lex_state = 9},
  [1957] = {.lex_state = 157, .external_lex_state = 2},
  [1958] = {.lex_state = 228},
  [1959] = {.lex_state = 304, .external_lex_state = 9},
  [1960] = {.lex_state = 157, .external_lex_state = 2},
  [1961] = {.lex_state = 157, .external_lex_state = 2},
  [1962] = {.lex_state = 304, .external_lex_state = 9},
  [1963] = {.lex_state = 304, .external_lex_state = 9},
  [1964] = {.lex_state = 157, .external_lex_state = 2},
  [1965] = {.lex_state = 304, .external_lex_state = 9},
  [1966] = {.lex_state = 307, .external_lex_state = 5},
  [1967] = {.lex_state = 350, .external_lex_state = 5},
  [1968] = {.lex_state = 307, .external_lex_state = 5},
  [1969] = {.lex_state = 157},
  [1970] = {.lex_state = 307, .external_lex_state = 14},
  [1971] = {.lex_state = 307, .external_lex_state = 5},
  [1972] = {.lex_state = 157, .external_lex_state = 2},
  [1973] = {.lex_state = 157, .external_lex_state = 2},
  [1974] = {.lex_state = 157, .external_lex_state = 2},
  [1975] = {.lex_state = 217, .external_lex_state = 22},
  [1976] = {.lex_state = 157, .external_lex_state = 2},
  [1977] = {.lex_state = 157, .external_lex_state = 2},
  [1978] = {.lex_state = 232, .external_lex_state = 2},
  [1979] = {.lex_state = 300, .external_lex_state = 27},
  [1980] = {.lex_state = 164},
  [1981] = {.lex_state = 157, .external_lex_state = 28},
  [1982] = {.lex_state = 157, .external_lex_state = 2},
  [1983] = {.lex_state = 157, .external_lex_state = 2},
  [1984] = {.lex_state = 347, .external_lex_state = 9},
  [1985] = {.lex_state = 157, .external_lex_state = 2},
  [1986] = {.lex_state = 228},
  [1987] = {.lex_state = 347, .external_lex_state = 9},
  [1988] = {.lex_state = 157, .external_lex_state = 2},
  [1989] = {.lex_state = 157, .external_lex_state = 2},
  [1990] = {.lex_state = 347, .external_lex_state = 9},
  [1991] = {.lex_state = 347, .external_lex_state = 9},
  [1992] = {.lex_state = 157, .external_lex_state = 2},
  [1993] = {.lex_state = 347, .external_lex_state = 9},
  [1994] = {.lex_state = 350, .external_lex_state = 5},
  [1995] = {.lex_state = 157},
  [1996] = {.lex_state = 347, .external_lex_state = 9},
  [1997] = {.lex_state = 313, .external_lex_state = 5},
  [1998] = {.lex_state = 350, .external_lex_state = 5},
  [1999] = {.lex_state = 350, .external_lex_state = 5},
  [2000] = {.lex_state = 350, .external_lex_state = 14},
  [2001] = {.lex_state = 313, .external_lex_state = 5},
  [2002] = {.lex_state = 157, .external_lex_state = 2},
  [2003] = {.lex_state = 157, .external_lex_state = 2},
  [2004] = {.lex_state = 157, .external_lex_state = 2},
  [2005] = {.lex_state = 157, .external_lex_state = 2},
  [2006] = {.lex_state = 157, .external_lex_state = 2},
  [2007] = {.lex_state = 157, .external_lex_state = 2},
  [2008] = {.lex_state = 157, .external_lex_state = 2},
  [2009] = {.lex_state = 157, .external_lex_state = 2},
  [2010] = {.lex_state = 157, .external_lex_state = 2},
  [2011] = {.lex_state = 157, .external_lex_state = 2},
  [2012] = {.lex_state = 157, .external_lex_state = 2},
  [2013] = {.lex_state = 307, .external_lex_state = 14},
  [2014] = {.lex_state = 197, .external_lex_state = 13},
  [2015] = {.lex_state = 215, .external_lex_state = 13},
  [2016] = {.lex_state = 232, .external_lex_state = 2},
  [2017] = {.lex_state = 197, .external_lex_state = 13},
  [2018] = {.lex_state = 197, .external_lex_state = 5},
  [2019] = {.lex_state = 197, .external_lex_state = 14},
  [2020] = {.lex_state = 157, .external_lex_state = 2},
  [2021] = {.lex_state = 197, .external_lex_state = 5},
  [2022] = {.lex_state = 271, .external_lex_state = 9},
  [2023] = {.lex_state = 157, .external_lex_state = 2},
  [2024] = {.lex_state = 271, .external_lex_state = 9},
  [2025] = {.lex_state = 228},
  [2026] = {.lex_state = 157, .external_lex_state = 2},
  [2027] = {.lex_state = 157, .external_lex_state = 2},
  [2028] = {.lex_state = 157, .external_lex_state = 2},
  [2029] = {.lex_state = 197, .external_lex_state = 5},
  [2030] = {.lex_state = 197, .external_lex_state = 5},
  [2031] = {.lex_state = 197, .external_lex_state = 14},
  [2032] = {.lex_state = 197, .external_lex_state = 5},
  [2033] = {.lex_state = 220, .external_lex_state = 9},
  [2034] = {.lex_state = 220, .external_lex_state = 9},
  [2035] = {.lex_state = 157, .external_lex_state = 2},
  [2036] = {.lex_state = 157, .external_lex_state = 2},
  [2037] = {.lex_state = 220, .external_lex_state = 9},
  [2038] = {.lex_state = 157, .external_lex_state = 2},
  [2039] = {.lex_state = 220, .external_lex_state = 9},
  [2040] = {.lex_state = 208, .external_lex_state = 5},
  [2041] = {.lex_state = 197, .external_lex_state = 5},
  [2042] = {.lex_state = 157},
  [2043] = {.lex_state = 197, .external_lex_state = 14},
  [2044] = {.lex_state = 197, .external_lex_state = 5},
  [2045] = {.lex_state = 197, .external_lex_state = 5},
  [2046] = {.lex_state = 157, .external_lex_state = 29},
  [2047] = {.lex_state = 197, .external_lex_state = 5},
  [2048] = {.lex_state = 197, .external_lex_state = 5},
  [2049] = {.lex_state = 157, .external_lex_state = 2},
  [2050] = {.lex_state = 157, .external_lex_state = 28},
  [2051] = {.lex_state = 157, .external_lex_state = 2},
  [2052] = {.lex_state = 157, .external_lex_state = 2},
  [2053] = {.lex_state = 157, .external_lex_state = 2},
  [2054] = {.lex_state = 157, .external_lex_state = 2},
  [2055] = {.lex_state = 157, .external_lex_state = 2},
  [2056] = {.lex_state = 157, .external_lex_state = 2},
  [2057] = {.lex_state = 157, .external_lex_state = 2},
  [2058] = {.lex_state = 157, .external_lex_state = 2},
  [2059] = {.lex_state = 157, .external_lex_state = 2},
  [2060] = {.lex_state = 300, .external_lex_state = 27},
  [2061] = {.lex_state = 164},
  [2062] = {.lex_state = 271, .external_lex_state = 9},
  [2063] = {.lex_state = 228},
  [2064] = {.lex_state = 157, .external_lex_state = 2},
  [2065] = {.lex_state = 157, .external_lex_state = 2},
  [2066] = {.lex_state = 157, .external_lex_state = 2},
  [2067] = {.lex_state = 268, .external_lex_state = 5},
  [2068] = {.lex_state = 268, .external_lex_state = 5},
  [2069] = {.lex_state = 268, .external_lex_state = 14},
  [2070] = {.lex_state = 268, .external_lex_state = 5},
  [2071] = {.lex_state = 197, .external_lex_state = 14},
  [2072] = {.lex_state = 164, .external_lex_state = 3},
  [2073] = {.lex_state = 157, .external_lex_state = 2},
  [2074] = {.lex_state = 157, .external_lex_state = 2},
  [2075] = {.lex_state = 157, .external_lex_state = 2},
  [2076] = {.lex_state = 164},
  [2077] = {.lex_state = 220, .external_lex_state = 9},
  [2078] = {.lex_state = 135, .external_lex_state = 2},
  [2079] = {.lex_state = 220, .external_lex_state = 9},
  [2080] = {.lex_state = 220, .external_lex_state = 9},
  [2081] = {.lex_state = 220, .external_lex_state = 9},
  [2082] = {.lex_state = 135, .external_lex_state = 13},
  [2083] = {.lex_state = 197, .external_lex_state = 5},
  [2084] = {.lex_state = 157},
  [2085] = {.lex_state = 223, .external_lex_state = 9},
  [2086] = {.lex_state = 208, .external_lex_state = 5},
  [2087] = {.lex_state = 197, .external_lex_state = 5},
  [2088] = {.lex_state = 197, .external_lex_state = 14},
  [2089] = {.lex_state = 135},
  [2090] = {.lex_state = 135, .external_lex_state = 2},
  [2091] = {.lex_state = 197, .external_lex_state = 5},
  [2092] = {.lex_state = 197, .external_lex_state = 5},
  [2093] = {.lex_state = 197, .external_lex_state = 5},
  [2094] = {.lex_state = 135, .external_lex_state = 2},
  [2095] = {.lex_state = 217, .external_lex_state = 22},
  [2096] = {.lex_state = 197, .external_lex_state = 5},
  [2097] = {.lex_state = 197, .external_lex_state = 5},
  [2098] = {.lex_state = 135, .external_lex_state = 2},
  [2099] = {.lex_state = 197, .external_lex_state = 5},
  [2100] = {.lex_state = 135},
  [2101] = {.lex_state = 223, .external_lex_state = 9},
  [2102] = {.lex_state = 266, .external_lex_state = 6},
  [2103] = {.lex_state = 223, .external_lex_state = 9},
  [2104] = {.lex_state = 223, .external_lex_state = 9},
  [2105] = {.lex_state = 300, .external_lex_state = 27},
  [2106] = {.lex_state = 223, .external_lex_state = 9},
  [2107] = {.lex_state = 157, .external_lex_state = 2},
  [2108] = {.lex_state = 157, .external_lex_state = 2},
  [2109] = {.lex_state = 157, .external_lex_state = 2},
  [2110] = {.lex_state = 157, .external_lex_state = 2},
  [2111] = {.lex_state = 208, .external_lex_state = 5},
  [2112] = {.lex_state = 197, .external_lex_state = 5},
  [2113] = {.lex_state = 157},
  [2114] = {.lex_state = 197, .external_lex_state = 5},
  [2115] = {.lex_state = 268, .external_lex_state = 5},
  [2116] = {.lex_state = 268, .external_lex_state = 14},
  [2117] = {.lex_state = 157, .external_lex_state = 2},
  [2118] = {.lex_state = 268, .external_lex_state = 5},
  [2119] = {.lex_state = 157, .external_lex_state = 2},
  [2120] = {.lex_state = 223, .external_lex_state = 9},
  [2121] = {.lex_state = 223, .external_lex_state = 9},
  [2122] = {.lex_state = 157, .external_lex_state = 2},
  [2123] = {.lex_state = 157, .external_lex_state = 2},
  [2124] = {.lex_state = 223, .external_lex_state = 9},
  [2125] = {.lex_state = 157, .external_lex_state = 2},
  [2126] = {.lex_state = 223, .external_lex_state = 9},
  [2127] = {.lex_state = 208, .external_lex_state = 5},
  [2128] = {.lex_state = 208, .external_lex_state = 5},
  [2129] = {.lex_state = 208, .external_lex_state = 5},
  [2130] = {.lex_state = 223, .external_lex_state = 9},
  [2131] = {.lex_state = 157},
  [2132] = {.lex_state = 208, .external_lex_state = 14},
  [2133] = {.lex_state = 208, .external_lex_state = 5},
  [2134] = {.lex_state = 208, .external_lex_state = 5},
  [2135] = {.lex_state = 157, .external_lex_state = 28},
  [2136] = {.lex_state = 157, .external_lex_state = 29},
  [2137] = {.lex_state = 208, .external_lex_state = 5},
  [2138] = {.lex_state = 208, .external_lex_state = 5},
  [2139] = {.lex_state = 157, .external_lex_state = 2},
  [2140] = {.lex_state = 157, .external_lex_state = 2},
  [2141] = {.lex_state = 157, .external_lex_state = 2},
  [2142] = {.lex_state = 157, .external_lex_state = 2},
  [2143] = {.lex_state = 157, .external_lex_state = 2},
  [2144] = {.lex_state = 157, .external_lex_state = 2},
  [2145] = {.lex_state = 157, .external_lex_state = 2},
  [2146] = {.lex_state = 157, .external_lex_state = 2},
  [2147] = {.lex_state = 157, .external_lex_state = 2},
  [2148] = {.lex_state = 157, .external_lex_state = 2},
  [2149] = {.lex_state = 268, .external_lex_state = 14},
  [2150] = {.lex_state = 197, .external_lex_state = 5},
  [2151] = {.lex_state = 197, .external_lex_state = 5},
  [2152] = {.lex_state = 197, .external_lex_state = 5},
  [2153] = {.lex_state = 197, .external_lex_state = 5},
  [2154] = {.lex_state = 197, .external_lex_state = 5},
  [2155] = {.lex_state = 359, .external_lex_state = 20},
  [2156] = {.lex_state = 197, .external_lex_state = 5},
  [2157] = {.lex_state = 197, .external_lex_state = 5},
  [2158] = {.lex_state = 197, .external_lex_state = 5},
  [2159] = {.lex_state = 197, .external_lex_state = 5},
  [2160] = {.lex_state = 197, .external_lex_state = 5},
  [2161] = {.lex_state = 197, .external_lex_state = 14},
  [2162] = {.lex_state = 197, .external_lex_state = 5},
  [2163] = {.lex_state = 217, .external_lex_state = 4},
  [2164] = {.lex_state = 197, .external_lex_state = 5},
  [2165] = {.lex_state = 234, .external_lex_state = 15},
  [2166] = {.lex_state = 197, .external_lex_state = 5},
  [2167] = {.lex_state = 215},
  [2168] = {.lex_state = 215},
  [2169] = {.lex_state = 215},
  [2170] = {.lex_state = 232, .external_lex_state = 2},
  [2171] = {.lex_state = 135, .external_lex_state = 13},
  [2172] = {.lex_state = 307, .external_lex_state = 20},
  [2173] = {.lex_state = 369, .external_lex_state = 20},
  [2174] = {.lex_state = 316, .external_lex_state = 20},
  [2175] = {.lex_state = 182, .external_lex_state = 4},
  [2176] = {.lex_state = 234, .external_lex_state = 15},
  [2177] = {.lex_state = 164, .external_lex_state = 3},
  [2178] = {.lex_state = 316, .external_lex_state = 20},
  [2179] = {.lex_state = 157},
  [2180] = {.lex_state = 316, .external_lex_state = 20},
  [2181] = {.lex_state = 215, .external_lex_state = 18},
  [2182] = {.lex_state = 215},
  [2183] = {.lex_state = 232, .external_lex_state = 2},
  [2184] = {.lex_state = 197, .external_lex_state = 5},
  [2185] = {.lex_state = 307, .external_lex_state = 20},
  [2186] = {.lex_state = 316, .external_lex_state = 23},
  [2187] = {.lex_state = 135, .external_lex_state = 15},
  [2188] = {.lex_state = 135},
  [2189] = {.lex_state = 135, .external_lex_state = 10},
  [2190] = {.lex_state = 232, .external_lex_state = 2},
  [2191] = {.lex_state = 316, .external_lex_state = 20},
  [2192] = {.lex_state = 135},
  [2193] = {.lex_state = 310, .external_lex_state = 21},
  [2194] = {.lex_state = 157, .external_lex_state = 2},
  [2195] = {.lex_state = 215, .external_lex_state = 13},
  [2196] = {.lex_state = 316, .external_lex_state = 20},
  [2197] = {.lex_state = 157},
  [2198] = {.lex_state = 157, .external_lex_state = 2},
  [2199] = {.lex_state = 157, .external_lex_state = 2},
  [2200] = {.lex_state = 347, .external_lex_state = 17},
  [2201] = {.lex_state = 157, .external_lex_state = 2},
  [2202] = {.lex_state = 164},
  [2203] = {.lex_state = 228},
  [2204] = {.lex_state = 304, .external_lex_state = 17},
  [2205] = {.lex_state = 157, .external_lex_state = 2},
  [2206] = {.lex_state = 266, .external_lex_state = 6},
  [2207] = {.lex_state = 157, .external_lex_state = 2},
  [2208] = {.lex_state = 304, .external_lex_state = 17},
  [2209] = {.lex_state = 304, .external_lex_state = 17},
  [2210] = {.lex_state = 157, .external_lex_state = 2},
  [2211] = {.lex_state = 304, .external_lex_state = 17},
  [2212] = {.lex_state = 307, .external_lex_state = 16},
  [2213] = {.lex_state = 350, .external_lex_state = 16},
  [2214] = {.lex_state = 307, .external_lex_state = 16},
  [2215] = {.lex_state = 307, .external_lex_state = 16},
  [2216] = {.lex_state = 347, .external_lex_state = 17},
  [2217] = {.lex_state = 157},
  [2218] = {.lex_state = 307, .external_lex_state = 19},
  [2219] = {.lex_state = 316, .external_lex_state = 20},
  [2220] = {.lex_state = 307, .external_lex_state = 16},
  [2221] = {.lex_state = 316, .external_lex_state = 20},
  [2222] = {.lex_state = 135, .external_lex_state = 15},
  [2223] = {.lex_state = 197, .external_lex_state = 5},
  [2224] = {.lex_state = 135},
  [2225] = {.lex_state = 316, .external_lex_state = 20},
  [2226] = {.lex_state = 135},
  [2227] = {.lex_state = 316, .external_lex_state = 20},
  [2228] = {.lex_state = 157, .external_lex_state = 2},
  [2229] = {.lex_state = 258, .external_lex_state = 25},
  [2230] = {.lex_state = 258, .external_lex_state = 25},
  [2231] = {.lex_state = 316, .external_lex_state = 20},
  [2232] = {.lex_state = 135, .external_lex_state = 15},
  [2233] = {.lex_state = 258, .external_lex_state = 25},
  [2234] = {.lex_state = 258, .external_lex_state = 25},
  [2235] = {.lex_state = 135},
  [2236] = {.lex_state = 135},
  [2237] = {.lex_state = 135, .external_lex_state = 2},
  [2238] = {.lex_state = 316, .external_lex_state = 20},
  [2239] = {.lex_state = 135},
  [2240] = {.lex_state = 135},
  [2241] = {.lex_state = 316, .external_lex_state = 20},
  [2242] = {.lex_state = 316, .external_lex_state = 20},
  [2243] = {.lex_state = 135, .external_lex_state = 15},
  [2244] = {.lex_state = 316, .external_lex_state = 20},
  [2245] = {.lex_state = 135, .external_lex_state = 13},
  [2246] = {.lex_state = 316, .external_lex_state = 20},
  [2247] = {.lex_state = 182, .external_lex_state = 4},
  [2248] = {.lex_state = 234, .external_lex_state = 15},
  [2249] = {.lex_state = 316, .external_lex_state = 20},
  [2250] = {.lex_state = 182, .external_lex_state = 4},
  [2251] = {.lex_state = 157, .external_lex_state = 2},
  [2252] = {.lex_state = 157, .external_lex_state = 2},
  [2253] = {.lex_state = 157, .external_lex_state = 2},
  [2254] = {.lex_state = 157, .external_lex_state = 2},
  [2255] = {.lex_state = 157, .external_lex_state = 2},
  [2256] = {.lex_state = 300, .external_lex_state = 27},
  [2257] = {.lex_state = 157, .external_lex_state = 6},
  [2258] = {.lex_state = 164},
  [2259] = {.lex_state = 157, .external_lex_state = 28},
  [2260] = {.lex_state = 157, .external_lex_state = 2},
  [2261] = {.lex_state = 157, .external_lex_state = 2},
  [2262] = {.lex_state = 232, .external_lex_state = 7},
  [2263] = {.lex_state = 347, .external_lex_state = 17},
  [2264] = {.lex_state = 157, .external_lex_state = 2},
  [2265] = {.lex_state = 135, .external_lex_state = 10},
  [2266] = {.lex_state = 228},
  [2267] = {.lex_state = 347, .external_lex_state = 17},
  [2268] = {.lex_state = 157, .external_lex_state = 2},
  [2269] = {.lex_state = 266, .external_lex_state = 6},
  [2270] = {.lex_state = 157, .external_lex_state = 2},
  [2271] = {.lex_state = 347, .external_lex_state = 17},
  [2272] = {.lex_state = 347, .external_lex_state = 17},
  [2273] = {.lex_state = 157, .external_lex_state = 2},
  [2274] = {.lex_state = 347, .external_lex_state = 17},
  [2275] = {.lex_state = 319, .external_lex_state = 20},
  [2276] = {.lex_state = 350, .external_lex_state = 16},
  [2277] = {.lex_state = 319, .external_lex_state = 20},
  [2278] = {.lex_state = 157},
  [2279] = {.lex_state = 347, .external_lex_state = 17},
  [2280] = {.lex_state = 313, .external_lex_state = 16},
  [2281] = {.lex_state = 350, .external_lex_state = 16},
  [2282] = {.lex_state = 350, .external_lex_state = 16},
  [2283] = {.lex_state = 350, .external_lex_state = 19},
  [2284] = {.lex_state = 313, .external_lex_state = 16},
  [2285] = {.lex_state = 157, .external_lex_state = 2},
  [2286] = {.lex_state = 157, .external_lex_state = 2},
  [2287] = {.lex_state = 157, .external_lex_state = 2},
  [2288] = {.lex_state = 157, .external_lex_state = 2},
  [2289] = {.lex_state = 157, .external_lex_state = 2},
  [2290] = {.lex_state = 157, .external_lex_state = 2},
  [2291] = {.lex_state = 157, .external_lex_state = 2},
  [2292] = {.lex_state = 157, .external_lex_state = 2},
  [2293] = {.lex_state = 157, .external_lex_state = 2},
  [2294] = {.lex_state = 157, .external_lex_state = 2},
  [2295] = {.lex_state = 157, .external_lex_state = 2},
  [2296] = {.lex_state = 307, .external_lex_state = 23},
  [2297] = {.lex_state = 197, .external_lex_state = 5},
  [2298] = {.lex_state = 234, .external_lex_state = 15},
  [2299] = {.lex_state = 217, .external_lex_state = 4},
  [2300] = {.lex_state = 234, .external_lex_state = 15},
  [2301] = {.lex_state = 164, .external_lex_state = 3},
  [2302] = {.lex_state = 135, .external_lex_state = 2},
  [2303] = {.lex_state = 135, .external_lex_state = 2},
  [2304] = {.lex_state = 135},
  [2305] = {.lex_state = 237, .external_lex_state = 16},
  [2306] = {.lex_state = 135, .external_lex_state = 15},
  [2307] = {.lex_state = 234, .external_lex_state = 15},
  [2308] = {.lex_state = 217, .external_lex_state = 4},
  [2309] = {.lex_state = 237, .external_lex_state = 16},
  [2310] = {.lex_state = 234, .external_lex_state = 15},
  [2311] = {.lex_state = 237, .external_lex_state = 16},
  [2312] = {.lex_state = 237, .external_lex_state = 16},
  [2313] = {.lex_state = 215},
  [2314] = {.lex_state = 255, .external_lex_state = 16},
  [2315] = {.lex_state = 135, .external_lex_state = 2},
  [2316] = {.lex_state = 322, .external_lex_state = 19},
  [2317] = {.lex_state = 135, .external_lex_state = 13},
  [2318] = {.lex_state = 237, .external_lex_state = 16},
  [2319] = {.lex_state = 135, .external_lex_state = 10},
  [2320] = {.lex_state = 135, .external_lex_state = 2},
  [2321] = {.lex_state = 135},
  [2322] = {.lex_state = 237, .external_lex_state = 16},
  [2323] = {.lex_state = 232, .external_lex_state = 2},
  [2324] = {.lex_state = 215},
  [2325] = {.lex_state = 237, .external_lex_state = 16},
  [2326] = {.lex_state = 255, .external_lex_state = 16},
  [2327] = {.lex_state = 274, .external_lex_state = 20},
  [2328] = {.lex_state = 135, .external_lex_state = 2},
  [2329] = {.lex_state = 164, .external_lex_state = 3},
  [2330] = {.lex_state = 255, .external_lex_state = 16},
  [2331] = {.lex_state = 157, .external_lex_state = 2},
  [2332] = {.lex_state = 255, .external_lex_state = 16},
  [2333] = {.lex_state = 157, .external_lex_state = 2},
  [2334] = {.lex_state = 255, .external_lex_state = 16},
  [2335] = {.lex_state = 237, .external_lex_state = 16},
  [2336] = {.lex_state = 135},
  [2337] = {.lex_state = 255, .external_lex_state = 16},
  [2338] = {.lex_state = 255, .external_lex_state = 16},
  [2339] = {.lex_state = 217, .external_lex_state = 22},
  [2340] = {.lex_state = 157, .external_lex_state = 29},
  [2341] = {.lex_state = 255, .external_lex_state = 16},
  [2342] = {.lex_state = 255, .external_lex_state = 16},
  [2343] = {.lex_state = 157, .external_lex_state = 2},
  [2344] = {.lex_state = 157, .external_lex_state = 28},
  [2345] = {.lex_state = 157, .external_lex_state = 2},
  [2346] = {.lex_state = 157, .external_lex_state = 2},
  [2347] = {.lex_state = 157, .external_lex_state = 2},
  [2348] = {.lex_state = 157, .external_lex_state = 2},
  [2349] = {.lex_state = 157, .external_lex_state = 2},
  [2350] = {.lex_state = 157, .external_lex_state = 2},
  [2351] = {.lex_state = 157, .external_lex_state = 2},
  [2352] = {.lex_state = 157, .external_lex_state = 2},
  [2353] = {.lex_state = 157, .external_lex_state = 2},
  [2354] = {.lex_state = 245, .external_lex_state = 17},
  [2355] = {.lex_state = 228},
  [2356] = {.lex_state = 157, .external_lex_state = 2},
  [2357] = {.lex_state = 157, .external_lex_state = 2},
  [2358] = {.lex_state = 157, .external_lex_state = 2},
  [2359] = {.lex_state = 255, .external_lex_state = 16},
  [2360] = {.lex_state = 255, .external_lex_state = 16},
  [2361] = {.lex_state = 255, .external_lex_state = 19},
  [2362] = {.lex_state = 326, .external_lex_state = 16},
  [2363] = {.lex_state = 255, .external_lex_state = 16},
  [2364] = {.lex_state = 197, .external_lex_state = 5},
  [2365] = {.lex_state = 197, .external_lex_state = 5},
  [2366] = {.lex_state = 135},
  [2367] = {.lex_state = 326, .external_lex_state = 16},
  [2368] = {.lex_state = 182, .external_lex_state = 4},
  [2369] = {.lex_state = 234, .external_lex_state = 15},
  [2370] = {.lex_state = 326, .external_lex_state = 16},
  [2371] = {.lex_state = 135, .external_lex_state = 15},
  [2372] = {.lex_state = 326, .external_lex_state = 16},
  [2373] = {.lex_state = 135},
  [2374] = {.lex_state = 326, .external_lex_state = 16},
  [2375] = {.lex_state = 135, .external_lex_state = 13},
  [2376] = {.lex_state = 157, .external_lex_state = 2},
  [2377] = {.lex_state = 258, .external_lex_state = 25},
  [2378] = {.lex_state = 258, .external_lex_state = 25},
  [2379] = {.lex_state = 258, .external_lex_state = 25},
  [2380] = {.lex_state = 258, .external_lex_state = 25},
  [2381] = {.lex_state = 135},
  [2382] = {.lex_state = 135},
  [2383] = {.lex_state = 135, .external_lex_state = 2},
  [2384] = {.lex_state = 326, .external_lex_state = 16},
  [2385] = {.lex_state = 135},
  [2386] = {.lex_state = 135},
  [2387] = {.lex_state = 255, .external_lex_state = 16},
  [2388] = {.lex_state = 326, .external_lex_state = 16},
  [2389] = {.lex_state = 326, .external_lex_state = 16},
  [2390] = {.lex_state = 135, .external_lex_state = 15},
  [2391] = {.lex_state = 326, .external_lex_state = 16},
  [2392] = {.lex_state = 182, .external_lex_state = 4},
  [2393] = {.lex_state = 234, .external_lex_state = 15},
  [2394] = {.lex_state = 326, .external_lex_state = 16},
  [2395] = {.lex_state = 157},
  [2396] = {.lex_state = 326, .external_lex_state = 16},
  [2397] = {.lex_state = 215, .external_lex_state = 18},
  [2398] = {.lex_state = 215},
  [2399] = {.lex_state = 326, .external_lex_state = 16},
  [2400] = {.lex_state = 197, .external_lex_state = 5},
  [2401] = {.lex_state = 255, .external_lex_state = 16},
  [2402] = {.lex_state = 326, .external_lex_state = 16},
  [2403] = {.lex_state = 135},
  [2404] = {.lex_state = 326, .external_lex_state = 19},
  [2405] = {.lex_state = 135, .external_lex_state = 15},
  [2406] = {.lex_state = 326, .external_lex_state = 16},
  [2407] = {.lex_state = 135, .external_lex_state = 15},
  [2408] = {.lex_state = 135, .external_lex_state = 10},
  [2409] = {.lex_state = 232, .external_lex_state = 2},
  [2410] = {.lex_state = 326, .external_lex_state = 16},
  [2411] = {.lex_state = 135},
  [2412] = {.lex_state = 332, .external_lex_state = 17},
  [2413] = {.lex_state = 157, .external_lex_state = 2},
  [2414] = {.lex_state = 215, .external_lex_state = 13},
  [2415] = {.lex_state = 326, .external_lex_state = 16},
  [2416] = {.lex_state = 157},
  [2417] = {.lex_state = 326, .external_lex_state = 16},
  [2418] = {.lex_state = 135, .external_lex_state = 13},
  [2419] = {.lex_state = 157, .external_lex_state = 2},
  [2420] = {.lex_state = 157, .external_lex_state = 28},
  [2421] = {.lex_state = 157, .external_lex_state = 2},
  [2422] = {.lex_state = 157, .external_lex_state = 2},
  [2423] = {.lex_state = 157, .external_lex_state = 2},
  [2424] = {.lex_state = 157, .external_lex_state = 2},
  [2425] = {.lex_state = 157, .external_lex_state = 2},
  [2426] = {.lex_state = 157, .external_lex_state = 2},
  [2427] = {.lex_state = 157, .external_lex_state = 2},
  [2428] = {.lex_state = 157, .external_lex_state = 2},
  [2429] = {.lex_state = 157, .external_lex_state = 2},
  [2430] = {.lex_state = 157, .external_lex_state = 2},
  [2431] = {.lex_state = 300, .external_lex_state = 27},
  [2432] = {.lex_state = 157, .external_lex_state = 6},
  [2433] = {.lex_state = 164},
  [2434] = {.lex_state = 232, .external_lex_state = 7},
  [2435] = {.lex_state = 245, .external_lex_state = 17},
  [2436] = {.lex_state = 135, .external_lex_state = 10},
  [2437] = {.lex_state = 228},
  [2438] = {.lex_state = 157, .external_lex_state = 2},
  [2439] = {.lex_state = 157, .external_lex_state = 2},
  [2440] = {.lex_state = 157, .external_lex_state = 2},
  [2441] = {.lex_state = 323, .external_lex_state = 16},
  [2442] = {.lex_state = 323, .external_lex_state = 16},
  [2443] = {.lex_state = 329, .external_lex_state = 16},
  [2444] = {.lex_state = 252, .external_lex_state = 16},
  [2445] = {.lex_state = 252, .external_lex_state = 19},
  [2446] = {.lex_state = 329, .external_lex_state = 16},
  [2447] = {.lex_state = 255, .external_lex_state = 19},
  [2448] = {.lex_state = 237, .external_lex_state = 16},
  [2449] = {.lex_state = 135},
  [2450] = {.lex_state = 237, .external_lex_state = 16},
  [2451] = {.lex_state = 135},
  [2452] = {.lex_state = 135},
  [2453] = {.lex_state = 135},
  [2454] = {.lex_state = 237, .external_lex_state = 16},
  [2455] = {.lex_state = 197, .external_lex_state = 5},
  [2456] = {.lex_state = 135, .external_lex_state = 2},
  [2457] = {.lex_state = 135, .external_lex_state = 13},
  [2458] = {.lex_state = 237, .external_lex_state = 16},
  [2459] = {.lex_state = 237, .external_lex_state = 16},
  [2460] = {.lex_state = 135, .external_lex_state = 2},
  [2461] = {.lex_state = 237, .external_lex_state = 16},
  [2462] = {.lex_state = 135},
  [2463] = {.lex_state = 135},
  [2464] = {.lex_state = 237, .external_lex_state = 16},
  [2465] = {.lex_state = 135},
  [2466] = {.lex_state = 237, .external_lex_state = 16},
  [2467] = {.lex_state = 135, .external_lex_state = 2},
  [2468] = {.lex_state = 135},
  [2469] = {.lex_state = 237, .external_lex_state = 16},
  [2470] = {.lex_state = 135, .external_lex_state = 15},
  [2471] = {.lex_state = 234, .external_lex_state = 15},
  [2472] = {.lex_state = 217, .external_lex_state = 4},
  [2473] = {.lex_state = 237, .external_lex_state = 16},
  [2474] = {.lex_state = 234, .external_lex_state = 15},
  [2475] = {.lex_state = 217, .external_lex_state = 22},
  [2476] = {.lex_state = 335, .external_lex_state = 18},
  [2477] = {.lex_state = 157, .external_lex_state = 6},
  [2478] = {.lex_state = 157, .external_lex_state = 29},
  [2479] = {.lex_state = 335},
  [2480] = {.lex_state = 157, .external_lex_state = 18},
  [2481] = {.lex_state = 255, .external_lex_state = 16},
  [2482] = {.lex_state = 157, .external_lex_state = 2},
  [2483] = {.lex_state = 237, .external_lex_state = 16},
  [2484] = {.lex_state = 255, .external_lex_state = 16},
  [2485] = {.lex_state = 255, .external_lex_state = 16},
  [2486] = {.lex_state = 255, .external_lex_state = 16},
  [2487] = {.lex_state = 255, .external_lex_state = 16},
  [2488] = {.lex_state = 359, .external_lex_state = 20},
  [2489] = {.lex_state = 255, .external_lex_state = 16},
  [2490] = {.lex_state = 255, .external_lex_state = 16},
  [2491] = {.lex_state = 255, .external_lex_state = 16},
  [2492] = {.lex_state = 255, .external_lex_state = 16},
  [2493] = {.lex_state = 255, .external_lex_state = 16},
  [2494] = {.lex_state = 255, .external_lex_state = 16},
  [2495] = {.lex_state = 255, .external_lex_state = 16},
  [2496] = {.lex_state = 245, .external_lex_state = 17},
  [2497] = {.lex_state = 266, .external_lex_state = 6},
  [2498] = {.lex_state = 245, .external_lex_state = 17},
  [2499] = {.lex_state = 245, .external_lex_state = 17},
  [2500] = {.lex_state = 300, .external_lex_state = 27},
  [2501] = {.lex_state = 242, .external_lex_state = 16},
  [2502] = {.lex_state = 157},
  [2503] = {.lex_state = 245, .external_lex_state = 17},
  [2504] = {.lex_state = 197, .external_lex_state = 5},
  [2505] = {.lex_state = 135, .external_lex_state = 13},
  [2506] = {.lex_state = 215, .external_lex_state = 7},
  [2507] = {.lex_state = 252, .external_lex_state = 16},
  [2508] = {.lex_state = 252, .external_lex_state = 19},
  [2509] = {.lex_state = 242, .external_lex_state = 16},
  [2510] = {.lex_state = 242, .external_lex_state = 16},
  [2511] = {.lex_state = 182, .external_lex_state = 4},
  [2512] = {.lex_state = 234, .external_lex_state = 15},
  [2513] = {.lex_state = 242, .external_lex_state = 16},
  [2514] = {.lex_state = 157},
  [2515] = {.lex_state = 242, .external_lex_state = 16},
  [2516] = {.lex_state = 232, .external_lex_state = 2},
  [2517] = {.lex_state = 215, .external_lex_state = 18},
  [2518] = {.lex_state = 215},
  [2519] = {.lex_state = 215},
  [2520] = {.lex_state = 157, .external_lex_state = 2},
  [2521] = {.lex_state = 197, .external_lex_state = 5},
  [2522] = {.lex_state = 252, .external_lex_state = 16},
  [2523] = {.lex_state = 371, .external_lex_state = 19},
  [2524] = {.lex_state = 135, .external_lex_state = 15},
  [2525] = {.lex_state = 135},
  [2526] = {.lex_state = 242, .external_lex_state = 16},
  [2527] = {.lex_state = 135, .external_lex_state = 10},
  [2528] = {.lex_state = 135, .external_lex_state = 2},
  [2529] = {.lex_state = 135},
  [2530] = {.lex_state = 232, .external_lex_state = 2},
  [2531] = {.lex_state = 242, .external_lex_state = 16},
  [2532] = {.lex_state = 135},
  [2533] = {.lex_state = 157, .external_lex_state = 2},
  [2534] = {.lex_state = 157, .external_lex_state = 2},
  [2535] = {.lex_state = 215, .external_lex_state = 13},
  [2536] = {.lex_state = 242, .external_lex_state = 16},
  [2537] = {.lex_state = 157},
  [2538] = {.lex_state = 242, .external_lex_state = 16},
  [2539] = {.lex_state = 252, .external_lex_state = 16},
  [2540] = {.lex_state = 242, .external_lex_state = 16},
  [2541] = {.lex_state = 135, .external_lex_state = 15},
  [2542] = {.lex_state = 197, .external_lex_state = 5},
  [2543] = {.lex_state = 135},
  [2544] = {.lex_state = 242, .external_lex_state = 16},
  [2545] = {.lex_state = 135},
  [2546] = {.lex_state = 242, .external_lex_state = 16},
  [2547] = {.lex_state = 135},
  [2548] = {.lex_state = 252, .external_lex_state = 16},
  [2549] = {.lex_state = 242, .external_lex_state = 16},
  [2550] = {.lex_state = 157, .external_lex_state = 2},
  [2551] = {.lex_state = 258, .external_lex_state = 25},
  [2552] = {.lex_state = 258, .external_lex_state = 25},
  [2553] = {.lex_state = 242, .external_lex_state = 16},
  [2554] = {.lex_state = 135, .external_lex_state = 15},
  [2555] = {.lex_state = 258, .external_lex_state = 25},
  [2556] = {.lex_state = 258, .external_lex_state = 25},
  [2557] = {.lex_state = 135},
  [2558] = {.lex_state = 135},
  [2559] = {.lex_state = 135, .external_lex_state = 2},
  [2560] = {.lex_state = 242, .external_lex_state = 16},
  [2561] = {.lex_state = 135},
  [2562] = {.lex_state = 135},
  [2563] = {.lex_state = 242, .external_lex_state = 16},
  [2564] = {.lex_state = 242, .external_lex_state = 16},
  [2565] = {.lex_state = 135, .external_lex_state = 15},
  [2566] = {.lex_state = 242, .external_lex_state = 16},
  [2567] = {.lex_state = 252, .external_lex_state = 16},
  [2568] = {.lex_state = 135, .external_lex_state = 13},
  [2569] = {.lex_state = 242, .external_lex_state = 16},
  [2570] = {.lex_state = 182, .external_lex_state = 4},
  [2571] = {.lex_state = 234, .external_lex_state = 15},
  [2572] = {.lex_state = 242, .external_lex_state = 16},
  [2573] = {.lex_state = 242, .external_lex_state = 16},
  [2574] = {.lex_state = 157, .external_lex_state = 28},
  [2575] = {.lex_state = 232, .external_lex_state = 7},
  [2576] = {.lex_state = 242, .external_lex_state = 16},
  [2577] = {.lex_state = 217, .external_lex_state = 22},
  [2578] = {.lex_state = 157, .external_lex_state = 29},
  [2579] = {.lex_state = 252, .external_lex_state = 16},
  [2580] = {.lex_state = 252, .external_lex_state = 16},
  [2581] = {.lex_state = 157, .external_lex_state = 2},
  [2582] = {.lex_state = 157, .external_lex_state = 2},
  [2583] = {.lex_state = 157, .external_lex_state = 2},
  [2584] = {.lex_state = 157, .external_lex_state = 2},
  [2585] = {.lex_state = 157, .external_lex_state = 2},
  [2586] = {.lex_state = 157, .external_lex_state = 2},
  [2587] = {.lex_state = 157, .external_lex_state = 2},
  [2588] = {.lex_state = 157, .external_lex_state = 2},
  [2589] = {.lex_state = 157, .external_lex_state = 2},
  [2590] = {.lex_state = 157, .external_lex_state = 2},
  [2591] = {.lex_state = 252, .external_lex_state = 19},
  [2592] = {.lex_state = 255, .external_lex_state = 19},
  [2593] = {.lex_state = 135, .external_lex_state = 2},
  [2594] = {.lex_state = 135, .external_lex_state = 2},
  [2595] = {.lex_state = 135},
  [2596] = {.lex_state = 197, .external_lex_state = 20},
  [2597] = {.lex_state = 135, .external_lex_state = 15},
  [2598] = {.lex_state = 234, .external_lex_state = 15},
  [2599] = {.lex_state = 217, .external_lex_state = 4},
  [2600] = {.lex_state = 197, .external_lex_state = 20},
  [2601] = {.lex_state = 234, .external_lex_state = 15},
  [2602] = {.lex_state = 197, .external_lex_state = 20},
  [2603] = {.lex_state = 197, .external_lex_state = 20},
  [2604] = {.lex_state = 215},
  [2605] = {.lex_state = 307, .external_lex_state = 16},
  [2606] = {.lex_state = 135, .external_lex_state = 2},
  [2607] = {.lex_state = 215},
  [2608] = {.lex_state = 338},
  [2609] = {.lex_state = 217, .external_lex_state = 22},
  [2610] = {.lex_state = 197, .external_lex_state = 23},
  [2611] = {.lex_state = 135, .external_lex_state = 13},
  [2612] = {.lex_state = 197, .external_lex_state = 20},
  [2613] = {.lex_state = 135, .external_lex_state = 10},
  [2614] = {.lex_state = 135, .external_lex_state = 2},
  [2615] = {.lex_state = 135},
  [2616] = {.lex_state = 197, .external_lex_state = 20},
  [2617] = {.lex_state = 232, .external_lex_state = 2},
  [2618] = {.lex_state = 215},
  [2619] = {.lex_state = 197, .external_lex_state = 20},
  [2620] = {.lex_state = 307, .external_lex_state = 16},
  [2621] = {.lex_state = 274, .external_lex_state = 20},
  [2622] = {.lex_state = 135, .external_lex_state = 2},
  [2623] = {.lex_state = 164, .external_lex_state = 3},
  [2624] = {.lex_state = 197, .external_lex_state = 16},
  [2625] = {.lex_state = 197, .external_lex_state = 19},
  [2626] = {.lex_state = 157, .external_lex_state = 2},
  [2627] = {.lex_state = 197, .external_lex_state = 16},
  [2628] = {.lex_state = 245, .external_lex_state = 17},
  [2629] = {.lex_state = 157, .external_lex_state = 2},
  [2630] = {.lex_state = 197, .external_lex_state = 16},
  [2631] = {.lex_state = 197, .external_lex_state = 16},
  [2632] = {.lex_state = 197, .external_lex_state = 16},
  [2633] = {.lex_state = 197, .external_lex_state = 16},
  [2634] = {.lex_state = 197, .external_lex_state = 16},
  [2635] = {.lex_state = 157, .external_lex_state = 29},
  [2636] = {.lex_state = 197, .external_lex_state = 16},
  [2637] = {.lex_state = 197, .external_lex_state = 16},
  [2638] = {.lex_state = 157, .external_lex_state = 2},
  [2639] = {.lex_state = 157, .external_lex_state = 28},
  [2640] = {.lex_state = 157, .external_lex_state = 2},
  [2641] = {.lex_state = 157, .external_lex_state = 2},
  [2642] = {.lex_state = 157, .external_lex_state = 2},
  [2643] = {.lex_state = 157, .external_lex_state = 2},
  [2644] = {.lex_state = 157, .external_lex_state = 2},
  [2645] = {.lex_state = 157, .external_lex_state = 2},
  [2646] = {.lex_state = 157, .external_lex_state = 2},
  [2647] = {.lex_state = 157, .external_lex_state = 2},
  [2648] = {.lex_state = 157, .external_lex_state = 2},
  [2649] = {.lex_state = 157, .external_lex_state = 2},
  [2650] = {.lex_state = 300, .external_lex_state = 27},
  [2651] = {.lex_state = 164},
  [2652] = {.lex_state = 197, .external_lex_state = 19},
  [2653] = {.lex_state = 197, .external_lex_state = 20},
  [2654] = {.lex_state = 135},
  [2655] = {.lex_state = 197, .external_lex_state = 20},
  [2656] = {.lex_state = 135},
  [2657] = {.lex_state = 135},
  [2658] = {.lex_state = 135},
  [2659] = {.lex_state = 197, .external_lex_state = 20},
  [2660] = {.lex_state = 197, .external_lex_state = 5},
  [2661] = {.lex_state = 135, .external_lex_state = 2},
  [2662] = {.lex_state = 135, .external_lex_state = 13},
  [2663] = {.lex_state = 197, .external_lex_state = 20},
  [2664] = {.lex_state = 197, .external_lex_state = 20},
  [2665] = {.lex_state = 135, .external_lex_state = 2},
  [2666] = {.lex_state = 197, .external_lex_state = 20},
  [2667] = {.lex_state = 135},
  [2668] = {.lex_state = 135},
  [2669] = {.lex_state = 197, .external_lex_state = 20},
  [2670] = {.lex_state = 135},
  [2671] = {.lex_state = 197, .external_lex_state = 20},
  [2672] = {.lex_state = 157, .external_lex_state = 2},
  [2673] = {.lex_state = 157, .external_lex_state = 2},
  [2674] = {.lex_state = 347, .external_lex_state = 17},
  [2675] = {.lex_state = 157, .external_lex_state = 2},
  [2676] = {.lex_state = 164},
  [2677] = {.lex_state = 228},
  [2678] = {.lex_state = 304, .external_lex_state = 17},
  [2679] = {.lex_state = 157, .external_lex_state = 2},
  [2680] = {.lex_state = 157, .external_lex_state = 2},
  [2681] = {.lex_state = 304, .external_lex_state = 17},
  [2682] = {.lex_state = 304, .external_lex_state = 17},
  [2683] = {.lex_state = 157, .external_lex_state = 2},
  [2684] = {.lex_state = 304, .external_lex_state = 17},
  [2685] = {.lex_state = 307, .external_lex_state = 16},
  [2686] = {.lex_state = 350, .external_lex_state = 16},
  [2687] = {.lex_state = 307, .external_lex_state = 16},
  [2688] = {.lex_state = 307, .external_lex_state = 16},
  [2689] = {.lex_state = 347, .external_lex_state = 17},
  [2690] = {.lex_state = 157},
  [2691] = {.lex_state = 307, .external_lex_state = 19},
  [2692] = {.lex_state = 307, .external_lex_state = 16},
  [2693] = {.lex_state = 307, .external_lex_state = 16},
  [2694] = {.lex_state = 307, .external_lex_state = 16},
  [2695] = {.lex_state = 310, .external_lex_state = 17},
  [2696] = {.lex_state = 157, .external_lex_state = 2},
  [2697] = {.lex_state = 157, .external_lex_state = 28},
  [2698] = {.lex_state = 157, .external_lex_state = 2},
  [2699] = {.lex_state = 157, .external_lex_state = 2},
  [2700] = {.lex_state = 157, .external_lex_state = 2},
  [2701] = {.lex_state = 157, .external_lex_state = 2},
  [2702] = {.lex_state = 157, .external_lex_state = 2},
  [2703] = {.lex_state = 157, .external_lex_state = 2},
  [2704] = {.lex_state = 157, .external_lex_state = 2},
  [2705] = {.lex_state = 157, .external_lex_state = 2},
  [2706] = {.lex_state = 157, .external_lex_state = 2},
  [2707] = {.lex_state = 157, .external_lex_state = 2},
  [2708] = {.lex_state = 300, .external_lex_state = 27},
  [2709] = {.lex_state = 164},
  [2710] = {.lex_state = 157, .external_lex_state = 2},
  [2711] = {.lex_state = 157, .external_lex_state = 2},
  [2712] = {.lex_state = 347, .external_lex_state = 17},
  [2713] = {.lex_state = 157, .external_lex_state = 2},
  [2714] = {.lex_state = 228},
  [2715] = {.lex_state = 347, .external_lex_state = 17},
  [2716] = {.lex_state = 157, .external_lex_state = 2},
  [2717] = {.lex_state = 157, .external_lex_state = 2},
  [2718] = {.lex_state = 347, .external_lex_state = 17},
  [2719] = {.lex_state = 347, .external_lex_state = 17},
  [2720] = {.lex_state = 157, .external_lex_state = 2},
  [2721] = {.lex_state = 347, .external_lex_state = 17},
  [2722] = {.lex_state = 350, .external_lex_state = 16},
  [2723] = {.lex_state = 157},
  [2724] = {.lex_state = 347, .external_lex_state = 17},
  [2725] = {.lex_state = 313, .external_lex_state = 16},
  [2726] = {.lex_state = 350, .external_lex_state = 16},
  [2727] = {.lex_state = 350, .external_lex_state = 16},
  [2728] = {.lex_state = 350, .external_lex_state = 19},
  [2729] = {.lex_state = 313, .external_lex_state = 16},
  [2730] = {.lex_state = 307, .external_lex_state = 19},
  [2731] = {.lex_state = 135, .external_lex_state = 2},
  [2732] = {.lex_state = 135},
  [2733] = {.lex_state = 197, .external_lex_state = 20},
  [2734] = {.lex_state = 135, .external_lex_state = 15},
  [2735] = {.lex_state = 234, .external_lex_state = 15},
  [2736] = {.lex_state = 217, .external_lex_state = 4},
  [2737] = {.lex_state = 197, .external_lex_state = 20},
  [2738] = {.lex_state = 234, .external_lex_state = 15},
  [2739] = {.lex_state = 197, .external_lex_state = 20},
  [2740] = {.lex_state = 220, .external_lex_state = 21},
  [2741] = {.lex_state = 157, .external_lex_state = 2},
  [2742] = {.lex_state = 220, .external_lex_state = 21},
  [2743] = {.lex_state = 157, .external_lex_state = 2},
  [2744] = {.lex_state = 157, .external_lex_state = 2},
  [2745] = {.lex_state = 220, .external_lex_state = 21},
  [2746] = {.lex_state = 157, .external_lex_state = 2},
  [2747] = {.lex_state = 220, .external_lex_state = 21},
  [2748] = {.lex_state = 197, .external_lex_state = 20},
  [2749] = {.lex_state = 242, .external_lex_state = 20},
  [2750] = {.lex_state = 197, .external_lex_state = 20},
  [2751] = {.lex_state = 157},
  [2752] = {.lex_state = 197, .external_lex_state = 23},
  [2753] = {.lex_state = 197, .external_lex_state = 20},
  [2754] = {.lex_state = 197, .external_lex_state = 20},
  [2755] = {.lex_state = 197, .external_lex_state = 20},
  [2756] = {.lex_state = 359, .external_lex_state = 20},
  [2757] = {.lex_state = 197, .external_lex_state = 20},
  [2758] = {.lex_state = 197, .external_lex_state = 20},
  [2759] = {.lex_state = 197, .external_lex_state = 20},
  [2760] = {.lex_state = 197, .external_lex_state = 20},
  [2761] = {.lex_state = 197, .external_lex_state = 20},
  [2762] = {.lex_state = 197, .external_lex_state = 20},
  [2763] = {.lex_state = 197, .external_lex_state = 20},
  [2764] = {.lex_state = 245, .external_lex_state = 21},
  [2765] = {.lex_state = 266, .external_lex_state = 6},
  [2766] = {.lex_state = 245, .external_lex_state = 21},
  [2767] = {.lex_state = 245, .external_lex_state = 21},
  [2768] = {.lex_state = 300, .external_lex_state = 27},
  [2769] = {.lex_state = 242, .external_lex_state = 20},
  [2770] = {.lex_state = 157},
  [2771] = {.lex_state = 245, .external_lex_state = 21},
  [2772] = {.lex_state = 217, .external_lex_state = 22},
  [2773] = {.lex_state = 215, .external_lex_state = 18},
  [2774] = {.lex_state = 215, .external_lex_state = 7},
  [2775] = {.lex_state = 197, .external_lex_state = 5},
  [2776] = {.lex_state = 242, .external_lex_state = 16},
  [2777] = {.lex_state = 242, .external_lex_state = 19},
  [2778] = {.lex_state = 242, .external_lex_state = 16},
  [2779] = {.lex_state = 232, .external_lex_state = 2},
  [2780] = {.lex_state = 215},
  [2781] = {.lex_state = 157, .external_lex_state = 2},
  [2782] = {.lex_state = 242, .external_lex_state = 16},
  [2783] = {.lex_state = 242, .external_lex_state = 20},
  [2784] = {.lex_state = 135, .external_lex_state = 10},
  [2785] = {.lex_state = 135, .external_lex_state = 2},
  [2786] = {.lex_state = 135},
  [2787] = {.lex_state = 157, .external_lex_state = 2},
  [2788] = {.lex_state = 242, .external_lex_state = 16},
  [2789] = {.lex_state = 242, .external_lex_state = 16},
  [2790] = {.lex_state = 242, .external_lex_state = 16},
  [2791] = {.lex_state = 232, .external_lex_state = 2},
  [2792] = {.lex_state = 242, .external_lex_state = 20},
  [2793] = {.lex_state = 157, .external_lex_state = 28},
  [2794] = {.lex_state = 157, .external_lex_state = 29},
  [2795] = {.lex_state = 242, .external_lex_state = 16},
  [2796] = {.lex_state = 242, .external_lex_state = 16},
  [2797] = {.lex_state = 157, .external_lex_state = 2},
  [2798] = {.lex_state = 157, .external_lex_state = 2},
  [2799] = {.lex_state = 157, .external_lex_state = 2},
  [2800] = {.lex_state = 157, .external_lex_state = 2},
  [2801] = {.lex_state = 157, .external_lex_state = 2},
  [2802] = {.lex_state = 157, .external_lex_state = 2},
  [2803] = {.lex_state = 157, .external_lex_state = 2},
  [2804] = {.lex_state = 157, .external_lex_state = 2},
  [2805] = {.lex_state = 157, .external_lex_state = 2},
  [2806] = {.lex_state = 157, .external_lex_state = 2},
  [2807] = {.lex_state = 242, .external_lex_state = 19},
  [2808] = {.lex_state = 197, .external_lex_state = 23},
  [2809] = {.lex_state = 197, .external_lex_state = 13},
  [2810] = {.lex_state = 197, .external_lex_state = 5},
  [2811] = {.lex_state = 135},
  [2812] = {.lex_state = 217, .external_lex_state = 4},
  [2813] = {.lex_state = 157, .external_lex_state = 2},
  [2814] = {.lex_state = 157, .external_lex_state = 2},
  [2815] = {.lex_state = 220, .external_lex_state = 17},
  [2816] = {.lex_state = 220, .external_lex_state = 17},
  [2817] = {.lex_state = 157, .external_lex_state = 2},
  [2818] = {.lex_state = 157, .external_lex_state = 2},
  [2819] = {.lex_state = 220, .external_lex_state = 17},
  [2820] = {.lex_state = 157, .external_lex_state = 2},
  [2821] = {.lex_state = 164},
  [2822] = {.lex_state = 220, .external_lex_state = 17},
  [2823] = {.lex_state = 208, .external_lex_state = 16},
  [2824] = {.lex_state = 197, .external_lex_state = 16},
  [2825] = {.lex_state = 316, .external_lex_state = 16},
  [2826] = {.lex_state = 223, .external_lex_state = 17},
  [2827] = {.lex_state = 157},
  [2828] = {.lex_state = 197, .external_lex_state = 19},
  [2829] = {.lex_state = 258, .external_lex_state = 18},
  [2830] = {.lex_state = 135},
  [2831] = {.lex_state = 197, .external_lex_state = 16},
  [2832] = {.lex_state = 197, .external_lex_state = 16},
  [2833] = {.lex_state = 217, .external_lex_state = 22},
  [2834] = {.lex_state = 157, .external_lex_state = 29},
  [2835] = {.lex_state = 258, .external_lex_state = 18},
  [2836] = {.lex_state = 258, .external_lex_state = 18},
  [2837] = {.lex_state = 258},
  [2838] = {.lex_state = 135, .external_lex_state = 15},
  [2839] = {.lex_state = 234, .external_lex_state = 15},
  [2840] = {.lex_state = 217, .external_lex_state = 4},
  [2841] = {.lex_state = 258},
  [2842] = {.lex_state = 234, .external_lex_state = 15},
  [2843] = {.lex_state = 135, .external_lex_state = 2},
  [2844] = {.lex_state = 135},
  [2845] = {.lex_state = 258},
  [2846] = {.lex_state = 135},
  [2847] = {.lex_state = 135},
  [2848] = {.lex_state = 135},
  [2849] = {.lex_state = 263},
  [2850] = {.lex_state = 258},
  [2851] = {.lex_state = 135, .external_lex_state = 2},
  [2852] = {.lex_state = 135},
  [2853] = {.lex_state = 197, .external_lex_state = 5},
  [2854] = {.lex_state = 135, .external_lex_state = 2},
  [2855] = {.lex_state = 135, .external_lex_state = 13},
  [2856] = {.lex_state = 258},
  [2857] = {.lex_state = 135, .external_lex_state = 2},
  [2858] = {.lex_state = 258},
  [2859] = {.lex_state = 135},
  [2860] = {.lex_state = 135},
  [2861] = {.lex_state = 258},
  [2862] = {.lex_state = 135},
  [2863] = {.lex_state = 258},
  [2864] = {.lex_state = 258},
  [2865] = {.lex_state = 135, .external_lex_state = 15},
  [2866] = {.lex_state = 234, .external_lex_state = 15},
  [2867] = {.lex_state = 217, .external_lex_state = 4},
  [2868] = {.lex_state = 258},
  [2869] = {.lex_state = 234, .external_lex_state = 15},
  [2870] = {.lex_state = 258},
  [2871] = {.lex_state = 258},
  [2872] = {.lex_state = 215},
  [2873] = {.lex_state = 135, .external_lex_state = 2},
  [2874] = {.lex_state = 258, .external_lex_state = 24},
  [2875] = {.lex_state = 135, .external_lex_state = 13},
  [2876] = {.lex_state = 258},
  [2877] = {.lex_state = 258},
  [2878] = {.lex_state = 135, .external_lex_state = 10},
  [2879] = {.lex_state = 135, .external_lex_state = 2},
  [2880] = {.lex_state = 135},
  [2881] = {.lex_state = 258},
  [2882] = {.lex_state = 232, .external_lex_state = 2},
  [2883] = {.lex_state = 215},
  [2884] = {.lex_state = 258},
  [2885] = {.lex_state = 274, .external_lex_state = 20},
  [2886] = {.lex_state = 135, .external_lex_state = 2},
  [2887] = {.lex_state = 164, .external_lex_state = 3},
  [2888] = {.lex_state = 135, .external_lex_state = 2},
  [2889] = {.lex_state = 135},
  [2890] = {.lex_state = 157, .external_lex_state = 8},
  [2891] = {.lex_state = 157},
  [2892] = {.lex_state = 258, .external_lex_state = 6},
  [2893] = {.lex_state = 266, .external_lex_state = 6},
  [2894] = {.lex_state = 258, .external_lex_state = 6},
  [2895] = {.lex_state = 258, .external_lex_state = 6},
  [2896] = {.lex_state = 300, .external_lex_state = 27},
  [2897] = {.lex_state = 258},
  [2898] = {.lex_state = 157},
  [2899] = {.lex_state = 258, .external_lex_state = 6},
  [2900] = {.lex_state = 197, .external_lex_state = 16},
  [2901] = {.lex_state = 197, .external_lex_state = 19},
  [2902] = {.lex_state = 274, .external_lex_state = 16},
  [2903] = {.lex_state = 157, .external_lex_state = 2},
  [2904] = {.lex_state = 197, .external_lex_state = 16},
  [2905] = {.lex_state = 245, .external_lex_state = 17},
  [2906] = {.lex_state = 157, .external_lex_state = 2},
  [2907] = {.lex_state = 245, .external_lex_state = 17},
  [2908] = {.lex_state = 228},
  [2909] = {.lex_state = 157, .external_lex_state = 2},
  [2910] = {.lex_state = 157, .external_lex_state = 2},
  [2911] = {.lex_state = 157, .external_lex_state = 2},
  [2912] = {.lex_state = 197, .external_lex_state = 16},
  [2913] = {.lex_state = 197, .external_lex_state = 16},
  [2914] = {.lex_state = 197, .external_lex_state = 19},
  [2915] = {.lex_state = 197, .external_lex_state = 16},
  [2916] = {.lex_state = 220, .external_lex_state = 17},
  [2917] = {.lex_state = 220, .external_lex_state = 17},
  [2918] = {.lex_state = 157, .external_lex_state = 2},
  [2919] = {.lex_state = 157, .external_lex_state = 2},
  [2920] = {.lex_state = 220, .external_lex_state = 17},
  [2921] = {.lex_state = 157, .external_lex_state = 2},
  [2922] = {.lex_state = 164},
  [2923] = {.lex_state = 220, .external_lex_state = 17},
  [2924] = {.lex_state = 208, .external_lex_state = 16},
  [2925] = {.lex_state = 197, .external_lex_state = 16},
  [2926] = {.lex_state = 197, .external_lex_state = 16},
  [2927] = {.lex_state = 223, .external_lex_state = 17},
  [2928] = {.lex_state = 157},
  [2929] = {.lex_state = 197, .external_lex_state = 19},
  [2930] = {.lex_state = 197, .external_lex_state = 16},
  [2931] = {.lex_state = 197, .external_lex_state = 16},
  [2932] = {.lex_state = 300, .external_lex_state = 27},
  [2933] = {.lex_state = 164},
  [2934] = {.lex_state = 258},
  [2935] = {.lex_state = 157, .external_lex_state = 28},
  [2936] = {.lex_state = 157, .external_lex_state = 2},
  [2937] = {.lex_state = 157, .external_lex_state = 2},
  [2938] = {.lex_state = 245, .external_lex_state = 17},
  [2939] = {.lex_state = 157, .external_lex_state = 2},
  [2940] = {.lex_state = 228},
  [2941] = {.lex_state = 245, .external_lex_state = 17},
  [2942] = {.lex_state = 157, .external_lex_state = 2},
  [2943] = {.lex_state = 157, .external_lex_state = 2},
  [2944] = {.lex_state = 245, .external_lex_state = 17},
  [2945] = {.lex_state = 245, .external_lex_state = 17},
  [2946] = {.lex_state = 157, .external_lex_state = 2},
  [2947] = {.lex_state = 245, .external_lex_state = 17},
  [2948] = {.lex_state = 242, .external_lex_state = 16},
  [2949] = {.lex_state = 157},
  [2950] = {.lex_state = 242, .external_lex_state = 16},
  [2951] = {.lex_state = 242, .external_lex_state = 16},
  [2952] = {.lex_state = 242, .external_lex_state = 16},
  [2953] = {.lex_state = 252, .external_lex_state = 19},
  [2954] = {.lex_state = 242, .external_lex_state = 16},
  [2955] = {.lex_state = 157, .external_lex_state = 29},
  [2956] = {.lex_state = 258, .external_lex_state = 18},
  [2957] = {.lex_state = 258, .external_lex_state = 18},
  [2958] = {.lex_state = 157, .external_lex_state = 2},
  [2959] = {.lex_state = 157, .external_lex_state = 2},
  [2960] = {.lex_state = 157, .external_lex_state = 2},
  [2961] = {.lex_state = 157, .external_lex_state = 2},
  [2962] = {.lex_state = 157, .external_lex_state = 2},
  [2963] = {.lex_state = 157, .external_lex_state = 2},
  [2964] = {.lex_state = 157, .external_lex_state = 2},
  [2965] = {.lex_state = 157, .external_lex_state = 2},
  [2966] = {.lex_state = 157, .external_lex_state = 2},
  [2967] = {.lex_state = 157, .external_lex_state = 2},
  [2968] = {.lex_state = 157, .external_lex_state = 2},
  [2969] = {.lex_state = 197, .external_lex_state = 19},
  [2970] = {.lex_state = 258, .external_lex_state = 24},
  [2971] = {.lex_state = 197, .external_lex_state = 5},
  [2972] = {.lex_state = 135, .external_lex_state = 2},
  [2973] = {.lex_state = 197, .external_lex_state = 13},
  [2974] = {.lex_state = 197, .external_lex_state = 5},
  [2975] = {.lex_state = 135, .external_lex_state = 2},
  [2976] = {.lex_state = 217, .external_lex_state = 22},
  [2977] = {.lex_state = 197, .external_lex_state = 5},
  [2978] = {.lex_state = 223, .external_lex_state = 9},
  [2979] = {.lex_state = 135, .external_lex_state = 10},
  [2980] = {.lex_state = 228},
  [2981] = {.lex_state = 135},
  [2982] = {.lex_state = 135},
  [2983] = {.lex_state = 197},
  [2984] = {.lex_state = 157, .external_lex_state = 2},
  [2985] = {.lex_state = 157, .external_lex_state = 2},
  [2986] = {.lex_state = 271, .external_lex_state = 9},
  [2987] = {.lex_state = 157, .external_lex_state = 2},
  [2988] = {.lex_state = 164},
  [2989] = {.lex_state = 228},
  [2990] = {.lex_state = 220, .external_lex_state = 9},
  [2991] = {.lex_state = 157, .external_lex_state = 2},
  [2992] = {.lex_state = 157, .external_lex_state = 2},
  [2993] = {.lex_state = 220, .external_lex_state = 9},
  [2994] = {.lex_state = 220, .external_lex_state = 9},
  [2995] = {.lex_state = 157, .external_lex_state = 2},
  [2996] = {.lex_state = 220, .external_lex_state = 9},
  [2997] = {.lex_state = 197, .external_lex_state = 5},
  [2998] = {.lex_state = 268, .external_lex_state = 5},
  [2999] = {.lex_state = 197, .external_lex_state = 5},
  [3000] = {.lex_state = 197, .external_lex_state = 5},
  [3001] = {.lex_state = 271, .external_lex_state = 9},
  [3002] = {.lex_state = 157},
  [3003] = {.lex_state = 197, .external_lex_state = 14},
  [3004] = {.lex_state = 197, .external_lex_state = 5},
  [3005] = {.lex_state = 157, .external_lex_state = 2},
  [3006] = {.lex_state = 157, .external_lex_state = 2},
  [3007] = {.lex_state = 157, .external_lex_state = 2},
  [3008] = {.lex_state = 157, .external_lex_state = 2},
  [3009] = {.lex_state = 157, .external_lex_state = 2},
  [3010] = {.lex_state = 135, .external_lex_state = 2},
  [3011] = {.lex_state = 197, .external_lex_state = 5},
  [3012] = {.lex_state = 135, .external_lex_state = 2},
  [3013] = {.lex_state = 135},
  [3014] = {.lex_state = 300, .external_lex_state = 27},
  [3015] = {.lex_state = 164},
  [3016] = {.lex_state = 157, .external_lex_state = 28},
  [3017] = {.lex_state = 135, .external_lex_state = 10},
  [3018] = {.lex_state = 157, .external_lex_state = 2},
  [3019] = {.lex_state = 157, .external_lex_state = 2},
  [3020] = {.lex_state = 271, .external_lex_state = 9},
  [3021] = {.lex_state = 157, .external_lex_state = 2},
  [3022] = {.lex_state = 228},
  [3023] = {.lex_state = 271, .external_lex_state = 9},
  [3024] = {.lex_state = 157, .external_lex_state = 2},
  [3025] = {.lex_state = 157, .external_lex_state = 2},
  [3026] = {.lex_state = 271, .external_lex_state = 9},
  [3027] = {.lex_state = 271, .external_lex_state = 9},
  [3028] = {.lex_state = 157, .external_lex_state = 2},
  [3029] = {.lex_state = 271, .external_lex_state = 9},
  [3030] = {.lex_state = 268, .external_lex_state = 5},
  [3031] = {.lex_state = 157},
  [3032] = {.lex_state = 271, .external_lex_state = 9},
  [3033] = {.lex_state = 208, .external_lex_state = 5},
  [3034] = {.lex_state = 268, .external_lex_state = 5},
  [3035] = {.lex_state = 268, .external_lex_state = 5},
  [3036] = {.lex_state = 268, .external_lex_state = 14},
  [3037] = {.lex_state = 208, .external_lex_state = 5},
  [3038] = {.lex_state = 157, .external_lex_state = 2},
  [3039] = {.lex_state = 157, .external_lex_state = 2},
  [3040] = {.lex_state = 157, .external_lex_state = 2},
  [3041] = {.lex_state = 157, .external_lex_state = 2},
  [3042] = {.lex_state = 157, .external_lex_state = 2},
  [3043] = {.lex_state = 157, .external_lex_state = 2},
  [3044] = {.lex_state = 157, .external_lex_state = 2},
  [3045] = {.lex_state = 157, .external_lex_state = 2},
  [3046] = {.lex_state = 157, .external_lex_state = 2},
  [3047] = {.lex_state = 157, .external_lex_state = 2},
  [3048] = {.lex_state = 157, .external_lex_state = 2},
  [3049] = {.lex_state = 197, .external_lex_state = 14},
  [3050] = {.lex_state = 135, .external_lex_state = 13},
  [3051] = {.lex_state = 135, .external_lex_state = 2},
  [3052] = {.lex_state = 220, .external_lex_state = 21},
  [3053] = {.lex_state = 220, .external_lex_state = 21},
  [3054] = {.lex_state = 157, .external_lex_state = 2},
  [3055] = {.lex_state = 157, .external_lex_state = 2},
  [3056] = {.lex_state = 220, .external_lex_state = 21},
  [3057] = {.lex_state = 157, .external_lex_state = 2},
  [3058] = {.lex_state = 164},
  [3059] = {.lex_state = 220, .external_lex_state = 21},
  [3060] = {.lex_state = 208, .external_lex_state = 20},
  [3061] = {.lex_state = 197, .external_lex_state = 20},
  [3062] = {.lex_state = 197, .external_lex_state = 20},
  [3063] = {.lex_state = 223, .external_lex_state = 21},
  [3064] = {.lex_state = 157},
  [3065] = {.lex_state = 197, .external_lex_state = 23},
  [3066] = {.lex_state = 197, .external_lex_state = 20},
  [3067] = {.lex_state = 232, .external_lex_state = 2},
  [3068] = {.lex_state = 135},
  [3069] = {.lex_state = 135},
  [3070] = {.lex_state = 197},
  [3071] = {.lex_state = 197, .external_lex_state = 5},
  [3072] = {.lex_state = 215},
  [3073] = {.lex_state = 266, .external_lex_state = 2},
  [3074] = {.lex_state = 157, .external_lex_state = 2},
  [3075] = {.lex_state = 220},
  [3076] = {.lex_state = 135},
  [3077] = {.lex_state = 157},
  [3078] = {.lex_state = 220},
  [3079] = {.lex_state = 157},
  [3080] = {.lex_state = 157},
  [3081] = {.lex_state = 215, .external_lex_state = 13},
  [3082] = {.lex_state = 157, .external_lex_state = 2},
  [3083] = {.lex_state = 157, .external_lex_state = 2},
  [3084] = {.lex_state = 271, .external_lex_state = 17},
  [3085] = {.lex_state = 157, .external_lex_state = 2},
  [3086] = {.lex_state = 228},
  [3087] = {.lex_state = 157, .external_lex_state = 2},
  [3088] = {.lex_state = 157, .external_lex_state = 2},
  [3089] = {.lex_state = 157, .external_lex_state = 2},
  [3090] = {.lex_state = 274, .external_lex_state = 16},
  [3091] = {.lex_state = 344, .external_lex_state = 16},
  [3092] = {.lex_state = 274, .external_lex_state = 16},
  [3093] = {.lex_state = 157},
  [3094] = {.lex_state = 274, .external_lex_state = 19},
  [3095] = {.lex_state = 274, .external_lex_state = 16},
  [3096] = {.lex_state = 274, .external_lex_state = 20},
  [3097] = {.lex_state = 274, .external_lex_state = 20},
  [3098] = {.lex_state = 223, .external_lex_state = 21},
  [3099] = {.lex_state = 157, .external_lex_state = 2},
  [3100] = {.lex_state = 157, .external_lex_state = 28},
  [3101] = {.lex_state = 157, .external_lex_state = 2},
  [3102] = {.lex_state = 157, .external_lex_state = 2},
  [3103] = {.lex_state = 157, .external_lex_state = 2},
  [3104] = {.lex_state = 157, .external_lex_state = 2},
  [3105] = {.lex_state = 157, .external_lex_state = 2},
  [3106] = {.lex_state = 157, .external_lex_state = 2},
  [3107] = {.lex_state = 157, .external_lex_state = 2},
  [3108] = {.lex_state = 157},
  [3109] = {.lex_state = 157, .external_lex_state = 2},
  [3110] = {.lex_state = 157, .external_lex_state = 2},
  [3111] = {.lex_state = 157, .external_lex_state = 2},
  [3112] = {.lex_state = 300, .external_lex_state = 27},
  [3113] = {.lex_state = 164},
  [3114] = {.lex_state = 157, .external_lex_state = 2},
  [3115] = {.lex_state = 157, .external_lex_state = 2},
  [3116] = {.lex_state = 271, .external_lex_state = 17},
  [3117] = {.lex_state = 157, .external_lex_state = 2},
  [3118] = {.lex_state = 228},
  [3119] = {.lex_state = 271, .external_lex_state = 17},
  [3120] = {.lex_state = 157, .external_lex_state = 2},
  [3121] = {.lex_state = 157, .external_lex_state = 2},
  [3122] = {.lex_state = 271, .external_lex_state = 17},
  [3123] = {.lex_state = 271, .external_lex_state = 17},
  [3124] = {.lex_state = 157, .external_lex_state = 2},
  [3125] = {.lex_state = 271, .external_lex_state = 17},
  [3126] = {.lex_state = 344, .external_lex_state = 16},
  [3127] = {.lex_state = 157},
  [3128] = {.lex_state = 271, .external_lex_state = 17},
  [3129] = {.lex_state = 277, .external_lex_state = 16},
  [3130] = {.lex_state = 344, .external_lex_state = 16},
  [3131] = {.lex_state = 344, .external_lex_state = 16},
  [3132] = {.lex_state = 344, .external_lex_state = 19},
  [3133] = {.lex_state = 277, .external_lex_state = 16},
  [3134] = {.lex_state = 274, .external_lex_state = 23},
  [3135] = {.lex_state = 197, .external_lex_state = 13},
  [3136] = {.lex_state = 157},
  [3137] = {.lex_state = 197, .external_lex_state = 13},
  [3138] = {.lex_state = 197, .external_lex_state = 13},
  [3139] = {.lex_state = 215, .external_lex_state = 10},
  [3140] = {.lex_state = 157, .external_lex_state = 2},
  [3141] = {.lex_state = 135, .external_lex_state = 10},
  [3142] = {.lex_state = 220},
  [3143] = {.lex_state = 197, .external_lex_state = 5},
  [3144] = {.lex_state = 157},
  [3145] = {.lex_state = 135, .external_lex_state = 2},
  [3146] = {.lex_state = 215, .external_lex_state = 13},
  [3147] = {.lex_state = 197, .external_lex_state = 5},
  [3148] = {.lex_state = 135, .external_lex_state = 2},
  [3149] = {.lex_state = 135, .external_lex_state = 2},
  [3150] = {.lex_state = 135},
  [3151] = {.lex_state = 197, .external_lex_state = 5},
  [3152] = {.lex_state = 135, .external_lex_state = 15},
  [3153] = {.lex_state = 234, .external_lex_state = 15},
  [3154] = {.lex_state = 217, .external_lex_state = 4},
  [3155] = {.lex_state = 197, .external_lex_state = 5},
  [3156] = {.lex_state = 234, .external_lex_state = 15},
  [3157] = {.lex_state = 197, .external_lex_state = 5},
  [3158] = {.lex_state = 197, .external_lex_state = 5},
  [3159] = {.lex_state = 215},
  [3160] = {.lex_state = 197, .external_lex_state = 5},
  [3161] = {.lex_state = 135, .external_lex_state = 2},
  [3162] = {.lex_state = 197, .external_lex_state = 14},
  [3163] = {.lex_state = 135, .external_lex_state = 13},
  [3164] = {.lex_state = 197, .external_lex_state = 5},
  [3165] = {.lex_state = 135, .external_lex_state = 10},
  [3166] = {.lex_state = 135, .external_lex_state = 2},
  [3167] = {.lex_state = 135},
  [3168] = {.lex_state = 197, .external_lex_state = 5},
  [3169] = {.lex_state = 232, .external_lex_state = 2},
  [3170] = {.lex_state = 215},
  [3171] = {.lex_state = 197, .external_lex_state = 5},
  [3172] = {.lex_state = 197, .external_lex_state = 5},
  [3173] = {.lex_state = 274, .external_lex_state = 20},
  [3174] = {.lex_state = 135, .external_lex_state = 2},
  [3175] = {.lex_state = 164, .external_lex_state = 3},
  [3176] = {.lex_state = 157, .external_lex_state = 2},
  [3177] = {.lex_state = 157, .external_lex_state = 2},
  [3178] = {.lex_state = 197, .external_lex_state = 5},
  [3179] = {.lex_state = 197, .external_lex_state = 5},
  [3180] = {.lex_state = 135},
  [3181] = {.lex_state = 197, .external_lex_state = 5},
  [3182] = {.lex_state = 197, .external_lex_state = 5},
  [3183] = {.lex_state = 217, .external_lex_state = 22},
  [3184] = {.lex_state = 157, .external_lex_state = 29},
  [3185] = {.lex_state = 197, .external_lex_state = 5},
  [3186] = {.lex_state = 197, .external_lex_state = 5},
  [3187] = {.lex_state = 197, .external_lex_state = 5},
  [3188] = {.lex_state = 197, .external_lex_state = 5},
  [3189] = {.lex_state = 197, .external_lex_state = 5},
  [3190] = {.lex_state = 197, .external_lex_state = 5},
  [3191] = {.lex_state = 157, .external_lex_state = 2},
  [3192] = {.lex_state = 157, .external_lex_state = 28},
  [3193] = {.lex_state = 157, .external_lex_state = 2},
  [3194] = {.lex_state = 157, .external_lex_state = 2},
  [3195] = {.lex_state = 157, .external_lex_state = 2},
  [3196] = {.lex_state = 157, .external_lex_state = 2},
  [3197] = {.lex_state = 157, .external_lex_state = 2},
  [3198] = {.lex_state = 157, .external_lex_state = 2},
  [3199] = {.lex_state = 157, .external_lex_state = 2},
  [3200] = {.lex_state = 157, .external_lex_state = 2},
  [3201] = {.lex_state = 157, .external_lex_state = 2},
  [3202] = {.lex_state = 197, .external_lex_state = 14},
  [3203] = {.lex_state = 197, .external_lex_state = 5},
  [3204] = {.lex_state = 135},
  [3205] = {.lex_state = 197, .external_lex_state = 5},
  [3206] = {.lex_state = 135},
  [3207] = {.lex_state = 135},
  [3208] = {.lex_state = 135},
  [3209] = {.lex_state = 274, .external_lex_state = 16},
  [3210] = {.lex_state = 274, .external_lex_state = 19},
  [3211] = {.lex_state = 157, .external_lex_state = 2},
  [3212] = {.lex_state = 274, .external_lex_state = 16},
  [3213] = {.lex_state = 271, .external_lex_state = 17},
  [3214] = {.lex_state = 157, .external_lex_state = 2},
  [3215] = {.lex_state = 271, .external_lex_state = 17},
  [3216] = {.lex_state = 228},
  [3217] = {.lex_state = 157, .external_lex_state = 2},
  [3218] = {.lex_state = 157, .external_lex_state = 2},
  [3219] = {.lex_state = 157, .external_lex_state = 2},
  [3220] = {.lex_state = 274, .external_lex_state = 16},
  [3221] = {.lex_state = 274, .external_lex_state = 16},
  [3222] = {.lex_state = 274, .external_lex_state = 19},
  [3223] = {.lex_state = 274, .external_lex_state = 16},
  [3224] = {.lex_state = 220, .external_lex_state = 17},
  [3225] = {.lex_state = 220, .external_lex_state = 17},
  [3226] = {.lex_state = 157, .external_lex_state = 2},
  [3227] = {.lex_state = 157, .external_lex_state = 2},
  [3228] = {.lex_state = 220, .external_lex_state = 17},
  [3229] = {.lex_state = 157, .external_lex_state = 2},
  [3230] = {.lex_state = 164},
  [3231] = {.lex_state = 220, .external_lex_state = 17},
  [3232] = {.lex_state = 277, .external_lex_state = 16},
  [3233] = {.lex_state = 274, .external_lex_state = 16},
  [3234] = {.lex_state = 372, .external_lex_state = 16},
  [3235] = {.lex_state = 223, .external_lex_state = 17},
  [3236] = {.lex_state = 157},
  [3237] = {.lex_state = 274, .external_lex_state = 19},
  [3238] = {.lex_state = 274, .external_lex_state = 16},
  [3239] = {.lex_state = 274, .external_lex_state = 16},
  [3240] = {.lex_state = 266, .external_lex_state = 29},
  [3241] = {.lex_state = 220, .external_lex_state = 18},
  [3242] = {.lex_state = 157, .external_lex_state = 2},
  [3243] = {.lex_state = 157, .external_lex_state = 28},
  [3244] = {.lex_state = 157, .external_lex_state = 2},
  [3245] = {.lex_state = 157, .external_lex_state = 2},
  [3246] = {.lex_state = 157, .external_lex_state = 2},
  [3247] = {.lex_state = 157, .external_lex_state = 2},
  [3248] = {.lex_state = 157, .external_lex_state = 2},
  [3249] = {.lex_state = 157, .external_lex_state = 2},
  [3250] = {.lex_state = 157, .external_lex_state = 2},
  [3251] = {.lex_state = 157, .external_lex_state = 2},
  [3252] = {.lex_state = 157, .external_lex_state = 2},
  [3253] = {.lex_state = 157, .external_lex_state = 2},
  [3254] = {.lex_state = 300, .external_lex_state = 27},
  [3255] = {.lex_state = 164},
  [3256] = {.lex_state = 271, .external_lex_state = 17},
  [3257] = {.lex_state = 228},
  [3258] = {.lex_state = 157, .external_lex_state = 2},
  [3259] = {.lex_state = 157, .external_lex_state = 2},
  [3260] = {.lex_state = 157, .external_lex_state = 2},
  [3261] = {.lex_state = 344, .external_lex_state = 16},
  [3262] = {.lex_state = 344, .external_lex_state = 16},
  [3263] = {.lex_state = 344, .external_lex_state = 19},
  [3264] = {.lex_state = 344, .external_lex_state = 16},
  [3265] = {.lex_state = 274, .external_lex_state = 19},
  [3266] = {.lex_state = 197, .external_lex_state = 5},
  [3267] = {.lex_state = 197, .external_lex_state = 5},
  [3268] = {.lex_state = 197, .external_lex_state = 5},
  [3269] = {.lex_state = 135, .external_lex_state = 2},
  [3270] = {.lex_state = 135, .external_lex_state = 13},
  [3271] = {.lex_state = 197, .external_lex_state = 5},
  [3272] = {.lex_state = 197, .external_lex_state = 5},
  [3273] = {.lex_state = 135, .external_lex_state = 2},
  [3274] = {.lex_state = 197, .external_lex_state = 5},
  [3275] = {.lex_state = 135},
  [3276] = {.lex_state = 135},
  [3277] = {.lex_state = 197, .external_lex_state = 5},
  [3278] = {.lex_state = 135},
  [3279] = {.lex_state = 197, .external_lex_state = 5},
  [3280] = {.lex_state = 135, .external_lex_state = 2},
  [3281] = {.lex_state = 135},
  [3282] = {.lex_state = 197, .external_lex_state = 5},
  [3283] = {.lex_state = 135, .external_lex_state = 15},
  [3284] = {.lex_state = 234, .external_lex_state = 15},
  [3285] = {.lex_state = 217, .external_lex_state = 4},
  [3286] = {.lex_state = 197, .external_lex_state = 5},
  [3287] = {.lex_state = 234, .external_lex_state = 15},
  [3288] = {.lex_state = 197, .external_lex_state = 5},
  [3289] = {.lex_state = 217, .external_lex_state = 22},
  [3290] = {.lex_state = 217, .external_lex_state = 22},
  [3291] = {.lex_state = 197, .external_lex_state = 5},
  [3292] = {.lex_state = 157, .external_lex_state = 6},
  [3293] = {.lex_state = 197, .external_lex_state = 5},
  [3294] = {.lex_state = 197, .external_lex_state = 5},
  [3295] = {.lex_state = 197, .external_lex_state = 5},
  [3296] = {.lex_state = 197, .external_lex_state = 5},
  [3297] = {.lex_state = 197, .external_lex_state = 5},
  [3298] = {.lex_state = 197, .external_lex_state = 5},
  [3299] = {.lex_state = 197, .external_lex_state = 5},
  [3300] = {.lex_state = 197, .external_lex_state = 5},
  [3301] = {.lex_state = 197, .external_lex_state = 5},
  [3302] = {.lex_state = 359, .external_lex_state = 20},
  [3303] = {.lex_state = 197, .external_lex_state = 5},
  [3304] = {.lex_state = 197, .external_lex_state = 5},
  [3305] = {.lex_state = 197, .external_lex_state = 5},
  [3306] = {.lex_state = 197, .external_lex_state = 5},
  [3307] = {.lex_state = 197, .external_lex_state = 5},
  [3308] = {.lex_state = 197, .external_lex_state = 5},
  [3309] = {.lex_state = 197, .external_lex_state = 5},
  [3310] = {.lex_state = 271, .external_lex_state = 9},
  [3311] = {.lex_state = 266, .external_lex_state = 6},
  [3312] = {.lex_state = 271, .external_lex_state = 9},
  [3313] = {.lex_state = 271, .external_lex_state = 9},
  [3314] = {.lex_state = 300, .external_lex_state = 27},
  [3315] = {.lex_state = 268, .external_lex_state = 5},
  [3316] = {.lex_state = 157},
  [3317] = {.lex_state = 271, .external_lex_state = 9},
  [3318] = {.lex_state = 268, .external_lex_state = 5},
  [3319] = {.lex_state = 232, .external_lex_state = 2},
  [3320] = {.lex_state = 215},
  [3321] = {.lex_state = 157, .external_lex_state = 2},
  [3322] = {.lex_state = 268, .external_lex_state = 5},
  [3323] = {.lex_state = 135, .external_lex_state = 10},
  [3324] = {.lex_state = 135, .external_lex_state = 2},
  [3325] = {.lex_state = 135},
  [3326] = {.lex_state = 157, .external_lex_state = 2},
  [3327] = {.lex_state = 268, .external_lex_state = 5},
  [3328] = {.lex_state = 268, .external_lex_state = 5},
  [3329] = {.lex_state = 135},
  [3330] = {.lex_state = 268, .external_lex_state = 5},
  [3331] = {.lex_state = 268, .external_lex_state = 5},
  [3332] = {.lex_state = 268, .external_lex_state = 5},
  [3333] = {.lex_state = 217, .external_lex_state = 22},
  [3334] = {.lex_state = 157, .external_lex_state = 29},
  [3335] = {.lex_state = 268, .external_lex_state = 5},
  [3336] = {.lex_state = 268, .external_lex_state = 5},
  [3337] = {.lex_state = 197, .external_lex_state = 14},
  [3338] = {.lex_state = 197, .external_lex_state = 5},
  [3339] = {.lex_state = 197, .external_lex_state = 14},
  [3340] = {.lex_state = 157, .external_lex_state = 2},
  [3341] = {.lex_state = 197, .external_lex_state = 5},
  [3342] = {.lex_state = 157, .external_lex_state = 2},
  [3343] = {.lex_state = 271, .external_lex_state = 9},
  [3344] = {.lex_state = 228},
  [3345] = {.lex_state = 157, .external_lex_state = 2},
  [3346] = {.lex_state = 157, .external_lex_state = 2},
  [3347] = {.lex_state = 157, .external_lex_state = 2},
  [3348] = {.lex_state = 197, .external_lex_state = 5},
  [3349] = {.lex_state = 197, .external_lex_state = 5},
  [3350] = {.lex_state = 197, .external_lex_state = 14},
  [3351] = {.lex_state = 197, .external_lex_state = 5},
  [3352] = {.lex_state = 220, .external_lex_state = 9},
  [3353] = {.lex_state = 220, .external_lex_state = 9},
  [3354] = {.lex_state = 157, .external_lex_state = 2},
  [3355] = {.lex_state = 157, .external_lex_state = 2},
  [3356] = {.lex_state = 220, .external_lex_state = 9},
  [3357] = {.lex_state = 157, .external_lex_state = 2},
  [3358] = {.lex_state = 220, .external_lex_state = 9},
  [3359] = {.lex_state = 208, .external_lex_state = 5},
  [3360] = {.lex_state = 197, .external_lex_state = 5},
  [3361] = {.lex_state = 157},
  [3362] = {.lex_state = 197, .external_lex_state = 14},
  [3363] = {.lex_state = 197, .external_lex_state = 5},
  [3364] = {.lex_state = 197, .external_lex_state = 5},
  [3365] = {.lex_state = 157, .external_lex_state = 29},
  [3366] = {.lex_state = 197, .external_lex_state = 5},
  [3367] = {.lex_state = 197, .external_lex_state = 5},
  [3368] = {.lex_state = 157, .external_lex_state = 2},
  [3369] = {.lex_state = 157, .external_lex_state = 28},
  [3370] = {.lex_state = 157, .external_lex_state = 2},
  [3371] = {.lex_state = 157, .external_lex_state = 2},
  [3372] = {.lex_state = 157, .external_lex_state = 2},
  [3373] = {.lex_state = 157, .external_lex_state = 2},
  [3374] = {.lex_state = 157, .external_lex_state = 2},
  [3375] = {.lex_state = 157, .external_lex_state = 2},
  [3376] = {.lex_state = 157, .external_lex_state = 2},
  [3377] = {.lex_state = 157, .external_lex_state = 2},
  [3378] = {.lex_state = 157, .external_lex_state = 2},
  [3379] = {.lex_state = 197, .external_lex_state = 14},
  [3380] = {.lex_state = 197, .external_lex_state = 5},
  [3381] = {.lex_state = 157, .external_lex_state = 2},
  [3382] = {.lex_state = 157, .external_lex_state = 2},
  [3383] = {.lex_state = 157, .external_lex_state = 2},
  [3384] = {.lex_state = 157, .external_lex_state = 2},
  [3385] = {.lex_state = 208, .external_lex_state = 5},
  [3386] = {.lex_state = 197, .external_lex_state = 5},
  [3387] = {.lex_state = 157},
  [3388] = {.lex_state = 197, .external_lex_state = 5},
  [3389] = {.lex_state = 197, .external_lex_state = 5},
  [3390] = {.lex_state = 197, .external_lex_state = 5},
  [3391] = {.lex_state = 359, .external_lex_state = 20},
  [3392] = {.lex_state = 197, .external_lex_state = 5},
  [3393] = {.lex_state = 197, .external_lex_state = 5},
  [3394] = {.lex_state = 197, .external_lex_state = 5},
  [3395] = {.lex_state = 197, .external_lex_state = 5},
  [3396] = {.lex_state = 197, .external_lex_state = 5},
  [3397] = {.lex_state = 197, .external_lex_state = 5},
  [3398] = {.lex_state = 197, .external_lex_state = 5},
  [3399] = {.lex_state = 197, .external_lex_state = 5},
  [3400] = {.lex_state = 135},
  [3401] = {.lex_state = 135},
  [3402] = {.lex_state = 135},
  [3403] = {.lex_state = 197, .external_lex_state = 14},
  [3404] = {.lex_state = 220, .external_lex_state = 9},
  [3405] = {.lex_state = 157, .external_lex_state = 2},
  [3406] = {.lex_state = 220, .external_lex_state = 9},
  [3407] = {.lex_state = 157, .external_lex_state = 2},
  [3408] = {.lex_state = 157, .external_lex_state = 2},
  [3409] = {.lex_state = 220, .external_lex_state = 9},
  [3410] = {.lex_state = 157, .external_lex_state = 2},
  [3411] = {.lex_state = 164},
  [3412] = {.lex_state = 220, .external_lex_state = 9},
  [3413] = {.lex_state = 208, .external_lex_state = 5},
  [3414] = {.lex_state = 197, .external_lex_state = 5},
  [3415] = {.lex_state = 197, .external_lex_state = 5},
  [3416] = {.lex_state = 197, .external_lex_state = 13},
  [3417] = {.lex_state = 197, .external_lex_state = 13},
  [3418] = {.lex_state = 223, .external_lex_state = 9},
  [3419] = {.lex_state = 157},
  [3420] = {.lex_state = 197, .external_lex_state = 14},
  [3421] = {.lex_state = 135, .external_lex_state = 2},
  [3422] = {.lex_state = 135},
  [3423] = {.lex_state = 135},
  [3424] = {.lex_state = 220, .external_lex_state = 13},
  [3425] = {.lex_state = 274, .external_lex_state = 5},
  [3426] = {.lex_state = 274, .external_lex_state = 14},
  [3427] = {.lex_state = 157, .external_lex_state = 2},
  [3428] = {.lex_state = 274, .external_lex_state = 5},
  [3429] = {.lex_state = 271, .external_lex_state = 9},
  [3430] = {.lex_state = 157, .external_lex_state = 2},
  [3431] = {.lex_state = 271, .external_lex_state = 9},
  [3432] = {.lex_state = 228},
  [3433] = {.lex_state = 157, .external_lex_state = 2},
  [3434] = {.lex_state = 157, .external_lex_state = 2},
  [3435] = {.lex_state = 157, .external_lex_state = 2},
  [3436] = {.lex_state = 274, .external_lex_state = 5},
  [3437] = {.lex_state = 274, .external_lex_state = 5},
  [3438] = {.lex_state = 274, .external_lex_state = 14},
  [3439] = {.lex_state = 274, .external_lex_state = 5},
  [3440] = {.lex_state = 220, .external_lex_state = 9},
  [3441] = {.lex_state = 220, .external_lex_state = 9},
  [3442] = {.lex_state = 157, .external_lex_state = 2},
  [3443] = {.lex_state = 157, .external_lex_state = 2},
  [3444] = {.lex_state = 220, .external_lex_state = 9},
  [3445] = {.lex_state = 157, .external_lex_state = 2},
  [3446] = {.lex_state = 220, .external_lex_state = 9},
  [3447] = {.lex_state = 277, .external_lex_state = 5},
  [3448] = {.lex_state = 274, .external_lex_state = 5},
  [3449] = {.lex_state = 157},
  [3450] = {.lex_state = 274, .external_lex_state = 14},
  [3451] = {.lex_state = 274, .external_lex_state = 5},
  [3452] = {.lex_state = 274, .external_lex_state = 5},
  [3453] = {.lex_state = 157, .external_lex_state = 29},
  [3454] = {.lex_state = 274, .external_lex_state = 5},
  [3455] = {.lex_state = 274, .external_lex_state = 5},
  [3456] = {.lex_state = 157, .external_lex_state = 2},
  [3457] = {.lex_state = 157, .external_lex_state = 28},
  [3458] = {.lex_state = 157, .external_lex_state = 2},
  [3459] = {.lex_state = 157, .external_lex_state = 2},
  [3460] = {.lex_state = 157, .external_lex_state = 2},
  [3461] = {.lex_state = 157, .external_lex_state = 2},
  [3462] = {.lex_state = 157, .external_lex_state = 2},
  [3463] = {.lex_state = 157, .external_lex_state = 2},
  [3464] = {.lex_state = 157, .external_lex_state = 2},
  [3465] = {.lex_state = 157, .external_lex_state = 2},
  [3466] = {.lex_state = 157, .external_lex_state = 2},
  [3467] = {.lex_state = 300, .external_lex_state = 27},
  [3468] = {.lex_state = 164},
  [3469] = {.lex_state = 271, .external_lex_state = 9},
  [3470] = {.lex_state = 228},
  [3471] = {.lex_state = 157, .external_lex_state = 2},
  [3472] = {.lex_state = 157, .external_lex_state = 2},
  [3473] = {.lex_state = 157, .external_lex_state = 2},
  [3474] = {.lex_state = 344, .external_lex_state = 5},
  [3475] = {.lex_state = 344, .external_lex_state = 5},
  [3476] = {.lex_state = 344, .external_lex_state = 14},
  [3477] = {.lex_state = 344, .external_lex_state = 5},
  [3478] = {.lex_state = 274, .external_lex_state = 14},
  [3479] = {.lex_state = 258, .external_lex_state = 6},
  [3480] = {.lex_state = 300, .external_lex_state = 27},
  [3481] = {.lex_state = 164},
  [3482] = {.lex_state = 157, .external_lex_state = 2},
  [3483] = {.lex_state = 157, .external_lex_state = 2},
  [3484] = {.lex_state = 271, .external_lex_state = 17},
  [3485] = {.lex_state = 157, .external_lex_state = 2},
  [3486] = {.lex_state = 228},
  [3487] = {.lex_state = 220, .external_lex_state = 17},
  [3488] = {.lex_state = 157, .external_lex_state = 2},
  [3489] = {.lex_state = 157, .external_lex_state = 2},
  [3490] = {.lex_state = 220, .external_lex_state = 17},
  [3491] = {.lex_state = 220, .external_lex_state = 17},
  [3492] = {.lex_state = 157, .external_lex_state = 2},
  [3493] = {.lex_state = 220, .external_lex_state = 17},
  [3494] = {.lex_state = 157},
  [3495] = {.lex_state = 258, .external_lex_state = 18},
  [3496] = {.lex_state = 344, .external_lex_state = 16},
  [3497] = {.lex_state = 274, .external_lex_state = 16},
  [3498] = {.lex_state = 274, .external_lex_state = 19},
  [3499] = {.lex_state = 258, .external_lex_state = 18},
  [3500] = {.lex_state = 274, .external_lex_state = 5},
  [3501] = {.lex_state = 274, .external_lex_state = 5},
  [3502] = {.lex_state = 274, .external_lex_state = 5},
  [3503] = {.lex_state = 135, .external_lex_state = 2},
  [3504] = {.lex_state = 217, .external_lex_state = 22},
  [3505] = {.lex_state = 274, .external_lex_state = 5},
  [3506] = {.lex_state = 274, .external_lex_state = 5},
  [3507] = {.lex_state = 266, .external_lex_state = 8},
  [3508] = {.lex_state = 258},
  [3509] = {.lex_state = 223, .external_lex_state = 9},
  [3510] = {.lex_state = 266, .external_lex_state = 6},
  [3511] = {.lex_state = 223, .external_lex_state = 9},
  [3512] = {.lex_state = 223, .external_lex_state = 9},
  [3513] = {.lex_state = 300, .external_lex_state = 27},
  [3514] = {.lex_state = 223, .external_lex_state = 9},
  [3515] = {.lex_state = 157, .external_lex_state = 2},
  [3516] = {.lex_state = 157, .external_lex_state = 2},
  [3517] = {.lex_state = 157, .external_lex_state = 2},
  [3518] = {.lex_state = 157, .external_lex_state = 2},
  [3519] = {.lex_state = 277, .external_lex_state = 5},
  [3520] = {.lex_state = 274, .external_lex_state = 5},
  [3521] = {.lex_state = 157},
  [3522] = {.lex_state = 274, .external_lex_state = 5},
  [3523] = {.lex_state = 344, .external_lex_state = 5},
  [3524] = {.lex_state = 344, .external_lex_state = 14},
  [3525] = {.lex_state = 157, .external_lex_state = 2},
  [3526] = {.lex_state = 344, .external_lex_state = 5},
  [3527] = {.lex_state = 157, .external_lex_state = 2},
  [3528] = {.lex_state = 223, .external_lex_state = 9},
  [3529] = {.lex_state = 223, .external_lex_state = 9},
  [3530] = {.lex_state = 157, .external_lex_state = 2},
  [3531] = {.lex_state = 157, .external_lex_state = 2},
  [3532] = {.lex_state = 223, .external_lex_state = 9},
  [3533] = {.lex_state = 157, .external_lex_state = 2},
  [3534] = {.lex_state = 223, .external_lex_state = 9},
  [3535] = {.lex_state = 277, .external_lex_state = 5},
  [3536] = {.lex_state = 277, .external_lex_state = 5},
  [3537] = {.lex_state = 277, .external_lex_state = 5},
  [3538] = {.lex_state = 223, .external_lex_state = 9},
  [3539] = {.lex_state = 157},
  [3540] = {.lex_state = 277, .external_lex_state = 14},
  [3541] = {.lex_state = 277, .external_lex_state = 5},
  [3542] = {.lex_state = 277, .external_lex_state = 5},
  [3543] = {.lex_state = 157, .external_lex_state = 28},
  [3544] = {.lex_state = 157, .external_lex_state = 29},
  [3545] = {.lex_state = 277, .external_lex_state = 5},
  [3546] = {.lex_state = 277, .external_lex_state = 5},
  [3547] = {.lex_state = 157, .external_lex_state = 2},
  [3548] = {.lex_state = 157, .external_lex_state = 2},
  [3549] = {.lex_state = 157, .external_lex_state = 2},
  [3550] = {.lex_state = 157, .external_lex_state = 2},
  [3551] = {.lex_state = 157, .external_lex_state = 2},
  [3552] = {.lex_state = 157, .external_lex_state = 2},
  [3553] = {.lex_state = 157, .external_lex_state = 2},
  [3554] = {.lex_state = 157, .external_lex_state = 2},
  [3555] = {.lex_state = 157, .external_lex_state = 2},
  [3556] = {.lex_state = 157, .external_lex_state = 2},
  [3557] = {.lex_state = 344, .external_lex_state = 14},
  [3558] = {.lex_state = 274, .external_lex_state = 5},
  [3559] = {.lex_state = 274, .external_lex_state = 5},
  [3560] = {.lex_state = 274, .external_lex_state = 5},
  [3561] = {.lex_state = 274, .external_lex_state = 5},
  [3562] = {.lex_state = 274, .external_lex_state = 5},
  [3563] = {.lex_state = 359, .external_lex_state = 20},
  [3564] = {.lex_state = 274, .external_lex_state = 5},
  [3565] = {.lex_state = 274, .external_lex_state = 5},
  [3566] = {.lex_state = 274, .external_lex_state = 5},
  [3567] = {.lex_state = 274, .external_lex_state = 5},
  [3568] = {.lex_state = 274, .external_lex_state = 5},
  [3569] = {.lex_state = 274, .external_lex_state = 14},
  [3570] = {.lex_state = 135, .external_lex_state = 13},
  [3571] = {.lex_state = 135, .external_lex_state = 2},
  [3572] = {.lex_state = 197, .external_lex_state = 5},
  [3573] = {.lex_state = 197, .external_lex_state = 5},
  [3574] = {.lex_state = 135, .external_lex_state = 2},
  [3575] = {.lex_state = 258, .external_lex_state = 6},
  [3576] = {.lex_state = 266, .external_lex_state = 6},
  [3577] = {.lex_state = 258, .external_lex_state = 6},
  [3578] = {.lex_state = 258, .external_lex_state = 6},
  [3579] = {.lex_state = 300, .external_lex_state = 27},
  [3580] = {.lex_state = 258, .external_lex_state = 25},
  [3581] = {.lex_state = 197, .external_lex_state = 16},
  [3582] = {.lex_state = 197, .external_lex_state = 19},
  [3583] = {.lex_state = 197, .external_lex_state = 16},
  [3584] = {.lex_state = 157, .external_lex_state = 2},
  [3585] = {.lex_state = 197, .external_lex_state = 16},
  [3586] = {.lex_state = 157, .external_lex_state = 2},
  [3587] = {.lex_state = 245, .external_lex_state = 17},
  [3588] = {.lex_state = 228},
  [3589] = {.lex_state = 157, .external_lex_state = 2},
  [3590] = {.lex_state = 157, .external_lex_state = 2},
  [3591] = {.lex_state = 157, .external_lex_state = 2},
  [3592] = {.lex_state = 197, .external_lex_state = 16},
  [3593] = {.lex_state = 197, .external_lex_state = 16},
  [3594] = {.lex_state = 197, .external_lex_state = 19},
  [3595] = {.lex_state = 197, .external_lex_state = 16},
  [3596] = {.lex_state = 220, .external_lex_state = 17},
  [3597] = {.lex_state = 220, .external_lex_state = 17},
  [3598] = {.lex_state = 157, .external_lex_state = 2},
  [3599] = {.lex_state = 157, .external_lex_state = 2},
  [3600] = {.lex_state = 220, .external_lex_state = 17},
  [3601] = {.lex_state = 157, .external_lex_state = 2},
  [3602] = {.lex_state = 220, .external_lex_state = 17},
  [3603] = {.lex_state = 208, .external_lex_state = 16},
  [3604] = {.lex_state = 197, .external_lex_state = 16},
  [3605] = {.lex_state = 223, .external_lex_state = 17},
  [3606] = {.lex_state = 157},
  [3607] = {.lex_state = 197, .external_lex_state = 19},
  [3608] = {.lex_state = 197, .external_lex_state = 16},
  [3609] = {.lex_state = 197, .external_lex_state = 16},
  [3610] = {.lex_state = 157, .external_lex_state = 28},
  [3611] = {.lex_state = 157, .external_lex_state = 29},
  [3612] = {.lex_state = 258, .external_lex_state = 18},
  [3613] = {.lex_state = 258, .external_lex_state = 18},
  [3614] = {.lex_state = 157, .external_lex_state = 2},
  [3615] = {.lex_state = 157, .external_lex_state = 2},
  [3616] = {.lex_state = 157, .external_lex_state = 2},
  [3617] = {.lex_state = 157, .external_lex_state = 2},
  [3618] = {.lex_state = 157, .external_lex_state = 2},
  [3619] = {.lex_state = 157, .external_lex_state = 2},
  [3620] = {.lex_state = 157, .external_lex_state = 2},
  [3621] = {.lex_state = 157, .external_lex_state = 2},
  [3622] = {.lex_state = 157, .external_lex_state = 2},
  [3623] = {.lex_state = 157, .external_lex_state = 2},
  [3624] = {.lex_state = 157, .external_lex_state = 2},
  [3625] = {.lex_state = 197, .external_lex_state = 19},
  [3626] = {.lex_state = 197, .external_lex_state = 5},
  [3627] = {.lex_state = 258, .external_lex_state = 25},
  [3628] = {.lex_state = 197, .external_lex_state = 13},
  [3629] = {.lex_state = 197, .external_lex_state = 5},
  [3630] = {.lex_state = 135, .external_lex_state = 2},
  [3631] = {.lex_state = 217, .external_lex_state = 22},
  [3632] = {.lex_state = 197, .external_lex_state = 5},
  [3633] = {.lex_state = 271, .external_lex_state = 9},
  [3634] = {.lex_state = 157, .external_lex_state = 2},
  [3635] = {.lex_state = 157, .external_lex_state = 2},
  [3636] = {.lex_state = 271, .external_lex_state = 9},
  [3637] = {.lex_state = 157, .external_lex_state = 2},
  [3638] = {.lex_state = 228},
  [3639] = {.lex_state = 157, .external_lex_state = 2},
  [3640] = {.lex_state = 157, .external_lex_state = 2},
  [3641] = {.lex_state = 157, .external_lex_state = 2},
  [3642] = {.lex_state = 197, .external_lex_state = 5},
  [3643] = {.lex_state = 268, .external_lex_state = 5},
  [3644] = {.lex_state = 197, .external_lex_state = 5},
  [3645] = {.lex_state = 157},
  [3646] = {.lex_state = 197, .external_lex_state = 14},
  [3647] = {.lex_state = 197, .external_lex_state = 5},
  [3648] = {.lex_state = 197, .external_lex_state = 5},
  [3649] = {.lex_state = 258, .external_lex_state = 13},
  [3650] = {.lex_state = 258, .external_lex_state = 13},
  [3651] = {.lex_state = 258, .external_lex_state = 13},
  [3652] = {.lex_state = 164},
  [3653] = {.lex_state = 258, .external_lex_state = 13},
  [3654] = {.lex_state = 258},
  [3655] = {.lex_state = 258, .external_lex_state = 25},
  [3656] = {.lex_state = 135},
  [3657] = {.lex_state = 135, .external_lex_state = 2},
  [3658] = {.lex_state = 135},
  [3659] = {.lex_state = 157, .external_lex_state = 2},
  [3660] = {.lex_state = 157, .external_lex_state = 28},
  [3661] = {.lex_state = 157, .external_lex_state = 2},
  [3662] = {.lex_state = 157, .external_lex_state = 2},
  [3663] = {.lex_state = 157, .external_lex_state = 2},
  [3664] = {.lex_state = 157, .external_lex_state = 2},
  [3665] = {.lex_state = 157, .external_lex_state = 2},
  [3666] = {.lex_state = 157, .external_lex_state = 2},
  [3667] = {.lex_state = 157, .external_lex_state = 2},
  [3668] = {.lex_state = 157, .external_lex_state = 2},
  [3669] = {.lex_state = 157, .external_lex_state = 2},
  [3670] = {.lex_state = 157, .external_lex_state = 2},
  [3671] = {.lex_state = 300, .external_lex_state = 27},
  [3672] = {.lex_state = 164},
  [3673] = {.lex_state = 157, .external_lex_state = 28},
  [3674] = {.lex_state = 197, .external_lex_state = 13},
  [3675] = {.lex_state = 157, .external_lex_state = 2},
  [3676] = {.lex_state = 157, .external_lex_state = 2},
  [3677] = {.lex_state = 271, .external_lex_state = 9},
  [3678] = {.lex_state = 157, .external_lex_state = 2},
  [3679] = {.lex_state = 228},
  [3680] = {.lex_state = 271, .external_lex_state = 9},
  [3681] = {.lex_state = 157, .external_lex_state = 2},
  [3682] = {.lex_state = 157, .external_lex_state = 2},
  [3683] = {.lex_state = 271, .external_lex_state = 9},
  [3684] = {.lex_state = 271, .external_lex_state = 9},
  [3685] = {.lex_state = 157, .external_lex_state = 2},
  [3686] = {.lex_state = 271, .external_lex_state = 9},
  [3687] = {.lex_state = 268, .external_lex_state = 5},
  [3688] = {.lex_state = 157},
  [3689] = {.lex_state = 271, .external_lex_state = 9},
  [3690] = {.lex_state = 268, .external_lex_state = 5},
  [3691] = {.lex_state = 268, .external_lex_state = 5},
  [3692] = {.lex_state = 268, .external_lex_state = 5},
  [3693] = {.lex_state = 268, .external_lex_state = 14},
  [3694] = {.lex_state = 268, .external_lex_state = 5},
  [3695] = {.lex_state = 197, .external_lex_state = 14},
  [3696] = {.lex_state = 135, .external_lex_state = 13},
  [3697] = {.lex_state = 135, .external_lex_state = 2},
  [3698] = {.lex_state = 135, .external_lex_state = 2},
  [3699] = {.lex_state = 197, .external_lex_state = 13},
  [3700] = {.lex_state = 197, .external_lex_state = 5},
  [3701] = {.lex_state = 135, .external_lex_state = 2},
  [3702] = {.lex_state = 217, .external_lex_state = 22},
  [3703] = {.lex_state = 197, .external_lex_state = 5},
  [3704] = {.lex_state = 223, .external_lex_state = 9},
  [3705] = {.lex_state = 157, .external_lex_state = 2},
  [3706] = {.lex_state = 157, .external_lex_state = 2},
  [3707] = {.lex_state = 271, .external_lex_state = 9},
  [3708] = {.lex_state = 157, .external_lex_state = 2},
  [3709] = {.lex_state = 164},
  [3710] = {.lex_state = 228},
  [3711] = {.lex_state = 220, .external_lex_state = 9},
  [3712] = {.lex_state = 157, .external_lex_state = 2},
  [3713] = {.lex_state = 157, .external_lex_state = 2},
  [3714] = {.lex_state = 220, .external_lex_state = 9},
  [3715] = {.lex_state = 220, .external_lex_state = 9},
  [3716] = {.lex_state = 157, .external_lex_state = 2},
  [3717] = {.lex_state = 220, .external_lex_state = 9},
  [3718] = {.lex_state = 197, .external_lex_state = 5},
  [3719] = {.lex_state = 268, .external_lex_state = 5},
  [3720] = {.lex_state = 197, .external_lex_state = 5},
  [3721] = {.lex_state = 197, .external_lex_state = 5},
  [3722] = {.lex_state = 271, .external_lex_state = 9},
  [3723] = {.lex_state = 157},
  [3724] = {.lex_state = 197, .external_lex_state = 14},
  [3725] = {.lex_state = 197, .external_lex_state = 5},
  [3726] = {.lex_state = 157, .external_lex_state = 2},
  [3727] = {.lex_state = 157, .external_lex_state = 2},
  [3728] = {.lex_state = 157, .external_lex_state = 2},
  [3729] = {.lex_state = 157, .external_lex_state = 2},
  [3730] = {.lex_state = 157, .external_lex_state = 2},
  [3731] = {.lex_state = 135, .external_lex_state = 2},
  [3732] = {.lex_state = 300, .external_lex_state = 27},
  [3733] = {.lex_state = 164},
  [3734] = {.lex_state = 157, .external_lex_state = 28},
  [3735] = {.lex_state = 135, .external_lex_state = 2},
  [3736] = {.lex_state = 135},
  [3737] = {.lex_state = 157, .external_lex_state = 2},
  [3738] = {.lex_state = 157, .external_lex_state = 2},
  [3739] = {.lex_state = 271, .external_lex_state = 9},
  [3740] = {.lex_state = 157, .external_lex_state = 2},
  [3741] = {.lex_state = 228},
  [3742] = {.lex_state = 271, .external_lex_state = 9},
  [3743] = {.lex_state = 157, .external_lex_state = 2},
  [3744] = {.lex_state = 157, .external_lex_state = 2},
  [3745] = {.lex_state = 271, .external_lex_state = 9},
  [3746] = {.lex_state = 271, .external_lex_state = 9},
  [3747] = {.lex_state = 157, .external_lex_state = 2},
  [3748] = {.lex_state = 271, .external_lex_state = 9},
  [3749] = {.lex_state = 268, .external_lex_state = 5},
  [3750] = {.lex_state = 157},
  [3751] = {.lex_state = 271, .external_lex_state = 9},
  [3752] = {.lex_state = 208, .external_lex_state = 5},
  [3753] = {.lex_state = 268, .external_lex_state = 5},
  [3754] = {.lex_state = 268, .external_lex_state = 5},
  [3755] = {.lex_state = 268, .external_lex_state = 14},
  [3756] = {.lex_state = 208, .external_lex_state = 5},
  [3757] = {.lex_state = 157, .external_lex_state = 2},
  [3758] = {.lex_state = 157, .external_lex_state = 2},
  [3759] = {.lex_state = 157, .external_lex_state = 2},
  [3760] = {.lex_state = 157, .external_lex_state = 2},
  [3761] = {.lex_state = 157, .external_lex_state = 2},
  [3762] = {.lex_state = 157, .external_lex_state = 2},
  [3763] = {.lex_state = 157, .external_lex_state = 2},
  [3764] = {.lex_state = 157, .external_lex_state = 2},
  [3765] = {.lex_state = 157, .external_lex_state = 2},
  [3766] = {.lex_state = 157, .external_lex_state = 2},
  [3767] = {.lex_state = 157, .external_lex_state = 2},
  [3768] = {.lex_state = 197, .external_lex_state = 14},
  [3769] = {.lex_state = 135, .external_lex_state = 13},
  [3770] = {.lex_state = 135, .external_lex_state = 2},
  [3771] = {.lex_state = 197, .external_lex_state = 5},
  [3772] = {.lex_state = 197, .external_lex_state = 14},
  [3773] = {.lex_state = 157, .external_lex_state = 2},
  [3774] = {.lex_state = 197, .external_lex_state = 5},
  [3775] = {.lex_state = 271, .external_lex_state = 9},
  [3776] = {.lex_state = 157, .external_lex_state = 2},
  [3777] = {.lex_state = 271, .external_lex_state = 9},
  [3778] = {.lex_state = 228},
  [3779] = {.lex_state = 157, .external_lex_state = 2},
  [3780] = {.lex_state = 157, .external_lex_state = 2},
  [3781] = {.lex_state = 157, .external_lex_state = 2},
  [3782] = {.lex_state = 197, .external_lex_state = 5},
  [3783] = {.lex_state = 197, .external_lex_state = 5},
  [3784] = {.lex_state = 197, .external_lex_state = 14},
  [3785] = {.lex_state = 197, .external_lex_state = 5},
  [3786] = {.lex_state = 220, .external_lex_state = 9},
  [3787] = {.lex_state = 220, .external_lex_state = 9},
  [3788] = {.lex_state = 157, .external_lex_state = 2},
  [3789] = {.lex_state = 157, .external_lex_state = 2},
  [3790] = {.lex_state = 220, .external_lex_state = 9},
  [3791] = {.lex_state = 157, .external_lex_state = 2},
  [3792] = {.lex_state = 220, .external_lex_state = 9},
  [3793] = {.lex_state = 208, .external_lex_state = 5},
  [3794] = {.lex_state = 197, .external_lex_state = 5},
  [3795] = {.lex_state = 157},
  [3796] = {.lex_state = 197, .external_lex_state = 14},
  [3797] = {.lex_state = 197, .external_lex_state = 5},
  [3798] = {.lex_state = 197, .external_lex_state = 5},
  [3799] = {.lex_state = 157, .external_lex_state = 29},
  [3800] = {.lex_state = 197, .external_lex_state = 5},
  [3801] = {.lex_state = 197, .external_lex_state = 5},
  [3802] = {.lex_state = 157, .external_lex_state = 2},
  [3803] = {.lex_state = 157, .external_lex_state = 28},
  [3804] = {.lex_state = 157, .external_lex_state = 2},
  [3805] = {.lex_state = 157, .external_lex_state = 2},
  [3806] = {.lex_state = 157, .external_lex_state = 2},
  [3807] = {.lex_state = 157, .external_lex_state = 2},
  [3808] = {.lex_state = 157, .external_lex_state = 2},
  [3809] = {.lex_state = 157, .external_lex_state = 2},
  [3810] = {.lex_state = 157, .external_lex_state = 2},
  [3811] = {.lex_state = 157, .external_lex_state = 2},
  [3812] = {.lex_state = 157, .external_lex_state = 2},
  [3813] = {.lex_state = 300, .external_lex_state = 27},
  [3814] = {.lex_state = 164},
  [3815] = {.lex_state = 271, .external_lex_state = 9},
  [3816] = {.lex_state = 228},
  [3817] = {.lex_state = 157, .external_lex_state = 2},
  [3818] = {.lex_state = 157, .external_lex_state = 2},
  [3819] = {.lex_state = 157, .external_lex_state = 2},
  [3820] = {.lex_state = 268, .external_lex_state = 5},
  [3821] = {.lex_state = 268, .external_lex_state = 5},
  [3822] = {.lex_state = 268, .external_lex_state = 14},
  [3823] = {.lex_state = 268, .external_lex_state = 5},
  [3824] = {.lex_state = 197, .external_lex_state = 14},
  [3825] = {.lex_state = 197, .external_lex_state = 5},
  [3826] = {.lex_state = 197, .external_lex_state = 5},
  [3827] = {.lex_state = 197, .external_lex_state = 5},
  [3828] = {.lex_state = 197, .external_lex_state = 5},
  [3829] = {.lex_state = 197, .external_lex_state = 5},
  [3830] = {.lex_state = 223, .external_lex_state = 9},
  [3831] = {.lex_state = 266, .external_lex_state = 6},
  [3832] = {.lex_state = 223, .external_lex_state = 9},
  [3833] = {.lex_state = 223, .external_lex_state = 9},
  [3834] = {.lex_state = 300, .external_lex_state = 27},
  [3835] = {.lex_state = 223, .external_lex_state = 9},
  [3836] = {.lex_state = 157, .external_lex_state = 2},
  [3837] = {.lex_state = 157, .external_lex_state = 2},
  [3838] = {.lex_state = 157, .external_lex_state = 2},
  [3839] = {.lex_state = 157, .external_lex_state = 2},
  [3840] = {.lex_state = 208, .external_lex_state = 5},
  [3841] = {.lex_state = 197, .external_lex_state = 5},
  [3842] = {.lex_state = 157},
  [3843] = {.lex_state = 197, .external_lex_state = 5},
  [3844] = {.lex_state = 197, .external_lex_state = 5},
  [3845] = {.lex_state = 135},
  [3846] = {.lex_state = 268, .external_lex_state = 5},
  [3847] = {.lex_state = 268, .external_lex_state = 14},
  [3848] = {.lex_state = 157, .external_lex_state = 2},
  [3849] = {.lex_state = 268, .external_lex_state = 5},
  [3850] = {.lex_state = 157, .external_lex_state = 2},
  [3851] = {.lex_state = 223, .external_lex_state = 9},
  [3852] = {.lex_state = 223, .external_lex_state = 9},
  [3853] = {.lex_state = 157, .external_lex_state = 2},
  [3854] = {.lex_state = 157, .external_lex_state = 2},
  [3855] = {.lex_state = 223, .external_lex_state = 9},
  [3856] = {.lex_state = 157, .external_lex_state = 2},
  [3857] = {.lex_state = 223, .external_lex_state = 9},
  [3858] = {.lex_state = 208, .external_lex_state = 5},
  [3859] = {.lex_state = 208, .external_lex_state = 5},
  [3860] = {.lex_state = 208, .external_lex_state = 5},
  [3861] = {.lex_state = 223, .external_lex_state = 9},
  [3862] = {.lex_state = 157},
  [3863] = {.lex_state = 208, .external_lex_state = 14},
  [3864] = {.lex_state = 208, .external_lex_state = 5},
  [3865] = {.lex_state = 208, .external_lex_state = 5},
  [3866] = {.lex_state = 157, .external_lex_state = 28},
  [3867] = {.lex_state = 157, .external_lex_state = 29},
  [3868] = {.lex_state = 208, .external_lex_state = 5},
  [3869] = {.lex_state = 208, .external_lex_state = 5},
  [3870] = {.lex_state = 157, .external_lex_state = 2},
  [3871] = {.lex_state = 157, .external_lex_state = 2},
  [3872] = {.lex_state = 157, .external_lex_state = 2},
  [3873] = {.lex_state = 157, .external_lex_state = 2},
  [3874] = {.lex_state = 157, .external_lex_state = 2},
  [3875] = {.lex_state = 157, .external_lex_state = 2},
  [3876] = {.lex_state = 157, .external_lex_state = 2},
  [3877] = {.lex_state = 157, .external_lex_state = 2},
  [3878] = {.lex_state = 157, .external_lex_state = 2},
  [3879] = {.lex_state = 157, .external_lex_state = 2},
  [3880] = {.lex_state = 268, .external_lex_state = 14},
  [3881] = {.lex_state = 197, .external_lex_state = 5},
  [3882] = {.lex_state = 197, .external_lex_state = 5},
  [3883] = {.lex_state = 197, .external_lex_state = 5},
  [3884] = {.lex_state = 197, .external_lex_state = 5},
  [3885] = {.lex_state = 197, .external_lex_state = 5},
  [3886] = {.lex_state = 359, .external_lex_state = 20},
  [3887] = {.lex_state = 197, .external_lex_state = 5},
  [3888] = {.lex_state = 197, .external_lex_state = 5},
  [3889] = {.lex_state = 197, .external_lex_state = 5},
  [3890] = {.lex_state = 197, .external_lex_state = 5},
  [3891] = {.lex_state = 197, .external_lex_state = 5},
  [3892] = {.lex_state = 197, .external_lex_state = 14},
  [3893] = {.lex_state = 135},
  [3894] = {.lex_state = 135, .external_lex_state = 13},
  [3895] = {.lex_state = 258, .external_lex_state = 6},
  [3896] = {.lex_state = 266, .external_lex_state = 6},
  [3897] = {.lex_state = 258, .external_lex_state = 6},
  [3898] = {.lex_state = 258, .external_lex_state = 6},
  [3899] = {.lex_state = 300, .external_lex_state = 27},
  [3900] = {.lex_state = 258, .external_lex_state = 6},
  [3901] = {.lex_state = 197, .external_lex_state = 16},
  [3902] = {.lex_state = 197, .external_lex_state = 19},
  [3903] = {.lex_state = 157, .external_lex_state = 2},
  [3904] = {.lex_state = 197, .external_lex_state = 16},
  [3905] = {.lex_state = 157, .external_lex_state = 2},
  [3906] = {.lex_state = 245, .external_lex_state = 17},
  [3907] = {.lex_state = 228},
  [3908] = {.lex_state = 157, .external_lex_state = 2},
  [3909] = {.lex_state = 157, .external_lex_state = 2},
  [3910] = {.lex_state = 157, .external_lex_state = 2},
  [3911] = {.lex_state = 197, .external_lex_state = 16},
  [3912] = {.lex_state = 197, .external_lex_state = 16},
  [3913] = {.lex_state = 197, .external_lex_state = 19},
  [3914] = {.lex_state = 197, .external_lex_state = 16},
  [3915] = {.lex_state = 338, .external_lex_state = 17},
  [3916] = {.lex_state = 338, .external_lex_state = 17},
  [3917] = {.lex_state = 157, .external_lex_state = 2},
  [3918] = {.lex_state = 157, .external_lex_state = 2},
  [3919] = {.lex_state = 338, .external_lex_state = 17},
  [3920] = {.lex_state = 157, .external_lex_state = 2},
  [3921] = {.lex_state = 338, .external_lex_state = 17},
  [3922] = {.lex_state = 208, .external_lex_state = 16},
  [3923] = {.lex_state = 316, .external_lex_state = 16},
  [3924] = {.lex_state = 157},
  [3925] = {.lex_state = 316, .external_lex_state = 19},
  [3926] = {.lex_state = 316, .external_lex_state = 16},
  [3927] = {.lex_state = 316, .external_lex_state = 16},
  [3928] = {.lex_state = 157, .external_lex_state = 28},
  [3929] = {.lex_state = 157, .external_lex_state = 29},
  [3930] = {.lex_state = 258, .external_lex_state = 18},
  [3931] = {.lex_state = 258, .external_lex_state = 18},
  [3932] = {.lex_state = 157, .external_lex_state = 2},
  [3933] = {.lex_state = 157, .external_lex_state = 2},
  [3934] = {.lex_state = 157, .external_lex_state = 2},
  [3935] = {.lex_state = 157, .external_lex_state = 2},
  [3936] = {.lex_state = 157, .external_lex_state = 2},
  [3937] = {.lex_state = 157, .external_lex_state = 2},
  [3938] = {.lex_state = 157, .external_lex_state = 2},
  [3939] = {.lex_state = 157, .external_lex_state = 2},
  [3940] = {.lex_state = 157, .external_lex_state = 2},
  [3941] = {.lex_state = 157, .external_lex_state = 2},
  [3942] = {.lex_state = 157, .external_lex_state = 2},
  [3943] = {.lex_state = 197, .external_lex_state = 19},
  [3944] = {.lex_state = 164, .external_lex_state = 3},
  [3945] = {.lex_state = 157, .external_lex_state = 2},
  [3946] = {.lex_state = 157, .external_lex_state = 2},
  [3947] = {.lex_state = 157, .external_lex_state = 2},
  [3948] = {.lex_state = 164},
  [3949] = {.lex_state = 220, .external_lex_state = 9},
  [3950] = {.lex_state = 135, .external_lex_state = 2},
  [3951] = {.lex_state = 220, .external_lex_state = 9},
  [3952] = {.lex_state = 220, .external_lex_state = 9},
  [3953] = {.lex_state = 220, .external_lex_state = 9},
  [3954] = {.lex_state = 135, .external_lex_state = 13},
  [3955] = {.lex_state = 197, .external_lex_state = 5},
  [3956] = {.lex_state = 157},
  [3957] = {.lex_state = 223, .external_lex_state = 9},
  [3958] = {.lex_state = 208, .external_lex_state = 5},
  [3959] = {.lex_state = 197, .external_lex_state = 5},
  [3960] = {.lex_state = 197, .external_lex_state = 14},
  [3961] = {.lex_state = 135, .external_lex_state = 2},
  [3962] = {.lex_state = 135, .external_lex_state = 2},
  [3963] = {.lex_state = 217, .external_lex_state = 22},
  [3964] = {.lex_state = 135, .external_lex_state = 2},
  [3965] = {.lex_state = 197, .external_lex_state = 5},
  [3966] = {.lex_state = 135, .external_lex_state = 2},
  [3967] = {.lex_state = 135},
  [3968] = {.lex_state = 197, .external_lex_state = 5},
  [3969] = {.lex_state = 217, .external_lex_state = 4},
  [3970] = {.lex_state = 197, .external_lex_state = 5},
  [3971] = {.lex_state = 234, .external_lex_state = 15},
  [3972] = {.lex_state = 197, .external_lex_state = 5},
  [3973] = {.lex_state = 234, .external_lex_state = 15},
  [3974] = {.lex_state = 217, .external_lex_state = 4},
  [3975] = {.lex_state = 234, .external_lex_state = 15},
  [3976] = {.lex_state = 135, .external_lex_state = 2},
  [3977] = {.lex_state = 157, .external_lex_state = 8},
  [3978] = {.lex_state = 223, .external_lex_state = 9},
  [3979] = {.lex_state = 135},
  [3980] = {.lex_state = 300, .external_lex_state = 27},
  [3981] = {.lex_state = 217, .external_lex_state = 22},
  [3982] = {.lex_state = 223, .external_lex_state = 9},
  [3983] = {.lex_state = 300, .external_lex_state = 27},
  [3984] = {.lex_state = 208, .external_lex_state = 5},
  [3985] = {.lex_state = 197, .external_lex_state = 5},
  [3986] = {.lex_state = 197, .external_lex_state = 5},
  [3987] = {.lex_state = 197, .external_lex_state = 5},
  [3988] = {.lex_state = 157, .external_lex_state = 2},
  [3989] = {.lex_state = 157, .external_lex_state = 28},
  [3990] = {.lex_state = 157, .external_lex_state = 2},
  [3991] = {.lex_state = 157, .external_lex_state = 2},
  [3992] = {.lex_state = 157, .external_lex_state = 2},
  [3993] = {.lex_state = 157, .external_lex_state = 2},
  [3994] = {.lex_state = 157, .external_lex_state = 2},
  [3995] = {.lex_state = 157, .external_lex_state = 2},
  [3996] = {.lex_state = 157, .external_lex_state = 2},
  [3997] = {.lex_state = 157, .external_lex_state = 2},
  [3998] = {.lex_state = 157, .external_lex_state = 2},
  [3999] = {.lex_state = 157, .external_lex_state = 28},
  [4000] = {.lex_state = 197, .external_lex_state = 5},
  [4001] = {.lex_state = 135, .external_lex_state = 2},
  [4002] = {.lex_state = 135, .external_lex_state = 2},
  [4003] = {.lex_state = 135},
  [4004] = {.lex_state = 268, .external_lex_state = 5},
  [4005] = {.lex_state = 268, .external_lex_state = 5},
  [4006] = {.lex_state = 135, .external_lex_state = 15},
  [4007] = {.lex_state = 234, .external_lex_state = 15},
  [4008] = {.lex_state = 217, .external_lex_state = 4},
  [4009] = {.lex_state = 268, .external_lex_state = 5},
  [4010] = {.lex_state = 234, .external_lex_state = 15},
  [4011] = {.lex_state = 268, .external_lex_state = 5},
  [4012] = {.lex_state = 307, .external_lex_state = 5},
  [4013] = {.lex_state = 307, .external_lex_state = 14},
  [4014] = {.lex_state = 307, .external_lex_state = 5},
  [4015] = {.lex_state = 347, .external_lex_state = 9},
  [4016] = {.lex_state = 347, .external_lex_state = 9},
  [4017] = {.lex_state = 228},
  [4018] = {.lex_state = 157, .external_lex_state = 2},
  [4019] = {.lex_state = 157, .external_lex_state = 2},
  [4020] = {.lex_state = 157, .external_lex_state = 2},
  [4021] = {.lex_state = 307, .external_lex_state = 5},
  [4022] = {.lex_state = 307, .external_lex_state = 5},
  [4023] = {.lex_state = 307, .external_lex_state = 14},
  [4024] = {.lex_state = 307, .external_lex_state = 5},
  [4025] = {.lex_state = 208, .external_lex_state = 5},
  [4026] = {.lex_state = 215},
  [4027] = {.lex_state = 268, .external_lex_state = 5},
  [4028] = {.lex_state = 215},
  [4029] = {.lex_state = 300, .external_lex_state = 27},
  [4030] = {.lex_state = 164},
  [4031] = {.lex_state = 157, .external_lex_state = 28},
  [4032] = {.lex_state = 347, .external_lex_state = 9},
  [4033] = {.lex_state = 228},
  [4034] = {.lex_state = 157, .external_lex_state = 2},
  [4035] = {.lex_state = 157, .external_lex_state = 2},
  [4036] = {.lex_state = 157, .external_lex_state = 2},
  [4037] = {.lex_state = 350, .external_lex_state = 5},
  [4038] = {.lex_state = 350, .external_lex_state = 5},
  [4039] = {.lex_state = 350, .external_lex_state = 14},
  [4040] = {.lex_state = 350, .external_lex_state = 5},
  [4041] = {.lex_state = 157, .external_lex_state = 2},
  [4042] = {.lex_state = 157, .external_lex_state = 2},
  [4043] = {.lex_state = 157, .external_lex_state = 2},
  [4044] = {.lex_state = 157, .external_lex_state = 2},
  [4045] = {.lex_state = 157, .external_lex_state = 2},
  [4046] = {.lex_state = 157, .external_lex_state = 2},
  [4047] = {.lex_state = 157, .external_lex_state = 2},
  [4048] = {.lex_state = 157, .external_lex_state = 2},
  [4049] = {.lex_state = 157, .external_lex_state = 2},
  [4050] = {.lex_state = 157, .external_lex_state = 2},
  [4051] = {.lex_state = 157, .external_lex_state = 2},
  [4052] = {.lex_state = 307, .external_lex_state = 14},
  [4053] = {.lex_state = 208, .external_lex_state = 5},
  [4054] = {.lex_state = 135, .external_lex_state = 2},
  [4055] = {.lex_state = 268, .external_lex_state = 14},
  [4056] = {.lex_state = 135, .external_lex_state = 13},
  [4057] = {.lex_state = 208, .external_lex_state = 5},
  [4058] = {.lex_state = 135, .external_lex_state = 2},
  [4059] = {.lex_state = 135},
  [4060] = {.lex_state = 135, .external_lex_state = 10},
  [4061] = {.lex_state = 268, .external_lex_state = 5},
  [4062] = {.lex_state = 268, .external_lex_state = 5},
  [4063] = {.lex_state = 208, .external_lex_state = 5},
  [4064] = {.lex_state = 274, .external_lex_state = 20},
  [4065] = {.lex_state = 135, .external_lex_state = 2},
  [4066] = {.lex_state = 164, .external_lex_state = 3},
  [4067] = {.lex_state = 208, .external_lex_state = 5},
  [4068] = {.lex_state = 197, .external_lex_state = 5},
  [4069] = {.lex_state = 197, .external_lex_state = 5},
  [4070] = {.lex_state = 135},
  [4071] = {.lex_state = 208, .external_lex_state = 5},
  [4072] = {.lex_state = 182, .external_lex_state = 4},
  [4073] = {.lex_state = 234, .external_lex_state = 15},
  [4074] = {.lex_state = 208, .external_lex_state = 5},
  [4075] = {.lex_state = 135, .external_lex_state = 15},
  [4076] = {.lex_state = 208, .external_lex_state = 5},
  [4077] = {.lex_state = 135},
  [4078] = {.lex_state = 208, .external_lex_state = 5},
  [4079] = {.lex_state = 135, .external_lex_state = 13},
  [4080] = {.lex_state = 157, .external_lex_state = 2},
  [4081] = {.lex_state = 258, .external_lex_state = 25},
  [4082] = {.lex_state = 258, .external_lex_state = 25},
  [4083] = {.lex_state = 258, .external_lex_state = 25},
  [4084] = {.lex_state = 258, .external_lex_state = 25},
  [4085] = {.lex_state = 135},
  [4086] = {.lex_state = 135},
  [4087] = {.lex_state = 135, .external_lex_state = 2},
  [4088] = {.lex_state = 208, .external_lex_state = 5},
  [4089] = {.lex_state = 135},
  [4090] = {.lex_state = 135},
  [4091] = {.lex_state = 208, .external_lex_state = 5},
  [4092] = {.lex_state = 208, .external_lex_state = 5},
  [4093] = {.lex_state = 208, .external_lex_state = 5},
  [4094] = {.lex_state = 135, .external_lex_state = 15},
  [4095] = {.lex_state = 208, .external_lex_state = 5},
  [4096] = {.lex_state = 182, .external_lex_state = 4},
  [4097] = {.lex_state = 234, .external_lex_state = 15},
  [4098] = {.lex_state = 208, .external_lex_state = 5},
  [4099] = {.lex_state = 157},
  [4100] = {.lex_state = 208, .external_lex_state = 5},
  [4101] = {.lex_state = 215, .external_lex_state = 18},
  [4102] = {.lex_state = 215},
  [4103] = {.lex_state = 208, .external_lex_state = 5},
  [4104] = {.lex_state = 197, .external_lex_state = 5},
  [4105] = {.lex_state = 208, .external_lex_state = 5},
  [4106] = {.lex_state = 208, .external_lex_state = 5},
  [4107] = {.lex_state = 135},
  [4108] = {.lex_state = 208, .external_lex_state = 14},
  [4109] = {.lex_state = 135, .external_lex_state = 15},
  [4110] = {.lex_state = 208, .external_lex_state = 5},
  [4111] = {.lex_state = 135, .external_lex_state = 15},
  [4112] = {.lex_state = 208, .external_lex_state = 5},
  [4113] = {.lex_state = 135},
  [4114] = {.lex_state = 157, .external_lex_state = 2},
  [4115] = {.lex_state = 215, .external_lex_state = 13},
  [4116] = {.lex_state = 208, .external_lex_state = 5},
  [4117] = {.lex_state = 157},
  [4118] = {.lex_state = 208, .external_lex_state = 5},
  [4119] = {.lex_state = 135, .external_lex_state = 13},
  [4120] = {.lex_state = 157, .external_lex_state = 2},
  [4121] = {.lex_state = 157, .external_lex_state = 28},
  [4122] = {.lex_state = 157, .external_lex_state = 2},
  [4123] = {.lex_state = 157, .external_lex_state = 2},
  [4124] = {.lex_state = 157, .external_lex_state = 2},
  [4125] = {.lex_state = 157, .external_lex_state = 2},
  [4126] = {.lex_state = 157, .external_lex_state = 2},
  [4127] = {.lex_state = 157, .external_lex_state = 2},
  [4128] = {.lex_state = 157, .external_lex_state = 2},
  [4129] = {.lex_state = 157, .external_lex_state = 2},
  [4130] = {.lex_state = 157, .external_lex_state = 2},
  [4131] = {.lex_state = 232, .external_lex_state = 7},
  [4132] = {.lex_state = 208, .external_lex_state = 14},
  [4133] = {.lex_state = 268, .external_lex_state = 5},
  [4134] = {.lex_state = 135},
  [4135] = {.lex_state = 268, .external_lex_state = 5},
  [4136] = {.lex_state = 135},
  [4137] = {.lex_state = 135},
  [4138] = {.lex_state = 135},
  [4139] = {.lex_state = 208, .external_lex_state = 5},
  [4140] = {.lex_state = 268, .external_lex_state = 5},
  [4141] = {.lex_state = 197, .external_lex_state = 5},
  [4142] = {.lex_state = 135, .external_lex_state = 2},
  [4143] = {.lex_state = 135, .external_lex_state = 13},
  [4144] = {.lex_state = 268, .external_lex_state = 5},
  [4145] = {.lex_state = 268, .external_lex_state = 5},
  [4146] = {.lex_state = 135, .external_lex_state = 2},
  [4147] = {.lex_state = 268, .external_lex_state = 5},
  [4148] = {.lex_state = 135},
  [4149] = {.lex_state = 135},
  [4150] = {.lex_state = 268, .external_lex_state = 5},
  [4151] = {.lex_state = 135},
  [4152] = {.lex_state = 268, .external_lex_state = 5},
  [4153] = {.lex_state = 135, .external_lex_state = 2},
  [4154] = {.lex_state = 135},
  [4155] = {.lex_state = 268, .external_lex_state = 5},
  [4156] = {.lex_state = 135, .external_lex_state = 15},
  [4157] = {.lex_state = 234, .external_lex_state = 15},
  [4158] = {.lex_state = 217, .external_lex_state = 4},
  [4159] = {.lex_state = 268, .external_lex_state = 5},
  [4160] = {.lex_state = 234, .external_lex_state = 15},
  [4161] = {.lex_state = 208, .external_lex_state = 5},
  [4162] = {.lex_state = 268, .external_lex_state = 5},
  [4163] = {.lex_state = 268, .external_lex_state = 5},
  [4164] = {.lex_state = 268, .external_lex_state = 5},
  [4165] = {.lex_state = 208, .external_lex_state = 5},
  [4166] = {.lex_state = 217, .external_lex_state = 22},
  [4167] = {.lex_state = 208, .external_lex_state = 5},
  [4168] = {.lex_state = 157, .external_lex_state = 6},
  [4169] = {.lex_state = 208, .external_lex_state = 5},
  [4170] = {.lex_state = 208, .external_lex_state = 5},
  [4171] = {.lex_state = 208, .external_lex_state = 5},
  [4172] = {.lex_state = 268, .external_lex_state = 5},
  [4173] = {.lex_state = 268, .external_lex_state = 5},
  [4174] = {.lex_state = 268, .external_lex_state = 5},
  [4175] = {.lex_state = 359, .external_lex_state = 20},
  [4176] = {.lex_state = 268, .external_lex_state = 5},
  [4177] = {.lex_state = 268, .external_lex_state = 5},
  [4178] = {.lex_state = 268, .external_lex_state = 5},
  [4179] = {.lex_state = 268, .external_lex_state = 5},
  [4180] = {.lex_state = 268, .external_lex_state = 5},
  [4181] = {.lex_state = 268, .external_lex_state = 5},
  [4182] = {.lex_state = 268, .external_lex_state = 5},
  [4183] = {.lex_state = 268, .external_lex_state = 14},
  [4184] = {.lex_state = 157, .external_lex_state = 2},
  [4185] = {.lex_state = 157, .external_lex_state = 2},
  [4186] = {.lex_state = 375, .external_lex_state = 17},
  [4187] = {.lex_state = 157, .external_lex_state = 2},
  [4188] = {.lex_state = 164},
  [4189] = {.lex_state = 228},
  [4190] = {.lex_state = 353, .external_lex_state = 17},
  [4191] = {.lex_state = 157, .external_lex_state = 2},
  [4192] = {.lex_state = 157, .external_lex_state = 2},
  [4193] = {.lex_state = 353, .external_lex_state = 17},
  [4194] = {.lex_state = 353, .external_lex_state = 17},
  [4195] = {.lex_state = 157, .external_lex_state = 2},
  [4196] = {.lex_state = 353, .external_lex_state = 17},
  [4197] = {.lex_state = 363, .external_lex_state = 16},
  [4198] = {.lex_state = 378, .external_lex_state = 16},
  [4199] = {.lex_state = 363, .external_lex_state = 16},
  [4200] = {.lex_state = 363, .external_lex_state = 16},
  [4201] = {.lex_state = 381, .external_lex_state = 17},
  [4202] = {.lex_state = 157},
  [4203] = {.lex_state = 382, .external_lex_state = 19},
  [4204] = {.lex_state = 363, .external_lex_state = 16},
  [4205] = {.lex_state = 359, .external_lex_state = 20},
  [4206] = {.lex_state = 359, .external_lex_state = 20},
  [4207] = {.lex_state = 366, .external_lex_state = 21},
  [4208] = {.lex_state = 157, .external_lex_state = 2},
  [4209] = {.lex_state = 157, .external_lex_state = 28},
  [4210] = {.lex_state = 157, .external_lex_state = 2},
  [4211] = {.lex_state = 157, .external_lex_state = 2},
  [4212] = {.lex_state = 157, .external_lex_state = 2},
  [4213] = {.lex_state = 157, .external_lex_state = 2},
  [4214] = {.lex_state = 157, .external_lex_state = 2},
  [4215] = {.lex_state = 157, .external_lex_state = 2},
  [4216] = {.lex_state = 157, .external_lex_state = 2},
  [4217] = {.lex_state = 157, .external_lex_state = 2},
  [4218] = {.lex_state = 157, .external_lex_state = 2},
  [4219] = {.lex_state = 157, .external_lex_state = 2},
  [4220] = {.lex_state = 157, .external_lex_state = 2},
  [4221] = {.lex_state = 300, .external_lex_state = 27},
  [4222] = {.lex_state = 164},
  [4223] = {.lex_state = 157, .external_lex_state = 2},
  [4224] = {.lex_state = 157, .external_lex_state = 2},
  [4225] = {.lex_state = 375, .external_lex_state = 17},
  [4226] = {.lex_state = 157, .external_lex_state = 2},
  [4227] = {.lex_state = 228},
  [4228] = {.lex_state = 381, .external_lex_state = 17},
  [4229] = {.lex_state = 157, .external_lex_state = 2},
  [4230] = {.lex_state = 157, .external_lex_state = 2},
  [4231] = {.lex_state = 381, .external_lex_state = 17},
  [4232] = {.lex_state = 381, .external_lex_state = 17},
  [4233] = {.lex_state = 157, .external_lex_state = 2},
  [4234] = {.lex_state = 381, .external_lex_state = 17},
  [4235] = {.lex_state = 378, .external_lex_state = 16},
  [4236] = {.lex_state = 157},
  [4237] = {.lex_state = 381, .external_lex_state = 17},
  [4238] = {.lex_state = 356, .external_lex_state = 16},
  [4239] = {.lex_state = 378, .external_lex_state = 16},
  [4240] = {.lex_state = 378, .external_lex_state = 16},
  [4241] = {.lex_state = 383, .external_lex_state = 19},
  [4242] = {.lex_state = 356, .external_lex_state = 16},
  [4243] = {.lex_state = 363, .external_lex_state = 23},
  [4244] = {.lex_state = 135},
  [4245] = {.lex_state = 197, .external_lex_state = 13},
  [4246] = {.lex_state = 197, .external_lex_state = 5},
  [4247] = {.lex_state = 197, .external_lex_state = 5},
  [4248] = {.lex_state = 223, .external_lex_state = 9},
  [4249] = {.lex_state = 157, .external_lex_state = 2},
  [4250] = {.lex_state = 157, .external_lex_state = 2},
  [4251] = {.lex_state = 271, .external_lex_state = 9},
  [4252] = {.lex_state = 157, .external_lex_state = 2},
  [4253] = {.lex_state = 164},
  [4254] = {.lex_state = 228},
  [4255] = {.lex_state = 220, .external_lex_state = 9},
  [4256] = {.lex_state = 157, .external_lex_state = 2},
  [4257] = {.lex_state = 157, .external_lex_state = 2},
  [4258] = {.lex_state = 220, .external_lex_state = 9},
  [4259] = {.lex_state = 220, .external_lex_state = 9},
  [4260] = {.lex_state = 157, .external_lex_state = 2},
  [4261] = {.lex_state = 220, .external_lex_state = 9},
  [4262] = {.lex_state = 197, .external_lex_state = 5},
  [4263] = {.lex_state = 268, .external_lex_state = 5},
  [4264] = {.lex_state = 197, .external_lex_state = 5},
  [4265] = {.lex_state = 197, .external_lex_state = 5},
  [4266] = {.lex_state = 271, .external_lex_state = 9},
  [4267] = {.lex_state = 157},
  [4268] = {.lex_state = 197, .external_lex_state = 14},
  [4269] = {.lex_state = 197, .external_lex_state = 5},
  [4270] = {.lex_state = 157, .external_lex_state = 2},
  [4271] = {.lex_state = 157, .external_lex_state = 2},
  [4272] = {.lex_state = 157, .external_lex_state = 2},
  [4273] = {.lex_state = 157, .external_lex_state = 2},
  [4274] = {.lex_state = 157, .external_lex_state = 2},
  [4275] = {.lex_state = 300, .external_lex_state = 27},
  [4276] = {.lex_state = 164},
  [4277] = {.lex_state = 157, .external_lex_state = 28},
  [4278] = {.lex_state = 157, .external_lex_state = 2},
  [4279] = {.lex_state = 157, .external_lex_state = 2},
  [4280] = {.lex_state = 271, .external_lex_state = 9},
  [4281] = {.lex_state = 157, .external_lex_state = 2},
  [4282] = {.lex_state = 228},
  [4283] = {.lex_state = 271, .external_lex_state = 9},
  [4284] = {.lex_state = 157, .external_lex_state = 2},
  [4285] = {.lex_state = 157, .external_lex_state = 2},
  [4286] = {.lex_state = 271, .external_lex_state = 9},
  [4287] = {.lex_state = 271, .external_lex_state = 9},
  [4288] = {.lex_state = 157, .external_lex_state = 2},
  [4289] = {.lex_state = 271, .external_lex_state = 9},
  [4290] = {.lex_state = 268, .external_lex_state = 5},
  [4291] = {.lex_state = 157},
  [4292] = {.lex_state = 271, .external_lex_state = 9},
  [4293] = {.lex_state = 208, .external_lex_state = 5},
  [4294] = {.lex_state = 268, .external_lex_state = 5},
  [4295] = {.lex_state = 268, .external_lex_state = 5},
  [4296] = {.lex_state = 268, .external_lex_state = 14},
  [4297] = {.lex_state = 208, .external_lex_state = 5},
  [4298] = {.lex_state = 157, .external_lex_state = 2},
  [4299] = {.lex_state = 157, .external_lex_state = 2},
  [4300] = {.lex_state = 157, .external_lex_state = 2},
  [4301] = {.lex_state = 157, .external_lex_state = 2},
  [4302] = {.lex_state = 157, .external_lex_state = 2},
  [4303] = {.lex_state = 157, .external_lex_state = 2},
  [4304] = {.lex_state = 157, .external_lex_state = 2},
  [4305] = {.lex_state = 157, .external_lex_state = 2},
  [4306] = {.lex_state = 157, .external_lex_state = 2},
  [4307] = {.lex_state = 157, .external_lex_state = 2},
  [4308] = {.lex_state = 157, .external_lex_state = 2},
  [4309] = {.lex_state = 197, .external_lex_state = 14},
  [4310] = {.lex_state = 197, .external_lex_state = 5},
  [4311] = {.lex_state = 197, .external_lex_state = 5},
  [4312] = {.lex_state = 157, .external_lex_state = 2},
  [4313] = {.lex_state = 157, .external_lex_state = 2},
  [4314] = {.lex_state = 197, .external_lex_state = 5},
  [4315] = {.lex_state = 197, .external_lex_state = 5},
  [4316] = {.lex_state = 197, .external_lex_state = 5},
  [4317] = {.lex_state = 157, .external_lex_state = 29},
  [4318] = {.lex_state = 197, .external_lex_state = 5},
  [4319] = {.lex_state = 197, .external_lex_state = 5},
  [4320] = {.lex_state = 197, .external_lex_state = 5},
  [4321] = {.lex_state = 197, .external_lex_state = 5},
  [4322] = {.lex_state = 197, .external_lex_state = 5},
  [4323] = {.lex_state = 197, .external_lex_state = 5},
  [4324] = {.lex_state = 157, .external_lex_state = 2},
  [4325] = {.lex_state = 157, .external_lex_state = 28},
  [4326] = {.lex_state = 157, .external_lex_state = 2},
  [4327] = {.lex_state = 157, .external_lex_state = 2},
  [4328] = {.lex_state = 157, .external_lex_state = 2},
  [4329] = {.lex_state = 157, .external_lex_state = 2},
  [4330] = {.lex_state = 157, .external_lex_state = 2},
  [4331] = {.lex_state = 157, .external_lex_state = 2},
  [4332] = {.lex_state = 157, .external_lex_state = 2},
  [4333] = {.lex_state = 157, .external_lex_state = 2},
  [4334] = {.lex_state = 157, .external_lex_state = 2},
  [4335] = {.lex_state = 197, .external_lex_state = 14},
  [4336] = {.lex_state = 157, .external_lex_state = 6},
  [4337] = {.lex_state = 197, .external_lex_state = 5},
  [4338] = {.lex_state = 197, .external_lex_state = 5},
  [4339] = {.lex_state = 197, .external_lex_state = 5},
  [4340] = {.lex_state = 197, .external_lex_state = 5},
  [4341] = {.lex_state = 197, .external_lex_state = 5},
  [4342] = {.lex_state = 197, .external_lex_state = 5},
  [4343] = {.lex_state = 197, .external_lex_state = 5},
  [4344] = {.lex_state = 197, .external_lex_state = 5},
  [4345] = {.lex_state = 359, .external_lex_state = 20},
  [4346] = {.lex_state = 197, .external_lex_state = 5},
  [4347] = {.lex_state = 197, .external_lex_state = 5},
  [4348] = {.lex_state = 197, .external_lex_state = 5},
  [4349] = {.lex_state = 197, .external_lex_state = 5},
  [4350] = {.lex_state = 197, .external_lex_state = 5},
  [4351] = {.lex_state = 197, .external_lex_state = 5},
  [4352] = {.lex_state = 197, .external_lex_state = 5},
  [4353] = {.lex_state = 271, .external_lex_state = 9},
  [4354] = {.lex_state = 266, .external_lex_state = 6},
  [4355] = {.lex_state = 271, .external_lex_state = 9},
  [4356] = {.lex_state = 271, .external_lex_state = 9},
  [4357] = {.lex_state = 300, .external_lex_state = 27},
  [4358] = {.lex_state = 271, .external_lex_state = 9},
  [4359] = {.lex_state = 268, .external_lex_state = 5},
  [4360] = {.lex_state = 157, .external_lex_state = 2},
  [4361] = {.lex_state = 157, .external_lex_state = 2},
  [4362] = {.lex_state = 268, .external_lex_state = 5},
  [4363] = {.lex_state = 268, .external_lex_state = 5},
  [4364] = {.lex_state = 268, .external_lex_state = 5},
  [4365] = {.lex_state = 157, .external_lex_state = 29},
  [4366] = {.lex_state = 268, .external_lex_state = 5},
  [4367] = {.lex_state = 268, .external_lex_state = 5},
  [4368] = {.lex_state = 197, .external_lex_state = 14},
  [4369] = {.lex_state = 197, .external_lex_state = 5},
  [4370] = {.lex_state = 197, .external_lex_state = 5},
  [4371] = {.lex_state = 197, .external_lex_state = 5},
  [4372] = {.lex_state = 157, .external_lex_state = 2},
  [4373] = {.lex_state = 157, .external_lex_state = 28},
  [4374] = {.lex_state = 157, .external_lex_state = 2},
  [4375] = {.lex_state = 157, .external_lex_state = 2},
  [4376] = {.lex_state = 157, .external_lex_state = 2},
  [4377] = {.lex_state = 157, .external_lex_state = 2},
  [4378] = {.lex_state = 157, .external_lex_state = 2},
  [4379] = {.lex_state = 157, .external_lex_state = 2},
  [4380] = {.lex_state = 157, .external_lex_state = 2},
  [4381] = {.lex_state = 157, .external_lex_state = 2},
  [4382] = {.lex_state = 157, .external_lex_state = 2},
  [4383] = {.lex_state = 157, .external_lex_state = 28},
  [4384] = {.lex_state = 197, .external_lex_state = 5},
  [4385] = {.lex_state = 157, .external_lex_state = 2},
  [4386] = {.lex_state = 135, .external_lex_state = 2},
  [4387] = {.lex_state = 197, .external_lex_state = 5},
  [4388] = {.lex_state = 223, .external_lex_state = 9},
  [4389] = {.lex_state = 135},
  [4390] = {.lex_state = 223, .external_lex_state = 9},
  [4391] = {.lex_state = 208, .external_lex_state = 5},
  [4392] = {.lex_state = 208, .external_lex_state = 5},
  [4393] = {.lex_state = 208, .external_lex_state = 5},
  [4394] = {.lex_state = 208, .external_lex_state = 5},
  [4395] = {.lex_state = 157, .external_lex_state = 2},
  [4396] = {.lex_state = 157, .external_lex_state = 28},
  [4397] = {.lex_state = 157, .external_lex_state = 2},
  [4398] = {.lex_state = 157, .external_lex_state = 2},
  [4399] = {.lex_state = 157, .external_lex_state = 2},
  [4400] = {.lex_state = 157, .external_lex_state = 2},
  [4401] = {.lex_state = 157, .external_lex_state = 2},
  [4402] = {.lex_state = 157, .external_lex_state = 2},
  [4403] = {.lex_state = 157, .external_lex_state = 2},
  [4404] = {.lex_state = 157, .external_lex_state = 2},
  [4405] = {.lex_state = 157, .external_lex_state = 2},
  [4406] = {.lex_state = 208, .external_lex_state = 14},
  [4407] = {.lex_state = 268, .external_lex_state = 5},
  [4408] = {.lex_state = 268, .external_lex_state = 5},
  [4409] = {.lex_state = 157, .external_lex_state = 6},
  [4410] = {.lex_state = 208, .external_lex_state = 5},
  [4411] = {.lex_state = 208, .external_lex_state = 5},
  [4412] = {.lex_state = 208, .external_lex_state = 5},
  [4413] = {.lex_state = 268, .external_lex_state = 5},
  [4414] = {.lex_state = 268, .external_lex_state = 5},
  [4415] = {.lex_state = 268, .external_lex_state = 5},
  [4416] = {.lex_state = 359, .external_lex_state = 20},
  [4417] = {.lex_state = 268, .external_lex_state = 5},
  [4418] = {.lex_state = 268, .external_lex_state = 5},
  [4419] = {.lex_state = 268, .external_lex_state = 5},
  [4420] = {.lex_state = 268, .external_lex_state = 5},
  [4421] = {.lex_state = 268, .external_lex_state = 5},
  [4422] = {.lex_state = 268, .external_lex_state = 5},
  [4423] = {.lex_state = 268, .external_lex_state = 5},
  [4424] = {.lex_state = 268, .external_lex_state = 14},
  [4425] = {.lex_state = 215, .external_lex_state = 13},
  [4426] = {.lex_state = 307, .external_lex_state = 5},
  [4427] = {.lex_state = 307, .external_lex_state = 14},
  [4428] = {.lex_state = 157, .external_lex_state = 2},
  [4429] = {.lex_state = 307, .external_lex_state = 5},
  [4430] = {.lex_state = 157, .external_lex_state = 2},
  [4431] = {.lex_state = 307, .external_lex_state = 5},
  [4432] = {.lex_state = 307, .external_lex_state = 5},
  [4433] = {.lex_state = 304, .external_lex_state = 9},
  [4434] = {.lex_state = 304, .external_lex_state = 9},
  [4435] = {.lex_state = 157, .external_lex_state = 2},
  [4436] = {.lex_state = 157, .external_lex_state = 2},
  [4437] = {.lex_state = 304, .external_lex_state = 9},
  [4438] = {.lex_state = 157, .external_lex_state = 2},
  [4439] = {.lex_state = 304, .external_lex_state = 9},
  [4440] = {.lex_state = 313, .external_lex_state = 5},
  [4441] = {.lex_state = 307, .external_lex_state = 5},
  [4442] = {.lex_state = 157},
  [4443] = {.lex_state = 307, .external_lex_state = 14},
  [4444] = {.lex_state = 307, .external_lex_state = 5},
  [4445] = {.lex_state = 307, .external_lex_state = 5},
  [4446] = {.lex_state = 157, .external_lex_state = 29},
  [4447] = {.lex_state = 307, .external_lex_state = 5},
  [4448] = {.lex_state = 307, .external_lex_state = 5},
  [4449] = {.lex_state = 157, .external_lex_state = 2},
  [4450] = {.lex_state = 157, .external_lex_state = 28},
  [4451] = {.lex_state = 157, .external_lex_state = 2},
  [4452] = {.lex_state = 157, .external_lex_state = 2},
  [4453] = {.lex_state = 157, .external_lex_state = 2},
  [4454] = {.lex_state = 157, .external_lex_state = 2},
  [4455] = {.lex_state = 157, .external_lex_state = 2},
  [4456] = {.lex_state = 157, .external_lex_state = 2},
  [4457] = {.lex_state = 157, .external_lex_state = 2},
  [4458] = {.lex_state = 157, .external_lex_state = 2},
  [4459] = {.lex_state = 157, .external_lex_state = 2},
  [4460] = {.lex_state = 307, .external_lex_state = 14},
  [4461] = {.lex_state = 307, .external_lex_state = 5},
  [4462] = {.lex_state = 307, .external_lex_state = 5},
  [4463] = {.lex_state = 307, .external_lex_state = 5},
  [4464] = {.lex_state = 232, .external_lex_state = 2},
  [4465] = {.lex_state = 217, .external_lex_state = 22},
  [4466] = {.lex_state = 307, .external_lex_state = 5},
  [4467] = {.lex_state = 307, .external_lex_state = 5},
  [4468] = {.lex_state = 310, .external_lex_state = 9},
  [4469] = {.lex_state = 266, .external_lex_state = 6},
  [4470] = {.lex_state = 310, .external_lex_state = 9},
  [4471] = {.lex_state = 310, .external_lex_state = 9},
  [4472] = {.lex_state = 300, .external_lex_state = 27},
  [4473] = {.lex_state = 310, .external_lex_state = 9},
  [4474] = {.lex_state = 157, .external_lex_state = 2},
  [4475] = {.lex_state = 157, .external_lex_state = 2},
  [4476] = {.lex_state = 157, .external_lex_state = 2},
  [4477] = {.lex_state = 157, .external_lex_state = 2},
  [4478] = {.lex_state = 313, .external_lex_state = 5},
  [4479] = {.lex_state = 307, .external_lex_state = 5},
  [4480] = {.lex_state = 157},
  [4481] = {.lex_state = 307, .external_lex_state = 5},
  [4482] = {.lex_state = 350, .external_lex_state = 5},
  [4483] = {.lex_state = 350, .external_lex_state = 14},
  [4484] = {.lex_state = 157, .external_lex_state = 2},
  [4485] = {.lex_state = 350, .external_lex_state = 5},
  [4486] = {.lex_state = 157, .external_lex_state = 2},
  [4487] = {.lex_state = 310, .external_lex_state = 9},
  [4488] = {.lex_state = 310, .external_lex_state = 9},
  [4489] = {.lex_state = 157, .external_lex_state = 2},
  [4490] = {.lex_state = 157, .external_lex_state = 2},
  [4491] = {.lex_state = 310, .external_lex_state = 9},
  [4492] = {.lex_state = 157, .external_lex_state = 2},
  [4493] = {.lex_state = 310, .external_lex_state = 9},
  [4494] = {.lex_state = 313, .external_lex_state = 5},
  [4495] = {.lex_state = 313, .external_lex_state = 5},
  [4496] = {.lex_state = 313, .external_lex_state = 5},
  [4497] = {.lex_state = 310, .external_lex_state = 9},
  [4498] = {.lex_state = 157},
  [4499] = {.lex_state = 313, .external_lex_state = 14},
  [4500] = {.lex_state = 313, .external_lex_state = 5},
  [4501] = {.lex_state = 313, .external_lex_state = 5},
  [4502] = {.lex_state = 157, .external_lex_state = 28},
  [4503] = {.lex_state = 157, .external_lex_state = 29},
  [4504] = {.lex_state = 313, .external_lex_state = 5},
  [4505] = {.lex_state = 313, .external_lex_state = 5},
  [4506] = {.lex_state = 157, .external_lex_state = 2},
  [4507] = {.lex_state = 157, .external_lex_state = 2},
  [4508] = {.lex_state = 157, .external_lex_state = 2},
  [4509] = {.lex_state = 157, .external_lex_state = 2},
  [4510] = {.lex_state = 157, .external_lex_state = 2},
  [4511] = {.lex_state = 157, .external_lex_state = 2},
  [4512] = {.lex_state = 157, .external_lex_state = 2},
  [4513] = {.lex_state = 157, .external_lex_state = 2},
  [4514] = {.lex_state = 157, .external_lex_state = 2},
  [4515] = {.lex_state = 157, .external_lex_state = 2},
  [4516] = {.lex_state = 350, .external_lex_state = 14},
  [4517] = {.lex_state = 307, .external_lex_state = 5},
  [4518] = {.lex_state = 307, .external_lex_state = 5},
  [4519] = {.lex_state = 307, .external_lex_state = 5},
  [4520] = {.lex_state = 307, .external_lex_state = 5},
  [4521] = {.lex_state = 307, .external_lex_state = 5},
  [4522] = {.lex_state = 359, .external_lex_state = 20},
  [4523] = {.lex_state = 307, .external_lex_state = 5},
  [4524] = {.lex_state = 307, .external_lex_state = 5},
  [4525] = {.lex_state = 307, .external_lex_state = 5},
  [4526] = {.lex_state = 307, .external_lex_state = 5},
  [4527] = {.lex_state = 307, .external_lex_state = 5},
  [4528] = {.lex_state = 307, .external_lex_state = 14},
  [4529] = {.lex_state = 135, .external_lex_state = 13},
  [4530] = {.lex_state = 197, .external_lex_state = 13},
  [4531] = {.lex_state = 197, .external_lex_state = 5},
  [4532] = {.lex_state = 197, .external_lex_state = 5},
  [4533] = {.lex_state = 157, .external_lex_state = 2},
  [4534] = {.lex_state = 157, .external_lex_state = 2},
  [4535] = {.lex_state = 197, .external_lex_state = 5},
  [4536] = {.lex_state = 197, .external_lex_state = 5},
  [4537] = {.lex_state = 197, .external_lex_state = 5},
  [4538] = {.lex_state = 157, .external_lex_state = 29},
  [4539] = {.lex_state = 197, .external_lex_state = 5},
  [4540] = {.lex_state = 197, .external_lex_state = 5},
  [4541] = {.lex_state = 197, .external_lex_state = 5},
  [4542] = {.lex_state = 197, .external_lex_state = 5},
  [4543] = {.lex_state = 197, .external_lex_state = 5},
  [4544] = {.lex_state = 197, .external_lex_state = 5},
  [4545] = {.lex_state = 157, .external_lex_state = 2},
  [4546] = {.lex_state = 157, .external_lex_state = 28},
  [4547] = {.lex_state = 157, .external_lex_state = 2},
  [4548] = {.lex_state = 157, .external_lex_state = 2},
  [4549] = {.lex_state = 157, .external_lex_state = 2},
  [4550] = {.lex_state = 157, .external_lex_state = 2},
  [4551] = {.lex_state = 157, .external_lex_state = 2},
  [4552] = {.lex_state = 157, .external_lex_state = 2},
  [4553] = {.lex_state = 157, .external_lex_state = 2},
  [4554] = {.lex_state = 157, .external_lex_state = 2},
  [4555] = {.lex_state = 157, .external_lex_state = 2},
  [4556] = {.lex_state = 197, .external_lex_state = 14},
  [4557] = {.lex_state = 157, .external_lex_state = 6},
  [4558] = {.lex_state = 197, .external_lex_state = 5},
  [4559] = {.lex_state = 197, .external_lex_state = 5},
  [4560] = {.lex_state = 197, .external_lex_state = 5},
  [4561] = {.lex_state = 197, .external_lex_state = 5},
  [4562] = {.lex_state = 197, .external_lex_state = 5},
  [4563] = {.lex_state = 197, .external_lex_state = 5},
  [4564] = {.lex_state = 197, .external_lex_state = 5},
  [4565] = {.lex_state = 197, .external_lex_state = 5},
  [4566] = {.lex_state = 359, .external_lex_state = 20},
  [4567] = {.lex_state = 197, .external_lex_state = 5},
  [4568] = {.lex_state = 197, .external_lex_state = 5},
  [4569] = {.lex_state = 197, .external_lex_state = 5},
  [4570] = {.lex_state = 197, .external_lex_state = 5},
  [4571] = {.lex_state = 197, .external_lex_state = 5},
  [4572] = {.lex_state = 197, .external_lex_state = 5},
  [4573] = {.lex_state = 197, .external_lex_state = 5},
  [4574] = {.lex_state = 271, .external_lex_state = 9},
  [4575] = {.lex_state = 266, .external_lex_state = 6},
  [4576] = {.lex_state = 271, .external_lex_state = 9},
  [4577] = {.lex_state = 271, .external_lex_state = 9},
  [4578] = {.lex_state = 300, .external_lex_state = 27},
  [4579] = {.lex_state = 271, .external_lex_state = 9},
  [4580] = {.lex_state = 157, .external_lex_state = 2},
  [4581] = {.lex_state = 157, .external_lex_state = 2},
  [4582] = {.lex_state = 268, .external_lex_state = 5},
  [4583] = {.lex_state = 268, .external_lex_state = 5},
  [4584] = {.lex_state = 268, .external_lex_state = 5},
  [4585] = {.lex_state = 157, .external_lex_state = 29},
  [4586] = {.lex_state = 268, .external_lex_state = 5},
  [4587] = {.lex_state = 268, .external_lex_state = 5},
  [4588] = {.lex_state = 197, .external_lex_state = 14},
  [4589] = {.lex_state = 197, .external_lex_state = 13},
  [4590] = {.lex_state = 197, .external_lex_state = 5},
  [4591] = {.lex_state = 197, .external_lex_state = 5},
  [4592] = {.lex_state = 223, .external_lex_state = 9},
  [4593] = {.lex_state = 157, .external_lex_state = 2},
  [4594] = {.lex_state = 157, .external_lex_state = 2},
  [4595] = {.lex_state = 271, .external_lex_state = 9},
  [4596] = {.lex_state = 157, .external_lex_state = 2},
  [4597] = {.lex_state = 164},
  [4598] = {.lex_state = 228},
  [4599] = {.lex_state = 220, .external_lex_state = 9},
  [4600] = {.lex_state = 157, .external_lex_state = 2},
  [4601] = {.lex_state = 157, .external_lex_state = 2},
  [4602] = {.lex_state = 220, .external_lex_state = 9},
  [4603] = {.lex_state = 220, .external_lex_state = 9},
  [4604] = {.lex_state = 157, .external_lex_state = 2},
  [4605] = {.lex_state = 220, .external_lex_state = 9},
  [4606] = {.lex_state = 197, .external_lex_state = 5},
  [4607] = {.lex_state = 268, .external_lex_state = 5},
  [4608] = {.lex_state = 197, .external_lex_state = 5},
  [4609] = {.lex_state = 197, .external_lex_state = 5},
  [4610] = {.lex_state = 271, .external_lex_state = 9},
  [4611] = {.lex_state = 157},
  [4612] = {.lex_state = 197, .external_lex_state = 14},
  [4613] = {.lex_state = 197, .external_lex_state = 5},
  [4614] = {.lex_state = 157, .external_lex_state = 2},
  [4615] = {.lex_state = 157, .external_lex_state = 2},
  [4616] = {.lex_state = 157, .external_lex_state = 2},
  [4617] = {.lex_state = 217, .external_lex_state = 22},
  [4618] = {.lex_state = 157, .external_lex_state = 2},
  [4619] = {.lex_state = 157, .external_lex_state = 2},
  [4620] = {.lex_state = 135, .external_lex_state = 2},
  [4621] = {.lex_state = 300, .external_lex_state = 27},
  [4622] = {.lex_state = 164},
  [4623] = {.lex_state = 157, .external_lex_state = 28},
  [4624] = {.lex_state = 157, .external_lex_state = 2},
  [4625] = {.lex_state = 157, .external_lex_state = 2},
  [4626] = {.lex_state = 271, .external_lex_state = 9},
  [4627] = {.lex_state = 157, .external_lex_state = 2},
  [4628] = {.lex_state = 228},
  [4629] = {.lex_state = 271, .external_lex_state = 9},
  [4630] = {.lex_state = 157, .external_lex_state = 2},
  [4631] = {.lex_state = 157, .external_lex_state = 2},
  [4632] = {.lex_state = 271, .external_lex_state = 9},
  [4633] = {.lex_state = 271, .external_lex_state = 9},
  [4634] = {.lex_state = 157, .external_lex_state = 2},
  [4635] = {.lex_state = 271, .external_lex_state = 9},
  [4636] = {.lex_state = 268, .external_lex_state = 5},
  [4637] = {.lex_state = 157},
  [4638] = {.lex_state = 271, .external_lex_state = 9},
  [4639] = {.lex_state = 208, .external_lex_state = 5},
  [4640] = {.lex_state = 268, .external_lex_state = 5},
  [4641] = {.lex_state = 268, .external_lex_state = 5},
  [4642] = {.lex_state = 268, .external_lex_state = 14},
  [4643] = {.lex_state = 208, .external_lex_state = 5},
  [4644] = {.lex_state = 157, .external_lex_state = 2},
  [4645] = {.lex_state = 157, .external_lex_state = 2},
  [4646] = {.lex_state = 157, .external_lex_state = 2},
  [4647] = {.lex_state = 157, .external_lex_state = 2},
  [4648] = {.lex_state = 157, .external_lex_state = 2},
  [4649] = {.lex_state = 157, .external_lex_state = 2},
  [4650] = {.lex_state = 157, .external_lex_state = 2},
  [4651] = {.lex_state = 157, .external_lex_state = 2},
  [4652] = {.lex_state = 157, .external_lex_state = 2},
  [4653] = {.lex_state = 157, .external_lex_state = 2},
  [4654] = {.lex_state = 157, .external_lex_state = 2},
  [4655] = {.lex_state = 197, .external_lex_state = 14},
  [4656] = {.lex_state = 135, .external_lex_state = 13},
  [4657] = {.lex_state = 135, .external_lex_state = 2},
  [4658] = {.lex_state = 135, .external_lex_state = 2},
  [4659] = {.lex_state = 135},
  [4660] = {.lex_state = 197, .external_lex_state = 5},
  [4661] = {.lex_state = 223, .external_lex_state = 9},
  [4662] = {.lex_state = 135},
  [4663] = {.lex_state = 223, .external_lex_state = 9},
  [4664] = {.lex_state = 197, .external_lex_state = 5},
  [4665] = {.lex_state = 197, .external_lex_state = 5},
  [4666] = {.lex_state = 197, .external_lex_state = 5},
  [4667] = {.lex_state = 157, .external_lex_state = 2},
  [4668] = {.lex_state = 157, .external_lex_state = 28},
  [4669] = {.lex_state = 157, .external_lex_state = 2},
  [4670] = {.lex_state = 157, .external_lex_state = 2},
  [4671] = {.lex_state = 157, .external_lex_state = 2},
  [4672] = {.lex_state = 157, .external_lex_state = 2},
  [4673] = {.lex_state = 157, .external_lex_state = 2},
  [4674] = {.lex_state = 157, .external_lex_state = 2},
  [4675] = {.lex_state = 157, .external_lex_state = 2},
  [4676] = {.lex_state = 157, .external_lex_state = 2},
  [4677] = {.lex_state = 157, .external_lex_state = 2},
  [4678] = {.lex_state = 157, .external_lex_state = 28},
  [4679] = {.lex_state = 197, .external_lex_state = 5},
  [4680] = {.lex_state = 208, .external_lex_state = 5},
  [4681] = {.lex_state = 208, .external_lex_state = 5},
  [4682] = {.lex_state = 208, .external_lex_state = 5},
  [4683] = {.lex_state = 208, .external_lex_state = 5},
  [4684] = {.lex_state = 157, .external_lex_state = 2},
  [4685] = {.lex_state = 157, .external_lex_state = 28},
  [4686] = {.lex_state = 157, .external_lex_state = 2},
  [4687] = {.lex_state = 157, .external_lex_state = 2},
  [4688] = {.lex_state = 157, .external_lex_state = 2},
  [4689] = {.lex_state = 157, .external_lex_state = 2},
  [4690] = {.lex_state = 157, .external_lex_state = 2},
  [4691] = {.lex_state = 157, .external_lex_state = 2},
  [4692] = {.lex_state = 157, .external_lex_state = 2},
  [4693] = {.lex_state = 157, .external_lex_state = 2},
  [4694] = {.lex_state = 157, .external_lex_state = 2},
  [4695] = {.lex_state = 208, .external_lex_state = 14},
  [4696] = {.lex_state = 268, .external_lex_state = 5},
  [4697] = {.lex_state = 268, .external_lex_state = 5},
  [4698] = {.lex_state = 157, .external_lex_state = 6},
  [4699] = {.lex_state = 208, .external_lex_state = 5},
  [4700] = {.lex_state = 208, .external_lex_state = 5},
  [4701] = {.lex_state = 208, .external_lex_state = 5},
  [4702] = {.lex_state = 268, .external_lex_state = 5},
  [4703] = {.lex_state = 268, .external_lex_state = 5},
  [4704] = {.lex_state = 268, .external_lex_state = 5},
  [4705] = {.lex_state = 359, .external_lex_state = 20},
  [4706] = {.lex_state = 268, .external_lex_state = 5},
  [4707] = {.lex_state = 268, .external_lex_state = 5},
  [4708] = {.lex_state = 268, .external_lex_state = 5},
  [4709] = {.lex_state = 268, .external_lex_state = 5},
  [4710] = {.lex_state = 268, .external_lex_state = 5},
  [4711] = {.lex_state = 268, .external_lex_state = 5},
  [4712] = {.lex_state = 268, .external_lex_state = 5},
  [4713] = {.lex_state = 268, .external_lex_state = 14},
  [4714] = {.lex_state = 157, .external_lex_state = 2},
  [4715] = {.lex_state = 197, .external_lex_state = 5},
  [4716] = {.lex_state = 217, .external_lex_state = 4},
  [4717] = {.lex_state = 135, .external_lex_state = 2},
  [4718] = {.lex_state = 215},
  [4719] = {.lex_state = 164, .external_lex_state = 3},
  [4720] = {.lex_state = 215},
  [4721] = {.lex_state = 215},
  [4722] = {.lex_state = 215},
  [4723] = {.lex_state = 135, .external_lex_state = 2},
  [4724] = {.lex_state = 135},
  [4725] = {.lex_state = 316, .external_lex_state = 20},
  [4726] = {.lex_state = 135, .external_lex_state = 15},
  [4727] = {.lex_state = 234, .external_lex_state = 15},
  [4728] = {.lex_state = 217, .external_lex_state = 4},
  [4729] = {.lex_state = 316, .external_lex_state = 20},
  [4730] = {.lex_state = 234, .external_lex_state = 15},
  [4731] = {.lex_state = 215},
  [4732] = {.lex_state = 316, .external_lex_state = 20},
  [4733] = {.lex_state = 316, .external_lex_state = 20},
  [4734] = {.lex_state = 215},
  [4735] = {.lex_state = 215},
  [4736] = {.lex_state = 215},
  [4737] = {.lex_state = 135, .external_lex_state = 2},
  [4738] = {.lex_state = 316, .external_lex_state = 23},
  [4739] = {.lex_state = 135, .external_lex_state = 13},
  [4740] = {.lex_state = 316, .external_lex_state = 20},
  [4741] = {.lex_state = 135, .external_lex_state = 10},
  [4742] = {.lex_state = 135, .external_lex_state = 2},
  [4743] = {.lex_state = 135},
  [4744] = {.lex_state = 316, .external_lex_state = 20},
  [4745] = {.lex_state = 232, .external_lex_state = 2},
  [4746] = {.lex_state = 215},
  [4747] = {.lex_state = 316, .external_lex_state = 20},
  [4748] = {.lex_state = 274, .external_lex_state = 20},
  [4749] = {.lex_state = 135, .external_lex_state = 2},
  [4750] = {.lex_state = 164, .external_lex_state = 3},
  [4751] = {.lex_state = 307, .external_lex_state = 16},
  [4752] = {.lex_state = 307, .external_lex_state = 19},
  [4753] = {.lex_state = 157, .external_lex_state = 2},
  [4754] = {.lex_state = 307, .external_lex_state = 16},
  [4755] = {.lex_state = 347, .external_lex_state = 17},
  [4756] = {.lex_state = 157, .external_lex_state = 2},
  [4757] = {.lex_state = 347, .external_lex_state = 17},
  [4758] = {.lex_state = 228},
  [4759] = {.lex_state = 157, .external_lex_state = 2},
  [4760] = {.lex_state = 157, .external_lex_state = 2},
  [4761] = {.lex_state = 157, .external_lex_state = 2},
  [4762] = {.lex_state = 307, .external_lex_state = 16},
  [4763] = {.lex_state = 307, .external_lex_state = 16},
  [4764] = {.lex_state = 307, .external_lex_state = 19},
  [4765] = {.lex_state = 307, .external_lex_state = 16},
  [4766] = {.lex_state = 304, .external_lex_state = 17},
  [4767] = {.lex_state = 304, .external_lex_state = 17},
  [4768] = {.lex_state = 157, .external_lex_state = 2},
  [4769] = {.lex_state = 157, .external_lex_state = 2},
  [4770] = {.lex_state = 304, .external_lex_state = 17},
  [4771] = {.lex_state = 157, .external_lex_state = 2},
  [4772] = {.lex_state = 164},
  [4773] = {.lex_state = 304, .external_lex_state = 17},
  [4774] = {.lex_state = 313, .external_lex_state = 16},
  [4775] = {.lex_state = 307, .external_lex_state = 16},
  [4776] = {.lex_state = 307, .external_lex_state = 16},
  [4777] = {.lex_state = 310, .external_lex_state = 17},
  [4778] = {.lex_state = 157},
  [4779] = {.lex_state = 307, .external_lex_state = 19},
  [4780] = {.lex_state = 326, .external_lex_state = 16},
  [4781] = {.lex_state = 135},
  [4782] = {.lex_state = 307, .external_lex_state = 16},
  [4783] = {.lex_state = 307, .external_lex_state = 16},
  [4784] = {.lex_state = 217, .external_lex_state = 22},
  [4785] = {.lex_state = 157, .external_lex_state = 29},
  [4786] = {.lex_state = 307, .external_lex_state = 16},
  [4787] = {.lex_state = 307, .external_lex_state = 16},
  [4788] = {.lex_state = 157, .external_lex_state = 2},
  [4789] = {.lex_state = 157, .external_lex_state = 28},
  [4790] = {.lex_state = 157, .external_lex_state = 2},
  [4791] = {.lex_state = 157, .external_lex_state = 2},
  [4792] = {.lex_state = 157, .external_lex_state = 2},
  [4793] = {.lex_state = 157, .external_lex_state = 2},
  [4794] = {.lex_state = 157, .external_lex_state = 2},
  [4795] = {.lex_state = 157, .external_lex_state = 2},
  [4796] = {.lex_state = 157, .external_lex_state = 2},
  [4797] = {.lex_state = 157, .external_lex_state = 2},
  [4798] = {.lex_state = 157, .external_lex_state = 2},
  [4799] = {.lex_state = 300, .external_lex_state = 27},
  [4800] = {.lex_state = 164},
  [4801] = {.lex_state = 347, .external_lex_state = 17},
  [4802] = {.lex_state = 228},
  [4803] = {.lex_state = 157, .external_lex_state = 2},
  [4804] = {.lex_state = 157, .external_lex_state = 2},
  [4805] = {.lex_state = 157, .external_lex_state = 2},
  [4806] = {.lex_state = 350, .external_lex_state = 16},
  [4807] = {.lex_state = 350, .external_lex_state = 16},
  [4808] = {.lex_state = 350, .external_lex_state = 19},
  [4809] = {.lex_state = 350, .external_lex_state = 16},
  [4810] = {.lex_state = 307, .external_lex_state = 19},
  [4811] = {.lex_state = 316, .external_lex_state = 20},
  [4812] = {.lex_state = 135},
  [4813] = {.lex_state = 316, .external_lex_state = 20},
  [4814] = {.lex_state = 135},
  [4815] = {.lex_state = 135},
  [4816] = {.lex_state = 135},
  [4817] = {.lex_state = 316, .external_lex_state = 20},
  [4818] = {.lex_state = 197, .external_lex_state = 5},
  [4819] = {.lex_state = 135, .external_lex_state = 2},
  [4820] = {.lex_state = 135, .external_lex_state = 13},
  [4821] = {.lex_state = 316, .external_lex_state = 20},
  [4822] = {.lex_state = 316, .external_lex_state = 20},
  [4823] = {.lex_state = 135, .external_lex_state = 2},
  [4824] = {.lex_state = 316, .external_lex_state = 20},
  [4825] = {.lex_state = 135},
  [4826] = {.lex_state = 135},
  [4827] = {.lex_state = 316, .external_lex_state = 20},
  [4828] = {.lex_state = 135},
  [4829] = {.lex_state = 316, .external_lex_state = 20},
  [4830] = {.lex_state = 135, .external_lex_state = 2},
  [4831] = {.lex_state = 135},
  [4832] = {.lex_state = 316, .external_lex_state = 20},
  [4833] = {.lex_state = 135, .external_lex_state = 15},
  [4834] = {.lex_state = 234, .external_lex_state = 15},
  [4835] = {.lex_state = 217, .external_lex_state = 4},
  [4836] = {.lex_state = 316, .external_lex_state = 20},
  [4837] = {.lex_state = 234, .external_lex_state = 15},
  [4838] = {.lex_state = 307, .external_lex_state = 20},
  [4839] = {.lex_state = 307, .external_lex_state = 20},
  [4840] = {.lex_state = 307, .external_lex_state = 20},
  [4841] = {.lex_state = 307, .external_lex_state = 20},
  [4842] = {.lex_state = 307, .external_lex_state = 20},
  [4843] = {.lex_state = 310, .external_lex_state = 21},
  [4844] = {.lex_state = 266, .external_lex_state = 6},
  [4845] = {.lex_state = 310, .external_lex_state = 21},
  [4846] = {.lex_state = 310, .external_lex_state = 21},
  [4847] = {.lex_state = 300, .external_lex_state = 27},
  [4848] = {.lex_state = 319, .external_lex_state = 20},
  [4849] = {.lex_state = 157},
  [4850] = {.lex_state = 310, .external_lex_state = 21},
  [4851] = {.lex_state = 304, .external_lex_state = 21},
  [4852] = {.lex_state = 157, .external_lex_state = 2},
  [4853] = {.lex_state = 304, .external_lex_state = 21},
  [4854] = {.lex_state = 157, .external_lex_state = 2},
  [4855] = {.lex_state = 157, .external_lex_state = 2},
  [4856] = {.lex_state = 304, .external_lex_state = 21},
  [4857] = {.lex_state = 157, .external_lex_state = 2},
  [4858] = {.lex_state = 304, .external_lex_state = 21},
  [4859] = {.lex_state = 369, .external_lex_state = 20},
  [4860] = {.lex_state = 313, .external_lex_state = 20},
  [4861] = {.lex_state = 307, .external_lex_state = 20},
  [4862] = {.lex_state = 157},
  [4863] = {.lex_state = 307, .external_lex_state = 23},
  [4864] = {.lex_state = 307, .external_lex_state = 20},
  [4865] = {.lex_state = 350, .external_lex_state = 16},
  [4866] = {.lex_state = 350, .external_lex_state = 19},
  [4867] = {.lex_state = 384, .external_lex_state = 16},
  [4868] = {.lex_state = 232, .external_lex_state = 2},
  [4869] = {.lex_state = 215},
  [4870] = {.lex_state = 157, .external_lex_state = 2},
  [4871] = {.lex_state = 350, .external_lex_state = 16},
  [4872] = {.lex_state = 319, .external_lex_state = 20},
  [4873] = {.lex_state = 135, .external_lex_state = 10},
  [4874] = {.lex_state = 135, .external_lex_state = 2},
  [4875] = {.lex_state = 135},
  [4876] = {.lex_state = 157, .external_lex_state = 2},
  [4877] = {.lex_state = 310, .external_lex_state = 17},
  [4878] = {.lex_state = 157, .external_lex_state = 2},
  [4879] = {.lex_state = 215, .external_lex_state = 10},
  [4880] = {.lex_state = 182, .external_lex_state = 4},
  [4881] = {.lex_state = 217, .external_lex_state = 4},
  [4882] = {.lex_state = 135, .external_lex_state = 2},
  [4883] = {.lex_state = 310, .external_lex_state = 17},
  [4884] = {.lex_state = 135, .external_lex_state = 2},
  [4885] = {.lex_state = 157, .external_lex_state = 11},
  [4886] = {.lex_state = 157, .external_lex_state = 8},
  [4887] = {.lex_state = 135, .external_lex_state = 10},
  [4888] = {.lex_state = 157, .external_lex_state = 2},
  [4889] = {.lex_state = 157, .external_lex_state = 2},
  [4890] = {.lex_state = 217, .external_lex_state = 4},
  [4891] = {.lex_state = 182, .external_lex_state = 4},
  [4892] = {.lex_state = 323, .external_lex_state = 16},
  [4893] = {.lex_state = 157, .external_lex_state = 6},
  [4894] = {.lex_state = 215, .external_lex_state = 7},
  [4895] = {.lex_state = 310, .external_lex_state = 17},
  [4896] = {.lex_state = 157, .external_lex_state = 2},
  [4897] = {.lex_state = 157, .external_lex_state = 2},
  [4898] = {.lex_state = 323, .external_lex_state = 16},
  [4899] = {.lex_state = 157, .external_lex_state = 8},
  [4900] = {.lex_state = 217, .external_lex_state = 4},
  [4901] = {.lex_state = 217, .external_lex_state = 4},
  [4902] = {.lex_state = 157},
  [4903] = {.lex_state = 164, .external_lex_state = 3},
  [4904] = {.lex_state = 310, .external_lex_state = 17},
  [4905] = {.lex_state = 135, .external_lex_state = 2},
  [4906] = {.lex_state = 313, .external_lex_state = 16},
  [4907] = {.lex_state = 313, .external_lex_state = 16},
  [4908] = {.lex_state = 313, .external_lex_state = 16},
  [4909] = {.lex_state = 310, .external_lex_state = 17},
  [4910] = {.lex_state = 157},
  [4911] = {.lex_state = 313, .external_lex_state = 19},
  [4912] = {.lex_state = 323, .external_lex_state = 16},
  [4913] = {.lex_state = 135},
  [4914] = {.lex_state = 313, .external_lex_state = 16},
  [4915] = {.lex_state = 313, .external_lex_state = 16},
  [4916] = {.lex_state = 232, .external_lex_state = 2},
  [4917] = {.lex_state = 319, .external_lex_state = 20},
  [4918] = {.lex_state = 157, .external_lex_state = 28},
  [4919] = {.lex_state = 217, .external_lex_state = 22},
  [4920] = {.lex_state = 157, .external_lex_state = 29},
  [4921] = {.lex_state = 313, .external_lex_state = 16},
  [4922] = {.lex_state = 313, .external_lex_state = 16},
  [4923] = {.lex_state = 157, .external_lex_state = 2},
  [4924] = {.lex_state = 157, .external_lex_state = 2},
  [4925] = {.lex_state = 157, .external_lex_state = 2},
  [4926] = {.lex_state = 157, .external_lex_state = 2},
  [4927] = {.lex_state = 157, .external_lex_state = 2},
  [4928] = {.lex_state = 157, .external_lex_state = 2},
  [4929] = {.lex_state = 157, .external_lex_state = 2},
  [4930] = {.lex_state = 157, .external_lex_state = 2},
  [4931] = {.lex_state = 157, .external_lex_state = 2},
  [4932] = {.lex_state = 157, .external_lex_state = 2},
  [4933] = {.lex_state = 350, .external_lex_state = 19},
  [4934] = {.lex_state = 307, .external_lex_state = 20},
  [4935] = {.lex_state = 307, .external_lex_state = 20},
  [4936] = {.lex_state = 307, .external_lex_state = 20},
  [4937] = {.lex_state = 307, .external_lex_state = 20},
  [4938] = {.lex_state = 307, .external_lex_state = 20},
  [4939] = {.lex_state = 359, .external_lex_state = 20},
  [4940] = {.lex_state = 307, .external_lex_state = 20},
  [4941] = {.lex_state = 307, .external_lex_state = 20},
  [4942] = {.lex_state = 307, .external_lex_state = 20},
  [4943] = {.lex_state = 307, .external_lex_state = 20},
  [4944] = {.lex_state = 307, .external_lex_state = 20},
  [4945] = {.lex_state = 307, .external_lex_state = 23},
  [4946] = {.lex_state = 197, .external_lex_state = 5},
  [4947] = {.lex_state = 217, .external_lex_state = 30},
  [4948] = {.lex_state = 237, .external_lex_state = 16},
  [4949] = {.lex_state = 135},
  [4950] = {.lex_state = 237, .external_lex_state = 16},
  [4951] = {.lex_state = 135},
  [4952] = {.lex_state = 237, .external_lex_state = 16},
  [4953] = {.lex_state = 217, .external_lex_state = 4},
  [4954] = {.lex_state = 237, .external_lex_state = 16},
  [4955] = {.lex_state = 234, .external_lex_state = 15},
  [4956] = {.lex_state = 237, .external_lex_state = 16},
  [4957] = {.lex_state = 217, .external_lex_state = 4},
  [4958] = {.lex_state = 237, .external_lex_state = 16},
  [4959] = {.lex_state = 237, .external_lex_state = 16},
  [4960] = {.lex_state = 135},
  [4961] = {.lex_state = 135, .external_lex_state = 2},
  [4962] = {.lex_state = 237, .external_lex_state = 16},
  [4963] = {.lex_state = 135, .external_lex_state = 2},
  [4964] = {.lex_state = 135},
  [4965] = {.lex_state = 135, .external_lex_state = 10},
  [4966] = {.lex_state = 237, .external_lex_state = 16},
  [4967] = {.lex_state = 215},
  [4968] = {.lex_state = 157},
  [4969] = {.lex_state = 237, .external_lex_state = 16},
  [4970] = {.lex_state = 237, .external_lex_state = 16},
  [4971] = {.lex_state = 255, .external_lex_state = 16},
  [4972] = {.lex_state = 255, .external_lex_state = 16},
  [4973] = {.lex_state = 237, .external_lex_state = 16},
  [4974] = {.lex_state = 237, .external_lex_state = 16},
  [4975] = {.lex_state = 217, .external_lex_state = 22},
  [4976] = {.lex_state = 237, .external_lex_state = 16},
  [4977] = {.lex_state = 157, .external_lex_state = 6},
  [4978] = {.lex_state = 255, .external_lex_state = 16},
  [4979] = {.lex_state = 255, .external_lex_state = 16},
  [4980] = {.lex_state = 255, .external_lex_state = 16},
  [4981] = {.lex_state = 255, .external_lex_state = 16},
  [4982] = {.lex_state = 255, .external_lex_state = 16},
  [4983] = {.lex_state = 255, .external_lex_state = 16},
  [4984] = {.lex_state = 255, .external_lex_state = 16},
  [4985] = {.lex_state = 255, .external_lex_state = 16},
  [4986] = {.lex_state = 359, .external_lex_state = 20},
  [4987] = {.lex_state = 255, .external_lex_state = 16},
  [4988] = {.lex_state = 255, .external_lex_state = 16},
  [4989] = {.lex_state = 255, .external_lex_state = 16},
  [4990] = {.lex_state = 255, .external_lex_state = 16},
  [4991] = {.lex_state = 255, .external_lex_state = 16},
  [4992] = {.lex_state = 255, .external_lex_state = 16},
  [4993] = {.lex_state = 255, .external_lex_state = 16},
  [4994] = {.lex_state = 157, .external_lex_state = 2},
  [4995] = {.lex_state = 157, .external_lex_state = 2},
  [4996] = {.lex_state = 157, .external_lex_state = 2},
  [4997] = {.lex_state = 157, .external_lex_state = 2},
  [4998] = {.lex_state = 157, .external_lex_state = 2},
  [4999] = {.lex_state = 329, .external_lex_state = 16},
  [5000] = {.lex_state = 255, .external_lex_state = 16},
  [5001] = {.lex_state = 157},
  [5002] = {.lex_state = 255, .external_lex_state = 16},
  [5003] = {.lex_state = 255, .external_lex_state = 16},
  [5004] = {.lex_state = 157, .external_lex_state = 29},
  [5005] = {.lex_state = 255, .external_lex_state = 16},
  [5006] = {.lex_state = 255, .external_lex_state = 16},
  [5007] = {.lex_state = 135, .external_lex_state = 2},
  [5008] = {.lex_state = 135},
  [5009] = {.lex_state = 326, .external_lex_state = 16},
  [5010] = {.lex_state = 135},
  [5011] = {.lex_state = 135},
  [5012] = {.lex_state = 135},
  [5013] = {.lex_state = 326, .external_lex_state = 16},
  [5014] = {.lex_state = 135, .external_lex_state = 15},
  [5015] = {.lex_state = 234, .external_lex_state = 15},
  [5016] = {.lex_state = 217, .external_lex_state = 4},
  [5017] = {.lex_state = 326, .external_lex_state = 16},
  [5018] = {.lex_state = 234, .external_lex_state = 15},
  [5019] = {.lex_state = 326, .external_lex_state = 16},
  [5020] = {.lex_state = 326, .external_lex_state = 16},
  [5021] = {.lex_state = 135, .external_lex_state = 2},
  [5022] = {.lex_state = 135},
  [5023] = {.lex_state = 197, .external_lex_state = 5},
  [5024] = {.lex_state = 135, .external_lex_state = 2},
  [5025] = {.lex_state = 135, .external_lex_state = 13},
  [5026] = {.lex_state = 326, .external_lex_state = 16},
  [5027] = {.lex_state = 135, .external_lex_state = 2},
  [5028] = {.lex_state = 326, .external_lex_state = 16},
  [5029] = {.lex_state = 135},
  [5030] = {.lex_state = 135},
  [5031] = {.lex_state = 326, .external_lex_state = 16},
  [5032] = {.lex_state = 135},
  [5033] = {.lex_state = 326, .external_lex_state = 16},
  [5034] = {.lex_state = 326, .external_lex_state = 16},
  [5035] = {.lex_state = 135, .external_lex_state = 15},
  [5036] = {.lex_state = 234, .external_lex_state = 15},
  [5037] = {.lex_state = 217, .external_lex_state = 4},
  [5038] = {.lex_state = 326, .external_lex_state = 16},
  [5039] = {.lex_state = 234, .external_lex_state = 15},
  [5040] = {.lex_state = 326, .external_lex_state = 16},
  [5041] = {.lex_state = 326, .external_lex_state = 16},
  [5042] = {.lex_state = 215},
  [5043] = {.lex_state = 135, .external_lex_state = 2},
  [5044] = {.lex_state = 135, .external_lex_state = 13},
  [5045] = {.lex_state = 326, .external_lex_state = 19},
  [5046] = {.lex_state = 326, .external_lex_state = 16},
  [5047] = {.lex_state = 326, .external_lex_state = 16},
  [5048] = {.lex_state = 135, .external_lex_state = 10},
  [5049] = {.lex_state = 135, .external_lex_state = 2},
  [5050] = {.lex_state = 135},
  [5051] = {.lex_state = 326, .external_lex_state = 16},
  [5052] = {.lex_state = 232, .external_lex_state = 2},
  [5053] = {.lex_state = 215},
  [5054] = {.lex_state = 326, .external_lex_state = 16},
  [5055] = {.lex_state = 274, .external_lex_state = 20},
  [5056] = {.lex_state = 135, .external_lex_state = 2},
  [5057] = {.lex_state = 164, .external_lex_state = 3},
  [5058] = {.lex_state = 135, .external_lex_state = 2},
  [5059] = {.lex_state = 135},
  [5060] = {.lex_state = 255, .external_lex_state = 16},
  [5061] = {.lex_state = 157, .external_lex_state = 2},
  [5062] = {.lex_state = 326, .external_lex_state = 16},
  [5063] = {.lex_state = 255, .external_lex_state = 16},
  [5064] = {.lex_state = 255, .external_lex_state = 16},
  [5065] = {.lex_state = 255, .external_lex_state = 16},
  [5066] = {.lex_state = 255, .external_lex_state = 16},
  [5067] = {.lex_state = 255, .external_lex_state = 16},
  [5068] = {.lex_state = 255, .external_lex_state = 16},
  [5069] = {.lex_state = 359, .external_lex_state = 20},
  [5070] = {.lex_state = 255, .external_lex_state = 16},
  [5071] = {.lex_state = 255, .external_lex_state = 16},
  [5072] = {.lex_state = 255, .external_lex_state = 16},
  [5073] = {.lex_state = 255, .external_lex_state = 16},
  [5074] = {.lex_state = 255, .external_lex_state = 16},
  [5075] = {.lex_state = 332, .external_lex_state = 17},
  [5076] = {.lex_state = 266, .external_lex_state = 6},
  [5077] = {.lex_state = 332, .external_lex_state = 17},
  [5078] = {.lex_state = 332, .external_lex_state = 17},
  [5079] = {.lex_state = 300, .external_lex_state = 27},
  [5080] = {.lex_state = 323, .external_lex_state = 16},
  [5081] = {.lex_state = 157},
  [5082] = {.lex_state = 332, .external_lex_state = 17},
  [5083] = {.lex_state = 242, .external_lex_state = 16},
  [5084] = {.lex_state = 232, .external_lex_state = 2},
  [5085] = {.lex_state = 215},
  [5086] = {.lex_state = 157, .external_lex_state = 2},
  [5087] = {.lex_state = 323, .external_lex_state = 16},
  [5088] = {.lex_state = 135, .external_lex_state = 10},
  [5089] = {.lex_state = 135, .external_lex_state = 2},
  [5090] = {.lex_state = 135},
  [5091] = {.lex_state = 157, .external_lex_state = 2},
  [5092] = {.lex_state = 332, .external_lex_state = 17},
  [5093] = {.lex_state = 332, .external_lex_state = 17},
  [5094] = {.lex_state = 157, .external_lex_state = 2},
  [5095] = {.lex_state = 157, .external_lex_state = 2},
  [5096] = {.lex_state = 332, .external_lex_state = 17},
  [5097] = {.lex_state = 157, .external_lex_state = 2},
  [5098] = {.lex_state = 332, .external_lex_state = 17},
  [5099] = {.lex_state = 329, .external_lex_state = 16},
  [5100] = {.lex_state = 329, .external_lex_state = 16},
  [5101] = {.lex_state = 329, .external_lex_state = 16},
  [5102] = {.lex_state = 332, .external_lex_state = 17},
  [5103] = {.lex_state = 157},
  [5104] = {.lex_state = 329, .external_lex_state = 19},
  [5105] = {.lex_state = 329, .external_lex_state = 16},
  [5106] = {.lex_state = 329, .external_lex_state = 16},
  [5107] = {.lex_state = 232, .external_lex_state = 2},
  [5108] = {.lex_state = 323, .external_lex_state = 16},
  [5109] = {.lex_state = 157, .external_lex_state = 29},
  [5110] = {.lex_state = 329, .external_lex_state = 16},
  [5111] = {.lex_state = 329, .external_lex_state = 16},
  [5112] = {.lex_state = 255, .external_lex_state = 19},
  [5113] = {.lex_state = 237, .external_lex_state = 16},
  [5114] = {.lex_state = 135},
  [5115] = {.lex_state = 135},
  [5116] = {.lex_state = 135},
  [5117] = {.lex_state = 135, .external_lex_state = 2},
  [5118] = {.lex_state = 237, .external_lex_state = 16},
  [5119] = {.lex_state = 135, .external_lex_state = 2},
  [5120] = {.lex_state = 237, .external_lex_state = 16},
  [5121] = {.lex_state = 237, .external_lex_state = 16},
  [5122] = {.lex_state = 135},
  [5123] = {.lex_state = 135},
  [5124] = {.lex_state = 237, .external_lex_state = 16},
  [5125] = {.lex_state = 135},
  [5126] = {.lex_state = 237, .external_lex_state = 16},
  [5127] = {.lex_state = 217, .external_lex_state = 4},
  [5128] = {.lex_state = 237, .external_lex_state = 16},
  [5129] = {.lex_state = 234, .external_lex_state = 15},
  [5130] = {.lex_state = 237, .external_lex_state = 16},
  [5131] = {.lex_state = 217, .external_lex_state = 4},
  [5132] = {.lex_state = 157, .external_lex_state = 6},
  [5133] = {.lex_state = 217, .external_lex_state = 22},
  [5134] = {.lex_state = 335, .external_lex_state = 18},
  [5135] = {.lex_state = 157, .external_lex_state = 6},
  [5136] = {.lex_state = 157, .external_lex_state = 29},
  [5137] = {.lex_state = 255, .external_lex_state = 16},
  [5138] = {.lex_state = 157, .external_lex_state = 28},
  [5139] = {.lex_state = 255, .external_lex_state = 16},
  [5140] = {.lex_state = 157, .external_lex_state = 2},
  [5141] = {.lex_state = 245, .external_lex_state = 17},
  [5142] = {.lex_state = 135},
  [5143] = {.lex_state = 245, .external_lex_state = 17},
  [5144] = {.lex_state = 242, .external_lex_state = 16},
  [5145] = {.lex_state = 135, .external_lex_state = 2},
  [5146] = {.lex_state = 135, .external_lex_state = 2},
  [5147] = {.lex_state = 135},
  [5148] = {.lex_state = 242, .external_lex_state = 16},
  [5149] = {.lex_state = 242, .external_lex_state = 16},
  [5150] = {.lex_state = 135, .external_lex_state = 15},
  [5151] = {.lex_state = 234, .external_lex_state = 15},
  [5152] = {.lex_state = 217, .external_lex_state = 4},
  [5153] = {.lex_state = 242, .external_lex_state = 16},
  [5154] = {.lex_state = 234, .external_lex_state = 15},
  [5155] = {.lex_state = 242, .external_lex_state = 16},
  [5156] = {.lex_state = 242, .external_lex_state = 16},
  [5157] = {.lex_state = 215},
  [5158] = {.lex_state = 242, .external_lex_state = 16},
  [5159] = {.lex_state = 215},
  [5160] = {.lex_state = 252, .external_lex_state = 16},
  [5161] = {.lex_state = 135, .external_lex_state = 2},
  [5162] = {.lex_state = 371, .external_lex_state = 19},
  [5163] = {.lex_state = 135, .external_lex_state = 13},
  [5164] = {.lex_state = 242, .external_lex_state = 16},
  [5165] = {.lex_state = 135, .external_lex_state = 2},
  [5166] = {.lex_state = 135},
  [5167] = {.lex_state = 135, .external_lex_state = 10},
  [5168] = {.lex_state = 242, .external_lex_state = 16},
  [5169] = {.lex_state = 242, .external_lex_state = 16},
  [5170] = {.lex_state = 252, .external_lex_state = 16},
  [5171] = {.lex_state = 274, .external_lex_state = 20},
  [5172] = {.lex_state = 135, .external_lex_state = 2},
  [5173] = {.lex_state = 164, .external_lex_state = 3},
  [5174] = {.lex_state = 242, .external_lex_state = 16},
  [5175] = {.lex_state = 135},
  [5176] = {.lex_state = 242, .external_lex_state = 16},
  [5177] = {.lex_state = 135},
  [5178] = {.lex_state = 135},
  [5179] = {.lex_state = 135},
  [5180] = {.lex_state = 242, .external_lex_state = 16},
  [5181] = {.lex_state = 242, .external_lex_state = 16},
  [5182] = {.lex_state = 197, .external_lex_state = 5},
  [5183] = {.lex_state = 135, .external_lex_state = 2},
  [5184] = {.lex_state = 135, .external_lex_state = 13},
  [5185] = {.lex_state = 242, .external_lex_state = 16},
  [5186] = {.lex_state = 242, .external_lex_state = 16},
  [5187] = {.lex_state = 135, .external_lex_state = 2},
  [5188] = {.lex_state = 242, .external_lex_state = 16},
  [5189] = {.lex_state = 135},
  [5190] = {.lex_state = 135},
  [5191] = {.lex_state = 242, .external_lex_state = 16},
  [5192] = {.lex_state = 135},
  [5193] = {.lex_state = 242, .external_lex_state = 16},
  [5194] = {.lex_state = 135, .external_lex_state = 2},
  [5195] = {.lex_state = 135},
  [5196] = {.lex_state = 242, .external_lex_state = 16},
  [5197] = {.lex_state = 135, .external_lex_state = 15},
  [5198] = {.lex_state = 234, .external_lex_state = 15},
  [5199] = {.lex_state = 217, .external_lex_state = 4},
  [5200] = {.lex_state = 242, .external_lex_state = 16},
  [5201] = {.lex_state = 234, .external_lex_state = 15},
  [5202] = {.lex_state = 242, .external_lex_state = 16},
  [5203] = {.lex_state = 252, .external_lex_state = 16},
  [5204] = {.lex_state = 252, .external_lex_state = 16},
  [5205] = {.lex_state = 242, .external_lex_state = 16},
  [5206] = {.lex_state = 217, .external_lex_state = 22},
  [5207] = {.lex_state = 242, .external_lex_state = 16},
  [5208] = {.lex_state = 157, .external_lex_state = 6},
  [5209] = {.lex_state = 252, .external_lex_state = 16},
  [5210] = {.lex_state = 252, .external_lex_state = 16},
  [5211] = {.lex_state = 252, .external_lex_state = 16},
  [5212] = {.lex_state = 252, .external_lex_state = 16},
  [5213] = {.lex_state = 252, .external_lex_state = 16},
  [5214] = {.lex_state = 252, .external_lex_state = 16},
  [5215] = {.lex_state = 359, .external_lex_state = 20},
  [5216] = {.lex_state = 252, .external_lex_state = 16},
  [5217] = {.lex_state = 252, .external_lex_state = 16},
  [5218] = {.lex_state = 252, .external_lex_state = 16},
  [5219] = {.lex_state = 252, .external_lex_state = 16},
  [5220] = {.lex_state = 252, .external_lex_state = 16},
  [5221] = {.lex_state = 252, .external_lex_state = 16},
  [5222] = {.lex_state = 252, .external_lex_state = 16},
  [5223] = {.lex_state = 252, .external_lex_state = 19},
  [5224] = {.lex_state = 197, .external_lex_state = 20},
  [5225] = {.lex_state = 135},
  [5226] = {.lex_state = 197, .external_lex_state = 20},
  [5227] = {.lex_state = 135},
  [5228] = {.lex_state = 197, .external_lex_state = 20},
  [5229] = {.lex_state = 217, .external_lex_state = 4},
  [5230] = {.lex_state = 197, .external_lex_state = 20},
  [5231] = {.lex_state = 234, .external_lex_state = 15},
  [5232] = {.lex_state = 197, .external_lex_state = 20},
  [5233] = {.lex_state = 217, .external_lex_state = 4},
  [5234] = {.lex_state = 197, .external_lex_state = 20},
  [5235] = {.lex_state = 197, .external_lex_state = 20},
  [5236] = {.lex_state = 135},
  [5237] = {.lex_state = 217, .external_lex_state = 22},
  [5238] = {.lex_state = 135, .external_lex_state = 2},
  [5239] = {.lex_state = 197, .external_lex_state = 20},
  [5240] = {.lex_state = 135, .external_lex_state = 2},
  [5241] = {.lex_state = 135},
  [5242] = {.lex_state = 135, .external_lex_state = 10},
  [5243] = {.lex_state = 197, .external_lex_state = 20},
  [5244] = {.lex_state = 215},
  [5245] = {.lex_state = 157},
  [5246] = {.lex_state = 197, .external_lex_state = 20},
  [5247] = {.lex_state = 197, .external_lex_state = 20},
  [5248] = {.lex_state = 197, .external_lex_state = 16},
  [5249] = {.lex_state = 197, .external_lex_state = 16},
  [5250] = {.lex_state = 197, .external_lex_state = 16},
  [5251] = {.lex_state = 197, .external_lex_state = 16},
  [5252] = {.lex_state = 157, .external_lex_state = 6},
  [5253] = {.lex_state = 197, .external_lex_state = 16},
  [5254] = {.lex_state = 197, .external_lex_state = 16},
  [5255] = {.lex_state = 197, .external_lex_state = 16},
  [5256] = {.lex_state = 197, .external_lex_state = 16},
  [5257] = {.lex_state = 197, .external_lex_state = 16},
  [5258] = {.lex_state = 197, .external_lex_state = 16},
  [5259] = {.lex_state = 197, .external_lex_state = 16},
  [5260] = {.lex_state = 197, .external_lex_state = 16},
  [5261] = {.lex_state = 359, .external_lex_state = 20},
  [5262] = {.lex_state = 197, .external_lex_state = 16},
  [5263] = {.lex_state = 197, .external_lex_state = 16},
  [5264] = {.lex_state = 197, .external_lex_state = 16},
  [5265] = {.lex_state = 197, .external_lex_state = 16},
  [5266] = {.lex_state = 197, .external_lex_state = 16},
  [5267] = {.lex_state = 197, .external_lex_state = 16},
  [5268] = {.lex_state = 197, .external_lex_state = 16},
  [5269] = {.lex_state = 245, .external_lex_state = 17},
  [5270] = {.lex_state = 266, .external_lex_state = 6},
  [5271] = {.lex_state = 245, .external_lex_state = 17},
  [5272] = {.lex_state = 245, .external_lex_state = 17},
  [5273] = {.lex_state = 300, .external_lex_state = 27},
  [5274] = {.lex_state = 245, .external_lex_state = 17},
  [5275] = {.lex_state = 197, .external_lex_state = 19},
  [5276] = {.lex_state = 197, .external_lex_state = 20},
  [5277] = {.lex_state = 135},
  [5278] = {.lex_state = 135},
  [5279] = {.lex_state = 135},
  [5280] = {.lex_state = 135, .external_lex_state = 2},
  [5281] = {.lex_state = 197, .external_lex_state = 20},
  [5282] = {.lex_state = 135, .external_lex_state = 2},
  [5283] = {.lex_state = 197, .external_lex_state = 20},
  [5284] = {.lex_state = 197, .external_lex_state = 20},
  [5285] = {.lex_state = 135},
  [5286] = {.lex_state = 135},
  [5287] = {.lex_state = 307, .external_lex_state = 16},
  [5288] = {.lex_state = 307, .external_lex_state = 19},
  [5289] = {.lex_state = 157, .external_lex_state = 2},
  [5290] = {.lex_state = 307, .external_lex_state = 16},
  [5291] = {.lex_state = 347, .external_lex_state = 17},
  [5292] = {.lex_state = 157, .external_lex_state = 2},
  [5293] = {.lex_state = 347, .external_lex_state = 17},
  [5294] = {.lex_state = 228},
  [5295] = {.lex_state = 157, .external_lex_state = 2},
  [5296] = {.lex_state = 157, .external_lex_state = 2},
  [5297] = {.lex_state = 157, .external_lex_state = 2},
  [5298] = {.lex_state = 307, .external_lex_state = 16},
  [5299] = {.lex_state = 307, .external_lex_state = 16},
  [5300] = {.lex_state = 307, .external_lex_state = 19},
  [5301] = {.lex_state = 307, .external_lex_state = 16},
  [5302] = {.lex_state = 157, .external_lex_state = 2},
  [5303] = {.lex_state = 157, .external_lex_state = 2},
  [5304] = {.lex_state = 157, .external_lex_state = 2},
  [5305] = {.lex_state = 313, .external_lex_state = 16},
  [5306] = {.lex_state = 307, .external_lex_state = 16},
  [5307] = {.lex_state = 157},
  [5308] = {.lex_state = 307, .external_lex_state = 16},
  [5309] = {.lex_state = 307, .external_lex_state = 16},
  [5310] = {.lex_state = 157, .external_lex_state = 29},
  [5311] = {.lex_state = 307, .external_lex_state = 16},
  [5312] = {.lex_state = 307, .external_lex_state = 16},
  [5313] = {.lex_state = 157, .external_lex_state = 2},
  [5314] = {.lex_state = 157, .external_lex_state = 28},
  [5315] = {.lex_state = 157, .external_lex_state = 2},
  [5316] = {.lex_state = 157, .external_lex_state = 2},
  [5317] = {.lex_state = 157, .external_lex_state = 2},
  [5318] = {.lex_state = 157, .external_lex_state = 2},
  [5319] = {.lex_state = 157, .external_lex_state = 2},
  [5320] = {.lex_state = 157, .external_lex_state = 2},
  [5321] = {.lex_state = 157, .external_lex_state = 2},
  [5322] = {.lex_state = 157, .external_lex_state = 2},
  [5323] = {.lex_state = 157, .external_lex_state = 2},
  [5324] = {.lex_state = 300, .external_lex_state = 27},
  [5325] = {.lex_state = 164},
  [5326] = {.lex_state = 347, .external_lex_state = 17},
  [5327] = {.lex_state = 228},
  [5328] = {.lex_state = 157, .external_lex_state = 2},
  [5329] = {.lex_state = 157, .external_lex_state = 2},
  [5330] = {.lex_state = 157, .external_lex_state = 2},
  [5331] = {.lex_state = 350, .external_lex_state = 16},
  [5332] = {.lex_state = 350, .external_lex_state = 16},
  [5333] = {.lex_state = 350, .external_lex_state = 19},
  [5334] = {.lex_state = 350, .external_lex_state = 16},
  [5335] = {.lex_state = 307, .external_lex_state = 19},
  [5336] = {.lex_state = 307, .external_lex_state = 16},
  [5337] = {.lex_state = 157, .external_lex_state = 2},
  [5338] = {.lex_state = 307, .external_lex_state = 16},
  [5339] = {.lex_state = 307, .external_lex_state = 16},
  [5340] = {.lex_state = 307, .external_lex_state = 16},
  [5341] = {.lex_state = 307, .external_lex_state = 16},
  [5342] = {.lex_state = 307, .external_lex_state = 16},
  [5343] = {.lex_state = 307, .external_lex_state = 16},
  [5344] = {.lex_state = 359, .external_lex_state = 20},
  [5345] = {.lex_state = 307, .external_lex_state = 16},
  [5346] = {.lex_state = 307, .external_lex_state = 16},
  [5347] = {.lex_state = 307, .external_lex_state = 16},
  [5348] = {.lex_state = 307, .external_lex_state = 16},
  [5349] = {.lex_state = 307, .external_lex_state = 16},
  [5350] = {.lex_state = 310, .external_lex_state = 17},
  [5351] = {.lex_state = 266, .external_lex_state = 6},
  [5352] = {.lex_state = 310, .external_lex_state = 17},
  [5353] = {.lex_state = 310, .external_lex_state = 17},
  [5354] = {.lex_state = 300, .external_lex_state = 27},
  [5355] = {.lex_state = 310, .external_lex_state = 17},
  [5356] = {.lex_state = 350, .external_lex_state = 16},
  [5357] = {.lex_state = 350, .external_lex_state = 19},
  [5358] = {.lex_state = 157, .external_lex_state = 2},
  [5359] = {.lex_state = 350, .external_lex_state = 16},
  [5360] = {.lex_state = 157, .external_lex_state = 2},
  [5361] = {.lex_state = 310, .external_lex_state = 17},
  [5362] = {.lex_state = 310, .external_lex_state = 17},
  [5363] = {.lex_state = 157, .external_lex_state = 2},
  [5364] = {.lex_state = 157, .external_lex_state = 2},
  [5365] = {.lex_state = 310, .external_lex_state = 17},
  [5366] = {.lex_state = 157, .external_lex_state = 2},
  [5367] = {.lex_state = 310, .external_lex_state = 17},
  [5368] = {.lex_state = 313, .external_lex_state = 16},
  [5369] = {.lex_state = 313, .external_lex_state = 16},
  [5370] = {.lex_state = 313, .external_lex_state = 16},
  [5371] = {.lex_state = 310, .external_lex_state = 17},
  [5372] = {.lex_state = 157},
  [5373] = {.lex_state = 313, .external_lex_state = 19},
  [5374] = {.lex_state = 313, .external_lex_state = 16},
  [5375] = {.lex_state = 313, .external_lex_state = 16},
  [5376] = {.lex_state = 157, .external_lex_state = 28},
  [5377] = {.lex_state = 157, .external_lex_state = 29},
  [5378] = {.lex_state = 313, .external_lex_state = 16},
  [5379] = {.lex_state = 313, .external_lex_state = 16},
  [5380] = {.lex_state = 157, .external_lex_state = 2},
  [5381] = {.lex_state = 157, .external_lex_state = 2},
  [5382] = {.lex_state = 157, .external_lex_state = 2},
  [5383] = {.lex_state = 157, .external_lex_state = 2},
  [5384] = {.lex_state = 157, .external_lex_state = 2},
  [5385] = {.lex_state = 157, .external_lex_state = 2},
  [5386] = {.lex_state = 157, .external_lex_state = 2},
  [5387] = {.lex_state = 157, .external_lex_state = 2},
  [5388] = {.lex_state = 157, .external_lex_state = 2},
  [5389] = {.lex_state = 157, .external_lex_state = 2},
  [5390] = {.lex_state = 350, .external_lex_state = 19},
  [5391] = {.lex_state = 307, .external_lex_state = 19},
  [5392] = {.lex_state = 197, .external_lex_state = 20},
  [5393] = {.lex_state = 135},
  [5394] = {.lex_state = 197, .external_lex_state = 20},
  [5395] = {.lex_state = 217, .external_lex_state = 4},
  [5396] = {.lex_state = 197, .external_lex_state = 20},
  [5397] = {.lex_state = 234, .external_lex_state = 15},
  [5398] = {.lex_state = 197, .external_lex_state = 20},
  [5399] = {.lex_state = 217, .external_lex_state = 4},
  [5400] = {.lex_state = 197, .external_lex_state = 20},
  [5401] = {.lex_state = 197, .external_lex_state = 20},
  [5402] = {.lex_state = 197, .external_lex_state = 20},
  [5403] = {.lex_state = 157, .external_lex_state = 2},
  [5404] = {.lex_state = 157, .external_lex_state = 28},
  [5405] = {.lex_state = 157, .external_lex_state = 2},
  [5406] = {.lex_state = 157, .external_lex_state = 2},
  [5407] = {.lex_state = 157, .external_lex_state = 2},
  [5408] = {.lex_state = 157, .external_lex_state = 2},
  [5409] = {.lex_state = 157, .external_lex_state = 2},
  [5410] = {.lex_state = 157, .external_lex_state = 2},
  [5411] = {.lex_state = 157, .external_lex_state = 2},
  [5412] = {.lex_state = 157, .external_lex_state = 2},
  [5413] = {.lex_state = 157, .external_lex_state = 2},
  [5414] = {.lex_state = 197, .external_lex_state = 23},
  [5415] = {.lex_state = 157, .external_lex_state = 28},
  [5416] = {.lex_state = 197, .external_lex_state = 20},
  [5417] = {.lex_state = 157, .external_lex_state = 2},
  [5418] = {.lex_state = 245, .external_lex_state = 21},
  [5419] = {.lex_state = 135},
  [5420] = {.lex_state = 245, .external_lex_state = 21},
  [5421] = {.lex_state = 242, .external_lex_state = 20},
  [5422] = {.lex_state = 215, .external_lex_state = 7},
  [5423] = {.lex_state = 217, .external_lex_state = 22},
  [5424] = {.lex_state = 215, .external_lex_state = 18},
  [5425] = {.lex_state = 242, .external_lex_state = 20},
  [5426] = {.lex_state = 215},
  [5427] = {.lex_state = 242, .external_lex_state = 16},
  [5428] = {.lex_state = 242, .external_lex_state = 20},
  [5429] = {.lex_state = 135, .external_lex_state = 2},
  [5430] = {.lex_state = 135},
  [5431] = {.lex_state = 135, .external_lex_state = 10},
  [5432] = {.lex_state = 242, .external_lex_state = 16},
  [5433] = {.lex_state = 242, .external_lex_state = 20},
  [5434] = {.lex_state = 242, .external_lex_state = 16},
  [5435] = {.lex_state = 242, .external_lex_state = 16},
  [5436] = {.lex_state = 157, .external_lex_state = 6},
  [5437] = {.lex_state = 242, .external_lex_state = 16},
  [5438] = {.lex_state = 242, .external_lex_state = 16},
  [5439] = {.lex_state = 242, .external_lex_state = 16},
  [5440] = {.lex_state = 242, .external_lex_state = 16},
  [5441] = {.lex_state = 242, .external_lex_state = 16},
  [5442] = {.lex_state = 242, .external_lex_state = 16},
  [5443] = {.lex_state = 359, .external_lex_state = 20},
  [5444] = {.lex_state = 242, .external_lex_state = 16},
  [5445] = {.lex_state = 242, .external_lex_state = 16},
  [5446] = {.lex_state = 242, .external_lex_state = 16},
  [5447] = {.lex_state = 242, .external_lex_state = 16},
  [5448] = {.lex_state = 242, .external_lex_state = 16},
  [5449] = {.lex_state = 242, .external_lex_state = 16},
  [5450] = {.lex_state = 242, .external_lex_state = 16},
  [5451] = {.lex_state = 242, .external_lex_state = 19},
  [5452] = {.lex_state = 197, .external_lex_state = 5},
  [5453] = {.lex_state = 197, .external_lex_state = 16},
  [5454] = {.lex_state = 197, .external_lex_state = 16},
  [5455] = {.lex_state = 245, .external_lex_state = 17},
  [5456] = {.lex_state = 228},
  [5457] = {.lex_state = 157, .external_lex_state = 2},
  [5458] = {.lex_state = 157, .external_lex_state = 2},
  [5459] = {.lex_state = 157, .external_lex_state = 2},
  [5460] = {.lex_state = 197, .external_lex_state = 16},
  [5461] = {.lex_state = 197, .external_lex_state = 16},
  [5462] = {.lex_state = 197, .external_lex_state = 19},
  [5463] = {.lex_state = 197, .external_lex_state = 16},
  [5464] = {.lex_state = 197, .external_lex_state = 16},
  [5465] = {.lex_state = 197, .external_lex_state = 16},
  [5466] = {.lex_state = 223, .external_lex_state = 17},
  [5467] = {.lex_state = 157, .external_lex_state = 2},
  [5468] = {.lex_state = 157, .external_lex_state = 28},
  [5469] = {.lex_state = 157, .external_lex_state = 2},
  [5470] = {.lex_state = 157, .external_lex_state = 2},
  [5471] = {.lex_state = 157, .external_lex_state = 2},
  [5472] = {.lex_state = 157, .external_lex_state = 2},
  [5473] = {.lex_state = 157, .external_lex_state = 2},
  [5474] = {.lex_state = 157, .external_lex_state = 2},
  [5475] = {.lex_state = 157, .external_lex_state = 2},
  [5476] = {.lex_state = 157, .external_lex_state = 2},
  [5477] = {.lex_state = 157, .external_lex_state = 2},
  [5478] = {.lex_state = 157, .external_lex_state = 2},
  [5479] = {.lex_state = 300, .external_lex_state = 27},
  [5480] = {.lex_state = 164},
  [5481] = {.lex_state = 245, .external_lex_state = 17},
  [5482] = {.lex_state = 228},
  [5483] = {.lex_state = 157, .external_lex_state = 2},
  [5484] = {.lex_state = 157, .external_lex_state = 2},
  [5485] = {.lex_state = 157, .external_lex_state = 2},
  [5486] = {.lex_state = 208, .external_lex_state = 16},
  [5487] = {.lex_state = 242, .external_lex_state = 16},
  [5488] = {.lex_state = 252, .external_lex_state = 19},
  [5489] = {.lex_state = 208, .external_lex_state = 16},
  [5490] = {.lex_state = 197, .external_lex_state = 19},
  [5491] = {.lex_state = 258, .external_lex_state = 18},
  [5492] = {.lex_state = 258, .external_lex_state = 18},
  [5493] = {.lex_state = 217, .external_lex_state = 22},
  [5494] = {.lex_state = 157, .external_lex_state = 6},
  [5495] = {.lex_state = 258, .external_lex_state = 18},
  [5496] = {.lex_state = 258, .external_lex_state = 18},
  [5497] = {.lex_state = 258, .external_lex_state = 18},
  [5498] = {.lex_state = 258},
  [5499] = {.lex_state = 217, .external_lex_state = 4},
  [5500] = {.lex_state = 258},
  [5501] = {.lex_state = 234, .external_lex_state = 15},
  [5502] = {.lex_state = 258},
  [5503] = {.lex_state = 217, .external_lex_state = 4},
  [5504] = {.lex_state = 258},
  [5505] = {.lex_state = 135},
  [5506] = {.lex_state = 258},
  [5507] = {.lex_state = 135},
  [5508] = {.lex_state = 135},
  [5509] = {.lex_state = 135},
  [5510] = {.lex_state = 258},
  [5511] = {.lex_state = 135},
  [5512] = {.lex_state = 135, .external_lex_state = 2},
  [5513] = {.lex_state = 258},
  [5514] = {.lex_state = 135, .external_lex_state = 2},
  [5515] = {.lex_state = 258},
  [5516] = {.lex_state = 258},
  [5517] = {.lex_state = 135},
  [5518] = {.lex_state = 135},
  [5519] = {.lex_state = 258},
  [5520] = {.lex_state = 217, .external_lex_state = 4},
  [5521] = {.lex_state = 258},
  [5522] = {.lex_state = 234, .external_lex_state = 15},
  [5523] = {.lex_state = 258},
  [5524] = {.lex_state = 217, .external_lex_state = 4},
  [5525] = {.lex_state = 258},
  [5526] = {.lex_state = 258},
  [5527] = {.lex_state = 135},
  [5528] = {.lex_state = 135, .external_lex_state = 2},
  [5529] = {.lex_state = 258},
  [5530] = {.lex_state = 135, .external_lex_state = 2},
  [5531] = {.lex_state = 135},
  [5532] = {.lex_state = 135, .external_lex_state = 10},
  [5533] = {.lex_state = 258},
  [5534] = {.lex_state = 215},
  [5535] = {.lex_state = 157},
  [5536] = {.lex_state = 258},
  [5537] = {.lex_state = 258},
  [5538] = {.lex_state = 258},
  [5539] = {.lex_state = 135},
  [5540] = {.lex_state = 157, .external_lex_state = 8},
  [5541] = {.lex_state = 258, .external_lex_state = 6},
  [5542] = {.lex_state = 135},
  [5543] = {.lex_state = 258, .external_lex_state = 6},
  [5544] = {.lex_state = 258},
  [5545] = {.lex_state = 197, .external_lex_state = 16},
  [5546] = {.lex_state = 197, .external_lex_state = 16},
  [5547] = {.lex_state = 157, .external_lex_state = 2},
  [5548] = {.lex_state = 157, .external_lex_state = 2},
  [5549] = {.lex_state = 197, .external_lex_state = 16},
  [5550] = {.lex_state = 197, .external_lex_state = 16},
  [5551] = {.lex_state = 197, .external_lex_state = 16},
  [5552] = {.lex_state = 157, .external_lex_state = 29},
  [5553] = {.lex_state = 197, .external_lex_state = 16},
  [5554] = {.lex_state = 197, .external_lex_state = 16},
  [5555] = {.lex_state = 245, .external_lex_state = 17},
  [5556] = {.lex_state = 228},
  [5557] = {.lex_state = 157, .external_lex_state = 2},
  [5558] = {.lex_state = 157, .external_lex_state = 2},
  [5559] = {.lex_state = 157, .external_lex_state = 2},
  [5560] = {.lex_state = 197, .external_lex_state = 16},
  [5561] = {.lex_state = 197, .external_lex_state = 16},
  [5562] = {.lex_state = 197, .external_lex_state = 19},
  [5563] = {.lex_state = 197, .external_lex_state = 16},
  [5564] = {.lex_state = 197, .external_lex_state = 16},
  [5565] = {.lex_state = 197, .external_lex_state = 16},
  [5566] = {.lex_state = 223, .external_lex_state = 17},
  [5567] = {.lex_state = 157, .external_lex_state = 2},
  [5568] = {.lex_state = 157, .external_lex_state = 28},
  [5569] = {.lex_state = 157, .external_lex_state = 2},
  [5570] = {.lex_state = 157, .external_lex_state = 2},
  [5571] = {.lex_state = 157, .external_lex_state = 2},
  [5572] = {.lex_state = 157, .external_lex_state = 2},
  [5573] = {.lex_state = 157, .external_lex_state = 2},
  [5574] = {.lex_state = 157, .external_lex_state = 2},
  [5575] = {.lex_state = 157, .external_lex_state = 2},
  [5576] = {.lex_state = 157, .external_lex_state = 2},
  [5577] = {.lex_state = 157, .external_lex_state = 2},
  [5578] = {.lex_state = 157, .external_lex_state = 2},
  [5579] = {.lex_state = 300, .external_lex_state = 27},
  [5580] = {.lex_state = 164},
  [5581] = {.lex_state = 232, .external_lex_state = 7},
  [5582] = {.lex_state = 245, .external_lex_state = 17},
  [5583] = {.lex_state = 228},
  [5584] = {.lex_state = 157, .external_lex_state = 2},
  [5585] = {.lex_state = 157, .external_lex_state = 2},
  [5586] = {.lex_state = 157, .external_lex_state = 2},
  [5587] = {.lex_state = 323, .external_lex_state = 16},
  [5588] = {.lex_state = 208, .external_lex_state = 16},
  [5589] = {.lex_state = 242, .external_lex_state = 16},
  [5590] = {.lex_state = 252, .external_lex_state = 19},
  [5591] = {.lex_state = 208, .external_lex_state = 16},
  [5592] = {.lex_state = 197, .external_lex_state = 19},
  [5593] = {.lex_state = 245, .external_lex_state = 17},
  [5594] = {.lex_state = 266, .external_lex_state = 6},
  [5595] = {.lex_state = 245, .external_lex_state = 17},
  [5596] = {.lex_state = 245, .external_lex_state = 17},
  [5597] = {.lex_state = 300, .external_lex_state = 27},
  [5598] = {.lex_state = 245, .external_lex_state = 17},
  [5599] = {.lex_state = 197, .external_lex_state = 16},
  [5600] = {.lex_state = 197, .external_lex_state = 16},
  [5601] = {.lex_state = 242, .external_lex_state = 16},
  [5602] = {.lex_state = 242, .external_lex_state = 19},
  [5603] = {.lex_state = 157, .external_lex_state = 2},
  [5604] = {.lex_state = 242, .external_lex_state = 16},
  [5605] = {.lex_state = 157, .external_lex_state = 2},
  [5606] = {.lex_state = 242, .external_lex_state = 16},
  [5607] = {.lex_state = 242, .external_lex_state = 16},
  [5608] = {.lex_state = 242, .external_lex_state = 16},
  [5609] = {.lex_state = 157, .external_lex_state = 28},
  [5610] = {.lex_state = 157, .external_lex_state = 29},
  [5611] = {.lex_state = 242, .external_lex_state = 16},
  [5612] = {.lex_state = 242, .external_lex_state = 16},
  [5613] = {.lex_state = 157, .external_lex_state = 2},
  [5614] = {.lex_state = 157, .external_lex_state = 2},
  [5615] = {.lex_state = 157, .external_lex_state = 2},
  [5616] = {.lex_state = 157, .external_lex_state = 2},
  [5617] = {.lex_state = 157, .external_lex_state = 2},
  [5618] = {.lex_state = 157, .external_lex_state = 2},
  [5619] = {.lex_state = 157, .external_lex_state = 2},
  [5620] = {.lex_state = 157, .external_lex_state = 2},
  [5621] = {.lex_state = 157, .external_lex_state = 2},
  [5622] = {.lex_state = 157, .external_lex_state = 2},
  [5623] = {.lex_state = 242, .external_lex_state = 19},
  [5624] = {.lex_state = 157, .external_lex_state = 6},
  [5625] = {.lex_state = 258, .external_lex_state = 18},
  [5626] = {.lex_state = 258, .external_lex_state = 18},
  [5627] = {.lex_state = 258, .external_lex_state = 18},
  [5628] = {.lex_state = 197, .external_lex_state = 16},
  [5629] = {.lex_state = 197, .external_lex_state = 16},
  [5630] = {.lex_state = 197, .external_lex_state = 16},
  [5631] = {.lex_state = 359, .external_lex_state = 20},
  [5632] = {.lex_state = 197, .external_lex_state = 16},
  [5633] = {.lex_state = 197, .external_lex_state = 16},
  [5634] = {.lex_state = 197, .external_lex_state = 16},
  [5635] = {.lex_state = 197, .external_lex_state = 16},
  [5636] = {.lex_state = 197, .external_lex_state = 16},
  [5637] = {.lex_state = 197, .external_lex_state = 16},
  [5638] = {.lex_state = 197, .external_lex_state = 16},
  [5639] = {.lex_state = 197, .external_lex_state = 19},
  [5640] = {.lex_state = 197, .external_lex_state = 5},
  [5641] = {.lex_state = 135},
  [5642] = {.lex_state = 197, .external_lex_state = 13},
  [5643] = {.lex_state = 135, .external_lex_state = 2},
  [5644] = {.lex_state = 215, .external_lex_state = 2},
  [5645] = {.lex_state = 157, .external_lex_state = 2},
  [5646] = {.lex_state = 135, .external_lex_state = 10},
  [5647] = {.lex_state = 135},
  [5648] = {.lex_state = 157},
  [5649] = {.lex_state = 215},
  [5650] = {.lex_state = 197},
  [5651] = {.lex_state = 197, .external_lex_state = 5},
  [5652] = {.lex_state = 197, .external_lex_state = 14},
  [5653] = {.lex_state = 157, .external_lex_state = 2},
  [5654] = {.lex_state = 197, .external_lex_state = 5},
  [5655] = {.lex_state = 271, .external_lex_state = 9},
  [5656] = {.lex_state = 157, .external_lex_state = 2},
  [5657] = {.lex_state = 271, .external_lex_state = 9},
  [5658] = {.lex_state = 228},
  [5659] = {.lex_state = 157, .external_lex_state = 2},
  [5660] = {.lex_state = 157, .external_lex_state = 2},
  [5661] = {.lex_state = 157, .external_lex_state = 2},
  [5662] = {.lex_state = 197, .external_lex_state = 5},
  [5663] = {.lex_state = 197, .external_lex_state = 5},
  [5664] = {.lex_state = 197, .external_lex_state = 14},
  [5665] = {.lex_state = 197, .external_lex_state = 5},
  [5666] = {.lex_state = 220, .external_lex_state = 9},
  [5667] = {.lex_state = 220, .external_lex_state = 9},
  [5668] = {.lex_state = 157, .external_lex_state = 2},
  [5669] = {.lex_state = 157, .external_lex_state = 2},
  [5670] = {.lex_state = 220, .external_lex_state = 9},
  [5671] = {.lex_state = 157, .external_lex_state = 2},
  [5672] = {.lex_state = 220, .external_lex_state = 9},
  [5673] = {.lex_state = 208, .external_lex_state = 5},
  [5674] = {.lex_state = 197, .external_lex_state = 5},
  [5675] = {.lex_state = 157},
  [5676] = {.lex_state = 197, .external_lex_state = 14},
  [5677] = {.lex_state = 197, .external_lex_state = 5},
  [5678] = {.lex_state = 197, .external_lex_state = 5},
  [5679] = {.lex_state = 157, .external_lex_state = 29},
  [5680] = {.lex_state = 197, .external_lex_state = 5},
  [5681] = {.lex_state = 197, .external_lex_state = 5},
  [5682] = {.lex_state = 157, .external_lex_state = 2},
  [5683] = {.lex_state = 157, .external_lex_state = 28},
  [5684] = {.lex_state = 157, .external_lex_state = 2},
  [5685] = {.lex_state = 157, .external_lex_state = 2},
  [5686] = {.lex_state = 157, .external_lex_state = 2},
  [5687] = {.lex_state = 157, .external_lex_state = 2},
  [5688] = {.lex_state = 157, .external_lex_state = 2},
  [5689] = {.lex_state = 157, .external_lex_state = 2},
  [5690] = {.lex_state = 157, .external_lex_state = 2},
  [5691] = {.lex_state = 157, .external_lex_state = 2},
  [5692] = {.lex_state = 157, .external_lex_state = 2},
  [5693] = {.lex_state = 300, .external_lex_state = 27},
  [5694] = {.lex_state = 164},
  [5695] = {.lex_state = 271, .external_lex_state = 9},
  [5696] = {.lex_state = 228},
  [5697] = {.lex_state = 157, .external_lex_state = 2},
  [5698] = {.lex_state = 157, .external_lex_state = 2},
  [5699] = {.lex_state = 157, .external_lex_state = 2},
  [5700] = {.lex_state = 268, .external_lex_state = 5},
  [5701] = {.lex_state = 268, .external_lex_state = 5},
  [5702] = {.lex_state = 268, .external_lex_state = 14},
  [5703] = {.lex_state = 268, .external_lex_state = 5},
  [5704] = {.lex_state = 197, .external_lex_state = 14},
  [5705] = {.lex_state = 197, .external_lex_state = 5},
  [5706] = {.lex_state = 197, .external_lex_state = 5},
  [5707] = {.lex_state = 197, .external_lex_state = 5},
  [5708] = {.lex_state = 197, .external_lex_state = 5},
  [5709] = {.lex_state = 197, .external_lex_state = 5},
  [5710] = {.lex_state = 197, .external_lex_state = 5},
  [5711] = {.lex_state = 135},
  [5712] = {.lex_state = 223, .external_lex_state = 9},
  [5713] = {.lex_state = 266, .external_lex_state = 6},
  [5714] = {.lex_state = 223, .external_lex_state = 9},
  [5715] = {.lex_state = 223, .external_lex_state = 9},
  [5716] = {.lex_state = 300, .external_lex_state = 27},
  [5717] = {.lex_state = 223, .external_lex_state = 9},
  [5718] = {.lex_state = 157, .external_lex_state = 2},
  [5719] = {.lex_state = 157, .external_lex_state = 2},
  [5720] = {.lex_state = 157, .external_lex_state = 2},
  [5721] = {.lex_state = 157, .external_lex_state = 2},
  [5722] = {.lex_state = 208, .external_lex_state = 5},
  [5723] = {.lex_state = 197, .external_lex_state = 5},
  [5724] = {.lex_state = 157},
  [5725] = {.lex_state = 197, .external_lex_state = 5},
  [5726] = {.lex_state = 135, .external_lex_state = 2},
  [5727] = {.lex_state = 268, .external_lex_state = 5},
  [5728] = {.lex_state = 268, .external_lex_state = 14},
  [5729] = {.lex_state = 157, .external_lex_state = 2},
  [5730] = {.lex_state = 268, .external_lex_state = 5},
  [5731] = {.lex_state = 157, .external_lex_state = 2},
  [5732] = {.lex_state = 223, .external_lex_state = 9},
  [5733] = {.lex_state = 223, .external_lex_state = 9},
  [5734] = {.lex_state = 157, .external_lex_state = 2},
  [5735] = {.lex_state = 157, .external_lex_state = 2},
  [5736] = {.lex_state = 223, .external_lex_state = 9},
  [5737] = {.lex_state = 157, .external_lex_state = 2},
  [5738] = {.lex_state = 223, .external_lex_state = 9},
  [5739] = {.lex_state = 208, .external_lex_state = 5},
  [5740] = {.lex_state = 208, .external_lex_state = 5},
  [5741] = {.lex_state = 208, .external_lex_state = 5},
  [5742] = {.lex_state = 223, .external_lex_state = 9},
  [5743] = {.lex_state = 157},
  [5744] = {.lex_state = 208, .external_lex_state = 14},
  [5745] = {.lex_state = 208, .external_lex_state = 5},
  [5746] = {.lex_state = 208, .external_lex_state = 5},
  [5747] = {.lex_state = 157, .external_lex_state = 28},
  [5748] = {.lex_state = 157, .external_lex_state = 29},
  [5749] = {.lex_state = 208, .external_lex_state = 5},
  [5750] = {.lex_state = 208, .external_lex_state = 5},
  [5751] = {.lex_state = 157, .external_lex_state = 2},
  [5752] = {.lex_state = 157, .external_lex_state = 2},
  [5753] = {.lex_state = 157, .external_lex_state = 2},
  [5754] = {.lex_state = 157, .external_lex_state = 2},
  [5755] = {.lex_state = 157, .external_lex_state = 2},
  [5756] = {.lex_state = 157, .external_lex_state = 2},
  [5757] = {.lex_state = 157, .external_lex_state = 2},
  [5758] = {.lex_state = 157, .external_lex_state = 2},
  [5759] = {.lex_state = 157, .external_lex_state = 2},
  [5760] = {.lex_state = 157, .external_lex_state = 2},
  [5761] = {.lex_state = 268, .external_lex_state = 14},
  [5762] = {.lex_state = 197, .external_lex_state = 5},
  [5763] = {.lex_state = 197, .external_lex_state = 5},
  [5764] = {.lex_state = 197, .external_lex_state = 5},
  [5765] = {.lex_state = 197, .external_lex_state = 5},
  [5766] = {.lex_state = 197, .external_lex_state = 5},
  [5767] = {.lex_state = 359, .external_lex_state = 20},
  [5768] = {.lex_state = 197, .external_lex_state = 5},
  [5769] = {.lex_state = 197, .external_lex_state = 5},
  [5770] = {.lex_state = 197, .external_lex_state = 5},
  [5771] = {.lex_state = 197, .external_lex_state = 5},
  [5772] = {.lex_state = 197, .external_lex_state = 5},
  [5773] = {.lex_state = 197, .external_lex_state = 14},
  [5774] = {.lex_state = 135, .external_lex_state = 13},
  [5775] = {.lex_state = 245, .external_lex_state = 17},
  [5776] = {.lex_state = 228},
  [5777] = {.lex_state = 157, .external_lex_state = 2},
  [5778] = {.lex_state = 157, .external_lex_state = 2},
  [5779] = {.lex_state = 157, .external_lex_state = 2},
  [5780] = {.lex_state = 197, .external_lex_state = 16},
  [5781] = {.lex_state = 197, .external_lex_state = 16},
  [5782] = {.lex_state = 197, .external_lex_state = 19},
  [5783] = {.lex_state = 197, .external_lex_state = 16},
  [5784] = {.lex_state = 197, .external_lex_state = 20},
  [5785] = {.lex_state = 197, .external_lex_state = 20},
  [5786] = {.lex_state = 223, .external_lex_state = 21},
  [5787] = {.lex_state = 157, .external_lex_state = 2},
  [5788] = {.lex_state = 157, .external_lex_state = 28},
  [5789] = {.lex_state = 157, .external_lex_state = 2},
  [5790] = {.lex_state = 157, .external_lex_state = 2},
  [5791] = {.lex_state = 157, .external_lex_state = 2},
  [5792] = {.lex_state = 157, .external_lex_state = 2},
  [5793] = {.lex_state = 157, .external_lex_state = 2},
  [5794] = {.lex_state = 157, .external_lex_state = 2},
  [5795] = {.lex_state = 157, .external_lex_state = 2},
  [5796] = {.lex_state = 157, .external_lex_state = 2},
  [5797] = {.lex_state = 157, .external_lex_state = 2},
  [5798] = {.lex_state = 157, .external_lex_state = 2},
  [5799] = {.lex_state = 300, .external_lex_state = 27},
  [5800] = {.lex_state = 164},
  [5801] = {.lex_state = 232, .external_lex_state = 7},
  [5802] = {.lex_state = 208, .external_lex_state = 20},
  [5803] = {.lex_state = 197, .external_lex_state = 23},
  [5804] = {.lex_state = 232, .external_lex_state = 2},
  [5805] = {.lex_state = 135},
  [5806] = {.lex_state = 157},
  [5807] = {.lex_state = 215},
  [5808] = {.lex_state = 197},
  [5809] = {.lex_state = 197, .external_lex_state = 5},
  [5810] = {.lex_state = 220, .external_lex_state = 21},
  [5811] = {.lex_state = 220, .external_lex_state = 21},
  [5812] = {.lex_state = 157, .external_lex_state = 2},
  [5813] = {.lex_state = 157, .external_lex_state = 2},
  [5814] = {.lex_state = 220, .external_lex_state = 21},
  [5815] = {.lex_state = 157, .external_lex_state = 2},
  [5816] = {.lex_state = 220, .external_lex_state = 21},
  [5817] = {.lex_state = 277, .external_lex_state = 20},
  [5818] = {.lex_state = 274, .external_lex_state = 20},
  [5819] = {.lex_state = 157},
  [5820] = {.lex_state = 274, .external_lex_state = 23},
  [5821] = {.lex_state = 274, .external_lex_state = 20},
  [5822] = {.lex_state = 220},
  [5823] = {.lex_state = 220},
  [5824] = {.lex_state = 220},
  [5825] = {.lex_state = 135},
  [5826] = {.lex_state = 220},
  [5827] = {.lex_state = 274, .external_lex_state = 16},
  [5828] = {.lex_state = 157, .external_lex_state = 2},
  [5829] = {.lex_state = 274, .external_lex_state = 16},
  [5830] = {.lex_state = 157, .external_lex_state = 2},
  [5831] = {.lex_state = 157, .external_lex_state = 2},
  [5832] = {.lex_state = 157, .external_lex_state = 2},
  [5833] = {.lex_state = 157, .external_lex_state = 2},
  [5834] = {.lex_state = 277, .external_lex_state = 16},
  [5835] = {.lex_state = 274, .external_lex_state = 16},
  [5836] = {.lex_state = 157},
  [5837] = {.lex_state = 274, .external_lex_state = 16},
  [5838] = {.lex_state = 274, .external_lex_state = 16},
  [5839] = {.lex_state = 157, .external_lex_state = 29},
  [5840] = {.lex_state = 274, .external_lex_state = 16},
  [5841] = {.lex_state = 274, .external_lex_state = 16},
  [5842] = {.lex_state = 157, .external_lex_state = 2},
  [5843] = {.lex_state = 157, .external_lex_state = 28},
  [5844] = {.lex_state = 157, .external_lex_state = 2},
  [5845] = {.lex_state = 157, .external_lex_state = 2},
  [5846] = {.lex_state = 157, .external_lex_state = 2},
  [5847] = {.lex_state = 157, .external_lex_state = 2},
  [5848] = {.lex_state = 157, .external_lex_state = 2},
  [5849] = {.lex_state = 157, .external_lex_state = 2},
  [5850] = {.lex_state = 157, .external_lex_state = 2},
  [5851] = {.lex_state = 157, .external_lex_state = 2},
  [5852] = {.lex_state = 157, .external_lex_state = 2},
  [5853] = {.lex_state = 274, .external_lex_state = 20},
  [5854] = {.lex_state = 157, .external_lex_state = 2},
  [5855] = {.lex_state = 274, .external_lex_state = 20},
  [5856] = {.lex_state = 274, .external_lex_state = 20},
  [5857] = {.lex_state = 274, .external_lex_state = 20},
  [5858] = {.lex_state = 274, .external_lex_state = 20},
  [5859] = {.lex_state = 359, .external_lex_state = 20},
  [5860] = {.lex_state = 274, .external_lex_state = 20},
  [5861] = {.lex_state = 274, .external_lex_state = 20},
  [5862] = {.lex_state = 274, .external_lex_state = 20},
  [5863] = {.lex_state = 274, .external_lex_state = 20},
  [5864] = {.lex_state = 164, .external_lex_state = 3},
  [5865] = {.lex_state = 274, .external_lex_state = 20},
  [5866] = {.lex_state = 274, .external_lex_state = 20},
  [5867] = {.lex_state = 274, .external_lex_state = 20},
  [5868] = {.lex_state = 223, .external_lex_state = 21},
  [5869] = {.lex_state = 266, .external_lex_state = 6},
  [5870] = {.lex_state = 223, .external_lex_state = 21},
  [5871] = {.lex_state = 223, .external_lex_state = 21},
  [5872] = {.lex_state = 300, .external_lex_state = 27},
  [5873] = {.lex_state = 223, .external_lex_state = 21},
  [5874] = {.lex_state = 344, .external_lex_state = 16},
  [5875] = {.lex_state = 344, .external_lex_state = 19},
  [5876] = {.lex_state = 157, .external_lex_state = 2},
  [5877] = {.lex_state = 344, .external_lex_state = 16},
  [5878] = {.lex_state = 157, .external_lex_state = 2},
  [5879] = {.lex_state = 223, .external_lex_state = 17},
  [5880] = {.lex_state = 223, .external_lex_state = 17},
  [5881] = {.lex_state = 157, .external_lex_state = 2},
  [5882] = {.lex_state = 157, .external_lex_state = 2},
  [5883] = {.lex_state = 223, .external_lex_state = 17},
  [5884] = {.lex_state = 157, .external_lex_state = 2},
  [5885] = {.lex_state = 223, .external_lex_state = 17},
  [5886] = {.lex_state = 277, .external_lex_state = 16},
  [5887] = {.lex_state = 277, .external_lex_state = 16},
  [5888] = {.lex_state = 277, .external_lex_state = 16},
  [5889] = {.lex_state = 223, .external_lex_state = 17},
  [5890] = {.lex_state = 157},
  [5891] = {.lex_state = 277, .external_lex_state = 19},
  [5892] = {.lex_state = 277, .external_lex_state = 16},
  [5893] = {.lex_state = 277, .external_lex_state = 16},
  [5894] = {.lex_state = 157, .external_lex_state = 28},
  [5895] = {.lex_state = 157, .external_lex_state = 29},
  [5896] = {.lex_state = 277, .external_lex_state = 16},
  [5897] = {.lex_state = 277, .external_lex_state = 16},
  [5898] = {.lex_state = 157, .external_lex_state = 2},
  [5899] = {.lex_state = 157, .external_lex_state = 2},
  [5900] = {.lex_state = 157, .external_lex_state = 2},
  [5901] = {.lex_state = 157, .external_lex_state = 2},
  [5902] = {.lex_state = 157, .external_lex_state = 2},
  [5903] = {.lex_state = 157, .external_lex_state = 2},
  [5904] = {.lex_state = 157, .external_lex_state = 2},
  [5905] = {.lex_state = 157, .external_lex_state = 2},
  [5906] = {.lex_state = 157, .external_lex_state = 2},
  [5907] = {.lex_state = 157, .external_lex_state = 2},
  [5908] = {.lex_state = 344, .external_lex_state = 19},
  [5909] = {.lex_state = 274, .external_lex_state = 23},
  [5910] = {.lex_state = 135, .external_lex_state = 10},
  [5911] = {.lex_state = 232, .external_lex_state = 2},
  [5912] = {.lex_state = 197, .external_lex_state = 13},
  [5913] = {.lex_state = 135},
  [5914] = {.lex_state = 197, .external_lex_state = 5},
  [5915] = {.lex_state = 197, .external_lex_state = 5},
  [5916] = {.lex_state = 135, .external_lex_state = 2},
  [5917] = {.lex_state = 135, .external_lex_state = 10},
  [5918] = {.lex_state = 220},
  [5919] = {.lex_state = 157},
  [5920] = {.lex_state = 197, .external_lex_state = 13},
  [5921] = {.lex_state = 197, .external_lex_state = 5},
  [5922] = {.lex_state = 135},
  [5923] = {.lex_state = 197, .external_lex_state = 5},
  [5924] = {.lex_state = 135},
  [5925] = {.lex_state = 197, .external_lex_state = 5},
  [5926] = {.lex_state = 217, .external_lex_state = 4},
  [5927] = {.lex_state = 197, .external_lex_state = 5},
  [5928] = {.lex_state = 234, .external_lex_state = 15},
  [5929] = {.lex_state = 197, .external_lex_state = 5},
  [5930] = {.lex_state = 217, .external_lex_state = 4},
  [5931] = {.lex_state = 197, .external_lex_state = 5},
  [5932] = {.lex_state = 197, .external_lex_state = 5},
  [5933] = {.lex_state = 135},
  [5934] = {.lex_state = 135, .external_lex_state = 2},
  [5935] = {.lex_state = 197, .external_lex_state = 5},
  [5936] = {.lex_state = 135, .external_lex_state = 2},
  [5937] = {.lex_state = 135},
  [5938] = {.lex_state = 135, .external_lex_state = 10},
  [5939] = {.lex_state = 197, .external_lex_state = 5},
  [5940] = {.lex_state = 215},
  [5941] = {.lex_state = 157},
  [5942] = {.lex_state = 197, .external_lex_state = 5},
  [5943] = {.lex_state = 197, .external_lex_state = 5},
  [5944] = {.lex_state = 197, .external_lex_state = 5},
  [5945] = {.lex_state = 197, .external_lex_state = 5},
  [5946] = {.lex_state = 197, .external_lex_state = 5},
  [5947] = {.lex_state = 197, .external_lex_state = 5},
  [5948] = {.lex_state = 217, .external_lex_state = 22},
  [5949] = {.lex_state = 197, .external_lex_state = 5},
  [5950] = {.lex_state = 157, .external_lex_state = 6},
  [5951] = {.lex_state = 197, .external_lex_state = 5},
  [5952] = {.lex_state = 197, .external_lex_state = 5},
  [5953] = {.lex_state = 197, .external_lex_state = 5},
  [5954] = {.lex_state = 197, .external_lex_state = 5},
  [5955] = {.lex_state = 197, .external_lex_state = 5},
  [5956] = {.lex_state = 197, .external_lex_state = 5},
  [5957] = {.lex_state = 197, .external_lex_state = 5},
  [5958] = {.lex_state = 197, .external_lex_state = 5},
  [5959] = {.lex_state = 197, .external_lex_state = 5},
  [5960] = {.lex_state = 197, .external_lex_state = 5},
  [5961] = {.lex_state = 197, .external_lex_state = 5},
  [5962] = {.lex_state = 197, .external_lex_state = 5},
  [5963] = {.lex_state = 359, .external_lex_state = 20},
  [5964] = {.lex_state = 197, .external_lex_state = 5},
  [5965] = {.lex_state = 197, .external_lex_state = 5},
  [5966] = {.lex_state = 197, .external_lex_state = 5},
  [5967] = {.lex_state = 197, .external_lex_state = 5},
  [5968] = {.lex_state = 197, .external_lex_state = 5},
  [5969] = {.lex_state = 197, .external_lex_state = 14},
  [5970] = {.lex_state = 197, .external_lex_state = 5},
  [5971] = {.lex_state = 135},
  [5972] = {.lex_state = 135},
  [5973] = {.lex_state = 135},
  [5974] = {.lex_state = 274, .external_lex_state = 16},
  [5975] = {.lex_state = 274, .external_lex_state = 16},
  [5976] = {.lex_state = 157, .external_lex_state = 2},
  [5977] = {.lex_state = 157, .external_lex_state = 2},
  [5978] = {.lex_state = 274, .external_lex_state = 16},
  [5979] = {.lex_state = 274, .external_lex_state = 16},
  [5980] = {.lex_state = 274, .external_lex_state = 16},
  [5981] = {.lex_state = 157, .external_lex_state = 29},
  [5982] = {.lex_state = 274, .external_lex_state = 16},
  [5983] = {.lex_state = 274, .external_lex_state = 16},
  [5984] = {.lex_state = 274, .external_lex_state = 16},
  [5985] = {.lex_state = 274, .external_lex_state = 16},
  [5986] = {.lex_state = 274, .external_lex_state = 16},
  [5987] = {.lex_state = 274, .external_lex_state = 16},
  [5988] = {.lex_state = 223, .external_lex_state = 17},
  [5989] = {.lex_state = 157, .external_lex_state = 2},
  [5990] = {.lex_state = 157, .external_lex_state = 28},
  [5991] = {.lex_state = 157, .external_lex_state = 2},
  [5992] = {.lex_state = 157, .external_lex_state = 2},
  [5993] = {.lex_state = 157, .external_lex_state = 2},
  [5994] = {.lex_state = 157, .external_lex_state = 2},
  [5995] = {.lex_state = 157, .external_lex_state = 2},
  [5996] = {.lex_state = 157, .external_lex_state = 2},
  [5997] = {.lex_state = 157, .external_lex_state = 2},
  [5998] = {.lex_state = 157, .external_lex_state = 2},
  [5999] = {.lex_state = 157, .external_lex_state = 2},
  [6000] = {.lex_state = 157, .external_lex_state = 2},
  [6001] = {.lex_state = 300, .external_lex_state = 27},
  [6002] = {.lex_state = 164},
  [6003] = {.lex_state = 274, .external_lex_state = 19},
  [6004] = {.lex_state = 217, .external_lex_state = 22},
  [6005] = {.lex_state = 266, .external_lex_state = 6},
  [6006] = {.lex_state = 266, .external_lex_state = 29},
  [6007] = {.lex_state = 220, .external_lex_state = 18},
  [6008] = {.lex_state = 274, .external_lex_state = 16},
  [6009] = {.lex_state = 157, .external_lex_state = 2},
  [6010] = {.lex_state = 274, .external_lex_state = 16},
  [6011] = {.lex_state = 274, .external_lex_state = 16},
  [6012] = {.lex_state = 274, .external_lex_state = 16},
  [6013] = {.lex_state = 274, .external_lex_state = 16},
  [6014] = {.lex_state = 359, .external_lex_state = 20},
  [6015] = {.lex_state = 274, .external_lex_state = 16},
  [6016] = {.lex_state = 274, .external_lex_state = 16},
  [6017] = {.lex_state = 274, .external_lex_state = 16},
  [6018] = {.lex_state = 274, .external_lex_state = 16},
  [6019] = {.lex_state = 274, .external_lex_state = 16},
  [6020] = {.lex_state = 274, .external_lex_state = 16},
  [6021] = {.lex_state = 274, .external_lex_state = 16},
  [6022] = {.lex_state = 271, .external_lex_state = 17},
  [6023] = {.lex_state = 266, .external_lex_state = 6},
  [6024] = {.lex_state = 271, .external_lex_state = 17},
  [6025] = {.lex_state = 271, .external_lex_state = 17},
  [6026] = {.lex_state = 300, .external_lex_state = 27},
  [6027] = {.lex_state = 271, .external_lex_state = 17},
  [6028] = {.lex_state = 157, .external_lex_state = 2},
  [6029] = {.lex_state = 157, .external_lex_state = 2},
  [6030] = {.lex_state = 344, .external_lex_state = 16},
  [6031] = {.lex_state = 344, .external_lex_state = 16},
  [6032] = {.lex_state = 344, .external_lex_state = 16},
  [6033] = {.lex_state = 157, .external_lex_state = 29},
  [6034] = {.lex_state = 344, .external_lex_state = 16},
  [6035] = {.lex_state = 344, .external_lex_state = 16},
  [6036] = {.lex_state = 274, .external_lex_state = 19},
  [6037] = {.lex_state = 135, .external_lex_state = 2},
  [6038] = {.lex_state = 197, .external_lex_state = 5},
  [6039] = {.lex_state = 135, .external_lex_state = 2},
  [6040] = {.lex_state = 197, .external_lex_state = 5},
  [6041] = {.lex_state = 197, .external_lex_state = 5},
  [6042] = {.lex_state = 135},
  [6043] = {.lex_state = 135},
  [6044] = {.lex_state = 197, .external_lex_state = 5},
  [6045] = {.lex_state = 135},
  [6046] = {.lex_state = 197, .external_lex_state = 5},
  [6047] = {.lex_state = 217, .external_lex_state = 4},
  [6048] = {.lex_state = 197, .external_lex_state = 5},
  [6049] = {.lex_state = 234, .external_lex_state = 15},
  [6050] = {.lex_state = 197, .external_lex_state = 5},
  [6051] = {.lex_state = 217, .external_lex_state = 4},
  [6052] = {.lex_state = 197, .external_lex_state = 5},
  [6053] = {.lex_state = 157, .external_lex_state = 6},
  [6054] = {.lex_state = 217, .external_lex_state = 22},
  [6055] = {.lex_state = 197, .external_lex_state = 5},
  [6056] = {.lex_state = 157, .external_lex_state = 28},
  [6057] = {.lex_state = 197, .external_lex_state = 5},
  [6058] = {.lex_state = 157, .external_lex_state = 2},
  [6059] = {.lex_state = 271, .external_lex_state = 9},
  [6060] = {.lex_state = 135},
  [6061] = {.lex_state = 271, .external_lex_state = 9},
  [6062] = {.lex_state = 268, .external_lex_state = 5},
  [6063] = {.lex_state = 268, .external_lex_state = 5},
  [6064] = {.lex_state = 215},
  [6065] = {.lex_state = 268, .external_lex_state = 5},
  [6066] = {.lex_state = 268, .external_lex_state = 5},
  [6067] = {.lex_state = 135, .external_lex_state = 2},
  [6068] = {.lex_state = 135},
  [6069] = {.lex_state = 135, .external_lex_state = 10},
  [6070] = {.lex_state = 268, .external_lex_state = 5},
  [6071] = {.lex_state = 268, .external_lex_state = 5},
  [6072] = {.lex_state = 268, .external_lex_state = 5},
  [6073] = {.lex_state = 217, .external_lex_state = 22},
  [6074] = {.lex_state = 268, .external_lex_state = 5},
  [6075] = {.lex_state = 157, .external_lex_state = 6},
  [6076] = {.lex_state = 268, .external_lex_state = 5},
  [6077] = {.lex_state = 268, .external_lex_state = 5},
  [6078] = {.lex_state = 268, .external_lex_state = 5},
  [6079] = {.lex_state = 197, .external_lex_state = 5},
  [6080] = {.lex_state = 197, .external_lex_state = 5},
  [6081] = {.lex_state = 157, .external_lex_state = 2},
  [6082] = {.lex_state = 157, .external_lex_state = 2},
  [6083] = {.lex_state = 197, .external_lex_state = 5},
  [6084] = {.lex_state = 197, .external_lex_state = 5},
  [6085] = {.lex_state = 197, .external_lex_state = 5},
  [6086] = {.lex_state = 157, .external_lex_state = 29},
  [6087] = {.lex_state = 197, .external_lex_state = 5},
  [6088] = {.lex_state = 197, .external_lex_state = 5},
  [6089] = {.lex_state = 197, .external_lex_state = 5},
  [6090] = {.lex_state = 197, .external_lex_state = 5},
  [6091] = {.lex_state = 197, .external_lex_state = 5},
  [6092] = {.lex_state = 197, .external_lex_state = 5},
  [6093] = {.lex_state = 157, .external_lex_state = 2},
  [6094] = {.lex_state = 157, .external_lex_state = 28},
  [6095] = {.lex_state = 157, .external_lex_state = 2},
  [6096] = {.lex_state = 157, .external_lex_state = 2},
  [6097] = {.lex_state = 157, .external_lex_state = 2},
  [6098] = {.lex_state = 157, .external_lex_state = 2},
  [6099] = {.lex_state = 157, .external_lex_state = 2},
  [6100] = {.lex_state = 157, .external_lex_state = 2},
  [6101] = {.lex_state = 157, .external_lex_state = 2},
  [6102] = {.lex_state = 157, .external_lex_state = 2},
  [6103] = {.lex_state = 157, .external_lex_state = 2},
  [6104] = {.lex_state = 197, .external_lex_state = 14},
  [6105] = {.lex_state = 157, .external_lex_state = 6},
  [6106] = {.lex_state = 197, .external_lex_state = 5},
  [6107] = {.lex_state = 197, .external_lex_state = 5},
  [6108] = {.lex_state = 197, .external_lex_state = 5},
  [6109] = {.lex_state = 197, .external_lex_state = 5},
  [6110] = {.lex_state = 197, .external_lex_state = 5},
  [6111] = {.lex_state = 197, .external_lex_state = 5},
  [6112] = {.lex_state = 197, .external_lex_state = 5},
  [6113] = {.lex_state = 197, .external_lex_state = 5},
  [6114] = {.lex_state = 359, .external_lex_state = 20},
  [6115] = {.lex_state = 197, .external_lex_state = 5},
  [6116] = {.lex_state = 197, .external_lex_state = 5},
  [6117] = {.lex_state = 197, .external_lex_state = 5},
  [6118] = {.lex_state = 197, .external_lex_state = 5},
  [6119] = {.lex_state = 197, .external_lex_state = 5},
  [6120] = {.lex_state = 197, .external_lex_state = 5},
  [6121] = {.lex_state = 197, .external_lex_state = 5},
  [6122] = {.lex_state = 197, .external_lex_state = 14},
  [6123] = {.lex_state = 197, .external_lex_state = 5},
  [6124] = {.lex_state = 197, .external_lex_state = 5},
  [6125] = {.lex_state = 197, .external_lex_state = 5},
  [6126] = {.lex_state = 157, .external_lex_state = 2},
  [6127] = {.lex_state = 157, .external_lex_state = 28},
  [6128] = {.lex_state = 157, .external_lex_state = 2},
  [6129] = {.lex_state = 157, .external_lex_state = 2},
  [6130] = {.lex_state = 157, .external_lex_state = 2},
  [6131] = {.lex_state = 157, .external_lex_state = 2},
  [6132] = {.lex_state = 157, .external_lex_state = 2},
  [6133] = {.lex_state = 157, .external_lex_state = 2},
  [6134] = {.lex_state = 157, .external_lex_state = 2},
  [6135] = {.lex_state = 157, .external_lex_state = 2},
  [6136] = {.lex_state = 157, .external_lex_state = 2},
  [6137] = {.lex_state = 157, .external_lex_state = 2},
  [6138] = {.lex_state = 157, .external_lex_state = 28},
  [6139] = {.lex_state = 197, .external_lex_state = 5},
  [6140] = {.lex_state = 157, .external_lex_state = 2},
  [6141] = {.lex_state = 197, .external_lex_state = 5},
  [6142] = {.lex_state = 135},
  [6143] = {.lex_state = 135},
  [6144] = {.lex_state = 271, .external_lex_state = 9},
  [6145] = {.lex_state = 228},
  [6146] = {.lex_state = 157, .external_lex_state = 2},
  [6147] = {.lex_state = 157, .external_lex_state = 2},
  [6148] = {.lex_state = 157, .external_lex_state = 2},
  [6149] = {.lex_state = 197, .external_lex_state = 5},
  [6150] = {.lex_state = 197, .external_lex_state = 5},
  [6151] = {.lex_state = 197, .external_lex_state = 14},
  [6152] = {.lex_state = 197, .external_lex_state = 5},
  [6153] = {.lex_state = 197, .external_lex_state = 5},
  [6154] = {.lex_state = 197, .external_lex_state = 5},
  [6155] = {.lex_state = 197, .external_lex_state = 5},
  [6156] = {.lex_state = 223, .external_lex_state = 9},
  [6157] = {.lex_state = 157, .external_lex_state = 2},
  [6158] = {.lex_state = 157, .external_lex_state = 28},
  [6159] = {.lex_state = 157, .external_lex_state = 2},
  [6160] = {.lex_state = 157, .external_lex_state = 2},
  [6161] = {.lex_state = 157, .external_lex_state = 2},
  [6162] = {.lex_state = 157, .external_lex_state = 2},
  [6163] = {.lex_state = 157, .external_lex_state = 2},
  [6164] = {.lex_state = 157, .external_lex_state = 2},
  [6165] = {.lex_state = 157, .external_lex_state = 2},
  [6166] = {.lex_state = 157, .external_lex_state = 2},
  [6167] = {.lex_state = 157, .external_lex_state = 2},
  [6168] = {.lex_state = 157, .external_lex_state = 2},
  [6169] = {.lex_state = 300, .external_lex_state = 27},
  [6170] = {.lex_state = 164},
  [6171] = {.lex_state = 217, .external_lex_state = 22},
  [6172] = {.lex_state = 135, .external_lex_state = 2},
  [6173] = {.lex_state = 157, .external_lex_state = 28},
  [6174] = {.lex_state = 135, .external_lex_state = 2},
  [6175] = {.lex_state = 135},
  [6176] = {.lex_state = 197, .external_lex_state = 13},
  [6177] = {.lex_state = 271, .external_lex_state = 9},
  [6178] = {.lex_state = 228},
  [6179] = {.lex_state = 157, .external_lex_state = 2},
  [6180] = {.lex_state = 157, .external_lex_state = 2},
  [6181] = {.lex_state = 157, .external_lex_state = 2},
  [6182] = {.lex_state = 208, .external_lex_state = 5},
  [6183] = {.lex_state = 268, .external_lex_state = 5},
  [6184] = {.lex_state = 268, .external_lex_state = 14},
  [6185] = {.lex_state = 208, .external_lex_state = 5},
  [6186] = {.lex_state = 197, .external_lex_state = 14},
  [6187] = {.lex_state = 220, .external_lex_state = 13},
  [6188] = {.lex_state = 274, .external_lex_state = 5},
  [6189] = {.lex_state = 274, .external_lex_state = 5},
  [6190] = {.lex_state = 157, .external_lex_state = 2},
  [6191] = {.lex_state = 157, .external_lex_state = 2},
  [6192] = {.lex_state = 274, .external_lex_state = 5},
  [6193] = {.lex_state = 274, .external_lex_state = 5},
  [6194] = {.lex_state = 274, .external_lex_state = 5},
  [6195] = {.lex_state = 157, .external_lex_state = 29},
  [6196] = {.lex_state = 274, .external_lex_state = 5},
  [6197] = {.lex_state = 274, .external_lex_state = 5},
  [6198] = {.lex_state = 274, .external_lex_state = 5},
  [6199] = {.lex_state = 274, .external_lex_state = 5},
  [6200] = {.lex_state = 274, .external_lex_state = 5},
  [6201] = {.lex_state = 274, .external_lex_state = 5},
  [6202] = {.lex_state = 157, .external_lex_state = 2},
  [6203] = {.lex_state = 157, .external_lex_state = 28},
  [6204] = {.lex_state = 157, .external_lex_state = 2},
  [6205] = {.lex_state = 157, .external_lex_state = 2},
  [6206] = {.lex_state = 157, .external_lex_state = 2},
  [6207] = {.lex_state = 157, .external_lex_state = 2},
  [6208] = {.lex_state = 157, .external_lex_state = 2},
  [6209] = {.lex_state = 157, .external_lex_state = 2},
  [6210] = {.lex_state = 157, .external_lex_state = 2},
  [6211] = {.lex_state = 157, .external_lex_state = 2},
  [6212] = {.lex_state = 157, .external_lex_state = 2},
  [6213] = {.lex_state = 274, .external_lex_state = 14},
  [6214] = {.lex_state = 157, .external_lex_state = 6},
  [6215] = {.lex_state = 274, .external_lex_state = 5},
  [6216] = {.lex_state = 274, .external_lex_state = 5},
  [6217] = {.lex_state = 274, .external_lex_state = 5},
  [6218] = {.lex_state = 274, .external_lex_state = 5},
  [6219] = {.lex_state = 274, .external_lex_state = 5},
  [6220] = {.lex_state = 274, .external_lex_state = 5},
  [6221] = {.lex_state = 274, .external_lex_state = 5},
  [6222] = {.lex_state = 274, .external_lex_state = 5},
  [6223] = {.lex_state = 359, .external_lex_state = 20},
  [6224] = {.lex_state = 274, .external_lex_state = 5},
  [6225] = {.lex_state = 274, .external_lex_state = 5},
  [6226] = {.lex_state = 274, .external_lex_state = 5},
  [6227] = {.lex_state = 274, .external_lex_state = 5},
  [6228] = {.lex_state = 274, .external_lex_state = 5},
  [6229] = {.lex_state = 274, .external_lex_state = 5},
  [6230] = {.lex_state = 274, .external_lex_state = 5},
  [6231] = {.lex_state = 271, .external_lex_state = 9},
  [6232] = {.lex_state = 266, .external_lex_state = 6},
  [6233] = {.lex_state = 271, .external_lex_state = 9},
  [6234] = {.lex_state = 271, .external_lex_state = 9},
  [6235] = {.lex_state = 300, .external_lex_state = 27},
  [6236] = {.lex_state = 271, .external_lex_state = 9},
  [6237] = {.lex_state = 157, .external_lex_state = 2},
  [6238] = {.lex_state = 157, .external_lex_state = 2},
  [6239] = {.lex_state = 344, .external_lex_state = 5},
  [6240] = {.lex_state = 344, .external_lex_state = 5},
  [6241] = {.lex_state = 344, .external_lex_state = 5},
  [6242] = {.lex_state = 157, .external_lex_state = 29},
  [6243] = {.lex_state = 344, .external_lex_state = 5},
  [6244] = {.lex_state = 344, .external_lex_state = 5},
  [6245] = {.lex_state = 274, .external_lex_state = 14},
  [6246] = {.lex_state = 258, .external_lex_state = 6},
  [6247] = {.lex_state = 266, .external_lex_state = 6},
  [6248] = {.lex_state = 258, .external_lex_state = 6},
  [6249] = {.lex_state = 258, .external_lex_state = 6},
  [6250] = {.lex_state = 300, .external_lex_state = 27},
  [6251] = {.lex_state = 258, .external_lex_state = 6},
  [6252] = {.lex_state = 274, .external_lex_state = 16},
  [6253] = {.lex_state = 274, .external_lex_state = 19},
  [6254] = {.lex_state = 157, .external_lex_state = 2},
  [6255] = {.lex_state = 274, .external_lex_state = 16},
  [6256] = {.lex_state = 157, .external_lex_state = 2},
  [6257] = {.lex_state = 271, .external_lex_state = 17},
  [6258] = {.lex_state = 228},
  [6259] = {.lex_state = 157, .external_lex_state = 2},
  [6260] = {.lex_state = 157, .external_lex_state = 2},
  [6261] = {.lex_state = 157, .external_lex_state = 2},
  [6262] = {.lex_state = 274, .external_lex_state = 16},
  [6263] = {.lex_state = 274, .external_lex_state = 16},
  [6264] = {.lex_state = 274, .external_lex_state = 19},
  [6265] = {.lex_state = 274, .external_lex_state = 16},
  [6266] = {.lex_state = 387, .external_lex_state = 17},
  [6267] = {.lex_state = 387, .external_lex_state = 17},
  [6268] = {.lex_state = 157, .external_lex_state = 2},
  [6269] = {.lex_state = 157, .external_lex_state = 2},
  [6270] = {.lex_state = 387, .external_lex_state = 17},
  [6271] = {.lex_state = 157, .external_lex_state = 2},
  [6272] = {.lex_state = 387, .external_lex_state = 17},
  [6273] = {.lex_state = 277, .external_lex_state = 16},
  [6274] = {.lex_state = 372, .external_lex_state = 16},
  [6275] = {.lex_state = 157},
  [6276] = {.lex_state = 372, .external_lex_state = 19},
  [6277] = {.lex_state = 372, .external_lex_state = 16},
  [6278] = {.lex_state = 372, .external_lex_state = 16},
  [6279] = {.lex_state = 157, .external_lex_state = 28},
  [6280] = {.lex_state = 157, .external_lex_state = 29},
  [6281] = {.lex_state = 258, .external_lex_state = 18},
  [6282] = {.lex_state = 258, .external_lex_state = 18},
  [6283] = {.lex_state = 157, .external_lex_state = 2},
  [6284] = {.lex_state = 157, .external_lex_state = 2},
  [6285] = {.lex_state = 157, .external_lex_state = 2},
  [6286] = {.lex_state = 157, .external_lex_state = 2},
  [6287] = {.lex_state = 157, .external_lex_state = 2},
  [6288] = {.lex_state = 157, .external_lex_state = 2},
  [6289] = {.lex_state = 157, .external_lex_state = 2},
  [6290] = {.lex_state = 157, .external_lex_state = 2},
  [6291] = {.lex_state = 157, .external_lex_state = 2},
  [6292] = {.lex_state = 157, .external_lex_state = 2},
  [6293] = {.lex_state = 157, .external_lex_state = 2},
  [6294] = {.lex_state = 274, .external_lex_state = 19},
  [6295] = {.lex_state = 135, .external_lex_state = 2},
  [6296] = {.lex_state = 157, .external_lex_state = 8},
  [6297] = {.lex_state = 223, .external_lex_state = 9},
  [6298] = {.lex_state = 135},
  [6299] = {.lex_state = 223, .external_lex_state = 9},
  [6300] = {.lex_state = 274, .external_lex_state = 5},
  [6301] = {.lex_state = 274, .external_lex_state = 5},
  [6302] = {.lex_state = 274, .external_lex_state = 5},
  [6303] = {.lex_state = 157, .external_lex_state = 2},
  [6304] = {.lex_state = 157, .external_lex_state = 28},
  [6305] = {.lex_state = 157, .external_lex_state = 2},
  [6306] = {.lex_state = 157, .external_lex_state = 2},
  [6307] = {.lex_state = 157, .external_lex_state = 2},
  [6308] = {.lex_state = 157, .external_lex_state = 2},
  [6309] = {.lex_state = 157, .external_lex_state = 2},
  [6310] = {.lex_state = 157, .external_lex_state = 2},
  [6311] = {.lex_state = 157, .external_lex_state = 2},
  [6312] = {.lex_state = 157, .external_lex_state = 2},
  [6313] = {.lex_state = 157, .external_lex_state = 2},
  [6314] = {.lex_state = 157, .external_lex_state = 28},
  [6315] = {.lex_state = 274, .external_lex_state = 5},
  [6316] = {.lex_state = 277, .external_lex_state = 5},
  [6317] = {.lex_state = 277, .external_lex_state = 5},
  [6318] = {.lex_state = 277, .external_lex_state = 5},
  [6319] = {.lex_state = 277, .external_lex_state = 5},
  [6320] = {.lex_state = 157, .external_lex_state = 2},
  [6321] = {.lex_state = 157, .external_lex_state = 28},
  [6322] = {.lex_state = 157, .external_lex_state = 2},
  [6323] = {.lex_state = 157, .external_lex_state = 2},
  [6324] = {.lex_state = 157, .external_lex_state = 2},
  [6325] = {.lex_state = 157, .external_lex_state = 2},
  [6326] = {.lex_state = 157, .external_lex_state = 2},
  [6327] = {.lex_state = 157, .external_lex_state = 2},
  [6328] = {.lex_state = 157, .external_lex_state = 2},
  [6329] = {.lex_state = 157, .external_lex_state = 2},
  [6330] = {.lex_state = 157, .external_lex_state = 2},
  [6331] = {.lex_state = 277, .external_lex_state = 14},
  [6332] = {.lex_state = 344, .external_lex_state = 5},
  [6333] = {.lex_state = 344, .external_lex_state = 5},
  [6334] = {.lex_state = 157, .external_lex_state = 6},
  [6335] = {.lex_state = 277, .external_lex_state = 5},
  [6336] = {.lex_state = 277, .external_lex_state = 5},
  [6337] = {.lex_state = 277, .external_lex_state = 5},
  [6338] = {.lex_state = 344, .external_lex_state = 5},
  [6339] = {.lex_state = 344, .external_lex_state = 5},
  [6340] = {.lex_state = 344, .external_lex_state = 5},
  [6341] = {.lex_state = 359, .external_lex_state = 20},
  [6342] = {.lex_state = 344, .external_lex_state = 5},
  [6343] = {.lex_state = 344, .external_lex_state = 5},
  [6344] = {.lex_state = 344, .external_lex_state = 5},
  [6345] = {.lex_state = 344, .external_lex_state = 5},
  [6346] = {.lex_state = 344, .external_lex_state = 5},
  [6347] = {.lex_state = 344, .external_lex_state = 5},
  [6348] = {.lex_state = 344, .external_lex_state = 5},
  [6349] = {.lex_state = 344, .external_lex_state = 14},
  [6350] = {.lex_state = 157, .external_lex_state = 2},
  [6351] = {.lex_state = 197, .external_lex_state = 5},
  [6352] = {.lex_state = 197, .external_lex_state = 5},
  [6353] = {.lex_state = 258, .external_lex_state = 6},
  [6354] = {.lex_state = 135},
  [6355] = {.lex_state = 258, .external_lex_state = 6},
  [6356] = {.lex_state = 197, .external_lex_state = 16},
  [6357] = {.lex_state = 197, .external_lex_state = 16},
  [6358] = {.lex_state = 157, .external_lex_state = 2},
  [6359] = {.lex_state = 157, .external_lex_state = 2},
  [6360] = {.lex_state = 197, .external_lex_state = 16},
  [6361] = {.lex_state = 197, .external_lex_state = 16},
  [6362] = {.lex_state = 197, .external_lex_state = 16},
  [6363] = {.lex_state = 157, .external_lex_state = 29},
  [6364] = {.lex_state = 197, .external_lex_state = 16},
  [6365] = {.lex_state = 197, .external_lex_state = 16},
  [6366] = {.lex_state = 197, .external_lex_state = 16},
  [6367] = {.lex_state = 197, .external_lex_state = 16},
  [6368] = {.lex_state = 157, .external_lex_state = 2},
  [6369] = {.lex_state = 157, .external_lex_state = 28},
  [6370] = {.lex_state = 157, .external_lex_state = 2},
  [6371] = {.lex_state = 157, .external_lex_state = 2},
  [6372] = {.lex_state = 157, .external_lex_state = 2},
  [6373] = {.lex_state = 157, .external_lex_state = 2},
  [6374] = {.lex_state = 157, .external_lex_state = 2},
  [6375] = {.lex_state = 157, .external_lex_state = 2},
  [6376] = {.lex_state = 157, .external_lex_state = 2},
  [6377] = {.lex_state = 157, .external_lex_state = 2},
  [6378] = {.lex_state = 157, .external_lex_state = 2},
  [6379] = {.lex_state = 157, .external_lex_state = 2},
  [6380] = {.lex_state = 197, .external_lex_state = 19},
  [6381] = {.lex_state = 197, .external_lex_state = 16},
  [6382] = {.lex_state = 197, .external_lex_state = 16},
  [6383] = {.lex_state = 157, .external_lex_state = 6},
  [6384] = {.lex_state = 258, .external_lex_state = 18},
  [6385] = {.lex_state = 258, .external_lex_state = 18},
  [6386] = {.lex_state = 258, .external_lex_state = 18},
  [6387] = {.lex_state = 197, .external_lex_state = 16},
  [6388] = {.lex_state = 197, .external_lex_state = 16},
  [6389] = {.lex_state = 197, .external_lex_state = 16},
  [6390] = {.lex_state = 359, .external_lex_state = 20},
  [6391] = {.lex_state = 197, .external_lex_state = 16},
  [6392] = {.lex_state = 197, .external_lex_state = 16},
  [6393] = {.lex_state = 197, .external_lex_state = 16},
  [6394] = {.lex_state = 197, .external_lex_state = 16},
  [6395] = {.lex_state = 197, .external_lex_state = 16},
  [6396] = {.lex_state = 197, .external_lex_state = 16},
  [6397] = {.lex_state = 197, .external_lex_state = 16},
  [6398] = {.lex_state = 197, .external_lex_state = 19},
  [6399] = {.lex_state = 197, .external_lex_state = 13},
  [6400] = {.lex_state = 135, .external_lex_state = 2},
  [6401] = {.lex_state = 197, .external_lex_state = 5},
  [6402] = {.lex_state = 157, .external_lex_state = 2},
  [6403] = {.lex_state = 197, .external_lex_state = 5},
  [6404] = {.lex_state = 157, .external_lex_state = 2},
  [6405] = {.lex_state = 197, .external_lex_state = 5},
  [6406] = {.lex_state = 197, .external_lex_state = 5},
  [6407] = {.lex_state = 197, .external_lex_state = 5},
  [6408] = {.lex_state = 157, .external_lex_state = 29},
  [6409] = {.lex_state = 197, .external_lex_state = 5},
  [6410] = {.lex_state = 197, .external_lex_state = 5},
  [6411] = {.lex_state = 157, .external_lex_state = 2},
  [6412] = {.lex_state = 157, .external_lex_state = 28},
  [6413] = {.lex_state = 157, .external_lex_state = 2},
  [6414] = {.lex_state = 157, .external_lex_state = 2},
  [6415] = {.lex_state = 157, .external_lex_state = 2},
  [6416] = {.lex_state = 157, .external_lex_state = 2},
  [6417] = {.lex_state = 157, .external_lex_state = 2},
  [6418] = {.lex_state = 157, .external_lex_state = 2},
  [6419] = {.lex_state = 157, .external_lex_state = 2},
  [6420] = {.lex_state = 157, .external_lex_state = 2},
  [6421] = {.lex_state = 157, .external_lex_state = 2},
  [6422] = {.lex_state = 258, .external_lex_state = 25},
  [6423] = {.lex_state = 300, .external_lex_state = 27},
  [6424] = {.lex_state = 157, .external_lex_state = 6},
  [6425] = {.lex_state = 164},
  [6426] = {.lex_state = 157, .external_lex_state = 2},
  [6427] = {.lex_state = 157, .external_lex_state = 2},
  [6428] = {.lex_state = 232, .external_lex_state = 7},
  [6429] = {.lex_state = 271, .external_lex_state = 9},
  [6430] = {.lex_state = 157, .external_lex_state = 2},
  [6431] = {.lex_state = 228},
  [6432] = {.lex_state = 220, .external_lex_state = 9},
  [6433] = {.lex_state = 157, .external_lex_state = 2},
  [6434] = {.lex_state = 266, .external_lex_state = 6},
  [6435] = {.lex_state = 157, .external_lex_state = 2},
  [6436] = {.lex_state = 220, .external_lex_state = 9},
  [6437] = {.lex_state = 220, .external_lex_state = 9},
  [6438] = {.lex_state = 157, .external_lex_state = 2},
  [6439] = {.lex_state = 220, .external_lex_state = 9},
  [6440] = {.lex_state = 258, .external_lex_state = 13},
  [6441] = {.lex_state = 258, .external_lex_state = 13},
  [6442] = {.lex_state = 157},
  [6443] = {.lex_state = 258, .external_lex_state = 13},
  [6444] = {.lex_state = 268, .external_lex_state = 5},
  [6445] = {.lex_state = 197, .external_lex_state = 5},
  [6446] = {.lex_state = 197, .external_lex_state = 14},
  [6447] = {.lex_state = 258, .external_lex_state = 13},
  [6448] = {.lex_state = 135},
  [6449] = {.lex_state = 197, .external_lex_state = 5},
  [6450] = {.lex_state = 157, .external_lex_state = 2},
  [6451] = {.lex_state = 197, .external_lex_state = 5},
  [6452] = {.lex_state = 197, .external_lex_state = 5},
  [6453] = {.lex_state = 197, .external_lex_state = 5},
  [6454] = {.lex_state = 197, .external_lex_state = 5},
  [6455] = {.lex_state = 197, .external_lex_state = 5},
  [6456] = {.lex_state = 197, .external_lex_state = 5},
  [6457] = {.lex_state = 359, .external_lex_state = 20},
  [6458] = {.lex_state = 197, .external_lex_state = 5},
  [6459] = {.lex_state = 197, .external_lex_state = 5},
  [6460] = {.lex_state = 197, .external_lex_state = 5},
  [6461] = {.lex_state = 197, .external_lex_state = 5},
  [6462] = {.lex_state = 197, .external_lex_state = 5},
  [6463] = {.lex_state = 271, .external_lex_state = 9},
  [6464] = {.lex_state = 266, .external_lex_state = 6},
  [6465] = {.lex_state = 271, .external_lex_state = 9},
  [6466] = {.lex_state = 271, .external_lex_state = 9},
  [6467] = {.lex_state = 300, .external_lex_state = 27},
  [6468] = {.lex_state = 271, .external_lex_state = 9},
  [6469] = {.lex_state = 197, .external_lex_state = 13},
  [6470] = {.lex_state = 197, .external_lex_state = 13},
  [6471] = {.lex_state = 268, .external_lex_state = 5},
  [6472] = {.lex_state = 268, .external_lex_state = 14},
  [6473] = {.lex_state = 157, .external_lex_state = 2},
  [6474] = {.lex_state = 268, .external_lex_state = 5},
  [6475] = {.lex_state = 157, .external_lex_state = 2},
  [6476] = {.lex_state = 268, .external_lex_state = 5},
  [6477] = {.lex_state = 268, .external_lex_state = 5},
  [6478] = {.lex_state = 268, .external_lex_state = 5},
  [6479] = {.lex_state = 157, .external_lex_state = 28},
  [6480] = {.lex_state = 157, .external_lex_state = 29},
  [6481] = {.lex_state = 268, .external_lex_state = 5},
  [6482] = {.lex_state = 268, .external_lex_state = 5},
  [6483] = {.lex_state = 157, .external_lex_state = 2},
  [6484] = {.lex_state = 157, .external_lex_state = 2},
  [6485] = {.lex_state = 157, .external_lex_state = 2},
  [6486] = {.lex_state = 157, .external_lex_state = 2},
  [6487] = {.lex_state = 157, .external_lex_state = 2},
  [6488] = {.lex_state = 157, .external_lex_state = 2},
  [6489] = {.lex_state = 157, .external_lex_state = 2},
  [6490] = {.lex_state = 157, .external_lex_state = 2},
  [6491] = {.lex_state = 157, .external_lex_state = 2},
  [6492] = {.lex_state = 157, .external_lex_state = 2},
  [6493] = {.lex_state = 268, .external_lex_state = 14},
  [6494] = {.lex_state = 197, .external_lex_state = 14},
  [6495] = {.lex_state = 135, .external_lex_state = 2},
  [6496] = {.lex_state = 135},
  [6497] = {.lex_state = 197, .external_lex_state = 13},
  [6498] = {.lex_state = 135, .external_lex_state = 2},
  [6499] = {.lex_state = 197, .external_lex_state = 5},
  [6500] = {.lex_state = 197, .external_lex_state = 14},
  [6501] = {.lex_state = 157, .external_lex_state = 2},
  [6502] = {.lex_state = 197, .external_lex_state = 5},
  [6503] = {.lex_state = 271, .external_lex_state = 9},
  [6504] = {.lex_state = 157, .external_lex_state = 2},
  [6505] = {.lex_state = 271, .external_lex_state = 9},
  [6506] = {.lex_state = 228},
  [6507] = {.lex_state = 157, .external_lex_state = 2},
  [6508] = {.lex_state = 157, .external_lex_state = 2},
  [6509] = {.lex_state = 157, .external_lex_state = 2},
  [6510] = {.lex_state = 197, .external_lex_state = 5},
  [6511] = {.lex_state = 197, .external_lex_state = 5},
  [6512] = {.lex_state = 197, .external_lex_state = 14},
  [6513] = {.lex_state = 197, .external_lex_state = 5},
  [6514] = {.lex_state = 220, .external_lex_state = 9},
  [6515] = {.lex_state = 220, .external_lex_state = 9},
  [6516] = {.lex_state = 157, .external_lex_state = 2},
  [6517] = {.lex_state = 157, .external_lex_state = 2},
  [6518] = {.lex_state = 220, .external_lex_state = 9},
  [6519] = {.lex_state = 157, .external_lex_state = 2},
  [6520] = {.lex_state = 220, .external_lex_state = 9},
  [6521] = {.lex_state = 208, .external_lex_state = 5},
  [6522] = {.lex_state = 197, .external_lex_state = 5},
  [6523] = {.lex_state = 157},
  [6524] = {.lex_state = 197, .external_lex_state = 14},
  [6525] = {.lex_state = 197, .external_lex_state = 5},
  [6526] = {.lex_state = 197, .external_lex_state = 5},
  [6527] = {.lex_state = 157, .external_lex_state = 29},
  [6528] = {.lex_state = 197, .external_lex_state = 5},
  [6529] = {.lex_state = 197, .external_lex_state = 5},
  [6530] = {.lex_state = 157, .external_lex_state = 2},
  [6531] = {.lex_state = 157, .external_lex_state = 28},
  [6532] = {.lex_state = 157, .external_lex_state = 2},
  [6533] = {.lex_state = 157, .external_lex_state = 2},
  [6534] = {.lex_state = 157, .external_lex_state = 2},
  [6535] = {.lex_state = 157, .external_lex_state = 2},
  [6536] = {.lex_state = 157, .external_lex_state = 2},
  [6537] = {.lex_state = 157, .external_lex_state = 2},
  [6538] = {.lex_state = 157, .external_lex_state = 2},
  [6539] = {.lex_state = 157, .external_lex_state = 2},
  [6540] = {.lex_state = 157, .external_lex_state = 2},
  [6541] = {.lex_state = 300, .external_lex_state = 27},
  [6542] = {.lex_state = 164},
  [6543] = {.lex_state = 271, .external_lex_state = 9},
  [6544] = {.lex_state = 228},
  [6545] = {.lex_state = 157, .external_lex_state = 2},
  [6546] = {.lex_state = 157, .external_lex_state = 2},
  [6547] = {.lex_state = 157, .external_lex_state = 2},
  [6548] = {.lex_state = 268, .external_lex_state = 5},
  [6549] = {.lex_state = 268, .external_lex_state = 5},
  [6550] = {.lex_state = 268, .external_lex_state = 14},
  [6551] = {.lex_state = 268, .external_lex_state = 5},
  [6552] = {.lex_state = 197, .external_lex_state = 14},
  [6553] = {.lex_state = 197, .external_lex_state = 5},
  [6554] = {.lex_state = 197, .external_lex_state = 5},
  [6555] = {.lex_state = 197, .external_lex_state = 5},
  [6556] = {.lex_state = 197, .external_lex_state = 5},
  [6557] = {.lex_state = 197, .external_lex_state = 5},
  [6558] = {.lex_state = 223, .external_lex_state = 9},
  [6559] = {.lex_state = 266, .external_lex_state = 6},
  [6560] = {.lex_state = 223, .external_lex_state = 9},
  [6561] = {.lex_state = 223, .external_lex_state = 9},
  [6562] = {.lex_state = 300, .external_lex_state = 27},
  [6563] = {.lex_state = 223, .external_lex_state = 9},
  [6564] = {.lex_state = 157, .external_lex_state = 2},
  [6565] = {.lex_state = 157, .external_lex_state = 2},
  [6566] = {.lex_state = 157, .external_lex_state = 2},
  [6567] = {.lex_state = 157, .external_lex_state = 2},
  [6568] = {.lex_state = 208, .external_lex_state = 5},
  [6569] = {.lex_state = 197, .external_lex_state = 5},
  [6570] = {.lex_state = 157},
  [6571] = {.lex_state = 197, .external_lex_state = 5},
  [6572] = {.lex_state = 268, .external_lex_state = 5},
  [6573] = {.lex_state = 268, .external_lex_state = 14},
  [6574] = {.lex_state = 157, .external_lex_state = 2},
  [6575] = {.lex_state = 268, .external_lex_state = 5},
  [6576] = {.lex_state = 157, .external_lex_state = 2},
  [6577] = {.lex_state = 223, .external_lex_state = 9},
  [6578] = {.lex_state = 223, .external_lex_state = 9},
  [6579] = {.lex_state = 157, .external_lex_state = 2},
  [6580] = {.lex_state = 157, .external_lex_state = 2},
  [6581] = {.lex_state = 223, .external_lex_state = 9},
  [6582] = {.lex_state = 157, .external_lex_state = 2},
  [6583] = {.lex_state = 223, .external_lex_state = 9},
  [6584] = {.lex_state = 208, .external_lex_state = 5},
  [6585] = {.lex_state = 208, .external_lex_state = 5},
  [6586] = {.lex_state = 208, .external_lex_state = 5},
  [6587] = {.lex_state = 223, .external_lex_state = 9},
  [6588] = {.lex_state = 157},
  [6589] = {.lex_state = 208, .external_lex_state = 14},
  [6590] = {.lex_state = 208, .external_lex_state = 5},
  [6591] = {.lex_state = 208, .external_lex_state = 5},
  [6592] = {.lex_state = 157, .external_lex_state = 28},
  [6593] = {.lex_state = 157, .external_lex_state = 29},
  [6594] = {.lex_state = 208, .external_lex_state = 5},
  [6595] = {.lex_state = 208, .external_lex_state = 5},
  [6596] = {.lex_state = 157, .external_lex_state = 2},
  [6597] = {.lex_state = 157, .external_lex_state = 2},
  [6598] = {.lex_state = 157, .external_lex_state = 2},
  [6599] = {.lex_state = 157, .external_lex_state = 2},
  [6600] = {.lex_state = 157, .external_lex_state = 2},
  [6601] = {.lex_state = 157, .external_lex_state = 2},
  [6602] = {.lex_state = 157, .external_lex_state = 2},
  [6603] = {.lex_state = 157, .external_lex_state = 2},
  [6604] = {.lex_state = 157, .external_lex_state = 2},
  [6605] = {.lex_state = 157, .external_lex_state = 2},
  [6606] = {.lex_state = 268, .external_lex_state = 14},
  [6607] = {.lex_state = 197, .external_lex_state = 5},
  [6608] = {.lex_state = 197, .external_lex_state = 5},
  [6609] = {.lex_state = 197, .external_lex_state = 5},
  [6610] = {.lex_state = 197, .external_lex_state = 5},
  [6611] = {.lex_state = 197, .external_lex_state = 5},
  [6612] = {.lex_state = 359, .external_lex_state = 20},
  [6613] = {.lex_state = 197, .external_lex_state = 5},
  [6614] = {.lex_state = 197, .external_lex_state = 5},
  [6615] = {.lex_state = 197, .external_lex_state = 5},
  [6616] = {.lex_state = 197, .external_lex_state = 5},
  [6617] = {.lex_state = 197, .external_lex_state = 5},
  [6618] = {.lex_state = 197, .external_lex_state = 14},
  [6619] = {.lex_state = 135, .external_lex_state = 13},
  [6620] = {.lex_state = 197, .external_lex_state = 5},
  [6621] = {.lex_state = 197, .external_lex_state = 5},
  [6622] = {.lex_state = 157, .external_lex_state = 2},
  [6623] = {.lex_state = 157, .external_lex_state = 2},
  [6624] = {.lex_state = 197, .external_lex_state = 5},
  [6625] = {.lex_state = 197, .external_lex_state = 5},
  [6626] = {.lex_state = 197, .external_lex_state = 5},
  [6627] = {.lex_state = 157, .external_lex_state = 29},
  [6628] = {.lex_state = 197, .external_lex_state = 5},
  [6629] = {.lex_state = 197, .external_lex_state = 5},
  [6630] = {.lex_state = 197, .external_lex_state = 5},
  [6631] = {.lex_state = 197, .external_lex_state = 5},
  [6632] = {.lex_state = 197, .external_lex_state = 5},
  [6633] = {.lex_state = 197, .external_lex_state = 5},
  [6634] = {.lex_state = 157, .external_lex_state = 2},
  [6635] = {.lex_state = 157, .external_lex_state = 28},
  [6636] = {.lex_state = 157, .external_lex_state = 2},
  [6637] = {.lex_state = 157, .external_lex_state = 2},
  [6638] = {.lex_state = 157, .external_lex_state = 2},
  [6639] = {.lex_state = 157, .external_lex_state = 2},
  [6640] = {.lex_state = 157, .external_lex_state = 2},
  [6641] = {.lex_state = 157, .external_lex_state = 2},
  [6642] = {.lex_state = 157, .external_lex_state = 2},
  [6643] = {.lex_state = 157, .external_lex_state = 2},
  [6644] = {.lex_state = 157, .external_lex_state = 2},
  [6645] = {.lex_state = 197, .external_lex_state = 14},
  [6646] = {.lex_state = 157, .external_lex_state = 6},
  [6647] = {.lex_state = 197, .external_lex_state = 5},
  [6648] = {.lex_state = 197, .external_lex_state = 5},
  [6649] = {.lex_state = 197, .external_lex_state = 5},
  [6650] = {.lex_state = 197, .external_lex_state = 5},
  [6651] = {.lex_state = 197, .external_lex_state = 5},
  [6652] = {.lex_state = 197, .external_lex_state = 5},
  [6653] = {.lex_state = 197, .external_lex_state = 5},
  [6654] = {.lex_state = 197, .external_lex_state = 5},
  [6655] = {.lex_state = 359, .external_lex_state = 20},
  [6656] = {.lex_state = 197, .external_lex_state = 5},
  [6657] = {.lex_state = 197, .external_lex_state = 5},
  [6658] = {.lex_state = 197, .external_lex_state = 5},
  [6659] = {.lex_state = 197, .external_lex_state = 5},
  [6660] = {.lex_state = 197, .external_lex_state = 5},
  [6661] = {.lex_state = 197, .external_lex_state = 5},
  [6662] = {.lex_state = 197, .external_lex_state = 5},
  [6663] = {.lex_state = 271, .external_lex_state = 9},
  [6664] = {.lex_state = 266, .external_lex_state = 6},
  [6665] = {.lex_state = 271, .external_lex_state = 9},
  [6666] = {.lex_state = 271, .external_lex_state = 9},
  [6667] = {.lex_state = 300, .external_lex_state = 27},
  [6668] = {.lex_state = 271, .external_lex_state = 9},
  [6669] = {.lex_state = 157, .external_lex_state = 2},
  [6670] = {.lex_state = 157, .external_lex_state = 2},
  [6671] = {.lex_state = 268, .external_lex_state = 5},
  [6672] = {.lex_state = 268, .external_lex_state = 5},
  [6673] = {.lex_state = 268, .external_lex_state = 5},
  [6674] = {.lex_state = 157, .external_lex_state = 29},
  [6675] = {.lex_state = 268, .external_lex_state = 5},
  [6676] = {.lex_state = 268, .external_lex_state = 5},
  [6677] = {.lex_state = 197, .external_lex_state = 14},
  [6678] = {.lex_state = 223, .external_lex_state = 9},
  [6679] = {.lex_state = 135},
  [6680] = {.lex_state = 223, .external_lex_state = 9},
  [6681] = {.lex_state = 197, .external_lex_state = 5},
  [6682] = {.lex_state = 197, .external_lex_state = 5},
  [6683] = {.lex_state = 197, .external_lex_state = 5},
  [6684] = {.lex_state = 157, .external_lex_state = 2},
  [6685] = {.lex_state = 157, .external_lex_state = 28},
  [6686] = {.lex_state = 157, .external_lex_state = 2},
  [6687] = {.lex_state = 157, .external_lex_state = 2},
  [6688] = {.lex_state = 157, .external_lex_state = 2},
  [6689] = {.lex_state = 157, .external_lex_state = 2},
  [6690] = {.lex_state = 157, .external_lex_state = 2},
  [6691] = {.lex_state = 157, .external_lex_state = 2},
  [6692] = {.lex_state = 157, .external_lex_state = 2},
  [6693] = {.lex_state = 157, .external_lex_state = 2},
  [6694] = {.lex_state = 157, .external_lex_state = 2},
  [6695] = {.lex_state = 157, .external_lex_state = 28},
  [6696] = {.lex_state = 197, .external_lex_state = 5},
  [6697] = {.lex_state = 197, .external_lex_state = 5},
  [6698] = {.lex_state = 208, .external_lex_state = 5},
  [6699] = {.lex_state = 208, .external_lex_state = 5},
  [6700] = {.lex_state = 208, .external_lex_state = 5},
  [6701] = {.lex_state = 208, .external_lex_state = 5},
  [6702] = {.lex_state = 157, .external_lex_state = 2},
  [6703] = {.lex_state = 157, .external_lex_state = 28},
  [6704] = {.lex_state = 157, .external_lex_state = 2},
  [6705] = {.lex_state = 157, .external_lex_state = 2},
  [6706] = {.lex_state = 157, .external_lex_state = 2},
  [6707] = {.lex_state = 157, .external_lex_state = 2},
  [6708] = {.lex_state = 157, .external_lex_state = 2},
  [6709] = {.lex_state = 157, .external_lex_state = 2},
  [6710] = {.lex_state = 157, .external_lex_state = 2},
  [6711] = {.lex_state = 157, .external_lex_state = 2},
  [6712] = {.lex_state = 157, .external_lex_state = 2},
  [6713] = {.lex_state = 208, .external_lex_state = 14},
  [6714] = {.lex_state = 268, .external_lex_state = 5},
  [6715] = {.lex_state = 268, .external_lex_state = 5},
  [6716] = {.lex_state = 157, .external_lex_state = 6},
  [6717] = {.lex_state = 208, .external_lex_state = 5},
  [6718] = {.lex_state = 208, .external_lex_state = 5},
  [6719] = {.lex_state = 208, .external_lex_state = 5},
  [6720] = {.lex_state = 268, .external_lex_state = 5},
  [6721] = {.lex_state = 268, .external_lex_state = 5},
  [6722] = {.lex_state = 268, .external_lex_state = 5},
  [6723] = {.lex_state = 359, .external_lex_state = 20},
  [6724] = {.lex_state = 268, .external_lex_state = 5},
  [6725] = {.lex_state = 268, .external_lex_state = 5},
  [6726] = {.lex_state = 268, .external_lex_state = 5},
  [6727] = {.lex_state = 268, .external_lex_state = 5},
  [6728] = {.lex_state = 268, .external_lex_state = 5},
  [6729] = {.lex_state = 268, .external_lex_state = 5},
  [6730] = {.lex_state = 268, .external_lex_state = 5},
  [6731] = {.lex_state = 268, .external_lex_state = 14},
  [6732] = {.lex_state = 157, .external_lex_state = 2},
  [6733] = {.lex_state = 135},
  [6734] = {.lex_state = 258, .external_lex_state = 6},
  [6735] = {.lex_state = 135},
  [6736] = {.lex_state = 258, .external_lex_state = 6},
  [6737] = {.lex_state = 316, .external_lex_state = 16},
  [6738] = {.lex_state = 316, .external_lex_state = 16},
  [6739] = {.lex_state = 157, .external_lex_state = 2},
  [6740] = {.lex_state = 157, .external_lex_state = 2},
  [6741] = {.lex_state = 197, .external_lex_state = 16},
  [6742] = {.lex_state = 197, .external_lex_state = 16},
  [6743] = {.lex_state = 197, .external_lex_state = 16},
  [6744] = {.lex_state = 157, .external_lex_state = 29},
  [6745] = {.lex_state = 197, .external_lex_state = 16},
  [6746] = {.lex_state = 197, .external_lex_state = 16},
  [6747] = {.lex_state = 245, .external_lex_state = 17},
  [6748] = {.lex_state = 228},
  [6749] = {.lex_state = 157, .external_lex_state = 2},
  [6750] = {.lex_state = 157, .external_lex_state = 2},
  [6751] = {.lex_state = 157, .external_lex_state = 2},
  [6752] = {.lex_state = 316, .external_lex_state = 16},
  [6753] = {.lex_state = 197, .external_lex_state = 16},
  [6754] = {.lex_state = 197, .external_lex_state = 19},
  [6755] = {.lex_state = 316, .external_lex_state = 16},
  [6756] = {.lex_state = 316, .external_lex_state = 16},
  [6757] = {.lex_state = 316, .external_lex_state = 16},
  [6758] = {.lex_state = 157, .external_lex_state = 2},
  [6759] = {.lex_state = 157, .external_lex_state = 28},
  [6760] = {.lex_state = 157, .external_lex_state = 2},
  [6761] = {.lex_state = 157, .external_lex_state = 2},
  [6762] = {.lex_state = 157, .external_lex_state = 2},
  [6763] = {.lex_state = 157, .external_lex_state = 2},
  [6764] = {.lex_state = 157, .external_lex_state = 2},
  [6765] = {.lex_state = 157, .external_lex_state = 2},
  [6766] = {.lex_state = 157, .external_lex_state = 2},
  [6767] = {.lex_state = 157, .external_lex_state = 2},
  [6768] = {.lex_state = 157, .external_lex_state = 2},
  [6769] = {.lex_state = 157, .external_lex_state = 2},
  [6770] = {.lex_state = 316, .external_lex_state = 19},
  [6771] = {.lex_state = 197, .external_lex_state = 16},
  [6772] = {.lex_state = 197, .external_lex_state = 16},
  [6773] = {.lex_state = 157, .external_lex_state = 6},
  [6774] = {.lex_state = 258, .external_lex_state = 18},
  [6775] = {.lex_state = 258, .external_lex_state = 18},
  [6776] = {.lex_state = 258, .external_lex_state = 18},
  [6777] = {.lex_state = 197, .external_lex_state = 16},
  [6778] = {.lex_state = 197, .external_lex_state = 16},
  [6779] = {.lex_state = 197, .external_lex_state = 16},
  [6780] = {.lex_state = 359, .external_lex_state = 20},
  [6781] = {.lex_state = 197, .external_lex_state = 16},
  [6782] = {.lex_state = 197, .external_lex_state = 16},
  [6783] = {.lex_state = 197, .external_lex_state = 16},
  [6784] = {.lex_state = 197, .external_lex_state = 16},
  [6785] = {.lex_state = 197, .external_lex_state = 16},
  [6786] = {.lex_state = 197, .external_lex_state = 16},
  [6787] = {.lex_state = 197, .external_lex_state = 16},
  [6788] = {.lex_state = 197, .external_lex_state = 19},
  [6789] = {.lex_state = 197, .external_lex_state = 13},
  [6790] = {.lex_state = 197, .external_lex_state = 5},
  [6791] = {.lex_state = 197, .external_lex_state = 5},
  [6792] = {.lex_state = 223, .external_lex_state = 9},
  [6793] = {.lex_state = 157, .external_lex_state = 2},
  [6794] = {.lex_state = 157, .external_lex_state = 2},
  [6795] = {.lex_state = 271, .external_lex_state = 9},
  [6796] = {.lex_state = 157, .external_lex_state = 2},
  [6797] = {.lex_state = 164},
  [6798] = {.lex_state = 228},
  [6799] = {.lex_state = 220, .external_lex_state = 9},
  [6800] = {.lex_state = 157, .external_lex_state = 2},
  [6801] = {.lex_state = 157, .external_lex_state = 2},
  [6802] = {.lex_state = 220, .external_lex_state = 9},
  [6803] = {.lex_state = 220, .external_lex_state = 9},
  [6804] = {.lex_state = 157, .external_lex_state = 2},
  [6805] = {.lex_state = 220, .external_lex_state = 9},
  [6806] = {.lex_state = 197, .external_lex_state = 5},
  [6807] = {.lex_state = 268, .external_lex_state = 5},
  [6808] = {.lex_state = 197, .external_lex_state = 5},
  [6809] = {.lex_state = 197, .external_lex_state = 5},
  [6810] = {.lex_state = 271, .external_lex_state = 9},
  [6811] = {.lex_state = 157},
  [6812] = {.lex_state = 197, .external_lex_state = 14},
  [6813] = {.lex_state = 197, .external_lex_state = 5},
  [6814] = {.lex_state = 157, .external_lex_state = 2},
  [6815] = {.lex_state = 157, .external_lex_state = 2},
  [6816] = {.lex_state = 157, .external_lex_state = 2},
  [6817] = {.lex_state = 217, .external_lex_state = 22},
  [6818] = {.lex_state = 157, .external_lex_state = 2},
  [6819] = {.lex_state = 157, .external_lex_state = 2},
  [6820] = {.lex_state = 135, .external_lex_state = 2},
  [6821] = {.lex_state = 300, .external_lex_state = 27},
  [6822] = {.lex_state = 164},
  [6823] = {.lex_state = 157, .external_lex_state = 28},
  [6824] = {.lex_state = 157, .external_lex_state = 2},
  [6825] = {.lex_state = 157, .external_lex_state = 2},
  [6826] = {.lex_state = 271, .external_lex_state = 9},
  [6827] = {.lex_state = 157, .external_lex_state = 2},
  [6828] = {.lex_state = 228},
  [6829] = {.lex_state = 271, .external_lex_state = 9},
  [6830] = {.lex_state = 157, .external_lex_state = 2},
  [6831] = {.lex_state = 157, .external_lex_state = 2},
  [6832] = {.lex_state = 271, .external_lex_state = 9},
  [6833] = {.lex_state = 271, .external_lex_state = 9},
  [6834] = {.lex_state = 157, .external_lex_state = 2},
  [6835] = {.lex_state = 271, .external_lex_state = 9},
  [6836] = {.lex_state = 268, .external_lex_state = 5},
  [6837] = {.lex_state = 157},
  [6838] = {.lex_state = 271, .external_lex_state = 9},
  [6839] = {.lex_state = 208, .external_lex_state = 5},
  [6840] = {.lex_state = 268, .external_lex_state = 5},
  [6841] = {.lex_state = 268, .external_lex_state = 5},
  [6842] = {.lex_state = 268, .external_lex_state = 14},
  [6843] = {.lex_state = 208, .external_lex_state = 5},
  [6844] = {.lex_state = 157, .external_lex_state = 2},
  [6845] = {.lex_state = 157, .external_lex_state = 2},
  [6846] = {.lex_state = 157, .external_lex_state = 2},
  [6847] = {.lex_state = 157, .external_lex_state = 2},
  [6848] = {.lex_state = 157, .external_lex_state = 2},
  [6849] = {.lex_state = 157, .external_lex_state = 2},
  [6850] = {.lex_state = 157, .external_lex_state = 2},
  [6851] = {.lex_state = 157, .external_lex_state = 2},
  [6852] = {.lex_state = 157, .external_lex_state = 2},
  [6853] = {.lex_state = 157, .external_lex_state = 2},
  [6854] = {.lex_state = 157, .external_lex_state = 2},
  [6855] = {.lex_state = 197, .external_lex_state = 14},
  [6856] = {.lex_state = 135, .external_lex_state = 13},
  [6857] = {.lex_state = 135, .external_lex_state = 2},
  [6858] = {.lex_state = 135, .external_lex_state = 2},
  [6859] = {.lex_state = 135, .external_lex_state = 13},
  [6860] = {.lex_state = 197, .external_lex_state = 5},
  [6861] = {.lex_state = 197, .external_lex_state = 5},
  [6862] = {.lex_state = 217, .external_lex_state = 4},
  [6863] = {.lex_state = 197, .external_lex_state = 5},
  [6864] = {.lex_state = 217, .external_lex_state = 30},
  [6865] = {.lex_state = 223, .external_lex_state = 9},
  [6866] = {.lex_state = 300, .external_lex_state = 27},
  [6867] = {.lex_state = 197, .external_lex_state = 5},
  [6868] = {.lex_state = 197, .external_lex_state = 5},
  [6869] = {.lex_state = 197, .external_lex_state = 5},
  [6870] = {.lex_state = 197, .external_lex_state = 5},
  [6871] = {.lex_state = 197, .external_lex_state = 5},
  [6872] = {.lex_state = 197, .external_lex_state = 5},
  [6873] = {.lex_state = 359, .external_lex_state = 20},
  [6874] = {.lex_state = 197, .external_lex_state = 5},
  [6875] = {.lex_state = 197, .external_lex_state = 5},
  [6876] = {.lex_state = 197, .external_lex_state = 5},
  [6877] = {.lex_state = 197, .external_lex_state = 5},
  [6878] = {.lex_state = 197, .external_lex_state = 5},
  [6879] = {.lex_state = 197, .external_lex_state = 5},
  [6880] = {.lex_state = 197, .external_lex_state = 5},
  [6881] = {.lex_state = 268, .external_lex_state = 5},
  [6882] = {.lex_state = 135},
  [6883] = {.lex_state = 268, .external_lex_state = 5},
  [6884] = {.lex_state = 135},
  [6885] = {.lex_state = 268, .external_lex_state = 5},
  [6886] = {.lex_state = 217, .external_lex_state = 4},
  [6887] = {.lex_state = 268, .external_lex_state = 5},
  [6888] = {.lex_state = 234, .external_lex_state = 15},
  [6889] = {.lex_state = 268, .external_lex_state = 5},
  [6890] = {.lex_state = 217, .external_lex_state = 4},
  [6891] = {.lex_state = 157, .external_lex_state = 2},
  [6892] = {.lex_state = 157, .external_lex_state = 2},
  [6893] = {.lex_state = 307, .external_lex_state = 5},
  [6894] = {.lex_state = 307, .external_lex_state = 5},
  [6895] = {.lex_state = 307, .external_lex_state = 5},
  [6896] = {.lex_state = 157, .external_lex_state = 29},
  [6897] = {.lex_state = 307, .external_lex_state = 5},
  [6898] = {.lex_state = 307, .external_lex_state = 5},
  [6899] = {.lex_state = 208, .external_lex_state = 5},
  [6900] = {.lex_state = 268, .external_lex_state = 5},
  [6901] = {.lex_state = 347, .external_lex_state = 9},
  [6902] = {.lex_state = 266, .external_lex_state = 6},
  [6903] = {.lex_state = 347, .external_lex_state = 9},
  [6904] = {.lex_state = 347, .external_lex_state = 9},
  [6905] = {.lex_state = 300, .external_lex_state = 27},
  [6906] = {.lex_state = 347, .external_lex_state = 9},
  [6907] = {.lex_state = 157, .external_lex_state = 2},
  [6908] = {.lex_state = 157, .external_lex_state = 2},
  [6909] = {.lex_state = 157, .external_lex_state = 2},
  [6910] = {.lex_state = 157, .external_lex_state = 2},
  [6911] = {.lex_state = 350, .external_lex_state = 5},
  [6912] = {.lex_state = 307, .external_lex_state = 5},
  [6913] = {.lex_state = 157},
  [6914] = {.lex_state = 307, .external_lex_state = 5},
  [6915] = {.lex_state = 157, .external_lex_state = 2},
  [6916] = {.lex_state = 157, .external_lex_state = 2},
  [6917] = {.lex_state = 350, .external_lex_state = 5},
  [6918] = {.lex_state = 350, .external_lex_state = 5},
  [6919] = {.lex_state = 350, .external_lex_state = 5},
  [6920] = {.lex_state = 157, .external_lex_state = 29},
  [6921] = {.lex_state = 350, .external_lex_state = 5},
  [6922] = {.lex_state = 350, .external_lex_state = 5},
  [6923] = {.lex_state = 307, .external_lex_state = 5},
  [6924] = {.lex_state = 307, .external_lex_state = 5},
  [6925] = {.lex_state = 307, .external_lex_state = 5},
  [6926] = {.lex_state = 359, .external_lex_state = 20},
  [6927] = {.lex_state = 307, .external_lex_state = 5},
  [6928] = {.lex_state = 307, .external_lex_state = 5},
  [6929] = {.lex_state = 307, .external_lex_state = 5},
  [6930] = {.lex_state = 307, .external_lex_state = 5},
  [6931] = {.lex_state = 307, .external_lex_state = 5},
  [6932] = {.lex_state = 307, .external_lex_state = 5},
  [6933] = {.lex_state = 307, .external_lex_state = 5},
  [6934] = {.lex_state = 307, .external_lex_state = 14},
  [6935] = {.lex_state = 268, .external_lex_state = 5},
  [6936] = {.lex_state = 135},
  [6937] = {.lex_state = 135, .external_lex_state = 2},
  [6938] = {.lex_state = 208, .external_lex_state = 5},
  [6939] = {.lex_state = 135},
  [6940] = {.lex_state = 135, .external_lex_state = 2},
  [6941] = {.lex_state = 157},
  [6942] = {.lex_state = 268, .external_lex_state = 5},
  [6943] = {.lex_state = 268, .external_lex_state = 5},
  [6944] = {.lex_state = 135, .external_lex_state = 2},
  [6945] = {.lex_state = 135},
  [6946] = {.lex_state = 208, .external_lex_state = 5},
  [6947] = {.lex_state = 135},
  [6948] = {.lex_state = 135},
  [6949] = {.lex_state = 135},
  [6950] = {.lex_state = 208, .external_lex_state = 5},
  [6951] = {.lex_state = 135, .external_lex_state = 15},
  [6952] = {.lex_state = 234, .external_lex_state = 15},
  [6953] = {.lex_state = 217, .external_lex_state = 4},
  [6954] = {.lex_state = 208, .external_lex_state = 5},
  [6955] = {.lex_state = 234, .external_lex_state = 15},
  [6956] = {.lex_state = 208, .external_lex_state = 5},
  [6957] = {.lex_state = 208, .external_lex_state = 5},
  [6958] = {.lex_state = 135, .external_lex_state = 2},
  [6959] = {.lex_state = 135},
  [6960] = {.lex_state = 197, .external_lex_state = 5},
  [6961] = {.lex_state = 135, .external_lex_state = 2},
  [6962] = {.lex_state = 135, .external_lex_state = 13},
  [6963] = {.lex_state = 208, .external_lex_state = 5},
  [6964] = {.lex_state = 135, .external_lex_state = 2},
  [6965] = {.lex_state = 208, .external_lex_state = 5},
  [6966] = {.lex_state = 135},
  [6967] = {.lex_state = 135},
  [6968] = {.lex_state = 208, .external_lex_state = 5},
  [6969] = {.lex_state = 135},
  [6970] = {.lex_state = 208, .external_lex_state = 5},
  [6971] = {.lex_state = 208, .external_lex_state = 5},
  [6972] = {.lex_state = 135, .external_lex_state = 15},
  [6973] = {.lex_state = 234, .external_lex_state = 15},
  [6974] = {.lex_state = 217, .external_lex_state = 4},
  [6975] = {.lex_state = 208, .external_lex_state = 5},
  [6976] = {.lex_state = 234, .external_lex_state = 15},
  [6977] = {.lex_state = 208, .external_lex_state = 5},
  [6978] = {.lex_state = 208, .external_lex_state = 5},
  [6979] = {.lex_state = 215},
  [6980] = {.lex_state = 135, .external_lex_state = 2},
  [6981] = {.lex_state = 135, .external_lex_state = 13},
  [6982] = {.lex_state = 208, .external_lex_state = 14},
  [6983] = {.lex_state = 208, .external_lex_state = 5},
  [6984] = {.lex_state = 208, .external_lex_state = 5},
  [6985] = {.lex_state = 274, .external_lex_state = 20},
  [6986] = {.lex_state = 135, .external_lex_state = 2},
  [6987] = {.lex_state = 164, .external_lex_state = 3},
  [6988] = {.lex_state = 135, .external_lex_state = 2},
  [6989] = {.lex_state = 135},
  [6990] = {.lex_state = 208, .external_lex_state = 5},
  [6991] = {.lex_state = 208, .external_lex_state = 5},
  [6992] = {.lex_state = 208, .external_lex_state = 5},
  [6993] = {.lex_state = 208, .external_lex_state = 5},
  [6994] = {.lex_state = 208, .external_lex_state = 5},
  [6995] = {.lex_state = 208, .external_lex_state = 5},
  [6996] = {.lex_state = 208, .external_lex_state = 5},
  [6997] = {.lex_state = 208, .external_lex_state = 5},
  [6998] = {.lex_state = 359, .external_lex_state = 20},
  [6999] = {.lex_state = 208, .external_lex_state = 5},
  [7000] = {.lex_state = 208, .external_lex_state = 5},
  [7001] = {.lex_state = 208, .external_lex_state = 5},
  [7002] = {.lex_state = 208, .external_lex_state = 5},
  [7003] = {.lex_state = 208, .external_lex_state = 5},
  [7004] = {.lex_state = 268, .external_lex_state = 5},
  [7005] = {.lex_state = 208, .external_lex_state = 14},
  [7006] = {.lex_state = 268, .external_lex_state = 5},
  [7007] = {.lex_state = 135},
  [7008] = {.lex_state = 135},
  [7009] = {.lex_state = 135},
  [7010] = {.lex_state = 135, .external_lex_state = 2},
  [7011] = {.lex_state = 268, .external_lex_state = 5},
  [7012] = {.lex_state = 135, .external_lex_state = 2},
  [7013] = {.lex_state = 268, .external_lex_state = 5},
  [7014] = {.lex_state = 268, .external_lex_state = 5},
  [7015] = {.lex_state = 135},
  [7016] = {.lex_state = 135},
  [7017] = {.lex_state = 268, .external_lex_state = 5},
  [7018] = {.lex_state = 135},
  [7019] = {.lex_state = 268, .external_lex_state = 5},
  [7020] = {.lex_state = 217, .external_lex_state = 4},
  [7021] = {.lex_state = 268, .external_lex_state = 5},
  [7022] = {.lex_state = 234, .external_lex_state = 15},
  [7023] = {.lex_state = 268, .external_lex_state = 5},
  [7024] = {.lex_state = 217, .external_lex_state = 4},
  [7025] = {.lex_state = 157, .external_lex_state = 28},
  [7026] = {.lex_state = 268, .external_lex_state = 5},
  [7027] = {.lex_state = 208, .external_lex_state = 5},
  [7028] = {.lex_state = 208, .external_lex_state = 5},
  [7029] = {.lex_state = 157, .external_lex_state = 2},
  [7030] = {.lex_state = 217, .external_lex_state = 4},
  [7031] = {.lex_state = 363, .external_lex_state = 16},
  [7032] = {.lex_state = 363, .external_lex_state = 19},
  [7033] = {.lex_state = 157, .external_lex_state = 2},
  [7034] = {.lex_state = 363, .external_lex_state = 16},
  [7035] = {.lex_state = 381, .external_lex_state = 17},
  [7036] = {.lex_state = 157, .external_lex_state = 2},
  [7037] = {.lex_state = 375, .external_lex_state = 17},
  [7038] = {.lex_state = 228},
  [7039] = {.lex_state = 157, .external_lex_state = 2},
  [7040] = {.lex_state = 157, .external_lex_state = 2},
  [7041] = {.lex_state = 157, .external_lex_state = 2},
  [7042] = {.lex_state = 363, .external_lex_state = 16},
  [7043] = {.lex_state = 363, .external_lex_state = 16},
  [7044] = {.lex_state = 382, .external_lex_state = 19},
  [7045] = {.lex_state = 363, .external_lex_state = 16},
  [7046] = {.lex_state = 353, .external_lex_state = 17},
  [7047] = {.lex_state = 353, .external_lex_state = 17},
  [7048] = {.lex_state = 157, .external_lex_state = 2},
  [7049] = {.lex_state = 157, .external_lex_state = 2},
  [7050] = {.lex_state = 353, .external_lex_state = 17},
  [7051] = {.lex_state = 157, .external_lex_state = 2},
  [7052] = {.lex_state = 164},
  [7053] = {.lex_state = 353, .external_lex_state = 17},
  [7054] = {.lex_state = 356, .external_lex_state = 16},
  [7055] = {.lex_state = 363, .external_lex_state = 16},
  [7056] = {.lex_state = 363, .external_lex_state = 16},
  [7057] = {.lex_state = 366, .external_lex_state = 17},
  [7058] = {.lex_state = 157},
  [7059] = {.lex_state = 363, .external_lex_state = 19},
  [7060] = {.lex_state = 363, .external_lex_state = 16},
  [7061] = {.lex_state = 363, .external_lex_state = 16},
  [7062] = {.lex_state = 157, .external_lex_state = 29},
  [7063] = {.lex_state = 363, .external_lex_state = 16},
  [7064] = {.lex_state = 363, .external_lex_state = 16},
  [7065] = {.lex_state = 157, .external_lex_state = 2},
  [7066] = {.lex_state = 157, .external_lex_state = 28},
  [7067] = {.lex_state = 157, .external_lex_state = 2},
  [7068] = {.lex_state = 157, .external_lex_state = 2},
  [7069] = {.lex_state = 157, .external_lex_state = 2},
  [7070] = {.lex_state = 157, .external_lex_state = 2},
  [7071] = {.lex_state = 157, .external_lex_state = 2},
  [7072] = {.lex_state = 157, .external_lex_state = 2},
  [7073] = {.lex_state = 157, .external_lex_state = 2},
  [7074] = {.lex_state = 157, .external_lex_state = 2},
  [7075] = {.lex_state = 157, .external_lex_state = 2},
  [7076] = {.lex_state = 300, .external_lex_state = 27},
  [7077] = {.lex_state = 164},
  [7078] = {.lex_state = 375, .external_lex_state = 17},
  [7079] = {.lex_state = 228},
  [7080] = {.lex_state = 157, .external_lex_state = 2},
  [7081] = {.lex_state = 157, .external_lex_state = 2},
  [7082] = {.lex_state = 157, .external_lex_state = 2},
  [7083] = {.lex_state = 378, .external_lex_state = 16},
  [7084] = {.lex_state = 378, .external_lex_state = 16},
  [7085] = {.lex_state = 383, .external_lex_state = 19},
  [7086] = {.lex_state = 378, .external_lex_state = 16},
  [7087] = {.lex_state = 363, .external_lex_state = 19},
  [7088] = {.lex_state = 359, .external_lex_state = 20},
  [7089] = {.lex_state = 353, .external_lex_state = 21},
  [7090] = {.lex_state = 157, .external_lex_state = 2},
  [7091] = {.lex_state = 353, .external_lex_state = 21},
  [7092] = {.lex_state = 157, .external_lex_state = 2},
  [7093] = {.lex_state = 157, .external_lex_state = 2},
  [7094] = {.lex_state = 353, .external_lex_state = 21},
  [7095] = {.lex_state = 157, .external_lex_state = 2},
  [7096] = {.lex_state = 353, .external_lex_state = 21},
  [7097] = {.lex_state = 356, .external_lex_state = 20},
  [7098] = {.lex_state = 359, .external_lex_state = 20},
  [7099] = {.lex_state = 157},
  [7100] = {.lex_state = 363, .external_lex_state = 23},
  [7101] = {.lex_state = 359, .external_lex_state = 20},
  [7102] = {.lex_state = 359, .external_lex_state = 20},
  [7103] = {.lex_state = 359, .external_lex_state = 20},
  [7104] = {.lex_state = 359, .external_lex_state = 20},
  [7105] = {.lex_state = 359, .external_lex_state = 20},
  [7106] = {.lex_state = 359, .external_lex_state = 20},
  [7107] = {.lex_state = 359, .external_lex_state = 20},
  [7108] = {.lex_state = 359, .external_lex_state = 20},
  [7109] = {.lex_state = 359, .external_lex_state = 20},
  [7110] = {.lex_state = 359, .external_lex_state = 20},
  [7111] = {.lex_state = 197, .external_lex_state = 5},
  [7112] = {.lex_state = 359, .external_lex_state = 20},
  [7113] = {.lex_state = 366, .external_lex_state = 21},
  [7114] = {.lex_state = 266, .external_lex_state = 6},
  [7115] = {.lex_state = 366, .external_lex_state = 21},
  [7116] = {.lex_state = 366, .external_lex_state = 21},
  [7117] = {.lex_state = 300, .external_lex_state = 27},
  [7118] = {.lex_state = 366, .external_lex_state = 21},
  [7119] = {.lex_state = 217, .external_lex_state = 4},
  [7120] = {.lex_state = 378, .external_lex_state = 16},
  [7121] = {.lex_state = 378, .external_lex_state = 19},
  [7122] = {.lex_state = 157, .external_lex_state = 2},
  [7123] = {.lex_state = 378, .external_lex_state = 16},
  [7124] = {.lex_state = 157, .external_lex_state = 2},
  [7125] = {.lex_state = 366, .external_lex_state = 17},
  [7126] = {.lex_state = 366, .external_lex_state = 17},
  [7127] = {.lex_state = 157, .external_lex_state = 2},
  [7128] = {.lex_state = 157, .external_lex_state = 2},
  [7129] = {.lex_state = 366, .external_lex_state = 17},
  [7130] = {.lex_state = 157, .external_lex_state = 2},
  [7131] = {.lex_state = 366, .external_lex_state = 17},
  [7132] = {.lex_state = 356, .external_lex_state = 16},
  [7133] = {.lex_state = 356, .external_lex_state = 16},
  [7134] = {.lex_state = 356, .external_lex_state = 16},
  [7135] = {.lex_state = 366, .external_lex_state = 17},
  [7136] = {.lex_state = 157},
  [7137] = {.lex_state = 356, .external_lex_state = 19},
  [7138] = {.lex_state = 356, .external_lex_state = 16},
  [7139] = {.lex_state = 356, .external_lex_state = 16},
  [7140] = {.lex_state = 157, .external_lex_state = 28},
  [7141] = {.lex_state = 157, .external_lex_state = 29},
  [7142] = {.lex_state = 356, .external_lex_state = 16},
  [7143] = {.lex_state = 356, .external_lex_state = 16},
  [7144] = {.lex_state = 157, .external_lex_state = 2},
  [7145] = {.lex_state = 157, .external_lex_state = 2},
  [7146] = {.lex_state = 157, .external_lex_state = 2},
  [7147] = {.lex_state = 157, .external_lex_state = 2},
  [7148] = {.lex_state = 157, .external_lex_state = 2},
  [7149] = {.lex_state = 157, .external_lex_state = 2},
  [7150] = {.lex_state = 157, .external_lex_state = 2},
  [7151] = {.lex_state = 157, .external_lex_state = 2},
  [7152] = {.lex_state = 157, .external_lex_state = 2},
  [7153] = {.lex_state = 157, .external_lex_state = 2},
  [7154] = {.lex_state = 378, .external_lex_state = 19},
  [7155] = {.lex_state = 363, .external_lex_state = 23},
  [7156] = {.lex_state = 197, .external_lex_state = 13},
  [7157] = {.lex_state = 197, .external_lex_state = 5},
  [7158] = {.lex_state = 197, .external_lex_state = 14},
  [7159] = {.lex_state = 157, .external_lex_state = 2},
  [7160] = {.lex_state = 197, .external_lex_state = 5},
  [7161] = {.lex_state = 271, .external_lex_state = 9},
  [7162] = {.lex_state = 157, .external_lex_state = 2},
  [7163] = {.lex_state = 271, .external_lex_state = 9},
  [7164] = {.lex_state = 228},
  [7165] = {.lex_state = 157, .external_lex_state = 2},
  [7166] = {.lex_state = 157, .external_lex_state = 2},
  [7167] = {.lex_state = 157, .external_lex_state = 2},
  [7168] = {.lex_state = 197, .external_lex_state = 5},
  [7169] = {.lex_state = 197, .external_lex_state = 5},
  [7170] = {.lex_state = 197, .external_lex_state = 14},
  [7171] = {.lex_state = 197, .external_lex_state = 5},
  [7172] = {.lex_state = 220, .external_lex_state = 9},
  [7173] = {.lex_state = 220, .external_lex_state = 9},
  [7174] = {.lex_state = 157, .external_lex_state = 2},
  [7175] = {.lex_state = 157, .external_lex_state = 2},
  [7176] = {.lex_state = 220, .external_lex_state = 9},
  [7177] = {.lex_state = 157, .external_lex_state = 2},
  [7178] = {.lex_state = 220, .external_lex_state = 9},
  [7179] = {.lex_state = 208, .external_lex_state = 5},
  [7180] = {.lex_state = 197, .external_lex_state = 5},
  [7181] = {.lex_state = 157},
  [7182] = {.lex_state = 197, .external_lex_state = 14},
  [7183] = {.lex_state = 197, .external_lex_state = 5},
  [7184] = {.lex_state = 197, .external_lex_state = 5},
  [7185] = {.lex_state = 157, .external_lex_state = 29},
  [7186] = {.lex_state = 197, .external_lex_state = 5},
  [7187] = {.lex_state = 197, .external_lex_state = 5},
  [7188] = {.lex_state = 157, .external_lex_state = 2},
  [7189] = {.lex_state = 157, .external_lex_state = 28},
  [7190] = {.lex_state = 157, .external_lex_state = 2},
  [7191] = {.lex_state = 157, .external_lex_state = 2},
  [7192] = {.lex_state = 157, .external_lex_state = 2},
  [7193] = {.lex_state = 157, .external_lex_state = 2},
  [7194] = {.lex_state = 157, .external_lex_state = 2},
  [7195] = {.lex_state = 157, .external_lex_state = 2},
  [7196] = {.lex_state = 157, .external_lex_state = 2},
  [7197] = {.lex_state = 157, .external_lex_state = 2},
  [7198] = {.lex_state = 157, .external_lex_state = 2},
  [7199] = {.lex_state = 300, .external_lex_state = 27},
  [7200] = {.lex_state = 164},
  [7201] = {.lex_state = 271, .external_lex_state = 9},
  [7202] = {.lex_state = 228},
  [7203] = {.lex_state = 157, .external_lex_state = 2},
  [7204] = {.lex_state = 157, .external_lex_state = 2},
  [7205] = {.lex_state = 157, .external_lex_state = 2},
  [7206] = {.lex_state = 268, .external_lex_state = 5},
  [7207] = {.lex_state = 268, .external_lex_state = 5},
  [7208] = {.lex_state = 268, .external_lex_state = 14},
  [7209] = {.lex_state = 268, .external_lex_state = 5},
  [7210] = {.lex_state = 197, .external_lex_state = 14},
  [7211] = {.lex_state = 197, .external_lex_state = 5},
  [7212] = {.lex_state = 197, .external_lex_state = 5},
  [7213] = {.lex_state = 197, .external_lex_state = 5},
  [7214] = {.lex_state = 197, .external_lex_state = 5},
  [7215] = {.lex_state = 197, .external_lex_state = 5},
  [7216] = {.lex_state = 223, .external_lex_state = 9},
  [7217] = {.lex_state = 266, .external_lex_state = 6},
  [7218] = {.lex_state = 223, .external_lex_state = 9},
  [7219] = {.lex_state = 223, .external_lex_state = 9},
  [7220] = {.lex_state = 300, .external_lex_state = 27},
  [7221] = {.lex_state = 223, .external_lex_state = 9},
  [7222] = {.lex_state = 157, .external_lex_state = 2},
  [7223] = {.lex_state = 157, .external_lex_state = 2},
  [7224] = {.lex_state = 157, .external_lex_state = 2},
  [7225] = {.lex_state = 157, .external_lex_state = 2},
  [7226] = {.lex_state = 208, .external_lex_state = 5},
  [7227] = {.lex_state = 197, .external_lex_state = 5},
  [7228] = {.lex_state = 157},
  [7229] = {.lex_state = 197, .external_lex_state = 5},
  [7230] = {.lex_state = 268, .external_lex_state = 5},
  [7231] = {.lex_state = 268, .external_lex_state = 14},
  [7232] = {.lex_state = 157, .external_lex_state = 2},
  [7233] = {.lex_state = 268, .external_lex_state = 5},
  [7234] = {.lex_state = 157, .external_lex_state = 2},
  [7235] = {.lex_state = 223, .external_lex_state = 9},
  [7236] = {.lex_state = 223, .external_lex_state = 9},
  [7237] = {.lex_state = 157, .external_lex_state = 2},
  [7238] = {.lex_state = 157, .external_lex_state = 2},
  [7239] = {.lex_state = 223, .external_lex_state = 9},
  [7240] = {.lex_state = 157, .external_lex_state = 2},
  [7241] = {.lex_state = 223, .external_lex_state = 9},
  [7242] = {.lex_state = 208, .external_lex_state = 5},
  [7243] = {.lex_state = 208, .external_lex_state = 5},
  [7244] = {.lex_state = 208, .external_lex_state = 5},
  [7245] = {.lex_state = 223, .external_lex_state = 9},
  [7246] = {.lex_state = 157},
  [7247] = {.lex_state = 208, .external_lex_state = 14},
  [7248] = {.lex_state = 208, .external_lex_state = 5},
  [7249] = {.lex_state = 208, .external_lex_state = 5},
  [7250] = {.lex_state = 157, .external_lex_state = 28},
  [7251] = {.lex_state = 157, .external_lex_state = 29},
  [7252] = {.lex_state = 208, .external_lex_state = 5},
  [7253] = {.lex_state = 208, .external_lex_state = 5},
  [7254] = {.lex_state = 157, .external_lex_state = 2},
  [7255] = {.lex_state = 157, .external_lex_state = 2},
  [7256] = {.lex_state = 157, .external_lex_state = 2},
  [7257] = {.lex_state = 157, .external_lex_state = 2},
  [7258] = {.lex_state = 157, .external_lex_state = 2},
  [7259] = {.lex_state = 157, .external_lex_state = 2},
  [7260] = {.lex_state = 157, .external_lex_state = 2},
  [7261] = {.lex_state = 157, .external_lex_state = 2},
  [7262] = {.lex_state = 157, .external_lex_state = 2},
  [7263] = {.lex_state = 157, .external_lex_state = 2},
  [7264] = {.lex_state = 268, .external_lex_state = 14},
  [7265] = {.lex_state = 197, .external_lex_state = 5},
  [7266] = {.lex_state = 197, .external_lex_state = 5},
  [7267] = {.lex_state = 197, .external_lex_state = 5},
  [7268] = {.lex_state = 197, .external_lex_state = 5},
  [7269] = {.lex_state = 197, .external_lex_state = 5},
  [7270] = {.lex_state = 359, .external_lex_state = 20},
  [7271] = {.lex_state = 197, .external_lex_state = 5},
  [7272] = {.lex_state = 197, .external_lex_state = 5},
  [7273] = {.lex_state = 197, .external_lex_state = 5},
  [7274] = {.lex_state = 197, .external_lex_state = 5},
  [7275] = {.lex_state = 197, .external_lex_state = 5},
  [7276] = {.lex_state = 197, .external_lex_state = 14},
  [7277] = {.lex_state = 197, .external_lex_state = 5},
  [7278] = {.lex_state = 197, .external_lex_state = 5},
  [7279] = {.lex_state = 157, .external_lex_state = 6},
  [7280] = {.lex_state = 197, .external_lex_state = 5},
  [7281] = {.lex_state = 197, .external_lex_state = 5},
  [7282] = {.lex_state = 197, .external_lex_state = 5},
  [7283] = {.lex_state = 197, .external_lex_state = 5},
  [7284] = {.lex_state = 197, .external_lex_state = 5},
  [7285] = {.lex_state = 197, .external_lex_state = 5},
  [7286] = {.lex_state = 197, .external_lex_state = 5},
  [7287] = {.lex_state = 197, .external_lex_state = 5},
  [7288] = {.lex_state = 197, .external_lex_state = 5},
  [7289] = {.lex_state = 197, .external_lex_state = 5},
  [7290] = {.lex_state = 197, .external_lex_state = 5},
  [7291] = {.lex_state = 197, .external_lex_state = 5},
  [7292] = {.lex_state = 359, .external_lex_state = 20},
  [7293] = {.lex_state = 197, .external_lex_state = 5},
  [7294] = {.lex_state = 197, .external_lex_state = 5},
  [7295] = {.lex_state = 197, .external_lex_state = 5},
  [7296] = {.lex_state = 197, .external_lex_state = 5},
  [7297] = {.lex_state = 197, .external_lex_state = 5},
  [7298] = {.lex_state = 197, .external_lex_state = 14},
  [7299] = {.lex_state = 157, .external_lex_state = 28},
  [7300] = {.lex_state = 197, .external_lex_state = 5},
  [7301] = {.lex_state = 157, .external_lex_state = 2},
  [7302] = {.lex_state = 271, .external_lex_state = 9},
  [7303] = {.lex_state = 135},
  [7304] = {.lex_state = 271, .external_lex_state = 9},
  [7305] = {.lex_state = 268, .external_lex_state = 5},
  [7306] = {.lex_state = 268, .external_lex_state = 5},
  [7307] = {.lex_state = 157, .external_lex_state = 6},
  [7308] = {.lex_state = 268, .external_lex_state = 5},
  [7309] = {.lex_state = 268, .external_lex_state = 5},
  [7310] = {.lex_state = 268, .external_lex_state = 5},
  [7311] = {.lex_state = 197, .external_lex_state = 5},
  [7312] = {.lex_state = 197, .external_lex_state = 5},
  [7313] = {.lex_state = 197, .external_lex_state = 5},
  [7314] = {.lex_state = 197, .external_lex_state = 5},
  [7315] = {.lex_state = 197, .external_lex_state = 5},
  [7316] = {.lex_state = 197, .external_lex_state = 5},
  [7317] = {.lex_state = 359, .external_lex_state = 20},
  [7318] = {.lex_state = 197, .external_lex_state = 5},
  [7319] = {.lex_state = 197, .external_lex_state = 5},
  [7320] = {.lex_state = 197, .external_lex_state = 5},
  [7321] = {.lex_state = 197, .external_lex_state = 5},
  [7322] = {.lex_state = 197, .external_lex_state = 5},
  [7323] = {.lex_state = 197, .external_lex_state = 5},
  [7324] = {.lex_state = 197, .external_lex_state = 5},
  [7325] = {.lex_state = 223, .external_lex_state = 9},
  [7326] = {.lex_state = 208, .external_lex_state = 5},
  [7327] = {.lex_state = 208, .external_lex_state = 5},
  [7328] = {.lex_state = 208, .external_lex_state = 5},
  [7329] = {.lex_state = 208, .external_lex_state = 5},
  [7330] = {.lex_state = 208, .external_lex_state = 5},
  [7331] = {.lex_state = 208, .external_lex_state = 5},
  [7332] = {.lex_state = 208, .external_lex_state = 5},
  [7333] = {.lex_state = 359, .external_lex_state = 20},
  [7334] = {.lex_state = 208, .external_lex_state = 5},
  [7335] = {.lex_state = 208, .external_lex_state = 5},
  [7336] = {.lex_state = 208, .external_lex_state = 5},
  [7337] = {.lex_state = 208, .external_lex_state = 5},
  [7338] = {.lex_state = 208, .external_lex_state = 5},
  [7339] = {.lex_state = 208, .external_lex_state = 14},
  [7340] = {.lex_state = 157, .external_lex_state = 28},
  [7341] = {.lex_state = 268, .external_lex_state = 5},
  [7342] = {.lex_state = 157, .external_lex_state = 2},
  [7343] = {.lex_state = 215, .external_lex_state = 13},
  [7344] = {.lex_state = 307, .external_lex_state = 5},
  [7345] = {.lex_state = 307, .external_lex_state = 5},
  [7346] = {.lex_state = 307, .external_lex_state = 5},
  [7347] = {.lex_state = 307, .external_lex_state = 5},
  [7348] = {.lex_state = 307, .external_lex_state = 5},
  [7349] = {.lex_state = 307, .external_lex_state = 5},
  [7350] = {.lex_state = 307, .external_lex_state = 5},
  [7351] = {.lex_state = 307, .external_lex_state = 5},
  [7352] = {.lex_state = 157, .external_lex_state = 2},
  [7353] = {.lex_state = 157, .external_lex_state = 28},
  [7354] = {.lex_state = 157, .external_lex_state = 2},
  [7355] = {.lex_state = 157, .external_lex_state = 2},
  [7356] = {.lex_state = 157, .external_lex_state = 2},
  [7357] = {.lex_state = 157, .external_lex_state = 2},
  [7358] = {.lex_state = 157, .external_lex_state = 2},
  [7359] = {.lex_state = 157, .external_lex_state = 2},
  [7360] = {.lex_state = 157, .external_lex_state = 2},
  [7361] = {.lex_state = 157, .external_lex_state = 2},
  [7362] = {.lex_state = 157, .external_lex_state = 2},
  [7363] = {.lex_state = 307, .external_lex_state = 14},
  [7364] = {.lex_state = 157, .external_lex_state = 6},
  [7365] = {.lex_state = 307, .external_lex_state = 5},
  [7366] = {.lex_state = 307, .external_lex_state = 5},
  [7367] = {.lex_state = 307, .external_lex_state = 5},
  [7368] = {.lex_state = 307, .external_lex_state = 5},
  [7369] = {.lex_state = 307, .external_lex_state = 5},
  [7370] = {.lex_state = 307, .external_lex_state = 5},
  [7371] = {.lex_state = 307, .external_lex_state = 5},
  [7372] = {.lex_state = 307, .external_lex_state = 5},
  [7373] = {.lex_state = 359, .external_lex_state = 20},
  [7374] = {.lex_state = 307, .external_lex_state = 5},
  [7375] = {.lex_state = 307, .external_lex_state = 5},
  [7376] = {.lex_state = 307, .external_lex_state = 5},
  [7377] = {.lex_state = 307, .external_lex_state = 5},
  [7378] = {.lex_state = 307, .external_lex_state = 5},
  [7379] = {.lex_state = 307, .external_lex_state = 5},
  [7380] = {.lex_state = 307, .external_lex_state = 5},
  [7381] = {.lex_state = 307, .external_lex_state = 14},
  [7382] = {.lex_state = 232, .external_lex_state = 2},
  [7383] = {.lex_state = 310, .external_lex_state = 9},
  [7384] = {.lex_state = 135},
  [7385] = {.lex_state = 310, .external_lex_state = 9},
  [7386] = {.lex_state = 307, .external_lex_state = 5},
  [7387] = {.lex_state = 307, .external_lex_state = 5},
  [7388] = {.lex_state = 307, .external_lex_state = 5},
  [7389] = {.lex_state = 157, .external_lex_state = 2},
  [7390] = {.lex_state = 157, .external_lex_state = 28},
  [7391] = {.lex_state = 157, .external_lex_state = 2},
  [7392] = {.lex_state = 157, .external_lex_state = 2},
  [7393] = {.lex_state = 157, .external_lex_state = 2},
  [7394] = {.lex_state = 157, .external_lex_state = 2},
  [7395] = {.lex_state = 157, .external_lex_state = 2},
  [7396] = {.lex_state = 157, .external_lex_state = 2},
  [7397] = {.lex_state = 157, .external_lex_state = 2},
  [7398] = {.lex_state = 157, .external_lex_state = 2},
  [7399] = {.lex_state = 157, .external_lex_state = 2},
  [7400] = {.lex_state = 157, .external_lex_state = 28},
  [7401] = {.lex_state = 307, .external_lex_state = 5},
  [7402] = {.lex_state = 313, .external_lex_state = 5},
  [7403] = {.lex_state = 313, .external_lex_state = 5},
  [7404] = {.lex_state = 313, .external_lex_state = 5},
  [7405] = {.lex_state = 313, .external_lex_state = 5},
  [7406] = {.lex_state = 157, .external_lex_state = 2},
  [7407] = {.lex_state = 157, .external_lex_state = 28},
  [7408] = {.lex_state = 157, .external_lex_state = 2},
  [7409] = {.lex_state = 157, .external_lex_state = 2},
  [7410] = {.lex_state = 157, .external_lex_state = 2},
  [7411] = {.lex_state = 157, .external_lex_state = 2},
  [7412] = {.lex_state = 157, .external_lex_state = 2},
  [7413] = {.lex_state = 157, .external_lex_state = 2},
  [7414] = {.lex_state = 157, .external_lex_state = 2},
  [7415] = {.lex_state = 157, .external_lex_state = 2},
  [7416] = {.lex_state = 157, .external_lex_state = 2},
  [7417] = {.lex_state = 313, .external_lex_state = 14},
  [7418] = {.lex_state = 350, .external_lex_state = 5},
  [7419] = {.lex_state = 350, .external_lex_state = 5},
  [7420] = {.lex_state = 157, .external_lex_state = 6},
  [7421] = {.lex_state = 313, .external_lex_state = 5},
  [7422] = {.lex_state = 313, .external_lex_state = 5},
  [7423] = {.lex_state = 313, .external_lex_state = 5},
  [7424] = {.lex_state = 350, .external_lex_state = 5},
  [7425] = {.lex_state = 350, .external_lex_state = 5},
  [7426] = {.lex_state = 350, .external_lex_state = 5},
  [7427] = {.lex_state = 359, .external_lex_state = 20},
  [7428] = {.lex_state = 350, .external_lex_state = 5},
  [7429] = {.lex_state = 350, .external_lex_state = 5},
  [7430] = {.lex_state = 350, .external_lex_state = 5},
  [7431] = {.lex_state = 350, .external_lex_state = 5},
  [7432] = {.lex_state = 350, .external_lex_state = 5},
  [7433] = {.lex_state = 350, .external_lex_state = 5},
  [7434] = {.lex_state = 350, .external_lex_state = 5},
  [7435] = {.lex_state = 350, .external_lex_state = 14},
  [7436] = {.lex_state = 157, .external_lex_state = 2},
  [7437] = {.lex_state = 197, .external_lex_state = 5},
  [7438] = {.lex_state = 197, .external_lex_state = 5},
  [7439] = {.lex_state = 157, .external_lex_state = 6},
  [7440] = {.lex_state = 197, .external_lex_state = 5},
  [7441] = {.lex_state = 197, .external_lex_state = 5},
  [7442] = {.lex_state = 197, .external_lex_state = 5},
  [7443] = {.lex_state = 197, .external_lex_state = 5},
  [7444] = {.lex_state = 197, .external_lex_state = 5},
  [7445] = {.lex_state = 197, .external_lex_state = 5},
  [7446] = {.lex_state = 197, .external_lex_state = 5},
  [7447] = {.lex_state = 197, .external_lex_state = 5},
  [7448] = {.lex_state = 197, .external_lex_state = 5},
  [7449] = {.lex_state = 197, .external_lex_state = 5},
  [7450] = {.lex_state = 197, .external_lex_state = 5},
  [7451] = {.lex_state = 197, .external_lex_state = 5},
  [7452] = {.lex_state = 359, .external_lex_state = 20},
  [7453] = {.lex_state = 197, .external_lex_state = 5},
  [7454] = {.lex_state = 197, .external_lex_state = 5},
  [7455] = {.lex_state = 197, .external_lex_state = 5},
  [7456] = {.lex_state = 197, .external_lex_state = 5},
  [7457] = {.lex_state = 197, .external_lex_state = 5},
  [7458] = {.lex_state = 197, .external_lex_state = 14},
  [7459] = {.lex_state = 157, .external_lex_state = 28},
  [7460] = {.lex_state = 197, .external_lex_state = 5},
  [7461] = {.lex_state = 157, .external_lex_state = 2},
  [7462] = {.lex_state = 271, .external_lex_state = 9},
  [7463] = {.lex_state = 135},
  [7464] = {.lex_state = 271, .external_lex_state = 9},
  [7465] = {.lex_state = 268, .external_lex_state = 5},
  [7466] = {.lex_state = 268, .external_lex_state = 5},
  [7467] = {.lex_state = 157, .external_lex_state = 6},
  [7468] = {.lex_state = 268, .external_lex_state = 5},
  [7469] = {.lex_state = 268, .external_lex_state = 5},
  [7470] = {.lex_state = 268, .external_lex_state = 5},
  [7471] = {.lex_state = 197, .external_lex_state = 13},
  [7472] = {.lex_state = 197, .external_lex_state = 5},
  [7473] = {.lex_state = 197, .external_lex_state = 14},
  [7474] = {.lex_state = 157, .external_lex_state = 2},
  [7475] = {.lex_state = 197, .external_lex_state = 5},
  [7476] = {.lex_state = 271, .external_lex_state = 9},
  [7477] = {.lex_state = 157, .external_lex_state = 2},
  [7478] = {.lex_state = 271, .external_lex_state = 9},
  [7479] = {.lex_state = 228},
  [7480] = {.lex_state = 157, .external_lex_state = 2},
  [7481] = {.lex_state = 157, .external_lex_state = 2},
  [7482] = {.lex_state = 157, .external_lex_state = 2},
  [7483] = {.lex_state = 197, .external_lex_state = 5},
  [7484] = {.lex_state = 197, .external_lex_state = 5},
  [7485] = {.lex_state = 197, .external_lex_state = 14},
  [7486] = {.lex_state = 197, .external_lex_state = 5},
  [7487] = {.lex_state = 220, .external_lex_state = 9},
  [7488] = {.lex_state = 220, .external_lex_state = 9},
  [7489] = {.lex_state = 157, .external_lex_state = 2},
  [7490] = {.lex_state = 157, .external_lex_state = 2},
  [7491] = {.lex_state = 220, .external_lex_state = 9},
  [7492] = {.lex_state = 157, .external_lex_state = 2},
  [7493] = {.lex_state = 220, .external_lex_state = 9},
  [7494] = {.lex_state = 208, .external_lex_state = 5},
  [7495] = {.lex_state = 197, .external_lex_state = 5},
  [7496] = {.lex_state = 157},
  [7497] = {.lex_state = 197, .external_lex_state = 14},
  [7498] = {.lex_state = 197, .external_lex_state = 5},
  [7499] = {.lex_state = 197, .external_lex_state = 5},
  [7500] = {.lex_state = 157, .external_lex_state = 29},
  [7501] = {.lex_state = 197, .external_lex_state = 5},
  [7502] = {.lex_state = 197, .external_lex_state = 5},
  [7503] = {.lex_state = 157, .external_lex_state = 2},
  [7504] = {.lex_state = 157, .external_lex_state = 28},
  [7505] = {.lex_state = 157, .external_lex_state = 2},
  [7506] = {.lex_state = 157, .external_lex_state = 2},
  [7507] = {.lex_state = 157, .external_lex_state = 2},
  [7508] = {.lex_state = 157, .external_lex_state = 2},
  [7509] = {.lex_state = 157, .external_lex_state = 2},
  [7510] = {.lex_state = 157, .external_lex_state = 2},
  [7511] = {.lex_state = 157, .external_lex_state = 2},
  [7512] = {.lex_state = 157, .external_lex_state = 2},
  [7513] = {.lex_state = 157, .external_lex_state = 2},
  [7514] = {.lex_state = 300, .external_lex_state = 27},
  [7515] = {.lex_state = 164},
  [7516] = {.lex_state = 271, .external_lex_state = 9},
  [7517] = {.lex_state = 228},
  [7518] = {.lex_state = 157, .external_lex_state = 2},
  [7519] = {.lex_state = 157, .external_lex_state = 2},
  [7520] = {.lex_state = 157, .external_lex_state = 2},
  [7521] = {.lex_state = 268, .external_lex_state = 5},
  [7522] = {.lex_state = 268, .external_lex_state = 5},
  [7523] = {.lex_state = 268, .external_lex_state = 14},
  [7524] = {.lex_state = 268, .external_lex_state = 5},
  [7525] = {.lex_state = 197, .external_lex_state = 14},
  [7526] = {.lex_state = 197, .external_lex_state = 5},
  [7527] = {.lex_state = 197, .external_lex_state = 5},
  [7528] = {.lex_state = 197, .external_lex_state = 5},
  [7529] = {.lex_state = 135, .external_lex_state = 2},
  [7530] = {.lex_state = 217, .external_lex_state = 22},
  [7531] = {.lex_state = 197, .external_lex_state = 5},
  [7532] = {.lex_state = 197, .external_lex_state = 5},
  [7533] = {.lex_state = 223, .external_lex_state = 9},
  [7534] = {.lex_state = 266, .external_lex_state = 6},
  [7535] = {.lex_state = 223, .external_lex_state = 9},
  [7536] = {.lex_state = 223, .external_lex_state = 9},
  [7537] = {.lex_state = 300, .external_lex_state = 27},
  [7538] = {.lex_state = 223, .external_lex_state = 9},
  [7539] = {.lex_state = 157, .external_lex_state = 2},
  [7540] = {.lex_state = 157, .external_lex_state = 2},
  [7541] = {.lex_state = 157, .external_lex_state = 2},
  [7542] = {.lex_state = 157, .external_lex_state = 2},
  [7543] = {.lex_state = 208, .external_lex_state = 5},
  [7544] = {.lex_state = 197, .external_lex_state = 5},
  [7545] = {.lex_state = 157},
  [7546] = {.lex_state = 197, .external_lex_state = 5},
  [7547] = {.lex_state = 268, .external_lex_state = 5},
  [7548] = {.lex_state = 268, .external_lex_state = 14},
  [7549] = {.lex_state = 157, .external_lex_state = 2},
  [7550] = {.lex_state = 268, .external_lex_state = 5},
  [7551] = {.lex_state = 157, .external_lex_state = 2},
  [7552] = {.lex_state = 223, .external_lex_state = 9},
  [7553] = {.lex_state = 223, .external_lex_state = 9},
  [7554] = {.lex_state = 157, .external_lex_state = 2},
  [7555] = {.lex_state = 157, .external_lex_state = 2},
  [7556] = {.lex_state = 223, .external_lex_state = 9},
  [7557] = {.lex_state = 157, .external_lex_state = 2},
  [7558] = {.lex_state = 223, .external_lex_state = 9},
  [7559] = {.lex_state = 208, .external_lex_state = 5},
  [7560] = {.lex_state = 208, .external_lex_state = 5},
  [7561] = {.lex_state = 208, .external_lex_state = 5},
  [7562] = {.lex_state = 223, .external_lex_state = 9},
  [7563] = {.lex_state = 157},
  [7564] = {.lex_state = 208, .external_lex_state = 14},
  [7565] = {.lex_state = 208, .external_lex_state = 5},
  [7566] = {.lex_state = 208, .external_lex_state = 5},
  [7567] = {.lex_state = 157, .external_lex_state = 28},
  [7568] = {.lex_state = 157, .external_lex_state = 29},
  [7569] = {.lex_state = 208, .external_lex_state = 5},
  [7570] = {.lex_state = 208, .external_lex_state = 5},
  [7571] = {.lex_state = 157, .external_lex_state = 2},
  [7572] = {.lex_state = 157, .external_lex_state = 2},
  [7573] = {.lex_state = 157, .external_lex_state = 2},
  [7574] = {.lex_state = 157, .external_lex_state = 2},
  [7575] = {.lex_state = 157, .external_lex_state = 2},
  [7576] = {.lex_state = 157, .external_lex_state = 2},
  [7577] = {.lex_state = 157, .external_lex_state = 2},
  [7578] = {.lex_state = 157, .external_lex_state = 2},
  [7579] = {.lex_state = 157, .external_lex_state = 2},
  [7580] = {.lex_state = 157, .external_lex_state = 2},
  [7581] = {.lex_state = 268, .external_lex_state = 14},
  [7582] = {.lex_state = 197, .external_lex_state = 5},
  [7583] = {.lex_state = 197, .external_lex_state = 5},
  [7584] = {.lex_state = 197, .external_lex_state = 5},
  [7585] = {.lex_state = 197, .external_lex_state = 5},
  [7586] = {.lex_state = 197, .external_lex_state = 5},
  [7587] = {.lex_state = 359, .external_lex_state = 20},
  [7588] = {.lex_state = 197, .external_lex_state = 5},
  [7589] = {.lex_state = 197, .external_lex_state = 5},
  [7590] = {.lex_state = 197, .external_lex_state = 5},
  [7591] = {.lex_state = 197, .external_lex_state = 5},
  [7592] = {.lex_state = 197, .external_lex_state = 5},
  [7593] = {.lex_state = 197, .external_lex_state = 14},
  [7594] = {.lex_state = 135, .external_lex_state = 13},
  [7595] = {.lex_state = 223, .external_lex_state = 9},
  [7596] = {.lex_state = 197, .external_lex_state = 5},
  [7597] = {.lex_state = 197, .external_lex_state = 5},
  [7598] = {.lex_state = 197, .external_lex_state = 5},
  [7599] = {.lex_state = 197, .external_lex_state = 5},
  [7600] = {.lex_state = 197, .external_lex_state = 5},
  [7601] = {.lex_state = 197, .external_lex_state = 5},
  [7602] = {.lex_state = 359, .external_lex_state = 20},
  [7603] = {.lex_state = 197, .external_lex_state = 5},
  [7604] = {.lex_state = 197, .external_lex_state = 5},
  [7605] = {.lex_state = 197, .external_lex_state = 5},
  [7606] = {.lex_state = 197, .external_lex_state = 5},
  [7607] = {.lex_state = 197, .external_lex_state = 5},
  [7608] = {.lex_state = 197, .external_lex_state = 5},
  [7609] = {.lex_state = 208, .external_lex_state = 5},
  [7610] = {.lex_state = 208, .external_lex_state = 5},
  [7611] = {.lex_state = 208, .external_lex_state = 5},
  [7612] = {.lex_state = 208, .external_lex_state = 5},
  [7613] = {.lex_state = 208, .external_lex_state = 5},
  [7614] = {.lex_state = 208, .external_lex_state = 5},
  [7615] = {.lex_state = 208, .external_lex_state = 5},
  [7616] = {.lex_state = 359, .external_lex_state = 20},
  [7617] = {.lex_state = 208, .external_lex_state = 5},
  [7618] = {.lex_state = 208, .external_lex_state = 5},
  [7619] = {.lex_state = 208, .external_lex_state = 5},
  [7620] = {.lex_state = 208, .external_lex_state = 5},
  [7621] = {.lex_state = 208, .external_lex_state = 5},
  [7622] = {.lex_state = 208, .external_lex_state = 14},
  [7623] = {.lex_state = 157, .external_lex_state = 28},
  [7624] = {.lex_state = 268, .external_lex_state = 5},
  [7625] = {.lex_state = 157, .external_lex_state = 2},
  [7626] = {.lex_state = 197, .external_lex_state = 5},
  [7627] = {.lex_state = 197, .external_lex_state = 5},
  [7628] = {.lex_state = 316, .external_lex_state = 20},
  [7629] = {.lex_state = 135},
  [7630] = {.lex_state = 215},
  [7631] = {.lex_state = 215},
  [7632] = {.lex_state = 215},
  [7633] = {.lex_state = 316, .external_lex_state = 20},
  [7634] = {.lex_state = 135},
  [7635] = {.lex_state = 316, .external_lex_state = 20},
  [7636] = {.lex_state = 217, .external_lex_state = 4},
  [7637] = {.lex_state = 316, .external_lex_state = 20},
  [7638] = {.lex_state = 234, .external_lex_state = 15},
  [7639] = {.lex_state = 316, .external_lex_state = 20},
  [7640] = {.lex_state = 217, .external_lex_state = 4},
  [7641] = {.lex_state = 316, .external_lex_state = 20},
  [7642] = {.lex_state = 215},
  [7643] = {.lex_state = 316, .external_lex_state = 20},
  [7644] = {.lex_state = 135},
  [7645] = {.lex_state = 135, .external_lex_state = 2},
  [7646] = {.lex_state = 316, .external_lex_state = 20},
  [7647] = {.lex_state = 135, .external_lex_state = 2},
  [7648] = {.lex_state = 135},
  [7649] = {.lex_state = 135, .external_lex_state = 10},
  [7650] = {.lex_state = 316, .external_lex_state = 20},
  [7651] = {.lex_state = 215},
  [7652] = {.lex_state = 157},
  [7653] = {.lex_state = 316, .external_lex_state = 20},
  [7654] = {.lex_state = 316, .external_lex_state = 20},
  [7655] = {.lex_state = 307, .external_lex_state = 16},
  [7656] = {.lex_state = 307, .external_lex_state = 16},
  [7657] = {.lex_state = 157, .external_lex_state = 2},
  [7658] = {.lex_state = 157, .external_lex_state = 2},
  [7659] = {.lex_state = 307, .external_lex_state = 16},
  [7660] = {.lex_state = 307, .external_lex_state = 16},
  [7661] = {.lex_state = 307, .external_lex_state = 16},
  [7662] = {.lex_state = 157, .external_lex_state = 29},
  [7663] = {.lex_state = 307, .external_lex_state = 16},
  [7664] = {.lex_state = 307, .external_lex_state = 16},
  [7665] = {.lex_state = 307, .external_lex_state = 16},
  [7666] = {.lex_state = 307, .external_lex_state = 16},
  [7667] = {.lex_state = 307, .external_lex_state = 16},
  [7668] = {.lex_state = 307, .external_lex_state = 16},
  [7669] = {.lex_state = 310, .external_lex_state = 17},
  [7670] = {.lex_state = 157, .external_lex_state = 2},
  [7671] = {.lex_state = 157, .external_lex_state = 28},
  [7672] = {.lex_state = 157, .external_lex_state = 2},
  [7673] = {.lex_state = 157, .external_lex_state = 2},
  [7674] = {.lex_state = 157, .external_lex_state = 2},
  [7675] = {.lex_state = 157, .external_lex_state = 2},
  [7676] = {.lex_state = 157, .external_lex_state = 2},
  [7677] = {.lex_state = 157, .external_lex_state = 2},
  [7678] = {.lex_state = 157, .external_lex_state = 2},
  [7679] = {.lex_state = 157, .external_lex_state = 2},
  [7680] = {.lex_state = 157, .external_lex_state = 2},
  [7681] = {.lex_state = 300, .external_lex_state = 27},
  [7682] = {.lex_state = 164},
  [7683] = {.lex_state = 307, .external_lex_state = 19},
  [7684] = {.lex_state = 326, .external_lex_state = 16},
  [7685] = {.lex_state = 326, .external_lex_state = 16},
  [7686] = {.lex_state = 217, .external_lex_state = 22},
  [7687] = {.lex_state = 326, .external_lex_state = 16},
  [7688] = {.lex_state = 157, .external_lex_state = 6},
  [7689] = {.lex_state = 307, .external_lex_state = 16},
  [7690] = {.lex_state = 307, .external_lex_state = 16},
  [7691] = {.lex_state = 307, .external_lex_state = 16},
  [7692] = {.lex_state = 307, .external_lex_state = 16},
  [7693] = {.lex_state = 307, .external_lex_state = 16},
  [7694] = {.lex_state = 307, .external_lex_state = 16},
  [7695] = {.lex_state = 307, .external_lex_state = 16},
  [7696] = {.lex_state = 307, .external_lex_state = 16},
  [7697] = {.lex_state = 359, .external_lex_state = 20},
  [7698] = {.lex_state = 307, .external_lex_state = 16},
  [7699] = {.lex_state = 307, .external_lex_state = 16},
  [7700] = {.lex_state = 307, .external_lex_state = 16},
  [7701] = {.lex_state = 307, .external_lex_state = 16},
  [7702] = {.lex_state = 307, .external_lex_state = 16},
  [7703] = {.lex_state = 307, .external_lex_state = 16},
  [7704] = {.lex_state = 307, .external_lex_state = 16},
  [7705] = {.lex_state = 347, .external_lex_state = 17},
  [7706] = {.lex_state = 266, .external_lex_state = 6},
  [7707] = {.lex_state = 347, .external_lex_state = 17},
  [7708] = {.lex_state = 347, .external_lex_state = 17},
  [7709] = {.lex_state = 300, .external_lex_state = 27},
  [7710] = {.lex_state = 347, .external_lex_state = 17},
  [7711] = {.lex_state = 157, .external_lex_state = 2},
  [7712] = {.lex_state = 157, .external_lex_state = 2},
  [7713] = {.lex_state = 350, .external_lex_state = 16},
  [7714] = {.lex_state = 350, .external_lex_state = 16},
  [7715] = {.lex_state = 350, .external_lex_state = 16},
  [7716] = {.lex_state = 157, .external_lex_state = 29},
  [7717] = {.lex_state = 350, .external_lex_state = 16},
  [7718] = {.lex_state = 350, .external_lex_state = 16},
  [7719] = {.lex_state = 307, .external_lex_state = 19},
  [7720] = {.lex_state = 316, .external_lex_state = 20},
  [7721] = {.lex_state = 135},
  [7722] = {.lex_state = 135},
  [7723] = {.lex_state = 135},
  [7724] = {.lex_state = 135, .external_lex_state = 2},
  [7725] = {.lex_state = 316, .external_lex_state = 20},
  [7726] = {.lex_state = 135, .external_lex_state = 2},
  [7727] = {.lex_state = 316, .external_lex_state = 20},
  [7728] = {.lex_state = 316, .external_lex_state = 20},
  [7729] = {.lex_state = 135},
  [7730] = {.lex_state = 135},
  [7731] = {.lex_state = 316, .external_lex_state = 20},
  [7732] = {.lex_state = 135},
  [7733] = {.lex_state = 316, .external_lex_state = 20},
  [7734] = {.lex_state = 217, .external_lex_state = 4},
  [7735] = {.lex_state = 316, .external_lex_state = 20},
  [7736] = {.lex_state = 234, .external_lex_state = 15},
  [7737] = {.lex_state = 316, .external_lex_state = 20},
  [7738] = {.lex_state = 217, .external_lex_state = 4},
  [7739] = {.lex_state = 310, .external_lex_state = 21},
  [7740] = {.lex_state = 135},
  [7741] = {.lex_state = 310, .external_lex_state = 21},
  [7742] = {.lex_state = 319, .external_lex_state = 20},
  [7743] = {.lex_state = 307, .external_lex_state = 20},
  [7744] = {.lex_state = 307, .external_lex_state = 20},
  [7745] = {.lex_state = 307, .external_lex_state = 20},
  [7746] = {.lex_state = 157, .external_lex_state = 2},
  [7747] = {.lex_state = 157, .external_lex_state = 28},
  [7748] = {.lex_state = 157, .external_lex_state = 2},
  [7749] = {.lex_state = 157, .external_lex_state = 2},
  [7750] = {.lex_state = 157, .external_lex_state = 2},
  [7751] = {.lex_state = 157, .external_lex_state = 2},
  [7752] = {.lex_state = 157, .external_lex_state = 2},
  [7753] = {.lex_state = 157, .external_lex_state = 2},
  [7754] = {.lex_state = 157, .external_lex_state = 2},
  [7755] = {.lex_state = 157, .external_lex_state = 2},
  [7756] = {.lex_state = 157, .external_lex_state = 2},
  [7757] = {.lex_state = 307, .external_lex_state = 23},
  [7758] = {.lex_state = 157, .external_lex_state = 28},
  [7759] = {.lex_state = 307, .external_lex_state = 20},
  [7760] = {.lex_state = 319, .external_lex_state = 20},
  [7761] = {.lex_state = 215},
  [7762] = {.lex_state = 313, .external_lex_state = 16},
  [7763] = {.lex_state = 319, .external_lex_state = 20},
  [7764] = {.lex_state = 135, .external_lex_state = 2},
  [7765] = {.lex_state = 135},
  [7766] = {.lex_state = 135, .external_lex_state = 10},
  [7767] = {.lex_state = 313, .external_lex_state = 16},
  [7768] = {.lex_state = 323, .external_lex_state = 16},
  [7769] = {.lex_state = 197, .external_lex_state = 5},
  [7770] = {.lex_state = 197, .external_lex_state = 5},
  [7771] = {.lex_state = 135},
  [7772] = {.lex_state = 323, .external_lex_state = 16},
  [7773] = {.lex_state = 182, .external_lex_state = 4},
  [7774] = {.lex_state = 234, .external_lex_state = 15},
  [7775] = {.lex_state = 323, .external_lex_state = 16},
  [7776] = {.lex_state = 135, .external_lex_state = 15},
  [7777] = {.lex_state = 323, .external_lex_state = 16},
  [7778] = {.lex_state = 135},
  [7779] = {.lex_state = 323, .external_lex_state = 16},
  [7780] = {.lex_state = 135, .external_lex_state = 13},
  [7781] = {.lex_state = 157, .external_lex_state = 2},
  [7782] = {.lex_state = 258, .external_lex_state = 25},
  [7783] = {.lex_state = 258, .external_lex_state = 25},
  [7784] = {.lex_state = 258, .external_lex_state = 25},
  [7785] = {.lex_state = 258, .external_lex_state = 25},
  [7786] = {.lex_state = 135},
  [7787] = {.lex_state = 135},
  [7788] = {.lex_state = 135, .external_lex_state = 2},
  [7789] = {.lex_state = 323, .external_lex_state = 16},
  [7790] = {.lex_state = 135},
  [7791] = {.lex_state = 135},
  [7792] = {.lex_state = 313, .external_lex_state = 16},
  [7793] = {.lex_state = 323, .external_lex_state = 16},
  [7794] = {.lex_state = 323, .external_lex_state = 16},
  [7795] = {.lex_state = 135, .external_lex_state = 15},
  [7796] = {.lex_state = 323, .external_lex_state = 16},
  [7797] = {.lex_state = 182, .external_lex_state = 4},
  [7798] = {.lex_state = 234, .external_lex_state = 15},
  [7799] = {.lex_state = 323, .external_lex_state = 16},
  [7800] = {.lex_state = 157},
  [7801] = {.lex_state = 323, .external_lex_state = 16},
  [7802] = {.lex_state = 215, .external_lex_state = 18},
  [7803] = {.lex_state = 215},
  [7804] = {.lex_state = 323, .external_lex_state = 16},
  [7805] = {.lex_state = 197, .external_lex_state = 5},
  [7806] = {.lex_state = 313, .external_lex_state = 16},
  [7807] = {.lex_state = 323, .external_lex_state = 16},
  [7808] = {.lex_state = 135},
  [7809] = {.lex_state = 323, .external_lex_state = 19},
  [7810] = {.lex_state = 135, .external_lex_state = 15},
  [7811] = {.lex_state = 323, .external_lex_state = 16},
  [7812] = {.lex_state = 135, .external_lex_state = 15},
  [7813] = {.lex_state = 323, .external_lex_state = 16},
  [7814] = {.lex_state = 135},
  [7815] = {.lex_state = 157, .external_lex_state = 2},
  [7816] = {.lex_state = 215, .external_lex_state = 13},
  [7817] = {.lex_state = 323, .external_lex_state = 16},
  [7818] = {.lex_state = 157},
  [7819] = {.lex_state = 323, .external_lex_state = 16},
  [7820] = {.lex_state = 135, .external_lex_state = 13},
  [7821] = {.lex_state = 157, .external_lex_state = 2},
  [7822] = {.lex_state = 157, .external_lex_state = 28},
  [7823] = {.lex_state = 157, .external_lex_state = 2},
  [7824] = {.lex_state = 157, .external_lex_state = 2},
  [7825] = {.lex_state = 157, .external_lex_state = 2},
  [7826] = {.lex_state = 157, .external_lex_state = 2},
  [7827] = {.lex_state = 157, .external_lex_state = 2},
  [7828] = {.lex_state = 157, .external_lex_state = 2},
  [7829] = {.lex_state = 157, .external_lex_state = 2},
  [7830] = {.lex_state = 157, .external_lex_state = 2},
  [7831] = {.lex_state = 157, .external_lex_state = 2},
  [7832] = {.lex_state = 313, .external_lex_state = 19},
  [7833] = {.lex_state = 323, .external_lex_state = 16},
  [7834] = {.lex_state = 319, .external_lex_state = 20},
  [7835] = {.lex_state = 350, .external_lex_state = 16},
  [7836] = {.lex_state = 350, .external_lex_state = 16},
  [7837] = {.lex_state = 323, .external_lex_state = 16},
  [7838] = {.lex_state = 217, .external_lex_state = 22},
  [7839] = {.lex_state = 323, .external_lex_state = 16},
  [7840] = {.lex_state = 157, .external_lex_state = 6},
  [7841] = {.lex_state = 313, .external_lex_state = 16},
  [7842] = {.lex_state = 313, .external_lex_state = 16},
  [7843] = {.lex_state = 313, .external_lex_state = 16},
  [7844] = {.lex_state = 350, .external_lex_state = 16},
  [7845] = {.lex_state = 350, .external_lex_state = 16},
  [7846] = {.lex_state = 350, .external_lex_state = 16},
  [7847] = {.lex_state = 359, .external_lex_state = 20},
  [7848] = {.lex_state = 350, .external_lex_state = 16},
  [7849] = {.lex_state = 350, .external_lex_state = 16},
  [7850] = {.lex_state = 350, .external_lex_state = 16},
  [7851] = {.lex_state = 350, .external_lex_state = 16},
  [7852] = {.lex_state = 350, .external_lex_state = 16},
  [7853] = {.lex_state = 350, .external_lex_state = 16},
  [7854] = {.lex_state = 350, .external_lex_state = 16},
  [7855] = {.lex_state = 350, .external_lex_state = 19},
  [7856] = {.lex_state = 157, .external_lex_state = 2},
  [7857] = {.lex_state = 237, .external_lex_state = 16},
  [7858] = {.lex_state = 237, .external_lex_state = 16},
  [7859] = {.lex_state = 237, .external_lex_state = 16},
  [7860] = {.lex_state = 217, .external_lex_state = 4},
  [7861] = {.lex_state = 237, .external_lex_state = 16},
  [7862] = {.lex_state = 237, .external_lex_state = 16},
  [7863] = {.lex_state = 237, .external_lex_state = 16},
  [7864] = {.lex_state = 135},
  [7865] = {.lex_state = 237, .external_lex_state = 16},
  [7866] = {.lex_state = 135},
  [7867] = {.lex_state = 135, .external_lex_state = 2},
  [7868] = {.lex_state = 237, .external_lex_state = 16},
  [7869] = {.lex_state = 164, .external_lex_state = 3},
  [7870] = {.lex_state = 237, .external_lex_state = 16},
  [7871] = {.lex_state = 237, .external_lex_state = 16},
  [7872] = {.lex_state = 157, .external_lex_state = 28},
  [7873] = {.lex_state = 255, .external_lex_state = 16},
  [7874] = {.lex_state = 157, .external_lex_state = 2},
  [7875] = {.lex_state = 255, .external_lex_state = 16},
  [7876] = {.lex_state = 255, .external_lex_state = 16},
  [7877] = {.lex_state = 255, .external_lex_state = 16},
  [7878] = {.lex_state = 255, .external_lex_state = 16},
  [7879] = {.lex_state = 157, .external_lex_state = 2},
  [7880] = {.lex_state = 157, .external_lex_state = 28},
  [7881] = {.lex_state = 157, .external_lex_state = 2},
  [7882] = {.lex_state = 157, .external_lex_state = 2},
  [7883] = {.lex_state = 157, .external_lex_state = 2},
  [7884] = {.lex_state = 157, .external_lex_state = 2},
  [7885] = {.lex_state = 157, .external_lex_state = 2},
  [7886] = {.lex_state = 157, .external_lex_state = 2},
  [7887] = {.lex_state = 157, .external_lex_state = 2},
  [7888] = {.lex_state = 157, .external_lex_state = 2},
  [7889] = {.lex_state = 157, .external_lex_state = 2},
  [7890] = {.lex_state = 157, .external_lex_state = 6},
  [7891] = {.lex_state = 255, .external_lex_state = 16},
  [7892] = {.lex_state = 255, .external_lex_state = 16},
  [7893] = {.lex_state = 255, .external_lex_state = 16},
  [7894] = {.lex_state = 326, .external_lex_state = 16},
  [7895] = {.lex_state = 135},
  [7896] = {.lex_state = 326, .external_lex_state = 16},
  [7897] = {.lex_state = 135},
  [7898] = {.lex_state = 135},
  [7899] = {.lex_state = 135},
  [7900] = {.lex_state = 326, .external_lex_state = 16},
  [7901] = {.lex_state = 217, .external_lex_state = 4},
  [7902] = {.lex_state = 326, .external_lex_state = 16},
  [7903] = {.lex_state = 234, .external_lex_state = 15},
  [7904] = {.lex_state = 326, .external_lex_state = 16},
  [7905] = {.lex_state = 217, .external_lex_state = 4},
  [7906] = {.lex_state = 326, .external_lex_state = 16},
  [7907] = {.lex_state = 135},
  [7908] = {.lex_state = 135, .external_lex_state = 2},
  [7909] = {.lex_state = 326, .external_lex_state = 16},
  [7910] = {.lex_state = 135, .external_lex_state = 2},
  [7911] = {.lex_state = 326, .external_lex_state = 16},
  [7912] = {.lex_state = 326, .external_lex_state = 16},
  [7913] = {.lex_state = 135},
  [7914] = {.lex_state = 135},
  [7915] = {.lex_state = 326, .external_lex_state = 16},
  [7916] = {.lex_state = 217, .external_lex_state = 4},
  [7917] = {.lex_state = 326, .external_lex_state = 16},
  [7918] = {.lex_state = 234, .external_lex_state = 15},
  [7919] = {.lex_state = 326, .external_lex_state = 16},
  [7920] = {.lex_state = 217, .external_lex_state = 4},
  [7921] = {.lex_state = 326, .external_lex_state = 16},
  [7922] = {.lex_state = 326, .external_lex_state = 16},
  [7923] = {.lex_state = 135},
  [7924] = {.lex_state = 135, .external_lex_state = 2},
  [7925] = {.lex_state = 326, .external_lex_state = 16},
  [7926] = {.lex_state = 135, .external_lex_state = 2},
  [7927] = {.lex_state = 135},
  [7928] = {.lex_state = 135, .external_lex_state = 10},
  [7929] = {.lex_state = 326, .external_lex_state = 16},
  [7930] = {.lex_state = 215},
  [7931] = {.lex_state = 157},
  [7932] = {.lex_state = 326, .external_lex_state = 16},
  [7933] = {.lex_state = 326, .external_lex_state = 16},
  [7934] = {.lex_state = 326, .external_lex_state = 16},
  [7935] = {.lex_state = 135},
  [7936] = {.lex_state = 255, .external_lex_state = 16},
  [7937] = {.lex_state = 157, .external_lex_state = 28},
  [7938] = {.lex_state = 255, .external_lex_state = 16},
  [7939] = {.lex_state = 157, .external_lex_state = 2},
  [7940] = {.lex_state = 332, .external_lex_state = 17},
  [7941] = {.lex_state = 135},
  [7942] = {.lex_state = 332, .external_lex_state = 17},
  [7943] = {.lex_state = 323, .external_lex_state = 16},
  [7944] = {.lex_state = 323, .external_lex_state = 16},
  [7945] = {.lex_state = 215},
  [7946] = {.lex_state = 329, .external_lex_state = 16},
  [7947] = {.lex_state = 323, .external_lex_state = 16},
  [7948] = {.lex_state = 135, .external_lex_state = 2},
  [7949] = {.lex_state = 135},
  [7950] = {.lex_state = 135, .external_lex_state = 10},
  [7951] = {.lex_state = 329, .external_lex_state = 16},
  [7952] = {.lex_state = 329, .external_lex_state = 16},
  [7953] = {.lex_state = 329, .external_lex_state = 16},
  [7954] = {.lex_state = 157, .external_lex_state = 2},
  [7955] = {.lex_state = 157, .external_lex_state = 28},
  [7956] = {.lex_state = 157, .external_lex_state = 2},
  [7957] = {.lex_state = 157, .external_lex_state = 2},
  [7958] = {.lex_state = 157, .external_lex_state = 2},
  [7959] = {.lex_state = 157, .external_lex_state = 2},
  [7960] = {.lex_state = 157, .external_lex_state = 2},
  [7961] = {.lex_state = 157, .external_lex_state = 2},
  [7962] = {.lex_state = 157, .external_lex_state = 2},
  [7963] = {.lex_state = 157, .external_lex_state = 2},
  [7964] = {.lex_state = 157, .external_lex_state = 2},
  [7965] = {.lex_state = 329, .external_lex_state = 19},
  [7966] = {.lex_state = 323, .external_lex_state = 16},
  [7967] = {.lex_state = 157, .external_lex_state = 6},
  [7968] = {.lex_state = 329, .external_lex_state = 16},
  [7969] = {.lex_state = 329, .external_lex_state = 16},
  [7970] = {.lex_state = 329, .external_lex_state = 16},
  [7971] = {.lex_state = 237, .external_lex_state = 16},
  [7972] = {.lex_state = 135},
  [7973] = {.lex_state = 135},
  [7974] = {.lex_state = 237, .external_lex_state = 16},
  [7975] = {.lex_state = 237, .external_lex_state = 16},
  [7976] = {.lex_state = 237, .external_lex_state = 16},
  [7977] = {.lex_state = 135},
  [7978] = {.lex_state = 237, .external_lex_state = 16},
  [7979] = {.lex_state = 237, .external_lex_state = 16},
  [7980] = {.lex_state = 217, .external_lex_state = 4},
  [7981] = {.lex_state = 237, .external_lex_state = 16},
  [7982] = {.lex_state = 157, .external_lex_state = 6},
  [7983] = {.lex_state = 157, .external_lex_state = 6},
  [7984] = {.lex_state = 237, .external_lex_state = 16},
  [7985] = {.lex_state = 255, .external_lex_state = 16},
  [7986] = {.lex_state = 255, .external_lex_state = 16},
  [7987] = {.lex_state = 245, .external_lex_state = 17},
  [7988] = {.lex_state = 242, .external_lex_state = 16},
  [7989] = {.lex_state = 135},
  [7990] = {.lex_state = 242, .external_lex_state = 16},
  [7991] = {.lex_state = 135},
  [7992] = {.lex_state = 242, .external_lex_state = 16},
  [7993] = {.lex_state = 217, .external_lex_state = 4},
  [7994] = {.lex_state = 242, .external_lex_state = 16},
  [7995] = {.lex_state = 234, .external_lex_state = 15},
  [7996] = {.lex_state = 242, .external_lex_state = 16},
  [7997] = {.lex_state = 217, .external_lex_state = 4},
  [7998] = {.lex_state = 242, .external_lex_state = 16},
  [7999] = {.lex_state = 242, .external_lex_state = 16},
  [8000] = {.lex_state = 242, .external_lex_state = 16},
  [8001] = {.lex_state = 135},
  [8002] = {.lex_state = 135, .external_lex_state = 2},
  [8003] = {.lex_state = 242, .external_lex_state = 16},
  [8004] = {.lex_state = 135},
  [8005] = {.lex_state = 135, .external_lex_state = 2},
  [8006] = {.lex_state = 157},
  [8007] = {.lex_state = 242, .external_lex_state = 16},
  [8008] = {.lex_state = 242, .external_lex_state = 16},
  [8009] = {.lex_state = 242, .external_lex_state = 16},
  [8010] = {.lex_state = 135},
  [8011] = {.lex_state = 135},
  [8012] = {.lex_state = 135},
  [8013] = {.lex_state = 135, .external_lex_state = 2},
  [8014] = {.lex_state = 242, .external_lex_state = 16},
  [8015] = {.lex_state = 135, .external_lex_state = 2},
  [8016] = {.lex_state = 242, .external_lex_state = 16},
  [8017] = {.lex_state = 242, .external_lex_state = 16},
  [8018] = {.lex_state = 135},
  [8019] = {.lex_state = 135},
  [8020] = {.lex_state = 242, .external_lex_state = 16},
  [8021] = {.lex_state = 135},
  [8022] = {.lex_state = 242, .external_lex_state = 16},
  [8023] = {.lex_state = 217, .external_lex_state = 4},
  [8024] = {.lex_state = 242, .external_lex_state = 16},
  [8025] = {.lex_state = 234, .external_lex_state = 15},
  [8026] = {.lex_state = 242, .external_lex_state = 16},
  [8027] = {.lex_state = 217, .external_lex_state = 4},
  [8028] = {.lex_state = 157, .external_lex_state = 28},
  [8029] = {.lex_state = 252, .external_lex_state = 16},
  [8030] = {.lex_state = 242, .external_lex_state = 16},
  [8031] = {.lex_state = 242, .external_lex_state = 16},
  [8032] = {.lex_state = 157, .external_lex_state = 2},
  [8033] = {.lex_state = 197, .external_lex_state = 20},
  [8034] = {.lex_state = 197, .external_lex_state = 20},
  [8035] = {.lex_state = 197, .external_lex_state = 20},
  [8036] = {.lex_state = 217, .external_lex_state = 4},
  [8037] = {.lex_state = 197, .external_lex_state = 20},
  [8038] = {.lex_state = 197, .external_lex_state = 20},
  [8039] = {.lex_state = 197, .external_lex_state = 20},
  [8040] = {.lex_state = 135},
  [8041] = {.lex_state = 197, .external_lex_state = 20},
  [8042] = {.lex_state = 135},
  [8043] = {.lex_state = 135, .external_lex_state = 2},
  [8044] = {.lex_state = 197, .external_lex_state = 20},
  [8045] = {.lex_state = 164, .external_lex_state = 3},
  [8046] = {.lex_state = 197, .external_lex_state = 16},
  [8047] = {.lex_state = 197, .external_lex_state = 16},
  [8048] = {.lex_state = 157, .external_lex_state = 28},
  [8049] = {.lex_state = 197, .external_lex_state = 16},
  [8050] = {.lex_state = 157, .external_lex_state = 2},
  [8051] = {.lex_state = 245, .external_lex_state = 17},
  [8052] = {.lex_state = 135},
  [8053] = {.lex_state = 245, .external_lex_state = 17},
  [8054] = {.lex_state = 197, .external_lex_state = 20},
  [8055] = {.lex_state = 135},
  [8056] = {.lex_state = 135},
  [8057] = {.lex_state = 197, .external_lex_state = 20},
  [8058] = {.lex_state = 197, .external_lex_state = 20},
  [8059] = {.lex_state = 197, .external_lex_state = 20},
  [8060] = {.lex_state = 135},
  [8061] = {.lex_state = 307, .external_lex_state = 16},
  [8062] = {.lex_state = 307, .external_lex_state = 16},
  [8063] = {.lex_state = 157, .external_lex_state = 2},
  [8064] = {.lex_state = 157, .external_lex_state = 2},
  [8065] = {.lex_state = 307, .external_lex_state = 16},
  [8066] = {.lex_state = 307, .external_lex_state = 16},
  [8067] = {.lex_state = 307, .external_lex_state = 16},
  [8068] = {.lex_state = 157, .external_lex_state = 29},
  [8069] = {.lex_state = 307, .external_lex_state = 16},
  [8070] = {.lex_state = 307, .external_lex_state = 16},
  [8071] = {.lex_state = 307, .external_lex_state = 16},
  [8072] = {.lex_state = 307, .external_lex_state = 16},
  [8073] = {.lex_state = 157, .external_lex_state = 2},
  [8074] = {.lex_state = 157, .external_lex_state = 28},
  [8075] = {.lex_state = 157, .external_lex_state = 2},
  [8076] = {.lex_state = 157, .external_lex_state = 2},
  [8077] = {.lex_state = 157, .external_lex_state = 2},
  [8078] = {.lex_state = 157, .external_lex_state = 2},
  [8079] = {.lex_state = 157, .external_lex_state = 2},
  [8080] = {.lex_state = 157, .external_lex_state = 2},
  [8081] = {.lex_state = 157, .external_lex_state = 2},
  [8082] = {.lex_state = 157, .external_lex_state = 2},
  [8083] = {.lex_state = 157, .external_lex_state = 2},
  [8084] = {.lex_state = 157, .external_lex_state = 6},
  [8085] = {.lex_state = 307, .external_lex_state = 16},
  [8086] = {.lex_state = 307, .external_lex_state = 16},
  [8087] = {.lex_state = 307, .external_lex_state = 16},
  [8088] = {.lex_state = 307, .external_lex_state = 16},
  [8089] = {.lex_state = 307, .external_lex_state = 16},
  [8090] = {.lex_state = 307, .external_lex_state = 16},
  [8091] = {.lex_state = 307, .external_lex_state = 16},
  [8092] = {.lex_state = 307, .external_lex_state = 16},
  [8093] = {.lex_state = 359, .external_lex_state = 20},
  [8094] = {.lex_state = 307, .external_lex_state = 16},
  [8095] = {.lex_state = 307, .external_lex_state = 16},
  [8096] = {.lex_state = 307, .external_lex_state = 16},
  [8097] = {.lex_state = 307, .external_lex_state = 16},
  [8098] = {.lex_state = 307, .external_lex_state = 16},
  [8099] = {.lex_state = 307, .external_lex_state = 16},
  [8100] = {.lex_state = 307, .external_lex_state = 16},
  [8101] = {.lex_state = 347, .external_lex_state = 17},
  [8102] = {.lex_state = 266, .external_lex_state = 6},
  [8103] = {.lex_state = 347, .external_lex_state = 17},
  [8104] = {.lex_state = 347, .external_lex_state = 17},
  [8105] = {.lex_state = 300, .external_lex_state = 27},
  [8106] = {.lex_state = 347, .external_lex_state = 17},
  [8107] = {.lex_state = 157, .external_lex_state = 2},
  [8108] = {.lex_state = 157, .external_lex_state = 2},
  [8109] = {.lex_state = 350, .external_lex_state = 16},
  [8110] = {.lex_state = 350, .external_lex_state = 16},
  [8111] = {.lex_state = 350, .external_lex_state = 16},
  [8112] = {.lex_state = 157, .external_lex_state = 29},
  [8113] = {.lex_state = 350, .external_lex_state = 16},
  [8114] = {.lex_state = 350, .external_lex_state = 16},
  [8115] = {.lex_state = 307, .external_lex_state = 19},
  [8116] = {.lex_state = 307, .external_lex_state = 16},
  [8117] = {.lex_state = 157, .external_lex_state = 28},
  [8118] = {.lex_state = 307, .external_lex_state = 16},
  [8119] = {.lex_state = 157, .external_lex_state = 2},
  [8120] = {.lex_state = 310, .external_lex_state = 17},
  [8121] = {.lex_state = 135},
  [8122] = {.lex_state = 310, .external_lex_state = 17},
  [8123] = {.lex_state = 313, .external_lex_state = 16},
  [8124] = {.lex_state = 313, .external_lex_state = 16},
  [8125] = {.lex_state = 313, .external_lex_state = 16},
  [8126] = {.lex_state = 313, .external_lex_state = 16},
  [8127] = {.lex_state = 157, .external_lex_state = 2},
  [8128] = {.lex_state = 157, .external_lex_state = 28},
  [8129] = {.lex_state = 157, .external_lex_state = 2},
  [8130] = {.lex_state = 157, .external_lex_state = 2},
  [8131] = {.lex_state = 157, .external_lex_state = 2},
  [8132] = {.lex_state = 157, .external_lex_state = 2},
  [8133] = {.lex_state = 157, .external_lex_state = 2},
  [8134] = {.lex_state = 157, .external_lex_state = 2},
  [8135] = {.lex_state = 157, .external_lex_state = 2},
  [8136] = {.lex_state = 157, .external_lex_state = 2},
  [8137] = {.lex_state = 157, .external_lex_state = 2},
  [8138] = {.lex_state = 313, .external_lex_state = 19},
  [8139] = {.lex_state = 350, .external_lex_state = 16},
  [8140] = {.lex_state = 350, .external_lex_state = 16},
  [8141] = {.lex_state = 157, .external_lex_state = 6},
  [8142] = {.lex_state = 313, .external_lex_state = 16},
  [8143] = {.lex_state = 313, .external_lex_state = 16},
  [8144] = {.lex_state = 313, .external_lex_state = 16},
  [8145] = {.lex_state = 350, .external_lex_state = 16},
  [8146] = {.lex_state = 350, .external_lex_state = 16},
  [8147] = {.lex_state = 350, .external_lex_state = 16},
  [8148] = {.lex_state = 359, .external_lex_state = 20},
  [8149] = {.lex_state = 350, .external_lex_state = 16},
  [8150] = {.lex_state = 350, .external_lex_state = 16},
  [8151] = {.lex_state = 350, .external_lex_state = 16},
  [8152] = {.lex_state = 350, .external_lex_state = 16},
  [8153] = {.lex_state = 350, .external_lex_state = 16},
  [8154] = {.lex_state = 350, .external_lex_state = 16},
  [8155] = {.lex_state = 350, .external_lex_state = 16},
  [8156] = {.lex_state = 350, .external_lex_state = 19},
  [8157] = {.lex_state = 197, .external_lex_state = 20},
  [8158] = {.lex_state = 197, .external_lex_state = 20},
  [8159] = {.lex_state = 217, .external_lex_state = 4},
  [8160] = {.lex_state = 197, .external_lex_state = 20},
  [8161] = {.lex_state = 197, .external_lex_state = 20},
  [8162] = {.lex_state = 197, .external_lex_state = 20},
  [8163] = {.lex_state = 197, .external_lex_state = 20},
  [8164] = {.lex_state = 197, .external_lex_state = 20},
  [8165] = {.lex_state = 197, .external_lex_state = 20},
  [8166] = {.lex_state = 197, .external_lex_state = 20},
  [8167] = {.lex_state = 359, .external_lex_state = 20},
  [8168] = {.lex_state = 197, .external_lex_state = 20},
  [8169] = {.lex_state = 197, .external_lex_state = 20},
  [8170] = {.lex_state = 197, .external_lex_state = 20},
  [8171] = {.lex_state = 197, .external_lex_state = 20},
  [8172] = {.lex_state = 197, .external_lex_state = 20},
  [8173] = {.lex_state = 197, .external_lex_state = 23},
  [8174] = {.lex_state = 197, .external_lex_state = 20},
  [8175] = {.lex_state = 197, .external_lex_state = 20},
  [8176] = {.lex_state = 197, .external_lex_state = 20},
  [8177] = {.lex_state = 245, .external_lex_state = 21},
  [8178] = {.lex_state = 215, .external_lex_state = 7},
  [8179] = {.lex_state = 242, .external_lex_state = 20},
  [8180] = {.lex_state = 242, .external_lex_state = 20},
  [8181] = {.lex_state = 135},
  [8182] = {.lex_state = 135, .external_lex_state = 2},
  [8183] = {.lex_state = 157, .external_lex_state = 28},
  [8184] = {.lex_state = 242, .external_lex_state = 16},
  [8185] = {.lex_state = 157, .external_lex_state = 2},
  [8186] = {.lex_state = 157, .external_lex_state = 2},
  [8187] = {.lex_state = 157, .external_lex_state = 2},
  [8188] = {.lex_state = 197, .external_lex_state = 16},
  [8189] = {.lex_state = 197, .external_lex_state = 16},
  [8190] = {.lex_state = 197, .external_lex_state = 16},
  [8191] = {.lex_state = 157, .external_lex_state = 29},
  [8192] = {.lex_state = 197, .external_lex_state = 16},
  [8193] = {.lex_state = 197, .external_lex_state = 16},
  [8194] = {.lex_state = 197, .external_lex_state = 16},
  [8195] = {.lex_state = 197, .external_lex_state = 16},
  [8196] = {.lex_state = 197, .external_lex_state = 16},
  [8197] = {.lex_state = 197, .external_lex_state = 16},
  [8198] = {.lex_state = 197, .external_lex_state = 16},
  [8199] = {.lex_state = 197, .external_lex_state = 16},
  [8200] = {.lex_state = 197, .external_lex_state = 16},
  [8201] = {.lex_state = 359, .external_lex_state = 20},
  [8202] = {.lex_state = 197, .external_lex_state = 16},
  [8203] = {.lex_state = 197, .external_lex_state = 16},
  [8204] = {.lex_state = 197, .external_lex_state = 16},
  [8205] = {.lex_state = 197, .external_lex_state = 16},
  [8206] = {.lex_state = 197, .external_lex_state = 16},
  [8207] = {.lex_state = 223, .external_lex_state = 17},
  [8208] = {.lex_state = 266, .external_lex_state = 6},
  [8209] = {.lex_state = 223, .external_lex_state = 17},
  [8210] = {.lex_state = 223, .external_lex_state = 17},
  [8211] = {.lex_state = 300, .external_lex_state = 27},
  [8212] = {.lex_state = 223, .external_lex_state = 17},
  [8213] = {.lex_state = 157, .external_lex_state = 2},
  [8214] = {.lex_state = 157, .external_lex_state = 2},
  [8215] = {.lex_state = 223, .external_lex_state = 17},
  [8216] = {.lex_state = 223, .external_lex_state = 17},
  [8217] = {.lex_state = 157, .external_lex_state = 2},
  [8218] = {.lex_state = 157, .external_lex_state = 2},
  [8219] = {.lex_state = 223, .external_lex_state = 17},
  [8220] = {.lex_state = 157, .external_lex_state = 2},
  [8221] = {.lex_state = 223, .external_lex_state = 17},
  [8222] = {.lex_state = 208, .external_lex_state = 16},
  [8223] = {.lex_state = 208, .external_lex_state = 16},
  [8224] = {.lex_state = 208, .external_lex_state = 16},
  [8225] = {.lex_state = 157},
  [8226] = {.lex_state = 208, .external_lex_state = 19},
  [8227] = {.lex_state = 208, .external_lex_state = 16},
  [8228] = {.lex_state = 208, .external_lex_state = 16},
  [8229] = {.lex_state = 157, .external_lex_state = 29},
  [8230] = {.lex_state = 208, .external_lex_state = 16},
  [8231] = {.lex_state = 208, .external_lex_state = 16},
  [8232] = {.lex_state = 197, .external_lex_state = 19},
  [8233] = {.lex_state = 258, .external_lex_state = 18},
  [8234] = {.lex_state = 258},
  [8235] = {.lex_state = 217, .external_lex_state = 4},
  [8236] = {.lex_state = 258},
  [8237] = {.lex_state = 258},
  [8238] = {.lex_state = 258},
  [8239] = {.lex_state = 135},
  [8240] = {.lex_state = 135},
  [8241] = {.lex_state = 258},
  [8242] = {.lex_state = 258},
  [8243] = {.lex_state = 258},
  [8244] = {.lex_state = 258},
  [8245] = {.lex_state = 135},
  [8246] = {.lex_state = 258},
  [8247] = {.lex_state = 217, .external_lex_state = 4},
  [8248] = {.lex_state = 258},
  [8249] = {.lex_state = 258},
  [8250] = {.lex_state = 258},
  [8251] = {.lex_state = 135},
  [8252] = {.lex_state = 258},
  [8253] = {.lex_state = 135},
  [8254] = {.lex_state = 135, .external_lex_state = 2},
  [8255] = {.lex_state = 258},
  [8256] = {.lex_state = 164, .external_lex_state = 3},
  [8257] = {.lex_state = 258},
  [8258] = {.lex_state = 258, .external_lex_state = 6},
  [8259] = {.lex_state = 197, .external_lex_state = 16},
  [8260] = {.lex_state = 197, .external_lex_state = 16},
  [8261] = {.lex_state = 157, .external_lex_state = 6},
  [8262] = {.lex_state = 197, .external_lex_state = 16},
  [8263] = {.lex_state = 197, .external_lex_state = 16},
  [8264] = {.lex_state = 197, .external_lex_state = 16},
  [8265] = {.lex_state = 157, .external_lex_state = 2},
  [8266] = {.lex_state = 157, .external_lex_state = 2},
  [8267] = {.lex_state = 197, .external_lex_state = 16},
  [8268] = {.lex_state = 197, .external_lex_state = 16},
  [8269] = {.lex_state = 197, .external_lex_state = 16},
  [8270] = {.lex_state = 157, .external_lex_state = 29},
  [8271] = {.lex_state = 197, .external_lex_state = 16},
  [8272] = {.lex_state = 197, .external_lex_state = 16},
  [8273] = {.lex_state = 197, .external_lex_state = 16},
  [8274] = {.lex_state = 197, .external_lex_state = 16},
  [8275] = {.lex_state = 197, .external_lex_state = 16},
  [8276] = {.lex_state = 197, .external_lex_state = 16},
  [8277] = {.lex_state = 197, .external_lex_state = 16},
  [8278] = {.lex_state = 197, .external_lex_state = 16},
  [8279] = {.lex_state = 197, .external_lex_state = 16},
  [8280] = {.lex_state = 359, .external_lex_state = 20},
  [8281] = {.lex_state = 197, .external_lex_state = 16},
  [8282] = {.lex_state = 197, .external_lex_state = 16},
  [8283] = {.lex_state = 197, .external_lex_state = 16},
  [8284] = {.lex_state = 197, .external_lex_state = 16},
  [8285] = {.lex_state = 197, .external_lex_state = 16},
  [8286] = {.lex_state = 223, .external_lex_state = 17},
  [8287] = {.lex_state = 266, .external_lex_state = 6},
  [8288] = {.lex_state = 223, .external_lex_state = 17},
  [8289] = {.lex_state = 223, .external_lex_state = 17},
  [8290] = {.lex_state = 300, .external_lex_state = 27},
  [8291] = {.lex_state = 223, .external_lex_state = 17},
  [8292] = {.lex_state = 242, .external_lex_state = 16},
  [8293] = {.lex_state = 157, .external_lex_state = 2},
  [8294] = {.lex_state = 157, .external_lex_state = 2},
  [8295] = {.lex_state = 223, .external_lex_state = 17},
  [8296] = {.lex_state = 223, .external_lex_state = 17},
  [8297] = {.lex_state = 157, .external_lex_state = 2},
  [8298] = {.lex_state = 157, .external_lex_state = 2},
  [8299] = {.lex_state = 223, .external_lex_state = 17},
  [8300] = {.lex_state = 157, .external_lex_state = 2},
  [8301] = {.lex_state = 223, .external_lex_state = 17},
  [8302] = {.lex_state = 208, .external_lex_state = 16},
  [8303] = {.lex_state = 208, .external_lex_state = 16},
  [8304] = {.lex_state = 208, .external_lex_state = 16},
  [8305] = {.lex_state = 157},
  [8306] = {.lex_state = 208, .external_lex_state = 19},
  [8307] = {.lex_state = 208, .external_lex_state = 16},
  [8308] = {.lex_state = 208, .external_lex_state = 16},
  [8309] = {.lex_state = 157, .external_lex_state = 29},
  [8310] = {.lex_state = 208, .external_lex_state = 16},
  [8311] = {.lex_state = 208, .external_lex_state = 16},
  [8312] = {.lex_state = 197, .external_lex_state = 19},
  [8313] = {.lex_state = 245, .external_lex_state = 17},
  [8314] = {.lex_state = 135},
  [8315] = {.lex_state = 245, .external_lex_state = 17},
  [8316] = {.lex_state = 157, .external_lex_state = 28},
  [8317] = {.lex_state = 197, .external_lex_state = 16},
  [8318] = {.lex_state = 242, .external_lex_state = 16},
  [8319] = {.lex_state = 242, .external_lex_state = 16},
  [8320] = {.lex_state = 242, .external_lex_state = 16},
  [8321] = {.lex_state = 242, .external_lex_state = 16},
  [8322] = {.lex_state = 157, .external_lex_state = 6},
  [8323] = {.lex_state = 242, .external_lex_state = 16},
  [8324] = {.lex_state = 242, .external_lex_state = 16},
  [8325] = {.lex_state = 242, .external_lex_state = 16},
  [8326] = {.lex_state = 242, .external_lex_state = 16},
  [8327] = {.lex_state = 242, .external_lex_state = 16},
  [8328] = {.lex_state = 242, .external_lex_state = 16},
  [8329] = {.lex_state = 359, .external_lex_state = 20},
  [8330] = {.lex_state = 242, .external_lex_state = 16},
  [8331] = {.lex_state = 242, .external_lex_state = 16},
  [8332] = {.lex_state = 242, .external_lex_state = 16},
  [8333] = {.lex_state = 242, .external_lex_state = 16},
  [8334] = {.lex_state = 242, .external_lex_state = 16},
  [8335] = {.lex_state = 242, .external_lex_state = 16},
  [8336] = {.lex_state = 242, .external_lex_state = 16},
  [8337] = {.lex_state = 242, .external_lex_state = 19},
  [8338] = {.lex_state = 157, .external_lex_state = 2},
  [8339] = {.lex_state = 197, .external_lex_state = 5},
  [8340] = {.lex_state = 197, .external_lex_state = 13},
  [8341] = {.lex_state = 220, .external_lex_state = 21},
  [8342] = {.lex_state = 220, .external_lex_state = 21},
  [8343] = {.lex_state = 157, .external_lex_state = 2},
  [8344] = {.lex_state = 157, .external_lex_state = 2},
  [8345] = {.lex_state = 220, .external_lex_state = 21},
  [8346] = {.lex_state = 157, .external_lex_state = 2},
  [8347] = {.lex_state = 164},
  [8348] = {.lex_state = 220, .external_lex_state = 21},
  [8349] = {.lex_state = 208, .external_lex_state = 20},
  [8350] = {.lex_state = 197, .external_lex_state = 20},
  [8351] = {.lex_state = 197, .external_lex_state = 20},
  [8352] = {.lex_state = 223, .external_lex_state = 21},
  [8353] = {.lex_state = 157},
  [8354] = {.lex_state = 197, .external_lex_state = 23},
  [8355] = {.lex_state = 197, .external_lex_state = 20},
  [8356] = {.lex_state = 157},
  [8357] = {.lex_state = 135, .external_lex_state = 10},
  [8358] = {.lex_state = 135},
  [8359] = {.lex_state = 157},
  [8360] = {.lex_state = 135},
  [8361] = {.lex_state = 215},
  [8362] = {.lex_state = 197},
  [8363] = {.lex_state = 197, .external_lex_state = 5},
  [8364] = {.lex_state = 197, .external_lex_state = 5},
  [8365] = {.lex_state = 157, .external_lex_state = 2},
  [8366] = {.lex_state = 157, .external_lex_state = 2},
  [8367] = {.lex_state = 197, .external_lex_state = 5},
  [8368] = {.lex_state = 197, .external_lex_state = 5},
  [8369] = {.lex_state = 197, .external_lex_state = 5},
  [8370] = {.lex_state = 157, .external_lex_state = 29},
  [8371] = {.lex_state = 197, .external_lex_state = 5},
  [8372] = {.lex_state = 197, .external_lex_state = 5},
  [8373] = {.lex_state = 197, .external_lex_state = 5},
  [8374] = {.lex_state = 197, .external_lex_state = 5},
  [8375] = {.lex_state = 197, .external_lex_state = 5},
  [8376] = {.lex_state = 197, .external_lex_state = 5},
  [8377] = {.lex_state = 157, .external_lex_state = 2},
  [8378] = {.lex_state = 157, .external_lex_state = 28},
  [8379] = {.lex_state = 157, .external_lex_state = 2},
  [8380] = {.lex_state = 157, .external_lex_state = 2},
  [8381] = {.lex_state = 157, .external_lex_state = 2},
  [8382] = {.lex_state = 157, .external_lex_state = 2},
  [8383] = {.lex_state = 157, .external_lex_state = 2},
  [8384] = {.lex_state = 157, .external_lex_state = 2},
  [8385] = {.lex_state = 157, .external_lex_state = 2},
  [8386] = {.lex_state = 157, .external_lex_state = 2},
  [8387] = {.lex_state = 157, .external_lex_state = 2},
  [8388] = {.lex_state = 197, .external_lex_state = 14},
  [8389] = {.lex_state = 157, .external_lex_state = 6},
  [8390] = {.lex_state = 197, .external_lex_state = 5},
  [8391] = {.lex_state = 197, .external_lex_state = 5},
  [8392] = {.lex_state = 197, .external_lex_state = 5},
  [8393] = {.lex_state = 197, .external_lex_state = 5},
  [8394] = {.lex_state = 197, .external_lex_state = 5},
  [8395] = {.lex_state = 197, .external_lex_state = 5},
  [8396] = {.lex_state = 197, .external_lex_state = 5},
  [8397] = {.lex_state = 197, .external_lex_state = 5},
  [8398] = {.lex_state = 359, .external_lex_state = 20},
  [8399] = {.lex_state = 197, .external_lex_state = 5},
  [8400] = {.lex_state = 197, .external_lex_state = 5},
  [8401] = {.lex_state = 197, .external_lex_state = 5},
  [8402] = {.lex_state = 197, .external_lex_state = 5},
  [8403] = {.lex_state = 197, .external_lex_state = 5},
  [8404] = {.lex_state = 197, .external_lex_state = 5},
  [8405] = {.lex_state = 197, .external_lex_state = 5},
  [8406] = {.lex_state = 271, .external_lex_state = 9},
  [8407] = {.lex_state = 266, .external_lex_state = 6},
  [8408] = {.lex_state = 271, .external_lex_state = 9},
  [8409] = {.lex_state = 271, .external_lex_state = 9},
  [8410] = {.lex_state = 300, .external_lex_state = 27},
  [8411] = {.lex_state = 271, .external_lex_state = 9},
  [8412] = {.lex_state = 157, .external_lex_state = 2},
  [8413] = {.lex_state = 157, .external_lex_state = 2},
  [8414] = {.lex_state = 268, .external_lex_state = 5},
  [8415] = {.lex_state = 268, .external_lex_state = 5},
  [8416] = {.lex_state = 268, .external_lex_state = 5},
  [8417] = {.lex_state = 157, .external_lex_state = 29},
  [8418] = {.lex_state = 268, .external_lex_state = 5},
  [8419] = {.lex_state = 268, .external_lex_state = 5},
  [8420] = {.lex_state = 197, .external_lex_state = 14},
  [8421] = {.lex_state = 197, .external_lex_state = 5},
  [8422] = {.lex_state = 223, .external_lex_state = 9},
  [8423] = {.lex_state = 135},
  [8424] = {.lex_state = 223, .external_lex_state = 9},
  [8425] = {.lex_state = 197, .external_lex_state = 5},
  [8426] = {.lex_state = 197, .external_lex_state = 5},
  [8427] = {.lex_state = 197, .external_lex_state = 5},
  [8428] = {.lex_state = 157, .external_lex_state = 2},
  [8429] = {.lex_state = 157, .external_lex_state = 28},
  [8430] = {.lex_state = 157, .external_lex_state = 2},
  [8431] = {.lex_state = 157, .external_lex_state = 2},
  [8432] = {.lex_state = 157, .external_lex_state = 2},
  [8433] = {.lex_state = 157, .external_lex_state = 2},
  [8434] = {.lex_state = 157, .external_lex_state = 2},
  [8435] = {.lex_state = 157, .external_lex_state = 2},
  [8436] = {.lex_state = 157, .external_lex_state = 2},
  [8437] = {.lex_state = 157, .external_lex_state = 2},
  [8438] = {.lex_state = 157, .external_lex_state = 2},
  [8439] = {.lex_state = 157, .external_lex_state = 28},
  [8440] = {.lex_state = 197, .external_lex_state = 5},
  [8441] = {.lex_state = 135},
  [8442] = {.lex_state = 208, .external_lex_state = 5},
  [8443] = {.lex_state = 208, .external_lex_state = 5},
  [8444] = {.lex_state = 208, .external_lex_state = 5},
  [8445] = {.lex_state = 208, .external_lex_state = 5},
  [8446] = {.lex_state = 157, .external_lex_state = 2},
  [8447] = {.lex_state = 157, .external_lex_state = 28},
  [8448] = {.lex_state = 157, .external_lex_state = 2},
  [8449] = {.lex_state = 157, .external_lex_state = 2},
  [8450] = {.lex_state = 157, .external_lex_state = 2},
  [8451] = {.lex_state = 157, .external_lex_state = 2},
  [8452] = {.lex_state = 157, .external_lex_state = 2},
  [8453] = {.lex_state = 157, .external_lex_state = 2},
  [8454] = {.lex_state = 157, .external_lex_state = 2},
  [8455] = {.lex_state = 157, .external_lex_state = 2},
  [8456] = {.lex_state = 157, .external_lex_state = 2},
  [8457] = {.lex_state = 208, .external_lex_state = 14},
  [8458] = {.lex_state = 268, .external_lex_state = 5},
  [8459] = {.lex_state = 268, .external_lex_state = 5},
  [8460] = {.lex_state = 157, .external_lex_state = 6},
  [8461] = {.lex_state = 208, .external_lex_state = 5},
  [8462] = {.lex_state = 208, .external_lex_state = 5},
  [8463] = {.lex_state = 208, .external_lex_state = 5},
  [8464] = {.lex_state = 268, .external_lex_state = 5},
  [8465] = {.lex_state = 268, .external_lex_state = 5},
  [8466] = {.lex_state = 268, .external_lex_state = 5},
  [8467] = {.lex_state = 359, .external_lex_state = 20},
  [8468] = {.lex_state = 268, .external_lex_state = 5},
  [8469] = {.lex_state = 268, .external_lex_state = 5},
  [8470] = {.lex_state = 268, .external_lex_state = 5},
  [8471] = {.lex_state = 268, .external_lex_state = 5},
  [8472] = {.lex_state = 268, .external_lex_state = 5},
  [8473] = {.lex_state = 268, .external_lex_state = 5},
  [8474] = {.lex_state = 268, .external_lex_state = 5},
  [8475] = {.lex_state = 268, .external_lex_state = 14},
  [8476] = {.lex_state = 157, .external_lex_state = 2},
  [8477] = {.lex_state = 157, .external_lex_state = 2},
  [8478] = {.lex_state = 157, .external_lex_state = 2},
  [8479] = {.lex_state = 197, .external_lex_state = 16},
  [8480] = {.lex_state = 197, .external_lex_state = 16},
  [8481] = {.lex_state = 197, .external_lex_state = 16},
  [8482] = {.lex_state = 157, .external_lex_state = 29},
  [8483] = {.lex_state = 197, .external_lex_state = 16},
  [8484] = {.lex_state = 197, .external_lex_state = 16},
  [8485] = {.lex_state = 197, .external_lex_state = 20},
  [8486] = {.lex_state = 157, .external_lex_state = 2},
  [8487] = {.lex_state = 197, .external_lex_state = 20},
  [8488] = {.lex_state = 197, .external_lex_state = 20},
  [8489] = {.lex_state = 197, .external_lex_state = 20},
  [8490] = {.lex_state = 197, .external_lex_state = 20},
  [8491] = {.lex_state = 197, .external_lex_state = 20},
  [8492] = {.lex_state = 197, .external_lex_state = 20},
  [8493] = {.lex_state = 359, .external_lex_state = 20},
  [8494] = {.lex_state = 197, .external_lex_state = 20},
  [8495] = {.lex_state = 197, .external_lex_state = 20},
  [8496] = {.lex_state = 197, .external_lex_state = 20},
  [8497] = {.lex_state = 197, .external_lex_state = 20},
  [8498] = {.lex_state = 197, .external_lex_state = 20},
  [8499] = {.lex_state = 223, .external_lex_state = 21},
  [8500] = {.lex_state = 266, .external_lex_state = 6},
  [8501] = {.lex_state = 223, .external_lex_state = 21},
  [8502] = {.lex_state = 223, .external_lex_state = 21},
  [8503] = {.lex_state = 300, .external_lex_state = 27},
  [8504] = {.lex_state = 223, .external_lex_state = 21},
  [8505] = {.lex_state = 242, .external_lex_state = 16},
  [8506] = {.lex_state = 197, .external_lex_state = 23},
  [8507] = {.lex_state = 157},
  [8508] = {.lex_state = 232, .external_lex_state = 2},
  [8509] = {.lex_state = 157},
  [8510] = {.lex_state = 135},
  [8511] = {.lex_state = 215},
  [8512] = {.lex_state = 274, .external_lex_state = 20},
  [8513] = {.lex_state = 274, .external_lex_state = 20},
  [8514] = {.lex_state = 157, .external_lex_state = 2},
  [8515] = {.lex_state = 157, .external_lex_state = 28},
  [8516] = {.lex_state = 157, .external_lex_state = 2},
  [8517] = {.lex_state = 157, .external_lex_state = 2},
  [8518] = {.lex_state = 157, .external_lex_state = 2},
  [8519] = {.lex_state = 157, .external_lex_state = 2},
  [8520] = {.lex_state = 157, .external_lex_state = 2},
  [8521] = {.lex_state = 157, .external_lex_state = 2},
  [8522] = {.lex_state = 157, .external_lex_state = 2},
  [8523] = {.lex_state = 157, .external_lex_state = 2},
  [8524] = {.lex_state = 157, .external_lex_state = 2},
  [8525] = {.lex_state = 157, .external_lex_state = 2},
  [8526] = {.lex_state = 274, .external_lex_state = 23},
  [8527] = {.lex_state = 220},
  [8528] = {.lex_state = 274, .external_lex_state = 16},
  [8529] = {.lex_state = 274, .external_lex_state = 16},
  [8530] = {.lex_state = 274, .external_lex_state = 16},
  [8531] = {.lex_state = 274, .external_lex_state = 16},
  [8532] = {.lex_state = 157, .external_lex_state = 2},
  [8533] = {.lex_state = 157, .external_lex_state = 28},
  [8534] = {.lex_state = 157, .external_lex_state = 2},
  [8535] = {.lex_state = 157, .external_lex_state = 2},
  [8536] = {.lex_state = 157, .external_lex_state = 2},
  [8537] = {.lex_state = 157, .external_lex_state = 2},
  [8538] = {.lex_state = 157, .external_lex_state = 2},
  [8539] = {.lex_state = 157, .external_lex_state = 2},
  [8540] = {.lex_state = 157, .external_lex_state = 2},
  [8541] = {.lex_state = 157, .external_lex_state = 2},
  [8542] = {.lex_state = 157, .external_lex_state = 2},
  [8543] = {.lex_state = 157, .external_lex_state = 6},
  [8544] = {.lex_state = 274, .external_lex_state = 16},
  [8545] = {.lex_state = 274, .external_lex_state = 16},
  [8546] = {.lex_state = 274, .external_lex_state = 16},
  [8547] = {.lex_state = 274, .external_lex_state = 16},
  [8548] = {.lex_state = 274, .external_lex_state = 16},
  [8549] = {.lex_state = 274, .external_lex_state = 16},
  [8550] = {.lex_state = 274, .external_lex_state = 16},
  [8551] = {.lex_state = 274, .external_lex_state = 16},
  [8552] = {.lex_state = 359, .external_lex_state = 20},
  [8553] = {.lex_state = 274, .external_lex_state = 16},
  [8554] = {.lex_state = 274, .external_lex_state = 16},
  [8555] = {.lex_state = 274, .external_lex_state = 16},
  [8556] = {.lex_state = 274, .external_lex_state = 16},
  [8557] = {.lex_state = 274, .external_lex_state = 16},
  [8558] = {.lex_state = 274, .external_lex_state = 16},
  [8559] = {.lex_state = 274, .external_lex_state = 16},
  [8560] = {.lex_state = 274, .external_lex_state = 20},
  [8561] = {.lex_state = 157, .external_lex_state = 28},
  [8562] = {.lex_state = 274, .external_lex_state = 20},
  [8563] = {.lex_state = 157, .external_lex_state = 2},
  [8564] = {.lex_state = 197, .external_lex_state = 5},
  [8565] = {.lex_state = 223, .external_lex_state = 21},
  [8566] = {.lex_state = 135},
  [8567] = {.lex_state = 223, .external_lex_state = 21},
  [8568] = {.lex_state = 277, .external_lex_state = 16},
  [8569] = {.lex_state = 277, .external_lex_state = 16},
  [8570] = {.lex_state = 277, .external_lex_state = 16},
  [8571] = {.lex_state = 277, .external_lex_state = 16},
  [8572] = {.lex_state = 157, .external_lex_state = 2},
  [8573] = {.lex_state = 157, .external_lex_state = 28},
  [8574] = {.lex_state = 157, .external_lex_state = 2},
  [8575] = {.lex_state = 157, .external_lex_state = 2},
  [8576] = {.lex_state = 157, .external_lex_state = 2},
  [8577] = {.lex_state = 157, .external_lex_state = 2},
  [8578] = {.lex_state = 157, .external_lex_state = 2},
  [8579] = {.lex_state = 157, .external_lex_state = 2},
  [8580] = {.lex_state = 157, .external_lex_state = 2},
  [8581] = {.lex_state = 157, .external_lex_state = 2},
  [8582] = {.lex_state = 157, .external_lex_state = 2},
  [8583] = {.lex_state = 277, .external_lex_state = 19},
  [8584] = {.lex_state = 344, .external_lex_state = 16},
  [8585] = {.lex_state = 344, .external_lex_state = 16},
  [8586] = {.lex_state = 157, .external_lex_state = 6},
  [8587] = {.lex_state = 277, .external_lex_state = 16},
  [8588] = {.lex_state = 277, .external_lex_state = 16},
  [8589] = {.lex_state = 277, .external_lex_state = 16},
  [8590] = {.lex_state = 344, .external_lex_state = 16},
  [8591] = {.lex_state = 344, .external_lex_state = 16},
  [8592] = {.lex_state = 344, .external_lex_state = 16},
  [8593] = {.lex_state = 359, .external_lex_state = 20},
  [8594] = {.lex_state = 344, .external_lex_state = 16},
  [8595] = {.lex_state = 344, .external_lex_state = 16},
  [8596] = {.lex_state = 344, .external_lex_state = 16},
  [8597] = {.lex_state = 344, .external_lex_state = 16},
  [8598] = {.lex_state = 344, .external_lex_state = 16},
  [8599] = {.lex_state = 344, .external_lex_state = 16},
  [8600] = {.lex_state = 344, .external_lex_state = 16},
  [8601] = {.lex_state = 344, .external_lex_state = 19},
  [8602] = {.lex_state = 258, .external_lex_state = 13},
  [8603] = {.lex_state = 135, .external_lex_state = 10},
  [8604] = {.lex_state = 135, .external_lex_state = 2},
  [8605] = {.lex_state = 135},
  [8606] = {.lex_state = 258, .external_lex_state = 13},
  [8607] = {.lex_state = 232, .external_lex_state = 2},
  [8608] = {.lex_state = 215},
  [8609] = {.lex_state = 197, .external_lex_state = 13},
  [8610] = {.lex_state = 135, .external_lex_state = 2},
  [8611] = {.lex_state = 135, .external_lex_state = 10},
  [8612] = {.lex_state = 220},
  [8613] = {.lex_state = 157},
  [8614] = {.lex_state = 197, .external_lex_state = 13},
  [8615] = {.lex_state = 197, .external_lex_state = 5},
  [8616] = {.lex_state = 197, .external_lex_state = 5},
  [8617] = {.lex_state = 197, .external_lex_state = 5},
  [8618] = {.lex_state = 217, .external_lex_state = 4},
  [8619] = {.lex_state = 197, .external_lex_state = 5},
  [8620] = {.lex_state = 197, .external_lex_state = 5},
  [8621] = {.lex_state = 197, .external_lex_state = 5},
  [8622] = {.lex_state = 135},
  [8623] = {.lex_state = 197, .external_lex_state = 5},
  [8624] = {.lex_state = 135},
  [8625] = {.lex_state = 135, .external_lex_state = 2},
  [8626] = {.lex_state = 197, .external_lex_state = 5},
  [8627] = {.lex_state = 164, .external_lex_state = 3},
  [8628] = {.lex_state = 197, .external_lex_state = 5},
  [8629] = {.lex_state = 197, .external_lex_state = 5},
  [8630] = {.lex_state = 197, .external_lex_state = 5},
  [8631] = {.lex_state = 197, .external_lex_state = 5},
  [8632] = {.lex_state = 157, .external_lex_state = 28},
  [8633] = {.lex_state = 197, .external_lex_state = 5},
  [8634] = {.lex_state = 157, .external_lex_state = 2},
  [8635] = {.lex_state = 197, .external_lex_state = 5},
  [8636] = {.lex_state = 135},
  [8637] = {.lex_state = 135},
  [8638] = {.lex_state = 274, .external_lex_state = 16},
  [8639] = {.lex_state = 274, .external_lex_state = 16},
  [8640] = {.lex_state = 157, .external_lex_state = 6},
  [8641] = {.lex_state = 274, .external_lex_state = 16},
  [8642] = {.lex_state = 274, .external_lex_state = 16},
  [8643] = {.lex_state = 274, .external_lex_state = 16},
  [8644] = {.lex_state = 274, .external_lex_state = 16},
  [8645] = {.lex_state = 274, .external_lex_state = 16},
  [8646] = {.lex_state = 274, .external_lex_state = 16},
  [8647] = {.lex_state = 157, .external_lex_state = 2},
  [8648] = {.lex_state = 274, .external_lex_state = 16},
  [8649] = {.lex_state = 274, .external_lex_state = 16},
  [8650] = {.lex_state = 274, .external_lex_state = 16},
  [8651] = {.lex_state = 274, .external_lex_state = 16},
  [8652] = {.lex_state = 274, .external_lex_state = 16},
  [8653] = {.lex_state = 274, .external_lex_state = 16},
  [8654] = {.lex_state = 359, .external_lex_state = 20},
  [8655] = {.lex_state = 274, .external_lex_state = 16},
  [8656] = {.lex_state = 274, .external_lex_state = 16},
  [8657] = {.lex_state = 274, .external_lex_state = 16},
  [8658] = {.lex_state = 274, .external_lex_state = 16},
  [8659] = {.lex_state = 274, .external_lex_state = 16},
  [8660] = {.lex_state = 223, .external_lex_state = 17},
  [8661] = {.lex_state = 266, .external_lex_state = 6},
  [8662] = {.lex_state = 223, .external_lex_state = 17},
  [8663] = {.lex_state = 223, .external_lex_state = 17},
  [8664] = {.lex_state = 300, .external_lex_state = 27},
  [8665] = {.lex_state = 223, .external_lex_state = 17},
  [8666] = {.lex_state = 274, .external_lex_state = 19},
  [8667] = {.lex_state = 266, .external_lex_state = 6},
  [8668] = {.lex_state = 217, .external_lex_state = 22},
  [8669] = {.lex_state = 266, .external_lex_state = 6},
  [8670] = {.lex_state = 157, .external_lex_state = 29},
  [8671] = {.lex_state = 274, .external_lex_state = 16},
  [8672] = {.lex_state = 157, .external_lex_state = 28},
  [8673] = {.lex_state = 274, .external_lex_state = 16},
  [8674] = {.lex_state = 157, .external_lex_state = 2},
  [8675] = {.lex_state = 271, .external_lex_state = 17},
  [8676] = {.lex_state = 135},
  [8677] = {.lex_state = 271, .external_lex_state = 17},
  [8678] = {.lex_state = 344, .external_lex_state = 16},
  [8679] = {.lex_state = 344, .external_lex_state = 16},
  [8680] = {.lex_state = 157, .external_lex_state = 6},
  [8681] = {.lex_state = 344, .external_lex_state = 16},
  [8682] = {.lex_state = 344, .external_lex_state = 16},
  [8683] = {.lex_state = 344, .external_lex_state = 16},
  [8684] = {.lex_state = 197, .external_lex_state = 5},
  [8685] = {.lex_state = 197, .external_lex_state = 5},
  [8686] = {.lex_state = 197, .external_lex_state = 5},
  [8687] = {.lex_state = 135},
  [8688] = {.lex_state = 197, .external_lex_state = 5},
  [8689] = {.lex_state = 197, .external_lex_state = 5},
  [8690] = {.lex_state = 217, .external_lex_state = 4},
  [8691] = {.lex_state = 197, .external_lex_state = 5},
  [8692] = {.lex_state = 157, .external_lex_state = 6},
  [8693] = {.lex_state = 197, .external_lex_state = 5},
  [8694] = {.lex_state = 197, .external_lex_state = 5},
  [8695] = {.lex_state = 197, .external_lex_state = 5},
  [8696] = {.lex_state = 271, .external_lex_state = 9},
  [8697] = {.lex_state = 268, .external_lex_state = 5},
  [8698] = {.lex_state = 268, .external_lex_state = 5},
  [8699] = {.lex_state = 135},
  [8700] = {.lex_state = 135, .external_lex_state = 2},
  [8701] = {.lex_state = 268, .external_lex_state = 5},
  [8702] = {.lex_state = 268, .external_lex_state = 5},
  [8703] = {.lex_state = 197, .external_lex_state = 5},
  [8704] = {.lex_state = 197, .external_lex_state = 5},
  [8705] = {.lex_state = 157, .external_lex_state = 6},
  [8706] = {.lex_state = 197, .external_lex_state = 5},
  [8707] = {.lex_state = 197, .external_lex_state = 5},
  [8708] = {.lex_state = 197, .external_lex_state = 5},
  [8709] = {.lex_state = 197, .external_lex_state = 5},
  [8710] = {.lex_state = 197, .external_lex_state = 5},
  [8711] = {.lex_state = 197, .external_lex_state = 5},
  [8712] = {.lex_state = 197, .external_lex_state = 5},
  [8713] = {.lex_state = 197, .external_lex_state = 5},
  [8714] = {.lex_state = 197, .external_lex_state = 5},
  [8715] = {.lex_state = 197, .external_lex_state = 5},
  [8716] = {.lex_state = 197, .external_lex_state = 5},
  [8717] = {.lex_state = 197, .external_lex_state = 5},
  [8718] = {.lex_state = 359, .external_lex_state = 20},
  [8719] = {.lex_state = 197, .external_lex_state = 5},
  [8720] = {.lex_state = 197, .external_lex_state = 5},
  [8721] = {.lex_state = 197, .external_lex_state = 5},
  [8722] = {.lex_state = 197, .external_lex_state = 5},
  [8723] = {.lex_state = 197, .external_lex_state = 5},
  [8724] = {.lex_state = 197, .external_lex_state = 14},
  [8725] = {.lex_state = 157, .external_lex_state = 28},
  [8726] = {.lex_state = 197, .external_lex_state = 5},
  [8727] = {.lex_state = 157, .external_lex_state = 2},
  [8728] = {.lex_state = 197, .external_lex_state = 5},
  [8729] = {.lex_state = 197, .external_lex_state = 5},
  [8730] = {.lex_state = 197, .external_lex_state = 5},
  [8731] = {.lex_state = 197, .external_lex_state = 5},
  [8732] = {.lex_state = 197, .external_lex_state = 5},
  [8733] = {.lex_state = 197, .external_lex_state = 5},
  [8734] = {.lex_state = 359, .external_lex_state = 20},
  [8735] = {.lex_state = 197, .external_lex_state = 5},
  [8736] = {.lex_state = 197, .external_lex_state = 5},
  [8737] = {.lex_state = 197, .external_lex_state = 5},
  [8738] = {.lex_state = 197, .external_lex_state = 5},
  [8739] = {.lex_state = 197, .external_lex_state = 5},
  [8740] = {.lex_state = 197, .external_lex_state = 5},
  [8741] = {.lex_state = 197, .external_lex_state = 5},
  [8742] = {.lex_state = 197, .external_lex_state = 5},
  [8743] = {.lex_state = 135},
  [8744] = {.lex_state = 157, .external_lex_state = 2},
  [8745] = {.lex_state = 157, .external_lex_state = 2},
  [8746] = {.lex_state = 157, .external_lex_state = 2},
  [8747] = {.lex_state = 157, .external_lex_state = 2},
  [8748] = {.lex_state = 157, .external_lex_state = 2},
  [8749] = {.lex_state = 208, .external_lex_state = 5},
  [8750] = {.lex_state = 197, .external_lex_state = 5},
  [8751] = {.lex_state = 157},
  [8752] = {.lex_state = 197, .external_lex_state = 5},
  [8753] = {.lex_state = 197, .external_lex_state = 5},
  [8754] = {.lex_state = 157, .external_lex_state = 29},
  [8755] = {.lex_state = 197, .external_lex_state = 5},
  [8756] = {.lex_state = 197, .external_lex_state = 5},
  [8757] = {.lex_state = 197, .external_lex_state = 5},
  [8758] = {.lex_state = 157, .external_lex_state = 2},
  [8759] = {.lex_state = 197, .external_lex_state = 5},
  [8760] = {.lex_state = 197, .external_lex_state = 5},
  [8761] = {.lex_state = 197, .external_lex_state = 5},
  [8762] = {.lex_state = 197, .external_lex_state = 5},
  [8763] = {.lex_state = 197, .external_lex_state = 5},
  [8764] = {.lex_state = 197, .external_lex_state = 5},
  [8765] = {.lex_state = 359, .external_lex_state = 20},
  [8766] = {.lex_state = 197, .external_lex_state = 5},
  [8767] = {.lex_state = 197, .external_lex_state = 5},
  [8768] = {.lex_state = 197, .external_lex_state = 5},
  [8769] = {.lex_state = 197, .external_lex_state = 5},
  [8770] = {.lex_state = 197, .external_lex_state = 5},
  [8771] = {.lex_state = 223, .external_lex_state = 9},
  [8772] = {.lex_state = 266, .external_lex_state = 6},
  [8773] = {.lex_state = 223, .external_lex_state = 9},
  [8774] = {.lex_state = 223, .external_lex_state = 9},
  [8775] = {.lex_state = 300, .external_lex_state = 27},
  [8776] = {.lex_state = 223, .external_lex_state = 9},
  [8777] = {.lex_state = 135, .external_lex_state = 2},
  [8778] = {.lex_state = 217, .external_lex_state = 22},
  [8779] = {.lex_state = 164, .external_lex_state = 3},
  [8780] = {.lex_state = 157, .external_lex_state = 2},
  [8781] = {.lex_state = 157, .external_lex_state = 2},
  [8782] = {.lex_state = 157, .external_lex_state = 2},
  [8783] = {.lex_state = 164},
  [8784] = {.lex_state = 220, .external_lex_state = 9},
  [8785] = {.lex_state = 135, .external_lex_state = 2},
  [8786] = {.lex_state = 220, .external_lex_state = 9},
  [8787] = {.lex_state = 220, .external_lex_state = 9},
  [8788] = {.lex_state = 220, .external_lex_state = 9},
  [8789] = {.lex_state = 135, .external_lex_state = 13},
  [8790] = {.lex_state = 197, .external_lex_state = 5},
  [8791] = {.lex_state = 157},
  [8792] = {.lex_state = 223, .external_lex_state = 9},
  [8793] = {.lex_state = 208, .external_lex_state = 5},
  [8794] = {.lex_state = 197, .external_lex_state = 5},
  [8795] = {.lex_state = 197, .external_lex_state = 14},
  [8796] = {.lex_state = 135, .external_lex_state = 2},
  [8797] = {.lex_state = 197, .external_lex_state = 13},
  [8798] = {.lex_state = 135, .external_lex_state = 2},
  [8799] = {.lex_state = 135, .external_lex_state = 2},
  [8800] = {.lex_state = 135},
  [8801] = {.lex_state = 197, .external_lex_state = 13},
  [8802] = {.lex_state = 157, .external_lex_state = 2},
  [8803] = {.lex_state = 157, .external_lex_state = 2},
  [8804] = {.lex_state = 223, .external_lex_state = 9},
  [8805] = {.lex_state = 223, .external_lex_state = 9},
  [8806] = {.lex_state = 157, .external_lex_state = 2},
  [8807] = {.lex_state = 157, .external_lex_state = 2},
  [8808] = {.lex_state = 223, .external_lex_state = 9},
  [8809] = {.lex_state = 157, .external_lex_state = 2},
  [8810] = {.lex_state = 223, .external_lex_state = 9},
  [8811] = {.lex_state = 208, .external_lex_state = 5},
  [8812] = {.lex_state = 208, .external_lex_state = 5},
  [8813] = {.lex_state = 208, .external_lex_state = 5},
  [8814] = {.lex_state = 223, .external_lex_state = 9},
  [8815] = {.lex_state = 157},
  [8816] = {.lex_state = 208, .external_lex_state = 14},
  [8817] = {.lex_state = 208, .external_lex_state = 5},
  [8818] = {.lex_state = 208, .external_lex_state = 5},
  [8819] = {.lex_state = 157, .external_lex_state = 29},
  [8820] = {.lex_state = 208, .external_lex_state = 5},
  [8821] = {.lex_state = 208, .external_lex_state = 5},
  [8822] = {.lex_state = 197, .external_lex_state = 14},
  [8823] = {.lex_state = 274, .external_lex_state = 5},
  [8824] = {.lex_state = 274, .external_lex_state = 5},
  [8825] = {.lex_state = 157, .external_lex_state = 6},
  [8826] = {.lex_state = 274, .external_lex_state = 5},
  [8827] = {.lex_state = 274, .external_lex_state = 5},
  [8828] = {.lex_state = 274, .external_lex_state = 5},
  [8829] = {.lex_state = 274, .external_lex_state = 5},
  [8830] = {.lex_state = 274, .external_lex_state = 5},
  [8831] = {.lex_state = 274, .external_lex_state = 5},
  [8832] = {.lex_state = 274, .external_lex_state = 5},
  [8833] = {.lex_state = 274, .external_lex_state = 5},
  [8834] = {.lex_state = 274, .external_lex_state = 5},
  [8835] = {.lex_state = 274, .external_lex_state = 5},
  [8836] = {.lex_state = 274, .external_lex_state = 5},
  [8837] = {.lex_state = 274, .external_lex_state = 5},
  [8838] = {.lex_state = 359, .external_lex_state = 20},
  [8839] = {.lex_state = 274, .external_lex_state = 5},
  [8840] = {.lex_state = 274, .external_lex_state = 5},
  [8841] = {.lex_state = 274, .external_lex_state = 5},
  [8842] = {.lex_state = 274, .external_lex_state = 5},
  [8843] = {.lex_state = 274, .external_lex_state = 5},
  [8844] = {.lex_state = 274, .external_lex_state = 14},
  [8845] = {.lex_state = 157, .external_lex_state = 28},
  [8846] = {.lex_state = 274, .external_lex_state = 5},
  [8847] = {.lex_state = 157, .external_lex_state = 2},
  [8848] = {.lex_state = 271, .external_lex_state = 9},
  [8849] = {.lex_state = 135},
  [8850] = {.lex_state = 271, .external_lex_state = 9},
  [8851] = {.lex_state = 344, .external_lex_state = 5},
  [8852] = {.lex_state = 344, .external_lex_state = 5},
  [8853] = {.lex_state = 157, .external_lex_state = 6},
  [8854] = {.lex_state = 344, .external_lex_state = 5},
  [8855] = {.lex_state = 344, .external_lex_state = 5},
  [8856] = {.lex_state = 344, .external_lex_state = 5},
  [8857] = {.lex_state = 258, .external_lex_state = 6},
  [8858] = {.lex_state = 135},
  [8859] = {.lex_state = 258, .external_lex_state = 6},
  [8860] = {.lex_state = 372, .external_lex_state = 16},
  [8861] = {.lex_state = 372, .external_lex_state = 16},
  [8862] = {.lex_state = 157, .external_lex_state = 2},
  [8863] = {.lex_state = 157, .external_lex_state = 2},
  [8864] = {.lex_state = 274, .external_lex_state = 16},
  [8865] = {.lex_state = 274, .external_lex_state = 16},
  [8866] = {.lex_state = 274, .external_lex_state = 16},
  [8867] = {.lex_state = 157, .external_lex_state = 29},
  [8868] = {.lex_state = 274, .external_lex_state = 16},
  [8869] = {.lex_state = 274, .external_lex_state = 16},
  [8870] = {.lex_state = 271, .external_lex_state = 17},
  [8871] = {.lex_state = 228},
  [8872] = {.lex_state = 157, .external_lex_state = 2},
  [8873] = {.lex_state = 157, .external_lex_state = 2},
  [8874] = {.lex_state = 157, .external_lex_state = 2},
  [8875] = {.lex_state = 372, .external_lex_state = 16},
  [8876] = {.lex_state = 274, .external_lex_state = 16},
  [8877] = {.lex_state = 274, .external_lex_state = 19},
  [8878] = {.lex_state = 372, .external_lex_state = 16},
  [8879] = {.lex_state = 372, .external_lex_state = 16},
  [8880] = {.lex_state = 372, .external_lex_state = 16},
  [8881] = {.lex_state = 157, .external_lex_state = 2},
  [8882] = {.lex_state = 157, .external_lex_state = 28},
  [8883] = {.lex_state = 157, .external_lex_state = 2},
  [8884] = {.lex_state = 157, .external_lex_state = 2},
  [8885] = {.lex_state = 157, .external_lex_state = 2},
  [8886] = {.lex_state = 157, .external_lex_state = 2},
  [8887] = {.lex_state = 157, .external_lex_state = 2},
  [8888] = {.lex_state = 157, .external_lex_state = 2},
  [8889] = {.lex_state = 157, .external_lex_state = 2},
  [8890] = {.lex_state = 157, .external_lex_state = 2},
  [8891] = {.lex_state = 157, .external_lex_state = 2},
  [8892] = {.lex_state = 157, .external_lex_state = 2},
  [8893] = {.lex_state = 372, .external_lex_state = 19},
  [8894] = {.lex_state = 274, .external_lex_state = 16},
  [8895] = {.lex_state = 274, .external_lex_state = 16},
  [8896] = {.lex_state = 157, .external_lex_state = 6},
  [8897] = {.lex_state = 258, .external_lex_state = 18},
  [8898] = {.lex_state = 258, .external_lex_state = 18},
  [8899] = {.lex_state = 258, .external_lex_state = 18},
  [8900] = {.lex_state = 274, .external_lex_state = 16},
  [8901] = {.lex_state = 274, .external_lex_state = 16},
  [8902] = {.lex_state = 274, .external_lex_state = 16},
  [8903] = {.lex_state = 359, .external_lex_state = 20},
  [8904] = {.lex_state = 274, .external_lex_state = 16},
  [8905] = {.lex_state = 274, .external_lex_state = 16},
  [8906] = {.lex_state = 274, .external_lex_state = 16},
  [8907] = {.lex_state = 274, .external_lex_state = 16},
  [8908] = {.lex_state = 274, .external_lex_state = 16},
  [8909] = {.lex_state = 274, .external_lex_state = 16},
  [8910] = {.lex_state = 274, .external_lex_state = 16},
  [8911] = {.lex_state = 274, .external_lex_state = 19},
  [8912] = {.lex_state = 223, .external_lex_state = 9},
  [8913] = {.lex_state = 274, .external_lex_state = 5},
  [8914] = {.lex_state = 274, .external_lex_state = 5},
  [8915] = {.lex_state = 274, .external_lex_state = 5},
  [8916] = {.lex_state = 274, .external_lex_state = 5},
  [8917] = {.lex_state = 274, .external_lex_state = 5},
  [8918] = {.lex_state = 274, .external_lex_state = 5},
  [8919] = {.lex_state = 359, .external_lex_state = 20},
  [8920] = {.lex_state = 274, .external_lex_state = 5},
  [8921] = {.lex_state = 274, .external_lex_state = 5},
  [8922] = {.lex_state = 274, .external_lex_state = 5},
  [8923] = {.lex_state = 274, .external_lex_state = 5},
  [8924] = {.lex_state = 274, .external_lex_state = 5},
  [8925] = {.lex_state = 274, .external_lex_state = 5},
  [8926] = {.lex_state = 277, .external_lex_state = 5},
  [8927] = {.lex_state = 277, .external_lex_state = 5},
  [8928] = {.lex_state = 277, .external_lex_state = 5},
  [8929] = {.lex_state = 277, .external_lex_state = 5},
  [8930] = {.lex_state = 277, .external_lex_state = 5},
  [8931] = {.lex_state = 277, .external_lex_state = 5},
  [8932] = {.lex_state = 277, .external_lex_state = 5},
  [8933] = {.lex_state = 359, .external_lex_state = 20},
  [8934] = {.lex_state = 277, .external_lex_state = 5},
  [8935] = {.lex_state = 277, .external_lex_state = 5},
  [8936] = {.lex_state = 277, .external_lex_state = 5},
  [8937] = {.lex_state = 277, .external_lex_state = 5},
  [8938] = {.lex_state = 277, .external_lex_state = 5},
  [8939] = {.lex_state = 277, .external_lex_state = 14},
  [8940] = {.lex_state = 157, .external_lex_state = 28},
  [8941] = {.lex_state = 344, .external_lex_state = 5},
  [8942] = {.lex_state = 157, .external_lex_state = 2},
  [8943] = {.lex_state = 274, .external_lex_state = 5},
  [8944] = {.lex_state = 258, .external_lex_state = 6},
  [8945] = {.lex_state = 197, .external_lex_state = 16},
  [8946] = {.lex_state = 197, .external_lex_state = 16},
  [8947] = {.lex_state = 157, .external_lex_state = 6},
  [8948] = {.lex_state = 197, .external_lex_state = 16},
  [8949] = {.lex_state = 197, .external_lex_state = 16},
  [8950] = {.lex_state = 197, .external_lex_state = 16},
  [8951] = {.lex_state = 197, .external_lex_state = 16},
  [8952] = {.lex_state = 197, .external_lex_state = 16},
  [8953] = {.lex_state = 197, .external_lex_state = 16},
  [8954] = {.lex_state = 197, .external_lex_state = 16},
  [8955] = {.lex_state = 197, .external_lex_state = 16},
  [8956] = {.lex_state = 197, .external_lex_state = 16},
  [8957] = {.lex_state = 197, .external_lex_state = 16},
  [8958] = {.lex_state = 359, .external_lex_state = 20},
  [8959] = {.lex_state = 197, .external_lex_state = 16},
  [8960] = {.lex_state = 197, .external_lex_state = 16},
  [8961] = {.lex_state = 197, .external_lex_state = 16},
  [8962] = {.lex_state = 197, .external_lex_state = 16},
  [8963] = {.lex_state = 197, .external_lex_state = 16},
  [8964] = {.lex_state = 197, .external_lex_state = 19},
  [8965] = {.lex_state = 157, .external_lex_state = 28},
  [8966] = {.lex_state = 197, .external_lex_state = 16},
  [8967] = {.lex_state = 157, .external_lex_state = 2},
  [8968] = {.lex_state = 197, .external_lex_state = 5},
  [8969] = {.lex_state = 197, .external_lex_state = 5},
  [8970] = {.lex_state = 157, .external_lex_state = 6},
  [8971] = {.lex_state = 197, .external_lex_state = 5},
  [8972] = {.lex_state = 197, .external_lex_state = 5},
  [8973] = {.lex_state = 197, .external_lex_state = 5},
  [8974] = {.lex_state = 197, .external_lex_state = 5},
  [8975] = {.lex_state = 197, .external_lex_state = 5},
  [8976] = {.lex_state = 197, .external_lex_state = 5},
  [8977] = {.lex_state = 197, .external_lex_state = 5},
  [8978] = {.lex_state = 197, .external_lex_state = 5},
  [8979] = {.lex_state = 359, .external_lex_state = 20},
  [8980] = {.lex_state = 197, .external_lex_state = 5},
  [8981] = {.lex_state = 197, .external_lex_state = 5},
  [8982] = {.lex_state = 197, .external_lex_state = 5},
  [8983] = {.lex_state = 197, .external_lex_state = 5},
  [8984] = {.lex_state = 197, .external_lex_state = 5},
  [8985] = {.lex_state = 197, .external_lex_state = 5},
  [8986] = {.lex_state = 197, .external_lex_state = 5},
  [8987] = {.lex_state = 258, .external_lex_state = 25},
  [8988] = {.lex_state = 266, .external_lex_state = 6},
  [8989] = {.lex_state = 258, .external_lex_state = 25},
  [8990] = {.lex_state = 258, .external_lex_state = 25},
  [8991] = {.lex_state = 300, .external_lex_state = 27},
  [8992] = {.lex_state = 258, .external_lex_state = 13},
  [8993] = {.lex_state = 157},
  [8994] = {.lex_state = 258, .external_lex_state = 25},
  [8995] = {.lex_state = 197, .external_lex_state = 5},
  [8996] = {.lex_state = 197, .external_lex_state = 14},
  [8997] = {.lex_state = 197, .external_lex_state = 5},
  [8998] = {.lex_state = 157, .external_lex_state = 2},
  [8999] = {.lex_state = 197, .external_lex_state = 5},
  [9000] = {.lex_state = 157, .external_lex_state = 2},
  [9001] = {.lex_state = 271, .external_lex_state = 9},
  [9002] = {.lex_state = 228},
  [9003] = {.lex_state = 157, .external_lex_state = 2},
  [9004] = {.lex_state = 157, .external_lex_state = 2},
  [9005] = {.lex_state = 157, .external_lex_state = 2},
  [9006] = {.lex_state = 197, .external_lex_state = 5},
  [9007] = {.lex_state = 197, .external_lex_state = 5},
  [9008] = {.lex_state = 197, .external_lex_state = 14},
  [9009] = {.lex_state = 197, .external_lex_state = 5},
  [9010] = {.lex_state = 220, .external_lex_state = 9},
  [9011] = {.lex_state = 220, .external_lex_state = 9},
  [9012] = {.lex_state = 157, .external_lex_state = 2},
  [9013] = {.lex_state = 157, .external_lex_state = 2},
  [9014] = {.lex_state = 220, .external_lex_state = 9},
  [9015] = {.lex_state = 157, .external_lex_state = 2},
  [9016] = {.lex_state = 220, .external_lex_state = 9},
  [9017] = {.lex_state = 208, .external_lex_state = 5},
  [9018] = {.lex_state = 197, .external_lex_state = 5},
  [9019] = {.lex_state = 157},
  [9020] = {.lex_state = 197, .external_lex_state = 14},
  [9021] = {.lex_state = 258, .external_lex_state = 13},
  [9022] = {.lex_state = 135},
  [9023] = {.lex_state = 197, .external_lex_state = 5},
  [9024] = {.lex_state = 197, .external_lex_state = 5},
  [9025] = {.lex_state = 258, .external_lex_state = 13},
  [9026] = {.lex_state = 157, .external_lex_state = 28},
  [9027] = {.lex_state = 217, .external_lex_state = 22},
  [9028] = {.lex_state = 157, .external_lex_state = 29},
  [9029] = {.lex_state = 258, .external_lex_state = 13},
  [9030] = {.lex_state = 258, .external_lex_state = 13},
  [9031] = {.lex_state = 157, .external_lex_state = 2},
  [9032] = {.lex_state = 157, .external_lex_state = 2},
  [9033] = {.lex_state = 157, .external_lex_state = 2},
  [9034] = {.lex_state = 157, .external_lex_state = 2},
  [9035] = {.lex_state = 157, .external_lex_state = 2},
  [9036] = {.lex_state = 157, .external_lex_state = 2},
  [9037] = {.lex_state = 157, .external_lex_state = 2},
  [9038] = {.lex_state = 157, .external_lex_state = 2},
  [9039] = {.lex_state = 157, .external_lex_state = 2},
  [9040] = {.lex_state = 157, .external_lex_state = 2},
  [9041] = {.lex_state = 157, .external_lex_state = 2},
  [9042] = {.lex_state = 197, .external_lex_state = 14},
  [9043] = {.lex_state = 197, .external_lex_state = 5},
  [9044] = {.lex_state = 157, .external_lex_state = 28},
  [9045] = {.lex_state = 197, .external_lex_state = 5},
  [9046] = {.lex_state = 157, .external_lex_state = 2},
  [9047] = {.lex_state = 271, .external_lex_state = 9},
  [9048] = {.lex_state = 135},
  [9049] = {.lex_state = 271, .external_lex_state = 9},
  [9050] = {.lex_state = 268, .external_lex_state = 5},
  [9051] = {.lex_state = 268, .external_lex_state = 5},
  [9052] = {.lex_state = 268, .external_lex_state = 5},
  [9053] = {.lex_state = 268, .external_lex_state = 5},
  [9054] = {.lex_state = 157, .external_lex_state = 6},
  [9055] = {.lex_state = 268, .external_lex_state = 5},
  [9056] = {.lex_state = 268, .external_lex_state = 5},
  [9057] = {.lex_state = 268, .external_lex_state = 5},
  [9058] = {.lex_state = 268, .external_lex_state = 5},
  [9059] = {.lex_state = 268, .external_lex_state = 5},
  [9060] = {.lex_state = 268, .external_lex_state = 5},
  [9061] = {.lex_state = 359, .external_lex_state = 20},
  [9062] = {.lex_state = 268, .external_lex_state = 5},
  [9063] = {.lex_state = 268, .external_lex_state = 5},
  [9064] = {.lex_state = 268, .external_lex_state = 5},
  [9065] = {.lex_state = 268, .external_lex_state = 5},
  [9066] = {.lex_state = 268, .external_lex_state = 5},
  [9067] = {.lex_state = 268, .external_lex_state = 5},
  [9068] = {.lex_state = 268, .external_lex_state = 5},
  [9069] = {.lex_state = 268, .external_lex_state = 14},
  [9070] = {.lex_state = 135},
  [9071] = {.lex_state = 197, .external_lex_state = 13},
  [9072] = {.lex_state = 197, .external_lex_state = 5},
  [9073] = {.lex_state = 197, .external_lex_state = 5},
  [9074] = {.lex_state = 157, .external_lex_state = 2},
  [9075] = {.lex_state = 157, .external_lex_state = 2},
  [9076] = {.lex_state = 197, .external_lex_state = 5},
  [9077] = {.lex_state = 197, .external_lex_state = 5},
  [9078] = {.lex_state = 197, .external_lex_state = 5},
  [9079] = {.lex_state = 157, .external_lex_state = 29},
  [9080] = {.lex_state = 197, .external_lex_state = 5},
  [9081] = {.lex_state = 197, .external_lex_state = 5},
  [9082] = {.lex_state = 197, .external_lex_state = 5},
  [9083] = {.lex_state = 197, .external_lex_state = 5},
  [9084] = {.lex_state = 197, .external_lex_state = 5},
  [9085] = {.lex_state = 197, .external_lex_state = 5},
  [9086] = {.lex_state = 157, .external_lex_state = 2},
  [9087] = {.lex_state = 157, .external_lex_state = 28},
  [9088] = {.lex_state = 157, .external_lex_state = 2},
  [9089] = {.lex_state = 157, .external_lex_state = 2},
  [9090] = {.lex_state = 157, .external_lex_state = 2},
  [9091] = {.lex_state = 157, .external_lex_state = 2},
  [9092] = {.lex_state = 157, .external_lex_state = 2},
  [9093] = {.lex_state = 157, .external_lex_state = 2},
  [9094] = {.lex_state = 157, .external_lex_state = 2},
  [9095] = {.lex_state = 157, .external_lex_state = 2},
  [9096] = {.lex_state = 157, .external_lex_state = 2},
  [9097] = {.lex_state = 197, .external_lex_state = 14},
  [9098] = {.lex_state = 157, .external_lex_state = 6},
  [9099] = {.lex_state = 197, .external_lex_state = 5},
  [9100] = {.lex_state = 197, .external_lex_state = 5},
  [9101] = {.lex_state = 197, .external_lex_state = 5},
  [9102] = {.lex_state = 197, .external_lex_state = 5},
  [9103] = {.lex_state = 197, .external_lex_state = 5},
  [9104] = {.lex_state = 197, .external_lex_state = 5},
  [9105] = {.lex_state = 197, .external_lex_state = 5},
  [9106] = {.lex_state = 197, .external_lex_state = 5},
  [9107] = {.lex_state = 359, .external_lex_state = 20},
  [9108] = {.lex_state = 197, .external_lex_state = 5},
  [9109] = {.lex_state = 197, .external_lex_state = 5},
  [9110] = {.lex_state = 197, .external_lex_state = 5},
  [9111] = {.lex_state = 197, .external_lex_state = 5},
  [9112] = {.lex_state = 197, .external_lex_state = 5},
  [9113] = {.lex_state = 197, .external_lex_state = 5},
  [9114] = {.lex_state = 197, .external_lex_state = 5},
  [9115] = {.lex_state = 271, .external_lex_state = 9},
  [9116] = {.lex_state = 266, .external_lex_state = 6},
  [9117] = {.lex_state = 271, .external_lex_state = 9},
  [9118] = {.lex_state = 271, .external_lex_state = 9},
  [9119] = {.lex_state = 300, .external_lex_state = 27},
  [9120] = {.lex_state = 271, .external_lex_state = 9},
  [9121] = {.lex_state = 157, .external_lex_state = 2},
  [9122] = {.lex_state = 157, .external_lex_state = 2},
  [9123] = {.lex_state = 268, .external_lex_state = 5},
  [9124] = {.lex_state = 268, .external_lex_state = 5},
  [9125] = {.lex_state = 268, .external_lex_state = 5},
  [9126] = {.lex_state = 157, .external_lex_state = 29},
  [9127] = {.lex_state = 268, .external_lex_state = 5},
  [9128] = {.lex_state = 268, .external_lex_state = 5},
  [9129] = {.lex_state = 197, .external_lex_state = 14},
  [9130] = {.lex_state = 223, .external_lex_state = 9},
  [9131] = {.lex_state = 135},
  [9132] = {.lex_state = 223, .external_lex_state = 9},
  [9133] = {.lex_state = 197, .external_lex_state = 5},
  [9134] = {.lex_state = 197, .external_lex_state = 5},
  [9135] = {.lex_state = 197, .external_lex_state = 5},
  [9136] = {.lex_state = 157, .external_lex_state = 2},
  [9137] = {.lex_state = 157, .external_lex_state = 28},
  [9138] = {.lex_state = 157, .external_lex_state = 2},
  [9139] = {.lex_state = 157, .external_lex_state = 2},
  [9140] = {.lex_state = 157, .external_lex_state = 2},
  [9141] = {.lex_state = 157, .external_lex_state = 2},
  [9142] = {.lex_state = 157, .external_lex_state = 2},
  [9143] = {.lex_state = 157, .external_lex_state = 2},
  [9144] = {.lex_state = 157, .external_lex_state = 2},
  [9145] = {.lex_state = 157, .external_lex_state = 2},
  [9146] = {.lex_state = 157, .external_lex_state = 2},
  [9147] = {.lex_state = 157, .external_lex_state = 28},
  [9148] = {.lex_state = 197, .external_lex_state = 5},
  [9149] = {.lex_state = 208, .external_lex_state = 5},
  [9150] = {.lex_state = 208, .external_lex_state = 5},
  [9151] = {.lex_state = 208, .external_lex_state = 5},
  [9152] = {.lex_state = 208, .external_lex_state = 5},
  [9153] = {.lex_state = 157, .external_lex_state = 2},
  [9154] = {.lex_state = 157, .external_lex_state = 28},
  [9155] = {.lex_state = 157, .external_lex_state = 2},
  [9156] = {.lex_state = 157, .external_lex_state = 2},
  [9157] = {.lex_state = 157, .external_lex_state = 2},
  [9158] = {.lex_state = 157, .external_lex_state = 2},
  [9159] = {.lex_state = 157, .external_lex_state = 2},
  [9160] = {.lex_state = 157, .external_lex_state = 2},
  [9161] = {.lex_state = 157, .external_lex_state = 2},
  [9162] = {.lex_state = 157, .external_lex_state = 2},
  [9163] = {.lex_state = 157, .external_lex_state = 2},
  [9164] = {.lex_state = 208, .external_lex_state = 14},
  [9165] = {.lex_state = 268, .external_lex_state = 5},
  [9166] = {.lex_state = 268, .external_lex_state = 5},
  [9167] = {.lex_state = 157, .external_lex_state = 6},
  [9168] = {.lex_state = 208, .external_lex_state = 5},
  [9169] = {.lex_state = 208, .external_lex_state = 5},
  [9170] = {.lex_state = 208, .external_lex_state = 5},
  [9171] = {.lex_state = 268, .external_lex_state = 5},
  [9172] = {.lex_state = 268, .external_lex_state = 5},
  [9173] = {.lex_state = 268, .external_lex_state = 5},
  [9174] = {.lex_state = 359, .external_lex_state = 20},
  [9175] = {.lex_state = 268, .external_lex_state = 5},
  [9176] = {.lex_state = 268, .external_lex_state = 5},
  [9177] = {.lex_state = 268, .external_lex_state = 5},
  [9178] = {.lex_state = 268, .external_lex_state = 5},
  [9179] = {.lex_state = 268, .external_lex_state = 5},
  [9180] = {.lex_state = 268, .external_lex_state = 5},
  [9181] = {.lex_state = 268, .external_lex_state = 5},
  [9182] = {.lex_state = 268, .external_lex_state = 14},
  [9183] = {.lex_state = 157, .external_lex_state = 2},
  [9184] = {.lex_state = 197, .external_lex_state = 5},
  [9185] = {.lex_state = 197, .external_lex_state = 5},
  [9186] = {.lex_state = 157, .external_lex_state = 6},
  [9187] = {.lex_state = 197, .external_lex_state = 5},
  [9188] = {.lex_state = 197, .external_lex_state = 5},
  [9189] = {.lex_state = 197, .external_lex_state = 5},
  [9190] = {.lex_state = 197, .external_lex_state = 5},
  [9191] = {.lex_state = 197, .external_lex_state = 5},
  [9192] = {.lex_state = 197, .external_lex_state = 5},
  [9193] = {.lex_state = 197, .external_lex_state = 5},
  [9194] = {.lex_state = 197, .external_lex_state = 5},
  [9195] = {.lex_state = 197, .external_lex_state = 5},
  [9196] = {.lex_state = 197, .external_lex_state = 5},
  [9197] = {.lex_state = 197, .external_lex_state = 5},
  [9198] = {.lex_state = 197, .external_lex_state = 5},
  [9199] = {.lex_state = 359, .external_lex_state = 20},
  [9200] = {.lex_state = 197, .external_lex_state = 5},
  [9201] = {.lex_state = 197, .external_lex_state = 5},
  [9202] = {.lex_state = 197, .external_lex_state = 5},
  [9203] = {.lex_state = 197, .external_lex_state = 5},
  [9204] = {.lex_state = 197, .external_lex_state = 5},
  [9205] = {.lex_state = 197, .external_lex_state = 14},
  [9206] = {.lex_state = 157, .external_lex_state = 28},
  [9207] = {.lex_state = 197, .external_lex_state = 5},
  [9208] = {.lex_state = 157, .external_lex_state = 2},
  [9209] = {.lex_state = 271, .external_lex_state = 9},
  [9210] = {.lex_state = 135},
  [9211] = {.lex_state = 271, .external_lex_state = 9},
  [9212] = {.lex_state = 268, .external_lex_state = 5},
  [9213] = {.lex_state = 268, .external_lex_state = 5},
  [9214] = {.lex_state = 157, .external_lex_state = 6},
  [9215] = {.lex_state = 268, .external_lex_state = 5},
  [9216] = {.lex_state = 268, .external_lex_state = 5},
  [9217] = {.lex_state = 268, .external_lex_state = 5},
  [9218] = {.lex_state = 223, .external_lex_state = 9},
  [9219] = {.lex_state = 197, .external_lex_state = 5},
  [9220] = {.lex_state = 197, .external_lex_state = 5},
  [9221] = {.lex_state = 197, .external_lex_state = 5},
  [9222] = {.lex_state = 197, .external_lex_state = 5},
  [9223] = {.lex_state = 197, .external_lex_state = 5},
  [9224] = {.lex_state = 197, .external_lex_state = 5},
  [9225] = {.lex_state = 359, .external_lex_state = 20},
  [9226] = {.lex_state = 197, .external_lex_state = 5},
  [9227] = {.lex_state = 197, .external_lex_state = 5},
  [9228] = {.lex_state = 197, .external_lex_state = 5},
  [9229] = {.lex_state = 197, .external_lex_state = 5},
  [9230] = {.lex_state = 197, .external_lex_state = 5},
  [9231] = {.lex_state = 197, .external_lex_state = 5},
  [9232] = {.lex_state = 208, .external_lex_state = 5},
  [9233] = {.lex_state = 208, .external_lex_state = 5},
  [9234] = {.lex_state = 208, .external_lex_state = 5},
  [9235] = {.lex_state = 208, .external_lex_state = 5},
  [9236] = {.lex_state = 208, .external_lex_state = 5},
  [9237] = {.lex_state = 208, .external_lex_state = 5},
  [9238] = {.lex_state = 208, .external_lex_state = 5},
  [9239] = {.lex_state = 359, .external_lex_state = 20},
  [9240] = {.lex_state = 208, .external_lex_state = 5},
  [9241] = {.lex_state = 208, .external_lex_state = 5},
  [9242] = {.lex_state = 208, .external_lex_state = 5},
  [9243] = {.lex_state = 208, .external_lex_state = 5},
  [9244] = {.lex_state = 208, .external_lex_state = 5},
  [9245] = {.lex_state = 208, .external_lex_state = 14},
  [9246] = {.lex_state = 157, .external_lex_state = 28},
  [9247] = {.lex_state = 268, .external_lex_state = 5},
  [9248] = {.lex_state = 157, .external_lex_state = 2},
  [9249] = {.lex_state = 197, .external_lex_state = 5},
  [9250] = {.lex_state = 197, .external_lex_state = 5},
  [9251] = {.lex_state = 258, .external_lex_state = 6},
  [9252] = {.lex_state = 197, .external_lex_state = 16},
  [9253] = {.lex_state = 197, .external_lex_state = 16},
  [9254] = {.lex_state = 157, .external_lex_state = 6},
  [9255] = {.lex_state = 197, .external_lex_state = 16},
  [9256] = {.lex_state = 197, .external_lex_state = 16},
  [9257] = {.lex_state = 197, .external_lex_state = 16},
  [9258] = {.lex_state = 157, .external_lex_state = 2},
  [9259] = {.lex_state = 157, .external_lex_state = 2},
  [9260] = {.lex_state = 316, .external_lex_state = 16},
  [9261] = {.lex_state = 316, .external_lex_state = 16},
  [9262] = {.lex_state = 316, .external_lex_state = 16},
  [9263] = {.lex_state = 157, .external_lex_state = 29},
  [9264] = {.lex_state = 316, .external_lex_state = 16},
  [9265] = {.lex_state = 316, .external_lex_state = 16},
  [9266] = {.lex_state = 316, .external_lex_state = 16},
  [9267] = {.lex_state = 316, .external_lex_state = 16},
  [9268] = {.lex_state = 316, .external_lex_state = 16},
  [9269] = {.lex_state = 316, .external_lex_state = 16},
  [9270] = {.lex_state = 316, .external_lex_state = 16},
  [9271] = {.lex_state = 316, .external_lex_state = 16},
  [9272] = {.lex_state = 316, .external_lex_state = 16},
  [9273] = {.lex_state = 359, .external_lex_state = 20},
  [9274] = {.lex_state = 316, .external_lex_state = 16},
  [9275] = {.lex_state = 316, .external_lex_state = 16},
  [9276] = {.lex_state = 316, .external_lex_state = 16},
  [9277] = {.lex_state = 316, .external_lex_state = 16},
  [9278] = {.lex_state = 316, .external_lex_state = 16},
  [9279] = {.lex_state = 316, .external_lex_state = 19},
  [9280] = {.lex_state = 157, .external_lex_state = 28},
  [9281] = {.lex_state = 197, .external_lex_state = 16},
  [9282] = {.lex_state = 157, .external_lex_state = 2},
  [9283] = {.lex_state = 197, .external_lex_state = 13},
  [9284] = {.lex_state = 197, .external_lex_state = 5},
  [9285] = {.lex_state = 197, .external_lex_state = 14},
  [9286] = {.lex_state = 157, .external_lex_state = 2},
  [9287] = {.lex_state = 197, .external_lex_state = 5},
  [9288] = {.lex_state = 271, .external_lex_state = 9},
  [9289] = {.lex_state = 157, .external_lex_state = 2},
  [9290] = {.lex_state = 271, .external_lex_state = 9},
  [9291] = {.lex_state = 228},
  [9292] = {.lex_state = 157, .external_lex_state = 2},
  [9293] = {.lex_state = 157, .external_lex_state = 2},
  [9294] = {.lex_state = 157, .external_lex_state = 2},
  [9295] = {.lex_state = 197, .external_lex_state = 5},
  [9296] = {.lex_state = 197, .external_lex_state = 5},
  [9297] = {.lex_state = 197, .external_lex_state = 14},
  [9298] = {.lex_state = 197, .external_lex_state = 5},
  [9299] = {.lex_state = 220, .external_lex_state = 9},
  [9300] = {.lex_state = 220, .external_lex_state = 9},
  [9301] = {.lex_state = 157, .external_lex_state = 2},
  [9302] = {.lex_state = 157, .external_lex_state = 2},
  [9303] = {.lex_state = 220, .external_lex_state = 9},
  [9304] = {.lex_state = 157, .external_lex_state = 2},
  [9305] = {.lex_state = 220, .external_lex_state = 9},
  [9306] = {.lex_state = 208, .external_lex_state = 5},
  [9307] = {.lex_state = 197, .external_lex_state = 5},
  [9308] = {.lex_state = 157},
  [9309] = {.lex_state = 197, .external_lex_state = 14},
  [9310] = {.lex_state = 197, .external_lex_state = 5},
  [9311] = {.lex_state = 197, .external_lex_state = 5},
  [9312] = {.lex_state = 157, .external_lex_state = 29},
  [9313] = {.lex_state = 197, .external_lex_state = 5},
  [9314] = {.lex_state = 197, .external_lex_state = 5},
  [9315] = {.lex_state = 157, .external_lex_state = 2},
  [9316] = {.lex_state = 157, .external_lex_state = 28},
  [9317] = {.lex_state = 157, .external_lex_state = 2},
  [9318] = {.lex_state = 157, .external_lex_state = 2},
  [9319] = {.lex_state = 157, .external_lex_state = 2},
  [9320] = {.lex_state = 157, .external_lex_state = 2},
  [9321] = {.lex_state = 157, .external_lex_state = 2},
  [9322] = {.lex_state = 157, .external_lex_state = 2},
  [9323] = {.lex_state = 157, .external_lex_state = 2},
  [9324] = {.lex_state = 157, .external_lex_state = 2},
  [9325] = {.lex_state = 157, .external_lex_state = 2},
  [9326] = {.lex_state = 300, .external_lex_state = 27},
  [9327] = {.lex_state = 164},
  [9328] = {.lex_state = 271, .external_lex_state = 9},
  [9329] = {.lex_state = 228},
  [9330] = {.lex_state = 157, .external_lex_state = 2},
  [9331] = {.lex_state = 157, .external_lex_state = 2},
  [9332] = {.lex_state = 157, .external_lex_state = 2},
  [9333] = {.lex_state = 268, .external_lex_state = 5},
  [9334] = {.lex_state = 268, .external_lex_state = 5},
  [9335] = {.lex_state = 268, .external_lex_state = 14},
  [9336] = {.lex_state = 268, .external_lex_state = 5},
  [9337] = {.lex_state = 197, .external_lex_state = 14},
  [9338] = {.lex_state = 197, .external_lex_state = 5},
  [9339] = {.lex_state = 197, .external_lex_state = 5},
  [9340] = {.lex_state = 197, .external_lex_state = 5},
  [9341] = {.lex_state = 135, .external_lex_state = 2},
  [9342] = {.lex_state = 217, .external_lex_state = 22},
  [9343] = {.lex_state = 197, .external_lex_state = 5},
  [9344] = {.lex_state = 197, .external_lex_state = 5},
  [9345] = {.lex_state = 223, .external_lex_state = 9},
  [9346] = {.lex_state = 266, .external_lex_state = 6},
  [9347] = {.lex_state = 223, .external_lex_state = 9},
  [9348] = {.lex_state = 223, .external_lex_state = 9},
  [9349] = {.lex_state = 300, .external_lex_state = 27},
  [9350] = {.lex_state = 223, .external_lex_state = 9},
  [9351] = {.lex_state = 157, .external_lex_state = 2},
  [9352] = {.lex_state = 157, .external_lex_state = 2},
  [9353] = {.lex_state = 157, .external_lex_state = 2},
  [9354] = {.lex_state = 157, .external_lex_state = 2},
  [9355] = {.lex_state = 208, .external_lex_state = 5},
  [9356] = {.lex_state = 197, .external_lex_state = 5},
  [9357] = {.lex_state = 157},
  [9358] = {.lex_state = 197, .external_lex_state = 5},
  [9359] = {.lex_state = 268, .external_lex_state = 5},
  [9360] = {.lex_state = 268, .external_lex_state = 14},
  [9361] = {.lex_state = 157, .external_lex_state = 2},
  [9362] = {.lex_state = 268, .external_lex_state = 5},
  [9363] = {.lex_state = 157, .external_lex_state = 2},
  [9364] = {.lex_state = 223, .external_lex_state = 9},
  [9365] = {.lex_state = 223, .external_lex_state = 9},
  [9366] = {.lex_state = 157, .external_lex_state = 2},
  [9367] = {.lex_state = 157, .external_lex_state = 2},
  [9368] = {.lex_state = 223, .external_lex_state = 9},
  [9369] = {.lex_state = 157, .external_lex_state = 2},
  [9370] = {.lex_state = 223, .external_lex_state = 9},
  [9371] = {.lex_state = 208, .external_lex_state = 5},
  [9372] = {.lex_state = 208, .external_lex_state = 5},
  [9373] = {.lex_state = 208, .external_lex_state = 5},
  [9374] = {.lex_state = 223, .external_lex_state = 9},
  [9375] = {.lex_state = 157},
  [9376] = {.lex_state = 208, .external_lex_state = 14},
  [9377] = {.lex_state = 208, .external_lex_state = 5},
  [9378] = {.lex_state = 208, .external_lex_state = 5},
  [9379] = {.lex_state = 157, .external_lex_state = 28},
  [9380] = {.lex_state = 157, .external_lex_state = 29},
  [9381] = {.lex_state = 208, .external_lex_state = 5},
  [9382] = {.lex_state = 208, .external_lex_state = 5},
  [9383] = {.lex_state = 157, .external_lex_state = 2},
  [9384] = {.lex_state = 157, .external_lex_state = 2},
  [9385] = {.lex_state = 157, .external_lex_state = 2},
  [9386] = {.lex_state = 157, .external_lex_state = 2},
  [9387] = {.lex_state = 157, .external_lex_state = 2},
  [9388] = {.lex_state = 157, .external_lex_state = 2},
  [9389] = {.lex_state = 157, .external_lex_state = 2},
  [9390] = {.lex_state = 157, .external_lex_state = 2},
  [9391] = {.lex_state = 157, .external_lex_state = 2},
  [9392] = {.lex_state = 157, .external_lex_state = 2},
  [9393] = {.lex_state = 268, .external_lex_state = 14},
  [9394] = {.lex_state = 197, .external_lex_state = 5},
  [9395] = {.lex_state = 197, .external_lex_state = 5},
  [9396] = {.lex_state = 197, .external_lex_state = 5},
  [9397] = {.lex_state = 197, .external_lex_state = 5},
  [9398] = {.lex_state = 197, .external_lex_state = 5},
  [9399] = {.lex_state = 359, .external_lex_state = 20},
  [9400] = {.lex_state = 197, .external_lex_state = 5},
  [9401] = {.lex_state = 197, .external_lex_state = 5},
  [9402] = {.lex_state = 197, .external_lex_state = 5},
  [9403] = {.lex_state = 197, .external_lex_state = 5},
  [9404] = {.lex_state = 197, .external_lex_state = 5},
  [9405] = {.lex_state = 197, .external_lex_state = 14},
  [9406] = {.lex_state = 135, .external_lex_state = 13},
  [9407] = {.lex_state = 135, .external_lex_state = 2},
  [9408] = {.lex_state = 135},
  [9409] = {.lex_state = 197, .external_lex_state = 5},
  [9410] = {.lex_state = 157, .external_lex_state = 2},
  [9411] = {.lex_state = 268, .external_lex_state = 5},
  [9412] = {.lex_state = 268, .external_lex_state = 5},
  [9413] = {.lex_state = 268, .external_lex_state = 5},
  [9414] = {.lex_state = 217, .external_lex_state = 4},
  [9415] = {.lex_state = 268, .external_lex_state = 5},
  [9416] = {.lex_state = 307, .external_lex_state = 5},
  [9417] = {.lex_state = 307, .external_lex_state = 5},
  [9418] = {.lex_state = 157, .external_lex_state = 6},
  [9419] = {.lex_state = 307, .external_lex_state = 5},
  [9420] = {.lex_state = 307, .external_lex_state = 5},
  [9421] = {.lex_state = 307, .external_lex_state = 5},
  [9422] = {.lex_state = 347, .external_lex_state = 9},
  [9423] = {.lex_state = 135},
  [9424] = {.lex_state = 347, .external_lex_state = 9},
  [9425] = {.lex_state = 307, .external_lex_state = 5},
  [9426] = {.lex_state = 307, .external_lex_state = 5},
  [9427] = {.lex_state = 307, .external_lex_state = 5},
  [9428] = {.lex_state = 157, .external_lex_state = 2},
  [9429] = {.lex_state = 157, .external_lex_state = 28},
  [9430] = {.lex_state = 157, .external_lex_state = 2},
  [9431] = {.lex_state = 157, .external_lex_state = 2},
  [9432] = {.lex_state = 157, .external_lex_state = 2},
  [9433] = {.lex_state = 157, .external_lex_state = 2},
  [9434] = {.lex_state = 157, .external_lex_state = 2},
  [9435] = {.lex_state = 157, .external_lex_state = 2},
  [9436] = {.lex_state = 157, .external_lex_state = 2},
  [9437] = {.lex_state = 157, .external_lex_state = 2},
  [9438] = {.lex_state = 157, .external_lex_state = 2},
  [9439] = {.lex_state = 157, .external_lex_state = 28},
  [9440] = {.lex_state = 307, .external_lex_state = 5},
  [9441] = {.lex_state = 350, .external_lex_state = 5},
  [9442] = {.lex_state = 350, .external_lex_state = 5},
  [9443] = {.lex_state = 157, .external_lex_state = 6},
  [9444] = {.lex_state = 350, .external_lex_state = 5},
  [9445] = {.lex_state = 350, .external_lex_state = 5},
  [9446] = {.lex_state = 350, .external_lex_state = 5},
  [9447] = {.lex_state = 157, .external_lex_state = 2},
  [9448] = {.lex_state = 268, .external_lex_state = 5},
  [9449] = {.lex_state = 268, .external_lex_state = 5},
  [9450] = {.lex_state = 135},
  [9451] = {.lex_state = 208, .external_lex_state = 5},
  [9452] = {.lex_state = 135},
  [9453] = {.lex_state = 164, .external_lex_state = 3},
  [9454] = {.lex_state = 208, .external_lex_state = 5},
  [9455] = {.lex_state = 135},
  [9456] = {.lex_state = 208, .external_lex_state = 5},
  [9457] = {.lex_state = 135},
  [9458] = {.lex_state = 135},
  [9459] = {.lex_state = 135},
  [9460] = {.lex_state = 208, .external_lex_state = 5},
  [9461] = {.lex_state = 217, .external_lex_state = 4},
  [9462] = {.lex_state = 208, .external_lex_state = 5},
  [9463] = {.lex_state = 234, .external_lex_state = 15},
  [9464] = {.lex_state = 208, .external_lex_state = 5},
  [9465] = {.lex_state = 217, .external_lex_state = 4},
  [9466] = {.lex_state = 208, .external_lex_state = 5},
  [9467] = {.lex_state = 135},
  [9468] = {.lex_state = 135, .external_lex_state = 2},
  [9469] = {.lex_state = 208, .external_lex_state = 5},
  [9470] = {.lex_state = 135, .external_lex_state = 2},
  [9471] = {.lex_state = 208, .external_lex_state = 5},
  [9472] = {.lex_state = 208, .external_lex_state = 5},
  [9473] = {.lex_state = 135},
  [9474] = {.lex_state = 135},
  [9475] = {.lex_state = 208, .external_lex_state = 5},
  [9476] = {.lex_state = 217, .external_lex_state = 4},
  [9477] = {.lex_state = 208, .external_lex_state = 5},
  [9478] = {.lex_state = 234, .external_lex_state = 15},
  [9479] = {.lex_state = 208, .external_lex_state = 5},
  [9480] = {.lex_state = 217, .external_lex_state = 4},
  [9481] = {.lex_state = 208, .external_lex_state = 5},
  [9482] = {.lex_state = 208, .external_lex_state = 5},
  [9483] = {.lex_state = 135},
  [9484] = {.lex_state = 135, .external_lex_state = 2},
  [9485] = {.lex_state = 157},
  [9486] = {.lex_state = 208, .external_lex_state = 5},
  [9487] = {.lex_state = 208, .external_lex_state = 5},
  [9488] = {.lex_state = 208, .external_lex_state = 5},
  [9489] = {.lex_state = 135},
  [9490] = {.lex_state = 157, .external_lex_state = 28},
  [9491] = {.lex_state = 208, .external_lex_state = 5},
  [9492] = {.lex_state = 157, .external_lex_state = 2},
  [9493] = {.lex_state = 268, .external_lex_state = 5},
  [9494] = {.lex_state = 135},
  [9495] = {.lex_state = 135},
  [9496] = {.lex_state = 268, .external_lex_state = 5},
  [9497] = {.lex_state = 268, .external_lex_state = 5},
  [9498] = {.lex_state = 268, .external_lex_state = 5},
  [9499] = {.lex_state = 135},
  [9500] = {.lex_state = 268, .external_lex_state = 5},
  [9501] = {.lex_state = 268, .external_lex_state = 5},
  [9502] = {.lex_state = 217, .external_lex_state = 4},
  [9503] = {.lex_state = 268, .external_lex_state = 5},
  [9504] = {.lex_state = 268, .external_lex_state = 5},
  [9505] = {.lex_state = 268, .external_lex_state = 5},
  [9506] = {.lex_state = 268, .external_lex_state = 5},
  [9507] = {.lex_state = 363, .external_lex_state = 19},
  [9508] = {.lex_state = 135, .external_lex_state = 15},
  [9509] = {.lex_state = 363, .external_lex_state = 16},
  [9510] = {.lex_state = 363, .external_lex_state = 16},
  [9511] = {.lex_state = 157, .external_lex_state = 2},
  [9512] = {.lex_state = 157, .external_lex_state = 2},
  [9513] = {.lex_state = 363, .external_lex_state = 16},
  [9514] = {.lex_state = 363, .external_lex_state = 16},
  [9515] = {.lex_state = 363, .external_lex_state = 16},
  [9516] = {.lex_state = 157, .external_lex_state = 29},
  [9517] = {.lex_state = 363, .external_lex_state = 16},
  [9518] = {.lex_state = 363, .external_lex_state = 16},
  [9519] = {.lex_state = 363, .external_lex_state = 16},
  [9520] = {.lex_state = 363, .external_lex_state = 16},
  [9521] = {.lex_state = 363, .external_lex_state = 16},
  [9522] = {.lex_state = 363, .external_lex_state = 16},
  [9523] = {.lex_state = 366, .external_lex_state = 17},
  [9524] = {.lex_state = 157, .external_lex_state = 2},
  [9525] = {.lex_state = 157, .external_lex_state = 28},
  [9526] = {.lex_state = 157, .external_lex_state = 2},
  [9527] = {.lex_state = 157, .external_lex_state = 2},
  [9528] = {.lex_state = 157, .external_lex_state = 2},
  [9529] = {.lex_state = 157, .external_lex_state = 2},
  [9530] = {.lex_state = 157, .external_lex_state = 2},
  [9531] = {.lex_state = 157, .external_lex_state = 2},
  [9532] = {.lex_state = 157, .external_lex_state = 2},
  [9533] = {.lex_state = 157, .external_lex_state = 2},
  [9534] = {.lex_state = 157, .external_lex_state = 2},
  [9535] = {.lex_state = 300, .external_lex_state = 27},
  [9536] = {.lex_state = 164},
  [9537] = {.lex_state = 363, .external_lex_state = 19},
  [9538] = {.lex_state = 157, .external_lex_state = 6},
  [9539] = {.lex_state = 363, .external_lex_state = 16},
  [9540] = {.lex_state = 363, .external_lex_state = 16},
  [9541] = {.lex_state = 363, .external_lex_state = 16},
  [9542] = {.lex_state = 363, .external_lex_state = 16},
  [9543] = {.lex_state = 363, .external_lex_state = 16},
  [9544] = {.lex_state = 363, .external_lex_state = 16},
  [9545] = {.lex_state = 363, .external_lex_state = 16},
  [9546] = {.lex_state = 363, .external_lex_state = 16},
  [9547] = {.lex_state = 359, .external_lex_state = 20},
  [9548] = {.lex_state = 363, .external_lex_state = 16},
  [9549] = {.lex_state = 363, .external_lex_state = 16},
  [9550] = {.lex_state = 363, .external_lex_state = 16},
  [9551] = {.lex_state = 363, .external_lex_state = 16},
  [9552] = {.lex_state = 363, .external_lex_state = 16},
  [9553] = {.lex_state = 363, .external_lex_state = 16},
  [9554] = {.lex_state = 363, .external_lex_state = 16},
  [9555] = {.lex_state = 381, .external_lex_state = 17},
  [9556] = {.lex_state = 266, .external_lex_state = 6},
  [9557] = {.lex_state = 381, .external_lex_state = 17},
  [9558] = {.lex_state = 381, .external_lex_state = 17},
  [9559] = {.lex_state = 300, .external_lex_state = 27},
  [9560] = {.lex_state = 381, .external_lex_state = 17},
  [9561] = {.lex_state = 157, .external_lex_state = 2},
  [9562] = {.lex_state = 157, .external_lex_state = 2},
  [9563] = {.lex_state = 378, .external_lex_state = 16},
  [9564] = {.lex_state = 378, .external_lex_state = 16},
  [9565] = {.lex_state = 378, .external_lex_state = 16},
  [9566] = {.lex_state = 157, .external_lex_state = 29},
  [9567] = {.lex_state = 378, .external_lex_state = 16},
  [9568] = {.lex_state = 378, .external_lex_state = 16},
  [9569] = {.lex_state = 363, .external_lex_state = 19},
  [9570] = {.lex_state = 359, .external_lex_state = 20},
  [9571] = {.lex_state = 359, .external_lex_state = 20},
  [9572] = {.lex_state = 359, .external_lex_state = 20},
  [9573] = {.lex_state = 157, .external_lex_state = 2},
  [9574] = {.lex_state = 157, .external_lex_state = 28},
  [9575] = {.lex_state = 157, .external_lex_state = 2},
  [9576] = {.lex_state = 157, .external_lex_state = 2},
  [9577] = {.lex_state = 157, .external_lex_state = 2},
  [9578] = {.lex_state = 157, .external_lex_state = 2},
  [9579] = {.lex_state = 157, .external_lex_state = 2},
  [9580] = {.lex_state = 157, .external_lex_state = 2},
  [9581] = {.lex_state = 157, .external_lex_state = 2},
  [9582] = {.lex_state = 157, .external_lex_state = 2},
  [9583] = {.lex_state = 157, .external_lex_state = 2},
  [9584] = {.lex_state = 363, .external_lex_state = 23},
  [9585] = {.lex_state = 157, .external_lex_state = 28},
  [9586] = {.lex_state = 359, .external_lex_state = 20},
  [9587] = {.lex_state = 157, .external_lex_state = 2},
  [9588] = {.lex_state = 366, .external_lex_state = 21},
  [9589] = {.lex_state = 135},
  [9590] = {.lex_state = 366, .external_lex_state = 21},
  [9591] = {.lex_state = 378, .external_lex_state = 19},
  [9592] = {.lex_state = 135, .external_lex_state = 15},
  [9593] = {.lex_state = 356, .external_lex_state = 16},
  [9594] = {.lex_state = 356, .external_lex_state = 16},
  [9595] = {.lex_state = 356, .external_lex_state = 16},
  [9596] = {.lex_state = 356, .external_lex_state = 16},
  [9597] = {.lex_state = 157, .external_lex_state = 2},
  [9598] = {.lex_state = 157, .external_lex_state = 28},
  [9599] = {.lex_state = 157, .external_lex_state = 2},
  [9600] = {.lex_state = 157, .external_lex_state = 2},
  [9601] = {.lex_state = 157, .external_lex_state = 2},
  [9602] = {.lex_state = 157, .external_lex_state = 2},
  [9603] = {.lex_state = 157, .external_lex_state = 2},
  [9604] = {.lex_state = 157, .external_lex_state = 2},
  [9605] = {.lex_state = 157, .external_lex_state = 2},
  [9606] = {.lex_state = 157, .external_lex_state = 2},
  [9607] = {.lex_state = 157, .external_lex_state = 2},
  [9608] = {.lex_state = 356, .external_lex_state = 19},
  [9609] = {.lex_state = 378, .external_lex_state = 16},
  [9610] = {.lex_state = 378, .external_lex_state = 16},
  [9611] = {.lex_state = 157, .external_lex_state = 6},
  [9612] = {.lex_state = 356, .external_lex_state = 16},
  [9613] = {.lex_state = 356, .external_lex_state = 16},
  [9614] = {.lex_state = 356, .external_lex_state = 16},
  [9615] = {.lex_state = 378, .external_lex_state = 16},
  [9616] = {.lex_state = 378, .external_lex_state = 16},
  [9617] = {.lex_state = 378, .external_lex_state = 16},
  [9618] = {.lex_state = 359, .external_lex_state = 20},
  [9619] = {.lex_state = 378, .external_lex_state = 16},
  [9620] = {.lex_state = 378, .external_lex_state = 16},
  [9621] = {.lex_state = 378, .external_lex_state = 16},
  [9622] = {.lex_state = 378, .external_lex_state = 16},
  [9623] = {.lex_state = 378, .external_lex_state = 16},
  [9624] = {.lex_state = 378, .external_lex_state = 16},
  [9625] = {.lex_state = 378, .external_lex_state = 16},
  [9626] = {.lex_state = 378, .external_lex_state = 19},
  [9627] = {.lex_state = 197, .external_lex_state = 13},
  [9628] = {.lex_state = 197, .external_lex_state = 5},
  [9629] = {.lex_state = 197, .external_lex_state = 5},
  [9630] = {.lex_state = 157, .external_lex_state = 2},
  [9631] = {.lex_state = 157, .external_lex_state = 2},
  [9632] = {.lex_state = 197, .external_lex_state = 5},
  [9633] = {.lex_state = 197, .external_lex_state = 5},
  [9634] = {.lex_state = 197, .external_lex_state = 5},
  [9635] = {.lex_state = 157, .external_lex_state = 29},
  [9636] = {.lex_state = 197, .external_lex_state = 5},
  [9637] = {.lex_state = 197, .external_lex_state = 5},
  [9638] = {.lex_state = 197, .external_lex_state = 5},
  [9639] = {.lex_state = 197, .external_lex_state = 5},
  [9640] = {.lex_state = 197, .external_lex_state = 5},
  [9641] = {.lex_state = 197, .external_lex_state = 5},
  [9642] = {.lex_state = 157, .external_lex_state = 2},
  [9643] = {.lex_state = 157, .external_lex_state = 28},
  [9644] = {.lex_state = 157, .external_lex_state = 2},
  [9645] = {.lex_state = 157, .external_lex_state = 2},
  [9646] = {.lex_state = 157, .external_lex_state = 2},
  [9647] = {.lex_state = 157, .external_lex_state = 2},
  [9648] = {.lex_state = 157, .external_lex_state = 2},
  [9649] = {.lex_state = 157, .external_lex_state = 2},
  [9650] = {.lex_state = 157, .external_lex_state = 2},
  [9651] = {.lex_state = 157, .external_lex_state = 2},
  [9652] = {.lex_state = 157, .external_lex_state = 2},
  [9653] = {.lex_state = 197, .external_lex_state = 14},
  [9654] = {.lex_state = 157, .external_lex_state = 6},
  [9655] = {.lex_state = 197, .external_lex_state = 5},
  [9656] = {.lex_state = 197, .external_lex_state = 5},
  [9657] = {.lex_state = 197, .external_lex_state = 5},
  [9658] = {.lex_state = 197, .external_lex_state = 5},
  [9659] = {.lex_state = 197, .external_lex_state = 5},
  [9660] = {.lex_state = 197, .external_lex_state = 5},
  [9661] = {.lex_state = 197, .external_lex_state = 5},
  [9662] = {.lex_state = 197, .external_lex_state = 5},
  [9663] = {.lex_state = 359, .external_lex_state = 20},
  [9664] = {.lex_state = 197, .external_lex_state = 5},
  [9665] = {.lex_state = 197, .external_lex_state = 5},
  [9666] = {.lex_state = 197, .external_lex_state = 5},
  [9667] = {.lex_state = 197, .external_lex_state = 5},
  [9668] = {.lex_state = 197, .external_lex_state = 5},
  [9669] = {.lex_state = 197, .external_lex_state = 5},
  [9670] = {.lex_state = 197, .external_lex_state = 5},
  [9671] = {.lex_state = 271, .external_lex_state = 9},
  [9672] = {.lex_state = 266, .external_lex_state = 6},
  [9673] = {.lex_state = 271, .external_lex_state = 9},
  [9674] = {.lex_state = 271, .external_lex_state = 9},
  [9675] = {.lex_state = 300, .external_lex_state = 27},
  [9676] = {.lex_state = 271, .external_lex_state = 9},
  [9677] = {.lex_state = 157, .external_lex_state = 2},
  [9678] = {.lex_state = 157, .external_lex_state = 2},
  [9679] = {.lex_state = 268, .external_lex_state = 5},
  [9680] = {.lex_state = 268, .external_lex_state = 5},
  [9681] = {.lex_state = 268, .external_lex_state = 5},
  [9682] = {.lex_state = 157, .external_lex_state = 29},
  [9683] = {.lex_state = 268, .external_lex_state = 5},
  [9684] = {.lex_state = 268, .external_lex_state = 5},
  [9685] = {.lex_state = 197, .external_lex_state = 14},
  [9686] = {.lex_state = 223, .external_lex_state = 9},
  [9687] = {.lex_state = 135},
  [9688] = {.lex_state = 223, .external_lex_state = 9},
  [9689] = {.lex_state = 197, .external_lex_state = 5},
  [9690] = {.lex_state = 197, .external_lex_state = 5},
  [9691] = {.lex_state = 197, .external_lex_state = 5},
  [9692] = {.lex_state = 157, .external_lex_state = 2},
  [9693] = {.lex_state = 157, .external_lex_state = 28},
  [9694] = {.lex_state = 157, .external_lex_state = 2},
  [9695] = {.lex_state = 157, .external_lex_state = 2},
  [9696] = {.lex_state = 157, .external_lex_state = 2},
  [9697] = {.lex_state = 157, .external_lex_state = 2},
  [9698] = {.lex_state = 157, .external_lex_state = 2},
  [9699] = {.lex_state = 157, .external_lex_state = 2},
  [9700] = {.lex_state = 157, .external_lex_state = 2},
  [9701] = {.lex_state = 157, .external_lex_state = 2},
  [9702] = {.lex_state = 157, .external_lex_state = 2},
  [9703] = {.lex_state = 157, .external_lex_state = 28},
  [9704] = {.lex_state = 197, .external_lex_state = 5},
  [9705] = {.lex_state = 208, .external_lex_state = 5},
  [9706] = {.lex_state = 208, .external_lex_state = 5},
  [9707] = {.lex_state = 208, .external_lex_state = 5},
  [9708] = {.lex_state = 208, .external_lex_state = 5},
  [9709] = {.lex_state = 157, .external_lex_state = 2},
  [9710] = {.lex_state = 157, .external_lex_state = 28},
  [9711] = {.lex_state = 157, .external_lex_state = 2},
  [9712] = {.lex_state = 157, .external_lex_state = 2},
  [9713] = {.lex_state = 157, .external_lex_state = 2},
  [9714] = {.lex_state = 157, .external_lex_state = 2},
  [9715] = {.lex_state = 157, .external_lex_state = 2},
  [9716] = {.lex_state = 157, .external_lex_state = 2},
  [9717] = {.lex_state = 157, .external_lex_state = 2},
  [9718] = {.lex_state = 157, .external_lex_state = 2},
  [9719] = {.lex_state = 157, .external_lex_state = 2},
  [9720] = {.lex_state = 208, .external_lex_state = 14},
  [9721] = {.lex_state = 268, .external_lex_state = 5},
  [9722] = {.lex_state = 268, .external_lex_state = 5},
  [9723] = {.lex_state = 157, .external_lex_state = 6},
  [9724] = {.lex_state = 208, .external_lex_state = 5},
  [9725] = {.lex_state = 208, .external_lex_state = 5},
  [9726] = {.lex_state = 208, .external_lex_state = 5},
  [9727] = {.lex_state = 268, .external_lex_state = 5},
  [9728] = {.lex_state = 268, .external_lex_state = 5},
  [9729] = {.lex_state = 268, .external_lex_state = 5},
  [9730] = {.lex_state = 359, .external_lex_state = 20},
  [9731] = {.lex_state = 268, .external_lex_state = 5},
  [9732] = {.lex_state = 268, .external_lex_state = 5},
  [9733] = {.lex_state = 268, .external_lex_state = 5},
  [9734] = {.lex_state = 268, .external_lex_state = 5},
  [9735] = {.lex_state = 268, .external_lex_state = 5},
  [9736] = {.lex_state = 268, .external_lex_state = 5},
  [9737] = {.lex_state = 268, .external_lex_state = 5},
  [9738] = {.lex_state = 268, .external_lex_state = 14},
  [9739] = {.lex_state = 157, .external_lex_state = 2},
  [9740] = {.lex_state = 197, .external_lex_state = 5},
  [9741] = {.lex_state = 197, .external_lex_state = 5},
  [9742] = {.lex_state = 157, .external_lex_state = 28},
  [9743] = {.lex_state = 197, .external_lex_state = 5},
  [9744] = {.lex_state = 157, .external_lex_state = 2},
  [9745] = {.lex_state = 197, .external_lex_state = 5},
  [9746] = {.lex_state = 197, .external_lex_state = 5},
  [9747] = {.lex_state = 271, .external_lex_state = 9},
  [9748] = {.lex_state = 157, .external_lex_state = 2},
  [9749] = {.lex_state = 157, .external_lex_state = 28},
  [9750] = {.lex_state = 208, .external_lex_state = 5},
  [9751] = {.lex_state = 157, .external_lex_state = 2},
  [9752] = {.lex_state = 268, .external_lex_state = 5},
  [9753] = {.lex_state = 268, .external_lex_state = 5},
  [9754] = {.lex_state = 307, .external_lex_state = 5},
  [9755] = {.lex_state = 307, .external_lex_state = 5},
  [9756] = {.lex_state = 307, .external_lex_state = 5},
  [9757] = {.lex_state = 307, .external_lex_state = 5},
  [9758] = {.lex_state = 307, .external_lex_state = 5},
  [9759] = {.lex_state = 307, .external_lex_state = 5},
  [9760] = {.lex_state = 307, .external_lex_state = 5},
  [9761] = {.lex_state = 307, .external_lex_state = 5},
  [9762] = {.lex_state = 307, .external_lex_state = 5},
  [9763] = {.lex_state = 307, .external_lex_state = 5},
  [9764] = {.lex_state = 307, .external_lex_state = 5},
  [9765] = {.lex_state = 359, .external_lex_state = 20},
  [9766] = {.lex_state = 307, .external_lex_state = 5},
  [9767] = {.lex_state = 307, .external_lex_state = 5},
  [9768] = {.lex_state = 307, .external_lex_state = 5},
  [9769] = {.lex_state = 307, .external_lex_state = 5},
  [9770] = {.lex_state = 307, .external_lex_state = 5},
  [9771] = {.lex_state = 307, .external_lex_state = 14},
  [9772] = {.lex_state = 157, .external_lex_state = 28},
  [9773] = {.lex_state = 307, .external_lex_state = 5},
  [9774] = {.lex_state = 157, .external_lex_state = 2},
  [9775] = {.lex_state = 310, .external_lex_state = 9},
  [9776] = {.lex_state = 307, .external_lex_state = 5},
  [9777] = {.lex_state = 307, .external_lex_state = 5},
  [9778] = {.lex_state = 307, .external_lex_state = 5},
  [9779] = {.lex_state = 307, .external_lex_state = 5},
  [9780] = {.lex_state = 307, .external_lex_state = 5},
  [9781] = {.lex_state = 307, .external_lex_state = 5},
  [9782] = {.lex_state = 359, .external_lex_state = 20},
  [9783] = {.lex_state = 307, .external_lex_state = 5},
  [9784] = {.lex_state = 307, .external_lex_state = 5},
  [9785] = {.lex_state = 307, .external_lex_state = 5},
  [9786] = {.lex_state = 307, .external_lex_state = 5},
  [9787] = {.lex_state = 307, .external_lex_state = 5},
  [9788] = {.lex_state = 307, .external_lex_state = 5},
  [9789] = {.lex_state = 313, .external_lex_state = 5},
  [9790] = {.lex_state = 313, .external_lex_state = 5},
  [9791] = {.lex_state = 313, .external_lex_state = 5},
  [9792] = {.lex_state = 313, .external_lex_state = 5},
  [9793] = {.lex_state = 313, .external_lex_state = 5},
  [9794] = {.lex_state = 313, .external_lex_state = 5},
  [9795] = {.lex_state = 313, .external_lex_state = 5},
  [9796] = {.lex_state = 359, .external_lex_state = 20},
  [9797] = {.lex_state = 313, .external_lex_state = 5},
  [9798] = {.lex_state = 313, .external_lex_state = 5},
  [9799] = {.lex_state = 313, .external_lex_state = 5},
  [9800] = {.lex_state = 313, .external_lex_state = 5},
  [9801] = {.lex_state = 313, .external_lex_state = 5},
  [9802] = {.lex_state = 313, .external_lex_state = 14},
  [9803] = {.lex_state = 157, .external_lex_state = 28},
  [9804] = {.lex_state = 350, .external_lex_state = 5},
  [9805] = {.lex_state = 157, .external_lex_state = 2},
  [9806] = {.lex_state = 307, .external_lex_state = 5},
  [9807] = {.lex_state = 197, .external_lex_state = 5},
  [9808] = {.lex_state = 197, .external_lex_state = 5},
  [9809] = {.lex_state = 157, .external_lex_state = 28},
  [9810] = {.lex_state = 197, .external_lex_state = 5},
  [9811] = {.lex_state = 157, .external_lex_state = 2},
  [9812] = {.lex_state = 197, .external_lex_state = 5},
  [9813] = {.lex_state = 197, .external_lex_state = 5},
  [9814] = {.lex_state = 271, .external_lex_state = 9},
  [9815] = {.lex_state = 197, .external_lex_state = 13},
  [9816] = {.lex_state = 197, .external_lex_state = 5},
  [9817] = {.lex_state = 197, .external_lex_state = 5},
  [9818] = {.lex_state = 157, .external_lex_state = 2},
  [9819] = {.lex_state = 157, .external_lex_state = 2},
  [9820] = {.lex_state = 197, .external_lex_state = 5},
  [9821] = {.lex_state = 197, .external_lex_state = 5},
  [9822] = {.lex_state = 197, .external_lex_state = 5},
  [9823] = {.lex_state = 157, .external_lex_state = 29},
  [9824] = {.lex_state = 197, .external_lex_state = 5},
  [9825] = {.lex_state = 197, .external_lex_state = 5},
  [9826] = {.lex_state = 197, .external_lex_state = 5},
  [9827] = {.lex_state = 197, .external_lex_state = 5},
  [9828] = {.lex_state = 197, .external_lex_state = 5},
  [9829] = {.lex_state = 197, .external_lex_state = 5},
  [9830] = {.lex_state = 157, .external_lex_state = 2},
  [9831] = {.lex_state = 157, .external_lex_state = 28},
  [9832] = {.lex_state = 157, .external_lex_state = 2},
  [9833] = {.lex_state = 157, .external_lex_state = 2},
  [9834] = {.lex_state = 157, .external_lex_state = 2},
  [9835] = {.lex_state = 157, .external_lex_state = 2},
  [9836] = {.lex_state = 157, .external_lex_state = 2},
  [9837] = {.lex_state = 157, .external_lex_state = 2},
  [9838] = {.lex_state = 157, .external_lex_state = 2},
  [9839] = {.lex_state = 157, .external_lex_state = 2},
  [9840] = {.lex_state = 157, .external_lex_state = 2},
  [9841] = {.lex_state = 197, .external_lex_state = 14},
  [9842] = {.lex_state = 157, .external_lex_state = 6},
  [9843] = {.lex_state = 197, .external_lex_state = 5},
  [9844] = {.lex_state = 197, .external_lex_state = 5},
  [9845] = {.lex_state = 197, .external_lex_state = 5},
  [9846] = {.lex_state = 197, .external_lex_state = 5},
  [9847] = {.lex_state = 197, .external_lex_state = 5},
  [9848] = {.lex_state = 197, .external_lex_state = 5},
  [9849] = {.lex_state = 197, .external_lex_state = 5},
  [9850] = {.lex_state = 197, .external_lex_state = 5},
  [9851] = {.lex_state = 359, .external_lex_state = 20},
  [9852] = {.lex_state = 197, .external_lex_state = 5},
  [9853] = {.lex_state = 197, .external_lex_state = 5},
  [9854] = {.lex_state = 197, .external_lex_state = 5},
  [9855] = {.lex_state = 197, .external_lex_state = 5},
  [9856] = {.lex_state = 197, .external_lex_state = 5},
  [9857] = {.lex_state = 197, .external_lex_state = 5},
  [9858] = {.lex_state = 197, .external_lex_state = 5},
  [9859] = {.lex_state = 271, .external_lex_state = 9},
  [9860] = {.lex_state = 266, .external_lex_state = 6},
  [9861] = {.lex_state = 271, .external_lex_state = 9},
  [9862] = {.lex_state = 271, .external_lex_state = 9},
  [9863] = {.lex_state = 300, .external_lex_state = 27},
  [9864] = {.lex_state = 271, .external_lex_state = 9},
  [9865] = {.lex_state = 157, .external_lex_state = 2},
  [9866] = {.lex_state = 157, .external_lex_state = 2},
  [9867] = {.lex_state = 268, .external_lex_state = 5},
  [9868] = {.lex_state = 268, .external_lex_state = 5},
  [9869] = {.lex_state = 268, .external_lex_state = 5},
  [9870] = {.lex_state = 157, .external_lex_state = 29},
  [9871] = {.lex_state = 268, .external_lex_state = 5},
  [9872] = {.lex_state = 268, .external_lex_state = 5},
  [9873] = {.lex_state = 197, .external_lex_state = 14},
  [9874] = {.lex_state = 135, .external_lex_state = 2},
  [9875] = {.lex_state = 223, .external_lex_state = 9},
  [9876] = {.lex_state = 135},
  [9877] = {.lex_state = 223, .external_lex_state = 9},
  [9878] = {.lex_state = 197, .external_lex_state = 5},
  [9879] = {.lex_state = 197, .external_lex_state = 5},
  [9880] = {.lex_state = 197, .external_lex_state = 5},
  [9881] = {.lex_state = 157, .external_lex_state = 2},
  [9882] = {.lex_state = 157, .external_lex_state = 28},
  [9883] = {.lex_state = 157, .external_lex_state = 2},
  [9884] = {.lex_state = 157, .external_lex_state = 2},
  [9885] = {.lex_state = 157, .external_lex_state = 2},
  [9886] = {.lex_state = 157, .external_lex_state = 2},
  [9887] = {.lex_state = 157, .external_lex_state = 2},
  [9888] = {.lex_state = 157, .external_lex_state = 2},
  [9889] = {.lex_state = 157, .external_lex_state = 2},
  [9890] = {.lex_state = 157, .external_lex_state = 2},
  [9891] = {.lex_state = 157, .external_lex_state = 2},
  [9892] = {.lex_state = 157, .external_lex_state = 28},
  [9893] = {.lex_state = 197, .external_lex_state = 5},
  [9894] = {.lex_state = 208, .external_lex_state = 5},
  [9895] = {.lex_state = 208, .external_lex_state = 5},
  [9896] = {.lex_state = 208, .external_lex_state = 5},
  [9897] = {.lex_state = 208, .external_lex_state = 5},
  [9898] = {.lex_state = 157, .external_lex_state = 2},
  [9899] = {.lex_state = 157, .external_lex_state = 28},
  [9900] = {.lex_state = 157, .external_lex_state = 2},
  [9901] = {.lex_state = 157, .external_lex_state = 2},
  [9902] = {.lex_state = 157, .external_lex_state = 2},
  [9903] = {.lex_state = 157, .external_lex_state = 2},
  [9904] = {.lex_state = 157, .external_lex_state = 2},
  [9905] = {.lex_state = 157, .external_lex_state = 2},
  [9906] = {.lex_state = 157, .external_lex_state = 2},
  [9907] = {.lex_state = 157, .external_lex_state = 2},
  [9908] = {.lex_state = 157, .external_lex_state = 2},
  [9909] = {.lex_state = 208, .external_lex_state = 14},
  [9910] = {.lex_state = 268, .external_lex_state = 5},
  [9911] = {.lex_state = 268, .external_lex_state = 5},
  [9912] = {.lex_state = 157, .external_lex_state = 6},
  [9913] = {.lex_state = 208, .external_lex_state = 5},
  [9914] = {.lex_state = 208, .external_lex_state = 5},
  [9915] = {.lex_state = 208, .external_lex_state = 5},
  [9916] = {.lex_state = 268, .external_lex_state = 5},
  [9917] = {.lex_state = 268, .external_lex_state = 5},
  [9918] = {.lex_state = 268, .external_lex_state = 5},
  [9919] = {.lex_state = 359, .external_lex_state = 20},
  [9920] = {.lex_state = 268, .external_lex_state = 5},
  [9921] = {.lex_state = 268, .external_lex_state = 5},
  [9922] = {.lex_state = 268, .external_lex_state = 5},
  [9923] = {.lex_state = 268, .external_lex_state = 5},
  [9924] = {.lex_state = 268, .external_lex_state = 5},
  [9925] = {.lex_state = 268, .external_lex_state = 5},
  [9926] = {.lex_state = 268, .external_lex_state = 5},
  [9927] = {.lex_state = 268, .external_lex_state = 14},
  [9928] = {.lex_state = 157, .external_lex_state = 2},
  [9929] = {.lex_state = 157, .external_lex_state = 2},
  [9930] = {.lex_state = 157, .external_lex_state = 28},
  [9931] = {.lex_state = 208, .external_lex_state = 5},
  [9932] = {.lex_state = 157, .external_lex_state = 2},
  [9933] = {.lex_state = 268, .external_lex_state = 5},
  [9934] = {.lex_state = 268, .external_lex_state = 5},
  [9935] = {.lex_state = 316, .external_lex_state = 20},
  [9936] = {.lex_state = 316, .external_lex_state = 20},
  [9937] = {.lex_state = 316, .external_lex_state = 20},
  [9938] = {.lex_state = 217, .external_lex_state = 4},
  [9939] = {.lex_state = 316, .external_lex_state = 20},
  [9940] = {.lex_state = 316, .external_lex_state = 20},
  [9941] = {.lex_state = 316, .external_lex_state = 20},
  [9942] = {.lex_state = 135},
  [9943] = {.lex_state = 316, .external_lex_state = 20},
  [9944] = {.lex_state = 135},
  [9945] = {.lex_state = 135, .external_lex_state = 2},
  [9946] = {.lex_state = 316, .external_lex_state = 20},
  [9947] = {.lex_state = 164, .external_lex_state = 3},
  [9948] = {.lex_state = 307, .external_lex_state = 16},
  [9949] = {.lex_state = 307, .external_lex_state = 16},
  [9950] = {.lex_state = 157, .external_lex_state = 6},
  [9951] = {.lex_state = 307, .external_lex_state = 16},
  [9952] = {.lex_state = 307, .external_lex_state = 16},
  [9953] = {.lex_state = 307, .external_lex_state = 16},
  [9954] = {.lex_state = 307, .external_lex_state = 16},
  [9955] = {.lex_state = 307, .external_lex_state = 16},
  [9956] = {.lex_state = 307, .external_lex_state = 16},
  [9957] = {.lex_state = 307, .external_lex_state = 16},
  [9958] = {.lex_state = 307, .external_lex_state = 16},
  [9959] = {.lex_state = 307, .external_lex_state = 16},
  [9960] = {.lex_state = 307, .external_lex_state = 16},
  [9961] = {.lex_state = 307, .external_lex_state = 16},
  [9962] = {.lex_state = 307, .external_lex_state = 16},
  [9963] = {.lex_state = 359, .external_lex_state = 20},
  [9964] = {.lex_state = 307, .external_lex_state = 16},
  [9965] = {.lex_state = 307, .external_lex_state = 16},
  [9966] = {.lex_state = 307, .external_lex_state = 16},
  [9967] = {.lex_state = 307, .external_lex_state = 16},
  [9968] = {.lex_state = 307, .external_lex_state = 16},
  [9969] = {.lex_state = 310, .external_lex_state = 17},
  [9970] = {.lex_state = 266, .external_lex_state = 6},
  [9971] = {.lex_state = 310, .external_lex_state = 17},
  [9972] = {.lex_state = 310, .external_lex_state = 17},
  [9973] = {.lex_state = 300, .external_lex_state = 27},
  [9974] = {.lex_state = 310, .external_lex_state = 17},
  [9975] = {.lex_state = 307, .external_lex_state = 19},
  [9976] = {.lex_state = 326, .external_lex_state = 16},
  [9977] = {.lex_state = 326, .external_lex_state = 16},
  [9978] = {.lex_state = 157, .external_lex_state = 28},
  [9979] = {.lex_state = 307, .external_lex_state = 16},
  [9980] = {.lex_state = 157, .external_lex_state = 2},
  [9981] = {.lex_state = 347, .external_lex_state = 17},
  [9982] = {.lex_state = 135},
  [9983] = {.lex_state = 347, .external_lex_state = 17},
  [9984] = {.lex_state = 350, .external_lex_state = 16},
  [9985] = {.lex_state = 350, .external_lex_state = 16},
  [9986] = {.lex_state = 157, .external_lex_state = 6},
  [9987] = {.lex_state = 350, .external_lex_state = 16},
  [9988] = {.lex_state = 350, .external_lex_state = 16},
  [9989] = {.lex_state = 350, .external_lex_state = 16},
  [9990] = {.lex_state = 316, .external_lex_state = 20},
  [9991] = {.lex_state = 135},
  [9992] = {.lex_state = 135},
  [9993] = {.lex_state = 316, .external_lex_state = 20},
  [9994] = {.lex_state = 316, .external_lex_state = 20},
  [9995] = {.lex_state = 316, .external_lex_state = 20},
  [9996] = {.lex_state = 135},
  [9997] = {.lex_state = 316, .external_lex_state = 20},
  [9998] = {.lex_state = 316, .external_lex_state = 20},
  [9999] = {.lex_state = 217, .external_lex_state = 4},
  [10000] = {.lex_state = 316, .external_lex_state = 20},
  [10001] = {.lex_state = 310, .external_lex_state = 21},
  [10002] = {.lex_state = 307, .external_lex_state = 20},
  [10003] = {.lex_state = 307, .external_lex_state = 20},
  [10004] = {.lex_state = 307, .external_lex_state = 20},
  [10005] = {.lex_state = 307, .external_lex_state = 20},
  [10006] = {.lex_state = 307, .external_lex_state = 20},
  [10007] = {.lex_state = 307, .external_lex_state = 20},
  [10008] = {.lex_state = 359, .external_lex_state = 20},
  [10009] = {.lex_state = 307, .external_lex_state = 20},
  [10010] = {.lex_state = 307, .external_lex_state = 20},
  [10011] = {.lex_state = 307, .external_lex_state = 20},
  [10012] = {.lex_state = 307, .external_lex_state = 20},
  [10013] = {.lex_state = 307, .external_lex_state = 20},
  [10014] = {.lex_state = 307, .external_lex_state = 23},
  [10015] = {.lex_state = 369, .external_lex_state = 20},
  [10016] = {.lex_state = 307, .external_lex_state = 20},
  [10017] = {.lex_state = 319, .external_lex_state = 20},
  [10018] = {.lex_state = 319, .external_lex_state = 20},
  [10019] = {.lex_state = 135},
  [10020] = {.lex_state = 135, .external_lex_state = 2},
  [10021] = {.lex_state = 135, .external_lex_state = 2},
  [10022] = {.lex_state = 135},
  [10023] = {.lex_state = 323, .external_lex_state = 16},
  [10024] = {.lex_state = 135},
  [10025] = {.lex_state = 135},
  [10026] = {.lex_state = 135},
  [10027] = {.lex_state = 323, .external_lex_state = 16},
  [10028] = {.lex_state = 135, .external_lex_state = 15},
  [10029] = {.lex_state = 234, .external_lex_state = 15},
  [10030] = {.lex_state = 217, .external_lex_state = 4},
  [10031] = {.lex_state = 323, .external_lex_state = 16},
  [10032] = {.lex_state = 234, .external_lex_state = 15},
  [10033] = {.lex_state = 323, .external_lex_state = 16},
  [10034] = {.lex_state = 323, .external_lex_state = 16},
  [10035] = {.lex_state = 135, .external_lex_state = 2},
  [10036] = {.lex_state = 135},
  [10037] = {.lex_state = 197, .external_lex_state = 5},
  [10038] = {.lex_state = 135, .external_lex_state = 2},
  [10039] = {.lex_state = 135, .external_lex_state = 13},
  [10040] = {.lex_state = 323, .external_lex_state = 16},
  [10041] = {.lex_state = 135, .external_lex_state = 2},
  [10042] = {.lex_state = 323, .external_lex_state = 16},
  [10043] = {.lex_state = 135},
  [10044] = {.lex_state = 135},
  [10045] = {.lex_state = 323, .external_lex_state = 16},
  [10046] = {.lex_state = 135},
  [10047] = {.lex_state = 323, .external_lex_state = 16},
  [10048] = {.lex_state = 323, .external_lex_state = 16},
  [10049] = {.lex_state = 135, .external_lex_state = 15},
  [10050] = {.lex_state = 234, .external_lex_state = 15},
  [10051] = {.lex_state = 217, .external_lex_state = 4},
  [10052] = {.lex_state = 323, .external_lex_state = 16},
  [10053] = {.lex_state = 234, .external_lex_state = 15},
  [10054] = {.lex_state = 323, .external_lex_state = 16},
  [10055] = {.lex_state = 323, .external_lex_state = 16},
  [10056] = {.lex_state = 215},
  [10057] = {.lex_state = 135, .external_lex_state = 2},
  [10058] = {.lex_state = 135, .external_lex_state = 13},
  [10059] = {.lex_state = 323, .external_lex_state = 19},
  [10060] = {.lex_state = 323, .external_lex_state = 16},
  [10061] = {.lex_state = 323, .external_lex_state = 16},
  [10062] = {.lex_state = 274, .external_lex_state = 20},
  [10063] = {.lex_state = 135, .external_lex_state = 2},
  [10064] = {.lex_state = 164, .external_lex_state = 3},
  [10065] = {.lex_state = 135, .external_lex_state = 2},
  [10066] = {.lex_state = 135},
  [10067] = {.lex_state = 313, .external_lex_state = 16},
  [10068] = {.lex_state = 323, .external_lex_state = 16},
  [10069] = {.lex_state = 313, .external_lex_state = 16},
  [10070] = {.lex_state = 313, .external_lex_state = 16},
  [10071] = {.lex_state = 313, .external_lex_state = 16},
  [10072] = {.lex_state = 313, .external_lex_state = 16},
  [10073] = {.lex_state = 313, .external_lex_state = 16},
  [10074] = {.lex_state = 313, .external_lex_state = 16},
  [10075] = {.lex_state = 359, .external_lex_state = 20},
  [10076] = {.lex_state = 313, .external_lex_state = 16},
  [10077] = {.lex_state = 313, .external_lex_state = 16},
  [10078] = {.lex_state = 313, .external_lex_state = 16},
  [10079] = {.lex_state = 313, .external_lex_state = 16},
  [10080] = {.lex_state = 313, .external_lex_state = 16},
  [10081] = {.lex_state = 313, .external_lex_state = 19},
  [10082] = {.lex_state = 157, .external_lex_state = 28},
  [10083] = {.lex_state = 350, .external_lex_state = 16},
  [10084] = {.lex_state = 323, .external_lex_state = 16},
  [10085] = {.lex_state = 323, .external_lex_state = 16},
  [10086] = {.lex_state = 157, .external_lex_state = 2},
  [10087] = {.lex_state = 307, .external_lex_state = 20},
  [10088] = {.lex_state = 237, .external_lex_state = 16},
  [10089] = {.lex_state = 237, .external_lex_state = 16},
  [10090] = {.lex_state = 237, .external_lex_state = 16},
  [10091] = {.lex_state = 135},
  [10092] = {.lex_state = 237, .external_lex_state = 16},
  [10093] = {.lex_state = 255, .external_lex_state = 16},
  [10094] = {.lex_state = 255, .external_lex_state = 16},
  [10095] = {.lex_state = 255, .external_lex_state = 16},
  [10096] = {.lex_state = 255, .external_lex_state = 16},
  [10097] = {.lex_state = 255, .external_lex_state = 16},
  [10098] = {.lex_state = 255, .external_lex_state = 16},
  [10099] = {.lex_state = 255, .external_lex_state = 16},
  [10100] = {.lex_state = 255, .external_lex_state = 16},
  [10101] = {.lex_state = 255, .external_lex_state = 16},
  [10102] = {.lex_state = 359, .external_lex_state = 20},
  [10103] = {.lex_state = 255, .external_lex_state = 16},
  [10104] = {.lex_state = 255, .external_lex_state = 16},
  [10105] = {.lex_state = 255, .external_lex_state = 16},
  [10106] = {.lex_state = 255, .external_lex_state = 16},
  [10107] = {.lex_state = 255, .external_lex_state = 16},
  [10108] = {.lex_state = 326, .external_lex_state = 16},
  [10109] = {.lex_state = 326, .external_lex_state = 16},
  [10110] = {.lex_state = 135},
  [10111] = {.lex_state = 135},
  [10112] = {.lex_state = 326, .external_lex_state = 16},
  [10113] = {.lex_state = 217, .external_lex_state = 4},
  [10114] = {.lex_state = 326, .external_lex_state = 16},
  [10115] = {.lex_state = 326, .external_lex_state = 16},
  [10116] = {.lex_state = 326, .external_lex_state = 16},
  [10117] = {.lex_state = 326, .external_lex_state = 16},
  [10118] = {.lex_state = 326, .external_lex_state = 16},
  [10119] = {.lex_state = 135},
  [10120] = {.lex_state = 326, .external_lex_state = 16},
  [10121] = {.lex_state = 217, .external_lex_state = 4},
  [10122] = {.lex_state = 326, .external_lex_state = 16},
  [10123] = {.lex_state = 326, .external_lex_state = 16},
  [10124] = {.lex_state = 326, .external_lex_state = 16},
  [10125] = {.lex_state = 135},
  [10126] = {.lex_state = 326, .external_lex_state = 16},
  [10127] = {.lex_state = 135},
  [10128] = {.lex_state = 135, .external_lex_state = 2},
  [10129] = {.lex_state = 326, .external_lex_state = 16},
  [10130] = {.lex_state = 164, .external_lex_state = 3},
  [10131] = {.lex_state = 326, .external_lex_state = 16},
  [10132] = {.lex_state = 326, .external_lex_state = 16},
  [10133] = {.lex_state = 255, .external_lex_state = 16},
  [10134] = {.lex_state = 255, .external_lex_state = 16},
  [10135] = {.lex_state = 332, .external_lex_state = 17},
  [10136] = {.lex_state = 323, .external_lex_state = 16},
  [10137] = {.lex_state = 323, .external_lex_state = 16},
  [10138] = {.lex_state = 135},
  [10139] = {.lex_state = 135, .external_lex_state = 2},
  [10140] = {.lex_state = 329, .external_lex_state = 16},
  [10141] = {.lex_state = 329, .external_lex_state = 16},
  [10142] = {.lex_state = 329, .external_lex_state = 16},
  [10143] = {.lex_state = 329, .external_lex_state = 16},
  [10144] = {.lex_state = 329, .external_lex_state = 16},
  [10145] = {.lex_state = 329, .external_lex_state = 16},
  [10146] = {.lex_state = 329, .external_lex_state = 16},
  [10147] = {.lex_state = 359, .external_lex_state = 20},
  [10148] = {.lex_state = 329, .external_lex_state = 16},
  [10149] = {.lex_state = 329, .external_lex_state = 16},
  [10150] = {.lex_state = 329, .external_lex_state = 16},
  [10151] = {.lex_state = 329, .external_lex_state = 16},
  [10152] = {.lex_state = 329, .external_lex_state = 16},
  [10153] = {.lex_state = 329, .external_lex_state = 19},
  [10154] = {.lex_state = 237, .external_lex_state = 16},
  [10155] = {.lex_state = 135},
  [10156] = {.lex_state = 237, .external_lex_state = 16},
  [10157] = {.lex_state = 237, .external_lex_state = 16},
  [10158] = {.lex_state = 242, .external_lex_state = 16},
  [10159] = {.lex_state = 242, .external_lex_state = 16},
  [10160] = {.lex_state = 242, .external_lex_state = 16},
  [10161] = {.lex_state = 217, .external_lex_state = 4},
  [10162] = {.lex_state = 242, .external_lex_state = 16},
  [10163] = {.lex_state = 242, .external_lex_state = 16},
  [10164] = {.lex_state = 242, .external_lex_state = 16},
  [10165] = {.lex_state = 135},
  [10166] = {.lex_state = 242, .external_lex_state = 16},
  [10167] = {.lex_state = 135},
  [10168] = {.lex_state = 164, .external_lex_state = 3},
  [10169] = {.lex_state = 242, .external_lex_state = 16},
  [10170] = {.lex_state = 135},
  [10171] = {.lex_state = 135},
  [10172] = {.lex_state = 242, .external_lex_state = 16},
  [10173] = {.lex_state = 242, .external_lex_state = 16},
  [10174] = {.lex_state = 242, .external_lex_state = 16},
  [10175] = {.lex_state = 135},
  [10176] = {.lex_state = 242, .external_lex_state = 16},
  [10177] = {.lex_state = 242, .external_lex_state = 16},
  [10178] = {.lex_state = 217, .external_lex_state = 4},
  [10179] = {.lex_state = 242, .external_lex_state = 16},
  [10180] = {.lex_state = 242, .external_lex_state = 16},
  [10181] = {.lex_state = 252, .external_lex_state = 16},
  [10182] = {.lex_state = 252, .external_lex_state = 16},
  [10183] = {.lex_state = 197, .external_lex_state = 20},
  [10184] = {.lex_state = 197, .external_lex_state = 20},
  [10185] = {.lex_state = 197, .external_lex_state = 20},
  [10186] = {.lex_state = 135},
  [10187] = {.lex_state = 197, .external_lex_state = 20},
  [10188] = {.lex_state = 197, .external_lex_state = 16},
  [10189] = {.lex_state = 197, .external_lex_state = 16},
  [10190] = {.lex_state = 245, .external_lex_state = 17},
  [10191] = {.lex_state = 197, .external_lex_state = 20},
  [10192] = {.lex_state = 135},
  [10193] = {.lex_state = 197, .external_lex_state = 20},
  [10194] = {.lex_state = 307, .external_lex_state = 16},
  [10195] = {.lex_state = 307, .external_lex_state = 16},
  [10196] = {.lex_state = 157, .external_lex_state = 6},
  [10197] = {.lex_state = 307, .external_lex_state = 16},
  [10198] = {.lex_state = 307, .external_lex_state = 16},
  [10199] = {.lex_state = 307, .external_lex_state = 16},
  [10200] = {.lex_state = 307, .external_lex_state = 16},
  [10201] = {.lex_state = 307, .external_lex_state = 16},
  [10202] = {.lex_state = 307, .external_lex_state = 16},
  [10203] = {.lex_state = 307, .external_lex_state = 16},
  [10204] = {.lex_state = 307, .external_lex_state = 16},
  [10205] = {.lex_state = 307, .external_lex_state = 16},
  [10206] = {.lex_state = 307, .external_lex_state = 16},
  [10207] = {.lex_state = 359, .external_lex_state = 20},
  [10208] = {.lex_state = 307, .external_lex_state = 16},
  [10209] = {.lex_state = 307, .external_lex_state = 16},
  [10210] = {.lex_state = 307, .external_lex_state = 16},
  [10211] = {.lex_state = 307, .external_lex_state = 16},
  [10212] = {.lex_state = 307, .external_lex_state = 16},
  [10213] = {.lex_state = 157, .external_lex_state = 28},
  [10214] = {.lex_state = 307, .external_lex_state = 16},
  [10215] = {.lex_state = 157, .external_lex_state = 2},
  [10216] = {.lex_state = 347, .external_lex_state = 17},
  [10217] = {.lex_state = 135},
  [10218] = {.lex_state = 347, .external_lex_state = 17},
  [10219] = {.lex_state = 350, .external_lex_state = 16},
  [10220] = {.lex_state = 350, .external_lex_state = 16},
  [10221] = {.lex_state = 157, .external_lex_state = 6},
  [10222] = {.lex_state = 350, .external_lex_state = 16},
  [10223] = {.lex_state = 350, .external_lex_state = 16},
  [10224] = {.lex_state = 350, .external_lex_state = 16},
  [10225] = {.lex_state = 307, .external_lex_state = 16},
  [10226] = {.lex_state = 307, .external_lex_state = 16},
  [10227] = {.lex_state = 310, .external_lex_state = 17},
  [10228] = {.lex_state = 313, .external_lex_state = 16},
  [10229] = {.lex_state = 313, .external_lex_state = 16},
  [10230] = {.lex_state = 313, .external_lex_state = 16},
  [10231] = {.lex_state = 313, .external_lex_state = 16},
  [10232] = {.lex_state = 313, .external_lex_state = 16},
  [10233] = {.lex_state = 313, .external_lex_state = 16},
  [10234] = {.lex_state = 313, .external_lex_state = 16},
  [10235] = {.lex_state = 359, .external_lex_state = 20},
  [10236] = {.lex_state = 313, .external_lex_state = 16},
  [10237] = {.lex_state = 313, .external_lex_state = 16},
  [10238] = {.lex_state = 313, .external_lex_state = 16},
  [10239] = {.lex_state = 313, .external_lex_state = 16},
  [10240] = {.lex_state = 313, .external_lex_state = 16},
  [10241] = {.lex_state = 313, .external_lex_state = 19},
  [10242] = {.lex_state = 157, .external_lex_state = 28},
  [10243] = {.lex_state = 350, .external_lex_state = 16},
  [10244] = {.lex_state = 157, .external_lex_state = 2},
  [10245] = {.lex_state = 197, .external_lex_state = 20},
  [10246] = {.lex_state = 157, .external_lex_state = 2},
  [10247] = {.lex_state = 242, .external_lex_state = 20},
  [10248] = {.lex_state = 135},
  [10249] = {.lex_state = 242, .external_lex_state = 16},
  [10250] = {.lex_state = 242, .external_lex_state = 16},
  [10251] = {.lex_state = 197, .external_lex_state = 16},
  [10252] = {.lex_state = 197, .external_lex_state = 16},
  [10253] = {.lex_state = 157, .external_lex_state = 6},
  [10254] = {.lex_state = 197, .external_lex_state = 16},
  [10255] = {.lex_state = 197, .external_lex_state = 16},
  [10256] = {.lex_state = 197, .external_lex_state = 16},
  [10257] = {.lex_state = 157, .external_lex_state = 28},
  [10258] = {.lex_state = 197, .external_lex_state = 16},
  [10259] = {.lex_state = 157, .external_lex_state = 2},
  [10260] = {.lex_state = 223, .external_lex_state = 17},
  [10261] = {.lex_state = 135},
  [10262] = {.lex_state = 223, .external_lex_state = 17},
  [10263] = {.lex_state = 208, .external_lex_state = 16},
  [10264] = {.lex_state = 208, .external_lex_state = 16},
  [10265] = {.lex_state = 208, .external_lex_state = 16},
  [10266] = {.lex_state = 208, .external_lex_state = 16},
  [10267] = {.lex_state = 157, .external_lex_state = 2},
  [10268] = {.lex_state = 157, .external_lex_state = 28},
  [10269] = {.lex_state = 157, .external_lex_state = 2},
  [10270] = {.lex_state = 157, .external_lex_state = 2},
  [10271] = {.lex_state = 157, .external_lex_state = 2},
  [10272] = {.lex_state = 157, .external_lex_state = 2},
  [10273] = {.lex_state = 157, .external_lex_state = 2},
  [10274] = {.lex_state = 157, .external_lex_state = 2},
  [10275] = {.lex_state = 157, .external_lex_state = 2},
  [10276] = {.lex_state = 157, .external_lex_state = 2},
  [10277] = {.lex_state = 157, .external_lex_state = 2},
  [10278] = {.lex_state = 208, .external_lex_state = 19},
  [10279] = {.lex_state = 157, .external_lex_state = 6},
  [10280] = {.lex_state = 208, .external_lex_state = 16},
  [10281] = {.lex_state = 208, .external_lex_state = 16},
  [10282] = {.lex_state = 208, .external_lex_state = 16},
  [10283] = {.lex_state = 258},
  [10284] = {.lex_state = 258},
  [10285] = {.lex_state = 135},
  [10286] = {.lex_state = 258},
  [10287] = {.lex_state = 258},
  [10288] = {.lex_state = 258},
  [10289] = {.lex_state = 258},
  [10290] = {.lex_state = 135},
  [10291] = {.lex_state = 258},
  [10292] = {.lex_state = 197, .external_lex_state = 16},
  [10293] = {.lex_state = 197, .external_lex_state = 16},
  [10294] = {.lex_state = 157, .external_lex_state = 6},
  [10295] = {.lex_state = 197, .external_lex_state = 16},
  [10296] = {.lex_state = 197, .external_lex_state = 16},
  [10297] = {.lex_state = 197, .external_lex_state = 16},
  [10298] = {.lex_state = 157, .external_lex_state = 28},
  [10299] = {.lex_state = 197, .external_lex_state = 16},
  [10300] = {.lex_state = 157, .external_lex_state = 2},
  [10301] = {.lex_state = 223, .external_lex_state = 17},
  [10302] = {.lex_state = 135},
  [10303] = {.lex_state = 223, .external_lex_state = 17},
  [10304] = {.lex_state = 208, .external_lex_state = 16},
  [10305] = {.lex_state = 208, .external_lex_state = 16},
  [10306] = {.lex_state = 208, .external_lex_state = 16},
  [10307] = {.lex_state = 208, .external_lex_state = 16},
  [10308] = {.lex_state = 157, .external_lex_state = 2},
  [10309] = {.lex_state = 157, .external_lex_state = 28},
  [10310] = {.lex_state = 157, .external_lex_state = 2},
  [10311] = {.lex_state = 157, .external_lex_state = 2},
  [10312] = {.lex_state = 157, .external_lex_state = 2},
  [10313] = {.lex_state = 157, .external_lex_state = 2},
  [10314] = {.lex_state = 157, .external_lex_state = 2},
  [10315] = {.lex_state = 157, .external_lex_state = 2},
  [10316] = {.lex_state = 157, .external_lex_state = 2},
  [10317] = {.lex_state = 157, .external_lex_state = 2},
  [10318] = {.lex_state = 157, .external_lex_state = 2},
  [10319] = {.lex_state = 208, .external_lex_state = 19},
  [10320] = {.lex_state = 157, .external_lex_state = 6},
  [10321] = {.lex_state = 208, .external_lex_state = 16},
  [10322] = {.lex_state = 208, .external_lex_state = 16},
  [10323] = {.lex_state = 208, .external_lex_state = 16},
  [10324] = {.lex_state = 245, .external_lex_state = 17},
  [10325] = {.lex_state = 197, .external_lex_state = 16},
  [10326] = {.lex_state = 157, .external_lex_state = 28},
  [10327] = {.lex_state = 242, .external_lex_state = 16},
  [10328] = {.lex_state = 157, .external_lex_state = 2},
  [10329] = {.lex_state = 197, .external_lex_state = 16},
  [10330] = {.lex_state = 157, .external_lex_state = 2},
  [10331] = {.lex_state = 157, .external_lex_state = 2},
  [10332] = {.lex_state = 271, .external_lex_state = 17},
  [10333] = {.lex_state = 157, .external_lex_state = 2},
  [10334] = {.lex_state = 164},
  [10335] = {.lex_state = 228},
  [10336] = {.lex_state = 220, .external_lex_state = 17},
  [10337] = {.lex_state = 157, .external_lex_state = 2},
  [10338] = {.lex_state = 157, .external_lex_state = 2},
  [10339] = {.lex_state = 220, .external_lex_state = 17},
  [10340] = {.lex_state = 220, .external_lex_state = 17},
  [10341] = {.lex_state = 157, .external_lex_state = 2},
  [10342] = {.lex_state = 220, .external_lex_state = 17},
  [10343] = {.lex_state = 197, .external_lex_state = 16},
  [10344] = {.lex_state = 268, .external_lex_state = 16},
  [10345] = {.lex_state = 197, .external_lex_state = 16},
  [10346] = {.lex_state = 197, .external_lex_state = 16},
  [10347] = {.lex_state = 271, .external_lex_state = 17},
  [10348] = {.lex_state = 157},
  [10349] = {.lex_state = 197, .external_lex_state = 19},
  [10350] = {.lex_state = 197, .external_lex_state = 16},
  [10351] = {.lex_state = 197, .external_lex_state = 20},
  [10352] = {.lex_state = 197, .external_lex_state = 20},
  [10353] = {.lex_state = 223, .external_lex_state = 21},
  [10354] = {.lex_state = 157, .external_lex_state = 2},
  [10355] = {.lex_state = 157, .external_lex_state = 28},
  [10356] = {.lex_state = 157, .external_lex_state = 2},
  [10357] = {.lex_state = 157, .external_lex_state = 2},
  [10358] = {.lex_state = 157, .external_lex_state = 2},
  [10359] = {.lex_state = 157, .external_lex_state = 2},
  [10360] = {.lex_state = 157, .external_lex_state = 2},
  [10361] = {.lex_state = 157, .external_lex_state = 2},
  [10362] = {.lex_state = 157, .external_lex_state = 2},
  [10363] = {.lex_state = 157, .external_lex_state = 2},
  [10364] = {.lex_state = 157, .external_lex_state = 2},
  [10365] = {.lex_state = 157, .external_lex_state = 2},
  [10366] = {.lex_state = 300, .external_lex_state = 27},
  [10367] = {.lex_state = 164},
  [10368] = {.lex_state = 157, .external_lex_state = 2},
  [10369] = {.lex_state = 157, .external_lex_state = 2},
  [10370] = {.lex_state = 271, .external_lex_state = 17},
  [10371] = {.lex_state = 157, .external_lex_state = 2},
  [10372] = {.lex_state = 228},
  [10373] = {.lex_state = 271, .external_lex_state = 17},
  [10374] = {.lex_state = 157, .external_lex_state = 2},
  [10375] = {.lex_state = 157, .external_lex_state = 2},
  [10376] = {.lex_state = 271, .external_lex_state = 17},
  [10377] = {.lex_state = 271, .external_lex_state = 17},
  [10378] = {.lex_state = 157, .external_lex_state = 2},
  [10379] = {.lex_state = 271, .external_lex_state = 17},
  [10380] = {.lex_state = 268, .external_lex_state = 16},
  [10381] = {.lex_state = 157},
  [10382] = {.lex_state = 271, .external_lex_state = 17},
  [10383] = {.lex_state = 208, .external_lex_state = 16},
  [10384] = {.lex_state = 268, .external_lex_state = 16},
  [10385] = {.lex_state = 268, .external_lex_state = 16},
  [10386] = {.lex_state = 268, .external_lex_state = 19},
  [10387] = {.lex_state = 208, .external_lex_state = 16},
  [10388] = {.lex_state = 197, .external_lex_state = 23},
  [10389] = {.lex_state = 135, .external_lex_state = 10},
  [10390] = {.lex_state = 157},
  [10391] = {.lex_state = 157},
  [10392] = {.lex_state = 157},
  [10393] = {.lex_state = 157},
  [10394] = {.lex_state = 135},
  [10395] = {.lex_state = 157},
  [10396] = {.lex_state = 197, .external_lex_state = 5},
  [10397] = {.lex_state = 197, .external_lex_state = 5},
  [10398] = {.lex_state = 157, .external_lex_state = 6},
  [10399] = {.lex_state = 197, .external_lex_state = 5},
  [10400] = {.lex_state = 197, .external_lex_state = 5},
  [10401] = {.lex_state = 197, .external_lex_state = 5},
  [10402] = {.lex_state = 197, .external_lex_state = 5},
  [10403] = {.lex_state = 197, .external_lex_state = 5},
  [10404] = {.lex_state = 197, .external_lex_state = 5},
  [10405] = {.lex_state = 197, .external_lex_state = 5},
  [10406] = {.lex_state = 197, .external_lex_state = 5},
  [10407] = {.lex_state = 197, .external_lex_state = 5},
  [10408] = {.lex_state = 197, .external_lex_state = 5},
  [10409] = {.lex_state = 197, .external_lex_state = 5},
  [10410] = {.lex_state = 197, .external_lex_state = 5},
  [10411] = {.lex_state = 359, .external_lex_state = 20},
  [10412] = {.lex_state = 197, .external_lex_state = 5},
  [10413] = {.lex_state = 197, .external_lex_state = 5},
  [10414] = {.lex_state = 197, .external_lex_state = 5},
  [10415] = {.lex_state = 197, .external_lex_state = 5},
  [10416] = {.lex_state = 197, .external_lex_state = 5},
  [10417] = {.lex_state = 197, .external_lex_state = 14},
  [10418] = {.lex_state = 157, .external_lex_state = 28},
  [10419] = {.lex_state = 197, .external_lex_state = 5},
  [10420] = {.lex_state = 157, .external_lex_state = 2},
  [10421] = {.lex_state = 271, .external_lex_state = 9},
  [10422] = {.lex_state = 135},
  [10423] = {.lex_state = 271, .external_lex_state = 9},
  [10424] = {.lex_state = 268, .external_lex_state = 5},
  [10425] = {.lex_state = 268, .external_lex_state = 5},
  [10426] = {.lex_state = 157, .external_lex_state = 6},
  [10427] = {.lex_state = 268, .external_lex_state = 5},
  [10428] = {.lex_state = 268, .external_lex_state = 5},
  [10429] = {.lex_state = 268, .external_lex_state = 5},
  [10430] = {.lex_state = 223, .external_lex_state = 9},
  [10431] = {.lex_state = 197, .external_lex_state = 5},
  [10432] = {.lex_state = 197, .external_lex_state = 5},
  [10433] = {.lex_state = 197, .external_lex_state = 5},
  [10434] = {.lex_state = 197, .external_lex_state = 5},
  [10435] = {.lex_state = 197, .external_lex_state = 5},
  [10436] = {.lex_state = 197, .external_lex_state = 5},
  [10437] = {.lex_state = 359, .external_lex_state = 20},
  [10438] = {.lex_state = 197, .external_lex_state = 5},
  [10439] = {.lex_state = 197, .external_lex_state = 5},
  [10440] = {.lex_state = 197, .external_lex_state = 5},
  [10441] = {.lex_state = 197, .external_lex_state = 5},
  [10442] = {.lex_state = 197, .external_lex_state = 5},
  [10443] = {.lex_state = 197, .external_lex_state = 5},
  [10444] = {.lex_state = 197, .external_lex_state = 5},
  [10445] = {.lex_state = 208, .external_lex_state = 5},
  [10446] = {.lex_state = 208, .external_lex_state = 5},
  [10447] = {.lex_state = 208, .external_lex_state = 5},
  [10448] = {.lex_state = 208, .external_lex_state = 5},
  [10449] = {.lex_state = 208, .external_lex_state = 5},
  [10450] = {.lex_state = 208, .external_lex_state = 5},
  [10451] = {.lex_state = 208, .external_lex_state = 5},
  [10452] = {.lex_state = 359, .external_lex_state = 20},
  [10453] = {.lex_state = 208, .external_lex_state = 5},
  [10454] = {.lex_state = 208, .external_lex_state = 5},
  [10455] = {.lex_state = 208, .external_lex_state = 5},
  [10456] = {.lex_state = 208, .external_lex_state = 5},
  [10457] = {.lex_state = 208, .external_lex_state = 5},
  [10458] = {.lex_state = 208, .external_lex_state = 14},
  [10459] = {.lex_state = 157, .external_lex_state = 28},
  [10460] = {.lex_state = 268, .external_lex_state = 5},
  [10461] = {.lex_state = 157, .external_lex_state = 2},
  [10462] = {.lex_state = 197, .external_lex_state = 5},
  [10463] = {.lex_state = 197, .external_lex_state = 16},
  [10464] = {.lex_state = 197, .external_lex_state = 16},
  [10465] = {.lex_state = 157, .external_lex_state = 6},
  [10466] = {.lex_state = 197, .external_lex_state = 16},
  [10467] = {.lex_state = 197, .external_lex_state = 16},
  [10468] = {.lex_state = 197, .external_lex_state = 16},
  [10469] = {.lex_state = 197, .external_lex_state = 20},
  [10470] = {.lex_state = 157, .external_lex_state = 28},
  [10471] = {.lex_state = 197, .external_lex_state = 20},
  [10472] = {.lex_state = 157, .external_lex_state = 2},
  [10473] = {.lex_state = 223, .external_lex_state = 21},
  [10474] = {.lex_state = 135},
  [10475] = {.lex_state = 223, .external_lex_state = 21},
  [10476] = {.lex_state = 232, .external_lex_state = 2},
  [10477] = {.lex_state = 157},
  [10478] = {.lex_state = 157},
  [10479] = {.lex_state = 135},
  [10480] = {.lex_state = 274, .external_lex_state = 20},
  [10481] = {.lex_state = 274, .external_lex_state = 20},
  [10482] = {.lex_state = 274, .external_lex_state = 20},
  [10483] = {.lex_state = 274, .external_lex_state = 20},
  [10484] = {.lex_state = 274, .external_lex_state = 20},
  [10485] = {.lex_state = 274, .external_lex_state = 20},
  [10486] = {.lex_state = 359, .external_lex_state = 20},
  [10487] = {.lex_state = 274, .external_lex_state = 20},
  [10488] = {.lex_state = 274, .external_lex_state = 20},
  [10489] = {.lex_state = 274, .external_lex_state = 20},
  [10490] = {.lex_state = 274, .external_lex_state = 20},
  [10491] = {.lex_state = 274, .external_lex_state = 20},
  [10492] = {.lex_state = 274, .external_lex_state = 23},
  [10493] = {.lex_state = 274, .external_lex_state = 16},
  [10494] = {.lex_state = 274, .external_lex_state = 16},
  [10495] = {.lex_state = 274, .external_lex_state = 16},
  [10496] = {.lex_state = 274, .external_lex_state = 16},
  [10497] = {.lex_state = 274, .external_lex_state = 16},
  [10498] = {.lex_state = 274, .external_lex_state = 16},
  [10499] = {.lex_state = 274, .external_lex_state = 16},
  [10500] = {.lex_state = 359, .external_lex_state = 20},
  [10501] = {.lex_state = 274, .external_lex_state = 16},
  [10502] = {.lex_state = 274, .external_lex_state = 16},
  [10503] = {.lex_state = 274, .external_lex_state = 16},
  [10504] = {.lex_state = 274, .external_lex_state = 16},
  [10505] = {.lex_state = 274, .external_lex_state = 16},
  [10506] = {.lex_state = 157, .external_lex_state = 28},
  [10507] = {.lex_state = 274, .external_lex_state = 16},
  [10508] = {.lex_state = 157, .external_lex_state = 2},
  [10509] = {.lex_state = 274, .external_lex_state = 20},
  [10510] = {.lex_state = 274, .external_lex_state = 20},
  [10511] = {.lex_state = 223, .external_lex_state = 21},
  [10512] = {.lex_state = 277, .external_lex_state = 16},
  [10513] = {.lex_state = 277, .external_lex_state = 16},
  [10514] = {.lex_state = 277, .external_lex_state = 16},
  [10515] = {.lex_state = 277, .external_lex_state = 16},
  [10516] = {.lex_state = 277, .external_lex_state = 16},
  [10517] = {.lex_state = 277, .external_lex_state = 16},
  [10518] = {.lex_state = 277, .external_lex_state = 16},
  [10519] = {.lex_state = 359, .external_lex_state = 20},
  [10520] = {.lex_state = 277, .external_lex_state = 16},
  [10521] = {.lex_state = 277, .external_lex_state = 16},
  [10522] = {.lex_state = 277, .external_lex_state = 16},
  [10523] = {.lex_state = 277, .external_lex_state = 16},
  [10524] = {.lex_state = 277, .external_lex_state = 16},
  [10525] = {.lex_state = 277, .external_lex_state = 19},
  [10526] = {.lex_state = 157, .external_lex_state = 28},
  [10527] = {.lex_state = 344, .external_lex_state = 16},
  [10528] = {.lex_state = 157, .external_lex_state = 2},
  [10529] = {.lex_state = 258, .external_lex_state = 13},
  [10530] = {.lex_state = 135, .external_lex_state = 2},
  [10531] = {.lex_state = 135},
  [10532] = {.lex_state = 135, .external_lex_state = 10},
  [10533] = {.lex_state = 258, .external_lex_state = 13},
  [10534] = {.lex_state = 215},
  [10535] = {.lex_state = 135, .external_lex_state = 2},
  [10536] = {.lex_state = 197, .external_lex_state = 13},
  [10537] = {.lex_state = 220},
  [10538] = {.lex_state = 197, .external_lex_state = 13},
  [10539] = {.lex_state = 197, .external_lex_state = 13},
  [10540] = {.lex_state = 197, .external_lex_state = 5},
  [10541] = {.lex_state = 197, .external_lex_state = 5},
  [10542] = {.lex_state = 197, .external_lex_state = 5},
  [10543] = {.lex_state = 135},
  [10544] = {.lex_state = 197, .external_lex_state = 5},
  [10545] = {.lex_state = 197, .external_lex_state = 5},
  [10546] = {.lex_state = 197, .external_lex_state = 5},
  [10547] = {.lex_state = 197, .external_lex_state = 5},
  [10548] = {.lex_state = 135},
  [10549] = {.lex_state = 274, .external_lex_state = 16},
  [10550] = {.lex_state = 274, .external_lex_state = 16},
  [10551] = {.lex_state = 274, .external_lex_state = 16},
  [10552] = {.lex_state = 157, .external_lex_state = 28},
  [10553] = {.lex_state = 274, .external_lex_state = 16},
  [10554] = {.lex_state = 157, .external_lex_state = 2},
  [10555] = {.lex_state = 223, .external_lex_state = 17},
  [10556] = {.lex_state = 135},
  [10557] = {.lex_state = 223, .external_lex_state = 17},
  [10558] = {.lex_state = 266, .external_lex_state = 6},
  [10559] = {.lex_state = 157, .external_lex_state = 6},
  [10560] = {.lex_state = 274, .external_lex_state = 16},
  [10561] = {.lex_state = 274, .external_lex_state = 16},
  [10562] = {.lex_state = 271, .external_lex_state = 17},
  [10563] = {.lex_state = 197, .external_lex_state = 5},
  [10564] = {.lex_state = 197, .external_lex_state = 5},
  [10565] = {.lex_state = 268, .external_lex_state = 5},
  [10566] = {.lex_state = 135},
  [10567] = {.lex_state = 197, .external_lex_state = 5},
  [10568] = {.lex_state = 197, .external_lex_state = 5},
  [10569] = {.lex_state = 157, .external_lex_state = 28},
  [10570] = {.lex_state = 197, .external_lex_state = 5},
  [10571] = {.lex_state = 157, .external_lex_state = 2},
  [10572] = {.lex_state = 197, .external_lex_state = 5},
  [10573] = {.lex_state = 197, .external_lex_state = 5},
  [10574] = {.lex_state = 157, .external_lex_state = 2},
  [10575] = {.lex_state = 197, .external_lex_state = 5},
  [10576] = {.lex_state = 197, .external_lex_state = 5},
  [10577] = {.lex_state = 197, .external_lex_state = 5},
  [10578] = {.lex_state = 197, .external_lex_state = 5},
  [10579] = {.lex_state = 197, .external_lex_state = 5},
  [10580] = {.lex_state = 157, .external_lex_state = 2},
  [10581] = {.lex_state = 157, .external_lex_state = 28},
  [10582] = {.lex_state = 157, .external_lex_state = 2},
  [10583] = {.lex_state = 157, .external_lex_state = 2},
  [10584] = {.lex_state = 157, .external_lex_state = 2},
  [10585] = {.lex_state = 157, .external_lex_state = 2},
  [10586] = {.lex_state = 157, .external_lex_state = 2},
  [10587] = {.lex_state = 157, .external_lex_state = 2},
  [10588] = {.lex_state = 157, .external_lex_state = 2},
  [10589] = {.lex_state = 157, .external_lex_state = 2},
  [10590] = {.lex_state = 157, .external_lex_state = 2},
  [10591] = {.lex_state = 157, .external_lex_state = 6},
  [10592] = {.lex_state = 197, .external_lex_state = 5},
  [10593] = {.lex_state = 197, .external_lex_state = 5},
  [10594] = {.lex_state = 197, .external_lex_state = 5},
  [10595] = {.lex_state = 197, .external_lex_state = 5},
  [10596] = {.lex_state = 157, .external_lex_state = 28},
  [10597] = {.lex_state = 197, .external_lex_state = 5},
  [10598] = {.lex_state = 157, .external_lex_state = 2},
  [10599] = {.lex_state = 223, .external_lex_state = 9},
  [10600] = {.lex_state = 135},
  [10601] = {.lex_state = 223, .external_lex_state = 9},
  [10602] = {.lex_state = 135, .external_lex_state = 2},
  [10603] = {.lex_state = 197, .external_lex_state = 13},
  [10604] = {.lex_state = 197, .external_lex_state = 5},
  [10605] = {.lex_state = 197, .external_lex_state = 5},
  [10606] = {.lex_state = 223, .external_lex_state = 9},
  [10607] = {.lex_state = 157, .external_lex_state = 2},
  [10608] = {.lex_state = 157, .external_lex_state = 2},
  [10609] = {.lex_state = 271, .external_lex_state = 9},
  [10610] = {.lex_state = 157, .external_lex_state = 2},
  [10611] = {.lex_state = 164},
  [10612] = {.lex_state = 228},
  [10613] = {.lex_state = 220, .external_lex_state = 9},
  [10614] = {.lex_state = 157, .external_lex_state = 2},
  [10615] = {.lex_state = 157, .external_lex_state = 2},
  [10616] = {.lex_state = 220, .external_lex_state = 9},
  [10617] = {.lex_state = 220, .external_lex_state = 9},
  [10618] = {.lex_state = 157, .external_lex_state = 2},
  [10619] = {.lex_state = 220, .external_lex_state = 9},
  [10620] = {.lex_state = 197, .external_lex_state = 5},
  [10621] = {.lex_state = 268, .external_lex_state = 5},
  [10622] = {.lex_state = 197, .external_lex_state = 5},
  [10623] = {.lex_state = 197, .external_lex_state = 5},
  [10624] = {.lex_state = 271, .external_lex_state = 9},
  [10625] = {.lex_state = 157},
  [10626] = {.lex_state = 197, .external_lex_state = 14},
  [10627] = {.lex_state = 197, .external_lex_state = 5},
  [10628] = {.lex_state = 157, .external_lex_state = 2},
  [10629] = {.lex_state = 157, .external_lex_state = 2},
  [10630] = {.lex_state = 157, .external_lex_state = 2},
  [10631] = {.lex_state = 217, .external_lex_state = 22},
  [10632] = {.lex_state = 157, .external_lex_state = 2},
  [10633] = {.lex_state = 157, .external_lex_state = 2},
  [10634] = {.lex_state = 135, .external_lex_state = 2},
  [10635] = {.lex_state = 300, .external_lex_state = 27},
  [10636] = {.lex_state = 164},
  [10637] = {.lex_state = 157, .external_lex_state = 28},
  [10638] = {.lex_state = 157, .external_lex_state = 2},
  [10639] = {.lex_state = 157, .external_lex_state = 2},
  [10640] = {.lex_state = 271, .external_lex_state = 9},
  [10641] = {.lex_state = 157, .external_lex_state = 2},
  [10642] = {.lex_state = 228},
  [10643] = {.lex_state = 271, .external_lex_state = 9},
  [10644] = {.lex_state = 157, .external_lex_state = 2},
  [10645] = {.lex_state = 157, .external_lex_state = 2},
  [10646] = {.lex_state = 271, .external_lex_state = 9},
  [10647] = {.lex_state = 271, .external_lex_state = 9},
  [10648] = {.lex_state = 157, .external_lex_state = 2},
  [10649] = {.lex_state = 271, .external_lex_state = 9},
  [10650] = {.lex_state = 268, .external_lex_state = 5},
  [10651] = {.lex_state = 157},
  [10652] = {.lex_state = 271, .external_lex_state = 9},
  [10653] = {.lex_state = 208, .external_lex_state = 5},
  [10654] = {.lex_state = 268, .external_lex_state = 5},
  [10655] = {.lex_state = 268, .external_lex_state = 5},
  [10656] = {.lex_state = 268, .external_lex_state = 14},
  [10657] = {.lex_state = 208, .external_lex_state = 5},
  [10658] = {.lex_state = 157, .external_lex_state = 2},
  [10659] = {.lex_state = 157, .external_lex_state = 2},
  [10660] = {.lex_state = 157, .external_lex_state = 2},
  [10661] = {.lex_state = 157, .external_lex_state = 2},
  [10662] = {.lex_state = 157, .external_lex_state = 2},
  [10663] = {.lex_state = 157, .external_lex_state = 2},
  [10664] = {.lex_state = 157, .external_lex_state = 2},
  [10665] = {.lex_state = 157, .external_lex_state = 2},
  [10666] = {.lex_state = 157, .external_lex_state = 2},
  [10667] = {.lex_state = 157, .external_lex_state = 2},
  [10668] = {.lex_state = 157, .external_lex_state = 2},
  [10669] = {.lex_state = 197, .external_lex_state = 14},
  [10670] = {.lex_state = 135, .external_lex_state = 13},
  [10671] = {.lex_state = 135, .external_lex_state = 2},
  [10672] = {.lex_state = 208, .external_lex_state = 5},
  [10673] = {.lex_state = 208, .external_lex_state = 5},
  [10674] = {.lex_state = 208, .external_lex_state = 5},
  [10675] = {.lex_state = 208, .external_lex_state = 5},
  [10676] = {.lex_state = 157, .external_lex_state = 2},
  [10677] = {.lex_state = 157, .external_lex_state = 28},
  [10678] = {.lex_state = 157, .external_lex_state = 2},
  [10679] = {.lex_state = 157, .external_lex_state = 2},
  [10680] = {.lex_state = 157, .external_lex_state = 2},
  [10681] = {.lex_state = 157, .external_lex_state = 2},
  [10682] = {.lex_state = 157, .external_lex_state = 2},
  [10683] = {.lex_state = 157, .external_lex_state = 2},
  [10684] = {.lex_state = 157, .external_lex_state = 2},
  [10685] = {.lex_state = 157, .external_lex_state = 2},
  [10686] = {.lex_state = 157, .external_lex_state = 2},
  [10687] = {.lex_state = 208, .external_lex_state = 14},
  [10688] = {.lex_state = 157, .external_lex_state = 6},
  [10689] = {.lex_state = 208, .external_lex_state = 5},
  [10690] = {.lex_state = 208, .external_lex_state = 5},
  [10691] = {.lex_state = 208, .external_lex_state = 5},
  [10692] = {.lex_state = 274, .external_lex_state = 5},
  [10693] = {.lex_state = 274, .external_lex_state = 5},
  [10694] = {.lex_state = 157, .external_lex_state = 28},
  [10695] = {.lex_state = 274, .external_lex_state = 5},
  [10696] = {.lex_state = 157, .external_lex_state = 2},
  [10697] = {.lex_state = 274, .external_lex_state = 5},
  [10698] = {.lex_state = 274, .external_lex_state = 5},
  [10699] = {.lex_state = 271, .external_lex_state = 9},
  [10700] = {.lex_state = 258, .external_lex_state = 6},
  [10701] = {.lex_state = 274, .external_lex_state = 16},
  [10702] = {.lex_state = 274, .external_lex_state = 16},
  [10703] = {.lex_state = 157, .external_lex_state = 6},
  [10704] = {.lex_state = 274, .external_lex_state = 16},
  [10705] = {.lex_state = 274, .external_lex_state = 16},
  [10706] = {.lex_state = 274, .external_lex_state = 16},
  [10707] = {.lex_state = 157, .external_lex_state = 2},
  [10708] = {.lex_state = 157, .external_lex_state = 2},
  [10709] = {.lex_state = 372, .external_lex_state = 16},
  [10710] = {.lex_state = 372, .external_lex_state = 16},
  [10711] = {.lex_state = 372, .external_lex_state = 16},
  [10712] = {.lex_state = 157, .external_lex_state = 29},
  [10713] = {.lex_state = 372, .external_lex_state = 16},
  [10714] = {.lex_state = 372, .external_lex_state = 16},
  [10715] = {.lex_state = 372, .external_lex_state = 16},
  [10716] = {.lex_state = 372, .external_lex_state = 16},
  [10717] = {.lex_state = 372, .external_lex_state = 16},
  [10718] = {.lex_state = 372, .external_lex_state = 16},
  [10719] = {.lex_state = 372, .external_lex_state = 16},
  [10720] = {.lex_state = 372, .external_lex_state = 16},
  [10721] = {.lex_state = 372, .external_lex_state = 16},
  [10722] = {.lex_state = 359, .external_lex_state = 20},
  [10723] = {.lex_state = 372, .external_lex_state = 16},
  [10724] = {.lex_state = 372, .external_lex_state = 16},
  [10725] = {.lex_state = 372, .external_lex_state = 16},
  [10726] = {.lex_state = 372, .external_lex_state = 16},
  [10727] = {.lex_state = 372, .external_lex_state = 16},
  [10728] = {.lex_state = 372, .external_lex_state = 19},
  [10729] = {.lex_state = 157, .external_lex_state = 28},
  [10730] = {.lex_state = 274, .external_lex_state = 16},
  [10731] = {.lex_state = 157, .external_lex_state = 2},
  [10732] = {.lex_state = 157, .external_lex_state = 2},
  [10733] = {.lex_state = 157, .external_lex_state = 28},
  [10734] = {.lex_state = 277, .external_lex_state = 5},
  [10735] = {.lex_state = 157, .external_lex_state = 2},
  [10736] = {.lex_state = 344, .external_lex_state = 5},
  [10737] = {.lex_state = 344, .external_lex_state = 5},
  [10738] = {.lex_state = 157, .external_lex_state = 28},
  [10739] = {.lex_state = 197, .external_lex_state = 16},
  [10740] = {.lex_state = 157, .external_lex_state = 2},
  [10741] = {.lex_state = 197, .external_lex_state = 16},
  [10742] = {.lex_state = 197, .external_lex_state = 16},
  [10743] = {.lex_state = 157, .external_lex_state = 28},
  [10744] = {.lex_state = 197, .external_lex_state = 5},
  [10745] = {.lex_state = 157, .external_lex_state = 2},
  [10746] = {.lex_state = 258, .external_lex_state = 25},
  [10747] = {.lex_state = 135},
  [10748] = {.lex_state = 258, .external_lex_state = 25},
  [10749] = {.lex_state = 258, .external_lex_state = 13},
  [10750] = {.lex_state = 197, .external_lex_state = 5},
  [10751] = {.lex_state = 197, .external_lex_state = 5},
  [10752] = {.lex_state = 157, .external_lex_state = 2},
  [10753] = {.lex_state = 157, .external_lex_state = 2},
  [10754] = {.lex_state = 197, .external_lex_state = 5},
  [10755] = {.lex_state = 197, .external_lex_state = 5},
  [10756] = {.lex_state = 197, .external_lex_state = 5},
  [10757] = {.lex_state = 157, .external_lex_state = 29},
  [10758] = {.lex_state = 197, .external_lex_state = 5},
  [10759] = {.lex_state = 197, .external_lex_state = 5},
  [10760] = {.lex_state = 271, .external_lex_state = 9},
  [10761] = {.lex_state = 228},
  [10762] = {.lex_state = 157, .external_lex_state = 2},
  [10763] = {.lex_state = 157, .external_lex_state = 2},
  [10764] = {.lex_state = 157, .external_lex_state = 2},
  [10765] = {.lex_state = 197, .external_lex_state = 5},
  [10766] = {.lex_state = 197, .external_lex_state = 5},
  [10767] = {.lex_state = 197, .external_lex_state = 14},
  [10768] = {.lex_state = 197, .external_lex_state = 5},
  [10769] = {.lex_state = 197, .external_lex_state = 5},
  [10770] = {.lex_state = 197, .external_lex_state = 5},
  [10771] = {.lex_state = 157, .external_lex_state = 2},
  [10772] = {.lex_state = 157, .external_lex_state = 28},
  [10773] = {.lex_state = 157, .external_lex_state = 2},
  [10774] = {.lex_state = 157, .external_lex_state = 2},
  [10775] = {.lex_state = 157, .external_lex_state = 2},
  [10776] = {.lex_state = 157, .external_lex_state = 2},
  [10777] = {.lex_state = 157, .external_lex_state = 2},
  [10778] = {.lex_state = 157, .external_lex_state = 2},
  [10779] = {.lex_state = 157, .external_lex_state = 2},
  [10780] = {.lex_state = 157, .external_lex_state = 2},
  [10781] = {.lex_state = 157, .external_lex_state = 2},
  [10782] = {.lex_state = 157, .external_lex_state = 2},
  [10783] = {.lex_state = 197, .external_lex_state = 14},
  [10784] = {.lex_state = 258, .external_lex_state = 13},
  [10785] = {.lex_state = 197, .external_lex_state = 5},
  [10786] = {.lex_state = 197, .external_lex_state = 5},
  [10787] = {.lex_state = 258, .external_lex_state = 13},
  [10788] = {.lex_state = 217, .external_lex_state = 22},
  [10789] = {.lex_state = 258, .external_lex_state = 13},
  [10790] = {.lex_state = 157, .external_lex_state = 6},
  [10791] = {.lex_state = 258, .external_lex_state = 13},
  [10792] = {.lex_state = 258, .external_lex_state = 13},
  [10793] = {.lex_state = 258, .external_lex_state = 13},
  [10794] = {.lex_state = 197, .external_lex_state = 5},
  [10795] = {.lex_state = 197, .external_lex_state = 5},
  [10796] = {.lex_state = 197, .external_lex_state = 5},
  [10797] = {.lex_state = 359, .external_lex_state = 20},
  [10798] = {.lex_state = 197, .external_lex_state = 5},
  [10799] = {.lex_state = 197, .external_lex_state = 5},
  [10800] = {.lex_state = 197, .external_lex_state = 5},
  [10801] = {.lex_state = 197, .external_lex_state = 5},
  [10802] = {.lex_state = 197, .external_lex_state = 5},
  [10803] = {.lex_state = 197, .external_lex_state = 5},
  [10804] = {.lex_state = 197, .external_lex_state = 5},
  [10805] = {.lex_state = 197, .external_lex_state = 14},
  [10806] = {.lex_state = 197, .external_lex_state = 5},
  [10807] = {.lex_state = 197, .external_lex_state = 5},
  [10808] = {.lex_state = 271, .external_lex_state = 9},
  [10809] = {.lex_state = 157, .external_lex_state = 28},
  [10810] = {.lex_state = 268, .external_lex_state = 5},
  [10811] = {.lex_state = 157, .external_lex_state = 2},
  [10812] = {.lex_state = 197, .external_lex_state = 5},
  [10813] = {.lex_state = 197, .external_lex_state = 5},
  [10814] = {.lex_state = 157, .external_lex_state = 6},
  [10815] = {.lex_state = 197, .external_lex_state = 5},
  [10816] = {.lex_state = 197, .external_lex_state = 5},
  [10817] = {.lex_state = 197, .external_lex_state = 5},
  [10818] = {.lex_state = 197, .external_lex_state = 5},
  [10819] = {.lex_state = 197, .external_lex_state = 5},
  [10820] = {.lex_state = 197, .external_lex_state = 5},
  [10821] = {.lex_state = 197, .external_lex_state = 5},
  [10822] = {.lex_state = 197, .external_lex_state = 5},
  [10823] = {.lex_state = 197, .external_lex_state = 5},
  [10824] = {.lex_state = 197, .external_lex_state = 5},
  [10825] = {.lex_state = 197, .external_lex_state = 5},
  [10826] = {.lex_state = 197, .external_lex_state = 5},
  [10827] = {.lex_state = 359, .external_lex_state = 20},
  [10828] = {.lex_state = 197, .external_lex_state = 5},
  [10829] = {.lex_state = 197, .external_lex_state = 5},
  [10830] = {.lex_state = 197, .external_lex_state = 5},
  [10831] = {.lex_state = 197, .external_lex_state = 5},
  [10832] = {.lex_state = 197, .external_lex_state = 5},
  [10833] = {.lex_state = 197, .external_lex_state = 14},
  [10834] = {.lex_state = 157, .external_lex_state = 28},
  [10835] = {.lex_state = 197, .external_lex_state = 5},
  [10836] = {.lex_state = 157, .external_lex_state = 2},
  [10837] = {.lex_state = 271, .external_lex_state = 9},
  [10838] = {.lex_state = 135},
  [10839] = {.lex_state = 271, .external_lex_state = 9},
  [10840] = {.lex_state = 268, .external_lex_state = 5},
  [10841] = {.lex_state = 268, .external_lex_state = 5},
  [10842] = {.lex_state = 157, .external_lex_state = 6},
  [10843] = {.lex_state = 268, .external_lex_state = 5},
  [10844] = {.lex_state = 268, .external_lex_state = 5},
  [10845] = {.lex_state = 268, .external_lex_state = 5},
  [10846] = {.lex_state = 223, .external_lex_state = 9},
  [10847] = {.lex_state = 197, .external_lex_state = 5},
  [10848] = {.lex_state = 197, .external_lex_state = 5},
  [10849] = {.lex_state = 197, .external_lex_state = 5},
  [10850] = {.lex_state = 197, .external_lex_state = 5},
  [10851] = {.lex_state = 197, .external_lex_state = 5},
  [10852] = {.lex_state = 197, .external_lex_state = 5},
  [10853] = {.lex_state = 359, .external_lex_state = 20},
  [10854] = {.lex_state = 197, .external_lex_state = 5},
  [10855] = {.lex_state = 197, .external_lex_state = 5},
  [10856] = {.lex_state = 197, .external_lex_state = 5},
  [10857] = {.lex_state = 197, .external_lex_state = 5},
  [10858] = {.lex_state = 197, .external_lex_state = 5},
  [10859] = {.lex_state = 197, .external_lex_state = 5},
  [10860] = {.lex_state = 208, .external_lex_state = 5},
  [10861] = {.lex_state = 208, .external_lex_state = 5},
  [10862] = {.lex_state = 208, .external_lex_state = 5},
  [10863] = {.lex_state = 208, .external_lex_state = 5},
  [10864] = {.lex_state = 208, .external_lex_state = 5},
  [10865] = {.lex_state = 208, .external_lex_state = 5},
  [10866] = {.lex_state = 208, .external_lex_state = 5},
  [10867] = {.lex_state = 359, .external_lex_state = 20},
  [10868] = {.lex_state = 208, .external_lex_state = 5},
  [10869] = {.lex_state = 208, .external_lex_state = 5},
  [10870] = {.lex_state = 208, .external_lex_state = 5},
  [10871] = {.lex_state = 208, .external_lex_state = 5},
  [10872] = {.lex_state = 208, .external_lex_state = 5},
  [10873] = {.lex_state = 208, .external_lex_state = 14},
  [10874] = {.lex_state = 157, .external_lex_state = 28},
  [10875] = {.lex_state = 268, .external_lex_state = 5},
  [10876] = {.lex_state = 157, .external_lex_state = 2},
  [10877] = {.lex_state = 197, .external_lex_state = 5},
  [10878] = {.lex_state = 197, .external_lex_state = 5},
  [10879] = {.lex_state = 197, .external_lex_state = 5},
  [10880] = {.lex_state = 157, .external_lex_state = 28},
  [10881] = {.lex_state = 197, .external_lex_state = 5},
  [10882] = {.lex_state = 157, .external_lex_state = 2},
  [10883] = {.lex_state = 197, .external_lex_state = 5},
  [10884] = {.lex_state = 197, .external_lex_state = 5},
  [10885] = {.lex_state = 271, .external_lex_state = 9},
  [10886] = {.lex_state = 157, .external_lex_state = 2},
  [10887] = {.lex_state = 157, .external_lex_state = 28},
  [10888] = {.lex_state = 208, .external_lex_state = 5},
  [10889] = {.lex_state = 157, .external_lex_state = 2},
  [10890] = {.lex_state = 268, .external_lex_state = 5},
  [10891] = {.lex_state = 268, .external_lex_state = 5},
  [10892] = {.lex_state = 316, .external_lex_state = 16},
  [10893] = {.lex_state = 316, .external_lex_state = 16},
  [10894] = {.lex_state = 157, .external_lex_state = 6},
  [10895] = {.lex_state = 316, .external_lex_state = 16},
  [10896] = {.lex_state = 316, .external_lex_state = 16},
  [10897] = {.lex_state = 316, .external_lex_state = 16},
  [10898] = {.lex_state = 157, .external_lex_state = 28},
  [10899] = {.lex_state = 316, .external_lex_state = 16},
  [10900] = {.lex_state = 157, .external_lex_state = 2},
  [10901] = {.lex_state = 197, .external_lex_state = 16},
  [10902] = {.lex_state = 197, .external_lex_state = 16},
  [10903] = {.lex_state = 197, .external_lex_state = 13},
  [10904] = {.lex_state = 197, .external_lex_state = 5},
  [10905] = {.lex_state = 197, .external_lex_state = 5},
  [10906] = {.lex_state = 157, .external_lex_state = 2},
  [10907] = {.lex_state = 157, .external_lex_state = 2},
  [10908] = {.lex_state = 197, .external_lex_state = 5},
  [10909] = {.lex_state = 197, .external_lex_state = 5},
  [10910] = {.lex_state = 197, .external_lex_state = 5},
  [10911] = {.lex_state = 157, .external_lex_state = 29},
  [10912] = {.lex_state = 197, .external_lex_state = 5},
  [10913] = {.lex_state = 197, .external_lex_state = 5},
  [10914] = {.lex_state = 197, .external_lex_state = 5},
  [10915] = {.lex_state = 197, .external_lex_state = 5},
  [10916] = {.lex_state = 197, .external_lex_state = 5},
  [10917] = {.lex_state = 197, .external_lex_state = 5},
  [10918] = {.lex_state = 157, .external_lex_state = 2},
  [10919] = {.lex_state = 157, .external_lex_state = 28},
  [10920] = {.lex_state = 157, .external_lex_state = 2},
  [10921] = {.lex_state = 157, .external_lex_state = 2},
  [10922] = {.lex_state = 157, .external_lex_state = 2},
  [10923] = {.lex_state = 157, .external_lex_state = 2},
  [10924] = {.lex_state = 157, .external_lex_state = 2},
  [10925] = {.lex_state = 157, .external_lex_state = 2},
  [10926] = {.lex_state = 157, .external_lex_state = 2},
  [10927] = {.lex_state = 157, .external_lex_state = 2},
  [10928] = {.lex_state = 157, .external_lex_state = 2},
  [10929] = {.lex_state = 197, .external_lex_state = 14},
  [10930] = {.lex_state = 157, .external_lex_state = 6},
  [10931] = {.lex_state = 197, .external_lex_state = 5},
  [10932] = {.lex_state = 197, .external_lex_state = 5},
  [10933] = {.lex_state = 197, .external_lex_state = 5},
  [10934] = {.lex_state = 197, .external_lex_state = 5},
  [10935] = {.lex_state = 197, .external_lex_state = 5},
  [10936] = {.lex_state = 197, .external_lex_state = 5},
  [10937] = {.lex_state = 197, .external_lex_state = 5},
  [10938] = {.lex_state = 197, .external_lex_state = 5},
  [10939] = {.lex_state = 359, .external_lex_state = 20},
  [10940] = {.lex_state = 197, .external_lex_state = 5},
  [10941] = {.lex_state = 197, .external_lex_state = 5},
  [10942] = {.lex_state = 197, .external_lex_state = 5},
  [10943] = {.lex_state = 197, .external_lex_state = 5},
  [10944] = {.lex_state = 197, .external_lex_state = 5},
  [10945] = {.lex_state = 197, .external_lex_state = 5},
  [10946] = {.lex_state = 197, .external_lex_state = 5},
  [10947] = {.lex_state = 271, .external_lex_state = 9},
  [10948] = {.lex_state = 266, .external_lex_state = 6},
  [10949] = {.lex_state = 271, .external_lex_state = 9},
  [10950] = {.lex_state = 271, .external_lex_state = 9},
  [10951] = {.lex_state = 300, .external_lex_state = 27},
  [10952] = {.lex_state = 271, .external_lex_state = 9},
  [10953] = {.lex_state = 157, .external_lex_state = 2},
  [10954] = {.lex_state = 157, .external_lex_state = 2},
  [10955] = {.lex_state = 268, .external_lex_state = 5},
  [10956] = {.lex_state = 268, .external_lex_state = 5},
  [10957] = {.lex_state = 268, .external_lex_state = 5},
  [10958] = {.lex_state = 157, .external_lex_state = 29},
  [10959] = {.lex_state = 268, .external_lex_state = 5},
  [10960] = {.lex_state = 268, .external_lex_state = 5},
  [10961] = {.lex_state = 197, .external_lex_state = 14},
  [10962] = {.lex_state = 135, .external_lex_state = 2},
  [10963] = {.lex_state = 223, .external_lex_state = 9},
  [10964] = {.lex_state = 135},
  [10965] = {.lex_state = 223, .external_lex_state = 9},
  [10966] = {.lex_state = 197, .external_lex_state = 5},
  [10967] = {.lex_state = 197, .external_lex_state = 5},
  [10968] = {.lex_state = 197, .external_lex_state = 5},
  [10969] = {.lex_state = 157, .external_lex_state = 2},
  [10970] = {.lex_state = 157, .external_lex_state = 28},
  [10971] = {.lex_state = 157, .external_lex_state = 2},
  [10972] = {.lex_state = 157, .external_lex_state = 2},
  [10973] = {.lex_state = 157, .external_lex_state = 2},
  [10974] = {.lex_state = 157, .external_lex_state = 2},
  [10975] = {.lex_state = 157, .external_lex_state = 2},
  [10976] = {.lex_state = 157, .external_lex_state = 2},
  [10977] = {.lex_state = 157, .external_lex_state = 2},
  [10978] = {.lex_state = 157, .external_lex_state = 2},
  [10979] = {.lex_state = 157, .external_lex_state = 2},
  [10980] = {.lex_state = 157, .external_lex_state = 28},
  [10981] = {.lex_state = 197, .external_lex_state = 5},
  [10982] = {.lex_state = 208, .external_lex_state = 5},
  [10983] = {.lex_state = 208, .external_lex_state = 5},
  [10984] = {.lex_state = 208, .external_lex_state = 5},
  [10985] = {.lex_state = 208, .external_lex_state = 5},
  [10986] = {.lex_state = 157, .external_lex_state = 2},
  [10987] = {.lex_state = 157, .external_lex_state = 28},
  [10988] = {.lex_state = 157, .external_lex_state = 2},
  [10989] = {.lex_state = 157, .external_lex_state = 2},
  [10990] = {.lex_state = 157, .external_lex_state = 2},
  [10991] = {.lex_state = 157, .external_lex_state = 2},
  [10992] = {.lex_state = 157, .external_lex_state = 2},
  [10993] = {.lex_state = 157, .external_lex_state = 2},
  [10994] = {.lex_state = 157, .external_lex_state = 2},
  [10995] = {.lex_state = 157, .external_lex_state = 2},
  [10996] = {.lex_state = 157, .external_lex_state = 2},
  [10997] = {.lex_state = 208, .external_lex_state = 14},
  [10998] = {.lex_state = 268, .external_lex_state = 5},
  [10999] = {.lex_state = 268, .external_lex_state = 5},
  [11000] = {.lex_state = 157, .external_lex_state = 6},
  [11001] = {.lex_state = 208, .external_lex_state = 5},
  [11002] = {.lex_state = 208, .external_lex_state = 5},
  [11003] = {.lex_state = 208, .external_lex_state = 5},
  [11004] = {.lex_state = 268, .external_lex_state = 5},
  [11005] = {.lex_state = 268, .external_lex_state = 5},
  [11006] = {.lex_state = 268, .external_lex_state = 5},
  [11007] = {.lex_state = 359, .external_lex_state = 20},
  [11008] = {.lex_state = 268, .external_lex_state = 5},
  [11009] = {.lex_state = 268, .external_lex_state = 5},
  [11010] = {.lex_state = 268, .external_lex_state = 5},
  [11011] = {.lex_state = 268, .external_lex_state = 5},
  [11012] = {.lex_state = 268, .external_lex_state = 5},
  [11013] = {.lex_state = 268, .external_lex_state = 5},
  [11014] = {.lex_state = 268, .external_lex_state = 5},
  [11015] = {.lex_state = 268, .external_lex_state = 14},
  [11016] = {.lex_state = 157, .external_lex_state = 2},
  [11017] = {.lex_state = 135},
  [11018] = {.lex_state = 197, .external_lex_state = 5},
  [11019] = {.lex_state = 268, .external_lex_state = 5},
  [11020] = {.lex_state = 347, .external_lex_state = 9},
  [11021] = {.lex_state = 307, .external_lex_state = 5},
  [11022] = {.lex_state = 307, .external_lex_state = 5},
  [11023] = {.lex_state = 307, .external_lex_state = 5},
  [11024] = {.lex_state = 307, .external_lex_state = 5},
  [11025] = {.lex_state = 307, .external_lex_state = 5},
  [11026] = {.lex_state = 307, .external_lex_state = 5},
  [11027] = {.lex_state = 359, .external_lex_state = 20},
  [11028] = {.lex_state = 307, .external_lex_state = 5},
  [11029] = {.lex_state = 307, .external_lex_state = 5},
  [11030] = {.lex_state = 307, .external_lex_state = 5},
  [11031] = {.lex_state = 307, .external_lex_state = 5},
  [11032] = {.lex_state = 307, .external_lex_state = 5},
  [11033] = {.lex_state = 307, .external_lex_state = 5},
  [11034] = {.lex_state = 307, .external_lex_state = 5},
  [11035] = {.lex_state = 268, .external_lex_state = 5},
  [11036] = {.lex_state = 208, .external_lex_state = 5},
  [11037] = {.lex_state = 268, .external_lex_state = 5},
  [11038] = {.lex_state = 208, .external_lex_state = 5},
  [11039] = {.lex_state = 208, .external_lex_state = 5},
  [11040] = {.lex_state = 135},
  [11041] = {.lex_state = 135},
  [11042] = {.lex_state = 208, .external_lex_state = 5},
  [11043] = {.lex_state = 217, .external_lex_state = 4},
  [11044] = {.lex_state = 208, .external_lex_state = 5},
  [11045] = {.lex_state = 208, .external_lex_state = 5},
  [11046] = {.lex_state = 208, .external_lex_state = 5},
  [11047] = {.lex_state = 208, .external_lex_state = 5},
  [11048] = {.lex_state = 208, .external_lex_state = 5},
  [11049] = {.lex_state = 135},
  [11050] = {.lex_state = 208, .external_lex_state = 5},
  [11051] = {.lex_state = 217, .external_lex_state = 4},
  [11052] = {.lex_state = 208, .external_lex_state = 5},
  [11053] = {.lex_state = 208, .external_lex_state = 5},
  [11054] = {.lex_state = 208, .external_lex_state = 5},
  [11055] = {.lex_state = 135},
  [11056] = {.lex_state = 164, .external_lex_state = 3},
  [11057] = {.lex_state = 208, .external_lex_state = 5},
  [11058] = {.lex_state = 208, .external_lex_state = 5},
  [11059] = {.lex_state = 208, .external_lex_state = 5},
  [11060] = {.lex_state = 208, .external_lex_state = 5},
  [11061] = {.lex_state = 268, .external_lex_state = 5},
  [11062] = {.lex_state = 135},
  [11063] = {.lex_state = 268, .external_lex_state = 5},
  [11064] = {.lex_state = 268, .external_lex_state = 5},
  [11065] = {.lex_state = 363, .external_lex_state = 19},
  [11066] = {.lex_state = 363, .external_lex_state = 16},
  [11067] = {.lex_state = 363, .external_lex_state = 16},
  [11068] = {.lex_state = 157, .external_lex_state = 6},
  [11069] = {.lex_state = 363, .external_lex_state = 16},
  [11070] = {.lex_state = 363, .external_lex_state = 16},
  [11071] = {.lex_state = 363, .external_lex_state = 16},
  [11072] = {.lex_state = 363, .external_lex_state = 16},
  [11073] = {.lex_state = 363, .external_lex_state = 16},
  [11074] = {.lex_state = 363, .external_lex_state = 16},
  [11075] = {.lex_state = 363, .external_lex_state = 16},
  [11076] = {.lex_state = 363, .external_lex_state = 16},
  [11077] = {.lex_state = 363, .external_lex_state = 16},
  [11078] = {.lex_state = 363, .external_lex_state = 16},
  [11079] = {.lex_state = 363, .external_lex_state = 16},
  [11080] = {.lex_state = 363, .external_lex_state = 16},
  [11081] = {.lex_state = 359, .external_lex_state = 20},
  [11082] = {.lex_state = 363, .external_lex_state = 16},
  [11083] = {.lex_state = 363, .external_lex_state = 16},
  [11084] = {.lex_state = 363, .external_lex_state = 16},
  [11085] = {.lex_state = 363, .external_lex_state = 16},
  [11086] = {.lex_state = 363, .external_lex_state = 16},
  [11087] = {.lex_state = 366, .external_lex_state = 17},
  [11088] = {.lex_state = 266, .external_lex_state = 6},
  [11089] = {.lex_state = 366, .external_lex_state = 17},
  [11090] = {.lex_state = 366, .external_lex_state = 17},
  [11091] = {.lex_state = 300, .external_lex_state = 27},
  [11092] = {.lex_state = 366, .external_lex_state = 17},
  [11093] = {.lex_state = 363, .external_lex_state = 19},
  [11094] = {.lex_state = 157, .external_lex_state = 28},
  [11095] = {.lex_state = 363, .external_lex_state = 16},
  [11096] = {.lex_state = 157, .external_lex_state = 2},
  [11097] = {.lex_state = 381, .external_lex_state = 17},
  [11098] = {.lex_state = 135},
  [11099] = {.lex_state = 381, .external_lex_state = 17},
  [11100] = {.lex_state = 378, .external_lex_state = 16},
  [11101] = {.lex_state = 378, .external_lex_state = 16},
  [11102] = {.lex_state = 157, .external_lex_state = 6},
  [11103] = {.lex_state = 378, .external_lex_state = 16},
  [11104] = {.lex_state = 378, .external_lex_state = 16},
  [11105] = {.lex_state = 378, .external_lex_state = 16},
  [11106] = {.lex_state = 359, .external_lex_state = 20},
  [11107] = {.lex_state = 359, .external_lex_state = 20},
  [11108] = {.lex_state = 359, .external_lex_state = 20},
  [11109] = {.lex_state = 359, .external_lex_state = 20},
  [11110] = {.lex_state = 359, .external_lex_state = 20},
  [11111] = {.lex_state = 359, .external_lex_state = 20},
  [11112] = {.lex_state = 359, .external_lex_state = 20},
  [11113] = {.lex_state = 359, .external_lex_state = 20},
  [11114] = {.lex_state = 359, .external_lex_state = 20},
  [11115] = {.lex_state = 359, .external_lex_state = 20},
  [11116] = {.lex_state = 359, .external_lex_state = 20},
  [11117] = {.lex_state = 359, .external_lex_state = 20},
  [11118] = {.lex_state = 363, .external_lex_state = 23},
  [11119] = {.lex_state = 359, .external_lex_state = 20},
  [11120] = {.lex_state = 359, .external_lex_state = 20},
  [11121] = {.lex_state = 366, .external_lex_state = 21},
  [11122] = {.lex_state = 378, .external_lex_state = 19},
  [11123] = {.lex_state = 356, .external_lex_state = 16},
  [11124] = {.lex_state = 356, .external_lex_state = 16},
  [11125] = {.lex_state = 356, .external_lex_state = 16},
  [11126] = {.lex_state = 356, .external_lex_state = 16},
  [11127] = {.lex_state = 356, .external_lex_state = 16},
  [11128] = {.lex_state = 356, .external_lex_state = 16},
  [11129] = {.lex_state = 356, .external_lex_state = 16},
  [11130] = {.lex_state = 359, .external_lex_state = 20},
  [11131] = {.lex_state = 356, .external_lex_state = 16},
  [11132] = {.lex_state = 356, .external_lex_state = 16},
  [11133] = {.lex_state = 356, .external_lex_state = 16},
  [11134] = {.lex_state = 356, .external_lex_state = 16},
  [11135] = {.lex_state = 356, .external_lex_state = 16},
  [11136] = {.lex_state = 356, .external_lex_state = 19},
  [11137] = {.lex_state = 157, .external_lex_state = 28},
  [11138] = {.lex_state = 378, .external_lex_state = 16},
  [11139] = {.lex_state = 157, .external_lex_state = 2},
  [11140] = {.lex_state = 197, .external_lex_state = 5},
  [11141] = {.lex_state = 197, .external_lex_state = 5},
  [11142] = {.lex_state = 157, .external_lex_state = 6},
  [11143] = {.lex_state = 197, .external_lex_state = 5},
  [11144] = {.lex_state = 197, .external_lex_state = 5},
  [11145] = {.lex_state = 197, .external_lex_state = 5},
  [11146] = {.lex_state = 197, .external_lex_state = 5},
  [11147] = {.lex_state = 197, .external_lex_state = 5},
  [11148] = {.lex_state = 197, .external_lex_state = 5},
  [11149] = {.lex_state = 197, .external_lex_state = 5},
  [11150] = {.lex_state = 197, .external_lex_state = 5},
  [11151] = {.lex_state = 197, .external_lex_state = 5},
  [11152] = {.lex_state = 197, .external_lex_state = 5},
  [11153] = {.lex_state = 197, .external_lex_state = 5},
  [11154] = {.lex_state = 197, .external_lex_state = 5},
  [11155] = {.lex_state = 359, .external_lex_state = 20},
  [11156] = {.lex_state = 197, .external_lex_state = 5},
  [11157] = {.lex_state = 197, .external_lex_state = 5},
  [11158] = {.lex_state = 197, .external_lex_state = 5},
  [11159] = {.lex_state = 197, .external_lex_state = 5},
  [11160] = {.lex_state = 197, .external_lex_state = 5},
  [11161] = {.lex_state = 197, .external_lex_state = 14},
  [11162] = {.lex_state = 157, .external_lex_state = 28},
  [11163] = {.lex_state = 197, .external_lex_state = 5},
  [11164] = {.lex_state = 157, .external_lex_state = 2},
  [11165] = {.lex_state = 271, .external_lex_state = 9},
  [11166] = {.lex_state = 135},
  [11167] = {.lex_state = 271, .external_lex_state = 9},
  [11168] = {.lex_state = 268, .external_lex_state = 5},
  [11169] = {.lex_state = 268, .external_lex_state = 5},
  [11170] = {.lex_state = 157, .external_lex_state = 6},
  [11171] = {.lex_state = 268, .external_lex_state = 5},
  [11172] = {.lex_state = 268, .external_lex_state = 5},
  [11173] = {.lex_state = 268, .external_lex_state = 5},
  [11174] = {.lex_state = 223, .external_lex_state = 9},
  [11175] = {.lex_state = 197, .external_lex_state = 5},
  [11176] = {.lex_state = 197, .external_lex_state = 5},
  [11177] = {.lex_state = 197, .external_lex_state = 5},
  [11178] = {.lex_state = 197, .external_lex_state = 5},
  [11179] = {.lex_state = 197, .external_lex_state = 5},
  [11180] = {.lex_state = 197, .external_lex_state = 5},
  [11181] = {.lex_state = 359, .external_lex_state = 20},
  [11182] = {.lex_state = 197, .external_lex_state = 5},
  [11183] = {.lex_state = 197, .external_lex_state = 5},
  [11184] = {.lex_state = 197, .external_lex_state = 5},
  [11185] = {.lex_state = 197, .external_lex_state = 5},
  [11186] = {.lex_state = 197, .external_lex_state = 5},
  [11187] = {.lex_state = 197, .external_lex_state = 5},
  [11188] = {.lex_state = 208, .external_lex_state = 5},
  [11189] = {.lex_state = 208, .external_lex_state = 5},
  [11190] = {.lex_state = 208, .external_lex_state = 5},
  [11191] = {.lex_state = 208, .external_lex_state = 5},
  [11192] = {.lex_state = 208, .external_lex_state = 5},
  [11193] = {.lex_state = 208, .external_lex_state = 5},
  [11194] = {.lex_state = 208, .external_lex_state = 5},
  [11195] = {.lex_state = 359, .external_lex_state = 20},
  [11196] = {.lex_state = 208, .external_lex_state = 5},
  [11197] = {.lex_state = 208, .external_lex_state = 5},
  [11198] = {.lex_state = 208, .external_lex_state = 5},
  [11199] = {.lex_state = 208, .external_lex_state = 5},
  [11200] = {.lex_state = 208, .external_lex_state = 5},
  [11201] = {.lex_state = 208, .external_lex_state = 14},
  [11202] = {.lex_state = 157, .external_lex_state = 28},
  [11203] = {.lex_state = 268, .external_lex_state = 5},
  [11204] = {.lex_state = 157, .external_lex_state = 2},
  [11205] = {.lex_state = 197, .external_lex_state = 5},
  [11206] = {.lex_state = 197, .external_lex_state = 5},
  [11207] = {.lex_state = 197, .external_lex_state = 5},
  [11208] = {.lex_state = 197, .external_lex_state = 5},
  [11209] = {.lex_state = 208, .external_lex_state = 5},
  [11210] = {.lex_state = 208, .external_lex_state = 5},
  [11211] = {.lex_state = 307, .external_lex_state = 5},
  [11212] = {.lex_state = 307, .external_lex_state = 5},
  [11213] = {.lex_state = 157, .external_lex_state = 28},
  [11214] = {.lex_state = 307, .external_lex_state = 5},
  [11215] = {.lex_state = 157, .external_lex_state = 2},
  [11216] = {.lex_state = 307, .external_lex_state = 5},
  [11217] = {.lex_state = 307, .external_lex_state = 5},
  [11218] = {.lex_state = 157, .external_lex_state = 2},
  [11219] = {.lex_state = 157, .external_lex_state = 28},
  [11220] = {.lex_state = 313, .external_lex_state = 5},
  [11221] = {.lex_state = 157, .external_lex_state = 2},
  [11222] = {.lex_state = 350, .external_lex_state = 5},
  [11223] = {.lex_state = 350, .external_lex_state = 5},
  [11224] = {.lex_state = 197, .external_lex_state = 5},
  [11225] = {.lex_state = 197, .external_lex_state = 5},
  [11226] = {.lex_state = 197, .external_lex_state = 5},
  [11227] = {.lex_state = 197, .external_lex_state = 5},
  [11228] = {.lex_state = 157, .external_lex_state = 6},
  [11229] = {.lex_state = 197, .external_lex_state = 5},
  [11230] = {.lex_state = 197, .external_lex_state = 5},
  [11231] = {.lex_state = 197, .external_lex_state = 5},
  [11232] = {.lex_state = 197, .external_lex_state = 5},
  [11233] = {.lex_state = 197, .external_lex_state = 5},
  [11234] = {.lex_state = 197, .external_lex_state = 5},
  [11235] = {.lex_state = 197, .external_lex_state = 5},
  [11236] = {.lex_state = 197, .external_lex_state = 5},
  [11237] = {.lex_state = 197, .external_lex_state = 5},
  [11238] = {.lex_state = 197, .external_lex_state = 5},
  [11239] = {.lex_state = 197, .external_lex_state = 5},
  [11240] = {.lex_state = 197, .external_lex_state = 5},
  [11241] = {.lex_state = 359, .external_lex_state = 20},
  [11242] = {.lex_state = 197, .external_lex_state = 5},
  [11243] = {.lex_state = 197, .external_lex_state = 5},
  [11244] = {.lex_state = 197, .external_lex_state = 5},
  [11245] = {.lex_state = 197, .external_lex_state = 5},
  [11246] = {.lex_state = 197, .external_lex_state = 5},
  [11247] = {.lex_state = 197, .external_lex_state = 14},
  [11248] = {.lex_state = 157, .external_lex_state = 28},
  [11249] = {.lex_state = 197, .external_lex_state = 5},
  [11250] = {.lex_state = 157, .external_lex_state = 2},
  [11251] = {.lex_state = 271, .external_lex_state = 9},
  [11252] = {.lex_state = 135},
  [11253] = {.lex_state = 271, .external_lex_state = 9},
  [11254] = {.lex_state = 268, .external_lex_state = 5},
  [11255] = {.lex_state = 268, .external_lex_state = 5},
  [11256] = {.lex_state = 157, .external_lex_state = 6},
  [11257] = {.lex_state = 268, .external_lex_state = 5},
  [11258] = {.lex_state = 268, .external_lex_state = 5},
  [11259] = {.lex_state = 268, .external_lex_state = 5},
  [11260] = {.lex_state = 223, .external_lex_state = 9},
  [11261] = {.lex_state = 197, .external_lex_state = 5},
  [11262] = {.lex_state = 197, .external_lex_state = 5},
  [11263] = {.lex_state = 197, .external_lex_state = 5},
  [11264] = {.lex_state = 197, .external_lex_state = 5},
  [11265] = {.lex_state = 197, .external_lex_state = 5},
  [11266] = {.lex_state = 197, .external_lex_state = 5},
  [11267] = {.lex_state = 359, .external_lex_state = 20},
  [11268] = {.lex_state = 197, .external_lex_state = 5},
  [11269] = {.lex_state = 197, .external_lex_state = 5},
  [11270] = {.lex_state = 197, .external_lex_state = 5},
  [11271] = {.lex_state = 197, .external_lex_state = 5},
  [11272] = {.lex_state = 197, .external_lex_state = 5},
  [11273] = {.lex_state = 197, .external_lex_state = 5},
  [11274] = {.lex_state = 208, .external_lex_state = 5},
  [11275] = {.lex_state = 208, .external_lex_state = 5},
  [11276] = {.lex_state = 208, .external_lex_state = 5},
  [11277] = {.lex_state = 208, .external_lex_state = 5},
  [11278] = {.lex_state = 208, .external_lex_state = 5},
  [11279] = {.lex_state = 208, .external_lex_state = 5},
  [11280] = {.lex_state = 208, .external_lex_state = 5},
  [11281] = {.lex_state = 359, .external_lex_state = 20},
  [11282] = {.lex_state = 208, .external_lex_state = 5},
  [11283] = {.lex_state = 208, .external_lex_state = 5},
  [11284] = {.lex_state = 208, .external_lex_state = 5},
  [11285] = {.lex_state = 208, .external_lex_state = 5},
  [11286] = {.lex_state = 208, .external_lex_state = 5},
  [11287] = {.lex_state = 208, .external_lex_state = 14},
  [11288] = {.lex_state = 157, .external_lex_state = 28},
  [11289] = {.lex_state = 268, .external_lex_state = 5},
  [11290] = {.lex_state = 157, .external_lex_state = 2},
  [11291] = {.lex_state = 197, .external_lex_state = 5},
  [11292] = {.lex_state = 197, .external_lex_state = 5},
  [11293] = {.lex_state = 208, .external_lex_state = 5},
  [11294] = {.lex_state = 208, .external_lex_state = 5},
  [11295] = {.lex_state = 316, .external_lex_state = 20},
  [11296] = {.lex_state = 316, .external_lex_state = 20},
  [11297] = {.lex_state = 316, .external_lex_state = 20},
  [11298] = {.lex_state = 135},
  [11299] = {.lex_state = 316, .external_lex_state = 20},
  [11300] = {.lex_state = 307, .external_lex_state = 16},
  [11301] = {.lex_state = 307, .external_lex_state = 16},
  [11302] = {.lex_state = 157, .external_lex_state = 28},
  [11303] = {.lex_state = 307, .external_lex_state = 16},
  [11304] = {.lex_state = 157, .external_lex_state = 2},
  [11305] = {.lex_state = 310, .external_lex_state = 17},
  [11306] = {.lex_state = 135},
  [11307] = {.lex_state = 310, .external_lex_state = 17},
  [11308] = {.lex_state = 307, .external_lex_state = 16},
  [11309] = {.lex_state = 307, .external_lex_state = 16},
  [11310] = {.lex_state = 347, .external_lex_state = 17},
  [11311] = {.lex_state = 316, .external_lex_state = 20},
  [11312] = {.lex_state = 135},
  [11313] = {.lex_state = 316, .external_lex_state = 20},
  [11314] = {.lex_state = 316, .external_lex_state = 20},
  [11315] = {.lex_state = 157, .external_lex_state = 2},
  [11316] = {.lex_state = 319, .external_lex_state = 20},
  [11317] = {.lex_state = 135},
  [11318] = {.lex_state = 323, .external_lex_state = 16},
  [11319] = {.lex_state = 135},
  [11320] = {.lex_state = 323, .external_lex_state = 16},
  [11321] = {.lex_state = 135},
  [11322] = {.lex_state = 135},
  [11323] = {.lex_state = 135},
  [11324] = {.lex_state = 323, .external_lex_state = 16},
  [11325] = {.lex_state = 217, .external_lex_state = 4},
  [11326] = {.lex_state = 323, .external_lex_state = 16},
  [11327] = {.lex_state = 234, .external_lex_state = 15},
  [11328] = {.lex_state = 323, .external_lex_state = 16},
  [11329] = {.lex_state = 217, .external_lex_state = 4},
  [11330] = {.lex_state = 323, .external_lex_state = 16},
  [11331] = {.lex_state = 135},
  [11332] = {.lex_state = 135, .external_lex_state = 2},
  [11333] = {.lex_state = 323, .external_lex_state = 16},
  [11334] = {.lex_state = 135, .external_lex_state = 2},
  [11335] = {.lex_state = 323, .external_lex_state = 16},
  [11336] = {.lex_state = 323, .external_lex_state = 16},
  [11337] = {.lex_state = 135},
  [11338] = {.lex_state = 135},
  [11339] = {.lex_state = 323, .external_lex_state = 16},
  [11340] = {.lex_state = 217, .external_lex_state = 4},
  [11341] = {.lex_state = 323, .external_lex_state = 16},
  [11342] = {.lex_state = 234, .external_lex_state = 15},
  [11343] = {.lex_state = 323, .external_lex_state = 16},
  [11344] = {.lex_state = 217, .external_lex_state = 4},
  [11345] = {.lex_state = 323, .external_lex_state = 16},
  [11346] = {.lex_state = 323, .external_lex_state = 16},
  [11347] = {.lex_state = 135},
  [11348] = {.lex_state = 135, .external_lex_state = 2},
  [11349] = {.lex_state = 157},
  [11350] = {.lex_state = 323, .external_lex_state = 16},
  [11351] = {.lex_state = 323, .external_lex_state = 16},
  [11352] = {.lex_state = 323, .external_lex_state = 16},
  [11353] = {.lex_state = 135},
  [11354] = {.lex_state = 157, .external_lex_state = 28},
  [11355] = {.lex_state = 313, .external_lex_state = 16},
  [11356] = {.lex_state = 157, .external_lex_state = 2},
  [11357] = {.lex_state = 350, .external_lex_state = 16},
  [11358] = {.lex_state = 350, .external_lex_state = 16},
  [11359] = {.lex_state = 237, .external_lex_state = 16},
  [11360] = {.lex_state = 157, .external_lex_state = 28},
  [11361] = {.lex_state = 255, .external_lex_state = 16},
  [11362] = {.lex_state = 157, .external_lex_state = 2},
  [11363] = {.lex_state = 326, .external_lex_state = 16},
  [11364] = {.lex_state = 135},
  [11365] = {.lex_state = 326, .external_lex_state = 16},
  [11366] = {.lex_state = 326, .external_lex_state = 16},
  [11367] = {.lex_state = 326, .external_lex_state = 16},
  [11368] = {.lex_state = 326, .external_lex_state = 16},
  [11369] = {.lex_state = 326, .external_lex_state = 16},
  [11370] = {.lex_state = 135},
  [11371] = {.lex_state = 326, .external_lex_state = 16},
  [11372] = {.lex_state = 323, .external_lex_state = 16},
  [11373] = {.lex_state = 135},
  [11374] = {.lex_state = 157, .external_lex_state = 28},
  [11375] = {.lex_state = 329, .external_lex_state = 16},
  [11376] = {.lex_state = 157, .external_lex_state = 2},
  [11377] = {.lex_state = 237, .external_lex_state = 16},
  [11378] = {.lex_state = 242, .external_lex_state = 16},
  [11379] = {.lex_state = 242, .external_lex_state = 16},
  [11380] = {.lex_state = 242, .external_lex_state = 16},
  [11381] = {.lex_state = 242, .external_lex_state = 16},
  [11382] = {.lex_state = 242, .external_lex_state = 16},
  [11383] = {.lex_state = 135},
  [11384] = {.lex_state = 242, .external_lex_state = 16},
  [11385] = {.lex_state = 242, .external_lex_state = 16},
  [11386] = {.lex_state = 197, .external_lex_state = 20},
  [11387] = {.lex_state = 197, .external_lex_state = 20},
  [11388] = {.lex_state = 157, .external_lex_state = 28},
  [11389] = {.lex_state = 307, .external_lex_state = 16},
  [11390] = {.lex_state = 157, .external_lex_state = 2},
  [11391] = {.lex_state = 307, .external_lex_state = 16},
  [11392] = {.lex_state = 307, .external_lex_state = 16},
  [11393] = {.lex_state = 347, .external_lex_state = 17},
  [11394] = {.lex_state = 157, .external_lex_state = 28},
  [11395] = {.lex_state = 313, .external_lex_state = 16},
  [11396] = {.lex_state = 157, .external_lex_state = 2},
  [11397] = {.lex_state = 350, .external_lex_state = 16},
  [11398] = {.lex_state = 350, .external_lex_state = 16},
  [11399] = {.lex_state = 197, .external_lex_state = 20},
  [11400] = {.lex_state = 242, .external_lex_state = 20},
  [11401] = {.lex_state = 197, .external_lex_state = 16},
  [11402] = {.lex_state = 197, .external_lex_state = 16},
  [11403] = {.lex_state = 223, .external_lex_state = 17},
  [11404] = {.lex_state = 208, .external_lex_state = 16},
  [11405] = {.lex_state = 208, .external_lex_state = 16},
  [11406] = {.lex_state = 208, .external_lex_state = 16},
  [11407] = {.lex_state = 208, .external_lex_state = 16},
  [11408] = {.lex_state = 208, .external_lex_state = 16},
  [11409] = {.lex_state = 208, .external_lex_state = 16},
  [11410] = {.lex_state = 208, .external_lex_state = 16},
  [11411] = {.lex_state = 359, .external_lex_state = 20},
  [11412] = {.lex_state = 208, .external_lex_state = 16},
  [11413] = {.lex_state = 208, .external_lex_state = 16},
  [11414] = {.lex_state = 208, .external_lex_state = 16},
  [11415] = {.lex_state = 208, .external_lex_state = 16},
  [11416] = {.lex_state = 208, .external_lex_state = 16},
  [11417] = {.lex_state = 208, .external_lex_state = 19},
  [11418] = {.lex_state = 258},
  [11419] = {.lex_state = 258},
  [11420] = {.lex_state = 197, .external_lex_state = 16},
  [11421] = {.lex_state = 197, .external_lex_state = 16},
  [11422] = {.lex_state = 223, .external_lex_state = 17},
  [11423] = {.lex_state = 208, .external_lex_state = 16},
  [11424] = {.lex_state = 208, .external_lex_state = 16},
  [11425] = {.lex_state = 208, .external_lex_state = 16},
  [11426] = {.lex_state = 208, .external_lex_state = 16},
  [11427] = {.lex_state = 208, .external_lex_state = 16},
  [11428] = {.lex_state = 208, .external_lex_state = 16},
  [11429] = {.lex_state = 208, .external_lex_state = 16},
  [11430] = {.lex_state = 359, .external_lex_state = 20},
  [11431] = {.lex_state = 208, .external_lex_state = 16},
  [11432] = {.lex_state = 208, .external_lex_state = 16},
  [11433] = {.lex_state = 208, .external_lex_state = 16},
  [11434] = {.lex_state = 208, .external_lex_state = 16},
  [11435] = {.lex_state = 208, .external_lex_state = 16},
  [11436] = {.lex_state = 208, .external_lex_state = 19},
  [11437] = {.lex_state = 242, .external_lex_state = 16},
  [11438] = {.lex_state = 242, .external_lex_state = 16},
  [11439] = {.lex_state = 197, .external_lex_state = 16},
  [11440] = {.lex_state = 197, .external_lex_state = 19},
  [11441] = {.lex_state = 157, .external_lex_state = 2},
  [11442] = {.lex_state = 197, .external_lex_state = 16},
  [11443] = {.lex_state = 271, .external_lex_state = 17},
  [11444] = {.lex_state = 157, .external_lex_state = 2},
  [11445] = {.lex_state = 271, .external_lex_state = 17},
  [11446] = {.lex_state = 228},
  [11447] = {.lex_state = 157, .external_lex_state = 2},
  [11448] = {.lex_state = 157, .external_lex_state = 2},
  [11449] = {.lex_state = 157, .external_lex_state = 2},
  [11450] = {.lex_state = 197, .external_lex_state = 16},
  [11451] = {.lex_state = 197, .external_lex_state = 16},
  [11452] = {.lex_state = 197, .external_lex_state = 19},
  [11453] = {.lex_state = 197, .external_lex_state = 16},
  [11454] = {.lex_state = 220, .external_lex_state = 17},
  [11455] = {.lex_state = 220, .external_lex_state = 17},
  [11456] = {.lex_state = 157, .external_lex_state = 2},
  [11457] = {.lex_state = 157, .external_lex_state = 2},
  [11458] = {.lex_state = 220, .external_lex_state = 17},
  [11459] = {.lex_state = 157, .external_lex_state = 2},
  [11460] = {.lex_state = 164},
  [11461] = {.lex_state = 220, .external_lex_state = 17},
  [11462] = {.lex_state = 208, .external_lex_state = 16},
  [11463] = {.lex_state = 197, .external_lex_state = 16},
  [11464] = {.lex_state = 197, .external_lex_state = 16},
  [11465] = {.lex_state = 223, .external_lex_state = 17},
  [11466] = {.lex_state = 157},
  [11467] = {.lex_state = 197, .external_lex_state = 19},
  [11468] = {.lex_state = 197, .external_lex_state = 16},
  [11469] = {.lex_state = 197, .external_lex_state = 16},
  [11470] = {.lex_state = 157, .external_lex_state = 29},
  [11471] = {.lex_state = 197, .external_lex_state = 16},
  [11472] = {.lex_state = 197, .external_lex_state = 16},
  [11473] = {.lex_state = 157, .external_lex_state = 2},
  [11474] = {.lex_state = 157, .external_lex_state = 28},
  [11475] = {.lex_state = 157, .external_lex_state = 2},
  [11476] = {.lex_state = 157, .external_lex_state = 2},
  [11477] = {.lex_state = 157, .external_lex_state = 2},
  [11478] = {.lex_state = 157, .external_lex_state = 2},
  [11479] = {.lex_state = 157, .external_lex_state = 2},
  [11480] = {.lex_state = 157, .external_lex_state = 2},
  [11481] = {.lex_state = 157, .external_lex_state = 2},
  [11482] = {.lex_state = 157, .external_lex_state = 2},
  [11483] = {.lex_state = 157, .external_lex_state = 2},
  [11484] = {.lex_state = 300, .external_lex_state = 27},
  [11485] = {.lex_state = 164},
  [11486] = {.lex_state = 271, .external_lex_state = 17},
  [11487] = {.lex_state = 228},
  [11488] = {.lex_state = 157, .external_lex_state = 2},
  [11489] = {.lex_state = 157, .external_lex_state = 2},
  [11490] = {.lex_state = 157, .external_lex_state = 2},
  [11491] = {.lex_state = 268, .external_lex_state = 16},
  [11492] = {.lex_state = 268, .external_lex_state = 16},
  [11493] = {.lex_state = 268, .external_lex_state = 19},
  [11494] = {.lex_state = 268, .external_lex_state = 16},
  [11495] = {.lex_state = 197, .external_lex_state = 19},
  [11496] = {.lex_state = 197, .external_lex_state = 20},
  [11497] = {.lex_state = 157, .external_lex_state = 2},
  [11498] = {.lex_state = 197, .external_lex_state = 20},
  [11499] = {.lex_state = 197, .external_lex_state = 20},
  [11500] = {.lex_state = 197, .external_lex_state = 20},
  [11501] = {.lex_state = 197, .external_lex_state = 20},
  [11502] = {.lex_state = 197, .external_lex_state = 20},
  [11503] = {.lex_state = 197, .external_lex_state = 20},
  [11504] = {.lex_state = 359, .external_lex_state = 20},
  [11505] = {.lex_state = 197, .external_lex_state = 20},
  [11506] = {.lex_state = 197, .external_lex_state = 20},
  [11507] = {.lex_state = 197, .external_lex_state = 20},
  [11508] = {.lex_state = 197, .external_lex_state = 20},
  [11509] = {.lex_state = 197, .external_lex_state = 20},
  [11510] = {.lex_state = 223, .external_lex_state = 21},
  [11511] = {.lex_state = 266, .external_lex_state = 6},
  [11512] = {.lex_state = 223, .external_lex_state = 21},
  [11513] = {.lex_state = 223, .external_lex_state = 21},
  [11514] = {.lex_state = 300, .external_lex_state = 27},
  [11515] = {.lex_state = 223, .external_lex_state = 21},
  [11516] = {.lex_state = 268, .external_lex_state = 16},
  [11517] = {.lex_state = 268, .external_lex_state = 19},
  [11518] = {.lex_state = 157, .external_lex_state = 2},
  [11519] = {.lex_state = 268, .external_lex_state = 16},
  [11520] = {.lex_state = 157, .external_lex_state = 2},
  [11521] = {.lex_state = 223, .external_lex_state = 17},
  [11522] = {.lex_state = 223, .external_lex_state = 17},
  [11523] = {.lex_state = 157, .external_lex_state = 2},
  [11524] = {.lex_state = 157, .external_lex_state = 2},
  [11525] = {.lex_state = 223, .external_lex_state = 17},
  [11526] = {.lex_state = 157, .external_lex_state = 2},
  [11527] = {.lex_state = 223, .external_lex_state = 17},
  [11528] = {.lex_state = 208, .external_lex_state = 16},
  [11529] = {.lex_state = 208, .external_lex_state = 16},
  [11530] = {.lex_state = 208, .external_lex_state = 16},
  [11531] = {.lex_state = 223, .external_lex_state = 17},
  [11532] = {.lex_state = 157},
  [11533] = {.lex_state = 208, .external_lex_state = 19},
  [11534] = {.lex_state = 208, .external_lex_state = 16},
  [11535] = {.lex_state = 208, .external_lex_state = 16},
  [11536] = {.lex_state = 157, .external_lex_state = 28},
  [11537] = {.lex_state = 157, .external_lex_state = 29},
  [11538] = {.lex_state = 208, .external_lex_state = 16},
  [11539] = {.lex_state = 208, .external_lex_state = 16},
  [11540] = {.lex_state = 157, .external_lex_state = 2},
  [11541] = {.lex_state = 157, .external_lex_state = 2},
  [11542] = {.lex_state = 157, .external_lex_state = 2},
  [11543] = {.lex_state = 157, .external_lex_state = 2},
  [11544] = {.lex_state = 157, .external_lex_state = 2},
  [11545] = {.lex_state = 157, .external_lex_state = 2},
  [11546] = {.lex_state = 157, .external_lex_state = 2},
  [11547] = {.lex_state = 157, .external_lex_state = 2},
  [11548] = {.lex_state = 157, .external_lex_state = 2},
  [11549] = {.lex_state = 157, .external_lex_state = 2},
  [11550] = {.lex_state = 268, .external_lex_state = 19},
  [11551] = {.lex_state = 197, .external_lex_state = 23},
  [11552] = {.lex_state = 135, .external_lex_state = 10},
  [11553] = {.lex_state = 157},
  [11554] = {.lex_state = 157},
  [11555] = {.lex_state = 197, .external_lex_state = 5},
  [11556] = {.lex_state = 197, .external_lex_state = 5},
  [11557] = {.lex_state = 157, .external_lex_state = 28},
  [11558] = {.lex_state = 197, .external_lex_state = 5},
  [11559] = {.lex_state = 157, .external_lex_state = 2},
  [11560] = {.lex_state = 197, .external_lex_state = 5},
  [11561] = {.lex_state = 197, .external_lex_state = 5},
  [11562] = {.lex_state = 271, .external_lex_state = 9},
  [11563] = {.lex_state = 157, .external_lex_state = 2},
  [11564] = {.lex_state = 157, .external_lex_state = 28},
  [11565] = {.lex_state = 208, .external_lex_state = 5},
  [11566] = {.lex_state = 157, .external_lex_state = 2},
  [11567] = {.lex_state = 268, .external_lex_state = 5},
  [11568] = {.lex_state = 268, .external_lex_state = 5},
  [11569] = {.lex_state = 197, .external_lex_state = 20},
  [11570] = {.lex_state = 197, .external_lex_state = 20},
  [11571] = {.lex_state = 223, .external_lex_state = 21},
  [11572] = {.lex_state = 232, .external_lex_state = 2},
  [11573] = {.lex_state = 157},
  [11574] = {.lex_state = 157},
  [11575] = {.lex_state = 157, .external_lex_state = 2},
  [11576] = {.lex_state = 157, .external_lex_state = 28},
  [11577] = {.lex_state = 274, .external_lex_state = 16},
  [11578] = {.lex_state = 157, .external_lex_state = 2},
  [11579] = {.lex_state = 274, .external_lex_state = 16},
  [11580] = {.lex_state = 274, .external_lex_state = 16},
  [11581] = {.lex_state = 157, .external_lex_state = 28},
  [11582] = {.lex_state = 277, .external_lex_state = 16},
  [11583] = {.lex_state = 157, .external_lex_state = 2},
  [11584] = {.lex_state = 344, .external_lex_state = 16},
  [11585] = {.lex_state = 344, .external_lex_state = 16},
  [11586] = {.lex_state = 258, .external_lex_state = 13},
  [11587] = {.lex_state = 135},
  [11588] = {.lex_state = 135, .external_lex_state = 2},
  [11589] = {.lex_state = 258, .external_lex_state = 13},
  [11590] = {.lex_state = 197, .external_lex_state = 13},
  [11591] = {.lex_state = 197, .external_lex_state = 5},
  [11592] = {.lex_state = 197, .external_lex_state = 5},
  [11593] = {.lex_state = 274, .external_lex_state = 16},
  [11594] = {.lex_state = 274, .external_lex_state = 16},
  [11595] = {.lex_state = 223, .external_lex_state = 17},
  [11596] = {.lex_state = 268, .external_lex_state = 5},
  [11597] = {.lex_state = 197, .external_lex_state = 5},
  [11598] = {.lex_state = 197, .external_lex_state = 5},
  [11599] = {.lex_state = 197, .external_lex_state = 5},
  [11600] = {.lex_state = 197, .external_lex_state = 5},
  [11601] = {.lex_state = 197, .external_lex_state = 5},
  [11602] = {.lex_state = 197, .external_lex_state = 5},
  [11603] = {.lex_state = 197, .external_lex_state = 5},
  [11604] = {.lex_state = 197, .external_lex_state = 5},
  [11605] = {.lex_state = 197, .external_lex_state = 5},
  [11606] = {.lex_state = 197, .external_lex_state = 5},
  [11607] = {.lex_state = 359, .external_lex_state = 20},
  [11608] = {.lex_state = 197, .external_lex_state = 5},
  [11609] = {.lex_state = 197, .external_lex_state = 5},
  [11610] = {.lex_state = 197, .external_lex_state = 5},
  [11611] = {.lex_state = 197, .external_lex_state = 5},
  [11612] = {.lex_state = 197, .external_lex_state = 5},
  [11613] = {.lex_state = 197, .external_lex_state = 5},
  [11614] = {.lex_state = 197, .external_lex_state = 5},
  [11615] = {.lex_state = 223, .external_lex_state = 9},
  [11616] = {.lex_state = 197, .external_lex_state = 13},
  [11617] = {.lex_state = 197, .external_lex_state = 5},
  [11618] = {.lex_state = 197, .external_lex_state = 14},
  [11619] = {.lex_state = 157, .external_lex_state = 2},
  [11620] = {.lex_state = 197, .external_lex_state = 5},
  [11621] = {.lex_state = 271, .external_lex_state = 9},
  [11622] = {.lex_state = 157, .external_lex_state = 2},
  [11623] = {.lex_state = 271, .external_lex_state = 9},
  [11624] = {.lex_state = 228},
  [11625] = {.lex_state = 157, .external_lex_state = 2},
  [11626] = {.lex_state = 157, .external_lex_state = 2},
  [11627] = {.lex_state = 157, .external_lex_state = 2},
  [11628] = {.lex_state = 197, .external_lex_state = 5},
  [11629] = {.lex_state = 197, .external_lex_state = 5},
  [11630] = {.lex_state = 197, .external_lex_state = 14},
  [11631] = {.lex_state = 197, .external_lex_state = 5},
  [11632] = {.lex_state = 220, .external_lex_state = 9},
  [11633] = {.lex_state = 220, .external_lex_state = 9},
  [11634] = {.lex_state = 157, .external_lex_state = 2},
  [11635] = {.lex_state = 157, .external_lex_state = 2},
  [11636] = {.lex_state = 220, .external_lex_state = 9},
  [11637] = {.lex_state = 157, .external_lex_state = 2},
  [11638] = {.lex_state = 220, .external_lex_state = 9},
  [11639] = {.lex_state = 208, .external_lex_state = 5},
  [11640] = {.lex_state = 197, .external_lex_state = 5},
  [11641] = {.lex_state = 157},
  [11642] = {.lex_state = 197, .external_lex_state = 14},
  [11643] = {.lex_state = 197, .external_lex_state = 5},
  [11644] = {.lex_state = 197, .external_lex_state = 5},
  [11645] = {.lex_state = 157, .external_lex_state = 29},
  [11646] = {.lex_state = 197, .external_lex_state = 5},
  [11647] = {.lex_state = 197, .external_lex_state = 5},
  [11648] = {.lex_state = 157, .external_lex_state = 2},
  [11649] = {.lex_state = 157, .external_lex_state = 28},
  [11650] = {.lex_state = 157, .external_lex_state = 2},
  [11651] = {.lex_state = 157, .external_lex_state = 2},
  [11652] = {.lex_state = 157, .external_lex_state = 2},
  [11653] = {.lex_state = 157, .external_lex_state = 2},
  [11654] = {.lex_state = 157, .external_lex_state = 2},
  [11655] = {.lex_state = 157, .external_lex_state = 2},
  [11656] = {.lex_state = 157, .external_lex_state = 2},
  [11657] = {.lex_state = 157, .external_lex_state = 2},
  [11658] = {.lex_state = 157, .external_lex_state = 2},
  [11659] = {.lex_state = 300, .external_lex_state = 27},
  [11660] = {.lex_state = 164},
  [11661] = {.lex_state = 271, .external_lex_state = 9},
  [11662] = {.lex_state = 228},
  [11663] = {.lex_state = 157, .external_lex_state = 2},
  [11664] = {.lex_state = 157, .external_lex_state = 2},
  [11665] = {.lex_state = 157, .external_lex_state = 2},
  [11666] = {.lex_state = 268, .external_lex_state = 5},
  [11667] = {.lex_state = 268, .external_lex_state = 5},
  [11668] = {.lex_state = 268, .external_lex_state = 14},
  [11669] = {.lex_state = 268, .external_lex_state = 5},
  [11670] = {.lex_state = 197, .external_lex_state = 14},
  [11671] = {.lex_state = 197, .external_lex_state = 5},
  [11672] = {.lex_state = 197, .external_lex_state = 5},
  [11673] = {.lex_state = 197, .external_lex_state = 5},
  [11674] = {.lex_state = 135, .external_lex_state = 2},
  [11675] = {.lex_state = 217, .external_lex_state = 22},
  [11676] = {.lex_state = 197, .external_lex_state = 5},
  [11677] = {.lex_state = 197, .external_lex_state = 5},
  [11678] = {.lex_state = 223, .external_lex_state = 9},
  [11679] = {.lex_state = 266, .external_lex_state = 6},
  [11680] = {.lex_state = 223, .external_lex_state = 9},
  [11681] = {.lex_state = 223, .external_lex_state = 9},
  [11682] = {.lex_state = 300, .external_lex_state = 27},
  [11683] = {.lex_state = 223, .external_lex_state = 9},
  [11684] = {.lex_state = 157, .external_lex_state = 2},
  [11685] = {.lex_state = 157, .external_lex_state = 2},
  [11686] = {.lex_state = 157, .external_lex_state = 2},
  [11687] = {.lex_state = 157, .external_lex_state = 2},
  [11688] = {.lex_state = 208, .external_lex_state = 5},
  [11689] = {.lex_state = 197, .external_lex_state = 5},
  [11690] = {.lex_state = 157},
  [11691] = {.lex_state = 197, .external_lex_state = 5},
  [11692] = {.lex_state = 268, .external_lex_state = 5},
  [11693] = {.lex_state = 268, .external_lex_state = 14},
  [11694] = {.lex_state = 157, .external_lex_state = 2},
  [11695] = {.lex_state = 268, .external_lex_state = 5},
  [11696] = {.lex_state = 157, .external_lex_state = 2},
  [11697] = {.lex_state = 223, .external_lex_state = 9},
  [11698] = {.lex_state = 223, .external_lex_state = 9},
  [11699] = {.lex_state = 157, .external_lex_state = 2},
  [11700] = {.lex_state = 157, .external_lex_state = 2},
  [11701] = {.lex_state = 223, .external_lex_state = 9},
  [11702] = {.lex_state = 157, .external_lex_state = 2},
  [11703] = {.lex_state = 223, .external_lex_state = 9},
  [11704] = {.lex_state = 208, .external_lex_state = 5},
  [11705] = {.lex_state = 208, .external_lex_state = 5},
  [11706] = {.lex_state = 208, .external_lex_state = 5},
  [11707] = {.lex_state = 223, .external_lex_state = 9},
  [11708] = {.lex_state = 157},
  [11709] = {.lex_state = 208, .external_lex_state = 14},
  [11710] = {.lex_state = 208, .external_lex_state = 5},
  [11711] = {.lex_state = 208, .external_lex_state = 5},
  [11712] = {.lex_state = 157, .external_lex_state = 28},
  [11713] = {.lex_state = 157, .external_lex_state = 29},
  [11714] = {.lex_state = 208, .external_lex_state = 5},
  [11715] = {.lex_state = 208, .external_lex_state = 5},
  [11716] = {.lex_state = 157, .external_lex_state = 2},
  [11717] = {.lex_state = 157, .external_lex_state = 2},
  [11718] = {.lex_state = 157, .external_lex_state = 2},
  [11719] = {.lex_state = 157, .external_lex_state = 2},
  [11720] = {.lex_state = 157, .external_lex_state = 2},
  [11721] = {.lex_state = 157, .external_lex_state = 2},
  [11722] = {.lex_state = 157, .external_lex_state = 2},
  [11723] = {.lex_state = 157, .external_lex_state = 2},
  [11724] = {.lex_state = 157, .external_lex_state = 2},
  [11725] = {.lex_state = 157, .external_lex_state = 2},
  [11726] = {.lex_state = 268, .external_lex_state = 14},
  [11727] = {.lex_state = 197, .external_lex_state = 5},
  [11728] = {.lex_state = 197, .external_lex_state = 5},
  [11729] = {.lex_state = 197, .external_lex_state = 5},
  [11730] = {.lex_state = 197, .external_lex_state = 5},
  [11731] = {.lex_state = 197, .external_lex_state = 5},
  [11732] = {.lex_state = 359, .external_lex_state = 20},
  [11733] = {.lex_state = 197, .external_lex_state = 5},
  [11734] = {.lex_state = 197, .external_lex_state = 5},
  [11735] = {.lex_state = 197, .external_lex_state = 5},
  [11736] = {.lex_state = 197, .external_lex_state = 5},
  [11737] = {.lex_state = 197, .external_lex_state = 5},
  [11738] = {.lex_state = 197, .external_lex_state = 14},
  [11739] = {.lex_state = 135, .external_lex_state = 13},
  [11740] = {.lex_state = 208, .external_lex_state = 5},
  [11741] = {.lex_state = 208, .external_lex_state = 5},
  [11742] = {.lex_state = 208, .external_lex_state = 5},
  [11743] = {.lex_state = 208, .external_lex_state = 5},
  [11744] = {.lex_state = 208, .external_lex_state = 5},
  [11745] = {.lex_state = 208, .external_lex_state = 5},
  [11746] = {.lex_state = 208, .external_lex_state = 5},
  [11747] = {.lex_state = 359, .external_lex_state = 20},
  [11748] = {.lex_state = 208, .external_lex_state = 5},
  [11749] = {.lex_state = 208, .external_lex_state = 5},
  [11750] = {.lex_state = 208, .external_lex_state = 5},
  [11751] = {.lex_state = 208, .external_lex_state = 5},
  [11752] = {.lex_state = 208, .external_lex_state = 5},
  [11753] = {.lex_state = 208, .external_lex_state = 14},
  [11754] = {.lex_state = 274, .external_lex_state = 5},
  [11755] = {.lex_state = 274, .external_lex_state = 5},
  [11756] = {.lex_state = 372, .external_lex_state = 16},
  [11757] = {.lex_state = 372, .external_lex_state = 16},
  [11758] = {.lex_state = 157, .external_lex_state = 6},
  [11759] = {.lex_state = 372, .external_lex_state = 16},
  [11760] = {.lex_state = 372, .external_lex_state = 16},
  [11761] = {.lex_state = 372, .external_lex_state = 16},
  [11762] = {.lex_state = 157, .external_lex_state = 28},
  [11763] = {.lex_state = 372, .external_lex_state = 16},
  [11764] = {.lex_state = 157, .external_lex_state = 2},
  [11765] = {.lex_state = 274, .external_lex_state = 16},
  [11766] = {.lex_state = 274, .external_lex_state = 16},
  [11767] = {.lex_state = 274, .external_lex_state = 5},
  [11768] = {.lex_state = 277, .external_lex_state = 5},
  [11769] = {.lex_state = 277, .external_lex_state = 5},
  [11770] = {.lex_state = 197, .external_lex_state = 16},
  [11771] = {.lex_state = 197, .external_lex_state = 16},
  [11772] = {.lex_state = 197, .external_lex_state = 5},
  [11773] = {.lex_state = 197, .external_lex_state = 5},
  [11774] = {.lex_state = 258, .external_lex_state = 25},
  [11775] = {.lex_state = 197, .external_lex_state = 5},
  [11776] = {.lex_state = 197, .external_lex_state = 5},
  [11777] = {.lex_state = 157, .external_lex_state = 6},
  [11778] = {.lex_state = 197, .external_lex_state = 5},
  [11779] = {.lex_state = 197, .external_lex_state = 5},
  [11780] = {.lex_state = 197, .external_lex_state = 5},
  [11781] = {.lex_state = 157, .external_lex_state = 2},
  [11782] = {.lex_state = 157, .external_lex_state = 2},
  [11783] = {.lex_state = 197, .external_lex_state = 5},
  [11784] = {.lex_state = 197, .external_lex_state = 5},
  [11785] = {.lex_state = 197, .external_lex_state = 5},
  [11786] = {.lex_state = 157, .external_lex_state = 29},
  [11787] = {.lex_state = 197, .external_lex_state = 5},
  [11788] = {.lex_state = 197, .external_lex_state = 5},
  [11789] = {.lex_state = 197, .external_lex_state = 5},
  [11790] = {.lex_state = 197, .external_lex_state = 5},
  [11791] = {.lex_state = 197, .external_lex_state = 5},
  [11792] = {.lex_state = 197, .external_lex_state = 5},
  [11793] = {.lex_state = 197, .external_lex_state = 5},
  [11794] = {.lex_state = 197, .external_lex_state = 5},
  [11795] = {.lex_state = 197, .external_lex_state = 5},
  [11796] = {.lex_state = 359, .external_lex_state = 20},
  [11797] = {.lex_state = 197, .external_lex_state = 5},
  [11798] = {.lex_state = 197, .external_lex_state = 5},
  [11799] = {.lex_state = 197, .external_lex_state = 5},
  [11800] = {.lex_state = 197, .external_lex_state = 5},
  [11801] = {.lex_state = 197, .external_lex_state = 5},
  [11802] = {.lex_state = 197, .external_lex_state = 14},
  [11803] = {.lex_state = 157, .external_lex_state = 28},
  [11804] = {.lex_state = 197, .external_lex_state = 5},
  [11805] = {.lex_state = 258, .external_lex_state = 13},
  [11806] = {.lex_state = 258, .external_lex_state = 13},
  [11807] = {.lex_state = 157, .external_lex_state = 2},
  [11808] = {.lex_state = 268, .external_lex_state = 5},
  [11809] = {.lex_state = 268, .external_lex_state = 5},
  [11810] = {.lex_state = 197, .external_lex_state = 5},
  [11811] = {.lex_state = 197, .external_lex_state = 5},
  [11812] = {.lex_state = 157, .external_lex_state = 28},
  [11813] = {.lex_state = 197, .external_lex_state = 5},
  [11814] = {.lex_state = 157, .external_lex_state = 2},
  [11815] = {.lex_state = 197, .external_lex_state = 5},
  [11816] = {.lex_state = 197, .external_lex_state = 5},
  [11817] = {.lex_state = 271, .external_lex_state = 9},
  [11818] = {.lex_state = 157, .external_lex_state = 2},
  [11819] = {.lex_state = 157, .external_lex_state = 28},
  [11820] = {.lex_state = 208, .external_lex_state = 5},
  [11821] = {.lex_state = 157, .external_lex_state = 2},
  [11822] = {.lex_state = 268, .external_lex_state = 5},
  [11823] = {.lex_state = 268, .external_lex_state = 5},
  [11824] = {.lex_state = 197, .external_lex_state = 5},
  [11825] = {.lex_state = 197, .external_lex_state = 5},
  [11826] = {.lex_state = 197, .external_lex_state = 5},
  [11827] = {.lex_state = 208, .external_lex_state = 5},
  [11828] = {.lex_state = 208, .external_lex_state = 5},
  [11829] = {.lex_state = 316, .external_lex_state = 16},
  [11830] = {.lex_state = 316, .external_lex_state = 16},
  [11831] = {.lex_state = 197, .external_lex_state = 5},
  [11832] = {.lex_state = 197, .external_lex_state = 5},
  [11833] = {.lex_state = 157, .external_lex_state = 6},
  [11834] = {.lex_state = 197, .external_lex_state = 5},
  [11835] = {.lex_state = 197, .external_lex_state = 5},
  [11836] = {.lex_state = 197, .external_lex_state = 5},
  [11837] = {.lex_state = 197, .external_lex_state = 5},
  [11838] = {.lex_state = 197, .external_lex_state = 5},
  [11839] = {.lex_state = 197, .external_lex_state = 5},
  [11840] = {.lex_state = 197, .external_lex_state = 5},
  [11841] = {.lex_state = 197, .external_lex_state = 5},
  [11842] = {.lex_state = 197, .external_lex_state = 5},
  [11843] = {.lex_state = 197, .external_lex_state = 5},
  [11844] = {.lex_state = 197, .external_lex_state = 5},
  [11845] = {.lex_state = 197, .external_lex_state = 5},
  [11846] = {.lex_state = 359, .external_lex_state = 20},
  [11847] = {.lex_state = 197, .external_lex_state = 5},
  [11848] = {.lex_state = 197, .external_lex_state = 5},
  [11849] = {.lex_state = 197, .external_lex_state = 5},
  [11850] = {.lex_state = 197, .external_lex_state = 5},
  [11851] = {.lex_state = 197, .external_lex_state = 5},
  [11852] = {.lex_state = 197, .external_lex_state = 14},
  [11853] = {.lex_state = 157, .external_lex_state = 28},
  [11854] = {.lex_state = 197, .external_lex_state = 5},
  [11855] = {.lex_state = 157, .external_lex_state = 2},
  [11856] = {.lex_state = 271, .external_lex_state = 9},
  [11857] = {.lex_state = 135},
  [11858] = {.lex_state = 271, .external_lex_state = 9},
  [11859] = {.lex_state = 268, .external_lex_state = 5},
  [11860] = {.lex_state = 268, .external_lex_state = 5},
  [11861] = {.lex_state = 157, .external_lex_state = 6},
  [11862] = {.lex_state = 268, .external_lex_state = 5},
  [11863] = {.lex_state = 268, .external_lex_state = 5},
  [11864] = {.lex_state = 268, .external_lex_state = 5},
  [11865] = {.lex_state = 223, .external_lex_state = 9},
  [11866] = {.lex_state = 197, .external_lex_state = 5},
  [11867] = {.lex_state = 197, .external_lex_state = 5},
  [11868] = {.lex_state = 197, .external_lex_state = 5},
  [11869] = {.lex_state = 197, .external_lex_state = 5},
  [11870] = {.lex_state = 197, .external_lex_state = 5},
  [11871] = {.lex_state = 197, .external_lex_state = 5},
  [11872] = {.lex_state = 359, .external_lex_state = 20},
  [11873] = {.lex_state = 197, .external_lex_state = 5},
  [11874] = {.lex_state = 197, .external_lex_state = 5},
  [11875] = {.lex_state = 197, .external_lex_state = 5},
  [11876] = {.lex_state = 197, .external_lex_state = 5},
  [11877] = {.lex_state = 197, .external_lex_state = 5},
  [11878] = {.lex_state = 197, .external_lex_state = 5},
  [11879] = {.lex_state = 208, .external_lex_state = 5},
  [11880] = {.lex_state = 208, .external_lex_state = 5},
  [11881] = {.lex_state = 208, .external_lex_state = 5},
  [11882] = {.lex_state = 208, .external_lex_state = 5},
  [11883] = {.lex_state = 208, .external_lex_state = 5},
  [11884] = {.lex_state = 208, .external_lex_state = 5},
  [11885] = {.lex_state = 208, .external_lex_state = 5},
  [11886] = {.lex_state = 359, .external_lex_state = 20},
  [11887] = {.lex_state = 208, .external_lex_state = 5},
  [11888] = {.lex_state = 208, .external_lex_state = 5},
  [11889] = {.lex_state = 208, .external_lex_state = 5},
  [11890] = {.lex_state = 208, .external_lex_state = 5},
  [11891] = {.lex_state = 208, .external_lex_state = 5},
  [11892] = {.lex_state = 208, .external_lex_state = 14},
  [11893] = {.lex_state = 157, .external_lex_state = 28},
  [11894] = {.lex_state = 268, .external_lex_state = 5},
  [11895] = {.lex_state = 157, .external_lex_state = 2},
  [11896] = {.lex_state = 197, .external_lex_state = 5},
  [11897] = {.lex_state = 157, .external_lex_state = 2},
  [11898] = {.lex_state = 208, .external_lex_state = 5},
  [11899] = {.lex_state = 135},
  [11900] = {.lex_state = 208, .external_lex_state = 5},
  [11901] = {.lex_state = 208, .external_lex_state = 5},
  [11902] = {.lex_state = 208, .external_lex_state = 5},
  [11903] = {.lex_state = 208, .external_lex_state = 5},
  [11904] = {.lex_state = 208, .external_lex_state = 5},
  [11905] = {.lex_state = 268, .external_lex_state = 5},
  [11906] = {.lex_state = 363, .external_lex_state = 16},
  [11907] = {.lex_state = 363, .external_lex_state = 16},
  [11908] = {.lex_state = 157, .external_lex_state = 28},
  [11909] = {.lex_state = 363, .external_lex_state = 16},
  [11910] = {.lex_state = 157, .external_lex_state = 2},
  [11911] = {.lex_state = 366, .external_lex_state = 17},
  [11912] = {.lex_state = 135},
  [11913] = {.lex_state = 366, .external_lex_state = 17},
  [11914] = {.lex_state = 363, .external_lex_state = 16},
  [11915] = {.lex_state = 363, .external_lex_state = 16},
  [11916] = {.lex_state = 381, .external_lex_state = 17},
  [11917] = {.lex_state = 157, .external_lex_state = 2},
  [11918] = {.lex_state = 157, .external_lex_state = 28},
  [11919] = {.lex_state = 356, .external_lex_state = 16},
  [11920] = {.lex_state = 157, .external_lex_state = 2},
  [11921] = {.lex_state = 378, .external_lex_state = 16},
  [11922] = {.lex_state = 378, .external_lex_state = 16},
  [11923] = {.lex_state = 197, .external_lex_state = 5},
  [11924] = {.lex_state = 197, .external_lex_state = 5},
  [11925] = {.lex_state = 157, .external_lex_state = 28},
  [11926] = {.lex_state = 197, .external_lex_state = 5},
  [11927] = {.lex_state = 157, .external_lex_state = 2},
  [11928] = {.lex_state = 197, .external_lex_state = 5},
  [11929] = {.lex_state = 197, .external_lex_state = 5},
  [11930] = {.lex_state = 271, .external_lex_state = 9},
  [11931] = {.lex_state = 157, .external_lex_state = 2},
  [11932] = {.lex_state = 157, .external_lex_state = 28},
  [11933] = {.lex_state = 208, .external_lex_state = 5},
  [11934] = {.lex_state = 157, .external_lex_state = 2},
  [11935] = {.lex_state = 268, .external_lex_state = 5},
  [11936] = {.lex_state = 268, .external_lex_state = 5},
  [11937] = {.lex_state = 307, .external_lex_state = 5},
  [11938] = {.lex_state = 307, .external_lex_state = 5},
  [11939] = {.lex_state = 307, .external_lex_state = 5},
  [11940] = {.lex_state = 313, .external_lex_state = 5},
  [11941] = {.lex_state = 313, .external_lex_state = 5},
  [11942] = {.lex_state = 197, .external_lex_state = 5},
  [11943] = {.lex_state = 197, .external_lex_state = 5},
  [11944] = {.lex_state = 157, .external_lex_state = 28},
  [11945] = {.lex_state = 197, .external_lex_state = 5},
  [11946] = {.lex_state = 157, .external_lex_state = 2},
  [11947] = {.lex_state = 197, .external_lex_state = 5},
  [11948] = {.lex_state = 197, .external_lex_state = 5},
  [11949] = {.lex_state = 271, .external_lex_state = 9},
  [11950] = {.lex_state = 157, .external_lex_state = 2},
  [11951] = {.lex_state = 157, .external_lex_state = 28},
  [11952] = {.lex_state = 208, .external_lex_state = 5},
  [11953] = {.lex_state = 157, .external_lex_state = 2},
  [11954] = {.lex_state = 268, .external_lex_state = 5},
  [11955] = {.lex_state = 268, .external_lex_state = 5},
  [11956] = {.lex_state = 316, .external_lex_state = 20},
  [11957] = {.lex_state = 307, .external_lex_state = 16},
  [11958] = {.lex_state = 307, .external_lex_state = 16},
  [11959] = {.lex_state = 310, .external_lex_state = 17},
  [11960] = {.lex_state = 316, .external_lex_state = 20},
  [11961] = {.lex_state = 307, .external_lex_state = 20},
  [11962] = {.lex_state = 319, .external_lex_state = 20},
  [11963] = {.lex_state = 323, .external_lex_state = 16},
  [11964] = {.lex_state = 323, .external_lex_state = 16},
  [11965] = {.lex_state = 135},
  [11966] = {.lex_state = 135},
  [11967] = {.lex_state = 323, .external_lex_state = 16},
  [11968] = {.lex_state = 217, .external_lex_state = 4},
  [11969] = {.lex_state = 323, .external_lex_state = 16},
  [11970] = {.lex_state = 323, .external_lex_state = 16},
  [11971] = {.lex_state = 323, .external_lex_state = 16},
  [11972] = {.lex_state = 323, .external_lex_state = 16},
  [11973] = {.lex_state = 323, .external_lex_state = 16},
  [11974] = {.lex_state = 135},
  [11975] = {.lex_state = 323, .external_lex_state = 16},
  [11976] = {.lex_state = 217, .external_lex_state = 4},
  [11977] = {.lex_state = 323, .external_lex_state = 16},
  [11978] = {.lex_state = 323, .external_lex_state = 16},
  [11979] = {.lex_state = 323, .external_lex_state = 16},
  [11980] = {.lex_state = 135},
  [11981] = {.lex_state = 164, .external_lex_state = 3},
  [11982] = {.lex_state = 323, .external_lex_state = 16},
  [11983] = {.lex_state = 323, .external_lex_state = 16},
  [11984] = {.lex_state = 313, .external_lex_state = 16},
  [11985] = {.lex_state = 313, .external_lex_state = 16},
  [11986] = {.lex_state = 255, .external_lex_state = 16},
  [11987] = {.lex_state = 255, .external_lex_state = 16},
  [11988] = {.lex_state = 326, .external_lex_state = 16},
  [11989] = {.lex_state = 326, .external_lex_state = 16},
  [11990] = {.lex_state = 323, .external_lex_state = 16},
  [11991] = {.lex_state = 329, .external_lex_state = 16},
  [11992] = {.lex_state = 329, .external_lex_state = 16},
  [11993] = {.lex_state = 242, .external_lex_state = 16},
  [11994] = {.lex_state = 307, .external_lex_state = 16},
  [11995] = {.lex_state = 307, .external_lex_state = 16},
  [11996] = {.lex_state = 313, .external_lex_state = 16},
  [11997] = {.lex_state = 313, .external_lex_state = 16},
  [11998] = {.lex_state = 157, .external_lex_state = 28},
  [11999] = {.lex_state = 208, .external_lex_state = 16},
  [12000] = {.lex_state = 157, .external_lex_state = 2},
  [12001] = {.lex_state = 157, .external_lex_state = 28},
  [12002] = {.lex_state = 208, .external_lex_state = 16},
  [12003] = {.lex_state = 157, .external_lex_state = 2},
  [12004] = {.lex_state = 197, .external_lex_state = 16},
  [12005] = {.lex_state = 197, .external_lex_state = 16},
  [12006] = {.lex_state = 157, .external_lex_state = 2},
  [12007] = {.lex_state = 157, .external_lex_state = 2},
  [12008] = {.lex_state = 197, .external_lex_state = 16},
  [12009] = {.lex_state = 197, .external_lex_state = 16},
  [12010] = {.lex_state = 197, .external_lex_state = 16},
  [12011] = {.lex_state = 157, .external_lex_state = 29},
  [12012] = {.lex_state = 197, .external_lex_state = 16},
  [12013] = {.lex_state = 197, .external_lex_state = 16},
  [12014] = {.lex_state = 197, .external_lex_state = 16},
  [12015] = {.lex_state = 197, .external_lex_state = 16},
  [12016] = {.lex_state = 223, .external_lex_state = 17},
  [12017] = {.lex_state = 157, .external_lex_state = 2},
  [12018] = {.lex_state = 157, .external_lex_state = 28},
  [12019] = {.lex_state = 157, .external_lex_state = 2},
  [12020] = {.lex_state = 157, .external_lex_state = 2},
  [12021] = {.lex_state = 157, .external_lex_state = 2},
  [12022] = {.lex_state = 157, .external_lex_state = 2},
  [12023] = {.lex_state = 157, .external_lex_state = 2},
  [12024] = {.lex_state = 157, .external_lex_state = 2},
  [12025] = {.lex_state = 157, .external_lex_state = 2},
  [12026] = {.lex_state = 157, .external_lex_state = 2},
  [12027] = {.lex_state = 157, .external_lex_state = 2},
  [12028] = {.lex_state = 300, .external_lex_state = 27},
  [12029] = {.lex_state = 164},
  [12030] = {.lex_state = 197, .external_lex_state = 19},
  [12031] = {.lex_state = 157, .external_lex_state = 6},
  [12032] = {.lex_state = 197, .external_lex_state = 16},
  [12033] = {.lex_state = 197, .external_lex_state = 16},
  [12034] = {.lex_state = 197, .external_lex_state = 16},
  [12035] = {.lex_state = 197, .external_lex_state = 16},
  [12036] = {.lex_state = 197, .external_lex_state = 16},
  [12037] = {.lex_state = 197, .external_lex_state = 16},
  [12038] = {.lex_state = 197, .external_lex_state = 16},
  [12039] = {.lex_state = 197, .external_lex_state = 16},
  [12040] = {.lex_state = 359, .external_lex_state = 20},
  [12041] = {.lex_state = 197, .external_lex_state = 16},
  [12042] = {.lex_state = 197, .external_lex_state = 16},
  [12043] = {.lex_state = 197, .external_lex_state = 16},
  [12044] = {.lex_state = 197, .external_lex_state = 16},
  [12045] = {.lex_state = 197, .external_lex_state = 16},
  [12046] = {.lex_state = 197, .external_lex_state = 16},
  [12047] = {.lex_state = 197, .external_lex_state = 16},
  [12048] = {.lex_state = 271, .external_lex_state = 17},
  [12049] = {.lex_state = 266, .external_lex_state = 6},
  [12050] = {.lex_state = 271, .external_lex_state = 17},
  [12051] = {.lex_state = 271, .external_lex_state = 17},
  [12052] = {.lex_state = 300, .external_lex_state = 27},
  [12053] = {.lex_state = 271, .external_lex_state = 17},
  [12054] = {.lex_state = 157, .external_lex_state = 2},
  [12055] = {.lex_state = 157, .external_lex_state = 2},
  [12056] = {.lex_state = 268, .external_lex_state = 16},
  [12057] = {.lex_state = 268, .external_lex_state = 16},
  [12058] = {.lex_state = 268, .external_lex_state = 16},
  [12059] = {.lex_state = 157, .external_lex_state = 29},
  [12060] = {.lex_state = 268, .external_lex_state = 16},
  [12061] = {.lex_state = 268, .external_lex_state = 16},
  [12062] = {.lex_state = 197, .external_lex_state = 19},
  [12063] = {.lex_state = 197, .external_lex_state = 20},
  [12064] = {.lex_state = 157, .external_lex_state = 28},
  [12065] = {.lex_state = 197, .external_lex_state = 20},
  [12066] = {.lex_state = 157, .external_lex_state = 2},
  [12067] = {.lex_state = 223, .external_lex_state = 21},
  [12068] = {.lex_state = 135},
  [12069] = {.lex_state = 223, .external_lex_state = 21},
  [12070] = {.lex_state = 208, .external_lex_state = 16},
  [12071] = {.lex_state = 208, .external_lex_state = 16},
  [12072] = {.lex_state = 208, .external_lex_state = 16},
  [12073] = {.lex_state = 208, .external_lex_state = 16},
  [12074] = {.lex_state = 157, .external_lex_state = 2},
  [12075] = {.lex_state = 157, .external_lex_state = 28},
  [12076] = {.lex_state = 157, .external_lex_state = 2},
  [12077] = {.lex_state = 157, .external_lex_state = 2},
  [12078] = {.lex_state = 157, .external_lex_state = 2},
  [12079] = {.lex_state = 157, .external_lex_state = 2},
  [12080] = {.lex_state = 157, .external_lex_state = 2},
  [12081] = {.lex_state = 157, .external_lex_state = 2},
  [12082] = {.lex_state = 157, .external_lex_state = 2},
  [12083] = {.lex_state = 157, .external_lex_state = 2},
  [12084] = {.lex_state = 157, .external_lex_state = 2},
  [12085] = {.lex_state = 208, .external_lex_state = 19},
  [12086] = {.lex_state = 268, .external_lex_state = 16},
  [12087] = {.lex_state = 268, .external_lex_state = 16},
  [12088] = {.lex_state = 157, .external_lex_state = 6},
  [12089] = {.lex_state = 208, .external_lex_state = 16},
  [12090] = {.lex_state = 208, .external_lex_state = 16},
  [12091] = {.lex_state = 208, .external_lex_state = 16},
  [12092] = {.lex_state = 268, .external_lex_state = 16},
  [12093] = {.lex_state = 268, .external_lex_state = 16},
  [12094] = {.lex_state = 268, .external_lex_state = 16},
  [12095] = {.lex_state = 359, .external_lex_state = 20},
  [12096] = {.lex_state = 268, .external_lex_state = 16},
  [12097] = {.lex_state = 268, .external_lex_state = 16},
  [12098] = {.lex_state = 268, .external_lex_state = 16},
  [12099] = {.lex_state = 268, .external_lex_state = 16},
  [12100] = {.lex_state = 268, .external_lex_state = 16},
  [12101] = {.lex_state = 268, .external_lex_state = 16},
  [12102] = {.lex_state = 268, .external_lex_state = 16},
  [12103] = {.lex_state = 268, .external_lex_state = 19},
  [12104] = {.lex_state = 135, .external_lex_state = 10},
  [12105] = {.lex_state = 157},
  [12106] = {.lex_state = 197, .external_lex_state = 5},
  [12107] = {.lex_state = 197, .external_lex_state = 5},
  [12108] = {.lex_state = 197, .external_lex_state = 5},
  [12109] = {.lex_state = 208, .external_lex_state = 5},
  [12110] = {.lex_state = 208, .external_lex_state = 5},
  [12111] = {.lex_state = 232, .external_lex_state = 2},
  [12112] = {.lex_state = 157},
  [12113] = {.lex_state = 274, .external_lex_state = 20},
  [12114] = {.lex_state = 274, .external_lex_state = 16},
  [12115] = {.lex_state = 274, .external_lex_state = 16},
  [12116] = {.lex_state = 277, .external_lex_state = 16},
  [12117] = {.lex_state = 277, .external_lex_state = 16},
  [12118] = {.lex_state = 258, .external_lex_state = 13},
  [12119] = {.lex_state = 135},
  [12120] = {.lex_state = 157, .external_lex_state = 28},
  [12121] = {.lex_state = 197, .external_lex_state = 5},
  [12122] = {.lex_state = 157, .external_lex_state = 2},
  [12123] = {.lex_state = 197, .external_lex_state = 13},
  [12124] = {.lex_state = 197, .external_lex_state = 5},
  [12125] = {.lex_state = 197, .external_lex_state = 5},
  [12126] = {.lex_state = 157, .external_lex_state = 2},
  [12127] = {.lex_state = 157, .external_lex_state = 2},
  [12128] = {.lex_state = 197, .external_lex_state = 5},
  [12129] = {.lex_state = 197, .external_lex_state = 5},
  [12130] = {.lex_state = 197, .external_lex_state = 5},
  [12131] = {.lex_state = 157, .external_lex_state = 29},
  [12132] = {.lex_state = 197, .external_lex_state = 5},
  [12133] = {.lex_state = 197, .external_lex_state = 5},
  [12134] = {.lex_state = 197, .external_lex_state = 5},
  [12135] = {.lex_state = 197, .external_lex_state = 5},
  [12136] = {.lex_state = 197, .external_lex_state = 5},
  [12137] = {.lex_state = 197, .external_lex_state = 5},
  [12138] = {.lex_state = 157, .external_lex_state = 2},
  [12139] = {.lex_state = 157, .external_lex_state = 28},
  [12140] = {.lex_state = 157, .external_lex_state = 2},
  [12141] = {.lex_state = 157, .external_lex_state = 2},
  [12142] = {.lex_state = 157, .external_lex_state = 2},
  [12143] = {.lex_state = 157, .external_lex_state = 2},
  [12144] = {.lex_state = 157, .external_lex_state = 2},
  [12145] = {.lex_state = 157, .external_lex_state = 2},
  [12146] = {.lex_state = 157, .external_lex_state = 2},
  [12147] = {.lex_state = 157, .external_lex_state = 2},
  [12148] = {.lex_state = 157, .external_lex_state = 2},
  [12149] = {.lex_state = 197, .external_lex_state = 14},
  [12150] = {.lex_state = 157, .external_lex_state = 6},
  [12151] = {.lex_state = 197, .external_lex_state = 5},
  [12152] = {.lex_state = 197, .external_lex_state = 5},
  [12153] = {.lex_state = 197, .external_lex_state = 5},
  [12154] = {.lex_state = 197, .external_lex_state = 5},
  [12155] = {.lex_state = 197, .external_lex_state = 5},
  [12156] = {.lex_state = 197, .external_lex_state = 5},
  [12157] = {.lex_state = 197, .external_lex_state = 5},
  [12158] = {.lex_state = 197, .external_lex_state = 5},
  [12159] = {.lex_state = 359, .external_lex_state = 20},
  [12160] = {.lex_state = 197, .external_lex_state = 5},
  [12161] = {.lex_state = 197, .external_lex_state = 5},
  [12162] = {.lex_state = 197, .external_lex_state = 5},
  [12163] = {.lex_state = 197, .external_lex_state = 5},
  [12164] = {.lex_state = 197, .external_lex_state = 5},
  [12165] = {.lex_state = 197, .external_lex_state = 5},
  [12166] = {.lex_state = 197, .external_lex_state = 5},
  [12167] = {.lex_state = 271, .external_lex_state = 9},
  [12168] = {.lex_state = 266, .external_lex_state = 6},
  [12169] = {.lex_state = 271, .external_lex_state = 9},
  [12170] = {.lex_state = 271, .external_lex_state = 9},
  [12171] = {.lex_state = 300, .external_lex_state = 27},
  [12172] = {.lex_state = 271, .external_lex_state = 9},
  [12173] = {.lex_state = 157, .external_lex_state = 2},
  [12174] = {.lex_state = 157, .external_lex_state = 2},
  [12175] = {.lex_state = 268, .external_lex_state = 5},
  [12176] = {.lex_state = 268, .external_lex_state = 5},
  [12177] = {.lex_state = 268, .external_lex_state = 5},
  [12178] = {.lex_state = 157, .external_lex_state = 29},
  [12179] = {.lex_state = 268, .external_lex_state = 5},
  [12180] = {.lex_state = 268, .external_lex_state = 5},
  [12181] = {.lex_state = 197, .external_lex_state = 14},
  [12182] = {.lex_state = 135, .external_lex_state = 2},
  [12183] = {.lex_state = 223, .external_lex_state = 9},
  [12184] = {.lex_state = 135},
  [12185] = {.lex_state = 223, .external_lex_state = 9},
  [12186] = {.lex_state = 197, .external_lex_state = 5},
  [12187] = {.lex_state = 197, .external_lex_state = 5},
  [12188] = {.lex_state = 197, .external_lex_state = 5},
  [12189] = {.lex_state = 157, .external_lex_state = 2},
  [12190] = {.lex_state = 157, .external_lex_state = 28},
  [12191] = {.lex_state = 157, .external_lex_state = 2},
  [12192] = {.lex_state = 157, .external_lex_state = 2},
  [12193] = {.lex_state = 157, .external_lex_state = 2},
  [12194] = {.lex_state = 157, .external_lex_state = 2},
  [12195] = {.lex_state = 157, .external_lex_state = 2},
  [12196] = {.lex_state = 157, .external_lex_state = 2},
  [12197] = {.lex_state = 157, .external_lex_state = 2},
  [12198] = {.lex_state = 157, .external_lex_state = 2},
  [12199] = {.lex_state = 157, .external_lex_state = 2},
  [12200] = {.lex_state = 157, .external_lex_state = 28},
  [12201] = {.lex_state = 197, .external_lex_state = 5},
  [12202] = {.lex_state = 208, .external_lex_state = 5},
  [12203] = {.lex_state = 208, .external_lex_state = 5},
  [12204] = {.lex_state = 208, .external_lex_state = 5},
  [12205] = {.lex_state = 208, .external_lex_state = 5},
  [12206] = {.lex_state = 157, .external_lex_state = 2},
  [12207] = {.lex_state = 157, .external_lex_state = 28},
  [12208] = {.lex_state = 157, .external_lex_state = 2},
  [12209] = {.lex_state = 157, .external_lex_state = 2},
  [12210] = {.lex_state = 157, .external_lex_state = 2},
  [12211] = {.lex_state = 157, .external_lex_state = 2},
  [12212] = {.lex_state = 157, .external_lex_state = 2},
  [12213] = {.lex_state = 157, .external_lex_state = 2},
  [12214] = {.lex_state = 157, .external_lex_state = 2},
  [12215] = {.lex_state = 157, .external_lex_state = 2},
  [12216] = {.lex_state = 157, .external_lex_state = 2},
  [12217] = {.lex_state = 208, .external_lex_state = 14},
  [12218] = {.lex_state = 268, .external_lex_state = 5},
  [12219] = {.lex_state = 268, .external_lex_state = 5},
  [12220] = {.lex_state = 157, .external_lex_state = 6},
  [12221] = {.lex_state = 208, .external_lex_state = 5},
  [12222] = {.lex_state = 208, .external_lex_state = 5},
  [12223] = {.lex_state = 208, .external_lex_state = 5},
  [12224] = {.lex_state = 268, .external_lex_state = 5},
  [12225] = {.lex_state = 268, .external_lex_state = 5},
  [12226] = {.lex_state = 268, .external_lex_state = 5},
  [12227] = {.lex_state = 359, .external_lex_state = 20},
  [12228] = {.lex_state = 268, .external_lex_state = 5},
  [12229] = {.lex_state = 268, .external_lex_state = 5},
  [12230] = {.lex_state = 268, .external_lex_state = 5},
  [12231] = {.lex_state = 268, .external_lex_state = 5},
  [12232] = {.lex_state = 268, .external_lex_state = 5},
  [12233] = {.lex_state = 268, .external_lex_state = 5},
  [12234] = {.lex_state = 268, .external_lex_state = 5},
  [12235] = {.lex_state = 268, .external_lex_state = 14},
  [12236] = {.lex_state = 157, .external_lex_state = 2},
  [12237] = {.lex_state = 157, .external_lex_state = 28},
  [12238] = {.lex_state = 208, .external_lex_state = 5},
  [12239] = {.lex_state = 157, .external_lex_state = 2},
  [12240] = {.lex_state = 372, .external_lex_state = 16},
  [12241] = {.lex_state = 372, .external_lex_state = 16},
  [12242] = {.lex_state = 197, .external_lex_state = 5},
  [12243] = {.lex_state = 197, .external_lex_state = 5},
  [12244] = {.lex_state = 157, .external_lex_state = 6},
  [12245] = {.lex_state = 197, .external_lex_state = 5},
  [12246] = {.lex_state = 197, .external_lex_state = 5},
  [12247] = {.lex_state = 197, .external_lex_state = 5},
  [12248] = {.lex_state = 157, .external_lex_state = 28},
  [12249] = {.lex_state = 197, .external_lex_state = 5},
  [12250] = {.lex_state = 157, .external_lex_state = 2},
  [12251] = {.lex_state = 197, .external_lex_state = 5},
  [12252] = {.lex_state = 197, .external_lex_state = 5},
  [12253] = {.lex_state = 197, .external_lex_state = 5},
  [12254] = {.lex_state = 197, .external_lex_state = 5},
  [12255] = {.lex_state = 197, .external_lex_state = 5},
  [12256] = {.lex_state = 208, .external_lex_state = 5},
  [12257] = {.lex_state = 208, .external_lex_state = 5},
  [12258] = {.lex_state = 197, .external_lex_state = 5},
  [12259] = {.lex_state = 197, .external_lex_state = 5},
  [12260] = {.lex_state = 157, .external_lex_state = 28},
  [12261] = {.lex_state = 197, .external_lex_state = 5},
  [12262] = {.lex_state = 157, .external_lex_state = 2},
  [12263] = {.lex_state = 197, .external_lex_state = 5},
  [12264] = {.lex_state = 197, .external_lex_state = 5},
  [12265] = {.lex_state = 271, .external_lex_state = 9},
  [12266] = {.lex_state = 157, .external_lex_state = 2},
  [12267] = {.lex_state = 157, .external_lex_state = 28},
  [12268] = {.lex_state = 208, .external_lex_state = 5},
  [12269] = {.lex_state = 157, .external_lex_state = 2},
  [12270] = {.lex_state = 268, .external_lex_state = 5},
  [12271] = {.lex_state = 268, .external_lex_state = 5},
  [12272] = {.lex_state = 307, .external_lex_state = 5},
  [12273] = {.lex_state = 208, .external_lex_state = 5},
  [12274] = {.lex_state = 363, .external_lex_state = 16},
  [12275] = {.lex_state = 363, .external_lex_state = 16},
  [12276] = {.lex_state = 366, .external_lex_state = 17},
  [12277] = {.lex_state = 359, .external_lex_state = 20},
  [12278] = {.lex_state = 356, .external_lex_state = 16},
  [12279] = {.lex_state = 356, .external_lex_state = 16},
  [12280] = {.lex_state = 197, .external_lex_state = 5},
  [12281] = {.lex_state = 197, .external_lex_state = 5},
  [12282] = {.lex_state = 197, .external_lex_state = 5},
  [12283] = {.lex_state = 208, .external_lex_state = 5},
  [12284] = {.lex_state = 208, .external_lex_state = 5},
  [12285] = {.lex_state = 197, .external_lex_state = 5},
  [12286] = {.lex_state = 197, .external_lex_state = 5},
  [12287] = {.lex_state = 197, .external_lex_state = 5},
  [12288] = {.lex_state = 208, .external_lex_state = 5},
  [12289] = {.lex_state = 208, .external_lex_state = 5},
  [12290] = {.lex_state = 323, .external_lex_state = 16},
  [12291] = {.lex_state = 135},
  [12292] = {.lex_state = 323, .external_lex_state = 16},
  [12293] = {.lex_state = 323, .external_lex_state = 16},
  [12294] = {.lex_state = 323, .external_lex_state = 16},
  [12295] = {.lex_state = 323, .external_lex_state = 16},
  [12296] = {.lex_state = 323, .external_lex_state = 16},
  [12297] = {.lex_state = 208, .external_lex_state = 16},
  [12298] = {.lex_state = 208, .external_lex_state = 16},
  [12299] = {.lex_state = 208, .external_lex_state = 16},
  [12300] = {.lex_state = 208, .external_lex_state = 16},
  [12301] = {.lex_state = 197, .external_lex_state = 16},
  [12302] = {.lex_state = 197, .external_lex_state = 16},
  [12303] = {.lex_state = 157, .external_lex_state = 6},
  [12304] = {.lex_state = 197, .external_lex_state = 16},
  [12305] = {.lex_state = 197, .external_lex_state = 16},
  [12306] = {.lex_state = 197, .external_lex_state = 16},
  [12307] = {.lex_state = 197, .external_lex_state = 16},
  [12308] = {.lex_state = 197, .external_lex_state = 16},
  [12309] = {.lex_state = 197, .external_lex_state = 16},
  [12310] = {.lex_state = 197, .external_lex_state = 16},
  [12311] = {.lex_state = 197, .external_lex_state = 16},
  [12312] = {.lex_state = 197, .external_lex_state = 16},
  [12313] = {.lex_state = 197, .external_lex_state = 16},
  [12314] = {.lex_state = 359, .external_lex_state = 20},
  [12315] = {.lex_state = 197, .external_lex_state = 16},
  [12316] = {.lex_state = 197, .external_lex_state = 16},
  [12317] = {.lex_state = 197, .external_lex_state = 16},
  [12318] = {.lex_state = 197, .external_lex_state = 16},
  [12319] = {.lex_state = 197, .external_lex_state = 16},
  [12320] = {.lex_state = 223, .external_lex_state = 17},
  [12321] = {.lex_state = 266, .external_lex_state = 6},
  [12322] = {.lex_state = 223, .external_lex_state = 17},
  [12323] = {.lex_state = 223, .external_lex_state = 17},
  [12324] = {.lex_state = 300, .external_lex_state = 27},
  [12325] = {.lex_state = 223, .external_lex_state = 17},
  [12326] = {.lex_state = 197, .external_lex_state = 19},
  [12327] = {.lex_state = 157, .external_lex_state = 28},
  [12328] = {.lex_state = 197, .external_lex_state = 16},
  [12329] = {.lex_state = 157, .external_lex_state = 2},
  [12330] = {.lex_state = 271, .external_lex_state = 17},
  [12331] = {.lex_state = 135},
  [12332] = {.lex_state = 271, .external_lex_state = 17},
  [12333] = {.lex_state = 268, .external_lex_state = 16},
  [12334] = {.lex_state = 268, .external_lex_state = 16},
  [12335] = {.lex_state = 157, .external_lex_state = 6},
  [12336] = {.lex_state = 268, .external_lex_state = 16},
  [12337] = {.lex_state = 268, .external_lex_state = 16},
  [12338] = {.lex_state = 268, .external_lex_state = 16},
  [12339] = {.lex_state = 197, .external_lex_state = 20},
  [12340] = {.lex_state = 197, .external_lex_state = 20},
  [12341] = {.lex_state = 223, .external_lex_state = 21},
  [12342] = {.lex_state = 208, .external_lex_state = 16},
  [12343] = {.lex_state = 208, .external_lex_state = 16},
  [12344] = {.lex_state = 208, .external_lex_state = 16},
  [12345] = {.lex_state = 208, .external_lex_state = 16},
  [12346] = {.lex_state = 208, .external_lex_state = 16},
  [12347] = {.lex_state = 208, .external_lex_state = 16},
  [12348] = {.lex_state = 208, .external_lex_state = 16},
  [12349] = {.lex_state = 359, .external_lex_state = 20},
  [12350] = {.lex_state = 208, .external_lex_state = 16},
  [12351] = {.lex_state = 208, .external_lex_state = 16},
  [12352] = {.lex_state = 208, .external_lex_state = 16},
  [12353] = {.lex_state = 208, .external_lex_state = 16},
  [12354] = {.lex_state = 208, .external_lex_state = 16},
  [12355] = {.lex_state = 208, .external_lex_state = 19},
  [12356] = {.lex_state = 157, .external_lex_state = 28},
  [12357] = {.lex_state = 268, .external_lex_state = 16},
  [12358] = {.lex_state = 157, .external_lex_state = 2},
  [12359] = {.lex_state = 135, .external_lex_state = 10},
  [12360] = {.lex_state = 232, .external_lex_state = 2},
  [12361] = {.lex_state = 258, .external_lex_state = 13},
  [12362] = {.lex_state = 197, .external_lex_state = 5},
  [12363] = {.lex_state = 197, .external_lex_state = 5},
  [12364] = {.lex_state = 197, .external_lex_state = 5},
  [12365] = {.lex_state = 197, .external_lex_state = 5},
  [12366] = {.lex_state = 157, .external_lex_state = 6},
  [12367] = {.lex_state = 197, .external_lex_state = 5},
  [12368] = {.lex_state = 197, .external_lex_state = 5},
  [12369] = {.lex_state = 197, .external_lex_state = 5},
  [12370] = {.lex_state = 197, .external_lex_state = 5},
  [12371] = {.lex_state = 197, .external_lex_state = 5},
  [12372] = {.lex_state = 197, .external_lex_state = 5},
  [12373] = {.lex_state = 197, .external_lex_state = 5},
  [12374] = {.lex_state = 197, .external_lex_state = 5},
  [12375] = {.lex_state = 197, .external_lex_state = 5},
  [12376] = {.lex_state = 197, .external_lex_state = 5},
  [12377] = {.lex_state = 197, .external_lex_state = 5},
  [12378] = {.lex_state = 197, .external_lex_state = 5},
  [12379] = {.lex_state = 359, .external_lex_state = 20},
  [12380] = {.lex_state = 197, .external_lex_state = 5},
  [12381] = {.lex_state = 197, .external_lex_state = 5},
  [12382] = {.lex_state = 197, .external_lex_state = 5},
  [12383] = {.lex_state = 197, .external_lex_state = 5},
  [12384] = {.lex_state = 197, .external_lex_state = 5},
  [12385] = {.lex_state = 197, .external_lex_state = 14},
  [12386] = {.lex_state = 157, .external_lex_state = 28},
  [12387] = {.lex_state = 197, .external_lex_state = 5},
  [12388] = {.lex_state = 157, .external_lex_state = 2},
  [12389] = {.lex_state = 271, .external_lex_state = 9},
  [12390] = {.lex_state = 135},
  [12391] = {.lex_state = 271, .external_lex_state = 9},
  [12392] = {.lex_state = 268, .external_lex_state = 5},
  [12393] = {.lex_state = 268, .external_lex_state = 5},
  [12394] = {.lex_state = 157, .external_lex_state = 6},
  [12395] = {.lex_state = 268, .external_lex_state = 5},
  [12396] = {.lex_state = 268, .external_lex_state = 5},
  [12397] = {.lex_state = 268, .external_lex_state = 5},
  [12398] = {.lex_state = 223, .external_lex_state = 9},
  [12399] = {.lex_state = 197, .external_lex_state = 5},
  [12400] = {.lex_state = 197, .external_lex_state = 5},
  [12401] = {.lex_state = 197, .external_lex_state = 5},
  [12402] = {.lex_state = 197, .external_lex_state = 5},
  [12403] = {.lex_state = 197, .external_lex_state = 5},
  [12404] = {.lex_state = 197, .external_lex_state = 5},
  [12405] = {.lex_state = 359, .external_lex_state = 20},
  [12406] = {.lex_state = 197, .external_lex_state = 5},
  [12407] = {.lex_state = 197, .external_lex_state = 5},
  [12408] = {.lex_state = 197, .external_lex_state = 5},
  [12409] = {.lex_state = 197, .external_lex_state = 5},
  [12410] = {.lex_state = 197, .external_lex_state = 5},
  [12411] = {.lex_state = 197, .external_lex_state = 5},
  [12412] = {.lex_state = 208, .external_lex_state = 5},
  [12413] = {.lex_state = 208, .external_lex_state = 5},
  [12414] = {.lex_state = 208, .external_lex_state = 5},
  [12415] = {.lex_state = 208, .external_lex_state = 5},
  [12416] = {.lex_state = 208, .external_lex_state = 5},
  [12417] = {.lex_state = 208, .external_lex_state = 5},
  [12418] = {.lex_state = 208, .external_lex_state = 5},
  [12419] = {.lex_state = 359, .external_lex_state = 20},
  [12420] = {.lex_state = 208, .external_lex_state = 5},
  [12421] = {.lex_state = 208, .external_lex_state = 5},
  [12422] = {.lex_state = 208, .external_lex_state = 5},
  [12423] = {.lex_state = 208, .external_lex_state = 5},
  [12424] = {.lex_state = 208, .external_lex_state = 5},
  [12425] = {.lex_state = 208, .external_lex_state = 14},
  [12426] = {.lex_state = 157, .external_lex_state = 28},
  [12427] = {.lex_state = 268, .external_lex_state = 5},
  [12428] = {.lex_state = 157, .external_lex_state = 2},
  [12429] = {.lex_state = 197, .external_lex_state = 5},
  [12430] = {.lex_state = 208, .external_lex_state = 5},
  [12431] = {.lex_state = 208, .external_lex_state = 5},
  [12432] = {.lex_state = 197, .external_lex_state = 5},
  [12433] = {.lex_state = 197, .external_lex_state = 5},
  [12434] = {.lex_state = 197, .external_lex_state = 5},
  [12435] = {.lex_state = 197, .external_lex_state = 5},
  [12436] = {.lex_state = 197, .external_lex_state = 5},
  [12437] = {.lex_state = 208, .external_lex_state = 5},
  [12438] = {.lex_state = 208, .external_lex_state = 5},
  [12439] = {.lex_state = 323, .external_lex_state = 16},
  [12440] = {.lex_state = 157, .external_lex_state = 28},
  [12441] = {.lex_state = 197, .external_lex_state = 16},
  [12442] = {.lex_state = 157, .external_lex_state = 2},
  [12443] = {.lex_state = 223, .external_lex_state = 17},
  [12444] = {.lex_state = 135},
  [12445] = {.lex_state = 223, .external_lex_state = 17},
  [12446] = {.lex_state = 197, .external_lex_state = 16},
  [12447] = {.lex_state = 197, .external_lex_state = 16},
  [12448] = {.lex_state = 271, .external_lex_state = 17},
  [12449] = {.lex_state = 157, .external_lex_state = 28},
  [12450] = {.lex_state = 208, .external_lex_state = 16},
  [12451] = {.lex_state = 157, .external_lex_state = 2},
  [12452] = {.lex_state = 268, .external_lex_state = 16},
  [12453] = {.lex_state = 268, .external_lex_state = 16},
  [12454] = {.lex_state = 197, .external_lex_state = 5},
  [12455] = {.lex_state = 197, .external_lex_state = 5},
  [12456] = {.lex_state = 157, .external_lex_state = 28},
  [12457] = {.lex_state = 197, .external_lex_state = 5},
  [12458] = {.lex_state = 157, .external_lex_state = 2},
  [12459] = {.lex_state = 197, .external_lex_state = 5},
  [12460] = {.lex_state = 197, .external_lex_state = 5},
  [12461] = {.lex_state = 271, .external_lex_state = 9},
  [12462] = {.lex_state = 157, .external_lex_state = 2},
  [12463] = {.lex_state = 157, .external_lex_state = 28},
  [12464] = {.lex_state = 208, .external_lex_state = 5},
  [12465] = {.lex_state = 157, .external_lex_state = 2},
  [12466] = {.lex_state = 268, .external_lex_state = 5},
  [12467] = {.lex_state = 268, .external_lex_state = 5},
  [12468] = {.lex_state = 197, .external_lex_state = 16},
  [12469] = {.lex_state = 197, .external_lex_state = 16},
  [12470] = {.lex_state = 223, .external_lex_state = 17},
  [12471] = {.lex_state = 208, .external_lex_state = 16},
  [12472] = {.lex_state = 208, .external_lex_state = 16},
  [12473] = {.lex_state = 197, .external_lex_state = 5},
  [12474] = {.lex_state = 197, .external_lex_state = 5},
  [12475] = {.lex_state = 197, .external_lex_state = 5},
  [12476] = {.lex_state = 208, .external_lex_state = 5},
  [12477] = {.lex_state = 208, .external_lex_state = 5},
};

enum {
  ts_external_token__line_break = 0,
  ts_external_token__simple_symbol = 1,
  ts_external_token__string_start = 2,
  ts_external_token__symbol_start = 3,
  ts_external_token__subshell_start = 4,
  ts_external_token__regex_start = 5,
  ts_external_token__string_array_start = 6,
  ts_external_token__symbol_array_start = 7,
  ts_external_token__heredoc_body_start = 8,
  ts_external_token__string_content = 9,
  ts_external_token__heredoc_content = 10,
  ts_external_token__string_end = 11,
  ts_external_token_heredoc_end = 12,
  ts_external_token_heredoc_beginning = 13,
  ts_external_token_SLASH = 14,
  ts_external_token__block_ampersand = 15,
  ts_external_token__splat_star = 16,
  ts_external_token__unary_minus = 17,
  ts_external_token__binary_minus = 18,
  ts_external_token__binary_star = 19,
  ts_external_token__singleton_class_left_angle_left_langle = 20,
  ts_external_token__identifier_hash_key = 21,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__simple_symbol] = sym__simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__heredoc_content] = sym__heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [2] = {
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [3] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__symbol_start] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [6] = {
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [7] = {
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [8] = {
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [9] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [10] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [11] = {
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [12] = {
    [ts_external_token__line_break] = true,
  },
  [13] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [15] = {
    [ts_external_token__string_end] = true,
  },
  [16] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [17] = {
    [ts_external_token__unary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [18] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [20] = {
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__unary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [22] = {
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__heredoc_content] = true,
  },
  [23] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_star] = true,
  },
  [24] = {
    [ts_external_token__string_start] = true,
  },
  [25] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [26] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [27] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [28] = {
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [29] = {
    [ts_external_token__splat_star] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_hash_key] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_start] = true,
  },
  [30] = {
    [ts_external_token__string_content] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_SLASH] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym_complex] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [sym__identifier_hash_key] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [sym__simple_symbol] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_NIL] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_TRUE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [sym__heredoc_content] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym_retry] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_FALSE] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [sym_redo] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
  },
  [1] = {
    [sym__statement] = STATE(42),
    [sym_unary] = STATE(49),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(42),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_unless_modifier] = STATE(42),
    [sym_symbol] = STATE(44),
    [sym_for] = STATE(44),
    [sym_if] = STATE(44),
    [sym__primary] = STATE(44),
    [sym_method] = STATE(44),
    [sym_conditional] = STATE(49),
    [sym_left_assignment_list] = STATE(45),
    [sym_return] = STATE(44),
    [sym_true] = STATE(48),
    [sym_while_modifier] = STATE(42),
    [sym_subshell] = STATE(44),
    [sym_unless] = STATE(44),
    [sym_empty_statement] = STATE(53),
    [sym_parenthesized_statements] = STATE(44),
    [sym_begin_block] = STATE(42),
    [sym_range] = STATE(49),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(48),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_array] = STATE(44),
    [sym_call] = STATE(47),
    [sym_end_block] = STATE(42),
    [sym_assignment] = STATE(49),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_alias] = STATE(42),
    [sym_if_modifier] = STATE(42),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(49),
    [sym_method_call] = STATE(48),
    [sym_program] = STATE(50),
    [sym_operator_assignment] = STATE(49),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_until_modifier] = STATE(42),
    [sym_lambda] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym__statements] = STATE(52),
    [sym_binary] = STATE(49),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_nil] = STATE(48),
    [sym_rescue_modifier] = STATE(42),
    [sym_symbol_array] = STATE(44),
    [sym_case] = STATE(44),
    [sym_hash] = STATE(44),
    [aux_sym__statements_repeat1] = STATE(53),
    [sym_scope_resolution] = STATE(47),
    [sym_float] = ACTIONS(5),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(9),
    [sym_self] = ACTIONS(11),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(11),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(39),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [anon_sym_yield] = ACTIONS(57),
    [sym_class_variable] = ACTIONS(39),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym___END__] = ACTIONS(83),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [sym_retry] = ACTIONS(5),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [ts_builtin_sym_end] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(5),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [2] = {
    [sym_assignment] = STATE(63),
    [sym_unary] = STATE(63),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(63),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(63),
    [sym_conditional] = STATE(63),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(63),
    [sym_binary] = STATE(63),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [3] = {
    [sym__method_name] = STATE(72),
    [sym_setter] = STATE(72),
    [sym_symbol] = STATE(72),
    [sym_operator] = STATE(72),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(133),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(133),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [4] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(141),
  },
  [5] = {
    [sym__statement] = STATE(83),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(83),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(83),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(83),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(83),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(83),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(83),
    [sym_if_modifier] = STATE(83),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(83),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(83),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [6] = {
    [sym_assignment] = STATE(90),
    [sym_unary] = STATE(90),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(90),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(90),
    [sym_conditional] = STATE(90),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(90),
    [sym_binary] = STATE(90),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [7] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [8] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(95),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(175),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(179),
  },
  [9] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [sym__line_break] = ACTIONS(183),
    [anon_sym_then] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_when] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym___END__] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_end] = ACTIONS(183),
    [anon_sym_ensure] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_elsif] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [sym__binary_minus] = ACTIONS(183),
  },
  [10] = {
    [sym__method_name] = STATE(101),
    [sym_setter] = STATE(101),
    [sym_symbol] = STATE(101),
    [sym_operator] = STATE(101),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(187),
    [sym_class_variable] = ACTIONS(189),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(187),
    [anon_sym_PLUS_AT] = ACTIONS(187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(187),
    [sym_global_variable] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(185),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_PERCENT] = ACTIONS(187),
    [sym__simple_symbol] = ACTIONS(191),
    [anon_sym_DASH_AT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_BANG_TILDE] = ACTIONS(187),
    [sym_constant] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(185),
    [sym_instance_variable] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(187),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(187),
    [anon_sym_LT_EQ_GT] = ACTIONS(187),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(185),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_CARET] = ACTIONS(187),
    [sym__symbol_start] = ACTIONS(195),
  },
  [11] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(148),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(199),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [12] = {
    [anon_sym_SLASH] = ACTIONS(289),
    [sym__line_break] = ACTIONS(291),
    [anon_sym_until] = ACTIONS(291),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_unless] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_rescue] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_while] = ACTIONS(291),
    [sym__heredoc_body_start] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_then] = ACTIONS(291),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_when] = ACTIONS(291),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym___END__] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_end] = ACTIONS(291),
    [anon_sym_ensure] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_elsif] = ACTIONS(291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [ts_builtin_sym_end] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [13] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(191),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(196),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(299),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [14] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(381),
  },
  [15] = {
    [sym_assignment] = STATE(198),
    [sym_unary] = STATE(198),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(198),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(198),
    [sym_conditional] = STATE(198),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(198),
    [sym_binary] = STATE(198),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [16] = {
    [sym_assignment] = STATE(199),
    [sym_unary] = STATE(199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(199),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(199),
    [sym_conditional] = STATE(199),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(199),
    [sym_binary] = STATE(199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [17] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(202),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(387),
  },
  [18] = {
    [anon_sym_SLASH] = ACTIONS(389),
    [sym__line_break] = ACTIONS(391),
    [anon_sym_until] = ACTIONS(391),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_unless] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_rescue] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [sym__heredoc_body_start] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_then] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_when] = ACTIONS(391),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym___END__] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_end] = ACTIONS(391),
    [anon_sym_ensure] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_elsif] = ACTIONS(391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [ts_builtin_sym_end] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [19] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(240),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [20] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(248),
    [sym_lambda_parameters] = STATE(249),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(248),
    [anon_sym_do] = ACTIONS(463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [21] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
  },
  [22] = {
    [sym__method_name] = STATE(258),
    [sym_setter] = STATE(258),
    [sym_symbol] = STATE(258),
    [sym_operator] = STATE(258),
    [sym__method_rest] = STATE(259),
    [sym__variable] = STATE(260),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(483),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(483),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [23] = {
    [sym__argument] = STATE(300),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(300),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(300),
    [sym_hash_splat_argument] = STATE(300),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(308),
    [sym_block_argument] = STATE(300),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym___END__] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [ts_builtin_sym_end] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [24] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(310),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(579),
  },
  [25] = {
    [sym_assignment] = STATE(319),
    [sym_unary] = STATE(319),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(319),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(319),
    [sym_conditional] = STATE(319),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(323),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(319),
    [sym_binary] = STATE(319),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(323),
    [sym__line_break] = ACTIONS(581),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [26] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym___END__] = ACTIONS(605),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [sym_integer] = ACTIONS(605),
    [ts_builtin_sym_end] = ACTIONS(607),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [27] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(345),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [28] = {
    [sym__argument] = STATE(300),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(300),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(300),
    [sym_hash_splat_argument] = STATE(300),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(308),
    [sym_block_argument] = STATE(300),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym___END__] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [29] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(354),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(659),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(661),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [30] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(356),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(665),
  },
  [31] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(360),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(671),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [32] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(379),
    [sym__body_statement] = STATE(380),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(379),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(675),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(675),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(711),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [33] = {
    [anon_sym_SLASH] = ACTIONS(717),
    [sym__line_break] = ACTIONS(719),
    [anon_sym_until] = ACTIONS(719),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_unless] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_rescue] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(719),
    [sym__heredoc_body_start] = ACTIONS(719),
    [anon_sym_else] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_then] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym___END__] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_end] = ACTIONS(719),
    [anon_sym_ensure] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_elsif] = ACTIONS(719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [ts_builtin_sym_end] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [34] = {
    [sym__lhs] = STATE(389),
    [sym_singleton_class] = STATE(390),
    [sym_module] = STATE(390),
    [sym_chained_string] = STATE(390),
    [sym_until] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_for] = STATE(390),
    [sym_symbol] = STATE(390),
    [sym_if] = STATE(390),
    [sym_begin] = STATE(390),
    [sym__primary] = STATE(390),
    [sym_method_call] = STATE(389),
    [sym_method] = STATE(390),
    [sym_singleton_method] = STATE(390),
    [sym__variable] = STATE(391),
    [sym_rational] = STATE(390),
    [sym_true] = STATE(389),
    [sym_return] = STATE(390),
    [sym_subshell] = STATE(390),
    [sym_yield] = STATE(390),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(390),
    [sym_lambda] = STATE(390),
    [sym_parenthesized_statements] = STATE(390),
    [sym_element_reference] = STATE(389),
    [sym_class] = STATE(390),
    [sym_break] = STATE(390),
    [sym_next] = STATE(390),
    [sym_string_array] = STATE(390),
    [sym_while] = STATE(390),
    [sym_case] = STATE(390),
    [sym_symbol_array] = STATE(390),
    [sym_array] = STATE(390),
    [sym_hash] = STATE(390),
    [sym_false] = STATE(389),
    [sym_nil] = STATE(389),
    [sym_scope_resolution] = STATE(391),
    [sym_call] = STATE(391),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(721),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(723),
    [sym_self] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(727),
    [sym_global_variable] = ACTIONS(729),
    [sym_super] = ACTIONS(723),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(721),
    [sym_constant] = ACTIONS(723),
    [sym_instance_variable] = ACTIONS(729),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(731),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(725),
    [sym__symbol_start] = ACTIONS(461),
  },
  [35] = {
    [sym__line_break] = ACTIONS(733),
    [sym_comment] = ACTIONS(49),
  },
  [36] = {
    [sym__argument] = STATE(300),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(300),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(300),
    [sym_hash_splat_argument] = STATE(300),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(308),
    [sym_block_argument] = STATE(300),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [37] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(395),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(739),
  },
  [38] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [39] = {
    [sym__statement] = STATE(397),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(397),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(397),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(397),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(397),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(397),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(397),
    [sym_if_modifier] = STATE(397),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(397),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(397),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [40] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(400),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(747),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(749),
  },
  [41] = {
    [sym__argument] = STATE(300),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(300),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(300),
    [sym_hash_splat_argument] = STATE(300),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(308),
    [sym_block_argument] = STATE(300),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym___END__] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [ts_builtin_sym_end] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [42] = {
    [sym_heredoc_body] = STATE(408),
    [sym__terminator] = STATE(408),
    [sym__line_break] = ACTIONS(755),
    [ts_builtin_sym_end] = ACTIONS(757),
    [anon_sym_unless] = ACTIONS(759),
    [anon_sym___END__] = ACTIONS(757),
    [anon_sym_until] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(763),
    [sym__heredoc_body_start] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(769),
    [sym_comment] = ACTIONS(49),
  },
  [43] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_COMMA] = ACTIONS(773),
  },
  [44] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(779),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym___END__] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [45] = {
    [anon_sym_EQ] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [anon_sym_EQ] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_for] = STATE(452),
    [sym_if] = STATE(452),
    [sym__primary] = STATE(452),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(456),
    [sym_method] = STATE(452),
    [sym_conditional] = STATE(458),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_true] = STATE(457),
    [sym_subshell] = STATE(452),
    [sym_unless] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(457),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_array] = STATE(452),
    [sym_call] = STATE(455),
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_lambda] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(458),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_nil] = STATE(457),
    [sym_symbol_array] = STATE(452),
    [sym_case] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_scope_resolution] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym___END__] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [ts_builtin_sym_end] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [48] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(869),
    [anon_sym_GT_GT_EQ] = ACTIONS(869),
    [anon_sym_SLASH_EQ] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(869),
    [anon_sym_LT_LT_EQ] = ACTIONS(869),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(869),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(869),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [anon_sym_STAR_EQ] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(869),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(869),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(869),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [49] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(873),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(873),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(903),
    [sym_comment] = ACTIONS(49),
  },
  [51] = {
    [aux_sym_chained_string_repeat1] = STATE(472),
    [sym_string] = STATE(472),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [52] = {
    [anon_sym___END__] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(907),
    [sym_comment] = ACTIONS(49),
  },
  [53] = {
    [sym__statement] = STATE(474),
    [sym_unary] = STATE(49),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(474),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_unless_modifier] = STATE(474),
    [sym_symbol] = STATE(44),
    [sym_for] = STATE(44),
    [sym_if] = STATE(44),
    [sym__primary] = STATE(44),
    [sym_method] = STATE(44),
    [sym_conditional] = STATE(49),
    [sym_left_assignment_list] = STATE(45),
    [sym_return] = STATE(44),
    [sym_true] = STATE(48),
    [sym_while_modifier] = STATE(474),
    [sym_subshell] = STATE(44),
    [sym_unless] = STATE(44),
    [sym_empty_statement] = STATE(475),
    [sym_parenthesized_statements] = STATE(44),
    [sym_begin_block] = STATE(474),
    [sym_range] = STATE(49),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(48),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_array] = STATE(44),
    [sym_call] = STATE(47),
    [sym_end_block] = STATE(474),
    [sym_assignment] = STATE(49),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_alias] = STATE(474),
    [sym_if_modifier] = STATE(474),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(49),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(49),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_rational] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_until_modifier] = STATE(474),
    [sym_lambda] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_binary] = STATE(49),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_nil] = STATE(48),
    [sym_rescue_modifier] = STATE(474),
    [sym_symbol_array] = STATE(44),
    [sym_case] = STATE(44),
    [sym_hash] = STATE(44),
    [aux_sym__statements_repeat1] = STATE(475),
    [sym_scope_resolution] = STATE(47),
    [sym_float] = ACTIONS(5),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(9),
    [sym_self] = ACTIONS(11),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(11),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(39),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [anon_sym_yield] = ACTIONS(57),
    [sym_class_variable] = ACTIONS(39),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym___END__] = ACTIONS(909),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [sym_retry] = ACTIONS(5),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [ts_builtin_sym_end] = ACTIONS(757),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(5),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [54] = {
    [sym__argument] = STATE(489),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(489),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(489),
    [sym_hash_splat_argument] = STATE(489),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(496),
    [sym_block_argument] = STATE(489),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [55] = {
    [sym__argument] = STATE(489),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(489),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(489),
    [sym_hash_splat_argument] = STATE(489),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(496),
    [sym_block_argument] = STATE(489),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [56] = {
    [sym_assignment] = STATE(497),
    [sym_unary] = STATE(497),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(497),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(497),
    [sym_conditional] = STATE(497),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(497),
    [sym_binary] = STATE(497),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [57] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [58] = {
    [sym__argument] = STATE(489),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(489),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(489),
    [sym_hash_splat_argument] = STATE(489),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(496),
    [sym_block_argument] = STATE(489),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [59] = {
    [sym_assignment] = STATE(498),
    [sym_unary] = STATE(498),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(498),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(498),
    [sym_conditional] = STATE(498),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(498),
    [sym_binary] = STATE(498),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [60] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(955),
    [sym_identifier] = ACTIONS(955),
  },
  [61] = {
    [sym__argument] = STATE(489),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(489),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(489),
    [sym_hash_splat_argument] = STATE(489),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(496),
    [sym_block_argument] = STATE(489),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [62] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(957),
    [anon_sym_SLASH_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(957),
    [anon_sym_PIPE_EQ] = ACTIONS(957),
    [anon_sym_LT_LT_EQ] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(957),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(957),
    [anon_sym_STAR_EQ] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(957),
    [anon_sym_CARET_EQ] = ACTIONS(957),
    [anon_sym_DASH_EQ] = ACTIONS(957),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(959),
  },
  [63] = {
    [sym__terminator] = STATE(513),
    [sym_heredoc_body] = STATE(513),
    [sym__do] = STATE(513),
    [sym__line_break] = ACTIONS(961),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(961),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [64] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [65] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(533),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(535),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(535),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [66] = {
    [anon_sym_EQ] = ACTIONS(1043),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [aux_sym_chained_string_repeat1] = STATE(538),
    [sym_string] = STATE(538),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [68] = {
    [sym__line_break] = ACTIONS(1045),
    [anon_sym_then] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1045),
    [anon_sym___END__] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1045),
    [ts_builtin_sym_end] = ACTIONS(1045),
    [anon_sym_elsif] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(1045),
    [anon_sym_when] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
  },
  [69] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(540),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1047),
  },
  [70] = {
    [sym__line_break] = ACTIONS(183),
    [anon_sym_then] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym___END__] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_end] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_elsif] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_when] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
  },
  [71] = {
    [sym__line_break] = ACTIONS(1049),
    [anon_sym_then] = ACTIONS(1049),
    [anon_sym_until] = ACTIONS(1049),
    [anon_sym___END__] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [sym__heredoc_body_start] = ACTIONS(1049),
    [anon_sym_end] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_ensure] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_unless] = ACTIONS(1049),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_elsif] = ACTIONS(1049),
    [anon_sym_rescue] = ACTIONS(1049),
    [anon_sym_when] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1051),
  },
  [72] = {
    [aux_sym_undef_repeat1] = STATE(543),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym___END__] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [73] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(562),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [74] = {
    [sym__method_name] = STATE(564),
    [sym_setter] = STATE(564),
    [sym_symbol] = STATE(564),
    [sym_operator] = STATE(564),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(1091),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [75] = {
    [sym_assignment] = STATE(565),
    [sym_unary] = STATE(565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(565),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(565),
    [sym_conditional] = STATE(565),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(565),
    [sym_binary] = STATE(565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [76] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [77] = {
    [sym_assignment] = STATE(566),
    [sym_unary] = STATE(566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(566),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(566),
    [sym_conditional] = STATE(566),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(566),
    [sym_binary] = STATE(566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [78] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1093),
  },
  [79] = {
    [sym__argument] = STATE(581),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(581),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(581),
    [sym_hash_splat_argument] = STATE(581),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(588),
    [sym_block_argument] = STATE(581),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [80] = {
    [sym__argument] = STATE(581),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(581),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(581),
    [sym_hash_splat_argument] = STATE(581),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(588),
    [sym_block_argument] = STATE(581),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [81] = {
    [sym__argument] = STATE(581),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(581),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(581),
    [sym_hash_splat_argument] = STATE(581),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(588),
    [sym_block_argument] = STATE(581),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [82] = {
    [sym__argument] = STATE(581),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(581),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(581),
    [sym_hash_splat_argument] = STATE(581),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(588),
    [sym_block_argument] = STATE(581),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [83] = {
    [sym__terminator] = STATE(596),
    [sym_heredoc_body] = STATE(596),
    [sym_then] = STATE(597),
    [sym__line_break] = ACTIONS(1131),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [84] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(1147),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1151),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [85] = {
    [anon_sym_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_for] = STATE(613),
    [sym_if] = STATE(613),
    [sym__primary] = STATE(613),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(616),
    [sym_method] = STATE(613),
    [sym_conditional] = STATE(618),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_true] = STATE(617),
    [sym_subshell] = STATE(613),
    [sym_unless] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(617),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_array] = STATE(613),
    [sym_call] = STATE(615),
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_rational] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_lambda] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(618),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_nil] = STATE(617),
    [sym_symbol_array] = STATE(613),
    [sym_case] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_scope_resolution] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [87] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(1189),
    [anon_sym_GT_GT_EQ] = ACTIONS(1189),
    [anon_sym_SLASH_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT_EQ] = ACTIONS(1189),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1189),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_PLUS_EQ] = ACTIONS(1189),
    [anon_sym_STAR_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1189),
    [anon_sym_DASH_EQ] = ACTIONS(1189),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [88] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_then] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [89] = {
    [aux_sym_chained_string_repeat1] = STATE(632),
    [sym_string] = STATE(632),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [90] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [91] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [92] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [sym__line_break] = ACTIONS(1227),
    [anon_sym_then] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_when] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym___END__] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_end] = ACTIONS(1227),
    [anon_sym_ensure] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_elsif] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [sym__binary_minus] = ACTIONS(1227),
  },
  [93] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(635),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1229),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1231),
  },
  [94] = {
    [sym__statement] = STATE(673),
    [sym_unary] = STATE(678),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(673),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_unless_modifier] = STATE(673),
    [sym_symbol] = STATE(674),
    [sym_for] = STATE(674),
    [sym_if] = STATE(674),
    [sym__primary] = STATE(674),
    [sym_method] = STATE(674),
    [sym_conditional] = STATE(678),
    [sym_left_assignment_list] = STATE(675),
    [sym_return] = STATE(674),
    [sym_true] = STATE(677),
    [sym_while_modifier] = STATE(673),
    [sym_subshell] = STATE(674),
    [sym_unless] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_begin_block] = STATE(673),
    [sym_range] = STATE(678),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(677),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_array] = STATE(674),
    [sym_call] = STATE(676),
    [sym_end_block] = STATE(673),
    [sym_assignment] = STATE(678),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_alias] = STATE(673),
    [sym_if_modifier] = STATE(673),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(678),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(678),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_rational] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_until_modifier] = STATE(673),
    [sym_lambda] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_binary] = STATE(678),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_nil] = STATE(677),
    [sym_rescue_modifier] = STATE(673),
    [sym_symbol_array] = STATE(674),
    [sym_case] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_scope_resolution] = STATE(676),
    [sym_float] = ACTIONS(1233),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_undef] = ACTIONS(1237),
    [sym_self] = ACTIONS(1239),
    [anon_sym_BEGIN] = ACTIONS(1241),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_unless] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym_complex] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [sym_super] = ACTIONS(1239),
    [anon_sym_alias] = ACTIONS(1255),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_character] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_END] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1267),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1283),
    [sym_class_variable] = ACTIONS(1267),
    [sym__symbol_start] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1287),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_class] = ACTIONS(1295),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [sym_retry] = ACTIONS(1233),
    [sym__regex_start] = ACTIONS(1309),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_FALSE] = ACTIONS(1303),
    [sym_redo] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1313),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [95] = {
    [aux_sym_symbol_array_repeat1] = STATE(682),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1319),
    [sym__string_end] = ACTIONS(1321),
  },
  [96] = {
    [sym_interpolation] = STATE(683),
    [aux_sym__literal_contents_repeat1] = STATE(683),
    [sym_escape_sequence] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1325),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(1323),
    [sym__string_end] = ACTIONS(1325),
  },
  [97] = {
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1045),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_AT] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_DASH_AT] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1327),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_CARET] = ACTIONS(1045),
    [sym_class_variable] = ACTIONS(1045),
  },
  [98] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(685),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1329),
  },
  [99] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [sym__symbol_start] = ACTIONS(183),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(183),
    [anon_sym_PLUS_AT] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(183),
    [sym_global_variable] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [sym__simple_symbol] = ACTIONS(183),
    [anon_sym_DASH_AT] = ACTIONS(183),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [sym_constant] = ACTIONS(183),
    [anon_sym_DASH] = ACTIONS(181),
    [sym_instance_variable] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(183),
    [anon_sym_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(181),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [sym_class_variable] = ACTIONS(183),
  },
  [100] = {
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1049),
    [sym__symbol_start] = ACTIONS(1049),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1049),
    [anon_sym_PLUS_AT] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_EQ_TILDE] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1049),
    [sym_global_variable] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_PERCENT] = ACTIONS(1049),
    [sym__simple_symbol] = ACTIONS(1049),
    [anon_sym_DASH_AT] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_BANG_TILDE] = ACTIONS(1049),
    [sym_constant] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1331),
    [sym_instance_variable] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1049),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_LT_EQ_GT] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_CARET] = ACTIONS(1049),
    [sym_class_variable] = ACTIONS(1049),
  },
  [101] = {
    [sym__method_name] = STATE(687),
    [sym_setter] = STATE(687),
    [sym_symbol] = STATE(687),
    [sym_operator] = STATE(687),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(1335),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(1335),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [102] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [sym__line_break] = ACTIONS(1339),
    [anon_sym_then] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym___END__] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_ensure] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_elsif] = ACTIONS(1339),
    [ts_builtin_sym_end] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [sym__binary_minus] = ACTIONS(1339),
  },
  [103] = {
    [sym_assignment] = STATE(688),
    [sym_unary] = STATE(688),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(688),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(688),
    [sym_conditional] = STATE(688),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(688),
    [sym_binary] = STATE(688),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [104] = {
    [sym__statement] = STATE(689),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(689),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(689),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(689),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(689),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(689),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(689),
    [sym_if_modifier] = STATE(689),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(689),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(689),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [105] = {
    [sym_assignment] = STATE(690),
    [sym_unary] = STATE(690),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(690),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(690),
    [sym_conditional] = STATE(690),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(690),
    [sym_binary] = STATE(690),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [106] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [107] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(695),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1341),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1343),
  },
  [108] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_COLON2] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [anon_sym_EQ] = ACTIONS(181),
  },
  [109] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(697),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1345),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [110] = {
    [anon_sym_SLASH] = ACTIONS(289),
    [anon_sym_RBRACK] = ACTIONS(291),
    [anon_sym_until] = ACTIONS(291),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_unless] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_rescue] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_COLON2] = ACTIONS(289),
    [anon_sym_while] = ACTIONS(291),
    [sym__heredoc_body_start] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_in] = ACTIONS(291),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_EQ_GT] = ACTIONS(291),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [111] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(699),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(700),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [112] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [113] = {
    [sym_assignment] = STATE(702),
    [sym_unary] = STATE(702),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(702),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(702),
    [sym_conditional] = STATE(702),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(702),
    [sym_binary] = STATE(702),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [114] = {
    [sym_assignment] = STATE(703),
    [sym_unary] = STATE(703),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(703),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(703),
    [sym_conditional] = STATE(703),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(703),
    [sym_binary] = STATE(703),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [115] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(705),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1355),
  },
  [116] = {
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_RBRACK] = ACTIONS(391),
    [anon_sym_until] = ACTIONS(391),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_unless] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_rescue] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_COLON2] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(391),
    [sym__heredoc_body_start] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_EQ_GT] = ACTIONS(391),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [117] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(706),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [118] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(709),
    [sym_lambda_parameters] = STATE(710),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(709),
    [anon_sym_do] = ACTIONS(1357),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [119] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(1361),
    [sym_identifier] = ACTIONS(1361),
  },
  [120] = {
    [anon_sym_COLON] = ACTIONS(1363),
    [sym_comment] = ACTIONS(49),
  },
  [121] = {
    [sym__method_name] = STATE(714),
    [sym_setter] = STATE(714),
    [sym_symbol] = STATE(714),
    [sym_operator] = STATE(714),
    [sym__method_rest] = STATE(715),
    [sym__variable] = STATE(716),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(1365),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(1365),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [122] = {
    [sym__argument] = STATE(726),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(726),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(726),
    [sym_hash_splat_argument] = STATE(726),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(732),
    [sym_block_argument] = STATE(726),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(495),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [123] = {
    [sym_assignment] = STATE(767),
    [sym_unary] = STATE(767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(767),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(767),
    [sym_conditional] = STATE(767),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(767),
    [sym_binary] = STATE(767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [124] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(773),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1473),
  },
  [125] = {
    [sym_assignment] = STATE(774),
    [sym_unary] = STATE(774),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(774),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(774),
    [sym_conditional] = STATE(774),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(775),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(774),
    [sym_binary] = STATE(774),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(775),
    [sym__line_break] = ACTIONS(1475),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [126] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(777),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [127] = {
    [sym_assignment] = STATE(778),
    [sym_unary] = STATE(778),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(778),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(778),
    [sym_conditional] = STATE(778),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(778),
    [sym_binary] = STATE(778),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [128] = {
    [sym__argument] = STATE(726),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(726),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(726),
    [sym_hash_splat_argument] = STATE(726),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(732),
    [sym_block_argument] = STATE(726),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(645),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [129] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(782),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1479),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(1481),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [130] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(784),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1483),
  },
  [131] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(786),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(1485),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [132] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(789),
    [sym__body_statement] = STATE(790),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(789),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(1487),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(1489),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [133] = {
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_RBRACK] = ACTIONS(719),
    [anon_sym_until] = ACTIONS(719),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_unless] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_rescue] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_COLON2] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym__heredoc_body_start] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_in] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_EQ_GT] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_if] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [134] = {
    [sym__argument] = STATE(726),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(726),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(726),
    [sym_hash_splat_argument] = STATE(726),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(732),
    [sym_block_argument] = STATE(726),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(735),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [135] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(795),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1491),
  },
  [136] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_r] = ACTIONS(1493),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
  },
  [137] = {
    [sym_assignment] = STATE(797),
    [sym_unary] = STATE(797),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(797),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(797),
    [sym_conditional] = STATE(797),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(797),
    [sym_binary] = STATE(797),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [138] = {
    [sym__statement] = STATE(798),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(798),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(798),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(798),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(798),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(798),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(798),
    [sym_if_modifier] = STATE(798),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(798),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(798),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [139] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(801),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1495),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1497),
  },
  [140] = {
    [sym__argument] = STATE(726),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(726),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(726),
    [sym_hash_splat_argument] = STATE(726),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(732),
    [sym_block_argument] = STATE(726),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(751),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [141] = {
    [sym_heredoc_body] = STATE(804),
    [aux_sym_argument_list_repeat1] = STATE(805),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(1499),
    [anon_sym_COMMA] = ACTIONS(1501),
    [sym_comment] = ACTIONS(49),
  },
  [142] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1503),
    [anon_sym_SLASH_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_LT_LT_EQ] = ACTIONS(1503),
    [anon_sym_PLUS_EQ] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1503),
    [anon_sym_STAR_EQ] = ACTIONS(1503),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1503),
    [anon_sym_CARET_EQ] = ACTIONS(1503),
    [anon_sym_DASH_EQ] = ACTIONS(1503),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1503),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(1505),
  },
  [143] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(1519),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1533),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [144] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_RBRACK] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1543),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [145] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_for] = STATE(858),
    [sym_if] = STATE(858),
    [sym__primary] = STATE(858),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(862),
    [sym_method] = STATE(858),
    [sym_conditional] = STATE(864),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_true] = STATE(863),
    [sym_subshell] = STATE(858),
    [sym_unless] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(863),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_array] = STATE(858),
    [sym_call] = STATE(861),
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_rational] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_lambda] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(864),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_nil] = STATE(863),
    [sym_symbol_array] = STATE(858),
    [sym_case] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_scope_resolution] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(793),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [146] = {
    [anon_sym_EQ] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [aux_sym_chained_string_repeat1] = STATE(867),
    [sym_string] = STATE(867),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(1629),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [148] = {
    [anon_sym_RBRACK] = ACTIONS(1631),
    [sym_comment] = ACTIONS(49),
  },
  [149] = {
    [sym_assignment] = STATE(869),
    [sym_unary] = STATE(869),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(869),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(869),
    [sym_conditional] = STATE(869),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(869),
    [sym_binary] = STATE(869),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [150] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [sym__line_break] = ACTIONS(1635),
    [anon_sym_then] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_when] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym___END__] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_end] = ACTIONS(1635),
    [anon_sym_ensure] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_elsif] = ACTIONS(1635),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [sym__binary_minus] = ACTIONS(1635),
  },
  [151] = {
    [sym__statement] = STATE(870),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(870),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(870),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(870),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(870),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(870),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(870),
    [sym_if_modifier] = STATE(870),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(870),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(870),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [152] = {
    [sym_assignment] = STATE(871),
    [sym_unary] = STATE(871),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(871),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(871),
    [sym_conditional] = STATE(871),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(871),
    [sym_binary] = STATE(871),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [153] = {
    [sym_assignment] = STATE(873),
    [sym_unary] = STATE(873),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(873),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(873),
    [sym_conditional] = STATE(873),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(873),
    [sym_binary] = STATE(873),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [154] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(876),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1637),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1639),
  },
  [155] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
  },
  [156] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(878),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [157] = {
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_SLASH] = ACTIONS(289),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_EQ_GT] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [158] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(880),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(881),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(1643),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [159] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1645),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [160] = {
    [sym_assignment] = STATE(883),
    [sym_unary] = STATE(883),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(883),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(883),
    [sym_conditional] = STATE(883),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(883),
    [sym_binary] = STATE(883),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [161] = {
    [aux_sym_heredoc_body_repeat1] = STATE(886),
    [sym_interpolation] = STATE(886),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(1647),
    [sym_heredoc_end] = ACTIONS(1649),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(1647),
  },
  [162] = {
    [sym_assignment] = STATE(887),
    [sym_unary] = STATE(887),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(887),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(887),
    [sym_conditional] = STATE(887),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(887),
    [sym_binary] = STATE(887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [163] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(889),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1653),
  },
  [164] = {
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_EQ_GT] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [165] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(890),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [166] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(893),
    [sym_lambda_parameters] = STATE(894),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(893),
    [anon_sym_do] = ACTIONS(1655),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [167] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(1659),
    [sym_identifier] = ACTIONS(1659),
  },
  [168] = {
    [anon_sym_COLON] = ACTIONS(1661),
    [sym_comment] = ACTIONS(49),
  },
  [169] = {
    [sym__method_name] = STATE(898),
    [sym_setter] = STATE(898),
    [sym_symbol] = STATE(898),
    [sym_operator] = STATE(898),
    [sym__method_rest] = STATE(899),
    [sym__variable] = STATE(900),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(1663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(1663),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [170] = {
    [sym__argument] = STATE(914),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(914),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(914),
    [sym_hash_splat_argument] = STATE(914),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(921),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(922),
    [sym_block_argument] = STATE(914),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [171] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(924),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1703),
  },
  [172] = {
    [sym_assignment] = STATE(925),
    [sym_unary] = STATE(925),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(925),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(925),
    [sym_conditional] = STATE(925),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(926),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(925),
    [sym_binary] = STATE(925),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(926),
    [sym__line_break] = ACTIONS(1705),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [173] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(928),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [174] = {
    [sym__argument] = STATE(914),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(914),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(914),
    [sym_hash_splat_argument] = STATE(914),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(929),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(922),
    [sym_block_argument] = STATE(914),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [175] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(932),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1709),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(1711),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [176] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(934),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1713),
  },
  [177] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(936),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(1715),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [178] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(939),
    [sym__body_statement] = STATE(940),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(939),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(1717),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1717),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(1719),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [179] = {
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_EQ_GT] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [180] = {
    [sym__argument] = STATE(914),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(914),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(914),
    [sym_hash_splat_argument] = STATE(914),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(943),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(922),
    [sym_block_argument] = STATE(914),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [181] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(945),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1721),
  },
  [182] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [183] = {
    [sym_assignment] = STATE(956),
    [sym_unary] = STATE(956),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(956),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(956),
    [sym_conditional] = STATE(956),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(956),
    [sym_binary] = STATE(956),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [184] = {
    [sym__statement] = STATE(961),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(961),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(961),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(961),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(961),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(961),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(961),
    [sym_if_modifier] = STATE(961),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(961),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(961),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [185] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(964),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1753),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1755),
  },
  [186] = {
    [sym__argument] = STATE(914),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(914),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(914),
    [sym_hash_splat_argument] = STATE(914),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(965),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(922),
    [sym_block_argument] = STATE(914),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [187] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(1757),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(1757),
    [anon_sym_SLASH_EQ] = ACTIONS(1757),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(1757),
    [anon_sym_PIPE_EQ] = ACTIONS(1757),
    [anon_sym_LT_LT_EQ] = ACTIONS(1757),
    [anon_sym_PLUS_EQ] = ACTIONS(1757),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1757),
    [anon_sym_STAR_EQ] = ACTIONS(1757),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1757),
    [anon_sym_CARET_EQ] = ACTIONS(1757),
    [anon_sym_DASH_EQ] = ACTIONS(1757),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1757),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(1759),
  },
  [188] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_or] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(1661),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(1773),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1785),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [189] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(1789),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1793),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1795),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [190] = {
    [anon_sym_RBRACE] = ACTIONS(1797),
    [sym__heredoc_body_start] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(1799),
    [sym_comment] = ACTIONS(49),
  },
  [191] = {
    [sym_heredoc_body] = STATE(983),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
  },
  [192] = {
    [anon_sym_RBRACE] = ACTIONS(1803),
    [sym__heredoc_body_start] = ACTIONS(1803),
    [anon_sym_COMMA] = ACTIONS(1803),
    [sym_comment] = ACTIONS(49),
  },
  [193] = {
    [sym_block] = STATE(998),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(1000),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(1005),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_do_block] = STATE(998),
    [sym_binary] = STATE(1005),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1815),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1823),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [194] = {
    [anon_sym_EQ] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [aux_sym_chained_string_repeat1] = STATE(1008),
    [sym_string] = STATE(1008),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(1845),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [196] = {
    [anon_sym_RBRACE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(49),
  },
  [197] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(1010),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(1847),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [198] = {
    [sym__terminator] = STATE(1011),
    [sym_heredoc_body] = STATE(1011),
    [sym__do] = STATE(1011),
    [sym__line_break] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(1849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [199] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [200] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [sym__line_break] = ACTIONS(1853),
    [anon_sym_then] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_when] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym___END__] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_end] = ACTIONS(1853),
    [anon_sym_ensure] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_else] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_elsif] = ACTIONS(1853),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [sym__binary_minus] = ACTIONS(1853),
  },
  [201] = {
    [sym__statement] = STATE(1012),
    [sym_unary] = STATE(678),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1012),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_unless_modifier] = STATE(1012),
    [sym_symbol] = STATE(674),
    [sym_for] = STATE(674),
    [sym_if] = STATE(674),
    [sym__primary] = STATE(674),
    [sym_method] = STATE(674),
    [sym_conditional] = STATE(678),
    [sym_left_assignment_list] = STATE(675),
    [sym_return] = STATE(674),
    [sym_true] = STATE(677),
    [sym_while_modifier] = STATE(1012),
    [sym_subshell] = STATE(674),
    [sym_unless] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_begin_block] = STATE(1012),
    [sym_range] = STATE(678),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(677),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_array] = STATE(674),
    [sym_call] = STATE(676),
    [sym_end_block] = STATE(1012),
    [sym_assignment] = STATE(678),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_alias] = STATE(1012),
    [sym_if_modifier] = STATE(1012),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(678),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(678),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_rational] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_until_modifier] = STATE(1012),
    [sym_lambda] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_binary] = STATE(678),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_nil] = STATE(677),
    [sym_rescue_modifier] = STATE(1012),
    [sym_symbol_array] = STATE(674),
    [sym_case] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_scope_resolution] = STATE(676),
    [sym_float] = ACTIONS(1233),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_undef] = ACTIONS(1237),
    [sym_self] = ACTIONS(1239),
    [anon_sym_BEGIN] = ACTIONS(1241),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_unless] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym_complex] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [sym_super] = ACTIONS(1239),
    [anon_sym_alias] = ACTIONS(1255),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_character] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_END] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1267),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1283),
    [sym_class_variable] = ACTIONS(1267),
    [sym__symbol_start] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1287),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_class] = ACTIONS(1295),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [sym_retry] = ACTIONS(1233),
    [sym__regex_start] = ACTIONS(1309),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_FALSE] = ACTIONS(1303),
    [sym_redo] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1313),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [202] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(1855),
  },
  [203] = {
    [sym_interpolation] = STATE(1014),
    [aux_sym__literal_contents_repeat1] = STATE(1014),
    [sym_escape_sequence] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(1857),
    [sym__string_end] = ACTIONS(1325),
  },
  [204] = {
    [sym__argument] = STATE(1021),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(1021),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(1021),
    [sym_hash_splat_argument] = STATE(1021),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(1024),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(1025),
    [sym_block_argument] = STATE(1021),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [205] = {
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_in] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(391),
    [sym_comment] = ACTIONS(49),
  },
  [206] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1028),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1873),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1875),
  },
  [207] = {
    [sym_assignment] = STATE(1029),
    [sym_unary] = STATE(1029),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1029),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1029),
    [sym_conditional] = STATE(1029),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1029),
    [sym_binary] = STATE(1029),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [208] = {
    [sym_assignment] = STATE(1030),
    [sym_unary] = STATE(1030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1030),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1030),
    [sym_conditional] = STATE(1030),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(1031),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1030),
    [sym_binary] = STATE(1030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(1031),
    [sym__line_break] = ACTIONS(1877),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [209] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1033),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1879),
  },
  [210] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(1035),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [211] = {
    [sym__argument] = STATE(1021),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(1021),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(1021),
    [sym_hash_splat_argument] = STATE(1021),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(1036),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(1025),
    [sym_block_argument] = STATE(1021),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [212] = {
    [sym__statement] = STATE(1037),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1037),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1037),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1037),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1037),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1037),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1037),
    [sym_if_modifier] = STATE(1037),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1037),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1037),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [213] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(1040),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1883),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(1885),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [214] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(1042),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(1887),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [215] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(1045),
    [sym__body_statement] = STATE(1046),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(1045),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(1889),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(1891),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [216] = {
    [anon_sym_DOT] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_EQ] = ACTIONS(719),
    [sym_comment] = ACTIONS(49),
  },
  [217] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1050),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1893),
  },
  [218] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1053),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(1895),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(1897),
  },
  [219] = {
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
  },
  [220] = {
    [anon_sym_DOT] = ACTIONS(291),
    [anon_sym_in] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_EQ] = ACTIONS(291),
    [sym_comment] = ACTIONS(49),
  },
  [221] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(1055),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1899),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [222] = {
    [sym__lhs] = STATE(389),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(389),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(389),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(389),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(389),
    [sym_nil] = STATE(389),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [sym__symbol_start] = ACTIONS(461),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(1901),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(393),
  },
  [223] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(1057),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(1058),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(1903),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [224] = {
    [sym__argument] = STATE(1021),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(1021),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(1021),
    [sym_hash_splat_argument] = STATE(1021),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(1059),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(1025),
    [sym_block_argument] = STATE(1021),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [225] = {
    [sym_assignment] = STATE(1060),
    [sym_unary] = STATE(1060),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1060),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1060),
    [sym_conditional] = STATE(1060),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1060),
    [sym_binary] = STATE(1060),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [226] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1062),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1905),
  },
  [227] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(1907),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
  },
  [228] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(1064),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [229] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1066),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(1909),
  },
  [230] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(1069),
    [sym_lambda_parameters] = STATE(1070),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(1069),
    [anon_sym_do] = ACTIONS(1911),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [231] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(1915),
    [sym_identifier] = ACTIONS(1915),
  },
  [232] = {
    [sym__method_name] = STATE(1073),
    [sym_setter] = STATE(1073),
    [sym_symbol] = STATE(1073),
    [sym_operator] = STATE(1073),
    [sym__method_rest] = STATE(1074),
    [sym__variable] = STATE(1075),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(1917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(1917),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [233] = {
    [sym__argument] = STATE(1021),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(1021),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(1021),
    [sym_hash_splat_argument] = STATE(1021),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(1076),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(1025),
    [sym_block_argument] = STATE(1021),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [234] = {
    [sym__statement] = STATE(1077),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1077),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1077),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1077),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1077),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1077),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1077),
    [sym_if_modifier] = STATE(1077),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1077),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1077),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [235] = {
    [aux_sym__mlhs_repeat1] = STATE(1079),
    [anon_sym_COMMA] = ACTIONS(1921),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(771),
  },
  [236] = {
    [aux_sym__mlhs_repeat1] = STATE(1079),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
  },
  [237] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(1923),
    [anon_sym_AMP_DOT] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_COLON_COLON2] = ACTIONS(1927),
  },
  [238] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1104),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym__primary] = STATE(1098),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1102),
    [sym_method] = STATE(1098),
    [sym_conditional] = STATE(1104),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_subshell] = STATE(1098),
    [sym_unless] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_block_argument] = STATE(1102),
    [sym_range] = STATE(1104),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1103),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_call] = STATE(1101),
    [sym__argument] = STATE(1102),
    [sym_assignment] = STATE(1104),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_pair] = STATE(1102),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(1104),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(1102),
    [sym_operator_assignment] = STATE(1104),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_rational] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(1105),
    [sym_lambda] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(1106),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1104),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_nil] = STATE(1103),
    [sym_symbol_array] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_scope_resolution] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [sym_constant] = ACTIONS(1941),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [sym__identifier_hash_key] = ACTIONS(1949),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(1953),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_in] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1965),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [239] = {
    [aux_sym_chained_string_repeat1] = STATE(1107),
    [sym_string] = STATE(1107),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(743),
    [sym__string_start] = ACTIONS(443),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
  },
  [240] = {
    [sym_in] = STATE(1109),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [241] = {
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [sym_comment] = ACTIONS(49),
  },
  [242] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(1124),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(1127),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(1127),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(1132),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(1977),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2011),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [243] = {
    [anon_sym_do] = ACTIONS(2015),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(2019),
    [sym_comment] = ACTIONS(49),
  },
  [244] = {
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_COLON] = ACTIONS(2023),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_lambda] = STATE(1137),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [sym_identifier] = ACTIONS(2027),
  },
  [246] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(1140),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(1141),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [247] = {
    [sym_splat_parameter] = STATE(1147),
    [sym_hash_splat_parameter] = STATE(1147),
    [sym_block_parameter] = STATE(1147),
    [sym__formal_parameter] = STATE(1147),
    [sym__simple_formal_parameter] = STATE(1147),
    [sym_keyword_parameter] = STATE(1147),
    [sym_optional_parameter] = STATE(1147),
    [sym_destructured_parameter] = STATE(1147),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(2039),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [248] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [sym__line_break] = ACTIONS(2045),
    [anon_sym_then] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym___END__] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_end] = ACTIONS(2045),
    [anon_sym_ensure] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_elsif] = ACTIONS(2045),
    [ts_builtin_sym_end] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [sym__binary_minus] = ACTIONS(2045),
  },
  [249] = {
    [sym_do_block] = STATE(1148),
    [sym_block] = STATE(1148),
    [anon_sym_do] = ACTIONS(2047),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(467),
  },
  [250] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(1150),
    [anon_sym_do] = ACTIONS(2049),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [sym_comment] = ACTIONS(49),
  },
  [251] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym___END__] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [ts_builtin_sym_end] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [252] = {
    [sym__line_break] = ACTIONS(1045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1045),
  },
  [253] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1152),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2057),
  },
  [254] = {
    [sym_assignment] = STATE(1162),
    [sym_unary] = STATE(1162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(1162),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(1162),
    [sym_conditional] = STATE(1162),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(1162),
    [sym_binary] = STATE(1162),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [255] = {
    [sym__line_break] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1331),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [sym__heredoc_body_start] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1049),
  },
  [256] = {
    [sym__line_break] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(183),
  },
  [257] = {
    [sym__line_break] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [sym__heredoc_body_start] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(1049),
  },
  [258] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(1173),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(1173),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(1173),
    [sym__line_break] = ACTIONS(2089),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [259] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [sym__line_break] = ACTIONS(2103),
    [anon_sym_then] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_when] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym___END__] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_end] = ACTIONS(2103),
    [anon_sym_ensure] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_elsif] = ACTIONS(2103),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [sym__binary_minus] = ACTIONS(2103),
  },
  [260] = {
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_COLON_COLON] = ACTIONS(2105),
    [sym_comment] = ACTIONS(49),
  },
  [261] = {
    [sym_assignment] = STATE(1176),
    [sym_unary] = STATE(1176),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1176),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1176),
    [sym_conditional] = STATE(1176),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1176),
    [sym_binary] = STATE(1176),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [262] = {
    [sym__statement] = STATE(1177),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1177),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1177),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1177),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1177),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1177),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1177),
    [sym_if_modifier] = STATE(1177),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1177),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1177),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [263] = {
    [sym_assignment] = STATE(1178),
    [sym_unary] = STATE(1178),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1178),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(1178),
    [sym_conditional] = STATE(1178),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(1178),
    [sym_binary] = STATE(1178),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [264] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [265] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1183),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(2115),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(2117),
  },
  [266] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [sym__line_break] = ACTIONS(183),
    [anon_sym_then] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_PERCENT] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_when] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym___END__] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_end] = ACTIONS(183),
    [anon_sym_ensure] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_elsif] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [sym__binary_minus] = ACTIONS(183),
  },
  [267] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(1185),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2119),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [268] = {
    [anon_sym_SLASH] = ACTIONS(289),
    [sym__line_break] = ACTIONS(291),
    [anon_sym_until] = ACTIONS(291),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_unless] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_rescue] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_while] = ACTIONS(291),
    [sym__heredoc_body_start] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_then] = ACTIONS(291),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_EQ_GT] = ACTIONS(291),
    [anon_sym_when] = ACTIONS(291),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym___END__] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_end] = ACTIONS(291),
    [anon_sym_ensure] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_elsif] = ACTIONS(291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [ts_builtin_sym_end] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [269] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(1187),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(1188),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [270] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(2123),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym___END__] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [271] = {
    [sym_assignment] = STATE(1190),
    [sym_unary] = STATE(1190),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1190),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1190),
    [sym_conditional] = STATE(1190),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1190),
    [sym_binary] = STATE(1190),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [272] = {
    [sym_assignment] = STATE(1191),
    [sym_unary] = STATE(1191),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1191),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(1191),
    [sym_conditional] = STATE(1191),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(1191),
    [sym_binary] = STATE(1191),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [273] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1193),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2125),
  },
  [274] = {
    [anon_sym_SLASH] = ACTIONS(389),
    [sym__line_break] = ACTIONS(391),
    [anon_sym_until] = ACTIONS(391),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_unless] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_rescue] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [sym__heredoc_body_start] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_then] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_EQ_GT] = ACTIONS(391),
    [anon_sym_when] = ACTIONS(391),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym___END__] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_end] = ACTIONS(391),
    [anon_sym_ensure] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_elsif] = ACTIONS(391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [ts_builtin_sym_end] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [275] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(1194),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [276] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(1197),
    [sym_lambda_parameters] = STATE(1198),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(1197),
    [anon_sym_do] = ACTIONS(2127),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [277] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2131),
    [sym_identifier] = ACTIONS(2131),
  },
  [278] = {
    [anon_sym_COLON] = ACTIONS(2133),
    [sym_comment] = ACTIONS(49),
  },
  [279] = {
    [sym__method_name] = STATE(1202),
    [sym_setter] = STATE(1202),
    [sym_symbol] = STATE(1202),
    [sym_operator] = STATE(1202),
    [sym__method_rest] = STATE(1203),
    [sym__variable] = STATE(1204),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(2135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(2135),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [280] = {
    [sym__argument] = STATE(1211),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(1211),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(1211),
    [sym_hash_splat_argument] = STATE(1211),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(1215),
    [sym_block_argument] = STATE(1211),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym___END__] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [ts_builtin_sym_end] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [281] = {
    [sym_assignment] = STATE(1224),
    [sym_unary] = STATE(1224),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1224),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(1224),
    [sym_conditional] = STATE(1224),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(1224),
    [sym_binary] = STATE(1224),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [282] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1228),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2167),
  },
  [283] = {
    [sym_assignment] = STATE(1229),
    [sym_unary] = STATE(1229),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1229),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1229),
    [sym_conditional] = STATE(1229),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(1230),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1229),
    [sym_binary] = STATE(1229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(1230),
    [sym__line_break] = ACTIONS(2169),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [284] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(1252),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(2175),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [285] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(1254),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [286] = {
    [sym_assignment] = STATE(1255),
    [sym_unary] = STATE(1255),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1255),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(1255),
    [sym_conditional] = STATE(1255),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(1255),
    [sym_binary] = STATE(1255),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [287] = {
    [sym__argument] = STATE(1211),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(1211),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(1211),
    [sym_hash_splat_argument] = STATE(1211),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(1215),
    [sym_block_argument] = STATE(1211),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym___END__] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [288] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(1259),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2213),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(2215),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [289] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1261),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2217),
  },
  [290] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(1263),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(2219),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [291] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(1266),
    [sym__body_statement] = STATE(1267),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(1266),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(2221),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2223),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [292] = {
    [anon_sym_SLASH] = ACTIONS(717),
    [sym__line_break] = ACTIONS(719),
    [anon_sym_until] = ACTIONS(719),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_unless] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_rescue] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_while] = ACTIONS(719),
    [sym__heredoc_body_start] = ACTIONS(719),
    [anon_sym_else] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_then] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_EQ_GT] = ACTIONS(719),
    [anon_sym_when] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym___END__] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_end] = ACTIONS(719),
    [anon_sym_ensure] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_elsif] = ACTIONS(719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [ts_builtin_sym_end] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [293] = {
    [sym__argument] = STATE(1211),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(1211),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(1211),
    [sym_hash_splat_argument] = STATE(1211),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(1215),
    [sym_block_argument] = STATE(1211),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [294] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1272),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2225),
  },
  [295] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(2227),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [296] = {
    [sym_assignment] = STATE(1274),
    [sym_unary] = STATE(1274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1274),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(1274),
    [sym_conditional] = STATE(1274),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(1274),
    [sym_binary] = STATE(1274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [297] = {
    [sym__statement] = STATE(1275),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1275),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1275),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1275),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1275),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1275),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1275),
    [sym_if_modifier] = STATE(1275),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1275),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1275),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [298] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1278),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(2229),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(2231),
  },
  [299] = {
    [sym__argument] = STATE(1211),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(1211),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(1211),
    [sym_hash_splat_argument] = STATE(1211),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(1215),
    [sym_block_argument] = STATE(1211),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym___END__] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [ts_builtin_sym_end] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [300] = {
    [sym_heredoc_body] = STATE(1282),
    [aux_sym_call_repeat1] = STATE(1282),
    [aux_sym_argument_list_repeat1] = STATE(1283),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [301] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2241),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [302] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_EQ_GT] = ACTIONS(2133),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [303] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(2273),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2275),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym___END__] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(2279),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [304] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_for] = STATE(452),
    [sym_if] = STATE(452),
    [sym__primary] = STATE(452),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_method] = STATE(452),
    [sym_conditional] = STATE(1309),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_true] = STATE(457),
    [sym_subshell] = STATE(452),
    [sym_unless] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(457),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_array] = STATE(452),
    [sym_call] = STATE(455),
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_lambda] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(1309),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_nil] = STATE(457),
    [sym_symbol_array] = STATE(452),
    [sym_case] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_scope_resolution] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym___END__] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [ts_builtin_sym_end] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [305] = {
    [anon_sym_EQ] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [aux_sym_chained_string_repeat1] = STATE(1312),
    [sym_string] = STATE(1312),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(2297),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [307] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [sym__line_break] = ACTIONS(2301),
    [anon_sym_then] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_when] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym___END__] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_end] = ACTIONS(2301),
    [anon_sym_ensure] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_elsif] = ACTIONS(2301),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [sym__binary_minus] = ACTIONS(2301),
  },
  [308] = {
    [sym_heredoc_body] = STATE(1282),
    [aux_sym_call_repeat1] = STATE(1282),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [309] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [sym__line_break] = ACTIONS(2305),
    [anon_sym_then] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_when] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym___END__] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_end] = ACTIONS(2305),
    [anon_sym_ensure] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_elsif] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [sym__binary_minus] = ACTIONS(2305),
  },
  [310] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(2307),
  },
  [311] = {
    [sym__argument] = STATE(1326),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1326),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(1326),
    [sym_hash_splat_argument] = STATE(1326),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(1332),
    [sym_block_argument] = STATE(1326),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [312] = {
    [sym__argument] = STATE(1326),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1326),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(1326),
    [sym_hash_splat_argument] = STATE(1326),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(1332),
    [sym_block_argument] = STATE(1326),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [313] = {
    [sym_assignment] = STATE(1333),
    [sym_unary] = STATE(1333),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1333),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1333),
    [sym_conditional] = STATE(1333),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1333),
    [sym_binary] = STATE(1333),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [314] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [315] = {
    [sym__argument] = STATE(1326),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1326),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(1326),
    [sym_hash_splat_argument] = STATE(1326),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(1332),
    [sym_block_argument] = STATE(1326),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [316] = {
    [sym_assignment] = STATE(1334),
    [sym_unary] = STATE(1334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1334),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1334),
    [sym_conditional] = STATE(1334),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1334),
    [sym_binary] = STATE(1334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [317] = {
    [sym__argument] = STATE(1326),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1326),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(1326),
    [sym_hash_splat_argument] = STATE(1326),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(1332),
    [sym_block_argument] = STATE(1326),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [318] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(2339),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(2339),
    [anon_sym_SLASH_EQ] = ACTIONS(2339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2339),
    [anon_sym_PIPE_EQ] = ACTIONS(2339),
    [anon_sym_LT_LT_EQ] = ACTIONS(2339),
    [anon_sym_PLUS_EQ] = ACTIONS(2339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2339),
    [anon_sym_STAR_EQ] = ACTIONS(2339),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2339),
    [anon_sym_CARET_EQ] = ACTIONS(2339),
    [anon_sym_DASH_EQ] = ACTIONS(2339),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2339),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(2341),
  },
  [319] = {
    [sym_heredoc_body] = STATE(1347),
    [sym__terminator] = STATE(1347),
    [sym__line_break] = ACTIONS(2343),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [320] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(533),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(535),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(535),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [321] = {
    [anon_sym_EQ] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [aux_sym_chained_string_repeat1] = STATE(1348),
    [sym_string] = STATE(1348),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [323] = {
    [sym_when] = STATE(1353),
    [sym_else] = STATE(1352),
    [aux_sym_case_repeat2] = STATE(1353),
    [aux_sym_case_repeat1] = STATE(1354),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(2377),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(2381),
    [sym_comment] = ACTIONS(49),
  },
  [324] = {
    [sym__method_name] = STATE(1355),
    [sym_setter] = STATE(1355),
    [sym_symbol] = STATE(1355),
    [sym_operator] = STATE(1355),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(2383),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(2383),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [325] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [sym__line_break] = ACTIONS(2387),
    [anon_sym_then] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_when] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym___END__] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_end] = ACTIONS(2387),
    [anon_sym_ensure] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_elsif] = ACTIONS(2387),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [sym__binary_minus] = ACTIONS(2387),
  },
  [326] = {
    [sym_assignment] = STATE(1357),
    [sym_unary] = STATE(1357),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(1357),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(1357),
    [sym_conditional] = STATE(1357),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(1357),
    [sym_binary] = STATE(1357),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [327] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [328] = {
    [sym_assignment] = STATE(1358),
    [sym_unary] = STATE(1358),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(1358),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(1358),
    [sym_conditional] = STATE(1358),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(1358),
    [sym_binary] = STATE(1358),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [329] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2389),
    [sym_identifier] = ACTIONS(2389),
  },
  [330] = {
    [sym__argument] = STATE(1373),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(1373),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(1373),
    [sym_hash_splat_argument] = STATE(1373),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym_block_argument] = STATE(1373),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [331] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [332] = {
    [sym__argument] = STATE(1373),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(1373),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(1373),
    [sym_hash_splat_argument] = STATE(1373),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym_block_argument] = STATE(1373),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [333] = {
    [sym__lhs] = STATE(389),
    [sym_singleton_class] = STATE(1382),
    [sym_module] = STATE(1382),
    [sym_chained_string] = STATE(1382),
    [sym_until] = STATE(1382),
    [sym_regex] = STATE(1382),
    [sym_for] = STATE(1382),
    [sym_symbol] = STATE(1382),
    [sym_if] = STATE(1382),
    [sym_begin] = STATE(1382),
    [sym__primary] = STATE(1382),
    [sym_method_call] = STATE(389),
    [sym_method] = STATE(1382),
    [sym_singleton_method] = STATE(1382),
    [sym__variable] = STATE(1383),
    [sym_rational] = STATE(1382),
    [sym_true] = STATE(389),
    [sym_return] = STATE(1382),
    [sym_subshell] = STATE(1382),
    [sym_yield] = STATE(1382),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(1382),
    [sym_lambda] = STATE(1382),
    [sym_parenthesized_statements] = STATE(1382),
    [sym_element_reference] = STATE(389),
    [sym_class] = STATE(1382),
    [sym_break] = STATE(1382),
    [sym_next] = STATE(1382),
    [sym_string_array] = STATE(1382),
    [sym_while] = STATE(1382),
    [sym_case] = STATE(1382),
    [sym_symbol_array] = STATE(1382),
    [sym_array] = STATE(1382),
    [sym_hash] = STATE(1382),
    [sym_false] = STATE(389),
    [sym_nil] = STATE(389),
    [sym_scope_resolution] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(2427),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(2429),
    [sym_self] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2433),
    [sym_super] = ACTIONS(2429),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2433),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(2433),
    [anon_sym_EQ] = ACTIONS(725),
    [sym__symbol_start] = ACTIONS(461),
  },
  [334] = {
    [sym__argument] = STATE(1373),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(1373),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(1373),
    [sym_hash_splat_argument] = STATE(1373),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym_block_argument] = STATE(1373),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [335] = {
    [sym__argument] = STATE(1373),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(1373),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(1373),
    [sym_hash_splat_argument] = STATE(1373),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1380),
    [sym_block_argument] = STATE(1373),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [336] = {
    [sym_heredoc_body] = STATE(1390),
    [sym__terminator] = STATE(1390),
    [sym__line_break] = ACTIONS(2437),
    [anon_sym_unless] = ACTIONS(2439),
    [anon_sym_until] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2443),
    [sym__heredoc_body_start] = ACTIONS(2445),
    [anon_sym_rescue] = ACTIONS(2447),
    [anon_sym_RPAREN] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2449),
    [sym_comment] = ACTIONS(49),
  },
  [337] = {
    [aux_sym__mlhs_repeat1] = STATE(1392),
    [anon_sym_COMMA] = ACTIONS(2451),
    [anon_sym_RPAREN] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2455),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2457),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [339] = {
    [anon_sym_EQ] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [anon_sym_RPAREN] = ACTIONS(2461),
    [anon_sym_EQ] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym__primary] = STATE(1409),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_method] = STATE(1409),
    [sym_conditional] = STATE(1414),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_subshell] = STATE(1409),
    [sym_unless] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1413),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_call] = STATE(1411),
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_rational] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_lambda] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1414),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_nil] = STATE(1413),
    [sym_symbol_array] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_scope_resolution] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [342] = {
    [aux_sym__mlhs_repeat1] = STATE(1392),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(2497),
    [anon_sym_GT_GT_EQ] = ACTIONS(2497),
    [anon_sym_SLASH_EQ] = ACTIONS(2497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2497),
    [anon_sym_LT_LT_EQ] = ACTIONS(2497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2497),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2497),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2451),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(2497),
    [anon_sym_PLUS_EQ] = ACTIONS(2497),
    [anon_sym_STAR_EQ] = ACTIONS(2497),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2497),
    [anon_sym_DASH_EQ] = ACTIONS(2497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2497),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [343] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [344] = {
    [aux_sym_chained_string_repeat1] = STATE(1428),
    [sym_string] = STATE(1428),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [345] = {
    [anon_sym_RPAREN] = ACTIONS(2529),
    [sym_comment] = ACTIONS(49),
  },
  [346] = {
    [sym__statement] = STATE(1430),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1430),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(1430),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_while_modifier] = STATE(1430),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(1431),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(1430),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1356),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(1430),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(1430),
    [sym_if_modifier] = STATE(1430),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(1430),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(1356),
    [sym_rescue_modifier] = STATE(1430),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(1431),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(757),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [347] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [sym__line_break] = ACTIONS(2533),
    [anon_sym_then] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_when] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym___END__] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_end] = ACTIONS(2533),
    [anon_sym_ensure] = ACTIONS(2533),
    [anon_sym_else] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_elsif] = ACTIONS(2533),
    [ts_builtin_sym_end] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [sym__binary_minus] = ACTIONS(2533),
  },
  [348] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1356),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym__statements] = STATE(1035),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(1356),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [349] = {
    [sym_assignment] = STATE(1432),
    [sym_unary] = STATE(1432),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1432),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1432),
    [sym_conditional] = STATE(1432),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1432),
    [sym_binary] = STATE(1432),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [350] = {
    [sym_heredoc_body] = STATE(1434),
    [sym__terminator] = STATE(1434),
    [sym_superclass] = STATE(1435),
    [sym__line_break] = ACTIONS(2535),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [351] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2539),
    [sym_identifier] = ACTIONS(2539),
  },
  [352] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2541),
    [anon_sym_AMP_DOT] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_COLON_COLON2] = ACTIONS(2543),
  },
  [353] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [354] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(1435),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(1434),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(1434),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(2535),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [355] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [sym__line_break] = ACTIONS(2577),
    [anon_sym_then] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_when] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym___END__] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_end] = ACTIONS(2577),
    [anon_sym_ensure] = ACTIONS(2577),
    [anon_sym_else] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_elsif] = ACTIONS(2577),
    [ts_builtin_sym_end] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [sym__binary_minus] = ACTIONS(2577),
  },
  [356] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(2579),
  },
  [357] = {
    [sym_heredoc_body] = STATE(1460),
    [sym__terminator] = STATE(1460),
    [sym__line_break] = ACTIONS(2581),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(2583),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [358] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2585),
  },
  [359] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2541),
    [anon_sym_AMP_DOT] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_COLON_COLON2] = ACTIONS(2587),
  },
  [360] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(1460),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(1460),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(2581),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(2583),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [361] = {
    [sym__method_name] = STATE(1463),
    [sym_setter] = STATE(1463),
    [sym_symbol] = STATE(1463),
    [sym_operator] = STATE(1463),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(2589),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(2589),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [362] = {
    [sym_assignment] = STATE(1464),
    [sym_unary] = STATE(1464),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(1464),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(1464),
    [sym_conditional] = STATE(1464),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(1464),
    [sym_binary] = STATE(1464),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [363] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [364] = {
    [sym_call] = STATE(1483),
    [sym_nil] = STATE(1479),
    [sym_assignment] = STATE(1480),
    [sym_unary] = STATE(1480),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym__arg] = STATE(1480),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_splat_argument] = STATE(1482),
    [sym_operator_assignment] = STATE(1480),
    [sym_conditional] = STATE(1480),
    [sym__arg_or_splat_arg] = STATE(1482),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_rational] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_subshell] = STATE(1481),
    [sym_left_assignment_list] = STATE(1485),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_heredoc_body] = STATE(1487),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_exceptions] = STATE(1486),
    [sym_range] = STATE(1480),
    [sym_binary] = STATE(1480),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym__terminator] = STATE(1487),
    [sym_then] = STATE(1477),
    [sym_exception_variable] = STATE(1478),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym__line_break] = ACTIONS(2591),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2595),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2603),
    [sym__heredoc_body_start] = ACTIONS(2605),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_then] = ACTIONS(2615),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_GT] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [365] = {
    [aux_sym_heredoc_body_repeat1] = STATE(1489),
    [sym_interpolation] = STATE(1489),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(2629),
    [sym_heredoc_end] = ACTIONS(2631),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(2629),
  },
  [366] = {
    [sym_assignment] = STATE(1490),
    [sym_unary] = STATE(1490),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(1490),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(1490),
    [sym_conditional] = STATE(1490),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(1490),
    [sym_binary] = STATE(1490),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [367] = {
    [sym__statement] = STATE(1501),
    [sym_unary] = STATE(1507),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1501),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_unless_modifier] = STATE(1501),
    [sym_symbol] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym__primary] = STATE(1502),
    [sym_method] = STATE(1502),
    [sym_conditional] = STATE(1507),
    [sym_left_assignment_list] = STATE(1503),
    [sym_return] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_while_modifier] = STATE(1501),
    [sym_subshell] = STATE(1502),
    [sym_unless] = STATE(1502),
    [sym_empty_statement] = STATE(1510),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_begin_block] = STATE(1501),
    [sym_range] = STATE(1507),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1506),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym__terminator] = STATE(1504),
    [sym_call] = STATE(1505),
    [sym_end_block] = STATE(1501),
    [sym_assignment] = STATE(1507),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_alias] = STATE(1501),
    [sym_if_modifier] = STATE(1501),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(1507),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(1507),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_rational] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_until_modifier] = STATE(1501),
    [sym_heredoc_body] = STATE(1504),
    [sym_lambda] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym__statements] = STATE(1509),
    [sym_binary] = STATE(1507),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_nil] = STATE(1506),
    [sym_rescue_modifier] = STATE(1501),
    [sym_symbol_array] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_hash] = STATE(1502),
    [aux_sym__statements_repeat1] = STATE(1510),
    [sym_scope_resolution] = STATE(1505),
    [sym__line_break] = ACTIONS(2633),
    [sym_float] = ACTIONS(2635),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(2637),
    [sym_self] = ACTIONS(2639),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(2639),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(2647),
    [sym__heredoc_body_start] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_yield] = ACTIONS(2655),
    [sym_class_variable] = ACTIONS(2647),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [sym_retry] = ACTIONS(2635),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2665),
    [anon_sym_ensure] = ACTIONS(2665),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [368] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2669),
    [sym_identifier] = ACTIONS(2669),
  },
  [369] = {
    [sym__argument] = STATE(1525),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(1525),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(1525),
    [sym_hash_splat_argument] = STATE(1525),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(1532),
    [sym_block_argument] = STATE(1525),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [370] = {
    [sym__argument] = STATE(1525),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(1525),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(1525),
    [sym_hash_splat_argument] = STATE(1525),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(1532),
    [sym_block_argument] = STATE(1525),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [371] = {
    [sym__argument] = STATE(1525),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(1525),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(1525),
    [sym_hash_splat_argument] = STATE(1525),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(1532),
    [sym_block_argument] = STATE(1525),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [372] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(1534),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2709),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [373] = {
    [sym__argument] = STATE(1525),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(1525),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(1525),
    [sym_hash_splat_argument] = STATE(1525),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(1532),
    [sym_block_argument] = STATE(1525),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [374] = {
    [sym_heredoc_body] = STATE(1540),
    [sym__terminator] = STATE(1540),
    [sym__line_break] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(2713),
    [anon_sym_until] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_rescue] = ACTIONS(2719),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_ensure] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2721),
    [sym_comment] = ACTIONS(49),
  },
  [375] = {
    [anon_sym_end] = ACTIONS(2723),
    [sym_comment] = ACTIONS(49),
  },
  [376] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [377] = {
    [anon_sym_EQ] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_ensure] = STATE(1545),
    [sym_else] = STATE(1546),
    [anon_sym_end] = ACTIONS(2723),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [379] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(1548),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2739),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [380] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [sym__line_break] = ACTIONS(2743),
    [anon_sym_then] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_when] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym___END__] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_end] = ACTIONS(2743),
    [anon_sym_ensure] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_elsif] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [sym__binary_minus] = ACTIONS(2743),
  },
  [381] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym__primary] = STATE(1561),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_method] = STATE(1561),
    [sym_conditional] = STATE(1566),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_subshell] = STATE(1561),
    [sym_unless] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1565),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_call] = STATE(1563),
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_rational] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_lambda] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1566),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_nil] = STATE(1565),
    [sym_symbol_array] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_scope_resolution] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [382] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(2779),
    [anon_sym_GT_GT_EQ] = ACTIONS(2779),
    [anon_sym_SLASH_EQ] = ACTIONS(2779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2779),
    [anon_sym_LT_LT_EQ] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2779),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2779),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(2781),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(2779),
    [anon_sym_PLUS_EQ] = ACTIONS(2779),
    [anon_sym_STAR_EQ] = ACTIONS(2779),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2779),
    [anon_sym_DASH_EQ] = ACTIONS(2779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [383] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_ensure] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [384] = {
    [aux_sym_chained_string_repeat1] = STATE(1580),
    [sym_string] = STATE(1580),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [385] = {
    [sym_ensure] = STATE(1545),
    [sym_else] = STATE(1546),
    [sym_rescue] = STATE(1581),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(2723),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [386] = {
    [sym_ensure] = STATE(1545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(2723),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [387] = {
    [sym__statement] = STATE(1582),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1582),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(1582),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(1582),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(1583),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(1582),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(1582),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(1582),
    [sym_if_modifier] = STATE(1582),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(1582),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(1582),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(1583),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [388] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2813),
    [sym_identifier] = ACTIONS(2813),
  },
  [389] = {
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(2815),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_AMP_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_COLON_COLON2] = ACTIONS(2819),
  },
  [391] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1602),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1600),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1602),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1600),
    [sym_range] = STATE(1602),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1601),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1600),
    [sym_assignment] = STATE(1602),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1600),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1602),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(1600),
    [sym_operator_assignment] = STATE(1602),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1603),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(1604),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1602),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1601),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [sym_constant] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2829),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [sym__block_ampersand] = ACTIONS(2835),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2845),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [392] = {
    [sym_uninterpreted] = ACTIONS(2849),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [sym__line_break] = ACTIONS(2853),
    [anon_sym_then] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_when] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym___END__] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_end] = ACTIONS(2853),
    [anon_sym_ensure] = ACTIONS(2853),
    [anon_sym_else] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_elsif] = ACTIONS(2853),
    [ts_builtin_sym_end] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
    [sym__binary_minus] = ACTIONS(2853),
  },
  [394] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [sym__line_break] = ACTIONS(2857),
    [anon_sym_then] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_when] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym___END__] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_end] = ACTIONS(2857),
    [anon_sym_ensure] = ACTIONS(2857),
    [anon_sym_else] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_elsif] = ACTIONS(2857),
    [ts_builtin_sym_end] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(2857),
  },
  [395] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(2859),
  },
  [396] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [sym__line_break] = ACTIONS(2863),
    [anon_sym_then] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_when] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym___END__] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_end] = ACTIONS(2863),
    [anon_sym_ensure] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_elsif] = ACTIONS(2863),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [sym__binary_minus] = ACTIONS(2863),
  },
  [397] = {
    [sym__terminator] = STATE(1609),
    [sym_heredoc_body] = STATE(1609),
    [sym_then] = STATE(1610),
    [sym__line_break] = ACTIONS(2865),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [398] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [sym__line_break] = ACTIONS(2873),
    [anon_sym_then] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_when] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym___END__] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_end] = ACTIONS(2873),
    [anon_sym_ensure] = ACTIONS(2873),
    [anon_sym_else] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_elsif] = ACTIONS(2873),
    [ts_builtin_sym_end] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [sym__binary_minus] = ACTIONS(2873),
  },
  [399] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1613),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(2875),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(2877),
  },
  [400] = {
    [aux_sym_string_array_repeat1] = STATE(1616),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(2879),
    [sym__string_end] = ACTIONS(2881),
  },
  [401] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [sym__line_break] = ACTIONS(2885),
    [anon_sym_then] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_when] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_ensure] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [ts_builtin_sym_end] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [sym__binary_minus] = ACTIONS(2885),
  },
  [402] = {
    [sym_assignment] = STATE(1617),
    [sym_unary] = STATE(1617),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1617),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1617),
    [sym_conditional] = STATE(1617),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1617),
    [sym_binary] = STATE(1617),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [403] = {
    [sym_assignment] = STATE(1618),
    [sym_unary] = STATE(1618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1618),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1618),
    [sym_conditional] = STATE(1618),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1618),
    [sym_binary] = STATE(1618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [404] = {
    [sym_assignment] = STATE(1619),
    [sym_unary] = STATE(1619),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1619),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1619),
    [sym_conditional] = STATE(1619),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1619),
    [sym_binary] = STATE(1619),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [405] = {
    [aux_sym_heredoc_body_repeat1] = STATE(1621),
    [sym_interpolation] = STATE(1621),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(2887),
    [sym_heredoc_end] = ACTIONS(2889),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(2887),
  },
  [406] = {
    [sym_assignment] = STATE(1622),
    [sym_unary] = STATE(1622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1622),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1622),
    [sym_conditional] = STATE(1622),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1622),
    [sym_binary] = STATE(1622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [407] = {
    [sym_assignment] = STATE(1623),
    [sym_unary] = STATE(1623),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1623),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1623),
    [sym_conditional] = STATE(1623),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1623),
    [sym_binary] = STATE(1623),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [408] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym___END__] = ACTIONS(2891),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [sym_integer] = ACTIONS(2891),
    [ts_builtin_sym_end] = ACTIONS(2893),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [409] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(390),
    [sym_module] = STATE(390),
    [sym_chained_string] = STATE(390),
    [sym_until] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_for] = STATE(390),
    [sym_symbol] = STATE(390),
    [sym_if] = STATE(390),
    [sym_begin] = STATE(390),
    [sym__primary] = STATE(390),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(390),
    [sym_singleton_method] = STATE(390),
    [sym__variable] = STATE(391),
    [sym_rational] = STATE(390),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(390),
    [sym_subshell] = STATE(390),
    [sym_yield] = STATE(390),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(390),
    [sym_lambda] = STATE(390),
    [sym_parenthesized_statements] = STATE(390),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(390),
    [sym_break] = STATE(390),
    [sym_next] = STATE(390),
    [sym_string_array] = STATE(390),
    [sym_while] = STATE(390),
    [sym_case] = STATE(390),
    [sym_symbol_array] = STATE(390),
    [sym_array] = STATE(390),
    [sym_hash] = STATE(390),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(391),
    [sym_call] = STATE(391),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(721),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(723),
    [sym_self] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(727),
    [sym_global_variable] = ACTIONS(729),
    [sym_super] = ACTIONS(723),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(721),
    [sym_constant] = ACTIONS(723),
    [sym_instance_variable] = ACTIONS(729),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(731),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(2895),
    [sym__symbol_start] = ACTIONS(461),
  },
  [410] = {
    [aux_sym__mlhs_repeat1] = STATE(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
  },
  [411] = {
    [sym_heredoc_body] = STATE(1633),
    [sym__argument_list_with_parens] = STATE(1632),
    [aux_sym_call_repeat1] = STATE(1633),
    [sym_argument_list_with_parens] = STATE(1630),
    [sym_operator] = STATE(1630),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_AT] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_DASH_AT] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_BANG_TILDE] = ACTIONS(2901),
    [sym_constant] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2899),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_LT_EQ_GT] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_CARET] = ACTIONS(2901),
  },
  [412] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(1635),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2909),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [413] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2911),
  },
  [414] = {
    [sym_assignment] = STATE(1643),
    [sym_unary] = STATE(1643),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1643),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_splat_argument] = STATE(1645),
    [sym_operator_assignment] = STATE(1643),
    [sym_conditional] = STATE(1643),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_return] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_subshell] = STATE(44),
    [sym__arg_or_splat_arg] = STATE(1645),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(1643),
    [sym_binary] = STATE(1643),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11),
    [sym_character] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [415] = {
    [sym_assignment] = STATE(1646),
    [sym_unary] = STATE(1646),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1646),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1646),
    [sym_conditional] = STATE(1646),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1646),
    [sym_binary] = STATE(1646),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [416] = {
    [sym__statement] = STATE(1647),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1647),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1647),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1647),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1647),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1647),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1647),
    [sym_if_modifier] = STATE(1647),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1647),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1647),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [417] = {
    [sym_assignment] = STATE(1649),
    [sym_unary] = STATE(1649),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1649),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(1649),
    [sym_conditional] = STATE(1649),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(1649),
    [sym_binary] = STATE(1649),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [418] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [419] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1654),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(2933),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(2935),
  },
  [420] = {
    [anon_sym_SLASH] = ACTIONS(181),
    [sym__line_break] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_AMP_EQ] = ACTIONS(183),
    [anon_sym_GT_GT_EQ] = ACTIONS(183),
    [anon_sym_SLASH_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(181),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_PERCENT_EQ] = ACTIONS(183),
    [anon_sym_LT_LT_EQ] = ACTIONS(183),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_CARET_EQ] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_when] = ACTIONS(183),
    [anon_sym_PIPE_EQ] = ACTIONS(183),
    [anon_sym_PLUS_EQ] = ACTIONS(183),
    [anon_sym_STAR_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym___END__] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_end] = ACTIONS(183),
    [anon_sym_ensure] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_elsif] = ACTIONS(183),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_DASH_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(181),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(181),
  },
  [421] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(1656),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2937),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [422] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(1667),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(1676),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [423] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(2971),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym___END__] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [424] = {
    [sym_assignment] = STATE(1678),
    [sym_unary] = STATE(1678),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1678),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1678),
    [sym_conditional] = STATE(1678),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1678),
    [sym_binary] = STATE(1678),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [425] = {
    [sym_assignment] = STATE(1679),
    [sym_unary] = STATE(1679),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1679),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(1679),
    [sym_conditional] = STATE(1679),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(1679),
    [sym_binary] = STATE(1679),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [426] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1681),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(2973),
  },
  [427] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(1682),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [428] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(1684),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(1685),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(1685),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(1686),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(2975),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2977),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [429] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(1688),
    [sym_lambda_parameters] = STATE(1689),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(1688),
    [anon_sym_do] = ACTIONS(2285),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [430] = {
    [anon_sym_COLON] = ACTIONS(2981),
    [sym_comment] = ACTIONS(49),
  },
  [431] = {
    [sym__method_name] = STATE(1692),
    [sym_setter] = STATE(1692),
    [sym_symbol] = STATE(1692),
    [sym_operator] = STATE(1692),
    [sym__method_rest] = STATE(1693),
    [sym__variable] = STATE(1694),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(2983),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [432] = {
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym___END__] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [ts_builtin_sym_end] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [433] = {
    [sym_assignment] = STATE(1726),
    [sym_unary] = STATE(1726),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(1726),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(1726),
    [sym_conditional] = STATE(1726),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(1726),
    [sym_binary] = STATE(1726),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [434] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1732),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3057),
  },
  [435] = {
    [sym_assignment] = STATE(1733),
    [sym_unary] = STATE(1733),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1733),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(1733),
    [sym_conditional] = STATE(1733),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(1734),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(1733),
    [sym_binary] = STATE(1733),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(1734),
    [sym__line_break] = ACTIONS(3059),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [436] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(1736),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(3061),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [437] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(1738),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [438] = {
    [sym_assignment] = STATE(1739),
    [sym_unary] = STATE(1739),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(1739),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(1739),
    [sym_conditional] = STATE(1739),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(1739),
    [sym_binary] = STATE(1739),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [439] = {
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym___END__] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [440] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(1743),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(3065),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(3067),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [441] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1745),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3069),
  },
  [442] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(1747),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(3071),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [443] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(1750),
    [sym__body_statement] = STATE(1751),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(1750),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(3073),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3075),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [444] = {
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [445] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(1756),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3077),
  },
  [446] = {
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(3079),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [447] = {
    [sym_assignment] = STATE(1758),
    [sym_unary] = STATE(1758),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(1758),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(1758),
    [sym_conditional] = STATE(1758),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(1758),
    [sym_binary] = STATE(1758),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [448] = {
    [sym__statement] = STATE(1759),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1759),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(1759),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(1759),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(1759),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(1759),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(1759),
    [sym_if_modifier] = STATE(1759),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(1759),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(1759),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [449] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(1762),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(3081),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(3083),
  },
  [450] = {
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym___END__] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [ts_builtin_sym_end] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [451] = {
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [452] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(2273),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2275),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(2279),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym___END__] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [ts_builtin_sym_end] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [453] = {
    [sym_do_block] = STATE(1765),
    [sym_block] = STATE(1765),
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [454] = {
    [anon_sym_EQ] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_for] = STATE(452),
    [sym_if] = STATE(452),
    [sym__primary] = STATE(452),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(1308),
    [sym_method] = STATE(452),
    [sym_conditional] = STATE(1309),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_true] = STATE(457),
    [sym_subshell] = STATE(452),
    [sym_unless] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_block_argument] = STATE(1308),
    [sym_range] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(457),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_array] = STATE(452),
    [sym_call] = STATE(455),
    [sym__argument] = STATE(1308),
    [sym_assignment] = STATE(1309),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_pair] = STATE(1308),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(1308),
    [sym_operator_assignment] = STATE(1309),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_lambda] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(1311),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(1309),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_nil] = STATE(457),
    [sym_symbol_array] = STATE(452),
    [sym_case] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_scope_resolution] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2289),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym___END__] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [ts_builtin_sym_end] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [456] = {
    [sym_heredoc_body] = STATE(1771),
    [aux_sym_call_repeat1] = STATE(1771),
    [aux_sym_argument_list_repeat1] = STATE(1772),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [457] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3101),
    [anon_sym_GT_GT_EQ] = ACTIONS(3101),
    [anon_sym_SLASH_EQ] = ACTIONS(3101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3101),
    [anon_sym_LT_LT_EQ] = ACTIONS(3101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3101),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(3101),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(3103),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(3101),
    [anon_sym_PLUS_EQ] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3101),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3101),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(3101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3101),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [458] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [459] = {
    [aux_sym_chained_string_repeat1] = STATE(1783),
    [sym_string] = STATE(1783),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(3133),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [460] = {
    [sym_heredoc_body] = STATE(1771),
    [aux_sym_call_repeat1] = STATE(1771),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [461] = {
    [sym_assignment] = STATE(1784),
    [sym_unary] = STATE(1784),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1784),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1784),
    [sym_conditional] = STATE(1784),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1784),
    [sym_binary] = STATE(1784),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [462] = {
    [sym_assignment] = STATE(1785),
    [sym_unary] = STATE(1785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1785),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1785),
    [sym_conditional] = STATE(1785),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1785),
    [sym_binary] = STATE(1785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [463] = {
    [sym_assignment] = STATE(1786),
    [sym_unary] = STATE(1786),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1786),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1786),
    [sym_conditional] = STATE(1786),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1786),
    [sym_binary] = STATE(1786),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [464] = {
    [sym_assignment] = STATE(1787),
    [sym_unary] = STATE(1787),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1787),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1787),
    [sym_conditional] = STATE(1787),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1787),
    [sym_binary] = STATE(1787),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [465] = {
    [sym_assignment] = STATE(1788),
    [sym_unary] = STATE(1788),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1788),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1788),
    [sym_conditional] = STATE(1788),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1788),
    [sym_binary] = STATE(1788),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [466] = {
    [sym_assignment] = STATE(1798),
    [sym_unary] = STATE(1798),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(1798),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(1798),
    [sym_conditional] = STATE(1798),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(1798),
    [sym_binary] = STATE(1798),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [467] = {
    [sym_assignment] = STATE(1803),
    [sym_unary] = STATE(1803),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1803),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1803),
    [sym_conditional] = STATE(1803),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1803),
    [sym_binary] = STATE(1803),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [468] = {
    [sym_assignment] = STATE(1804),
    [sym_unary] = STATE(1804),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1804),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1804),
    [sym_conditional] = STATE(1804),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1804),
    [sym_binary] = STATE(1804),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [469] = {
    [sym_assignment] = STATE(1805),
    [sym_unary] = STATE(1805),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1805),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1805),
    [sym_conditional] = STATE(1805),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1805),
    [sym_binary] = STATE(1805),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [470] = {
    [sym_assignment] = STATE(1806),
    [sym_unary] = STATE(1806),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1806),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1806),
    [sym_conditional] = STATE(1806),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1806),
    [sym_binary] = STATE(1806),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [471] = {
    [sym_assignment] = STATE(1807),
    [sym_unary] = STATE(1807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1807),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(1807),
    [sym_conditional] = STATE(1807),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(1807),
    [sym_binary] = STATE(1807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [472] = {
    [aux_sym_chained_string_repeat1] = STATE(1808),
    [sym_string] = STATE(1808),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym___END__] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [473] = {
    [sym__line_break] = ACTIONS(3167),
    [sym_comment] = ACTIONS(49),
  },
  [474] = {
    [sym_heredoc_body] = STATE(408),
    [sym__terminator] = STATE(408),
    [sym__line_break] = ACTIONS(755),
    [ts_builtin_sym_end] = ACTIONS(3169),
    [anon_sym_unless] = ACTIONS(759),
    [anon_sym___END__] = ACTIONS(3169),
    [anon_sym_until] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(763),
    [sym__heredoc_body_start] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(769),
    [sym_comment] = ACTIONS(49),
  },
  [475] = {
    [sym__statement] = STATE(1819),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1819),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(1819),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(1819),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(475),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(1819),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(1819),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(1819),
    [sym_if_modifier] = STATE(1819),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(1819),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(1819),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(475),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym___END__] = ACTIONS(2891),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [sym_integer] = ACTIONS(3294),
    [ts_builtin_sym_end] = ACTIONS(2893),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [476] = {
    [sym_assignment] = STATE(1826),
    [sym_unary] = STATE(1826),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1826),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(1826),
    [sym_conditional] = STATE(1826),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(1826),
    [sym_binary] = STATE(1826),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [477] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [478] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(3310),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [479] = {
    [sym_assignment] = STATE(1829),
    [sym_unary] = STATE(1829),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1829),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(1829),
    [sym_conditional] = STATE(1829),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(1829),
    [sym_binary] = STATE(1829),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [480] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3312),
  },
  [481] = {
    [anon_sym_COLON] = ACTIONS(3314),
    [sym_comment] = ACTIONS(49),
  },
  [482] = {
    [sym__argument] = STATE(1837),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1837),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(1837),
    [sym_hash_splat_argument] = STATE(1837),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(1840),
    [sym_block_argument] = STATE(1837),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [483] = {
    [sym_assignment] = STATE(1849),
    [sym_unary] = STATE(1849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1849),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(1849),
    [sym_conditional] = STATE(1849),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(1849),
    [sym_binary] = STATE(1849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [484] = {
    [sym_assignment] = STATE(1852),
    [sym_unary] = STATE(1852),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1852),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(1852),
    [sym_conditional] = STATE(1852),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(1852),
    [sym_binary] = STATE(1852),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [485] = {
    [sym__argument] = STATE(1837),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1837),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(1837),
    [sym_hash_splat_argument] = STATE(1837),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(1840),
    [sym_block_argument] = STATE(1837),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [486] = {
    [sym__argument] = STATE(1837),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1837),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(1837),
    [sym_hash_splat_argument] = STATE(1837),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(1840),
    [sym_block_argument] = STATE(1837),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [487] = {
    [sym_assignment] = STATE(1853),
    [sym_unary] = STATE(1853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1853),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(1853),
    [sym_conditional] = STATE(1853),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(1853),
    [sym_binary] = STATE(1853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [488] = {
    [sym__argument] = STATE(1837),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(1837),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(1837),
    [sym_hash_splat_argument] = STATE(1837),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(1840),
    [sym_block_argument] = STATE(1837),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [489] = {
    [sym_heredoc_body] = STATE(1855),
    [aux_sym_call_repeat1] = STATE(1855),
    [aux_sym_argument_list_repeat1] = STATE(1856),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [490] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(3344),
    [anon_sym_SLASH_EQ] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3344),
    [anon_sym_PIPE_EQ] = ACTIONS(3344),
    [anon_sym_LT_LT_EQ] = ACTIONS(3344),
    [anon_sym_PLUS_EQ] = ACTIONS(3344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3344),
    [anon_sym_STAR_EQ] = ACTIONS(3344),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3344),
    [anon_sym_CARET_EQ] = ACTIONS(3344),
    [anon_sym_DASH_EQ] = ACTIONS(3344),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3344),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(3346),
  },
  [491] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_EQ_GT] = ACTIONS(3314),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [492] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(3378),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [493] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(1877),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(1877),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(3380),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [494] = {
    [anon_sym_EQ] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [aux_sym_chained_string_repeat1] = STATE(1880),
    [sym_string] = STATE(1880),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(3392),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [496] = {
    [sym_heredoc_body] = STATE(1855),
    [aux_sym_call_repeat1] = STATE(1855),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [497] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [498] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [499] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [500] = {
    [sym_assignment] = STATE(1881),
    [sym_unary] = STATE(1881),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1881),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1881),
    [sym_conditional] = STATE(1881),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1881),
    [sym_binary] = STATE(1881),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [501] = {
    [sym_assignment] = STATE(1887),
    [sym_unary] = STATE(1887),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1887),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_splat_argument] = STATE(1889),
    [sym_operator_assignment] = STATE(1887),
    [sym_conditional] = STATE(1887),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(1889),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(1887),
    [sym_binary] = STATE(1887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3398),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [sym_global_variable] = ACTIONS(117),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(109),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [502] = {
    [sym_assignment] = STATE(1890),
    [sym_unary] = STATE(1890),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1890),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1890),
    [sym_conditional] = STATE(1890),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1890),
    [sym_binary] = STATE(1890),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [503] = {
    [sym_assignment] = STATE(1891),
    [sym_unary] = STATE(1891),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1891),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1891),
    [sym_conditional] = STATE(1891),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1891),
    [sym_binary] = STATE(1891),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [504] = {
    [sym_assignment] = STATE(1892),
    [sym_unary] = STATE(1892),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(1892),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(1892),
    [sym_conditional] = STATE(1892),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(1892),
    [sym_binary] = STATE(1892),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [505] = {
    [sym_assignment] = STATE(1893),
    [sym_unary] = STATE(1893),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1893),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1893),
    [sym_conditional] = STATE(1893),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1893),
    [sym_binary] = STATE(1893),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [506] = {
    [sym_assignment] = STATE(1894),
    [sym_unary] = STATE(1894),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1894),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1894),
    [sym_conditional] = STATE(1894),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1894),
    [sym_binary] = STATE(1894),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [507] = {
    [sym_assignment] = STATE(1895),
    [sym_unary] = STATE(1895),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1895),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1895),
    [sym_conditional] = STATE(1895),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1895),
    [sym_binary] = STATE(1895),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [508] = {
    [sym_assignment] = STATE(1896),
    [sym_unary] = STATE(1896),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1896),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1896),
    [sym_conditional] = STATE(1896),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1896),
    [sym_binary] = STATE(1896),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [509] = {
    [sym_assignment] = STATE(1897),
    [sym_unary] = STATE(1897),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1897),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1897),
    [sym_conditional] = STATE(1897),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1897),
    [sym_binary] = STATE(1897),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [510] = {
    [sym_assignment] = STATE(1898),
    [sym_unary] = STATE(1898),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1898),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1898),
    [sym_conditional] = STATE(1898),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1898),
    [sym_binary] = STATE(1898),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [511] = {
    [aux_sym_heredoc_body_repeat1] = STATE(1900),
    [sym_interpolation] = STATE(1900),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(3406),
    [sym_heredoc_end] = ACTIONS(3408),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(3406),
  },
  [512] = {
    [sym_assignment] = STATE(1901),
    [sym_unary] = STATE(1901),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1901),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(1901),
    [sym_conditional] = STATE(1901),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(1901),
    [sym_binary] = STATE(1901),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [513] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(1903),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3410),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [514] = {
    [sym_heredoc_body] = STATE(1908),
    [sym__argument_list_with_parens] = STATE(1907),
    [aux_sym_call_repeat1] = STATE(1908),
    [sym_argument_list_with_parens] = STATE(1906),
    [sym_operator] = STATE(1906),
    [anon_sym_LT] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(3414),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3414),
    [anon_sym_PLUS_AT] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3414),
    [anon_sym_GT_GT] = ACTIONS(3414),
    [anon_sym_EQ_TILDE] = ACTIONS(3414),
    [anon_sym_LT_LT] = ACTIONS(3414),
    [anon_sym_TILDE] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym_GT] = ACTIONS(3412),
    [anon_sym_PERCENT] = ACTIONS(3414),
    [anon_sym_DASH_AT] = ACTIONS(3414),
    [anon_sym_EQ_EQ] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_BANG_TILDE] = ACTIONS(3414),
    [sym_constant] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3412),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(3414),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3414),
    [anon_sym_STAR_STAR] = ACTIONS(3414),
    [anon_sym_PIPE] = ACTIONS(3414),
    [anon_sym_DOT_DOT] = ACTIONS(3414),
    [anon_sym_LT_EQ_GT] = ACTIONS(3414),
    [anon_sym_LT_EQ] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [sym_identifier] = ACTIONS(3418),
    [anon_sym_CARET] = ACTIONS(3414),
  },
  [515] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3420),
    [sym_identifier] = ACTIONS(3420),
  },
  [516] = {
    [sym_assignment] = STATE(1910),
    [sym_unary] = STATE(1910),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1910),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(1910),
    [sym_conditional] = STATE(1910),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(1910),
    [sym_binary] = STATE(1910),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [517] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [518] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(1667),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(1676),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(3424),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [519] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(3426),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [520] = {
    [sym_assignment] = STATE(1914),
    [sym_unary] = STATE(1914),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1914),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(1914),
    [sym_conditional] = STATE(1914),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(1914),
    [sym_binary] = STATE(1914),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [521] = {
    [anon_sym_COLON] = ACTIONS(3428),
    [sym_comment] = ACTIONS(49),
  },
  [522] = {
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1041),
  },
  [523] = {
    [sym_assignment] = STATE(1924),
    [sym_unary] = STATE(1924),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(1924),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(1924),
    [sym_conditional] = STATE(1924),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(1924),
    [sym_binary] = STATE(1924),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [524] = {
    [sym_assignment] = STATE(1929),
    [sym_unary] = STATE(1929),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(1929),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(1929),
    [sym_conditional] = STATE(1929),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(1929),
    [sym_binary] = STATE(1929),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [525] = {
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1041),
  },
  [526] = {
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1041),
  },
  [527] = {
    [sym_assignment] = STATE(1930),
    [sym_unary] = STATE(1930),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(1930),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(1930),
    [sym_conditional] = STATE(1930),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(1930),
    [sym_binary] = STATE(1930),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [528] = {
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1041),
  },
  [529] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(3378),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [530] = {
    [sym_do_block] = STATE(1765),
    [sym_block] = STATE(1765),
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [531] = {
    [anon_sym_EQ] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(1877),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(1877),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [533] = {
    [sym_heredoc_body] = STATE(1933),
    [aux_sym_call_repeat1] = STATE(1933),
    [aux_sym_argument_list_repeat1] = STATE(1934),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [534] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3460),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(3460),
    [anon_sym_SLASH_EQ] = ACTIONS(3460),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3460),
    [anon_sym_PIPE_EQ] = ACTIONS(3460),
    [anon_sym_LT_LT_EQ] = ACTIONS(3460),
    [anon_sym_PLUS_EQ] = ACTIONS(3460),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3460),
    [anon_sym_STAR_EQ] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3460),
    [anon_sym_CARET_EQ] = ACTIONS(3460),
    [anon_sym_DASH_EQ] = ACTIONS(3460),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3460),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [535] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_EQ_GT] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [536] = {
    [aux_sym_chained_string_repeat1] = STATE(1945),
    [sym_string] = STATE(1945),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(3492),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [537] = {
    [sym_heredoc_body] = STATE(1933),
    [aux_sym_call_repeat1] = STATE(1933),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [538] = {
    [aux_sym_chained_string_repeat1] = STATE(1946),
    [sym_string] = STATE(1946),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [539] = {
    [sym__line_break] = ACTIONS(2305),
    [anon_sym_then] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym___END__] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_end] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_elsif] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_when] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
  },
  [540] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(3494),
  },
  [541] = {
    [sym__line_break] = ACTIONS(3496),
    [anon_sym_then] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym___END__] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [sym__heredoc_body_start] = ACTIONS(3496),
    [anon_sym_end] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_RPAREN] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym_else] = ACTIONS(3496),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(3496),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [anon_sym_elsif] = ACTIONS(3496),
    [anon_sym_rescue] = ACTIONS(3496),
    [anon_sym_when] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
  },
  [542] = {
    [sym__method_name] = STATE(1948),
    [sym_setter] = STATE(1948),
    [sym_symbol] = STATE(1948),
    [sym_operator] = STATE(1948),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(3498),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [543] = {
    [aux_sym_undef_repeat1] = STATE(1949),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [ts_builtin_sym_end] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym___END__] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [544] = {
    [sym__method_name] = STATE(1950),
    [sym_setter] = STATE(1950),
    [sym_symbol] = STATE(1950),
    [sym_operator] = STATE(1950),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(3502),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(3502),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [545] = {
    [sym__line_break] = ACTIONS(3504),
    [anon_sym_then] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym___END__] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [sym__heredoc_body_start] = ACTIONS(3504),
    [anon_sym_end] = ACTIONS(3504),
    [anon_sym_ensure] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_else] = ACTIONS(3504),
    [sym_comment] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_elsif] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_when] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
  },
  [546] = {
    [sym_assignment] = STATE(1951),
    [sym_unary] = STATE(1951),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1951),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(1951),
    [sym_conditional] = STATE(1951),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(1951),
    [sym_binary] = STATE(1951),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [547] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [548] = {
    [sym_assignment] = STATE(1952),
    [sym_unary] = STATE(1952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1952),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(1952),
    [sym_conditional] = STATE(1952),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(1952),
    [sym_binary] = STATE(1952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [549] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3506),
    [sym_identifier] = ACTIONS(3506),
  },
  [550] = {
    [sym__argument] = STATE(1966),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(1966),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(1966),
    [sym_hash_splat_argument] = STATE(1966),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(1971),
    [sym_block_argument] = STATE(1966),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [551] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [552] = {
    [sym__argument] = STATE(1966),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(1966),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(1966),
    [sym_hash_splat_argument] = STATE(1966),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(1971),
    [sym_block_argument] = STATE(1966),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [553] = {
    [sym__argument] = STATE(1966),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(1966),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(1966),
    [sym_hash_splat_argument] = STATE(1966),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(1971),
    [sym_block_argument] = STATE(1966),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [554] = {
    [sym__argument] = STATE(1966),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(1966),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(1966),
    [sym_hash_splat_argument] = STATE(1966),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(1971),
    [sym_block_argument] = STATE(1966),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [555] = {
    [sym_heredoc_body] = STATE(1978),
    [sym__terminator] = STATE(1978),
    [anon_sym_RBRACE] = ACTIONS(757),
    [sym__line_break] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(3538),
    [anon_sym_until] = ACTIONS(3540),
    [anon_sym_while] = ACTIONS(3542),
    [sym__heredoc_body_start] = ACTIONS(3544),
    [anon_sym_rescue] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(3548),
    [sym_comment] = ACTIONS(49),
  },
  [556] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(3550),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3552),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3554),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [557] = {
    [anon_sym_EQ] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym__primary] = STATE(1994),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_method] = STATE(1994),
    [sym_conditional] = STATE(1999),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_subshell] = STATE(1994),
    [sym_unless] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1998),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_call] = STATE(1996),
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_rational] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_lambda] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1999),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_nil] = STATE(1998),
    [sym_symbol_array] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_scope_resolution] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [559] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3592),
    [anon_sym_GT_GT_EQ] = ACTIONS(3592),
    [anon_sym_SLASH_EQ] = ACTIONS(3592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3592),
    [anon_sym_LT_LT_EQ] = ACTIONS(3592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3592),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(3592),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(3592),
    [anon_sym_PLUS_EQ] = ACTIONS(3592),
    [anon_sym_STAR_EQ] = ACTIONS(3592),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3592),
    [anon_sym_DASH_EQ] = ACTIONS(3592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3592),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [560] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [561] = {
    [aux_sym_chained_string_repeat1] = STATE(2013),
    [sym_string] = STATE(2013),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [562] = {
    [anon_sym_RBRACE] = ACTIONS(3624),
    [sym_comment] = ACTIONS(49),
  },
  [563] = {
    [sym__statement] = STATE(2015),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2015),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(2015),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(2015),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(2016),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(2015),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(2015),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(2015),
    [sym_if_modifier] = STATE(2015),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(2015),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(2015),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(2016),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(757),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [564] = {
    [aux_sym_undef_repeat1] = STATE(2017),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_then] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [565] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [566] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [567] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_then] = ACTIONS(2053),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [568] = {
    [sym_assignment] = STATE(2018),
    [sym_unary] = STATE(2018),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2018),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(2018),
    [sym_conditional] = STATE(2018),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(2018),
    [sym_binary] = STATE(2018),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [569] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [570] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(3630),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [571] = {
    [sym_assignment] = STATE(2021),
    [sym_unary] = STATE(2021),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2021),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(2021),
    [sym_conditional] = STATE(2021),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(2021),
    [sym_binary] = STATE(2021),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [572] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3632),
    [sym_identifier] = ACTIONS(3632),
  },
  [573] = {
    [anon_sym_COLON] = ACTIONS(3634),
    [sym_comment] = ACTIONS(49),
  },
  [574] = {
    [sym__argument] = STATE(2029),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(2029),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(2029),
    [sym_hash_splat_argument] = STATE(2029),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(2032),
    [sym_block_argument] = STATE(2029),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [575] = {
    [sym_assignment] = STATE(2041),
    [sym_unary] = STATE(2041),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2041),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(2041),
    [sym_conditional] = STATE(2041),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(2041),
    [sym_binary] = STATE(2041),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [576] = {
    [sym_assignment] = STATE(2044),
    [sym_unary] = STATE(2044),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2044),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(2044),
    [sym_conditional] = STATE(2044),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(2044),
    [sym_binary] = STATE(2044),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [577] = {
    [sym__argument] = STATE(2029),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(2029),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(2029),
    [sym_hash_splat_argument] = STATE(2029),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(2032),
    [sym_block_argument] = STATE(2029),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [578] = {
    [sym__argument] = STATE(2029),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(2029),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(2029),
    [sym_hash_splat_argument] = STATE(2029),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(2032),
    [sym_block_argument] = STATE(2029),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [579] = {
    [sym_assignment] = STATE(2045),
    [sym_unary] = STATE(2045),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2045),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(2045),
    [sym_conditional] = STATE(2045),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(2045),
    [sym_binary] = STATE(2045),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [580] = {
    [sym__argument] = STATE(2029),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(2029),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(2029),
    [sym_hash_splat_argument] = STATE(2029),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(2032),
    [sym_block_argument] = STATE(2029),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [581] = {
    [sym_heredoc_body] = STATE(2047),
    [aux_sym_call_repeat1] = STATE(2047),
    [aux_sym_argument_list_repeat1] = STATE(2048),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [582] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3664),
    [anon_sym_GT_GT_EQ] = ACTIONS(3664),
    [anon_sym_SLASH_EQ] = ACTIONS(3664),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3664),
    [anon_sym_LT_LT_EQ] = ACTIONS(3664),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(3664),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(3664),
    [anon_sym_PLUS_EQ] = ACTIONS(3664),
    [anon_sym_STAR_EQ] = ACTIONS(3664),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3664),
    [anon_sym_DASH_EQ] = ACTIONS(3664),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3664),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [583] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [584] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(3694),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3696),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3698),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [585] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_for] = STATE(613),
    [sym_if] = STATE(613),
    [sym__primary] = STATE(613),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_method] = STATE(613),
    [sym_conditional] = STATE(2068),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_true] = STATE(617),
    [sym_subshell] = STATE(613),
    [sym_unless] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(617),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_array] = STATE(613),
    [sym_call] = STATE(615),
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_rational] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_lambda] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(2068),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_nil] = STATE(617),
    [sym_symbol_array] = STATE(613),
    [sym_case] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_scope_resolution] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [586] = {
    [anon_sym_EQ] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [aux_sym_chained_string_repeat1] = STATE(2071),
    [sym_string] = STATE(2071),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(3710),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [588] = {
    [sym_heredoc_body] = STATE(2047),
    [aux_sym_call_repeat1] = STATE(2047),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [589] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3728),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3728),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [590] = {
    [sym_assignment] = STATE(2091),
    [sym_unary] = STATE(2091),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2091),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2091),
    [sym_conditional] = STATE(2091),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2091),
    [sym_binary] = STATE(2091),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [591] = {
    [sym_assignment] = STATE(2092),
    [sym_unary] = STATE(2092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2092),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2092),
    [sym_conditional] = STATE(2092),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2092),
    [sym_binary] = STATE(2092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [592] = {
    [sym_assignment] = STATE(2093),
    [sym_unary] = STATE(2093),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2093),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2093),
    [sym_conditional] = STATE(2093),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2093),
    [sym_binary] = STATE(2093),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [593] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2095),
    [sym_interpolation] = STATE(2095),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(3746),
    [sym_heredoc_end] = ACTIONS(3748),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(3746),
  },
  [594] = {
    [sym_assignment] = STATE(2096),
    [sym_unary] = STATE(2096),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2096),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2096),
    [sym_conditional] = STATE(2096),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2096),
    [sym_binary] = STATE(2096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [595] = {
    [sym_assignment] = STATE(2097),
    [sym_unary] = STATE(2097),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2097),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2097),
    [sym_conditional] = STATE(2097),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2097),
    [sym_binary] = STATE(2097),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [596] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(2100),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3754),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [597] = {
    [sym_else] = STATE(2100),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(3756),
    [sym_comment] = ACTIONS(49),
  },
  [598] = {
    [sym_heredoc_body] = STATE(2105),
    [sym__argument_list_with_parens] = STATE(2104),
    [aux_sym_call_repeat1] = STATE(2105),
    [sym_argument_list_with_parens] = STATE(2103),
    [sym_operator] = STATE(2103),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3760),
    [anon_sym_PLUS_AT] = ACTIONS(3760),
    [anon_sym_LPAREN2] = ACTIONS(3762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_EQ_TILDE] = ACTIONS(3760),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_GT] = ACTIONS(3758),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_DASH_AT] = ACTIONS(3760),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3758),
    [anon_sym_BANG_TILDE] = ACTIONS(3760),
    [sym_constant] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3758),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(3760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3760),
    [anon_sym_STAR_STAR] = ACTIONS(3760),
    [anon_sym_PIPE] = ACTIONS(3760),
    [anon_sym_DOT_DOT] = ACTIONS(3760),
    [anon_sym_LT_EQ_GT] = ACTIONS(3760),
    [anon_sym_LT_EQ] = ACTIONS(3758),
    [anon_sym_BANG] = ACTIONS(3758),
    [sym_identifier] = ACTIONS(3764),
    [anon_sym_CARET] = ACTIONS(3760),
  },
  [599] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3766),
  },
  [600] = {
    [sym_assignment] = STATE(2112),
    [sym_unary] = STATE(2112),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2112),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_splat_argument] = STATE(2114),
    [sym_operator_assignment] = STATE(2112),
    [sym_conditional] = STATE(2112),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_return] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_subshell] = STATE(84),
    [sym__arg_or_splat_arg] = STATE(2114),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(2112),
    [sym_binary] = STATE(2112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(147),
    [sym_character] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [601] = {
    [sym_assignment] = STATE(2115),
    [sym_unary] = STATE(2115),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2115),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(2115),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(2115),
    [sym_binary] = STATE(2115),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [602] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [603] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [604] = {
    [sym_assignment] = STATE(2118),
    [sym_unary] = STATE(2118),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2118),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(2118),
    [sym_conditional] = STATE(2118),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(2118),
    [sym_binary] = STATE(2118),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [605] = {
    [anon_sym_COLON] = ACTIONS(3784),
    [sym_comment] = ACTIONS(49),
  },
  [606] = {
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [607] = {
    [sym_assignment] = STATE(2128),
    [sym_unary] = STATE(2128),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(2128),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(2128),
    [sym_conditional] = STATE(2128),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(2128),
    [sym_binary] = STATE(2128),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [608] = {
    [sym_assignment] = STATE(2133),
    [sym_unary] = STATE(2133),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(2133),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(2133),
    [sym_conditional] = STATE(2133),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(2133),
    [sym_binary] = STATE(2133),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [609] = {
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [610] = {
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [611] = {
    [sym_assignment] = STATE(2134),
    [sym_unary] = STATE(2134),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(2134),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(2134),
    [sym_conditional] = STATE(2134),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(2134),
    [sym_binary] = STATE(2134),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [612] = {
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [613] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(3694),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3696),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(3698),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [614] = {
    [anon_sym_EQ] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
  },
  [615] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_for] = STATE(613),
    [sym_if] = STATE(613),
    [sym__primary] = STATE(613),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(2067),
    [sym_method] = STATE(613),
    [sym_conditional] = STATE(2068),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_true] = STATE(617),
    [sym_subshell] = STATE(613),
    [sym_unless] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_block_argument] = STATE(2067),
    [sym_range] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(617),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_array] = STATE(613),
    [sym_call] = STATE(615),
    [sym__argument] = STATE(2067),
    [sym_assignment] = STATE(2068),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_pair] = STATE(2067),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(2067),
    [sym_operator_assignment] = STATE(2068),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_rational] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_lambda] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(2070),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(2068),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_nil] = STATE(617),
    [sym_symbol_array] = STATE(613),
    [sym_case] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_scope_resolution] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3704),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [616] = {
    [sym_heredoc_body] = STATE(2137),
    [aux_sym_call_repeat1] = STATE(2137),
    [aux_sym_argument_list_repeat1] = STATE(2138),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [617] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(3816),
    [anon_sym_GT_GT_EQ] = ACTIONS(3816),
    [anon_sym_SLASH_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(3816),
    [anon_sym_LT_LT_EQ] = ACTIONS(3816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(3816),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(3816),
    [anon_sym_PLUS_EQ] = ACTIONS(3816),
    [anon_sym_STAR_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3816),
    [anon_sym_DASH_EQ] = ACTIONS(3816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [618] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(3784),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [619] = {
    [aux_sym_chained_string_repeat1] = STATE(2149),
    [sym_string] = STATE(2149),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(3848),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [620] = {
    [sym_heredoc_body] = STATE(2137),
    [aux_sym_call_repeat1] = STATE(2137),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [621] = {
    [sym_assignment] = STATE(2150),
    [sym_unary] = STATE(2150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2150),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2150),
    [sym_conditional] = STATE(2150),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2150),
    [sym_binary] = STATE(2150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [622] = {
    [sym_assignment] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [623] = {
    [sym_assignment] = STATE(2152),
    [sym_unary] = STATE(2152),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2152),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2152),
    [sym_conditional] = STATE(2152),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2152),
    [sym_binary] = STATE(2152),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [624] = {
    [sym_assignment] = STATE(2153),
    [sym_unary] = STATE(2153),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2153),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2153),
    [sym_conditional] = STATE(2153),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2153),
    [sym_binary] = STATE(2153),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [625] = {
    [sym_assignment] = STATE(2154),
    [sym_unary] = STATE(2154),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2154),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2154),
    [sym_conditional] = STATE(2154),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2154),
    [sym_binary] = STATE(2154),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [626] = {
    [sym_assignment] = STATE(2155),
    [sym_unary] = STATE(2155),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(2155),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(2155),
    [sym_conditional] = STATE(2155),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(2155),
    [sym_binary] = STATE(2155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [627] = {
    [sym_assignment] = STATE(2156),
    [sym_unary] = STATE(2156),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2156),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2156),
    [sym_conditional] = STATE(2156),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2156),
    [sym_binary] = STATE(2156),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [628] = {
    [sym_assignment] = STATE(2157),
    [sym_unary] = STATE(2157),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2157),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2157),
    [sym_conditional] = STATE(2157),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2157),
    [sym_binary] = STATE(2157),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [629] = {
    [sym_assignment] = STATE(2158),
    [sym_unary] = STATE(2158),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2158),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2158),
    [sym_conditional] = STATE(2158),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2158),
    [sym_binary] = STATE(2158),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [630] = {
    [sym_assignment] = STATE(2159),
    [sym_unary] = STATE(2159),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2159),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2159),
    [sym_conditional] = STATE(2159),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2159),
    [sym_binary] = STATE(2159),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [631] = {
    [sym_assignment] = STATE(2160),
    [sym_unary] = STATE(2160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2160),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(2160),
    [sym_conditional] = STATE(2160),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(2160),
    [sym_binary] = STATE(2160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [632] = {
    [aux_sym_chained_string_repeat1] = STATE(2161),
    [sym_string] = STATE(2161),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [633] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [sym__line_break] = ACTIONS(3852),
    [anon_sym_then] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym___END__] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_end] = ACTIONS(3852),
    [anon_sym_ensure] = ACTIONS(3852),
    [anon_sym_else] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_elsif] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
    [sym__binary_minus] = ACTIONS(3852),
  },
  [634] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(3854),
  },
  [635] = {
    [aux_sym_symbol_array_repeat1] = STATE(2165),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(3856),
    [sym__string_end] = ACTIONS(3858),
  },
  [636] = {
    [sym_assignment] = STATE(2166),
    [sym_unary] = STATE(2166),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2166),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2166),
    [sym_conditional] = STATE(2166),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2166),
    [sym_binary] = STATE(2166),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [637] = {
    [sym__method_name] = STATE(2169),
    [sym_setter] = STATE(2169),
    [sym_symbol] = STATE(2169),
    [sym_operator] = STATE(2169),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(3862),
    [sym_class_variable] = ACTIONS(3864),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3862),
    [anon_sym_PLUS_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3862),
    [anon_sym_GT_GT] = ACTIONS(3862),
    [anon_sym_EQ_TILDE] = ACTIONS(3862),
    [anon_sym_LT_LT] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_global_variable] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3862),
    [sym__simple_symbol] = ACTIONS(433),
    [anon_sym_DASH_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_BANG_TILDE] = ACTIONS(3862),
    [sym_constant] = ACTIONS(3864),
    [anon_sym_DASH] = ACTIONS(3860),
    [sym_instance_variable] = ACTIONS(3864),
    [anon_sym_GT_EQ] = ACTIONS(3862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3860),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3862),
    [anon_sym_STAR_STAR] = ACTIONS(3862),
    [anon_sym_PIPE] = ACTIONS(3862),
    [anon_sym_DOT_DOT] = ACTIONS(3862),
    [anon_sym_LT_EQ_GT] = ACTIONS(3862),
    [anon_sym_LT_EQ] = ACTIONS(3860),
    [anon_sym_BANG] = ACTIONS(3860),
    [sym_identifier] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3862),
    [sym__symbol_start] = ACTIONS(461),
  },
  [638] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(3868),
  },
  [639] = {
    [sym__statement] = STATE(2171),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2171),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2171),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2171),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2171),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2171),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2171),
    [sym_if_modifier] = STATE(2171),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2171),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2171),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [640] = {
    [sym_assignment] = STATE(2172),
    [sym_unary] = STATE(2172),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(2172),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(2172),
    [sym_conditional] = STATE(2172),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(2172),
    [sym_binary] = STATE(2172),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [641] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [642] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2176),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(3870),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(3872),
  },
  [643] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_COLON2] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [sym__binary_minus] = ACTIONS(183),
  },
  [644] = {
    [sym__method_name] = STATE(2177),
    [sym_setter] = STATE(2177),
    [sym_symbol] = STATE(2177),
    [sym_operator] = STATE(2177),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(187),
    [sym_class_variable] = ACTIONS(3874),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(187),
    [anon_sym_PLUS_AT] = ACTIONS(187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_TILDE] = ACTIONS(187),
    [sym_global_variable] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(185),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(185),
    [anon_sym_PERCENT] = ACTIONS(187),
    [sym__simple_symbol] = ACTIONS(191),
    [anon_sym_DASH_AT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_BANG_TILDE] = ACTIONS(187),
    [sym_constant] = ACTIONS(3874),
    [anon_sym_DASH] = ACTIONS(185),
    [sym_instance_variable] = ACTIONS(3874),
    [anon_sym_GT_EQ] = ACTIONS(187),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(185),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(187),
    [anon_sym_LT_EQ_GT] = ACTIONS(187),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(185),
    [sym_identifier] = ACTIONS(193),
    [anon_sym_CARET] = ACTIONS(187),
    [sym__symbol_start] = ACTIONS(195),
  },
  [645] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2179),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(3876),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [646] = {
    [anon_sym_SLASH] = ACTIONS(289),
    [anon_sym_until] = ACTIONS(291),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(291),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_unless] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_rescue] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_COLON2] = ACTIONS(289),
    [anon_sym_while] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [647] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(2181),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(2182),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [648] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(3880),
  },
  [649] = {
    [sym_assignment] = STATE(2184),
    [sym_unary] = STATE(2184),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2184),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2184),
    [sym_conditional] = STATE(2184),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2184),
    [sym_binary] = STATE(2184),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [650] = {
    [sym_assignment] = STATE(2185),
    [sym_unary] = STATE(2185),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(2185),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(2185),
    [sym_conditional] = STATE(2185),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(2185),
    [sym_binary] = STATE(2185),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [651] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2187),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3882),
  },
  [652] = {
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_until] = ACTIONS(391),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(391),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_unless] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_rescue] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_COLON2] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [653] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(2188),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [654] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(2191),
    [sym_lambda_parameters] = STATE(2192),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(2191),
    [anon_sym_do] = ACTIONS(3884),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [655] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
  },
  [656] = {
    [sym__method_name] = STATE(2195),
    [sym_setter] = STATE(2195),
    [sym_symbol] = STATE(2195),
    [sym_operator] = STATE(2195),
    [sym__method_rest] = STATE(2196),
    [sym__variable] = STATE(2197),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(3890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(3892),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(3890),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [657] = {
    [sym__argument] = STATE(2212),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(2212),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(2212),
    [sym_hash_splat_argument] = STATE(2212),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(2220),
    [sym_block_argument] = STATE(2212),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(501),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [658] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2222),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3932),
  },
  [659] = {
    [sym_assignment] = STATE(2223),
    [sym_unary] = STATE(2223),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2223),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2223),
    [sym_conditional] = STATE(2223),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(2224),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2223),
    [sym_binary] = STATE(2223),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(2224),
    [sym__line_break] = ACTIONS(3934),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [660] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(2226),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [661] = {
    [sym__argument] = STATE(2212),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(2212),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(2212),
    [sym_hash_splat_argument] = STATE(2212),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(2220),
    [sym_block_argument] = STATE(2212),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(647),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(647),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [662] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(2230),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(3938),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(3940),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [663] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2232),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3942),
  },
  [664] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(2234),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(3944),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [665] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(2237),
    [sym__body_statement] = STATE(2238),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(2237),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(3946),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3948),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [666] = {
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_until] = ACTIONS(719),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_unless] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_rescue] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_COLON2] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [667] = {
    [sym__argument] = STATE(2212),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(2212),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(2212),
    [sym_hash_splat_argument] = STATE(2212),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(2220),
    [sym_block_argument] = STATE(2212),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(737),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(737),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [668] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2243),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(3950),
  },
  [669] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [670] = {
    [sym__statement] = STATE(2245),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2245),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2245),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2245),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2245),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2245),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2245),
    [sym_if_modifier] = STATE(2245),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2245),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2245),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [671] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2248),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(3954),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(3956),
  },
  [672] = {
    [sym__argument] = STATE(2212),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(2212),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(2212),
    [sym_hash_splat_argument] = STATE(2212),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(2220),
    [sym_block_argument] = STATE(2212),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(753),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(753),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [673] = {
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_rescue] = ACTIONS(3960),
    [anon_sym_unless] = ACTIONS(3962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3968),
  },
  [674] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(3970),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3972),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3976),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [675] = {
    [anon_sym_EQ] = ACTIONS(3978),
    [sym_comment] = ACTIONS(3),
  },
  [676] = {
    [sym_block] = STATE(2275),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym__primary] = STATE(2276),
    [sym_argument_list] = STATE(2277),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_method] = STATE(2276),
    [sym_conditional] = STATE(2282),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_subshell] = STATE(2276),
    [sym_unless] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2281),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_call] = STATE(2279),
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_rational] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_lambda] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_do_block] = STATE(2275),
    [sym_binary] = STATE(2282),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_nil] = STATE(2281),
    [sym_symbol_array] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_scope_resolution] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_while] = ACTIONS(791),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [677] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4022),
    [anon_sym_SLASH_EQ] = ACTIONS(4022),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(4022),
    [anon_sym_PIPE_EQ] = ACTIONS(4022),
    [anon_sym_LT_LT_EQ] = ACTIONS(4022),
    [anon_sym_PLUS_EQ] = ACTIONS(4022),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4022),
    [anon_sym_STAR_EQ] = ACTIONS(4022),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4022),
    [anon_sym_CARET_EQ] = ACTIONS(4022),
    [anon_sym_DASH_EQ] = ACTIONS(4022),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [678] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [679] = {
    [aux_sym_chained_string_repeat1] = STATE(2296),
    [sym_string] = STATE(2296),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [680] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4052),
  },
  [681] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [sym__line_break] = ACTIONS(4056),
    [anon_sym_then] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym___END__] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_end] = ACTIONS(4056),
    [anon_sym_ensure] = ACTIONS(4056),
    [anon_sym_else] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_elsif] = ACTIONS(4056),
    [ts_builtin_sym_end] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [sym__binary_minus] = ACTIONS(4056),
  },
  [682] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4058),
    [sym__string_end] = ACTIONS(4052),
  },
  [683] = {
    [sym_interpolation] = STATE(683),
    [aux_sym__literal_contents_repeat1] = STATE(683),
    [sym__string_end] = ACTIONS(4060),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4060),
    [anon_sym_POUND_LBRACE] = ACTIONS(4062),
    [sym__string_content] = ACTIONS(4065),
    [sym_escape_sequence] = ACTIONS(4065),
  },
  [684] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [sym__symbol_start] = ACTIONS(2305),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2305),
    [anon_sym_PLUS_AT] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_TILDE] = ACTIONS(2305),
    [sym_global_variable] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [sym__simple_symbol] = ACTIONS(2305),
    [anon_sym_DASH_AT] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [sym_constant] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2303),
    [sym_instance_variable] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2303),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_BANG] = ACTIONS(2303),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [sym_class_variable] = ACTIONS(2305),
  },
  [685] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4068),
  },
  [686] = {
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(3496),
    [sym__symbol_start] = ACTIONS(3496),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3496),
    [anon_sym_PLUS_AT] = ACTIONS(3496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_TILDE] = ACTIONS(3496),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [sym_global_variable] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [sym__simple_symbol] = ACTIONS(3496),
    [anon_sym_DASH_AT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_BANG_TILDE] = ACTIONS(3496),
    [sym_constant] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(4070),
    [sym_instance_variable] = ACTIONS(3496),
    [anon_sym_GT_EQ] = ACTIONS(3496),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4070),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3496),
    [anon_sym_STAR_STAR] = ACTIONS(3496),
    [anon_sym_PIPE] = ACTIONS(3496),
    [anon_sym_DOT_DOT] = ACTIONS(3496),
    [anon_sym_LT_EQ_GT] = ACTIONS(3496),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(3496),
    [anon_sym_CARET] = ACTIONS(3496),
    [sym_class_variable] = ACTIONS(3496),
  },
  [687] = {
    [sym__line_break] = ACTIONS(4072),
    [anon_sym_then] = ACTIONS(4072),
    [anon_sym_until] = ACTIONS(4072),
    [anon_sym___END__] = ACTIONS(4072),
    [anon_sym_while] = ACTIONS(4072),
    [sym__heredoc_body_start] = ACTIONS(4072),
    [anon_sym_end] = ACTIONS(4072),
    [anon_sym_ensure] = ACTIONS(4072),
    [anon_sym_RPAREN] = ACTIONS(4072),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_else] = ACTIONS(4072),
    [sym_comment] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_elsif] = ACTIONS(4072),
    [anon_sym_unless] = ACTIONS(4072),
    [ts_builtin_sym_end] = ACTIONS(4072),
    [anon_sym_rescue] = ACTIONS(4072),
    [anon_sym_when] = ACTIONS(4072),
    [anon_sym_if] = ACTIONS(4072),
  },
  [688] = {
    [sym__terminator] = STATE(2302),
    [sym_heredoc_body] = STATE(2302),
    [sym__do] = STATE(2302),
    [sym__line_break] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [689] = {
    [sym__terminator] = STATE(2303),
    [sym_heredoc_body] = STATE(2303),
    [sym_then] = STATE(2304),
    [sym__line_break] = ACTIONS(4076),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [690] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [691] = {
    [aux_sym_chained_string_repeat1] = STATE(867),
    [sym_string] = STATE(867),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [692] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
  },
  [693] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_COLON2] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(1225),
  },
  [694] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2307),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4078),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4080),
  },
  [695] = {
    [aux_sym_symbol_array_repeat1] = STATE(2310),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4082),
    [sym__string_end] = ACTIONS(4084),
  },
  [696] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_RBRACK] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_COLON2] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1337),
  },
  [697] = {
    [anon_sym_RBRACK] = ACTIONS(4086),
    [sym_comment] = ACTIONS(49),
  },
  [698] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_RBRACK] = ACTIONS(1635),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
  },
  [699] = {
    [sym_heredoc_body] = STATE(2313),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(4088),
    [sym_comment] = ACTIONS(49),
  },
  [700] = {
    [anon_sym_RBRACE] = ACTIONS(4088),
    [sym_comment] = ACTIONS(49),
  },
  [701] = {
    [sym_assignment] = STATE(2314),
    [sym_unary] = STATE(2314),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2314),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(2314),
    [sym_conditional] = STATE(2314),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(2314),
    [sym_binary] = STATE(2314),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [702] = {
    [sym__terminator] = STATE(2315),
    [sym_heredoc_body] = STATE(2315),
    [sym__do] = STATE(2315),
    [sym__line_break] = ACTIONS(4090),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4090),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [703] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [704] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_RBRACK] = ACTIONS(1853),
    [anon_sym_in] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_EQ] = ACTIONS(1851),
  },
  [705] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4092),
  },
  [706] = {
    [sym_in] = STATE(2317),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [707] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(2319),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(2320),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(2320),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2321),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(4094),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4094),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4096),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [708] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(2323),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(2324),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [709] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_in] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_EQ_GT] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_COLON2] = ACTIONS(2043),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_EQ] = ACTIONS(2043),
  },
  [710] = {
    [sym_do_block] = STATE(2325),
    [sym_block] = STATE(2325),
    [anon_sym_do] = ACTIONS(4100),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1359),
  },
  [711] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [712] = {
    [sym_assignment] = STATE(2326),
    [sym_unary] = STATE(2326),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2326),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(2326),
    [sym_conditional] = STATE(2326),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(2326),
    [sym_binary] = STATE(2326),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [713] = {
    [sym_assignment] = STATE(2327),
    [sym_unary] = STATE(2327),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(2327),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(2327),
    [sym_conditional] = STATE(2327),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(2327),
    [sym_binary] = STATE(2327),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [714] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(2328),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(2328),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(2328),
    [sym__line_break] = ACTIONS(4102),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(4102),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [715] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_RBRACK] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_EQ_GT] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_COLON2] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_EQ] = ACTIONS(2101),
  },
  [716] = {
    [anon_sym_DOT] = ACTIONS(4104),
    [anon_sym_COLON_COLON] = ACTIONS(4104),
    [sym_comment] = ACTIONS(49),
  },
  [717] = {
    [sym_assignment] = STATE(2330),
    [sym_unary] = STATE(2330),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2330),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(2330),
    [sym_conditional] = STATE(2330),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(2330),
    [sym_binary] = STATE(2330),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [718] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [719] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4108),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [720] = {
    [sym_assignment] = STATE(2332),
    [sym_unary] = STATE(2332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2332),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(2332),
    [sym_conditional] = STATE(2332),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(2332),
    [sym_binary] = STATE(2332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [721] = {
    [anon_sym_COLON] = ACTIONS(4110),
    [sym_comment] = ACTIONS(49),
  },
  [722] = {
    [sym_assignment] = STATE(2334),
    [sym_unary] = STATE(2334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2334),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(2334),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(2334),
    [sym_binary] = STATE(2334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [723] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(2336),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(4112),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [724] = {
    [sym_assignment] = STATE(2337),
    [sym_unary] = STATE(2337),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2337),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(2337),
    [sym_conditional] = STATE(2337),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(2337),
    [sym_binary] = STATE(2337),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [725] = {
    [sym_assignment] = STATE(2338),
    [sym_unary] = STATE(2338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2338),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(2338),
    [sym_conditional] = STATE(2338),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(2338),
    [sym_binary] = STATE(2338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [726] = {
    [sym_heredoc_body] = STATE(2341),
    [aux_sym_call_repeat1] = STATE(2341),
    [aux_sym_argument_list_repeat1] = STATE(2342),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(4114),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [727] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(4118),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4118),
    [anon_sym_SLASH_EQ] = ACTIONS(4118),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4118),
    [anon_sym_PIPE_EQ] = ACTIONS(4118),
    [anon_sym_LT_LT_EQ] = ACTIONS(4118),
    [anon_sym_PLUS_EQ] = ACTIONS(4118),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4118),
    [anon_sym_STAR_EQ] = ACTIONS(4118),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4118),
    [anon_sym_CARET_EQ] = ACTIONS(4118),
    [anon_sym_DASH_EQ] = ACTIONS(4118),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4118),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4120),
  },
  [728] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [729] = {
    [anon_sym_EQ] = ACTIONS(4148),
    [sym_comment] = ACTIONS(3),
  },
  [730] = {
    [aux_sym_chained_string_repeat1] = STATE(867),
    [sym_string] = STATE(867),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(4150),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [731] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_COLON2] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2299),
  },
  [732] = {
    [sym_heredoc_body] = STATE(2341),
    [aux_sym_call_repeat1] = STATE(2341),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [733] = {
    [sym__argument] = STATE(2359),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2359),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(2359),
    [sym_hash_splat_argument] = STATE(2359),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(2363),
    [sym_block_argument] = STATE(2359),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(751),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [734] = {
    [sym_assignment] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2364),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [735] = {
    [sym_assignment] = STATE(2365),
    [sym_unary] = STATE(2365),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2365),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2365),
    [sym_conditional] = STATE(2365),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(2366),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2365),
    [sym_binary] = STATE(2365),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(2366),
    [sym__line_break] = ACTIONS(4160),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [736] = {
    [anon_sym_SLASH] = ACTIONS(389),
    [anon_sym_RBRACK] = ACTIONS(391),
    [anon_sym_until] = ACTIONS(391),
    [anon_sym_AMP_EQ] = ACTIONS(391),
    [anon_sym_GT_GT_EQ] = ACTIONS(391),
    [anon_sym_SLASH_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_EQ_TILDE] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(389),
    [sym__binary_star] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_unless] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(389),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [anon_sym_rescue] = ACTIONS(391),
    [anon_sym_PERCENT_EQ] = ACTIONS(391),
    [anon_sym_LT_LT_EQ] = ACTIONS(391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(389),
    [anon_sym_BANG_TILDE] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_COLON2] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(391),
    [sym__heredoc_body_start] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_CARET_EQ] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(391),
    [anon_sym_STAR_EQ] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(391),
    [anon_sym_DASH_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(391),
    [anon_sym_BANG_EQ] = ACTIONS(391),
    [anon_sym_STAR_STAR] = ACTIONS(389),
    [anon_sym_LT_EQ_GT] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [sym__binary_minus] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(389),
  },
  [737] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2369),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4162),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4164),
  },
  [738] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2371),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4166),
  },
  [739] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(2373),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(4168),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [740] = {
    [sym__argument] = STATE(2359),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2359),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(2359),
    [sym_hash_splat_argument] = STATE(2359),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(2363),
    [sym_block_argument] = STATE(2359),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(645),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [741] = {
    [sym__statement] = STATE(2375),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2375),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2375),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2375),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2375),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2375),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2375),
    [sym_if_modifier] = STATE(2375),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2375),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2375),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [742] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(2378),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(4170),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(4172),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [743] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(2380),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(4174),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [744] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(2383),
    [sym__body_statement] = STATE(2384),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(2383),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(4176),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4178),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [745] = {
    [sym_assignment] = STATE(2387),
    [sym_unary] = STATE(2387),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2387),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(2387),
    [sym_conditional] = STATE(2387),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(2387),
    [sym_binary] = STATE(2387),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [746] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [747] = {
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_RBRACK] = ACTIONS(719),
    [anon_sym_until] = ACTIONS(719),
    [anon_sym_AMP_EQ] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_EQ_TILDE] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(717),
    [sym__binary_star] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_unless] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(717),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [anon_sym_rescue] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(717),
    [anon_sym_BANG_TILDE] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_COLON2] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym__heredoc_body_start] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(717),
    [anon_sym_in] = ACTIONS(719),
    [anon_sym_QMARK] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_GT] = ACTIONS(717),
    [anon_sym_PIPE_EQ] = ACTIONS(719),
    [anon_sym_PLUS_EQ] = ACTIONS(719),
    [anon_sym_STAR_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(719),
    [anon_sym_DASH_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(719),
    [anon_sym_BANG_EQ] = ACTIONS(719),
    [anon_sym_STAR_STAR] = ACTIONS(717),
    [anon_sym_LT_EQ_GT] = ACTIONS(719),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [sym__binary_minus] = ACTIONS(719),
    [anon_sym_if] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(717),
  },
  [748] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2390),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4180),
  },
  [749] = {
    [anon_sym_SLASH] = ACTIONS(289),
    [anon_sym_RBRACK] = ACTIONS(291),
    [anon_sym_until] = ACTIONS(291),
    [anon_sym_AMP_EQ] = ACTIONS(291),
    [anon_sym_GT_GT_EQ] = ACTIONS(291),
    [anon_sym_SLASH_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_EQ_TILDE] = ACTIONS(291),
    [anon_sym_LT_LT] = ACTIONS(289),
    [sym__binary_star] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_unless] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PERCENT] = ACTIONS(289),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [anon_sym_rescue] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(291),
    [anon_sym_LT_LT_EQ] = ACTIONS(291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_BANG_TILDE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_COLON2] = ACTIONS(289),
    [anon_sym_while] = ACTIONS(291),
    [sym__heredoc_body_start] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(291),
    [anon_sym_CARET_EQ] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_LT_EQ] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(289),
    [anon_sym_DOT_DOT] = ACTIONS(289),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_in] = ACTIONS(291),
    [anon_sym_QMARK] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(289),
    [anon_sym_PIPE_EQ] = ACTIONS(291),
    [anon_sym_PLUS_EQ] = ACTIONS(291),
    [anon_sym_STAR_EQ] = ACTIONS(291),
    [anon_sym_EQ_EQ] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_PIPE_PIPE] = ACTIONS(289),
    [anon_sym_GT_EQ] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(291),
    [anon_sym_DASH_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(291),
    [anon_sym_BANG_EQ] = ACTIONS(291),
    [anon_sym_STAR_STAR] = ACTIONS(289),
    [anon_sym_LT_EQ_GT] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(289),
    [sym__binary_minus] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_CARET] = ACTIONS(289),
  },
  [750] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2393),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4182),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4184),
  },
  [751] = {
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_SLASH] = ACTIONS(183),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(183),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_COLON2] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(183),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(183),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(183),
    [anon_sym_EQ] = ACTIONS(181),
  },
  [752] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2395),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [753] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(2397),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(2398),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(4188),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [754] = {
    [sym__argument] = STATE(2359),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2359),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(2359),
    [sym_hash_splat_argument] = STATE(2359),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(2363),
    [sym_block_argument] = STATE(2359),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(735),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [755] = {
    [sym_assignment] = STATE(2400),
    [sym_unary] = STATE(2400),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2400),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2400),
    [sym_conditional] = STATE(2400),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2400),
    [sym_binary] = STATE(2400),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [756] = {
    [sym_assignment] = STATE(2401),
    [sym_unary] = STATE(2401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2401),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(2401),
    [sym_conditional] = STATE(2401),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(2401),
    [sym_binary] = STATE(2401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [757] = {
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_r] = ACTIONS(4190),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
  },
  [758] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(2403),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [759] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2405),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4192),
  },
  [760] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2407),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4194),
  },
  [761] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(2410),
    [sym_lambda_parameters] = STATE(2411),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(2410),
    [anon_sym_do] = ACTIONS(4196),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [762] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4200),
    [sym_identifier] = ACTIONS(4200),
  },
  [763] = {
    [sym__method_name] = STATE(2414),
    [sym_setter] = STATE(2414),
    [sym_symbol] = STATE(2414),
    [sym_operator] = STATE(2414),
    [sym__method_rest] = STATE(2415),
    [sym__variable] = STATE(2416),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(4202),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(4204),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(4202),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [764] = {
    [sym__argument] = STATE(2359),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2359),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(2359),
    [sym_hash_splat_argument] = STATE(2359),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym__argument_list_with_parens] = STATE(2363),
    [sym_block_argument] = STATE(2359),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(495),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_return] = ACTIONS(287),
    [sym_self] = ACTIONS(203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1383),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [765] = {
    [sym__statement] = STATE(2418),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2418),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2418),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2418),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2418),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2418),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2418),
    [sym_if_modifier] = STATE(2418),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2418),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2418),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [766] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(4206),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_LT_LT_EQ] = ACTIONS(4206),
    [anon_sym_PLUS_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_STAR_EQ] = ACTIONS(4206),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4206),
    [anon_sym_CARET_EQ] = ACTIONS(4206),
    [anon_sym_DASH_EQ] = ACTIONS(4206),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4206),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4208),
  },
  [767] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4224),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [768] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_RBRACK] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(4240),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [769] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_for] = STATE(858),
    [sym_if] = STATE(858),
    [sym__primary] = STATE(858),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_method] = STATE(858),
    [sym_conditional] = STATE(2444),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_true] = STATE(863),
    [sym_subshell] = STATE(858),
    [sym_unless] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(863),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_array] = STATE(858),
    [sym_call] = STATE(861),
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_rational] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_lambda] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2444),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_nil] = STATE(863),
    [sym_symbol_array] = STATE(858),
    [sym_case] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_scope_resolution] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(793),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [770] = {
    [anon_sym_EQ] = ACTIONS(4260),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [aux_sym_chained_string_repeat1] = STATE(2447),
    [sym_string] = STATE(2447),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [772] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_in] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_COLON2] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2303),
  },
  [773] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4262),
  },
  [774] = {
    [sym_heredoc_body] = STATE(2449),
    [sym__terminator] = STATE(2449),
    [sym__line_break] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(4264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [775] = {
    [sym_when] = STATE(2452),
    [sym_else] = STATE(2451),
    [aux_sym_case_repeat2] = STATE(2452),
    [aux_sym_case_repeat1] = STATE(2453),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(4266),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(4268),
    [sym_comment] = ACTIONS(49),
  },
  [776] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [anon_sym_RBRACK] = ACTIONS(2387),
    [anon_sym_in] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_EQ_GT] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_COLON2] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [anon_sym_EQ] = ACTIONS(2385),
  },
  [777] = {
    [anon_sym_RPAREN] = ACTIONS(4270),
    [sym_comment] = ACTIONS(49),
  },
  [778] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4224),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [779] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_RBRACK] = ACTIONS(2533),
    [anon_sym_in] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_EQ_GT] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_COLON2] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_EQ] = ACTIONS(2531),
  },
  [780] = {
    [sym_assignment] = STATE(2455),
    [sym_unary] = STATE(2455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2455),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2455),
    [sym_conditional] = STATE(2455),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2455),
    [sym_binary] = STATE(2455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [781] = {
    [sym_heredoc_body] = STATE(2456),
    [sym__terminator] = STATE(2456),
    [sym_superclass] = STATE(2457),
    [sym__line_break] = ACTIONS(4274),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [782] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(2457),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2456),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2456),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4274),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [783] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [anon_sym_RBRACK] = ACTIONS(2577),
    [anon_sym_in] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_EQ_GT] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_COLON2] = ACTIONS(2575),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(2575),
  },
  [784] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4276),
  },
  [785] = {
    [sym_heredoc_body] = STATE(2460),
    [sym__terminator] = STATE(2460),
    [sym__line_break] = ACTIONS(4278),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(4280),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [786] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2460),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2460),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4278),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(4280),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [787] = {
    [anon_sym_end] = ACTIONS(4282),
    [sym_comment] = ACTIONS(49),
  },
  [788] = {
    [sym_ensure] = STATE(2462),
    [sym_else] = STATE(2463),
    [anon_sym_end] = ACTIONS(4282),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [789] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(2464),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4284),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [790] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_in] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_COLON2] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [anon_sym_EQ] = ACTIONS(2741),
  },
  [791] = {
    [sym_ensure] = STATE(2462),
    [sym_else] = STATE(2463),
    [sym_rescue] = STATE(2465),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(4282),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [792] = {
    [sym_ensure] = STATE(2462),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(4282),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [793] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_COLON2] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
    [anon_sym_EQ] = ACTIONS(2851),
  },
  [794] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_COLON2] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
    [anon_sym_EQ] = ACTIONS(2855),
  },
  [795] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4286),
  },
  [796] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_EQ_GT] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_COLON2] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2861),
  },
  [797] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4224),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [798] = {
    [sym__terminator] = STATE(2467),
    [sym_heredoc_body] = STATE(2467),
    [sym_then] = STATE(2468),
    [sym__line_break] = ACTIONS(4290),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4290),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [799] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_EQ_GT] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2871),
  },
  [800] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2471),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4292),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4294),
  },
  [801] = {
    [aux_sym_string_array_repeat1] = STATE(2474),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4296),
    [sym__string_end] = ACTIONS(4298),
  },
  [802] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2883),
  },
  [803] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_heredoc_body] = STATE(2477),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4300),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [sym__heredoc_body_start] = ACTIONS(4302),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [804] = {
    [anon_sym_RPAREN] = ACTIONS(4300),
    [anon_sym_RBRACK] = ACTIONS(4300),
    [sym_comment] = ACTIONS(49),
  },
  [805] = {
    [sym_heredoc_body] = STATE(2479),
    [aux_sym_argument_list_repeat1] = STATE(2480),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(4300),
    [anon_sym_COMMA] = ACTIONS(4304),
    [sym_comment] = ACTIONS(49),
  },
  [806] = {
    [sym_assignment] = STATE(2481),
    [sym_unary] = STATE(2481),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2481),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2481),
    [sym_conditional] = STATE(2481),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2481),
    [sym_binary] = STATE(2481),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [807] = {
    [sym_assignment] = STATE(2484),
    [sym_unary] = STATE(2484),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2484),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(2485),
    [sym_operator_assignment] = STATE(2484),
    [sym_conditional] = STATE(2484),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_subshell] = STATE(144),
    [sym__arg_or_splat_arg] = STATE(2485),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_true] = STATE(142),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2484),
    [sym_binary] = STATE(2484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(203),
    [sym_character] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [808] = {
    [sym_assignment] = STATE(2486),
    [sym_unary] = STATE(2486),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2486),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2486),
    [sym_conditional] = STATE(2486),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2486),
    [sym_binary] = STATE(2486),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [809] = {
    [sym_assignment] = STATE(2487),
    [sym_unary] = STATE(2487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2487),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2487),
    [sym_conditional] = STATE(2487),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2487),
    [sym_binary] = STATE(2487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [810] = {
    [sym_assignment] = STATE(2488),
    [sym_unary] = STATE(2488),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(2488),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(2488),
    [sym_conditional] = STATE(2488),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(2488),
    [sym_binary] = STATE(2488),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [811] = {
    [sym_assignment] = STATE(2489),
    [sym_unary] = STATE(2489),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2489),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2489),
    [sym_conditional] = STATE(2489),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2489),
    [sym_binary] = STATE(2489),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [812] = {
    [sym_assignment] = STATE(2490),
    [sym_unary] = STATE(2490),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2490),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2490),
    [sym_conditional] = STATE(2490),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2490),
    [sym_binary] = STATE(2490),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [813] = {
    [sym_assignment] = STATE(2491),
    [sym_unary] = STATE(2491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2491),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2491),
    [sym_conditional] = STATE(2491),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2491),
    [sym_binary] = STATE(2491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [814] = {
    [sym_assignment] = STATE(2492),
    [sym_unary] = STATE(2492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2492),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2492),
    [sym_conditional] = STATE(2492),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2492),
    [sym_binary] = STATE(2492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [815] = {
    [sym_assignment] = STATE(2493),
    [sym_unary] = STATE(2493),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2493),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2493),
    [sym_conditional] = STATE(2493),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2493),
    [sym_binary] = STATE(2493),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [816] = {
    [sym_assignment] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [817] = {
    [sym_assignment] = STATE(2495),
    [sym_unary] = STATE(2495),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2495),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(2495),
    [sym_conditional] = STATE(2495),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2495),
    [sym_binary] = STATE(2495),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [818] = {
    [sym_heredoc_body] = STATE(2500),
    [sym__argument_list_with_parens] = STATE(2499),
    [aux_sym_call_repeat1] = STATE(2500),
    [sym_argument_list_with_parens] = STATE(2498),
    [sym_operator] = STATE(2498),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4310),
    [anon_sym_PLUS_AT] = ACTIONS(4310),
    [anon_sym_LPAREN2] = ACTIONS(4312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4310),
    [anon_sym_GT_GT] = ACTIONS(4310),
    [anon_sym_EQ_TILDE] = ACTIONS(4310),
    [anon_sym_LT_LT] = ACTIONS(4310),
    [anon_sym_TILDE] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4308),
    [anon_sym_AMP] = ACTIONS(4310),
    [anon_sym_GT] = ACTIONS(4308),
    [anon_sym_PERCENT] = ACTIONS(4310),
    [anon_sym_DASH_AT] = ACTIONS(4310),
    [anon_sym_EQ_EQ] = ACTIONS(4308),
    [anon_sym_STAR] = ACTIONS(4308),
    [anon_sym_BANG_TILDE] = ACTIONS(4310),
    [sym_constant] = ACTIONS(4314),
    [anon_sym_DASH] = ACTIONS(4308),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4308),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_STAR_STAR] = ACTIONS(4310),
    [anon_sym_PIPE] = ACTIONS(4310),
    [anon_sym_DOT_DOT] = ACTIONS(4310),
    [anon_sym_LT_EQ_GT] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(4308),
    [anon_sym_BANG] = ACTIONS(4308),
    [sym_identifier] = ACTIONS(4314),
    [anon_sym_CARET] = ACTIONS(4310),
  },
  [819] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2502),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4316),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [820] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
  },
  [821] = {
    [sym_assignment] = STATE(2504),
    [sym_unary] = STATE(2504),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2504),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2504),
    [sym_conditional] = STATE(2504),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2504),
    [sym_binary] = STATE(2504),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [822] = {
    [sym__statement] = STATE(2505),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2505),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2505),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2505),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2505),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2505),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2505),
    [sym_if_modifier] = STATE(2505),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2505),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2505),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [823] = {
    [sym_assignment] = STATE(2507),
    [sym_unary] = STATE(2507),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2507),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2507),
    [sym_conditional] = STATE(2507),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2507),
    [sym_binary] = STATE(2507),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [824] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [825] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2512),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4328),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4330),
  },
  [826] = {
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_AMP_EQ] = ACTIONS(183),
    [anon_sym_GT_GT_EQ] = ACTIONS(183),
    [anon_sym_SLASH_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(181),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_PERCENT_EQ] = ACTIONS(183),
    [anon_sym_LT_LT_EQ] = ACTIONS(183),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_COLON2] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_CARET_EQ] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_PIPE_EQ] = ACTIONS(183),
    [anon_sym_PLUS_EQ] = ACTIONS(183),
    [anon_sym_STAR_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(183),
    [anon_sym_DASH_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(181),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(181),
  },
  [827] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2514),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4332),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [828] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(2516),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(2519),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4334),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [829] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4336),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [830] = {
    [sym_assignment] = STATE(2521),
    [sym_unary] = STATE(2521),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2521),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2521),
    [sym_conditional] = STATE(2521),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2521),
    [sym_binary] = STATE(2521),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [831] = {
    [sym_assignment] = STATE(2522),
    [sym_unary] = STATE(2522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2522),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2522),
    [sym_conditional] = STATE(2522),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2522),
    [sym_binary] = STATE(2522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [832] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2524),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4338),
  },
  [833] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(2525),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [834] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(2527),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(2528),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(2528),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2529),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(4340),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4342),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [835] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(2531),
    [sym_lambda_parameters] = STATE(2532),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(2531),
    [anon_sym_do] = ACTIONS(1581),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [836] = {
    [anon_sym_COLON] = ACTIONS(4346),
    [sym_comment] = ACTIONS(49),
  },
  [837] = {
    [sym__method_name] = STATE(2535),
    [sym_setter] = STATE(2535),
    [sym_symbol] = STATE(2535),
    [sym_operator] = STATE(2535),
    [sym__method_rest] = STATE(2536),
    [sym__variable] = STATE(2537),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(4348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(4350),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(4348),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [838] = {
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_hash_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(495),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [839] = {
    [sym_assignment] = STATE(2539),
    [sym_unary] = STATE(2539),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2539),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2539),
    [sym_conditional] = STATE(2539),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2539),
    [sym_binary] = STATE(2539),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [840] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2541),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4352),
  },
  [841] = {
    [sym_assignment] = STATE(2542),
    [sym_unary] = STATE(2542),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2542),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2542),
    [sym_conditional] = STATE(2542),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(2543),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2542),
    [sym_binary] = STATE(2542),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(2543),
    [sym__line_break] = ACTIONS(4354),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [842] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(2545),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [843] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(2547),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(4358),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [844] = {
    [sym_assignment] = STATE(2548),
    [sym_unary] = STATE(2548),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2548),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2548),
    [sym_conditional] = STATE(2548),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2548),
    [sym_binary] = STATE(2548),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [845] = {
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_hash_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(645),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [846] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(2552),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(4362),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [847] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2554),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4364),
  },
  [848] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(2556),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(4366),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [849] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(2559),
    [sym__body_statement] = STATE(2560),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(2559),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(4368),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4370),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [850] = {
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_hash_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(735),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [851] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(2565),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(4372),
  },
  [852] = {
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(4374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [853] = {
    [sym_assignment] = STATE(2567),
    [sym_unary] = STATE(2567),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2567),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(2567),
    [sym_conditional] = STATE(2567),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(2567),
    [sym_binary] = STATE(2567),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [854] = {
    [sym__statement] = STATE(2568),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2568),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(2568),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(2568),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(2568),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(2568),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(2568),
    [sym_if_modifier] = STATE(2568),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(2568),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(2568),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [855] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2571),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4376),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4378),
  },
  [856] = {
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_hash_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(751),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [857] = {
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [858] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_RBRACK] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(1543),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [859] = {
    [sym_do_block] = STATE(2573),
    [sym_block] = STATE(2573),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4380),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [860] = {
    [anon_sym_EQ] = ACTIONS(4382),
    [sym_comment] = ACTIONS(3),
  },
  [861] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_for] = STATE(858),
    [sym_if] = STATE(858),
    [sym__primary] = STATE(858),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(862),
    [sym_method] = STATE(858),
    [sym_conditional] = STATE(864),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_true] = STATE(863),
    [sym_subshell] = STATE(858),
    [sym_unless] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_block_argument] = STATE(862),
    [sym_range] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(863),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_array] = STATE(858),
    [sym_call] = STATE(861),
    [sym__argument] = STATE(862),
    [sym_assignment] = STATE(864),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_pair] = STATE(862),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(862),
    [sym_operator_assignment] = STATE(864),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_rational] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_lambda] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(866),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(864),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_nil] = STATE(863),
    [sym_symbol_array] = STATE(858),
    [sym_case] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_scope_resolution] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(793),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1591),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [862] = {
    [sym_heredoc_body] = STATE(2579),
    [aux_sym_call_repeat1] = STATE(2579),
    [aux_sym_argument_list_repeat1] = STATE(2580),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(4386),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [863] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4390),
    [anon_sym_SLASH_EQ] = ACTIONS(4390),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4390),
    [anon_sym_PIPE_EQ] = ACTIONS(4390),
    [anon_sym_LT_LT_EQ] = ACTIONS(4390),
    [anon_sym_PLUS_EQ] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4390),
    [anon_sym_STAR_EQ] = ACTIONS(4390),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4390),
    [anon_sym_CARET_EQ] = ACTIONS(4390),
    [anon_sym_DASH_EQ] = ACTIONS(4390),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4390),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4392),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [864] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [865] = {
    [aux_sym_chained_string_repeat1] = STATE(2591),
    [sym_string] = STATE(2591),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(4422),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [866] = {
    [sym_heredoc_body] = STATE(2579),
    [aux_sym_call_repeat1] = STATE(2579),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [867] = {
    [aux_sym_chained_string_repeat1] = STATE(2592),
    [sym_string] = STATE(2592),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_RBRACK] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [868] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [sym__line_break] = ACTIONS(4426),
    [anon_sym_then] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym___END__] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_end] = ACTIONS(4426),
    [anon_sym_ensure] = ACTIONS(4426),
    [anon_sym_else] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_elsif] = ACTIONS(4426),
    [ts_builtin_sym_end] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [sym__binary_minus] = ACTIONS(4426),
  },
  [869] = {
    [sym__terminator] = STATE(2593),
    [sym_heredoc_body] = STATE(2593),
    [sym__do] = STATE(2593),
    [sym__line_break] = ACTIONS(4428),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [870] = {
    [sym__terminator] = STATE(2594),
    [sym_heredoc_body] = STATE(2594),
    [sym_then] = STATE(2595),
    [sym__line_break] = ACTIONS(4430),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [871] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [872] = {
    [aux_sym_chained_string_repeat1] = STATE(1008),
    [sym_string] = STATE(1008),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [873] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [874] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
  },
  [875] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2598),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4432),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4434),
  },
  [876] = {
    [aux_sym_symbol_array_repeat1] = STATE(2601),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4436),
    [sym__string_end] = ACTIONS(4438),
  },
  [877] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
  },
  [878] = {
    [anon_sym_RBRACK] = ACTIONS(4440),
    [sym_comment] = ACTIONS(49),
  },
  [879] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
  },
  [880] = {
    [sym_heredoc_body] = STATE(2604),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(4442),
    [sym_comment] = ACTIONS(49),
  },
  [881] = {
    [anon_sym_RBRACE] = ACTIONS(4442),
    [sym_comment] = ACTIONS(49),
  },
  [882] = {
    [sym_assignment] = STATE(2605),
    [sym_unary] = STATE(2605),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2605),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(2605),
    [sym_conditional] = STATE(2605),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(2605),
    [sym_binary] = STATE(2605),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [883] = {
    [sym__terminator] = STATE(2606),
    [sym_heredoc_body] = STATE(2606),
    [sym__do] = STATE(2606),
    [sym__line_break] = ACTIONS(4444),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4444),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [884] = {
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(4446),
    [anon_sym_when] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
  },
  [885] = {
    [sym__statement] = STATE(2607),
    [sym_unary] = STATE(678),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2607),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_unless_modifier] = STATE(2607),
    [sym_symbol] = STATE(674),
    [sym_for] = STATE(674),
    [sym_if] = STATE(674),
    [sym__primary] = STATE(674),
    [sym_method] = STATE(674),
    [sym_conditional] = STATE(678),
    [sym_left_assignment_list] = STATE(675),
    [sym_return] = STATE(674),
    [sym_true] = STATE(677),
    [sym_while_modifier] = STATE(2607),
    [sym_subshell] = STATE(674),
    [sym_unless] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_begin_block] = STATE(2607),
    [sym_range] = STATE(678),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(677),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_array] = STATE(674),
    [sym_call] = STATE(676),
    [sym_end_block] = STATE(2607),
    [sym_assignment] = STATE(678),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_alias] = STATE(2607),
    [sym_if_modifier] = STATE(2607),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(678),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(678),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_rational] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_until_modifier] = STATE(2607),
    [sym_lambda] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_binary] = STATE(678),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_nil] = STATE(677),
    [sym_rescue_modifier] = STATE(2607),
    [sym_symbol_array] = STATE(674),
    [sym_case] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_scope_resolution] = STATE(676),
    [sym_float] = ACTIONS(1233),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_undef] = ACTIONS(1237),
    [sym_self] = ACTIONS(1239),
    [anon_sym_BEGIN] = ACTIONS(1241),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_unless] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym_complex] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [sym_super] = ACTIONS(1239),
    [anon_sym_alias] = ACTIONS(1255),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_character] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_END] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1267),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1283),
    [sym_class_variable] = ACTIONS(1267),
    [sym__symbol_start] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(1287),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_class] = ACTIONS(1295),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [sym_retry] = ACTIONS(1233),
    [sym__regex_start] = ACTIONS(1309),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_FALSE] = ACTIONS(1303),
    [sym_redo] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1313),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [886] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(4450),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [887] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [888] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
  },
  [889] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4452),
  },
  [890] = {
    [sym_in] = STATE(2611),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [891] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(2613),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(2614),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(2614),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2615),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(4454),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4456),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [892] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(2617),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(2618),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4458),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [893] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_EQ_GT] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
  },
  [894] = {
    [sym_do_block] = STATE(2619),
    [sym_block] = STATE(2619),
    [anon_sym_do] = ACTIONS(4460),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1657),
  },
  [895] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [896] = {
    [sym_assignment] = STATE(2620),
    [sym_unary] = STATE(2620),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2620),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(2620),
    [sym_conditional] = STATE(2620),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(2620),
    [sym_binary] = STATE(2620),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [897] = {
    [sym_assignment] = STATE(2621),
    [sym_unary] = STATE(2621),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(2621),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(2621),
    [sym_conditional] = STATE(2621),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(2621),
    [sym_binary] = STATE(2621),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [898] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(2622),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(2622),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(2622),
    [sym__line_break] = ACTIONS(4462),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [899] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_EQ_GT] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
  },
  [900] = {
    [anon_sym_DOT] = ACTIONS(4464),
    [anon_sym_COLON_COLON] = ACTIONS(4464),
    [sym_comment] = ACTIONS(49),
  },
  [901] = {
    [sym_assignment] = STATE(2624),
    [sym_unary] = STATE(2624),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(2624),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(2624),
    [sym_conditional] = STATE(2624),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(2624),
    [sym_binary] = STATE(2624),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [902] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [903] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4468),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [904] = {
    [sym_assignment] = STATE(2627),
    [sym_unary] = STATE(2627),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(2627),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(2627),
    [sym_conditional] = STATE(2627),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(2627),
    [sym_binary] = STATE(2627),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [905] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
  },
  [906] = {
    [anon_sym_COLON] = ACTIONS(4472),
    [sym_comment] = ACTIONS(49),
  },
  [907] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [908] = {
    [sym_assignment] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [909] = {
    [sym_assignment] = STATE(2633),
    [sym_unary] = STATE(2633),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(2633),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(2633),
    [sym_conditional] = STATE(2633),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(2633),
    [sym_binary] = STATE(2633),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [910] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [911] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [912] = {
    [sym_assignment] = STATE(2634),
    [sym_unary] = STATE(2634),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(2634),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(2634),
    [sym_conditional] = STATE(2634),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(2634),
    [sym_binary] = STATE(2634),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [913] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [914] = {
    [sym_heredoc_body] = STATE(2636),
    [aux_sym_call_repeat1] = STATE(2636),
    [aux_sym_argument_list_repeat1] = STATE(2637),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(4474),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [915] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(4476),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4476),
    [anon_sym_SLASH_EQ] = ACTIONS(4476),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4476),
    [anon_sym_PIPE_EQ] = ACTIONS(4476),
    [anon_sym_LT_LT_EQ] = ACTIONS(4476),
    [anon_sym_PLUS_EQ] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4476),
    [anon_sym_STAR_EQ] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4476),
    [anon_sym_CARET_EQ] = ACTIONS(4476),
    [anon_sym_DASH_EQ] = ACTIONS(4476),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4476),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4478),
  },
  [916] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [917] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(4506),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4510),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
  },
  [918] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(1005),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(1005),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [919] = {
    [anon_sym_EQ] = ACTIONS(4512),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [aux_sym_chained_string_repeat1] = STATE(2652),
    [sym_string] = STATE(2652),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(4514),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [921] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
  },
  [922] = {
    [sym_heredoc_body] = STATE(2636),
    [aux_sym_call_repeat1] = STATE(2636),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [923] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
  },
  [924] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4516),
  },
  [925] = {
    [sym_heredoc_body] = STATE(2654),
    [sym__terminator] = STATE(2654),
    [sym__line_break] = ACTIONS(4518),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(4518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [926] = {
    [sym_when] = STATE(2657),
    [sym_else] = STATE(2656),
    [aux_sym_case_repeat2] = STATE(2657),
    [aux_sym_case_repeat1] = STATE(2658),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(4520),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(4522),
    [sym_comment] = ACTIONS(49),
  },
  [927] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_EQ_GT] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
  },
  [928] = {
    [anon_sym_RPAREN] = ACTIONS(4524),
    [sym_comment] = ACTIONS(49),
  },
  [929] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_EQ_GT] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
  },
  [930] = {
    [sym_assignment] = STATE(2660),
    [sym_unary] = STATE(2660),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2660),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2660),
    [sym_conditional] = STATE(2660),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2660),
    [sym_binary] = STATE(2660),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [931] = {
    [sym_heredoc_body] = STATE(2661),
    [sym__terminator] = STATE(2661),
    [sym_superclass] = STATE(2662),
    [sym__line_break] = ACTIONS(4526),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [932] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(2662),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2661),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2661),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4526),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4526),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [933] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_EQ_GT] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
  },
  [934] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4528),
  },
  [935] = {
    [sym_heredoc_body] = STATE(2665),
    [sym__terminator] = STATE(2665),
    [sym__line_break] = ACTIONS(4530),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4530),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(4532),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [936] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2665),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2665),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4530),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4530),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(4532),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [937] = {
    [anon_sym_end] = ACTIONS(4534),
    [sym_comment] = ACTIONS(49),
  },
  [938] = {
    [sym_ensure] = STATE(2667),
    [sym_else] = STATE(2668),
    [anon_sym_end] = ACTIONS(4534),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [939] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(2669),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4536),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [940] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
  },
  [941] = {
    [sym_ensure] = STATE(2667),
    [sym_else] = STATE(2668),
    [sym_rescue] = STATE(2670),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(4534),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [942] = {
    [sym_ensure] = STATE(2667),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(4534),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [943] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
  },
  [944] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
  },
  [945] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4538),
  },
  [946] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_EQ_GT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
  },
  [947] = {
    [sym__argument] = STATE(2685),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(2685),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(2685),
    [sym_hash_splat_argument] = STATE(2685),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(2692),
    [sym_block_argument] = STATE(2685),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [948] = {
    [sym__argument] = STATE(2685),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(2685),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(2685),
    [sym_hash_splat_argument] = STATE(2685),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(2692),
    [sym_block_argument] = STATE(2685),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [949] = {
    [sym_assignment] = STATE(2693),
    [sym_unary] = STATE(2693),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2693),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(2693),
    [sym_conditional] = STATE(2693),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(2693),
    [sym_binary] = STATE(2693),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [950] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [951] = {
    [sym__argument] = STATE(2685),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(2685),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(2685),
    [sym_hash_splat_argument] = STATE(2685),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(2692),
    [sym_block_argument] = STATE(2685),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [952] = {
    [sym_assignment] = STATE(2694),
    [sym_unary] = STATE(2694),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2694),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(2694),
    [sym_conditional] = STATE(2694),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(2694),
    [sym_binary] = STATE(2694),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [953] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
  },
  [954] = {
    [sym__argument] = STATE(2685),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(2685),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(2685),
    [sym_hash_splat_argument] = STATE(2685),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(2692),
    [sym_block_argument] = STATE(2685),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [955] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(4578),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4578),
    [anon_sym_SLASH_EQ] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4578),
    [anon_sym_PIPE_EQ] = ACTIONS(4578),
    [anon_sym_LT_LT_EQ] = ACTIONS(4578),
    [anon_sym_PLUS_EQ] = ACTIONS(4578),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4578),
    [anon_sym_STAR_EQ] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4578),
    [anon_sym_CARET_EQ] = ACTIONS(4578),
    [anon_sym_DASH_EQ] = ACTIONS(4578),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4578),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4580),
  },
  [956] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_or] = ACTIONS(4594),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE] = ACTIONS(4606),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [957] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4612),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4614),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [958] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym__primary] = STATE(2722),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_method] = STATE(2722),
    [sym_conditional] = STATE(2727),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_subshell] = STATE(2722),
    [sym_unless] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2726),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_call] = STATE(2724),
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_rational] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_lambda] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2727),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_nil] = STATE(2726),
    [sym_symbol_array] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_scope_resolution] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [959] = {
    [anon_sym_EQ] = ACTIONS(4650),
    [sym_comment] = ACTIONS(3),
  },
  [960] = {
    [aux_sym_chained_string_repeat1] = STATE(2730),
    [sym_string] = STATE(2730),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [961] = {
    [sym__terminator] = STATE(2731),
    [sym_heredoc_body] = STATE(2731),
    [sym_then] = STATE(2732),
    [sym__line_break] = ACTIONS(4652),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4652),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [962] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_EQ_GT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
  },
  [963] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2735),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4654),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4656),
  },
  [964] = {
    [aux_sym_string_array_repeat1] = STATE(2738),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4658),
    [sym__string_end] = ACTIONS(4660),
  },
  [965] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
  },
  [966] = {
    [sym_assignment] = STATE(2739),
    [sym_unary] = STATE(2739),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2739),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2739),
    [sym_conditional] = STATE(2739),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2739),
    [sym_binary] = STATE(2739),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [967] = {
    [sym_assignment] = STATE(2750),
    [sym_unary] = STATE(2750),
    [sym_right_assignment_list] = STATE(2748),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2750),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_splat_argument] = STATE(2753),
    [sym_operator_assignment] = STATE(2750),
    [sym_conditional] = STATE(2750),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_subshell] = STATE(189),
    [sym__arg_or_splat_arg] = STATE(2753),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(2750),
    [sym_binary] = STATE(2750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [sym__splat_star] = ACTIONS(4668),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(355),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_nil] = ACTIONS(315),
    [sym_super] = ACTIONS(297),
    [sym_character] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [968] = {
    [sym_assignment] = STATE(2754),
    [sym_unary] = STATE(2754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2754),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2754),
    [sym_conditional] = STATE(2754),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2754),
    [sym_binary] = STATE(2754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [969] = {
    [sym_assignment] = STATE(2755),
    [sym_unary] = STATE(2755),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2755),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2755),
    [sym_conditional] = STATE(2755),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2755),
    [sym_binary] = STATE(2755),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [970] = {
    [sym_assignment] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [971] = {
    [sym_assignment] = STATE(2757),
    [sym_unary] = STATE(2757),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2757),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2757),
    [sym_conditional] = STATE(2757),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2757),
    [sym_binary] = STATE(2757),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [972] = {
    [sym_assignment] = STATE(2758),
    [sym_unary] = STATE(2758),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2758),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2758),
    [sym_conditional] = STATE(2758),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2758),
    [sym_binary] = STATE(2758),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [973] = {
    [sym_assignment] = STATE(2759),
    [sym_unary] = STATE(2759),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2759),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2759),
    [sym_conditional] = STATE(2759),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2759),
    [sym_binary] = STATE(2759),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [974] = {
    [sym_assignment] = STATE(2760),
    [sym_unary] = STATE(2760),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2760),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2760),
    [sym_conditional] = STATE(2760),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2760),
    [sym_binary] = STATE(2760),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [975] = {
    [sym_assignment] = STATE(2761),
    [sym_unary] = STATE(2761),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2761),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2761),
    [sym_conditional] = STATE(2761),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2761),
    [sym_binary] = STATE(2761),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [976] = {
    [sym_assignment] = STATE(2762),
    [sym_unary] = STATE(2762),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2762),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2762),
    [sym_conditional] = STATE(2762),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2762),
    [sym_binary] = STATE(2762),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [977] = {
    [sym_assignment] = STATE(2763),
    [sym_unary] = STATE(2763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2763),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(2763),
    [sym_conditional] = STATE(2763),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(2763),
    [sym_binary] = STATE(2763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [978] = {
    [sym_heredoc_body] = STATE(2768),
    [sym__argument_list_with_parens] = STATE(2767),
    [aux_sym_call_repeat1] = STATE(2768),
    [sym_argument_list_with_parens] = STATE(2766),
    [sym_operator] = STATE(2766),
    [anon_sym_LT] = ACTIONS(4682),
    [anon_sym_SLASH] = ACTIONS(4684),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4684),
    [anon_sym_PLUS_AT] = ACTIONS(4684),
    [anon_sym_LPAREN2] = ACTIONS(4686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4684),
    [anon_sym_GT_GT] = ACTIONS(4684),
    [anon_sym_EQ_TILDE] = ACTIONS(4684),
    [anon_sym_LT_LT] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4682),
    [anon_sym_PERCENT] = ACTIONS(4684),
    [anon_sym_DASH_AT] = ACTIONS(4684),
    [anon_sym_EQ_EQ] = ACTIONS(4682),
    [anon_sym_STAR] = ACTIONS(4682),
    [anon_sym_BANG_TILDE] = ACTIONS(4684),
    [sym_constant] = ACTIONS(4688),
    [anon_sym_DASH] = ACTIONS(4682),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_STAR_STAR] = ACTIONS(4684),
    [anon_sym_PIPE] = ACTIONS(4684),
    [anon_sym_DOT_DOT] = ACTIONS(4684),
    [anon_sym_LT_EQ_GT] = ACTIONS(4684),
    [anon_sym_LT_EQ] = ACTIONS(4682),
    [anon_sym_BANG] = ACTIONS(4682),
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_CARET] = ACTIONS(4684),
  },
  [979] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2770),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4690),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [980] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4692),
    [sym_identifier] = ACTIONS(4692),
  },
  [981] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(2773),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(2774),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(4694),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(4696),
    [sym_instance_variable] = ACTIONS(323),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [982] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [sym__line_break] = ACTIONS(4700),
    [anon_sym_then] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_when] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym___END__] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_end] = ACTIONS(4700),
    [anon_sym_ensure] = ACTIONS(4700),
    [anon_sym_else] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_elsif] = ACTIONS(4700),
    [ts_builtin_sym_end] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
    [sym__binary_minus] = ACTIONS(4700),
  },
  [983] = {
    [anon_sym_RBRACE] = ACTIONS(4702),
    [sym_comment] = ACTIONS(49),
  },
  [984] = {
    [sym_assignment] = STATE(2776),
    [sym_unary] = STATE(2776),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2776),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2776),
    [sym_conditional] = STATE(2776),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2776),
    [sym_binary] = STATE(2776),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [985] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [986] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(2779),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(2780),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [987] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4708),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [988] = {
    [sym_assignment] = STATE(2782),
    [sym_unary] = STATE(2782),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2782),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2782),
    [sym_conditional] = STATE(2782),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2782),
    [sym_binary] = STATE(2782),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [989] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(2784),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(2785),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(2785),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2786),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(4710),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4710),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4712),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [990] = {
    [anon_sym_COLON] = ACTIONS(4714),
    [sym_comment] = ACTIONS(49),
  },
  [991] = {
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [992] = {
    [sym_assignment] = STATE(2788),
    [sym_unary] = STATE(2788),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2788),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2788),
    [sym_conditional] = STATE(2788),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2788),
    [sym_binary] = STATE(2788),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [993] = {
    [sym_assignment] = STATE(2789),
    [sym_unary] = STATE(2789),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2789),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2789),
    [sym_conditional] = STATE(2789),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2789),
    [sym_binary] = STATE(2789),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [994] = {
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [995] = {
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [996] = {
    [sym_assignment] = STATE(2790),
    [sym_unary] = STATE(2790),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(2790),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(2790),
    [sym_conditional] = STATE(2790),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(2790),
    [sym_binary] = STATE(2790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [997] = {
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [998] = {
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [999] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(4506),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4510),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1000] = {
    [sym_do_block] = STATE(2792),
    [sym_block] = STATE(2792),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(4716),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4718),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [1001] = {
    [anon_sym_EQ] = ACTIONS(4720),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(1003),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(1005),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(1003),
    [sym_range] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1003),
    [sym_assignment] = STATE(1005),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(1003),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(1003),
    [sym_operator_assignment] = STATE(1005),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(1007),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(1005),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1829),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [1003] = {
    [sym_heredoc_body] = STATE(2795),
    [aux_sym_call_repeat1] = STATE(2795),
    [aux_sym_argument_list_repeat1] = STATE(2796),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(4722),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1004] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(4724),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4724),
    [anon_sym_SLASH_EQ] = ACTIONS(4724),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4724),
    [anon_sym_PIPE_EQ] = ACTIONS(4724),
    [anon_sym_LT_LT_EQ] = ACTIONS(4724),
    [anon_sym_PLUS_EQ] = ACTIONS(4724),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4724),
    [anon_sym_STAR_EQ] = ACTIONS(4724),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4724),
    [anon_sym_CARET_EQ] = ACTIONS(4724),
    [anon_sym_DASH_EQ] = ACTIONS(4724),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4724),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(4726),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1005] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [1006] = {
    [aux_sym_chained_string_repeat1] = STATE(2807),
    [sym_string] = STATE(2807),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(4756),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1007] = {
    [sym_heredoc_body] = STATE(2795),
    [aux_sym_call_repeat1] = STATE(2795),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1008] = {
    [aux_sym_chained_string_repeat1] = STATE(2808),
    [sym_string] = STATE(2808),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [1009] = {
    [sym__line_break] = ACTIONS(4758),
    [anon_sym_then] = ACTIONS(4758),
    [anon_sym_until] = ACTIONS(4758),
    [anon_sym___END__] = ACTIONS(4758),
    [anon_sym_while] = ACTIONS(4758),
    [sym__heredoc_body_start] = ACTIONS(4758),
    [anon_sym_end] = ACTIONS(4758),
    [anon_sym_ensure] = ACTIONS(4758),
    [anon_sym_RPAREN] = ACTIONS(4758),
    [anon_sym_SEMI] = ACTIONS(4758),
    [anon_sym_else] = ACTIONS(4758),
    [sym_comment] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(4758),
    [anon_sym_elsif] = ACTIONS(4758),
    [anon_sym_unless] = ACTIONS(4758),
    [ts_builtin_sym_end] = ACTIONS(4758),
    [anon_sym_rescue] = ACTIONS(4758),
    [anon_sym_when] = ACTIONS(4758),
    [anon_sym_if] = ACTIONS(4758),
  },
  [1010] = {
    [anon_sym_RBRACE] = ACTIONS(4760),
    [sym_comment] = ACTIONS(49),
  },
  [1011] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2811),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4762),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1012] = {
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_rescue] = ACTIONS(3960),
    [anon_sym_unless] = ACTIONS(3962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3968),
  },
  [1013] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [sym__line_break] = ACTIONS(4768),
    [anon_sym_then] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_when] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym___END__] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_ensure] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_else] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_elsif] = ACTIONS(4768),
    [ts_builtin_sym_end] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
    [sym__binary_minus] = ACTIONS(4768),
  },
  [1014] = {
    [sym_interpolation] = STATE(1014),
    [aux_sym__literal_contents_repeat1] = STATE(1014),
    [sym__string_end] = ACTIONS(4060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(4770),
    [sym__string_content] = ACTIONS(4773),
    [sym_escape_sequence] = ACTIONS(4773),
  },
  [1015] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1016] = {
    [anon_sym_COLON] = ACTIONS(4778),
    [sym_comment] = ACTIONS(49),
  },
  [1017] = {
    [sym_assignment] = STATE(2824),
    [sym_unary] = STATE(2824),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2824),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(2824),
    [sym_conditional] = STATE(2824),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(2824),
    [sym_binary] = STATE(2824),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [1018] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(2830),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(4808),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1019] = {
    [sym_assignment] = STATE(2831),
    [sym_unary] = STATE(2831),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2831),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(2831),
    [sym_conditional] = STATE(2831),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(2831),
    [sym_binary] = STATE(2831),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [1020] = {
    [sym_assignment] = STATE(2832),
    [sym_unary] = STATE(2832),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2832),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(2832),
    [sym_conditional] = STATE(2832),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(2832),
    [sym_binary] = STATE(2832),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [1021] = {
    [sym_heredoc_body] = STATE(2835),
    [aux_sym_call_repeat1] = STATE(2835),
    [aux_sym_argument_list_repeat1] = STATE(2836),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_DOT] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
  },
  [1022] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [anon_sym_or] = ACTIONS(4814),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_PIPE] = ACTIONS(4500),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [1023] = {
    [aux_sym_chained_string_repeat1] = STATE(2652),
    [sym_string] = STATE(2652),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(4816),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1024] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
  },
  [1025] = {
    [sym_heredoc_body] = STATE(2835),
    [aux_sym_call_repeat1] = STATE(2835),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_DOT] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
  },
  [1026] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
  },
  [1027] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2839),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4818),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4820),
  },
  [1028] = {
    [aux_sym_string_array_repeat1] = STATE(2842),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4822),
    [sym__string_end] = ACTIONS(4824),
  },
  [1029] = {
    [sym__terminator] = STATE(2843),
    [sym_heredoc_body] = STATE(2843),
    [sym__do] = STATE(2843),
    [sym__line_break] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4826),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1030] = {
    [sym_heredoc_body] = STATE(2844),
    [sym__terminator] = STATE(2844),
    [sym__line_break] = ACTIONS(4828),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [1031] = {
    [sym_when] = STATE(2847),
    [sym_else] = STATE(2846),
    [aux_sym_case_repeat2] = STATE(2847),
    [aux_sym_case_repeat1] = STATE(2848),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(4830),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(4832),
    [sym_comment] = ACTIONS(49),
  },
  [1032] = {
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
  },
  [1033] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4834),
  },
  [1034] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
  },
  [1035] = {
    [anon_sym_RPAREN] = ACTIONS(4836),
    [sym_comment] = ACTIONS(49),
  },
  [1036] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
  },
  [1037] = {
    [sym__terminator] = STATE(2851),
    [sym_heredoc_body] = STATE(2851),
    [sym_then] = STATE(2852),
    [sym__line_break] = ACTIONS(4838),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4838),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1038] = {
    [sym_assignment] = STATE(2853),
    [sym_unary] = STATE(2853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2853),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(2853),
    [sym_conditional] = STATE(2853),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(2853),
    [sym_binary] = STATE(2853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1039] = {
    [sym_heredoc_body] = STATE(2854),
    [sym__terminator] = STATE(2854),
    [sym_superclass] = STATE(2855),
    [sym__line_break] = ACTIONS(4840),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4840),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1040] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(2855),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2854),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2854),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4840),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4840),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1041] = {
    [sym_heredoc_body] = STATE(2857),
    [sym__terminator] = STATE(2857),
    [sym__line_break] = ACTIONS(4842),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(4844),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1042] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(2857),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(2857),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(4842),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(4844),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1043] = {
    [anon_sym_end] = ACTIONS(4846),
    [sym_comment] = ACTIONS(49),
  },
  [1044] = {
    [sym_ensure] = STATE(2859),
    [sym_else] = STATE(2860),
    [anon_sym_end] = ACTIONS(4846),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1045] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(2861),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4848),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1046] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
  },
  [1047] = {
    [sym_ensure] = STATE(2859),
    [sym_else] = STATE(2860),
    [sym_rescue] = STATE(2862),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(4846),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1048] = {
    [sym_ensure] = STATE(2859),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(4846),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [1049] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
  },
  [1050] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4850),
  },
  [1051] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
  },
  [1052] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2866),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4852),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(4854),
  },
  [1053] = {
    [aux_sym_symbol_array_repeat1] = STATE(2869),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(4856),
    [sym__string_end] = ACTIONS(4858),
  },
  [1054] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
  },
  [1055] = {
    [anon_sym_RBRACK] = ACTIONS(4860),
    [sym_comment] = ACTIONS(49),
  },
  [1056] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
  },
  [1057] = {
    [sym_heredoc_body] = STATE(2872),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(49),
  },
  [1058] = {
    [anon_sym_RBRACE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(49),
  },
  [1059] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
  },
  [1060] = {
    [sym__terminator] = STATE(2873),
    [sym_heredoc_body] = STATE(2873),
    [sym__do] = STATE(2873),
    [sym__line_break] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(4864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4864),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1061] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
  },
  [1062] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4866),
  },
  [1063] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
  },
  [1064] = {
    [sym_in] = STATE(2875),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [1065] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
  },
  [1066] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(4868),
  },
  [1067] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(2878),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(2879),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(2879),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(2880),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(4870),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(4870),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(4872),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1068] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(2882),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(2883),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4874),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1069] = {
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
  },
  [1070] = {
    [sym_do_block] = STATE(2884),
    [sym_block] = STATE(2884),
    [anon_sym_do] = ACTIONS(4876),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1913),
  },
  [1071] = {
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1072] = {
    [sym_assignment] = STATE(2885),
    [sym_unary] = STATE(2885),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(2885),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(2885),
    [sym_conditional] = STATE(2885),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(2885),
    [sym_binary] = STATE(2885),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1073] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(2886),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(2886),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(2886),
    [sym__line_break] = ACTIONS(4878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [1074] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
  },
  [1075] = {
    [anon_sym_DOT] = ACTIONS(4880),
    [anon_sym_COLON_COLON] = ACTIONS(4880),
    [sym_comment] = ACTIONS(49),
  },
  [1076] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
  },
  [1077] = {
    [sym__terminator] = STATE(2888),
    [sym_heredoc_body] = STATE(2888),
    [sym_then] = STATE(2889),
    [sym__line_break] = ACTIONS(4882),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4882),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1078] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [sym__symbol_start] = ACTIONS(461),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(4884),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(393),
  },
  [1079] = {
    [aux_sym__mlhs_repeat1] = STATE(2891),
    [anon_sym_COMMA] = ACTIONS(4886),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(2895),
  },
  [1080] = {
    [sym_heredoc_body] = STATE(2896),
    [sym__argument_list_with_parens] = STATE(2895),
    [aux_sym_call_repeat1] = STATE(2896),
    [sym_argument_list_with_parens] = STATE(2894),
    [sym_operator] = STATE(2894),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_SLASH] = ACTIONS(4890),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4890),
    [anon_sym_PLUS_AT] = ACTIONS(4890),
    [anon_sym_LPAREN2] = ACTIONS(4892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_TILDE] = ACTIONS(4890),
    [anon_sym_PLUS] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_PERCENT] = ACTIONS(4890),
    [anon_sym_DASH_AT] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4888),
    [anon_sym_BANG_TILDE] = ACTIONS(4890),
    [sym_constant] = ACTIONS(4894),
    [anon_sym_DASH] = ACTIONS(4888),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_STAR_STAR] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_DOT_DOT] = ACTIONS(4890),
    [anon_sym_LT_EQ_GT] = ACTIONS(4890),
    [anon_sym_LT_EQ] = ACTIONS(4888),
    [anon_sym_BANG] = ACTIONS(4888),
    [sym_identifier] = ACTIONS(4894),
    [anon_sym_CARET] = ACTIONS(4890),
  },
  [1081] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(2898),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(4896),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [1082] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4898),
    [sym_identifier] = ACTIONS(4898),
  },
  [1083] = {
    [sym_assignment] = STATE(2900),
    [sym_unary] = STATE(2900),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2900),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(2900),
    [sym_conditional] = STATE(2900),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(2900),
    [sym_binary] = STATE(2900),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [1084] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [1085] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(2882),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(699),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(700),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(2883),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(4902),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1086] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(4904),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1087] = {
    [sym_assignment] = STATE(2904),
    [sym_unary] = STATE(2904),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2904),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(2904),
    [sym_conditional] = STATE(2904),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(2904),
    [sym_binary] = STATE(2904),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [1088] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(4906),
    [sym_identifier] = ACTIONS(4906),
  },
  [1089] = {
    [anon_sym_COLON] = ACTIONS(4908),
    [sym_comment] = ACTIONS(49),
  },
  [1090] = {
    [sym__argument] = STATE(2912),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(2912),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(2912),
    [sym_hash_splat_argument] = STATE(2912),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(2915),
    [sym_block_argument] = STATE(2912),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(501),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1091] = {
    [sym_assignment] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [1092] = {
    [sym_assignment] = STATE(2930),
    [sym_unary] = STATE(2930),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(2930),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(2930),
    [sym_conditional] = STATE(2930),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(2930),
    [sym_binary] = STATE(2930),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [1093] = {
    [sym__argument] = STATE(2912),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(2912),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(2912),
    [sym_hash_splat_argument] = STATE(2912),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(2915),
    [sym_block_argument] = STATE(2912),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1094] = {
    [sym__argument] = STATE(2912),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(2912),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(2912),
    [sym_hash_splat_argument] = STATE(2912),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(2915),
    [sym_block_argument] = STATE(2912),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1095] = {
    [sym_assignment] = STATE(2931),
    [sym_unary] = STATE(2931),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(2931),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(2931),
    [sym_conditional] = STATE(2931),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(2931),
    [sym_binary] = STATE(2931),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [1096] = {
    [sym__argument] = STATE(2912),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(2912),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(2912),
    [sym_hash_splat_argument] = STATE(2912),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(2915),
    [sym_block_argument] = STATE(2912),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(753),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1097] = {
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [sym_comment] = ACTIONS(49),
  },
  [1098] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_in] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(4948),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4950),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4952),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [1099] = {
    [sym_do_block] = STATE(2934),
    [sym_block] = STATE(2934),
    [anon_sym_do] = ACTIONS(4876),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [sym_comment] = ACTIONS(49),
  },
  [1100] = {
    [anon_sym_EQ] = ACTIONS(4954),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym__primary] = STATE(2948),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(2950),
    [sym_method] = STATE(2948),
    [sym_conditional] = STATE(2952),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_subshell] = STATE(2948),
    [sym_unless] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_block_argument] = STATE(2950),
    [sym_range] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2951),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_call] = STATE(1101),
    [sym__argument] = STATE(2950),
    [sym_assignment] = STATE(2952),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_pair] = STATE(2950),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(2950),
    [sym_operator_assignment] = STATE(2952),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_rational] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_lambda] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(2954),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(2952),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_nil] = STATE(2951),
    [sym_symbol_array] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_scope_resolution] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4972),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(791),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [1102] = {
    [sym_heredoc_body] = STATE(2956),
    [aux_sym_call_repeat1] = STATE(2956),
    [aux_sym_argument_list_repeat1] = STATE(2957),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [1103] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(4988),
    [anon_sym_SLASH_EQ] = ACTIONS(4988),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_LT_LT_EQ] = ACTIONS(4988),
    [anon_sym_PLUS_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_STAR_EQ] = ACTIONS(4988),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4988),
    [anon_sym_CARET_EQ] = ACTIONS(4988),
    [anon_sym_DASH_EQ] = ACTIONS(4988),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4988),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(4990),
  },
  [1104] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(5004),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [anon_sym_and] = ACTIONS(5004),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_PIPE] = ACTIONS(5016),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [1105] = {
    [aux_sym_chained_string_repeat1] = STATE(2969),
    [sym_string] = STATE(2969),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5020),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1106] = {
    [sym_heredoc_body] = STATE(2956),
    [aux_sym_call_repeat1] = STATE(2956),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [1107] = {
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym_string] = STATE(2970),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(443),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
  },
  [1108] = {
    [sym_assignment] = STATE(2971),
    [sym_unary] = STATE(2971),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(2971),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(2971),
    [sym_conditional] = STATE(2971),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(2971),
    [sym_binary] = STATE(2971),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [1109] = {
    [sym__terminator] = STATE(2972),
    [sym_heredoc_body] = STATE(2972),
    [sym__do] = STATE(2972),
    [anon_sym_do] = ACTIONS(5022),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5022),
    [sym_comment] = ACTIONS(49),
  },
  [1110] = {
    [anon_sym_do] = ACTIONS(5024),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_COMMA] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5024),
    [anon_sym_RPAREN] = ACTIONS(5024),
    [anon_sym_SEMI] = ACTIONS(5024),
    [sym_comment] = ACTIONS(49),
  },
  [1111] = {
    [sym__method_name] = STATE(2973),
    [sym_setter] = STATE(2973),
    [sym_symbol] = STATE(2973),
    [sym_operator] = STATE(2973),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(5026),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(5026),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(5026),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [1112] = {
    [sym_assignment] = STATE(2974),
    [sym_unary] = STATE(2974),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(2974),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(2974),
    [sym_conditional] = STATE(2974),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(2974),
    [sym_binary] = STATE(2974),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1113] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1114] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2976),
    [sym_interpolation] = STATE(2976),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(5028),
    [sym_heredoc_end] = ACTIONS(5030),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(5028),
  },
  [1115] = {
    [sym_assignment] = STATE(2977),
    [sym_unary] = STATE(2977),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(2977),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(2977),
    [sym_conditional] = STATE(2977),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(2977),
    [sym_binary] = STATE(2977),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1116] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5032),
    [sym_identifier] = ACTIONS(5032),
  },
  [1117] = {
    [sym_splat_parameter] = STATE(2983),
    [sym_hash_splat_parameter] = STATE(2983),
    [sym_block_parameter] = STATE(2983),
    [sym__formal_parameter] = STATE(2983),
    [sym__simple_formal_parameter] = STATE(2983),
    [sym_keyword_parameter] = STATE(2983),
    [sym_optional_parameter] = STATE(2983),
    [sym_destructured_parameter] = STATE(2983),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(5034),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5038),
    [anon_sym_SEMI] = ACTIONS(5040),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [1118] = {
    [sym__argument] = STATE(2997),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(2997),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(2997),
    [sym_hash_splat_argument] = STATE(2997),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(3004),
    [sym_block_argument] = STATE(2997),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [1119] = {
    [sym__argument] = STATE(2997),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(2997),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(2997),
    [sym_hash_splat_argument] = STATE(2997),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(3004),
    [sym_block_argument] = STATE(2997),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [1120] = {
    [sym__argument] = STATE(2997),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(2997),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(2997),
    [sym_hash_splat_argument] = STATE(2997),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(3004),
    [sym_block_argument] = STATE(2997),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [1121] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [sym__line_break] = ACTIONS(5080),
    [anon_sym_then] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_when] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym___END__] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_end] = ACTIONS(5080),
    [anon_sym_ensure] = ACTIONS(5080),
    [anon_sym_else] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_elsif] = ACTIONS(5080),
    [ts_builtin_sym_end] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
  },
  [1122] = {
    [sym__argument] = STATE(2997),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(2997),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(2997),
    [sym_hash_splat_argument] = STATE(2997),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(3004),
    [sym_block_argument] = STATE(2997),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [1123] = {
    [sym_heredoc_body] = STATE(3010),
    [sym__terminator] = STATE(3010),
    [sym__line_break] = ACTIONS(5082),
    [anon_sym_unless] = ACTIONS(5084),
    [anon_sym_until] = ACTIONS(5086),
    [anon_sym_while] = ACTIONS(5088),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(5090),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym_if] = ACTIONS(5092),
    [sym_comment] = ACTIONS(49),
  },
  [1124] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(3012),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(3012),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(3013),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(5094),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5096),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1125] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(5098),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5100),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5102),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1126] = {
    [anon_sym_EQ] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
  },
  [1127] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(3017),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(3013),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5096),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1128] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym__primary] = STATE(3030),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_method] = STATE(3030),
    [sym_conditional] = STATE(3035),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_subshell] = STATE(3030),
    [sym_unless] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3034),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_call] = STATE(3032),
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_rational] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_lambda] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(3035),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_nil] = STATE(3034),
    [sym_symbol_array] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_scope_resolution] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [1129] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(5140),
    [anon_sym_GT_GT_EQ] = ACTIONS(5140),
    [anon_sym_SLASH_EQ] = ACTIONS(5140),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5140),
    [anon_sym_LT_LT_EQ] = ACTIONS(5140),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5140),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5140),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(5140),
    [anon_sym_PLUS_EQ] = ACTIONS(5140),
    [anon_sym_STAR_EQ] = ACTIONS(5140),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5140),
    [anon_sym_DASH_EQ] = ACTIONS(5140),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5140),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1130] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [1131] = {
    [aux_sym_chained_string_repeat1] = STATE(3049),
    [sym_string] = STATE(3049),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1132] = {
    [anon_sym_end] = ACTIONS(5172),
    [sym_comment] = ACTIONS(49),
  },
  [1133] = {
    [sym__statement] = STATE(3050),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3050),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(3050),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(3050),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(3051),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(3050),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(3050),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(3050),
    [sym_if_modifier] = STATE(3050),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(3050),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(3050),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(3051),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1134] = {
    [anon_sym_do] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5174),
    [anon_sym_COMMA] = ACTIONS(5174),
    [anon_sym_LBRACE] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [anon_sym_SEMI] = ACTIONS(5174),
    [sym_comment] = ACTIONS(49),
  },
  [1135] = {
    [sym_assignment] = STATE(3061),
    [sym_unary] = STATE(3061),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(3061),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(3061),
    [sym_conditional] = STATE(3061),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(3061),
    [sym_binary] = STATE(3061),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_COMMA] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [anon_sym_class] = ACTIONS(1295),
    [sym__subshell_start] = ACTIONS(1297),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5194),
    [sym_super] = ACTIONS(5184),
    [anon_sym_nil] = ACTIONS(1259),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym_character] = ACTIONS(5190),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_do] = ACTIONS(5202),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [1136] = {
    [sym_assignment] = STATE(3066),
    [sym_unary] = STATE(3066),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(3066),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(3066),
    [sym_conditional] = STATE(3066),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(3066),
    [sym_binary] = STATE(3066),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [1137] = {
    [anon_sym_do] = ACTIONS(5208),
    [anon_sym_PIPE] = ACTIONS(5208),
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_LBRACE] = ACTIONS(5208),
    [anon_sym_RPAREN] = ACTIONS(5208),
    [anon_sym_SEMI] = ACTIONS(5208),
    [sym_comment] = ACTIONS(49),
  },
  [1138] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
  },
  [1139] = {
    [sym_splat_parameter] = STATE(3070),
    [sym_hash_splat_parameter] = STATE(3070),
    [sym_block_parameter] = STATE(3070),
    [sym__formal_parameter] = STATE(3070),
    [sym__simple_formal_parameter] = STATE(3070),
    [sym_keyword_parameter] = STATE(3070),
    [sym_optional_parameter] = STATE(3070),
    [sym_destructured_parameter] = STATE(3070),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(5214),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_SEMI] = ACTIONS(5218),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [1140] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(3072),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1141] = {
    [anon_sym_RBRACE] = ACTIONS(5220),
    [sym_comment] = ACTIONS(49),
  },
  [1142] = {
    [anon_sym_PIPE] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(5222),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_SEMI] = ACTIONS(1973),
    [sym_comment] = ACTIONS(49),
  },
  [1143] = {
    [anon_sym_PIPE] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(5224),
    [anon_sym_RPAREN] = ACTIONS(2017),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2017),
    [sym_comment] = ACTIONS(49),
  },
  [1144] = {
    [anon_sym_COLON] = ACTIONS(5226),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [anon_sym_do] = ACTIONS(5230),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(5230),
  },
  [1146] = {
    [sym_splat_parameter] = STATE(3075),
    [sym_hash_splat_parameter] = STATE(3075),
    [sym_block_parameter] = STATE(3075),
    [sym__formal_parameter] = STATE(3075),
    [sym__simple_formal_parameter] = STATE(3075),
    [sym_keyword_parameter] = STATE(3075),
    [sym_optional_parameter] = STATE(3075),
    [sym_destructured_parameter] = STATE(3075),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [1147] = {
    [aux_sym_method_parameters_repeat1] = STATE(3078),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [1148] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [sym__line_break] = ACTIONS(5238),
    [anon_sym_then] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym___END__] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_end] = ACTIONS(5238),
    [anon_sym_ensure] = ACTIONS(5238),
    [anon_sym_else] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_elsif] = ACTIONS(5238),
    [ts_builtin_sym_end] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [sym__binary_minus] = ACTIONS(5238),
  },
  [1149] = {
    [sym_splat_parameter] = STATE(3079),
    [sym__simple_formal_parameter] = STATE(3079),
    [sym_keyword_parameter] = STATE(3079),
    [sym_optional_parameter] = STATE(3079),
    [sym_hash_splat_parameter] = STATE(3079),
    [sym_block_parameter] = STATE(3079),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [sym_identifier] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
  },
  [1150] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3080),
    [anon_sym_do] = ACTIONS(5230),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(5230),
    [sym_comment] = ACTIONS(49),
  },
  [1151] = {
    [sym__line_break] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2305),
  },
  [1152] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(5242),
  },
  [1153] = {
    [sym__argument] = STATE(3090),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3090),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3090),
    [sym_hash_splat_argument] = STATE(3090),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3095),
    [sym_block_argument] = STATE(3090),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1154] = {
    [sym__argument] = STATE(3090),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3090),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3090),
    [sym_hash_splat_argument] = STATE(3090),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3095),
    [sym_block_argument] = STATE(3090),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1155] = {
    [sym_assignment] = STATE(3096),
    [sym_unary] = STATE(3096),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(3096),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(3096),
    [sym_conditional] = STATE(3096),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(3096),
    [sym_binary] = STATE(3096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1156] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1157] = {
    [sym__argument] = STATE(3090),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3090),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3090),
    [sym_hash_splat_argument] = STATE(3090),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3095),
    [sym_block_argument] = STATE(3090),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1158] = {
    [sym_assignment] = STATE(3097),
    [sym_unary] = STATE(3097),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(3097),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(3097),
    [sym_conditional] = STATE(3097),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(3097),
    [sym_binary] = STATE(3097),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1159] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5264),
    [sym_identifier] = ACTIONS(5264),
  },
  [1160] = {
    [sym__argument] = STATE(3090),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3090),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3090),
    [sym_hash_splat_argument] = STATE(3090),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3095),
    [sym_block_argument] = STATE(3090),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1161] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(5266),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(5266),
    [anon_sym_SLASH_EQ] = ACTIONS(5266),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(5266),
    [anon_sym_PIPE_EQ] = ACTIONS(5266),
    [anon_sym_LT_LT_EQ] = ACTIONS(5266),
    [anon_sym_PLUS_EQ] = ACTIONS(5266),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5266),
    [anon_sym_STAR_EQ] = ACTIONS(5266),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5266),
    [anon_sym_CARET_EQ] = ACTIONS(5266),
    [anon_sym_DASH_EQ] = ACTIONS(5266),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5268),
  },
  [1162] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(5278),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [1163] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(5300),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5302),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [1164] = {
    [sym_block] = STATE(2275),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym__primary] = STATE(3126),
    [sym_argument_list] = STATE(2277),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_method] = STATE(3126),
    [sym_conditional] = STATE(3131),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_subshell] = STATE(3126),
    [sym_unless] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3130),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_lambda] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_do_block] = STATE(2275),
    [sym_binary] = STATE(3131),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_nil] = STATE(3130),
    [sym_symbol_array] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_scope_resolution] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [1165] = {
    [anon_sym_EQ] = ACTIONS(5340),
    [sym_comment] = ACTIONS(3),
  },
  [1166] = {
    [aux_sym_chained_string_repeat1] = STATE(3134),
    [sym_string] = STATE(3134),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1167] = {
    [sym__line_break] = ACTIONS(3496),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_STAR_STAR] = ACTIONS(3496),
    [sym__heredoc_body_start] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym_LPAREN] = ACTIONS(3496),
  },
  [1168] = {
    [sym__line_break] = ACTIONS(2017),
    [sym__heredoc_body_start] = ACTIONS(2017),
    [anon_sym_COMMA] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(5342),
    [anon_sym_SEMI] = ACTIONS(2017),
    [sym_comment] = ACTIONS(49),
  },
  [1169] = {
    [sym_lambda] = STATE(3137),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(5344),
    [sym_identifier] = ACTIONS(5346),
  },
  [1170] = {
    [sym__line_break] = ACTIONS(1973),
    [sym__heredoc_body_start] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(5348),
    [anon_sym_SEMI] = ACTIONS(1973),
    [sym_comment] = ACTIONS(49),
  },
  [1171] = {
    [sym__line_break] = ACTIONS(2021),
    [sym__heredoc_body_start] = ACTIONS(2021),
    [anon_sym_COLON] = ACTIONS(5350),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(5352),
    [sym_comment] = ACTIONS(3),
  },
  [1172] = {
    [sym_splat_parameter] = STATE(3142),
    [sym_hash_splat_parameter] = STATE(3142),
    [sym_block_parameter] = STATE(3142),
    [sym__formal_parameter] = STATE(3142),
    [sym__simple_formal_parameter] = STATE(3142),
    [sym_keyword_parameter] = STATE(3142),
    [sym_optional_parameter] = STATE(3142),
    [sym_destructured_parameter] = STATE(3142),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(5354),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [1173] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(3143),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1174] = {
    [sym_heredoc_body] = STATE(3145),
    [sym__terminator] = STATE(3145),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5358),
    [sym_comment] = ACTIONS(49),
  },
  [1175] = {
    [sym__method_name] = STATE(258),
    [sym_setter] = STATE(258),
    [sym_symbol] = STATE(258),
    [sym_operator] = STATE(258),
    [sym__method_rest] = STATE(3147),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(5362),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(5362),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(5362),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [1176] = {
    [sym__terminator] = STATE(3148),
    [sym_heredoc_body] = STATE(3148),
    [sym__do] = STATE(3148),
    [sym__line_break] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1177] = {
    [sym__terminator] = STATE(3149),
    [sym_heredoc_body] = STATE(3149),
    [sym_then] = STATE(3150),
    [sym__line_break] = ACTIONS(5368),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1178] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [1179] = {
    [aux_sym_chained_string_repeat1] = STATE(1312),
    [sym_string] = STATE(1312),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1180] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [1181] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [sym__line_break] = ACTIONS(1227),
    [anon_sym_then] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_when] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym___END__] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_end] = ACTIONS(1227),
    [anon_sym_ensure] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_elsif] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [sym__binary_minus] = ACTIONS(1227),
  },
  [1182] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3153),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(5370),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(5372),
  },
  [1183] = {
    [aux_sym_symbol_array_repeat1] = STATE(3156),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(5374),
    [sym__string_end] = ACTIONS(5376),
  },
  [1184] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [sym__line_break] = ACTIONS(1339),
    [anon_sym_then] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym___END__] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_ensure] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_elsif] = ACTIONS(1339),
    [ts_builtin_sym_end] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [sym__binary_minus] = ACTIONS(1339),
  },
  [1185] = {
    [anon_sym_RBRACK] = ACTIONS(5378),
    [sym_comment] = ACTIONS(49),
  },
  [1186] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [sym__line_break] = ACTIONS(1635),
    [anon_sym_then] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_when] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym___END__] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_end] = ACTIONS(1635),
    [anon_sym_ensure] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_elsif] = ACTIONS(1635),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [sym__binary_minus] = ACTIONS(1635),
  },
  [1187] = {
    [sym_heredoc_body] = STATE(3159),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [sym_comment] = ACTIONS(49),
  },
  [1188] = {
    [anon_sym_RBRACE] = ACTIONS(5380),
    [sym_comment] = ACTIONS(49),
  },
  [1189] = {
    [sym_assignment] = STATE(3160),
    [sym_unary] = STATE(3160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3160),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(3160),
    [sym_conditional] = STATE(3160),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(3160),
    [sym_binary] = STATE(3160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1190] = {
    [sym__terminator] = STATE(3161),
    [sym_heredoc_body] = STATE(3161),
    [sym__do] = STATE(3161),
    [sym__line_break] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1191] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [1192] = {
    [anon_sym_SLASH] = ACTIONS(1853),
    [sym__line_break] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(1851),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_else] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_then] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_when] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym___END__] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_end] = ACTIONS(1853),
    [anon_sym_ensure] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_elsif] = ACTIONS(1853),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
  },
  [1193] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(5384),
  },
  [1194] = {
    [sym_in] = STATE(3163),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [1195] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(3165),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(3166),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(3166),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(3167),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(5386),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5388),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1196] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(3169),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(3170),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(5390),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1197] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [sym__line_break] = ACTIONS(2045),
    [anon_sym_then] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_EQ_GT] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym___END__] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_end] = ACTIONS(2045),
    [anon_sym_ensure] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_elsif] = ACTIONS(2045),
    [ts_builtin_sym_end] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [sym__binary_minus] = ACTIONS(2045),
  },
  [1198] = {
    [sym_do_block] = STATE(3171),
    [sym_block] = STATE(3171),
    [anon_sym_do] = ACTIONS(5392),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(2129),
  },
  [1199] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym___END__] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [ts_builtin_sym_end] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1200] = {
    [sym_assignment] = STATE(3172),
    [sym_unary] = STATE(3172),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3172),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(3172),
    [sym_conditional] = STATE(3172),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(3172),
    [sym_binary] = STATE(3172),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1201] = {
    [sym_assignment] = STATE(3173),
    [sym_unary] = STATE(3173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(3173),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(3173),
    [sym_conditional] = STATE(3173),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(3173),
    [sym_binary] = STATE(3173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1202] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(3174),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(3174),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(3174),
    [sym__line_break] = ACTIONS(5394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [1203] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [sym__line_break] = ACTIONS(2103),
    [anon_sym_then] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_EQ_GT] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_when] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym___END__] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_end] = ACTIONS(2103),
    [anon_sym_ensure] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_elsif] = ACTIONS(2103),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [sym__binary_minus] = ACTIONS(2103),
  },
  [1204] = {
    [anon_sym_DOT] = ACTIONS(5396),
    [anon_sym_COLON_COLON] = ACTIONS(5396),
    [sym_comment] = ACTIONS(49),
  },
  [1205] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(5398),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym___END__] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1206] = {
    [anon_sym_COLON] = ACTIONS(5400),
    [sym_comment] = ACTIONS(49),
  },
  [1207] = {
    [sym_assignment] = STATE(3178),
    [sym_unary] = STATE(3178),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3178),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3178),
    [sym_conditional] = STATE(3178),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3178),
    [sym_binary] = STATE(3178),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1208] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(3180),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(5402),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1209] = {
    [sym_assignment] = STATE(3181),
    [sym_unary] = STATE(3181),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3181),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3181),
    [sym_conditional] = STATE(3181),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3181),
    [sym_binary] = STATE(3181),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1210] = {
    [sym_assignment] = STATE(3182),
    [sym_unary] = STATE(3182),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3182),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3182),
    [sym_conditional] = STATE(3182),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3182),
    [sym_binary] = STATE(3182),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1211] = {
    [sym_heredoc_body] = STATE(3185),
    [aux_sym_call_repeat1] = STATE(3185),
    [aux_sym_argument_list_repeat1] = STATE(3186),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1212] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [1213] = {
    [aux_sym_chained_string_repeat1] = STATE(1312),
    [sym_string] = STATE(1312),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5408),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1214] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [sym__line_break] = ACTIONS(2301),
    [anon_sym_then] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_when] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym___END__] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_end] = ACTIONS(2301),
    [anon_sym_ensure] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_elsif] = ACTIONS(2301),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [sym__binary_minus] = ACTIONS(2301),
  },
  [1215] = {
    [sym_heredoc_body] = STATE(3185),
    [aux_sym_call_repeat1] = STATE(3185),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1216] = {
    [sym__argument] = STATE(3187),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(3187),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3187),
    [sym_hash_splat_argument] = STATE(3187),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(3188),
    [sym_block_argument] = STATE(3187),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym___END__] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [ts_builtin_sym_end] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [1217] = {
    [sym__argument] = STATE(3187),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(3187),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3187),
    [sym_hash_splat_argument] = STATE(3187),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(3188),
    [sym_block_argument] = STATE(3187),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym___END__] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [1218] = {
    [sym_assignment] = STATE(3189),
    [sym_unary] = STATE(3189),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3189),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(3189),
    [sym_conditional] = STATE(3189),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(3189),
    [sym_binary] = STATE(3189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1219] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1220] = {
    [sym__argument] = STATE(3187),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(3187),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3187),
    [sym_hash_splat_argument] = STATE(3187),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(3188),
    [sym_block_argument] = STATE(3187),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [1221] = {
    [sym_assignment] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1222] = {
    [sym__argument] = STATE(3187),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(3187),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3187),
    [sym_hash_splat_argument] = STATE(3187),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym__argument_list_with_parens] = STATE(3188),
    [sym_block_argument] = STATE(3187),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(497),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(503),
    [sym_self] = ACTIONS(505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(545),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym___END__] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [ts_builtin_sym_end] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(577),
  },
  [1223] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(5410),
    [anon_sym_GT_GT_EQ] = ACTIONS(5410),
    [anon_sym_SLASH_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5410),
    [anon_sym_LT_LT_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_PLUS_EQ] = ACTIONS(5410),
    [anon_sym_STAR_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5410),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(5410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5410),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1224] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [1225] = {
    [anon_sym_EQ] = ACTIONS(5442),
    [sym_comment] = ACTIONS(3),
  },
  [1226] = {
    [aux_sym_chained_string_repeat1] = STATE(3202),
    [sym_string] = STATE(3202),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1227] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [sym__line_break] = ACTIONS(2305),
    [anon_sym_then] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_when] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym___END__] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_end] = ACTIONS(2305),
    [anon_sym_ensure] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_elsif] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [sym__binary_minus] = ACTIONS(2305),
  },
  [1228] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(5444),
  },
  [1229] = {
    [sym_heredoc_body] = STATE(3204),
    [sym__terminator] = STATE(3204),
    [sym__line_break] = ACTIONS(5446),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [1230] = {
    [sym_when] = STATE(3207),
    [sym_else] = STATE(3206),
    [aux_sym_case_repeat2] = STATE(3207),
    [aux_sym_case_repeat1] = STATE(3208),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(5448),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5450),
    [sym_comment] = ACTIONS(49),
  },
  [1231] = {
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_then] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_when] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym___END__] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5454),
    [anon_sym_ensure] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_elsif] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
  },
  [1232] = {
    [sym_assignment] = STATE(3209),
    [sym_unary] = STATE(3209),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3209),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(3209),
    [sym_conditional] = STATE(3209),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(3209),
    [sym_binary] = STATE(3209),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1233] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1234] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1235] = {
    [sym_assignment] = STATE(3212),
    [sym_unary] = STATE(3212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3212),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(3212),
    [sym_conditional] = STATE(3212),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(3212),
    [sym_binary] = STATE(3212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1236] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5458),
    [sym_identifier] = ACTIONS(5458),
  },
  [1237] = {
    [anon_sym_COLON] = ACTIONS(5460),
    [sym_comment] = ACTIONS(49),
  },
  [1238] = {
    [sym__argument] = STATE(3220),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3220),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3220),
    [sym_hash_splat_argument] = STATE(3220),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3223),
    [sym_block_argument] = STATE(3220),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1239] = {
    [sym_assignment] = STATE(3233),
    [sym_unary] = STATE(3233),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(3233),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(3233),
    [sym_conditional] = STATE(3233),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(3233),
    [sym_binary] = STATE(3233),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [1240] = {
    [sym_assignment] = STATE(3238),
    [sym_unary] = STATE(3238),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(3238),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(3238),
    [sym_conditional] = STATE(3238),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(3238),
    [sym_binary] = STATE(3238),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [1241] = {
    [sym__argument] = STATE(3220),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3220),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3220),
    [sym_hash_splat_argument] = STATE(3220),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3223),
    [sym_block_argument] = STATE(3220),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1242] = {
    [sym__argument] = STATE(3220),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3220),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3220),
    [sym_hash_splat_argument] = STATE(3220),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3223),
    [sym_block_argument] = STATE(3220),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1243] = {
    [sym_assignment] = STATE(3239),
    [sym_unary] = STATE(3239),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(3239),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(3239),
    [sym_conditional] = STATE(3239),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(3239),
    [sym_binary] = STATE(3239),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [1244] = {
    [sym__argument] = STATE(3220),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(3220),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(3220),
    [sym_hash_splat_argument] = STATE(3220),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(3223),
    [sym_block_argument] = STATE(3220),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1245] = {
    [sym_heredoc_body] = STATE(804),
    [aux_sym_argument_list_repeat1] = STATE(3241),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(1499),
    [sym_comment] = ACTIONS(49),
  },
  [1246] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(5500),
    [anon_sym_SLASH_EQ] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5500),
    [anon_sym_PIPE_EQ] = ACTIONS(5500),
    [anon_sym_LT_LT_EQ] = ACTIONS(5500),
    [anon_sym_PLUS_EQ] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5500),
    [anon_sym_STAR_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5500),
    [anon_sym_CARET_EQ] = ACTIONS(5500),
    [anon_sym_DASH_EQ] = ACTIONS(5500),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5502),
  },
  [1247] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5516),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(5460),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5516),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5528),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [1248] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(5536),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
  },
  [1249] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym__primary] = STATE(3126),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_method] = STATE(3126),
    [sym_conditional] = STATE(3262),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_subshell] = STATE(3126),
    [sym_unless] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3130),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_lambda] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(3262),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_nil] = STATE(3130),
    [sym_symbol_array] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_scope_resolution] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [1250] = {
    [anon_sym_EQ] = ACTIONS(5546),
    [sym_comment] = ACTIONS(3),
  },
  [1251] = {
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym_string] = STATE(3265),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5548),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1252] = {
    [anon_sym_RPAREN] = ACTIONS(5550),
    [sym_comment] = ACTIONS(49),
  },
  [1253] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [sym__line_break] = ACTIONS(2387),
    [anon_sym_then] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_EQ_GT] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_when] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym___END__] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_end] = ACTIONS(2387),
    [anon_sym_ensure] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_elsif] = ACTIONS(2387),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [sym__binary_minus] = ACTIONS(2387),
  },
  [1254] = {
    [anon_sym_RPAREN] = ACTIONS(5552),
    [sym_comment] = ACTIONS(49),
  },
  [1255] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym___END__] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [1256] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [sym__line_break] = ACTIONS(2533),
    [anon_sym_then] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_EQ_GT] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_when] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym___END__] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_end] = ACTIONS(2533),
    [anon_sym_ensure] = ACTIONS(2533),
    [anon_sym_else] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_elsif] = ACTIONS(2533),
    [ts_builtin_sym_end] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [sym__binary_minus] = ACTIONS(2533),
  },
  [1257] = {
    [sym_assignment] = STATE(3268),
    [sym_unary] = STATE(3268),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3268),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3268),
    [sym_conditional] = STATE(3268),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3268),
    [sym_binary] = STATE(3268),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1258] = {
    [sym_heredoc_body] = STATE(3269),
    [sym__terminator] = STATE(3269),
    [sym_superclass] = STATE(3270),
    [sym__line_break] = ACTIONS(5556),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(5556),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1259] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(3270),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(3269),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(3269),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(5556),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(5556),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1260] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [sym__line_break] = ACTIONS(2577),
    [anon_sym_then] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_EQ_GT] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_when] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym___END__] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_end] = ACTIONS(2577),
    [anon_sym_ensure] = ACTIONS(2577),
    [anon_sym_else] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_elsif] = ACTIONS(2577),
    [ts_builtin_sym_end] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [sym__binary_minus] = ACTIONS(2577),
  },
  [1261] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(5558),
  },
  [1262] = {
    [sym_heredoc_body] = STATE(3273),
    [sym__terminator] = STATE(3273),
    [sym__line_break] = ACTIONS(5560),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(5560),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(5562),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1263] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(3273),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(3273),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(5560),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(5560),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(5562),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1264] = {
    [anon_sym_end] = ACTIONS(5564),
    [sym_comment] = ACTIONS(49),
  },
  [1265] = {
    [sym_ensure] = STATE(3275),
    [sym_else] = STATE(3276),
    [anon_sym_end] = ACTIONS(5564),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1266] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(3277),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5566),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1267] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [sym__line_break] = ACTIONS(2743),
    [anon_sym_then] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_when] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym___END__] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_end] = ACTIONS(2743),
    [anon_sym_ensure] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_elsif] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [sym__binary_minus] = ACTIONS(2743),
  },
  [1268] = {
    [sym_ensure] = STATE(3275),
    [sym_else] = STATE(3276),
    [sym_rescue] = STATE(3278),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(5564),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1269] = {
    [sym_ensure] = STATE(3275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(5564),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [1270] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [sym__line_break] = ACTIONS(2853),
    [anon_sym_then] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_when] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym___END__] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_end] = ACTIONS(2853),
    [anon_sym_ensure] = ACTIONS(2853),
    [anon_sym_else] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_elsif] = ACTIONS(2853),
    [ts_builtin_sym_end] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
    [sym__binary_minus] = ACTIONS(2853),
  },
  [1271] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [sym__line_break] = ACTIONS(2857),
    [anon_sym_then] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_when] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym___END__] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_end] = ACTIONS(2857),
    [anon_sym_ensure] = ACTIONS(2857),
    [anon_sym_else] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_elsif] = ACTIONS(2857),
    [ts_builtin_sym_end] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(2857),
  },
  [1272] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(5568),
  },
  [1273] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [sym__line_break] = ACTIONS(2863),
    [anon_sym_then] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_EQ_GT] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_when] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym___END__] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_end] = ACTIONS(2863),
    [anon_sym_ensure] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_elsif] = ACTIONS(2863),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [sym__binary_minus] = ACTIONS(2863),
  },
  [1274] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym___END__] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [1275] = {
    [sym__terminator] = STATE(3280),
    [sym_heredoc_body] = STATE(3280),
    [sym_then] = STATE(3281),
    [sym__line_break] = ACTIONS(5572),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(5572),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1276] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [sym__line_break] = ACTIONS(2873),
    [anon_sym_then] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_EQ_GT] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_when] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym___END__] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_end] = ACTIONS(2873),
    [anon_sym_ensure] = ACTIONS(2873),
    [anon_sym_else] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_elsif] = ACTIONS(2873),
    [ts_builtin_sym_end] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [sym__binary_minus] = ACTIONS(2873),
  },
  [1277] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3284),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(5574),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(5576),
  },
  [1278] = {
    [aux_sym_string_array_repeat1] = STATE(3287),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(5578),
    [sym__string_end] = ACTIONS(5580),
  },
  [1279] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [sym__line_break] = ACTIONS(2885),
    [anon_sym_then] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_when] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_ensure] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [ts_builtin_sym_end] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [sym__binary_minus] = ACTIONS(2885),
  },
  [1280] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3289),
    [sym_interpolation] = STATE(3289),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(5582),
    [sym_heredoc_end] = ACTIONS(5584),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(5582),
  },
  [1281] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_heredoc_body] = STATE(3292),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym_float] = ACTIONS(497),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(505),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(523),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(5588),
    [sym_redo] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1282] = {
    [sym_heredoc_body] = STATE(3293),
    [aux_sym_call_repeat1] = STATE(3293),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [1283] = {
    [sym_heredoc_body] = STATE(3294),
    [aux_sym_call_repeat1] = STATE(3294),
    [aux_sym_argument_list_repeat1] = STATE(3295),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [1284] = {
    [sym_assignment] = STATE(3296),
    [sym_unary] = STATE(3296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3296),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3296),
    [sym_conditional] = STATE(3296),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3296),
    [sym_binary] = STATE(3296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1285] = {
    [sym_assignment] = STATE(3298),
    [sym_unary] = STATE(3298),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3298),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(3299),
    [sym_operator_assignment] = STATE(3298),
    [sym_conditional] = STATE(3298),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_subshell] = STATE(303),
    [sym__arg_or_splat_arg] = STATE(3299),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_true] = STATE(301),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3298),
    [sym_binary] = STATE(3298),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(505),
    [sym_character] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1286] = {
    [sym_assignment] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1287] = {
    [sym_assignment] = STATE(3301),
    [sym_unary] = STATE(3301),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3301),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3301),
    [sym_conditional] = STATE(3301),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3301),
    [sym_binary] = STATE(3301),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1288] = {
    [sym_assignment] = STATE(3302),
    [sym_unary] = STATE(3302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(3302),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(3302),
    [sym_conditional] = STATE(3302),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(3302),
    [sym_binary] = STATE(3302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1289] = {
    [sym_assignment] = STATE(3303),
    [sym_unary] = STATE(3303),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3303),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3303),
    [sym_conditional] = STATE(3303),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3303),
    [sym_binary] = STATE(3303),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1290] = {
    [sym_assignment] = STATE(3304),
    [sym_unary] = STATE(3304),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3304),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3304),
    [sym_conditional] = STATE(3304),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3304),
    [sym_binary] = STATE(3304),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1291] = {
    [sym_assignment] = STATE(3305),
    [sym_unary] = STATE(3305),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3305),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3305),
    [sym_conditional] = STATE(3305),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3305),
    [sym_binary] = STATE(3305),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1292] = {
    [sym_assignment] = STATE(3307),
    [sym_unary] = STATE(3307),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3307),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3307),
    [sym_conditional] = STATE(3307),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3307),
    [sym_binary] = STATE(3307),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1293] = {
    [sym_assignment] = STATE(3308),
    [sym_unary] = STATE(3308),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3308),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3308),
    [sym_conditional] = STATE(3308),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3308),
    [sym_binary] = STATE(3308),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1294] = {
    [sym_assignment] = STATE(3309),
    [sym_unary] = STATE(3309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3309),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(3309),
    [sym_conditional] = STATE(3309),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3309),
    [sym_binary] = STATE(3309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [1295] = {
    [sym_heredoc_body] = STATE(3314),
    [sym__argument_list_with_parens] = STATE(3313),
    [aux_sym_call_repeat1] = STATE(3314),
    [sym_argument_list_with_parens] = STATE(3312),
    [sym_operator] = STATE(3312),
    [anon_sym_LT] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5596),
    [anon_sym_PLUS_AT] = ACTIONS(5596),
    [anon_sym_LPAREN2] = ACTIONS(5598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_TILDE] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_DASH_AT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5596),
    [sym_constant] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5594),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_LT_EQ_GT] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_BANG] = ACTIONS(5594),
    [sym_identifier] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5596),
  },
  [1296] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(3316),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(5602),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [1297] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5604),
    [sym_identifier] = ACTIONS(5604),
  },
  [1298] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(3319),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(3320),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(5606),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1299] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym___END__] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [ts_builtin_sym_end] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1300] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(3323),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(3324),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(3324),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(3325),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(5610),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(5610),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5612),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1301] = {
    [anon_sym_COLON] = ACTIONS(5614),
    [sym_comment] = ACTIONS(49),
  },
  [1302] = {
    [sym_assignment] = STATE(3327),
    [sym_unary] = STATE(3327),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(3327),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(3327),
    [sym_conditional] = STATE(3327),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(3327),
    [sym_binary] = STATE(3327),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1303] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(3329),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(5616),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1304] = {
    [sym_assignment] = STATE(3330),
    [sym_unary] = STATE(3330),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(3330),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(3330),
    [sym_conditional] = STATE(3330),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(3330),
    [sym_binary] = STATE(3330),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1305] = {
    [sym_assignment] = STATE(3331),
    [sym_unary] = STATE(3331),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(3331),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(3331),
    [sym_conditional] = STATE(3331),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(3331),
    [sym_binary] = STATE(3331),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1306] = {
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [1307] = {
    [sym_do_block] = STATE(3332),
    [sym_block] = STATE(3332),
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5618),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [1308] = {
    [sym_heredoc_body] = STATE(3335),
    [aux_sym_call_repeat1] = STATE(3335),
    [aux_sym_argument_list_repeat1] = STATE(3336),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1309] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym___END__] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [ts_builtin_sym_end] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [1310] = {
    [aux_sym_chained_string_repeat1] = STATE(1783),
    [sym_string] = STATE(1783),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5624),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1311] = {
    [sym_heredoc_body] = STATE(3335),
    [aux_sym_call_repeat1] = STATE(3335),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1312] = {
    [aux_sym_chained_string_repeat1] = STATE(3337),
    [sym_string] = STATE(3337),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym___END__] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [1313] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [sym__line_break] = ACTIONS(5628),
    [anon_sym_then] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym___END__] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_ensure] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_elsif] = ACTIONS(5628),
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [sym__binary_minus] = ACTIONS(5628),
  },
  [1314] = {
    [sym_assignment] = STATE(3338),
    [sym_unary] = STATE(3338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3338),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(3338),
    [sym_conditional] = STATE(3338),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(3338),
    [sym_binary] = STATE(3338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [1315] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [1316] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1317] = {
    [sym_assignment] = STATE(3341),
    [sym_unary] = STATE(3341),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3341),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(3341),
    [sym_conditional] = STATE(3341),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(3341),
    [sym_binary] = STATE(3341),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [1318] = {
    [anon_sym_COLON] = ACTIONS(5634),
    [sym_comment] = ACTIONS(49),
  },
  [1319] = {
    [sym__argument] = STATE(3348),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3348),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(3348),
    [sym_hash_splat_argument] = STATE(3348),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(3351),
    [sym_block_argument] = STATE(3348),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [1320] = {
    [sym_assignment] = STATE(3360),
    [sym_unary] = STATE(3360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3360),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(3360),
    [sym_conditional] = STATE(3360),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(3360),
    [sym_binary] = STATE(3360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [1321] = {
    [sym_assignment] = STATE(3363),
    [sym_unary] = STATE(3363),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3363),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(3363),
    [sym_conditional] = STATE(3363),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(3363),
    [sym_binary] = STATE(3363),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [1322] = {
    [sym__argument] = STATE(3348),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3348),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(3348),
    [sym_hash_splat_argument] = STATE(3348),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(3351),
    [sym_block_argument] = STATE(3348),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [1323] = {
    [sym__argument] = STATE(3348),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3348),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(3348),
    [sym_hash_splat_argument] = STATE(3348),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(3351),
    [sym_block_argument] = STATE(3348),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [1324] = {
    [sym_assignment] = STATE(3364),
    [sym_unary] = STATE(3364),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3364),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(3364),
    [sym_conditional] = STATE(3364),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(3364),
    [sym_binary] = STATE(3364),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [1325] = {
    [sym__argument] = STATE(3348),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3348),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(3348),
    [sym_hash_splat_argument] = STATE(3348),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(3351),
    [sym_block_argument] = STATE(3348),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [1326] = {
    [sym_heredoc_body] = STATE(3366),
    [aux_sym_call_repeat1] = STATE(3366),
    [aux_sym_argument_list_repeat1] = STATE(3367),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [1327] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(5664),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(5664),
    [anon_sym_SLASH_EQ] = ACTIONS(5664),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5664),
    [anon_sym_PIPE_EQ] = ACTIONS(5664),
    [anon_sym_LT_LT_EQ] = ACTIONS(5664),
    [anon_sym_PLUS_EQ] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5664),
    [anon_sym_STAR_EQ] = ACTIONS(5664),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5664),
    [anon_sym_CARET_EQ] = ACTIONS(5664),
    [anon_sym_DASH_EQ] = ACTIONS(5664),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5664),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5666),
  },
  [1328] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5634),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [1329] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(1876),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(1877),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(1876),
    [sym_range] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(1876),
    [sym_assignment] = STATE(1877),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(1876),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(1876),
    [sym_operator_assignment] = STATE(1877),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(1879),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(1877),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3386),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1330] = {
    [anon_sym_EQ] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
  },
  [1331] = {
    [aux_sym_chained_string_repeat1] = STATE(3379),
    [sym_string] = STATE(3379),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5696),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1332] = {
    [sym_heredoc_body] = STATE(3366),
    [aux_sym_call_repeat1] = STATE(3366),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [1333] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [1334] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [1335] = {
    [sym_assignment] = STATE(3380),
    [sym_unary] = STATE(3380),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3380),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3380),
    [sym_conditional] = STATE(3380),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3380),
    [sym_binary] = STATE(3380),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1336] = {
    [sym_assignment] = STATE(3386),
    [sym_unary] = STATE(3386),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3386),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_splat_argument] = STATE(3388),
    [sym_operator_assignment] = STATE(3386),
    [sym_conditional] = STATE(3386),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(3388),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(3386),
    [sym_binary] = STATE(3386),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5702),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(583),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [1337] = {
    [sym_assignment] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1338] = {
    [sym_assignment] = STATE(3390),
    [sym_unary] = STATE(3390),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3390),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3390),
    [sym_conditional] = STATE(3390),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3390),
    [sym_binary] = STATE(3390),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1339] = {
    [sym_assignment] = STATE(3391),
    [sym_unary] = STATE(3391),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(3391),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(3391),
    [sym_conditional] = STATE(3391),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(3391),
    [sym_binary] = STATE(3391),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1340] = {
    [sym_assignment] = STATE(3392),
    [sym_unary] = STATE(3392),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3392),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3392),
    [sym_conditional] = STATE(3392),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3392),
    [sym_binary] = STATE(3392),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1341] = {
    [sym_assignment] = STATE(3393),
    [sym_unary] = STATE(3393),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3393),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3393),
    [sym_conditional] = STATE(3393),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3393),
    [sym_binary] = STATE(3393),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1342] = {
    [sym_assignment] = STATE(3394),
    [sym_unary] = STATE(3394),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3394),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3394),
    [sym_conditional] = STATE(3394),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3394),
    [sym_binary] = STATE(3394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1343] = {
    [sym_assignment] = STATE(3395),
    [sym_unary] = STATE(3395),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3395),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3395),
    [sym_conditional] = STATE(3395),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3395),
    [sym_binary] = STATE(3395),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1344] = {
    [sym_assignment] = STATE(3396),
    [sym_unary] = STATE(3396),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3396),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3396),
    [sym_conditional] = STATE(3396),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3396),
    [sym_binary] = STATE(3396),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1345] = {
    [sym_assignment] = STATE(3397),
    [sym_unary] = STATE(3397),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3397),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3397),
    [sym_conditional] = STATE(3397),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3397),
    [sym_binary] = STATE(3397),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1346] = {
    [sym_assignment] = STATE(3398),
    [sym_unary] = STATE(3398),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3398),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3398),
    [sym_conditional] = STATE(3398),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3398),
    [sym_binary] = STATE(3398),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1347] = {
    [sym_when] = STATE(3401),
    [sym_else] = STATE(3400),
    [aux_sym_case_repeat2] = STATE(3401),
    [aux_sym_case_repeat1] = STATE(3402),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5712),
    [sym_comment] = ACTIONS(49),
  },
  [1348] = {
    [aux_sym_chained_string_repeat1] = STATE(3403),
    [sym_string] = STATE(3403),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [1349] = {
    [sym_assignment] = STATE(3414),
    [sym_unary] = STATE(3414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(3414),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_pattern] = STATE(3416),
    [sym_splat_argument] = STATE(3417),
    [sym_operator_assignment] = STATE(3414),
    [sym_conditional] = STATE(3414),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_rational] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(3414),
    [sym_binary] = STATE(3414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5724),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [1350] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [sym__line_break] = ACTIONS(5746),
    [anon_sym_then] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_when] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym___END__] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_end] = ACTIONS(5746),
    [anon_sym_ensure] = ACTIONS(5746),
    [anon_sym_else] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_elsif] = ACTIONS(5746),
    [ts_builtin_sym_end] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [sym__binary_minus] = ACTIONS(5746),
  },
  [1351] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(3421),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(3421),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(1509),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(5748),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(5748),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(2665),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1352] = {
    [anon_sym_end] = ACTIONS(5710),
    [sym_comment] = ACTIONS(49),
  },
  [1353] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(3400),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [1354] = {
    [sym_when] = STATE(3401),
    [sym_else] = STATE(3400),
    [aux_sym_case_repeat2] = STATE(3401),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [1355] = {
    [aux_sym_undef_repeat1] = STATE(3424),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [1356] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(2497),
    [anon_sym_GT_GT_EQ] = ACTIONS(2497),
    [anon_sym_SLASH_EQ] = ACTIONS(2497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2497),
    [anon_sym_LT_LT_EQ] = ACTIONS(2497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2497),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2497),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(2497),
    [anon_sym_PLUS_EQ] = ACTIONS(2497),
    [anon_sym_STAR_EQ] = ACTIONS(2497),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2497),
    [anon_sym_DASH_EQ] = ACTIONS(2497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2497),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1357] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [1358] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [1359] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1360] = {
    [sym_assignment] = STATE(3425),
    [sym_unary] = STATE(3425),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3425),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(3425),
    [sym_conditional] = STATE(3425),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(3425),
    [sym_binary] = STATE(3425),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [1361] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [1362] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(5756),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1363] = {
    [sym_assignment] = STATE(3428),
    [sym_unary] = STATE(3428),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3428),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(3428),
    [sym_conditional] = STATE(3428),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(3428),
    [sym_binary] = STATE(3428),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [1364] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5758),
    [sym_identifier] = ACTIONS(5758),
  },
  [1365] = {
    [anon_sym_COLON] = ACTIONS(5760),
    [sym_comment] = ACTIONS(49),
  },
  [1366] = {
    [sym__argument] = STATE(3436),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(3436),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(3436),
    [sym_hash_splat_argument] = STATE(3436),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3439),
    [sym_block_argument] = STATE(3436),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [1367] = {
    [sym_assignment] = STATE(3448),
    [sym_unary] = STATE(3448),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3448),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(3448),
    [sym_conditional] = STATE(3448),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(3448),
    [sym_binary] = STATE(3448),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [1368] = {
    [sym_assignment] = STATE(3451),
    [sym_unary] = STATE(3451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3451),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(3451),
    [sym_conditional] = STATE(3451),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(3451),
    [sym_binary] = STATE(3451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [1369] = {
    [sym__argument] = STATE(3436),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(3436),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(3436),
    [sym_hash_splat_argument] = STATE(3436),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3439),
    [sym_block_argument] = STATE(3436),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [1370] = {
    [sym__argument] = STATE(3436),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(3436),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(3436),
    [sym_hash_splat_argument] = STATE(3436),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3439),
    [sym_block_argument] = STATE(3436),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [1371] = {
    [sym_assignment] = STATE(3452),
    [sym_unary] = STATE(3452),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3452),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(3452),
    [sym_conditional] = STATE(3452),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(3452),
    [sym_binary] = STATE(3452),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [1372] = {
    [sym__argument] = STATE(3436),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(3436),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(3436),
    [sym_hash_splat_argument] = STATE(3436),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3439),
    [sym_block_argument] = STATE(3436),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [1373] = {
    [sym_heredoc_body] = STATE(3454),
    [aux_sym_call_repeat1] = STATE(3454),
    [aux_sym_argument_list_repeat1] = STATE(3455),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1374] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(5790),
    [anon_sym_GT_GT_EQ] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5790),
    [anon_sym_LT_LT_EQ] = ACTIONS(5790),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5790),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_PLUS_EQ] = ACTIONS(5790),
    [anon_sym_STAR_EQ] = ACTIONS(5790),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5790),
    [anon_sym_DASH_EQ] = ACTIONS(5790),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5790),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1375] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [1376] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1377] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym__primary] = STATE(1409),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_method] = STATE(1409),
    [sym_conditional] = STATE(3475),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_subshell] = STATE(1409),
    [sym_unless] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1413),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_call] = STATE(1411),
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_rational] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_lambda] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3475),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_nil] = STATE(1413),
    [sym_symbol_array] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_scope_resolution] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1378] = {
    [anon_sym_EQ] = ACTIONS(5834),
    [sym_comment] = ACTIONS(3),
  },
  [1379] = {
    [aux_sym_chained_string_repeat1] = STATE(3478),
    [sym_string] = STATE(3478),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5836),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1380] = {
    [sym_heredoc_body] = STATE(3454),
    [aux_sym_call_repeat1] = STATE(3454),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1381] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5838),
    [sym_identifier] = ACTIONS(5838),
  },
  [1382] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_AMP_DOT] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_COLON_COLON2] = ACTIONS(5842),
  },
  [1383] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(3497),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym__primary] = STATE(1248),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(3495),
    [sym_method] = STATE(1248),
    [sym_conditional] = STATE(3497),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_subshell] = STATE(1248),
    [sym_unless] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_block_argument] = STATE(3495),
    [sym_range] = STATE(3497),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3496),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3495),
    [sym_assignment] = STATE(3497),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_pair] = STATE(3495),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3497),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(3495),
    [sym_operator_assignment] = STATE(3497),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3498),
    [sym_lambda] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(3499),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(3497),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_nil] = STATE(3496),
    [sym_symbol_array] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_scope_resolution] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_RPAREN] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [sym_constant] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [sym__identifier_hash_key] = ACTIONS(5852),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5848),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [sym__block_ampersand] = ACTIONS(5858),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(5860),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(5868),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [1384] = {
    [sym_assignment] = STATE(3500),
    [sym_unary] = STATE(3500),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3500),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3500),
    [sym_conditional] = STATE(3500),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3500),
    [sym_binary] = STATE(3500),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1385] = {
    [sym_assignment] = STATE(3501),
    [sym_unary] = STATE(3501),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3501),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3501),
    [sym_conditional] = STATE(3501),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3501),
    [sym_binary] = STATE(3501),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1386] = {
    [sym_assignment] = STATE(3502),
    [sym_unary] = STATE(3502),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3502),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3502),
    [sym_conditional] = STATE(3502),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3502),
    [sym_binary] = STATE(3502),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1387] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3504),
    [sym_interpolation] = STATE(3504),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(5872),
    [sym_heredoc_end] = ACTIONS(5874),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(5872),
  },
  [1388] = {
    [sym_assignment] = STATE(3505),
    [sym_unary] = STATE(3505),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3505),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3505),
    [sym_conditional] = STATE(3505),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3505),
    [sym_binary] = STATE(3505),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1389] = {
    [sym_assignment] = STATE(3506),
    [sym_unary] = STATE(3506),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3506),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3506),
    [sym_conditional] = STATE(3506),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3506),
    [sym_binary] = STATE(3506),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1390] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [1391] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(1382),
    [sym_module] = STATE(1382),
    [sym_chained_string] = STATE(1382),
    [sym_until] = STATE(1382),
    [sym_regex] = STATE(1382),
    [sym_for] = STATE(1382),
    [sym_symbol] = STATE(1382),
    [sym_if] = STATE(1382),
    [sym_begin] = STATE(1382),
    [sym__primary] = STATE(1382),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(1382),
    [sym_singleton_method] = STATE(1382),
    [sym__variable] = STATE(1383),
    [sym_rational] = STATE(1382),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(1382),
    [sym_subshell] = STATE(1382),
    [sym_yield] = STATE(1382),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(1382),
    [sym_lambda] = STATE(1382),
    [sym_parenthesized_statements] = STATE(1382),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(1382),
    [sym_break] = STATE(1382),
    [sym_next] = STATE(1382),
    [sym_string_array] = STATE(1382),
    [sym_while] = STATE(1382),
    [sym_case] = STATE(1382),
    [sym_symbol_array] = STATE(1382),
    [sym_array] = STATE(1382),
    [sym_hash] = STATE(1382),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(2427),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(2429),
    [sym_self] = ACTIONS(2429),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2433),
    [sym_super] = ACTIONS(2429),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2433),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(2433),
    [anon_sym_EQ] = ACTIONS(2895),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1392] = {
    [aux_sym__mlhs_repeat1] = STATE(3508),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
  },
  [1393] = {
    [sym_heredoc_body] = STATE(3513),
    [sym__argument_list_with_parens] = STATE(3512),
    [aux_sym_call_repeat1] = STATE(3513),
    [sym_argument_list_with_parens] = STATE(3511),
    [sym_operator] = STATE(3511),
    [anon_sym_LT] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5880),
    [anon_sym_PLUS_AT] = ACTIONS(5880),
    [anon_sym_LPAREN2] = ACTIONS(5882),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5880),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_EQ_TILDE] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5878),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5880),
    [anon_sym_DASH_AT] = ACTIONS(5880),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_BANG_TILDE] = ACTIONS(5880),
    [sym_constant] = ACTIONS(5884),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5880),
    [anon_sym_STAR_STAR] = ACTIONS(5880),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_BANG] = ACTIONS(5878),
    [sym_identifier] = ACTIONS(5884),
    [anon_sym_CARET] = ACTIONS(5880),
  },
  [1394] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5886),
    [sym_identifier] = ACTIONS(5886),
  },
  [1395] = {
    [sym_assignment] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_splat_argument] = STATE(3522),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_return] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_subshell] = STATE(338),
    [sym__arg_or_splat_arg] = STATE(3522),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5892),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(613),
    [sym_character] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [1396] = {
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_in] = ACTIONS(5900),
    [anon_sym_RPAREN] = ACTIONS(5900),
    [anon_sym_EQ] = ACTIONS(5900),
    [sym_comment] = ACTIONS(3),
  },
  [1397] = {
    [sym_assignment] = STATE(3523),
    [sym_unary] = STATE(3523),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3523),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(3523),
    [sym_conditional] = STATE(3523),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(3523),
    [sym_binary] = STATE(3523),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [1398] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [1399] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1400] = {
    [sym_assignment] = STATE(3526),
    [sym_unary] = STATE(3526),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3526),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(3526),
    [sym_conditional] = STATE(3526),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(3526),
    [sym_binary] = STATE(3526),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [1401] = {
    [anon_sym_COLON] = ACTIONS(5906),
    [sym_comment] = ACTIONS(49),
  },
  [1402] = {
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1403] = {
    [sym_assignment] = STATE(3536),
    [sym_unary] = STATE(3536),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(3536),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(3536),
    [sym_conditional] = STATE(3536),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(3536),
    [sym_binary] = STATE(3536),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [1404] = {
    [sym_assignment] = STATE(3541),
    [sym_unary] = STATE(3541),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(3541),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(3541),
    [sym_conditional] = STATE(3541),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(3541),
    [sym_binary] = STATE(3541),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [1405] = {
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1406] = {
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1407] = {
    [sym_assignment] = STATE(3542),
    [sym_unary] = STATE(3542),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(3542),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(3542),
    [sym_conditional] = STATE(3542),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(3542),
    [sym_binary] = STATE(3542),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [1408] = {
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1409] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(5820),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1410] = {
    [anon_sym_EQ] = ACTIONS(5934),
    [sym_comment] = ACTIONS(3),
  },
  [1411] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym__primary] = STATE(1409),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(3474),
    [sym_method] = STATE(1409),
    [sym_conditional] = STATE(3475),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_subshell] = STATE(1409),
    [sym_unless] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_block_argument] = STATE(3474),
    [sym_range] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1413),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_call] = STATE(1411),
    [sym__argument] = STATE(3474),
    [sym_assignment] = STATE(3475),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_pair] = STATE(3474),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(3474),
    [sym_operator_assignment] = STATE(3475),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_rational] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_lambda] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(3477),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3475),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_nil] = STATE(1413),
    [sym_symbol_array] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_scope_resolution] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5830),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [1412] = {
    [sym_heredoc_body] = STATE(3545),
    [aux_sym_call_repeat1] = STATE(3545),
    [aux_sym_argument_list_repeat1] = STATE(3546),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1413] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(5938),
    [anon_sym_GT_GT_EQ] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(5938),
    [anon_sym_LT_LT_EQ] = ACTIONS(5938),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(5938),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_PLUS_EQ] = ACTIONS(5938),
    [anon_sym_STAR_EQ] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5938),
    [anon_sym_DASH_EQ] = ACTIONS(5938),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5938),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1414] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [1415] = {
    [aux_sym_chained_string_repeat1] = STATE(3557),
    [sym_string] = STATE(3557),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(5970),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1416] = {
    [sym_heredoc_body] = STATE(3545),
    [aux_sym_call_repeat1] = STATE(3545),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1417] = {
    [sym_assignment] = STATE(3558),
    [sym_unary] = STATE(3558),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3558),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3558),
    [sym_conditional] = STATE(3558),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3558),
    [sym_binary] = STATE(3558),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1418] = {
    [sym_assignment] = STATE(3559),
    [sym_unary] = STATE(3559),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3559),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3559),
    [sym_conditional] = STATE(3559),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3559),
    [sym_binary] = STATE(3559),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1419] = {
    [sym_assignment] = STATE(3560),
    [sym_unary] = STATE(3560),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3560),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3560),
    [sym_conditional] = STATE(3560),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3560),
    [sym_binary] = STATE(3560),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1420] = {
    [sym_assignment] = STATE(3561),
    [sym_unary] = STATE(3561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3561),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3561),
    [sym_conditional] = STATE(3561),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3561),
    [sym_binary] = STATE(3561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1421] = {
    [sym_assignment] = STATE(3562),
    [sym_unary] = STATE(3562),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3562),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3562),
    [sym_conditional] = STATE(3562),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3562),
    [sym_binary] = STATE(3562),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1422] = {
    [sym_assignment] = STATE(3563),
    [sym_unary] = STATE(3563),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(3563),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(3563),
    [sym_conditional] = STATE(3563),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(3563),
    [sym_binary] = STATE(3563),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1423] = {
    [sym_assignment] = STATE(3564),
    [sym_unary] = STATE(3564),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3564),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3564),
    [sym_conditional] = STATE(3564),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3564),
    [sym_binary] = STATE(3564),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1424] = {
    [sym_assignment] = STATE(3565),
    [sym_unary] = STATE(3565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3565),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3565),
    [sym_conditional] = STATE(3565),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3565),
    [sym_binary] = STATE(3565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1425] = {
    [sym_assignment] = STATE(3566),
    [sym_unary] = STATE(3566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3566),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3566),
    [sym_conditional] = STATE(3566),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3566),
    [sym_binary] = STATE(3566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1426] = {
    [sym_assignment] = STATE(3567),
    [sym_unary] = STATE(3567),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3567),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3567),
    [sym_conditional] = STATE(3567),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3567),
    [sym_binary] = STATE(3567),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1427] = {
    [sym_assignment] = STATE(3568),
    [sym_unary] = STATE(3568),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3568),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(3568),
    [sym_conditional] = STATE(3568),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(3568),
    [sym_binary] = STATE(3568),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1428] = {
    [aux_sym_chained_string_repeat1] = STATE(3569),
    [sym_string] = STATE(3569),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [1429] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [sym__line_break] = ACTIONS(5974),
    [anon_sym_then] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_when] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_end] = ACTIONS(5974),
    [anon_sym_ensure] = ACTIONS(5974),
    [anon_sym_else] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_elsif] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
    [sym__binary_minus] = ACTIONS(5974),
  },
  [1430] = {
    [sym_heredoc_body] = STATE(1390),
    [sym__terminator] = STATE(1390),
    [sym__line_break] = ACTIONS(2437),
    [anon_sym_unless] = ACTIONS(2439),
    [anon_sym_until] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2443),
    [sym__heredoc_body_start] = ACTIONS(2445),
    [anon_sym_rescue] = ACTIONS(2447),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2449),
    [sym_comment] = ACTIONS(49),
  },
  [1431] = {
    [sym__statement] = STATE(3570),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3570),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(3570),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(3570),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(1431),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(3570),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(3570),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(3570),
    [sym_if_modifier] = STATE(3570),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(3570),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(3570),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(1431),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [1432] = {
    [sym_heredoc_body] = STATE(3571),
    [sym__terminator] = STATE(3571),
    [sym__line_break] = ACTIONS(5979),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [1433] = {
    [sym_assignment] = STATE(3572),
    [sym_unary] = STATE(3572),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3572),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(3572),
    [sym_conditional] = STATE(3572),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(3572),
    [sym_binary] = STATE(3572),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1434] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(3573),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(5981),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1435] = {
    [sym_heredoc_body] = STATE(3574),
    [sym__terminator] = STATE(3574),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(5983),
    [anon_sym_SEMI] = ACTIONS(5983),
    [sym_comment] = ACTIONS(49),
  },
  [1436] = {
    [sym__line_break] = ACTIONS(2055),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2055),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1437] = {
    [sym_heredoc_body] = STATE(3579),
    [sym__argument_list_with_parens] = STATE(3578),
    [aux_sym_call_repeat1] = STATE(3579),
    [sym_argument_list_with_parens] = STATE(3577),
    [sym_operator] = STATE(3577),
    [anon_sym_LT] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5987),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5987),
    [anon_sym_PLUS_AT] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(5989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5987),
    [anon_sym_GT_GT] = ACTIONS(5987),
    [anon_sym_EQ_TILDE] = ACTIONS(5987),
    [anon_sym_LT_LT] = ACTIONS(5987),
    [anon_sym_TILDE] = ACTIONS(5987),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5987),
    [anon_sym_DASH_AT] = ACTIONS(5987),
    [anon_sym_EQ_EQ] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_BANG_TILDE] = ACTIONS(5987),
    [sym_constant] = ACTIONS(5991),
    [anon_sym_DASH] = ACTIONS(5985),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5987),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5987),
    [anon_sym_STAR_STAR] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_DOT_DOT] = ACTIONS(5987),
    [anon_sym_LT_EQ_GT] = ACTIONS(5987),
    [anon_sym_LT_EQ] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5985),
    [sym_identifier] = ACTIONS(5991),
    [anon_sym_CARET] = ACTIONS(5987),
  },
  [1438] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(5993),
    [sym_identifier] = ACTIONS(5993),
  },
  [1439] = {
    [sym_assignment] = STATE(3581),
    [sym_unary] = STATE(3581),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3581),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(3581),
    [sym_conditional] = STATE(3581),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(3581),
    [sym_binary] = STATE(3581),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1440] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1441] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(2882),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(699),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(700),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(2883),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1442] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1443] = {
    [sym_assignment] = STATE(3585),
    [sym_unary] = STATE(3585),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3585),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(3585),
    [sym_conditional] = STATE(3585),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(3585),
    [sym_binary] = STATE(3585),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1444] = {
    [anon_sym_COLON] = ACTIONS(5999),
    [sym_comment] = ACTIONS(49),
  },
  [1445] = {
    [sym__argument] = STATE(3592),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3592),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(3592),
    [sym_hash_splat_argument] = STATE(3592),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(3595),
    [sym_block_argument] = STATE(3592),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1446] = {
    [sym_assignment] = STATE(3604),
    [sym_unary] = STATE(3604),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3604),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(3604),
    [sym_conditional] = STATE(3604),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(3604),
    [sym_binary] = STATE(3604),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [1447] = {
    [sym_assignment] = STATE(3608),
    [sym_unary] = STATE(3608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3608),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(3608),
    [sym_conditional] = STATE(3608),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(3608),
    [sym_binary] = STATE(3608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [1448] = {
    [sym__argument] = STATE(3592),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3592),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(3592),
    [sym_hash_splat_argument] = STATE(3592),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(3595),
    [sym_block_argument] = STATE(3592),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1449] = {
    [sym__argument] = STATE(3592),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3592),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(3592),
    [sym_hash_splat_argument] = STATE(3592),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(3595),
    [sym_block_argument] = STATE(3592),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1450] = {
    [sym_assignment] = STATE(3609),
    [sym_unary] = STATE(3609),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3609),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(3609),
    [sym_conditional] = STATE(3609),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(3609),
    [sym_binary] = STATE(3609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [1451] = {
    [sym__argument] = STATE(3592),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3592),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(3592),
    [sym_hash_splat_argument] = STATE(3592),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(3595),
    [sym_block_argument] = STATE(3592),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1452] = {
    [anon_sym_EQ] = ACTIONS(6033),
    [sym_comment] = ACTIONS(3),
  },
  [1453] = {
    [sym_heredoc_body] = STATE(3612),
    [aux_sym_call_repeat1] = STATE(3612),
    [aux_sym_argument_list_repeat1] = STATE(3613),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [1454] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(6037),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(6037),
    [anon_sym_SLASH_EQ] = ACTIONS(6037),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6037),
    [anon_sym_PIPE_EQ] = ACTIONS(6037),
    [anon_sym_LT_LT_EQ] = ACTIONS(6037),
    [anon_sym_PLUS_EQ] = ACTIONS(6037),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6037),
    [anon_sym_STAR_EQ] = ACTIONS(6037),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6037),
    [anon_sym_CARET_EQ] = ACTIONS(6037),
    [anon_sym_DASH_EQ] = ACTIONS(6037),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6037),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6039),
  },
  [1455] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(6053),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(5999),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [anon_sym_and] = ACTIONS(6053),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6065),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [1456] = {
    [aux_sym_chained_string_repeat1] = STATE(3625),
    [sym_string] = STATE(3625),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(6069),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1457] = {
    [sym_heredoc_body] = STATE(3612),
    [aux_sym_call_repeat1] = STATE(3612),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [1458] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [sym__line_break] = ACTIONS(6073),
    [anon_sym_then] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_when] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym___END__] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_end] = ACTIONS(6073),
    [anon_sym_ensure] = ACTIONS(6073),
    [anon_sym_else] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_elsif] = ACTIONS(6073),
    [ts_builtin_sym_end] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
    [sym__binary_minus] = ACTIONS(6073),
  },
  [1459] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [sym__line_break] = ACTIONS(6077),
    [anon_sym_then] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_when] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym___END__] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_end] = ACTIONS(6077),
    [anon_sym_ensure] = ACTIONS(6077),
    [anon_sym_else] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_elsif] = ACTIONS(6077),
    [ts_builtin_sym_end] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
    [sym__binary_minus] = ACTIONS(6077),
  },
  [1460] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(3626),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6079),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1461] = {
    [sym__line_break] = ACTIONS(2055),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1462] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6081),
    [sym_identifier] = ACTIONS(6081),
  },
  [1463] = {
    [aux_sym_undef_repeat1] = STATE(3628),
    [sym__line_break] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_ensure] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
  },
  [1464] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [1465] = {
    [sym_assignment] = STATE(3629),
    [sym_unary] = STATE(3629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3629),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(3629),
    [sym_conditional] = STATE(3629),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(3629),
    [sym_binary] = STATE(3629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [1466] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [1467] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3631),
    [sym_interpolation] = STATE(3631),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(6083),
    [sym_heredoc_end] = ACTIONS(6085),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(6083),
  },
  [1468] = {
    [sym_assignment] = STATE(3632),
    [sym_unary] = STATE(3632),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3632),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(3632),
    [sym_conditional] = STATE(3632),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(3632),
    [sym_binary] = STATE(3632),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [1469] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6087),
    [sym_identifier] = ACTIONS(6087),
  },
  [1470] = {
    [sym__argument] = STATE(3642),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3642),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(3642),
    [sym_hash_splat_argument] = STATE(3642),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(3647),
    [sym_block_argument] = STATE(3642),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [1471] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(3728),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3728),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3728),
    [anon_sym_ensure] = ACTIONS(3728),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1472] = {
    [sym_assignment] = STATE(3648),
    [sym_unary] = STATE(3648),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3648),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(3648),
    [sym_conditional] = STATE(3648),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(3648),
    [sym_binary] = STATE(3648),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [1473] = {
    [sym__argument] = STATE(3642),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3642),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(3642),
    [sym_hash_splat_argument] = STATE(3642),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(3647),
    [sym_block_argument] = STATE(3642),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [1474] = {
    [sym__lhs] = STATE(3653),
    [sym_singleton_class] = STATE(3654),
    [sym_module] = STATE(3654),
    [sym_chained_string] = STATE(3654),
    [sym_until] = STATE(3654),
    [sym_regex] = STATE(3654),
    [sym_for] = STATE(3654),
    [sym_symbol] = STATE(3654),
    [sym_if] = STATE(3654),
    [sym_begin] = STATE(3654),
    [sym__primary] = STATE(3654),
    [sym_method_call] = STATE(3653),
    [sym_method] = STATE(3654),
    [sym_singleton_method] = STATE(3654),
    [sym__variable] = STATE(3655),
    [sym_rational] = STATE(3654),
    [sym_true] = STATE(3653),
    [sym_return] = STATE(3654),
    [sym_subshell] = STATE(3654),
    [sym_yield] = STATE(3654),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(3654),
    [sym_lambda] = STATE(3654),
    [sym_parenthesized_statements] = STATE(3654),
    [sym_element_reference] = STATE(3653),
    [sym_class] = STATE(3654),
    [sym_break] = STATE(3654),
    [sym_next] = STATE(3654),
    [sym_string_array] = STATE(3654),
    [sym_while] = STATE(3654),
    [sym_case] = STATE(3654),
    [sym_symbol_array] = STATE(3654),
    [sym_array] = STATE(3654),
    [sym_hash] = STATE(3654),
    [sym_false] = STATE(3653),
    [sym_nil] = STATE(3653),
    [sym_scope_resolution] = STATE(3655),
    [sym_call] = STATE(3655),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(6109),
    [anon_sym_TRUE] = ACTIONS(6111),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(6113),
    [sym_self] = ACTIONS(6113),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(6115),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(6115),
    [sym_global_variable] = ACTIONS(6117),
    [sym_super] = ACTIONS(6113),
    [anon_sym_false] = ACTIONS(6119),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(6121),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(6109),
    [sym_constant] = ACTIONS(6113),
    [sym_instance_variable] = ACTIONS(6117),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(6111),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(6121),
    [anon_sym_FALSE] = ACTIONS(6119),
    [anon_sym_COLON_COLON] = ACTIONS(6123),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(6109),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(6117),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1475] = {
    [sym__argument] = STATE(3642),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3642),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(3642),
    [sym_hash_splat_argument] = STATE(3642),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(3647),
    [sym_block_argument] = STATE(3642),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [1476] = {
    [sym__argument] = STATE(3642),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3642),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(3642),
    [sym_hash_splat_argument] = STATE(3642),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(3647),
    [sym_block_argument] = STATE(3642),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [1477] = {
    [sym_rescue] = STATE(3656),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(6125),
    [anon_sym_ensure] = ACTIONS(6125),
    [anon_sym_else] = ACTIONS(6125),
    [sym_comment] = ACTIONS(49),
  },
  [1478] = {
    [sym__terminator] = STATE(3657),
    [sym_heredoc_body] = STATE(3657),
    [sym_then] = STATE(3658),
    [sym__heredoc_body_start] = ACTIONS(2605),
    [anon_sym_then] = ACTIONS(6127),
    [sym__line_break] = ACTIONS(6129),
    [anon_sym_SEMI] = ACTIONS(6129),
    [sym_comment] = ACTIONS(49),
  },
  [1479] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6131),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(6131),
    [anon_sym_SLASH_EQ] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6131),
    [anon_sym_PIPE_EQ] = ACTIONS(6131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6131),
    [anon_sym_PLUS_EQ] = ACTIONS(6131),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6131),
    [anon_sym_STAR_EQ] = ACTIONS(6131),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6131),
    [anon_sym_CARET_EQ] = ACTIONS(6131),
    [anon_sym_DASH_EQ] = ACTIONS(6131),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6131),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6133),
  },
  [1480] = {
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(6149),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(6149),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_PIPE] = ACTIONS(6161),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [1481] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(6165),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6167),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(6169),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [1482] = {
    [aux_sym_exceptions_repeat1] = STATE(3674),
    [anon_sym_EQ_GT] = ACTIONS(6171),
    [anon_sym_then] = ACTIONS(6171),
    [sym__line_break] = ACTIONS(6171),
    [sym__heredoc_body_start] = ACTIONS(6171),
    [anon_sym_COMMA] = ACTIONS(6173),
    [anon_sym_SEMI] = ACTIONS(6171),
    [sym_comment] = ACTIONS(49),
  },
  [1483] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym__primary] = STATE(3687),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_method] = STATE(3687),
    [sym_conditional] = STATE(3692),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_subshell] = STATE(3687),
    [sym_unless] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3691),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_call] = STATE(3689),
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_rational] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_lambda] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3692),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_nil] = STATE(3691),
    [sym_symbol_array] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_scope_resolution] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1484] = {
    [aux_sym_chained_string_repeat1] = STATE(3695),
    [sym_string] = STATE(3695),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1485] = {
    [anon_sym_EQ] = ACTIONS(6209),
    [sym_comment] = ACTIONS(3),
  },
  [1486] = {
    [sym__terminator] = STATE(3657),
    [sym_heredoc_body] = STATE(3657),
    [sym_then] = STATE(3658),
    [sym_exception_variable] = STATE(3696),
    [anon_sym_EQ_GT] = ACTIONS(2621),
    [anon_sym_then] = ACTIONS(6127),
    [sym__heredoc_body_start] = ACTIONS(2605),
    [sym__line_break] = ACTIONS(6129),
    [anon_sym_SEMI] = ACTIONS(6129),
    [sym_comment] = ACTIONS(49),
  },
  [1487] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(3656),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(6211),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(6213),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6211),
    [anon_sym_ensure] = ACTIONS(6211),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1488] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_rescue] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [anon_sym_ensure] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [1489] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(6217),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [1490] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [1491] = {
    [sym__method_name] = STATE(3699),
    [sym_setter] = STATE(3699),
    [sym_symbol] = STATE(3699),
    [sym_operator] = STATE(3699),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(6219),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(6219),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(6219),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(6219),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [1492] = {
    [sym_assignment] = STATE(3700),
    [sym_unary] = STATE(3700),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(3700),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(3700),
    [sym_conditional] = STATE(3700),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(3700),
    [sym_binary] = STATE(3700),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [1493] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [1494] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3702),
    [sym_interpolation] = STATE(3702),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(6221),
    [sym_heredoc_end] = ACTIONS(6223),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(6221),
  },
  [1495] = {
    [sym_assignment] = STATE(3703),
    [sym_unary] = STATE(3703),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(3703),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(3703),
    [sym_conditional] = STATE(3703),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(3703),
    [sym_binary] = STATE(3703),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [1496] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6225),
    [sym_identifier] = ACTIONS(6225),
  },
  [1497] = {
    [sym__argument] = STATE(3718),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(3718),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(3718),
    [sym_hash_splat_argument] = STATE(3718),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(3725),
    [sym_block_argument] = STATE(3718),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [1498] = {
    [sym__argument] = STATE(3718),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(3718),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(3718),
    [sym_hash_splat_argument] = STATE(3718),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(3725),
    [sym_block_argument] = STATE(3718),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [1499] = {
    [sym__argument] = STATE(3718),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(3718),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(3718),
    [sym_hash_splat_argument] = STATE(3718),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(3725),
    [sym_block_argument] = STATE(3718),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [1500] = {
    [sym__argument] = STATE(3718),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(3718),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(3718),
    [sym_hash_splat_argument] = STATE(3718),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(3725),
    [sym_block_argument] = STATE(3718),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [1501] = {
    [sym_heredoc_body] = STATE(3731),
    [sym__terminator] = STATE(3731),
    [sym__line_break] = ACTIONS(6263),
    [anon_sym_unless] = ACTIONS(6265),
    [anon_sym_until] = ACTIONS(6267),
    [anon_sym_while] = ACTIONS(6269),
    [sym__heredoc_body_start] = ACTIONS(2649),
    [anon_sym_rescue] = ACTIONS(6271),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_ensure] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(6273),
    [sym_comment] = ACTIONS(49),
  },
  [1502] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(6275),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6277),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6279),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1503] = {
    [anon_sym_EQ] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
  },
  [1504] = {
    [sym__statement] = STATE(1501),
    [sym_unary] = STATE(1507),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1501),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_unless_modifier] = STATE(1501),
    [sym_symbol] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym__primary] = STATE(1502),
    [sym_method] = STATE(1502),
    [sym_conditional] = STATE(1507),
    [sym_left_assignment_list] = STATE(1503),
    [sym_return] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_while_modifier] = STATE(1501),
    [sym_subshell] = STATE(1502),
    [sym_unless] = STATE(1502),
    [sym_empty_statement] = STATE(1510),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_begin_block] = STATE(1501),
    [sym_range] = STATE(1507),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1506),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_call] = STATE(1505),
    [sym_end_block] = STATE(1501),
    [sym_assignment] = STATE(1507),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_alias] = STATE(1501),
    [sym_if_modifier] = STATE(1501),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(1507),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(1507),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_rational] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_until_modifier] = STATE(1501),
    [sym_lambda] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym__statements] = STATE(3736),
    [sym_binary] = STATE(1507),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_nil] = STATE(1506),
    [sym_rescue_modifier] = STATE(1501),
    [sym_symbol_array] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_hash] = STATE(1502),
    [aux_sym__statements_repeat1] = STATE(1510),
    [sym_scope_resolution] = STATE(1505),
    [sym_float] = ACTIONS(2635),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(2637),
    [sym_self] = ACTIONS(2639),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(2639),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(2647),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_yield] = ACTIONS(2655),
    [sym_class_variable] = ACTIONS(2647),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6283),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [sym_retry] = ACTIONS(2635),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6285),
    [anon_sym_ensure] = ACTIONS(6285),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [1505] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym__primary] = STATE(3749),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_method] = STATE(3749),
    [sym_conditional] = STATE(3754),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_subshell] = STATE(3749),
    [sym_unless] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3753),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_call] = STATE(3751),
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_rational] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_lambda] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(3754),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_nil] = STATE(3753),
    [sym_symbol_array] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_scope_resolution] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [1506] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6321),
    [anon_sym_GT_GT_EQ] = ACTIONS(6321),
    [anon_sym_SLASH_EQ] = ACTIONS(6321),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6321),
    [anon_sym_LT_LT_EQ] = ACTIONS(6321),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6321),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6321),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6323),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(6321),
    [anon_sym_PLUS_EQ] = ACTIONS(6321),
    [anon_sym_STAR_EQ] = ACTIONS(6321),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6321),
    [anon_sym_DASH_EQ] = ACTIONS(6321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6321),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1507] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_ensure] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [1508] = {
    [aux_sym_chained_string_repeat1] = STATE(3768),
    [sym_string] = STATE(3768),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1509] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(6353),
    [anon_sym_ensure] = ACTIONS(6353),
  },
  [1510] = {
    [sym__statement] = STATE(3769),
    [sym_unary] = STATE(1507),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3769),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_unless_modifier] = STATE(3769),
    [sym_symbol] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym__primary] = STATE(1502),
    [sym_method] = STATE(1502),
    [sym_conditional] = STATE(1507),
    [sym_left_assignment_list] = STATE(1503),
    [sym_return] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_while_modifier] = STATE(3769),
    [sym_subshell] = STATE(1502),
    [sym_unless] = STATE(1502),
    [sym_empty_statement] = STATE(3770),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_begin_block] = STATE(3769),
    [sym_range] = STATE(1507),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1506),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_call] = STATE(1505),
    [sym_end_block] = STATE(3769),
    [sym_assignment] = STATE(1507),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_alias] = STATE(3769),
    [sym_if_modifier] = STATE(3769),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(1507),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(1507),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_rational] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_until_modifier] = STATE(3769),
    [sym_lambda] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_binary] = STATE(1507),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_nil] = STATE(1506),
    [sym_rescue_modifier] = STATE(3769),
    [sym_symbol_array] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_hash] = STATE(1502),
    [aux_sym__statements_repeat1] = STATE(3770),
    [sym_scope_resolution] = STATE(1505),
    [sym_float] = ACTIONS(2635),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(2637),
    [sym_self] = ACTIONS(2639),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(2639),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(2647),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_yield] = ACTIONS(2655),
    [sym_class_variable] = ACTIONS(2647),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6283),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [sym_retry] = ACTIONS(2635),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [1511] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_ensure] = ACTIONS(2053),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1512] = {
    [sym_assignment] = STATE(3771),
    [sym_unary] = STATE(3771),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3771),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(3771),
    [sym_conditional] = STATE(3771),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(3771),
    [sym_binary] = STATE(3771),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [1513] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [1514] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(6359),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1515] = {
    [sym_assignment] = STATE(3774),
    [sym_unary] = STATE(3774),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3774),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(3774),
    [sym_conditional] = STATE(3774),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(3774),
    [sym_binary] = STATE(3774),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [1516] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6361),
    [sym_identifier] = ACTIONS(6361),
  },
  [1517] = {
    [anon_sym_COLON] = ACTIONS(6363),
    [sym_comment] = ACTIONS(49),
  },
  [1518] = {
    [sym__argument] = STATE(3782),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(3782),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(3782),
    [sym_hash_splat_argument] = STATE(3782),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(3785),
    [sym_block_argument] = STATE(3782),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [1519] = {
    [sym_assignment] = STATE(3794),
    [sym_unary] = STATE(3794),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3794),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(3794),
    [sym_conditional] = STATE(3794),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(3794),
    [sym_binary] = STATE(3794),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [1520] = {
    [sym_assignment] = STATE(3797),
    [sym_unary] = STATE(3797),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3797),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(3797),
    [sym_conditional] = STATE(3797),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(3797),
    [sym_binary] = STATE(3797),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [1521] = {
    [sym__argument] = STATE(3782),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(3782),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(3782),
    [sym_hash_splat_argument] = STATE(3782),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(3785),
    [sym_block_argument] = STATE(3782),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [1522] = {
    [sym__argument] = STATE(3782),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(3782),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(3782),
    [sym_hash_splat_argument] = STATE(3782),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(3785),
    [sym_block_argument] = STATE(3782),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [1523] = {
    [sym_assignment] = STATE(3798),
    [sym_unary] = STATE(3798),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3798),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(3798),
    [sym_conditional] = STATE(3798),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(3798),
    [sym_binary] = STATE(3798),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [1524] = {
    [sym__argument] = STATE(3782),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(3782),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(3782),
    [sym_hash_splat_argument] = STATE(3782),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(3785),
    [sym_block_argument] = STATE(3782),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [1525] = {
    [sym_heredoc_body] = STATE(3800),
    [aux_sym_call_repeat1] = STATE(3800),
    [aux_sym_argument_list_repeat1] = STATE(3801),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(6391),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1526] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6393),
    [anon_sym_GT_GT_EQ] = ACTIONS(6393),
    [anon_sym_SLASH_EQ] = ACTIONS(6393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6393),
    [anon_sym_LT_LT_EQ] = ACTIONS(6393),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6393),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6393),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6395),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(6393),
    [anon_sym_PLUS_EQ] = ACTIONS(6393),
    [anon_sym_STAR_EQ] = ACTIONS(6393),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6393),
    [anon_sym_DASH_EQ] = ACTIONS(6393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6393),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1527] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_EQ_GT] = ACTIONS(6363),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [1528] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(6423),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1529] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym__primary] = STATE(1561),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_method] = STATE(1561),
    [sym_conditional] = STATE(3821),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_subshell] = STATE(1561),
    [sym_unless] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1565),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_call] = STATE(1563),
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_rational] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_lambda] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3821),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_nil] = STATE(1565),
    [sym_symbol_array] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_scope_resolution] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(791),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1530] = {
    [anon_sym_EQ] = ACTIONS(6437),
    [sym_comment] = ACTIONS(3),
  },
  [1531] = {
    [aux_sym_chained_string_repeat1] = STATE(3824),
    [sym_string] = STATE(3824),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(6439),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1532] = {
    [sym_heredoc_body] = STATE(3800),
    [aux_sym_call_repeat1] = STATE(3800),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1533] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [1534] = {
    [anon_sym_end] = ACTIONS(6441),
    [sym_comment] = ACTIONS(49),
  },
  [1535] = {
    [sym_assignment] = STATE(3825),
    [sym_unary] = STATE(3825),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3825),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3825),
    [sym_conditional] = STATE(3825),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3825),
    [sym_binary] = STATE(3825),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1536] = {
    [sym_assignment] = STATE(3826),
    [sym_unary] = STATE(3826),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3826),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3826),
    [sym_conditional] = STATE(3826),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3826),
    [sym_binary] = STATE(3826),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1537] = {
    [sym_assignment] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1538] = {
    [sym_assignment] = STATE(3828),
    [sym_unary] = STATE(3828),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3828),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3828),
    [sym_conditional] = STATE(3828),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3828),
    [sym_binary] = STATE(3828),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1539] = {
    [sym_assignment] = STATE(3829),
    [sym_unary] = STATE(3829),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3829),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3829),
    [sym_conditional] = STATE(3829),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3829),
    [sym_binary] = STATE(3829),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1540] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_rescue] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [anon_sym_ensure] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [1541] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [sym__line_break] = ACTIONS(6445),
    [anon_sym_then] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_when] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym___END__] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_end] = ACTIONS(6445),
    [anon_sym_ensure] = ACTIONS(6445),
    [anon_sym_else] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_elsif] = ACTIONS(6445),
    [ts_builtin_sym_end] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
    [sym__binary_minus] = ACTIONS(6445),
  },
  [1542] = {
    [sym_heredoc_body] = STATE(3834),
    [sym__argument_list_with_parens] = STATE(3833),
    [aux_sym_call_repeat1] = STATE(3834),
    [sym_argument_list_with_parens] = STATE(3832),
    [sym_operator] = STATE(3832),
    [anon_sym_LT] = ACTIONS(6447),
    [anon_sym_SLASH] = ACTIONS(6449),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6449),
    [anon_sym_PLUS_AT] = ACTIONS(6449),
    [anon_sym_LPAREN2] = ACTIONS(6451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6449),
    [anon_sym_GT_GT] = ACTIONS(6449),
    [anon_sym_EQ_TILDE] = ACTIONS(6449),
    [anon_sym_LT_LT] = ACTIONS(6449),
    [anon_sym_TILDE] = ACTIONS(6449),
    [anon_sym_PLUS] = ACTIONS(6447),
    [anon_sym_AMP] = ACTIONS(6449),
    [anon_sym_GT] = ACTIONS(6447),
    [anon_sym_PERCENT] = ACTIONS(6449),
    [anon_sym_DASH_AT] = ACTIONS(6449),
    [anon_sym_EQ_EQ] = ACTIONS(6447),
    [anon_sym_STAR] = ACTIONS(6447),
    [anon_sym_BANG_TILDE] = ACTIONS(6449),
    [sym_constant] = ACTIONS(6453),
    [anon_sym_DASH] = ACTIONS(6447),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(6449),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6447),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(6449),
    [anon_sym_STAR_STAR] = ACTIONS(6449),
    [anon_sym_PIPE] = ACTIONS(6449),
    [anon_sym_DOT_DOT] = ACTIONS(6449),
    [anon_sym_LT_EQ_GT] = ACTIONS(6449),
    [anon_sym_LT_EQ] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(6447),
    [sym_identifier] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(6449),
  },
  [1543] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6455),
    [sym_identifier] = ACTIONS(6455),
  },
  [1544] = {
    [sym_assignment] = STATE(3841),
    [sym_unary] = STATE(3841),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3841),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_splat_argument] = STATE(3843),
    [sym_operator_assignment] = STATE(3841),
    [sym_conditional] = STATE(3841),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_return] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_subshell] = STATE(376),
    [sym__arg_or_splat_arg] = STATE(3843),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(3841),
    [sym_binary] = STATE(3841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(6461),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(681),
    [sym_character] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [1545] = {
    [anon_sym_end] = ACTIONS(6469),
    [sym_comment] = ACTIONS(49),
  },
  [1546] = {
    [sym_ensure] = STATE(3845),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(6469),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [1547] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_rescue] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [anon_sym_ensure] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [1548] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [sym__line_break] = ACTIONS(6473),
    [anon_sym_then] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_when] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym___END__] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_end] = ACTIONS(6473),
    [anon_sym_ensure] = ACTIONS(6473),
    [anon_sym_else] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_elsif] = ACTIONS(6473),
    [ts_builtin_sym_end] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
    [sym__binary_minus] = ACTIONS(6473),
  },
  [1549] = {
    [sym_assignment] = STATE(3846),
    [sym_unary] = STATE(3846),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3846),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(3846),
    [sym_conditional] = STATE(3846),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(3846),
    [sym_binary] = STATE(3846),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1550] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1551] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(6477),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1552] = {
    [sym_assignment] = STATE(3849),
    [sym_unary] = STATE(3849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3849),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(3849),
    [sym_conditional] = STATE(3849),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(3849),
    [sym_binary] = STATE(3849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1553] = {
    [anon_sym_COLON] = ACTIONS(6479),
    [sym_comment] = ACTIONS(49),
  },
  [1554] = {
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(501),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(501),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(501),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(501),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1555] = {
    [sym_assignment] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [1556] = {
    [sym_assignment] = STATE(3864),
    [sym_unary] = STATE(3864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(3864),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(3864),
    [sym_conditional] = STATE(3864),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(3864),
    [sym_binary] = STATE(3864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [1557] = {
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(647),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(647),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(647),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(647),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1558] = {
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(737),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(737),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(737),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(737),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1559] = {
    [sym_assignment] = STATE(3865),
    [sym_unary] = STATE(3865),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(3865),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(3865),
    [sym_conditional] = STATE(3865),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(3865),
    [sym_binary] = STATE(3865),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [1560] = {
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(753),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(753),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(753),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(753),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1561] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(6423),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(6427),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1562] = {
    [anon_sym_EQ] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
  },
  [1563] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym__primary] = STATE(1561),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(3820),
    [sym_method] = STATE(1561),
    [sym_conditional] = STATE(3821),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_subshell] = STATE(1561),
    [sym_unless] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_block_argument] = STATE(3820),
    [sym_range] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1565),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_call] = STATE(1563),
    [sym__argument] = STATE(3820),
    [sym_assignment] = STATE(3821),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_pair] = STATE(3820),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(3820),
    [sym_operator_assignment] = STATE(3821),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_rational] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_lambda] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(3823),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3821),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_nil] = STATE(1565),
    [sym_symbol_array] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_scope_resolution] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2749),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [sym__block_ampersand] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2773),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_ensure] = ACTIONS(791),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2747),
  },
  [1564] = {
    [sym_heredoc_body] = STATE(3868),
    [aux_sym_call_repeat1] = STATE(3868),
    [aux_sym_argument_list_repeat1] = STATE(3869),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(6509),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1565] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6511),
    [anon_sym_GT_GT_EQ] = ACTIONS(6511),
    [anon_sym_SLASH_EQ] = ACTIONS(6511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6511),
    [anon_sym_LT_LT_EQ] = ACTIONS(6511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6511),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(6511),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6513),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(6511),
    [anon_sym_PLUS_EQ] = ACTIONS(6511),
    [anon_sym_STAR_EQ] = ACTIONS(6511),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6511),
    [anon_sym_DASH_EQ] = ACTIONS(6511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6511),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1566] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(6479),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [1567] = {
    [aux_sym_chained_string_repeat1] = STATE(3880),
    [sym_string] = STATE(3880),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(6543),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1568] = {
    [sym_heredoc_body] = STATE(3868),
    [aux_sym_call_repeat1] = STATE(3868),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1569] = {
    [sym_assignment] = STATE(3881),
    [sym_unary] = STATE(3881),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3881),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3881),
    [sym_conditional] = STATE(3881),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3881),
    [sym_binary] = STATE(3881),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1570] = {
    [sym_assignment] = STATE(3882),
    [sym_unary] = STATE(3882),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3882),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3882),
    [sym_conditional] = STATE(3882),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3882),
    [sym_binary] = STATE(3882),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1571] = {
    [sym_assignment] = STATE(3883),
    [sym_unary] = STATE(3883),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3883),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3883),
    [sym_conditional] = STATE(3883),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3883),
    [sym_binary] = STATE(3883),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1572] = {
    [sym_assignment] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1573] = {
    [sym_assignment] = STATE(3885),
    [sym_unary] = STATE(3885),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3885),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3885),
    [sym_conditional] = STATE(3885),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3885),
    [sym_binary] = STATE(3885),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1574] = {
    [sym_assignment] = STATE(3886),
    [sym_unary] = STATE(3886),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(3886),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(3886),
    [sym_conditional] = STATE(3886),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(3886),
    [sym_binary] = STATE(3886),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1575] = {
    [sym_assignment] = STATE(3887),
    [sym_unary] = STATE(3887),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3887),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3887),
    [sym_conditional] = STATE(3887),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3887),
    [sym_binary] = STATE(3887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1576] = {
    [sym_assignment] = STATE(3888),
    [sym_unary] = STATE(3888),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3888),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3888),
    [sym_conditional] = STATE(3888),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3888),
    [sym_binary] = STATE(3888),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1577] = {
    [sym_assignment] = STATE(3889),
    [sym_unary] = STATE(3889),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3889),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3889),
    [sym_conditional] = STATE(3889),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3889),
    [sym_binary] = STATE(3889),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1578] = {
    [sym_assignment] = STATE(3890),
    [sym_unary] = STATE(3890),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3890),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3890),
    [sym_conditional] = STATE(3890),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3890),
    [sym_binary] = STATE(3890),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1579] = {
    [sym_assignment] = STATE(3891),
    [sym_unary] = STATE(3891),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3891),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(3891),
    [sym_conditional] = STATE(3891),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(3891),
    [sym_binary] = STATE(3891),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1580] = {
    [aux_sym_chained_string_repeat1] = STATE(3892),
    [sym_string] = STATE(3892),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [1581] = {
    [sym_ensure] = STATE(3845),
    [sym_else] = STATE(3893),
    [anon_sym_end] = ACTIONS(6469),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1582] = {
    [sym_heredoc_body] = STATE(1540),
    [sym__terminator] = STATE(1540),
    [sym__line_break] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(2713),
    [anon_sym_until] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2717),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_rescue] = ACTIONS(2719),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_ensure] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(2721),
    [sym_comment] = ACTIONS(49),
  },
  [1583] = {
    [sym__statement] = STATE(3894),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3894),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(3894),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(3894),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(1583),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(3894),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(3894),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(3894),
    [sym_if_modifier] = STATE(3894),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(3894),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(3894),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(1583),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_rescue] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3252),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(6545),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [anon_sym_ensure] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [1584] = {
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1585] = {
    [sym_heredoc_body] = STATE(3899),
    [sym__argument_list_with_parens] = STATE(3898),
    [aux_sym_call_repeat1] = STATE(3899),
    [sym_argument_list_with_parens] = STATE(3897),
    [sym_operator] = STATE(3897),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6550),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6550),
    [anon_sym_PLUS_AT] = ACTIONS(6550),
    [anon_sym_LPAREN2] = ACTIONS(6552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6550),
    [anon_sym_GT_GT] = ACTIONS(6550),
    [anon_sym_EQ_TILDE] = ACTIONS(6550),
    [anon_sym_LT_LT] = ACTIONS(6550),
    [anon_sym_TILDE] = ACTIONS(6550),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6550),
    [anon_sym_DASH_AT] = ACTIONS(6550),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_BANG_TILDE] = ACTIONS(6550),
    [sym_constant] = ACTIONS(6554),
    [anon_sym_DASH] = ACTIONS(6548),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(6550),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6548),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(6550),
    [anon_sym_STAR_STAR] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_DOT_DOT] = ACTIONS(6550),
    [anon_sym_LT_EQ_GT] = ACTIONS(6550),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_BANG] = ACTIONS(6548),
    [sym_identifier] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6550),
  },
  [1586] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6556),
    [sym_identifier] = ACTIONS(6556),
  },
  [1587] = {
    [sym_assignment] = STATE(3901),
    [sym_unary] = STATE(3901),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3901),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(3901),
    [sym_conditional] = STATE(3901),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(3901),
    [sym_binary] = STATE(3901),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [1588] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [1589] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1590] = {
    [sym_assignment] = STATE(3904),
    [sym_unary] = STATE(3904),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3904),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(3904),
    [sym_conditional] = STATE(3904),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(3904),
    [sym_binary] = STATE(3904),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [1591] = {
    [anon_sym_COLON] = ACTIONS(6560),
    [sym_comment] = ACTIONS(49),
  },
  [1592] = {
    [sym__argument] = STATE(3911),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3911),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(3911),
    [sym_hash_splat_argument] = STATE(3911),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(3914),
    [sym_block_argument] = STATE(3911),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(6566),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1593] = {
    [sym_assignment] = STATE(3923),
    [sym_unary] = STATE(3923),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3923),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(3923),
    [sym_conditional] = STATE(3923),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(3923),
    [sym_binary] = STATE(3923),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [1594] = {
    [sym_assignment] = STATE(3926),
    [sym_unary] = STATE(3926),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3926),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(3926),
    [sym_conditional] = STATE(3926),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(3926),
    [sym_binary] = STATE(3926),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [1595] = {
    [sym__argument] = STATE(3911),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3911),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(3911),
    [sym_hash_splat_argument] = STATE(3911),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(3914),
    [sym_block_argument] = STATE(3911),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(6566),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1596] = {
    [sym__argument] = STATE(3911),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3911),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(3911),
    [sym_hash_splat_argument] = STATE(3911),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(3914),
    [sym_block_argument] = STATE(3911),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(6566),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1597] = {
    [sym_assignment] = STATE(3927),
    [sym_unary] = STATE(3927),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(3927),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(3927),
    [sym_conditional] = STATE(3927),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(3927),
    [sym_binary] = STATE(3927),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [1598] = {
    [sym__argument] = STATE(3911),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(3911),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(3911),
    [sym_hash_splat_argument] = STATE(3911),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(3914),
    [sym_block_argument] = STATE(3911),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(6566),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1599] = {
    [anon_sym_EQ] = ACTIONS(6590),
    [sym_comment] = ACTIONS(3),
  },
  [1600] = {
    [sym_heredoc_body] = STATE(3930),
    [aux_sym_call_repeat1] = STATE(3930),
    [aux_sym_argument_list_repeat1] = STATE(3931),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
  },
  [1601] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(6594),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(6594),
    [anon_sym_SLASH_EQ] = ACTIONS(6594),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6594),
    [anon_sym_PIPE_EQ] = ACTIONS(6594),
    [anon_sym_LT_LT_EQ] = ACTIONS(6594),
    [anon_sym_PLUS_EQ] = ACTIONS(6594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6594),
    [anon_sym_STAR_EQ] = ACTIONS(6594),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6594),
    [anon_sym_CARET_EQ] = ACTIONS(6594),
    [anon_sym_DASH_EQ] = ACTIONS(6594),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6594),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1602] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6610),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(6560),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [anon_sym_and] = ACTIONS(6610),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_PIPE] = ACTIONS(6622),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [1603] = {
    [aux_sym_chained_string_repeat1] = STATE(3943),
    [sym_string] = STATE(3943),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(6626),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1604] = {
    [sym_heredoc_body] = STATE(3930),
    [aux_sym_call_repeat1] = STATE(3930),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
  },
  [1605] = {
    [ts_builtin_sym_end] = ACTIONS(6628),
    [sym_comment] = ACTIONS(49),
  },
  [1606] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [sym__line_break] = ACTIONS(6632),
    [anon_sym_then] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_when] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym___END__] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6632),
    [anon_sym_ensure] = ACTIONS(6632),
    [anon_sym_else] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_elsif] = ACTIONS(6632),
    [ts_builtin_sym_end] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [sym__binary_minus] = ACTIONS(6632),
  },
  [1607] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3728),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3728),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(3728),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [1608] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3963),
    [sym_interpolation] = STATE(3963),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(6666),
    [sym_heredoc_end] = ACTIONS(6668),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(6666),
  },
  [1609] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(3967),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(3967),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6672),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [1610] = {
    [sym_elsif] = STATE(3967),
    [sym_else] = STATE(3967),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(6676),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [1611] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [sym__line_break] = ACTIONS(6682),
    [anon_sym_then] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_when] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym___END__] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_end] = ACTIONS(6682),
    [anon_sym_ensure] = ACTIONS(6682),
    [anon_sym_else] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_elsif] = ACTIONS(6682),
    [ts_builtin_sym_end] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
    [sym__binary_minus] = ACTIONS(6682),
  },
  [1612] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(6684),
  },
  [1613] = {
    [aux_sym_string_array_repeat1] = STATE(3971),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6686),
    [sym__string_end] = ACTIONS(6688),
  },
  [1614] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(6690),
  },
  [1615] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [sym__line_break] = ACTIONS(6694),
    [anon_sym_then] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_when] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym___END__] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_end] = ACTIONS(6694),
    [anon_sym_ensure] = ACTIONS(6694),
    [anon_sym_else] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_elsif] = ACTIONS(6694),
    [ts_builtin_sym_end] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
    [sym__binary_minus] = ACTIONS(6694),
  },
  [1616] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6696),
    [sym__string_end] = ACTIONS(6690),
  },
  [1617] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(6698),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6698),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [1618] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(6700),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6700),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [1619] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(6702),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6702),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [1620] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [anon_sym___END__] = ACTIONS(6215),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [1621] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(6704),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [1622] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(6706),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6706),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [1623] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(6708),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6708),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(877),
  },
  [1624] = {
    [anon_sym_COMMA] = ACTIONS(6710),
    [anon_sym_in] = ACTIONS(6710),
    [anon_sym_RPAREN] = ACTIONS(6710),
    [anon_sym_EQ] = ACTIONS(6710),
    [sym_comment] = ACTIONS(3),
  },
  [1625] = {
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(6710),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(6710),
    [anon_sym_RPAREN] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(6710),
    [sym_comment] = ACTIONS(3),
  },
  [1626] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(390),
    [sym_module] = STATE(390),
    [sym_chained_string] = STATE(390),
    [sym_until] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_for] = STATE(390),
    [sym_symbol] = STATE(390),
    [sym_if] = STATE(390),
    [sym_begin] = STATE(390),
    [sym__primary] = STATE(390),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(390),
    [sym_singleton_method] = STATE(390),
    [sym__variable] = STATE(391),
    [sym_rational] = STATE(390),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(390),
    [sym_subshell] = STATE(390),
    [sym_yield] = STATE(390),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(390),
    [sym_lambda] = STATE(390),
    [sym_parenthesized_statements] = STATE(390),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(390),
    [sym_break] = STATE(390),
    [sym_next] = STATE(390),
    [sym_string_array] = STATE(390),
    [sym_while] = STATE(390),
    [sym_case] = STATE(390),
    [sym_symbol_array] = STATE(390),
    [sym_array] = STATE(390),
    [sym_hash] = STATE(390),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(391),
    [sym_call] = STATE(391),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(721),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(723),
    [sym_self] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(727),
    [sym_global_variable] = ACTIONS(729),
    [sym_super] = ACTIONS(723),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(721),
    [sym_constant] = ACTIONS(723),
    [sym_instance_variable] = ACTIONS(729),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(731),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(6712),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1627] = {
    [aux_sym__mlhs_repeat1] = STATE(1627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(6710),
    [anon_sym_COMMA] = ACTIONS(6714),
  },
  [1628] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym___END__] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [ts_builtin_sym_end] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [1629] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(3979),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(6717),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1630] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym___END__] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [ts_builtin_sym_end] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [1631] = {
    [aux_sym_heredoc_body_repeat1] = STATE(3981),
    [sym_interpolation] = STATE(3981),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(6723),
    [sym_heredoc_end] = ACTIONS(6725),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(6723),
  },
  [1632] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym___END__] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [ts_builtin_sym_end] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [1633] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(1632),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(3982),
    [sym_operator] = STATE(3982),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_AT] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_DASH_AT] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_BANG_TILDE] = ACTIONS(2901),
    [sym_constant] = ACTIONS(6731),
    [anon_sym_DASH] = ACTIONS(2899),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_LT_EQ_GT] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(6731),
    [anon_sym_CARET] = ACTIONS(2901),
  },
  [1634] = {
    [anon_sym_SLASH] = ACTIONS(6733),
    [sym__line_break] = ACTIONS(6735),
    [anon_sym_until] = ACTIONS(6735),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_RBRACE] = ACTIONS(6735),
    [anon_sym_unless] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_rescue] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_LBRACE] = ACTIONS(6735),
    [anon_sym_while] = ACTIONS(6735),
    [sym__heredoc_body_start] = ACTIONS(6735),
    [anon_sym_else] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_then] = ACTIONS(6735),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_when] = ACTIONS(6735),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym___END__] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_end] = ACTIONS(6735),
    [anon_sym_ensure] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_elsif] = ACTIONS(6735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [ts_builtin_sym_end] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [anon_sym_if] = ACTIONS(6735),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [1635] = {
    [anon_sym_RBRACK] = ACTIONS(6737),
    [sym_comment] = ACTIONS(49),
  },
  [1636] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [ts_builtin_sym_end] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [1637] = {
    [sym_assignment] = STATE(3985),
    [sym_unary] = STATE(3985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3985),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(3985),
    [sym_conditional] = STATE(3985),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(3985),
    [sym_binary] = STATE(3985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1638] = {
    [sym_assignment] = STATE(3986),
    [sym_unary] = STATE(3986),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3986),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(3986),
    [sym_conditional] = STATE(3986),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(3986),
    [sym_binary] = STATE(3986),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1639] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1640] = {
    [sym_assignment] = STATE(3987),
    [sym_unary] = STATE(3987),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(3987),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(3987),
    [sym_conditional] = STATE(3987),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(3987),
    [sym_binary] = STATE(3987),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [1641] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [1642] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6747),
    [anon_sym_GT_GT_EQ] = ACTIONS(6747),
    [anon_sym_SLASH_EQ] = ACTIONS(6747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6747),
    [anon_sym_LT_LT_EQ] = ACTIONS(6747),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6747),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6747),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6749),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(6747),
    [anon_sym_PLUS_EQ] = ACTIONS(6747),
    [anon_sym_STAR_EQ] = ACTIONS(6747),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6747),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(6747),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6747),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1643] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym___END__] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [1644] = {
    [anon_sym_EQ] = ACTIONS(6777),
    [sym_comment] = ACTIONS(3),
  },
  [1645] = {
    [aux_sym_exceptions_repeat1] = STATE(4000),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6779),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [1646] = {
    [sym__terminator] = STATE(4001),
    [sym_heredoc_body] = STATE(4001),
    [sym__do] = STATE(4001),
    [sym__line_break] = ACTIONS(6781),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(6781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1647] = {
    [sym__terminator] = STATE(4002),
    [sym_heredoc_body] = STATE(4002),
    [sym_then] = STATE(4003),
    [sym__line_break] = ACTIONS(6783),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1648] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(1668),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(1675),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(6785),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [1649] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [1650] = {
    [aux_sym_chained_string_repeat1] = STATE(1783),
    [sym_string] = STATE(1783),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1651] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [1652] = {
    [anon_sym_SLASH] = ACTIONS(1225),
    [sym__line_break] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_then] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_when] = ACTIONS(1227),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym___END__] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_end] = ACTIONS(1227),
    [anon_sym_ensure] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_elsif] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1225),
  },
  [1653] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4007),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6787),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(6789),
  },
  [1654] = {
    [aux_sym_symbol_array_repeat1] = STATE(4010),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6791),
    [sym__string_end] = ACTIONS(6793),
  },
  [1655] = {
    [anon_sym_SLASH] = ACTIONS(1337),
    [sym__line_break] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_AMP_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT_EQ] = ACTIONS(1339),
    [anon_sym_SLASH_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_PERCENT_EQ] = ACTIONS(1339),
    [anon_sym_LT_LT_EQ] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_CARET_EQ] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_then] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_PLUS_EQ] = ACTIONS(1339),
    [anon_sym_STAR_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym___END__] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_ensure] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_elsif] = ACTIONS(1339),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1339),
    [ts_builtin_sym_end] = ACTIONS(1339),
    [anon_sym_DASH_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1337),
  },
  [1656] = {
    [anon_sym_RBRACK] = ACTIONS(6795),
    [sym_comment] = ACTIONS(49),
  },
  [1657] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [1658] = {
    [sym_assignment] = STATE(4012),
    [sym_unary] = STATE(4012),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4012),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(4012),
    [sym_conditional] = STATE(4012),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(4012),
    [sym_binary] = STATE(4012),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1659] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1660] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1645),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1661] = {
    [sym_assignment] = STATE(4014),
    [sym_unary] = STATE(4014),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4014),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(4014),
    [sym_conditional] = STATE(4014),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(4014),
    [sym_binary] = STATE(4014),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1662] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(6797),
    [sym_identifier] = ACTIONS(6797),
  },
  [1663] = {
    [sym__argument] = STATE(4021),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4021),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4021),
    [sym_hash_splat_argument] = STATE(4021),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4024),
    [sym_block_argument] = STATE(4021),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1664] = {
    [sym__argument] = STATE(4021),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4021),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4021),
    [sym_hash_splat_argument] = STATE(4021),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4024),
    [sym_block_argument] = STATE(4021),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1665] = {
    [sym__argument] = STATE(4021),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4021),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4021),
    [sym_hash_splat_argument] = STATE(4021),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4024),
    [sym_block_argument] = STATE(4021),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1666] = {
    [sym__argument] = STATE(4021),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4021),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4021),
    [sym_hash_splat_argument] = STATE(4021),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4024),
    [sym_block_argument] = STATE(4021),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1667] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4026),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(6807),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1668] = {
    [sym_heredoc_body] = STATE(4028),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(6809),
    [sym_comment] = ACTIONS(49),
  },
  [1669] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(6811),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6813),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6815),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1670] = {
    [anon_sym_EQ] = ACTIONS(6817),
    [sym_comment] = ACTIONS(3),
  },
  [1671] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym__primary] = STATE(1994),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_method] = STATE(1994),
    [sym_conditional] = STATE(4038),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_subshell] = STATE(1994),
    [sym_unless] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1998),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_call] = STATE(1996),
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_rational] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_lambda] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(4038),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_nil] = STATE(1998),
    [sym_symbol_array] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_scope_resolution] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1672] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6827),
    [anon_sym_GT_GT_EQ] = ACTIONS(6827),
    [anon_sym_SLASH_EQ] = ACTIONS(6827),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6827),
    [anon_sym_LT_LT_EQ] = ACTIONS(6827),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6827),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6827),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6829),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(6827),
    [anon_sym_PLUS_EQ] = ACTIONS(6827),
    [anon_sym_STAR_EQ] = ACTIONS(6827),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6827),
    [anon_sym_DASH_EQ] = ACTIONS(6827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6827),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1673] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_unless] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(6843),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(1661),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(6843),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_PIPE] = ACTIONS(6855),
    [sym__binary_minus] = ACTIONS(6845),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_CARET] = ACTIONS(6857),
  },
  [1674] = {
    [aux_sym_chained_string_repeat1] = STATE(4052),
    [sym_string] = STATE(4052),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(1845),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1675] = {
    [anon_sym_RBRACE] = ACTIONS(6809),
    [sym_comment] = ACTIONS(49),
  },
  [1676] = {
    [anon_sym_RBRACE] = ACTIONS(6807),
    [sym_comment] = ACTIONS(49),
  },
  [1677] = {
    [sym_assignment] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [1678] = {
    [sym__terminator] = STATE(4054),
    [sym_heredoc_body] = STATE(4054),
    [sym__do] = STATE(4054),
    [sym__line_break] = ACTIONS(6859),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(6859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6859),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1679] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [1680] = {
    [anon_sym_SLASH] = ACTIONS(1851),
    [sym__line_break] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_AMP_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT_EQ] = ACTIONS(1853),
    [anon_sym_SLASH_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1851),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_PERCENT_EQ] = ACTIONS(1853),
    [anon_sym_LT_LT_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(1851),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_else] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_CARET_EQ] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_then] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_when] = ACTIONS(1853),
    [anon_sym_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_PLUS_EQ] = ACTIONS(1853),
    [anon_sym_STAR_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym___END__] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_end] = ACTIONS(1853),
    [anon_sym_ensure] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_elsif] = ACTIONS(1853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1853),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_DASH_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1851),
  },
  [1681] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(6861),
  },
  [1682] = {
    [sym_in] = STATE(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [1683] = {
    [anon_sym_SLASH] = ACTIONS(5078),
    [sym__line_break] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_else] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_then] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_when] = ACTIONS(5080),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym___END__] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_end] = ACTIONS(5080),
    [anon_sym_ensure] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_elsif] = ACTIONS(5080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [ts_builtin_sym_end] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [1684] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(4058),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(4058),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4059),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(6863),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6863),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6865),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1685] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(4060),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4059),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6865),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [1686] = {
    [anon_sym_end] = ACTIONS(6867),
    [sym_comment] = ACTIONS(49),
  },
  [1687] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(3319),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(3320),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1688] = {
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym__line_break] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_AMP_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT_EQ] = ACTIONS(2045),
    [anon_sym_SLASH_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2043),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2043),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_PERCENT_EQ] = ACTIONS(2045),
    [anon_sym_LT_LT_EQ] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_CARET_EQ] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_EQ] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_then] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_EQ_GT] = ACTIONS(2045),
    [anon_sym_when] = ACTIONS(2045),
    [anon_sym_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_PLUS_EQ] = ACTIONS(2045),
    [anon_sym_STAR_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym___END__] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_end] = ACTIONS(2045),
    [anon_sym_ensure] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_elsif] = ACTIONS(2045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2045),
    [ts_builtin_sym_end] = ACTIONS(2045),
    [anon_sym_DASH_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2043),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2043),
  },
  [1689] = {
    [sym_do_block] = STATE(4062),
    [sym_block] = STATE(4062),
    [anon_sym_do] = ACTIONS(5618),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(2979),
  },
  [1690] = {
    [sym_assignment] = STATE(4063),
    [sym_unary] = STATE(4063),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(4063),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(4063),
    [sym_conditional] = STATE(4063),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(4063),
    [sym_binary] = STATE(4063),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [1691] = {
    [sym_assignment] = STATE(4064),
    [sym_unary] = STATE(4064),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(4064),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(4064),
    [sym_conditional] = STATE(4064),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(4064),
    [sym_binary] = STATE(4064),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [1692] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(4065),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(4065),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(4065),
    [sym__line_break] = ACTIONS(6871),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(6871),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [1693] = {
    [anon_sym_SLASH] = ACTIONS(2101),
    [sym__line_break] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_AMP_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT_EQ] = ACTIONS(2103),
    [anon_sym_SLASH_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_PERCENT_EQ] = ACTIONS(2103),
    [anon_sym_LT_LT_EQ] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_CARET_EQ] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_EQ] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_then] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_EQ_GT] = ACTIONS(2103),
    [anon_sym_when] = ACTIONS(2103),
    [anon_sym_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_PLUS_EQ] = ACTIONS(2103),
    [anon_sym_STAR_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym___END__] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_end] = ACTIONS(2103),
    [anon_sym_ensure] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_elsif] = ACTIONS(2103),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2103),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [anon_sym_DASH_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2101),
  },
  [1694] = {
    [anon_sym_DOT] = ACTIONS(6873),
    [anon_sym_COLON_COLON] = ACTIONS(6873),
    [sym_comment] = ACTIONS(49),
  },
  [1695] = {
    [anon_sym_SLASH] = ACTIONS(2299),
    [sym__line_break] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_AMP_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT_EQ] = ACTIONS(2301),
    [anon_sym_SLASH_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2299),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_PERCENT_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_CARET_EQ] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_then] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_when] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_PLUS_EQ] = ACTIONS(2301),
    [anon_sym_STAR_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym___END__] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_end] = ACTIONS(2301),
    [anon_sym_ensure] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_elsif] = ACTIONS(2301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2301),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_DASH_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2299),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2299),
  },
  [1696] = {
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_hash_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym___END__] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [ts_builtin_sym_end] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [1697] = {
    [sym_assignment] = STATE(4068),
    [sym_unary] = STATE(4068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4068),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(4068),
    [sym_conditional] = STATE(4068),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(4068),
    [sym_binary] = STATE(4068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [1698] = {
    [sym_assignment] = STATE(4069),
    [sym_unary] = STATE(4069),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4069),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(4069),
    [sym_conditional] = STATE(4069),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(4070),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(4069),
    [sym_binary] = STATE(4069),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(4070),
    [sym__line_break] = ACTIONS(6875),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6875),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1699] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4073),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6877),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(6879),
  },
  [1700] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(4075),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(6881),
  },
  [1701] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(4077),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(6883),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [1702] = {
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_hash_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym___END__] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [1703] = {
    [sym__statement] = STATE(4079),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(4079),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(4079),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(4079),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(4079),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(4079),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(4079),
    [sym_if_modifier] = STATE(4079),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(4079),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(4079),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [1704] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(4082),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(6885),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(6887),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1705] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(4084),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(6889),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1706] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(4087),
    [sym__body_statement] = STATE(4088),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(4087),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(6891),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6891),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6893),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1707] = {
    [sym_assignment] = STATE(4091),
    [sym_unary] = STATE(4091),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(4091),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(4091),
    [sym_conditional] = STATE(4091),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(4091),
    [sym_binary] = STATE(4091),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [1708] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [1709] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(4094),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(6895),
  },
  [1710] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4097),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6897),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(6899),
  },
  [1711] = {
    [anon_sym_SLASH] = ACTIONS(181),
    [sym__line_break] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_AMP_EQ] = ACTIONS(183),
    [anon_sym_GT_GT_EQ] = ACTIONS(183),
    [anon_sym_SLASH_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(181),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_PERCENT_EQ] = ACTIONS(183),
    [anon_sym_LT_LT_EQ] = ACTIONS(183),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [anon_sym_else] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_CARET_EQ] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_then] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_when] = ACTIONS(183),
    [anon_sym_PIPE_EQ] = ACTIONS(183),
    [anon_sym_PLUS_EQ] = ACTIONS(183),
    [anon_sym_STAR_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym___END__] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_end] = ACTIONS(183),
    [anon_sym_ensure] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_elsif] = ACTIONS(183),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(183),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_DASH_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(181),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(181),
  },
  [1712] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(4099),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(6901),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [1713] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(4101),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(4102),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(6903),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [1714] = {
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_hash_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [ts_builtin_sym_end] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [1715] = {
    [sym_assignment] = STATE(4104),
    [sym_unary] = STATE(4104),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4104),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(4104),
    [sym_conditional] = STATE(4104),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(4104),
    [sym_binary] = STATE(4104),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [1716] = {
    [sym_assignment] = STATE(4105),
    [sym_unary] = STATE(4105),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(4105),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(4105),
    [sym_conditional] = STATE(4105),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(4105),
    [sym_binary] = STATE(4105),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [1717] = {
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(6905),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1718] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(4107),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [1719] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(4109),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(6907),
  },
  [1720] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(4111),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(6909),
  },
  [1721] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(4112),
    [sym_lambda_parameters] = STATE(4113),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(4112),
    [anon_sym_do] = ACTIONS(825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [1722] = {
    [sym__method_name] = STATE(4115),
    [sym_setter] = STATE(4115),
    [sym_symbol] = STATE(4115),
    [sym_operator] = STATE(4115),
    [sym__method_rest] = STATE(4116),
    [sym__variable] = STATE(4117),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(6911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(6913),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(6911),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [1723] = {
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_hash_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym___END__] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [ts_builtin_sym_end] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [1724] = {
    [sym__statement] = STATE(4119),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(4119),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(4119),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(4119),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(4119),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(4119),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(4119),
    [sym_if_modifier] = STATE(4119),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(4119),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(4119),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [1725] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(6915),
    [anon_sym_GT_GT_EQ] = ACTIONS(6915),
    [anon_sym_SLASH_EQ] = ACTIONS(6915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(6915),
    [anon_sym_LT_LT_EQ] = ACTIONS(6915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6915),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(6915),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(6917),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(6915),
    [anon_sym_PLUS_EQ] = ACTIONS(6915),
    [anon_sym_STAR_EQ] = ACTIONS(6915),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6915),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(6915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6915),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1726] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [1727] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(779),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(781),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(785),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym___END__] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [ts_builtin_sym_end] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1728] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_for] = STATE(452),
    [sym_if] = STATE(452),
    [sym__primary] = STATE(452),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(456),
    [sym_method] = STATE(452),
    [sym_conditional] = STATE(458),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_true] = STATE(457),
    [sym_subshell] = STATE(452),
    [sym_unless] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_block_argument] = STATE(456),
    [sym_range] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(457),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_array] = STATE(452),
    [sym_call] = STATE(455),
    [sym__argument] = STATE(456),
    [sym_assignment] = STATE(458),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_pair] = STATE(456),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(456),
    [sym_operator_assignment] = STATE(458),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_rational] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_lambda] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym__argument_list_with_parens] = STATE(460),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(458),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_nil] = STATE(457),
    [sym_symbol_array] = STATE(452),
    [sym_case] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_scope_resolution] = STATE(455),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(795),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(801),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(835),
    [anon_sym_not] = ACTIONS(837),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym___END__] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [ts_builtin_sym_end] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(867),
  },
  [1729] = {
    [anon_sym_EQ] = ACTIONS(6949),
    [sym_comment] = ACTIONS(3),
  },
  [1730] = {
    [aux_sym_chained_string_repeat1] = STATE(4132),
    [sym_string] = STATE(4132),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym___END__] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1731] = {
    [anon_sym_SLASH] = ACTIONS(2303),
    [sym__line_break] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_AMP_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT_EQ] = ACTIONS(2305),
    [anon_sym_SLASH_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_CARET_EQ] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_then] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_when] = ACTIONS(2305),
    [anon_sym_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_PLUS_EQ] = ACTIONS(2305),
    [anon_sym_STAR_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym___END__] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_end] = ACTIONS(2305),
    [anon_sym_ensure] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_elsif] = ACTIONS(2305),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_DASH_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2303),
  },
  [1732] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(6951),
  },
  [1733] = {
    [sym_heredoc_body] = STATE(4134),
    [sym__terminator] = STATE(4134),
    [sym__line_break] = ACTIONS(6953),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(6953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [1734] = {
    [sym_when] = STATE(4137),
    [sym_else] = STATE(4136),
    [aux_sym_case_repeat2] = STATE(4137),
    [aux_sym_case_repeat1] = STATE(4138),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(6955),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(6957),
    [sym_comment] = ACTIONS(49),
  },
  [1735] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym___END__] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5454),
    [anon_sym_ensure] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_elsif] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
  },
  [1736] = {
    [anon_sym_RPAREN] = ACTIONS(6959),
    [sym_comment] = ACTIONS(49),
  },
  [1737] = {
    [anon_sym_SLASH] = ACTIONS(2385),
    [sym__line_break] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_AMP_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT_EQ] = ACTIONS(2387),
    [anon_sym_SLASH_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2385),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_PERCENT_EQ] = ACTIONS(2387),
    [anon_sym_LT_LT_EQ] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_CARET_EQ] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_then] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_EQ_GT] = ACTIONS(2387),
    [anon_sym_when] = ACTIONS(2387),
    [anon_sym_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [anon_sym_STAR_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym___END__] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_end] = ACTIONS(2387),
    [anon_sym_ensure] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_elsif] = ACTIONS(2387),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2387),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2385),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2385),
  },
  [1738] = {
    [anon_sym_RPAREN] = ACTIONS(6961),
    [sym_comment] = ACTIONS(49),
  },
  [1739] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym___END__] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [ts_builtin_sym_end] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [1740] = {
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym__line_break] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_AMP_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2531),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_else] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_EQ] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_then] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_EQ_GT] = ACTIONS(2533),
    [anon_sym_when] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_PLUS_EQ] = ACTIONS(2533),
    [anon_sym_STAR_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym___END__] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_end] = ACTIONS(2533),
    [anon_sym_ensure] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_elsif] = ACTIONS(2533),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2533),
    [ts_builtin_sym_end] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2531),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_AMP_AMP] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2531),
  },
  [1741] = {
    [sym_assignment] = STATE(4141),
    [sym_unary] = STATE(4141),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4141),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(4141),
    [sym_conditional] = STATE(4141),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(4141),
    [sym_binary] = STATE(4141),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [1742] = {
    [sym_heredoc_body] = STATE(4142),
    [sym__terminator] = STATE(4142),
    [sym_superclass] = STATE(4143),
    [sym__line_break] = ACTIONS(6963),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(6963),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1743] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(4143),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(4142),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(4142),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(6963),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(6963),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1744] = {
    [anon_sym_SLASH] = ACTIONS(2575),
    [sym__line_break] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_else] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_then] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_EQ_GT] = ACTIONS(2577),
    [anon_sym_when] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym___END__] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_end] = ACTIONS(2577),
    [anon_sym_ensure] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_elsif] = ACTIONS(2577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2577),
    [ts_builtin_sym_end] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2575),
  },
  [1745] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(6965),
  },
  [1746] = {
    [sym_heredoc_body] = STATE(4146),
    [sym__terminator] = STATE(4146),
    [sym__line_break] = ACTIONS(6967),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(6967),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(6969),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1747] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(4146),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(4146),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(6967),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(6967),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(6969),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [1748] = {
    [anon_sym_end] = ACTIONS(6971),
    [sym_comment] = ACTIONS(49),
  },
  [1749] = {
    [sym_ensure] = STATE(4148),
    [sym_else] = STATE(4149),
    [anon_sym_end] = ACTIONS(6971),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1750] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(4150),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6973),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [1751] = {
    [anon_sym_SLASH] = ACTIONS(2741),
    [sym__line_break] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2741),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2741),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_then] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_when] = ACTIONS(2743),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym___END__] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_end] = ACTIONS(2743),
    [anon_sym_ensure] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_elsif] = ACTIONS(2743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(2743),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2741),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2741),
  },
  [1752] = {
    [sym_ensure] = STATE(4148),
    [sym_else] = STATE(4149),
    [sym_rescue] = STATE(4151),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(6971),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [1753] = {
    [sym_ensure] = STATE(4148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(6971),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [1754] = {
    [anon_sym_SLASH] = ACTIONS(2851),
    [sym__line_break] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_AMP_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_SLASH_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2851),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_PERCENT_EQ] = ACTIONS(2853),
    [anon_sym_LT_LT_EQ] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_else] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_CARET_EQ] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_then] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_when] = ACTIONS(2853),
    [anon_sym_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_PLUS_EQ] = ACTIONS(2853),
    [anon_sym_STAR_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym___END__] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_end] = ACTIONS(2853),
    [anon_sym_ensure] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_elsif] = ACTIONS(2853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2853),
    [ts_builtin_sym_end] = ACTIONS(2853),
    [anon_sym_DASH_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2851),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2851),
  },
  [1755] = {
    [anon_sym_SLASH] = ACTIONS(2855),
    [sym__line_break] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_AMP_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT_EQ] = ACTIONS(2857),
    [anon_sym_SLASH_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_PERCENT_EQ] = ACTIONS(2857),
    [anon_sym_LT_LT_EQ] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_else] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_CARET_EQ] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_then] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_when] = ACTIONS(2857),
    [anon_sym_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_PLUS_EQ] = ACTIONS(2857),
    [anon_sym_STAR_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym___END__] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_end] = ACTIONS(2857),
    [anon_sym_ensure] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_elsif] = ACTIONS(2857),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2857),
    [ts_builtin_sym_end] = ACTIONS(2857),
    [anon_sym_DASH_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2855),
  },
  [1756] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(6975),
  },
  [1757] = {
    [anon_sym_SLASH] = ACTIONS(2861),
    [sym__line_break] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_AMP_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT_EQ] = ACTIONS(2863),
    [anon_sym_SLASH_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_PERCENT_EQ] = ACTIONS(2863),
    [anon_sym_LT_LT_EQ] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_CARET_EQ] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_then] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_EQ_GT] = ACTIONS(2863),
    [anon_sym_when] = ACTIONS(2863),
    [anon_sym_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_PLUS_EQ] = ACTIONS(2863),
    [anon_sym_STAR_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym___END__] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2861),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_end] = ACTIONS(2863),
    [anon_sym_ensure] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_elsif] = ACTIONS(2863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2863),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_DASH_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2861),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2861),
  },
  [1758] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym___END__] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [ts_builtin_sym_end] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [1759] = {
    [sym__terminator] = STATE(4153),
    [sym_heredoc_body] = STATE(4153),
    [sym_then] = STATE(4154),
    [sym__line_break] = ACTIONS(6977),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(6977),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [1760] = {
    [anon_sym_SLASH] = ACTIONS(2871),
    [sym__line_break] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_else] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_then] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2873),
    [anon_sym_when] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym___END__] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_end] = ACTIONS(2873),
    [anon_sym_ensure] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_elsif] = ACTIONS(2873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2873),
    [ts_builtin_sym_end] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2871),
  },
  [1761] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4157),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6979),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(6981),
  },
  [1762] = {
    [aux_sym_string_array_repeat1] = STATE(4160),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(6983),
    [sym__string_end] = ACTIONS(6985),
  },
  [1763] = {
    [anon_sym_SLASH] = ACTIONS(2883),
    [sym__line_break] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_then] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_when] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_ensure] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [ts_builtin_sym_end] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2883),
  },
  [1764] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(1667),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(1676),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(6987),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1765] = {
    [anon_sym_SLASH] = ACTIONS(6989),
    [sym__line_break] = ACTIONS(6991),
    [anon_sym_until] = ACTIONS(6991),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_RBRACE] = ACTIONS(6991),
    [anon_sym_unless] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_rescue] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_while] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(6991),
    [anon_sym_else] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_then] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_when] = ACTIONS(6991),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym___END__] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_end] = ACTIONS(6991),
    [anon_sym_ensure] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_elsif] = ACTIONS(6991),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [ts_builtin_sym_end] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [1766] = {
    [sym_assignment] = STATE(4163),
    [sym_unary] = STATE(4163),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4163),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(4164),
    [sym_operator_assignment] = STATE(4163),
    [sym_conditional] = STATE(4163),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_subshell] = STATE(452),
    [sym__arg_or_splat_arg] = STATE(4164),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_true] = STATE(457),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4163),
    [sym_binary] = STATE(4163),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(801),
    [sym_character] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1767] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(3319),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(3320),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1768] = {
    [sym_do_block] = STATE(3332),
    [sym_block] = STATE(3332),
    [anon_sym_SLASH] = ACTIONS(3085),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym___END__] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_end] = ACTIONS(3087),
    [anon_sym_ensure] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_elsif] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [1769] = {
    [aux_sym_heredoc_body_repeat1] = STATE(4166),
    [sym_interpolation] = STATE(4166),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(6993),
    [sym_heredoc_end] = ACTIONS(6995),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(6993),
  },
  [1770] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_heredoc_body] = STATE(4168),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_float] = ACTIONS(795),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(801),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(801),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(817),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [sym_class_variable] = ACTIONS(817),
    [sym__block_ampersand] = ACTIONS(835),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(6997),
    [sym_redo] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1771] = {
    [sym_heredoc_body] = STATE(4169),
    [aux_sym_call_repeat1] = STATE(4169),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [1772] = {
    [sym_heredoc_body] = STATE(4170),
    [aux_sym_call_repeat1] = STATE(4170),
    [aux_sym_argument_list_repeat1] = STATE(4171),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [1773] = {
    [sym_assignment] = STATE(4172),
    [sym_unary] = STATE(4172),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4172),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4172),
    [sym_conditional] = STATE(4172),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4172),
    [sym_binary] = STATE(4172),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1774] = {
    [sym_assignment] = STATE(4173),
    [sym_unary] = STATE(4173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4173),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4173),
    [sym_conditional] = STATE(4173),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4173),
    [sym_binary] = STATE(4173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1775] = {
    [sym_assignment] = STATE(4174),
    [sym_unary] = STATE(4174),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4174),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4174),
    [sym_conditional] = STATE(4174),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4174),
    [sym_binary] = STATE(4174),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1776] = {
    [sym_assignment] = STATE(4175),
    [sym_unary] = STATE(4175),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4175),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4175),
    [sym_conditional] = STATE(4175),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4175),
    [sym_binary] = STATE(4175),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1777] = {
    [sym_assignment] = STATE(4176),
    [sym_unary] = STATE(4176),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4176),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4176),
    [sym_conditional] = STATE(4176),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4176),
    [sym_binary] = STATE(4176),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1778] = {
    [sym_assignment] = STATE(4177),
    [sym_unary] = STATE(4177),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4177),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4177),
    [sym_conditional] = STATE(4177),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4177),
    [sym_binary] = STATE(4177),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1779] = {
    [sym_assignment] = STATE(4178),
    [sym_unary] = STATE(4178),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4178),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4178),
    [sym_conditional] = STATE(4178),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4178),
    [sym_binary] = STATE(4178),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1780] = {
    [sym_assignment] = STATE(4180),
    [sym_unary] = STATE(4180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4180),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4180),
    [sym_conditional] = STATE(4180),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4180),
    [sym_binary] = STATE(4180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1781] = {
    [sym_assignment] = STATE(4181),
    [sym_unary] = STATE(4181),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4181),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4181),
    [sym_conditional] = STATE(4181),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4181),
    [sym_binary] = STATE(4181),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1782] = {
    [sym_assignment] = STATE(4182),
    [sym_unary] = STATE(4182),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4182),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(4182),
    [sym_conditional] = STATE(4182),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4182),
    [sym_binary] = STATE(4182),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [1783] = {
    [aux_sym_chained_string_repeat1] = STATE(4183),
    [sym_string] = STATE(4183),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym___END__] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [ts_builtin_sym_end] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [1784] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1785] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1786] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1787] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1788] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [1789] = {
    [sym__argument] = STATE(4197),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(4197),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(4197),
    [sym_hash_splat_argument] = STATE(4197),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(4204),
    [sym_block_argument] = STATE(4197),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [1790] = {
    [sym__argument] = STATE(4197),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(4197),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(4197),
    [sym_hash_splat_argument] = STATE(4197),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(4204),
    [sym_block_argument] = STATE(4197),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [1791] = {
    [sym_assignment] = STATE(4205),
    [sym_unary] = STATE(4205),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4205),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4205),
    [sym_conditional] = STATE(4205),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4205),
    [sym_binary] = STATE(4205),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1792] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1793] = {
    [sym__argument] = STATE(4197),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(4197),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(4197),
    [sym_hash_splat_argument] = STATE(4197),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(4204),
    [sym_block_argument] = STATE(4197),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [1794] = {
    [sym_assignment] = STATE(4206),
    [sym_unary] = STATE(4206),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4206),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4206),
    [sym_conditional] = STATE(4206),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4206),
    [sym_binary] = STATE(4206),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1795] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7041),
    [sym_identifier] = ACTIONS(7041),
  },
  [1796] = {
    [sym__argument] = STATE(4197),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(4197),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(4197),
    [sym_hash_splat_argument] = STATE(4197),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(4204),
    [sym_block_argument] = STATE(4197),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [1797] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(7043),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7043),
    [anon_sym_SLASH_EQ] = ACTIONS(7043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7043),
    [anon_sym_PIPE_EQ] = ACTIONS(7043),
    [anon_sym_LT_LT_EQ] = ACTIONS(7043),
    [anon_sym_PLUS_EQ] = ACTIONS(7043),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7043),
    [anon_sym_STAR_EQ] = ACTIONS(7043),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7043),
    [anon_sym_CARET_EQ] = ACTIONS(7043),
    [anon_sym_DASH_EQ] = ACTIONS(7043),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7043),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7045),
  },
  [1798] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(7067),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [1799] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(7079),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7081),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [1800] = {
    [sym_block] = STATE(2275),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym__primary] = STATE(4235),
    [sym_argument_list] = STATE(2277),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_method] = STATE(4235),
    [sym_conditional] = STATE(4240),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_subshell] = STATE(4235),
    [sym_unless] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4239),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_call] = STATE(4237),
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_rational] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_lambda] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_do_block] = STATE(2275),
    [sym_binary] = STATE(4240),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_nil] = STATE(4239),
    [sym_symbol_array] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_scope_resolution] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(7089),
    [anon_sym_COLON2] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [1801] = {
    [anon_sym_EQ] = ACTIONS(7117),
    [sym_comment] = ACTIONS(3),
  },
  [1802] = {
    [aux_sym_chained_string_repeat1] = STATE(4243),
    [sym_string] = STATE(4243),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1803] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1804] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1805] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [1806] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1807] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(889),
  },
  [1808] = {
    [aux_sym_chained_string_repeat1] = STATE(1808),
    [sym_string] = STATE(1808),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym___END__] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [1809] = {
    [sym_uninterpreted] = ACTIONS(7128),
    [sym_comment] = ACTIONS(3),
  },
  [1810] = {
    [sym__method_name] = STATE(4245),
    [sym_setter] = STATE(4245),
    [sym_symbol] = STATE(4245),
    [sym_operator] = STATE(4245),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(7130),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(7130),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(7130),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(7130),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [1811] = {
    [sym_assignment] = STATE(4246),
    [sym_unary] = STATE(4246),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(4246),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(4246),
    [sym_conditional] = STATE(4246),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(4246),
    [sym_binary] = STATE(4246),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [1812] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [1813] = {
    [sym_assignment] = STATE(4247),
    [sym_unary] = STATE(4247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(4247),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(4247),
    [sym_conditional] = STATE(4247),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(4247),
    [sym_binary] = STATE(4247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [1814] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7160),
    [sym_identifier] = ACTIONS(7160),
  },
  [1815] = {
    [sym__argument] = STATE(4262),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(4262),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(4262),
    [sym_hash_splat_argument] = STATE(4262),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(4269),
    [sym_block_argument] = STATE(4262),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [1816] = {
    [sym__argument] = STATE(4262),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(4262),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(4262),
    [sym_hash_splat_argument] = STATE(4262),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(4269),
    [sym_block_argument] = STATE(4262),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [1817] = {
    [sym__argument] = STATE(4262),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(4262),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(4262),
    [sym_hash_splat_argument] = STATE(4262),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(4269),
    [sym_block_argument] = STATE(4262),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [1818] = {
    [sym__argument] = STATE(4262),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(4262),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(4262),
    [sym_hash_splat_argument] = STATE(4262),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(4269),
    [sym_block_argument] = STATE(4262),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [1819] = {
    [sym_heredoc_body] = STATE(408),
    [sym__terminator] = STATE(408),
    [sym__line_break] = ACTIONS(755),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [1820] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(7208),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(7210),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7212),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [1821] = {
    [anon_sym_EQ] = ACTIONS(7214),
    [sym_comment] = ACTIONS(3),
  },
  [1822] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym__primary] = STATE(4290),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_method] = STATE(4290),
    [sym_conditional] = STATE(4295),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_subshell] = STATE(4290),
    [sym_unless] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4294),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_call] = STATE(4292),
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_rational] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_lambda] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(4295),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_nil] = STATE(4294),
    [sym_symbol_array] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_scope_resolution] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [1823] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(7250),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7252),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7252),
    [anon_sym_SLASH_EQ] = ACTIONS(7252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7252),
    [anon_sym_PIPE_EQ] = ACTIONS(7252),
    [anon_sym_LT_LT_EQ] = ACTIONS(7252),
    [anon_sym_PLUS_EQ] = ACTIONS(7252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7252),
    [anon_sym_STAR_EQ] = ACTIONS(7252),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7252),
    [anon_sym_CARET_EQ] = ACTIONS(7252),
    [anon_sym_DASH_EQ] = ACTIONS(7252),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7252),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1824] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [1825] = {
    [aux_sym_chained_string_repeat1] = STATE(4309),
    [sym_string] = STATE(4309),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1826] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [1827] = {
    [aux_sym_chained_string_repeat1] = STATE(1880),
    [sym_string] = STATE(1880),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1828] = {
    [sym_assignment] = STATE(4310),
    [sym_unary] = STATE(4310),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4310),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(4310),
    [sym_conditional] = STATE(4310),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(4310),
    [sym_binary] = STATE(4310),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1829] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [1830] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1831] = {
    [sym_assignment] = STATE(4311),
    [sym_unary] = STATE(4311),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4311),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(4311),
    [sym_conditional] = STATE(4311),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(4311),
    [sym_binary] = STATE(4311),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1832] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(7282),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1833] = {
    [anon_sym_COLON] = ACTIONS(7284),
    [sym_comment] = ACTIONS(49),
  },
  [1834] = {
    [sym_assignment] = STATE(4314),
    [sym_unary] = STATE(4314),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4314),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4314),
    [sym_conditional] = STATE(4314),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4314),
    [sym_binary] = STATE(4314),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1835] = {
    [sym_assignment] = STATE(4315),
    [sym_unary] = STATE(4315),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4315),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4315),
    [sym_conditional] = STATE(4315),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4315),
    [sym_binary] = STATE(4315),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1836] = {
    [sym_assignment] = STATE(4316),
    [sym_unary] = STATE(4316),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4316),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4316),
    [sym_conditional] = STATE(4316),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4316),
    [sym_binary] = STATE(4316),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1837] = {
    [sym_heredoc_body] = STATE(4318),
    [aux_sym_call_repeat1] = STATE(4318),
    [aux_sym_argument_list_repeat1] = STATE(4319),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7286),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [1838] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [1839] = {
    [aux_sym_chained_string_repeat1] = STATE(1880),
    [sym_string] = STATE(1880),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7288),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1840] = {
    [sym_heredoc_body] = STATE(4318),
    [aux_sym_call_repeat1] = STATE(4318),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [1841] = {
    [sym__argument] = STATE(4320),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(4320),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(4320),
    [sym_hash_splat_argument] = STATE(4320),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(4321),
    [sym_block_argument] = STATE(4320),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [1842] = {
    [sym__argument] = STATE(4320),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(4320),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(4320),
    [sym_hash_splat_argument] = STATE(4320),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(4321),
    [sym_block_argument] = STATE(4320),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [1843] = {
    [sym_assignment] = STATE(4322),
    [sym_unary] = STATE(4322),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4322),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(4322),
    [sym_conditional] = STATE(4322),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(4322),
    [sym_binary] = STATE(4322),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1844] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1845] = {
    [sym__argument] = STATE(4320),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(4320),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(4320),
    [sym_hash_splat_argument] = STATE(4320),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(4321),
    [sym_block_argument] = STATE(4320),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [1846] = {
    [sym_assignment] = STATE(4323),
    [sym_unary] = STATE(4323),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4323),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(4323),
    [sym_conditional] = STATE(4323),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(4323),
    [sym_binary] = STATE(4323),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1847] = {
    [sym__argument] = STATE(4320),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(4320),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(4320),
    [sym_hash_splat_argument] = STATE(4320),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym__argument_list_with_parens] = STATE(4321),
    [sym_block_argument] = STATE(4320),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(915),
    [sym_self] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(941),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [1848] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7292),
  },
  [1849] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [1850] = {
    [anon_sym_EQ] = ACTIONS(7320),
    [sym_comment] = ACTIONS(3),
  },
  [1851] = {
    [aux_sym_chained_string_repeat1] = STATE(4335),
    [sym_string] = STATE(4335),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [1852] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [1853] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [1854] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_heredoc_body] = STATE(4336),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(917),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(929),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(941),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7322),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1855] = {
    [sym_heredoc_body] = STATE(4337),
    [aux_sym_call_repeat1] = STATE(4337),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [1856] = {
    [sym_heredoc_body] = STATE(4338),
    [aux_sym_call_repeat1] = STATE(4338),
    [aux_sym_argument_list_repeat1] = STATE(4339),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [1857] = {
    [sym_assignment] = STATE(4340),
    [sym_unary] = STATE(4340),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4340),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4340),
    [sym_conditional] = STATE(4340),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4340),
    [sym_binary] = STATE(4340),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1858] = {
    [sym_assignment] = STATE(4341),
    [sym_unary] = STATE(4341),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4341),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(4342),
    [sym_operator_assignment] = STATE(4341),
    [sym_conditional] = STATE(4341),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_subshell] = STATE(492),
    [sym__arg_or_splat_arg] = STATE(4342),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_true] = STATE(490),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4341),
    [sym_binary] = STATE(4341),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(917),
    [sym_character] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1859] = {
    [sym_assignment] = STATE(4343),
    [sym_unary] = STATE(4343),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4343),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4343),
    [sym_conditional] = STATE(4343),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4343),
    [sym_binary] = STATE(4343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1860] = {
    [sym_assignment] = STATE(4344),
    [sym_unary] = STATE(4344),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4344),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4344),
    [sym_conditional] = STATE(4344),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4344),
    [sym_binary] = STATE(4344),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1861] = {
    [sym_assignment] = STATE(4345),
    [sym_unary] = STATE(4345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4345),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4345),
    [sym_conditional] = STATE(4345),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4345),
    [sym_binary] = STATE(4345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1862] = {
    [sym_assignment] = STATE(4346),
    [sym_unary] = STATE(4346),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4346),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4346),
    [sym_conditional] = STATE(4346),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4346),
    [sym_binary] = STATE(4346),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1863] = {
    [sym_assignment] = STATE(4347),
    [sym_unary] = STATE(4347),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4347),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4347),
    [sym_conditional] = STATE(4347),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4347),
    [sym_binary] = STATE(4347),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1864] = {
    [sym_assignment] = STATE(4348),
    [sym_unary] = STATE(4348),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4348),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4348),
    [sym_conditional] = STATE(4348),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4348),
    [sym_binary] = STATE(4348),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1865] = {
    [sym_assignment] = STATE(4350),
    [sym_unary] = STATE(4350),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4350),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4350),
    [sym_conditional] = STATE(4350),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4350),
    [sym_binary] = STATE(4350),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1866] = {
    [sym_assignment] = STATE(4351),
    [sym_unary] = STATE(4351),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4351),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4351),
    [sym_conditional] = STATE(4351),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4351),
    [sym_binary] = STATE(4351),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1867] = {
    [sym_assignment] = STATE(4352),
    [sym_unary] = STATE(4352),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4352),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(4352),
    [sym_conditional] = STATE(4352),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4352),
    [sym_binary] = STATE(4352),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [1868] = {
    [sym_heredoc_body] = STATE(4357),
    [sym__argument_list_with_parens] = STATE(4356),
    [aux_sym_call_repeat1] = STATE(4357),
    [sym_argument_list_with_parens] = STATE(4355),
    [sym_operator] = STATE(4355),
    [anon_sym_LT] = ACTIONS(7324),
    [anon_sym_SLASH] = ACTIONS(7326),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7326),
    [anon_sym_PLUS_AT] = ACTIONS(7326),
    [anon_sym_LPAREN2] = ACTIONS(7328),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7326),
    [anon_sym_GT_GT] = ACTIONS(7326),
    [anon_sym_EQ_TILDE] = ACTIONS(7326),
    [anon_sym_LT_LT] = ACTIONS(7326),
    [anon_sym_TILDE] = ACTIONS(7326),
    [anon_sym_PLUS] = ACTIONS(7324),
    [anon_sym_AMP] = ACTIONS(7326),
    [anon_sym_GT] = ACTIONS(7324),
    [anon_sym_PERCENT] = ACTIONS(7326),
    [anon_sym_DASH_AT] = ACTIONS(7326),
    [anon_sym_EQ_EQ] = ACTIONS(7324),
    [anon_sym_STAR] = ACTIONS(7324),
    [anon_sym_BANG_TILDE] = ACTIONS(7326),
    [sym_constant] = ACTIONS(7330),
    [anon_sym_DASH] = ACTIONS(7324),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7326),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7324),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7326),
    [anon_sym_STAR_STAR] = ACTIONS(7326),
    [anon_sym_PIPE] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7326),
    [anon_sym_LT_EQ_GT] = ACTIONS(7326),
    [anon_sym_LT_EQ] = ACTIONS(7324),
    [anon_sym_BANG] = ACTIONS(7324),
    [sym_identifier] = ACTIONS(7330),
    [anon_sym_CARET] = ACTIONS(7326),
  },
  [1869] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7332),
    [sym_identifier] = ACTIONS(7332),
  },
  [1870] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(3319),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(3320),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(7334),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [1871] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(7336),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1872] = {
    [anon_sym_COLON] = ACTIONS(7338),
    [sym_comment] = ACTIONS(49),
  },
  [1873] = {
    [sym_assignment] = STATE(4362),
    [sym_unary] = STATE(4362),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4362),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4362),
    [sym_conditional] = STATE(4362),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4362),
    [sym_binary] = STATE(4362),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1874] = {
    [sym_assignment] = STATE(4363),
    [sym_unary] = STATE(4363),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4363),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4363),
    [sym_conditional] = STATE(4363),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4363),
    [sym_binary] = STATE(4363),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1875] = {
    [sym_assignment] = STATE(4364),
    [sym_unary] = STATE(4364),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4364),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4364),
    [sym_conditional] = STATE(4364),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4364),
    [sym_binary] = STATE(4364),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1876] = {
    [sym_heredoc_body] = STATE(4366),
    [aux_sym_call_repeat1] = STATE(4366),
    [aux_sym_argument_list_repeat1] = STATE(4367),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7340),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1877] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [1878] = {
    [aux_sym_chained_string_repeat1] = STATE(1945),
    [sym_string] = STATE(1945),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7342),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1879] = {
    [sym_heredoc_body] = STATE(4366),
    [aux_sym_call_repeat1] = STATE(4366),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1880] = {
    [aux_sym_chained_string_repeat1] = STATE(4368),
    [sym_string] = STATE(4368),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [1881] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1882] = {
    [sym_assignment] = STATE(4369),
    [sym_unary] = STATE(4369),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4369),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(4369),
    [sym_conditional] = STATE(4369),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(4369),
    [sym_binary] = STATE(4369),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1883] = {
    [sym_assignment] = STATE(4370),
    [sym_unary] = STATE(4370),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4370),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(4370),
    [sym_conditional] = STATE(4370),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(4370),
    [sym_binary] = STATE(4370),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1884] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1885] = {
    [sym_assignment] = STATE(4371),
    [sym_unary] = STATE(4371),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4371),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(4371),
    [sym_conditional] = STATE(4371),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(4371),
    [sym_binary] = STATE(4371),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [1886] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7344),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7344),
    [anon_sym_SLASH_EQ] = ACTIONS(7344),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7344),
    [anon_sym_PIPE_EQ] = ACTIONS(7344),
    [anon_sym_LT_LT_EQ] = ACTIONS(7344),
    [anon_sym_PLUS_EQ] = ACTIONS(7344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7344),
    [anon_sym_STAR_EQ] = ACTIONS(7344),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7344),
    [anon_sym_CARET_EQ] = ACTIONS(7344),
    [anon_sym_DASH_EQ] = ACTIONS(7344),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7344),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7346),
  },
  [1887] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [1888] = {
    [anon_sym_EQ] = ACTIONS(7374),
    [sym_comment] = ACTIONS(3),
  },
  [1889] = {
    [aux_sym_exceptions_repeat1] = STATE(4384),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [1890] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1891] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [1892] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(7378),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [1893] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1894] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [1895] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1896] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [1897] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [1898] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [1899] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [1900] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(7380),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [1901] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [1902] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [sym__line_break] = ACTIONS(7384),
    [anon_sym_then] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_when] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym___END__] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_end] = ACTIONS(7384),
    [anon_sym_ensure] = ACTIONS(7384),
    [anon_sym_else] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_elsif] = ACTIONS(7384),
    [ts_builtin_sym_end] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
    [sym__binary_minus] = ACTIONS(7384),
  },
  [1903] = {
    [anon_sym_end] = ACTIONS(7386),
    [sym_comment] = ACTIONS(49),
  },
  [1904] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [1905] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(4389),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [1906] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [1907] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [1908] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(1907),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(4390),
    [sym_operator] = STATE(4390),
    [anon_sym_LT] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(3414),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3414),
    [anon_sym_PLUS_AT] = ACTIONS(3414),
    [anon_sym_LPAREN2] = ACTIONS(3416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3414),
    [anon_sym_GT_GT] = ACTIONS(3414),
    [anon_sym_EQ_TILDE] = ACTIONS(3414),
    [anon_sym_LT_LT] = ACTIONS(3414),
    [anon_sym_TILDE] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3414),
    [anon_sym_GT] = ACTIONS(3412),
    [anon_sym_PERCENT] = ACTIONS(3414),
    [anon_sym_DASH_AT] = ACTIONS(3414),
    [anon_sym_EQ_EQ] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_BANG_TILDE] = ACTIONS(3414),
    [sym_constant] = ACTIONS(7390),
    [anon_sym_DASH] = ACTIONS(3412),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(3414),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3414),
    [anon_sym_STAR_STAR] = ACTIONS(3414),
    [anon_sym_PIPE] = ACTIONS(3414),
    [anon_sym_DOT_DOT] = ACTIONS(3414),
    [anon_sym_LT_EQ_GT] = ACTIONS(3414),
    [anon_sym_LT_EQ] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [sym_identifier] = ACTIONS(7390),
    [anon_sym_CARET] = ACTIONS(3414),
  },
  [1909] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [1910] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [1911] = {
    [aux_sym_chained_string_repeat1] = STATE(1945),
    [sym_string] = STATE(1945),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1912] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [1913] = {
    [sym_assignment] = STATE(4391),
    [sym_unary] = STATE(4391),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(4391),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(4391),
    [sym_conditional] = STATE(4391),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(4391),
    [sym_binary] = STATE(4391),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [1914] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [1915] = {
    [sym_assignment] = STATE(4392),
    [sym_unary] = STATE(4392),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(4392),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(4392),
    [sym_conditional] = STATE(4392),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(4392),
    [sym_binary] = STATE(4392),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [1916] = {
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_hash_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1917] = {
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_hash_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1918] = {
    [sym_assignment] = STATE(4393),
    [sym_unary] = STATE(4393),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(4393),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(4393),
    [sym_conditional] = STATE(4393),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(4393),
    [sym_binary] = STATE(4393),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [1919] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [1920] = {
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_hash_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1921] = {
    [sym_assignment] = STATE(4394),
    [sym_unary] = STATE(4394),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(4394),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(4394),
    [sym_conditional] = STATE(4394),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(4394),
    [sym_binary] = STATE(4394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [1922] = {
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_hash_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1923] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7392),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7392),
    [anon_sym_SLASH_EQ] = ACTIONS(7392),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7392),
    [anon_sym_PIPE_EQ] = ACTIONS(7392),
    [anon_sym_LT_LT_EQ] = ACTIONS(7392),
    [anon_sym_PLUS_EQ] = ACTIONS(7392),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7392),
    [anon_sym_STAR_EQ] = ACTIONS(7392),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7392),
    [anon_sym_CARET_EQ] = ACTIONS(7392),
    [anon_sym_DASH_EQ] = ACTIONS(7392),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7392),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(7394),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1924] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [1925] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1926] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_for] = STATE(529),
    [sym_if] = STATE(529),
    [sym__primary] = STATE(529),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(533),
    [sym_method] = STATE(529),
    [sym_conditional] = STATE(535),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_true] = STATE(534),
    [sym_subshell] = STATE(529),
    [sym_unless] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_block_argument] = STATE(533),
    [sym_range] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(534),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_array] = STATE(529),
    [sym_call] = STATE(532),
    [sym__argument] = STATE(533),
    [sym_assignment] = STATE(535),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_pair] = STATE(533),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(533),
    [sym_operator_assignment] = STATE(535),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_rational] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_lambda] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym__argument_list_with_parens] = STATE(537),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(535),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_nil] = STATE(534),
    [sym_symbol_array] = STATE(529),
    [sym_case] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_scope_resolution] = STATE(532),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(999),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1005),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [sym_character] = ACTIONS(1007),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [1927] = {
    [anon_sym_EQ] = ACTIONS(7424),
    [sym_comment] = ACTIONS(3),
  },
  [1928] = {
    [aux_sym_chained_string_repeat1] = STATE(4406),
    [sym_string] = STATE(4406),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1929] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [1930] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [1931] = {
    [sym_assignment] = STATE(4407),
    [sym_unary] = STATE(4407),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4407),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(4408),
    [sym_operator_assignment] = STATE(4407),
    [sym_conditional] = STATE(4407),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_subshell] = STATE(529),
    [sym__arg_or_splat_arg] = STATE(4408),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_true] = STATE(534),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4407),
    [sym_binary] = STATE(4407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1005),
    [sym_character] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1932] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_heredoc_body] = STATE(4409),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym_float] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1019),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1019),
    [sym__block_ampersand] = ACTIONS(1027),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7426),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1933] = {
    [sym_heredoc_body] = STATE(4410),
    [aux_sym_call_repeat1] = STATE(4410),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [1934] = {
    [sym_heredoc_body] = STATE(4411),
    [aux_sym_call_repeat1] = STATE(4411),
    [aux_sym_argument_list_repeat1] = STATE(4412),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [1935] = {
    [sym_assignment] = STATE(4413),
    [sym_unary] = STATE(4413),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4413),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4413),
    [sym_conditional] = STATE(4413),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4413),
    [sym_binary] = STATE(4413),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1936] = {
    [sym_assignment] = STATE(4414),
    [sym_unary] = STATE(4414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4414),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4414),
    [sym_conditional] = STATE(4414),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4414),
    [sym_binary] = STATE(4414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1937] = {
    [sym_assignment] = STATE(4415),
    [sym_unary] = STATE(4415),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4415),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4415),
    [sym_conditional] = STATE(4415),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4415),
    [sym_binary] = STATE(4415),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1938] = {
    [sym_assignment] = STATE(4416),
    [sym_unary] = STATE(4416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4416),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4416),
    [sym_conditional] = STATE(4416),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4416),
    [sym_binary] = STATE(4416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [1939] = {
    [sym_assignment] = STATE(4417),
    [sym_unary] = STATE(4417),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4417),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4417),
    [sym_conditional] = STATE(4417),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4417),
    [sym_binary] = STATE(4417),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1940] = {
    [sym_assignment] = STATE(4418),
    [sym_unary] = STATE(4418),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4418),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4418),
    [sym_conditional] = STATE(4418),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4418),
    [sym_binary] = STATE(4418),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1941] = {
    [sym_assignment] = STATE(4419),
    [sym_unary] = STATE(4419),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4419),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4419),
    [sym_conditional] = STATE(4419),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4419),
    [sym_binary] = STATE(4419),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1942] = {
    [sym_assignment] = STATE(4421),
    [sym_unary] = STATE(4421),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4421),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4421),
    [sym_conditional] = STATE(4421),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4421),
    [sym_binary] = STATE(4421),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1943] = {
    [sym_assignment] = STATE(4422),
    [sym_unary] = STATE(4422),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4422),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4422),
    [sym_conditional] = STATE(4422),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4422),
    [sym_binary] = STATE(4422),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1944] = {
    [sym_assignment] = STATE(4423),
    [sym_unary] = STATE(4423),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4423),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(4423),
    [sym_conditional] = STATE(4423),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4423),
    [sym_binary] = STATE(4423),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [1945] = {
    [aux_sym_chained_string_repeat1] = STATE(4424),
    [sym_string] = STATE(4424),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [1946] = {
    [aux_sym_chained_string_repeat1] = STATE(1946),
    [sym_string] = STATE(1946),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [1947] = {
    [sym__line_break] = ACTIONS(5628),
    [anon_sym_then] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym___END__] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_elsif] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
  },
  [1948] = {
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_then] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym___END__] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7428),
    [anon_sym_RPAREN] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_else] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_ensure] = ACTIONS(7428),
    [anon_sym_RBRACE] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [ts_builtin_sym_end] = ACTIONS(7428),
    [anon_sym_elsif] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_when] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
  },
  [1949] = {
    [aux_sym_undef_repeat1] = STATE(1949),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [ts_builtin_sym_end] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym___END__] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [1950] = {
    [aux_sym_undef_repeat1] = STATE(4425),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [1951] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [1952] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [1953] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [1954] = {
    [sym_assignment] = STATE(4426),
    [sym_unary] = STATE(4426),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4426),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(4426),
    [sym_conditional] = STATE(4426),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(4426),
    [sym_binary] = STATE(4426),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [1955] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [1956] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(7435),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1957] = {
    [sym_assignment] = STATE(4429),
    [sym_unary] = STATE(4429),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4429),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(4429),
    [sym_conditional] = STATE(4429),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(4429),
    [sym_binary] = STATE(4429),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [1958] = {
    [anon_sym_COLON] = ACTIONS(7437),
    [sym_comment] = ACTIONS(49),
  },
  [1959] = {
    [sym__argument] = STATE(4431),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4431),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4431),
    [sym_hash_splat_argument] = STATE(4431),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4432),
    [sym_block_argument] = STATE(4431),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1960] = {
    [sym_assignment] = STATE(4441),
    [sym_unary] = STATE(4441),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4441),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(4441),
    [sym_conditional] = STATE(4441),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(4441),
    [sym_binary] = STATE(4441),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [1961] = {
    [sym_assignment] = STATE(4444),
    [sym_unary] = STATE(4444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4444),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(4444),
    [sym_conditional] = STATE(4444),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(4444),
    [sym_binary] = STATE(4444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [1962] = {
    [sym__argument] = STATE(4431),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4431),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4431),
    [sym_hash_splat_argument] = STATE(4431),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4432),
    [sym_block_argument] = STATE(4431),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1963] = {
    [sym__argument] = STATE(4431),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4431),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4431),
    [sym_hash_splat_argument] = STATE(4431),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4432),
    [sym_block_argument] = STATE(4431),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1964] = {
    [sym_assignment] = STATE(4445),
    [sym_unary] = STATE(4445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4445),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(4445),
    [sym_conditional] = STATE(4445),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(4445),
    [sym_binary] = STATE(4445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [1965] = {
    [sym__argument] = STATE(4431),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(4431),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(4431),
    [sym_hash_splat_argument] = STATE(4431),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(4432),
    [sym_block_argument] = STATE(4431),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [1966] = {
    [sym_heredoc_body] = STATE(4447),
    [aux_sym_call_repeat1] = STATE(4447),
    [aux_sym_argument_list_repeat1] = STATE(4448),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7457),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1967] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7459),
    [anon_sym_GT_GT_EQ] = ACTIONS(7459),
    [anon_sym_SLASH_EQ] = ACTIONS(7459),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7459),
    [anon_sym_LT_LT_EQ] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7459),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(7459),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7461),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(7459),
    [anon_sym_PLUS_EQ] = ACTIONS(7459),
    [anon_sym_STAR_EQ] = ACTIONS(7459),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7459),
    [anon_sym_DASH_EQ] = ACTIONS(7459),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7459),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1968] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_EQ_GT] = ACTIONS(7437),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [1969] = {
    [anon_sym_EQ] = ACTIONS(7489),
    [sym_comment] = ACTIONS(3),
  },
  [1970] = {
    [aux_sym_chained_string_repeat1] = STATE(4460),
    [sym_string] = STATE(4460),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7491),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [1971] = {
    [sym_heredoc_body] = STATE(4447),
    [aux_sym_call_repeat1] = STATE(4447),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [1972] = {
    [sym_assignment] = STATE(4461),
    [sym_unary] = STATE(4461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4461),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4461),
    [sym_conditional] = STATE(4461),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4461),
    [sym_binary] = STATE(4461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1973] = {
    [sym_assignment] = STATE(4462),
    [sym_unary] = STATE(4462),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4462),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4462),
    [sym_conditional] = STATE(4462),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4462),
    [sym_binary] = STATE(4462),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1974] = {
    [sym_assignment] = STATE(4463),
    [sym_unary] = STATE(4463),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4463),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4463),
    [sym_conditional] = STATE(4463),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4463),
    [sym_binary] = STATE(4463),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1975] = {
    [aux_sym_heredoc_body_repeat1] = STATE(4465),
    [sym_interpolation] = STATE(4465),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(7493),
    [sym_heredoc_end] = ACTIONS(7495),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(7493),
  },
  [1976] = {
    [sym_assignment] = STATE(4466),
    [sym_unary] = STATE(4466),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4466),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4466),
    [sym_conditional] = STATE(4466),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4466),
    [sym_binary] = STATE(4466),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1977] = {
    [sym_assignment] = STATE(4467),
    [sym_unary] = STATE(4467),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4467),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4467),
    [sym_conditional] = STATE(4467),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4467),
    [sym_binary] = STATE(4467),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [1978] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [1979] = {
    [sym_heredoc_body] = STATE(4472),
    [sym__argument_list_with_parens] = STATE(4471),
    [aux_sym_call_repeat1] = STATE(4472),
    [sym_argument_list_with_parens] = STATE(4470),
    [sym_operator] = STATE(4470),
    [anon_sym_LT] = ACTIONS(7497),
    [anon_sym_SLASH] = ACTIONS(7499),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7499),
    [anon_sym_PLUS_AT] = ACTIONS(7499),
    [anon_sym_LPAREN2] = ACTIONS(7501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7499),
    [anon_sym_GT_GT] = ACTIONS(7499),
    [anon_sym_EQ_TILDE] = ACTIONS(7499),
    [anon_sym_LT_LT] = ACTIONS(7499),
    [anon_sym_TILDE] = ACTIONS(7499),
    [anon_sym_PLUS] = ACTIONS(7497),
    [anon_sym_AMP] = ACTIONS(7499),
    [anon_sym_GT] = ACTIONS(7497),
    [anon_sym_PERCENT] = ACTIONS(7499),
    [anon_sym_DASH_AT] = ACTIONS(7499),
    [anon_sym_EQ_EQ] = ACTIONS(7497),
    [anon_sym_STAR] = ACTIONS(7497),
    [anon_sym_BANG_TILDE] = ACTIONS(7499),
    [sym_constant] = ACTIONS(7503),
    [anon_sym_DASH] = ACTIONS(7497),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7499),
    [anon_sym_STAR_STAR] = ACTIONS(7499),
    [anon_sym_PIPE] = ACTIONS(7499),
    [anon_sym_DOT_DOT] = ACTIONS(7499),
    [anon_sym_LT_EQ_GT] = ACTIONS(7499),
    [anon_sym_LT_EQ] = ACTIONS(7497),
    [anon_sym_BANG] = ACTIONS(7497),
    [sym_identifier] = ACTIONS(7503),
    [anon_sym_CARET] = ACTIONS(7499),
  },
  [1980] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7505),
    [sym_identifier] = ACTIONS(7505),
  },
  [1981] = {
    [sym_assignment] = STATE(4479),
    [sym_unary] = STATE(4479),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4479),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_splat_argument] = STATE(4481),
    [sym_operator_assignment] = STATE(4479),
    [sym_conditional] = STATE(4479),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_subshell] = STATE(556),
    [sym__arg_or_splat_arg] = STATE(4481),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(4479),
    [sym_binary] = STATE(4479),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7511),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1061),
    [sym_character] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [1982] = {
    [sym_assignment] = STATE(4482),
    [sym_unary] = STATE(4482),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4482),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(4482),
    [sym_conditional] = STATE(4482),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(4482),
    [sym_binary] = STATE(4482),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [1983] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [1984] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(7521),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [1985] = {
    [sym_assignment] = STATE(4485),
    [sym_unary] = STATE(4485),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4485),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(4485),
    [sym_conditional] = STATE(4485),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(4485),
    [sym_binary] = STATE(4485),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [1986] = {
    [anon_sym_COLON] = ACTIONS(7523),
    [sym_comment] = ACTIONS(49),
  },
  [1987] = {
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1988] = {
    [sym_assignment] = STATE(4495),
    [sym_unary] = STATE(4495),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(4495),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(4495),
    [sym_conditional] = STATE(4495),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(4495),
    [sym_binary] = STATE(4495),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [1989] = {
    [sym_assignment] = STATE(4500),
    [sym_unary] = STATE(4500),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(4500),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(4500),
    [sym_conditional] = STATE(4500),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(4500),
    [sym_binary] = STATE(4500),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [1990] = {
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1991] = {
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1992] = {
    [sym_assignment] = STATE(4501),
    [sym_unary] = STATE(4501),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(4501),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(4501),
    [sym_conditional] = STATE(4501),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(4501),
    [sym_binary] = STATE(4501),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [1993] = {
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1994] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(6811),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6813),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(6815),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [1995] = {
    [anon_sym_EQ] = ACTIONS(7551),
    [sym_comment] = ACTIONS(3),
  },
  [1996] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym__primary] = STATE(1994),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(4037),
    [sym_method] = STATE(1994),
    [sym_conditional] = STATE(4038),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_subshell] = STATE(1994),
    [sym_unless] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_block_argument] = STATE(4037),
    [sym_range] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1998),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_call] = STATE(1996),
    [sym__argument] = STATE(4037),
    [sym_assignment] = STATE(4038),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_pair] = STATE(4037),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4037),
    [sym_operator_assignment] = STATE(4038),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_rational] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_lambda] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4040),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(4038),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_nil] = STATE(1998),
    [sym_symbol_array] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_scope_resolution] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(6819),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6823),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [1997] = {
    [sym_heredoc_body] = STATE(4504),
    [aux_sym_call_repeat1] = STATE(4504),
    [aux_sym_argument_list_repeat1] = STATE(4505),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7553),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [1998] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7555),
    [anon_sym_GT_GT_EQ] = ACTIONS(7555),
    [anon_sym_SLASH_EQ] = ACTIONS(7555),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7555),
    [anon_sym_LT_LT_EQ] = ACTIONS(7555),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7555),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(7555),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7557),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(7555),
    [anon_sym_PLUS_EQ] = ACTIONS(7555),
    [anon_sym_STAR_EQ] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7555),
    [anon_sym_DASH_EQ] = ACTIONS(7555),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7555),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [1999] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(7523),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [2000] = {
    [aux_sym_chained_string_repeat1] = STATE(4516),
    [sym_string] = STATE(4516),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7587),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2001] = {
    [sym_heredoc_body] = STATE(4504),
    [aux_sym_call_repeat1] = STATE(4504),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2002] = {
    [sym_assignment] = STATE(4517),
    [sym_unary] = STATE(4517),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4517),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4517),
    [sym_conditional] = STATE(4517),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4517),
    [sym_binary] = STATE(4517),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2003] = {
    [sym_assignment] = STATE(4518),
    [sym_unary] = STATE(4518),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4518),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4518),
    [sym_conditional] = STATE(4518),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4518),
    [sym_binary] = STATE(4518),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2004] = {
    [sym_assignment] = STATE(4519),
    [sym_unary] = STATE(4519),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4519),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4519),
    [sym_conditional] = STATE(4519),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4519),
    [sym_binary] = STATE(4519),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2005] = {
    [sym_assignment] = STATE(4520),
    [sym_unary] = STATE(4520),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4520),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4520),
    [sym_conditional] = STATE(4520),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4520),
    [sym_binary] = STATE(4520),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2006] = {
    [sym_assignment] = STATE(4521),
    [sym_unary] = STATE(4521),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4521),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4521),
    [sym_conditional] = STATE(4521),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4521),
    [sym_binary] = STATE(4521),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2007] = {
    [sym_assignment] = STATE(4522),
    [sym_unary] = STATE(4522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4522),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4522),
    [sym_conditional] = STATE(4522),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4522),
    [sym_binary] = STATE(4522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2008] = {
    [sym_assignment] = STATE(4523),
    [sym_unary] = STATE(4523),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4523),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4523),
    [sym_conditional] = STATE(4523),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4523),
    [sym_binary] = STATE(4523),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2009] = {
    [sym_assignment] = STATE(4524),
    [sym_unary] = STATE(4524),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4524),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4524),
    [sym_conditional] = STATE(4524),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4524),
    [sym_binary] = STATE(4524),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2010] = {
    [sym_assignment] = STATE(4525),
    [sym_unary] = STATE(4525),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4525),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4525),
    [sym_conditional] = STATE(4525),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4525),
    [sym_binary] = STATE(4525),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2011] = {
    [sym_assignment] = STATE(4526),
    [sym_unary] = STATE(4526),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4526),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4526),
    [sym_conditional] = STATE(4526),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4526),
    [sym_binary] = STATE(4526),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2012] = {
    [sym_assignment] = STATE(4527),
    [sym_unary] = STATE(4527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4527),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(4527),
    [sym_conditional] = STATE(4527),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(4527),
    [sym_binary] = STATE(4527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2013] = {
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym_string] = STATE(4528),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [2014] = {
    [sym__line_break] = ACTIONS(7589),
    [anon_sym_then] = ACTIONS(7589),
    [anon_sym_until] = ACTIONS(7589),
    [anon_sym___END__] = ACTIONS(7589),
    [anon_sym_while] = ACTIONS(7589),
    [sym__heredoc_body_start] = ACTIONS(7589),
    [anon_sym_end] = ACTIONS(7589),
    [anon_sym_ensure] = ACTIONS(7589),
    [anon_sym_RPAREN] = ACTIONS(7589),
    [anon_sym_SEMI] = ACTIONS(7589),
    [anon_sym_else] = ACTIONS(7589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(7589),
    [anon_sym_elsif] = ACTIONS(7589),
    [anon_sym_unless] = ACTIONS(7589),
    [ts_builtin_sym_end] = ACTIONS(7589),
    [anon_sym_rescue] = ACTIONS(7589),
    [anon_sym_when] = ACTIONS(7589),
    [anon_sym_if] = ACTIONS(7589),
  },
  [2015] = {
    [sym_heredoc_body] = STATE(1978),
    [sym__terminator] = STATE(1978),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [sym__line_break] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(3538),
    [anon_sym_until] = ACTIONS(3540),
    [anon_sym_while] = ACTIONS(3542),
    [sym__heredoc_body_start] = ACTIONS(3544),
    [anon_sym_rescue] = ACTIONS(3546),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(3548),
    [sym_comment] = ACTIONS(49),
  },
  [2016] = {
    [sym__statement] = STATE(4529),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(4529),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(4529),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(4529),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(2016),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(4529),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(4529),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(4529),
    [sym_if_modifier] = STATE(4529),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(4529),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(4529),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(2016),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(7591),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [2017] = {
    [aux_sym_undef_repeat1] = STATE(4530),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_then] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [2018] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [2019] = {
    [aux_sym_chained_string_repeat1] = STATE(2071),
    [sym_string] = STATE(2071),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2020] = {
    [sym_assignment] = STATE(4531),
    [sym_unary] = STATE(4531),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4531),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(4531),
    [sym_conditional] = STATE(4531),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(4531),
    [sym_binary] = STATE(4531),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2021] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [2022] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_then] = ACTIONS(2053),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2023] = {
    [sym_assignment] = STATE(4532),
    [sym_unary] = STATE(4532),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4532),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(4532),
    [sym_conditional] = STATE(4532),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(4532),
    [sym_binary] = STATE(4532),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2024] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(7594),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2025] = {
    [anon_sym_COLON] = ACTIONS(7596),
    [sym_comment] = ACTIONS(49),
  },
  [2026] = {
    [sym_assignment] = STATE(4535),
    [sym_unary] = STATE(4535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4535),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4535),
    [sym_conditional] = STATE(4535),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4535),
    [sym_binary] = STATE(4535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2027] = {
    [sym_assignment] = STATE(4536),
    [sym_unary] = STATE(4536),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4536),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4536),
    [sym_conditional] = STATE(4536),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4536),
    [sym_binary] = STATE(4536),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2028] = {
    [sym_assignment] = STATE(4537),
    [sym_unary] = STATE(4537),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4537),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4537),
    [sym_conditional] = STATE(4537),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4537),
    [sym_binary] = STATE(4537),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2029] = {
    [sym_heredoc_body] = STATE(4539),
    [aux_sym_call_repeat1] = STATE(4539),
    [aux_sym_argument_list_repeat1] = STATE(4540),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7598),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [2030] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [2031] = {
    [aux_sym_chained_string_repeat1] = STATE(2071),
    [sym_string] = STATE(2071),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7600),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2032] = {
    [sym_heredoc_body] = STATE(4539),
    [aux_sym_call_repeat1] = STATE(4539),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [2033] = {
    [sym__argument] = STATE(4541),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(4541),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(4541),
    [sym_hash_splat_argument] = STATE(4541),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(4542),
    [sym_block_argument] = STATE(4541),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [2034] = {
    [sym__argument] = STATE(4541),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(4541),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(4541),
    [sym_hash_splat_argument] = STATE(4541),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(4542),
    [sym_block_argument] = STATE(4541),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [2035] = {
    [sym_assignment] = STATE(4543),
    [sym_unary] = STATE(4543),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4543),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(4543),
    [sym_conditional] = STATE(4543),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(4543),
    [sym_binary] = STATE(4543),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2036] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2037] = {
    [sym__argument] = STATE(4541),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(4541),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(4541),
    [sym_hash_splat_argument] = STATE(4541),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(4542),
    [sym_block_argument] = STATE(4541),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [2038] = {
    [sym_assignment] = STATE(4544),
    [sym_unary] = STATE(4544),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4544),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(4544),
    [sym_conditional] = STATE(4544),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(4544),
    [sym_binary] = STATE(4544),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2039] = {
    [sym__argument] = STATE(4541),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(4541),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(4541),
    [sym_hash_splat_argument] = STATE(4541),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym__argument_list_with_parens] = STATE(4542),
    [sym_block_argument] = STATE(4541),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(1095),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(1097),
    [sym_self] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1119),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(1129),
  },
  [2040] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7602),
    [anon_sym_GT_GT_EQ] = ACTIONS(7602),
    [anon_sym_SLASH_EQ] = ACTIONS(7602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7602),
    [anon_sym_LT_LT_EQ] = ACTIONS(7602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7602),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(7602),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7604),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(7602),
    [anon_sym_PLUS_EQ] = ACTIONS(7602),
    [anon_sym_STAR_EQ] = ACTIONS(7602),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7602),
    [anon_sym_DASH_EQ] = ACTIONS(7602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7602),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2041] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [2042] = {
    [anon_sym_EQ] = ACTIONS(7632),
    [sym_comment] = ACTIONS(3),
  },
  [2043] = {
    [aux_sym_chained_string_repeat1] = STATE(4556),
    [sym_string] = STATE(4556),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2044] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [2045] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [2046] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_heredoc_body] = STATE(4557),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym_float] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(1099),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(1107),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7634),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2047] = {
    [sym_heredoc_body] = STATE(4558),
    [aux_sym_call_repeat1] = STATE(4558),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [2048] = {
    [sym_heredoc_body] = STATE(4559),
    [aux_sym_call_repeat1] = STATE(4559),
    [aux_sym_argument_list_repeat1] = STATE(4560),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [2049] = {
    [sym_assignment] = STATE(4561),
    [sym_unary] = STATE(4561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4561),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4561),
    [sym_conditional] = STATE(4561),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4561),
    [sym_binary] = STATE(4561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2050] = {
    [sym_assignment] = STATE(4562),
    [sym_unary] = STATE(4562),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4562),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(4563),
    [sym_operator_assignment] = STATE(4562),
    [sym_conditional] = STATE(4562),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_subshell] = STATE(584),
    [sym__arg_or_splat_arg] = STATE(4563),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_true] = STATE(582),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4562),
    [sym_binary] = STATE(4562),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1099),
    [sym_character] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2051] = {
    [sym_assignment] = STATE(4564),
    [sym_unary] = STATE(4564),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4564),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4564),
    [sym_conditional] = STATE(4564),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4564),
    [sym_binary] = STATE(4564),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2052] = {
    [sym_assignment] = STATE(4565),
    [sym_unary] = STATE(4565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4565),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4565),
    [sym_conditional] = STATE(4565),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4565),
    [sym_binary] = STATE(4565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2053] = {
    [sym_assignment] = STATE(4566),
    [sym_unary] = STATE(4566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4566),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4566),
    [sym_conditional] = STATE(4566),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4566),
    [sym_binary] = STATE(4566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2054] = {
    [sym_assignment] = STATE(4567),
    [sym_unary] = STATE(4567),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4567),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4567),
    [sym_conditional] = STATE(4567),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4567),
    [sym_binary] = STATE(4567),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2055] = {
    [sym_assignment] = STATE(4568),
    [sym_unary] = STATE(4568),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4568),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4568),
    [sym_conditional] = STATE(4568),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4568),
    [sym_binary] = STATE(4568),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2056] = {
    [sym_assignment] = STATE(4569),
    [sym_unary] = STATE(4569),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4569),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4569),
    [sym_conditional] = STATE(4569),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4569),
    [sym_binary] = STATE(4569),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2057] = {
    [sym_assignment] = STATE(4571),
    [sym_unary] = STATE(4571),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4571),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4571),
    [sym_conditional] = STATE(4571),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4571),
    [sym_binary] = STATE(4571),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2058] = {
    [sym_assignment] = STATE(4572),
    [sym_unary] = STATE(4572),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4572),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4572),
    [sym_conditional] = STATE(4572),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4572),
    [sym_binary] = STATE(4572),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2059] = {
    [sym_assignment] = STATE(4573),
    [sym_unary] = STATE(4573),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4573),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(4573),
    [sym_conditional] = STATE(4573),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4573),
    [sym_binary] = STATE(4573),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [2060] = {
    [sym_heredoc_body] = STATE(4578),
    [sym__argument_list_with_parens] = STATE(4577),
    [aux_sym_call_repeat1] = STATE(4578),
    [sym_argument_list_with_parens] = STATE(4576),
    [sym_operator] = STATE(4576),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_SLASH] = ACTIONS(7638),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7638),
    [anon_sym_PLUS_AT] = ACTIONS(7638),
    [anon_sym_LPAREN2] = ACTIONS(7640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7638),
    [anon_sym_GT_GT] = ACTIONS(7638),
    [anon_sym_EQ_TILDE] = ACTIONS(7638),
    [anon_sym_LT_LT] = ACTIONS(7638),
    [anon_sym_TILDE] = ACTIONS(7638),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_AMP] = ACTIONS(7638),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_PERCENT] = ACTIONS(7638),
    [anon_sym_DASH_AT] = ACTIONS(7638),
    [anon_sym_EQ_EQ] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_BANG_TILDE] = ACTIONS(7638),
    [sym_constant] = ACTIONS(7642),
    [anon_sym_DASH] = ACTIONS(7636),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7638),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7636),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7638),
    [anon_sym_STAR_STAR] = ACTIONS(7638),
    [anon_sym_PIPE] = ACTIONS(7638),
    [anon_sym_DOT_DOT] = ACTIONS(7638),
    [anon_sym_LT_EQ_GT] = ACTIONS(7638),
    [anon_sym_LT_EQ] = ACTIONS(7636),
    [anon_sym_BANG] = ACTIONS(7636),
    [sym_identifier] = ACTIONS(7642),
    [anon_sym_CARET] = ACTIONS(7638),
  },
  [2061] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7644),
    [sym_identifier] = ACTIONS(7644),
  },
  [2062] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(7646),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2063] = {
    [anon_sym_COLON] = ACTIONS(7648),
    [sym_comment] = ACTIONS(49),
  },
  [2064] = {
    [sym_assignment] = STATE(4582),
    [sym_unary] = STATE(4582),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4582),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4582),
    [sym_conditional] = STATE(4582),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4582),
    [sym_binary] = STATE(4582),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2065] = {
    [sym_assignment] = STATE(4583),
    [sym_unary] = STATE(4583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4583),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4583),
    [sym_conditional] = STATE(4583),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4583),
    [sym_binary] = STATE(4583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2066] = {
    [sym_assignment] = STATE(4584),
    [sym_unary] = STATE(4584),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4584),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4584),
    [sym_conditional] = STATE(4584),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4584),
    [sym_binary] = STATE(4584),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2067] = {
    [sym_heredoc_body] = STATE(4586),
    [aux_sym_call_repeat1] = STATE(4586),
    [aux_sym_argument_list_repeat1] = STATE(4587),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7650),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2068] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [2069] = {
    [aux_sym_chained_string_repeat1] = STATE(2149),
    [sym_string] = STATE(2149),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(7652),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2070] = {
    [sym_heredoc_body] = STATE(4586),
    [aux_sym_call_repeat1] = STATE(4586),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2071] = {
    [aux_sym_chained_string_repeat1] = STATE(4588),
    [sym_string] = STATE(4588),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [2072] = {
    [sym__method_name] = STATE(4589),
    [sym_setter] = STATE(4589),
    [sym_symbol] = STATE(4589),
    [sym_operator] = STATE(4589),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(7654),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(7654),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(7654),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(7654),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [2073] = {
    [sym_assignment] = STATE(4590),
    [sym_unary] = STATE(4590),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(4590),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(4590),
    [sym_conditional] = STATE(4590),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(4590),
    [sym_binary] = STATE(4590),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2074] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2075] = {
    [sym_assignment] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2076] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7656),
    [sym_identifier] = ACTIONS(7656),
  },
  [2077] = {
    [sym__argument] = STATE(4606),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(4606),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(4606),
    [sym_hash_splat_argument] = STATE(4606),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(4613),
    [sym_block_argument] = STATE(4606),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [2078] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [2079] = {
    [sym__argument] = STATE(4606),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(4606),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(4606),
    [sym_hash_splat_argument] = STATE(4606),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(4613),
    [sym_block_argument] = STATE(4606),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [2080] = {
    [sym__argument] = STATE(4606),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(4606),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(4606),
    [sym_hash_splat_argument] = STATE(4606),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(4613),
    [sym_block_argument] = STATE(4606),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [2081] = {
    [sym__argument] = STATE(4606),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(4606),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(4606),
    [sym_hash_splat_argument] = STATE(4606),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(4613),
    [sym_block_argument] = STATE(4606),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [2082] = {
    [sym_heredoc_body] = STATE(4620),
    [sym__terminator] = STATE(4620),
    [sym__line_break] = ACTIONS(7694),
    [anon_sym_unless] = ACTIONS(7696),
    [anon_sym_until] = ACTIONS(7698),
    [anon_sym_while] = ACTIONS(7700),
    [sym__heredoc_body_start] = ACTIONS(7702),
    [anon_sym_rescue] = ACTIONS(7704),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(7694),
    [anon_sym_if] = ACTIONS(7706),
    [sym_comment] = ACTIONS(49),
  },
  [2083] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(7708),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(7710),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7712),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [2084] = {
    [anon_sym_EQ] = ACTIONS(7714),
    [sym_comment] = ACTIONS(3),
  },
  [2085] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym__primary] = STATE(4636),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_method] = STATE(4636),
    [sym_conditional] = STATE(4641),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_subshell] = STATE(4636),
    [sym_unless] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4640),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_call] = STATE(4638),
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_rational] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_lambda] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(4641),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_nil] = STATE(4640),
    [sym_symbol_array] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_scope_resolution] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [2086] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7750),
    [anon_sym_GT_GT_EQ] = ACTIONS(7750),
    [anon_sym_SLASH_EQ] = ACTIONS(7750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7750),
    [anon_sym_LT_LT_EQ] = ACTIONS(7750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7750),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(7750),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7752),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(7750),
    [anon_sym_PLUS_EQ] = ACTIONS(7750),
    [anon_sym_STAR_EQ] = ACTIONS(7750),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7750),
    [anon_sym_DASH_EQ] = ACTIONS(7750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7750),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2087] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [2088] = {
    [aux_sym_chained_string_repeat1] = STATE(4655),
    [sym_string] = STATE(4655),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2089] = {
    [anon_sym_elsif] = ACTIONS(7782),
    [anon_sym_rescue] = ACTIONS(7782),
    [anon_sym_end] = ACTIONS(7782),
    [anon_sym_ensure] = ACTIONS(7782),
    [anon_sym_else] = ACTIONS(7782),
    [anon_sym_when] = ACTIONS(7782),
    [sym_comment] = ACTIONS(49),
  },
  [2090] = {
    [sym__statement] = STATE(4656),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(4656),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(4656),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(4656),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(4657),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(4656),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(4656),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(4656),
    [sym_if_modifier] = STATE(4656),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(4656),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(4656),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [aux_sym__statements_repeat1] = STATE(4657),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2091] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_then] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [2092] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_then] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [2093] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_then] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [2094] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [2095] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(7784),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [2096] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_then] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [2097] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_then] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1217),
    [sym__binary_minus] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
  },
  [2098] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(4659),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(7786),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(7786),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2099] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [sym__line_break] = ACTIONS(7790),
    [anon_sym_then] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_when] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym___END__] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7790),
    [anon_sym_ensure] = ACTIONS(7790),
    [anon_sym_else] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_elsif] = ACTIONS(7790),
    [ts_builtin_sym_end] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [sym__binary_minus] = ACTIONS(7790),
  },
  [2100] = {
    [anon_sym_end] = ACTIONS(7792),
    [sym_comment] = ACTIONS(49),
  },
  [2101] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_then] = ACTIONS(1327),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [2102] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(4662),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(7794),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2103] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_then] = ACTIONS(6719),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [2104] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_then] = ACTIONS(6727),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [2105] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(2104),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(4663),
    [sym_operator] = STATE(4663),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_SLASH] = ACTIONS(3760),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3760),
    [anon_sym_PLUS_AT] = ACTIONS(3760),
    [anon_sym_LPAREN2] = ACTIONS(3762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3760),
    [anon_sym_GT_GT] = ACTIONS(3760),
    [anon_sym_EQ_TILDE] = ACTIONS(3760),
    [anon_sym_LT_LT] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3758),
    [anon_sym_AMP] = ACTIONS(3760),
    [anon_sym_GT] = ACTIONS(3758),
    [anon_sym_PERCENT] = ACTIONS(3760),
    [anon_sym_DASH_AT] = ACTIONS(3760),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_STAR] = ACTIONS(3758),
    [anon_sym_BANG_TILDE] = ACTIONS(3760),
    [sym_constant] = ACTIONS(7796),
    [anon_sym_DASH] = ACTIONS(3758),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(3760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3758),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3760),
    [anon_sym_STAR_STAR] = ACTIONS(3760),
    [anon_sym_PIPE] = ACTIONS(3760),
    [anon_sym_DOT_DOT] = ACTIONS(3760),
    [anon_sym_LT_EQ_GT] = ACTIONS(3760),
    [anon_sym_LT_EQ] = ACTIONS(3758),
    [anon_sym_BANG] = ACTIONS(3758),
    [sym_identifier] = ACTIONS(7796),
    [anon_sym_CARET] = ACTIONS(3760),
  },
  [2106] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [2107] = {
    [sym_assignment] = STATE(4664),
    [sym_unary] = STATE(4664),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4664),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(4664),
    [sym_conditional] = STATE(4664),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(4664),
    [sym_binary] = STATE(4664),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2108] = {
    [sym_assignment] = STATE(4665),
    [sym_unary] = STATE(4665),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4665),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(4665),
    [sym_conditional] = STATE(4665),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(4665),
    [sym_binary] = STATE(4665),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2109] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2110] = {
    [sym_assignment] = STATE(4666),
    [sym_unary] = STATE(4666),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(4666),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(4666),
    [sym_conditional] = STATE(4666),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(4666),
    [sym_binary] = STATE(4666),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [2111] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7798),
    [anon_sym_GT_GT_EQ] = ACTIONS(7798),
    [anon_sym_SLASH_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7798),
    [anon_sym_LT_LT_EQ] = ACTIONS(7798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7798),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(7798),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7800),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(7798),
    [anon_sym_PLUS_EQ] = ACTIONS(7798),
    [anon_sym_STAR_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7798),
    [anon_sym_DASH_EQ] = ACTIONS(7798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7798),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2112] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [2113] = {
    [anon_sym_EQ] = ACTIONS(7828),
    [sym_comment] = ACTIONS(3),
  },
  [2114] = {
    [aux_sym_exceptions_repeat1] = STATE(4679),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(7830),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [2115] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [2116] = {
    [aux_sym_chained_string_repeat1] = STATE(2149),
    [sym_string] = STATE(2149),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2117] = {
    [sym_assignment] = STATE(4680),
    [sym_unary] = STATE(4680),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(4680),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(4680),
    [sym_conditional] = STATE(4680),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(4680),
    [sym_binary] = STATE(4680),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [2118] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [2119] = {
    [sym_assignment] = STATE(4681),
    [sym_unary] = STATE(4681),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(4681),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(4681),
    [sym_conditional] = STATE(4681),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(4681),
    [sym_binary] = STATE(4681),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [2120] = {
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_hash_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [2121] = {
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_hash_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [2122] = {
    [sym_assignment] = STATE(4682),
    [sym_unary] = STATE(4682),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(4682),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(4682),
    [sym_conditional] = STATE(4682),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(4682),
    [sym_binary] = STATE(4682),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [2123] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [2124] = {
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_hash_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [2125] = {
    [sym_assignment] = STATE(4683),
    [sym_unary] = STATE(4683),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(4683),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(4683),
    [sym_conditional] = STATE(4683),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(4683),
    [sym_binary] = STATE(4683),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [2126] = {
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_hash_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [2127] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7832),
    [anon_sym_GT_GT_EQ] = ACTIONS(7832),
    [anon_sym_SLASH_EQ] = ACTIONS(7832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7832),
    [anon_sym_LT_LT_EQ] = ACTIONS(7832),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7832),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(7832),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7834),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(7832),
    [anon_sym_PLUS_EQ] = ACTIONS(7832),
    [anon_sym_STAR_EQ] = ACTIONS(7832),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7832),
    [anon_sym_DASH_EQ] = ACTIONS(7832),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7832),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2128] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [2129] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(1147),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(1151),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [2130] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_for] = STATE(613),
    [sym_if] = STATE(613),
    [sym__primary] = STATE(613),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(616),
    [sym_method] = STATE(613),
    [sym_conditional] = STATE(618),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_true] = STATE(617),
    [sym_subshell] = STATE(613),
    [sym_unless] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_block_argument] = STATE(616),
    [sym_range] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(617),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_array] = STATE(613),
    [sym_call] = STATE(615),
    [sym__argument] = STATE(616),
    [sym_assignment] = STATE(618),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_pair] = STATE(616),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(616),
    [sym_operator_assignment] = STATE(618),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_rational] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_lambda] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym__argument_list_with_parens] = STATE(620),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(618),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_nil] = STATE(617),
    [sym_symbol_array] = STATE(613),
    [sym_case] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_scope_resolution] = STATE(615),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(1155),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1159),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1111),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1177),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(1187),
  },
  [2131] = {
    [anon_sym_EQ] = ACTIONS(7864),
    [sym_comment] = ACTIONS(3),
  },
  [2132] = {
    [aux_sym_chained_string_repeat1] = STATE(4695),
    [sym_string] = STATE(4695),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2133] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [2134] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [2135] = {
    [sym_assignment] = STATE(4696),
    [sym_unary] = STATE(4696),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4696),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(4697),
    [sym_operator_assignment] = STATE(4696),
    [sym_conditional] = STATE(4696),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_subshell] = STATE(613),
    [sym__arg_or_splat_arg] = STATE(4697),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_true] = STATE(617),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4696),
    [sym_binary] = STATE(4696),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1159),
    [sym_character] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2136] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_heredoc_body] = STATE(4698),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym_float] = ACTIONS(1155),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1159),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1159),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1167),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [sym_class_variable] = ACTIONS(1167),
    [sym__block_ampersand] = ACTIONS(1175),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1177),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7866),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2137] = {
    [sym_heredoc_body] = STATE(4699),
    [aux_sym_call_repeat1] = STATE(4699),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2138] = {
    [sym_heredoc_body] = STATE(4700),
    [aux_sym_call_repeat1] = STATE(4700),
    [aux_sym_argument_list_repeat1] = STATE(4701),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2139] = {
    [sym_assignment] = STATE(4702),
    [sym_unary] = STATE(4702),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4702),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4702),
    [sym_conditional] = STATE(4702),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4702),
    [sym_binary] = STATE(4702),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2140] = {
    [sym_assignment] = STATE(4703),
    [sym_unary] = STATE(4703),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4703),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4703),
    [sym_conditional] = STATE(4703),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4703),
    [sym_binary] = STATE(4703),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2141] = {
    [sym_assignment] = STATE(4704),
    [sym_unary] = STATE(4704),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4704),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4704),
    [sym_conditional] = STATE(4704),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4704),
    [sym_binary] = STATE(4704),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2142] = {
    [sym_assignment] = STATE(4705),
    [sym_unary] = STATE(4705),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4705),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4705),
    [sym_conditional] = STATE(4705),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4705),
    [sym_binary] = STATE(4705),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2143] = {
    [sym_assignment] = STATE(4706),
    [sym_unary] = STATE(4706),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4706),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4706),
    [sym_conditional] = STATE(4706),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4706),
    [sym_binary] = STATE(4706),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2144] = {
    [sym_assignment] = STATE(4707),
    [sym_unary] = STATE(4707),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4707),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4707),
    [sym_conditional] = STATE(4707),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4707),
    [sym_binary] = STATE(4707),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2145] = {
    [sym_assignment] = STATE(4708),
    [sym_unary] = STATE(4708),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4708),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4708),
    [sym_conditional] = STATE(4708),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4708),
    [sym_binary] = STATE(4708),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2146] = {
    [sym_assignment] = STATE(4710),
    [sym_unary] = STATE(4710),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4710),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4710),
    [sym_conditional] = STATE(4710),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4710),
    [sym_binary] = STATE(4710),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2147] = {
    [sym_assignment] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2148] = {
    [sym_assignment] = STATE(4712),
    [sym_unary] = STATE(4712),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4712),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(4712),
    [sym_conditional] = STATE(4712),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4712),
    [sym_binary] = STATE(4712),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [2149] = {
    [aux_sym_chained_string_repeat1] = STATE(4713),
    [sym_string] = STATE(4713),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [2150] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2151] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2152] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2153] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2154] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [2155] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(7868),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [2156] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2157] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2158] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [2159] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2160] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [2161] = {
    [aux_sym_chained_string_repeat1] = STATE(2161),
    [sym_string] = STATE(2161),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [2162] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [sym__line_break] = ACTIONS(7872),
    [anon_sym_then] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_when] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym___END__] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_end] = ACTIONS(7872),
    [anon_sym_ensure] = ACTIONS(7872),
    [anon_sym_else] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_elsif] = ACTIONS(7872),
    [ts_builtin_sym_end] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
    [sym__binary_minus] = ACTIONS(7872),
  },
  [2163] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(7874),
  },
  [2164] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [sym__line_break] = ACTIONS(7878),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [ts_builtin_sym_end] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
    [sym__binary_minus] = ACTIONS(7878),
  },
  [2165] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(7880),
    [sym__string_end] = ACTIONS(7874),
  },
  [2166] = {
    [sym__terminator] = STATE(4717),
    [sym_heredoc_body] = STATE(4717),
    [sym__do] = STATE(4717),
    [sym__line_break] = ACTIONS(7882),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7882),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2167] = {
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [sym_comment] = ACTIONS(49),
  },
  [2168] = {
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_unless] = ACTIONS(1049),
    [anon_sym_until] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_rescue] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(7884),
    [sym_comment] = ACTIONS(3),
  },
  [2169] = {
    [aux_sym_undef_repeat1] = STATE(4720),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(7886),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [2170] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4722),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2171] = {
    [sym__terminator] = STATE(4723),
    [sym_heredoc_body] = STATE(4723),
    [sym_then] = STATE(4724),
    [sym__line_break] = ACTIONS(7890),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(7890),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2172] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [2173] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [2174] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_COLON2] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [sym__binary_minus] = ACTIONS(1227),
  },
  [2175] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4727),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(7892),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(7894),
  },
  [2176] = {
    [aux_sym_symbol_array_repeat1] = STATE(4730),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(7896),
    [sym__string_end] = ACTIONS(7898),
  },
  [2177] = {
    [sym__method_name] = STATE(4731),
    [sym_setter] = STATE(4731),
    [sym_symbol] = STATE(4731),
    [sym_operator] = STATE(4731),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(3862),
    [sym_class_variable] = ACTIONS(7900),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3862),
    [anon_sym_PLUS_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3862),
    [anon_sym_GT_GT] = ACTIONS(3862),
    [anon_sym_EQ_TILDE] = ACTIONS(3862),
    [anon_sym_LT_LT] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_global_variable] = ACTIONS(7900),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3862),
    [sym__simple_symbol] = ACTIONS(433),
    [anon_sym_DASH_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_BANG_TILDE] = ACTIONS(3862),
    [sym_constant] = ACTIONS(7900),
    [anon_sym_DASH] = ACTIONS(3860),
    [sym_instance_variable] = ACTIONS(7900),
    [anon_sym_GT_EQ] = ACTIONS(3862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3860),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3862),
    [anon_sym_STAR_STAR] = ACTIONS(3862),
    [anon_sym_PIPE] = ACTIONS(3862),
    [anon_sym_DOT_DOT] = ACTIONS(3862),
    [anon_sym_LT_EQ_GT] = ACTIONS(3862),
    [anon_sym_LT_EQ] = ACTIONS(3860),
    [anon_sym_BANG] = ACTIONS(3860),
    [sym_identifier] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3862),
    [sym__symbol_start] = ACTIONS(461),
  },
  [2178] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_COLON2] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [sym__binary_minus] = ACTIONS(1339),
  },
  [2179] = {
    [anon_sym_RBRACK] = ACTIONS(7902),
    [sym_comment] = ACTIONS(49),
  },
  [2180] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [sym__binary_minus] = ACTIONS(1635),
  },
  [2181] = {
    [sym_heredoc_body] = STATE(4734),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(7904),
    [sym_comment] = ACTIONS(49),
  },
  [2182] = {
    [anon_sym_RBRACE] = ACTIONS(7904),
    [sym_comment] = ACTIONS(49),
  },
  [2183] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4736),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(7906),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2184] = {
    [sym__terminator] = STATE(4737),
    [sym_heredoc_body] = STATE(4737),
    [sym__do] = STATE(4737),
    [sym__line_break] = ACTIONS(7908),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(7908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2185] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [2186] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_while] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [sym__binary_minus] = ACTIONS(1853),
  },
  [2187] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(7910),
  },
  [2188] = {
    [sym_in] = STATE(4739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [2189] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(4741),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(4742),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(4742),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4743),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(7912),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(7912),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(7914),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2190] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(4745),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4746),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(7916),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2191] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_COLON2] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [sym__binary_minus] = ACTIONS(2045),
  },
  [2192] = {
    [sym_do_block] = STATE(4747),
    [sym_block] = STATE(4747),
    [anon_sym_do] = ACTIONS(7918),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(3886),
  },
  [2193] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2194] = {
    [sym_assignment] = STATE(4748),
    [sym_unary] = STATE(4748),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(4748),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(4748),
    [sym_conditional] = STATE(4748),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(4748),
    [sym_binary] = STATE(4748),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [2195] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(4749),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(4749),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(4749),
    [sym__line_break] = ACTIONS(7920),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(7920),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [2196] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_COLON2] = ACTIONS(2101),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [sym__binary_minus] = ACTIONS(2103),
  },
  [2197] = {
    [anon_sym_DOT] = ACTIONS(7922),
    [anon_sym_COLON_COLON] = ACTIONS(7922),
    [sym_comment] = ACTIONS(49),
  },
  [2198] = {
    [sym_assignment] = STATE(4751),
    [sym_unary] = STATE(4751),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4751),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(4751),
    [sym_conditional] = STATE(4751),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(4751),
    [sym_binary] = STATE(4751),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [2199] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [2200] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(7928),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2201] = {
    [sym_assignment] = STATE(4754),
    [sym_unary] = STATE(4754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4754),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(4754),
    [sym_conditional] = STATE(4754),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(4754),
    [sym_binary] = STATE(4754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [2202] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(7930),
    [sym_identifier] = ACTIONS(7930),
  },
  [2203] = {
    [anon_sym_COLON] = ACTIONS(7932),
    [sym_comment] = ACTIONS(49),
  },
  [2204] = {
    [sym__argument] = STATE(4762),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(4762),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(4762),
    [sym_hash_splat_argument] = STATE(4762),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(4765),
    [sym_block_argument] = STATE(4762),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(501),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [2205] = {
    [sym_assignment] = STATE(4775),
    [sym_unary] = STATE(4775),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(4775),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(4775),
    [sym_conditional] = STATE(4775),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(4775),
    [sym_binary] = STATE(4775),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [2206] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(4781),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2207] = {
    [sym_assignment] = STATE(4782),
    [sym_unary] = STATE(4782),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(4782),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(4782),
    [sym_conditional] = STATE(4782),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(4782),
    [sym_binary] = STATE(4782),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [2208] = {
    [sym__argument] = STATE(4762),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(4762),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(4762),
    [sym_hash_splat_argument] = STATE(4762),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(4765),
    [sym_block_argument] = STATE(4762),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(647),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [2209] = {
    [sym__argument] = STATE(4762),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(4762),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(4762),
    [sym_hash_splat_argument] = STATE(4762),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(4765),
    [sym_block_argument] = STATE(4762),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(737),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [2210] = {
    [sym_assignment] = STATE(4783),
    [sym_unary] = STATE(4783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(4783),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(4783),
    [sym_conditional] = STATE(4783),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(4783),
    [sym_binary] = STATE(4783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [2211] = {
    [sym__argument] = STATE(4762),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(4762),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(4762),
    [sym_hash_splat_argument] = STATE(4762),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(4765),
    [sym_block_argument] = STATE(4762),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(753),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [2212] = {
    [sym_heredoc_body] = STATE(4786),
    [aux_sym_call_repeat1] = STATE(4786),
    [aux_sym_argument_list_repeat1] = STATE(4787),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [2213] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(7976),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(7978),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(7978),
    [anon_sym_SLASH_EQ] = ACTIONS(7978),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(7978),
    [anon_sym_PIPE_EQ] = ACTIONS(7978),
    [anon_sym_LT_LT_EQ] = ACTIONS(7978),
    [anon_sym_PLUS_EQ] = ACTIONS(7978),
    [anon_sym_STAR_EQ] = ACTIONS(7978),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7978),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7978),
    [anon_sym_CARET_EQ] = ACTIONS(7978),
    [anon_sym_DASH_EQ] = ACTIONS(7978),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7978),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2214] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_EQ_GT] = ACTIONS(7932),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [2215] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(8006),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(8008),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8010),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [2216] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym__primary] = STATE(2276),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_method] = STATE(2276),
    [sym_conditional] = STATE(4807),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_subshell] = STATE(2276),
    [sym_unless] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2281),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_call] = STATE(2279),
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_rational] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_lambda] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(4807),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_nil] = STATE(2281),
    [sym_symbol_array] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_scope_resolution] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2217] = {
    [anon_sym_EQ] = ACTIONS(8020),
    [sym_comment] = ACTIONS(3),
  },
  [2218] = {
    [aux_sym_chained_string_repeat1] = STATE(4810),
    [sym_string] = STATE(4810),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8022),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [2219] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_COLON2] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [sym__binary_minus] = ACTIONS(2301),
  },
  [2220] = {
    [sym_heredoc_body] = STATE(4786),
    [aux_sym_call_repeat1] = STATE(4786),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [2221] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_COLON2] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [sym__binary_minus] = ACTIONS(2305),
  },
  [2222] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8024),
  },
  [2223] = {
    [sym_heredoc_body] = STATE(4812),
    [sym__terminator] = STATE(4812),
    [sym__line_break] = ACTIONS(8026),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2224] = {
    [sym_when] = STATE(4815),
    [sym_else] = STATE(4814),
    [aux_sym_case_repeat2] = STATE(4815),
    [aux_sym_case_repeat1] = STATE(4816),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8028),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8030),
    [sym_comment] = ACTIONS(49),
  },
  [2225] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_COLON2] = ACTIONS(2385),
    [anon_sym_while] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [sym__binary_minus] = ACTIONS(2387),
  },
  [2226] = {
    [anon_sym_RPAREN] = ACTIONS(8032),
    [sym_comment] = ACTIONS(49),
  },
  [2227] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_COLON2] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [sym__binary_minus] = ACTIONS(2533),
  },
  [2228] = {
    [sym_assignment] = STATE(4818),
    [sym_unary] = STATE(4818),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(4818),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(4818),
    [sym_conditional] = STATE(4818),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(4818),
    [sym_binary] = STATE(4818),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [2229] = {
    [sym_heredoc_body] = STATE(4819),
    [sym__terminator] = STATE(4819),
    [sym_superclass] = STATE(4820),
    [sym__line_break] = ACTIONS(8034),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8034),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2230] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(4820),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(4819),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(4819),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8034),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8034),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2231] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_COLON2] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [sym__binary_minus] = ACTIONS(2577),
  },
  [2232] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8036),
  },
  [2233] = {
    [sym_heredoc_body] = STATE(4823),
    [sym__terminator] = STATE(4823),
    [sym__line_break] = ACTIONS(8038),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8038),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(8040),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2234] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(4823),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(4823),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8038),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8038),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(8040),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2235] = {
    [anon_sym_end] = ACTIONS(8042),
    [sym_comment] = ACTIONS(49),
  },
  [2236] = {
    [sym_ensure] = STATE(4825),
    [sym_else] = STATE(4826),
    [anon_sym_end] = ACTIONS(8042),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2237] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(4827),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8044),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2238] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_COLON2] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [sym__binary_minus] = ACTIONS(2743),
  },
  [2239] = {
    [sym_ensure] = STATE(4825),
    [sym_else] = STATE(4826),
    [sym_rescue] = STATE(4828),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(8042),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2240] = {
    [sym_ensure] = STATE(4825),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8042),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2241] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_COLON2] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
    [sym__binary_minus] = ACTIONS(2853),
  },
  [2242] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_COLON2] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(2857),
  },
  [2243] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8046),
  },
  [2244] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_COLON2] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [sym__binary_minus] = ACTIONS(2863),
  },
  [2245] = {
    [sym__terminator] = STATE(4830),
    [sym_heredoc_body] = STATE(4830),
    [sym_then] = STATE(4831),
    [sym__line_break] = ACTIONS(8048),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(8048),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2246] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [sym__binary_minus] = ACTIONS(2873),
  },
  [2247] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(4834),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8050),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8052),
  },
  [2248] = {
    [aux_sym_string_array_repeat1] = STATE(4837),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8054),
    [sym__string_end] = ACTIONS(8056),
  },
  [2249] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [sym__binary_minus] = ACTIONS(2885),
  },
  [2250] = {
    [sym__string_end] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8058),
    [anon_sym_POUND_LBRACE] = ACTIONS(8060),
    [sym__string_content] = ACTIONS(8058),
    [sym_escape_sequence] = ACTIONS(8058),
  },
  [2251] = {
    [sym_assignment] = STATE(4838),
    [sym_unary] = STATE(4838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4838),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4838),
    [sym_conditional] = STATE(4838),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4838),
    [sym_binary] = STATE(4838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2252] = {
    [sym_assignment] = STATE(4839),
    [sym_unary] = STATE(4839),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4839),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4839),
    [sym_conditional] = STATE(4839),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4839),
    [sym_binary] = STATE(4839),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2253] = {
    [sym_assignment] = STATE(4840),
    [sym_unary] = STATE(4840),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4840),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4840),
    [sym_conditional] = STATE(4840),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4840),
    [sym_binary] = STATE(4840),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2254] = {
    [sym_assignment] = STATE(4841),
    [sym_unary] = STATE(4841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4841),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4841),
    [sym_conditional] = STATE(4841),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4841),
    [sym_binary] = STATE(4841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2255] = {
    [sym_assignment] = STATE(4842),
    [sym_unary] = STATE(4842),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4842),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4842),
    [sym_conditional] = STATE(4842),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4842),
    [sym_binary] = STATE(4842),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2256] = {
    [sym_heredoc_body] = STATE(4847),
    [sym__argument_list_with_parens] = STATE(4846),
    [aux_sym_call_repeat1] = STATE(4847),
    [sym_argument_list_with_parens] = STATE(4845),
    [sym_operator] = STATE(4845),
    [anon_sym_LT] = ACTIONS(8062),
    [anon_sym_SLASH] = ACTIONS(8064),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8064),
    [anon_sym_PLUS_AT] = ACTIONS(8064),
    [anon_sym_LPAREN2] = ACTIONS(8066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8064),
    [anon_sym_GT_GT] = ACTIONS(8064),
    [anon_sym_EQ_TILDE] = ACTIONS(8064),
    [anon_sym_LT_LT] = ACTIONS(8064),
    [anon_sym_TILDE] = ACTIONS(8064),
    [anon_sym_PLUS] = ACTIONS(8062),
    [anon_sym_AMP] = ACTIONS(8064),
    [anon_sym_GT] = ACTIONS(8062),
    [anon_sym_PERCENT] = ACTIONS(8064),
    [anon_sym_DASH_AT] = ACTIONS(8064),
    [anon_sym_EQ_EQ] = ACTIONS(8062),
    [anon_sym_STAR] = ACTIONS(8062),
    [anon_sym_BANG_TILDE] = ACTIONS(8064),
    [sym_constant] = ACTIONS(8068),
    [anon_sym_DASH] = ACTIONS(8062),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8064),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8062),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8064),
    [anon_sym_STAR_STAR] = ACTIONS(8064),
    [anon_sym_PIPE] = ACTIONS(8064),
    [anon_sym_DOT_DOT] = ACTIONS(8064),
    [anon_sym_LT_EQ_GT] = ACTIONS(8064),
    [anon_sym_LT_EQ] = ACTIONS(8062),
    [anon_sym_BANG] = ACTIONS(8062),
    [sym_identifier] = ACTIONS(8068),
    [anon_sym_CARET] = ACTIONS(8064),
  },
  [2257] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(4849),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(8070),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2258] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8072),
    [sym_identifier] = ACTIONS(8072),
  },
  [2259] = {
    [sym_assignment] = STATE(4861),
    [sym_unary] = STATE(4861),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4861),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_splat_argument] = STATE(4864),
    [sym_operator_assignment] = STATE(4861),
    [sym_conditional] = STATE(4861),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_return] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_subshell] = STATE(674),
    [sym__arg_or_splat_arg] = STATE(4864),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(4861),
    [sym_binary] = STATE(4861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(8080),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(1239),
    [sym_character] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [2260] = {
    [sym_assignment] = STATE(4865),
    [sym_unary] = STATE(4865),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4865),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(4865),
    [sym_conditional] = STATE(4865),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(4865),
    [sym_binary] = STATE(4865),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [2261] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [2262] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(4868),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(4869),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8096),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [2263] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(8098),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2264] = {
    [sym_assignment] = STATE(4871),
    [sym_unary] = STATE(4871),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4871),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(4871),
    [sym_conditional] = STATE(4871),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(4871),
    [sym_binary] = STATE(4871),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [2265] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(4873),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(4874),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(4874),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4875),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8100),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8100),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8102),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2266] = {
    [anon_sym_COLON] = ACTIONS(8104),
    [sym_comment] = ACTIONS(49),
  },
  [2267] = {
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2268] = {
    [sym_assignment] = STATE(4907),
    [sym_unary] = STATE(4907),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(4907),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(4907),
    [sym_conditional] = STATE(4907),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(4907),
    [sym_binary] = STATE(4907),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [2269] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(4913),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2270] = {
    [sym_assignment] = STATE(4914),
    [sym_unary] = STATE(4914),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(4914),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(4914),
    [sym_conditional] = STATE(4914),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(4914),
    [sym_binary] = STATE(4914),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [2271] = {
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2272] = {
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2273] = {
    [sym_assignment] = STATE(4915),
    [sym_unary] = STATE(4915),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(4915),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(4915),
    [sym_conditional] = STATE(4915),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(4915),
    [sym_binary] = STATE(4915),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [2274] = {
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2275] = {
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [2276] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(8006),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(8008),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(8010),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [2277] = {
    [sym_do_block] = STATE(4917),
    [sym_block] = STATE(4917),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8180),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [2278] = {
    [anon_sym_EQ] = ACTIONS(8182),
    [sym_comment] = ACTIONS(3),
  },
  [2279] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym__primary] = STATE(2276),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(4806),
    [sym_method] = STATE(2276),
    [sym_conditional] = STATE(4807),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_subshell] = STATE(2276),
    [sym_unless] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_block_argument] = STATE(4806),
    [sym_range] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2281),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_call] = STATE(2279),
    [sym__argument] = STATE(4806),
    [sym_assignment] = STATE(4807),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_pair] = STATE(4806),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(4806),
    [sym_operator_assignment] = STATE(4807),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_rational] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_lambda] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(4809),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(4807),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_nil] = STATE(2281),
    [sym_symbol_array] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_scope_resolution] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(8012),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [2280] = {
    [sym_heredoc_body] = STATE(4921),
    [aux_sym_call_repeat1] = STATE(4921),
    [aux_sym_argument_list_repeat1] = STATE(4922),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(8186),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2281] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(8188),
    [anon_sym_GT_GT_EQ] = ACTIONS(8188),
    [anon_sym_SLASH_EQ] = ACTIONS(8188),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(8188),
    [anon_sym_LT_LT_EQ] = ACTIONS(8188),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8188),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(8188),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(8188),
    [anon_sym_PLUS_EQ] = ACTIONS(8188),
    [anon_sym_STAR_EQ] = ACTIONS(8188),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8188),
    [anon_sym_DASH_EQ] = ACTIONS(8188),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8188),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2282] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(8104),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [2283] = {
    [aux_sym_chained_string_repeat1] = STATE(4933),
    [sym_string] = STATE(4933),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8220),
    [sym__string_start] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2284] = {
    [sym_heredoc_body] = STATE(4921),
    [aux_sym_call_repeat1] = STATE(4921),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2285] = {
    [sym_assignment] = STATE(4934),
    [sym_unary] = STATE(4934),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4934),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4934),
    [sym_conditional] = STATE(4934),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4934),
    [sym_binary] = STATE(4934),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2286] = {
    [sym_assignment] = STATE(4935),
    [sym_unary] = STATE(4935),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4935),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4935),
    [sym_conditional] = STATE(4935),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4935),
    [sym_binary] = STATE(4935),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2287] = {
    [sym_assignment] = STATE(4936),
    [sym_unary] = STATE(4936),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4936),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4936),
    [sym_conditional] = STATE(4936),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4936),
    [sym_binary] = STATE(4936),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2288] = {
    [sym_assignment] = STATE(4937),
    [sym_unary] = STATE(4937),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4937),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4937),
    [sym_conditional] = STATE(4937),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4937),
    [sym_binary] = STATE(4937),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2289] = {
    [sym_assignment] = STATE(4938),
    [sym_unary] = STATE(4938),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4938),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4938),
    [sym_conditional] = STATE(4938),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4938),
    [sym_binary] = STATE(4938),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2290] = {
    [sym_assignment] = STATE(4939),
    [sym_unary] = STATE(4939),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4939),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4939),
    [sym_conditional] = STATE(4939),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4939),
    [sym_binary] = STATE(4939),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2291] = {
    [sym_assignment] = STATE(4940),
    [sym_unary] = STATE(4940),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4940),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4940),
    [sym_conditional] = STATE(4940),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4940),
    [sym_binary] = STATE(4940),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2292] = {
    [sym_assignment] = STATE(4941),
    [sym_unary] = STATE(4941),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4941),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4941),
    [sym_conditional] = STATE(4941),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4941),
    [sym_binary] = STATE(4941),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2293] = {
    [sym_assignment] = STATE(4942),
    [sym_unary] = STATE(4942),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4942),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4942),
    [sym_conditional] = STATE(4942),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4942),
    [sym_binary] = STATE(4942),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2294] = {
    [sym_assignment] = STATE(4943),
    [sym_unary] = STATE(4943),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4943),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4943),
    [sym_conditional] = STATE(4943),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4943),
    [sym_binary] = STATE(4943),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2295] = {
    [sym_assignment] = STATE(4944),
    [sym_unary] = STATE(4944),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4944),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(4944),
    [sym_conditional] = STATE(4944),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(4944),
    [sym_binary] = STATE(4944),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [2296] = {
    [aux_sym_chained_string_repeat1] = STATE(4945),
    [sym_string] = STATE(4945),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [2297] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [sym__line_break] = ACTIONS(8224),
    [anon_sym_then] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_when] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym___END__] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_end] = ACTIONS(8224),
    [anon_sym_ensure] = ACTIONS(8224),
    [anon_sym_else] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_elsif] = ACTIONS(8224),
    [ts_builtin_sym_end] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
    [sym__binary_minus] = ACTIONS(8224),
  },
  [2298] = {
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8226),
    [sym__string_end] = ACTIONS(8226),
  },
  [2299] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8228),
  },
  [2300] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8230),
    [sym__string_end] = ACTIONS(8233),
  },
  [2301] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [sym__symbol_start] = ACTIONS(5628),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_AT] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(5628),
    [sym_global_variable] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [sym__simple_symbol] = ACTIONS(5628),
    [anon_sym_DASH_AT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [sym_constant] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [sym_instance_variable] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5626),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5628),
    [anon_sym_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_BANG] = ACTIONS(5626),
    [sym_identifier] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [sym_class_variable] = ACTIONS(5628),
  },
  [2302] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4949),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8235),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2303] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(4951),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8237),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2304] = {
    [sym_else] = STATE(4951),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(8239),
    [sym_comment] = ACTIONS(49),
  },
  [2305] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [anon_sym_RBRACK] = ACTIONS(3852),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_EQ_GT] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_COLON2] = ACTIONS(3850),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3850),
  },
  [2306] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8241),
  },
  [2307] = {
    [aux_sym_symbol_array_repeat1] = STATE(4955),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8243),
    [sym__string_end] = ACTIONS(8245),
  },
  [2308] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8247),
  },
  [2309] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_RBRACK] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_COLON2] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4054),
  },
  [2310] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8249),
    [sym__string_end] = ACTIONS(8247),
  },
  [2311] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_RBRACK] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_COLON2] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_EQ] = ACTIONS(4424),
  },
  [2312] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [anon_sym_RBRACK] = ACTIONS(4700),
    [anon_sym_in] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_EQ_GT] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_COLON2] = ACTIONS(4698),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
    [anon_sym_EQ] = ACTIONS(4698),
  },
  [2313] = {
    [anon_sym_RBRACE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(49),
  },
  [2314] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4224),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [2315] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4960),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8255),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2316] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_in] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_COLON] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
  },
  [2317] = {
    [sym__terminator] = STATE(4961),
    [sym_heredoc_body] = STATE(4961),
    [sym__do] = STATE(4961),
    [anon_sym_do] = ACTIONS(8257),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(8257),
    [anon_sym_SEMI] = ACTIONS(8257),
    [sym_comment] = ACTIONS(49),
  },
  [2318] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_in] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5078),
  },
  [2319] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(4963),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(4963),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4964),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8259),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8259),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8261),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2320] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(4965),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(4964),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8261),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2321] = {
    [anon_sym_end] = ACTIONS(8263),
    [sym_comment] = ACTIONS(49),
  },
  [2322] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
  },
  [2323] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4967),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8265),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2324] = {
    [anon_sym_RBRACE] = ACTIONS(8265),
    [sym_comment] = ACTIONS(49),
  },
  [2325] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_COLON2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_EQ] = ACTIONS(5236),
  },
  [2326] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4224),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4224),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_PIPE] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [2327] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(8269),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [2328] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(4969),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8271),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2329] = {
    [sym__method_name] = STATE(714),
    [sym_setter] = STATE(714),
    [sym_symbol] = STATE(714),
    [sym_operator] = STATE(714),
    [sym__method_rest] = STATE(4970),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8273),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8273),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8273),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8273),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [2330] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [2331] = {
    [sym_assignment] = STATE(4971),
    [sym_unary] = STATE(4971),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4971),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4971),
    [sym_conditional] = STATE(4971),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4971),
    [sym_binary] = STATE(4971),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2332] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [2333] = {
    [sym_assignment] = STATE(4972),
    [sym_unary] = STATE(4972),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4972),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4972),
    [sym_conditional] = STATE(4972),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4972),
    [sym_binary] = STATE(4972),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2334] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [2335] = {
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
  },
  [2336] = {
    [anon_sym_RPAREN] = ACTIONS(8275),
    [sym_comment] = ACTIONS(49),
  },
  [2337] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [2338] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [2339] = {
    [aux_sym_heredoc_body_repeat1] = STATE(4975),
    [sym_interpolation] = STATE(4975),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8277),
    [sym_heredoc_end] = ACTIONS(8279),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(8277),
  },
  [2340] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_heredoc_body] = STATE(4977),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2341] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [2342] = {
    [sym_heredoc_body] = STATE(4979),
    [aux_sym_call_repeat1] = STATE(4979),
    [aux_sym_argument_list_repeat1] = STATE(4980),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(4114),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [2343] = {
    [sym_assignment] = STATE(4981),
    [sym_unary] = STATE(4981),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4981),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4981),
    [sym_conditional] = STATE(4981),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4981),
    [sym_binary] = STATE(4981),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2344] = {
    [sym_assignment] = STATE(4982),
    [sym_unary] = STATE(4982),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4982),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(4983),
    [sym_operator_assignment] = STATE(4982),
    [sym_conditional] = STATE(4982),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_subshell] = STATE(144),
    [sym__arg_or_splat_arg] = STATE(4983),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_true] = STATE(727),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4982),
    [sym_binary] = STATE(4982),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(203),
    [sym_character] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2345] = {
    [sym_assignment] = STATE(4984),
    [sym_unary] = STATE(4984),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4984),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4984),
    [sym_conditional] = STATE(4984),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4984),
    [sym_binary] = STATE(4984),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2346] = {
    [sym_assignment] = STATE(4985),
    [sym_unary] = STATE(4985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4985),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4985),
    [sym_conditional] = STATE(4985),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4985),
    [sym_binary] = STATE(4985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2347] = {
    [sym_assignment] = STATE(4986),
    [sym_unary] = STATE(4986),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(4986),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(4986),
    [sym_conditional] = STATE(4986),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(4986),
    [sym_binary] = STATE(4986),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2348] = {
    [sym_assignment] = STATE(4987),
    [sym_unary] = STATE(4987),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4987),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4987),
    [sym_conditional] = STATE(4987),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4987),
    [sym_binary] = STATE(4987),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2349] = {
    [sym_assignment] = STATE(4988),
    [sym_unary] = STATE(4988),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4988),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4988),
    [sym_conditional] = STATE(4988),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4988),
    [sym_binary] = STATE(4988),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2350] = {
    [sym_assignment] = STATE(4989),
    [sym_unary] = STATE(4989),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4989),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4989),
    [sym_conditional] = STATE(4989),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4989),
    [sym_binary] = STATE(4989),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2351] = {
    [sym_assignment] = STATE(4991),
    [sym_unary] = STATE(4991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4991),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4991),
    [sym_conditional] = STATE(4991),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4991),
    [sym_binary] = STATE(4991),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2352] = {
    [sym_assignment] = STATE(4992),
    [sym_unary] = STATE(4992),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4992),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4992),
    [sym_conditional] = STATE(4992),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4992),
    [sym_binary] = STATE(4992),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2353] = {
    [sym_assignment] = STATE(4993),
    [sym_unary] = STATE(4993),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4993),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(4993),
    [sym_conditional] = STATE(4993),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4993),
    [sym_binary] = STATE(4993),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2354] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(8283),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2355] = {
    [anon_sym_COLON] = ACTIONS(8285),
    [sym_comment] = ACTIONS(49),
  },
  [2356] = {
    [sym_assignment] = STATE(5000),
    [sym_unary] = STATE(5000),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5000),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(5000),
    [sym_conditional] = STATE(5000),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(5000),
    [sym_binary] = STATE(5000),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2357] = {
    [sym_assignment] = STATE(5002),
    [sym_unary] = STATE(5002),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5002),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(5002),
    [sym_conditional] = STATE(5002),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(5002),
    [sym_binary] = STATE(5002),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2358] = {
    [sym_assignment] = STATE(5003),
    [sym_unary] = STATE(5003),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5003),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(5003),
    [sym_conditional] = STATE(5003),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(5003),
    [sym_binary] = STATE(5003),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2359] = {
    [sym_heredoc_body] = STATE(5005),
    [aux_sym_call_repeat1] = STATE(5005),
    [aux_sym_argument_list_repeat1] = STATE(5006),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(8297),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2360] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(8285),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [2361] = {
    [aux_sym_chained_string_repeat1] = STATE(867),
    [sym_string] = STATE(867),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8299),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2362] = {
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2883),
  },
  [2363] = {
    [sym_heredoc_body] = STATE(5005),
    [aux_sym_call_repeat1] = STATE(5005),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2364] = {
    [sym__terminator] = STATE(5007),
    [sym_heredoc_body] = STATE(5007),
    [sym__do] = STATE(5007),
    [sym__line_break] = ACTIONS(8301),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(8301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8301),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2365] = {
    [sym_heredoc_body] = STATE(5008),
    [sym__terminator] = STATE(5008),
    [sym__line_break] = ACTIONS(8303),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2366] = {
    [sym_when] = STATE(5011),
    [sym_else] = STATE(5010),
    [aux_sym_case_repeat2] = STATE(5011),
    [aux_sym_case_repeat1] = STATE(5012),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8305),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8307),
    [sym_comment] = ACTIONS(49),
  },
  [2367] = {
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2873),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2871),
  },
  [2368] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(5015),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8309),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8311),
  },
  [2369] = {
    [aux_sym_string_array_repeat1] = STATE(5018),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8313),
    [sym__string_end] = ACTIONS(8315),
  },
  [2370] = {
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_in] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_COLON2] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2303),
  },
  [2371] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8317),
  },
  [2372] = {
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2387),
    [anon_sym_RBRACK] = ACTIONS(2387),
    [anon_sym_in] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_COLON2] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2387),
    [anon_sym_EQ] = ACTIONS(2385),
  },
  [2373] = {
    [anon_sym_RPAREN] = ACTIONS(8319),
    [sym_comment] = ACTIONS(49),
  },
  [2374] = {
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_RBRACK] = ACTIONS(2533),
    [anon_sym_in] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_COLON2] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_EQ] = ACTIONS(2531),
  },
  [2375] = {
    [sym__terminator] = STATE(5021),
    [sym_heredoc_body] = STATE(5021),
    [sym_then] = STATE(5022),
    [sym__line_break] = ACTIONS(8321),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(8321),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2376] = {
    [sym_assignment] = STATE(5023),
    [sym_unary] = STATE(5023),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(5023),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(5023),
    [sym_conditional] = STATE(5023),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(5023),
    [sym_binary] = STATE(5023),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [2377] = {
    [sym_heredoc_body] = STATE(5024),
    [sym__terminator] = STATE(5024),
    [sym_superclass] = STATE(5025),
    [sym__line_break] = ACTIONS(8323),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8323),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2378] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(5025),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(5024),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(5024),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8323),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8323),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2379] = {
    [sym_heredoc_body] = STATE(5027),
    [sym__terminator] = STATE(5027),
    [sym__line_break] = ACTIONS(8325),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8325),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(8327),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2380] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(5027),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(5027),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8325),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8325),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(8327),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2381] = {
    [anon_sym_end] = ACTIONS(8329),
    [sym_comment] = ACTIONS(49),
  },
  [2382] = {
    [sym_ensure] = STATE(5029),
    [sym_else] = STATE(5030),
    [anon_sym_end] = ACTIONS(8329),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2383] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5031),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8331),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2384] = {
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2743),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_in] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_COLON2] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [anon_sym_EQ] = ACTIONS(2741),
  },
  [2385] = {
    [sym_ensure] = STATE(5029),
    [sym_else] = STATE(5030),
    [sym_rescue] = STATE(5032),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(8329),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2386] = {
    [sym_ensure] = STATE(5029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8329),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2387] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [2388] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
  },
  [2389] = {
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2577),
    [anon_sym_RBRACK] = ACTIONS(2577),
    [anon_sym_in] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2577),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_COLON2] = ACTIONS(2575),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2577),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2577),
    [anon_sym_EQ] = ACTIONS(2575),
  },
  [2390] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8333),
  },
  [2391] = {
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_COLON2] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(1225),
  },
  [2392] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(5036),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8335),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8337),
  },
  [2393] = {
    [aux_sym_symbol_array_repeat1] = STATE(5039),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8339),
    [sym__string_end] = ACTIONS(8341),
  },
  [2394] = {
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_RBRACK] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_COLON2] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1339),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1337),
  },
  [2395] = {
    [anon_sym_RBRACK] = ACTIONS(8343),
    [sym_comment] = ACTIONS(49),
  },
  [2396] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_RBRACK] = ACTIONS(1635),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(1633),
  },
  [2397] = {
    [sym_heredoc_body] = STATE(5042),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(8345),
    [sym_comment] = ACTIONS(49),
  },
  [2398] = {
    [anon_sym_RBRACE] = ACTIONS(8345),
    [sym_comment] = ACTIONS(49),
  },
  [2399] = {
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2853),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_COLON2] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2853),
    [anon_sym_EQ] = ACTIONS(2851),
  },
  [2400] = {
    [sym__terminator] = STATE(5043),
    [sym_heredoc_body] = STATE(5043),
    [sym__do] = STATE(5043),
    [sym__line_break] = ACTIONS(8347),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(8347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8347),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2401] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [2402] = {
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_COLON2] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2861),
  },
  [2403] = {
    [sym_in] = STATE(5044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [2404] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_RBRACK] = ACTIONS(1853),
    [anon_sym_in] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_EQ] = ACTIONS(1851),
  },
  [2405] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8349),
  },
  [2406] = {
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_COLON2] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2857),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2857),
    [anon_sym_EQ] = ACTIONS(2855),
  },
  [2407] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8351),
  },
  [2408] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5048),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5049),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5049),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5050),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8353),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8353),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8355),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2409] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(5052),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5053),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8357),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2410] = {
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_in] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2045),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_COLON2] = ACTIONS(2043),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_EQ] = ACTIONS(2043),
  },
  [2411] = {
    [sym_do_block] = STATE(5054),
    [sym_block] = STATE(5054),
    [anon_sym_do] = ACTIONS(8359),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4198),
  },
  [2412] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2413] = {
    [sym_assignment] = STATE(5055),
    [sym_unary] = STATE(5055),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5055),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5055),
    [sym_conditional] = STATE(5055),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5055),
    [sym_binary] = STATE(5055),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [2414] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(5056),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(5056),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(5056),
    [sym__line_break] = ACTIONS(8361),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(8361),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [2415] = {
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_RBRACK] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2103),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_COLON2] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2103),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2103),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_EQ] = ACTIONS(2101),
  },
  [2416] = {
    [anon_sym_DOT] = ACTIONS(8363),
    [anon_sym_COLON_COLON] = ACTIONS(8363),
    [sym_comment] = ACTIONS(49),
  },
  [2417] = {
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_SLASH] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_COLON2] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2299),
  },
  [2418] = {
    [sym__terminator] = STATE(5058),
    [sym_heredoc_body] = STATE(5058),
    [sym_then] = STATE(5059),
    [sym__line_break] = ACTIONS(8365),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(8365),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2419] = {
    [sym_assignment] = STATE(5060),
    [sym_unary] = STATE(5060),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5060),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5060),
    [sym_conditional] = STATE(5060),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5060),
    [sym_binary] = STATE(5060),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2420] = {
    [sym_assignment] = STATE(5063),
    [sym_unary] = STATE(5063),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5063),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_splat_argument] = STATE(5064),
    [sym_operator_assignment] = STATE(5063),
    [sym_conditional] = STATE(5063),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_return] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_subshell] = STATE(768),
    [sym__arg_or_splat_arg] = STATE(5064),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_true] = STATE(766),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5063),
    [sym_binary] = STATE(5063),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8367),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_global_variable] = ACTIONS(1441),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1413),
    [sym_character] = ACTIONS(1431),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2421] = {
    [sym_assignment] = STATE(5065),
    [sym_unary] = STATE(5065),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5065),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5065),
    [sym_conditional] = STATE(5065),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5065),
    [sym_binary] = STATE(5065),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2422] = {
    [sym_assignment] = STATE(5066),
    [sym_unary] = STATE(5066),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5066),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5066),
    [sym_conditional] = STATE(5066),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5066),
    [sym_binary] = STATE(5066),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2423] = {
    [sym_assignment] = STATE(5067),
    [sym_unary] = STATE(5067),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5067),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5067),
    [sym_conditional] = STATE(5067),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5067),
    [sym_binary] = STATE(5067),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2424] = {
    [sym_assignment] = STATE(5068),
    [sym_unary] = STATE(5068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5068),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5068),
    [sym_conditional] = STATE(5068),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5068),
    [sym_binary] = STATE(5068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2425] = {
    [sym_assignment] = STATE(5069),
    [sym_unary] = STATE(5069),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5069),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5069),
    [sym_conditional] = STATE(5069),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5069),
    [sym_binary] = STATE(5069),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2426] = {
    [sym_assignment] = STATE(5070),
    [sym_unary] = STATE(5070),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5070),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5070),
    [sym_conditional] = STATE(5070),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5070),
    [sym_binary] = STATE(5070),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2427] = {
    [sym_assignment] = STATE(5071),
    [sym_unary] = STATE(5071),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5071),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5071),
    [sym_conditional] = STATE(5071),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5071),
    [sym_binary] = STATE(5071),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2428] = {
    [sym_assignment] = STATE(5072),
    [sym_unary] = STATE(5072),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5072),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5072),
    [sym_conditional] = STATE(5072),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5072),
    [sym_binary] = STATE(5072),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2429] = {
    [sym_assignment] = STATE(5073),
    [sym_unary] = STATE(5073),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5073),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5073),
    [sym_conditional] = STATE(5073),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5073),
    [sym_binary] = STATE(5073),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2430] = {
    [sym_assignment] = STATE(5074),
    [sym_unary] = STATE(5074),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5074),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(5074),
    [sym_conditional] = STATE(5074),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5074),
    [sym_binary] = STATE(5074),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [2431] = {
    [sym_heredoc_body] = STATE(5079),
    [sym__argument_list_with_parens] = STATE(5078),
    [aux_sym_call_repeat1] = STATE(5079),
    [sym_argument_list_with_parens] = STATE(5077),
    [sym_operator] = STATE(5077),
    [anon_sym_LT] = ACTIONS(8369),
    [anon_sym_SLASH] = ACTIONS(8371),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8371),
    [anon_sym_PLUS_AT] = ACTIONS(8371),
    [anon_sym_LPAREN2] = ACTIONS(8373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8371),
    [anon_sym_GT_GT] = ACTIONS(8371),
    [anon_sym_EQ_TILDE] = ACTIONS(8371),
    [anon_sym_LT_LT] = ACTIONS(8371),
    [anon_sym_TILDE] = ACTIONS(8371),
    [anon_sym_PLUS] = ACTIONS(8369),
    [anon_sym_AMP] = ACTIONS(8371),
    [anon_sym_GT] = ACTIONS(8369),
    [anon_sym_PERCENT] = ACTIONS(8371),
    [anon_sym_DASH_AT] = ACTIONS(8371),
    [anon_sym_EQ_EQ] = ACTIONS(8369),
    [anon_sym_STAR] = ACTIONS(8369),
    [anon_sym_BANG_TILDE] = ACTIONS(8371),
    [sym_constant] = ACTIONS(8375),
    [anon_sym_DASH] = ACTIONS(8369),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8371),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8369),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8371),
    [anon_sym_STAR_STAR] = ACTIONS(8371),
    [anon_sym_PIPE] = ACTIONS(8371),
    [anon_sym_DOT_DOT] = ACTIONS(8371),
    [anon_sym_LT_EQ_GT] = ACTIONS(8371),
    [anon_sym_LT_EQ] = ACTIONS(8369),
    [anon_sym_BANG] = ACTIONS(8369),
    [sym_identifier] = ACTIONS(8375),
    [anon_sym_CARET] = ACTIONS(8371),
  },
  [2432] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(5081),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(8377),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2433] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8379),
    [sym_identifier] = ACTIONS(8379),
  },
  [2434] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(5084),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(5085),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8381),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [2435] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(8383),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2436] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5088),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5089),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5089),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5090),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8385),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8385),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8387),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2437] = {
    [anon_sym_COLON] = ACTIONS(8389),
    [sym_comment] = ACTIONS(49),
  },
  [2438] = {
    [sym_assignment] = STATE(5100),
    [sym_unary] = STATE(5100),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(5100),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(5100),
    [sym_conditional] = STATE(5100),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(5100),
    [sym_binary] = STATE(5100),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [2439] = {
    [sym_assignment] = STATE(5105),
    [sym_unary] = STATE(5105),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(5105),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(5105),
    [sym_conditional] = STATE(5105),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(5105),
    [sym_binary] = STATE(5105),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [2440] = {
    [sym_assignment] = STATE(5106),
    [sym_unary] = STATE(5106),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(5106),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(5106),
    [sym_conditional] = STATE(5106),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(5106),
    [sym_binary] = STATE(5106),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [2441] = {
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [2442] = {
    [sym_do_block] = STATE(5108),
    [sym_block] = STATE(5108),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(8417),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8419),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [2443] = {
    [sym_heredoc_body] = STATE(5110),
    [aux_sym_call_repeat1] = STATE(5110),
    [aux_sym_argument_list_repeat1] = STATE(5111),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(8421),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2444] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(8389),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [2445] = {
    [aux_sym_chained_string_repeat1] = STATE(2591),
    [sym_string] = STATE(2591),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8423),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2446] = {
    [sym_heredoc_body] = STATE(5110),
    [aux_sym_call_repeat1] = STATE(5110),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2447] = {
    [aux_sym_chained_string_repeat1] = STATE(5112),
    [sym_string] = STATE(5112),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_RBRACK] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [2448] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_COLON2] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
  },
  [2449] = {
    [sym_when] = STATE(5115),
    [sym_else] = STATE(5114),
    [aux_sym_case_repeat2] = STATE(5115),
    [aux_sym_case_repeat1] = STATE(5116),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8425),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8427),
    [sym_comment] = ACTIONS(49),
  },
  [2450] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_in] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5744),
  },
  [2451] = {
    [anon_sym_end] = ACTIONS(8425),
    [sym_comment] = ACTIONS(49),
  },
  [2452] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(5114),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8425),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [2453] = {
    [sym_when] = STATE(5115),
    [sym_else] = STATE(5114),
    [aux_sym_case_repeat2] = STATE(5115),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8425),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [2454] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_in] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_COLON2] = ACTIONS(5972),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
    [anon_sym_EQ] = ACTIONS(5972),
  },
  [2455] = {
    [sym_heredoc_body] = STATE(5117),
    [sym__terminator] = STATE(5117),
    [sym__line_break] = ACTIONS(8429),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2456] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5118),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8431),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2457] = {
    [sym_heredoc_body] = STATE(5119),
    [sym__terminator] = STATE(5119),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(8433),
    [anon_sym_SEMI] = ACTIONS(8433),
    [sym_comment] = ACTIONS(49),
  },
  [2458] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_RBRACK] = ACTIONS(6073),
    [anon_sym_in] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_EQ_GT] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_COLON2] = ACTIONS(6071),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
    [anon_sym_EQ] = ACTIONS(6071),
  },
  [2459] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_in] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_COLON2] = ACTIONS(6075),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6075),
  },
  [2460] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5120),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8435),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2461] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [anon_sym_RBRACK] = ACTIONS(6445),
    [anon_sym_in] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_COLON2] = ACTIONS(6443),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
    [anon_sym_EQ] = ACTIONS(6443),
  },
  [2462] = {
    [anon_sym_end] = ACTIONS(8437),
    [sym_comment] = ACTIONS(49),
  },
  [2463] = {
    [sym_ensure] = STATE(5122),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8437),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2464] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [anon_sym_RBRACK] = ACTIONS(6473),
    [anon_sym_in] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_EQ_GT] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_COLON2] = ACTIONS(6471),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
    [anon_sym_EQ] = ACTIONS(6471),
  },
  [2465] = {
    [sym_ensure] = STATE(5122),
    [sym_else] = STATE(5123),
    [anon_sym_end] = ACTIONS(8437),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2466] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_in] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_EQ_GT] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_COLON2] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6630),
  },
  [2467] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(5125),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(5125),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8439),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [2468] = {
    [sym_elsif] = STATE(5125),
    [sym_else] = STATE(5125),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8441),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [2469] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [anon_sym_RBRACK] = ACTIONS(6682),
    [anon_sym_in] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_EQ_GT] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_COLON2] = ACTIONS(6680),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
    [anon_sym_EQ] = ACTIONS(6680),
  },
  [2470] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8443),
  },
  [2471] = {
    [aux_sym_string_array_repeat1] = STATE(5129),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8445),
    [sym__string_end] = ACTIONS(8447),
  },
  [2472] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8449),
  },
  [2473] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [anon_sym_RBRACK] = ACTIONS(6694),
    [anon_sym_in] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_EQ_GT] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_COLON2] = ACTIONS(6692),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
    [anon_sym_EQ] = ACTIONS(6692),
  },
  [2474] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8451),
    [sym__string_end] = ACTIONS(8449),
  },
  [2475] = {
    [aux_sym_heredoc_body_repeat1] = STATE(5133),
    [sym_interpolation] = STATE(5133),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8453),
    [sym_heredoc_end] = ACTIONS(8455),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(8453),
  },
  [2476] = {
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [2477] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(8459),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2478] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_heredoc_body] = STATE(5135),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(8459),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [sym__heredoc_body_start] = ACTIONS(4302),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2479] = {
    [anon_sym_RPAREN] = ACTIONS(8459),
    [anon_sym_RBRACK] = ACTIONS(8459),
    [sym_comment] = ACTIONS(49),
  },
  [2480] = {
    [aux_sym_argument_list_repeat1] = STATE(2480),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8461),
    [sym_comment] = ACTIONS(49),
  },
  [2481] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2482] = {
    [sym_assignment] = STATE(5137),
    [sym_unary] = STATE(5137),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(5137),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(5137),
    [sym_conditional] = STATE(5137),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(5137),
    [sym_binary] = STATE(5137),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [2483] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
  },
  [2484] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2485] = {
    [aux_sym_exceptions_repeat1] = STATE(5139),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [2486] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2487] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2488] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [2489] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2490] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2491] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2492] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [2493] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2494] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2495] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2496] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [anon_sym_RBRACK] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [2497] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(5142),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(8466),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2498] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [anon_sym_RBRACK] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [2499] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [anon_sym_RBRACK] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [2500] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(2499),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(5143),
    [sym_operator] = STATE(5143),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4310),
    [anon_sym_PLUS_AT] = ACTIONS(4310),
    [anon_sym_LPAREN2] = ACTIONS(4312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4310),
    [anon_sym_GT_GT] = ACTIONS(4310),
    [anon_sym_EQ_TILDE] = ACTIONS(4310),
    [anon_sym_LT_LT] = ACTIONS(4310),
    [anon_sym_TILDE] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4308),
    [anon_sym_AMP] = ACTIONS(4310),
    [anon_sym_GT] = ACTIONS(4308),
    [anon_sym_PERCENT] = ACTIONS(4310),
    [anon_sym_DASH_AT] = ACTIONS(4310),
    [anon_sym_EQ_EQ] = ACTIONS(4308),
    [anon_sym_STAR] = ACTIONS(4308),
    [anon_sym_BANG_TILDE] = ACTIONS(4310),
    [sym_constant] = ACTIONS(8468),
    [anon_sym_DASH] = ACTIONS(4308),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4308),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_STAR_STAR] = ACTIONS(4310),
    [anon_sym_PIPE] = ACTIONS(4310),
    [anon_sym_DOT_DOT] = ACTIONS(4310),
    [anon_sym_LT_EQ_GT] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(4308),
    [anon_sym_BANG] = ACTIONS(4308),
    [sym_identifier] = ACTIONS(8468),
    [anon_sym_CARET] = ACTIONS(4310),
  },
  [2501] = {
    [anon_sym_SLASH] = ACTIONS(6733),
    [anon_sym_RBRACK] = ACTIONS(6735),
    [anon_sym_until] = ACTIONS(6735),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_RBRACE] = ACTIONS(6735),
    [anon_sym_unless] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_rescue] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_LBRACE] = ACTIONS(6735),
    [anon_sym_COLON2] = ACTIONS(6733),
    [anon_sym_while] = ACTIONS(6735),
    [sym__heredoc_body_start] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_in] = ACTIONS(6735),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_EQ_GT] = ACTIONS(6735),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_if] = ACTIONS(6735),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [2502] = {
    [anon_sym_RBRACK] = ACTIONS(8470),
    [sym_comment] = ACTIONS(49),
  },
  [2503] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [2504] = {
    [sym__terminator] = STATE(5145),
    [sym_heredoc_body] = STATE(5145),
    [sym__do] = STATE(5145),
    [sym__line_break] = ACTIONS(8472),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(8472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8472),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2505] = {
    [sym__terminator] = STATE(5146),
    [sym_heredoc_body] = STATE(5146),
    [sym_then] = STATE(5147),
    [sym__line_break] = ACTIONS(8474),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(8474),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2506] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(2517),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(2518),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(8476),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [2507] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [2508] = {
    [aux_sym_chained_string_repeat1] = STATE(2591),
    [sym_string] = STATE(2591),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2509] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [2510] = {
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_COLON2] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1225),
  },
  [2511] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(5151),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8478),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8480),
  },
  [2512] = {
    [aux_sym_symbol_array_repeat1] = STATE(5154),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8482),
    [sym__string_end] = ACTIONS(8484),
  },
  [2513] = {
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_AMP_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT_EQ] = ACTIONS(1339),
    [anon_sym_SLASH_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_PERCENT_EQ] = ACTIONS(1339),
    [anon_sym_LT_LT_EQ] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_COLON2] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_CARET_EQ] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_PLUS_EQ] = ACTIONS(1339),
    [anon_sym_STAR_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1339),
    [anon_sym_DASH_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1337),
  },
  [2514] = {
    [anon_sym_RBRACK] = ACTIONS(8486),
    [sym_comment] = ACTIONS(49),
  },
  [2515] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [2516] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5157),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8488),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2517] = {
    [sym_heredoc_body] = STATE(5159),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(8490),
    [sym_comment] = ACTIONS(49),
  },
  [2518] = {
    [anon_sym_RBRACE] = ACTIONS(8490),
    [sym_comment] = ACTIONS(49),
  },
  [2519] = {
    [anon_sym_RBRACE] = ACTIONS(8488),
    [sym_comment] = ACTIONS(49),
  },
  [2520] = {
    [sym_assignment] = STATE(5160),
    [sym_unary] = STATE(5160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5160),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5160),
    [sym_conditional] = STATE(5160),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5160),
    [sym_binary] = STATE(5160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2521] = {
    [sym__terminator] = STATE(5161),
    [sym_heredoc_body] = STATE(5161),
    [sym__do] = STATE(5161),
    [sym__line_break] = ACTIONS(8492),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(8492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8492),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2522] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [2523] = {
    [anon_sym_SLASH] = ACTIONS(1851),
    [anon_sym_RBRACK] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_AMP_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT_EQ] = ACTIONS(1853),
    [anon_sym_SLASH_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1851),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_PERCENT_EQ] = ACTIONS(1853),
    [anon_sym_LT_LT_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_COLON] = ACTIONS(1851),
    [sym__string_start] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_CARET_EQ] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_in] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_PLUS_EQ] = ACTIONS(1853),
    [anon_sym_STAR_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1853),
    [anon_sym_DASH_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1851),
  },
  [2524] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8494),
  },
  [2525] = {
    [sym_in] = STATE(5163),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [2526] = {
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [2527] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5165),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5165),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5166),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8496),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8496),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8498),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2528] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5167),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5166),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8498),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2529] = {
    [anon_sym_end] = ACTIONS(8500),
    [sym_comment] = ACTIONS(49),
  },
  [2530] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(2516),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(2519),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2531] = {
    [anon_sym_SLASH] = ACTIONS(2043),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_AMP_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT_EQ] = ACTIONS(2045),
    [anon_sym_SLASH_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2043),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2043),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_PERCENT_EQ] = ACTIONS(2045),
    [anon_sym_LT_LT_EQ] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_COLON2] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_CARET_EQ] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_EQ] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_in] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_EQ_GT] = ACTIONS(2045),
    [anon_sym_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_PLUS_EQ] = ACTIONS(2045),
    [anon_sym_STAR_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2045),
    [anon_sym_DASH_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2043),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2043),
  },
  [2532] = {
    [sym_do_block] = STATE(5169),
    [sym_block] = STATE(5169),
    [anon_sym_do] = ACTIONS(4380),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4344),
  },
  [2533] = {
    [sym_assignment] = STATE(5170),
    [sym_unary] = STATE(5170),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5170),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5170),
    [sym_conditional] = STATE(5170),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5170),
    [sym_binary] = STATE(5170),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2534] = {
    [sym_assignment] = STATE(5171),
    [sym_unary] = STATE(5171),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5171),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5171),
    [sym_conditional] = STATE(5171),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5171),
    [sym_binary] = STATE(5171),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [2535] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(5172),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(5172),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(5172),
    [sym__line_break] = ACTIONS(8504),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(8504),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [2536] = {
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_RBRACK] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_AMP_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT_EQ] = ACTIONS(2103),
    [anon_sym_SLASH_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_PERCENT_EQ] = ACTIONS(2103),
    [anon_sym_LT_LT_EQ] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COLON2] = ACTIONS(2101),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_CARET_EQ] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_EQ] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_in] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_EQ_GT] = ACTIONS(2103),
    [anon_sym_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_PLUS_EQ] = ACTIONS(2103),
    [anon_sym_STAR_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2103),
    [anon_sym_DASH_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2101),
  },
  [2537] = {
    [anon_sym_DOT] = ACTIONS(8506),
    [anon_sym_COLON_COLON] = ACTIONS(8506),
    [sym_comment] = ACTIONS(49),
  },
  [2538] = {
    [anon_sym_SLASH] = ACTIONS(2299),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_AMP_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT_EQ] = ACTIONS(2301),
    [anon_sym_SLASH_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2299),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_PERCENT_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_COLON2] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_CARET_EQ] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_in] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_PLUS_EQ] = ACTIONS(2301),
    [anon_sym_STAR_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2301),
    [anon_sym_DASH_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2299),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2299),
  },
  [2539] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [2540] = {
    [anon_sym_SLASH] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_AMP_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT_EQ] = ACTIONS(2305),
    [anon_sym_SLASH_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_COLON2] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_CARET_EQ] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_in] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_PLUS_EQ] = ACTIONS(2305),
    [anon_sym_STAR_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2305),
    [anon_sym_DASH_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2303),
  },
  [2541] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8508),
  },
  [2542] = {
    [sym_heredoc_body] = STATE(5175),
    [sym__terminator] = STATE(5175),
    [sym__line_break] = ACTIONS(8510),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2543] = {
    [sym_when] = STATE(5178),
    [sym_else] = STATE(5177),
    [aux_sym_case_repeat2] = STATE(5178),
    [aux_sym_case_repeat1] = STATE(5179),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8512),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8514),
    [sym_comment] = ACTIONS(49),
  },
  [2544] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
  },
  [2545] = {
    [anon_sym_RPAREN] = ACTIONS(8516),
    [sym_comment] = ACTIONS(49),
  },
  [2546] = {
    [anon_sym_SLASH] = ACTIONS(2385),
    [anon_sym_RBRACK] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_AMP_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT_EQ] = ACTIONS(2387),
    [anon_sym_SLASH_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2385),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_PERCENT_EQ] = ACTIONS(2387),
    [anon_sym_LT_LT_EQ] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_COLON2] = ACTIONS(2385),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_CARET_EQ] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_in] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_EQ_GT] = ACTIONS(2387),
    [anon_sym_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [anon_sym_STAR_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2385),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2385),
  },
  [2547] = {
    [anon_sym_RPAREN] = ACTIONS(8518),
    [sym_comment] = ACTIONS(49),
  },
  [2548] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [2549] = {
    [anon_sym_SLASH] = ACTIONS(2531),
    [anon_sym_RBRACK] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_AMP_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2531),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_COLON2] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_EQ] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_in] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_EQ_GT] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_PLUS_EQ] = ACTIONS(2533),
    [anon_sym_STAR_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2531),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_AMP_AMP] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2531),
  },
  [2550] = {
    [sym_assignment] = STATE(5182),
    [sym_unary] = STATE(5182),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(5182),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(5182),
    [sym_conditional] = STATE(5182),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(5182),
    [sym_binary] = STATE(5182),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [2551] = {
    [sym_heredoc_body] = STATE(5183),
    [sym__terminator] = STATE(5183),
    [sym_superclass] = STATE(5184),
    [sym__line_break] = ACTIONS(8520),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8520),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2552] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(5184),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(5183),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(5183),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8520),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8520),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2553] = {
    [anon_sym_SLASH] = ACTIONS(2575),
    [anon_sym_RBRACK] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_COLON2] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_in] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_EQ_GT] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2575),
  },
  [2554] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8522),
  },
  [2555] = {
    [sym_heredoc_body] = STATE(5187),
    [sym__terminator] = STATE(5187),
    [sym__line_break] = ACTIONS(8524),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(8524),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(8526),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2556] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(5187),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(5187),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(8524),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(8524),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(8526),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [2557] = {
    [anon_sym_end] = ACTIONS(8528),
    [sym_comment] = ACTIONS(49),
  },
  [2558] = {
    [sym_ensure] = STATE(5189),
    [sym_else] = STATE(5190),
    [anon_sym_end] = ACTIONS(8528),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2559] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5191),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8530),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2560] = {
    [anon_sym_SLASH] = ACTIONS(2741),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2741),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2741),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_COLON2] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_in] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2743),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2741),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2741),
  },
  [2561] = {
    [sym_ensure] = STATE(5189),
    [sym_else] = STATE(5190),
    [sym_rescue] = STATE(5192),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(8528),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2562] = {
    [sym_ensure] = STATE(5189),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8528),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2563] = {
    [anon_sym_SLASH] = ACTIONS(2851),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_AMP_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_SLASH_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2851),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_PERCENT_EQ] = ACTIONS(2853),
    [anon_sym_LT_LT_EQ] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_COLON2] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_CARET_EQ] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_PLUS_EQ] = ACTIONS(2853),
    [anon_sym_STAR_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2853),
    [anon_sym_DASH_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2851),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2851),
  },
  [2564] = {
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_AMP_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT_EQ] = ACTIONS(2857),
    [anon_sym_SLASH_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_PERCENT_EQ] = ACTIONS(2857),
    [anon_sym_LT_LT_EQ] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_COLON2] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_CARET_EQ] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_PLUS_EQ] = ACTIONS(2857),
    [anon_sym_STAR_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2857),
    [anon_sym_DASH_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2855),
  },
  [2565] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8532),
  },
  [2566] = {
    [anon_sym_SLASH] = ACTIONS(2861),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_AMP_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT_EQ] = ACTIONS(2863),
    [anon_sym_SLASH_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_PERCENT_EQ] = ACTIONS(2863),
    [anon_sym_LT_LT_EQ] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_COLON2] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_CARET_EQ] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_in] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_EQ_GT] = ACTIONS(2863),
    [anon_sym_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_PLUS_EQ] = ACTIONS(2863),
    [anon_sym_STAR_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2861),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2863),
    [anon_sym_DASH_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2861),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2861),
  },
  [2567] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [2568] = {
    [sym__terminator] = STATE(5194),
    [sym_heredoc_body] = STATE(5194),
    [sym_then] = STATE(5195),
    [sym__line_break] = ACTIONS(8534),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(8534),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [2569] = {
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2871),
  },
  [2570] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(5198),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8536),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8538),
  },
  [2571] = {
    [aux_sym_string_array_repeat1] = STATE(5201),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8540),
    [sym__string_end] = ACTIONS(8542),
  },
  [2572] = {
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2883),
  },
  [2573] = {
    [anon_sym_SLASH] = ACTIONS(6989),
    [anon_sym_RBRACK] = ACTIONS(6991),
    [anon_sym_until] = ACTIONS(6991),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_RBRACE] = ACTIONS(6991),
    [anon_sym_unless] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_rescue] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_COLON2] = ACTIONS(6989),
    [anon_sym_while] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_in] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_EQ_GT] = ACTIONS(6991),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [2574] = {
    [sym_assignment] = STATE(5203),
    [sym_unary] = STATE(5203),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5203),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(5204),
    [sym_operator_assignment] = STATE(5203),
    [sym_conditional] = STATE(5203),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_subshell] = STATE(858),
    [sym__arg_or_splat_arg] = STATE(5204),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_true] = STATE(863),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5203),
    [sym_binary] = STATE(5203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1553),
    [sym_character] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2575] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(2516),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(2519),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [2576] = {
    [sym_do_block] = STATE(2573),
    [sym_block] = STATE(2573),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [2577] = {
    [aux_sym_heredoc_body_repeat1] = STATE(5206),
    [sym_interpolation] = STATE(5206),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8544),
    [sym_heredoc_end] = ACTIONS(8546),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(8544),
  },
  [2578] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_heredoc_body] = STATE(5208),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym_float] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1553),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1573),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [sym_class_variable] = ACTIONS(1573),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1593),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8548),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2579] = {
    [sym_heredoc_body] = STATE(5209),
    [aux_sym_call_repeat1] = STATE(5209),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2580] = {
    [sym_heredoc_body] = STATE(5210),
    [aux_sym_call_repeat1] = STATE(5210),
    [aux_sym_argument_list_repeat1] = STATE(5211),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(4386),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2581] = {
    [sym_assignment] = STATE(5212),
    [sym_unary] = STATE(5212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5212),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5212),
    [sym_conditional] = STATE(5212),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5212),
    [sym_binary] = STATE(5212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2582] = {
    [sym_assignment] = STATE(5213),
    [sym_unary] = STATE(5213),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5213),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5213),
    [sym_conditional] = STATE(5213),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5213),
    [sym_binary] = STATE(5213),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2583] = {
    [sym_assignment] = STATE(5214),
    [sym_unary] = STATE(5214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5214),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5214),
    [sym_conditional] = STATE(5214),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5214),
    [sym_binary] = STATE(5214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2584] = {
    [sym_assignment] = STATE(5215),
    [sym_unary] = STATE(5215),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5215),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5215),
    [sym_conditional] = STATE(5215),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5215),
    [sym_binary] = STATE(5215),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2585] = {
    [sym_assignment] = STATE(5216),
    [sym_unary] = STATE(5216),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5216),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5216),
    [sym_conditional] = STATE(5216),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5216),
    [sym_binary] = STATE(5216),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2586] = {
    [sym_assignment] = STATE(5217),
    [sym_unary] = STATE(5217),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5217),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5217),
    [sym_conditional] = STATE(5217),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5217),
    [sym_binary] = STATE(5217),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2587] = {
    [sym_assignment] = STATE(5218),
    [sym_unary] = STATE(5218),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5218),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5218),
    [sym_conditional] = STATE(5218),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5218),
    [sym_binary] = STATE(5218),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2588] = {
    [sym_assignment] = STATE(5220),
    [sym_unary] = STATE(5220),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5220),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5220),
    [sym_conditional] = STATE(5220),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5220),
    [sym_binary] = STATE(5220),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2589] = {
    [sym_assignment] = STATE(5221),
    [sym_unary] = STATE(5221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5221),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5221),
    [sym_conditional] = STATE(5221),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5221),
    [sym_binary] = STATE(5221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2590] = {
    [sym_assignment] = STATE(5222),
    [sym_unary] = STATE(5222),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5222),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(5222),
    [sym_conditional] = STATE(5222),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5222),
    [sym_binary] = STATE(5222),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [2591] = {
    [aux_sym_chained_string_repeat1] = STATE(5223),
    [sym_string] = STATE(5223),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_RBRACK] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [2592] = {
    [aux_sym_chained_string_repeat1] = STATE(2592),
    [sym_string] = STATE(2592),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_RBRACK] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [2593] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5225),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8553),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2594] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(5227),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8555),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2595] = {
    [sym_else] = STATE(5227),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(8557),
    [sym_comment] = ACTIONS(49),
  },
  [2596] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_EQ_GT] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
  },
  [2597] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8559),
  },
  [2598] = {
    [aux_sym_symbol_array_repeat1] = STATE(5231),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8561),
    [sym__string_end] = ACTIONS(8563),
  },
  [2599] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8565),
  },
  [2600] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
  },
  [2601] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8567),
    [sym__string_end] = ACTIONS(8565),
  },
  [2602] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
  },
  [2603] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_EQ_GT] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
  },
  [2604] = {
    [anon_sym_RBRACE] = ACTIONS(8569),
    [sym_comment] = ACTIONS(49),
  },
  [2605] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_or] = ACTIONS(4594),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE] = ACTIONS(4606),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [2606] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5236),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8571),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2607] = {
    [anon_sym_RBRACE] = ACTIONS(8573),
    [anon_sym_rescue] = ACTIONS(3960),
    [anon_sym_unless] = ACTIONS(3962),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3966),
    [anon_sym_while] = ACTIONS(3968),
  },
  [2608] = {
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(8575),
    [anon_sym_when] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
  },
  [2609] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8577),
    [sym_heredoc_end] = ACTIONS(8580),
    [anon_sym_POUND_LBRACE] = ACTIONS(8582),
    [sym_escape_sequence] = ACTIONS(8577),
  },
  [2610] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_COLON] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
  },
  [2611] = {
    [sym__terminator] = STATE(5238),
    [sym_heredoc_body] = STATE(5238),
    [sym__do] = STATE(5238),
    [anon_sym_do] = ACTIONS(8585),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(8585),
    [anon_sym_SEMI] = ACTIONS(8585),
    [sym_comment] = ACTIONS(49),
  },
  [2612] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
  },
  [2613] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5240),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5240),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5241),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8587),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8587),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2614] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5242),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5241),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2615] = {
    [anon_sym_end] = ACTIONS(8591),
    [sym_comment] = ACTIONS(49),
  },
  [2616] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
  },
  [2617] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5244),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8593),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2618] = {
    [anon_sym_RBRACE] = ACTIONS(8593),
    [sym_comment] = ACTIONS(49),
  },
  [2619] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
  },
  [2620] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_or] = ACTIONS(4594),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_PIPE] = ACTIONS(4606),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [2621] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(8595),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [2622] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5246),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8597),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2623] = {
    [sym__method_name] = STATE(898),
    [sym_setter] = STATE(898),
    [sym_symbol] = STATE(898),
    [sym_operator] = STATE(898),
    [sym__method_rest] = STATE(5247),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8599),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8599),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8599),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8599),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [2624] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [2625] = {
    [aux_sym_chained_string_repeat1] = STATE(2652),
    [sym_string] = STATE(2652),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2626] = {
    [sym_assignment] = STATE(5248),
    [sym_unary] = STATE(5248),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5248),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5248),
    [sym_conditional] = STATE(5248),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5248),
    [sym_binary] = STATE(5248),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2627] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [2628] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2629] = {
    [sym_assignment] = STATE(5249),
    [sym_unary] = STATE(5249),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5249),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5249),
    [sym_conditional] = STATE(5249),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5249),
    [sym_binary] = STATE(5249),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2630] = {
    [sym_heredoc_body] = STATE(5250),
    [aux_sym_call_repeat1] = STATE(5250),
    [aux_sym_argument_list_repeat1] = STATE(5251),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(4474),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2631] = {
    [sym_heredoc_body] = STATE(5250),
    [aux_sym_call_repeat1] = STATE(5250),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2632] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [2633] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [2634] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [2635] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(5252),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8601),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2636] = {
    [sym_heredoc_body] = STATE(5253),
    [aux_sym_call_repeat1] = STATE(5253),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [2637] = {
    [sym_heredoc_body] = STATE(5254),
    [aux_sym_call_repeat1] = STATE(5254),
    [aux_sym_argument_list_repeat1] = STATE(5255),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(4474),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [2638] = {
    [sym_assignment] = STATE(5256),
    [sym_unary] = STATE(5256),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5256),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5256),
    [sym_conditional] = STATE(5256),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5256),
    [sym_binary] = STATE(5256),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2639] = {
    [sym_assignment] = STATE(5257),
    [sym_unary] = STATE(5257),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5257),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5258),
    [sym_operator_assignment] = STATE(5257),
    [sym_conditional] = STATE(5257),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_subshell] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(5258),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_true] = STATE(915),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5257),
    [sym_binary] = STATE(5257),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1671),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2640] = {
    [sym_assignment] = STATE(5259),
    [sym_unary] = STATE(5259),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5259),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5259),
    [sym_conditional] = STATE(5259),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5259),
    [sym_binary] = STATE(5259),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2641] = {
    [sym_assignment] = STATE(5260),
    [sym_unary] = STATE(5260),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5260),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5260),
    [sym_conditional] = STATE(5260),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5260),
    [sym_binary] = STATE(5260),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2642] = {
    [sym_assignment] = STATE(5261),
    [sym_unary] = STATE(5261),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5261),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5261),
    [sym_conditional] = STATE(5261),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5261),
    [sym_binary] = STATE(5261),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2643] = {
    [sym_assignment] = STATE(5262),
    [sym_unary] = STATE(5262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5262),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5262),
    [sym_conditional] = STATE(5262),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5262),
    [sym_binary] = STATE(5262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2644] = {
    [sym_assignment] = STATE(5263),
    [sym_unary] = STATE(5263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5263),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5263),
    [sym_conditional] = STATE(5263),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5263),
    [sym_binary] = STATE(5263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2645] = {
    [sym_assignment] = STATE(5264),
    [sym_unary] = STATE(5264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5264),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5264),
    [sym_conditional] = STATE(5264),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5264),
    [sym_binary] = STATE(5264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2646] = {
    [sym_assignment] = STATE(5265),
    [sym_unary] = STATE(5265),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5265),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5265),
    [sym_conditional] = STATE(5265),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5265),
    [sym_binary] = STATE(5265),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2647] = {
    [sym_assignment] = STATE(5266),
    [sym_unary] = STATE(5266),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5266),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5266),
    [sym_conditional] = STATE(5266),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5266),
    [sym_binary] = STATE(5266),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2648] = {
    [sym_assignment] = STATE(5267),
    [sym_unary] = STATE(5267),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5267),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5267),
    [sym_conditional] = STATE(5267),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5267),
    [sym_binary] = STATE(5267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2649] = {
    [sym_assignment] = STATE(5268),
    [sym_unary] = STATE(5268),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5268),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(5268),
    [sym_conditional] = STATE(5268),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5268),
    [sym_binary] = STATE(5268),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2650] = {
    [sym_heredoc_body] = STATE(5273),
    [sym__argument_list_with_parens] = STATE(5272),
    [aux_sym_call_repeat1] = STATE(5273),
    [sym_argument_list_with_parens] = STATE(5271),
    [sym_operator] = STATE(5271),
    [anon_sym_LT] = ACTIONS(8603),
    [anon_sym_SLASH] = ACTIONS(8605),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8605),
    [anon_sym_PLUS_AT] = ACTIONS(8605),
    [anon_sym_LPAREN2] = ACTIONS(8607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_TILDE] = ACTIONS(8605),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_TILDE] = ACTIONS(8605),
    [anon_sym_PLUS] = ACTIONS(8603),
    [anon_sym_AMP] = ACTIONS(8605),
    [anon_sym_GT] = ACTIONS(8603),
    [anon_sym_PERCENT] = ACTIONS(8605),
    [anon_sym_DASH_AT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8603),
    [anon_sym_STAR] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8605),
    [sym_constant] = ACTIONS(8609),
    [anon_sym_DASH] = ACTIONS(8603),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8605),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8603),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8605),
    [anon_sym_STAR_STAR] = ACTIONS(8605),
    [anon_sym_PIPE] = ACTIONS(8605),
    [anon_sym_DOT_DOT] = ACTIONS(8605),
    [anon_sym_LT_EQ_GT] = ACTIONS(8605),
    [anon_sym_LT_EQ] = ACTIONS(8603),
    [anon_sym_BANG] = ACTIONS(8603),
    [sym_identifier] = ACTIONS(8609),
    [anon_sym_CARET] = ACTIONS(8605),
  },
  [2651] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8611),
    [sym_identifier] = ACTIONS(8611),
  },
  [2652] = {
    [aux_sym_chained_string_repeat1] = STATE(5275),
    [sym_string] = STATE(5275),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [2653] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
  },
  [2654] = {
    [sym_when] = STATE(5278),
    [sym_else] = STATE(5277),
    [aux_sym_case_repeat2] = STATE(5278),
    [aux_sym_case_repeat1] = STATE(5279),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8613),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8615),
    [sym_comment] = ACTIONS(49),
  },
  [2655] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
  },
  [2656] = {
    [anon_sym_end] = ACTIONS(8613),
    [sym_comment] = ACTIONS(49),
  },
  [2657] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(5277),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8613),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [2658] = {
    [sym_when] = STATE(5278),
    [sym_else] = STATE(5277),
    [aux_sym_case_repeat2] = STATE(5278),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8613),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [2659] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
  },
  [2660] = {
    [sym_heredoc_body] = STATE(5280),
    [sym__terminator] = STATE(5280),
    [sym__line_break] = ACTIONS(8617),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2661] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5281),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8619),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2662] = {
    [sym_heredoc_body] = STATE(5282),
    [sym__terminator] = STATE(5282),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(8621),
    [anon_sym_SEMI] = ACTIONS(8621),
    [sym_comment] = ACTIONS(49),
  },
  [2663] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_EQ_GT] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
  },
  [2664] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
  },
  [2665] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5283),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8623),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2666] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
  },
  [2667] = {
    [anon_sym_end] = ACTIONS(8625),
    [sym_comment] = ACTIONS(49),
  },
  [2668] = {
    [sym_ensure] = STATE(5285),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8625),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2669] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_EQ_GT] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
  },
  [2670] = {
    [sym_ensure] = STATE(5285),
    [sym_else] = STATE(5286),
    [anon_sym_end] = ACTIONS(8625),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2671] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_EQ_GT] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
  },
  [2672] = {
    [sym_assignment] = STATE(5287),
    [sym_unary] = STATE(5287),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5287),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(5287),
    [sym_conditional] = STATE(5287),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(5287),
    [sym_binary] = STATE(5287),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [2673] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [2674] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(8631),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2675] = {
    [sym_assignment] = STATE(5290),
    [sym_unary] = STATE(5290),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5290),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(5290),
    [sym_conditional] = STATE(5290),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(5290),
    [sym_binary] = STATE(5290),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [2676] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8633),
    [sym_identifier] = ACTIONS(8633),
  },
  [2677] = {
    [anon_sym_COLON] = ACTIONS(8635),
    [sym_comment] = ACTIONS(49),
  },
  [2678] = {
    [sym__argument] = STATE(5298),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(5298),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(5298),
    [sym_hash_splat_argument] = STATE(5298),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(5301),
    [sym_block_argument] = STATE(5298),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [2679] = {
    [sym_assignment] = STATE(5306),
    [sym_unary] = STATE(5306),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5306),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(5306),
    [sym_conditional] = STATE(5306),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(5306),
    [sym_binary] = STATE(5306),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2680] = {
    [sym_assignment] = STATE(5308),
    [sym_unary] = STATE(5308),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5308),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(5308),
    [sym_conditional] = STATE(5308),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(5308),
    [sym_binary] = STATE(5308),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2681] = {
    [sym__argument] = STATE(5298),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(5298),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(5298),
    [sym_hash_splat_argument] = STATE(5298),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(5301),
    [sym_block_argument] = STATE(5298),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [2682] = {
    [sym__argument] = STATE(5298),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(5298),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(5298),
    [sym_hash_splat_argument] = STATE(5298),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(5301),
    [sym_block_argument] = STATE(5298),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [2683] = {
    [sym_assignment] = STATE(5309),
    [sym_unary] = STATE(5309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5309),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(5309),
    [sym_conditional] = STATE(5309),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(5309),
    [sym_binary] = STATE(5309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2684] = {
    [sym__argument] = STATE(5298),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(5298),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(5298),
    [sym_hash_splat_argument] = STATE(5298),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym__argument_list_with_parens] = STATE(5301),
    [sym_block_argument] = STATE(5298),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(4540),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(4564),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [2685] = {
    [sym_heredoc_body] = STATE(5311),
    [aux_sym_call_repeat1] = STATE(5311),
    [aux_sym_argument_list_repeat1] = STATE(5312),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(8655),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2686] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(8657),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(8657),
    [anon_sym_SLASH_EQ] = ACTIONS(8657),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(8657),
    [anon_sym_PIPE_EQ] = ACTIONS(8657),
    [anon_sym_LT_LT_EQ] = ACTIONS(8657),
    [anon_sym_PLUS_EQ] = ACTIONS(8657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8657),
    [anon_sym_STAR_EQ] = ACTIONS(8657),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8657),
    [anon_sym_CARET_EQ] = ACTIONS(8657),
    [anon_sym_DASH_EQ] = ACTIONS(8657),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8657),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(8659),
  },
  [2687] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_EQ_GT] = ACTIONS(8635),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [2688] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(8687),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8691),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [2689] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym__primary] = STATE(2722),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_method] = STATE(2722),
    [sym_conditional] = STATE(5332),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_subshell] = STATE(2722),
    [sym_unless] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2726),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_call] = STATE(2724),
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_rational] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_lambda] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(5332),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_nil] = STATE(2726),
    [sym_symbol_array] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_scope_resolution] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2690] = {
    [anon_sym_EQ] = ACTIONS(8701),
    [sym_comment] = ACTIONS(3),
  },
  [2691] = {
    [aux_sym_chained_string_repeat1] = STATE(5335),
    [sym_string] = STATE(5335),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8703),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2692] = {
    [sym_heredoc_body] = STATE(5311),
    [aux_sym_call_repeat1] = STATE(5311),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2693] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [2694] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [2695] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2696] = {
    [sym_assignment] = STATE(5336),
    [sym_unary] = STATE(5336),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5336),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5336),
    [sym_conditional] = STATE(5336),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5336),
    [sym_binary] = STATE(5336),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2697] = {
    [sym_assignment] = STATE(5338),
    [sym_unary] = STATE(5338),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5338),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_splat_argument] = STATE(5339),
    [sym_operator_assignment] = STATE(5338),
    [sym_conditional] = STATE(5338),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_return] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_subshell] = STATE(957),
    [sym__arg_or_splat_arg] = STATE(5339),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_true] = STATE(955),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5338),
    [sym_binary] = STATE(5338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [sym_global_variable] = ACTIONS(1741),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1733),
    [sym_character] = ACTIONS(1737),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2698] = {
    [sym_assignment] = STATE(5340),
    [sym_unary] = STATE(5340),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5340),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5340),
    [sym_conditional] = STATE(5340),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5340),
    [sym_binary] = STATE(5340),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2699] = {
    [sym_assignment] = STATE(5341),
    [sym_unary] = STATE(5341),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5341),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5341),
    [sym_conditional] = STATE(5341),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5341),
    [sym_binary] = STATE(5341),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2700] = {
    [sym_assignment] = STATE(5342),
    [sym_unary] = STATE(5342),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5342),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5342),
    [sym_conditional] = STATE(5342),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5342),
    [sym_binary] = STATE(5342),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2701] = {
    [sym_assignment] = STATE(5343),
    [sym_unary] = STATE(5343),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5343),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5343),
    [sym_conditional] = STATE(5343),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5343),
    [sym_binary] = STATE(5343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2702] = {
    [sym_assignment] = STATE(5344),
    [sym_unary] = STATE(5344),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5344),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5344),
    [sym_conditional] = STATE(5344),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5344),
    [sym_binary] = STATE(5344),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2703] = {
    [sym_assignment] = STATE(5345),
    [sym_unary] = STATE(5345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5345),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5345),
    [sym_conditional] = STATE(5345),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5345),
    [sym_binary] = STATE(5345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2704] = {
    [sym_assignment] = STATE(5346),
    [sym_unary] = STATE(5346),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5346),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5346),
    [sym_conditional] = STATE(5346),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5346),
    [sym_binary] = STATE(5346),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2705] = {
    [sym_assignment] = STATE(5347),
    [sym_unary] = STATE(5347),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5347),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5347),
    [sym_conditional] = STATE(5347),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5347),
    [sym_binary] = STATE(5347),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2706] = {
    [sym_assignment] = STATE(5348),
    [sym_unary] = STATE(5348),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5348),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5348),
    [sym_conditional] = STATE(5348),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5348),
    [sym_binary] = STATE(5348),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2707] = {
    [sym_assignment] = STATE(5349),
    [sym_unary] = STATE(5349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5349),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(5349),
    [sym_conditional] = STATE(5349),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5349),
    [sym_binary] = STATE(5349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [2708] = {
    [sym_heredoc_body] = STATE(5354),
    [sym__argument_list_with_parens] = STATE(5353),
    [aux_sym_call_repeat1] = STATE(5354),
    [sym_argument_list_with_parens] = STATE(5352),
    [sym_operator] = STATE(5352),
    [anon_sym_LT] = ACTIONS(8707),
    [anon_sym_SLASH] = ACTIONS(8709),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8709),
    [anon_sym_PLUS_AT] = ACTIONS(8709),
    [anon_sym_LPAREN2] = ACTIONS(8711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_TILDE] = ACTIONS(8709),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_TILDE] = ACTIONS(8709),
    [anon_sym_PLUS] = ACTIONS(8707),
    [anon_sym_AMP] = ACTIONS(8709),
    [anon_sym_GT] = ACTIONS(8707),
    [anon_sym_PERCENT] = ACTIONS(8709),
    [anon_sym_DASH_AT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8707),
    [anon_sym_STAR] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8709),
    [sym_constant] = ACTIONS(8713),
    [anon_sym_DASH] = ACTIONS(8707),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8709),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8707),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8709),
    [anon_sym_STAR_STAR] = ACTIONS(8709),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_DOT_DOT] = ACTIONS(8709),
    [anon_sym_LT_EQ_GT] = ACTIONS(8709),
    [anon_sym_LT_EQ] = ACTIONS(8707),
    [anon_sym_BANG] = ACTIONS(8707),
    [sym_identifier] = ACTIONS(8713),
    [anon_sym_CARET] = ACTIONS(8709),
  },
  [2709] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8715),
    [sym_identifier] = ACTIONS(8715),
  },
  [2710] = {
    [sym_assignment] = STATE(5356),
    [sym_unary] = STATE(5356),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5356),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(5356),
    [sym_conditional] = STATE(5356),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(5356),
    [sym_binary] = STATE(5356),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [2711] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [2712] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(8719),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2713] = {
    [sym_assignment] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [2714] = {
    [anon_sym_COLON] = ACTIONS(8721),
    [sym_comment] = ACTIONS(49),
  },
  [2715] = {
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2716] = {
    [sym_assignment] = STATE(5369),
    [sym_unary] = STATE(5369),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(5369),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(5369),
    [sym_conditional] = STATE(5369),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(5369),
    [sym_binary] = STATE(5369),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [2717] = {
    [sym_assignment] = STATE(5374),
    [sym_unary] = STATE(5374),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(5374),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(5374),
    [sym_conditional] = STATE(5374),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(5374),
    [sym_binary] = STATE(5374),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [2718] = {
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2719] = {
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2720] = {
    [sym_assignment] = STATE(5375),
    [sym_unary] = STATE(5375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(5375),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(5375),
    [sym_conditional] = STATE(5375),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(5375),
    [sym_binary] = STATE(5375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [2721] = {
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2722] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(8687),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(8689),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(8691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [2723] = {
    [anon_sym_EQ] = ACTIONS(8749),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym__primary] = STATE(2722),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(5331),
    [sym_method] = STATE(2722),
    [sym_conditional] = STATE(5332),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_subshell] = STATE(2722),
    [sym_unless] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_block_argument] = STATE(5331),
    [sym_range] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2726),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_call] = STATE(2724),
    [sym__argument] = STATE(5331),
    [sym_assignment] = STATE(5332),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_pair] = STATE(5331),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5331),
    [sym_operator_assignment] = STATE(5332),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_rational] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_lambda] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(5334),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(5332),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_nil] = STATE(2726),
    [sym_symbol_array] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_scope_resolution] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8697),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2725] = {
    [sym_heredoc_body] = STATE(5378),
    [aux_sym_call_repeat1] = STATE(5378),
    [aux_sym_argument_list_repeat1] = STATE(5379),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(8751),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2726] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(8753),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(8753),
    [anon_sym_SLASH_EQ] = ACTIONS(8753),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(8753),
    [anon_sym_PIPE_EQ] = ACTIONS(8753),
    [anon_sym_LT_LT_EQ] = ACTIONS(8753),
    [anon_sym_PLUS_EQ] = ACTIONS(8753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8753),
    [anon_sym_STAR_EQ] = ACTIONS(8753),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8753),
    [anon_sym_CARET_EQ] = ACTIONS(8753),
    [anon_sym_DASH_EQ] = ACTIONS(8753),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8753),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(8755),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2727] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_EQ_GT] = ACTIONS(8721),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [2728] = {
    [aux_sym_chained_string_repeat1] = STATE(5390),
    [sym_string] = STATE(5390),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(8785),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2729] = {
    [sym_heredoc_body] = STATE(5378),
    [aux_sym_call_repeat1] = STATE(5378),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2730] = {
    [aux_sym_chained_string_repeat1] = STATE(5391),
    [sym_string] = STATE(5391),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [2731] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(5393),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(5393),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8787),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [2732] = {
    [sym_elsif] = STATE(5393),
    [sym_else] = STATE(5393),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8789),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [2733] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_EQ_GT] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
  },
  [2734] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8791),
  },
  [2735] = {
    [aux_sym_string_array_repeat1] = STATE(5397),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8793),
    [sym__string_end] = ACTIONS(8795),
  },
  [2736] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8797),
  },
  [2737] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_EQ_GT] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
  },
  [2738] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8799),
    [sym__string_end] = ACTIONS(8797),
  },
  [2739] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [2740] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(965),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [2741] = {
    [sym_assignment] = STATE(5400),
    [sym_unary] = STATE(5400),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(5400),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(5400),
    [sym_conditional] = STATE(5400),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(5400),
    [sym_binary] = STATE(5400),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [2742] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(929),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [2743] = {
    [sym_assignment] = STATE(5401),
    [sym_unary] = STATE(5401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(5401),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(5401),
    [sym_conditional] = STATE(5401),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(5401),
    [sym_binary] = STATE(5401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [2744] = {
    [sym_assignment] = STATE(873),
    [sym_unary] = STATE(873),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(873),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(873),
    [sym_conditional] = STATE(873),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(873),
    [sym_binary] = STATE(873),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [2745] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(943),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [2746] = {
    [sym_assignment] = STATE(5402),
    [sym_unary] = STATE(5402),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(5402),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(5402),
    [sym_conditional] = STATE(5402),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(5402),
    [sym_binary] = STATE(5402),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [2747] = {
    [sym__argument] = STATE(2630),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2630),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2630),
    [sym_hash_splat_argument] = STATE(2630),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(921),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(2631),
    [sym_block_argument] = STATE(2630),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [2748] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [2749] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(8801),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(8801),
    [anon_sym_SLASH_EQ] = ACTIONS(8801),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(8801),
    [anon_sym_PIPE_EQ] = ACTIONS(8801),
    [anon_sym_LT_LT_EQ] = ACTIONS(8801),
    [anon_sym_PLUS_EQ] = ACTIONS(8801),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8801),
    [anon_sym_STAR_EQ] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8801),
    [anon_sym_CARET_EQ] = ACTIONS(8801),
    [anon_sym_DASH_EQ] = ACTIONS(8801),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8801),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(8803),
  },
  [2750] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [2751] = {
    [anon_sym_EQ] = ACTIONS(8831),
    [sym_comment] = ACTIONS(3),
  },
  [2752] = {
    [aux_sym_chained_string_repeat1] = STATE(5414),
    [sym_string] = STATE(5414),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2753] = {
    [aux_sym_exceptions_repeat1] = STATE(5416),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [2754] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [2755] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2756] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(8835),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [2757] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [2758] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2759] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [2760] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [2761] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2762] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2763] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [2764] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [2765] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(5419),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(8837),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2766] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [2767] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [2768] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(2767),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(5420),
    [sym_operator] = STATE(5420),
    [anon_sym_LT] = ACTIONS(4682),
    [anon_sym_SLASH] = ACTIONS(4684),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4684),
    [anon_sym_PLUS_AT] = ACTIONS(4684),
    [anon_sym_LPAREN2] = ACTIONS(4686),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4684),
    [anon_sym_GT_GT] = ACTIONS(4684),
    [anon_sym_EQ_TILDE] = ACTIONS(4684),
    [anon_sym_LT_LT] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4682),
    [anon_sym_PERCENT] = ACTIONS(4684),
    [anon_sym_DASH_AT] = ACTIONS(4684),
    [anon_sym_EQ_EQ] = ACTIONS(4682),
    [anon_sym_STAR] = ACTIONS(4682),
    [anon_sym_BANG_TILDE] = ACTIONS(4684),
    [sym_constant] = ACTIONS(8839),
    [anon_sym_DASH] = ACTIONS(4682),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_STAR_STAR] = ACTIONS(4684),
    [anon_sym_PIPE] = ACTIONS(4684),
    [anon_sym_DOT_DOT] = ACTIONS(4684),
    [anon_sym_LT_EQ_GT] = ACTIONS(4684),
    [anon_sym_LT_EQ] = ACTIONS(4682),
    [anon_sym_BANG] = ACTIONS(4682),
    [sym_identifier] = ACTIONS(8839),
    [anon_sym_CARET] = ACTIONS(4684),
  },
  [2769] = {
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_SLASH] = ACTIONS(6733),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_EQ_GT] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [2770] = {
    [anon_sym_RBRACK] = ACTIONS(8841),
    [sym_comment] = ACTIONS(49),
  },
  [2771] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [2772] = {
    [aux_sym_heredoc_body_repeat1] = STATE(5423),
    [sym_interpolation] = STATE(5423),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8843),
    [sym_heredoc_end] = ACTIONS(8845),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(8843),
  },
  [2773] = {
    [anon_sym_RBRACE] = ACTIONS(8847),
    [sym__heredoc_body_start] = ACTIONS(8847),
    [sym_comment] = ACTIONS(49),
  },
  [2774] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(5424),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(8847),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(8847),
    [sym_instance_variable] = ACTIONS(323),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [2775] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [sym__line_break] = ACTIONS(8851),
    [anon_sym_then] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_when] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym___END__] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_end] = ACTIONS(8851),
    [anon_sym_ensure] = ACTIONS(8851),
    [anon_sym_else] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_elsif] = ACTIONS(8851),
    [ts_builtin_sym_end] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
    [sym__binary_minus] = ACTIONS(8851),
  },
  [2776] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [2777] = {
    [aux_sym_chained_string_repeat1] = STATE(2807),
    [sym_string] = STATE(2807),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2778] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [2779] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5426),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8853),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2780] = {
    [anon_sym_RBRACE] = ACTIONS(8853),
    [sym_comment] = ACTIONS(49),
  },
  [2781] = {
    [sym_assignment] = STATE(5427),
    [sym_unary] = STATE(5427),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5427),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5427),
    [sym_conditional] = STATE(5427),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5427),
    [sym_binary] = STATE(5427),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2782] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [2783] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [2784] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5429),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5429),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5430),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8855),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8855),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8857),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2785] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5431),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5430),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8857),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2786] = {
    [anon_sym_end] = ACTIONS(8859),
    [sym_comment] = ACTIONS(49),
  },
  [2787] = {
    [sym_assignment] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2788] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [2789] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [2790] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [2791] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(2779),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(2780),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8861),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2792] = {
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_SLASH] = ACTIONS(6989),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_EQ_GT] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [2793] = {
    [sym_assignment] = STATE(5434),
    [sym_unary] = STATE(5434),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5434),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5435),
    [sym_operator_assignment] = STATE(5434),
    [sym_conditional] = STATE(5434),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_subshell] = STATE(999),
    [sym__arg_or_splat_arg] = STATE(5435),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5434),
    [sym_binary] = STATE(5434),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2794] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_heredoc_body] = STATE(5436),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1805),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(1829),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2795] = {
    [sym_heredoc_body] = STATE(5437),
    [aux_sym_call_repeat1] = STATE(5437),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2796] = {
    [sym_heredoc_body] = STATE(5438),
    [aux_sym_call_repeat1] = STATE(5438),
    [aux_sym_argument_list_repeat1] = STATE(5439),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(4722),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [2797] = {
    [sym_assignment] = STATE(5440),
    [sym_unary] = STATE(5440),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5440),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5440),
    [sym_conditional] = STATE(5440),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5440),
    [sym_binary] = STATE(5440),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2798] = {
    [sym_assignment] = STATE(5441),
    [sym_unary] = STATE(5441),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5441),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5441),
    [sym_conditional] = STATE(5441),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5441),
    [sym_binary] = STATE(5441),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2799] = {
    [sym_assignment] = STATE(5442),
    [sym_unary] = STATE(5442),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5442),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5442),
    [sym_conditional] = STATE(5442),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5442),
    [sym_binary] = STATE(5442),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2800] = {
    [sym_assignment] = STATE(5443),
    [sym_unary] = STATE(5443),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5443),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5443),
    [sym_conditional] = STATE(5443),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5443),
    [sym_binary] = STATE(5443),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2801] = {
    [sym_assignment] = STATE(5444),
    [sym_unary] = STATE(5444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5444),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5444),
    [sym_conditional] = STATE(5444),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5444),
    [sym_binary] = STATE(5444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2802] = {
    [sym_assignment] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2803] = {
    [sym_assignment] = STATE(5446),
    [sym_unary] = STATE(5446),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5446),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5446),
    [sym_conditional] = STATE(5446),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5446),
    [sym_binary] = STATE(5446),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2804] = {
    [sym_assignment] = STATE(5448),
    [sym_unary] = STATE(5448),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5448),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5448),
    [sym_conditional] = STATE(5448),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5448),
    [sym_binary] = STATE(5448),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2805] = {
    [sym_assignment] = STATE(5449),
    [sym_unary] = STATE(5449),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5449),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5449),
    [sym_conditional] = STATE(5449),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5449),
    [sym_binary] = STATE(5449),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2806] = {
    [sym_assignment] = STATE(5450),
    [sym_unary] = STATE(5450),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5450),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(5450),
    [sym_conditional] = STATE(5450),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5450),
    [sym_binary] = STATE(5450),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [2807] = {
    [aux_sym_chained_string_repeat1] = STATE(5451),
    [sym_string] = STATE(5451),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [2808] = {
    [aux_sym_chained_string_repeat1] = STATE(2808),
    [sym_string] = STATE(2808),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8865),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [2809] = {
    [sym__line_break] = ACTIONS(8868),
    [anon_sym_then] = ACTIONS(8868),
    [anon_sym_until] = ACTIONS(8868),
    [anon_sym___END__] = ACTIONS(8868),
    [anon_sym_while] = ACTIONS(8868),
    [sym__heredoc_body_start] = ACTIONS(8868),
    [anon_sym_end] = ACTIONS(8868),
    [anon_sym_ensure] = ACTIONS(8868),
    [anon_sym_RPAREN] = ACTIONS(8868),
    [anon_sym_SEMI] = ACTIONS(8868),
    [anon_sym_else] = ACTIONS(8868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(8868),
    [anon_sym_elsif] = ACTIONS(8868),
    [anon_sym_unless] = ACTIONS(8868),
    [ts_builtin_sym_end] = ACTIONS(8868),
    [anon_sym_rescue] = ACTIONS(8868),
    [anon_sym_when] = ACTIONS(8868),
    [anon_sym_if] = ACTIONS(8868),
  },
  [2810] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [sym__line_break] = ACTIONS(8872),
    [anon_sym_then] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_when] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym___END__] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_end] = ACTIONS(8872),
    [anon_sym_ensure] = ACTIONS(8872),
    [anon_sym_else] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_elsif] = ACTIONS(8872),
    [ts_builtin_sym_end] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
    [sym__binary_minus] = ACTIONS(8872),
  },
  [2811] = {
    [anon_sym_end] = ACTIONS(8874),
    [sym_comment] = ACTIONS(49),
  },
  [2812] = {
    [sym__string_end] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(8060),
    [sym__string_content] = ACTIONS(8058),
    [sym_escape_sequence] = ACTIONS(8058),
  },
  [2813] = {
    [sym_assignment] = STATE(5453),
    [sym_unary] = STATE(5453),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(5453),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(5453),
    [sym_conditional] = STATE(5453),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(5453),
    [sym_binary] = STATE(5453),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [2814] = {
    [sym_assignment] = STATE(5454),
    [sym_unary] = STATE(5454),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(5454),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(5454),
    [sym_conditional] = STATE(5454),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(5454),
    [sym_binary] = STATE(5454),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [2815] = {
    [sym__argument] = STATE(5460),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5460),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5460),
    [sym_hash_splat_argument] = STATE(5460),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym_block_argument] = STATE(5460),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [2816] = {
    [sym__argument] = STATE(5460),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5460),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5460),
    [sym_hash_splat_argument] = STATE(5460),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym_block_argument] = STATE(5460),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [2817] = {
    [sym_assignment] = STATE(5464),
    [sym_unary] = STATE(5464),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(5464),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(5464),
    [sym_conditional] = STATE(5464),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(5464),
    [sym_binary] = STATE(5464),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [2818] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [2819] = {
    [sym__argument] = STATE(5460),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5460),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5460),
    [sym_hash_splat_argument] = STATE(5460),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym_block_argument] = STATE(5460),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [2820] = {
    [sym_assignment] = STATE(5465),
    [sym_unary] = STATE(5465),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(5465),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(5465),
    [sym_conditional] = STATE(5465),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(5465),
    [sym_binary] = STATE(5465),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [2821] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(8884),
    [sym_identifier] = ACTIONS(8884),
  },
  [2822] = {
    [sym__argument] = STATE(5460),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5460),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5460),
    [sym_hash_splat_argument] = STATE(5460),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym_block_argument] = STATE(5460),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1691),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [2823] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(8886),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(8886),
    [anon_sym_SLASH_EQ] = ACTIONS(8886),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(8886),
    [anon_sym_PIPE_EQ] = ACTIONS(8886),
    [anon_sym_LT_LT_EQ] = ACTIONS(8886),
    [anon_sym_PLUS_EQ] = ACTIONS(8886),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8886),
    [anon_sym_STAR_EQ] = ACTIONS(8886),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8886),
    [anon_sym_CARET_EQ] = ACTIONS(8886),
    [anon_sym_DASH_EQ] = ACTIONS(8886),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8886),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(8888),
  },
  [2824] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8902),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_and] = ACTIONS(8902),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_PIPE] = ACTIONS(8914),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [2825] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(8918),
    [anon_sym_DOT] = ACTIONS(8920),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(8922),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
  },
  [2826] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(5487),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(5487),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2827] = {
    [anon_sym_EQ] = ACTIONS(8932),
    [sym_comment] = ACTIONS(3),
  },
  [2828] = {
    [aux_sym_chained_string_repeat1] = STATE(5490),
    [sym_string] = STATE(5490),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2829] = {
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
  },
  [2830] = {
    [anon_sym_RPAREN] = ACTIONS(8934),
    [sym_comment] = ACTIONS(49),
  },
  [2831] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8902),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_and] = ACTIONS(8902),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_PIPE] = ACTIONS(8914),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [2832] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8902),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_and] = ACTIONS(8902),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_PIPE] = ACTIONS(8914),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [2833] = {
    [aux_sym_heredoc_body_repeat1] = STATE(5493),
    [sym_interpolation] = STATE(5493),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8936),
    [sym_heredoc_end] = ACTIONS(8938),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(8936),
  },
  [2834] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(5494),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [2835] = {
    [sym_heredoc_body] = STATE(5495),
    [aux_sym_call_repeat1] = STATE(5495),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_DOT] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
  },
  [2836] = {
    [sym_heredoc_body] = STATE(5496),
    [aux_sym_call_repeat1] = STATE(5496),
    [aux_sym_argument_list_repeat1] = STATE(5497),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_DOT] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
  },
  [2837] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
  },
  [2838] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8940),
  },
  [2839] = {
    [aux_sym_string_array_repeat1] = STATE(5501),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8942),
    [sym__string_end] = ACTIONS(8944),
  },
  [2840] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8946),
  },
  [2841] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
  },
  [2842] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8948),
    [sym__string_end] = ACTIONS(8946),
  },
  [2843] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5505),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8950),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2844] = {
    [sym_when] = STATE(5508),
    [sym_else] = STATE(5507),
    [aux_sym_case_repeat2] = STATE(5508),
    [aux_sym_case_repeat1] = STATE(5509),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8952),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(8954),
    [sym_comment] = ACTIONS(49),
  },
  [2845] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
  },
  [2846] = {
    [anon_sym_end] = ACTIONS(8952),
    [sym_comment] = ACTIONS(49),
  },
  [2847] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(5507),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8952),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [2848] = {
    [sym_when] = STATE(5508),
    [sym_else] = STATE(5507),
    [aux_sym_case_repeat2] = STATE(5508),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(8952),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [2849] = {
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
  },
  [2850] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
  },
  [2851] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(5511),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8956),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [2852] = {
    [sym_else] = STATE(5511),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(8958),
    [sym_comment] = ACTIONS(49),
  },
  [2853] = {
    [sym_heredoc_body] = STATE(5512),
    [sym__terminator] = STATE(5512),
    [sym__line_break] = ACTIONS(8960),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(8960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [2854] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5513),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8962),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2855] = {
    [sym_heredoc_body] = STATE(5514),
    [sym__terminator] = STATE(5514),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(8964),
    [anon_sym_SEMI] = ACTIONS(8964),
    [sym_comment] = ACTIONS(49),
  },
  [2856] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
  },
  [2857] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5515),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8966),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2858] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
  },
  [2859] = {
    [anon_sym_end] = ACTIONS(8968),
    [sym_comment] = ACTIONS(49),
  },
  [2860] = {
    [sym_ensure] = STATE(5517),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(8968),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [2861] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
  },
  [2862] = {
    [sym_ensure] = STATE(5517),
    [sym_else] = STATE(5518),
    [anon_sym_end] = ACTIONS(8968),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [2863] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
  },
  [2864] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
  },
  [2865] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(8970),
  },
  [2866] = {
    [aux_sym_symbol_array_repeat1] = STATE(5522),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8972),
    [sym__string_end] = ACTIONS(8974),
  },
  [2867] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(8976),
  },
  [2868] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
  },
  [2869] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(8978),
    [sym__string_end] = ACTIONS(8976),
  },
  [2870] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
  },
  [2871] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
  },
  [2872] = {
    [anon_sym_RBRACE] = ACTIONS(8980),
    [sym_comment] = ACTIONS(49),
  },
  [2873] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5527),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8982),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2874] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
  },
  [2875] = {
    [sym__terminator] = STATE(5528),
    [sym_heredoc_body] = STATE(5528),
    [sym__do] = STATE(5528),
    [anon_sym_do] = ACTIONS(8984),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(8984),
    [anon_sym_SEMI] = ACTIONS(8984),
    [sym_comment] = ACTIONS(49),
  },
  [2876] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
  },
  [2877] = {
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_in] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
  },
  [2878] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5530),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5530),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5531),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(8986),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(8986),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8988),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2879] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5532),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5531),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8988),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2880] = {
    [anon_sym_end] = ACTIONS(8990),
    [sym_comment] = ACTIONS(49),
  },
  [2881] = {
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
  },
  [2882] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5534),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(8992),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [2883] = {
    [anon_sym_RBRACE] = ACTIONS(8992),
    [sym_comment] = ACTIONS(49),
  },
  [2884] = {
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
  },
  [2885] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(8994),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [2886] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5536),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(8996),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [2887] = {
    [sym__method_name] = STATE(1073),
    [sym_setter] = STATE(1073),
    [sym_symbol] = STATE(1073),
    [sym_operator] = STATE(1073),
    [sym__method_rest] = STATE(5537),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8998),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8998),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8998),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8998),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [2888] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(5539),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(5539),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9000),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [2889] = {
    [sym_elsif] = STATE(5539),
    [sym_else] = STATE(5539),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(9002),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [2890] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [sym__symbol_start] = ACTIONS(461),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(393),
  },
  [2891] = {
    [aux_sym__mlhs_repeat1] = STATE(2891),
    [anon_sym_in] = ACTIONS(6710),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(9006),
  },
  [2892] = {
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [sym_self] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(1327),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_in] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [anon_sym_next] = ACTIONS(1327),
    [sym_retry] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1327),
  },
  [2893] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(5542),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(9009),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [2894] = {
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [sym_self] = ACTIONS(6719),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_nil] = ACTIONS(6719),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_in] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [anon_sym_next] = ACTIONS(6719),
    [sym_retry] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6721),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_return] = ACTIONS(6719),
  },
  [2895] = {
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [sym_self] = ACTIONS(6727),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_nil] = ACTIONS(6727),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_in] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [anon_sym_next] = ACTIONS(6727),
    [sym_retry] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(6727),
  },
  [2896] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(2895),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(5543),
    [sym_operator] = STATE(5543),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_SLASH] = ACTIONS(4890),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4890),
    [anon_sym_PLUS_AT] = ACTIONS(4890),
    [anon_sym_LPAREN2] = ACTIONS(4892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4890),
    [anon_sym_GT_GT] = ACTIONS(4890),
    [anon_sym_EQ_TILDE] = ACTIONS(4890),
    [anon_sym_LT_LT] = ACTIONS(4890),
    [anon_sym_TILDE] = ACTIONS(4890),
    [anon_sym_PLUS] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4890),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_PERCENT] = ACTIONS(4890),
    [anon_sym_DASH_AT] = ACTIONS(4890),
    [anon_sym_EQ_EQ] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4888),
    [anon_sym_BANG_TILDE] = ACTIONS(4890),
    [sym_constant] = ACTIONS(9011),
    [anon_sym_DASH] = ACTIONS(4888),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(4890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4888),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_STAR_STAR] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(4890),
    [anon_sym_DOT_DOT] = ACTIONS(4890),
    [anon_sym_LT_EQ_GT] = ACTIONS(4890),
    [anon_sym_LT_EQ] = ACTIONS(4888),
    [anon_sym_BANG] = ACTIONS(4888),
    [sym_identifier] = ACTIONS(9011),
    [anon_sym_CARET] = ACTIONS(4890),
  },
  [2897] = {
    [anon_sym_DOT] = ACTIONS(6735),
    [anon_sym_in] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_EQ] = ACTIONS(6735),
    [sym_comment] = ACTIONS(49),
  },
  [2898] = {
    [anon_sym_RBRACK] = ACTIONS(9013),
    [sym_comment] = ACTIONS(49),
  },
  [2899] = {
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [2900] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [2901] = {
    [aux_sym_chained_string_repeat1] = STATE(2969),
    [sym_string] = STATE(2969),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2902] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(5210),
  },
  [2903] = {
    [sym_assignment] = STATE(5545),
    [sym_unary] = STATE(5545),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(5545),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(5545),
    [sym_conditional] = STATE(5545),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(5545),
    [sym_binary] = STATE(5545),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [2904] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [2905] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2906] = {
    [sym_assignment] = STATE(5546),
    [sym_unary] = STATE(5546),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(5546),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(5546),
    [sym_conditional] = STATE(5546),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(5546),
    [sym_binary] = STATE(5546),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [2907] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9015),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2908] = {
    [anon_sym_COLON] = ACTIONS(9017),
    [sym_comment] = ACTIONS(49),
  },
  [2909] = {
    [sym_assignment] = STATE(5549),
    [sym_unary] = STATE(5549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5549),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5549),
    [sym_conditional] = STATE(5549),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5549),
    [sym_binary] = STATE(5549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2910] = {
    [sym_assignment] = STATE(5550),
    [sym_unary] = STATE(5550),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5550),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5550),
    [sym_conditional] = STATE(5550),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5550),
    [sym_binary] = STATE(5550),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2911] = {
    [sym_assignment] = STATE(5551),
    [sym_unary] = STATE(5551),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5551),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5551),
    [sym_conditional] = STATE(5551),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5551),
    [sym_binary] = STATE(5551),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2912] = {
    [sym_heredoc_body] = STATE(5553),
    [aux_sym_call_repeat1] = STATE(5553),
    [aux_sym_argument_list_repeat1] = STATE(5554),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9019),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2913] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [2914] = {
    [aux_sym_chained_string_repeat1] = STATE(2969),
    [sym_string] = STATE(2969),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9021),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2915] = {
    [sym_heredoc_body] = STATE(5553),
    [aux_sym_call_repeat1] = STATE(5553),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [2916] = {
    [sym__argument] = STATE(5560),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(5560),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5560),
    [sym_hash_splat_argument] = STATE(5560),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(5563),
    [sym_block_argument] = STATE(5560),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(753),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [2917] = {
    [sym__argument] = STATE(5560),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(5560),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5560),
    [sym_hash_splat_argument] = STATE(5560),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(5563),
    [sym_block_argument] = STATE(5560),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(647),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [2918] = {
    [sym_assignment] = STATE(5564),
    [sym_unary] = STATE(5564),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(5564),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(5564),
    [sym_conditional] = STATE(5564),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(5564),
    [sym_binary] = STATE(5564),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [2919] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [2920] = {
    [sym__argument] = STATE(5560),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(5560),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5560),
    [sym_hash_splat_argument] = STATE(5560),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(5563),
    [sym_block_argument] = STATE(5560),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [2921] = {
    [sym_assignment] = STATE(5565),
    [sym_unary] = STATE(5565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(5565),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(5565),
    [sym_conditional] = STATE(5565),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(5565),
    [sym_binary] = STATE(5565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [2922] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9031),
    [sym_identifier] = ACTIONS(9031),
  },
  [2923] = {
    [sym__argument] = STATE(5560),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(5560),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5560),
    [sym_hash_splat_argument] = STATE(5560),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym__argument_list_with_parens] = STATE(5563),
    [sym_block_argument] = STATE(5560),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1929),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(1955),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_in] = ACTIONS(501),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [2924] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9033),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9033),
    [anon_sym_SLASH_EQ] = ACTIONS(9033),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9033),
    [anon_sym_PIPE_EQ] = ACTIONS(9033),
    [anon_sym_LT_LT_EQ] = ACTIONS(9033),
    [anon_sym_PLUS_EQ] = ACTIONS(9033),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9033),
    [anon_sym_STAR_EQ] = ACTIONS(9033),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9033),
    [anon_sym_CARET_EQ] = ACTIONS(9033),
    [anon_sym_DASH_EQ] = ACTIONS(9033),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9033),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9035),
  },
  [2925] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(9049),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [anon_sym_and] = ACTIONS(9049),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9061),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [2926] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_in] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(9065),
    [anon_sym_DOT] = ACTIONS(9067),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9069),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [2927] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym__primary] = STATE(2948),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(5588),
    [sym_method] = STATE(2948),
    [sym_conditional] = STATE(5589),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_subshell] = STATE(2948),
    [sym_unless] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_block_argument] = STATE(5588),
    [sym_range] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2951),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_call] = STATE(1101),
    [sym__argument] = STATE(5588),
    [sym_assignment] = STATE(5589),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_pair] = STATE(5588),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5588),
    [sym_operator_assignment] = STATE(5589),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_rational] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_lambda] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(5591),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(5589),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_nil] = STATE(2951),
    [sym_symbol_array] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_scope_resolution] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(791),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2928] = {
    [anon_sym_EQ] = ACTIONS(9081),
    [sym_comment] = ACTIONS(3),
  },
  [2929] = {
    [aux_sym_chained_string_repeat1] = STATE(5592),
    [sym_string] = STATE(5592),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [2930] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(9049),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [anon_sym_and] = ACTIONS(9049),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9061),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [2931] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(9049),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [anon_sym_and] = ACTIONS(9049),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9061),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [2932] = {
    [sym_heredoc_body] = STATE(5597),
    [sym__argument_list_with_parens] = STATE(5596),
    [aux_sym_call_repeat1] = STATE(5597),
    [sym_argument_list_with_parens] = STATE(5595),
    [sym_operator] = STATE(5595),
    [anon_sym_LT] = ACTIONS(9083),
    [anon_sym_SLASH] = ACTIONS(9085),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9085),
    [anon_sym_PLUS_AT] = ACTIONS(9085),
    [anon_sym_LPAREN2] = ACTIONS(9087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9085),
    [anon_sym_GT_GT] = ACTIONS(9085),
    [anon_sym_EQ_TILDE] = ACTIONS(9085),
    [anon_sym_LT_LT] = ACTIONS(9085),
    [anon_sym_TILDE] = ACTIONS(9085),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_AMP] = ACTIONS(9085),
    [anon_sym_GT] = ACTIONS(9083),
    [anon_sym_PERCENT] = ACTIONS(9085),
    [anon_sym_DASH_AT] = ACTIONS(9085),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_STAR] = ACTIONS(9083),
    [anon_sym_BANG_TILDE] = ACTIONS(9085),
    [sym_constant] = ACTIONS(9089),
    [anon_sym_DASH] = ACTIONS(9083),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9083),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9085),
    [anon_sym_STAR_STAR] = ACTIONS(9085),
    [anon_sym_PIPE] = ACTIONS(9085),
    [anon_sym_DOT_DOT] = ACTIONS(9085),
    [anon_sym_LT_EQ_GT] = ACTIONS(9085),
    [anon_sym_LT_EQ] = ACTIONS(9083),
    [anon_sym_BANG] = ACTIONS(9083),
    [sym_identifier] = ACTIONS(9089),
    [anon_sym_CARET] = ACTIONS(9085),
  },
  [2933] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9091),
    [sym_identifier] = ACTIONS(9091),
  },
  [2934] = {
    [anon_sym_DOT] = ACTIONS(6991),
    [anon_sym_in] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_EQ] = ACTIONS(6991),
    [sym_comment] = ACTIONS(49),
  },
  [2935] = {
    [sym_assignment] = STATE(5599),
    [sym_unary] = STATE(5599),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5599),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5600),
    [sym_operator_assignment] = STATE(5599),
    [sym_conditional] = STATE(5599),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_subshell] = STATE(1098),
    [sym__arg_or_splat_arg] = STATE(5600),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5599),
    [sym_binary] = STATE(5599),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1931),
    [sym_character] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2936] = {
    [sym_assignment] = STATE(5601),
    [sym_unary] = STATE(5601),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5601),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(5601),
    [sym_conditional] = STATE(5601),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(5601),
    [sym_binary] = STATE(5601),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2937] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2938] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9095),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2939] = {
    [sym_assignment] = STATE(5604),
    [sym_unary] = STATE(5604),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5604),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(5604),
    [sym_conditional] = STATE(5604),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(5604),
    [sym_binary] = STATE(5604),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2940] = {
    [anon_sym_COLON] = ACTIONS(9097),
    [sym_comment] = ACTIONS(49),
  },
  [2941] = {
    [sym__argument] = STATE(2950),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(2950),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(2950),
    [sym_hash_splat_argument] = STATE(2950),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(2954),
    [sym_block_argument] = STATE(2950),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(4972),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(501),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2942] = {
    [sym_assignment] = STATE(5606),
    [sym_unary] = STATE(5606),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5606),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(5606),
    [sym_conditional] = STATE(5606),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(5606),
    [sym_binary] = STATE(5606),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2943] = {
    [sym_assignment] = STATE(5607),
    [sym_unary] = STATE(5607),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5607),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(5607),
    [sym_conditional] = STATE(5607),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(5607),
    [sym_binary] = STATE(5607),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2944] = {
    [sym__argument] = STATE(2950),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(2950),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(2950),
    [sym_hash_splat_argument] = STATE(2950),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(2954),
    [sym_block_argument] = STATE(2950),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(4972),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(647),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2945] = {
    [sym__argument] = STATE(2950),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(2950),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(2950),
    [sym_hash_splat_argument] = STATE(2950),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(2954),
    [sym_block_argument] = STATE(2950),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(4972),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(737),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2946] = {
    [sym_assignment] = STATE(5608),
    [sym_unary] = STATE(5608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5608),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(5608),
    [sym_conditional] = STATE(5608),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(5608),
    [sym_binary] = STATE(5608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [2947] = {
    [sym__argument] = STATE(2950),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(2950),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(2950),
    [sym_hash_splat_argument] = STATE(2950),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(2954),
    [sym_block_argument] = STATE(2950),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(4972),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(753),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [2948] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_in] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(4948),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4950),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4952),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [2949] = {
    [anon_sym_EQ] = ACTIONS(9099),
    [sym_comment] = ACTIONS(3),
  },
  [2950] = {
    [sym_heredoc_body] = STATE(5611),
    [aux_sym_call_repeat1] = STATE(5611),
    [aux_sym_argument_list_repeat1] = STATE(5612),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9101),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2951] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9103),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9103),
    [anon_sym_SLASH_EQ] = ACTIONS(9103),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9103),
    [anon_sym_PIPE_EQ] = ACTIONS(9103),
    [anon_sym_LT_LT_EQ] = ACTIONS(9103),
    [anon_sym_PLUS_EQ] = ACTIONS(9103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9103),
    [anon_sym_STAR_EQ] = ACTIONS(9103),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9103),
    [anon_sym_CARET_EQ] = ACTIONS(9103),
    [anon_sym_DASH_EQ] = ACTIONS(9103),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9103),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(9105),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2952] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [2953] = {
    [aux_sym_chained_string_repeat1] = STATE(5623),
    [sym_string] = STATE(5623),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9135),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2954] = {
    [sym_heredoc_body] = STATE(5611),
    [aux_sym_call_repeat1] = STATE(5611),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [2955] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1104),
    [sym_unary] = STATE(1104),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(1104),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1104),
    [sym_conditional] = STATE(1104),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(1105),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_heredoc_body] = STATE(5624),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1104),
    [sym_binary] = STATE(1104),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1941),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(1949),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(1953),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1965),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2956] = {
    [sym_heredoc_body] = STATE(5625),
    [aux_sym_call_repeat1] = STATE(5625),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [2957] = {
    [sym_heredoc_body] = STATE(5626),
    [aux_sym_call_repeat1] = STATE(5626),
    [aux_sym_argument_list_repeat1] = STATE(5627),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [2958] = {
    [sym_assignment] = STATE(5628),
    [sym_unary] = STATE(5628),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5628),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5628),
    [sym_conditional] = STATE(5628),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5628),
    [sym_binary] = STATE(5628),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2959] = {
    [sym_assignment] = STATE(5629),
    [sym_unary] = STATE(5629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5629),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5629),
    [sym_conditional] = STATE(5629),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5629),
    [sym_binary] = STATE(5629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2960] = {
    [sym_assignment] = STATE(5630),
    [sym_unary] = STATE(5630),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5630),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5630),
    [sym_conditional] = STATE(5630),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5630),
    [sym_binary] = STATE(5630),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2961] = {
    [sym_assignment] = STATE(5631),
    [sym_unary] = STATE(5631),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5631),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5631),
    [sym_conditional] = STATE(5631),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5631),
    [sym_binary] = STATE(5631),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [2962] = {
    [sym_assignment] = STATE(5632),
    [sym_unary] = STATE(5632),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5632),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5632),
    [sym_conditional] = STATE(5632),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5632),
    [sym_binary] = STATE(5632),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2963] = {
    [sym_assignment] = STATE(5633),
    [sym_unary] = STATE(5633),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5633),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5633),
    [sym_conditional] = STATE(5633),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5633),
    [sym_binary] = STATE(5633),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2964] = {
    [sym_assignment] = STATE(5634),
    [sym_unary] = STATE(5634),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5634),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5634),
    [sym_conditional] = STATE(5634),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5634),
    [sym_binary] = STATE(5634),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2965] = {
    [sym_assignment] = STATE(5635),
    [sym_unary] = STATE(5635),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5635),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5635),
    [sym_conditional] = STATE(5635),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5635),
    [sym_binary] = STATE(5635),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2966] = {
    [sym_assignment] = STATE(5636),
    [sym_unary] = STATE(5636),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5636),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5636),
    [sym_conditional] = STATE(5636),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5636),
    [sym_binary] = STATE(5636),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2967] = {
    [sym_assignment] = STATE(5637),
    [sym_unary] = STATE(5637),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5637),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5637),
    [sym_conditional] = STATE(5637),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5637),
    [sym_binary] = STATE(5637),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2968] = {
    [sym_assignment] = STATE(5638),
    [sym_unary] = STATE(5638),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5638),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(5638),
    [sym_conditional] = STATE(5638),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5638),
    [sym_binary] = STATE(5638),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [2969] = {
    [aux_sym_chained_string_repeat1] = STATE(5639),
    [sym_string] = STATE(5639),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [2970] = {
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym_string] = STATE(2970),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9137),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
  },
  [2971] = {
    [sym__line_break] = ACTIONS(9140),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(9140),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(9140),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9140),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [2972] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5641),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9142),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [2973] = {
    [aux_sym_undef_repeat1] = STATE(5642),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [2974] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [2975] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [2976] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(9144),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [2977] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [2978] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [2979] = {
    [sym__line_break] = ACTIONS(9146),
    [sym_float] = ACTIONS(9148),
    [anon_sym_until] = ACTIONS(9148),
    [anon_sym_undef] = ACTIONS(9148),
    [sym_self] = ACTIONS(9148),
    [anon_sym_BEGIN] = ACTIONS(9148),
    [anon_sym_TILDE] = ACTIONS(9146),
    [anon_sym_unless] = ACTIONS(9148),
    [anon_sym_PLUS] = ACTIONS(9148),
    [sym__symbol_array_start] = ACTIONS(9146),
    [sym__simple_symbol] = ACTIONS(9146),
    [sym_complex] = ACTIONS(9146),
    [sym_heredoc_beginning] = ACTIONS(9146),
    [sym_super] = ACTIONS(9148),
    [anon_sym_alias] = ACTIONS(9148),
    [anon_sym_LBRACK2] = ACTIONS(9146),
    [anon_sym_nil] = ACTIONS(9148),
    [sym_character] = ACTIONS(9146),
    [anon_sym_LBRACE] = ACTIONS(9146),
    [anon_sym_END] = ACTIONS(9148),
    [sym_constant] = ACTIONS(9148),
    [anon_sym_while] = ACTIONS(9148),
    [sym_instance_variable] = ACTIONS(9146),
    [sym__heredoc_body_start] = ACTIONS(9146),
    [anon_sym_defined_QMARK] = ACTIONS(9146),
    [sym__string_start] = ACTIONS(9146),
    [anon_sym_true] = ACTIONS(9148),
    [anon_sym_for] = ACTIONS(9148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(9146),
    [anon_sym_NIL] = ACTIONS(9148),
    [anon_sym_COLON_COLON] = ACTIONS(9146),
    [anon_sym_def] = ACTIONS(9148),
    [sym_identifier] = ACTIONS(9148),
    [anon_sym_yield] = ACTIONS(9148),
    [sym_class_variable] = ACTIONS(9146),
    [sym__symbol_start] = ACTIONS(9146),
    [anon_sym_not] = ACTIONS(9148),
    [anon_sym_TRUE] = ACTIONS(9148),
    [anon_sym_case] = ACTIONS(9148),
    [anon_sym_SEMI] = ACTIONS(9146),
    [anon_sym_LPAREN] = ACTIONS(9146),
    [anon_sym_break] = ACTIONS(9148),
    [sym_global_variable] = ACTIONS(9146),
    [anon_sym_class] = ACTIONS(9148),
    [sym__subshell_start] = ACTIONS(9146),
    [anon_sym_module] = ACTIONS(9148),
    [anon_sym_begin] = ACTIONS(9148),
    [anon_sym_false] = ACTIONS(9148),
    [anon_sym_STAR] = ACTIONS(9146),
    [sym__unary_minus] = ACTIONS(9146),
    [anon_sym_next] = ACTIONS(9148),
    [sym_retry] = ACTIONS(9148),
    [sym__regex_start] = ACTIONS(9146),
    [anon_sym_end] = ACTIONS(9148),
    [sym_integer] = ACTIONS(9148),
    [anon_sym_FALSE] = ACTIONS(9148),
    [sym_redo] = ACTIONS(9148),
    [anon_sym_BANG] = ACTIONS(9146),
    [anon_sym_if] = ACTIONS(9148),
    [sym__string_array_start] = ACTIONS(9146),
    [anon_sym_return] = ACTIONS(9148),
  },
  [2980] = {
    [anon_sym_PIPE] = ACTIONS(2021),
    [anon_sym_COLON] = ACTIONS(9150),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(9152),
    [sym_comment] = ACTIONS(3),
  },
  [2981] = {
    [anon_sym_PIPE] = ACTIONS(9154),
    [anon_sym_SEMI] = ACTIONS(9156),
    [sym_comment] = ACTIONS(49),
  },
  [2982] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(9158),
  },
  [2983] = {
    [aux_sym_method_parameters_repeat1] = STATE(5650),
    [anon_sym_PIPE] = ACTIONS(9154),
    [anon_sym_COMMA] = ACTIONS(9160),
    [anon_sym_SEMI] = ACTIONS(9156),
    [sym_comment] = ACTIONS(49),
  },
  [2984] = {
    [sym_assignment] = STATE(5651),
    [sym_unary] = STATE(5651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5651),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(5651),
    [sym_conditional] = STATE(5651),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(5651),
    [sym_binary] = STATE(5651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [2985] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [2986] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9166),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [2987] = {
    [sym_assignment] = STATE(5654),
    [sym_unary] = STATE(5654),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5654),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(5654),
    [sym_conditional] = STATE(5654),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(5654),
    [sym_binary] = STATE(5654),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [2988] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9168),
    [sym_identifier] = ACTIONS(9168),
  },
  [2989] = {
    [anon_sym_COLON] = ACTIONS(9170),
    [sym_comment] = ACTIONS(49),
  },
  [2990] = {
    [sym__argument] = STATE(5662),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(5662),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(5662),
    [sym_hash_splat_argument] = STATE(5662),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(5665),
    [sym_block_argument] = STATE(5662),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [2991] = {
    [sym_assignment] = STATE(5674),
    [sym_unary] = STATE(5674),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5674),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(5674),
    [sym_conditional] = STATE(5674),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(5674),
    [sym_binary] = STATE(5674),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [2992] = {
    [sym_assignment] = STATE(5677),
    [sym_unary] = STATE(5677),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5677),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(5677),
    [sym_conditional] = STATE(5677),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(5677),
    [sym_binary] = STATE(5677),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [2993] = {
    [sym__argument] = STATE(5662),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(5662),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(5662),
    [sym_hash_splat_argument] = STATE(5662),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(5665),
    [sym_block_argument] = STATE(5662),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [2994] = {
    [sym__argument] = STATE(5662),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(5662),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(5662),
    [sym_hash_splat_argument] = STATE(5662),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(5665),
    [sym_block_argument] = STATE(5662),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [2995] = {
    [sym_assignment] = STATE(5678),
    [sym_unary] = STATE(5678),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5678),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(5678),
    [sym_conditional] = STATE(5678),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(5678),
    [sym_binary] = STATE(5678),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [2996] = {
    [sym__argument] = STATE(5662),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(5662),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(5662),
    [sym_hash_splat_argument] = STATE(5662),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(5665),
    [sym_block_argument] = STATE(5662),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [2997] = {
    [sym_heredoc_body] = STATE(5680),
    [aux_sym_call_repeat1] = STATE(5680),
    [aux_sym_argument_list_repeat1] = STATE(5681),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9198),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [2998] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9200),
    [anon_sym_GT_GT_EQ] = ACTIONS(9200),
    [anon_sym_SLASH_EQ] = ACTIONS(9200),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9200),
    [anon_sym_LT_LT_EQ] = ACTIONS(9200),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9200),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(9200),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9202),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(9200),
    [anon_sym_PLUS_EQ] = ACTIONS(9200),
    [anon_sym_STAR_EQ] = ACTIONS(9200),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9200),
    [anon_sym_DASH_EQ] = ACTIONS(9200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9200),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [2999] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_EQ_GT] = ACTIONS(9170),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [3000] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(9230),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9232),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9234),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [3001] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym__primary] = STATE(3030),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_method] = STATE(3030),
    [sym_conditional] = STATE(5701),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_subshell] = STATE(3030),
    [sym_unless] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3034),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_call] = STATE(3032),
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_rational] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_lambda] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(5701),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_nil] = STATE(3034),
    [sym_symbol_array] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_scope_resolution] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3002] = {
    [anon_sym_EQ] = ACTIONS(9244),
    [sym_comment] = ACTIONS(3),
  },
  [3003] = {
    [aux_sym_chained_string_repeat1] = STATE(5704),
    [sym_string] = STATE(5704),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9246),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3004] = {
    [sym_heredoc_body] = STATE(5680),
    [aux_sym_call_repeat1] = STATE(5680),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3005] = {
    [sym_assignment] = STATE(5705),
    [sym_unary] = STATE(5705),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5705),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5705),
    [sym_conditional] = STATE(5705),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5705),
    [sym_binary] = STATE(5705),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3006] = {
    [sym_assignment] = STATE(5706),
    [sym_unary] = STATE(5706),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5706),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5706),
    [sym_conditional] = STATE(5706),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5706),
    [sym_binary] = STATE(5706),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3007] = {
    [sym_assignment] = STATE(5707),
    [sym_unary] = STATE(5707),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5707),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5707),
    [sym_conditional] = STATE(5707),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5707),
    [sym_binary] = STATE(5707),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3008] = {
    [sym_assignment] = STATE(5708),
    [sym_unary] = STATE(5708),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5708),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5708),
    [sym_conditional] = STATE(5708),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5708),
    [sym_binary] = STATE(5708),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3009] = {
    [sym_assignment] = STATE(5709),
    [sym_unary] = STATE(5709),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5709),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5709),
    [sym_conditional] = STATE(5709),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5709),
    [sym_binary] = STATE(5709),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3010] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [3011] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [sym__line_break] = ACTIONS(9250),
    [anon_sym_then] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_when] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym___END__] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(9250),
    [anon_sym_ensure] = ACTIONS(9250),
    [anon_sym_else] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_elsif] = ACTIONS(9250),
    [ts_builtin_sym_end] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
  },
  [3012] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5711),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9252),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3013] = {
    [anon_sym_end] = ACTIONS(9254),
    [sym_comment] = ACTIONS(49),
  },
  [3014] = {
    [sym_heredoc_body] = STATE(5716),
    [sym__argument_list_with_parens] = STATE(5715),
    [aux_sym_call_repeat1] = STATE(5716),
    [sym_argument_list_with_parens] = STATE(5714),
    [sym_operator] = STATE(5714),
    [anon_sym_LT] = ACTIONS(9256),
    [anon_sym_SLASH] = ACTIONS(9258),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9258),
    [anon_sym_PLUS_AT] = ACTIONS(9258),
    [anon_sym_LPAREN2] = ACTIONS(9260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9258),
    [anon_sym_GT_GT] = ACTIONS(9258),
    [anon_sym_EQ_TILDE] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9258),
    [anon_sym_TILDE] = ACTIONS(9258),
    [anon_sym_PLUS] = ACTIONS(9256),
    [anon_sym_AMP] = ACTIONS(9258),
    [anon_sym_GT] = ACTIONS(9256),
    [anon_sym_PERCENT] = ACTIONS(9258),
    [anon_sym_DASH_AT] = ACTIONS(9258),
    [anon_sym_EQ_EQ] = ACTIONS(9256),
    [anon_sym_STAR] = ACTIONS(9256),
    [anon_sym_BANG_TILDE] = ACTIONS(9258),
    [sym_constant] = ACTIONS(9262),
    [anon_sym_DASH] = ACTIONS(9256),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9256),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9258),
    [anon_sym_STAR_STAR] = ACTIONS(9258),
    [anon_sym_PIPE] = ACTIONS(9258),
    [anon_sym_DOT_DOT] = ACTIONS(9258),
    [anon_sym_LT_EQ_GT] = ACTIONS(9258),
    [anon_sym_LT_EQ] = ACTIONS(9256),
    [anon_sym_BANG] = ACTIONS(9256),
    [sym_identifier] = ACTIONS(9262),
    [anon_sym_CARET] = ACTIONS(9258),
  },
  [3015] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9264),
    [sym_identifier] = ACTIONS(9264),
  },
  [3016] = {
    [sym_assignment] = STATE(5723),
    [sym_unary] = STATE(5723),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5723),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_splat_argument] = STATE(5725),
    [sym_operator_assignment] = STATE(5723),
    [sym_conditional] = STATE(5723),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_return] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_subshell] = STATE(1125),
    [sym__arg_or_splat_arg] = STATE(5725),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(5723),
    [sym_binary] = STATE(5723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(9270),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1983),
    [sym_character] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [3017] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5726),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5726),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5711),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(9278),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(9278),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9252),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3018] = {
    [sym_assignment] = STATE(5727),
    [sym_unary] = STATE(5727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5727),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(5727),
    [sym_conditional] = STATE(5727),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(5727),
    [sym_binary] = STATE(5727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [3019] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [3020] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9282),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3021] = {
    [sym_assignment] = STATE(5730),
    [sym_unary] = STATE(5730),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5730),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(5730),
    [sym_conditional] = STATE(5730),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(5730),
    [sym_binary] = STATE(5730),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [3022] = {
    [anon_sym_COLON] = ACTIONS(9284),
    [sym_comment] = ACTIONS(49),
  },
  [3023] = {
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3024] = {
    [sym_assignment] = STATE(5740),
    [sym_unary] = STATE(5740),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(5740),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(5740),
    [sym_conditional] = STATE(5740),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(5740),
    [sym_binary] = STATE(5740),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [3025] = {
    [sym_assignment] = STATE(5745),
    [sym_unary] = STATE(5745),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(5745),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(5745),
    [sym_conditional] = STATE(5745),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(5745),
    [sym_binary] = STATE(5745),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [3026] = {
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3027] = {
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3028] = {
    [sym_assignment] = STATE(5746),
    [sym_unary] = STATE(5746),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(5746),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(5746),
    [sym_conditional] = STATE(5746),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(5746),
    [sym_binary] = STATE(5746),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [3029] = {
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3030] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(9230),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9232),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9234),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3031] = {
    [anon_sym_EQ] = ACTIONS(9312),
    [sym_comment] = ACTIONS(3),
  },
  [3032] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym__primary] = STATE(3030),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(5700),
    [sym_method] = STATE(3030),
    [sym_conditional] = STATE(5701),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_subshell] = STATE(3030),
    [sym_unless] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_block_argument] = STATE(5700),
    [sym_range] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3034),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_call] = STATE(3032),
    [sym__argument] = STATE(5700),
    [sym_assignment] = STATE(5701),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_pair] = STATE(5700),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(5700),
    [sym_operator_assignment] = STATE(5701),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_rational] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_lambda] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(5703),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(5701),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_nil] = STATE(3034),
    [sym_symbol_array] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_scope_resolution] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(9240),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [3033] = {
    [sym_heredoc_body] = STATE(5749),
    [aux_sym_call_repeat1] = STATE(5749),
    [aux_sym_argument_list_repeat1] = STATE(5750),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9314),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3034] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9316),
    [anon_sym_GT_GT_EQ] = ACTIONS(9316),
    [anon_sym_SLASH_EQ] = ACTIONS(9316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9316),
    [anon_sym_LT_LT_EQ] = ACTIONS(9316),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9316),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(9316),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9318),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(9316),
    [anon_sym_PLUS_EQ] = ACTIONS(9316),
    [anon_sym_STAR_EQ] = ACTIONS(9316),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9316),
    [anon_sym_DASH_EQ] = ACTIONS(9316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9316),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3035] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(9284),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [3036] = {
    [aux_sym_chained_string_repeat1] = STATE(5761),
    [sym_string] = STATE(5761),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9348),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3037] = {
    [sym_heredoc_body] = STATE(5749),
    [aux_sym_call_repeat1] = STATE(5749),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3038] = {
    [sym_assignment] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3039] = {
    [sym_assignment] = STATE(5763),
    [sym_unary] = STATE(5763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5763),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5763),
    [sym_conditional] = STATE(5763),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5763),
    [sym_binary] = STATE(5763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3040] = {
    [sym_assignment] = STATE(5764),
    [sym_unary] = STATE(5764),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5764),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5764),
    [sym_conditional] = STATE(5764),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5764),
    [sym_binary] = STATE(5764),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3041] = {
    [sym_assignment] = STATE(5765),
    [sym_unary] = STATE(5765),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5765),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5765),
    [sym_conditional] = STATE(5765),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5765),
    [sym_binary] = STATE(5765),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3042] = {
    [sym_assignment] = STATE(5766),
    [sym_unary] = STATE(5766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5766),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5766),
    [sym_conditional] = STATE(5766),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5766),
    [sym_binary] = STATE(5766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3043] = {
    [sym_assignment] = STATE(5767),
    [sym_unary] = STATE(5767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5767),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5767),
    [sym_conditional] = STATE(5767),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5767),
    [sym_binary] = STATE(5767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3044] = {
    [sym_assignment] = STATE(5768),
    [sym_unary] = STATE(5768),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5768),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5768),
    [sym_conditional] = STATE(5768),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5768),
    [sym_binary] = STATE(5768),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3045] = {
    [sym_assignment] = STATE(5769),
    [sym_unary] = STATE(5769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5769),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5769),
    [sym_conditional] = STATE(5769),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5769),
    [sym_binary] = STATE(5769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3046] = {
    [sym_assignment] = STATE(5770),
    [sym_unary] = STATE(5770),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5770),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5770),
    [sym_conditional] = STATE(5770),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5770),
    [sym_binary] = STATE(5770),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3047] = {
    [sym_assignment] = STATE(5771),
    [sym_unary] = STATE(5771),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5771),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5771),
    [sym_conditional] = STATE(5771),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5771),
    [sym_binary] = STATE(5771),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3048] = {
    [sym_assignment] = STATE(5772),
    [sym_unary] = STATE(5772),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5772),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(5772),
    [sym_conditional] = STATE(5772),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(5772),
    [sym_binary] = STATE(5772),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3049] = {
    [aux_sym_chained_string_repeat1] = STATE(5773),
    [sym_string] = STATE(5773),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [3050] = {
    [sym_heredoc_body] = STATE(3010),
    [sym__terminator] = STATE(3010),
    [sym__line_break] = ACTIONS(5082),
    [anon_sym_unless] = ACTIONS(5084),
    [anon_sym_until] = ACTIONS(5086),
    [anon_sym_while] = ACTIONS(5088),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(5090),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym_if] = ACTIONS(5092),
    [sym_comment] = ACTIONS(49),
  },
  [3051] = {
    [sym__statement] = STATE(5774),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(5774),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(5774),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(5774),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(3051),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(5774),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(5774),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(5774),
    [sym_if_modifier] = STATE(5774),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(5774),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(5774),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(3051),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(9350),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [3052] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [3053] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [3054] = {
    [sym_assignment] = STATE(5784),
    [sym_unary] = STATE(5784),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(5784),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(5784),
    [sym_conditional] = STATE(5784),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(5784),
    [sym_binary] = STATE(5784),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [3055] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [3056] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [3057] = {
    [sym_assignment] = STATE(5785),
    [sym_unary] = STATE(5785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(5785),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(5785),
    [sym_conditional] = STATE(5785),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(5785),
    [sym_binary] = STATE(5785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [3058] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9361),
    [sym_identifier] = ACTIONS(9361),
  },
  [3059] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [3060] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(9363),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9363),
    [anon_sym_SLASH_EQ] = ACTIONS(9363),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9363),
    [anon_sym_PIPE_EQ] = ACTIONS(9363),
    [anon_sym_LT_LT_EQ] = ACTIONS(9363),
    [anon_sym_PLUS_EQ] = ACTIONS(9363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9363),
    [anon_sym_STAR_EQ] = ACTIONS(9363),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9363),
    [anon_sym_CARET_EQ] = ACTIONS(9363),
    [anon_sym_DASH_EQ] = ACTIONS(9363),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9363),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9365),
  },
  [3061] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(9373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(9381),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(9373),
    [anon_sym_and] = ACTIONS(9381),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9373),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_PIPE] = ACTIONS(9393),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [3062] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(9397),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9399),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9401),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [3063] = {
    [sym_block] = STATE(2275),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(5802),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(5487),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_do_block] = STATE(2275),
    [sym_binary] = STATE(5487),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9403),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3064] = {
    [anon_sym_EQ] = ACTIONS(9405),
    [sym_comment] = ACTIONS(3),
  },
  [3065] = {
    [aux_sym_chained_string_repeat1] = STATE(5803),
    [sym_string] = STATE(5803),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3066] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(9407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(9381),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(9407),
    [anon_sym_and] = ACTIONS(9381),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9407),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_PIPE] = ACTIONS(9393),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [3067] = {
    [sym_float] = ACTIONS(9148),
    [anon_sym_until] = ACTIONS(9148),
    [anon_sym_undef] = ACTIONS(9148),
    [sym_self] = ACTIONS(9148),
    [anon_sym_BEGIN] = ACTIONS(9148),
    [anon_sym_RBRACE] = ACTIONS(9146),
    [anon_sym_TILDE] = ACTIONS(9146),
    [anon_sym_unless] = ACTIONS(9148),
    [anon_sym_PLUS] = ACTIONS(9148),
    [sym__symbol_array_start] = ACTIONS(9146),
    [sym__simple_symbol] = ACTIONS(9146),
    [sym_complex] = ACTIONS(9146),
    [sym_heredoc_beginning] = ACTIONS(9146),
    [sym_super] = ACTIONS(9148),
    [anon_sym_alias] = ACTIONS(9148),
    [anon_sym_LBRACK2] = ACTIONS(9146),
    [anon_sym_nil] = ACTIONS(9148),
    [sym_character] = ACTIONS(9146),
    [anon_sym_LBRACE] = ACTIONS(9146),
    [anon_sym_END] = ACTIONS(9148),
    [sym_constant] = ACTIONS(9148),
    [anon_sym_while] = ACTIONS(9148),
    [sym_instance_variable] = ACTIONS(9146),
    [anon_sym_defined_QMARK] = ACTIONS(9146),
    [sym__string_start] = ACTIONS(9146),
    [anon_sym_true] = ACTIONS(9148),
    [anon_sym_for] = ACTIONS(9148),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(9146),
    [anon_sym_NIL] = ACTIONS(9148),
    [anon_sym_COLON_COLON] = ACTIONS(9146),
    [anon_sym_def] = ACTIONS(9148),
    [sym_identifier] = ACTIONS(9148),
    [anon_sym_yield] = ACTIONS(9148),
    [sym_class_variable] = ACTIONS(9146),
    [sym__symbol_start] = ACTIONS(9146),
    [anon_sym_not] = ACTIONS(9148),
    [anon_sym_TRUE] = ACTIONS(9148),
    [anon_sym_case] = ACTIONS(9148),
    [anon_sym_SEMI] = ACTIONS(9146),
    [anon_sym_LPAREN] = ACTIONS(9146),
    [anon_sym_break] = ACTIONS(9148),
    [sym_global_variable] = ACTIONS(9146),
    [anon_sym_class] = ACTIONS(9148),
    [sym__subshell_start] = ACTIONS(9146),
    [anon_sym_module] = ACTIONS(9148),
    [anon_sym_begin] = ACTIONS(9148),
    [anon_sym_false] = ACTIONS(9148),
    [anon_sym_STAR] = ACTIONS(9146),
    [sym__unary_minus] = ACTIONS(9146),
    [anon_sym_next] = ACTIONS(9148),
    [sym_retry] = ACTIONS(9148),
    [sym__regex_start] = ACTIONS(9146),
    [sym_integer] = ACTIONS(9148),
    [anon_sym_FALSE] = ACTIONS(9148),
    [sym_redo] = ACTIONS(9148),
    [anon_sym_BANG] = ACTIONS(9146),
    [anon_sym_if] = ACTIONS(9148),
    [sym__string_array_start] = ACTIONS(9146),
    [anon_sym_return] = ACTIONS(9148),
  },
  [3068] = {
    [anon_sym_PIPE] = ACTIONS(9409),
    [anon_sym_SEMI] = ACTIONS(9411),
    [sym_comment] = ACTIONS(49),
  },
  [3069] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(9413),
  },
  [3070] = {
    [aux_sym_method_parameters_repeat1] = STATE(5808),
    [anon_sym_PIPE] = ACTIONS(9409),
    [anon_sym_COMMA] = ACTIONS(9415),
    [anon_sym_SEMI] = ACTIONS(9411),
    [sym_comment] = ACTIONS(49),
  },
  [3071] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [sym__line_break] = ACTIONS(9419),
    [anon_sym_then] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_when] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym___END__] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_end] = ACTIONS(9419),
    [anon_sym_ensure] = ACTIONS(9419),
    [anon_sym_else] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_elsif] = ACTIONS(9419),
    [ts_builtin_sym_end] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
  },
  [3072] = {
    [anon_sym_RBRACE] = ACTIONS(9421),
    [sym_comment] = ACTIONS(49),
  },
  [3073] = {
    [sym_assignment] = STATE(5818),
    [sym_unary] = STATE(5818),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5818),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(5818),
    [sym_conditional] = STATE(5818),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(5818),
    [sym_binary] = STATE(5818),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(2067),
    [sym_character] = ACTIONS(2071),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [3074] = {
    [sym_assignment] = STATE(5821),
    [sym_unary] = STATE(5821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5821),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(5821),
    [sym_conditional] = STATE(5821),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(5821),
    [sym_binary] = STATE(5821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [3075] = {
    [aux_sym_method_parameters_repeat1] = STATE(5823),
    [anon_sym_RPAREN] = ACTIONS(9441),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [3076] = {
    [anon_sym_do] = ACTIONS(9443),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(9443),
  },
  [3077] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [3078] = {
    [aux_sym_method_parameters_repeat1] = STATE(5826),
    [anon_sym_RPAREN] = ACTIONS(9445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [3079] = {
    [anon_sym_do] = ACTIONS(9447),
    [anon_sym_COMMA] = ACTIONS(9447),
    [anon_sym_LBRACE] = ACTIONS(9447),
    [sym_comment] = ACTIONS(49),
  },
  [3080] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3080),
    [anon_sym_do] = ACTIONS(9447),
    [anon_sym_COMMA] = ACTIONS(9449),
    [anon_sym_LBRACE] = ACTIONS(9447),
    [sym_comment] = ACTIONS(49),
  },
  [3081] = {
    [sym__line_break] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [sym_identifier] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
  },
  [3082] = {
    [sym_assignment] = STATE(5827),
    [sym_unary] = STATE(5827),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(5827),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(5827),
    [sym_conditional] = STATE(5827),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(5827),
    [sym_binary] = STATE(5827),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3083] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3084] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9454),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3085] = {
    [sym_assignment] = STATE(5829),
    [sym_unary] = STATE(5829),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(5829),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(5829),
    [sym_conditional] = STATE(5829),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(5829),
    [sym_binary] = STATE(5829),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3086] = {
    [anon_sym_COLON] = ACTIONS(9456),
    [sym_comment] = ACTIONS(49),
  },
  [3087] = {
    [sym_assignment] = STATE(5835),
    [sym_unary] = STATE(5835),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5835),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(5835),
    [sym_conditional] = STATE(5835),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(5835),
    [sym_binary] = STATE(5835),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3088] = {
    [sym_assignment] = STATE(5837),
    [sym_unary] = STATE(5837),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5837),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(5837),
    [sym_conditional] = STATE(5837),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(5837),
    [sym_binary] = STATE(5837),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3089] = {
    [sym_assignment] = STATE(5838),
    [sym_unary] = STATE(5838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5838),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(5838),
    [sym_conditional] = STATE(5838),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(5838),
    [sym_binary] = STATE(5838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3090] = {
    [sym_heredoc_body] = STATE(5840),
    [aux_sym_call_repeat1] = STATE(5840),
    [aux_sym_argument_list_repeat1] = STATE(5841),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9468),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3091] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(9470),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9470),
    [anon_sym_SLASH_EQ] = ACTIONS(9470),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9470),
    [anon_sym_PIPE_EQ] = ACTIONS(9470),
    [anon_sym_LT_LT_EQ] = ACTIONS(9470),
    [anon_sym_PLUS_EQ] = ACTIONS(9470),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9470),
    [anon_sym_STAR_EQ] = ACTIONS(9470),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9470),
    [anon_sym_CARET_EQ] = ACTIONS(9470),
    [anon_sym_DASH_EQ] = ACTIONS(9470),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9470),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9472),
  },
  [3092] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_EQ_GT] = ACTIONS(9456),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [3093] = {
    [anon_sym_EQ] = ACTIONS(9500),
    [sym_comment] = ACTIONS(3),
  },
  [3094] = {
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym_string] = STATE(3265),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9502),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3095] = {
    [sym_heredoc_body] = STATE(5840),
    [aux_sym_call_repeat1] = STATE(5840),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3096] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3097] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [3098] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3099] = {
    [sym_assignment] = STATE(5853),
    [sym_unary] = STATE(5853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5853),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5853),
    [sym_conditional] = STATE(5853),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5853),
    [sym_binary] = STATE(5853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3100] = {
    [sym_assignment] = STATE(5855),
    [sym_unary] = STATE(5855),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5855),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_splat_argument] = STATE(5856),
    [sym_operator_assignment] = STATE(5855),
    [sym_conditional] = STATE(5855),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_return] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_subshell] = STATE(1163),
    [sym__arg_or_splat_arg] = STATE(5856),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(5855),
    [sym_binary] = STATE(5855),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(9504),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(2067),
    [sym_character] = ACTIONS(2071),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [3101] = {
    [sym_assignment] = STATE(5857),
    [sym_unary] = STATE(5857),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5857),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5857),
    [sym_conditional] = STATE(5857),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5857),
    [sym_binary] = STATE(5857),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3102] = {
    [sym_assignment] = STATE(5858),
    [sym_unary] = STATE(5858),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5858),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5858),
    [sym_conditional] = STATE(5858),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5858),
    [sym_binary] = STATE(5858),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3103] = {
    [sym_assignment] = STATE(5859),
    [sym_unary] = STATE(5859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5859),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5859),
    [sym_conditional] = STATE(5859),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5859),
    [sym_binary] = STATE(5859),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3104] = {
    [sym_assignment] = STATE(5860),
    [sym_unary] = STATE(5860),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5860),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5860),
    [sym_conditional] = STATE(5860),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5860),
    [sym_binary] = STATE(5860),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3105] = {
    [sym_assignment] = STATE(5861),
    [sym_unary] = STATE(5861),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5861),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5861),
    [sym_conditional] = STATE(5861),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5861),
    [sym_binary] = STATE(5861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3106] = {
    [sym_assignment] = STATE(5862),
    [sym_unary] = STATE(5862),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5862),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5862),
    [sym_conditional] = STATE(5862),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5862),
    [sym_binary] = STATE(5862),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3107] = {
    [sym_assignment] = STATE(5863),
    [sym_unary] = STATE(5863),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5863),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5863),
    [sym_conditional] = STATE(5863),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5863),
    [sym_binary] = STATE(5863),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3108] = {
    [anon_sym_DOT] = ACTIONS(9506),
    [anon_sym_COLON_COLON] = ACTIONS(9506),
    [sym_comment] = ACTIONS(49),
  },
  [3109] = {
    [sym_assignment] = STATE(5865),
    [sym_unary] = STATE(5865),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5865),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5865),
    [sym_conditional] = STATE(5865),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5865),
    [sym_binary] = STATE(5865),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3110] = {
    [sym_assignment] = STATE(5866),
    [sym_unary] = STATE(5866),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5866),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5866),
    [sym_conditional] = STATE(5866),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5866),
    [sym_binary] = STATE(5866),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3111] = {
    [sym_assignment] = STATE(5867),
    [sym_unary] = STATE(5867),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5867),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(5867),
    [sym_conditional] = STATE(5867),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(5867),
    [sym_binary] = STATE(5867),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [3112] = {
    [sym_heredoc_body] = STATE(5872),
    [sym__argument_list_with_parens] = STATE(5871),
    [aux_sym_call_repeat1] = STATE(5872),
    [sym_argument_list_with_parens] = STATE(5870),
    [sym_operator] = STATE(5870),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9510),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9510),
    [anon_sym_PLUS_AT] = ACTIONS(9510),
    [anon_sym_LPAREN2] = ACTIONS(9512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9510),
    [anon_sym_GT_GT] = ACTIONS(9510),
    [anon_sym_EQ_TILDE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(9510),
    [anon_sym_TILDE] = ACTIONS(9510),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9510),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9510),
    [anon_sym_DASH_AT] = ACTIONS(9510),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_STAR] = ACTIONS(9508),
    [anon_sym_BANG_TILDE] = ACTIONS(9510),
    [sym_constant] = ACTIONS(9514),
    [anon_sym_DASH] = ACTIONS(9508),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9508),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9510),
    [anon_sym_STAR_STAR] = ACTIONS(9510),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_DOT_DOT] = ACTIONS(9510),
    [anon_sym_LT_EQ_GT] = ACTIONS(9510),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_BANG] = ACTIONS(9508),
    [sym_identifier] = ACTIONS(9514),
    [anon_sym_CARET] = ACTIONS(9510),
  },
  [3113] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9516),
    [sym_identifier] = ACTIONS(9516),
  },
  [3114] = {
    [sym_assignment] = STATE(5874),
    [sym_unary] = STATE(5874),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(5874),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(5874),
    [sym_conditional] = STATE(5874),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(5874),
    [sym_binary] = STATE(5874),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3115] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3116] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9520),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3117] = {
    [sym_assignment] = STATE(5877),
    [sym_unary] = STATE(5877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(5877),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(5877),
    [sym_conditional] = STATE(5877),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(5877),
    [sym_binary] = STATE(5877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3118] = {
    [anon_sym_COLON] = ACTIONS(9522),
    [sym_comment] = ACTIONS(49),
  },
  [3119] = {
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3120] = {
    [sym_assignment] = STATE(5887),
    [sym_unary] = STATE(5887),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(5887),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(5887),
    [sym_conditional] = STATE(5887),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(5887),
    [sym_binary] = STATE(5887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [3121] = {
    [sym_assignment] = STATE(5892),
    [sym_unary] = STATE(5892),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(5892),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(5892),
    [sym_conditional] = STATE(5892),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(5892),
    [sym_binary] = STATE(5892),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [3122] = {
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3123] = {
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3124] = {
    [sym_assignment] = STATE(5893),
    [sym_unary] = STATE(5893),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(5893),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(5893),
    [sym_conditional] = STATE(5893),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(5893),
    [sym_binary] = STATE(5893),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [3125] = {
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3126] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(5532),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(5536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3127] = {
    [anon_sym_EQ] = ACTIONS(9550),
    [sym_comment] = ACTIONS(3),
  },
  [3128] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym__primary] = STATE(3126),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(3261),
    [sym_method] = STATE(3126),
    [sym_conditional] = STATE(3262),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_subshell] = STATE(3126),
    [sym_unless] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_block_argument] = STATE(3261),
    [sym_range] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3130),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3261),
    [sym_assignment] = STATE(3262),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_pair] = STATE(3261),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3261),
    [sym_operator_assignment] = STATE(3262),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_lambda] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3264),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(3262),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_nil] = STATE(3130),
    [sym_symbol_array] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_scope_resolution] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5542),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3129] = {
    [sym_heredoc_body] = STATE(5896),
    [aux_sym_call_repeat1] = STATE(5896),
    [aux_sym_argument_list_repeat1] = STATE(5897),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9552),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3130] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(9554),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9554),
    [anon_sym_SLASH_EQ] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9554),
    [anon_sym_PIPE_EQ] = ACTIONS(9554),
    [anon_sym_LT_LT_EQ] = ACTIONS(9554),
    [anon_sym_PLUS_EQ] = ACTIONS(9554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9554),
    [anon_sym_STAR_EQ] = ACTIONS(9554),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9554),
    [anon_sym_CARET_EQ] = ACTIONS(9554),
    [anon_sym_DASH_EQ] = ACTIONS(9554),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9554),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(9556),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3131] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_EQ_GT] = ACTIONS(9522),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [3132] = {
    [aux_sym_chained_string_repeat1] = STATE(5908),
    [sym_string] = STATE(5908),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9586),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3133] = {
    [sym_heredoc_body] = STATE(5896),
    [aux_sym_call_repeat1] = STATE(5896),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3134] = {
    [aux_sym_chained_string_repeat1] = STATE(5909),
    [sym_string] = STATE(5909),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3135] = {
    [sym__line_break] = ACTIONS(5174),
    [sym__heredoc_body_start] = ACTIONS(5174),
    [anon_sym_COMMA] = ACTIONS(5174),
    [anon_sym_SEMI] = ACTIONS(5174),
    [sym_comment] = ACTIONS(49),
  },
  [3136] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(5912),
    [sym_lambda_parameters] = STATE(5913),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(5912),
    [anon_sym_do] = ACTIONS(9588),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(9590),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [3137] = {
    [sym__line_break] = ACTIONS(5208),
    [sym__heredoc_body_start] = ACTIONS(5208),
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_SEMI] = ACTIONS(5208),
    [sym_comment] = ACTIONS(49),
  },
  [3138] = {
    [sym__line_break] = ACTIONS(5024),
    [sym__heredoc_body_start] = ACTIONS(5024),
    [anon_sym_COMMA] = ACTIONS(5024),
    [anon_sym_SEMI] = ACTIONS(5024),
    [sym_comment] = ACTIONS(49),
  },
  [3139] = {
    [sym_assignment] = STATE(5914),
    [sym_unary] = STATE(5914),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(5914),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(5914),
    [sym_conditional] = STATE(5914),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(5914),
    [sym_binary] = STATE(5914),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__line_break] = ACTIONS(5186),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym__heredoc_body_start] = ACTIONS(5186),
    [sym_instance_variable] = ACTIONS(589),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(5644),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(5700),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3140] = {
    [sym_assignment] = STATE(5915),
    [sym_unary] = STATE(5915),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(5915),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(5915),
    [sym_conditional] = STATE(5915),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(5915),
    [sym_binary] = STATE(5915),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3141] = {
    [sym_heredoc_body] = STATE(5916),
    [sym__terminator] = STATE(5916),
    [sym__line_break] = ACTIONS(9592),
    [sym_float] = ACTIONS(9594),
    [anon_sym_until] = ACTIONS(9594),
    [anon_sym_undef] = ACTIONS(9594),
    [sym_self] = ACTIONS(9594),
    [anon_sym_BEGIN] = ACTIONS(9594),
    [anon_sym_TILDE] = ACTIONS(9596),
    [anon_sym_unless] = ACTIONS(9594),
    [anon_sym_PLUS] = ACTIONS(9594),
    [sym__symbol_array_start] = ACTIONS(9596),
    [sym__simple_symbol] = ACTIONS(9596),
    [sym_complex] = ACTIONS(9596),
    [sym_heredoc_beginning] = ACTIONS(9596),
    [sym_super] = ACTIONS(9594),
    [anon_sym_rescue] = ACTIONS(9594),
    [anon_sym_alias] = ACTIONS(9594),
    [anon_sym_LBRACK2] = ACTIONS(9596),
    [anon_sym_nil] = ACTIONS(9594),
    [sym_character] = ACTIONS(9596),
    [anon_sym_LBRACE] = ACTIONS(9596),
    [anon_sym_END] = ACTIONS(9594),
    [sym_constant] = ACTIONS(9594),
    [anon_sym_while] = ACTIONS(9594),
    [sym_instance_variable] = ACTIONS(9596),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(9596),
    [sym__string_start] = ACTIONS(9596),
    [anon_sym_else] = ACTIONS(9594),
    [anon_sym_true] = ACTIONS(9594),
    [anon_sym_for] = ACTIONS(9594),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(9596),
    [anon_sym_NIL] = ACTIONS(9594),
    [anon_sym_COLON_COLON] = ACTIONS(9596),
    [anon_sym_def] = ACTIONS(9594),
    [sym_identifier] = ACTIONS(9594),
    [anon_sym_yield] = ACTIONS(9594),
    [sym_class_variable] = ACTIONS(9596),
    [anon_sym_not] = ACTIONS(9594),
    [sym__symbol_start] = ACTIONS(9596),
    [anon_sym_TRUE] = ACTIONS(9594),
    [anon_sym_case] = ACTIONS(9594),
    [anon_sym_SEMI] = ACTIONS(9592),
    [anon_sym_LPAREN] = ACTIONS(9596),
    [anon_sym_break] = ACTIONS(9594),
    [sym_global_variable] = ACTIONS(9596),
    [anon_sym_class] = ACTIONS(9594),
    [sym__subshell_start] = ACTIONS(9596),
    [anon_sym_module] = ACTIONS(9594),
    [anon_sym_begin] = ACTIONS(9594),
    [anon_sym_false] = ACTIONS(9594),
    [anon_sym_STAR] = ACTIONS(9596),
    [sym__unary_minus] = ACTIONS(9596),
    [anon_sym_next] = ACTIONS(9594),
    [sym_retry] = ACTIONS(9594),
    [sym__regex_start] = ACTIONS(9596),
    [anon_sym_end] = ACTIONS(9594),
    [anon_sym_ensure] = ACTIONS(9594),
    [sym_integer] = ACTIONS(9594),
    [anon_sym_FALSE] = ACTIONS(9594),
    [sym_redo] = ACTIONS(9594),
    [anon_sym_BANG] = ACTIONS(9596),
    [anon_sym_if] = ACTIONS(9594),
    [sym__string_array_start] = ACTIONS(9596),
    [anon_sym_return] = ACTIONS(9594),
  },
  [3142] = {
    [aux_sym_method_parameters_repeat1] = STATE(5918),
    [anon_sym_RPAREN] = ACTIONS(9598),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [3143] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [sym__line_break] = ACTIONS(9602),
    [anon_sym_then] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_when] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym___END__] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_end] = ACTIONS(9602),
    [anon_sym_ensure] = ACTIONS(9602),
    [anon_sym_else] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_elsif] = ACTIONS(9602),
    [ts_builtin_sym_end] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
    [sym__binary_minus] = ACTIONS(9602),
  },
  [3144] = {
    [sym_splat_parameter] = STATE(5920),
    [sym_hash_splat_parameter] = STATE(5920),
    [sym_block_parameter] = STATE(5920),
    [sym__formal_parameter] = STATE(5920),
    [sym__simple_formal_parameter] = STATE(5920),
    [sym_keyword_parameter] = STATE(5920),
    [sym_optional_parameter] = STATE(5920),
    [sym_destructured_parameter] = STATE(5920),
    [anon_sym_LPAREN] = ACTIONS(9604),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
  },
  [3145] = {
    [sym_float] = ACTIONS(9594),
    [anon_sym_until] = ACTIONS(9594),
    [anon_sym_undef] = ACTIONS(9594),
    [sym_self] = ACTIONS(9594),
    [anon_sym_BEGIN] = ACTIONS(9594),
    [anon_sym_TILDE] = ACTIONS(9596),
    [anon_sym_unless] = ACTIONS(9594),
    [anon_sym_PLUS] = ACTIONS(9594),
    [sym__symbol_array_start] = ACTIONS(9596),
    [sym__simple_symbol] = ACTIONS(9596),
    [sym_complex] = ACTIONS(9596),
    [sym_heredoc_beginning] = ACTIONS(9596),
    [sym_super] = ACTIONS(9594),
    [anon_sym_rescue] = ACTIONS(9594),
    [anon_sym_alias] = ACTIONS(9594),
    [anon_sym_LBRACK2] = ACTIONS(9596),
    [anon_sym_nil] = ACTIONS(9594),
    [sym_character] = ACTIONS(9596),
    [anon_sym_LBRACE] = ACTIONS(9596),
    [anon_sym_END] = ACTIONS(9594),
    [sym_constant] = ACTIONS(9594),
    [anon_sym_while] = ACTIONS(9594),
    [sym_instance_variable] = ACTIONS(9596),
    [anon_sym_defined_QMARK] = ACTIONS(9596),
    [sym__string_start] = ACTIONS(9596),
    [anon_sym_else] = ACTIONS(9594),
    [anon_sym_true] = ACTIONS(9594),
    [anon_sym_for] = ACTIONS(9594),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(9596),
    [anon_sym_NIL] = ACTIONS(9594),
    [anon_sym_COLON_COLON] = ACTIONS(9596),
    [anon_sym_def] = ACTIONS(9594),
    [sym_identifier] = ACTIONS(9594),
    [anon_sym_yield] = ACTIONS(9594),
    [sym_class_variable] = ACTIONS(9596),
    [anon_sym_not] = ACTIONS(9594),
    [sym__symbol_start] = ACTIONS(9596),
    [anon_sym_TRUE] = ACTIONS(9594),
    [anon_sym_case] = ACTIONS(9594),
    [anon_sym_SEMI] = ACTIONS(9596),
    [anon_sym_LPAREN] = ACTIONS(9596),
    [anon_sym_break] = ACTIONS(9594),
    [sym_global_variable] = ACTIONS(9596),
    [anon_sym_class] = ACTIONS(9594),
    [sym__subshell_start] = ACTIONS(9596),
    [anon_sym_module] = ACTIONS(9594),
    [anon_sym_begin] = ACTIONS(9594),
    [anon_sym_false] = ACTIONS(9594),
    [anon_sym_STAR] = ACTIONS(9596),
    [sym__unary_minus] = ACTIONS(9596),
    [anon_sym_next] = ACTIONS(9594),
    [sym_retry] = ACTIONS(9594),
    [sym__regex_start] = ACTIONS(9596),
    [anon_sym_end] = ACTIONS(9594),
    [anon_sym_ensure] = ACTIONS(9594),
    [sym_integer] = ACTIONS(9594),
    [anon_sym_FALSE] = ACTIONS(9594),
    [sym_redo] = ACTIONS(9594),
    [anon_sym_BANG] = ACTIONS(9596),
    [anon_sym_if] = ACTIONS(9594),
    [sym__string_array_start] = ACTIONS(9596),
    [anon_sym_return] = ACTIONS(9594),
  },
  [3146] = {
    [sym__line_break] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [sym__heredoc_body_start] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(1049),
  },
  [3147] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [sym__line_break] = ACTIONS(9608),
    [anon_sym_then] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_when] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym___END__] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_end] = ACTIONS(9608),
    [anon_sym_ensure] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_elsif] = ACTIONS(9608),
    [ts_builtin_sym_end] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
    [sym__binary_minus] = ACTIONS(9608),
  },
  [3148] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5922),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9610),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3149] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(5924),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9612),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [3150] = {
    [sym_else] = STATE(5924),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(9614),
    [sym_comment] = ACTIONS(49),
  },
  [3151] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [sym__line_break] = ACTIONS(3852),
    [anon_sym_then] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_EQ_GT] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym___END__] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_end] = ACTIONS(3852),
    [anon_sym_ensure] = ACTIONS(3852),
    [anon_sym_else] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_elsif] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
    [sym__binary_minus] = ACTIONS(3852),
  },
  [3152] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(9616),
  },
  [3153] = {
    [aux_sym_symbol_array_repeat1] = STATE(5928),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(9618),
    [sym__string_end] = ACTIONS(9620),
  },
  [3154] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(9622),
  },
  [3155] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [sym__line_break] = ACTIONS(4056),
    [anon_sym_then] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_EQ_GT] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym___END__] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_end] = ACTIONS(4056),
    [anon_sym_ensure] = ACTIONS(4056),
    [anon_sym_else] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_elsif] = ACTIONS(4056),
    [ts_builtin_sym_end] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [sym__binary_minus] = ACTIONS(4056),
  },
  [3156] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(9624),
    [sym__string_end] = ACTIONS(9622),
  },
  [3157] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [sym__line_break] = ACTIONS(4426),
    [anon_sym_then] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_EQ_GT] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym___END__] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_end] = ACTIONS(4426),
    [anon_sym_ensure] = ACTIONS(4426),
    [anon_sym_else] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_elsif] = ACTIONS(4426),
    [ts_builtin_sym_end] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [sym__binary_minus] = ACTIONS(4426),
  },
  [3158] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [sym__line_break] = ACTIONS(4700),
    [anon_sym_then] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_EQ_GT] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_when] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym___END__] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_end] = ACTIONS(4700),
    [anon_sym_ensure] = ACTIONS(4700),
    [anon_sym_else] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_elsif] = ACTIONS(4700),
    [ts_builtin_sym_end] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
    [sym__binary_minus] = ACTIONS(4700),
  },
  [3159] = {
    [anon_sym_RBRACE] = ACTIONS(9626),
    [sym_comment] = ACTIONS(49),
  },
  [3160] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym___END__] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [3161] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5933),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9630),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3162] = {
    [anon_sym_SLASH] = ACTIONS(4768),
    [sym__line_break] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_COLON] = ACTIONS(4766),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_else] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_then] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_when] = ACTIONS(4768),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym___END__] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_ensure] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_elsif] = ACTIONS(4768),
    [ts_builtin_sym_end] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
  },
  [3163] = {
    [sym__terminator] = STATE(5934),
    [sym_heredoc_body] = STATE(5934),
    [sym__do] = STATE(5934),
    [anon_sym_do] = ACTIONS(9632),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(9632),
    [anon_sym_SEMI] = ACTIONS(9632),
    [sym_comment] = ACTIONS(49),
  },
  [3164] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [sym__line_break] = ACTIONS(5080),
    [anon_sym_then] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_when] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym___END__] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_end] = ACTIONS(5080),
    [anon_sym_ensure] = ACTIONS(5080),
    [anon_sym_else] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_elsif] = ACTIONS(5080),
    [ts_builtin_sym_end] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
  },
  [3165] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(5936),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(5936),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5937),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(9634),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(9634),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9636),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3166] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(5938),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(5937),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9636),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3167] = {
    [anon_sym_end] = ACTIONS(9638),
    [sym_comment] = ACTIONS(49),
  },
  [3168] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
  },
  [3169] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5940),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(9640),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [3170] = {
    [anon_sym_RBRACE] = ACTIONS(9640),
    [sym_comment] = ACTIONS(49),
  },
  [3171] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [sym__line_break] = ACTIONS(5238),
    [anon_sym_then] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym___END__] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_end] = ACTIONS(5238),
    [anon_sym_ensure] = ACTIONS(5238),
    [anon_sym_else] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_elsif] = ACTIONS(5238),
    [ts_builtin_sym_end] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [sym__binary_minus] = ACTIONS(5238),
  },
  [3172] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym___END__] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [3173] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [3174] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(5942),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9646),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3175] = {
    [sym__method_name] = STATE(1202),
    [sym_setter] = STATE(1202),
    [sym_symbol] = STATE(1202),
    [sym_operator] = STATE(1202),
    [sym__method_rest] = STATE(5943),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(9648),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(9648),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(9648),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(9648),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [3176] = {
    [sym_assignment] = STATE(5944),
    [sym_unary] = STATE(5944),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(5944),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(5944),
    [sym_conditional] = STATE(5944),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(5944),
    [sym_binary] = STATE(5944),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [3177] = {
    [sym_assignment] = STATE(5945),
    [sym_unary] = STATE(5945),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(5945),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(5945),
    [sym_conditional] = STATE(5945),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(5945),
    [sym_binary] = STATE(5945),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [3178] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3179] = {
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_then] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_when] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym___END__] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5454),
    [anon_sym_ensure] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_elsif] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
  },
  [3180] = {
    [anon_sym_RPAREN] = ACTIONS(9650),
    [sym_comment] = ACTIONS(49),
  },
  [3181] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym___END__] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3182] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym___END__] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3183] = {
    [aux_sym_heredoc_body_repeat1] = STATE(5948),
    [sym_interpolation] = STATE(5948),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(9652),
    [sym_heredoc_end] = ACTIONS(9654),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(9652),
  },
  [3184] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_heredoc_body] = STATE(5950),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym_float] = ACTIONS(497),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(505),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(523),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9656),
    [sym_redo] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [3185] = {
    [sym_heredoc_body] = STATE(5951),
    [aux_sym_call_repeat1] = STATE(5951),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3186] = {
    [sym_heredoc_body] = STATE(5952),
    [aux_sym_call_repeat1] = STATE(5952),
    [aux_sym_argument_list_repeat1] = STATE(5953),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3187] = {
    [sym_heredoc_body] = STATE(5954),
    [aux_sym_call_repeat1] = STATE(5954),
    [aux_sym_argument_list_repeat1] = STATE(5955),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3188] = {
    [sym_heredoc_body] = STATE(5954),
    [aux_sym_call_repeat1] = STATE(5954),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym___END__] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3189] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [3190] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [3191] = {
    [sym_assignment] = STATE(5956),
    [sym_unary] = STATE(5956),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5956),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5956),
    [sym_conditional] = STATE(5956),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5956),
    [sym_binary] = STATE(5956),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3192] = {
    [sym_assignment] = STATE(5957),
    [sym_unary] = STATE(5957),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5957),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(5958),
    [sym_operator_assignment] = STATE(5957),
    [sym_conditional] = STATE(5957),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_return] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_subshell] = STATE(44),
    [sym__arg_or_splat_arg] = STATE(5958),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5957),
    [sym_binary] = STATE(5957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11),
    [sym_character] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3193] = {
    [sym_assignment] = STATE(5959),
    [sym_unary] = STATE(5959),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5959),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5959),
    [sym_conditional] = STATE(5959),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5959),
    [sym_binary] = STATE(5959),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3194] = {
    [sym_assignment] = STATE(5960),
    [sym_unary] = STATE(5960),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5960),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5960),
    [sym_conditional] = STATE(5960),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5960),
    [sym_binary] = STATE(5960),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3195] = {
    [sym_assignment] = STATE(5962),
    [sym_unary] = STATE(5962),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5962),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5962),
    [sym_conditional] = STATE(5962),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5962),
    [sym_binary] = STATE(5962),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3196] = {
    [sym_assignment] = STATE(5963),
    [sym_unary] = STATE(5963),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(5963),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(5963),
    [sym_conditional] = STATE(5963),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(5963),
    [sym_binary] = STATE(5963),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3197] = {
    [sym_assignment] = STATE(5964),
    [sym_unary] = STATE(5964),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5964),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5964),
    [sym_conditional] = STATE(5964),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5964),
    [sym_binary] = STATE(5964),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3198] = {
    [sym_assignment] = STATE(5965),
    [sym_unary] = STATE(5965),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5965),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5965),
    [sym_conditional] = STATE(5965),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5965),
    [sym_binary] = STATE(5965),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3199] = {
    [sym_assignment] = STATE(5966),
    [sym_unary] = STATE(5966),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5966),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5966),
    [sym_conditional] = STATE(5966),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5966),
    [sym_binary] = STATE(5966),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3200] = {
    [sym_assignment] = STATE(5967),
    [sym_unary] = STATE(5967),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5967),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5967),
    [sym_conditional] = STATE(5967),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5967),
    [sym_binary] = STATE(5967),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3201] = {
    [sym_assignment] = STATE(5968),
    [sym_unary] = STATE(5968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5968),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(5968),
    [sym_conditional] = STATE(5968),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5968),
    [sym_binary] = STATE(5968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3202] = {
    [aux_sym_chained_string_repeat1] = STATE(5969),
    [sym_string] = STATE(5969),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym___END__] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [3203] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [sym__line_break] = ACTIONS(5628),
    [anon_sym_then] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym___END__] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_ensure] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_elsif] = ACTIONS(5628),
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [sym__binary_minus] = ACTIONS(5628),
  },
  [3204] = {
    [sym_when] = STATE(5972),
    [sym_else] = STATE(5971),
    [aux_sym_case_repeat2] = STATE(5972),
    [aux_sym_case_repeat1] = STATE(5973),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(9658),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(9660),
    [sym_comment] = ACTIONS(49),
  },
  [3205] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [sym__line_break] = ACTIONS(5746),
    [anon_sym_then] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_when] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym___END__] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_end] = ACTIONS(5746),
    [anon_sym_ensure] = ACTIONS(5746),
    [anon_sym_else] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_elsif] = ACTIONS(5746),
    [ts_builtin_sym_end] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [sym__binary_minus] = ACTIONS(5746),
  },
  [3206] = {
    [anon_sym_end] = ACTIONS(9658),
    [sym_comment] = ACTIONS(49),
  },
  [3207] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(5971),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(9658),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [3208] = {
    [sym_when] = STATE(5972),
    [sym_else] = STATE(5971),
    [aux_sym_case_repeat2] = STATE(5972),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(9658),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [3209] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3210] = {
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym_string] = STATE(3265),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3211] = {
    [sym_assignment] = STATE(5974),
    [sym_unary] = STATE(5974),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5974),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(5974),
    [sym_conditional] = STATE(5974),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(5974),
    [sym_binary] = STATE(5974),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3212] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [3213] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3214] = {
    [sym_assignment] = STATE(5975),
    [sym_unary] = STATE(5975),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5975),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(5975),
    [sym_conditional] = STATE(5975),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(5975),
    [sym_binary] = STATE(5975),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3215] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3216] = {
    [anon_sym_COLON] = ACTIONS(9664),
    [sym_comment] = ACTIONS(49),
  },
  [3217] = {
    [sym_assignment] = STATE(5978),
    [sym_unary] = STATE(5978),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(5978),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(5978),
    [sym_conditional] = STATE(5978),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(5978),
    [sym_binary] = STATE(5978),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3218] = {
    [sym_assignment] = STATE(5979),
    [sym_unary] = STATE(5979),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(5979),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(5979),
    [sym_conditional] = STATE(5979),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(5979),
    [sym_binary] = STATE(5979),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3219] = {
    [sym_assignment] = STATE(5980),
    [sym_unary] = STATE(5980),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(5980),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(5980),
    [sym_conditional] = STATE(5980),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(5980),
    [sym_binary] = STATE(5980),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3220] = {
    [sym_heredoc_body] = STATE(5982),
    [aux_sym_call_repeat1] = STATE(5982),
    [aux_sym_argument_list_repeat1] = STATE(5983),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9666),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3221] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [3222] = {
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym_string] = STATE(3265),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9668),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3223] = {
    [sym_heredoc_body] = STATE(5982),
    [aux_sym_call_repeat1] = STATE(5982),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3224] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [3225] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [3226] = {
    [sym_assignment] = STATE(5986),
    [sym_unary] = STATE(5986),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5986),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(5986),
    [sym_conditional] = STATE(5986),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(5986),
    [sym_binary] = STATE(5986),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3227] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3228] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [3229] = {
    [sym_assignment] = STATE(5987),
    [sym_unary] = STATE(5987),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(5987),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(5987),
    [sym_conditional] = STATE(5987),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(5987),
    [sym_binary] = STATE(5987),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [3230] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9670),
    [sym_identifier] = ACTIONS(9670),
  },
  [3231] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [3232] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(9672),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9672),
    [anon_sym_SLASH_EQ] = ACTIONS(9672),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9672),
    [anon_sym_PIPE_EQ] = ACTIONS(9672),
    [anon_sym_LT_LT_EQ] = ACTIONS(9672),
    [anon_sym_PLUS_EQ] = ACTIONS(9672),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9672),
    [anon_sym_STAR_EQ] = ACTIONS(9672),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9672),
    [anon_sym_CARET_EQ] = ACTIONS(9672),
    [anon_sym_DASH_EQ] = ACTIONS(9672),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9672),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9674),
  },
  [3233] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(9688),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(9688),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9700),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [3234] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(9704),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9708),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
  },
  [3235] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym__primary] = STATE(3126),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_method] = STATE(3126),
    [sym_conditional] = STATE(3131),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_subshell] = STATE(3126),
    [sym_unless] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3130),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_lambda] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(3131),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_nil] = STATE(3130),
    [sym_symbol_array] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_scope_resolution] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3236] = {
    [anon_sym_EQ] = ACTIONS(9710),
    [sym_comment] = ACTIONS(3),
  },
  [3237] = {
    [aux_sym_chained_string_repeat1] = STATE(6003),
    [sym_string] = STATE(6003),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3238] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(9688),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(9688),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9700),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [3239] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(9688),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(9688),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9700),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [3240] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(6005),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(4300),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [sym__heredoc_body_start] = ACTIONS(9712),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3241] = {
    [sym_heredoc_body] = STATE(2479),
    [aux_sym_argument_list_repeat1] = STATE(6007),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_RPAREN] = ACTIONS(4300),
    [sym_comment] = ACTIONS(49),
  },
  [3242] = {
    [sym_assignment] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3243] = {
    [sym_assignment] = STATE(6010),
    [sym_unary] = STATE(6010),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6010),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(6011),
    [sym_operator_assignment] = STATE(6010),
    [sym_conditional] = STATE(6010),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_subshell] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(6011),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6010),
    [sym_binary] = STATE(6010),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9716),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(2173),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3244] = {
    [sym_assignment] = STATE(6012),
    [sym_unary] = STATE(6012),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6012),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6012),
    [sym_conditional] = STATE(6012),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6012),
    [sym_binary] = STATE(6012),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3245] = {
    [sym_assignment] = STATE(6013),
    [sym_unary] = STATE(6013),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6013),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6013),
    [sym_conditional] = STATE(6013),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6013),
    [sym_binary] = STATE(6013),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3246] = {
    [sym_assignment] = STATE(6014),
    [sym_unary] = STATE(6014),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6014),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6014),
    [sym_conditional] = STATE(6014),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6014),
    [sym_binary] = STATE(6014),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3247] = {
    [sym_assignment] = STATE(6015),
    [sym_unary] = STATE(6015),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6015),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6015),
    [sym_conditional] = STATE(6015),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6015),
    [sym_binary] = STATE(6015),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3248] = {
    [sym_assignment] = STATE(6016),
    [sym_unary] = STATE(6016),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6016),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6016),
    [sym_conditional] = STATE(6016),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6016),
    [sym_binary] = STATE(6016),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3249] = {
    [sym_assignment] = STATE(6017),
    [sym_unary] = STATE(6017),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6017),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6017),
    [sym_conditional] = STATE(6017),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6017),
    [sym_binary] = STATE(6017),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3250] = {
    [sym_assignment] = STATE(6018),
    [sym_unary] = STATE(6018),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6018),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6018),
    [sym_conditional] = STATE(6018),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6018),
    [sym_binary] = STATE(6018),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3251] = {
    [sym_assignment] = STATE(6019),
    [sym_unary] = STATE(6019),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6019),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6019),
    [sym_conditional] = STATE(6019),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6019),
    [sym_binary] = STATE(6019),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3252] = {
    [sym_assignment] = STATE(6020),
    [sym_unary] = STATE(6020),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6020),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6020),
    [sym_conditional] = STATE(6020),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6020),
    [sym_binary] = STATE(6020),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3253] = {
    [sym_assignment] = STATE(6021),
    [sym_unary] = STATE(6021),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6021),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(6021),
    [sym_conditional] = STATE(6021),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6021),
    [sym_binary] = STATE(6021),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3254] = {
    [sym_heredoc_body] = STATE(6026),
    [sym__argument_list_with_parens] = STATE(6025),
    [aux_sym_call_repeat1] = STATE(6026),
    [sym_argument_list_with_parens] = STATE(6024),
    [sym_operator] = STATE(6024),
    [anon_sym_LT] = ACTIONS(9718),
    [anon_sym_SLASH] = ACTIONS(9720),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9720),
    [anon_sym_PLUS_AT] = ACTIONS(9720),
    [anon_sym_LPAREN2] = ACTIONS(9722),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9720),
    [anon_sym_GT_GT] = ACTIONS(9720),
    [anon_sym_EQ_TILDE] = ACTIONS(9720),
    [anon_sym_LT_LT] = ACTIONS(9720),
    [anon_sym_TILDE] = ACTIONS(9720),
    [anon_sym_PLUS] = ACTIONS(9718),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_GT] = ACTIONS(9718),
    [anon_sym_PERCENT] = ACTIONS(9720),
    [anon_sym_DASH_AT] = ACTIONS(9720),
    [anon_sym_EQ_EQ] = ACTIONS(9718),
    [anon_sym_STAR] = ACTIONS(9718),
    [anon_sym_BANG_TILDE] = ACTIONS(9720),
    [sym_constant] = ACTIONS(9724),
    [anon_sym_DASH] = ACTIONS(9718),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9720),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9718),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9720),
    [anon_sym_STAR_STAR] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9720),
    [anon_sym_DOT_DOT] = ACTIONS(9720),
    [anon_sym_LT_EQ_GT] = ACTIONS(9720),
    [anon_sym_LT_EQ] = ACTIONS(9718),
    [anon_sym_BANG] = ACTIONS(9718),
    [sym_identifier] = ACTIONS(9724),
    [anon_sym_CARET] = ACTIONS(9720),
  },
  [3255] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9726),
    [sym_identifier] = ACTIONS(9726),
  },
  [3256] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3257] = {
    [anon_sym_COLON] = ACTIONS(9730),
    [sym_comment] = ACTIONS(49),
  },
  [3258] = {
    [sym_assignment] = STATE(6030),
    [sym_unary] = STATE(6030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(6030),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(6030),
    [sym_conditional] = STATE(6030),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(6030),
    [sym_binary] = STATE(6030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3259] = {
    [sym_assignment] = STATE(6031),
    [sym_unary] = STATE(6031),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(6031),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(6031),
    [sym_conditional] = STATE(6031),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(6031),
    [sym_binary] = STATE(6031),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3260] = {
    [sym_assignment] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [3261] = {
    [sym_heredoc_body] = STATE(6034),
    [aux_sym_call_repeat1] = STATE(6034),
    [aux_sym_argument_list_repeat1] = STATE(6035),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9732),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3262] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [3263] = {
    [aux_sym_chained_string_repeat1] = STATE(5908),
    [sym_string] = STATE(5908),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9734),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3264] = {
    [sym_heredoc_body] = STATE(6034),
    [aux_sym_call_repeat1] = STATE(6034),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3265] = {
    [aux_sym_chained_string_repeat1] = STATE(6036),
    [sym_string] = STATE(6036),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3266] = {
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_SLASH] = ACTIONS(9738),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_then] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_when] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym___END__] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9738),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_ensure] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_elsif] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_AMP_AMP] = ACTIONS(9738),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
  },
  [3267] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [sym__line_break] = ACTIONS(5974),
    [anon_sym_then] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_when] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_end] = ACTIONS(5974),
    [anon_sym_ensure] = ACTIONS(5974),
    [anon_sym_else] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_elsif] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
    [sym__binary_minus] = ACTIONS(5974),
  },
  [3268] = {
    [sym_heredoc_body] = STATE(6037),
    [sym__terminator] = STATE(6037),
    [sym__line_break] = ACTIONS(9740),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3269] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6038),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3270] = {
    [sym_heredoc_body] = STATE(6039),
    [sym__terminator] = STATE(6039),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(9744),
    [anon_sym_SEMI] = ACTIONS(9744),
    [sym_comment] = ACTIONS(49),
  },
  [3271] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [sym__line_break] = ACTIONS(6073),
    [anon_sym_then] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_EQ_GT] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_when] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym___END__] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_end] = ACTIONS(6073),
    [anon_sym_ensure] = ACTIONS(6073),
    [anon_sym_else] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_elsif] = ACTIONS(6073),
    [ts_builtin_sym_end] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
    [sym__binary_minus] = ACTIONS(6073),
  },
  [3272] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [sym__line_break] = ACTIONS(6077),
    [anon_sym_then] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_when] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym___END__] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_end] = ACTIONS(6077),
    [anon_sym_ensure] = ACTIONS(6077),
    [anon_sym_else] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_elsif] = ACTIONS(6077),
    [ts_builtin_sym_end] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
    [sym__binary_minus] = ACTIONS(6077),
  },
  [3273] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6040),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9746),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3274] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [sym__line_break] = ACTIONS(6445),
    [anon_sym_then] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_when] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym___END__] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_end] = ACTIONS(6445),
    [anon_sym_ensure] = ACTIONS(6445),
    [anon_sym_else] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_elsif] = ACTIONS(6445),
    [ts_builtin_sym_end] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
    [sym__binary_minus] = ACTIONS(6445),
  },
  [3275] = {
    [anon_sym_end] = ACTIONS(9748),
    [sym_comment] = ACTIONS(49),
  },
  [3276] = {
    [sym_ensure] = STATE(6042),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(9748),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [3277] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [sym__line_break] = ACTIONS(6473),
    [anon_sym_then] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_EQ_GT] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_when] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym___END__] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_end] = ACTIONS(6473),
    [anon_sym_ensure] = ACTIONS(6473),
    [anon_sym_else] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_elsif] = ACTIONS(6473),
    [ts_builtin_sym_end] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
    [sym__binary_minus] = ACTIONS(6473),
  },
  [3278] = {
    [sym_ensure] = STATE(6042),
    [sym_else] = STATE(6043),
    [anon_sym_end] = ACTIONS(9748),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [3279] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [sym__line_break] = ACTIONS(6632),
    [anon_sym_then] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_EQ_GT] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_when] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym___END__] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6632),
    [anon_sym_ensure] = ACTIONS(6632),
    [anon_sym_else] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_elsif] = ACTIONS(6632),
    [ts_builtin_sym_end] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [sym__binary_minus] = ACTIONS(6632),
  },
  [3280] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(6045),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(6045),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9750),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3281] = {
    [sym_elsif] = STATE(6045),
    [sym_else] = STATE(6045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [3282] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [sym__line_break] = ACTIONS(6682),
    [anon_sym_then] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_EQ_GT] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_when] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym___END__] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_end] = ACTIONS(6682),
    [anon_sym_ensure] = ACTIONS(6682),
    [anon_sym_else] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_elsif] = ACTIONS(6682),
    [ts_builtin_sym_end] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
    [sym__binary_minus] = ACTIONS(6682),
  },
  [3283] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(9754),
  },
  [3284] = {
    [aux_sym_string_array_repeat1] = STATE(6049),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(9756),
    [sym__string_end] = ACTIONS(9758),
  },
  [3285] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(9760),
  },
  [3286] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [sym__line_break] = ACTIONS(6694),
    [anon_sym_then] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_EQ_GT] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_when] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym___END__] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_end] = ACTIONS(6694),
    [anon_sym_ensure] = ACTIONS(6694),
    [anon_sym_else] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_elsif] = ACTIONS(6694),
    [ts_builtin_sym_end] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
    [sym__binary_minus] = ACTIONS(6694),
  },
  [3287] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(9762),
    [sym__string_end] = ACTIONS(9760),
  },
  [3288] = {
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(4446),
    [sym__line_break] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_when] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym___END__] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(4446),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(4446),
    [anon_sym_ensure] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_elsif] = ACTIONS(4446),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_AMP_AMP] = ACTIONS(4446),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(4446),
    [sym__binary_minus] = ACTIONS(4446),
  },
  [3289] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(9764),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3290] = {
    [aux_sym_heredoc_body_repeat1] = STATE(6054),
    [sym_interpolation] = STATE(6054),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(9766),
    [sym_heredoc_end] = ACTIONS(9768),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(9766),
  },
  [3291] = {
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [3292] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(306),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym_float] = ACTIONS(497),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(505),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(537),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(543),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(5588),
    [sym_redo] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [3293] = {
    [sym_heredoc_body] = STATE(3293),
    [aux_sym_call_repeat1] = STATE(3293),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym___END__] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [3294] = {
    [sym_heredoc_body] = STATE(3293),
    [aux_sym_call_repeat1] = STATE(3293),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym___END__] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [3295] = {
    [aux_sym_argument_list_repeat1] = STATE(3295),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(9783),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [3296] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3297] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [3298] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym___END__] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3299] = {
    [aux_sym_exceptions_repeat1] = STATE(6057),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [3300] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3301] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3302] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [3303] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3304] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3305] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3306] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3307] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3308] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3309] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [3310] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym___END__] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [ts_builtin_sym_end] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [3311] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(6060),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(9794),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3312] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym___END__] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [ts_builtin_sym_end] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [3313] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym___END__] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [ts_builtin_sym_end] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [3314] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(3313),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(6061),
    [sym_operator] = STATE(6061),
    [anon_sym_LT] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5596),
    [anon_sym_PLUS_AT] = ACTIONS(5596),
    [anon_sym_LPAREN2] = ACTIONS(5598),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_TILDE] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_DASH_AT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5596),
    [sym_constant] = ACTIONS(9796),
    [anon_sym_DASH] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5594),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_LT_EQ_GT] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5594),
    [anon_sym_BANG] = ACTIONS(5594),
    [sym_identifier] = ACTIONS(9796),
    [anon_sym_CARET] = ACTIONS(5596),
  },
  [3315] = {
    [anon_sym_SLASH] = ACTIONS(6733),
    [sym__line_break] = ACTIONS(6735),
    [anon_sym_until] = ACTIONS(6735),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_RBRACE] = ACTIONS(6735),
    [anon_sym_unless] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_rescue] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_LBRACE] = ACTIONS(6735),
    [anon_sym_while] = ACTIONS(6735),
    [sym__heredoc_body_start] = ACTIONS(6735),
    [anon_sym_else] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_then] = ACTIONS(6735),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_EQ_GT] = ACTIONS(6735),
    [anon_sym_when] = ACTIONS(6735),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym___END__] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_end] = ACTIONS(6735),
    [anon_sym_ensure] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_elsif] = ACTIONS(6735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [ts_builtin_sym_end] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [anon_sym_if] = ACTIONS(6735),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [3316] = {
    [anon_sym_RBRACK] = ACTIONS(9798),
    [sym_comment] = ACTIONS(49),
  },
  [3317] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [ts_builtin_sym_end] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3318] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [3319] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(6064),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(9800),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [3320] = {
    [anon_sym_RBRACE] = ACTIONS(9800),
    [sym_comment] = ACTIONS(49),
  },
  [3321] = {
    [sym_assignment] = STATE(6065),
    [sym_unary] = STATE(6065),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(6065),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(6065),
    [sym_conditional] = STATE(6065),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(6065),
    [sym_binary] = STATE(6065),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [3322] = {
    [anon_sym_SLASH] = ACTIONS(5078),
    [sym__line_break] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_else] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_then] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5080),
    [anon_sym_when] = ACTIONS(5080),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym___END__] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_end] = ACTIONS(5080),
    [anon_sym_ensure] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_elsif] = ACTIONS(5080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [ts_builtin_sym_end] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [3323] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(6067),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(6067),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6068),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(9802),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9804),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3324] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(6069),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6068),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(9804),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3325] = {
    [anon_sym_end] = ACTIONS(9806),
    [sym_comment] = ACTIONS(49),
  },
  [3326] = {
    [sym_assignment] = STATE(6070),
    [sym_unary] = STATE(6070),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(6070),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(6070),
    [sym_conditional] = STATE(6070),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(6070),
    [sym_binary] = STATE(6070),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [3327] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym___END__] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [ts_builtin_sym_end] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [3328] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_when] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym___END__] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5454),
    [anon_sym_ensure] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_elsif] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
  },
  [3329] = {
    [anon_sym_RPAREN] = ACTIONS(9808),
    [sym_comment] = ACTIONS(49),
  },
  [3330] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym___END__] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [ts_builtin_sym_end] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [3331] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym___END__] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [ts_builtin_sym_end] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [3332] = {
    [anon_sym_SLASH] = ACTIONS(6989),
    [sym__line_break] = ACTIONS(6991),
    [anon_sym_until] = ACTIONS(6991),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_RBRACE] = ACTIONS(6991),
    [anon_sym_unless] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_rescue] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_while] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(6991),
    [anon_sym_else] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_then] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_EQ_GT] = ACTIONS(6991),
    [anon_sym_when] = ACTIONS(6991),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym___END__] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_end] = ACTIONS(6991),
    [anon_sym_ensure] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_elsif] = ACTIONS(6991),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [ts_builtin_sym_end] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [3333] = {
    [aux_sym_heredoc_body_repeat1] = STATE(6073),
    [sym_interpolation] = STATE(6073),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(9810),
    [sym_heredoc_end] = ACTIONS(9812),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(9810),
  },
  [3334] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_heredoc_body] = STATE(6075),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_float] = ACTIONS(795),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(801),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(801),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(817),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [sym_class_variable] = ACTIONS(817),
    [sym__block_ampersand] = ACTIONS(2289),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9814),
    [sym_redo] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [3335] = {
    [sym_heredoc_body] = STATE(6076),
    [aux_sym_call_repeat1] = STATE(6076),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3336] = {
    [sym_heredoc_body] = STATE(6077),
    [aux_sym_call_repeat1] = STATE(6077),
    [aux_sym_argument_list_repeat1] = STATE(6078),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3337] = {
    [aux_sym_chained_string_repeat1] = STATE(3337),
    [sym_string] = STATE(3337),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym___END__] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [3338] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3339] = {
    [aux_sym_chained_string_repeat1] = STATE(3379),
    [sym_string] = STATE(3379),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3340] = {
    [sym_assignment] = STATE(6079),
    [sym_unary] = STATE(6079),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6079),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(6079),
    [sym_conditional] = STATE(6079),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(6079),
    [sym_binary] = STATE(6079),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3341] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [3342] = {
    [sym_assignment] = STATE(6080),
    [sym_unary] = STATE(6080),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6080),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(6080),
    [sym_conditional] = STATE(6080),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(6080),
    [sym_binary] = STATE(6080),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3343] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9819),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3344] = {
    [anon_sym_COLON] = ACTIONS(9821),
    [sym_comment] = ACTIONS(49),
  },
  [3345] = {
    [sym_assignment] = STATE(6083),
    [sym_unary] = STATE(6083),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6083),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6083),
    [sym_conditional] = STATE(6083),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6083),
    [sym_binary] = STATE(6083),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3346] = {
    [sym_assignment] = STATE(6084),
    [sym_unary] = STATE(6084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6084),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6084),
    [sym_conditional] = STATE(6084),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6084),
    [sym_binary] = STATE(6084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3347] = {
    [sym_assignment] = STATE(6085),
    [sym_unary] = STATE(6085),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6085),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6085),
    [sym_conditional] = STATE(6085),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6085),
    [sym_binary] = STATE(6085),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3348] = {
    [sym_heredoc_body] = STATE(6087),
    [aux_sym_call_repeat1] = STATE(6087),
    [aux_sym_argument_list_repeat1] = STATE(6088),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9823),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3349] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [3350] = {
    [aux_sym_chained_string_repeat1] = STATE(3379),
    [sym_string] = STATE(3379),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9825),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3351] = {
    [sym_heredoc_body] = STATE(6087),
    [aux_sym_call_repeat1] = STATE(6087),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3352] = {
    [sym__argument] = STATE(6089),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6089),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6089),
    [sym_hash_splat_argument] = STATE(6089),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(6090),
    [sym_block_argument] = STATE(6089),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [3353] = {
    [sym__argument] = STATE(6089),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6089),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6089),
    [sym_hash_splat_argument] = STATE(6089),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(6090),
    [sym_block_argument] = STATE(6089),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [3354] = {
    [sym_assignment] = STATE(6091),
    [sym_unary] = STATE(6091),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6091),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(6091),
    [sym_conditional] = STATE(6091),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(6091),
    [sym_binary] = STATE(6091),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3355] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3356] = {
    [sym__argument] = STATE(6089),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6089),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6089),
    [sym_hash_splat_argument] = STATE(6089),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(6090),
    [sym_block_argument] = STATE(6089),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [3357] = {
    [sym_assignment] = STATE(6092),
    [sym_unary] = STATE(6092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6092),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(6092),
    [sym_conditional] = STATE(6092),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(6092),
    [sym_binary] = STATE(6092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3358] = {
    [sym__argument] = STATE(6089),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6089),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6089),
    [sym_hash_splat_argument] = STATE(6089),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym__argument_list_with_parens] = STATE(6090),
    [sym_block_argument] = STATE(6089),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(911),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2309),
    [sym_self] = ACTIONS(2311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2327),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [3359] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9827),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9827),
    [anon_sym_SLASH_EQ] = ACTIONS(9827),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9827),
    [anon_sym_PIPE_EQ] = ACTIONS(9827),
    [anon_sym_LT_LT_EQ] = ACTIONS(9827),
    [anon_sym_PLUS_EQ] = ACTIONS(9827),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9827),
    [anon_sym_STAR_EQ] = ACTIONS(9827),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9827),
    [anon_sym_CARET_EQ] = ACTIONS(9827),
    [anon_sym_DASH_EQ] = ACTIONS(9827),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9827),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9829),
  },
  [3360] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [3361] = {
    [anon_sym_EQ] = ACTIONS(9857),
    [sym_comment] = ACTIONS(3),
  },
  [3362] = {
    [aux_sym_chained_string_repeat1] = STATE(6104),
    [sym_string] = STATE(6104),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3363] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [3364] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [3365] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_heredoc_body] = STATE(6105),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2311),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2317),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2327),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9859),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3366] = {
    [sym_heredoc_body] = STATE(6106),
    [aux_sym_call_repeat1] = STATE(6106),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [3367] = {
    [sym_heredoc_body] = STATE(6107),
    [aux_sym_call_repeat1] = STATE(6107),
    [aux_sym_argument_list_repeat1] = STATE(6108),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [3368] = {
    [sym_assignment] = STATE(6109),
    [sym_unary] = STATE(6109),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6109),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6109),
    [sym_conditional] = STATE(6109),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6109),
    [sym_binary] = STATE(6109),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3369] = {
    [sym_assignment] = STATE(6110),
    [sym_unary] = STATE(6110),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6110),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6111),
    [sym_operator_assignment] = STATE(6110),
    [sym_conditional] = STATE(6110),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_subshell] = STATE(492),
    [sym__arg_or_splat_arg] = STATE(6111),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6110),
    [sym_binary] = STATE(6110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2311),
    [sym_character] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3370] = {
    [sym_assignment] = STATE(6112),
    [sym_unary] = STATE(6112),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6112),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6112),
    [sym_conditional] = STATE(6112),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6112),
    [sym_binary] = STATE(6112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3371] = {
    [sym_assignment] = STATE(6113),
    [sym_unary] = STATE(6113),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6113),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6113),
    [sym_conditional] = STATE(6113),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6113),
    [sym_binary] = STATE(6113),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3372] = {
    [sym_assignment] = STATE(6114),
    [sym_unary] = STATE(6114),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6114),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6114),
    [sym_conditional] = STATE(6114),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6114),
    [sym_binary] = STATE(6114),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3373] = {
    [sym_assignment] = STATE(6115),
    [sym_unary] = STATE(6115),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6115),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6115),
    [sym_conditional] = STATE(6115),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6115),
    [sym_binary] = STATE(6115),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3374] = {
    [sym_assignment] = STATE(6116),
    [sym_unary] = STATE(6116),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6116),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6116),
    [sym_conditional] = STATE(6116),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6116),
    [sym_binary] = STATE(6116),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3375] = {
    [sym_assignment] = STATE(6117),
    [sym_unary] = STATE(6117),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6117),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6117),
    [sym_conditional] = STATE(6117),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6117),
    [sym_binary] = STATE(6117),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3376] = {
    [sym_assignment] = STATE(6119),
    [sym_unary] = STATE(6119),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6119),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6119),
    [sym_conditional] = STATE(6119),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6119),
    [sym_binary] = STATE(6119),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3377] = {
    [sym_assignment] = STATE(6120),
    [sym_unary] = STATE(6120),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6120),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6120),
    [sym_conditional] = STATE(6120),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6120),
    [sym_binary] = STATE(6120),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3378] = {
    [sym_assignment] = STATE(6121),
    [sym_unary] = STATE(6121),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6121),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(6121),
    [sym_conditional] = STATE(6121),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6121),
    [sym_binary] = STATE(6121),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [3379] = {
    [aux_sym_chained_string_repeat1] = STATE(6122),
    [sym_string] = STATE(6122),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3380] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3381] = {
    [sym_assignment] = STATE(6123),
    [sym_unary] = STATE(6123),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6123),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(6123),
    [sym_conditional] = STATE(6123),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(6123),
    [sym_binary] = STATE(6123),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3382] = {
    [sym_assignment] = STATE(6124),
    [sym_unary] = STATE(6124),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6124),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(6124),
    [sym_conditional] = STATE(6124),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(6124),
    [sym_binary] = STATE(6124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3383] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3384] = {
    [sym_assignment] = STATE(6125),
    [sym_unary] = STATE(6125),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6125),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(6125),
    [sym_conditional] = STATE(6125),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(6125),
    [sym_binary] = STATE(6125),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [3385] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9861),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9861),
    [anon_sym_SLASH_EQ] = ACTIONS(9861),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9861),
    [anon_sym_PIPE_EQ] = ACTIONS(9861),
    [anon_sym_LT_LT_EQ] = ACTIONS(9861),
    [anon_sym_PLUS_EQ] = ACTIONS(9861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9861),
    [anon_sym_STAR_EQ] = ACTIONS(9861),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9861),
    [anon_sym_CARET_EQ] = ACTIONS(9861),
    [anon_sym_DASH_EQ] = ACTIONS(9861),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9861),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9863),
  },
  [3386] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [3387] = {
    [anon_sym_EQ] = ACTIONS(9891),
    [sym_comment] = ACTIONS(3),
  },
  [3388] = {
    [aux_sym_exceptions_repeat1] = STATE(6139),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(9893),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [3389] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3390] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [3391] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(9895),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [3392] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3393] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [3394] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3395] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3396] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [3397] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [3398] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [3399] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [sym__line_break] = ACTIONS(9899),
    [anon_sym_then] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_when] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym___END__] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_end] = ACTIONS(9899),
    [anon_sym_ensure] = ACTIONS(9899),
    [anon_sym_else] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_elsif] = ACTIONS(9899),
    [ts_builtin_sym_end] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
    [sym__binary_minus] = ACTIONS(9899),
  },
  [3400] = {
    [anon_sym_end] = ACTIONS(9901),
    [sym_comment] = ACTIONS(49),
  },
  [3401] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(6142),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(9901),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [3402] = {
    [sym_when] = STATE(6143),
    [sym_else] = STATE(6142),
    [aux_sym_case_repeat2] = STATE(6143),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(9901),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [3403] = {
    [aux_sym_chained_string_repeat1] = STATE(3403),
    [sym_string] = STATE(3403),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [3404] = {
    [sym__argument] = STATE(6149),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6149),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(6149),
    [sym_hash_splat_argument] = STATE(6149),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(6152),
    [sym_block_argument] = STATE(6149),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [3405] = {
    [sym_assignment] = STATE(6153),
    [sym_unary] = STATE(6153),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(6153),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(6153),
    [sym_conditional] = STATE(6153),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(6153),
    [sym_binary] = STATE(6153),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [3406] = {
    [sym__argument] = STATE(6149),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6149),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(6149),
    [sym_hash_splat_argument] = STATE(6149),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(6152),
    [sym_block_argument] = STATE(6149),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [3407] = {
    [sym_assignment] = STATE(6154),
    [sym_unary] = STATE(6154),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(6154),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(6154),
    [sym_conditional] = STATE(6154),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(6154),
    [sym_binary] = STATE(6154),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [3408] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [3409] = {
    [sym__argument] = STATE(6149),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6149),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(6149),
    [sym_hash_splat_argument] = STATE(6149),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(6152),
    [sym_block_argument] = STATE(6149),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [3410] = {
    [sym_assignment] = STATE(6155),
    [sym_unary] = STATE(6155),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(6155),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(6155),
    [sym_conditional] = STATE(6155),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(6155),
    [sym_binary] = STATE(6155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [3411] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(9911),
    [sym_identifier] = ACTIONS(9911),
  },
  [3412] = {
    [sym__argument] = STATE(6149),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6149),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(6149),
    [sym_hash_splat_argument] = STATE(6149),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym__argument_list_with_parens] = STATE(6152),
    [sym_block_argument] = STATE(6149),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(2627),
    [sym_self] = ACTIONS(2595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(6101),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [3413] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9913),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(9913),
    [anon_sym_SLASH_EQ] = ACTIONS(9913),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9913),
    [anon_sym_PIPE_EQ] = ACTIONS(9913),
    [anon_sym_LT_LT_EQ] = ACTIONS(9913),
    [anon_sym_PLUS_EQ] = ACTIONS(9913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9913),
    [anon_sym_STAR_EQ] = ACTIONS(9913),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9913),
    [anon_sym_CARET_EQ] = ACTIONS(9913),
    [anon_sym_DASH_EQ] = ACTIONS(9913),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9913),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9915),
  },
  [3414] = {
    [sym__line_break] = ACTIONS(9917),
    [anon_sym_then] = ACTIONS(9917),
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_SLASH] = ACTIONS(9921),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(9917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_SEMI] = ACTIONS(9917),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(9931),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(9931),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(9917),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(9943),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [3415] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(9947),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9949),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9951),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [3416] = {
    [sym__terminator] = STATE(6174),
    [sym_heredoc_body] = STATE(6174),
    [sym_then] = STATE(6175),
    [aux_sym_when_repeat1] = STATE(6176),
    [sym__heredoc_body_start] = ACTIONS(9953),
    [anon_sym_then] = ACTIONS(9955),
    [sym__line_break] = ACTIONS(9957),
    [anon_sym_COMMA] = ACTIONS(9959),
    [anon_sym_SEMI] = ACTIONS(9957),
    [sym_comment] = ACTIONS(49),
  },
  [3417] = {
    [sym__line_break] = ACTIONS(9917),
    [anon_sym_then] = ACTIONS(9917),
    [sym__heredoc_body_start] = ACTIONS(9917),
    [anon_sym_COMMA] = ACTIONS(9917),
    [anon_sym_SEMI] = ACTIONS(9917),
    [sym_comment] = ACTIONS(49),
  },
  [3418] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym__primary] = STATE(3687),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_method] = STATE(3687),
    [sym_conditional] = STATE(6183),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_subshell] = STATE(3687),
    [sym_unless] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3691),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_call] = STATE(3689),
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_rational] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_lambda] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(6183),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_nil] = STATE(3691),
    [sym_symbol_array] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_scope_resolution] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3419] = {
    [anon_sym_EQ] = ACTIONS(9969),
    [sym_comment] = ACTIONS(3),
  },
  [3420] = {
    [aux_sym_chained_string_repeat1] = STATE(6186),
    [sym_string] = STATE(6186),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3421] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(3736),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(6285),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [3422] = {
    [sym_when] = STATE(3422),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_end] = ACTIONS(9971),
    [anon_sym_when] = ACTIONS(9973),
    [anon_sym_else] = ACTIONS(9971),
    [sym_comment] = ACTIONS(49),
  },
  [3423] = {
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_end] = ACTIONS(9976),
    [anon_sym_when] = ACTIONS(9976),
    [anon_sym_else] = ACTIONS(9976),
    [anon_sym_SEMI] = ACTIONS(9978),
    [sym_comment] = ACTIONS(49),
  },
  [3424] = {
    [aux_sym_undef_repeat1] = STATE(6187),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [3425] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [3426] = {
    [aux_sym_chained_string_repeat1] = STATE(3478),
    [sym_string] = STATE(3478),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3427] = {
    [sym_assignment] = STATE(6188),
    [sym_unary] = STATE(6188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6188),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(6188),
    [sym_conditional] = STATE(6188),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(6188),
    [sym_binary] = STATE(6188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3428] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [3429] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3430] = {
    [sym_assignment] = STATE(6189),
    [sym_unary] = STATE(6189),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6189),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(6189),
    [sym_conditional] = STATE(6189),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(6189),
    [sym_binary] = STATE(6189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3431] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(9981),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3432] = {
    [anon_sym_COLON] = ACTIONS(9983),
    [sym_comment] = ACTIONS(49),
  },
  [3433] = {
    [sym_assignment] = STATE(6192),
    [sym_unary] = STATE(6192),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6192),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6192),
    [sym_conditional] = STATE(6192),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6192),
    [sym_binary] = STATE(6192),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3434] = {
    [sym_assignment] = STATE(6193),
    [sym_unary] = STATE(6193),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6193),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6193),
    [sym_conditional] = STATE(6193),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6193),
    [sym_binary] = STATE(6193),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3435] = {
    [sym_assignment] = STATE(6194),
    [sym_unary] = STATE(6194),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6194),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6194),
    [sym_conditional] = STATE(6194),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6194),
    [sym_binary] = STATE(6194),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3436] = {
    [sym_heredoc_body] = STATE(6196),
    [aux_sym_call_repeat1] = STATE(6196),
    [aux_sym_argument_list_repeat1] = STATE(6197),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9985),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3437] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [3438] = {
    [aux_sym_chained_string_repeat1] = STATE(3478),
    [sym_string] = STATE(3478),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(9987),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3439] = {
    [sym_heredoc_body] = STATE(6196),
    [aux_sym_call_repeat1] = STATE(6196),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3440] = {
    [sym__argument] = STATE(6198),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(6198),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6198),
    [sym_hash_splat_argument] = STATE(6198),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6199),
    [sym_block_argument] = STATE(6198),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [3441] = {
    [sym__argument] = STATE(6198),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(6198),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6198),
    [sym_hash_splat_argument] = STATE(6198),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6199),
    [sym_block_argument] = STATE(6198),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [3442] = {
    [sym_assignment] = STATE(6200),
    [sym_unary] = STATE(6200),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6200),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(6200),
    [sym_conditional] = STATE(6200),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(6200),
    [sym_binary] = STATE(6200),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3443] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3444] = {
    [sym__argument] = STATE(6198),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(6198),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6198),
    [sym_hash_splat_argument] = STATE(6198),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6199),
    [sym_block_argument] = STATE(6198),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [3445] = {
    [sym_assignment] = STATE(6201),
    [sym_unary] = STATE(6201),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6201),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(6201),
    [sym_conditional] = STATE(6201),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(6201),
    [sym_binary] = STATE(6201),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3446] = {
    [sym__argument] = STATE(6198),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(6198),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6198),
    [sym_hash_splat_argument] = STATE(6198),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6199),
    [sym_block_argument] = STATE(6198),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2391),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2393),
    [sym_self] = ACTIONS(2395),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2415),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2425),
  },
  [3447] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(9989),
    [anon_sym_GT_GT_EQ] = ACTIONS(9989),
    [anon_sym_SLASH_EQ] = ACTIONS(9989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(9989),
    [anon_sym_LT_LT_EQ] = ACTIONS(9989),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9989),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(9989),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(9991),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(9989),
    [anon_sym_PLUS_EQ] = ACTIONS(9989),
    [anon_sym_STAR_EQ] = ACTIONS(9989),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9989),
    [anon_sym_DASH_EQ] = ACTIONS(9989),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9989),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3448] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [3449] = {
    [anon_sym_EQ] = ACTIONS(10019),
    [sym_comment] = ACTIONS(3),
  },
  [3450] = {
    [aux_sym_chained_string_repeat1] = STATE(6213),
    [sym_string] = STATE(6213),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3451] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [3452] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [3453] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_heredoc_body] = STATE(6214),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_float] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2395),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2403),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10021),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3454] = {
    [sym_heredoc_body] = STATE(6215),
    [aux_sym_call_repeat1] = STATE(6215),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3455] = {
    [sym_heredoc_body] = STATE(6216),
    [aux_sym_call_repeat1] = STATE(6216),
    [aux_sym_argument_list_repeat1] = STATE(6217),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3456] = {
    [sym_assignment] = STATE(6218),
    [sym_unary] = STATE(6218),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6218),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6218),
    [sym_conditional] = STATE(6218),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6218),
    [sym_binary] = STATE(6218),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3457] = {
    [sym_assignment] = STATE(6219),
    [sym_unary] = STATE(6219),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6219),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6220),
    [sym_operator_assignment] = STATE(6219),
    [sym_conditional] = STATE(6219),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_subshell] = STATE(1376),
    [sym__arg_or_splat_arg] = STATE(6220),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6219),
    [sym_binary] = STATE(6219),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2395),
    [sym_character] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3458] = {
    [sym_assignment] = STATE(6221),
    [sym_unary] = STATE(6221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6221),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6221),
    [sym_conditional] = STATE(6221),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6221),
    [sym_binary] = STATE(6221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3459] = {
    [sym_assignment] = STATE(6222),
    [sym_unary] = STATE(6222),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6222),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6222),
    [sym_conditional] = STATE(6222),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6222),
    [sym_binary] = STATE(6222),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3460] = {
    [sym_assignment] = STATE(6223),
    [sym_unary] = STATE(6223),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6223),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6223),
    [sym_conditional] = STATE(6223),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6223),
    [sym_binary] = STATE(6223),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3461] = {
    [sym_assignment] = STATE(6224),
    [sym_unary] = STATE(6224),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6224),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6224),
    [sym_conditional] = STATE(6224),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6224),
    [sym_binary] = STATE(6224),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3462] = {
    [sym_assignment] = STATE(6225),
    [sym_unary] = STATE(6225),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6225),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6225),
    [sym_conditional] = STATE(6225),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6225),
    [sym_binary] = STATE(6225),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3463] = {
    [sym_assignment] = STATE(6226),
    [sym_unary] = STATE(6226),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6226),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6226),
    [sym_conditional] = STATE(6226),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6226),
    [sym_binary] = STATE(6226),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3464] = {
    [sym_assignment] = STATE(6228),
    [sym_unary] = STATE(6228),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6228),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6228),
    [sym_conditional] = STATE(6228),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6228),
    [sym_binary] = STATE(6228),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3465] = {
    [sym_assignment] = STATE(6229),
    [sym_unary] = STATE(6229),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6229),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6229),
    [sym_conditional] = STATE(6229),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6229),
    [sym_binary] = STATE(6229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3466] = {
    [sym_assignment] = STATE(6230),
    [sym_unary] = STATE(6230),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6230),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(6230),
    [sym_conditional] = STATE(6230),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6230),
    [sym_binary] = STATE(6230),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [3467] = {
    [sym_heredoc_body] = STATE(6235),
    [sym__argument_list_with_parens] = STATE(6234),
    [aux_sym_call_repeat1] = STATE(6235),
    [sym_argument_list_with_parens] = STATE(6233),
    [sym_operator] = STATE(6233),
    [anon_sym_LT] = ACTIONS(10023),
    [anon_sym_SLASH] = ACTIONS(10025),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10025),
    [anon_sym_PLUS_AT] = ACTIONS(10025),
    [anon_sym_LPAREN2] = ACTIONS(10027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10025),
    [anon_sym_GT_GT] = ACTIONS(10025),
    [anon_sym_EQ_TILDE] = ACTIONS(10025),
    [anon_sym_LT_LT] = ACTIONS(10025),
    [anon_sym_TILDE] = ACTIONS(10025),
    [anon_sym_PLUS] = ACTIONS(10023),
    [anon_sym_AMP] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10023),
    [anon_sym_PERCENT] = ACTIONS(10025),
    [anon_sym_DASH_AT] = ACTIONS(10025),
    [anon_sym_EQ_EQ] = ACTIONS(10023),
    [anon_sym_STAR] = ACTIONS(10023),
    [anon_sym_BANG_TILDE] = ACTIONS(10025),
    [sym_constant] = ACTIONS(10029),
    [anon_sym_DASH] = ACTIONS(10023),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10025),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10023),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10025),
    [anon_sym_STAR_STAR] = ACTIONS(10025),
    [anon_sym_PIPE] = ACTIONS(10025),
    [anon_sym_DOT_DOT] = ACTIONS(10025),
    [anon_sym_LT_EQ_GT] = ACTIONS(10025),
    [anon_sym_LT_EQ] = ACTIONS(10023),
    [anon_sym_BANG] = ACTIONS(10023),
    [sym_identifier] = ACTIONS(10029),
    [anon_sym_CARET] = ACTIONS(10025),
  },
  [3468] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10031),
    [sym_identifier] = ACTIONS(10031),
  },
  [3469] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10033),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3470] = {
    [anon_sym_COLON] = ACTIONS(10035),
    [sym_comment] = ACTIONS(49),
  },
  [3471] = {
    [sym_assignment] = STATE(6239),
    [sym_unary] = STATE(6239),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6239),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6239),
    [sym_conditional] = STATE(6239),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6239),
    [sym_binary] = STATE(6239),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3472] = {
    [sym_assignment] = STATE(6240),
    [sym_unary] = STATE(6240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6240),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6240),
    [sym_conditional] = STATE(6240),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6240),
    [sym_binary] = STATE(6240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3473] = {
    [sym_assignment] = STATE(6241),
    [sym_unary] = STATE(6241),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6241),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6241),
    [sym_conditional] = STATE(6241),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6241),
    [sym_binary] = STATE(6241),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3474] = {
    [sym_heredoc_body] = STATE(6243),
    [aux_sym_call_repeat1] = STATE(6243),
    [aux_sym_argument_list_repeat1] = STATE(6244),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10037),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3475] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [3476] = {
    [aux_sym_chained_string_repeat1] = STATE(3557),
    [sym_string] = STATE(3557),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10039),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3477] = {
    [sym_heredoc_body] = STATE(6243),
    [aux_sym_call_repeat1] = STATE(6243),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3478] = {
    [aux_sym_chained_string_repeat1] = STATE(6245),
    [sym_string] = STATE(6245),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [3479] = {
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3480] = {
    [sym_heredoc_body] = STATE(6250),
    [sym__argument_list_with_parens] = STATE(6249),
    [aux_sym_call_repeat1] = STATE(6250),
    [sym_argument_list_with_parens] = STATE(6248),
    [sym_operator] = STATE(6248),
    [anon_sym_LT] = ACTIONS(10041),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10043),
    [anon_sym_PLUS_AT] = ACTIONS(10043),
    [anon_sym_LPAREN2] = ACTIONS(10045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10043),
    [anon_sym_GT_GT] = ACTIONS(10043),
    [anon_sym_EQ_TILDE] = ACTIONS(10043),
    [anon_sym_LT_LT] = ACTIONS(10043),
    [anon_sym_TILDE] = ACTIONS(10043),
    [anon_sym_PLUS] = ACTIONS(10041),
    [anon_sym_AMP] = ACTIONS(10043),
    [anon_sym_GT] = ACTIONS(10041),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [anon_sym_DASH_AT] = ACTIONS(10043),
    [anon_sym_EQ_EQ] = ACTIONS(10041),
    [anon_sym_STAR] = ACTIONS(10041),
    [anon_sym_BANG_TILDE] = ACTIONS(10043),
    [sym_constant] = ACTIONS(10047),
    [anon_sym_DASH] = ACTIONS(10041),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10043),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10043),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_PIPE] = ACTIONS(10043),
    [anon_sym_DOT_DOT] = ACTIONS(10043),
    [anon_sym_LT_EQ_GT] = ACTIONS(10043),
    [anon_sym_LT_EQ] = ACTIONS(10041),
    [anon_sym_BANG] = ACTIONS(10041),
    [sym_identifier] = ACTIONS(10047),
    [anon_sym_CARET] = ACTIONS(10043),
  },
  [3481] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10049),
    [sym_identifier] = ACTIONS(10049),
  },
  [3482] = {
    [sym_assignment] = STATE(6252),
    [sym_unary] = STATE(6252),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6252),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(6252),
    [sym_conditional] = STATE(6252),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(6252),
    [sym_binary] = STATE(6252),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [3483] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [3484] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10051),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3485] = {
    [sym_assignment] = STATE(6255),
    [sym_unary] = STATE(6255),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6255),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(6255),
    [sym_conditional] = STATE(6255),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(6255),
    [sym_binary] = STATE(6255),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [3486] = {
    [anon_sym_COLON] = ACTIONS(10053),
    [sym_comment] = ACTIONS(49),
  },
  [3487] = {
    [sym__argument] = STATE(6262),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(6262),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(6262),
    [sym_hash_splat_argument] = STATE(6262),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(6265),
    [sym_block_argument] = STATE(6262),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(10059),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [3488] = {
    [sym_assignment] = STATE(6274),
    [sym_unary] = STATE(6274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(6274),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(6274),
    [sym_conditional] = STATE(6274),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(6274),
    [sym_binary] = STATE(6274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [3489] = {
    [sym_assignment] = STATE(6277),
    [sym_unary] = STATE(6277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(6277),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(6277),
    [sym_conditional] = STATE(6277),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(6277),
    [sym_binary] = STATE(6277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [3490] = {
    [sym__argument] = STATE(6262),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(6262),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(6262),
    [sym_hash_splat_argument] = STATE(6262),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(6265),
    [sym_block_argument] = STATE(6262),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(10059),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [3491] = {
    [sym__argument] = STATE(6262),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(6262),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(6262),
    [sym_hash_splat_argument] = STATE(6262),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(6265),
    [sym_block_argument] = STATE(6262),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(10059),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [3492] = {
    [sym_assignment] = STATE(6278),
    [sym_unary] = STATE(6278),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(6278),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(6278),
    [sym_conditional] = STATE(6278),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(6278),
    [sym_binary] = STATE(6278),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [3493] = {
    [sym__argument] = STATE(6262),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(6262),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(6262),
    [sym_hash_splat_argument] = STATE(6262),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(6265),
    [sym_block_argument] = STATE(6262),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(10059),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [3494] = {
    [anon_sym_EQ] = ACTIONS(10083),
    [sym_comment] = ACTIONS(3),
  },
  [3495] = {
    [sym_heredoc_body] = STATE(6281),
    [aux_sym_call_repeat1] = STATE(6281),
    [aux_sym_argument_list_repeat1] = STATE(6282),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(10085),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
  },
  [3496] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(10087),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(10087),
    [anon_sym_SLASH_EQ] = ACTIONS(10087),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10087),
    [anon_sym_PIPE_EQ] = ACTIONS(10087),
    [anon_sym_LT_LT_EQ] = ACTIONS(10087),
    [anon_sym_PLUS_EQ] = ACTIONS(10087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10087),
    [anon_sym_STAR_EQ] = ACTIONS(10087),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10087),
    [anon_sym_CARET_EQ] = ACTIONS(10087),
    [anon_sym_DASH_EQ] = ACTIONS(10087),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10087),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(10089),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3497] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(10103),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_EQ_GT] = ACTIONS(10053),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [anon_sym_and] = ACTIONS(10103),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_PIPE] = ACTIONS(10115),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [3498] = {
    [aux_sym_chained_string_repeat1] = STATE(6294),
    [sym_string] = STATE(6294),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10119),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3499] = {
    [sym_heredoc_body] = STATE(6281),
    [aux_sym_call_repeat1] = STATE(6281),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
  },
  [3500] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6698),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6698),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [3501] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6700),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6700),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [3502] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6702),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6702),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [3503] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [3504] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(10121),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3505] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6706),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6706),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [3506] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6708),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6708),
    [anon_sym_or] = ACTIONS(2513),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2525),
    [sym__binary_minus] = ACTIONS(2515),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(2527),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
  },
  [3507] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(1382),
    [sym_module] = STATE(1382),
    [sym_chained_string] = STATE(1382),
    [sym_until] = STATE(1382),
    [sym_regex] = STATE(1382),
    [sym_for] = STATE(1382),
    [sym_symbol] = STATE(1382),
    [sym_if] = STATE(1382),
    [sym_begin] = STATE(1382),
    [sym__primary] = STATE(1382),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(1382),
    [sym_singleton_method] = STATE(1382),
    [sym__variable] = STATE(1383),
    [sym_rational] = STATE(1382),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(1382),
    [sym_subshell] = STATE(1382),
    [sym_yield] = STATE(1382),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(1382),
    [sym_lambda] = STATE(1382),
    [sym_parenthesized_statements] = STATE(1382),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(1382),
    [sym_break] = STATE(1382),
    [sym_next] = STATE(1382),
    [sym_string_array] = STATE(1382),
    [sym_while] = STATE(1382),
    [sym_case] = STATE(1382),
    [sym_symbol_array] = STATE(1382),
    [sym_array] = STATE(1382),
    [sym_hash] = STATE(1382),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym__string_array_start] = ACTIONS(459),
    [sym_float] = ACTIONS(2427),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(393),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(399),
    [sym_identifier] = ACTIONS(2429),
    [sym_self] = ACTIONS(2429),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2433),
    [sym_super] = ACTIONS(2429),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2433),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(2433),
    [anon_sym_EQ] = ACTIONS(6712),
    [sym__symbol_start] = ACTIONS(461),
  },
  [3508] = {
    [aux_sym__mlhs_repeat1] = STATE(3508),
    [anon_sym_COMMA] = ACTIONS(10123),
    [anon_sym_RPAREN] = ACTIONS(6710),
    [anon_sym_EQ] = ACTIONS(6710),
    [sym_comment] = ACTIONS(3),
  },
  [3509] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [3510] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(6298),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(10126),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3511] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [3512] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [3513] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(3512),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(6299),
    [sym_operator] = STATE(6299),
    [anon_sym_LT] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5880),
    [anon_sym_PLUS_AT] = ACTIONS(5880),
    [anon_sym_LPAREN2] = ACTIONS(5882),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5880),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_EQ_TILDE] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5878),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5880),
    [anon_sym_DASH_AT] = ACTIONS(5880),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_BANG_TILDE] = ACTIONS(5880),
    [sym_constant] = ACTIONS(10128),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5880),
    [anon_sym_STAR_STAR] = ACTIONS(5880),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_BANG] = ACTIONS(5878),
    [sym_identifier] = ACTIONS(10128),
    [anon_sym_CARET] = ACTIONS(5880),
  },
  [3514] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3515] = {
    [sym_assignment] = STATE(6300),
    [sym_unary] = STATE(6300),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6300),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(6300),
    [sym_conditional] = STATE(6300),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(6300),
    [sym_binary] = STATE(6300),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3516] = {
    [sym_assignment] = STATE(6301),
    [sym_unary] = STATE(6301),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6301),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(6301),
    [sym_conditional] = STATE(6301),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(6301),
    [sym_binary] = STATE(6301),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3517] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3518] = {
    [sym_assignment] = STATE(6302),
    [sym_unary] = STATE(6302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(6302),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(6302),
    [sym_conditional] = STATE(6302),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(6302),
    [sym_binary] = STATE(6302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [3519] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10130),
    [anon_sym_GT_GT_EQ] = ACTIONS(10130),
    [anon_sym_SLASH_EQ] = ACTIONS(10130),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10130),
    [anon_sym_LT_LT_EQ] = ACTIONS(10130),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10130),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10130),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10132),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10130),
    [anon_sym_PLUS_EQ] = ACTIONS(10130),
    [anon_sym_STAR_EQ] = ACTIONS(10130),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10130),
    [anon_sym_DASH_EQ] = ACTIONS(10130),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10130),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3520] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [3521] = {
    [anon_sym_EQ] = ACTIONS(10160),
    [sym_comment] = ACTIONS(3),
  },
  [3522] = {
    [aux_sym_exceptions_repeat1] = STATE(6315),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(10162),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [3523] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [3524] = {
    [aux_sym_chained_string_repeat1] = STATE(3557),
    [sym_string] = STATE(3557),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3525] = {
    [sym_assignment] = STATE(6316),
    [sym_unary] = STATE(6316),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(6316),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(6316),
    [sym_conditional] = STATE(6316),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(6316),
    [sym_binary] = STATE(6316),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [3526] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [3527] = {
    [sym_assignment] = STATE(6317),
    [sym_unary] = STATE(6317),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(6317),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(6317),
    [sym_conditional] = STATE(6317),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(6317),
    [sym_binary] = STATE(6317),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [3528] = {
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [3529] = {
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [3530] = {
    [sym_assignment] = STATE(6318),
    [sym_unary] = STATE(6318),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(6318),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(6318),
    [sym_conditional] = STATE(6318),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(6318),
    [sym_binary] = STATE(6318),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [3531] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [3532] = {
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [3533] = {
    [sym_assignment] = STATE(6319),
    [sym_unary] = STATE(6319),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(6319),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(6319),
    [sym_conditional] = STATE(6319),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(6319),
    [sym_binary] = STATE(6319),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [3534] = {
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [3535] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10164),
    [anon_sym_GT_GT_EQ] = ACTIONS(10164),
    [anon_sym_SLASH_EQ] = ACTIONS(10164),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10164),
    [anon_sym_LT_LT_EQ] = ACTIONS(10164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10164),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(10164),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10166),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10164),
    [anon_sym_PLUS_EQ] = ACTIONS(10164),
    [anon_sym_STAR_EQ] = ACTIONS(10164),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10164),
    [anon_sym_DASH_EQ] = ACTIONS(10164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10164),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3536] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [3537] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(2453),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2455),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(2457),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3538] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym__primary] = STATE(1409),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(1412),
    [sym_method] = STATE(1409),
    [sym_conditional] = STATE(1414),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_subshell] = STATE(1409),
    [sym_unless] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_block_argument] = STATE(1412),
    [sym_range] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1413),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_call] = STATE(1411),
    [sym__argument] = STATE(1412),
    [sym_assignment] = STATE(1414),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_pair] = STATE(1412),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(1412),
    [sym_operator_assignment] = STATE(1414),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_rational] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_lambda] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym__argument_list_with_parens] = STATE(1416),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1414),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_nil] = STATE(1413),
    [sym_symbol_array] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_scope_resolution] = STATE(1411),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2463),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2467),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2407),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2475),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2483),
    [anon_sym_not] = ACTIONS(2485),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2495),
  },
  [3539] = {
    [anon_sym_EQ] = ACTIONS(10196),
    [sym_comment] = ACTIONS(3),
  },
  [3540] = {
    [aux_sym_chained_string_repeat1] = STATE(6331),
    [sym_string] = STATE(6331),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3541] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [3542] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [3543] = {
    [sym_assignment] = STATE(6332),
    [sym_unary] = STATE(6332),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6332),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(6333),
    [sym_operator_assignment] = STATE(6332),
    [sym_conditional] = STATE(6332),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_subshell] = STATE(1409),
    [sym__arg_or_splat_arg] = STATE(6333),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6332),
    [sym_binary] = STATE(6332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2467),
    [sym_character] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3544] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_heredoc_body] = STATE(6334),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym_float] = ACTIONS(2463),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2467),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2467),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2475),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [sym_class_variable] = ACTIONS(2475),
    [sym__block_ampersand] = ACTIONS(2483),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10198),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3545] = {
    [sym_heredoc_body] = STATE(6335),
    [aux_sym_call_repeat1] = STATE(6335),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3546] = {
    [sym_heredoc_body] = STATE(6336),
    [aux_sym_call_repeat1] = STATE(6336),
    [aux_sym_argument_list_repeat1] = STATE(6337),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5936),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3547] = {
    [sym_assignment] = STATE(6338),
    [sym_unary] = STATE(6338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6338),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6338),
    [sym_conditional] = STATE(6338),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6338),
    [sym_binary] = STATE(6338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3548] = {
    [sym_assignment] = STATE(6339),
    [sym_unary] = STATE(6339),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6339),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6339),
    [sym_conditional] = STATE(6339),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6339),
    [sym_binary] = STATE(6339),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3549] = {
    [sym_assignment] = STATE(6340),
    [sym_unary] = STATE(6340),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6340),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6340),
    [sym_conditional] = STATE(6340),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6340),
    [sym_binary] = STATE(6340),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3550] = {
    [sym_assignment] = STATE(6341),
    [sym_unary] = STATE(6341),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6341),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6341),
    [sym_conditional] = STATE(6341),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6341),
    [sym_binary] = STATE(6341),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3551] = {
    [sym_assignment] = STATE(6342),
    [sym_unary] = STATE(6342),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6342),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6342),
    [sym_conditional] = STATE(6342),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6342),
    [sym_binary] = STATE(6342),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3552] = {
    [sym_assignment] = STATE(6343),
    [sym_unary] = STATE(6343),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6343),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6343),
    [sym_conditional] = STATE(6343),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6343),
    [sym_binary] = STATE(6343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3553] = {
    [sym_assignment] = STATE(6344),
    [sym_unary] = STATE(6344),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6344),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6344),
    [sym_conditional] = STATE(6344),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6344),
    [sym_binary] = STATE(6344),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3554] = {
    [sym_assignment] = STATE(6346),
    [sym_unary] = STATE(6346),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6346),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6346),
    [sym_conditional] = STATE(6346),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6346),
    [sym_binary] = STATE(6346),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3555] = {
    [sym_assignment] = STATE(6347),
    [sym_unary] = STATE(6347),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6347),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6347),
    [sym_conditional] = STATE(6347),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6347),
    [sym_binary] = STATE(6347),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3556] = {
    [sym_assignment] = STATE(6348),
    [sym_unary] = STATE(6348),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6348),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(6348),
    [sym_conditional] = STATE(6348),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6348),
    [sym_binary] = STATE(6348),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [3557] = {
    [aux_sym_chained_string_repeat1] = STATE(6349),
    [sym_string] = STATE(6349),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [3558] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3559] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3560] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3561] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3562] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3563] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(10200),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [3564] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3565] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3566] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3567] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3568] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [3569] = {
    [aux_sym_chained_string_repeat1] = STATE(3569),
    [sym_string] = STATE(3569),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [3570] = {
    [sym_heredoc_body] = STATE(1390),
    [sym__terminator] = STATE(1390),
    [sym__line_break] = ACTIONS(2437),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(2445),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [3571] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6351),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(10202),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3572] = {
    [sym__line_break] = ACTIONS(10204),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(10204),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(10204),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [3573] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [sym__line_break] = ACTIONS(10208),
    [anon_sym_then] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_when] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym___END__] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_end] = ACTIONS(10208),
    [anon_sym_ensure] = ACTIONS(10208),
    [anon_sym_else] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_elsif] = ACTIONS(10208),
    [ts_builtin_sym_end] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
    [sym__binary_minus] = ACTIONS(10208),
  },
  [3574] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(375),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(378),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6352),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(10210),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3575] = {
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [sym_self] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(1327),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [anon_sym_next] = ACTIONS(1327),
    [sym_retry] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1327),
  },
  [3576] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(6354),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(10212),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3577] = {
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [sym_self] = ACTIONS(6719),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_nil] = ACTIONS(6719),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [anon_sym_next] = ACTIONS(6719),
    [sym_retry] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6721),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_return] = ACTIONS(6719),
  },
  [3578] = {
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [sym_self] = ACTIONS(6727),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_nil] = ACTIONS(6727),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [anon_sym_next] = ACTIONS(6727),
    [sym_retry] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(6727),
  },
  [3579] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(3578),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(6355),
    [sym_operator] = STATE(6355),
    [anon_sym_LT] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5987),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5987),
    [anon_sym_PLUS_AT] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(5989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5987),
    [anon_sym_GT_GT] = ACTIONS(5987),
    [anon_sym_EQ_TILDE] = ACTIONS(5987),
    [anon_sym_LT_LT] = ACTIONS(5987),
    [anon_sym_TILDE] = ACTIONS(5987),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5987),
    [anon_sym_DASH_AT] = ACTIONS(5987),
    [anon_sym_EQ_EQ] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_BANG_TILDE] = ACTIONS(5987),
    [sym_constant] = ACTIONS(10214),
    [anon_sym_DASH] = ACTIONS(5985),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(5987),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(5987),
    [anon_sym_STAR_STAR] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_DOT_DOT] = ACTIONS(5987),
    [anon_sym_LT_EQ_GT] = ACTIONS(5987),
    [anon_sym_LT_EQ] = ACTIONS(5985),
    [anon_sym_BANG] = ACTIONS(5985),
    [sym_identifier] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(5987),
  },
  [3580] = {
    [sym__line_break] = ACTIONS(6741),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6741),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3581] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3582] = {
    [aux_sym_chained_string_repeat1] = STATE(3625),
    [sym_string] = STATE(3625),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3583] = {
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
  },
  [3584] = {
    [sym_assignment] = STATE(6356),
    [sym_unary] = STATE(6356),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6356),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(6356),
    [sym_conditional] = STATE(6356),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(6356),
    [sym_binary] = STATE(6356),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [3585] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [3586] = {
    [sym_assignment] = STATE(6357),
    [sym_unary] = STATE(6357),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6357),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(6357),
    [sym_conditional] = STATE(6357),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(6357),
    [sym_binary] = STATE(6357),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [3587] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10216),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3588] = {
    [anon_sym_COLON] = ACTIONS(10218),
    [sym_comment] = ACTIONS(49),
  },
  [3589] = {
    [sym_assignment] = STATE(6360),
    [sym_unary] = STATE(6360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6360),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6360),
    [sym_conditional] = STATE(6360),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6360),
    [sym_binary] = STATE(6360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3590] = {
    [sym_assignment] = STATE(6361),
    [sym_unary] = STATE(6361),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6361),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6361),
    [sym_conditional] = STATE(6361),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6361),
    [sym_binary] = STATE(6361),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3591] = {
    [sym_assignment] = STATE(6362),
    [sym_unary] = STATE(6362),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6362),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6362),
    [sym_conditional] = STATE(6362),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6362),
    [sym_binary] = STATE(6362),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3592] = {
    [sym_heredoc_body] = STATE(6364),
    [aux_sym_call_repeat1] = STATE(6364),
    [aux_sym_argument_list_repeat1] = STATE(6365),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10220),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3593] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [3594] = {
    [aux_sym_chained_string_repeat1] = STATE(3625),
    [sym_string] = STATE(3625),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10222),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3595] = {
    [sym_heredoc_body] = STATE(6364),
    [aux_sym_call_repeat1] = STATE(6364),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3596] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [3597] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [3598] = {
    [sym_assignment] = STATE(6366),
    [sym_unary] = STATE(6366),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6366),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(6366),
    [sym_conditional] = STATE(6366),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(6366),
    [sym_binary] = STATE(6366),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [3599] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [3600] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [3601] = {
    [sym_assignment] = STATE(6367),
    [sym_unary] = STATE(6367),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6367),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(6367),
    [sym_conditional] = STATE(6367),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(6367),
    [sym_binary] = STATE(6367),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [3602] = {
    [sym__argument] = STATE(5780),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5780),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5780),
    [sym_hash_splat_argument] = STATE(5780),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(5783),
    [sym_block_argument] = STATE(5780),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2561),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [3603] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(10224),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(10224),
    [anon_sym_SLASH_EQ] = ACTIONS(10224),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10224),
    [anon_sym_PIPE_EQ] = ACTIONS(10224),
    [anon_sym_LT_LT_EQ] = ACTIONS(10224),
    [anon_sym_PLUS_EQ] = ACTIONS(10224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10224),
    [anon_sym_STAR_EQ] = ACTIONS(10224),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10224),
    [anon_sym_CARET_EQ] = ACTIONS(10224),
    [anon_sym_DASH_EQ] = ACTIONS(10224),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10224),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10226),
  },
  [3604] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(10240),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [anon_sym_and] = ACTIONS(10240),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_PIPE] = ACTIONS(10252),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [3605] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_for] = STATE(999),
    [sym_if] = STATE(999),
    [sym__primary] = STATE(999),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_method] = STATE(999),
    [sym_conditional] = STATE(5487),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_subshell] = STATE(999),
    [sym_unless] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1004),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_array] = STATE(999),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_lambda] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(5487),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_nil] = STATE(1004),
    [sym_symbol_array] = STATE(999),
    [sym_case] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_scope_resolution] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [3606] = {
    [anon_sym_EQ] = ACTIONS(10256),
    [sym_comment] = ACTIONS(3),
  },
  [3607] = {
    [aux_sym_chained_string_repeat1] = STATE(6380),
    [sym_string] = STATE(6380),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3608] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(10240),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [anon_sym_and] = ACTIONS(10240),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_PIPE] = ACTIONS(10252),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [3609] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(10240),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [anon_sym_and] = ACTIONS(10240),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_PIPE] = ACTIONS(10252),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [3610] = {
    [sym_assignment] = STATE(6381),
    [sym_unary] = STATE(6381),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6381),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(6382),
    [sym_operator_assignment] = STATE(6381),
    [sym_conditional] = STATE(6381),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_subshell] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(6382),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6381),
    [sym_binary] = STATE(6381),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3611] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1455),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1455),
    [sym_conditional] = STATE(1455),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(6383),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1455),
    [sym_binary] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3612] = {
    [sym_heredoc_body] = STATE(6384),
    [aux_sym_call_repeat1] = STATE(6384),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [3613] = {
    [sym_heredoc_body] = STATE(6385),
    [aux_sym_call_repeat1] = STATE(6385),
    [aux_sym_argument_list_repeat1] = STATE(6386),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [3614] = {
    [sym_assignment] = STATE(6387),
    [sym_unary] = STATE(6387),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6387),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6387),
    [sym_conditional] = STATE(6387),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6387),
    [sym_binary] = STATE(6387),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3615] = {
    [sym_assignment] = STATE(6388),
    [sym_unary] = STATE(6388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6388),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6388),
    [sym_conditional] = STATE(6388),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6388),
    [sym_binary] = STATE(6388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3616] = {
    [sym_assignment] = STATE(6389),
    [sym_unary] = STATE(6389),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6389),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6389),
    [sym_conditional] = STATE(6389),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6389),
    [sym_binary] = STATE(6389),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3617] = {
    [sym_assignment] = STATE(6390),
    [sym_unary] = STATE(6390),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6390),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6390),
    [sym_conditional] = STATE(6390),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6390),
    [sym_binary] = STATE(6390),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3618] = {
    [sym_assignment] = STATE(6391),
    [sym_unary] = STATE(6391),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6391),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6391),
    [sym_conditional] = STATE(6391),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6391),
    [sym_binary] = STATE(6391),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3619] = {
    [sym_assignment] = STATE(6392),
    [sym_unary] = STATE(6392),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6392),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6392),
    [sym_conditional] = STATE(6392),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6392),
    [sym_binary] = STATE(6392),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3620] = {
    [sym_assignment] = STATE(6393),
    [sym_unary] = STATE(6393),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6393),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6393),
    [sym_conditional] = STATE(6393),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6393),
    [sym_binary] = STATE(6393),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3621] = {
    [sym_assignment] = STATE(6394),
    [sym_unary] = STATE(6394),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6394),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6394),
    [sym_conditional] = STATE(6394),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6394),
    [sym_binary] = STATE(6394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3622] = {
    [sym_assignment] = STATE(6395),
    [sym_unary] = STATE(6395),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6395),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6395),
    [sym_conditional] = STATE(6395),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6395),
    [sym_binary] = STATE(6395),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3623] = {
    [sym_assignment] = STATE(6396),
    [sym_unary] = STATE(6396),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6396),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6396),
    [sym_conditional] = STATE(6396),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6396),
    [sym_binary] = STATE(6396),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3624] = {
    [sym_assignment] = STATE(6397),
    [sym_unary] = STATE(6397),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6397),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(6397),
    [sym_conditional] = STATE(6397),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6397),
    [sym_binary] = STATE(6397),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [3625] = {
    [aux_sym_chained_string_repeat1] = STATE(6398),
    [sym_string] = STATE(6398),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3626] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [sym__line_break] = ACTIONS(10260),
    [anon_sym_then] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_when] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym___END__] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_end] = ACTIONS(10260),
    [anon_sym_ensure] = ACTIONS(10260),
    [anon_sym_else] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_elsif] = ACTIONS(10260),
    [ts_builtin_sym_end] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
    [sym__binary_minus] = ACTIONS(10260),
  },
  [3627] = {
    [sym__line_break] = ACTIONS(6741),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3628] = {
    [aux_sym_undef_repeat1] = STATE(6399),
    [sym__line_break] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_ensure] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
  },
  [3629] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3630] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_rescue] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [anon_sym_ensure] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [3631] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(10262),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3632] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [3633] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_then] = ACTIONS(2053),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3634] = {
    [sym_assignment] = STATE(6401),
    [sym_unary] = STATE(6401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6401),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(6401),
    [sym_conditional] = STATE(6401),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(6401),
    [sym_binary] = STATE(6401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3635] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3636] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10266),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3637] = {
    [sym_assignment] = STATE(6403),
    [sym_unary] = STATE(6403),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6403),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(6403),
    [sym_conditional] = STATE(6403),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(6403),
    [sym_binary] = STATE(6403),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3638] = {
    [anon_sym_COLON] = ACTIONS(10268),
    [sym_comment] = ACTIONS(49),
  },
  [3639] = {
    [sym_assignment] = STATE(6405),
    [sym_unary] = STATE(6405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6405),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(6405),
    [sym_conditional] = STATE(6405),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(6405),
    [sym_binary] = STATE(6405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3640] = {
    [sym_assignment] = STATE(6406),
    [sym_unary] = STATE(6406),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6406),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(6406),
    [sym_conditional] = STATE(6406),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(6406),
    [sym_binary] = STATE(6406),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3641] = {
    [sym_assignment] = STATE(6407),
    [sym_unary] = STATE(6407),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6407),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(6407),
    [sym_conditional] = STATE(6407),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(6407),
    [sym_binary] = STATE(6407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3642] = {
    [sym_heredoc_body] = STATE(6409),
    [aux_sym_call_repeat1] = STATE(6409),
    [aux_sym_argument_list_repeat1] = STATE(6410),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10270),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3643] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10272),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(10272),
    [anon_sym_SLASH_EQ] = ACTIONS(10272),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10272),
    [anon_sym_PIPE_EQ] = ACTIONS(10272),
    [anon_sym_LT_LT_EQ] = ACTIONS(10272),
    [anon_sym_PLUS_EQ] = ACTIONS(10272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10272),
    [anon_sym_STAR_EQ] = ACTIONS(10272),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10272),
    [anon_sym_CARET_EQ] = ACTIONS(10272),
    [anon_sym_DASH_EQ] = ACTIONS(10272),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10272),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10274),
  },
  [3644] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [3645] = {
    [anon_sym_EQ] = ACTIONS(10302),
    [sym_comment] = ACTIONS(3),
  },
  [3646] = {
    [aux_sym_chained_string_repeat1] = STATE(3695),
    [sym_string] = STATE(3695),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10304),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3647] = {
    [sym_heredoc_body] = STATE(6409),
    [aux_sym_call_repeat1] = STATE(6409),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3648] = {
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(6149),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(6149),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_PIPE] = ACTIONS(6161),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [3649] = {
    [sym__line_break] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_then] = ACTIONS(391),
    [anon_sym_AMP_DOT] = ACTIONS(391),
    [anon_sym_COLON_COLON2] = ACTIONS(391),
    [sym__heredoc_body_start] = ACTIONS(391),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [sym_comment] = ACTIONS(49),
  },
  [3650] = {
    [sym__line_break] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(719),
    [anon_sym_then] = ACTIONS(719),
    [anon_sym_AMP_DOT] = ACTIONS(719),
    [anon_sym_COLON_COLON2] = ACTIONS(719),
    [sym__heredoc_body_start] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(719),
    [sym_comment] = ACTIONS(49),
  },
  [3651] = {
    [sym__line_break] = ACTIONS(291),
    [anon_sym_DOT] = ACTIONS(291),
    [anon_sym_then] = ACTIONS(291),
    [anon_sym_AMP_DOT] = ACTIONS(291),
    [anon_sym_COLON_COLON2] = ACTIONS(291),
    [sym__heredoc_body_start] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [sym_comment] = ACTIONS(49),
  },
  [3652] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10306),
    [sym_identifier] = ACTIONS(10306),
  },
  [3653] = {
    [sym__line_break] = ACTIONS(10308),
    [anon_sym_DOT] = ACTIONS(743),
    [anon_sym_then] = ACTIONS(10308),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(10308),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(10308),
    [sym_comment] = ACTIONS(49),
  },
  [3654] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10310),
    [anon_sym_AMP_DOT] = ACTIONS(10310),
    [anon_sym_LBRACK] = ACTIONS(10312),
    [anon_sym_COLON_COLON2] = ACTIONS(10314),
  },
  [3655] = {
    [sym_block] = STATE(6440),
    [sym_unary] = STATE(6445),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym__primary] = STATE(1481),
    [sym_argument_list] = STATE(6441),
    [sym_hash_splat_argument] = STATE(6443),
    [sym_method] = STATE(1481),
    [sym_conditional] = STATE(6445),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_subshell] = STATE(1481),
    [sym_unless] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_block_argument] = STATE(6443),
    [sym_range] = STATE(6445),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(6444),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_call] = STATE(3689),
    [sym__argument] = STATE(6443),
    [sym_assignment] = STATE(6445),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_pair] = STATE(6443),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6445),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(6443),
    [sym_operator_assignment] = STATE(6445),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_rational] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6446),
    [sym_lambda] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(6447),
    [sym_do_block] = STATE(6440),
    [sym_binary] = STATE(6445),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_nil] = STATE(6444),
    [sym_symbol_array] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_scope_resolution] = STATE(3689),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(10320),
    [sym_constant] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9588),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [sym__identifier_hash_key] = ACTIONS(10326),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10322),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(10330),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_then] = ACTIONS(791),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN2] = ACTIONS(10334),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(553),
    [sym__splat_star] = ACTIONS(10336),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10344),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [3656] = {
    [anon_sym_end] = ACTIONS(10348),
    [anon_sym_ensure] = ACTIONS(10348),
    [anon_sym_else] = ACTIONS(10348),
    [sym_comment] = ACTIONS(49),
  },
  [3657] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(6448),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(10350),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(6213),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(10350),
    [anon_sym_ensure] = ACTIONS(10350),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3658] = {
    [sym_rescue] = STATE(6448),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(10348),
    [anon_sym_ensure] = ACTIONS(10348),
    [anon_sym_else] = ACTIONS(10348),
    [sym_comment] = ACTIONS(49),
  },
  [3659] = {
    [sym_assignment] = STATE(6449),
    [sym_unary] = STATE(6449),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6449),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6449),
    [sym_conditional] = STATE(6449),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6449),
    [sym_binary] = STATE(6449),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3660] = {
    [sym_assignment] = STATE(6451),
    [sym_unary] = STATE(6451),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6451),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_splat_argument] = STATE(6452),
    [sym_operator_assignment] = STATE(6451),
    [sym_conditional] = STATE(6451),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_subshell] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(6452),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6451),
    [sym_binary] = STATE(6451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10352),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2595),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3661] = {
    [sym_assignment] = STATE(6453),
    [sym_unary] = STATE(6453),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6453),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6453),
    [sym_conditional] = STATE(6453),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6453),
    [sym_binary] = STATE(6453),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3662] = {
    [sym_assignment] = STATE(6454),
    [sym_unary] = STATE(6454),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6454),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6454),
    [sym_conditional] = STATE(6454),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6454),
    [sym_binary] = STATE(6454),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3663] = {
    [sym_assignment] = STATE(6455),
    [sym_unary] = STATE(6455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6455),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6455),
    [sym_conditional] = STATE(6455),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6455),
    [sym_binary] = STATE(6455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3664] = {
    [sym_assignment] = STATE(6456),
    [sym_unary] = STATE(6456),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6456),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6456),
    [sym_conditional] = STATE(6456),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6456),
    [sym_binary] = STATE(6456),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3665] = {
    [sym_assignment] = STATE(6457),
    [sym_unary] = STATE(6457),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6457),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6457),
    [sym_conditional] = STATE(6457),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6457),
    [sym_binary] = STATE(6457),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3666] = {
    [sym_assignment] = STATE(6458),
    [sym_unary] = STATE(6458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6458),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6458),
    [sym_conditional] = STATE(6458),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6458),
    [sym_binary] = STATE(6458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3667] = {
    [sym_assignment] = STATE(6459),
    [sym_unary] = STATE(6459),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6459),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6459),
    [sym_conditional] = STATE(6459),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6459),
    [sym_binary] = STATE(6459),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3668] = {
    [sym_assignment] = STATE(6460),
    [sym_unary] = STATE(6460),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6460),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6460),
    [sym_conditional] = STATE(6460),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6460),
    [sym_binary] = STATE(6460),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3669] = {
    [sym_assignment] = STATE(6461),
    [sym_unary] = STATE(6461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6461),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6461),
    [sym_conditional] = STATE(6461),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6461),
    [sym_binary] = STATE(6461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3670] = {
    [sym_assignment] = STATE(6462),
    [sym_unary] = STATE(6462),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6462),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(6462),
    [sym_conditional] = STATE(6462),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6462),
    [sym_binary] = STATE(6462),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3671] = {
    [sym_heredoc_body] = STATE(6467),
    [sym__argument_list_with_parens] = STATE(6466),
    [aux_sym_call_repeat1] = STATE(6467),
    [sym_argument_list_with_parens] = STATE(6465),
    [sym_operator] = STATE(6465),
    [anon_sym_LT] = ACTIONS(10354),
    [anon_sym_SLASH] = ACTIONS(10356),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10356),
    [anon_sym_PLUS_AT] = ACTIONS(10356),
    [anon_sym_LPAREN2] = ACTIONS(10358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10356),
    [anon_sym_GT_GT] = ACTIONS(10356),
    [anon_sym_EQ_TILDE] = ACTIONS(10356),
    [anon_sym_LT_LT] = ACTIONS(10356),
    [anon_sym_TILDE] = ACTIONS(10356),
    [anon_sym_PLUS] = ACTIONS(10354),
    [anon_sym_AMP] = ACTIONS(10356),
    [anon_sym_GT] = ACTIONS(10354),
    [anon_sym_PERCENT] = ACTIONS(10356),
    [anon_sym_DASH_AT] = ACTIONS(10356),
    [anon_sym_EQ_EQ] = ACTIONS(10354),
    [anon_sym_STAR] = ACTIONS(10354),
    [anon_sym_BANG_TILDE] = ACTIONS(10356),
    [sym_constant] = ACTIONS(10360),
    [anon_sym_DASH] = ACTIONS(10354),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10356),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10356),
    [anon_sym_STAR_STAR] = ACTIONS(10356),
    [anon_sym_PIPE] = ACTIONS(10356),
    [anon_sym_DOT_DOT] = ACTIONS(10356),
    [anon_sym_LT_EQ_GT] = ACTIONS(10356),
    [anon_sym_LT_EQ] = ACTIONS(10354),
    [anon_sym_BANG] = ACTIONS(10354),
    [sym_identifier] = ACTIONS(10360),
    [anon_sym_CARET] = ACTIONS(10356),
  },
  [3672] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10362),
    [sym_identifier] = ACTIONS(10362),
  },
  [3673] = {
    [sym_assignment] = STATE(1480),
    [sym_unary] = STATE(1480),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(1480),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_splat_argument] = STATE(6469),
    [sym_operator_assignment] = STATE(1480),
    [sym_conditional] = STATE(1480),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_true] = STATE(1479),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(6469),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(1480),
    [sym_binary] = STATE(1480),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2595),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [3674] = {
    [aux_sym_exceptions_repeat1] = STATE(6470),
    [anon_sym_EQ_GT] = ACTIONS(10364),
    [anon_sym_then] = ACTIONS(10364),
    [sym__line_break] = ACTIONS(10364),
    [sym__heredoc_body_start] = ACTIONS(10364),
    [anon_sym_COMMA] = ACTIONS(6173),
    [anon_sym_SEMI] = ACTIONS(10364),
    [sym_comment] = ACTIONS(49),
  },
  [3675] = {
    [sym_assignment] = STATE(6471),
    [sym_unary] = STATE(6471),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6471),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(6471),
    [sym_conditional] = STATE(6471),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(6471),
    [sym_binary] = STATE(6471),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3676] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3677] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10368),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3678] = {
    [sym_assignment] = STATE(6474),
    [sym_unary] = STATE(6474),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6474),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(6474),
    [sym_conditional] = STATE(6474),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(6474),
    [sym_binary] = STATE(6474),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3679] = {
    [anon_sym_COLON] = ACTIONS(10370),
    [sym_comment] = ACTIONS(49),
  },
  [3680] = {
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3681] = {
    [sym_assignment] = STATE(6476),
    [sym_unary] = STATE(6476),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6476),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(6476),
    [sym_conditional] = STATE(6476),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(6476),
    [sym_binary] = STATE(6476),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3682] = {
    [sym_assignment] = STATE(6477),
    [sym_unary] = STATE(6477),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6477),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(6477),
    [sym_conditional] = STATE(6477),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(6477),
    [sym_binary] = STATE(6477),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3683] = {
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3684] = {
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3685] = {
    [sym_assignment] = STATE(6478),
    [sym_unary] = STATE(6478),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6478),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(6478),
    [sym_conditional] = STATE(6478),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(6478),
    [sym_binary] = STATE(6478),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [3686] = {
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3687] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(6165),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6167),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(6169),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3688] = {
    [anon_sym_EQ] = ACTIONS(10372),
    [sym_comment] = ACTIONS(3),
  },
  [3689] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym__primary] = STATE(3687),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(3690),
    [sym_method] = STATE(3687),
    [sym_conditional] = STATE(3692),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_subshell] = STATE(3687),
    [sym_unless] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_block_argument] = STATE(3690),
    [sym_range] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3691),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_call] = STATE(3689),
    [sym__argument] = STATE(3690),
    [sym_assignment] = STATE(3692),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_pair] = STATE(3690),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(3690),
    [sym_operator_assignment] = STATE(3692),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_rational] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_lambda] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(3694),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(3692),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_nil] = STATE(3691),
    [sym_symbol_array] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_scope_resolution] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6195),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [3690] = {
    [sym_heredoc_body] = STATE(6481),
    [aux_sym_call_repeat1] = STATE(6481),
    [aux_sym_argument_list_repeat1] = STATE(6482),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10374),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3691] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10376),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(10376),
    [anon_sym_SLASH_EQ] = ACTIONS(10376),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10376),
    [anon_sym_PIPE_EQ] = ACTIONS(10376),
    [anon_sym_LT_LT_EQ] = ACTIONS(10376),
    [anon_sym_PLUS_EQ] = ACTIONS(10376),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10376),
    [anon_sym_STAR_EQ] = ACTIONS(10376),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10376),
    [anon_sym_CARET_EQ] = ACTIONS(10376),
    [anon_sym_DASH_EQ] = ACTIONS(10376),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10376),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(10378),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3692] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [3693] = {
    [aux_sym_chained_string_repeat1] = STATE(6493),
    [sym_string] = STATE(6493),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10408),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3694] = {
    [sym_heredoc_body] = STATE(6481),
    [aux_sym_call_repeat1] = STATE(6481),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3695] = {
    [aux_sym_chained_string_repeat1] = STATE(6494),
    [sym_string] = STATE(6494),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3696] = {
    [sym__terminator] = STATE(6495),
    [sym_heredoc_body] = STATE(6495),
    [sym_then] = STATE(6496),
    [sym__heredoc_body_start] = ACTIONS(2605),
    [anon_sym_then] = ACTIONS(6127),
    [sym__line_break] = ACTIONS(10410),
    [anon_sym_SEMI] = ACTIONS(10410),
    [sym_comment] = ACTIONS(49),
  },
  [3697] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4659),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(7786),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(7786),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(7786),
    [anon_sym_ensure] = ACTIONS(7786),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [3698] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_rescue] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [anon_sym_ensure] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [3699] = {
    [aux_sym_undef_repeat1] = STATE(6497),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_ensure] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [3700] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [3701] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [anon_sym_ensure] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [3702] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(10414),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3703] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [3704] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_ensure] = ACTIONS(2053),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3705] = {
    [sym_assignment] = STATE(6499),
    [sym_unary] = STATE(6499),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6499),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(6499),
    [sym_conditional] = STATE(6499),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(6499),
    [sym_binary] = STATE(6499),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [3706] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [3707] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(10420),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3708] = {
    [sym_assignment] = STATE(6502),
    [sym_unary] = STATE(6502),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6502),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(6502),
    [sym_conditional] = STATE(6502),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(6502),
    [sym_binary] = STATE(6502),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [3709] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10422),
    [sym_identifier] = ACTIONS(10422),
  },
  [3710] = {
    [anon_sym_COLON] = ACTIONS(10424),
    [sym_comment] = ACTIONS(49),
  },
  [3711] = {
    [sym__argument] = STATE(6510),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(6510),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(6510),
    [sym_hash_splat_argument] = STATE(6510),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(6513),
    [sym_block_argument] = STATE(6510),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [3712] = {
    [sym_assignment] = STATE(6522),
    [sym_unary] = STATE(6522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6522),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(6522),
    [sym_conditional] = STATE(6522),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(6522),
    [sym_binary] = STATE(6522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [3713] = {
    [sym_assignment] = STATE(6525),
    [sym_unary] = STATE(6525),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6525),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(6525),
    [sym_conditional] = STATE(6525),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(6525),
    [sym_binary] = STATE(6525),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [3714] = {
    [sym__argument] = STATE(6510),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(6510),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(6510),
    [sym_hash_splat_argument] = STATE(6510),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(6513),
    [sym_block_argument] = STATE(6510),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [3715] = {
    [sym__argument] = STATE(6510),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(6510),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(6510),
    [sym_hash_splat_argument] = STATE(6510),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(6513),
    [sym_block_argument] = STATE(6510),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [3716] = {
    [sym_assignment] = STATE(6526),
    [sym_unary] = STATE(6526),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6526),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(6526),
    [sym_conditional] = STATE(6526),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(6526),
    [sym_binary] = STATE(6526),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [3717] = {
    [sym__argument] = STATE(6510),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(6510),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(6510),
    [sym_hash_splat_argument] = STATE(6510),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(6513),
    [sym_block_argument] = STATE(6510),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [3718] = {
    [sym_heredoc_body] = STATE(6528),
    [aux_sym_call_repeat1] = STATE(6528),
    [aux_sym_argument_list_repeat1] = STATE(6529),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10452),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3719] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10454),
    [anon_sym_GT_GT_EQ] = ACTIONS(10454),
    [anon_sym_SLASH_EQ] = ACTIONS(10454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10454),
    [anon_sym_LT_LT_EQ] = ACTIONS(10454),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10454),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10454),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10456),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(10454),
    [anon_sym_PLUS_EQ] = ACTIONS(10454),
    [anon_sym_STAR_EQ] = ACTIONS(10454),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10454),
    [anon_sym_DASH_EQ] = ACTIONS(10454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10454),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3720] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_EQ_GT] = ACTIONS(10424),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [3721] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(10484),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(10486),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10488),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [3722] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym__primary] = STATE(3749),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_method] = STATE(3749),
    [sym_conditional] = STATE(6549),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_subshell] = STATE(3749),
    [sym_unless] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3753),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_call] = STATE(3751),
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_rational] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_lambda] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(6549),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_nil] = STATE(3753),
    [sym_symbol_array] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_scope_resolution] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3723] = {
    [anon_sym_EQ] = ACTIONS(10498),
    [sym_comment] = ACTIONS(3),
  },
  [3724] = {
    [aux_sym_chained_string_repeat1] = STATE(6552),
    [sym_string] = STATE(6552),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10500),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3725] = {
    [sym_heredoc_body] = STATE(6528),
    [aux_sym_call_repeat1] = STATE(6528),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3726] = {
    [sym_assignment] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3727] = {
    [sym_assignment] = STATE(6554),
    [sym_unary] = STATE(6554),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6554),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6554),
    [sym_conditional] = STATE(6554),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6554),
    [sym_binary] = STATE(6554),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3728] = {
    [sym_assignment] = STATE(6555),
    [sym_unary] = STATE(6555),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6555),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6555),
    [sym_conditional] = STATE(6555),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6555),
    [sym_binary] = STATE(6555),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3729] = {
    [sym_assignment] = STATE(6556),
    [sym_unary] = STATE(6556),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6556),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6556),
    [sym_conditional] = STATE(6556),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6556),
    [sym_binary] = STATE(6556),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3730] = {
    [sym_assignment] = STATE(6557),
    [sym_unary] = STATE(6557),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6557),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6557),
    [sym_conditional] = STATE(6557),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6557),
    [sym_binary] = STATE(6557),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3731] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [anon_sym_ensure] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [3732] = {
    [sym_heredoc_body] = STATE(6562),
    [sym__argument_list_with_parens] = STATE(6561),
    [aux_sym_call_repeat1] = STATE(6562),
    [sym_argument_list_with_parens] = STATE(6560),
    [sym_operator] = STATE(6560),
    [anon_sym_LT] = ACTIONS(10502),
    [anon_sym_SLASH] = ACTIONS(10504),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10504),
    [anon_sym_PLUS_AT] = ACTIONS(10504),
    [anon_sym_LPAREN2] = ACTIONS(10506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10504),
    [anon_sym_GT_GT] = ACTIONS(10504),
    [anon_sym_EQ_TILDE] = ACTIONS(10504),
    [anon_sym_LT_LT] = ACTIONS(10504),
    [anon_sym_TILDE] = ACTIONS(10504),
    [anon_sym_PLUS] = ACTIONS(10502),
    [anon_sym_AMP] = ACTIONS(10504),
    [anon_sym_GT] = ACTIONS(10502),
    [anon_sym_PERCENT] = ACTIONS(10504),
    [anon_sym_DASH_AT] = ACTIONS(10504),
    [anon_sym_EQ_EQ] = ACTIONS(10502),
    [anon_sym_STAR] = ACTIONS(10502),
    [anon_sym_BANG_TILDE] = ACTIONS(10504),
    [sym_constant] = ACTIONS(10508),
    [anon_sym_DASH] = ACTIONS(10502),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10504),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10504),
    [anon_sym_STAR_STAR] = ACTIONS(10504),
    [anon_sym_PIPE] = ACTIONS(10504),
    [anon_sym_DOT_DOT] = ACTIONS(10504),
    [anon_sym_LT_EQ_GT] = ACTIONS(10504),
    [anon_sym_LT_EQ] = ACTIONS(10502),
    [anon_sym_BANG] = ACTIONS(10502),
    [sym_identifier] = ACTIONS(10508),
    [anon_sym_CARET] = ACTIONS(10504),
  },
  [3733] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10510),
    [sym_identifier] = ACTIONS(10510),
  },
  [3734] = {
    [sym_assignment] = STATE(6569),
    [sym_unary] = STATE(6569),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6569),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_splat_argument] = STATE(6571),
    [sym_operator_assignment] = STATE(6569),
    [sym_conditional] = STATE(6569),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_return] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_subshell] = STATE(1502),
    [sym__arg_or_splat_arg] = STATE(6571),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(6569),
    [sym_binary] = STATE(6569),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(10516),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(2639),
    [sym_character] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [3735] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [anon_sym_ensure] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [3736] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(10524),
    [anon_sym_ensure] = ACTIONS(10524),
  },
  [3737] = {
    [sym_assignment] = STATE(6572),
    [sym_unary] = STATE(6572),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6572),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(6572),
    [sym_conditional] = STATE(6572),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(6572),
    [sym_binary] = STATE(6572),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [3738] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [3739] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(10528),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3740] = {
    [sym_assignment] = STATE(6575),
    [sym_unary] = STATE(6575),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6575),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(6575),
    [sym_conditional] = STATE(6575),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(6575),
    [sym_binary] = STATE(6575),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [3741] = {
    [anon_sym_COLON] = ACTIONS(10530),
    [sym_comment] = ACTIONS(49),
  },
  [3742] = {
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3743] = {
    [sym_assignment] = STATE(6585),
    [sym_unary] = STATE(6585),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(6585),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(6585),
    [sym_conditional] = STATE(6585),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(6585),
    [sym_binary] = STATE(6585),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [3744] = {
    [sym_assignment] = STATE(6590),
    [sym_unary] = STATE(6590),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(6590),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(6590),
    [sym_conditional] = STATE(6590),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(6590),
    [sym_binary] = STATE(6590),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [3745] = {
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3746] = {
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3747] = {
    [sym_assignment] = STATE(6591),
    [sym_unary] = STATE(6591),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(6591),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(6591),
    [sym_conditional] = STATE(6591),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(6591),
    [sym_binary] = STATE(6591),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [3748] = {
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3749] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(10484),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(10486),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(10488),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3750] = {
    [anon_sym_EQ] = ACTIONS(10558),
    [sym_comment] = ACTIONS(3),
  },
  [3751] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym__primary] = STATE(3749),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(6548),
    [sym_method] = STATE(3749),
    [sym_conditional] = STATE(6549),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_subshell] = STATE(3749),
    [sym_unless] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_block_argument] = STATE(6548),
    [sym_range] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3753),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_call] = STATE(3751),
    [sym__argument] = STATE(6548),
    [sym_assignment] = STATE(6549),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_pair] = STATE(6548),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6548),
    [sym_operator_assignment] = STATE(6549),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_rational] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_lambda] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(6551),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(6549),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_nil] = STATE(3753),
    [sym_symbol_array] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_scope_resolution] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(10494),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [3752] = {
    [sym_heredoc_body] = STATE(6594),
    [aux_sym_call_repeat1] = STATE(6594),
    [aux_sym_argument_list_repeat1] = STATE(6595),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10560),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3753] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10562),
    [anon_sym_GT_GT_EQ] = ACTIONS(10562),
    [anon_sym_SLASH_EQ] = ACTIONS(10562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10562),
    [anon_sym_LT_LT_EQ] = ACTIONS(10562),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10562),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(10562),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10564),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(10562),
    [anon_sym_PLUS_EQ] = ACTIONS(10562),
    [anon_sym_STAR_EQ] = ACTIONS(10562),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10562),
    [anon_sym_DASH_EQ] = ACTIONS(10562),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10562),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3754] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(10530),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [3755] = {
    [aux_sym_chained_string_repeat1] = STATE(6606),
    [sym_string] = STATE(6606),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10594),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3756] = {
    [sym_heredoc_body] = STATE(6594),
    [aux_sym_call_repeat1] = STATE(6594),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3757] = {
    [sym_assignment] = STATE(6607),
    [sym_unary] = STATE(6607),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6607),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6607),
    [sym_conditional] = STATE(6607),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6607),
    [sym_binary] = STATE(6607),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3758] = {
    [sym_assignment] = STATE(6608),
    [sym_unary] = STATE(6608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6608),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6608),
    [sym_conditional] = STATE(6608),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6608),
    [sym_binary] = STATE(6608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3759] = {
    [sym_assignment] = STATE(6609),
    [sym_unary] = STATE(6609),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6609),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6609),
    [sym_conditional] = STATE(6609),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6609),
    [sym_binary] = STATE(6609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3760] = {
    [sym_assignment] = STATE(6610),
    [sym_unary] = STATE(6610),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6610),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6610),
    [sym_conditional] = STATE(6610),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6610),
    [sym_binary] = STATE(6610),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3761] = {
    [sym_assignment] = STATE(6611),
    [sym_unary] = STATE(6611),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6611),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6611),
    [sym_conditional] = STATE(6611),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6611),
    [sym_binary] = STATE(6611),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3762] = {
    [sym_assignment] = STATE(6612),
    [sym_unary] = STATE(6612),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6612),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6612),
    [sym_conditional] = STATE(6612),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6612),
    [sym_binary] = STATE(6612),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3763] = {
    [sym_assignment] = STATE(6613),
    [sym_unary] = STATE(6613),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6613),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6613),
    [sym_conditional] = STATE(6613),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6613),
    [sym_binary] = STATE(6613),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3764] = {
    [sym_assignment] = STATE(6614),
    [sym_unary] = STATE(6614),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6614),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6614),
    [sym_conditional] = STATE(6614),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6614),
    [sym_binary] = STATE(6614),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3765] = {
    [sym_assignment] = STATE(6615),
    [sym_unary] = STATE(6615),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6615),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6615),
    [sym_conditional] = STATE(6615),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6615),
    [sym_binary] = STATE(6615),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3766] = {
    [sym_assignment] = STATE(6616),
    [sym_unary] = STATE(6616),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6616),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6616),
    [sym_conditional] = STATE(6616),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6616),
    [sym_binary] = STATE(6616),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3767] = {
    [sym_assignment] = STATE(6617),
    [sym_unary] = STATE(6617),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6617),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(6617),
    [sym_conditional] = STATE(6617),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(6617),
    [sym_binary] = STATE(6617),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [3768] = {
    [aux_sym_chained_string_repeat1] = STATE(6618),
    [sym_string] = STATE(6618),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [3769] = {
    [sym_heredoc_body] = STATE(3731),
    [sym__terminator] = STATE(3731),
    [sym__line_break] = ACTIONS(6263),
    [anon_sym_unless] = ACTIONS(6265),
    [anon_sym_until] = ACTIONS(6267),
    [anon_sym_while] = ACTIONS(6269),
    [sym__heredoc_body_start] = ACTIONS(2649),
    [anon_sym_rescue] = ACTIONS(6271),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_ensure] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(6273),
    [sym_comment] = ACTIONS(49),
  },
  [3770] = {
    [sym__statement] = STATE(6619),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(6619),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(6619),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(6619),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(3770),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(6619),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(6619),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(6619),
    [sym_if_modifier] = STATE(6619),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(6619),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(6619),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(3770),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [anon_sym_ensure] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [3771] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [3772] = {
    [aux_sym_chained_string_repeat1] = STATE(3824),
    [sym_string] = STATE(3824),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3773] = {
    [sym_assignment] = STATE(6620),
    [sym_unary] = STATE(6620),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6620),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(6620),
    [sym_conditional] = STATE(6620),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(6620),
    [sym_binary] = STATE(6620),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3774] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [3775] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_rescue] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_CARET] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [anon_sym_ensure] = ACTIONS(2053),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [3776] = {
    [sym_assignment] = STATE(6621),
    [sym_unary] = STATE(6621),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6621),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(6621),
    [sym_conditional] = STATE(6621),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(6621),
    [sym_binary] = STATE(6621),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3777] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(10599),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3778] = {
    [anon_sym_COLON] = ACTIONS(10601),
    [sym_comment] = ACTIONS(49),
  },
  [3779] = {
    [sym_assignment] = STATE(6624),
    [sym_unary] = STATE(6624),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6624),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6624),
    [sym_conditional] = STATE(6624),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6624),
    [sym_binary] = STATE(6624),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3780] = {
    [sym_assignment] = STATE(6625),
    [sym_unary] = STATE(6625),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6625),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6625),
    [sym_conditional] = STATE(6625),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6625),
    [sym_binary] = STATE(6625),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3781] = {
    [sym_assignment] = STATE(6626),
    [sym_unary] = STATE(6626),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6626),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6626),
    [sym_conditional] = STATE(6626),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6626),
    [sym_binary] = STATE(6626),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3782] = {
    [sym_heredoc_body] = STATE(6628),
    [aux_sym_call_repeat1] = STATE(6628),
    [aux_sym_argument_list_repeat1] = STATE(6629),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10603),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3783] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [3784] = {
    [aux_sym_chained_string_repeat1] = STATE(3824),
    [sym_string] = STATE(3824),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10605),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3785] = {
    [sym_heredoc_body] = STATE(6628),
    [aux_sym_call_repeat1] = STATE(6628),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [3786] = {
    [sym__argument] = STATE(6630),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(6630),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6630),
    [sym_hash_splat_argument] = STATE(6630),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(6631),
    [sym_block_argument] = STATE(6630),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [3787] = {
    [sym__argument] = STATE(6630),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(6630),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6630),
    [sym_hash_splat_argument] = STATE(6630),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(6631),
    [sym_block_argument] = STATE(6630),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [3788] = {
    [sym_assignment] = STATE(6632),
    [sym_unary] = STATE(6632),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6632),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(6632),
    [sym_conditional] = STATE(6632),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(6632),
    [sym_binary] = STATE(6632),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3789] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3790] = {
    [sym__argument] = STATE(6630),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(6630),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6630),
    [sym_hash_splat_argument] = STATE(6630),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(6631),
    [sym_block_argument] = STATE(6630),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [3791] = {
    [sym_assignment] = STATE(6633),
    [sym_unary] = STATE(6633),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6633),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(6633),
    [sym_conditional] = STATE(6633),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(6633),
    [sym_binary] = STATE(6633),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3792] = {
    [sym__argument] = STATE(6630),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(6630),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6630),
    [sym_hash_splat_argument] = STATE(6630),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym__argument_list_with_parens] = STATE(6631),
    [sym_block_argument] = STATE(6630),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2671),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2673),
    [sym_self] = ACTIONS(2675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(2695),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [3793] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10607),
    [anon_sym_GT_GT_EQ] = ACTIONS(10607),
    [anon_sym_SLASH_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10607),
    [anon_sym_LT_LT_EQ] = ACTIONS(10607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10607),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10607),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10609),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10607),
    [anon_sym_PLUS_EQ] = ACTIONS(10607),
    [anon_sym_STAR_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10607),
    [anon_sym_DASH_EQ] = ACTIONS(10607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10607),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3794] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [3795] = {
    [anon_sym_EQ] = ACTIONS(10637),
    [sym_comment] = ACTIONS(3),
  },
  [3796] = {
    [aux_sym_chained_string_repeat1] = STATE(6645),
    [sym_string] = STATE(6645),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3797] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [3798] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [3799] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_heredoc_body] = STATE(6646),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym_float] = ACTIONS(2671),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2675),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2683),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10639),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3800] = {
    [sym_heredoc_body] = STATE(6647),
    [aux_sym_call_repeat1] = STATE(6647),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3801] = {
    [sym_heredoc_body] = STATE(6648),
    [aux_sym_call_repeat1] = STATE(6648),
    [aux_sym_argument_list_repeat1] = STATE(6649),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(6391),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [3802] = {
    [sym_assignment] = STATE(6650),
    [sym_unary] = STATE(6650),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6650),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6650),
    [sym_conditional] = STATE(6650),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6650),
    [sym_binary] = STATE(6650),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3803] = {
    [sym_assignment] = STATE(6651),
    [sym_unary] = STATE(6651),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6651),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6652),
    [sym_operator_assignment] = STATE(6651),
    [sym_conditional] = STATE(6651),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_subshell] = STATE(1528),
    [sym__arg_or_splat_arg] = STATE(6652),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6651),
    [sym_binary] = STATE(6651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2675),
    [sym_character] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3804] = {
    [sym_assignment] = STATE(6653),
    [sym_unary] = STATE(6653),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6653),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6653),
    [sym_conditional] = STATE(6653),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6653),
    [sym_binary] = STATE(6653),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3805] = {
    [sym_assignment] = STATE(6654),
    [sym_unary] = STATE(6654),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6654),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6654),
    [sym_conditional] = STATE(6654),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6654),
    [sym_binary] = STATE(6654),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3806] = {
    [sym_assignment] = STATE(6655),
    [sym_unary] = STATE(6655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6655),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6655),
    [sym_conditional] = STATE(6655),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6655),
    [sym_binary] = STATE(6655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3807] = {
    [sym_assignment] = STATE(6656),
    [sym_unary] = STATE(6656),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6656),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6656),
    [sym_conditional] = STATE(6656),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6656),
    [sym_binary] = STATE(6656),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3808] = {
    [sym_assignment] = STATE(6657),
    [sym_unary] = STATE(6657),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6657),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6657),
    [sym_conditional] = STATE(6657),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6657),
    [sym_binary] = STATE(6657),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3809] = {
    [sym_assignment] = STATE(6658),
    [sym_unary] = STATE(6658),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6658),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6658),
    [sym_conditional] = STATE(6658),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6658),
    [sym_binary] = STATE(6658),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3810] = {
    [sym_assignment] = STATE(6660),
    [sym_unary] = STATE(6660),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6660),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6660),
    [sym_conditional] = STATE(6660),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6660),
    [sym_binary] = STATE(6660),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3811] = {
    [sym_assignment] = STATE(6661),
    [sym_unary] = STATE(6661),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6661),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6661),
    [sym_conditional] = STATE(6661),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6661),
    [sym_binary] = STATE(6661),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3812] = {
    [sym_assignment] = STATE(6662),
    [sym_unary] = STATE(6662),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6662),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(6662),
    [sym_conditional] = STATE(6662),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6662),
    [sym_binary] = STATE(6662),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [3813] = {
    [sym_heredoc_body] = STATE(6667),
    [sym__argument_list_with_parens] = STATE(6666),
    [aux_sym_call_repeat1] = STATE(6667),
    [sym_argument_list_with_parens] = STATE(6665),
    [sym_operator] = STATE(6665),
    [anon_sym_LT] = ACTIONS(10641),
    [anon_sym_SLASH] = ACTIONS(10643),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10643),
    [anon_sym_PLUS_AT] = ACTIONS(10643),
    [anon_sym_LPAREN2] = ACTIONS(10645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10643),
    [anon_sym_GT_GT] = ACTIONS(10643),
    [anon_sym_EQ_TILDE] = ACTIONS(10643),
    [anon_sym_LT_LT] = ACTIONS(10643),
    [anon_sym_TILDE] = ACTIONS(10643),
    [anon_sym_PLUS] = ACTIONS(10641),
    [anon_sym_AMP] = ACTIONS(10643),
    [anon_sym_GT] = ACTIONS(10641),
    [anon_sym_PERCENT] = ACTIONS(10643),
    [anon_sym_DASH_AT] = ACTIONS(10643),
    [anon_sym_EQ_EQ] = ACTIONS(10641),
    [anon_sym_STAR] = ACTIONS(10641),
    [anon_sym_BANG_TILDE] = ACTIONS(10643),
    [sym_constant] = ACTIONS(10647),
    [anon_sym_DASH] = ACTIONS(10641),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10643),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10641),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10643),
    [anon_sym_STAR_STAR] = ACTIONS(10643),
    [anon_sym_PIPE] = ACTIONS(10643),
    [anon_sym_DOT_DOT] = ACTIONS(10643),
    [anon_sym_LT_EQ_GT] = ACTIONS(10643),
    [anon_sym_LT_EQ] = ACTIONS(10641),
    [anon_sym_BANG] = ACTIONS(10641),
    [sym_identifier] = ACTIONS(10647),
    [anon_sym_CARET] = ACTIONS(10643),
  },
  [3814] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10649),
    [sym_identifier] = ACTIONS(10649),
  },
  [3815] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(10651),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3816] = {
    [anon_sym_COLON] = ACTIONS(10653),
    [sym_comment] = ACTIONS(49),
  },
  [3817] = {
    [sym_assignment] = STATE(6671),
    [sym_unary] = STATE(6671),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6671),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6671),
    [sym_conditional] = STATE(6671),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6671),
    [sym_binary] = STATE(6671),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3818] = {
    [sym_assignment] = STATE(6672),
    [sym_unary] = STATE(6672),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6672),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6672),
    [sym_conditional] = STATE(6672),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6672),
    [sym_binary] = STATE(6672),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3819] = {
    [sym_assignment] = STATE(6673),
    [sym_unary] = STATE(6673),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6673),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6673),
    [sym_conditional] = STATE(6673),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6673),
    [sym_binary] = STATE(6673),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3820] = {
    [sym_heredoc_body] = STATE(6675),
    [aux_sym_call_repeat1] = STATE(6675),
    [aux_sym_argument_list_repeat1] = STATE(6676),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10655),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3821] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [3822] = {
    [aux_sym_chained_string_repeat1] = STATE(3880),
    [sym_string] = STATE(3880),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10657),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3823] = {
    [sym_heredoc_body] = STATE(6675),
    [aux_sym_call_repeat1] = STATE(6675),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [3824] = {
    [aux_sym_chained_string_repeat1] = STATE(6677),
    [sym_string] = STATE(6677),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [3825] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6698),
    [anon_sym_ensure] = ACTIONS(6698),
    [anon_sym_else] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [3826] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6700),
    [anon_sym_ensure] = ACTIONS(6700),
    [anon_sym_else] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [3827] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6702),
    [anon_sym_ensure] = ACTIONS(6702),
    [anon_sym_else] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [3828] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6706),
    [anon_sym_ensure] = ACTIONS(6706),
    [anon_sym_else] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [3829] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2795),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6708),
    [anon_sym_ensure] = ACTIONS(6708),
    [anon_sym_else] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2807),
    [sym__binary_minus] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
  },
  [3830] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_ensure] = ACTIONS(1327),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [3831] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(6679),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(10659),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3832] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_ensure] = ACTIONS(6719),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [3833] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_ensure] = ACTIONS(6727),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [3834] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(3833),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(6680),
    [sym_operator] = STATE(6680),
    [anon_sym_LT] = ACTIONS(6447),
    [anon_sym_SLASH] = ACTIONS(6449),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6449),
    [anon_sym_PLUS_AT] = ACTIONS(6449),
    [anon_sym_LPAREN2] = ACTIONS(6451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6449),
    [anon_sym_GT_GT] = ACTIONS(6449),
    [anon_sym_EQ_TILDE] = ACTIONS(6449),
    [anon_sym_LT_LT] = ACTIONS(6449),
    [anon_sym_TILDE] = ACTIONS(6449),
    [anon_sym_PLUS] = ACTIONS(6447),
    [anon_sym_AMP] = ACTIONS(6449),
    [anon_sym_GT] = ACTIONS(6447),
    [anon_sym_PERCENT] = ACTIONS(6449),
    [anon_sym_DASH_AT] = ACTIONS(6449),
    [anon_sym_EQ_EQ] = ACTIONS(6447),
    [anon_sym_STAR] = ACTIONS(6447),
    [anon_sym_BANG_TILDE] = ACTIONS(6449),
    [sym_constant] = ACTIONS(10661),
    [anon_sym_DASH] = ACTIONS(6447),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(6449),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6447),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(6449),
    [anon_sym_STAR_STAR] = ACTIONS(6449),
    [anon_sym_PIPE] = ACTIONS(6449),
    [anon_sym_DOT_DOT] = ACTIONS(6449),
    [anon_sym_LT_EQ_GT] = ACTIONS(6449),
    [anon_sym_LT_EQ] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(6447),
    [sym_identifier] = ACTIONS(10661),
    [anon_sym_CARET] = ACTIONS(6449),
  },
  [3835] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3836] = {
    [sym_assignment] = STATE(6681),
    [sym_unary] = STATE(6681),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6681),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(6681),
    [sym_conditional] = STATE(6681),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(6681),
    [sym_binary] = STATE(6681),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3837] = {
    [sym_assignment] = STATE(6682),
    [sym_unary] = STATE(6682),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6682),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(6682),
    [sym_conditional] = STATE(6682),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(6682),
    [sym_binary] = STATE(6682),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3838] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3839] = {
    [sym_assignment] = STATE(6683),
    [sym_unary] = STATE(6683),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(6683),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(6683),
    [sym_conditional] = STATE(6683),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(6683),
    [sym_binary] = STATE(6683),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [3840] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10663),
    [anon_sym_GT_GT_EQ] = ACTIONS(10663),
    [anon_sym_SLASH_EQ] = ACTIONS(10663),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10663),
    [anon_sym_LT_LT_EQ] = ACTIONS(10663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10663),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10663),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10665),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10663),
    [anon_sym_PLUS_EQ] = ACTIONS(10663),
    [anon_sym_STAR_EQ] = ACTIONS(10663),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10663),
    [anon_sym_DASH_EQ] = ACTIONS(10663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3841] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [3842] = {
    [anon_sym_EQ] = ACTIONS(10693),
    [sym_comment] = ACTIONS(3),
  },
  [3843] = {
    [aux_sym_exceptions_repeat1] = STATE(6696),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(10695),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [3844] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [sym__line_break] = ACTIONS(10699),
    [anon_sym_then] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_when] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym___END__] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_end] = ACTIONS(10699),
    [anon_sym_ensure] = ACTIONS(10699),
    [anon_sym_else] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_elsif] = ACTIONS(10699),
    [ts_builtin_sym_end] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
    [sym__binary_minus] = ACTIONS(10699),
  },
  [3845] = {
    [anon_sym_end] = ACTIONS(10701),
    [sym_comment] = ACTIONS(49),
  },
  [3846] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [3847] = {
    [aux_sym_chained_string_repeat1] = STATE(3880),
    [sym_string] = STATE(3880),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3848] = {
    [sym_assignment] = STATE(6698),
    [sym_unary] = STATE(6698),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(6698),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(6698),
    [sym_conditional] = STATE(6698),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(6698),
    [sym_binary] = STATE(6698),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [3849] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [3850] = {
    [sym_assignment] = STATE(6699),
    [sym_unary] = STATE(6699),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(6699),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(6699),
    [sym_conditional] = STATE(6699),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(6699),
    [sym_binary] = STATE(6699),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [3851] = {
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [3852] = {
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [3853] = {
    [sym_assignment] = STATE(6700),
    [sym_unary] = STATE(6700),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(6700),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(6700),
    [sym_conditional] = STATE(6700),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(6700),
    [sym_binary] = STATE(6700),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [3854] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [3855] = {
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [3856] = {
    [sym_assignment] = STATE(6701),
    [sym_unary] = STATE(6701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(6701),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(6701),
    [sym_conditional] = STATE(6701),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(6701),
    [sym_binary] = STATE(6701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [3857] = {
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [3858] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10703),
    [anon_sym_GT_GT_EQ] = ACTIONS(10703),
    [anon_sym_SLASH_EQ] = ACTIONS(10703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10703),
    [anon_sym_LT_LT_EQ] = ACTIONS(10703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10703),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(10703),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10705),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10703),
    [anon_sym_PLUS_EQ] = ACTIONS(10703),
    [anon_sym_STAR_EQ] = ACTIONS(10703),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10703),
    [anon_sym_DASH_EQ] = ACTIONS(10703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10703),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3859] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [3860] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [3861] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym__primary] = STATE(1561),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(1564),
    [sym_method] = STATE(1561),
    [sym_conditional] = STATE(1566),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_subshell] = STATE(1561),
    [sym_unless] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_block_argument] = STATE(1564),
    [sym_range] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1565),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_call] = STATE(1563),
    [sym__argument] = STATE(1564),
    [sym_assignment] = STATE(1566),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_pair] = STATE(1564),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(1564),
    [sym_operator_assignment] = STATE(1566),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_rational] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_lambda] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym__argument_list_with_parens] = STATE(1568),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1566),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_nil] = STATE(1565),
    [sym_symbol_array] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_scope_resolution] = STATE(1563),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(2745),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(2749),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(2749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2767),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [3862] = {
    [anon_sym_EQ] = ACTIONS(10735),
    [sym_comment] = ACTIONS(3),
  },
  [3863] = {
    [aux_sym_chained_string_repeat1] = STATE(6713),
    [sym_string] = STATE(6713),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3864] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [3865] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [3866] = {
    [sym_assignment] = STATE(6714),
    [sym_unary] = STATE(6714),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6714),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(6715),
    [sym_operator_assignment] = STATE(6714),
    [sym_conditional] = STATE(6714),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_subshell] = STATE(1561),
    [sym__arg_or_splat_arg] = STATE(6715),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6714),
    [sym_binary] = STATE(6714),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2749),
    [sym_character] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3867] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_heredoc_body] = STATE(6716),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2749),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2749),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2757),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10737),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3868] = {
    [sym_heredoc_body] = STATE(6717),
    [aux_sym_call_repeat1] = STATE(6717),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3869] = {
    [sym_heredoc_body] = STATE(6718),
    [aux_sym_call_repeat1] = STATE(6718),
    [aux_sym_argument_list_repeat1] = STATE(6719),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(6509),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [3870] = {
    [sym_assignment] = STATE(6720),
    [sym_unary] = STATE(6720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6720),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6720),
    [sym_conditional] = STATE(6720),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6720),
    [sym_binary] = STATE(6720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3871] = {
    [sym_assignment] = STATE(6721),
    [sym_unary] = STATE(6721),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6721),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6721),
    [sym_conditional] = STATE(6721),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6721),
    [sym_binary] = STATE(6721),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3872] = {
    [sym_assignment] = STATE(6722),
    [sym_unary] = STATE(6722),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6722),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6722),
    [sym_conditional] = STATE(6722),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6722),
    [sym_binary] = STATE(6722),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3873] = {
    [sym_assignment] = STATE(6723),
    [sym_unary] = STATE(6723),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6723),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6723),
    [sym_conditional] = STATE(6723),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6723),
    [sym_binary] = STATE(6723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3874] = {
    [sym_assignment] = STATE(6724),
    [sym_unary] = STATE(6724),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6724),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6724),
    [sym_conditional] = STATE(6724),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6724),
    [sym_binary] = STATE(6724),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3875] = {
    [sym_assignment] = STATE(6725),
    [sym_unary] = STATE(6725),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6725),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6725),
    [sym_conditional] = STATE(6725),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6725),
    [sym_binary] = STATE(6725),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3876] = {
    [sym_assignment] = STATE(6726),
    [sym_unary] = STATE(6726),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6726),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6726),
    [sym_conditional] = STATE(6726),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6726),
    [sym_binary] = STATE(6726),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3877] = {
    [sym_assignment] = STATE(6728),
    [sym_unary] = STATE(6728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6728),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6728),
    [sym_conditional] = STATE(6728),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6728),
    [sym_binary] = STATE(6728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3878] = {
    [sym_assignment] = STATE(6729),
    [sym_unary] = STATE(6729),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6729),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6729),
    [sym_conditional] = STATE(6729),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6729),
    [sym_binary] = STATE(6729),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3879] = {
    [sym_assignment] = STATE(6730),
    [sym_unary] = STATE(6730),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6730),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(6730),
    [sym_conditional] = STATE(6730),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6730),
    [sym_binary] = STATE(6730),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [3880] = {
    [aux_sym_chained_string_repeat1] = STATE(6731),
    [sym_string] = STATE(6731),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [3881] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3882] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3883] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3884] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3885] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3886] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(10739),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [3887] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3888] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3889] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [3890] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3891] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [3892] = {
    [aux_sym_chained_string_repeat1] = STATE(3892),
    [sym_string] = STATE(3892),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [3893] = {
    [sym_ensure] = STATE(6733),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(10701),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [3894] = {
    [sym_heredoc_body] = STATE(1540),
    [sym__terminator] = STATE(1540),
    [sym__line_break] = ACTIONS(2711),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [3895] = {
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [sym_self] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(1327),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [anon_sym_next] = ACTIONS(1327),
    [sym_retry] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1327),
  },
  [3896] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(6735),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(10741),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [3897] = {
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [sym_self] = ACTIONS(6719),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_nil] = ACTIONS(6719),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6721),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [anon_sym_next] = ACTIONS(6719),
    [sym_retry] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6721),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_return] = ACTIONS(6719),
  },
  [3898] = {
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [sym_self] = ACTIONS(6727),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_nil] = ACTIONS(6727),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6729),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [anon_sym_next] = ACTIONS(6727),
    [sym_retry] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(6727),
  },
  [3899] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(3898),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(6736),
    [sym_operator] = STATE(6736),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6550),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6550),
    [anon_sym_PLUS_AT] = ACTIONS(6550),
    [anon_sym_LPAREN2] = ACTIONS(6552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6550),
    [anon_sym_GT_GT] = ACTIONS(6550),
    [anon_sym_EQ_TILDE] = ACTIONS(6550),
    [anon_sym_LT_LT] = ACTIONS(6550),
    [anon_sym_TILDE] = ACTIONS(6550),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6550),
    [anon_sym_DASH_AT] = ACTIONS(6550),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_BANG_TILDE] = ACTIONS(6550),
    [sym_constant] = ACTIONS(10743),
    [anon_sym_DASH] = ACTIONS(6548),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(6550),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6548),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(6550),
    [anon_sym_STAR_STAR] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_DOT_DOT] = ACTIONS(6550),
    [anon_sym_LT_EQ_GT] = ACTIONS(6550),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_BANG] = ACTIONS(6548),
    [sym_identifier] = ACTIONS(10743),
    [anon_sym_CARET] = ACTIONS(6550),
  },
  [3900] = {
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [3901] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [3902] = {
    [aux_sym_chained_string_repeat1] = STATE(3943),
    [sym_string] = STATE(3943),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3903] = {
    [sym_assignment] = STATE(6737),
    [sym_unary] = STATE(6737),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6737),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(6737),
    [sym_conditional] = STATE(6737),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(6737),
    [sym_binary] = STATE(6737),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [3904] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [3905] = {
    [sym_assignment] = STATE(6738),
    [sym_unary] = STATE(6738),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6738),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(6738),
    [sym_conditional] = STATE(6738),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(6738),
    [sym_binary] = STATE(6738),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [3906] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(10745),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [3907] = {
    [anon_sym_COLON] = ACTIONS(10747),
    [sym_comment] = ACTIONS(49),
  },
  [3908] = {
    [sym_assignment] = STATE(6741),
    [sym_unary] = STATE(6741),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6741),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6741),
    [sym_conditional] = STATE(6741),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6741),
    [sym_binary] = STATE(6741),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3909] = {
    [sym_assignment] = STATE(6742),
    [sym_unary] = STATE(6742),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6742),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6742),
    [sym_conditional] = STATE(6742),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6742),
    [sym_binary] = STATE(6742),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3910] = {
    [sym_assignment] = STATE(6743),
    [sym_unary] = STATE(6743),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6743),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6743),
    [sym_conditional] = STATE(6743),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6743),
    [sym_binary] = STATE(6743),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3911] = {
    [sym_heredoc_body] = STATE(6745),
    [aux_sym_call_repeat1] = STATE(6745),
    [aux_sym_argument_list_repeat1] = STATE(6746),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3912] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [3913] = {
    [aux_sym_chained_string_repeat1] = STATE(3943),
    [sym_string] = STATE(3943),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10751),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3914] = {
    [sym_heredoc_body] = STATE(6745),
    [aux_sym_call_repeat1] = STATE(6745),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [3915] = {
    [sym__argument] = STATE(6752),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(6752),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(6755),
    [sym_block_argument] = STATE(6752),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(10757),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [3916] = {
    [sym__argument] = STATE(6752),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(6752),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(6755),
    [sym_block_argument] = STATE(6752),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(10757),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [3917] = {
    [sym_assignment] = STATE(6756),
    [sym_unary] = STATE(6756),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6756),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(6756),
    [sym_conditional] = STATE(6756),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(6756),
    [sym_binary] = STATE(6756),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [3918] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [3919] = {
    [sym__argument] = STATE(6752),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(6752),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(6755),
    [sym_block_argument] = STATE(6752),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(10757),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [3920] = {
    [sym_assignment] = STATE(6757),
    [sym_unary] = STATE(6757),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(6757),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(6757),
    [sym_conditional] = STATE(6757),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(6757),
    [sym_binary] = STATE(6757),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [3921] = {
    [sym__argument] = STATE(6752),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(6752),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym__argument_list_with_parens] = STATE(6755),
    [sym_block_argument] = STATE(6752),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(1667),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(10757),
    [anon_sym_not] = ACTIONS(2833),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(6570),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [3922] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(10761),
    [anon_sym_SLASH_EQ] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10761),
    [anon_sym_PIPE_EQ] = ACTIONS(10761),
    [anon_sym_LT_LT_EQ] = ACTIONS(10761),
    [anon_sym_PLUS_EQ] = ACTIONS(10761),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10761),
    [anon_sym_STAR_EQ] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10761),
    [anon_sym_CARET_EQ] = ACTIONS(10761),
    [anon_sym_DASH_EQ] = ACTIONS(10761),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10761),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(10763),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3923] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(10777),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [anon_sym_and] = ACTIONS(10777),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_PIPE] = ACTIONS(10789),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [3924] = {
    [anon_sym_EQ] = ACTIONS(10793),
    [sym_comment] = ACTIONS(3),
  },
  [3925] = {
    [aux_sym_chained_string_repeat1] = STATE(6770),
    [sym_string] = STATE(6770),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [3926] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(10777),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [anon_sym_and] = ACTIONS(10777),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_PIPE] = ACTIONS(10789),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [3927] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(10777),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [anon_sym_and] = ACTIONS(10777),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_PIPE] = ACTIONS(10789),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [3928] = {
    [sym_assignment] = STATE(6771),
    [sym_unary] = STATE(6771),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6771),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(6772),
    [sym_operator_assignment] = STATE(6771),
    [sym_conditional] = STATE(6771),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_subshell] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(6772),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6771),
    [sym_binary] = STATE(6771),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3929] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1602),
    [sym_unary] = STATE(1602),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1602),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1602),
    [sym_conditional] = STATE(1602),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1603),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(6773),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1602),
    [sym_binary] = STATE(1602),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(2829),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2835),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2845),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3930] = {
    [sym_heredoc_body] = STATE(6774),
    [aux_sym_call_repeat1] = STATE(6774),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
  },
  [3931] = {
    [sym_heredoc_body] = STATE(6775),
    [aux_sym_call_repeat1] = STATE(6775),
    [aux_sym_argument_list_repeat1] = STATE(6776),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
  },
  [3932] = {
    [sym_assignment] = STATE(6777),
    [sym_unary] = STATE(6777),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6777),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6777),
    [sym_conditional] = STATE(6777),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6777),
    [sym_binary] = STATE(6777),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3933] = {
    [sym_assignment] = STATE(6778),
    [sym_unary] = STATE(6778),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6778),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6778),
    [sym_conditional] = STATE(6778),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6778),
    [sym_binary] = STATE(6778),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3934] = {
    [sym_assignment] = STATE(6779),
    [sym_unary] = STATE(6779),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6779),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6779),
    [sym_conditional] = STATE(6779),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6779),
    [sym_binary] = STATE(6779),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3935] = {
    [sym_assignment] = STATE(6780),
    [sym_unary] = STATE(6780),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6780),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6780),
    [sym_conditional] = STATE(6780),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6780),
    [sym_binary] = STATE(6780),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3936] = {
    [sym_assignment] = STATE(6781),
    [sym_unary] = STATE(6781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6781),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6781),
    [sym_conditional] = STATE(6781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6781),
    [sym_binary] = STATE(6781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3937] = {
    [sym_assignment] = STATE(6782),
    [sym_unary] = STATE(6782),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6782),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6782),
    [sym_conditional] = STATE(6782),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6782),
    [sym_binary] = STATE(6782),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3938] = {
    [sym_assignment] = STATE(6783),
    [sym_unary] = STATE(6783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6783),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6783),
    [sym_conditional] = STATE(6783),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6783),
    [sym_binary] = STATE(6783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3939] = {
    [sym_assignment] = STATE(6784),
    [sym_unary] = STATE(6784),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6784),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6784),
    [sym_conditional] = STATE(6784),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6784),
    [sym_binary] = STATE(6784),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3940] = {
    [sym_assignment] = STATE(6785),
    [sym_unary] = STATE(6785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6785),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6785),
    [sym_conditional] = STATE(6785),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6785),
    [sym_binary] = STATE(6785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3941] = {
    [sym_assignment] = STATE(6786),
    [sym_unary] = STATE(6786),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6786),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6786),
    [sym_conditional] = STATE(6786),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6786),
    [sym_binary] = STATE(6786),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3942] = {
    [sym_assignment] = STATE(6787),
    [sym_unary] = STATE(6787),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6787),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(6787),
    [sym_conditional] = STATE(6787),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6787),
    [sym_binary] = STATE(6787),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [3943] = {
    [aux_sym_chained_string_repeat1] = STATE(6788),
    [sym_string] = STATE(6788),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [3944] = {
    [sym__method_name] = STATE(6789),
    [sym_setter] = STATE(6789),
    [sym_symbol] = STATE(6789),
    [sym_operator] = STATE(6789),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(10795),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(10795),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(10795),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(10795),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [3945] = {
    [sym_assignment] = STATE(6790),
    [sym_unary] = STATE(6790),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(6790),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(6790),
    [sym_conditional] = STATE(6790),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(6790),
    [sym_binary] = STATE(6790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3946] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3947] = {
    [sym_assignment] = STATE(6791),
    [sym_unary] = STATE(6791),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(6791),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(6791),
    [sym_conditional] = STATE(6791),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(6791),
    [sym_binary] = STATE(6791),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3948] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(10797),
    [sym_identifier] = ACTIONS(10797),
  },
  [3949] = {
    [sym__argument] = STATE(6806),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(6806),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(6806),
    [sym_hash_splat_argument] = STATE(6806),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(6813),
    [sym_block_argument] = STATE(6806),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_elsif] = ACTIONS(501),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [3950] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_elsif] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [3951] = {
    [sym__argument] = STATE(6806),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(6806),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(6806),
    [sym_hash_splat_argument] = STATE(6806),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(6813),
    [sym_block_argument] = STATE(6806),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_elsif] = ACTIONS(647),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [3952] = {
    [sym__argument] = STATE(6806),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(6806),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(6806),
    [sym_hash_splat_argument] = STATE(6806),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(6813),
    [sym_block_argument] = STATE(6806),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [3953] = {
    [sym__argument] = STATE(6806),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(6806),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(6806),
    [sym_hash_splat_argument] = STATE(6806),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(6813),
    [sym_block_argument] = STATE(6806),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_elsif] = ACTIONS(753),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [3954] = {
    [sym_heredoc_body] = STATE(6820),
    [sym__terminator] = STATE(6820),
    [sym__line_break] = ACTIONS(10835),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(10837),
    [anon_sym_until] = ACTIONS(10839),
    [anon_sym_while] = ACTIONS(10841),
    [sym__heredoc_body_start] = ACTIONS(10843),
    [anon_sym_rescue] = ACTIONS(10845),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10847),
    [anon_sym_elsif] = ACTIONS(757),
  },
  [3955] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(10849),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(10851),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_elsif] = ACTIONS(777),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10853),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [3956] = {
    [anon_sym_EQ] = ACTIONS(10855),
    [sym_comment] = ACTIONS(3),
  },
  [3957] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym__primary] = STATE(6836),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_method] = STATE(6836),
    [sym_conditional] = STATE(6841),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_subshell] = STATE(6836),
    [sym_unless] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(6840),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_call] = STATE(6838),
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_rational] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_lambda] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(6841),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_nil] = STATE(6840),
    [sym_symbol_array] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_scope_resolution] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_elsif] = ACTIONS(791),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [3958] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(10891),
    [anon_sym_GT_GT_EQ] = ACTIONS(10891),
    [anon_sym_SLASH_EQ] = ACTIONS(10891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(10891),
    [anon_sym_LT_LT_EQ] = ACTIONS(10891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10891),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10891),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(10893),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(10891),
    [anon_sym_PLUS_EQ] = ACTIONS(10891),
    [anon_sym_STAR_EQ] = ACTIONS(10891),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10891),
    [anon_sym_DASH_EQ] = ACTIONS(10891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10891),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [3959] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_elsif] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [3960] = {
    [aux_sym_chained_string_repeat1] = STATE(6855),
    [sym_string] = STATE(6855),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [3961] = {
    [sym__statement] = STATE(6856),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(6856),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(6856),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(6856),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(6857),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(6856),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(6856),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(6856),
    [sym_if_modifier] = STATE(6856),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(6856),
    [sym_lambda] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(6856),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [aux_sym__statements_repeat1] = STATE(6857),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3962] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_elsif] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [3963] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(10923),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3964] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(4659),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(7786),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(7786),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(7786),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [3965] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [sym__line_break] = ACTIONS(10927),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
  },
  [3966] = {
    [sym__statement] = STATE(6859),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(6859),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(6859),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(6859),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(6859),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(6859),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(6859),
    [sym_if_modifier] = STATE(6859),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(6859),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(6859),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [3967] = {
    [anon_sym_end] = ACTIONS(10929),
    [sym_comment] = ACTIONS(49),
  },
  [3968] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [sym__line_break] = ACTIONS(10933),
    [anon_sym_then] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_when] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym___END__] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10933),
    [anon_sym_ensure] = ACTIONS(10933),
    [anon_sym_else] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_elsif] = ACTIONS(10933),
    [ts_builtin_sym_end] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
    [sym__binary_minus] = ACTIONS(10933),
  },
  [3969] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(10935),
  },
  [3970] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [sym__line_break] = ACTIONS(10939),
    [anon_sym_then] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_when] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym___END__] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_end] = ACTIONS(10939),
    [anon_sym_ensure] = ACTIONS(10939),
    [anon_sym_else] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_elsif] = ACTIONS(10939),
    [ts_builtin_sym_end] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
    [sym__binary_minus] = ACTIONS(10939),
  },
  [3971] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(10941),
    [sym__string_end] = ACTIONS(10935),
  },
  [3972] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [sym__line_break] = ACTIONS(10945),
    [anon_sym_then] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_when] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym___END__] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_end] = ACTIONS(10945),
    [anon_sym_ensure] = ACTIONS(10945),
    [anon_sym_else] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_elsif] = ACTIONS(10945),
    [ts_builtin_sym_end] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
    [sym__binary_minus] = ACTIONS(10945),
  },
  [3973] = {
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(10947),
    [sym__string_end] = ACTIONS(10947),
  },
  [3974] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(10949),
  },
  [3975] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(10951),
    [sym__string_end] = ACTIONS(10954),
  },
  [3976] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [anon_sym___END__] = ACTIONS(10412),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [ts_builtin_sym_end] = ACTIONS(8575),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [3977] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(390),
    [sym_module] = STATE(390),
    [sym_chained_string] = STATE(390),
    [sym_until] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_for] = STATE(390),
    [sym_symbol] = STATE(390),
    [sym_if] = STATE(390),
    [sym_begin] = STATE(390),
    [sym__primary] = STATE(390),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(390),
    [sym_singleton_method] = STATE(390),
    [sym__variable] = STATE(391),
    [sym_rational] = STATE(390),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(390),
    [sym_subshell] = STATE(390),
    [sym_yield] = STATE(390),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(390),
    [sym_lambda] = STATE(390),
    [sym_parenthesized_statements] = STATE(390),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(390),
    [sym_break] = STATE(390),
    [sym_next] = STATE(390),
    [sym_string_array] = STATE(390),
    [sym_while] = STATE(390),
    [sym_case] = STATE(390),
    [sym_symbol_array] = STATE(390),
    [sym_array] = STATE(390),
    [sym_hash] = STATE(390),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(391),
    [sym_call] = STATE(391),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(721),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(723),
    [sym_self] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(727),
    [sym_global_variable] = ACTIONS(729),
    [sym_super] = ACTIONS(723),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(721),
    [sym_constant] = ACTIONS(723),
    [sym_instance_variable] = ACTIONS(729),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(731),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(729),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [3978] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym___END__] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [3979] = {
    [anon_sym_RPAREN] = ACTIONS(10956),
    [sym_comment] = ACTIONS(49),
  },
  [3980] = {
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(4446),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4446),
    [anon_sym_PLUS_AT] = ACTIONS(4446),
    [anon_sym_LPAREN2] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(4446),
    [anon_sym_DASH_AT] = ACTIONS(4446),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [sym_constant] = ACTIONS(4446),
    [anon_sym_DASH] = ACTIONS(6215),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(4446),
    [anon_sym_DOT_DOT] = ACTIONS(4446),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(4446),
  },
  [3981] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(10958),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [3982] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym___END__] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [ts_builtin_sym_end] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [3983] = {
    [sym_heredoc_body] = STATE(3983),
    [aux_sym_call_repeat1] = STATE(3983),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_AT] = ACTIONS(9774),
    [anon_sym_LPAREN2] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_DASH_AT] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_STAR] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym_constant] = ACTIONS(9774),
    [anon_sym_DASH] = ACTIONS(9772),
    [sym__heredoc_body_start] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9772),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9774),
    [anon_sym_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_BANG] = ACTIONS(9772),
    [sym_identifier] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [3984] = {
    [anon_sym_SLASH] = ACTIONS(10967),
    [sym__line_break] = ACTIONS(10969),
    [anon_sym_until] = ACTIONS(10969),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_RBRACE] = ACTIONS(10969),
    [anon_sym_unless] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_rescue] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_LBRACE] = ACTIONS(10969),
    [anon_sym_while] = ACTIONS(10969),
    [sym__heredoc_body_start] = ACTIONS(10969),
    [anon_sym_else] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_then] = ACTIONS(10969),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_when] = ACTIONS(10969),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym___END__] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_end] = ACTIONS(10969),
    [anon_sym_ensure] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_elsif] = ACTIONS(10969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [ts_builtin_sym_end] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [anon_sym_if] = ACTIONS(10969),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [3985] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym___END__] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [3986] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [3987] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [3988] = {
    [sym_assignment] = STATE(6867),
    [sym_unary] = STATE(6867),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6867),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6867),
    [sym_conditional] = STATE(6867),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6867),
    [sym_binary] = STATE(6867),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3989] = {
    [sym_assignment] = STATE(1643),
    [sym_unary] = STATE(1643),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1643),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_splat_argument] = STATE(6868),
    [sym_operator_assignment] = STATE(1643),
    [sym_conditional] = STATE(1643),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_return] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_subshell] = STATE(44),
    [sym__arg_or_splat_arg] = STATE(6868),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(1643),
    [sym_binary] = STATE(1643),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11),
    [sym_character] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3990] = {
    [sym_assignment] = STATE(6869),
    [sym_unary] = STATE(6869),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6869),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6869),
    [sym_conditional] = STATE(6869),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6869),
    [sym_binary] = STATE(6869),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3991] = {
    [sym_assignment] = STATE(6870),
    [sym_unary] = STATE(6870),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6870),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6870),
    [sym_conditional] = STATE(6870),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6870),
    [sym_binary] = STATE(6870),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3992] = {
    [sym_assignment] = STATE(6872),
    [sym_unary] = STATE(6872),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6872),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6872),
    [sym_conditional] = STATE(6872),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6872),
    [sym_binary] = STATE(6872),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3993] = {
    [sym_assignment] = STATE(6873),
    [sym_unary] = STATE(6873),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6873),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6873),
    [sym_conditional] = STATE(6873),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6873),
    [sym_binary] = STATE(6873),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [3994] = {
    [sym_assignment] = STATE(6874),
    [sym_unary] = STATE(6874),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6874),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6874),
    [sym_conditional] = STATE(6874),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6874),
    [sym_binary] = STATE(6874),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3995] = {
    [sym_assignment] = STATE(6875),
    [sym_unary] = STATE(6875),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6875),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6875),
    [sym_conditional] = STATE(6875),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6875),
    [sym_binary] = STATE(6875),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3996] = {
    [sym_assignment] = STATE(6876),
    [sym_unary] = STATE(6876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6876),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6876),
    [sym_conditional] = STATE(6876),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6876),
    [sym_binary] = STATE(6876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3997] = {
    [sym_assignment] = STATE(6877),
    [sym_unary] = STATE(6877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6877),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6877),
    [sym_conditional] = STATE(6877),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6877),
    [sym_binary] = STATE(6877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3998] = {
    [sym_assignment] = STATE(6878),
    [sym_unary] = STATE(6878),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(6878),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(6878),
    [sym_conditional] = STATE(6878),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(6878),
    [sym_binary] = STATE(6878),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [3999] = {
    [sym_assignment] = STATE(1643),
    [sym_unary] = STATE(1643),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(1643),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(1643),
    [sym_conditional] = STATE(1643),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_return] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_true] = STATE(1642),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(1643),
    [sym_binary] = STATE(1643),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11),
    [sym_character] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [4000] = {
    [aux_sym_exceptions_repeat1] = STATE(6880),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(6779),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym___END__] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [4001] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6882),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(10975),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4002] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(6884),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(10977),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4003] = {
    [sym_else] = STATE(6884),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(10979),
    [sym_comment] = ACTIONS(49),
  },
  [4004] = {
    [anon_sym_SLASH] = ACTIONS(1633),
    [sym__line_break] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_AMP_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT_EQ] = ACTIONS(1635),
    [anon_sym_SLASH_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(1635),
    [anon_sym_LT_LT_EQ] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_then] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_when] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_PLUS_EQ] = ACTIONS(1635),
    [anon_sym_STAR_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym___END__] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_end] = ACTIONS(1635),
    [anon_sym_ensure] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_elsif] = ACTIONS(1635),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1635),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_DASH_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
  },
  [4005] = {
    [anon_sym_SLASH] = ACTIONS(3850),
    [sym__line_break] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_AMP_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT_EQ] = ACTIONS(3852),
    [anon_sym_SLASH_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3850),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3850),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_PERCENT_EQ] = ACTIONS(3852),
    [anon_sym_LT_LT_EQ] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_else] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_CARET_EQ] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_then] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_EQ_GT] = ACTIONS(3852),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_PLUS_EQ] = ACTIONS(3852),
    [anon_sym_STAR_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym___END__] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3850),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_end] = ACTIONS(3852),
    [anon_sym_ensure] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_elsif] = ACTIONS(3852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_DASH_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3850),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3850),
  },
  [4006] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(10981),
  },
  [4007] = {
    [aux_sym_symbol_array_repeat1] = STATE(6888),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(10983),
    [sym__string_end] = ACTIONS(10985),
  },
  [4008] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(10987),
  },
  [4009] = {
    [anon_sym_SLASH] = ACTIONS(4054),
    [sym__line_break] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_AMP_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT_EQ] = ACTIONS(4056),
    [anon_sym_SLASH_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_PERCENT_EQ] = ACTIONS(4056),
    [anon_sym_LT_LT_EQ] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_else] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_CARET_EQ] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_then] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_GT] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [anon_sym_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4056),
    [anon_sym_STAR_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym___END__] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_end] = ACTIONS(4056),
    [anon_sym_ensure] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_elsif] = ACTIONS(4056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4056),
    [ts_builtin_sym_end] = ACTIONS(4056),
    [anon_sym_DASH_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4054),
  },
  [4010] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(10989),
    [sym__string_end] = ACTIONS(10987),
  },
  [4011] = {
    [anon_sym_SLASH] = ACTIONS(4424),
    [sym__line_break] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_AMP_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT_EQ] = ACTIONS(4426),
    [anon_sym_SLASH_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_PERCENT_EQ] = ACTIONS(4426),
    [anon_sym_LT_LT_EQ] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_else] = ACTIONS(4426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_CARET_EQ] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_EQ] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_then] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4424),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_EQ_GT] = ACTIONS(4426),
    [anon_sym_when] = ACTIONS(4426),
    [anon_sym_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_PLUS_EQ] = ACTIONS(4426),
    [anon_sym_STAR_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym___END__] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_end] = ACTIONS(4426),
    [anon_sym_ensure] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_elsif] = ACTIONS(4426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4426),
    [ts_builtin_sym_end] = ACTIONS(4426),
    [anon_sym_DASH_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4424),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4424),
  },
  [4012] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4013] = {
    [aux_sym_chained_string_repeat1] = STATE(4052),
    [sym_string] = STATE(4052),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4014] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [4015] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [4016] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(10991),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4017] = {
    [anon_sym_COLON] = ACTIONS(10993),
    [sym_comment] = ACTIONS(49),
  },
  [4018] = {
    [sym_assignment] = STATE(6893),
    [sym_unary] = STATE(6893),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6893),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(6893),
    [sym_conditional] = STATE(6893),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(6893),
    [sym_binary] = STATE(6893),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4019] = {
    [sym_assignment] = STATE(6894),
    [sym_unary] = STATE(6894),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6894),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(6894),
    [sym_conditional] = STATE(6894),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(6894),
    [sym_binary] = STATE(6894),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4020] = {
    [sym_assignment] = STATE(6895),
    [sym_unary] = STATE(6895),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6895),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(6895),
    [sym_conditional] = STATE(6895),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(6895),
    [sym_binary] = STATE(6895),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4021] = {
    [sym_heredoc_body] = STATE(6897),
    [aux_sym_call_repeat1] = STATE(6897),
    [aux_sym_argument_list_repeat1] = STATE(6898),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10995),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4022] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [4023] = {
    [aux_sym_chained_string_repeat1] = STATE(4460),
    [sym_string] = STATE(4460),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(10997),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4024] = {
    [sym_heredoc_body] = STATE(6897),
    [aux_sym_call_repeat1] = STATE(6897),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4025] = {
    [anon_sym_SLASH] = ACTIONS(9417),
    [sym__line_break] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_else] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_then] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_when] = ACTIONS(9419),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym___END__] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_end] = ACTIONS(9419),
    [anon_sym_ensure] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_elsif] = ACTIONS(9419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [ts_builtin_sym_end] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [4026] = {
    [anon_sym_RBRACE] = ACTIONS(10999),
    [sym_comment] = ACTIONS(49),
  },
  [4027] = {
    [anon_sym_SLASH] = ACTIONS(4698),
    [sym__line_break] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_AMP_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT_EQ] = ACTIONS(4700),
    [anon_sym_SLASH_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4698),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4698),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4698),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_PERCENT_EQ] = ACTIONS(4700),
    [anon_sym_LT_LT_EQ] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_else] = ACTIONS(4700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_CARET_EQ] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_EQ] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_then] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4698),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_EQ_GT] = ACTIONS(4700),
    [anon_sym_when] = ACTIONS(4700),
    [anon_sym_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_PLUS_EQ] = ACTIONS(4700),
    [anon_sym_STAR_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym___END__] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4698),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_end] = ACTIONS(4700),
    [anon_sym_ensure] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_elsif] = ACTIONS(4700),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4700),
    [ts_builtin_sym_end] = ACTIONS(4700),
    [anon_sym_DASH_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4698),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_AMP_AMP] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4698),
  },
  [4028] = {
    [anon_sym_RBRACE] = ACTIONS(11001),
    [sym_comment] = ACTIONS(49),
  },
  [4029] = {
    [sym_heredoc_body] = STATE(6905),
    [sym__argument_list_with_parens] = STATE(6904),
    [aux_sym_call_repeat1] = STATE(6905),
    [sym_argument_list_with_parens] = STATE(6903),
    [sym_operator] = STATE(6903),
    [anon_sym_LT] = ACTIONS(11003),
    [anon_sym_SLASH] = ACTIONS(11005),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11005),
    [anon_sym_PLUS_AT] = ACTIONS(11005),
    [anon_sym_LPAREN2] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11005),
    [anon_sym_GT_GT] = ACTIONS(11005),
    [anon_sym_EQ_TILDE] = ACTIONS(11005),
    [anon_sym_LT_LT] = ACTIONS(11005),
    [anon_sym_TILDE] = ACTIONS(11005),
    [anon_sym_PLUS] = ACTIONS(11003),
    [anon_sym_AMP] = ACTIONS(11005),
    [anon_sym_GT] = ACTIONS(11003),
    [anon_sym_PERCENT] = ACTIONS(11005),
    [anon_sym_DASH_AT] = ACTIONS(11005),
    [anon_sym_EQ_EQ] = ACTIONS(11003),
    [anon_sym_STAR] = ACTIONS(11003),
    [anon_sym_BANG_TILDE] = ACTIONS(11005),
    [sym_constant] = ACTIONS(11009),
    [anon_sym_DASH] = ACTIONS(11003),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11005),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11005),
    [anon_sym_STAR_STAR] = ACTIONS(11005),
    [anon_sym_PIPE] = ACTIONS(11005),
    [anon_sym_DOT_DOT] = ACTIONS(11005),
    [anon_sym_LT_EQ_GT] = ACTIONS(11005),
    [anon_sym_LT_EQ] = ACTIONS(11003),
    [anon_sym_BANG] = ACTIONS(11003),
    [sym_identifier] = ACTIONS(11009),
    [anon_sym_CARET] = ACTIONS(11005),
  },
  [4030] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11011),
    [sym_identifier] = ACTIONS(11011),
  },
  [4031] = {
    [sym_assignment] = STATE(6912),
    [sym_unary] = STATE(6912),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6912),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_splat_argument] = STATE(6914),
    [sym_operator_assignment] = STATE(6912),
    [sym_conditional] = STATE(6912),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(1669),
    [sym__arg_or_splat_arg] = STATE(6914),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11017),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2941),
    [sym_character] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4032] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(11025),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4033] = {
    [anon_sym_COLON] = ACTIONS(11027),
    [sym_comment] = ACTIONS(49),
  },
  [4034] = {
    [sym_assignment] = STATE(6917),
    [sym_unary] = STATE(6917),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(6917),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(6917),
    [sym_conditional] = STATE(6917),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(6917),
    [sym_binary] = STATE(6917),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4035] = {
    [sym_assignment] = STATE(6918),
    [sym_unary] = STATE(6918),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(6918),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(6918),
    [sym_conditional] = STATE(6918),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(6918),
    [sym_binary] = STATE(6918),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4036] = {
    [sym_assignment] = STATE(6919),
    [sym_unary] = STATE(6919),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(6919),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(6919),
    [sym_conditional] = STATE(6919),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(6919),
    [sym_binary] = STATE(6919),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4037] = {
    [sym_heredoc_body] = STATE(6921),
    [aux_sym_call_repeat1] = STATE(6921),
    [aux_sym_argument_list_repeat1] = STATE(6922),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11029),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4038] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [4039] = {
    [aux_sym_chained_string_repeat1] = STATE(4516),
    [sym_string] = STATE(4516),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11031),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4040] = {
    [sym_heredoc_body] = STATE(6921),
    [aux_sym_call_repeat1] = STATE(6921),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4041] = {
    [sym_assignment] = STATE(6923),
    [sym_unary] = STATE(6923),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6923),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6923),
    [sym_conditional] = STATE(6923),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6923),
    [sym_binary] = STATE(6923),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4042] = {
    [sym_assignment] = STATE(6924),
    [sym_unary] = STATE(6924),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6924),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6924),
    [sym_conditional] = STATE(6924),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6924),
    [sym_binary] = STATE(6924),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4043] = {
    [sym_assignment] = STATE(6925),
    [sym_unary] = STATE(6925),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6925),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6925),
    [sym_conditional] = STATE(6925),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6925),
    [sym_binary] = STATE(6925),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4044] = {
    [sym_assignment] = STATE(6926),
    [sym_unary] = STATE(6926),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6926),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6926),
    [sym_conditional] = STATE(6926),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6926),
    [sym_binary] = STATE(6926),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4045] = {
    [sym_assignment] = STATE(6927),
    [sym_unary] = STATE(6927),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6927),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6927),
    [sym_conditional] = STATE(6927),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6927),
    [sym_binary] = STATE(6927),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4046] = {
    [sym_assignment] = STATE(6928),
    [sym_unary] = STATE(6928),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6928),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6928),
    [sym_conditional] = STATE(6928),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6928),
    [sym_binary] = STATE(6928),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4047] = {
    [sym_assignment] = STATE(6929),
    [sym_unary] = STATE(6929),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6929),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6929),
    [sym_conditional] = STATE(6929),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6929),
    [sym_binary] = STATE(6929),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4048] = {
    [sym_assignment] = STATE(6930),
    [sym_unary] = STATE(6930),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6930),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6930),
    [sym_conditional] = STATE(6930),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6930),
    [sym_binary] = STATE(6930),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4049] = {
    [sym_assignment] = STATE(6931),
    [sym_unary] = STATE(6931),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6931),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6931),
    [sym_conditional] = STATE(6931),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6931),
    [sym_binary] = STATE(6931),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4050] = {
    [sym_assignment] = STATE(6932),
    [sym_unary] = STATE(6932),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6932),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6932),
    [sym_conditional] = STATE(6932),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6932),
    [sym_binary] = STATE(6932),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4051] = {
    [sym_assignment] = STATE(6933),
    [sym_unary] = STATE(6933),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6933),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(6933),
    [sym_conditional] = STATE(6933),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(6933),
    [sym_binary] = STATE(6933),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4052] = {
    [aux_sym_chained_string_repeat1] = STATE(6934),
    [sym_string] = STATE(6934),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4053] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym___END__] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [ts_builtin_sym_end] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [4054] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6936),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11033),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4055] = {
    [anon_sym_SLASH] = ACTIONS(4766),
    [sym__line_break] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_COLON] = ACTIONS(4766),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_else] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_then] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_when] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym___END__] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_ensure] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_elsif] = ACTIONS(4768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4768),
    [ts_builtin_sym_end] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4766),
  },
  [4056] = {
    [sym__terminator] = STATE(6937),
    [sym_heredoc_body] = STATE(6937),
    [sym__do] = STATE(6937),
    [anon_sym_do] = ACTIONS(11035),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(11035),
    [anon_sym_SEMI] = ACTIONS(11035),
    [sym_comment] = ACTIONS(49),
  },
  [4057] = {
    [anon_sym_SLASH] = ACTIONS(9248),
    [sym__line_break] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_else] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_then] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_when] = ACTIONS(9250),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym___END__] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(9250),
    [anon_sym_ensure] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_elsif] = ACTIONS(9250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [ts_builtin_sym_end] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [4058] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6939),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11037),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4059] = {
    [anon_sym_end] = ACTIONS(11039),
    [sym_comment] = ACTIONS(49),
  },
  [4060] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(6940),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(6940),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(6939),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(11041),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(11041),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11037),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4061] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [4062] = {
    [anon_sym_SLASH] = ACTIONS(5236),
    [sym__line_break] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_AMP_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT_EQ] = ACTIONS(5238),
    [anon_sym_SLASH_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_PERCENT_EQ] = ACTIONS(5238),
    [anon_sym_LT_LT_EQ] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_else] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_CARET_EQ] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_then] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_PLUS_EQ] = ACTIONS(5238),
    [anon_sym_STAR_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym___END__] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_end] = ACTIONS(5238),
    [anon_sym_ensure] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_elsif] = ACTIONS(5238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5238),
    [ts_builtin_sym_end] = ACTIONS(5238),
    [anon_sym_DASH_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5236),
  },
  [4063] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym___END__] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [ts_builtin_sym_end] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [4064] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(11043),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [4065] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6942),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11045),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4066] = {
    [sym__method_name] = STATE(1692),
    [sym_setter] = STATE(1692),
    [sym_symbol] = STATE(1692),
    [sym_operator] = STATE(1692),
    [sym__method_rest] = STATE(6943),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(11047),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(11047),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(11047),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(11047),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [4067] = {
    [anon_sym_SLASH] = ACTIONS(2883),
    [sym__line_break] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_then] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_when] = ACTIONS(2885),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym___END__] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_ensure] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_elsif] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [ts_builtin_sym_end] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2883),
  },
  [4068] = {
    [sym__terminator] = STATE(6944),
    [sym_heredoc_body] = STATE(6944),
    [sym__do] = STATE(6944),
    [sym__line_break] = ACTIONS(11049),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(11049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11049),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [4069] = {
    [sym_heredoc_body] = STATE(6945),
    [sym__terminator] = STATE(6945),
    [sym__line_break] = ACTIONS(11051),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(11051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [4070] = {
    [sym_when] = STATE(6948),
    [sym_else] = STATE(6947),
    [aux_sym_case_repeat2] = STATE(6948),
    [aux_sym_case_repeat1] = STATE(6949),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11053),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(11055),
    [sym_comment] = ACTIONS(49),
  },
  [4071] = {
    [anon_sym_SLASH] = ACTIONS(2871),
    [sym__line_break] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [anon_sym_else] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_then] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_when] = ACTIONS(2873),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym___END__] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_end] = ACTIONS(2873),
    [anon_sym_ensure] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_elsif] = ACTIONS(2873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2873),
    [ts_builtin_sym_end] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2871),
  },
  [4072] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(6952),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11057),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(11059),
  },
  [4073] = {
    [aux_sym_string_array_repeat1] = STATE(6955),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11061),
    [sym__string_end] = ACTIONS(11063),
  },
  [4074] = {
    [anon_sym_SLASH] = ACTIONS(2303),
    [sym__line_break] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_AMP_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT_EQ] = ACTIONS(2305),
    [anon_sym_SLASH_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_CARET_EQ] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_then] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_when] = ACTIONS(2305),
    [anon_sym_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_PLUS_EQ] = ACTIONS(2305),
    [anon_sym_STAR_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym___END__] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_end] = ACTIONS(2305),
    [anon_sym_ensure] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_elsif] = ACTIONS(2305),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_DASH_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2303),
  },
  [4075] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11065),
  },
  [4076] = {
    [anon_sym_SLASH] = ACTIONS(2385),
    [sym__line_break] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_AMP_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT_EQ] = ACTIONS(2387),
    [anon_sym_SLASH_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2385),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_PERCENT_EQ] = ACTIONS(2387),
    [anon_sym_LT_LT_EQ] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [anon_sym_else] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_CARET_EQ] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_then] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_when] = ACTIONS(2387),
    [anon_sym_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [anon_sym_STAR_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym___END__] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_end] = ACTIONS(2387),
    [anon_sym_ensure] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_elsif] = ACTIONS(2387),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2387),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2385),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2385),
  },
  [4077] = {
    [anon_sym_RPAREN] = ACTIONS(11067),
    [sym_comment] = ACTIONS(49),
  },
  [4078] = {
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym__line_break] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_AMP_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2531),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [anon_sym_else] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_EQ] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_then] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_when] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_PLUS_EQ] = ACTIONS(2533),
    [anon_sym_STAR_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym___END__] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_end] = ACTIONS(2533),
    [anon_sym_ensure] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_elsif] = ACTIONS(2533),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2533),
    [ts_builtin_sym_end] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2531),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [anon_sym_AMP_AMP] = ACTIONS(2531),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2531),
  },
  [4079] = {
    [sym__terminator] = STATE(6958),
    [sym_heredoc_body] = STATE(6958),
    [sym_then] = STATE(6959),
    [sym__line_break] = ACTIONS(11069),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(11069),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [4080] = {
    [sym_assignment] = STATE(6960),
    [sym_unary] = STATE(6960),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(6960),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(6960),
    [sym_conditional] = STATE(6960),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(6960),
    [sym_binary] = STATE(6960),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [4081] = {
    [sym_heredoc_body] = STATE(6961),
    [sym__terminator] = STATE(6961),
    [sym_superclass] = STATE(6962),
    [sym__line_break] = ACTIONS(11071),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(11071),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4082] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(6962),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(6961),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(6961),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(11071),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(11071),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [4083] = {
    [sym_heredoc_body] = STATE(6964),
    [sym__terminator] = STATE(6964),
    [sym__line_break] = ACTIONS(11073),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(11073),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(11075),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4084] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(6964),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(6964),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(11073),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(11073),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(11075),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [4085] = {
    [anon_sym_end] = ACTIONS(11077),
    [sym_comment] = ACTIONS(49),
  },
  [4086] = {
    [sym_ensure] = STATE(6966),
    [sym_else] = STATE(6967),
    [anon_sym_end] = ACTIONS(11077),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [4087] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(6968),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11079),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4088] = {
    [anon_sym_SLASH] = ACTIONS(2741),
    [sym__line_break] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2741),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2741),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_then] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_when] = ACTIONS(2743),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym___END__] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_end] = ACTIONS(2743),
    [anon_sym_ensure] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_elsif] = ACTIONS(2743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(2743),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2741),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2741),
  },
  [4089] = {
    [sym_ensure] = STATE(6966),
    [sym_else] = STATE(6967),
    [sym_rescue] = STATE(6969),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(11077),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [4090] = {
    [sym_ensure] = STATE(6966),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(11077),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [4091] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4092] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4093] = {
    [anon_sym_SLASH] = ACTIONS(2575),
    [sym__line_break] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [anon_sym_else] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_then] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_when] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym___END__] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_end] = ACTIONS(2577),
    [anon_sym_ensure] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_elsif] = ACTIONS(2577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2577),
    [ts_builtin_sym_end] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2575),
  },
  [4094] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11081),
  },
  [4095] = {
    [anon_sym_SLASH] = ACTIONS(1225),
    [sym__line_break] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_then] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_when] = ACTIONS(1227),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym___END__] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_end] = ACTIONS(1227),
    [anon_sym_ensure] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_elsif] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [ts_builtin_sym_end] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1225),
  },
  [4096] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(6973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11083),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(11085),
  },
  [4097] = {
    [aux_sym_symbol_array_repeat1] = STATE(6976),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11087),
    [sym__string_end] = ACTIONS(11089),
  },
  [4098] = {
    [anon_sym_SLASH] = ACTIONS(1337),
    [sym__line_break] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_AMP_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT_EQ] = ACTIONS(1339),
    [anon_sym_SLASH_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_PERCENT_EQ] = ACTIONS(1339),
    [anon_sym_LT_LT_EQ] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_CARET_EQ] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_then] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_PLUS_EQ] = ACTIONS(1339),
    [anon_sym_STAR_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym___END__] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_ensure] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_elsif] = ACTIONS(1339),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1339),
    [ts_builtin_sym_end] = ACTIONS(1339),
    [anon_sym_DASH_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1337),
  },
  [4099] = {
    [anon_sym_RBRACK] = ACTIONS(11091),
    [sym_comment] = ACTIONS(49),
  },
  [4100] = {
    [anon_sym_SLASH] = ACTIONS(1633),
    [sym__line_break] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_AMP_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT_EQ] = ACTIONS(1635),
    [anon_sym_SLASH_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(1635),
    [anon_sym_LT_LT_EQ] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_then] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_PLUS_EQ] = ACTIONS(1635),
    [anon_sym_STAR_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym___END__] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_end] = ACTIONS(1635),
    [anon_sym_ensure] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_elsif] = ACTIONS(1635),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1635),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_DASH_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
  },
  [4101] = {
    [sym_heredoc_body] = STATE(6979),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(11093),
    [sym_comment] = ACTIONS(49),
  },
  [4102] = {
    [anon_sym_RBRACE] = ACTIONS(11093),
    [sym_comment] = ACTIONS(49),
  },
  [4103] = {
    [anon_sym_SLASH] = ACTIONS(2851),
    [sym__line_break] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_AMP_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_SLASH_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2851),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_PERCENT_EQ] = ACTIONS(2853),
    [anon_sym_LT_LT_EQ] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [anon_sym_else] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_CARET_EQ] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_then] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_when] = ACTIONS(2853),
    [anon_sym_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_PLUS_EQ] = ACTIONS(2853),
    [anon_sym_STAR_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym___END__] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_end] = ACTIONS(2853),
    [anon_sym_ensure] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_elsif] = ACTIONS(2853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2853),
    [ts_builtin_sym_end] = ACTIONS(2853),
    [anon_sym_DASH_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2851),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2851),
  },
  [4104] = {
    [sym__terminator] = STATE(6980),
    [sym_heredoc_body] = STATE(6980),
    [sym__do] = STATE(6980),
    [sym__line_break] = ACTIONS(11095),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(11095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11095),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [4105] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym___END__] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [4106] = {
    [anon_sym_SLASH] = ACTIONS(2861),
    [sym__line_break] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_AMP_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT_EQ] = ACTIONS(2863),
    [anon_sym_SLASH_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_PERCENT_EQ] = ACTIONS(2863),
    [anon_sym_LT_LT_EQ] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_CARET_EQ] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_then] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_when] = ACTIONS(2863),
    [anon_sym_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_PLUS_EQ] = ACTIONS(2863),
    [anon_sym_STAR_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym___END__] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2861),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_end] = ACTIONS(2863),
    [anon_sym_ensure] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_elsif] = ACTIONS(2863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2863),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_DASH_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2861),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2861),
  },
  [4107] = {
    [sym_in] = STATE(6981),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [4108] = {
    [anon_sym_SLASH] = ACTIONS(1851),
    [sym__line_break] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_AMP_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT_EQ] = ACTIONS(1853),
    [anon_sym_SLASH_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1851),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_PERCENT_EQ] = ACTIONS(1853),
    [anon_sym_LT_LT_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_else] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_CARET_EQ] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_then] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_when] = ACTIONS(1853),
    [anon_sym_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_PLUS_EQ] = ACTIONS(1853),
    [anon_sym_STAR_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym___END__] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_end] = ACTIONS(1853),
    [anon_sym_ensure] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_elsif] = ACTIONS(1853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1853),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_DASH_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1851),
  },
  [4109] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11097),
  },
  [4110] = {
    [anon_sym_SLASH] = ACTIONS(2855),
    [sym__line_break] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_AMP_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT_EQ] = ACTIONS(2857),
    [anon_sym_SLASH_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_PERCENT_EQ] = ACTIONS(2857),
    [anon_sym_LT_LT_EQ] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [anon_sym_else] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_CARET_EQ] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_then] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_when] = ACTIONS(2857),
    [anon_sym_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_PLUS_EQ] = ACTIONS(2857),
    [anon_sym_STAR_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym___END__] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_end] = ACTIONS(2857),
    [anon_sym_ensure] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_elsif] = ACTIONS(2857),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2857),
    [ts_builtin_sym_end] = ACTIONS(2857),
    [anon_sym_DASH_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2855),
  },
  [4111] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11099),
  },
  [4112] = {
    [anon_sym_SLASH] = ACTIONS(2043),
    [sym__line_break] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_AMP_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT_EQ] = ACTIONS(2045),
    [anon_sym_SLASH_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2043),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2043),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_PERCENT_EQ] = ACTIONS(2045),
    [anon_sym_LT_LT_EQ] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_CARET_EQ] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_EQ] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_then] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_when] = ACTIONS(2045),
    [anon_sym_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_PLUS_EQ] = ACTIONS(2045),
    [anon_sym_STAR_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym___END__] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_end] = ACTIONS(2045),
    [anon_sym_ensure] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_elsif] = ACTIONS(2045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2045),
    [ts_builtin_sym_end] = ACTIONS(2045),
    [anon_sym_DASH_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2043),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2043),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2043),
  },
  [4113] = {
    [sym_do_block] = STATE(6984),
    [sym_block] = STATE(6984),
    [anon_sym_do] = ACTIONS(3091),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(3089),
  },
  [4114] = {
    [sym_assignment] = STATE(6985),
    [sym_unary] = STATE(6985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(6985),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(6985),
    [sym_conditional] = STATE(6985),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(6985),
    [sym_binary] = STATE(6985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [4115] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(6986),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(6986),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(6986),
    [sym__line_break] = ACTIONS(11101),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(11101),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [4116] = {
    [anon_sym_SLASH] = ACTIONS(2101),
    [sym__line_break] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_AMP_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT_EQ] = ACTIONS(2103),
    [anon_sym_SLASH_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_PERCENT_EQ] = ACTIONS(2103),
    [anon_sym_LT_LT_EQ] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_CARET_EQ] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_EQ] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_then] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_when] = ACTIONS(2103),
    [anon_sym_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_PLUS_EQ] = ACTIONS(2103),
    [anon_sym_STAR_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym___END__] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_end] = ACTIONS(2103),
    [anon_sym_ensure] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_elsif] = ACTIONS(2103),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2103),
    [ts_builtin_sym_end] = ACTIONS(2103),
    [anon_sym_DASH_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2101),
  },
  [4117] = {
    [anon_sym_DOT] = ACTIONS(11103),
    [anon_sym_COLON_COLON] = ACTIONS(11103),
    [sym_comment] = ACTIONS(49),
  },
  [4118] = {
    [anon_sym_SLASH] = ACTIONS(2299),
    [sym__line_break] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_AMP_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT_EQ] = ACTIONS(2301),
    [anon_sym_SLASH_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2299),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_PERCENT_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_CARET_EQ] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_then] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_when] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_PLUS_EQ] = ACTIONS(2301),
    [anon_sym_STAR_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym___END__] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_end] = ACTIONS(2301),
    [anon_sym_ensure] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_elsif] = ACTIONS(2301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2301),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_DASH_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2299),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2299),
  },
  [4119] = {
    [sym__terminator] = STATE(6988),
    [sym_heredoc_body] = STATE(6988),
    [sym_then] = STATE(6989),
    [sym__line_break] = ACTIONS(11105),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(11105),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [4120] = {
    [sym_assignment] = STATE(6990),
    [sym_unary] = STATE(6990),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6990),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(6990),
    [sym_conditional] = STATE(6990),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6990),
    [sym_binary] = STATE(6990),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4121] = {
    [sym_assignment] = STATE(6992),
    [sym_unary] = STATE(6992),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6992),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_splat_argument] = STATE(6993),
    [sym_operator_assignment] = STATE(6992),
    [sym_conditional] = STATE(6992),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_return] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_subshell] = STATE(1727),
    [sym__arg_or_splat_arg] = STATE(6993),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6992),
    [sym_binary] = STATE(6992),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [sym_global_variable] = ACTIONS(3027),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3003),
    [sym_character] = ACTIONS(3019),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4122] = {
    [sym_assignment] = STATE(6994),
    [sym_unary] = STATE(6994),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6994),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(6994),
    [sym_conditional] = STATE(6994),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6994),
    [sym_binary] = STATE(6994),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4123] = {
    [sym_assignment] = STATE(6995),
    [sym_unary] = STATE(6995),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6995),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(6995),
    [sym_conditional] = STATE(6995),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6995),
    [sym_binary] = STATE(6995),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4124] = {
    [sym_assignment] = STATE(6997),
    [sym_unary] = STATE(6997),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6997),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(6997),
    [sym_conditional] = STATE(6997),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6997),
    [sym_binary] = STATE(6997),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4125] = {
    [sym_assignment] = STATE(6998),
    [sym_unary] = STATE(6998),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(6998),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(6998),
    [sym_conditional] = STATE(6998),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(6998),
    [sym_binary] = STATE(6998),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4126] = {
    [sym_assignment] = STATE(6999),
    [sym_unary] = STATE(6999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6999),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(6999),
    [sym_conditional] = STATE(6999),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6999),
    [sym_binary] = STATE(6999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4127] = {
    [sym_assignment] = STATE(7000),
    [sym_unary] = STATE(7000),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(7000),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(7000),
    [sym_conditional] = STATE(7000),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(7000),
    [sym_binary] = STATE(7000),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4128] = {
    [sym_assignment] = STATE(7001),
    [sym_unary] = STATE(7001),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(7001),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(7001),
    [sym_conditional] = STATE(7001),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(7001),
    [sym_binary] = STATE(7001),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4129] = {
    [sym_assignment] = STATE(7002),
    [sym_unary] = STATE(7002),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(7002),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(7002),
    [sym_conditional] = STATE(7002),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(7002),
    [sym_binary] = STATE(7002),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4130] = {
    [sym_assignment] = STATE(7003),
    [sym_unary] = STATE(7003),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(7003),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(7003),
    [sym_conditional] = STATE(7003),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(7003),
    [sym_binary] = STATE(7003),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [4131] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(1667),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1668),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1675),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(1676),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(11107),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [4132] = {
    [aux_sym_chained_string_repeat1] = STATE(7005),
    [sym_string] = STATE(7005),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym___END__] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [ts_builtin_sym_end] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [4133] = {
    [anon_sym_SLASH] = ACTIONS(5626),
    [sym__line_break] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_then] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym___END__] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_ensure] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_elsif] = ACTIONS(5628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5628),
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5626),
  },
  [4134] = {
    [sym_when] = STATE(7008),
    [sym_else] = STATE(7007),
    [aux_sym_case_repeat2] = STATE(7008),
    [aux_sym_case_repeat1] = STATE(7009),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11109),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(11111),
    [sym_comment] = ACTIONS(49),
  },
  [4135] = {
    [anon_sym_SLASH] = ACTIONS(5744),
    [sym__line_break] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_else] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_then] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5746),
    [anon_sym_when] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym___END__] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_end] = ACTIONS(5746),
    [anon_sym_ensure] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_elsif] = ACTIONS(5746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5746),
    [ts_builtin_sym_end] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
  },
  [4136] = {
    [anon_sym_end] = ACTIONS(11109),
    [sym_comment] = ACTIONS(49),
  },
  [4137] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(7007),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11109),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [4138] = {
    [sym_when] = STATE(7008),
    [sym_else] = STATE(7007),
    [aux_sym_case_repeat2] = STATE(7008),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11109),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [4139] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_when] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym___END__] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_ensure] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_elsif] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
  },
  [4140] = {
    [anon_sym_SLASH] = ACTIONS(5972),
    [sym__line_break] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5972),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_else] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_then] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_when] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5972),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_end] = ACTIONS(5974),
    [anon_sym_ensure] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_elsif] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5972),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_AMP_AMP] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5972),
  },
  [4141] = {
    [sym_heredoc_body] = STATE(7010),
    [sym__terminator] = STATE(7010),
    [sym__line_break] = ACTIONS(11113),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [4142] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7011),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11115),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4143] = {
    [sym_heredoc_body] = STATE(7012),
    [sym__terminator] = STATE(7012),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(11117),
    [anon_sym_SEMI] = ACTIONS(11117),
    [sym_comment] = ACTIONS(49),
  },
  [4144] = {
    [anon_sym_SLASH] = ACTIONS(6071),
    [sym__line_break] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_AMP_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT_EQ] = ACTIONS(6073),
    [anon_sym_SLASH_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6071),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_PERCENT_EQ] = ACTIONS(6073),
    [anon_sym_LT_LT_EQ] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_else] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_CARET_EQ] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_then] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_EQ_GT] = ACTIONS(6073),
    [anon_sym_when] = ACTIONS(6073),
    [anon_sym_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_PLUS_EQ] = ACTIONS(6073),
    [anon_sym_STAR_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym___END__] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_end] = ACTIONS(6073),
    [anon_sym_ensure] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_elsif] = ACTIONS(6073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6073),
    [ts_builtin_sym_end] = ACTIONS(6073),
    [anon_sym_DASH_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6071),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6071),
  },
  [4145] = {
    [anon_sym_SLASH] = ACTIONS(6075),
    [sym__line_break] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_AMP_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT_EQ] = ACTIONS(6077),
    [anon_sym_SLASH_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6075),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_PERCENT_EQ] = ACTIONS(6077),
    [anon_sym_LT_LT_EQ] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_else] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_CARET_EQ] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_then] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6075),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_when] = ACTIONS(6077),
    [anon_sym_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_PLUS_EQ] = ACTIONS(6077),
    [anon_sym_STAR_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym___END__] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_end] = ACTIONS(6077),
    [anon_sym_ensure] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_elsif] = ACTIONS(6077),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6077),
    [ts_builtin_sym_end] = ACTIONS(6077),
    [anon_sym_DASH_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6075),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6075),
  },
  [4146] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7013),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11119),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4147] = {
    [anon_sym_SLASH] = ACTIONS(6443),
    [sym__line_break] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_AMP_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT_EQ] = ACTIONS(6445),
    [anon_sym_SLASH_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6443),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_PERCENT_EQ] = ACTIONS(6445),
    [anon_sym_LT_LT_EQ] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_else] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_CARET_EQ] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(6443),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_then] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6443),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [anon_sym_when] = ACTIONS(6445),
    [anon_sym_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_PLUS_EQ] = ACTIONS(6445),
    [anon_sym_STAR_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym___END__] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_end] = ACTIONS(6445),
    [anon_sym_ensure] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_elsif] = ACTIONS(6445),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6445),
    [ts_builtin_sym_end] = ACTIONS(6445),
    [anon_sym_DASH_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6443),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_AMP_AMP] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6443),
  },
  [4148] = {
    [anon_sym_end] = ACTIONS(11121),
    [sym_comment] = ACTIONS(49),
  },
  [4149] = {
    [sym_ensure] = STATE(7015),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(11121),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [4150] = {
    [anon_sym_SLASH] = ACTIONS(6471),
    [sym__line_break] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_AMP_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT_EQ] = ACTIONS(6473),
    [anon_sym_SLASH_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6471),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6471),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6471),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_PERCENT_EQ] = ACTIONS(6473),
    [anon_sym_LT_LT_EQ] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_else] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_CARET_EQ] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_EQ] = ACTIONS(6471),
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_then] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6471),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_EQ_GT] = ACTIONS(6473),
    [anon_sym_when] = ACTIONS(6473),
    [anon_sym_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_PLUS_EQ] = ACTIONS(6473),
    [anon_sym_STAR_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym___END__] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_end] = ACTIONS(6473),
    [anon_sym_ensure] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_elsif] = ACTIONS(6473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6473),
    [ts_builtin_sym_end] = ACTIONS(6473),
    [anon_sym_DASH_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6471),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6471),
  },
  [4151] = {
    [sym_ensure] = STATE(7015),
    [sym_else] = STATE(7016),
    [anon_sym_end] = ACTIONS(11121),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [4152] = {
    [anon_sym_SLASH] = ACTIONS(6630),
    [sym__line_break] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_AMP_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6632),
    [anon_sym_SLASH_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_else] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_CARET_EQ] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_EQ] = ACTIONS(6630),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_then] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6632),
    [anon_sym_when] = ACTIONS(6632),
    [anon_sym_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_PLUS_EQ] = ACTIONS(6632),
    [anon_sym_STAR_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym___END__] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6632),
    [anon_sym_ensure] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_elsif] = ACTIONS(6632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6632),
    [ts_builtin_sym_end] = ACTIONS(6632),
    [anon_sym_DASH_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6630),
  },
  [4153] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(7018),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(7018),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11123),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [4154] = {
    [sym_elsif] = STATE(7018),
    [sym_else] = STATE(7018),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(11125),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [4155] = {
    [anon_sym_SLASH] = ACTIONS(6680),
    [sym__line_break] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_AMP_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT_EQ] = ACTIONS(6682),
    [anon_sym_SLASH_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6680),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6680),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_PERCENT_EQ] = ACTIONS(6682),
    [anon_sym_LT_LT_EQ] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_else] = ACTIONS(6682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_CARET_EQ] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_then] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6680),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_EQ_GT] = ACTIONS(6682),
    [anon_sym_when] = ACTIONS(6682),
    [anon_sym_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_PLUS_EQ] = ACTIONS(6682),
    [anon_sym_STAR_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym___END__] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6680),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_end] = ACTIONS(6682),
    [anon_sym_ensure] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_elsif] = ACTIONS(6682),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6682),
    [ts_builtin_sym_end] = ACTIONS(6682),
    [anon_sym_DASH_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6680),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_AMP_AMP] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6680),
  },
  [4156] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11127),
  },
  [4157] = {
    [aux_sym_string_array_repeat1] = STATE(7022),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11129),
    [sym__string_end] = ACTIONS(11131),
  },
  [4158] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(11133),
  },
  [4159] = {
    [anon_sym_SLASH] = ACTIONS(6692),
    [sym__line_break] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_AMP_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT_EQ] = ACTIONS(6694),
    [anon_sym_SLASH_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_PERCENT_EQ] = ACTIONS(6694),
    [anon_sym_LT_LT_EQ] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_else] = ACTIONS(6694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_CARET_EQ] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_then] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_EQ_GT] = ACTIONS(6694),
    [anon_sym_when] = ACTIONS(6694),
    [anon_sym_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_PLUS_EQ] = ACTIONS(6694),
    [anon_sym_STAR_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym___END__] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_end] = ACTIONS(6694),
    [anon_sym_ensure] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_elsif] = ACTIONS(6694),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6694),
    [ts_builtin_sym_end] = ACTIONS(6694),
    [anon_sym_DASH_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6692),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_AMP_AMP] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6692),
  },
  [4160] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11135),
    [sym__string_end] = ACTIONS(11133),
  },
  [4161] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [4162] = {
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [4163] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym___END__] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [ts_builtin_sym_end] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4164] = {
    [aux_sym_exceptions_repeat1] = STATE(7026),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [4165] = {
    [anon_sym_SLASH] = ACTIONS(6215),
    [sym__line_break] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_AMP_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT_EQ] = ACTIONS(4446),
    [anon_sym_SLASH_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(6215),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_PERCENT_EQ] = ACTIONS(4446),
    [anon_sym_LT_LT_EQ] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(4446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_CARET_EQ] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_then] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_when] = ACTIONS(4446),
    [anon_sym_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_PLUS_EQ] = ACTIONS(4446),
    [anon_sym_STAR_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym___END__] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(4446),
    [anon_sym_ensure] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_elsif] = ACTIONS(4446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4446),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [anon_sym_DASH_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(6215),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_AMP_AMP] = ACTIONS(6215),
    [sym__binary_minus] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(6215),
  },
  [4166] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(11137),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [4167] = {
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [4168] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(458),
    [sym_unary] = STATE(458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(458),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(458),
    [sym_conditional] = STATE(458),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(459),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(458),
    [sym_binary] = STATE(458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_float] = ACTIONS(795),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(801),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(801),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(829),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(833),
    [sym_class_variable] = ACTIONS(817),
    [sym__block_ampersand] = ACTIONS(835),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(6997),
    [sym_redo] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [4169] = {
    [sym_heredoc_body] = STATE(4169),
    [aux_sym_call_repeat1] = STATE(4169),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym___END__] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [ts_builtin_sym_end] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [4170] = {
    [sym_heredoc_body] = STATE(4169),
    [aux_sym_call_repeat1] = STATE(4169),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym___END__] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [ts_builtin_sym_end] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [4171] = {
    [aux_sym_argument_list_repeat1] = STATE(4171),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(11142),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [4172] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4173] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4174] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4175] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11145),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4176] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4177] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4178] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4179] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [4180] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4181] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4182] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4183] = {
    [aux_sym_chained_string_repeat1] = STATE(4183),
    [sym_string] = STATE(4183),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym___END__] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [ts_builtin_sym_end] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [4184] = {
    [sym_assignment] = STATE(7031),
    [sym_unary] = STATE(7031),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7031),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(7031),
    [sym_conditional] = STATE(7031),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(7031),
    [sym_binary] = STATE(7031),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [4185] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [4186] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(11156),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4187] = {
    [sym_assignment] = STATE(7034),
    [sym_unary] = STATE(7034),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7034),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(7034),
    [sym_conditional] = STATE(7034),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(7034),
    [sym_binary] = STATE(7034),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [4188] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11158),
    [sym_identifier] = ACTIONS(11158),
  },
  [4189] = {
    [anon_sym_COLON] = ACTIONS(11160),
    [sym_comment] = ACTIONS(49),
  },
  [4190] = {
    [sym__argument] = STATE(7042),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7042),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7042),
    [sym_hash_splat_argument] = STATE(7042),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(7045),
    [sym_block_argument] = STATE(7042),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [4191] = {
    [sym_assignment] = STATE(7055),
    [sym_unary] = STATE(7055),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(7055),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(7055),
    [sym_conditional] = STATE(7055),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(7055),
    [sym_binary] = STATE(7055),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [4192] = {
    [sym_assignment] = STATE(7060),
    [sym_unary] = STATE(7060),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(7060),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(7060),
    [sym_conditional] = STATE(7060),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(7060),
    [sym_binary] = STATE(7060),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [4193] = {
    [sym__argument] = STATE(7042),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7042),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7042),
    [sym_hash_splat_argument] = STATE(7042),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(7045),
    [sym_block_argument] = STATE(7042),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [4194] = {
    [sym__argument] = STATE(7042),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7042),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7042),
    [sym_hash_splat_argument] = STATE(7042),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(7045),
    [sym_block_argument] = STATE(7042),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [4195] = {
    [sym_assignment] = STATE(7061),
    [sym_unary] = STATE(7061),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(7061),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(7061),
    [sym_conditional] = STATE(7061),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(7061),
    [sym_binary] = STATE(7061),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [4196] = {
    [sym__argument] = STATE(7042),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7042),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7042),
    [sym_hash_splat_argument] = STATE(7042),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(7045),
    [sym_block_argument] = STATE(7042),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [4197] = {
    [sym_heredoc_body] = STATE(7063),
    [aux_sym_call_repeat1] = STATE(7063),
    [aux_sym_argument_list_repeat1] = STATE(7064),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11198),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [4198] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(11200),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(11200),
    [anon_sym_SLASH_EQ] = ACTIONS(11200),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11200),
    [anon_sym_PIPE_EQ] = ACTIONS(11200),
    [anon_sym_LT_LT_EQ] = ACTIONS(11200),
    [anon_sym_PLUS_EQ] = ACTIONS(11200),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11200),
    [anon_sym_STAR_EQ] = ACTIONS(11200),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11200),
    [anon_sym_CARET_EQ] = ACTIONS(11200),
    [anon_sym_DASH_EQ] = ACTIONS(11200),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11200),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11202),
  },
  [4199] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(11160),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_COLON2] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [4200] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(11230),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11232),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11234),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [4201] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym__primary] = STATE(4235),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_method] = STATE(4235),
    [sym_conditional] = STATE(7084),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_subshell] = STATE(4235),
    [sym_unless] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4239),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_call] = STATE(4237),
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_rational] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_lambda] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(7084),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_nil] = STATE(4239),
    [sym_symbol_array] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_scope_resolution] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(7089),
    [anon_sym_COLON2] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4202] = {
    [anon_sym_EQ] = ACTIONS(11244),
    [sym_comment] = ACTIONS(3),
  },
  [4203] = {
    [aux_sym_chained_string_repeat1] = STATE(7087),
    [sym_string] = STATE(7087),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11246),
    [sym__string_start] = ACTIONS(11152),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [4204] = {
    [sym_heredoc_body] = STATE(7063),
    [aux_sym_call_repeat1] = STATE(7063),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [4205] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [4206] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4207] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_COLON2] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [4208] = {
    [sym_assignment] = STATE(7088),
    [sym_unary] = STATE(7088),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7088),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7088),
    [sym_conditional] = STATE(7088),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7088),
    [sym_binary] = STATE(7088),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4209] = {
    [sym_assignment] = STATE(7098),
    [sym_unary] = STATE(7098),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7098),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_splat_argument] = STATE(7101),
    [sym_operator_assignment] = STATE(7098),
    [sym_conditional] = STATE(7098),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_return] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_subshell] = STATE(1799),
    [sym__arg_or_splat_arg] = STATE(7101),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(7098),
    [sym_binary] = STATE(7098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(11254),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [sym_global_variable] = ACTIONS(3151),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(3143),
    [sym_character] = ACTIONS(3147),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [4210] = {
    [sym_assignment] = STATE(7102),
    [sym_unary] = STATE(7102),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7102),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7102),
    [sym_conditional] = STATE(7102),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7102),
    [sym_binary] = STATE(7102),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4211] = {
    [sym_assignment] = STATE(7103),
    [sym_unary] = STATE(7103),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7103),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7103),
    [sym_conditional] = STATE(7103),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7103),
    [sym_binary] = STATE(7103),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4212] = {
    [sym_assignment] = STATE(7104),
    [sym_unary] = STATE(7104),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7104),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7104),
    [sym_conditional] = STATE(7104),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7104),
    [sym_binary] = STATE(7104),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4213] = {
    [sym_assignment] = STATE(7105),
    [sym_unary] = STATE(7105),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7105),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7105),
    [sym_conditional] = STATE(7105),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7105),
    [sym_binary] = STATE(7105),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4214] = {
    [sym_assignment] = STATE(7106),
    [sym_unary] = STATE(7106),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7106),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7106),
    [sym_conditional] = STATE(7106),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7106),
    [sym_binary] = STATE(7106),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4215] = {
    [sym_assignment] = STATE(7107),
    [sym_unary] = STATE(7107),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7107),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7107),
    [sym_conditional] = STATE(7107),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7107),
    [sym_binary] = STATE(7107),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4216] = {
    [sym_assignment] = STATE(7108),
    [sym_unary] = STATE(7108),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7108),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7108),
    [sym_conditional] = STATE(7108),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7108),
    [sym_binary] = STATE(7108),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4217] = {
    [sym_assignment] = STATE(7109),
    [sym_unary] = STATE(7109),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7109),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7109),
    [sym_conditional] = STATE(7109),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7109),
    [sym_binary] = STATE(7109),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4218] = {
    [sym_assignment] = STATE(7110),
    [sym_unary] = STATE(7110),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7110),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7110),
    [sym_conditional] = STATE(7110),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7110),
    [sym_binary] = STATE(7110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4219] = {
    [sym_assignment] = STATE(7111),
    [sym_unary] = STATE(7111),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(48),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(7111),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(48),
    [sym_operator_assignment] = STATE(7111),
    [sym_conditional] = STATE(7111),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(45),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(48),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(51),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(48),
    [sym_range] = STATE(7111),
    [sym_binary] = STATE(7111),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(48),
    [sym_nil] = STATE(48),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_not] = ACTIONS(61),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(85),
    [anon_sym_next] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(41),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(99),
  },
  [4220] = {
    [sym_assignment] = STATE(7112),
    [sym_unary] = STATE(7112),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7112),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7112),
    [sym_conditional] = STATE(7112),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7112),
    [sym_binary] = STATE(7112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4221] = {
    [sym_heredoc_body] = STATE(7117),
    [sym__argument_list_with_parens] = STATE(7116),
    [aux_sym_call_repeat1] = STATE(7117),
    [sym_argument_list_with_parens] = STATE(7115),
    [sym_operator] = STATE(7115),
    [anon_sym_LT] = ACTIONS(11268),
    [anon_sym_SLASH] = ACTIONS(11270),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11270),
    [anon_sym_PLUS_AT] = ACTIONS(11270),
    [anon_sym_LPAREN2] = ACTIONS(11272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11270),
    [anon_sym_GT_GT] = ACTIONS(11270),
    [anon_sym_EQ_TILDE] = ACTIONS(11270),
    [anon_sym_LT_LT] = ACTIONS(11270),
    [anon_sym_TILDE] = ACTIONS(11270),
    [anon_sym_PLUS] = ACTIONS(11268),
    [anon_sym_AMP] = ACTIONS(11270),
    [anon_sym_GT] = ACTIONS(11268),
    [anon_sym_PERCENT] = ACTIONS(11270),
    [anon_sym_DASH_AT] = ACTIONS(11270),
    [anon_sym_EQ_EQ] = ACTIONS(11268),
    [anon_sym_STAR] = ACTIONS(11268),
    [anon_sym_BANG_TILDE] = ACTIONS(11270),
    [sym_constant] = ACTIONS(11274),
    [anon_sym_DASH] = ACTIONS(11268),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11270),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11268),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11270),
    [anon_sym_STAR_STAR] = ACTIONS(11270),
    [anon_sym_PIPE] = ACTIONS(11270),
    [anon_sym_DOT_DOT] = ACTIONS(11270),
    [anon_sym_LT_EQ_GT] = ACTIONS(11270),
    [anon_sym_LT_EQ] = ACTIONS(11268),
    [anon_sym_BANG] = ACTIONS(11268),
    [sym_identifier] = ACTIONS(11274),
    [anon_sym_CARET] = ACTIONS(11270),
  },
  [4222] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11276),
    [sym_identifier] = ACTIONS(11276),
  },
  [4223] = {
    [sym_assignment] = STATE(7120),
    [sym_unary] = STATE(7120),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7120),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(7120),
    [sym_conditional] = STATE(7120),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(7120),
    [sym_binary] = STATE(7120),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [4224] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [4225] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(11282),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4226] = {
    [sym_assignment] = STATE(7123),
    [sym_unary] = STATE(7123),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7123),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(7123),
    [sym_conditional] = STATE(7123),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(7123),
    [sym_binary] = STATE(7123),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [4227] = {
    [anon_sym_COLON] = ACTIONS(11284),
    [sym_comment] = ACTIONS(49),
  },
  [4228] = {
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4229] = {
    [sym_assignment] = STATE(7133),
    [sym_unary] = STATE(7133),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(7133),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(7133),
    [sym_conditional] = STATE(7133),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(7133),
    [sym_binary] = STATE(7133),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [4230] = {
    [sym_assignment] = STATE(7138),
    [sym_unary] = STATE(7138),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(7138),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(7138),
    [sym_conditional] = STATE(7138),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(7138),
    [sym_binary] = STATE(7138),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [4231] = {
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4232] = {
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4233] = {
    [sym_assignment] = STATE(7139),
    [sym_unary] = STATE(7139),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(7139),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(7139),
    [sym_conditional] = STATE(7139),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(7139),
    [sym_binary] = STATE(7139),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [4234] = {
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4235] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(11230),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11232),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(11234),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [4236] = {
    [anon_sym_EQ] = ACTIONS(11312),
    [sym_comment] = ACTIONS(3),
  },
  [4237] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym__primary] = STATE(4235),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(7083),
    [sym_method] = STATE(4235),
    [sym_conditional] = STATE(7084),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_subshell] = STATE(4235),
    [sym_unless] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_block_argument] = STATE(7083),
    [sym_range] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4239),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_call] = STATE(4237),
    [sym__argument] = STATE(7083),
    [sym_assignment] = STATE(7084),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_pair] = STATE(7083),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7083),
    [sym_operator_assignment] = STATE(7084),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_rational] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_lambda] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(7086),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(7084),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_nil] = STATE(4239),
    [sym_symbol_array] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_scope_resolution] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [anon_sym_COLON2] = ACTIONS(791),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11240),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [4238] = {
    [sym_heredoc_body] = STATE(7142),
    [aux_sym_call_repeat1] = STATE(7142),
    [aux_sym_argument_list_repeat1] = STATE(7143),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11314),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4239] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(11316),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(11316),
    [anon_sym_SLASH_EQ] = ACTIONS(11316),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11316),
    [anon_sym_PIPE_EQ] = ACTIONS(11316),
    [anon_sym_LT_LT_EQ] = ACTIONS(11316),
    [anon_sym_PLUS_EQ] = ACTIONS(11316),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11316),
    [anon_sym_STAR_EQ] = ACTIONS(11316),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11316),
    [anon_sym_CARET_EQ] = ACTIONS(11316),
    [anon_sym_DASH_EQ] = ACTIONS(11316),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11316),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(11318),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4240] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(11284),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_COLON2] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [4241] = {
    [aux_sym_chained_string_repeat1] = STATE(7154),
    [sym_string] = STATE(7154),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11348),
    [sym__string_start] = ACTIONS(11280),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4242] = {
    [sym_heredoc_body] = STATE(7142),
    [aux_sym_call_repeat1] = STATE(7142),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4243] = {
    [aux_sym_chained_string_repeat1] = STATE(7155),
    [sym_string] = STATE(7155),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [4244] = {
    [ts_builtin_sym_end] = ACTIONS(11350),
    [sym_comment] = ACTIONS(49),
  },
  [4245] = {
    [aux_sym_undef_repeat1] = STATE(7156),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [4246] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4247] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [4248] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [4249] = {
    [sym_assignment] = STATE(7157),
    [sym_unary] = STATE(7157),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7157),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(7157),
    [sym_conditional] = STATE(7157),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(7157),
    [sym_binary] = STATE(7157),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [4250] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [4251] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(11356),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4252] = {
    [sym_assignment] = STATE(7160),
    [sym_unary] = STATE(7160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7160),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(7160),
    [sym_conditional] = STATE(7160),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(7160),
    [sym_binary] = STATE(7160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [4253] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11358),
    [sym_identifier] = ACTIONS(11358),
  },
  [4254] = {
    [anon_sym_COLON] = ACTIONS(11360),
    [sym_comment] = ACTIONS(49),
  },
  [4255] = {
    [sym__argument] = STATE(7168),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(7168),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(7168),
    [sym_hash_splat_argument] = STATE(7168),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(7171),
    [sym_block_argument] = STATE(7168),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [4256] = {
    [sym_assignment] = STATE(7180),
    [sym_unary] = STATE(7180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7180),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(7180),
    [sym_conditional] = STATE(7180),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(7180),
    [sym_binary] = STATE(7180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [4257] = {
    [sym_assignment] = STATE(7183),
    [sym_unary] = STATE(7183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7183),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(7183),
    [sym_conditional] = STATE(7183),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(7183),
    [sym_binary] = STATE(7183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [4258] = {
    [sym__argument] = STATE(7168),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(7168),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(7168),
    [sym_hash_splat_argument] = STATE(7168),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(7171),
    [sym_block_argument] = STATE(7168),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [4259] = {
    [sym__argument] = STATE(7168),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(7168),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(7168),
    [sym_hash_splat_argument] = STATE(7168),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(7171),
    [sym_block_argument] = STATE(7168),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [4260] = {
    [sym_assignment] = STATE(7184),
    [sym_unary] = STATE(7184),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7184),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(7184),
    [sym_conditional] = STATE(7184),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(7184),
    [sym_binary] = STATE(7184),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [4261] = {
    [sym__argument] = STATE(7168),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(7168),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(7168),
    [sym_hash_splat_argument] = STATE(7168),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(7171),
    [sym_block_argument] = STATE(7168),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [4262] = {
    [sym_heredoc_body] = STATE(7186),
    [aux_sym_call_repeat1] = STATE(7186),
    [aux_sym_argument_list_repeat1] = STATE(7187),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11388),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4263] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11390),
    [anon_sym_GT_GT_EQ] = ACTIONS(11390),
    [anon_sym_SLASH_EQ] = ACTIONS(11390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11390),
    [anon_sym_LT_LT_EQ] = ACTIONS(11390),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11390),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(11390),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11392),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(11390),
    [anon_sym_PLUS_EQ] = ACTIONS(11390),
    [anon_sym_STAR_EQ] = ACTIONS(11390),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11390),
    [anon_sym_DASH_EQ] = ACTIONS(11390),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11390),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4264] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_EQ_GT] = ACTIONS(11360),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [4265] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(11420),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11422),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11424),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [4266] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym__primary] = STATE(4290),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_method] = STATE(4290),
    [sym_conditional] = STATE(7207),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_subshell] = STATE(4290),
    [sym_unless] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4294),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_call] = STATE(4292),
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_rational] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_lambda] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(7207),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_nil] = STATE(4294),
    [sym_symbol_array] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_scope_resolution] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4267] = {
    [anon_sym_EQ] = ACTIONS(11434),
    [sym_comment] = ACTIONS(3),
  },
  [4268] = {
    [aux_sym_chained_string_repeat1] = STATE(7210),
    [sym_string] = STATE(7210),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11436),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4269] = {
    [sym_heredoc_body] = STATE(7186),
    [aux_sym_call_repeat1] = STATE(7186),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4270] = {
    [sym_assignment] = STATE(7211),
    [sym_unary] = STATE(7211),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7211),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7211),
    [sym_conditional] = STATE(7211),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7211),
    [sym_binary] = STATE(7211),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4271] = {
    [sym_assignment] = STATE(7212),
    [sym_unary] = STATE(7212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7212),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7212),
    [sym_conditional] = STATE(7212),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7212),
    [sym_binary] = STATE(7212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4272] = {
    [sym_assignment] = STATE(7213),
    [sym_unary] = STATE(7213),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7213),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7213),
    [sym_conditional] = STATE(7213),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7213),
    [sym_binary] = STATE(7213),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4273] = {
    [sym_assignment] = STATE(7214),
    [sym_unary] = STATE(7214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7214),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7214),
    [sym_conditional] = STATE(7214),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7214),
    [sym_binary] = STATE(7214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4274] = {
    [sym_assignment] = STATE(7215),
    [sym_unary] = STATE(7215),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7215),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7215),
    [sym_conditional] = STATE(7215),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7215),
    [sym_binary] = STATE(7215),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4275] = {
    [sym_heredoc_body] = STATE(7220),
    [sym__argument_list_with_parens] = STATE(7219),
    [aux_sym_call_repeat1] = STATE(7220),
    [sym_argument_list_with_parens] = STATE(7218),
    [sym_operator] = STATE(7218),
    [anon_sym_LT] = ACTIONS(11438),
    [anon_sym_SLASH] = ACTIONS(11440),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11440),
    [anon_sym_PLUS_AT] = ACTIONS(11440),
    [anon_sym_LPAREN2] = ACTIONS(11442),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11440),
    [anon_sym_GT_GT] = ACTIONS(11440),
    [anon_sym_EQ_TILDE] = ACTIONS(11440),
    [anon_sym_LT_LT] = ACTIONS(11440),
    [anon_sym_TILDE] = ACTIONS(11440),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_AMP] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11438),
    [anon_sym_PERCENT] = ACTIONS(11440),
    [anon_sym_DASH_AT] = ACTIONS(11440),
    [anon_sym_EQ_EQ] = ACTIONS(11438),
    [anon_sym_STAR] = ACTIONS(11438),
    [anon_sym_BANG_TILDE] = ACTIONS(11440),
    [sym_constant] = ACTIONS(11444),
    [anon_sym_DASH] = ACTIONS(11438),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11440),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11438),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11440),
    [anon_sym_STAR_STAR] = ACTIONS(11440),
    [anon_sym_PIPE] = ACTIONS(11440),
    [anon_sym_DOT_DOT] = ACTIONS(11440),
    [anon_sym_LT_EQ_GT] = ACTIONS(11440),
    [anon_sym_LT_EQ] = ACTIONS(11438),
    [anon_sym_BANG] = ACTIONS(11438),
    [sym_identifier] = ACTIONS(11444),
    [anon_sym_CARET] = ACTIONS(11440),
  },
  [4276] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11446),
    [sym_identifier] = ACTIONS(11446),
  },
  [4277] = {
    [sym_assignment] = STATE(7227),
    [sym_unary] = STATE(7227),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7227),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_splat_argument] = STATE(7229),
    [sym_operator_assignment] = STATE(7227),
    [sym_conditional] = STATE(7227),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_return] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_subshell] = STATE(1820),
    [sym__arg_or_splat_arg] = STATE(7229),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(7227),
    [sym_binary] = STATE(7227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11452),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(7148),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7140),
    [sym_character] = ACTIONS(7144),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [4278] = {
    [sym_assignment] = STATE(7230),
    [sym_unary] = STATE(7230),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7230),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(7230),
    [sym_conditional] = STATE(7230),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(7230),
    [sym_binary] = STATE(7230),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [4279] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [4280] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(11462),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4281] = {
    [sym_assignment] = STATE(7233),
    [sym_unary] = STATE(7233),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7233),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(7233),
    [sym_conditional] = STATE(7233),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(7233),
    [sym_binary] = STATE(7233),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [4282] = {
    [anon_sym_COLON] = ACTIONS(11464),
    [sym_comment] = ACTIONS(49),
  },
  [4283] = {
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4284] = {
    [sym_assignment] = STATE(7243),
    [sym_unary] = STATE(7243),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(7243),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(7243),
    [sym_conditional] = STATE(7243),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(7243),
    [sym_binary] = STATE(7243),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [4285] = {
    [sym_assignment] = STATE(7248),
    [sym_unary] = STATE(7248),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(7248),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(7248),
    [sym_conditional] = STATE(7248),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(7248),
    [sym_binary] = STATE(7248),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [4286] = {
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4287] = {
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4288] = {
    [sym_assignment] = STATE(7249),
    [sym_unary] = STATE(7249),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(7249),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(7249),
    [sym_conditional] = STATE(7249),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(7249),
    [sym_binary] = STATE(7249),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [4289] = {
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4290] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(11420),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11422),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(11424),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [4291] = {
    [anon_sym_EQ] = ACTIONS(11492),
    [sym_comment] = ACTIONS(3),
  },
  [4292] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym__primary] = STATE(4290),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(7206),
    [sym_method] = STATE(4290),
    [sym_conditional] = STATE(7207),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_subshell] = STATE(4290),
    [sym_unless] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_block_argument] = STATE(7206),
    [sym_range] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4294),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_call] = STATE(4292),
    [sym__argument] = STATE(7206),
    [sym_assignment] = STATE(7207),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_pair] = STATE(7206),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7206),
    [sym_operator_assignment] = STATE(7207),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_rational] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_lambda] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(7209),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(7207),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_nil] = STATE(4294),
    [sym_symbol_array] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_scope_resolution] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11430),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [4293] = {
    [sym_heredoc_body] = STATE(7252),
    [aux_sym_call_repeat1] = STATE(7252),
    [aux_sym_argument_list_repeat1] = STATE(7253),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11494),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4294] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11496),
    [anon_sym_GT_GT_EQ] = ACTIONS(11496),
    [anon_sym_SLASH_EQ] = ACTIONS(11496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11496),
    [anon_sym_LT_LT_EQ] = ACTIONS(11496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11496),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(11496),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11498),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(11496),
    [anon_sym_PLUS_EQ] = ACTIONS(11496),
    [anon_sym_STAR_EQ] = ACTIONS(11496),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11496),
    [anon_sym_DASH_EQ] = ACTIONS(11496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11496),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4295] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(11464),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [4296] = {
    [aux_sym_chained_string_repeat1] = STATE(7264),
    [sym_string] = STATE(7264),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11528),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4297] = {
    [sym_heredoc_body] = STATE(7252),
    [aux_sym_call_repeat1] = STATE(7252),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4298] = {
    [sym_assignment] = STATE(7265),
    [sym_unary] = STATE(7265),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7265),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7265),
    [sym_conditional] = STATE(7265),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7265),
    [sym_binary] = STATE(7265),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4299] = {
    [sym_assignment] = STATE(7266),
    [sym_unary] = STATE(7266),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7266),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7266),
    [sym_conditional] = STATE(7266),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7266),
    [sym_binary] = STATE(7266),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4300] = {
    [sym_assignment] = STATE(7267),
    [sym_unary] = STATE(7267),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7267),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7267),
    [sym_conditional] = STATE(7267),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7267),
    [sym_binary] = STATE(7267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4301] = {
    [sym_assignment] = STATE(7268),
    [sym_unary] = STATE(7268),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7268),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7268),
    [sym_conditional] = STATE(7268),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7268),
    [sym_binary] = STATE(7268),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4302] = {
    [sym_assignment] = STATE(7269),
    [sym_unary] = STATE(7269),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7269),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7269),
    [sym_conditional] = STATE(7269),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7269),
    [sym_binary] = STATE(7269),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4303] = {
    [sym_assignment] = STATE(7270),
    [sym_unary] = STATE(7270),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7270),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7270),
    [sym_conditional] = STATE(7270),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7270),
    [sym_binary] = STATE(7270),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4304] = {
    [sym_assignment] = STATE(7271),
    [sym_unary] = STATE(7271),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7271),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7271),
    [sym_conditional] = STATE(7271),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7271),
    [sym_binary] = STATE(7271),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4305] = {
    [sym_assignment] = STATE(7272),
    [sym_unary] = STATE(7272),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7272),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7272),
    [sym_conditional] = STATE(7272),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7272),
    [sym_binary] = STATE(7272),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4306] = {
    [sym_assignment] = STATE(7273),
    [sym_unary] = STATE(7273),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7273),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7273),
    [sym_conditional] = STATE(7273),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7273),
    [sym_binary] = STATE(7273),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4307] = {
    [sym_assignment] = STATE(7274),
    [sym_unary] = STATE(7274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7274),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7274),
    [sym_conditional] = STATE(7274),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7274),
    [sym_binary] = STATE(7274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4308] = {
    [sym_assignment] = STATE(7275),
    [sym_unary] = STATE(7275),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7275),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(7275),
    [sym_conditional] = STATE(7275),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(7275),
    [sym_binary] = STATE(7275),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [4309] = {
    [aux_sym_chained_string_repeat1] = STATE(7276),
    [sym_string] = STATE(7276),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4310] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [4311] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [4312] = {
    [sym_assignment] = STATE(7277),
    [sym_unary] = STATE(7277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(7277),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(7277),
    [sym_conditional] = STATE(7277),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(7277),
    [sym_binary] = STATE(7277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [4313] = {
    [sym_assignment] = STATE(7278),
    [sym_unary] = STATE(7278),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(7278),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(7278),
    [sym_conditional] = STATE(7278),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(7278),
    [sym_binary] = STATE(7278),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [4314] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4315] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4316] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4317] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_heredoc_body] = STATE(7279),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(917),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(929),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(941),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11530),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [4318] = {
    [sym_heredoc_body] = STATE(7280),
    [aux_sym_call_repeat1] = STATE(7280),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [4319] = {
    [sym_heredoc_body] = STATE(7281),
    [aux_sym_call_repeat1] = STATE(7281),
    [aux_sym_argument_list_repeat1] = STATE(7282),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7286),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [4320] = {
    [sym_heredoc_body] = STATE(7283),
    [aux_sym_call_repeat1] = STATE(7283),
    [aux_sym_argument_list_repeat1] = STATE(7284),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [4321] = {
    [sym_heredoc_body] = STATE(7283),
    [aux_sym_call_repeat1] = STATE(7283),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [4322] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [4323] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [4324] = {
    [sym_assignment] = STATE(7285),
    [sym_unary] = STATE(7285),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7285),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7285),
    [sym_conditional] = STATE(7285),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7285),
    [sym_binary] = STATE(7285),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4325] = {
    [sym_assignment] = STATE(7286),
    [sym_unary] = STATE(7286),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7286),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_splat_argument] = STATE(7287),
    [sym_operator_assignment] = STATE(7286),
    [sym_conditional] = STATE(7286),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(7287),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7286),
    [sym_binary] = STATE(7286),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [sym_global_variable] = ACTIONS(117),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(109),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4326] = {
    [sym_assignment] = STATE(7288),
    [sym_unary] = STATE(7288),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7288),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7288),
    [sym_conditional] = STATE(7288),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7288),
    [sym_binary] = STATE(7288),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4327] = {
    [sym_assignment] = STATE(7289),
    [sym_unary] = STATE(7289),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7289),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7289),
    [sym_conditional] = STATE(7289),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7289),
    [sym_binary] = STATE(7289),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4328] = {
    [sym_assignment] = STATE(7291),
    [sym_unary] = STATE(7291),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7291),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7291),
    [sym_conditional] = STATE(7291),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7291),
    [sym_binary] = STATE(7291),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4329] = {
    [sym_assignment] = STATE(7292),
    [sym_unary] = STATE(7292),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7292),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7292),
    [sym_conditional] = STATE(7292),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7292),
    [sym_binary] = STATE(7292),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4330] = {
    [sym_assignment] = STATE(7293),
    [sym_unary] = STATE(7293),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7293),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7293),
    [sym_conditional] = STATE(7293),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7293),
    [sym_binary] = STATE(7293),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4331] = {
    [sym_assignment] = STATE(7294),
    [sym_unary] = STATE(7294),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7294),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7294),
    [sym_conditional] = STATE(7294),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7294),
    [sym_binary] = STATE(7294),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4332] = {
    [sym_assignment] = STATE(7295),
    [sym_unary] = STATE(7295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7295),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7295),
    [sym_conditional] = STATE(7295),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7295),
    [sym_binary] = STATE(7295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4333] = {
    [sym_assignment] = STATE(7296),
    [sym_unary] = STATE(7296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7296),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7296),
    [sym_conditional] = STATE(7296),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7296),
    [sym_binary] = STATE(7296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4334] = {
    [sym_assignment] = STATE(7297),
    [sym_unary] = STATE(7297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7297),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(7297),
    [sym_conditional] = STATE(7297),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7297),
    [sym_binary] = STATE(7297),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4335] = {
    [aux_sym_chained_string_repeat1] = STATE(7298),
    [sym_string] = STATE(7298),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [4336] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(491),
    [sym_unary] = STATE(491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(491),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(491),
    [sym_conditional] = STATE(491),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(495),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(491),
    [sym_binary] = STATE(491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(917),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(935),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(939),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(941),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7322),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [4337] = {
    [sym_heredoc_body] = STATE(4337),
    [aux_sym_call_repeat1] = STATE(4337),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [4338] = {
    [sym_heredoc_body] = STATE(4337),
    [aux_sym_call_repeat1] = STATE(4337),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [4339] = {
    [aux_sym_argument_list_repeat1] = STATE(4339),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(11532),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [4340] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4341] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4342] = {
    [aux_sym_exceptions_repeat1] = STATE(7300),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [4343] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4344] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4345] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11535),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4346] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4347] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4348] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4349] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [4350] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4351] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4352] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4353] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [4354] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(7303),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(11537),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [4355] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [4356] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [4357] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(4356),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(7304),
    [sym_operator] = STATE(7304),
    [anon_sym_LT] = ACTIONS(7324),
    [anon_sym_SLASH] = ACTIONS(7326),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7326),
    [anon_sym_PLUS_AT] = ACTIONS(7326),
    [anon_sym_LPAREN2] = ACTIONS(7328),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7326),
    [anon_sym_GT_GT] = ACTIONS(7326),
    [anon_sym_EQ_TILDE] = ACTIONS(7326),
    [anon_sym_LT_LT] = ACTIONS(7326),
    [anon_sym_TILDE] = ACTIONS(7326),
    [anon_sym_PLUS] = ACTIONS(7324),
    [anon_sym_AMP] = ACTIONS(7326),
    [anon_sym_GT] = ACTIONS(7324),
    [anon_sym_PERCENT] = ACTIONS(7326),
    [anon_sym_DASH_AT] = ACTIONS(7326),
    [anon_sym_EQ_EQ] = ACTIONS(7324),
    [anon_sym_STAR] = ACTIONS(7324),
    [anon_sym_BANG_TILDE] = ACTIONS(7326),
    [sym_constant] = ACTIONS(11539),
    [anon_sym_DASH] = ACTIONS(7324),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7326),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7324),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7326),
    [anon_sym_STAR_STAR] = ACTIONS(7326),
    [anon_sym_PIPE] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7326),
    [anon_sym_LT_EQ_GT] = ACTIONS(7326),
    [anon_sym_LT_EQ] = ACTIONS(7324),
    [anon_sym_BANG] = ACTIONS(7324),
    [sym_identifier] = ACTIONS(11539),
    [anon_sym_CARET] = ACTIONS(7326),
  },
  [4358] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [4359] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [4360] = {
    [sym_assignment] = STATE(7305),
    [sym_unary] = STATE(7305),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(7305),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(7305),
    [sym_conditional] = STATE(7305),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(7305),
    [sym_binary] = STATE(7305),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [4361] = {
    [sym_assignment] = STATE(7306),
    [sym_unary] = STATE(7306),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(7306),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(7306),
    [sym_conditional] = STATE(7306),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(7306),
    [sym_binary] = STATE(7306),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [4362] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4363] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4364] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4365] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_heredoc_body] = STATE(7307),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym_float] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1019),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1019),
    [sym__block_ampersand] = ACTIONS(3386),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11541),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [4366] = {
    [sym_heredoc_body] = STATE(7308),
    [aux_sym_call_repeat1] = STATE(7308),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4367] = {
    [sym_heredoc_body] = STATE(7309),
    [aux_sym_call_repeat1] = STATE(7309),
    [aux_sym_argument_list_repeat1] = STATE(7310),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7340),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4368] = {
    [aux_sym_chained_string_repeat1] = STATE(4368),
    [sym_string] = STATE(4368),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [4369] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [4370] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [4371] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [4372] = {
    [sym_assignment] = STATE(7311),
    [sym_unary] = STATE(7311),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7311),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7311),
    [sym_conditional] = STATE(7311),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7311),
    [sym_binary] = STATE(7311),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4373] = {
    [sym_assignment] = STATE(1887),
    [sym_unary] = STATE(1887),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1887),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_splat_argument] = STATE(7312),
    [sym_operator_assignment] = STATE(1887),
    [sym_conditional] = STATE(1887),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(7312),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(1887),
    [sym_binary] = STATE(1887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3398),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [sym_global_variable] = ACTIONS(117),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(109),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4374] = {
    [sym_assignment] = STATE(7313),
    [sym_unary] = STATE(7313),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7313),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7313),
    [sym_conditional] = STATE(7313),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7313),
    [sym_binary] = STATE(7313),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4375] = {
    [sym_assignment] = STATE(7314),
    [sym_unary] = STATE(7314),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7314),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7314),
    [sym_conditional] = STATE(7314),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7314),
    [sym_binary] = STATE(7314),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4376] = {
    [sym_assignment] = STATE(7316),
    [sym_unary] = STATE(7316),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7316),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7316),
    [sym_conditional] = STATE(7316),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7316),
    [sym_binary] = STATE(7316),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4377] = {
    [sym_assignment] = STATE(7317),
    [sym_unary] = STATE(7317),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7317),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7317),
    [sym_conditional] = STATE(7317),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7317),
    [sym_binary] = STATE(7317),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4378] = {
    [sym_assignment] = STATE(7318),
    [sym_unary] = STATE(7318),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7318),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7318),
    [sym_conditional] = STATE(7318),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7318),
    [sym_binary] = STATE(7318),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4379] = {
    [sym_assignment] = STATE(7319),
    [sym_unary] = STATE(7319),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7319),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7319),
    [sym_conditional] = STATE(7319),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7319),
    [sym_binary] = STATE(7319),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4380] = {
    [sym_assignment] = STATE(7320),
    [sym_unary] = STATE(7320),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7320),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7320),
    [sym_conditional] = STATE(7320),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7320),
    [sym_binary] = STATE(7320),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4381] = {
    [sym_assignment] = STATE(7321),
    [sym_unary] = STATE(7321),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7321),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7321),
    [sym_conditional] = STATE(7321),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7321),
    [sym_binary] = STATE(7321),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4382] = {
    [sym_assignment] = STATE(7322),
    [sym_unary] = STATE(7322),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7322),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(7322),
    [sym_conditional] = STATE(7322),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(7322),
    [sym_binary] = STATE(7322),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4383] = {
    [sym_assignment] = STATE(1887),
    [sym_unary] = STATE(1887),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(1887),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(1887),
    [sym_conditional] = STATE(1887),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_true] = STATE(1886),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(1887),
    [sym_binary] = STATE(1887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3398),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [sym_global_variable] = ACTIONS(117),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(109),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [4384] = {
    [aux_sym_exceptions_repeat1] = STATE(7323),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [4385] = {
    [sym_assignment] = STATE(7324),
    [sym_unary] = STATE(7324),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7324),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(7324),
    [sym_conditional] = STATE(7324),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(7324),
    [sym_binary] = STATE(7324),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [4386] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [4387] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [sym__line_break] = ACTIONS(11545),
    [anon_sym_then] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_when] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym___END__] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_end] = ACTIONS(11545),
    [anon_sym_ensure] = ACTIONS(11545),
    [anon_sym_else] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_elsif] = ACTIONS(11545),
    [ts_builtin_sym_end] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
    [sym__binary_minus] = ACTIONS(11545),
  },
  [4388] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [4389] = {
    [anon_sym_RPAREN] = ACTIONS(11547),
    [sym_comment] = ACTIONS(49),
  },
  [4390] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [4391] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [4392] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [4393] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4394] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [4395] = {
    [sym_assignment] = STATE(7326),
    [sym_unary] = STATE(7326),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7326),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7326),
    [sym_conditional] = STATE(7326),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7326),
    [sym_binary] = STATE(7326),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4396] = {
    [sym_assignment] = STATE(7327),
    [sym_unary] = STATE(7327),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7327),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_splat_argument] = STATE(7328),
    [sym_operator_assignment] = STATE(7327),
    [sym_conditional] = STATE(7327),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_return] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_subshell] = STATE(1925),
    [sym__arg_or_splat_arg] = STATE(7328),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7327),
    [sym_binary] = STATE(7327),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [sym_global_variable] = ACTIONS(3446),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3438),
    [sym_character] = ACTIONS(3442),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4397] = {
    [sym_assignment] = STATE(7329),
    [sym_unary] = STATE(7329),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7329),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7329),
    [sym_conditional] = STATE(7329),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7329),
    [sym_binary] = STATE(7329),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4398] = {
    [sym_assignment] = STATE(7330),
    [sym_unary] = STATE(7330),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7330),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7330),
    [sym_conditional] = STATE(7330),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7330),
    [sym_binary] = STATE(7330),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4399] = {
    [sym_assignment] = STATE(7332),
    [sym_unary] = STATE(7332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7332),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7332),
    [sym_conditional] = STATE(7332),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7332),
    [sym_binary] = STATE(7332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4400] = {
    [sym_assignment] = STATE(7333),
    [sym_unary] = STATE(7333),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7333),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7333),
    [sym_conditional] = STATE(7333),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7333),
    [sym_binary] = STATE(7333),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4401] = {
    [sym_assignment] = STATE(7334),
    [sym_unary] = STATE(7334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7334),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7334),
    [sym_conditional] = STATE(7334),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7334),
    [sym_binary] = STATE(7334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4402] = {
    [sym_assignment] = STATE(7335),
    [sym_unary] = STATE(7335),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7335),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7335),
    [sym_conditional] = STATE(7335),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7335),
    [sym_binary] = STATE(7335),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4403] = {
    [sym_assignment] = STATE(7336),
    [sym_unary] = STATE(7336),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7336),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7336),
    [sym_conditional] = STATE(7336),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7336),
    [sym_binary] = STATE(7336),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4404] = {
    [sym_assignment] = STATE(7337),
    [sym_unary] = STATE(7337),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7337),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7337),
    [sym_conditional] = STATE(7337),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7337),
    [sym_binary] = STATE(7337),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4405] = {
    [sym_assignment] = STATE(7338),
    [sym_unary] = STATE(7338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7338),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(7338),
    [sym_conditional] = STATE(7338),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7338),
    [sym_binary] = STATE(7338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [4406] = {
    [aux_sym_chained_string_repeat1] = STATE(7339),
    [sym_string] = STATE(7339),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [4407] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4408] = {
    [aux_sym_exceptions_repeat1] = STATE(7341),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [4409] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(535),
    [sym_unary] = STATE(535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(535),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(535),
    [sym_conditional] = STATE(535),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(536),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(535),
    [sym_binary] = STATE(535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym_float] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(1023),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1019),
    [sym__block_ampersand] = ACTIONS(1027),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7426),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [4410] = {
    [sym_heredoc_body] = STATE(4410),
    [aux_sym_call_repeat1] = STATE(4410),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [4411] = {
    [sym_heredoc_body] = STATE(4410),
    [aux_sym_call_repeat1] = STATE(4410),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [4412] = {
    [aux_sym_argument_list_repeat1] = STATE(4412),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(11549),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [4413] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4414] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4415] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4416] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4417] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4418] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4419] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4420] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [4421] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4422] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4423] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4424] = {
    [aux_sym_chained_string_repeat1] = STATE(4424),
    [sym_string] = STATE(4424),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [4425] = {
    [aux_sym_undef_repeat1] = STATE(7343),
    [anon_sym_RBRACE] = ACTIONS(3500),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [4426] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4427] = {
    [aux_sym_chained_string_repeat1] = STATE(4460),
    [sym_string] = STATE(4460),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4428] = {
    [sym_assignment] = STATE(7344),
    [sym_unary] = STATE(7344),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7344),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(7344),
    [sym_conditional] = STATE(7344),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(7344),
    [sym_binary] = STATE(7344),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4429] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [4430] = {
    [sym_assignment] = STATE(7345),
    [sym_unary] = STATE(7345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7345),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(7345),
    [sym_conditional] = STATE(7345),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(7345),
    [sym_binary] = STATE(7345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4431] = {
    [sym_heredoc_body] = STATE(7346),
    [aux_sym_call_repeat1] = STATE(7346),
    [aux_sym_argument_list_repeat1] = STATE(7347),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10995),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4432] = {
    [sym_heredoc_body] = STATE(7346),
    [aux_sym_call_repeat1] = STATE(7346),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4433] = {
    [sym__argument] = STATE(7348),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(7348),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(7348),
    [sym_hash_splat_argument] = STATE(7348),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(7349),
    [sym_block_argument] = STATE(7348),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [4434] = {
    [sym__argument] = STATE(7348),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(7348),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(7348),
    [sym_hash_splat_argument] = STATE(7348),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(7349),
    [sym_block_argument] = STATE(7348),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [4435] = {
    [sym_assignment] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4436] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4437] = {
    [sym__argument] = STATE(7348),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(7348),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(7348),
    [sym_hash_splat_argument] = STATE(7348),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(7349),
    [sym_block_argument] = STATE(7348),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [4438] = {
    [sym_assignment] = STATE(7351),
    [sym_unary] = STATE(7351),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7351),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(7351),
    [sym_conditional] = STATE(7351),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(7351),
    [sym_binary] = STATE(7351),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4439] = {
    [sym__argument] = STATE(7348),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(7348),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(7348),
    [sym_hash_splat_argument] = STATE(7348),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym__argument_list_with_parens] = STATE(7349),
    [sym_block_argument] = STATE(7348),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2939),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3508),
    [sym_self] = ACTIONS(2941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3524),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3534),
  },
  [4440] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11554),
    [anon_sym_GT_GT_EQ] = ACTIONS(11554),
    [anon_sym_SLASH_EQ] = ACTIONS(11554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11554),
    [anon_sym_LT_LT_EQ] = ACTIONS(11554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11554),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(11554),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11556),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(11554),
    [anon_sym_PLUS_EQ] = ACTIONS(11554),
    [anon_sym_STAR_EQ] = ACTIONS(11554),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11554),
    [anon_sym_DASH_EQ] = ACTIONS(11554),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11554),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4441] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [4442] = {
    [anon_sym_EQ] = ACTIONS(11584),
    [sym_comment] = ACTIONS(3),
  },
  [4443] = {
    [aux_sym_chained_string_repeat1] = STATE(7363),
    [sym_string] = STATE(7363),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4444] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [4445] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [4446] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_heredoc_body] = STATE(7364),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2941),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(3524),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11586),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4447] = {
    [sym_heredoc_body] = STATE(7365),
    [aux_sym_call_repeat1] = STATE(7365),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4448] = {
    [sym_heredoc_body] = STATE(7366),
    [aux_sym_call_repeat1] = STATE(7366),
    [aux_sym_argument_list_repeat1] = STATE(7367),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7457),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4449] = {
    [sym_assignment] = STATE(7368),
    [sym_unary] = STATE(7368),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7368),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7368),
    [sym_conditional] = STATE(7368),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7368),
    [sym_binary] = STATE(7368),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4450] = {
    [sym_assignment] = STATE(7369),
    [sym_unary] = STATE(7369),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7369),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(7370),
    [sym_operator_assignment] = STATE(7369),
    [sym_conditional] = STATE(7369),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(1669),
    [sym__arg_or_splat_arg] = STATE(7370),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7369),
    [sym_binary] = STATE(7369),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2941),
    [sym_character] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4451] = {
    [sym_assignment] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4452] = {
    [sym_assignment] = STATE(7372),
    [sym_unary] = STATE(7372),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7372),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7372),
    [sym_conditional] = STATE(7372),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7372),
    [sym_binary] = STATE(7372),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4453] = {
    [sym_assignment] = STATE(7373),
    [sym_unary] = STATE(7373),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7373),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7373),
    [sym_conditional] = STATE(7373),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7373),
    [sym_binary] = STATE(7373),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4454] = {
    [sym_assignment] = STATE(7374),
    [sym_unary] = STATE(7374),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7374),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7374),
    [sym_conditional] = STATE(7374),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7374),
    [sym_binary] = STATE(7374),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4455] = {
    [sym_assignment] = STATE(7375),
    [sym_unary] = STATE(7375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7375),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7375),
    [sym_conditional] = STATE(7375),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7375),
    [sym_binary] = STATE(7375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4456] = {
    [sym_assignment] = STATE(7376),
    [sym_unary] = STATE(7376),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7376),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7376),
    [sym_conditional] = STATE(7376),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7376),
    [sym_binary] = STATE(7376),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4457] = {
    [sym_assignment] = STATE(7378),
    [sym_unary] = STATE(7378),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7378),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7378),
    [sym_conditional] = STATE(7378),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7378),
    [sym_binary] = STATE(7378),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4458] = {
    [sym_assignment] = STATE(7379),
    [sym_unary] = STATE(7379),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7379),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7379),
    [sym_conditional] = STATE(7379),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7379),
    [sym_binary] = STATE(7379),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4459] = {
    [sym_assignment] = STATE(7380),
    [sym_unary] = STATE(7380),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7380),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(7380),
    [sym_conditional] = STATE(7380),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7380),
    [sym_binary] = STATE(7380),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [4460] = {
    [aux_sym_chained_string_repeat1] = STATE(7381),
    [sym_string] = STATE(7381),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4461] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(6698),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(6698),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [4462] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(6700),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(6700),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [4463] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(6702),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(6702),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [4464] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [4465] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(11588),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [4466] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(6706),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(6706),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [4467] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_RBRACE] = ACTIONS(6708),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_unless] = ACTIONS(6708),
    [anon_sym_or] = ACTIONS(3608),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(3608),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3620),
    [sym__binary_minus] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(3622),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
  },
  [4468] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [4469] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(7384),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(11590),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [4470] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [4471] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [4472] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(4471),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(7385),
    [sym_operator] = STATE(7385),
    [anon_sym_LT] = ACTIONS(7497),
    [anon_sym_SLASH] = ACTIONS(7499),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7499),
    [anon_sym_PLUS_AT] = ACTIONS(7499),
    [anon_sym_LPAREN2] = ACTIONS(7501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7499),
    [anon_sym_GT_GT] = ACTIONS(7499),
    [anon_sym_EQ_TILDE] = ACTIONS(7499),
    [anon_sym_LT_LT] = ACTIONS(7499),
    [anon_sym_TILDE] = ACTIONS(7499),
    [anon_sym_PLUS] = ACTIONS(7497),
    [anon_sym_AMP] = ACTIONS(7499),
    [anon_sym_GT] = ACTIONS(7497),
    [anon_sym_PERCENT] = ACTIONS(7499),
    [anon_sym_DASH_AT] = ACTIONS(7499),
    [anon_sym_EQ_EQ] = ACTIONS(7497),
    [anon_sym_STAR] = ACTIONS(7497),
    [anon_sym_BANG_TILDE] = ACTIONS(7499),
    [sym_constant] = ACTIONS(11592),
    [anon_sym_DASH] = ACTIONS(7497),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7497),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7499),
    [anon_sym_STAR_STAR] = ACTIONS(7499),
    [anon_sym_PIPE] = ACTIONS(7499),
    [anon_sym_DOT_DOT] = ACTIONS(7499),
    [anon_sym_LT_EQ_GT] = ACTIONS(7499),
    [anon_sym_LT_EQ] = ACTIONS(7497),
    [anon_sym_BANG] = ACTIONS(7497),
    [sym_identifier] = ACTIONS(11592),
    [anon_sym_CARET] = ACTIONS(7499),
  },
  [4473] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [4474] = {
    [sym_assignment] = STATE(7386),
    [sym_unary] = STATE(7386),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7386),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(7386),
    [sym_conditional] = STATE(7386),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(7386),
    [sym_binary] = STATE(7386),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4475] = {
    [sym_assignment] = STATE(7387),
    [sym_unary] = STATE(7387),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7387),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(7387),
    [sym_conditional] = STATE(7387),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(7387),
    [sym_binary] = STATE(7387),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4476] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4477] = {
    [sym_assignment] = STATE(7388),
    [sym_unary] = STATE(7388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7388),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(7388),
    [sym_conditional] = STATE(7388),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(7388),
    [sym_binary] = STATE(7388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [4478] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11594),
    [anon_sym_GT_GT_EQ] = ACTIONS(11594),
    [anon_sym_SLASH_EQ] = ACTIONS(11594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11594),
    [anon_sym_LT_LT_EQ] = ACTIONS(11594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11594),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(11594),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11596),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(11594),
    [anon_sym_PLUS_EQ] = ACTIONS(11594),
    [anon_sym_STAR_EQ] = ACTIONS(11594),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11594),
    [anon_sym_DASH_EQ] = ACTIONS(11594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11594),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4479] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [4480] = {
    [anon_sym_EQ] = ACTIONS(11624),
    [sym_comment] = ACTIONS(3),
  },
  [4481] = {
    [aux_sym_exceptions_repeat1] = STATE(7401),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(11626),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [4482] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4483] = {
    [aux_sym_chained_string_repeat1] = STATE(4516),
    [sym_string] = STATE(4516),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4484] = {
    [sym_assignment] = STATE(7402),
    [sym_unary] = STATE(7402),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(7402),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(7402),
    [sym_conditional] = STATE(7402),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(7402),
    [sym_binary] = STATE(7402),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [4485] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [4486] = {
    [sym_assignment] = STATE(7403),
    [sym_unary] = STATE(7403),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(7403),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(7403),
    [sym_conditional] = STATE(7403),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(7403),
    [sym_binary] = STATE(7403),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [4487] = {
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [4488] = {
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [4489] = {
    [sym_assignment] = STATE(7404),
    [sym_unary] = STATE(7404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(7404),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(7404),
    [sym_conditional] = STATE(7404),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(7404),
    [sym_binary] = STATE(7404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [4490] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [4491] = {
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [4492] = {
    [sym_assignment] = STATE(7405),
    [sym_unary] = STATE(7405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(7405),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(7405),
    [sym_conditional] = STATE(7405),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(7405),
    [sym_binary] = STATE(7405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [4493] = {
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [4494] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11628),
    [anon_sym_GT_GT_EQ] = ACTIONS(11628),
    [anon_sym_SLASH_EQ] = ACTIONS(11628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11628),
    [anon_sym_LT_LT_EQ] = ACTIONS(11628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11628),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(11628),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11630),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(11628),
    [anon_sym_PLUS_EQ] = ACTIONS(11628),
    [anon_sym_STAR_EQ] = ACTIONS(11628),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11628),
    [anon_sym_DASH_EQ] = ACTIONS(11628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11628),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4495] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [4496] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(3550),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(3552),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [4497] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym__primary] = STATE(1994),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(1997),
    [sym_method] = STATE(1994),
    [sym_conditional] = STATE(1999),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_subshell] = STATE(1994),
    [sym_unless] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_block_argument] = STATE(1997),
    [sym_range] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1998),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_call] = STATE(1996),
    [sym__argument] = STATE(1997),
    [sym_assignment] = STATE(1999),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_pair] = STATE(1997),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(1997),
    [sym_operator_assignment] = STATE(1999),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_rational] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_lambda] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2001),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(1999),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_nil] = STATE(1998),
    [sym_symbol_array] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_scope_resolution] = STATE(1996),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(3558),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(3568),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(3578),
    [anon_sym_not] = ACTIONS(3580),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(3590),
  },
  [4498] = {
    [anon_sym_EQ] = ACTIONS(11660),
    [sym_comment] = ACTIONS(3),
  },
  [4499] = {
    [aux_sym_chained_string_repeat1] = STATE(7417),
    [sym_string] = STATE(7417),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4500] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [4501] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [4502] = {
    [sym_assignment] = STATE(7418),
    [sym_unary] = STATE(7418),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7418),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(7419),
    [sym_operator_assignment] = STATE(7418),
    [sym_conditional] = STATE(7418),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_subshell] = STATE(1994),
    [sym__arg_or_splat_arg] = STATE(7419),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7418),
    [sym_binary] = STATE(7418),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(3562),
    [sym_character] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4503] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_heredoc_body] = STATE(7420),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym_float] = ACTIONS(3558),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(3562),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(3562),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(3570),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [sym_class_variable] = ACTIONS(3570),
    [sym__block_ampersand] = ACTIONS(3578),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11662),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4504] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4505] = {
    [sym_heredoc_body] = STATE(7422),
    [aux_sym_call_repeat1] = STATE(7422),
    [aux_sym_argument_list_repeat1] = STATE(7423),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7553),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4506] = {
    [sym_assignment] = STATE(7424),
    [sym_unary] = STATE(7424),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7424),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7424),
    [sym_conditional] = STATE(7424),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7424),
    [sym_binary] = STATE(7424),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4507] = {
    [sym_assignment] = STATE(7425),
    [sym_unary] = STATE(7425),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7425),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7425),
    [sym_conditional] = STATE(7425),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7425),
    [sym_binary] = STATE(7425),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4508] = {
    [sym_assignment] = STATE(7426),
    [sym_unary] = STATE(7426),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7426),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7426),
    [sym_conditional] = STATE(7426),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7426),
    [sym_binary] = STATE(7426),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4509] = {
    [sym_assignment] = STATE(7427),
    [sym_unary] = STATE(7427),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7427),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7427),
    [sym_conditional] = STATE(7427),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7427),
    [sym_binary] = STATE(7427),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4510] = {
    [sym_assignment] = STATE(7428),
    [sym_unary] = STATE(7428),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7428),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7428),
    [sym_conditional] = STATE(7428),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7428),
    [sym_binary] = STATE(7428),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4511] = {
    [sym_assignment] = STATE(7429),
    [sym_unary] = STATE(7429),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7429),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7429),
    [sym_conditional] = STATE(7429),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7429),
    [sym_binary] = STATE(7429),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4512] = {
    [sym_assignment] = STATE(7430),
    [sym_unary] = STATE(7430),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7430),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7430),
    [sym_conditional] = STATE(7430),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7430),
    [sym_binary] = STATE(7430),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4513] = {
    [sym_assignment] = STATE(7432),
    [sym_unary] = STATE(7432),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7432),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7432),
    [sym_conditional] = STATE(7432),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7432),
    [sym_binary] = STATE(7432),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4514] = {
    [sym_assignment] = STATE(7433),
    [sym_unary] = STATE(7433),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7433),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7433),
    [sym_conditional] = STATE(7433),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7433),
    [sym_binary] = STATE(7433),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4515] = {
    [sym_assignment] = STATE(7434),
    [sym_unary] = STATE(7434),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7434),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(7434),
    [sym_conditional] = STATE(7434),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7434),
    [sym_binary] = STATE(7434),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [4516] = {
    [aux_sym_chained_string_repeat1] = STATE(7435),
    [sym_string] = STATE(7435),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [4517] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4518] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4519] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4520] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4521] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4522] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11664),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4523] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4524] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4525] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4526] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4527] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [4528] = {
    [aux_sym_chained_string_repeat1] = STATE(4528),
    [sym_string] = STATE(4528),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [4529] = {
    [sym_heredoc_body] = STATE(1978),
    [sym__terminator] = STATE(1978),
    [sym__line_break] = ACTIONS(3536),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(3544),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(3536),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [4530] = {
    [aux_sym_undef_repeat1] = STATE(4530),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_then] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [4531] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [4532] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [4533] = {
    [sym_assignment] = STATE(7437),
    [sym_unary] = STATE(7437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(7437),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(7437),
    [sym_conditional] = STATE(7437),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(7437),
    [sym_binary] = STATE(7437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [4534] = {
    [sym_assignment] = STATE(7438),
    [sym_unary] = STATE(7438),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(7438),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(7438),
    [sym_conditional] = STATE(7438),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(7438),
    [sym_binary] = STATE(7438),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [4535] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4536] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4537] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4538] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_heredoc_body] = STATE(7439),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym_float] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(1099),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(1107),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11666),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [4539] = {
    [sym_heredoc_body] = STATE(7440),
    [aux_sym_call_repeat1] = STATE(7440),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4540] = {
    [sym_heredoc_body] = STATE(7441),
    [aux_sym_call_repeat1] = STATE(7441),
    [aux_sym_argument_list_repeat1] = STATE(7442),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7598),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4541] = {
    [sym_heredoc_body] = STATE(7443),
    [aux_sym_call_repeat1] = STATE(7443),
    [aux_sym_argument_list_repeat1] = STATE(7444),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4542] = {
    [sym_heredoc_body] = STATE(7443),
    [aux_sym_call_repeat1] = STATE(7443),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4543] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4544] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [4545] = {
    [sym_assignment] = STATE(7445),
    [sym_unary] = STATE(7445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7445),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7445),
    [sym_conditional] = STATE(7445),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7445),
    [sym_binary] = STATE(7445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4546] = {
    [sym_assignment] = STATE(7446),
    [sym_unary] = STATE(7446),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7446),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_splat_argument] = STATE(7447),
    [sym_operator_assignment] = STATE(7446),
    [sym_conditional] = STATE(7446),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_return] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_subshell] = STATE(84),
    [sym__arg_or_splat_arg] = STATE(7447),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7446),
    [sym_binary] = STATE(7446),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(147),
    [sym_character] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4547] = {
    [sym_assignment] = STATE(7448),
    [sym_unary] = STATE(7448),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7448),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7448),
    [sym_conditional] = STATE(7448),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7448),
    [sym_binary] = STATE(7448),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4548] = {
    [sym_assignment] = STATE(7449),
    [sym_unary] = STATE(7449),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7449),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7449),
    [sym_conditional] = STATE(7449),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7449),
    [sym_binary] = STATE(7449),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4549] = {
    [sym_assignment] = STATE(7451),
    [sym_unary] = STATE(7451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7451),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7451),
    [sym_conditional] = STATE(7451),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7451),
    [sym_binary] = STATE(7451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4550] = {
    [sym_assignment] = STATE(7452),
    [sym_unary] = STATE(7452),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7452),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7452),
    [sym_conditional] = STATE(7452),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7452),
    [sym_binary] = STATE(7452),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4551] = {
    [sym_assignment] = STATE(7453),
    [sym_unary] = STATE(7453),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7453),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7453),
    [sym_conditional] = STATE(7453),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7453),
    [sym_binary] = STATE(7453),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4552] = {
    [sym_assignment] = STATE(7454),
    [sym_unary] = STATE(7454),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7454),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7454),
    [sym_conditional] = STATE(7454),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7454),
    [sym_binary] = STATE(7454),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4553] = {
    [sym_assignment] = STATE(7455),
    [sym_unary] = STATE(7455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7455),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7455),
    [sym_conditional] = STATE(7455),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7455),
    [sym_binary] = STATE(7455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4554] = {
    [sym_assignment] = STATE(7456),
    [sym_unary] = STATE(7456),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7456),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7456),
    [sym_conditional] = STATE(7456),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7456),
    [sym_binary] = STATE(7456),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4555] = {
    [sym_assignment] = STATE(7457),
    [sym_unary] = STATE(7457),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7457),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(7457),
    [sym_conditional] = STATE(7457),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7457),
    [sym_binary] = STATE(7457),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4556] = {
    [aux_sym_chained_string_repeat1] = STATE(7458),
    [sym_string] = STATE(7458),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4557] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(583),
    [sym_unary] = STATE(583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(583),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(583),
    [sym_conditional] = STATE(583),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(587),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(583),
    [sym_binary] = STATE(583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym_float] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(1099),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(1117),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7634),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [4558] = {
    [sym_heredoc_body] = STATE(4558),
    [aux_sym_call_repeat1] = STATE(4558),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [4559] = {
    [sym_heredoc_body] = STATE(4558),
    [aux_sym_call_repeat1] = STATE(4558),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [4560] = {
    [aux_sym_argument_list_repeat1] = STATE(4560),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(11668),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [4561] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4562] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4563] = {
    [aux_sym_exceptions_repeat1] = STATE(7460),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [4564] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4565] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4566] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11671),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4567] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4568] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4569] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4570] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4571] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4572] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4573] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [4574] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_then] = ACTIONS(1327),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [4575] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(7463),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(11673),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [4576] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_then] = ACTIONS(6719),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [4577] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_then] = ACTIONS(6727),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [4578] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(4577),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(7464),
    [sym_operator] = STATE(7464),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_SLASH] = ACTIONS(7638),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7638),
    [anon_sym_PLUS_AT] = ACTIONS(7638),
    [anon_sym_LPAREN2] = ACTIONS(7640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7638),
    [anon_sym_GT_GT] = ACTIONS(7638),
    [anon_sym_EQ_TILDE] = ACTIONS(7638),
    [anon_sym_LT_LT] = ACTIONS(7638),
    [anon_sym_TILDE] = ACTIONS(7638),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_AMP] = ACTIONS(7638),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_PERCENT] = ACTIONS(7638),
    [anon_sym_DASH_AT] = ACTIONS(7638),
    [anon_sym_EQ_EQ] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_BANG_TILDE] = ACTIONS(7638),
    [sym_constant] = ACTIONS(11675),
    [anon_sym_DASH] = ACTIONS(7636),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(7638),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7636),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(7638),
    [anon_sym_STAR_STAR] = ACTIONS(7638),
    [anon_sym_PIPE] = ACTIONS(7638),
    [anon_sym_DOT_DOT] = ACTIONS(7638),
    [anon_sym_LT_EQ_GT] = ACTIONS(7638),
    [anon_sym_LT_EQ] = ACTIONS(7636),
    [anon_sym_BANG] = ACTIONS(7636),
    [sym_identifier] = ACTIONS(11675),
    [anon_sym_CARET] = ACTIONS(7638),
  },
  [4579] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [4580] = {
    [sym_assignment] = STATE(7465),
    [sym_unary] = STATE(7465),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(7465),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(7465),
    [sym_conditional] = STATE(7465),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(7465),
    [sym_binary] = STATE(7465),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [4581] = {
    [sym_assignment] = STATE(7466),
    [sym_unary] = STATE(7466),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(7466),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(7466),
    [sym_conditional] = STATE(7466),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(7466),
    [sym_binary] = STATE(7466),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [4582] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4583] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4584] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4585] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_heredoc_body] = STATE(7467),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym_float] = ACTIONS(1155),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1159),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1159),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1167),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [sym_class_variable] = ACTIONS(1167),
    [sym__block_ampersand] = ACTIONS(3704),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1177),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [4586] = {
    [sym_heredoc_body] = STATE(7468),
    [aux_sym_call_repeat1] = STATE(7468),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4587] = {
    [sym_heredoc_body] = STATE(7469),
    [aux_sym_call_repeat1] = STATE(7469),
    [aux_sym_argument_list_repeat1] = STATE(7470),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7650),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4588] = {
    [aux_sym_chained_string_repeat1] = STATE(4588),
    [sym_string] = STATE(4588),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [4589] = {
    [aux_sym_undef_repeat1] = STATE(7471),
    [sym__line_break] = ACTIONS(1053),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
  },
  [4590] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4591] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [4592] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [4593] = {
    [sym_assignment] = STATE(7472),
    [sym_unary] = STATE(7472),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7472),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(7472),
    [sym_conditional] = STATE(7472),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(7472),
    [sym_binary] = STATE(7472),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [4594] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [4595] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(11683),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4596] = {
    [sym_assignment] = STATE(7475),
    [sym_unary] = STATE(7475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7475),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(7475),
    [sym_conditional] = STATE(7475),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(7475),
    [sym_binary] = STATE(7475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [4597] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11685),
    [sym_identifier] = ACTIONS(11685),
  },
  [4598] = {
    [anon_sym_COLON] = ACTIONS(11687),
    [sym_comment] = ACTIONS(49),
  },
  [4599] = {
    [sym__argument] = STATE(7483),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(7483),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(7483),
    [sym_hash_splat_argument] = STATE(7483),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(7486),
    [sym_block_argument] = STATE(7483),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [4600] = {
    [sym_assignment] = STATE(7495),
    [sym_unary] = STATE(7495),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7495),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(7495),
    [sym_conditional] = STATE(7495),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(7495),
    [sym_binary] = STATE(7495),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [4601] = {
    [sym_assignment] = STATE(7498),
    [sym_unary] = STATE(7498),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7498),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(7498),
    [sym_conditional] = STATE(7498),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(7498),
    [sym_binary] = STATE(7498),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [4602] = {
    [sym__argument] = STATE(7483),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(7483),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(7483),
    [sym_hash_splat_argument] = STATE(7483),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(7486),
    [sym_block_argument] = STATE(7483),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [4603] = {
    [sym__argument] = STATE(7483),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(7483),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(7483),
    [sym_hash_splat_argument] = STATE(7483),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(7486),
    [sym_block_argument] = STATE(7483),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [4604] = {
    [sym_assignment] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [4605] = {
    [sym__argument] = STATE(7483),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(7483),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(7483),
    [sym_hash_splat_argument] = STATE(7483),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(7486),
    [sym_block_argument] = STATE(7483),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [4606] = {
    [sym_heredoc_body] = STATE(7501),
    [aux_sym_call_repeat1] = STATE(7501),
    [aux_sym_argument_list_repeat1] = STATE(7502),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11715),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4607] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11717),
    [anon_sym_GT_GT_EQ] = ACTIONS(11717),
    [anon_sym_SLASH_EQ] = ACTIONS(11717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11717),
    [anon_sym_LT_LT_EQ] = ACTIONS(11717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11717),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(11717),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11719),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(11717),
    [anon_sym_PLUS_EQ] = ACTIONS(11717),
    [anon_sym_STAR_EQ] = ACTIONS(11717),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11717),
    [anon_sym_DASH_EQ] = ACTIONS(11717),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11717),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4608] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_EQ_GT] = ACTIONS(11687),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [4609] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(11747),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11749),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11751),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [4610] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym__primary] = STATE(4636),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_method] = STATE(4636),
    [sym_conditional] = STATE(7522),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_subshell] = STATE(4636),
    [sym_unless] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4640),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_call] = STATE(4638),
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_rational] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_lambda] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(7522),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_nil] = STATE(4640),
    [sym_symbol_array] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_scope_resolution] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4611] = {
    [anon_sym_EQ] = ACTIONS(11761),
    [sym_comment] = ACTIONS(3),
  },
  [4612] = {
    [aux_sym_chained_string_repeat1] = STATE(7525),
    [sym_string] = STATE(7525),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11763),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4613] = {
    [sym_heredoc_body] = STATE(7501),
    [aux_sym_call_repeat1] = STATE(7501),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4614] = {
    [sym_assignment] = STATE(7526),
    [sym_unary] = STATE(7526),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7526),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7526),
    [sym_conditional] = STATE(7526),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7526),
    [sym_binary] = STATE(7526),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4615] = {
    [sym_assignment] = STATE(7527),
    [sym_unary] = STATE(7527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7527),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7527),
    [sym_conditional] = STATE(7527),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7527),
    [sym_binary] = STATE(7527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4616] = {
    [sym_assignment] = STATE(7528),
    [sym_unary] = STATE(7528),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7528),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7528),
    [sym_conditional] = STATE(7528),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7528),
    [sym_binary] = STATE(7528),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4617] = {
    [aux_sym_heredoc_body_repeat1] = STATE(7530),
    [sym_interpolation] = STATE(7530),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(11765),
    [sym_heredoc_end] = ACTIONS(11767),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(11765),
  },
  [4618] = {
    [sym_assignment] = STATE(7531),
    [sym_unary] = STATE(7531),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7531),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7531),
    [sym_conditional] = STATE(7531),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7531),
    [sym_binary] = STATE(7531),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4619] = {
    [sym_assignment] = STATE(7532),
    [sym_unary] = STATE(7532),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7532),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7532),
    [sym_conditional] = STATE(7532),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7532),
    [sym_binary] = STATE(7532),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4620] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [4621] = {
    [sym_heredoc_body] = STATE(7537),
    [sym__argument_list_with_parens] = STATE(7536),
    [aux_sym_call_repeat1] = STATE(7537),
    [sym_argument_list_with_parens] = STATE(7535),
    [sym_operator] = STATE(7535),
    [anon_sym_LT] = ACTIONS(11769),
    [anon_sym_SLASH] = ACTIONS(11771),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11771),
    [anon_sym_PLUS_AT] = ACTIONS(11771),
    [anon_sym_LPAREN2] = ACTIONS(11773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11771),
    [anon_sym_GT_GT] = ACTIONS(11771),
    [anon_sym_EQ_TILDE] = ACTIONS(11771),
    [anon_sym_LT_LT] = ACTIONS(11771),
    [anon_sym_TILDE] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11769),
    [anon_sym_AMP] = ACTIONS(11771),
    [anon_sym_GT] = ACTIONS(11769),
    [anon_sym_PERCENT] = ACTIONS(11771),
    [anon_sym_DASH_AT] = ACTIONS(11771),
    [anon_sym_EQ_EQ] = ACTIONS(11769),
    [anon_sym_STAR] = ACTIONS(11769),
    [anon_sym_BANG_TILDE] = ACTIONS(11771),
    [sym_constant] = ACTIONS(11775),
    [anon_sym_DASH] = ACTIONS(11769),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11771),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11769),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11771),
    [anon_sym_STAR_STAR] = ACTIONS(11771),
    [anon_sym_PIPE] = ACTIONS(11771),
    [anon_sym_DOT_DOT] = ACTIONS(11771),
    [anon_sym_LT_EQ_GT] = ACTIONS(11771),
    [anon_sym_LT_EQ] = ACTIONS(11769),
    [anon_sym_BANG] = ACTIONS(11769),
    [sym_identifier] = ACTIONS(11775),
    [anon_sym_CARET] = ACTIONS(11771),
  },
  [4622] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11777),
    [sym_identifier] = ACTIONS(11777),
  },
  [4623] = {
    [sym_assignment] = STATE(7544),
    [sym_unary] = STATE(7544),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7544),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_splat_argument] = STATE(7546),
    [sym_operator_assignment] = STATE(7544),
    [sym_conditional] = STATE(7544),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_return] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_subshell] = STATE(2083),
    [sym__arg_or_splat_arg] = STATE(7546),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(7544),
    [sym_binary] = STATE(7544),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11783),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3716),
    [sym_character] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [4624] = {
    [sym_assignment] = STATE(7547),
    [sym_unary] = STATE(7547),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7547),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(7547),
    [sym_conditional] = STATE(7547),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(7547),
    [sym_binary] = STATE(7547),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [4625] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [4626] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(11793),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4627] = {
    [sym_assignment] = STATE(7550),
    [sym_unary] = STATE(7550),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7550),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(7550),
    [sym_conditional] = STATE(7550),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(7550),
    [sym_binary] = STATE(7550),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [4628] = {
    [anon_sym_COLON] = ACTIONS(11795),
    [sym_comment] = ACTIONS(49),
  },
  [4629] = {
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4630] = {
    [sym_assignment] = STATE(7560),
    [sym_unary] = STATE(7560),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(7560),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(7560),
    [sym_conditional] = STATE(7560),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(7560),
    [sym_binary] = STATE(7560),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [4631] = {
    [sym_assignment] = STATE(7565),
    [sym_unary] = STATE(7565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(7565),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(7565),
    [sym_conditional] = STATE(7565),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(7565),
    [sym_binary] = STATE(7565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [4632] = {
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4633] = {
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4634] = {
    [sym_assignment] = STATE(7566),
    [sym_unary] = STATE(7566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(7566),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(7566),
    [sym_conditional] = STATE(7566),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(7566),
    [sym_binary] = STATE(7566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [4635] = {
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4636] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(11747),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11749),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(11751),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [4637] = {
    [anon_sym_EQ] = ACTIONS(11823),
    [sym_comment] = ACTIONS(3),
  },
  [4638] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym__primary] = STATE(4636),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(7521),
    [sym_method] = STATE(4636),
    [sym_conditional] = STATE(7522),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_subshell] = STATE(4636),
    [sym_unless] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_block_argument] = STATE(7521),
    [sym_range] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4640),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_call] = STATE(4638),
    [sym__argument] = STATE(7521),
    [sym_assignment] = STATE(7522),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_pair] = STATE(7521),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7521),
    [sym_operator_assignment] = STATE(7522),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_rational] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_lambda] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(7524),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(7522),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_nil] = STATE(4640),
    [sym_symbol_array] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_scope_resolution] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(11757),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [4639] = {
    [sym_heredoc_body] = STATE(7569),
    [aux_sym_call_repeat1] = STATE(7569),
    [aux_sym_argument_list_repeat1] = STATE(7570),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4640] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11827),
    [anon_sym_GT_GT_EQ] = ACTIONS(11827),
    [anon_sym_SLASH_EQ] = ACTIONS(11827),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11827),
    [anon_sym_LT_LT_EQ] = ACTIONS(11827),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11827),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(11827),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11829),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(11827),
    [anon_sym_PLUS_EQ] = ACTIONS(11827),
    [anon_sym_STAR_EQ] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11827),
    [anon_sym_DASH_EQ] = ACTIONS(11827),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4641] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(11795),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [4642] = {
    [aux_sym_chained_string_repeat1] = STATE(7581),
    [sym_string] = STATE(7581),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11859),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4643] = {
    [sym_heredoc_body] = STATE(7569),
    [aux_sym_call_repeat1] = STATE(7569),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4644] = {
    [sym_assignment] = STATE(7582),
    [sym_unary] = STATE(7582),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7582),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7582),
    [sym_conditional] = STATE(7582),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7582),
    [sym_binary] = STATE(7582),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4645] = {
    [sym_assignment] = STATE(7583),
    [sym_unary] = STATE(7583),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7583),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7583),
    [sym_conditional] = STATE(7583),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4646] = {
    [sym_assignment] = STATE(7584),
    [sym_unary] = STATE(7584),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7584),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7584),
    [sym_conditional] = STATE(7584),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7584),
    [sym_binary] = STATE(7584),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4647] = {
    [sym_assignment] = STATE(7585),
    [sym_unary] = STATE(7585),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7585),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7585),
    [sym_conditional] = STATE(7585),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7585),
    [sym_binary] = STATE(7585),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4648] = {
    [sym_assignment] = STATE(7586),
    [sym_unary] = STATE(7586),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7586),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7586),
    [sym_conditional] = STATE(7586),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7586),
    [sym_binary] = STATE(7586),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4649] = {
    [sym_assignment] = STATE(7587),
    [sym_unary] = STATE(7587),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7587),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7587),
    [sym_conditional] = STATE(7587),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7587),
    [sym_binary] = STATE(7587),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4650] = {
    [sym_assignment] = STATE(7588),
    [sym_unary] = STATE(7588),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7588),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7588),
    [sym_conditional] = STATE(7588),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7588),
    [sym_binary] = STATE(7588),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4651] = {
    [sym_assignment] = STATE(7589),
    [sym_unary] = STATE(7589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7589),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7589),
    [sym_conditional] = STATE(7589),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7589),
    [sym_binary] = STATE(7589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4652] = {
    [sym_assignment] = STATE(7590),
    [sym_unary] = STATE(7590),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7590),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7590),
    [sym_conditional] = STATE(7590),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7590),
    [sym_binary] = STATE(7590),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4653] = {
    [sym_assignment] = STATE(7591),
    [sym_unary] = STATE(7591),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7591),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7591),
    [sym_conditional] = STATE(7591),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7591),
    [sym_binary] = STATE(7591),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4654] = {
    [sym_assignment] = STATE(7592),
    [sym_unary] = STATE(7592),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7592),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(7592),
    [sym_conditional] = STATE(7592),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(7592),
    [sym_binary] = STATE(7592),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4655] = {
    [aux_sym_chained_string_repeat1] = STATE(7593),
    [sym_string] = STATE(7593),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4656] = {
    [sym_heredoc_body] = STATE(4620),
    [sym__terminator] = STATE(4620),
    [sym__line_break] = ACTIONS(7694),
    [anon_sym_unless] = ACTIONS(7696),
    [anon_sym_until] = ACTIONS(7698),
    [anon_sym_while] = ACTIONS(7700),
    [sym__heredoc_body_start] = ACTIONS(7702),
    [anon_sym_rescue] = ACTIONS(7704),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(7694),
    [anon_sym_if] = ACTIONS(7706),
    [sym_comment] = ACTIONS(49),
  },
  [4657] = {
    [sym__statement] = STATE(7594),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(7594),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(7594),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(7594),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(4657),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(7594),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(7594),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(7594),
    [sym_if_modifier] = STATE(7594),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(7594),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(7594),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(4657),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_not] = ACTIONS(3252),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(11861),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [4658] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [4659] = {
    [anon_sym_elsif] = ACTIONS(11864),
    [anon_sym_rescue] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_ensure] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_when] = ACTIONS(11864),
    [sym_comment] = ACTIONS(49),
  },
  [4660] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [sym__line_break] = ACTIONS(11868),
    [anon_sym_then] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_when] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym___END__] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_end] = ACTIONS(11868),
    [anon_sym_ensure] = ACTIONS(11868),
    [anon_sym_else] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_elsif] = ACTIONS(11868),
    [ts_builtin_sym_end] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
    [sym__binary_minus] = ACTIONS(11868),
  },
  [4661] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5452),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [4662] = {
    [anon_sym_RPAREN] = ACTIONS(11870),
    [sym_comment] = ACTIONS(49),
  },
  [4663] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [4664] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [4665] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4666] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [4667] = {
    [sym_assignment] = STATE(7596),
    [sym_unary] = STATE(7596),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7596),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7596),
    [sym_conditional] = STATE(7596),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7596),
    [sym_binary] = STATE(7596),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4668] = {
    [sym_assignment] = STATE(2112),
    [sym_unary] = STATE(2112),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2112),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_splat_argument] = STATE(7597),
    [sym_operator_assignment] = STATE(2112),
    [sym_conditional] = STATE(2112),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_return] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_subshell] = STATE(84),
    [sym__arg_or_splat_arg] = STATE(7597),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(2112),
    [sym_binary] = STATE(2112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(147),
    [sym_character] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4669] = {
    [sym_assignment] = STATE(7598),
    [sym_unary] = STATE(7598),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7598),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7598),
    [sym_conditional] = STATE(7598),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7598),
    [sym_binary] = STATE(7598),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4670] = {
    [sym_assignment] = STATE(7599),
    [sym_unary] = STATE(7599),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7599),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7599),
    [sym_conditional] = STATE(7599),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7599),
    [sym_binary] = STATE(7599),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4671] = {
    [sym_assignment] = STATE(7601),
    [sym_unary] = STATE(7601),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7601),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7601),
    [sym_conditional] = STATE(7601),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7601),
    [sym_binary] = STATE(7601),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4672] = {
    [sym_assignment] = STATE(7602),
    [sym_unary] = STATE(7602),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7602),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7602),
    [sym_conditional] = STATE(7602),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7602),
    [sym_binary] = STATE(7602),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4673] = {
    [sym_assignment] = STATE(7603),
    [sym_unary] = STATE(7603),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7603),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7603),
    [sym_conditional] = STATE(7603),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7603),
    [sym_binary] = STATE(7603),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4674] = {
    [sym_assignment] = STATE(7604),
    [sym_unary] = STATE(7604),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7604),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7604),
    [sym_conditional] = STATE(7604),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7604),
    [sym_binary] = STATE(7604),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4675] = {
    [sym_assignment] = STATE(7605),
    [sym_unary] = STATE(7605),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7605),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7605),
    [sym_conditional] = STATE(7605),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7605),
    [sym_binary] = STATE(7605),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4676] = {
    [sym_assignment] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4677] = {
    [sym_assignment] = STATE(7607),
    [sym_unary] = STATE(7607),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7607),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(7607),
    [sym_conditional] = STATE(7607),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(7607),
    [sym_binary] = STATE(7607),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4678] = {
    [sym_assignment] = STATE(2112),
    [sym_unary] = STATE(2112),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(2112),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(2112),
    [sym_conditional] = STATE(2112),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_return] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_true] = STATE(2111),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(2112),
    [sym_binary] = STATE(2112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(147),
    [sym_character] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [4679] = {
    [aux_sym_exceptions_repeat1] = STATE(7608),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(7830),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [4680] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [4681] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [4682] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4683] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [4684] = {
    [sym_assignment] = STATE(7609),
    [sym_unary] = STATE(7609),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7609),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7609),
    [sym_conditional] = STATE(7609),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7609),
    [sym_binary] = STATE(7609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4685] = {
    [sym_assignment] = STATE(7610),
    [sym_unary] = STATE(7610),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7610),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_splat_argument] = STATE(7611),
    [sym_operator_assignment] = STATE(7610),
    [sym_conditional] = STATE(7610),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_return] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_subshell] = STATE(2129),
    [sym__arg_or_splat_arg] = STATE(7611),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7610),
    [sym_binary] = STATE(7610),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [sym_global_variable] = ACTIONS(3802),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3794),
    [sym_character] = ACTIONS(3798),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4686] = {
    [sym_assignment] = STATE(7612),
    [sym_unary] = STATE(7612),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7612),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7612),
    [sym_conditional] = STATE(7612),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7612),
    [sym_binary] = STATE(7612),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4687] = {
    [sym_assignment] = STATE(7613),
    [sym_unary] = STATE(7613),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7613),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7613),
    [sym_conditional] = STATE(7613),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7613),
    [sym_binary] = STATE(7613),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4688] = {
    [sym_assignment] = STATE(7615),
    [sym_unary] = STATE(7615),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7615),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7615),
    [sym_conditional] = STATE(7615),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7615),
    [sym_binary] = STATE(7615),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4689] = {
    [sym_assignment] = STATE(7616),
    [sym_unary] = STATE(7616),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7616),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7616),
    [sym_conditional] = STATE(7616),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7616),
    [sym_binary] = STATE(7616),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4690] = {
    [sym_assignment] = STATE(7617),
    [sym_unary] = STATE(7617),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7617),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7617),
    [sym_conditional] = STATE(7617),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7617),
    [sym_binary] = STATE(7617),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4691] = {
    [sym_assignment] = STATE(7618),
    [sym_unary] = STATE(7618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7618),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7618),
    [sym_conditional] = STATE(7618),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7618),
    [sym_binary] = STATE(7618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4692] = {
    [sym_assignment] = STATE(7619),
    [sym_unary] = STATE(7619),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7619),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7619),
    [sym_conditional] = STATE(7619),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7619),
    [sym_binary] = STATE(7619),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4693] = {
    [sym_assignment] = STATE(7620),
    [sym_unary] = STATE(7620),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7620),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7620),
    [sym_conditional] = STATE(7620),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7620),
    [sym_binary] = STATE(7620),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4694] = {
    [sym_assignment] = STATE(7621),
    [sym_unary] = STATE(7621),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7621),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(7621),
    [sym_conditional] = STATE(7621),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7621),
    [sym_binary] = STATE(7621),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [4695] = {
    [aux_sym_chained_string_repeat1] = STATE(7622),
    [sym_string] = STATE(7622),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [4696] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4697] = {
    [aux_sym_exceptions_repeat1] = STATE(7624),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [4698] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(618),
    [sym_unary] = STATE(618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(618),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(618),
    [sym_conditional] = STATE(618),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(619),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(618),
    [sym_binary] = STATE(618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym_float] = ACTIONS(1155),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1159),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1159),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(1171),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1173),
    [sym_class_variable] = ACTIONS(1167),
    [sym__block_ampersand] = ACTIONS(1175),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1177),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(7866),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [4699] = {
    [sym_heredoc_body] = STATE(4699),
    [aux_sym_call_repeat1] = STATE(4699),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [4700] = {
    [sym_heredoc_body] = STATE(4699),
    [aux_sym_call_repeat1] = STATE(4699),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [4701] = {
    [aux_sym_argument_list_repeat1] = STATE(4701),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(11872),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [4702] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4703] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4704] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4705] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(11875),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4706] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4707] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4708] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4709] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [4710] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4711] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4712] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [4713] = {
    [aux_sym_chained_string_repeat1] = STATE(4713),
    [sym_string] = STATE(4713),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [4714] = {
    [sym_assignment] = STATE(7626),
    [sym_unary] = STATE(7626),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7626),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(7626),
    [sym_conditional] = STATE(7626),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(85),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(87),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_range] = STATE(7626),
    [sym_binary] = STATE(7626),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(87),
    [sym_nil] = STATE(87),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(161),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_not] = ACTIONS(163),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [4715] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [sym__line_break] = ACTIONS(11879),
    [anon_sym_then] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_when] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym___END__] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_end] = ACTIONS(11879),
    [anon_sym_ensure] = ACTIONS(11879),
    [anon_sym_else] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_elsif] = ACTIONS(11879),
    [ts_builtin_sym_end] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
    [sym__binary_minus] = ACTIONS(11879),
  },
  [4716] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(11881),
  },
  [4717] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7629),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11883),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4718] = {
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_unless] = ACTIONS(3496),
    [anon_sym_until] = ACTIONS(3496),
    [anon_sym_while] = ACTIONS(3496),
    [anon_sym_rescue] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3496),
    [anon_sym_if] = ACTIONS(3496),
    [sym_comment] = ACTIONS(49),
  },
  [4719] = {
    [sym__method_name] = STATE(7630),
    [sym_setter] = STATE(7630),
    [sym_symbol] = STATE(7630),
    [sym_operator] = STATE(7630),
    [anon_sym_LT] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(3862),
    [sym_class_variable] = ACTIONS(11885),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3862),
    [anon_sym_PLUS_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3862),
    [anon_sym_GT_GT] = ACTIONS(3862),
    [anon_sym_EQ_TILDE] = ACTIONS(3862),
    [anon_sym_LT_LT] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3862),
    [sym_global_variable] = ACTIONS(11885),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_AMP] = ACTIONS(3862),
    [anon_sym_GT] = ACTIONS(3860),
    [anon_sym_PERCENT] = ACTIONS(3862),
    [sym__simple_symbol] = ACTIONS(433),
    [anon_sym_DASH_AT] = ACTIONS(3862),
    [anon_sym_EQ_EQ] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_BANG_TILDE] = ACTIONS(3862),
    [sym_constant] = ACTIONS(11885),
    [anon_sym_DASH] = ACTIONS(3860),
    [sym_instance_variable] = ACTIONS(11885),
    [anon_sym_GT_EQ] = ACTIONS(3862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3860),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(3862),
    [anon_sym_STAR_STAR] = ACTIONS(3862),
    [anon_sym_PIPE] = ACTIONS(3862),
    [anon_sym_DOT_DOT] = ACTIONS(3862),
    [anon_sym_LT_EQ_GT] = ACTIONS(3862),
    [anon_sym_LT_EQ] = ACTIONS(3860),
    [anon_sym_BANG] = ACTIONS(3860),
    [sym_identifier] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3862),
    [sym__symbol_start] = ACTIONS(461),
  },
  [4720] = {
    [aux_sym_undef_repeat1] = STATE(7631),
    [anon_sym_RBRACE] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(7886),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [4721] = {
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
  },
  [4722] = {
    [anon_sym_RBRACE] = ACTIONS(11887),
    [sym_comment] = ACTIONS(49),
  },
  [4723] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(7634),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11889),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [4724] = {
    [sym_else] = STATE(7634),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(11891),
    [sym_comment] = ACTIONS(49),
  },
  [4725] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_COLON2] = ACTIONS(3850),
    [anon_sym_while] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
    [sym__binary_minus] = ACTIONS(3852),
  },
  [4726] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(11893),
  },
  [4727] = {
    [aux_sym_symbol_array_repeat1] = STATE(7638),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11895),
    [sym__string_end] = ACTIONS(11897),
  },
  [4728] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(11899),
  },
  [4729] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_COLON2] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [sym__binary_minus] = ACTIONS(4056),
  },
  [4730] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(11901),
    [sym__string_end] = ACTIONS(11899),
  },
  [4731] = {
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_rescue] = ACTIONS(4072),
    [anon_sym_unless] = ACTIONS(4072),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(4072),
    [anon_sym_if] = ACTIONS(4072),
    [anon_sym_while] = ACTIONS(4072),
  },
  [4732] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_COLON2] = ACTIONS(4424),
    [anon_sym_while] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [sym__binary_minus] = ACTIONS(4426),
  },
  [4733] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_COLON2] = ACTIONS(4698),
    [anon_sym_while] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
    [sym__binary_minus] = ACTIONS(4700),
  },
  [4734] = {
    [anon_sym_RBRACE] = ACTIONS(11903),
    [sym_comment] = ACTIONS(49),
  },
  [4735] = {
    [anon_sym_RBRACE] = ACTIONS(4758),
    [anon_sym_rescue] = ACTIONS(4758),
    [anon_sym_unless] = ACTIONS(4758),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(4758),
    [anon_sym_if] = ACTIONS(4758),
    [anon_sym_while] = ACTIONS(4758),
  },
  [4736] = {
    [anon_sym_RBRACE] = ACTIONS(11905),
    [sym_comment] = ACTIONS(49),
  },
  [4737] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7644),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11907),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4738] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_while] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
    [sym__binary_minus] = ACTIONS(4768),
  },
  [4739] = {
    [sym__terminator] = STATE(7645),
    [sym_heredoc_body] = STATE(7645),
    [sym__do] = STATE(7645),
    [anon_sym_do] = ACTIONS(11909),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(11909),
    [anon_sym_SEMI] = ACTIONS(11909),
    [sym_comment] = ACTIONS(49),
  },
  [4740] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_while] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
  },
  [4741] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(7647),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(7647),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7648),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(11911),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(11911),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11913),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4742] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(7649),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7648),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11913),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4743] = {
    [anon_sym_end] = ACTIONS(11915),
    [sym_comment] = ACTIONS(49),
  },
  [4744] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
  },
  [4745] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(7651),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(11917),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [4746] = {
    [anon_sym_RBRACE] = ACTIONS(11917),
    [sym_comment] = ACTIONS(49),
  },
  [4747] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_COLON2] = ACTIONS(5236),
    [anon_sym_while] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [sym__binary_minus] = ACTIONS(5238),
  },
  [4748] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(11919),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [4749] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7653),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(11921),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4750] = {
    [sym__method_name] = STATE(2195),
    [sym_setter] = STATE(2195),
    [sym_symbol] = STATE(2195),
    [sym_operator] = STATE(2195),
    [sym__method_rest] = STATE(7654),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(11923),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(11923),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(11923),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(11923),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [4751] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [4752] = {
    [aux_sym_chained_string_repeat1] = STATE(4810),
    [sym_string] = STATE(4810),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4753] = {
    [sym_assignment] = STATE(7655),
    [sym_unary] = STATE(7655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(7655),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(7655),
    [sym_conditional] = STATE(7655),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(7655),
    [sym_binary] = STATE(7655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [4754] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [4755] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [4756] = {
    [sym_assignment] = STATE(7656),
    [sym_unary] = STATE(7656),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(7656),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(7656),
    [sym_conditional] = STATE(7656),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(7656),
    [sym_binary] = STATE(7656),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [4757] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(11925),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4758] = {
    [anon_sym_COLON] = ACTIONS(11927),
    [sym_comment] = ACTIONS(49),
  },
  [4759] = {
    [sym_assignment] = STATE(7659),
    [sym_unary] = STATE(7659),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7659),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7659),
    [sym_conditional] = STATE(7659),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7659),
    [sym_binary] = STATE(7659),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4760] = {
    [sym_assignment] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4761] = {
    [sym_assignment] = STATE(7661),
    [sym_unary] = STATE(7661),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7661),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7661),
    [sym_conditional] = STATE(7661),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7661),
    [sym_binary] = STATE(7661),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4762] = {
    [sym_heredoc_body] = STATE(7663),
    [aux_sym_call_repeat1] = STATE(7663),
    [aux_sym_argument_list_repeat1] = STATE(7664),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11929),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4763] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [4764] = {
    [aux_sym_chained_string_repeat1] = STATE(4810),
    [sym_string] = STATE(4810),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11931),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4765] = {
    [sym_heredoc_body] = STATE(7663),
    [aux_sym_call_repeat1] = STATE(7663),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [4766] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(753),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4767] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(647),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4768] = {
    [sym_assignment] = STATE(7667),
    [sym_unary] = STATE(7667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(7667),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(7667),
    [sym_conditional] = STATE(7667),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(7667),
    [sym_binary] = STATE(7667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [4769] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [4770] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(737),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4771] = {
    [sym_assignment] = STATE(7668),
    [sym_unary] = STATE(7668),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(7668),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(7668),
    [sym_conditional] = STATE(7668),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(7668),
    [sym_binary] = STATE(7668),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [4772] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11933),
    [sym_identifier] = ACTIONS(11933),
  },
  [4773] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(501),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4774] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(11935),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(11937),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(11937),
    [anon_sym_SLASH_EQ] = ACTIONS(11937),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11937),
    [anon_sym_PIPE_EQ] = ACTIONS(11937),
    [anon_sym_LT_LT_EQ] = ACTIONS(11937),
    [anon_sym_PLUS_EQ] = ACTIONS(11937),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11937),
    [anon_sym_STAR_EQ] = ACTIONS(11937),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11937),
    [anon_sym_CARET_EQ] = ACTIONS(11937),
    [anon_sym_DASH_EQ] = ACTIONS(11937),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11937),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4775] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [4776] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(11965),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11967),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11969),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [4777] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym__primary] = STATE(2276),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_method] = STATE(2276),
    [sym_conditional] = STATE(2282),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_subshell] = STATE(2276),
    [sym_unless] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2281),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_call] = STATE(2279),
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_rational] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_lambda] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2282),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_nil] = STATE(2281),
    [sym_symbol_array] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_scope_resolution] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4778] = {
    [anon_sym_EQ] = ACTIONS(11971),
    [sym_comment] = ACTIONS(3),
  },
  [4779] = {
    [aux_sym_chained_string_repeat1] = STATE(7683),
    [sym_string] = STATE(7683),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4780] = {
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
  },
  [4781] = {
    [anon_sym_RPAREN] = ACTIONS(11973),
    [sym_comment] = ACTIONS(49),
  },
  [4782] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [4783] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [4784] = {
    [aux_sym_heredoc_body_repeat1] = STATE(7686),
    [sym_interpolation] = STATE(7686),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(11975),
    [sym_heredoc_end] = ACTIONS(11977),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(11975),
  },
  [4785] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_heredoc_body] = STATE(7688),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym_float] = ACTIONS(3894),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(3898),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(3906),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(3918),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(11979),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4786] = {
    [sym_heredoc_body] = STATE(7689),
    [aux_sym_call_repeat1] = STATE(7689),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4787] = {
    [sym_heredoc_body] = STATE(7690),
    [aux_sym_call_repeat1] = STATE(7690),
    [aux_sym_argument_list_repeat1] = STATE(7691),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [4788] = {
    [sym_assignment] = STATE(7692),
    [sym_unary] = STATE(7692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7692),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7692),
    [sym_conditional] = STATE(7692),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7692),
    [sym_binary] = STATE(7692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4789] = {
    [sym_assignment] = STATE(7693),
    [sym_unary] = STATE(7693),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7693),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7694),
    [sym_operator_assignment] = STATE(7693),
    [sym_conditional] = STATE(7693),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_subshell] = STATE(2215),
    [sym__arg_or_splat_arg] = STATE(7694),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7693),
    [sym_binary] = STATE(7693),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(3898),
    [sym_character] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4790] = {
    [sym_assignment] = STATE(7695),
    [sym_unary] = STATE(7695),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7695),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7695),
    [sym_conditional] = STATE(7695),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7695),
    [sym_binary] = STATE(7695),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4791] = {
    [sym_assignment] = STATE(7696),
    [sym_unary] = STATE(7696),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7696),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7696),
    [sym_conditional] = STATE(7696),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7696),
    [sym_binary] = STATE(7696),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4792] = {
    [sym_assignment] = STATE(7697),
    [sym_unary] = STATE(7697),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7697),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7697),
    [sym_conditional] = STATE(7697),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7697),
    [sym_binary] = STATE(7697),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4793] = {
    [sym_assignment] = STATE(7698),
    [sym_unary] = STATE(7698),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7698),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7698),
    [sym_conditional] = STATE(7698),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7698),
    [sym_binary] = STATE(7698),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4794] = {
    [sym_assignment] = STATE(7699),
    [sym_unary] = STATE(7699),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7699),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7699),
    [sym_conditional] = STATE(7699),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7699),
    [sym_binary] = STATE(7699),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4795] = {
    [sym_assignment] = STATE(7700),
    [sym_unary] = STATE(7700),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7700),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7700),
    [sym_conditional] = STATE(7700),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7700),
    [sym_binary] = STATE(7700),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4796] = {
    [sym_assignment] = STATE(7702),
    [sym_unary] = STATE(7702),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7702),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7702),
    [sym_conditional] = STATE(7702),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7702),
    [sym_binary] = STATE(7702),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4797] = {
    [sym_assignment] = STATE(7703),
    [sym_unary] = STATE(7703),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7703),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7703),
    [sym_conditional] = STATE(7703),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7703),
    [sym_binary] = STATE(7703),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4798] = {
    [sym_assignment] = STATE(7704),
    [sym_unary] = STATE(7704),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7704),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(7704),
    [sym_conditional] = STATE(7704),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7704),
    [sym_binary] = STATE(7704),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [4799] = {
    [sym_heredoc_body] = STATE(7709),
    [sym__argument_list_with_parens] = STATE(7708),
    [aux_sym_call_repeat1] = STATE(7709),
    [sym_argument_list_with_parens] = STATE(7707),
    [sym_operator] = STATE(7707),
    [anon_sym_LT] = ACTIONS(11981),
    [anon_sym_SLASH] = ACTIONS(11983),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11983),
    [anon_sym_PLUS_AT] = ACTIONS(11983),
    [anon_sym_LPAREN2] = ACTIONS(11985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11983),
    [anon_sym_GT_GT] = ACTIONS(11983),
    [anon_sym_EQ_TILDE] = ACTIONS(11983),
    [anon_sym_LT_LT] = ACTIONS(11983),
    [anon_sym_TILDE] = ACTIONS(11983),
    [anon_sym_PLUS] = ACTIONS(11981),
    [anon_sym_AMP] = ACTIONS(11983),
    [anon_sym_GT] = ACTIONS(11981),
    [anon_sym_PERCENT] = ACTIONS(11983),
    [anon_sym_DASH_AT] = ACTIONS(11983),
    [anon_sym_EQ_EQ] = ACTIONS(11981),
    [anon_sym_STAR] = ACTIONS(11981),
    [anon_sym_BANG_TILDE] = ACTIONS(11983),
    [sym_constant] = ACTIONS(11987),
    [anon_sym_DASH] = ACTIONS(11981),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11983),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11981),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11983),
    [anon_sym_STAR_STAR] = ACTIONS(11983),
    [anon_sym_PIPE] = ACTIONS(11983),
    [anon_sym_DOT_DOT] = ACTIONS(11983),
    [anon_sym_LT_EQ_GT] = ACTIONS(11983),
    [anon_sym_LT_EQ] = ACTIONS(11981),
    [anon_sym_BANG] = ACTIONS(11981),
    [sym_identifier] = ACTIONS(11987),
    [anon_sym_CARET] = ACTIONS(11983),
  },
  [4800] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(11989),
    [sym_identifier] = ACTIONS(11989),
  },
  [4801] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(11991),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [4802] = {
    [anon_sym_COLON] = ACTIONS(11993),
    [sym_comment] = ACTIONS(49),
  },
  [4803] = {
    [sym_assignment] = STATE(7713),
    [sym_unary] = STATE(7713),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7713),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7713),
    [sym_conditional] = STATE(7713),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7713),
    [sym_binary] = STATE(7713),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4804] = {
    [sym_assignment] = STATE(7714),
    [sym_unary] = STATE(7714),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7714),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7714),
    [sym_conditional] = STATE(7714),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7714),
    [sym_binary] = STATE(7714),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4805] = {
    [sym_assignment] = STATE(7715),
    [sym_unary] = STATE(7715),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7715),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7715),
    [sym_conditional] = STATE(7715),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7715),
    [sym_binary] = STATE(7715),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4806] = {
    [sym_heredoc_body] = STATE(7717),
    [aux_sym_call_repeat1] = STATE(7717),
    [aux_sym_argument_list_repeat1] = STATE(7718),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11995),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4807] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [4808] = {
    [aux_sym_chained_string_repeat1] = STATE(4933),
    [sym_string] = STATE(4933),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(11997),
    [sym__string_start] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4809] = {
    [sym_heredoc_body] = STATE(7717),
    [aux_sym_call_repeat1] = STATE(7717),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [4810] = {
    [aux_sym_chained_string_repeat1] = STATE(7719),
    [sym_string] = STATE(7719),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [4811] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_COLON2] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [sym__binary_minus] = ACTIONS(5628),
  },
  [4812] = {
    [sym_when] = STATE(7722),
    [sym_else] = STATE(7721),
    [aux_sym_case_repeat2] = STATE(7722),
    [aux_sym_case_repeat1] = STATE(7723),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11999),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(12001),
    [sym_comment] = ACTIONS(49),
  },
  [4813] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_while] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [sym__binary_minus] = ACTIONS(5746),
  },
  [4814] = {
    [anon_sym_end] = ACTIONS(11999),
    [sym_comment] = ACTIONS(49),
  },
  [4815] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(7721),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11999),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [4816] = {
    [sym_when] = STATE(7722),
    [sym_else] = STATE(7721),
    [aux_sym_case_repeat2] = STATE(7722),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(11999),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [4817] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_COLON2] = ACTIONS(5972),
    [anon_sym_while] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
    [sym__binary_minus] = ACTIONS(5974),
  },
  [4818] = {
    [sym_heredoc_body] = STATE(7724),
    [sym__terminator] = STATE(7724),
    [sym__line_break] = ACTIONS(12003),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(12003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [4819] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7725),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12005),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4820] = {
    [sym_heredoc_body] = STATE(7726),
    [sym__terminator] = STATE(7726),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(12007),
    [anon_sym_SEMI] = ACTIONS(12007),
    [sym_comment] = ACTIONS(49),
  },
  [4821] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_COLON2] = ACTIONS(6071),
    [anon_sym_while] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
    [sym__binary_minus] = ACTIONS(6073),
  },
  [4822] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_COLON2] = ACTIONS(6075),
    [anon_sym_while] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
    [sym__binary_minus] = ACTIONS(6077),
  },
  [4823] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7727),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12009),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4824] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_COLON2] = ACTIONS(6443),
    [anon_sym_while] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
    [sym__binary_minus] = ACTIONS(6445),
  },
  [4825] = {
    [anon_sym_end] = ACTIONS(12011),
    [sym_comment] = ACTIONS(49),
  },
  [4826] = {
    [sym_ensure] = STATE(7729),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12011),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [4827] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_COLON2] = ACTIONS(6471),
    [anon_sym_while] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
    [sym__binary_minus] = ACTIONS(6473),
  },
  [4828] = {
    [sym_ensure] = STATE(7729),
    [sym_else] = STATE(7730),
    [anon_sym_end] = ACTIONS(12011),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [4829] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_COLON2] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [sym__binary_minus] = ACTIONS(6632),
  },
  [4830] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(7732),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(7732),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12013),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [4831] = {
    [sym_elsif] = STATE(7732),
    [sym_else] = STATE(7732),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12015),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [4832] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_COLON2] = ACTIONS(6680),
    [anon_sym_while] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
    [sym__binary_minus] = ACTIONS(6682),
  },
  [4833] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(12017),
  },
  [4834] = {
    [aux_sym_string_array_repeat1] = STATE(7736),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12019),
    [sym__string_end] = ACTIONS(12021),
  },
  [4835] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12023),
  },
  [4836] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_COLON2] = ACTIONS(6692),
    [anon_sym_while] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
    [sym__binary_minus] = ACTIONS(6694),
  },
  [4837] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12025),
    [sym__string_end] = ACTIONS(12023),
  },
  [4838] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6706),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [4839] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6698),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [4840] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6700),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [4841] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6708),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [4842] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6702),
    [anon_sym_or] = ACTIONS(4036),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_PIPE] = ACTIONS(4048),
    [sym__binary_minus] = ACTIONS(4038),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(4050),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
  },
  [4843] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [4844] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(7740),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12027),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [4845] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [4846] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [4847] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(4846),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(7741),
    [sym_operator] = STATE(7741),
    [anon_sym_LT] = ACTIONS(8062),
    [anon_sym_SLASH] = ACTIONS(8064),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8064),
    [anon_sym_PLUS_AT] = ACTIONS(8064),
    [anon_sym_LPAREN2] = ACTIONS(8066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8064),
    [anon_sym_GT_GT] = ACTIONS(8064),
    [anon_sym_EQ_TILDE] = ACTIONS(8064),
    [anon_sym_LT_LT] = ACTIONS(8064),
    [anon_sym_TILDE] = ACTIONS(8064),
    [anon_sym_PLUS] = ACTIONS(8062),
    [anon_sym_AMP] = ACTIONS(8064),
    [anon_sym_GT] = ACTIONS(8062),
    [anon_sym_PERCENT] = ACTIONS(8064),
    [anon_sym_DASH_AT] = ACTIONS(8064),
    [anon_sym_EQ_EQ] = ACTIONS(8062),
    [anon_sym_STAR] = ACTIONS(8062),
    [anon_sym_BANG_TILDE] = ACTIONS(8064),
    [sym_constant] = ACTIONS(12029),
    [anon_sym_DASH] = ACTIONS(8062),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8064),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8062),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8064),
    [anon_sym_STAR_STAR] = ACTIONS(8064),
    [anon_sym_PIPE] = ACTIONS(8064),
    [anon_sym_DOT_DOT] = ACTIONS(8064),
    [anon_sym_LT_EQ_GT] = ACTIONS(8064),
    [anon_sym_LT_EQ] = ACTIONS(8062),
    [anon_sym_BANG] = ACTIONS(8062),
    [sym_identifier] = ACTIONS(12029),
    [anon_sym_CARET] = ACTIONS(8064),
  },
  [4848] = {
    [anon_sym_SLASH] = ACTIONS(6733),
    [anon_sym_until] = ACTIONS(6735),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [anon_sym_RBRACE] = ACTIONS(6735),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_unless] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_rescue] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_LBRACE] = ACTIONS(6735),
    [anon_sym_COLON2] = ACTIONS(6733),
    [anon_sym_while] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [anon_sym_if] = ACTIONS(6735),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [4849] = {
    [anon_sym_RBRACK] = ACTIONS(12031),
    [sym_comment] = ACTIONS(49),
  },
  [4850] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [4851] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(753),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(753),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4852] = {
    [sym_assignment] = STATE(7743),
    [sym_unary] = STATE(7743),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(7743),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(7743),
    [sym_conditional] = STATE(7743),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(7743),
    [sym_binary] = STATE(7743),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [4853] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(647),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(647),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4854] = {
    [sym_assignment] = STATE(7744),
    [sym_unary] = STATE(7744),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(7744),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(7744),
    [sym_conditional] = STATE(7744),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(7744),
    [sym_binary] = STATE(7744),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [4855] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [4856] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(737),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(737),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4857] = {
    [sym_assignment] = STATE(7745),
    [sym_unary] = STATE(7745),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(7745),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(7745),
    [sym_conditional] = STATE(7745),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(7745),
    [sym_binary] = STATE(7745),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [4858] = {
    [sym__argument] = STATE(7665),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7665),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7665),
    [sym_hash_splat_argument] = STATE(7665),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym__argument_list_with_parens] = STATE(7666),
    [sym_block_argument] = STATE(7665),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(3894),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_until] = ACTIONS(501),
    [sym_self] = ACTIONS(3898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(3918),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(3930),
  },
  [4859] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [4860] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12033),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12035),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(12035),
    [anon_sym_SLASH_EQ] = ACTIONS(12035),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12035),
    [anon_sym_PIPE_EQ] = ACTIONS(12035),
    [anon_sym_LT_LT_EQ] = ACTIONS(12035),
    [anon_sym_PLUS_EQ] = ACTIONS(12035),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12035),
    [anon_sym_STAR_EQ] = ACTIONS(12035),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12035),
    [anon_sym_CARET_EQ] = ACTIONS(12035),
    [anon_sym_DASH_EQ] = ACTIONS(12035),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12035),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4861] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [4862] = {
    [anon_sym_EQ] = ACTIONS(12063),
    [sym_comment] = ACTIONS(3),
  },
  [4863] = {
    [aux_sym_chained_string_repeat1] = STATE(7757),
    [sym_string] = STATE(7757),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [4864] = {
    [aux_sym_exceptions_repeat1] = STATE(7759),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(12065),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [4865] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [4866] = {
    [aux_sym_chained_string_repeat1] = STATE(4933),
    [sym_string] = STATE(4933),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4867] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [4868] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(7761),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12067),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [4869] = {
    [anon_sym_RBRACE] = ACTIONS(12067),
    [sym_comment] = ACTIONS(49),
  },
  [4870] = {
    [sym_assignment] = STATE(7762),
    [sym_unary] = STATE(7762),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(7762),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(7762),
    [sym_conditional] = STATE(7762),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(7762),
    [sym_binary] = STATE(7762),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [4871] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [4872] = {
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_while] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [4873] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(7764),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(7764),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7765),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12069),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4874] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(7766),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7765),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4875] = {
    [anon_sym_end] = ACTIONS(12073),
    [sym_comment] = ACTIONS(49),
  },
  [4876] = {
    [sym_assignment] = STATE(7767),
    [sym_unary] = STATE(7767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(7767),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(7767),
    [sym_conditional] = STATE(7767),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(7767),
    [sym_binary] = STATE(7767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [4877] = {
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4878] = {
    [sym_assignment] = STATE(7769),
    [sym_unary] = STATE(7769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7769),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(7769),
    [sym_conditional] = STATE(7769),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(7769),
    [sym_binary] = STATE(7769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [4879] = {
    [sym_assignment] = STATE(7770),
    [sym_unary] = STATE(7770),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7770),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(7770),
    [sym_conditional] = STATE(7770),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_heredoc_body] = STATE(7771),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(7770),
    [sym_binary] = STATE(7770),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__terminator] = STATE(7771),
    [sym__line_break] = ACTIONS(12075),
    [sym_float] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(7),
    [sym_self] = ACTIONS(583),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [sym_complex] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(583),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym_constant] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(593),
    [sym_class_variable] = ACTIONS(589),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(595),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12075),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [sym_retry] = ACTIONS(101),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [4880] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(7774),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12077),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12079),
  },
  [4881] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(7776),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(12081),
  },
  [4882] = {
    [sym__statement] = STATE(336),
    [sym_unary] = STATE(343),
    [sym_rest_assignment] = STATE(337),
    [sym_undef] = STATE(336),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_unless_modifier] = STATE(336),
    [sym_symbol] = STATE(338),
    [sym_for] = STATE(338),
    [sym_if] = STATE(338),
    [sym__primary] = STATE(338),
    [sym_method] = STATE(338),
    [sym_conditional] = STATE(343),
    [sym_left_assignment_list] = STATE(339),
    [sym_return] = STATE(338),
    [sym_true] = STATE(342),
    [sym_while_modifier] = STATE(336),
    [sym_subshell] = STATE(338),
    [sym_unless] = STATE(338),
    [sym_empty_statement] = STATE(346),
    [sym_parenthesized_statements] = STATE(338),
    [sym_begin_block] = STATE(336),
    [sym_range] = STATE(343),
    [sym__mlhs] = STATE(340),
    [sym_false] = STATE(342),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_array] = STATE(338),
    [sym_call] = STATE(341),
    [sym_end_block] = STATE(336),
    [sym_assignment] = STATE(343),
    [sym__lhs] = STATE(342),
    [sym_singleton_class] = STATE(338),
    [sym_alias] = STATE(336),
    [sym_if_modifier] = STATE(336),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(343),
    [sym_method_call] = STATE(342),
    [sym_operator_assignment] = STATE(343),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_rational] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_until_modifier] = STATE(336),
    [sym_lambda] = STATE(338),
    [sym_element_reference] = STATE(342),
    [sym__statements] = STATE(7778),
    [sym_binary] = STATE(343),
    [sym_destructured_left_assignment] = STATE(337),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_nil] = STATE(342),
    [sym_rescue_modifier] = STATE(336),
    [sym_symbol_array] = STATE(338),
    [sym_case] = STATE(338),
    [sym_hash] = STATE(338),
    [aux_sym__statements_repeat1] = STATE(346),
    [sym_scope_resolution] = STATE(341),
    [sym_float] = ACTIONS(609),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(611),
    [sym_self] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(12083),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(613),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(623),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_yield] = ACTIONS(629),
    [sym_class_variable] = ACTIONS(623),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(631),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(637),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [sym_retry] = ACTIONS(609),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [4883] = {
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4884] = {
    [sym__statement] = STATE(7780),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(7780),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(7780),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(7780),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(7780),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(7780),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(7780),
    [sym_if_modifier] = STATE(7780),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(7780),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(7780),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [4885] = {
    [sym__lhs] = STATE(352),
    [sym_singleton_class] = STATE(352),
    [sym_module] = STATE(352),
    [sym_chained_string] = STATE(352),
    [sym_until] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_for] = STATE(352),
    [sym_symbol] = STATE(352),
    [sym_if] = STATE(352),
    [sym_begin] = STATE(352),
    [sym__primary] = STATE(352),
    [sym_method_call] = STATE(352),
    [sym_method] = STATE(352),
    [sym_singleton_method] = STATE(352),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(352),
    [sym_true] = STATE(352),
    [sym_return] = STATE(352),
    [sym_subshell] = STATE(352),
    [sym_yield] = STATE(352),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(352),
    [sym_lambda] = STATE(352),
    [sym_parenthesized_statements] = STATE(352),
    [sym_element_reference] = STATE(352),
    [sym_class] = STATE(352),
    [sym_break] = STATE(352),
    [sym_next] = STATE(352),
    [sym_string_array] = STATE(352),
    [sym_while] = STATE(352),
    [sym_case] = STATE(352),
    [sym_symbol_array] = STATE(352),
    [sym_array] = STATE(352),
    [sym_hash] = STATE(352),
    [sym_false] = STATE(352),
    [sym_nil] = STATE(352),
    [sym_scope_resolution] = STATE(7783),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(649),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(655),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(437),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(12085),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(649),
    [sym_constant] = ACTIONS(12087),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(663),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [4886] = {
    [sym__lhs] = STATE(359),
    [sym_singleton_class] = STATE(359),
    [sym_module] = STATE(359),
    [sym_chained_string] = STATE(359),
    [sym_until] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_for] = STATE(359),
    [sym_symbol] = STATE(359),
    [sym_if] = STATE(359),
    [sym_begin] = STATE(359),
    [sym__primary] = STATE(359),
    [sym_method_call] = STATE(359),
    [sym_method] = STATE(359),
    [sym_singleton_method] = STATE(359),
    [sym__variable] = STATE(353),
    [sym_rational] = STATE(359),
    [sym_true] = STATE(359),
    [sym_return] = STATE(359),
    [sym_subshell] = STATE(359),
    [sym_yield] = STATE(359),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(359),
    [sym_lambda] = STATE(359),
    [sym_parenthesized_statements] = STATE(359),
    [sym_element_reference] = STATE(359),
    [sym_class] = STATE(359),
    [sym_break] = STATE(359),
    [sym_next] = STATE(359),
    [sym_string_array] = STATE(359),
    [sym_while] = STATE(359),
    [sym_case] = STATE(359),
    [sym_symbol_array] = STATE(359),
    [sym_array] = STATE(359),
    [sym_hash] = STATE(359),
    [sym_false] = STATE(359),
    [sym_nil] = STATE(359),
    [sym_scope_resolution] = STATE(7785),
    [sym_call] = STATE(353),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(667),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(651),
    [sym_self] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(669),
    [sym_global_variable] = ACTIONS(657),
    [sym_super] = ACTIONS(651),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(667),
    [sym_constant] = ACTIONS(12089),
    [sym_instance_variable] = ACTIONS(657),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(657),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [4887] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__terminator] = STATE(7788),
    [sym__body_statement] = STATE(7789),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_heredoc_body] = STATE(7788),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym__line_break] = ACTIONS(12091),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12091),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12093),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [4888] = {
    [sym_assignment] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [4889] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [4890] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(7795),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(12095),
  },
  [4891] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(7798),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12097),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12099),
  },
  [4892] = {
    [anon_sym_SLASH] = ACTIONS(181),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_until] = ACTIONS(183),
    [anon_sym_AMP_EQ] = ACTIONS(183),
    [anon_sym_GT_GT_EQ] = ACTIONS(183),
    [anon_sym_SLASH_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_EQ_TILDE] = ACTIONS(183),
    [anon_sym_LT_LT] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(183),
    [sym__binary_star] = ACTIONS(183),
    [anon_sym_unless] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_COLON_COLON2] = ACTIONS(183),
    [anon_sym_rescue] = ACTIONS(183),
    [anon_sym_PERCENT_EQ] = ACTIONS(183),
    [anon_sym_LT_LT_EQ] = ACTIONS(183),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(183),
    [anon_sym_DOT] = ACTIONS(181),
    [anon_sym_BANG_TILDE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_COLON2] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(183),
    [sym__heredoc_body_start] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(183),
    [anon_sym_CARET_EQ] = ACTIONS(183),
    [anon_sym_AMP_DOT] = ACTIONS(183),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_PIPE] = ACTIONS(181),
    [anon_sym_DOT_DOT] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(181),
    [anon_sym_LT] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_GT_GT] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(183),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_PIPE_EQ] = ACTIONS(183),
    [anon_sym_PLUS_EQ] = ACTIONS(183),
    [anon_sym_STAR_EQ] = ACTIONS(183),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_GT_EQ] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(183),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(183),
    [anon_sym_DASH_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(183),
    [anon_sym_BANG_EQ] = ACTIONS(183),
    [anon_sym_STAR_STAR] = ACTIONS(181),
    [anon_sym_LT_EQ_GT] = ACTIONS(183),
    [sym__binary_minus] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_CARET] = ACTIONS(181),
  },
  [4893] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(7800),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(12101),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [4894] = {
    [sym_assignment] = STATE(188),
    [sym_unary] = STATE(188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(188),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_pair] = STATE(190),
    [sym__hash_items] = STATE(7802),
    [sym_hash_splat_argument] = STATE(192),
    [sym_operator_assignment] = STATE(188),
    [sym_conditional] = STATE(188),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(195),
    [sym_rational] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_true] = STATE(187),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_heredoc_body] = STATE(7803),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(188),
    [sym_binary] = STATE(188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym_float] = ACTIONS(293),
    [anon_sym_until] = ACTIONS(295),
    [sym_self] = ACTIONS(297),
    [anon_sym_RBRACE] = ACTIONS(12103),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_unless] = ACTIONS(303),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym_complex] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [sym_super] = ACTIONS(297),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_nil] = ACTIONS(315),
    [sym_character] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym_constant] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [sym_instance_variable] = ACTIONS(323),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(319),
    [anon_sym_yield] = ACTIONS(343),
    [sym_class_variable] = ACTIONS(323),
    [anon_sym_not] = ACTIONS(345),
    [sym__symbol_start] = ACTIONS(347),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(355),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [sym_retry] = ACTIONS(293),
    [sym__regex_start] = ACTIONS(369),
    [sym_integer] = ACTIONS(371),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_if] = ACTIONS(375),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [4895] = {
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4896] = {
    [sym_assignment] = STATE(7805),
    [sym_unary] = STATE(7805),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(62),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7805),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(62),
    [sym_operator_assignment] = STATE(7805),
    [sym_conditional] = STATE(7805),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(66),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(62),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(67),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(62),
    [sym_range] = STATE(7805),
    [sym_binary] = STATE(7805),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(62),
    [sym_nil] = STATE(62),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(105),
    [anon_sym_not] = ACTIONS(107),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(111),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(119),
    [anon_sym_next] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(123),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(127),
  },
  [4897] = {
    [sym_assignment] = STATE(7806),
    [sym_unary] = STATE(7806),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(7806),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(7806),
    [sym_conditional] = STATE(7806),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(7806),
    [sym_binary] = STATE(7806),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [4898] = {
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_r] = ACTIONS(12105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4899] = {
    [sym_rest_assignment] = STATE(235),
    [sym__lhs] = STATE(236),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(236),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(236),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(236),
    [sym__mlhs] = STATE(7808),
    [sym_destructured_left_assignment] = STATE(235),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(236),
    [sym_nil] = STATE(236),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [4900] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(7810),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(12107),
  },
  [4901] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(7812),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(12109),
  },
  [4902] = {
    [sym_splat_parameter] = STATE(250),
    [sym_block] = STATE(7813),
    [sym_lambda_parameters] = STATE(7814),
    [sym_hash_splat_parameter] = STATE(250),
    [sym_block_parameter] = STATE(250),
    [sym__simple_formal_parameter] = STATE(250),
    [sym_keyword_parameter] = STATE(250),
    [sym_optional_parameter] = STATE(250),
    [sym_do_block] = STATE(7813),
    [anon_sym_do] = ACTIONS(4252),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(8417),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(475),
  },
  [4903] = {
    [sym__method_name] = STATE(7816),
    [sym_setter] = STATE(7816),
    [sym_symbol] = STATE(7816),
    [sym_operator] = STATE(7816),
    [sym__method_rest] = STATE(7817),
    [sym__variable] = STATE(7818),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [sym_self] = ACTIONS(12111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(12113),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(487),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [sym_super] = ACTIONS(12111),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [sym__symbol_start] = ACTIONS(493),
  },
  [4904] = {
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4905] = {
    [sym__statement] = STATE(7820),
    [sym_unary] = STATE(88),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(7820),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_unless_modifier] = STATE(7820),
    [sym_symbol] = STATE(84),
    [sym_for] = STATE(84),
    [sym_if] = STATE(84),
    [sym__primary] = STATE(84),
    [sym_method] = STATE(84),
    [sym_conditional] = STATE(88),
    [sym_left_assignment_list] = STATE(85),
    [sym_return] = STATE(84),
    [sym_true] = STATE(87),
    [sym_while_modifier] = STATE(7820),
    [sym_subshell] = STATE(84),
    [sym_unless] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_begin_block] = STATE(7820),
    [sym_range] = STATE(88),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(87),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_array] = STATE(84),
    [sym_call] = STATE(86),
    [sym_end_block] = STATE(7820),
    [sym_assignment] = STATE(88),
    [sym__lhs] = STATE(87),
    [sym_singleton_class] = STATE(84),
    [sym_alias] = STATE(7820),
    [sym_if_modifier] = STATE(7820),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(88),
    [sym_method_call] = STATE(87),
    [sym_operator_assignment] = STATE(88),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_rational] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(89),
    [sym_until_modifier] = STATE(7820),
    [sym_lambda] = STATE(84),
    [sym_element_reference] = STATE(87),
    [sym_binary] = STATE(88),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_nil] = STATE(87),
    [sym_rescue_modifier] = STATE(7820),
    [sym_symbol_array] = STATE(84),
    [sym_case] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_scope_resolution] = STATE(86),
    [sym_float] = ACTIONS(143),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(145),
    [sym_self] = ACTIONS(147),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(147),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(155),
    [anon_sym_defined_QMARK] = ACTIONS(157),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_yield] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(155),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(163),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(165),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(167),
    [anon_sym_next] = ACTIONS(169),
    [sym_retry] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(171),
  },
  [4906] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12115),
    [anon_sym_GT_GT_EQ] = ACTIONS(12115),
    [anon_sym_SLASH_EQ] = ACTIONS(12115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12115),
    [anon_sym_LT_LT_EQ] = ACTIONS(12115),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12115),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(12115),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12117),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(12115),
    [anon_sym_PLUS_EQ] = ACTIONS(12115),
    [anon_sym_STAR_EQ] = ACTIONS(12115),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12115),
    [anon_sym_DASH_EQ] = ACTIONS(12115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12115),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4907] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [4908] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(11965),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(11967),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(11969),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [4909] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym__primary] = STATE(2276),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(2280),
    [sym_method] = STATE(2276),
    [sym_conditional] = STATE(2282),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_subshell] = STATE(2276),
    [sym_unless] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_block_argument] = STATE(2280),
    [sym_range] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2281),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_call] = STATE(2279),
    [sym__argument] = STATE(2280),
    [sym_assignment] = STATE(2282),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_pair] = STATE(2280),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(2280),
    [sym_operator_assignment] = STATE(2282),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_rational] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_lambda] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym__argument_list_with_parens] = STATE(2284),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2282),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_nil] = STATE(2281),
    [sym_symbol_array] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_scope_resolution] = STATE(2279),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(3980),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_rescue] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(1561),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(3984),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_constant] = ACTIONS(3992),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(3994),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4006),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [4910] = {
    [anon_sym_EQ] = ACTIONS(12147),
    [sym_comment] = ACTIONS(3),
  },
  [4911] = {
    [aux_sym_chained_string_repeat1] = STATE(7832),
    [sym_string] = STATE(7832),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [4912] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
  },
  [4913] = {
    [anon_sym_RPAREN] = ACTIONS(12149),
    [sym_comment] = ACTIONS(49),
  },
  [4914] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [4915] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [4916] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(4868),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(4869),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12151),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [4917] = {
    [anon_sym_SLASH] = ACTIONS(6989),
    [anon_sym_until] = ACTIONS(6991),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [anon_sym_RBRACE] = ACTIONS(6991),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_unless] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_rescue] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_COLON2] = ACTIONS(6989),
    [anon_sym_while] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [4918] = {
    [sym_assignment] = STATE(7835),
    [sym_unary] = STATE(7835),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7835),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(7836),
    [sym_operator_assignment] = STATE(7835),
    [sym_conditional] = STATE(7835),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_subshell] = STATE(2276),
    [sym__arg_or_splat_arg] = STATE(7836),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7835),
    [sym_binary] = STATE(7835),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(3984),
    [sym_character] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4919] = {
    [aux_sym_heredoc_body_repeat1] = STATE(7838),
    [sym_interpolation] = STATE(7838),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(12153),
    [sym_heredoc_end] = ACTIONS(12155),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(12153),
  },
  [4920] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_heredoc_body] = STATE(7840),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym_float] = ACTIONS(3980),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(3984),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(3984),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(3994),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [sym_class_variable] = ACTIONS(3994),
    [sym__block_ampersand] = ACTIONS(4004),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4006),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12157),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4921] = {
    [sym_heredoc_body] = STATE(7841),
    [aux_sym_call_repeat1] = STATE(7841),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4922] = {
    [sym_heredoc_body] = STATE(7842),
    [aux_sym_call_repeat1] = STATE(7842),
    [aux_sym_argument_list_repeat1] = STATE(7843),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(8186),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [4923] = {
    [sym_assignment] = STATE(7844),
    [sym_unary] = STATE(7844),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7844),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7844),
    [sym_conditional] = STATE(7844),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7844),
    [sym_binary] = STATE(7844),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4924] = {
    [sym_assignment] = STATE(7845),
    [sym_unary] = STATE(7845),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7845),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7845),
    [sym_conditional] = STATE(7845),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7845),
    [sym_binary] = STATE(7845),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4925] = {
    [sym_assignment] = STATE(7846),
    [sym_unary] = STATE(7846),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7846),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7846),
    [sym_conditional] = STATE(7846),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7846),
    [sym_binary] = STATE(7846),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4926] = {
    [sym_assignment] = STATE(7847),
    [sym_unary] = STATE(7847),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7847),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(7847),
    [sym_conditional] = STATE(7847),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(7847),
    [sym_binary] = STATE(7847),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [4927] = {
    [sym_assignment] = STATE(7848),
    [sym_unary] = STATE(7848),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7848),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7848),
    [sym_conditional] = STATE(7848),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7848),
    [sym_binary] = STATE(7848),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4928] = {
    [sym_assignment] = STATE(7849),
    [sym_unary] = STATE(7849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7849),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7849),
    [sym_conditional] = STATE(7849),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7849),
    [sym_binary] = STATE(7849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4929] = {
    [sym_assignment] = STATE(7850),
    [sym_unary] = STATE(7850),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7850),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7850),
    [sym_conditional] = STATE(7850),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7850),
    [sym_binary] = STATE(7850),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4930] = {
    [sym_assignment] = STATE(7852),
    [sym_unary] = STATE(7852),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7852),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7852),
    [sym_conditional] = STATE(7852),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7852),
    [sym_binary] = STATE(7852),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4931] = {
    [sym_assignment] = STATE(7853),
    [sym_unary] = STATE(7853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7853),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7853),
    [sym_conditional] = STATE(7853),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7853),
    [sym_binary] = STATE(7853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4932] = {
    [sym_assignment] = STATE(7854),
    [sym_unary] = STATE(7854),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7854),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(7854),
    [sym_conditional] = STATE(7854),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7854),
    [sym_binary] = STATE(7854),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [4933] = {
    [aux_sym_chained_string_repeat1] = STATE(7855),
    [sym_string] = STATE(7855),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [4934] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4935] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4936] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4937] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4938] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4939] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12159),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4940] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4941] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4942] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [4943] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4944] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [4945] = {
    [aux_sym_chained_string_repeat1] = STATE(4945),
    [sym_string] = STATE(4945),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [4946] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [sym__line_break] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
    [sym__binary_minus] = ACTIONS(12166),
  },
  [4947] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym_escape_sequence] = ACTIONS(173),
  },
  [4948] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [anon_sym_RBRACK] = ACTIONS(7384),
    [anon_sym_in] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_EQ_GT] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_COLON2] = ACTIONS(7382),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
    [anon_sym_EQ] = ACTIONS(7382),
  },
  [4949] = {
    [anon_sym_end] = ACTIONS(12168),
    [sym_comment] = ACTIONS(49),
  },
  [4950] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_RBRACK] = ACTIONS(7790),
    [anon_sym_in] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_EQ_GT] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_COLON2] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7788),
  },
  [4951] = {
    [anon_sym_end] = ACTIONS(12170),
    [sym_comment] = ACTIONS(49),
  },
  [4952] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [anon_sym_RBRACK] = ACTIONS(7872),
    [anon_sym_in] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_COLON2] = ACTIONS(7870),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
    [anon_sym_EQ] = ACTIONS(7870),
  },
  [4953] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12172),
  },
  [4954] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_RBRACK] = ACTIONS(7878),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7876),
  },
  [4955] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12174),
    [sym__string_end] = ACTIONS(12172),
  },
  [4956] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_in] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_EQ_GT] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_COLON2] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
  },
  [4957] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12176),
  },
  [4958] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [anon_sym_RBRACK] = ACTIONS(8851),
    [anon_sym_in] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_EQ_GT] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_COLON2] = ACTIONS(8849),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
    [anon_sym_EQ] = ACTIONS(8849),
  },
  [4959] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [anon_sym_RBRACK] = ACTIONS(8872),
    [anon_sym_in] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_EQ_GT] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_COLON2] = ACTIONS(8870),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
    [anon_sym_EQ] = ACTIONS(8870),
  },
  [4960] = {
    [anon_sym_end] = ACTIONS(12178),
    [sym_comment] = ACTIONS(49),
  },
  [4961] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7864),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12180),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4962] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [anon_sym_RBRACK] = ACTIONS(9250),
    [anon_sym_in] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
    [anon_sym_EQ] = ACTIONS(9248),
  },
  [4963] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7866),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12182),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4964] = {
    [anon_sym_end] = ACTIONS(12184),
    [sym_comment] = ACTIONS(49),
  },
  [4965] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(7867),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(7867),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7866),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12186),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12186),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12182),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [4966] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [anon_sym_RBRACK] = ACTIONS(9419),
    [anon_sym_in] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
    [anon_sym_EQ] = ACTIONS(9417),
  },
  [4967] = {
    [anon_sym_RBRACE] = ACTIONS(12188),
    [sym_comment] = ACTIONS(49),
  },
  [4968] = {
    [anon_sym_DOT] = ACTIONS(12190),
    [anon_sym_COLON_COLON] = ACTIONS(12190),
    [sym_comment] = ACTIONS(49),
  },
  [4969] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [anon_sym_RBRACK] = ACTIONS(9602),
    [anon_sym_in] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_EQ_GT] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_COLON2] = ACTIONS(9600),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
    [anon_sym_EQ] = ACTIONS(9600),
  },
  [4970] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [anon_sym_RBRACK] = ACTIONS(9608),
    [anon_sym_in] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_EQ_GT] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_COLON2] = ACTIONS(9606),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
    [anon_sym_EQ] = ACTIONS(9606),
  },
  [4971] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4972] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4973] = {
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_SLASH] = ACTIONS(9738),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_AMP_AMP] = ACTIONS(9738),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
  },
  [4974] = {
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(4446),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_in] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_EQ_GT] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_COLON2] = ACTIONS(6215),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_AMP_AMP] = ACTIONS(4446),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [sym__binary_minus] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(4446),
    [anon_sym_EQ] = ACTIONS(6215),
  },
  [4975] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(12192),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [4976] = {
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
  },
  [4977] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(728),
    [sym_unary] = STATE(728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(728),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(728),
    [sym_conditional] = STATE(728),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(730),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(728),
    [sym_binary] = STATE(728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(1381),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [4978] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_RBRACK] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [4979] = {
    [sym_heredoc_body] = STATE(4978),
    [aux_sym_call_repeat1] = STATE(4978),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_RBRACK] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [4980] = {
    [aux_sym_argument_list_repeat1] = STATE(4980),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(12197),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [4981] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4982] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4983] = {
    [aux_sym_exceptions_repeat1] = STATE(7873),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [4984] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4985] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4986] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12200),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [4987] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4988] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4989] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4990] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [4991] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4992] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4993] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [4994] = {
    [sym_assignment] = STATE(7875),
    [sym_unary] = STATE(7875),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(7875),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(7875),
    [sym_conditional] = STATE(7875),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(7875),
    [sym_binary] = STATE(7875),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [4995] = {
    [sym_assignment] = STATE(7876),
    [sym_unary] = STATE(7876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(7876),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(7876),
    [sym_conditional] = STATE(7876),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(7876),
    [sym_binary] = STATE(7876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [4996] = {
    [sym_assignment] = STATE(7877),
    [sym_unary] = STATE(7877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(7877),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(7877),
    [sym_conditional] = STATE(7877),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(7877),
    [sym_binary] = STATE(7877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [4997] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [4998] = {
    [sym_assignment] = STATE(7878),
    [sym_unary] = STATE(7878),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(7878),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(7878),
    [sym_conditional] = STATE(7878),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(7878),
    [sym_binary] = STATE(7878),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [4999] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12202),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(12202),
    [anon_sym_SLASH_EQ] = ACTIONS(12202),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12202),
    [anon_sym_PIPE_EQ] = ACTIONS(12202),
    [anon_sym_LT_LT_EQ] = ACTIONS(12202),
    [anon_sym_PLUS_EQ] = ACTIONS(12202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12202),
    [anon_sym_STAR_EQ] = ACTIONS(12202),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12202),
    [anon_sym_CARET_EQ] = ACTIONS(12202),
    [anon_sym_DASH_EQ] = ACTIONS(12202),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12202),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12204),
  },
  [5000] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [5001] = {
    [anon_sym_EQ] = ACTIONS(12232),
    [sym_comment] = ACTIONS(3),
  },
  [5002] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [5003] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [5004] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_heredoc_body] = STATE(7890),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12234),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [5005] = {
    [sym_heredoc_body] = STATE(7891),
    [aux_sym_call_repeat1] = STATE(7891),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5006] = {
    [sym_heredoc_body] = STATE(7892),
    [aux_sym_call_repeat1] = STATE(7892),
    [aux_sym_argument_list_repeat1] = STATE(7893),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(8297),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5007] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7895),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12236),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5008] = {
    [sym_when] = STATE(7898),
    [sym_else] = STATE(7897),
    [aux_sym_case_repeat2] = STATE(7898),
    [aux_sym_case_repeat1] = STATE(7899),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12238),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(12240),
    [sym_comment] = ACTIONS(49),
  },
  [5009] = {
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_in] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5744),
  },
  [5010] = {
    [anon_sym_end] = ACTIONS(12238),
    [sym_comment] = ACTIONS(49),
  },
  [5011] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(7897),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12238),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5012] = {
    [sym_when] = STATE(7898),
    [sym_else] = STATE(7897),
    [aux_sym_case_repeat2] = STATE(7898),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12238),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5013] = {
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6682),
    [anon_sym_RBRACK] = ACTIONS(6682),
    [anon_sym_in] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6682),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_COLON2] = ACTIONS(6680),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_AMP_AMP] = ACTIONS(6682),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6682),
    [anon_sym_EQ] = ACTIONS(6680),
  },
  [5014] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(12242),
  },
  [5015] = {
    [aux_sym_string_array_repeat1] = STATE(7903),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12244),
    [sym__string_end] = ACTIONS(12246),
  },
  [5016] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12248),
  },
  [5017] = {
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_SLASH] = ACTIONS(6694),
    [anon_sym_RBRACK] = ACTIONS(6694),
    [anon_sym_in] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6694),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6694),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_COLON2] = ACTIONS(6692),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6694),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_AMP_AMP] = ACTIONS(6694),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6694),
    [anon_sym_EQ] = ACTIONS(6692),
  },
  [5018] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12250),
    [sym__string_end] = ACTIONS(12248),
  },
  [5019] = {
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_COLON2] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
  },
  [5020] = {
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5974),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_in] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_COLON2] = ACTIONS(5972),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5974),
    [anon_sym_EQ] = ACTIONS(5972),
  },
  [5021] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(7907),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12252),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [5022] = {
    [sym_else] = STATE(7907),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(12254),
    [sym_comment] = ACTIONS(49),
  },
  [5023] = {
    [sym_heredoc_body] = STATE(7908),
    [sym__terminator] = STATE(7908),
    [sym__line_break] = ACTIONS(12256),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [5024] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7909),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12258),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5025] = {
    [sym_heredoc_body] = STATE(7910),
    [sym__terminator] = STATE(7910),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [sym_comment] = ACTIONS(49),
  },
  [5026] = {
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6077),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_in] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_COLON2] = ACTIONS(6075),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6075),
  },
  [5027] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7911),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12262),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5028] = {
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_SLASH] = ACTIONS(6445),
    [anon_sym_RBRACK] = ACTIONS(6445),
    [anon_sym_in] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6445),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_COLON2] = ACTIONS(6443),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6445),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_AMP_AMP] = ACTIONS(6445),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6445),
    [anon_sym_EQ] = ACTIONS(6443),
  },
  [5029] = {
    [anon_sym_end] = ACTIONS(12264),
    [sym_comment] = ACTIONS(49),
  },
  [5030] = {
    [sym_ensure] = STATE(7913),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [5031] = {
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_SLASH] = ACTIONS(6473),
    [anon_sym_RBRACK] = ACTIONS(6473),
    [anon_sym_in] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6473),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6473),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_COLON2] = ACTIONS(6471),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6473),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6473),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6473),
    [anon_sym_EQ] = ACTIONS(6471),
  },
  [5032] = {
    [sym_ensure] = STATE(7913),
    [sym_else] = STATE(7914),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [5033] = {
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6073),
    [anon_sym_RBRACK] = ACTIONS(6073),
    [anon_sym_in] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6073),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_COLON2] = ACTIONS(6071),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6073),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6073),
    [anon_sym_EQ] = ACTIONS(6071),
  },
  [5034] = {
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3852),
    [anon_sym_RBRACK] = ACTIONS(3852),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3852),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_COLON2] = ACTIONS(3850),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3850),
  },
  [5035] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(12266),
  },
  [5036] = {
    [aux_sym_symbol_array_repeat1] = STATE(7918),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12268),
    [sym__string_end] = ACTIONS(12270),
  },
  [5037] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12272),
  },
  [5038] = {
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4056),
    [anon_sym_RBRACK] = ACTIONS(4056),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4056),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_COLON2] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4056),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_AMP_AMP] = ACTIONS(4056),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_EQ] = ACTIONS(4054),
  },
  [5039] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12274),
    [sym__string_end] = ACTIONS(12272),
  },
  [5040] = {
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(4426),
    [anon_sym_RBRACK] = ACTIONS(4426),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4426),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_COLON2] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_AMP_AMP] = ACTIONS(4426),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_EQ] = ACTIONS(4424),
  },
  [5041] = {
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_SLASH] = ACTIONS(4700),
    [anon_sym_RBRACK] = ACTIONS(4700),
    [anon_sym_in] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4700),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_COLON2] = ACTIONS(4698),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4700),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4700),
    [anon_sym_EQ] = ACTIONS(4698),
  },
  [5042] = {
    [anon_sym_RBRACE] = ACTIONS(12276),
    [sym_comment] = ACTIONS(49),
  },
  [5043] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7923),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12278),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5044] = {
    [sym__terminator] = STATE(7924),
    [sym_heredoc_body] = STATE(7924),
    [sym__do] = STATE(7924),
    [anon_sym_do] = ACTIONS(12280),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [sym_comment] = ACTIONS(49),
  },
  [5045] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_in] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
  },
  [5046] = {
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_in] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_COLON2] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6632),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_AMP_AMP] = ACTIONS(6632),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6630),
  },
  [5047] = {
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5080),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_in] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5078),
  },
  [5048] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(7926),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(7926),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7927),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12282),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12284),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5049] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(7928),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7927),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12284),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5050] = {
    [anon_sym_end] = ACTIONS(12286),
    [sym_comment] = ACTIONS(49),
  },
  [5051] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5212),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
  },
  [5052] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(7930),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12288),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [5053] = {
    [anon_sym_RBRACE] = ACTIONS(12288),
    [sym_comment] = ACTIONS(49),
  },
  [5054] = {
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_COLON2] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5238),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_EQ] = ACTIONS(5236),
  },
  [5055] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5056] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7932),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5057] = {
    [sym__method_name] = STATE(2414),
    [sym_setter] = STATE(2414),
    [sym_symbol] = STATE(2414),
    [sym_operator] = STATE(2414),
    [sym__method_rest] = STATE(7933),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(12294),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(12294),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(12294),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(12294),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [5058] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(7935),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(7935),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12296),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [5059] = {
    [sym_elsif] = STATE(7935),
    [sym_else] = STATE(7935),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12298),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [5060] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5061] = {
    [sym_assignment] = STATE(7936),
    [sym_unary] = STATE(7936),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(7936),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(7936),
    [sym_conditional] = STATE(7936),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(7936),
    [sym_binary] = STATE(7936),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [5062] = {
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
  },
  [5063] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5064] = {
    [aux_sym_exceptions_repeat1] = STATE(7938),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [5065] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5066] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5067] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5068] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5069] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5070] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5071] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [5072] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5073] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5074] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5075] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [anon_sym_RBRACK] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5076] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(7941),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5077] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [anon_sym_RBRACK] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5078] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [anon_sym_RBRACK] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5079] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5078),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(7942),
    [sym_operator] = STATE(7942),
    [anon_sym_LT] = ACTIONS(8369),
    [anon_sym_SLASH] = ACTIONS(8371),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8371),
    [anon_sym_PLUS_AT] = ACTIONS(8371),
    [anon_sym_LPAREN2] = ACTIONS(8373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8371),
    [anon_sym_GT_GT] = ACTIONS(8371),
    [anon_sym_EQ_TILDE] = ACTIONS(8371),
    [anon_sym_LT_LT] = ACTIONS(8371),
    [anon_sym_TILDE] = ACTIONS(8371),
    [anon_sym_PLUS] = ACTIONS(8369),
    [anon_sym_AMP] = ACTIONS(8371),
    [anon_sym_GT] = ACTIONS(8369),
    [anon_sym_PERCENT] = ACTIONS(8371),
    [anon_sym_DASH_AT] = ACTIONS(8371),
    [anon_sym_EQ_EQ] = ACTIONS(8369),
    [anon_sym_STAR] = ACTIONS(8369),
    [anon_sym_BANG_TILDE] = ACTIONS(8371),
    [sym_constant] = ACTIONS(12304),
    [anon_sym_DASH] = ACTIONS(8369),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8371),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8369),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8371),
    [anon_sym_STAR_STAR] = ACTIONS(8371),
    [anon_sym_PIPE] = ACTIONS(8371),
    [anon_sym_DOT_DOT] = ACTIONS(8371),
    [anon_sym_LT_EQ_GT] = ACTIONS(8371),
    [anon_sym_LT_EQ] = ACTIONS(8369),
    [anon_sym_BANG] = ACTIONS(8369),
    [sym_identifier] = ACTIONS(12304),
    [anon_sym_CARET] = ACTIONS(8371),
  },
  [5080] = {
    [anon_sym_SLASH] = ACTIONS(6733),
    [anon_sym_RBRACK] = ACTIONS(6735),
    [anon_sym_until] = ACTIONS(6735),
    [anon_sym_AMP_EQ] = ACTIONS(6735),
    [anon_sym_GT_GT_EQ] = ACTIONS(6735),
    [anon_sym_SLASH_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6735),
    [anon_sym_RPAREN] = ACTIONS(6735),
    [anon_sym_EQ_TILDE] = ACTIONS(6735),
    [anon_sym_LT_LT] = ACTIONS(6733),
    [sym__binary_star] = ACTIONS(6735),
    [anon_sym_RBRACE] = ACTIONS(6735),
    [anon_sym_unless] = ACTIONS(6735),
    [anon_sym_PLUS] = ACTIONS(6733),
    [anon_sym_AMP] = ACTIONS(6733),
    [anon_sym_PERCENT] = ACTIONS(6733),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [anon_sym_rescue] = ACTIONS(6735),
    [anon_sym_PERCENT_EQ] = ACTIONS(6735),
    [anon_sym_LT_LT_EQ] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6733),
    [anon_sym_BANG_TILDE] = ACTIONS(6735),
    [anon_sym_LBRACE] = ACTIONS(6735),
    [anon_sym_COLON2] = ACTIONS(6733),
    [anon_sym_while] = ACTIONS(6735),
    [sym__heredoc_body_start] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6735),
    [anon_sym_CARET_EQ] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_LT_EQ] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6733),
    [anon_sym_DOT_DOT] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6733),
    [anon_sym_LT] = ACTIONS(6733),
    [anon_sym_in] = ACTIONS(6735),
    [anon_sym_QMARK] = ACTIONS(6735),
    [anon_sym_COMMA] = ACTIONS(6735),
    [anon_sym_GT_GT] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6735),
    [anon_sym_or] = ACTIONS(6735),
    [anon_sym_GT] = ACTIONS(6733),
    [anon_sym_PIPE_EQ] = ACTIONS(6735),
    [anon_sym_PLUS_EQ] = ACTIONS(6735),
    [anon_sym_STAR_EQ] = ACTIONS(6735),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_and] = ACTIONS(6735),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_GT_EQ] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6735),
    [anon_sym_DASH_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6735),
    [anon_sym_BANG_EQ] = ACTIONS(6735),
    [anon_sym_STAR_STAR] = ACTIONS(6733),
    [anon_sym_LT_EQ_GT] = ACTIONS(6735),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [sym__binary_minus] = ACTIONS(6735),
    [anon_sym_if] = ACTIONS(6735),
    [anon_sym_CARET] = ACTIONS(6733),
  },
  [5081] = {
    [anon_sym_RBRACK] = ACTIONS(12306),
    [sym_comment] = ACTIONS(49),
  },
  [5082] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5083] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [5084] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(7945),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12308),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [5085] = {
    [anon_sym_RBRACE] = ACTIONS(12308),
    [sym_comment] = ACTIONS(49),
  },
  [5086] = {
    [sym_assignment] = STATE(7946),
    [sym_unary] = STATE(7946),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(7946),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(7946),
    [sym_conditional] = STATE(7946),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(7946),
    [sym_binary] = STATE(7946),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [5087] = {
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_until] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_EQ_TILDE] = ACTIONS(5080),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [sym__binary_star] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [anon_sym_rescue] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_BANG_TILDE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_COLON2] = ACTIONS(5078),
    [anon_sym_while] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_EQ_EQ] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_STAR_STAR] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5078),
    [sym__binary_minus] = ACTIONS(5080),
    [anon_sym_if] = ACTIONS(5080),
    [anon_sym_CARET] = ACTIONS(5078),
  },
  [5088] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(7948),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(7948),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7949),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12310),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12310),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12312),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5089] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(7950),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7949),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12312),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5090] = {
    [anon_sym_end] = ACTIONS(12314),
    [sym_comment] = ACTIONS(49),
  },
  [5091] = {
    [sym_assignment] = STATE(7951),
    [sym_unary] = STATE(7951),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(7951),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(7951),
    [sym_conditional] = STATE(7951),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(7951),
    [sym_binary] = STATE(7951),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [5092] = {
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(751),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5093] = {
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(645),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5094] = {
    [sym_assignment] = STATE(7952),
    [sym_unary] = STATE(7952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(7952),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(7952),
    [sym_conditional] = STATE(7952),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(7952),
    [sym_binary] = STATE(7952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [5095] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [5096] = {
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(735),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5097] = {
    [sym_assignment] = STATE(7953),
    [sym_unary] = STATE(7953),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(7953),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(7953),
    [sym_conditional] = STATE(7953),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(7953),
    [sym_binary] = STATE(7953),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [5098] = {
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(495),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5099] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12316),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(12316),
    [anon_sym_SLASH_EQ] = ACTIONS(12316),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12316),
    [anon_sym_PIPE_EQ] = ACTIONS(12316),
    [anon_sym_LT_LT_EQ] = ACTIONS(12316),
    [anon_sym_PLUS_EQ] = ACTIONS(12316),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12316),
    [anon_sym_STAR_EQ] = ACTIONS(12316),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12316),
    [anon_sym_CARET_EQ] = ACTIONS(12316),
    [anon_sym_DASH_EQ] = ACTIONS(12316),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12316),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(12318),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5100] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [5101] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_RBRACK] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(4240),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [5102] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_for] = STATE(858),
    [sym_if] = STATE(858),
    [sym__primary] = STATE(858),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(2443),
    [sym_method] = STATE(858),
    [sym_conditional] = STATE(2444),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_true] = STATE(863),
    [sym_subshell] = STATE(858),
    [sym_unless] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_block_argument] = STATE(2443),
    [sym_range] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(863),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_array] = STATE(858),
    [sym_call] = STATE(861),
    [sym__argument] = STATE(2443),
    [sym_assignment] = STATE(2444),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_pair] = STATE(2443),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(2443),
    [sym_operator_assignment] = STATE(2444),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_rational] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_lambda] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym__argument_list_with_parens] = STATE(2446),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2444),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_nil] = STATE(863),
    [sym_symbol_array] = STATE(858),
    [sym_case] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_scope_resolution] = STATE(861),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(793),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(1553),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [sym_character] = ACTIONS(1555),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4256),
    [anon_sym_not] = ACTIONS(1593),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5103] = {
    [anon_sym_EQ] = ACTIONS(12348),
    [sym_comment] = ACTIONS(3),
  },
  [5104] = {
    [aux_sym_chained_string_repeat1] = STATE(7965),
    [sym_string] = STATE(7965),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_RBRACK] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5105] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [5106] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [5107] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(5084),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(5085),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12350),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [5108] = {
    [anon_sym_SLASH] = ACTIONS(6989),
    [anon_sym_RBRACK] = ACTIONS(6991),
    [anon_sym_until] = ACTIONS(6991),
    [anon_sym_AMP_EQ] = ACTIONS(6991),
    [anon_sym_GT_GT_EQ] = ACTIONS(6991),
    [anon_sym_SLASH_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6991),
    [anon_sym_RPAREN] = ACTIONS(6991),
    [anon_sym_EQ_TILDE] = ACTIONS(6991),
    [anon_sym_LT_LT] = ACTIONS(6989),
    [sym__binary_star] = ACTIONS(6991),
    [anon_sym_RBRACE] = ACTIONS(6991),
    [anon_sym_unless] = ACTIONS(6991),
    [anon_sym_PLUS] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(6989),
    [anon_sym_PERCENT] = ACTIONS(6989),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [anon_sym_rescue] = ACTIONS(6991),
    [anon_sym_PERCENT_EQ] = ACTIONS(6991),
    [anon_sym_LT_LT_EQ] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6989),
    [anon_sym_BANG_TILDE] = ACTIONS(6991),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_COLON2] = ACTIONS(6989),
    [anon_sym_while] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6991),
    [anon_sym_CARET_EQ] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_LT_EQ] = ACTIONS(6989),
    [anon_sym_PIPE] = ACTIONS(6989),
    [anon_sym_DOT_DOT] = ACTIONS(6989),
    [anon_sym_EQ] = ACTIONS(6989),
    [anon_sym_LT] = ACTIONS(6989),
    [anon_sym_in] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(6991),
    [anon_sym_COMMA] = ACTIONS(6991),
    [anon_sym_GT_GT] = ACTIONS(6989),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6991),
    [anon_sym_or] = ACTIONS(6991),
    [anon_sym_GT] = ACTIONS(6989),
    [anon_sym_PIPE_EQ] = ACTIONS(6991),
    [anon_sym_PLUS_EQ] = ACTIONS(6991),
    [anon_sym_STAR_EQ] = ACTIONS(6991),
    [anon_sym_EQ_EQ] = ACTIONS(6989),
    [anon_sym_and] = ACTIONS(6991),
    [anon_sym_PIPE_PIPE] = ACTIONS(6989),
    [anon_sym_GT_EQ] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6991),
    [anon_sym_DASH_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6991),
    [anon_sym_BANG_EQ] = ACTIONS(6991),
    [anon_sym_STAR_STAR] = ACTIONS(6989),
    [anon_sym_LT_EQ_GT] = ACTIONS(6991),
    [anon_sym_AMP_AMP] = ACTIONS(6989),
    [sym__binary_minus] = ACTIONS(6991),
    [anon_sym_if] = ACTIONS(6991),
    [anon_sym_CARET] = ACTIONS(6989),
  },
  [5109] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_heredoc_body] = STATE(7967),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym_float] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1553),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1573),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [sym_class_variable] = ACTIONS(1573),
    [sym__block_ampersand] = ACTIONS(4256),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1593),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12352),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [5110] = {
    [sym_heredoc_body] = STATE(7968),
    [aux_sym_call_repeat1] = STATE(7968),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5111] = {
    [sym_heredoc_body] = STATE(7969),
    [aux_sym_call_repeat1] = STATE(7969),
    [aux_sym_argument_list_repeat1] = STATE(7970),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_RBRACK] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(8421),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5112] = {
    [aux_sym_chained_string_repeat1] = STATE(5112),
    [sym_string] = STATE(5112),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_RBRACK] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [5113] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [anon_sym_RBRACK] = ACTIONS(9899),
    [anon_sym_in] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_EQ_GT] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_COLON2] = ACTIONS(9897),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
    [anon_sym_EQ] = ACTIONS(9897),
  },
  [5114] = {
    [anon_sym_end] = ACTIONS(12357),
    [sym_comment] = ACTIONS(49),
  },
  [5115] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(7972),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12357),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5116] = {
    [sym_when] = STATE(7973),
    [sym_else] = STATE(7972),
    [aux_sym_case_repeat2] = STATE(7973),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12357),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5117] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7974),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12359),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5118] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [anon_sym_RBRACK] = ACTIONS(10208),
    [anon_sym_in] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_EQ_GT] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_COLON2] = ACTIONS(10206),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
    [anon_sym_EQ] = ACTIONS(10206),
  },
  [5119] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(787),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(788),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(7975),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(791),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(792),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12361),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5120] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [anon_sym_RBRACK] = ACTIONS(10260),
    [anon_sym_in] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_EQ_GT] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_COLON2] = ACTIONS(10258),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
    [anon_sym_EQ] = ACTIONS(10258),
  },
  [5121] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [anon_sym_RBRACK] = ACTIONS(10699),
    [anon_sym_in] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_EQ_GT] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_COLON2] = ACTIONS(10697),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
    [anon_sym_EQ] = ACTIONS(10697),
  },
  [5122] = {
    [anon_sym_end] = ACTIONS(12363),
    [sym_comment] = ACTIONS(49),
  },
  [5123] = {
    [sym_ensure] = STATE(7977),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12363),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [5124] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10925),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_EQ] = ACTIONS(10925),
  },
  [5125] = {
    [anon_sym_end] = ACTIONS(12365),
    [sym_comment] = ACTIONS(49),
  },
  [5126] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_RBRACK] = ACTIONS(10933),
    [anon_sym_in] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_EQ_GT] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_COLON2] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10931),
  },
  [5127] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12367),
  },
  [5128] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [anon_sym_RBRACK] = ACTIONS(10939),
    [anon_sym_in] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_EQ_GT] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_COLON2] = ACTIONS(10937),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
    [anon_sym_EQ] = ACTIONS(10937),
  },
  [5129] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12369),
    [sym__string_end] = ACTIONS(12367),
  },
  [5130] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [anon_sym_RBRACK] = ACTIONS(10945),
    [anon_sym_in] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_EQ_GT] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_COLON2] = ACTIONS(10943),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
    [anon_sym_EQ] = ACTIONS(10943),
  },
  [5131] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12371),
  },
  [5132] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [sym__identifier_hash_key] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [sym__block_ampersand] = ACTIONS(4446),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [sym__splat_star] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [5133] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(12373),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [5134] = {
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(12375),
    [anon_sym_RBRACK] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_in] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_EQ] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
  },
  [5135] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(12377),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [5136] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_heredoc_body] = STATE(7983),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [5137] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [5138] = {
    [sym_assignment] = STATE(2484),
    [sym_unary] = STATE(2484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2484),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(2484),
    [sym_conditional] = STATE(2484),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_string] = STATE(691),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(2484),
    [sym_binary] = STATE(2484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(203),
    [sym_character] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [5139] = {
    [aux_sym_exceptions_repeat1] = STATE(7985),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(12379),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [5140] = {
    [sym_assignment] = STATE(7986),
    [sym_unary] = STATE(7986),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(7986),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(142),
    [sym_operator_assignment] = STATE(7986),
    [sym_conditional] = STATE(7986),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(142),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_range] = STATE(7986),
    [sym_binary] = STATE(7986),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(251),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [5141] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [5142] = {
    [anon_sym_RPAREN] = ACTIONS(12381),
    [sym_comment] = ACTIONS(49),
  },
  [5143] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [anon_sym_RBRACK] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [5144] = {
    [anon_sym_SLASH] = ACTIONS(10967),
    [anon_sym_RBRACK] = ACTIONS(10969),
    [anon_sym_until] = ACTIONS(10969),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_RBRACE] = ACTIONS(10969),
    [anon_sym_unless] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_rescue] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_LBRACE] = ACTIONS(10969),
    [anon_sym_COLON2] = ACTIONS(10967),
    [anon_sym_while] = ACTIONS(10969),
    [sym__heredoc_body_start] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_in] = ACTIONS(10969),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_EQ_GT] = ACTIONS(10969),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_if] = ACTIONS(10969),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [5145] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(7989),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12383),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5146] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(7991),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12385),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [5147] = {
    [sym_else] = STATE(7991),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(12387),
    [sym_comment] = ACTIONS(49),
  },
  [5148] = {
    [anon_sym_SLASH] = ACTIONS(1633),
    [anon_sym_RBRACK] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_AMP_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT_EQ] = ACTIONS(1635),
    [anon_sym_SLASH_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(1635),
    [anon_sym_LT_LT_EQ] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_PLUS_EQ] = ACTIONS(1635),
    [anon_sym_STAR_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1635),
    [anon_sym_DASH_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
  },
  [5149] = {
    [anon_sym_SLASH] = ACTIONS(3850),
    [anon_sym_RBRACK] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_AMP_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT_EQ] = ACTIONS(3852),
    [anon_sym_SLASH_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3850),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3850),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_PERCENT_EQ] = ACTIONS(3852),
    [anon_sym_LT_LT_EQ] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_COLON2] = ACTIONS(3850),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_CARET_EQ] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_EQ_GT] = ACTIONS(3852),
    [anon_sym_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_PLUS_EQ] = ACTIONS(3852),
    [anon_sym_STAR_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3850),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3852),
    [anon_sym_DASH_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3850),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3850),
  },
  [5150] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(12389),
  },
  [5151] = {
    [aux_sym_symbol_array_repeat1] = STATE(7995),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12391),
    [sym__string_end] = ACTIONS(12393),
  },
  [5152] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12395),
  },
  [5153] = {
    [anon_sym_SLASH] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_AMP_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT_EQ] = ACTIONS(4056),
    [anon_sym_SLASH_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_PERCENT_EQ] = ACTIONS(4056),
    [anon_sym_LT_LT_EQ] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_COLON2] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_CARET_EQ] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_EQ_GT] = ACTIONS(4056),
    [anon_sym_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4056),
    [anon_sym_STAR_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4056),
    [anon_sym_DASH_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4054),
  },
  [5154] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12397),
    [sym__string_end] = ACTIONS(12395),
  },
  [5155] = {
    [anon_sym_SLASH] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_AMP_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT_EQ] = ACTIONS(4426),
    [anon_sym_SLASH_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_PERCENT_EQ] = ACTIONS(4426),
    [anon_sym_LT_LT_EQ] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_COLON2] = ACTIONS(4424),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_CARET_EQ] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_EQ] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4424),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_EQ_GT] = ACTIONS(4426),
    [anon_sym_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_PLUS_EQ] = ACTIONS(4426),
    [anon_sym_STAR_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4426),
    [anon_sym_DASH_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4424),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4424),
  },
  [5156] = {
    [anon_sym_SLASH] = ACTIONS(9417),
    [anon_sym_RBRACK] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_in] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [5157] = {
    [anon_sym_RBRACE] = ACTIONS(12399),
    [sym_comment] = ACTIONS(49),
  },
  [5158] = {
    [anon_sym_SLASH] = ACTIONS(4698),
    [anon_sym_RBRACK] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_AMP_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT_EQ] = ACTIONS(4700),
    [anon_sym_SLASH_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4698),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4698),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4698),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_PERCENT_EQ] = ACTIONS(4700),
    [anon_sym_LT_LT_EQ] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_COLON2] = ACTIONS(4698),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_CARET_EQ] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_EQ] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_in] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4698),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_EQ_GT] = ACTIONS(4700),
    [anon_sym_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_PLUS_EQ] = ACTIONS(4700),
    [anon_sym_STAR_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4698),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4700),
    [anon_sym_DASH_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4698),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_AMP_AMP] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4698),
  },
  [5159] = {
    [anon_sym_RBRACE] = ACTIONS(12401),
    [sym_comment] = ACTIONS(49),
  },
  [5160] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5161] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8001),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12403),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5162] = {
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_COLON] = ACTIONS(4766),
    [sym__string_start] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_in] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4766),
  },
  [5163] = {
    [sym__terminator] = STATE(8002),
    [sym_heredoc_body] = STATE(8002),
    [sym__do] = STATE(8002),
    [anon_sym_do] = ACTIONS(12405),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(12405),
    [anon_sym_SEMI] = ACTIONS(12405),
    [sym_comment] = ACTIONS(49),
  },
  [5164] = {
    [anon_sym_SLASH] = ACTIONS(9248),
    [anon_sym_RBRACK] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_in] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [5165] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8004),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12407),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5166] = {
    [anon_sym_end] = ACTIONS(12409),
    [sym_comment] = ACTIONS(49),
  },
  [5167] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8005),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8005),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8004),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12411),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12411),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12407),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5168] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [5169] = {
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_AMP_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT_EQ] = ACTIONS(5238),
    [anon_sym_SLASH_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_PERCENT_EQ] = ACTIONS(5238),
    [anon_sym_LT_LT_EQ] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_COLON2] = ACTIONS(5236),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_CARET_EQ] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_EQ_GT] = ACTIONS(5238),
    [anon_sym_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_PLUS_EQ] = ACTIONS(5238),
    [anon_sym_STAR_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5238),
    [anon_sym_DASH_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5236),
  },
  [5170] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5171] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(12413),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5172] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8007),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12415),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5173] = {
    [sym__method_name] = STATE(2535),
    [sym_setter] = STATE(2535),
    [sym_symbol] = STATE(2535),
    [sym_operator] = STATE(2535),
    [sym__method_rest] = STATE(8008),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(12417),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(12417),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(12417),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(12417),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [5174] = {
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_COLON2] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5626),
  },
  [5175] = {
    [sym_when] = STATE(8011),
    [sym_else] = STATE(8010),
    [aux_sym_case_repeat2] = STATE(8011),
    [aux_sym_case_repeat1] = STATE(8012),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12419),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(12421),
    [sym_comment] = ACTIONS(49),
  },
  [5176] = {
    [anon_sym_SLASH] = ACTIONS(5744),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_in] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
  },
  [5177] = {
    [anon_sym_end] = ACTIONS(12419),
    [sym_comment] = ACTIONS(49),
  },
  [5178] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(8010),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12419),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5179] = {
    [sym_when] = STATE(8011),
    [sym_else] = STATE(8010),
    [aux_sym_case_repeat2] = STATE(8011),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12419),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5180] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
  },
  [5181] = {
    [anon_sym_SLASH] = ACTIONS(5972),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5972),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_COLON2] = ACTIONS(5972),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_in] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5972),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5972),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_AMP_AMP] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5972),
  },
  [5182] = {
    [sym_heredoc_body] = STATE(8013),
    [sym__terminator] = STATE(8013),
    [sym__line_break] = ACTIONS(12423),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(12423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [5183] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8014),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12425),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5184] = {
    [sym_heredoc_body] = STATE(8015),
    [sym__terminator] = STATE(8015),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(12427),
    [anon_sym_SEMI] = ACTIONS(12427),
    [sym_comment] = ACTIONS(49),
  },
  [5185] = {
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_AMP_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT_EQ] = ACTIONS(6073),
    [anon_sym_SLASH_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6071),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_PERCENT_EQ] = ACTIONS(6073),
    [anon_sym_LT_LT_EQ] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_COLON2] = ACTIONS(6071),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_CARET_EQ] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_in] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_EQ_GT] = ACTIONS(6073),
    [anon_sym_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_PLUS_EQ] = ACTIONS(6073),
    [anon_sym_STAR_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6073),
    [anon_sym_DASH_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6071),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6071),
  },
  [5186] = {
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_AMP_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT_EQ] = ACTIONS(6077),
    [anon_sym_SLASH_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6075),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_PERCENT_EQ] = ACTIONS(6077),
    [anon_sym_LT_LT_EQ] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_COLON2] = ACTIONS(6075),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_CARET_EQ] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_in] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6075),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_EQ_GT] = ACTIONS(6077),
    [anon_sym_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_PLUS_EQ] = ACTIONS(6077),
    [anon_sym_STAR_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6077),
    [anon_sym_DASH_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6075),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6075),
  },
  [5187] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8016),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12429),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5188] = {
    [anon_sym_SLASH] = ACTIONS(6443),
    [anon_sym_RBRACK] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_AMP_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT_EQ] = ACTIONS(6445),
    [anon_sym_SLASH_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6443),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_PERCENT_EQ] = ACTIONS(6445),
    [anon_sym_LT_LT_EQ] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_COLON2] = ACTIONS(6443),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_CARET_EQ] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(6443),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_in] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6443),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_EQ_GT] = ACTIONS(6445),
    [anon_sym_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_PLUS_EQ] = ACTIONS(6445),
    [anon_sym_STAR_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6445),
    [anon_sym_DASH_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6443),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_AMP_AMP] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6443),
  },
  [5189] = {
    [anon_sym_end] = ACTIONS(12431),
    [sym_comment] = ACTIONS(49),
  },
  [5190] = {
    [sym_ensure] = STATE(8018),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12431),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [5191] = {
    [anon_sym_SLASH] = ACTIONS(6471),
    [anon_sym_RBRACK] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_AMP_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT_EQ] = ACTIONS(6473),
    [anon_sym_SLASH_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6471),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6471),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6471),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_PERCENT_EQ] = ACTIONS(6473),
    [anon_sym_LT_LT_EQ] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_COLON2] = ACTIONS(6471),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_CARET_EQ] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_EQ] = ACTIONS(6471),
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_in] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6471),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_EQ_GT] = ACTIONS(6473),
    [anon_sym_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_PLUS_EQ] = ACTIONS(6473),
    [anon_sym_STAR_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6473),
    [anon_sym_DASH_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6471),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6471),
  },
  [5192] = {
    [sym_ensure] = STATE(8018),
    [sym_else] = STATE(8019),
    [anon_sym_end] = ACTIONS(12431),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [5193] = {
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_AMP_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6632),
    [anon_sym_SLASH_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_COLON2] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_CARET_EQ] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_EQ] = ACTIONS(6630),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_in] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_EQ_GT] = ACTIONS(6632),
    [anon_sym_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_PLUS_EQ] = ACTIONS(6632),
    [anon_sym_STAR_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6632),
    [anon_sym_DASH_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6630),
  },
  [5194] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(8021),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(8021),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12433),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [5195] = {
    [sym_elsif] = STATE(8021),
    [sym_else] = STATE(8021),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12435),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [5196] = {
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_AMP_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT_EQ] = ACTIONS(6682),
    [anon_sym_SLASH_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6680),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6680),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_PERCENT_EQ] = ACTIONS(6682),
    [anon_sym_LT_LT_EQ] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_COLON2] = ACTIONS(6680),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_CARET_EQ] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_in] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6680),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_EQ_GT] = ACTIONS(6682),
    [anon_sym_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_PLUS_EQ] = ACTIONS(6682),
    [anon_sym_STAR_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6680),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6682),
    [anon_sym_DASH_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6680),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_AMP_AMP] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6680),
  },
  [5197] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(12437),
  },
  [5198] = {
    [aux_sym_string_array_repeat1] = STATE(8025),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12439),
    [sym__string_end] = ACTIONS(12441),
  },
  [5199] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12443),
  },
  [5200] = {
    [anon_sym_SLASH] = ACTIONS(6692),
    [anon_sym_RBRACK] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_AMP_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT_EQ] = ACTIONS(6694),
    [anon_sym_SLASH_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_PERCENT_EQ] = ACTIONS(6694),
    [anon_sym_LT_LT_EQ] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_COLON2] = ACTIONS(6692),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_CARET_EQ] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_in] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_EQ_GT] = ACTIONS(6694),
    [anon_sym_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_PLUS_EQ] = ACTIONS(6694),
    [anon_sym_STAR_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6694),
    [anon_sym_DASH_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6692),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_AMP_AMP] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6692),
  },
  [5201] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12445),
    [sym__string_end] = ACTIONS(12443),
  },
  [5202] = {
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [5203] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5204] = {
    [aux_sym_exceptions_repeat1] = STATE(8029),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [5205] = {
    [anon_sym_SLASH] = ACTIONS(6215),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_AMP_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT_EQ] = ACTIONS(4446),
    [anon_sym_SLASH_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(6215),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_PERCENT_EQ] = ACTIONS(4446),
    [anon_sym_LT_LT_EQ] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_COLON2] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_CARET_EQ] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_in] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_EQ_GT] = ACTIONS(4446),
    [anon_sym_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_PLUS_EQ] = ACTIONS(4446),
    [anon_sym_STAR_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4446),
    [anon_sym_DASH_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(6215),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_AMP_AMP] = ACTIONS(6215),
    [sym__binary_minus] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(6215),
  },
  [5206] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(12447),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [5207] = {
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [5208] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(864),
    [sym_unary] = STATE(864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(864),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(864),
    [sym_conditional] = STATE(864),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(865),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(864),
    [sym_binary] = STATE(864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym_float] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1553),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(1585),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1589),
    [sym_class_variable] = ACTIONS(1573),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1593),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8548),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [5209] = {
    [sym_heredoc_body] = STATE(5209),
    [aux_sym_call_repeat1] = STATE(5209),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_RBRACK] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [5210] = {
    [sym_heredoc_body] = STATE(5209),
    [aux_sym_call_repeat1] = STATE(5209),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_RBRACK] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [5211] = {
    [aux_sym_argument_list_repeat1] = STATE(5211),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(12452),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [5212] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5213] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5214] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5215] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12455),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5216] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5217] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5218] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5219] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [5220] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5221] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5222] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5223] = {
    [aux_sym_chained_string_repeat1] = STATE(5223),
    [sym_string] = STATE(5223),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_RBRACK] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [5224] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_EQ_GT] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
  },
  [5225] = {
    [anon_sym_end] = ACTIONS(12460),
    [sym_comment] = ACTIONS(49),
  },
  [5226] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_EQ_GT] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
  },
  [5227] = {
    [anon_sym_end] = ACTIONS(12462),
    [sym_comment] = ACTIONS(49),
  },
  [5228] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
  },
  [5229] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12464),
  },
  [5230] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
  },
  [5231] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12466),
    [sym__string_end] = ACTIONS(12464),
  },
  [5232] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_EQ_GT] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
  },
  [5233] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12468),
  },
  [5234] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_EQ_GT] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
  },
  [5235] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_EQ_GT] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
  },
  [5236] = {
    [anon_sym_end] = ACTIONS(12470),
    [sym_comment] = ACTIONS(49),
  },
  [5237] = {
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(8058),
    [sym_heredoc_end] = ACTIONS(8058),
    [anon_sym_POUND_LBRACE] = ACTIONS(8060),
    [sym_escape_sequence] = ACTIONS(8058),
  },
  [5238] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8040),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12472),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5239] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
  },
  [5240] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8042),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12474),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5241] = {
    [anon_sym_end] = ACTIONS(12476),
    [sym_comment] = ACTIONS(49),
  },
  [5242] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8043),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8043),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8042),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12478),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12478),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12474),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5243] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
  },
  [5244] = {
    [anon_sym_RBRACE] = ACTIONS(12480),
    [sym_comment] = ACTIONS(49),
  },
  [5245] = {
    [anon_sym_DOT] = ACTIONS(12482),
    [anon_sym_COLON_COLON] = ACTIONS(12482),
    [sym_comment] = ACTIONS(49),
  },
  [5246] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_EQ_GT] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
  },
  [5247] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_EQ_GT] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
  },
  [5248] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5249] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5250] = {
    [sym_heredoc_body] = STATE(8046),
    [aux_sym_call_repeat1] = STATE(8046),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5251] = {
    [sym_heredoc_body] = STATE(8047),
    [aux_sym_call_repeat1] = STATE(8047),
    [aux_sym_argument_list_repeat1] = STATE(5255),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(4474),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5252] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(916),
    [sym_unary] = STATE(916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(916),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(916),
    [sym_conditional] = STATE(916),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(920),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(916),
    [sym_binary] = STATE(916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1677),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1685),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1689),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8601),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [5253] = {
    [sym_heredoc_body] = STATE(5253),
    [aux_sym_call_repeat1] = STATE(5253),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [5254] = {
    [sym_heredoc_body] = STATE(5253),
    [aux_sym_call_repeat1] = STATE(5253),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [5255] = {
    [aux_sym_argument_list_repeat1] = STATE(5255),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(12484),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [5256] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5257] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5258] = {
    [aux_sym_exceptions_repeat1] = STATE(8049),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [5259] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5260] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5261] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12487),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5262] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5263] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5264] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5265] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5266] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5267] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5268] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5269] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5270] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8052),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12489),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5271] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5272] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5273] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5272),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8053),
    [sym_operator] = STATE(8053),
    [anon_sym_LT] = ACTIONS(8603),
    [anon_sym_SLASH] = ACTIONS(8605),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8605),
    [anon_sym_PLUS_AT] = ACTIONS(8605),
    [anon_sym_LPAREN2] = ACTIONS(8607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8605),
    [anon_sym_GT_GT] = ACTIONS(8605),
    [anon_sym_EQ_TILDE] = ACTIONS(8605),
    [anon_sym_LT_LT] = ACTIONS(8605),
    [anon_sym_TILDE] = ACTIONS(8605),
    [anon_sym_PLUS] = ACTIONS(8603),
    [anon_sym_AMP] = ACTIONS(8605),
    [anon_sym_GT] = ACTIONS(8603),
    [anon_sym_PERCENT] = ACTIONS(8605),
    [anon_sym_DASH_AT] = ACTIONS(8605),
    [anon_sym_EQ_EQ] = ACTIONS(8603),
    [anon_sym_STAR] = ACTIONS(8603),
    [anon_sym_BANG_TILDE] = ACTIONS(8605),
    [sym_constant] = ACTIONS(12491),
    [anon_sym_DASH] = ACTIONS(8603),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8605),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8603),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8605),
    [anon_sym_STAR_STAR] = ACTIONS(8605),
    [anon_sym_PIPE] = ACTIONS(8605),
    [anon_sym_DOT_DOT] = ACTIONS(8605),
    [anon_sym_LT_EQ_GT] = ACTIONS(8605),
    [anon_sym_LT_EQ] = ACTIONS(8603),
    [anon_sym_BANG] = ACTIONS(8603),
    [sym_identifier] = ACTIONS(12491),
    [anon_sym_CARET] = ACTIONS(8605),
  },
  [5274] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5275] = {
    [aux_sym_chained_string_repeat1] = STATE(5275),
    [sym_string] = STATE(5275),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [5276] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_EQ_GT] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
  },
  [5277] = {
    [anon_sym_end] = ACTIONS(12493),
    [sym_comment] = ACTIONS(49),
  },
  [5278] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(8055),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12493),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5279] = {
    [sym_when] = STATE(8056),
    [sym_else] = STATE(8055),
    [aux_sym_case_repeat2] = STATE(8056),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12493),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5280] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8057),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12495),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5281] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_EQ_GT] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
  },
  [5282] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(937),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(938),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8058),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(941),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(942),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12497),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5283] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_EQ_GT] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
  },
  [5284] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_EQ_GT] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
  },
  [5285] = {
    [anon_sym_end] = ACTIONS(12499),
    [sym_comment] = ACTIONS(49),
  },
  [5286] = {
    [sym_ensure] = STATE(8060),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12499),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [5287] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5288] = {
    [aux_sym_chained_string_repeat1] = STATE(5335),
    [sym_string] = STATE(5335),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5289] = {
    [sym_assignment] = STATE(8061),
    [sym_unary] = STATE(8061),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(8061),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(8061),
    [sym_conditional] = STATE(8061),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(8061),
    [sym_binary] = STATE(8061),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5290] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [5291] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5292] = {
    [sym_assignment] = STATE(8062),
    [sym_unary] = STATE(8062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(8062),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(8062),
    [sym_conditional] = STATE(8062),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(8062),
    [sym_binary] = STATE(8062),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5293] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12501),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5294] = {
    [anon_sym_COLON] = ACTIONS(12503),
    [sym_comment] = ACTIONS(49),
  },
  [5295] = {
    [sym_assignment] = STATE(8065),
    [sym_unary] = STATE(8065),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8065),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8065),
    [sym_conditional] = STATE(8065),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8065),
    [sym_binary] = STATE(8065),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5296] = {
    [sym_assignment] = STATE(8066),
    [sym_unary] = STATE(8066),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8066),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8066),
    [sym_conditional] = STATE(8066),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8066),
    [sym_binary] = STATE(8066),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5297] = {
    [sym_assignment] = STATE(8067),
    [sym_unary] = STATE(8067),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8067),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8067),
    [sym_conditional] = STATE(8067),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8067),
    [sym_binary] = STATE(8067),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5298] = {
    [sym_heredoc_body] = STATE(8069),
    [aux_sym_call_repeat1] = STATE(8069),
    [aux_sym_argument_list_repeat1] = STATE(8070),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12505),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5299] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [5300] = {
    [aux_sym_chained_string_repeat1] = STATE(5335),
    [sym_string] = STATE(5335),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12507),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5301] = {
    [sym_heredoc_body] = STATE(8069),
    [aux_sym_call_repeat1] = STATE(8069),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5302] = {
    [sym_assignment] = STATE(8071),
    [sym_unary] = STATE(8071),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(8071),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(8071),
    [sym_conditional] = STATE(8071),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(8071),
    [sym_binary] = STATE(8071),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5303] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5304] = {
    [sym_assignment] = STATE(8072),
    [sym_unary] = STATE(8072),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(8072),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(8072),
    [sym_conditional] = STATE(8072),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(8072),
    [sym_binary] = STATE(8072),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5305] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(12509),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(12509),
    [anon_sym_SLASH_EQ] = ACTIONS(12509),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12509),
    [anon_sym_PIPE_EQ] = ACTIONS(12509),
    [anon_sym_LT_LT_EQ] = ACTIONS(12509),
    [anon_sym_PLUS_EQ] = ACTIONS(12509),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12509),
    [anon_sym_STAR_EQ] = ACTIONS(12509),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12509),
    [anon_sym_CARET_EQ] = ACTIONS(12509),
    [anon_sym_DASH_EQ] = ACTIONS(12509),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12511),
  },
  [5306] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [5307] = {
    [anon_sym_EQ] = ACTIONS(12539),
    [sym_comment] = ACTIONS(3),
  },
  [5308] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [5309] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [5310] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_heredoc_body] = STATE(8084),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym_float] = ACTIONS(4540),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(4552),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(4564),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12541),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5311] = {
    [sym_heredoc_body] = STATE(8085),
    [aux_sym_call_repeat1] = STATE(8085),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5312] = {
    [sym_heredoc_body] = STATE(8086),
    [aux_sym_call_repeat1] = STATE(8086),
    [aux_sym_argument_list_repeat1] = STATE(8087),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(8655),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5313] = {
    [sym_assignment] = STATE(8088),
    [sym_unary] = STATE(8088),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8088),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8088),
    [sym_conditional] = STATE(8088),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8088),
    [sym_binary] = STATE(8088),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5314] = {
    [sym_assignment] = STATE(8089),
    [sym_unary] = STATE(8089),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8089),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(8090),
    [sym_operator_assignment] = STATE(8089),
    [sym_conditional] = STATE(8089),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_subshell] = STATE(2688),
    [sym__arg_or_splat_arg] = STATE(8090),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8089),
    [sym_binary] = STATE(8089),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(4544),
    [sym_character] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5315] = {
    [sym_assignment] = STATE(8091),
    [sym_unary] = STATE(8091),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8091),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8091),
    [sym_conditional] = STATE(8091),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8091),
    [sym_binary] = STATE(8091),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5316] = {
    [sym_assignment] = STATE(8092),
    [sym_unary] = STATE(8092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8092),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8092),
    [sym_conditional] = STATE(8092),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8092),
    [sym_binary] = STATE(8092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5317] = {
    [sym_assignment] = STATE(8093),
    [sym_unary] = STATE(8093),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8093),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8093),
    [sym_conditional] = STATE(8093),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8093),
    [sym_binary] = STATE(8093),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5318] = {
    [sym_assignment] = STATE(8094),
    [sym_unary] = STATE(8094),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8094),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8094),
    [sym_conditional] = STATE(8094),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8094),
    [sym_binary] = STATE(8094),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5319] = {
    [sym_assignment] = STATE(8095),
    [sym_unary] = STATE(8095),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8095),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8095),
    [sym_conditional] = STATE(8095),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8095),
    [sym_binary] = STATE(8095),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5320] = {
    [sym_assignment] = STATE(8096),
    [sym_unary] = STATE(8096),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8096),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8096),
    [sym_conditional] = STATE(8096),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8096),
    [sym_binary] = STATE(8096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5321] = {
    [sym_assignment] = STATE(8098),
    [sym_unary] = STATE(8098),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8098),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8098),
    [sym_conditional] = STATE(8098),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8098),
    [sym_binary] = STATE(8098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5322] = {
    [sym_assignment] = STATE(8099),
    [sym_unary] = STATE(8099),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8099),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8099),
    [sym_conditional] = STATE(8099),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8099),
    [sym_binary] = STATE(8099),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5323] = {
    [sym_assignment] = STATE(8100),
    [sym_unary] = STATE(8100),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8100),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(8100),
    [sym_conditional] = STATE(8100),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8100),
    [sym_binary] = STATE(8100),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [5324] = {
    [sym_heredoc_body] = STATE(8105),
    [sym__argument_list_with_parens] = STATE(8104),
    [aux_sym_call_repeat1] = STATE(8105),
    [sym_argument_list_with_parens] = STATE(8103),
    [sym_operator] = STATE(8103),
    [anon_sym_LT] = ACTIONS(12543),
    [anon_sym_SLASH] = ACTIONS(12545),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12545),
    [anon_sym_PLUS_AT] = ACTIONS(12545),
    [anon_sym_LPAREN2] = ACTIONS(12547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_TILDE] = ACTIONS(12545),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_TILDE] = ACTIONS(12545),
    [anon_sym_PLUS] = ACTIONS(12543),
    [anon_sym_AMP] = ACTIONS(12545),
    [anon_sym_GT] = ACTIONS(12543),
    [anon_sym_PERCENT] = ACTIONS(12545),
    [anon_sym_DASH_AT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12543),
    [anon_sym_STAR] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12545),
    [sym_constant] = ACTIONS(12549),
    [anon_sym_DASH] = ACTIONS(12543),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12543),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12545),
    [anon_sym_STAR_STAR] = ACTIONS(12545),
    [anon_sym_PIPE] = ACTIONS(12545),
    [anon_sym_DOT_DOT] = ACTIONS(12545),
    [anon_sym_LT_EQ_GT] = ACTIONS(12545),
    [anon_sym_LT_EQ] = ACTIONS(12543),
    [anon_sym_BANG] = ACTIONS(12543),
    [sym_identifier] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12545),
  },
  [5325] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(12551),
    [sym_identifier] = ACTIONS(12551),
  },
  [5326] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym__binary_star] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12553),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5327] = {
    [anon_sym_COLON] = ACTIONS(12555),
    [sym_comment] = ACTIONS(49),
  },
  [5328] = {
    [sym_assignment] = STATE(8109),
    [sym_unary] = STATE(8109),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8109),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8109),
    [sym_conditional] = STATE(8109),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8109),
    [sym_binary] = STATE(8109),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5329] = {
    [sym_assignment] = STATE(8110),
    [sym_unary] = STATE(8110),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8110),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8110),
    [sym_conditional] = STATE(8110),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8110),
    [sym_binary] = STATE(8110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5330] = {
    [sym_assignment] = STATE(8111),
    [sym_unary] = STATE(8111),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8111),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8111),
    [sym_conditional] = STATE(8111),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8111),
    [sym_binary] = STATE(8111),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5331] = {
    [sym_heredoc_body] = STATE(8113),
    [aux_sym_call_repeat1] = STATE(8113),
    [aux_sym_argument_list_repeat1] = STATE(8114),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5332] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [5333] = {
    [aux_sym_chained_string_repeat1] = STATE(5390),
    [sym_string] = STATE(5390),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12559),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5334] = {
    [sym_heredoc_body] = STATE(8113),
    [aux_sym_call_repeat1] = STATE(8113),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5335] = {
    [aux_sym_chained_string_repeat1] = STATE(8115),
    [sym_string] = STATE(8115),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [5336] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5337] = {
    [sym_assignment] = STATE(8116),
    [sym_unary] = STATE(8116),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(8116),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(8116),
    [sym_conditional] = STATE(8116),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(8116),
    [sym_binary] = STATE(8116),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [5338] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5339] = {
    [aux_sym_exceptions_repeat1] = STATE(8118),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [5340] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5341] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5342] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5343] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5344] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12561),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5345] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5346] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [5347] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5348] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5349] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5350] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5351] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8121),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12563),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5352] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5353] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5354] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5353),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8122),
    [sym_operator] = STATE(8122),
    [anon_sym_LT] = ACTIONS(8707),
    [anon_sym_SLASH] = ACTIONS(8709),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8709),
    [anon_sym_PLUS_AT] = ACTIONS(8709),
    [anon_sym_LPAREN2] = ACTIONS(8711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8709),
    [anon_sym_GT_GT] = ACTIONS(8709),
    [anon_sym_EQ_TILDE] = ACTIONS(8709),
    [anon_sym_LT_LT] = ACTIONS(8709),
    [anon_sym_TILDE] = ACTIONS(8709),
    [anon_sym_PLUS] = ACTIONS(8707),
    [anon_sym_AMP] = ACTIONS(8709),
    [anon_sym_GT] = ACTIONS(8707),
    [anon_sym_PERCENT] = ACTIONS(8709),
    [anon_sym_DASH_AT] = ACTIONS(8709),
    [anon_sym_EQ_EQ] = ACTIONS(8707),
    [anon_sym_STAR] = ACTIONS(8707),
    [anon_sym_BANG_TILDE] = ACTIONS(8709),
    [sym_constant] = ACTIONS(12565),
    [anon_sym_DASH] = ACTIONS(8707),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(8709),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8707),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8709),
    [anon_sym_STAR_STAR] = ACTIONS(8709),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_DOT_DOT] = ACTIONS(8709),
    [anon_sym_LT_EQ_GT] = ACTIONS(8709),
    [anon_sym_LT_EQ] = ACTIONS(8707),
    [anon_sym_BANG] = ACTIONS(8707),
    [sym_identifier] = ACTIONS(12565),
    [anon_sym_CARET] = ACTIONS(8709),
  },
  [5355] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5356] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [5357] = {
    [aux_sym_chained_string_repeat1] = STATE(5390),
    [sym_string] = STATE(5390),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5358] = {
    [sym_assignment] = STATE(8123),
    [sym_unary] = STATE(8123),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(8123),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(8123),
    [sym_conditional] = STATE(8123),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(8123),
    [sym_binary] = STATE(8123),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [5359] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [5360] = {
    [sym_assignment] = STATE(8124),
    [sym_unary] = STATE(8124),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(8124),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(8124),
    [sym_conditional] = STATE(8124),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(8124),
    [sym_binary] = STATE(8124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [5361] = {
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5362] = {
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5363] = {
    [sym_assignment] = STATE(8125),
    [sym_unary] = STATE(8125),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(8125),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(8125),
    [sym_conditional] = STATE(8125),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(8125),
    [sym_binary] = STATE(8125),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [5364] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [5365] = {
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5366] = {
    [sym_assignment] = STATE(8126),
    [sym_unary] = STATE(8126),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(8126),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(8126),
    [sym_conditional] = STATE(8126),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(8126),
    [sym_binary] = STATE(8126),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [5367] = {
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5368] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(12567),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(12567),
    [anon_sym_SLASH_EQ] = ACTIONS(12567),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12567),
    [anon_sym_PIPE_EQ] = ACTIONS(12567),
    [anon_sym_LT_LT_EQ] = ACTIONS(12567),
    [anon_sym_PLUS_EQ] = ACTIONS(12567),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12567),
    [anon_sym_STAR_EQ] = ACTIONS(12567),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12567),
    [anon_sym_CARET_EQ] = ACTIONS(12567),
    [anon_sym_DASH_EQ] = ACTIONS(12567),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12567),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(12569),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5369] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [5370] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(4610),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(4612),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(4614),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [5371] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym__primary] = STATE(2722),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(2725),
    [sym_method] = STATE(2722),
    [sym_conditional] = STATE(2727),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_subshell] = STATE(2722),
    [sym_unless] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_block_argument] = STATE(2725),
    [sym_range] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2726),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_call] = STATE(2724),
    [sym__argument] = STATE(2725),
    [sym_assignment] = STATE(2727),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_pair] = STATE(2725),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(2725),
    [sym_operator_assignment] = STATE(2727),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_rational] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_lambda] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym__argument_list_with_parens] = STATE(2729),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(2727),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_nil] = STATE(2726),
    [sym_symbol_array] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_scope_resolution] = STATE(2724),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(4616),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(4620),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(4556),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(4628),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(4636),
    [anon_sym_not] = ACTIONS(4638),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4648),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5372] = {
    [anon_sym_EQ] = ACTIONS(12599),
    [sym_comment] = ACTIONS(3),
  },
  [5373] = {
    [aux_sym_chained_string_repeat1] = STATE(8138),
    [sym_string] = STATE(8138),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5374] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [5375] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [5376] = {
    [sym_assignment] = STATE(8139),
    [sym_unary] = STATE(8139),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8139),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(8140),
    [sym_operator_assignment] = STATE(8139),
    [sym_conditional] = STATE(8139),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_subshell] = STATE(2722),
    [sym__arg_or_splat_arg] = STATE(8140),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8139),
    [sym_binary] = STATE(8139),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(4620),
    [sym_character] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5377] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_heredoc_body] = STATE(8141),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym_float] = ACTIONS(4616),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(4620),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(4620),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(4628),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [sym_class_variable] = ACTIONS(4628),
    [sym__block_ampersand] = ACTIONS(4636),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4638),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12601),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5378] = {
    [sym_heredoc_body] = STATE(8142),
    [aux_sym_call_repeat1] = STATE(8142),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5379] = {
    [sym_heredoc_body] = STATE(8143),
    [aux_sym_call_repeat1] = STATE(8143),
    [aux_sym_argument_list_repeat1] = STATE(8144),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(8751),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5380] = {
    [sym_assignment] = STATE(8145),
    [sym_unary] = STATE(8145),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8145),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8145),
    [sym_conditional] = STATE(8145),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8145),
    [sym_binary] = STATE(8145),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5381] = {
    [sym_assignment] = STATE(8146),
    [sym_unary] = STATE(8146),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8146),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8146),
    [sym_conditional] = STATE(8146),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8146),
    [sym_binary] = STATE(8146),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5382] = {
    [sym_assignment] = STATE(8147),
    [sym_unary] = STATE(8147),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8147),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8147),
    [sym_conditional] = STATE(8147),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8147),
    [sym_binary] = STATE(8147),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5383] = {
    [sym_assignment] = STATE(8148),
    [sym_unary] = STATE(8148),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8148),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8148),
    [sym_conditional] = STATE(8148),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8148),
    [sym_binary] = STATE(8148),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5384] = {
    [sym_assignment] = STATE(8149),
    [sym_unary] = STATE(8149),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8149),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8149),
    [sym_conditional] = STATE(8149),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8149),
    [sym_binary] = STATE(8149),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5385] = {
    [sym_assignment] = STATE(8150),
    [sym_unary] = STATE(8150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8150),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8150),
    [sym_conditional] = STATE(8150),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8150),
    [sym_binary] = STATE(8150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5386] = {
    [sym_assignment] = STATE(8151),
    [sym_unary] = STATE(8151),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8151),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8151),
    [sym_conditional] = STATE(8151),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8151),
    [sym_binary] = STATE(8151),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5387] = {
    [sym_assignment] = STATE(8153),
    [sym_unary] = STATE(8153),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8153),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8153),
    [sym_conditional] = STATE(8153),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8153),
    [sym_binary] = STATE(8153),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5388] = {
    [sym_assignment] = STATE(8154),
    [sym_unary] = STATE(8154),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8154),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8154),
    [sym_conditional] = STATE(8154),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8154),
    [sym_binary] = STATE(8154),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5389] = {
    [sym_assignment] = STATE(8155),
    [sym_unary] = STATE(8155),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8155),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(8155),
    [sym_conditional] = STATE(8155),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8155),
    [sym_binary] = STATE(8155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [5390] = {
    [aux_sym_chained_string_repeat1] = STATE(8156),
    [sym_string] = STATE(8156),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [5391] = {
    [aux_sym_chained_string_repeat1] = STATE(5391),
    [sym_string] = STATE(5391),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [5392] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
  },
  [5393] = {
    [anon_sym_end] = ACTIONS(12603),
    [sym_comment] = ACTIONS(49),
  },
  [5394] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_EQ_GT] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
  },
  [5395] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12605),
  },
  [5396] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_EQ_GT] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
  },
  [5397] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12607),
    [sym__string_end] = ACTIONS(12605),
  },
  [5398] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_EQ_GT] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
  },
  [5399] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12609),
  },
  [5400] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [5401] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5402] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [5403] = {
    [sym_assignment] = STATE(8161),
    [sym_unary] = STATE(8161),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8161),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8161),
    [sym_conditional] = STATE(8161),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8161),
    [sym_binary] = STATE(8161),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5404] = {
    [sym_assignment] = STATE(2750),
    [sym_unary] = STATE(2750),
    [sym_right_assignment_list] = STATE(2748),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2750),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_splat_argument] = STATE(8162),
    [sym_operator_assignment] = STATE(2750),
    [sym_conditional] = STATE(2750),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_subshell] = STATE(189),
    [sym__arg_or_splat_arg] = STATE(8162),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(2750),
    [sym_binary] = STATE(2750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [sym__splat_star] = ACTIONS(4668),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(355),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_nil] = ACTIONS(315),
    [sym_super] = ACTIONS(297),
    [sym_character] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5405] = {
    [sym_assignment] = STATE(8163),
    [sym_unary] = STATE(8163),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8163),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8163),
    [sym_conditional] = STATE(8163),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8163),
    [sym_binary] = STATE(8163),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5406] = {
    [sym_assignment] = STATE(8164),
    [sym_unary] = STATE(8164),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8164),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8164),
    [sym_conditional] = STATE(8164),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8164),
    [sym_binary] = STATE(8164),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5407] = {
    [sym_assignment] = STATE(8166),
    [sym_unary] = STATE(8166),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8166),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8166),
    [sym_conditional] = STATE(8166),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8166),
    [sym_binary] = STATE(8166),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5408] = {
    [sym_assignment] = STATE(8167),
    [sym_unary] = STATE(8167),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8167),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8167),
    [sym_conditional] = STATE(8167),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8167),
    [sym_binary] = STATE(8167),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5409] = {
    [sym_assignment] = STATE(8168),
    [sym_unary] = STATE(8168),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8168),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8168),
    [sym_conditional] = STATE(8168),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8168),
    [sym_binary] = STATE(8168),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5410] = {
    [sym_assignment] = STATE(8169),
    [sym_unary] = STATE(8169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8169),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8169),
    [sym_conditional] = STATE(8169),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8169),
    [sym_binary] = STATE(8169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5411] = {
    [sym_assignment] = STATE(8170),
    [sym_unary] = STATE(8170),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8170),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8170),
    [sym_conditional] = STATE(8170),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8170),
    [sym_binary] = STATE(8170),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5412] = {
    [sym_assignment] = STATE(8171),
    [sym_unary] = STATE(8171),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8171),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8171),
    [sym_conditional] = STATE(8171),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8171),
    [sym_binary] = STATE(8171),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5413] = {
    [sym_assignment] = STATE(8172),
    [sym_unary] = STATE(8172),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8172),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(8172),
    [sym_conditional] = STATE(8172),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(8172),
    [sym_binary] = STATE(8172),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5414] = {
    [aux_sym_chained_string_repeat1] = STATE(8173),
    [sym_string] = STATE(8173),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [5415] = {
    [sym_assignment] = STATE(2750),
    [sym_unary] = STATE(2750),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(2750),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_splat_argument] = STATE(8174),
    [sym_operator_assignment] = STATE(2750),
    [sym_conditional] = STATE(2750),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_true] = STATE(2749),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__arg_or_splat_arg] = STATE(8174),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(2750),
    [sym_binary] = STATE(2750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [sym__splat_star] = ACTIONS(4668),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(355),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [sym_global_variable] = ACTIONS(323),
    [anon_sym_nil] = ACTIONS(315),
    [sym_super] = ACTIONS(297),
    [sym_character] = ACTIONS(301),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [5416] = {
    [aux_sym_exceptions_repeat1] = STATE(8175),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [5417] = {
    [sym_assignment] = STATE(8176),
    [sym_unary] = STATE(8176),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(187),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(8176),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(187),
    [sym_operator_assignment] = STATE(8176),
    [sym_conditional] = STATE(8176),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(194),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(187),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(872),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(187),
    [sym_range] = STATE(8176),
    [sym_binary] = STATE(8176),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(187),
    [sym_nil] = STATE(187),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(345),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(365),
    [anon_sym_next] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(327),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(379),
  },
  [5418] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [5419] = {
    [anon_sym_RPAREN] = ACTIONS(12611),
    [sym_comment] = ACTIONS(49),
  },
  [5420] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [5421] = {
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_SLASH] = ACTIONS(10967),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_EQ_GT] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [5422] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [sym__identifier_hash_key] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [5423] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(12613),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [5424] = {
    [anon_sym_RBRACE] = ACTIONS(12615),
    [sym__heredoc_body_start] = ACTIONS(12615),
    [sym_comment] = ACTIONS(49),
  },
  [5425] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9417),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [5426] = {
    [anon_sym_RBRACE] = ACTIONS(12617),
    [sym_comment] = ACTIONS(49),
  },
  [5427] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5428] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9248),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [5429] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8181),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12619),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5430] = {
    [anon_sym_end] = ACTIONS(12621),
    [sym_comment] = ACTIONS(49),
  },
  [5431] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8182),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8182),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8181),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12623),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12623),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12619),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5432] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5433] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [5434] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5435] = {
    [aux_sym_exceptions_repeat1] = STATE(8184),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [5436] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(1005),
    [sym_unary] = STATE(1005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(1005),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(1005),
    [sym_conditional] = STATE(1005),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(1006),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(1005),
    [sym_binary] = STATE(1005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1805),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1825),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_yield] = ACTIONS(1827),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(1829),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [5437] = {
    [sym_heredoc_body] = STATE(5437),
    [aux_sym_call_repeat1] = STATE(5437),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [5438] = {
    [sym_heredoc_body] = STATE(5437),
    [aux_sym_call_repeat1] = STATE(5437),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [5439] = {
    [aux_sym_argument_list_repeat1] = STATE(5439),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(12625),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [5440] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5441] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5442] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5443] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12628),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5444] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5445] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5446] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5447] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5448] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5449] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5450] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [5451] = {
    [aux_sym_chained_string_repeat1] = STATE(5451),
    [sym_string] = STATE(5451),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [5452] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [sym__line_break] = ACTIONS(12632),
    [anon_sym_then] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_when] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym___END__] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_end] = ACTIONS(12632),
    [anon_sym_ensure] = ACTIONS(12632),
    [anon_sym_else] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_elsif] = ACTIONS(12632),
    [ts_builtin_sym_end] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
    [sym__binary_minus] = ACTIONS(12632),
  },
  [5453] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8902),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_and] = ACTIONS(8902),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_PIPE] = ACTIONS(8914),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [5454] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8902),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_and] = ACTIONS(8902),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_PIPE] = ACTIONS(8914),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [5455] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12634),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5456] = {
    [anon_sym_COLON] = ACTIONS(12636),
    [sym_comment] = ACTIONS(49),
  },
  [5457] = {
    [sym_assignment] = STATE(8188),
    [sym_unary] = STATE(8188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8188),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8188),
    [sym_conditional] = STATE(8188),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8188),
    [sym_binary] = STATE(8188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5458] = {
    [sym_assignment] = STATE(8189),
    [sym_unary] = STATE(8189),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8189),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8189),
    [sym_conditional] = STATE(8189),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8189),
    [sym_binary] = STATE(8189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5459] = {
    [sym_assignment] = STATE(8190),
    [sym_unary] = STATE(8190),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8190),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8190),
    [sym_conditional] = STATE(8190),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8190),
    [sym_binary] = STATE(8190),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5460] = {
    [sym_heredoc_body] = STATE(8192),
    [aux_sym_call_repeat1] = STATE(8192),
    [aux_sym_argument_list_repeat1] = STATE(8193),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12638),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5461] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(12636),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [5462] = {
    [aux_sym_chained_string_repeat1] = STATE(2652),
    [sym_string] = STATE(2652),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12640),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5463] = {
    [sym_heredoc_body] = STATE(8192),
    [aux_sym_call_repeat1] = STATE(8192),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5464] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5465] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [5466] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5467] = {
    [sym_assignment] = STATE(8194),
    [sym_unary] = STATE(8194),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8194),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8194),
    [sym_conditional] = STATE(8194),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8194),
    [sym_binary] = STATE(8194),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5468] = {
    [sym_assignment] = STATE(8195),
    [sym_unary] = STATE(8195),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8195),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_splat_argument] = STATE(8196),
    [sym_operator_assignment] = STATE(8195),
    [sym_conditional] = STATE(8195),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_subshell] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(8196),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8195),
    [sym_binary] = STATE(8195),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [sym_global_variable] = ACTIONS(4796),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4788),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5469] = {
    [sym_assignment] = STATE(8197),
    [sym_unary] = STATE(8197),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8197),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8197),
    [sym_conditional] = STATE(8197),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8197),
    [sym_binary] = STATE(8197),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5470] = {
    [sym_assignment] = STATE(8198),
    [sym_unary] = STATE(8198),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8198),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8198),
    [sym_conditional] = STATE(8198),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8198),
    [sym_binary] = STATE(8198),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5471] = {
    [sym_assignment] = STATE(8199),
    [sym_unary] = STATE(8199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8199),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8199),
    [sym_conditional] = STATE(8199),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8199),
    [sym_binary] = STATE(8199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5472] = {
    [sym_assignment] = STATE(8200),
    [sym_unary] = STATE(8200),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8200),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8200),
    [sym_conditional] = STATE(8200),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8200),
    [sym_binary] = STATE(8200),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5473] = {
    [sym_assignment] = STATE(8201),
    [sym_unary] = STATE(8201),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8201),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8201),
    [sym_conditional] = STATE(8201),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8201),
    [sym_binary] = STATE(8201),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5474] = {
    [sym_assignment] = STATE(8202),
    [sym_unary] = STATE(8202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8202),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8202),
    [sym_conditional] = STATE(8202),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8202),
    [sym_binary] = STATE(8202),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5475] = {
    [sym_assignment] = STATE(8203),
    [sym_unary] = STATE(8203),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8203),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8203),
    [sym_conditional] = STATE(8203),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8203),
    [sym_binary] = STATE(8203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5476] = {
    [sym_assignment] = STATE(8204),
    [sym_unary] = STATE(8204),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8204),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8204),
    [sym_conditional] = STATE(8204),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8204),
    [sym_binary] = STATE(8204),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5477] = {
    [sym_assignment] = STATE(8205),
    [sym_unary] = STATE(8205),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8205),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8205),
    [sym_conditional] = STATE(8205),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8205),
    [sym_binary] = STATE(8205),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5478] = {
    [sym_assignment] = STATE(8206),
    [sym_unary] = STATE(8206),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8206),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(8206),
    [sym_conditional] = STATE(8206),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8206),
    [sym_binary] = STATE(8206),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [5479] = {
    [sym_heredoc_body] = STATE(8211),
    [sym__argument_list_with_parens] = STATE(8210),
    [aux_sym_call_repeat1] = STATE(8211),
    [sym_argument_list_with_parens] = STATE(8209),
    [sym_operator] = STATE(8209),
    [anon_sym_LT] = ACTIONS(12642),
    [anon_sym_SLASH] = ACTIONS(12644),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12644),
    [anon_sym_PLUS_AT] = ACTIONS(12644),
    [anon_sym_LPAREN2] = ACTIONS(12646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12644),
    [anon_sym_GT_GT] = ACTIONS(12644),
    [anon_sym_EQ_TILDE] = ACTIONS(12644),
    [anon_sym_LT_LT] = ACTIONS(12644),
    [anon_sym_TILDE] = ACTIONS(12644),
    [anon_sym_PLUS] = ACTIONS(12642),
    [anon_sym_AMP] = ACTIONS(12644),
    [anon_sym_GT] = ACTIONS(12642),
    [anon_sym_PERCENT] = ACTIONS(12644),
    [anon_sym_DASH_AT] = ACTIONS(12644),
    [anon_sym_EQ_EQ] = ACTIONS(12642),
    [anon_sym_STAR] = ACTIONS(12642),
    [anon_sym_BANG_TILDE] = ACTIONS(12644),
    [sym_constant] = ACTIONS(12648),
    [anon_sym_DASH] = ACTIONS(12642),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12644),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12642),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12644),
    [anon_sym_STAR_STAR] = ACTIONS(12644),
    [anon_sym_PIPE] = ACTIONS(12644),
    [anon_sym_DOT_DOT] = ACTIONS(12644),
    [anon_sym_LT_EQ_GT] = ACTIONS(12644),
    [anon_sym_LT_EQ] = ACTIONS(12642),
    [anon_sym_BANG] = ACTIONS(12642),
    [sym_identifier] = ACTIONS(12648),
    [anon_sym_CARET] = ACTIONS(12644),
  },
  [5480] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(12650),
    [sym_identifier] = ACTIONS(12650),
  },
  [5481] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12652),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5482] = {
    [anon_sym_COLON] = ACTIONS(12654),
    [sym_comment] = ACTIONS(49),
  },
  [5483] = {
    [sym_assignment] = STATE(8223),
    [sym_unary] = STATE(8223),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(8223),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(8223),
    [sym_conditional] = STATE(8223),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(8223),
    [sym_binary] = STATE(8223),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [5484] = {
    [sym_assignment] = STATE(8227),
    [sym_unary] = STATE(8227),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(8227),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(8227),
    [sym_conditional] = STATE(8227),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(8227),
    [sym_binary] = STATE(8227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [5485] = {
    [sym_assignment] = STATE(8228),
    [sym_unary] = STATE(8228),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(8228),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(8228),
    [sym_conditional] = STATE(8228),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(8228),
    [sym_binary] = STATE(8228),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [5486] = {
    [sym_heredoc_body] = STATE(8230),
    [aux_sym_call_repeat1] = STATE(8230),
    [aux_sym_argument_list_repeat1] = STATE(8231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5487] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(12654),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [5488] = {
    [aux_sym_chained_string_repeat1] = STATE(2807),
    [sym_string] = STATE(2807),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12680),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5489] = {
    [sym_heredoc_body] = STATE(8230),
    [aux_sym_call_repeat1] = STATE(8230),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5490] = {
    [aux_sym_chained_string_repeat1] = STATE(8232),
    [sym_string] = STATE(8232),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [5491] = {
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
  },
  [5492] = {
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_in] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_EQ] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
  },
  [5493] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(12682),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [5494] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1022),
    [sym_unary] = STATE(1022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1022),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1022),
    [sym_conditional] = STATE(1022),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1023),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1022),
    [sym_binary] = STATE(1022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(1863),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(1865),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [5495] = {
    [sym_heredoc_body] = STATE(5495),
    [aux_sym_call_repeat1] = STATE(5495),
    [sym__heredoc_body_start] = ACTIONS(12684),
    [anon_sym_DOT] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
  },
  [5496] = {
    [sym_heredoc_body] = STATE(5495),
    [aux_sym_call_repeat1] = STATE(5495),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_DOT] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
  },
  [5497] = {
    [aux_sym_argument_list_repeat1] = STATE(5497),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12687),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
  },
  [5498] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
  },
  [5499] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12690),
  },
  [5500] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
  },
  [5501] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12692),
    [sym__string_end] = ACTIONS(12690),
  },
  [5502] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
  },
  [5503] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12694),
  },
  [5504] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
  },
  [5505] = {
    [anon_sym_end] = ACTIONS(12696),
    [sym_comment] = ACTIONS(49),
  },
  [5506] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
  },
  [5507] = {
    [anon_sym_end] = ACTIONS(12698),
    [sym_comment] = ACTIONS(49),
  },
  [5508] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(8239),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12698),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5509] = {
    [sym_when] = STATE(8240),
    [sym_else] = STATE(8239),
    [aux_sym_case_repeat2] = STATE(8240),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(12698),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5510] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
  },
  [5511] = {
    [anon_sym_end] = ACTIONS(12700),
    [sym_comment] = ACTIONS(49),
  },
  [5512] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8242),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12702),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5513] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
  },
  [5514] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1043),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1044),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8243),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1047),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1048),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12704),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [5515] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
  },
  [5516] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
  },
  [5517] = {
    [anon_sym_end] = ACTIONS(12706),
    [sym_comment] = ACTIONS(49),
  },
  [5518] = {
    [sym_ensure] = STATE(8245),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(12706),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [5519] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
  },
  [5520] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12708),
  },
  [5521] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
  },
  [5522] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(12710),
    [sym__string_end] = ACTIONS(12708),
  },
  [5523] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
  },
  [5524] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(12712),
  },
  [5525] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
  },
  [5526] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
  },
  [5527] = {
    [anon_sym_end] = ACTIONS(12714),
    [sym_comment] = ACTIONS(49),
  },
  [5528] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8251),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12716),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5529] = {
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_in] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_EQ] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
  },
  [5530] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8253),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12718),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5531] = {
    [anon_sym_end] = ACTIONS(12720),
    [sym_comment] = ACTIONS(49),
  },
  [5532] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8254),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8254),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8253),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(12722),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(12722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12718),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5533] = {
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_in] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_EQ] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
  },
  [5534] = {
    [anon_sym_RBRACE] = ACTIONS(12724),
    [sym_comment] = ACTIONS(49),
  },
  [5535] = {
    [anon_sym_DOT] = ACTIONS(12726),
    [anon_sym_COLON_COLON] = ACTIONS(12726),
    [sym_comment] = ACTIONS(49),
  },
  [5536] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
  },
  [5537] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
  },
  [5538] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
  },
  [5539] = {
    [anon_sym_end] = ACTIONS(12728),
    [sym_comment] = ACTIONS(49),
  },
  [5540] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(237),
    [sym_module] = STATE(237),
    [sym_chained_string] = STATE(237),
    [sym_until] = STATE(237),
    [sym_regex] = STATE(237),
    [sym_for] = STATE(237),
    [sym_symbol] = STATE(237),
    [sym_if] = STATE(237),
    [sym_begin] = STATE(237),
    [sym__primary] = STATE(237),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(237),
    [sym_singleton_method] = STATE(237),
    [sym__variable] = STATE(238),
    [sym_rational] = STATE(237),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(237),
    [sym_subshell] = STATE(237),
    [sym_yield] = STATE(237),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(237),
    [sym_lambda] = STATE(237),
    [sym_parenthesized_statements] = STATE(237),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(237),
    [sym_break] = STATE(237),
    [sym_next] = STATE(237),
    [sym_string_array] = STATE(237),
    [sym_while] = STATE(237),
    [sym_case] = STATE(237),
    [sym_symbol_array] = STATE(237),
    [sym_array] = STATE(237),
    [sym_hash] = STATE(237),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(238),
    [sym_call] = STATE(238),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(395),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(415),
    [sym_global_variable] = ACTIONS(421),
    [sym_super] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(395),
    [sym_constant] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(421),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(421),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [5541] = {
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [sym_self] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_nil] = ACTIONS(5452),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [anon_sym_next] = ACTIONS(5452),
    [sym_retry] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_return] = ACTIONS(5452),
  },
  [5542] = {
    [anon_sym_RPAREN] = ACTIONS(12730),
    [sym_comment] = ACTIONS(49),
  },
  [5543] = {
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [sym_self] = ACTIONS(10960),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_nil] = ACTIONS(10960),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [anon_sym_next] = ACTIONS(10960),
    [sym_retry] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_return] = ACTIONS(10960),
  },
  [5544] = {
    [anon_sym_DOT] = ACTIONS(10969),
    [anon_sym_in] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_EQ] = ACTIONS(10969),
    [sym_comment] = ACTIONS(49),
  },
  [5545] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(9049),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [anon_sym_and] = ACTIONS(9049),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9061),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [5546] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(9049),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [anon_sym_and] = ACTIONS(9049),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9061),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [5547] = {
    [sym_assignment] = STATE(8259),
    [sym_unary] = STATE(8259),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(8259),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(8259),
    [sym_conditional] = STATE(8259),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(8259),
    [sym_binary] = STATE(8259),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [5548] = {
    [sym_assignment] = STATE(8260),
    [sym_unary] = STATE(8260),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(8260),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(8260),
    [sym_conditional] = STATE(8260),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(8260),
    [sym_binary] = STATE(8260),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [5549] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5550] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5551] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5552] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_heredoc_body] = STATE(8261),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12732),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [5553] = {
    [sym_heredoc_body] = STATE(8262),
    [aux_sym_call_repeat1] = STATE(8262),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5554] = {
    [sym_heredoc_body] = STATE(8263),
    [aux_sym_call_repeat1] = STATE(8263),
    [aux_sym_argument_list_repeat1] = STATE(8264),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9019),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5555] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12734),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5556] = {
    [anon_sym_COLON] = ACTIONS(12736),
    [sym_comment] = ACTIONS(49),
  },
  [5557] = {
    [sym_assignment] = STATE(8267),
    [sym_unary] = STATE(8267),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8267),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8267),
    [sym_conditional] = STATE(8267),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8267),
    [sym_binary] = STATE(8267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5558] = {
    [sym_assignment] = STATE(8268),
    [sym_unary] = STATE(8268),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8268),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8268),
    [sym_conditional] = STATE(8268),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8268),
    [sym_binary] = STATE(8268),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5559] = {
    [sym_assignment] = STATE(8269),
    [sym_unary] = STATE(8269),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8269),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8269),
    [sym_conditional] = STATE(8269),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8269),
    [sym_binary] = STATE(8269),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5560] = {
    [sym_heredoc_body] = STATE(8271),
    [aux_sym_call_repeat1] = STATE(8271),
    [aux_sym_argument_list_repeat1] = STATE(8272),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12738),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5561] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(12736),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5562] = {
    [aux_sym_chained_string_repeat1] = STATE(2969),
    [sym_string] = STATE(2969),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12740),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5563] = {
    [sym_heredoc_body] = STATE(8271),
    [aux_sym_call_repeat1] = STATE(8271),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5564] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5565] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [5566] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_in] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5567] = {
    [sym_assignment] = STATE(8273),
    [sym_unary] = STATE(8273),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8273),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8273),
    [sym_conditional] = STATE(8273),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8273),
    [sym_binary] = STATE(8273),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5568] = {
    [sym_assignment] = STATE(8274),
    [sym_unary] = STATE(8274),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8274),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_splat_argument] = STATE(8275),
    [sym_operator_assignment] = STATE(8274),
    [sym_conditional] = STATE(8274),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_return] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_subshell] = STATE(2926),
    [sym__arg_or_splat_arg] = STATE(8275),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8274),
    [sym_binary] = STATE(8274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [sym_global_variable] = ACTIONS(4936),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4928),
    [sym_character] = ACTIONS(4932),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5569] = {
    [sym_assignment] = STATE(8276),
    [sym_unary] = STATE(8276),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8276),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8276),
    [sym_conditional] = STATE(8276),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8276),
    [sym_binary] = STATE(8276),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5570] = {
    [sym_assignment] = STATE(8277),
    [sym_unary] = STATE(8277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8277),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8277),
    [sym_conditional] = STATE(8277),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8277),
    [sym_binary] = STATE(8277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5571] = {
    [sym_assignment] = STATE(8278),
    [sym_unary] = STATE(8278),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8278),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8278),
    [sym_conditional] = STATE(8278),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8278),
    [sym_binary] = STATE(8278),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5572] = {
    [sym_assignment] = STATE(8279),
    [sym_unary] = STATE(8279),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8279),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8279),
    [sym_conditional] = STATE(8279),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8279),
    [sym_binary] = STATE(8279),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5573] = {
    [sym_assignment] = STATE(8280),
    [sym_unary] = STATE(8280),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8280),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8280),
    [sym_conditional] = STATE(8280),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8280),
    [sym_binary] = STATE(8280),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5574] = {
    [sym_assignment] = STATE(8281),
    [sym_unary] = STATE(8281),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8281),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8281),
    [sym_conditional] = STATE(8281),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8281),
    [sym_binary] = STATE(8281),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5575] = {
    [sym_assignment] = STATE(8282),
    [sym_unary] = STATE(8282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8282),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8282),
    [sym_conditional] = STATE(8282),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8282),
    [sym_binary] = STATE(8282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5576] = {
    [sym_assignment] = STATE(8283),
    [sym_unary] = STATE(8283),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8283),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8283),
    [sym_conditional] = STATE(8283),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8283),
    [sym_binary] = STATE(8283),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5577] = {
    [sym_assignment] = STATE(8284),
    [sym_unary] = STATE(8284),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8284),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8284),
    [sym_conditional] = STATE(8284),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8284),
    [sym_binary] = STATE(8284),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5578] = {
    [sym_assignment] = STATE(8285),
    [sym_unary] = STATE(8285),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8285),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(8285),
    [sym_conditional] = STATE(8285),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8285),
    [sym_binary] = STATE(8285),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [5579] = {
    [sym_heredoc_body] = STATE(8290),
    [sym__argument_list_with_parens] = STATE(8289),
    [aux_sym_call_repeat1] = STATE(8290),
    [sym_argument_list_with_parens] = STATE(8288),
    [sym_operator] = STATE(8288),
    [anon_sym_LT] = ACTIONS(12742),
    [anon_sym_SLASH] = ACTIONS(12744),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12744),
    [anon_sym_PLUS_AT] = ACTIONS(12744),
    [anon_sym_LPAREN2] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_TILDE] = ACTIONS(12744),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_TILDE] = ACTIONS(12744),
    [anon_sym_PLUS] = ACTIONS(12742),
    [anon_sym_AMP] = ACTIONS(12744),
    [anon_sym_GT] = ACTIONS(12742),
    [anon_sym_PERCENT] = ACTIONS(12744),
    [anon_sym_DASH_AT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_STAR] = ACTIONS(12742),
    [anon_sym_BANG_TILDE] = ACTIONS(12744),
    [sym_constant] = ACTIONS(12748),
    [anon_sym_DASH] = ACTIONS(12742),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12742),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12744),
    [anon_sym_STAR_STAR] = ACTIONS(12744),
    [anon_sym_PIPE] = ACTIONS(12744),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_LT_EQ_GT] = ACTIONS(12744),
    [anon_sym_LT_EQ] = ACTIONS(12742),
    [anon_sym_BANG] = ACTIONS(12742),
    [sym_identifier] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12744),
  },
  [5580] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(12750),
    [sym_identifier] = ACTIONS(12750),
  },
  [5581] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(5084),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(5085),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(12752),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [5582] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12754),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_in] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5583] = {
    [anon_sym_COLON] = ACTIONS(12756),
    [sym_comment] = ACTIONS(49),
  },
  [5584] = {
    [sym_assignment] = STATE(8303),
    [sym_unary] = STATE(8303),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(8303),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(8303),
    [sym_conditional] = STATE(8303),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(8303),
    [sym_binary] = STATE(8303),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [5585] = {
    [sym_assignment] = STATE(8307),
    [sym_unary] = STATE(8307),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(8307),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(8307),
    [sym_conditional] = STATE(8307),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(8307),
    [sym_binary] = STATE(8307),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [5586] = {
    [sym_assignment] = STATE(8308),
    [sym_unary] = STATE(8308),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(8308),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(8308),
    [sym_conditional] = STATE(8308),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(8308),
    [sym_binary] = STATE(8308),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [5587] = {
    [sym_do_block] = STATE(5108),
    [sym_block] = STATE(5108),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_until] = ACTIONS(3087),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_unless] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_rescue] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(8417),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [5588] = {
    [sym_heredoc_body] = STATE(8310),
    [aux_sym_call_repeat1] = STATE(8310),
    [aux_sym_argument_list_repeat1] = STATE(8311),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12780),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5589] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(12756),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [5590] = {
    [aux_sym_chained_string_repeat1] = STATE(5623),
    [sym_string] = STATE(5623),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12782),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5591] = {
    [sym_heredoc_body] = STATE(8310),
    [aux_sym_call_repeat1] = STATE(8310),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5592] = {
    [aux_sym_chained_string_repeat1] = STATE(8312),
    [sym_string] = STATE(8312),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [5593] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_in] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5594] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8314),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12784),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5595] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_in] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5596] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_in] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5597] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5596),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8315),
    [sym_operator] = STATE(8315),
    [anon_sym_LT] = ACTIONS(9083),
    [anon_sym_SLASH] = ACTIONS(9085),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9085),
    [anon_sym_PLUS_AT] = ACTIONS(9085),
    [anon_sym_LPAREN2] = ACTIONS(9087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9085),
    [anon_sym_GT_GT] = ACTIONS(9085),
    [anon_sym_EQ_TILDE] = ACTIONS(9085),
    [anon_sym_LT_LT] = ACTIONS(9085),
    [anon_sym_TILDE] = ACTIONS(9085),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_AMP] = ACTIONS(9085),
    [anon_sym_GT] = ACTIONS(9083),
    [anon_sym_PERCENT] = ACTIONS(9085),
    [anon_sym_DASH_AT] = ACTIONS(9085),
    [anon_sym_EQ_EQ] = ACTIONS(9083),
    [anon_sym_STAR] = ACTIONS(9083),
    [anon_sym_BANG_TILDE] = ACTIONS(9085),
    [sym_constant] = ACTIONS(12786),
    [anon_sym_DASH] = ACTIONS(9083),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9085),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9083),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9085),
    [anon_sym_STAR_STAR] = ACTIONS(9085),
    [anon_sym_PIPE] = ACTIONS(9085),
    [anon_sym_DOT_DOT] = ACTIONS(9085),
    [anon_sym_LT_EQ_GT] = ACTIONS(9085),
    [anon_sym_LT_EQ] = ACTIONS(9083),
    [anon_sym_BANG] = ACTIONS(9083),
    [sym_identifier] = ACTIONS(12786),
    [anon_sym_CARET] = ACTIONS(9085),
  },
  [5598] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5599] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5600] = {
    [aux_sym_exceptions_repeat1] = STATE(8317),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [5601] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [5602] = {
    [aux_sym_chained_string_repeat1] = STATE(5623),
    [sym_string] = STATE(5623),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5603] = {
    [sym_assignment] = STATE(8318),
    [sym_unary] = STATE(8318),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8318),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8318),
    [sym_conditional] = STATE(8318),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8318),
    [sym_binary] = STATE(8318),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5604] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [5605] = {
    [sym_assignment] = STATE(8319),
    [sym_unary] = STATE(8319),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8319),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8319),
    [sym_conditional] = STATE(8319),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8319),
    [sym_binary] = STATE(8319),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5606] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [5607] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [5608] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [5609] = {
    [sym_assignment] = STATE(8320),
    [sym_unary] = STATE(8320),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8320),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(8321),
    [sym_operator_assignment] = STATE(8320),
    [sym_conditional] = STATE(8320),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_subshell] = STATE(2948),
    [sym__arg_or_splat_arg] = STATE(8321),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8320),
    [sym_binary] = STATE(8320),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1931),
    [sym_character] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5610] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_heredoc_body] = STATE(8322),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(4956),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1943),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4972),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12788),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5611] = {
    [sym_heredoc_body] = STATE(8323),
    [aux_sym_call_repeat1] = STATE(8323),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5612] = {
    [sym_heredoc_body] = STATE(8324),
    [aux_sym_call_repeat1] = STATE(8324),
    [aux_sym_argument_list_repeat1] = STATE(8325),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9101),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5613] = {
    [sym_assignment] = STATE(8326),
    [sym_unary] = STATE(8326),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8326),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8326),
    [sym_conditional] = STATE(8326),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8326),
    [sym_binary] = STATE(8326),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5614] = {
    [sym_assignment] = STATE(8327),
    [sym_unary] = STATE(8327),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8327),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8327),
    [sym_conditional] = STATE(8327),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8327),
    [sym_binary] = STATE(8327),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5615] = {
    [sym_assignment] = STATE(8328),
    [sym_unary] = STATE(8328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8328),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8328),
    [sym_conditional] = STATE(8328),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8328),
    [sym_binary] = STATE(8328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5616] = {
    [sym_assignment] = STATE(8329),
    [sym_unary] = STATE(8329),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8329),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8329),
    [sym_conditional] = STATE(8329),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8329),
    [sym_binary] = STATE(8329),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5617] = {
    [sym_assignment] = STATE(8330),
    [sym_unary] = STATE(8330),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8330),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8330),
    [sym_conditional] = STATE(8330),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8330),
    [sym_binary] = STATE(8330),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5618] = {
    [sym_assignment] = STATE(8331),
    [sym_unary] = STATE(8331),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8331),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8331),
    [sym_conditional] = STATE(8331),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8331),
    [sym_binary] = STATE(8331),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5619] = {
    [sym_assignment] = STATE(8332),
    [sym_unary] = STATE(8332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8332),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8332),
    [sym_conditional] = STATE(8332),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8332),
    [sym_binary] = STATE(8332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5620] = {
    [sym_assignment] = STATE(8334),
    [sym_unary] = STATE(8334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8334),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8334),
    [sym_conditional] = STATE(8334),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8334),
    [sym_binary] = STATE(8334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5621] = {
    [sym_assignment] = STATE(8335),
    [sym_unary] = STATE(8335),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8335),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8335),
    [sym_conditional] = STATE(8335),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8335),
    [sym_binary] = STATE(8335),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5622] = {
    [sym_assignment] = STATE(8336),
    [sym_unary] = STATE(8336),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8336),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(8336),
    [sym_conditional] = STATE(8336),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8336),
    [sym_binary] = STATE(8336),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [5623] = {
    [aux_sym_chained_string_repeat1] = STATE(8337),
    [sym_string] = STATE(8337),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [5624] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1104),
    [sym_unary] = STATE(1104),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(1104),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1104),
    [sym_conditional] = STATE(1104),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(1105),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1104),
    [sym_binary] = STATE(1104),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(1941),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(1949),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(1953),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(1965),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [5625] = {
    [sym_heredoc_body] = STATE(5625),
    [aux_sym_call_repeat1] = STATE(5625),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_in] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12684),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
  },
  [5626] = {
    [sym_heredoc_body] = STATE(5625),
    [aux_sym_call_repeat1] = STATE(5625),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_in] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
  },
  [5627] = {
    [aux_sym_argument_list_repeat1] = STATE(5627),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(12790),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [5628] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5629] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5630] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5631] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12793),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5632] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5633] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5634] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5635] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [5636] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5637] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5638] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5639] = {
    [aux_sym_chained_string_repeat1] = STATE(5639),
    [sym_string] = STATE(5639),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_in] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [5640] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [sym__line_break] = ACTIONS(12797),
    [anon_sym_then] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_when] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym___END__] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_end] = ACTIONS(12797),
    [anon_sym_ensure] = ACTIONS(12797),
    [anon_sym_else] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_elsif] = ACTIONS(12797),
    [ts_builtin_sym_end] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
    [sym__binary_minus] = ACTIONS(12797),
  },
  [5641] = {
    [anon_sym_end] = ACTIONS(12799),
    [sym_comment] = ACTIONS(49),
  },
  [5642] = {
    [aux_sym_undef_repeat1] = STATE(8340),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [5643] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [5644] = {
    [sym_assignment] = STATE(8350),
    [sym_unary] = STATE(8350),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(8350),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(8350),
    [sym_conditional] = STATE(8350),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(8350),
    [sym_binary] = STATE(8350),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym_float] = ACTIONS(12801),
    [anon_sym_until] = ACTIONS(1235),
    [sym_self] = ACTIONS(12803),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_unless] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym_complex] = ACTIONS(12805),
    [sym__simple_symbol] = ACTIONS(1253),
    [sym_super] = ACTIONS(12803),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_character] = ACTIONS(12805),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_while] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(12811),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_PIPE] = ACTIONS(5186),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [anon_sym_yield] = ACTIONS(12817),
    [sym_class_variable] = ACTIONS(12811),
    [sym__symbol_start] = ACTIONS(1285),
    [anon_sym_not] = ACTIONS(12819),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [sym_global_variable] = ACTIONS(12811),
    [anon_sym_class] = ACTIONS(1295),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [sym_retry] = ACTIONS(12801),
    [sym__regex_start] = ACTIONS(1309),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_FALSE] = ACTIONS(1303),
    [sym_redo] = ACTIONS(12801),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_if] = ACTIONS(1313),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [5645] = {
    [sym_assignment] = STATE(8355),
    [sym_unary] = STATE(8355),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(8355),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(8355),
    [sym_conditional] = STATE(8355),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(8355),
    [sym_binary] = STATE(8355),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [5646] = {
    [sym__line_break] = ACTIONS(12829),
    [sym_float] = ACTIONS(12831),
    [anon_sym_until] = ACTIONS(12831),
    [anon_sym_undef] = ACTIONS(12831),
    [sym_self] = ACTIONS(12831),
    [anon_sym_BEGIN] = ACTIONS(12831),
    [anon_sym_TILDE] = ACTIONS(12829),
    [anon_sym_unless] = ACTIONS(12831),
    [anon_sym_PLUS] = ACTIONS(12831),
    [sym__symbol_array_start] = ACTIONS(12829),
    [sym__simple_symbol] = ACTIONS(12829),
    [sym_complex] = ACTIONS(12829),
    [sym_heredoc_beginning] = ACTIONS(12829),
    [sym_super] = ACTIONS(12831),
    [anon_sym_alias] = ACTIONS(12831),
    [anon_sym_LBRACK2] = ACTIONS(12829),
    [anon_sym_nil] = ACTIONS(12831),
    [sym_character] = ACTIONS(12829),
    [anon_sym_LBRACE] = ACTIONS(12829),
    [anon_sym_END] = ACTIONS(12831),
    [sym_constant] = ACTIONS(12831),
    [anon_sym_while] = ACTIONS(12831),
    [sym_instance_variable] = ACTIONS(12829),
    [sym__heredoc_body_start] = ACTIONS(12829),
    [anon_sym_defined_QMARK] = ACTIONS(12829),
    [sym__string_start] = ACTIONS(12829),
    [anon_sym_true] = ACTIONS(12831),
    [anon_sym_for] = ACTIONS(12831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(12829),
    [anon_sym_NIL] = ACTIONS(12831),
    [anon_sym_COLON_COLON] = ACTIONS(12829),
    [anon_sym_def] = ACTIONS(12831),
    [sym_identifier] = ACTIONS(12831),
    [anon_sym_yield] = ACTIONS(12831),
    [sym_class_variable] = ACTIONS(12829),
    [sym__symbol_start] = ACTIONS(12829),
    [anon_sym_not] = ACTIONS(12831),
    [anon_sym_TRUE] = ACTIONS(12831),
    [anon_sym_case] = ACTIONS(12831),
    [anon_sym_SEMI] = ACTIONS(12829),
    [anon_sym_LPAREN] = ACTIONS(12829),
    [anon_sym_break] = ACTIONS(12831),
    [sym_global_variable] = ACTIONS(12829),
    [anon_sym_class] = ACTIONS(12831),
    [sym__subshell_start] = ACTIONS(12829),
    [anon_sym_module] = ACTIONS(12831),
    [anon_sym_begin] = ACTIONS(12831),
    [anon_sym_false] = ACTIONS(12831),
    [anon_sym_STAR] = ACTIONS(12829),
    [sym__unary_minus] = ACTIONS(12829),
    [anon_sym_next] = ACTIONS(12831),
    [sym_retry] = ACTIONS(12831),
    [sym__regex_start] = ACTIONS(12829),
    [anon_sym_end] = ACTIONS(12831),
    [sym_integer] = ACTIONS(12831),
    [anon_sym_FALSE] = ACTIONS(12831),
    [sym_redo] = ACTIONS(12831),
    [anon_sym_BANG] = ACTIONS(12829),
    [anon_sym_if] = ACTIONS(12831),
    [sym__string_array_start] = ACTIONS(12829),
    [anon_sym_return] = ACTIONS(12831),
  },
  [5647] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(12833),
  },
  [5648] = {
    [aux_sym_block_parameters_repeat1] = STATE(8359),
    [anon_sym_PIPE] = ACTIONS(12835),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [5649] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(12835),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(12839),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [5650] = {
    [aux_sym_method_parameters_repeat1] = STATE(8362),
    [anon_sym_PIPE] = ACTIONS(12835),
    [anon_sym_COMMA] = ACTIONS(12841),
    [anon_sym_SEMI] = ACTIONS(12839),
    [sym_comment] = ACTIONS(49),
  },
  [5651] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [5652] = {
    [aux_sym_chained_string_repeat1] = STATE(5704),
    [sym_string] = STATE(5704),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [5653] = {
    [sym_assignment] = STATE(8363),
    [sym_unary] = STATE(8363),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8363),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(8363),
    [sym_conditional] = STATE(8363),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(8363),
    [sym_binary] = STATE(8363),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5654] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [5655] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5656] = {
    [sym_assignment] = STATE(8364),
    [sym_unary] = STATE(8364),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8364),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(8364),
    [sym_conditional] = STATE(8364),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(8364),
    [sym_binary] = STATE(8364),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5657] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12843),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5658] = {
    [anon_sym_COLON] = ACTIONS(12845),
    [sym_comment] = ACTIONS(49),
  },
  [5659] = {
    [sym_assignment] = STATE(8367),
    [sym_unary] = STATE(8367),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8367),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8367),
    [sym_conditional] = STATE(8367),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8367),
    [sym_binary] = STATE(8367),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5660] = {
    [sym_assignment] = STATE(8368),
    [sym_unary] = STATE(8368),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8368),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8368),
    [sym_conditional] = STATE(8368),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8368),
    [sym_binary] = STATE(8368),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5661] = {
    [sym_assignment] = STATE(8369),
    [sym_unary] = STATE(8369),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8369),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8369),
    [sym_conditional] = STATE(8369),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8369),
    [sym_binary] = STATE(8369),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5662] = {
    [sym_heredoc_body] = STATE(8371),
    [aux_sym_call_repeat1] = STATE(8371),
    [aux_sym_argument_list_repeat1] = STATE(8372),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12847),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [5663] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [5664] = {
    [aux_sym_chained_string_repeat1] = STATE(5704),
    [sym_string] = STATE(5704),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12849),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [5665] = {
    [sym_heredoc_body] = STATE(8371),
    [aux_sym_call_repeat1] = STATE(8371),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [5666] = {
    [sym__argument] = STATE(8373),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(8373),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8373),
    [sym_hash_splat_argument] = STATE(8373),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(8374),
    [sym_block_argument] = STATE(8373),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [5667] = {
    [sym__argument] = STATE(8373),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(8373),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8373),
    [sym_hash_splat_argument] = STATE(8373),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(8374),
    [sym_block_argument] = STATE(8373),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [5668] = {
    [sym_assignment] = STATE(8375),
    [sym_unary] = STATE(8375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8375),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(8375),
    [sym_conditional] = STATE(8375),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(8375),
    [sym_binary] = STATE(8375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5669] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5670] = {
    [sym__argument] = STATE(8373),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(8373),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8373),
    [sym_hash_splat_argument] = STATE(8373),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(8374),
    [sym_block_argument] = STATE(8373),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [5671] = {
    [sym_assignment] = STATE(8376),
    [sym_unary] = STATE(8376),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8376),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(8376),
    [sym_conditional] = STATE(8376),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(8376),
    [sym_binary] = STATE(8376),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5672] = {
    [sym__argument] = STATE(8373),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(8373),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8373),
    [sym_hash_splat_argument] = STATE(8373),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym__argument_list_with_parens] = STATE(8374),
    [sym_block_argument] = STATE(8373),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(5042),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(5044),
    [sym_self] = ACTIONS(5046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5066),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(5076),
  },
  [5673] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12851),
    [anon_sym_GT_GT_EQ] = ACTIONS(12851),
    [anon_sym_SLASH_EQ] = ACTIONS(12851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12851),
    [anon_sym_LT_LT_EQ] = ACTIONS(12851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12851),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(12851),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12853),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(12851),
    [anon_sym_PLUS_EQ] = ACTIONS(12851),
    [anon_sym_STAR_EQ] = ACTIONS(12851),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12851),
    [anon_sym_DASH_EQ] = ACTIONS(12851),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12851),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5674] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [5675] = {
    [anon_sym_EQ] = ACTIONS(12881),
    [sym_comment] = ACTIONS(3),
  },
  [5676] = {
    [aux_sym_chained_string_repeat1] = STATE(8388),
    [sym_string] = STATE(8388),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [5677] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [5678] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [5679] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_heredoc_body] = STATE(8389),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym_float] = ACTIONS(5042),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(5046),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(5054),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(5066),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(12883),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5680] = {
    [sym_heredoc_body] = STATE(8390),
    [aux_sym_call_repeat1] = STATE(8390),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [5681] = {
    [sym_heredoc_body] = STATE(8391),
    [aux_sym_call_repeat1] = STATE(8391),
    [aux_sym_argument_list_repeat1] = STATE(8392),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9198),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [5682] = {
    [sym_assignment] = STATE(8393),
    [sym_unary] = STATE(8393),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8393),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8393),
    [sym_conditional] = STATE(8393),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8393),
    [sym_binary] = STATE(8393),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5683] = {
    [sym_assignment] = STATE(8394),
    [sym_unary] = STATE(8394),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8394),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8395),
    [sym_operator_assignment] = STATE(8394),
    [sym_conditional] = STATE(8394),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_subshell] = STATE(3000),
    [sym__arg_or_splat_arg] = STATE(8395),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8394),
    [sym_binary] = STATE(8394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(5046),
    [sym_character] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5684] = {
    [sym_assignment] = STATE(8396),
    [sym_unary] = STATE(8396),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8396),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8396),
    [sym_conditional] = STATE(8396),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8396),
    [sym_binary] = STATE(8396),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5685] = {
    [sym_assignment] = STATE(8397),
    [sym_unary] = STATE(8397),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8397),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8397),
    [sym_conditional] = STATE(8397),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8397),
    [sym_binary] = STATE(8397),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5686] = {
    [sym_assignment] = STATE(8398),
    [sym_unary] = STATE(8398),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8398),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8398),
    [sym_conditional] = STATE(8398),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8398),
    [sym_binary] = STATE(8398),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5687] = {
    [sym_assignment] = STATE(8399),
    [sym_unary] = STATE(8399),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8399),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8399),
    [sym_conditional] = STATE(8399),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8399),
    [sym_binary] = STATE(8399),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5688] = {
    [sym_assignment] = STATE(8400),
    [sym_unary] = STATE(8400),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8400),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8400),
    [sym_conditional] = STATE(8400),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8400),
    [sym_binary] = STATE(8400),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5689] = {
    [sym_assignment] = STATE(8401),
    [sym_unary] = STATE(8401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8401),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8401),
    [sym_conditional] = STATE(8401),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8401),
    [sym_binary] = STATE(8401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5690] = {
    [sym_assignment] = STATE(8403),
    [sym_unary] = STATE(8403),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8403),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8403),
    [sym_conditional] = STATE(8403),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8403),
    [sym_binary] = STATE(8403),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5691] = {
    [sym_assignment] = STATE(8404),
    [sym_unary] = STATE(8404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8404),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8404),
    [sym_conditional] = STATE(8404),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8404),
    [sym_binary] = STATE(8404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5692] = {
    [sym_assignment] = STATE(8405),
    [sym_unary] = STATE(8405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8405),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(8405),
    [sym_conditional] = STATE(8405),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8405),
    [sym_binary] = STATE(8405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [5693] = {
    [sym_heredoc_body] = STATE(8410),
    [sym__argument_list_with_parens] = STATE(8409),
    [aux_sym_call_repeat1] = STATE(8410),
    [sym_argument_list_with_parens] = STATE(8408),
    [sym_operator] = STATE(8408),
    [anon_sym_LT] = ACTIONS(12885),
    [anon_sym_SLASH] = ACTIONS(12887),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12887),
    [anon_sym_PLUS_AT] = ACTIONS(12887),
    [anon_sym_LPAREN2] = ACTIONS(12889),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12887),
    [anon_sym_GT_GT] = ACTIONS(12887),
    [anon_sym_EQ_TILDE] = ACTIONS(12887),
    [anon_sym_LT_LT] = ACTIONS(12887),
    [anon_sym_TILDE] = ACTIONS(12887),
    [anon_sym_PLUS] = ACTIONS(12885),
    [anon_sym_AMP] = ACTIONS(12887),
    [anon_sym_GT] = ACTIONS(12885),
    [anon_sym_PERCENT] = ACTIONS(12887),
    [anon_sym_DASH_AT] = ACTIONS(12887),
    [anon_sym_EQ_EQ] = ACTIONS(12885),
    [anon_sym_STAR] = ACTIONS(12885),
    [anon_sym_BANG_TILDE] = ACTIONS(12887),
    [sym_constant] = ACTIONS(12891),
    [anon_sym_DASH] = ACTIONS(12885),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12887),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12887),
    [anon_sym_STAR_STAR] = ACTIONS(12887),
    [anon_sym_PIPE] = ACTIONS(12887),
    [anon_sym_DOT_DOT] = ACTIONS(12887),
    [anon_sym_LT_EQ_GT] = ACTIONS(12887),
    [anon_sym_LT_EQ] = ACTIONS(12885),
    [anon_sym_BANG] = ACTIONS(12885),
    [sym_identifier] = ACTIONS(12891),
    [anon_sym_CARET] = ACTIONS(12887),
  },
  [5694] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(12893),
    [sym_identifier] = ACTIONS(12893),
  },
  [5695] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12895),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5696] = {
    [anon_sym_COLON] = ACTIONS(12897),
    [sym_comment] = ACTIONS(49),
  },
  [5697] = {
    [sym_assignment] = STATE(8414),
    [sym_unary] = STATE(8414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8414),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8414),
    [sym_conditional] = STATE(8414),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8414),
    [sym_binary] = STATE(8414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5698] = {
    [sym_assignment] = STATE(8415),
    [sym_unary] = STATE(8415),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8415),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8415),
    [sym_conditional] = STATE(8415),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8415),
    [sym_binary] = STATE(8415),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5699] = {
    [sym_assignment] = STATE(8416),
    [sym_unary] = STATE(8416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8416),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8416),
    [sym_conditional] = STATE(8416),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8416),
    [sym_binary] = STATE(8416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5700] = {
    [sym_heredoc_body] = STATE(8418),
    [aux_sym_call_repeat1] = STATE(8418),
    [aux_sym_argument_list_repeat1] = STATE(8419),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12899),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5701] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [5702] = {
    [aux_sym_chained_string_repeat1] = STATE(5761),
    [sym_string] = STATE(5761),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12901),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5703] = {
    [sym_heredoc_body] = STATE(8418),
    [aux_sym_call_repeat1] = STATE(8418),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [5704] = {
    [aux_sym_chained_string_repeat1] = STATE(8420),
    [sym_string] = STATE(8420),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [5705] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [5706] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [5707] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [5708] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [5709] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_PIPE] = ACTIONS(5168),
    [sym__binary_minus] = ACTIONS(5158),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
  },
  [5710] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [sym__line_break] = ACTIONS(12905),
    [anon_sym_then] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_when] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym___END__] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_end] = ACTIONS(12905),
    [anon_sym_ensure] = ACTIONS(12905),
    [anon_sym_else] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_elsif] = ACTIONS(12905),
    [ts_builtin_sym_end] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
  },
  [5711] = {
    [anon_sym_end] = ACTIONS(12907),
    [sym_comment] = ACTIONS(49),
  },
  [5712] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5713] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8423),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12909),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5714] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5715] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5716] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5715),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8424),
    [sym_operator] = STATE(8424),
    [anon_sym_LT] = ACTIONS(9256),
    [anon_sym_SLASH] = ACTIONS(9258),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9258),
    [anon_sym_PLUS_AT] = ACTIONS(9258),
    [anon_sym_LPAREN2] = ACTIONS(9260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9258),
    [anon_sym_GT_GT] = ACTIONS(9258),
    [anon_sym_EQ_TILDE] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9258),
    [anon_sym_TILDE] = ACTIONS(9258),
    [anon_sym_PLUS] = ACTIONS(9256),
    [anon_sym_AMP] = ACTIONS(9258),
    [anon_sym_GT] = ACTIONS(9256),
    [anon_sym_PERCENT] = ACTIONS(9258),
    [anon_sym_DASH_AT] = ACTIONS(9258),
    [anon_sym_EQ_EQ] = ACTIONS(9256),
    [anon_sym_STAR] = ACTIONS(9256),
    [anon_sym_BANG_TILDE] = ACTIONS(9258),
    [sym_constant] = ACTIONS(12911),
    [anon_sym_DASH] = ACTIONS(9256),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9256),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9258),
    [anon_sym_STAR_STAR] = ACTIONS(9258),
    [anon_sym_PIPE] = ACTIONS(9258),
    [anon_sym_DOT_DOT] = ACTIONS(9258),
    [anon_sym_LT_EQ_GT] = ACTIONS(9258),
    [anon_sym_LT_EQ] = ACTIONS(9256),
    [anon_sym_BANG] = ACTIONS(9256),
    [sym_identifier] = ACTIONS(12911),
    [anon_sym_CARET] = ACTIONS(9258),
  },
  [5717] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5718] = {
    [sym_assignment] = STATE(8425),
    [sym_unary] = STATE(8425),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8425),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(8425),
    [sym_conditional] = STATE(8425),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(8425),
    [sym_binary] = STATE(8425),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5719] = {
    [sym_assignment] = STATE(8426),
    [sym_unary] = STATE(8426),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8426),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(8426),
    [sym_conditional] = STATE(8426),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(8426),
    [sym_binary] = STATE(8426),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5720] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5721] = {
    [sym_assignment] = STATE(8427),
    [sym_unary] = STATE(8427),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(8427),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(8427),
    [sym_conditional] = STATE(8427),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(8427),
    [sym_binary] = STATE(8427),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [5722] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12913),
    [anon_sym_GT_GT_EQ] = ACTIONS(12913),
    [anon_sym_SLASH_EQ] = ACTIONS(12913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12913),
    [anon_sym_LT_LT_EQ] = ACTIONS(12913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12913),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(12913),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12915),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(12913),
    [anon_sym_PLUS_EQ] = ACTIONS(12913),
    [anon_sym_STAR_EQ] = ACTIONS(12913),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12913),
    [anon_sym_DASH_EQ] = ACTIONS(12913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12913),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5723] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [5724] = {
    [anon_sym_EQ] = ACTIONS(12943),
    [sym_comment] = ACTIONS(3),
  },
  [5725] = {
    [aux_sym_exceptions_repeat1] = STATE(8440),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(12945),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [5726] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8441),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(12947),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5727] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [5728] = {
    [aux_sym_chained_string_repeat1] = STATE(5761),
    [sym_string] = STATE(5761),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5729] = {
    [sym_assignment] = STATE(8442),
    [sym_unary] = STATE(8442),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(8442),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(8442),
    [sym_conditional] = STATE(8442),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(8442),
    [sym_binary] = STATE(8442),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [5730] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [5731] = {
    [sym_assignment] = STATE(8443),
    [sym_unary] = STATE(8443),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(8443),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(8443),
    [sym_conditional] = STATE(8443),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(8443),
    [sym_binary] = STATE(8443),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [5732] = {
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [5733] = {
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [5734] = {
    [sym_assignment] = STATE(8444),
    [sym_unary] = STATE(8444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(8444),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(8444),
    [sym_conditional] = STATE(8444),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(8444),
    [sym_binary] = STATE(8444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [5735] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [5736] = {
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [5737] = {
    [sym_assignment] = STATE(8445),
    [sym_unary] = STATE(8445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(8445),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(8445),
    [sym_conditional] = STATE(8445),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(8445),
    [sym_binary] = STATE(8445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [5738] = {
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [5739] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(12949),
    [anon_sym_GT_GT_EQ] = ACTIONS(12949),
    [anon_sym_SLASH_EQ] = ACTIONS(12949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(12949),
    [anon_sym_LT_LT_EQ] = ACTIONS(12949),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12949),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(12949),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(12951),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(12949),
    [anon_sym_PLUS_EQ] = ACTIONS(12949),
    [anon_sym_STAR_EQ] = ACTIONS(12949),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12949),
    [anon_sym_DASH_EQ] = ACTIONS(12949),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12949),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5740] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [5741] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(5098),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(5100),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(5102),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [5742] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym__primary] = STATE(3030),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(3033),
    [sym_method] = STATE(3030),
    [sym_conditional] = STATE(3035),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_subshell] = STATE(3030),
    [sym_unless] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_block_argument] = STATE(3033),
    [sym_range] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3034),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_call] = STATE(3032),
    [sym__argument] = STATE(3033),
    [sym_assignment] = STATE(3035),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_pair] = STATE(3033),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(3033),
    [sym_operator_assignment] = STATE(3035),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_rational] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_lambda] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym__argument_list_with_parens] = STATE(3037),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(3035),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_nil] = STATE(3034),
    [sym_symbol_array] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_scope_resolution] = STATE(3032),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(5106),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(5108),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5118),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5126),
    [anon_sym_not] = ACTIONS(5128),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(5138),
  },
  [5743] = {
    [anon_sym_EQ] = ACTIONS(12981),
    [sym_comment] = ACTIONS(3),
  },
  [5744] = {
    [aux_sym_chained_string_repeat1] = STATE(8457),
    [sym_string] = STATE(8457),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5745] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [5746] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [5747] = {
    [sym_assignment] = STATE(8458),
    [sym_unary] = STATE(8458),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8458),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(8459),
    [sym_operator_assignment] = STATE(8458),
    [sym_conditional] = STATE(8458),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_subshell] = STATE(3030),
    [sym__arg_or_splat_arg] = STATE(8459),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8458),
    [sym_binary] = STATE(8458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(5110),
    [sym_character] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5748] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_heredoc_body] = STATE(8460),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym_float] = ACTIONS(5106),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(5110),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(5110),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(5118),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_class_variable] = ACTIONS(5118),
    [sym__block_ampersand] = ACTIONS(5126),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(5128),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(12983),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5749] = {
    [sym_heredoc_body] = STATE(8461),
    [aux_sym_call_repeat1] = STATE(8461),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5750] = {
    [sym_heredoc_body] = STATE(8462),
    [aux_sym_call_repeat1] = STATE(8462),
    [aux_sym_argument_list_repeat1] = STATE(8463),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9314),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5751] = {
    [sym_assignment] = STATE(8464),
    [sym_unary] = STATE(8464),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8464),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8464),
    [sym_conditional] = STATE(8464),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8464),
    [sym_binary] = STATE(8464),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5752] = {
    [sym_assignment] = STATE(8465),
    [sym_unary] = STATE(8465),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8465),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8465),
    [sym_conditional] = STATE(8465),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8465),
    [sym_binary] = STATE(8465),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5753] = {
    [sym_assignment] = STATE(8466),
    [sym_unary] = STATE(8466),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8466),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8466),
    [sym_conditional] = STATE(8466),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8466),
    [sym_binary] = STATE(8466),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5754] = {
    [sym_assignment] = STATE(8467),
    [sym_unary] = STATE(8467),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8467),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8467),
    [sym_conditional] = STATE(8467),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8467),
    [sym_binary] = STATE(8467),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5755] = {
    [sym_assignment] = STATE(8468),
    [sym_unary] = STATE(8468),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8468),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8468),
    [sym_conditional] = STATE(8468),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8468),
    [sym_binary] = STATE(8468),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5756] = {
    [sym_assignment] = STATE(8469),
    [sym_unary] = STATE(8469),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8469),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8469),
    [sym_conditional] = STATE(8469),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8469),
    [sym_binary] = STATE(8469),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5757] = {
    [sym_assignment] = STATE(8470),
    [sym_unary] = STATE(8470),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8470),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8470),
    [sym_conditional] = STATE(8470),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8470),
    [sym_binary] = STATE(8470),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5758] = {
    [sym_assignment] = STATE(8472),
    [sym_unary] = STATE(8472),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8472),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8472),
    [sym_conditional] = STATE(8472),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8472),
    [sym_binary] = STATE(8472),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5759] = {
    [sym_assignment] = STATE(8473),
    [sym_unary] = STATE(8473),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8473),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8473),
    [sym_conditional] = STATE(8473),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8473),
    [sym_binary] = STATE(8473),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5760] = {
    [sym_assignment] = STATE(8474),
    [sym_unary] = STATE(8474),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8474),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(8474),
    [sym_conditional] = STATE(8474),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8474),
    [sym_binary] = STATE(8474),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [5761] = {
    [aux_sym_chained_string_repeat1] = STATE(8475),
    [sym_string] = STATE(8475),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [5762] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5763] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5764] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5765] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5766] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [5767] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(12985),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5768] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5769] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5770] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [5771] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5772] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [5773] = {
    [aux_sym_chained_string_repeat1] = STATE(5773),
    [sym_string] = STATE(5773),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [5774] = {
    [sym_heredoc_body] = STATE(3010),
    [sym__terminator] = STATE(3010),
    [sym__line_break] = ACTIONS(5082),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(5082),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [5775] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(12987),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [5776] = {
    [anon_sym_COLON] = ACTIONS(12989),
    [sym_comment] = ACTIONS(49),
  },
  [5777] = {
    [sym_assignment] = STATE(8479),
    [sym_unary] = STATE(8479),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8479),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8479),
    [sym_conditional] = STATE(8479),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8479),
    [sym_binary] = STATE(8479),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [5778] = {
    [sym_assignment] = STATE(8480),
    [sym_unary] = STATE(8480),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8480),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8480),
    [sym_conditional] = STATE(8480),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8480),
    [sym_binary] = STATE(8480),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [5779] = {
    [sym_assignment] = STATE(8481),
    [sym_unary] = STATE(8481),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8481),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8481),
    [sym_conditional] = STATE(8481),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8481),
    [sym_binary] = STATE(8481),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [5780] = {
    [sym_heredoc_body] = STATE(8483),
    [aux_sym_call_repeat1] = STATE(8483),
    [aux_sym_argument_list_repeat1] = STATE(8484),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(12991),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5781] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(12989),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [5782] = {
    [aux_sym_chained_string_repeat1] = STATE(3625),
    [sym_string] = STATE(3625),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(12993),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5783] = {
    [sym_heredoc_body] = STATE(8483),
    [aux_sym_call_repeat1] = STATE(8483),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5784] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5785] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [5786] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5787] = {
    [sym_assignment] = STATE(8485),
    [sym_unary] = STATE(8485),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8485),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8485),
    [sym_conditional] = STATE(8485),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8485),
    [sym_binary] = STATE(8485),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5788] = {
    [sym_assignment] = STATE(8487),
    [sym_unary] = STATE(8487),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8487),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_splat_argument] = STATE(8488),
    [sym_operator_assignment] = STATE(8487),
    [sym_conditional] = STATE(8487),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_return] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_subshell] = STATE(3062),
    [sym__arg_or_splat_arg] = STATE(8488),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8487),
    [sym_binary] = STATE(8487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(12995),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5194),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(5184),
    [sym_character] = ACTIONS(5190),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5789] = {
    [sym_assignment] = STATE(8489),
    [sym_unary] = STATE(8489),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8489),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8489),
    [sym_conditional] = STATE(8489),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8489),
    [sym_binary] = STATE(8489),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5790] = {
    [sym_assignment] = STATE(8490),
    [sym_unary] = STATE(8490),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8490),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8490),
    [sym_conditional] = STATE(8490),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8490),
    [sym_binary] = STATE(8490),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5791] = {
    [sym_assignment] = STATE(8491),
    [sym_unary] = STATE(8491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8491),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8491),
    [sym_conditional] = STATE(8491),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8491),
    [sym_binary] = STATE(8491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5792] = {
    [sym_assignment] = STATE(8492),
    [sym_unary] = STATE(8492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8492),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8492),
    [sym_conditional] = STATE(8492),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8492),
    [sym_binary] = STATE(8492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5793] = {
    [sym_assignment] = STATE(8493),
    [sym_unary] = STATE(8493),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8493),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8493),
    [sym_conditional] = STATE(8493),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8493),
    [sym_binary] = STATE(8493),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5794] = {
    [sym_assignment] = STATE(8494),
    [sym_unary] = STATE(8494),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8494),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8494),
    [sym_conditional] = STATE(8494),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8494),
    [sym_binary] = STATE(8494),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5795] = {
    [sym_assignment] = STATE(8495),
    [sym_unary] = STATE(8495),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8495),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8495),
    [sym_conditional] = STATE(8495),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8495),
    [sym_binary] = STATE(8495),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5796] = {
    [sym_assignment] = STATE(8496),
    [sym_unary] = STATE(8496),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8496),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8496),
    [sym_conditional] = STATE(8496),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8496),
    [sym_binary] = STATE(8496),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5797] = {
    [sym_assignment] = STATE(8497),
    [sym_unary] = STATE(8497),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8497),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8497),
    [sym_conditional] = STATE(8497),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8497),
    [sym_binary] = STATE(8497),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5798] = {
    [sym_assignment] = STATE(8498),
    [sym_unary] = STATE(8498),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8498),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(8498),
    [sym_conditional] = STATE(8498),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8498),
    [sym_binary] = STATE(8498),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [5799] = {
    [sym_heredoc_body] = STATE(8503),
    [sym__argument_list_with_parens] = STATE(8502),
    [aux_sym_call_repeat1] = STATE(8503),
    [sym_argument_list_with_parens] = STATE(8501),
    [sym_operator] = STATE(8501),
    [anon_sym_LT] = ACTIONS(12997),
    [anon_sym_SLASH] = ACTIONS(12999),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12999),
    [anon_sym_PLUS_AT] = ACTIONS(12999),
    [anon_sym_LPAREN2] = ACTIONS(13001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12999),
    [anon_sym_GT_GT] = ACTIONS(12999),
    [anon_sym_EQ_TILDE] = ACTIONS(12999),
    [anon_sym_LT_LT] = ACTIONS(12999),
    [anon_sym_TILDE] = ACTIONS(12999),
    [anon_sym_PLUS] = ACTIONS(12997),
    [anon_sym_AMP] = ACTIONS(12999),
    [anon_sym_GT] = ACTIONS(12997),
    [anon_sym_PERCENT] = ACTIONS(12999),
    [anon_sym_DASH_AT] = ACTIONS(12999),
    [anon_sym_EQ_EQ] = ACTIONS(12997),
    [anon_sym_STAR] = ACTIONS(12997),
    [anon_sym_BANG_TILDE] = ACTIONS(12999),
    [sym_constant] = ACTIONS(13003),
    [anon_sym_DASH] = ACTIONS(12997),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12999),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12997),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12999),
    [anon_sym_STAR_STAR] = ACTIONS(12999),
    [anon_sym_PIPE] = ACTIONS(12999),
    [anon_sym_DOT_DOT] = ACTIONS(12999),
    [anon_sym_LT_EQ_GT] = ACTIONS(12999),
    [anon_sym_LT_EQ] = ACTIONS(12997),
    [anon_sym_BANG] = ACTIONS(12997),
    [sym_identifier] = ACTIONS(13003),
    [anon_sym_CARET] = ACTIONS(12999),
  },
  [5800] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13005),
    [sym_identifier] = ACTIONS(13005),
  },
  [5801] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(4868),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(2517),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(2518),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(4869),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13007),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [5802] = {
    [sym_do_block] = STATE(4917),
    [sym_block] = STATE(4917),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_EQ_TILDE] = ACTIONS(3087),
    [sym__binary_star] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(8178),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_BANG_TILDE] = ACTIONS(3087),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3087),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_STAR_STAR] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_LT_EQ_GT] = ACTIONS(3087),
    [anon_sym_LT_EQ] = ACTIONS(3085),
    [sym__binary_minus] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
  },
  [5803] = {
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym_string] = STATE(8506),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [5804] = {
    [sym_float] = ACTIONS(12831),
    [anon_sym_until] = ACTIONS(12831),
    [anon_sym_undef] = ACTIONS(12831),
    [sym_self] = ACTIONS(12831),
    [anon_sym_BEGIN] = ACTIONS(12831),
    [anon_sym_RBRACE] = ACTIONS(12829),
    [anon_sym_TILDE] = ACTIONS(12829),
    [anon_sym_unless] = ACTIONS(12831),
    [anon_sym_PLUS] = ACTIONS(12831),
    [sym__symbol_array_start] = ACTIONS(12829),
    [sym__simple_symbol] = ACTIONS(12829),
    [sym_complex] = ACTIONS(12829),
    [sym_heredoc_beginning] = ACTIONS(12829),
    [sym_super] = ACTIONS(12831),
    [anon_sym_alias] = ACTIONS(12831),
    [anon_sym_LBRACK2] = ACTIONS(12829),
    [anon_sym_nil] = ACTIONS(12831),
    [sym_character] = ACTIONS(12829),
    [anon_sym_LBRACE] = ACTIONS(12829),
    [anon_sym_END] = ACTIONS(12831),
    [sym_constant] = ACTIONS(12831),
    [anon_sym_while] = ACTIONS(12831),
    [sym_instance_variable] = ACTIONS(12829),
    [anon_sym_defined_QMARK] = ACTIONS(12829),
    [sym__string_start] = ACTIONS(12829),
    [anon_sym_true] = ACTIONS(12831),
    [anon_sym_for] = ACTIONS(12831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(12829),
    [anon_sym_NIL] = ACTIONS(12831),
    [anon_sym_COLON_COLON] = ACTIONS(12829),
    [anon_sym_def] = ACTIONS(12831),
    [sym_identifier] = ACTIONS(12831),
    [anon_sym_yield] = ACTIONS(12831),
    [sym_class_variable] = ACTIONS(12829),
    [sym__symbol_start] = ACTIONS(12829),
    [anon_sym_not] = ACTIONS(12831),
    [anon_sym_TRUE] = ACTIONS(12831),
    [anon_sym_case] = ACTIONS(12831),
    [anon_sym_SEMI] = ACTIONS(12829),
    [anon_sym_LPAREN] = ACTIONS(12829),
    [anon_sym_break] = ACTIONS(12831),
    [sym_global_variable] = ACTIONS(12829),
    [anon_sym_class] = ACTIONS(12831),
    [sym__subshell_start] = ACTIONS(12829),
    [anon_sym_module] = ACTIONS(12831),
    [anon_sym_begin] = ACTIONS(12831),
    [anon_sym_false] = ACTIONS(12831),
    [anon_sym_STAR] = ACTIONS(12829),
    [sym__unary_minus] = ACTIONS(12829),
    [anon_sym_next] = ACTIONS(12831),
    [sym_retry] = ACTIONS(12831),
    [sym__regex_start] = ACTIONS(12829),
    [sym_integer] = ACTIONS(12831),
    [anon_sym_FALSE] = ACTIONS(12831),
    [sym_redo] = ACTIONS(12831),
    [anon_sym_BANG] = ACTIONS(12829),
    [anon_sym_if] = ACTIONS(12831),
    [sym__string_array_start] = ACTIONS(12829),
    [anon_sym_return] = ACTIONS(12831),
  },
  [5805] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(13009),
  },
  [5806] = {
    [aux_sym_block_parameters_repeat1] = STATE(8509),
    [anon_sym_PIPE] = ACTIONS(13011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [5807] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(13011),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(13013),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [5808] = {
    [aux_sym_method_parameters_repeat1] = STATE(8362),
    [anon_sym_PIPE] = ACTIONS(13011),
    [anon_sym_COMMA] = ACTIONS(13015),
    [anon_sym_SEMI] = ACTIONS(13013),
    [sym_comment] = ACTIONS(49),
  },
  [5809] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [sym__line_break] = ACTIONS(13019),
    [anon_sym_then] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_when] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym___END__] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_end] = ACTIONS(13019),
    [anon_sym_ensure] = ACTIONS(13019),
    [anon_sym_else] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_elsif] = ACTIONS(13019),
    [ts_builtin_sym_end] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
  },
  [5810] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [5811] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [5812] = {
    [sym_assignment] = STATE(8512),
    [sym_unary] = STATE(8512),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(8512),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(8512),
    [sym_conditional] = STATE(8512),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(8512),
    [sym_binary] = STATE(8512),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [5813] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [5814] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [5815] = {
    [sym_assignment] = STATE(8513),
    [sym_unary] = STATE(8513),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(8513),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(8513),
    [sym_conditional] = STATE(8513),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(8513),
    [sym_binary] = STATE(8513),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [5816] = {
    [sym__argument] = STATE(5984),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5984),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(5984),
    [sym_hash_splat_argument] = STATE(5984),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym__argument_list_with_parens] = STATE(5985),
    [sym_block_argument] = STATE(5984),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(5256),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [5817] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(13021),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(13021),
    [anon_sym_SLASH_EQ] = ACTIONS(13021),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13021),
    [anon_sym_PIPE_EQ] = ACTIONS(13021),
    [anon_sym_LT_LT_EQ] = ACTIONS(13021),
    [anon_sym_PLUS_EQ] = ACTIONS(13021),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13021),
    [anon_sym_STAR_EQ] = ACTIONS(13021),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13021),
    [anon_sym_CARET_EQ] = ACTIONS(13021),
    [anon_sym_DASH_EQ] = ACTIONS(13021),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13021),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13023),
  },
  [5818] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(9373),
    [anon_sym_RPAREN] = ACTIONS(9373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(13037),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(13037),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_PIPE] = ACTIONS(13049),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [5819] = {
    [anon_sym_EQ] = ACTIONS(13053),
    [sym_comment] = ACTIONS(3),
  },
  [5820] = {
    [aux_sym_chained_string_repeat1] = STATE(8526),
    [sym_string] = STATE(8526),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [5821] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(9407),
    [anon_sym_RPAREN] = ACTIONS(9407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(13037),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(13037),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_PIPE] = ACTIONS(13049),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [5822] = {
    [anon_sym_PIPE] = ACTIONS(13055),
    [anon_sym_COMMA] = ACTIONS(13055),
    [anon_sym_RPAREN] = ACTIONS(13055),
    [anon_sym_SEMI] = ACTIONS(13055),
    [sym_comment] = ACTIONS(49),
  },
  [5823] = {
    [aux_sym_method_parameters_repeat1] = STATE(5826),
    [anon_sym_RPAREN] = ACTIONS(13057),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [5824] = {
    [anon_sym_PIPE] = ACTIONS(13059),
    [anon_sym_COMMA] = ACTIONS(13059),
    [anon_sym_RPAREN] = ACTIONS(13059),
    [anon_sym_SEMI] = ACTIONS(13059),
    [sym_comment] = ACTIONS(49),
  },
  [5825] = {
    [anon_sym_do] = ACTIONS(13061),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(13061),
  },
  [5826] = {
    [aux_sym_method_parameters_repeat1] = STATE(5826),
    [anon_sym_RPAREN] = ACTIONS(13059),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(13063),
  },
  [5827] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5828] = {
    [sym_assignment] = STATE(8528),
    [sym_unary] = STATE(8528),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8528),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(8528),
    [sym_conditional] = STATE(8528),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(8528),
    [sym_binary] = STATE(8528),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5829] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [5830] = {
    [sym_assignment] = STATE(8529),
    [sym_unary] = STATE(8529),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8529),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(8529),
    [sym_conditional] = STATE(8529),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(8529),
    [sym_binary] = STATE(8529),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5831] = {
    [sym_assignment] = STATE(8530),
    [sym_unary] = STATE(8530),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8530),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(8530),
    [sym_conditional] = STATE(8530),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(8530),
    [sym_binary] = STATE(8530),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5832] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5833] = {
    [sym_assignment] = STATE(8531),
    [sym_unary] = STATE(8531),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8531),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(8531),
    [sym_conditional] = STATE(8531),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(8531),
    [sym_binary] = STATE(8531),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5834] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(13066),
    [anon_sym_SLASH_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13066),
    [anon_sym_PIPE_EQ] = ACTIONS(13066),
    [anon_sym_LT_LT_EQ] = ACTIONS(13066),
    [anon_sym_PLUS_EQ] = ACTIONS(13066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13066),
    [anon_sym_STAR_EQ] = ACTIONS(13066),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13066),
    [anon_sym_CARET_EQ] = ACTIONS(13066),
    [anon_sym_DASH_EQ] = ACTIONS(13066),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13068),
  },
  [5835] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [5836] = {
    [anon_sym_EQ] = ACTIONS(13096),
    [sym_comment] = ACTIONS(3),
  },
  [5837] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [5838] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [5839] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(8543),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5256),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13098),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5840] = {
    [sym_heredoc_body] = STATE(8544),
    [aux_sym_call_repeat1] = STATE(8544),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5841] = {
    [sym_heredoc_body] = STATE(8545),
    [aux_sym_call_repeat1] = STATE(8545),
    [aux_sym_argument_list_repeat1] = STATE(8546),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9468),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5842] = {
    [sym_assignment] = STATE(8547),
    [sym_unary] = STATE(8547),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8547),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8547),
    [sym_conditional] = STATE(8547),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8547),
    [sym_binary] = STATE(8547),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5843] = {
    [sym_assignment] = STATE(8548),
    [sym_unary] = STATE(8548),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8548),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(8549),
    [sym_operator_assignment] = STATE(8548),
    [sym_conditional] = STATE(8548),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_subshell] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(8549),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8548),
    [sym_binary] = STATE(8548),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(2173),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5844] = {
    [sym_assignment] = STATE(8550),
    [sym_unary] = STATE(8550),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8550),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8550),
    [sym_conditional] = STATE(8550),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8550),
    [sym_binary] = STATE(8550),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5845] = {
    [sym_assignment] = STATE(8551),
    [sym_unary] = STATE(8551),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8551),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8551),
    [sym_conditional] = STATE(8551),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8551),
    [sym_binary] = STATE(8551),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5846] = {
    [sym_assignment] = STATE(8552),
    [sym_unary] = STATE(8552),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8552),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8552),
    [sym_conditional] = STATE(8552),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8552),
    [sym_binary] = STATE(8552),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5847] = {
    [sym_assignment] = STATE(8553),
    [sym_unary] = STATE(8553),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8553),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8553),
    [sym_conditional] = STATE(8553),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8553),
    [sym_binary] = STATE(8553),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5848] = {
    [sym_assignment] = STATE(8554),
    [sym_unary] = STATE(8554),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8554),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8554),
    [sym_conditional] = STATE(8554),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8554),
    [sym_binary] = STATE(8554),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5849] = {
    [sym_assignment] = STATE(8555),
    [sym_unary] = STATE(8555),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8555),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8555),
    [sym_conditional] = STATE(8555),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8555),
    [sym_binary] = STATE(8555),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5850] = {
    [sym_assignment] = STATE(8557),
    [sym_unary] = STATE(8557),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8557),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8557),
    [sym_conditional] = STATE(8557),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8557),
    [sym_binary] = STATE(8557),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5851] = {
    [sym_assignment] = STATE(8558),
    [sym_unary] = STATE(8558),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8558),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8558),
    [sym_conditional] = STATE(8558),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8558),
    [sym_binary] = STATE(8558),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5852] = {
    [sym_assignment] = STATE(8559),
    [sym_unary] = STATE(8559),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8559),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8559),
    [sym_conditional] = STATE(8559),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8559),
    [sym_binary] = STATE(8559),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5853] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5854] = {
    [sym_assignment] = STATE(8560),
    [sym_unary] = STATE(8560),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(8560),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(8560),
    [sym_conditional] = STATE(8560),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(8560),
    [sym_binary] = STATE(8560),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [5855] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [5856] = {
    [aux_sym_exceptions_repeat1] = STATE(8562),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [5857] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5858] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5859] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13102),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5860] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5861] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5862] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5863] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [5864] = {
    [sym__method_name] = STATE(258),
    [sym_setter] = STATE(258),
    [sym_symbol] = STATE(258),
    [sym_operator] = STATE(258),
    [sym__method_rest] = STATE(8564),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(5362),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(5362),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(5362),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [5865] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5866] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5867] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [5868] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [5869] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8566),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13104),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5870] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [5871] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [5872] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(5871),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8567),
    [sym_operator] = STATE(8567),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9510),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9510),
    [anon_sym_PLUS_AT] = ACTIONS(9510),
    [anon_sym_LPAREN2] = ACTIONS(9512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9510),
    [anon_sym_GT_GT] = ACTIONS(9510),
    [anon_sym_EQ_TILDE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(9510),
    [anon_sym_TILDE] = ACTIONS(9510),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9510),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9510),
    [anon_sym_DASH_AT] = ACTIONS(9510),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_STAR] = ACTIONS(9508),
    [anon_sym_BANG_TILDE] = ACTIONS(9510),
    [sym_constant] = ACTIONS(13106),
    [anon_sym_DASH] = ACTIONS(9508),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9508),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9510),
    [anon_sym_STAR_STAR] = ACTIONS(9510),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_DOT_DOT] = ACTIONS(9510),
    [anon_sym_LT_EQ_GT] = ACTIONS(9510),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_BANG] = ACTIONS(9508),
    [sym_identifier] = ACTIONS(13106),
    [anon_sym_CARET] = ACTIONS(9510),
  },
  [5873] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [5874] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [5875] = {
    [aux_sym_chained_string_repeat1] = STATE(5908),
    [sym_string] = STATE(5908),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5876] = {
    [sym_assignment] = STATE(8568),
    [sym_unary] = STATE(8568),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(8568),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(8568),
    [sym_conditional] = STATE(8568),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(8568),
    [sym_binary] = STATE(8568),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [5877] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [5878] = {
    [sym_assignment] = STATE(8569),
    [sym_unary] = STATE(8569),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(8569),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(8569),
    [sym_conditional] = STATE(8569),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(8569),
    [sym_binary] = STATE(8569),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [5879] = {
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5880] = {
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5881] = {
    [sym_assignment] = STATE(8570),
    [sym_unary] = STATE(8570),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(8570),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(8570),
    [sym_conditional] = STATE(8570),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(8570),
    [sym_binary] = STATE(8570),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [5882] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [5883] = {
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5884] = {
    [sym_assignment] = STATE(8571),
    [sym_unary] = STATE(8571),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(8571),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(8571),
    [sym_conditional] = STATE(8571),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(8571),
    [sym_binary] = STATE(8571),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [5885] = {
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5886] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(13108),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(13108),
    [anon_sym_SLASH_EQ] = ACTIONS(13108),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13108),
    [anon_sym_PIPE_EQ] = ACTIONS(13108),
    [anon_sym_LT_LT_EQ] = ACTIONS(13108),
    [anon_sym_PLUS_EQ] = ACTIONS(13108),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13108),
    [anon_sym_STAR_EQ] = ACTIONS(13108),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13108),
    [anon_sym_CARET_EQ] = ACTIONS(13108),
    [anon_sym_DASH_EQ] = ACTIONS(13108),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13108),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(13110),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5887] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [5888] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(9704),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9708),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [5889] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym__primary] = STATE(3126),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(3129),
    [sym_method] = STATE(3126),
    [sym_conditional] = STATE(3131),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_subshell] = STATE(3126),
    [sym_unless] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_block_argument] = STATE(3129),
    [sym_range] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3130),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_call] = STATE(3128),
    [sym__argument] = STATE(3129),
    [sym_assignment] = STATE(3131),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_pair] = STATE(3129),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(3129),
    [sym_operator_assignment] = STATE(3131),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_rational] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_lambda] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym__argument_list_with_parens] = STATE(3133),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(3131),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_nil] = STATE(3130),
    [sym_symbol_array] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_scope_resolution] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(5306),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(5310),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [sym_character] = ACTIONS(5312),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(5326),
    [anon_sym_not] = ACTIONS(5328),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5338),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [5890] = {
    [anon_sym_EQ] = ACTIONS(13140),
    [sym_comment] = ACTIONS(3),
  },
  [5891] = {
    [aux_sym_chained_string_repeat1] = STATE(8583),
    [sym_string] = STATE(8583),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [5892] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [5893] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [5894] = {
    [sym_assignment] = STATE(8584),
    [sym_unary] = STATE(8584),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8584),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(8585),
    [sym_operator_assignment] = STATE(8584),
    [sym_conditional] = STATE(8584),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_subshell] = STATE(3126),
    [sym__arg_or_splat_arg] = STATE(8585),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8584),
    [sym_binary] = STATE(8584),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(5310),
    [sym_character] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5895] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_heredoc_body] = STATE(8586),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(5306),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(5318),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5326),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(5328),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13142),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5896] = {
    [sym_heredoc_body] = STATE(8587),
    [aux_sym_call_repeat1] = STATE(8587),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5897] = {
    [sym_heredoc_body] = STATE(8588),
    [aux_sym_call_repeat1] = STATE(8588),
    [aux_sym_argument_list_repeat1] = STATE(8589),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9552),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [5898] = {
    [sym_assignment] = STATE(8590),
    [sym_unary] = STATE(8590),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8590),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8590),
    [sym_conditional] = STATE(8590),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8590),
    [sym_binary] = STATE(8590),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5899] = {
    [sym_assignment] = STATE(8591),
    [sym_unary] = STATE(8591),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8591),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8591),
    [sym_conditional] = STATE(8591),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8591),
    [sym_binary] = STATE(8591),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5900] = {
    [sym_assignment] = STATE(8592),
    [sym_unary] = STATE(8592),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8592),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8592),
    [sym_conditional] = STATE(8592),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8592),
    [sym_binary] = STATE(8592),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5901] = {
    [sym_assignment] = STATE(8593),
    [sym_unary] = STATE(8593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8593),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8593),
    [sym_conditional] = STATE(8593),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8593),
    [sym_binary] = STATE(8593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5902] = {
    [sym_assignment] = STATE(8594),
    [sym_unary] = STATE(8594),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8594),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8594),
    [sym_conditional] = STATE(8594),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8594),
    [sym_binary] = STATE(8594),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5903] = {
    [sym_assignment] = STATE(8595),
    [sym_unary] = STATE(8595),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8595),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8595),
    [sym_conditional] = STATE(8595),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8595),
    [sym_binary] = STATE(8595),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5904] = {
    [sym_assignment] = STATE(8596),
    [sym_unary] = STATE(8596),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8596),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8596),
    [sym_conditional] = STATE(8596),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8596),
    [sym_binary] = STATE(8596),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5905] = {
    [sym_assignment] = STATE(8598),
    [sym_unary] = STATE(8598),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8598),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8598),
    [sym_conditional] = STATE(8598),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8598),
    [sym_binary] = STATE(8598),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5906] = {
    [sym_assignment] = STATE(8599),
    [sym_unary] = STATE(8599),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8599),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8599),
    [sym_conditional] = STATE(8599),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8599),
    [sym_binary] = STATE(8599),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5907] = {
    [sym_assignment] = STATE(8600),
    [sym_unary] = STATE(8600),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8600),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8600),
    [sym_conditional] = STATE(8600),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8600),
    [sym_binary] = STATE(8600),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [5908] = {
    [aux_sym_chained_string_repeat1] = STATE(8601),
    [sym_string] = STATE(8601),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [5909] = {
    [aux_sym_chained_string_repeat1] = STATE(5909),
    [sym_string] = STATE(5909),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [5910] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(8603),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8604),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8604),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8605),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(13144),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(1993),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13146),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5911] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_block_parameters] = STATE(8607),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(8608),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13148),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [5912] = {
    [sym__line_break] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2045),
    [sym_comment] = ACTIONS(49),
  },
  [5913] = {
    [sym_do_block] = STATE(8609),
    [sym_block] = STATE(8609),
    [anon_sym_do] = ACTIONS(13150),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(9590),
  },
  [5914] = {
    [sym__line_break] = ACTIONS(9373),
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(9373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_SEMI] = ACTIONS(9373),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(13152),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(13152),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_PIPE] = ACTIONS(9885),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [5915] = {
    [sym__line_break] = ACTIONS(9407),
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(9407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_SEMI] = ACTIONS(9407),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(13152),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(13152),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(9407),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_PIPE] = ACTIONS(9885),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [5916] = {
    [sym_float] = ACTIONS(13154),
    [anon_sym_until] = ACTIONS(13154),
    [anon_sym_undef] = ACTIONS(13154),
    [sym_self] = ACTIONS(13154),
    [anon_sym_BEGIN] = ACTIONS(13154),
    [anon_sym_TILDE] = ACTIONS(13156),
    [anon_sym_unless] = ACTIONS(13154),
    [anon_sym_PLUS] = ACTIONS(13154),
    [sym__symbol_array_start] = ACTIONS(13156),
    [sym__simple_symbol] = ACTIONS(13156),
    [sym_complex] = ACTIONS(13156),
    [sym_heredoc_beginning] = ACTIONS(13156),
    [sym_super] = ACTIONS(13154),
    [anon_sym_rescue] = ACTIONS(13154),
    [anon_sym_alias] = ACTIONS(13154),
    [anon_sym_LBRACK2] = ACTIONS(13156),
    [anon_sym_nil] = ACTIONS(13154),
    [sym_character] = ACTIONS(13156),
    [anon_sym_LBRACE] = ACTIONS(13156),
    [anon_sym_END] = ACTIONS(13154),
    [sym_constant] = ACTIONS(13154),
    [anon_sym_while] = ACTIONS(13154),
    [sym_instance_variable] = ACTIONS(13156),
    [anon_sym_defined_QMARK] = ACTIONS(13156),
    [sym__string_start] = ACTIONS(13156),
    [anon_sym_else] = ACTIONS(13154),
    [anon_sym_true] = ACTIONS(13154),
    [anon_sym_for] = ACTIONS(13154),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(13156),
    [anon_sym_NIL] = ACTIONS(13154),
    [anon_sym_COLON_COLON] = ACTIONS(13156),
    [anon_sym_def] = ACTIONS(13154),
    [sym_identifier] = ACTIONS(13154),
    [anon_sym_yield] = ACTIONS(13154),
    [sym_class_variable] = ACTIONS(13156),
    [anon_sym_not] = ACTIONS(13154),
    [sym__symbol_start] = ACTIONS(13156),
    [anon_sym_TRUE] = ACTIONS(13154),
    [anon_sym_case] = ACTIONS(13154),
    [anon_sym_SEMI] = ACTIONS(13156),
    [anon_sym_LPAREN] = ACTIONS(13156),
    [anon_sym_break] = ACTIONS(13154),
    [sym_global_variable] = ACTIONS(13156),
    [anon_sym_class] = ACTIONS(13154),
    [sym__subshell_start] = ACTIONS(13156),
    [anon_sym_module] = ACTIONS(13154),
    [anon_sym_begin] = ACTIONS(13154),
    [anon_sym_false] = ACTIONS(13154),
    [anon_sym_STAR] = ACTIONS(13156),
    [sym__unary_minus] = ACTIONS(13156),
    [anon_sym_next] = ACTIONS(13154),
    [sym_retry] = ACTIONS(13154),
    [sym__regex_start] = ACTIONS(13156),
    [anon_sym_end] = ACTIONS(13154),
    [anon_sym_ensure] = ACTIONS(13154),
    [sym_integer] = ACTIONS(13154),
    [anon_sym_FALSE] = ACTIONS(13154),
    [sym_redo] = ACTIONS(13154),
    [anon_sym_BANG] = ACTIONS(13156),
    [anon_sym_if] = ACTIONS(13154),
    [sym__string_array_start] = ACTIONS(13156),
    [anon_sym_return] = ACTIONS(13154),
  },
  [5917] = {
    [sym_heredoc_body] = STATE(8610),
    [sym__terminator] = STATE(8610),
    [sym__line_break] = ACTIONS(13158),
    [sym_float] = ACTIONS(13154),
    [anon_sym_until] = ACTIONS(13154),
    [anon_sym_undef] = ACTIONS(13154),
    [sym_self] = ACTIONS(13154),
    [anon_sym_BEGIN] = ACTIONS(13154),
    [anon_sym_TILDE] = ACTIONS(13156),
    [anon_sym_unless] = ACTIONS(13154),
    [anon_sym_PLUS] = ACTIONS(13154),
    [sym__symbol_array_start] = ACTIONS(13156),
    [sym__simple_symbol] = ACTIONS(13156),
    [sym_complex] = ACTIONS(13156),
    [sym_heredoc_beginning] = ACTIONS(13156),
    [sym_super] = ACTIONS(13154),
    [anon_sym_rescue] = ACTIONS(13154),
    [anon_sym_alias] = ACTIONS(13154),
    [anon_sym_LBRACK2] = ACTIONS(13156),
    [anon_sym_nil] = ACTIONS(13154),
    [sym_character] = ACTIONS(13156),
    [anon_sym_LBRACE] = ACTIONS(13156),
    [anon_sym_END] = ACTIONS(13154),
    [sym_constant] = ACTIONS(13154),
    [anon_sym_while] = ACTIONS(13154),
    [sym_instance_variable] = ACTIONS(13156),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(13156),
    [sym__string_start] = ACTIONS(13156),
    [anon_sym_else] = ACTIONS(13154),
    [anon_sym_true] = ACTIONS(13154),
    [anon_sym_for] = ACTIONS(13154),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(13156),
    [anon_sym_NIL] = ACTIONS(13154),
    [anon_sym_COLON_COLON] = ACTIONS(13156),
    [anon_sym_def] = ACTIONS(13154),
    [sym_identifier] = ACTIONS(13154),
    [anon_sym_yield] = ACTIONS(13154),
    [sym_class_variable] = ACTIONS(13156),
    [anon_sym_not] = ACTIONS(13154),
    [sym__symbol_start] = ACTIONS(13156),
    [anon_sym_TRUE] = ACTIONS(13154),
    [anon_sym_case] = ACTIONS(13154),
    [anon_sym_SEMI] = ACTIONS(13158),
    [anon_sym_LPAREN] = ACTIONS(13156),
    [anon_sym_break] = ACTIONS(13154),
    [sym_global_variable] = ACTIONS(13156),
    [anon_sym_class] = ACTIONS(13154),
    [sym__subshell_start] = ACTIONS(13156),
    [anon_sym_module] = ACTIONS(13154),
    [anon_sym_begin] = ACTIONS(13154),
    [anon_sym_false] = ACTIONS(13154),
    [anon_sym_STAR] = ACTIONS(13156),
    [sym__unary_minus] = ACTIONS(13156),
    [anon_sym_next] = ACTIONS(13154),
    [sym_retry] = ACTIONS(13154),
    [sym__regex_start] = ACTIONS(13156),
    [anon_sym_end] = ACTIONS(13154),
    [anon_sym_ensure] = ACTIONS(13154),
    [sym_integer] = ACTIONS(13154),
    [anon_sym_FALSE] = ACTIONS(13154),
    [sym_redo] = ACTIONS(13154),
    [anon_sym_BANG] = ACTIONS(13156),
    [anon_sym_if] = ACTIONS(13154),
    [sym__string_array_start] = ACTIONS(13156),
    [anon_sym_return] = ACTIONS(13154),
  },
  [5918] = {
    [aux_sym_method_parameters_repeat1] = STATE(5826),
    [anon_sym_RPAREN] = ACTIONS(13160),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [5919] = {
    [sym_splat_parameter] = STATE(8612),
    [sym_hash_splat_parameter] = STATE(8612),
    [sym_block_parameter] = STATE(8612),
    [sym__formal_parameter] = STATE(8612),
    [sym__simple_formal_parameter] = STATE(8612),
    [sym_keyword_parameter] = STATE(8612),
    [sym_optional_parameter] = STATE(8612),
    [sym_destructured_parameter] = STATE(8612),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [5920] = {
    [sym_heredoc_body] = STATE(8610),
    [sym__terminator] = STATE(8610),
    [aux_sym_method_parameters_repeat1] = STATE(8614),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(13158),
    [anon_sym_COMMA] = ACTIONS(13162),
    [anon_sym_SEMI] = ACTIONS(13158),
    [sym_comment] = ACTIONS(49),
  },
  [5921] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [sym__line_break] = ACTIONS(7384),
    [anon_sym_then] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_EQ_GT] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_when] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym___END__] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_end] = ACTIONS(7384),
    [anon_sym_ensure] = ACTIONS(7384),
    [anon_sym_else] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_elsif] = ACTIONS(7384),
    [ts_builtin_sym_end] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
    [sym__binary_minus] = ACTIONS(7384),
  },
  [5922] = {
    [anon_sym_end] = ACTIONS(13164),
    [sym_comment] = ACTIONS(49),
  },
  [5923] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [sym__line_break] = ACTIONS(7790),
    [anon_sym_then] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_EQ_GT] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_when] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym___END__] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7790),
    [anon_sym_ensure] = ACTIONS(7790),
    [anon_sym_else] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_elsif] = ACTIONS(7790),
    [ts_builtin_sym_end] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [sym__binary_minus] = ACTIONS(7790),
  },
  [5924] = {
    [anon_sym_end] = ACTIONS(13166),
    [sym_comment] = ACTIONS(49),
  },
  [5925] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [sym__line_break] = ACTIONS(7872),
    [anon_sym_then] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_when] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym___END__] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_end] = ACTIONS(7872),
    [anon_sym_ensure] = ACTIONS(7872),
    [anon_sym_else] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_elsif] = ACTIONS(7872),
    [ts_builtin_sym_end] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
    [sym__binary_minus] = ACTIONS(7872),
  },
  [5926] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13168),
  },
  [5927] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [sym__line_break] = ACTIONS(7878),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_EQ_GT] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [ts_builtin_sym_end] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
    [sym__binary_minus] = ACTIONS(7878),
  },
  [5928] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(13170),
    [sym__string_end] = ACTIONS(13168),
  },
  [5929] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [sym__line_break] = ACTIONS(8224),
    [anon_sym_then] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_EQ_GT] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_when] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym___END__] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_end] = ACTIONS(8224),
    [anon_sym_ensure] = ACTIONS(8224),
    [anon_sym_else] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_elsif] = ACTIONS(8224),
    [ts_builtin_sym_end] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
    [sym__binary_minus] = ACTIONS(8224),
  },
  [5930] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13172),
  },
  [5931] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [sym__line_break] = ACTIONS(8851),
    [anon_sym_then] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_EQ_GT] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_when] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym___END__] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_end] = ACTIONS(8851),
    [anon_sym_ensure] = ACTIONS(8851),
    [anon_sym_else] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_elsif] = ACTIONS(8851),
    [ts_builtin_sym_end] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
    [sym__binary_minus] = ACTIONS(8851),
  },
  [5932] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [sym__line_break] = ACTIONS(8872),
    [anon_sym_then] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_EQ_GT] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_when] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym___END__] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_end] = ACTIONS(8872),
    [anon_sym_ensure] = ACTIONS(8872),
    [anon_sym_else] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_elsif] = ACTIONS(8872),
    [ts_builtin_sym_end] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
    [sym__binary_minus] = ACTIONS(8872),
  },
  [5933] = {
    [anon_sym_end] = ACTIONS(13174),
    [sym_comment] = ACTIONS(49),
  },
  [5934] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8622),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13176),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5935] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [sym__line_break] = ACTIONS(9250),
    [anon_sym_then] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_when] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym___END__] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(9250),
    [anon_sym_ensure] = ACTIONS(9250),
    [anon_sym_else] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_elsif] = ACTIONS(9250),
    [ts_builtin_sym_end] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
  },
  [5936] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8624),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13178),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5937] = {
    [anon_sym_end] = ACTIONS(13180),
    [sym_comment] = ACTIONS(49),
  },
  [5938] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8625),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8625),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8624),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(13182),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13182),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13178),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [5939] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [sym__line_break] = ACTIONS(9419),
    [anon_sym_then] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_when] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym___END__] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_end] = ACTIONS(9419),
    [anon_sym_ensure] = ACTIONS(9419),
    [anon_sym_else] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_elsif] = ACTIONS(9419),
    [ts_builtin_sym_end] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
  },
  [5940] = {
    [anon_sym_RBRACE] = ACTIONS(13184),
    [sym_comment] = ACTIONS(49),
  },
  [5941] = {
    [anon_sym_DOT] = ACTIONS(13186),
    [anon_sym_COLON_COLON] = ACTIONS(13186),
    [sym_comment] = ACTIONS(49),
  },
  [5942] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [sym__line_break] = ACTIONS(9602),
    [anon_sym_then] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_EQ_GT] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_when] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym___END__] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_end] = ACTIONS(9602),
    [anon_sym_ensure] = ACTIONS(9602),
    [anon_sym_else] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_elsif] = ACTIONS(9602),
    [ts_builtin_sym_end] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
    [sym__binary_minus] = ACTIONS(9602),
  },
  [5943] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [sym__line_break] = ACTIONS(9608),
    [anon_sym_then] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_EQ_GT] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_when] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym___END__] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_end] = ACTIONS(9608),
    [anon_sym_ensure] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_elsif] = ACTIONS(9608),
    [ts_builtin_sym_end] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
    [sym__binary_minus] = ACTIONS(9608),
  },
  [5944] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym___END__] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [5945] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym___END__] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [5946] = {
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_SLASH] = ACTIONS(9738),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_then] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_PERCENT] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_when] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym___END__] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9738),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_ensure] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_elsif] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_AMP_AMP] = ACTIONS(9738),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
  },
  [5947] = {
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(4446),
    [sym__line_break] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_EQ_GT] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_PERCENT] = ACTIONS(4446),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_when] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym___END__] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(4446),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(4446),
    [anon_sym_ensure] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_elsif] = ACTIONS(4446),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_AMP_AMP] = ACTIONS(4446),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(4446),
    [sym__binary_minus] = ACTIONS(4446),
  },
  [5948] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(13188),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [5949] = {
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [5950] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(1212),
    [sym_unary] = STATE(1212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(1212),
    [sym__primary] = STATE(303),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(1212),
    [sym_conditional] = STATE(1212),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1213),
    [sym_rational] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(1212),
    [sym_binary] = STATE(1212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym_float] = ACTIONS(497),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(505),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(505),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(523),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(2141),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(541),
    [sym_class_variable] = ACTIONS(523),
    [sym__block_ampersand] = ACTIONS(2143),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(545),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [sym_retry] = ACTIONS(497),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9656),
    [sym_redo] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [5951] = {
    [sym_heredoc_body] = STATE(5951),
    [aux_sym_call_repeat1] = STATE(5951),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym___END__] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [5952] = {
    [sym_heredoc_body] = STATE(5951),
    [aux_sym_call_repeat1] = STATE(5951),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym___END__] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [5953] = {
    [aux_sym_argument_list_repeat1] = STATE(5953),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13193),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [5954] = {
    [sym_heredoc_body] = STATE(8630),
    [aux_sym_call_repeat1] = STATE(8630),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [5955] = {
    [sym_heredoc_body] = STATE(8631),
    [aux_sym_call_repeat1] = STATE(8631),
    [aux_sym_argument_list_repeat1] = STATE(3295),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym___END__] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [5956] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5957] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym___END__] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5958] = {
    [aux_sym_exceptions_repeat1] = STATE(8633),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [5959] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5960] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5961] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5962] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [5963] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13196),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [5964] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5965] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5966] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [5967] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5968] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [5969] = {
    [aux_sym_chained_string_repeat1] = STATE(5969),
    [sym_string] = STATE(5969),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym___END__] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [5970] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [sym__line_break] = ACTIONS(9899),
    [anon_sym_then] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_EQ_GT] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_when] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym___END__] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_end] = ACTIONS(9899),
    [anon_sym_ensure] = ACTIONS(9899),
    [anon_sym_else] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_elsif] = ACTIONS(9899),
    [ts_builtin_sym_end] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
    [sym__binary_minus] = ACTIONS(9899),
  },
  [5971] = {
    [anon_sym_end] = ACTIONS(13198),
    [sym_comment] = ACTIONS(49),
  },
  [5972] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(8636),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(13198),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [5973] = {
    [sym_when] = STATE(8637),
    [sym_else] = STATE(8636),
    [aux_sym_case_repeat2] = STATE(8637),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(13198),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [5974] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(9688),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(9688),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9700),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [5975] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(9688),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(9688),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9700),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [5976] = {
    [sym_assignment] = STATE(8638),
    [sym_unary] = STATE(8638),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8638),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8638),
    [sym_conditional] = STATE(8638),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8638),
    [sym_binary] = STATE(8638),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5977] = {
    [sym_assignment] = STATE(8639),
    [sym_unary] = STATE(8639),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8639),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(8639),
    [sym_conditional] = STATE(8639),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8639),
    [sym_binary] = STATE(8639),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5978] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [5979] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [5980] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [5981] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(8640),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5256),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13200),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [5982] = {
    [sym_heredoc_body] = STATE(8641),
    [aux_sym_call_repeat1] = STATE(8641),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5983] = {
    [sym_heredoc_body] = STATE(8642),
    [aux_sym_call_repeat1] = STATE(8642),
    [aux_sym_argument_list_repeat1] = STATE(8643),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9666),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [5984] = {
    [sym_heredoc_body] = STATE(8644),
    [aux_sym_call_repeat1] = STATE(8644),
    [aux_sym_argument_list_repeat1] = STATE(8645),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9468),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5985] = {
    [sym_heredoc_body] = STATE(8644),
    [aux_sym_call_repeat1] = STATE(8644),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [5986] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [5987] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [5988] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [5989] = {
    [sym_assignment] = STATE(8646),
    [sym_unary] = STATE(8646),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8646),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8646),
    [sym_conditional] = STATE(8646),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8646),
    [sym_binary] = STATE(8646),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5990] = {
    [sym_assignment] = STATE(8648),
    [sym_unary] = STATE(8648),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8648),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_splat_argument] = STATE(8649),
    [sym_operator_assignment] = STATE(8648),
    [sym_conditional] = STATE(8648),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_subshell] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(8649),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8648),
    [sym_binary] = STATE(8648),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(13202),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [sym_global_variable] = ACTIONS(5486),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(5478),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5991] = {
    [sym_assignment] = STATE(8650),
    [sym_unary] = STATE(8650),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8650),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8650),
    [sym_conditional] = STATE(8650),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8650),
    [sym_binary] = STATE(8650),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5992] = {
    [sym_assignment] = STATE(8651),
    [sym_unary] = STATE(8651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8651),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8651),
    [sym_conditional] = STATE(8651),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8651),
    [sym_binary] = STATE(8651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5993] = {
    [sym_assignment] = STATE(8652),
    [sym_unary] = STATE(8652),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8652),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8652),
    [sym_conditional] = STATE(8652),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8652),
    [sym_binary] = STATE(8652),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5994] = {
    [sym_assignment] = STATE(8653),
    [sym_unary] = STATE(8653),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8653),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8653),
    [sym_conditional] = STATE(8653),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8653),
    [sym_binary] = STATE(8653),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5995] = {
    [sym_assignment] = STATE(8654),
    [sym_unary] = STATE(8654),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8654),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8654),
    [sym_conditional] = STATE(8654),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8654),
    [sym_binary] = STATE(8654),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [5996] = {
    [sym_assignment] = STATE(8655),
    [sym_unary] = STATE(8655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8655),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8655),
    [sym_conditional] = STATE(8655),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8655),
    [sym_binary] = STATE(8655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5997] = {
    [sym_assignment] = STATE(8656),
    [sym_unary] = STATE(8656),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8656),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8656),
    [sym_conditional] = STATE(8656),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8656),
    [sym_binary] = STATE(8656),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5998] = {
    [sym_assignment] = STATE(8657),
    [sym_unary] = STATE(8657),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8657),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8657),
    [sym_conditional] = STATE(8657),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8657),
    [sym_binary] = STATE(8657),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [5999] = {
    [sym_assignment] = STATE(8658),
    [sym_unary] = STATE(8658),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8658),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8658),
    [sym_conditional] = STATE(8658),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8658),
    [sym_binary] = STATE(8658),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [6000] = {
    [sym_assignment] = STATE(8659),
    [sym_unary] = STATE(8659),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8659),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(8659),
    [sym_conditional] = STATE(8659),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8659),
    [sym_binary] = STATE(8659),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [6001] = {
    [sym_heredoc_body] = STATE(8664),
    [sym__argument_list_with_parens] = STATE(8663),
    [aux_sym_call_repeat1] = STATE(8664),
    [sym_argument_list_with_parens] = STATE(8662),
    [sym_operator] = STATE(8662),
    [anon_sym_LT] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13206),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13206),
    [anon_sym_PLUS_AT] = ACTIONS(13206),
    [anon_sym_LPAREN2] = ACTIONS(13208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13206),
    [anon_sym_GT_GT] = ACTIONS(13206),
    [anon_sym_EQ_TILDE] = ACTIONS(13206),
    [anon_sym_LT_LT] = ACTIONS(13206),
    [anon_sym_TILDE] = ACTIONS(13206),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_AMP] = ACTIONS(13206),
    [anon_sym_GT] = ACTIONS(13204),
    [anon_sym_PERCENT] = ACTIONS(13206),
    [anon_sym_DASH_AT] = ACTIONS(13206),
    [anon_sym_EQ_EQ] = ACTIONS(13204),
    [anon_sym_STAR] = ACTIONS(13204),
    [anon_sym_BANG_TILDE] = ACTIONS(13206),
    [sym_constant] = ACTIONS(13210),
    [anon_sym_DASH] = ACTIONS(13204),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13206),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13206),
    [anon_sym_STAR_STAR] = ACTIONS(13206),
    [anon_sym_PIPE] = ACTIONS(13206),
    [anon_sym_DOT_DOT] = ACTIONS(13206),
    [anon_sym_LT_EQ_GT] = ACTIONS(13206),
    [anon_sym_LT_EQ] = ACTIONS(13204),
    [anon_sym_BANG] = ACTIONS(13204),
    [sym_identifier] = ACTIONS(13210),
    [anon_sym_CARET] = ACTIONS(13206),
  },
  [6002] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13212),
    [sym_identifier] = ACTIONS(13212),
  },
  [6003] = {
    [aux_sym_chained_string_repeat1] = STATE(8666),
    [sym_string] = STATE(8666),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6004] = {
    [aux_sym_heredoc_body_repeat1] = STATE(8668),
    [sym_interpolation] = STATE(8668),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(13214),
    [sym_heredoc_end] = ACTIONS(13216),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(13214),
  },
  [6005] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(8459),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6006] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(8669),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(8459),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [sym__heredoc_body_start] = ACTIONS(9712),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6007] = {
    [aux_sym_argument_list_repeat1] = STATE(6007),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13218),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [6008] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6009] = {
    [sym_assignment] = STATE(8671),
    [sym_unary] = STATE(8671),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8671),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(8671),
    [sym_conditional] = STATE(8671),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(8671),
    [sym_binary] = STATE(8671),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6010] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6011] = {
    [aux_sym_exceptions_repeat1] = STATE(8673),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [6012] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6013] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6014] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13221),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6015] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6016] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6017] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6018] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [6019] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6020] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6021] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6022] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6023] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8676),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13223),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6024] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6025] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6026] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6025),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8677),
    [sym_operator] = STATE(8677),
    [anon_sym_LT] = ACTIONS(9718),
    [anon_sym_SLASH] = ACTIONS(9720),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(9720),
    [anon_sym_PLUS_AT] = ACTIONS(9720),
    [anon_sym_LPAREN2] = ACTIONS(9722),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9720),
    [anon_sym_GT_GT] = ACTIONS(9720),
    [anon_sym_EQ_TILDE] = ACTIONS(9720),
    [anon_sym_LT_LT] = ACTIONS(9720),
    [anon_sym_TILDE] = ACTIONS(9720),
    [anon_sym_PLUS] = ACTIONS(9718),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_GT] = ACTIONS(9718),
    [anon_sym_PERCENT] = ACTIONS(9720),
    [anon_sym_DASH_AT] = ACTIONS(9720),
    [anon_sym_EQ_EQ] = ACTIONS(9718),
    [anon_sym_STAR] = ACTIONS(9718),
    [anon_sym_BANG_TILDE] = ACTIONS(9720),
    [sym_constant] = ACTIONS(13225),
    [anon_sym_DASH] = ACTIONS(9718),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(9720),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(9718),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(9720),
    [anon_sym_STAR_STAR] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9720),
    [anon_sym_DOT_DOT] = ACTIONS(9720),
    [anon_sym_LT_EQ_GT] = ACTIONS(9720),
    [anon_sym_LT_EQ] = ACTIONS(9718),
    [anon_sym_BANG] = ACTIONS(9718),
    [sym_identifier] = ACTIONS(13225),
    [anon_sym_CARET] = ACTIONS(9720),
  },
  [6027] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6028] = {
    [sym_assignment] = STATE(8678),
    [sym_unary] = STATE(8678),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8678),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8678),
    [sym_conditional] = STATE(8678),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8678),
    [sym_binary] = STATE(8678),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [6029] = {
    [sym_assignment] = STATE(8679),
    [sym_unary] = STATE(8679),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8679),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(8679),
    [sym_conditional] = STATE(8679),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8679),
    [sym_binary] = STATE(8679),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [6030] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [6031] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [6032] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [6033] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_heredoc_body] = STATE(8680),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(5306),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(5318),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5542),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(5328),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [6034] = {
    [sym_heredoc_body] = STATE(8681),
    [aux_sym_call_repeat1] = STATE(8681),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6035] = {
    [sym_heredoc_body] = STATE(8682),
    [aux_sym_call_repeat1] = STATE(8682),
    [aux_sym_argument_list_repeat1] = STATE(8683),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9732),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6036] = {
    [aux_sym_chained_string_repeat1] = STATE(6036),
    [sym_string] = STATE(6036),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [6037] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8684),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13229),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6038] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [sym__line_break] = ACTIONS(10208),
    [anon_sym_then] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_EQ_GT] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_when] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym___END__] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_end] = ACTIONS(10208),
    [anon_sym_ensure] = ACTIONS(10208),
    [anon_sym_else] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_elsif] = ACTIONS(10208),
    [ts_builtin_sym_end] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
    [sym__binary_minus] = ACTIONS(10208),
  },
  [6039] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1264),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1265),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(8685),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1268),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1269),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13231),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6040] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [sym__line_break] = ACTIONS(10260),
    [anon_sym_then] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_EQ_GT] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_when] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym___END__] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_end] = ACTIONS(10260),
    [anon_sym_ensure] = ACTIONS(10260),
    [anon_sym_else] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_elsif] = ACTIONS(10260),
    [ts_builtin_sym_end] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
    [sym__binary_minus] = ACTIONS(10260),
  },
  [6041] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [sym__line_break] = ACTIONS(10699),
    [anon_sym_then] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_EQ_GT] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_when] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym___END__] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_end] = ACTIONS(10699),
    [anon_sym_ensure] = ACTIONS(10699),
    [anon_sym_else] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_elsif] = ACTIONS(10699),
    [ts_builtin_sym_end] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
    [sym__binary_minus] = ACTIONS(10699),
  },
  [6042] = {
    [anon_sym_end] = ACTIONS(13233),
    [sym_comment] = ACTIONS(49),
  },
  [6043] = {
    [sym_ensure] = STATE(8687),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(13233),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [6044] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [sym__line_break] = ACTIONS(10927),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
  },
  [6045] = {
    [anon_sym_end] = ACTIONS(13235),
    [sym_comment] = ACTIONS(49),
  },
  [6046] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [sym__line_break] = ACTIONS(10933),
    [anon_sym_then] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_EQ_GT] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_when] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym___END__] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10933),
    [anon_sym_ensure] = ACTIONS(10933),
    [anon_sym_else] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_elsif] = ACTIONS(10933),
    [ts_builtin_sym_end] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
    [sym__binary_minus] = ACTIONS(10933),
  },
  [6047] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13237),
  },
  [6048] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [sym__line_break] = ACTIONS(10939),
    [anon_sym_then] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_EQ_GT] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_when] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym___END__] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_end] = ACTIONS(10939),
    [anon_sym_ensure] = ACTIONS(10939),
    [anon_sym_else] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_elsif] = ACTIONS(10939),
    [ts_builtin_sym_end] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
    [sym__binary_minus] = ACTIONS(10939),
  },
  [6049] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(13239),
    [sym__string_end] = ACTIONS(13237),
  },
  [6050] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [sym__line_break] = ACTIONS(10945),
    [anon_sym_then] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_EQ_GT] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_when] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym___END__] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_end] = ACTIONS(10945),
    [anon_sym_ensure] = ACTIONS(10945),
    [anon_sym_else] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_elsif] = ACTIONS(10945),
    [ts_builtin_sym_end] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
    [sym__binary_minus] = ACTIONS(10945),
  },
  [6051] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13241),
  },
  [6052] = {
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_SLASH] = ACTIONS(8575),
    [sym__line_break] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(8575),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_when] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym___END__] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(8575),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(8575),
    [anon_sym_ensure] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_elsif] = ACTIONS(8575),
    [ts_builtin_sym_end] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_AMP_AMP] = ACTIONS(8575),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(8575),
    [sym__binary_minus] = ACTIONS(8575),
  },
  [6053] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [sym__identifier_hash_key] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym__block_ampersand] = ACTIONS(4446),
    [sym_identifier] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [sym__splat_star] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [6054] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(13243),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [6055] = {
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_SLASH] = ACTIONS(12375),
    [sym__line_break] = ACTIONS(12375),
    [anon_sym_then] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(12375),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_PLUS] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_PERCENT] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_when] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym___END__] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(12375),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_end] = ACTIONS(12375),
    [anon_sym_ensure] = ACTIONS(12375),
    [anon_sym_else] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_elsif] = ACTIONS(12375),
    [ts_builtin_sym_end] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(12375),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_AMP_AMP] = ACTIONS(12375),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(12375),
    [sym__binary_minus] = ACTIONS(12375),
  },
  [6056] = {
    [sym_assignment] = STATE(3298),
    [sym_unary] = STATE(3298),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(3298),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(3298),
    [sym_conditional] = STATE(3298),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_return] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_true] = STATE(301),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(3298),
    [sym_binary] = STATE(3298),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [sym_global_variable] = ACTIONS(523),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(505),
    [sym_character] = ACTIONS(507),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [6057] = {
    [aux_sym_exceptions_repeat1] = STATE(8694),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym___END__] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [6058] = {
    [sym_assignment] = STATE(8695),
    [sym_unary] = STATE(8695),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(301),
    [sym_singleton_class] = STATE(303),
    [sym_module] = STATE(303),
    [sym_chained_string] = STATE(303),
    [sym_until] = STATE(303),
    [sym_regex] = STATE(303),
    [sym_for] = STATE(303),
    [sym_symbol] = STATE(303),
    [sym_if] = STATE(303),
    [sym_begin] = STATE(303),
    [sym__arg] = STATE(8695),
    [sym__primary] = STATE(303),
    [sym_method_call] = STATE(301),
    [sym_operator_assignment] = STATE(8695),
    [sym_conditional] = STATE(8695),
    [sym_method] = STATE(303),
    [sym_singleton_method] = STATE(303),
    [sym__variable] = STATE(304),
    [sym_left_assignment_list] = STATE(305),
    [sym_rational] = STATE(303),
    [sym_true] = STATE(301),
    [sym_return] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_yield] = STATE(303),
    [sym_string] = STATE(1179),
    [sym_unless] = STATE(303),
    [sym_lambda] = STATE(303),
    [sym_parenthesized_statements] = STATE(303),
    [sym_element_reference] = STATE(301),
    [sym_range] = STATE(8695),
    [sym_binary] = STATE(8695),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(303),
    [sym_break] = STATE(303),
    [sym_next] = STATE(303),
    [sym_string_array] = STATE(303),
    [sym_while] = STATE(303),
    [sym_case] = STATE(303),
    [sym_symbol_array] = STATE(303),
    [sym_array] = STATE(303),
    [sym_hash] = STATE(303),
    [sym_false] = STATE(301),
    [sym_nil] = STATE(301),
    [sym_scope_resolution] = STATE(304),
    [sym_call] = STATE(304),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(497),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_not] = ACTIONS(545),
    [sym_self] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(507),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(509),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(523),
    [sym_character] = ACTIONS(507),
    [sym_super] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(569),
    [anon_sym_next] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(497),
    [sym_constant] = ACTIONS(505),
    [anon_sym_defined_QMARK] = ACTIONS(525),
    [sym_instance_variable] = ACTIONS(523),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(505),
    [sym_redo] = ACTIONS(497),
    [sym_class_variable] = ACTIONS(523),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(503),
  },
  [6059] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym___END__] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [ts_builtin_sym_end] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [6060] = {
    [anon_sym_RPAREN] = ACTIONS(13249),
    [sym_comment] = ACTIONS(49),
  },
  [6061] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym___END__] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [ts_builtin_sym_end] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [6062] = {
    [anon_sym_SLASH] = ACTIONS(10967),
    [sym__line_break] = ACTIONS(10969),
    [anon_sym_until] = ACTIONS(10969),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_RBRACE] = ACTIONS(10969),
    [anon_sym_unless] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_rescue] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_LBRACE] = ACTIONS(10969),
    [anon_sym_while] = ACTIONS(10969),
    [sym__heredoc_body_start] = ACTIONS(10969),
    [anon_sym_else] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_then] = ACTIONS(10969),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_EQ_GT] = ACTIONS(10969),
    [anon_sym_when] = ACTIONS(10969),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym___END__] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_end] = ACTIONS(10969),
    [anon_sym_ensure] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_elsif] = ACTIONS(10969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [ts_builtin_sym_end] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [anon_sym_if] = ACTIONS(10969),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [6063] = {
    [anon_sym_SLASH] = ACTIONS(9417),
    [sym__line_break] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_else] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_then] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [anon_sym_when] = ACTIONS(9419),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym___END__] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_end] = ACTIONS(9419),
    [anon_sym_ensure] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_elsif] = ACTIONS(9419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [ts_builtin_sym_end] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [6064] = {
    [anon_sym_RBRACE] = ACTIONS(13251),
    [sym_comment] = ACTIONS(49),
  },
  [6065] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym___END__] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [ts_builtin_sym_end] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [6066] = {
    [anon_sym_SLASH] = ACTIONS(9248),
    [sym__line_break] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_else] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_then] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_EQ_GT] = ACTIONS(9250),
    [anon_sym_when] = ACTIONS(9250),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym___END__] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(9250),
    [anon_sym_ensure] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_elsif] = ACTIONS(9250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [ts_builtin_sym_end] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [6067] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8699),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13253),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6068] = {
    [anon_sym_end] = ACTIONS(13255),
    [sym_comment] = ACTIONS(49),
  },
  [6069] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(8700),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(8700),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(8699),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(13257),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13253),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6070] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym___END__] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [ts_builtin_sym_end] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [6071] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_when] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym___END__] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_ensure] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_elsif] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
  },
  [6072] = {
    [anon_sym_SLASH] = ACTIONS(6215),
    [sym__line_break] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_AMP_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT_EQ] = ACTIONS(4446),
    [anon_sym_SLASH_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(6215),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_PERCENT_EQ] = ACTIONS(4446),
    [anon_sym_LT_LT_EQ] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(4446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_CARET_EQ] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_then] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_EQ_GT] = ACTIONS(4446),
    [anon_sym_when] = ACTIONS(4446),
    [anon_sym_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_PLUS_EQ] = ACTIONS(4446),
    [anon_sym_STAR_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym___END__] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(4446),
    [anon_sym_ensure] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_elsif] = ACTIONS(4446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4446),
    [ts_builtin_sym_end] = ACTIONS(4446),
    [anon_sym_DASH_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(6215),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_AMP_AMP] = ACTIONS(6215),
    [sym__binary_minus] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(6215),
  },
  [6073] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(13259),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [6074] = {
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [6075] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(1309),
    [sym_unary] = STATE(1309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(1309),
    [sym__primary] = STATE(452),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(1309),
    [sym_conditional] = STATE(1309),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1310),
    [sym_rational] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(1309),
    [sym_binary] = STATE(1309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym_float] = ACTIONS(795),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(801),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(801),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2283),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(817),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [sym__identifier_hash_key] = ACTIONS(2287),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_yield] = ACTIONS(833),
    [sym_class_variable] = ACTIONS(817),
    [sym__block_ampersand] = ACTIONS(2289),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [sym_retry] = ACTIONS(795),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9814),
    [sym_redo] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [6076] = {
    [sym_heredoc_body] = STATE(6076),
    [aux_sym_call_repeat1] = STATE(6076),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym___END__] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [ts_builtin_sym_end] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [6077] = {
    [sym_heredoc_body] = STATE(6076),
    [aux_sym_call_repeat1] = STATE(6076),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym___END__] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [ts_builtin_sym_end] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [6078] = {
    [aux_sym_argument_list_repeat1] = STATE(6078),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym___END__] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [ts_builtin_sym_end] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [6079] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [6080] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [6081] = {
    [sym_assignment] = STATE(8703),
    [sym_unary] = STATE(8703),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(8703),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(8703),
    [sym_conditional] = STATE(8703),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(8703),
    [sym_binary] = STATE(8703),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [6082] = {
    [sym_assignment] = STATE(8704),
    [sym_unary] = STATE(8704),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(8704),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(8704),
    [sym_conditional] = STATE(8704),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(8704),
    [sym_binary] = STATE(8704),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [6083] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6084] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6085] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6086] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_heredoc_body] = STATE(8705),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2311),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2317),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2327),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13267),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [6087] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6088] = {
    [sym_heredoc_body] = STATE(8707),
    [aux_sym_call_repeat1] = STATE(8707),
    [aux_sym_argument_list_repeat1] = STATE(8708),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9823),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6089] = {
    [sym_heredoc_body] = STATE(8709),
    [aux_sym_call_repeat1] = STATE(8709),
    [aux_sym_argument_list_repeat1] = STATE(8710),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6090] = {
    [sym_heredoc_body] = STATE(8709),
    [aux_sym_call_repeat1] = STATE(8709),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6091] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6092] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [6093] = {
    [sym_assignment] = STATE(8711),
    [sym_unary] = STATE(8711),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8711),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8711),
    [sym_conditional] = STATE(8711),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8711),
    [sym_binary] = STATE(8711),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6094] = {
    [sym_assignment] = STATE(8712),
    [sym_unary] = STATE(8712),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8712),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_splat_argument] = STATE(8713),
    [sym_operator_assignment] = STATE(8712),
    [sym_conditional] = STATE(8712),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(8713),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8712),
    [sym_binary] = STATE(8712),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(583),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6095] = {
    [sym_assignment] = STATE(8714),
    [sym_unary] = STATE(8714),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8714),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8714),
    [sym_conditional] = STATE(8714),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8714),
    [sym_binary] = STATE(8714),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6096] = {
    [sym_assignment] = STATE(8715),
    [sym_unary] = STATE(8715),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8715),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8715),
    [sym_conditional] = STATE(8715),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8715),
    [sym_binary] = STATE(8715),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6097] = {
    [sym_assignment] = STATE(8717),
    [sym_unary] = STATE(8717),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8717),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8717),
    [sym_conditional] = STATE(8717),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8717),
    [sym_binary] = STATE(8717),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6098] = {
    [sym_assignment] = STATE(8718),
    [sym_unary] = STATE(8718),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8718),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8718),
    [sym_conditional] = STATE(8718),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8718),
    [sym_binary] = STATE(8718),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6099] = {
    [sym_assignment] = STATE(8719),
    [sym_unary] = STATE(8719),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8719),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8719),
    [sym_conditional] = STATE(8719),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8719),
    [sym_binary] = STATE(8719),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6100] = {
    [sym_assignment] = STATE(8720),
    [sym_unary] = STATE(8720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8720),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8720),
    [sym_conditional] = STATE(8720),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8720),
    [sym_binary] = STATE(8720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6101] = {
    [sym_assignment] = STATE(8721),
    [sym_unary] = STATE(8721),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8721),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8721),
    [sym_conditional] = STATE(8721),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8721),
    [sym_binary] = STATE(8721),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6102] = {
    [sym_assignment] = STATE(8722),
    [sym_unary] = STATE(8722),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8722),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8722),
    [sym_conditional] = STATE(8722),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8722),
    [sym_binary] = STATE(8722),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6103] = {
    [sym_assignment] = STATE(8723),
    [sym_unary] = STATE(8723),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8723),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(8723),
    [sym_conditional] = STATE(8723),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8723),
    [sym_binary] = STATE(8723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6104] = {
    [aux_sym_chained_string_repeat1] = STATE(8724),
    [sym_string] = STATE(8724),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6105] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(1328),
    [sym_unary] = STATE(1328),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1328),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(1328),
    [sym_conditional] = STATE(1328),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1331),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(1328),
    [sym_binary] = STATE(1328),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2311),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(2321),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(2325),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2327),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(9859),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [6106] = {
    [sym_heredoc_body] = STATE(6106),
    [aux_sym_call_repeat1] = STATE(6106),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [6107] = {
    [sym_heredoc_body] = STATE(6106),
    [aux_sym_call_repeat1] = STATE(6106),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [6108] = {
    [aux_sym_argument_list_repeat1] = STATE(6108),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13269),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [6109] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6110] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6111] = {
    [aux_sym_exceptions_repeat1] = STATE(8726),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [6112] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6113] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6114] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6115] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6116] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6117] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6118] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [6119] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6120] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6121] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6122] = {
    [aux_sym_chained_string_repeat1] = STATE(6122),
    [sym_string] = STATE(6122),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [6123] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [6124] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6125] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [6126] = {
    [sym_assignment] = STATE(8728),
    [sym_unary] = STATE(8728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8728),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8728),
    [sym_conditional] = STATE(8728),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8728),
    [sym_binary] = STATE(8728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6127] = {
    [sym_assignment] = STATE(3386),
    [sym_unary] = STATE(3386),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3386),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_splat_argument] = STATE(8729),
    [sym_operator_assignment] = STATE(3386),
    [sym_conditional] = STATE(3386),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_subshell] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(8729),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(3386),
    [sym_binary] = STATE(3386),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5702),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(583),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6128] = {
    [sym_assignment] = STATE(8730),
    [sym_unary] = STATE(8730),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8730),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8730),
    [sym_conditional] = STATE(8730),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8730),
    [sym_binary] = STATE(8730),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6129] = {
    [sym_assignment] = STATE(8731),
    [sym_unary] = STATE(8731),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8731),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8731),
    [sym_conditional] = STATE(8731),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8731),
    [sym_binary] = STATE(8731),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6130] = {
    [sym_assignment] = STATE(8732),
    [sym_unary] = STATE(8732),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8732),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8732),
    [sym_conditional] = STATE(8732),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8732),
    [sym_binary] = STATE(8732),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6131] = {
    [sym_assignment] = STATE(8733),
    [sym_unary] = STATE(8733),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8733),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8733),
    [sym_conditional] = STATE(8733),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8733),
    [sym_binary] = STATE(8733),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6132] = {
    [sym_assignment] = STATE(8734),
    [sym_unary] = STATE(8734),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8734),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8734),
    [sym_conditional] = STATE(8734),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8734),
    [sym_binary] = STATE(8734),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6133] = {
    [sym_assignment] = STATE(8735),
    [sym_unary] = STATE(8735),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8735),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8735),
    [sym_conditional] = STATE(8735),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8735),
    [sym_binary] = STATE(8735),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6134] = {
    [sym_assignment] = STATE(8736),
    [sym_unary] = STATE(8736),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8736),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8736),
    [sym_conditional] = STATE(8736),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8736),
    [sym_binary] = STATE(8736),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6135] = {
    [sym_assignment] = STATE(8737),
    [sym_unary] = STATE(8737),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8737),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8737),
    [sym_conditional] = STATE(8737),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8737),
    [sym_binary] = STATE(8737),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6136] = {
    [sym_assignment] = STATE(8738),
    [sym_unary] = STATE(8738),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8738),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8738),
    [sym_conditional] = STATE(8738),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8738),
    [sym_binary] = STATE(8738),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6137] = {
    [sym_assignment] = STATE(8739),
    [sym_unary] = STATE(8739),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8739),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(8739),
    [sym_conditional] = STATE(8739),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(8739),
    [sym_binary] = STATE(8739),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6138] = {
    [sym_assignment] = STATE(3386),
    [sym_unary] = STATE(3386),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(3386),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(3386),
    [sym_conditional] = STATE(3386),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_true] = STATE(3385),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(3386),
    [sym_binary] = STATE(3386),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5702),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(583),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [6139] = {
    [aux_sym_exceptions_repeat1] = STATE(8740),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(9893),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [6140] = {
    [sym_assignment] = STATE(8741),
    [sym_unary] = STATE(8741),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8741),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(8741),
    [sym_conditional] = STATE(8741),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(8741),
    [sym_binary] = STATE(8741),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [6141] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [sym__line_break] = ACTIONS(13276),
    [anon_sym_then] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_when] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym___END__] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_end] = ACTIONS(13276),
    [anon_sym_ensure] = ACTIONS(13276),
    [anon_sym_else] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_elsif] = ACTIONS(13276),
    [ts_builtin_sym_end] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
    [sym__binary_minus] = ACTIONS(13276),
  },
  [6142] = {
    [anon_sym_end] = ACTIONS(13278),
    [sym_comment] = ACTIONS(49),
  },
  [6143] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(8743),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(13278),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [6144] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(13280),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6145] = {
    [anon_sym_COLON] = ACTIONS(13282),
    [sym_comment] = ACTIONS(49),
  },
  [6146] = {
    [sym_assignment] = STATE(8750),
    [sym_unary] = STATE(8750),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8750),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(8750),
    [sym_conditional] = STATE(8750),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(8750),
    [sym_binary] = STATE(8750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6147] = {
    [sym_assignment] = STATE(8752),
    [sym_unary] = STATE(8752),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8752),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(8752),
    [sym_conditional] = STATE(8752),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(8752),
    [sym_binary] = STATE(8752),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6148] = {
    [sym_assignment] = STATE(8753),
    [sym_unary] = STATE(8753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8753),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(8753),
    [sym_conditional] = STATE(8753),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(8753),
    [sym_binary] = STATE(8753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6149] = {
    [sym_heredoc_body] = STATE(8755),
    [aux_sym_call_repeat1] = STATE(8755),
    [aux_sym_argument_list_repeat1] = STATE(8756),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13294),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6150] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_EQ_GT] = ACTIONS(13282),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [6151] = {
    [aux_sym_chained_string_repeat1] = STATE(3695),
    [sym_string] = STATE(3695),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13296),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6152] = {
    [sym_heredoc_body] = STATE(8755),
    [aux_sym_call_repeat1] = STATE(8755),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6153] = {
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_SLASH] = ACTIONS(9921),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(9931),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(9931),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_PIPE] = ACTIONS(9943),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [6154] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6155] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [6156] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_then] = ACTIONS(2053),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [6157] = {
    [sym_assignment] = STATE(8757),
    [sym_unary] = STATE(8757),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8757),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8757),
    [sym_conditional] = STATE(8757),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8757),
    [sym_binary] = STATE(8757),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6158] = {
    [sym_assignment] = STATE(8759),
    [sym_unary] = STATE(8759),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8759),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_splat_argument] = STATE(8760),
    [sym_operator_assignment] = STATE(8759),
    [sym_conditional] = STATE(8759),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_subshell] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(8760),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8759),
    [sym_binary] = STATE(8759),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(13298),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6159] = {
    [sym_assignment] = STATE(8761),
    [sym_unary] = STATE(8761),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8761),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8761),
    [sym_conditional] = STATE(8761),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8761),
    [sym_binary] = STATE(8761),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6160] = {
    [sym_assignment] = STATE(8762),
    [sym_unary] = STATE(8762),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8762),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8762),
    [sym_conditional] = STATE(8762),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8762),
    [sym_binary] = STATE(8762),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6161] = {
    [sym_assignment] = STATE(8763),
    [sym_unary] = STATE(8763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8763),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8763),
    [sym_conditional] = STATE(8763),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8763),
    [sym_binary] = STATE(8763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6162] = {
    [sym_assignment] = STATE(8764),
    [sym_unary] = STATE(8764),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8764),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8764),
    [sym_conditional] = STATE(8764),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8764),
    [sym_binary] = STATE(8764),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6163] = {
    [sym_assignment] = STATE(8765),
    [sym_unary] = STATE(8765),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8765),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8765),
    [sym_conditional] = STATE(8765),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8765),
    [sym_binary] = STATE(8765),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6164] = {
    [sym_assignment] = STATE(8766),
    [sym_unary] = STATE(8766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8766),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8766),
    [sym_conditional] = STATE(8766),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8766),
    [sym_binary] = STATE(8766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6165] = {
    [sym_assignment] = STATE(8767),
    [sym_unary] = STATE(8767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8767),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8767),
    [sym_conditional] = STATE(8767),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8767),
    [sym_binary] = STATE(8767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6166] = {
    [sym_assignment] = STATE(8768),
    [sym_unary] = STATE(8768),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8768),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8768),
    [sym_conditional] = STATE(8768),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8768),
    [sym_binary] = STATE(8768),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6167] = {
    [sym_assignment] = STATE(8769),
    [sym_unary] = STATE(8769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8769),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8769),
    [sym_conditional] = STATE(8769),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8769),
    [sym_binary] = STATE(8769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6168] = {
    [sym_assignment] = STATE(8770),
    [sym_unary] = STATE(8770),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8770),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(8770),
    [sym_conditional] = STATE(8770),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8770),
    [sym_binary] = STATE(8770),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6169] = {
    [sym_heredoc_body] = STATE(8775),
    [sym__argument_list_with_parens] = STATE(8774),
    [aux_sym_call_repeat1] = STATE(8775),
    [sym_argument_list_with_parens] = STATE(8773),
    [sym_operator] = STATE(8773),
    [anon_sym_LT] = ACTIONS(13300),
    [anon_sym_SLASH] = ACTIONS(13302),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13302),
    [anon_sym_PLUS_AT] = ACTIONS(13302),
    [anon_sym_LPAREN2] = ACTIONS(13304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13302),
    [anon_sym_GT_GT] = ACTIONS(13302),
    [anon_sym_EQ_TILDE] = ACTIONS(13302),
    [anon_sym_LT_LT] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13302),
    [anon_sym_PLUS] = ACTIONS(13300),
    [anon_sym_AMP] = ACTIONS(13302),
    [anon_sym_GT] = ACTIONS(13300),
    [anon_sym_PERCENT] = ACTIONS(13302),
    [anon_sym_DASH_AT] = ACTIONS(13302),
    [anon_sym_EQ_EQ] = ACTIONS(13300),
    [anon_sym_STAR] = ACTIONS(13300),
    [anon_sym_BANG_TILDE] = ACTIONS(13302),
    [sym_constant] = ACTIONS(13306),
    [anon_sym_DASH] = ACTIONS(13300),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13302),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13300),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13302),
    [anon_sym_STAR_STAR] = ACTIONS(13302),
    [anon_sym_PIPE] = ACTIONS(13302),
    [anon_sym_DOT_DOT] = ACTIONS(13302),
    [anon_sym_LT_EQ_GT] = ACTIONS(13302),
    [anon_sym_LT_EQ] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13306),
    [anon_sym_CARET] = ACTIONS(13302),
  },
  [6170] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13308),
    [sym_identifier] = ACTIONS(13308),
  },
  [6171] = {
    [aux_sym_heredoc_body_repeat1] = STATE(8778),
    [sym_interpolation] = STATE(8778),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(13310),
    [sym_heredoc_end] = ACTIONS(13312),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(13310),
  },
  [6172] = {
    [sym__statement] = STATE(8789),
    [sym_unary] = STATE(8794),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(8789),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_unless_modifier] = STATE(8789),
    [sym_symbol] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym__primary] = STATE(8790),
    [sym_method] = STATE(8790),
    [sym_conditional] = STATE(8794),
    [sym_left_assignment_list] = STATE(8791),
    [sym_return] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_while_modifier] = STATE(8789),
    [sym_subshell] = STATE(8790),
    [sym_unless] = STATE(8790),
    [sym_empty_statement] = STATE(8796),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_begin_block] = STATE(8789),
    [sym_range] = STATE(8794),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(8793),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_call] = STATE(8792),
    [sym_end_block] = STATE(8789),
    [sym_assignment] = STATE(8794),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_alias] = STATE(8789),
    [sym_if_modifier] = STATE(8789),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(8794),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(8794),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_rational] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_until_modifier] = STATE(8789),
    [sym_lambda] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(8794),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_nil] = STATE(8793),
    [sym_rescue_modifier] = STATE(8789),
    [sym_symbol_array] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_hash] = STATE(8790),
    [aux_sym__statements_repeat1] = STATE(8796),
    [sym_scope_resolution] = STATE(8792),
    [sym_float] = ACTIONS(13314),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(13316),
    [sym_self] = ACTIONS(13318),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(13318),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(13326),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3728),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [anon_sym_yield] = ACTIONS(13332),
    [sym_class_variable] = ACTIONS(13326),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(13334),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_when] = ACTIONS(3728),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [sym_retry] = ACTIONS(13314),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(3728),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(13314),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [6173] = {
    [sym_assignment] = STATE(3414),
    [sym_unary] = STATE(3414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(3414),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_pattern] = STATE(8797),
    [sym_splat_argument] = STATE(3417),
    [sym_operator_assignment] = STATE(3414),
    [sym_conditional] = STATE(3414),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_rational] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(3414),
    [sym_binary] = STATE(3414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5724),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [6174] = {
    [sym__statement] = STATE(8789),
    [sym_unary] = STATE(8794),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(8789),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_unless_modifier] = STATE(8789),
    [sym_symbol] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym__primary] = STATE(8790),
    [sym_method] = STATE(8790),
    [sym_conditional] = STATE(8794),
    [sym_left_assignment_list] = STATE(8791),
    [sym_return] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_while_modifier] = STATE(8789),
    [sym_subshell] = STATE(8790),
    [sym_unless] = STATE(8790),
    [sym_empty_statement] = STATE(8796),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_begin_block] = STATE(8789),
    [sym_range] = STATE(8794),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(8793),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_call] = STATE(8792),
    [sym_end_block] = STATE(8789),
    [sym_assignment] = STATE(8794),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_alias] = STATE(8789),
    [sym_if_modifier] = STATE(8789),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(8794),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(8794),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_rational] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_until_modifier] = STATE(8789),
    [sym_lambda] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(8794),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_nil] = STATE(8793),
    [sym_rescue_modifier] = STATE(8789),
    [sym_symbol_array] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_hash] = STATE(8790),
    [aux_sym__statements_repeat1] = STATE(8796),
    [sym_scope_resolution] = STATE(8792),
    [sym_float] = ACTIONS(13314),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(13316),
    [sym_self] = ACTIONS(13318),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(13318),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(13326),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [anon_sym_yield] = ACTIONS(13332),
    [sym_class_variable] = ACTIONS(13326),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(13334),
    [anon_sym_then] = ACTIONS(13348),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_when] = ACTIONS(13346),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [sym_retry] = ACTIONS(13314),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13346),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(13314),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [6175] = {
    [anon_sym_end] = ACTIONS(13350),
    [anon_sym_when] = ACTIONS(13350),
    [anon_sym_else] = ACTIONS(13350),
    [sym_comment] = ACTIONS(49),
  },
  [6176] = {
    [sym__terminator] = STATE(8799),
    [sym_heredoc_body] = STATE(8799),
    [sym_then] = STATE(8800),
    [aux_sym_when_repeat1] = STATE(8801),
    [sym__heredoc_body_start] = ACTIONS(9953),
    [anon_sym_then] = ACTIONS(9955),
    [sym__line_break] = ACTIONS(13352),
    [anon_sym_COMMA] = ACTIONS(9959),
    [anon_sym_SEMI] = ACTIONS(13352),
    [sym_comment] = ACTIONS(49),
  },
  [6177] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(13354),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6178] = {
    [anon_sym_COLON] = ACTIONS(13356),
    [sym_comment] = ACTIONS(49),
  },
  [6179] = {
    [sym_assignment] = STATE(8812),
    [sym_unary] = STATE(8812),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(8812),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(8812),
    [sym_conditional] = STATE(8812),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(8812),
    [sym_binary] = STATE(8812),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [6180] = {
    [sym_assignment] = STATE(8817),
    [sym_unary] = STATE(8817),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(8817),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(8817),
    [sym_conditional] = STATE(8817),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(8817),
    [sym_binary] = STATE(8817),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [6181] = {
    [sym_assignment] = STATE(8818),
    [sym_unary] = STATE(8818),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(8818),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(8818),
    [sym_conditional] = STATE(8818),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(8818),
    [sym_binary] = STATE(8818),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [6182] = {
    [sym_heredoc_body] = STATE(8820),
    [aux_sym_call_repeat1] = STATE(8820),
    [aux_sym_argument_list_repeat1] = STATE(8821),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13384),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6183] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_EQ_GT] = ACTIONS(13356),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [6184] = {
    [aux_sym_chained_string_repeat1] = STATE(6493),
    [sym_string] = STATE(6493),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13386),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6185] = {
    [sym_heredoc_body] = STATE(8820),
    [aux_sym_call_repeat1] = STATE(8820),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6186] = {
    [aux_sym_chained_string_repeat1] = STATE(8822),
    [sym_string] = STATE(8822),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6187] = {
    [aux_sym_undef_repeat1] = STATE(6187),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_RPAREN] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [6188] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [6189] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [6190] = {
    [sym_assignment] = STATE(8823),
    [sym_unary] = STATE(8823),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(8823),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(8823),
    [sym_conditional] = STATE(8823),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(8823),
    [sym_binary] = STATE(8823),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [6191] = {
    [sym_assignment] = STATE(8824),
    [sym_unary] = STATE(8824),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(8824),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(8824),
    [sym_conditional] = STATE(8824),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(8824),
    [sym_binary] = STATE(8824),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [6192] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6193] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6194] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6195] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_heredoc_body] = STATE(8825),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_float] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2395),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2403),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13388),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [6196] = {
    [sym_heredoc_body] = STATE(8826),
    [aux_sym_call_repeat1] = STATE(8826),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6197] = {
    [sym_heredoc_body] = STATE(8827),
    [aux_sym_call_repeat1] = STATE(8827),
    [aux_sym_argument_list_repeat1] = STATE(8828),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9985),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6198] = {
    [sym_heredoc_body] = STATE(8829),
    [aux_sym_call_repeat1] = STATE(8829),
    [aux_sym_argument_list_repeat1] = STATE(8830),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6199] = {
    [sym_heredoc_body] = STATE(8829),
    [aux_sym_call_repeat1] = STATE(8829),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6200] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6201] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [6202] = {
    [sym_assignment] = STATE(8831),
    [sym_unary] = STATE(8831),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8831),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8831),
    [sym_conditional] = STATE(8831),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8831),
    [sym_binary] = STATE(8831),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6203] = {
    [sym_assignment] = STATE(8832),
    [sym_unary] = STATE(8832),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8832),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_splat_argument] = STATE(8833),
    [sym_operator_assignment] = STATE(8832),
    [sym_conditional] = STATE(8832),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_return] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_subshell] = STATE(338),
    [sym__arg_or_splat_arg] = STATE(8833),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8832),
    [sym_binary] = STATE(8832),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(613),
    [sym_character] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6204] = {
    [sym_assignment] = STATE(8834),
    [sym_unary] = STATE(8834),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8834),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8834),
    [sym_conditional] = STATE(8834),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8834),
    [sym_binary] = STATE(8834),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6205] = {
    [sym_assignment] = STATE(8835),
    [sym_unary] = STATE(8835),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8835),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8835),
    [sym_conditional] = STATE(8835),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8835),
    [sym_binary] = STATE(8835),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6206] = {
    [sym_assignment] = STATE(8837),
    [sym_unary] = STATE(8837),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8837),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8837),
    [sym_conditional] = STATE(8837),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8837),
    [sym_binary] = STATE(8837),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6207] = {
    [sym_assignment] = STATE(8838),
    [sym_unary] = STATE(8838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8838),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8838),
    [sym_conditional] = STATE(8838),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8838),
    [sym_binary] = STATE(8838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6208] = {
    [sym_assignment] = STATE(8839),
    [sym_unary] = STATE(8839),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8839),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8839),
    [sym_conditional] = STATE(8839),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8839),
    [sym_binary] = STATE(8839),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6209] = {
    [sym_assignment] = STATE(8840),
    [sym_unary] = STATE(8840),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8840),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8840),
    [sym_conditional] = STATE(8840),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8840),
    [sym_binary] = STATE(8840),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6210] = {
    [sym_assignment] = STATE(8841),
    [sym_unary] = STATE(8841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8841),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8841),
    [sym_conditional] = STATE(8841),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8841),
    [sym_binary] = STATE(8841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6211] = {
    [sym_assignment] = STATE(8842),
    [sym_unary] = STATE(8842),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8842),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8842),
    [sym_conditional] = STATE(8842),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8842),
    [sym_binary] = STATE(8842),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6212] = {
    [sym_assignment] = STATE(8843),
    [sym_unary] = STATE(8843),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8843),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(8843),
    [sym_conditional] = STATE(8843),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8843),
    [sym_binary] = STATE(8843),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6213] = {
    [aux_sym_chained_string_repeat1] = STATE(8844),
    [sym_string] = STATE(8844),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [6214] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(1375),
    [sym_unary] = STATE(1375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(1375),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(1375),
    [sym_conditional] = STATE(1375),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(1379),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(1375),
    [sym_binary] = STATE(1375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_float] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2395),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(2413),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10021),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [6215] = {
    [sym_heredoc_body] = STATE(6215),
    [aux_sym_call_repeat1] = STATE(6215),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [6216] = {
    [sym_heredoc_body] = STATE(6215),
    [aux_sym_call_repeat1] = STATE(6215),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [6217] = {
    [aux_sym_argument_list_repeat1] = STATE(6217),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [6218] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6219] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6220] = {
    [aux_sym_exceptions_repeat1] = STATE(8846),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [6221] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6222] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6223] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13393),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6224] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6225] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6226] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6227] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6228] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6229] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6230] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [6231] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6232] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8849),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13395),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6233] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6234] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6235] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6234),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8850),
    [sym_operator] = STATE(8850),
    [anon_sym_LT] = ACTIONS(10023),
    [anon_sym_SLASH] = ACTIONS(10025),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10025),
    [anon_sym_PLUS_AT] = ACTIONS(10025),
    [anon_sym_LPAREN2] = ACTIONS(10027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10025),
    [anon_sym_GT_GT] = ACTIONS(10025),
    [anon_sym_EQ_TILDE] = ACTIONS(10025),
    [anon_sym_LT_LT] = ACTIONS(10025),
    [anon_sym_TILDE] = ACTIONS(10025),
    [anon_sym_PLUS] = ACTIONS(10023),
    [anon_sym_AMP] = ACTIONS(10025),
    [anon_sym_GT] = ACTIONS(10023),
    [anon_sym_PERCENT] = ACTIONS(10025),
    [anon_sym_DASH_AT] = ACTIONS(10025),
    [anon_sym_EQ_EQ] = ACTIONS(10023),
    [anon_sym_STAR] = ACTIONS(10023),
    [anon_sym_BANG_TILDE] = ACTIONS(10025),
    [sym_constant] = ACTIONS(13397),
    [anon_sym_DASH] = ACTIONS(10023),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10025),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10023),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10025),
    [anon_sym_STAR_STAR] = ACTIONS(10025),
    [anon_sym_PIPE] = ACTIONS(10025),
    [anon_sym_DOT_DOT] = ACTIONS(10025),
    [anon_sym_LT_EQ_GT] = ACTIONS(10025),
    [anon_sym_LT_EQ] = ACTIONS(10023),
    [anon_sym_BANG] = ACTIONS(10023),
    [sym_identifier] = ACTIONS(13397),
    [anon_sym_CARET] = ACTIONS(10025),
  },
  [6236] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6237] = {
    [sym_assignment] = STATE(8851),
    [sym_unary] = STATE(8851),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(8851),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(8851),
    [sym_conditional] = STATE(8851),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(8851),
    [sym_binary] = STATE(8851),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [6238] = {
    [sym_assignment] = STATE(8852),
    [sym_unary] = STATE(8852),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(8852),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(8852),
    [sym_conditional] = STATE(8852),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(8852),
    [sym_binary] = STATE(8852),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [6239] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6240] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6241] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6242] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_heredoc_body] = STATE(8853),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym_float] = ACTIONS(2463),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2467),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2467),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2475),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [sym_class_variable] = ACTIONS(2475),
    [sym__block_ampersand] = ACTIONS(5830),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13399),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [6243] = {
    [sym_heredoc_body] = STATE(8854),
    [aux_sym_call_repeat1] = STATE(8854),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6244] = {
    [sym_heredoc_body] = STATE(8855),
    [aux_sym_call_repeat1] = STATE(8855),
    [aux_sym_argument_list_repeat1] = STATE(8856),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10037),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6245] = {
    [aux_sym_chained_string_repeat1] = STATE(6245),
    [sym_string] = STATE(6245),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [6246] = {
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [sym_self] = ACTIONS(1327),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(1327),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [anon_sym_next] = ACTIONS(1327),
    [sym_retry] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6247] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(8858),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13401),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6248] = {
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [sym_self] = ACTIONS(6719),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_nil] = ACTIONS(6719),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6721),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [anon_sym_next] = ACTIONS(6719),
    [sym_retry] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6721),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6249] = {
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [sym_self] = ACTIONS(6727),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_nil] = ACTIONS(6727),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6729),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [anon_sym_next] = ACTIONS(6727),
    [sym_retry] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6250] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6249),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(8859),
    [sym_operator] = STATE(8859),
    [anon_sym_LT] = ACTIONS(10041),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10043),
    [anon_sym_PLUS_AT] = ACTIONS(10043),
    [anon_sym_LPAREN2] = ACTIONS(10045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10043),
    [anon_sym_GT_GT] = ACTIONS(10043),
    [anon_sym_EQ_TILDE] = ACTIONS(10043),
    [anon_sym_LT_LT] = ACTIONS(10043),
    [anon_sym_TILDE] = ACTIONS(10043),
    [anon_sym_PLUS] = ACTIONS(10041),
    [anon_sym_AMP] = ACTIONS(10043),
    [anon_sym_GT] = ACTIONS(10041),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [anon_sym_DASH_AT] = ACTIONS(10043),
    [anon_sym_EQ_EQ] = ACTIONS(10041),
    [anon_sym_STAR] = ACTIONS(10041),
    [anon_sym_BANG_TILDE] = ACTIONS(10043),
    [sym_constant] = ACTIONS(13403),
    [anon_sym_DASH] = ACTIONS(10041),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10043),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10041),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10043),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_PIPE] = ACTIONS(10043),
    [anon_sym_DOT_DOT] = ACTIONS(10043),
    [anon_sym_LT_EQ_GT] = ACTIONS(10043),
    [anon_sym_LT_EQ] = ACTIONS(10041),
    [anon_sym_BANG] = ACTIONS(10041),
    [sym_identifier] = ACTIONS(13403),
    [anon_sym_CARET] = ACTIONS(10043),
  },
  [6251] = {
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6252] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6253] = {
    [aux_sym_chained_string_repeat1] = STATE(6294),
    [sym_string] = STATE(6294),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6254] = {
    [sym_assignment] = STATE(8860),
    [sym_unary] = STATE(8860),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8860),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(8860),
    [sym_conditional] = STATE(8860),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(8860),
    [sym_binary] = STATE(8860),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [6255] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [6256] = {
    [sym_assignment] = STATE(8861),
    [sym_unary] = STATE(8861),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8861),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(8861),
    [sym_conditional] = STATE(8861),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(8861),
    [sym_binary] = STATE(8861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [6257] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(13405),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6258] = {
    [anon_sym_COLON] = ACTIONS(13407),
    [sym_comment] = ACTIONS(49),
  },
  [6259] = {
    [sym_assignment] = STATE(8864),
    [sym_unary] = STATE(8864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8864),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8864),
    [sym_conditional] = STATE(8864),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8864),
    [sym_binary] = STATE(8864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6260] = {
    [sym_assignment] = STATE(8865),
    [sym_unary] = STATE(8865),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8865),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8865),
    [sym_conditional] = STATE(8865),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8865),
    [sym_binary] = STATE(8865),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6261] = {
    [sym_assignment] = STATE(8866),
    [sym_unary] = STATE(8866),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8866),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8866),
    [sym_conditional] = STATE(8866),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8866),
    [sym_binary] = STATE(8866),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6262] = {
    [sym_heredoc_body] = STATE(8868),
    [aux_sym_call_repeat1] = STATE(8868),
    [aux_sym_argument_list_repeat1] = STATE(8869),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13409),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6263] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [6264] = {
    [aux_sym_chained_string_repeat1] = STATE(6294),
    [sym_string] = STATE(6294),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13411),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6265] = {
    [sym_heredoc_body] = STATE(8868),
    [aux_sym_call_repeat1] = STATE(8868),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6266] = {
    [sym__argument] = STATE(8875),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(8875),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8875),
    [sym_hash_splat_argument] = STATE(8875),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(8878),
    [sym_block_argument] = STATE(8875),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(13417),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [6267] = {
    [sym__argument] = STATE(8875),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(8875),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8875),
    [sym_hash_splat_argument] = STATE(8875),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(8878),
    [sym_block_argument] = STATE(8875),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(13417),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [6268] = {
    [sym_assignment] = STATE(8879),
    [sym_unary] = STATE(8879),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8879),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(8879),
    [sym_conditional] = STATE(8879),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(8879),
    [sym_binary] = STATE(8879),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [6269] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [6270] = {
    [sym__argument] = STATE(8875),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(8875),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8875),
    [sym_hash_splat_argument] = STATE(8875),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(8878),
    [sym_block_argument] = STATE(8875),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(13417),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [6271] = {
    [sym_assignment] = STATE(8880),
    [sym_unary] = STATE(8880),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8880),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(8880),
    [sym_conditional] = STATE(8880),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(8880),
    [sym_binary] = STATE(8880),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [6272] = {
    [sym__argument] = STATE(8875),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(8875),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8875),
    [sym_hash_splat_argument] = STATE(8875),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym__argument_list_with_parens] = STATE(8878),
    [sym_block_argument] = STATE(8875),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(2171),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(5250),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(5318),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(13417),
    [anon_sym_not] = ACTIONS(5856),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(10063),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [6273] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(13421),
    [anon_sym_SLASH_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13421),
    [anon_sym_PIPE_EQ] = ACTIONS(13421),
    [anon_sym_LT_LT_EQ] = ACTIONS(13421),
    [anon_sym_PLUS_EQ] = ACTIONS(13421),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13421),
    [anon_sym_STAR_EQ] = ACTIONS(13421),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13421),
    [anon_sym_CARET_EQ] = ACTIONS(13421),
    [anon_sym_DASH_EQ] = ACTIONS(13421),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13421),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(13423),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6274] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(13437),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [anon_sym_and] = ACTIONS(13437),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_PIPE] = ACTIONS(13449),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [6275] = {
    [anon_sym_EQ] = ACTIONS(13453),
    [sym_comment] = ACTIONS(3),
  },
  [6276] = {
    [aux_sym_chained_string_repeat1] = STATE(8893),
    [sym_string] = STATE(8893),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6277] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(13437),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [anon_sym_and] = ACTIONS(13437),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_PIPE] = ACTIONS(13449),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [6278] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(13437),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [anon_sym_and] = ACTIONS(13437),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_PIPE] = ACTIONS(13449),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [6279] = {
    [sym_assignment] = STATE(8894),
    [sym_unary] = STATE(8894),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8894),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(8895),
    [sym_operator_assignment] = STATE(8894),
    [sym_conditional] = STATE(8894),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_subshell] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(8895),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8894),
    [sym_binary] = STATE(8894),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(5310),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6280] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3498),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(8896),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5852),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5848),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5858),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5860),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(5868),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6281] = {
    [sym_heredoc_body] = STATE(8897),
    [aux_sym_call_repeat1] = STATE(8897),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
  },
  [6282] = {
    [sym_heredoc_body] = STATE(8898),
    [aux_sym_call_repeat1] = STATE(8898),
    [aux_sym_argument_list_repeat1] = STATE(8899),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(10085),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
  },
  [6283] = {
    [sym_assignment] = STATE(8900),
    [sym_unary] = STATE(8900),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8900),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8900),
    [sym_conditional] = STATE(8900),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8900),
    [sym_binary] = STATE(8900),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6284] = {
    [sym_assignment] = STATE(8901),
    [sym_unary] = STATE(8901),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8901),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8901),
    [sym_conditional] = STATE(8901),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8901),
    [sym_binary] = STATE(8901),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6285] = {
    [sym_assignment] = STATE(8902),
    [sym_unary] = STATE(8902),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8902),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8902),
    [sym_conditional] = STATE(8902),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8902),
    [sym_binary] = STATE(8902),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6286] = {
    [sym_assignment] = STATE(8903),
    [sym_unary] = STATE(8903),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8903),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8903),
    [sym_conditional] = STATE(8903),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8903),
    [sym_binary] = STATE(8903),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6287] = {
    [sym_assignment] = STATE(8904),
    [sym_unary] = STATE(8904),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8904),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8904),
    [sym_conditional] = STATE(8904),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8904),
    [sym_binary] = STATE(8904),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6288] = {
    [sym_assignment] = STATE(8905),
    [sym_unary] = STATE(8905),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8905),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8905),
    [sym_conditional] = STATE(8905),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8905),
    [sym_binary] = STATE(8905),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6289] = {
    [sym_assignment] = STATE(8906),
    [sym_unary] = STATE(8906),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8906),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8906),
    [sym_conditional] = STATE(8906),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8906),
    [sym_binary] = STATE(8906),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6290] = {
    [sym_assignment] = STATE(8907),
    [sym_unary] = STATE(8907),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8907),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8907),
    [sym_conditional] = STATE(8907),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8907),
    [sym_binary] = STATE(8907),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6291] = {
    [sym_assignment] = STATE(8908),
    [sym_unary] = STATE(8908),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8908),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8908),
    [sym_conditional] = STATE(8908),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8908),
    [sym_binary] = STATE(8908),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6292] = {
    [sym_assignment] = STATE(8909),
    [sym_unary] = STATE(8909),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8909),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8909),
    [sym_conditional] = STATE(8909),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8909),
    [sym_binary] = STATE(8909),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6293] = {
    [sym_assignment] = STATE(8910),
    [sym_unary] = STATE(8910),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8910),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(8910),
    [sym_conditional] = STATE(8910),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8910),
    [sym_binary] = STATE(8910),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [6294] = {
    [aux_sym_chained_string_repeat1] = STATE(8911),
    [sym_string] = STATE(8911),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6295] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [6296] = {
    [sym_rest_assignment] = STATE(1624),
    [sym__lhs] = STATE(1625),
    [sym_singleton_class] = STATE(1382),
    [sym_module] = STATE(1382),
    [sym_chained_string] = STATE(1382),
    [sym_until] = STATE(1382),
    [sym_regex] = STATE(1382),
    [sym_for] = STATE(1382),
    [sym_symbol] = STATE(1382),
    [sym_if] = STATE(1382),
    [sym_begin] = STATE(1382),
    [sym__primary] = STATE(1382),
    [sym_method_call] = STATE(1625),
    [sym_method] = STATE(1382),
    [sym_singleton_method] = STATE(1382),
    [sym__variable] = STATE(1383),
    [sym_rational] = STATE(1382),
    [sym_true] = STATE(1625),
    [sym_return] = STATE(1382),
    [sym_subshell] = STATE(1382),
    [sym_yield] = STATE(1382),
    [sym_string] = STATE(239),
    [sym_unless] = STATE(1382),
    [sym_lambda] = STATE(1382),
    [sym_parenthesized_statements] = STATE(1382),
    [sym_element_reference] = STATE(1625),
    [sym_destructured_left_assignment] = STATE(1624),
    [sym_class] = STATE(1382),
    [sym_break] = STATE(1382),
    [sym_next] = STATE(1382),
    [sym_string_array] = STATE(1382),
    [sym_while] = STATE(1382),
    [sym_case] = STATE(1382),
    [sym_symbol_array] = STATE(1382),
    [sym_array] = STATE(1382),
    [sym_hash] = STATE(1382),
    [sym_false] = STATE(1625),
    [sym_nil] = STATE(1625),
    [sym_scope_resolution] = STATE(1383),
    [sym_call] = STATE(1383),
    [anon_sym_return] = ACTIONS(393),
    [sym_float] = ACTIONS(2427),
    [anon_sym_TRUE] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_until] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [sym_identifier] = ACTIONS(2429),
    [sym_self] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(409),
    [anon_sym_unless] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(413),
    [sym_heredoc_beginning] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(419),
    [sym_complex] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2433),
    [sym_super] = ACTIONS(2429),
    [anon_sym_false] = ACTIONS(423),
    [sym__subshell_start] = ACTIONS(425),
    [anon_sym_LBRACK2] = ACTIONS(427),
    [sym__symbol_array_start] = ACTIONS(429),
    [anon_sym_nil] = ACTIONS(431),
    [sym__simple_symbol] = ACTIONS(433),
    [sym_character] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_next] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(441),
    [sym_retry] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2433),
    [sym__string_start] = ACTIONS(443),
    [sym_integer] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(447),
    [sym__regex_start] = ACTIONS(449),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(451),
    [anon_sym_NIL] = ACTIONS(431),
    [anon_sym_FALSE] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_def] = ACTIONS(455),
    [sym_redo] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(457),
    [sym_class_variable] = ACTIONS(2433),
    [sym__string_array_start] = ACTIONS(459),
    [sym__symbol_start] = ACTIONS(461),
  },
  [6297] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [6298] = {
    [anon_sym_RPAREN] = ACTIONS(13455),
    [sym_comment] = ACTIONS(49),
  },
  [6299] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [6300] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [6301] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6302] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [6303] = {
    [sym_assignment] = STATE(8913),
    [sym_unary] = STATE(8913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8913),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8913),
    [sym_conditional] = STATE(8913),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8913),
    [sym_binary] = STATE(8913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6304] = {
    [sym_assignment] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_splat_argument] = STATE(8914),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_return] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_subshell] = STATE(338),
    [sym__arg_or_splat_arg] = STATE(8914),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5892),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(613),
    [sym_character] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6305] = {
    [sym_assignment] = STATE(8915),
    [sym_unary] = STATE(8915),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8915),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8915),
    [sym_conditional] = STATE(8915),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8915),
    [sym_binary] = STATE(8915),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6306] = {
    [sym_assignment] = STATE(8916),
    [sym_unary] = STATE(8916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8916),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8916),
    [sym_conditional] = STATE(8916),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8916),
    [sym_binary] = STATE(8916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6307] = {
    [sym_assignment] = STATE(8918),
    [sym_unary] = STATE(8918),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8918),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8918),
    [sym_conditional] = STATE(8918),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8918),
    [sym_binary] = STATE(8918),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6308] = {
    [sym_assignment] = STATE(8919),
    [sym_unary] = STATE(8919),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8919),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8919),
    [sym_conditional] = STATE(8919),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8919),
    [sym_binary] = STATE(8919),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6309] = {
    [sym_assignment] = STATE(8920),
    [sym_unary] = STATE(8920),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8920),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8920),
    [sym_conditional] = STATE(8920),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8920),
    [sym_binary] = STATE(8920),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6310] = {
    [sym_assignment] = STATE(8921),
    [sym_unary] = STATE(8921),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8921),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8921),
    [sym_conditional] = STATE(8921),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8921),
    [sym_binary] = STATE(8921),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6311] = {
    [sym_assignment] = STATE(8922),
    [sym_unary] = STATE(8922),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8922),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8922),
    [sym_conditional] = STATE(8922),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8922),
    [sym_binary] = STATE(8922),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6312] = {
    [sym_assignment] = STATE(8923),
    [sym_unary] = STATE(8923),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8923),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8923),
    [sym_conditional] = STATE(8923),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8923),
    [sym_binary] = STATE(8923),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6313] = {
    [sym_assignment] = STATE(8924),
    [sym_unary] = STATE(8924),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8924),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(8924),
    [sym_conditional] = STATE(8924),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(8924),
    [sym_binary] = STATE(8924),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6314] = {
    [sym_assignment] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_return] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_true] = STATE(3519),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5892),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(613),
    [sym_character] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [6315] = {
    [aux_sym_exceptions_repeat1] = STATE(8925),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(10162),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [6316] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [6317] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [6318] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [6319] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [6320] = {
    [sym_assignment] = STATE(8926),
    [sym_unary] = STATE(8926),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8926),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8926),
    [sym_conditional] = STATE(8926),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8926),
    [sym_binary] = STATE(8926),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6321] = {
    [sym_assignment] = STATE(8927),
    [sym_unary] = STATE(8927),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8927),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_splat_argument] = STATE(8928),
    [sym_operator_assignment] = STATE(8927),
    [sym_conditional] = STATE(8927),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_return] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_subshell] = STATE(3537),
    [sym__arg_or_splat_arg] = STATE(8928),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8927),
    [sym_binary] = STATE(8927),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [sym_global_variable] = ACTIONS(5924),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5916),
    [sym_character] = ACTIONS(5920),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6322] = {
    [sym_assignment] = STATE(8929),
    [sym_unary] = STATE(8929),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8929),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8929),
    [sym_conditional] = STATE(8929),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8929),
    [sym_binary] = STATE(8929),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6323] = {
    [sym_assignment] = STATE(8930),
    [sym_unary] = STATE(8930),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8930),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8930),
    [sym_conditional] = STATE(8930),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8930),
    [sym_binary] = STATE(8930),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6324] = {
    [sym_assignment] = STATE(8932),
    [sym_unary] = STATE(8932),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8932),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8932),
    [sym_conditional] = STATE(8932),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8932),
    [sym_binary] = STATE(8932),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6325] = {
    [sym_assignment] = STATE(8933),
    [sym_unary] = STATE(8933),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8933),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8933),
    [sym_conditional] = STATE(8933),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8933),
    [sym_binary] = STATE(8933),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6326] = {
    [sym_assignment] = STATE(8934),
    [sym_unary] = STATE(8934),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8934),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8934),
    [sym_conditional] = STATE(8934),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8934),
    [sym_binary] = STATE(8934),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6327] = {
    [sym_assignment] = STATE(8935),
    [sym_unary] = STATE(8935),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8935),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8935),
    [sym_conditional] = STATE(8935),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8935),
    [sym_binary] = STATE(8935),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6328] = {
    [sym_assignment] = STATE(8936),
    [sym_unary] = STATE(8936),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8936),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8936),
    [sym_conditional] = STATE(8936),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8936),
    [sym_binary] = STATE(8936),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6329] = {
    [sym_assignment] = STATE(8937),
    [sym_unary] = STATE(8937),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8937),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8937),
    [sym_conditional] = STATE(8937),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8937),
    [sym_binary] = STATE(8937),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6330] = {
    [sym_assignment] = STATE(8938),
    [sym_unary] = STATE(8938),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8938),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(8938),
    [sym_conditional] = STATE(8938),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8938),
    [sym_binary] = STATE(8938),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [6331] = {
    [aux_sym_chained_string_repeat1] = STATE(8939),
    [sym_string] = STATE(8939),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [6332] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6333] = {
    [aux_sym_exceptions_repeat1] = STATE(8941),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [6334] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(1415),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym_float] = ACTIONS(2463),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2467),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2467),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(2479),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2473),
    [anon_sym_yield] = ACTIONS(2481),
    [sym_class_variable] = ACTIONS(2475),
    [sym__block_ampersand] = ACTIONS(2483),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10198),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [6335] = {
    [sym_heredoc_body] = STATE(6335),
    [aux_sym_call_repeat1] = STATE(6335),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [6336] = {
    [sym_heredoc_body] = STATE(6335),
    [aux_sym_call_repeat1] = STATE(6335),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [6337] = {
    [aux_sym_argument_list_repeat1] = STATE(6337),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [6338] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6339] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6340] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6341] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13460),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6342] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6343] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6344] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6345] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [6346] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6347] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6348] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6349] = {
    [aux_sym_chained_string_repeat1] = STATE(6349),
    [sym_string] = STATE(6349),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [6350] = {
    [sym_assignment] = STATE(8943),
    [sym_unary] = STATE(8943),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1356),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8943),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(1356),
    [sym_operator_assignment] = STATE(8943),
    [sym_conditional] = STATE(8943),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(339),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(1356),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(344),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(1356),
    [sym_range] = STATE(8943),
    [sym_binary] = STATE(8943),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(1356),
    [sym_nil] = STATE(1356),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(631),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(639),
    [anon_sym_next] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(625),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(643),
  },
  [6351] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [sym__line_break] = ACTIONS(13464),
    [anon_sym_then] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_when] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym___END__] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_end] = ACTIONS(13464),
    [anon_sym_ensure] = ACTIONS(13464),
    [anon_sym_else] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_elsif] = ACTIONS(13464),
    [ts_builtin_sym_end] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
    [sym__binary_minus] = ACTIONS(13464),
  },
  [6352] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [sym__line_break] = ACTIONS(13468),
    [anon_sym_then] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_when] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym___END__] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_end] = ACTIONS(13468),
    [anon_sym_ensure] = ACTIONS(13468),
    [anon_sym_else] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_elsif] = ACTIONS(13468),
    [ts_builtin_sym_end] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
    [sym__binary_minus] = ACTIONS(13468),
  },
  [6353] = {
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [sym_self] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_nil] = ACTIONS(5452),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [anon_sym_next] = ACTIONS(5452),
    [sym_retry] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_return] = ACTIONS(5452),
  },
  [6354] = {
    [anon_sym_RPAREN] = ACTIONS(13470),
    [sym_comment] = ACTIONS(49),
  },
  [6355] = {
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [sym_self] = ACTIONS(10960),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_nil] = ACTIONS(10960),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [anon_sym_next] = ACTIONS(10960),
    [sym_retry] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_return] = ACTIONS(10960),
  },
  [6356] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(10240),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [anon_sym_and] = ACTIONS(10240),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_PIPE] = ACTIONS(10252),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [6357] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(10240),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [anon_sym_and] = ACTIONS(10240),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_PIPE] = ACTIONS(10252),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [6358] = {
    [sym_assignment] = STATE(8945),
    [sym_unary] = STATE(8945),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(8945),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(8945),
    [sym_conditional] = STATE(8945),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(8945),
    [sym_binary] = STATE(8945),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [6359] = {
    [sym_assignment] = STATE(8946),
    [sym_unary] = STATE(8946),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(8946),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(8946),
    [sym_conditional] = STATE(8946),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(8946),
    [sym_binary] = STATE(8946),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [6360] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6361] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6362] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6363] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(8947),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13472),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [6364] = {
    [sym_heredoc_body] = STATE(8948),
    [aux_sym_call_repeat1] = STATE(8948),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6365] = {
    [sym_heredoc_body] = STATE(8949),
    [aux_sym_call_repeat1] = STATE(8949),
    [aux_sym_argument_list_repeat1] = STATE(8950),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10220),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6366] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6367] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [6368] = {
    [sym_assignment] = STATE(8951),
    [sym_unary] = STATE(8951),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8951),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8951),
    [sym_conditional] = STATE(8951),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8951),
    [sym_binary] = STATE(8951),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6369] = {
    [sym_assignment] = STATE(8952),
    [sym_unary] = STATE(8952),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8952),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_splat_argument] = STATE(8953),
    [sym_operator_assignment] = STATE(8952),
    [sym_conditional] = STATE(8952),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_subshell] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(8953),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8952),
    [sym_binary] = STATE(8952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6370] = {
    [sym_assignment] = STATE(8954),
    [sym_unary] = STATE(8954),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8954),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8954),
    [sym_conditional] = STATE(8954),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8954),
    [sym_binary] = STATE(8954),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6371] = {
    [sym_assignment] = STATE(8955),
    [sym_unary] = STATE(8955),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8955),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8955),
    [sym_conditional] = STATE(8955),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8955),
    [sym_binary] = STATE(8955),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6372] = {
    [sym_assignment] = STATE(8956),
    [sym_unary] = STATE(8956),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8956),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8956),
    [sym_conditional] = STATE(8956),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8956),
    [sym_binary] = STATE(8956),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6373] = {
    [sym_assignment] = STATE(8957),
    [sym_unary] = STATE(8957),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8957),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8957),
    [sym_conditional] = STATE(8957),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8957),
    [sym_binary] = STATE(8957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6374] = {
    [sym_assignment] = STATE(8958),
    [sym_unary] = STATE(8958),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8958),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8958),
    [sym_conditional] = STATE(8958),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8958),
    [sym_binary] = STATE(8958),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6375] = {
    [sym_assignment] = STATE(8959),
    [sym_unary] = STATE(8959),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8959),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8959),
    [sym_conditional] = STATE(8959),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8959),
    [sym_binary] = STATE(8959),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6376] = {
    [sym_assignment] = STATE(8960),
    [sym_unary] = STATE(8960),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8960),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8960),
    [sym_conditional] = STATE(8960),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8960),
    [sym_binary] = STATE(8960),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6377] = {
    [sym_assignment] = STATE(8961),
    [sym_unary] = STATE(8961),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8961),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8961),
    [sym_conditional] = STATE(8961),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8961),
    [sym_binary] = STATE(8961),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6378] = {
    [sym_assignment] = STATE(8962),
    [sym_unary] = STATE(8962),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8962),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8962),
    [sym_conditional] = STATE(8962),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8962),
    [sym_binary] = STATE(8962),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6379] = {
    [sym_assignment] = STATE(8963),
    [sym_unary] = STATE(8963),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8963),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(8963),
    [sym_conditional] = STATE(8963),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8963),
    [sym_binary] = STATE(8963),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [6380] = {
    [aux_sym_chained_string_repeat1] = STATE(8964),
    [sym_string] = STATE(8964),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6381] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6382] = {
    [aux_sym_exceptions_repeat1] = STATE(8966),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [6383] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1455),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1455),
    [sym_conditional] = STATE(1455),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1455),
    [sym_binary] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [6384] = {
    [sym_heredoc_body] = STATE(6384),
    [aux_sym_call_repeat1] = STATE(6384),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12684),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
  },
  [6385] = {
    [sym_heredoc_body] = STATE(6384),
    [aux_sym_call_repeat1] = STATE(6384),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
  },
  [6386] = {
    [aux_sym_argument_list_repeat1] = STATE(6386),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13474),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [6387] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6388] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6389] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6390] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13477),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6391] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6392] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6393] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6394] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [6395] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6396] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6397] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6398] = {
    [aux_sym_chained_string_repeat1] = STATE(6398),
    [sym_string] = STATE(6398),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [6399] = {
    [aux_sym_undef_repeat1] = STATE(6399),
    [sym__line_break] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_else] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [anon_sym_ensure] = ACTIONS(7428),
  },
  [6400] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_rescue] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [anon_sym_ensure] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [6401] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6402] = {
    [sym_assignment] = STATE(8968),
    [sym_unary] = STATE(8968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8968),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8968),
    [sym_conditional] = STATE(8968),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8968),
    [sym_binary] = STATE(8968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6403] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [6404] = {
    [sym_assignment] = STATE(8969),
    [sym_unary] = STATE(8969),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8969),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8969),
    [sym_conditional] = STATE(8969),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8969),
    [sym_binary] = STATE(8969),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6405] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [6406] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [6407] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [6408] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_heredoc_body] = STATE(8970),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2595),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2603),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6101),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13479),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6409] = {
    [sym_heredoc_body] = STATE(8971),
    [aux_sym_call_repeat1] = STATE(8971),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6410] = {
    [sym_heredoc_body] = STATE(8972),
    [aux_sym_call_repeat1] = STATE(8972),
    [aux_sym_argument_list_repeat1] = STATE(8973),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10270),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6411] = {
    [sym_assignment] = STATE(8974),
    [sym_unary] = STATE(8974),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8974),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8974),
    [sym_conditional] = STATE(8974),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8974),
    [sym_binary] = STATE(8974),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6412] = {
    [sym_assignment] = STATE(8975),
    [sym_unary] = STATE(8975),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8975),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(8976),
    [sym_operator_assignment] = STATE(8975),
    [sym_conditional] = STATE(8975),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_subshell] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(8976),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8975),
    [sym_binary] = STATE(8975),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2595),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6413] = {
    [sym_assignment] = STATE(8977),
    [sym_unary] = STATE(8977),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8977),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8977),
    [sym_conditional] = STATE(8977),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8977),
    [sym_binary] = STATE(8977),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6414] = {
    [sym_assignment] = STATE(8978),
    [sym_unary] = STATE(8978),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8978),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8978),
    [sym_conditional] = STATE(8978),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8978),
    [sym_binary] = STATE(8978),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6415] = {
    [sym_assignment] = STATE(8979),
    [sym_unary] = STATE(8979),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(8979),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(8979),
    [sym_conditional] = STATE(8979),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(8979),
    [sym_binary] = STATE(8979),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6416] = {
    [sym_assignment] = STATE(8980),
    [sym_unary] = STATE(8980),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8980),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8980),
    [sym_conditional] = STATE(8980),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8980),
    [sym_binary] = STATE(8980),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6417] = {
    [sym_assignment] = STATE(8981),
    [sym_unary] = STATE(8981),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8981),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8981),
    [sym_conditional] = STATE(8981),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8981),
    [sym_binary] = STATE(8981),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6418] = {
    [sym_assignment] = STATE(8982),
    [sym_unary] = STATE(8982),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8982),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8982),
    [sym_conditional] = STATE(8982),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8982),
    [sym_binary] = STATE(8982),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6419] = {
    [sym_assignment] = STATE(8984),
    [sym_unary] = STATE(8984),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8984),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8984),
    [sym_conditional] = STATE(8984),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8984),
    [sym_binary] = STATE(8984),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6420] = {
    [sym_assignment] = STATE(8985),
    [sym_unary] = STATE(8985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8985),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8985),
    [sym_conditional] = STATE(8985),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8985),
    [sym_binary] = STATE(8985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6421] = {
    [sym_assignment] = STATE(8986),
    [sym_unary] = STATE(8986),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8986),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(8986),
    [sym_conditional] = STATE(8986),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8986),
    [sym_binary] = STATE(8986),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6422] = {
    [sym__line_break] = ACTIONS(2055),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [sym_self] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_nil] = ACTIONS(2053),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_then] = ACTIONS(2053),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_next] = ACTIONS(2053),
    [sym_retry] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2053),
  },
  [6423] = {
    [sym_heredoc_body] = STATE(8991),
    [sym__argument_list_with_parens] = STATE(8990),
    [aux_sym_call_repeat1] = STATE(8991),
    [sym_argument_list_with_parens] = STATE(8989),
    [sym_operator] = STATE(8989),
    [anon_sym_LT] = ACTIONS(13481),
    [anon_sym_SLASH] = ACTIONS(13483),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13483),
    [anon_sym_PLUS_AT] = ACTIONS(13483),
    [anon_sym_LPAREN2] = ACTIONS(13485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13483),
    [anon_sym_GT_GT] = ACTIONS(13483),
    [anon_sym_EQ_TILDE] = ACTIONS(13483),
    [anon_sym_LT_LT] = ACTIONS(13483),
    [anon_sym_TILDE] = ACTIONS(13483),
    [anon_sym_PLUS] = ACTIONS(13481),
    [anon_sym_AMP] = ACTIONS(13483),
    [anon_sym_GT] = ACTIONS(13481),
    [anon_sym_PERCENT] = ACTIONS(13483),
    [anon_sym_DASH_AT] = ACTIONS(13483),
    [anon_sym_EQ_EQ] = ACTIONS(13481),
    [anon_sym_STAR] = ACTIONS(13481),
    [anon_sym_BANG_TILDE] = ACTIONS(13483),
    [sym_constant] = ACTIONS(13487),
    [anon_sym_DASH] = ACTIONS(13481),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13483),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13481),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13483),
    [anon_sym_STAR_STAR] = ACTIONS(13483),
    [anon_sym_PIPE] = ACTIONS(13483),
    [anon_sym_DOT_DOT] = ACTIONS(13483),
    [anon_sym_LT_EQ_GT] = ACTIONS(13483),
    [anon_sym_LT_EQ] = ACTIONS(13481),
    [anon_sym_BANG] = ACTIONS(13481),
    [sym_identifier] = ACTIONS(13487),
    [anon_sym_CARET] = ACTIONS(13483),
  },
  [6424] = {
    [sym__argument] = STATE(141),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(141),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(141),
    [sym_hash_splat_argument] = STATE(141),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(141),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__argument_list_with_trailing_comma] = STATE(8993),
    [sym_float] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(13489),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [6425] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13491),
    [sym_identifier] = ACTIONS(13491),
  },
  [6426] = {
    [sym_assignment] = STATE(8995),
    [sym_unary] = STATE(8995),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8995),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(8995),
    [sym_conditional] = STATE(8995),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(8995),
    [sym_binary] = STATE(8995),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [6427] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [6428] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(1673),
    [sym_block_parameters] = STATE(8607),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym__hash_items] = STATE(1187),
    [sym_if] = STATE(1669),
    [sym__primary] = STATE(1669),
    [sym_hash_splat_argument] = STATE(192),
    [sym_method] = STATE(1669),
    [sym_conditional] = STATE(1673),
    [sym_left_assignment_list] = STATE(1670),
    [sym_return] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(1669),
    [sym_unless] = STATE(1669),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(1673),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1672),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_call] = STATE(1671),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(1673),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_pair] = STATE(190),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1673),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(1673),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_rational] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1674),
    [sym_until_modifier] = STATE(555),
    [sym_heredoc_body] = STATE(1188),
    [sym_lambda] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym__statements] = STATE(8608),
    [sym_binary] = STATE(1673),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_nil] = STATE(1672),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_hash] = STATE(1669),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(2941),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13493),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2031),
    [sym__identifier_hash_key] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2953),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2961),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(373),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [6429] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(13495),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6430] = {
    [sym_assignment] = STATE(8999),
    [sym_unary] = STATE(8999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8999),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(8999),
    [sym_conditional] = STATE(8999),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(8999),
    [sym_binary] = STATE(8999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [6431] = {
    [anon_sym_COLON] = ACTIONS(13497),
    [sym_comment] = ACTIONS(49),
  },
  [6432] = {
    [sym__argument] = STATE(9006),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(9006),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(9006),
    [sym_hash_splat_argument] = STATE(9006),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(9009),
    [sym_block_argument] = STATE(9006),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [6433] = {
    [sym_assignment] = STATE(9018),
    [sym_unary] = STATE(9018),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(9018),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(9018),
    [sym_conditional] = STATE(9018),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(9018),
    [sym_binary] = STATE(9018),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [6434] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9022),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13527),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6435] = {
    [sym_assignment] = STATE(9023),
    [sym_unary] = STATE(9023),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(9023),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(9023),
    [sym_conditional] = STATE(9023),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(9023),
    [sym_binary] = STATE(9023),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [6436] = {
    [sym__argument] = STATE(9006),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(9006),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(9006),
    [sym_hash_splat_argument] = STATE(9006),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(9009),
    [sym_block_argument] = STATE(9006),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [6437] = {
    [sym__argument] = STATE(9006),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(9006),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(9006),
    [sym_hash_splat_argument] = STATE(9006),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(9009),
    [sym_block_argument] = STATE(9006),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [6438] = {
    [sym_assignment] = STATE(9024),
    [sym_unary] = STATE(9024),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(9024),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(9024),
    [sym_conditional] = STATE(9024),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(9024),
    [sym_binary] = STATE(9024),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [6439] = {
    [sym__argument] = STATE(9006),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(9006),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(9006),
    [sym_hash_splat_argument] = STATE(9006),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(9009),
    [sym_block_argument] = STATE(9006),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [6440] = {
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [sym_comment] = ACTIONS(49),
  },
  [6441] = {
    [sym_do_block] = STATE(9025),
    [sym_block] = STATE(9025),
    [sym__line_break] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_then] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(13150),
    [anon_sym_AMP_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(9590),
    [anon_sym_COLON_COLON2] = ACTIONS(3087),
    [sym__heredoc_body_start] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [sym_comment] = ACTIONS(49),
  },
  [6442] = {
    [anon_sym_EQ] = ACTIONS(13529),
    [sym_comment] = ACTIONS(3),
  },
  [6443] = {
    [sym_heredoc_body] = STATE(9029),
    [aux_sym_call_repeat1] = STATE(9029),
    [aux_sym_argument_list_repeat1] = STATE(9030),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(13531),
    [anon_sym_COMMA] = ACTIONS(13533),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [6444] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13535),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(13535),
    [anon_sym_SLASH_EQ] = ACTIONS(13535),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13535),
    [anon_sym_PIPE_EQ] = ACTIONS(13535),
    [anon_sym_LT_LT_EQ] = ACTIONS(13535),
    [anon_sym_PLUS_EQ] = ACTIONS(13535),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13535),
    [anon_sym_STAR_EQ] = ACTIONS(13535),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13535),
    [anon_sym_CARET_EQ] = ACTIONS(13535),
    [anon_sym_DASH_EQ] = ACTIONS(13535),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13535),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13537),
  },
  [6445] = {
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_SLASH] = ACTIONS(13541),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(13551),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_EQ_GT] = ACTIONS(13497),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_PIPE] = ACTIONS(13563),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [6446] = {
    [aux_sym_chained_string_repeat1] = STATE(9042),
    [sym_string] = STATE(9042),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13567),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6447] = {
    [sym_heredoc_body] = STATE(9029),
    [aux_sym_call_repeat1] = STATE(9029),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2235),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(13531),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
  },
  [6448] = {
    [anon_sym_end] = ACTIONS(13569),
    [anon_sym_ensure] = ACTIONS(13569),
    [anon_sym_else] = ACTIONS(13569),
    [sym_comment] = ACTIONS(49),
  },
  [6449] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6450] = {
    [sym_assignment] = STATE(9043),
    [sym_unary] = STATE(9043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9043),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(9043),
    [sym_conditional] = STATE(9043),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(9043),
    [sym_binary] = STATE(9043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [6451] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6452] = {
    [aux_sym_exceptions_repeat1] = STATE(9045),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [6453] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6454] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6455] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6456] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6457] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13571),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6458] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6459] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [6460] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6461] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6462] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6463] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_then] = ACTIONS(1327),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6464] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9048),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13573),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6465] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_then] = ACTIONS(6719),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6466] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_then] = ACTIONS(6727),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6467] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6466),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9049),
    [sym_operator] = STATE(9049),
    [anon_sym_LT] = ACTIONS(10354),
    [anon_sym_SLASH] = ACTIONS(10356),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10356),
    [anon_sym_PLUS_AT] = ACTIONS(10356),
    [anon_sym_LPAREN2] = ACTIONS(10358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10356),
    [anon_sym_GT_GT] = ACTIONS(10356),
    [anon_sym_EQ_TILDE] = ACTIONS(10356),
    [anon_sym_LT_LT] = ACTIONS(10356),
    [anon_sym_TILDE] = ACTIONS(10356),
    [anon_sym_PLUS] = ACTIONS(10354),
    [anon_sym_AMP] = ACTIONS(10356),
    [anon_sym_GT] = ACTIONS(10354),
    [anon_sym_PERCENT] = ACTIONS(10356),
    [anon_sym_DASH_AT] = ACTIONS(10356),
    [anon_sym_EQ_EQ] = ACTIONS(10354),
    [anon_sym_STAR] = ACTIONS(10354),
    [anon_sym_BANG_TILDE] = ACTIONS(10356),
    [sym_constant] = ACTIONS(13575),
    [anon_sym_DASH] = ACTIONS(10354),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10356),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10354),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10356),
    [anon_sym_STAR_STAR] = ACTIONS(10356),
    [anon_sym_PIPE] = ACTIONS(10356),
    [anon_sym_DOT_DOT] = ACTIONS(10356),
    [anon_sym_LT_EQ_GT] = ACTIONS(10356),
    [anon_sym_LT_EQ] = ACTIONS(10354),
    [anon_sym_BANG] = ACTIONS(10354),
    [sym_identifier] = ACTIONS(13575),
    [anon_sym_CARET] = ACTIONS(10356),
  },
  [6468] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6469] = {
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_then] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
  },
  [6470] = {
    [aux_sym_exceptions_repeat1] = STATE(6470),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_then] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13579),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
  },
  [6471] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [6472] = {
    [aux_sym_chained_string_repeat1] = STATE(6493),
    [sym_string] = STATE(6493),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6473] = {
    [sym_assignment] = STATE(9050),
    [sym_unary] = STATE(9050),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9050),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9050),
    [sym_conditional] = STATE(9050),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9050),
    [sym_binary] = STATE(9050),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6474] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [6475] = {
    [sym_assignment] = STATE(9051),
    [sym_unary] = STATE(9051),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9051),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9051),
    [sym_conditional] = STATE(9051),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9051),
    [sym_binary] = STATE(9051),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6476] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [6477] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [6478] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [6479] = {
    [sym_assignment] = STATE(9052),
    [sym_unary] = STATE(9052),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9052),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(9053),
    [sym_operator_assignment] = STATE(9052),
    [sym_conditional] = STATE(9052),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_subshell] = STATE(3687),
    [sym__arg_or_splat_arg] = STATE(9053),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9052),
    [sym_binary] = STATE(9052),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6179),
    [sym_character] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6480] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_heredoc_body] = STATE(9054),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(6175),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(6195),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6197),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13582),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6481] = {
    [sym_heredoc_body] = STATE(9055),
    [aux_sym_call_repeat1] = STATE(9055),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6482] = {
    [sym_heredoc_body] = STATE(9056),
    [aux_sym_call_repeat1] = STATE(9056),
    [aux_sym_argument_list_repeat1] = STATE(9057),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10374),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6483] = {
    [sym_assignment] = STATE(9058),
    [sym_unary] = STATE(9058),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9058),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9058),
    [sym_conditional] = STATE(9058),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9058),
    [sym_binary] = STATE(9058),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6484] = {
    [sym_assignment] = STATE(9059),
    [sym_unary] = STATE(9059),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9059),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9059),
    [sym_conditional] = STATE(9059),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9059),
    [sym_binary] = STATE(9059),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6485] = {
    [sym_assignment] = STATE(9060),
    [sym_unary] = STATE(9060),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9060),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9060),
    [sym_conditional] = STATE(9060),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9060),
    [sym_binary] = STATE(9060),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6486] = {
    [sym_assignment] = STATE(9061),
    [sym_unary] = STATE(9061),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9061),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9061),
    [sym_conditional] = STATE(9061),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9061),
    [sym_binary] = STATE(9061),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6487] = {
    [sym_assignment] = STATE(9062),
    [sym_unary] = STATE(9062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9062),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9062),
    [sym_conditional] = STATE(9062),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9062),
    [sym_binary] = STATE(9062),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6488] = {
    [sym_assignment] = STATE(9063),
    [sym_unary] = STATE(9063),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9063),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9063),
    [sym_conditional] = STATE(9063),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9063),
    [sym_binary] = STATE(9063),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6489] = {
    [sym_assignment] = STATE(9064),
    [sym_unary] = STATE(9064),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9064),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9064),
    [sym_conditional] = STATE(9064),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9064),
    [sym_binary] = STATE(9064),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6490] = {
    [sym_assignment] = STATE(9066),
    [sym_unary] = STATE(9066),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9066),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9066),
    [sym_conditional] = STATE(9066),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9066),
    [sym_binary] = STATE(9066),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6491] = {
    [sym_assignment] = STATE(9067),
    [sym_unary] = STATE(9067),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9067),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9067),
    [sym_conditional] = STATE(9067),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9067),
    [sym_binary] = STATE(9067),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6492] = {
    [sym_assignment] = STATE(9068),
    [sym_unary] = STATE(9068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9068),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(9068),
    [sym_conditional] = STATE(9068),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9068),
    [sym_binary] = STATE(9068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [6493] = {
    [aux_sym_chained_string_repeat1] = STATE(9069),
    [sym_string] = STATE(9069),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [6494] = {
    [aux_sym_chained_string_repeat1] = STATE(6494),
    [sym_string] = STATE(6494),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [6495] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(9070),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(13584),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(6213),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(13584),
    [anon_sym_ensure] = ACTIONS(13584),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6496] = {
    [sym_rescue] = STATE(9070),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(13569),
    [anon_sym_ensure] = ACTIONS(13569),
    [anon_sym_else] = ACTIONS(13569),
    [sym_comment] = ACTIONS(49),
  },
  [6497] = {
    [aux_sym_undef_repeat1] = STATE(9071),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_ensure] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [6498] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [anon_sym_ensure] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [6499] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6500] = {
    [aux_sym_chained_string_repeat1] = STATE(6552),
    [sym_string] = STATE(6552),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [6501] = {
    [sym_assignment] = STATE(9072),
    [sym_unary] = STATE(9072),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9072),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(9072),
    [sym_conditional] = STATE(9072),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(9072),
    [sym_binary] = STATE(9072),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6502] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [6503] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_ensure] = ACTIONS(2053),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [6504] = {
    [sym_assignment] = STATE(9073),
    [sym_unary] = STATE(9073),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9073),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(9073),
    [sym_conditional] = STATE(9073),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(9073),
    [sym_binary] = STATE(9073),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6505] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6506] = {
    [anon_sym_COLON] = ACTIONS(13588),
    [sym_comment] = ACTIONS(49),
  },
  [6507] = {
    [sym_assignment] = STATE(9076),
    [sym_unary] = STATE(9076),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9076),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9076),
    [sym_conditional] = STATE(9076),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9076),
    [sym_binary] = STATE(9076),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6508] = {
    [sym_assignment] = STATE(9077),
    [sym_unary] = STATE(9077),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9077),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9077),
    [sym_conditional] = STATE(9077),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9077),
    [sym_binary] = STATE(9077),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6509] = {
    [sym_assignment] = STATE(9078),
    [sym_unary] = STATE(9078),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9078),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9078),
    [sym_conditional] = STATE(9078),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9078),
    [sym_binary] = STATE(9078),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6510] = {
    [sym_heredoc_body] = STATE(9080),
    [aux_sym_call_repeat1] = STATE(9080),
    [aux_sym_argument_list_repeat1] = STATE(9081),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6511] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [6512] = {
    [aux_sym_chained_string_repeat1] = STATE(6552),
    [sym_string] = STATE(6552),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13592),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [6513] = {
    [sym_heredoc_body] = STATE(9080),
    [aux_sym_call_repeat1] = STATE(9080),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6514] = {
    [sym__argument] = STATE(9082),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(9082),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(9082),
    [sym_hash_splat_argument] = STATE(9082),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(9083),
    [sym_block_argument] = STATE(9082),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [6515] = {
    [sym__argument] = STATE(9082),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(9082),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(9082),
    [sym_hash_splat_argument] = STATE(9082),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(9083),
    [sym_block_argument] = STATE(9082),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [6516] = {
    [sym_assignment] = STATE(9084),
    [sym_unary] = STATE(9084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9084),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(9084),
    [sym_conditional] = STATE(9084),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(9084),
    [sym_binary] = STATE(9084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6517] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6518] = {
    [sym__argument] = STATE(9082),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(9082),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(9082),
    [sym_hash_splat_argument] = STATE(9082),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(9083),
    [sym_block_argument] = STATE(9082),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [6519] = {
    [sym_assignment] = STATE(9085),
    [sym_unary] = STATE(9085),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9085),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(9085),
    [sym_conditional] = STATE(9085),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(9085),
    [sym_binary] = STATE(9085),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6520] = {
    [sym__argument] = STATE(9082),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(9082),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(9082),
    [sym_hash_splat_argument] = STATE(9082),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym__argument_list_with_parens] = STATE(9083),
    [sym_block_argument] = STATE(9082),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6227),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(6229),
    [sym_self] = ACTIONS(6231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(6251),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(6261),
  },
  [6521] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13594),
    [anon_sym_GT_GT_EQ] = ACTIONS(13594),
    [anon_sym_SLASH_EQ] = ACTIONS(13594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13594),
    [anon_sym_LT_LT_EQ] = ACTIONS(13594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13594),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(13594),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13596),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(13594),
    [anon_sym_PLUS_EQ] = ACTIONS(13594),
    [anon_sym_STAR_EQ] = ACTIONS(13594),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13594),
    [anon_sym_DASH_EQ] = ACTIONS(13594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13594),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6522] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [6523] = {
    [anon_sym_EQ] = ACTIONS(13624),
    [sym_comment] = ACTIONS(3),
  },
  [6524] = {
    [aux_sym_chained_string_repeat1] = STATE(9097),
    [sym_string] = STATE(9097),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [6525] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [6526] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [6527] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_heredoc_body] = STATE(9098),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym_float] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6231),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6239),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6251),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13626),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6528] = {
    [sym_heredoc_body] = STATE(9099),
    [aux_sym_call_repeat1] = STATE(9099),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6529] = {
    [sym_heredoc_body] = STATE(9100),
    [aux_sym_call_repeat1] = STATE(9100),
    [aux_sym_argument_list_repeat1] = STATE(9101),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10452),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6530] = {
    [sym_assignment] = STATE(9102),
    [sym_unary] = STATE(9102),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9102),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9102),
    [sym_conditional] = STATE(9102),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9102),
    [sym_binary] = STATE(9102),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6531] = {
    [sym_assignment] = STATE(9103),
    [sym_unary] = STATE(9103),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9103),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(9104),
    [sym_operator_assignment] = STATE(9103),
    [sym_conditional] = STATE(9103),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_subshell] = STATE(3721),
    [sym__arg_or_splat_arg] = STATE(9104),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9103),
    [sym_binary] = STATE(9103),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6231),
    [sym_character] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6532] = {
    [sym_assignment] = STATE(9105),
    [sym_unary] = STATE(9105),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9105),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9105),
    [sym_conditional] = STATE(9105),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9105),
    [sym_binary] = STATE(9105),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6533] = {
    [sym_assignment] = STATE(9106),
    [sym_unary] = STATE(9106),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9106),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9106),
    [sym_conditional] = STATE(9106),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9106),
    [sym_binary] = STATE(9106),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6534] = {
    [sym_assignment] = STATE(9107),
    [sym_unary] = STATE(9107),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9107),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9107),
    [sym_conditional] = STATE(9107),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9107),
    [sym_binary] = STATE(9107),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6535] = {
    [sym_assignment] = STATE(9108),
    [sym_unary] = STATE(9108),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9108),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9108),
    [sym_conditional] = STATE(9108),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9108),
    [sym_binary] = STATE(9108),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6536] = {
    [sym_assignment] = STATE(9109),
    [sym_unary] = STATE(9109),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9109),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9109),
    [sym_conditional] = STATE(9109),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9109),
    [sym_binary] = STATE(9109),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6537] = {
    [sym_assignment] = STATE(9110),
    [sym_unary] = STATE(9110),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9110),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9110),
    [sym_conditional] = STATE(9110),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9110),
    [sym_binary] = STATE(9110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6538] = {
    [sym_assignment] = STATE(9112),
    [sym_unary] = STATE(9112),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9112),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9112),
    [sym_conditional] = STATE(9112),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9112),
    [sym_binary] = STATE(9112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6539] = {
    [sym_assignment] = STATE(9113),
    [sym_unary] = STATE(9113),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9113),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9113),
    [sym_conditional] = STATE(9113),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9113),
    [sym_binary] = STATE(9113),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6540] = {
    [sym_assignment] = STATE(9114),
    [sym_unary] = STATE(9114),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9114),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(9114),
    [sym_conditional] = STATE(9114),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9114),
    [sym_binary] = STATE(9114),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [6541] = {
    [sym_heredoc_body] = STATE(9119),
    [sym__argument_list_with_parens] = STATE(9118),
    [aux_sym_call_repeat1] = STATE(9119),
    [sym_argument_list_with_parens] = STATE(9117),
    [sym_operator] = STATE(9117),
    [anon_sym_LT] = ACTIONS(13628),
    [anon_sym_SLASH] = ACTIONS(13630),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13630),
    [anon_sym_PLUS_AT] = ACTIONS(13630),
    [anon_sym_LPAREN2] = ACTIONS(13632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13630),
    [anon_sym_GT_GT] = ACTIONS(13630),
    [anon_sym_EQ_TILDE] = ACTIONS(13630),
    [anon_sym_LT_LT] = ACTIONS(13630),
    [anon_sym_TILDE] = ACTIONS(13630),
    [anon_sym_PLUS] = ACTIONS(13628),
    [anon_sym_AMP] = ACTIONS(13630),
    [anon_sym_GT] = ACTIONS(13628),
    [anon_sym_PERCENT] = ACTIONS(13630),
    [anon_sym_DASH_AT] = ACTIONS(13630),
    [anon_sym_EQ_EQ] = ACTIONS(13628),
    [anon_sym_STAR] = ACTIONS(13628),
    [anon_sym_BANG_TILDE] = ACTIONS(13630),
    [sym_constant] = ACTIONS(13634),
    [anon_sym_DASH] = ACTIONS(13628),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13630),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13630),
    [anon_sym_STAR_STAR] = ACTIONS(13630),
    [anon_sym_PIPE] = ACTIONS(13630),
    [anon_sym_DOT_DOT] = ACTIONS(13630),
    [anon_sym_LT_EQ_GT] = ACTIONS(13630),
    [anon_sym_LT_EQ] = ACTIONS(13628),
    [anon_sym_BANG] = ACTIONS(13628),
    [sym_identifier] = ACTIONS(13634),
    [anon_sym_CARET] = ACTIONS(13630),
  },
  [6542] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13636),
    [sym_identifier] = ACTIONS(13636),
  },
  [6543] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(13638),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_ensure] = ACTIONS(1349),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6544] = {
    [anon_sym_COLON] = ACTIONS(13640),
    [sym_comment] = ACTIONS(49),
  },
  [6545] = {
    [sym_assignment] = STATE(9123),
    [sym_unary] = STATE(9123),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9123),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9123),
    [sym_conditional] = STATE(9123),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9123),
    [sym_binary] = STATE(9123),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6546] = {
    [sym_assignment] = STATE(9124),
    [sym_unary] = STATE(9124),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9124),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9124),
    [sym_conditional] = STATE(9124),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9124),
    [sym_binary] = STATE(9124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6547] = {
    [sym_assignment] = STATE(9125),
    [sym_unary] = STATE(9125),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9125),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9125),
    [sym_conditional] = STATE(9125),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9125),
    [sym_binary] = STATE(9125),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6548] = {
    [sym_heredoc_body] = STATE(9127),
    [aux_sym_call_repeat1] = STATE(9127),
    [aux_sym_argument_list_repeat1] = STATE(9128),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13642),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6549] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_ensure] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [6550] = {
    [aux_sym_chained_string_repeat1] = STATE(6606),
    [sym_string] = STATE(6606),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13644),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6551] = {
    [sym_heredoc_body] = STATE(9127),
    [aux_sym_call_repeat1] = STATE(9127),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6552] = {
    [aux_sym_chained_string_repeat1] = STATE(9129),
    [sym_string] = STATE(9129),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [6553] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6698),
    [anon_sym_ensure] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [6554] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6700),
    [anon_sym_ensure] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [6555] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6702),
    [anon_sym_ensure] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [6556] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6706),
    [anon_sym_ensure] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [6557] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6708),
    [anon_sym_ensure] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_PIPE] = ACTIONS(6349),
    [sym__binary_minus] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(6351),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
  },
  [6558] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_ensure] = ACTIONS(1327),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6559] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9131),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13646),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6560] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_ensure] = ACTIONS(6719),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6561] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_ensure] = ACTIONS(6727),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6562] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6561),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9132),
    [sym_operator] = STATE(9132),
    [anon_sym_LT] = ACTIONS(10502),
    [anon_sym_SLASH] = ACTIONS(10504),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10504),
    [anon_sym_PLUS_AT] = ACTIONS(10504),
    [anon_sym_LPAREN2] = ACTIONS(10506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10504),
    [anon_sym_GT_GT] = ACTIONS(10504),
    [anon_sym_EQ_TILDE] = ACTIONS(10504),
    [anon_sym_LT_LT] = ACTIONS(10504),
    [anon_sym_TILDE] = ACTIONS(10504),
    [anon_sym_PLUS] = ACTIONS(10502),
    [anon_sym_AMP] = ACTIONS(10504),
    [anon_sym_GT] = ACTIONS(10502),
    [anon_sym_PERCENT] = ACTIONS(10504),
    [anon_sym_DASH_AT] = ACTIONS(10504),
    [anon_sym_EQ_EQ] = ACTIONS(10502),
    [anon_sym_STAR] = ACTIONS(10502),
    [anon_sym_BANG_TILDE] = ACTIONS(10504),
    [sym_constant] = ACTIONS(13648),
    [anon_sym_DASH] = ACTIONS(10502),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10504),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10502),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10504),
    [anon_sym_STAR_STAR] = ACTIONS(10504),
    [anon_sym_PIPE] = ACTIONS(10504),
    [anon_sym_DOT_DOT] = ACTIONS(10504),
    [anon_sym_LT_EQ_GT] = ACTIONS(10504),
    [anon_sym_LT_EQ] = ACTIONS(10502),
    [anon_sym_BANG] = ACTIONS(10502),
    [sym_identifier] = ACTIONS(13648),
    [anon_sym_CARET] = ACTIONS(10504),
  },
  [6563] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6564] = {
    [sym_assignment] = STATE(9133),
    [sym_unary] = STATE(9133),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9133),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(9133),
    [sym_conditional] = STATE(9133),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(9133),
    [sym_binary] = STATE(9133),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6565] = {
    [sym_assignment] = STATE(9134),
    [sym_unary] = STATE(9134),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9134),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(9134),
    [sym_conditional] = STATE(9134),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(9134),
    [sym_binary] = STATE(9134),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6566] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6567] = {
    [sym_assignment] = STATE(9135),
    [sym_unary] = STATE(9135),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(9135),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(9135),
    [sym_conditional] = STATE(9135),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(9135),
    [sym_binary] = STATE(9135),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [6568] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13650),
    [anon_sym_GT_GT_EQ] = ACTIONS(13650),
    [anon_sym_SLASH_EQ] = ACTIONS(13650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13650),
    [anon_sym_LT_LT_EQ] = ACTIONS(13650),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13650),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(13650),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(13650),
    [anon_sym_PLUS_EQ] = ACTIONS(13650),
    [anon_sym_STAR_EQ] = ACTIONS(13650),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13650),
    [anon_sym_DASH_EQ] = ACTIONS(13650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13650),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6569] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [6570] = {
    [anon_sym_EQ] = ACTIONS(13680),
    [sym_comment] = ACTIONS(3),
  },
  [6571] = {
    [aux_sym_exceptions_repeat1] = STATE(9148),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(13682),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [6572] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [6573] = {
    [aux_sym_chained_string_repeat1] = STATE(6606),
    [sym_string] = STATE(6606),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6574] = {
    [sym_assignment] = STATE(9149),
    [sym_unary] = STATE(9149),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(9149),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(9149),
    [sym_conditional] = STATE(9149),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(9149),
    [sym_binary] = STATE(9149),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [6575] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [6576] = {
    [sym_assignment] = STATE(9150),
    [sym_unary] = STATE(9150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(9150),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(9150),
    [sym_conditional] = STATE(9150),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(9150),
    [sym_binary] = STATE(9150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [6577] = {
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_ensure] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(751),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [6578] = {
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_ensure] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [6579] = {
    [sym_assignment] = STATE(9151),
    [sym_unary] = STATE(9151),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(9151),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(9151),
    [sym_conditional] = STATE(9151),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(9151),
    [sym_binary] = STATE(9151),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [6580] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [6581] = {
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [6582] = {
    [sym_assignment] = STATE(9152),
    [sym_unary] = STATE(9152),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(9152),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(9152),
    [sym_conditional] = STATE(9152),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(9152),
    [sym_binary] = STATE(9152),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [6583] = {
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_ensure] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(495),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [6584] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13684),
    [anon_sym_GT_GT_EQ] = ACTIONS(13684),
    [anon_sym_SLASH_EQ] = ACTIONS(13684),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13684),
    [anon_sym_LT_LT_EQ] = ACTIONS(13684),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13684),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(13684),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13686),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(13684),
    [anon_sym_PLUS_EQ] = ACTIONS(13684),
    [anon_sym_STAR_EQ] = ACTIONS(13684),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13684),
    [anon_sym_DASH_EQ] = ACTIONS(13684),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13684),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6585] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [6586] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(6275),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(6277),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(6279),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_ensure] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [6587] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym__primary] = STATE(3749),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(3752),
    [sym_method] = STATE(3749),
    [sym_conditional] = STATE(3754),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_subshell] = STATE(3749),
    [sym_unless] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_block_argument] = STATE(3752),
    [sym_range] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3753),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_call] = STATE(3751),
    [sym__argument] = STATE(3752),
    [sym_assignment] = STATE(3754),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_pair] = STATE(3752),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(3752),
    [sym_operator_assignment] = STATE(3754),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_rational] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_lambda] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym__argument_list_with_parens] = STATE(3756),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(3754),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_nil] = STATE(3753),
    [sym_symbol_array] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_scope_resolution] = STATE(3751),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6287),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(6289),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6291),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6243),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6299),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(6307),
    [anon_sym_not] = ACTIONS(6309),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_ensure] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_integer] = ACTIONS(865),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(6319),
  },
  [6588] = {
    [anon_sym_EQ] = ACTIONS(13716),
    [sym_comment] = ACTIONS(3),
  },
  [6589] = {
    [aux_sym_chained_string_repeat1] = STATE(9164),
    [sym_string] = STATE(9164),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_ensure] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6590] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [6591] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [6592] = {
    [sym_assignment] = STATE(9165),
    [sym_unary] = STATE(9165),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9165),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(9166),
    [sym_operator_assignment] = STATE(9165),
    [sym_conditional] = STATE(9165),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_subshell] = STATE(3749),
    [sym__arg_or_splat_arg] = STATE(9166),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9165),
    [sym_binary] = STATE(9165),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6291),
    [sym_character] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6593] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_heredoc_body] = STATE(9167),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym_float] = ACTIONS(6287),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6291),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6291),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6299),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_class_variable] = ACTIONS(6299),
    [sym__block_ampersand] = ACTIONS(6307),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6309),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13718),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6594] = {
    [sym_heredoc_body] = STATE(9168),
    [aux_sym_call_repeat1] = STATE(9168),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6595] = {
    [sym_heredoc_body] = STATE(9169),
    [aux_sym_call_repeat1] = STATE(9169),
    [aux_sym_argument_list_repeat1] = STATE(9170),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10560),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6596] = {
    [sym_assignment] = STATE(9171),
    [sym_unary] = STATE(9171),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9171),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9171),
    [sym_conditional] = STATE(9171),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9171),
    [sym_binary] = STATE(9171),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6597] = {
    [sym_assignment] = STATE(9172),
    [sym_unary] = STATE(9172),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9172),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9172),
    [sym_conditional] = STATE(9172),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9172),
    [sym_binary] = STATE(9172),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6598] = {
    [sym_assignment] = STATE(9173),
    [sym_unary] = STATE(9173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9173),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9173),
    [sym_conditional] = STATE(9173),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9173),
    [sym_binary] = STATE(9173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6599] = {
    [sym_assignment] = STATE(9174),
    [sym_unary] = STATE(9174),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9174),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9174),
    [sym_conditional] = STATE(9174),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9174),
    [sym_binary] = STATE(9174),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6600] = {
    [sym_assignment] = STATE(9175),
    [sym_unary] = STATE(9175),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9175),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9175),
    [sym_conditional] = STATE(9175),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9175),
    [sym_binary] = STATE(9175),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6601] = {
    [sym_assignment] = STATE(9176),
    [sym_unary] = STATE(9176),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9176),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9176),
    [sym_conditional] = STATE(9176),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9176),
    [sym_binary] = STATE(9176),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6602] = {
    [sym_assignment] = STATE(9177),
    [sym_unary] = STATE(9177),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9177),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9177),
    [sym_conditional] = STATE(9177),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9177),
    [sym_binary] = STATE(9177),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6603] = {
    [sym_assignment] = STATE(9179),
    [sym_unary] = STATE(9179),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9179),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9179),
    [sym_conditional] = STATE(9179),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9179),
    [sym_binary] = STATE(9179),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6604] = {
    [sym_assignment] = STATE(9180),
    [sym_unary] = STATE(9180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9180),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9180),
    [sym_conditional] = STATE(9180),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9180),
    [sym_binary] = STATE(9180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6605] = {
    [sym_assignment] = STATE(9181),
    [sym_unary] = STATE(9181),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9181),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(9181),
    [sym_conditional] = STATE(9181),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9181),
    [sym_binary] = STATE(9181),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [6606] = {
    [aux_sym_chained_string_repeat1] = STATE(9182),
    [sym_string] = STATE(9182),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [6607] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6608] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6609] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6610] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6611] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6612] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13720),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6613] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6614] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6615] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6616] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6617] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [6618] = {
    [aux_sym_chained_string_repeat1] = STATE(6618),
    [sym_string] = STATE(6618),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [6619] = {
    [sym_heredoc_body] = STATE(3731),
    [sym__terminator] = STATE(3731),
    [sym__line_break] = ACTIONS(6263),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(2649),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(6263),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [6620] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [6621] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [6622] = {
    [sym_assignment] = STATE(9184),
    [sym_unary] = STATE(9184),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(9184),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(9184),
    [sym_conditional] = STATE(9184),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(9184),
    [sym_binary] = STATE(9184),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [6623] = {
    [sym_assignment] = STATE(9185),
    [sym_unary] = STATE(9185),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(9185),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(9185),
    [sym_conditional] = STATE(9185),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(9185),
    [sym_binary] = STATE(9185),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [6624] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6625] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6626] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6627] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_heredoc_body] = STATE(9186),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym_float] = ACTIONS(2671),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2675),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2683),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13722),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [6628] = {
    [sym_heredoc_body] = STATE(9187),
    [aux_sym_call_repeat1] = STATE(9187),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6629] = {
    [sym_heredoc_body] = STATE(9188),
    [aux_sym_call_repeat1] = STATE(9188),
    [aux_sym_argument_list_repeat1] = STATE(9189),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10603),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6630] = {
    [sym_heredoc_body] = STATE(9190),
    [aux_sym_call_repeat1] = STATE(9190),
    [aux_sym_argument_list_repeat1] = STATE(9191),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(6391),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6631] = {
    [sym_heredoc_body] = STATE(9190),
    [aux_sym_call_repeat1] = STATE(9190),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6632] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6633] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [6634] = {
    [sym_assignment] = STATE(9192),
    [sym_unary] = STATE(9192),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9192),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9192),
    [sym_conditional] = STATE(9192),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9192),
    [sym_binary] = STATE(9192),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6635] = {
    [sym_assignment] = STATE(9193),
    [sym_unary] = STATE(9193),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9193),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_splat_argument] = STATE(9194),
    [sym_operator_assignment] = STATE(9193),
    [sym_conditional] = STATE(9193),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_return] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_subshell] = STATE(376),
    [sym__arg_or_splat_arg] = STATE(9194),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9193),
    [sym_binary] = STATE(9193),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(681),
    [sym_character] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6636] = {
    [sym_assignment] = STATE(9195),
    [sym_unary] = STATE(9195),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9195),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9195),
    [sym_conditional] = STATE(9195),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9195),
    [sym_binary] = STATE(9195),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6637] = {
    [sym_assignment] = STATE(9196),
    [sym_unary] = STATE(9196),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9196),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9196),
    [sym_conditional] = STATE(9196),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9196),
    [sym_binary] = STATE(9196),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6638] = {
    [sym_assignment] = STATE(9198),
    [sym_unary] = STATE(9198),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9198),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9198),
    [sym_conditional] = STATE(9198),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9198),
    [sym_binary] = STATE(9198),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6639] = {
    [sym_assignment] = STATE(9199),
    [sym_unary] = STATE(9199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9199),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9199),
    [sym_conditional] = STATE(9199),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9199),
    [sym_binary] = STATE(9199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6640] = {
    [sym_assignment] = STATE(9200),
    [sym_unary] = STATE(9200),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9200),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9200),
    [sym_conditional] = STATE(9200),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9200),
    [sym_binary] = STATE(9200),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6641] = {
    [sym_assignment] = STATE(9201),
    [sym_unary] = STATE(9201),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9201),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9201),
    [sym_conditional] = STATE(9201),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9201),
    [sym_binary] = STATE(9201),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6642] = {
    [sym_assignment] = STATE(9202),
    [sym_unary] = STATE(9202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9202),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9202),
    [sym_conditional] = STATE(9202),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9202),
    [sym_binary] = STATE(9202),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6643] = {
    [sym_assignment] = STATE(9203),
    [sym_unary] = STATE(9203),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9203),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9203),
    [sym_conditional] = STATE(9203),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9203),
    [sym_binary] = STATE(9203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6644] = {
    [sym_assignment] = STATE(9204),
    [sym_unary] = STATE(9204),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9204),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(9204),
    [sym_conditional] = STATE(9204),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9204),
    [sym_binary] = STATE(9204),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6645] = {
    [aux_sym_chained_string_repeat1] = STATE(9205),
    [sym_string] = STATE(9205),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [6646] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(1531),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym_float] = ACTIONS(2671),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2675),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(2689),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(2693),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10639),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [6647] = {
    [sym_heredoc_body] = STATE(6647),
    [aux_sym_call_repeat1] = STATE(6647),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [6648] = {
    [sym_heredoc_body] = STATE(6647),
    [aux_sym_call_repeat1] = STATE(6647),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [6649] = {
    [aux_sym_argument_list_repeat1] = STATE(6649),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13724),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [6650] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6651] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6652] = {
    [aux_sym_exceptions_repeat1] = STATE(9207),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [6653] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6654] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6655] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13727),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6656] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6657] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6658] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6659] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6660] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6661] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6662] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [6663] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_CARET] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [anon_sym_ensure] = ACTIONS(1327),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6664] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9210),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13729),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6665] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_rescue] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_CARET] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [anon_sym_ensure] = ACTIONS(6719),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6666] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_rescue] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_CARET] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [anon_sym_ensure] = ACTIONS(6727),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6667] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6666),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9211),
    [sym_operator] = STATE(9211),
    [anon_sym_LT] = ACTIONS(10641),
    [anon_sym_SLASH] = ACTIONS(10643),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(10643),
    [anon_sym_PLUS_AT] = ACTIONS(10643),
    [anon_sym_LPAREN2] = ACTIONS(10645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10643),
    [anon_sym_GT_GT] = ACTIONS(10643),
    [anon_sym_EQ_TILDE] = ACTIONS(10643),
    [anon_sym_LT_LT] = ACTIONS(10643),
    [anon_sym_TILDE] = ACTIONS(10643),
    [anon_sym_PLUS] = ACTIONS(10641),
    [anon_sym_AMP] = ACTIONS(10643),
    [anon_sym_GT] = ACTIONS(10641),
    [anon_sym_PERCENT] = ACTIONS(10643),
    [anon_sym_DASH_AT] = ACTIONS(10643),
    [anon_sym_EQ_EQ] = ACTIONS(10641),
    [anon_sym_STAR] = ACTIONS(10641),
    [anon_sym_BANG_TILDE] = ACTIONS(10643),
    [sym_constant] = ACTIONS(13731),
    [anon_sym_DASH] = ACTIONS(10641),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(10643),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10641),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(10643),
    [anon_sym_STAR_STAR] = ACTIONS(10643),
    [anon_sym_PIPE] = ACTIONS(10643),
    [anon_sym_DOT_DOT] = ACTIONS(10643),
    [anon_sym_LT_EQ_GT] = ACTIONS(10643),
    [anon_sym_LT_EQ] = ACTIONS(10641),
    [anon_sym_BANG] = ACTIONS(10641),
    [sym_identifier] = ACTIONS(13731),
    [anon_sym_CARET] = ACTIONS(10643),
  },
  [6668] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_CARET] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [anon_sym_ensure] = ACTIONS(6739),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6669] = {
    [sym_assignment] = STATE(9212),
    [sym_unary] = STATE(9212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(9212),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(9212),
    [sym_conditional] = STATE(9212),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(9212),
    [sym_binary] = STATE(9212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [6670] = {
    [sym_assignment] = STATE(9213),
    [sym_unary] = STATE(9213),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(9213),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(9213),
    [sym_conditional] = STATE(9213),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(9213),
    [sym_binary] = STATE(9213),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [6671] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6672] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6673] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6674] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_heredoc_body] = STATE(9214),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2749),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2749),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2757),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [sym__block_ampersand] = ACTIONS(6435),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13733),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [6675] = {
    [sym_heredoc_body] = STATE(9215),
    [aux_sym_call_repeat1] = STATE(9215),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6676] = {
    [sym_heredoc_body] = STATE(9216),
    [aux_sym_call_repeat1] = STATE(9216),
    [aux_sym_argument_list_repeat1] = STATE(9217),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10655),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6677] = {
    [aux_sym_chained_string_repeat1] = STATE(6677),
    [sym_string] = STATE(6677),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [6678] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_ensure] = ACTIONS(5452),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [6679] = {
    [anon_sym_RPAREN] = ACTIONS(13735),
    [sym_comment] = ACTIONS(49),
  },
  [6680] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [6681] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [6682] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6683] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [6684] = {
    [sym_assignment] = STATE(9219),
    [sym_unary] = STATE(9219),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9219),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9219),
    [sym_conditional] = STATE(9219),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9219),
    [sym_binary] = STATE(9219),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6685] = {
    [sym_assignment] = STATE(3841),
    [sym_unary] = STATE(3841),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3841),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_splat_argument] = STATE(9220),
    [sym_operator_assignment] = STATE(3841),
    [sym_conditional] = STATE(3841),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_return] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_subshell] = STATE(376),
    [sym__arg_or_splat_arg] = STATE(9220),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(3841),
    [sym_binary] = STATE(3841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(6461),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(681),
    [sym_character] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6686] = {
    [sym_assignment] = STATE(9221),
    [sym_unary] = STATE(9221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9221),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9221),
    [sym_conditional] = STATE(9221),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9221),
    [sym_binary] = STATE(9221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6687] = {
    [sym_assignment] = STATE(9222),
    [sym_unary] = STATE(9222),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9222),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9222),
    [sym_conditional] = STATE(9222),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9222),
    [sym_binary] = STATE(9222),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6688] = {
    [sym_assignment] = STATE(9224),
    [sym_unary] = STATE(9224),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9224),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9224),
    [sym_conditional] = STATE(9224),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9224),
    [sym_binary] = STATE(9224),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6689] = {
    [sym_assignment] = STATE(9225),
    [sym_unary] = STATE(9225),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9225),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9225),
    [sym_conditional] = STATE(9225),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9225),
    [sym_binary] = STATE(9225),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6690] = {
    [sym_assignment] = STATE(9226),
    [sym_unary] = STATE(9226),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9226),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9226),
    [sym_conditional] = STATE(9226),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9226),
    [sym_binary] = STATE(9226),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6691] = {
    [sym_assignment] = STATE(9227),
    [sym_unary] = STATE(9227),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9227),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9227),
    [sym_conditional] = STATE(9227),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9227),
    [sym_binary] = STATE(9227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6692] = {
    [sym_assignment] = STATE(9228),
    [sym_unary] = STATE(9228),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9228),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9228),
    [sym_conditional] = STATE(9228),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9228),
    [sym_binary] = STATE(9228),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6693] = {
    [sym_assignment] = STATE(9229),
    [sym_unary] = STATE(9229),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9229),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9229),
    [sym_conditional] = STATE(9229),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9229),
    [sym_binary] = STATE(9229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6694] = {
    [sym_assignment] = STATE(9230),
    [sym_unary] = STATE(9230),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9230),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(9230),
    [sym_conditional] = STATE(9230),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(9230),
    [sym_binary] = STATE(9230),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6695] = {
    [sym_assignment] = STATE(3841),
    [sym_unary] = STATE(3841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(3841),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(3841),
    [sym_conditional] = STATE(3841),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_return] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_true] = STATE(3840),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(3841),
    [sym_binary] = STATE(3841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(6461),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(681),
    [sym_character] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [6696] = {
    [aux_sym_exceptions_repeat1] = STATE(9231),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(10695),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [6697] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [sym__line_break] = ACTIONS(13739),
    [anon_sym_then] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_when] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym___END__] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_end] = ACTIONS(13739),
    [anon_sym_ensure] = ACTIONS(13739),
    [anon_sym_else] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_elsif] = ACTIONS(13739),
    [ts_builtin_sym_end] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
    [sym__binary_minus] = ACTIONS(13739),
  },
  [6698] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [6699] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [6700] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [6701] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [6702] = {
    [sym_assignment] = STATE(9232),
    [sym_unary] = STATE(9232),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9232),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9232),
    [sym_conditional] = STATE(9232),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9232),
    [sym_binary] = STATE(9232),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6703] = {
    [sym_assignment] = STATE(9233),
    [sym_unary] = STATE(9233),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9233),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_splat_argument] = STATE(9234),
    [sym_operator_assignment] = STATE(9233),
    [sym_conditional] = STATE(9233),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_return] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_subshell] = STATE(3860),
    [sym__arg_or_splat_arg] = STATE(9234),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9233),
    [sym_binary] = STATE(9233),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [sym_global_variable] = ACTIONS(6497),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6489),
    [sym_character] = ACTIONS(6493),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6704] = {
    [sym_assignment] = STATE(9235),
    [sym_unary] = STATE(9235),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9235),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9235),
    [sym_conditional] = STATE(9235),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9235),
    [sym_binary] = STATE(9235),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6705] = {
    [sym_assignment] = STATE(9236),
    [sym_unary] = STATE(9236),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9236),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9236),
    [sym_conditional] = STATE(9236),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9236),
    [sym_binary] = STATE(9236),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6706] = {
    [sym_assignment] = STATE(9238),
    [sym_unary] = STATE(9238),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9238),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9238),
    [sym_conditional] = STATE(9238),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9238),
    [sym_binary] = STATE(9238),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6707] = {
    [sym_assignment] = STATE(9239),
    [sym_unary] = STATE(9239),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9239),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9239),
    [sym_conditional] = STATE(9239),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9239),
    [sym_binary] = STATE(9239),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6708] = {
    [sym_assignment] = STATE(9240),
    [sym_unary] = STATE(9240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9240),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9240),
    [sym_conditional] = STATE(9240),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9240),
    [sym_binary] = STATE(9240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6709] = {
    [sym_assignment] = STATE(9241),
    [sym_unary] = STATE(9241),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9241),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9241),
    [sym_conditional] = STATE(9241),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9241),
    [sym_binary] = STATE(9241),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6710] = {
    [sym_assignment] = STATE(9242),
    [sym_unary] = STATE(9242),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9242),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9242),
    [sym_conditional] = STATE(9242),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9242),
    [sym_binary] = STATE(9242),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6711] = {
    [sym_assignment] = STATE(9243),
    [sym_unary] = STATE(9243),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9243),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9243),
    [sym_conditional] = STATE(9243),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9243),
    [sym_binary] = STATE(9243),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6712] = {
    [sym_assignment] = STATE(9244),
    [sym_unary] = STATE(9244),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9244),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(9244),
    [sym_conditional] = STATE(9244),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9244),
    [sym_binary] = STATE(9244),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [6713] = {
    [aux_sym_chained_string_repeat1] = STATE(9245),
    [sym_string] = STATE(9245),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [6714] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6715] = {
    [aux_sym_exceptions_repeat1] = STATE(9247),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [6716] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(1566),
    [sym_unary] = STATE(1566),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(1566),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(1566),
    [sym_conditional] = STATE(1566),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(1567),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(1566),
    [sym_binary] = STATE(1566),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2749),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2749),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(2761),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10737),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [6717] = {
    [sym_heredoc_body] = STATE(6717),
    [aux_sym_call_repeat1] = STATE(6717),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [6718] = {
    [sym_heredoc_body] = STATE(6717),
    [aux_sym_call_repeat1] = STATE(6717),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [6719] = {
    [aux_sym_argument_list_repeat1] = STATE(6719),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13741),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [6720] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6721] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6722] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6723] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13744),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6724] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6725] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6726] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6727] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [6728] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6729] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6730] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6731] = {
    [aux_sym_chained_string_repeat1] = STATE(6731),
    [sym_string] = STATE(6731),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [6732] = {
    [sym_assignment] = STATE(9249),
    [sym_unary] = STATE(9249),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9249),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(9249),
    [sym_conditional] = STATE(9249),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(377),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(382),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym_range] = STATE(9249),
    [sym_binary] = STATE(9249),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(382),
    [sym_nil] = STATE(382),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(701),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(703),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6733] = {
    [anon_sym_end] = ACTIONS(13746),
    [sym_comment] = ACTIONS(49),
  },
  [6734] = {
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [sym_self] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_nil] = ACTIONS(5452),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [anon_sym_next] = ACTIONS(5452),
    [sym_retry] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_return] = ACTIONS(5452),
  },
  [6735] = {
    [anon_sym_RPAREN] = ACTIONS(13748),
    [sym_comment] = ACTIONS(49),
  },
  [6736] = {
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [sym_self] = ACTIONS(10960),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_nil] = ACTIONS(10960),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [anon_sym_next] = ACTIONS(10960),
    [sym_retry] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_return] = ACTIONS(10960),
  },
  [6737] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(10777),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [anon_sym_and] = ACTIONS(10777),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_PIPE] = ACTIONS(10789),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [6738] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(10777),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [anon_sym_and] = ACTIONS(10777),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_PIPE] = ACTIONS(10789),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [6739] = {
    [sym_assignment] = STATE(9252),
    [sym_unary] = STATE(9252),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(9252),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(9252),
    [sym_conditional] = STATE(9252),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(9252),
    [sym_binary] = STATE(9252),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [6740] = {
    [sym_assignment] = STATE(9253),
    [sym_unary] = STATE(9253),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(9253),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(9253),
    [sym_conditional] = STATE(9253),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(9253),
    [sym_binary] = STATE(9253),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [6741] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6742] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6743] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6744] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(9254),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6566),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13750),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [6745] = {
    [sym_heredoc_body] = STATE(9255),
    [aux_sym_call_repeat1] = STATE(9255),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6746] = {
    [sym_heredoc_body] = STATE(9256),
    [aux_sym_call_repeat1] = STATE(9256),
    [aux_sym_argument_list_repeat1] = STATE(9257),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [6747] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(13752),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6748] = {
    [anon_sym_COLON] = ACTIONS(13754),
    [sym_comment] = ACTIONS(49),
  },
  [6749] = {
    [sym_assignment] = STATE(9260),
    [sym_unary] = STATE(9260),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9260),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9260),
    [sym_conditional] = STATE(9260),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9260),
    [sym_binary] = STATE(9260),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6750] = {
    [sym_assignment] = STATE(9261),
    [sym_unary] = STATE(9261),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9261),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9261),
    [sym_conditional] = STATE(9261),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9261),
    [sym_binary] = STATE(9261),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6751] = {
    [sym_assignment] = STATE(9262),
    [sym_unary] = STATE(9262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9262),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9262),
    [sym_conditional] = STATE(9262),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9262),
    [sym_binary] = STATE(9262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6752] = {
    [sym_heredoc_body] = STATE(9264),
    [aux_sym_call_repeat1] = STATE(9264),
    [aux_sym_argument_list_repeat1] = STATE(9265),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13756),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6753] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(13754),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6754] = {
    [aux_sym_chained_string_repeat1] = STATE(3943),
    [sym_string] = STATE(3943),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13758),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [6755] = {
    [sym_heredoc_body] = STATE(9264),
    [aux_sym_call_repeat1] = STATE(9264),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [6756] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [6757] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [6758] = {
    [sym_assignment] = STATE(9266),
    [sym_unary] = STATE(9266),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9266),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9266),
    [sym_conditional] = STATE(9266),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9266),
    [sym_binary] = STATE(9266),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6759] = {
    [sym_assignment] = STATE(9267),
    [sym_unary] = STATE(9267),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9267),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_splat_argument] = STATE(9268),
    [sym_operator_assignment] = STATE(9267),
    [sym_conditional] = STATE(9267),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_subshell] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(9268),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9267),
    [sym_binary] = STATE(9267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6760] = {
    [sym_assignment] = STATE(9269),
    [sym_unary] = STATE(9269),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9269),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9269),
    [sym_conditional] = STATE(9269),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9269),
    [sym_binary] = STATE(9269),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6761] = {
    [sym_assignment] = STATE(9270),
    [sym_unary] = STATE(9270),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9270),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9270),
    [sym_conditional] = STATE(9270),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9270),
    [sym_binary] = STATE(9270),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6762] = {
    [sym_assignment] = STATE(9271),
    [sym_unary] = STATE(9271),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9271),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9271),
    [sym_conditional] = STATE(9271),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9271),
    [sym_binary] = STATE(9271),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6763] = {
    [sym_assignment] = STATE(9272),
    [sym_unary] = STATE(9272),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9272),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9272),
    [sym_conditional] = STATE(9272),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9272),
    [sym_binary] = STATE(9272),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6764] = {
    [sym_assignment] = STATE(9273),
    [sym_unary] = STATE(9273),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9273),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9273),
    [sym_conditional] = STATE(9273),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9273),
    [sym_binary] = STATE(9273),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6765] = {
    [sym_assignment] = STATE(9274),
    [sym_unary] = STATE(9274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9274),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9274),
    [sym_conditional] = STATE(9274),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9274),
    [sym_binary] = STATE(9274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6766] = {
    [sym_assignment] = STATE(9275),
    [sym_unary] = STATE(9275),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9275),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9275),
    [sym_conditional] = STATE(9275),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9275),
    [sym_binary] = STATE(9275),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6767] = {
    [sym_assignment] = STATE(9276),
    [sym_unary] = STATE(9276),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9276),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9276),
    [sym_conditional] = STATE(9276),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9276),
    [sym_binary] = STATE(9276),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6768] = {
    [sym_assignment] = STATE(9277),
    [sym_unary] = STATE(9277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9277),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9277),
    [sym_conditional] = STATE(9277),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9277),
    [sym_binary] = STATE(9277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6769] = {
    [sym_assignment] = STATE(9278),
    [sym_unary] = STATE(9278),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9278),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(9278),
    [sym_conditional] = STATE(9278),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9278),
    [sym_binary] = STATE(9278),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [6770] = {
    [aux_sym_chained_string_repeat1] = STATE(9279),
    [sym_string] = STATE(9279),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [6771] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6772] = {
    [aux_sym_exceptions_repeat1] = STATE(9281),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [6773] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1602),
    [sym_unary] = STATE(1602),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1602),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1602),
    [sym_conditional] = STATE(1602),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1603),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1602),
    [sym_binary] = STATE(1602),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(2829),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2835),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2845),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [6774] = {
    [sym_heredoc_body] = STATE(6774),
    [aux_sym_call_repeat1] = STATE(6774),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12684),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
  },
  [6775] = {
    [sym_heredoc_body] = STATE(6774),
    [aux_sym_call_repeat1] = STATE(6774),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
  },
  [6776] = {
    [aux_sym_argument_list_repeat1] = STATE(6776),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(13760),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
  },
  [6777] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6778] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6779] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6780] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13763),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6781] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6782] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6783] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6784] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [6785] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6786] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6787] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [6788] = {
    [aux_sym_chained_string_repeat1] = STATE(6788),
    [sym_string] = STATE(6788),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [6789] = {
    [aux_sym_undef_repeat1] = STATE(9283),
    [sym__line_break] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_elsif] = ACTIONS(1053),
  },
  [6790] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [6791] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [6792] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_elsif] = ACTIONS(2053),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [6793] = {
    [sym_assignment] = STATE(9284),
    [sym_unary] = STATE(9284),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9284),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(9284),
    [sym_conditional] = STATE(9284),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(9284),
    [sym_binary] = STATE(9284),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [6794] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [6795] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(13769),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_elsif] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6796] = {
    [sym_assignment] = STATE(9287),
    [sym_unary] = STATE(9287),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9287),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(9287),
    [sym_conditional] = STATE(9287),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(9287),
    [sym_binary] = STATE(9287),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [6797] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13771),
    [sym_identifier] = ACTIONS(13771),
  },
  [6798] = {
    [anon_sym_COLON] = ACTIONS(13773),
    [sym_comment] = ACTIONS(49),
  },
  [6799] = {
    [sym__argument] = STATE(9295),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(9295),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(9295),
    [sym_hash_splat_argument] = STATE(9295),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(9298),
    [sym_block_argument] = STATE(9295),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_elsif] = ACTIONS(501),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [6800] = {
    [sym_assignment] = STATE(9307),
    [sym_unary] = STATE(9307),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9307),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(9307),
    [sym_conditional] = STATE(9307),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(9307),
    [sym_binary] = STATE(9307),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [6801] = {
    [sym_assignment] = STATE(9310),
    [sym_unary] = STATE(9310),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9310),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(9310),
    [sym_conditional] = STATE(9310),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(9310),
    [sym_binary] = STATE(9310),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [6802] = {
    [sym__argument] = STATE(9295),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(9295),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(9295),
    [sym_hash_splat_argument] = STATE(9295),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(9298),
    [sym_block_argument] = STATE(9295),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_elsif] = ACTIONS(647),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [6803] = {
    [sym__argument] = STATE(9295),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(9295),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(9295),
    [sym_hash_splat_argument] = STATE(9295),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(9298),
    [sym_block_argument] = STATE(9295),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [6804] = {
    [sym_assignment] = STATE(9311),
    [sym_unary] = STATE(9311),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9311),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(9311),
    [sym_conditional] = STATE(9311),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(9311),
    [sym_binary] = STATE(9311),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [6805] = {
    [sym__argument] = STATE(9295),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(9295),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(9295),
    [sym_hash_splat_argument] = STATE(9295),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(9298),
    [sym_block_argument] = STATE(9295),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_elsif] = ACTIONS(753),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [6806] = {
    [sym_heredoc_body] = STATE(9313),
    [aux_sym_call_repeat1] = STATE(9313),
    [aux_sym_argument_list_repeat1] = STATE(9314),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13801),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6807] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13803),
    [anon_sym_GT_GT_EQ] = ACTIONS(13803),
    [anon_sym_SLASH_EQ] = ACTIONS(13803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13803),
    [anon_sym_LT_LT_EQ] = ACTIONS(13803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13803),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(13803),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13805),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(13803),
    [anon_sym_PLUS_EQ] = ACTIONS(13803),
    [anon_sym_STAR_EQ] = ACTIONS(13803),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13803),
    [anon_sym_DASH_EQ] = ACTIONS(13803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13803),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6808] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [anon_sym_rescue] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_EQ_GT] = ACTIONS(13773),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [6809] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(13833),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(13835),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_elsif] = ACTIONS(777),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13837),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [6810] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym__primary] = STATE(6836),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_method] = STATE(6836),
    [sym_conditional] = STATE(9334),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_subshell] = STATE(6836),
    [sym_unless] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(6840),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_call] = STATE(6838),
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_rational] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_lambda] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(9334),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_nil] = STATE(6840),
    [sym_symbol_array] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_scope_resolution] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6811] = {
    [anon_sym_EQ] = ACTIONS(13847),
    [sym_comment] = ACTIONS(3),
  },
  [6812] = {
    [aux_sym_chained_string_repeat1] = STATE(9337),
    [sym_string] = STATE(9337),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13849),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_elsif] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [6813] = {
    [sym_heredoc_body] = STATE(9313),
    [aux_sym_call_repeat1] = STATE(9313),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [6814] = {
    [sym_assignment] = STATE(9338),
    [sym_unary] = STATE(9338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9338),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9338),
    [sym_conditional] = STATE(9338),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9338),
    [sym_binary] = STATE(9338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6815] = {
    [sym_assignment] = STATE(9339),
    [sym_unary] = STATE(9339),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9339),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9339),
    [sym_conditional] = STATE(9339),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9339),
    [sym_binary] = STATE(9339),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6816] = {
    [sym_assignment] = STATE(9340),
    [sym_unary] = STATE(9340),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9340),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9340),
    [sym_conditional] = STATE(9340),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9340),
    [sym_binary] = STATE(9340),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6817] = {
    [aux_sym_heredoc_body_repeat1] = STATE(9342),
    [sym_interpolation] = STATE(9342),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(13851),
    [sym_heredoc_end] = ACTIONS(13853),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(13851),
  },
  [6818] = {
    [sym_assignment] = STATE(9343),
    [sym_unary] = STATE(9343),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9343),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9343),
    [sym_conditional] = STATE(9343),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9343),
    [sym_binary] = STATE(9343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6819] = {
    [sym_assignment] = STATE(9344),
    [sym_unary] = STATE(9344),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9344),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9344),
    [sym_conditional] = STATE(9344),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9344),
    [sym_binary] = STATE(9344),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6820] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_elsif] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [6821] = {
    [sym_heredoc_body] = STATE(9349),
    [sym__argument_list_with_parens] = STATE(9348),
    [aux_sym_call_repeat1] = STATE(9349),
    [sym_argument_list_with_parens] = STATE(9347),
    [sym_operator] = STATE(9347),
    [anon_sym_LT] = ACTIONS(13855),
    [anon_sym_SLASH] = ACTIONS(13857),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13857),
    [anon_sym_PLUS_AT] = ACTIONS(13857),
    [anon_sym_LPAREN2] = ACTIONS(13859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13857),
    [anon_sym_GT_GT] = ACTIONS(13857),
    [anon_sym_EQ_TILDE] = ACTIONS(13857),
    [anon_sym_LT_LT] = ACTIONS(13857),
    [anon_sym_TILDE] = ACTIONS(13857),
    [anon_sym_PLUS] = ACTIONS(13855),
    [anon_sym_AMP] = ACTIONS(13857),
    [anon_sym_GT] = ACTIONS(13855),
    [anon_sym_PERCENT] = ACTIONS(13857),
    [anon_sym_DASH_AT] = ACTIONS(13857),
    [anon_sym_EQ_EQ] = ACTIONS(13855),
    [anon_sym_STAR] = ACTIONS(13855),
    [anon_sym_BANG_TILDE] = ACTIONS(13857),
    [sym_constant] = ACTIONS(13861),
    [anon_sym_DASH] = ACTIONS(13855),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13857),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13855),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13857),
    [anon_sym_STAR_STAR] = ACTIONS(13857),
    [anon_sym_PIPE] = ACTIONS(13857),
    [anon_sym_DOT_DOT] = ACTIONS(13857),
    [anon_sym_LT_EQ_GT] = ACTIONS(13857),
    [anon_sym_LT_EQ] = ACTIONS(13855),
    [anon_sym_BANG] = ACTIONS(13855),
    [sym_identifier] = ACTIONS(13861),
    [anon_sym_CARET] = ACTIONS(13857),
  },
  [6822] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(13863),
    [sym_identifier] = ACTIONS(13863),
  },
  [6823] = {
    [sym_assignment] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_splat_argument] = STATE(9358),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_return] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_subshell] = STATE(3955),
    [sym__arg_or_splat_arg] = STATE(9358),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(13869),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6638),
    [sym_character] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [6824] = {
    [sym_assignment] = STATE(9359),
    [sym_unary] = STATE(9359),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9359),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(9359),
    [sym_conditional] = STATE(9359),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(9359),
    [sym_binary] = STATE(9359),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6825] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6826] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(13879),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_elsif] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [6827] = {
    [sym_assignment] = STATE(9362),
    [sym_unary] = STATE(9362),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9362),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(9362),
    [sym_conditional] = STATE(9362),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(9362),
    [sym_binary] = STATE(9362),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6828] = {
    [anon_sym_COLON] = ACTIONS(13881),
    [sym_comment] = ACTIONS(49),
  },
  [6829] = {
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(501),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(501),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(501),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(501),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6830] = {
    [sym_assignment] = STATE(9372),
    [sym_unary] = STATE(9372),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(9372),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(9372),
    [sym_conditional] = STATE(9372),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(9372),
    [sym_binary] = STATE(9372),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [6831] = {
    [sym_assignment] = STATE(9377),
    [sym_unary] = STATE(9377),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(9377),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(9377),
    [sym_conditional] = STATE(9377),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(9377),
    [sym_binary] = STATE(9377),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [6832] = {
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(647),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(647),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(647),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(647),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6833] = {
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(737),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(737),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(737),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6834] = {
    [sym_assignment] = STATE(9378),
    [sym_unary] = STATE(9378),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(9378),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(9378),
    [sym_conditional] = STATE(9378),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(9378),
    [sym_binary] = STATE(9378),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [6835] = {
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(753),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(753),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(753),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(753),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6836] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(13833),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(13835),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(13837),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_elsif] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [6837] = {
    [anon_sym_EQ] = ACTIONS(13909),
    [sym_comment] = ACTIONS(3),
  },
  [6838] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym__primary] = STATE(6836),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(9333),
    [sym_method] = STATE(6836),
    [sym_conditional] = STATE(9334),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_subshell] = STATE(6836),
    [sym_unless] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_block_argument] = STATE(9333),
    [sym_range] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(6840),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_call] = STATE(6838),
    [sym__argument] = STATE(9333),
    [sym_assignment] = STATE(9334),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_pair] = STATE(9333),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9333),
    [sym_operator_assignment] = STATE(9334),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_rational] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_lambda] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(9336),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(9334),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_nil] = STATE(6840),
    [sym_symbol_array] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_scope_resolution] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(10861),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [sym__block_ampersand] = ACTIONS(13845),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(10885),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_elsif] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10889),
    [anon_sym_return] = ACTIONS(10859),
  },
  [6839] = {
    [sym_heredoc_body] = STATE(9381),
    [aux_sym_call_repeat1] = STATE(9381),
    [aux_sym_argument_list_repeat1] = STATE(9382),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13911),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6840] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13913),
    [anon_sym_GT_GT_EQ] = ACTIONS(13913),
    [anon_sym_SLASH_EQ] = ACTIONS(13913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13913),
    [anon_sym_LT_LT_EQ] = ACTIONS(13913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13913),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(13913),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13915),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(13913),
    [anon_sym_PLUS_EQ] = ACTIONS(13913),
    [anon_sym_STAR_EQ] = ACTIONS(13913),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13913),
    [anon_sym_DASH_EQ] = ACTIONS(13913),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13913),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6841] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(13881),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [6842] = {
    [aux_sym_chained_string_repeat1] = STATE(9393),
    [sym_string] = STATE(9393),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(13945),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6843] = {
    [sym_heredoc_body] = STATE(9381),
    [aux_sym_call_repeat1] = STATE(9381),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [6844] = {
    [sym_assignment] = STATE(9394),
    [sym_unary] = STATE(9394),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9394),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9394),
    [sym_conditional] = STATE(9394),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9394),
    [sym_binary] = STATE(9394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6845] = {
    [sym_assignment] = STATE(9395),
    [sym_unary] = STATE(9395),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9395),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9395),
    [sym_conditional] = STATE(9395),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9395),
    [sym_binary] = STATE(9395),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6846] = {
    [sym_assignment] = STATE(9396),
    [sym_unary] = STATE(9396),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9396),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9396),
    [sym_conditional] = STATE(9396),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9396),
    [sym_binary] = STATE(9396),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6847] = {
    [sym_assignment] = STATE(9397),
    [sym_unary] = STATE(9397),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9397),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9397),
    [sym_conditional] = STATE(9397),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9397),
    [sym_binary] = STATE(9397),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6848] = {
    [sym_assignment] = STATE(9398),
    [sym_unary] = STATE(9398),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9398),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9398),
    [sym_conditional] = STATE(9398),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9398),
    [sym_binary] = STATE(9398),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6849] = {
    [sym_assignment] = STATE(9399),
    [sym_unary] = STATE(9399),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9399),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9399),
    [sym_conditional] = STATE(9399),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9399),
    [sym_binary] = STATE(9399),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [6850] = {
    [sym_assignment] = STATE(9400),
    [sym_unary] = STATE(9400),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9400),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9400),
    [sym_conditional] = STATE(9400),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9400),
    [sym_binary] = STATE(9400),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6851] = {
    [sym_assignment] = STATE(9401),
    [sym_unary] = STATE(9401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9401),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9401),
    [sym_conditional] = STATE(9401),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9401),
    [sym_binary] = STATE(9401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6852] = {
    [sym_assignment] = STATE(9402),
    [sym_unary] = STATE(9402),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9402),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9402),
    [sym_conditional] = STATE(9402),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9402),
    [sym_binary] = STATE(9402),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6853] = {
    [sym_assignment] = STATE(9403),
    [sym_unary] = STATE(9403),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9403),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9403),
    [sym_conditional] = STATE(9403),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9403),
    [sym_binary] = STATE(9403),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6854] = {
    [sym_assignment] = STATE(9404),
    [sym_unary] = STATE(9404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9404),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(9404),
    [sym_conditional] = STATE(9404),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(9404),
    [sym_binary] = STATE(9404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6855] = {
    [aux_sym_chained_string_repeat1] = STATE(9405),
    [sym_string] = STATE(9405),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_elsif] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [6856] = {
    [sym_heredoc_body] = STATE(6820),
    [sym__terminator] = STATE(6820),
    [sym__line_break] = ACTIONS(10835),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(10837),
    [anon_sym_until] = ACTIONS(10839),
    [anon_sym_while] = ACTIONS(10841),
    [sym__heredoc_body_start] = ACTIONS(10843),
    [anon_sym_rescue] = ACTIONS(10845),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10847),
    [anon_sym_elsif] = ACTIONS(3169),
  },
  [6857] = {
    [sym__statement] = STATE(9406),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(9406),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(9406),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(9406),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(6857),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(9406),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(9406),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(9406),
    [sym_if_modifier] = STATE(9406),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(9406),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(9406),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(6857),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3252),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(13947),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_elsif] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [6858] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_elsif] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [6859] = {
    [sym__terminator] = STATE(9407),
    [sym_heredoc_body] = STATE(9407),
    [sym_then] = STATE(9408),
    [sym__line_break] = ACTIONS(13950),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(13950),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [6860] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [sym__line_break] = ACTIONS(13954),
    [anon_sym_then] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_when] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym___END__] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_end] = ACTIONS(13954),
    [anon_sym_ensure] = ACTIONS(13954),
    [anon_sym_else] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_elsif] = ACTIONS(13954),
    [ts_builtin_sym_end] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
    [sym__binary_minus] = ACTIONS(13954),
  },
  [6861] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [sym__line_break] = ACTIONS(13958),
    [anon_sym_then] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_when] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym___END__] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_end] = ACTIONS(13958),
    [anon_sym_ensure] = ACTIONS(13958),
    [anon_sym_else] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_elsif] = ACTIONS(13958),
    [ts_builtin_sym_end] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
    [sym__binary_minus] = ACTIONS(13958),
  },
  [6862] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13960),
  },
  [6863] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [sym__line_break] = ACTIONS(13964),
    [anon_sym_then] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_when] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym___END__] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_end] = ACTIONS(13964),
    [anon_sym_ensure] = ACTIONS(13964),
    [anon_sym_else] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_elsif] = ACTIONS(13964),
    [ts_builtin_sym_end] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
    [sym__binary_minus] = ACTIONS(13964),
  },
  [6864] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym_escape_sequence] = ACTIONS(173),
  },
  [6865] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym___END__] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [6866] = {
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_SLASH] = ACTIONS(8575),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(8575),
    [anon_sym_PLUS_AT] = ACTIONS(8575),
    [anon_sym_LPAREN2] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(8575),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(10412),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(8575),
    [anon_sym_DASH_AT] = ACTIONS(8575),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(10412),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [sym_constant] = ACTIONS(8575),
    [anon_sym_DASH] = ACTIONS(10412),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(8575),
    [anon_sym_DOT_DOT] = ACTIONS(8575),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(8575),
  },
  [6867] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6868] = {
    [aux_sym_exceptions_repeat1] = STATE(4000),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [6869] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6870] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6871] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6872] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6873] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(13966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6874] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6875] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6876] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6877] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6878] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [6879] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [6880] = {
    [aux_sym_exceptions_repeat1] = STATE(6880),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13970),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [6881] = {
    [anon_sym_SLASH] = ACTIONS(7382),
    [sym__line_break] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_AMP_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT_EQ] = ACTIONS(7384),
    [anon_sym_SLASH_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7382),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7382),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7382),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_PERCENT_EQ] = ACTIONS(7384),
    [anon_sym_LT_LT_EQ] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_else] = ACTIONS(7384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_CARET_EQ] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_EQ] = ACTIONS(7382),
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_then] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7382),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_EQ_GT] = ACTIONS(7384),
    [anon_sym_when] = ACTIONS(7384),
    [anon_sym_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_PLUS_EQ] = ACTIONS(7384),
    [anon_sym_STAR_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym___END__] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7382),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_end] = ACTIONS(7384),
    [anon_sym_ensure] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_elsif] = ACTIONS(7384),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7384),
    [ts_builtin_sym_end] = ACTIONS(7384),
    [anon_sym_DASH_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7382),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_AMP_AMP] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7382),
  },
  [6882] = {
    [anon_sym_end] = ACTIONS(13973),
    [sym_comment] = ACTIONS(49),
  },
  [6883] = {
    [anon_sym_SLASH] = ACTIONS(7788),
    [sym__line_break] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_AMP_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT_EQ] = ACTIONS(7790),
    [anon_sym_SLASH_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_PERCENT_EQ] = ACTIONS(7790),
    [anon_sym_LT_LT_EQ] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_else] = ACTIONS(7790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_CARET_EQ] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_EQ] = ACTIONS(7788),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_then] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7790),
    [anon_sym_when] = ACTIONS(7790),
    [anon_sym_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_PLUS_EQ] = ACTIONS(7790),
    [anon_sym_STAR_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym___END__] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7790),
    [anon_sym_ensure] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_elsif] = ACTIONS(7790),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7790),
    [ts_builtin_sym_end] = ACTIONS(7790),
    [anon_sym_DASH_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7788),
  },
  [6884] = {
    [anon_sym_end] = ACTIONS(13975),
    [sym_comment] = ACTIONS(49),
  },
  [6885] = {
    [anon_sym_SLASH] = ACTIONS(7870),
    [sym__line_break] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_AMP_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT_EQ] = ACTIONS(7872),
    [anon_sym_SLASH_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7870),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7870),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7870),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_PERCENT_EQ] = ACTIONS(7872),
    [anon_sym_LT_LT_EQ] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_else] = ACTIONS(7872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_CARET_EQ] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_EQ] = ACTIONS(7870),
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_then] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7870),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [anon_sym_when] = ACTIONS(7872),
    [anon_sym_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_PLUS_EQ] = ACTIONS(7872),
    [anon_sym_STAR_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym___END__] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_end] = ACTIONS(7872),
    [anon_sym_ensure] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_elsif] = ACTIONS(7872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7872),
    [ts_builtin_sym_end] = ACTIONS(7872),
    [anon_sym_DASH_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7870),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7870),
  },
  [6886] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13977),
  },
  [6887] = {
    [anon_sym_SLASH] = ACTIONS(7876),
    [sym__line_break] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_AMP_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT_EQ] = ACTIONS(7878),
    [anon_sym_SLASH_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_PERCENT_EQ] = ACTIONS(7878),
    [anon_sym_LT_LT_EQ] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_CARET_EQ] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7878),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_PLUS_EQ] = ACTIONS(7878),
    [anon_sym_STAR_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7878),
    [ts_builtin_sym_end] = ACTIONS(7878),
    [anon_sym_DASH_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7876),
  },
  [6888] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(13979),
    [sym__string_end] = ACTIONS(13977),
  },
  [6889] = {
    [anon_sym_SLASH] = ACTIONS(8222),
    [sym__line_break] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_AMP_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT_EQ] = ACTIONS(8224),
    [anon_sym_SLASH_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8222),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_PERCENT_EQ] = ACTIONS(8224),
    [anon_sym_LT_LT_EQ] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_else] = ACTIONS(8224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_CARET_EQ] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_then] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_EQ_GT] = ACTIONS(8224),
    [anon_sym_when] = ACTIONS(8224),
    [anon_sym_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_PLUS_EQ] = ACTIONS(8224),
    [anon_sym_STAR_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym___END__] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_end] = ACTIONS(8224),
    [anon_sym_ensure] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_elsif] = ACTIONS(8224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8224),
    [ts_builtin_sym_end] = ACTIONS(8224),
    [anon_sym_DASH_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8222),
  },
  [6890] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(13981),
  },
  [6891] = {
    [sym_assignment] = STATE(9416),
    [sym_unary] = STATE(9416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(9416),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(9416),
    [sym_conditional] = STATE(9416),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(9416),
    [sym_binary] = STATE(9416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6892] = {
    [sym_assignment] = STATE(9417),
    [sym_unary] = STATE(9417),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(9417),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(9417),
    [sym_conditional] = STATE(9417),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(9417),
    [sym_binary] = STATE(9417),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6893] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [6894] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [6895] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [6896] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_heredoc_body] = STATE(9418),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2941),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(3524),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13983),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6897] = {
    [sym_heredoc_body] = STATE(9419),
    [aux_sym_call_repeat1] = STATE(9419),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6898] = {
    [sym_heredoc_body] = STATE(9420),
    [aux_sym_call_repeat1] = STATE(9420),
    [aux_sym_argument_list_repeat1] = STATE(9421),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10995),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [6899] = {
    [anon_sym_SLASH] = ACTIONS(13017),
    [sym__line_break] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_else] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_then] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_when] = ACTIONS(13019),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym___END__] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_end] = ACTIONS(13019),
    [anon_sym_ensure] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_elsif] = ACTIONS(13019),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [ts_builtin_sym_end] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [6900] = {
    [anon_sym_SLASH] = ACTIONS(8849),
    [sym__line_break] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_AMP_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT_EQ] = ACTIONS(8851),
    [anon_sym_SLASH_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8849),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8849),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_PERCENT_EQ] = ACTIONS(8851),
    [anon_sym_LT_LT_EQ] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_else] = ACTIONS(8851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_CARET_EQ] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_EQ] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_then] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_EQ_GT] = ACTIONS(8851),
    [anon_sym_when] = ACTIONS(8851),
    [anon_sym_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_PLUS_EQ] = ACTIONS(8851),
    [anon_sym_STAR_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym___END__] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_end] = ACTIONS(8851),
    [anon_sym_ensure] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_elsif] = ACTIONS(8851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8851),
    [ts_builtin_sym_end] = ACTIONS(8851),
    [anon_sym_DASH_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8849),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8849),
  },
  [6901] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [6902] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9423),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(13985),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [6903] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [6904] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [6905] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(6904),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9424),
    [sym_operator] = STATE(9424),
    [anon_sym_LT] = ACTIONS(11003),
    [anon_sym_SLASH] = ACTIONS(11005),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11005),
    [anon_sym_PLUS_AT] = ACTIONS(11005),
    [anon_sym_LPAREN2] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11005),
    [anon_sym_GT_GT] = ACTIONS(11005),
    [anon_sym_EQ_TILDE] = ACTIONS(11005),
    [anon_sym_LT_LT] = ACTIONS(11005),
    [anon_sym_TILDE] = ACTIONS(11005),
    [anon_sym_PLUS] = ACTIONS(11003),
    [anon_sym_AMP] = ACTIONS(11005),
    [anon_sym_GT] = ACTIONS(11003),
    [anon_sym_PERCENT] = ACTIONS(11005),
    [anon_sym_DASH_AT] = ACTIONS(11005),
    [anon_sym_EQ_EQ] = ACTIONS(11003),
    [anon_sym_STAR] = ACTIONS(11003),
    [anon_sym_BANG_TILDE] = ACTIONS(11005),
    [sym_constant] = ACTIONS(13987),
    [anon_sym_DASH] = ACTIONS(11003),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11005),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11005),
    [anon_sym_STAR_STAR] = ACTIONS(11005),
    [anon_sym_PIPE] = ACTIONS(11005),
    [anon_sym_DOT_DOT] = ACTIONS(11005),
    [anon_sym_LT_EQ_GT] = ACTIONS(11005),
    [anon_sym_LT_EQ] = ACTIONS(11003),
    [anon_sym_BANG] = ACTIONS(11003),
    [sym_identifier] = ACTIONS(13987),
    [anon_sym_CARET] = ACTIONS(11005),
  },
  [6906] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [6907] = {
    [sym_assignment] = STATE(9425),
    [sym_unary] = STATE(9425),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(9425),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(9425),
    [sym_conditional] = STATE(9425),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(9425),
    [sym_binary] = STATE(9425),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6908] = {
    [sym_assignment] = STATE(9426),
    [sym_unary] = STATE(9426),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(9426),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(9426),
    [sym_conditional] = STATE(9426),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(9426),
    [sym_binary] = STATE(9426),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6909] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6910] = {
    [sym_assignment] = STATE(9427),
    [sym_unary] = STATE(9427),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(9427),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(9427),
    [sym_conditional] = STATE(9427),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(9427),
    [sym_binary] = STATE(9427),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [6911] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(13989),
    [anon_sym_GT_GT_EQ] = ACTIONS(13989),
    [anon_sym_SLASH_EQ] = ACTIONS(13989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(13989),
    [anon_sym_LT_LT_EQ] = ACTIONS(13989),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13989),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(13989),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(13991),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(13989),
    [anon_sym_PLUS_EQ] = ACTIONS(13989),
    [anon_sym_STAR_EQ] = ACTIONS(13989),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13989),
    [anon_sym_DASH_EQ] = ACTIONS(13989),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13989),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [6912] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [6913] = {
    [anon_sym_EQ] = ACTIONS(14019),
    [sym_comment] = ACTIONS(3),
  },
  [6914] = {
    [aux_sym_exceptions_repeat1] = STATE(9440),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(14021),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [6915] = {
    [sym_assignment] = STATE(9441),
    [sym_unary] = STATE(9441),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(9441),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(9441),
    [sym_conditional] = STATE(9441),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(9441),
    [sym_binary] = STATE(9441),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [6916] = {
    [sym_assignment] = STATE(9442),
    [sym_unary] = STATE(9442),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(9442),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(9442),
    [sym_conditional] = STATE(9442),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(9442),
    [sym_binary] = STATE(9442),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [6917] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [6918] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [6919] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [6920] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_heredoc_body] = STATE(9443),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym_float] = ACTIONS(3558),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(3562),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(3562),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6819),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(3570),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [sym_class_variable] = ACTIONS(3570),
    [sym__block_ampersand] = ACTIONS(6823),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14023),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [6921] = {
    [sym_heredoc_body] = STATE(9444),
    [aux_sym_call_repeat1] = STATE(9444),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6922] = {
    [sym_heredoc_body] = STATE(9445),
    [aux_sym_call_repeat1] = STATE(9445),
    [aux_sym_argument_list_repeat1] = STATE(9446),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11029),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [6923] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6924] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6925] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6926] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14025),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6927] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6928] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6929] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6930] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6931] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [6932] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6933] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [6934] = {
    [aux_sym_chained_string_repeat1] = STATE(6934),
    [sym_string] = STATE(6934),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [6935] = {
    [anon_sym_SLASH] = ACTIONS(8870),
    [sym__line_break] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_AMP_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT_EQ] = ACTIONS(8872),
    [anon_sym_SLASH_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8870),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8870),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8870),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_PERCENT_EQ] = ACTIONS(8872),
    [anon_sym_LT_LT_EQ] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_else] = ACTIONS(8872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_CARET_EQ] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_EQ] = ACTIONS(8870),
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_then] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8870),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_EQ_GT] = ACTIONS(8872),
    [anon_sym_when] = ACTIONS(8872),
    [anon_sym_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_PLUS_EQ] = ACTIONS(8872),
    [anon_sym_STAR_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym___END__] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8870),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_end] = ACTIONS(8872),
    [anon_sym_ensure] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_elsif] = ACTIONS(8872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8872),
    [ts_builtin_sym_end] = ACTIONS(8872),
    [anon_sym_DASH_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8870),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_AMP_AMP] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8870),
  },
  [6936] = {
    [anon_sym_end] = ACTIONS(14027),
    [sym_comment] = ACTIONS(49),
  },
  [6937] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9450),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14029),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6938] = {
    [anon_sym_SLASH] = ACTIONS(12903),
    [sym__line_break] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_else] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_then] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_when] = ACTIONS(12905),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym___END__] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_end] = ACTIONS(12905),
    [anon_sym_ensure] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_elsif] = ACTIONS(12905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [ts_builtin_sym_end] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [6939] = {
    [anon_sym_end] = ACTIONS(14031),
    [sym_comment] = ACTIONS(49),
  },
  [6940] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9452),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14033),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6941] = {
    [anon_sym_DOT] = ACTIONS(14035),
    [anon_sym_COLON_COLON] = ACTIONS(14035),
    [sym_comment] = ACTIONS(49),
  },
  [6942] = {
    [anon_sym_SLASH] = ACTIONS(9600),
    [sym__line_break] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_AMP_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT_EQ] = ACTIONS(9602),
    [anon_sym_SLASH_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9600),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9600),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9600),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_PERCENT_EQ] = ACTIONS(9602),
    [anon_sym_LT_LT_EQ] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_else] = ACTIONS(9602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_CARET_EQ] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_EQ] = ACTIONS(9600),
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_then] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9600),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_EQ_GT] = ACTIONS(9602),
    [anon_sym_when] = ACTIONS(9602),
    [anon_sym_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_PLUS_EQ] = ACTIONS(9602),
    [anon_sym_STAR_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym___END__] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9600),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_end] = ACTIONS(9602),
    [anon_sym_ensure] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_elsif] = ACTIONS(9602),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9602),
    [ts_builtin_sym_end] = ACTIONS(9602),
    [anon_sym_DASH_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9600),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_AMP_AMP] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9600),
  },
  [6943] = {
    [anon_sym_SLASH] = ACTIONS(9606),
    [sym__line_break] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_AMP_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT_EQ] = ACTIONS(9608),
    [anon_sym_SLASH_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9606),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9606),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9606),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_PERCENT_EQ] = ACTIONS(9608),
    [anon_sym_LT_LT_EQ] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(9608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_CARET_EQ] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_EQ] = ACTIONS(9606),
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_then] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9606),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_EQ_GT] = ACTIONS(9608),
    [anon_sym_when] = ACTIONS(9608),
    [anon_sym_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_PLUS_EQ] = ACTIONS(9608),
    [anon_sym_STAR_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym___END__] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9606),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_end] = ACTIONS(9608),
    [anon_sym_ensure] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_elsif] = ACTIONS(9608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9608),
    [ts_builtin_sym_end] = ACTIONS(9608),
    [anon_sym_DASH_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9606),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_AMP_AMP] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9606),
  },
  [6944] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9455),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14037),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6945] = {
    [sym_when] = STATE(9458),
    [sym_else] = STATE(9457),
    [aux_sym_case_repeat2] = STATE(9458),
    [aux_sym_case_repeat1] = STATE(9459),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14039),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(14041),
    [sym_comment] = ACTIONS(49),
  },
  [6946] = {
    [anon_sym_SLASH] = ACTIONS(5744),
    [sym__line_break] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [anon_sym_else] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_then] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_when] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym___END__] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_end] = ACTIONS(5746),
    [anon_sym_ensure] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_elsif] = ACTIONS(5746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5746),
    [ts_builtin_sym_end] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
  },
  [6947] = {
    [anon_sym_end] = ACTIONS(14039),
    [sym_comment] = ACTIONS(49),
  },
  [6948] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(9457),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14039),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [6949] = {
    [sym_when] = STATE(9458),
    [sym_else] = STATE(9457),
    [aux_sym_case_repeat2] = STATE(9458),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14039),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [6950] = {
    [anon_sym_SLASH] = ACTIONS(6680),
    [sym__line_break] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_AMP_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT_EQ] = ACTIONS(6682),
    [anon_sym_SLASH_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6680),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6680),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_PERCENT_EQ] = ACTIONS(6682),
    [anon_sym_LT_LT_EQ] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [anon_sym_else] = ACTIONS(6682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_CARET_EQ] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_then] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6680),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_when] = ACTIONS(6682),
    [anon_sym_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_PLUS_EQ] = ACTIONS(6682),
    [anon_sym_STAR_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym___END__] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6680),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_end] = ACTIONS(6682),
    [anon_sym_ensure] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_elsif] = ACTIONS(6682),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6682),
    [ts_builtin_sym_end] = ACTIONS(6682),
    [anon_sym_DASH_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6680),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [anon_sym_AMP_AMP] = ACTIONS(6680),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6680),
  },
  [6951] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14043),
  },
  [6952] = {
    [aux_sym_string_array_repeat1] = STATE(9463),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14045),
    [sym__string_end] = ACTIONS(14047),
  },
  [6953] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14049),
  },
  [6954] = {
    [anon_sym_SLASH] = ACTIONS(6692),
    [sym__line_break] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_AMP_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT_EQ] = ACTIONS(6694),
    [anon_sym_SLASH_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_PERCENT_EQ] = ACTIONS(6694),
    [anon_sym_LT_LT_EQ] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [anon_sym_else] = ACTIONS(6694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_CARET_EQ] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_then] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_when] = ACTIONS(6694),
    [anon_sym_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_PLUS_EQ] = ACTIONS(6694),
    [anon_sym_STAR_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym___END__] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_end] = ACTIONS(6694),
    [anon_sym_ensure] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_elsif] = ACTIONS(6694),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6694),
    [ts_builtin_sym_end] = ACTIONS(6694),
    [anon_sym_DASH_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6692),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [anon_sym_AMP_AMP] = ACTIONS(6692),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6692),
  },
  [6955] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14051),
    [sym__string_end] = ACTIONS(14049),
  },
  [6956] = {
    [anon_sym_SLASH] = ACTIONS(5626),
    [sym__line_break] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_then] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym___END__] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_ensure] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_elsif] = ACTIONS(5628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5628),
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5626),
  },
  [6957] = {
    [anon_sym_SLASH] = ACTIONS(5972),
    [sym__line_break] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5972),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [anon_sym_else] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_then] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_when] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5972),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_end] = ACTIONS(5974),
    [anon_sym_ensure] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_elsif] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5972),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_AMP_AMP] = ACTIONS(5972),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5972),
  },
  [6958] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(9467),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14053),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [6959] = {
    [sym_else] = STATE(9467),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(14055),
    [sym_comment] = ACTIONS(49),
  },
  [6960] = {
    [sym_heredoc_body] = STATE(9468),
    [sym__terminator] = STATE(9468),
    [sym__line_break] = ACTIONS(14057),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(14057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [6961] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9469),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14059),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6962] = {
    [sym_heredoc_body] = STATE(9470),
    [sym__terminator] = STATE(9470),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(14061),
    [anon_sym_SEMI] = ACTIONS(14061),
    [sym_comment] = ACTIONS(49),
  },
  [6963] = {
    [anon_sym_SLASH] = ACTIONS(6075),
    [sym__line_break] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_AMP_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT_EQ] = ACTIONS(6077),
    [anon_sym_SLASH_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6075),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_PERCENT_EQ] = ACTIONS(6077),
    [anon_sym_LT_LT_EQ] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [anon_sym_else] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_CARET_EQ] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_then] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6075),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_when] = ACTIONS(6077),
    [anon_sym_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_PLUS_EQ] = ACTIONS(6077),
    [anon_sym_STAR_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym___END__] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_end] = ACTIONS(6077),
    [anon_sym_ensure] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_elsif] = ACTIONS(6077),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6077),
    [ts_builtin_sym_end] = ACTIONS(6077),
    [anon_sym_DASH_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6075),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6075),
  },
  [6964] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9471),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14063),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6965] = {
    [anon_sym_SLASH] = ACTIONS(6443),
    [sym__line_break] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_AMP_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT_EQ] = ACTIONS(6445),
    [anon_sym_SLASH_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6443),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_PERCENT_EQ] = ACTIONS(6445),
    [anon_sym_LT_LT_EQ] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [anon_sym_else] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_CARET_EQ] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(6443),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_then] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6443),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_when] = ACTIONS(6445),
    [anon_sym_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_PLUS_EQ] = ACTIONS(6445),
    [anon_sym_STAR_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym___END__] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_end] = ACTIONS(6445),
    [anon_sym_ensure] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_elsif] = ACTIONS(6445),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6445),
    [ts_builtin_sym_end] = ACTIONS(6445),
    [anon_sym_DASH_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6443),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [anon_sym_AMP_AMP] = ACTIONS(6443),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6443),
  },
  [6966] = {
    [anon_sym_end] = ACTIONS(14065),
    [sym_comment] = ACTIONS(49),
  },
  [6967] = {
    [sym_ensure] = STATE(9473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14065),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [6968] = {
    [anon_sym_SLASH] = ACTIONS(6471),
    [sym__line_break] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_AMP_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT_EQ] = ACTIONS(6473),
    [anon_sym_SLASH_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6471),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6471),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6471),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_PERCENT_EQ] = ACTIONS(6473),
    [anon_sym_LT_LT_EQ] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [anon_sym_else] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_CARET_EQ] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_EQ] = ACTIONS(6471),
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_then] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6471),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_when] = ACTIONS(6473),
    [anon_sym_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_PLUS_EQ] = ACTIONS(6473),
    [anon_sym_STAR_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym___END__] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_end] = ACTIONS(6473),
    [anon_sym_ensure] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_elsif] = ACTIONS(6473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6473),
    [ts_builtin_sym_end] = ACTIONS(6473),
    [anon_sym_DASH_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6471),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6471),
  },
  [6969] = {
    [sym_ensure] = STATE(9473),
    [sym_else] = STATE(9474),
    [anon_sym_end] = ACTIONS(14065),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [6970] = {
    [anon_sym_SLASH] = ACTIONS(6071),
    [sym__line_break] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_AMP_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT_EQ] = ACTIONS(6073),
    [anon_sym_SLASH_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6071),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_PERCENT_EQ] = ACTIONS(6073),
    [anon_sym_LT_LT_EQ] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [anon_sym_else] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_CARET_EQ] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_then] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_when] = ACTIONS(6073),
    [anon_sym_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_PLUS_EQ] = ACTIONS(6073),
    [anon_sym_STAR_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym___END__] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_end] = ACTIONS(6073),
    [anon_sym_ensure] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_elsif] = ACTIONS(6073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6073),
    [ts_builtin_sym_end] = ACTIONS(6073),
    [anon_sym_DASH_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6071),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6071),
  },
  [6971] = {
    [anon_sym_SLASH] = ACTIONS(3850),
    [sym__line_break] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_AMP_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT_EQ] = ACTIONS(3852),
    [anon_sym_SLASH_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3850),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3850),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_PERCENT_EQ] = ACTIONS(3852),
    [anon_sym_LT_LT_EQ] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [anon_sym_else] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_CARET_EQ] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_then] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_when] = ACTIONS(3852),
    [anon_sym_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_PLUS_EQ] = ACTIONS(3852),
    [anon_sym_STAR_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym___END__] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3850),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_end] = ACTIONS(3852),
    [anon_sym_ensure] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_elsif] = ACTIONS(3852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_DASH_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3850),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3850),
  },
  [6972] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14067),
  },
  [6973] = {
    [aux_sym_symbol_array_repeat1] = STATE(9478),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14069),
    [sym__string_end] = ACTIONS(14071),
  },
  [6974] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14073),
  },
  [6975] = {
    [anon_sym_SLASH] = ACTIONS(4054),
    [sym__line_break] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_AMP_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT_EQ] = ACTIONS(4056),
    [anon_sym_SLASH_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_PERCENT_EQ] = ACTIONS(4056),
    [anon_sym_LT_LT_EQ] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [anon_sym_else] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_CARET_EQ] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_then] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_when] = ACTIONS(4056),
    [anon_sym_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4056),
    [anon_sym_STAR_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym___END__] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_end] = ACTIONS(4056),
    [anon_sym_ensure] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_elsif] = ACTIONS(4056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4056),
    [ts_builtin_sym_end] = ACTIONS(4056),
    [anon_sym_DASH_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4054),
  },
  [6976] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14075),
    [sym__string_end] = ACTIONS(14073),
  },
  [6977] = {
    [anon_sym_SLASH] = ACTIONS(4424),
    [sym__line_break] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_AMP_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT_EQ] = ACTIONS(4426),
    [anon_sym_SLASH_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_PERCENT_EQ] = ACTIONS(4426),
    [anon_sym_LT_LT_EQ] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [anon_sym_else] = ACTIONS(4426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_CARET_EQ] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_EQ] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_then] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4424),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4426),
    [anon_sym_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_PLUS_EQ] = ACTIONS(4426),
    [anon_sym_STAR_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym___END__] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_end] = ACTIONS(4426),
    [anon_sym_ensure] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_elsif] = ACTIONS(4426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4426),
    [ts_builtin_sym_end] = ACTIONS(4426),
    [anon_sym_DASH_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4424),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4424),
  },
  [6978] = {
    [anon_sym_SLASH] = ACTIONS(4698),
    [sym__line_break] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_AMP_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT_EQ] = ACTIONS(4700),
    [anon_sym_SLASH_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4698),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4698),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4698),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_PERCENT_EQ] = ACTIONS(4700),
    [anon_sym_LT_LT_EQ] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [anon_sym_else] = ACTIONS(4700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_CARET_EQ] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_EQ] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_then] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4698),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_when] = ACTIONS(4700),
    [anon_sym_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_PLUS_EQ] = ACTIONS(4700),
    [anon_sym_STAR_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym___END__] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4698),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_end] = ACTIONS(4700),
    [anon_sym_ensure] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_elsif] = ACTIONS(4700),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4700),
    [ts_builtin_sym_end] = ACTIONS(4700),
    [anon_sym_DASH_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4698),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [anon_sym_AMP_AMP] = ACTIONS(4698),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4698),
  },
  [6979] = {
    [anon_sym_RBRACE] = ACTIONS(14077),
    [sym_comment] = ACTIONS(49),
  },
  [6980] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9483),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14079),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [6981] = {
    [sym__terminator] = STATE(9484),
    [sym_heredoc_body] = STATE(9484),
    [sym__do] = STATE(9484),
    [anon_sym_do] = ACTIONS(14081),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(14081),
    [anon_sym_SEMI] = ACTIONS(14081),
    [sym_comment] = ACTIONS(49),
  },
  [6982] = {
    [anon_sym_SLASH] = ACTIONS(4766),
    [sym__line_break] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_else] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_then] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_when] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym___END__] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_ensure] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_elsif] = ACTIONS(4768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4768),
    [ts_builtin_sym_end] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4766),
  },
  [6983] = {
    [anon_sym_SLASH] = ACTIONS(6630),
    [sym__line_break] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_AMP_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6632),
    [anon_sym_SLASH_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [anon_sym_else] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_CARET_EQ] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_EQ] = ACTIONS(6630),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_then] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_when] = ACTIONS(6632),
    [anon_sym_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_PLUS_EQ] = ACTIONS(6632),
    [anon_sym_STAR_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym___END__] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_end] = ACTIONS(6632),
    [anon_sym_ensure] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_elsif] = ACTIONS(6632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6632),
    [ts_builtin_sym_end] = ACTIONS(6632),
    [anon_sym_DASH_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6630),
  },
  [6984] = {
    [anon_sym_SLASH] = ACTIONS(5236),
    [sym__line_break] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_AMP_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT_EQ] = ACTIONS(5238),
    [anon_sym_SLASH_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_PERCENT_EQ] = ACTIONS(5238),
    [anon_sym_LT_LT_EQ] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_else] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_CARET_EQ] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_then] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_when] = ACTIONS(5238),
    [anon_sym_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_PLUS_EQ] = ACTIONS(5238),
    [anon_sym_STAR_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym___END__] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_end] = ACTIONS(5238),
    [anon_sym_ensure] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_elsif] = ACTIONS(5238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5238),
    [ts_builtin_sym_end] = ACTIONS(5238),
    [anon_sym_DASH_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5236),
  },
  [6985] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(14083),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [6986] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9486),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14085),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [6987] = {
    [sym__method_name] = STATE(4115),
    [sym_setter] = STATE(4115),
    [sym_symbol] = STATE(4115),
    [sym_operator] = STATE(4115),
    [sym__method_rest] = STATE(9487),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(14087),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(14087),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(14087),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(14087),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [6988] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(9489),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(9489),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14089),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [6989] = {
    [sym_elsif] = STATE(9489),
    [sym_else] = STATE(9489),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14091),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [6990] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym___END__] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [ts_builtin_sym_end] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [6991] = {
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [6992] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym___END__] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [ts_builtin_sym_end] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [6993] = {
    [aux_sym_exceptions_repeat1] = STATE(9491),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym___END__] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [ts_builtin_sym_end] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [6994] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [6995] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [6996] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [6997] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [6998] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14093),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [6999] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7000] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym___END__] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [ts_builtin_sym_end] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [7001] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7002] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7003] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym___END__] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [ts_builtin_sym_end] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7004] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_else] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_when] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym___END__] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_elsif] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [ts_builtin_sym_end] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [7005] = {
    [aux_sym_chained_string_repeat1] = STATE(7005),
    [sym_string] = STATE(7005),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym___END__] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [ts_builtin_sym_end] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [7006] = {
    [anon_sym_SLASH] = ACTIONS(9897),
    [sym__line_break] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_AMP_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT_EQ] = ACTIONS(9899),
    [anon_sym_SLASH_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9897),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9897),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9897),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_PERCENT_EQ] = ACTIONS(9899),
    [anon_sym_LT_LT_EQ] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_else] = ACTIONS(9899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_CARET_EQ] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_EQ] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_then] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9897),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_EQ_GT] = ACTIONS(9899),
    [anon_sym_when] = ACTIONS(9899),
    [anon_sym_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_PLUS_EQ] = ACTIONS(9899),
    [anon_sym_STAR_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym___END__] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9897),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_end] = ACTIONS(9899),
    [anon_sym_ensure] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_elsif] = ACTIONS(9899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9899),
    [ts_builtin_sym_end] = ACTIONS(9899),
    [anon_sym_DASH_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9897),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_AMP_AMP] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9897),
  },
  [7007] = {
    [anon_sym_end] = ACTIONS(14098),
    [sym_comment] = ACTIONS(49),
  },
  [7008] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(9494),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14098),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [7009] = {
    [sym_when] = STATE(9495),
    [sym_else] = STATE(9494),
    [aux_sym_case_repeat2] = STATE(9495),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14098),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [7010] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9496),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14100),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7011] = {
    [anon_sym_SLASH] = ACTIONS(10206),
    [sym__line_break] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_AMP_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT_EQ] = ACTIONS(10208),
    [anon_sym_SLASH_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10206),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10206),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10206),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_PERCENT_EQ] = ACTIONS(10208),
    [anon_sym_LT_LT_EQ] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_else] = ACTIONS(10208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_CARET_EQ] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_then] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10206),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_EQ_GT] = ACTIONS(10208),
    [anon_sym_when] = ACTIONS(10208),
    [anon_sym_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_PLUS_EQ] = ACTIONS(10208),
    [anon_sym_STAR_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym___END__] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10206),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_end] = ACTIONS(10208),
    [anon_sym_ensure] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_elsif] = ACTIONS(10208),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10208),
    [ts_builtin_sym_end] = ACTIONS(10208),
    [anon_sym_DASH_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10206),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10206),
  },
  [7012] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(1748),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(1749),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9497),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(1752),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(1753),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14102),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7013] = {
    [anon_sym_SLASH] = ACTIONS(10258),
    [sym__line_break] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_AMP_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT_EQ] = ACTIONS(10260),
    [anon_sym_SLASH_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10258),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10258),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10258),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_PERCENT_EQ] = ACTIONS(10260),
    [anon_sym_LT_LT_EQ] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_else] = ACTIONS(10260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_CARET_EQ] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_EQ] = ACTIONS(10258),
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_then] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10258),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_EQ_GT] = ACTIONS(10260),
    [anon_sym_when] = ACTIONS(10260),
    [anon_sym_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_PLUS_EQ] = ACTIONS(10260),
    [anon_sym_STAR_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym___END__] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10258),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_end] = ACTIONS(10260),
    [anon_sym_ensure] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_elsif] = ACTIONS(10260),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10260),
    [ts_builtin_sym_end] = ACTIONS(10260),
    [anon_sym_DASH_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10258),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_AMP_AMP] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10258),
  },
  [7014] = {
    [anon_sym_SLASH] = ACTIONS(10697),
    [sym__line_break] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_AMP_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT_EQ] = ACTIONS(10699),
    [anon_sym_SLASH_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10697),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10697),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10697),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_PERCENT_EQ] = ACTIONS(10699),
    [anon_sym_LT_LT_EQ] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_else] = ACTIONS(10699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_CARET_EQ] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_EQ] = ACTIONS(10697),
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_then] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10697),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_EQ_GT] = ACTIONS(10699),
    [anon_sym_when] = ACTIONS(10699),
    [anon_sym_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_PLUS_EQ] = ACTIONS(10699),
    [anon_sym_STAR_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym___END__] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10697),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_end] = ACTIONS(10699),
    [anon_sym_ensure] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_elsif] = ACTIONS(10699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10699),
    [ts_builtin_sym_end] = ACTIONS(10699),
    [anon_sym_DASH_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10697),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_AMP_AMP] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10697),
  },
  [7015] = {
    [anon_sym_end] = ACTIONS(14104),
    [sym_comment] = ACTIONS(49),
  },
  [7016] = {
    [sym_ensure] = STATE(9499),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14104),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [7017] = {
    [anon_sym_SLASH] = ACTIONS(10925),
    [sym__line_break] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10925),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10925),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10925),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_EQ] = ACTIONS(10925),
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10925),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10925),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10925),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10925),
  },
  [7018] = {
    [anon_sym_end] = ACTIONS(14106),
    [sym_comment] = ACTIONS(49),
  },
  [7019] = {
    [anon_sym_SLASH] = ACTIONS(10931),
    [sym__line_break] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_AMP_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT_EQ] = ACTIONS(10933),
    [anon_sym_SLASH_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_PERCENT_EQ] = ACTIONS(10933),
    [anon_sym_LT_LT_EQ] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_else] = ACTIONS(10933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_CARET_EQ] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_EQ] = ACTIONS(10931),
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_then] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10933),
    [anon_sym_when] = ACTIONS(10933),
    [anon_sym_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_PLUS_EQ] = ACTIONS(10933),
    [anon_sym_STAR_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym___END__] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10933),
    [anon_sym_ensure] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_elsif] = ACTIONS(10933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10933),
    [ts_builtin_sym_end] = ACTIONS(10933),
    [anon_sym_DASH_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10931),
  },
  [7020] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14108),
  },
  [7021] = {
    [anon_sym_SLASH] = ACTIONS(10937),
    [sym__line_break] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_AMP_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT_EQ] = ACTIONS(10939),
    [anon_sym_SLASH_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10937),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10937),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10937),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_PERCENT_EQ] = ACTIONS(10939),
    [anon_sym_LT_LT_EQ] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_else] = ACTIONS(10939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_CARET_EQ] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_EQ] = ACTIONS(10937),
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_then] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10937),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_EQ_GT] = ACTIONS(10939),
    [anon_sym_when] = ACTIONS(10939),
    [anon_sym_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_PLUS_EQ] = ACTIONS(10939),
    [anon_sym_STAR_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym___END__] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10937),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_end] = ACTIONS(10939),
    [anon_sym_ensure] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_elsif] = ACTIONS(10939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10939),
    [ts_builtin_sym_end] = ACTIONS(10939),
    [anon_sym_DASH_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10937),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_AMP_AMP] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10937),
  },
  [7022] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14110),
    [sym__string_end] = ACTIONS(14108),
  },
  [7023] = {
    [anon_sym_SLASH] = ACTIONS(10943),
    [sym__line_break] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_AMP_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT_EQ] = ACTIONS(10945),
    [anon_sym_SLASH_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10943),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10943),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10943),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_PERCENT_EQ] = ACTIONS(10945),
    [anon_sym_LT_LT_EQ] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_else] = ACTIONS(10945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_CARET_EQ] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_EQ] = ACTIONS(10943),
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_then] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10943),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_EQ_GT] = ACTIONS(10945),
    [anon_sym_when] = ACTIONS(10945),
    [anon_sym_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_PLUS_EQ] = ACTIONS(10945),
    [anon_sym_STAR_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym___END__] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10943),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_end] = ACTIONS(10945),
    [anon_sym_ensure] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_elsif] = ACTIONS(10945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10945),
    [ts_builtin_sym_end] = ACTIONS(10945),
    [anon_sym_DASH_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_AMP_AMP] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10943),
  },
  [7024] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14112),
  },
  [7025] = {
    [sym_assignment] = STATE(4163),
    [sym_unary] = STATE(4163),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(4163),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(4163),
    [sym_conditional] = STATE(4163),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_return] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_true] = STATE(457),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(4163),
    [sym_binary] = STATE(4163),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(2293),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [sym_global_variable] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(801),
    [sym_character] = ACTIONS(803),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [7026] = {
    [aux_sym_exceptions_repeat1] = STATE(9505),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14114),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym___END__] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [ts_builtin_sym_end] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [7027] = {
    [anon_sym_SLASH] = ACTIONS(10412),
    [sym__line_break] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_AMP_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8575),
    [anon_sym_SLASH_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(10412),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(10412),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(10412),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_PERCENT_EQ] = ACTIONS(8575),
    [anon_sym_LT_LT_EQ] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_CARET_EQ] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_EQ] = ACTIONS(10412),
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_then] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_when] = ACTIONS(8575),
    [anon_sym_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_PLUS_EQ] = ACTIONS(8575),
    [anon_sym_STAR_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym___END__] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(10412),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(8575),
    [anon_sym_ensure] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_elsif] = ACTIONS(8575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8575),
    [ts_builtin_sym_end] = ACTIONS(8575),
    [anon_sym_DASH_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(10412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_AMP_AMP] = ACTIONS(10412),
    [sym__binary_minus] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(10412),
  },
  [7028] = {
    [anon_sym_SLASH] = ACTIONS(13245),
    [sym__line_break] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_AMP_EQ] = ACTIONS(12375),
    [anon_sym_GT_GT_EQ] = ACTIONS(12375),
    [anon_sym_SLASH_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(13245),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_PLUS] = ACTIONS(13245),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_PERCENT] = ACTIONS(13245),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_PERCENT_EQ] = ACTIONS(12375),
    [anon_sym_LT_LT_EQ] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_else] = ACTIONS(12375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_CARET_EQ] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_EQ] = ACTIONS(13245),
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_then] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(13245),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_when] = ACTIONS(12375),
    [anon_sym_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_PLUS_EQ] = ACTIONS(12375),
    [anon_sym_STAR_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym___END__] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(13245),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_end] = ACTIONS(12375),
    [anon_sym_ensure] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_elsif] = ACTIONS(12375),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12375),
    [ts_builtin_sym_end] = ACTIONS(12375),
    [anon_sym_DASH_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(13245),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_AMP_AMP] = ACTIONS(13245),
    [sym__binary_minus] = ACTIONS(12375),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(13245),
  },
  [7029] = {
    [sym_assignment] = STATE(9506),
    [sym_unary] = STATE(9506),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(457),
    [sym_singleton_class] = STATE(452),
    [sym_module] = STATE(452),
    [sym_chained_string] = STATE(452),
    [sym_until] = STATE(452),
    [sym_regex] = STATE(452),
    [sym_for] = STATE(452),
    [sym_symbol] = STATE(452),
    [sym_if] = STATE(452),
    [sym_begin] = STATE(452),
    [sym__arg] = STATE(9506),
    [sym__primary] = STATE(452),
    [sym_method_call] = STATE(457),
    [sym_operator_assignment] = STATE(9506),
    [sym_conditional] = STATE(9506),
    [sym_method] = STATE(452),
    [sym_singleton_method] = STATE(452),
    [sym__variable] = STATE(455),
    [sym_left_assignment_list] = STATE(454),
    [sym_rational] = STATE(452),
    [sym_true] = STATE(457),
    [sym_return] = STATE(452),
    [sym_subshell] = STATE(452),
    [sym_yield] = STATE(452),
    [sym_string] = STATE(1650),
    [sym_unless] = STATE(452),
    [sym_lambda] = STATE(452),
    [sym_parenthesized_statements] = STATE(452),
    [sym_element_reference] = STATE(457),
    [sym_range] = STATE(9506),
    [sym_binary] = STATE(9506),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(452),
    [sym_break] = STATE(452),
    [sym_next] = STATE(452),
    [sym_string_array] = STATE(452),
    [sym_while] = STATE(452),
    [sym_case] = STATE(452),
    [sym_symbol_array] = STATE(452),
    [sym_array] = STATE(452),
    [sym_hash] = STATE(452),
    [sym_false] = STATE(457),
    [sym_nil] = STATE(457),
    [sym_scope_resolution] = STATE(455),
    [sym_call] = STATE(455),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(795),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(833),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_not] = ACTIONS(837),
    [sym_self] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(803),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(817),
    [sym_character] = ACTIONS(803),
    [sym_super] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(859),
    [anon_sym_next] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(795),
    [sym_constant] = ACTIONS(801),
    [anon_sym_defined_QMARK] = ACTIONS(819),
    [sym_instance_variable] = ACTIONS(817),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2113),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(801),
    [sym_redo] = ACTIONS(795),
    [sym_class_variable] = ACTIONS(817),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(799),
  },
  [7030] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(9508),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(14116),
  },
  [7031] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [7032] = {
    [aux_sym_chained_string_repeat1] = STATE(7087),
    [sym_string] = STATE(7087),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(11152),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [7033] = {
    [sym_assignment] = STATE(9509),
    [sym_unary] = STATE(9509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(9509),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(9509),
    [sym_conditional] = STATE(9509),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(9509),
    [sym_binary] = STATE(9509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [7034] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [7035] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_COLON2] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [7036] = {
    [sym_assignment] = STATE(9510),
    [sym_unary] = STATE(9510),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(9510),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(9510),
    [sym_conditional] = STATE(9510),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(9510),
    [sym_binary] = STATE(9510),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [7037] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(14118),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7038] = {
    [anon_sym_COLON] = ACTIONS(14120),
    [sym_comment] = ACTIONS(49),
  },
  [7039] = {
    [sym_assignment] = STATE(9513),
    [sym_unary] = STATE(9513),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9513),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9513),
    [sym_conditional] = STATE(9513),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9513),
    [sym_binary] = STATE(9513),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7040] = {
    [sym_assignment] = STATE(9514),
    [sym_unary] = STATE(9514),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9514),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9514),
    [sym_conditional] = STATE(9514),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9514),
    [sym_binary] = STATE(9514),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7041] = {
    [sym_assignment] = STATE(9515),
    [sym_unary] = STATE(9515),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9515),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9515),
    [sym_conditional] = STATE(9515),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9515),
    [sym_binary] = STATE(9515),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7042] = {
    [sym_heredoc_body] = STATE(9517),
    [aux_sym_call_repeat1] = STATE(9517),
    [aux_sym_argument_list_repeat1] = STATE(9518),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [7043] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_COLON2] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [7044] = {
    [aux_sym_chained_string_repeat1] = STATE(7087),
    [sym_string] = STATE(7087),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14124),
    [sym__string_start] = ACTIONS(11152),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [7045] = {
    [sym_heredoc_body] = STATE(9517),
    [aux_sym_call_repeat1] = STATE(9517),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [7046] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [7047] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [7048] = {
    [sym_assignment] = STATE(9521),
    [sym_unary] = STATE(9521),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(9521),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(9521),
    [sym_conditional] = STATE(9521),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(9521),
    [sym_binary] = STATE(9521),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [7049] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [7050] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [7051] = {
    [sym_assignment] = STATE(9522),
    [sym_unary] = STATE(9522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(9522),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(9522),
    [sym_conditional] = STATE(9522),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(9522),
    [sym_binary] = STATE(9522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [7052] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(14126),
    [sym_identifier] = ACTIONS(14126),
  },
  [7053] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [7054] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(14128),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14128),
    [anon_sym_SLASH_EQ] = ACTIONS(14128),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14128),
    [anon_sym_PIPE_EQ] = ACTIONS(14128),
    [anon_sym_LT_LT_EQ] = ACTIONS(14128),
    [anon_sym_PLUS_EQ] = ACTIONS(14128),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14128),
    [anon_sym_STAR_EQ] = ACTIONS(14128),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14128),
    [anon_sym_CARET_EQ] = ACTIONS(14128),
    [anon_sym_DASH_EQ] = ACTIONS(14128),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14128),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14130),
  },
  [7055] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_COLON2] = ACTIONS(5430),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [7056] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(14158),
    [anon_sym_DOT] = ACTIONS(14160),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14162),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [7057] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym__primary] = STATE(4235),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_method] = STATE(4235),
    [sym_conditional] = STATE(4240),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_subshell] = STATE(4235),
    [sym_unless] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4239),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_call] = STATE(4237),
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_rational] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_lambda] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(4240),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_nil] = STATE(4239),
    [sym_symbol_array] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_scope_resolution] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(7089),
    [anon_sym_COLON2] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7058] = {
    [anon_sym_EQ] = ACTIONS(14164),
    [sym_comment] = ACTIONS(3),
  },
  [7059] = {
    [aux_sym_chained_string_repeat1] = STATE(9537),
    [sym_string] = STATE(9537),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [7060] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_COLON2] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [7061] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_COLON2] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [7062] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_heredoc_body] = STATE(9538),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym_float] = ACTIONS(7005),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(7029),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14166),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7063] = {
    [sym_heredoc_body] = STATE(9539),
    [aux_sym_call_repeat1] = STATE(9539),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [7064] = {
    [sym_heredoc_body] = STATE(9540),
    [aux_sym_call_repeat1] = STATE(9540),
    [aux_sym_argument_list_repeat1] = STATE(9541),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11198),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [7065] = {
    [sym_assignment] = STATE(9542),
    [sym_unary] = STATE(9542),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9542),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9542),
    [sym_conditional] = STATE(9542),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9542),
    [sym_binary] = STATE(9542),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7066] = {
    [sym_assignment] = STATE(9543),
    [sym_unary] = STATE(9543),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9543),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9544),
    [sym_operator_assignment] = STATE(9543),
    [sym_conditional] = STATE(9543),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_subshell] = STATE(4200),
    [sym__arg_or_splat_arg] = STATE(9544),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9543),
    [sym_binary] = STATE(9543),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(7009),
    [sym_character] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7067] = {
    [sym_assignment] = STATE(9545),
    [sym_unary] = STATE(9545),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9545),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9545),
    [sym_conditional] = STATE(9545),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9545),
    [sym_binary] = STATE(9545),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7068] = {
    [sym_assignment] = STATE(9546),
    [sym_unary] = STATE(9546),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9546),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9546),
    [sym_conditional] = STATE(9546),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9546),
    [sym_binary] = STATE(9546),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7069] = {
    [sym_assignment] = STATE(9547),
    [sym_unary] = STATE(9547),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9547),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9547),
    [sym_conditional] = STATE(9547),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9547),
    [sym_binary] = STATE(9547),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7070] = {
    [sym_assignment] = STATE(9548),
    [sym_unary] = STATE(9548),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9548),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9548),
    [sym_conditional] = STATE(9548),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9548),
    [sym_binary] = STATE(9548),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7071] = {
    [sym_assignment] = STATE(9549),
    [sym_unary] = STATE(9549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9549),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9549),
    [sym_conditional] = STATE(9549),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9549),
    [sym_binary] = STATE(9549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7072] = {
    [sym_assignment] = STATE(9550),
    [sym_unary] = STATE(9550),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9550),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9550),
    [sym_conditional] = STATE(9550),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9550),
    [sym_binary] = STATE(9550),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7073] = {
    [sym_assignment] = STATE(9552),
    [sym_unary] = STATE(9552),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9552),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9552),
    [sym_conditional] = STATE(9552),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9552),
    [sym_binary] = STATE(9552),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7074] = {
    [sym_assignment] = STATE(9553),
    [sym_unary] = STATE(9553),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9553),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9553),
    [sym_conditional] = STATE(9553),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9553),
    [sym_binary] = STATE(9553),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7075] = {
    [sym_assignment] = STATE(9554),
    [sym_unary] = STATE(9554),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9554),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(9554),
    [sym_conditional] = STATE(9554),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9554),
    [sym_binary] = STATE(9554),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [7076] = {
    [sym_heredoc_body] = STATE(9559),
    [sym__argument_list_with_parens] = STATE(9558),
    [aux_sym_call_repeat1] = STATE(9559),
    [sym_argument_list_with_parens] = STATE(9557),
    [sym_operator] = STATE(9557),
    [anon_sym_LT] = ACTIONS(14168),
    [anon_sym_SLASH] = ACTIONS(14170),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14170),
    [anon_sym_PLUS_AT] = ACTIONS(14170),
    [anon_sym_LPAREN2] = ACTIONS(14172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14170),
    [anon_sym_GT_GT] = ACTIONS(14170),
    [anon_sym_EQ_TILDE] = ACTIONS(14170),
    [anon_sym_LT_LT] = ACTIONS(14170),
    [anon_sym_TILDE] = ACTIONS(14170),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_AMP] = ACTIONS(14170),
    [anon_sym_GT] = ACTIONS(14168),
    [anon_sym_PERCENT] = ACTIONS(14170),
    [anon_sym_DASH_AT] = ACTIONS(14170),
    [anon_sym_EQ_EQ] = ACTIONS(14168),
    [anon_sym_STAR] = ACTIONS(14168),
    [anon_sym_BANG_TILDE] = ACTIONS(14170),
    [sym_constant] = ACTIONS(14174),
    [anon_sym_DASH] = ACTIONS(14168),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14170),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14170),
    [anon_sym_STAR_STAR] = ACTIONS(14170),
    [anon_sym_PIPE] = ACTIONS(14170),
    [anon_sym_DOT_DOT] = ACTIONS(14170),
    [anon_sym_LT_EQ_GT] = ACTIONS(14170),
    [anon_sym_LT_EQ] = ACTIONS(14168),
    [anon_sym_BANG] = ACTIONS(14168),
    [sym_identifier] = ACTIONS(14174),
    [anon_sym_CARET] = ACTIONS(14170),
  },
  [7077] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(14176),
    [sym_identifier] = ACTIONS(14176),
  },
  [7078] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(14178),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7079] = {
    [anon_sym_COLON] = ACTIONS(14180),
    [sym_comment] = ACTIONS(49),
  },
  [7080] = {
    [sym_assignment] = STATE(9563),
    [sym_unary] = STATE(9563),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9563),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9563),
    [sym_conditional] = STATE(9563),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9563),
    [sym_binary] = STATE(9563),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7081] = {
    [sym_assignment] = STATE(9564),
    [sym_unary] = STATE(9564),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9564),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9564),
    [sym_conditional] = STATE(9564),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9564),
    [sym_binary] = STATE(9564),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7082] = {
    [sym_assignment] = STATE(9565),
    [sym_unary] = STATE(9565),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9565),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9565),
    [sym_conditional] = STATE(9565),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9565),
    [sym_binary] = STATE(9565),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7083] = {
    [sym_heredoc_body] = STATE(9567),
    [aux_sym_call_repeat1] = STATE(9567),
    [aux_sym_argument_list_repeat1] = STATE(9568),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14182),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7084] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_COLON2] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [7085] = {
    [aux_sym_chained_string_repeat1] = STATE(7154),
    [sym_string] = STATE(7154),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14184),
    [sym__string_start] = ACTIONS(11280),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7086] = {
    [sym_heredoc_body] = STATE(9567),
    [aux_sym_call_repeat1] = STATE(9567),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7087] = {
    [aux_sym_chained_string_repeat1] = STATE(9569),
    [sym_string] = STATE(9569),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(11152),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [7088] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7089] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [7090] = {
    [sym_assignment] = STATE(9570),
    [sym_unary] = STATE(9570),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9570),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(9570),
    [sym_conditional] = STATE(9570),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(9570),
    [sym_binary] = STATE(9570),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [7091] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [7092] = {
    [sym_assignment] = STATE(9571),
    [sym_unary] = STATE(9571),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9571),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(9571),
    [sym_conditional] = STATE(9571),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(9571),
    [sym_binary] = STATE(9571),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [7093] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [7094] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [7095] = {
    [sym_assignment] = STATE(9572),
    [sym_unary] = STATE(9572),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9572),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(9572),
    [sym_conditional] = STATE(9572),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(9572),
    [sym_binary] = STATE(9572),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [7096] = {
    [sym__argument] = STATE(9519),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9519),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9519),
    [sym_hash_splat_argument] = STATE(9519),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym__argument_list_with_parens] = STATE(9520),
    [sym_block_argument] = STATE(9519),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(7005),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7029),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7039),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [7097] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(14186),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14186),
    [anon_sym_SLASH_EQ] = ACTIONS(14186),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14186),
    [anon_sym_PIPE_EQ] = ACTIONS(14186),
    [anon_sym_LT_LT_EQ] = ACTIONS(14186),
    [anon_sym_PLUS_EQ] = ACTIONS(14186),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14186),
    [anon_sym_STAR_EQ] = ACTIONS(14186),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14186),
    [anon_sym_CARET_EQ] = ACTIONS(14186),
    [anon_sym_DASH_EQ] = ACTIONS(14186),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14186),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14188),
  },
  [7098] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_COLON2] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [7099] = {
    [anon_sym_EQ] = ACTIONS(14216),
    [sym_comment] = ACTIONS(3),
  },
  [7100] = {
    [aux_sym_chained_string_repeat1] = STATE(9584),
    [sym_string] = STATE(9584),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [7101] = {
    [aux_sym_exceptions_repeat1] = STATE(9586),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(14218),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [7102] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7103] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7104] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14220),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7105] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7106] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7107] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7108] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7109] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7110] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7111] = {
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(877),
    [sym__binary_star] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_STAR_STAR] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(901),
    [sym__binary_minus] = ACTIONS(889),
  },
  [7112] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7113] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_COLON2] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [7114] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9589),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14224),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [7115] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_COLON2] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [7116] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_COLON2] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [7117] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(7116),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9590),
    [sym_operator] = STATE(9590),
    [anon_sym_LT] = ACTIONS(11268),
    [anon_sym_SLASH] = ACTIONS(11270),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11270),
    [anon_sym_PLUS_AT] = ACTIONS(11270),
    [anon_sym_LPAREN2] = ACTIONS(11272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11270),
    [anon_sym_GT_GT] = ACTIONS(11270),
    [anon_sym_EQ_TILDE] = ACTIONS(11270),
    [anon_sym_LT_LT] = ACTIONS(11270),
    [anon_sym_TILDE] = ACTIONS(11270),
    [anon_sym_PLUS] = ACTIONS(11268),
    [anon_sym_AMP] = ACTIONS(11270),
    [anon_sym_GT] = ACTIONS(11268),
    [anon_sym_PERCENT] = ACTIONS(11270),
    [anon_sym_DASH_AT] = ACTIONS(11270),
    [anon_sym_EQ_EQ] = ACTIONS(11268),
    [anon_sym_STAR] = ACTIONS(11268),
    [anon_sym_BANG_TILDE] = ACTIONS(11270),
    [sym_constant] = ACTIONS(14226),
    [anon_sym_DASH] = ACTIONS(11268),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11270),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11268),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11270),
    [anon_sym_STAR_STAR] = ACTIONS(11270),
    [anon_sym_PIPE] = ACTIONS(11270),
    [anon_sym_DOT_DOT] = ACTIONS(11270),
    [anon_sym_LT_EQ_GT] = ACTIONS(11270),
    [anon_sym_LT_EQ] = ACTIONS(11268),
    [anon_sym_BANG] = ACTIONS(11268),
    [sym_identifier] = ACTIONS(14226),
    [anon_sym_CARET] = ACTIONS(11270),
  },
  [7118] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_COLON2] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [7119] = {
    [sym_interpolation] = STATE(203),
    [sym__literal_contents] = STATE(9592),
    [aux_sym__literal_contents_repeat1] = STATE(203),
    [sym_escape_sequence] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(385),
    [sym__string_content] = ACTIONS(383),
    [sym__string_end] = ACTIONS(14228),
  },
  [7120] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7121] = {
    [aux_sym_chained_string_repeat1] = STATE(7154),
    [sym_string] = STATE(7154),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(11280),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7122] = {
    [sym_assignment] = STATE(9593),
    [sym_unary] = STATE(9593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(9593),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(9593),
    [sym_conditional] = STATE(9593),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(9593),
    [sym_binary] = STATE(9593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [7123] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [7124] = {
    [sym_assignment] = STATE(9594),
    [sym_unary] = STATE(9594),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(9594),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(9594),
    [sym_conditional] = STATE(9594),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(9594),
    [sym_binary] = STATE(9594),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [7125] = {
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_COLON2] = ACTIONS(753),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7126] = {
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_COLON2] = ACTIONS(647),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7127] = {
    [sym_assignment] = STATE(9595),
    [sym_unary] = STATE(9595),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(9595),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(9595),
    [sym_conditional] = STATE(9595),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(9595),
    [sym_binary] = STATE(9595),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [7128] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [7129] = {
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_COLON2] = ACTIONS(737),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7130] = {
    [sym_assignment] = STATE(9596),
    [sym_unary] = STATE(9596),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(9596),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(9596),
    [sym_conditional] = STATE(9596),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(9596),
    [sym_binary] = STATE(9596),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [7131] = {
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_COLON2] = ACTIONS(501),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7132] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(14230),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14230),
    [anon_sym_SLASH_EQ] = ACTIONS(14230),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14230),
    [anon_sym_PIPE_EQ] = ACTIONS(14230),
    [anon_sym_LT_LT_EQ] = ACTIONS(14230),
    [anon_sym_PLUS_EQ] = ACTIONS(14230),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14230),
    [anon_sym_STAR_EQ] = ACTIONS(14230),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14230),
    [anon_sym_CARET_EQ] = ACTIONS(14230),
    [anon_sym_DASH_EQ] = ACTIONS(14230),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14230),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(14232),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7133] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_COLON2] = ACTIONS(5430),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [7134] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(14158),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(14160),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(14162),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [7135] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym__primary] = STATE(4235),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(4238),
    [sym_method] = STATE(4235),
    [sym_conditional] = STATE(4240),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_subshell] = STATE(4235),
    [sym_unless] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_block_argument] = STATE(4238),
    [sym_range] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4239),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_call] = STATE(4237),
    [sym__argument] = STATE(4238),
    [sym_assignment] = STATE(4240),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_pair] = STATE(4238),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(4238),
    [sym_operator_assignment] = STATE(4240),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_rational] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_lambda] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym__argument_list_with_parens] = STATE(4242),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(4240),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_nil] = STATE(4239),
    [sym_symbol_array] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_scope_resolution] = STATE(4237),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(7083),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7087),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [anon_sym_COLON2] = ACTIONS(791),
    [sym_character] = ACTIONS(7089),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7021),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7095),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7103),
    [anon_sym_not] = ACTIONS(7105),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7115),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [7136] = {
    [anon_sym_EQ] = ACTIONS(14262),
    [sym_comment] = ACTIONS(3),
  },
  [7137] = {
    [aux_sym_chained_string_repeat1] = STATE(9608),
    [sym_string] = STATE(9608),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7138] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_COLON2] = ACTIONS(5554),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [7139] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_COLON2] = ACTIONS(5570),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [7140] = {
    [sym_assignment] = STATE(9609),
    [sym_unary] = STATE(9609),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9609),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(9610),
    [sym_operator_assignment] = STATE(9609),
    [sym_conditional] = STATE(9609),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_subshell] = STATE(4235),
    [sym__arg_or_splat_arg] = STATE(9610),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9609),
    [sym_binary] = STATE(9609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(7087),
    [sym_character] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7141] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_heredoc_body] = STATE(9611),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym_float] = ACTIONS(7083),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(7087),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7089),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(7095),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [sym_class_variable] = ACTIONS(7095),
    [sym__block_ampersand] = ACTIONS(7103),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(7105),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14264),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7142] = {
    [sym_heredoc_body] = STATE(9612),
    [aux_sym_call_repeat1] = STATE(9612),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7143] = {
    [sym_heredoc_body] = STATE(9613),
    [aux_sym_call_repeat1] = STATE(9613),
    [aux_sym_argument_list_repeat1] = STATE(9614),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11314),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7144] = {
    [sym_assignment] = STATE(9615),
    [sym_unary] = STATE(9615),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9615),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9615),
    [sym_conditional] = STATE(9615),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9615),
    [sym_binary] = STATE(9615),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7145] = {
    [sym_assignment] = STATE(9616),
    [sym_unary] = STATE(9616),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9616),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9616),
    [sym_conditional] = STATE(9616),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9616),
    [sym_binary] = STATE(9616),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7146] = {
    [sym_assignment] = STATE(9617),
    [sym_unary] = STATE(9617),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9617),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9617),
    [sym_conditional] = STATE(9617),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9617),
    [sym_binary] = STATE(9617),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7147] = {
    [sym_assignment] = STATE(9618),
    [sym_unary] = STATE(9618),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9618),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9618),
    [sym_conditional] = STATE(9618),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9618),
    [sym_binary] = STATE(9618),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7148] = {
    [sym_assignment] = STATE(9619),
    [sym_unary] = STATE(9619),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9619),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9619),
    [sym_conditional] = STATE(9619),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9619),
    [sym_binary] = STATE(9619),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7149] = {
    [sym_assignment] = STATE(9620),
    [sym_unary] = STATE(9620),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9620),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9620),
    [sym_conditional] = STATE(9620),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9620),
    [sym_binary] = STATE(9620),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7150] = {
    [sym_assignment] = STATE(9621),
    [sym_unary] = STATE(9621),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9621),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9621),
    [sym_conditional] = STATE(9621),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9621),
    [sym_binary] = STATE(9621),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7151] = {
    [sym_assignment] = STATE(9623),
    [sym_unary] = STATE(9623),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9623),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9623),
    [sym_conditional] = STATE(9623),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9623),
    [sym_binary] = STATE(9623),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7152] = {
    [sym_assignment] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7153] = {
    [sym_assignment] = STATE(9625),
    [sym_unary] = STATE(9625),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9625),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(9625),
    [sym_conditional] = STATE(9625),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9625),
    [sym_binary] = STATE(9625),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [7154] = {
    [aux_sym_chained_string_repeat1] = STATE(9626),
    [sym_string] = STATE(9626),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(11280),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7155] = {
    [aux_sym_chained_string_repeat1] = STATE(7155),
    [sym_string] = STATE(7155),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [7156] = {
    [aux_sym_undef_repeat1] = STATE(9627),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [7157] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7158] = {
    [aux_sym_chained_string_repeat1] = STATE(7210),
    [sym_string] = STATE(7210),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7159] = {
    [sym_assignment] = STATE(9628),
    [sym_unary] = STATE(9628),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9628),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(9628),
    [sym_conditional] = STATE(9628),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(9628),
    [sym_binary] = STATE(9628),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7160] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [7161] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [7162] = {
    [sym_assignment] = STATE(9629),
    [sym_unary] = STATE(9629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9629),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(9629),
    [sym_conditional] = STATE(9629),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(9629),
    [sym_binary] = STATE(9629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7163] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(14266),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7164] = {
    [anon_sym_COLON] = ACTIONS(14268),
    [sym_comment] = ACTIONS(49),
  },
  [7165] = {
    [sym_assignment] = STATE(9632),
    [sym_unary] = STATE(9632),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9632),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9632),
    [sym_conditional] = STATE(9632),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9632),
    [sym_binary] = STATE(9632),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7166] = {
    [sym_assignment] = STATE(9633),
    [sym_unary] = STATE(9633),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9633),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9633),
    [sym_conditional] = STATE(9633),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9633),
    [sym_binary] = STATE(9633),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7167] = {
    [sym_assignment] = STATE(9634),
    [sym_unary] = STATE(9634),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9634),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9634),
    [sym_conditional] = STATE(9634),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9634),
    [sym_binary] = STATE(9634),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7168] = {
    [sym_heredoc_body] = STATE(9636),
    [aux_sym_call_repeat1] = STATE(9636),
    [aux_sym_argument_list_repeat1] = STATE(9637),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14270),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7169] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [7170] = {
    [aux_sym_chained_string_repeat1] = STATE(7210),
    [sym_string] = STATE(7210),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14272),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7171] = {
    [sym_heredoc_body] = STATE(9636),
    [aux_sym_call_repeat1] = STATE(9636),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7172] = {
    [sym__argument] = STATE(9638),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(9638),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(9638),
    [sym_hash_splat_argument] = STATE(9638),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(9639),
    [sym_block_argument] = STATE(9638),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [7173] = {
    [sym__argument] = STATE(9638),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(9638),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(9638),
    [sym_hash_splat_argument] = STATE(9638),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(9639),
    [sym_block_argument] = STATE(9638),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [7174] = {
    [sym_assignment] = STATE(9640),
    [sym_unary] = STATE(9640),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9640),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(9640),
    [sym_conditional] = STATE(9640),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(9640),
    [sym_binary] = STATE(9640),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7175] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7176] = {
    [sym__argument] = STATE(9638),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(9638),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(9638),
    [sym_hash_splat_argument] = STATE(9638),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(9639),
    [sym_block_argument] = STATE(9638),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [7177] = {
    [sym_assignment] = STATE(9641),
    [sym_unary] = STATE(9641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9641),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(9641),
    [sym_conditional] = STATE(9641),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(9641),
    [sym_binary] = STATE(9641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7178] = {
    [sym__argument] = STATE(9638),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(9638),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(9638),
    [sym_hash_splat_argument] = STATE(9638),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym__argument_list_with_parens] = STATE(9639),
    [sym_block_argument] = STATE(9638),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7162),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7164),
    [sym_self] = ACTIONS(7166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7186),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7196),
  },
  [7179] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(14274),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14276),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14276),
    [anon_sym_SLASH_EQ] = ACTIONS(14276),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14276),
    [anon_sym_PIPE_EQ] = ACTIONS(14276),
    [anon_sym_LT_LT_EQ] = ACTIONS(14276),
    [anon_sym_PLUS_EQ] = ACTIONS(14276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14276),
    [anon_sym_STAR_EQ] = ACTIONS(14276),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14276),
    [anon_sym_CARET_EQ] = ACTIONS(14276),
    [anon_sym_DASH_EQ] = ACTIONS(14276),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14276),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7180] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [7181] = {
    [anon_sym_EQ] = ACTIONS(14304),
    [sym_comment] = ACTIONS(3),
  },
  [7182] = {
    [aux_sym_chained_string_repeat1] = STATE(9653),
    [sym_string] = STATE(9653),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7183] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [7184] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [7185] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_heredoc_body] = STATE(9654),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym_float] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7166),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7174),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7186),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14306),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7186] = {
    [sym_heredoc_body] = STATE(9655),
    [aux_sym_call_repeat1] = STATE(9655),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7187] = {
    [sym_heredoc_body] = STATE(9656),
    [aux_sym_call_repeat1] = STATE(9656),
    [aux_sym_argument_list_repeat1] = STATE(9657),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11388),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7188] = {
    [sym_assignment] = STATE(9658),
    [sym_unary] = STATE(9658),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9658),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9658),
    [sym_conditional] = STATE(9658),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9658),
    [sym_binary] = STATE(9658),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7189] = {
    [sym_assignment] = STATE(9659),
    [sym_unary] = STATE(9659),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9659),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(9660),
    [sym_operator_assignment] = STATE(9659),
    [sym_conditional] = STATE(9659),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_subshell] = STATE(4265),
    [sym__arg_or_splat_arg] = STATE(9660),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9659),
    [sym_binary] = STATE(9659),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7166),
    [sym_character] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7190] = {
    [sym_assignment] = STATE(9661),
    [sym_unary] = STATE(9661),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9661),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9661),
    [sym_conditional] = STATE(9661),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9661),
    [sym_binary] = STATE(9661),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7191] = {
    [sym_assignment] = STATE(9662),
    [sym_unary] = STATE(9662),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9662),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9662),
    [sym_conditional] = STATE(9662),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9662),
    [sym_binary] = STATE(9662),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7192] = {
    [sym_assignment] = STATE(9663),
    [sym_unary] = STATE(9663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9663),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9663),
    [sym_conditional] = STATE(9663),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9663),
    [sym_binary] = STATE(9663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7193] = {
    [sym_assignment] = STATE(9664),
    [sym_unary] = STATE(9664),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9664),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9664),
    [sym_conditional] = STATE(9664),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9664),
    [sym_binary] = STATE(9664),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7194] = {
    [sym_assignment] = STATE(9665),
    [sym_unary] = STATE(9665),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9665),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9665),
    [sym_conditional] = STATE(9665),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9665),
    [sym_binary] = STATE(9665),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7195] = {
    [sym_assignment] = STATE(9666),
    [sym_unary] = STATE(9666),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9666),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9666),
    [sym_conditional] = STATE(9666),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9666),
    [sym_binary] = STATE(9666),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7196] = {
    [sym_assignment] = STATE(9668),
    [sym_unary] = STATE(9668),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9668),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9668),
    [sym_conditional] = STATE(9668),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9668),
    [sym_binary] = STATE(9668),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7197] = {
    [sym_assignment] = STATE(9669),
    [sym_unary] = STATE(9669),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9669),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9669),
    [sym_conditional] = STATE(9669),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9669),
    [sym_binary] = STATE(9669),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7198] = {
    [sym_assignment] = STATE(9670),
    [sym_unary] = STATE(9670),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9670),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(9670),
    [sym_conditional] = STATE(9670),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9670),
    [sym_binary] = STATE(9670),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [7199] = {
    [sym_heredoc_body] = STATE(9675),
    [sym__argument_list_with_parens] = STATE(9674),
    [aux_sym_call_repeat1] = STATE(9675),
    [sym_argument_list_with_parens] = STATE(9673),
    [sym_operator] = STATE(9673),
    [anon_sym_LT] = ACTIONS(14308),
    [anon_sym_SLASH] = ACTIONS(14310),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14310),
    [anon_sym_PLUS_AT] = ACTIONS(14310),
    [anon_sym_LPAREN2] = ACTIONS(14312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14310),
    [anon_sym_GT_GT] = ACTIONS(14310),
    [anon_sym_EQ_TILDE] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [anon_sym_PLUS] = ACTIONS(14308),
    [anon_sym_AMP] = ACTIONS(14310),
    [anon_sym_GT] = ACTIONS(14308),
    [anon_sym_PERCENT] = ACTIONS(14310),
    [anon_sym_DASH_AT] = ACTIONS(14310),
    [anon_sym_EQ_EQ] = ACTIONS(14308),
    [anon_sym_STAR] = ACTIONS(14308),
    [anon_sym_BANG_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(14314),
    [anon_sym_DASH] = ACTIONS(14308),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14308),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14310),
    [anon_sym_STAR_STAR] = ACTIONS(14310),
    [anon_sym_PIPE] = ACTIONS(14310),
    [anon_sym_DOT_DOT] = ACTIONS(14310),
    [anon_sym_LT_EQ_GT] = ACTIONS(14310),
    [anon_sym_LT_EQ] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14308),
    [sym_identifier] = ACTIONS(14314),
    [anon_sym_CARET] = ACTIONS(14310),
  },
  [7200] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(14316),
    [sym_identifier] = ACTIONS(14316),
  },
  [7201] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(14318),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7202] = {
    [anon_sym_COLON] = ACTIONS(14320),
    [sym_comment] = ACTIONS(49),
  },
  [7203] = {
    [sym_assignment] = STATE(9679),
    [sym_unary] = STATE(9679),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9679),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9679),
    [sym_conditional] = STATE(9679),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9679),
    [sym_binary] = STATE(9679),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7204] = {
    [sym_assignment] = STATE(9680),
    [sym_unary] = STATE(9680),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9680),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9680),
    [sym_conditional] = STATE(9680),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9680),
    [sym_binary] = STATE(9680),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7205] = {
    [sym_assignment] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7206] = {
    [sym_heredoc_body] = STATE(9683),
    [aux_sym_call_repeat1] = STATE(9683),
    [aux_sym_argument_list_repeat1] = STATE(9684),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7207] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [7208] = {
    [aux_sym_chained_string_repeat1] = STATE(7264),
    [sym_string] = STATE(7264),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14324),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7209] = {
    [sym_heredoc_body] = STATE(9683),
    [aux_sym_call_repeat1] = STATE(9683),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7210] = {
    [aux_sym_chained_string_repeat1] = STATE(9685),
    [sym_string] = STATE(9685),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [7211] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [7212] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [7213] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [7214] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [7215] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7266),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_PIPE] = ACTIONS(7278),
    [sym__binary_minus] = ACTIONS(7268),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(7280),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
  },
  [7216] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [7217] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9687),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14326),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [7218] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [7219] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [7220] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(7219),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9688),
    [sym_operator] = STATE(9688),
    [anon_sym_LT] = ACTIONS(11438),
    [anon_sym_SLASH] = ACTIONS(11440),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11440),
    [anon_sym_PLUS_AT] = ACTIONS(11440),
    [anon_sym_LPAREN2] = ACTIONS(11442),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11440),
    [anon_sym_GT_GT] = ACTIONS(11440),
    [anon_sym_EQ_TILDE] = ACTIONS(11440),
    [anon_sym_LT_LT] = ACTIONS(11440),
    [anon_sym_TILDE] = ACTIONS(11440),
    [anon_sym_PLUS] = ACTIONS(11438),
    [anon_sym_AMP] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11438),
    [anon_sym_PERCENT] = ACTIONS(11440),
    [anon_sym_DASH_AT] = ACTIONS(11440),
    [anon_sym_EQ_EQ] = ACTIONS(11438),
    [anon_sym_STAR] = ACTIONS(11438),
    [anon_sym_BANG_TILDE] = ACTIONS(11440),
    [sym_constant] = ACTIONS(14328),
    [anon_sym_DASH] = ACTIONS(11438),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11440),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11438),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11440),
    [anon_sym_STAR_STAR] = ACTIONS(11440),
    [anon_sym_PIPE] = ACTIONS(11440),
    [anon_sym_DOT_DOT] = ACTIONS(11440),
    [anon_sym_LT_EQ_GT] = ACTIONS(11440),
    [anon_sym_LT_EQ] = ACTIONS(11438),
    [anon_sym_BANG] = ACTIONS(11438),
    [sym_identifier] = ACTIONS(14328),
    [anon_sym_CARET] = ACTIONS(11440),
  },
  [7221] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [7222] = {
    [sym_assignment] = STATE(9689),
    [sym_unary] = STATE(9689),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9689),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(9689),
    [sym_conditional] = STATE(9689),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(9689),
    [sym_binary] = STATE(9689),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7223] = {
    [sym_assignment] = STATE(9690),
    [sym_unary] = STATE(9690),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9690),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(9690),
    [sym_conditional] = STATE(9690),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(9690),
    [sym_binary] = STATE(9690),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7224] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7225] = {
    [sym_assignment] = STATE(9691),
    [sym_unary] = STATE(9691),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(9691),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(9691),
    [sym_conditional] = STATE(9691),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(9691),
    [sym_binary] = STATE(9691),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [7226] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(14330),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14332),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14332),
    [anon_sym_SLASH_EQ] = ACTIONS(14332),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14332),
    [anon_sym_PIPE_EQ] = ACTIONS(14332),
    [anon_sym_LT_LT_EQ] = ACTIONS(14332),
    [anon_sym_PLUS_EQ] = ACTIONS(14332),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14332),
    [anon_sym_STAR_EQ] = ACTIONS(14332),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14332),
    [anon_sym_CARET_EQ] = ACTIONS(14332),
    [anon_sym_DASH_EQ] = ACTIONS(14332),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14332),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7227] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [7228] = {
    [anon_sym_EQ] = ACTIONS(14360),
    [sym_comment] = ACTIONS(3),
  },
  [7229] = {
    [aux_sym_exceptions_repeat1] = STATE(9704),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(14362),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7230] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7231] = {
    [aux_sym_chained_string_repeat1] = STATE(7264),
    [sym_string] = STATE(7264),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7232] = {
    [sym_assignment] = STATE(9705),
    [sym_unary] = STATE(9705),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(9705),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(9705),
    [sym_conditional] = STATE(9705),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(9705),
    [sym_binary] = STATE(9705),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [7233] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [7234] = {
    [sym_assignment] = STATE(9706),
    [sym_unary] = STATE(9706),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(9706),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(9706),
    [sym_conditional] = STATE(9706),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(9706),
    [sym_binary] = STATE(9706),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [7235] = {
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [7236] = {
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [7237] = {
    [sym_assignment] = STATE(9707),
    [sym_unary] = STATE(9707),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(9707),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(9707),
    [sym_conditional] = STATE(9707),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(9707),
    [sym_binary] = STATE(9707),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [7238] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [7239] = {
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [7240] = {
    [sym_assignment] = STATE(9708),
    [sym_unary] = STATE(9708),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(9708),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(9708),
    [sym_conditional] = STATE(9708),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(9708),
    [sym_binary] = STATE(9708),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [7241] = {
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [7242] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14364),
    [anon_sym_GT_GT_EQ] = ACTIONS(14364),
    [anon_sym_SLASH_EQ] = ACTIONS(14364),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14364),
    [anon_sym_LT_LT_EQ] = ACTIONS(14364),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14364),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(14364),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14366),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(14364),
    [anon_sym_PLUS_EQ] = ACTIONS(14364),
    [anon_sym_STAR_EQ] = ACTIONS(14364),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14364),
    [anon_sym_DASH_EQ] = ACTIONS(14364),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14364),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7243] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [7244] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(7208),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(7210),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(7212),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [7245] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym__primary] = STATE(4290),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(4293),
    [sym_method] = STATE(4290),
    [sym_conditional] = STATE(4295),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_subshell] = STATE(4290),
    [sym_unless] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_block_argument] = STATE(4293),
    [sym_range] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4294),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_call] = STATE(4292),
    [sym__argument] = STATE(4293),
    [sym_assignment] = STATE(4295),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_pair] = STATE(4293),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4293),
    [sym_operator_assignment] = STATE(4295),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_rational] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_lambda] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym__argument_list_with_parens] = STATE(4297),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(4295),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_nil] = STATE(4294),
    [sym_symbol_array] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_scope_resolution] = STATE(4292),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7216),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7178),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7228),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7236),
    [anon_sym_not] = ACTIONS(7238),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7248),
  },
  [7246] = {
    [anon_sym_EQ] = ACTIONS(14396),
    [sym_comment] = ACTIONS(3),
  },
  [7247] = {
    [aux_sym_chained_string_repeat1] = STATE(9720),
    [sym_string] = STATE(9720),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7248] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [7249] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [7250] = {
    [sym_assignment] = STATE(9721),
    [sym_unary] = STATE(9721),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9721),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(9722),
    [sym_operator_assignment] = STATE(9721),
    [sym_conditional] = STATE(9721),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_subshell] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(9722),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9721),
    [sym_binary] = STATE(9721),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7220),
    [sym_character] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7251] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_heredoc_body] = STATE(9723),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym_float] = ACTIONS(7216),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7220),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7220),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7228),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [sym_class_variable] = ACTIONS(7228),
    [sym__block_ampersand] = ACTIONS(7236),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7238),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14398),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7252] = {
    [sym_heredoc_body] = STATE(9724),
    [aux_sym_call_repeat1] = STATE(9724),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7253] = {
    [sym_heredoc_body] = STATE(9725),
    [aux_sym_call_repeat1] = STATE(9725),
    [aux_sym_argument_list_repeat1] = STATE(9726),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11494),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7254] = {
    [sym_assignment] = STATE(9727),
    [sym_unary] = STATE(9727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9727),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9727),
    [sym_conditional] = STATE(9727),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9727),
    [sym_binary] = STATE(9727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7255] = {
    [sym_assignment] = STATE(9728),
    [sym_unary] = STATE(9728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9728),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9728),
    [sym_conditional] = STATE(9728),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9728),
    [sym_binary] = STATE(9728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7256] = {
    [sym_assignment] = STATE(9729),
    [sym_unary] = STATE(9729),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9729),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9729),
    [sym_conditional] = STATE(9729),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9729),
    [sym_binary] = STATE(9729),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7257] = {
    [sym_assignment] = STATE(9730),
    [sym_unary] = STATE(9730),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9730),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9730),
    [sym_conditional] = STATE(9730),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9730),
    [sym_binary] = STATE(9730),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7258] = {
    [sym_assignment] = STATE(9731),
    [sym_unary] = STATE(9731),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9731),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9731),
    [sym_conditional] = STATE(9731),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9731),
    [sym_binary] = STATE(9731),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7259] = {
    [sym_assignment] = STATE(9732),
    [sym_unary] = STATE(9732),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9732),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9732),
    [sym_conditional] = STATE(9732),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9732),
    [sym_binary] = STATE(9732),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7260] = {
    [sym_assignment] = STATE(9733),
    [sym_unary] = STATE(9733),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9733),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9733),
    [sym_conditional] = STATE(9733),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9733),
    [sym_binary] = STATE(9733),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7261] = {
    [sym_assignment] = STATE(9735),
    [sym_unary] = STATE(9735),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9735),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9735),
    [sym_conditional] = STATE(9735),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9735),
    [sym_binary] = STATE(9735),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7262] = {
    [sym_assignment] = STATE(9736),
    [sym_unary] = STATE(9736),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9736),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9736),
    [sym_conditional] = STATE(9736),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9736),
    [sym_binary] = STATE(9736),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7263] = {
    [sym_assignment] = STATE(9737),
    [sym_unary] = STATE(9737),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9737),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(9737),
    [sym_conditional] = STATE(9737),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9737),
    [sym_binary] = STATE(9737),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [7264] = {
    [aux_sym_chained_string_repeat1] = STATE(9738),
    [sym_string] = STATE(9738),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7265] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7266] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7267] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7268] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7269] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7270] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14400),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7271] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7272] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7273] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7274] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7275] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [7276] = {
    [aux_sym_chained_string_repeat1] = STATE(7276),
    [sym_string] = STATE(7276),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [7277] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [7278] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [7279] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(1838),
    [sym_unary] = STATE(1838),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(1838),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(1838),
    [sym_conditional] = STATE(1838),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1839),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(1838),
    [sym_binary] = STATE(1838),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(917),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(917),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(929),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(3318),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(937),
    [sym_class_variable] = ACTIONS(929),
    [sym__block_ampersand] = ACTIONS(3320),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(941),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11530),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [7280] = {
    [sym_heredoc_body] = STATE(7280),
    [aux_sym_call_repeat1] = STATE(7280),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [7281] = {
    [sym_heredoc_body] = STATE(7280),
    [aux_sym_call_repeat1] = STATE(7280),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [7282] = {
    [aux_sym_argument_list_repeat1] = STATE(7282),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14402),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [7283] = {
    [sym_heredoc_body] = STATE(9740),
    [aux_sym_call_repeat1] = STATE(9740),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [7284] = {
    [sym_heredoc_body] = STATE(9741),
    [aux_sym_call_repeat1] = STATE(9741),
    [aux_sym_argument_list_repeat1] = STATE(4339),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [7285] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7286] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7287] = {
    [aux_sym_exceptions_repeat1] = STATE(9743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [7288] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7289] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7290] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7291] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7292] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14405),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7293] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7294] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [7295] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7296] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7297] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7298] = {
    [aux_sym_chained_string_repeat1] = STATE(7298),
    [sym_string] = STATE(7298),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [7299] = {
    [sym_assignment] = STATE(4341),
    [sym_unary] = STATE(4341),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(4341),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(4341),
    [sym_conditional] = STATE(4341),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_true] = STATE(490),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(4341),
    [sym_binary] = STATE(4341),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [sym_global_variable] = ACTIONS(929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(917),
    [sym_character] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [7300] = {
    [aux_sym_exceptions_repeat1] = STATE(9745),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14407),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [7301] = {
    [sym_assignment] = STATE(9746),
    [sym_unary] = STATE(9746),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(490),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(9746),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(490),
    [sym_operator_assignment] = STATE(9746),
    [sym_conditional] = STATE(9746),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(493),
    [sym_left_assignment_list] = STATE(494),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(490),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(1827),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(490),
    [sym_range] = STATE(9746),
    [sym_binary] = STATE(9746),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(490),
    [sym_nil] = STATE(490),
    [sym_scope_resolution] = STATE(493),
    [sym_call] = STATE(493),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(937),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_not] = ACTIONS(941),
    [sym_self] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(929),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(947),
    [anon_sym_next] = ACTIONS(949),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(917),
    [anon_sym_defined_QMARK] = ACTIONS(931),
    [sym_instance_variable] = ACTIONS(929),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(917),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(929),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(915),
  },
  [7302] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [7303] = {
    [anon_sym_RPAREN] = ACTIONS(14409),
    [sym_comment] = ACTIONS(49),
  },
  [7304] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [7305] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [7306] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [7307] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(1877),
    [sym_unary] = STATE(1877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(1877),
    [sym__primary] = STATE(529),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(1877),
    [sym_conditional] = STATE(1877),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1878),
    [sym_rational] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(1877),
    [sym_binary] = STATE(1877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym_float] = ACTIONS(999),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1005),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3382),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1019),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(3384),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3382),
    [anon_sym_yield] = ACTIONS(1025),
    [sym_class_variable] = ACTIONS(1019),
    [sym__block_ampersand] = ACTIONS(3386),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [sym_retry] = ACTIONS(999),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11541),
    [sym_redo] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [7308] = {
    [sym_heredoc_body] = STATE(7308),
    [aux_sym_call_repeat1] = STATE(7308),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [7309] = {
    [sym_heredoc_body] = STATE(7308),
    [aux_sym_call_repeat1] = STATE(7308),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [7310] = {
    [aux_sym_argument_list_repeat1] = STATE(7310),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14411),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7311] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [7312] = {
    [aux_sym_exceptions_repeat1] = STATE(4384),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [7313] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [7314] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [7315] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [7316] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7317] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14414),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7318] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7319] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [7320] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7321] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7322] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [7323] = {
    [aux_sym_exceptions_repeat1] = STATE(7323),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(14416),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [7324] = {
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [7325] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [7326] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7327] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7328] = {
    [aux_sym_exceptions_repeat1] = STATE(9750),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [7329] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7330] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7331] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7332] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7333] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7334] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7335] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [7336] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7337] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7338] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7339] = {
    [aux_sym_chained_string_repeat1] = STATE(7339),
    [sym_string] = STATE(7339),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [7340] = {
    [sym_assignment] = STATE(4407),
    [sym_unary] = STATE(4407),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(4407),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(4407),
    [sym_conditional] = STATE(4407),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_return] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_true] = STATE(534),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(4407),
    [sym_binary] = STATE(4407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3388),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [sym_global_variable] = ACTIONS(1019),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1005),
    [sym_character] = ACTIONS(1007),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [7341] = {
    [aux_sym_exceptions_repeat1] = STATE(9752),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14421),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [7342] = {
    [sym_assignment] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(534),
    [sym_singleton_class] = STATE(529),
    [sym_module] = STATE(529),
    [sym_chained_string] = STATE(529),
    [sym_until] = STATE(529),
    [sym_regex] = STATE(529),
    [sym_for] = STATE(529),
    [sym_symbol] = STATE(529),
    [sym_if] = STATE(529),
    [sym_begin] = STATE(529),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(529),
    [sym_method_call] = STATE(534),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_method] = STATE(529),
    [sym_singleton_method] = STATE(529),
    [sym__variable] = STATE(532),
    [sym_left_assignment_list] = STATE(531),
    [sym_rational] = STATE(529),
    [sym_true] = STATE(534),
    [sym_return] = STATE(529),
    [sym_subshell] = STATE(529),
    [sym_yield] = STATE(529),
    [sym_string] = STATE(1911),
    [sym_unless] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_parenthesized_statements] = STATE(529),
    [sym_element_reference] = STATE(534),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(529),
    [sym_break] = STATE(529),
    [sym_next] = STATE(529),
    [sym_string_array] = STATE(529),
    [sym_while] = STATE(529),
    [sym_case] = STATE(529),
    [sym_symbol_array] = STATE(529),
    [sym_array] = STATE(529),
    [sym_hash] = STATE(529),
    [sym_false] = STATE(534),
    [sym_nil] = STATE(534),
    [sym_scope_resolution] = STATE(532),
    [sym_call] = STATE(532),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(999),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1029),
    [sym_self] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1007),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(3422),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1019),
    [sym_character] = ACTIONS(1007),
    [sym_super] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1035),
    [anon_sym_next] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(999),
    [sym_constant] = ACTIONS(1005),
    [anon_sym_defined_QMARK] = ACTIONS(1021),
    [sym_instance_variable] = ACTIONS(1019),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1005),
    [sym_redo] = ACTIONS(999),
    [sym_class_variable] = ACTIONS(1019),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1003),
  },
  [7343] = {
    [aux_sym_undef_repeat1] = STATE(7343),
    [anon_sym_RBRACE] = ACTIONS(7428),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [7344] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [7345] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [7346] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7347] = {
    [sym_heredoc_body] = STATE(9755),
    [aux_sym_call_repeat1] = STATE(9755),
    [aux_sym_argument_list_repeat1] = STATE(9421),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10995),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7348] = {
    [sym_heredoc_body] = STATE(9756),
    [aux_sym_call_repeat1] = STATE(9756),
    [aux_sym_argument_list_repeat1] = STATE(9757),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7457),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7349] = {
    [sym_heredoc_body] = STATE(9756),
    [aux_sym_call_repeat1] = STATE(9756),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7350] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7351] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [7352] = {
    [sym_assignment] = STATE(9758),
    [sym_unary] = STATE(9758),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9758),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9758),
    [sym_conditional] = STATE(9758),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9758),
    [sym_binary] = STATE(9758),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7353] = {
    [sym_assignment] = STATE(9759),
    [sym_unary] = STATE(9759),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9759),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_splat_argument] = STATE(9760),
    [sym_operator_assignment] = STATE(9759),
    [sym_conditional] = STATE(9759),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_subshell] = STATE(556),
    [sym__arg_or_splat_arg] = STATE(9760),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9759),
    [sym_binary] = STATE(9759),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1061),
    [sym_character] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7354] = {
    [sym_assignment] = STATE(9761),
    [sym_unary] = STATE(9761),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9761),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9761),
    [sym_conditional] = STATE(9761),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9761),
    [sym_binary] = STATE(9761),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7355] = {
    [sym_assignment] = STATE(9762),
    [sym_unary] = STATE(9762),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9762),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9762),
    [sym_conditional] = STATE(9762),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9762),
    [sym_binary] = STATE(9762),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7356] = {
    [sym_assignment] = STATE(9764),
    [sym_unary] = STATE(9764),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9764),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9764),
    [sym_conditional] = STATE(9764),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9764),
    [sym_binary] = STATE(9764),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7357] = {
    [sym_assignment] = STATE(9765),
    [sym_unary] = STATE(9765),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9765),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9765),
    [sym_conditional] = STATE(9765),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9765),
    [sym_binary] = STATE(9765),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7358] = {
    [sym_assignment] = STATE(9766),
    [sym_unary] = STATE(9766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9766),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9766),
    [sym_conditional] = STATE(9766),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9766),
    [sym_binary] = STATE(9766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7359] = {
    [sym_assignment] = STATE(9767),
    [sym_unary] = STATE(9767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9767),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9767),
    [sym_conditional] = STATE(9767),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9767),
    [sym_binary] = STATE(9767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7360] = {
    [sym_assignment] = STATE(9768),
    [sym_unary] = STATE(9768),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9768),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9768),
    [sym_conditional] = STATE(9768),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9768),
    [sym_binary] = STATE(9768),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7361] = {
    [sym_assignment] = STATE(9769),
    [sym_unary] = STATE(9769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9769),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9769),
    [sym_conditional] = STATE(9769),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9769),
    [sym_binary] = STATE(9769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7362] = {
    [sym_assignment] = STATE(9770),
    [sym_unary] = STATE(9770),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9770),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(9770),
    [sym_conditional] = STATE(9770),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9770),
    [sym_binary] = STATE(9770),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7363] = {
    [aux_sym_chained_string_repeat1] = STATE(9771),
    [sym_string] = STATE(9771),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [7364] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(1968),
    [sym_unary] = STATE(1968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(1968),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(1968),
    [sym_conditional] = STATE(1968),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(1970),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(1968),
    [sym_binary] = STATE(1968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2941),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3512),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(3518),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(3522),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(3524),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11586),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [7365] = {
    [sym_heredoc_body] = STATE(7365),
    [aux_sym_call_repeat1] = STATE(7365),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [7366] = {
    [sym_heredoc_body] = STATE(7365),
    [aux_sym_call_repeat1] = STATE(7365),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [7367] = {
    [aux_sym_argument_list_repeat1] = STATE(7367),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14423),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [7368] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7369] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7370] = {
    [aux_sym_exceptions_repeat1] = STATE(9773),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7371] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7372] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7373] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14426),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7374] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7375] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7376] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7377] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7378] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7379] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7380] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [7381] = {
    [aux_sym_chained_string_repeat1] = STATE(7381),
    [sym_string] = STATE(7381),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [7382] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [7383] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [7384] = {
    [anon_sym_RPAREN] = ACTIONS(14428),
    [sym_comment] = ACTIONS(49),
  },
  [7385] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [7386] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [7387] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7388] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [7389] = {
    [sym_assignment] = STATE(9776),
    [sym_unary] = STATE(9776),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9776),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9776),
    [sym_conditional] = STATE(9776),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9776),
    [sym_binary] = STATE(9776),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7390] = {
    [sym_assignment] = STATE(4479),
    [sym_unary] = STATE(4479),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4479),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_splat_argument] = STATE(9777),
    [sym_operator_assignment] = STATE(4479),
    [sym_conditional] = STATE(4479),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_subshell] = STATE(556),
    [sym__arg_or_splat_arg] = STATE(9777),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(4479),
    [sym_binary] = STATE(4479),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7511),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1061),
    [sym_character] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7391] = {
    [sym_assignment] = STATE(9778),
    [sym_unary] = STATE(9778),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9778),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9778),
    [sym_conditional] = STATE(9778),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9778),
    [sym_binary] = STATE(9778),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7392] = {
    [sym_assignment] = STATE(9779),
    [sym_unary] = STATE(9779),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9779),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9779),
    [sym_conditional] = STATE(9779),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9779),
    [sym_binary] = STATE(9779),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7393] = {
    [sym_assignment] = STATE(9781),
    [sym_unary] = STATE(9781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9781),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9781),
    [sym_conditional] = STATE(9781),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9781),
    [sym_binary] = STATE(9781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7394] = {
    [sym_assignment] = STATE(9782),
    [sym_unary] = STATE(9782),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9782),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9782),
    [sym_conditional] = STATE(9782),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9782),
    [sym_binary] = STATE(9782),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7395] = {
    [sym_assignment] = STATE(9783),
    [sym_unary] = STATE(9783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9783),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9783),
    [sym_conditional] = STATE(9783),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9783),
    [sym_binary] = STATE(9783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7396] = {
    [sym_assignment] = STATE(9784),
    [sym_unary] = STATE(9784),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9784),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9784),
    [sym_conditional] = STATE(9784),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9784),
    [sym_binary] = STATE(9784),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7397] = {
    [sym_assignment] = STATE(9785),
    [sym_unary] = STATE(9785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9785),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9785),
    [sym_conditional] = STATE(9785),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9785),
    [sym_binary] = STATE(9785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7398] = {
    [sym_assignment] = STATE(9786),
    [sym_unary] = STATE(9786),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9786),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9786),
    [sym_conditional] = STATE(9786),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9786),
    [sym_binary] = STATE(9786),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7399] = {
    [sym_assignment] = STATE(9787),
    [sym_unary] = STATE(9787),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9787),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(9787),
    [sym_conditional] = STATE(9787),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(9787),
    [sym_binary] = STATE(9787),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7400] = {
    [sym_assignment] = STATE(4479),
    [sym_unary] = STATE(4479),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4479),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(4479),
    [sym_conditional] = STATE(4479),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_true] = STATE(4478),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(4479),
    [sym_binary] = STATE(4479),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7511),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1061),
    [sym_character] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [7401] = {
    [aux_sym_exceptions_repeat1] = STATE(9788),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(11626),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [7402] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [7403] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [7404] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7405] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [7406] = {
    [sym_assignment] = STATE(9789),
    [sym_unary] = STATE(9789),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9789),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9789),
    [sym_conditional] = STATE(9789),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9789),
    [sym_binary] = STATE(9789),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7407] = {
    [sym_assignment] = STATE(9790),
    [sym_unary] = STATE(9790),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9790),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_splat_argument] = STATE(9791),
    [sym_operator_assignment] = STATE(9790),
    [sym_conditional] = STATE(9790),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_return] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_subshell] = STATE(4496),
    [sym__arg_or_splat_arg] = STATE(9791),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9790),
    [sym_binary] = STATE(9790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [sym_global_variable] = ACTIONS(7541),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7533),
    [sym_character] = ACTIONS(7537),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7408] = {
    [sym_assignment] = STATE(9792),
    [sym_unary] = STATE(9792),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9792),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9792),
    [sym_conditional] = STATE(9792),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9792),
    [sym_binary] = STATE(9792),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7409] = {
    [sym_assignment] = STATE(9793),
    [sym_unary] = STATE(9793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9793),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9793),
    [sym_conditional] = STATE(9793),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9793),
    [sym_binary] = STATE(9793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7410] = {
    [sym_assignment] = STATE(9795),
    [sym_unary] = STATE(9795),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9795),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9795),
    [sym_conditional] = STATE(9795),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9795),
    [sym_binary] = STATE(9795),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7411] = {
    [sym_assignment] = STATE(9796),
    [sym_unary] = STATE(9796),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9796),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9796),
    [sym_conditional] = STATE(9796),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9796),
    [sym_binary] = STATE(9796),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7412] = {
    [sym_assignment] = STATE(9797),
    [sym_unary] = STATE(9797),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9797),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9797),
    [sym_conditional] = STATE(9797),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9797),
    [sym_binary] = STATE(9797),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7413] = {
    [sym_assignment] = STATE(9798),
    [sym_unary] = STATE(9798),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9798),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9798),
    [sym_conditional] = STATE(9798),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9798),
    [sym_binary] = STATE(9798),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7414] = {
    [sym_assignment] = STATE(9799),
    [sym_unary] = STATE(9799),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9799),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9799),
    [sym_conditional] = STATE(9799),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9799),
    [sym_binary] = STATE(9799),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7415] = {
    [sym_assignment] = STATE(9800),
    [sym_unary] = STATE(9800),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9800),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9800),
    [sym_conditional] = STATE(9800),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9800),
    [sym_binary] = STATE(9800),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7416] = {
    [sym_assignment] = STATE(9801),
    [sym_unary] = STATE(9801),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9801),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(9801),
    [sym_conditional] = STATE(9801),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9801),
    [sym_binary] = STATE(9801),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [7417] = {
    [aux_sym_chained_string_repeat1] = STATE(9802),
    [sym_string] = STATE(9802),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7418] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7419] = {
    [aux_sym_exceptions_repeat1] = STATE(9804),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [7420] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(2000),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym_float] = ACTIONS(3558),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(3562),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(3562),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(3574),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3576),
    [sym_class_variable] = ACTIONS(3570),
    [sym__block_ampersand] = ACTIONS(3578),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11662),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [7421] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [7422] = {
    [sym_heredoc_body] = STATE(7421),
    [aux_sym_call_repeat1] = STATE(7421),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [7423] = {
    [aux_sym_argument_list_repeat1] = STATE(7423),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14430),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7424] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7425] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7426] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7427] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14433),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7428] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7429] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7430] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7431] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [7432] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7433] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7434] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7435] = {
    [aux_sym_chained_string_repeat1] = STATE(7435),
    [sym_string] = STATE(7435),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [7436] = {
    [sym_assignment] = STATE(9806),
    [sym_unary] = STATE(9806),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9806),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(9806),
    [sym_conditional] = STATE(9806),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_range] = STATE(9806),
    [sym_binary] = STATE(9806),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_not] = ACTIONS(1079),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [7437] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [7438] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [7439] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(584),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2031),
    [sym_rational] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym_float] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(1099),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(1099),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(1107),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(3638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1115),
    [sym_class_variable] = ACTIONS(1107),
    [sym__block_ampersand] = ACTIONS(3640),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [sym_retry] = ACTIONS(1095),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11666),
    [sym_redo] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [7440] = {
    [sym_heredoc_body] = STATE(7440),
    [aux_sym_call_repeat1] = STATE(7440),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [7441] = {
    [sym_heredoc_body] = STATE(7440),
    [aux_sym_call_repeat1] = STATE(7440),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [7442] = {
    [aux_sym_argument_list_repeat1] = STATE(7442),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14435),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [7443] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7444] = {
    [sym_heredoc_body] = STATE(9808),
    [aux_sym_call_repeat1] = STATE(9808),
    [aux_sym_argument_list_repeat1] = STATE(4560),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7445] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7446] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7447] = {
    [aux_sym_exceptions_repeat1] = STATE(9810),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7448] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7449] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7450] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7451] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7452] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14438),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7453] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7454] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7455] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7456] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7457] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [7458] = {
    [aux_sym_chained_string_repeat1] = STATE(7458),
    [sym_string] = STATE(7458),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [7459] = {
    [sym_assignment] = STATE(4562),
    [sym_unary] = STATE(4562),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(4562),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(4562),
    [sym_conditional] = STATE(4562),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_return] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_true] = STATE(582),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(4562),
    [sym_binary] = STATE(4562),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(3642),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [sym_global_variable] = ACTIONS(1107),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1099),
    [sym_character] = ACTIONS(1101),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [7460] = {
    [aux_sym_exceptions_repeat1] = STATE(9812),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14440),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [7461] = {
    [sym_assignment] = STATE(9813),
    [sym_unary] = STATE(9813),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(582),
    [sym_singleton_class] = STATE(584),
    [sym_module] = STATE(584),
    [sym_chained_string] = STATE(584),
    [sym_until] = STATE(584),
    [sym_regex] = STATE(584),
    [sym_for] = STATE(584),
    [sym_symbol] = STATE(584),
    [sym_if] = STATE(584),
    [sym_begin] = STATE(584),
    [sym__arg] = STATE(9813),
    [sym__primary] = STATE(584),
    [sym_method_call] = STATE(582),
    [sym_operator_assignment] = STATE(9813),
    [sym_conditional] = STATE(9813),
    [sym_method] = STATE(584),
    [sym_singleton_method] = STATE(584),
    [sym__variable] = STATE(585),
    [sym_left_assignment_list] = STATE(586),
    [sym_rational] = STATE(584),
    [sym_true] = STATE(582),
    [sym_return] = STATE(584),
    [sym_subshell] = STATE(584),
    [sym_yield] = STATE(584),
    [sym_string] = STATE(2019),
    [sym_unless] = STATE(584),
    [sym_lambda] = STATE(584),
    [sym_parenthesized_statements] = STATE(584),
    [sym_element_reference] = STATE(582),
    [sym_range] = STATE(9813),
    [sym_binary] = STATE(9813),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(584),
    [sym_break] = STATE(584),
    [sym_next] = STATE(584),
    [sym_string_array] = STATE(584),
    [sym_while] = STATE(584),
    [sym_case] = STATE(584),
    [sym_symbol_array] = STATE(584),
    [sym_array] = STATE(584),
    [sym_hash] = STATE(584),
    [sym_false] = STATE(582),
    [sym_nil] = STATE(582),
    [sym_scope_resolution] = STATE(585),
    [sym_call] = STATE(585),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_not] = ACTIONS(1119),
    [sym_self] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1107),
    [sym_character] = ACTIONS(1101),
    [sym_super] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(1125),
    [anon_sym_next] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(1095),
    [sym_constant] = ACTIONS(1099),
    [anon_sym_defined_QMARK] = ACTIONS(1109),
    [sym_instance_variable] = ACTIONS(1107),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(1099),
    [sym_redo] = ACTIONS(1095),
    [sym_class_variable] = ACTIONS(1107),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(1097),
  },
  [7462] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5452),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [7463] = {
    [anon_sym_RPAREN] = ACTIONS(14442),
    [sym_comment] = ACTIONS(49),
  },
  [7464] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [7465] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [7466] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [7467] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(2068),
    [sym_unary] = STATE(2068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(2068),
    [sym__primary] = STATE(613),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(2068),
    [sym_conditional] = STATE(2068),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2069),
    [sym_rational] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(2068),
    [sym_binary] = STATE(2068),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym_float] = ACTIONS(1155),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(1159),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(1159),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(3700),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(1167),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [sym__identifier_hash_key] = ACTIONS(3702),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(1173),
    [sym_class_variable] = ACTIONS(1167),
    [sym__block_ampersand] = ACTIONS(3704),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(1177),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [sym_retry] = ACTIONS(1155),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [sym_redo] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [7468] = {
    [sym_heredoc_body] = STATE(7468),
    [aux_sym_call_repeat1] = STATE(7468),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [7469] = {
    [sym_heredoc_body] = STATE(7468),
    [aux_sym_call_repeat1] = STATE(7468),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [7470] = {
    [aux_sym_argument_list_repeat1] = STATE(7470),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14444),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7471] = {
    [aux_sym_undef_repeat1] = STATE(9815),
    [sym__line_break] = ACTIONS(3500),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
  },
  [7472] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7473] = {
    [aux_sym_chained_string_repeat1] = STATE(7525),
    [sym_string] = STATE(7525),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7474] = {
    [sym_assignment] = STATE(9816),
    [sym_unary] = STATE(9816),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9816),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(9816),
    [sym_conditional] = STATE(9816),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(9816),
    [sym_binary] = STATE(9816),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7475] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [7476] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [7477] = {
    [sym_assignment] = STATE(9817),
    [sym_unary] = STATE(9817),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9817),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(9817),
    [sym_conditional] = STATE(9817),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(9817),
    [sym_binary] = STATE(9817),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7478] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(14447),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7479] = {
    [anon_sym_COLON] = ACTIONS(14449),
    [sym_comment] = ACTIONS(49),
  },
  [7480] = {
    [sym_assignment] = STATE(9820),
    [sym_unary] = STATE(9820),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9820),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9820),
    [sym_conditional] = STATE(9820),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9820),
    [sym_binary] = STATE(9820),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7481] = {
    [sym_assignment] = STATE(9821),
    [sym_unary] = STATE(9821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9821),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9821),
    [sym_conditional] = STATE(9821),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9821),
    [sym_binary] = STATE(9821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7482] = {
    [sym_assignment] = STATE(9822),
    [sym_unary] = STATE(9822),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9822),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9822),
    [sym_conditional] = STATE(9822),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9822),
    [sym_binary] = STATE(9822),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7483] = {
    [sym_heredoc_body] = STATE(9824),
    [aux_sym_call_repeat1] = STATE(9824),
    [aux_sym_argument_list_repeat1] = STATE(9825),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14451),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7484] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [7485] = {
    [aux_sym_chained_string_repeat1] = STATE(7525),
    [sym_string] = STATE(7525),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14453),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7486] = {
    [sym_heredoc_body] = STATE(9824),
    [aux_sym_call_repeat1] = STATE(9824),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7487] = {
    [sym__argument] = STATE(9826),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(9826),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(9826),
    [sym_hash_splat_argument] = STATE(9826),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(9827),
    [sym_block_argument] = STATE(9826),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [7488] = {
    [sym__argument] = STATE(9826),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(9826),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(9826),
    [sym_hash_splat_argument] = STATE(9826),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(9827),
    [sym_block_argument] = STATE(9826),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [7489] = {
    [sym_assignment] = STATE(9828),
    [sym_unary] = STATE(9828),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9828),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(9828),
    [sym_conditional] = STATE(9828),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(9828),
    [sym_binary] = STATE(9828),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7490] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7491] = {
    [sym__argument] = STATE(9826),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(9826),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(9826),
    [sym_hash_splat_argument] = STATE(9826),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(9827),
    [sym_block_argument] = STATE(9826),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [7492] = {
    [sym_assignment] = STATE(9829),
    [sym_unary] = STATE(9829),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9829),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(9829),
    [sym_conditional] = STATE(9829),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(9829),
    [sym_binary] = STATE(9829),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7493] = {
    [sym__argument] = STATE(9826),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(9826),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(9826),
    [sym_hash_splat_argument] = STATE(9826),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym__argument_list_with_parens] = STATE(9827),
    [sym_block_argument] = STATE(9826),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7658),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7660),
    [sym_self] = ACTIONS(7662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(7682),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(7692),
  },
  [7494] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14455),
    [anon_sym_GT_GT_EQ] = ACTIONS(14455),
    [anon_sym_SLASH_EQ] = ACTIONS(14455),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14455),
    [anon_sym_LT_LT_EQ] = ACTIONS(14455),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14455),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(14455),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14457),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(14455),
    [anon_sym_PLUS_EQ] = ACTIONS(14455),
    [anon_sym_STAR_EQ] = ACTIONS(14455),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14455),
    [anon_sym_DASH_EQ] = ACTIONS(14455),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14455),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7495] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [7496] = {
    [anon_sym_EQ] = ACTIONS(14485),
    [sym_comment] = ACTIONS(3),
  },
  [7497] = {
    [aux_sym_chained_string_repeat1] = STATE(9841),
    [sym_string] = STATE(9841),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [7498] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [7499] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [7500] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_heredoc_body] = STATE(9842),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym_float] = ACTIONS(7658),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7662),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7670),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7682),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14487),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7501] = {
    [sym_heredoc_body] = STATE(9843),
    [aux_sym_call_repeat1] = STATE(9843),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7502] = {
    [sym_heredoc_body] = STATE(9844),
    [aux_sym_call_repeat1] = STATE(9844),
    [aux_sym_argument_list_repeat1] = STATE(9845),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11715),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7503] = {
    [sym_assignment] = STATE(9846),
    [sym_unary] = STATE(9846),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9846),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9846),
    [sym_conditional] = STATE(9846),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9846),
    [sym_binary] = STATE(9846),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7504] = {
    [sym_assignment] = STATE(9847),
    [sym_unary] = STATE(9847),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9847),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(9848),
    [sym_operator_assignment] = STATE(9847),
    [sym_conditional] = STATE(9847),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_subshell] = STATE(4609),
    [sym__arg_or_splat_arg] = STATE(9848),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9847),
    [sym_binary] = STATE(9847),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7662),
    [sym_character] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7505] = {
    [sym_assignment] = STATE(9849),
    [sym_unary] = STATE(9849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9849),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9849),
    [sym_conditional] = STATE(9849),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9849),
    [sym_binary] = STATE(9849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7506] = {
    [sym_assignment] = STATE(9850),
    [sym_unary] = STATE(9850),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9850),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9850),
    [sym_conditional] = STATE(9850),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9850),
    [sym_binary] = STATE(9850),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7507] = {
    [sym_assignment] = STATE(9851),
    [sym_unary] = STATE(9851),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9851),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9851),
    [sym_conditional] = STATE(9851),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9851),
    [sym_binary] = STATE(9851),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7508] = {
    [sym_assignment] = STATE(9852),
    [sym_unary] = STATE(9852),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9852),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9852),
    [sym_conditional] = STATE(9852),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9852),
    [sym_binary] = STATE(9852),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7509] = {
    [sym_assignment] = STATE(9853),
    [sym_unary] = STATE(9853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9853),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9853),
    [sym_conditional] = STATE(9853),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9853),
    [sym_binary] = STATE(9853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7510] = {
    [sym_assignment] = STATE(9854),
    [sym_unary] = STATE(9854),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9854),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9854),
    [sym_conditional] = STATE(9854),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9854),
    [sym_binary] = STATE(9854),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7511] = {
    [sym_assignment] = STATE(9856),
    [sym_unary] = STATE(9856),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9856),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9856),
    [sym_conditional] = STATE(9856),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9856),
    [sym_binary] = STATE(9856),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7512] = {
    [sym_assignment] = STATE(9857),
    [sym_unary] = STATE(9857),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9857),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9857),
    [sym_conditional] = STATE(9857),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9857),
    [sym_binary] = STATE(9857),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7513] = {
    [sym_assignment] = STATE(9858),
    [sym_unary] = STATE(9858),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9858),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(9858),
    [sym_conditional] = STATE(9858),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9858),
    [sym_binary] = STATE(9858),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [7514] = {
    [sym_heredoc_body] = STATE(9863),
    [sym__argument_list_with_parens] = STATE(9862),
    [aux_sym_call_repeat1] = STATE(9863),
    [sym_argument_list_with_parens] = STATE(9861),
    [sym_operator] = STATE(9861),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_SLASH] = ACTIONS(14491),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14491),
    [anon_sym_PLUS_AT] = ACTIONS(14491),
    [anon_sym_LPAREN2] = ACTIONS(14493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14491),
    [anon_sym_GT_GT] = ACTIONS(14491),
    [anon_sym_EQ_TILDE] = ACTIONS(14491),
    [anon_sym_LT_LT] = ACTIONS(14491),
    [anon_sym_TILDE] = ACTIONS(14491),
    [anon_sym_PLUS] = ACTIONS(14489),
    [anon_sym_AMP] = ACTIONS(14491),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_PERCENT] = ACTIONS(14491),
    [anon_sym_DASH_AT] = ACTIONS(14491),
    [anon_sym_EQ_EQ] = ACTIONS(14489),
    [anon_sym_STAR] = ACTIONS(14489),
    [anon_sym_BANG_TILDE] = ACTIONS(14491),
    [sym_constant] = ACTIONS(14495),
    [anon_sym_DASH] = ACTIONS(14489),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14489),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14491),
    [anon_sym_STAR_STAR] = ACTIONS(14491),
    [anon_sym_PIPE] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14491),
    [anon_sym_LT_EQ_GT] = ACTIONS(14491),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_BANG] = ACTIONS(14489),
    [sym_identifier] = ACTIONS(14495),
    [anon_sym_CARET] = ACTIONS(14491),
  },
  [7515] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(14497),
    [sym_identifier] = ACTIONS(14497),
  },
  [7516] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(14499),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7517] = {
    [anon_sym_COLON] = ACTIONS(14501),
    [sym_comment] = ACTIONS(49),
  },
  [7518] = {
    [sym_assignment] = STATE(9867),
    [sym_unary] = STATE(9867),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9867),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9867),
    [sym_conditional] = STATE(9867),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9867),
    [sym_binary] = STATE(9867),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7519] = {
    [sym_assignment] = STATE(9868),
    [sym_unary] = STATE(9868),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9868),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9868),
    [sym_conditional] = STATE(9868),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9868),
    [sym_binary] = STATE(9868),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7520] = {
    [sym_assignment] = STATE(9869),
    [sym_unary] = STATE(9869),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9869),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9869),
    [sym_conditional] = STATE(9869),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9869),
    [sym_binary] = STATE(9869),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7521] = {
    [sym_heredoc_body] = STATE(9871),
    [aux_sym_call_repeat1] = STATE(9871),
    [aux_sym_argument_list_repeat1] = STATE(9872),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(14503),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7522] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [7523] = {
    [aux_sym_chained_string_repeat1] = STATE(7581),
    [sym_string] = STATE(7581),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(14505),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7524] = {
    [sym_heredoc_body] = STATE(9871),
    [aux_sym_call_repeat1] = STATE(9871),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [7525] = {
    [aux_sym_chained_string_repeat1] = STATE(9873),
    [sym_string] = STATE(9873),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [7526] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6698),
    [anon_sym_else] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [7527] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6700),
    [anon_sym_else] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [7528] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6702),
    [anon_sym_else] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [7529] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [7530] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(14507),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [7531] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6706),
    [anon_sym_else] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [7532] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7766),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7766),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6708),
    [anon_sym_else] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_PIPE] = ACTIONS(7778),
    [sym__binary_minus] = ACTIONS(7768),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(7780),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
  },
  [7533] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [7534] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9876),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14509),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [7535] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [7536] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [7537] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(7536),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9877),
    [sym_operator] = STATE(9877),
    [anon_sym_LT] = ACTIONS(11769),
    [anon_sym_SLASH] = ACTIONS(11771),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11771),
    [anon_sym_PLUS_AT] = ACTIONS(11771),
    [anon_sym_LPAREN2] = ACTIONS(11773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11771),
    [anon_sym_GT_GT] = ACTIONS(11771),
    [anon_sym_EQ_TILDE] = ACTIONS(11771),
    [anon_sym_LT_LT] = ACTIONS(11771),
    [anon_sym_TILDE] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11769),
    [anon_sym_AMP] = ACTIONS(11771),
    [anon_sym_GT] = ACTIONS(11769),
    [anon_sym_PERCENT] = ACTIONS(11771),
    [anon_sym_DASH_AT] = ACTIONS(11771),
    [anon_sym_EQ_EQ] = ACTIONS(11769),
    [anon_sym_STAR] = ACTIONS(11769),
    [anon_sym_BANG_TILDE] = ACTIONS(11771),
    [sym_constant] = ACTIONS(14511),
    [anon_sym_DASH] = ACTIONS(11769),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11771),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11769),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11771),
    [anon_sym_STAR_STAR] = ACTIONS(11771),
    [anon_sym_PIPE] = ACTIONS(11771),
    [anon_sym_DOT_DOT] = ACTIONS(11771),
    [anon_sym_LT_EQ_GT] = ACTIONS(11771),
    [anon_sym_LT_EQ] = ACTIONS(11769),
    [anon_sym_BANG] = ACTIONS(11769),
    [sym_identifier] = ACTIONS(14511),
    [anon_sym_CARET] = ACTIONS(11771),
  },
  [7538] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [7539] = {
    [sym_assignment] = STATE(9878),
    [sym_unary] = STATE(9878),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9878),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(9878),
    [sym_conditional] = STATE(9878),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(9878),
    [sym_binary] = STATE(9878),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7540] = {
    [sym_assignment] = STATE(9879),
    [sym_unary] = STATE(9879),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9879),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(9879),
    [sym_conditional] = STATE(9879),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(9879),
    [sym_binary] = STATE(9879),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7541] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7542] = {
    [sym_assignment] = STATE(9880),
    [sym_unary] = STATE(9880),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(9880),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(9880),
    [sym_conditional] = STATE(9880),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(9880),
    [sym_binary] = STATE(9880),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [7543] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14513),
    [anon_sym_GT_GT_EQ] = ACTIONS(14513),
    [anon_sym_SLASH_EQ] = ACTIONS(14513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14513),
    [anon_sym_LT_LT_EQ] = ACTIONS(14513),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14513),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(14513),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14515),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(14513),
    [anon_sym_PLUS_EQ] = ACTIONS(14513),
    [anon_sym_STAR_EQ] = ACTIONS(14513),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14513),
    [anon_sym_DASH_EQ] = ACTIONS(14513),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14513),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7544] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [7545] = {
    [anon_sym_EQ] = ACTIONS(14543),
    [sym_comment] = ACTIONS(3),
  },
  [7546] = {
    [aux_sym_exceptions_repeat1] = STATE(9893),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(14545),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7547] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7548] = {
    [aux_sym_chained_string_repeat1] = STATE(7581),
    [sym_string] = STATE(7581),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7549] = {
    [sym_assignment] = STATE(9894),
    [sym_unary] = STATE(9894),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(9894),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(9894),
    [sym_conditional] = STATE(9894),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(9894),
    [sym_binary] = STATE(9894),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [7550] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [7551] = {
    [sym_assignment] = STATE(9895),
    [sym_unary] = STATE(9895),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(9895),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(9895),
    [sym_conditional] = STATE(9895),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(9895),
    [sym_binary] = STATE(9895),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [7552] = {
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [7553] = {
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [7554] = {
    [sym_assignment] = STATE(9896),
    [sym_unary] = STATE(9896),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(9896),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(9896),
    [sym_conditional] = STATE(9896),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(9896),
    [sym_binary] = STATE(9896),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [7555] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [7556] = {
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [7557] = {
    [sym_assignment] = STATE(9897),
    [sym_unary] = STATE(9897),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(9897),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(9897),
    [sym_conditional] = STATE(9897),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(9897),
    [sym_binary] = STATE(9897),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [7558] = {
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [7559] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14547),
    [anon_sym_GT_GT_EQ] = ACTIONS(14547),
    [anon_sym_SLASH_EQ] = ACTIONS(14547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14547),
    [anon_sym_LT_LT_EQ] = ACTIONS(14547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14547),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(14547),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(14549),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(14547),
    [anon_sym_PLUS_EQ] = ACTIONS(14547),
    [anon_sym_STAR_EQ] = ACTIONS(14547),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14547),
    [anon_sym_DASH_EQ] = ACTIONS(14547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14547),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7560] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [7561] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(7708),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(7710),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(7712),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [7562] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym__primary] = STATE(4636),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(4639),
    [sym_method] = STATE(4636),
    [sym_conditional] = STATE(4641),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_subshell] = STATE(4636),
    [sym_unless] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_block_argument] = STATE(4639),
    [sym_range] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(4640),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_call] = STATE(4638),
    [sym__argument] = STATE(4639),
    [sym_assignment] = STATE(4641),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_pair] = STATE(4639),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4639),
    [sym_operator_assignment] = STATE(4641),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_rational] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_lambda] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym__argument_list_with_parens] = STATE(4643),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(4641),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_nil] = STATE(4640),
    [sym_symbol_array] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_scope_resolution] = STATE(4638),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(7716),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(7718),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(7720),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(7720),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(7674),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(7728),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(7736),
    [anon_sym_not] = ACTIONS(7738),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(7748),
  },
  [7563] = {
    [anon_sym_EQ] = ACTIONS(14579),
    [sym_comment] = ACTIONS(3),
  },
  [7564] = {
    [aux_sym_chained_string_repeat1] = STATE(9909),
    [sym_string] = STATE(9909),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [7565] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [7566] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [7567] = {
    [sym_assignment] = STATE(9910),
    [sym_unary] = STATE(9910),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9910),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(9911),
    [sym_operator_assignment] = STATE(9910),
    [sym_conditional] = STATE(9910),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_subshell] = STATE(4636),
    [sym__arg_or_splat_arg] = STATE(9911),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9910),
    [sym_binary] = STATE(9910),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7720),
    [sym_character] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7568] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_heredoc_body] = STATE(9912),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym_float] = ACTIONS(7716),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7720),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7720),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7728),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [sym_class_variable] = ACTIONS(7728),
    [sym__block_ampersand] = ACTIONS(7736),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7738),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14581),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7569] = {
    [sym_heredoc_body] = STATE(9913),
    [aux_sym_call_repeat1] = STATE(9913),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7570] = {
    [sym_heredoc_body] = STATE(9914),
    [aux_sym_call_repeat1] = STATE(9914),
    [aux_sym_argument_list_repeat1] = STATE(9915),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7571] = {
    [sym_assignment] = STATE(9916),
    [sym_unary] = STATE(9916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9916),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9916),
    [sym_conditional] = STATE(9916),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9916),
    [sym_binary] = STATE(9916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7572] = {
    [sym_assignment] = STATE(9917),
    [sym_unary] = STATE(9917),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9917),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9917),
    [sym_conditional] = STATE(9917),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9917),
    [sym_binary] = STATE(9917),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7573] = {
    [sym_assignment] = STATE(9918),
    [sym_unary] = STATE(9918),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9918),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9918),
    [sym_conditional] = STATE(9918),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9918),
    [sym_binary] = STATE(9918),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7574] = {
    [sym_assignment] = STATE(9919),
    [sym_unary] = STATE(9919),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9919),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9919),
    [sym_conditional] = STATE(9919),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9919),
    [sym_binary] = STATE(9919),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7575] = {
    [sym_assignment] = STATE(9920),
    [sym_unary] = STATE(9920),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9920),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9920),
    [sym_conditional] = STATE(9920),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9920),
    [sym_binary] = STATE(9920),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7576] = {
    [sym_assignment] = STATE(9921),
    [sym_unary] = STATE(9921),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9921),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9921),
    [sym_conditional] = STATE(9921),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9921),
    [sym_binary] = STATE(9921),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7577] = {
    [sym_assignment] = STATE(9922),
    [sym_unary] = STATE(9922),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9922),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9922),
    [sym_conditional] = STATE(9922),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9922),
    [sym_binary] = STATE(9922),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7578] = {
    [sym_assignment] = STATE(9924),
    [sym_unary] = STATE(9924),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9924),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9924),
    [sym_conditional] = STATE(9924),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9924),
    [sym_binary] = STATE(9924),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7579] = {
    [sym_assignment] = STATE(9925),
    [sym_unary] = STATE(9925),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9925),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9925),
    [sym_conditional] = STATE(9925),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9925),
    [sym_binary] = STATE(9925),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7580] = {
    [sym_assignment] = STATE(9926),
    [sym_unary] = STATE(9926),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9926),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(9926),
    [sym_conditional] = STATE(9926),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9926),
    [sym_binary] = STATE(9926),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [7581] = {
    [aux_sym_chained_string_repeat1] = STATE(9927),
    [sym_string] = STATE(9927),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7582] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7583] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7584] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7585] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7586] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7587] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14583),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7588] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7589] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7590] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7591] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7592] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [7593] = {
    [aux_sym_chained_string_repeat1] = STATE(7593),
    [sym_string] = STATE(7593),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [7594] = {
    [sym_heredoc_body] = STATE(4620),
    [sym__terminator] = STATE(4620),
    [sym__line_break] = ACTIONS(7694),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(7702),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(7694),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [7595] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9736),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [7596] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7597] = {
    [aux_sym_exceptions_repeat1] = STATE(4679),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7598] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7599] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7600] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7601] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7602] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14585),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7603] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7604] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7605] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7606] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7607] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [7608] = {
    [aux_sym_exceptions_repeat1] = STATE(7608),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(14587),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [7609] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7610] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7611] = {
    [aux_sym_exceptions_repeat1] = STATE(9931),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [7612] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7613] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7614] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7615] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7616] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14590),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7617] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7618] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [7619] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7620] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7621] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7622] = {
    [aux_sym_chained_string_repeat1] = STATE(7622),
    [sym_string] = STATE(7622),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [7623] = {
    [sym_assignment] = STATE(4696),
    [sym_unary] = STATE(4696),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(4696),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(4696),
    [sym_conditional] = STATE(4696),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_return] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_true] = STATE(617),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(4696),
    [sym_binary] = STATE(4696),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(3706),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [sym_global_variable] = ACTIONS(1167),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(1159),
    [sym_character] = ACTIONS(1161),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [7624] = {
    [aux_sym_exceptions_repeat1] = STATE(9933),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14592),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [7625] = {
    [sym_assignment] = STATE(9934),
    [sym_unary] = STATE(9934),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(617),
    [sym_singleton_class] = STATE(613),
    [sym_module] = STATE(613),
    [sym_chained_string] = STATE(613),
    [sym_until] = STATE(613),
    [sym_regex] = STATE(613),
    [sym_for] = STATE(613),
    [sym_symbol] = STATE(613),
    [sym_if] = STATE(613),
    [sym_begin] = STATE(613),
    [sym__arg] = STATE(9934),
    [sym__primary] = STATE(613),
    [sym_method_call] = STATE(617),
    [sym_operator_assignment] = STATE(9934),
    [sym_conditional] = STATE(9934),
    [sym_method] = STATE(613),
    [sym_singleton_method] = STATE(613),
    [sym__variable] = STATE(615),
    [sym_left_assignment_list] = STATE(614),
    [sym_rational] = STATE(613),
    [sym_true] = STATE(617),
    [sym_return] = STATE(613),
    [sym_subshell] = STATE(613),
    [sym_yield] = STATE(613),
    [sym_string] = STATE(2116),
    [sym_unless] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_parenthesized_statements] = STATE(613),
    [sym_element_reference] = STATE(617),
    [sym_range] = STATE(9934),
    [sym_binary] = STATE(9934),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(613),
    [sym_break] = STATE(613),
    [sym_next] = STATE(613),
    [sym_string_array] = STATE(613),
    [sym_while] = STATE(613),
    [sym_case] = STATE(613),
    [sym_symbol_array] = STATE(613),
    [sym_array] = STATE(613),
    [sym_hash] = STATE(613),
    [sym_false] = STATE(617),
    [sym_nil] = STATE(617),
    [sym_scope_resolution] = STATE(615),
    [sym_call] = STATE(615),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(1155),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1177),
    [sym_self] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(1167),
    [sym_character] = ACTIONS(1161),
    [sym_super] = ACTIONS(1159),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(1183),
    [anon_sym_next] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(1155),
    [sym_constant] = ACTIONS(1159),
    [anon_sym_defined_QMARK] = ACTIONS(1169),
    [sym_instance_variable] = ACTIONS(1167),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(1159),
    [sym_redo] = ACTIONS(1155),
    [sym_class_variable] = ACTIONS(1167),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(1157),
  },
  [7626] = {
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(1195),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(1199),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [sym__binary_star] = ACTIONS(1195),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_BANG_TILDE] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_DOT_DOT] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1199),
    [anon_sym_LT_EQ_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(1219),
    [sym__binary_minus] = ACTIONS(1207),
  },
  [7627] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [sym__line_break] = ACTIONS(14596),
    [anon_sym_then] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_when] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym___END__] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_end] = ACTIONS(14596),
    [anon_sym_ensure] = ACTIONS(14596),
    [anon_sym_else] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_elsif] = ACTIONS(14596),
    [ts_builtin_sym_end] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
    [sym__binary_minus] = ACTIONS(14596),
  },
  [7628] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_COLON2] = ACTIONS(7382),
    [anon_sym_while] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
    [sym__binary_minus] = ACTIONS(7384),
  },
  [7629] = {
    [anon_sym_end] = ACTIONS(14598),
    [sym_comment] = ACTIONS(49),
  },
  [7630] = {
    [anon_sym_RBRACE] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [7631] = {
    [aux_sym_undef_repeat1] = STATE(7631),
    [anon_sym_RBRACE] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(14600),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [7632] = {
    [anon_sym_RBRACE] = ACTIONS(7589),
    [anon_sym_rescue] = ACTIONS(7589),
    [anon_sym_unless] = ACTIONS(7589),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(7589),
    [anon_sym_if] = ACTIONS(7589),
    [anon_sym_while] = ACTIONS(7589),
  },
  [7633] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_COLON2] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [sym__binary_minus] = ACTIONS(7790),
  },
  [7634] = {
    [anon_sym_end] = ACTIONS(14603),
    [sym_comment] = ACTIONS(49),
  },
  [7635] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_COLON2] = ACTIONS(7870),
    [anon_sym_while] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
    [sym__binary_minus] = ACTIONS(7872),
  },
  [7636] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14605),
  },
  [7637] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
    [sym__binary_minus] = ACTIONS(7878),
  },
  [7638] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14607),
    [sym__string_end] = ACTIONS(14605),
  },
  [7639] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_COLON2] = ACTIONS(8222),
    [anon_sym_while] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
    [sym__binary_minus] = ACTIONS(8224),
  },
  [7640] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14609),
  },
  [7641] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_COLON2] = ACTIONS(8849),
    [anon_sym_while] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
    [sym__binary_minus] = ACTIONS(8851),
  },
  [7642] = {
    [anon_sym_RBRACE] = ACTIONS(8868),
    [anon_sym_rescue] = ACTIONS(8868),
    [anon_sym_unless] = ACTIONS(8868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_until] = ACTIONS(8868),
    [anon_sym_if] = ACTIONS(8868),
    [anon_sym_while] = ACTIONS(8868),
  },
  [7643] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_COLON2] = ACTIONS(8870),
    [anon_sym_while] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
    [sym__binary_minus] = ACTIONS(8872),
  },
  [7644] = {
    [anon_sym_end] = ACTIONS(14611),
    [sym_comment] = ACTIONS(49),
  },
  [7645] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9942),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14613),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7646] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_while] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
  },
  [7647] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9944),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14615),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7648] = {
    [anon_sym_end] = ACTIONS(14617),
    [sym_comment] = ACTIONS(49),
  },
  [7649] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(9945),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(9945),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(9944),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(14619),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(14619),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14615),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7650] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_while] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
  },
  [7651] = {
    [anon_sym_RBRACE] = ACTIONS(14621),
    [sym_comment] = ACTIONS(49),
  },
  [7652] = {
    [anon_sym_DOT] = ACTIONS(14623),
    [anon_sym_COLON_COLON] = ACTIONS(14623),
    [sym_comment] = ACTIONS(49),
  },
  [7653] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_COLON2] = ACTIONS(9600),
    [anon_sym_while] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
    [sym__binary_minus] = ACTIONS(9602),
  },
  [7654] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_COLON2] = ACTIONS(9606),
    [anon_sym_while] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
    [sym__binary_minus] = ACTIONS(9608),
  },
  [7655] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [7656] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [7657] = {
    [sym_assignment] = STATE(9948),
    [sym_unary] = STATE(9948),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(9948),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(9948),
    [sym_conditional] = STATE(9948),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(9948),
    [sym_binary] = STATE(9948),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [7658] = {
    [sym_assignment] = STATE(9949),
    [sym_unary] = STATE(9949),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(9949),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(9949),
    [sym_conditional] = STATE(9949),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(9949),
    [sym_binary] = STATE(9949),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [7659] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7660] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7661] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7662] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_heredoc_body] = STATE(9950),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym_float] = ACTIONS(3894),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(3898),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(3906),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(3918),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14625),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [7663] = {
    [sym_heredoc_body] = STATE(9951),
    [aux_sym_call_repeat1] = STATE(9951),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7664] = {
    [sym_heredoc_body] = STATE(9952),
    [aux_sym_call_repeat1] = STATE(9952),
    [aux_sym_argument_list_repeat1] = STATE(9953),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11929),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [7665] = {
    [sym_heredoc_body] = STATE(9954),
    [aux_sym_call_repeat1] = STATE(9954),
    [aux_sym_argument_list_repeat1] = STATE(9955),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7666] = {
    [sym_heredoc_body] = STATE(9954),
    [aux_sym_call_repeat1] = STATE(9954),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [7667] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7668] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [7669] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [7670] = {
    [sym_assignment] = STATE(9956),
    [sym_unary] = STATE(9956),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9956),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9956),
    [sym_conditional] = STATE(9956),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9956),
    [sym_binary] = STATE(9956),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7671] = {
    [sym_assignment] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_splat_argument] = STATE(9958),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_return] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_subshell] = STATE(4776),
    [sym__arg_or_splat_arg] = STATE(9958),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [sym_global_variable] = ACTIONS(7958),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(7950),
    [sym_character] = ACTIONS(7954),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7672] = {
    [sym_assignment] = STATE(9959),
    [sym_unary] = STATE(9959),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9959),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9959),
    [sym_conditional] = STATE(9959),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9959),
    [sym_binary] = STATE(9959),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7673] = {
    [sym_assignment] = STATE(9960),
    [sym_unary] = STATE(9960),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9960),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9960),
    [sym_conditional] = STATE(9960),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9960),
    [sym_binary] = STATE(9960),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7674] = {
    [sym_assignment] = STATE(9962),
    [sym_unary] = STATE(9962),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9962),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9962),
    [sym_conditional] = STATE(9962),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9962),
    [sym_binary] = STATE(9962),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7675] = {
    [sym_assignment] = STATE(9963),
    [sym_unary] = STATE(9963),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(9963),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(9963),
    [sym_conditional] = STATE(9963),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(9963),
    [sym_binary] = STATE(9963),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7676] = {
    [sym_assignment] = STATE(9964),
    [sym_unary] = STATE(9964),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9964),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9964),
    [sym_conditional] = STATE(9964),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9964),
    [sym_binary] = STATE(9964),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7677] = {
    [sym_assignment] = STATE(9965),
    [sym_unary] = STATE(9965),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9965),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9965),
    [sym_conditional] = STATE(9965),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9965),
    [sym_binary] = STATE(9965),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7678] = {
    [sym_assignment] = STATE(9966),
    [sym_unary] = STATE(9966),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9966),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9966),
    [sym_conditional] = STATE(9966),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9966),
    [sym_binary] = STATE(9966),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7679] = {
    [sym_assignment] = STATE(9967),
    [sym_unary] = STATE(9967),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9967),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9967),
    [sym_conditional] = STATE(9967),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9967),
    [sym_binary] = STATE(9967),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7680] = {
    [sym_assignment] = STATE(9968),
    [sym_unary] = STATE(9968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9968),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(9968),
    [sym_conditional] = STATE(9968),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9968),
    [sym_binary] = STATE(9968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [7681] = {
    [sym_heredoc_body] = STATE(9973),
    [sym__argument_list_with_parens] = STATE(9972),
    [aux_sym_call_repeat1] = STATE(9973),
    [sym_argument_list_with_parens] = STATE(9971),
    [sym_operator] = STATE(9971),
    [anon_sym_LT] = ACTIONS(14627),
    [anon_sym_SLASH] = ACTIONS(14629),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14629),
    [anon_sym_PLUS_AT] = ACTIONS(14629),
    [anon_sym_LPAREN2] = ACTIONS(14631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14629),
    [anon_sym_GT_GT] = ACTIONS(14629),
    [anon_sym_EQ_TILDE] = ACTIONS(14629),
    [anon_sym_LT_LT] = ACTIONS(14629),
    [anon_sym_TILDE] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14627),
    [anon_sym_AMP] = ACTIONS(14629),
    [anon_sym_GT] = ACTIONS(14627),
    [anon_sym_PERCENT] = ACTIONS(14629),
    [anon_sym_DASH_AT] = ACTIONS(14629),
    [anon_sym_EQ_EQ] = ACTIONS(14627),
    [anon_sym_STAR] = ACTIONS(14627),
    [anon_sym_BANG_TILDE] = ACTIONS(14629),
    [sym_constant] = ACTIONS(14633),
    [anon_sym_DASH] = ACTIONS(14627),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14629),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14627),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14629),
    [anon_sym_STAR_STAR] = ACTIONS(14629),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_DOT_DOT] = ACTIONS(14629),
    [anon_sym_LT_EQ_GT] = ACTIONS(14629),
    [anon_sym_LT_EQ] = ACTIONS(14627),
    [anon_sym_BANG] = ACTIONS(14627),
    [sym_identifier] = ACTIONS(14633),
    [anon_sym_CARET] = ACTIONS(14629),
  },
  [7682] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(14635),
    [sym_identifier] = ACTIONS(14635),
  },
  [7683] = {
    [aux_sym_chained_string_repeat1] = STATE(9975),
    [sym_string] = STATE(9975),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [7684] = {
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_SLASH] = ACTIONS(9738),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9738),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_AMP_AMP] = ACTIONS(9738),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
  },
  [7685] = {
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(4446),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_in] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(4446),
    [anon_sym_COLON2] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_AMP_AMP] = ACTIONS(4446),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(4446),
    [sym__binary_minus] = ACTIONS(4446),
  },
  [7686] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(14637),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [7687] = {
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [7688] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(2214),
    [sym_unary] = STATE(2214),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(2214),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(2214),
    [sym_conditional] = STATE(2214),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(2218),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(2214),
    [sym_binary] = STATE(2214),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym_float] = ACTIONS(3894),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(3898),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(3912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3904),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(3916),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(3918),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(11979),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [7689] = {
    [sym_heredoc_body] = STATE(7689),
    [aux_sym_call_repeat1] = STATE(7689),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [7690] = {
    [sym_heredoc_body] = STATE(7689),
    [aux_sym_call_repeat1] = STATE(7689),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [7691] = {
    [aux_sym_argument_list_repeat1] = STATE(7691),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14642),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [7692] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7693] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7694] = {
    [aux_sym_exceptions_repeat1] = STATE(9979),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [7695] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7696] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7697] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14645),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7698] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7699] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7700] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7701] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7702] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [7703] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7704] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [7705] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [7706] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(9982),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14647),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [7707] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [7708] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [7709] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(7708),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(9983),
    [sym_operator] = STATE(9983),
    [anon_sym_LT] = ACTIONS(11981),
    [anon_sym_SLASH] = ACTIONS(11983),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11983),
    [anon_sym_PLUS_AT] = ACTIONS(11983),
    [anon_sym_LPAREN2] = ACTIONS(11985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11983),
    [anon_sym_GT_GT] = ACTIONS(11983),
    [anon_sym_EQ_TILDE] = ACTIONS(11983),
    [anon_sym_LT_LT] = ACTIONS(11983),
    [anon_sym_TILDE] = ACTIONS(11983),
    [anon_sym_PLUS] = ACTIONS(11981),
    [anon_sym_AMP] = ACTIONS(11983),
    [anon_sym_GT] = ACTIONS(11981),
    [anon_sym_PERCENT] = ACTIONS(11983),
    [anon_sym_DASH_AT] = ACTIONS(11983),
    [anon_sym_EQ_EQ] = ACTIONS(11981),
    [anon_sym_STAR] = ACTIONS(11981),
    [anon_sym_BANG_TILDE] = ACTIONS(11983),
    [sym_constant] = ACTIONS(14649),
    [anon_sym_DASH] = ACTIONS(11981),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(11983),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11981),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(11983),
    [anon_sym_STAR_STAR] = ACTIONS(11983),
    [anon_sym_PIPE] = ACTIONS(11983),
    [anon_sym_DOT_DOT] = ACTIONS(11983),
    [anon_sym_LT_EQ_GT] = ACTIONS(11983),
    [anon_sym_LT_EQ] = ACTIONS(11981),
    [anon_sym_BANG] = ACTIONS(11981),
    [sym_identifier] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(11983),
  },
  [7710] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [7711] = {
    [sym_assignment] = STATE(9984),
    [sym_unary] = STATE(9984),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(9984),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(9984),
    [sym_conditional] = STATE(9984),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(9984),
    [sym_binary] = STATE(9984),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [7712] = {
    [sym_assignment] = STATE(9985),
    [sym_unary] = STATE(9985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(9985),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(9985),
    [sym_conditional] = STATE(9985),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(9985),
    [sym_binary] = STATE(9985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [7713] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7714] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7715] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7716] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_heredoc_body] = STATE(9986),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym_float] = ACTIONS(3980),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(3984),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(3984),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8012),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(3994),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [sym_class_variable] = ACTIONS(3994),
    [sym__block_ampersand] = ACTIONS(8016),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4006),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14651),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [7717] = {
    [sym_heredoc_body] = STATE(9987),
    [aux_sym_call_repeat1] = STATE(9987),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7718] = {
    [sym_heredoc_body] = STATE(9988),
    [aux_sym_call_repeat1] = STATE(9988),
    [aux_sym_argument_list_repeat1] = STATE(9989),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11995),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [7719] = {
    [aux_sym_chained_string_repeat1] = STATE(7719),
    [sym_string] = STATE(7719),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [7720] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_COLON2] = ACTIONS(9897),
    [anon_sym_while] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
    [sym__binary_minus] = ACTIONS(9899),
  },
  [7721] = {
    [anon_sym_end] = ACTIONS(14653),
    [sym_comment] = ACTIONS(49),
  },
  [7722] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(9991),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14653),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [7723] = {
    [sym_when] = STATE(9992),
    [sym_else] = STATE(9991),
    [aux_sym_case_repeat2] = STATE(9992),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14653),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [7724] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9993),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14655),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7725] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_COLON2] = ACTIONS(10206),
    [anon_sym_while] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
    [sym__binary_minus] = ACTIONS(10208),
  },
  [7726] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2235),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2236),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(9994),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2239),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2240),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14657),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7727] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_COLON2] = ACTIONS(10258),
    [anon_sym_while] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
    [sym__binary_minus] = ACTIONS(10260),
  },
  [7728] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_COLON2] = ACTIONS(10697),
    [anon_sym_while] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
    [sym__binary_minus] = ACTIONS(10699),
  },
  [7729] = {
    [anon_sym_end] = ACTIONS(14659),
    [sym_comment] = ACTIONS(49),
  },
  [7730] = {
    [sym_ensure] = STATE(9996),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14659),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [7731] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10925),
    [anon_sym_while] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
  },
  [7732] = {
    [anon_sym_end] = ACTIONS(14661),
    [sym_comment] = ACTIONS(49),
  },
  [7733] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_COLON2] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
    [sym__binary_minus] = ACTIONS(10933),
  },
  [7734] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14663),
  },
  [7735] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_COLON2] = ACTIONS(10937),
    [anon_sym_while] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
    [sym__binary_minus] = ACTIONS(10939),
  },
  [7736] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14665),
    [sym__string_end] = ACTIONS(14663),
  },
  [7737] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_COLON2] = ACTIONS(10943),
    [anon_sym_while] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
    [sym__binary_minus] = ACTIONS(10945),
  },
  [7738] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14667),
  },
  [7739] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [7740] = {
    [anon_sym_RPAREN] = ACTIONS(14669),
    [sym_comment] = ACTIONS(49),
  },
  [7741] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [7742] = {
    [anon_sym_SLASH] = ACTIONS(10967),
    [anon_sym_until] = ACTIONS(10969),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [anon_sym_RBRACE] = ACTIONS(10969),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_unless] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_rescue] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_LBRACE] = ACTIONS(10969),
    [anon_sym_COLON2] = ACTIONS(10967),
    [anon_sym_while] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [anon_sym_if] = ACTIONS(10969),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [7743] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [7744] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [7745] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [7746] = {
    [sym_assignment] = STATE(10002),
    [sym_unary] = STATE(10002),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10002),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10002),
    [sym_conditional] = STATE(10002),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10002),
    [sym_binary] = STATE(10002),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7747] = {
    [sym_assignment] = STATE(4861),
    [sym_unary] = STATE(4861),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4861),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_splat_argument] = STATE(10003),
    [sym_operator_assignment] = STATE(4861),
    [sym_conditional] = STATE(4861),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_return] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_subshell] = STATE(674),
    [sym__arg_or_splat_arg] = STATE(10003),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(4861),
    [sym_binary] = STATE(4861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(8080),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(1239),
    [sym_character] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7748] = {
    [sym_assignment] = STATE(10004),
    [sym_unary] = STATE(10004),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10004),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10004),
    [sym_conditional] = STATE(10004),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10004),
    [sym_binary] = STATE(10004),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7749] = {
    [sym_assignment] = STATE(10005),
    [sym_unary] = STATE(10005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10005),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10005),
    [sym_conditional] = STATE(10005),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10005),
    [sym_binary] = STATE(10005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7750] = {
    [sym_assignment] = STATE(10007),
    [sym_unary] = STATE(10007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10007),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10007),
    [sym_conditional] = STATE(10007),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10007),
    [sym_binary] = STATE(10007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7751] = {
    [sym_assignment] = STATE(10008),
    [sym_unary] = STATE(10008),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10008),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10008),
    [sym_conditional] = STATE(10008),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10008),
    [sym_binary] = STATE(10008),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7752] = {
    [sym_assignment] = STATE(10009),
    [sym_unary] = STATE(10009),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10009),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10009),
    [sym_conditional] = STATE(10009),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10009),
    [sym_binary] = STATE(10009),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7753] = {
    [sym_assignment] = STATE(10010),
    [sym_unary] = STATE(10010),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10010),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10010),
    [sym_conditional] = STATE(10010),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10010),
    [sym_binary] = STATE(10010),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7754] = {
    [sym_assignment] = STATE(10011),
    [sym_unary] = STATE(10011),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10011),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10011),
    [sym_conditional] = STATE(10011),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10011),
    [sym_binary] = STATE(10011),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7755] = {
    [sym_assignment] = STATE(10012),
    [sym_unary] = STATE(10012),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10012),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10012),
    [sym_conditional] = STATE(10012),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10012),
    [sym_binary] = STATE(10012),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7756] = {
    [sym_assignment] = STATE(10013),
    [sym_unary] = STATE(10013),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10013),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(10013),
    [sym_conditional] = STATE(10013),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(10013),
    [sym_binary] = STATE(10013),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7757] = {
    [aux_sym_chained_string_repeat1] = STATE(10014),
    [sym_string] = STATE(10014),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [7758] = {
    [sym_assignment] = STATE(4861),
    [sym_unary] = STATE(4861),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(4861),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_splat_argument] = STATE(10015),
    [sym_operator_assignment] = STATE(4861),
    [sym_conditional] = STATE(4861),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_return] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_true] = STATE(4860),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym__arg_or_splat_arg] = STATE(10015),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(4861),
    [sym_binary] = STATE(4861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(8080),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(1239),
    [sym_character] = ACTIONS(1243),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [7759] = {
    [aux_sym_exceptions_repeat1] = STATE(10016),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(12065),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [7760] = {
    [anon_sym_SLASH] = ACTIONS(9417),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_while] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [7761] = {
    [anon_sym_RBRACE] = ACTIONS(14671),
    [sym_comment] = ACTIONS(49),
  },
  [7762] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [7763] = {
    [anon_sym_SLASH] = ACTIONS(9248),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_while] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [7764] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10019),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14673),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7765] = {
    [anon_sym_end] = ACTIONS(14675),
    [sym_comment] = ACTIONS(49),
  },
  [7766] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(10020),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(10020),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10019),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(14677),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(14677),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14673),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7767] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [7768] = {
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_until] = ACTIONS(2885),
    [anon_sym_AMP_EQ] = ACTIONS(2885),
    [anon_sym_GT_GT_EQ] = ACTIONS(2885),
    [anon_sym_SLASH_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [sym__binary_star] = ACTIONS(2885),
    [anon_sym_unless] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_COLON_COLON2] = ACTIONS(2885),
    [anon_sym_rescue] = ACTIONS(2885),
    [anon_sym_PERCENT_EQ] = ACTIONS(2885),
    [anon_sym_LT_LT_EQ] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2885),
    [sym__heredoc_body_start] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_CARET_EQ] = ACTIONS(2885),
    [anon_sym_AMP_DOT] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_DOT_DOT] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_PIPE_EQ] = ACTIONS(2885),
    [anon_sym_PLUS_EQ] = ACTIONS(2885),
    [anon_sym_STAR_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2885),
    [anon_sym_DASH_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2885),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_STAR_STAR] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [sym__binary_minus] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_CARET] = ACTIONS(2883),
  },
  [7769] = {
    [sym__terminator] = STATE(10021),
    [sym_heredoc_body] = STATE(10021),
    [sym__do] = STATE(10021),
    [sym__line_break] = ACTIONS(14679),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(14679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14679),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [7770] = {
    [sym_heredoc_body] = STATE(10022),
    [sym__terminator] = STATE(10022),
    [sym__line_break] = ACTIONS(14681),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(14681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [7771] = {
    [sym_when] = STATE(10025),
    [sym_else] = STATE(10024),
    [aux_sym_case_repeat2] = STATE(10025),
    [aux_sym_case_repeat1] = STATE(10026),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14683),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(14685),
    [sym_comment] = ACTIONS(49),
  },
  [7772] = {
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2873),
    [anon_sym_until] = ACTIONS(2873),
    [anon_sym_AMP_EQ] = ACTIONS(2873),
    [anon_sym_GT_GT_EQ] = ACTIONS(2873),
    [anon_sym_SLASH_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2873),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_EQ_TILDE] = ACTIONS(2873),
    [anon_sym_LT_LT] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [sym__binary_star] = ACTIONS(2873),
    [anon_sym_unless] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [anon_sym_COLON_COLON2] = ACTIONS(2873),
    [anon_sym_rescue] = ACTIONS(2873),
    [anon_sym_PERCENT_EQ] = ACTIONS(2873),
    [anon_sym_LT_LT_EQ] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_BANG_TILDE] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2873),
    [sym__heredoc_body_start] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_CARET_EQ] = ACTIONS(2873),
    [anon_sym_AMP_DOT] = ACTIONS(2873),
    [anon_sym_LT_EQ] = ACTIONS(2871),
    [anon_sym_PIPE] = ACTIONS(2871),
    [anon_sym_DOT_DOT] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_LT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2873),
    [anon_sym_GT_GT] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2871),
    [anon_sym_PIPE_EQ] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(2873),
    [anon_sym_STAR_EQ] = ACTIONS(2873),
    [anon_sym_EQ_EQ] = ACTIONS(2871),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_GT_EQ] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2873),
    [anon_sym_DASH_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_LT_EQ_GT] = ACTIONS(2873),
    [sym__binary_minus] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_CARET] = ACTIONS(2871),
  },
  [7773] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(10029),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14687),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14689),
  },
  [7774] = {
    [aux_sym_string_array_repeat1] = STATE(10032),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14691),
    [sym__string_end] = ACTIONS(14693),
  },
  [7775] = {
    [anon_sym_SLASH] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_until] = ACTIONS(2305),
    [anon_sym_AMP_EQ] = ACTIONS(2305),
    [anon_sym_GT_GT_EQ] = ACTIONS(2305),
    [anon_sym_SLASH_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_EQ_TILDE] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [sym__binary_star] = ACTIONS(2305),
    [anon_sym_unless] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_PERCENT] = ACTIONS(2303),
    [anon_sym_COLON_COLON2] = ACTIONS(2305),
    [anon_sym_rescue] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(2305),
    [anon_sym_LT_LT_EQ] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(2303),
    [anon_sym_BANG_TILDE] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_COLON2] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2305),
    [sym__heredoc_body_start] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2305),
    [anon_sym_CARET_EQ] = ACTIONS(2305),
    [anon_sym_AMP_DOT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_in] = ACTIONS(2305),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2305),
    [anon_sym_or] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_PIPE_EQ] = ACTIONS(2305),
    [anon_sym_PLUS_EQ] = ACTIONS(2305),
    [anon_sym_STAR_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_and] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2305),
    [anon_sym_DASH_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2305),
    [anon_sym_STAR_STAR] = ACTIONS(2303),
    [anon_sym_LT_EQ_GT] = ACTIONS(2305),
    [sym__binary_minus] = ACTIONS(2305),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2305),
    [anon_sym_CARET] = ACTIONS(2303),
  },
  [7776] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14695),
  },
  [7777] = {
    [anon_sym_SLASH] = ACTIONS(2385),
    [anon_sym_RBRACK] = ACTIONS(2387),
    [anon_sym_until] = ACTIONS(2387),
    [anon_sym_AMP_EQ] = ACTIONS(2387),
    [anon_sym_GT_GT_EQ] = ACTIONS(2387),
    [anon_sym_SLASH_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [sym__binary_star] = ACTIONS(2387),
    [anon_sym_unless] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2385),
    [anon_sym_COLON_COLON2] = ACTIONS(2387),
    [anon_sym_rescue] = ACTIONS(2387),
    [anon_sym_PERCENT_EQ] = ACTIONS(2387),
    [anon_sym_LT_LT_EQ] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2385),
    [anon_sym_BANG_TILDE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_COLON2] = ACTIONS(2385),
    [anon_sym_while] = ACTIONS(2387),
    [sym__heredoc_body_start] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2387),
    [anon_sym_CARET_EQ] = ACTIONS(2387),
    [anon_sym_AMP_DOT] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2385),
    [anon_sym_DOT_DOT] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2385),
    [anon_sym_in] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2387),
    [anon_sym_or] = ACTIONS(2387),
    [anon_sym_GT] = ACTIONS(2385),
    [anon_sym_PIPE_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [anon_sym_STAR_EQ] = ACTIONS(2387),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_and] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_LBRACK] = ACTIONS(2387),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_STAR_STAR] = ACTIONS(2385),
    [anon_sym_LT_EQ_GT] = ACTIONS(2387),
    [sym__binary_minus] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [anon_sym_if] = ACTIONS(2387),
    [anon_sym_CARET] = ACTIONS(2385),
  },
  [7778] = {
    [anon_sym_RPAREN] = ACTIONS(14697),
    [sym_comment] = ACTIONS(49),
  },
  [7779] = {
    [anon_sym_SLASH] = ACTIONS(2531),
    [anon_sym_RBRACK] = ACTIONS(2533),
    [anon_sym_until] = ACTIONS(2533),
    [anon_sym_AMP_EQ] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_EQ_TILDE] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2531),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [sym__binary_star] = ACTIONS(2533),
    [anon_sym_unless] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2531),
    [anon_sym_COLON_COLON2] = ACTIONS(2533),
    [anon_sym_rescue] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2531),
    [anon_sym_BANG_TILDE] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_COLON2] = ACTIONS(2531),
    [anon_sym_while] = ACTIONS(2533),
    [sym__heredoc_body_start] = ACTIONS(2533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2533),
    [anon_sym_AMP_DOT] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_DOT_DOT] = ACTIONS(2531),
    [anon_sym_EQ] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_in] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2533),
    [anon_sym_or] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_PIPE_EQ] = ACTIONS(2533),
    [anon_sym_PLUS_EQ] = ACTIONS(2533),
    [anon_sym_STAR_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_and] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2531),
    [anon_sym_LT_EQ_GT] = ACTIONS(2533),
    [sym__binary_minus] = ACTIONS(2533),
    [anon_sym_AMP_AMP] = ACTIONS(2531),
    [anon_sym_if] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2531),
  },
  [7780] = {
    [sym__terminator] = STATE(10035),
    [sym_heredoc_body] = STATE(10035),
    [sym_then] = STATE(10036),
    [sym__line_break] = ACTIONS(14699),
    [anon_sym_then] = ACTIONS(1133),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(1141),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(14699),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [7781] = {
    [sym_assignment] = STATE(10037),
    [sym_unary] = STATE(10037),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(318),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(10037),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(318),
    [sym_operator_assignment] = STATE(10037),
    [sym_conditional] = STATE(10037),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(321),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(318),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(322),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(318),
    [sym_range] = STATE(10037),
    [sym_binary] = STATE(10037),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(318),
    [sym_nil] = STATE(318),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(593),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_not] = ACTIONS(595),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(597),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(599),
    [anon_sym_next] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(591),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(603),
  },
  [7782] = {
    [sym_heredoc_body] = STATE(10038),
    [sym__terminator] = STATE(10038),
    [sym_superclass] = STATE(10039),
    [sym__line_break] = ACTIONS(14701),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(14701),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7783] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_superclass] = STATE(10039),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(10038),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(10038),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(14701),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(14701),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [7784] = {
    [sym_heredoc_body] = STATE(10041),
    [sym__terminator] = STATE(10041),
    [sym__line_break] = ACTIONS(14703),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [sym_self] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_nil] = ACTIONS(1349),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(14703),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [anon_sym_next] = ACTIONS(1349),
    [sym_retry] = ACTIONS(1349),
    [sym__regex_start] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(14705),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1349),
  },
  [7785] = {
    [sym_block] = STATE(1097),
    [sym_unary] = STATE(1455),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_for] = STATE(917),
    [sym_if] = STATE(917),
    [sym__primary] = STATE(917),
    [sym_argument_list] = STATE(1099),
    [sym_hash_splat_argument] = STATE(1453),
    [sym_method] = STATE(917),
    [sym_conditional] = STATE(1455),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_subshell] = STATE(917),
    [sym_unless] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_block_argument] = STATE(1453),
    [sym_range] = STATE(1455),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1454),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_array] = STATE(917),
    [sym__terminator] = STATE(10041),
    [sym_call] = STATE(1002),
    [sym__argument] = STATE(1453),
    [sym_assignment] = STATE(1455),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_pair] = STATE(1453),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(1455),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(1453),
    [sym_operator_assignment] = STATE(1455),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(1456),
    [sym_heredoc_body] = STATE(10041),
    [sym_lambda] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym__argument_list_with_parens] = STATE(1457),
    [sym_do_block] = STATE(1097),
    [sym_binary] = STATE(1455),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_nil] = STATE(1454),
    [sym_symbol_array] = STATE(917),
    [sym_case] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_scope_resolution] = STATE(1002),
    [sym__line_break] = ACTIONS(14703),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_DOT] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [sym_constant] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [sym__identifier_hash_key] = ACTIONS(2555),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2551),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(14703),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [sym__splat_star] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_end] = ACTIONS(14705),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2571),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [7786] = {
    [anon_sym_end] = ACTIONS(14707),
    [sym_comment] = ACTIONS(49),
  },
  [7787] = {
    [sym_ensure] = STATE(10043),
    [sym_else] = STATE(10044),
    [anon_sym_end] = ACTIONS(14707),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [7788] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(10045),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14709),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7789] = {
    [anon_sym_SLASH] = ACTIONS(2741),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_until] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_EQ_TILDE] = ACTIONS(2743),
    [anon_sym_LT_LT] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [sym__binary_star] = ACTIONS(2743),
    [anon_sym_unless] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_PERCENT] = ACTIONS(2741),
    [anon_sym_COLON_COLON2] = ACTIONS(2743),
    [anon_sym_rescue] = ACTIONS(2743),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_BANG_TILDE] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_COLON2] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2743),
    [sym__heredoc_body_start] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_AMP_DOT] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2741),
    [anon_sym_PIPE] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_in] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_or] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_EQ_EQ] = ACTIONS(2741),
    [anon_sym_and] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2741),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2743),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_STAR] = ACTIONS(2741),
    [anon_sym_LT_EQ_GT] = ACTIONS(2743),
    [sym__binary_minus] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2741),
  },
  [7790] = {
    [sym_ensure] = STATE(10043),
    [sym_else] = STATE(10044),
    [sym_rescue] = STATE(10046),
    [anon_sym_rescue] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(14707),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [7791] = {
    [sym_ensure] = STATE(10043),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14707),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [7792] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7793] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7794] = {
    [anon_sym_SLASH] = ACTIONS(2575),
    [anon_sym_RBRACK] = ACTIONS(2577),
    [anon_sym_until] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2577),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_EQ_TILDE] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [sym__binary_star] = ACTIONS(2577),
    [anon_sym_unless] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_COLON_COLON2] = ACTIONS(2577),
    [anon_sym_rescue] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2577),
    [anon_sym_COLON2] = ACTIONS(2575),
    [anon_sym_while] = ACTIONS(2577),
    [sym__heredoc_body_start] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_DOT] = ACTIONS(2577),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_in] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(2577),
    [anon_sym_COMMA] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2577),
    [anon_sym_or] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_and] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_GT_EQ] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2577),
    [anon_sym_BANG_EQ] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2577),
    [sym__binary_minus] = ACTIONS(2577),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_CARET] = ACTIONS(2575),
  },
  [7795] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14711),
  },
  [7796] = {
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_until] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_EQ_TILDE] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [sym__binary_star] = ACTIONS(1227),
    [anon_sym_unless] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_COLON_COLON2] = ACTIONS(1227),
    [anon_sym_rescue] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_BANG_TILDE] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_COLON2] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1227),
    [sym__heredoc_body_start] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_AMP_DOT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1225),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ_GT] = ACTIONS(1227),
    [sym__binary_minus] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1225),
  },
  [7797] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(10050),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14713),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14715),
  },
  [7798] = {
    [aux_sym_symbol_array_repeat1] = STATE(10053),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14717),
    [sym__string_end] = ACTIONS(14719),
  },
  [7799] = {
    [anon_sym_SLASH] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1339),
    [anon_sym_AMP_EQ] = ACTIONS(1339),
    [anon_sym_GT_GT_EQ] = ACTIONS(1339),
    [anon_sym_SLASH_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_EQ_TILDE] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [sym__binary_star] = ACTIONS(1339),
    [anon_sym_unless] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_COLON_COLON2] = ACTIONS(1339),
    [anon_sym_rescue] = ACTIONS(1339),
    [anon_sym_PERCENT_EQ] = ACTIONS(1339),
    [anon_sym_LT_LT_EQ] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1337),
    [anon_sym_BANG_TILDE] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_COLON2] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1339),
    [sym__heredoc_body_start] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_CARET_EQ] = ACTIONS(1339),
    [anon_sym_AMP_DOT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1339),
    [anon_sym_COMMA] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1339),
    [anon_sym_PLUS_EQ] = ACTIONS(1339),
    [anon_sym_STAR_EQ] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1339),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1339),
    [anon_sym_DASH_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1339),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_LT_EQ_GT] = ACTIONS(1339),
    [sym__binary_minus] = ACTIONS(1339),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1337),
  },
  [7800] = {
    [anon_sym_RBRACK] = ACTIONS(14721),
    [sym_comment] = ACTIONS(49),
  },
  [7801] = {
    [anon_sym_SLASH] = ACTIONS(1633),
    [anon_sym_RBRACK] = ACTIONS(1635),
    [anon_sym_until] = ACTIONS(1635),
    [anon_sym_AMP_EQ] = ACTIONS(1635),
    [anon_sym_GT_GT_EQ] = ACTIONS(1635),
    [anon_sym_SLASH_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_unless] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_COLON_COLON2] = ACTIONS(1635),
    [anon_sym_rescue] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(1635),
    [anon_sym_LT_LT_EQ] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_CARET_EQ] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PIPE_EQ] = ACTIONS(1635),
    [anon_sym_PLUS_EQ] = ACTIONS(1635),
    [anon_sym_STAR_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1635),
    [anon_sym_DASH_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
  },
  [7802] = {
    [sym_heredoc_body] = STATE(10056),
    [sym__heredoc_body_start] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(14723),
    [sym_comment] = ACTIONS(49),
  },
  [7803] = {
    [anon_sym_RBRACE] = ACTIONS(14723),
    [sym_comment] = ACTIONS(49),
  },
  [7804] = {
    [anon_sym_SLASH] = ACTIONS(2851),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_until] = ACTIONS(2853),
    [anon_sym_AMP_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_SLASH_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_EQ_TILDE] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [sym__binary_star] = ACTIONS(2853),
    [anon_sym_unless] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_COLON_COLON2] = ACTIONS(2853),
    [anon_sym_rescue] = ACTIONS(2853),
    [anon_sym_PERCENT_EQ] = ACTIONS(2853),
    [anon_sym_LT_LT_EQ] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_BANG_TILDE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2853),
    [anon_sym_COLON2] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2853),
    [sym__heredoc_body_start] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_CARET_EQ] = ACTIONS(2853),
    [anon_sym_AMP_DOT] = ACTIONS(2853),
    [anon_sym_LT_EQ] = ACTIONS(2851),
    [anon_sym_PIPE] = ACTIONS(2851),
    [anon_sym_DOT_DOT] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_PLUS_EQ] = ACTIONS(2853),
    [anon_sym_STAR_EQ] = ACTIONS(2853),
    [anon_sym_EQ_EQ] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2853),
    [anon_sym_DASH_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2853),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_STAR_STAR] = ACTIONS(2851),
    [anon_sym_LT_EQ_GT] = ACTIONS(2853),
    [sym__binary_minus] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2851),
  },
  [7805] = {
    [sym__terminator] = STATE(10057),
    [sym_heredoc_body] = STATE(10057),
    [sym__do] = STATE(10057),
    [sym__line_break] = ACTIONS(14725),
    [anon_sym_LT] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(969),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(14725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(975),
    [sym__binary_star] = ACTIONS(965),
    [anon_sym_EQ_TILDE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_TILDE] = ACTIONS(969),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(969),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14725),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_LT_EQ] = ACTIONS(963),
    [anon_sym_LT_EQ_GT] = ACTIONS(969),
    [anon_sym_DOT_DOT] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(969),
    [anon_sym_PIPE] = ACTIONS(989),
    [sym__binary_minus] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(991),
  },
  [7806] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [7807] = {
    [anon_sym_SLASH] = ACTIONS(2861),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_until] = ACTIONS(2863),
    [anon_sym_AMP_EQ] = ACTIONS(2863),
    [anon_sym_GT_GT_EQ] = ACTIONS(2863),
    [anon_sym_SLASH_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [sym__binary_star] = ACTIONS(2863),
    [anon_sym_unless] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_COLON_COLON2] = ACTIONS(2863),
    [anon_sym_rescue] = ACTIONS(2863),
    [anon_sym_PERCENT_EQ] = ACTIONS(2863),
    [anon_sym_LT_LT_EQ] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2861),
    [anon_sym_BANG_TILDE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_COLON2] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2863),
    [sym__heredoc_body_start] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_CARET_EQ] = ACTIONS(2863),
    [anon_sym_AMP_DOT] = ACTIONS(2863),
    [anon_sym_LT_EQ] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_in] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_PIPE_EQ] = ACTIONS(2863),
    [anon_sym_PLUS_EQ] = ACTIONS(2863),
    [anon_sym_STAR_EQ] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2861),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2861),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2863),
    [anon_sym_DASH_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2861),
    [anon_sym_LT_EQ_GT] = ACTIONS(2863),
    [sym__binary_minus] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2861),
  },
  [7808] = {
    [sym_in] = STATE(10058),
    [sym_comment] = ACTIONS(49),
    [anon_sym_in] = ACTIONS(1969),
  },
  [7809] = {
    [anon_sym_SLASH] = ACTIONS(1851),
    [anon_sym_RBRACK] = ACTIONS(1853),
    [anon_sym_until] = ACTIONS(1853),
    [anon_sym_AMP_EQ] = ACTIONS(1853),
    [anon_sym_GT_GT_EQ] = ACTIONS(1853),
    [anon_sym_SLASH_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_unless] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1851),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_rescue] = ACTIONS(1853),
    [anon_sym_PERCENT_EQ] = ACTIONS(1853),
    [anon_sym_LT_LT_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_while] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_CARET_EQ] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_in] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_PLUS_EQ] = ACTIONS(1853),
    [anon_sym_STAR_EQ] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1853),
    [anon_sym_DASH_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1851),
  },
  [7810] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14727),
  },
  [7811] = {
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_until] = ACTIONS(2857),
    [anon_sym_AMP_EQ] = ACTIONS(2857),
    [anon_sym_GT_GT_EQ] = ACTIONS(2857),
    [anon_sym_SLASH_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_EQ_TILDE] = ACTIONS(2857),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [sym__binary_star] = ACTIONS(2857),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_COLON_COLON2] = ACTIONS(2857),
    [anon_sym_rescue] = ACTIONS(2857),
    [anon_sym_PERCENT_EQ] = ACTIONS(2857),
    [anon_sym_LT_LT_EQ] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_BANG_TILDE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_COLON2] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2857),
    [sym__heredoc_body_start] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_CARET_EQ] = ACTIONS(2857),
    [anon_sym_AMP_DOT] = ACTIONS(2857),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_PIPE_EQ] = ACTIONS(2857),
    [anon_sym_PLUS_EQ] = ACTIONS(2857),
    [anon_sym_STAR_EQ] = ACTIONS(2857),
    [anon_sym_EQ_EQ] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2857),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_GT_EQ] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2857),
    [anon_sym_DASH_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_LT_EQ_GT] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_CARET] = ACTIONS(2855),
  },
  [7812] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(14729),
  },
  [7813] = {
    [anon_sym_SLASH] = ACTIONS(2043),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_until] = ACTIONS(2045),
    [anon_sym_AMP_EQ] = ACTIONS(2045),
    [anon_sym_GT_GT_EQ] = ACTIONS(2045),
    [anon_sym_SLASH_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2045),
    [anon_sym_RPAREN] = ACTIONS(2045),
    [anon_sym_EQ_TILDE] = ACTIONS(2045),
    [anon_sym_LT_LT] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [sym__binary_star] = ACTIONS(2045),
    [anon_sym_unless] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2043),
    [anon_sym_COLON_COLON2] = ACTIONS(2045),
    [anon_sym_rescue] = ACTIONS(2045),
    [anon_sym_PERCENT_EQ] = ACTIONS(2045),
    [anon_sym_LT_LT_EQ] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2043),
    [anon_sym_BANG_TILDE] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_COLON2] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2045),
    [sym__heredoc_body_start] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_CARET_EQ] = ACTIONS(2045),
    [anon_sym_AMP_DOT] = ACTIONS(2045),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_PIPE] = ACTIONS(2043),
    [anon_sym_DOT_DOT] = ACTIONS(2043),
    [anon_sym_EQ] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_in] = ACTIONS(2045),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(2045),
    [anon_sym_GT_GT] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_PIPE_EQ] = ACTIONS(2045),
    [anon_sym_PLUS_EQ] = ACTIONS(2045),
    [anon_sym_STAR_EQ] = ACTIONS(2045),
    [anon_sym_EQ_EQ] = ACTIONS(2043),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_PIPE_PIPE] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2045),
    [anon_sym_DASH_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2045),
    [anon_sym_BANG_EQ] = ACTIONS(2045),
    [anon_sym_STAR_STAR] = ACTIONS(2043),
    [anon_sym_LT_EQ_GT] = ACTIONS(2045),
    [sym__binary_minus] = ACTIONS(2045),
    [anon_sym_AMP_AMP] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_CARET] = ACTIONS(2043),
  },
  [7814] = {
    [sym_do_block] = STATE(10061),
    [sym_block] = STATE(10061),
    [anon_sym_do] = ACTIONS(8419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(8417),
  },
  [7815] = {
    [sym_assignment] = STATE(10062),
    [sym_unary] = STATE(10062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10062),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(10062),
    [sym_conditional] = STATE(10062),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(10062),
    [sym_binary] = STATE(10062),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [7816] = {
    [sym_splat_parameter] = STATE(1174),
    [sym_heredoc_body] = STATE(10063),
    [sym_hash_splat_parameter] = STATE(1174),
    [sym_block_parameter] = STATE(1174),
    [sym__terminator] = STATE(10063),
    [sym__simple_formal_parameter] = STATE(1174),
    [sym_keyword_parameter] = STATE(1174),
    [sym_optional_parameter] = STATE(1174),
    [sym_method_parameters] = STATE(10063),
    [sym__line_break] = ACTIONS(14731),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(14731),
    [anon_sym_LPAREN] = ACTIONS(2099),
  },
  [7817] = {
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_RBRACK] = ACTIONS(2103),
    [anon_sym_until] = ACTIONS(2103),
    [anon_sym_AMP_EQ] = ACTIONS(2103),
    [anon_sym_GT_GT_EQ] = ACTIONS(2103),
    [anon_sym_SLASH_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_EQ_TILDE] = ACTIONS(2103),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [sym__binary_star] = ACTIONS(2103),
    [anon_sym_unless] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_COLON_COLON2] = ACTIONS(2103),
    [anon_sym_rescue] = ACTIONS(2103),
    [anon_sym_PERCENT_EQ] = ACTIONS(2103),
    [anon_sym_LT_LT_EQ] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_BANG_TILDE] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COLON2] = ACTIONS(2101),
    [anon_sym_while] = ACTIONS(2103),
    [sym__heredoc_body_start] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_CARET_EQ] = ACTIONS(2103),
    [anon_sym_AMP_DOT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2101),
    [anon_sym_DOT_DOT] = ACTIONS(2101),
    [anon_sym_EQ] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_in] = ACTIONS(2103),
    [anon_sym_QMARK] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2103),
    [anon_sym_or] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2101),
    [anon_sym_PIPE_EQ] = ACTIONS(2103),
    [anon_sym_PLUS_EQ] = ACTIONS(2103),
    [anon_sym_STAR_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2101),
    [anon_sym_and] = ACTIONS(2103),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2103),
    [anon_sym_DASH_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_LT_EQ_GT] = ACTIONS(2103),
    [sym__binary_minus] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_CARET] = ACTIONS(2101),
  },
  [7818] = {
    [anon_sym_DOT] = ACTIONS(14733),
    [anon_sym_COLON_COLON] = ACTIONS(14733),
    [sym_comment] = ACTIONS(49),
  },
  [7819] = {
    [anon_sym_SLASH] = ACTIONS(2299),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_until] = ACTIONS(2301),
    [anon_sym_AMP_EQ] = ACTIONS(2301),
    [anon_sym_GT_GT_EQ] = ACTIONS(2301),
    [anon_sym_SLASH_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_EQ_TILDE] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2299),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [sym__binary_star] = ACTIONS(2301),
    [anon_sym_unless] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2299),
    [anon_sym_COLON_COLON2] = ACTIONS(2301),
    [anon_sym_rescue] = ACTIONS(2301),
    [anon_sym_PERCENT_EQ] = ACTIONS(2301),
    [anon_sym_LT_LT_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2299),
    [anon_sym_BANG_TILDE] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_COLON2] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2301),
    [sym__heredoc_body_start] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2301),
    [anon_sym_CARET_EQ] = ACTIONS(2301),
    [anon_sym_AMP_DOT] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_DOT_DOT] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_in] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2301),
    [anon_sym_or] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_PIPE_EQ] = ACTIONS(2301),
    [anon_sym_PLUS_EQ] = ACTIONS(2301),
    [anon_sym_STAR_EQ] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_and] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2299),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2301),
    [anon_sym_DASH_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2299),
    [anon_sym_LT_EQ_GT] = ACTIONS(2301),
    [sym__binary_minus] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2299),
  },
  [7820] = {
    [sym__terminator] = STATE(10065),
    [sym_heredoc_body] = STATE(10065),
    [sym_then] = STATE(10066),
    [sym__line_break] = ACTIONS(14735),
    [anon_sym_then] = ACTIONS(2867),
    [anon_sym_unless] = ACTIONS(1135),
    [anon_sym_until] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1139),
    [sym__heredoc_body_start] = ACTIONS(2869),
    [anon_sym_rescue] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(14735),
    [anon_sym_if] = ACTIONS(1145),
    [sym_comment] = ACTIONS(49),
  },
  [7821] = {
    [sym_assignment] = STATE(10067),
    [sym_unary] = STATE(10067),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10067),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10067),
    [sym_conditional] = STATE(10067),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10067),
    [sym_binary] = STATE(10067),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7822] = {
    [sym_assignment] = STATE(10069),
    [sym_unary] = STATE(10069),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10069),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_splat_argument] = STATE(10070),
    [sym_operator_assignment] = STATE(10069),
    [sym_conditional] = STATE(10069),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_return] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_subshell] = STATE(4908),
    [sym__arg_or_splat_arg] = STATE(10070),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10069),
    [sym_binary] = STATE(10069),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [sym_global_variable] = ACTIONS(8146),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8122),
    [sym_character] = ACTIONS(8138),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7823] = {
    [sym_assignment] = STATE(10071),
    [sym_unary] = STATE(10071),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10071),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10071),
    [sym_conditional] = STATE(10071),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10071),
    [sym_binary] = STATE(10071),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7824] = {
    [sym_assignment] = STATE(10072),
    [sym_unary] = STATE(10072),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10072),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10072),
    [sym_conditional] = STATE(10072),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10072),
    [sym_binary] = STATE(10072),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7825] = {
    [sym_assignment] = STATE(10074),
    [sym_unary] = STATE(10074),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10074),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10074),
    [sym_conditional] = STATE(10074),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10074),
    [sym_binary] = STATE(10074),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7826] = {
    [sym_assignment] = STATE(10075),
    [sym_unary] = STATE(10075),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10075),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10075),
    [sym_conditional] = STATE(10075),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10075),
    [sym_binary] = STATE(10075),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7827] = {
    [sym_assignment] = STATE(10076),
    [sym_unary] = STATE(10076),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10076),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10076),
    [sym_conditional] = STATE(10076),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10076),
    [sym_binary] = STATE(10076),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7828] = {
    [sym_assignment] = STATE(10077),
    [sym_unary] = STATE(10077),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10077),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10077),
    [sym_conditional] = STATE(10077),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10077),
    [sym_binary] = STATE(10077),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7829] = {
    [sym_assignment] = STATE(10078),
    [sym_unary] = STATE(10078),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10078),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10078),
    [sym_conditional] = STATE(10078),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10078),
    [sym_binary] = STATE(10078),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7830] = {
    [sym_assignment] = STATE(10079),
    [sym_unary] = STATE(10079),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10079),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10079),
    [sym_conditional] = STATE(10079),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10079),
    [sym_binary] = STATE(10079),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7831] = {
    [sym_assignment] = STATE(10080),
    [sym_unary] = STATE(10080),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10080),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(10080),
    [sym_conditional] = STATE(10080),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10080),
    [sym_binary] = STATE(10080),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [7832] = {
    [aux_sym_chained_string_repeat1] = STATE(10081),
    [sym_string] = STATE(10081),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7833] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9738),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_or] = ACTIONS(9738),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9738),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
  },
  [7834] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [7835] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7836] = {
    [aux_sym_exceptions_repeat1] = STATE(10083),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [7837] = {
    [anon_sym_SLASH] = ACTIONS(6215),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [anon_sym_until] = ACTIONS(4446),
    [anon_sym_AMP_EQ] = ACTIONS(4446),
    [anon_sym_GT_GT_EQ] = ACTIONS(4446),
    [anon_sym_SLASH_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_EQ_TILDE] = ACTIONS(4446),
    [anon_sym_LT_LT] = ACTIONS(6215),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [sym__binary_star] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [anon_sym_rescue] = ACTIONS(4446),
    [anon_sym_PERCENT_EQ] = ACTIONS(4446),
    [anon_sym_LT_LT_EQ] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_BANG_TILDE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_COLON2] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_CARET_EQ] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_DOT_DOT] = ACTIONS(6215),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_in] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(4446),
    [anon_sym_COMMA] = ACTIONS(4446),
    [anon_sym_GT_GT] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4446),
    [anon_sym_or] = ACTIONS(4446),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_PIPE_EQ] = ACTIONS(4446),
    [anon_sym_PLUS_EQ] = ACTIONS(4446),
    [anon_sym_STAR_EQ] = ACTIONS(4446),
    [anon_sym_EQ_EQ] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(4446),
    [anon_sym_PIPE_PIPE] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4446),
    [anon_sym_DASH_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4446),
    [anon_sym_BANG_EQ] = ACTIONS(4446),
    [anon_sym_STAR_STAR] = ACTIONS(6215),
    [anon_sym_LT_EQ_GT] = ACTIONS(4446),
    [sym__binary_minus] = ACTIONS(4446),
    [anon_sym_AMP_AMP] = ACTIONS(6215),
    [anon_sym_if] = ACTIONS(4446),
    [anon_sym_CARET] = ACTIONS(6215),
  },
  [7838] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(14737),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [7839] = {
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7840] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(2283),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym_float] = ACTIONS(3980),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(3984),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(3984),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(3992),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(4000),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_yield] = ACTIONS(4002),
    [sym_class_variable] = ACTIONS(3994),
    [sym__block_ampersand] = ACTIONS(4004),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4006),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12157),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [7841] = {
    [sym_heredoc_body] = STATE(7841),
    [aux_sym_call_repeat1] = STATE(7841),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [7842] = {
    [sym_heredoc_body] = STATE(7841),
    [aux_sym_call_repeat1] = STATE(7841),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [7843] = {
    [aux_sym_argument_list_repeat1] = STATE(7843),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14742),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7844] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7845] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7846] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7847] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14745),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [7848] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7849] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7850] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7851] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [7852] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7853] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7854] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [7855] = {
    [aux_sym_chained_string_repeat1] = STATE(7855),
    [sym_string] = STATE(7855),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [7856] = {
    [sym_assignment] = STATE(10087),
    [sym_unary] = STATE(10087),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(677),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(10087),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(677),
    [sym_operator_assignment] = STATE(10087),
    [sym_conditional] = STATE(10087),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(675),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(677),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(679),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(677),
    [sym_range] = STATE(10087),
    [sym_binary] = STATE(10087),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(677),
    [sym_nil] = STATE(677),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_not] = ACTIONS(1287),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1249),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(1305),
    [anon_sym_next] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1317),
  },
  [7857] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [anon_sym_RBRACK] = ACTIONS(11545),
    [anon_sym_in] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_EQ_GT] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_COLON2] = ACTIONS(11543),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
    [anon_sym_EQ] = ACTIONS(11543),
  },
  [7858] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [anon_sym_RBRACK] = ACTIONS(11868),
    [anon_sym_in] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_EQ_GT] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
    [anon_sym_EQ] = ACTIONS(11866),
  },
  [7859] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [anon_sym_RBRACK] = ACTIONS(11879),
    [anon_sym_in] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_EQ_GT] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_COLON2] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
    [anon_sym_EQ] = ACTIONS(11877),
  },
  [7860] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14747),
  },
  [7861] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12164),
  },
  [7862] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [anon_sym_RBRACK] = ACTIONS(12632),
    [anon_sym_in] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_EQ_GT] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_COLON2] = ACTIONS(12630),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
    [anon_sym_EQ] = ACTIONS(12630),
  },
  [7863] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [anon_sym_RBRACK] = ACTIONS(12797),
    [anon_sym_in] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_EQ_GT] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_COLON2] = ACTIONS(12795),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
    [anon_sym_EQ] = ACTIONS(12795),
  },
  [7864] = {
    [anon_sym_end] = ACTIONS(14749),
    [sym_comment] = ACTIONS(49),
  },
  [7865] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [anon_sym_RBRACK] = ACTIONS(12905),
    [anon_sym_in] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
    [anon_sym_EQ] = ACTIONS(12903),
  },
  [7866] = {
    [anon_sym_end] = ACTIONS(14751),
    [sym_comment] = ACTIONS(49),
  },
  [7867] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10091),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14753),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7868] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [anon_sym_RBRACK] = ACTIONS(13019),
    [anon_sym_in] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
    [anon_sym_EQ] = ACTIONS(13017),
  },
  [7869] = {
    [sym__method_name] = STATE(714),
    [sym_setter] = STATE(714),
    [sym_symbol] = STATE(714),
    [sym_operator] = STATE(714),
    [sym__method_rest] = STATE(10092),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8273),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8273),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8273),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8273),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [7870] = {
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_SLASH] = ACTIONS(8575),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_in] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(8575),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_EQ_GT] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_COLON2] = ACTIONS(10412),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_AMP_AMP] = ACTIONS(8575),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [sym__binary_minus] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(10412),
  },
  [7871] = {
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_SLASH] = ACTIONS(12375),
    [anon_sym_RBRACK] = ACTIONS(12375),
    [anon_sym_in] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_PLUS] = ACTIONS(12375),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_PERCENT] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_EQ_GT] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_COLON2] = ACTIONS(13245),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(12375),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_AMP_AMP] = ACTIONS(12375),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [sym__binary_minus] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(12375),
    [anon_sym_EQ] = ACTIONS(13245),
  },
  [7872] = {
    [sym_assignment] = STATE(4982),
    [sym_unary] = STATE(4982),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(4982),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(4982),
    [sym_conditional] = STATE(4982),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_string] = STATE(691),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(4982),
    [sym_binary] = STATE(4982),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(203),
    [sym_character] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [7873] = {
    [aux_sym_exceptions_repeat1] = STATE(10093),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14755),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [7874] = {
    [sym_assignment] = STATE(10094),
    [sym_unary] = STATE(10094),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(10094),
    [sym__primary] = STATE(144),
    [sym_method_call] = STATE(727),
    [sym_operator_assignment] = STATE(10094),
    [sym_conditional] = STATE(10094),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_rational] = STATE(144),
    [sym_true] = STATE(727),
    [sym_return] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(691),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_range] = STATE(10094),
    [sym_binary] = STATE(10094),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(245),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_not] = ACTIONS(1383),
    [sym_self] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(259),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(227),
    [sym_character] = ACTIONS(205),
    [sym_super] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(197),
    [sym_constant] = ACTIONS(203),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym_instance_variable] = ACTIONS(227),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(203),
    [sym_redo] = ACTIONS(197),
    [sym_class_variable] = ACTIONS(227),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [7875] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [7876] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [7877] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [7878] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [7879] = {
    [sym_assignment] = STATE(10095),
    [sym_unary] = STATE(10095),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10095),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10095),
    [sym_conditional] = STATE(10095),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10095),
    [sym_binary] = STATE(10095),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7880] = {
    [sym_assignment] = STATE(10096),
    [sym_unary] = STATE(10096),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10096),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_splat_argument] = STATE(10097),
    [sym_operator_assignment] = STATE(10096),
    [sym_conditional] = STATE(10096),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_return] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_subshell] = STATE(768),
    [sym__arg_or_splat_arg] = STATE(10097),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10096),
    [sym_binary] = STATE(10096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [sym_global_variable] = ACTIONS(1441),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1413),
    [sym_character] = ACTIONS(1431),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7881] = {
    [sym_assignment] = STATE(10098),
    [sym_unary] = STATE(10098),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10098),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10098),
    [sym_conditional] = STATE(10098),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10098),
    [sym_binary] = STATE(10098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7882] = {
    [sym_assignment] = STATE(10099),
    [sym_unary] = STATE(10099),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10099),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10099),
    [sym_conditional] = STATE(10099),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10099),
    [sym_binary] = STATE(10099),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7883] = {
    [sym_assignment] = STATE(10101),
    [sym_unary] = STATE(10101),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10101),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10101),
    [sym_conditional] = STATE(10101),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10101),
    [sym_binary] = STATE(10101),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7884] = {
    [sym_assignment] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7885] = {
    [sym_assignment] = STATE(10103),
    [sym_unary] = STATE(10103),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10103),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10103),
    [sym_conditional] = STATE(10103),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10103),
    [sym_binary] = STATE(10103),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7886] = {
    [sym_assignment] = STATE(10104),
    [sym_unary] = STATE(10104),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10104),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10104),
    [sym_conditional] = STATE(10104),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10104),
    [sym_binary] = STATE(10104),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7887] = {
    [sym_assignment] = STATE(10105),
    [sym_unary] = STATE(10105),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10105),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10105),
    [sym_conditional] = STATE(10105),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10105),
    [sym_binary] = STATE(10105),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7888] = {
    [sym_assignment] = STATE(10106),
    [sym_unary] = STATE(10106),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10106),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10106),
    [sym_conditional] = STATE(10106),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10106),
    [sym_binary] = STATE(10106),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7889] = {
    [sym_assignment] = STATE(10107),
    [sym_unary] = STATE(10107),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10107),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(10107),
    [sym_conditional] = STATE(10107),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10107),
    [sym_binary] = STATE(10107),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7890] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(2360),
    [sym_unary] = STATE(2360),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(727),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(2360),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(727),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(2360),
    [sym_conditional] = STATE(2360),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(729),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(2361),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(727),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(727),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(2360),
    [sym_binary] = STATE(2360),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(727),
    [sym_nil] = STATE(727),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(4106),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4152),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(1375),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(4156),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1391),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12234),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [7891] = {
    [sym_heredoc_body] = STATE(7891),
    [aux_sym_call_repeat1] = STATE(7891),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_RBRACK] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [7892] = {
    [sym_heredoc_body] = STATE(7891),
    [aux_sym_call_repeat1] = STATE(7891),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_RBRACK] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [7893] = {
    [aux_sym_argument_list_repeat1] = STATE(7893),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14757),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [7894] = {
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_SLASH] = ACTIONS(7384),
    [anon_sym_RBRACK] = ACTIONS(7384),
    [anon_sym_in] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7384),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_COLON2] = ACTIONS(7382),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7384),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_AMP_AMP] = ACTIONS(7384),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7384),
    [anon_sym_EQ] = ACTIONS(7382),
  },
  [7895] = {
    [anon_sym_end] = ACTIONS(14760),
    [sym_comment] = ACTIONS(49),
  },
  [7896] = {
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_SLASH] = ACTIONS(9899),
    [anon_sym_RBRACK] = ACTIONS(9899),
    [anon_sym_in] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9899),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9899),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_COLON2] = ACTIONS(9897),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9899),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_AMP_AMP] = ACTIONS(9899),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9899),
    [anon_sym_EQ] = ACTIONS(9897),
  },
  [7897] = {
    [anon_sym_end] = ACTIONS(14762),
    [sym_comment] = ACTIONS(49),
  },
  [7898] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10110),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14762),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [7899] = {
    [sym_when] = STATE(10111),
    [sym_else] = STATE(10110),
    [aux_sym_case_repeat2] = STATE(10111),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14762),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [7900] = {
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_SLASH] = ACTIONS(10933),
    [anon_sym_RBRACK] = ACTIONS(10933),
    [anon_sym_in] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10933),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10933),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_COLON2] = ACTIONS(10931),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10933),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_AMP_AMP] = ACTIONS(10933),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10933),
    [anon_sym_EQ] = ACTIONS(10931),
  },
  [7901] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14764),
  },
  [7902] = {
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_SLASH] = ACTIONS(10939),
    [anon_sym_RBRACK] = ACTIONS(10939),
    [anon_sym_in] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10939),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10939),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_COLON2] = ACTIONS(10937),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10939),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_AMP_AMP] = ACTIONS(10939),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10939),
    [anon_sym_EQ] = ACTIONS(10937),
  },
  [7903] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14766),
    [sym__string_end] = ACTIONS(14764),
  },
  [7904] = {
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_SLASH] = ACTIONS(10945),
    [anon_sym_RBRACK] = ACTIONS(10945),
    [anon_sym_in] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10945),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10945),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_COLON2] = ACTIONS(10943),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10945),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_AMP_AMP] = ACTIONS(10945),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10945),
    [anon_sym_EQ] = ACTIONS(10943),
  },
  [7905] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14768),
  },
  [7906] = {
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_RBRACK] = ACTIONS(7790),
    [anon_sym_in] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_COLON2] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7788),
  },
  [7907] = {
    [anon_sym_end] = ACTIONS(14770),
    [sym_comment] = ACTIONS(49),
  },
  [7908] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(10116),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14772),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7909] = {
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_SLASH] = ACTIONS(10208),
    [anon_sym_RBRACK] = ACTIONS(10208),
    [anon_sym_in] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10208),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10208),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_COLON2] = ACTIONS(10206),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10208),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10208),
    [anon_sym_EQ] = ACTIONS(10206),
  },
  [7910] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2381),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2382),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(10117),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2385),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2386),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14774),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [7911] = {
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_SLASH] = ACTIONS(10260),
    [anon_sym_RBRACK] = ACTIONS(10260),
    [anon_sym_in] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10260),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10260),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_COLON2] = ACTIONS(10258),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10260),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_AMP_AMP] = ACTIONS(10260),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10260),
    [anon_sym_EQ] = ACTIONS(10258),
  },
  [7912] = {
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_SLASH] = ACTIONS(10699),
    [anon_sym_RBRACK] = ACTIONS(10699),
    [anon_sym_in] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10699),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10699),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_COLON2] = ACTIONS(10697),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10699),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_AMP_AMP] = ACTIONS(10699),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10699),
    [anon_sym_EQ] = ACTIONS(10697),
  },
  [7913] = {
    [anon_sym_end] = ACTIONS(14776),
    [sym_comment] = ACTIONS(49),
  },
  [7914] = {
    [sym_ensure] = STATE(10119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14776),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [7915] = {
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_SLASH] = ACTIONS(7872),
    [anon_sym_RBRACK] = ACTIONS(7872),
    [anon_sym_in] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7872),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7872),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_COLON2] = ACTIONS(7870),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7872),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7872),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7872),
    [anon_sym_EQ] = ACTIONS(7870),
  },
  [7916] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14778),
  },
  [7917] = {
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_SLASH] = ACTIONS(7878),
    [anon_sym_RBRACK] = ACTIONS(7878),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7878),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7878),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_AMP_AMP] = ACTIONS(7878),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7878),
    [anon_sym_EQ] = ACTIONS(7876),
  },
  [7918] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14780),
    [sym__string_end] = ACTIONS(14778),
  },
  [7919] = {
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_SLASH] = ACTIONS(8224),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_in] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8224),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_COLON2] = ACTIONS(8222),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8224),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_AMP_AMP] = ACTIONS(8224),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(8222),
  },
  [7920] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14782),
  },
  [7921] = {
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_SLASH] = ACTIONS(8851),
    [anon_sym_RBRACK] = ACTIONS(8851),
    [anon_sym_in] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8851),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_COLON2] = ACTIONS(8849),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8851),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_AMP_AMP] = ACTIONS(8851),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8851),
    [anon_sym_EQ] = ACTIONS(8849),
  },
  [7922] = {
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_SLASH] = ACTIONS(8872),
    [anon_sym_RBRACK] = ACTIONS(8872),
    [anon_sym_in] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8872),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8872),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_COLON2] = ACTIONS(8870),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8872),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_AMP_AMP] = ACTIONS(8872),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8872),
    [anon_sym_EQ] = ACTIONS(8870),
  },
  [7923] = {
    [anon_sym_end] = ACTIONS(14784),
    [sym_comment] = ACTIONS(49),
  },
  [7924] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10125),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14786),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7925] = {
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_SLASH] = ACTIONS(9250),
    [anon_sym_RBRACK] = ACTIONS(9250),
    [anon_sym_in] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9250),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9250),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_AMP_AMP] = ACTIONS(9250),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9250),
    [anon_sym_EQ] = ACTIONS(9248),
  },
  [7926] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10127),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14788),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7927] = {
    [anon_sym_end] = ACTIONS(14790),
    [sym_comment] = ACTIONS(49),
  },
  [7928] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(10128),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(10128),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10127),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(14792),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(14792),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14788),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7929] = {
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_SLASH] = ACTIONS(9419),
    [anon_sym_RBRACK] = ACTIONS(9419),
    [anon_sym_in] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9419),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9419),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_AMP_AMP] = ACTIONS(9419),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9419),
    [anon_sym_EQ] = ACTIONS(9417),
  },
  [7930] = {
    [anon_sym_RBRACE] = ACTIONS(14794),
    [sym_comment] = ACTIONS(49),
  },
  [7931] = {
    [anon_sym_DOT] = ACTIONS(14796),
    [anon_sym_COLON_COLON] = ACTIONS(14796),
    [sym_comment] = ACTIONS(49),
  },
  [7932] = {
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_SLASH] = ACTIONS(9602),
    [anon_sym_RBRACK] = ACTIONS(9602),
    [anon_sym_in] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9602),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9602),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_COLON2] = ACTIONS(9600),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9602),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_AMP_AMP] = ACTIONS(9602),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9602),
    [anon_sym_EQ] = ACTIONS(9600),
  },
  [7933] = {
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(9608),
    [anon_sym_RBRACK] = ACTIONS(9608),
    [anon_sym_in] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9608),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9608),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_COLON2] = ACTIONS(9606),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9608),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_AMP_AMP] = ACTIONS(9608),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9608),
    [anon_sym_EQ] = ACTIONS(9606),
  },
  [7934] = {
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_SLASH] = ACTIONS(10927),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10927),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10927),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10925),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10927),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_AMP_AMP] = ACTIONS(10927),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10927),
    [anon_sym_EQ] = ACTIONS(10925),
  },
  [7935] = {
    [anon_sym_end] = ACTIONS(14798),
    [sym_comment] = ACTIONS(49),
  },
  [7936] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [7937] = {
    [sym_assignment] = STATE(5063),
    [sym_unary] = STATE(5063),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(5063),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(5063),
    [sym_conditional] = STATE(5063),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_return] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_string] = STATE(771),
    [sym_true] = STATE(766),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(5063),
    [sym_binary] = STATE(5063),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8367),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_global_variable] = ACTIONS(1441),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1413),
    [sym_character] = ACTIONS(1431),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7938] = {
    [aux_sym_exceptions_repeat1] = STATE(10133),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14800),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [7939] = {
    [sym_assignment] = STATE(10134),
    [sym_unary] = STATE(10134),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(766),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10134),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(766),
    [sym_operator_assignment] = STATE(10134),
    [sym_conditional] = STATE(10134),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(770),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(766),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(766),
    [sym_range] = STATE(10134),
    [sym_binary] = STATE(10134),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(766),
    [sym_nil] = STATE(766),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1447),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(1453),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [7940] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [7941] = {
    [anon_sym_RPAREN] = ACTIONS(14802),
    [sym_comment] = ACTIONS(49),
  },
  [7942] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [anon_sym_RBRACK] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [7943] = {
    [anon_sym_SLASH] = ACTIONS(10967),
    [anon_sym_RBRACK] = ACTIONS(10969),
    [anon_sym_until] = ACTIONS(10969),
    [anon_sym_AMP_EQ] = ACTIONS(10969),
    [anon_sym_GT_GT_EQ] = ACTIONS(10969),
    [anon_sym_SLASH_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10969),
    [anon_sym_RPAREN] = ACTIONS(10969),
    [anon_sym_EQ_TILDE] = ACTIONS(10969),
    [anon_sym_LT_LT] = ACTIONS(10967),
    [sym__binary_star] = ACTIONS(10969),
    [anon_sym_RBRACE] = ACTIONS(10969),
    [anon_sym_unless] = ACTIONS(10969),
    [anon_sym_PLUS] = ACTIONS(10967),
    [anon_sym_AMP] = ACTIONS(10967),
    [anon_sym_PERCENT] = ACTIONS(10967),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [anon_sym_rescue] = ACTIONS(10969),
    [anon_sym_PERCENT_EQ] = ACTIONS(10969),
    [anon_sym_LT_LT_EQ] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10967),
    [anon_sym_BANG_TILDE] = ACTIONS(10969),
    [anon_sym_LBRACE] = ACTIONS(10969),
    [anon_sym_COLON2] = ACTIONS(10967),
    [anon_sym_while] = ACTIONS(10969),
    [sym__heredoc_body_start] = ACTIONS(10969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10969),
    [anon_sym_CARET_EQ] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_LT_EQ] = ACTIONS(10967),
    [anon_sym_PIPE] = ACTIONS(10967),
    [anon_sym_DOT_DOT] = ACTIONS(10967),
    [anon_sym_EQ] = ACTIONS(10967),
    [anon_sym_LT] = ACTIONS(10967),
    [anon_sym_in] = ACTIONS(10969),
    [anon_sym_QMARK] = ACTIONS(10969),
    [anon_sym_COMMA] = ACTIONS(10969),
    [anon_sym_GT_GT] = ACTIONS(10967),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10969),
    [anon_sym_or] = ACTIONS(10969),
    [anon_sym_GT] = ACTIONS(10967),
    [anon_sym_PIPE_EQ] = ACTIONS(10969),
    [anon_sym_PLUS_EQ] = ACTIONS(10969),
    [anon_sym_STAR_EQ] = ACTIONS(10969),
    [anon_sym_EQ_EQ] = ACTIONS(10967),
    [anon_sym_and] = ACTIONS(10969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10967),
    [anon_sym_GT_EQ] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10969),
    [anon_sym_DASH_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10969),
    [anon_sym_BANG_EQ] = ACTIONS(10969),
    [anon_sym_STAR_STAR] = ACTIONS(10967),
    [anon_sym_LT_EQ_GT] = ACTIONS(10969),
    [anon_sym_AMP_AMP] = ACTIONS(10967),
    [sym__binary_minus] = ACTIONS(10969),
    [anon_sym_if] = ACTIONS(10969),
    [anon_sym_CARET] = ACTIONS(10967),
  },
  [7944] = {
    [anon_sym_SLASH] = ACTIONS(9417),
    [anon_sym_RBRACK] = ACTIONS(9419),
    [anon_sym_until] = ACTIONS(9419),
    [anon_sym_AMP_EQ] = ACTIONS(9419),
    [anon_sym_GT_GT_EQ] = ACTIONS(9419),
    [anon_sym_SLASH_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9419),
    [anon_sym_RPAREN] = ACTIONS(9419),
    [anon_sym_EQ_TILDE] = ACTIONS(9419),
    [anon_sym_LT_LT] = ACTIONS(9417),
    [sym__binary_star] = ACTIONS(9419),
    [anon_sym_RBRACE] = ACTIONS(9419),
    [anon_sym_unless] = ACTIONS(9419),
    [anon_sym_PLUS] = ACTIONS(9417),
    [anon_sym_AMP] = ACTIONS(9417),
    [anon_sym_PERCENT] = ACTIONS(9417),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [anon_sym_rescue] = ACTIONS(9419),
    [anon_sym_PERCENT_EQ] = ACTIONS(9419),
    [anon_sym_LT_LT_EQ] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9417),
    [anon_sym_BANG_TILDE] = ACTIONS(9419),
    [anon_sym_LBRACE] = ACTIONS(9419),
    [anon_sym_COLON2] = ACTIONS(9417),
    [anon_sym_while] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9419),
    [anon_sym_CARET_EQ] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_LT_EQ] = ACTIONS(9417),
    [anon_sym_PIPE] = ACTIONS(9417),
    [anon_sym_DOT_DOT] = ACTIONS(9417),
    [anon_sym_EQ] = ACTIONS(9417),
    [anon_sym_LT] = ACTIONS(9417),
    [anon_sym_in] = ACTIONS(9419),
    [anon_sym_QMARK] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_GT_GT] = ACTIONS(9417),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9419),
    [anon_sym_or] = ACTIONS(9419),
    [anon_sym_GT] = ACTIONS(9417),
    [anon_sym_PIPE_EQ] = ACTIONS(9419),
    [anon_sym_PLUS_EQ] = ACTIONS(9419),
    [anon_sym_STAR_EQ] = ACTIONS(9419),
    [anon_sym_EQ_EQ] = ACTIONS(9417),
    [anon_sym_and] = ACTIONS(9419),
    [anon_sym_PIPE_PIPE] = ACTIONS(9417),
    [anon_sym_GT_EQ] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9419),
    [anon_sym_DASH_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9419),
    [anon_sym_BANG_EQ] = ACTIONS(9419),
    [anon_sym_STAR_STAR] = ACTIONS(9417),
    [anon_sym_LT_EQ_GT] = ACTIONS(9419),
    [anon_sym_AMP_AMP] = ACTIONS(9417),
    [sym__binary_minus] = ACTIONS(9419),
    [anon_sym_if] = ACTIONS(9419),
    [anon_sym_CARET] = ACTIONS(9417),
  },
  [7945] = {
    [anon_sym_RBRACE] = ACTIONS(14804),
    [sym_comment] = ACTIONS(49),
  },
  [7946] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [7947] = {
    [anon_sym_SLASH] = ACTIONS(9248),
    [anon_sym_RBRACK] = ACTIONS(9250),
    [anon_sym_until] = ACTIONS(9250),
    [anon_sym_AMP_EQ] = ACTIONS(9250),
    [anon_sym_GT_GT_EQ] = ACTIONS(9250),
    [anon_sym_SLASH_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9250),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_EQ_TILDE] = ACTIONS(9250),
    [anon_sym_LT_LT] = ACTIONS(9248),
    [sym__binary_star] = ACTIONS(9250),
    [anon_sym_RBRACE] = ACTIONS(9250),
    [anon_sym_unless] = ACTIONS(9250),
    [anon_sym_PLUS] = ACTIONS(9248),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_PERCENT] = ACTIONS(9248),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [anon_sym_rescue] = ACTIONS(9250),
    [anon_sym_PERCENT_EQ] = ACTIONS(9250),
    [anon_sym_LT_LT_EQ] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9248),
    [anon_sym_BANG_TILDE] = ACTIONS(9250),
    [anon_sym_LBRACE] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9248),
    [anon_sym_while] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9250),
    [anon_sym_CARET_EQ] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_LT_EQ] = ACTIONS(9248),
    [anon_sym_PIPE] = ACTIONS(9248),
    [anon_sym_DOT_DOT] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9248),
    [anon_sym_LT] = ACTIONS(9248),
    [anon_sym_in] = ACTIONS(9250),
    [anon_sym_QMARK] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_GT_GT] = ACTIONS(9248),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9250),
    [anon_sym_or] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9248),
    [anon_sym_PIPE_EQ] = ACTIONS(9250),
    [anon_sym_PLUS_EQ] = ACTIONS(9250),
    [anon_sym_STAR_EQ] = ACTIONS(9250),
    [anon_sym_EQ_EQ] = ACTIONS(9248),
    [anon_sym_and] = ACTIONS(9250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9248),
    [anon_sym_GT_EQ] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9250),
    [anon_sym_DASH_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9250),
    [anon_sym_BANG_EQ] = ACTIONS(9250),
    [anon_sym_STAR_STAR] = ACTIONS(9248),
    [anon_sym_LT_EQ_GT] = ACTIONS(9250),
    [anon_sym_AMP_AMP] = ACTIONS(9248),
    [sym__binary_minus] = ACTIONS(9250),
    [anon_sym_if] = ACTIONS(9250),
    [anon_sym_CARET] = ACTIONS(9248),
  },
  [7948] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10138),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14806),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7949] = {
    [anon_sym_end] = ACTIONS(14808),
    [sym_comment] = ACTIONS(49),
  },
  [7950] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(10139),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(10139),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10138),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(14810),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(14810),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14806),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [7951] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [7952] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [7953] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [7954] = {
    [sym_assignment] = STATE(10140),
    [sym_unary] = STATE(10140),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10140),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10140),
    [sym_conditional] = STATE(10140),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10140),
    [sym_binary] = STATE(10140),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7955] = {
    [sym_assignment] = STATE(10141),
    [sym_unary] = STATE(10141),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10141),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_splat_argument] = STATE(10142),
    [sym_operator_assignment] = STATE(10141),
    [sym_conditional] = STATE(10141),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_return] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_subshell] = STATE(5101),
    [sym__arg_or_splat_arg] = STATE(10142),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10141),
    [sym_binary] = STATE(10141),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [sym_global_variable] = ACTIONS(8407),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8399),
    [sym_character] = ACTIONS(8403),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7956] = {
    [sym_assignment] = STATE(10143),
    [sym_unary] = STATE(10143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10143),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10143),
    [sym_conditional] = STATE(10143),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10143),
    [sym_binary] = STATE(10143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7957] = {
    [sym_assignment] = STATE(10144),
    [sym_unary] = STATE(10144),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10144),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10144),
    [sym_conditional] = STATE(10144),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10144),
    [sym_binary] = STATE(10144),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7958] = {
    [sym_assignment] = STATE(10146),
    [sym_unary] = STATE(10146),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10146),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10146),
    [sym_conditional] = STATE(10146),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10146),
    [sym_binary] = STATE(10146),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7959] = {
    [sym_assignment] = STATE(10147),
    [sym_unary] = STATE(10147),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10147),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10147),
    [sym_conditional] = STATE(10147),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10147),
    [sym_binary] = STATE(10147),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [7960] = {
    [sym_assignment] = STATE(10148),
    [sym_unary] = STATE(10148),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10148),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10148),
    [sym_conditional] = STATE(10148),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10148),
    [sym_binary] = STATE(10148),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7961] = {
    [sym_assignment] = STATE(10149),
    [sym_unary] = STATE(10149),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10149),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10149),
    [sym_conditional] = STATE(10149),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10149),
    [sym_binary] = STATE(10149),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7962] = {
    [sym_assignment] = STATE(10150),
    [sym_unary] = STATE(10150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10150),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10150),
    [sym_conditional] = STATE(10150),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10150),
    [sym_binary] = STATE(10150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7963] = {
    [sym_assignment] = STATE(10151),
    [sym_unary] = STATE(10151),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10151),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10151),
    [sym_conditional] = STATE(10151),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10151),
    [sym_binary] = STATE(10151),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7964] = {
    [sym_assignment] = STATE(10152),
    [sym_unary] = STATE(10152),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10152),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(10152),
    [sym_conditional] = STATE(10152),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10152),
    [sym_binary] = STATE(10152),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [7965] = {
    [aux_sym_chained_string_repeat1] = STATE(10153),
    [sym_string] = STATE(10153),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_RBRACK] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [7966] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [7967] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(858),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2445),
    [sym_rational] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym_float] = ACTIONS(1545),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1553),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1553),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4250),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1573),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(4254),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4250),
    [anon_sym_yield] = ACTIONS(1589),
    [sym_class_variable] = ACTIONS(1573),
    [sym__block_ampersand] = ACTIONS(4256),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1593),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [sym_retry] = ACTIONS(1545),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12352),
    [sym_redo] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [7968] = {
    [sym_heredoc_body] = STATE(7968),
    [aux_sym_call_repeat1] = STATE(7968),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_RBRACK] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [7969] = {
    [sym_heredoc_body] = STATE(7968),
    [aux_sym_call_repeat1] = STATE(7968),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_RBRACK] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [7970] = {
    [aux_sym_argument_list_repeat1] = STATE(7970),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_RBRACK] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14812),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [7971] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [anon_sym_RBRACK] = ACTIONS(13276),
    [anon_sym_in] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_EQ_GT] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_COLON2] = ACTIONS(13274),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
    [anon_sym_EQ] = ACTIONS(13274),
  },
  [7972] = {
    [anon_sym_end] = ACTIONS(14815),
    [sym_comment] = ACTIONS(49),
  },
  [7973] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10155),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14815),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [7974] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_RBRACK] = ACTIONS(13464),
    [anon_sym_in] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_EQ_GT] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_COLON2] = ACTIONS(13462),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
    [anon_sym_EQ] = ACTIONS(13462),
  },
  [7975] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_RBRACK] = ACTIONS(13468),
    [anon_sym_in] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_EQ_GT] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
    [anon_sym_EQ] = ACTIONS(13466),
  },
  [7976] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [anon_sym_RBRACK] = ACTIONS(13739),
    [anon_sym_in] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_EQ_GT] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_COLON2] = ACTIONS(13737),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
    [anon_sym_EQ] = ACTIONS(13737),
  },
  [7977] = {
    [anon_sym_end] = ACTIONS(14817),
    [sym_comment] = ACTIONS(49),
  },
  [7978] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [anon_sym_RBRACK] = ACTIONS(13954),
    [anon_sym_in] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_EQ_GT] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_COLON2] = ACTIONS(13952),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
    [anon_sym_EQ] = ACTIONS(13952),
  },
  [7979] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_in] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_EQ_GT] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_COLON2] = ACTIONS(13956),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
    [anon_sym_EQ] = ACTIONS(13956),
  },
  [7980] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14819),
  },
  [7981] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [anon_sym_RBRACK] = ACTIONS(13964),
    [anon_sym_in] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_EQ_GT] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
    [anon_sym_EQ] = ACTIONS(13962),
  },
  [7982] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [sym__identifier_hash_key] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [sym__block_ampersand] = ACTIONS(8575),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_yield] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [sym__splat_star] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(10412),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [7983] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(143),
    [sym_unary] = STATE(143),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(142),
    [sym_singleton_class] = STATE(144),
    [sym_module] = STATE(144),
    [sym_chained_string] = STATE(144),
    [sym_until] = STATE(144),
    [sym_regex] = STATE(144),
    [sym_for] = STATE(144),
    [sym_symbol] = STATE(144),
    [sym_if] = STATE(144),
    [sym_begin] = STATE(144),
    [sym__arg] = STATE(143),
    [sym__primary] = STATE(144),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(142),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(143),
    [sym_conditional] = STATE(143),
    [sym_method] = STATE(144),
    [sym_singleton_method] = STATE(144),
    [sym__variable] = STATE(145),
    [sym_left_assignment_list] = STATE(146),
    [sym_return] = STATE(144),
    [sym_yield] = STATE(144),
    [sym_string] = STATE(147),
    [sym_rational] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_true] = STATE(142),
    [sym_unless] = STATE(144),
    [sym_lambda] = STATE(144),
    [sym_parenthesized_statements] = STATE(144),
    [sym_element_reference] = STATE(142),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(143),
    [sym_binary] = STATE(143),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(144),
    [sym_break] = STATE(144),
    [sym_next] = STATE(144),
    [sym_string_array] = STATE(144),
    [sym_while] = STATE(144),
    [sym_case] = STATE(144),
    [sym_symbol_array] = STATE(144),
    [sym_array] = STATE(144),
    [sym_hash] = STATE(144),
    [sym_false] = STATE(142),
    [sym_nil] = STATE(142),
    [sym_scope_resolution] = STATE(145),
    [sym_call] = STATE(145),
    [sym_float] = ACTIONS(197),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(203),
    [sym_heredoc_beginning] = ACTIONS(205),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_TILDE] = ACTIONS(211),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(205),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(227),
    [anon_sym_defined_QMARK] = ACTIONS(229),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [sym__identifier_hash_key] = ACTIONS(241),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(245),
    [sym_class_variable] = ACTIONS(227),
    [sym__block_ampersand] = ACTIONS(247),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(251),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(257),
    [anon_sym_break] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(227),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(273),
    [anon_sym_next] = ACTIONS(275),
    [sym_retry] = ACTIONS(197),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(281),
    [sym_redo] = ACTIONS(197),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(287),
  },
  [7984] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
  },
  [7985] = {
    [aux_sym_exceptions_repeat1] = STATE(7985),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(14821),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [7986] = {
    [anon_sym_LT] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(1517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1517),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(1515),
    [sym__binary_star] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_PERCENT] = ACTIONS(1509),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(1527),
    [anon_sym_BANG_TILDE] = ACTIONS(1515),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_LT_EQ_GT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [sym__binary_minus] = ACTIONS(1523),
    [anon_sym_CARET] = ACTIONS(1535),
  },
  [7987] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [7988] = {
    [anon_sym_SLASH] = ACTIONS(7382),
    [anon_sym_RBRACK] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_AMP_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT_EQ] = ACTIONS(7384),
    [anon_sym_SLASH_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7382),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7382),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7382),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_PERCENT_EQ] = ACTIONS(7384),
    [anon_sym_LT_LT_EQ] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_COLON2] = ACTIONS(7382),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_CARET_EQ] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_EQ] = ACTIONS(7382),
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_in] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7382),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_EQ_GT] = ACTIONS(7384),
    [anon_sym_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_PLUS_EQ] = ACTIONS(7384),
    [anon_sym_STAR_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7382),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7384),
    [anon_sym_DASH_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7382),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_AMP_AMP] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7382),
  },
  [7989] = {
    [anon_sym_end] = ACTIONS(14824),
    [sym_comment] = ACTIONS(49),
  },
  [7990] = {
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_RBRACK] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_AMP_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT_EQ] = ACTIONS(7790),
    [anon_sym_SLASH_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_PERCENT_EQ] = ACTIONS(7790),
    [anon_sym_LT_LT_EQ] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_COLON2] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_CARET_EQ] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_EQ] = ACTIONS(7788),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_in] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7790),
    [anon_sym_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_PLUS_EQ] = ACTIONS(7790),
    [anon_sym_STAR_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7790),
    [anon_sym_DASH_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7788),
  },
  [7991] = {
    [anon_sym_end] = ACTIONS(14826),
    [sym_comment] = ACTIONS(49),
  },
  [7992] = {
    [anon_sym_SLASH] = ACTIONS(7870),
    [anon_sym_RBRACK] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_AMP_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT_EQ] = ACTIONS(7872),
    [anon_sym_SLASH_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7870),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7870),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7870),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_PERCENT_EQ] = ACTIONS(7872),
    [anon_sym_LT_LT_EQ] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_COLON2] = ACTIONS(7870),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_CARET_EQ] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_EQ] = ACTIONS(7870),
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_in] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7870),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [anon_sym_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_PLUS_EQ] = ACTIONS(7872),
    [anon_sym_STAR_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7872),
    [anon_sym_DASH_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7870),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7870),
  },
  [7993] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14828),
  },
  [7994] = {
    [anon_sym_SLASH] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_AMP_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT_EQ] = ACTIONS(7878),
    [anon_sym_SLASH_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_PERCENT_EQ] = ACTIONS(7878),
    [anon_sym_LT_LT_EQ] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_CARET_EQ] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_EQ_GT] = ACTIONS(7878),
    [anon_sym_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_PLUS_EQ] = ACTIONS(7878),
    [anon_sym_STAR_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7878),
    [anon_sym_DASH_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7876),
  },
  [7995] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14830),
    [sym__string_end] = ACTIONS(14828),
  },
  [7996] = {
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_AMP_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT_EQ] = ACTIONS(8224),
    [anon_sym_SLASH_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8222),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_PERCENT_EQ] = ACTIONS(8224),
    [anon_sym_LT_LT_EQ] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_COLON2] = ACTIONS(8222),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_CARET_EQ] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_in] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_EQ_GT] = ACTIONS(8224),
    [anon_sym_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_PLUS_EQ] = ACTIONS(8224),
    [anon_sym_STAR_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8224),
    [anon_sym_DASH_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8222),
  },
  [7997] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14832),
  },
  [7998] = {
    [anon_sym_SLASH] = ACTIONS(13017),
    [anon_sym_RBRACK] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_in] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [7999] = {
    [anon_sym_SLASH] = ACTIONS(8849),
    [anon_sym_RBRACK] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_AMP_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT_EQ] = ACTIONS(8851),
    [anon_sym_SLASH_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8849),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8849),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_PERCENT_EQ] = ACTIONS(8851),
    [anon_sym_LT_LT_EQ] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_COLON2] = ACTIONS(8849),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_CARET_EQ] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_EQ] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_in] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_EQ_GT] = ACTIONS(8851),
    [anon_sym_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_PLUS_EQ] = ACTIONS(8851),
    [anon_sym_STAR_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8851),
    [anon_sym_DASH_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8849),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8849),
  },
  [8000] = {
    [anon_sym_SLASH] = ACTIONS(8870),
    [anon_sym_RBRACK] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_AMP_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT_EQ] = ACTIONS(8872),
    [anon_sym_SLASH_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8870),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8870),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8870),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_PERCENT_EQ] = ACTIONS(8872),
    [anon_sym_LT_LT_EQ] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_COLON2] = ACTIONS(8870),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_CARET_EQ] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_EQ] = ACTIONS(8870),
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_in] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8870),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_EQ_GT] = ACTIONS(8872),
    [anon_sym_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_PLUS_EQ] = ACTIONS(8872),
    [anon_sym_STAR_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8870),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8872),
    [anon_sym_DASH_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8870),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_AMP_AMP] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8870),
  },
  [8001] = {
    [anon_sym_end] = ACTIONS(14834),
    [sym_comment] = ACTIONS(49),
  },
  [8002] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10165),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14836),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8003] = {
    [anon_sym_SLASH] = ACTIONS(12903),
    [anon_sym_RBRACK] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_in] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [8004] = {
    [anon_sym_end] = ACTIONS(14838),
    [sym_comment] = ACTIONS(49),
  },
  [8005] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10167),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14840),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8006] = {
    [anon_sym_DOT] = ACTIONS(14842),
    [anon_sym_COLON_COLON] = ACTIONS(14842),
    [sym_comment] = ACTIONS(49),
  },
  [8007] = {
    [anon_sym_SLASH] = ACTIONS(9600),
    [anon_sym_RBRACK] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_AMP_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT_EQ] = ACTIONS(9602),
    [anon_sym_SLASH_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9600),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9600),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9600),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_PERCENT_EQ] = ACTIONS(9602),
    [anon_sym_LT_LT_EQ] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_COLON2] = ACTIONS(9600),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_CARET_EQ] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_EQ] = ACTIONS(9600),
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_in] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9600),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_EQ_GT] = ACTIONS(9602),
    [anon_sym_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_PLUS_EQ] = ACTIONS(9602),
    [anon_sym_STAR_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9600),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9602),
    [anon_sym_DASH_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9600),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_AMP_AMP] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9600),
  },
  [8008] = {
    [anon_sym_SLASH] = ACTIONS(9606),
    [anon_sym_RBRACK] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_AMP_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT_EQ] = ACTIONS(9608),
    [anon_sym_SLASH_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9606),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9606),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9606),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_PERCENT_EQ] = ACTIONS(9608),
    [anon_sym_LT_LT_EQ] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_COLON2] = ACTIONS(9606),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_CARET_EQ] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_EQ] = ACTIONS(9606),
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_in] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9606),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_EQ_GT] = ACTIONS(9608),
    [anon_sym_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_PLUS_EQ] = ACTIONS(9608),
    [anon_sym_STAR_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9606),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9608),
    [anon_sym_DASH_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9606),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_AMP_AMP] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9606),
  },
  [8009] = {
    [anon_sym_SLASH] = ACTIONS(9897),
    [anon_sym_RBRACK] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_AMP_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT_EQ] = ACTIONS(9899),
    [anon_sym_SLASH_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9897),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9897),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9897),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_PERCENT_EQ] = ACTIONS(9899),
    [anon_sym_LT_LT_EQ] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_COLON2] = ACTIONS(9897),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_CARET_EQ] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_EQ] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_in] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9897),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_EQ_GT] = ACTIONS(9899),
    [anon_sym_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_PLUS_EQ] = ACTIONS(9899),
    [anon_sym_STAR_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9897),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9899),
    [anon_sym_DASH_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9897),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_AMP_AMP] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9897),
  },
  [8010] = {
    [anon_sym_end] = ACTIONS(14844),
    [sym_comment] = ACTIONS(49),
  },
  [8011] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10170),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14844),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [8012] = {
    [sym_when] = STATE(10171),
    [sym_else] = STATE(10170),
    [aux_sym_case_repeat2] = STATE(10171),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14844),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [8013] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(10172),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14846),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [8014] = {
    [anon_sym_SLASH] = ACTIONS(10206),
    [anon_sym_RBRACK] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_AMP_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT_EQ] = ACTIONS(10208),
    [anon_sym_SLASH_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10206),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10206),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10206),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_PERCENT_EQ] = ACTIONS(10208),
    [anon_sym_LT_LT_EQ] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_COLON2] = ACTIONS(10206),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_CARET_EQ] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_in] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10206),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_EQ_GT] = ACTIONS(10208),
    [anon_sym_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_PLUS_EQ] = ACTIONS(10208),
    [anon_sym_STAR_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10206),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10208),
    [anon_sym_DASH_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10206),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10206),
  },
  [8015] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(2557),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(2558),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(10173),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(2561),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(2562),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14848),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [8016] = {
    [anon_sym_SLASH] = ACTIONS(10258),
    [anon_sym_RBRACK] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_AMP_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT_EQ] = ACTIONS(10260),
    [anon_sym_SLASH_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10258),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10258),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10258),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_PERCENT_EQ] = ACTIONS(10260),
    [anon_sym_LT_LT_EQ] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_COLON2] = ACTIONS(10258),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_CARET_EQ] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_EQ] = ACTIONS(10258),
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_in] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10258),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_EQ_GT] = ACTIONS(10260),
    [anon_sym_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_PLUS_EQ] = ACTIONS(10260),
    [anon_sym_STAR_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10258),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10260),
    [anon_sym_DASH_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10258),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_AMP_AMP] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10258),
  },
  [8017] = {
    [anon_sym_SLASH] = ACTIONS(10697),
    [anon_sym_RBRACK] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_AMP_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT_EQ] = ACTIONS(10699),
    [anon_sym_SLASH_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10697),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10697),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10697),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_PERCENT_EQ] = ACTIONS(10699),
    [anon_sym_LT_LT_EQ] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_COLON2] = ACTIONS(10697),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_CARET_EQ] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_EQ] = ACTIONS(10697),
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_in] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10697),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_EQ_GT] = ACTIONS(10699),
    [anon_sym_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_PLUS_EQ] = ACTIONS(10699),
    [anon_sym_STAR_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10697),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10699),
    [anon_sym_DASH_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10697),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_AMP_AMP] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10697),
  },
  [8018] = {
    [anon_sym_end] = ACTIONS(14850),
    [sym_comment] = ACTIONS(49),
  },
  [8019] = {
    [sym_ensure] = STATE(10175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(14850),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [8020] = {
    [anon_sym_SLASH] = ACTIONS(10925),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10925),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10925),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10925),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10925),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_EQ] = ACTIONS(10925),
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10925),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_EQ_GT] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10925),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10925),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10925),
  },
  [8021] = {
    [anon_sym_end] = ACTIONS(14852),
    [sym_comment] = ACTIONS(49),
  },
  [8022] = {
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_RBRACK] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_AMP_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT_EQ] = ACTIONS(10933),
    [anon_sym_SLASH_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_PERCENT_EQ] = ACTIONS(10933),
    [anon_sym_LT_LT_EQ] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_COLON2] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_CARET_EQ] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_EQ] = ACTIONS(10931),
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_in] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_EQ_GT] = ACTIONS(10933),
    [anon_sym_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_PLUS_EQ] = ACTIONS(10933),
    [anon_sym_STAR_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10933),
    [anon_sym_DASH_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10931),
  },
  [8023] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14854),
  },
  [8024] = {
    [anon_sym_SLASH] = ACTIONS(10937),
    [anon_sym_RBRACK] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_AMP_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT_EQ] = ACTIONS(10939),
    [anon_sym_SLASH_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10937),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10937),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10937),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_PERCENT_EQ] = ACTIONS(10939),
    [anon_sym_LT_LT_EQ] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_COLON2] = ACTIONS(10937),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_CARET_EQ] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_EQ] = ACTIONS(10937),
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_in] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10937),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_EQ_GT] = ACTIONS(10939),
    [anon_sym_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_PLUS_EQ] = ACTIONS(10939),
    [anon_sym_STAR_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10937),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10939),
    [anon_sym_DASH_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10937),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_AMP_AMP] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10937),
  },
  [8025] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(14856),
    [sym__string_end] = ACTIONS(14854),
  },
  [8026] = {
    [anon_sym_SLASH] = ACTIONS(10943),
    [anon_sym_RBRACK] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_AMP_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT_EQ] = ACTIONS(10945),
    [anon_sym_SLASH_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10943),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10943),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10943),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_PERCENT_EQ] = ACTIONS(10945),
    [anon_sym_LT_LT_EQ] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_COLON2] = ACTIONS(10943),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_CARET_EQ] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_EQ] = ACTIONS(10943),
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_in] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10943),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_EQ_GT] = ACTIONS(10945),
    [anon_sym_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_PLUS_EQ] = ACTIONS(10945),
    [anon_sym_STAR_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10943),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10945),
    [anon_sym_DASH_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_AMP_AMP] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10943),
  },
  [8027] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14858),
  },
  [8028] = {
    [sym_assignment] = STATE(5203),
    [sym_unary] = STATE(5203),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(5203),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(5203),
    [sym_conditional] = STATE(5203),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_return] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_true] = STATE(863),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(5203),
    [sym_binary] = STATE(5203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [sym_global_variable] = ACTIONS(1573),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1553),
    [sym_character] = ACTIONS(1555),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [8029] = {
    [aux_sym_exceptions_repeat1] = STATE(10181),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14860),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [8030] = {
    [anon_sym_SLASH] = ACTIONS(10412),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_AMP_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8575),
    [anon_sym_SLASH_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(10412),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(10412),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(10412),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_PERCENT_EQ] = ACTIONS(8575),
    [anon_sym_LT_LT_EQ] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_COLON2] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_CARET_EQ] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_EQ] = ACTIONS(10412),
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_in] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_EQ_GT] = ACTIONS(8575),
    [anon_sym_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_PLUS_EQ] = ACTIONS(8575),
    [anon_sym_STAR_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(10412),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8575),
    [anon_sym_DASH_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(10412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_AMP_AMP] = ACTIONS(10412),
    [sym__binary_minus] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(10412),
  },
  [8031] = {
    [anon_sym_SLASH] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_AMP_EQ] = ACTIONS(12375),
    [anon_sym_GT_GT_EQ] = ACTIONS(12375),
    [anon_sym_SLASH_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(13245),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_PLUS] = ACTIONS(13245),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_PERCENT] = ACTIONS(13245),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_PERCENT_EQ] = ACTIONS(12375),
    [anon_sym_LT_LT_EQ] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_COLON2] = ACTIONS(13245),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_CARET_EQ] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_EQ] = ACTIONS(13245),
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(13245),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_EQ_GT] = ACTIONS(12375),
    [anon_sym_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_PLUS_EQ] = ACTIONS(12375),
    [anon_sym_STAR_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(13245),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12375),
    [anon_sym_DASH_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(13245),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_AMP_AMP] = ACTIONS(13245),
    [sym__binary_minus] = ACTIONS(12375),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(13245),
  },
  [8032] = {
    [sym_assignment] = STATE(10182),
    [sym_unary] = STATE(10182),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(863),
    [sym_singleton_class] = STATE(858),
    [sym_module] = STATE(858),
    [sym_chained_string] = STATE(858),
    [sym_until] = STATE(858),
    [sym_regex] = STATE(858),
    [sym_for] = STATE(858),
    [sym_symbol] = STATE(858),
    [sym_if] = STATE(858),
    [sym_begin] = STATE(858),
    [sym__arg] = STATE(10182),
    [sym__primary] = STATE(858),
    [sym_method_call] = STATE(863),
    [sym_operator_assignment] = STATE(10182),
    [sym_conditional] = STATE(10182),
    [sym_method] = STATE(858),
    [sym_singleton_method] = STATE(858),
    [sym__variable] = STATE(861),
    [sym_left_assignment_list] = STATE(860),
    [sym_rational] = STATE(858),
    [sym_true] = STATE(863),
    [sym_return] = STATE(858),
    [sym_subshell] = STATE(858),
    [sym_yield] = STATE(858),
    [sym_string] = STATE(2508),
    [sym_unless] = STATE(858),
    [sym_lambda] = STATE(858),
    [sym_parenthesized_statements] = STATE(858),
    [sym_element_reference] = STATE(863),
    [sym_range] = STATE(10182),
    [sym_binary] = STATE(10182),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(858),
    [sym_break] = STATE(858),
    [sym_next] = STATE(858),
    [sym_string_array] = STATE(858),
    [sym_while] = STATE(858),
    [sym_case] = STATE(858),
    [sym_symbol_array] = STATE(858),
    [sym_array] = STATE(858),
    [sym_hash] = STATE(858),
    [sym_false] = STATE(863),
    [sym_nil] = STATE(863),
    [sym_scope_resolution] = STATE(861),
    [sym_call] = STATE(861),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1545),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1593),
    [sym_self] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1555),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1573),
    [sym_character] = ACTIONS(1555),
    [sym_super] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1615),
    [anon_sym_next] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1545),
    [sym_constant] = ACTIONS(1553),
    [anon_sym_defined_QMARK] = ACTIONS(1575),
    [sym_instance_variable] = ACTIONS(1573),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1553),
    [sym_redo] = ACTIONS(1545),
    [sym_class_variable] = ACTIONS(1573),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1551),
  },
  [8033] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_EQ_GT] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
  },
  [8034] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_EQ_GT] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
  },
  [8035] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_EQ_GT] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
  },
  [8036] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14862),
  },
  [8037] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
  },
  [8038] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_EQ_GT] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
  },
  [8039] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_EQ_GT] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
  },
  [8040] = {
    [anon_sym_end] = ACTIONS(14864),
    [sym_comment] = ACTIONS(49),
  },
  [8041] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
  },
  [8042] = {
    [anon_sym_end] = ACTIONS(14866),
    [sym_comment] = ACTIONS(49),
  },
  [8043] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10186),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14868),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8044] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
  },
  [8045] = {
    [sym__method_name] = STATE(898),
    [sym_setter] = STATE(898),
    [sym_symbol] = STATE(898),
    [sym_operator] = STATE(898),
    [sym__method_rest] = STATE(10187),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8599),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8599),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8599),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8599),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [8046] = {
    [sym_heredoc_body] = STATE(8046),
    [aux_sym_call_repeat1] = STATE(8046),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8047] = {
    [sym_heredoc_body] = STATE(8046),
    [aux_sym_call_repeat1] = STATE(8046),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8048] = {
    [sym_assignment] = STATE(5257),
    [sym_unary] = STATE(5257),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5257),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(5257),
    [sym_conditional] = STATE(5257),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(5257),
    [sym_binary] = STATE(5257),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1671),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [8049] = {
    [aux_sym_exceptions_repeat1] = STATE(10188),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14870),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8050] = {
    [sym_assignment] = STATE(10189),
    [sym_unary] = STATE(10189),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(10189),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(915),
    [sym_operator_assignment] = STATE(10189),
    [sym_conditional] = STATE(10189),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(915),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(2625),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_range] = STATE(10189),
    [sym_binary] = STATE(10189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_not] = ACTIONS(1691),
    [sym_self] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1679),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1671),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym_instance_variable] = ACTIONS(1679),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1671),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1679),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [8051] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8052] = {
    [anon_sym_RPAREN] = ACTIONS(14872),
    [sym_comment] = ACTIONS(49),
  },
  [8053] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8054] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_EQ_GT] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
  },
  [8055] = {
    [anon_sym_end] = ACTIONS(14874),
    [sym_comment] = ACTIONS(49),
  },
  [8056] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10192),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14874),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [8057] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_EQ_GT] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
  },
  [8058] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_EQ_GT] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
  },
  [8059] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_EQ_GT] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
  },
  [8060] = {
    [anon_sym_end] = ACTIONS(14876),
    [sym_comment] = ACTIONS(49),
  },
  [8061] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [8062] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [8063] = {
    [sym_assignment] = STATE(10194),
    [sym_unary] = STATE(10194),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(10194),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(10194),
    [sym_conditional] = STATE(10194),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(10194),
    [sym_binary] = STATE(10194),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [8064] = {
    [sym_assignment] = STATE(10195),
    [sym_unary] = STATE(10195),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(10195),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(10195),
    [sym_conditional] = STATE(10195),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(10195),
    [sym_binary] = STATE(10195),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [8065] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8066] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8067] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8068] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_heredoc_body] = STATE(10196),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym_float] = ACTIONS(4540),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(4552),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(4564),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14878),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [8069] = {
    [sym_heredoc_body] = STATE(10197),
    [aux_sym_call_repeat1] = STATE(10197),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8070] = {
    [sym_heredoc_body] = STATE(10198),
    [aux_sym_call_repeat1] = STATE(10198),
    [aux_sym_argument_list_repeat1] = STATE(10199),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12505),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8071] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [8072] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [8073] = {
    [sym_assignment] = STATE(10200),
    [sym_unary] = STATE(10200),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10200),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10200),
    [sym_conditional] = STATE(10200),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10200),
    [sym_binary] = STATE(10200),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8074] = {
    [sym_assignment] = STATE(10201),
    [sym_unary] = STATE(10201),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10201),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_splat_argument] = STATE(10202),
    [sym_operator_assignment] = STATE(10201),
    [sym_conditional] = STATE(10201),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_return] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_subshell] = STATE(957),
    [sym__arg_or_splat_arg] = STATE(10202),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10201),
    [sym_binary] = STATE(10201),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [sym_global_variable] = ACTIONS(1741),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1733),
    [sym_character] = ACTIONS(1737),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8075] = {
    [sym_assignment] = STATE(10203),
    [sym_unary] = STATE(10203),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10203),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10203),
    [sym_conditional] = STATE(10203),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10203),
    [sym_binary] = STATE(10203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8076] = {
    [sym_assignment] = STATE(10204),
    [sym_unary] = STATE(10204),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10204),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10204),
    [sym_conditional] = STATE(10204),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10204),
    [sym_binary] = STATE(10204),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8077] = {
    [sym_assignment] = STATE(10206),
    [sym_unary] = STATE(10206),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10206),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10206),
    [sym_conditional] = STATE(10206),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10206),
    [sym_binary] = STATE(10206),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8078] = {
    [sym_assignment] = STATE(10207),
    [sym_unary] = STATE(10207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10207),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10207),
    [sym_conditional] = STATE(10207),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10207),
    [sym_binary] = STATE(10207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8079] = {
    [sym_assignment] = STATE(10208),
    [sym_unary] = STATE(10208),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10208),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10208),
    [sym_conditional] = STATE(10208),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10208),
    [sym_binary] = STATE(10208),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8080] = {
    [sym_assignment] = STATE(10209),
    [sym_unary] = STATE(10209),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10209),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10209),
    [sym_conditional] = STATE(10209),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10209),
    [sym_binary] = STATE(10209),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8081] = {
    [sym_assignment] = STATE(10210),
    [sym_unary] = STATE(10210),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10210),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10210),
    [sym_conditional] = STATE(10210),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10210),
    [sym_binary] = STATE(10210),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8082] = {
    [sym_assignment] = STATE(10211),
    [sym_unary] = STATE(10211),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10211),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10211),
    [sym_conditional] = STATE(10211),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10211),
    [sym_binary] = STATE(10211),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8083] = {
    [sym_assignment] = STATE(10212),
    [sym_unary] = STATE(10212),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10212),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(10212),
    [sym_conditional] = STATE(10212),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10212),
    [sym_binary] = STATE(10212),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8084] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(2687),
    [sym_unary] = STATE(2687),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(2687),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(2687),
    [sym_conditional] = STATE(2687),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(2691),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(2687),
    [sym_binary] = STATE(2687),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym_float] = ACTIONS(4540),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4550),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(4558),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(4562),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(4564),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12541),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [8085] = {
    [sym_heredoc_body] = STATE(8085),
    [aux_sym_call_repeat1] = STATE(8085),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8086] = {
    [sym_heredoc_body] = STATE(8085),
    [aux_sym_call_repeat1] = STATE(8085),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8087] = {
    [aux_sym_argument_list_repeat1] = STATE(8087),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14880),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8088] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8089] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8090] = {
    [aux_sym_exceptions_repeat1] = STATE(10214),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8091] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8092] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8093] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14883),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8094] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8095] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8096] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8097] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [8098] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8099] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8100] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8101] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8102] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10217),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14885),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8103] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8104] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8105] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8104),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10218),
    [sym_operator] = STATE(10218),
    [anon_sym_LT] = ACTIONS(12543),
    [anon_sym_SLASH] = ACTIONS(12545),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12545),
    [anon_sym_PLUS_AT] = ACTIONS(12545),
    [anon_sym_LPAREN2] = ACTIONS(12547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_TILDE] = ACTIONS(12545),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_TILDE] = ACTIONS(12545),
    [anon_sym_PLUS] = ACTIONS(12543),
    [anon_sym_AMP] = ACTIONS(12545),
    [anon_sym_GT] = ACTIONS(12543),
    [anon_sym_PERCENT] = ACTIONS(12545),
    [anon_sym_DASH_AT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12543),
    [anon_sym_STAR] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12545),
    [sym_constant] = ACTIONS(14887),
    [anon_sym_DASH] = ACTIONS(12543),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12543),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12545),
    [anon_sym_STAR_STAR] = ACTIONS(12545),
    [anon_sym_PIPE] = ACTIONS(12545),
    [anon_sym_DOT_DOT] = ACTIONS(12545),
    [anon_sym_LT_EQ_GT] = ACTIONS(12545),
    [anon_sym_LT_EQ] = ACTIONS(12543),
    [anon_sym_BANG] = ACTIONS(12543),
    [sym_identifier] = ACTIONS(14887),
    [anon_sym_CARET] = ACTIONS(12545),
  },
  [8106] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8107] = {
    [sym_assignment] = STATE(10219),
    [sym_unary] = STATE(10219),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(10219),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(10219),
    [sym_conditional] = STATE(10219),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(10219),
    [sym_binary] = STATE(10219),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [8108] = {
    [sym_assignment] = STATE(10220),
    [sym_unary] = STATE(10220),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(10220),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(10220),
    [sym_conditional] = STATE(10220),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(10220),
    [sym_binary] = STATE(10220),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [8109] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8110] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8111] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8112] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_heredoc_body] = STATE(10221),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym_float] = ACTIONS(4616),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(4620),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(4620),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(4628),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [sym_class_variable] = ACTIONS(4628),
    [sym__block_ampersand] = ACTIONS(8697),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4638),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [8113] = {
    [sym_heredoc_body] = STATE(10222),
    [aux_sym_call_repeat1] = STATE(10222),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8114] = {
    [sym_heredoc_body] = STATE(10223),
    [aux_sym_call_repeat1] = STATE(10223),
    [aux_sym_argument_list_repeat1] = STATE(10224),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12557),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8115] = {
    [aux_sym_chained_string_repeat1] = STATE(8115),
    [sym_string] = STATE(8115),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8116] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [8117] = {
    [sym_assignment] = STATE(5338),
    [sym_unary] = STATE(5338),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(5338),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(5338),
    [sym_conditional] = STATE(5338),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_return] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_string] = STATE(960),
    [sym_true] = STATE(955),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(5338),
    [sym_binary] = STATE(5338),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [sym_global_variable] = ACTIONS(1741),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1733),
    [sym_character] = ACTIONS(1737),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8118] = {
    [aux_sym_exceptions_repeat1] = STATE(10225),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14891),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8119] = {
    [sym_assignment] = STATE(10226),
    [sym_unary] = STATE(10226),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(955),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10226),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(955),
    [sym_operator_assignment] = STATE(10226),
    [sym_conditional] = STATE(10226),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(959),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(955),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(955),
    [sym_range] = STATE(10226),
    [sym_binary] = STATE(10226),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(955),
    [sym_nil] = STATE(955),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_not] = ACTIONS(1731),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1729),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [8120] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8121] = {
    [anon_sym_RPAREN] = ACTIONS(14893),
    [sym_comment] = ACTIONS(49),
  },
  [8122] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8123] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [8124] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [8125] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [8126] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [8127] = {
    [sym_assignment] = STATE(10228),
    [sym_unary] = STATE(10228),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10228),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10228),
    [sym_conditional] = STATE(10228),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10228),
    [sym_binary] = STATE(10228),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8128] = {
    [sym_assignment] = STATE(10229),
    [sym_unary] = STATE(10229),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10229),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_splat_argument] = STATE(10230),
    [sym_operator_assignment] = STATE(10229),
    [sym_conditional] = STATE(10229),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_return] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_subshell] = STATE(5370),
    [sym__arg_or_splat_arg] = STATE(10230),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10229),
    [sym_binary] = STATE(10229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [sym_global_variable] = ACTIONS(8739),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8731),
    [sym_character] = ACTIONS(8735),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8129] = {
    [sym_assignment] = STATE(10231),
    [sym_unary] = STATE(10231),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10231),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10231),
    [sym_conditional] = STATE(10231),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10231),
    [sym_binary] = STATE(10231),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8130] = {
    [sym_assignment] = STATE(10232),
    [sym_unary] = STATE(10232),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10232),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10232),
    [sym_conditional] = STATE(10232),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10232),
    [sym_binary] = STATE(10232),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8131] = {
    [sym_assignment] = STATE(10234),
    [sym_unary] = STATE(10234),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10234),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10234),
    [sym_conditional] = STATE(10234),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10234),
    [sym_binary] = STATE(10234),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8132] = {
    [sym_assignment] = STATE(10235),
    [sym_unary] = STATE(10235),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10235),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10235),
    [sym_conditional] = STATE(10235),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10235),
    [sym_binary] = STATE(10235),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8133] = {
    [sym_assignment] = STATE(10236),
    [sym_unary] = STATE(10236),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10236),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10236),
    [sym_conditional] = STATE(10236),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10236),
    [sym_binary] = STATE(10236),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8134] = {
    [sym_assignment] = STATE(10237),
    [sym_unary] = STATE(10237),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10237),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10237),
    [sym_conditional] = STATE(10237),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10237),
    [sym_binary] = STATE(10237),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8135] = {
    [sym_assignment] = STATE(10238),
    [sym_unary] = STATE(10238),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10238),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10238),
    [sym_conditional] = STATE(10238),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10238),
    [sym_binary] = STATE(10238),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8136] = {
    [sym_assignment] = STATE(10239),
    [sym_unary] = STATE(10239),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10239),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10239),
    [sym_conditional] = STATE(10239),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10239),
    [sym_binary] = STATE(10239),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8137] = {
    [sym_assignment] = STATE(10240),
    [sym_unary] = STATE(10240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10240),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(10240),
    [sym_conditional] = STATE(10240),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10240),
    [sym_binary] = STATE(10240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [8138] = {
    [aux_sym_chained_string_repeat1] = STATE(10241),
    [sym_string] = STATE(10241),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [8139] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8140] = {
    [aux_sym_exceptions_repeat1] = STATE(10243),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [8141] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(2727),
    [sym_unary] = STATE(2727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(2727),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(2727),
    [sym_conditional] = STATE(2727),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(2728),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(2727),
    [sym_binary] = STATE(2727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym_float] = ACTIONS(4616),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(4620),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(4620),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4626),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(4632),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4634),
    [sym_class_variable] = ACTIONS(4628),
    [sym__block_ampersand] = ACTIONS(4636),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4638),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12601),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [8142] = {
    [sym_heredoc_body] = STATE(8142),
    [aux_sym_call_repeat1] = STATE(8142),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8143] = {
    [sym_heredoc_body] = STATE(8142),
    [aux_sym_call_repeat1] = STATE(8142),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8144] = {
    [aux_sym_argument_list_repeat1] = STATE(8144),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14895),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8145] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8146] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8147] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8148] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14898),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8149] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8150] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8151] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8152] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [8153] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8154] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8155] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8156] = {
    [aux_sym_chained_string_repeat1] = STATE(8156),
    [sym_string] = STATE(8156),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [8157] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_EQ_GT] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
  },
  [8158] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_EQ_GT] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
  },
  [8159] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14900),
  },
  [8160] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_EQ_GT] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
  },
  [8161] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [8162] = {
    [aux_sym_exceptions_repeat1] = STATE(5416),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8163] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [8164] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [8165] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [8166] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8167] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14902),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8168] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8169] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [8170] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8171] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8172] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8173] = {
    [aux_sym_chained_string_repeat1] = STATE(8173),
    [sym_string] = STATE(8173),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8865),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8174] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [8175] = {
    [aux_sym_exceptions_repeat1] = STATE(8175),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(14904),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [8176] = {
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1763),
    [anon_sym_QMARK] = ACTIONS(1765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_TILDE] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_or] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1763),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(1779),
    [anon_sym_BANG_TILDE] = ACTIONS(1767),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1785),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [sym__binary_minus] = ACTIONS(1775),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_LT_EQ_GT] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1761),
    [anon_sym_CARET] = ACTIONS(1787),
  },
  [8177] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [8178] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [sym__identifier_hash_key] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(10412),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [8179] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13017),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [8180] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12903),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [8181] = {
    [anon_sym_end] = ACTIONS(14907),
    [sym_comment] = ACTIONS(49),
  },
  [8182] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10248),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8183] = {
    [sym_assignment] = STATE(5434),
    [sym_unary] = STATE(5434),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5434),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(5434),
    [sym_conditional] = STATE(5434),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(5434),
    [sym_binary] = STATE(5434),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [8184] = {
    [aux_sym_exceptions_repeat1] = STATE(10249),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14911),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [8185] = {
    [sym_assignment] = STATE(10250),
    [sym_unary] = STATE(10250),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(10250),
    [sym__primary] = STATE(999),
    [sym_method_call] = STATE(1004),
    [sym_operator_assignment] = STATE(10250),
    [sym_conditional] = STATE(10250),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_rational] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_return] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(2777),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_range] = STATE(10250),
    [sym_binary] = STATE(10250),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(1805),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_not] = ACTIONS(1831),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1811),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(1805),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1805),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [8186] = {
    [sym_assignment] = STATE(10251),
    [sym_unary] = STATE(10251),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10251),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(10251),
    [sym_conditional] = STATE(10251),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(10251),
    [sym_binary] = STATE(10251),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [8187] = {
    [sym_assignment] = STATE(10252),
    [sym_unary] = STATE(10252),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10252),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(10252),
    [sym_conditional] = STATE(10252),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(10252),
    [sym_binary] = STATE(10252),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [8188] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8189] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8190] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8191] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(10253),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14913),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [8192] = {
    [sym_heredoc_body] = STATE(10254),
    [aux_sym_call_repeat1] = STATE(10254),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8193] = {
    [sym_heredoc_body] = STATE(10255),
    [aux_sym_call_repeat1] = STATE(10255),
    [aux_sym_argument_list_repeat1] = STATE(10256),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12638),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8194] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8195] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8196] = {
    [aux_sym_exceptions_repeat1] = STATE(10258),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8197] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8198] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8199] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8200] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8201] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14915),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8202] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8203] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [8204] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8205] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8206] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8207] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8208] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10261),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14917),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8209] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8210] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8211] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8210),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10262),
    [sym_operator] = STATE(10262),
    [anon_sym_LT] = ACTIONS(12642),
    [anon_sym_SLASH] = ACTIONS(12644),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12644),
    [anon_sym_PLUS_AT] = ACTIONS(12644),
    [anon_sym_LPAREN2] = ACTIONS(12646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12644),
    [anon_sym_GT_GT] = ACTIONS(12644),
    [anon_sym_EQ_TILDE] = ACTIONS(12644),
    [anon_sym_LT_LT] = ACTIONS(12644),
    [anon_sym_TILDE] = ACTIONS(12644),
    [anon_sym_PLUS] = ACTIONS(12642),
    [anon_sym_AMP] = ACTIONS(12644),
    [anon_sym_GT] = ACTIONS(12642),
    [anon_sym_PERCENT] = ACTIONS(12644),
    [anon_sym_DASH_AT] = ACTIONS(12644),
    [anon_sym_EQ_EQ] = ACTIONS(12642),
    [anon_sym_STAR] = ACTIONS(12642),
    [anon_sym_BANG_TILDE] = ACTIONS(12644),
    [sym_constant] = ACTIONS(14919),
    [anon_sym_DASH] = ACTIONS(12642),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12644),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12642),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12644),
    [anon_sym_STAR_STAR] = ACTIONS(12644),
    [anon_sym_PIPE] = ACTIONS(12644),
    [anon_sym_DOT_DOT] = ACTIONS(12644),
    [anon_sym_LT_EQ_GT] = ACTIONS(12644),
    [anon_sym_LT_EQ] = ACTIONS(12642),
    [anon_sym_BANG] = ACTIONS(12642),
    [sym_identifier] = ACTIONS(14919),
    [anon_sym_CARET] = ACTIONS(12644),
  },
  [8212] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8213] = {
    [sym_assignment] = STATE(10263),
    [sym_unary] = STATE(10263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(10263),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(10263),
    [sym_conditional] = STATE(10263),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(10263),
    [sym_binary] = STATE(10263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [8214] = {
    [sym_assignment] = STATE(10264),
    [sym_unary] = STATE(10264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(10264),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(10264),
    [sym_conditional] = STATE(10264),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(10264),
    [sym_binary] = STATE(10264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [8215] = {
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8216] = {
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8217] = {
    [sym_assignment] = STATE(10265),
    [sym_unary] = STATE(10265),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(10265),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(10265),
    [sym_conditional] = STATE(10265),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(10265),
    [sym_binary] = STATE(10265),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [8218] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [8219] = {
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8220] = {
    [sym_assignment] = STATE(10266),
    [sym_unary] = STATE(10266),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(10266),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(10266),
    [sym_conditional] = STATE(10266),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(10266),
    [sym_binary] = STATE(10266),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [8221] = {
    [sym__argument] = STATE(5486),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(5486),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(5486),
    [sym_hash_splat_argument] = STATE(5486),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym__argument_list_with_parens] = STATE(5489),
    [sym_block_argument] = STATE(5486),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(1805),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1809),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(1811),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(8928),
    [anon_sym_not] = ACTIONS(1831),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8222] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(14921),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14921),
    [anon_sym_SLASH_EQ] = ACTIONS(14921),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14921),
    [anon_sym_PIPE_EQ] = ACTIONS(14921),
    [anon_sym_LT_LT_EQ] = ACTIONS(14921),
    [anon_sym_PLUS_EQ] = ACTIONS(14921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14921),
    [anon_sym_STAR_EQ] = ACTIONS(14921),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14921),
    [anon_sym_CARET_EQ] = ACTIONS(14921),
    [anon_sym_DASH_EQ] = ACTIONS(14921),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14921),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(14923),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8223] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [8224] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(8918),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(8920),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(8922),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [8225] = {
    [anon_sym_EQ] = ACTIONS(14953),
    [sym_comment] = ACTIONS(3),
  },
  [8226] = {
    [aux_sym_chained_string_repeat1] = STATE(10278),
    [sym_string] = STATE(10278),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8227] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [8228] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [8229] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_heredoc_body] = STATE(10279),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1805),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(8928),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14955),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [8230] = {
    [sym_heredoc_body] = STATE(10280),
    [aux_sym_call_repeat1] = STATE(10280),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8231] = {
    [sym_heredoc_body] = STATE(10281),
    [aux_sym_call_repeat1] = STATE(10281),
    [aux_sym_argument_list_repeat1] = STATE(10282),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8232] = {
    [aux_sym_chained_string_repeat1] = STATE(8232),
    [sym_string] = STATE(8232),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8233] = {
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_in] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
  },
  [8234] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
  },
  [8235] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14957),
  },
  [8236] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
  },
  [8237] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
  },
  [8238] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
  },
  [8239] = {
    [anon_sym_end] = ACTIONS(14959),
    [sym_comment] = ACTIONS(49),
  },
  [8240] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10285),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(14959),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [8241] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
  },
  [8242] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
  },
  [8243] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
  },
  [8244] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
  },
  [8245] = {
    [anon_sym_end] = ACTIONS(14961),
    [sym_comment] = ACTIONS(49),
  },
  [8246] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
  },
  [8247] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(14963),
  },
  [8248] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
  },
  [8249] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
  },
  [8250] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
  },
  [8251] = {
    [anon_sym_end] = ACTIONS(14965),
    [sym_comment] = ACTIONS(49),
  },
  [8252] = {
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_in] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_EQ] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
  },
  [8253] = {
    [anon_sym_end] = ACTIONS(14967),
    [sym_comment] = ACTIONS(49),
  },
  [8254] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10290),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(14969),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8255] = {
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_in] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_EQ] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
  },
  [8256] = {
    [sym__method_name] = STATE(1073),
    [sym_setter] = STATE(1073),
    [sym_symbol] = STATE(1073),
    [sym_operator] = STATE(1073),
    [sym__method_rest] = STATE(10291),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(8998),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(8998),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(8998),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(8998),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [8257] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
  },
  [8258] = {
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [sym_self] = ACTIONS(9736),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_nil] = ACTIONS(9736),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [anon_sym_next] = ACTIONS(9736),
    [sym_retry] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9736),
  },
  [8259] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [8260] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [8261] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(2913),
    [sym_unary] = STATE(2913),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(2913),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(2913),
    [sym_conditional] = STATE(2913),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2914),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(2913),
    [sym_binary] = STATE(2913),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(4910),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(4912),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4914),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12732),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [8262] = {
    [sym_heredoc_body] = STATE(8262),
    [aux_sym_call_repeat1] = STATE(8262),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_in] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8263] = {
    [sym_heredoc_body] = STATE(8262),
    [aux_sym_call_repeat1] = STATE(8262),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_in] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8264] = {
    [aux_sym_argument_list_repeat1] = STATE(8264),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(14971),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8265] = {
    [sym_assignment] = STATE(10292),
    [sym_unary] = STATE(10292),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(10292),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(10292),
    [sym_conditional] = STATE(10292),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(10292),
    [sym_binary] = STATE(10292),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [8266] = {
    [sym_assignment] = STATE(10293),
    [sym_unary] = STATE(10293),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(10293),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(10293),
    [sym_conditional] = STATE(10293),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(10293),
    [sym_binary] = STATE(10293),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [8267] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8268] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8269] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8270] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_heredoc_body] = STATE(10294),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14974),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [8271] = {
    [sym_heredoc_body] = STATE(10295),
    [aux_sym_call_repeat1] = STATE(10295),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8272] = {
    [sym_heredoc_body] = STATE(10296),
    [aux_sym_call_repeat1] = STATE(10296),
    [aux_sym_argument_list_repeat1] = STATE(10297),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12738),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8273] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8274] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8275] = {
    [aux_sym_exceptions_repeat1] = STATE(10299),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8276] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8277] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8278] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8279] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8280] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(14976),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8281] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8282] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [8283] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8284] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8285] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8286] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_in] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8287] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10302),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(14978),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8288] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_in] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8289] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_in] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8290] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8289),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10303),
    [sym_operator] = STATE(10303),
    [anon_sym_LT] = ACTIONS(12742),
    [anon_sym_SLASH] = ACTIONS(12744),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12744),
    [anon_sym_PLUS_AT] = ACTIONS(12744),
    [anon_sym_LPAREN2] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_TILDE] = ACTIONS(12744),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_TILDE] = ACTIONS(12744),
    [anon_sym_PLUS] = ACTIONS(12742),
    [anon_sym_AMP] = ACTIONS(12744),
    [anon_sym_GT] = ACTIONS(12742),
    [anon_sym_PERCENT] = ACTIONS(12744),
    [anon_sym_DASH_AT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_STAR] = ACTIONS(12742),
    [anon_sym_BANG_TILDE] = ACTIONS(12744),
    [sym_constant] = ACTIONS(14980),
    [anon_sym_DASH] = ACTIONS(12742),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12742),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12744),
    [anon_sym_STAR_STAR] = ACTIONS(12744),
    [anon_sym_PIPE] = ACTIONS(12744),
    [anon_sym_DOT_DOT] = ACTIONS(12744),
    [anon_sym_LT_EQ_GT] = ACTIONS(12744),
    [anon_sym_LT_EQ] = ACTIONS(12742),
    [anon_sym_BANG] = ACTIONS(12742),
    [sym_identifier] = ACTIONS(14980),
    [anon_sym_CARET] = ACTIONS(12744),
  },
  [8291] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8292] = {
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_RBRACK] = ACTIONS(5212),
    [anon_sym_until] = ACTIONS(5212),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5212),
    [anon_sym_unless] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_rescue] = ACTIONS(5212),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_COLON2] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_in] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_if] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [8293] = {
    [sym_assignment] = STATE(10304),
    [sym_unary] = STATE(10304),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(10304),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(10304),
    [sym_conditional] = STATE(10304),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(10304),
    [sym_binary] = STATE(10304),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [8294] = {
    [sym_assignment] = STATE(10305),
    [sym_unary] = STATE(10305),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(10305),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(10305),
    [sym_conditional] = STATE(10305),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(10305),
    [sym_binary] = STATE(10305),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [8295] = {
    [sym__argument] = STATE(5588),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(5588),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5588),
    [sym_hash_splat_argument] = STATE(5588),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(5591),
    [sym_block_argument] = STATE(5588),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(753),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8296] = {
    [sym__argument] = STATE(5588),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(5588),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5588),
    [sym_hash_splat_argument] = STATE(5588),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(5591),
    [sym_block_argument] = STATE(5588),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(647),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8297] = {
    [sym_assignment] = STATE(10306),
    [sym_unary] = STATE(10306),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(10306),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(10306),
    [sym_conditional] = STATE(10306),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(10306),
    [sym_binary] = STATE(10306),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [8298] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [8299] = {
    [sym__argument] = STATE(5588),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(5588),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5588),
    [sym_hash_splat_argument] = STATE(5588),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(5591),
    [sym_block_argument] = STATE(5588),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(737),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8300] = {
    [sym_assignment] = STATE(10307),
    [sym_unary] = STATE(10307),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(10307),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(10307),
    [sym_conditional] = STATE(10307),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(10307),
    [sym_binary] = STATE(10307),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [8301] = {
    [sym__argument] = STATE(5588),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(5588),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(5588),
    [sym_hash_splat_argument] = STATE(5588),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym__argument_list_with_parens] = STATE(5591),
    [sym_block_argument] = STATE(5588),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(4956),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(4960),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_in] = ACTIONS(501),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8302] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(14982),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(14982),
    [anon_sym_SLASH_EQ] = ACTIONS(14982),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(14982),
    [anon_sym_PIPE_EQ] = ACTIONS(14982),
    [anon_sym_LT_LT_EQ] = ACTIONS(14982),
    [anon_sym_PLUS_EQ] = ACTIONS(14982),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14982),
    [anon_sym_STAR_EQ] = ACTIONS(14982),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14982),
    [anon_sym_CARET_EQ] = ACTIONS(14982),
    [anon_sym_DASH_EQ] = ACTIONS(14982),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14982),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(14984),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8303] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [8304] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_in] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(9065),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9067),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [8305] = {
    [anon_sym_EQ] = ACTIONS(15014),
    [sym_comment] = ACTIONS(3),
  },
  [8306] = {
    [aux_sym_chained_string_repeat1] = STATE(10319),
    [sym_string] = STATE(10319),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8307] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [8308] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [8309] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_heredoc_body] = STATE(10320),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(4956),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1943),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9077),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15016),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [8310] = {
    [sym_heredoc_body] = STATE(10321),
    [aux_sym_call_repeat1] = STATE(10321),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8311] = {
    [sym_heredoc_body] = STATE(10322),
    [aux_sym_call_repeat1] = STATE(10322),
    [aux_sym_argument_list_repeat1] = STATE(10323),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_in] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12780),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8312] = {
    [aux_sym_chained_string_repeat1] = STATE(8312),
    [sym_string] = STATE(8312),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_in] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8313] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8314] = {
    [anon_sym_RPAREN] = ACTIONS(15018),
    [sym_comment] = ACTIONS(49),
  },
  [8315] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8316] = {
    [sym_assignment] = STATE(5599),
    [sym_unary] = STATE(5599),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5599),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(5599),
    [sym_conditional] = STATE(5599),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(5599),
    [sym_binary] = STATE(5599),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1931),
    [sym_character] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [8317] = {
    [aux_sym_exceptions_repeat1] = STATE(10325),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_in] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15020),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8318] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8319] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8320] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8321] = {
    [aux_sym_exceptions_repeat1] = STATE(10327),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [8322] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(2952),
    [sym_unary] = STATE(2952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(2952),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(2952),
    [sym_conditional] = STATE(2952),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(2953),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(2952),
    [sym_binary] = STATE(2952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(4956),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(4964),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(4968),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4964),
    [anon_sym_yield] = ACTIONS(4970),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(4972),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(12788),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [8323] = {
    [sym_heredoc_body] = STATE(8323),
    [aux_sym_call_repeat1] = STATE(8323),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_in] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8324] = {
    [sym_heredoc_body] = STATE(8323),
    [aux_sym_call_repeat1] = STATE(8323),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_in] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8325] = {
    [aux_sym_argument_list_repeat1] = STATE(8325),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15022),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8326] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8327] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8328] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8329] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15025),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8330] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8331] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8332] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8333] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [8334] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8335] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8336] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8337] = {
    [aux_sym_chained_string_repeat1] = STATE(8337),
    [sym_string] = STATE(8337),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_in] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [8338] = {
    [sym_assignment] = STATE(10329),
    [sym_unary] = STATE(10329),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(10329),
    [sym__primary] = STATE(1098),
    [sym_method_call] = STATE(1103),
    [sym_operator_assignment] = STATE(10329),
    [sym_conditional] = STATE(10329),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_rational] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_return] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(2901),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_range] = STATE(10329),
    [sym_binary] = STATE(10329),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1929),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1955),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(1933),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1929),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(1929),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [8339] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [sym__line_break] = ACTIONS(15029),
    [anon_sym_then] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_when] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym___END__] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_end] = ACTIONS(15029),
    [anon_sym_ensure] = ACTIONS(15029),
    [anon_sym_else] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_elsif] = ACTIONS(15029),
    [ts_builtin_sym_end] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
    [sym__binary_minus] = ACTIONS(15029),
  },
  [8340] = {
    [aux_sym_undef_repeat1] = STATE(8340),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [8341] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2249),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [8342] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2227),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [8343] = {
    [sym_assignment] = STATE(10351),
    [sym_unary] = STATE(10351),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(10351),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(10351),
    [sym_conditional] = STATE(10351),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(10351),
    [sym_binary] = STATE(10351),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [8344] = {
    [sym_assignment] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [8345] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2241),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [8346] = {
    [sym_assignment] = STATE(10352),
    [sym_unary] = STATE(10352),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(10352),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(10352),
    [sym_conditional] = STATE(10352),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(10352),
    [sym_binary] = STATE(10352),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [8347] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(15067),
    [sym_identifier] = ACTIONS(15067),
  },
  [8348] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2219),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [8349] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(15069),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(15069),
    [anon_sym_SLASH_EQ] = ACTIONS(15069),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15069),
    [anon_sym_PIPE_EQ] = ACTIONS(15069),
    [anon_sym_LT_LT_EQ] = ACTIONS(15069),
    [anon_sym_PLUS_EQ] = ACTIONS(15069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15069),
    [anon_sym_STAR_EQ] = ACTIONS(15069),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15069),
    [anon_sym_CARET_EQ] = ACTIONS(15069),
    [anon_sym_DASH_EQ] = ACTIONS(15069),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15069),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15071),
  },
  [8350] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(9373),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_SEMI] = ACTIONS(9373),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(15085),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(15085),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [anon_sym_PIPE] = ACTIONS(15095),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [8351] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(15101),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(15103),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15105),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [8352] = {
    [sym_block] = STATE(2275),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym__primary] = STATE(10380),
    [sym_argument_list] = STATE(2277),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_method] = STATE(10380),
    [sym_conditional] = STATE(10385),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_subshell] = STATE(10380),
    [sym_unless] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10384),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_call] = STATE(10382),
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_rational] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_lambda] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_do_block] = STATE(2275),
    [sym_binary] = STATE(10385),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_nil] = STATE(10384),
    [sym_symbol_array] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_scope_resolution] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [8353] = {
    [anon_sym_EQ] = ACTIONS(15141),
    [sym_comment] = ACTIONS(3),
  },
  [8354] = {
    [aux_sym_chained_string_repeat1] = STATE(10388),
    [sym_string] = STATE(10388),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [8355] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(9407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_SEMI] = ACTIONS(9407),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(15085),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(15085),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [anon_sym_PIPE] = ACTIONS(15143),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [8356] = {
    [aux_sym_block_parameters_repeat1] = STATE(10390),
    [anon_sym_PIPE] = ACTIONS(15145),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [8357] = {
    [sym__line_break] = ACTIONS(15147),
    [sym_float] = ACTIONS(15149),
    [anon_sym_until] = ACTIONS(15149),
    [anon_sym_undef] = ACTIONS(15149),
    [sym_self] = ACTIONS(15149),
    [anon_sym_BEGIN] = ACTIONS(15149),
    [anon_sym_TILDE] = ACTIONS(15147),
    [anon_sym_unless] = ACTIONS(15149),
    [anon_sym_PLUS] = ACTIONS(15149),
    [sym__symbol_array_start] = ACTIONS(15147),
    [sym__simple_symbol] = ACTIONS(15147),
    [sym_complex] = ACTIONS(15147),
    [sym_heredoc_beginning] = ACTIONS(15147),
    [sym_super] = ACTIONS(15149),
    [anon_sym_alias] = ACTIONS(15149),
    [anon_sym_LBRACK2] = ACTIONS(15147),
    [anon_sym_nil] = ACTIONS(15149),
    [sym_character] = ACTIONS(15147),
    [anon_sym_LBRACE] = ACTIONS(15147),
    [anon_sym_END] = ACTIONS(15149),
    [sym_constant] = ACTIONS(15149),
    [anon_sym_while] = ACTIONS(15149),
    [sym_instance_variable] = ACTIONS(15147),
    [sym__heredoc_body_start] = ACTIONS(15147),
    [anon_sym_defined_QMARK] = ACTIONS(15147),
    [sym__string_start] = ACTIONS(15147),
    [anon_sym_true] = ACTIONS(15149),
    [anon_sym_for] = ACTIONS(15149),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(15147),
    [anon_sym_NIL] = ACTIONS(15149),
    [anon_sym_COLON_COLON] = ACTIONS(15147),
    [anon_sym_def] = ACTIONS(15149),
    [sym_identifier] = ACTIONS(15149),
    [anon_sym_yield] = ACTIONS(15149),
    [sym_class_variable] = ACTIONS(15147),
    [sym__symbol_start] = ACTIONS(15147),
    [anon_sym_not] = ACTIONS(15149),
    [anon_sym_TRUE] = ACTIONS(15149),
    [anon_sym_case] = ACTIONS(15149),
    [anon_sym_SEMI] = ACTIONS(15147),
    [anon_sym_LPAREN] = ACTIONS(15147),
    [anon_sym_break] = ACTIONS(15149),
    [sym_global_variable] = ACTIONS(15147),
    [anon_sym_class] = ACTIONS(15149),
    [sym__subshell_start] = ACTIONS(15147),
    [anon_sym_module] = ACTIONS(15149),
    [anon_sym_begin] = ACTIONS(15149),
    [anon_sym_false] = ACTIONS(15149),
    [anon_sym_STAR] = ACTIONS(15147),
    [sym__unary_minus] = ACTIONS(15147),
    [anon_sym_next] = ACTIONS(15149),
    [sym_retry] = ACTIONS(15149),
    [sym__regex_start] = ACTIONS(15147),
    [anon_sym_end] = ACTIONS(15149),
    [sym_integer] = ACTIONS(15149),
    [anon_sym_FALSE] = ACTIONS(15149),
    [sym_redo] = ACTIONS(15149),
    [anon_sym_BANG] = ACTIONS(15147),
    [anon_sym_if] = ACTIONS(15149),
    [sym__string_array_start] = ACTIONS(15147),
    [anon_sym_return] = ACTIONS(15149),
  },
  [8358] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(15151),
  },
  [8359] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(15145),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [8360] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(15153),
  },
  [8361] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(15145),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(15155),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [8362] = {
    [aux_sym_method_parameters_repeat1] = STATE(8362),
    [anon_sym_PIPE] = ACTIONS(13059),
    [anon_sym_COMMA] = ACTIONS(15157),
    [anon_sym_SEMI] = ACTIONS(13059),
    [sym_comment] = ACTIONS(49),
  },
  [8363] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [8364] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [8365] = {
    [sym_assignment] = STATE(10396),
    [sym_unary] = STATE(10396),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(10396),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(10396),
    [sym_conditional] = STATE(10396),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(10396),
    [sym_binary] = STATE(10396),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [8366] = {
    [sym_assignment] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [8367] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8368] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8369] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8370] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_heredoc_body] = STATE(10398),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym_float] = ACTIONS(5042),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(5046),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(5054),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(5066),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15160),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [8371] = {
    [sym_heredoc_body] = STATE(10399),
    [aux_sym_call_repeat1] = STATE(10399),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [8372] = {
    [sym_heredoc_body] = STATE(10400),
    [aux_sym_call_repeat1] = STATE(10400),
    [aux_sym_argument_list_repeat1] = STATE(10401),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12847),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [8373] = {
    [sym_heredoc_body] = STATE(10402),
    [aux_sym_call_repeat1] = STATE(10402),
    [aux_sym_argument_list_repeat1] = STATE(10403),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(9198),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [8374] = {
    [sym_heredoc_body] = STATE(10402),
    [aux_sym_call_repeat1] = STATE(10402),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [8375] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [8376] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [8377] = {
    [sym_assignment] = STATE(10404),
    [sym_unary] = STATE(10404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10404),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10404),
    [sym_conditional] = STATE(10404),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10404),
    [sym_binary] = STATE(10404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8378] = {
    [sym_assignment] = STATE(10405),
    [sym_unary] = STATE(10405),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10405),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_splat_argument] = STATE(10406),
    [sym_operator_assignment] = STATE(10405),
    [sym_conditional] = STATE(10405),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_return] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_subshell] = STATE(1125),
    [sym__arg_or_splat_arg] = STATE(10406),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10405),
    [sym_binary] = STATE(10405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1983),
    [sym_character] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8379] = {
    [sym_assignment] = STATE(10407),
    [sym_unary] = STATE(10407),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10407),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10407),
    [sym_conditional] = STATE(10407),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10407),
    [sym_binary] = STATE(10407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8380] = {
    [sym_assignment] = STATE(10408),
    [sym_unary] = STATE(10408),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10408),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10408),
    [sym_conditional] = STATE(10408),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10408),
    [sym_binary] = STATE(10408),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8381] = {
    [sym_assignment] = STATE(10410),
    [sym_unary] = STATE(10410),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10410),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10410),
    [sym_conditional] = STATE(10410),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10410),
    [sym_binary] = STATE(10410),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8382] = {
    [sym_assignment] = STATE(10411),
    [sym_unary] = STATE(10411),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10411),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10411),
    [sym_conditional] = STATE(10411),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10411),
    [sym_binary] = STATE(10411),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8383] = {
    [sym_assignment] = STATE(10412),
    [sym_unary] = STATE(10412),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10412),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10412),
    [sym_conditional] = STATE(10412),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10412),
    [sym_binary] = STATE(10412),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8384] = {
    [sym_assignment] = STATE(10413),
    [sym_unary] = STATE(10413),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10413),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10413),
    [sym_conditional] = STATE(10413),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10413),
    [sym_binary] = STATE(10413),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8385] = {
    [sym_assignment] = STATE(10414),
    [sym_unary] = STATE(10414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10414),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10414),
    [sym_conditional] = STATE(10414),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10414),
    [sym_binary] = STATE(10414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8386] = {
    [sym_assignment] = STATE(10415),
    [sym_unary] = STATE(10415),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10415),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10415),
    [sym_conditional] = STATE(10415),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10415),
    [sym_binary] = STATE(10415),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8387] = {
    [sym_assignment] = STATE(10416),
    [sym_unary] = STATE(10416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10416),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(10416),
    [sym_conditional] = STATE(10416),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10416),
    [sym_binary] = STATE(10416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8388] = {
    [aux_sym_chained_string_repeat1] = STATE(10417),
    [sym_string] = STATE(10417),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [8389] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(2999),
    [sym_unary] = STATE(2999),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(2999),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(2999),
    [sym_conditional] = STATE(2999),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(3003),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(2999),
    [sym_binary] = STATE(2999),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym_float] = ACTIONS(5042),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(5046),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5052),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(5060),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(5064),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(5066),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(12883),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [8390] = {
    [sym_heredoc_body] = STATE(8390),
    [aux_sym_call_repeat1] = STATE(8390),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [8391] = {
    [sym_heredoc_body] = STATE(8390),
    [aux_sym_call_repeat1] = STATE(8390),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [8392] = {
    [aux_sym_argument_list_repeat1] = STATE(8392),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15162),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [8393] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8394] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8395] = {
    [aux_sym_exceptions_repeat1] = STATE(10419),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [8396] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8397] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8398] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15165),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8399] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8400] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8401] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8402] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8403] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8404] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8405] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [8406] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8407] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10422),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15167),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8408] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8409] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8410] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8409),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10423),
    [sym_operator] = STATE(10423),
    [anon_sym_LT] = ACTIONS(12885),
    [anon_sym_SLASH] = ACTIONS(12887),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12887),
    [anon_sym_PLUS_AT] = ACTIONS(12887),
    [anon_sym_LPAREN2] = ACTIONS(12889),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12887),
    [anon_sym_GT_GT] = ACTIONS(12887),
    [anon_sym_EQ_TILDE] = ACTIONS(12887),
    [anon_sym_LT_LT] = ACTIONS(12887),
    [anon_sym_TILDE] = ACTIONS(12887),
    [anon_sym_PLUS] = ACTIONS(12885),
    [anon_sym_AMP] = ACTIONS(12887),
    [anon_sym_GT] = ACTIONS(12885),
    [anon_sym_PERCENT] = ACTIONS(12887),
    [anon_sym_DASH_AT] = ACTIONS(12887),
    [anon_sym_EQ_EQ] = ACTIONS(12885),
    [anon_sym_STAR] = ACTIONS(12885),
    [anon_sym_BANG_TILDE] = ACTIONS(12887),
    [sym_constant] = ACTIONS(15169),
    [anon_sym_DASH] = ACTIONS(12885),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12887),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12885),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12887),
    [anon_sym_STAR_STAR] = ACTIONS(12887),
    [anon_sym_PIPE] = ACTIONS(12887),
    [anon_sym_DOT_DOT] = ACTIONS(12887),
    [anon_sym_LT_EQ_GT] = ACTIONS(12887),
    [anon_sym_LT_EQ] = ACTIONS(12885),
    [anon_sym_BANG] = ACTIONS(12885),
    [sym_identifier] = ACTIONS(15169),
    [anon_sym_CARET] = ACTIONS(12887),
  },
  [8411] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8412] = {
    [sym_assignment] = STATE(10424),
    [sym_unary] = STATE(10424),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(10424),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(10424),
    [sym_conditional] = STATE(10424),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(10424),
    [sym_binary] = STATE(10424),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [8413] = {
    [sym_assignment] = STATE(10425),
    [sym_unary] = STATE(10425),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(10425),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(10425),
    [sym_conditional] = STATE(10425),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(10425),
    [sym_binary] = STATE(10425),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [8414] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8415] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8416] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8417] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_heredoc_body] = STATE(10426),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym_float] = ACTIONS(5106),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(5110),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(5110),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(5118),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_class_variable] = ACTIONS(5118),
    [sym__block_ampersand] = ACTIONS(9240),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(5128),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15171),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [8418] = {
    [sym_heredoc_body] = STATE(10427),
    [aux_sym_call_repeat1] = STATE(10427),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8419] = {
    [sym_heredoc_body] = STATE(10428),
    [aux_sym_call_repeat1] = STATE(10428),
    [aux_sym_argument_list_repeat1] = STATE(10429),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12899),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8420] = {
    [aux_sym_chained_string_repeat1] = STATE(8420),
    [sym_string] = STATE(8420),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [8421] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [sym__line_break] = ACTIONS(15175),
    [anon_sym_then] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_when] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym___END__] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_ensure] = ACTIONS(15175),
    [anon_sym_else] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_elsif] = ACTIONS(15175),
    [ts_builtin_sym_end] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
  },
  [8422] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8423] = {
    [anon_sym_RPAREN] = ACTIONS(15177),
    [sym_comment] = ACTIONS(49),
  },
  [8424] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8425] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [8426] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [8427] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [8428] = {
    [sym_assignment] = STATE(10431),
    [sym_unary] = STATE(10431),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10431),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10431),
    [sym_conditional] = STATE(10431),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10431),
    [sym_binary] = STATE(10431),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8429] = {
    [sym_assignment] = STATE(5723),
    [sym_unary] = STATE(5723),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5723),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_splat_argument] = STATE(10432),
    [sym_operator_assignment] = STATE(5723),
    [sym_conditional] = STATE(5723),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_return] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_subshell] = STATE(1125),
    [sym__arg_or_splat_arg] = STATE(10432),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(5723),
    [sym_binary] = STATE(5723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(9270),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1983),
    [sym_character] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8430] = {
    [sym_assignment] = STATE(10433),
    [sym_unary] = STATE(10433),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10433),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10433),
    [sym_conditional] = STATE(10433),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10433),
    [sym_binary] = STATE(10433),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8431] = {
    [sym_assignment] = STATE(10434),
    [sym_unary] = STATE(10434),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10434),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10434),
    [sym_conditional] = STATE(10434),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10434),
    [sym_binary] = STATE(10434),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8432] = {
    [sym_assignment] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8433] = {
    [sym_assignment] = STATE(10437),
    [sym_unary] = STATE(10437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10437),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10437),
    [sym_conditional] = STATE(10437),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10437),
    [sym_binary] = STATE(10437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8434] = {
    [sym_assignment] = STATE(10438),
    [sym_unary] = STATE(10438),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10438),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10438),
    [sym_conditional] = STATE(10438),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10438),
    [sym_binary] = STATE(10438),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8435] = {
    [sym_assignment] = STATE(10439),
    [sym_unary] = STATE(10439),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10439),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10439),
    [sym_conditional] = STATE(10439),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10439),
    [sym_binary] = STATE(10439),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8436] = {
    [sym_assignment] = STATE(10440),
    [sym_unary] = STATE(10440),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10440),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10440),
    [sym_conditional] = STATE(10440),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10440),
    [sym_binary] = STATE(10440),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8437] = {
    [sym_assignment] = STATE(10441),
    [sym_unary] = STATE(10441),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10441),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10441),
    [sym_conditional] = STATE(10441),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10441),
    [sym_binary] = STATE(10441),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8438] = {
    [sym_assignment] = STATE(10442),
    [sym_unary] = STATE(10442),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10442),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(10442),
    [sym_conditional] = STATE(10442),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(10442),
    [sym_binary] = STATE(10442),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8439] = {
    [sym_assignment] = STATE(5723),
    [sym_unary] = STATE(5723),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(5723),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(5723),
    [sym_conditional] = STATE(5723),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_return] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_true] = STATE(5722),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(5723),
    [sym_binary] = STATE(5723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(9270),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1983),
    [sym_character] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [8440] = {
    [aux_sym_exceptions_repeat1] = STATE(10443),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(12945),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [8441] = {
    [anon_sym_end] = ACTIONS(15179),
    [sym_comment] = ACTIONS(49),
  },
  [8442] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [8443] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [8444] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [8445] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [8446] = {
    [sym_assignment] = STATE(10445),
    [sym_unary] = STATE(10445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10445),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10445),
    [sym_conditional] = STATE(10445),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10445),
    [sym_binary] = STATE(10445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8447] = {
    [sym_assignment] = STATE(10446),
    [sym_unary] = STATE(10446),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10446),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_splat_argument] = STATE(10447),
    [sym_operator_assignment] = STATE(10446),
    [sym_conditional] = STATE(10446),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_return] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(5741),
    [sym__arg_or_splat_arg] = STATE(10447),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10446),
    [sym_binary] = STATE(10446),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [sym_global_variable] = ACTIONS(9302),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(9294),
    [sym_character] = ACTIONS(9298),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8448] = {
    [sym_assignment] = STATE(10448),
    [sym_unary] = STATE(10448),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10448),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10448),
    [sym_conditional] = STATE(10448),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10448),
    [sym_binary] = STATE(10448),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8449] = {
    [sym_assignment] = STATE(10449),
    [sym_unary] = STATE(10449),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10449),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10449),
    [sym_conditional] = STATE(10449),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10449),
    [sym_binary] = STATE(10449),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8450] = {
    [sym_assignment] = STATE(10451),
    [sym_unary] = STATE(10451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10451),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10451),
    [sym_conditional] = STATE(10451),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10451),
    [sym_binary] = STATE(10451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8451] = {
    [sym_assignment] = STATE(10452),
    [sym_unary] = STATE(10452),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10452),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10452),
    [sym_conditional] = STATE(10452),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10452),
    [sym_binary] = STATE(10452),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8452] = {
    [sym_assignment] = STATE(10453),
    [sym_unary] = STATE(10453),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10453),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10453),
    [sym_conditional] = STATE(10453),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10453),
    [sym_binary] = STATE(10453),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8453] = {
    [sym_assignment] = STATE(10454),
    [sym_unary] = STATE(10454),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10454),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10454),
    [sym_conditional] = STATE(10454),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10454),
    [sym_binary] = STATE(10454),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8454] = {
    [sym_assignment] = STATE(10455),
    [sym_unary] = STATE(10455),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10455),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10455),
    [sym_conditional] = STATE(10455),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10455),
    [sym_binary] = STATE(10455),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8455] = {
    [sym_assignment] = STATE(10456),
    [sym_unary] = STATE(10456),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10456),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10456),
    [sym_conditional] = STATE(10456),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10456),
    [sym_binary] = STATE(10456),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8456] = {
    [sym_assignment] = STATE(10457),
    [sym_unary] = STATE(10457),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10457),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(10457),
    [sym_conditional] = STATE(10457),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10457),
    [sym_binary] = STATE(10457),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [8457] = {
    [aux_sym_chained_string_repeat1] = STATE(10458),
    [sym_string] = STATE(10458),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [8458] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8459] = {
    [aux_sym_exceptions_repeat1] = STATE(10460),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [8460] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(3036),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym_float] = ACTIONS(5106),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(5110),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(5110),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(5116),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5116),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_class_variable] = ACTIONS(5118),
    [sym__block_ampersand] = ACTIONS(5126),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(5128),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(12983),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [8461] = {
    [sym_heredoc_body] = STATE(8461),
    [aux_sym_call_repeat1] = STATE(8461),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8462] = {
    [sym_heredoc_body] = STATE(8461),
    [aux_sym_call_repeat1] = STATE(8461),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8463] = {
    [aux_sym_argument_list_repeat1] = STATE(8463),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15181),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8464] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8465] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8466] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8467] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15184),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8468] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8469] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8470] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8471] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [8472] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8473] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8474] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8475] = {
    [aux_sym_chained_string_repeat1] = STATE(8475),
    [sym_string] = STATE(8475),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [8476] = {
    [sym_assignment] = STATE(10462),
    [sym_unary] = STATE(10462),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10462),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(10462),
    [sym_conditional] = STATE(10462),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(1126),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym_range] = STATE(10462),
    [sym_binary] = STATE(10462),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(1129),
    [sym_nil] = STATE(1129),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(2003),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8477] = {
    [sym_assignment] = STATE(10463),
    [sym_unary] = STATE(10463),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10463),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(10463),
    [sym_conditional] = STATE(10463),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(10463),
    [sym_binary] = STATE(10463),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [8478] = {
    [sym_assignment] = STATE(10464),
    [sym_unary] = STATE(10464),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10464),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(10464),
    [sym_conditional] = STATE(10464),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(10464),
    [sym_binary] = STATE(10464),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [8479] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8480] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8481] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8482] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(10465),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15186),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [8483] = {
    [sym_heredoc_body] = STATE(10466),
    [aux_sym_call_repeat1] = STATE(10466),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8484] = {
    [sym_heredoc_body] = STATE(10467),
    [aux_sym_call_repeat1] = STATE(10467),
    [aux_sym_argument_list_repeat1] = STATE(10468),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(12991),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8485] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8486] = {
    [sym_assignment] = STATE(10469),
    [sym_unary] = STATE(10469),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(10469),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(10469),
    [sym_conditional] = STATE(10469),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(10469),
    [sym_binary] = STATE(10469),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [8487] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8488] = {
    [aux_sym_exceptions_repeat1] = STATE(10471),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8489] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8490] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8491] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8492] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8493] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15188),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8494] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8495] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [8496] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8497] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8498] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8499] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8500] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10474),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15190),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8501] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8502] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8503] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8502),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10475),
    [sym_operator] = STATE(10475),
    [anon_sym_LT] = ACTIONS(12997),
    [anon_sym_SLASH] = ACTIONS(12999),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(12999),
    [anon_sym_PLUS_AT] = ACTIONS(12999),
    [anon_sym_LPAREN2] = ACTIONS(13001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12999),
    [anon_sym_GT_GT] = ACTIONS(12999),
    [anon_sym_EQ_TILDE] = ACTIONS(12999),
    [anon_sym_LT_LT] = ACTIONS(12999),
    [anon_sym_TILDE] = ACTIONS(12999),
    [anon_sym_PLUS] = ACTIONS(12997),
    [anon_sym_AMP] = ACTIONS(12999),
    [anon_sym_GT] = ACTIONS(12997),
    [anon_sym_PERCENT] = ACTIONS(12999),
    [anon_sym_DASH_AT] = ACTIONS(12999),
    [anon_sym_EQ_EQ] = ACTIONS(12997),
    [anon_sym_STAR] = ACTIONS(12997),
    [anon_sym_BANG_TILDE] = ACTIONS(12999),
    [sym_constant] = ACTIONS(15192),
    [anon_sym_DASH] = ACTIONS(12997),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(12999),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(12997),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(12999),
    [anon_sym_STAR_STAR] = ACTIONS(12999),
    [anon_sym_PIPE] = ACTIONS(12999),
    [anon_sym_DOT_DOT] = ACTIONS(12999),
    [anon_sym_LT_EQ_GT] = ACTIONS(12999),
    [anon_sym_LT_EQ] = ACTIONS(12997),
    [anon_sym_BANG] = ACTIONS(12997),
    [sym_identifier] = ACTIONS(15192),
    [anon_sym_CARET] = ACTIONS(12999),
  },
  [8504] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8505] = {
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_SLASH] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5212),
    [anon_sym_GT_GT_EQ] = ACTIONS(5212),
    [anon_sym_SLASH_EQ] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5212),
    [anon_sym_LT_LT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_EQ_TILDE] = ACTIONS(5212),
    [sym__binary_star] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5210),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [anon_sym_PERCENT_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_LT_LT_EQ] = ACTIONS(5212),
    [anon_sym_PLUS_EQ] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5212),
    [anon_sym_STAR_EQ] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(5212),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_BANG_TILDE] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(1635),
    [anon_sym_GT_EQ] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5212),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5212),
    [anon_sym_CARET_EQ] = ACTIONS(5212),
    [anon_sym_DASH_EQ] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(5212),
    [anon_sym_STAR_STAR] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_LT_EQ_GT] = ACTIONS(5212),
    [anon_sym_LT_EQ] = ACTIONS(5210),
    [sym__binary_minus] = ACTIONS(5212),
    [anon_sym_EQ] = ACTIONS(5210),
    [anon_sym_CARET] = ACTIONS(5210),
  },
  [8506] = {
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym_string] = STATE(8506),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8507] = {
    [aux_sym_block_parameters_repeat1] = STATE(10477),
    [anon_sym_PIPE] = ACTIONS(15194),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [8508] = {
    [sym_float] = ACTIONS(15149),
    [anon_sym_until] = ACTIONS(15149),
    [anon_sym_undef] = ACTIONS(15149),
    [sym_self] = ACTIONS(15149),
    [anon_sym_BEGIN] = ACTIONS(15149),
    [anon_sym_RBRACE] = ACTIONS(15147),
    [anon_sym_TILDE] = ACTIONS(15147),
    [anon_sym_unless] = ACTIONS(15149),
    [anon_sym_PLUS] = ACTIONS(15149),
    [sym__symbol_array_start] = ACTIONS(15147),
    [sym__simple_symbol] = ACTIONS(15147),
    [sym_complex] = ACTIONS(15147),
    [sym_heredoc_beginning] = ACTIONS(15147),
    [sym_super] = ACTIONS(15149),
    [anon_sym_alias] = ACTIONS(15149),
    [anon_sym_LBRACK2] = ACTIONS(15147),
    [anon_sym_nil] = ACTIONS(15149),
    [sym_character] = ACTIONS(15147),
    [anon_sym_LBRACE] = ACTIONS(15147),
    [anon_sym_END] = ACTIONS(15149),
    [sym_constant] = ACTIONS(15149),
    [anon_sym_while] = ACTIONS(15149),
    [sym_instance_variable] = ACTIONS(15147),
    [anon_sym_defined_QMARK] = ACTIONS(15147),
    [sym__string_start] = ACTIONS(15147),
    [anon_sym_true] = ACTIONS(15149),
    [anon_sym_for] = ACTIONS(15149),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(15147),
    [anon_sym_NIL] = ACTIONS(15149),
    [anon_sym_COLON_COLON] = ACTIONS(15147),
    [anon_sym_def] = ACTIONS(15149),
    [sym_identifier] = ACTIONS(15149),
    [anon_sym_yield] = ACTIONS(15149),
    [sym_class_variable] = ACTIONS(15147),
    [sym__symbol_start] = ACTIONS(15147),
    [anon_sym_not] = ACTIONS(15149),
    [anon_sym_TRUE] = ACTIONS(15149),
    [anon_sym_case] = ACTIONS(15149),
    [anon_sym_SEMI] = ACTIONS(15147),
    [anon_sym_LPAREN] = ACTIONS(15147),
    [anon_sym_break] = ACTIONS(15149),
    [sym_global_variable] = ACTIONS(15147),
    [anon_sym_class] = ACTIONS(15149),
    [sym__subshell_start] = ACTIONS(15147),
    [anon_sym_module] = ACTIONS(15149),
    [anon_sym_begin] = ACTIONS(15149),
    [anon_sym_false] = ACTIONS(15149),
    [anon_sym_STAR] = ACTIONS(15147),
    [sym__unary_minus] = ACTIONS(15147),
    [anon_sym_next] = ACTIONS(15149),
    [sym_retry] = ACTIONS(15149),
    [sym__regex_start] = ACTIONS(15147),
    [sym_integer] = ACTIONS(15149),
    [anon_sym_FALSE] = ACTIONS(15149),
    [sym_redo] = ACTIONS(15149),
    [anon_sym_BANG] = ACTIONS(15147),
    [anon_sym_if] = ACTIONS(15149),
    [sym__string_array_start] = ACTIONS(15147),
    [anon_sym_return] = ACTIONS(15149),
  },
  [8509] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(15194),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [8510] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(15196),
  },
  [8511] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
    [anon_sym_PIPE] = ACTIONS(15194),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(15198),
    [anon_sym_LPAREN] = ACTIONS(2033),
  },
  [8512] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [8513] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [8514] = {
    [sym_assignment] = STATE(10480),
    [sym_unary] = STATE(10480),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10480),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10480),
    [sym_conditional] = STATE(10480),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10480),
    [sym_binary] = STATE(10480),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8515] = {
    [sym_assignment] = STATE(5855),
    [sym_unary] = STATE(5855),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5855),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_splat_argument] = STATE(10481),
    [sym_operator_assignment] = STATE(5855),
    [sym_conditional] = STATE(5855),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_return] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_subshell] = STATE(1163),
    [sym__arg_or_splat_arg] = STATE(10481),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(5855),
    [sym_binary] = STATE(5855),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(9504),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(2067),
    [sym_character] = ACTIONS(2071),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8516] = {
    [sym_assignment] = STATE(10482),
    [sym_unary] = STATE(10482),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10482),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10482),
    [sym_conditional] = STATE(10482),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10482),
    [sym_binary] = STATE(10482),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8517] = {
    [sym_assignment] = STATE(10483),
    [sym_unary] = STATE(10483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10483),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10483),
    [sym_conditional] = STATE(10483),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10483),
    [sym_binary] = STATE(10483),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8518] = {
    [sym_assignment] = STATE(10484),
    [sym_unary] = STATE(10484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10484),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10484),
    [sym_conditional] = STATE(10484),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10484),
    [sym_binary] = STATE(10484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8519] = {
    [sym_assignment] = STATE(10485),
    [sym_unary] = STATE(10485),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10485),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10485),
    [sym_conditional] = STATE(10485),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10485),
    [sym_binary] = STATE(10485),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8520] = {
    [sym_assignment] = STATE(10486),
    [sym_unary] = STATE(10486),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10486),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10486),
    [sym_conditional] = STATE(10486),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10486),
    [sym_binary] = STATE(10486),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8521] = {
    [sym_assignment] = STATE(10487),
    [sym_unary] = STATE(10487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10487),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10487),
    [sym_conditional] = STATE(10487),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10487),
    [sym_binary] = STATE(10487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8522] = {
    [sym_assignment] = STATE(10488),
    [sym_unary] = STATE(10488),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10488),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10488),
    [sym_conditional] = STATE(10488),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10488),
    [sym_binary] = STATE(10488),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8523] = {
    [sym_assignment] = STATE(10489),
    [sym_unary] = STATE(10489),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10489),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10489),
    [sym_conditional] = STATE(10489),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10489),
    [sym_binary] = STATE(10489),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8524] = {
    [sym_assignment] = STATE(10490),
    [sym_unary] = STATE(10490),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10490),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10490),
    [sym_conditional] = STATE(10490),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10490),
    [sym_binary] = STATE(10490),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8525] = {
    [sym_assignment] = STATE(10491),
    [sym_unary] = STATE(10491),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10491),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(10491),
    [sym_conditional] = STATE(10491),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(10491),
    [sym_binary] = STATE(10491),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8526] = {
    [aux_sym_chained_string_repeat1] = STATE(10492),
    [sym_string] = STATE(10492),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [8527] = {
    [anon_sym_PIPE] = ACTIONS(15200),
    [anon_sym_COMMA] = ACTIONS(15200),
    [anon_sym_RPAREN] = ACTIONS(15200),
    [anon_sym_SEMI] = ACTIONS(15200),
    [sym_comment] = ACTIONS(49),
  },
  [8528] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [8529] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [8530] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [8531] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [8532] = {
    [sym_assignment] = STATE(10493),
    [sym_unary] = STATE(10493),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10493),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10493),
    [sym_conditional] = STATE(10493),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10493),
    [sym_binary] = STATE(10493),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8533] = {
    [sym_assignment] = STATE(10494),
    [sym_unary] = STATE(10494),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10494),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_splat_argument] = STATE(10495),
    [sym_operator_assignment] = STATE(10494),
    [sym_conditional] = STATE(10494),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_subshell] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(10495),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10494),
    [sym_binary] = STATE(10494),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [sym_global_variable] = ACTIONS(5486),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(5478),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8534] = {
    [sym_assignment] = STATE(10496),
    [sym_unary] = STATE(10496),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10496),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10496),
    [sym_conditional] = STATE(10496),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10496),
    [sym_binary] = STATE(10496),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8535] = {
    [sym_assignment] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8536] = {
    [sym_assignment] = STATE(10499),
    [sym_unary] = STATE(10499),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10499),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10499),
    [sym_conditional] = STATE(10499),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10499),
    [sym_binary] = STATE(10499),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8537] = {
    [sym_assignment] = STATE(10500),
    [sym_unary] = STATE(10500),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10500),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10500),
    [sym_conditional] = STATE(10500),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10500),
    [sym_binary] = STATE(10500),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8538] = {
    [sym_assignment] = STATE(10501),
    [sym_unary] = STATE(10501),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10501),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10501),
    [sym_conditional] = STATE(10501),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10501),
    [sym_binary] = STATE(10501),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8539] = {
    [sym_assignment] = STATE(10502),
    [sym_unary] = STATE(10502),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10502),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10502),
    [sym_conditional] = STATE(10502),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10502),
    [sym_binary] = STATE(10502),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8540] = {
    [sym_assignment] = STATE(10503),
    [sym_unary] = STATE(10503),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10503),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10503),
    [sym_conditional] = STATE(10503),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10503),
    [sym_binary] = STATE(10503),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8541] = {
    [sym_assignment] = STATE(10504),
    [sym_unary] = STATE(10504),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10504),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10504),
    [sym_conditional] = STATE(10504),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10504),
    [sym_binary] = STATE(10504),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8542] = {
    [sym_assignment] = STATE(10505),
    [sym_unary] = STATE(10505),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10505),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(10505),
    [sym_conditional] = STATE(10505),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10505),
    [sym_binary] = STATE(10505),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8543] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(3092),
    [sym_unary] = STATE(3092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3092),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(3092),
    [sym_conditional] = STATE(3092),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3094),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(3092),
    [sym_binary] = STATE(3092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5252),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5254),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5256),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13098),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8544] = {
    [sym_heredoc_body] = STATE(8544),
    [aux_sym_call_repeat1] = STATE(8544),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8545] = {
    [sym_heredoc_body] = STATE(8544),
    [aux_sym_call_repeat1] = STATE(8544),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8546] = {
    [aux_sym_argument_list_repeat1] = STATE(8546),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15202),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8547] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8548] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8549] = {
    [aux_sym_exceptions_repeat1] = STATE(10507),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8550] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8551] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8552] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15205),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8553] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8554] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8555] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8556] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8557] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8558] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8559] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8560] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [8561] = {
    [sym_assignment] = STATE(5855),
    [sym_unary] = STATE(5855),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(5855),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_splat_argument] = STATE(10015),
    [sym_operator_assignment] = STATE(5855),
    [sym_conditional] = STATE(5855),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_return] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_true] = STATE(5817),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym__arg_or_splat_arg] = STATE(10015),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(5855),
    [sym_binary] = STATE(5855),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(9504),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(2075),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(2067),
    [sym_character] = ACTIONS(2071),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [8562] = {
    [aux_sym_exceptions_repeat1] = STATE(10509),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8563] = {
    [sym_assignment] = STATE(10510),
    [sym_unary] = STATE(10510),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1161),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(10510),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(1161),
    [sym_operator_assignment] = STATE(10510),
    [sym_conditional] = STATE(10510),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(1165),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(1161),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(1166),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(1161),
    [sym_range] = STATE(10510),
    [sym_binary] = STATE(10510),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(1161),
    [sym_nil] = STATE(1161),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_not] = ACTIONS(2065),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(2077),
    [anon_sym_next] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(2085),
  },
  [8564] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [sym__line_break] = ACTIONS(15209),
    [anon_sym_then] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_when] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym___END__] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_end] = ACTIONS(15209),
    [anon_sym_ensure] = ACTIONS(15209),
    [anon_sym_else] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_elsif] = ACTIONS(15209),
    [ts_builtin_sym_end] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
    [sym__binary_minus] = ACTIONS(15209),
  },
  [8565] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8566] = {
    [anon_sym_RPAREN] = ACTIONS(15211),
    [sym_comment] = ACTIONS(49),
  },
  [8567] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8568] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [8569] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [8570] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [8571] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [8572] = {
    [sym_assignment] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8573] = {
    [sym_assignment] = STATE(10513),
    [sym_unary] = STATE(10513),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10513),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_splat_argument] = STATE(10514),
    [sym_operator_assignment] = STATE(10513),
    [sym_conditional] = STATE(10513),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_return] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_subshell] = STATE(5888),
    [sym__arg_or_splat_arg] = STATE(10514),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10513),
    [sym_binary] = STATE(10513),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [sym_global_variable] = ACTIONS(9540),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(9532),
    [sym_character] = ACTIONS(9536),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8574] = {
    [sym_assignment] = STATE(10515),
    [sym_unary] = STATE(10515),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10515),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10515),
    [sym_conditional] = STATE(10515),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10515),
    [sym_binary] = STATE(10515),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8575] = {
    [sym_assignment] = STATE(10516),
    [sym_unary] = STATE(10516),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10516),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10516),
    [sym_conditional] = STATE(10516),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10516),
    [sym_binary] = STATE(10516),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8576] = {
    [sym_assignment] = STATE(10518),
    [sym_unary] = STATE(10518),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10518),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10518),
    [sym_conditional] = STATE(10518),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10518),
    [sym_binary] = STATE(10518),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8577] = {
    [sym_assignment] = STATE(10519),
    [sym_unary] = STATE(10519),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10519),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10519),
    [sym_conditional] = STATE(10519),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10519),
    [sym_binary] = STATE(10519),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8578] = {
    [sym_assignment] = STATE(10520),
    [sym_unary] = STATE(10520),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10520),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10520),
    [sym_conditional] = STATE(10520),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10520),
    [sym_binary] = STATE(10520),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8579] = {
    [sym_assignment] = STATE(10521),
    [sym_unary] = STATE(10521),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10521),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10521),
    [sym_conditional] = STATE(10521),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10521),
    [sym_binary] = STATE(10521),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8580] = {
    [sym_assignment] = STATE(10522),
    [sym_unary] = STATE(10522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10522),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10522),
    [sym_conditional] = STATE(10522),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10522),
    [sym_binary] = STATE(10522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8581] = {
    [sym_assignment] = STATE(10523),
    [sym_unary] = STATE(10523),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10523),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10523),
    [sym_conditional] = STATE(10523),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10523),
    [sym_binary] = STATE(10523),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8582] = {
    [sym_assignment] = STATE(10524),
    [sym_unary] = STATE(10524),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10524),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(10524),
    [sym_conditional] = STATE(10524),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10524),
    [sym_binary] = STATE(10524),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [8583] = {
    [aux_sym_chained_string_repeat1] = STATE(10525),
    [sym_string] = STATE(10525),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [8584] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8585] = {
    [aux_sym_exceptions_repeat1] = STATE(10527),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [8586] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(3131),
    [sym_unary] = STATE(3131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3131),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(3131),
    [sym_conditional] = STATE(3131),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3132),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(3131),
    [sym_binary] = STATE(3131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(5306),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(5316),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5322),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(5324),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5326),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(5328),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13142),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [8587] = {
    [sym_heredoc_body] = STATE(8587),
    [aux_sym_call_repeat1] = STATE(8587),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8588] = {
    [sym_heredoc_body] = STATE(8587),
    [aux_sym_call_repeat1] = STATE(8587),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8589] = {
    [aux_sym_argument_list_repeat1] = STATE(8589),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15213),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8590] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8591] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8592] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8593] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15216),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8594] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8595] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8596] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8597] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8598] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8599] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8600] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8601] = {
    [aux_sym_chained_string_repeat1] = STATE(8601),
    [sym_string] = STATE(8601),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [8602] = {
    [sym__line_break] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_then] = ACTIONS(5080),
    [anon_sym_AMP_DOT] = ACTIONS(5080),
    [anon_sym_COLON_COLON2] = ACTIONS(5080),
    [sym__heredoc_body_start] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(49),
  },
  [8603] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(10530),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(10530),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10531),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(15218),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(15218),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15220),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8604] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_block_parameters] = STATE(10532),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10531),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15220),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8605] = {
    [anon_sym_end] = ACTIONS(15222),
    [sym_comment] = ACTIONS(49),
  },
  [8606] = {
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_DOT] = ACTIONS(5212),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_COMMA] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
  },
  [8607] = {
    [sym__statement] = STATE(555),
    [sym_unary] = STATE(560),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(555),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_unless_modifier] = STATE(555),
    [sym_symbol] = STATE(556),
    [sym_for] = STATE(556),
    [sym_if] = STATE(556),
    [sym__primary] = STATE(556),
    [sym_method] = STATE(556),
    [sym_conditional] = STATE(560),
    [sym_left_assignment_list] = STATE(557),
    [sym_return] = STATE(556),
    [sym_true] = STATE(559),
    [sym_while_modifier] = STATE(555),
    [sym_subshell] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_empty_statement] = STATE(563),
    [sym_parenthesized_statements] = STATE(556),
    [sym_begin_block] = STATE(555),
    [sym_range] = STATE(560),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(559),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_array] = STATE(556),
    [sym_call] = STATE(558),
    [sym_end_block] = STATE(555),
    [sym_assignment] = STATE(560),
    [sym__lhs] = STATE(559),
    [sym_singleton_class] = STATE(556),
    [sym_alias] = STATE(555),
    [sym_if_modifier] = STATE(555),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(560),
    [sym_method_call] = STATE(559),
    [sym_operator_assignment] = STATE(560),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_rational] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(561),
    [sym_until_modifier] = STATE(555),
    [sym_lambda] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym__statements] = STATE(10534),
    [sym_binary] = STATE(560),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_nil] = STATE(559),
    [sym_rescue_modifier] = STATE(555),
    [sym_symbol_array] = STATE(556),
    [sym_case] = STATE(556),
    [sym_hash] = STATE(556),
    [aux_sym__statements_repeat1] = STATE(563),
    [sym_scope_resolution] = STATE(558),
    [sym_float] = ACTIONS(1057),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1059),
    [sym_self] = ACTIONS(1061),
    [anon_sym_BEGIN] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(15224),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1069),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1061),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1071),
    [anon_sym_defined_QMARK] = ACTIONS(1073),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1071),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(1083),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(1085),
    [anon_sym_next] = ACTIONS(1087),
    [sym_retry] = ACTIONS(1057),
    [sym__regex_start] = ACTIONS(89),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(1089),
  },
  [8608] = {
    [anon_sym_RBRACE] = ACTIONS(15224),
    [sym_comment] = ACTIONS(49),
  },
  [8609] = {
    [sym__line_break] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5238),
    [sym_comment] = ACTIONS(49),
  },
  [8610] = {
    [sym_float] = ACTIONS(15226),
    [anon_sym_until] = ACTIONS(15226),
    [anon_sym_undef] = ACTIONS(15226),
    [sym_self] = ACTIONS(15226),
    [anon_sym_BEGIN] = ACTIONS(15226),
    [anon_sym_TILDE] = ACTIONS(15228),
    [anon_sym_unless] = ACTIONS(15226),
    [anon_sym_PLUS] = ACTIONS(15226),
    [sym__symbol_array_start] = ACTIONS(15228),
    [sym__simple_symbol] = ACTIONS(15228),
    [sym_complex] = ACTIONS(15228),
    [sym_heredoc_beginning] = ACTIONS(15228),
    [sym_super] = ACTIONS(15226),
    [anon_sym_rescue] = ACTIONS(15226),
    [anon_sym_alias] = ACTIONS(15226),
    [anon_sym_LBRACK2] = ACTIONS(15228),
    [anon_sym_nil] = ACTIONS(15226),
    [sym_character] = ACTIONS(15228),
    [anon_sym_LBRACE] = ACTIONS(15228),
    [anon_sym_END] = ACTIONS(15226),
    [sym_constant] = ACTIONS(15226),
    [anon_sym_while] = ACTIONS(15226),
    [sym_instance_variable] = ACTIONS(15228),
    [anon_sym_defined_QMARK] = ACTIONS(15228),
    [sym__string_start] = ACTIONS(15228),
    [anon_sym_else] = ACTIONS(15226),
    [anon_sym_true] = ACTIONS(15226),
    [anon_sym_for] = ACTIONS(15226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(15228),
    [anon_sym_NIL] = ACTIONS(15226),
    [anon_sym_COLON_COLON] = ACTIONS(15228),
    [anon_sym_def] = ACTIONS(15226),
    [sym_identifier] = ACTIONS(15226),
    [anon_sym_yield] = ACTIONS(15226),
    [sym_class_variable] = ACTIONS(15228),
    [anon_sym_not] = ACTIONS(15226),
    [sym__symbol_start] = ACTIONS(15228),
    [anon_sym_TRUE] = ACTIONS(15226),
    [anon_sym_case] = ACTIONS(15226),
    [anon_sym_SEMI] = ACTIONS(15228),
    [anon_sym_LPAREN] = ACTIONS(15228),
    [anon_sym_break] = ACTIONS(15226),
    [sym_global_variable] = ACTIONS(15228),
    [anon_sym_class] = ACTIONS(15226),
    [sym__subshell_start] = ACTIONS(15228),
    [anon_sym_module] = ACTIONS(15226),
    [anon_sym_begin] = ACTIONS(15226),
    [anon_sym_false] = ACTIONS(15226),
    [anon_sym_STAR] = ACTIONS(15228),
    [sym__unary_minus] = ACTIONS(15228),
    [anon_sym_next] = ACTIONS(15226),
    [sym_retry] = ACTIONS(15226),
    [sym__regex_start] = ACTIONS(15228),
    [anon_sym_end] = ACTIONS(15226),
    [anon_sym_ensure] = ACTIONS(15226),
    [sym_integer] = ACTIONS(15226),
    [anon_sym_FALSE] = ACTIONS(15226),
    [sym_redo] = ACTIONS(15226),
    [anon_sym_BANG] = ACTIONS(15228),
    [anon_sym_if] = ACTIONS(15226),
    [sym__string_array_start] = ACTIONS(15228),
    [anon_sym_return] = ACTIONS(15226),
  },
  [8611] = {
    [sym_heredoc_body] = STATE(10535),
    [sym__terminator] = STATE(10535),
    [sym__line_break] = ACTIONS(15230),
    [sym_float] = ACTIONS(15226),
    [anon_sym_until] = ACTIONS(15226),
    [anon_sym_undef] = ACTIONS(15226),
    [sym_self] = ACTIONS(15226),
    [anon_sym_BEGIN] = ACTIONS(15226),
    [anon_sym_TILDE] = ACTIONS(15228),
    [anon_sym_unless] = ACTIONS(15226),
    [anon_sym_PLUS] = ACTIONS(15226),
    [sym__symbol_array_start] = ACTIONS(15228),
    [sym__simple_symbol] = ACTIONS(15228),
    [sym_complex] = ACTIONS(15228),
    [sym_heredoc_beginning] = ACTIONS(15228),
    [sym_super] = ACTIONS(15226),
    [anon_sym_rescue] = ACTIONS(15226),
    [anon_sym_alias] = ACTIONS(15226),
    [anon_sym_LBRACK2] = ACTIONS(15228),
    [anon_sym_nil] = ACTIONS(15226),
    [sym_character] = ACTIONS(15228),
    [anon_sym_LBRACE] = ACTIONS(15228),
    [anon_sym_END] = ACTIONS(15226),
    [sym_constant] = ACTIONS(15226),
    [anon_sym_while] = ACTIONS(15226),
    [sym_instance_variable] = ACTIONS(15228),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_defined_QMARK] = ACTIONS(15228),
    [sym__string_start] = ACTIONS(15228),
    [anon_sym_else] = ACTIONS(15226),
    [anon_sym_true] = ACTIONS(15226),
    [anon_sym_for] = ACTIONS(15226),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(15228),
    [anon_sym_NIL] = ACTIONS(15226),
    [anon_sym_COLON_COLON] = ACTIONS(15228),
    [anon_sym_def] = ACTIONS(15226),
    [sym_identifier] = ACTIONS(15226),
    [anon_sym_yield] = ACTIONS(15226),
    [sym_class_variable] = ACTIONS(15228),
    [anon_sym_not] = ACTIONS(15226),
    [sym__symbol_start] = ACTIONS(15228),
    [anon_sym_TRUE] = ACTIONS(15226),
    [anon_sym_case] = ACTIONS(15226),
    [anon_sym_SEMI] = ACTIONS(15230),
    [anon_sym_LPAREN] = ACTIONS(15228),
    [anon_sym_break] = ACTIONS(15226),
    [sym_global_variable] = ACTIONS(15228),
    [anon_sym_class] = ACTIONS(15226),
    [sym__subshell_start] = ACTIONS(15228),
    [anon_sym_module] = ACTIONS(15226),
    [anon_sym_begin] = ACTIONS(15226),
    [anon_sym_false] = ACTIONS(15226),
    [anon_sym_STAR] = ACTIONS(15228),
    [sym__unary_minus] = ACTIONS(15228),
    [anon_sym_next] = ACTIONS(15226),
    [sym_retry] = ACTIONS(15226),
    [sym__regex_start] = ACTIONS(15228),
    [anon_sym_end] = ACTIONS(15226),
    [anon_sym_ensure] = ACTIONS(15226),
    [sym_integer] = ACTIONS(15226),
    [anon_sym_FALSE] = ACTIONS(15226),
    [sym_redo] = ACTIONS(15226),
    [anon_sym_BANG] = ACTIONS(15228),
    [anon_sym_if] = ACTIONS(15226),
    [sym__string_array_start] = ACTIONS(15228),
    [anon_sym_return] = ACTIONS(15226),
  },
  [8612] = {
    [aux_sym_method_parameters_repeat1] = STATE(10537),
    [anon_sym_RPAREN] = ACTIONS(15232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [8613] = {
    [sym_splat_parameter] = STATE(10538),
    [sym_hash_splat_parameter] = STATE(10538),
    [sym_block_parameter] = STATE(10538),
    [sym__formal_parameter] = STATE(10538),
    [sym__simple_formal_parameter] = STATE(10538),
    [sym_keyword_parameter] = STATE(10538),
    [sym_optional_parameter] = STATE(10538),
    [sym_destructured_parameter] = STATE(10538),
    [anon_sym_LPAREN] = ACTIONS(9604),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2095),
  },
  [8614] = {
    [sym_heredoc_body] = STATE(10535),
    [sym__terminator] = STATE(10535),
    [aux_sym_method_parameters_repeat1] = STATE(10539),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(15230),
    [anon_sym_COMMA] = ACTIONS(13162),
    [anon_sym_SEMI] = ACTIONS(15230),
    [sym_comment] = ACTIONS(49),
  },
  [8615] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [sym__line_break] = ACTIONS(11545),
    [anon_sym_then] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_EQ_GT] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_when] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym___END__] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_end] = ACTIONS(11545),
    [anon_sym_ensure] = ACTIONS(11545),
    [anon_sym_else] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_elsif] = ACTIONS(11545),
    [ts_builtin_sym_end] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
    [sym__binary_minus] = ACTIONS(11545),
  },
  [8616] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [sym__line_break] = ACTIONS(11868),
    [anon_sym_then] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_EQ_GT] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_when] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym___END__] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_end] = ACTIONS(11868),
    [anon_sym_ensure] = ACTIONS(11868),
    [anon_sym_else] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_elsif] = ACTIONS(11868),
    [ts_builtin_sym_end] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
    [sym__binary_minus] = ACTIONS(11868),
  },
  [8617] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [sym__line_break] = ACTIONS(11879),
    [anon_sym_then] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_EQ_GT] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_when] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym___END__] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_end] = ACTIONS(11879),
    [anon_sym_ensure] = ACTIONS(11879),
    [anon_sym_else] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_elsif] = ACTIONS(11879),
    [ts_builtin_sym_end] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
    [sym__binary_minus] = ACTIONS(11879),
  },
  [8618] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15234),
  },
  [8619] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [sym__line_break] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
    [sym__binary_minus] = ACTIONS(12166),
  },
  [8620] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [sym__line_break] = ACTIONS(12632),
    [anon_sym_then] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_EQ_GT] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_when] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym___END__] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_end] = ACTIONS(12632),
    [anon_sym_ensure] = ACTIONS(12632),
    [anon_sym_else] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_elsif] = ACTIONS(12632),
    [ts_builtin_sym_end] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
    [sym__binary_minus] = ACTIONS(12632),
  },
  [8621] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [sym__line_break] = ACTIONS(12797),
    [anon_sym_then] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_EQ_GT] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_when] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym___END__] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_end] = ACTIONS(12797),
    [anon_sym_ensure] = ACTIONS(12797),
    [anon_sym_else] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_elsif] = ACTIONS(12797),
    [ts_builtin_sym_end] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
    [sym__binary_minus] = ACTIONS(12797),
  },
  [8622] = {
    [anon_sym_end] = ACTIONS(15236),
    [sym_comment] = ACTIONS(49),
  },
  [8623] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [sym__line_break] = ACTIONS(12905),
    [anon_sym_then] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_when] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym___END__] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_end] = ACTIONS(12905),
    [anon_sym_ensure] = ACTIONS(12905),
    [anon_sym_else] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_elsif] = ACTIONS(12905),
    [ts_builtin_sym_end] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
  },
  [8624] = {
    [anon_sym_end] = ACTIONS(15238),
    [sym_comment] = ACTIONS(49),
  },
  [8625] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10543),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15240),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8626] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [sym__line_break] = ACTIONS(13019),
    [anon_sym_then] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_when] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym___END__] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_end] = ACTIONS(13019),
    [anon_sym_ensure] = ACTIONS(13019),
    [anon_sym_else] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_elsif] = ACTIONS(13019),
    [ts_builtin_sym_end] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
  },
  [8627] = {
    [sym__method_name] = STATE(1202),
    [sym_setter] = STATE(1202),
    [sym_symbol] = STATE(1202),
    [sym_operator] = STATE(1202),
    [sym__method_rest] = STATE(10544),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(9648),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(9648),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(9648),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(9648),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [8628] = {
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_SLASH] = ACTIONS(8575),
    [sym__line_break] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_EQ_GT] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_PERCENT] = ACTIONS(8575),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_when] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym___END__] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(8575),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(8575),
    [anon_sym_ensure] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_elsif] = ACTIONS(8575),
    [ts_builtin_sym_end] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_AMP_AMP] = ACTIONS(8575),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(8575),
    [sym__binary_minus] = ACTIONS(8575),
  },
  [8629] = {
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_SLASH] = ACTIONS(12375),
    [sym__line_break] = ACTIONS(12375),
    [anon_sym_then] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(12375),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_PLUS] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_EQ_GT] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_PERCENT] = ACTIONS(12375),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_when] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym___END__] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(12375),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_end] = ACTIONS(12375),
    [anon_sym_ensure] = ACTIONS(12375),
    [anon_sym_else] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_elsif] = ACTIONS(12375),
    [ts_builtin_sym_end] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(12375),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_AMP_AMP] = ACTIONS(12375),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(12375),
    [sym__binary_minus] = ACTIONS(12375),
  },
  [8630] = {
    [sym_heredoc_body] = STATE(8630),
    [aux_sym_call_repeat1] = STATE(8630),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym___END__] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [8631] = {
    [sym_heredoc_body] = STATE(8630),
    [aux_sym_call_repeat1] = STATE(8630),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym___END__] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [8632] = {
    [sym_assignment] = STATE(5957),
    [sym_unary] = STATE(5957),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(5957),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(5957),
    [sym_conditional] = STATE(5957),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_return] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_true] = STATE(1223),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(5957),
    [sym_binary] = STATE(5957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [sym_global_variable] = ACTIONS(39),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11),
    [sym_character] = ACTIONS(15),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [8633] = {
    [aux_sym_exceptions_repeat1] = STATE(10545),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15242),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym___END__] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [8634] = {
    [sym_assignment] = STATE(10546),
    [sym_unary] = STATE(10546),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1223),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(10546),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1223),
    [sym_operator_assignment] = STATE(10546),
    [sym_conditional] = STATE(10546),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1225),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1223),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1223),
    [sym_range] = STATE(10546),
    [sym_binary] = STATE(10546),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2153),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2151),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2159),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2163),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [8635] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [sym__line_break] = ACTIONS(13276),
    [anon_sym_then] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_EQ_GT] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_when] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym___END__] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_end] = ACTIONS(13276),
    [anon_sym_ensure] = ACTIONS(13276),
    [anon_sym_else] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_elsif] = ACTIONS(13276),
    [ts_builtin_sym_end] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
    [sym__binary_minus] = ACTIONS(13276),
  },
  [8636] = {
    [anon_sym_end] = ACTIONS(15244),
    [sym_comment] = ACTIONS(49),
  },
  [8637] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(10548),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(15244),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [8638] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8639] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [8640] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3222),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5462),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5464),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(5466),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5256),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13200),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8641] = {
    [sym_heredoc_body] = STATE(8641),
    [aux_sym_call_repeat1] = STATE(8641),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8642] = {
    [sym_heredoc_body] = STATE(8641),
    [aux_sym_call_repeat1] = STATE(8641),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8643] = {
    [aux_sym_argument_list_repeat1] = STATE(8643),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15246),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8644] = {
    [sym_heredoc_body] = STATE(10549),
    [aux_sym_call_repeat1] = STATE(10549),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8645] = {
    [sym_heredoc_body] = STATE(10550),
    [aux_sym_call_repeat1] = STATE(10550),
    [aux_sym_argument_list_repeat1] = STATE(8546),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9468),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8646] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8647] = {
    [sym_assignment] = STATE(10551),
    [sym_unary] = STATE(10551),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10551),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(10551),
    [sym_conditional] = STATE(10551),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(10551),
    [sym_binary] = STATE(10551),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [8648] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8649] = {
    [aux_sym_exceptions_repeat1] = STATE(10553),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8650] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8651] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8652] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8653] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8654] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15249),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8655] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8656] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [8657] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8658] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8659] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8660] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_RPAREN] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8661] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10556),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15251),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8662] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_RPAREN] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8663] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_RPAREN] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8664] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8663),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10557),
    [sym_operator] = STATE(10557),
    [anon_sym_LT] = ACTIONS(13204),
    [anon_sym_SLASH] = ACTIONS(13206),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13206),
    [anon_sym_PLUS_AT] = ACTIONS(13206),
    [anon_sym_LPAREN2] = ACTIONS(13208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13206),
    [anon_sym_GT_GT] = ACTIONS(13206),
    [anon_sym_EQ_TILDE] = ACTIONS(13206),
    [anon_sym_LT_LT] = ACTIONS(13206),
    [anon_sym_TILDE] = ACTIONS(13206),
    [anon_sym_PLUS] = ACTIONS(13204),
    [anon_sym_AMP] = ACTIONS(13206),
    [anon_sym_GT] = ACTIONS(13204),
    [anon_sym_PERCENT] = ACTIONS(13206),
    [anon_sym_DASH_AT] = ACTIONS(13206),
    [anon_sym_EQ_EQ] = ACTIONS(13204),
    [anon_sym_STAR] = ACTIONS(13204),
    [anon_sym_BANG_TILDE] = ACTIONS(13206),
    [sym_constant] = ACTIONS(15253),
    [anon_sym_DASH] = ACTIONS(13204),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13206),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13204),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13206),
    [anon_sym_STAR_STAR] = ACTIONS(13206),
    [anon_sym_PIPE] = ACTIONS(13206),
    [anon_sym_DOT_DOT] = ACTIONS(13206),
    [anon_sym_LT_EQ_GT] = ACTIONS(13206),
    [anon_sym_LT_EQ] = ACTIONS(13204),
    [anon_sym_BANG] = ACTIONS(13204),
    [sym_identifier] = ACTIONS(15253),
    [anon_sym_CARET] = ACTIONS(13206),
  },
  [8665] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_RPAREN] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8666] = {
    [aux_sym_chained_string_repeat1] = STATE(8666),
    [sym_string] = STATE(8666),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8667] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [sym__identifier_hash_key] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [sym__block_ampersand] = ACTIONS(4446),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [sym__splat_star] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [anon_sym_STAR_STAR] = ACTIONS(4446),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [8668] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(15255),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [8669] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(12377),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8670] = {
    [sym__argument] = STATE(2476),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(2476),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(2476),
    [sym_hash_splat_argument] = STATE(2476),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(10559),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(2476),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8671] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [8672] = {
    [sym_assignment] = STATE(6010),
    [sym_unary] = STATE(6010),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6010),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(6010),
    [sym_conditional] = STATE(6010),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(6010),
    [sym_binary] = STATE(6010),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9716),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(2173),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8673] = {
    [aux_sym_exceptions_repeat1] = STATE(10560),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15257),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8674] = {
    [sym_assignment] = STATE(10561),
    [sym_unary] = STATE(10561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(10561),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(1246),
    [sym_operator_assignment] = STATE(10561),
    [sym_conditional] = STATE(10561),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_range] = STATE(10561),
    [sym_binary] = STATE(10561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_not] = ACTIONS(2197),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8675] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8676] = {
    [anon_sym_RPAREN] = ACTIONS(15259),
    [sym_comment] = ACTIONS(49),
  },
  [8677] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8678] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8679] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [8680] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(3262),
    [sym_unary] = STATE(3262),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(3262),
    [sym__primary] = STATE(3126),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(3262),
    [sym_conditional] = STATE(3262),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(3263),
    [sym_rational] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(3262),
    [sym_binary] = STATE(3262),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(5306),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(5312),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(5538),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5540),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5538),
    [anon_sym_yield] = ACTIONS(5324),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5542),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(5328),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [sym_retry] = ACTIONS(5306),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [sym_redo] = ACTIONS(5306),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [8681] = {
    [sym_heredoc_body] = STATE(8681),
    [aux_sym_call_repeat1] = STATE(8681),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8682] = {
    [sym_heredoc_body] = STATE(8681),
    [aux_sym_call_repeat1] = STATE(8681),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8683] = {
    [aux_sym_argument_list_repeat1] = STATE(8683),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15261),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8684] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [sym__line_break] = ACTIONS(13464),
    [anon_sym_then] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_EQ_GT] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_when] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym___END__] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_end] = ACTIONS(13464),
    [anon_sym_ensure] = ACTIONS(13464),
    [anon_sym_else] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_elsif] = ACTIONS(13464),
    [ts_builtin_sym_end] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
    [sym__binary_minus] = ACTIONS(13464),
  },
  [8685] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [sym__line_break] = ACTIONS(13468),
    [anon_sym_then] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_EQ_GT] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_when] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym___END__] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_end] = ACTIONS(13468),
    [anon_sym_ensure] = ACTIONS(13468),
    [anon_sym_else] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_elsif] = ACTIONS(13468),
    [ts_builtin_sym_end] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
    [sym__binary_minus] = ACTIONS(13468),
  },
  [8686] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [sym__line_break] = ACTIONS(13739),
    [anon_sym_then] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_EQ_GT] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_when] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym___END__] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_end] = ACTIONS(13739),
    [anon_sym_ensure] = ACTIONS(13739),
    [anon_sym_else] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_elsif] = ACTIONS(13739),
    [ts_builtin_sym_end] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
    [sym__binary_minus] = ACTIONS(13739),
  },
  [8687] = {
    [anon_sym_end] = ACTIONS(15264),
    [sym_comment] = ACTIONS(49),
  },
  [8688] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [sym__line_break] = ACTIONS(13954),
    [anon_sym_then] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_EQ_GT] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_when] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym___END__] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_end] = ACTIONS(13954),
    [anon_sym_ensure] = ACTIONS(13954),
    [anon_sym_else] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_elsif] = ACTIONS(13954),
    [ts_builtin_sym_end] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
    [sym__binary_minus] = ACTIONS(13954),
  },
  [8689] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [sym__line_break] = ACTIONS(13958),
    [anon_sym_then] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_EQ_GT] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_when] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym___END__] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_end] = ACTIONS(13958),
    [anon_sym_ensure] = ACTIONS(13958),
    [anon_sym_else] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_elsif] = ACTIONS(13958),
    [ts_builtin_sym_end] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
    [sym__binary_minus] = ACTIONS(13958),
  },
  [8690] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15266),
  },
  [8691] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [sym__line_break] = ACTIONS(13964),
    [anon_sym_then] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_EQ_GT] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_when] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym___END__] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_end] = ACTIONS(13964),
    [anon_sym_ensure] = ACTIONS(13964),
    [anon_sym_else] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_elsif] = ACTIONS(13964),
    [ts_builtin_sym_end] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
    [sym__binary_minus] = ACTIONS(13964),
  },
  [8692] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [sym__identifier_hash_key] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym__block_ampersand] = ACTIONS(8575),
    [sym_identifier] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_yield] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [sym__splat_star] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(10412),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [8693] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [8694] = {
    [aux_sym_exceptions_repeat1] = STATE(8694),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15268),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [8695] = {
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2253),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [sym__binary_star] = ACTIONS(2247),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_BANG_TILDE] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(2271),
    [sym__binary_minus] = ACTIONS(2259),
  },
  [8696] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym___END__] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [ts_builtin_sym_end] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [8697] = {
    [anon_sym_SLASH] = ACTIONS(13017),
    [sym__line_break] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_else] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_then] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_EQ_GT] = ACTIONS(13019),
    [anon_sym_when] = ACTIONS(13019),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym___END__] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_end] = ACTIONS(13019),
    [anon_sym_ensure] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_elsif] = ACTIONS(13019),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [ts_builtin_sym_end] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [8698] = {
    [anon_sym_SLASH] = ACTIONS(12903),
    [sym__line_break] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_else] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_then] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_EQ_GT] = ACTIONS(12905),
    [anon_sym_when] = ACTIONS(12905),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym___END__] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_end] = ACTIONS(12905),
    [anon_sym_ensure] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_elsif] = ACTIONS(12905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [ts_builtin_sym_end] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [8699] = {
    [anon_sym_end] = ACTIONS(15273),
    [sym_comment] = ACTIONS(49),
  },
  [8700] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(10566),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15275),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [8701] = {
    [anon_sym_SLASH] = ACTIONS(10412),
    [sym__line_break] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_AMP_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8575),
    [anon_sym_SLASH_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(10412),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(10412),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(10412),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_PERCENT_EQ] = ACTIONS(8575),
    [anon_sym_LT_LT_EQ] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_CARET_EQ] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_EQ] = ACTIONS(10412),
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_then] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_EQ_GT] = ACTIONS(8575),
    [anon_sym_when] = ACTIONS(8575),
    [anon_sym_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_PLUS_EQ] = ACTIONS(8575),
    [anon_sym_STAR_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym___END__] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(10412),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(8575),
    [anon_sym_ensure] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_elsif] = ACTIONS(8575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8575),
    [ts_builtin_sym_end] = ACTIONS(8575),
    [anon_sym_DASH_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(10412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_AMP_AMP] = ACTIONS(10412),
    [sym__binary_minus] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(10412),
  },
  [8702] = {
    [anon_sym_SLASH] = ACTIONS(13245),
    [sym__line_break] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_AMP_EQ] = ACTIONS(12375),
    [anon_sym_GT_GT_EQ] = ACTIONS(12375),
    [anon_sym_SLASH_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(13245),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_PLUS] = ACTIONS(13245),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_PERCENT] = ACTIONS(13245),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_PERCENT_EQ] = ACTIONS(12375),
    [anon_sym_LT_LT_EQ] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_else] = ACTIONS(12375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_CARET_EQ] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_EQ] = ACTIONS(13245),
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_then] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(13245),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_EQ_GT] = ACTIONS(12375),
    [anon_sym_when] = ACTIONS(12375),
    [anon_sym_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_PLUS_EQ] = ACTIONS(12375),
    [anon_sym_STAR_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym___END__] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(13245),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_end] = ACTIONS(12375),
    [anon_sym_ensure] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_elsif] = ACTIONS(12375),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12375),
    [ts_builtin_sym_end] = ACTIONS(12375),
    [anon_sym_DASH_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(13245),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_AMP_AMP] = ACTIONS(13245),
    [sym__binary_minus] = ACTIONS(12375),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(13245),
  },
  [8703] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [8704] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [8705] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(3349),
    [sym_unary] = STATE(3349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(3349),
    [sym__primary] = STATE(492),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(3349),
    [sym_conditional] = STATE(3349),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3350),
    [sym_rational] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(3349),
    [sym_binary] = STATE(3349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym_float] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2311),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2311),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5636),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2317),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [sym__identifier_hash_key] = ACTIONS(5638),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(2323),
    [sym_class_variable] = ACTIONS(2317),
    [sym__block_ampersand] = ACTIONS(5640),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2327),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_retry] = ACTIONS(911),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13267),
    [sym_redo] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [8706] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8707] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8708] = {
    [aux_sym_argument_list_repeat1] = STATE(8708),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15277),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8709] = {
    [sym_heredoc_body] = STATE(10567),
    [aux_sym_call_repeat1] = STATE(10567),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8710] = {
    [sym_heredoc_body] = STATE(10568),
    [aux_sym_call_repeat1] = STATE(10568),
    [aux_sym_argument_list_repeat1] = STATE(6108),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8711] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8712] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8713] = {
    [aux_sym_exceptions_repeat1] = STATE(10570),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8714] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8715] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8716] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8717] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8718] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15280),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8719] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8720] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [8721] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8722] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8723] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8724] = {
    [aux_sym_chained_string_repeat1] = STATE(8724),
    [sym_string] = STATE(8724),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8725] = {
    [sym_assignment] = STATE(6110),
    [sym_unary] = STATE(6110),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(6110),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(6110),
    [sym_conditional] = STATE(6110),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_return] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_true] = STATE(1327),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(6110),
    [sym_binary] = STATE(6110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5642),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [sym_global_variable] = ACTIONS(2317),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2311),
    [sym_character] = ACTIONS(919),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [8726] = {
    [aux_sym_exceptions_repeat1] = STATE(10572),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15282),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8727] = {
    [sym_assignment] = STATE(10573),
    [sym_unary] = STATE(10573),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1327),
    [sym_singleton_class] = STATE(492),
    [sym_module] = STATE(492),
    [sym_chained_string] = STATE(492),
    [sym_until] = STATE(492),
    [sym_regex] = STATE(492),
    [sym_for] = STATE(492),
    [sym_symbol] = STATE(492),
    [sym_if] = STATE(492),
    [sym_begin] = STATE(492),
    [sym__arg] = STATE(10573),
    [sym__primary] = STATE(492),
    [sym_method_call] = STATE(1327),
    [sym_operator_assignment] = STATE(10573),
    [sym_conditional] = STATE(10573),
    [sym_method] = STATE(492),
    [sym_singleton_method] = STATE(492),
    [sym__variable] = STATE(1329),
    [sym_left_assignment_list] = STATE(1330),
    [sym_rational] = STATE(492),
    [sym_true] = STATE(1327),
    [sym_return] = STATE(492),
    [sym_subshell] = STATE(492),
    [sym_yield] = STATE(492),
    [sym_string] = STATE(3339),
    [sym_unless] = STATE(492),
    [sym_lambda] = STATE(492),
    [sym_parenthesized_statements] = STATE(492),
    [sym_element_reference] = STATE(1327),
    [sym_range] = STATE(10573),
    [sym_binary] = STATE(10573),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(492),
    [sym_break] = STATE(492),
    [sym_next] = STATE(492),
    [sym_string_array] = STATE(492),
    [sym_while] = STATE(492),
    [sym_case] = STATE(492),
    [sym_symbol_array] = STATE(492),
    [sym_array] = STATE(492),
    [sym_hash] = STATE(492),
    [sym_false] = STATE(1327),
    [sym_nil] = STATE(1327),
    [sym_scope_resolution] = STATE(1329),
    [sym_call] = STATE(1329),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(911),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2323),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_not] = ACTIONS(2327),
    [sym_self] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2331),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2317),
    [sym_character] = ACTIONS(919),
    [sym_super] = ACTIONS(2311),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(911),
    [sym_constant] = ACTIONS(2311),
    [anon_sym_defined_QMARK] = ACTIONS(2319),
    [sym_instance_variable] = ACTIONS(2317),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(3308),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2311),
    [sym_redo] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(2317),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2309),
  },
  [8728] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [8729] = {
    [aux_sym_exceptions_repeat1] = STATE(6139),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8730] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [8731] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [8732] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [8733] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8734] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15284),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8735] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8736] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [8737] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8738] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8739] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8740] = {
    [aux_sym_exceptions_repeat1] = STATE(8740),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15286),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [8741] = {
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [8742] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [sym__line_break] = ACTIONS(15291),
    [anon_sym_then] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_when] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym___END__] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_end] = ACTIONS(15291),
    [anon_sym_ensure] = ACTIONS(15291),
    [anon_sym_else] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_elsif] = ACTIONS(15291),
    [ts_builtin_sym_end] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
    [sym__binary_minus] = ACTIONS(15291),
  },
  [8743] = {
    [anon_sym_end] = ACTIONS(15293),
    [sym_comment] = ACTIONS(49),
  },
  [8744] = {
    [sym_assignment] = STATE(10576),
    [sym_unary] = STATE(10576),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10576),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(10576),
    [sym_conditional] = STATE(10576),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(10576),
    [sym_binary] = STATE(10576),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8745] = {
    [sym_assignment] = STATE(10577),
    [sym_unary] = STATE(10577),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10577),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(10577),
    [sym_conditional] = STATE(10577),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(10577),
    [sym_binary] = STATE(10577),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8746] = {
    [sym_assignment] = STATE(10578),
    [sym_unary] = STATE(10578),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10578),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(10578),
    [sym_conditional] = STATE(10578),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(10578),
    [sym_binary] = STATE(10578),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8747] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8748] = {
    [sym_assignment] = STATE(10579),
    [sym_unary] = STATE(10579),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10579),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(10579),
    [sym_conditional] = STATE(10579),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(10579),
    [sym_binary] = STATE(10579),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8749] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15295),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(15295),
    [anon_sym_SLASH_EQ] = ACTIONS(15295),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15295),
    [anon_sym_PIPE_EQ] = ACTIONS(15295),
    [anon_sym_LT_LT_EQ] = ACTIONS(15295),
    [anon_sym_PLUS_EQ] = ACTIONS(15295),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15295),
    [anon_sym_STAR_EQ] = ACTIONS(15295),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15295),
    [anon_sym_CARET_EQ] = ACTIONS(15295),
    [anon_sym_DASH_EQ] = ACTIONS(15295),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15295),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15297),
  },
  [8750] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [8751] = {
    [anon_sym_EQ] = ACTIONS(15325),
    [sym_comment] = ACTIONS(3),
  },
  [8752] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [8753] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [8754] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_heredoc_body] = STATE(10591),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2595),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2603),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6101),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15327),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [8755] = {
    [sym_heredoc_body] = STATE(10592),
    [aux_sym_call_repeat1] = STATE(10592),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8756] = {
    [sym_heredoc_body] = STATE(10593),
    [aux_sym_call_repeat1] = STATE(10593),
    [aux_sym_argument_list_repeat1] = STATE(10594),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13294),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8757] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8758] = {
    [sym_assignment] = STATE(10595),
    [sym_unary] = STATE(10595),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10595),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(10595),
    [sym_conditional] = STATE(10595),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(10595),
    [sym_binary] = STATE(10595),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [8759] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8760] = {
    [aux_sym_exceptions_repeat1] = STATE(10597),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8761] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8762] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8763] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8764] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8765] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15329),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8766] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8767] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [8768] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8769] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8770] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8771] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_then] = ACTIONS(1327),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8772] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10600),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15331),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8773] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_then] = ACTIONS(6719),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8774] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_then] = ACTIONS(6727),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8775] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8774),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10601),
    [sym_operator] = STATE(10601),
    [anon_sym_LT] = ACTIONS(13300),
    [anon_sym_SLASH] = ACTIONS(13302),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13302),
    [anon_sym_PLUS_AT] = ACTIONS(13302),
    [anon_sym_LPAREN2] = ACTIONS(13304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13302),
    [anon_sym_GT_GT] = ACTIONS(13302),
    [anon_sym_EQ_TILDE] = ACTIONS(13302),
    [anon_sym_LT_LT] = ACTIONS(13302),
    [anon_sym_TILDE] = ACTIONS(13302),
    [anon_sym_PLUS] = ACTIONS(13300),
    [anon_sym_AMP] = ACTIONS(13302),
    [anon_sym_GT] = ACTIONS(13300),
    [anon_sym_PERCENT] = ACTIONS(13302),
    [anon_sym_DASH_AT] = ACTIONS(13302),
    [anon_sym_EQ_EQ] = ACTIONS(13300),
    [anon_sym_STAR] = ACTIONS(13300),
    [anon_sym_BANG_TILDE] = ACTIONS(13302),
    [sym_constant] = ACTIONS(15333),
    [anon_sym_DASH] = ACTIONS(13300),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13302),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13300),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13302),
    [anon_sym_STAR_STAR] = ACTIONS(13302),
    [anon_sym_PIPE] = ACTIONS(13302),
    [anon_sym_DOT_DOT] = ACTIONS(13302),
    [anon_sym_LT_EQ_GT] = ACTIONS(13302),
    [anon_sym_LT_EQ] = ACTIONS(13300),
    [anon_sym_BANG] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(15333),
    [anon_sym_CARET] = ACTIONS(13302),
  },
  [8776] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8777] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(6215),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_when] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [8778] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(15335),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [8779] = {
    [sym__method_name] = STATE(10603),
    [sym_setter] = STATE(10603),
    [sym_symbol] = STATE(10603),
    [sym_operator] = STATE(10603),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(131),
    [sym_class_variable] = ACTIONS(15337),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(131),
    [anon_sym_PLUS_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(131),
    [anon_sym_EQ_TILDE] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [sym_global_variable] = ACTIONS(15337),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(131),
    [sym__simple_symbol] = ACTIONS(135),
    [anon_sym_DASH_AT] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_BANG_TILDE] = ACTIONS(131),
    [sym_constant] = ACTIONS(15337),
    [anon_sym_DASH] = ACTIONS(129),
    [sym_instance_variable] = ACTIONS(15337),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(129),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_STAR_STAR] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_DOT_DOT] = ACTIONS(131),
    [anon_sym_LT_EQ_GT] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_BANG] = ACTIONS(129),
    [sym_identifier] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(131),
    [sym__symbol_start] = ACTIONS(139),
  },
  [8780] = {
    [sym_assignment] = STATE(10604),
    [sym_unary] = STATE(10604),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(10604),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(10604),
    [sym_conditional] = STATE(10604),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(10604),
    [sym_binary] = STATE(10604),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8781] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8782] = {
    [sym_assignment] = STATE(10605),
    [sym_unary] = STATE(10605),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(10605),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(10605),
    [sym_conditional] = STATE(10605),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(10605),
    [sym_binary] = STATE(10605),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8783] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(15339),
    [sym_identifier] = ACTIONS(15339),
  },
  [8784] = {
    [sym__argument] = STATE(10620),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(10620),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(10620),
    [sym_hash_splat_argument] = STATE(10620),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(10627),
    [sym_block_argument] = STATE(10620),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [8785] = {
    [sym_float] = ACTIONS(605),
    [anon_sym_until] = ACTIONS(605),
    [anon_sym_undef] = ACTIONS(605),
    [sym_self] = ACTIONS(605),
    [anon_sym_BEGIN] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_unless] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(605),
    [sym__symbol_array_start] = ACTIONS(607),
    [sym__simple_symbol] = ACTIONS(607),
    [sym_complex] = ACTIONS(607),
    [sym_heredoc_beginning] = ACTIONS(607),
    [sym_super] = ACTIONS(605),
    [anon_sym_alias] = ACTIONS(605),
    [anon_sym_LBRACK2] = ACTIONS(607),
    [anon_sym_nil] = ACTIONS(605),
    [sym_character] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_END] = ACTIONS(605),
    [sym_constant] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [sym_instance_variable] = ACTIONS(607),
    [anon_sym_defined_QMARK] = ACTIONS(607),
    [sym__string_start] = ACTIONS(607),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(605),
    [anon_sym_for] = ACTIONS(605),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(607),
    [anon_sym_NIL] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_def] = ACTIONS(605),
    [sym_identifier] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(605),
    [sym_class_variable] = ACTIONS(607),
    [anon_sym_not] = ACTIONS(605),
    [sym__symbol_start] = ACTIONS(607),
    [anon_sym_TRUE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(605),
    [sym_global_variable] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(605),
    [sym__subshell_start] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(605),
    [anon_sym_begin] = ACTIONS(605),
    [anon_sym_false] = ACTIONS(605),
    [anon_sym_when] = ACTIONS(605),
    [anon_sym_STAR] = ACTIONS(607),
    [sym__unary_minus] = ACTIONS(607),
    [anon_sym_next] = ACTIONS(605),
    [sym_retry] = ACTIONS(605),
    [sym__regex_start] = ACTIONS(607),
    [anon_sym_end] = ACTIONS(605),
    [sym_integer] = ACTIONS(605),
    [anon_sym_FALSE] = ACTIONS(605),
    [sym_redo] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(605),
    [sym__string_array_start] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(605),
  },
  [8786] = {
    [sym__argument] = STATE(10620),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(10620),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(10620),
    [sym_hash_splat_argument] = STATE(10620),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(10627),
    [sym_block_argument] = STATE(10620),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(647),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [8787] = {
    [sym__argument] = STATE(10620),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(10620),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(10620),
    [sym_hash_splat_argument] = STATE(10620),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(10627),
    [sym_block_argument] = STATE(10620),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [8788] = {
    [sym__argument] = STATE(10620),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(10620),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(10620),
    [sym_hash_splat_argument] = STATE(10620),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(10627),
    [sym_block_argument] = STATE(10620),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(753),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [8789] = {
    [sym_heredoc_body] = STATE(10634),
    [sym__terminator] = STATE(10634),
    [sym__line_break] = ACTIONS(15377),
    [anon_sym_unless] = ACTIONS(15379),
    [anon_sym_until] = ACTIONS(15381),
    [anon_sym_while] = ACTIONS(15383),
    [sym__heredoc_body_start] = ACTIONS(15385),
    [anon_sym_rescue] = ACTIONS(15387),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_when] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(15377),
    [anon_sym_if] = ACTIONS(15389),
    [sym_comment] = ACTIONS(49),
  },
  [8790] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(15391),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_when] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(15393),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15395),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [8791] = {
    [anon_sym_EQ] = ACTIONS(15397),
    [sym_comment] = ACTIONS(3),
  },
  [8792] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym__primary] = STATE(10650),
    [sym_argument_list] = STATE(453),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_method] = STATE(10650),
    [sym_conditional] = STATE(10655),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_subshell] = STATE(10650),
    [sym_unless] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10654),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_call] = STATE(10652),
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_rational] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_lambda] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(10655),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_nil] = STATE(10654),
    [sym_symbol_array] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_scope_resolution] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(813),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(825),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [8793] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15433),
    [anon_sym_GT_GT_EQ] = ACTIONS(15433),
    [anon_sym_SLASH_EQ] = ACTIONS(15433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15433),
    [anon_sym_LT_LT_EQ] = ACTIONS(15433),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15433),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(15433),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15435),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(15433),
    [anon_sym_PLUS_EQ] = ACTIONS(15433),
    [anon_sym_STAR_EQ] = ACTIONS(15433),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15433),
    [anon_sym_DASH_EQ] = ACTIONS(15433),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15433),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8794] = {
    [sym__line_break] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(873),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(873),
    [anon_sym_when] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(873),
    [sym__heredoc_body_start] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [8795] = {
    [aux_sym_chained_string_repeat1] = STATE(10669),
    [sym_string] = STATE(10669),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [8796] = {
    [sym__statement] = STATE(10670),
    [sym_unary] = STATE(8794),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(10670),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_unless_modifier] = STATE(10670),
    [sym_symbol] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym__primary] = STATE(8790),
    [sym_method] = STATE(8790),
    [sym_conditional] = STATE(8794),
    [sym_left_assignment_list] = STATE(8791),
    [sym_return] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_while_modifier] = STATE(10670),
    [sym_subshell] = STATE(8790),
    [sym_unless] = STATE(8790),
    [sym_empty_statement] = STATE(10671),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_begin_block] = STATE(10670),
    [sym_range] = STATE(8794),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(8793),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_call] = STATE(8792),
    [sym_end_block] = STATE(10670),
    [sym_assignment] = STATE(8794),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_alias] = STATE(10670),
    [sym_if_modifier] = STATE(10670),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(8794),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(8794),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_rational] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_until_modifier] = STATE(10670),
    [sym_lambda] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_binary] = STATE(8794),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_nil] = STATE(8793),
    [sym_rescue_modifier] = STATE(10670),
    [sym_symbol_array] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_hash] = STATE(8790),
    [aux_sym__statements_repeat1] = STATE(10671),
    [sym_scope_resolution] = STATE(8792),
    [sym_float] = ACTIONS(13314),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(13316),
    [sym_self] = ACTIONS(13318),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(13318),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(13326),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [anon_sym_yield] = ACTIONS(13332),
    [sym_class_variable] = ACTIONS(13326),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(13334),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [sym_retry] = ACTIONS(13314),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(909),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(13314),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8797] = {
    [sym__line_break] = ACTIONS(15465),
    [anon_sym_then] = ACTIONS(15465),
    [sym__heredoc_body_start] = ACTIONS(15465),
    [anon_sym_COMMA] = ACTIONS(15465),
    [anon_sym_SEMI] = ACTIONS(15465),
    [sym_comment] = ACTIONS(49),
  },
  [8798] = {
    [sym__statement] = STATE(8789),
    [sym_unary] = STATE(8794),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(8789),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_unless_modifier] = STATE(8789),
    [sym_symbol] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym__primary] = STATE(8790),
    [sym_method] = STATE(8790),
    [sym_conditional] = STATE(8794),
    [sym_left_assignment_list] = STATE(8791),
    [sym_return] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_while_modifier] = STATE(8789),
    [sym_subshell] = STATE(8790),
    [sym_unless] = STATE(8790),
    [sym_empty_statement] = STATE(8796),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_begin_block] = STATE(8789),
    [sym_range] = STATE(8794),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(8793),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_call] = STATE(8792),
    [sym_end_block] = STATE(8789),
    [sym_assignment] = STATE(8794),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_alias] = STATE(8789),
    [sym_if_modifier] = STATE(8789),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(8794),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(8794),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_rational] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_until_modifier] = STATE(8789),
    [sym_lambda] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym__statements] = STATE(4659),
    [sym_binary] = STATE(8794),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_nil] = STATE(8793),
    [sym_rescue_modifier] = STATE(8789),
    [sym_symbol_array] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_hash] = STATE(8790),
    [aux_sym__statements_repeat1] = STATE(8796),
    [sym_scope_resolution] = STATE(8792),
    [sym_float] = ACTIONS(13314),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(13316),
    [sym_self] = ACTIONS(13318),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(13318),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(13326),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(7786),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [anon_sym_yield] = ACTIONS(13332),
    [sym_class_variable] = ACTIONS(13326),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(13334),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_when] = ACTIONS(7786),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [sym_retry] = ACTIONS(13314),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(7786),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(13314),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8799] = {
    [sym__statement] = STATE(8789),
    [sym_unary] = STATE(8794),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(8789),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_unless_modifier] = STATE(8789),
    [sym_symbol] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym__primary] = STATE(8790),
    [sym_method] = STATE(8790),
    [sym_conditional] = STATE(8794),
    [sym_left_assignment_list] = STATE(8791),
    [sym_return] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_while_modifier] = STATE(8789),
    [sym_subshell] = STATE(8790),
    [sym_unless] = STATE(8790),
    [sym_empty_statement] = STATE(8796),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_begin_block] = STATE(8789),
    [sym_range] = STATE(8794),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(8793),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_call] = STATE(8792),
    [sym_end_block] = STATE(8789),
    [sym_assignment] = STATE(8794),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_alias] = STATE(8789),
    [sym_if_modifier] = STATE(8789),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(8794),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(8794),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_rational] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_until_modifier] = STATE(8789),
    [sym_lambda] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(8794),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_nil] = STATE(8793),
    [sym_rescue_modifier] = STATE(8789),
    [sym_symbol_array] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_hash] = STATE(8790),
    [aux_sym__statements_repeat1] = STATE(8796),
    [sym_scope_resolution] = STATE(8792),
    [sym_float] = ACTIONS(13314),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(13316),
    [sym_self] = ACTIONS(13318),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(13318),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(13326),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(15467),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [anon_sym_yield] = ACTIONS(13332),
    [sym_class_variable] = ACTIONS(13326),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(13334),
    [anon_sym_then] = ACTIONS(13348),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_when] = ACTIONS(15467),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [sym_retry] = ACTIONS(13314),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15467),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(13314),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [8800] = {
    [anon_sym_end] = ACTIONS(15469),
    [anon_sym_when] = ACTIONS(15469),
    [anon_sym_else] = ACTIONS(15469),
    [sym_comment] = ACTIONS(49),
  },
  [8801] = {
    [aux_sym_when_repeat1] = STATE(8801),
    [sym__line_break] = ACTIONS(15465),
    [anon_sym_then] = ACTIONS(15465),
    [sym__heredoc_body_start] = ACTIONS(15465),
    [anon_sym_COMMA] = ACTIONS(15471),
    [anon_sym_SEMI] = ACTIONS(15465),
    [sym_comment] = ACTIONS(49),
  },
  [8802] = {
    [sym_assignment] = STATE(10672),
    [sym_unary] = STATE(10672),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(10672),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(10672),
    [sym_conditional] = STATE(10672),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(10672),
    [sym_binary] = STATE(10672),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [8803] = {
    [sym_assignment] = STATE(10673),
    [sym_unary] = STATE(10673),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(10673),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(10673),
    [sym_conditional] = STATE(10673),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(10673),
    [sym_binary] = STATE(10673),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [8804] = {
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1041),
  },
  [8805] = {
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1041),
  },
  [8806] = {
    [sym_assignment] = STATE(10674),
    [sym_unary] = STATE(10674),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(10674),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(10674),
    [sym_conditional] = STATE(10674),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(10674),
    [sym_binary] = STATE(10674),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [8807] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [8808] = {
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1041),
  },
  [8809] = {
    [sym_assignment] = STATE(10675),
    [sym_unary] = STATE(10675),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(10675),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(10675),
    [sym_conditional] = STATE(10675),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(10675),
    [sym_binary] = STATE(10675),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [8810] = {
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1041),
  },
  [8811] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15474),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(15474),
    [anon_sym_SLASH_EQ] = ACTIONS(15474),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15474),
    [anon_sym_PIPE_EQ] = ACTIONS(15474),
    [anon_sym_LT_LT_EQ] = ACTIONS(15474),
    [anon_sym_PLUS_EQ] = ACTIONS(15474),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15474),
    [anon_sym_STAR_EQ] = ACTIONS(15474),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15474),
    [anon_sym_CARET_EQ] = ACTIONS(15474),
    [anon_sym_DASH_EQ] = ACTIONS(15474),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15474),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(15476),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8812] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [8813] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_then] = ACTIONS(777),
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(9947),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(9949),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(9951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [8814] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym__primary] = STATE(3687),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(6182),
    [sym_method] = STATE(3687),
    [sym_conditional] = STATE(6183),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_subshell] = STATE(3687),
    [sym_unless] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_block_argument] = STATE(6182),
    [sym_range] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3691),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_call] = STATE(3689),
    [sym__argument] = STATE(6182),
    [sym_assignment] = STATE(6183),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_pair] = STATE(6182),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(6182),
    [sym_operator_assignment] = STATE(6183),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_rational] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_lambda] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym__argument_list_with_parens] = STATE(6185),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(6183),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_nil] = STATE(3691),
    [sym_symbol_array] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_scope_resolution] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(6175),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(6177),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(6179),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [sym_character] = ACTIONS(6181),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_then] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(9965),
    [anon_sym_not] = ACTIONS(6197),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6207),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1041),
  },
  [8815] = {
    [anon_sym_EQ] = ACTIONS(15506),
    [sym_comment] = ACTIONS(3),
  },
  [8816] = {
    [aux_sym_chained_string_repeat1] = STATE(10687),
    [sym_string] = STATE(10687),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [8817] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [8818] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [8819] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_heredoc_body] = STATE(10688),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(6175),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(9965),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6197),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15508),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [8820] = {
    [sym_heredoc_body] = STATE(10689),
    [aux_sym_call_repeat1] = STATE(10689),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8821] = {
    [sym_heredoc_body] = STATE(10690),
    [aux_sym_call_repeat1] = STATE(10690),
    [aux_sym_argument_list_repeat1] = STATE(10691),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13384),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [8822] = {
    [aux_sym_chained_string_repeat1] = STATE(8822),
    [sym_string] = STATE(8822),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8823] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [8824] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [8825] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(3437),
    [sym_unary] = STATE(3437),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(3437),
    [sym__primary] = STATE(1376),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(3437),
    [sym_conditional] = STATE(3437),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3438),
    [sym_rational] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(3437),
    [sym_binary] = STATE(3437),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_float] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2395),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2395),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(5762),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2403),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(5764),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(2411),
    [sym_class_variable] = ACTIONS(2403),
    [sym__block_ampersand] = ACTIONS(5766),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2415),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [sym_retry] = ACTIONS(2391),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13388),
    [sym_redo] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [8826] = {
    [sym_heredoc_body] = STATE(8826),
    [aux_sym_call_repeat1] = STATE(8826),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [8827] = {
    [sym_heredoc_body] = STATE(8826),
    [aux_sym_call_repeat1] = STATE(8826),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [8828] = {
    [aux_sym_argument_list_repeat1] = STATE(8828),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15510),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [8829] = {
    [sym_heredoc_body] = STATE(10692),
    [aux_sym_call_repeat1] = STATE(10692),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [8830] = {
    [sym_heredoc_body] = STATE(10693),
    [aux_sym_call_repeat1] = STATE(10693),
    [aux_sym_argument_list_repeat1] = STATE(6217),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5788),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [8831] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8832] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8833] = {
    [aux_sym_exceptions_repeat1] = STATE(10695),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [8834] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8835] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8836] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8837] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8838] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15513),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8839] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8840] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8841] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8842] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8843] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [8844] = {
    [aux_sym_chained_string_repeat1] = STATE(8844),
    [sym_string] = STATE(8844),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [8845] = {
    [sym_assignment] = STATE(6219),
    [sym_unary] = STATE(6219),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(6219),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(6219),
    [sym_conditional] = STATE(6219),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_return] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_true] = STATE(1374),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(6219),
    [sym_binary] = STATE(6219),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(5768),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [sym_global_variable] = ACTIONS(2403),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2395),
    [sym_character] = ACTIONS(2397),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [8846] = {
    [aux_sym_exceptions_repeat1] = STATE(10697),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15515),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [8847] = {
    [sym_assignment] = STATE(10698),
    [sym_unary] = STATE(10698),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1374),
    [sym_singleton_class] = STATE(1376),
    [sym_module] = STATE(1376),
    [sym_chained_string] = STATE(1376),
    [sym_until] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_for] = STATE(1376),
    [sym_symbol] = STATE(1376),
    [sym_if] = STATE(1376),
    [sym_begin] = STATE(1376),
    [sym__arg] = STATE(10698),
    [sym__primary] = STATE(1376),
    [sym_method_call] = STATE(1374),
    [sym_operator_assignment] = STATE(10698),
    [sym_conditional] = STATE(10698),
    [sym_method] = STATE(1376),
    [sym_singleton_method] = STATE(1376),
    [sym__variable] = STATE(1377),
    [sym_left_assignment_list] = STATE(1378),
    [sym_rational] = STATE(1376),
    [sym_true] = STATE(1374),
    [sym_return] = STATE(1376),
    [sym_subshell] = STATE(1376),
    [sym_yield] = STATE(1376),
    [sym_string] = STATE(3426),
    [sym_unless] = STATE(1376),
    [sym_lambda] = STATE(1376),
    [sym_parenthesized_statements] = STATE(1376),
    [sym_element_reference] = STATE(1374),
    [sym_range] = STATE(10698),
    [sym_binary] = STATE(10698),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1376),
    [sym_break] = STATE(1376),
    [sym_next] = STATE(1376),
    [sym_string_array] = STATE(1376),
    [sym_while] = STATE(1376),
    [sym_case] = STATE(1376),
    [sym_symbol_array] = STATE(1376),
    [sym_array] = STATE(1376),
    [sym_hash] = STATE(1376),
    [sym_false] = STATE(1374),
    [sym_nil] = STATE(1374),
    [sym_scope_resolution] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2391),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_not] = ACTIONS(2415),
    [sym_self] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2397),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2403),
    [sym_character] = ACTIONS(2397),
    [sym_super] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2421),
    [anon_sym_next] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2391),
    [sym_constant] = ACTIONS(2395),
    [anon_sym_defined_QMARK] = ACTIONS(2405),
    [sym_instance_variable] = ACTIONS(2403),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2395),
    [sym_redo] = ACTIONS(2391),
    [sym_class_variable] = ACTIONS(2403),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2393),
  },
  [8848] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8849] = {
    [anon_sym_RPAREN] = ACTIONS(15517),
    [sym_comment] = ACTIONS(49),
  },
  [8850] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8851] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [8852] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [8853] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(3475),
    [sym_unary] = STATE(3475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(3475),
    [sym__primary] = STATE(1409),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(3475),
    [sym_conditional] = STATE(3475),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3476),
    [sym_rational] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(3475),
    [sym_binary] = STATE(3475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym_float] = ACTIONS(2463),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2467),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2467),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(5826),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2475),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [sym__identifier_hash_key] = ACTIONS(5828),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(2481),
    [sym_class_variable] = ACTIONS(2475),
    [sym__block_ampersand] = ACTIONS(5830),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [sym_retry] = ACTIONS(2463),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13399),
    [sym_redo] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [8854] = {
    [sym_heredoc_body] = STATE(8854),
    [aux_sym_call_repeat1] = STATE(8854),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [8855] = {
    [sym_heredoc_body] = STATE(8854),
    [aux_sym_call_repeat1] = STATE(8854),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [8856] = {
    [aux_sym_argument_list_repeat1] = STATE(8856),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15519),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [8857] = {
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [sym_self] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_nil] = ACTIONS(5452),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [anon_sym_next] = ACTIONS(5452),
    [sym_retry] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_return] = ACTIONS(5452),
  },
  [8858] = {
    [anon_sym_RPAREN] = ACTIONS(15522),
    [sym_comment] = ACTIONS(49),
  },
  [8859] = {
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [sym_self] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_nil] = ACTIONS(10960),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [anon_sym_next] = ACTIONS(10960),
    [sym_retry] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_return] = ACTIONS(10960),
  },
  [8860] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(13437),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [anon_sym_and] = ACTIONS(13437),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_PIPE] = ACTIONS(13449),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [8861] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(13437),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [anon_sym_and] = ACTIONS(13437),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_PIPE] = ACTIONS(13449),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [8862] = {
    [sym_assignment] = STATE(10701),
    [sym_unary] = STATE(10701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(10701),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(10701),
    [sym_conditional] = STATE(10701),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(10701),
    [sym_binary] = STATE(10701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [8863] = {
    [sym_assignment] = STATE(10702),
    [sym_unary] = STATE(10702),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(10702),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(10702),
    [sym_conditional] = STATE(10702),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(10702),
    [sym_binary] = STATE(10702),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [8864] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8865] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8866] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8867] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(10703),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(10059),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15524),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [8868] = {
    [sym_heredoc_body] = STATE(10704),
    [aux_sym_call_repeat1] = STATE(10704),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8869] = {
    [sym_heredoc_body] = STATE(10705),
    [aux_sym_call_repeat1] = STATE(10705),
    [aux_sym_argument_list_repeat1] = STATE(10706),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13409),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [8870] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(15526),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [8871] = {
    [anon_sym_COLON] = ACTIONS(15528),
    [sym_comment] = ACTIONS(49),
  },
  [8872] = {
    [sym_assignment] = STATE(10709),
    [sym_unary] = STATE(10709),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10709),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10709),
    [sym_conditional] = STATE(10709),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10709),
    [sym_binary] = STATE(10709),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8873] = {
    [sym_assignment] = STATE(10710),
    [sym_unary] = STATE(10710),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10710),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10710),
    [sym_conditional] = STATE(10710),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10710),
    [sym_binary] = STATE(10710),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8874] = {
    [sym_assignment] = STATE(10711),
    [sym_unary] = STATE(10711),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10711),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10711),
    [sym_conditional] = STATE(10711),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10711),
    [sym_binary] = STATE(10711),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8875] = {
    [sym_heredoc_body] = STATE(10713),
    [aux_sym_call_repeat1] = STATE(10713),
    [aux_sym_argument_list_repeat1] = STATE(10714),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(15530),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [8876] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_RPAREN] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_EQ_GT] = ACTIONS(15528),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8877] = {
    [aux_sym_chained_string_repeat1] = STATE(6294),
    [sym_string] = STATE(6294),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_RPAREN] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(15532),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [8878] = {
    [sym_heredoc_body] = STATE(10713),
    [aux_sym_call_repeat1] = STATE(10713),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [8879] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [8880] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [8881] = {
    [sym_assignment] = STATE(10715),
    [sym_unary] = STATE(10715),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10715),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10715),
    [sym_conditional] = STATE(10715),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10715),
    [sym_binary] = STATE(10715),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8882] = {
    [sym_assignment] = STATE(10716),
    [sym_unary] = STATE(10716),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10716),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_splat_argument] = STATE(10717),
    [sym_operator_assignment] = STATE(10716),
    [sym_conditional] = STATE(10716),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_subshell] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(10717),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10716),
    [sym_binary] = STATE(10716),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [sym_global_variable] = ACTIONS(9540),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(9532),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8883] = {
    [sym_assignment] = STATE(10718),
    [sym_unary] = STATE(10718),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10718),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10718),
    [sym_conditional] = STATE(10718),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10718),
    [sym_binary] = STATE(10718),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8884] = {
    [sym_assignment] = STATE(10719),
    [sym_unary] = STATE(10719),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10719),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10719),
    [sym_conditional] = STATE(10719),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10719),
    [sym_binary] = STATE(10719),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8885] = {
    [sym_assignment] = STATE(10720),
    [sym_unary] = STATE(10720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10720),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10720),
    [sym_conditional] = STATE(10720),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10720),
    [sym_binary] = STATE(10720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8886] = {
    [sym_assignment] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8887] = {
    [sym_assignment] = STATE(10722),
    [sym_unary] = STATE(10722),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10722),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10722),
    [sym_conditional] = STATE(10722),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10722),
    [sym_binary] = STATE(10722),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [8888] = {
    [sym_assignment] = STATE(10723),
    [sym_unary] = STATE(10723),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10723),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10723),
    [sym_conditional] = STATE(10723),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10723),
    [sym_binary] = STATE(10723),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8889] = {
    [sym_assignment] = STATE(10724),
    [sym_unary] = STATE(10724),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10724),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10724),
    [sym_conditional] = STATE(10724),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10724),
    [sym_binary] = STATE(10724),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8890] = {
    [sym_assignment] = STATE(10725),
    [sym_unary] = STATE(10725),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10725),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10725),
    [sym_conditional] = STATE(10725),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10725),
    [sym_binary] = STATE(10725),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8891] = {
    [sym_assignment] = STATE(10726),
    [sym_unary] = STATE(10726),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10726),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10726),
    [sym_conditional] = STATE(10726),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10726),
    [sym_binary] = STATE(10726),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8892] = {
    [sym_assignment] = STATE(10727),
    [sym_unary] = STATE(10727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10727),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(10727),
    [sym_conditional] = STATE(10727),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10727),
    [sym_binary] = STATE(10727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [8893] = {
    [aux_sym_chained_string_repeat1] = STATE(10728),
    [sym_string] = STATE(10728),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [8894] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8895] = {
    [aux_sym_exceptions_repeat1] = STATE(10730),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8896] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3498),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(5852),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5848),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(5858),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5860),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(5868),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [8897] = {
    [sym_heredoc_body] = STATE(8897),
    [aux_sym_call_repeat1] = STATE(8897),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12684),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
  },
  [8898] = {
    [sym_heredoc_body] = STATE(8897),
    [aux_sym_call_repeat1] = STATE(8897),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
  },
  [8899] = {
    [aux_sym_argument_list_repeat1] = STATE(8899),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15534),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
  },
  [8900] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8901] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8902] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8903] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15537),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8904] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8905] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8906] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8907] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [8908] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8909] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8910] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8911] = {
    [aux_sym_chained_string_repeat1] = STATE(8911),
    [sym_string] = STATE(8911),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8912] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [8913] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8914] = {
    [aux_sym_exceptions_repeat1] = STATE(6315),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [8915] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8916] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8917] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8918] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8919] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15539),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8920] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8921] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8922] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [8923] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8924] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [8925] = {
    [aux_sym_exceptions_repeat1] = STATE(8925),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15541),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [8926] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8927] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8928] = {
    [aux_sym_exceptions_repeat1] = STATE(10734),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [8929] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8930] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8931] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8932] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8933] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15544),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8934] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8935] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [8936] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8937] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8938] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [8939] = {
    [aux_sym_chained_string_repeat1] = STATE(8939),
    [sym_string] = STATE(8939),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [8940] = {
    [sym_assignment] = STATE(6332),
    [sym_unary] = STATE(6332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(6332),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(6332),
    [sym_conditional] = STATE(6332),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_return] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_true] = STATE(1413),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(6332),
    [sym_binary] = STATE(6332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(5832),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [sym_global_variable] = ACTIONS(2475),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2467),
    [sym_character] = ACTIONS(2469),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [8941] = {
    [aux_sym_exceptions_repeat1] = STATE(10736),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15546),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [8942] = {
    [sym_assignment] = STATE(10737),
    [sym_unary] = STATE(10737),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1413),
    [sym_singleton_class] = STATE(1409),
    [sym_module] = STATE(1409),
    [sym_chained_string] = STATE(1409),
    [sym_until] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_for] = STATE(1409),
    [sym_symbol] = STATE(1409),
    [sym_if] = STATE(1409),
    [sym_begin] = STATE(1409),
    [sym__arg] = STATE(10737),
    [sym__primary] = STATE(1409),
    [sym_method_call] = STATE(1413),
    [sym_operator_assignment] = STATE(10737),
    [sym_conditional] = STATE(10737),
    [sym_method] = STATE(1409),
    [sym_singleton_method] = STATE(1409),
    [sym__variable] = STATE(1411),
    [sym_left_assignment_list] = STATE(1410),
    [sym_rational] = STATE(1409),
    [sym_true] = STATE(1413),
    [sym_return] = STATE(1409),
    [sym_subshell] = STATE(1409),
    [sym_yield] = STATE(1409),
    [sym_string] = STATE(3524),
    [sym_unless] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_parenthesized_statements] = STATE(1409),
    [sym_element_reference] = STATE(1413),
    [sym_range] = STATE(10737),
    [sym_binary] = STATE(10737),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1409),
    [sym_break] = STATE(1409),
    [sym_next] = STATE(1409),
    [sym_string_array] = STATE(1409),
    [sym_while] = STATE(1409),
    [sym_case] = STATE(1409),
    [sym_symbol_array] = STATE(1409),
    [sym_array] = STATE(1409),
    [sym_hash] = STATE(1409),
    [sym_false] = STATE(1413),
    [sym_nil] = STATE(1413),
    [sym_scope_resolution] = STATE(1411),
    [sym_call] = STATE(1411),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2463),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2481),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_not] = ACTIONS(2485),
    [sym_self] = ACTIONS(2467),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2489),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2475),
    [sym_character] = ACTIONS(2469),
    [sym_super] = ACTIONS(2467),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2491),
    [anon_sym_next] = ACTIONS(2493),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2463),
    [sym_constant] = ACTIONS(2467),
    [anon_sym_defined_QMARK] = ACTIONS(2477),
    [sym_instance_variable] = ACTIONS(2475),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2467),
    [sym_redo] = ACTIONS(2463),
    [sym_class_variable] = ACTIONS(2475),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2465),
  },
  [8943] = {
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(2505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2511),
    [anon_sym_LT_LT] = ACTIONS(2509),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [sym__binary_star] = ACTIONS(2503),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_BANG_TILDE] = ACTIONS(2507),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(2521),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2503),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_DOT_DOT] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ_GT] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2501),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(2527),
    [sym__binary_minus] = ACTIONS(2515),
  },
  [8944] = {
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [sym_self] = ACTIONS(9736),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_nil] = ACTIONS(9736),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [anon_sym_next] = ACTIONS(9736),
    [sym_retry] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9736),
  },
  [8945] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [8946] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [8947] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3594),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(6001),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(6003),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6005),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13472),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [8948] = {
    [sym_heredoc_body] = STATE(8948),
    [aux_sym_call_repeat1] = STATE(8948),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8949] = {
    [sym_heredoc_body] = STATE(8948),
    [aux_sym_call_repeat1] = STATE(8948),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8950] = {
    [aux_sym_argument_list_repeat1] = STATE(8950),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15548),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8951] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8952] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8953] = {
    [aux_sym_exceptions_repeat1] = STATE(10739),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8954] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8955] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8956] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8957] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8958] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8959] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8960] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [8961] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8962] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8963] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8964] = {
    [aux_sym_chained_string_repeat1] = STATE(8964),
    [sym_string] = STATE(8964),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [8965] = {
    [sym_assignment] = STATE(6381),
    [sym_unary] = STATE(6381),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6381),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(6381),
    [sym_conditional] = STATE(6381),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(6381),
    [sym_binary] = STATE(6381),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6007),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [8966] = {
    [aux_sym_exceptions_repeat1] = STATE(10741),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15553),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [8967] = {
    [sym_assignment] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1454),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3582),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_not] = ACTIONS(2561),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2565),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [8968] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8969] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8970] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(3644),
    [sym_unary] = STATE(3644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(3644),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(3644),
    [sym_conditional] = STATE(3644),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(3646),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(3644),
    [sym_binary] = STATE(3644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2595),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6091),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(6097),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(6099),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6101),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13479),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [8971] = {
    [sym_heredoc_body] = STATE(8971),
    [aux_sym_call_repeat1] = STATE(8971),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [8972] = {
    [sym_heredoc_body] = STATE(8971),
    [aux_sym_call_repeat1] = STATE(8971),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [8973] = {
    [aux_sym_argument_list_repeat1] = STATE(8973),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15555),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [8974] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8975] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8976] = {
    [aux_sym_exceptions_repeat1] = STATE(10744),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [8977] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8978] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8979] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15558),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [8980] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8981] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8982] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8983] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [8984] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8985] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8986] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [8987] = {
    [sym__line_break] = ACTIONS(1045),
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [sym_self] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(1327),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_then] = ACTIONS(1327),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [anon_sym_next] = ACTIONS(1327),
    [sym_retry] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1327),
  },
  [8988] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10747),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15560),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [8989] = {
    [sym__line_break] = ACTIONS(6721),
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [sym_self] = ACTIONS(6719),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_nil] = ACTIONS(6719),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_then] = ACTIONS(6719),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [anon_sym_next] = ACTIONS(6719),
    [sym_retry] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6721),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_return] = ACTIONS(6719),
  },
  [8990] = {
    [sym__line_break] = ACTIONS(6729),
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [sym_self] = ACTIONS(6727),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_nil] = ACTIONS(6727),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_then] = ACTIONS(6727),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [anon_sym_next] = ACTIONS(6727),
    [sym_retry] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6729),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(6727),
  },
  [8991] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(8990),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10748),
    [sym_operator] = STATE(10748),
    [anon_sym_LT] = ACTIONS(13481),
    [anon_sym_SLASH] = ACTIONS(13483),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13483),
    [anon_sym_PLUS_AT] = ACTIONS(13483),
    [anon_sym_LPAREN2] = ACTIONS(13485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13483),
    [anon_sym_GT_GT] = ACTIONS(13483),
    [anon_sym_EQ_TILDE] = ACTIONS(13483),
    [anon_sym_LT_LT] = ACTIONS(13483),
    [anon_sym_TILDE] = ACTIONS(13483),
    [anon_sym_PLUS] = ACTIONS(13481),
    [anon_sym_AMP] = ACTIONS(13483),
    [anon_sym_GT] = ACTIONS(13481),
    [anon_sym_PERCENT] = ACTIONS(13483),
    [anon_sym_DASH_AT] = ACTIONS(13483),
    [anon_sym_EQ_EQ] = ACTIONS(13481),
    [anon_sym_STAR] = ACTIONS(13481),
    [anon_sym_BANG_TILDE] = ACTIONS(13483),
    [sym_constant] = ACTIONS(15562),
    [anon_sym_DASH] = ACTIONS(13481),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13483),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13481),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13483),
    [anon_sym_STAR_STAR] = ACTIONS(13483),
    [anon_sym_PIPE] = ACTIONS(13483),
    [anon_sym_DOT_DOT] = ACTIONS(13483),
    [anon_sym_LT_EQ_GT] = ACTIONS(13483),
    [anon_sym_LT_EQ] = ACTIONS(13481),
    [anon_sym_BANG] = ACTIONS(13481),
    [sym_identifier] = ACTIONS(15562),
    [anon_sym_CARET] = ACTIONS(13483),
  },
  [8992] = {
    [sym__line_break] = ACTIONS(6735),
    [anon_sym_DOT] = ACTIONS(6735),
    [anon_sym_then] = ACTIONS(6735),
    [anon_sym_AMP_DOT] = ACTIONS(6735),
    [anon_sym_COLON_COLON2] = ACTIONS(6735),
    [sym__heredoc_body_start] = ACTIONS(6735),
    [anon_sym_SEMI] = ACTIONS(6735),
    [anon_sym_LBRACK] = ACTIONS(6735),
    [sym_comment] = ACTIONS(49),
  },
  [8993] = {
    [anon_sym_RBRACK] = ACTIONS(15564),
    [sym_comment] = ACTIONS(49),
  },
  [8994] = {
    [sym__line_break] = ACTIONS(6741),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [sym_self] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_nil] = ACTIONS(6739),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [anon_sym_next] = ACTIONS(6739),
    [sym_retry] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6741),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_return] = ACTIONS(6739),
  },
  [8995] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [8996] = {
    [aux_sym_chained_string_repeat1] = STATE(9042),
    [sym_string] = STATE(9042),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [8997] = {
    [sym__line_break] = ACTIONS(5212),
    [anon_sym_then] = ACTIONS(5212),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_or] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_TILDE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_COLON_COLON2] = ACTIONS(5212),
    [anon_sym_EQ_GT] = ACTIONS(1635),
    [sym__binary_star] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(5210),
    [anon_sym_EQ_EQ] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_and] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BANG_TILDE] = ACTIONS(1635),
    [sym__heredoc_body_start] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_AMP_DOT] = ACTIONS(5212),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_LT_EQ_GT] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [sym__binary_minus] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
  },
  [8998] = {
    [sym_assignment] = STATE(10750),
    [sym_unary] = STATE(10750),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10750),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(10750),
    [sym_conditional] = STATE(10750),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(10750),
    [sym_binary] = STATE(10750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [8999] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [9000] = {
    [sym_assignment] = STATE(10751),
    [sym_unary] = STATE(10751),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10751),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(10751),
    [sym_conditional] = STATE(10751),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(10751),
    [sym_binary] = STATE(10751),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [9001] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(15566),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [9002] = {
    [anon_sym_COLON] = ACTIONS(15568),
    [sym_comment] = ACTIONS(49),
  },
  [9003] = {
    [sym_assignment] = STATE(10754),
    [sym_unary] = STATE(10754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10754),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10754),
    [sym_conditional] = STATE(10754),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10754),
    [sym_binary] = STATE(10754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9004] = {
    [sym_assignment] = STATE(10755),
    [sym_unary] = STATE(10755),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10755),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10755),
    [sym_conditional] = STATE(10755),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10755),
    [sym_binary] = STATE(10755),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9005] = {
    [sym_assignment] = STATE(10756),
    [sym_unary] = STATE(10756),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10756),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10756),
    [sym_conditional] = STATE(10756),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10756),
    [sym_binary] = STATE(10756),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9006] = {
    [sym_heredoc_body] = STATE(10758),
    [aux_sym_call_repeat1] = STATE(10758),
    [aux_sym_argument_list_repeat1] = STATE(10759),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(15570),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [9007] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [9008] = {
    [aux_sym_chained_string_repeat1] = STATE(9042),
    [sym_string] = STATE(9042),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(15572),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [9009] = {
    [sym_heredoc_body] = STATE(10758),
    [aux_sym_call_repeat1] = STATE(10758),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [9010] = {
    [sym__argument] = STATE(10765),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(10765),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10765),
    [sym_hash_splat_argument] = STATE(10765),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(10768),
    [sym_block_argument] = STATE(10765),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_then] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(953),
  },
  [9011] = {
    [sym__argument] = STATE(10765),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(10765),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10765),
    [sym_hash_splat_argument] = STATE(10765),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(10768),
    [sym_block_argument] = STATE(10765),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_then] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(953),
  },
  [9012] = {
    [sym_assignment] = STATE(10769),
    [sym_unary] = STATE(10769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10769),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(10769),
    [sym_conditional] = STATE(10769),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(10769),
    [sym_binary] = STATE(10769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [9013] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [9014] = {
    [sym__argument] = STATE(10765),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(10765),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10765),
    [sym_hash_splat_argument] = STATE(10765),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(10768),
    [sym_block_argument] = STATE(10765),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(953),
  },
  [9015] = {
    [sym_assignment] = STATE(10770),
    [sym_unary] = STATE(10770),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(10770),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(10770),
    [sym_conditional] = STATE(10770),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(10770),
    [sym_binary] = STATE(10770),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [9016] = {
    [sym__argument] = STATE(10765),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(10765),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10765),
    [sym_hash_splat_argument] = STATE(10765),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym__argument_list_with_parens] = STATE(10768),
    [sym_block_argument] = STATE(10765),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(2593),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(10346),
    [sym_self] = ACTIONS(6179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(6095),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_then] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10332),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(13507),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(953),
  },
  [9017] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15582),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(15582),
    [anon_sym_SLASH_EQ] = ACTIONS(15582),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15582),
    [anon_sym_PIPE_EQ] = ACTIONS(15582),
    [anon_sym_LT_LT_EQ] = ACTIONS(15582),
    [anon_sym_PLUS_EQ] = ACTIONS(15582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15582),
    [anon_sym_STAR_EQ] = ACTIONS(15582),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15582),
    [anon_sym_CARET_EQ] = ACTIONS(15582),
    [anon_sym_DASH_EQ] = ACTIONS(15582),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15582),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15584),
  },
  [9018] = {
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_SLASH] = ACTIONS(15588),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(15598),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [anon_sym_and] = ACTIONS(15598),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_PIPE] = ACTIONS(15610),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [9019] = {
    [anon_sym_EQ] = ACTIONS(15614),
    [sym_comment] = ACTIONS(3),
  },
  [9020] = {
    [aux_sym_chained_string_repeat1] = STATE(10783),
    [sym_string] = STATE(10783),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [9021] = {
    [anon_sym_do] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_then] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym_comment] = ACTIONS(49),
  },
  [9022] = {
    [anon_sym_RPAREN] = ACTIONS(15616),
    [sym_comment] = ACTIONS(49),
  },
  [9023] = {
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_SLASH] = ACTIONS(15588),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(15598),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [anon_sym_and] = ACTIONS(15598),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_PIPE] = ACTIONS(15610),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [9024] = {
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_SLASH] = ACTIONS(15588),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(15598),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [anon_sym_and] = ACTIONS(15598),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_PIPE] = ACTIONS(15610),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [9025] = {
    [sym__line_break] = ACTIONS(6991),
    [anon_sym_DOT] = ACTIONS(6991),
    [anon_sym_then] = ACTIONS(6991),
    [anon_sym_AMP_DOT] = ACTIONS(6991),
    [anon_sym_COLON_COLON2] = ACTIONS(6991),
    [sym__heredoc_body_start] = ACTIONS(6991),
    [anon_sym_SEMI] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(6991),
    [sym_comment] = ACTIONS(49),
  },
  [9026] = {
    [sym_assignment] = STATE(10785),
    [sym_unary] = STATE(10785),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10785),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10786),
    [sym_operator_assignment] = STATE(10785),
    [sym_conditional] = STATE(10785),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_subshell] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(10786),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10785),
    [sym_binary] = STATE(10785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6179),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9027] = {
    [aux_sym_heredoc_body_repeat1] = STATE(10788),
    [sym_interpolation] = STATE(10788),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(15618),
    [sym_heredoc_end] = ACTIONS(15620),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(15618),
  },
  [9028] = {
    [sym__argument] = STATE(10789),
    [sym_assignment] = STATE(6445),
    [sym_unary] = STATE(6445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6445),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(10789),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(10789),
    [sym_hash_splat_argument] = STATE(10789),
    [sym_operator_assignment] = STATE(6445),
    [sym_conditional] = STATE(6445),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6446),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_heredoc_body] = STATE(10790),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(10789),
    [sym_range] = STATE(6445),
    [sym_binary] = STATE(6445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(10326),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10322),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(10330),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10336),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10344),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9029] = {
    [sym_heredoc_body] = STATE(10791),
    [aux_sym_call_repeat1] = STATE(10791),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(13531),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [9030] = {
    [sym_heredoc_body] = STATE(10792),
    [aux_sym_call_repeat1] = STATE(10792),
    [aux_sym_argument_list_repeat1] = STATE(10793),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(13531),
    [anon_sym_COMMA] = ACTIONS(13533),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
  },
  [9031] = {
    [sym_assignment] = STATE(10794),
    [sym_unary] = STATE(10794),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10794),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10794),
    [sym_conditional] = STATE(10794),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10794),
    [sym_binary] = STATE(10794),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9032] = {
    [sym_assignment] = STATE(10795),
    [sym_unary] = STATE(10795),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10795),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10795),
    [sym_conditional] = STATE(10795),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10795),
    [sym_binary] = STATE(10795),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9033] = {
    [sym_assignment] = STATE(10796),
    [sym_unary] = STATE(10796),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10796),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10796),
    [sym_conditional] = STATE(10796),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10796),
    [sym_binary] = STATE(10796),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9034] = {
    [sym_assignment] = STATE(10797),
    [sym_unary] = STATE(10797),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10797),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10797),
    [sym_conditional] = STATE(10797),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10797),
    [sym_binary] = STATE(10797),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9035] = {
    [sym_assignment] = STATE(10798),
    [sym_unary] = STATE(10798),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10798),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10798),
    [sym_conditional] = STATE(10798),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10798),
    [sym_binary] = STATE(10798),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9036] = {
    [sym_assignment] = STATE(10799),
    [sym_unary] = STATE(10799),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10799),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10799),
    [sym_conditional] = STATE(10799),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10799),
    [sym_binary] = STATE(10799),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9037] = {
    [sym_assignment] = STATE(10800),
    [sym_unary] = STATE(10800),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10800),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10800),
    [sym_conditional] = STATE(10800),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10800),
    [sym_binary] = STATE(10800),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9038] = {
    [sym_assignment] = STATE(10801),
    [sym_unary] = STATE(10801),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10801),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10801),
    [sym_conditional] = STATE(10801),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10801),
    [sym_binary] = STATE(10801),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9039] = {
    [sym_assignment] = STATE(10802),
    [sym_unary] = STATE(10802),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10802),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10802),
    [sym_conditional] = STATE(10802),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10802),
    [sym_binary] = STATE(10802),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9040] = {
    [sym_assignment] = STATE(10803),
    [sym_unary] = STATE(10803),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10803),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10803),
    [sym_conditional] = STATE(10803),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10803),
    [sym_binary] = STATE(10803),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9041] = {
    [sym_assignment] = STATE(10804),
    [sym_unary] = STATE(10804),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10804),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(10804),
    [sym_conditional] = STATE(10804),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10804),
    [sym_binary] = STATE(10804),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [9042] = {
    [aux_sym_chained_string_repeat1] = STATE(10805),
    [sym_string] = STATE(10805),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [9043] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [9044] = {
    [sym_assignment] = STATE(6451),
    [sym_unary] = STATE(6451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6451),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(6451),
    [sym_conditional] = STATE(6451),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_true] = STATE(1479),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(6451),
    [sym_binary] = STATE(6451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10352),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2595),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [9045] = {
    [aux_sym_exceptions_repeat1] = STATE(10806),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15622),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [9046] = {
    [sym_assignment] = STATE(10807),
    [sym_unary] = STATE(10807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1479),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10807),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(1479),
    [sym_operator_assignment] = STATE(10807),
    [sym_conditional] = STATE(10807),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(1485),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(1479),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(1479),
    [sym_range] = STATE(10807),
    [sym_binary] = STATE(10807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(1479),
    [sym_nil] = STATE(1479),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2613),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2601),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2623),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(2607),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [9047] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5452),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9048] = {
    [anon_sym_RPAREN] = ACTIONS(15624),
    [sym_comment] = ACTIONS(49),
  },
  [9049] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9050] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9051] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9052] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9053] = {
    [aux_sym_exceptions_repeat1] = STATE(10810),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9054] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(3692),
    [sym_unary] = STATE(3692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(3692),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(3692),
    [sym_conditional] = STATE(3692),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(3693),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(3692),
    [sym_binary] = STATE(3692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(6175),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6185),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(6191),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6185),
    [anon_sym_yield] = ACTIONS(6193),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(6195),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6197),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13582),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [9055] = {
    [sym_heredoc_body] = STATE(9055),
    [aux_sym_call_repeat1] = STATE(9055),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9056] = {
    [sym_heredoc_body] = STATE(9055),
    [aux_sym_call_repeat1] = STATE(9055),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9057] = {
    [aux_sym_argument_list_repeat1] = STATE(9057),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15626),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9058] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9059] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9060] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9061] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15629),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9062] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9063] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9064] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9065] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [9066] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9067] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9068] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9069] = {
    [aux_sym_chained_string_repeat1] = STATE(9069),
    [sym_string] = STATE(9069),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9070] = {
    [anon_sym_end] = ACTIONS(15631),
    [anon_sym_ensure] = ACTIONS(15631),
    [anon_sym_else] = ACTIONS(15631),
    [sym_comment] = ACTIONS(49),
  },
  [9071] = {
    [aux_sym_undef_repeat1] = STATE(9071),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_ensure] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [9072] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [9073] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [9074] = {
    [sym_assignment] = STATE(10812),
    [sym_unary] = STATE(10812),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(10812),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(10812),
    [sym_conditional] = STATE(10812),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(10812),
    [sym_binary] = STATE(10812),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [9075] = {
    [sym_assignment] = STATE(10813),
    [sym_unary] = STATE(10813),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(10813),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(10813),
    [sym_conditional] = STATE(10813),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(10813),
    [sym_binary] = STATE(10813),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [9076] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9077] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9078] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9079] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_heredoc_body] = STATE(10814),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym_float] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6231),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6239),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6251),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15633),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [9080] = {
    [sym_heredoc_body] = STATE(10815),
    [aux_sym_call_repeat1] = STATE(10815),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9081] = {
    [sym_heredoc_body] = STATE(10816),
    [aux_sym_call_repeat1] = STATE(10816),
    [aux_sym_argument_list_repeat1] = STATE(10817),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9082] = {
    [sym_heredoc_body] = STATE(10818),
    [aux_sym_call_repeat1] = STATE(10818),
    [aux_sym_argument_list_repeat1] = STATE(10819),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(10452),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9083] = {
    [sym_heredoc_body] = STATE(10818),
    [aux_sym_call_repeat1] = STATE(10818),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_ensure] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9084] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9085] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [9086] = {
    [sym_assignment] = STATE(10820),
    [sym_unary] = STATE(10820),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10820),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10820),
    [sym_conditional] = STATE(10820),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10820),
    [sym_binary] = STATE(10820),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9087] = {
    [sym_assignment] = STATE(10821),
    [sym_unary] = STATE(10821),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10821),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_splat_argument] = STATE(10822),
    [sym_operator_assignment] = STATE(10821),
    [sym_conditional] = STATE(10821),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_return] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_subshell] = STATE(1502),
    [sym__arg_or_splat_arg] = STATE(10822),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10821),
    [sym_binary] = STATE(10821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(2639),
    [sym_character] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9088] = {
    [sym_assignment] = STATE(10823),
    [sym_unary] = STATE(10823),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10823),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10823),
    [sym_conditional] = STATE(10823),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10823),
    [sym_binary] = STATE(10823),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9089] = {
    [sym_assignment] = STATE(10824),
    [sym_unary] = STATE(10824),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10824),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10824),
    [sym_conditional] = STATE(10824),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10824),
    [sym_binary] = STATE(10824),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9090] = {
    [sym_assignment] = STATE(10826),
    [sym_unary] = STATE(10826),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10826),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10826),
    [sym_conditional] = STATE(10826),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10826),
    [sym_binary] = STATE(10826),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9091] = {
    [sym_assignment] = STATE(10827),
    [sym_unary] = STATE(10827),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10827),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10827),
    [sym_conditional] = STATE(10827),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10827),
    [sym_binary] = STATE(10827),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9092] = {
    [sym_assignment] = STATE(10828),
    [sym_unary] = STATE(10828),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10828),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10828),
    [sym_conditional] = STATE(10828),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10828),
    [sym_binary] = STATE(10828),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9093] = {
    [sym_assignment] = STATE(10829),
    [sym_unary] = STATE(10829),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10829),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10829),
    [sym_conditional] = STATE(10829),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10829),
    [sym_binary] = STATE(10829),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9094] = {
    [sym_assignment] = STATE(10830),
    [sym_unary] = STATE(10830),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10830),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10830),
    [sym_conditional] = STATE(10830),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10830),
    [sym_binary] = STATE(10830),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9095] = {
    [sym_assignment] = STATE(10831),
    [sym_unary] = STATE(10831),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10831),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10831),
    [sym_conditional] = STATE(10831),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10831),
    [sym_binary] = STATE(10831),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9096] = {
    [sym_assignment] = STATE(10832),
    [sym_unary] = STATE(10832),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10832),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(10832),
    [sym_conditional] = STATE(10832),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10832),
    [sym_binary] = STATE(10832),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9097] = {
    [aux_sym_chained_string_repeat1] = STATE(10833),
    [sym_string] = STATE(10833),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [9098] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(3720),
    [sym_unary] = STATE(3720),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(3720),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(3720),
    [sym_conditional] = STATE(3720),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(3724),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(3720),
    [sym_binary] = STATE(3720),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym_float] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6231),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6237),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(6245),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6237),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(6249),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6251),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13626),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [9099] = {
    [sym_heredoc_body] = STATE(9099),
    [aux_sym_call_repeat1] = STATE(9099),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9100] = {
    [sym_heredoc_body] = STATE(9099),
    [aux_sym_call_repeat1] = STATE(9099),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9101] = {
    [aux_sym_argument_list_repeat1] = STATE(9101),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15635),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9102] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9103] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9104] = {
    [aux_sym_exceptions_repeat1] = STATE(10835),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9105] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9106] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9107] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15638),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9108] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9109] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9110] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9111] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9112] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9113] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9114] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [9115] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_ensure] = ACTIONS(1327),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9116] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10838),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15640),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9117] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_ensure] = ACTIONS(6719),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9118] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_ensure] = ACTIONS(6727),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9119] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9118),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10839),
    [sym_operator] = STATE(10839),
    [anon_sym_LT] = ACTIONS(13628),
    [anon_sym_SLASH] = ACTIONS(13630),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13630),
    [anon_sym_PLUS_AT] = ACTIONS(13630),
    [anon_sym_LPAREN2] = ACTIONS(13632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13630),
    [anon_sym_GT_GT] = ACTIONS(13630),
    [anon_sym_EQ_TILDE] = ACTIONS(13630),
    [anon_sym_LT_LT] = ACTIONS(13630),
    [anon_sym_TILDE] = ACTIONS(13630),
    [anon_sym_PLUS] = ACTIONS(13628),
    [anon_sym_AMP] = ACTIONS(13630),
    [anon_sym_GT] = ACTIONS(13628),
    [anon_sym_PERCENT] = ACTIONS(13630),
    [anon_sym_DASH_AT] = ACTIONS(13630),
    [anon_sym_EQ_EQ] = ACTIONS(13628),
    [anon_sym_STAR] = ACTIONS(13628),
    [anon_sym_BANG_TILDE] = ACTIONS(13630),
    [sym_constant] = ACTIONS(15642),
    [anon_sym_DASH] = ACTIONS(13628),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13630),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13628),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13630),
    [anon_sym_STAR_STAR] = ACTIONS(13630),
    [anon_sym_PIPE] = ACTIONS(13630),
    [anon_sym_DOT_DOT] = ACTIONS(13630),
    [anon_sym_LT_EQ_GT] = ACTIONS(13630),
    [anon_sym_LT_EQ] = ACTIONS(13628),
    [anon_sym_BANG] = ACTIONS(13628),
    [sym_identifier] = ACTIONS(15642),
    [anon_sym_CARET] = ACTIONS(13630),
  },
  [9120] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9121] = {
    [sym_assignment] = STATE(10840),
    [sym_unary] = STATE(10840),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(10840),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(10840),
    [sym_conditional] = STATE(10840),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(10840),
    [sym_binary] = STATE(10840),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [9122] = {
    [sym_assignment] = STATE(10841),
    [sym_unary] = STATE(10841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(10841),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(10841),
    [sym_conditional] = STATE(10841),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(10841),
    [sym_binary] = STATE(10841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [9123] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_ensure] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9124] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9125] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_ensure] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9126] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_heredoc_body] = STATE(10842),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym_float] = ACTIONS(6287),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6291),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6291),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6299),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_class_variable] = ACTIONS(6299),
    [sym__block_ampersand] = ACTIONS(10494),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6309),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15644),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [9127] = {
    [sym_heredoc_body] = STATE(10843),
    [aux_sym_call_repeat1] = STATE(10843),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9128] = {
    [sym_heredoc_body] = STATE(10844),
    [aux_sym_call_repeat1] = STATE(10844),
    [aux_sym_argument_list_repeat1] = STATE(10845),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13642),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9129] = {
    [aux_sym_chained_string_repeat1] = STATE(9129),
    [sym_string] = STATE(9129),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9130] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_ensure] = ACTIONS(5452),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9131] = {
    [anon_sym_RPAREN] = ACTIONS(15646),
    [sym_comment] = ACTIONS(49),
  },
  [9132] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9133] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_ensure] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [9134] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9135] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [9136] = {
    [sym_assignment] = STATE(10847),
    [sym_unary] = STATE(10847),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10847),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10847),
    [sym_conditional] = STATE(10847),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10847),
    [sym_binary] = STATE(10847),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9137] = {
    [sym_assignment] = STATE(6569),
    [sym_unary] = STATE(6569),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6569),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_splat_argument] = STATE(10848),
    [sym_operator_assignment] = STATE(6569),
    [sym_conditional] = STATE(6569),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_return] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_subshell] = STATE(1502),
    [sym__arg_or_splat_arg] = STATE(10848),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(6569),
    [sym_binary] = STATE(6569),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(10516),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(2639),
    [sym_character] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9138] = {
    [sym_assignment] = STATE(10849),
    [sym_unary] = STATE(10849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10849),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10849),
    [sym_conditional] = STATE(10849),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10849),
    [sym_binary] = STATE(10849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9139] = {
    [sym_assignment] = STATE(10850),
    [sym_unary] = STATE(10850),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10850),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10850),
    [sym_conditional] = STATE(10850),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10850),
    [sym_binary] = STATE(10850),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9140] = {
    [sym_assignment] = STATE(10852),
    [sym_unary] = STATE(10852),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10852),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10852),
    [sym_conditional] = STATE(10852),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10852),
    [sym_binary] = STATE(10852),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9141] = {
    [sym_assignment] = STATE(10853),
    [sym_unary] = STATE(10853),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10853),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10853),
    [sym_conditional] = STATE(10853),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10853),
    [sym_binary] = STATE(10853),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9142] = {
    [sym_assignment] = STATE(10854),
    [sym_unary] = STATE(10854),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10854),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10854),
    [sym_conditional] = STATE(10854),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10854),
    [sym_binary] = STATE(10854),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9143] = {
    [sym_assignment] = STATE(10855),
    [sym_unary] = STATE(10855),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10855),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10855),
    [sym_conditional] = STATE(10855),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10855),
    [sym_binary] = STATE(10855),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9144] = {
    [sym_assignment] = STATE(10856),
    [sym_unary] = STATE(10856),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10856),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10856),
    [sym_conditional] = STATE(10856),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10856),
    [sym_binary] = STATE(10856),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9145] = {
    [sym_assignment] = STATE(10857),
    [sym_unary] = STATE(10857),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10857),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10857),
    [sym_conditional] = STATE(10857),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10857),
    [sym_binary] = STATE(10857),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9146] = {
    [sym_assignment] = STATE(10858),
    [sym_unary] = STATE(10858),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10858),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(10858),
    [sym_conditional] = STATE(10858),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(10858),
    [sym_binary] = STATE(10858),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9147] = {
    [sym_assignment] = STATE(6569),
    [sym_unary] = STATE(6569),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(6569),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(6569),
    [sym_conditional] = STATE(6569),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_return] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_true] = STATE(6568),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(6569),
    [sym_binary] = STATE(6569),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(10516),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(2639),
    [sym_character] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [9148] = {
    [aux_sym_exceptions_repeat1] = STATE(10859),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(13682),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9149] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [9150] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [9151] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [9152] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_ensure] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [9153] = {
    [sym_assignment] = STATE(10860),
    [sym_unary] = STATE(10860),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10860),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10860),
    [sym_conditional] = STATE(10860),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10860),
    [sym_binary] = STATE(10860),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9154] = {
    [sym_assignment] = STATE(10861),
    [sym_unary] = STATE(10861),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10861),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_splat_argument] = STATE(10862),
    [sym_operator_assignment] = STATE(10861),
    [sym_conditional] = STATE(10861),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_return] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_subshell] = STATE(6586),
    [sym__arg_or_splat_arg] = STATE(10862),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10861),
    [sym_binary] = STATE(10861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [sym_global_variable] = ACTIONS(10548),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(10540),
    [sym_character] = ACTIONS(10544),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9155] = {
    [sym_assignment] = STATE(10863),
    [sym_unary] = STATE(10863),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10863),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10863),
    [sym_conditional] = STATE(10863),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10863),
    [sym_binary] = STATE(10863),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9156] = {
    [sym_assignment] = STATE(10864),
    [sym_unary] = STATE(10864),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10864),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10864),
    [sym_conditional] = STATE(10864),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10864),
    [sym_binary] = STATE(10864),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9157] = {
    [sym_assignment] = STATE(10866),
    [sym_unary] = STATE(10866),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10866),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10866),
    [sym_conditional] = STATE(10866),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10866),
    [sym_binary] = STATE(10866),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9158] = {
    [sym_assignment] = STATE(10867),
    [sym_unary] = STATE(10867),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10867),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10867),
    [sym_conditional] = STATE(10867),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10867),
    [sym_binary] = STATE(10867),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9159] = {
    [sym_assignment] = STATE(10868),
    [sym_unary] = STATE(10868),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10868),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10868),
    [sym_conditional] = STATE(10868),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10868),
    [sym_binary] = STATE(10868),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9160] = {
    [sym_assignment] = STATE(10869),
    [sym_unary] = STATE(10869),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10869),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10869),
    [sym_conditional] = STATE(10869),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10869),
    [sym_binary] = STATE(10869),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9161] = {
    [sym_assignment] = STATE(10870),
    [sym_unary] = STATE(10870),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10870),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10870),
    [sym_conditional] = STATE(10870),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10870),
    [sym_binary] = STATE(10870),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9162] = {
    [sym_assignment] = STATE(10871),
    [sym_unary] = STATE(10871),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10871),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10871),
    [sym_conditional] = STATE(10871),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10871),
    [sym_binary] = STATE(10871),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9163] = {
    [sym_assignment] = STATE(10872),
    [sym_unary] = STATE(10872),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10872),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(10872),
    [sym_conditional] = STATE(10872),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10872),
    [sym_binary] = STATE(10872),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [9164] = {
    [aux_sym_chained_string_repeat1] = STATE(10873),
    [sym_string] = STATE(10873),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_ensure] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [9165] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9166] = {
    [aux_sym_exceptions_repeat1] = STATE(10875),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9167] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(3754),
    [sym_unary] = STATE(3754),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(3754),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(3754),
    [sym_conditional] = STATE(3754),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(3755),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(3754),
    [sym_binary] = STATE(3754),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym_float] = ACTIONS(6287),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6291),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6291),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6297),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(6303),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_class_variable] = ACTIONS(6299),
    [sym__block_ampersand] = ACTIONS(6307),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6309),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13718),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [9168] = {
    [sym_heredoc_body] = STATE(9168),
    [aux_sym_call_repeat1] = STATE(9168),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9169] = {
    [sym_heredoc_body] = STATE(9168),
    [aux_sym_call_repeat1] = STATE(9168),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9170] = {
    [aux_sym_argument_list_repeat1] = STATE(9170),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15648),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9171] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9172] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9173] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9174] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15651),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9175] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9176] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9177] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9178] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [9179] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9180] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9181] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9182] = {
    [aux_sym_chained_string_repeat1] = STATE(9182),
    [sym_string] = STATE(9182),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9183] = {
    [sym_assignment] = STATE(10877),
    [sym_unary] = STATE(10877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1506),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10877),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(1506),
    [sym_operator_assignment] = STATE(10877),
    [sym_conditional] = STATE(10877),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(1503),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(1506),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(1508),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(1506),
    [sym_range] = STATE(10877),
    [sym_binary] = STATE(10877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(1506),
    [sym_nil] = STATE(1506),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2655),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2657),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2659),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2661),
    [anon_sym_next] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2667),
  },
  [9184] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [9185] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [9186] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(3783),
    [sym_unary] = STATE(3783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(3783),
    [sym__primary] = STATE(1528),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(3783),
    [sym_conditional] = STATE(3783),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3784),
    [sym_rational] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(3783),
    [sym_binary] = STATE(3783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym_float] = ACTIONS(2671),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2675),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2675),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6365),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2683),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(6367),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6365),
    [anon_sym_yield] = ACTIONS(2691),
    [sym_class_variable] = ACTIONS(2683),
    [sym__block_ampersand] = ACTIONS(6369),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [sym_retry] = ACTIONS(2671),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13722),
    [sym_redo] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [9187] = {
    [sym_heredoc_body] = STATE(9187),
    [aux_sym_call_repeat1] = STATE(9187),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9188] = {
    [sym_heredoc_body] = STATE(9187),
    [aux_sym_call_repeat1] = STATE(9187),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9189] = {
    [aux_sym_argument_list_repeat1] = STATE(9189),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15653),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9190] = {
    [sym_heredoc_body] = STATE(10878),
    [aux_sym_call_repeat1] = STATE(10878),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9191] = {
    [sym_heredoc_body] = STATE(10879),
    [aux_sym_call_repeat1] = STATE(10879),
    [aux_sym_argument_list_repeat1] = STATE(6649),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(6391),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9192] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9193] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9194] = {
    [aux_sym_exceptions_repeat1] = STATE(10881),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9195] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9196] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9197] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9198] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9199] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15656),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9200] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9201] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9202] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9203] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9204] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [9205] = {
    [aux_sym_chained_string_repeat1] = STATE(9205),
    [sym_string] = STATE(9205),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9206] = {
    [sym_assignment] = STATE(6651),
    [sym_unary] = STATE(6651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(6651),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(6651),
    [sym_conditional] = STATE(6651),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_return] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_true] = STATE(1526),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(6651),
    [sym_binary] = STATE(6651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6371),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [sym_global_variable] = ACTIONS(2683),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2675),
    [sym_character] = ACTIONS(2677),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [9207] = {
    [aux_sym_exceptions_repeat1] = STATE(10883),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15658),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9208] = {
    [sym_assignment] = STATE(10884),
    [sym_unary] = STATE(10884),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1526),
    [sym_singleton_class] = STATE(1528),
    [sym_module] = STATE(1528),
    [sym_chained_string] = STATE(1528),
    [sym_until] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_for] = STATE(1528),
    [sym_symbol] = STATE(1528),
    [sym_if] = STATE(1528),
    [sym_begin] = STATE(1528),
    [sym__arg] = STATE(10884),
    [sym__primary] = STATE(1528),
    [sym_method_call] = STATE(1526),
    [sym_operator_assignment] = STATE(10884),
    [sym_conditional] = STATE(10884),
    [sym_method] = STATE(1528),
    [sym_singleton_method] = STATE(1528),
    [sym__variable] = STATE(1529),
    [sym_left_assignment_list] = STATE(1530),
    [sym_rational] = STATE(1528),
    [sym_true] = STATE(1526),
    [sym_return] = STATE(1528),
    [sym_subshell] = STATE(1528),
    [sym_yield] = STATE(1528),
    [sym_string] = STATE(3772),
    [sym_unless] = STATE(1528),
    [sym_lambda] = STATE(1528),
    [sym_parenthesized_statements] = STATE(1528),
    [sym_element_reference] = STATE(1526),
    [sym_range] = STATE(10884),
    [sym_binary] = STATE(10884),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1528),
    [sym_break] = STATE(1528),
    [sym_next] = STATE(1528),
    [sym_string_array] = STATE(1528),
    [sym_while] = STATE(1528),
    [sym_case] = STATE(1528),
    [sym_symbol_array] = STATE(1528),
    [sym_array] = STATE(1528),
    [sym_hash] = STATE(1528),
    [sym_false] = STATE(1526),
    [sym_nil] = STATE(1526),
    [sym_scope_resolution] = STATE(1529),
    [sym_call] = STATE(1529),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2671),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2691),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2695),
    [sym_self] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2699),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(6355),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2683),
    [sym_character] = ACTIONS(2677),
    [sym_super] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2701),
    [anon_sym_next] = ACTIONS(2703),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2671),
    [sym_constant] = ACTIONS(2675),
    [anon_sym_defined_QMARK] = ACTIONS(2685),
    [sym_instance_variable] = ACTIONS(2683),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2675),
    [sym_redo] = ACTIONS(2671),
    [sym_class_variable] = ACTIONS(2683),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2673),
  },
  [9209] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [anon_sym_ensure] = ACTIONS(5452),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9210] = {
    [anon_sym_RPAREN] = ACTIONS(15660),
    [sym_comment] = ACTIONS(49),
  },
  [9211] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [anon_sym_ensure] = ACTIONS(10960),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9212] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [9213] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [9214] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(3821),
    [sym_unary] = STATE(3821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(3821),
    [sym__primary] = STATE(1561),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(3821),
    [sym_conditional] = STATE(3821),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3822),
    [sym_rational] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(3821),
    [sym_binary] = STATE(3821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym_float] = ACTIONS(2745),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(2749),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(2749),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(2757),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [sym__identifier_hash_key] = ACTIONS(6431),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6429),
    [anon_sym_yield] = ACTIONS(2763),
    [sym_class_variable] = ACTIONS(2757),
    [sym__block_ampersand] = ACTIONS(6435),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_break] = ACTIONS(2771),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [sym_retry] = ACTIONS(2745),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13733),
    [sym_redo] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [9215] = {
    [sym_heredoc_body] = STATE(9215),
    [aux_sym_call_repeat1] = STATE(9215),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9216] = {
    [sym_heredoc_body] = STATE(9215),
    [aux_sym_call_repeat1] = STATE(9215),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9217] = {
    [aux_sym_argument_list_repeat1] = STATE(9217),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15662),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9218] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_ensure] = ACTIONS(9736),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [9219] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9220] = {
    [aux_sym_exceptions_repeat1] = STATE(6696),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9221] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9222] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9223] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9224] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9225] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15665),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9226] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9227] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9228] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9229] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9230] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [9231] = {
    [aux_sym_exceptions_repeat1] = STATE(9231),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15667),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [9232] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9233] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9234] = {
    [aux_sym_exceptions_repeat1] = STATE(10888),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9235] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9236] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9237] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9238] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9239] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15670),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9240] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9241] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [9242] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9243] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9244] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9245] = {
    [aux_sym_chained_string_repeat1] = STATE(9245),
    [sym_string] = STATE(9245),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9246] = {
    [sym_assignment] = STATE(6714),
    [sym_unary] = STATE(6714),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(6714),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(6714),
    [sym_conditional] = STATE(6714),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_return] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_true] = STATE(1565),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(6714),
    [sym_binary] = STATE(6714),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6433),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [sym_global_variable] = ACTIONS(2757),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2749),
    [sym_character] = ACTIONS(2751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [9247] = {
    [aux_sym_exceptions_repeat1] = STATE(10890),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15672),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [9248] = {
    [sym_assignment] = STATE(10891),
    [sym_unary] = STATE(10891),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1565),
    [sym_singleton_class] = STATE(1561),
    [sym_module] = STATE(1561),
    [sym_chained_string] = STATE(1561),
    [sym_until] = STATE(1561),
    [sym_regex] = STATE(1561),
    [sym_for] = STATE(1561),
    [sym_symbol] = STATE(1561),
    [sym_if] = STATE(1561),
    [sym_begin] = STATE(1561),
    [sym__arg] = STATE(10891),
    [sym__primary] = STATE(1561),
    [sym_method_call] = STATE(1565),
    [sym_operator_assignment] = STATE(10891),
    [sym_conditional] = STATE(10891),
    [sym_method] = STATE(1561),
    [sym_singleton_method] = STATE(1561),
    [sym__variable] = STATE(1563),
    [sym_left_assignment_list] = STATE(1562),
    [sym_rational] = STATE(1561),
    [sym_true] = STATE(1565),
    [sym_return] = STATE(1561),
    [sym_subshell] = STATE(1561),
    [sym_yield] = STATE(1561),
    [sym_string] = STATE(3847),
    [sym_unless] = STATE(1561),
    [sym_lambda] = STATE(1561),
    [sym_parenthesized_statements] = STATE(1561),
    [sym_element_reference] = STATE(1565),
    [sym_range] = STATE(10891),
    [sym_binary] = STATE(10891),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1561),
    [sym_break] = STATE(1561),
    [sym_next] = STATE(1561),
    [sym_string_array] = STATE(1561),
    [sym_while] = STATE(1561),
    [sym_case] = STATE(1561),
    [sym_symbol_array] = STATE(1561),
    [sym_array] = STATE(1561),
    [sym_hash] = STATE(1561),
    [sym_false] = STATE(1565),
    [sym_nil] = STATE(1565),
    [sym_scope_resolution] = STATE(1563),
    [sym_call] = STATE(1563),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(2745),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2763),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_not] = ACTIONS(2767),
    [sym_self] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(6475),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2757),
    [sym_character] = ACTIONS(2751),
    [sym_super] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(2773),
    [anon_sym_next] = ACTIONS(2775),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(2745),
    [sym_constant] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2759),
    [sym_instance_variable] = ACTIONS(2757),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(6357),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(2749),
    [sym_redo] = ACTIONS(2745),
    [sym_class_variable] = ACTIONS(2757),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(2747),
  },
  [9249] = {
    [anon_sym_LT] = ACTIONS(2783),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(2789),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [sym__binary_star] = ACTIONS(2785),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(2801),
    [anon_sym_BANG_TILDE] = ACTIONS(2789),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ_GT] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(2809),
    [sym__binary_minus] = ACTIONS(2797),
  },
  [9250] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [sym__line_break] = ACTIONS(15676),
    [anon_sym_then] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_when] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym___END__] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_end] = ACTIONS(15676),
    [anon_sym_ensure] = ACTIONS(15676),
    [anon_sym_else] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_elsif] = ACTIONS(15676),
    [ts_builtin_sym_end] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
    [sym__binary_minus] = ACTIONS(15676),
  },
  [9251] = {
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [sym_self] = ACTIONS(9736),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_nil] = ACTIONS(9736),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [anon_sym_next] = ACTIONS(9736),
    [sym_retry] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9736),
  },
  [9252] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [9253] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [9254] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(3912),
    [sym_unary] = STATE(3912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(3912),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(3912),
    [sym_conditional] = STATE(3912),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3913),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(3912),
    [sym_binary] = STATE(3912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(6562),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(6564),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(6562),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(6566),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(13750),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [9255] = {
    [sym_heredoc_body] = STATE(9255),
    [aux_sym_call_repeat1] = STATE(9255),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [9256] = {
    [sym_heredoc_body] = STATE(9255),
    [aux_sym_call_repeat1] = STATE(9255),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [9257] = {
    [aux_sym_argument_list_repeat1] = STATE(9257),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15678),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [9258] = {
    [sym_assignment] = STATE(10892),
    [sym_unary] = STATE(10892),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10892),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(10892),
    [sym_conditional] = STATE(10892),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(10892),
    [sym_binary] = STATE(10892),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [9259] = {
    [sym_assignment] = STATE(10893),
    [sym_unary] = STATE(10893),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(10893),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(10893),
    [sym_conditional] = STATE(10893),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(10893),
    [sym_binary] = STATE(10893),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [9260] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9261] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9262] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9263] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_heredoc_body] = STATE(10894),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(10757),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15681),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [9264] = {
    [sym_heredoc_body] = STATE(10895),
    [aux_sym_call_repeat1] = STATE(10895),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [9265] = {
    [sym_heredoc_body] = STATE(10896),
    [aux_sym_call_repeat1] = STATE(10896),
    [aux_sym_argument_list_repeat1] = STATE(10897),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13756),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [9266] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9267] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9268] = {
    [aux_sym_exceptions_repeat1] = STATE(10899),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [9269] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9270] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9271] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9272] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9273] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15683),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9274] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9275] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [9276] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9277] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9278] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9279] = {
    [aux_sym_chained_string_repeat1] = STATE(9279),
    [sym_string] = STATE(9279),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [9280] = {
    [sym_assignment] = STATE(6771),
    [sym_unary] = STATE(6771),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6771),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(6771),
    [sym_conditional] = STATE(6771),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(6771),
    [sym_binary] = STATE(6771),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(6568),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1809),
    [sym_character] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [9281] = {
    [aux_sym_exceptions_repeat1] = STATE(10901),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15685),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [9282] = {
    [sym_assignment] = STATE(10902),
    [sym_unary] = STATE(10902),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(10902),
    [sym__primary] = STATE(917),
    [sym_method_call] = STATE(1601),
    [sym_operator_assignment] = STATE(10902),
    [sym_conditional] = STATE(10902),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_rational] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_return] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(3902),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_range] = STATE(10902),
    [sym_binary] = STATE(10902),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(1667),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_not] = ACTIONS(2833),
    [sym_self] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2839),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1819),
    [sym_character] = ACTIONS(1673),
    [sym_super] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(1667),
    [sym_constant] = ACTIONS(1809),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym_instance_variable] = ACTIONS(1819),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(1809),
    [sym_redo] = ACTIONS(1667),
    [sym_class_variable] = ACTIONS(1819),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [9283] = {
    [aux_sym_undef_repeat1] = STATE(10903),
    [sym__line_break] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_elsif] = ACTIONS(3500),
  },
  [9284] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9285] = {
    [aux_sym_chained_string_repeat1] = STATE(9337),
    [sym_string] = STATE(9337),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [9286] = {
    [sym_assignment] = STATE(10904),
    [sym_unary] = STATE(10904),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10904),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(10904),
    [sym_conditional] = STATE(10904),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(10904),
    [sym_binary] = STATE(10904),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9287] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [9288] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_rescue] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_CARET] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_elsif] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [9289] = {
    [sym_assignment] = STATE(10905),
    [sym_unary] = STATE(10905),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10905),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(10905),
    [sym_conditional] = STATE(10905),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(10905),
    [sym_binary] = STATE(10905),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9290] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(15687),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_elsif] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [9291] = {
    [anon_sym_COLON] = ACTIONS(15689),
    [sym_comment] = ACTIONS(49),
  },
  [9292] = {
    [sym_assignment] = STATE(10908),
    [sym_unary] = STATE(10908),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10908),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10908),
    [sym_conditional] = STATE(10908),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10908),
    [sym_binary] = STATE(10908),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9293] = {
    [sym_assignment] = STATE(10909),
    [sym_unary] = STATE(10909),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10909),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10909),
    [sym_conditional] = STATE(10909),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10909),
    [sym_binary] = STATE(10909),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9294] = {
    [sym_assignment] = STATE(10910),
    [sym_unary] = STATE(10910),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10910),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10910),
    [sym_conditional] = STATE(10910),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10910),
    [sym_binary] = STATE(10910),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9295] = {
    [sym_heredoc_body] = STATE(10912),
    [aux_sym_call_repeat1] = STATE(10912),
    [aux_sym_argument_list_repeat1] = STATE(10913),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(15691),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9296] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [9297] = {
    [aux_sym_chained_string_repeat1] = STATE(9337),
    [sym_string] = STATE(9337),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(15693),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_elsif] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [9298] = {
    [sym_heredoc_body] = STATE(10912),
    [aux_sym_call_repeat1] = STATE(10912),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9299] = {
    [sym__argument] = STATE(10914),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(10914),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(10914),
    [sym_hash_splat_argument] = STATE(10914),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(10915),
    [sym_block_argument] = STATE(10914),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_elsif] = ACTIONS(753),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [9300] = {
    [sym__argument] = STATE(10914),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(10914),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(10914),
    [sym_hash_splat_argument] = STATE(10914),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(10915),
    [sym_block_argument] = STATE(10914),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_elsif] = ACTIONS(647),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [9301] = {
    [sym_assignment] = STATE(10916),
    [sym_unary] = STATE(10916),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10916),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(10916),
    [sym_conditional] = STATE(10916),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(10916),
    [sym_binary] = STATE(10916),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9302] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9303] = {
    [sym__argument] = STATE(10914),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(10914),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(10914),
    [sym_hash_splat_argument] = STATE(10914),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(10915),
    [sym_block_argument] = STATE(10914),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [9304] = {
    [sym_assignment] = STATE(10917),
    [sym_unary] = STATE(10917),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10917),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(10917),
    [sym_conditional] = STATE(10917),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(10917),
    [sym_binary] = STATE(10917),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9305] = {
    [sym__argument] = STATE(10914),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(10914),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(10914),
    [sym_hash_splat_argument] = STATE(10914),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym__argument_list_with_parens] = STATE(10915),
    [sym_block_argument] = STATE(10914),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(10799),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(10801),
    [sym_self] = ACTIONS(10803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(10823),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_elsif] = ACTIONS(501),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(10833),
  },
  [9306] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15695),
    [anon_sym_GT_GT_EQ] = ACTIONS(15695),
    [anon_sym_SLASH_EQ] = ACTIONS(15695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15695),
    [anon_sym_LT_LT_EQ] = ACTIONS(15695),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15695),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(15695),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15697),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(15695),
    [anon_sym_PLUS_EQ] = ACTIONS(15695),
    [anon_sym_STAR_EQ] = ACTIONS(15695),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15695),
    [anon_sym_DASH_EQ] = ACTIONS(15695),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15695),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9307] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_elsif] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [9308] = {
    [anon_sym_EQ] = ACTIONS(15725),
    [sym_comment] = ACTIONS(3),
  },
  [9309] = {
    [aux_sym_chained_string_repeat1] = STATE(10929),
    [sym_string] = STATE(10929),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [9310] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_elsif] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [9311] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_elsif] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [9312] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_heredoc_body] = STATE(10930),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym_float] = ACTIONS(10799),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(10803),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(10811),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10823),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15727),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9313] = {
    [sym_heredoc_body] = STATE(10931),
    [aux_sym_call_repeat1] = STATE(10931),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9314] = {
    [sym_heredoc_body] = STATE(10932),
    [aux_sym_call_repeat1] = STATE(10932),
    [aux_sym_argument_list_repeat1] = STATE(10933),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13801),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9315] = {
    [sym_assignment] = STATE(10934),
    [sym_unary] = STATE(10934),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10934),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10934),
    [sym_conditional] = STATE(10934),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10934),
    [sym_binary] = STATE(10934),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9316] = {
    [sym_assignment] = STATE(10935),
    [sym_unary] = STATE(10935),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10935),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(10936),
    [sym_operator_assignment] = STATE(10935),
    [sym_conditional] = STATE(10935),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_subshell] = STATE(6809),
    [sym__arg_or_splat_arg] = STATE(10936),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10935),
    [sym_binary] = STATE(10935),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(10803),
    [sym_character] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9317] = {
    [sym_assignment] = STATE(10937),
    [sym_unary] = STATE(10937),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10937),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10937),
    [sym_conditional] = STATE(10937),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10937),
    [sym_binary] = STATE(10937),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9318] = {
    [sym_assignment] = STATE(10938),
    [sym_unary] = STATE(10938),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10938),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10938),
    [sym_conditional] = STATE(10938),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10938),
    [sym_binary] = STATE(10938),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9319] = {
    [sym_assignment] = STATE(10939),
    [sym_unary] = STATE(10939),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(10939),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(10939),
    [sym_conditional] = STATE(10939),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(10939),
    [sym_binary] = STATE(10939),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9320] = {
    [sym_assignment] = STATE(10940),
    [sym_unary] = STATE(10940),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10940),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10940),
    [sym_conditional] = STATE(10940),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10940),
    [sym_binary] = STATE(10940),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9321] = {
    [sym_assignment] = STATE(10941),
    [sym_unary] = STATE(10941),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10941),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10941),
    [sym_conditional] = STATE(10941),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10941),
    [sym_binary] = STATE(10941),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9322] = {
    [sym_assignment] = STATE(10942),
    [sym_unary] = STATE(10942),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10942),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10942),
    [sym_conditional] = STATE(10942),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10942),
    [sym_binary] = STATE(10942),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9323] = {
    [sym_assignment] = STATE(10944),
    [sym_unary] = STATE(10944),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10944),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10944),
    [sym_conditional] = STATE(10944),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10944),
    [sym_binary] = STATE(10944),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9324] = {
    [sym_assignment] = STATE(10945),
    [sym_unary] = STATE(10945),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10945),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10945),
    [sym_conditional] = STATE(10945),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10945),
    [sym_binary] = STATE(10945),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9325] = {
    [sym_assignment] = STATE(10946),
    [sym_unary] = STATE(10946),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10946),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(10946),
    [sym_conditional] = STATE(10946),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10946),
    [sym_binary] = STATE(10946),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [9326] = {
    [sym_heredoc_body] = STATE(10951),
    [sym__argument_list_with_parens] = STATE(10950),
    [aux_sym_call_repeat1] = STATE(10951),
    [sym_argument_list_with_parens] = STATE(10949),
    [sym_operator] = STATE(10949),
    [anon_sym_LT] = ACTIONS(15729),
    [anon_sym_SLASH] = ACTIONS(15731),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(15731),
    [anon_sym_PLUS_AT] = ACTIONS(15731),
    [anon_sym_LPAREN2] = ACTIONS(15733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15731),
    [anon_sym_GT_GT] = ACTIONS(15731),
    [anon_sym_EQ_TILDE] = ACTIONS(15731),
    [anon_sym_LT_LT] = ACTIONS(15731),
    [anon_sym_TILDE] = ACTIONS(15731),
    [anon_sym_PLUS] = ACTIONS(15729),
    [anon_sym_AMP] = ACTIONS(15731),
    [anon_sym_GT] = ACTIONS(15729),
    [anon_sym_PERCENT] = ACTIONS(15731),
    [anon_sym_DASH_AT] = ACTIONS(15731),
    [anon_sym_EQ_EQ] = ACTIONS(15729),
    [anon_sym_STAR] = ACTIONS(15729),
    [anon_sym_BANG_TILDE] = ACTIONS(15731),
    [sym_constant] = ACTIONS(15735),
    [anon_sym_DASH] = ACTIONS(15729),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(15731),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(15729),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(15731),
    [anon_sym_STAR_STAR] = ACTIONS(15731),
    [anon_sym_PIPE] = ACTIONS(15731),
    [anon_sym_DOT_DOT] = ACTIONS(15731),
    [anon_sym_LT_EQ_GT] = ACTIONS(15731),
    [anon_sym_LT_EQ] = ACTIONS(15729),
    [anon_sym_BANG] = ACTIONS(15729),
    [sym_identifier] = ACTIONS(15735),
    [anon_sym_CARET] = ACTIONS(15731),
  },
  [9327] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(15737),
    [sym_identifier] = ACTIONS(15737),
  },
  [9328] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(15739),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_elsif] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [9329] = {
    [anon_sym_COLON] = ACTIONS(15741),
    [sym_comment] = ACTIONS(49),
  },
  [9330] = {
    [sym_assignment] = STATE(10955),
    [sym_unary] = STATE(10955),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(10955),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(10955),
    [sym_conditional] = STATE(10955),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(10955),
    [sym_binary] = STATE(10955),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9331] = {
    [sym_assignment] = STATE(10956),
    [sym_unary] = STATE(10956),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(10956),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(10956),
    [sym_conditional] = STATE(10956),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(10956),
    [sym_binary] = STATE(10956),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9332] = {
    [sym_assignment] = STATE(10957),
    [sym_unary] = STATE(10957),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(10957),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(10957),
    [sym_conditional] = STATE(10957),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(10957),
    [sym_binary] = STATE(10957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9333] = {
    [sym_heredoc_body] = STATE(10959),
    [aux_sym_call_repeat1] = STATE(10959),
    [aux_sym_argument_list_repeat1] = STATE(10960),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(15743),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [9334] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_elsif] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [9335] = {
    [aux_sym_chained_string_repeat1] = STATE(9393),
    [sym_string] = STATE(9393),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(15745),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9336] = {
    [sym_heredoc_body] = STATE(10959),
    [aux_sym_call_repeat1] = STATE(10959),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [9337] = {
    [aux_sym_chained_string_repeat1] = STATE(10961),
    [sym_string] = STATE(10961),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_elsif] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [9338] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6698),
    [anon_sym_else] = ACTIONS(6698),
    [anon_sym_elsif] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [9339] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6700),
    [anon_sym_else] = ACTIONS(6700),
    [anon_sym_elsif] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [9340] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6702),
    [anon_sym_else] = ACTIONS(6702),
    [anon_sym_elsif] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [9341] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_elsif] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [9342] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(15747),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [9343] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6706),
    [anon_sym_else] = ACTIONS(6706),
    [anon_sym_elsif] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [9344] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(10907),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(10907),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6708),
    [anon_sym_else] = ACTIONS(6708),
    [anon_sym_elsif] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_PIPE] = ACTIONS(10919),
    [sym__binary_minus] = ACTIONS(10909),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(10921),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
  },
  [9345] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_elsif] = ACTIONS(1327),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9346] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(10964),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15749),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9347] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_elsif] = ACTIONS(6719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9348] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_elsif] = ACTIONS(6727),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9349] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9348),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(10965),
    [sym_operator] = STATE(10965),
    [anon_sym_LT] = ACTIONS(13855),
    [anon_sym_SLASH] = ACTIONS(13857),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(13857),
    [anon_sym_PLUS_AT] = ACTIONS(13857),
    [anon_sym_LPAREN2] = ACTIONS(13859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13857),
    [anon_sym_GT_GT] = ACTIONS(13857),
    [anon_sym_EQ_TILDE] = ACTIONS(13857),
    [anon_sym_LT_LT] = ACTIONS(13857),
    [anon_sym_TILDE] = ACTIONS(13857),
    [anon_sym_PLUS] = ACTIONS(13855),
    [anon_sym_AMP] = ACTIONS(13857),
    [anon_sym_GT] = ACTIONS(13855),
    [anon_sym_PERCENT] = ACTIONS(13857),
    [anon_sym_DASH_AT] = ACTIONS(13857),
    [anon_sym_EQ_EQ] = ACTIONS(13855),
    [anon_sym_STAR] = ACTIONS(13855),
    [anon_sym_BANG_TILDE] = ACTIONS(13857),
    [sym_constant] = ACTIONS(15751),
    [anon_sym_DASH] = ACTIONS(13855),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(13857),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(13855),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(13857),
    [anon_sym_STAR_STAR] = ACTIONS(13857),
    [anon_sym_PIPE] = ACTIONS(13857),
    [anon_sym_DOT_DOT] = ACTIONS(13857),
    [anon_sym_LT_EQ_GT] = ACTIONS(13857),
    [anon_sym_LT_EQ] = ACTIONS(13855),
    [anon_sym_BANG] = ACTIONS(13855),
    [sym_identifier] = ACTIONS(15751),
    [anon_sym_CARET] = ACTIONS(13857),
  },
  [9350] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_elsif] = ACTIONS(6739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9351] = {
    [sym_assignment] = STATE(10966),
    [sym_unary] = STATE(10966),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10966),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(10966),
    [sym_conditional] = STATE(10966),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(10966),
    [sym_binary] = STATE(10966),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9352] = {
    [sym_assignment] = STATE(10967),
    [sym_unary] = STATE(10967),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10967),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(10967),
    [sym_conditional] = STATE(10967),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(10967),
    [sym_binary] = STATE(10967),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9353] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9354] = {
    [sym_assignment] = STATE(10968),
    [sym_unary] = STATE(10968),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(10968),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(10968),
    [sym_conditional] = STATE(10968),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(10968),
    [sym_binary] = STATE(10968),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [9355] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15753),
    [anon_sym_GT_GT_EQ] = ACTIONS(15753),
    [anon_sym_SLASH_EQ] = ACTIONS(15753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15753),
    [anon_sym_LT_LT_EQ] = ACTIONS(15753),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15753),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(15753),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15755),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(15753),
    [anon_sym_PLUS_EQ] = ACTIONS(15753),
    [anon_sym_STAR_EQ] = ACTIONS(15753),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15753),
    [anon_sym_DASH_EQ] = ACTIONS(15753),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15753),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9356] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_elsif] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [9357] = {
    [anon_sym_EQ] = ACTIONS(15783),
    [sym_comment] = ACTIONS(3),
  },
  [9358] = {
    [aux_sym_exceptions_repeat1] = STATE(10981),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(15785),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9359] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [9360] = {
    [aux_sym_chained_string_repeat1] = STATE(9393),
    [sym_string] = STATE(9393),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9361] = {
    [sym_assignment] = STATE(10982),
    [sym_unary] = STATE(10982),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(10982),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(10982),
    [sym_conditional] = STATE(10982),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(10982),
    [sym_binary] = STATE(10982),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [9362] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [9363] = {
    [sym_assignment] = STATE(10983),
    [sym_unary] = STATE(10983),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(10983),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(10983),
    [sym_conditional] = STATE(10983),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(10983),
    [sym_binary] = STATE(10983),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [9364] = {
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_elsif] = ACTIONS(753),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [9365] = {
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_elsif] = ACTIONS(647),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [9366] = {
    [sym_assignment] = STATE(10984),
    [sym_unary] = STATE(10984),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(10984),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(10984),
    [sym_conditional] = STATE(10984),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(10984),
    [sym_binary] = STATE(10984),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [9367] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [9368] = {
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [9369] = {
    [sym_assignment] = STATE(10985),
    [sym_unary] = STATE(10985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(10985),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(10985),
    [sym_conditional] = STATE(10985),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(10985),
    [sym_binary] = STATE(10985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [9370] = {
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_elsif] = ACTIONS(501),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [9371] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(15787),
    [anon_sym_GT_GT_EQ] = ACTIONS(15787),
    [anon_sym_SLASH_EQ] = ACTIONS(15787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(15787),
    [anon_sym_LT_LT_EQ] = ACTIONS(15787),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15787),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(15787),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(15789),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(15787),
    [anon_sym_PLUS_EQ] = ACTIONS(15787),
    [anon_sym_STAR_EQ] = ACTIONS(15787),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15787),
    [anon_sym_DASH_EQ] = ACTIONS(15787),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15787),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9372] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_elsif] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [9373] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(10849),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(10851),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(10853),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_elsif] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [9374] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym__primary] = STATE(6836),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(6839),
    [sym_method] = STATE(6836),
    [sym_conditional] = STATE(6841),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_subshell] = STATE(6836),
    [sym_unless] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_block_argument] = STATE(6839),
    [sym_range] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(6840),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_call] = STATE(6838),
    [sym__argument] = STATE(6839),
    [sym_assignment] = STATE(6841),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_pair] = STATE(6839),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6839),
    [sym_operator_assignment] = STATE(6841),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_rational] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_lambda] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym__argument_list_with_parens] = STATE(6843),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(6841),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_nil] = STATE(6840),
    [sym_symbol_array] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_scope_resolution] = STATE(6838),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(10857),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(10859),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(10861),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(10861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(10869),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(10877),
    [anon_sym_not] = ACTIONS(10879),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_elsif] = ACTIONS(791),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(10889),
  },
  [9375] = {
    [anon_sym_EQ] = ACTIONS(15819),
    [sym_comment] = ACTIONS(3),
  },
  [9376] = {
    [aux_sym_chained_string_repeat1] = STATE(10997),
    [sym_string] = STATE(10997),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_elsif] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [9377] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_elsif] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [9378] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_elsif] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [9379] = {
    [sym_assignment] = STATE(10998),
    [sym_unary] = STATE(10998),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(10998),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(10999),
    [sym_operator_assignment] = STATE(10998),
    [sym_conditional] = STATE(10998),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_subshell] = STATE(6836),
    [sym__arg_or_splat_arg] = STATE(10999),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(10998),
    [sym_binary] = STATE(10998),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(10861),
    [sym_character] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9380] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_heredoc_body] = STATE(11000),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(10861),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(10861),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(10869),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [sym__block_ampersand] = ACTIONS(10877),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(10879),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15821),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9381] = {
    [sym_heredoc_body] = STATE(11001),
    [aux_sym_call_repeat1] = STATE(11001),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9382] = {
    [sym_heredoc_body] = STATE(11002),
    [aux_sym_call_repeat1] = STATE(11002),
    [aux_sym_argument_list_repeat1] = STATE(11003),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13911),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9383] = {
    [sym_assignment] = STATE(11004),
    [sym_unary] = STATE(11004),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11004),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11004),
    [sym_conditional] = STATE(11004),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11004),
    [sym_binary] = STATE(11004),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9384] = {
    [sym_assignment] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9385] = {
    [sym_assignment] = STATE(11006),
    [sym_unary] = STATE(11006),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11006),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11006),
    [sym_conditional] = STATE(11006),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11006),
    [sym_binary] = STATE(11006),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9386] = {
    [sym_assignment] = STATE(11007),
    [sym_unary] = STATE(11007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11007),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11007),
    [sym_conditional] = STATE(11007),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11007),
    [sym_binary] = STATE(11007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9387] = {
    [sym_assignment] = STATE(11008),
    [sym_unary] = STATE(11008),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11008),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11008),
    [sym_conditional] = STATE(11008),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11008),
    [sym_binary] = STATE(11008),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9388] = {
    [sym_assignment] = STATE(11009),
    [sym_unary] = STATE(11009),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11009),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11009),
    [sym_conditional] = STATE(11009),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11009),
    [sym_binary] = STATE(11009),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9389] = {
    [sym_assignment] = STATE(11010),
    [sym_unary] = STATE(11010),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11010),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11010),
    [sym_conditional] = STATE(11010),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11010),
    [sym_binary] = STATE(11010),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9390] = {
    [sym_assignment] = STATE(11012),
    [sym_unary] = STATE(11012),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11012),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11012),
    [sym_conditional] = STATE(11012),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11012),
    [sym_binary] = STATE(11012),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9391] = {
    [sym_assignment] = STATE(11013),
    [sym_unary] = STATE(11013),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11013),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11013),
    [sym_conditional] = STATE(11013),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11013),
    [sym_binary] = STATE(11013),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9392] = {
    [sym_assignment] = STATE(11014),
    [sym_unary] = STATE(11014),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11014),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11014),
    [sym_conditional] = STATE(11014),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11014),
    [sym_binary] = STATE(11014),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [9393] = {
    [aux_sym_chained_string_repeat1] = STATE(11015),
    [sym_string] = STATE(11015),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_elsif] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [9394] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9395] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9396] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9397] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9398] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9399] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15823),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9400] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9401] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9402] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9403] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9404] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [9405] = {
    [aux_sym_chained_string_repeat1] = STATE(9405),
    [sym_string] = STATE(9405),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_elsif] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9406] = {
    [sym_heredoc_body] = STATE(6820),
    [sym__terminator] = STATE(6820),
    [sym__line_break] = ACTIONS(10835),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(10843),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [9407] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(11017),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(11017),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15825),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [9408] = {
    [sym_elsif] = STATE(11017),
    [sym_else] = STATE(11017),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(15827),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [9409] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [sym__line_break] = ACTIONS(15831),
    [anon_sym_then] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_when] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym___END__] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_end] = ACTIONS(15831),
    [anon_sym_ensure] = ACTIONS(15831),
    [anon_sym_else] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_elsif] = ACTIONS(15831),
    [ts_builtin_sym_end] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
    [sym__binary_minus] = ACTIONS(15831),
  },
  [9410] = {
    [sym_assignment] = STATE(11018),
    [sym_unary] = STATE(11018),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1642),
    [sym_singleton_class] = STATE(44),
    [sym_module] = STATE(44),
    [sym_chained_string] = STATE(44),
    [sym_until] = STATE(44),
    [sym_regex] = STATE(44),
    [sym_for] = STATE(44),
    [sym_symbol] = STATE(44),
    [sym_if] = STATE(44),
    [sym_begin] = STATE(44),
    [sym__arg] = STATE(11018),
    [sym__primary] = STATE(44),
    [sym_method_call] = STATE(1642),
    [sym_operator_assignment] = STATE(11018),
    [sym_conditional] = STATE(11018),
    [sym_method] = STATE(44),
    [sym_singleton_method] = STATE(44),
    [sym__variable] = STATE(47),
    [sym_left_assignment_list] = STATE(1644),
    [sym_rational] = STATE(44),
    [sym_true] = STATE(1642),
    [sym_return] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_yield] = STATE(44),
    [sym_string] = STATE(1226),
    [sym_unless] = STATE(44),
    [sym_lambda] = STATE(44),
    [sym_parenthesized_statements] = STATE(44),
    [sym_element_reference] = STATE(1642),
    [sym_range] = STATE(11018),
    [sym_binary] = STATE(11018),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(44),
    [sym_break] = STATE(44),
    [sym_next] = STATE(44),
    [sym_string_array] = STATE(44),
    [sym_while] = STATE(44),
    [sym_case] = STATE(44),
    [sym_symbol_array] = STATE(44),
    [sym_array] = STATE(44),
    [sym_hash] = STATE(44),
    [sym_false] = STATE(1642),
    [sym_nil] = STATE(1642),
    [sym_scope_resolution] = STATE(47),
    [sym_call] = STATE(47),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_not] = ACTIONS(2915),
    [sym_self] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(15),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(15),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(39),
    [sym_character] = ACTIONS(15),
    [sym_super] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(2921),
    [anon_sym_next] = ACTIONS(2161),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5),
    [sym_constant] = ACTIONS(11),
    [anon_sym_defined_QMARK] = ACTIONS(2923),
    [sym_instance_variable] = ACTIONS(39),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(11),
    [sym_redo] = ACTIONS(5),
    [sym_class_variable] = ACTIONS(39),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2165),
  },
  [9411] = {
    [anon_sym_SLASH] = ACTIONS(11543),
    [sym__line_break] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_AMP_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT_EQ] = ACTIONS(11545),
    [anon_sym_SLASH_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11543),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11543),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11543),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_PERCENT_EQ] = ACTIONS(11545),
    [anon_sym_LT_LT_EQ] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_else] = ACTIONS(11545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_CARET_EQ] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_EQ] = ACTIONS(11543),
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_then] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11543),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_EQ_GT] = ACTIONS(11545),
    [anon_sym_when] = ACTIONS(11545),
    [anon_sym_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_PLUS_EQ] = ACTIONS(11545),
    [anon_sym_STAR_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym___END__] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_end] = ACTIONS(11545),
    [anon_sym_ensure] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_elsif] = ACTIONS(11545),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11545),
    [ts_builtin_sym_end] = ACTIONS(11545),
    [anon_sym_DASH_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11543),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11543),
  },
  [9412] = {
    [anon_sym_SLASH] = ACTIONS(11866),
    [sym__line_break] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_AMP_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT_EQ] = ACTIONS(11868),
    [anon_sym_SLASH_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11866),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11866),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11866),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_PERCENT_EQ] = ACTIONS(11868),
    [anon_sym_LT_LT_EQ] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_else] = ACTIONS(11868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_CARET_EQ] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_then] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_EQ_GT] = ACTIONS(11868),
    [anon_sym_when] = ACTIONS(11868),
    [anon_sym_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_PLUS_EQ] = ACTIONS(11868),
    [anon_sym_STAR_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym___END__] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11866),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_end] = ACTIONS(11868),
    [anon_sym_ensure] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_elsif] = ACTIONS(11868),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11868),
    [ts_builtin_sym_end] = ACTIONS(11868),
    [anon_sym_DASH_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11866),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_AMP_AMP] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11866),
  },
  [9413] = {
    [anon_sym_SLASH] = ACTIONS(11877),
    [sym__line_break] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_AMP_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT_EQ] = ACTIONS(11879),
    [anon_sym_SLASH_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11877),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11877),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11877),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_PERCENT_EQ] = ACTIONS(11879),
    [anon_sym_LT_LT_EQ] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_else] = ACTIONS(11879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_CARET_EQ] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_EQ] = ACTIONS(11877),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_then] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11877),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_EQ_GT] = ACTIONS(11879),
    [anon_sym_when] = ACTIONS(11879),
    [anon_sym_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_PLUS_EQ] = ACTIONS(11879),
    [anon_sym_STAR_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym___END__] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_end] = ACTIONS(11879),
    [anon_sym_ensure] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_elsif] = ACTIONS(11879),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11879),
    [ts_builtin_sym_end] = ACTIONS(11879),
    [anon_sym_DASH_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11877),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_AMP_AMP] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11877),
  },
  [9414] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15833),
  },
  [9415] = {
    [anon_sym_SLASH] = ACTIONS(12164),
    [sym__line_break] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12164),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12164),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12164),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(12164),
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12164),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12164),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12164),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_AMP_AMP] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12164),
  },
  [9416] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [9417] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [9418] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(4022),
    [sym_unary] = STATE(4022),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(4022),
    [sym__primary] = STATE(1669),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(4022),
    [sym_conditional] = STATE(4022),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4023),
    [sym_rational] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(4022),
    [sym_binary] = STATE(4022),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym_float] = ACTIONS(2939),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2941),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(6799),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2953),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(6801),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_yield] = ACTIONS(3520),
    [sym_class_variable] = ACTIONS(2953),
    [sym__block_ampersand] = ACTIONS(6803),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(3524),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [sym_retry] = ACTIONS(2939),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(13983),
    [sym_redo] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9419] = {
    [sym_heredoc_body] = STATE(9419),
    [aux_sym_call_repeat1] = STATE(9419),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9420] = {
    [sym_heredoc_body] = STATE(9419),
    [aux_sym_call_repeat1] = STATE(9419),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9421] = {
    [aux_sym_argument_list_repeat1] = STATE(9421),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15835),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9422] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9423] = {
    [anon_sym_RPAREN] = ACTIONS(15838),
    [sym_comment] = ACTIONS(49),
  },
  [9424] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9425] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(4272),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [9426] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9427] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [9428] = {
    [sym_assignment] = STATE(11021),
    [sym_unary] = STATE(11021),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11021),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11021),
    [sym_conditional] = STATE(11021),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11021),
    [sym_binary] = STATE(11021),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9429] = {
    [sym_assignment] = STATE(6912),
    [sym_unary] = STATE(6912),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6912),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_splat_argument] = STATE(11022),
    [sym_operator_assignment] = STATE(6912),
    [sym_conditional] = STATE(6912),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(1669),
    [sym__arg_or_splat_arg] = STATE(11022),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11017),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2941),
    [sym_character] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9430] = {
    [sym_assignment] = STATE(11023),
    [sym_unary] = STATE(11023),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11023),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11023),
    [sym_conditional] = STATE(11023),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11023),
    [sym_binary] = STATE(11023),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9431] = {
    [sym_assignment] = STATE(11024),
    [sym_unary] = STATE(11024),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11024),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11024),
    [sym_conditional] = STATE(11024),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11024),
    [sym_binary] = STATE(11024),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9432] = {
    [sym_assignment] = STATE(11026),
    [sym_unary] = STATE(11026),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11026),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11026),
    [sym_conditional] = STATE(11026),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11026),
    [sym_binary] = STATE(11026),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9433] = {
    [sym_assignment] = STATE(11027),
    [sym_unary] = STATE(11027),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11027),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11027),
    [sym_conditional] = STATE(11027),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11027),
    [sym_binary] = STATE(11027),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9434] = {
    [sym_assignment] = STATE(11028),
    [sym_unary] = STATE(11028),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11028),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11028),
    [sym_conditional] = STATE(11028),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11028),
    [sym_binary] = STATE(11028),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9435] = {
    [sym_assignment] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9436] = {
    [sym_assignment] = STATE(11030),
    [sym_unary] = STATE(11030),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11030),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11030),
    [sym_conditional] = STATE(11030),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11030),
    [sym_binary] = STATE(11030),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9437] = {
    [sym_assignment] = STATE(11031),
    [sym_unary] = STATE(11031),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11031),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11031),
    [sym_conditional] = STATE(11031),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11031),
    [sym_binary] = STATE(11031),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9438] = {
    [sym_assignment] = STATE(11032),
    [sym_unary] = STATE(11032),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11032),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(11032),
    [sym_conditional] = STATE(11032),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(11032),
    [sym_binary] = STATE(11032),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9439] = {
    [sym_assignment] = STATE(6912),
    [sym_unary] = STATE(6912),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(6912),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(6912),
    [sym_conditional] = STATE(6912),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_true] = STATE(6911),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11017),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2941),
    [sym_character] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9440] = {
    [aux_sym_exceptions_repeat1] = STATE(11033),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14021),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9441] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [9442] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [9443] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(1994),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4039),
    [sym_rational] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym_float] = ACTIONS(3558),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(3562),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(3562),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(3564),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(6819),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(3570),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [sym__identifier_hash_key] = ACTIONS(6821),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6819),
    [anon_sym_yield] = ACTIONS(3576),
    [sym_class_variable] = ACTIONS(3570),
    [sym__block_ampersand] = ACTIONS(6823),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [sym_retry] = ACTIONS(3558),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14023),
    [sym_redo] = ACTIONS(3558),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [9444] = {
    [sym_heredoc_body] = STATE(9444),
    [aux_sym_call_repeat1] = STATE(9444),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9445] = {
    [sym_heredoc_body] = STATE(9444),
    [aux_sym_call_repeat1] = STATE(9444),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9446] = {
    [aux_sym_argument_list_repeat1] = STATE(9446),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15840),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9447] = {
    [sym_assignment] = STATE(11034),
    [sym_unary] = STATE(11034),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1672),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11034),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1672),
    [sym_operator_assignment] = STATE(11034),
    [sym_conditional] = STATE(11034),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1670),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1672),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4013),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1672),
    [sym_range] = STATE(11034),
    [sym_binary] = STATE(11034),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1672),
    [sym_nil] = STATE(1672),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2961),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(2965),
    [anon_sym_next] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(2955),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2969),
  },
  [9448] = {
    [anon_sym_SLASH] = ACTIONS(12630),
    [sym__line_break] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_AMP_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT_EQ] = ACTIONS(12632),
    [anon_sym_SLASH_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12630),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12630),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12630),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_PERCENT_EQ] = ACTIONS(12632),
    [anon_sym_LT_LT_EQ] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_else] = ACTIONS(12632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_CARET_EQ] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_then] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12630),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_EQ_GT] = ACTIONS(12632),
    [anon_sym_when] = ACTIONS(12632),
    [anon_sym_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_PLUS_EQ] = ACTIONS(12632),
    [anon_sym_STAR_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym___END__] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12630),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_end] = ACTIONS(12632),
    [anon_sym_ensure] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_elsif] = ACTIONS(12632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12632),
    [ts_builtin_sym_end] = ACTIONS(12632),
    [anon_sym_DASH_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12630),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_AMP_AMP] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12630),
  },
  [9449] = {
    [anon_sym_SLASH] = ACTIONS(12795),
    [sym__line_break] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_AMP_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT_EQ] = ACTIONS(12797),
    [anon_sym_SLASH_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12795),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12795),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12795),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_PERCENT_EQ] = ACTIONS(12797),
    [anon_sym_LT_LT_EQ] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_else] = ACTIONS(12797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_CARET_EQ] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_EQ] = ACTIONS(12795),
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_then] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12795),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_EQ_GT] = ACTIONS(12797),
    [anon_sym_when] = ACTIONS(12797),
    [anon_sym_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_PLUS_EQ] = ACTIONS(12797),
    [anon_sym_STAR_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym___END__] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12795),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_end] = ACTIONS(12797),
    [anon_sym_ensure] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_elsif] = ACTIONS(12797),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12797),
    [ts_builtin_sym_end] = ACTIONS(12797),
    [anon_sym_DASH_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12795),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_AMP_AMP] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12795),
  },
  [9450] = {
    [anon_sym_end] = ACTIONS(15843),
    [sym_comment] = ACTIONS(49),
  },
  [9451] = {
    [anon_sym_SLASH] = ACTIONS(15173),
    [sym__line_break] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_else] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_then] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_when] = ACTIONS(15175),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym___END__] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_ensure] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_elsif] = ACTIONS(15175),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [ts_builtin_sym_end] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [9452] = {
    [anon_sym_end] = ACTIONS(15845),
    [sym_comment] = ACTIONS(49),
  },
  [9453] = {
    [sym__method_name] = STATE(1692),
    [sym_setter] = STATE(1692),
    [sym_symbol] = STATE(1692),
    [sym_operator] = STATE(1692),
    [sym__method_rest] = STATE(11037),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(11047),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(11047),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(11047),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(11047),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [9454] = {
    [anon_sym_SLASH] = ACTIONS(7382),
    [sym__line_break] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_AMP_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT_EQ] = ACTIONS(7384),
    [anon_sym_SLASH_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7382),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7382),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7382),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_PERCENT_EQ] = ACTIONS(7384),
    [anon_sym_LT_LT_EQ] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [anon_sym_else] = ACTIONS(7384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_CARET_EQ] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_EQ] = ACTIONS(7382),
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_then] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7382),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_when] = ACTIONS(7384),
    [anon_sym_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_PLUS_EQ] = ACTIONS(7384),
    [anon_sym_STAR_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym___END__] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7382),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_end] = ACTIONS(7384),
    [anon_sym_ensure] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_elsif] = ACTIONS(7384),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7384),
    [ts_builtin_sym_end] = ACTIONS(7384),
    [anon_sym_DASH_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7382),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [anon_sym_AMP_AMP] = ACTIONS(7382),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7382),
  },
  [9455] = {
    [anon_sym_end] = ACTIONS(15847),
    [sym_comment] = ACTIONS(49),
  },
  [9456] = {
    [anon_sym_SLASH] = ACTIONS(9897),
    [sym__line_break] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_AMP_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT_EQ] = ACTIONS(9899),
    [anon_sym_SLASH_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9897),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9897),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9897),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_PERCENT_EQ] = ACTIONS(9899),
    [anon_sym_LT_LT_EQ] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [anon_sym_else] = ACTIONS(9899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_CARET_EQ] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_EQ] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_then] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9897),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_when] = ACTIONS(9899),
    [anon_sym_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_PLUS_EQ] = ACTIONS(9899),
    [anon_sym_STAR_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym___END__] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9897),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_end] = ACTIONS(9899),
    [anon_sym_ensure] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_elsif] = ACTIONS(9899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9899),
    [ts_builtin_sym_end] = ACTIONS(9899),
    [anon_sym_DASH_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9897),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [anon_sym_AMP_AMP] = ACTIONS(9897),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9897),
  },
  [9457] = {
    [anon_sym_end] = ACTIONS(15849),
    [sym_comment] = ACTIONS(49),
  },
  [9458] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11040),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(15849),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [9459] = {
    [sym_when] = STATE(11041),
    [sym_else] = STATE(11040),
    [aux_sym_case_repeat2] = STATE(11041),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(15849),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [9460] = {
    [anon_sym_SLASH] = ACTIONS(10931),
    [sym__line_break] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_AMP_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT_EQ] = ACTIONS(10933),
    [anon_sym_SLASH_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_PERCENT_EQ] = ACTIONS(10933),
    [anon_sym_LT_LT_EQ] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [anon_sym_else] = ACTIONS(10933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_CARET_EQ] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_EQ] = ACTIONS(10931),
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_then] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_when] = ACTIONS(10933),
    [anon_sym_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_PLUS_EQ] = ACTIONS(10933),
    [anon_sym_STAR_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym___END__] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_end] = ACTIONS(10933),
    [anon_sym_ensure] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_elsif] = ACTIONS(10933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10933),
    [ts_builtin_sym_end] = ACTIONS(10933),
    [anon_sym_DASH_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10931),
  },
  [9461] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15851),
  },
  [9462] = {
    [anon_sym_SLASH] = ACTIONS(10937),
    [sym__line_break] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_AMP_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT_EQ] = ACTIONS(10939),
    [anon_sym_SLASH_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10937),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10937),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10937),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_PERCENT_EQ] = ACTIONS(10939),
    [anon_sym_LT_LT_EQ] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [anon_sym_else] = ACTIONS(10939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_CARET_EQ] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_EQ] = ACTIONS(10937),
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_then] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10937),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_when] = ACTIONS(10939),
    [anon_sym_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_PLUS_EQ] = ACTIONS(10939),
    [anon_sym_STAR_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym___END__] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10937),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_end] = ACTIONS(10939),
    [anon_sym_ensure] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_elsif] = ACTIONS(10939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10939),
    [ts_builtin_sym_end] = ACTIONS(10939),
    [anon_sym_DASH_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10937),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [anon_sym_AMP_AMP] = ACTIONS(10937),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10937),
  },
  [9463] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(15853),
    [sym__string_end] = ACTIONS(15851),
  },
  [9464] = {
    [anon_sym_SLASH] = ACTIONS(10943),
    [sym__line_break] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_AMP_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT_EQ] = ACTIONS(10945),
    [anon_sym_SLASH_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10943),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10943),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10943),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_PERCENT_EQ] = ACTIONS(10945),
    [anon_sym_LT_LT_EQ] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [anon_sym_else] = ACTIONS(10945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_CARET_EQ] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_EQ] = ACTIONS(10943),
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_then] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10943),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_when] = ACTIONS(10945),
    [anon_sym_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_PLUS_EQ] = ACTIONS(10945),
    [anon_sym_STAR_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym___END__] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10943),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_end] = ACTIONS(10945),
    [anon_sym_ensure] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_elsif] = ACTIONS(10945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10945),
    [ts_builtin_sym_end] = ACTIONS(10945),
    [anon_sym_DASH_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [anon_sym_AMP_AMP] = ACTIONS(10943),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10943),
  },
  [9465] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15855),
  },
  [9466] = {
    [anon_sym_SLASH] = ACTIONS(7788),
    [sym__line_break] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_AMP_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT_EQ] = ACTIONS(7790),
    [anon_sym_SLASH_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_PERCENT_EQ] = ACTIONS(7790),
    [anon_sym_LT_LT_EQ] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [anon_sym_else] = ACTIONS(7790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_CARET_EQ] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_EQ] = ACTIONS(7788),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_then] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_when] = ACTIONS(7790),
    [anon_sym_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_PLUS_EQ] = ACTIONS(7790),
    [anon_sym_STAR_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym___END__] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7790),
    [anon_sym_ensure] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_elsif] = ACTIONS(7790),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7790),
    [ts_builtin_sym_end] = ACTIONS(7790),
    [anon_sym_DASH_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7788),
  },
  [9467] = {
    [anon_sym_end] = ACTIONS(15857),
    [sym_comment] = ACTIONS(49),
  },
  [9468] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11046),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15859),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [9469] = {
    [anon_sym_SLASH] = ACTIONS(10206),
    [sym__line_break] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_AMP_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT_EQ] = ACTIONS(10208),
    [anon_sym_SLASH_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10206),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10206),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10206),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_PERCENT_EQ] = ACTIONS(10208),
    [anon_sym_LT_LT_EQ] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [anon_sym_else] = ACTIONS(10208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_CARET_EQ] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_then] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10206),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_when] = ACTIONS(10208),
    [anon_sym_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_PLUS_EQ] = ACTIONS(10208),
    [anon_sym_STAR_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym___END__] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10206),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_end] = ACTIONS(10208),
    [anon_sym_ensure] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_elsif] = ACTIONS(10208),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10208),
    [ts_builtin_sym_end] = ACTIONS(10208),
    [anon_sym_DASH_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10206),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10206),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10206),
  },
  [9470] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(4085),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(4086),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11047),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(4089),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(4090),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15861),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [9471] = {
    [anon_sym_SLASH] = ACTIONS(10258),
    [sym__line_break] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_AMP_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT_EQ] = ACTIONS(10260),
    [anon_sym_SLASH_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10258),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10258),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10258),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_PERCENT_EQ] = ACTIONS(10260),
    [anon_sym_LT_LT_EQ] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [anon_sym_else] = ACTIONS(10260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_CARET_EQ] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_EQ] = ACTIONS(10258),
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_then] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10258),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_when] = ACTIONS(10260),
    [anon_sym_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_PLUS_EQ] = ACTIONS(10260),
    [anon_sym_STAR_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym___END__] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10258),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_end] = ACTIONS(10260),
    [anon_sym_ensure] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_elsif] = ACTIONS(10260),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10260),
    [ts_builtin_sym_end] = ACTIONS(10260),
    [anon_sym_DASH_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10258),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [anon_sym_AMP_AMP] = ACTIONS(10258),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10258),
  },
  [9472] = {
    [anon_sym_SLASH] = ACTIONS(10697),
    [sym__line_break] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_AMP_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT_EQ] = ACTIONS(10699),
    [anon_sym_SLASH_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10697),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10697),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10697),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_PERCENT_EQ] = ACTIONS(10699),
    [anon_sym_LT_LT_EQ] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [anon_sym_else] = ACTIONS(10699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_CARET_EQ] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_EQ] = ACTIONS(10697),
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_then] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10697),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_when] = ACTIONS(10699),
    [anon_sym_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_PLUS_EQ] = ACTIONS(10699),
    [anon_sym_STAR_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym___END__] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10697),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_end] = ACTIONS(10699),
    [anon_sym_ensure] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_elsif] = ACTIONS(10699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10699),
    [ts_builtin_sym_end] = ACTIONS(10699),
    [anon_sym_DASH_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10697),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [anon_sym_AMP_AMP] = ACTIONS(10697),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10697),
  },
  [9473] = {
    [anon_sym_end] = ACTIONS(15863),
    [sym_comment] = ACTIONS(49),
  },
  [9474] = {
    [sym_ensure] = STATE(11049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(15863),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [9475] = {
    [anon_sym_SLASH] = ACTIONS(7870),
    [sym__line_break] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_AMP_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT_EQ] = ACTIONS(7872),
    [anon_sym_SLASH_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7870),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7870),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7870),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_PERCENT_EQ] = ACTIONS(7872),
    [anon_sym_LT_LT_EQ] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [anon_sym_else] = ACTIONS(7872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_CARET_EQ] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_EQ] = ACTIONS(7870),
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_then] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7870),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_when] = ACTIONS(7872),
    [anon_sym_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_PLUS_EQ] = ACTIONS(7872),
    [anon_sym_STAR_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym___END__] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_end] = ACTIONS(7872),
    [anon_sym_ensure] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_elsif] = ACTIONS(7872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7872),
    [ts_builtin_sym_end] = ACTIONS(7872),
    [anon_sym_DASH_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7870),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7870),
  },
  [9476] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15865),
  },
  [9477] = {
    [anon_sym_SLASH] = ACTIONS(7876),
    [sym__line_break] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_AMP_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT_EQ] = ACTIONS(7878),
    [anon_sym_SLASH_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_PERCENT_EQ] = ACTIONS(7878),
    [anon_sym_LT_LT_EQ] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [anon_sym_else] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_CARET_EQ] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_then] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_when] = ACTIONS(7878),
    [anon_sym_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_PLUS_EQ] = ACTIONS(7878),
    [anon_sym_STAR_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym___END__] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_end] = ACTIONS(7878),
    [anon_sym_ensure] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_elsif] = ACTIONS(7878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7878),
    [ts_builtin_sym_end] = ACTIONS(7878),
    [anon_sym_DASH_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7876),
  },
  [9478] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(15867),
    [sym__string_end] = ACTIONS(15865),
  },
  [9479] = {
    [anon_sym_SLASH] = ACTIONS(8222),
    [sym__line_break] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_AMP_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT_EQ] = ACTIONS(8224),
    [anon_sym_SLASH_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8222),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_PERCENT_EQ] = ACTIONS(8224),
    [anon_sym_LT_LT_EQ] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [anon_sym_else] = ACTIONS(8224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_CARET_EQ] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_then] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_when] = ACTIONS(8224),
    [anon_sym_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_PLUS_EQ] = ACTIONS(8224),
    [anon_sym_STAR_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym___END__] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_end] = ACTIONS(8224),
    [anon_sym_ensure] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_elsif] = ACTIONS(8224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8224),
    [ts_builtin_sym_end] = ACTIONS(8224),
    [anon_sym_DASH_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8222),
  },
  [9480] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15869),
  },
  [9481] = {
    [anon_sym_SLASH] = ACTIONS(8849),
    [sym__line_break] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_AMP_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT_EQ] = ACTIONS(8851),
    [anon_sym_SLASH_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8849),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8849),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_PERCENT_EQ] = ACTIONS(8851),
    [anon_sym_LT_LT_EQ] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [anon_sym_else] = ACTIONS(8851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_CARET_EQ] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_EQ] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_then] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_when] = ACTIONS(8851),
    [anon_sym_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_PLUS_EQ] = ACTIONS(8851),
    [anon_sym_STAR_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym___END__] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_end] = ACTIONS(8851),
    [anon_sym_ensure] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_elsif] = ACTIONS(8851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8851),
    [ts_builtin_sym_end] = ACTIONS(8851),
    [anon_sym_DASH_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8849),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8849),
  },
  [9482] = {
    [anon_sym_SLASH] = ACTIONS(8870),
    [sym__line_break] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_AMP_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT_EQ] = ACTIONS(8872),
    [anon_sym_SLASH_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8870),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8870),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8870),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_PERCENT_EQ] = ACTIONS(8872),
    [anon_sym_LT_LT_EQ] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [anon_sym_else] = ACTIONS(8872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_CARET_EQ] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_EQ] = ACTIONS(8870),
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_then] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8870),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_when] = ACTIONS(8872),
    [anon_sym_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_PLUS_EQ] = ACTIONS(8872),
    [anon_sym_STAR_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym___END__] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8870),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_end] = ACTIONS(8872),
    [anon_sym_ensure] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_elsif] = ACTIONS(8872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8872),
    [ts_builtin_sym_end] = ACTIONS(8872),
    [anon_sym_DASH_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8870),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [anon_sym_AMP_AMP] = ACTIONS(8870),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8870),
  },
  [9483] = {
    [anon_sym_end] = ACTIONS(15871),
    [sym_comment] = ACTIONS(49),
  },
  [9484] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11055),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(15873),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [9485] = {
    [anon_sym_DOT] = ACTIONS(15875),
    [anon_sym_COLON_COLON] = ACTIONS(15875),
    [sym_comment] = ACTIONS(49),
  },
  [9486] = {
    [anon_sym_SLASH] = ACTIONS(9600),
    [sym__line_break] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_AMP_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT_EQ] = ACTIONS(9602),
    [anon_sym_SLASH_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9600),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9600),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9600),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_PERCENT_EQ] = ACTIONS(9602),
    [anon_sym_LT_LT_EQ] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [anon_sym_else] = ACTIONS(9602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_CARET_EQ] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_EQ] = ACTIONS(9600),
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_then] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9600),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_when] = ACTIONS(9602),
    [anon_sym_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_PLUS_EQ] = ACTIONS(9602),
    [anon_sym_STAR_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym___END__] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9600),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_end] = ACTIONS(9602),
    [anon_sym_ensure] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_elsif] = ACTIONS(9602),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9602),
    [ts_builtin_sym_end] = ACTIONS(9602),
    [anon_sym_DASH_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9600),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [anon_sym_AMP_AMP] = ACTIONS(9600),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9600),
  },
  [9487] = {
    [anon_sym_SLASH] = ACTIONS(9606),
    [sym__line_break] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_AMP_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT_EQ] = ACTIONS(9608),
    [anon_sym_SLASH_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9606),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9606),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9606),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_PERCENT_EQ] = ACTIONS(9608),
    [anon_sym_LT_LT_EQ] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [anon_sym_else] = ACTIONS(9608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_CARET_EQ] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_EQ] = ACTIONS(9606),
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_then] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9606),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_when] = ACTIONS(9608),
    [anon_sym_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_PLUS_EQ] = ACTIONS(9608),
    [anon_sym_STAR_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym___END__] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9606),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_end] = ACTIONS(9608),
    [anon_sym_ensure] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_elsif] = ACTIONS(9608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9608),
    [ts_builtin_sym_end] = ACTIONS(9608),
    [anon_sym_DASH_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9606),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [anon_sym_AMP_AMP] = ACTIONS(9606),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9606),
  },
  [9488] = {
    [anon_sym_SLASH] = ACTIONS(10925),
    [sym__line_break] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10925),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10925),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10925),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [anon_sym_else] = ACTIONS(10927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_EQ] = ACTIONS(10925),
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_then] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10925),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_when] = ACTIONS(10927),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym___END__] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10925),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_end] = ACTIONS(10927),
    [anon_sym_ensure] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_elsif] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [ts_builtin_sym_end] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10925),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10925),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10925),
  },
  [9489] = {
    [anon_sym_end] = ACTIONS(15877),
    [sym_comment] = ACTIONS(49),
  },
  [9490] = {
    [sym_assignment] = STATE(6992),
    [sym_unary] = STATE(6992),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(6992),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(6992),
    [sym_conditional] = STATE(6992),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_return] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_true] = STATE(1725),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(6992),
    [sym_binary] = STATE(6992),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [sym_global_variable] = ACTIONS(3027),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3003),
    [sym_character] = ACTIONS(3019),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [9491] = {
    [aux_sym_exceptions_repeat1] = STATE(11059),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15879),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym___END__] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [ts_builtin_sym_end] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [9492] = {
    [sym_assignment] = STATE(11060),
    [sym_unary] = STATE(11060),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1725),
    [sym_singleton_class] = STATE(1727),
    [sym_module] = STATE(1727),
    [sym_chained_string] = STATE(1727),
    [sym_until] = STATE(1727),
    [sym_regex] = STATE(1727),
    [sym_for] = STATE(1727),
    [sym_symbol] = STATE(1727),
    [sym_if] = STATE(1727),
    [sym_begin] = STATE(1727),
    [sym__arg] = STATE(11060),
    [sym__primary] = STATE(1727),
    [sym_method_call] = STATE(1725),
    [sym_operator_assignment] = STATE(11060),
    [sym_conditional] = STATE(11060),
    [sym_method] = STATE(1727),
    [sym_singleton_method] = STATE(1727),
    [sym__variable] = STATE(1728),
    [sym_left_assignment_list] = STATE(1729),
    [sym_rational] = STATE(1727),
    [sym_true] = STATE(1725),
    [sym_return] = STATE(1727),
    [sym_subshell] = STATE(1727),
    [sym_yield] = STATE(1727),
    [sym_string] = STATE(1730),
    [sym_unless] = STATE(1727),
    [sym_lambda] = STATE(1727),
    [sym_parenthesized_statements] = STATE(1727),
    [sym_element_reference] = STATE(1725),
    [sym_range] = STATE(11060),
    [sym_binary] = STATE(11060),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1727),
    [sym_break] = STATE(1727),
    [sym_next] = STATE(1727),
    [sym_string_array] = STATE(1727),
    [sym_while] = STATE(1727),
    [sym_case] = STATE(1727),
    [sym_symbol_array] = STATE(1727),
    [sym_array] = STATE(1727),
    [sym_hash] = STATE(1727),
    [sym_false] = STATE(1725),
    [sym_nil] = STATE(1725),
    [sym_scope_resolution] = STATE(1728),
    [sym_call] = STATE(1728),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(2989),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_not] = ACTIONS(3001),
    [sym_self] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3019),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3027),
    [sym_character] = ACTIONS(3019),
    [sym_super] = ACTIONS(3003),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3033),
    [anon_sym_next] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(2989),
    [sym_constant] = ACTIONS(3003),
    [anon_sym_defined_QMARK] = ACTIONS(3039),
    [sym_instance_variable] = ACTIONS(3027),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3003),
    [sym_redo] = ACTIONS(2989),
    [sym_class_variable] = ACTIONS(3027),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3055),
  },
  [9493] = {
    [anon_sym_SLASH] = ACTIONS(13274),
    [sym__line_break] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_AMP_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT_EQ] = ACTIONS(13276),
    [anon_sym_SLASH_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13274),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13274),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13274),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_PERCENT_EQ] = ACTIONS(13276),
    [anon_sym_LT_LT_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_else] = ACTIONS(13276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_CARET_EQ] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_EQ] = ACTIONS(13274),
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_then] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13274),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_EQ_GT] = ACTIONS(13276),
    [anon_sym_when] = ACTIONS(13276),
    [anon_sym_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_PLUS_EQ] = ACTIONS(13276),
    [anon_sym_STAR_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym___END__] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13274),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_end] = ACTIONS(13276),
    [anon_sym_ensure] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_elsif] = ACTIONS(13276),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13276),
    [ts_builtin_sym_end] = ACTIONS(13276),
    [anon_sym_DASH_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_AMP_AMP] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13274),
  },
  [9494] = {
    [anon_sym_end] = ACTIONS(15881),
    [sym_comment] = ACTIONS(49),
  },
  [9495] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11062),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(15881),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [9496] = {
    [anon_sym_SLASH] = ACTIONS(13462),
    [sym__line_break] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_AMP_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT_EQ] = ACTIONS(13464),
    [anon_sym_SLASH_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13462),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_PERCENT_EQ] = ACTIONS(13464),
    [anon_sym_LT_LT_EQ] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_else] = ACTIONS(13464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_CARET_EQ] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_EQ] = ACTIONS(13462),
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_then] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13462),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_EQ_GT] = ACTIONS(13464),
    [anon_sym_when] = ACTIONS(13464),
    [anon_sym_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_PLUS_EQ] = ACTIONS(13464),
    [anon_sym_STAR_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym___END__] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13462),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_end] = ACTIONS(13464),
    [anon_sym_ensure] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_elsif] = ACTIONS(13464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13464),
    [ts_builtin_sym_end] = ACTIONS(13464),
    [anon_sym_DASH_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13462),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_AMP_AMP] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13462),
  },
  [9497] = {
    [anon_sym_SLASH] = ACTIONS(13466),
    [sym__line_break] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_AMP_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT_EQ] = ACTIONS(13468),
    [anon_sym_SLASH_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13466),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13466),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13466),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_PERCENT_EQ] = ACTIONS(13468),
    [anon_sym_LT_LT_EQ] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_else] = ACTIONS(13468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_CARET_EQ] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_EQ] = ACTIONS(13466),
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_then] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_EQ_GT] = ACTIONS(13468),
    [anon_sym_when] = ACTIONS(13468),
    [anon_sym_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_PLUS_EQ] = ACTIONS(13468),
    [anon_sym_STAR_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym___END__] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13466),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_end] = ACTIONS(13468),
    [anon_sym_ensure] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_elsif] = ACTIONS(13468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13468),
    [ts_builtin_sym_end] = ACTIONS(13468),
    [anon_sym_DASH_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13466),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_AMP_AMP] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13466),
  },
  [9498] = {
    [anon_sym_SLASH] = ACTIONS(13737),
    [sym__line_break] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_AMP_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT_EQ] = ACTIONS(13739),
    [anon_sym_SLASH_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13737),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13737),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13737),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_PERCENT_EQ] = ACTIONS(13739),
    [anon_sym_LT_LT_EQ] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_else] = ACTIONS(13739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_CARET_EQ] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_EQ] = ACTIONS(13737),
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_then] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13737),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_EQ_GT] = ACTIONS(13739),
    [anon_sym_when] = ACTIONS(13739),
    [anon_sym_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_PLUS_EQ] = ACTIONS(13739),
    [anon_sym_STAR_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym___END__] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13737),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_end] = ACTIONS(13739),
    [anon_sym_ensure] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_elsif] = ACTIONS(13739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13739),
    [ts_builtin_sym_end] = ACTIONS(13739),
    [anon_sym_DASH_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13737),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_AMP_AMP] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13737),
  },
  [9499] = {
    [anon_sym_end] = ACTIONS(15883),
    [sym_comment] = ACTIONS(49),
  },
  [9500] = {
    [anon_sym_SLASH] = ACTIONS(13952),
    [sym__line_break] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_AMP_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT_EQ] = ACTIONS(13954),
    [anon_sym_SLASH_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13952),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13952),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13952),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_PERCENT_EQ] = ACTIONS(13954),
    [anon_sym_LT_LT_EQ] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_else] = ACTIONS(13954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_CARET_EQ] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_EQ] = ACTIONS(13952),
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_then] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13952),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_EQ_GT] = ACTIONS(13954),
    [anon_sym_when] = ACTIONS(13954),
    [anon_sym_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_PLUS_EQ] = ACTIONS(13954),
    [anon_sym_STAR_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym___END__] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13952),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_end] = ACTIONS(13954),
    [anon_sym_ensure] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_elsif] = ACTIONS(13954),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13954),
    [ts_builtin_sym_end] = ACTIONS(13954),
    [anon_sym_DASH_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13952),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_AMP_AMP] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13952),
  },
  [9501] = {
    [anon_sym_SLASH] = ACTIONS(13956),
    [sym__line_break] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_AMP_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT_EQ] = ACTIONS(13958),
    [anon_sym_SLASH_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13956),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13956),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13956),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_PERCENT_EQ] = ACTIONS(13958),
    [anon_sym_LT_LT_EQ] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_else] = ACTIONS(13958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_CARET_EQ] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_EQ] = ACTIONS(13956),
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_then] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13956),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_EQ_GT] = ACTIONS(13958),
    [anon_sym_when] = ACTIONS(13958),
    [anon_sym_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_PLUS_EQ] = ACTIONS(13958),
    [anon_sym_STAR_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym___END__] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13956),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_end] = ACTIONS(13958),
    [anon_sym_ensure] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_elsif] = ACTIONS(13958),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13958),
    [ts_builtin_sym_end] = ACTIONS(13958),
    [anon_sym_DASH_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13956),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_AMP_AMP] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13956),
  },
  [9502] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(15885),
  },
  [9503] = {
    [anon_sym_SLASH] = ACTIONS(13962),
    [sym__line_break] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_AMP_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT_EQ] = ACTIONS(13964),
    [anon_sym_SLASH_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13962),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13962),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13962),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_PERCENT_EQ] = ACTIONS(13964),
    [anon_sym_LT_LT_EQ] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_else] = ACTIONS(13964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_CARET_EQ] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_EQ] = ACTIONS(13962),
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_then] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13962),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_EQ_GT] = ACTIONS(13964),
    [anon_sym_when] = ACTIONS(13964),
    [anon_sym_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_PLUS_EQ] = ACTIONS(13964),
    [anon_sym_STAR_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym___END__] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13962),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_end] = ACTIONS(13964),
    [anon_sym_ensure] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_elsif] = ACTIONS(13964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13964),
    [ts_builtin_sym_end] = ACTIONS(13964),
    [anon_sym_DASH_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13962),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_AMP_AMP] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13962),
  },
  [9504] = {
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [9505] = {
    [aux_sym_exceptions_repeat1] = STATE(9505),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15887),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [9506] = {
    [anon_sym_SLASH] = ACTIONS(3105),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3107),
    [anon_sym_EQ_TILDE] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [sym__binary_star] = ACTIONS(3111),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_STAR_STAR] = ACTIONS(3105),
    [anon_sym_LT_EQ_GT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [sym__binary_minus] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(3119),
  },
  [9507] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
  },
  [9508] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(15890),
  },
  [9509] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_COLON2] = ACTIONS(9628),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [9510] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [9511] = {
    [sym_assignment] = STATE(11066),
    [sym_unary] = STATE(11066),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(11066),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(11066),
    [sym_conditional] = STATE(11066),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(11066),
    [sym_binary] = STATE(11066),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [9512] = {
    [sym_assignment] = STATE(11067),
    [sym_unary] = STATE(11067),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(11067),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(11067),
    [sym_conditional] = STATE(11067),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(11067),
    [sym_binary] = STATE(11067),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [9513] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_COLON2] = ACTIONS(5430),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9514] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_COLON2] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9515] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_COLON2] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9516] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_heredoc_body] = STATE(11068),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym_float] = ACTIONS(7005),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(7029),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15892),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [9517] = {
    [sym_heredoc_body] = STATE(11069),
    [aux_sym_call_repeat1] = STATE(11069),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [9518] = {
    [sym_heredoc_body] = STATE(11070),
    [aux_sym_call_repeat1] = STATE(11070),
    [aux_sym_argument_list_repeat1] = STATE(11071),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [9519] = {
    [sym_heredoc_body] = STATE(11072),
    [aux_sym_call_repeat1] = STATE(11072),
    [aux_sym_argument_list_repeat1] = STATE(11073),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11198),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [9520] = {
    [sym_heredoc_body] = STATE(11072),
    [aux_sym_call_repeat1] = STATE(11072),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_COLON2] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [9521] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [9522] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [9523] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_COLON2] = ACTIONS(2053),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [9524] = {
    [sym_assignment] = STATE(11074),
    [sym_unary] = STATE(11074),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11074),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11074),
    [sym_conditional] = STATE(11074),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11074),
    [sym_binary] = STATE(11074),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9525] = {
    [sym_assignment] = STATE(11075),
    [sym_unary] = STATE(11075),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11075),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_splat_argument] = STATE(11076),
    [sym_operator_assignment] = STATE(11075),
    [sym_conditional] = STATE(11075),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_return] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_subshell] = STATE(7056),
    [sym__arg_or_splat_arg] = STATE(11076),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11075),
    [sym_binary] = STATE(11075),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [sym_global_variable] = ACTIONS(11186),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(11178),
    [sym_character] = ACTIONS(11182),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9526] = {
    [sym_assignment] = STATE(11077),
    [sym_unary] = STATE(11077),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11077),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11077),
    [sym_conditional] = STATE(11077),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11077),
    [sym_binary] = STATE(11077),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9527] = {
    [sym_assignment] = STATE(11078),
    [sym_unary] = STATE(11078),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11078),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11078),
    [sym_conditional] = STATE(11078),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11078),
    [sym_binary] = STATE(11078),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9528] = {
    [sym_assignment] = STATE(11080),
    [sym_unary] = STATE(11080),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11080),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11080),
    [sym_conditional] = STATE(11080),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11080),
    [sym_binary] = STATE(11080),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9529] = {
    [sym_assignment] = STATE(11081),
    [sym_unary] = STATE(11081),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11081),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11081),
    [sym_conditional] = STATE(11081),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11081),
    [sym_binary] = STATE(11081),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9530] = {
    [sym_assignment] = STATE(11082),
    [sym_unary] = STATE(11082),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11082),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11082),
    [sym_conditional] = STATE(11082),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11082),
    [sym_binary] = STATE(11082),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9531] = {
    [sym_assignment] = STATE(11083),
    [sym_unary] = STATE(11083),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11083),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11083),
    [sym_conditional] = STATE(11083),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11083),
    [sym_binary] = STATE(11083),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9532] = {
    [sym_assignment] = STATE(11084),
    [sym_unary] = STATE(11084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11084),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11084),
    [sym_conditional] = STATE(11084),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11084),
    [sym_binary] = STATE(11084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9533] = {
    [sym_assignment] = STATE(11085),
    [sym_unary] = STATE(11085),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11085),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11085),
    [sym_conditional] = STATE(11085),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11085),
    [sym_binary] = STATE(11085),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9534] = {
    [sym_assignment] = STATE(11086),
    [sym_unary] = STATE(11086),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11086),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(11086),
    [sym_conditional] = STATE(11086),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11086),
    [sym_binary] = STATE(11086),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [9535] = {
    [sym_heredoc_body] = STATE(11091),
    [sym__argument_list_with_parens] = STATE(11090),
    [aux_sym_call_repeat1] = STATE(11091),
    [sym_argument_list_with_parens] = STATE(11089),
    [sym_operator] = STATE(11089),
    [anon_sym_LT] = ACTIONS(15894),
    [anon_sym_SLASH] = ACTIONS(15896),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(15896),
    [anon_sym_PLUS_AT] = ACTIONS(15896),
    [anon_sym_LPAREN2] = ACTIONS(15898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15896),
    [anon_sym_GT_GT] = ACTIONS(15896),
    [anon_sym_EQ_TILDE] = ACTIONS(15896),
    [anon_sym_LT_LT] = ACTIONS(15896),
    [anon_sym_TILDE] = ACTIONS(15896),
    [anon_sym_PLUS] = ACTIONS(15894),
    [anon_sym_AMP] = ACTIONS(15896),
    [anon_sym_GT] = ACTIONS(15894),
    [anon_sym_PERCENT] = ACTIONS(15896),
    [anon_sym_DASH_AT] = ACTIONS(15896),
    [anon_sym_EQ_EQ] = ACTIONS(15894),
    [anon_sym_STAR] = ACTIONS(15894),
    [anon_sym_BANG_TILDE] = ACTIONS(15896),
    [sym_constant] = ACTIONS(15900),
    [anon_sym_DASH] = ACTIONS(15894),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(15896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(15894),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(15896),
    [anon_sym_STAR_STAR] = ACTIONS(15896),
    [anon_sym_PIPE] = ACTIONS(15896),
    [anon_sym_DOT_DOT] = ACTIONS(15896),
    [anon_sym_LT_EQ_GT] = ACTIONS(15896),
    [anon_sym_LT_EQ] = ACTIONS(15894),
    [anon_sym_BANG] = ACTIONS(15894),
    [sym_identifier] = ACTIONS(15900),
    [anon_sym_CARET] = ACTIONS(15896),
  },
  [9536] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(15902),
    [sym_identifier] = ACTIONS(15902),
  },
  [9537] = {
    [aux_sym_chained_string_repeat1] = STATE(11093),
    [sym_string] = STATE(11093),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [9538] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(4199),
    [sym_unary] = STATE(4199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(4199),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(4199),
    [sym_conditional] = STATE(4199),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(4203),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(4199),
    [sym_binary] = STATE(4199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym_float] = ACTIONS(7005),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7015),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(7023),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7015),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(7027),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(7029),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14166),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [9539] = {
    [sym_heredoc_body] = STATE(9539),
    [aux_sym_call_repeat1] = STATE(9539),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_COLON2] = ACTIONS(9772),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [9540] = {
    [sym_heredoc_body] = STATE(9539),
    [aux_sym_call_repeat1] = STATE(9539),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_COLON2] = ACTIONS(9779),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [9541] = {
    [aux_sym_argument_list_repeat1] = STATE(9541),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15904),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [9542] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(9786),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9543] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9544] = {
    [aux_sym_exceptions_repeat1] = STATE(11095),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [9545] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9546] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9547] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15907),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9548] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9549] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9550] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(9792),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9551] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [9552] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9553] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9554] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [9555] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_COLON2] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9556] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11098),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15909),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9557] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_COLON2] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9558] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_COLON2] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9559] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9558),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11099),
    [sym_operator] = STATE(11099),
    [anon_sym_LT] = ACTIONS(14168),
    [anon_sym_SLASH] = ACTIONS(14170),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14170),
    [anon_sym_PLUS_AT] = ACTIONS(14170),
    [anon_sym_LPAREN2] = ACTIONS(14172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14170),
    [anon_sym_GT_GT] = ACTIONS(14170),
    [anon_sym_EQ_TILDE] = ACTIONS(14170),
    [anon_sym_LT_LT] = ACTIONS(14170),
    [anon_sym_TILDE] = ACTIONS(14170),
    [anon_sym_PLUS] = ACTIONS(14168),
    [anon_sym_AMP] = ACTIONS(14170),
    [anon_sym_GT] = ACTIONS(14168),
    [anon_sym_PERCENT] = ACTIONS(14170),
    [anon_sym_DASH_AT] = ACTIONS(14170),
    [anon_sym_EQ_EQ] = ACTIONS(14168),
    [anon_sym_STAR] = ACTIONS(14168),
    [anon_sym_BANG_TILDE] = ACTIONS(14170),
    [sym_constant] = ACTIONS(15911),
    [anon_sym_DASH] = ACTIONS(14168),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14170),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14170),
    [anon_sym_STAR_STAR] = ACTIONS(14170),
    [anon_sym_PIPE] = ACTIONS(14170),
    [anon_sym_DOT_DOT] = ACTIONS(14170),
    [anon_sym_LT_EQ_GT] = ACTIONS(14170),
    [anon_sym_LT_EQ] = ACTIONS(14168),
    [anon_sym_BANG] = ACTIONS(14168),
    [sym_identifier] = ACTIONS(15911),
    [anon_sym_CARET] = ACTIONS(14170),
  },
  [9560] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_COLON2] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9561] = {
    [sym_assignment] = STATE(11100),
    [sym_unary] = STATE(11100),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(11100),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(11100),
    [sym_conditional] = STATE(11100),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(11100),
    [sym_binary] = STATE(11100),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [9562] = {
    [sym_assignment] = STATE(11101),
    [sym_unary] = STATE(11101),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(11101),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(11101),
    [sym_conditional] = STATE(11101),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(11101),
    [sym_binary] = STATE(11101),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [9563] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_COLON2] = ACTIONS(5430),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9564] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_COLON2] = ACTIONS(5554),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9565] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_COLON2] = ACTIONS(5570),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9566] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_heredoc_body] = STATE(11102),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym_float] = ACTIONS(7083),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(7087),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7089),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(7095),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [sym_class_variable] = ACTIONS(7095),
    [sym__block_ampersand] = ACTIONS(11240),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(7105),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15913),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [9567] = {
    [sym_heredoc_body] = STATE(11103),
    [aux_sym_call_repeat1] = STATE(11103),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9568] = {
    [sym_heredoc_body] = STATE(11104),
    [aux_sym_call_repeat1] = STATE(11104),
    [aux_sym_argument_list_repeat1] = STATE(11105),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14182),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9569] = {
    [aux_sym_chained_string_repeat1] = STATE(9569),
    [sym_string] = STATE(9569),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(15915),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [9570] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_COLON2] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [9571] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [9572] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [9573] = {
    [sym_assignment] = STATE(11106),
    [sym_unary] = STATE(11106),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11106),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11106),
    [sym_conditional] = STATE(11106),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11106),
    [sym_binary] = STATE(11106),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9574] = {
    [sym_assignment] = STATE(7098),
    [sym_unary] = STATE(7098),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7098),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_splat_argument] = STATE(11107),
    [sym_operator_assignment] = STATE(7098),
    [sym_conditional] = STATE(7098),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_return] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_subshell] = STATE(1799),
    [sym__arg_or_splat_arg] = STATE(11107),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(7098),
    [sym_binary] = STATE(7098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(11254),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [sym_global_variable] = ACTIONS(3151),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(3143),
    [sym_character] = ACTIONS(3147),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9575] = {
    [sym_assignment] = STATE(11108),
    [sym_unary] = STATE(11108),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11108),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11108),
    [sym_conditional] = STATE(11108),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11108),
    [sym_binary] = STATE(11108),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9576] = {
    [sym_assignment] = STATE(11109),
    [sym_unary] = STATE(11109),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11109),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11109),
    [sym_conditional] = STATE(11109),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11109),
    [sym_binary] = STATE(11109),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9577] = {
    [sym_assignment] = STATE(11111),
    [sym_unary] = STATE(11111),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11111),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11111),
    [sym_conditional] = STATE(11111),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11111),
    [sym_binary] = STATE(11111),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9578] = {
    [sym_assignment] = STATE(11112),
    [sym_unary] = STATE(11112),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11112),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11112),
    [sym_conditional] = STATE(11112),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11112),
    [sym_binary] = STATE(11112),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9579] = {
    [sym_assignment] = STATE(11113),
    [sym_unary] = STATE(11113),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11113),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11113),
    [sym_conditional] = STATE(11113),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11113),
    [sym_binary] = STATE(11113),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9580] = {
    [sym_assignment] = STATE(11114),
    [sym_unary] = STATE(11114),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11114),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11114),
    [sym_conditional] = STATE(11114),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11114),
    [sym_binary] = STATE(11114),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9581] = {
    [sym_assignment] = STATE(11115),
    [sym_unary] = STATE(11115),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11115),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11115),
    [sym_conditional] = STATE(11115),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11115),
    [sym_binary] = STATE(11115),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9582] = {
    [sym_assignment] = STATE(11116),
    [sym_unary] = STATE(11116),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11116),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11116),
    [sym_conditional] = STATE(11116),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11116),
    [sym_binary] = STATE(11116),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9583] = {
    [sym_assignment] = STATE(11117),
    [sym_unary] = STATE(11117),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11117),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(11117),
    [sym_conditional] = STATE(11117),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(11117),
    [sym_binary] = STATE(11117),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9584] = {
    [aux_sym_chained_string_repeat1] = STATE(11118),
    [sym_string] = STATE(11118),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [9585] = {
    [sym_assignment] = STATE(7098),
    [sym_unary] = STATE(7098),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(7098),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_splat_argument] = STATE(10015),
    [sym_operator_assignment] = STATE(7098),
    [sym_conditional] = STATE(7098),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_return] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_true] = STATE(7097),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym__arg_or_splat_arg] = STATE(10015),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(7098),
    [sym_binary] = STATE(7098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(11254),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [sym_global_variable] = ACTIONS(3151),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(3143),
    [sym_character] = ACTIONS(3147),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [9586] = {
    [aux_sym_exceptions_repeat1] = STATE(11119),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14218),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_COLON2] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [9587] = {
    [sym_assignment] = STATE(11120),
    [sym_unary] = STATE(11120),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11120),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11120),
    [sym_conditional] = STATE(11120),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11120),
    [sym_binary] = STATE(11120),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9588] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9589] = {
    [anon_sym_RPAREN] = ACTIONS(15918),
    [sym_comment] = ACTIONS(49),
  },
  [9590] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9591] = {
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1851),
    [anon_sym_AMP_EQ] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_GT_GT_EQ] = ACTIONS(1853),
    [anon_sym_SLASH_EQ] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [anon_sym_or] = ACTIONS(1853),
    [anon_sym_EQ_TILDE] = ACTIONS(1853),
    [sym__binary_star] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [anon_sym_PERCENT] = ACTIONS(1851),
    [anon_sym_COLON_COLON2] = ACTIONS(1853),
    [anon_sym_EQ_GT] = ACTIONS(1853),
    [anon_sym_PERCENT_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_LT_LT_EQ] = ACTIONS(1853),
    [anon_sym_PLUS_EQ] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1853),
    [anon_sym_STAR_EQ] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_EQ_EQ] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_COLON2] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1851),
    [anon_sym_BANG_TILDE] = ACTIONS(1853),
    [sym__heredoc_body_start] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [sym__string_start] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1853),
    [anon_sym_CARET_EQ] = ACTIONS(1853),
    [anon_sym_DASH_EQ] = ACTIONS(1853),
    [anon_sym_AMP_DOT] = ACTIONS(1853),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1853),
    [anon_sym_BANG_EQ] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_AMP_AMP] = ACTIONS(1851),
    [anon_sym_LT_EQ_GT] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [sym__binary_minus] = ACTIONS(1853),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_CARET] = ACTIONS(1851),
  },
  [9592] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(15920),
  },
  [9593] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_COLON2] = ACTIONS(9628),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [9594] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [9595] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [9596] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COLON2] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [9597] = {
    [sym_assignment] = STATE(11123),
    [sym_unary] = STATE(11123),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11123),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11123),
    [sym_conditional] = STATE(11123),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11123),
    [sym_binary] = STATE(11123),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9598] = {
    [sym_assignment] = STATE(11124),
    [sym_unary] = STATE(11124),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11124),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_splat_argument] = STATE(11125),
    [sym_operator_assignment] = STATE(11124),
    [sym_conditional] = STATE(11124),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_return] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_subshell] = STATE(7134),
    [sym__arg_or_splat_arg] = STATE(11125),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11124),
    [sym_binary] = STATE(11124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [sym_global_variable] = ACTIONS(11302),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(11294),
    [sym_character] = ACTIONS(11298),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9599] = {
    [sym_assignment] = STATE(11126),
    [sym_unary] = STATE(11126),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11126),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11126),
    [sym_conditional] = STATE(11126),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11126),
    [sym_binary] = STATE(11126),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9600] = {
    [sym_assignment] = STATE(11127),
    [sym_unary] = STATE(11127),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11127),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11127),
    [sym_conditional] = STATE(11127),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11127),
    [sym_binary] = STATE(11127),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9601] = {
    [sym_assignment] = STATE(11129),
    [sym_unary] = STATE(11129),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11129),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11129),
    [sym_conditional] = STATE(11129),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11129),
    [sym_binary] = STATE(11129),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9602] = {
    [sym_assignment] = STATE(11130),
    [sym_unary] = STATE(11130),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11130),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11130),
    [sym_conditional] = STATE(11130),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11130),
    [sym_binary] = STATE(11130),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9603] = {
    [sym_assignment] = STATE(11131),
    [sym_unary] = STATE(11131),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11131),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11131),
    [sym_conditional] = STATE(11131),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11131),
    [sym_binary] = STATE(11131),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9604] = {
    [sym_assignment] = STATE(11132),
    [sym_unary] = STATE(11132),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11132),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11132),
    [sym_conditional] = STATE(11132),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11132),
    [sym_binary] = STATE(11132),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9605] = {
    [sym_assignment] = STATE(11133),
    [sym_unary] = STATE(11133),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11133),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11133),
    [sym_conditional] = STATE(11133),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11133),
    [sym_binary] = STATE(11133),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9606] = {
    [sym_assignment] = STATE(11134),
    [sym_unary] = STATE(11134),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11134),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11134),
    [sym_conditional] = STATE(11134),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11134),
    [sym_binary] = STATE(11134),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9607] = {
    [sym_assignment] = STATE(11135),
    [sym_unary] = STATE(11135),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11135),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(11135),
    [sym_conditional] = STATE(11135),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11135),
    [sym_binary] = STATE(11135),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [9608] = {
    [aux_sym_chained_string_repeat1] = STATE(11136),
    [sym_string] = STATE(11136),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [9609] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9610] = {
    [aux_sym_exceptions_repeat1] = STATE(11138),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9611] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(4240),
    [sym_unary] = STATE(4240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(4240),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(4240),
    [sym_conditional] = STATE(4240),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(4241),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(4240),
    [sym_binary] = STATE(4240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym_float] = ACTIONS(7083),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(7087),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7089),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(7093),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(7099),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7093),
    [anon_sym_yield] = ACTIONS(7101),
    [sym_class_variable] = ACTIONS(7095),
    [sym__block_ampersand] = ACTIONS(7103),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(7105),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14264),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [9612] = {
    [sym_heredoc_body] = STATE(9612),
    [aux_sym_call_repeat1] = STATE(9612),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_COLON2] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9613] = {
    [sym_heredoc_body] = STATE(9612),
    [aux_sym_call_repeat1] = STATE(9612),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_COLON2] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9614] = {
    [aux_sym_argument_list_repeat1] = STATE(9614),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15922),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9615] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(9786),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9616] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9617] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9618] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15925),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9619] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9620] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9621] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(9792),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9622] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [9623] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9624] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9625] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9626] = {
    [aux_sym_chained_string_repeat1] = STATE(9626),
    [sym_string] = STATE(9626),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(15927),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9627] = {
    [aux_sym_undef_repeat1] = STATE(9627),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [9628] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [9629] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [9630] = {
    [sym_assignment] = STATE(11140),
    [sym_unary] = STATE(11140),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(11140),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(11140),
    [sym_conditional] = STATE(11140),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(11140),
    [sym_binary] = STATE(11140),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [9631] = {
    [sym_assignment] = STATE(11141),
    [sym_unary] = STATE(11141),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(11141),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(11141),
    [sym_conditional] = STATE(11141),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(11141),
    [sym_binary] = STATE(11141),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [9632] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9633] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9634] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9635] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_heredoc_body] = STATE(11142),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym_float] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7166),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7174),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7186),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15930),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [9636] = {
    [sym_heredoc_body] = STATE(11143),
    [aux_sym_call_repeat1] = STATE(11143),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9637] = {
    [sym_heredoc_body] = STATE(11144),
    [aux_sym_call_repeat1] = STATE(11144),
    [aux_sym_argument_list_repeat1] = STATE(11145),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14270),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9638] = {
    [sym_heredoc_body] = STATE(11146),
    [aux_sym_call_repeat1] = STATE(11146),
    [aux_sym_argument_list_repeat1] = STATE(11147),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11388),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9639] = {
    [sym_heredoc_body] = STATE(11146),
    [aux_sym_call_repeat1] = STATE(11146),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9640] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9641] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [9642] = {
    [sym_assignment] = STATE(11148),
    [sym_unary] = STATE(11148),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11148),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11148),
    [sym_conditional] = STATE(11148),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11148),
    [sym_binary] = STATE(11148),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9643] = {
    [sym_assignment] = STATE(11149),
    [sym_unary] = STATE(11149),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11149),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_splat_argument] = STATE(11150),
    [sym_operator_assignment] = STATE(11149),
    [sym_conditional] = STATE(11149),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_return] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_subshell] = STATE(1820),
    [sym__arg_or_splat_arg] = STATE(11150),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11149),
    [sym_binary] = STATE(11149),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_global_variable] = ACTIONS(7148),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7140),
    [sym_character] = ACTIONS(7144),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9644] = {
    [sym_assignment] = STATE(11151),
    [sym_unary] = STATE(11151),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11151),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11151),
    [sym_conditional] = STATE(11151),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11151),
    [sym_binary] = STATE(11151),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9645] = {
    [sym_assignment] = STATE(11152),
    [sym_unary] = STATE(11152),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11152),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11152),
    [sym_conditional] = STATE(11152),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11152),
    [sym_binary] = STATE(11152),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9646] = {
    [sym_assignment] = STATE(11154),
    [sym_unary] = STATE(11154),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11154),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11154),
    [sym_conditional] = STATE(11154),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11154),
    [sym_binary] = STATE(11154),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9647] = {
    [sym_assignment] = STATE(11155),
    [sym_unary] = STATE(11155),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11155),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11155),
    [sym_conditional] = STATE(11155),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11155),
    [sym_binary] = STATE(11155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9648] = {
    [sym_assignment] = STATE(11156),
    [sym_unary] = STATE(11156),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11156),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11156),
    [sym_conditional] = STATE(11156),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11156),
    [sym_binary] = STATE(11156),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9649] = {
    [sym_assignment] = STATE(11157),
    [sym_unary] = STATE(11157),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11157),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11157),
    [sym_conditional] = STATE(11157),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11157),
    [sym_binary] = STATE(11157),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9650] = {
    [sym_assignment] = STATE(11158),
    [sym_unary] = STATE(11158),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11158),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11158),
    [sym_conditional] = STATE(11158),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11158),
    [sym_binary] = STATE(11158),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9651] = {
    [sym_assignment] = STATE(11159),
    [sym_unary] = STATE(11159),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11159),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11159),
    [sym_conditional] = STATE(11159),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11159),
    [sym_binary] = STATE(11159),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9652] = {
    [sym_assignment] = STATE(11160),
    [sym_unary] = STATE(11160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11160),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(11160),
    [sym_conditional] = STATE(11160),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11160),
    [sym_binary] = STATE(11160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9653] = {
    [aux_sym_chained_string_repeat1] = STATE(11161),
    [sym_string] = STATE(11161),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [9654] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(4264),
    [sym_unary] = STATE(4264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(4264),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(4264),
    [sym_conditional] = STATE(4264),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(4268),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(4264),
    [sym_binary] = STATE(4264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym_float] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7166),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7172),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(7180),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(7184),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7186),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14306),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [9655] = {
    [sym_heredoc_body] = STATE(9655),
    [aux_sym_call_repeat1] = STATE(9655),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9656] = {
    [sym_heredoc_body] = STATE(9655),
    [aux_sym_call_repeat1] = STATE(9655),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9657] = {
    [aux_sym_argument_list_repeat1] = STATE(9657),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15932),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9658] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9659] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9660] = {
    [aux_sym_exceptions_repeat1] = STATE(11163),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9661] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9662] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9663] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9664] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9665] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9666] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9667] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9668] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9669] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9670] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [9671] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9672] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11166),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15937),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9673] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9674] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9675] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9674),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11167),
    [sym_operator] = STATE(11167),
    [anon_sym_LT] = ACTIONS(14308),
    [anon_sym_SLASH] = ACTIONS(14310),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14310),
    [anon_sym_PLUS_AT] = ACTIONS(14310),
    [anon_sym_LPAREN2] = ACTIONS(14312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14310),
    [anon_sym_GT_GT] = ACTIONS(14310),
    [anon_sym_EQ_TILDE] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14310),
    [anon_sym_TILDE] = ACTIONS(14310),
    [anon_sym_PLUS] = ACTIONS(14308),
    [anon_sym_AMP] = ACTIONS(14310),
    [anon_sym_GT] = ACTIONS(14308),
    [anon_sym_PERCENT] = ACTIONS(14310),
    [anon_sym_DASH_AT] = ACTIONS(14310),
    [anon_sym_EQ_EQ] = ACTIONS(14308),
    [anon_sym_STAR] = ACTIONS(14308),
    [anon_sym_BANG_TILDE] = ACTIONS(14310),
    [sym_constant] = ACTIONS(15939),
    [anon_sym_DASH] = ACTIONS(14308),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14308),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14310),
    [anon_sym_STAR_STAR] = ACTIONS(14310),
    [anon_sym_PIPE] = ACTIONS(14310),
    [anon_sym_DOT_DOT] = ACTIONS(14310),
    [anon_sym_LT_EQ_GT] = ACTIONS(14310),
    [anon_sym_LT_EQ] = ACTIONS(14308),
    [anon_sym_BANG] = ACTIONS(14308),
    [sym_identifier] = ACTIONS(15939),
    [anon_sym_CARET] = ACTIONS(14310),
  },
  [9676] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9677] = {
    [sym_assignment] = STATE(11168),
    [sym_unary] = STATE(11168),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(11168),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(11168),
    [sym_conditional] = STATE(11168),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(11168),
    [sym_binary] = STATE(11168),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [9678] = {
    [sym_assignment] = STATE(11169),
    [sym_unary] = STATE(11169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(11169),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(11169),
    [sym_conditional] = STATE(11169),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(11169),
    [sym_binary] = STATE(11169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [9679] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9680] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9681] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9682] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_heredoc_body] = STATE(11170),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym_float] = ACTIONS(7216),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7220),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7220),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7228),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [sym_class_variable] = ACTIONS(7228),
    [sym__block_ampersand] = ACTIONS(11430),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7238),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15941),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [9683] = {
    [sym_heredoc_body] = STATE(11171),
    [aux_sym_call_repeat1] = STATE(11171),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9684] = {
    [sym_heredoc_body] = STATE(11172),
    [aux_sym_call_repeat1] = STATE(11172),
    [aux_sym_argument_list_repeat1] = STATE(11173),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9685] = {
    [aux_sym_chained_string_repeat1] = STATE(9685),
    [sym_string] = STATE(9685),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9686] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9687] = {
    [anon_sym_RPAREN] = ACTIONS(15943),
    [sym_comment] = ACTIONS(49),
  },
  [9688] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9689] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [9690] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9691] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [9692] = {
    [sym_assignment] = STATE(11175),
    [sym_unary] = STATE(11175),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11175),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11175),
    [sym_conditional] = STATE(11175),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11175),
    [sym_binary] = STATE(11175),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9693] = {
    [sym_assignment] = STATE(7227),
    [sym_unary] = STATE(7227),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7227),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_splat_argument] = STATE(11176),
    [sym_operator_assignment] = STATE(7227),
    [sym_conditional] = STATE(7227),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_return] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_subshell] = STATE(1820),
    [sym__arg_or_splat_arg] = STATE(11176),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(7227),
    [sym_binary] = STATE(7227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11452),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(7148),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7140),
    [sym_character] = ACTIONS(7144),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9694] = {
    [sym_assignment] = STATE(11177),
    [sym_unary] = STATE(11177),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11177),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11177),
    [sym_conditional] = STATE(11177),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11177),
    [sym_binary] = STATE(11177),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9695] = {
    [sym_assignment] = STATE(11178),
    [sym_unary] = STATE(11178),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11178),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11178),
    [sym_conditional] = STATE(11178),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11178),
    [sym_binary] = STATE(11178),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9696] = {
    [sym_assignment] = STATE(11180),
    [sym_unary] = STATE(11180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11180),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11180),
    [sym_conditional] = STATE(11180),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11180),
    [sym_binary] = STATE(11180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9697] = {
    [sym_assignment] = STATE(11181),
    [sym_unary] = STATE(11181),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11181),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11181),
    [sym_conditional] = STATE(11181),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11181),
    [sym_binary] = STATE(11181),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9698] = {
    [sym_assignment] = STATE(11182),
    [sym_unary] = STATE(11182),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11182),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11182),
    [sym_conditional] = STATE(11182),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11182),
    [sym_binary] = STATE(11182),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9699] = {
    [sym_assignment] = STATE(11183),
    [sym_unary] = STATE(11183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11183),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11183),
    [sym_conditional] = STATE(11183),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11183),
    [sym_binary] = STATE(11183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9700] = {
    [sym_assignment] = STATE(11184),
    [sym_unary] = STATE(11184),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11184),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11184),
    [sym_conditional] = STATE(11184),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11184),
    [sym_binary] = STATE(11184),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9701] = {
    [sym_assignment] = STATE(11185),
    [sym_unary] = STATE(11185),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11185),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11185),
    [sym_conditional] = STATE(11185),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11185),
    [sym_binary] = STATE(11185),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9702] = {
    [sym_assignment] = STATE(11186),
    [sym_unary] = STATE(11186),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11186),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(11186),
    [sym_conditional] = STATE(11186),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(11186),
    [sym_binary] = STATE(11186),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9703] = {
    [sym_assignment] = STATE(7227),
    [sym_unary] = STATE(7227),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(7227),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(7227),
    [sym_conditional] = STATE(7227),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_return] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_true] = STATE(7226),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(7227),
    [sym_binary] = STATE(7227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11452),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [sym_global_variable] = ACTIONS(7148),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7140),
    [sym_character] = ACTIONS(7144),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [9704] = {
    [aux_sym_exceptions_repeat1] = STATE(11187),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14362),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9705] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [9706] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [9707] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [9708] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [9709] = {
    [sym_assignment] = STATE(11188),
    [sym_unary] = STATE(11188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11188),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11188),
    [sym_conditional] = STATE(11188),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11188),
    [sym_binary] = STATE(11188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9710] = {
    [sym_assignment] = STATE(11189),
    [sym_unary] = STATE(11189),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11189),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_splat_argument] = STATE(11190),
    [sym_operator_assignment] = STATE(11189),
    [sym_conditional] = STATE(11189),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_return] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_subshell] = STATE(7244),
    [sym__arg_or_splat_arg] = STATE(11190),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11189),
    [sym_binary] = STATE(11189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [sym_global_variable] = ACTIONS(11482),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11474),
    [sym_character] = ACTIONS(11478),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9711] = {
    [sym_assignment] = STATE(11191),
    [sym_unary] = STATE(11191),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11191),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11191),
    [sym_conditional] = STATE(11191),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11191),
    [sym_binary] = STATE(11191),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9712] = {
    [sym_assignment] = STATE(11192),
    [sym_unary] = STATE(11192),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11192),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11192),
    [sym_conditional] = STATE(11192),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11192),
    [sym_binary] = STATE(11192),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9713] = {
    [sym_assignment] = STATE(11194),
    [sym_unary] = STATE(11194),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11194),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11194),
    [sym_conditional] = STATE(11194),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11194),
    [sym_binary] = STATE(11194),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9714] = {
    [sym_assignment] = STATE(11195),
    [sym_unary] = STATE(11195),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11195),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11195),
    [sym_conditional] = STATE(11195),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11195),
    [sym_binary] = STATE(11195),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9715] = {
    [sym_assignment] = STATE(11196),
    [sym_unary] = STATE(11196),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11196),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11196),
    [sym_conditional] = STATE(11196),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11196),
    [sym_binary] = STATE(11196),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9716] = {
    [sym_assignment] = STATE(11197),
    [sym_unary] = STATE(11197),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11197),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11197),
    [sym_conditional] = STATE(11197),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11197),
    [sym_binary] = STATE(11197),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9717] = {
    [sym_assignment] = STATE(11198),
    [sym_unary] = STATE(11198),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11198),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11198),
    [sym_conditional] = STATE(11198),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11198),
    [sym_binary] = STATE(11198),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9718] = {
    [sym_assignment] = STATE(11199),
    [sym_unary] = STATE(11199),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11199),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11199),
    [sym_conditional] = STATE(11199),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11199),
    [sym_binary] = STATE(11199),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9719] = {
    [sym_assignment] = STATE(11200),
    [sym_unary] = STATE(11200),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11200),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(11200),
    [sym_conditional] = STATE(11200),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11200),
    [sym_binary] = STATE(11200),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [9720] = {
    [aux_sym_chained_string_repeat1] = STATE(11201),
    [sym_string] = STATE(11201),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [9721] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9722] = {
    [aux_sym_exceptions_repeat1] = STATE(11203),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9723] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(4296),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym_float] = ACTIONS(7216),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7220),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7220),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(7226),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(7232),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7226),
    [anon_sym_yield] = ACTIONS(7234),
    [sym_class_variable] = ACTIONS(7228),
    [sym__block_ampersand] = ACTIONS(7236),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7238),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14398),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [9724] = {
    [sym_heredoc_body] = STATE(9724),
    [aux_sym_call_repeat1] = STATE(9724),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9725] = {
    [sym_heredoc_body] = STATE(9724),
    [aux_sym_call_repeat1] = STATE(9724),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9726] = {
    [aux_sym_argument_list_repeat1] = STATE(9726),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15945),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9727] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9728] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9729] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9730] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15948),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9731] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9732] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9733] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9734] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [9735] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9736] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9737] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9738] = {
    [aux_sym_chained_string_repeat1] = STATE(9738),
    [sym_string] = STATE(9738),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9739] = {
    [sym_assignment] = STATE(11205),
    [sym_unary] = STATE(11205),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11205),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(11205),
    [sym_conditional] = STATE(11205),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(1821),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_range] = STATE(11205),
    [sym_binary] = STATE(11205),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(1823),
    [sym_nil] = STATE(1823),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7134),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7136),
    [anon_sym_not] = ACTIONS(7138),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7142),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7136),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7150),
    [anon_sym_next] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(7154),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7158),
  },
  [9740] = {
    [sym_heredoc_body] = STATE(9740),
    [aux_sym_call_repeat1] = STATE(9740),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [9741] = {
    [sym_heredoc_body] = STATE(9740),
    [aux_sym_call_repeat1] = STATE(9740),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [9742] = {
    [sym_assignment] = STATE(7286),
    [sym_unary] = STATE(7286),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(7286),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(7286),
    [sym_conditional] = STATE(7286),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_true] = STATE(1848),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(7286),
    [sym_binary] = STATE(7286),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [sym_global_variable] = ACTIONS(117),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(109),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [9743] = {
    [aux_sym_exceptions_repeat1] = STATE(11206),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15950),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [9744] = {
    [sym_assignment] = STATE(11207),
    [sym_unary] = STATE(11207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1848),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(11207),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1848),
    [sym_operator_assignment] = STATE(11207),
    [sym_conditional] = STATE(11207),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1850),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1848),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1848),
    [sym_range] = STATE(11207),
    [sym_binary] = STATE(11207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1848),
    [sym_nil] = STATE(1848),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_not] = ACTIONS(3328),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3334),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3338),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [9745] = {
    [aux_sym_exceptions_repeat1] = STATE(9745),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15952),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [9746] = {
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3350),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3358),
    [anon_sym_EQ_TILDE] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3350),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(3350),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_STAR_STAR] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_LT_EQ_GT] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3348),
    [sym__binary_minus] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3372),
  },
  [9747] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [9748] = {
    [sym_assignment] = STATE(11208),
    [sym_unary] = STATE(11208),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1886),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(11208),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(1886),
    [sym_operator_assignment] = STATE(11208),
    [sym_conditional] = STATE(11208),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(65),
    [sym_left_assignment_list] = STATE(1888),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(1886),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(1851),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(1886),
    [sym_range] = STATE(11208),
    [sym_binary] = STATE(11208),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(1886),
    [sym_nil] = STATE(1886),
    [sym_scope_resolution] = STATE(65),
    [sym_call] = STATE(65),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_not] = ACTIONS(3396),
    [sym_self] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3394),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(117),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3402),
    [anon_sym_next] = ACTIONS(3336),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(109),
    [anon_sym_defined_QMARK] = ACTIONS(3404),
    [sym_instance_variable] = ACTIONS(117),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(109),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(117),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3340),
  },
  [9749] = {
    [sym_assignment] = STATE(7327),
    [sym_unary] = STATE(7327),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(7327),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(7327),
    [sym_conditional] = STATE(7327),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_return] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_true] = STATE(1923),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(7327),
    [sym_binary] = STATE(7327),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [sym_global_variable] = ACTIONS(3446),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3438),
    [sym_character] = ACTIONS(3442),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [9750] = {
    [aux_sym_exceptions_repeat1] = STATE(11209),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15955),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [9751] = {
    [sym_assignment] = STATE(11210),
    [sym_unary] = STATE(11210),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1923),
    [sym_singleton_class] = STATE(1925),
    [sym_module] = STATE(1925),
    [sym_chained_string] = STATE(1925),
    [sym_until] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_for] = STATE(1925),
    [sym_symbol] = STATE(1925),
    [sym_if] = STATE(1925),
    [sym_begin] = STATE(1925),
    [sym__arg] = STATE(11210),
    [sym__primary] = STATE(1925),
    [sym_method_call] = STATE(1923),
    [sym_operator_assignment] = STATE(11210),
    [sym_conditional] = STATE(11210),
    [sym_method] = STATE(1925),
    [sym_singleton_method] = STATE(1925),
    [sym__variable] = STATE(1926),
    [sym_left_assignment_list] = STATE(1927),
    [sym_rational] = STATE(1925),
    [sym_true] = STATE(1923),
    [sym_return] = STATE(1925),
    [sym_subshell] = STATE(1925),
    [sym_yield] = STATE(1925),
    [sym_string] = STATE(1928),
    [sym_unless] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_parenthesized_statements] = STATE(1925),
    [sym_element_reference] = STATE(1923),
    [sym_range] = STATE(11210),
    [sym_binary] = STATE(11210),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1925),
    [sym_break] = STATE(1925),
    [sym_next] = STATE(1925),
    [sym_string_array] = STATE(1925),
    [sym_while] = STATE(1925),
    [sym_case] = STATE(1925),
    [sym_symbol_array] = STATE(1925),
    [sym_array] = STATE(1925),
    [sym_hash] = STATE(1925),
    [sym_false] = STATE(1923),
    [sym_nil] = STATE(1923),
    [sym_scope_resolution] = STATE(1926),
    [sym_call] = STATE(1926),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3430),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3432),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [sym_self] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3442),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3446),
    [sym_character] = ACTIONS(3442),
    [sym_super] = ACTIONS(3438),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3448),
    [anon_sym_next] = ACTIONS(3450),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3430),
    [sym_constant] = ACTIONS(3438),
    [anon_sym_defined_QMARK] = ACTIONS(3452),
    [sym_instance_variable] = ACTIONS(3446),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3438),
    [sym_redo] = ACTIONS(3430),
    [sym_class_variable] = ACTIONS(3446),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3454),
  },
  [9752] = {
    [aux_sym_exceptions_repeat1] = STATE(9752),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15957),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [9753] = {
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3466),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3474),
    [anon_sym_EQ_TILDE] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3466),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_BANG_TILDE] = ACTIONS(3474),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_STAR_STAR] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_LT_EQ_GT] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3464),
    [sym__binary_minus] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(3486),
  },
  [9754] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9755] = {
    [sym_heredoc_body] = STATE(9754),
    [aux_sym_call_repeat1] = STATE(9754),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9756] = {
    [sym_heredoc_body] = STATE(11211),
    [aux_sym_call_repeat1] = STATE(11211),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9757] = {
    [sym_heredoc_body] = STATE(11212),
    [aux_sym_call_repeat1] = STATE(11212),
    [aux_sym_argument_list_repeat1] = STATE(7367),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7457),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9758] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9759] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9760] = {
    [aux_sym_exceptions_repeat1] = STATE(11214),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9761] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9762] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9763] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9764] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9765] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15960),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9766] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9767] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9768] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9769] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9770] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [9771] = {
    [aux_sym_chained_string_repeat1] = STATE(9771),
    [sym_string] = STATE(9771),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9772] = {
    [sym_assignment] = STATE(7369),
    [sym_unary] = STATE(7369),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(7369),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(7369),
    [sym_conditional] = STATE(7369),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_return] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_true] = STATE(1967),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(7369),
    [sym_binary] = STATE(7369),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6805),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [sym_global_variable] = ACTIONS(2953),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2941),
    [sym_character] = ACTIONS(2945),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9773] = {
    [aux_sym_exceptions_repeat1] = STATE(11216),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15962),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9774] = {
    [sym_assignment] = STATE(11217),
    [sym_unary] = STATE(11217),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1967),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(11217),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(1967),
    [sym_operator_assignment] = STATE(11217),
    [sym_conditional] = STATE(11217),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(1969),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(1967),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(1967),
    [sym_range] = STATE(11217),
    [sym_binary] = STATE(11217),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(1967),
    [sym_nil] = STATE(1967),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3524),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(7433),
    [anon_sym_TILDE] = ACTIONS(3510),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(3530),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(3514),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [9775] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [9776] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9777] = {
    [aux_sym_exceptions_repeat1] = STATE(7401),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9778] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9779] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9780] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9781] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9782] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15964),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9783] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9784] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9785] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9786] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9787] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [9788] = {
    [aux_sym_exceptions_repeat1] = STATE(9788),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15966),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [9789] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9790] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9791] = {
    [aux_sym_exceptions_repeat1] = STATE(11220),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9792] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9793] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9794] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9795] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9796] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9797] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9798] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [9799] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9800] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9801] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9802] = {
    [aux_sym_chained_string_repeat1] = STATE(9802),
    [sym_string] = STATE(9802),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9803] = {
    [sym_assignment] = STATE(7418),
    [sym_unary] = STATE(7418),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(7418),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(7418),
    [sym_conditional] = STATE(7418),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_return] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_true] = STATE(1998),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(7418),
    [sym_binary] = STATE(7418),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6825),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [sym_global_variable] = ACTIONS(3570),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(3562),
    [sym_character] = ACTIONS(3564),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [9804] = {
    [aux_sym_exceptions_repeat1] = STATE(11222),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15971),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [9805] = {
    [sym_assignment] = STATE(11223),
    [sym_unary] = STATE(11223),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1998),
    [sym_singleton_class] = STATE(1994),
    [sym_module] = STATE(1994),
    [sym_chained_string] = STATE(1994),
    [sym_until] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_for] = STATE(1994),
    [sym_symbol] = STATE(1994),
    [sym_if] = STATE(1994),
    [sym_begin] = STATE(1994),
    [sym__arg] = STATE(11223),
    [sym__primary] = STATE(1994),
    [sym_method_call] = STATE(1998),
    [sym_operator_assignment] = STATE(11223),
    [sym_conditional] = STATE(11223),
    [sym_method] = STATE(1994),
    [sym_singleton_method] = STATE(1994),
    [sym__variable] = STATE(1996),
    [sym_left_assignment_list] = STATE(1995),
    [sym_rational] = STATE(1994),
    [sym_true] = STATE(1998),
    [sym_return] = STATE(1994),
    [sym_subshell] = STATE(1994),
    [sym_yield] = STATE(1994),
    [sym_string] = STATE(4483),
    [sym_unless] = STATE(1994),
    [sym_lambda] = STATE(1994),
    [sym_parenthesized_statements] = STATE(1994),
    [sym_element_reference] = STATE(1998),
    [sym_range] = STATE(11223),
    [sym_binary] = STATE(11223),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1994),
    [sym_break] = STATE(1994),
    [sym_next] = STATE(1994),
    [sym_string_array] = STATE(1994),
    [sym_while] = STATE(1994),
    [sym_case] = STATE(1994),
    [sym_symbol_array] = STATE(1994),
    [sym_array] = STATE(1994),
    [sym_hash] = STATE(1994),
    [sym_false] = STATE(1998),
    [sym_nil] = STATE(1998),
    [sym_scope_resolution] = STATE(1996),
    [sym_call] = STATE(1996),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(3558),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3576),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(3566),
    [anon_sym_not] = ACTIONS(3580),
    [sym_self] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(3564),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(3564),
    [anon_sym_PLUS] = ACTIONS(7519),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(3570),
    [sym_character] = ACTIONS(3564),
    [sym_super] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(3586),
    [anon_sym_next] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(3558),
    [sym_constant] = ACTIONS(3562),
    [anon_sym_defined_QMARK] = ACTIONS(3572),
    [sym_instance_variable] = ACTIONS(3570),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(3562),
    [sym_redo] = ACTIONS(3558),
    [sym_class_variable] = ACTIONS(3570),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(3560),
  },
  [9806] = {
    [anon_sym_LT] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(3600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3606),
    [anon_sym_LT_LT] = ACTIONS(3604),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3612),
    [anon_sym_GT] = ACTIONS(3596),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [sym__binary_star] = ACTIONS(3598),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(3614),
    [anon_sym_BANG_TILDE] = ACTIONS(3602),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(3602),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(3616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3598),
    [anon_sym_PIPE] = ACTIONS(3620),
    [anon_sym_DOT_DOT] = ACTIONS(3618),
    [anon_sym_AMP_AMP] = ACTIONS(3602),
    [anon_sym_LT_EQ_GT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(3622),
    [sym__binary_minus] = ACTIONS(3610),
  },
  [9807] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9808] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9809] = {
    [sym_assignment] = STATE(7446),
    [sym_unary] = STATE(7446),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(7446),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(7446),
    [sym_conditional] = STATE(7446),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_return] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_true] = STATE(2040),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(7446),
    [sym_binary] = STATE(7446),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [sym_global_variable] = ACTIONS(155),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(147),
    [sym_character] = ACTIONS(149),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [9810] = {
    [aux_sym_exceptions_repeat1] = STATE(11224),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9811] = {
    [sym_assignment] = STATE(11225),
    [sym_unary] = STATE(11225),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2040),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(11225),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2040),
    [sym_operator_assignment] = STATE(11225),
    [sym_conditional] = STATE(11225),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2042),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2040),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2040),
    [sym_range] = STATE(11225),
    [sym_binary] = STATE(11225),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2040),
    [sym_nil] = STATE(2040),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3648),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3654),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [9812] = {
    [aux_sym_exceptions_repeat1] = STATE(9812),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(15975),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [9813] = {
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(3670),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(3674),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3676),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3678),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(3678),
    [anon_sym_AMP] = ACTIONS(3680),
    [anon_sym_GT] = ACTIONS(3668),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(3684),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(3678),
    [anon_sym_PIPE_PIPE] = ACTIONS(3678),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(3678),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3688),
    [anon_sym_DOT_DOT] = ACTIONS(3690),
    [anon_sym_AMP_AMP] = ACTIONS(3678),
    [anon_sym_LT_EQ_GT] = ACTIONS(3678),
    [anon_sym_LT_EQ] = ACTIONS(3668),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(3692),
    [sym__binary_minus] = ACTIONS(3682),
  },
  [9814] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9736),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [9815] = {
    [aux_sym_undef_repeat1] = STATE(9815),
    [sym__line_break] = ACTIONS(7428),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_else] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
  },
  [9816] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [9817] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [9818] = {
    [sym_assignment] = STATE(11226),
    [sym_unary] = STATE(11226),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(11226),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(11226),
    [sym_conditional] = STATE(11226),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(11226),
    [sym_binary] = STATE(11226),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [9819] = {
    [sym_assignment] = STATE(11227),
    [sym_unary] = STATE(11227),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(11227),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(11227),
    [sym_conditional] = STATE(11227),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(11227),
    [sym_binary] = STATE(11227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [9820] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9821] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9822] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9823] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_heredoc_body] = STATE(11228),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym_float] = ACTIONS(7658),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7662),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7670),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7682),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15978),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [9824] = {
    [sym_heredoc_body] = STATE(11229),
    [aux_sym_call_repeat1] = STATE(11229),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9825] = {
    [sym_heredoc_body] = STATE(11230),
    [aux_sym_call_repeat1] = STATE(11230),
    [aux_sym_argument_list_repeat1] = STATE(11231),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14451),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9826] = {
    [sym_heredoc_body] = STATE(11232),
    [aux_sym_call_repeat1] = STATE(11232),
    [aux_sym_argument_list_repeat1] = STATE(11233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(11715),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9827] = {
    [sym_heredoc_body] = STATE(11232),
    [aux_sym_call_repeat1] = STATE(11232),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [9828] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9829] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [9830] = {
    [sym_assignment] = STATE(11234),
    [sym_unary] = STATE(11234),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11234),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11234),
    [sym_conditional] = STATE(11234),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11234),
    [sym_binary] = STATE(11234),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9831] = {
    [sym_assignment] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_splat_argument] = STATE(11236),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_return] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_subshell] = STATE(2083),
    [sym__arg_or_splat_arg] = STATE(11236),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3716),
    [sym_character] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9832] = {
    [sym_assignment] = STATE(11237),
    [sym_unary] = STATE(11237),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11237),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11237),
    [sym_conditional] = STATE(11237),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11237),
    [sym_binary] = STATE(11237),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9833] = {
    [sym_assignment] = STATE(11238),
    [sym_unary] = STATE(11238),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11238),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11238),
    [sym_conditional] = STATE(11238),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11238),
    [sym_binary] = STATE(11238),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9834] = {
    [sym_assignment] = STATE(11240),
    [sym_unary] = STATE(11240),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11240),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11240),
    [sym_conditional] = STATE(11240),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11240),
    [sym_binary] = STATE(11240),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9835] = {
    [sym_assignment] = STATE(11241),
    [sym_unary] = STATE(11241),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11241),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11241),
    [sym_conditional] = STATE(11241),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11241),
    [sym_binary] = STATE(11241),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9836] = {
    [sym_assignment] = STATE(11242),
    [sym_unary] = STATE(11242),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11242),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11242),
    [sym_conditional] = STATE(11242),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11242),
    [sym_binary] = STATE(11242),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9837] = {
    [sym_assignment] = STATE(11243),
    [sym_unary] = STATE(11243),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11243),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11243),
    [sym_conditional] = STATE(11243),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11243),
    [sym_binary] = STATE(11243),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9838] = {
    [sym_assignment] = STATE(11244),
    [sym_unary] = STATE(11244),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11244),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11244),
    [sym_conditional] = STATE(11244),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11244),
    [sym_binary] = STATE(11244),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9839] = {
    [sym_assignment] = STATE(11245),
    [sym_unary] = STATE(11245),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11245),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11245),
    [sym_conditional] = STATE(11245),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11245),
    [sym_binary] = STATE(11245),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9840] = {
    [sym_assignment] = STATE(11246),
    [sym_unary] = STATE(11246),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11246),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(11246),
    [sym_conditional] = STATE(11246),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11246),
    [sym_binary] = STATE(11246),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9841] = {
    [aux_sym_chained_string_repeat1] = STATE(11247),
    [sym_string] = STATE(11247),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [9842] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(4608),
    [sym_unary] = STATE(4608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(4608),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(4608),
    [sym_conditional] = STATE(4608),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(4612),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(4608),
    [sym_binary] = STATE(4608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym_float] = ACTIONS(7658),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7662),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(7668),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(7676),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(7680),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7682),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14487),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [9843] = {
    [sym_heredoc_body] = STATE(9843),
    [aux_sym_call_repeat1] = STATE(9843),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9844] = {
    [sym_heredoc_body] = STATE(9843),
    [aux_sym_call_repeat1] = STATE(9843),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9845] = {
    [aux_sym_argument_list_repeat1] = STATE(9845),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15980),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9846] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9847] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9848] = {
    [aux_sym_exceptions_repeat1] = STATE(11249),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9849] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9850] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9851] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9852] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9853] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9854] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9855] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9856] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9857] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9858] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [9859] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9860] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11252),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(15985),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9861] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9862] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9863] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9862),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11253),
    [sym_operator] = STATE(11253),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_SLASH] = ACTIONS(14491),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14491),
    [anon_sym_PLUS_AT] = ACTIONS(14491),
    [anon_sym_LPAREN2] = ACTIONS(14493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14491),
    [anon_sym_GT_GT] = ACTIONS(14491),
    [anon_sym_EQ_TILDE] = ACTIONS(14491),
    [anon_sym_LT_LT] = ACTIONS(14491),
    [anon_sym_TILDE] = ACTIONS(14491),
    [anon_sym_PLUS] = ACTIONS(14489),
    [anon_sym_AMP] = ACTIONS(14491),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_PERCENT] = ACTIONS(14491),
    [anon_sym_DASH_AT] = ACTIONS(14491),
    [anon_sym_EQ_EQ] = ACTIONS(14489),
    [anon_sym_STAR] = ACTIONS(14489),
    [anon_sym_BANG_TILDE] = ACTIONS(14491),
    [sym_constant] = ACTIONS(15987),
    [anon_sym_DASH] = ACTIONS(14489),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14489),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14491),
    [anon_sym_STAR_STAR] = ACTIONS(14491),
    [anon_sym_PIPE] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14491),
    [anon_sym_LT_EQ_GT] = ACTIONS(14491),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_BANG] = ACTIONS(14489),
    [sym_identifier] = ACTIONS(15987),
    [anon_sym_CARET] = ACTIONS(14491),
  },
  [9864] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9865] = {
    [sym_assignment] = STATE(11254),
    [sym_unary] = STATE(11254),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(11254),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(11254),
    [sym_conditional] = STATE(11254),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(11254),
    [sym_binary] = STATE(11254),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [9866] = {
    [sym_assignment] = STATE(11255),
    [sym_unary] = STATE(11255),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(11255),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(11255),
    [sym_conditional] = STATE(11255),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(11255),
    [sym_binary] = STATE(11255),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [9867] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9868] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9869] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9870] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_heredoc_body] = STATE(11256),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym_float] = ACTIONS(7716),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7720),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7720),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7728),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [sym_class_variable] = ACTIONS(7728),
    [sym__block_ampersand] = ACTIONS(11757),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7738),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15989),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [9871] = {
    [sym_heredoc_body] = STATE(11257),
    [aux_sym_call_repeat1] = STATE(11257),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9872] = {
    [sym_heredoc_body] = STATE(11258),
    [aux_sym_call_repeat1] = STATE(11258),
    [aux_sym_argument_list_repeat1] = STATE(11259),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(14503),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [9873] = {
    [aux_sym_chained_string_repeat1] = STATE(9873),
    [sym_string] = STATE(9873),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9874] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [9875] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9876] = {
    [anon_sym_RPAREN] = ACTIONS(15991),
    [sym_comment] = ACTIONS(49),
  },
  [9877] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9878] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [9879] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [9880] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [9881] = {
    [sym_assignment] = STATE(11261),
    [sym_unary] = STATE(11261),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11261),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11261),
    [sym_conditional] = STATE(11261),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11261),
    [sym_binary] = STATE(11261),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9882] = {
    [sym_assignment] = STATE(7544),
    [sym_unary] = STATE(7544),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7544),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_splat_argument] = STATE(11262),
    [sym_operator_assignment] = STATE(7544),
    [sym_conditional] = STATE(7544),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_return] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_subshell] = STATE(2083),
    [sym__arg_or_splat_arg] = STATE(11262),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(7544),
    [sym_binary] = STATE(7544),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11783),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3716),
    [sym_character] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9883] = {
    [sym_assignment] = STATE(11263),
    [sym_unary] = STATE(11263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11263),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11263),
    [sym_conditional] = STATE(11263),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11263),
    [sym_binary] = STATE(11263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9884] = {
    [sym_assignment] = STATE(11264),
    [sym_unary] = STATE(11264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11264),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11264),
    [sym_conditional] = STATE(11264),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11264),
    [sym_binary] = STATE(11264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9885] = {
    [sym_assignment] = STATE(11266),
    [sym_unary] = STATE(11266),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11266),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11266),
    [sym_conditional] = STATE(11266),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11266),
    [sym_binary] = STATE(11266),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9886] = {
    [sym_assignment] = STATE(11267),
    [sym_unary] = STATE(11267),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11267),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11267),
    [sym_conditional] = STATE(11267),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11267),
    [sym_binary] = STATE(11267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9887] = {
    [sym_assignment] = STATE(11268),
    [sym_unary] = STATE(11268),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11268),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11268),
    [sym_conditional] = STATE(11268),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11268),
    [sym_binary] = STATE(11268),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9888] = {
    [sym_assignment] = STATE(11269),
    [sym_unary] = STATE(11269),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11269),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11269),
    [sym_conditional] = STATE(11269),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11269),
    [sym_binary] = STATE(11269),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9889] = {
    [sym_assignment] = STATE(11270),
    [sym_unary] = STATE(11270),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11270),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11270),
    [sym_conditional] = STATE(11270),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11270),
    [sym_binary] = STATE(11270),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9890] = {
    [sym_assignment] = STATE(11271),
    [sym_unary] = STATE(11271),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11271),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11271),
    [sym_conditional] = STATE(11271),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11271),
    [sym_binary] = STATE(11271),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9891] = {
    [sym_assignment] = STATE(11272),
    [sym_unary] = STATE(11272),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11272),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(11272),
    [sym_conditional] = STATE(11272),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(11272),
    [sym_binary] = STATE(11272),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9892] = {
    [sym_assignment] = STATE(7544),
    [sym_unary] = STATE(7544),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(7544),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(7544),
    [sym_conditional] = STATE(7544),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_return] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_true] = STATE(7543),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(7544),
    [sym_binary] = STATE(7544),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(11783),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3716),
    [sym_character] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [9893] = {
    [aux_sym_exceptions_repeat1] = STATE(11273),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(14545),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9894] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [9895] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [9896] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [9897] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [9898] = {
    [sym_assignment] = STATE(11274),
    [sym_unary] = STATE(11274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11274),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11274),
    [sym_conditional] = STATE(11274),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11274),
    [sym_binary] = STATE(11274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9899] = {
    [sym_assignment] = STATE(11275),
    [sym_unary] = STATE(11275),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11275),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_splat_argument] = STATE(11276),
    [sym_operator_assignment] = STATE(11275),
    [sym_conditional] = STATE(11275),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_return] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_subshell] = STATE(7561),
    [sym__arg_or_splat_arg] = STATE(11276),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11275),
    [sym_binary] = STATE(11275),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [sym_global_variable] = ACTIONS(11813),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11805),
    [sym_character] = ACTIONS(11809),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9900] = {
    [sym_assignment] = STATE(11277),
    [sym_unary] = STATE(11277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11277),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11277),
    [sym_conditional] = STATE(11277),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11277),
    [sym_binary] = STATE(11277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9901] = {
    [sym_assignment] = STATE(11278),
    [sym_unary] = STATE(11278),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11278),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11278),
    [sym_conditional] = STATE(11278),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11278),
    [sym_binary] = STATE(11278),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9902] = {
    [sym_assignment] = STATE(11280),
    [sym_unary] = STATE(11280),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11280),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11280),
    [sym_conditional] = STATE(11280),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11280),
    [sym_binary] = STATE(11280),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9903] = {
    [sym_assignment] = STATE(11281),
    [sym_unary] = STATE(11281),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11281),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11281),
    [sym_conditional] = STATE(11281),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11281),
    [sym_binary] = STATE(11281),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [9904] = {
    [sym_assignment] = STATE(11282),
    [sym_unary] = STATE(11282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11282),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11282),
    [sym_conditional] = STATE(11282),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11282),
    [sym_binary] = STATE(11282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9905] = {
    [sym_assignment] = STATE(11283),
    [sym_unary] = STATE(11283),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11283),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11283),
    [sym_conditional] = STATE(11283),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11283),
    [sym_binary] = STATE(11283),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9906] = {
    [sym_assignment] = STATE(11284),
    [sym_unary] = STATE(11284),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11284),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11284),
    [sym_conditional] = STATE(11284),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11284),
    [sym_binary] = STATE(11284),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9907] = {
    [sym_assignment] = STATE(11285),
    [sym_unary] = STATE(11285),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11285),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11285),
    [sym_conditional] = STATE(11285),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11285),
    [sym_binary] = STATE(11285),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9908] = {
    [sym_assignment] = STATE(11286),
    [sym_unary] = STATE(11286),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11286),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(11286),
    [sym_conditional] = STATE(11286),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11286),
    [sym_binary] = STATE(11286),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [9909] = {
    [aux_sym_chained_string_repeat1] = STATE(11287),
    [sym_string] = STATE(11287),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [9910] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9911] = {
    [aux_sym_exceptions_repeat1] = STATE(11289),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [9912] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(4642),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym_float] = ACTIONS(7716),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7720),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7720),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(7726),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(7732),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_yield] = ACTIONS(7734),
    [sym_class_variable] = ACTIONS(7728),
    [sym__block_ampersand] = ACTIONS(7736),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7738),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(14581),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [9913] = {
    [sym_heredoc_body] = STATE(9913),
    [aux_sym_call_repeat1] = STATE(9913),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9914] = {
    [sym_heredoc_body] = STATE(9913),
    [aux_sym_call_repeat1] = STATE(9913),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9915] = {
    [aux_sym_argument_list_repeat1] = STATE(9915),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(15993),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9916] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9917] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9918] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9919] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(15996),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9920] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9921] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9922] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9923] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [9924] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9925] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9926] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [9927] = {
    [aux_sym_chained_string_repeat1] = STATE(9927),
    [sym_string] = STATE(9927),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [9928] = {
    [sym_assignment] = STATE(11291),
    [sym_unary] = STATE(11291),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11291),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(11291),
    [sym_conditional] = STATE(11291),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(2084),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym_range] = STATE(11291),
    [sym_binary] = STATE(11291),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(2086),
    [sym_nil] = STATE(2086),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3732),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_not] = ACTIONS(3734),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [9929] = {
    [sym_assignment] = STATE(11292),
    [sym_unary] = STATE(11292),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2111),
    [sym_singleton_class] = STATE(84),
    [sym_module] = STATE(84),
    [sym_chained_string] = STATE(84),
    [sym_until] = STATE(84),
    [sym_regex] = STATE(84),
    [sym_for] = STATE(84),
    [sym_symbol] = STATE(84),
    [sym_if] = STATE(84),
    [sym_begin] = STATE(84),
    [sym__arg] = STATE(11292),
    [sym__primary] = STATE(84),
    [sym_method_call] = STATE(2111),
    [sym_operator_assignment] = STATE(11292),
    [sym_conditional] = STATE(11292),
    [sym_method] = STATE(84),
    [sym_singleton_method] = STATE(84),
    [sym__variable] = STATE(86),
    [sym_left_assignment_list] = STATE(2113),
    [sym_rational] = STATE(84),
    [sym_true] = STATE(2111),
    [sym_return] = STATE(84),
    [sym_subshell] = STATE(84),
    [sym_yield] = STATE(84),
    [sym_string] = STATE(2043),
    [sym_unless] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_parenthesized_statements] = STATE(84),
    [sym_element_reference] = STATE(2111),
    [sym_range] = STATE(11292),
    [sym_binary] = STATE(11292),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(84),
    [sym_break] = STATE(84),
    [sym_next] = STATE(84),
    [sym_string_array] = STATE(84),
    [sym_while] = STATE(84),
    [sym_case] = STATE(84),
    [sym_symbol_array] = STATE(84),
    [sym_array] = STATE(84),
    [sym_hash] = STATE(84),
    [sym_false] = STATE(2111),
    [sym_nil] = STATE(2111),
    [sym_scope_resolution] = STATE(86),
    [sym_call] = STATE(86),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(143),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_not] = ACTIONS(3770),
    [sym_self] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(149),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(155),
    [sym_character] = ACTIONS(149),
    [sym_super] = ACTIONS(147),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(3776),
    [anon_sym_next] = ACTIONS(3656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(143),
    [sym_constant] = ACTIONS(147),
    [anon_sym_defined_QMARK] = ACTIONS(3778),
    [sym_instance_variable] = ACTIONS(155),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(147),
    [sym_redo] = ACTIONS(143),
    [sym_class_variable] = ACTIONS(155),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3660),
  },
  [9930] = {
    [sym_assignment] = STATE(7610),
    [sym_unary] = STATE(7610),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(7610),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(7610),
    [sym_conditional] = STATE(7610),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_return] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_true] = STATE(2127),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(7610),
    [sym_binary] = STATE(7610),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [sym_global_variable] = ACTIONS(3802),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3794),
    [sym_character] = ACTIONS(3798),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [9931] = {
    [aux_sym_exceptions_repeat1] = STATE(11293),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15998),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [9932] = {
    [sym_assignment] = STATE(11294),
    [sym_unary] = STATE(11294),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2127),
    [sym_singleton_class] = STATE(2129),
    [sym_module] = STATE(2129),
    [sym_chained_string] = STATE(2129),
    [sym_until] = STATE(2129),
    [sym_regex] = STATE(2129),
    [sym_for] = STATE(2129),
    [sym_symbol] = STATE(2129),
    [sym_if] = STATE(2129),
    [sym_begin] = STATE(2129),
    [sym__arg] = STATE(11294),
    [sym__primary] = STATE(2129),
    [sym_method_call] = STATE(2127),
    [sym_operator_assignment] = STATE(11294),
    [sym_conditional] = STATE(11294),
    [sym_method] = STATE(2129),
    [sym_singleton_method] = STATE(2129),
    [sym__variable] = STATE(2130),
    [sym_left_assignment_list] = STATE(2131),
    [sym_rational] = STATE(2129),
    [sym_true] = STATE(2127),
    [sym_return] = STATE(2129),
    [sym_subshell] = STATE(2129),
    [sym_yield] = STATE(2129),
    [sym_string] = STATE(2132),
    [sym_unless] = STATE(2129),
    [sym_lambda] = STATE(2129),
    [sym_parenthesized_statements] = STATE(2129),
    [sym_element_reference] = STATE(2127),
    [sym_range] = STATE(11294),
    [sym_binary] = STATE(11294),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2129),
    [sym_break] = STATE(2129),
    [sym_next] = STATE(2129),
    [sym_string_array] = STATE(2129),
    [sym_while] = STATE(2129),
    [sym_case] = STATE(2129),
    [sym_symbol_array] = STATE(2129),
    [sym_array] = STATE(2129),
    [sym_hash] = STATE(2129),
    [sym_false] = STATE(2127),
    [sym_nil] = STATE(2127),
    [sym_scope_resolution] = STATE(2130),
    [sym_call] = STATE(2130),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(3786),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_not] = ACTIONS(3792),
    [sym_self] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(3798),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3802),
    [sym_character] = ACTIONS(3798),
    [sym_super] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(3804),
    [anon_sym_next] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(3786),
    [sym_constant] = ACTIONS(3794),
    [anon_sym_defined_QMARK] = ACTIONS(3808),
    [sym_instance_variable] = ACTIONS(3802),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3794),
    [sym_redo] = ACTIONS(3786),
    [sym_class_variable] = ACTIONS(3802),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3810),
  },
  [9933] = {
    [aux_sym_exceptions_repeat1] = STATE(9933),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16000),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [9934] = {
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_TILDE] = ACTIONS(3822),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [sym__binary_star] = ACTIONS(3826),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(3834),
    [anon_sym_DOT_DOT] = ACTIONS(3836),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(3838),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3840),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(3842),
    [anon_sym_GT_EQ] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_STAR_STAR] = ACTIONS(3820),
    [anon_sym_LT_EQ_GT] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3842),
    [sym__binary_minus] = ACTIONS(3846),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(3834),
  },
  [9935] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_COLON2] = ACTIONS(11543),
    [anon_sym_while] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
    [sym__binary_minus] = ACTIONS(11545),
  },
  [9936] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
    [sym__binary_minus] = ACTIONS(11868),
  },
  [9937] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_COLON2] = ACTIONS(11877),
    [anon_sym_while] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
    [sym__binary_minus] = ACTIONS(11879),
  },
  [9938] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16003),
  },
  [9939] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
    [sym__binary_minus] = ACTIONS(12166),
  },
  [9940] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_COLON2] = ACTIONS(12630),
    [anon_sym_while] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
    [sym__binary_minus] = ACTIONS(12632),
  },
  [9941] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_COLON2] = ACTIONS(12795),
    [anon_sym_while] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
    [sym__binary_minus] = ACTIONS(12797),
  },
  [9942] = {
    [anon_sym_end] = ACTIONS(16005),
    [sym_comment] = ACTIONS(49),
  },
  [9943] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_while] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
  },
  [9944] = {
    [anon_sym_end] = ACTIONS(16007),
    [sym_comment] = ACTIONS(49),
  },
  [9945] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11298),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16009),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [9946] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_while] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
  },
  [9947] = {
    [sym__method_name] = STATE(2195),
    [sym_setter] = STATE(2195),
    [sym_symbol] = STATE(2195),
    [sym_operator] = STATE(2195),
    [sym__method_rest] = STATE(11299),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(11923),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(11923),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(11923),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(11923),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [9948] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [9949] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [9950] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(4763),
    [sym_unary] = STATE(4763),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(4763),
    [sym__primary] = STATE(2215),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(4763),
    [sym_conditional] = STATE(4763),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4764),
    [sym_rational] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(4763),
    [sym_binary] = STATE(4763),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym_float] = ACTIONS(3894),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(3898),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(3898),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3900),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(7934),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(3906),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(7936),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(3914),
    [sym_class_variable] = ACTIONS(3906),
    [sym__block_ampersand] = ACTIONS(7938),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(3918),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [sym_retry] = ACTIONS(3894),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14625),
    [sym_redo] = ACTIONS(3894),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [9951] = {
    [sym_heredoc_body] = STATE(9951),
    [aux_sym_call_repeat1] = STATE(9951),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [9952] = {
    [sym_heredoc_body] = STATE(9951),
    [aux_sym_call_repeat1] = STATE(9951),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [9953] = {
    [aux_sym_argument_list_repeat1] = STATE(9953),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16011),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [9954] = {
    [sym_heredoc_body] = STATE(11300),
    [aux_sym_call_repeat1] = STATE(11300),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9955] = {
    [sym_heredoc_body] = STATE(11301),
    [aux_sym_call_repeat1] = STATE(11301),
    [aux_sym_argument_list_repeat1] = STATE(7691),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_RBRACE] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [9956] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9957] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9958] = {
    [aux_sym_exceptions_repeat1] = STATE(11303),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [9959] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9960] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9961] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9962] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9963] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16014),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [9964] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9965] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9966] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [9967] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9968] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [9969] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [9970] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11306),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(16016),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [9971] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [anon_sym_RBRACE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [9972] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [anon_sym_RBRACE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [9973] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(9972),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11307),
    [sym_operator] = STATE(11307),
    [anon_sym_LT] = ACTIONS(14627),
    [anon_sym_SLASH] = ACTIONS(14629),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(14629),
    [anon_sym_PLUS_AT] = ACTIONS(14629),
    [anon_sym_LPAREN2] = ACTIONS(14631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14629),
    [anon_sym_GT_GT] = ACTIONS(14629),
    [anon_sym_EQ_TILDE] = ACTIONS(14629),
    [anon_sym_LT_LT] = ACTIONS(14629),
    [anon_sym_TILDE] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14627),
    [anon_sym_AMP] = ACTIONS(14629),
    [anon_sym_GT] = ACTIONS(14627),
    [anon_sym_PERCENT] = ACTIONS(14629),
    [anon_sym_DASH_AT] = ACTIONS(14629),
    [anon_sym_EQ_EQ] = ACTIONS(14627),
    [anon_sym_STAR] = ACTIONS(14627),
    [anon_sym_BANG_TILDE] = ACTIONS(14629),
    [sym_constant] = ACTIONS(16018),
    [anon_sym_DASH] = ACTIONS(14627),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(14629),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(14627),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(14629),
    [anon_sym_STAR_STAR] = ACTIONS(14629),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_DOT_DOT] = ACTIONS(14629),
    [anon_sym_LT_EQ_GT] = ACTIONS(14629),
    [anon_sym_LT_EQ] = ACTIONS(14627),
    [anon_sym_BANG] = ACTIONS(14627),
    [sym_identifier] = ACTIONS(16018),
    [anon_sym_CARET] = ACTIONS(14629),
  },
  [9974] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [9975] = {
    [aux_sym_chained_string_repeat1] = STATE(9975),
    [sym_string] = STATE(9975),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [9976] = {
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_SLASH] = ACTIONS(8575),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_in] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(10412),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(8575),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(8575),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(8575),
    [anon_sym_COLON2] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_AMP_AMP] = ACTIONS(8575),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(8575),
    [sym__binary_minus] = ACTIONS(8575),
  },
  [9977] = {
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_SLASH] = ACTIONS(12375),
    [anon_sym_RBRACK] = ACTIONS(12375),
    [anon_sym_in] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_EQ] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(12375),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_PLUS] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_PERCENT] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(12375),
    [anon_sym_COLON2] = ACTIONS(13245),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(12375),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_AMP_AMP] = ACTIONS(12375),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(12375),
    [sym__binary_minus] = ACTIONS(12375),
  },
  [9978] = {
    [sym_assignment] = STATE(7693),
    [sym_unary] = STATE(7693),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(7693),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(7693),
    [sym_conditional] = STATE(7693),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_return] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_true] = STATE(2213),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(7693),
    [sym_binary] = STATE(7693),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(7940),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [sym_global_variable] = ACTIONS(3906),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(3898),
    [sym_character] = ACTIONS(3900),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [9979] = {
    [aux_sym_exceptions_repeat1] = STATE(11308),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16020),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [9980] = {
    [sym_assignment] = STATE(11309),
    [sym_unary] = STATE(11309),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2213),
    [sym_singleton_class] = STATE(2215),
    [sym_module] = STATE(2215),
    [sym_chained_string] = STATE(2215),
    [sym_until] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_for] = STATE(2215),
    [sym_symbol] = STATE(2215),
    [sym_if] = STATE(2215),
    [sym_begin] = STATE(2215),
    [sym__arg] = STATE(11309),
    [sym__primary] = STATE(2215),
    [sym_method_call] = STATE(2213),
    [sym_operator_assignment] = STATE(11309),
    [sym_conditional] = STATE(11309),
    [sym_method] = STATE(2215),
    [sym_singleton_method] = STATE(2215),
    [sym__variable] = STATE(2216),
    [sym_left_assignment_list] = STATE(2217),
    [sym_rational] = STATE(2215),
    [sym_true] = STATE(2213),
    [sym_return] = STATE(2215),
    [sym_subshell] = STATE(2215),
    [sym_yield] = STATE(2215),
    [sym_string] = STATE(4752),
    [sym_unless] = STATE(2215),
    [sym_lambda] = STATE(2215),
    [sym_parenthesized_statements] = STATE(2215),
    [sym_element_reference] = STATE(2213),
    [sym_range] = STATE(11309),
    [sym_binary] = STATE(11309),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2215),
    [sym_break] = STATE(2215),
    [sym_next] = STATE(2215),
    [sym_string_array] = STATE(2215),
    [sym_while] = STATE(2215),
    [sym_case] = STATE(2215),
    [sym_symbol_array] = STATE(2215),
    [sym_array] = STATE(2215),
    [sym_hash] = STATE(2215),
    [sym_false] = STATE(2213),
    [sym_nil] = STATE(2213),
    [sym_scope_resolution] = STATE(2216),
    [sym_call] = STATE(2216),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(3894),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(3902),
    [anon_sym_not] = ACTIONS(3918),
    [sym_self] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(3924),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3900),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(3900),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_TILDE] = ACTIONS(3902),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3906),
    [sym_character] = ACTIONS(3900),
    [sym_super] = ACTIONS(3898),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(3926),
    [anon_sym_next] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(3894),
    [sym_constant] = ACTIONS(3898),
    [anon_sym_defined_QMARK] = ACTIONS(3908),
    [sym_instance_variable] = ACTIONS(3906),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(3898),
    [sym_redo] = ACTIONS(3894),
    [sym_class_variable] = ACTIONS(3906),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(3896),
  },
  [9981] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [9982] = {
    [anon_sym_RPAREN] = ACTIONS(16022),
    [sym_comment] = ACTIONS(49),
  },
  [9983] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [9984] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [9985] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [9986] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(2276),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4808),
    [sym_rational] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym_float] = ACTIONS(3980),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(3984),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(3984),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8012),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [sym__identifier_hash_key] = ACTIONS(8014),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4002),
    [sym_class_variable] = ACTIONS(3994),
    [sym__block_ampersand] = ACTIONS(8016),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4006),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [sym_retry] = ACTIONS(3980),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14651),
    [sym_redo] = ACTIONS(3980),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [9987] = {
    [sym_heredoc_body] = STATE(9987),
    [aux_sym_call_repeat1] = STATE(9987),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [9988] = {
    [sym_heredoc_body] = STATE(9987),
    [aux_sym_call_repeat1] = STATE(9987),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [9989] = {
    [aux_sym_argument_list_repeat1] = STATE(9989),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16024),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [9990] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_COLON2] = ACTIONS(13274),
    [anon_sym_while] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
    [sym__binary_minus] = ACTIONS(13276),
  },
  [9991] = {
    [anon_sym_end] = ACTIONS(16027),
    [sym_comment] = ACTIONS(49),
  },
  [9992] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11312),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16027),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [9993] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_COLON2] = ACTIONS(13462),
    [anon_sym_while] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
    [sym__binary_minus] = ACTIONS(13464),
  },
  [9994] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_while] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
    [sym__binary_minus] = ACTIONS(13468),
  },
  [9995] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_COLON2] = ACTIONS(13737),
    [anon_sym_while] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
    [sym__binary_minus] = ACTIONS(13739),
  },
  [9996] = {
    [anon_sym_end] = ACTIONS(16029),
    [sym_comment] = ACTIONS(49),
  },
  [9997] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_COLON2] = ACTIONS(13952),
    [anon_sym_while] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
    [sym__binary_minus] = ACTIONS(13954),
  },
  [9998] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_COLON2] = ACTIONS(13956),
    [anon_sym_while] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
    [sym__binary_minus] = ACTIONS(13958),
  },
  [9999] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16031),
  },
  [10000] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_while] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
    [sym__binary_minus] = ACTIONS(13964),
  },
  [10001] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10002] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10003] = {
    [aux_sym_exceptions_repeat1] = STATE(7759),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10004] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10005] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10006] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10007] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10008] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16033),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10009] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10010] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10011] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10012] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10013] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [10014] = {
    [aux_sym_chained_string_repeat1] = STATE(10014),
    [sym_string] = STATE(10014),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [10015] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10016] = {
    [aux_sym_exceptions_repeat1] = STATE(10016),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16035),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10017] = {
    [anon_sym_SLASH] = ACTIONS(13017),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_while] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [10018] = {
    [anon_sym_SLASH] = ACTIONS(12903),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_while] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [10019] = {
    [anon_sym_end] = ACTIONS(16038),
    [sym_comment] = ACTIONS(49),
  },
  [10020] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11317),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16040),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10021] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11319),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16042),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10022] = {
    [sym_when] = STATE(11322),
    [sym_else] = STATE(11321),
    [aux_sym_case_repeat2] = STATE(11322),
    [aux_sym_case_repeat1] = STATE(11323),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16044),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(16046),
    [sym_comment] = ACTIONS(49),
  },
  [10023] = {
    [anon_sym_SLASH] = ACTIONS(5744),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_until] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_EQ_TILDE] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [sym__binary_star] = ACTIONS(5746),
    [anon_sym_unless] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_COLON_COLON2] = ACTIONS(5746),
    [anon_sym_rescue] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_BANG_TILDE] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_while] = ACTIONS(5746),
    [sym__heredoc_body_start] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_AMP_DOT] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_in] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5746),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_STAR_STAR] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5746),
    [sym__binary_minus] = ACTIONS(5746),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
  },
  [10024] = {
    [anon_sym_end] = ACTIONS(16044),
    [sym_comment] = ACTIONS(49),
  },
  [10025] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11321),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16044),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [10026] = {
    [sym_when] = STATE(11322),
    [sym_else] = STATE(11321),
    [aux_sym_case_repeat2] = STATE(11322),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16044),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [10027] = {
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6682),
    [anon_sym_until] = ACTIONS(6682),
    [anon_sym_AMP_EQ] = ACTIONS(6682),
    [anon_sym_GT_GT_EQ] = ACTIONS(6682),
    [anon_sym_SLASH_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6682),
    [anon_sym_RPAREN] = ACTIONS(6682),
    [anon_sym_EQ_TILDE] = ACTIONS(6682),
    [anon_sym_LT_LT] = ACTIONS(6680),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [sym__binary_star] = ACTIONS(6682),
    [anon_sym_unless] = ACTIONS(6682),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_PERCENT] = ACTIONS(6680),
    [anon_sym_COLON_COLON2] = ACTIONS(6682),
    [anon_sym_rescue] = ACTIONS(6682),
    [anon_sym_PERCENT_EQ] = ACTIONS(6682),
    [anon_sym_LT_LT_EQ] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_DOT] = ACTIONS(6680),
    [anon_sym_BANG_TILDE] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(6682),
    [anon_sym_COLON2] = ACTIONS(6680),
    [anon_sym_while] = ACTIONS(6682),
    [sym__heredoc_body_start] = ACTIONS(6682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6682),
    [anon_sym_CARET_EQ] = ACTIONS(6682),
    [anon_sym_AMP_DOT] = ACTIONS(6682),
    [anon_sym_LT_EQ] = ACTIONS(6680),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_in] = ACTIONS(6682),
    [anon_sym_QMARK] = ACTIONS(6682),
    [anon_sym_COMMA] = ACTIONS(6682),
    [anon_sym_GT_GT] = ACTIONS(6680),
    [anon_sym_SEMI] = ACTIONS(6682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6682),
    [anon_sym_or] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6680),
    [anon_sym_PIPE_EQ] = ACTIONS(6682),
    [anon_sym_PLUS_EQ] = ACTIONS(6682),
    [anon_sym_STAR_EQ] = ACTIONS(6682),
    [anon_sym_EQ_EQ] = ACTIONS(6680),
    [anon_sym_and] = ACTIONS(6682),
    [anon_sym_PIPE_PIPE] = ACTIONS(6680),
    [anon_sym_GT_EQ] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6682),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6682),
    [anon_sym_DASH_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6682),
    [anon_sym_BANG_EQ] = ACTIONS(6682),
    [anon_sym_STAR_STAR] = ACTIONS(6680),
    [anon_sym_LT_EQ_GT] = ACTIONS(6682),
    [sym__binary_minus] = ACTIONS(6682),
    [anon_sym_AMP_AMP] = ACTIONS(6680),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_CARET] = ACTIONS(6680),
  },
  [10028] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(16048),
  },
  [10029] = {
    [aux_sym_string_array_repeat1] = STATE(11327),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16050),
    [sym__string_end] = ACTIONS(16052),
  },
  [10030] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16054),
  },
  [10031] = {
    [anon_sym_SLASH] = ACTIONS(6692),
    [anon_sym_RBRACK] = ACTIONS(6694),
    [anon_sym_until] = ACTIONS(6694),
    [anon_sym_AMP_EQ] = ACTIONS(6694),
    [anon_sym_GT_GT_EQ] = ACTIONS(6694),
    [anon_sym_SLASH_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6694),
    [anon_sym_RPAREN] = ACTIONS(6694),
    [anon_sym_EQ_TILDE] = ACTIONS(6694),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [sym__binary_star] = ACTIONS(6694),
    [anon_sym_unless] = ACTIONS(6694),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_COLON_COLON2] = ACTIONS(6694),
    [anon_sym_rescue] = ACTIONS(6694),
    [anon_sym_PERCENT_EQ] = ACTIONS(6694),
    [anon_sym_LT_LT_EQ] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_BANG_TILDE] = ACTIONS(6694),
    [anon_sym_LBRACE] = ACTIONS(6694),
    [anon_sym_COLON2] = ACTIONS(6692),
    [anon_sym_while] = ACTIONS(6694),
    [sym__heredoc_body_start] = ACTIONS(6694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6694),
    [anon_sym_CARET_EQ] = ACTIONS(6694),
    [anon_sym_AMP_DOT] = ACTIONS(6694),
    [anon_sym_LT_EQ] = ACTIONS(6692),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_in] = ACTIONS(6694),
    [anon_sym_QMARK] = ACTIONS(6694),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_SEMI] = ACTIONS(6694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6694),
    [anon_sym_or] = ACTIONS(6694),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_PIPE_EQ] = ACTIONS(6694),
    [anon_sym_PLUS_EQ] = ACTIONS(6694),
    [anon_sym_STAR_EQ] = ACTIONS(6694),
    [anon_sym_EQ_EQ] = ACTIONS(6692),
    [anon_sym_and] = ACTIONS(6694),
    [anon_sym_PIPE_PIPE] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6694),
    [anon_sym_LBRACK] = ACTIONS(6694),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6694),
    [anon_sym_DASH_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6694),
    [anon_sym_BANG_EQ] = ACTIONS(6694),
    [anon_sym_STAR_STAR] = ACTIONS(6692),
    [anon_sym_LT_EQ_GT] = ACTIONS(6694),
    [sym__binary_minus] = ACTIONS(6694),
    [anon_sym_AMP_AMP] = ACTIONS(6692),
    [anon_sym_if] = ACTIONS(6694),
    [anon_sym_CARET] = ACTIONS(6692),
  },
  [10032] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16056),
    [sym__string_end] = ACTIONS(16054),
  },
  [10033] = {
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_until] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_EQ_TILDE] = ACTIONS(5628),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym__binary_star] = ACTIONS(5628),
    [anon_sym_unless] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_COLON_COLON2] = ACTIONS(5628),
    [anon_sym_rescue] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_COLON2] = ACTIONS(5626),
    [anon_sym_while] = ACTIONS(5628),
    [sym__heredoc_body_start] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_AMP_DOT] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_DOT_DOT] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_STAR_STAR] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [sym__binary_minus] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5626),
  },
  [10034] = {
    [anon_sym_SLASH] = ACTIONS(5972),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_until] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_LT_LT] = ACTIONS(5972),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [sym__binary_star] = ACTIONS(5974),
    [anon_sym_unless] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_rescue] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_COLON2] = ACTIONS(5972),
    [anon_sym_while] = ACTIONS(5974),
    [sym__heredoc_body_start] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_DOT_DOT] = ACTIONS(5972),
    [anon_sym_EQ] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_in] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_GT_GT] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5974),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE] = ACTIONS(5972),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR] = ACTIONS(5972),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [sym__binary_minus] = ACTIONS(5974),
    [anon_sym_AMP_AMP] = ACTIONS(5972),
    [anon_sym_if] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5972),
  },
  [10035] = {
    [sym__statement] = STATE(2082),
    [sym_unary] = STATE(2087),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(2082),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_unless_modifier] = STATE(2082),
    [sym_symbol] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym__primary] = STATE(2083),
    [sym_method] = STATE(2083),
    [sym_conditional] = STATE(2087),
    [sym_left_assignment_list] = STATE(2084),
    [sym_return] = STATE(2083),
    [sym_true] = STATE(2086),
    [sym_while_modifier] = STATE(2082),
    [sym_subshell] = STATE(2083),
    [sym_unless] = STATE(2083),
    [sym_empty_statement] = STATE(2090),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_begin_block] = STATE(2082),
    [sym_range] = STATE(2087),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(2086),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_call] = STATE(2085),
    [sym_end_block] = STATE(2082),
    [sym_assignment] = STATE(2087),
    [sym__lhs] = STATE(2086),
    [sym_singleton_class] = STATE(2083),
    [sym_alias] = STATE(2082),
    [sym_if_modifier] = STATE(2082),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(2087),
    [sym_method_call] = STATE(2086),
    [sym_operator_assignment] = STATE(2087),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_rational] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(2088),
    [sym_until_modifier] = STATE(2082),
    [sym_lambda] = STATE(2083),
    [sym_element_reference] = STATE(2086),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(2087),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_nil] = STATE(2086),
    [sym_rescue_modifier] = STATE(2082),
    [sym_symbol_array] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_else] = STATE(11331),
    [aux_sym__statements_repeat1] = STATE(2090),
    [sym_scope_resolution] = STATE(2085),
    [sym_float] = ACTIONS(3712),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(3714),
    [sym_self] = ACTIONS(3716),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(3720),
    [anon_sym_TILDE] = ACTIONS(3722),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(3716),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(3718),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(3724),
    [anon_sym_defined_QMARK] = ACTIONS(3726),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_yield] = ACTIONS(3732),
    [sym_class_variable] = ACTIONS(3724),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(3734),
    [anon_sym_then] = ACTIONS(3752),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(3738),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(3740),
    [anon_sym_next] = ACTIONS(3742),
    [sym_retry] = ACTIONS(3712),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16058),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(3744),
  },
  [10036] = {
    [sym_else] = STATE(11331),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_end] = ACTIONS(16060),
    [sym_comment] = ACTIONS(49),
  },
  [10037] = {
    [sym_heredoc_body] = STATE(11332),
    [sym__terminator] = STATE(11332),
    [sym__line_break] = ACTIONS(16062),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(16062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_or] = ACTIONS(2357),
    [sym__binary_star] = ACTIONS(2347),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2359),
    [anon_sym_GT] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(693),
    [anon_sym_GT_EQ] = ACTIONS(2365),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2369),
    [sym__binary_minus] = ACTIONS(2359),
    [anon_sym_STAR_STAR] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2371),
  },
  [10038] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11333),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16064),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [10039] = {
    [sym_heredoc_body] = STATE(11334),
    [sym__terminator] = STATE(11334),
    [sym__heredoc_body_start] = ACTIONS(693),
    [sym__line_break] = ACTIONS(16066),
    [anon_sym_SEMI] = ACTIONS(16066),
    [sym_comment] = ACTIONS(49),
  },
  [10040] = {
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_until] = ACTIONS(6077),
    [anon_sym_AMP_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT_EQ] = ACTIONS(6077),
    [anon_sym_SLASH_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_EQ_TILDE] = ACTIONS(6077),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [sym__binary_star] = ACTIONS(6077),
    [anon_sym_unless] = ACTIONS(6077),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6075),
    [anon_sym_COLON_COLON2] = ACTIONS(6077),
    [anon_sym_rescue] = ACTIONS(6077),
    [anon_sym_PERCENT_EQ] = ACTIONS(6077),
    [anon_sym_LT_LT_EQ] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_BANG_TILDE] = ACTIONS(6077),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_COLON2] = ACTIONS(6075),
    [anon_sym_while] = ACTIONS(6077),
    [sym__heredoc_body_start] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6077),
    [anon_sym_CARET_EQ] = ACTIONS(6077),
    [anon_sym_AMP_DOT] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_DOT_DOT] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_in] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6075),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_PLUS_EQ] = ACTIONS(6077),
    [anon_sym_STAR_EQ] = ACTIONS(6077),
    [anon_sym_EQ_EQ] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6077),
    [anon_sym_DASH_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_STAR_STAR] = ACTIONS(6075),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [sym__binary_minus] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6075),
    [anon_sym_if] = ACTIONS(6077),
    [anon_sym_CARET] = ACTIONS(6075),
  },
  [10041] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11335),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16068),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [10042] = {
    [anon_sym_SLASH] = ACTIONS(6443),
    [anon_sym_RBRACK] = ACTIONS(6445),
    [anon_sym_until] = ACTIONS(6445),
    [anon_sym_AMP_EQ] = ACTIONS(6445),
    [anon_sym_GT_GT_EQ] = ACTIONS(6445),
    [anon_sym_SLASH_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6445),
    [anon_sym_RPAREN] = ACTIONS(6445),
    [anon_sym_EQ_TILDE] = ACTIONS(6445),
    [anon_sym_LT_LT] = ACTIONS(6443),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [sym__binary_star] = ACTIONS(6445),
    [anon_sym_unless] = ACTIONS(6445),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_AMP] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_COLON_COLON2] = ACTIONS(6445),
    [anon_sym_rescue] = ACTIONS(6445),
    [anon_sym_PERCENT_EQ] = ACTIONS(6445),
    [anon_sym_LT_LT_EQ] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_DOT] = ACTIONS(6443),
    [anon_sym_BANG_TILDE] = ACTIONS(6445),
    [anon_sym_LBRACE] = ACTIONS(6445),
    [anon_sym_COLON2] = ACTIONS(6443),
    [anon_sym_while] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6445),
    [anon_sym_CARET_EQ] = ACTIONS(6445),
    [anon_sym_AMP_DOT] = ACTIONS(6445),
    [anon_sym_LT_EQ] = ACTIONS(6443),
    [anon_sym_PIPE] = ACTIONS(6443),
    [anon_sym_DOT_DOT] = ACTIONS(6443),
    [anon_sym_EQ] = ACTIONS(6443),
    [anon_sym_LT] = ACTIONS(6443),
    [anon_sym_in] = ACTIONS(6445),
    [anon_sym_QMARK] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(6445),
    [anon_sym_GT_GT] = ACTIONS(6443),
    [anon_sym_SEMI] = ACTIONS(6445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6445),
    [anon_sym_or] = ACTIONS(6445),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_PIPE_EQ] = ACTIONS(6445),
    [anon_sym_PLUS_EQ] = ACTIONS(6445),
    [anon_sym_STAR_EQ] = ACTIONS(6445),
    [anon_sym_EQ_EQ] = ACTIONS(6443),
    [anon_sym_and] = ACTIONS(6445),
    [anon_sym_PIPE_PIPE] = ACTIONS(6443),
    [anon_sym_GT_EQ] = ACTIONS(6445),
    [anon_sym_LBRACK] = ACTIONS(6445),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6445),
    [anon_sym_DASH_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6445),
    [anon_sym_BANG_EQ] = ACTIONS(6445),
    [anon_sym_STAR_STAR] = ACTIONS(6443),
    [anon_sym_LT_EQ_GT] = ACTIONS(6445),
    [sym__binary_minus] = ACTIONS(6445),
    [anon_sym_AMP_AMP] = ACTIONS(6443),
    [anon_sym_if] = ACTIONS(6445),
    [anon_sym_CARET] = ACTIONS(6443),
  },
  [10043] = {
    [anon_sym_end] = ACTIONS(16070),
    [sym_comment] = ACTIONS(49),
  },
  [10044] = {
    [sym_ensure] = STATE(11337),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(16070),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [10045] = {
    [anon_sym_SLASH] = ACTIONS(6471),
    [anon_sym_RBRACK] = ACTIONS(6473),
    [anon_sym_until] = ACTIONS(6473),
    [anon_sym_AMP_EQ] = ACTIONS(6473),
    [anon_sym_GT_GT_EQ] = ACTIONS(6473),
    [anon_sym_SLASH_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6473),
    [anon_sym_RPAREN] = ACTIONS(6473),
    [anon_sym_EQ_TILDE] = ACTIONS(6473),
    [anon_sym_LT_LT] = ACTIONS(6471),
    [anon_sym_RBRACE] = ACTIONS(6473),
    [sym__binary_star] = ACTIONS(6473),
    [anon_sym_unless] = ACTIONS(6473),
    [anon_sym_PLUS] = ACTIONS(6471),
    [anon_sym_AMP] = ACTIONS(6471),
    [anon_sym_PERCENT] = ACTIONS(6471),
    [anon_sym_COLON_COLON2] = ACTIONS(6473),
    [anon_sym_rescue] = ACTIONS(6473),
    [anon_sym_PERCENT_EQ] = ACTIONS(6473),
    [anon_sym_LT_LT_EQ] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_DOT] = ACTIONS(6471),
    [anon_sym_BANG_TILDE] = ACTIONS(6473),
    [anon_sym_LBRACE] = ACTIONS(6473),
    [anon_sym_COLON2] = ACTIONS(6471),
    [anon_sym_while] = ACTIONS(6473),
    [sym__heredoc_body_start] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6473),
    [anon_sym_CARET_EQ] = ACTIONS(6473),
    [anon_sym_AMP_DOT] = ACTIONS(6473),
    [anon_sym_LT_EQ] = ACTIONS(6471),
    [anon_sym_PIPE] = ACTIONS(6471),
    [anon_sym_DOT_DOT] = ACTIONS(6471),
    [anon_sym_EQ] = ACTIONS(6471),
    [anon_sym_LT] = ACTIONS(6471),
    [anon_sym_in] = ACTIONS(6473),
    [anon_sym_QMARK] = ACTIONS(6473),
    [anon_sym_COMMA] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6471),
    [anon_sym_SEMI] = ACTIONS(6473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6473),
    [anon_sym_or] = ACTIONS(6473),
    [anon_sym_GT] = ACTIONS(6471),
    [anon_sym_PIPE_EQ] = ACTIONS(6473),
    [anon_sym_PLUS_EQ] = ACTIONS(6473),
    [anon_sym_STAR_EQ] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_and] = ACTIONS(6473),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_GT_EQ] = ACTIONS(6473),
    [anon_sym_LBRACK] = ACTIONS(6473),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6473),
    [anon_sym_DASH_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6473),
    [anon_sym_BANG_EQ] = ACTIONS(6473),
    [anon_sym_STAR_STAR] = ACTIONS(6471),
    [anon_sym_LT_EQ_GT] = ACTIONS(6473),
    [sym__binary_minus] = ACTIONS(6473),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_if] = ACTIONS(6473),
    [anon_sym_CARET] = ACTIONS(6471),
  },
  [10046] = {
    [sym_ensure] = STATE(11337),
    [sym_else] = STATE(11338),
    [anon_sym_end] = ACTIONS(16070),
    [anon_sym_ensure] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2735),
    [sym_comment] = ACTIONS(49),
  },
  [10047] = {
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6073),
    [anon_sym_until] = ACTIONS(6073),
    [anon_sym_AMP_EQ] = ACTIONS(6073),
    [anon_sym_GT_GT_EQ] = ACTIONS(6073),
    [anon_sym_SLASH_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6073),
    [anon_sym_RPAREN] = ACTIONS(6073),
    [anon_sym_EQ_TILDE] = ACTIONS(6073),
    [anon_sym_LT_LT] = ACTIONS(6071),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [sym__binary_star] = ACTIONS(6073),
    [anon_sym_unless] = ACTIONS(6073),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_COLON_COLON2] = ACTIONS(6073),
    [anon_sym_rescue] = ACTIONS(6073),
    [anon_sym_PERCENT_EQ] = ACTIONS(6073),
    [anon_sym_LT_LT_EQ] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_DOT] = ACTIONS(6071),
    [anon_sym_BANG_TILDE] = ACTIONS(6073),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_COLON2] = ACTIONS(6071),
    [anon_sym_while] = ACTIONS(6073),
    [sym__heredoc_body_start] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6073),
    [anon_sym_CARET_EQ] = ACTIONS(6073),
    [anon_sym_AMP_DOT] = ACTIONS(6073),
    [anon_sym_LT_EQ] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6071),
    [anon_sym_DOT_DOT] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6071),
    [anon_sym_in] = ACTIONS(6073),
    [anon_sym_QMARK] = ACTIONS(6073),
    [anon_sym_COMMA] = ACTIONS(6073),
    [anon_sym_GT_GT] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6073),
    [anon_sym_or] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6071),
    [anon_sym_PIPE_EQ] = ACTIONS(6073),
    [anon_sym_PLUS_EQ] = ACTIONS(6073),
    [anon_sym_STAR_EQ] = ACTIONS(6073),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6073),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_GT_EQ] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6073),
    [anon_sym_DASH_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6073),
    [anon_sym_BANG_EQ] = ACTIONS(6073),
    [anon_sym_STAR_STAR] = ACTIONS(6071),
    [anon_sym_LT_EQ_GT] = ACTIONS(6073),
    [sym__binary_minus] = ACTIONS(6073),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_if] = ACTIONS(6073),
    [anon_sym_CARET] = ACTIONS(6071),
  },
  [10048] = {
    [anon_sym_SLASH] = ACTIONS(3850),
    [anon_sym_RBRACK] = ACTIONS(3852),
    [anon_sym_until] = ACTIONS(3852),
    [anon_sym_AMP_EQ] = ACTIONS(3852),
    [anon_sym_GT_GT_EQ] = ACTIONS(3852),
    [anon_sym_SLASH_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3850),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [sym__binary_star] = ACTIONS(3852),
    [anon_sym_unless] = ACTIONS(3852),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3850),
    [anon_sym_COLON_COLON2] = ACTIONS(3852),
    [anon_sym_rescue] = ACTIONS(3852),
    [anon_sym_PERCENT_EQ] = ACTIONS(3852),
    [anon_sym_LT_LT_EQ] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_DOT] = ACTIONS(3850),
    [anon_sym_BANG_TILDE] = ACTIONS(3852),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_COLON2] = ACTIONS(3850),
    [anon_sym_while] = ACTIONS(3852),
    [sym__heredoc_body_start] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3852),
    [anon_sym_CARET_EQ] = ACTIONS(3852),
    [anon_sym_AMP_DOT] = ACTIONS(3852),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_DOT_DOT] = ACTIONS(3850),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_QMARK] = ACTIONS(3852),
    [anon_sym_COMMA] = ACTIONS(3852),
    [anon_sym_GT_GT] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3852),
    [anon_sym_or] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_PIPE_EQ] = ACTIONS(3852),
    [anon_sym_PLUS_EQ] = ACTIONS(3852),
    [anon_sym_STAR_EQ] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3850),
    [anon_sym_GT_EQ] = ACTIONS(3852),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3852),
    [anon_sym_DASH_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [anon_sym_STAR_STAR] = ACTIONS(3850),
    [anon_sym_LT_EQ_GT] = ACTIONS(3852),
    [sym__binary_minus] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3850),
    [anon_sym_if] = ACTIONS(3852),
    [anon_sym_CARET] = ACTIONS(3850),
  },
  [10049] = {
    [sym_comment] = ACTIONS(49),
    [sym__string_end] = ACTIONS(16072),
  },
  [10050] = {
    [aux_sym_symbol_array_repeat1] = STATE(11342),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16074),
    [sym__string_end] = ACTIONS(16076),
  },
  [10051] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16078),
  },
  [10052] = {
    [anon_sym_SLASH] = ACTIONS(4054),
    [anon_sym_RBRACK] = ACTIONS(4056),
    [anon_sym_until] = ACTIONS(4056),
    [anon_sym_AMP_EQ] = ACTIONS(4056),
    [anon_sym_GT_GT_EQ] = ACTIONS(4056),
    [anon_sym_SLASH_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4056),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_EQ_TILDE] = ACTIONS(4056),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [sym__binary_star] = ACTIONS(4056),
    [anon_sym_unless] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_AMP] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_COLON_COLON2] = ACTIONS(4056),
    [anon_sym_rescue] = ACTIONS(4056),
    [anon_sym_PERCENT_EQ] = ACTIONS(4056),
    [anon_sym_LT_LT_EQ] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_DOT] = ACTIONS(4054),
    [anon_sym_BANG_TILDE] = ACTIONS(4056),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_COLON2] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4056),
    [sym__heredoc_body_start] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4056),
    [anon_sym_CARET_EQ] = ACTIONS(4056),
    [anon_sym_AMP_DOT] = ACTIONS(4056),
    [anon_sym_LT_EQ] = ACTIONS(4054),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_DOT_DOT] = ACTIONS(4054),
    [anon_sym_EQ] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_in] = ACTIONS(4056),
    [anon_sym_QMARK] = ACTIONS(4056),
    [anon_sym_COMMA] = ACTIONS(4056),
    [anon_sym_GT_GT] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4056),
    [anon_sym_or] = ACTIONS(4056),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_PIPE_EQ] = ACTIONS(4056),
    [anon_sym_PLUS_EQ] = ACTIONS(4056),
    [anon_sym_STAR_EQ] = ACTIONS(4056),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_and] = ACTIONS(4056),
    [anon_sym_PIPE_PIPE] = ACTIONS(4054),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4056),
    [anon_sym_DASH_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4056),
    [anon_sym_BANG_EQ] = ACTIONS(4056),
    [anon_sym_STAR_STAR] = ACTIONS(4054),
    [anon_sym_LT_EQ_GT] = ACTIONS(4056),
    [sym__binary_minus] = ACTIONS(4056),
    [anon_sym_AMP_AMP] = ACTIONS(4054),
    [anon_sym_if] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4054),
  },
  [10053] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16080),
    [sym__string_end] = ACTIONS(16078),
  },
  [10054] = {
    [anon_sym_SLASH] = ACTIONS(4424),
    [anon_sym_RBRACK] = ACTIONS(4426),
    [anon_sym_until] = ACTIONS(4426),
    [anon_sym_AMP_EQ] = ACTIONS(4426),
    [anon_sym_GT_GT_EQ] = ACTIONS(4426),
    [anon_sym_SLASH_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_EQ_TILDE] = ACTIONS(4426),
    [anon_sym_LT_LT] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [sym__binary_star] = ACTIONS(4426),
    [anon_sym_unless] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_AMP] = ACTIONS(4424),
    [anon_sym_PERCENT] = ACTIONS(4424),
    [anon_sym_COLON_COLON2] = ACTIONS(4426),
    [anon_sym_rescue] = ACTIONS(4426),
    [anon_sym_PERCENT_EQ] = ACTIONS(4426),
    [anon_sym_LT_LT_EQ] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4424),
    [anon_sym_BANG_TILDE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_COLON2] = ACTIONS(4424),
    [anon_sym_while] = ACTIONS(4426),
    [sym__heredoc_body_start] = ACTIONS(4426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4426),
    [anon_sym_CARET_EQ] = ACTIONS(4426),
    [anon_sym_AMP_DOT] = ACTIONS(4426),
    [anon_sym_LT_EQ] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(4424),
    [anon_sym_DOT_DOT] = ACTIONS(4424),
    [anon_sym_EQ] = ACTIONS(4424),
    [anon_sym_LT] = ACTIONS(4424),
    [anon_sym_in] = ACTIONS(4426),
    [anon_sym_QMARK] = ACTIONS(4426),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_GT_GT] = ACTIONS(4424),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4426),
    [anon_sym_or] = ACTIONS(4426),
    [anon_sym_GT] = ACTIONS(4424),
    [anon_sym_PIPE_EQ] = ACTIONS(4426),
    [anon_sym_PLUS_EQ] = ACTIONS(4426),
    [anon_sym_STAR_EQ] = ACTIONS(4426),
    [anon_sym_EQ_EQ] = ACTIONS(4424),
    [anon_sym_and] = ACTIONS(4426),
    [anon_sym_PIPE_PIPE] = ACTIONS(4424),
    [anon_sym_GT_EQ] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4426),
    [anon_sym_DASH_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4426),
    [anon_sym_BANG_EQ] = ACTIONS(4426),
    [anon_sym_STAR_STAR] = ACTIONS(4424),
    [anon_sym_LT_EQ_GT] = ACTIONS(4426),
    [sym__binary_minus] = ACTIONS(4426),
    [anon_sym_AMP_AMP] = ACTIONS(4424),
    [anon_sym_if] = ACTIONS(4426),
    [anon_sym_CARET] = ACTIONS(4424),
  },
  [10055] = {
    [anon_sym_SLASH] = ACTIONS(4698),
    [anon_sym_RBRACK] = ACTIONS(4700),
    [anon_sym_until] = ACTIONS(4700),
    [anon_sym_AMP_EQ] = ACTIONS(4700),
    [anon_sym_GT_GT_EQ] = ACTIONS(4700),
    [anon_sym_SLASH_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4700),
    [anon_sym_RPAREN] = ACTIONS(4700),
    [anon_sym_EQ_TILDE] = ACTIONS(4700),
    [anon_sym_LT_LT] = ACTIONS(4698),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [sym__binary_star] = ACTIONS(4700),
    [anon_sym_unless] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4698),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4698),
    [anon_sym_COLON_COLON2] = ACTIONS(4700),
    [anon_sym_rescue] = ACTIONS(4700),
    [anon_sym_PERCENT_EQ] = ACTIONS(4700),
    [anon_sym_LT_LT_EQ] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_DOT] = ACTIONS(4698),
    [anon_sym_BANG_TILDE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4700),
    [anon_sym_COLON2] = ACTIONS(4698),
    [anon_sym_while] = ACTIONS(4700),
    [sym__heredoc_body_start] = ACTIONS(4700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4700),
    [anon_sym_CARET_EQ] = ACTIONS(4700),
    [anon_sym_AMP_DOT] = ACTIONS(4700),
    [anon_sym_LT_EQ] = ACTIONS(4698),
    [anon_sym_PIPE] = ACTIONS(4698),
    [anon_sym_DOT_DOT] = ACTIONS(4698),
    [anon_sym_EQ] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(4698),
    [anon_sym_in] = ACTIONS(4700),
    [anon_sym_QMARK] = ACTIONS(4700),
    [anon_sym_COMMA] = ACTIONS(4700),
    [anon_sym_GT_GT] = ACTIONS(4698),
    [anon_sym_SEMI] = ACTIONS(4700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_or] = ACTIONS(4700),
    [anon_sym_GT] = ACTIONS(4698),
    [anon_sym_PIPE_EQ] = ACTIONS(4700),
    [anon_sym_PLUS_EQ] = ACTIONS(4700),
    [anon_sym_STAR_EQ] = ACTIONS(4700),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4700),
    [anon_sym_PIPE_PIPE] = ACTIONS(4698),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4700),
    [anon_sym_DASH_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4700),
    [anon_sym_BANG_EQ] = ACTIONS(4700),
    [anon_sym_STAR_STAR] = ACTIONS(4698),
    [anon_sym_LT_EQ_GT] = ACTIONS(4700),
    [sym__binary_minus] = ACTIONS(4700),
    [anon_sym_AMP_AMP] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4698),
  },
  [10056] = {
    [anon_sym_RBRACE] = ACTIONS(16082),
    [sym_comment] = ACTIONS(49),
  },
  [10057] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11347),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16084),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10058] = {
    [sym__terminator] = STATE(11348),
    [sym_heredoc_body] = STATE(11348),
    [sym__do] = STATE(11348),
    [anon_sym_do] = ACTIONS(16086),
    [sym__heredoc_body_start] = ACTIONS(983),
    [sym__line_break] = ACTIONS(16086),
    [anon_sym_SEMI] = ACTIONS(16086),
    [sym_comment] = ACTIONS(49),
  },
  [10059] = {
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_until] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_unless] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_rescue] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_while] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_in] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [anon_sym_if] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4766),
  },
  [10060] = {
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_until] = ACTIONS(6632),
    [anon_sym_AMP_EQ] = ACTIONS(6632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6632),
    [anon_sym_SLASH_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_EQ_TILDE] = ACTIONS(6632),
    [anon_sym_LT_LT] = ACTIONS(6630),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [sym__binary_star] = ACTIONS(6632),
    [anon_sym_unless] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6630),
    [anon_sym_AMP] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [anon_sym_COLON_COLON2] = ACTIONS(6632),
    [anon_sym_rescue] = ACTIONS(6632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_DOT] = ACTIONS(6630),
    [anon_sym_BANG_TILDE] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_COLON2] = ACTIONS(6630),
    [anon_sym_while] = ACTIONS(6632),
    [sym__heredoc_body_start] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6632),
    [anon_sym_CARET_EQ] = ACTIONS(6632),
    [anon_sym_AMP_DOT] = ACTIONS(6632),
    [anon_sym_LT_EQ] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_DOT_DOT] = ACTIONS(6630),
    [anon_sym_EQ] = ACTIONS(6630),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_in] = ACTIONS(6632),
    [anon_sym_QMARK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_GT_GT] = ACTIONS(6630),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6632),
    [anon_sym_or] = ACTIONS(6632),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_PIPE_EQ] = ACTIONS(6632),
    [anon_sym_PLUS_EQ] = ACTIONS(6632),
    [anon_sym_STAR_EQ] = ACTIONS(6632),
    [anon_sym_EQ_EQ] = ACTIONS(6630),
    [anon_sym_and] = ACTIONS(6632),
    [anon_sym_PIPE_PIPE] = ACTIONS(6630),
    [anon_sym_GT_EQ] = ACTIONS(6632),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6632),
    [anon_sym_DASH_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6632),
    [anon_sym_BANG_EQ] = ACTIONS(6632),
    [anon_sym_STAR_STAR] = ACTIONS(6630),
    [anon_sym_LT_EQ_GT] = ACTIONS(6632),
    [sym__binary_minus] = ACTIONS(6632),
    [anon_sym_AMP_AMP] = ACTIONS(6630),
    [anon_sym_if] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6630),
  },
  [10061] = {
    [anon_sym_SLASH] = ACTIONS(5236),
    [anon_sym_RBRACK] = ACTIONS(5238),
    [anon_sym_until] = ACTIONS(5238),
    [anon_sym_AMP_EQ] = ACTIONS(5238),
    [anon_sym_GT_GT_EQ] = ACTIONS(5238),
    [anon_sym_SLASH_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5238),
    [anon_sym_EQ_TILDE] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [sym__binary_star] = ACTIONS(5238),
    [anon_sym_unless] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5236),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_COLON_COLON2] = ACTIONS(5238),
    [anon_sym_rescue] = ACTIONS(5238),
    [anon_sym_PERCENT_EQ] = ACTIONS(5238),
    [anon_sym_LT_LT_EQ] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_BANG_TILDE] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_COLON2] = ACTIONS(5236),
    [anon_sym_while] = ACTIONS(5238),
    [sym__heredoc_body_start] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5238),
    [anon_sym_CARET_EQ] = ACTIONS(5238),
    [anon_sym_AMP_DOT] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5236),
    [anon_sym_DOT_DOT] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5238),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5238),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5238),
    [anon_sym_PLUS_EQ] = ACTIONS(5238),
    [anon_sym_STAR_EQ] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5238),
    [anon_sym_DASH_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5238),
    [sym__binary_minus] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_if] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5236),
  },
  [10062] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(16088),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5296),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [10063] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11350),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16090),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [10064] = {
    [sym__method_name] = STATE(7816),
    [sym_setter] = STATE(7816),
    [sym_symbol] = STATE(7816),
    [sym_operator] = STATE(7816),
    [sym__method_rest] = STATE(11351),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(16092),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(16092),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(16092),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(16092),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [10065] = {
    [sym__statement] = STATE(3954),
    [sym_unary] = STATE(3959),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(3954),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_unless_modifier] = STATE(3954),
    [sym_symbol] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym__primary] = STATE(3955),
    [sym_method] = STATE(3955),
    [sym_conditional] = STATE(3959),
    [sym_left_assignment_list] = STATE(3956),
    [sym_return] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_while_modifier] = STATE(3954),
    [sym_subshell] = STATE(3955),
    [sym_unless] = STATE(3955),
    [sym_empty_statement] = STATE(3961),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_begin_block] = STATE(3954),
    [sym_range] = STATE(3959),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(3958),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_call] = STATE(3957),
    [sym_end_block] = STATE(3954),
    [sym_assignment] = STATE(3959),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_alias] = STATE(3954),
    [sym_if_modifier] = STATE(3954),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(3959),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(3959),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_rational] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_until_modifier] = STATE(3954),
    [sym_lambda] = STATE(3955),
    [sym_elsif] = STATE(11353),
    [sym_element_reference] = STATE(3958),
    [sym__statements] = STATE(2089),
    [sym_binary] = STATE(3959),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_nil] = STATE(3958),
    [sym_rescue_modifier] = STATE(3954),
    [sym_symbol_array] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_else] = STATE(11353),
    [aux_sym__statements_repeat1] = STATE(3961),
    [sym_scope_resolution] = STATE(3957),
    [sym_float] = ACTIONS(6634),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(6636),
    [sym_self] = ACTIONS(6638),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(6638),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(6646),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3750),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(6652),
    [sym_class_variable] = ACTIONS(6646),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(6654),
    [anon_sym_then] = ACTIONS(6670),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [sym_retry] = ACTIONS(6634),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16094),
    [sym_integer] = ACTIONS(91),
    [anon_sym_elsif] = ACTIONS(6674),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [10066] = {
    [sym_elsif] = STATE(11353),
    [sym_else] = STATE(11353),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(16096),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_elsif] = ACTIONS(6678),
  },
  [10067] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10068] = {
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10069] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10070] = {
    [aux_sym_exceptions_repeat1] = STATE(11355),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10071] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10072] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10073] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10074] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10075] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10076] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10077] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [10078] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10079] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10080] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10081] = {
    [aux_sym_chained_string_repeat1] = STATE(10081),
    [sym_string] = STATE(10081),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10082] = {
    [sym_assignment] = STATE(7835),
    [sym_unary] = STATE(7835),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(7835),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(7835),
    [sym_conditional] = STATE(7835),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_return] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_true] = STATE(2281),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(7835),
    [sym_binary] = STATE(7835),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8018),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [sym_global_variable] = ACTIONS(3994),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(3984),
    [sym_character] = ACTIONS(3986),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [10083] = {
    [aux_sym_exceptions_repeat1] = STATE(11357),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16103),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10084] = {
    [anon_sym_SLASH] = ACTIONS(10412),
    [anon_sym_RBRACK] = ACTIONS(8575),
    [anon_sym_until] = ACTIONS(8575),
    [anon_sym_AMP_EQ] = ACTIONS(8575),
    [anon_sym_GT_GT_EQ] = ACTIONS(8575),
    [anon_sym_SLASH_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8575),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_EQ_TILDE] = ACTIONS(8575),
    [anon_sym_LT_LT] = ACTIONS(10412),
    [anon_sym_RBRACE] = ACTIONS(8575),
    [sym__binary_star] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(8575),
    [anon_sym_PLUS] = ACTIONS(10412),
    [anon_sym_AMP] = ACTIONS(10412),
    [anon_sym_PERCENT] = ACTIONS(10412),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [anon_sym_rescue] = ACTIONS(8575),
    [anon_sym_PERCENT_EQ] = ACTIONS(8575),
    [anon_sym_LT_LT_EQ] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(10412),
    [anon_sym_BANG_TILDE] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_COLON2] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_CARET_EQ] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [anon_sym_LT_EQ] = ACTIONS(10412),
    [anon_sym_PIPE] = ACTIONS(10412),
    [anon_sym_DOT_DOT] = ACTIONS(10412),
    [anon_sym_EQ] = ACTIONS(10412),
    [anon_sym_LT] = ACTIONS(10412),
    [anon_sym_in] = ACTIONS(8575),
    [anon_sym_QMARK] = ACTIONS(8575),
    [anon_sym_COMMA] = ACTIONS(8575),
    [anon_sym_GT_GT] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8575),
    [anon_sym_or] = ACTIONS(8575),
    [anon_sym_GT] = ACTIONS(10412),
    [anon_sym_PIPE_EQ] = ACTIONS(8575),
    [anon_sym_PLUS_EQ] = ACTIONS(8575),
    [anon_sym_STAR_EQ] = ACTIONS(8575),
    [anon_sym_EQ_EQ] = ACTIONS(10412),
    [anon_sym_and] = ACTIONS(8575),
    [anon_sym_PIPE_PIPE] = ACTIONS(10412),
    [anon_sym_GT_EQ] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8575),
    [anon_sym_DASH_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8575),
    [anon_sym_BANG_EQ] = ACTIONS(8575),
    [anon_sym_STAR_STAR] = ACTIONS(10412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8575),
    [sym__binary_minus] = ACTIONS(8575),
    [anon_sym_AMP_AMP] = ACTIONS(10412),
    [anon_sym_if] = ACTIONS(8575),
    [anon_sym_CARET] = ACTIONS(10412),
  },
  [10085] = {
    [anon_sym_SLASH] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(12375),
    [anon_sym_until] = ACTIONS(12375),
    [anon_sym_AMP_EQ] = ACTIONS(12375),
    [anon_sym_GT_GT_EQ] = ACTIONS(12375),
    [anon_sym_SLASH_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12375),
    [anon_sym_RPAREN] = ACTIONS(12375),
    [anon_sym_EQ_TILDE] = ACTIONS(12375),
    [anon_sym_LT_LT] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(12375),
    [sym__binary_star] = ACTIONS(12375),
    [anon_sym_unless] = ACTIONS(12375),
    [anon_sym_PLUS] = ACTIONS(13245),
    [anon_sym_AMP] = ACTIONS(13245),
    [anon_sym_PERCENT] = ACTIONS(13245),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [anon_sym_rescue] = ACTIONS(12375),
    [anon_sym_PERCENT_EQ] = ACTIONS(12375),
    [anon_sym_LT_LT_EQ] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(13245),
    [anon_sym_BANG_TILDE] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_COLON2] = ACTIONS(13245),
    [anon_sym_while] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_CARET_EQ] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [anon_sym_LT_EQ] = ACTIONS(13245),
    [anon_sym_PIPE] = ACTIONS(13245),
    [anon_sym_DOT_DOT] = ACTIONS(13245),
    [anon_sym_EQ] = ACTIONS(13245),
    [anon_sym_LT] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(12375),
    [anon_sym_QMARK] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_GT_GT] = ACTIONS(13245),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12375),
    [anon_sym_or] = ACTIONS(12375),
    [anon_sym_GT] = ACTIONS(13245),
    [anon_sym_PIPE_EQ] = ACTIONS(12375),
    [anon_sym_PLUS_EQ] = ACTIONS(12375),
    [anon_sym_STAR_EQ] = ACTIONS(12375),
    [anon_sym_EQ_EQ] = ACTIONS(13245),
    [anon_sym_and] = ACTIONS(12375),
    [anon_sym_PIPE_PIPE] = ACTIONS(13245),
    [anon_sym_GT_EQ] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12375),
    [anon_sym_DASH_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12375),
    [anon_sym_BANG_EQ] = ACTIONS(12375),
    [anon_sym_STAR_STAR] = ACTIONS(13245),
    [anon_sym_LT_EQ_GT] = ACTIONS(12375),
    [sym__binary_minus] = ACTIONS(12375),
    [anon_sym_AMP_AMP] = ACTIONS(13245),
    [anon_sym_if] = ACTIONS(12375),
    [anon_sym_CARET] = ACTIONS(13245),
  },
  [10086] = {
    [sym_assignment] = STATE(11358),
    [sym_unary] = STATE(11358),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2281),
    [sym_singleton_class] = STATE(2276),
    [sym_module] = STATE(2276),
    [sym_chained_string] = STATE(2276),
    [sym_until] = STATE(2276),
    [sym_regex] = STATE(2276),
    [sym_for] = STATE(2276),
    [sym_symbol] = STATE(2276),
    [sym_if] = STATE(2276),
    [sym_begin] = STATE(2276),
    [sym__arg] = STATE(11358),
    [sym__primary] = STATE(2276),
    [sym_method_call] = STATE(2281),
    [sym_operator_assignment] = STATE(11358),
    [sym_conditional] = STATE(11358),
    [sym_method] = STATE(2276),
    [sym_singleton_method] = STATE(2276),
    [sym__variable] = STATE(2279),
    [sym_left_assignment_list] = STATE(2278),
    [sym_rational] = STATE(2276),
    [sym_true] = STATE(2281),
    [sym_return] = STATE(2276),
    [sym_subshell] = STATE(2276),
    [sym_yield] = STATE(2276),
    [sym_string] = STATE(4866),
    [sym_unless] = STATE(2276),
    [sym_lambda] = STATE(2276),
    [sym_parenthesized_statements] = STATE(2276),
    [sym_element_reference] = STATE(2281),
    [sym_range] = STATE(11358),
    [sym_binary] = STATE(11358),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2276),
    [sym_break] = STATE(2276),
    [sym_next] = STATE(2276),
    [sym_string_array] = STATE(2276),
    [sym_while] = STATE(2276),
    [sym_case] = STATE(2276),
    [sym_symbol_array] = STATE(2276),
    [sym_array] = STATE(2276),
    [sym_hash] = STATE(2276),
    [sym_false] = STATE(2281),
    [sym_nil] = STATE(2281),
    [sym_scope_resolution] = STATE(2279),
    [sym_call] = STATE(2279),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(3980),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(3988),
    [anon_sym_not] = ACTIONS(4006),
    [sym_self] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4012),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(3986),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(3986),
    [anon_sym_PLUS] = ACTIONS(8094),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(3994),
    [sym_character] = ACTIONS(3986),
    [sym_super] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4014),
    [anon_sym_next] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(3980),
    [sym_constant] = ACTIONS(3984),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [sym_instance_variable] = ACTIONS(3994),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(7926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(3984),
    [sym_redo] = ACTIONS(3980),
    [sym_class_variable] = ACTIONS(3994),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(3982),
  },
  [10087] = {
    [anon_sym_LT] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4030),
    [anon_sym_GT_GT] = ACTIONS(4032),
    [anon_sym_EQ_TILDE] = ACTIONS(4030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [sym__binary_star] = ACTIONS(4026),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(4042),
    [anon_sym_BANG_TILDE] = ACTIONS(4030),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4044),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4030),
    [anon_sym_STAR_STAR] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4048),
    [anon_sym_DOT_DOT] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4030),
    [anon_sym_LT_EQ_GT] = ACTIONS(4030),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(4050),
    [sym__binary_minus] = ACTIONS(4038),
  },
  [10088] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [anon_sym_RBRACK] = ACTIONS(14596),
    [anon_sym_in] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_EQ_GT] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_COLON2] = ACTIONS(14594),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
    [anon_sym_EQ] = ACTIONS(14594),
  },
  [10089] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [anon_sym_RBRACK] = ACTIONS(15029),
    [anon_sym_in] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_EQ_GT] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_COLON2] = ACTIONS(15027),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
    [anon_sym_EQ] = ACTIONS(15027),
  },
  [10090] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [anon_sym_RBRACK] = ACTIONS(15175),
    [anon_sym_in] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
    [anon_sym_EQ] = ACTIONS(15173),
  },
  [10091] = {
    [anon_sym_end] = ACTIONS(16105),
    [sym_comment] = ACTIONS(49),
  },
  [10092] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [anon_sym_RBRACK] = ACTIONS(15209),
    [anon_sym_in] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_EQ_GT] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_COLON2] = ACTIONS(15207),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
    [anon_sym_EQ] = ACTIONS(15207),
  },
  [10093] = {
    [aux_sym_exceptions_repeat1] = STATE(10093),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16107),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10094] = {
    [anon_sym_LT] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4130),
    [sym__binary_star] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4136),
    [anon_sym_GT] = ACTIONS(4122),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(4138),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(4130),
    [anon_sym_PIPE_PIPE] = ACTIONS(4130),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(4130),
    [anon_sym_STAR_STAR] = ACTIONS(4124),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4130),
    [anon_sym_LT_EQ_GT] = ACTIONS(4130),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [sym__binary_minus] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4146),
  },
  [10095] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10096] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10097] = {
    [aux_sym_exceptions_repeat1] = STATE(11361),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10098] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10099] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10100] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10101] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10102] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10103] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10104] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [10105] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10106] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10107] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10108] = {
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_SLASH] = ACTIONS(11545),
    [anon_sym_RBRACK] = ACTIONS(11545),
    [anon_sym_in] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11545),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11545),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_COLON2] = ACTIONS(11543),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11545),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11545),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11545),
    [anon_sym_EQ] = ACTIONS(11543),
  },
  [10109] = {
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_SLASH] = ACTIONS(13276),
    [anon_sym_RBRACK] = ACTIONS(13276),
    [anon_sym_in] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13276),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13276),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_COLON2] = ACTIONS(13274),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13276),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_AMP_AMP] = ACTIONS(13276),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13276),
    [anon_sym_EQ] = ACTIONS(13274),
  },
  [10110] = {
    [anon_sym_end] = ACTIONS(16112),
    [sym_comment] = ACTIONS(49),
  },
  [10111] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11364),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16112),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [10112] = {
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_SLASH] = ACTIONS(13958),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_in] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13958),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13958),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_COLON2] = ACTIONS(13956),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13958),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_AMP_AMP] = ACTIONS(13958),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13958),
    [anon_sym_EQ] = ACTIONS(13956),
  },
  [10113] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16114),
  },
  [10114] = {
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_SLASH] = ACTIONS(13964),
    [anon_sym_RBRACK] = ACTIONS(13964),
    [anon_sym_in] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13964),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13964),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_AMP_AMP] = ACTIONS(13964),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13964),
    [anon_sym_EQ] = ACTIONS(13962),
  },
  [10115] = {
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_SLASH] = ACTIONS(11868),
    [anon_sym_RBRACK] = ACTIONS(11868),
    [anon_sym_in] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11868),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11868),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_AMP_AMP] = ACTIONS(11868),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11868),
    [anon_sym_EQ] = ACTIONS(11866),
  },
  [10116] = {
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_SLASH] = ACTIONS(13464),
    [anon_sym_RBRACK] = ACTIONS(13464),
    [anon_sym_in] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13464),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13464),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_COLON2] = ACTIONS(13462),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13464),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_AMP_AMP] = ACTIONS(13464),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13464),
    [anon_sym_EQ] = ACTIONS(13462),
  },
  [10117] = {
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_RBRACK] = ACTIONS(13468),
    [anon_sym_in] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_AMP_AMP] = ACTIONS(13468),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13468),
    [anon_sym_EQ] = ACTIONS(13466),
  },
  [10118] = {
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_SLASH] = ACTIONS(13739),
    [anon_sym_RBRACK] = ACTIONS(13739),
    [anon_sym_in] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13739),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13739),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_COLON2] = ACTIONS(13737),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13739),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_AMP_AMP] = ACTIONS(13739),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13739),
    [anon_sym_EQ] = ACTIONS(13737),
  },
  [10119] = {
    [anon_sym_end] = ACTIONS(16116),
    [sym_comment] = ACTIONS(49),
  },
  [10120] = {
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_SLASH] = ACTIONS(11879),
    [anon_sym_RBRACK] = ACTIONS(11879),
    [anon_sym_in] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11879),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11879),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_COLON2] = ACTIONS(11877),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11879),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_AMP_AMP] = ACTIONS(11879),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11879),
    [anon_sym_EQ] = ACTIONS(11877),
  },
  [10121] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16118),
  },
  [10122] = {
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_SLASH] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12166),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_AMP_AMP] = ACTIONS(12166),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12164),
  },
  [10123] = {
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_SLASH] = ACTIONS(12632),
    [anon_sym_RBRACK] = ACTIONS(12632),
    [anon_sym_in] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12632),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12632),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_COLON2] = ACTIONS(12630),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12632),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_AMP_AMP] = ACTIONS(12632),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12632),
    [anon_sym_EQ] = ACTIONS(12630),
  },
  [10124] = {
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_SLASH] = ACTIONS(12797),
    [anon_sym_RBRACK] = ACTIONS(12797),
    [anon_sym_in] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12797),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12797),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_COLON2] = ACTIONS(12795),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12797),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_AMP_AMP] = ACTIONS(12797),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12797),
    [anon_sym_EQ] = ACTIONS(12795),
  },
  [10125] = {
    [anon_sym_end] = ACTIONS(16120),
    [sym_comment] = ACTIONS(49),
  },
  [10126] = {
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_SLASH] = ACTIONS(12905),
    [anon_sym_RBRACK] = ACTIONS(12905),
    [anon_sym_in] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12905),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12905),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_AMP_AMP] = ACTIONS(12905),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12905),
    [anon_sym_EQ] = ACTIONS(12903),
  },
  [10127] = {
    [anon_sym_end] = ACTIONS(16122),
    [sym_comment] = ACTIONS(49),
  },
  [10128] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11370),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16124),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10129] = {
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_SLASH] = ACTIONS(13019),
    [anon_sym_RBRACK] = ACTIONS(13019),
    [anon_sym_in] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13019),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13019),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_AMP_AMP] = ACTIONS(13019),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13019),
    [anon_sym_EQ] = ACTIONS(13017),
  },
  [10130] = {
    [sym__method_name] = STATE(2414),
    [sym_setter] = STATE(2414),
    [sym_symbol] = STATE(2414),
    [sym_operator] = STATE(2414),
    [sym__method_rest] = STATE(11371),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(12294),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(12294),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(12294),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(12294),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [10131] = {
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_SLASH] = ACTIONS(13954),
    [anon_sym_RBRACK] = ACTIONS(13954),
    [anon_sym_in] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13954),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13954),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_COLON2] = ACTIONS(13952),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13954),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_AMP_AMP] = ACTIONS(13954),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13954),
    [anon_sym_EQ] = ACTIONS(13952),
  },
  [10132] = {
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
  },
  [10133] = {
    [aux_sym_exceptions_repeat1] = STATE(10133),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16126),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10134] = {
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4216),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4220),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4222),
    [anon_sym_LT_LT] = ACTIONS(4220),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4218),
    [sym__binary_star] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4226),
    [anon_sym_AMP] = ACTIONS(4228),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4230),
    [anon_sym_BANG_TILDE] = ACTIONS(4218),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4218),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4232),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4218),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4236),
    [anon_sym_DOT_DOT] = ACTIONS(4234),
    [anon_sym_AMP_AMP] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4218),
    [anon_sym_LT_EQ] = ACTIONS(4210),
    [sym__binary_minus] = ACTIONS(4226),
    [anon_sym_CARET] = ACTIONS(4238),
  },
  [10135] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10136] = {
    [anon_sym_SLASH] = ACTIONS(13017),
    [anon_sym_RBRACK] = ACTIONS(13019),
    [anon_sym_until] = ACTIONS(13019),
    [anon_sym_AMP_EQ] = ACTIONS(13019),
    [anon_sym_GT_GT_EQ] = ACTIONS(13019),
    [anon_sym_SLASH_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13019),
    [anon_sym_RPAREN] = ACTIONS(13019),
    [anon_sym_EQ_TILDE] = ACTIONS(13019),
    [anon_sym_LT_LT] = ACTIONS(13017),
    [sym__binary_star] = ACTIONS(13019),
    [anon_sym_RBRACE] = ACTIONS(13019),
    [anon_sym_unless] = ACTIONS(13019),
    [anon_sym_PLUS] = ACTIONS(13017),
    [anon_sym_AMP] = ACTIONS(13017),
    [anon_sym_PERCENT] = ACTIONS(13017),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [anon_sym_rescue] = ACTIONS(13019),
    [anon_sym_PERCENT_EQ] = ACTIONS(13019),
    [anon_sym_LT_LT_EQ] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13017),
    [anon_sym_BANG_TILDE] = ACTIONS(13019),
    [anon_sym_LBRACE] = ACTIONS(13019),
    [anon_sym_COLON2] = ACTIONS(13017),
    [anon_sym_while] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13019),
    [anon_sym_CARET_EQ] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_LT_EQ] = ACTIONS(13017),
    [anon_sym_PIPE] = ACTIONS(13017),
    [anon_sym_DOT_DOT] = ACTIONS(13017),
    [anon_sym_EQ] = ACTIONS(13017),
    [anon_sym_LT] = ACTIONS(13017),
    [anon_sym_in] = ACTIONS(13019),
    [anon_sym_QMARK] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_GT_GT] = ACTIONS(13017),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13019),
    [anon_sym_or] = ACTIONS(13019),
    [anon_sym_GT] = ACTIONS(13017),
    [anon_sym_PIPE_EQ] = ACTIONS(13019),
    [anon_sym_PLUS_EQ] = ACTIONS(13019),
    [anon_sym_STAR_EQ] = ACTIONS(13019),
    [anon_sym_EQ_EQ] = ACTIONS(13017),
    [anon_sym_and] = ACTIONS(13019),
    [anon_sym_PIPE_PIPE] = ACTIONS(13017),
    [anon_sym_GT_EQ] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13019),
    [anon_sym_DASH_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13019),
    [anon_sym_BANG_EQ] = ACTIONS(13019),
    [anon_sym_STAR_STAR] = ACTIONS(13017),
    [anon_sym_LT_EQ_GT] = ACTIONS(13019),
    [anon_sym_AMP_AMP] = ACTIONS(13017),
    [sym__binary_minus] = ACTIONS(13019),
    [anon_sym_if] = ACTIONS(13019),
    [anon_sym_CARET] = ACTIONS(13017),
  },
  [10137] = {
    [anon_sym_SLASH] = ACTIONS(12903),
    [anon_sym_RBRACK] = ACTIONS(12905),
    [anon_sym_until] = ACTIONS(12905),
    [anon_sym_AMP_EQ] = ACTIONS(12905),
    [anon_sym_GT_GT_EQ] = ACTIONS(12905),
    [anon_sym_SLASH_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12905),
    [anon_sym_RPAREN] = ACTIONS(12905),
    [anon_sym_EQ_TILDE] = ACTIONS(12905),
    [anon_sym_LT_LT] = ACTIONS(12903),
    [sym__binary_star] = ACTIONS(12905),
    [anon_sym_RBRACE] = ACTIONS(12905),
    [anon_sym_unless] = ACTIONS(12905),
    [anon_sym_PLUS] = ACTIONS(12903),
    [anon_sym_AMP] = ACTIONS(12903),
    [anon_sym_PERCENT] = ACTIONS(12903),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [anon_sym_rescue] = ACTIONS(12905),
    [anon_sym_PERCENT_EQ] = ACTIONS(12905),
    [anon_sym_LT_LT_EQ] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12903),
    [anon_sym_BANG_TILDE] = ACTIONS(12905),
    [anon_sym_LBRACE] = ACTIONS(12905),
    [anon_sym_COLON2] = ACTIONS(12903),
    [anon_sym_while] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12905),
    [anon_sym_CARET_EQ] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_LT_EQ] = ACTIONS(12903),
    [anon_sym_PIPE] = ACTIONS(12903),
    [anon_sym_DOT_DOT] = ACTIONS(12903),
    [anon_sym_EQ] = ACTIONS(12903),
    [anon_sym_LT] = ACTIONS(12903),
    [anon_sym_in] = ACTIONS(12905),
    [anon_sym_QMARK] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_GT_GT] = ACTIONS(12903),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12905),
    [anon_sym_or] = ACTIONS(12905),
    [anon_sym_GT] = ACTIONS(12903),
    [anon_sym_PIPE_EQ] = ACTIONS(12905),
    [anon_sym_PLUS_EQ] = ACTIONS(12905),
    [anon_sym_STAR_EQ] = ACTIONS(12905),
    [anon_sym_EQ_EQ] = ACTIONS(12903),
    [anon_sym_and] = ACTIONS(12905),
    [anon_sym_PIPE_PIPE] = ACTIONS(12903),
    [anon_sym_GT_EQ] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12905),
    [anon_sym_DASH_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12905),
    [anon_sym_BANG_EQ] = ACTIONS(12905),
    [anon_sym_STAR_STAR] = ACTIONS(12903),
    [anon_sym_LT_EQ_GT] = ACTIONS(12905),
    [anon_sym_AMP_AMP] = ACTIONS(12903),
    [sym__binary_minus] = ACTIONS(12905),
    [anon_sym_if] = ACTIONS(12905),
    [anon_sym_CARET] = ACTIONS(12903),
  },
  [10138] = {
    [anon_sym_end] = ACTIONS(16129),
    [sym_comment] = ACTIONS(49),
  },
  [10139] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11373),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16131),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10140] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10141] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10142] = {
    [aux_sym_exceptions_repeat1] = STATE(11375),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_RBRACK] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10143] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10144] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10145] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10146] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10147] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16133),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10148] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10149] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [10150] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10151] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10152] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10153] = {
    [aux_sym_chained_string_repeat1] = STATE(10153),
    [sym_string] = STATE(10153),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_RBRACK] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10154] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [anon_sym_RBRACK] = ACTIONS(15291),
    [anon_sym_in] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_EQ_GT] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
    [anon_sym_EQ] = ACTIONS(15289),
  },
  [10155] = {
    [anon_sym_end] = ACTIONS(16135),
    [sym_comment] = ACTIONS(49),
  },
  [10156] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [anon_sym_RBRACK] = ACTIONS(15676),
    [anon_sym_in] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_EQ_GT] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_COLON2] = ACTIONS(15674),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
    [anon_sym_EQ] = ACTIONS(15674),
  },
  [10157] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [anon_sym_RBRACK] = ACTIONS(15831),
    [anon_sym_in] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_EQ_GT] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_COLON2] = ACTIONS(15829),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
    [anon_sym_EQ] = ACTIONS(15829),
  },
  [10158] = {
    [anon_sym_SLASH] = ACTIONS(11543),
    [anon_sym_RBRACK] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_AMP_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT_EQ] = ACTIONS(11545),
    [anon_sym_SLASH_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11543),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11543),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11543),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_PERCENT_EQ] = ACTIONS(11545),
    [anon_sym_LT_LT_EQ] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_COLON2] = ACTIONS(11543),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_CARET_EQ] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_EQ] = ACTIONS(11543),
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_in] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11543),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_EQ_GT] = ACTIONS(11545),
    [anon_sym_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_PLUS_EQ] = ACTIONS(11545),
    [anon_sym_STAR_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11545),
    [anon_sym_DASH_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11543),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11543),
  },
  [10159] = {
    [anon_sym_SLASH] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_AMP_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT_EQ] = ACTIONS(11868),
    [anon_sym_SLASH_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11866),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11866),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11866),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_PERCENT_EQ] = ACTIONS(11868),
    [anon_sym_LT_LT_EQ] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_CARET_EQ] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_EQ_GT] = ACTIONS(11868),
    [anon_sym_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_PLUS_EQ] = ACTIONS(11868),
    [anon_sym_STAR_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11866),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11868),
    [anon_sym_DASH_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11866),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_AMP_AMP] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11866),
  },
  [10160] = {
    [anon_sym_SLASH] = ACTIONS(11877),
    [anon_sym_RBRACK] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_AMP_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT_EQ] = ACTIONS(11879),
    [anon_sym_SLASH_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11877),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11877),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11877),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_PERCENT_EQ] = ACTIONS(11879),
    [anon_sym_LT_LT_EQ] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_COLON2] = ACTIONS(11877),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_CARET_EQ] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_EQ] = ACTIONS(11877),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_in] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11877),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_EQ_GT] = ACTIONS(11879),
    [anon_sym_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_PLUS_EQ] = ACTIONS(11879),
    [anon_sym_STAR_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11879),
    [anon_sym_DASH_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11877),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_AMP_AMP] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11877),
  },
  [10161] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16137),
  },
  [10162] = {
    [anon_sym_SLASH] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12164),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12164),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12164),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(12164),
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12164),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12164),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12164),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_AMP_AMP] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12164),
  },
  [10163] = {
    [anon_sym_SLASH] = ACTIONS(12630),
    [anon_sym_RBRACK] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_AMP_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT_EQ] = ACTIONS(12632),
    [anon_sym_SLASH_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12630),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12630),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12630),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_PERCENT_EQ] = ACTIONS(12632),
    [anon_sym_LT_LT_EQ] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_COLON2] = ACTIONS(12630),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_CARET_EQ] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_in] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12630),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_EQ_GT] = ACTIONS(12632),
    [anon_sym_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_PLUS_EQ] = ACTIONS(12632),
    [anon_sym_STAR_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12630),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12632),
    [anon_sym_DASH_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12630),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_AMP_AMP] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12630),
  },
  [10164] = {
    [anon_sym_SLASH] = ACTIONS(12795),
    [anon_sym_RBRACK] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_AMP_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT_EQ] = ACTIONS(12797),
    [anon_sym_SLASH_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12795),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12795),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12795),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_PERCENT_EQ] = ACTIONS(12797),
    [anon_sym_LT_LT_EQ] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_COLON2] = ACTIONS(12795),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_CARET_EQ] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_EQ] = ACTIONS(12795),
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_in] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12795),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_EQ_GT] = ACTIONS(12797),
    [anon_sym_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_PLUS_EQ] = ACTIONS(12797),
    [anon_sym_STAR_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12795),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12797),
    [anon_sym_DASH_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12795),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_AMP_AMP] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12795),
  },
  [10165] = {
    [anon_sym_end] = ACTIONS(16139),
    [sym_comment] = ACTIONS(49),
  },
  [10166] = {
    [anon_sym_SLASH] = ACTIONS(15173),
    [anon_sym_RBRACK] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_in] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [10167] = {
    [anon_sym_end] = ACTIONS(16141),
    [sym_comment] = ACTIONS(49),
  },
  [10168] = {
    [sym__method_name] = STATE(2535),
    [sym_setter] = STATE(2535),
    [sym_symbol] = STATE(2535),
    [sym_operator] = STATE(2535),
    [sym__method_rest] = STATE(11381),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(12417),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(12417),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(12417),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(12417),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [10169] = {
    [anon_sym_SLASH] = ACTIONS(13274),
    [anon_sym_RBRACK] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_AMP_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT_EQ] = ACTIONS(13276),
    [anon_sym_SLASH_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13274),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13274),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13274),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_PERCENT_EQ] = ACTIONS(13276),
    [anon_sym_LT_LT_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_COLON2] = ACTIONS(13274),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_CARET_EQ] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_EQ] = ACTIONS(13274),
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_in] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13274),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_EQ_GT] = ACTIONS(13276),
    [anon_sym_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_PLUS_EQ] = ACTIONS(13276),
    [anon_sym_STAR_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13274),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13276),
    [anon_sym_DASH_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_AMP_AMP] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13274),
  },
  [10170] = {
    [anon_sym_end] = ACTIONS(16143),
    [sym_comment] = ACTIONS(49),
  },
  [10171] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11383),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16143),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [10172] = {
    [anon_sym_SLASH] = ACTIONS(13462),
    [anon_sym_RBRACK] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_AMP_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT_EQ] = ACTIONS(13464),
    [anon_sym_SLASH_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13462),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_PERCENT_EQ] = ACTIONS(13464),
    [anon_sym_LT_LT_EQ] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_COLON2] = ACTIONS(13462),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_CARET_EQ] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_EQ] = ACTIONS(13462),
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_in] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13462),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_EQ_GT] = ACTIONS(13464),
    [anon_sym_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_PLUS_EQ] = ACTIONS(13464),
    [anon_sym_STAR_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13462),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13464),
    [anon_sym_DASH_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13462),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_AMP_AMP] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13462),
  },
  [10173] = {
    [anon_sym_SLASH] = ACTIONS(13466),
    [anon_sym_RBRACK] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_AMP_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT_EQ] = ACTIONS(13468),
    [anon_sym_SLASH_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13466),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13466),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13466),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_PERCENT_EQ] = ACTIONS(13468),
    [anon_sym_LT_LT_EQ] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_CARET_EQ] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_EQ] = ACTIONS(13466),
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_in] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_EQ_GT] = ACTIONS(13468),
    [anon_sym_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_PLUS_EQ] = ACTIONS(13468),
    [anon_sym_STAR_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13466),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13468),
    [anon_sym_DASH_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13466),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_AMP_AMP] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13466),
  },
  [10174] = {
    [anon_sym_SLASH] = ACTIONS(13737),
    [anon_sym_RBRACK] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_AMP_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT_EQ] = ACTIONS(13739),
    [anon_sym_SLASH_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13737),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13737),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13737),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_PERCENT_EQ] = ACTIONS(13739),
    [anon_sym_LT_LT_EQ] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_COLON2] = ACTIONS(13737),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_CARET_EQ] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_EQ] = ACTIONS(13737),
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_in] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13737),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_EQ_GT] = ACTIONS(13739),
    [anon_sym_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_PLUS_EQ] = ACTIONS(13739),
    [anon_sym_STAR_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13737),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13739),
    [anon_sym_DASH_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13737),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_AMP_AMP] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13737),
  },
  [10175] = {
    [anon_sym_end] = ACTIONS(16145),
    [sym_comment] = ACTIONS(49),
  },
  [10176] = {
    [anon_sym_SLASH] = ACTIONS(13952),
    [anon_sym_RBRACK] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_AMP_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT_EQ] = ACTIONS(13954),
    [anon_sym_SLASH_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13952),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13952),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13952),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_PERCENT_EQ] = ACTIONS(13954),
    [anon_sym_LT_LT_EQ] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_COLON2] = ACTIONS(13952),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_CARET_EQ] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_EQ] = ACTIONS(13952),
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_in] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13952),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_EQ_GT] = ACTIONS(13954),
    [anon_sym_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_PLUS_EQ] = ACTIONS(13954),
    [anon_sym_STAR_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13952),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13954),
    [anon_sym_DASH_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13952),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_AMP_AMP] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13952),
  },
  [10177] = {
    [anon_sym_SLASH] = ACTIONS(13956),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_AMP_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT_EQ] = ACTIONS(13958),
    [anon_sym_SLASH_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13956),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13956),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13956),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_PERCENT_EQ] = ACTIONS(13958),
    [anon_sym_LT_LT_EQ] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_COLON2] = ACTIONS(13956),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_CARET_EQ] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_EQ] = ACTIONS(13956),
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_in] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13956),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_EQ_GT] = ACTIONS(13958),
    [anon_sym_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_PLUS_EQ] = ACTIONS(13958),
    [anon_sym_STAR_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13956),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13958),
    [anon_sym_DASH_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13956),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_AMP_AMP] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13956),
  },
  [10178] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16147),
  },
  [10179] = {
    [anon_sym_SLASH] = ACTIONS(13962),
    [anon_sym_RBRACK] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_AMP_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT_EQ] = ACTIONS(13964),
    [anon_sym_SLASH_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13962),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13962),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13962),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_PERCENT_EQ] = ACTIONS(13964),
    [anon_sym_LT_LT_EQ] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_CARET_EQ] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_EQ] = ACTIONS(13962),
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_in] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13962),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_EQ_GT] = ACTIONS(13964),
    [anon_sym_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_PLUS_EQ] = ACTIONS(13964),
    [anon_sym_STAR_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13962),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13964),
    [anon_sym_DASH_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13962),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_AMP_AMP] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13962),
  },
  [10180] = {
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [10181] = {
    [aux_sym_exceptions_repeat1] = STATE(10181),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16149),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [10182] = {
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(4396),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4398),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LT_LT] = ACTIONS(4400),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4402),
    [sym__binary_star] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4394),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4412),
    [anon_sym_BANG_TILDE] = ACTIONS(4402),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(4402),
    [anon_sym_STAR_STAR] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4416),
    [anon_sym_DOT_DOT] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4412),
    [anon_sym_LT_EQ_GT] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4394),
    [sym__binary_minus] = ACTIONS(4420),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(4416),
  },
  [10183] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_EQ_GT] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
  },
  [10184] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_EQ_GT] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
  },
  [10185] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
  },
  [10186] = {
    [anon_sym_end] = ACTIONS(16152),
    [sym_comment] = ACTIONS(49),
  },
  [10187] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_EQ_GT] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
  },
  [10188] = {
    [aux_sym_exceptions_repeat1] = STATE(10188),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16154),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10189] = {
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4490),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4488),
    [sym__binary_star] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(4488),
    [anon_sym_PIPE_PIPE] = ACTIONS(4488),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_STAR_STAR] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4502),
    [anon_sym_AMP_AMP] = ACTIONS(4488),
    [anon_sym_LT_EQ_GT] = ACTIONS(4488),
    [anon_sym_LT_EQ] = ACTIONS(4480),
    [sym__binary_minus] = ACTIONS(4492),
    [anon_sym_CARET] = ACTIONS(4504),
  },
  [10190] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10191] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_EQ_GT] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
  },
  [10192] = {
    [anon_sym_end] = ACTIONS(16157),
    [sym_comment] = ACTIONS(49),
  },
  [10193] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_EQ_GT] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
  },
  [10194] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [10195] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [10196] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(2688),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5300),
    [sym_rational] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym_float] = ACTIONS(4540),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(4544),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(4544),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8637),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(4552),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(8639),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4560),
    [sym_class_variable] = ACTIONS(4552),
    [sym__block_ampersand] = ACTIONS(8641),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(4564),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [sym_retry] = ACTIONS(4540),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14878),
    [sym_redo] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [10197] = {
    [sym_heredoc_body] = STATE(10197),
    [aux_sym_call_repeat1] = STATE(10197),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10198] = {
    [sym_heredoc_body] = STATE(10197),
    [aux_sym_call_repeat1] = STATE(10197),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10199] = {
    [aux_sym_argument_list_repeat1] = STATE(10199),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16159),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10200] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10201] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10202] = {
    [aux_sym_exceptions_repeat1] = STATE(11389),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10203] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10204] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10205] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10206] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10207] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16162),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10208] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10209] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [10210] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10211] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10212] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10213] = {
    [sym_assignment] = STATE(8089),
    [sym_unary] = STATE(8089),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(8089),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(8089),
    [sym_conditional] = STATE(8089),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_return] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_true] = STATE(2686),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(8089),
    [sym_binary] = STATE(8089),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8643),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym_global_variable] = ACTIONS(4552),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(4544),
    [sym_character] = ACTIONS(4546),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [10214] = {
    [aux_sym_exceptions_repeat1] = STATE(11391),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16164),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10215] = {
    [sym_assignment] = STATE(11392),
    [sym_unary] = STATE(11392),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2686),
    [sym_singleton_class] = STATE(2688),
    [sym_module] = STATE(2688),
    [sym_chained_string] = STATE(2688),
    [sym_until] = STATE(2688),
    [sym_regex] = STATE(2688),
    [sym_for] = STATE(2688),
    [sym_symbol] = STATE(2688),
    [sym_if] = STATE(2688),
    [sym_begin] = STATE(2688),
    [sym__arg] = STATE(11392),
    [sym__primary] = STATE(2688),
    [sym_method_call] = STATE(2686),
    [sym_operator_assignment] = STATE(11392),
    [sym_conditional] = STATE(11392),
    [sym_method] = STATE(2688),
    [sym_singleton_method] = STATE(2688),
    [sym__variable] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym_rational] = STATE(2688),
    [sym_true] = STATE(2686),
    [sym_return] = STATE(2688),
    [sym_subshell] = STATE(2688),
    [sym_yield] = STATE(2688),
    [sym_string] = STATE(5288),
    [sym_unless] = STATE(2688),
    [sym_lambda] = STATE(2688),
    [sym_parenthesized_statements] = STATE(2688),
    [sym_element_reference] = STATE(2686),
    [sym_range] = STATE(11392),
    [sym_binary] = STATE(11392),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2688),
    [sym_break] = STATE(2688),
    [sym_next] = STATE(2688),
    [sym_string_array] = STATE(2688),
    [sym_while] = STATE(2688),
    [sym_case] = STATE(2688),
    [sym_symbol_array] = STATE(2688),
    [sym_array] = STATE(2688),
    [sym_hash] = STATE(2688),
    [sym_false] = STATE(2686),
    [sym_nil] = STATE(2686),
    [sym_scope_resolution] = STATE(2689),
    [sym_call] = STATE(2689),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(4540),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4560),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(4564),
    [sym_self] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(4568),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4546),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4552),
    [sym_character] = ACTIONS(4546),
    [sym_super] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(4570),
    [anon_sym_next] = ACTIONS(4572),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(4540),
    [sym_constant] = ACTIONS(4544),
    [anon_sym_defined_QMARK] = ACTIONS(4554),
    [sym_instance_variable] = ACTIONS(4552),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(4544),
    [sym_redo] = ACTIONS(4540),
    [sym_class_variable] = ACTIONS(4552),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(4542),
  },
  [10216] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10217] = {
    [anon_sym_RPAREN] = ACTIONS(16166),
    [sym_comment] = ACTIONS(49),
  },
  [10218] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10219] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [10220] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [10221] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(2722),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5333),
    [sym_rational] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym_float] = ACTIONS(4616),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(4620),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(4620),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4622),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8693),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(4628),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [sym__identifier_hash_key] = ACTIONS(8695),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8693),
    [anon_sym_yield] = ACTIONS(4634),
    [sym_class_variable] = ACTIONS(4628),
    [sym__block_ampersand] = ACTIONS(8697),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4638),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [sym_retry] = ACTIONS(4616),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14889),
    [sym_redo] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [10222] = {
    [sym_heredoc_body] = STATE(10222),
    [aux_sym_call_repeat1] = STATE(10222),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10223] = {
    [sym_heredoc_body] = STATE(10222),
    [aux_sym_call_repeat1] = STATE(10222),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10224] = {
    [aux_sym_argument_list_repeat1] = STATE(10224),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16168),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_RBRACE] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10225] = {
    [aux_sym_exceptions_repeat1] = STATE(10225),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16171),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10226] = {
    [anon_sym_LT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4592),
    [anon_sym_LT_LT] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [sym__binary_star] = ACTIONS(4584),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_TILDE] = ACTIONS(4588),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4588),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4602),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(4588),
    [anon_sym_STAR_STAR] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4588),
    [anon_sym_LT_EQ_GT] = ACTIONS(4588),
    [anon_sym_LT_EQ] = ACTIONS(4582),
    [sym__binary_minus] = ACTIONS(4596),
    [anon_sym_CARET] = ACTIONS(4608),
  },
  [10227] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10228] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10229] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10230] = {
    [aux_sym_exceptions_repeat1] = STATE(11395),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10231] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10232] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10233] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10234] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10235] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16174),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10236] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10237] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [10238] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10239] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10240] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10241] = {
    [aux_sym_chained_string_repeat1] = STATE(10241),
    [sym_string] = STATE(10241),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10242] = {
    [sym_assignment] = STATE(8139),
    [sym_unary] = STATE(8139),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(8139),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(8139),
    [sym_conditional] = STATE(8139),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_return] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_true] = STATE(2726),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(8139),
    [sym_binary] = STATE(8139),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym_global_variable] = ACTIONS(4628),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(4620),
    [sym_character] = ACTIONS(4622),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [10243] = {
    [aux_sym_exceptions_repeat1] = STATE(11397),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16176),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10244] = {
    [sym_assignment] = STATE(11398),
    [sym_unary] = STATE(11398),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2726),
    [sym_singleton_class] = STATE(2722),
    [sym_module] = STATE(2722),
    [sym_chained_string] = STATE(2722),
    [sym_until] = STATE(2722),
    [sym_regex] = STATE(2722),
    [sym_for] = STATE(2722),
    [sym_symbol] = STATE(2722),
    [sym_if] = STATE(2722),
    [sym_begin] = STATE(2722),
    [sym__arg] = STATE(11398),
    [sym__primary] = STATE(2722),
    [sym_method_call] = STATE(2726),
    [sym_operator_assignment] = STATE(11398),
    [sym_conditional] = STATE(11398),
    [sym_method] = STATE(2722),
    [sym_singleton_method] = STATE(2722),
    [sym__variable] = STATE(2724),
    [sym_left_assignment_list] = STATE(2723),
    [sym_rational] = STATE(2722),
    [sym_true] = STATE(2726),
    [sym_return] = STATE(2722),
    [sym_subshell] = STATE(2722),
    [sym_yield] = STATE(2722),
    [sym_string] = STATE(5357),
    [sym_unless] = STATE(2722),
    [sym_lambda] = STATE(2722),
    [sym_parenthesized_statements] = STATE(2722),
    [sym_element_reference] = STATE(2726),
    [sym_range] = STATE(11398),
    [sym_binary] = STATE(11398),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2722),
    [sym_break] = STATE(2722),
    [sym_next] = STATE(2722),
    [sym_string_array] = STATE(2722),
    [sym_while] = STATE(2722),
    [sym_case] = STATE(2722),
    [sym_symbol_array] = STATE(2722),
    [sym_array] = STATE(2722),
    [sym_hash] = STATE(2722),
    [sym_false] = STATE(2726),
    [sym_nil] = STATE(2726),
    [sym_scope_resolution] = STATE(2724),
    [sym_call] = STATE(2724),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4616),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_not] = ACTIONS(4638),
    [sym_self] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4642),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4622),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4622),
    [anon_sym_PLUS] = ACTIONS(8717),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(4628),
    [sym_character] = ACTIONS(4622),
    [sym_super] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4644),
    [anon_sym_next] = ACTIONS(4646),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4616),
    [sym_constant] = ACTIONS(4620),
    [anon_sym_defined_QMARK] = ACTIONS(4630),
    [sym_instance_variable] = ACTIONS(4628),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(8629),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(4620),
    [sym_redo] = ACTIONS(4616),
    [sym_class_variable] = ACTIONS(4628),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4618),
  },
  [10245] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_EQ_GT] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
  },
  [10246] = {
    [sym_assignment] = STATE(11399),
    [sym_unary] = STATE(11399),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2749),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_chained_string] = STATE(189),
    [sym_until] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_for] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_if] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__arg] = STATE(11399),
    [sym__primary] = STATE(189),
    [sym_method_call] = STATE(2749),
    [sym_operator_assignment] = STATE(11399),
    [sym_conditional] = STATE(11399),
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym__variable] = STATE(193),
    [sym_left_assignment_list] = STATE(2751),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(2749),
    [sym_return] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_string] = STATE(2752),
    [sym_unless] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(2749),
    [sym_range] = STATE(11399),
    [sym_binary] = STATE(11399),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_while] = STATE(189),
    [sym_case] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_false] = STATE(2749),
    [sym_nil] = STATE(2749),
    [sym_scope_resolution] = STATE(193),
    [sym_call] = STATE(193),
    [sym__symbol_start] = ACTIONS(347),
    [sym_float] = ACTIONS(293),
    [anon_sym_TRUE] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_until] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_not] = ACTIONS(4666),
    [sym_self] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_break] = ACTIONS(4670),
    [anon_sym_unless] = ACTIONS(303),
    [sym__symbol_array_start] = ACTIONS(309),
    [sym__subshell_start] = ACTIONS(357),
    [sym__simple_symbol] = ACTIONS(311),
    [anon_sym_class] = ACTIONS(355),
    [anon_sym_false] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_begin] = ACTIONS(361),
    [sym_complex] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_nil] = ACTIONS(315),
    [sym_global_variable] = ACTIONS(323),
    [sym_character] = ACTIONS(301),
    [sym_super] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(317),
    [sym__unary_minus] = ACTIONS(4674),
    [anon_sym_next] = ACTIONS(4676),
    [anon_sym_while] = ACTIONS(321),
    [sym_retry] = ACTIONS(293),
    [sym_constant] = ACTIONS(297),
    [anon_sym_defined_QMARK] = ACTIONS(4678),
    [sym_instance_variable] = ACTIONS(323),
    [sym_integer] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [sym__string_start] = ACTIONS(329),
    [sym__regex_start] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(335),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(315),
    [anon_sym_FALSE] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(341),
    [sym_identifier] = ACTIONS(297),
    [sym_redo] = ACTIONS(293),
    [sym_class_variable] = ACTIONS(323),
    [sym__string_array_start] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(4680),
  },
  [10247] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15173),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [10248] = {
    [anon_sym_end] = ACTIONS(16178),
    [sym_comment] = ACTIONS(49),
  },
  [10249] = {
    [aux_sym_exceptions_repeat1] = STATE(10249),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16180),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [10250] = {
    [anon_sym_LT] = ACTIONS(4728),
    [anon_sym_SLASH] = ACTIONS(4730),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4732),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(4734),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4738),
    [anon_sym_LT_LT] = ACTIONS(4734),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4736),
    [sym__binary_star] = ACTIONS(4740),
    [anon_sym_PLUS] = ACTIONS(4742),
    [anon_sym_AMP] = ACTIONS(4744),
    [anon_sym_GT] = ACTIONS(4728),
    [anon_sym_PERCENT] = ACTIONS(4730),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(4746),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4746),
    [anon_sym_BANG_TILDE] = ACTIONS(4736),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR] = ACTIONS(4730),
    [anon_sym_PIPE] = ACTIONS(4750),
    [anon_sym_DOT_DOT] = ACTIONS(4752),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_LT_EQ_GT] = ACTIONS(4736),
    [anon_sym_LT_EQ] = ACTIONS(4728),
    [sym__binary_minus] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(4750),
  },
  [10251] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [10252] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [10253] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(5461),
    [sym_unary] = STATE(5461),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(915),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5461),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(915),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(5461),
    [sym_conditional] = STATE(5461),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(918),
    [sym_left_assignment_list] = STATE(919),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5462),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(915),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(915),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(5461),
    [sym_binary] = STATE(5461),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(915),
    [sym_nil] = STATE(915),
    [sym_scope_resolution] = STATE(918),
    [sym_call] = STATE(918),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1671),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1675),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1671),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(8876),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1679),
    [anon_sym_defined_QMARK] = ACTIONS(1681),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(8878),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(8876),
    [anon_sym_yield] = ACTIONS(1687),
    [sym_class_variable] = ACTIONS(1679),
    [sym__block_ampersand] = ACTIONS(8880),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1691),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1697),
    [anon_sym_next] = ACTIONS(1699),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14913),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1669),
  },
  [10254] = {
    [sym_heredoc_body] = STATE(10254),
    [aux_sym_call_repeat1] = STATE(10254),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10255] = {
    [sym_heredoc_body] = STATE(10254),
    [aux_sym_call_repeat1] = STATE(10254),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10256] = {
    [aux_sym_argument_list_repeat1] = STATE(10256),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16183),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10257] = {
    [sym_assignment] = STATE(8195),
    [sym_unary] = STATE(8195),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8195),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(8195),
    [sym_conditional] = STATE(8195),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_true] = STATE(2823),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(8195),
    [sym_binary] = STATE(8195),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(8882),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [sym_global_variable] = ACTIONS(4796),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4788),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [10258] = {
    [aux_sym_exceptions_repeat1] = STATE(11401),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16186),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10259] = {
    [sym_assignment] = STATE(11402),
    [sym_unary] = STATE(11402),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2823),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(11402),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(2823),
    [sym_operator_assignment] = STATE(11402),
    [sym_conditional] = STATE(11402),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(2826),
    [sym_left_assignment_list] = STATE(2827),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(2823),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(2828),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(2823),
    [sym_range] = STATE(11402),
    [sym_binary] = STATE(11402),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(2823),
    [sym_nil] = STATE(2823),
    [sym_scope_resolution] = STATE(2826),
    [sym_call] = STATE(2826),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4784),
    [anon_sym_not] = ACTIONS(4786),
    [sym_self] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4790),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4796),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(4788),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4798),
    [anon_sym_next] = ACTIONS(4800),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(4788),
    [anon_sym_defined_QMARK] = ACTIONS(4802),
    [sym_instance_variable] = ACTIONS(4796),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4788),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(4796),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4806),
  },
  [10260] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10261] = {
    [anon_sym_RPAREN] = ACTIONS(16188),
    [sym_comment] = ACTIONS(49),
  },
  [10262] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10263] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [10264] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [10265] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [10266] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [10267] = {
    [sym_assignment] = STATE(11404),
    [sym_unary] = STATE(11404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11404),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11404),
    [sym_conditional] = STATE(11404),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11404),
    [sym_binary] = STATE(11404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10268] = {
    [sym_assignment] = STATE(11405),
    [sym_unary] = STATE(11405),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11405),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_splat_argument] = STATE(11406),
    [sym_operator_assignment] = STATE(11405),
    [sym_conditional] = STATE(11405),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_return] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_subshell] = STATE(8224),
    [sym__arg_or_splat_arg] = STATE(11406),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11405),
    [sym_binary] = STATE(11405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(12666),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10269] = {
    [sym_assignment] = STATE(11407),
    [sym_unary] = STATE(11407),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11407),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11407),
    [sym_conditional] = STATE(11407),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11407),
    [sym_binary] = STATE(11407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10270] = {
    [sym_assignment] = STATE(11408),
    [sym_unary] = STATE(11408),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11408),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11408),
    [sym_conditional] = STATE(11408),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11408),
    [sym_binary] = STATE(11408),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10271] = {
    [sym_assignment] = STATE(11410),
    [sym_unary] = STATE(11410),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11410),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11410),
    [sym_conditional] = STATE(11410),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11410),
    [sym_binary] = STATE(11410),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10272] = {
    [sym_assignment] = STATE(11411),
    [sym_unary] = STATE(11411),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11411),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11411),
    [sym_conditional] = STATE(11411),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11411),
    [sym_binary] = STATE(11411),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10273] = {
    [sym_assignment] = STATE(11412),
    [sym_unary] = STATE(11412),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11412),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11412),
    [sym_conditional] = STATE(11412),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11412),
    [sym_binary] = STATE(11412),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10274] = {
    [sym_assignment] = STATE(11413),
    [sym_unary] = STATE(11413),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11413),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11413),
    [sym_conditional] = STATE(11413),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11413),
    [sym_binary] = STATE(11413),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10275] = {
    [sym_assignment] = STATE(11414),
    [sym_unary] = STATE(11414),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11414),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11414),
    [sym_conditional] = STATE(11414),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11414),
    [sym_binary] = STATE(11414),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10276] = {
    [sym_assignment] = STATE(11415),
    [sym_unary] = STATE(11415),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11415),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11415),
    [sym_conditional] = STATE(11415),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11415),
    [sym_binary] = STATE(11415),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10277] = {
    [sym_assignment] = STATE(11416),
    [sym_unary] = STATE(11416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11416),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(11416),
    [sym_conditional] = STATE(11416),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11416),
    [sym_binary] = STATE(11416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [10278] = {
    [aux_sym_chained_string_repeat1] = STATE(11417),
    [sym_string] = STATE(11417),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [10279] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(5487),
    [sym_unary] = STATE(5487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1004),
    [sym_singleton_class] = STATE(999),
    [sym_module] = STATE(999),
    [sym_chained_string] = STATE(999),
    [sym_until] = STATE(999),
    [sym_regex] = STATE(999),
    [sym_for] = STATE(999),
    [sym_symbol] = STATE(999),
    [sym_if] = STATE(999),
    [sym_begin] = STATE(999),
    [sym__arg] = STATE(5487),
    [sym__primary] = STATE(999),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(1004),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(5487),
    [sym_conditional] = STATE(5487),
    [sym_method] = STATE(999),
    [sym_singleton_method] = STATE(999),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1001),
    [sym_return] = STATE(999),
    [sym_yield] = STATE(999),
    [sym_string] = STATE(5488),
    [sym_rational] = STATE(999),
    [sym_subshell] = STATE(999),
    [sym_true] = STATE(1004),
    [sym_unless] = STATE(999),
    [sym_lambda] = STATE(999),
    [sym_parenthesized_statements] = STATE(999),
    [sym_element_reference] = STATE(1004),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(5487),
    [sym_binary] = STATE(5487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(999),
    [sym_break] = STATE(999),
    [sym_next] = STATE(999),
    [sym_string_array] = STATE(999),
    [sym_while] = STATE(999),
    [sym_case] = STATE(999),
    [sym_symbol_array] = STATE(999),
    [sym_array] = STATE(999),
    [sym_hash] = STATE(999),
    [sym_false] = STATE(1004),
    [sym_nil] = STATE(1004),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1805),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1811),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(1813),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(1811),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(8924),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(1821),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(8926),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(8924),
    [anon_sym_yield] = ACTIONS(1827),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(8928),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(1835),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1837),
    [anon_sym_next] = ACTIONS(1839),
    [sym_retry] = ACTIONS(1805),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14955),
    [sym_redo] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1807),
  },
  [10280] = {
    [sym_heredoc_body] = STATE(10280),
    [aux_sym_call_repeat1] = STATE(10280),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10281] = {
    [sym_heredoc_body] = STATE(10280),
    [aux_sym_call_repeat1] = STATE(10280),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10282] = {
    [aux_sym_argument_list_repeat1] = STATE(10282),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16190),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10283] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
  },
  [10284] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
  },
  [10285] = {
    [anon_sym_end] = ACTIONS(16193),
    [sym_comment] = ACTIONS(49),
  },
  [10286] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
  },
  [10287] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
  },
  [10288] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
  },
  [10289] = {
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_in] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_EQ] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
  },
  [10290] = {
    [anon_sym_end] = ACTIONS(16195),
    [sym_comment] = ACTIONS(49),
  },
  [10291] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
  },
  [10292] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [10293] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [10294] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1103),
    [sym_singleton_class] = STATE(1098),
    [sym_module] = STATE(1098),
    [sym_chained_string] = STATE(1098),
    [sym_until] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_for] = STATE(1098),
    [sym_symbol] = STATE(1098),
    [sym_if] = STATE(1098),
    [sym_begin] = STATE(1098),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1098),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(1103),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_method] = STATE(1098),
    [sym_singleton_method] = STATE(1098),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(1100),
    [sym_return] = STATE(1098),
    [sym_yield] = STATE(1098),
    [sym_string] = STATE(5562),
    [sym_rational] = STATE(1098),
    [sym_subshell] = STATE(1098),
    [sym_true] = STATE(1103),
    [sym_unless] = STATE(1098),
    [sym_lambda] = STATE(1098),
    [sym_parenthesized_statements] = STATE(1098),
    [sym_element_reference] = STATE(1103),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1098),
    [sym_break] = STATE(1098),
    [sym_next] = STATE(1098),
    [sym_string_array] = STATE(1098),
    [sym_while] = STATE(1098),
    [sym_case] = STATE(1098),
    [sym_symbol_array] = STATE(1098),
    [sym_array] = STATE(1098),
    [sym_hash] = STATE(1098),
    [sym_false] = STATE(1103),
    [sym_nil] = STATE(1103),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(1929),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1937),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1933),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(9023),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(1945),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(9025),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9023),
    [anon_sym_yield] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9027),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(1955),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(1959),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(1961),
    [anon_sym_next] = ACTIONS(1963),
    [sym_retry] = ACTIONS(1929),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(14974),
    [sym_redo] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(1967),
  },
  [10295] = {
    [sym_heredoc_body] = STATE(10295),
    [aux_sym_call_repeat1] = STATE(10295),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_in] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10296] = {
    [sym_heredoc_body] = STATE(10295),
    [aux_sym_call_repeat1] = STATE(10295),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_in] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10297] = {
    [aux_sym_argument_list_repeat1] = STATE(10297),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16197),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10298] = {
    [sym_assignment] = STATE(8274),
    [sym_unary] = STATE(8274),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(8274),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(8274),
    [sym_conditional] = STATE(8274),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_return] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_true] = STATE(2924),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(8274),
    [sym_binary] = STATE(8274),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(9029),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [sym_global_variable] = ACTIONS(4936),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4928),
    [sym_character] = ACTIONS(4932),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [10299] = {
    [aux_sym_exceptions_repeat1] = STATE(11420),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_in] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16200),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10300] = {
    [sym_assignment] = STATE(11421),
    [sym_unary] = STATE(11421),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2924),
    [sym_singleton_class] = STATE(2926),
    [sym_module] = STATE(2926),
    [sym_chained_string] = STATE(2926),
    [sym_until] = STATE(2926),
    [sym_regex] = STATE(2926),
    [sym_for] = STATE(2926),
    [sym_symbol] = STATE(2926),
    [sym_if] = STATE(2926),
    [sym_begin] = STATE(2926),
    [sym__arg] = STATE(11421),
    [sym__primary] = STATE(2926),
    [sym_method_call] = STATE(2924),
    [sym_operator_assignment] = STATE(11421),
    [sym_conditional] = STATE(11421),
    [sym_method] = STATE(2926),
    [sym_singleton_method] = STATE(2926),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(2928),
    [sym_rational] = STATE(2926),
    [sym_true] = STATE(2924),
    [sym_return] = STATE(2926),
    [sym_subshell] = STATE(2926),
    [sym_yield] = STATE(2926),
    [sym_string] = STATE(2929),
    [sym_unless] = STATE(2926),
    [sym_lambda] = STATE(2926),
    [sym_parenthesized_statements] = STATE(2926),
    [sym_element_reference] = STATE(2924),
    [sym_range] = STATE(11421),
    [sym_binary] = STATE(11421),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2926),
    [sym_break] = STATE(2926),
    [sym_next] = STATE(2926),
    [sym_string_array] = STATE(2926),
    [sym_while] = STATE(2926),
    [sym_case] = STATE(2926),
    [sym_symbol_array] = STATE(2926),
    [sym_array] = STATE(2926),
    [sym_hash] = STATE(2926),
    [sym_false] = STATE(2924),
    [sym_nil] = STATE(2924),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4920),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(4924),
    [anon_sym_not] = ACTIONS(4926),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(4930),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4932),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(4932),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_next] = ACTIONS(4940),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4920),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(4920),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(4946),
  },
  [10301] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10302] = {
    [anon_sym_RPAREN] = ACTIONS(16202),
    [sym_comment] = ACTIONS(49),
  },
  [10303] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10304] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [10305] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [10306] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [10307] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [10308] = {
    [sym_assignment] = STATE(11423),
    [sym_unary] = STATE(11423),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11423),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11423),
    [sym_conditional] = STATE(11423),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11423),
    [sym_binary] = STATE(11423),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10309] = {
    [sym_assignment] = STATE(11424),
    [sym_unary] = STATE(11424),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11424),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_splat_argument] = STATE(11425),
    [sym_operator_assignment] = STATE(11424),
    [sym_conditional] = STATE(11424),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_return] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_subshell] = STATE(8304),
    [sym__arg_or_splat_arg] = STATE(11425),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11424),
    [sym_binary] = STATE(11424),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [sym_global_variable] = ACTIONS(4936),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4928),
    [sym_character] = ACTIONS(12768),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10310] = {
    [sym_assignment] = STATE(11426),
    [sym_unary] = STATE(11426),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11426),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11426),
    [sym_conditional] = STATE(11426),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11426),
    [sym_binary] = STATE(11426),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10311] = {
    [sym_assignment] = STATE(11427),
    [sym_unary] = STATE(11427),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11427),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11427),
    [sym_conditional] = STATE(11427),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11427),
    [sym_binary] = STATE(11427),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10312] = {
    [sym_assignment] = STATE(11429),
    [sym_unary] = STATE(11429),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11429),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11429),
    [sym_conditional] = STATE(11429),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11429),
    [sym_binary] = STATE(11429),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10313] = {
    [sym_assignment] = STATE(11430),
    [sym_unary] = STATE(11430),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11430),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11430),
    [sym_conditional] = STATE(11430),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11430),
    [sym_binary] = STATE(11430),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10314] = {
    [sym_assignment] = STATE(11431),
    [sym_unary] = STATE(11431),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11431),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11431),
    [sym_conditional] = STATE(11431),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11431),
    [sym_binary] = STATE(11431),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10315] = {
    [sym_assignment] = STATE(11432),
    [sym_unary] = STATE(11432),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11432),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11432),
    [sym_conditional] = STATE(11432),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11432),
    [sym_binary] = STATE(11432),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10316] = {
    [sym_assignment] = STATE(11433),
    [sym_unary] = STATE(11433),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11433),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11433),
    [sym_conditional] = STATE(11433),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11433),
    [sym_binary] = STATE(11433),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10317] = {
    [sym_assignment] = STATE(11434),
    [sym_unary] = STATE(11434),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11434),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11434),
    [sym_conditional] = STATE(11434),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11434),
    [sym_binary] = STATE(11434),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10318] = {
    [sym_assignment] = STATE(11435),
    [sym_unary] = STATE(11435),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11435),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(11435),
    [sym_conditional] = STATE(11435),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11435),
    [sym_binary] = STATE(11435),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [10319] = {
    [aux_sym_chained_string_repeat1] = STATE(11436),
    [sym_string] = STATE(11436),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [10320] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(2948),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5590),
    [sym_rational] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym_float] = ACTIONS(4956),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(1931),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(1931),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(9073),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(1943),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [sym__identifier_hash_key] = ACTIONS(9075),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(9073),
    [anon_sym_yield] = ACTIONS(4970),
    [sym_class_variable] = ACTIONS(1943),
    [sym__block_ampersand] = ACTIONS(9077),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(4974),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(4978),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4956),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15016),
    [sym_redo] = ACTIONS(4956),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [10321] = {
    [sym_heredoc_body] = STATE(10321),
    [aux_sym_call_repeat1] = STATE(10321),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_in] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10322] = {
    [sym_heredoc_body] = STATE(10321),
    [aux_sym_call_repeat1] = STATE(10321),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_in] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10323] = {
    [aux_sym_argument_list_repeat1] = STATE(10323),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_in] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16204),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10324] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10325] = {
    [aux_sym_exceptions_repeat1] = STATE(10325),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16207),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10326] = {
    [sym_assignment] = STATE(8320),
    [sym_unary] = STATE(8320),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(8320),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(8320),
    [sym_conditional] = STATE(8320),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_return] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_true] = STATE(2951),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(8320),
    [sym_binary] = STATE(8320),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(4976),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [sym_global_variable] = ACTIONS(1943),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(1931),
    [sym_character] = ACTIONS(4960),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [10327] = {
    [aux_sym_exceptions_repeat1] = STATE(11437),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_in] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16210),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10328] = {
    [sym_assignment] = STATE(11438),
    [sym_unary] = STATE(11438),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2951),
    [sym_singleton_class] = STATE(2948),
    [sym_module] = STATE(2948),
    [sym_chained_string] = STATE(2948),
    [sym_until] = STATE(2948),
    [sym_regex] = STATE(2948),
    [sym_for] = STATE(2948),
    [sym_symbol] = STATE(2948),
    [sym_if] = STATE(2948),
    [sym_begin] = STATE(2948),
    [sym__arg] = STATE(11438),
    [sym__primary] = STATE(2948),
    [sym_method_call] = STATE(2951),
    [sym_operator_assignment] = STATE(11438),
    [sym_conditional] = STATE(11438),
    [sym_method] = STATE(2948),
    [sym_singleton_method] = STATE(2948),
    [sym__variable] = STATE(1101),
    [sym_left_assignment_list] = STATE(2949),
    [sym_rational] = STATE(2948),
    [sym_true] = STATE(2951),
    [sym_return] = STATE(2948),
    [sym_subshell] = STATE(2948),
    [sym_yield] = STATE(2948),
    [sym_string] = STATE(5602),
    [sym_unless] = STATE(2948),
    [sym_lambda] = STATE(2948),
    [sym_parenthesized_statements] = STATE(2948),
    [sym_element_reference] = STATE(2951),
    [sym_range] = STATE(11438),
    [sym_binary] = STATE(11438),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2948),
    [sym_break] = STATE(2948),
    [sym_next] = STATE(2948),
    [sym_string_array] = STATE(2948),
    [sym_while] = STATE(2948),
    [sym_case] = STATE(2948),
    [sym_symbol_array] = STATE(2948),
    [sym_array] = STATE(2948),
    [sym_hash] = STATE(2948),
    [sym_false] = STATE(2951),
    [sym_nil] = STATE(2951),
    [sym_scope_resolution] = STATE(1101),
    [sym_call] = STATE(1101),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(4956),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(4962),
    [anon_sym_not] = ACTIONS(4974),
    [sym_self] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(4978),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(4960),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(4960),
    [anon_sym_PLUS] = ACTIONS(9093),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(1943),
    [sym_character] = ACTIONS(4960),
    [sym_super] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(4980),
    [anon_sym_next] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(4956),
    [sym_constant] = ACTIONS(1931),
    [anon_sym_defined_QMARK] = ACTIONS(4966),
    [sym_instance_variable] = ACTIONS(1943),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1931),
    [sym_redo] = ACTIONS(4956),
    [sym_class_variable] = ACTIONS(1943),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(4958),
  },
  [10329] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_in] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5002),
    [anon_sym_LT_LT] = ACTIONS(5000),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(4998),
    [sym__binary_star] = ACTIONS(4994),
    [anon_sym_PLUS] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(5010),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(4998),
    [anon_sym_BANG_TILDE] = ACTIONS(4998),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(4998),
    [anon_sym_STAR_STAR] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_DOT_DOT] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_LT_EQ_GT] = ACTIONS(4998),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [sym__binary_minus] = ACTIONS(5006),
    [anon_sym_CARET] = ACTIONS(5018),
  },
  [10330] = {
    [sym_assignment] = STATE(11439),
    [sym_unary] = STATE(11439),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11439),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(11439),
    [sym_conditional] = STATE(11439),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(11439),
    [sym_binary] = STATE(11439),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [10331] = {
    [sym_assignment] = STATE(692),
    [sym_unary] = STATE(692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(692),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(692),
    [sym_conditional] = STATE(692),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(692),
    [sym_binary] = STATE(692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [10332] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(16216),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [10333] = {
    [sym_assignment] = STATE(11442),
    [sym_unary] = STATE(11442),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11442),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(11442),
    [sym_conditional] = STATE(11442),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(11442),
    [sym_binary] = STATE(11442),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [10334] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(16218),
    [sym_identifier] = ACTIONS(16218),
  },
  [10335] = {
    [anon_sym_COLON] = ACTIONS(16220),
    [sym_comment] = ACTIONS(49),
  },
  [10336] = {
    [sym__argument] = STATE(11450),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(11450),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(11450),
    [sym_hash_splat_argument] = STATE(11450),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(731),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(11453),
    [sym_block_argument] = STATE(11450),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [10337] = {
    [sym_assignment] = STATE(11463),
    [sym_unary] = STATE(11463),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(11463),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(11463),
    [sym_conditional] = STATE(11463),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(11463),
    [sym_binary] = STATE(11463),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [10338] = {
    [sym_assignment] = STATE(11468),
    [sym_unary] = STATE(11468),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(11468),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(11468),
    [sym_conditional] = STATE(11468),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(11468),
    [sym_binary] = STATE(11468),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [10339] = {
    [sym__argument] = STATE(11450),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(11450),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(11450),
    [sym_hash_splat_argument] = STATE(11450),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(779),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(11453),
    [sym_block_argument] = STATE(11450),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [10340] = {
    [sym__argument] = STATE(11450),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(11450),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(11450),
    [sym_hash_splat_argument] = STATE(11450),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(793),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(11453),
    [sym_block_argument] = STATE(11450),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [10341] = {
    [sym_assignment] = STATE(11469),
    [sym_unary] = STATE(11469),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(11469),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(11469),
    [sym_conditional] = STATE(11469),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(11469),
    [sym_binary] = STATE(11469),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [10342] = {
    [sym__argument] = STATE(11450),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(11450),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(11450),
    [sym_hash_splat_argument] = STATE(11450),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(802),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(11453),
    [sym_block_argument] = STATE(11450),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [10343] = {
    [sym_heredoc_body] = STATE(11471),
    [aux_sym_call_repeat1] = STATE(11471),
    [aux_sym_argument_list_repeat1] = STATE(11472),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16258),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [10344] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(16260),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(16260),
    [anon_sym_SLASH_EQ] = ACTIONS(16260),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(16260),
    [anon_sym_PIPE_EQ] = ACTIONS(16260),
    [anon_sym_LT_LT_EQ] = ACTIONS(16260),
    [anon_sym_PLUS_EQ] = ACTIONS(16260),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16260),
    [anon_sym_STAR_EQ] = ACTIONS(16260),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16260),
    [anon_sym_CARET_EQ] = ACTIONS(16260),
    [anon_sym_DASH_EQ] = ACTIONS(16260),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16260),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(16262),
  },
  [10345] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_EQ_GT] = ACTIONS(16220),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [10346] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(16290),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(16292),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(16294),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [10347] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym__primary] = STATE(10380),
    [sym_argument_list] = STATE(859),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_method] = STATE(10380),
    [sym_conditional] = STATE(11492),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_subshell] = STATE(10380),
    [sym_unless] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10384),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_call] = STATE(10382),
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_rational] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_lambda] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(11492),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_nil] = STATE(10384),
    [sym_symbol_array] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_scope_resolution] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10348] = {
    [anon_sym_EQ] = ACTIONS(16304),
    [sym_comment] = ACTIONS(3),
  },
  [10349] = {
    [aux_sym_chained_string_repeat1] = STATE(11495),
    [sym_string] = STATE(11495),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(16306),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [10350] = {
    [sym_heredoc_body] = STATE(11471),
    [aux_sym_call_repeat1] = STATE(11471),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [10351] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [10352] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [10353] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [10354] = {
    [sym_assignment] = STATE(11496),
    [sym_unary] = STATE(11496),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11496),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11496),
    [sym_conditional] = STATE(11496),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11496),
    [sym_binary] = STATE(11496),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10355] = {
    [sym_assignment] = STATE(11498),
    [sym_unary] = STATE(11498),
    [sym_right_assignment_list] = STATE(4859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11498),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_splat_argument] = STATE(11499),
    [sym_operator_assignment] = STATE(11498),
    [sym_conditional] = STATE(11498),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_return] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_subshell] = STATE(8351),
    [sym__arg_or_splat_arg] = STATE(11499),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11498),
    [sym_binary] = STATE(11498),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(16310),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [sym_global_variable] = ACTIONS(12811),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(12803),
    [sym_character] = ACTIONS(12805),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10356] = {
    [sym_assignment] = STATE(11500),
    [sym_unary] = STATE(11500),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11500),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11500),
    [sym_conditional] = STATE(11500),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11500),
    [sym_binary] = STATE(11500),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10357] = {
    [sym_assignment] = STATE(11501),
    [sym_unary] = STATE(11501),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11501),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11501),
    [sym_conditional] = STATE(11501),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11501),
    [sym_binary] = STATE(11501),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10358] = {
    [sym_assignment] = STATE(11502),
    [sym_unary] = STATE(11502),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11502),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11502),
    [sym_conditional] = STATE(11502),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11502),
    [sym_binary] = STATE(11502),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10359] = {
    [sym_assignment] = STATE(11503),
    [sym_unary] = STATE(11503),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11503),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11503),
    [sym_conditional] = STATE(11503),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11503),
    [sym_binary] = STATE(11503),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10360] = {
    [sym_assignment] = STATE(11504),
    [sym_unary] = STATE(11504),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11504),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11504),
    [sym_conditional] = STATE(11504),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11504),
    [sym_binary] = STATE(11504),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10361] = {
    [sym_assignment] = STATE(11505),
    [sym_unary] = STATE(11505),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11505),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11505),
    [sym_conditional] = STATE(11505),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11505),
    [sym_binary] = STATE(11505),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10362] = {
    [sym_assignment] = STATE(11506),
    [sym_unary] = STATE(11506),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11506),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11506),
    [sym_conditional] = STATE(11506),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11506),
    [sym_binary] = STATE(11506),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10363] = {
    [sym_assignment] = STATE(11507),
    [sym_unary] = STATE(11507),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11507),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11507),
    [sym_conditional] = STATE(11507),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11507),
    [sym_binary] = STATE(11507),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10364] = {
    [sym_assignment] = STATE(11508),
    [sym_unary] = STATE(11508),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11508),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11508),
    [sym_conditional] = STATE(11508),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11508),
    [sym_binary] = STATE(11508),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10365] = {
    [sym_assignment] = STATE(11509),
    [sym_unary] = STATE(11509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11509),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(11509),
    [sym_conditional] = STATE(11509),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11509),
    [sym_binary] = STATE(11509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [10366] = {
    [sym_heredoc_body] = STATE(11514),
    [sym__argument_list_with_parens] = STATE(11513),
    [aux_sym_call_repeat1] = STATE(11514),
    [sym_argument_list_with_parens] = STATE(11512),
    [sym_operator] = STATE(11512),
    [anon_sym_LT] = ACTIONS(16312),
    [anon_sym_SLASH] = ACTIONS(16314),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(16314),
    [anon_sym_PLUS_AT] = ACTIONS(16314),
    [anon_sym_LPAREN2] = ACTIONS(16316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16314),
    [anon_sym_GT_GT] = ACTIONS(16314),
    [anon_sym_EQ_TILDE] = ACTIONS(16314),
    [anon_sym_LT_LT] = ACTIONS(16314),
    [anon_sym_TILDE] = ACTIONS(16314),
    [anon_sym_PLUS] = ACTIONS(16312),
    [anon_sym_AMP] = ACTIONS(16314),
    [anon_sym_GT] = ACTIONS(16312),
    [anon_sym_PERCENT] = ACTIONS(16314),
    [anon_sym_DASH_AT] = ACTIONS(16314),
    [anon_sym_EQ_EQ] = ACTIONS(16312),
    [anon_sym_STAR] = ACTIONS(16312),
    [anon_sym_BANG_TILDE] = ACTIONS(16314),
    [sym_constant] = ACTIONS(16318),
    [anon_sym_DASH] = ACTIONS(16312),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(16314),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(16312),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(16314),
    [anon_sym_STAR_STAR] = ACTIONS(16314),
    [anon_sym_PIPE] = ACTIONS(16314),
    [anon_sym_DOT_DOT] = ACTIONS(16314),
    [anon_sym_LT_EQ_GT] = ACTIONS(16314),
    [anon_sym_LT_EQ] = ACTIONS(16312),
    [anon_sym_BANG] = ACTIONS(16312),
    [sym_identifier] = ACTIONS(16318),
    [anon_sym_CARET] = ACTIONS(16314),
  },
  [10367] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(16320),
    [sym_identifier] = ACTIONS(16320),
  },
  [10368] = {
    [sym_assignment] = STATE(11516),
    [sym_unary] = STATE(11516),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11516),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(11516),
    [sym_conditional] = STATE(11516),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(11516),
    [sym_binary] = STATE(11516),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [10369] = {
    [sym_assignment] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [10370] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(16324),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [10371] = {
    [sym_assignment] = STATE(11519),
    [sym_unary] = STATE(11519),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11519),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(11519),
    [sym_conditional] = STATE(11519),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(11519),
    [sym_binary] = STATE(11519),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [10372] = {
    [anon_sym_COLON] = ACTIONS(16326),
    [sym_comment] = ACTIONS(49),
  },
  [10373] = {
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(2538),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10374] = {
    [sym_assignment] = STATE(11529),
    [sym_unary] = STATE(11529),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(11529),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(11529),
    [sym_conditional] = STATE(11529),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(11529),
    [sym_binary] = STATE(11529),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [10375] = {
    [sym_assignment] = STATE(11534),
    [sym_unary] = STATE(11534),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(11534),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(11534),
    [sym_conditional] = STATE(11534),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(11534),
    [sym_binary] = STATE(11534),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [10376] = {
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(2549),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10377] = {
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(2563),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10378] = {
    [sym_assignment] = STATE(11535),
    [sym_unary] = STATE(11535),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(11535),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(11535),
    [sym_conditional] = STATE(11535),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(11535),
    [sym_binary] = STATE(11535),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [10379] = {
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(2572),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10380] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(16290),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(16292),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(16294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [10381] = {
    [anon_sym_EQ] = ACTIONS(16354),
    [sym_comment] = ACTIONS(3),
  },
  [10382] = {
    [sym_block] = STATE(857),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym__primary] = STATE(10380),
    [sym_argument_list] = STATE(2576),
    [sym_hash_splat_argument] = STATE(11491),
    [sym_method] = STATE(10380),
    [sym_conditional] = STATE(11492),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_subshell] = STATE(10380),
    [sym_unless] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_block_argument] = STATE(11491),
    [sym_range] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10384),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_call] = STATE(10382),
    [sym__argument] = STATE(11491),
    [sym_assignment] = STATE(11492),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_pair] = STATE(11491),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(11491),
    [sym_operator_assignment] = STATE(11492),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_rational] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_lambda] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(11494),
    [sym_do_block] = STATE(857),
    [sym_binary] = STATE(11492),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_nil] = STATE(10384),
    [sym_symbol_array] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_scope_resolution] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(4384),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(16300),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [10383] = {
    [sym_heredoc_body] = STATE(11538),
    [aux_sym_call_repeat1] = STATE(11538),
    [aux_sym_argument_list_repeat1] = STATE(11539),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16356),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [10384] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(16358),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(16358),
    [anon_sym_SLASH_EQ] = ACTIONS(16358),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(16358),
    [anon_sym_PIPE_EQ] = ACTIONS(16358),
    [anon_sym_LT_LT_EQ] = ACTIONS(16358),
    [anon_sym_PLUS_EQ] = ACTIONS(16358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16358),
    [anon_sym_STAR_EQ] = ACTIONS(16358),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16358),
    [anon_sym_CARET_EQ] = ACTIONS(16358),
    [anon_sym_DASH_EQ] = ACTIONS(16358),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16358),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(16360),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [10385] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_EQ_GT] = ACTIONS(16326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [10386] = {
    [aux_sym_chained_string_repeat1] = STATE(11550),
    [sym_string] = STATE(11550),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(16390),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [10387] = {
    [sym_heredoc_body] = STATE(11538),
    [aux_sym_call_repeat1] = STATE(11538),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [10388] = {
    [aux_sym_chained_string_repeat1] = STATE(11551),
    [sym_string] = STATE(11551),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [10389] = {
    [sym__line_break] = ACTIONS(16392),
    [sym_float] = ACTIONS(16394),
    [anon_sym_until] = ACTIONS(16394),
    [anon_sym_undef] = ACTIONS(16394),
    [sym_self] = ACTIONS(16394),
    [anon_sym_BEGIN] = ACTIONS(16394),
    [anon_sym_TILDE] = ACTIONS(16392),
    [anon_sym_unless] = ACTIONS(16394),
    [anon_sym_PLUS] = ACTIONS(16394),
    [sym__symbol_array_start] = ACTIONS(16392),
    [sym__simple_symbol] = ACTIONS(16392),
    [sym_complex] = ACTIONS(16392),
    [sym_heredoc_beginning] = ACTIONS(16392),
    [sym_super] = ACTIONS(16394),
    [anon_sym_alias] = ACTIONS(16394),
    [anon_sym_LBRACK2] = ACTIONS(16392),
    [anon_sym_nil] = ACTIONS(16394),
    [sym_character] = ACTIONS(16392),
    [anon_sym_LBRACE] = ACTIONS(16392),
    [anon_sym_END] = ACTIONS(16394),
    [sym_constant] = ACTIONS(16394),
    [anon_sym_while] = ACTIONS(16394),
    [sym_instance_variable] = ACTIONS(16392),
    [sym__heredoc_body_start] = ACTIONS(16392),
    [anon_sym_defined_QMARK] = ACTIONS(16392),
    [sym__string_start] = ACTIONS(16392),
    [anon_sym_true] = ACTIONS(16394),
    [anon_sym_for] = ACTIONS(16394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(16392),
    [anon_sym_NIL] = ACTIONS(16394),
    [anon_sym_COLON_COLON] = ACTIONS(16392),
    [anon_sym_def] = ACTIONS(16394),
    [sym_identifier] = ACTIONS(16394),
    [anon_sym_yield] = ACTIONS(16394),
    [sym_class_variable] = ACTIONS(16392),
    [sym__symbol_start] = ACTIONS(16392),
    [anon_sym_not] = ACTIONS(16394),
    [anon_sym_TRUE] = ACTIONS(16394),
    [anon_sym_case] = ACTIONS(16394),
    [anon_sym_SEMI] = ACTIONS(16392),
    [anon_sym_LPAREN] = ACTIONS(16392),
    [anon_sym_break] = ACTIONS(16394),
    [sym_global_variable] = ACTIONS(16392),
    [anon_sym_class] = ACTIONS(16394),
    [sym__subshell_start] = ACTIONS(16392),
    [anon_sym_module] = ACTIONS(16394),
    [anon_sym_begin] = ACTIONS(16394),
    [anon_sym_false] = ACTIONS(16394),
    [anon_sym_STAR] = ACTIONS(16392),
    [sym__unary_minus] = ACTIONS(16392),
    [anon_sym_next] = ACTIONS(16394),
    [sym_retry] = ACTIONS(16394),
    [sym__regex_start] = ACTIONS(16392),
    [anon_sym_end] = ACTIONS(16394),
    [sym_integer] = ACTIONS(16394),
    [anon_sym_FALSE] = ACTIONS(16394),
    [sym_redo] = ACTIONS(16394),
    [anon_sym_BANG] = ACTIONS(16392),
    [anon_sym_if] = ACTIONS(16394),
    [sym__string_array_start] = ACTIONS(16392),
    [anon_sym_return] = ACTIONS(16394),
  },
  [10390] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(16396),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [10391] = {
    [anon_sym_PIPE] = ACTIONS(16398),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(16398),
  },
  [10392] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(16398),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(16400),
  },
  [10393] = {
    [aux_sym_block_parameters_repeat1] = STATE(11553),
    [anon_sym_PIPE] = ACTIONS(16396),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [10394] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(16403),
  },
  [10395] = {
    [sym_splat_parameter] = STATE(5824),
    [sym_hash_splat_parameter] = STATE(5824),
    [sym_block_parameter] = STATE(5824),
    [sym__formal_parameter] = STATE(5824),
    [sym__simple_formal_parameter] = STATE(5824),
    [sym_keyword_parameter] = STATE(5824),
    [sym_optional_parameter] = STATE(5824),
    [sym_destructured_parameter] = STATE(5824),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [sym_comment] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(2041),
  },
  [10396] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [10397] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [10398] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(3000),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5664),
    [sym_rational] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym_float] = ACTIONS(5042),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(5046),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(5046),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(5054),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(9174),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9172),
    [anon_sym_yield] = ACTIONS(5062),
    [sym_class_variable] = ACTIONS(5054),
    [sym__block_ampersand] = ACTIONS(9176),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(5066),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [sym_retry] = ACTIONS(5042),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15160),
    [sym_redo] = ACTIONS(5042),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [10399] = {
    [sym_heredoc_body] = STATE(10399),
    [aux_sym_call_repeat1] = STATE(10399),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [10400] = {
    [sym_heredoc_body] = STATE(10399),
    [aux_sym_call_repeat1] = STATE(10399),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [10401] = {
    [aux_sym_argument_list_repeat1] = STATE(10401),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16405),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [10402] = {
    [sym_heredoc_body] = STATE(11555),
    [aux_sym_call_repeat1] = STATE(11555),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10403] = {
    [sym_heredoc_body] = STATE(11556),
    [aux_sym_call_repeat1] = STATE(11556),
    [aux_sym_argument_list_repeat1] = STATE(8392),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(9198),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10404] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10405] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10406] = {
    [aux_sym_exceptions_repeat1] = STATE(11558),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10407] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10408] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10409] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10410] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10411] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16408),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10412] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10413] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10414] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10415] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10416] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [10417] = {
    [aux_sym_chained_string_repeat1] = STATE(10417),
    [sym_string] = STATE(10417),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [10418] = {
    [sym_assignment] = STATE(8394),
    [sym_unary] = STATE(8394),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(8394),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(8394),
    [sym_conditional] = STATE(8394),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_return] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_true] = STATE(2998),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(8394),
    [sym_binary] = STATE(8394),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9178),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [sym_global_variable] = ACTIONS(5054),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(5046),
    [sym_character] = ACTIONS(5048),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [10419] = {
    [aux_sym_exceptions_repeat1] = STATE(11560),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16410),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [10420] = {
    [sym_assignment] = STATE(11561),
    [sym_unary] = STATE(11561),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(2998),
    [sym_singleton_class] = STATE(3000),
    [sym_module] = STATE(3000),
    [sym_chained_string] = STATE(3000),
    [sym_until] = STATE(3000),
    [sym_regex] = STATE(3000),
    [sym_for] = STATE(3000),
    [sym_symbol] = STATE(3000),
    [sym_if] = STATE(3000),
    [sym_begin] = STATE(3000),
    [sym__arg] = STATE(11561),
    [sym__primary] = STATE(3000),
    [sym_method_call] = STATE(2998),
    [sym_operator_assignment] = STATE(11561),
    [sym_conditional] = STATE(11561),
    [sym_method] = STATE(3000),
    [sym_singleton_method] = STATE(3000),
    [sym__variable] = STATE(3001),
    [sym_left_assignment_list] = STATE(3002),
    [sym_rational] = STATE(3000),
    [sym_true] = STATE(2998),
    [sym_return] = STATE(3000),
    [sym_subshell] = STATE(3000),
    [sym_yield] = STATE(3000),
    [sym_string] = STATE(5652),
    [sym_unless] = STATE(3000),
    [sym_lambda] = STATE(3000),
    [sym_parenthesized_statements] = STATE(3000),
    [sym_element_reference] = STATE(2998),
    [sym_range] = STATE(11561),
    [sym_binary] = STATE(11561),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3000),
    [sym_break] = STATE(3000),
    [sym_next] = STATE(3000),
    [sym_string_array] = STATE(3000),
    [sym_while] = STATE(3000),
    [sym_case] = STATE(3000),
    [sym_symbol_array] = STATE(3000),
    [sym_array] = STATE(3000),
    [sym_hash] = STATE(3000),
    [sym_false] = STATE(2998),
    [sym_nil] = STATE(2998),
    [sym_scope_resolution] = STATE(3001),
    [sym_call] = STATE(3001),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(5042),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_not] = ACTIONS(5066),
    [sym_self] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5048),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(5048),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5054),
    [sym_character] = ACTIONS(5048),
    [sym_super] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(5072),
    [anon_sym_next] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(5042),
    [sym_constant] = ACTIONS(5046),
    [anon_sym_defined_QMARK] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(5054),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(5046),
    [sym_redo] = ACTIONS(5042),
    [sym_class_variable] = ACTIONS(5054),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(5044),
  },
  [10421] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10422] = {
    [anon_sym_RPAREN] = ACTIONS(16412),
    [sym_comment] = ACTIONS(49),
  },
  [10423] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10424] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [10425] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [10426] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(5701),
    [sym_unary] = STATE(5701),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(5701),
    [sym__primary] = STATE(3030),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(5701),
    [sym_conditional] = STATE(5701),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5702),
    [sym_rational] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(5701),
    [sym_binary] = STATE(5701),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym_float] = ACTIONS(5106),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(5110),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(5110),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(5112),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(9236),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(5118),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [sym__identifier_hash_key] = ACTIONS(9238),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9236),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_class_variable] = ACTIONS(5118),
    [sym__block_ampersand] = ACTIONS(9240),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(5128),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [sym_retry] = ACTIONS(5106),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15171),
    [sym_redo] = ACTIONS(5106),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [10427] = {
    [sym_heredoc_body] = STATE(10427),
    [aux_sym_call_repeat1] = STATE(10427),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10428] = {
    [sym_heredoc_body] = STATE(10427),
    [aux_sym_call_repeat1] = STATE(10427),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10429] = {
    [aux_sym_argument_list_repeat1] = STATE(10429),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16414),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10430] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10431] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10432] = {
    [aux_sym_exceptions_repeat1] = STATE(8440),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10433] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10434] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10435] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10436] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10437] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16417),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10438] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10439] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10440] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10441] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10442] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [10443] = {
    [aux_sym_exceptions_repeat1] = STATE(10443),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16419),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10444] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [sym__line_break] = ACTIONS(16424),
    [anon_sym_then] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_when] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym___END__] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_end] = ACTIONS(16424),
    [anon_sym_ensure] = ACTIONS(16424),
    [anon_sym_else] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_elsif] = ACTIONS(16424),
    [ts_builtin_sym_end] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
  },
  [10445] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10446] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10447] = {
    [aux_sym_exceptions_repeat1] = STATE(11565),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10448] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10449] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10450] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10451] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10452] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16426),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10453] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10454] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [10455] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10456] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10457] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10458] = {
    [aux_sym_chained_string_repeat1] = STATE(10458),
    [sym_string] = STATE(10458),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10459] = {
    [sym_assignment] = STATE(8458),
    [sym_unary] = STATE(8458),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(8458),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(8458),
    [sym_conditional] = STATE(8458),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_return] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_true] = STATE(3034),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(8458),
    [sym_binary] = STATE(8458),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9242),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [sym_global_variable] = ACTIONS(5118),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(5110),
    [sym_character] = ACTIONS(5112),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [10460] = {
    [aux_sym_exceptions_repeat1] = STATE(11567),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16428),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10461] = {
    [sym_assignment] = STATE(11568),
    [sym_unary] = STATE(11568),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3034),
    [sym_singleton_class] = STATE(3030),
    [sym_module] = STATE(3030),
    [sym_chained_string] = STATE(3030),
    [sym_until] = STATE(3030),
    [sym_regex] = STATE(3030),
    [sym_for] = STATE(3030),
    [sym_symbol] = STATE(3030),
    [sym_if] = STATE(3030),
    [sym_begin] = STATE(3030),
    [sym__arg] = STATE(11568),
    [sym__primary] = STATE(3030),
    [sym_method_call] = STATE(3034),
    [sym_operator_assignment] = STATE(11568),
    [sym_conditional] = STATE(11568),
    [sym_method] = STATE(3030),
    [sym_singleton_method] = STATE(3030),
    [sym__variable] = STATE(3032),
    [sym_left_assignment_list] = STATE(3031),
    [sym_rational] = STATE(3030),
    [sym_true] = STATE(3034),
    [sym_return] = STATE(3030),
    [sym_subshell] = STATE(3030),
    [sym_yield] = STATE(3030),
    [sym_string] = STATE(5728),
    [sym_unless] = STATE(3030),
    [sym_lambda] = STATE(3030),
    [sym_parenthesized_statements] = STATE(3030),
    [sym_element_reference] = STATE(3034),
    [sym_range] = STATE(11568),
    [sym_binary] = STATE(11568),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3030),
    [sym_break] = STATE(3030),
    [sym_next] = STATE(3030),
    [sym_string_array] = STATE(3030),
    [sym_while] = STATE(3030),
    [sym_case] = STATE(3030),
    [sym_symbol_array] = STATE(3030),
    [sym_array] = STATE(3030),
    [sym_hash] = STATE(3030),
    [sym_false] = STATE(3034),
    [sym_nil] = STATE(3034),
    [sym_scope_resolution] = STATE(3032),
    [sym_call] = STATE(3032),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(5106),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(5114),
    [anon_sym_not] = ACTIONS(5128),
    [sym_self] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(5112),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(5112),
    [anon_sym_PLUS] = ACTIONS(9280),
    [anon_sym_TILDE] = ACTIONS(5114),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(5118),
    [sym_character] = ACTIONS(5112),
    [sym_super] = ACTIONS(5110),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(5134),
    [anon_sym_next] = ACTIONS(5136),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(5106),
    [sym_constant] = ACTIONS(5110),
    [anon_sym_defined_QMARK] = ACTIONS(5120),
    [sym_instance_variable] = ACTIONS(5118),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(9164),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(5110),
    [sym_redo] = ACTIONS(5106),
    [sym_class_variable] = ACTIONS(5118),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(5108),
  },
  [10462] = {
    [anon_sym_LT] = ACTIONS(5144),
    [anon_sym_SLASH] = ACTIONS(5146),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(5148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(5150),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_GT] = ACTIONS(5144),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [sym__binary_star] = ACTIONS(5146),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_TILDE] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5150),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5164),
    [anon_sym_end] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR] = ACTIONS(5146),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_DOT_DOT] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5150),
    [anon_sym_LT_EQ_GT] = ACTIONS(5150),
    [anon_sym_LT_EQ] = ACTIONS(5144),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym__binary_minus] = ACTIONS(5158),
  },
  [10463] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [10464] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [10465] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1454),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(1454),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1452),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(5782),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1454),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1454),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1454),
    [sym_nil] = STATE(1454),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2547),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(9353),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2553),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(9355),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(9353),
    [anon_sym_yield] = ACTIONS(2557),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(9357),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(2565),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2567),
    [anon_sym_next] = ACTIONS(2569),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15186),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2573),
  },
  [10466] = {
    [sym_heredoc_body] = STATE(10466),
    [aux_sym_call_repeat1] = STATE(10466),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10467] = {
    [sym_heredoc_body] = STATE(10466),
    [aux_sym_call_repeat1] = STATE(10466),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10468] = {
    [aux_sym_argument_list_repeat1] = STATE(10468),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16430),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10469] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [10470] = {
    [sym_assignment] = STATE(8487),
    [sym_unary] = STATE(8487),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(8487),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_splat_argument] = STATE(10015),
    [sym_operator_assignment] = STATE(8487),
    [sym_conditional] = STATE(8487),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_return] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_true] = STATE(3060),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym__arg_or_splat_arg] = STATE(10015),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(8487),
    [sym_binary] = STATE(8487),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(12995),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5194),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(5184),
    [sym_character] = ACTIONS(5190),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [10471] = {
    [aux_sym_exceptions_repeat1] = STATE(11569),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16433),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10472] = {
    [sym_assignment] = STATE(11570),
    [sym_unary] = STATE(11570),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3060),
    [sym_singleton_class] = STATE(3062),
    [sym_module] = STATE(3062),
    [sym_chained_string] = STATE(3062),
    [sym_until] = STATE(3062),
    [sym_regex] = STATE(3062),
    [sym_for] = STATE(3062),
    [sym_symbol] = STATE(3062),
    [sym_if] = STATE(3062),
    [sym_begin] = STATE(3062),
    [sym__arg] = STATE(11570),
    [sym__primary] = STATE(3062),
    [sym_method_call] = STATE(3060),
    [sym_operator_assignment] = STATE(11570),
    [sym_conditional] = STATE(11570),
    [sym_method] = STATE(3062),
    [sym_singleton_method] = STATE(3062),
    [sym__variable] = STATE(3063),
    [sym_left_assignment_list] = STATE(3064),
    [sym_rational] = STATE(3062),
    [sym_true] = STATE(3060),
    [sym_return] = STATE(3062),
    [sym_subshell] = STATE(3062),
    [sym_yield] = STATE(3062),
    [sym_string] = STATE(3065),
    [sym_unless] = STATE(3062),
    [sym_lambda] = STATE(3062),
    [sym_parenthesized_statements] = STATE(3062),
    [sym_element_reference] = STATE(3060),
    [sym_range] = STATE(11570),
    [sym_binary] = STATE(11570),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3062),
    [sym_break] = STATE(3062),
    [sym_next] = STATE(3062),
    [sym_string_array] = STATE(3062),
    [sym_while] = STATE(3062),
    [sym_case] = STATE(3062),
    [sym_symbol_array] = STATE(3062),
    [sym_array] = STATE(3062),
    [sym_hash] = STATE(3062),
    [sym_false] = STATE(3060),
    [sym_nil] = STATE(3060),
    [sym_scope_resolution] = STATE(3063),
    [sym_call] = STATE(3063),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(5176),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(5180),
    [anon_sym_not] = ACTIONS(5182),
    [sym_self] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(5188),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(5190),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(5190),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(5194),
    [sym_character] = ACTIONS(5190),
    [sym_super] = ACTIONS(5184),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(5196),
    [anon_sym_next] = ACTIONS(5198),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5184),
    [anon_sym_defined_QMARK] = ACTIONS(5200),
    [sym_instance_variable] = ACTIONS(5194),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(5184),
    [sym_redo] = ACTIONS(5176),
    [sym_class_variable] = ACTIONS(5194),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(5206),
  },
  [10473] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10474] = {
    [anon_sym_RPAREN] = ACTIONS(16435),
    [sym_comment] = ACTIONS(49),
  },
  [10475] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10476] = {
    [sym_float] = ACTIONS(16394),
    [anon_sym_until] = ACTIONS(16394),
    [anon_sym_undef] = ACTIONS(16394),
    [sym_self] = ACTIONS(16394),
    [anon_sym_BEGIN] = ACTIONS(16394),
    [anon_sym_RBRACE] = ACTIONS(16392),
    [anon_sym_TILDE] = ACTIONS(16392),
    [anon_sym_unless] = ACTIONS(16394),
    [anon_sym_PLUS] = ACTIONS(16394),
    [sym__symbol_array_start] = ACTIONS(16392),
    [sym__simple_symbol] = ACTIONS(16392),
    [sym_complex] = ACTIONS(16392),
    [sym_heredoc_beginning] = ACTIONS(16392),
    [sym_super] = ACTIONS(16394),
    [anon_sym_alias] = ACTIONS(16394),
    [anon_sym_LBRACK2] = ACTIONS(16392),
    [anon_sym_nil] = ACTIONS(16394),
    [sym_character] = ACTIONS(16392),
    [anon_sym_LBRACE] = ACTIONS(16392),
    [anon_sym_END] = ACTIONS(16394),
    [sym_constant] = ACTIONS(16394),
    [anon_sym_while] = ACTIONS(16394),
    [sym_instance_variable] = ACTIONS(16392),
    [anon_sym_defined_QMARK] = ACTIONS(16392),
    [sym__string_start] = ACTIONS(16392),
    [anon_sym_true] = ACTIONS(16394),
    [anon_sym_for] = ACTIONS(16394),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(16392),
    [anon_sym_NIL] = ACTIONS(16394),
    [anon_sym_COLON_COLON] = ACTIONS(16392),
    [anon_sym_def] = ACTIONS(16394),
    [sym_identifier] = ACTIONS(16394),
    [anon_sym_yield] = ACTIONS(16394),
    [sym_class_variable] = ACTIONS(16392),
    [sym__symbol_start] = ACTIONS(16392),
    [anon_sym_not] = ACTIONS(16394),
    [anon_sym_TRUE] = ACTIONS(16394),
    [anon_sym_case] = ACTIONS(16394),
    [anon_sym_SEMI] = ACTIONS(16392),
    [anon_sym_LPAREN] = ACTIONS(16392),
    [anon_sym_break] = ACTIONS(16394),
    [sym_global_variable] = ACTIONS(16392),
    [anon_sym_class] = ACTIONS(16394),
    [sym__subshell_start] = ACTIONS(16392),
    [anon_sym_module] = ACTIONS(16394),
    [anon_sym_begin] = ACTIONS(16394),
    [anon_sym_false] = ACTIONS(16394),
    [anon_sym_STAR] = ACTIONS(16392),
    [sym__unary_minus] = ACTIONS(16392),
    [anon_sym_next] = ACTIONS(16394),
    [sym_retry] = ACTIONS(16394),
    [sym__regex_start] = ACTIONS(16392),
    [sym_integer] = ACTIONS(16394),
    [anon_sym_FALSE] = ACTIONS(16394),
    [sym_redo] = ACTIONS(16394),
    [anon_sym_BANG] = ACTIONS(16392),
    [anon_sym_if] = ACTIONS(16394),
    [sym__string_array_start] = ACTIONS(16392),
    [anon_sym_return] = ACTIONS(16394),
  },
  [10477] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(16437),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [10478] = {
    [aux_sym_block_parameters_repeat1] = STATE(11573),
    [anon_sym_PIPE] = ACTIONS(16437),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [10479] = {
    [sym_comment] = ACTIONS(49),
    [sym_identifier] = ACTIONS(16439),
  },
  [10480] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [10481] = {
    [aux_sym_exceptions_repeat1] = STATE(8562),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10482] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [10483] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [10484] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [10485] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10486] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16441),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10487] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10488] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [10489] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10490] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10491] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10492] = {
    [aux_sym_chained_string_repeat1] = STATE(10492),
    [sym_string] = STATE(10492),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [10493] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10494] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10495] = {
    [aux_sym_exceptions_repeat1] = STATE(11577),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10496] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10497] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10498] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10499] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10500] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16443),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10501] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10502] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [10503] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10504] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10505] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10506] = {
    [sym_assignment] = STATE(8548),
    [sym_unary] = STATE(8548),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8548),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(8548),
    [sym_conditional] = STATE(8548),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_true] = STATE(3091),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(8548),
    [sym_binary] = STATE(8548),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(5468),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(2173),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [10507] = {
    [aux_sym_exceptions_repeat1] = STATE(11579),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16445),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10508] = {
    [sym_assignment] = STATE(11580),
    [sym_unary] = STATE(11580),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3091),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(11580),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3091),
    [sym_operator_assignment] = STATE(11580),
    [sym_conditional] = STATE(11580),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(3093),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3091),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(3210),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3091),
    [sym_range] = STATE(11580),
    [sym_binary] = STATE(11580),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3091),
    [sym_nil] = STATE(3091),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(2193),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5256),
    [sym_self] = ACTIONS(2173),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(9452),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(2185),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(2173),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5260),
    [anon_sym_next] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(2173),
    [anon_sym_defined_QMARK] = ACTIONS(5248),
    [sym_instance_variable] = ACTIONS(2185),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2173),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(2185),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [10509] = {
    [aux_sym_exceptions_repeat1] = STATE(10509),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16447),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10510] = {
    [anon_sym_LT] = ACTIONS(5270),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5276),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5284),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(5276),
    [sym__binary_star] = ACTIONS(5272),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5288),
    [anon_sym_GT] = ACTIONS(5270),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5290),
    [anon_sym_BANG_TILDE] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5292),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [sym__binary_minus] = ACTIONS(5286),
    [anon_sym_CARET] = ACTIONS(5298),
  },
  [10511] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10512] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10513] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10514] = {
    [aux_sym_exceptions_repeat1] = STATE(11582),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10515] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10516] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10517] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10518] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10519] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16450),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10520] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10521] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [10522] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10523] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10524] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10525] = {
    [aux_sym_chained_string_repeat1] = STATE(10525),
    [sym_string] = STATE(10525),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10526] = {
    [sym_assignment] = STATE(8584),
    [sym_unary] = STATE(8584),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(8584),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(8584),
    [sym_conditional] = STATE(8584),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_return] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_true] = STATE(3130),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(8584),
    [sym_binary] = STATE(8584),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(5544),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(5310),
    [sym_character] = ACTIONS(5312),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [10527] = {
    [aux_sym_exceptions_repeat1] = STATE(11584),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16452),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10528] = {
    [sym_assignment] = STATE(11585),
    [sym_unary] = STATE(11585),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3130),
    [sym_singleton_class] = STATE(3126),
    [sym_module] = STATE(3126),
    [sym_chained_string] = STATE(3126),
    [sym_until] = STATE(3126),
    [sym_regex] = STATE(3126),
    [sym_for] = STATE(3126),
    [sym_symbol] = STATE(3126),
    [sym_if] = STATE(3126),
    [sym_begin] = STATE(3126),
    [sym__arg] = STATE(11585),
    [sym__primary] = STATE(3126),
    [sym_method_call] = STATE(3130),
    [sym_operator_assignment] = STATE(11585),
    [sym_conditional] = STATE(11585),
    [sym_method] = STATE(3126),
    [sym_singleton_method] = STATE(3126),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3127),
    [sym_rational] = STATE(3126),
    [sym_true] = STATE(3130),
    [sym_return] = STATE(3126),
    [sym_subshell] = STATE(3126),
    [sym_yield] = STATE(3126),
    [sym_string] = STATE(5875),
    [sym_unless] = STATE(3126),
    [sym_lambda] = STATE(3126),
    [sym_parenthesized_statements] = STATE(3126),
    [sym_element_reference] = STATE(3130),
    [sym_range] = STATE(11585),
    [sym_binary] = STATE(11585),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3126),
    [sym_break] = STATE(3126),
    [sym_next] = STATE(3126),
    [sym_string_array] = STATE(3126),
    [sym_while] = STATE(3126),
    [sym_case] = STATE(3126),
    [sym_symbol_array] = STATE(3126),
    [sym_array] = STATE(3126),
    [sym_hash] = STATE(3126),
    [sym_false] = STATE(3130),
    [sym_nil] = STATE(3130),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(5306),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5324),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(5314),
    [anon_sym_not] = ACTIONS(5328),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(5312),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(5312),
    [anon_sym_PLUS] = ACTIONS(9518),
    [anon_sym_TILDE] = ACTIONS(5314),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(5312),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(5334),
    [anon_sym_next] = ACTIONS(5336),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(5306),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(5306),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(5308),
  },
  [10529] = {
    [sym__line_break] = ACTIONS(9250),
    [anon_sym_DOT] = ACTIONS(9250),
    [anon_sym_then] = ACTIONS(9250),
    [anon_sym_AMP_DOT] = ACTIONS(9250),
    [anon_sym_COLON_COLON2] = ACTIONS(9250),
    [sym__heredoc_body_start] = ACTIONS(9250),
    [anon_sym_COMMA] = ACTIONS(9250),
    [anon_sym_SEMI] = ACTIONS(9250),
    [anon_sym_LBRACK] = ACTIONS(9250),
    [sym_comment] = ACTIONS(49),
  },
  [10530] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11587),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16454),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10531] = {
    [anon_sym_end] = ACTIONS(16456),
    [sym_comment] = ACTIONS(49),
  },
  [10532] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym__terminator] = STATE(11588),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_heredoc_body] = STATE(11588),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11587),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym__line_break] = ACTIONS(16458),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [sym__heredoc_body_start] = ACTIONS(983),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(16458),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16454),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [10533] = {
    [sym__line_break] = ACTIONS(9419),
    [anon_sym_DOT] = ACTIONS(9419),
    [anon_sym_then] = ACTIONS(9419),
    [anon_sym_AMP_DOT] = ACTIONS(9419),
    [anon_sym_COLON_COLON2] = ACTIONS(9419),
    [sym__heredoc_body_start] = ACTIONS(9419),
    [anon_sym_COMMA] = ACTIONS(9419),
    [anon_sym_SEMI] = ACTIONS(9419),
    [anon_sym_LBRACK] = ACTIONS(9419),
    [sym_comment] = ACTIONS(49),
  },
  [10534] = {
    [anon_sym_RBRACE] = ACTIONS(16460),
    [sym_comment] = ACTIONS(49),
  },
  [10535] = {
    [sym_float] = ACTIONS(16462),
    [anon_sym_until] = ACTIONS(16462),
    [anon_sym_undef] = ACTIONS(16462),
    [sym_self] = ACTIONS(16462),
    [anon_sym_BEGIN] = ACTIONS(16462),
    [anon_sym_TILDE] = ACTIONS(16464),
    [anon_sym_unless] = ACTIONS(16462),
    [anon_sym_PLUS] = ACTIONS(16462),
    [sym__symbol_array_start] = ACTIONS(16464),
    [sym__simple_symbol] = ACTIONS(16464),
    [sym_complex] = ACTIONS(16464),
    [sym_heredoc_beginning] = ACTIONS(16464),
    [sym_super] = ACTIONS(16462),
    [anon_sym_rescue] = ACTIONS(16462),
    [anon_sym_alias] = ACTIONS(16462),
    [anon_sym_LBRACK2] = ACTIONS(16464),
    [anon_sym_nil] = ACTIONS(16462),
    [sym_character] = ACTIONS(16464),
    [anon_sym_LBRACE] = ACTIONS(16464),
    [anon_sym_END] = ACTIONS(16462),
    [sym_constant] = ACTIONS(16462),
    [anon_sym_while] = ACTIONS(16462),
    [sym_instance_variable] = ACTIONS(16464),
    [anon_sym_defined_QMARK] = ACTIONS(16464),
    [sym__string_start] = ACTIONS(16464),
    [anon_sym_else] = ACTIONS(16462),
    [anon_sym_true] = ACTIONS(16462),
    [anon_sym_for] = ACTIONS(16462),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(16464),
    [anon_sym_NIL] = ACTIONS(16462),
    [anon_sym_COLON_COLON] = ACTIONS(16464),
    [anon_sym_def] = ACTIONS(16462),
    [sym_identifier] = ACTIONS(16462),
    [anon_sym_yield] = ACTIONS(16462),
    [sym_class_variable] = ACTIONS(16464),
    [anon_sym_not] = ACTIONS(16462),
    [sym__symbol_start] = ACTIONS(16464),
    [anon_sym_TRUE] = ACTIONS(16462),
    [anon_sym_case] = ACTIONS(16462),
    [anon_sym_SEMI] = ACTIONS(16464),
    [anon_sym_LPAREN] = ACTIONS(16464),
    [anon_sym_break] = ACTIONS(16462),
    [sym_global_variable] = ACTIONS(16464),
    [anon_sym_class] = ACTIONS(16462),
    [sym__subshell_start] = ACTIONS(16464),
    [anon_sym_module] = ACTIONS(16462),
    [anon_sym_begin] = ACTIONS(16462),
    [anon_sym_false] = ACTIONS(16462),
    [anon_sym_STAR] = ACTIONS(16464),
    [sym__unary_minus] = ACTIONS(16464),
    [anon_sym_next] = ACTIONS(16462),
    [sym_retry] = ACTIONS(16462),
    [sym__regex_start] = ACTIONS(16464),
    [anon_sym_end] = ACTIONS(16462),
    [anon_sym_ensure] = ACTIONS(16462),
    [sym_integer] = ACTIONS(16462),
    [anon_sym_FALSE] = ACTIONS(16462),
    [sym_redo] = ACTIONS(16462),
    [anon_sym_BANG] = ACTIONS(16464),
    [anon_sym_if] = ACTIONS(16462),
    [sym__string_array_start] = ACTIONS(16464),
    [anon_sym_return] = ACTIONS(16462),
  },
  [10536] = {
    [sym__line_break] = ACTIONS(13055),
    [sym__heredoc_body_start] = ACTIONS(13055),
    [anon_sym_COMMA] = ACTIONS(13055),
    [anon_sym_SEMI] = ACTIONS(13055),
    [sym_comment] = ACTIONS(49),
  },
  [10537] = {
    [aux_sym_method_parameters_repeat1] = STATE(5826),
    [anon_sym_RPAREN] = ACTIONS(16466),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(5234),
  },
  [10538] = {
    [sym__line_break] = ACTIONS(13059),
    [sym__heredoc_body_start] = ACTIONS(13059),
    [anon_sym_COMMA] = ACTIONS(13059),
    [anon_sym_SEMI] = ACTIONS(13059),
    [sym_comment] = ACTIONS(49),
  },
  [10539] = {
    [aux_sym_method_parameters_repeat1] = STATE(10539),
    [sym__line_break] = ACTIONS(13059),
    [sym__heredoc_body_start] = ACTIONS(13059),
    [anon_sym_COMMA] = ACTIONS(16468),
    [anon_sym_SEMI] = ACTIONS(13059),
    [sym_comment] = ACTIONS(49),
  },
  [10540] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [sym__line_break] = ACTIONS(14596),
    [anon_sym_then] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_EQ_GT] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_when] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym___END__] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_end] = ACTIONS(14596),
    [anon_sym_ensure] = ACTIONS(14596),
    [anon_sym_else] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_elsif] = ACTIONS(14596),
    [ts_builtin_sym_end] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
    [sym__binary_minus] = ACTIONS(14596),
  },
  [10541] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [sym__line_break] = ACTIONS(15029),
    [anon_sym_then] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_EQ_GT] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_when] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym___END__] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_end] = ACTIONS(15029),
    [anon_sym_ensure] = ACTIONS(15029),
    [anon_sym_else] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_elsif] = ACTIONS(15029),
    [ts_builtin_sym_end] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
    [sym__binary_minus] = ACTIONS(15029),
  },
  [10542] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [sym__line_break] = ACTIONS(15175),
    [anon_sym_then] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_when] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym___END__] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_ensure] = ACTIONS(15175),
    [anon_sym_else] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_elsif] = ACTIONS(15175),
    [ts_builtin_sym_end] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
  },
  [10543] = {
    [anon_sym_end] = ACTIONS(16471),
    [sym_comment] = ACTIONS(49),
  },
  [10544] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [sym__line_break] = ACTIONS(15209),
    [anon_sym_then] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_EQ_GT] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_when] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym___END__] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_end] = ACTIONS(15209),
    [anon_sym_ensure] = ACTIONS(15209),
    [anon_sym_else] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_elsif] = ACTIONS(15209),
    [ts_builtin_sym_end] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
    [sym__binary_minus] = ACTIONS(15209),
  },
  [10545] = {
    [aux_sym_exceptions_repeat1] = STATE(10545),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16473),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10546] = {
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5416),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5424),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_BANG_TILDE] = ACTIONS(5424),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_STAR_STAR] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5436),
    [anon_sym_DOT_DOT] = ACTIONS(5438),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(5440),
    [sym__binary_minus] = ACTIONS(5428),
  },
  [10547] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [sym__line_break] = ACTIONS(15291),
    [anon_sym_then] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_EQ_GT] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_when] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym___END__] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_end] = ACTIONS(15291),
    [anon_sym_ensure] = ACTIONS(15291),
    [anon_sym_else] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_elsif] = ACTIONS(15291),
    [ts_builtin_sym_end] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
    [sym__binary_minus] = ACTIONS(15291),
  },
  [10548] = {
    [anon_sym_end] = ACTIONS(16476),
    [sym_comment] = ACTIONS(49),
  },
  [10549] = {
    [sym_heredoc_body] = STATE(10549),
    [aux_sym_call_repeat1] = STATE(10549),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10550] = {
    [sym_heredoc_body] = STATE(10549),
    [aux_sym_call_repeat1] = STATE(10549),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10551] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [10552] = {
    [sym_assignment] = STATE(8648),
    [sym_unary] = STATE(8648),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(8648),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(8648),
    [sym_conditional] = STATE(8648),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_true] = STATE(3232),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(8648),
    [sym_binary] = STATE(8648),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(13202),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [sym_global_variable] = ACTIONS(5486),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(5478),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [10553] = {
    [aux_sym_exceptions_repeat1] = STATE(11593),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16478),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10554] = {
    [sym_assignment] = STATE(11594),
    [sym_unary] = STATE(11594),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3232),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(11594),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(3232),
    [sym_operator_assignment] = STATE(11594),
    [sym_conditional] = STATE(11594),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(3236),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(3232),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(3232),
    [sym_range] = STATE(11594),
    [sym_binary] = STATE(11594),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(3232),
    [sym_nil] = STATE(3232),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_not] = ACTIONS(5476),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(5488),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [10555] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10556] = {
    [anon_sym_RPAREN] = ACTIONS(16480),
    [sym_comment] = ACTIONS(49),
  },
  [10557] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10558] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_RPAREN] = ACTIONS(8575),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [sym__identifier_hash_key] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [sym__block_ampersand] = ACTIONS(8575),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_yield] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [sym__splat_star] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(10412),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [anon_sym_STAR_STAR] = ACTIONS(8575),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [10559] = {
    [sym__argument] = STATE(5134),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(5134),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(5134),
    [sym_hash_splat_argument] = STATE(5134),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(5134),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [10560] = {
    [aux_sym_exceptions_repeat1] = STATE(10560),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16482),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10561] = {
    [anon_sym_LT] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5510),
    [anon_sym_EQ_TILDE] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [sym__binary_star] = ACTIONS(5506),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_TILDE] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5524),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_STAR_STAR] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5504),
    [sym__binary_minus] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5530),
  },
  [10562] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10563] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [sym__line_break] = ACTIONS(15676),
    [anon_sym_then] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_EQ_GT] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_when] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym___END__] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_end] = ACTIONS(15676),
    [anon_sym_ensure] = ACTIONS(15676),
    [anon_sym_else] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_elsif] = ACTIONS(15676),
    [ts_builtin_sym_end] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
    [sym__binary_minus] = ACTIONS(15676),
  },
  [10564] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [sym__line_break] = ACTIONS(15831),
    [anon_sym_then] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_EQ_GT] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_when] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym___END__] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_end] = ACTIONS(15831),
    [anon_sym_ensure] = ACTIONS(15831),
    [anon_sym_else] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_elsif] = ACTIONS(15831),
    [ts_builtin_sym_end] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
    [sym__binary_minus] = ACTIONS(15831),
  },
  [10565] = {
    [anon_sym_SLASH] = ACTIONS(15173),
    [sym__line_break] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_else] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_then] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_EQ_GT] = ACTIONS(15175),
    [anon_sym_when] = ACTIONS(15175),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym___END__] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_ensure] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_elsif] = ACTIONS(15175),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [ts_builtin_sym_end] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [10566] = {
    [anon_sym_end] = ACTIONS(16485),
    [sym_comment] = ACTIONS(49),
  },
  [10567] = {
    [sym_heredoc_body] = STATE(10567),
    [aux_sym_call_repeat1] = STATE(10567),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10568] = {
    [sym_heredoc_body] = STATE(10567),
    [aux_sym_call_repeat1] = STATE(10567),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10569] = {
    [sym_assignment] = STATE(8712),
    [sym_unary] = STATE(8712),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(8712),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(8712),
    [sym_conditional] = STATE(8712),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_return] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_true] = STATE(3359),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(8712),
    [sym_binary] = STATE(8712),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [sym_global_variable] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(583),
    [sym_character] = ACTIONS(113),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [10570] = {
    [aux_sym_exceptions_repeat1] = STATE(11597),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16487),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10571] = {
    [sym_assignment] = STATE(11598),
    [sym_unary] = STATE(11598),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3359),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(11598),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3359),
    [sym_operator_assignment] = STATE(11598),
    [sym_conditional] = STATE(11598),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3361),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3359),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3359),
    [sym_range] = STATE(11598),
    [sym_binary] = STATE(11598),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3359),
    [sym_nil] = STATE(3359),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_not] = ACTIONS(5648),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5654),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5658),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [10572] = {
    [aux_sym_exceptions_repeat1] = STATE(10572),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16489),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10573] = {
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5678),
    [anon_sym_EQ_TILDE] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_STAR_STAR] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_DOT_DOT] = ACTIONS(5690),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [sym__binary_minus] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5692),
  },
  [10574] = {
    [sym_assignment] = STATE(11599),
    [sym_unary] = STATE(11599),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3385),
    [sym_singleton_class] = STATE(64),
    [sym_module] = STATE(64),
    [sym_chained_string] = STATE(64),
    [sym_until] = STATE(64),
    [sym_regex] = STATE(64),
    [sym_for] = STATE(64),
    [sym_symbol] = STATE(64),
    [sym_if] = STATE(64),
    [sym_begin] = STATE(64),
    [sym__arg] = STATE(11599),
    [sym__primary] = STATE(64),
    [sym_method_call] = STATE(3385),
    [sym_operator_assignment] = STATE(11599),
    [sym_conditional] = STATE(11599),
    [sym_method] = STATE(64),
    [sym_singleton_method] = STATE(64),
    [sym__variable] = STATE(320),
    [sym_left_assignment_list] = STATE(3387),
    [sym_rational] = STATE(64),
    [sym_true] = STATE(3385),
    [sym_return] = STATE(64),
    [sym_subshell] = STATE(64),
    [sym_yield] = STATE(64),
    [sym_string] = STATE(3362),
    [sym_unless] = STATE(64),
    [sym_lambda] = STATE(64),
    [sym_parenthesized_statements] = STATE(64),
    [sym_element_reference] = STATE(3385),
    [sym_range] = STATE(11599),
    [sym_binary] = STATE(11599),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(64),
    [sym_break] = STATE(64),
    [sym_next] = STATE(64),
    [sym_string_array] = STATE(64),
    [sym_while] = STATE(64),
    [sym_case] = STATE(64),
    [sym_symbol_array] = STATE(64),
    [sym_array] = STATE(64),
    [sym_hash] = STATE(64),
    [sym_false] = STATE(3385),
    [sym_nil] = STATE(3385),
    [sym_scope_resolution] = STATE(320),
    [sym_call] = STATE(320),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(101),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5644),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5698),
    [anon_sym_not] = ACTIONS(5700),
    [sym_self] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5650),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(113),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(589),
    [sym_character] = ACTIONS(113),
    [sym_super] = ACTIONS(583),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_next] = ACTIONS(5656),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(101),
    [sym_constant] = ACTIONS(583),
    [anon_sym_defined_QMARK] = ACTIONS(5708),
    [sym_instance_variable] = ACTIONS(589),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(583),
    [sym_redo] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(589),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5660),
  },
  [10575] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [sym__line_break] = ACTIONS(16494),
    [anon_sym_then] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_when] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym___END__] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_end] = ACTIONS(16494),
    [anon_sym_ensure] = ACTIONS(16494),
    [anon_sym_else] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_elsif] = ACTIONS(16494),
    [ts_builtin_sym_end] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
    [sym__binary_minus] = ACTIONS(16494),
  },
  [10576] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [10577] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [10578] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [10579] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [10580] = {
    [sym_assignment] = STATE(11600),
    [sym_unary] = STATE(11600),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11600),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11600),
    [sym_conditional] = STATE(11600),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11600),
    [sym_binary] = STATE(11600),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10581] = {
    [sym_assignment] = STATE(11601),
    [sym_unary] = STATE(11601),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11601),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_splat_argument] = STATE(11602),
    [sym_operator_assignment] = STATE(11601),
    [sym_conditional] = STATE(11601),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_subshell] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(11602),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11601),
    [sym_binary] = STATE(11601),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10582] = {
    [sym_assignment] = STATE(11603),
    [sym_unary] = STATE(11603),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11603),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11603),
    [sym_conditional] = STATE(11603),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11603),
    [sym_binary] = STATE(11603),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10583] = {
    [sym_assignment] = STATE(11604),
    [sym_unary] = STATE(11604),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11604),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11604),
    [sym_conditional] = STATE(11604),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11604),
    [sym_binary] = STATE(11604),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10584] = {
    [sym_assignment] = STATE(11606),
    [sym_unary] = STATE(11606),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11606),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11606),
    [sym_conditional] = STATE(11606),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11606),
    [sym_binary] = STATE(11606),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10585] = {
    [sym_assignment] = STATE(11607),
    [sym_unary] = STATE(11607),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11607),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11607),
    [sym_conditional] = STATE(11607),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11607),
    [sym_binary] = STATE(11607),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10586] = {
    [sym_assignment] = STATE(11608),
    [sym_unary] = STATE(11608),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11608),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11608),
    [sym_conditional] = STATE(11608),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11608),
    [sym_binary] = STATE(11608),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10587] = {
    [sym_assignment] = STATE(11609),
    [sym_unary] = STATE(11609),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11609),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11609),
    [sym_conditional] = STATE(11609),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11609),
    [sym_binary] = STATE(11609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10588] = {
    [sym_assignment] = STATE(11610),
    [sym_unary] = STATE(11610),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11610),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11610),
    [sym_conditional] = STATE(11610),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11610),
    [sym_binary] = STATE(11610),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10589] = {
    [sym_assignment] = STATE(11611),
    [sym_unary] = STATE(11611),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11611),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11611),
    [sym_conditional] = STATE(11611),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11611),
    [sym_binary] = STATE(11611),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10590] = {
    [sym_assignment] = STATE(11612),
    [sym_unary] = STATE(11612),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11612),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(11612),
    [sym_conditional] = STATE(11612),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11612),
    [sym_binary] = STATE(11612),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10591] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(6150),
    [sym_unary] = STATE(6150),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6150),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(6150),
    [sym_conditional] = STATE(6150),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6151),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(6150),
    [sym_binary] = STATE(6150),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(2595),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(2595),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(9903),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(2603),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(9905),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(9903),
    [anon_sym_yield] = ACTIONS(2611),
    [sym_class_variable] = ACTIONS(2603),
    [sym__block_ampersand] = ACTIONS(9907),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6101),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15327),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [10592] = {
    [sym_heredoc_body] = STATE(10592),
    [aux_sym_call_repeat1] = STATE(10592),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10593] = {
    [sym_heredoc_body] = STATE(10592),
    [aux_sym_call_repeat1] = STATE(10592),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10594] = {
    [aux_sym_argument_list_repeat1] = STATE(10594),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16496),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10595] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [10596] = {
    [sym_assignment] = STATE(8759),
    [sym_unary] = STATE(8759),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(8759),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(8759),
    [sym_conditional] = STATE(8759),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_true] = STATE(3413),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(8759),
    [sym_binary] = STATE(8759),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(13298),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10597] = {
    [aux_sym_exceptions_repeat1] = STATE(11613),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16499),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10598] = {
    [sym_assignment] = STATE(11614),
    [sym_unary] = STATE(11614),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3413),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11614),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(3413),
    [sym_operator_assignment] = STATE(11614),
    [sym_conditional] = STATE(11614),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(3419),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(3413),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(3413),
    [sym_range] = STATE(11614),
    [sym_binary] = STATE(11614),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(3413),
    [sym_nil] = STATE(3413),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5734),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(5738),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [10599] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_then] = ACTIONS(5452),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10600] = {
    [anon_sym_RPAREN] = ACTIONS(16501),
    [sym_comment] = ACTIONS(49),
  },
  [10601] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10602] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(10412),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_when] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [10603] = {
    [aux_sym_undef_repeat1] = STATE(11616),
    [sym__line_break] = ACTIONS(1053),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(1053),
    [anon_sym_until] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [sym__heredoc_body_start] = ACTIONS(1053),
    [anon_sym_rescue] = ACTIONS(1053),
    [anon_sym_end] = ACTIONS(1053),
    [anon_sym_when] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1055),
  },
  [10604] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [10605] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [10606] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_rescue] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_when] = ACTIONS(2053),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [anon_sym_end] = ACTIONS(2053),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [10607] = {
    [sym_assignment] = STATE(11617),
    [sym_unary] = STATE(11617),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11617),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(11617),
    [sym_conditional] = STATE(11617),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(11617),
    [sym_binary] = STATE(11617),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [10608] = {
    [sym_assignment] = STATE(1180),
    [sym_unary] = STATE(1180),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(1180),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(1180),
    [sym_conditional] = STATE(1180),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(1180),
    [sym_binary] = STATE(1180),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [10609] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(16507),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_when] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [10610] = {
    [sym_assignment] = STATE(11620),
    [sym_unary] = STATE(11620),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11620),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(11620),
    [sym_conditional] = STATE(11620),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(11620),
    [sym_binary] = STATE(11620),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [10611] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(16509),
    [sym_identifier] = ACTIONS(16509),
  },
  [10612] = {
    [anon_sym_COLON] = ACTIONS(16511),
    [sym_comment] = ACTIONS(49),
  },
  [10613] = {
    [sym__argument] = STATE(11628),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(11628),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(11628),
    [sym_hash_splat_argument] = STATE(11628),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(1214),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(11631),
    [sym_block_argument] = STATE(11628),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(501),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [10614] = {
    [sym_assignment] = STATE(11640),
    [sym_unary] = STATE(11640),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11640),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(11640),
    [sym_conditional] = STATE(11640),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(11640),
    [sym_binary] = STATE(11640),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [10615] = {
    [sym_assignment] = STATE(11643),
    [sym_unary] = STATE(11643),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11643),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(11643),
    [sym_conditional] = STATE(11643),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(11643),
    [sym_binary] = STATE(11643),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [10616] = {
    [sym__argument] = STATE(11628),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(11628),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(11628),
    [sym_hash_splat_argument] = STATE(11628),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(1256),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(11631),
    [sym_block_argument] = STATE(11628),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(647),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [10617] = {
    [sym__argument] = STATE(11628),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(11628),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(11628),
    [sym_hash_splat_argument] = STATE(11628),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(1270),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(11631),
    [sym_block_argument] = STATE(11628),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [10618] = {
    [sym_assignment] = STATE(11644),
    [sym_unary] = STATE(11644),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11644),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(11644),
    [sym_conditional] = STATE(11644),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(11644),
    [sym_binary] = STATE(11644),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [10619] = {
    [sym__argument] = STATE(11628),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(11628),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(11628),
    [sym_hash_splat_argument] = STATE(11628),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(1279),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(11631),
    [sym_block_argument] = STATE(11628),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [10620] = {
    [sym_heredoc_body] = STATE(11646),
    [aux_sym_call_repeat1] = STATE(11646),
    [aux_sym_argument_list_repeat1] = STATE(11647),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16539),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [10621] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(16541),
    [anon_sym_GT_GT_EQ] = ACTIONS(16541),
    [anon_sym_SLASH_EQ] = ACTIONS(16541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(16541),
    [anon_sym_LT_LT_EQ] = ACTIONS(16541),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16541),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(16541),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(16543),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(16541),
    [anon_sym_PLUS_EQ] = ACTIONS(16541),
    [anon_sym_STAR_EQ] = ACTIONS(16541),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16541),
    [anon_sym_DASH_EQ] = ACTIONS(16541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16541),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [10622] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_EQ_GT] = ACTIONS(16511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [10623] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(16571),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_when] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(777),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(16573),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(16575),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
    [sym__binary_minus] = ACTIONS(777),
  },
  [10624] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym__primary] = STATE(10650),
    [sym_argument_list] = STATE(1307),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_method] = STATE(10650),
    [sym_conditional] = STATE(11667),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_subshell] = STATE(10650),
    [sym_unless] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10654),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_call] = STATE(10652),
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_rational] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_lambda] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(11667),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_nil] = STATE(10654),
    [sym_symbol_array] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_scope_resolution] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(2285),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(791),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(2281),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10625] = {
    [anon_sym_EQ] = ACTIONS(16585),
    [sym_comment] = ACTIONS(3),
  },
  [10626] = {
    [aux_sym_chained_string_repeat1] = STATE(11670),
    [sym_string] = STATE(11670),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(16587),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [10627] = {
    [sym_heredoc_body] = STATE(11646),
    [aux_sym_call_repeat1] = STATE(11646),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [10628] = {
    [sym_assignment] = STATE(11671),
    [sym_unary] = STATE(11671),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11671),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11671),
    [sym_conditional] = STATE(11671),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11671),
    [sym_binary] = STATE(11671),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10629] = {
    [sym_assignment] = STATE(11672),
    [sym_unary] = STATE(11672),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11672),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11672),
    [sym_conditional] = STATE(11672),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11672),
    [sym_binary] = STATE(11672),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10630] = {
    [sym_assignment] = STATE(11673),
    [sym_unary] = STATE(11673),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11673),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11673),
    [sym_conditional] = STATE(11673),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11673),
    [sym_binary] = STATE(11673),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10631] = {
    [aux_sym_heredoc_body_repeat1] = STATE(11675),
    [sym_interpolation] = STATE(11675),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(16589),
    [sym_heredoc_end] = ACTIONS(16591),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(16589),
  },
  [10632] = {
    [sym_assignment] = STATE(11676),
    [sym_unary] = STATE(11676),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11676),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11676),
    [sym_conditional] = STATE(11676),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11676),
    [sym_binary] = STATE(11676),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10633] = {
    [sym_assignment] = STATE(11677),
    [sym_unary] = STATE(11677),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11677),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11677),
    [sym_conditional] = STATE(11677),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11677),
    [sym_binary] = STATE(11677),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10634] = {
    [sym_float] = ACTIONS(2891),
    [anon_sym_until] = ACTIONS(2891),
    [anon_sym_undef] = ACTIONS(2891),
    [sym_self] = ACTIONS(2891),
    [anon_sym_BEGIN] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_unless] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [sym__symbol_array_start] = ACTIONS(2893),
    [sym__simple_symbol] = ACTIONS(2893),
    [sym_complex] = ACTIONS(2893),
    [sym_heredoc_beginning] = ACTIONS(2893),
    [sym_super] = ACTIONS(2891),
    [anon_sym_alias] = ACTIONS(2891),
    [anon_sym_LBRACK2] = ACTIONS(2893),
    [anon_sym_nil] = ACTIONS(2891),
    [sym_character] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_END] = ACTIONS(2891),
    [sym_constant] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [sym_instance_variable] = ACTIONS(2893),
    [anon_sym_defined_QMARK] = ACTIONS(2893),
    [sym__string_start] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [anon_sym_NIL] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_def] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [sym_class_variable] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2891),
    [sym__symbol_start] = ACTIONS(2893),
    [anon_sym_TRUE] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2891),
    [sym_global_variable] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2891),
    [sym__subshell_start] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_false] = ACTIONS(2891),
    [anon_sym_when] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2893),
    [sym__unary_minus] = ACTIONS(2893),
    [anon_sym_next] = ACTIONS(2891),
    [sym_retry] = ACTIONS(2891),
    [sym__regex_start] = ACTIONS(2893),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(2891),
    [anon_sym_FALSE] = ACTIONS(2891),
    [sym_redo] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2891),
    [sym__string_array_start] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2891),
  },
  [10635] = {
    [sym_heredoc_body] = STATE(11682),
    [sym__argument_list_with_parens] = STATE(11681),
    [aux_sym_call_repeat1] = STATE(11682),
    [sym_argument_list_with_parens] = STATE(11680),
    [sym_operator] = STATE(11680),
    [anon_sym_LT] = ACTIONS(16593),
    [anon_sym_SLASH] = ACTIONS(16595),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(16595),
    [anon_sym_PLUS_AT] = ACTIONS(16595),
    [anon_sym_LPAREN2] = ACTIONS(16597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16595),
    [anon_sym_GT_GT] = ACTIONS(16595),
    [anon_sym_EQ_TILDE] = ACTIONS(16595),
    [anon_sym_LT_LT] = ACTIONS(16595),
    [anon_sym_TILDE] = ACTIONS(16595),
    [anon_sym_PLUS] = ACTIONS(16593),
    [anon_sym_AMP] = ACTIONS(16595),
    [anon_sym_GT] = ACTIONS(16593),
    [anon_sym_PERCENT] = ACTIONS(16595),
    [anon_sym_DASH_AT] = ACTIONS(16595),
    [anon_sym_EQ_EQ] = ACTIONS(16593),
    [anon_sym_STAR] = ACTIONS(16593),
    [anon_sym_BANG_TILDE] = ACTIONS(16595),
    [sym_constant] = ACTIONS(16599),
    [anon_sym_DASH] = ACTIONS(16593),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(16595),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(16593),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(16595),
    [anon_sym_STAR_STAR] = ACTIONS(16595),
    [anon_sym_PIPE] = ACTIONS(16595),
    [anon_sym_DOT_DOT] = ACTIONS(16595),
    [anon_sym_LT_EQ_GT] = ACTIONS(16595),
    [anon_sym_LT_EQ] = ACTIONS(16593),
    [anon_sym_BANG] = ACTIONS(16593),
    [sym_identifier] = ACTIONS(16599),
    [anon_sym_CARET] = ACTIONS(16595),
  },
  [10636] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(16601),
    [sym_identifier] = ACTIONS(16601),
  },
  [10637] = {
    [sym_assignment] = STATE(11689),
    [sym_unary] = STATE(11689),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11689),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_splat_argument] = STATE(11691),
    [sym_operator_assignment] = STATE(11689),
    [sym_conditional] = STATE(11689),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_return] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_subshell] = STATE(8790),
    [sym__arg_or_splat_arg] = STATE(11691),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(11689),
    [sym_binary] = STATE(11689),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(16607),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13318),
    [sym_character] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [10638] = {
    [sym_assignment] = STATE(11692),
    [sym_unary] = STATE(11692),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11692),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(11692),
    [sym_conditional] = STATE(11692),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(11692),
    [sym_binary] = STATE(11692),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10639] = {
    [sym_assignment] = STATE(1651),
    [sym_unary] = STATE(1651),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(1651),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(1651),
    [sym_conditional] = STATE(1651),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(1651),
    [sym_binary] = STATE(1651),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10640] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(16617),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_when] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [10641] = {
    [sym_assignment] = STATE(11695),
    [sym_unary] = STATE(11695),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11695),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(11695),
    [sym_conditional] = STATE(11695),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(11695),
    [sym_binary] = STATE(11695),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10642] = {
    [anon_sym_COLON] = ACTIONS(16619),
    [sym_comment] = ACTIONS(49),
  },
  [10643] = {
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(1695),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(501),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(501),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(501),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(501),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10644] = {
    [sym_assignment] = STATE(11705),
    [sym_unary] = STATE(11705),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(11705),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(11705),
    [sym_conditional] = STATE(11705),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(11705),
    [sym_binary] = STATE(11705),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [10645] = {
    [sym_assignment] = STATE(11710),
    [sym_unary] = STATE(11710),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(11710),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(11710),
    [sym_conditional] = STATE(11710),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(11710),
    [sym_binary] = STATE(11710),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [10646] = {
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(1740),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(647),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(647),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(647),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(647),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(645),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10647] = {
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(1754),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(737),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(737),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(737),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10648] = {
    [sym_assignment] = STATE(11711),
    [sym_unary] = STATE(11711),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(11711),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(11711),
    [sym_conditional] = STATE(11711),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(11711),
    [sym_binary] = STATE(11711),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [10649] = {
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(1763),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(753),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(753),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(753),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(753),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10650] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(16571),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(16573),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(16575),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(777),
    [anon_sym_when] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2277),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [10651] = {
    [anon_sym_EQ] = ACTIONS(16647),
    [sym_comment] = ACTIONS(3),
  },
  [10652] = {
    [sym_block] = STATE(1306),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym__primary] = STATE(10650),
    [sym_argument_list] = STATE(1768),
    [sym_hash_splat_argument] = STATE(11666),
    [sym_method] = STATE(10650),
    [sym_conditional] = STATE(11667),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_subshell] = STATE(10650),
    [sym_unless] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_block_argument] = STATE(11666),
    [sym_range] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10654),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_call] = STATE(10652),
    [sym__argument] = STATE(11666),
    [sym_assignment] = STATE(11667),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_pair] = STATE(11666),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(11666),
    [sym_operator_assignment] = STATE(11667),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_rational] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_lambda] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(11669),
    [sym_do_block] = STATE(1306),
    [sym_binary] = STATE(11667),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_nil] = STATE(10654),
    [sym_symbol_array] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_scope_resolution] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_rescue] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(791),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(791),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(791),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(791),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15403),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [sym__block_ampersand] = ACTIONS(16583),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_EQ_GT] = ACTIONS(793),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15427),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15431),
    [anon_sym_return] = ACTIONS(15401),
  },
  [10653] = {
    [sym_heredoc_body] = STATE(11714),
    [aux_sym_call_repeat1] = STATE(11714),
    [aux_sym_argument_list_repeat1] = STATE(11715),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16649),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [10654] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(16651),
    [anon_sym_GT_GT_EQ] = ACTIONS(16651),
    [anon_sym_SLASH_EQ] = ACTIONS(16651),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(16651),
    [anon_sym_LT_LT_EQ] = ACTIONS(16651),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16651),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(16651),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(16653),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(16651),
    [anon_sym_PLUS_EQ] = ACTIONS(16651),
    [anon_sym_STAR_EQ] = ACTIONS(16651),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16651),
    [anon_sym_DASH_EQ] = ACTIONS(16651),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16651),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [10655] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(16619),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [10656] = {
    [aux_sym_chained_string_repeat1] = STATE(11726),
    [sym_string] = STATE(11726),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(16683),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [10657] = {
    [sym_heredoc_body] = STATE(11714),
    [aux_sym_call_repeat1] = STATE(11714),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [10658] = {
    [sym_assignment] = STATE(11727),
    [sym_unary] = STATE(11727),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11727),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11727),
    [sym_conditional] = STATE(11727),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11727),
    [sym_binary] = STATE(11727),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10659] = {
    [sym_assignment] = STATE(11728),
    [sym_unary] = STATE(11728),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11728),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11728),
    [sym_conditional] = STATE(11728),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11728),
    [sym_binary] = STATE(11728),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10660] = {
    [sym_assignment] = STATE(11729),
    [sym_unary] = STATE(11729),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11729),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11729),
    [sym_conditional] = STATE(11729),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11729),
    [sym_binary] = STATE(11729),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10661] = {
    [sym_assignment] = STATE(11730),
    [sym_unary] = STATE(11730),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11730),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11730),
    [sym_conditional] = STATE(11730),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11730),
    [sym_binary] = STATE(11730),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10662] = {
    [sym_assignment] = STATE(11731),
    [sym_unary] = STATE(11731),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11731),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11731),
    [sym_conditional] = STATE(11731),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11731),
    [sym_binary] = STATE(11731),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10663] = {
    [sym_assignment] = STATE(11732),
    [sym_unary] = STATE(11732),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11732),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11732),
    [sym_conditional] = STATE(11732),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11732),
    [sym_binary] = STATE(11732),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10664] = {
    [sym_assignment] = STATE(11733),
    [sym_unary] = STATE(11733),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11733),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11733),
    [sym_conditional] = STATE(11733),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11733),
    [sym_binary] = STATE(11733),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10665] = {
    [sym_assignment] = STATE(11734),
    [sym_unary] = STATE(11734),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11734),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11734),
    [sym_conditional] = STATE(11734),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11734),
    [sym_binary] = STATE(11734),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10666] = {
    [sym_assignment] = STATE(11735),
    [sym_unary] = STATE(11735),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11735),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11735),
    [sym_conditional] = STATE(11735),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11735),
    [sym_binary] = STATE(11735),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10667] = {
    [sym_assignment] = STATE(11736),
    [sym_unary] = STATE(11736),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11736),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11736),
    [sym_conditional] = STATE(11736),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11736),
    [sym_binary] = STATE(11736),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10668] = {
    [sym_assignment] = STATE(11737),
    [sym_unary] = STATE(11737),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11737),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(11737),
    [sym_conditional] = STATE(11737),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(11737),
    [sym_binary] = STATE(11737),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [10669] = {
    [aux_sym_chained_string_repeat1] = STATE(11738),
    [sym_string] = STATE(11738),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [10670] = {
    [sym_heredoc_body] = STATE(10634),
    [sym__terminator] = STATE(10634),
    [sym__line_break] = ACTIONS(15377),
    [anon_sym_unless] = ACTIONS(15379),
    [anon_sym_until] = ACTIONS(15381),
    [anon_sym_while] = ACTIONS(15383),
    [sym__heredoc_body_start] = ACTIONS(15385),
    [anon_sym_rescue] = ACTIONS(15387),
    [anon_sym_end] = ACTIONS(3169),
    [anon_sym_when] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(15377),
    [anon_sym_if] = ACTIONS(15389),
    [sym_comment] = ACTIONS(49),
  },
  [10671] = {
    [sym__statement] = STATE(11739),
    [sym_unary] = STATE(1824),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(11739),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_unless_modifier] = STATE(11739),
    [sym_symbol] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym__primary] = STATE(1820),
    [sym_method] = STATE(1820),
    [sym_conditional] = STATE(1824),
    [sym_left_assignment_list] = STATE(1821),
    [sym_return] = STATE(1820),
    [sym_true] = STATE(1823),
    [sym_while_modifier] = STATE(11739),
    [sym_subshell] = STATE(1820),
    [sym_unless] = STATE(1820),
    [sym_empty_statement] = STATE(10671),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_begin_block] = STATE(11739),
    [sym_range] = STATE(1824),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1823),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_call] = STATE(1822),
    [sym_end_block] = STATE(11739),
    [sym_assignment] = STATE(1824),
    [sym__lhs] = STATE(1823),
    [sym_singleton_class] = STATE(1820),
    [sym_alias] = STATE(11739),
    [sym_if_modifier] = STATE(11739),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(1824),
    [sym_method_call] = STATE(1823),
    [sym_operator_assignment] = STATE(1824),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_rational] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(1825),
    [sym_until_modifier] = STATE(11739),
    [sym_lambda] = STATE(1820),
    [sym_element_reference] = STATE(1823),
    [sym_binary] = STATE(1824),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_nil] = STATE(1823),
    [sym_rescue_modifier] = STATE(11739),
    [sym_symbol_array] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_hash] = STATE(1820),
    [aux_sym__statements_repeat1] = STATE(10671),
    [sym_scope_resolution] = STATE(1822),
    [sym_float] = ACTIONS(3171),
    [anon_sym_until] = ACTIONS(3174),
    [anon_sym_undef] = ACTIONS(3177),
    [sym_self] = ACTIONS(3180),
    [anon_sym_BEGIN] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3186),
    [anon_sym_unless] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3192),
    [sym__symbol_array_start] = ACTIONS(3195),
    [sym__simple_symbol] = ACTIONS(3198),
    [sym_complex] = ACTIONS(3201),
    [sym_heredoc_beginning] = ACTIONS(3201),
    [sym_super] = ACTIONS(3180),
    [anon_sym_alias] = ACTIONS(3204),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_nil] = ACTIONS(3210),
    [sym_character] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_END] = ACTIONS(3216),
    [sym_constant] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3219),
    [sym_instance_variable] = ACTIONS(3222),
    [anon_sym_defined_QMARK] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_true] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3234),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(3237),
    [anon_sym_NIL] = ACTIONS(3210),
    [anon_sym_COLON_COLON] = ACTIONS(3240),
    [anon_sym_def] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3246),
    [sym_class_variable] = ACTIONS(3222),
    [anon_sym_not] = ACTIONS(3252),
    [sym__symbol_start] = ACTIONS(3249),
    [anon_sym_TRUE] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(16685),
    [anon_sym_LPAREN] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3264),
    [sym_global_variable] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3267),
    [sym__subshell_start] = ACTIONS(3270),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_begin] = ACTIONS(3276),
    [anon_sym_false] = ACTIONS(3279),
    [anon_sym_when] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(3282),
    [sym__unary_minus] = ACTIONS(3285),
    [anon_sym_next] = ACTIONS(3288),
    [sym_retry] = ACTIONS(3171),
    [sym__regex_start] = ACTIONS(3291),
    [anon_sym_end] = ACTIONS(2891),
    [sym_integer] = ACTIONS(3294),
    [anon_sym_FALSE] = ACTIONS(3279),
    [sym_redo] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_if] = ACTIONS(3297),
    [sym__string_array_start] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3303),
  },
  [10672] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [10673] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [10674] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [10675] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [10676] = {
    [sym_assignment] = STATE(11740),
    [sym_unary] = STATE(11740),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11740),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11740),
    [sym_conditional] = STATE(11740),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11740),
    [sym_binary] = STATE(11740),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10677] = {
    [sym_assignment] = STATE(11741),
    [sym_unary] = STATE(11741),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11741),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_splat_argument] = STATE(11742),
    [sym_operator_assignment] = STATE(11741),
    [sym_conditional] = STATE(11741),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_return] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_subshell] = STATE(8813),
    [sym__arg_or_splat_arg] = STATE(11742),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11741),
    [sym_binary] = STATE(11741),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [sym_global_variable] = ACTIONS(13374),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13366),
    [sym_character] = ACTIONS(13370),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10678] = {
    [sym_assignment] = STATE(11743),
    [sym_unary] = STATE(11743),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11743),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11743),
    [sym_conditional] = STATE(11743),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11743),
    [sym_binary] = STATE(11743),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10679] = {
    [sym_assignment] = STATE(11744),
    [sym_unary] = STATE(11744),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11744),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11744),
    [sym_conditional] = STATE(11744),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11744),
    [sym_binary] = STATE(11744),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10680] = {
    [sym_assignment] = STATE(11746),
    [sym_unary] = STATE(11746),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11746),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11746),
    [sym_conditional] = STATE(11746),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11746),
    [sym_binary] = STATE(11746),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10681] = {
    [sym_assignment] = STATE(11747),
    [sym_unary] = STATE(11747),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11747),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11747),
    [sym_conditional] = STATE(11747),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11747),
    [sym_binary] = STATE(11747),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10682] = {
    [sym_assignment] = STATE(11748),
    [sym_unary] = STATE(11748),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11748),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11748),
    [sym_conditional] = STATE(11748),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11748),
    [sym_binary] = STATE(11748),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10683] = {
    [sym_assignment] = STATE(11749),
    [sym_unary] = STATE(11749),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11749),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11749),
    [sym_conditional] = STATE(11749),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11749),
    [sym_binary] = STATE(11749),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10684] = {
    [sym_assignment] = STATE(11750),
    [sym_unary] = STATE(11750),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11750),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11750),
    [sym_conditional] = STATE(11750),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11750),
    [sym_binary] = STATE(11750),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10685] = {
    [sym_assignment] = STATE(11751),
    [sym_unary] = STATE(11751),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11751),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11751),
    [sym_conditional] = STATE(11751),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11751),
    [sym_binary] = STATE(11751),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10686] = {
    [sym_assignment] = STATE(11752),
    [sym_unary] = STATE(11752),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11752),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(11752),
    [sym_conditional] = STATE(11752),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11752),
    [sym_binary] = STATE(11752),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [10687] = {
    [aux_sym_chained_string_repeat1] = STATE(11753),
    [sym_string] = STATE(11753),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [10688] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(3687),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6184),
    [sym_rational] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(6175),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6181),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(9961),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(9963),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(9961),
    [anon_sym_yield] = ACTIONS(6193),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(9965),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6197),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(6201),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [sym_retry] = ACTIONS(6175),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15508),
    [sym_redo] = ACTIONS(6175),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [10689] = {
    [sym_heredoc_body] = STATE(10689),
    [aux_sym_call_repeat1] = STATE(10689),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10690] = {
    [sym_heredoc_body] = STATE(10689),
    [aux_sym_call_repeat1] = STATE(10689),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10691] = {
    [aux_sym_argument_list_repeat1] = STATE(10691),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16688),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10692] = {
    [sym_heredoc_body] = STATE(10692),
    [aux_sym_call_repeat1] = STATE(10692),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [10693] = {
    [sym_heredoc_body] = STATE(10692),
    [aux_sym_call_repeat1] = STATE(10692),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [10694] = {
    [sym_assignment] = STATE(8832),
    [sym_unary] = STATE(8832),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(8832),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(8832),
    [sym_conditional] = STATE(8832),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_return] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_true] = STATE(3447),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(8832),
    [sym_binary] = STATE(8832),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [sym_global_variable] = ACTIONS(623),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(613),
    [sym_character] = ACTIONS(617),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [10695] = {
    [aux_sym_exceptions_repeat1] = STATE(11754),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16691),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [10696] = {
    [sym_assignment] = STATE(11755),
    [sym_unary] = STATE(11755),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3447),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(11755),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3447),
    [sym_operator_assignment] = STATE(11755),
    [sym_conditional] = STATE(11755),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3449),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3447),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3447),
    [sym_range] = STATE(11755),
    [sym_binary] = STATE(11755),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3447),
    [sym_nil] = STATE(3447),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5772),
    [anon_sym_not] = ACTIONS(5774),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5772),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5780),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5784),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [10697] = {
    [aux_sym_exceptions_repeat1] = STATE(10697),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16693),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10698] = {
    [anon_sym_LT] = ACTIONS(5794),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5800),
    [anon_sym_LT_LT] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5804),
    [anon_sym_AMP] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5804),
    [anon_sym_GT] = ACTIONS(5794),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [sym__binary_star] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5804),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(5804),
    [anon_sym_STAR_STAR] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_AMP_AMP] = ACTIONS(5804),
    [anon_sym_LT_EQ_GT] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5794),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(5818),
    [sym__binary_minus] = ACTIONS(5808),
  },
  [10699] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10700] = {
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [sym_self] = ACTIONS(9736),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_nil] = ACTIONS(9736),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [anon_sym_next] = ACTIONS(9736),
    [sym_retry] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10701] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [10702] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [10703] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6264),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(10055),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(10057),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10055),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(10059),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15524),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [10704] = {
    [sym_heredoc_body] = STATE(10704),
    [aux_sym_call_repeat1] = STATE(10704),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10705] = {
    [sym_heredoc_body] = STATE(10704),
    [aux_sym_call_repeat1] = STATE(10704),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10706] = {
    [aux_sym_argument_list_repeat1] = STATE(10706),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16696),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10707] = {
    [sym_assignment] = STATE(11756),
    [sym_unary] = STATE(11756),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(11756),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(11756),
    [sym_conditional] = STATE(11756),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(11756),
    [sym_binary] = STATE(11756),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [10708] = {
    [sym_assignment] = STATE(11757),
    [sym_unary] = STATE(11757),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(11757),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(11757),
    [sym_conditional] = STATE(11757),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(11757),
    [sym_binary] = STATE(11757),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [10709] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10710] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_RPAREN] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10711] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10712] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_heredoc_body] = STATE(11758),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(13417),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(16699),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [10713] = {
    [sym_heredoc_body] = STATE(11759),
    [aux_sym_call_repeat1] = STATE(11759),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [10714] = {
    [sym_heredoc_body] = STATE(11760),
    [aux_sym_call_repeat1] = STATE(11760),
    [aux_sym_argument_list_repeat1] = STATE(11761),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(15530),
    [anon_sym_RPAREN] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [10715] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10716] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10717] = {
    [aux_sym_exceptions_repeat1] = STATE(11763),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_RPAREN] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10718] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10719] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10720] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10721] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10722] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16701),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10723] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10724] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_RPAREN] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [10725] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10726] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10727] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_RPAREN] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10728] = {
    [aux_sym_chained_string_repeat1] = STATE(10728),
    [sym_string] = STATE(10728),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_RPAREN] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [10729] = {
    [sym_assignment] = STATE(8894),
    [sym_unary] = STATE(8894),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8894),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(8894),
    [sym_conditional] = STATE(8894),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(8894),
    [sym_binary] = STATE(8894),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10061),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(5310),
    [sym_character] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [10730] = {
    [aux_sym_exceptions_repeat1] = STATE(11765),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16703),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10731] = {
    [sym_assignment] = STATE(11766),
    [sym_unary] = STATE(11766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(11766),
    [sym__primary] = STATE(1248),
    [sym_method_call] = STATE(3496),
    [sym_operator_assignment] = STATE(11766),
    [sym_conditional] = STATE(11766),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_rational] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_return] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(6253),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_range] = STATE(11766),
    [sym_binary] = STATE(11766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(2171),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(5854),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_not] = ACTIONS(5856),
    [sym_self] = ACTIONS(5310),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(5862),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(5318),
    [sym_character] = ACTIONS(2177),
    [sym_super] = ACTIONS(5310),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(2171),
    [sym_constant] = ACTIONS(5310),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym_instance_variable] = ACTIONS(5318),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(5310),
    [sym_redo] = ACTIONS(2171),
    [sym_class_variable] = ACTIONS(5318),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [10732] = {
    [sym_assignment] = STATE(11767),
    [sym_unary] = STATE(11767),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3519),
    [sym_singleton_class] = STATE(338),
    [sym_module] = STATE(338),
    [sym_chained_string] = STATE(338),
    [sym_until] = STATE(338),
    [sym_regex] = STATE(338),
    [sym_for] = STATE(338),
    [sym_symbol] = STATE(338),
    [sym_if] = STATE(338),
    [sym_begin] = STATE(338),
    [sym__arg] = STATE(11767),
    [sym__primary] = STATE(338),
    [sym_method_call] = STATE(3519),
    [sym_operator_assignment] = STATE(11767),
    [sym_conditional] = STATE(11767),
    [sym_method] = STATE(338),
    [sym_singleton_method] = STATE(338),
    [sym__variable] = STATE(341),
    [sym_left_assignment_list] = STATE(3521),
    [sym_rational] = STATE(338),
    [sym_true] = STATE(3519),
    [sym_return] = STATE(338),
    [sym_subshell] = STATE(338),
    [sym_yield] = STATE(338),
    [sym_string] = STATE(3450),
    [sym_unless] = STATE(338),
    [sym_lambda] = STATE(338),
    [sym_parenthesized_statements] = STATE(338),
    [sym_element_reference] = STATE(3519),
    [sym_range] = STATE(11767),
    [sym_binary] = STATE(11767),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(338),
    [sym_break] = STATE(338),
    [sym_next] = STATE(338),
    [sym_string_array] = STATE(338),
    [sym_while] = STATE(338),
    [sym_case] = STATE(338),
    [sym_symbol_array] = STATE(338),
    [sym_array] = STATE(338),
    [sym_hash] = STATE(338),
    [sym_false] = STATE(3519),
    [sym_nil] = STATE(3519),
    [sym_scope_resolution] = STATE(341),
    [sym_call] = STATE(341),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(609),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5770),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_not] = ACTIONS(5890),
    [sym_self] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5776),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(5894),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(623),
    [sym_character] = ACTIONS(617),
    [sym_super] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(5896),
    [anon_sym_next] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(609),
    [sym_constant] = ACTIONS(613),
    [anon_sym_defined_QMARK] = ACTIONS(5898),
    [sym_instance_variable] = ACTIONS(623),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(613),
    [sym_redo] = ACTIONS(609),
    [sym_class_variable] = ACTIONS(623),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5786),
  },
  [10733] = {
    [sym_assignment] = STATE(8927),
    [sym_unary] = STATE(8927),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(8927),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(8927),
    [sym_conditional] = STATE(8927),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_return] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_true] = STATE(3535),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(8927),
    [sym_binary] = STATE(8927),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [sym_global_variable] = ACTIONS(5924),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5916),
    [sym_character] = ACTIONS(5920),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [10734] = {
    [aux_sym_exceptions_repeat1] = STATE(11768),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16705),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10735] = {
    [sym_assignment] = STATE(11769),
    [sym_unary] = STATE(11769),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3535),
    [sym_singleton_class] = STATE(3537),
    [sym_module] = STATE(3537),
    [sym_chained_string] = STATE(3537),
    [sym_until] = STATE(3537),
    [sym_regex] = STATE(3537),
    [sym_for] = STATE(3537),
    [sym_symbol] = STATE(3537),
    [sym_if] = STATE(3537),
    [sym_begin] = STATE(3537),
    [sym__arg] = STATE(11769),
    [sym__primary] = STATE(3537),
    [sym_method_call] = STATE(3535),
    [sym_operator_assignment] = STATE(11769),
    [sym_conditional] = STATE(11769),
    [sym_method] = STATE(3537),
    [sym_singleton_method] = STATE(3537),
    [sym__variable] = STATE(3538),
    [sym_left_assignment_list] = STATE(3539),
    [sym_rational] = STATE(3537),
    [sym_true] = STATE(3535),
    [sym_return] = STATE(3537),
    [sym_subshell] = STATE(3537),
    [sym_yield] = STATE(3537),
    [sym_string] = STATE(3540),
    [sym_unless] = STATE(3537),
    [sym_lambda] = STATE(3537),
    [sym_parenthesized_statements] = STATE(3537),
    [sym_element_reference] = STATE(3535),
    [sym_range] = STATE(11769),
    [sym_binary] = STATE(11769),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3537),
    [sym_break] = STATE(3537),
    [sym_next] = STATE(3537),
    [sym_string_array] = STATE(3537),
    [sym_while] = STATE(3537),
    [sym_case] = STATE(3537),
    [sym_symbol_array] = STATE(3537),
    [sym_array] = STATE(3537),
    [sym_hash] = STATE(3537),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_scope_resolution] = STATE(3538),
    [sym_call] = STATE(3538),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(5908),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5910),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(5912),
    [anon_sym_not] = ACTIONS(5914),
    [sym_self] = ACTIONS(5916),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(5918),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5920),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5912),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5924),
    [sym_character] = ACTIONS(5920),
    [sym_super] = ACTIONS(5916),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(5926),
    [anon_sym_next] = ACTIONS(5928),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(5908),
    [sym_constant] = ACTIONS(5916),
    [anon_sym_defined_QMARK] = ACTIONS(5930),
    [sym_instance_variable] = ACTIONS(5924),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(627),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(5916),
    [sym_redo] = ACTIONS(5908),
    [sym_class_variable] = ACTIONS(5924),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(5932),
  },
  [10736] = {
    [aux_sym_exceptions_repeat1] = STATE(10736),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16707),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [10737] = {
    [anon_sym_SLASH] = ACTIONS(5942),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(5944),
    [anon_sym_LT_LT] = ACTIONS(5946),
    [sym__binary_star] = ACTIONS(5948),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_STAR_STAR] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [sym__binary_minus] = ACTIONS(5968),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(5956),
  },
  [10738] = {
    [sym_assignment] = STATE(8952),
    [sym_unary] = STATE(8952),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(8952),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(8952),
    [sym_conditional] = STATE(8952),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_true] = STATE(3603),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(8952),
    [sym_binary] = STATE(8952),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(9359),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [10739] = {
    [aux_sym_exceptions_repeat1] = STATE(11770),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16710),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10740] = {
    [sym_assignment] = STATE(11771),
    [sym_unary] = STATE(11771),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3603),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(11771),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3603),
    [sym_operator_assignment] = STATE(11771),
    [sym_conditional] = STATE(11771),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3606),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3603),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3607),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3603),
    [sym_range] = STATE(11771),
    [sym_binary] = STATE(11771),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3603),
    [sym_nil] = STATE(3603),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6011),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6013),
    [anon_sym_not] = ACTIONS(6015),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6025),
    [anon_sym_next] = ACTIONS(6027),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6029),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6031),
  },
  [10741] = {
    [aux_sym_exceptions_repeat1] = STATE(10741),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16712),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10742] = {
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6047),
    [sym__binary_star] = ACTIONS(6043),
    [anon_sym_PLUS] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_BANG_TILDE] = ACTIONS(6047),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_STAR_STAR] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_DOT_DOT] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [sym__binary_minus] = ACTIONS(6055),
    [anon_sym_CARET] = ACTIONS(6067),
  },
  [10743] = {
    [sym_assignment] = STATE(8975),
    [sym_unary] = STATE(8975),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(8975),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(8975),
    [sym_conditional] = STATE(8975),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_true] = STATE(3643),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(8975),
    [sym_binary] = STATE(8975),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(6103),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [sym_global_variable] = ACTIONS(2603),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(2595),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [10744] = {
    [aux_sym_exceptions_repeat1] = STATE(11772),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16715),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10745] = {
    [sym_assignment] = STATE(11773),
    [sym_unary] = STATE(11773),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3643),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(11773),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(3643),
    [sym_operator_assignment] = STATE(11773),
    [sym_conditional] = STATE(11773),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(1483),
    [sym_left_assignment_list] = STATE(3645),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(3643),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(1484),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(3643),
    [sym_range] = STATE(11773),
    [sym_binary] = STATE(11773),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(3643),
    [sym_nil] = STATE(3643),
    [sym_scope_resolution] = STATE(1483),
    [sym_call] = STATE(1483),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_not] = ACTIONS(6101),
    [sym_self] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10264),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2603),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6105),
    [anon_sym_next] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(2595),
    [anon_sym_defined_QMARK] = ACTIONS(6093),
    [sym_instance_variable] = ACTIONS(2603),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2595),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(2603),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(2627),
  },
  [10746] = {
    [sym__line_break] = ACTIONS(5454),
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [sym_self] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_nil] = ACTIONS(5452),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_then] = ACTIONS(5452),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [anon_sym_next] = ACTIONS(5452),
    [sym_retry] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10747] = {
    [anon_sym_RPAREN] = ACTIONS(16717),
    [sym_comment] = ACTIONS(49),
  },
  [10748] = {
    [sym__line_break] = ACTIONS(10962),
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [sym_self] = ACTIONS(10960),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_nil] = ACTIONS(10960),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [anon_sym_next] = ACTIONS(10960),
    [sym_retry] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10749] = {
    [sym__line_break] = ACTIONS(10969),
    [anon_sym_DOT] = ACTIONS(10969),
    [anon_sym_then] = ACTIONS(10969),
    [anon_sym_AMP_DOT] = ACTIONS(10969),
    [anon_sym_COLON_COLON2] = ACTIONS(10969),
    [sym__heredoc_body_start] = ACTIONS(10969),
    [anon_sym_SEMI] = ACTIONS(10969),
    [anon_sym_LBRACK] = ACTIONS(10969),
    [sym_comment] = ACTIONS(49),
  },
  [10750] = {
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_SLASH] = ACTIONS(15588),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(15598),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [anon_sym_and] = ACTIONS(15598),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_PIPE] = ACTIONS(15610),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [10751] = {
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_SLASH] = ACTIONS(15588),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(15598),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [anon_sym_and] = ACTIONS(15598),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_PIPE] = ACTIONS(15610),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [10752] = {
    [sym_assignment] = STATE(11775),
    [sym_unary] = STATE(11775),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(11775),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(11775),
    [sym_conditional] = STATE(11775),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(11775),
    [sym_binary] = STATE(11775),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [10753] = {
    [sym_assignment] = STATE(11776),
    [sym_unary] = STATE(11776),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(11776),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(11776),
    [sym_conditional] = STATE(11776),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(11776),
    [sym_binary] = STATE(11776),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [10754] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10755] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10756] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10757] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_heredoc_body] = STATE(11777),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16719),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [10758] = {
    [sym_heredoc_body] = STATE(11778),
    [aux_sym_call_repeat1] = STATE(11778),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [10759] = {
    [sym_heredoc_body] = STATE(11779),
    [aux_sym_call_repeat1] = STATE(11779),
    [aux_sym_argument_list_repeat1] = STATE(11780),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(15570),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [10760] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(16721),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1349),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [10761] = {
    [anon_sym_COLON] = ACTIONS(16723),
    [sym_comment] = ACTIONS(49),
  },
  [10762] = {
    [sym_assignment] = STATE(11783),
    [sym_unary] = STATE(11783),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11783),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11783),
    [sym_conditional] = STATE(11783),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11783),
    [sym_binary] = STATE(11783),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10763] = {
    [sym_assignment] = STATE(11784),
    [sym_unary] = STATE(11784),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11784),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11784),
    [sym_conditional] = STATE(11784),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11784),
    [sym_binary] = STATE(11784),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10764] = {
    [sym_assignment] = STATE(11785),
    [sym_unary] = STATE(11785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11785),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11785),
    [sym_conditional] = STATE(11785),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11785),
    [sym_binary] = STATE(11785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10765] = {
    [sym_heredoc_body] = STATE(11787),
    [aux_sym_call_repeat1] = STATE(11787),
    [aux_sym_argument_list_repeat1] = STATE(11788),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16725),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [10766] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_EQ_GT] = ACTIONS(16723),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10767] = {
    [aux_sym_chained_string_repeat1] = STATE(9042),
    [sym_string] = STATE(9042),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_then] = ACTIONS(743),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(16727),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [10768] = {
    [sym_heredoc_body] = STATE(11787),
    [aux_sym_call_repeat1] = STATE(11787),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_then] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [10769] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [10770] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [10771] = {
    [sym_assignment] = STATE(11789),
    [sym_unary] = STATE(11789),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11789),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11789),
    [sym_conditional] = STATE(11789),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11789),
    [sym_binary] = STATE(11789),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10772] = {
    [sym_assignment] = STATE(11790),
    [sym_unary] = STATE(11790),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11790),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_splat_argument] = STATE(11791),
    [sym_operator_assignment] = STATE(11790),
    [sym_conditional] = STATE(11790),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_subshell] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(11791),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11790),
    [sym_binary] = STATE(11790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [sym_global_variable] = ACTIONS(13374),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13366),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10773] = {
    [sym_assignment] = STATE(11792),
    [sym_unary] = STATE(11792),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11792),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11792),
    [sym_conditional] = STATE(11792),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11792),
    [sym_binary] = STATE(11792),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10774] = {
    [sym_assignment] = STATE(11793),
    [sym_unary] = STATE(11793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11793),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11793),
    [sym_conditional] = STATE(11793),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11793),
    [sym_binary] = STATE(11793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10775] = {
    [sym_assignment] = STATE(11794),
    [sym_unary] = STATE(11794),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11794),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11794),
    [sym_conditional] = STATE(11794),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11794),
    [sym_binary] = STATE(11794),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10776] = {
    [sym_assignment] = STATE(11795),
    [sym_unary] = STATE(11795),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11795),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11795),
    [sym_conditional] = STATE(11795),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11795),
    [sym_binary] = STATE(11795),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10777] = {
    [sym_assignment] = STATE(11796),
    [sym_unary] = STATE(11796),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11796),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11796),
    [sym_conditional] = STATE(11796),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11796),
    [sym_binary] = STATE(11796),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10778] = {
    [sym_assignment] = STATE(11797),
    [sym_unary] = STATE(11797),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11797),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11797),
    [sym_conditional] = STATE(11797),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11797),
    [sym_binary] = STATE(11797),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10779] = {
    [sym_assignment] = STATE(11798),
    [sym_unary] = STATE(11798),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11798),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11798),
    [sym_conditional] = STATE(11798),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11798),
    [sym_binary] = STATE(11798),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10780] = {
    [sym_assignment] = STATE(11799),
    [sym_unary] = STATE(11799),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11799),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11799),
    [sym_conditional] = STATE(11799),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11799),
    [sym_binary] = STATE(11799),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10781] = {
    [sym_assignment] = STATE(11800),
    [sym_unary] = STATE(11800),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11800),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11800),
    [sym_conditional] = STATE(11800),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11800),
    [sym_binary] = STATE(11800),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10782] = {
    [sym_assignment] = STATE(11801),
    [sym_unary] = STATE(11801),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11801),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(11801),
    [sym_conditional] = STATE(11801),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11801),
    [sym_binary] = STATE(11801),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [10783] = {
    [aux_sym_chained_string_repeat1] = STATE(11802),
    [sym_string] = STATE(11802),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_then] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [10784] = {
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_then] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym_comment] = ACTIONS(49),
  },
  [10785] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10786] = {
    [aux_sym_exceptions_repeat1] = STATE(11804),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [10787] = {
    [anon_sym_do] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_then] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_AMP_DOT] = ACTIONS(4446),
    [sym__line_break] = ACTIONS(4446),
    [anon_sym_COLON_COLON2] = ACTIONS(4446),
    [sym__heredoc_body_start] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [sym_comment] = ACTIONS(49),
  },
  [10788] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(16729),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [10789] = {
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [10790] = {
    [sym__argument] = STATE(11806),
    [sym_assignment] = STATE(6445),
    [sym_unary] = STATE(6445),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(6445),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(11806),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(11806),
    [sym_hash_splat_argument] = STATE(11806),
    [sym_operator_assignment] = STATE(6445),
    [sym_conditional] = STATE(6445),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(6446),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(11806),
    [sym_range] = STATE(6445),
    [sym_binary] = STATE(6445),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(10326),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10322),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(10330),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10336),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(10344),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [10791] = {
    [sym_heredoc_body] = STATE(10791),
    [aux_sym_call_repeat1] = STATE(10791),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9774),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(16731),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
  },
  [10792] = {
    [sym_heredoc_body] = STATE(10791),
    [aux_sym_call_repeat1] = STATE(10791),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9781),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(13531),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
  },
  [10793] = {
    [aux_sym_argument_list_repeat1] = STATE(10793),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(8457),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16734),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
  },
  [10794] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10795] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10796] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10797] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16737),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10798] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10799] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10800] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10801] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [10802] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10803] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10804] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [10805] = {
    [aux_sym_chained_string_repeat1] = STATE(10805),
    [sym_string] = STATE(10805),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [10806] = {
    [aux_sym_exceptions_repeat1] = STATE(10806),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16739),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10807] = {
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(6139),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(6141),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6143),
    [anon_sym_EQ_TILDE] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6151),
    [anon_sym_AMP] = ACTIONS(6153),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [sym__binary_star] = ACTIONS(6139),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(6155),
    [anon_sym_BANG_TILDE] = ACTIONS(6143),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_STAR_STAR] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_DOT_DOT] = ACTIONS(6159),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [sym__binary_minus] = ACTIONS(6151),
    [anon_sym_CARET] = ACTIONS(6163),
  },
  [10808] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9736),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10809] = {
    [sym_assignment] = STATE(9052),
    [sym_unary] = STATE(9052),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(9052),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(9052),
    [sym_conditional] = STATE(9052),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_return] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_true] = STATE(3691),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(9052),
    [sym_binary] = STATE(9052),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(6199),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6179),
    [sym_character] = ACTIONS(6181),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [10810] = {
    [aux_sym_exceptions_repeat1] = STATE(11808),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16742),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10811] = {
    [sym_assignment] = STATE(11809),
    [sym_unary] = STATE(11809),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3691),
    [sym_singleton_class] = STATE(3687),
    [sym_module] = STATE(3687),
    [sym_chained_string] = STATE(3687),
    [sym_until] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_for] = STATE(3687),
    [sym_symbol] = STATE(3687),
    [sym_if] = STATE(3687),
    [sym_begin] = STATE(3687),
    [sym__arg] = STATE(11809),
    [sym__primary] = STATE(3687),
    [sym_method_call] = STATE(3691),
    [sym_operator_assignment] = STATE(11809),
    [sym_conditional] = STATE(11809),
    [sym_method] = STATE(3687),
    [sym_singleton_method] = STATE(3687),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(3688),
    [sym_rational] = STATE(3687),
    [sym_true] = STATE(3691),
    [sym_return] = STATE(3687),
    [sym_subshell] = STATE(3687),
    [sym_yield] = STATE(3687),
    [sym_string] = STATE(6472),
    [sym_unless] = STATE(3687),
    [sym_lambda] = STATE(3687),
    [sym_parenthesized_statements] = STATE(3687),
    [sym_element_reference] = STATE(3691),
    [sym_range] = STATE(11809),
    [sym_binary] = STATE(11809),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3687),
    [sym_break] = STATE(3687),
    [sym_next] = STATE(3687),
    [sym_string_array] = STATE(3687),
    [sym_while] = STATE(3687),
    [sym_case] = STATE(3687),
    [sym_symbol_array] = STATE(3687),
    [sym_array] = STATE(3687),
    [sym_hash] = STATE(3687),
    [sym_false] = STATE(3691),
    [sym_nil] = STATE(3691),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6175),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6193),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6183),
    [anon_sym_not] = ACTIONS(6197),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6201),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6181),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_TILDE] = ACTIONS(6183),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(6181),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6203),
    [anon_sym_next] = ACTIONS(6205),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6175),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(6189),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(6175),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6177),
  },
  [10812] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [10813] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [10814] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(6511),
    [sym_unary] = STATE(6511),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(6511),
    [sym__primary] = STATE(3721),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(6511),
    [sym_conditional] = STATE(6511),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6512),
    [sym_rational] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(6511),
    [sym_binary] = STATE(6511),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym_float] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6231),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6231),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6233),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10426),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6239),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(10428),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10426),
    [anon_sym_yield] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6239),
    [sym__block_ampersand] = ACTIONS(10430),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(6251),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [sym_retry] = ACTIONS(6227),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15633),
    [sym_redo] = ACTIONS(6227),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [10815] = {
    [sym_heredoc_body] = STATE(10815),
    [aux_sym_call_repeat1] = STATE(10815),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [10816] = {
    [sym_heredoc_body] = STATE(10815),
    [aux_sym_call_repeat1] = STATE(10815),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [10817] = {
    [aux_sym_argument_list_repeat1] = STATE(10817),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16744),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [10818] = {
    [sym_heredoc_body] = STATE(11810),
    [aux_sym_call_repeat1] = STATE(11810),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10819] = {
    [sym_heredoc_body] = STATE(11811),
    [aux_sym_call_repeat1] = STATE(11811),
    [aux_sym_argument_list_repeat1] = STATE(9101),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(10452),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_ensure] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10820] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10821] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10822] = {
    [aux_sym_exceptions_repeat1] = STATE(11813),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10823] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10824] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10825] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10826] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10827] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16747),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10828] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10829] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10830] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10831] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10832] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [10833] = {
    [aux_sym_chained_string_repeat1] = STATE(10833),
    [sym_string] = STATE(10833),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [10834] = {
    [sym_assignment] = STATE(9103),
    [sym_unary] = STATE(9103),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(9103),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(9103),
    [sym_conditional] = STATE(9103),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_return] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_true] = STATE(3719),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(9103),
    [sym_binary] = STATE(9103),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10432),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [sym_global_variable] = ACTIONS(6239),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6231),
    [sym_character] = ACTIONS(6233),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [10835] = {
    [aux_sym_exceptions_repeat1] = STATE(11815),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16749),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [10836] = {
    [sym_assignment] = STATE(11816),
    [sym_unary] = STATE(11816),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3719),
    [sym_singleton_class] = STATE(3721),
    [sym_module] = STATE(3721),
    [sym_chained_string] = STATE(3721),
    [sym_until] = STATE(3721),
    [sym_regex] = STATE(3721),
    [sym_for] = STATE(3721),
    [sym_symbol] = STATE(3721),
    [sym_if] = STATE(3721),
    [sym_begin] = STATE(3721),
    [sym__arg] = STATE(11816),
    [sym__primary] = STATE(3721),
    [sym_method_call] = STATE(3719),
    [sym_operator_assignment] = STATE(11816),
    [sym_conditional] = STATE(11816),
    [sym_method] = STATE(3721),
    [sym_singleton_method] = STATE(3721),
    [sym__variable] = STATE(3722),
    [sym_left_assignment_list] = STATE(3723),
    [sym_rational] = STATE(3721),
    [sym_true] = STATE(3719),
    [sym_return] = STATE(3721),
    [sym_subshell] = STATE(3721),
    [sym_yield] = STATE(3721),
    [sym_string] = STATE(6500),
    [sym_unless] = STATE(3721),
    [sym_lambda] = STATE(3721),
    [sym_parenthesized_statements] = STATE(3721),
    [sym_element_reference] = STATE(3719),
    [sym_range] = STATE(11816),
    [sym_binary] = STATE(11816),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3721),
    [sym_break] = STATE(3721),
    [sym_next] = STATE(3721),
    [sym_string_array] = STATE(3721),
    [sym_while] = STATE(3721),
    [sym_case] = STATE(3721),
    [sym_symbol_array] = STATE(3721),
    [sym_array] = STATE(3721),
    [sym_hash] = STATE(3721),
    [sym_false] = STATE(3719),
    [sym_nil] = STATE(3719),
    [sym_scope_resolution] = STATE(3722),
    [sym_call] = STATE(3722),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(6227),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6247),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(6235),
    [anon_sym_not] = ACTIONS(6251),
    [sym_self] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(6255),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6233),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(6233),
    [anon_sym_PLUS] = ACTIONS(10416),
    [anon_sym_TILDE] = ACTIONS(6235),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6239),
    [sym_character] = ACTIONS(6233),
    [sym_super] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(6257),
    [anon_sym_next] = ACTIONS(6259),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(6227),
    [sym_constant] = ACTIONS(6231),
    [anon_sym_defined_QMARK] = ACTIONS(6241),
    [sym_instance_variable] = ACTIONS(6239),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6231),
    [sym_redo] = ACTIONS(6227),
    [sym_class_variable] = ACTIONS(6239),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(6229),
  },
  [10837] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_ensure] = ACTIONS(5452),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10838] = {
    [anon_sym_RPAREN] = ACTIONS(16751),
    [sym_comment] = ACTIONS(49),
  },
  [10839] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10840] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_ensure] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [10841] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_ensure] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [10842] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(6549),
    [sym_unary] = STATE(6549),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(6549),
    [sym__primary] = STATE(3749),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(6549),
    [sym_conditional] = STATE(6549),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6550),
    [sym_rational] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(6549),
    [sym_binary] = STATE(6549),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym_float] = ACTIONS(6287),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(6291),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(6291),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(10490),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(6299),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [sym__identifier_hash_key] = ACTIONS(10492),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10490),
    [anon_sym_yield] = ACTIONS(6305),
    [sym_class_variable] = ACTIONS(6299),
    [sym__block_ampersand] = ACTIONS(10494),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(6309),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [sym_retry] = ACTIONS(6287),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15644),
    [sym_redo] = ACTIONS(6287),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [10843] = {
    [sym_heredoc_body] = STATE(10843),
    [aux_sym_call_repeat1] = STATE(10843),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [10844] = {
    [sym_heredoc_body] = STATE(10843),
    [aux_sym_call_repeat1] = STATE(10843),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [10845] = {
    [aux_sym_argument_list_repeat1] = STATE(10845),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16753),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_ensure] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [10846] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_ensure] = ACTIONS(9736),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10847] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10848] = {
    [aux_sym_exceptions_repeat1] = STATE(9148),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10849] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10850] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10851] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10852] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10853] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16756),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10854] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10855] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10856] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10857] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10858] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [10859] = {
    [aux_sym_exceptions_repeat1] = STATE(10859),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16758),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10860] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_ensure] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10861] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_ensure] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10862] = {
    [aux_sym_exceptions_repeat1] = STATE(11820),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_ensure] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [10863] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10864] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10865] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10866] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10867] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16761),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10868] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10869] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_ensure] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [10870] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10871] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10872] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_ensure] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [10873] = {
    [aux_sym_chained_string_repeat1] = STATE(10873),
    [sym_string] = STATE(10873),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_ensure] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [10874] = {
    [sym_assignment] = STATE(9165),
    [sym_unary] = STATE(9165),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(9165),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(9165),
    [sym_conditional] = STATE(9165),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_return] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_true] = STATE(3753),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(9165),
    [sym_binary] = STATE(9165),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10496),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [sym_global_variable] = ACTIONS(6299),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6291),
    [sym_character] = ACTIONS(6293),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [10875] = {
    [aux_sym_exceptions_repeat1] = STATE(11822),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16763),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10876] = {
    [sym_assignment] = STATE(11823),
    [sym_unary] = STATE(11823),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3753),
    [sym_singleton_class] = STATE(3749),
    [sym_module] = STATE(3749),
    [sym_chained_string] = STATE(3749),
    [sym_until] = STATE(3749),
    [sym_regex] = STATE(3749),
    [sym_for] = STATE(3749),
    [sym_symbol] = STATE(3749),
    [sym_if] = STATE(3749),
    [sym_begin] = STATE(3749),
    [sym__arg] = STATE(11823),
    [sym__primary] = STATE(3749),
    [sym_method_call] = STATE(3753),
    [sym_operator_assignment] = STATE(11823),
    [sym_conditional] = STATE(11823),
    [sym_method] = STATE(3749),
    [sym_singleton_method] = STATE(3749),
    [sym__variable] = STATE(3751),
    [sym_left_assignment_list] = STATE(3750),
    [sym_rational] = STATE(3749),
    [sym_true] = STATE(3753),
    [sym_return] = STATE(3749),
    [sym_subshell] = STATE(3749),
    [sym_yield] = STATE(3749),
    [sym_string] = STATE(6573),
    [sym_unless] = STATE(3749),
    [sym_lambda] = STATE(3749),
    [sym_parenthesized_statements] = STATE(3749),
    [sym_element_reference] = STATE(3753),
    [sym_range] = STATE(11823),
    [sym_binary] = STATE(11823),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3749),
    [sym_break] = STATE(3749),
    [sym_next] = STATE(3749),
    [sym_string_array] = STATE(3749),
    [sym_while] = STATE(3749),
    [sym_case] = STATE(3749),
    [sym_symbol_array] = STATE(3749),
    [sym_array] = STATE(3749),
    [sym_hash] = STATE(3749),
    [sym_false] = STATE(3753),
    [sym_nil] = STATE(3753),
    [sym_scope_resolution] = STATE(3751),
    [sym_call] = STATE(3751),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(6287),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(6305),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_not] = ACTIONS(6309),
    [sym_self] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(6313),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(6293),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(10526),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6299),
    [sym_character] = ACTIONS(6293),
    [sym_super] = ACTIONS(6291),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_next] = ACTIONS(6317),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(6287),
    [sym_constant] = ACTIONS(6291),
    [anon_sym_defined_QMARK] = ACTIONS(6301),
    [sym_instance_variable] = ACTIONS(6299),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(10418),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(6291),
    [sym_redo] = ACTIONS(6287),
    [sym_class_variable] = ACTIONS(6299),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(6289),
  },
  [10877] = {
    [anon_sym_LT] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6327),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(6329),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6331),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6331),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6341),
    [anon_sym_GT] = ACTIONS(6325),
    [anon_sym_PERCENT] = ACTIONS(6327),
    [sym__binary_star] = ACTIONS(6327),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(6343),
    [anon_sym_BANG_TILDE] = ACTIONS(6331),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6331),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6331),
    [anon_sym_STAR_STAR] = ACTIONS(6327),
    [anon_sym_PIPE] = ACTIONS(6349),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6331),
    [anon_sym_LT_EQ_GT] = ACTIONS(6331),
    [anon_sym_LT_EQ] = ACTIONS(6325),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6351),
    [sym__binary_minus] = ACTIONS(6339),
  },
  [10878] = {
    [sym_heredoc_body] = STATE(10878),
    [aux_sym_call_repeat1] = STATE(10878),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [10879] = {
    [sym_heredoc_body] = STATE(10878),
    [aux_sym_call_repeat1] = STATE(10878),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [10880] = {
    [sym_assignment] = STATE(9193),
    [sym_unary] = STATE(9193),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(9193),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(9193),
    [sym_conditional] = STATE(9193),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_return] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_true] = STATE(3793),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(9193),
    [sym_binary] = STATE(9193),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(681),
    [sym_character] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [10881] = {
    [aux_sym_exceptions_repeat1] = STATE(11824),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16765),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [10882] = {
    [sym_assignment] = STATE(11825),
    [sym_unary] = STATE(11825),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3793),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(11825),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3793),
    [sym_operator_assignment] = STATE(11825),
    [sym_conditional] = STATE(11825),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3795),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3793),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3793),
    [sym_range] = STATE(11825),
    [sym_binary] = STATE(11825),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3793),
    [sym_nil] = STATE(3793),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_not] = ACTIONS(6377),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6381),
    [anon_sym_TILDE] = ACTIONS(6375),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6387),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [10883] = {
    [aux_sym_exceptions_repeat1] = STATE(10883),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16767),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [10884] = {
    [anon_sym_LT] = ACTIONS(6397),
    [anon_sym_SLASH] = ACTIONS(6399),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(6401),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6403),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6405),
    [anon_sym_LT_LT] = ACTIONS(6403),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6407),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6407),
    [anon_sym_AMP] = ACTIONS(6409),
    [anon_sym_GT] = ACTIONS(6397),
    [anon_sym_PLUS] = ACTIONS(6411),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(6399),
    [sym__binary_star] = ACTIONS(6399),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(6413),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(6407),
    [anon_sym_PIPE_PIPE] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6415),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6407),
    [anon_sym_STAR_STAR] = ACTIONS(6399),
    [anon_sym_PIPE] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_AMP_AMP] = ACTIONS(6407),
    [anon_sym_LT_EQ_GT] = ACTIONS(6407),
    [anon_sym_LT_EQ] = ACTIONS(6397),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6421),
    [sym__binary_minus] = ACTIONS(6411),
  },
  [10885] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [anon_sym_ensure] = ACTIONS(9736),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [10886] = {
    [sym_assignment] = STATE(11826),
    [sym_unary] = STATE(11826),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3840),
    [sym_singleton_class] = STATE(376),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_for] = STATE(376),
    [sym_symbol] = STATE(376),
    [sym_if] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(11826),
    [sym__primary] = STATE(376),
    [sym_method_call] = STATE(3840),
    [sym_operator_assignment] = STATE(11826),
    [sym_conditional] = STATE(11826),
    [sym_method] = STATE(376),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_left_assignment_list] = STATE(3842),
    [sym_rational] = STATE(376),
    [sym_true] = STATE(3840),
    [sym_return] = STATE(376),
    [sym_subshell] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(3796),
    [sym_unless] = STATE(376),
    [sym_lambda] = STATE(376),
    [sym_parenthesized_statements] = STATE(376),
    [sym_element_reference] = STATE(3840),
    [sym_range] = STATE(11826),
    [sym_binary] = STATE(11826),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_case] = STATE(376),
    [sym_symbol_array] = STATE(376),
    [sym_array] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_false] = STATE(3840),
    [sym_nil] = STATE(3840),
    [sym_scope_resolution] = STATE(381),
    [sym_call] = STATE(381),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(677),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6373),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6457),
    [anon_sym_not] = ACTIONS(6459),
    [sym_self] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6457),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(691),
    [sym_character] = ACTIONS(683),
    [sym_super] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6465),
    [anon_sym_next] = ACTIONS(6385),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(677),
    [sym_constant] = ACTIONS(681),
    [anon_sym_defined_QMARK] = ACTIONS(6467),
    [sym_instance_variable] = ACTIONS(691),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [sym_redo] = ACTIONS(677),
    [sym_class_variable] = ACTIONS(691),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6389),
  },
  [10887] = {
    [sym_assignment] = STATE(9233),
    [sym_unary] = STATE(9233),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(9233),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(9233),
    [sym_conditional] = STATE(9233),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_return] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_true] = STATE(3858),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(9233),
    [sym_binary] = STATE(9233),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [sym_global_variable] = ACTIONS(6497),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6489),
    [sym_character] = ACTIONS(6493),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [10888] = {
    [aux_sym_exceptions_repeat1] = STATE(11827),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16770),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [10889] = {
    [sym_assignment] = STATE(11828),
    [sym_unary] = STATE(11828),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3858),
    [sym_singleton_class] = STATE(3860),
    [sym_module] = STATE(3860),
    [sym_chained_string] = STATE(3860),
    [sym_until] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_for] = STATE(3860),
    [sym_symbol] = STATE(3860),
    [sym_if] = STATE(3860),
    [sym_begin] = STATE(3860),
    [sym__arg] = STATE(11828),
    [sym__primary] = STATE(3860),
    [sym_method_call] = STATE(3858),
    [sym_operator_assignment] = STATE(11828),
    [sym_conditional] = STATE(11828),
    [sym_method] = STATE(3860),
    [sym_singleton_method] = STATE(3860),
    [sym__variable] = STATE(3861),
    [sym_left_assignment_list] = STATE(3862),
    [sym_rational] = STATE(3860),
    [sym_true] = STATE(3858),
    [sym_return] = STATE(3860),
    [sym_subshell] = STATE(3860),
    [sym_yield] = STATE(3860),
    [sym_string] = STATE(3863),
    [sym_unless] = STATE(3860),
    [sym_lambda] = STATE(3860),
    [sym_parenthesized_statements] = STATE(3860),
    [sym_element_reference] = STATE(3858),
    [sym_range] = STATE(11828),
    [sym_binary] = STATE(11828),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3860),
    [sym_break] = STATE(3860),
    [sym_next] = STATE(3860),
    [sym_string_array] = STATE(3860),
    [sym_while] = STATE(3860),
    [sym_case] = STATE(3860),
    [sym_symbol_array] = STATE(3860),
    [sym_array] = STATE(3860),
    [sym_hash] = STATE(3860),
    [sym_false] = STATE(3858),
    [sym_nil] = STATE(3858),
    [sym_scope_resolution] = STATE(3861),
    [sym_call] = STATE(3861),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(6481),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6483),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(6485),
    [anon_sym_not] = ACTIONS(6487),
    [sym_self] = ACTIONS(6489),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(6491),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6493),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6485),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6497),
    [sym_character] = ACTIONS(6493),
    [sym_super] = ACTIONS(6489),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(6499),
    [anon_sym_next] = ACTIONS(6501),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(6481),
    [sym_constant] = ACTIONS(6489),
    [anon_sym_defined_QMARK] = ACTIONS(6503),
    [sym_instance_variable] = ACTIONS(6497),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(6489),
    [sym_redo] = ACTIONS(6481),
    [sym_class_variable] = ACTIONS(6497),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(6505),
  },
  [10890] = {
    [aux_sym_exceptions_repeat1] = STATE(10890),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16772),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [10891] = {
    [anon_sym_SLASH] = ACTIONS(6515),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [sym__binary_star] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6525),
    [anon_sym_PERCENT] = ACTIONS(6515),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(6527),
    [anon_sym_PIPE] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(6527),
    [anon_sym_QMARK] = ACTIONS(6533),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6535),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(6527),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(6537),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6537),
    [anon_sym_GT_EQ] = ACTIONS(6539),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6515),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6537),
    [sym__binary_minus] = ACTIONS(6541),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6529),
  },
  [10892] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [10893] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [10894] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(6753),
    [sym_unary] = STATE(6753),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1601),
    [sym_singleton_class] = STATE(917),
    [sym_module] = STATE(917),
    [sym_chained_string] = STATE(917),
    [sym_until] = STATE(917),
    [sym_regex] = STATE(917),
    [sym_for] = STATE(917),
    [sym_symbol] = STATE(917),
    [sym_if] = STATE(917),
    [sym_begin] = STATE(917),
    [sym__arg] = STATE(6753),
    [sym__primary] = STATE(917),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(1601),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(6753),
    [sym_conditional] = STATE(6753),
    [sym_method] = STATE(917),
    [sym_singleton_method] = STATE(917),
    [sym__variable] = STATE(1002),
    [sym_left_assignment_list] = STATE(1599),
    [sym_return] = STATE(917),
    [sym_yield] = STATE(917),
    [sym_string] = STATE(6754),
    [sym_rational] = STATE(917),
    [sym_subshell] = STATE(917),
    [sym_true] = STATE(1601),
    [sym_unless] = STATE(917),
    [sym_lambda] = STATE(917),
    [sym_parenthesized_statements] = STATE(917),
    [sym_element_reference] = STATE(1601),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(6753),
    [sym_binary] = STATE(6753),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(917),
    [sym_break] = STATE(917),
    [sym_next] = STATE(917),
    [sym_string_array] = STATE(917),
    [sym_while] = STATE(917),
    [sym_case] = STATE(917),
    [sym_symbol_array] = STATE(917),
    [sym_array] = STATE(917),
    [sym_hash] = STATE(917),
    [sym_false] = STATE(1601),
    [sym_nil] = STATE(1601),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_float] = ACTIONS(1667),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(1809),
    [sym_heredoc_beginning] = ACTIONS(1673),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(1673),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(1809),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(10753),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(1819),
    [anon_sym_defined_QMARK] = ACTIONS(2827),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(4466),
    [sym__identifier_hash_key] = ACTIONS(10755),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(10753),
    [anon_sym_yield] = ACTIONS(2831),
    [sym_class_variable] = ACTIONS(1819),
    [sym__block_ampersand] = ACTIONS(10757),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2833),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2841),
    [anon_sym_next] = ACTIONS(2843),
    [sym_retry] = ACTIONS(1667),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15681),
    [sym_redo] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2847),
  },
  [10895] = {
    [sym_heredoc_body] = STATE(10895),
    [aux_sym_call_repeat1] = STATE(10895),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [10896] = {
    [sym_heredoc_body] = STATE(10895),
    [aux_sym_call_repeat1] = STATE(10895),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [10897] = {
    [aux_sym_argument_list_repeat1] = STATE(10897),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16775),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [10898] = {
    [sym_assignment] = STATE(9267),
    [sym_unary] = STATE(9267),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(9267),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(9267),
    [sym_conditional] = STATE(9267),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_return] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_true] = STATE(3922),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(9267),
    [sym_binary] = STATE(9267),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(10759),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(4792),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [10899] = {
    [aux_sym_exceptions_repeat1] = STATE(11829),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16778),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [10900] = {
    [sym_assignment] = STATE(11830),
    [sym_unary] = STATE(11830),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3922),
    [sym_singleton_class] = STATE(2825),
    [sym_module] = STATE(2825),
    [sym_chained_string] = STATE(2825),
    [sym_until] = STATE(2825),
    [sym_regex] = STATE(2825),
    [sym_for] = STATE(2825),
    [sym_symbol] = STATE(2825),
    [sym_if] = STATE(2825),
    [sym_begin] = STATE(2825),
    [sym__arg] = STATE(11830),
    [sym__primary] = STATE(2825),
    [sym_method_call] = STATE(3922),
    [sym_operator_assignment] = STATE(11830),
    [sym_conditional] = STATE(11830),
    [sym_method] = STATE(2825),
    [sym_singleton_method] = STATE(2825),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(3924),
    [sym_rational] = STATE(2825),
    [sym_true] = STATE(3922),
    [sym_return] = STATE(2825),
    [sym_subshell] = STATE(2825),
    [sym_yield] = STATE(2825),
    [sym_string] = STATE(3925),
    [sym_unless] = STATE(2825),
    [sym_lambda] = STATE(2825),
    [sym_parenthesized_statements] = STATE(2825),
    [sym_element_reference] = STATE(3922),
    [sym_range] = STATE(11830),
    [sym_binary] = STATE(11830),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2825),
    [sym_break] = STATE(2825),
    [sym_next] = STATE(2825),
    [sym_string_array] = STATE(2825),
    [sym_while] = STATE(2825),
    [sym_case] = STATE(2825),
    [sym_symbol_array] = STATE(2825),
    [sym_array] = STATE(2825),
    [sym_hash] = STATE(2825),
    [sym_false] = STATE(3922),
    [sym_nil] = STATE(3922),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(4780),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(6572),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(6574),
    [anon_sym_not] = ACTIONS(6576),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(6578),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(4792),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(6580),
    [anon_sym_TILDE] = ACTIONS(6574),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(4792),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(6582),
    [anon_sym_next] = ACTIONS(6584),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(4780),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(6586),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(4780),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(6588),
  },
  [10901] = {
    [aux_sym_exceptions_repeat1] = STATE(10901),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16780),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [10902] = {
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_QMARK] = ACTIONS(6602),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6608),
    [anon_sym_LT_LT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6604),
    [sym__binary_star] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_AMP] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_PERCENT] = ACTIONS(6600),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6604),
    [anon_sym_BANG_TILDE] = ACTIONS(6604),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6604),
    [anon_sym_STAR_STAR] = ACTIONS(6600),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_DOT_DOT] = ACTIONS(6620),
    [anon_sym_AMP_AMP] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6604),
    [anon_sym_LT_EQ] = ACTIONS(6598),
    [sym__binary_minus] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(6624),
  },
  [10903] = {
    [aux_sym_undef_repeat1] = STATE(10903),
    [sym__line_break] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_else] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [anon_sym_elsif] = ACTIONS(7428),
  },
  [10904] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_elsif] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [10905] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_elsif] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [10906] = {
    [sym_assignment] = STATE(11831),
    [sym_unary] = STATE(11831),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(11831),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(11831),
    [sym_conditional] = STATE(11831),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(11831),
    [sym_binary] = STATE(11831),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [10907] = {
    [sym_assignment] = STATE(11832),
    [sym_unary] = STATE(11832),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(11832),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(11832),
    [sym_conditional] = STATE(11832),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(11832),
    [sym_binary] = STATE(11832),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [10908] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_elsif] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10909] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_elsif] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10910] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_elsif] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10911] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_heredoc_body] = STATE(11833),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym_float] = ACTIONS(10799),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(10803),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(10811),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10823),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16783),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [10912] = {
    [sym_heredoc_body] = STATE(11834),
    [aux_sym_call_repeat1] = STATE(11834),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10913] = {
    [sym_heredoc_body] = STATE(11835),
    [aux_sym_call_repeat1] = STATE(11835),
    [aux_sym_argument_list_repeat1] = STATE(11836),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(15691),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [10914] = {
    [sym_heredoc_body] = STATE(11837),
    [aux_sym_call_repeat1] = STATE(11837),
    [aux_sym_argument_list_repeat1] = STATE(11838),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(13801),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [10915] = {
    [sym_heredoc_body] = STATE(11837),
    [aux_sym_call_repeat1] = STATE(11837),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_elsif] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [10916] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [10917] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [10918] = {
    [sym_assignment] = STATE(11839),
    [sym_unary] = STATE(11839),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11839),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11839),
    [sym_conditional] = STATE(11839),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11839),
    [sym_binary] = STATE(11839),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10919] = {
    [sym_assignment] = STATE(11840),
    [sym_unary] = STATE(11840),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11840),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_splat_argument] = STATE(11841),
    [sym_operator_assignment] = STATE(11840),
    [sym_conditional] = STATE(11840),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_return] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_subshell] = STATE(3955),
    [sym__arg_or_splat_arg] = STATE(11841),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11840),
    [sym_binary] = STATE(11840),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6638),
    [sym_character] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10920] = {
    [sym_assignment] = STATE(11842),
    [sym_unary] = STATE(11842),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11842),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11842),
    [sym_conditional] = STATE(11842),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11842),
    [sym_binary] = STATE(11842),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10921] = {
    [sym_assignment] = STATE(11843),
    [sym_unary] = STATE(11843),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11843),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11843),
    [sym_conditional] = STATE(11843),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11843),
    [sym_binary] = STATE(11843),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10922] = {
    [sym_assignment] = STATE(11845),
    [sym_unary] = STATE(11845),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11845),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11845),
    [sym_conditional] = STATE(11845),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11845),
    [sym_binary] = STATE(11845),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10923] = {
    [sym_assignment] = STATE(11846),
    [sym_unary] = STATE(11846),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11846),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11846),
    [sym_conditional] = STATE(11846),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11846),
    [sym_binary] = STATE(11846),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10924] = {
    [sym_assignment] = STATE(11847),
    [sym_unary] = STATE(11847),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11847),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11847),
    [sym_conditional] = STATE(11847),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11847),
    [sym_binary] = STATE(11847),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10925] = {
    [sym_assignment] = STATE(11848),
    [sym_unary] = STATE(11848),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11848),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11848),
    [sym_conditional] = STATE(11848),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11848),
    [sym_binary] = STATE(11848),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10926] = {
    [sym_assignment] = STATE(11849),
    [sym_unary] = STATE(11849),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11849),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11849),
    [sym_conditional] = STATE(11849),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11849),
    [sym_binary] = STATE(11849),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10927] = {
    [sym_assignment] = STATE(11850),
    [sym_unary] = STATE(11850),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11850),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11850),
    [sym_conditional] = STATE(11850),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11850),
    [sym_binary] = STATE(11850),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10928] = {
    [sym_assignment] = STATE(11851),
    [sym_unary] = STATE(11851),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11851),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(11851),
    [sym_conditional] = STATE(11851),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11851),
    [sym_binary] = STATE(11851),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10929] = {
    [aux_sym_chained_string_repeat1] = STATE(11852),
    [sym_string] = STATE(11852),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_elsif] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [10930] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(6808),
    [sym_unary] = STATE(6808),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(6808),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(6808),
    [sym_conditional] = STATE(6808),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(6812),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(6808),
    [sym_binary] = STATE(6808),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym_float] = ACTIONS(10799),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(10803),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(10809),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(10817),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10809),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(10821),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10823),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15727),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [10931] = {
    [sym_heredoc_body] = STATE(10931),
    [aux_sym_call_repeat1] = STATE(10931),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_elsif] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [10932] = {
    [sym_heredoc_body] = STATE(10931),
    [aux_sym_call_repeat1] = STATE(10931),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_elsif] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [10933] = {
    [aux_sym_argument_list_repeat1] = STATE(10933),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16785),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [10934] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10935] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_elsif] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10936] = {
    [aux_sym_exceptions_repeat1] = STATE(11854),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [10937] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10938] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10939] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [10940] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10941] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10942] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10943] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10944] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [10945] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10946] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [10947] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_CARET] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_elsif] = ACTIONS(1327),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [10948] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11857),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(16790),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [10949] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_rescue] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_CARET] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_elsif] = ACTIONS(6719),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [10950] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_rescue] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_CARET] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_elsif] = ACTIONS(6727),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [10951] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(10950),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11858),
    [sym_operator] = STATE(11858),
    [anon_sym_LT] = ACTIONS(15729),
    [anon_sym_SLASH] = ACTIONS(15731),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(15731),
    [anon_sym_PLUS_AT] = ACTIONS(15731),
    [anon_sym_LPAREN2] = ACTIONS(15733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15731),
    [anon_sym_GT_GT] = ACTIONS(15731),
    [anon_sym_EQ_TILDE] = ACTIONS(15731),
    [anon_sym_LT_LT] = ACTIONS(15731),
    [anon_sym_TILDE] = ACTIONS(15731),
    [anon_sym_PLUS] = ACTIONS(15729),
    [anon_sym_AMP] = ACTIONS(15731),
    [anon_sym_GT] = ACTIONS(15729),
    [anon_sym_PERCENT] = ACTIONS(15731),
    [anon_sym_DASH_AT] = ACTIONS(15731),
    [anon_sym_EQ_EQ] = ACTIONS(15729),
    [anon_sym_STAR] = ACTIONS(15729),
    [anon_sym_BANG_TILDE] = ACTIONS(15731),
    [sym_constant] = ACTIONS(16792),
    [anon_sym_DASH] = ACTIONS(15729),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(15731),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(15729),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(15731),
    [anon_sym_STAR_STAR] = ACTIONS(15731),
    [anon_sym_PIPE] = ACTIONS(15731),
    [anon_sym_DOT_DOT] = ACTIONS(15731),
    [anon_sym_LT_EQ_GT] = ACTIONS(15731),
    [anon_sym_LT_EQ] = ACTIONS(15729),
    [anon_sym_BANG] = ACTIONS(15729),
    [sym_identifier] = ACTIONS(16792),
    [anon_sym_CARET] = ACTIONS(15731),
  },
  [10952] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_CARET] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_elsif] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [10953] = {
    [sym_assignment] = STATE(11859),
    [sym_unary] = STATE(11859),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11859),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11859),
    [sym_conditional] = STATE(11859),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11859),
    [sym_binary] = STATE(11859),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [10954] = {
    [sym_assignment] = STATE(11860),
    [sym_unary] = STATE(11860),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(11860),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(11860),
    [sym_conditional] = STATE(11860),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(11860),
    [sym_binary] = STATE(11860),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [10955] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_elsif] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [10956] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_elsif] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [10957] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_elsif] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [10958] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_heredoc_body] = STATE(11861),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(10861),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(10861),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(10869),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [sym__block_ampersand] = ACTIONS(13845),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(10879),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16794),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [10959] = {
    [sym_heredoc_body] = STATE(11862),
    [aux_sym_call_repeat1] = STATE(11862),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [10960] = {
    [sym_heredoc_body] = STATE(11863),
    [aux_sym_call_repeat1] = STATE(11863),
    [aux_sym_argument_list_repeat1] = STATE(11864),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(15743),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [10961] = {
    [aux_sym_chained_string_repeat1] = STATE(10961),
    [sym_string] = STATE(10961),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_elsif] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [10962] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_elsif] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [10963] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_elsif] = ACTIONS(5452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [10964] = {
    [anon_sym_RPAREN] = ACTIONS(16796),
    [sym_comment] = ACTIONS(49),
  },
  [10965] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_elsif] = ACTIONS(10960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [10966] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_elsif] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [10967] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [10968] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [10969] = {
    [sym_assignment] = STATE(11866),
    [sym_unary] = STATE(11866),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11866),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11866),
    [sym_conditional] = STATE(11866),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11866),
    [sym_binary] = STATE(11866),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10970] = {
    [sym_assignment] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_splat_argument] = STATE(11867),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_return] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_subshell] = STATE(3955),
    [sym__arg_or_splat_arg] = STATE(11867),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(13869),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6638),
    [sym_character] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10971] = {
    [sym_assignment] = STATE(11868),
    [sym_unary] = STATE(11868),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11868),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11868),
    [sym_conditional] = STATE(11868),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11868),
    [sym_binary] = STATE(11868),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10972] = {
    [sym_assignment] = STATE(11869),
    [sym_unary] = STATE(11869),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11869),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11869),
    [sym_conditional] = STATE(11869),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11869),
    [sym_binary] = STATE(11869),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10973] = {
    [sym_assignment] = STATE(11871),
    [sym_unary] = STATE(11871),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11871),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11871),
    [sym_conditional] = STATE(11871),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11871),
    [sym_binary] = STATE(11871),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10974] = {
    [sym_assignment] = STATE(11872),
    [sym_unary] = STATE(11872),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11872),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11872),
    [sym_conditional] = STATE(11872),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11872),
    [sym_binary] = STATE(11872),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10975] = {
    [sym_assignment] = STATE(11873),
    [sym_unary] = STATE(11873),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11873),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11873),
    [sym_conditional] = STATE(11873),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11873),
    [sym_binary] = STATE(11873),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10976] = {
    [sym_assignment] = STATE(11874),
    [sym_unary] = STATE(11874),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11874),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11874),
    [sym_conditional] = STATE(11874),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11874),
    [sym_binary] = STATE(11874),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10977] = {
    [sym_assignment] = STATE(11875),
    [sym_unary] = STATE(11875),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11875),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11875),
    [sym_conditional] = STATE(11875),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11875),
    [sym_binary] = STATE(11875),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10978] = {
    [sym_assignment] = STATE(11876),
    [sym_unary] = STATE(11876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11876),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11876),
    [sym_conditional] = STATE(11876),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11876),
    [sym_binary] = STATE(11876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10979] = {
    [sym_assignment] = STATE(11877),
    [sym_unary] = STATE(11877),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11877),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(11877),
    [sym_conditional] = STATE(11877),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(11877),
    [sym_binary] = STATE(11877),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10980] = {
    [sym_assignment] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_return] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_true] = STATE(9355),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(13869),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6638),
    [sym_character] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [10981] = {
    [aux_sym_exceptions_repeat1] = STATE(11878),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(15785),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_elsif] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [10982] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_elsif] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [10983] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_elsif] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [10984] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [10985] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_elsif] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [10986] = {
    [sym_assignment] = STATE(11879),
    [sym_unary] = STATE(11879),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11879),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11879),
    [sym_conditional] = STATE(11879),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11879),
    [sym_binary] = STATE(11879),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10987] = {
    [sym_assignment] = STATE(11880),
    [sym_unary] = STATE(11880),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11880),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_splat_argument] = STATE(11881),
    [sym_operator_assignment] = STATE(11880),
    [sym_conditional] = STATE(11880),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_return] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_subshell] = STATE(9373),
    [sym__arg_or_splat_arg] = STATE(11881),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11880),
    [sym_binary] = STATE(11880),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [sym_global_variable] = ACTIONS(13899),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13891),
    [sym_character] = ACTIONS(13895),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10988] = {
    [sym_assignment] = STATE(11882),
    [sym_unary] = STATE(11882),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11882),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11882),
    [sym_conditional] = STATE(11882),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11882),
    [sym_binary] = STATE(11882),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10989] = {
    [sym_assignment] = STATE(11883),
    [sym_unary] = STATE(11883),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11883),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11883),
    [sym_conditional] = STATE(11883),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11883),
    [sym_binary] = STATE(11883),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10990] = {
    [sym_assignment] = STATE(11885),
    [sym_unary] = STATE(11885),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11885),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11885),
    [sym_conditional] = STATE(11885),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11885),
    [sym_binary] = STATE(11885),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10991] = {
    [sym_assignment] = STATE(11886),
    [sym_unary] = STATE(11886),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(11886),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(11886),
    [sym_conditional] = STATE(11886),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(11886),
    [sym_binary] = STATE(11886),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [10992] = {
    [sym_assignment] = STATE(11887),
    [sym_unary] = STATE(11887),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11887),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11887),
    [sym_conditional] = STATE(11887),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11887),
    [sym_binary] = STATE(11887),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10993] = {
    [sym_assignment] = STATE(11888),
    [sym_unary] = STATE(11888),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11888),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11888),
    [sym_conditional] = STATE(11888),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11888),
    [sym_binary] = STATE(11888),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10994] = {
    [sym_assignment] = STATE(11889),
    [sym_unary] = STATE(11889),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11889),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11889),
    [sym_conditional] = STATE(11889),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11889),
    [sym_binary] = STATE(11889),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10995] = {
    [sym_assignment] = STATE(11890),
    [sym_unary] = STATE(11890),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11890),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11890),
    [sym_conditional] = STATE(11890),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11890),
    [sym_binary] = STATE(11890),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10996] = {
    [sym_assignment] = STATE(11891),
    [sym_unary] = STATE(11891),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11891),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(11891),
    [sym_conditional] = STATE(11891),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11891),
    [sym_binary] = STATE(11891),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [10997] = {
    [aux_sym_chained_string_repeat1] = STATE(11892),
    [sym_string] = STATE(11892),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_elsif] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [10998] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_elsif] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [10999] = {
    [aux_sym_exceptions_repeat1] = STATE(11894),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11000] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(6842),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(10861),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(10861),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(10867),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(10873),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10867),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [sym__block_ampersand] = ACTIONS(10877),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(10879),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15821),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [11001] = {
    [sym_heredoc_body] = STATE(11001),
    [aux_sym_call_repeat1] = STATE(11001),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_elsif] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [11002] = {
    [sym_heredoc_body] = STATE(11001),
    [aux_sym_call_repeat1] = STATE(11001),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_elsif] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [11003] = {
    [aux_sym_argument_list_repeat1] = STATE(11003),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16798),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [11004] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11005] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11006] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11007] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16801),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11008] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11009] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11010] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11011] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11012] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11013] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11014] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11015] = {
    [aux_sym_chained_string_repeat1] = STATE(11015),
    [sym_string] = STATE(11015),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_elsif] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11016] = {
    [sym_assignment] = STATE(11896),
    [sym_unary] = STATE(11896),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3958),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11896),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(3958),
    [sym_operator_assignment] = STATE(11896),
    [sym_conditional] = STATE(11896),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(3956),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(3958),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(3960),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(3958),
    [sym_range] = STATE(11896),
    [sym_binary] = STATE(11896),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(3958),
    [sym_nil] = STATE(3958),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(6652),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(6644),
    [anon_sym_not] = ACTIONS(6654),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(6658),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6642),
    [anon_sym_TILDE] = ACTIONS(6644),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(6660),
    [anon_sym_next] = ACTIONS(6662),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(6648),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(6664),
  },
  [11017] = {
    [anon_sym_end] = ACTIONS(16803),
    [sym_comment] = ACTIONS(49),
  },
  [11018] = {
    [anon_sym_LT] = ACTIONS(6751),
    [anon_sym_SLASH] = ACTIONS(6753),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(6755),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6757),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6759),
    [anon_sym_LT_LT] = ACTIONS(6757),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6761),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6761),
    [anon_sym_AMP] = ACTIONS(6763),
    [anon_sym_GT] = ACTIONS(6751),
    [anon_sym_PLUS] = ACTIONS(6765),
    [anon_sym_PERCENT] = ACTIONS(6753),
    [sym__binary_star] = ACTIONS(6753),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(6767),
    [anon_sym_BANG_TILDE] = ACTIONS(6761),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6761),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6769),
    [sym_comment] = ACTIONS(49),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6761),
    [anon_sym_STAR_STAR] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(6773),
    [anon_sym_AMP_AMP] = ACTIONS(6761),
    [anon_sym_LT_EQ_GT] = ACTIONS(6761),
    [anon_sym_LT_EQ] = ACTIONS(6751),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6775),
    [sym__binary_minus] = ACTIONS(6765),
  },
  [11019] = {
    [anon_sym_SLASH] = ACTIONS(14594),
    [sym__line_break] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_AMP_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT_EQ] = ACTIONS(14596),
    [anon_sym_SLASH_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14594),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14594),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14594),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_PERCENT_EQ] = ACTIONS(14596),
    [anon_sym_LT_LT_EQ] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_else] = ACTIONS(14596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_CARET_EQ] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_EQ] = ACTIONS(14594),
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_then] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14594),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_EQ_GT] = ACTIONS(14596),
    [anon_sym_when] = ACTIONS(14596),
    [anon_sym_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_PLUS_EQ] = ACTIONS(14596),
    [anon_sym_STAR_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym___END__] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14594),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_end] = ACTIONS(14596),
    [anon_sym_ensure] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_elsif] = ACTIONS(14596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14596),
    [ts_builtin_sym_end] = ACTIONS(14596),
    [anon_sym_DASH_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14594),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_AMP_AMP] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14594),
  },
  [11020] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11021] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(6999),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11022] = {
    [aux_sym_exceptions_repeat1] = STATE(9440),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_RBRACE] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11023] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11024] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11025] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11026] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11027] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16805),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11028] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11029] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11030] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11031] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11032] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [11033] = {
    [aux_sym_exceptions_repeat1] = STATE(11033),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16807),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11034] = {
    [anon_sym_LT] = ACTIONS(6831),
    [anon_sym_SLASH] = ACTIONS(6833),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6837),
    [anon_sym_GT_GT] = ACTIONS(6839),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6841),
    [anon_sym_LT_LT] = ACTIONS(6839),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(6837),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_GT] = ACTIONS(6831),
    [anon_sym_PLUS] = ACTIONS(6845),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_TILDE] = ACTIONS(6837),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6837),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(6851),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6837),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6855),
    [anon_sym_DOT_DOT] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6837),
    [anon_sym_LT_EQ_GT] = ACTIONS(6837),
    [anon_sym_LT_EQ] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6857),
    [sym__binary_minus] = ACTIONS(6845),
  },
  [11035] = {
    [anon_sym_SLASH] = ACTIONS(15027),
    [sym__line_break] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_AMP_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT_EQ] = ACTIONS(15029),
    [anon_sym_SLASH_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15027),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15027),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15027),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_PERCENT_EQ] = ACTIONS(15029),
    [anon_sym_LT_LT_EQ] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_else] = ACTIONS(15029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_CARET_EQ] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_EQ] = ACTIONS(15027),
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_then] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15027),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_EQ_GT] = ACTIONS(15029),
    [anon_sym_when] = ACTIONS(15029),
    [anon_sym_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_PLUS_EQ] = ACTIONS(15029),
    [anon_sym_STAR_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym___END__] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15027),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_end] = ACTIONS(15029),
    [anon_sym_ensure] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_elsif] = ACTIONS(15029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15029),
    [ts_builtin_sym_end] = ACTIONS(15029),
    [anon_sym_DASH_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15027),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_AMP_AMP] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15027),
  },
  [11036] = {
    [anon_sym_SLASH] = ACTIONS(16422),
    [sym__line_break] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_else] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_then] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_when] = ACTIONS(16424),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym___END__] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_end] = ACTIONS(16424),
    [anon_sym_ensure] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_elsif] = ACTIONS(16424),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [ts_builtin_sym_end] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11037] = {
    [anon_sym_SLASH] = ACTIONS(15207),
    [sym__line_break] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_AMP_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT_EQ] = ACTIONS(15209),
    [anon_sym_SLASH_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15207),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15207),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15207),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_PERCENT_EQ] = ACTIONS(15209),
    [anon_sym_LT_LT_EQ] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_else] = ACTIONS(15209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_CARET_EQ] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_EQ] = ACTIONS(15207),
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_then] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15207),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_EQ_GT] = ACTIONS(15209),
    [anon_sym_when] = ACTIONS(15209),
    [anon_sym_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_PLUS_EQ] = ACTIONS(15209),
    [anon_sym_STAR_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym___END__] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15207),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_end] = ACTIONS(15209),
    [anon_sym_ensure] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_elsif] = ACTIONS(15209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15209),
    [ts_builtin_sym_end] = ACTIONS(15209),
    [anon_sym_DASH_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15207),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_AMP_AMP] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15207),
  },
  [11038] = {
    [anon_sym_SLASH] = ACTIONS(11543),
    [sym__line_break] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_AMP_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT_EQ] = ACTIONS(11545),
    [anon_sym_SLASH_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11543),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11543),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11543),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_PERCENT_EQ] = ACTIONS(11545),
    [anon_sym_LT_LT_EQ] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [anon_sym_else] = ACTIONS(11545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_CARET_EQ] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_EQ] = ACTIONS(11543),
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_then] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11543),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_when] = ACTIONS(11545),
    [anon_sym_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_PLUS_EQ] = ACTIONS(11545),
    [anon_sym_STAR_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym___END__] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_end] = ACTIONS(11545),
    [anon_sym_ensure] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_elsif] = ACTIONS(11545),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11545),
    [ts_builtin_sym_end] = ACTIONS(11545),
    [anon_sym_DASH_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11543),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11543),
  },
  [11039] = {
    [anon_sym_SLASH] = ACTIONS(13274),
    [sym__line_break] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_AMP_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT_EQ] = ACTIONS(13276),
    [anon_sym_SLASH_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13274),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13274),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13274),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_PERCENT_EQ] = ACTIONS(13276),
    [anon_sym_LT_LT_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [anon_sym_else] = ACTIONS(13276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_CARET_EQ] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_EQ] = ACTIONS(13274),
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_then] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13274),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_when] = ACTIONS(13276),
    [anon_sym_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_PLUS_EQ] = ACTIONS(13276),
    [anon_sym_STAR_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym___END__] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13274),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_end] = ACTIONS(13276),
    [anon_sym_ensure] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_elsif] = ACTIONS(13276),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13276),
    [ts_builtin_sym_end] = ACTIONS(13276),
    [anon_sym_DASH_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [anon_sym_AMP_AMP] = ACTIONS(13274),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13274),
  },
  [11040] = {
    [anon_sym_end] = ACTIONS(16810),
    [sym_comment] = ACTIONS(49),
  },
  [11041] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11899),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16810),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [11042] = {
    [anon_sym_SLASH] = ACTIONS(13956),
    [sym__line_break] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_AMP_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT_EQ] = ACTIONS(13958),
    [anon_sym_SLASH_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13956),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13956),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13956),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_PERCENT_EQ] = ACTIONS(13958),
    [anon_sym_LT_LT_EQ] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [anon_sym_else] = ACTIONS(13958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_CARET_EQ] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_EQ] = ACTIONS(13956),
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_then] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13956),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_when] = ACTIONS(13958),
    [anon_sym_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_PLUS_EQ] = ACTIONS(13958),
    [anon_sym_STAR_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym___END__] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13956),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_end] = ACTIONS(13958),
    [anon_sym_ensure] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_elsif] = ACTIONS(13958),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13958),
    [ts_builtin_sym_end] = ACTIONS(13958),
    [anon_sym_DASH_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13956),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [anon_sym_AMP_AMP] = ACTIONS(13956),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13956),
  },
  [11043] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16812),
  },
  [11044] = {
    [anon_sym_SLASH] = ACTIONS(13962),
    [sym__line_break] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_AMP_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT_EQ] = ACTIONS(13964),
    [anon_sym_SLASH_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13962),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13962),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13962),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_PERCENT_EQ] = ACTIONS(13964),
    [anon_sym_LT_LT_EQ] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [anon_sym_else] = ACTIONS(13964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_CARET_EQ] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_EQ] = ACTIONS(13962),
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_then] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13962),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_when] = ACTIONS(13964),
    [anon_sym_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_PLUS_EQ] = ACTIONS(13964),
    [anon_sym_STAR_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym___END__] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13962),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_end] = ACTIONS(13964),
    [anon_sym_ensure] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_elsif] = ACTIONS(13964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13964),
    [ts_builtin_sym_end] = ACTIONS(13964),
    [anon_sym_DASH_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13962),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [anon_sym_AMP_AMP] = ACTIONS(13962),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13962),
  },
  [11045] = {
    [anon_sym_SLASH] = ACTIONS(11866),
    [sym__line_break] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_AMP_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT_EQ] = ACTIONS(11868),
    [anon_sym_SLASH_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11866),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11866),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11866),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_PERCENT_EQ] = ACTIONS(11868),
    [anon_sym_LT_LT_EQ] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [anon_sym_else] = ACTIONS(11868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_CARET_EQ] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_then] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_when] = ACTIONS(11868),
    [anon_sym_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_PLUS_EQ] = ACTIONS(11868),
    [anon_sym_STAR_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym___END__] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11866),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_end] = ACTIONS(11868),
    [anon_sym_ensure] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_elsif] = ACTIONS(11868),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11868),
    [ts_builtin_sym_end] = ACTIONS(11868),
    [anon_sym_DASH_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11866),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [anon_sym_AMP_AMP] = ACTIONS(11866),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11866),
  },
  [11046] = {
    [anon_sym_SLASH] = ACTIONS(13462),
    [sym__line_break] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_AMP_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT_EQ] = ACTIONS(13464),
    [anon_sym_SLASH_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13462),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13462),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_PERCENT_EQ] = ACTIONS(13464),
    [anon_sym_LT_LT_EQ] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [anon_sym_else] = ACTIONS(13464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_CARET_EQ] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_EQ] = ACTIONS(13462),
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_then] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13462),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_when] = ACTIONS(13464),
    [anon_sym_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_PLUS_EQ] = ACTIONS(13464),
    [anon_sym_STAR_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym___END__] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13462),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_end] = ACTIONS(13464),
    [anon_sym_ensure] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_elsif] = ACTIONS(13464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13464),
    [ts_builtin_sym_end] = ACTIONS(13464),
    [anon_sym_DASH_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13462),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [anon_sym_AMP_AMP] = ACTIONS(13462),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13462),
  },
  [11047] = {
    [anon_sym_SLASH] = ACTIONS(13466),
    [sym__line_break] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_AMP_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT_EQ] = ACTIONS(13468),
    [anon_sym_SLASH_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13466),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13466),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13466),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_PERCENT_EQ] = ACTIONS(13468),
    [anon_sym_LT_LT_EQ] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [anon_sym_else] = ACTIONS(13468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_CARET_EQ] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_EQ] = ACTIONS(13466),
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_then] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_when] = ACTIONS(13468),
    [anon_sym_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_PLUS_EQ] = ACTIONS(13468),
    [anon_sym_STAR_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym___END__] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13466),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_end] = ACTIONS(13468),
    [anon_sym_ensure] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_elsif] = ACTIONS(13468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13468),
    [ts_builtin_sym_end] = ACTIONS(13468),
    [anon_sym_DASH_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13466),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [anon_sym_AMP_AMP] = ACTIONS(13466),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13466),
  },
  [11048] = {
    [anon_sym_SLASH] = ACTIONS(13737),
    [sym__line_break] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_AMP_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT_EQ] = ACTIONS(13739),
    [anon_sym_SLASH_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13737),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13737),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13737),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_PERCENT_EQ] = ACTIONS(13739),
    [anon_sym_LT_LT_EQ] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [anon_sym_else] = ACTIONS(13739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_CARET_EQ] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_EQ] = ACTIONS(13737),
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_then] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13737),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_when] = ACTIONS(13739),
    [anon_sym_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_PLUS_EQ] = ACTIONS(13739),
    [anon_sym_STAR_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym___END__] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13737),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_end] = ACTIONS(13739),
    [anon_sym_ensure] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_elsif] = ACTIONS(13739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13739),
    [ts_builtin_sym_end] = ACTIONS(13739),
    [anon_sym_DASH_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13737),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [anon_sym_AMP_AMP] = ACTIONS(13737),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13737),
  },
  [11049] = {
    [anon_sym_end] = ACTIONS(16814),
    [sym_comment] = ACTIONS(49),
  },
  [11050] = {
    [anon_sym_SLASH] = ACTIONS(11877),
    [sym__line_break] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_AMP_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT_EQ] = ACTIONS(11879),
    [anon_sym_SLASH_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11877),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11877),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11877),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_PERCENT_EQ] = ACTIONS(11879),
    [anon_sym_LT_LT_EQ] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [anon_sym_else] = ACTIONS(11879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_CARET_EQ] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_EQ] = ACTIONS(11877),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_then] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11877),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_when] = ACTIONS(11879),
    [anon_sym_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_PLUS_EQ] = ACTIONS(11879),
    [anon_sym_STAR_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym___END__] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_end] = ACTIONS(11879),
    [anon_sym_ensure] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_elsif] = ACTIONS(11879),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11879),
    [ts_builtin_sym_end] = ACTIONS(11879),
    [anon_sym_DASH_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11877),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [anon_sym_AMP_AMP] = ACTIONS(11877),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11877),
  },
  [11051] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16816),
  },
  [11052] = {
    [anon_sym_SLASH] = ACTIONS(12164),
    [sym__line_break] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12164),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12164),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12164),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(12164),
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12164),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12164),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12164),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [anon_sym_AMP_AMP] = ACTIONS(12164),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12164),
  },
  [11053] = {
    [anon_sym_SLASH] = ACTIONS(12630),
    [sym__line_break] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_AMP_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT_EQ] = ACTIONS(12632),
    [anon_sym_SLASH_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12630),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12630),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12630),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_PERCENT_EQ] = ACTIONS(12632),
    [anon_sym_LT_LT_EQ] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [anon_sym_else] = ACTIONS(12632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_CARET_EQ] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_then] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12630),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_when] = ACTIONS(12632),
    [anon_sym_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_PLUS_EQ] = ACTIONS(12632),
    [anon_sym_STAR_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym___END__] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12630),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_end] = ACTIONS(12632),
    [anon_sym_ensure] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_elsif] = ACTIONS(12632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12632),
    [ts_builtin_sym_end] = ACTIONS(12632),
    [anon_sym_DASH_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12630),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [anon_sym_AMP_AMP] = ACTIONS(12630),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12630),
  },
  [11054] = {
    [anon_sym_SLASH] = ACTIONS(12795),
    [sym__line_break] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_AMP_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT_EQ] = ACTIONS(12797),
    [anon_sym_SLASH_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12795),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12795),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12795),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_PERCENT_EQ] = ACTIONS(12797),
    [anon_sym_LT_LT_EQ] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [anon_sym_else] = ACTIONS(12797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_CARET_EQ] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_EQ] = ACTIONS(12795),
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_then] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12795),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_when] = ACTIONS(12797),
    [anon_sym_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_PLUS_EQ] = ACTIONS(12797),
    [anon_sym_STAR_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym___END__] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12795),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_end] = ACTIONS(12797),
    [anon_sym_ensure] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_elsif] = ACTIONS(12797),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12797),
    [ts_builtin_sym_end] = ACTIONS(12797),
    [anon_sym_DASH_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12795),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [anon_sym_AMP_AMP] = ACTIONS(12795),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12795),
  },
  [11055] = {
    [anon_sym_end] = ACTIONS(16818),
    [sym_comment] = ACTIONS(49),
  },
  [11056] = {
    [sym__method_name] = STATE(4115),
    [sym_setter] = STATE(4115),
    [sym_symbol] = STATE(4115),
    [sym_operator] = STATE(4115),
    [sym__method_rest] = STATE(11904),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(14087),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(14087),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(14087),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(14087),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [11057] = {
    [anon_sym_SLASH] = ACTIONS(13952),
    [sym__line_break] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_AMP_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT_EQ] = ACTIONS(13954),
    [anon_sym_SLASH_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13952),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13952),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13952),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_PERCENT_EQ] = ACTIONS(13954),
    [anon_sym_LT_LT_EQ] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [anon_sym_else] = ACTIONS(13954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_CARET_EQ] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_EQ] = ACTIONS(13952),
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_then] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13952),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_when] = ACTIONS(13954),
    [anon_sym_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_PLUS_EQ] = ACTIONS(13954),
    [anon_sym_STAR_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym___END__] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13952),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_end] = ACTIONS(13954),
    [anon_sym_ensure] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_elsif] = ACTIONS(13954),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13954),
    [ts_builtin_sym_end] = ACTIONS(13954),
    [anon_sym_DASH_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13952),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [anon_sym_AMP_AMP] = ACTIONS(13952),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13952),
  },
  [11058] = {
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11059] = {
    [aux_sym_exceptions_repeat1] = STATE(11059),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16820),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym___END__] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [ts_builtin_sym_end] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11060] = {
    [anon_sym_SLASH] = ACTIONS(6919),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6921),
    [anon_sym_EQ_TILDE] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6923),
    [sym__binary_star] = ACTIONS(6925),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(6927),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_PERCENT] = ACTIONS(6919),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(6921),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(6931),
    [anon_sym_PIPE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(6935),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(6931),
    [anon_sym_QMARK] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(6923),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6939),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(6931),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(6941),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym___END__] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(6941),
    [anon_sym_GT_EQ] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [ts_builtin_sym_end] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(6921),
    [anon_sym_STAR_STAR] = ACTIONS(6919),
    [anon_sym_LT_EQ_GT] = ACTIONS(6921),
    [anon_sym_AMP_AMP] = ACTIONS(6941),
    [sym__binary_minus] = ACTIONS(6945),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(6933),
  },
  [11061] = {
    [anon_sym_SLASH] = ACTIONS(15289),
    [sym__line_break] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_AMP_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT_EQ] = ACTIONS(15291),
    [anon_sym_SLASH_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15289),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15289),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15289),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_PERCENT_EQ] = ACTIONS(15291),
    [anon_sym_LT_LT_EQ] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_else] = ACTIONS(15291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_CARET_EQ] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_EQ] = ACTIONS(15289),
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_then] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15289),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_EQ_GT] = ACTIONS(15291),
    [anon_sym_when] = ACTIONS(15291),
    [anon_sym_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_PLUS_EQ] = ACTIONS(15291),
    [anon_sym_STAR_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym___END__] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15289),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_end] = ACTIONS(15291),
    [anon_sym_ensure] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_elsif] = ACTIONS(15291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15291),
    [ts_builtin_sym_end] = ACTIONS(15291),
    [anon_sym_DASH_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15289),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_AMP_AMP] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15289),
  },
  [11062] = {
    [anon_sym_end] = ACTIONS(16823),
    [sym_comment] = ACTIONS(49),
  },
  [11063] = {
    [anon_sym_SLASH] = ACTIONS(15674),
    [sym__line_break] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_AMP_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT_EQ] = ACTIONS(15676),
    [anon_sym_SLASH_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15674),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15674),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15674),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_PERCENT_EQ] = ACTIONS(15676),
    [anon_sym_LT_LT_EQ] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_else] = ACTIONS(15676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_CARET_EQ] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_EQ] = ACTIONS(15674),
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_then] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15674),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_EQ_GT] = ACTIONS(15676),
    [anon_sym_when] = ACTIONS(15676),
    [anon_sym_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_PLUS_EQ] = ACTIONS(15676),
    [anon_sym_STAR_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym___END__] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15674),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_end] = ACTIONS(15676),
    [anon_sym_ensure] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_elsif] = ACTIONS(15676),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15676),
    [ts_builtin_sym_end] = ACTIONS(15676),
    [anon_sym_DASH_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15674),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_AMP_AMP] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15674),
  },
  [11064] = {
    [anon_sym_SLASH] = ACTIONS(15829),
    [sym__line_break] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_AMP_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT_EQ] = ACTIONS(15831),
    [anon_sym_SLASH_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15829),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15829),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15829),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_PERCENT_EQ] = ACTIONS(15831),
    [anon_sym_LT_LT_EQ] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_else] = ACTIONS(15831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_CARET_EQ] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_EQ] = ACTIONS(15829),
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_then] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15829),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_EQ_GT] = ACTIONS(15831),
    [anon_sym_when] = ACTIONS(15831),
    [anon_sym_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_PLUS_EQ] = ACTIONS(15831),
    [anon_sym_STAR_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym___END__] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15829),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_end] = ACTIONS(15831),
    [anon_sym_ensure] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_elsif] = ACTIONS(15831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15831),
    [ts_builtin_sym_end] = ACTIONS(15831),
    [anon_sym_DASH_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15829),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_AMP_AMP] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15829),
  },
  [11065] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_CARET] = ACTIONS(4768),
  },
  [11066] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_COLON2] = ACTIONS(9628),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [11067] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [11068] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(4200),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7044),
    [sym_rational] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym_float] = ACTIONS(7005),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(7009),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(7009),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7011),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(11162),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(7017),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(11164),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(11162),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_class_variable] = ACTIONS(7017),
    [sym__block_ampersand] = ACTIONS(11166),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(7029),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [sym_retry] = ACTIONS(7005),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15892),
    [sym_redo] = ACTIONS(7005),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [11069] = {
    [sym_heredoc_body] = STATE(11069),
    [aux_sym_call_repeat1] = STATE(11069),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_COLON2] = ACTIONS(9772),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [11070] = {
    [sym_heredoc_body] = STATE(11069),
    [aux_sym_call_repeat1] = STATE(11069),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_COLON2] = ACTIONS(9779),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [11071] = {
    [aux_sym_argument_list_repeat1] = STATE(11071),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16825),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [11072] = {
    [sym_heredoc_body] = STATE(11906),
    [aux_sym_call_repeat1] = STATE(11906),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11073] = {
    [sym_heredoc_body] = STATE(11907),
    [aux_sym_call_repeat1] = STATE(11907),
    [aux_sym_argument_list_repeat1] = STATE(9541),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11198),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_COLON2] = ACTIONS(5590),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11074] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(9786),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11075] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11076] = {
    [aux_sym_exceptions_repeat1] = STATE(11909),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [11077] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11078] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11079] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11080] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11081] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16828),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11082] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11083] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(9792),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [11084] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11085] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11086] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11087] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_COLON2] = ACTIONS(1327),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [11088] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(11912),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(16830),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [11089] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_COLON2] = ACTIONS(6719),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [11090] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_COLON2] = ACTIONS(6727),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [11091] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(11090),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(11913),
    [sym_operator] = STATE(11913),
    [anon_sym_LT] = ACTIONS(15894),
    [anon_sym_SLASH] = ACTIONS(15896),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(15896),
    [anon_sym_PLUS_AT] = ACTIONS(15896),
    [anon_sym_LPAREN2] = ACTIONS(15898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15896),
    [anon_sym_GT_GT] = ACTIONS(15896),
    [anon_sym_EQ_TILDE] = ACTIONS(15896),
    [anon_sym_LT_LT] = ACTIONS(15896),
    [anon_sym_TILDE] = ACTIONS(15896),
    [anon_sym_PLUS] = ACTIONS(15894),
    [anon_sym_AMP] = ACTIONS(15896),
    [anon_sym_GT] = ACTIONS(15894),
    [anon_sym_PERCENT] = ACTIONS(15896),
    [anon_sym_DASH_AT] = ACTIONS(15896),
    [anon_sym_EQ_EQ] = ACTIONS(15894),
    [anon_sym_STAR] = ACTIONS(15894),
    [anon_sym_BANG_TILDE] = ACTIONS(15896),
    [sym_constant] = ACTIONS(16832),
    [anon_sym_DASH] = ACTIONS(15894),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(15896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(15894),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(15896),
    [anon_sym_STAR_STAR] = ACTIONS(15896),
    [anon_sym_PIPE] = ACTIONS(15896),
    [anon_sym_DOT_DOT] = ACTIONS(15896),
    [anon_sym_LT_EQ_GT] = ACTIONS(15896),
    [anon_sym_LT_EQ] = ACTIONS(15894),
    [anon_sym_BANG] = ACTIONS(15894),
    [sym_identifier] = ACTIONS(16832),
    [anon_sym_CARET] = ACTIONS(15896),
  },
  [11092] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_COLON2] = ACTIONS(6739),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [11093] = {
    [aux_sym_chained_string_repeat1] = STATE(11093),
    [sym_string] = STATE(11093),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [11094] = {
    [sym_assignment] = STATE(9543),
    [sym_unary] = STATE(9543),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(9543),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(9543),
    [sym_conditional] = STATE(9543),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_return] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_true] = STATE(4198),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(9543),
    [sym_binary] = STATE(9543),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(11168),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [sym_global_variable] = ACTIONS(7017),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(7009),
    [sym_character] = ACTIONS(7011),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [11095] = {
    [aux_sym_exceptions_repeat1] = STATE(11914),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16834),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_COLON2] = ACTIONS(10971),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11096] = {
    [sym_assignment] = STATE(11915),
    [sym_unary] = STATE(11915),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4198),
    [sym_singleton_class] = STATE(4200),
    [sym_module] = STATE(4200),
    [sym_chained_string] = STATE(4200),
    [sym_until] = STATE(4200),
    [sym_regex] = STATE(4200),
    [sym_for] = STATE(4200),
    [sym_symbol] = STATE(4200),
    [sym_if] = STATE(4200),
    [sym_begin] = STATE(4200),
    [sym__arg] = STATE(11915),
    [sym__primary] = STATE(4200),
    [sym_method_call] = STATE(4198),
    [sym_operator_assignment] = STATE(11915),
    [sym_conditional] = STATE(11915),
    [sym_method] = STATE(4200),
    [sym_singleton_method] = STATE(4200),
    [sym__variable] = STATE(4201),
    [sym_left_assignment_list] = STATE(4202),
    [sym_rational] = STATE(4200),
    [sym_true] = STATE(4198),
    [sym_return] = STATE(4200),
    [sym_subshell] = STATE(4200),
    [sym_yield] = STATE(4200),
    [sym_string] = STATE(7032),
    [sym_unless] = STATE(4200),
    [sym_lambda] = STATE(4200),
    [sym_parenthesized_statements] = STATE(4200),
    [sym_element_reference] = STATE(4198),
    [sym_range] = STATE(11915),
    [sym_binary] = STATE(11915),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4200),
    [sym_break] = STATE(4200),
    [sym_next] = STATE(4200),
    [sym_string_array] = STATE(4200),
    [sym_while] = STATE(4200),
    [sym_case] = STATE(4200),
    [sym_symbol_array] = STATE(4200),
    [sym_array] = STATE(4200),
    [sym_hash] = STATE(4200),
    [sym_false] = STATE(4198),
    [sym_nil] = STATE(4198),
    [sym_scope_resolution] = STATE(4201),
    [sym_call] = STATE(4201),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(7005),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7025),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(7013),
    [anon_sym_not] = ACTIONS(7029),
    [sym_self] = ACTIONS(7009),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(7033),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7011),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(7011),
    [anon_sym_PLUS] = ACTIONS(11150),
    [anon_sym_TILDE] = ACTIONS(7013),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7017),
    [sym_character] = ACTIONS(7011),
    [sym_super] = ACTIONS(7009),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(7035),
    [anon_sym_next] = ACTIONS(7037),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(7005),
    [sym_constant] = ACTIONS(7009),
    [anon_sym_defined_QMARK] = ACTIONS(7019),
    [sym_instance_variable] = ACTIONS(7017),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(11152),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(7009),
    [sym_redo] = ACTIONS(7005),
    [sym_class_variable] = ACTIONS(7017),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(7007),
  },
  [11097] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11098] = {
    [anon_sym_RPAREN] = ACTIONS(16836),
    [sym_comment] = ACTIONS(49),
  },
  [11099] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11100] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_COLON2] = ACTIONS(9628),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [11101] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [11102] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(4235),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7085),
    [sym_rational] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym_float] = ACTIONS(7083),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(7087),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(7087),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(7089),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(7095),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [sym__identifier_hash_key] = ACTIONS(11238),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(11236),
    [anon_sym_yield] = ACTIONS(7101),
    [sym_class_variable] = ACTIONS(7095),
    [sym__block_ampersand] = ACTIONS(11240),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(7105),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [sym_retry] = ACTIONS(7083),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(15913),
    [sym_redo] = ACTIONS(7083),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [11103] = {
    [sym_heredoc_body] = STATE(11103),
    [aux_sym_call_repeat1] = STATE(11103),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_COLON2] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [11104] = {
    [sym_heredoc_body] = STATE(11103),
    [aux_sym_call_repeat1] = STATE(11103),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_COLON2] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [11105] = {
    [aux_sym_argument_list_repeat1] = STATE(11105),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16838),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_COLON2] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [11106] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [11107] = {
    [aux_sym_exceptions_repeat1] = STATE(9586),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [11108] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [11109] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [11110] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [11111] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11112] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16841),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11113] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11114] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [11115] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11116] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11117] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11118] = {
    [aux_sym_chained_string_repeat1] = STATE(11118),
    [sym_string] = STATE(11118),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [11119] = {
    [aux_sym_exceptions_repeat1] = STATE(11119),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16843),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11120] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_or] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_PIPE] = ACTIONS(7073),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11121] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11122] = {
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [anon_sym_or] = ACTIONS(4768),
    [anon_sym_EQ_TILDE] = ACTIONS(4768),
    [sym__binary_star] = ACTIONS(4768),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_COLON_COLON2] = ACTIONS(4768),
    [anon_sym_EQ_GT] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_COLON2] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_BANG_TILDE] = ACTIONS(4768),
    [sym__heredoc_body_start] = ACTIONS(4768),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [sym__string_start] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_AMP_DOT] = ACTIONS(4768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_STAR_STAR] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [sym__binary_minus] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4766),
  },
  [11123] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_COLON2] = ACTIONS(9786),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11124] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11125] = {
    [aux_sym_exceptions_repeat1] = STATE(11919),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_COLON2] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11126] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11127] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11128] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11129] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11130] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16846),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11131] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11132] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_COLON2] = ACTIONS(9792),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [11133] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11134] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11135] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_COLON2] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11136] = {
    [aux_sym_chained_string_repeat1] = STATE(11136),
    [sym_string] = STATE(11136),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_COLON2] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11137] = {
    [sym_assignment] = STATE(9609),
    [sym_unary] = STATE(9609),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(9609),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(9609),
    [sym_conditional] = STATE(9609),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_return] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_true] = STATE(4239),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(9609),
    [sym_binary] = STATE(9609),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(11242),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [sym_global_variable] = ACTIONS(7095),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(7087),
    [sym_character] = ACTIONS(7089),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [11138] = {
    [aux_sym_exceptions_repeat1] = STATE(11921),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16848),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_COLON2] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11139] = {
    [sym_assignment] = STATE(11922),
    [sym_unary] = STATE(11922),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4239),
    [sym_singleton_class] = STATE(4235),
    [sym_module] = STATE(4235),
    [sym_chained_string] = STATE(4235),
    [sym_until] = STATE(4235),
    [sym_regex] = STATE(4235),
    [sym_for] = STATE(4235),
    [sym_symbol] = STATE(4235),
    [sym_if] = STATE(4235),
    [sym_begin] = STATE(4235),
    [sym__arg] = STATE(11922),
    [sym__primary] = STATE(4235),
    [sym_method_call] = STATE(4239),
    [sym_operator_assignment] = STATE(11922),
    [sym_conditional] = STATE(11922),
    [sym_method] = STATE(4235),
    [sym_singleton_method] = STATE(4235),
    [sym__variable] = STATE(4237),
    [sym_left_assignment_list] = STATE(4236),
    [sym_rational] = STATE(4235),
    [sym_true] = STATE(4239),
    [sym_return] = STATE(4235),
    [sym_subshell] = STATE(4235),
    [sym_yield] = STATE(4235),
    [sym_string] = STATE(7121),
    [sym_unless] = STATE(4235),
    [sym_lambda] = STATE(4235),
    [sym_parenthesized_statements] = STATE(4235),
    [sym_element_reference] = STATE(4239),
    [sym_range] = STATE(11922),
    [sym_binary] = STATE(11922),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4235),
    [sym_break] = STATE(4235),
    [sym_next] = STATE(4235),
    [sym_string_array] = STATE(4235),
    [sym_while] = STATE(4235),
    [sym_case] = STATE(4235),
    [sym_symbol_array] = STATE(4235),
    [sym_array] = STATE(4235),
    [sym_hash] = STATE(4235),
    [sym_false] = STATE(4239),
    [sym_nil] = STATE(4239),
    [sym_scope_resolution] = STATE(4237),
    [sym_call] = STATE(4237),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(7083),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(7101),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(7091),
    [anon_sym_not] = ACTIONS(7105),
    [sym_self] = ACTIONS(7087),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(7109),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(7089),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(7089),
    [anon_sym_PLUS] = ACTIONS(11278),
    [anon_sym_TILDE] = ACTIONS(7091),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(7095),
    [sym_character] = ACTIONS(7089),
    [sym_super] = ACTIONS(7087),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(7111),
    [anon_sym_next] = ACTIONS(7113),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(7083),
    [sym_constant] = ACTIONS(7087),
    [anon_sym_defined_QMARK] = ACTIONS(7097),
    [sym_instance_variable] = ACTIONS(7095),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(11280),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(11154),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7087),
    [sym_redo] = ACTIONS(7083),
    [sym_class_variable] = ACTIONS(7095),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(7085),
  },
  [11140] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [11141] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [11142] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(7169),
    [sym_unary] = STATE(7169),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(7169),
    [sym__primary] = STATE(4265),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(7169),
    [sym_conditional] = STATE(7169),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7170),
    [sym_rational] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(7169),
    [sym_binary] = STATE(7169),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym_float] = ACTIONS(7162),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7166),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7166),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7168),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11362),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7174),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(11364),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11362),
    [anon_sym_yield] = ACTIONS(7182),
    [sym_class_variable] = ACTIONS(7174),
    [sym__block_ampersand] = ACTIONS(11366),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7186),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [sym_retry] = ACTIONS(7162),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15930),
    [sym_redo] = ACTIONS(7162),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [11143] = {
    [sym_heredoc_body] = STATE(11143),
    [aux_sym_call_repeat1] = STATE(11143),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11144] = {
    [sym_heredoc_body] = STATE(11143),
    [aux_sym_call_repeat1] = STATE(11143),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11145] = {
    [aux_sym_argument_list_repeat1] = STATE(11145),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16850),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [11146] = {
    [sym_heredoc_body] = STATE(11923),
    [aux_sym_call_repeat1] = STATE(11923),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11147] = {
    [sym_heredoc_body] = STATE(11924),
    [aux_sym_call_repeat1] = STATE(11924),
    [aux_sym_argument_list_repeat1] = STATE(9657),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11388),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11148] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11149] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11150] = {
    [aux_sym_exceptions_repeat1] = STATE(11926),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11151] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11152] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11153] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11154] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11155] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16853),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11156] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11157] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11158] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11159] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11160] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [11161] = {
    [aux_sym_chained_string_repeat1] = STATE(11161),
    [sym_string] = STATE(11161),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [11162] = {
    [sym_assignment] = STATE(9659),
    [sym_unary] = STATE(9659),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(9659),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(9659),
    [sym_conditional] = STATE(9659),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_return] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_true] = STATE(4263),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(9659),
    [sym_binary] = STATE(9659),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11368),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [sym_global_variable] = ACTIONS(7174),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7166),
    [sym_character] = ACTIONS(7168),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [11163] = {
    [aux_sym_exceptions_repeat1] = STATE(11928),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16855),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11164] = {
    [sym_assignment] = STATE(11929),
    [sym_unary] = STATE(11929),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4263),
    [sym_singleton_class] = STATE(4265),
    [sym_module] = STATE(4265),
    [sym_chained_string] = STATE(4265),
    [sym_until] = STATE(4265),
    [sym_regex] = STATE(4265),
    [sym_for] = STATE(4265),
    [sym_symbol] = STATE(4265),
    [sym_if] = STATE(4265),
    [sym_begin] = STATE(4265),
    [sym__arg] = STATE(11929),
    [sym__primary] = STATE(4265),
    [sym_method_call] = STATE(4263),
    [sym_operator_assignment] = STATE(11929),
    [sym_conditional] = STATE(11929),
    [sym_method] = STATE(4265),
    [sym_singleton_method] = STATE(4265),
    [sym__variable] = STATE(4266),
    [sym_left_assignment_list] = STATE(4267),
    [sym_rational] = STATE(4265),
    [sym_true] = STATE(4263),
    [sym_return] = STATE(4265),
    [sym_subshell] = STATE(4265),
    [sym_yield] = STATE(4265),
    [sym_string] = STATE(7158),
    [sym_unless] = STATE(4265),
    [sym_lambda] = STATE(4265),
    [sym_parenthesized_statements] = STATE(4265),
    [sym_element_reference] = STATE(4263),
    [sym_range] = STATE(11929),
    [sym_binary] = STATE(11929),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4265),
    [sym_break] = STATE(4265),
    [sym_next] = STATE(4265),
    [sym_string_array] = STATE(4265),
    [sym_while] = STATE(4265),
    [sym_case] = STATE(4265),
    [sym_symbol_array] = STATE(4265),
    [sym_array] = STATE(4265),
    [sym_hash] = STATE(4265),
    [sym_false] = STATE(4263),
    [sym_nil] = STATE(4263),
    [sym_scope_resolution] = STATE(4266),
    [sym_call] = STATE(4266),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7162),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7182),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7170),
    [anon_sym_not] = ACTIONS(7186),
    [sym_self] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7190),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7168),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7168),
    [anon_sym_PLUS] = ACTIONS(11352),
    [anon_sym_TILDE] = ACTIONS(7170),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7174),
    [sym_character] = ACTIONS(7168),
    [sym_super] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7192),
    [anon_sym_next] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7162),
    [sym_constant] = ACTIONS(7166),
    [anon_sym_defined_QMARK] = ACTIONS(7176),
    [sym_instance_variable] = ACTIONS(7174),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7166),
    [sym_redo] = ACTIONS(7162),
    [sym_class_variable] = ACTIONS(7174),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7164),
  },
  [11165] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11166] = {
    [anon_sym_RPAREN] = ACTIONS(16857),
    [sym_comment] = ACTIONS(49),
  },
  [11167] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11168] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [11169] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [11170] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(4290),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7208),
    [sym_rational] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym_float] = ACTIONS(7216),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7220),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7220),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(11426),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7228),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [sym__identifier_hash_key] = ACTIONS(11428),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11426),
    [anon_sym_yield] = ACTIONS(7234),
    [sym_class_variable] = ACTIONS(7228),
    [sym__block_ampersand] = ACTIONS(11430),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7238),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [sym_retry] = ACTIONS(7216),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15941),
    [sym_redo] = ACTIONS(7216),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [11171] = {
    [sym_heredoc_body] = STATE(11171),
    [aux_sym_call_repeat1] = STATE(11171),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [11172] = {
    [sym_heredoc_body] = STATE(11171),
    [aux_sym_call_repeat1] = STATE(11171),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [11173] = {
    [aux_sym_argument_list_repeat1] = STATE(11173),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16859),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [11174] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11175] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11176] = {
    [aux_sym_exceptions_repeat1] = STATE(9704),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11177] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11178] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11179] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11180] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11181] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16862),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11182] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11183] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11184] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11185] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11186] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [11187] = {
    [aux_sym_exceptions_repeat1] = STATE(11187),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16864),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11188] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11189] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11190] = {
    [aux_sym_exceptions_repeat1] = STATE(11933),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11191] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11192] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11193] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11194] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11195] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16867),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11196] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11197] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [11198] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11199] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11200] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11201] = {
    [aux_sym_chained_string_repeat1] = STATE(11201),
    [sym_string] = STATE(11201),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11202] = {
    [sym_assignment] = STATE(9721),
    [sym_unary] = STATE(9721),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(9721),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(9721),
    [sym_conditional] = STATE(9721),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_return] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_true] = STATE(4294),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(9721),
    [sym_binary] = STATE(9721),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11432),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [sym_global_variable] = ACTIONS(7228),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7220),
    [sym_character] = ACTIONS(7222),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [11203] = {
    [aux_sym_exceptions_repeat1] = STATE(11935),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16869),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11204] = {
    [sym_assignment] = STATE(11936),
    [sym_unary] = STATE(11936),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4294),
    [sym_singleton_class] = STATE(4290),
    [sym_module] = STATE(4290),
    [sym_chained_string] = STATE(4290),
    [sym_until] = STATE(4290),
    [sym_regex] = STATE(4290),
    [sym_for] = STATE(4290),
    [sym_symbol] = STATE(4290),
    [sym_if] = STATE(4290),
    [sym_begin] = STATE(4290),
    [sym__arg] = STATE(11936),
    [sym__primary] = STATE(4290),
    [sym_method_call] = STATE(4294),
    [sym_operator_assignment] = STATE(11936),
    [sym_conditional] = STATE(11936),
    [sym_method] = STATE(4290),
    [sym_singleton_method] = STATE(4290),
    [sym__variable] = STATE(4292),
    [sym_left_assignment_list] = STATE(4291),
    [sym_rational] = STATE(4290),
    [sym_true] = STATE(4294),
    [sym_return] = STATE(4290),
    [sym_subshell] = STATE(4290),
    [sym_yield] = STATE(4290),
    [sym_string] = STATE(7231),
    [sym_unless] = STATE(4290),
    [sym_lambda] = STATE(4290),
    [sym_parenthesized_statements] = STATE(4290),
    [sym_element_reference] = STATE(4294),
    [sym_range] = STATE(11936),
    [sym_binary] = STATE(11936),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4290),
    [sym_break] = STATE(4290),
    [sym_next] = STATE(4290),
    [sym_string_array] = STATE(4290),
    [sym_while] = STATE(4290),
    [sym_case] = STATE(4290),
    [sym_symbol_array] = STATE(4290),
    [sym_array] = STATE(4290),
    [sym_hash] = STATE(4290),
    [sym_false] = STATE(4294),
    [sym_nil] = STATE(4294),
    [sym_scope_resolution] = STATE(4292),
    [sym_call] = STATE(4292),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7216),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7234),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7224),
    [anon_sym_not] = ACTIONS(7238),
    [sym_self] = ACTIONS(7220),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7242),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7222),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(11460),
    [anon_sym_TILDE] = ACTIONS(7224),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7228),
    [sym_character] = ACTIONS(7222),
    [sym_super] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7244),
    [anon_sym_next] = ACTIONS(7246),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7216),
    [sym_constant] = ACTIONS(7220),
    [anon_sym_defined_QMARK] = ACTIONS(7230),
    [sym_instance_variable] = ACTIONS(7228),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11354),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7220),
    [sym_redo] = ACTIONS(7216),
    [sym_class_variable] = ACTIONS(7228),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7218),
  },
  [11205] = {
    [anon_sym_LT] = ACTIONS(7254),
    [anon_sym_SLASH] = ACTIONS(7256),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7262),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7264),
    [anon_sym_LT_LT] = ACTIONS(7262),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(7260),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(7268),
    [anon_sym_AMP] = ACTIONS(7270),
    [anon_sym_GT] = ACTIONS(7254),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [sym__binary_star] = ACTIONS(7256),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(7272),
    [anon_sym_BANG_TILDE] = ACTIONS(7260),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7256),
    [anon_sym_PIPE] = ACTIONS(7278),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_EQ_GT] = ACTIONS(7260),
    [anon_sym_LT_EQ] = ACTIONS(7254),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7280),
    [sym__binary_minus] = ACTIONS(7268),
  },
  [11206] = {
    [aux_sym_exceptions_repeat1] = STATE(11206),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16871),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11207] = {
    [anon_sym_LT] = ACTIONS(7294),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7298),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7300),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7302),
    [anon_sym_LT_LT] = ACTIONS(7300),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7304),
    [anon_sym_EQ_TILDE] = ACTIONS(7304),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_GT] = ACTIONS(7294),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(7296),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(7310),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(7304),
    [anon_sym_PIPE_PIPE] = ACTIONS(7304),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7312),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7304),
    [anon_sym_STAR_STAR] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_DOT_DOT] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7304),
    [anon_sym_LT_EQ_GT] = ACTIONS(7304),
    [anon_sym_LT_EQ] = ACTIONS(7294),
    [sym__binary_minus] = ACTIONS(7306),
    [anon_sym_CARET] = ACTIONS(7318),
  },
  [11208] = {
    [anon_sym_LT] = ACTIONS(7348),
    [anon_sym_SLASH] = ACTIONS(7350),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7358),
    [anon_sym_EQ_TILDE] = ACTIONS(7358),
    [anon_sym_PLUS] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7362),
    [anon_sym_GT] = ACTIONS(7348),
    [anon_sym_PERCENT] = ACTIONS(7350),
    [sym__binary_star] = ACTIONS(7350),
    [anon_sym_EQ_EQ] = ACTIONS(7364),
    [anon_sym_BANG_TILDE] = ACTIONS(7358),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7358),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7366),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7358),
    [anon_sym_STAR_STAR] = ACTIONS(7350),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7358),
    [anon_sym_LT_EQ_GT] = ACTIONS(7358),
    [anon_sym_LT_EQ] = ACTIONS(7348),
    [sym__binary_minus] = ACTIONS(7360),
    [anon_sym_CARET] = ACTIONS(7372),
  },
  [11209] = {
    [aux_sym_exceptions_repeat1] = STATE(11209),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16874),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11210] = {
    [anon_sym_LT] = ACTIONS(7396),
    [anon_sym_SLASH] = ACTIONS(7398),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7400),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7402),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7404),
    [anon_sym_LT_LT] = ACTIONS(7402),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7406),
    [anon_sym_EQ_TILDE] = ACTIONS(7406),
    [anon_sym_PLUS] = ACTIONS(7408),
    [anon_sym_AMP] = ACTIONS(7410),
    [anon_sym_GT] = ACTIONS(7396),
    [anon_sym_PERCENT] = ACTIONS(7398),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(7412),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(7414),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7414),
    [anon_sym_BANG_TILDE] = ACTIONS(7406),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7406),
    [anon_sym_STAR_STAR] = ACTIONS(7398),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_DOT_DOT] = ACTIONS(7420),
    [anon_sym_AMP_AMP] = ACTIONS(7414),
    [anon_sym_LT_EQ_GT] = ACTIONS(7406),
    [anon_sym_LT_EQ] = ACTIONS(7396),
    [sym__binary_minus] = ACTIONS(7422),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(7418),
  },
  [11211] = {
    [sym_heredoc_body] = STATE(11211),
    [aux_sym_call_repeat1] = STATE(11211),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11212] = {
    [sym_heredoc_body] = STATE(11211),
    [aux_sym_call_repeat1] = STATE(11211),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11213] = {
    [sym_assignment] = STATE(9759),
    [sym_unary] = STATE(9759),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9759),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(9759),
    [sym_conditional] = STATE(9759),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_true] = STATE(4440),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(9759),
    [sym_binary] = STATE(9759),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(3526),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [sym_global_variable] = ACTIONS(1071),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1061),
    [sym_character] = ACTIONS(1065),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [11214] = {
    [aux_sym_exceptions_repeat1] = STATE(11937),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16877),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11215] = {
    [sym_assignment] = STATE(11938),
    [sym_unary] = STATE(11938),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4440),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11938),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4440),
    [sym_operator_assignment] = STATE(11938),
    [sym_conditional] = STATE(11938),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4442),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4440),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4440),
    [sym_range] = STATE(11938),
    [sym_binary] = STATE(11938),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4440),
    [sym_nil] = STATE(4440),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7441),
    [anon_sym_not] = ACTIONS(7443),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7447),
    [anon_sym_TILDE] = ACTIONS(7441),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7449),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7453),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [11216] = {
    [aux_sym_exceptions_repeat1] = STATE(11216),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16879),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11217] = {
    [anon_sym_LT] = ACTIONS(7463),
    [anon_sym_SLASH] = ACTIONS(7465),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7467),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7469),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7471),
    [anon_sym_LT_LT] = ACTIONS(7469),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7473),
    [anon_sym_AMP] = ACTIONS(7475),
    [anon_sym_EQ_TILDE] = ACTIONS(7473),
    [anon_sym_GT] = ACTIONS(7463),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(7477),
    [anon_sym_PERCENT] = ACTIONS(7465),
    [sym__binary_star] = ACTIONS(7465),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(7479),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(7473),
    [anon_sym_PIPE_PIPE] = ACTIONS(7473),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7481),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7473),
    [anon_sym_STAR_STAR] = ACTIONS(7465),
    [anon_sym_PIPE] = ACTIONS(7483),
    [anon_sym_DOT_DOT] = ACTIONS(7485),
    [anon_sym_AMP_AMP] = ACTIONS(7473),
    [anon_sym_LT_EQ_GT] = ACTIONS(7473),
    [anon_sym_LT_EQ] = ACTIONS(7463),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7487),
    [sym__binary_minus] = ACTIONS(7477),
  },
  [11218] = {
    [sym_assignment] = STATE(11939),
    [sym_unary] = STATE(11939),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4478),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_chained_string] = STATE(556),
    [sym_until] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_for] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_if] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11939),
    [sym__primary] = STATE(556),
    [sym_method_call] = STATE(4478),
    [sym_operator_assignment] = STATE(11939),
    [sym_conditional] = STATE(11939),
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym__variable] = STATE(558),
    [sym_left_assignment_list] = STATE(4480),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4478),
    [sym_return] = STATE(556),
    [sym_subshell] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_string] = STATE(4443),
    [sym_unless] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4478),
    [sym_range] = STATE(11939),
    [sym_binary] = STATE(11939),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_while] = STATE(556),
    [sym_case] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_false] = STATE(4478),
    [sym_nil] = STATE(4478),
    [sym_scope_resolution] = STATE(558),
    [sym_call] = STATE(558),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1057),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7439),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(7507),
    [anon_sym_not] = ACTIONS(7509),
    [sym_self] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(7445),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(7513),
    [anon_sym_TILDE] = ACTIONS(7507),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1071),
    [sym_character] = ACTIONS(1065),
    [sym_super] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(7515),
    [anon_sym_next] = ACTIONS(7451),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1057),
    [sym_constant] = ACTIONS(1061),
    [anon_sym_defined_QMARK] = ACTIONS(7517),
    [sym_instance_variable] = ACTIONS(1071),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1061),
    [sym_redo] = ACTIONS(1057),
    [sym_class_variable] = ACTIONS(1071),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(7455),
  },
  [11219] = {
    [sym_assignment] = STATE(9790),
    [sym_unary] = STATE(9790),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(9790),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(9790),
    [sym_conditional] = STATE(9790),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_return] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_true] = STATE(4494),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(9790),
    [sym_binary] = STATE(9790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [sym_global_variable] = ACTIONS(7541),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7533),
    [sym_character] = ACTIONS(7537),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [11220] = {
    [aux_sym_exceptions_repeat1] = STATE(11940),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16882),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11221] = {
    [sym_assignment] = STATE(11941),
    [sym_unary] = STATE(11941),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4494),
    [sym_singleton_class] = STATE(4496),
    [sym_module] = STATE(4496),
    [sym_chained_string] = STATE(4496),
    [sym_until] = STATE(4496),
    [sym_regex] = STATE(4496),
    [sym_for] = STATE(4496),
    [sym_symbol] = STATE(4496),
    [sym_if] = STATE(4496),
    [sym_begin] = STATE(4496),
    [sym__arg] = STATE(11941),
    [sym__primary] = STATE(4496),
    [sym_method_call] = STATE(4494),
    [sym_operator_assignment] = STATE(11941),
    [sym_conditional] = STATE(11941),
    [sym_method] = STATE(4496),
    [sym_singleton_method] = STATE(4496),
    [sym__variable] = STATE(4497),
    [sym_left_assignment_list] = STATE(4498),
    [sym_rational] = STATE(4496),
    [sym_true] = STATE(4494),
    [sym_return] = STATE(4496),
    [sym_subshell] = STATE(4496),
    [sym_yield] = STATE(4496),
    [sym_string] = STATE(4499),
    [sym_unless] = STATE(4496),
    [sym_lambda] = STATE(4496),
    [sym_parenthesized_statements] = STATE(4496),
    [sym_element_reference] = STATE(4494),
    [sym_range] = STATE(11941),
    [sym_binary] = STATE(11941),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4496),
    [sym_break] = STATE(4496),
    [sym_next] = STATE(4496),
    [sym_string_array] = STATE(4496),
    [sym_while] = STATE(4496),
    [sym_case] = STATE(4496),
    [sym_symbol_array] = STATE(4496),
    [sym_array] = STATE(4496),
    [sym_hash] = STATE(4496),
    [sym_false] = STATE(4494),
    [sym_nil] = STATE(4494),
    [sym_scope_resolution] = STATE(4497),
    [sym_call] = STATE(4497),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(7525),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(7527),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_not] = ACTIONS(7531),
    [sym_self] = ACTIONS(7533),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(7535),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7537),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(7537),
    [anon_sym_PLUS] = ACTIONS(7539),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7541),
    [sym_character] = ACTIONS(7537),
    [sym_super] = ACTIONS(7533),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(7543),
    [anon_sym_next] = ACTIONS(7545),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(7525),
    [sym_constant] = ACTIONS(7533),
    [anon_sym_defined_QMARK] = ACTIONS(7547),
    [sym_instance_variable] = ACTIONS(7541),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1075),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(7533),
    [sym_redo] = ACTIONS(7525),
    [sym_class_variable] = ACTIONS(7541),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(7549),
  },
  [11222] = {
    [aux_sym_exceptions_repeat1] = STATE(11222),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16884),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11223] = {
    [anon_sym_SLASH] = ACTIONS(7559),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7561),
    [anon_sym_EQ_TILDE] = ACTIONS(7561),
    [anon_sym_LT_LT] = ACTIONS(7563),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(7565),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_AMP] = ACTIONS(7569),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(7561),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(7571),
    [anon_sym_PIPE] = ACTIONS(7573),
    [anon_sym_DOT_DOT] = ACTIONS(7575),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(7571),
    [anon_sym_QMARK] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7563),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7579),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(7571),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(7581),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7581),
    [anon_sym_GT_EQ] = ACTIONS(7583),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7561),
    [anon_sym_STAR_STAR] = ACTIONS(7559),
    [anon_sym_LT_EQ_GT] = ACTIONS(7561),
    [anon_sym_AMP_AMP] = ACTIONS(7581),
    [sym__binary_minus] = ACTIONS(7585),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7573),
  },
  [11224] = {
    [aux_sym_exceptions_repeat1] = STATE(11224),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16887),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11225] = {
    [anon_sym_LT] = ACTIONS(7606),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(7608),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7614),
    [anon_sym_LT_LT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7616),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(7616),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_GT] = ACTIONS(7606),
    [anon_sym_PLUS] = ACTIONS(7620),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(7616),
    [anon_sym_PIPE_PIPE] = ACTIONS(7616),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7616),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7616),
    [anon_sym_LT_EQ_GT] = ACTIONS(7616),
    [anon_sym_LT_EQ] = ACTIONS(7606),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7630),
    [sym__binary_minus] = ACTIONS(7620),
  },
  [11226] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [11227] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [11228] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(7484),
    [sym_unary] = STATE(7484),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(7484),
    [sym__primary] = STATE(4609),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(7484),
    [sym_conditional] = STATE(7484),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7485),
    [sym_rational] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(7484),
    [sym_binary] = STATE(7484),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym_float] = ACTIONS(7658),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(7662),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(7662),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(11689),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(7670),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(11691),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(11689),
    [anon_sym_yield] = ACTIONS(7678),
    [sym_class_variable] = ACTIONS(7670),
    [sym__block_ampersand] = ACTIONS(11693),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(7682),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [sym_retry] = ACTIONS(7658),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15978),
    [sym_redo] = ACTIONS(7658),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [11229] = {
    [sym_heredoc_body] = STATE(11229),
    [aux_sym_call_repeat1] = STATE(11229),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11230] = {
    [sym_heredoc_body] = STATE(11229),
    [aux_sym_call_repeat1] = STATE(11229),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11231] = {
    [aux_sym_argument_list_repeat1] = STATE(11231),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16890),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [11232] = {
    [sym_heredoc_body] = STATE(11942),
    [aux_sym_call_repeat1] = STATE(11942),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11233] = {
    [sym_heredoc_body] = STATE(11943),
    [aux_sym_call_repeat1] = STATE(11943),
    [aux_sym_argument_list_repeat1] = STATE(9845),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(11715),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11234] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11235] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11236] = {
    [aux_sym_exceptions_repeat1] = STATE(11945),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11237] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11238] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11239] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11240] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11241] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16893),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11242] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11243] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11244] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11245] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11246] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [11247] = {
    [aux_sym_chained_string_repeat1] = STATE(11247),
    [sym_string] = STATE(11247),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [11248] = {
    [sym_assignment] = STATE(9847),
    [sym_unary] = STATE(9847),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(9847),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(9847),
    [sym_conditional] = STATE(9847),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_return] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_true] = STATE(4607),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(9847),
    [sym_binary] = STATE(9847),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(11695),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [sym_global_variable] = ACTIONS(7670),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7662),
    [sym_character] = ACTIONS(7664),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [11249] = {
    [aux_sym_exceptions_repeat1] = STATE(11947),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16895),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11250] = {
    [sym_assignment] = STATE(11948),
    [sym_unary] = STATE(11948),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4607),
    [sym_singleton_class] = STATE(4609),
    [sym_module] = STATE(4609),
    [sym_chained_string] = STATE(4609),
    [sym_until] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_for] = STATE(4609),
    [sym_symbol] = STATE(4609),
    [sym_if] = STATE(4609),
    [sym_begin] = STATE(4609),
    [sym__arg] = STATE(11948),
    [sym__primary] = STATE(4609),
    [sym_method_call] = STATE(4607),
    [sym_operator_assignment] = STATE(11948),
    [sym_conditional] = STATE(11948),
    [sym_method] = STATE(4609),
    [sym_singleton_method] = STATE(4609),
    [sym__variable] = STATE(4610),
    [sym_left_assignment_list] = STATE(4611),
    [sym_rational] = STATE(4609),
    [sym_true] = STATE(4607),
    [sym_return] = STATE(4609),
    [sym_subshell] = STATE(4609),
    [sym_yield] = STATE(4609),
    [sym_string] = STATE(7473),
    [sym_unless] = STATE(4609),
    [sym_lambda] = STATE(4609),
    [sym_parenthesized_statements] = STATE(4609),
    [sym_element_reference] = STATE(4607),
    [sym_range] = STATE(11948),
    [sym_binary] = STATE(11948),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4609),
    [sym_break] = STATE(4609),
    [sym_next] = STATE(4609),
    [sym_string_array] = STATE(4609),
    [sym_while] = STATE(4609),
    [sym_case] = STATE(4609),
    [sym_symbol_array] = STATE(4609),
    [sym_array] = STATE(4609),
    [sym_hash] = STATE(4609),
    [sym_false] = STATE(4607),
    [sym_nil] = STATE(4607),
    [sym_scope_resolution] = STATE(4610),
    [sym_call] = STATE(4610),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(7658),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7678),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(7666),
    [anon_sym_not] = ACTIONS(7682),
    [sym_self] = ACTIONS(7662),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(7686),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7664),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(7664),
    [anon_sym_PLUS] = ACTIONS(11679),
    [anon_sym_TILDE] = ACTIONS(7666),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7670),
    [sym_character] = ACTIONS(7664),
    [sym_super] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(7688),
    [anon_sym_next] = ACTIONS(7690),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(7658),
    [sym_constant] = ACTIONS(7662),
    [anon_sym_defined_QMARK] = ACTIONS(7672),
    [sym_instance_variable] = ACTIONS(7670),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(7662),
    [sym_redo] = ACTIONS(7658),
    [sym_class_variable] = ACTIONS(7670),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(7660),
  },
  [11251] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11252] = {
    [anon_sym_RPAREN] = ACTIONS(16897),
    [sym_comment] = ACTIONS(49),
  },
  [11253] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11254] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [11255] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [11256] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(7522),
    [sym_unary] = STATE(7522),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(7522),
    [sym__primary] = STATE(4636),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(7522),
    [sym_conditional] = STATE(7522),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7523),
    [sym_rational] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(7522),
    [sym_binary] = STATE(7522),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym_float] = ACTIONS(7716),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(7720),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(7720),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(11753),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(7728),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [sym__identifier_hash_key] = ACTIONS(11755),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(11753),
    [anon_sym_yield] = ACTIONS(7734),
    [sym_class_variable] = ACTIONS(7728),
    [sym__block_ampersand] = ACTIONS(11757),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(7738),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [sym_retry] = ACTIONS(7716),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(15989),
    [sym_redo] = ACTIONS(7716),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [11257] = {
    [sym_heredoc_body] = STATE(11257),
    [aux_sym_call_repeat1] = STATE(11257),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [11258] = {
    [sym_heredoc_body] = STATE(11257),
    [aux_sym_call_repeat1] = STATE(11257),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [11259] = {
    [aux_sym_argument_list_repeat1] = STATE(11259),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(16899),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [11260] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11261] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11262] = {
    [aux_sym_exceptions_repeat1] = STATE(9893),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11263] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11264] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11265] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11266] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11267] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16902),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11268] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11269] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11270] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11271] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11272] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [11273] = {
    [aux_sym_exceptions_repeat1] = STATE(11273),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16904),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11274] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11275] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11276] = {
    [aux_sym_exceptions_repeat1] = STATE(11952),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11277] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11278] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11279] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11280] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11281] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16907),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11282] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11283] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [11284] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11285] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11286] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11287] = {
    [aux_sym_chained_string_repeat1] = STATE(11287),
    [sym_string] = STATE(11287),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11288] = {
    [sym_assignment] = STATE(9910),
    [sym_unary] = STATE(9910),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(9910),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(9910),
    [sym_conditional] = STATE(9910),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_return] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_true] = STATE(4640),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(9910),
    [sym_binary] = STATE(9910),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(11759),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [sym_global_variable] = ACTIONS(7728),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(7720),
    [sym_character] = ACTIONS(7722),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [11289] = {
    [aux_sym_exceptions_repeat1] = STATE(11954),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16909),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11290] = {
    [sym_assignment] = STATE(11955),
    [sym_unary] = STATE(11955),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4640),
    [sym_singleton_class] = STATE(4636),
    [sym_module] = STATE(4636),
    [sym_chained_string] = STATE(4636),
    [sym_until] = STATE(4636),
    [sym_regex] = STATE(4636),
    [sym_for] = STATE(4636),
    [sym_symbol] = STATE(4636),
    [sym_if] = STATE(4636),
    [sym_begin] = STATE(4636),
    [sym__arg] = STATE(11955),
    [sym__primary] = STATE(4636),
    [sym_method_call] = STATE(4640),
    [sym_operator_assignment] = STATE(11955),
    [sym_conditional] = STATE(11955),
    [sym_method] = STATE(4636),
    [sym_singleton_method] = STATE(4636),
    [sym__variable] = STATE(4638),
    [sym_left_assignment_list] = STATE(4637),
    [sym_rational] = STATE(4636),
    [sym_true] = STATE(4640),
    [sym_return] = STATE(4636),
    [sym_subshell] = STATE(4636),
    [sym_yield] = STATE(4636),
    [sym_string] = STATE(7548),
    [sym_unless] = STATE(4636),
    [sym_lambda] = STATE(4636),
    [sym_parenthesized_statements] = STATE(4636),
    [sym_element_reference] = STATE(4640),
    [sym_range] = STATE(11955),
    [sym_binary] = STATE(11955),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4636),
    [sym_break] = STATE(4636),
    [sym_next] = STATE(4636),
    [sym_string_array] = STATE(4636),
    [sym_while] = STATE(4636),
    [sym_case] = STATE(4636),
    [sym_symbol_array] = STATE(4636),
    [sym_array] = STATE(4636),
    [sym_hash] = STATE(4636),
    [sym_false] = STATE(4640),
    [sym_nil] = STATE(4640),
    [sym_scope_resolution] = STATE(4638),
    [sym_call] = STATE(4638),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(7716),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(7734),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(7724),
    [anon_sym_not] = ACTIONS(7738),
    [sym_self] = ACTIONS(7720),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(7742),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(7722),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(7722),
    [anon_sym_PLUS] = ACTIONS(11791),
    [anon_sym_TILDE] = ACTIONS(7724),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(7728),
    [sym_character] = ACTIONS(7722),
    [sym_super] = ACTIONS(7720),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(7744),
    [anon_sym_next] = ACTIONS(7746),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(7716),
    [sym_constant] = ACTIONS(7720),
    [anon_sym_defined_QMARK] = ACTIONS(7730),
    [sym_instance_variable] = ACTIONS(7728),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(11681),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(7720),
    [sym_redo] = ACTIONS(7716),
    [sym_class_variable] = ACTIONS(7728),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(7718),
  },
  [11291] = {
    [anon_sym_LT] = ACTIONS(7754),
    [anon_sym_SLASH] = ACTIONS(7756),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7760),
    [anon_sym_GT_GT] = ACTIONS(7762),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7764),
    [anon_sym_LT_LT] = ACTIONS(7762),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(7760),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(7768),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_GT] = ACTIONS(7754),
    [anon_sym_PERCENT] = ACTIONS(7756),
    [sym__binary_star] = ACTIONS(7756),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(7772),
    [anon_sym_BANG_TILDE] = ACTIONS(7760),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7760),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7774),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7760),
    [anon_sym_STAR_STAR] = ACTIONS(7756),
    [anon_sym_PIPE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_AMP_AMP] = ACTIONS(7760),
    [anon_sym_LT_EQ_GT] = ACTIONS(7760),
    [anon_sym_LT_EQ] = ACTIONS(7754),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7780),
    [sym__binary_minus] = ACTIONS(7768),
  },
  [11292] = {
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(7804),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7808),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7810),
    [anon_sym_LT_LT] = ACTIONS(7808),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7812),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(7812),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7816),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [sym__binary_star] = ACTIONS(7804),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(7818),
    [anon_sym_BANG_TILDE] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7812),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7812),
    [anon_sym_STAR_STAR] = ACTIONS(7804),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_DOT_DOT] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7812),
    [anon_sym_LT_EQ_GT] = ACTIONS(7812),
    [anon_sym_LT_EQ] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7826),
    [sym__binary_minus] = ACTIONS(7816),
  },
  [11293] = {
    [aux_sym_exceptions_repeat1] = STATE(11293),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16911),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11294] = {
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7838),
    [anon_sym_EQ_TILDE] = ACTIONS(7838),
    [anon_sym_LT_LT] = ACTIONS(7840),
    [sym__binary_star] = ACTIONS(7842),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(7844),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(7848),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7840),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7856),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_GT_EQ] = ACTIONS(7860),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_STAR_STAR] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [sym__binary_minus] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(7850),
  },
  [11295] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_COLON2] = ACTIONS(14594),
    [anon_sym_while] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
    [sym__binary_minus] = ACTIONS(14596),
  },
  [11296] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_COLON2] = ACTIONS(15027),
    [anon_sym_while] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
    [sym__binary_minus] = ACTIONS(15029),
  },
  [11297] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_while] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
  },
  [11298] = {
    [anon_sym_end] = ACTIONS(16914),
    [sym_comment] = ACTIONS(49),
  },
  [11299] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_COLON2] = ACTIONS(15207),
    [anon_sym_while] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
    [sym__binary_minus] = ACTIONS(15209),
  },
  [11300] = {
    [sym_heredoc_body] = STATE(11300),
    [aux_sym_call_repeat1] = STATE(11300),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11301] = {
    [sym_heredoc_body] = STATE(11300),
    [aux_sym_call_repeat1] = STATE(11300),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_RBRACE] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11302] = {
    [sym_assignment] = STATE(9957),
    [sym_unary] = STATE(9957),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(9957),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(9957),
    [sym_conditional] = STATE(9957),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_return] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_true] = STATE(4774),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(9957),
    [sym_binary] = STATE(9957),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(3922),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [sym_global_variable] = ACTIONS(7958),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(7950),
    [sym_character] = ACTIONS(7954),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [11303] = {
    [aux_sym_exceptions_repeat1] = STATE(11957),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16916),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11304] = {
    [sym_assignment] = STATE(11958),
    [sym_unary] = STATE(11958),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4774),
    [sym_singleton_class] = STATE(4776),
    [sym_module] = STATE(4776),
    [sym_chained_string] = STATE(4776),
    [sym_until] = STATE(4776),
    [sym_regex] = STATE(4776),
    [sym_for] = STATE(4776),
    [sym_symbol] = STATE(4776),
    [sym_if] = STATE(4776),
    [sym_begin] = STATE(4776),
    [sym__arg] = STATE(11958),
    [sym__primary] = STATE(4776),
    [sym_method_call] = STATE(4774),
    [sym_operator_assignment] = STATE(11958),
    [sym_conditional] = STATE(11958),
    [sym_method] = STATE(4776),
    [sym_singleton_method] = STATE(4776),
    [sym__variable] = STATE(4777),
    [sym_left_assignment_list] = STATE(4778),
    [sym_rational] = STATE(4776),
    [sym_true] = STATE(4774),
    [sym_return] = STATE(4776),
    [sym_subshell] = STATE(4776),
    [sym_yield] = STATE(4776),
    [sym_string] = STATE(4779),
    [sym_unless] = STATE(4776),
    [sym_lambda] = STATE(4776),
    [sym_parenthesized_statements] = STATE(4776),
    [sym_element_reference] = STATE(4774),
    [sym_range] = STATE(11958),
    [sym_binary] = STATE(11958),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4776),
    [sym_break] = STATE(4776),
    [sym_next] = STATE(4776),
    [sym_string_array] = STATE(4776),
    [sym_while] = STATE(4776),
    [sym_case] = STATE(4776),
    [sym_symbol_array] = STATE(4776),
    [sym_array] = STATE(4776),
    [sym_hash] = STATE(4776),
    [sym_false] = STATE(4774),
    [sym_nil] = STATE(4774),
    [sym_scope_resolution] = STATE(4777),
    [sym_call] = STATE(4777),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(7942),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(7944),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_not] = ACTIONS(7948),
    [sym_self] = ACTIONS(7950),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(7952),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(7954),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(7954),
    [anon_sym_PLUS] = ACTIONS(7956),
    [anon_sym_TILDE] = ACTIONS(7946),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(7958),
    [sym_character] = ACTIONS(7954),
    [sym_super] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(7960),
    [anon_sym_next] = ACTIONS(7962),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(7942),
    [sym_constant] = ACTIONS(7950),
    [anon_sym_defined_QMARK] = ACTIONS(7964),
    [sym_instance_variable] = ACTIONS(7958),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(7950),
    [sym_redo] = ACTIONS(7942),
    [sym_class_variable] = ACTIONS(7958),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(7968),
  },
  [11305] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11306] = {
    [anon_sym_RPAREN] = ACTIONS(16918),
    [sym_comment] = ACTIONS(49),
  },
  [11307] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11308] = {
    [aux_sym_exceptions_repeat1] = STATE(11308),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16920),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11309] = {
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(7984),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7986),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(7988),
    [anon_sym_AMP] = ACTIONS(7992),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_PLUS] = ACTIONS(7994),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(7982),
    [sym__binary_star] = ACTIONS(7982),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(7996),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7988),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(7998),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(7988),
    [anon_sym_STAR_STAR] = ACTIONS(7982),
    [anon_sym_PIPE] = ACTIONS(8000),
    [anon_sym_DOT_DOT] = ACTIONS(8002),
    [anon_sym_AMP_AMP] = ACTIONS(7988),
    [anon_sym_LT_EQ_GT] = ACTIONS(7988),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(7994),
  },
  [11310] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11311] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_while] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
    [sym__binary_minus] = ACTIONS(15291),
  },
  [11312] = {
    [anon_sym_end] = ACTIONS(16923),
    [sym_comment] = ACTIONS(49),
  },
  [11313] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_COLON2] = ACTIONS(15674),
    [anon_sym_while] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
    [sym__binary_minus] = ACTIONS(15676),
  },
  [11314] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_COLON2] = ACTIONS(15829),
    [anon_sym_while] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
    [sym__binary_minus] = ACTIONS(15831),
  },
  [11315] = {
    [sym_assignment] = STATE(11961),
    [sym_unary] = STATE(11961),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4860),
    [sym_singleton_class] = STATE(674),
    [sym_module] = STATE(674),
    [sym_chained_string] = STATE(674),
    [sym_until] = STATE(674),
    [sym_regex] = STATE(674),
    [sym_for] = STATE(674),
    [sym_symbol] = STATE(674),
    [sym_if] = STATE(674),
    [sym_begin] = STATE(674),
    [sym__arg] = STATE(11961),
    [sym__primary] = STATE(674),
    [sym_method_call] = STATE(4860),
    [sym_operator_assignment] = STATE(11961),
    [sym_conditional] = STATE(11961),
    [sym_method] = STATE(674),
    [sym_singleton_method] = STATE(674),
    [sym__variable] = STATE(676),
    [sym_left_assignment_list] = STATE(4862),
    [sym_rational] = STATE(674),
    [sym_true] = STATE(4860),
    [sym_return] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_yield] = STATE(674),
    [sym_string] = STATE(4863),
    [sym_unless] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_parenthesized_statements] = STATE(674),
    [sym_element_reference] = STATE(4860),
    [sym_range] = STATE(11961),
    [sym_binary] = STATE(11961),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(674),
    [sym_break] = STATE(674),
    [sym_next] = STATE(674),
    [sym_string_array] = STATE(674),
    [sym_while] = STATE(674),
    [sym_case] = STATE(674),
    [sym_symbol_array] = STATE(674),
    [sym_array] = STATE(674),
    [sym_hash] = STATE(674),
    [sym_false] = STATE(4860),
    [sym_nil] = STATE(4860),
    [sym_scope_resolution] = STATE(676),
    [sym_call] = STATE(676),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(1233),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(8074),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(8076),
    [anon_sym_not] = ACTIONS(8078),
    [sym_self] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(8082),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(8084),
    [anon_sym_TILDE] = ACTIONS(8076),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(1267),
    [sym_character] = ACTIONS(1243),
    [sym_super] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(8086),
    [anon_sym_next] = ACTIONS(8088),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1233),
    [sym_constant] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(8090),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1279),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1239),
    [sym_redo] = ACTIONS(1233),
    [sym_class_variable] = ACTIONS(1267),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(8092),
  },
  [11316] = {
    [anon_sym_SLASH] = ACTIONS(15173),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_while] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [11317] = {
    [anon_sym_end] = ACTIONS(16925),
    [sym_comment] = ACTIONS(49),
  },
  [11318] = {
    [anon_sym_SLASH] = ACTIONS(7382),
    [anon_sym_RBRACK] = ACTIONS(7384),
    [anon_sym_until] = ACTIONS(7384),
    [anon_sym_AMP_EQ] = ACTIONS(7384),
    [anon_sym_GT_GT_EQ] = ACTIONS(7384),
    [anon_sym_SLASH_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7384),
    [anon_sym_RPAREN] = ACTIONS(7384),
    [anon_sym_EQ_TILDE] = ACTIONS(7384),
    [anon_sym_LT_LT] = ACTIONS(7382),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [sym__binary_star] = ACTIONS(7384),
    [anon_sym_unless] = ACTIONS(7384),
    [anon_sym_PLUS] = ACTIONS(7382),
    [anon_sym_AMP] = ACTIONS(7382),
    [anon_sym_PERCENT] = ACTIONS(7382),
    [anon_sym_COLON_COLON2] = ACTIONS(7384),
    [anon_sym_rescue] = ACTIONS(7384),
    [anon_sym_PERCENT_EQ] = ACTIONS(7384),
    [anon_sym_LT_LT_EQ] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_DOT] = ACTIONS(7382),
    [anon_sym_BANG_TILDE] = ACTIONS(7384),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_COLON2] = ACTIONS(7382),
    [anon_sym_while] = ACTIONS(7384),
    [sym__heredoc_body_start] = ACTIONS(7384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7384),
    [anon_sym_CARET_EQ] = ACTIONS(7384),
    [anon_sym_AMP_DOT] = ACTIONS(7384),
    [anon_sym_LT_EQ] = ACTIONS(7382),
    [anon_sym_PIPE] = ACTIONS(7382),
    [anon_sym_DOT_DOT] = ACTIONS(7382),
    [anon_sym_EQ] = ACTIONS(7382),
    [anon_sym_LT] = ACTIONS(7382),
    [anon_sym_in] = ACTIONS(7384),
    [anon_sym_QMARK] = ACTIONS(7384),
    [anon_sym_COMMA] = ACTIONS(7384),
    [anon_sym_GT_GT] = ACTIONS(7382),
    [anon_sym_SEMI] = ACTIONS(7384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7384),
    [anon_sym_or] = ACTIONS(7384),
    [anon_sym_GT] = ACTIONS(7382),
    [anon_sym_PIPE_EQ] = ACTIONS(7384),
    [anon_sym_PLUS_EQ] = ACTIONS(7384),
    [anon_sym_STAR_EQ] = ACTIONS(7384),
    [anon_sym_EQ_EQ] = ACTIONS(7382),
    [anon_sym_and] = ACTIONS(7384),
    [anon_sym_PIPE_PIPE] = ACTIONS(7382),
    [anon_sym_GT_EQ] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(7384),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7384),
    [anon_sym_DASH_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7384),
    [anon_sym_BANG_EQ] = ACTIONS(7384),
    [anon_sym_STAR_STAR] = ACTIONS(7382),
    [anon_sym_LT_EQ_GT] = ACTIONS(7384),
    [sym__binary_minus] = ACTIONS(7384),
    [anon_sym_AMP_AMP] = ACTIONS(7382),
    [anon_sym_if] = ACTIONS(7384),
    [anon_sym_CARET] = ACTIONS(7382),
  },
  [11319] = {
    [anon_sym_end] = ACTIONS(16927),
    [sym_comment] = ACTIONS(49),
  },
  [11320] = {
    [anon_sym_SLASH] = ACTIONS(9897),
    [anon_sym_RBRACK] = ACTIONS(9899),
    [anon_sym_until] = ACTIONS(9899),
    [anon_sym_AMP_EQ] = ACTIONS(9899),
    [anon_sym_GT_GT_EQ] = ACTIONS(9899),
    [anon_sym_SLASH_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9899),
    [anon_sym_RPAREN] = ACTIONS(9899),
    [anon_sym_EQ_TILDE] = ACTIONS(9899),
    [anon_sym_LT_LT] = ACTIONS(9897),
    [anon_sym_RBRACE] = ACTIONS(9899),
    [sym__binary_star] = ACTIONS(9899),
    [anon_sym_unless] = ACTIONS(9899),
    [anon_sym_PLUS] = ACTIONS(9897),
    [anon_sym_AMP] = ACTIONS(9897),
    [anon_sym_PERCENT] = ACTIONS(9897),
    [anon_sym_COLON_COLON2] = ACTIONS(9899),
    [anon_sym_rescue] = ACTIONS(9899),
    [anon_sym_PERCENT_EQ] = ACTIONS(9899),
    [anon_sym_LT_LT_EQ] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_DOT] = ACTIONS(9897),
    [anon_sym_BANG_TILDE] = ACTIONS(9899),
    [anon_sym_LBRACE] = ACTIONS(9899),
    [anon_sym_COLON2] = ACTIONS(9897),
    [anon_sym_while] = ACTIONS(9899),
    [sym__heredoc_body_start] = ACTIONS(9899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9899),
    [anon_sym_CARET_EQ] = ACTIONS(9899),
    [anon_sym_AMP_DOT] = ACTIONS(9899),
    [anon_sym_LT_EQ] = ACTIONS(9897),
    [anon_sym_PIPE] = ACTIONS(9897),
    [anon_sym_DOT_DOT] = ACTIONS(9897),
    [anon_sym_EQ] = ACTIONS(9897),
    [anon_sym_LT] = ACTIONS(9897),
    [anon_sym_in] = ACTIONS(9899),
    [anon_sym_QMARK] = ACTIONS(9899),
    [anon_sym_COMMA] = ACTIONS(9899),
    [anon_sym_GT_GT] = ACTIONS(9897),
    [anon_sym_SEMI] = ACTIONS(9899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9899),
    [anon_sym_or] = ACTIONS(9899),
    [anon_sym_GT] = ACTIONS(9897),
    [anon_sym_PIPE_EQ] = ACTIONS(9899),
    [anon_sym_PLUS_EQ] = ACTIONS(9899),
    [anon_sym_STAR_EQ] = ACTIONS(9899),
    [anon_sym_EQ_EQ] = ACTIONS(9897),
    [anon_sym_and] = ACTIONS(9899),
    [anon_sym_PIPE_PIPE] = ACTIONS(9897),
    [anon_sym_GT_EQ] = ACTIONS(9899),
    [anon_sym_LBRACK] = ACTIONS(9899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9899),
    [anon_sym_DASH_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9899),
    [anon_sym_BANG_EQ] = ACTIONS(9899),
    [anon_sym_STAR_STAR] = ACTIONS(9897),
    [anon_sym_LT_EQ_GT] = ACTIONS(9899),
    [sym__binary_minus] = ACTIONS(9899),
    [anon_sym_AMP_AMP] = ACTIONS(9897),
    [anon_sym_if] = ACTIONS(9899),
    [anon_sym_CARET] = ACTIONS(9897),
  },
  [11321] = {
    [anon_sym_end] = ACTIONS(16929),
    [sym_comment] = ACTIONS(49),
  },
  [11322] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(11965),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16929),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [11323] = {
    [sym_when] = STATE(11966),
    [sym_else] = STATE(11965),
    [aux_sym_case_repeat2] = STATE(11966),
    [aux_sym_case_repeat1] = STATE(3423),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(16929),
    [anon_sym_else] = ACTIONS(2379),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(49),
  },
  [11324] = {
    [anon_sym_SLASH] = ACTIONS(10931),
    [anon_sym_RBRACK] = ACTIONS(10933),
    [anon_sym_until] = ACTIONS(10933),
    [anon_sym_AMP_EQ] = ACTIONS(10933),
    [anon_sym_GT_GT_EQ] = ACTIONS(10933),
    [anon_sym_SLASH_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10933),
    [anon_sym_RPAREN] = ACTIONS(10933),
    [anon_sym_EQ_TILDE] = ACTIONS(10933),
    [anon_sym_LT_LT] = ACTIONS(10931),
    [anon_sym_RBRACE] = ACTIONS(10933),
    [sym__binary_star] = ACTIONS(10933),
    [anon_sym_unless] = ACTIONS(10933),
    [anon_sym_PLUS] = ACTIONS(10931),
    [anon_sym_AMP] = ACTIONS(10931),
    [anon_sym_PERCENT] = ACTIONS(10931),
    [anon_sym_COLON_COLON2] = ACTIONS(10933),
    [anon_sym_rescue] = ACTIONS(10933),
    [anon_sym_PERCENT_EQ] = ACTIONS(10933),
    [anon_sym_LT_LT_EQ] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_DOT] = ACTIONS(10931),
    [anon_sym_BANG_TILDE] = ACTIONS(10933),
    [anon_sym_LBRACE] = ACTIONS(10933),
    [anon_sym_COLON2] = ACTIONS(10931),
    [anon_sym_while] = ACTIONS(10933),
    [sym__heredoc_body_start] = ACTIONS(10933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10933),
    [anon_sym_CARET_EQ] = ACTIONS(10933),
    [anon_sym_AMP_DOT] = ACTIONS(10933),
    [anon_sym_LT_EQ] = ACTIONS(10931),
    [anon_sym_PIPE] = ACTIONS(10931),
    [anon_sym_DOT_DOT] = ACTIONS(10931),
    [anon_sym_EQ] = ACTIONS(10931),
    [anon_sym_LT] = ACTIONS(10931),
    [anon_sym_in] = ACTIONS(10933),
    [anon_sym_QMARK] = ACTIONS(10933),
    [anon_sym_COMMA] = ACTIONS(10933),
    [anon_sym_GT_GT] = ACTIONS(10931),
    [anon_sym_SEMI] = ACTIONS(10933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10933),
    [anon_sym_or] = ACTIONS(10933),
    [anon_sym_GT] = ACTIONS(10931),
    [anon_sym_PIPE_EQ] = ACTIONS(10933),
    [anon_sym_PLUS_EQ] = ACTIONS(10933),
    [anon_sym_STAR_EQ] = ACTIONS(10933),
    [anon_sym_EQ_EQ] = ACTIONS(10931),
    [anon_sym_and] = ACTIONS(10933),
    [anon_sym_PIPE_PIPE] = ACTIONS(10931),
    [anon_sym_GT_EQ] = ACTIONS(10933),
    [anon_sym_LBRACK] = ACTIONS(10933),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10933),
    [anon_sym_DASH_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10933),
    [anon_sym_BANG_EQ] = ACTIONS(10933),
    [anon_sym_STAR_STAR] = ACTIONS(10931),
    [anon_sym_LT_EQ_GT] = ACTIONS(10933),
    [sym__binary_minus] = ACTIONS(10933),
    [anon_sym_AMP_AMP] = ACTIONS(10931),
    [anon_sym_if] = ACTIONS(10933),
    [anon_sym_CARET] = ACTIONS(10931),
  },
  [11325] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16931),
  },
  [11326] = {
    [anon_sym_SLASH] = ACTIONS(10937),
    [anon_sym_RBRACK] = ACTIONS(10939),
    [anon_sym_until] = ACTIONS(10939),
    [anon_sym_AMP_EQ] = ACTIONS(10939),
    [anon_sym_GT_GT_EQ] = ACTIONS(10939),
    [anon_sym_SLASH_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10939),
    [anon_sym_RPAREN] = ACTIONS(10939),
    [anon_sym_EQ_TILDE] = ACTIONS(10939),
    [anon_sym_LT_LT] = ACTIONS(10937),
    [anon_sym_RBRACE] = ACTIONS(10939),
    [sym__binary_star] = ACTIONS(10939),
    [anon_sym_unless] = ACTIONS(10939),
    [anon_sym_PLUS] = ACTIONS(10937),
    [anon_sym_AMP] = ACTIONS(10937),
    [anon_sym_PERCENT] = ACTIONS(10937),
    [anon_sym_COLON_COLON2] = ACTIONS(10939),
    [anon_sym_rescue] = ACTIONS(10939),
    [anon_sym_PERCENT_EQ] = ACTIONS(10939),
    [anon_sym_LT_LT_EQ] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_DOT] = ACTIONS(10937),
    [anon_sym_BANG_TILDE] = ACTIONS(10939),
    [anon_sym_LBRACE] = ACTIONS(10939),
    [anon_sym_COLON2] = ACTIONS(10937),
    [anon_sym_while] = ACTIONS(10939),
    [sym__heredoc_body_start] = ACTIONS(10939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10939),
    [anon_sym_CARET_EQ] = ACTIONS(10939),
    [anon_sym_AMP_DOT] = ACTIONS(10939),
    [anon_sym_LT_EQ] = ACTIONS(10937),
    [anon_sym_PIPE] = ACTIONS(10937),
    [anon_sym_DOT_DOT] = ACTIONS(10937),
    [anon_sym_EQ] = ACTIONS(10937),
    [anon_sym_LT] = ACTIONS(10937),
    [anon_sym_in] = ACTIONS(10939),
    [anon_sym_QMARK] = ACTIONS(10939),
    [anon_sym_COMMA] = ACTIONS(10939),
    [anon_sym_GT_GT] = ACTIONS(10937),
    [anon_sym_SEMI] = ACTIONS(10939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10939),
    [anon_sym_or] = ACTIONS(10939),
    [anon_sym_GT] = ACTIONS(10937),
    [anon_sym_PIPE_EQ] = ACTIONS(10939),
    [anon_sym_PLUS_EQ] = ACTIONS(10939),
    [anon_sym_STAR_EQ] = ACTIONS(10939),
    [anon_sym_EQ_EQ] = ACTIONS(10937),
    [anon_sym_and] = ACTIONS(10939),
    [anon_sym_PIPE_PIPE] = ACTIONS(10937),
    [anon_sym_GT_EQ] = ACTIONS(10939),
    [anon_sym_LBRACK] = ACTIONS(10939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10939),
    [anon_sym_DASH_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10939),
    [anon_sym_BANG_EQ] = ACTIONS(10939),
    [anon_sym_STAR_STAR] = ACTIONS(10937),
    [anon_sym_LT_EQ_GT] = ACTIONS(10939),
    [sym__binary_minus] = ACTIONS(10939),
    [anon_sym_AMP_AMP] = ACTIONS(10937),
    [anon_sym_if] = ACTIONS(10939),
    [anon_sym_CARET] = ACTIONS(10937),
  },
  [11327] = {
    [aux_sym_string_array_repeat1] = STATE(3975),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16933),
    [sym__string_end] = ACTIONS(16931),
  },
  [11328] = {
    [anon_sym_SLASH] = ACTIONS(10943),
    [anon_sym_RBRACK] = ACTIONS(10945),
    [anon_sym_until] = ACTIONS(10945),
    [anon_sym_AMP_EQ] = ACTIONS(10945),
    [anon_sym_GT_GT_EQ] = ACTIONS(10945),
    [anon_sym_SLASH_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10945),
    [anon_sym_RPAREN] = ACTIONS(10945),
    [anon_sym_EQ_TILDE] = ACTIONS(10945),
    [anon_sym_LT_LT] = ACTIONS(10943),
    [anon_sym_RBRACE] = ACTIONS(10945),
    [sym__binary_star] = ACTIONS(10945),
    [anon_sym_unless] = ACTIONS(10945),
    [anon_sym_PLUS] = ACTIONS(10943),
    [anon_sym_AMP] = ACTIONS(10943),
    [anon_sym_PERCENT] = ACTIONS(10943),
    [anon_sym_COLON_COLON2] = ACTIONS(10945),
    [anon_sym_rescue] = ACTIONS(10945),
    [anon_sym_PERCENT_EQ] = ACTIONS(10945),
    [anon_sym_LT_LT_EQ] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_DOT] = ACTIONS(10943),
    [anon_sym_BANG_TILDE] = ACTIONS(10945),
    [anon_sym_LBRACE] = ACTIONS(10945),
    [anon_sym_COLON2] = ACTIONS(10943),
    [anon_sym_while] = ACTIONS(10945),
    [sym__heredoc_body_start] = ACTIONS(10945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10945),
    [anon_sym_CARET_EQ] = ACTIONS(10945),
    [anon_sym_AMP_DOT] = ACTIONS(10945),
    [anon_sym_LT_EQ] = ACTIONS(10943),
    [anon_sym_PIPE] = ACTIONS(10943),
    [anon_sym_DOT_DOT] = ACTIONS(10943),
    [anon_sym_EQ] = ACTIONS(10943),
    [anon_sym_LT] = ACTIONS(10943),
    [anon_sym_in] = ACTIONS(10945),
    [anon_sym_QMARK] = ACTIONS(10945),
    [anon_sym_COMMA] = ACTIONS(10945),
    [anon_sym_GT_GT] = ACTIONS(10943),
    [anon_sym_SEMI] = ACTIONS(10945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10945),
    [anon_sym_or] = ACTIONS(10945),
    [anon_sym_GT] = ACTIONS(10943),
    [anon_sym_PIPE_EQ] = ACTIONS(10945),
    [anon_sym_PLUS_EQ] = ACTIONS(10945),
    [anon_sym_STAR_EQ] = ACTIONS(10945),
    [anon_sym_EQ_EQ] = ACTIONS(10943),
    [anon_sym_and] = ACTIONS(10945),
    [anon_sym_PIPE_PIPE] = ACTIONS(10943),
    [anon_sym_GT_EQ] = ACTIONS(10945),
    [anon_sym_LBRACK] = ACTIONS(10945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10945),
    [anon_sym_DASH_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10945),
    [anon_sym_BANG_EQ] = ACTIONS(10945),
    [anon_sym_STAR_STAR] = ACTIONS(10943),
    [anon_sym_LT_EQ_GT] = ACTIONS(10945),
    [sym__binary_minus] = ACTIONS(10945),
    [anon_sym_AMP_AMP] = ACTIONS(10943),
    [anon_sym_if] = ACTIONS(10945),
    [anon_sym_CARET] = ACTIONS(10943),
  },
  [11329] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16935),
  },
  [11330] = {
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_RBRACK] = ACTIONS(7790),
    [anon_sym_until] = ACTIONS(7790),
    [anon_sym_AMP_EQ] = ACTIONS(7790),
    [anon_sym_GT_GT_EQ] = ACTIONS(7790),
    [anon_sym_SLASH_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7790),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_EQ_TILDE] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [sym__binary_star] = ACTIONS(7790),
    [anon_sym_unless] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7790),
    [anon_sym_rescue] = ACTIONS(7790),
    [anon_sym_PERCENT_EQ] = ACTIONS(7790),
    [anon_sym_LT_LT_EQ] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7790),
    [anon_sym_COLON2] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7790),
    [sym__heredoc_body_start] = ACTIONS(7790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7790),
    [anon_sym_CARET_EQ] = ACTIONS(7790),
    [anon_sym_AMP_DOT] = ACTIONS(7790),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7788),
    [anon_sym_EQ] = ACTIONS(7788),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_in] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_SEMI] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7790),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_PIPE_EQ] = ACTIONS(7790),
    [anon_sym_PLUS_EQ] = ACTIONS(7790),
    [anon_sym_STAR_EQ] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7790),
    [anon_sym_LBRACK] = ACTIONS(7790),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7790),
    [anon_sym_DASH_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7790),
    [sym__binary_minus] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7788),
  },
  [11331] = {
    [anon_sym_end] = ACTIONS(16937),
    [sym_comment] = ACTIONS(49),
  },
  [11332] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11971),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16939),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [11333] = {
    [anon_sym_SLASH] = ACTIONS(10206),
    [anon_sym_RBRACK] = ACTIONS(10208),
    [anon_sym_until] = ACTIONS(10208),
    [anon_sym_AMP_EQ] = ACTIONS(10208),
    [anon_sym_GT_GT_EQ] = ACTIONS(10208),
    [anon_sym_SLASH_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10208),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_EQ_TILDE] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10206),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [sym__binary_star] = ACTIONS(10208),
    [anon_sym_unless] = ACTIONS(10208),
    [anon_sym_PLUS] = ACTIONS(10206),
    [anon_sym_AMP] = ACTIONS(10206),
    [anon_sym_PERCENT] = ACTIONS(10206),
    [anon_sym_COLON_COLON2] = ACTIONS(10208),
    [anon_sym_rescue] = ACTIONS(10208),
    [anon_sym_PERCENT_EQ] = ACTIONS(10208),
    [anon_sym_LT_LT_EQ] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_DOT] = ACTIONS(10206),
    [anon_sym_BANG_TILDE] = ACTIONS(10208),
    [anon_sym_LBRACE] = ACTIONS(10208),
    [anon_sym_COLON2] = ACTIONS(10206),
    [anon_sym_while] = ACTIONS(10208),
    [sym__heredoc_body_start] = ACTIONS(10208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10208),
    [anon_sym_CARET_EQ] = ACTIONS(10208),
    [anon_sym_AMP_DOT] = ACTIONS(10208),
    [anon_sym_LT_EQ] = ACTIONS(10206),
    [anon_sym_PIPE] = ACTIONS(10206),
    [anon_sym_DOT_DOT] = ACTIONS(10206),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_LT] = ACTIONS(10206),
    [anon_sym_in] = ACTIONS(10208),
    [anon_sym_QMARK] = ACTIONS(10208),
    [anon_sym_COMMA] = ACTIONS(10208),
    [anon_sym_GT_GT] = ACTIONS(10206),
    [anon_sym_SEMI] = ACTIONS(10208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10208),
    [anon_sym_or] = ACTIONS(10208),
    [anon_sym_GT] = ACTIONS(10206),
    [anon_sym_PIPE_EQ] = ACTIONS(10208),
    [anon_sym_PLUS_EQ] = ACTIONS(10208),
    [anon_sym_STAR_EQ] = ACTIONS(10208),
    [anon_sym_EQ_EQ] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(10208),
    [anon_sym_PIPE_PIPE] = ACTIONS(10206),
    [anon_sym_GT_EQ] = ACTIONS(10208),
    [anon_sym_LBRACK] = ACTIONS(10208),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10208),
    [anon_sym_DASH_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10208),
    [anon_sym_STAR_STAR] = ACTIONS(10206),
    [anon_sym_LT_EQ_GT] = ACTIONS(10208),
    [sym__binary_minus] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10206),
    [anon_sym_if] = ACTIONS(10208),
    [anon_sym_CARET] = ACTIONS(10206),
  },
  [11334] = {
    [sym__statement] = STATE(374),
    [sym_unary] = STATE(383),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(374),
    [sym_module] = STATE(376),
    [sym_chained_string] = STATE(376),
    [sym_unless_modifier] = STATE(374),
    [sym_symbol] = STATE(376),
    [sym_for] = STATE(376),
    [sym_if] = STATE(376),
    [sym_ensure] = STATE(7786),
    [sym__primary] = STATE(376),
    [sym_method] = STATE(376),
    [sym_conditional] = STATE(383),
    [sym_left_assignment_list] = STATE(377),
    [sym_return] = STATE(376),
    [sym_true] = STATE(382),
    [sym_while_modifier] = STATE(374),
    [sym_subshell] = STATE(376),
    [sym_unless] = STATE(376),
    [sym_empty_statement] = STATE(387),
    [sym_rescue] = STATE(7787),
    [sym_parenthesized_statements] = STATE(376),
    [sym_begin_block] = STATE(374),
    [sym_range] = STATE(383),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(382),
    [sym_next] = STATE(376),
    [sym_string_array] = STATE(376),
    [sym_while] = STATE(376),
    [sym_array] = STATE(376),
    [sym__body_statement] = STATE(11972),
    [sym_call] = STATE(381),
    [sym_end_block] = STATE(374),
    [sym_assignment] = STATE(383),
    [sym__lhs] = STATE(382),
    [sym_singleton_class] = STATE(376),
    [sym_alias] = STATE(374),
    [sym_if_modifier] = STATE(374),
    [sym_until] = STATE(376),
    [sym_regex] = STATE(376),
    [sym_begin] = STATE(376),
    [sym__arg] = STATE(383),
    [sym_method_call] = STATE(382),
    [sym_operator_assignment] = STATE(383),
    [sym_singleton_method] = STATE(376),
    [sym__variable] = STATE(381),
    [sym_rational] = STATE(376),
    [sym_yield] = STATE(376),
    [sym_string] = STATE(384),
    [sym_until_modifier] = STATE(374),
    [sym_lambda] = STATE(376),
    [sym_element_reference] = STATE(382),
    [sym__statements] = STATE(7790),
    [sym_binary] = STATE(383),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(376),
    [sym_break] = STATE(376),
    [sym_nil] = STATE(382),
    [sym_rescue_modifier] = STATE(374),
    [sym_symbol_array] = STATE(376),
    [sym_case] = STATE(376),
    [sym_hash] = STATE(376),
    [sym_else] = STATE(7791),
    [aux_sym__statements_repeat1] = STATE(387),
    [sym_scope_resolution] = STATE(381),
    [sym_float] = ACTIONS(677),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(679),
    [sym_self] = ACTIONS(681),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(683),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(687),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(683),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(681),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(681),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(691),
    [anon_sym_defined_QMARK] = ACTIONS(695),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(697),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(699),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(701),
    [sym_class_variable] = ACTIONS(691),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(703),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(705),
    [sym_global_variable] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(707),
    [anon_sym_next] = ACTIONS(709),
    [sym_retry] = ACTIONS(677),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16941),
    [anon_sym_ensure] = ACTIONS(713),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(715),
  },
  [11335] = {
    [anon_sym_SLASH] = ACTIONS(10258),
    [anon_sym_RBRACK] = ACTIONS(10260),
    [anon_sym_until] = ACTIONS(10260),
    [anon_sym_AMP_EQ] = ACTIONS(10260),
    [anon_sym_GT_GT_EQ] = ACTIONS(10260),
    [anon_sym_SLASH_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10260),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_EQ_TILDE] = ACTIONS(10260),
    [anon_sym_LT_LT] = ACTIONS(10258),
    [anon_sym_RBRACE] = ACTIONS(10260),
    [sym__binary_star] = ACTIONS(10260),
    [anon_sym_unless] = ACTIONS(10260),
    [anon_sym_PLUS] = ACTIONS(10258),
    [anon_sym_AMP] = ACTIONS(10258),
    [anon_sym_PERCENT] = ACTIONS(10258),
    [anon_sym_COLON_COLON2] = ACTIONS(10260),
    [anon_sym_rescue] = ACTIONS(10260),
    [anon_sym_PERCENT_EQ] = ACTIONS(10260),
    [anon_sym_LT_LT_EQ] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_DOT] = ACTIONS(10258),
    [anon_sym_BANG_TILDE] = ACTIONS(10260),
    [anon_sym_LBRACE] = ACTIONS(10260),
    [anon_sym_COLON2] = ACTIONS(10258),
    [anon_sym_while] = ACTIONS(10260),
    [sym__heredoc_body_start] = ACTIONS(10260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10260),
    [anon_sym_CARET_EQ] = ACTIONS(10260),
    [anon_sym_AMP_DOT] = ACTIONS(10260),
    [anon_sym_LT_EQ] = ACTIONS(10258),
    [anon_sym_PIPE] = ACTIONS(10258),
    [anon_sym_DOT_DOT] = ACTIONS(10258),
    [anon_sym_EQ] = ACTIONS(10258),
    [anon_sym_LT] = ACTIONS(10258),
    [anon_sym_in] = ACTIONS(10260),
    [anon_sym_QMARK] = ACTIONS(10260),
    [anon_sym_COMMA] = ACTIONS(10260),
    [anon_sym_GT_GT] = ACTIONS(10258),
    [anon_sym_SEMI] = ACTIONS(10260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10260),
    [anon_sym_or] = ACTIONS(10260),
    [anon_sym_GT] = ACTIONS(10258),
    [anon_sym_PIPE_EQ] = ACTIONS(10260),
    [anon_sym_PLUS_EQ] = ACTIONS(10260),
    [anon_sym_STAR_EQ] = ACTIONS(10260),
    [anon_sym_EQ_EQ] = ACTIONS(10258),
    [anon_sym_and] = ACTIONS(10260),
    [anon_sym_PIPE_PIPE] = ACTIONS(10258),
    [anon_sym_GT_EQ] = ACTIONS(10260),
    [anon_sym_LBRACK] = ACTIONS(10260),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10260),
    [anon_sym_DASH_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10260),
    [anon_sym_BANG_EQ] = ACTIONS(10260),
    [anon_sym_STAR_STAR] = ACTIONS(10258),
    [anon_sym_LT_EQ_GT] = ACTIONS(10260),
    [sym__binary_minus] = ACTIONS(10260),
    [anon_sym_AMP_AMP] = ACTIONS(10258),
    [anon_sym_if] = ACTIONS(10260),
    [anon_sym_CARET] = ACTIONS(10258),
  },
  [11336] = {
    [anon_sym_SLASH] = ACTIONS(10697),
    [anon_sym_RBRACK] = ACTIONS(10699),
    [anon_sym_until] = ACTIONS(10699),
    [anon_sym_AMP_EQ] = ACTIONS(10699),
    [anon_sym_GT_GT_EQ] = ACTIONS(10699),
    [anon_sym_SLASH_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10699),
    [anon_sym_RPAREN] = ACTIONS(10699),
    [anon_sym_EQ_TILDE] = ACTIONS(10699),
    [anon_sym_LT_LT] = ACTIONS(10697),
    [anon_sym_RBRACE] = ACTIONS(10699),
    [sym__binary_star] = ACTIONS(10699),
    [anon_sym_unless] = ACTIONS(10699),
    [anon_sym_PLUS] = ACTIONS(10697),
    [anon_sym_AMP] = ACTIONS(10697),
    [anon_sym_PERCENT] = ACTIONS(10697),
    [anon_sym_COLON_COLON2] = ACTIONS(10699),
    [anon_sym_rescue] = ACTIONS(10699),
    [anon_sym_PERCENT_EQ] = ACTIONS(10699),
    [anon_sym_LT_LT_EQ] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_DOT] = ACTIONS(10697),
    [anon_sym_BANG_TILDE] = ACTIONS(10699),
    [anon_sym_LBRACE] = ACTIONS(10699),
    [anon_sym_COLON2] = ACTIONS(10697),
    [anon_sym_while] = ACTIONS(10699),
    [sym__heredoc_body_start] = ACTIONS(10699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10699),
    [anon_sym_CARET_EQ] = ACTIONS(10699),
    [anon_sym_AMP_DOT] = ACTIONS(10699),
    [anon_sym_LT_EQ] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(10697),
    [anon_sym_DOT_DOT] = ACTIONS(10697),
    [anon_sym_EQ] = ACTIONS(10697),
    [anon_sym_LT] = ACTIONS(10697),
    [anon_sym_in] = ACTIONS(10699),
    [anon_sym_QMARK] = ACTIONS(10699),
    [anon_sym_COMMA] = ACTIONS(10699),
    [anon_sym_GT_GT] = ACTIONS(10697),
    [anon_sym_SEMI] = ACTIONS(10699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10699),
    [anon_sym_or] = ACTIONS(10699),
    [anon_sym_GT] = ACTIONS(10697),
    [anon_sym_PIPE_EQ] = ACTIONS(10699),
    [anon_sym_PLUS_EQ] = ACTIONS(10699),
    [anon_sym_STAR_EQ] = ACTIONS(10699),
    [anon_sym_EQ_EQ] = ACTIONS(10697),
    [anon_sym_and] = ACTIONS(10699),
    [anon_sym_PIPE_PIPE] = ACTIONS(10697),
    [anon_sym_GT_EQ] = ACTIONS(10699),
    [anon_sym_LBRACK] = ACTIONS(10699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10699),
    [anon_sym_DASH_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10699),
    [anon_sym_BANG_EQ] = ACTIONS(10699),
    [anon_sym_STAR_STAR] = ACTIONS(10697),
    [anon_sym_LT_EQ_GT] = ACTIONS(10699),
    [sym__binary_minus] = ACTIONS(10699),
    [anon_sym_AMP_AMP] = ACTIONS(10697),
    [anon_sym_if] = ACTIONS(10699),
    [anon_sym_CARET] = ACTIONS(10697),
  },
  [11337] = {
    [anon_sym_end] = ACTIONS(16943),
    [sym_comment] = ACTIONS(49),
  },
  [11338] = {
    [sym_ensure] = STATE(11974),
    [sym_comment] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(16943),
    [anon_sym_ensure] = ACTIONS(2733),
  },
  [11339] = {
    [anon_sym_SLASH] = ACTIONS(7870),
    [anon_sym_RBRACK] = ACTIONS(7872),
    [anon_sym_until] = ACTIONS(7872),
    [anon_sym_AMP_EQ] = ACTIONS(7872),
    [anon_sym_GT_GT_EQ] = ACTIONS(7872),
    [anon_sym_SLASH_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7872),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_EQ_TILDE] = ACTIONS(7872),
    [anon_sym_LT_LT] = ACTIONS(7870),
    [anon_sym_RBRACE] = ACTIONS(7872),
    [sym__binary_star] = ACTIONS(7872),
    [anon_sym_unless] = ACTIONS(7872),
    [anon_sym_PLUS] = ACTIONS(7870),
    [anon_sym_AMP] = ACTIONS(7870),
    [anon_sym_PERCENT] = ACTIONS(7870),
    [anon_sym_COLON_COLON2] = ACTIONS(7872),
    [anon_sym_rescue] = ACTIONS(7872),
    [anon_sym_PERCENT_EQ] = ACTIONS(7872),
    [anon_sym_LT_LT_EQ] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_DOT] = ACTIONS(7870),
    [anon_sym_BANG_TILDE] = ACTIONS(7872),
    [anon_sym_LBRACE] = ACTIONS(7872),
    [anon_sym_COLON2] = ACTIONS(7870),
    [anon_sym_while] = ACTIONS(7872),
    [sym__heredoc_body_start] = ACTIONS(7872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7872),
    [anon_sym_CARET_EQ] = ACTIONS(7872),
    [anon_sym_AMP_DOT] = ACTIONS(7872),
    [anon_sym_LT_EQ] = ACTIONS(7870),
    [anon_sym_PIPE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7870),
    [anon_sym_EQ] = ACTIONS(7870),
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_in] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [anon_sym_COMMA] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7870),
    [anon_sym_SEMI] = ACTIONS(7872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7872),
    [anon_sym_or] = ACTIONS(7872),
    [anon_sym_GT] = ACTIONS(7870),
    [anon_sym_PIPE_EQ] = ACTIONS(7872),
    [anon_sym_PLUS_EQ] = ACTIONS(7872),
    [anon_sym_STAR_EQ] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_and] = ACTIONS(7872),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_GT_EQ] = ACTIONS(7872),
    [anon_sym_LBRACK] = ACTIONS(7872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7872),
    [anon_sym_DASH_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7872),
    [anon_sym_BANG_EQ] = ACTIONS(7872),
    [anon_sym_STAR_STAR] = ACTIONS(7870),
    [anon_sym_LT_EQ_GT] = ACTIONS(7872),
    [sym__binary_minus] = ACTIONS(7872),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_if] = ACTIONS(7872),
    [anon_sym_CARET] = ACTIONS(7870),
  },
  [11340] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16945),
  },
  [11341] = {
    [anon_sym_SLASH] = ACTIONS(7876),
    [anon_sym_RBRACK] = ACTIONS(7878),
    [anon_sym_until] = ACTIONS(7878),
    [anon_sym_AMP_EQ] = ACTIONS(7878),
    [anon_sym_GT_GT_EQ] = ACTIONS(7878),
    [anon_sym_SLASH_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7878),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_EQ_TILDE] = ACTIONS(7878),
    [anon_sym_LT_LT] = ACTIONS(7876),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [sym__binary_star] = ACTIONS(7878),
    [anon_sym_unless] = ACTIONS(7878),
    [anon_sym_PLUS] = ACTIONS(7876),
    [anon_sym_AMP] = ACTIONS(7876),
    [anon_sym_PERCENT] = ACTIONS(7876),
    [anon_sym_COLON_COLON2] = ACTIONS(7878),
    [anon_sym_rescue] = ACTIONS(7878),
    [anon_sym_PERCENT_EQ] = ACTIONS(7878),
    [anon_sym_LT_LT_EQ] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_DOT] = ACTIONS(7876),
    [anon_sym_BANG_TILDE] = ACTIONS(7878),
    [anon_sym_LBRACE] = ACTIONS(7878),
    [anon_sym_COLON2] = ACTIONS(7876),
    [anon_sym_while] = ACTIONS(7878),
    [sym__heredoc_body_start] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7878),
    [anon_sym_CARET_EQ] = ACTIONS(7878),
    [anon_sym_AMP_DOT] = ACTIONS(7878),
    [anon_sym_LT_EQ] = ACTIONS(7876),
    [anon_sym_PIPE] = ACTIONS(7876),
    [anon_sym_DOT_DOT] = ACTIONS(7876),
    [anon_sym_EQ] = ACTIONS(7876),
    [anon_sym_LT] = ACTIONS(7876),
    [anon_sym_in] = ACTIONS(7878),
    [anon_sym_QMARK] = ACTIONS(7878),
    [anon_sym_COMMA] = ACTIONS(7878),
    [anon_sym_GT_GT] = ACTIONS(7876),
    [anon_sym_SEMI] = ACTIONS(7878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7878),
    [anon_sym_or] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(7876),
    [anon_sym_PIPE_EQ] = ACTIONS(7878),
    [anon_sym_PLUS_EQ] = ACTIONS(7878),
    [anon_sym_STAR_EQ] = ACTIONS(7878),
    [anon_sym_EQ_EQ] = ACTIONS(7876),
    [anon_sym_and] = ACTIONS(7878),
    [anon_sym_PIPE_PIPE] = ACTIONS(7876),
    [anon_sym_GT_EQ] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(7878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7878),
    [anon_sym_DASH_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7878),
    [anon_sym_BANG_EQ] = ACTIONS(7878),
    [anon_sym_STAR_STAR] = ACTIONS(7876),
    [anon_sym_LT_EQ_GT] = ACTIONS(7878),
    [sym__binary_minus] = ACTIONS(7878),
    [anon_sym_AMP_AMP] = ACTIONS(7876),
    [anon_sym_if] = ACTIONS(7878),
    [anon_sym_CARET] = ACTIONS(7876),
  },
  [11342] = {
    [aux_sym_symbol_array_repeat1] = STATE(2300),
    [sym_comment] = ACTIONS(3),
    [aux_sym_string_array_token1] = ACTIONS(16947),
    [sym__string_end] = ACTIONS(16945),
  },
  [11343] = {
    [anon_sym_SLASH] = ACTIONS(8222),
    [anon_sym_RBRACK] = ACTIONS(8224),
    [anon_sym_until] = ACTIONS(8224),
    [anon_sym_AMP_EQ] = ACTIONS(8224),
    [anon_sym_GT_GT_EQ] = ACTIONS(8224),
    [anon_sym_SLASH_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8224),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_EQ_TILDE] = ACTIONS(8224),
    [anon_sym_LT_LT] = ACTIONS(8222),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [sym__binary_star] = ACTIONS(8224),
    [anon_sym_unless] = ACTIONS(8224),
    [anon_sym_PLUS] = ACTIONS(8222),
    [anon_sym_AMP] = ACTIONS(8222),
    [anon_sym_PERCENT] = ACTIONS(8222),
    [anon_sym_COLON_COLON2] = ACTIONS(8224),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_PERCENT_EQ] = ACTIONS(8224),
    [anon_sym_LT_LT_EQ] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_DOT] = ACTIONS(8222),
    [anon_sym_BANG_TILDE] = ACTIONS(8224),
    [anon_sym_LBRACE] = ACTIONS(8224),
    [anon_sym_COLON2] = ACTIONS(8222),
    [anon_sym_while] = ACTIONS(8224),
    [sym__heredoc_body_start] = ACTIONS(8224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8224),
    [anon_sym_CARET_EQ] = ACTIONS(8224),
    [anon_sym_AMP_DOT] = ACTIONS(8224),
    [anon_sym_LT_EQ] = ACTIONS(8222),
    [anon_sym_PIPE] = ACTIONS(8222),
    [anon_sym_DOT_DOT] = ACTIONS(8222),
    [anon_sym_EQ] = ACTIONS(8222),
    [anon_sym_LT] = ACTIONS(8222),
    [anon_sym_in] = ACTIONS(8224),
    [anon_sym_QMARK] = ACTIONS(8224),
    [anon_sym_COMMA] = ACTIONS(8224),
    [anon_sym_GT_GT] = ACTIONS(8222),
    [anon_sym_SEMI] = ACTIONS(8224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8224),
    [anon_sym_or] = ACTIONS(8224),
    [anon_sym_GT] = ACTIONS(8222),
    [anon_sym_PIPE_EQ] = ACTIONS(8224),
    [anon_sym_PLUS_EQ] = ACTIONS(8224),
    [anon_sym_STAR_EQ] = ACTIONS(8224),
    [anon_sym_EQ_EQ] = ACTIONS(8222),
    [anon_sym_and] = ACTIONS(8224),
    [anon_sym_PIPE_PIPE] = ACTIONS(8222),
    [anon_sym_GT_EQ] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(8224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8224),
    [anon_sym_DASH_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8224),
    [anon_sym_BANG_EQ] = ACTIONS(8224),
    [anon_sym_STAR_STAR] = ACTIONS(8222),
    [anon_sym_LT_EQ_GT] = ACTIONS(8224),
    [sym__binary_minus] = ACTIONS(8224),
    [anon_sym_AMP_AMP] = ACTIONS(8222),
    [anon_sym_if] = ACTIONS(8224),
    [anon_sym_CARET] = ACTIONS(8222),
  },
  [11344] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(16949),
  },
  [11345] = {
    [anon_sym_SLASH] = ACTIONS(8849),
    [anon_sym_RBRACK] = ACTIONS(8851),
    [anon_sym_until] = ACTIONS(8851),
    [anon_sym_AMP_EQ] = ACTIONS(8851),
    [anon_sym_GT_GT_EQ] = ACTIONS(8851),
    [anon_sym_SLASH_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8851),
    [anon_sym_RPAREN] = ACTIONS(8851),
    [anon_sym_EQ_TILDE] = ACTIONS(8851),
    [anon_sym_LT_LT] = ACTIONS(8849),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [sym__binary_star] = ACTIONS(8851),
    [anon_sym_unless] = ACTIONS(8851),
    [anon_sym_PLUS] = ACTIONS(8849),
    [anon_sym_AMP] = ACTIONS(8849),
    [anon_sym_PERCENT] = ACTIONS(8849),
    [anon_sym_COLON_COLON2] = ACTIONS(8851),
    [anon_sym_rescue] = ACTIONS(8851),
    [anon_sym_PERCENT_EQ] = ACTIONS(8851),
    [anon_sym_LT_LT_EQ] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_DOT] = ACTIONS(8849),
    [anon_sym_BANG_TILDE] = ACTIONS(8851),
    [anon_sym_LBRACE] = ACTIONS(8851),
    [anon_sym_COLON2] = ACTIONS(8849),
    [anon_sym_while] = ACTIONS(8851),
    [sym__heredoc_body_start] = ACTIONS(8851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8851),
    [anon_sym_CARET_EQ] = ACTIONS(8851),
    [anon_sym_AMP_DOT] = ACTIONS(8851),
    [anon_sym_LT_EQ] = ACTIONS(8849),
    [anon_sym_PIPE] = ACTIONS(8849),
    [anon_sym_DOT_DOT] = ACTIONS(8849),
    [anon_sym_EQ] = ACTIONS(8849),
    [anon_sym_LT] = ACTIONS(8849),
    [anon_sym_in] = ACTIONS(8851),
    [anon_sym_QMARK] = ACTIONS(8851),
    [anon_sym_COMMA] = ACTIONS(8851),
    [anon_sym_GT_GT] = ACTIONS(8849),
    [anon_sym_SEMI] = ACTIONS(8851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8851),
    [anon_sym_or] = ACTIONS(8851),
    [anon_sym_GT] = ACTIONS(8849),
    [anon_sym_PIPE_EQ] = ACTIONS(8851),
    [anon_sym_PLUS_EQ] = ACTIONS(8851),
    [anon_sym_STAR_EQ] = ACTIONS(8851),
    [anon_sym_EQ_EQ] = ACTIONS(8849),
    [anon_sym_and] = ACTIONS(8851),
    [anon_sym_PIPE_PIPE] = ACTIONS(8849),
    [anon_sym_GT_EQ] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(8851),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8851),
    [anon_sym_DASH_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8851),
    [anon_sym_BANG_EQ] = ACTIONS(8851),
    [anon_sym_STAR_STAR] = ACTIONS(8849),
    [anon_sym_LT_EQ_GT] = ACTIONS(8851),
    [sym__binary_minus] = ACTIONS(8851),
    [anon_sym_AMP_AMP] = ACTIONS(8849),
    [anon_sym_if] = ACTIONS(8851),
    [anon_sym_CARET] = ACTIONS(8849),
  },
  [11346] = {
    [anon_sym_SLASH] = ACTIONS(8870),
    [anon_sym_RBRACK] = ACTIONS(8872),
    [anon_sym_until] = ACTIONS(8872),
    [anon_sym_AMP_EQ] = ACTIONS(8872),
    [anon_sym_GT_GT_EQ] = ACTIONS(8872),
    [anon_sym_SLASH_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8872),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_EQ_TILDE] = ACTIONS(8872),
    [anon_sym_LT_LT] = ACTIONS(8870),
    [anon_sym_RBRACE] = ACTIONS(8872),
    [sym__binary_star] = ACTIONS(8872),
    [anon_sym_unless] = ACTIONS(8872),
    [anon_sym_PLUS] = ACTIONS(8870),
    [anon_sym_AMP] = ACTIONS(8870),
    [anon_sym_PERCENT] = ACTIONS(8870),
    [anon_sym_COLON_COLON2] = ACTIONS(8872),
    [anon_sym_rescue] = ACTIONS(8872),
    [anon_sym_PERCENT_EQ] = ACTIONS(8872),
    [anon_sym_LT_LT_EQ] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_DOT] = ACTIONS(8870),
    [anon_sym_BANG_TILDE] = ACTIONS(8872),
    [anon_sym_LBRACE] = ACTIONS(8872),
    [anon_sym_COLON2] = ACTIONS(8870),
    [anon_sym_while] = ACTIONS(8872),
    [sym__heredoc_body_start] = ACTIONS(8872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8872),
    [anon_sym_CARET_EQ] = ACTIONS(8872),
    [anon_sym_AMP_DOT] = ACTIONS(8872),
    [anon_sym_LT_EQ] = ACTIONS(8870),
    [anon_sym_PIPE] = ACTIONS(8870),
    [anon_sym_DOT_DOT] = ACTIONS(8870),
    [anon_sym_EQ] = ACTIONS(8870),
    [anon_sym_LT] = ACTIONS(8870),
    [anon_sym_in] = ACTIONS(8872),
    [anon_sym_QMARK] = ACTIONS(8872),
    [anon_sym_COMMA] = ACTIONS(8872),
    [anon_sym_GT_GT] = ACTIONS(8870),
    [anon_sym_SEMI] = ACTIONS(8872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8872),
    [anon_sym_or] = ACTIONS(8872),
    [anon_sym_GT] = ACTIONS(8870),
    [anon_sym_PIPE_EQ] = ACTIONS(8872),
    [anon_sym_PLUS_EQ] = ACTIONS(8872),
    [anon_sym_STAR_EQ] = ACTIONS(8872),
    [anon_sym_EQ_EQ] = ACTIONS(8870),
    [anon_sym_and] = ACTIONS(8872),
    [anon_sym_PIPE_PIPE] = ACTIONS(8870),
    [anon_sym_GT_EQ] = ACTIONS(8872),
    [anon_sym_LBRACK] = ACTIONS(8872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8872),
    [anon_sym_DASH_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8872),
    [anon_sym_BANG_EQ] = ACTIONS(8872),
    [anon_sym_STAR_STAR] = ACTIONS(8870),
    [anon_sym_LT_EQ_GT] = ACTIONS(8872),
    [sym__binary_minus] = ACTIONS(8872),
    [anon_sym_AMP_AMP] = ACTIONS(8870),
    [anon_sym_if] = ACTIONS(8872),
    [anon_sym_CARET] = ACTIONS(8870),
  },
  [11347] = {
    [anon_sym_end] = ACTIONS(16951),
    [sym_comment] = ACTIONS(49),
  },
  [11348] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(11980),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(16953),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [11349] = {
    [anon_sym_DOT] = ACTIONS(16955),
    [anon_sym_COLON_COLON] = ACTIONS(16955),
    [sym_comment] = ACTIONS(49),
  },
  [11350] = {
    [anon_sym_SLASH] = ACTIONS(9600),
    [anon_sym_RBRACK] = ACTIONS(9602),
    [anon_sym_until] = ACTIONS(9602),
    [anon_sym_AMP_EQ] = ACTIONS(9602),
    [anon_sym_GT_GT_EQ] = ACTIONS(9602),
    [anon_sym_SLASH_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9602),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_EQ_TILDE] = ACTIONS(9602),
    [anon_sym_LT_LT] = ACTIONS(9600),
    [anon_sym_RBRACE] = ACTIONS(9602),
    [sym__binary_star] = ACTIONS(9602),
    [anon_sym_unless] = ACTIONS(9602),
    [anon_sym_PLUS] = ACTIONS(9600),
    [anon_sym_AMP] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9600),
    [anon_sym_COLON_COLON2] = ACTIONS(9602),
    [anon_sym_rescue] = ACTIONS(9602),
    [anon_sym_PERCENT_EQ] = ACTIONS(9602),
    [anon_sym_LT_LT_EQ] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_DOT] = ACTIONS(9600),
    [anon_sym_BANG_TILDE] = ACTIONS(9602),
    [anon_sym_LBRACE] = ACTIONS(9602),
    [anon_sym_COLON2] = ACTIONS(9600),
    [anon_sym_while] = ACTIONS(9602),
    [sym__heredoc_body_start] = ACTIONS(9602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9602),
    [anon_sym_CARET_EQ] = ACTIONS(9602),
    [anon_sym_AMP_DOT] = ACTIONS(9602),
    [anon_sym_LT_EQ] = ACTIONS(9600),
    [anon_sym_PIPE] = ACTIONS(9600),
    [anon_sym_DOT_DOT] = ACTIONS(9600),
    [anon_sym_EQ] = ACTIONS(9600),
    [anon_sym_LT] = ACTIONS(9600),
    [anon_sym_in] = ACTIONS(9602),
    [anon_sym_QMARK] = ACTIONS(9602),
    [anon_sym_COMMA] = ACTIONS(9602),
    [anon_sym_GT_GT] = ACTIONS(9600),
    [anon_sym_SEMI] = ACTIONS(9602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9602),
    [anon_sym_or] = ACTIONS(9602),
    [anon_sym_GT] = ACTIONS(9600),
    [anon_sym_PIPE_EQ] = ACTIONS(9602),
    [anon_sym_PLUS_EQ] = ACTIONS(9602),
    [anon_sym_STAR_EQ] = ACTIONS(9602),
    [anon_sym_EQ_EQ] = ACTIONS(9600),
    [anon_sym_and] = ACTIONS(9602),
    [anon_sym_PIPE_PIPE] = ACTIONS(9600),
    [anon_sym_GT_EQ] = ACTIONS(9602),
    [anon_sym_LBRACK] = ACTIONS(9602),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9602),
    [anon_sym_DASH_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9602),
    [anon_sym_BANG_EQ] = ACTIONS(9602),
    [anon_sym_STAR_STAR] = ACTIONS(9600),
    [anon_sym_LT_EQ_GT] = ACTIONS(9602),
    [sym__binary_minus] = ACTIONS(9602),
    [anon_sym_AMP_AMP] = ACTIONS(9600),
    [anon_sym_if] = ACTIONS(9602),
    [anon_sym_CARET] = ACTIONS(9600),
  },
  [11351] = {
    [anon_sym_SLASH] = ACTIONS(9606),
    [anon_sym_RBRACK] = ACTIONS(9608),
    [anon_sym_until] = ACTIONS(9608),
    [anon_sym_AMP_EQ] = ACTIONS(9608),
    [anon_sym_GT_GT_EQ] = ACTIONS(9608),
    [anon_sym_SLASH_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9608),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_EQ_TILDE] = ACTIONS(9608),
    [anon_sym_LT_LT] = ACTIONS(9606),
    [anon_sym_RBRACE] = ACTIONS(9608),
    [sym__binary_star] = ACTIONS(9608),
    [anon_sym_unless] = ACTIONS(9608),
    [anon_sym_PLUS] = ACTIONS(9606),
    [anon_sym_AMP] = ACTIONS(9606),
    [anon_sym_PERCENT] = ACTIONS(9606),
    [anon_sym_COLON_COLON2] = ACTIONS(9608),
    [anon_sym_rescue] = ACTIONS(9608),
    [anon_sym_PERCENT_EQ] = ACTIONS(9608),
    [anon_sym_LT_LT_EQ] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_DOT] = ACTIONS(9606),
    [anon_sym_BANG_TILDE] = ACTIONS(9608),
    [anon_sym_LBRACE] = ACTIONS(9608),
    [anon_sym_COLON2] = ACTIONS(9606),
    [anon_sym_while] = ACTIONS(9608),
    [sym__heredoc_body_start] = ACTIONS(9608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9608),
    [anon_sym_CARET_EQ] = ACTIONS(9608),
    [anon_sym_AMP_DOT] = ACTIONS(9608),
    [anon_sym_LT_EQ] = ACTIONS(9606),
    [anon_sym_PIPE] = ACTIONS(9606),
    [anon_sym_DOT_DOT] = ACTIONS(9606),
    [anon_sym_EQ] = ACTIONS(9606),
    [anon_sym_LT] = ACTIONS(9606),
    [anon_sym_in] = ACTIONS(9608),
    [anon_sym_QMARK] = ACTIONS(9608),
    [anon_sym_COMMA] = ACTIONS(9608),
    [anon_sym_GT_GT] = ACTIONS(9606),
    [anon_sym_SEMI] = ACTIONS(9608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9608),
    [anon_sym_or] = ACTIONS(9608),
    [anon_sym_GT] = ACTIONS(9606),
    [anon_sym_PIPE_EQ] = ACTIONS(9608),
    [anon_sym_PLUS_EQ] = ACTIONS(9608),
    [anon_sym_STAR_EQ] = ACTIONS(9608),
    [anon_sym_EQ_EQ] = ACTIONS(9606),
    [anon_sym_and] = ACTIONS(9608),
    [anon_sym_PIPE_PIPE] = ACTIONS(9606),
    [anon_sym_GT_EQ] = ACTIONS(9608),
    [anon_sym_LBRACK] = ACTIONS(9608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9608),
    [anon_sym_DASH_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9608),
    [anon_sym_BANG_EQ] = ACTIONS(9608),
    [anon_sym_STAR_STAR] = ACTIONS(9606),
    [anon_sym_LT_EQ_GT] = ACTIONS(9608),
    [sym__binary_minus] = ACTIONS(9608),
    [anon_sym_AMP_AMP] = ACTIONS(9606),
    [anon_sym_if] = ACTIONS(9608),
    [anon_sym_CARET] = ACTIONS(9606),
  },
  [11352] = {
    [anon_sym_SLASH] = ACTIONS(10925),
    [anon_sym_RBRACK] = ACTIONS(10927),
    [anon_sym_until] = ACTIONS(10927),
    [anon_sym_AMP_EQ] = ACTIONS(10927),
    [anon_sym_GT_GT_EQ] = ACTIONS(10927),
    [anon_sym_SLASH_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10927),
    [anon_sym_RPAREN] = ACTIONS(10927),
    [anon_sym_EQ_TILDE] = ACTIONS(10927),
    [anon_sym_LT_LT] = ACTIONS(10925),
    [anon_sym_RBRACE] = ACTIONS(10927),
    [sym__binary_star] = ACTIONS(10927),
    [anon_sym_unless] = ACTIONS(10927),
    [anon_sym_PLUS] = ACTIONS(10925),
    [anon_sym_AMP] = ACTIONS(10925),
    [anon_sym_PERCENT] = ACTIONS(10925),
    [anon_sym_COLON_COLON2] = ACTIONS(10927),
    [anon_sym_rescue] = ACTIONS(10927),
    [anon_sym_PERCENT_EQ] = ACTIONS(10927),
    [anon_sym_LT_LT_EQ] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_DOT] = ACTIONS(10925),
    [anon_sym_BANG_TILDE] = ACTIONS(10927),
    [anon_sym_LBRACE] = ACTIONS(10927),
    [anon_sym_COLON2] = ACTIONS(10925),
    [anon_sym_while] = ACTIONS(10927),
    [sym__heredoc_body_start] = ACTIONS(10927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10927),
    [anon_sym_CARET_EQ] = ACTIONS(10927),
    [anon_sym_AMP_DOT] = ACTIONS(10927),
    [anon_sym_LT_EQ] = ACTIONS(10925),
    [anon_sym_PIPE] = ACTIONS(10925),
    [anon_sym_DOT_DOT] = ACTIONS(10925),
    [anon_sym_EQ] = ACTIONS(10925),
    [anon_sym_LT] = ACTIONS(10925),
    [anon_sym_in] = ACTIONS(10927),
    [anon_sym_QMARK] = ACTIONS(10927),
    [anon_sym_COMMA] = ACTIONS(10927),
    [anon_sym_GT_GT] = ACTIONS(10925),
    [anon_sym_SEMI] = ACTIONS(10927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10927),
    [anon_sym_or] = ACTIONS(10927),
    [anon_sym_GT] = ACTIONS(10925),
    [anon_sym_PIPE_EQ] = ACTIONS(10927),
    [anon_sym_PLUS_EQ] = ACTIONS(10927),
    [anon_sym_STAR_EQ] = ACTIONS(10927),
    [anon_sym_EQ_EQ] = ACTIONS(10925),
    [anon_sym_and] = ACTIONS(10927),
    [anon_sym_PIPE_PIPE] = ACTIONS(10925),
    [anon_sym_GT_EQ] = ACTIONS(10927),
    [anon_sym_LBRACK] = ACTIONS(10927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10927),
    [anon_sym_DASH_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10927),
    [anon_sym_BANG_EQ] = ACTIONS(10927),
    [anon_sym_STAR_STAR] = ACTIONS(10925),
    [anon_sym_LT_EQ_GT] = ACTIONS(10927),
    [sym__binary_minus] = ACTIONS(10927),
    [anon_sym_AMP_AMP] = ACTIONS(10925),
    [anon_sym_if] = ACTIONS(10927),
    [anon_sym_CARET] = ACTIONS(10925),
  },
  [11353] = {
    [anon_sym_end] = ACTIONS(16957),
    [sym_comment] = ACTIONS(49),
  },
  [11354] = {
    [sym_assignment] = STATE(10069),
    [sym_unary] = STATE(10069),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(10069),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(10069),
    [sym_conditional] = STATE(10069),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_return] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_true] = STATE(4906),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(10069),
    [sym_binary] = STATE(10069),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [sym_global_variable] = ACTIONS(8146),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8122),
    [sym_character] = ACTIONS(8138),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [11355] = {
    [aux_sym_exceptions_repeat1] = STATE(11984),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16959),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11356] = {
    [sym_assignment] = STATE(11985),
    [sym_unary] = STATE(11985),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4906),
    [sym_singleton_class] = STATE(4908),
    [sym_module] = STATE(4908),
    [sym_chained_string] = STATE(4908),
    [sym_until] = STATE(4908),
    [sym_regex] = STATE(4908),
    [sym_for] = STATE(4908),
    [sym_symbol] = STATE(4908),
    [sym_if] = STATE(4908),
    [sym_begin] = STATE(4908),
    [sym__arg] = STATE(11985),
    [sym__primary] = STATE(4908),
    [sym_method_call] = STATE(4906),
    [sym_operator_assignment] = STATE(11985),
    [sym_conditional] = STATE(11985),
    [sym_method] = STATE(4908),
    [sym_singleton_method] = STATE(4908),
    [sym__variable] = STATE(4909),
    [sym_left_assignment_list] = STATE(4910),
    [sym_rational] = STATE(4908),
    [sym_true] = STATE(4906),
    [sym_return] = STATE(4908),
    [sym_subshell] = STATE(4908),
    [sym_yield] = STATE(4908),
    [sym_string] = STATE(4911),
    [sym_unless] = STATE(4908),
    [sym_lambda] = STATE(4908),
    [sym_parenthesized_statements] = STATE(4908),
    [sym_element_reference] = STATE(4906),
    [sym_range] = STATE(11985),
    [sym_binary] = STATE(11985),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(4908),
    [sym_break] = STATE(4908),
    [sym_next] = STATE(4908),
    [sym_string_array] = STATE(4908),
    [sym_while] = STATE(4908),
    [sym_case] = STATE(4908),
    [sym_symbol_array] = STATE(4908),
    [sym_array] = STATE(4908),
    [sym_hash] = STATE(4908),
    [sym_false] = STATE(4906),
    [sym_nil] = STATE(4906),
    [sym_scope_resolution] = STATE(4909),
    [sym_call] = STATE(4909),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8108),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8110),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8118),
    [anon_sym_not] = ACTIONS(8120),
    [sym_self] = ACTIONS(8122),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8126),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8138),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8138),
    [anon_sym_PLUS] = ACTIONS(8144),
    [anon_sym_TILDE] = ACTIONS(8118),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8146),
    [sym_character] = ACTIONS(8138),
    [sym_super] = ACTIONS(8122),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8152),
    [anon_sym_next] = ACTIONS(8154),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8108),
    [sym_constant] = ACTIONS(8122),
    [anon_sym_defined_QMARK] = ACTIONS(8158),
    [sym_instance_variable] = ACTIONS(8146),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(7966),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8122),
    [sym_redo] = ACTIONS(8108),
    [sym_class_variable] = ACTIONS(8146),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8174),
  },
  [11357] = {
    [aux_sym_exceptions_repeat1] = STATE(11357),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16961),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11358] = {
    [anon_sym_SLASH] = ACTIONS(8192),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8194),
    [anon_sym_EQ_TILDE] = ACTIONS(8194),
    [anon_sym_LT_LT] = ACTIONS(8196),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(8198),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(8200),
    [anon_sym_AMP] = ACTIONS(8202),
    [anon_sym_PERCENT] = ACTIONS(8192),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(8194),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_DOT_DOT] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(8204),
    [anon_sym_QMARK] = ACTIONS(8210),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(8196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8212),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(8204),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(8214),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8214),
    [anon_sym_GT_EQ] = ACTIONS(8216),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(8194),
    [anon_sym_STAR_STAR] = ACTIONS(8192),
    [anon_sym_LT_EQ_GT] = ACTIONS(8194),
    [sym__binary_minus] = ACTIONS(8218),
    [anon_sym_AMP_AMP] = ACTIONS(8214),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(8206),
  },
  [11359] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [anon_sym_RBRACK] = ACTIONS(16424),
    [anon_sym_in] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
    [anon_sym_EQ] = ACTIONS(16422),
  },
  [11360] = {
    [sym_assignment] = STATE(10096),
    [sym_unary] = STATE(10096),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(10096),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(10096),
    [sym_conditional] = STATE(10096),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_return] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_string] = STATE(771),
    [sym_true] = STATE(4999),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(10096),
    [sym_binary] = STATE(10096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [sym_global_variable] = ACTIONS(1441),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1413),
    [sym_character] = ACTIONS(1431),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [11361] = {
    [aux_sym_exceptions_repeat1] = STATE(11986),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16964),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11362] = {
    [sym_assignment] = STATE(11987),
    [sym_unary] = STATE(11987),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(4999),
    [sym_singleton_class] = STATE(768),
    [sym_module] = STATE(768),
    [sym_chained_string] = STATE(768),
    [sym_until] = STATE(768),
    [sym_regex] = STATE(768),
    [sym_for] = STATE(768),
    [sym_symbol] = STATE(768),
    [sym_if] = STATE(768),
    [sym_begin] = STATE(768),
    [sym__arg] = STATE(11987),
    [sym__primary] = STATE(768),
    [sym_method_call] = STATE(4999),
    [sym_operator_assignment] = STATE(11987),
    [sym_conditional] = STATE(11987),
    [sym_method] = STATE(768),
    [sym_singleton_method] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_left_assignment_list] = STATE(5001),
    [sym_rational] = STATE(768),
    [sym_true] = STATE(4999),
    [sym_return] = STATE(768),
    [sym_subshell] = STATE(768),
    [sym_yield] = STATE(768),
    [sym_string] = STATE(771),
    [sym_unless] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_parenthesized_statements] = STATE(768),
    [sym_element_reference] = STATE(4999),
    [sym_range] = STATE(11987),
    [sym_binary] = STATE(11987),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(768),
    [sym_break] = STATE(768),
    [sym_next] = STATE(768),
    [sym_string_array] = STATE(768),
    [sym_while] = STATE(768),
    [sym_case] = STATE(768),
    [sym_symbol_array] = STATE(768),
    [sym_array] = STATE(768),
    [sym_hash] = STATE(768),
    [sym_false] = STATE(4999),
    [sym_nil] = STATE(4999),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1397),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8287),
    [anon_sym_not] = ACTIONS(8289),
    [sym_self] = ACTIONS(1413),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(8291),
    [anon_sym_TILDE] = ACTIONS(8287),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1441),
    [sym_character] = ACTIONS(1431),
    [sym_super] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8293),
    [anon_sym_next] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1397),
    [sym_constant] = ACTIONS(1413),
    [anon_sym_defined_QMARK] = ACTIONS(8295),
    [sym_instance_variable] = ACTIONS(1441),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1413),
    [sym_redo] = ACTIONS(1397),
    [sym_class_variable] = ACTIONS(1441),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1471),
  },
  [11363] = {
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_SLASH] = ACTIONS(15291),
    [anon_sym_RBRACK] = ACTIONS(15291),
    [anon_sym_in] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15291),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15291),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_AMP_AMP] = ACTIONS(15291),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15291),
    [anon_sym_EQ] = ACTIONS(15289),
  },
  [11364] = {
    [anon_sym_end] = ACTIONS(16966),
    [sym_comment] = ACTIONS(49),
  },
  [11365] = {
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_SLASH] = ACTIONS(15831),
    [anon_sym_RBRACK] = ACTIONS(15831),
    [anon_sym_in] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15831),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15831),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_COLON2] = ACTIONS(15829),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15831),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_AMP_AMP] = ACTIONS(15831),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15831),
    [anon_sym_EQ] = ACTIONS(15829),
  },
  [11366] = {
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_SLASH] = ACTIONS(15676),
    [anon_sym_RBRACK] = ACTIONS(15676),
    [anon_sym_in] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15676),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15676),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_COLON2] = ACTIONS(15674),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15676),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_AMP_AMP] = ACTIONS(15676),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15676),
    [anon_sym_EQ] = ACTIONS(15674),
  },
  [11367] = {
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_SLASH] = ACTIONS(14596),
    [anon_sym_RBRACK] = ACTIONS(14596),
    [anon_sym_in] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14596),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14596),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_COLON2] = ACTIONS(14594),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14596),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_AMP_AMP] = ACTIONS(14596),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14596),
    [anon_sym_EQ] = ACTIONS(14594),
  },
  [11368] = {
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_SLASH] = ACTIONS(15029),
    [anon_sym_RBRACK] = ACTIONS(15029),
    [anon_sym_in] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15029),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15029),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_COLON2] = ACTIONS(15027),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15029),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_AMP_AMP] = ACTIONS(15029),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15029),
    [anon_sym_EQ] = ACTIONS(15027),
  },
  [11369] = {
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_SLASH] = ACTIONS(15175),
    [anon_sym_RBRACK] = ACTIONS(15175),
    [anon_sym_in] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15175),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15175),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_AMP_AMP] = ACTIONS(15175),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15175),
    [anon_sym_EQ] = ACTIONS(15173),
  },
  [11370] = {
    [anon_sym_end] = ACTIONS(16968),
    [sym_comment] = ACTIONS(49),
  },
  [11371] = {
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_SLASH] = ACTIONS(15209),
    [anon_sym_RBRACK] = ACTIONS(15209),
    [anon_sym_in] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15209),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15209),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_COLON2] = ACTIONS(15207),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15209),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_AMP_AMP] = ACTIONS(15209),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15209),
    [anon_sym_EQ] = ACTIONS(15207),
  },
  [11372] = {
    [anon_sym_SLASH] = ACTIONS(15173),
    [anon_sym_RBRACK] = ACTIONS(15175),
    [anon_sym_until] = ACTIONS(15175),
    [anon_sym_AMP_EQ] = ACTIONS(15175),
    [anon_sym_GT_GT_EQ] = ACTIONS(15175),
    [anon_sym_SLASH_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15175),
    [anon_sym_RPAREN] = ACTIONS(15175),
    [anon_sym_EQ_TILDE] = ACTIONS(15175),
    [anon_sym_LT_LT] = ACTIONS(15173),
    [sym__binary_star] = ACTIONS(15175),
    [anon_sym_RBRACE] = ACTIONS(15175),
    [anon_sym_unless] = ACTIONS(15175),
    [anon_sym_PLUS] = ACTIONS(15173),
    [anon_sym_AMP] = ACTIONS(15173),
    [anon_sym_PERCENT] = ACTIONS(15173),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [anon_sym_rescue] = ACTIONS(15175),
    [anon_sym_PERCENT_EQ] = ACTIONS(15175),
    [anon_sym_LT_LT_EQ] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15173),
    [anon_sym_BANG_TILDE] = ACTIONS(15175),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_COLON2] = ACTIONS(15173),
    [anon_sym_while] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15175),
    [anon_sym_CARET_EQ] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_LT_EQ] = ACTIONS(15173),
    [anon_sym_PIPE] = ACTIONS(15173),
    [anon_sym_DOT_DOT] = ACTIONS(15173),
    [anon_sym_EQ] = ACTIONS(15173),
    [anon_sym_LT] = ACTIONS(15173),
    [anon_sym_in] = ACTIONS(15175),
    [anon_sym_QMARK] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_GT_GT] = ACTIONS(15173),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15175),
    [anon_sym_or] = ACTIONS(15175),
    [anon_sym_GT] = ACTIONS(15173),
    [anon_sym_PIPE_EQ] = ACTIONS(15175),
    [anon_sym_PLUS_EQ] = ACTIONS(15175),
    [anon_sym_STAR_EQ] = ACTIONS(15175),
    [anon_sym_EQ_EQ] = ACTIONS(15173),
    [anon_sym_and] = ACTIONS(15175),
    [anon_sym_PIPE_PIPE] = ACTIONS(15173),
    [anon_sym_GT_EQ] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15175),
    [anon_sym_DASH_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15175),
    [anon_sym_BANG_EQ] = ACTIONS(15175),
    [anon_sym_STAR_STAR] = ACTIONS(15173),
    [anon_sym_LT_EQ_GT] = ACTIONS(15175),
    [anon_sym_AMP_AMP] = ACTIONS(15173),
    [sym__binary_minus] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_CARET] = ACTIONS(15173),
  },
  [11373] = {
    [anon_sym_end] = ACTIONS(16970),
    [sym_comment] = ACTIONS(49),
  },
  [11374] = {
    [sym_assignment] = STATE(10141),
    [sym_unary] = STATE(10141),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(10141),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(10141),
    [sym_conditional] = STATE(10141),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_return] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_true] = STATE(5099),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(10141),
    [sym_binary] = STATE(10141),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [sym_global_variable] = ACTIONS(8407),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8399),
    [sym_character] = ACTIONS(8403),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [11375] = {
    [aux_sym_exceptions_repeat1] = STATE(11991),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_RBRACK] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16972),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11376] = {
    [sym_assignment] = STATE(11992),
    [sym_unary] = STATE(11992),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5099),
    [sym_singleton_class] = STATE(5101),
    [sym_module] = STATE(5101),
    [sym_chained_string] = STATE(5101),
    [sym_until] = STATE(5101),
    [sym_regex] = STATE(5101),
    [sym_for] = STATE(5101),
    [sym_symbol] = STATE(5101),
    [sym_if] = STATE(5101),
    [sym_begin] = STATE(5101),
    [sym__arg] = STATE(11992),
    [sym__primary] = STATE(5101),
    [sym_method_call] = STATE(5099),
    [sym_operator_assignment] = STATE(11992),
    [sym_conditional] = STATE(11992),
    [sym_method] = STATE(5101),
    [sym_singleton_method] = STATE(5101),
    [sym__variable] = STATE(5102),
    [sym_left_assignment_list] = STATE(5103),
    [sym_rational] = STATE(5101),
    [sym_true] = STATE(5099),
    [sym_return] = STATE(5101),
    [sym_subshell] = STATE(5101),
    [sym_yield] = STATE(5101),
    [sym_string] = STATE(5104),
    [sym_unless] = STATE(5101),
    [sym_lambda] = STATE(5101),
    [sym_parenthesized_statements] = STATE(5101),
    [sym_element_reference] = STATE(5099),
    [sym_range] = STATE(11992),
    [sym_binary] = STATE(11992),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5101),
    [sym_break] = STATE(5101),
    [sym_next] = STATE(5101),
    [sym_string_array] = STATE(5101),
    [sym_while] = STATE(5101),
    [sym_case] = STATE(5101),
    [sym_symbol_array] = STATE(5101),
    [sym_array] = STATE(5101),
    [sym_hash] = STATE(5101),
    [sym_false] = STATE(5099),
    [sym_nil] = STATE(5099),
    [sym_scope_resolution] = STATE(5102),
    [sym_call] = STATE(5102),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8391),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8393),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8395),
    [anon_sym_not] = ACTIONS(8397),
    [sym_self] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8401),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8403),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8403),
    [anon_sym_PLUS] = ACTIONS(8405),
    [anon_sym_TILDE] = ACTIONS(8395),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8407),
    [sym_character] = ACTIONS(8403),
    [sym_super] = ACTIONS(8399),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8409),
    [anon_sym_next] = ACTIONS(8411),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8391),
    [sym_constant] = ACTIONS(8399),
    [anon_sym_defined_QMARK] = ACTIONS(8413),
    [sym_instance_variable] = ACTIONS(8407),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1465),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8399),
    [sym_redo] = ACTIONS(8391),
    [sym_class_variable] = ACTIONS(8407),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8415),
  },
  [11377] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [anon_sym_RBRACK] = ACTIONS(16494),
    [anon_sym_in] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_EQ_GT] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_COLON2] = ACTIONS(16492),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
    [anon_sym_EQ] = ACTIONS(16492),
  },
  [11378] = {
    [anon_sym_SLASH] = ACTIONS(14594),
    [anon_sym_RBRACK] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_AMP_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT_EQ] = ACTIONS(14596),
    [anon_sym_SLASH_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14594),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14594),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14594),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_PERCENT_EQ] = ACTIONS(14596),
    [anon_sym_LT_LT_EQ] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_COLON2] = ACTIONS(14594),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_CARET_EQ] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_EQ] = ACTIONS(14594),
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_in] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14594),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_EQ_GT] = ACTIONS(14596),
    [anon_sym_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_PLUS_EQ] = ACTIONS(14596),
    [anon_sym_STAR_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14594),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14596),
    [anon_sym_DASH_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14594),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_AMP_AMP] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14594),
  },
  [11379] = {
    [anon_sym_SLASH] = ACTIONS(15027),
    [anon_sym_RBRACK] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_AMP_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT_EQ] = ACTIONS(15029),
    [anon_sym_SLASH_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15027),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15027),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15027),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_PERCENT_EQ] = ACTIONS(15029),
    [anon_sym_LT_LT_EQ] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_COLON2] = ACTIONS(15027),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_CARET_EQ] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_EQ] = ACTIONS(15027),
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_in] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15027),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_EQ_GT] = ACTIONS(15029),
    [anon_sym_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_PLUS_EQ] = ACTIONS(15029),
    [anon_sym_STAR_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15027),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15029),
    [anon_sym_DASH_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15027),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_AMP_AMP] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15027),
  },
  [11380] = {
    [anon_sym_SLASH] = ACTIONS(16422),
    [anon_sym_RBRACK] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_in] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11381] = {
    [anon_sym_SLASH] = ACTIONS(15207),
    [anon_sym_RBRACK] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_AMP_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT_EQ] = ACTIONS(15209),
    [anon_sym_SLASH_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15207),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15207),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15207),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_PERCENT_EQ] = ACTIONS(15209),
    [anon_sym_LT_LT_EQ] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_COLON2] = ACTIONS(15207),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_CARET_EQ] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_EQ] = ACTIONS(15207),
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_in] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15207),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_EQ_GT] = ACTIONS(15209),
    [anon_sym_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_PLUS_EQ] = ACTIONS(15209),
    [anon_sym_STAR_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15207),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15209),
    [anon_sym_DASH_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15207),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_AMP_AMP] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15207),
  },
  [11382] = {
    [anon_sym_SLASH] = ACTIONS(15289),
    [anon_sym_RBRACK] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_AMP_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT_EQ] = ACTIONS(15291),
    [anon_sym_SLASH_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15289),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15289),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15289),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_PERCENT_EQ] = ACTIONS(15291),
    [anon_sym_LT_LT_EQ] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_CARET_EQ] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_EQ] = ACTIONS(15289),
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_in] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15289),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_EQ_GT] = ACTIONS(15291),
    [anon_sym_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_PLUS_EQ] = ACTIONS(15291),
    [anon_sym_STAR_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15289),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15291),
    [anon_sym_DASH_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15289),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_AMP_AMP] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15289),
  },
  [11383] = {
    [anon_sym_end] = ACTIONS(16974),
    [sym_comment] = ACTIONS(49),
  },
  [11384] = {
    [anon_sym_SLASH] = ACTIONS(15674),
    [anon_sym_RBRACK] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_AMP_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT_EQ] = ACTIONS(15676),
    [anon_sym_SLASH_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15674),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15674),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15674),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_PERCENT_EQ] = ACTIONS(15676),
    [anon_sym_LT_LT_EQ] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_COLON2] = ACTIONS(15674),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_CARET_EQ] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_EQ] = ACTIONS(15674),
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_in] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15674),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_EQ_GT] = ACTIONS(15676),
    [anon_sym_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_PLUS_EQ] = ACTIONS(15676),
    [anon_sym_STAR_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15674),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15676),
    [anon_sym_DASH_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15674),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_AMP_AMP] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15674),
  },
  [11385] = {
    [anon_sym_SLASH] = ACTIONS(15829),
    [anon_sym_RBRACK] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_AMP_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT_EQ] = ACTIONS(15831),
    [anon_sym_SLASH_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15829),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15829),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15829),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_PERCENT_EQ] = ACTIONS(15831),
    [anon_sym_LT_LT_EQ] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_COLON2] = ACTIONS(15829),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_CARET_EQ] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_EQ] = ACTIONS(15829),
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_in] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15829),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_EQ_GT] = ACTIONS(15831),
    [anon_sym_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_PLUS_EQ] = ACTIONS(15831),
    [anon_sym_STAR_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15829),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15831),
    [anon_sym_DASH_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15829),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_AMP_AMP] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15829),
  },
  [11386] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
  },
  [11387] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_EQ_GT] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
  },
  [11388] = {
    [sym_assignment] = STATE(10201),
    [sym_unary] = STATE(10201),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(10201),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(10201),
    [sym_conditional] = STATE(10201),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_return] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_string] = STATE(960),
    [sym_true] = STATE(5305),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(10201),
    [sym_binary] = STATE(10201),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(4566),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [sym_global_variable] = ACTIONS(1741),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(1733),
    [sym_character] = ACTIONS(1737),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [11389] = {
    [aux_sym_exceptions_repeat1] = STATE(11994),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16976),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11390] = {
    [sym_assignment] = STATE(11995),
    [sym_unary] = STATE(11995),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5305),
    [sym_singleton_class] = STATE(957),
    [sym_module] = STATE(957),
    [sym_chained_string] = STATE(957),
    [sym_until] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_for] = STATE(957),
    [sym_symbol] = STATE(957),
    [sym_if] = STATE(957),
    [sym_begin] = STATE(957),
    [sym__arg] = STATE(11995),
    [sym__primary] = STATE(957),
    [sym_method_call] = STATE(5305),
    [sym_operator_assignment] = STATE(11995),
    [sym_conditional] = STATE(11995),
    [sym_method] = STATE(957),
    [sym_singleton_method] = STATE(957),
    [sym__variable] = STATE(958),
    [sym_left_assignment_list] = STATE(5307),
    [sym_rational] = STATE(957),
    [sym_true] = STATE(5305),
    [sym_return] = STATE(957),
    [sym_subshell] = STATE(957),
    [sym_yield] = STATE(957),
    [sym_string] = STATE(960),
    [sym_unless] = STATE(957),
    [sym_lambda] = STATE(957),
    [sym_parenthesized_statements] = STATE(957),
    [sym_element_reference] = STATE(5305),
    [sym_range] = STATE(11995),
    [sym_binary] = STATE(11995),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(957),
    [sym_break] = STATE(957),
    [sym_next] = STATE(957),
    [sym_string_array] = STATE(957),
    [sym_while] = STATE(957),
    [sym_case] = STATE(957),
    [sym_symbol_array] = STATE(957),
    [sym_array] = STATE(957),
    [sym_hash] = STATE(957),
    [sym_false] = STATE(5305),
    [sym_nil] = STATE(5305),
    [sym_scope_resolution] = STATE(958),
    [sym_call] = STATE(958),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(1725),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(8645),
    [anon_sym_not] = ACTIONS(8647),
    [sym_self] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(1737),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(8649),
    [anon_sym_TILDE] = ACTIONS(8645),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1741),
    [sym_character] = ACTIONS(1737),
    [sym_super] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(8651),
    [anon_sym_next] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(1725),
    [sym_constant] = ACTIONS(1733),
    [anon_sym_defined_QMARK] = ACTIONS(8653),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1733),
    [sym_redo] = ACTIONS(1725),
    [sym_class_variable] = ACTIONS(1741),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1751),
  },
  [11391] = {
    [aux_sym_exceptions_repeat1] = STATE(11391),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16978),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11392] = {
    [anon_sym_LT] = ACTIONS(8661),
    [anon_sym_SLASH] = ACTIONS(8663),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(8667),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8671),
    [anon_sym_LT_LT] = ACTIONS(8667),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(8669),
    [anon_sym_PLUS] = ACTIONS(8673),
    [anon_sym_AMP] = ACTIONS(8675),
    [anon_sym_GT] = ACTIONS(8661),
    [anon_sym_PERCENT] = ACTIONS(8663),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(8663),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(8677),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(8669),
    [anon_sym_PIPE_PIPE] = ACTIONS(8669),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(8669),
    [anon_sym_STAR_STAR] = ACTIONS(8663),
    [anon_sym_PIPE] = ACTIONS(8681),
    [anon_sym_DOT_DOT] = ACTIONS(8683),
    [anon_sym_AMP_AMP] = ACTIONS(8669),
    [anon_sym_LT_EQ_GT] = ACTIONS(8669),
    [anon_sym_LT_EQ] = ACTIONS(8661),
    [sym__binary_minus] = ACTIONS(8673),
    [anon_sym_CARET] = ACTIONS(8685),
  },
  [11393] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11394] = {
    [sym_assignment] = STATE(10229),
    [sym_unary] = STATE(10229),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(10229),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(10229),
    [sym_conditional] = STATE(10229),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_return] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_true] = STATE(5368),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(10229),
    [sym_binary] = STATE(10229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(4640),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [sym_global_variable] = ACTIONS(8739),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(8731),
    [sym_character] = ACTIONS(8735),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [11395] = {
    [aux_sym_exceptions_repeat1] = STATE(11996),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(16981),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_RBRACE] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11396] = {
    [sym_assignment] = STATE(11997),
    [sym_unary] = STATE(11997),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5368),
    [sym_singleton_class] = STATE(5370),
    [sym_module] = STATE(5370),
    [sym_chained_string] = STATE(5370),
    [sym_until] = STATE(5370),
    [sym_regex] = STATE(5370),
    [sym_for] = STATE(5370),
    [sym_symbol] = STATE(5370),
    [sym_if] = STATE(5370),
    [sym_begin] = STATE(5370),
    [sym__arg] = STATE(11997),
    [sym__primary] = STATE(5370),
    [sym_method_call] = STATE(5368),
    [sym_operator_assignment] = STATE(11997),
    [sym_conditional] = STATE(11997),
    [sym_method] = STATE(5370),
    [sym_singleton_method] = STATE(5370),
    [sym__variable] = STATE(5371),
    [sym_left_assignment_list] = STATE(5372),
    [sym_rational] = STATE(5370),
    [sym_true] = STATE(5368),
    [sym_return] = STATE(5370),
    [sym_subshell] = STATE(5370),
    [sym_yield] = STATE(5370),
    [sym_string] = STATE(5373),
    [sym_unless] = STATE(5370),
    [sym_lambda] = STATE(5370),
    [sym_parenthesized_statements] = STATE(5370),
    [sym_element_reference] = STATE(5368),
    [sym_range] = STATE(11997),
    [sym_binary] = STATE(11997),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5370),
    [sym_break] = STATE(5370),
    [sym_next] = STATE(5370),
    [sym_string_array] = STATE(5370),
    [sym_while] = STATE(5370),
    [sym_case] = STATE(5370),
    [sym_symbol_array] = STATE(5370),
    [sym_array] = STATE(5370),
    [sym_hash] = STATE(5370),
    [sym_false] = STATE(5368),
    [sym_nil] = STATE(5368),
    [sym_scope_resolution] = STATE(5371),
    [sym_call] = STATE(5371),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(8723),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(8725),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(8727),
    [anon_sym_not] = ACTIONS(8729),
    [sym_self] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(8733),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(8735),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(8735),
    [anon_sym_PLUS] = ACTIONS(8737),
    [anon_sym_TILDE] = ACTIONS(8727),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(8739),
    [sym_character] = ACTIONS(8735),
    [sym_super] = ACTIONS(8731),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(8741),
    [anon_sym_next] = ACTIONS(8743),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(8723),
    [sym_constant] = ACTIONS(8731),
    [anon_sym_defined_QMARK] = ACTIONS(8745),
    [sym_instance_variable] = ACTIONS(8739),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1749),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(8731),
    [sym_redo] = ACTIONS(8723),
    [sym_class_variable] = ACTIONS(8739),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(8747),
  },
  [11397] = {
    [aux_sym_exceptions_repeat1] = STATE(11397),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16983),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11398] = {
    [anon_sym_LT] = ACTIONS(8757),
    [anon_sym_SLASH] = ACTIONS(8759),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(8761),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(8763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8767),
    [anon_sym_LT_LT] = ACTIONS(8763),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(8765),
    [anon_sym_PLUS] = ACTIONS(8769),
    [anon_sym_AMP] = ACTIONS(8771),
    [anon_sym_GT] = ACTIONS(8757),
    [anon_sym_PERCENT] = ACTIONS(8759),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(8773),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(8775),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8775),
    [anon_sym_BANG_TILDE] = ACTIONS(8765),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(8765),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_PIPE] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_AMP_AMP] = ACTIONS(8775),
    [anon_sym_LT_EQ_GT] = ACTIONS(8765),
    [anon_sym_LT_EQ] = ACTIONS(8757),
    [sym__binary_minus] = ACTIONS(8783),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(8779),
  },
  [11399] = {
    [anon_sym_LT] = ACTIONS(8805),
    [anon_sym_SLASH] = ACTIONS(8807),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(8811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8811),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(8813),
    [sym__binary_star] = ACTIONS(8807),
    [anon_sym_PLUS] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8805),
    [anon_sym_PERCENT] = ACTIONS(8807),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(8821),
    [anon_sym_BANG_TILDE] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(8813),
    [anon_sym_GT_EQ] = ACTIONS(8823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(8813),
    [anon_sym_STAR_STAR] = ACTIONS(8807),
    [anon_sym_PIPE] = ACTIONS(8825),
    [anon_sym_DOT_DOT] = ACTIONS(8827),
    [anon_sym_AMP_AMP] = ACTIONS(8813),
    [anon_sym_LT_EQ_GT] = ACTIONS(8813),
    [anon_sym_LT_EQ] = ACTIONS(8805),
    [sym__binary_minus] = ACTIONS(8817),
    [anon_sym_CARET] = ACTIONS(8829),
  },
  [11400] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16422),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11401] = {
    [aux_sym_exceptions_repeat1] = STATE(11401),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16986),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11402] = {
    [anon_sym_LT] = ACTIONS(8890),
    [anon_sym_SLASH] = ACTIONS(8892),
    [anon_sym_QMARK] = ACTIONS(8894),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(8898),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8900),
    [anon_sym_LT_LT] = ACTIONS(8898),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(8896),
    [sym__binary_star] = ACTIONS(8892),
    [anon_sym_PLUS] = ACTIONS(8904),
    [anon_sym_AMP] = ACTIONS(8906),
    [anon_sym_GT] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8892),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(8908),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(8896),
    [anon_sym_PIPE_PIPE] = ACTIONS(8896),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(8910),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(8896),
    [anon_sym_STAR_STAR] = ACTIONS(8892),
    [anon_sym_PIPE] = ACTIONS(8914),
    [anon_sym_DOT_DOT] = ACTIONS(8912),
    [anon_sym_AMP_AMP] = ACTIONS(8896),
    [anon_sym_LT_EQ_GT] = ACTIONS(8896),
    [anon_sym_LT_EQ] = ACTIONS(8890),
    [sym__binary_minus] = ACTIONS(8904),
    [anon_sym_CARET] = ACTIONS(8916),
  },
  [11403] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11404] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11405] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11406] = {
    [aux_sym_exceptions_repeat1] = STATE(11999),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11407] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11408] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11409] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11410] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11411] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16989),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11412] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11413] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [11414] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11415] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11416] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11417] = {
    [aux_sym_chained_string_repeat1] = STATE(11417),
    [sym_string] = STATE(11417),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11418] = {
    [sym_comment] = ACTIONS(49),
    [anon_sym_DOT] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
  },
  [11419] = {
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_in] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_EQ] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
  },
  [11420] = {
    [aux_sym_exceptions_repeat1] = STATE(11420),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16991),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11421] = {
    [anon_sym_LT] = ACTIONS(9037),
    [anon_sym_SLASH] = ACTIONS(9039),
    [anon_sym_in] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9041),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9047),
    [anon_sym_LT_LT] = ACTIONS(9045),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(9043),
    [sym__binary_star] = ACTIONS(9039),
    [anon_sym_PLUS] = ACTIONS(9051),
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_GT] = ACTIONS(9037),
    [anon_sym_PERCENT] = ACTIONS(9039),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9055),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9043),
    [anon_sym_BANG_TILDE] = ACTIONS(9043),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9057),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9043),
    [anon_sym_STAR_STAR] = ACTIONS(9039),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_DOT_DOT] = ACTIONS(9059),
    [anon_sym_AMP_AMP] = ACTIONS(9043),
    [anon_sym_LT_EQ_GT] = ACTIONS(9043),
    [anon_sym_LT_EQ] = ACTIONS(9037),
    [sym__binary_minus] = ACTIONS(9051),
    [anon_sym_CARET] = ACTIONS(9063),
  },
  [11422] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11423] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11424] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11425] = {
    [aux_sym_exceptions_repeat1] = STATE(12002),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_in] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11426] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11427] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11428] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11429] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11430] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(16994),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11431] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11432] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [11433] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11434] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11435] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11436] = {
    [aux_sym_chained_string_repeat1] = STATE(11436),
    [sym_string] = STATE(11436),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_in] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11437] = {
    [aux_sym_exceptions_repeat1] = STATE(11437),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(16996),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11438] = {
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_SLASH] = ACTIONS(9109),
    [anon_sym_in] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(9115),
    [sym__binary_star] = ACTIONS(9119),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_PERCENT] = ACTIONS(9109),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9125),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9125),
    [anon_sym_BANG_TILDE] = ACTIONS(9115),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9127),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9115),
    [anon_sym_STAR_STAR] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9129),
    [anon_sym_DOT_DOT] = ACTIONS(9131),
    [anon_sym_AMP_AMP] = ACTIONS(9125),
    [anon_sym_LT_EQ_GT] = ACTIONS(9115),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [sym__binary_minus] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(9129),
  },
  [11439] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [11440] = {
    [aux_sym_chained_string_repeat1] = STATE(11495),
    [sym_string] = STATE(11495),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [11441] = {
    [sym_assignment] = STATE(12004),
    [sym_unary] = STATE(12004),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12004),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12004),
    [sym_conditional] = STATE(12004),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12004),
    [sym_binary] = STATE(12004),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [11442] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [11443] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [11444] = {
    [sym_assignment] = STATE(12005),
    [sym_unary] = STATE(12005),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12005),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12005),
    [sym_conditional] = STATE(12005),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12005),
    [sym_binary] = STATE(12005),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [11445] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(16999),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [11446] = {
    [anon_sym_COLON] = ACTIONS(17001),
    [sym_comment] = ACTIONS(49),
  },
  [11447] = {
    [sym_assignment] = STATE(12008),
    [sym_unary] = STATE(12008),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12008),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12008),
    [sym_conditional] = STATE(12008),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12008),
    [sym_binary] = STATE(12008),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11448] = {
    [sym_assignment] = STATE(12009),
    [sym_unary] = STATE(12009),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12009),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12009),
    [sym_conditional] = STATE(12009),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12009),
    [sym_binary] = STATE(12009),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11449] = {
    [sym_assignment] = STATE(12010),
    [sym_unary] = STATE(12010),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12010),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12010),
    [sym_conditional] = STATE(12010),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12010),
    [sym_binary] = STATE(12010),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11450] = {
    [sym_heredoc_body] = STATE(12012),
    [aux_sym_call_repeat1] = STATE(12012),
    [aux_sym_argument_list_repeat1] = STATE(12013),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(17003),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [11451] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [11452] = {
    [aux_sym_chained_string_repeat1] = STATE(11495),
    [sym_string] = STATE(11495),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(17005),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [11453] = {
    [sym_heredoc_body] = STATE(12012),
    [aux_sym_call_repeat1] = STATE(12012),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
  },
  [11454] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2362),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(283),
  },
  [11455] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2374),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(283),
  },
  [11456] = {
    [sym_assignment] = STATE(12014),
    [sym_unary] = STATE(12014),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12014),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12014),
    [sym_conditional] = STATE(12014),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12014),
    [sym_binary] = STATE(12014),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [11457] = {
    [sym_assignment] = STATE(2388),
    [sym_unary] = STATE(2388),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(2388),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(2388),
    [sym_conditional] = STATE(2388),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(2388),
    [sym_binary] = STATE(2388),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [11458] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2399),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_if] = ACTIONS(283),
  },
  [11459] = {
    [sym_assignment] = STATE(12015),
    [sym_unary] = STATE(12015),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12015),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12015),
    [sym_conditional] = STATE(12015),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12015),
    [sym_binary] = STATE(12015),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [11460] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(17007),
    [sym_identifier] = ACTIONS(17007),
  },
  [11461] = {
    [sym__argument] = STATE(10343),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(10343),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(10343),
    [sym_hash_splat_argument] = STATE(10343),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_argument_list] = STATE(2417),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym__argument_list_with_parens] = STATE(10350),
    [sym_block_argument] = STATE(10343),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym_float] = ACTIONS(15031),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(1371),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15055),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(3920),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15065),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(283),
  },
  [11462] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(17009),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(17009),
    [anon_sym_SLASH_EQ] = ACTIONS(17009),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(17009),
    [anon_sym_PIPE_EQ] = ACTIONS(17009),
    [anon_sym_LT_LT_EQ] = ACTIONS(17009),
    [anon_sym_PLUS_EQ] = ACTIONS(17009),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(17009),
    [anon_sym_STAR_EQ] = ACTIONS(17009),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(17009),
    [anon_sym_CARET_EQ] = ACTIONS(17009),
    [anon_sym_DASH_EQ] = ACTIONS(17009),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(17009),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(17011),
  },
  [11463] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [11464] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(777),
    [anon_sym_COLON_COLON2] = ACTIONS(17039),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(17041),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(17043),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(777),
  },
  [11465] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym__primary] = STATE(10380),
    [sym_argument_list] = STATE(2442),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_method] = STATE(10380),
    [sym_conditional] = STATE(10385),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_subshell] = STATE(10380),
    [sym_unless] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10384),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_call] = STATE(10382),
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_rational] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_lambda] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(10385),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_nil] = STATE(10384),
    [sym_symbol_array] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_scope_resolution] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(4248),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11466] = {
    [anon_sym_EQ] = ACTIONS(17045),
    [sym_comment] = ACTIONS(3),
  },
  [11467] = {
    [aux_sym_chained_string_repeat1] = STATE(12030),
    [sym_string] = STATE(12030),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
  },
  [11468] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [11469] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [11470] = {
    [sym__argument] = STATE(7687),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(7687),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(7687),
    [sym_hash_splat_argument] = STATE(7687),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_heredoc_body] = STATE(12031),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_block_argument] = STATE(7687),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym_float] = ACTIONS(15031),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(15055),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17047),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11471] = {
    [sym_heredoc_body] = STATE(12032),
    [aux_sym_call_repeat1] = STATE(12032),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11472] = {
    [sym_heredoc_body] = STATE(12033),
    [aux_sym_call_repeat1] = STATE(12033),
    [aux_sym_argument_list_repeat1] = STATE(12034),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16258),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11473] = {
    [sym_assignment] = STATE(12035),
    [sym_unary] = STATE(12035),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12035),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12035),
    [sym_conditional] = STATE(12035),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12035),
    [sym_binary] = STATE(12035),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11474] = {
    [sym_assignment] = STATE(12036),
    [sym_unary] = STATE(12036),
    [sym_right_assignment_list] = STATE(2483),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12036),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(12037),
    [sym_operator_assignment] = STATE(12036),
    [sym_conditional] = STATE(12036),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_subshell] = STATE(10346),
    [sym__arg_or_splat_arg] = STATE(12037),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12036),
    [sym_binary] = STATE(12036),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(15035),
    [sym_character] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11475] = {
    [sym_assignment] = STATE(12038),
    [sym_unary] = STATE(12038),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12038),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12038),
    [sym_conditional] = STATE(12038),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12038),
    [sym_binary] = STATE(12038),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11476] = {
    [sym_assignment] = STATE(12039),
    [sym_unary] = STATE(12039),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12039),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12039),
    [sym_conditional] = STATE(12039),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12039),
    [sym_binary] = STATE(12039),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11477] = {
    [sym_assignment] = STATE(12040),
    [sym_unary] = STATE(12040),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12040),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12040),
    [sym_conditional] = STATE(12040),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12040),
    [sym_binary] = STATE(12040),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [11478] = {
    [sym_assignment] = STATE(12041),
    [sym_unary] = STATE(12041),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12041),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12041),
    [sym_conditional] = STATE(12041),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12041),
    [sym_binary] = STATE(12041),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11479] = {
    [sym_assignment] = STATE(12042),
    [sym_unary] = STATE(12042),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12042),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12042),
    [sym_conditional] = STATE(12042),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12042),
    [sym_binary] = STATE(12042),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11480] = {
    [sym_assignment] = STATE(12043),
    [sym_unary] = STATE(12043),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12043),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12043),
    [sym_conditional] = STATE(12043),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12043),
    [sym_binary] = STATE(12043),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11481] = {
    [sym_assignment] = STATE(12045),
    [sym_unary] = STATE(12045),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12045),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12045),
    [sym_conditional] = STATE(12045),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12045),
    [sym_binary] = STATE(12045),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11482] = {
    [sym_assignment] = STATE(12046),
    [sym_unary] = STATE(12046),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12046),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12046),
    [sym_conditional] = STATE(12046),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12046),
    [sym_binary] = STATE(12046),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11483] = {
    [sym_assignment] = STATE(12047),
    [sym_unary] = STATE(12047),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12047),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12047),
    [sym_conditional] = STATE(12047),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12047),
    [sym_binary] = STATE(12047),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [11484] = {
    [sym_heredoc_body] = STATE(12052),
    [sym__argument_list_with_parens] = STATE(12051),
    [aux_sym_call_repeat1] = STATE(12052),
    [sym_argument_list_with_parens] = STATE(12050),
    [sym_operator] = STATE(12050),
    [anon_sym_LT] = ACTIONS(17049),
    [anon_sym_SLASH] = ACTIONS(17051),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17051),
    [anon_sym_PLUS_AT] = ACTIONS(17051),
    [anon_sym_LPAREN2] = ACTIONS(17053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17051),
    [anon_sym_GT_GT] = ACTIONS(17051),
    [anon_sym_EQ_TILDE] = ACTIONS(17051),
    [anon_sym_LT_LT] = ACTIONS(17051),
    [anon_sym_TILDE] = ACTIONS(17051),
    [anon_sym_PLUS] = ACTIONS(17049),
    [anon_sym_AMP] = ACTIONS(17051),
    [anon_sym_GT] = ACTIONS(17049),
    [anon_sym_PERCENT] = ACTIONS(17051),
    [anon_sym_DASH_AT] = ACTIONS(17051),
    [anon_sym_EQ_EQ] = ACTIONS(17049),
    [anon_sym_STAR] = ACTIONS(17049),
    [anon_sym_BANG_TILDE] = ACTIONS(17051),
    [sym_constant] = ACTIONS(17055),
    [anon_sym_DASH] = ACTIONS(17049),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17051),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17051),
    [anon_sym_STAR_STAR] = ACTIONS(17051),
    [anon_sym_PIPE] = ACTIONS(17051),
    [anon_sym_DOT_DOT] = ACTIONS(17051),
    [anon_sym_LT_EQ_GT] = ACTIONS(17051),
    [anon_sym_LT_EQ] = ACTIONS(17049),
    [anon_sym_BANG] = ACTIONS(17049),
    [sym_identifier] = ACTIONS(17055),
    [anon_sym_CARET] = ACTIONS(17051),
  },
  [11485] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(17057),
    [sym_identifier] = ACTIONS(17057),
  },
  [11486] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [sym__symbol_array_start] = ACTIONS(1351),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(17059),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [sym__subshell_start] = ACTIONS(1351),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [11487] = {
    [anon_sym_COLON] = ACTIONS(17061),
    [sym_comment] = ACTIONS(49),
  },
  [11488] = {
    [sym_assignment] = STATE(12056),
    [sym_unary] = STATE(12056),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12056),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12056),
    [sym_conditional] = STATE(12056),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12056),
    [sym_binary] = STATE(12056),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11489] = {
    [sym_assignment] = STATE(12057),
    [sym_unary] = STATE(12057),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12057),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12057),
    [sym_conditional] = STATE(12057),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12057),
    [sym_binary] = STATE(12057),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11490] = {
    [sym_assignment] = STATE(12058),
    [sym_unary] = STATE(12058),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12058),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12058),
    [sym_conditional] = STATE(12058),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12058),
    [sym_binary] = STATE(12058),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11491] = {
    [sym_heredoc_body] = STATE(12060),
    [aux_sym_call_repeat1] = STATE(12060),
    [aux_sym_argument_list_repeat1] = STATE(12061),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(17063),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [11492] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [11493] = {
    [aux_sym_chained_string_repeat1] = STATE(11550),
    [sym_string] = STATE(11550),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(17065),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11494] = {
    [sym_heredoc_body] = STATE(12060),
    [aux_sym_call_repeat1] = STATE(12060),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [11495] = {
    [aux_sym_chained_string_repeat1] = STATE(12062),
    [sym_string] = STATE(12062),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [11496] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11497] = {
    [sym_assignment] = STATE(12063),
    [sym_unary] = STATE(12063),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(12063),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(12063),
    [sym_conditional] = STATE(12063),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(12063),
    [sym_binary] = STATE(12063),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [11498] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11499] = {
    [aux_sym_exceptions_repeat1] = STATE(12065),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [11500] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11501] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11502] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11503] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11504] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17067),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11505] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11506] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [11507] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11508] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11509] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11510] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [11511] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(12068),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(17069),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [11512] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [11513] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [11514] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(11513),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(12069),
    [sym_operator] = STATE(12069),
    [anon_sym_LT] = ACTIONS(16312),
    [anon_sym_SLASH] = ACTIONS(16314),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(16314),
    [anon_sym_PLUS_AT] = ACTIONS(16314),
    [anon_sym_LPAREN2] = ACTIONS(16316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16314),
    [anon_sym_GT_GT] = ACTIONS(16314),
    [anon_sym_EQ_TILDE] = ACTIONS(16314),
    [anon_sym_LT_LT] = ACTIONS(16314),
    [anon_sym_TILDE] = ACTIONS(16314),
    [anon_sym_PLUS] = ACTIONS(16312),
    [anon_sym_AMP] = ACTIONS(16314),
    [anon_sym_GT] = ACTIONS(16312),
    [anon_sym_PERCENT] = ACTIONS(16314),
    [anon_sym_DASH_AT] = ACTIONS(16314),
    [anon_sym_EQ_EQ] = ACTIONS(16312),
    [anon_sym_STAR] = ACTIONS(16312),
    [anon_sym_BANG_TILDE] = ACTIONS(16314),
    [sym_constant] = ACTIONS(17071),
    [anon_sym_DASH] = ACTIONS(16312),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(16314),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(16312),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(16314),
    [anon_sym_STAR_STAR] = ACTIONS(16314),
    [anon_sym_PIPE] = ACTIONS(16314),
    [anon_sym_DOT_DOT] = ACTIONS(16314),
    [anon_sym_LT_EQ_GT] = ACTIONS(16314),
    [anon_sym_LT_EQ] = ACTIONS(16312),
    [anon_sym_BANG] = ACTIONS(16312),
    [sym_identifier] = ACTIONS(17071),
    [anon_sym_CARET] = ACTIONS(16314),
  },
  [11515] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [11516] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [11517] = {
    [aux_sym_chained_string_repeat1] = STATE(11550),
    [sym_string] = STATE(11550),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11518] = {
    [sym_assignment] = STATE(12070),
    [sym_unary] = STATE(12070),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12070),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12070),
    [sym_conditional] = STATE(12070),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12070),
    [sym_binary] = STATE(12070),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [11519] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [11520] = {
    [sym_assignment] = STATE(12071),
    [sym_unary] = STATE(12071),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12071),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12071),
    [sym_conditional] = STATE(12071),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12071),
    [sym_binary] = STATE(12071),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [11521] = {
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(7768),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11522] = {
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(7779),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11523] = {
    [sym_assignment] = STATE(12072),
    [sym_unary] = STATE(12072),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12072),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12072),
    [sym_conditional] = STATE(12072),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12072),
    [sym_binary] = STATE(12072),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [11524] = {
    [sym_assignment] = STATE(7793),
    [sym_unary] = STATE(7793),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(7793),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(7793),
    [sym_conditional] = STATE(7793),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(7793),
    [sym_binary] = STATE(7793),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [11525] = {
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(7804),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11526] = {
    [sym_assignment] = STATE(12073),
    [sym_unary] = STATE(12073),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12073),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12073),
    [sym_conditional] = STATE(12073),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12073),
    [sym_binary] = STATE(12073),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [11527] = {
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_argument_list] = STATE(7819),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11528] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(17073),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(17073),
    [anon_sym_SLASH_EQ] = ACTIONS(17073),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(17073),
    [anon_sym_PIPE_EQ] = ACTIONS(17073),
    [anon_sym_LT_LT_EQ] = ACTIONS(17073),
    [anon_sym_PLUS_EQ] = ACTIONS(17073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(17073),
    [anon_sym_STAR_EQ] = ACTIONS(17073),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(17073),
    [anon_sym_CARET_EQ] = ACTIONS(17073),
    [anon_sym_DASH_EQ] = ACTIONS(17073),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(17073),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(17075),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11529] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [11530] = {
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(17039),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(17041),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(17043),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [11531] = {
    [sym_block] = STATE(2441),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym__primary] = STATE(10380),
    [sym_argument_list] = STATE(5587),
    [sym_hash_splat_argument] = STATE(10383),
    [sym_method] = STATE(10380),
    [sym_conditional] = STATE(10385),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_subshell] = STATE(10380),
    [sym_unless] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_block_argument] = STATE(10383),
    [sym_range] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10384),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_call] = STATE(10382),
    [sym__argument] = STATE(10383),
    [sym_assignment] = STATE(10385),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_pair] = STATE(10383),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10383),
    [sym_operator_assignment] = STATE(10385),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_rational] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_lambda] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym__argument_list_with_parens] = STATE(10387),
    [sym_do_block] = STATE(2441),
    [sym_binary] = STATE(10385),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_nil] = STATE(10384),
    [sym_symbol_array] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_scope_resolution] = STATE(10382),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym_float] = ACTIONS(15107),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15111),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_nil] = ACTIONS(219),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [sym_character] = ACTIONS(15113),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15047),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15119),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(15127),
    [anon_sym_not] = ACTIONS(15129),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15139),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1625),
  },
  [11532] = {
    [anon_sym_EQ] = ACTIONS(17105),
    [sym_comment] = ACTIONS(3),
  },
  [11533] = {
    [aux_sym_chained_string_repeat1] = STATE(12085),
    [sym_string] = STATE(12085),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11534] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [11535] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [11536] = {
    [sym_assignment] = STATE(12086),
    [sym_unary] = STATE(12086),
    [sym_right_assignment_list] = STATE(5202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12086),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(12087),
    [sym_operator_assignment] = STATE(12086),
    [sym_conditional] = STATE(12086),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_subshell] = STATE(10380),
    [sym__arg_or_splat_arg] = STATE(12087),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12086),
    [sym_binary] = STATE(12086),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(15111),
    [sym_character] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11537] = {
    [sym__argument] = STATE(7839),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(7839),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(7839),
    [sym_hash_splat_argument] = STATE(7839),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_heredoc_body] = STATE(12088),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_block_argument] = STATE(7839),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym_float] = ACTIONS(15107),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(15111),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(15119),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [sym_class_variable] = ACTIONS(15119),
    [sym__block_ampersand] = ACTIONS(15127),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(15129),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17107),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11538] = {
    [sym_heredoc_body] = STATE(12089),
    [aux_sym_call_repeat1] = STATE(12089),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [11539] = {
    [sym_heredoc_body] = STATE(12090),
    [aux_sym_call_repeat1] = STATE(12090),
    [aux_sym_argument_list_repeat1] = STATE(12091),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16356),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [11540] = {
    [sym_assignment] = STATE(12092),
    [sym_unary] = STATE(12092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12092),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12092),
    [sym_conditional] = STATE(12092),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12092),
    [sym_binary] = STATE(12092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11541] = {
    [sym_assignment] = STATE(12093),
    [sym_unary] = STATE(12093),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12093),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12093),
    [sym_conditional] = STATE(12093),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12093),
    [sym_binary] = STATE(12093),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11542] = {
    [sym_assignment] = STATE(12094),
    [sym_unary] = STATE(12094),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12094),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12094),
    [sym_conditional] = STATE(12094),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12094),
    [sym_binary] = STATE(12094),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11543] = {
    [sym_assignment] = STATE(12095),
    [sym_unary] = STATE(12095),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12095),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12095),
    [sym_conditional] = STATE(12095),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12095),
    [sym_binary] = STATE(12095),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [11544] = {
    [sym_assignment] = STATE(12096),
    [sym_unary] = STATE(12096),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12096),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12096),
    [sym_conditional] = STATE(12096),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12096),
    [sym_binary] = STATE(12096),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11545] = {
    [sym_assignment] = STATE(12097),
    [sym_unary] = STATE(12097),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12097),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12097),
    [sym_conditional] = STATE(12097),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12097),
    [sym_binary] = STATE(12097),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11546] = {
    [sym_assignment] = STATE(12098),
    [sym_unary] = STATE(12098),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12098),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12098),
    [sym_conditional] = STATE(12098),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12098),
    [sym_binary] = STATE(12098),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11547] = {
    [sym_assignment] = STATE(12100),
    [sym_unary] = STATE(12100),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12100),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12100),
    [sym_conditional] = STATE(12100),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12100),
    [sym_binary] = STATE(12100),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11548] = {
    [sym_assignment] = STATE(12101),
    [sym_unary] = STATE(12101),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12101),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12101),
    [sym_conditional] = STATE(12101),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12101),
    [sym_binary] = STATE(12101),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11549] = {
    [sym_assignment] = STATE(12102),
    [sym_unary] = STATE(12102),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12102),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12102),
    [sym_conditional] = STATE(12102),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12102),
    [sym_binary] = STATE(12102),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [11550] = {
    [aux_sym_chained_string_repeat1] = STATE(12103),
    [sym_string] = STATE(12103),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [11551] = {
    [aux_sym_chained_string_repeat1] = STATE(11551),
    [sym_string] = STATE(11551),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12161),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [11552] = {
    [sym__line_break] = ACTIONS(17109),
    [sym_float] = ACTIONS(17111),
    [anon_sym_until] = ACTIONS(17111),
    [anon_sym_undef] = ACTIONS(17111),
    [sym_self] = ACTIONS(17111),
    [anon_sym_BEGIN] = ACTIONS(17111),
    [anon_sym_TILDE] = ACTIONS(17109),
    [anon_sym_unless] = ACTIONS(17111),
    [anon_sym_PLUS] = ACTIONS(17111),
    [sym__symbol_array_start] = ACTIONS(17109),
    [sym__simple_symbol] = ACTIONS(17109),
    [sym_complex] = ACTIONS(17109),
    [sym_heredoc_beginning] = ACTIONS(17109),
    [sym_super] = ACTIONS(17111),
    [anon_sym_alias] = ACTIONS(17111),
    [anon_sym_LBRACK2] = ACTIONS(17109),
    [anon_sym_nil] = ACTIONS(17111),
    [sym_character] = ACTIONS(17109),
    [anon_sym_LBRACE] = ACTIONS(17109),
    [anon_sym_END] = ACTIONS(17111),
    [sym_constant] = ACTIONS(17111),
    [anon_sym_while] = ACTIONS(17111),
    [sym_instance_variable] = ACTIONS(17109),
    [sym__heredoc_body_start] = ACTIONS(17109),
    [anon_sym_defined_QMARK] = ACTIONS(17109),
    [sym__string_start] = ACTIONS(17109),
    [anon_sym_true] = ACTIONS(17111),
    [anon_sym_for] = ACTIONS(17111),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17109),
    [anon_sym_NIL] = ACTIONS(17111),
    [anon_sym_COLON_COLON] = ACTIONS(17109),
    [anon_sym_def] = ACTIONS(17111),
    [sym_identifier] = ACTIONS(17111),
    [anon_sym_yield] = ACTIONS(17111),
    [sym_class_variable] = ACTIONS(17109),
    [sym__symbol_start] = ACTIONS(17109),
    [anon_sym_not] = ACTIONS(17111),
    [anon_sym_TRUE] = ACTIONS(17111),
    [anon_sym_case] = ACTIONS(17111),
    [anon_sym_SEMI] = ACTIONS(17109),
    [anon_sym_LPAREN] = ACTIONS(17109),
    [anon_sym_break] = ACTIONS(17111),
    [sym_global_variable] = ACTIONS(17109),
    [anon_sym_class] = ACTIONS(17111),
    [sym__subshell_start] = ACTIONS(17109),
    [anon_sym_module] = ACTIONS(17111),
    [anon_sym_begin] = ACTIONS(17111),
    [anon_sym_false] = ACTIONS(17111),
    [anon_sym_STAR] = ACTIONS(17109),
    [sym__unary_minus] = ACTIONS(17109),
    [anon_sym_next] = ACTIONS(17111),
    [sym_retry] = ACTIONS(17111),
    [sym__regex_start] = ACTIONS(17109),
    [anon_sym_end] = ACTIONS(17111),
    [sym_integer] = ACTIONS(17111),
    [anon_sym_FALSE] = ACTIONS(17111),
    [sym_redo] = ACTIONS(17111),
    [anon_sym_BANG] = ACTIONS(17109),
    [anon_sym_if] = ACTIONS(17111),
    [sym__string_array_start] = ACTIONS(17109),
    [anon_sym_return] = ACTIONS(17111),
  },
  [11553] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(17113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [11554] = {
    [aux_sym_block_parameters_repeat1] = STATE(12105),
    [anon_sym_PIPE] = ACTIONS(17113),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [11555] = {
    [sym_heredoc_body] = STATE(11555),
    [aux_sym_call_repeat1] = STATE(11555),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11556] = {
    [sym_heredoc_body] = STATE(11555),
    [aux_sym_call_repeat1] = STATE(11555),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11557] = {
    [sym_assignment] = STATE(10405),
    [sym_unary] = STATE(10405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(10405),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(10405),
    [sym_conditional] = STATE(10405),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_return] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_true] = STATE(5673),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(10405),
    [sym_binary] = STATE(10405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(1983),
    [sym_character] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [11558] = {
    [aux_sym_exceptions_repeat1] = STATE(12106),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17115),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11559] = {
    [sym_assignment] = STATE(12107),
    [sym_unary] = STATE(12107),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5673),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(12107),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5673),
    [sym_operator_assignment] = STATE(12107),
    [sym_conditional] = STATE(12107),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5675),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5673),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5673),
    [sym_range] = STATE(12107),
    [sym_binary] = STATE(12107),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5673),
    [sym_nil] = STATE(5673),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9182),
    [anon_sym_not] = ACTIONS(9184),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9188),
    [anon_sym_TILDE] = ACTIONS(9182),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9190),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9194),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [11560] = {
    [aux_sym_exceptions_repeat1] = STATE(11560),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17117),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11561] = {
    [anon_sym_LT] = ACTIONS(9204),
    [anon_sym_SLASH] = ACTIONS(9206),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9208),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9210),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_LT_LT] = ACTIONS(9210),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9214),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(9214),
    [anon_sym_AMP] = ACTIONS(9216),
    [anon_sym_GT] = ACTIONS(9204),
    [anon_sym_PLUS] = ACTIONS(9218),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [sym__binary_star] = ACTIONS(9206),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9220),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(9214),
    [anon_sym_PIPE_PIPE] = ACTIONS(9214),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9222),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9214),
    [anon_sym_STAR_STAR] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9224),
    [anon_sym_DOT_DOT] = ACTIONS(9226),
    [anon_sym_AMP_AMP] = ACTIONS(9214),
    [anon_sym_LT_EQ_GT] = ACTIONS(9214),
    [anon_sym_LT_EQ] = ACTIONS(9204),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(9228),
    [sym__binary_minus] = ACTIONS(9218),
  },
  [11562] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11563] = {
    [sym_assignment] = STATE(12108),
    [sym_unary] = STATE(12108),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5722),
    [sym_singleton_class] = STATE(1125),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_symbol] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(12108),
    [sym__primary] = STATE(1125),
    [sym_method_call] = STATE(5722),
    [sym_operator_assignment] = STATE(12108),
    [sym_conditional] = STATE(12108),
    [sym_method] = STATE(1125),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_left_assignment_list] = STATE(5724),
    [sym_rational] = STATE(1125),
    [sym_true] = STATE(5722),
    [sym_return] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(5676),
    [sym_unless] = STATE(1125),
    [sym_lambda] = STATE(1125),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_element_reference] = STATE(5722),
    [sym_range] = STATE(12108),
    [sym_binary] = STATE(12108),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_symbol_array] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_hash] = STATE(1125),
    [sym_false] = STATE(5722),
    [sym_nil] = STATE(5722),
    [sym_scope_resolution] = STATE(1128),
    [sym_call] = STATE(1128),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(1979),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9180),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(9266),
    [anon_sym_not] = ACTIONS(9268),
    [sym_self] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(9186),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(9272),
    [anon_sym_TILDE] = ACTIONS(9266),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(1991),
    [sym_character] = ACTIONS(1985),
    [sym_super] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(9274),
    [anon_sym_next] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(1979),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(9276),
    [sym_instance_variable] = ACTIONS(1991),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [sym_redo] = ACTIONS(1979),
    [sym_class_variable] = ACTIONS(1991),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(9196),
  },
  [11564] = {
    [sym_assignment] = STATE(10446),
    [sym_unary] = STATE(10446),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(10446),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(10446),
    [sym_conditional] = STATE(10446),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_return] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_true] = STATE(5739),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(10446),
    [sym_binary] = STATE(10446),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(5130),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [sym_global_variable] = ACTIONS(9302),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(9294),
    [sym_character] = ACTIONS(9298),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [11565] = {
    [aux_sym_exceptions_repeat1] = STATE(12109),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17120),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11566] = {
    [sym_assignment] = STATE(12110),
    [sym_unary] = STATE(12110),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5739),
    [sym_singleton_class] = STATE(5741),
    [sym_module] = STATE(5741),
    [sym_chained_string] = STATE(5741),
    [sym_until] = STATE(5741),
    [sym_regex] = STATE(5741),
    [sym_for] = STATE(5741),
    [sym_symbol] = STATE(5741),
    [sym_if] = STATE(5741),
    [sym_begin] = STATE(5741),
    [sym__arg] = STATE(12110),
    [sym__primary] = STATE(5741),
    [sym_method_call] = STATE(5739),
    [sym_operator_assignment] = STATE(12110),
    [sym_conditional] = STATE(12110),
    [sym_method] = STATE(5741),
    [sym_singleton_method] = STATE(5741),
    [sym__variable] = STATE(5742),
    [sym_left_assignment_list] = STATE(5743),
    [sym_rational] = STATE(5741),
    [sym_true] = STATE(5739),
    [sym_return] = STATE(5741),
    [sym_subshell] = STATE(5741),
    [sym_yield] = STATE(5741),
    [sym_string] = STATE(5744),
    [sym_unless] = STATE(5741),
    [sym_lambda] = STATE(5741),
    [sym_parenthesized_statements] = STATE(5741),
    [sym_element_reference] = STATE(5739),
    [sym_range] = STATE(12110),
    [sym_binary] = STATE(12110),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5741),
    [sym_break] = STATE(5741),
    [sym_next] = STATE(5741),
    [sym_string_array] = STATE(5741),
    [sym_while] = STATE(5741),
    [sym_case] = STATE(5741),
    [sym_symbol_array] = STATE(5741),
    [sym_array] = STATE(5741),
    [sym_hash] = STATE(5741),
    [sym_false] = STATE(5739),
    [sym_nil] = STATE(5739),
    [sym_scope_resolution] = STATE(5742),
    [sym_call] = STATE(5742),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(9286),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(9288),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(9290),
    [anon_sym_not] = ACTIONS(9292),
    [sym_self] = ACTIONS(9294),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(9296),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(9298),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(9298),
    [anon_sym_PLUS] = ACTIONS(9300),
    [anon_sym_TILDE] = ACTIONS(9290),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(9302),
    [sym_character] = ACTIONS(9298),
    [sym_super] = ACTIONS(9294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(9304),
    [anon_sym_next] = ACTIONS(9306),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(9286),
    [sym_constant] = ACTIONS(9294),
    [anon_sym_defined_QMARK] = ACTIONS(9308),
    [sym_instance_variable] = ACTIONS(9302),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(9294),
    [sym_redo] = ACTIONS(9286),
    [sym_class_variable] = ACTIONS(9302),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(9310),
  },
  [11567] = {
    [aux_sym_exceptions_repeat1] = STATE(11567),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17122),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11568] = {
    [anon_sym_SLASH] = ACTIONS(9320),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9322),
    [anon_sym_EQ_TILDE] = ACTIONS(9322),
    [anon_sym_LT_LT] = ACTIONS(9324),
    [sym__binary_star] = ACTIONS(9326),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(9328),
    [anon_sym_AMP] = ACTIONS(9330),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(9332),
    [anon_sym_PIPE] = ACTIONS(9334),
    [anon_sym_DOT_DOT] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(9332),
    [anon_sym_QMARK] = ACTIONS(9338),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9324),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9340),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(9332),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(9342),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9342),
    [anon_sym_GT_EQ] = ACTIONS(9344),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9322),
    [anon_sym_STAR_STAR] = ACTIONS(9320),
    [anon_sym_LT_EQ_GT] = ACTIONS(9322),
    [anon_sym_AMP_AMP] = ACTIONS(9342),
    [sym__binary_minus] = ACTIONS(9346),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(9334),
  },
  [11569] = {
    [aux_sym_exceptions_repeat1] = STATE(11569),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17125),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11570] = {
    [anon_sym_LT] = ACTIONS(9367),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_QMARK] = ACTIONS(9371),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_LT_LT] = ACTIONS(9377),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(9375),
    [sym__binary_star] = ACTIONS(9369),
    [anon_sym_PLUS] = ACTIONS(9383),
    [anon_sym_AMP] = ACTIONS(9385),
    [anon_sym_GT] = ACTIONS(9367),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [anon_sym_EQ_EQ] = ACTIONS(9387),
    [anon_sym_BANG_TILDE] = ACTIONS(9375),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9375),
    [anon_sym_GT_EQ] = ACTIONS(9389),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9375),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_PIPE] = ACTIONS(9393),
    [anon_sym_DOT_DOT] = ACTIONS(9391),
    [anon_sym_AMP_AMP] = ACTIONS(9375),
    [anon_sym_LT_EQ_GT] = ACTIONS(9375),
    [anon_sym_LT_EQ] = ACTIONS(9367),
    [sym__binary_minus] = ACTIONS(9383),
    [anon_sym_CARET] = ACTIONS(9395),
  },
  [11571] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11572] = {
    [sym_float] = ACTIONS(17111),
    [anon_sym_until] = ACTIONS(17111),
    [anon_sym_undef] = ACTIONS(17111),
    [sym_self] = ACTIONS(17111),
    [anon_sym_BEGIN] = ACTIONS(17111),
    [anon_sym_RBRACE] = ACTIONS(17109),
    [anon_sym_TILDE] = ACTIONS(17109),
    [anon_sym_unless] = ACTIONS(17111),
    [anon_sym_PLUS] = ACTIONS(17111),
    [sym__symbol_array_start] = ACTIONS(17109),
    [sym__simple_symbol] = ACTIONS(17109),
    [sym_complex] = ACTIONS(17109),
    [sym_heredoc_beginning] = ACTIONS(17109),
    [sym_super] = ACTIONS(17111),
    [anon_sym_alias] = ACTIONS(17111),
    [anon_sym_LBRACK2] = ACTIONS(17109),
    [anon_sym_nil] = ACTIONS(17111),
    [sym_character] = ACTIONS(17109),
    [anon_sym_LBRACE] = ACTIONS(17109),
    [anon_sym_END] = ACTIONS(17111),
    [sym_constant] = ACTIONS(17111),
    [anon_sym_while] = ACTIONS(17111),
    [sym_instance_variable] = ACTIONS(17109),
    [anon_sym_defined_QMARK] = ACTIONS(17109),
    [sym__string_start] = ACTIONS(17109),
    [anon_sym_true] = ACTIONS(17111),
    [anon_sym_for] = ACTIONS(17111),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17109),
    [anon_sym_NIL] = ACTIONS(17111),
    [anon_sym_COLON_COLON] = ACTIONS(17109),
    [anon_sym_def] = ACTIONS(17111),
    [sym_identifier] = ACTIONS(17111),
    [anon_sym_yield] = ACTIONS(17111),
    [sym_class_variable] = ACTIONS(17109),
    [sym__symbol_start] = ACTIONS(17109),
    [anon_sym_not] = ACTIONS(17111),
    [anon_sym_TRUE] = ACTIONS(17111),
    [anon_sym_case] = ACTIONS(17111),
    [anon_sym_SEMI] = ACTIONS(17109),
    [anon_sym_LPAREN] = ACTIONS(17109),
    [anon_sym_break] = ACTIONS(17111),
    [sym_global_variable] = ACTIONS(17109),
    [anon_sym_class] = ACTIONS(17111),
    [sym__subshell_start] = ACTIONS(17109),
    [anon_sym_module] = ACTIONS(17111),
    [anon_sym_begin] = ACTIONS(17111),
    [anon_sym_false] = ACTIONS(17111),
    [anon_sym_STAR] = ACTIONS(17109),
    [sym__unary_minus] = ACTIONS(17109),
    [anon_sym_next] = ACTIONS(17111),
    [sym_retry] = ACTIONS(17111),
    [sym__regex_start] = ACTIONS(17109),
    [sym_integer] = ACTIONS(17111),
    [anon_sym_FALSE] = ACTIONS(17111),
    [sym_redo] = ACTIONS(17111),
    [anon_sym_BANG] = ACTIONS(17109),
    [anon_sym_if] = ACTIONS(17111),
    [sym__string_array_start] = ACTIONS(17109),
    [anon_sym_return] = ACTIONS(17111),
  },
  [11573] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(17128),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [11574] = {
    [aux_sym_block_parameters_repeat1] = STATE(12112),
    [anon_sym_PIPE] = ACTIONS(17128),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [11575] = {
    [sym_assignment] = STATE(12113),
    [sym_unary] = STATE(12113),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5817),
    [sym_singleton_class] = STATE(1163),
    [sym_module] = STATE(1163),
    [sym_chained_string] = STATE(1163),
    [sym_until] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_for] = STATE(1163),
    [sym_symbol] = STATE(1163),
    [sym_if] = STATE(1163),
    [sym_begin] = STATE(1163),
    [sym__arg] = STATE(12113),
    [sym__primary] = STATE(1163),
    [sym_method_call] = STATE(5817),
    [sym_operator_assignment] = STATE(12113),
    [sym_conditional] = STATE(12113),
    [sym_method] = STATE(1163),
    [sym_singleton_method] = STATE(1163),
    [sym__variable] = STATE(1164),
    [sym_left_assignment_list] = STATE(5819),
    [sym_rational] = STATE(1163),
    [sym_true] = STATE(5817),
    [sym_return] = STATE(1163),
    [sym_subshell] = STATE(1163),
    [sym_yield] = STATE(1163),
    [sym_string] = STATE(5820),
    [sym_unless] = STATE(1163),
    [sym_lambda] = STATE(1163),
    [sym_parenthesized_statements] = STATE(1163),
    [sym_element_reference] = STATE(5817),
    [sym_range] = STATE(12113),
    [sym_binary] = STATE(12113),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1163),
    [sym_break] = STATE(1163),
    [sym_next] = STATE(1163),
    [sym_string_array] = STATE(1163),
    [sym_while] = STATE(1163),
    [sym_case] = STATE(1163),
    [sym_symbol_array] = STATE(1163),
    [sym_array] = STATE(1163),
    [sym_hash] = STATE(1163),
    [sym_false] = STATE(5817),
    [sym_nil] = STATE(5817),
    [sym_scope_resolution] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(2059),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(9423),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [sym_self] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(9429),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(9431),
    [anon_sym_TILDE] = ACTIONS(9425),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(2075),
    [sym_character] = ACTIONS(2071),
    [sym_super] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(9433),
    [anon_sym_next] = ACTIONS(9435),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(2059),
    [sym_constant] = ACTIONS(2067),
    [anon_sym_defined_QMARK] = ACTIONS(9437),
    [sym_instance_variable] = ACTIONS(2075),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(2083),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(2067),
    [sym_redo] = ACTIONS(2059),
    [sym_class_variable] = ACTIONS(2075),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(9439),
  },
  [11576] = {
    [sym_assignment] = STATE(10494),
    [sym_unary] = STATE(10494),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10494),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(10494),
    [sym_conditional] = STATE(10494),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_true] = STATE(5834),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(10494),
    [sym_binary] = STATE(10494),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(5258),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [sym_global_variable] = ACTIONS(5486),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(5478),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [11577] = {
    [aux_sym_exceptions_repeat1] = STATE(12114),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17130),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11578] = {
    [sym_assignment] = STATE(12115),
    [sym_unary] = STATE(12115),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5834),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(12115),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(5834),
    [sym_operator_assignment] = STATE(12115),
    [sym_conditional] = STATE(12115),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(3235),
    [sym_left_assignment_list] = STATE(5836),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(5834),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(3237),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(5834),
    [sym_range] = STATE(12115),
    [sym_binary] = STATE(12115),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(5834),
    [sym_nil] = STATE(5834),
    [sym_scope_resolution] = STATE(3235),
    [sym_call] = STATE(3235),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(5472),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(9458),
    [anon_sym_not] = ACTIONS(9460),
    [sym_self] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(5480),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(9462),
    [anon_sym_TILDE] = ACTIONS(9458),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(5486),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(9464),
    [anon_sym_next] = ACTIONS(5490),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(5478),
    [anon_sym_defined_QMARK] = ACTIONS(9466),
    [sym_instance_variable] = ACTIONS(5486),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(5478),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(5486),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(5496),
  },
  [11579] = {
    [aux_sym_exceptions_repeat1] = STATE(11579),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17132),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11580] = {
    [anon_sym_LT] = ACTIONS(9474),
    [anon_sym_SLASH] = ACTIONS(9476),
    [anon_sym_QMARK] = ACTIONS(9478),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9482),
    [anon_sym_LT_LT] = ACTIONS(9480),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9484),
    [anon_sym_EQ_TILDE] = ACTIONS(9484),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9474),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(9476),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9490),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(9484),
    [anon_sym_PIPE_PIPE] = ACTIONS(9484),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9492),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9484),
    [anon_sym_STAR_STAR] = ACTIONS(9476),
    [anon_sym_PIPE] = ACTIONS(9494),
    [anon_sym_DOT_DOT] = ACTIONS(9496),
    [anon_sym_AMP_AMP] = ACTIONS(9484),
    [anon_sym_LT_EQ_GT] = ACTIONS(9484),
    [anon_sym_LT_EQ] = ACTIONS(9474),
    [sym__binary_minus] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9498),
  },
  [11581] = {
    [sym_assignment] = STATE(10513),
    [sym_unary] = STATE(10513),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(10513),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(10513),
    [sym_conditional] = STATE(10513),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_return] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_true] = STATE(5886),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(10513),
    [sym_binary] = STATE(10513),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(5330),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [sym_global_variable] = ACTIONS(9540),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(9532),
    [sym_character] = ACTIONS(9536),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [11582] = {
    [aux_sym_exceptions_repeat1] = STATE(12116),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17135),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11583] = {
    [sym_assignment] = STATE(12117),
    [sym_unary] = STATE(12117),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(5886),
    [sym_singleton_class] = STATE(5888),
    [sym_module] = STATE(5888),
    [sym_chained_string] = STATE(5888),
    [sym_until] = STATE(5888),
    [sym_regex] = STATE(5888),
    [sym_for] = STATE(5888),
    [sym_symbol] = STATE(5888),
    [sym_if] = STATE(5888),
    [sym_begin] = STATE(5888),
    [sym__arg] = STATE(12117),
    [sym__primary] = STATE(5888),
    [sym_method_call] = STATE(5886),
    [sym_operator_assignment] = STATE(12117),
    [sym_conditional] = STATE(12117),
    [sym_method] = STATE(5888),
    [sym_singleton_method] = STATE(5888),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(5890),
    [sym_rational] = STATE(5888),
    [sym_true] = STATE(5886),
    [sym_return] = STATE(5888),
    [sym_subshell] = STATE(5888),
    [sym_yield] = STATE(5888),
    [sym_string] = STATE(5891),
    [sym_unless] = STATE(5888),
    [sym_lambda] = STATE(5888),
    [sym_parenthesized_statements] = STATE(5888),
    [sym_element_reference] = STATE(5886),
    [sym_range] = STATE(12117),
    [sym_binary] = STATE(12117),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(5888),
    [sym_break] = STATE(5888),
    [sym_next] = STATE(5888),
    [sym_string_array] = STATE(5888),
    [sym_while] = STATE(5888),
    [sym_case] = STATE(5888),
    [sym_symbol_array] = STATE(5888),
    [sym_array] = STATE(5888),
    [sym_hash] = STATE(5888),
    [sym_false] = STATE(5886),
    [sym_nil] = STATE(5886),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(9524),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(9526),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(9528),
    [anon_sym_not] = ACTIONS(9530),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(9534),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(9536),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(9536),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_TILDE] = ACTIONS(9528),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(9536),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(9542),
    [anon_sym_next] = ACTIONS(9544),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(9524),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(9546),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(9524),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(9548),
  },
  [11584] = {
    [aux_sym_exceptions_repeat1] = STATE(11584),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17137),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11585] = {
    [anon_sym_LT] = ACTIONS(9558),
    [anon_sym_SLASH] = ACTIONS(9560),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9566),
    [anon_sym_LT_LT] = ACTIONS(9564),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9568),
    [anon_sym_EQ_TILDE] = ACTIONS(9568),
    [anon_sym_PLUS] = ACTIONS(9570),
    [anon_sym_AMP] = ACTIONS(9572),
    [anon_sym_GT] = ACTIONS(9558),
    [anon_sym_PERCENT] = ACTIONS(9560),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(9574),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9576),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9576),
    [anon_sym_BANG_TILDE] = ACTIONS(9568),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9578),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9568),
    [anon_sym_STAR_STAR] = ACTIONS(9560),
    [anon_sym_PIPE] = ACTIONS(9580),
    [anon_sym_DOT_DOT] = ACTIONS(9582),
    [anon_sym_AMP_AMP] = ACTIONS(9576),
    [anon_sym_LT_EQ_GT] = ACTIONS(9568),
    [anon_sym_LT_EQ] = ACTIONS(9558),
    [sym__binary_minus] = ACTIONS(9584),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(9580),
  },
  [11586] = {
    [sym__line_break] = ACTIONS(12905),
    [anon_sym_DOT] = ACTIONS(12905),
    [anon_sym_then] = ACTIONS(12905),
    [anon_sym_AMP_DOT] = ACTIONS(12905),
    [anon_sym_COLON_COLON2] = ACTIONS(12905),
    [sym__heredoc_body_start] = ACTIONS(12905),
    [anon_sym_COMMA] = ACTIONS(12905),
    [anon_sym_SEMI] = ACTIONS(12905),
    [anon_sym_LBRACK] = ACTIONS(12905),
    [sym_comment] = ACTIONS(49),
  },
  [11587] = {
    [anon_sym_end] = ACTIONS(17140),
    [sym_comment] = ACTIONS(49),
  },
  [11588] = {
    [sym__statement] = STATE(1123),
    [sym_unary] = STATE(1130),
    [sym_rest_assignment] = STATE(43),
    [sym_undef] = STATE(1123),
    [sym_module] = STATE(1125),
    [sym_chained_string] = STATE(1125),
    [sym_unless_modifier] = STATE(1123),
    [sym_symbol] = STATE(1125),
    [sym_for] = STATE(1125),
    [sym_if] = STATE(1125),
    [sym__primary] = STATE(1125),
    [sym_method] = STATE(1125),
    [sym_conditional] = STATE(1130),
    [sym_left_assignment_list] = STATE(1126),
    [sym_return] = STATE(1125),
    [sym_true] = STATE(1129),
    [sym_while_modifier] = STATE(1123),
    [sym_subshell] = STATE(1125),
    [sym_unless] = STATE(1125),
    [sym_empty_statement] = STATE(1133),
    [sym_parenthesized_statements] = STATE(1125),
    [sym_begin_block] = STATE(1123),
    [sym_range] = STATE(1130),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(1129),
    [sym_next] = STATE(1125),
    [sym_string_array] = STATE(1125),
    [sym_while] = STATE(1125),
    [sym_array] = STATE(1125),
    [sym_call] = STATE(1128),
    [sym_end_block] = STATE(1123),
    [sym_assignment] = STATE(1130),
    [sym__lhs] = STATE(1129),
    [sym_singleton_class] = STATE(1125),
    [sym_alias] = STATE(1123),
    [sym_if_modifier] = STATE(1123),
    [sym_until] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_begin] = STATE(1125),
    [sym__arg] = STATE(1130),
    [sym_method_call] = STATE(1129),
    [sym_operator_assignment] = STATE(1130),
    [sym_singleton_method] = STATE(1125),
    [sym__variable] = STATE(1128),
    [sym_rational] = STATE(1125),
    [sym_yield] = STATE(1125),
    [sym_string] = STATE(1131),
    [sym_until_modifier] = STATE(1123),
    [sym_lambda] = STATE(1125),
    [sym_element_reference] = STATE(1129),
    [sym__statements] = STATE(12119),
    [sym_binary] = STATE(1130),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1125),
    [sym_break] = STATE(1125),
    [sym_nil] = STATE(1129),
    [sym_rescue_modifier] = STATE(1123),
    [sym_symbol_array] = STATE(1125),
    [sym_case] = STATE(1125),
    [sym_hash] = STATE(1125),
    [aux_sym__statements_repeat1] = STATE(1133),
    [sym_scope_resolution] = STATE(1128),
    [sym_float] = ACTIONS(1979),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_undef] = ACTIONS(1981),
    [sym_self] = ACTIONS(1983),
    [anon_sym_BEGIN] = ACTIONS(13),
    [sym_heredoc_beginning] = ACTIONS(1985),
    [anon_sym_unless] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym_complex] = ACTIONS(1985),
    [sym__simple_symbol] = ACTIONS(25),
    [sym_super] = ACTIONS(1983),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_nil] = ACTIONS(31),
    [sym_character] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_END] = ACTIONS(35),
    [sym_constant] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(37),
    [sym_instance_variable] = ACTIONS(1991),
    [anon_sym_defined_QMARK] = ACTIONS(1995),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(2001),
    [sym_class_variable] = ACTIONS(1991),
    [sym__symbol_start] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(2003),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(2005),
    [sym_global_variable] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(71),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [sym__unary_minus] = ACTIONS(2007),
    [anon_sym_next] = ACTIONS(2009),
    [sym_retry] = ACTIONS(1979),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_end] = ACTIONS(17142),
    [sym_integer] = ACTIONS(91),
    [anon_sym_FALSE] = ACTIONS(79),
    [sym_redo] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(95),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(2013),
  },
  [11589] = {
    [sym__line_break] = ACTIONS(13019),
    [anon_sym_DOT] = ACTIONS(13019),
    [anon_sym_then] = ACTIONS(13019),
    [anon_sym_AMP_DOT] = ACTIONS(13019),
    [anon_sym_COLON_COLON2] = ACTIONS(13019),
    [sym__heredoc_body_start] = ACTIONS(13019),
    [anon_sym_COMMA] = ACTIONS(13019),
    [anon_sym_SEMI] = ACTIONS(13019),
    [anon_sym_LBRACK] = ACTIONS(13019),
    [sym_comment] = ACTIONS(49),
  },
  [11590] = {
    [sym__line_break] = ACTIONS(15200),
    [sym__heredoc_body_start] = ACTIONS(15200),
    [anon_sym_COMMA] = ACTIONS(15200),
    [anon_sym_SEMI] = ACTIONS(15200),
    [sym_comment] = ACTIONS(49),
  },
  [11591] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [sym__line_break] = ACTIONS(16424),
    [anon_sym_then] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_when] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym___END__] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_end] = ACTIONS(16424),
    [anon_sym_ensure] = ACTIONS(16424),
    [anon_sym_else] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_elsif] = ACTIONS(16424),
    [ts_builtin_sym_end] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
  },
  [11592] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [sym__line_break] = ACTIONS(16494),
    [anon_sym_then] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_EQ_GT] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_when] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym___END__] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_end] = ACTIONS(16494),
    [anon_sym_ensure] = ACTIONS(16494),
    [anon_sym_else] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_elsif] = ACTIONS(16494),
    [ts_builtin_sym_end] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
    [sym__binary_minus] = ACTIONS(16494),
  },
  [11593] = {
    [aux_sym_exceptions_repeat1] = STATE(11593),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17144),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11594] = {
    [anon_sym_LT] = ACTIONS(9676),
    [anon_sym_SLASH] = ACTIONS(9678),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9686),
    [anon_sym_LT_LT] = ACTIONS(9684),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9682),
    [anon_sym_EQ_TILDE] = ACTIONS(9682),
    [anon_sym_PLUS] = ACTIONS(9690),
    [anon_sym_AMP] = ACTIONS(9692),
    [anon_sym_GT] = ACTIONS(9676),
    [anon_sym_PERCENT] = ACTIONS(9678),
    [sym__binary_star] = ACTIONS(9678),
    [anon_sym_EQ_EQ] = ACTIONS(9694),
    [anon_sym_BANG_TILDE] = ACTIONS(9682),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9682),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9696),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9682),
    [anon_sym_STAR_STAR] = ACTIONS(9678),
    [anon_sym_PIPE] = ACTIONS(9700),
    [anon_sym_DOT_DOT] = ACTIONS(9698),
    [anon_sym_AMP_AMP] = ACTIONS(9682),
    [anon_sym_LT_EQ_GT] = ACTIONS(9682),
    [anon_sym_LT_EQ] = ACTIONS(9676),
    [sym__binary_minus] = ACTIONS(9690),
    [anon_sym_CARET] = ACTIONS(9702),
  },
  [11595] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11596] = {
    [anon_sym_SLASH] = ACTIONS(16422),
    [sym__line_break] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_else] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_then] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_EQ_GT] = ACTIONS(16424),
    [anon_sym_when] = ACTIONS(16424),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym___END__] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_end] = ACTIONS(16424),
    [anon_sym_ensure] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_elsif] = ACTIONS(16424),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [ts_builtin_sym_end] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11597] = {
    [aux_sym_exceptions_repeat1] = STATE(11597),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17147),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11598] = {
    [anon_sym_LT] = ACTIONS(9831),
    [anon_sym_SLASH] = ACTIONS(9833),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9835),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9837),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9839),
    [anon_sym_LT_LT] = ACTIONS(9837),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9841),
    [anon_sym_EQ_TILDE] = ACTIONS(9841),
    [anon_sym_PLUS] = ACTIONS(9843),
    [anon_sym_AMP] = ACTIONS(9845),
    [anon_sym_GT] = ACTIONS(9831),
    [anon_sym_PERCENT] = ACTIONS(9833),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(9833),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(9847),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(9841),
    [anon_sym_PIPE_PIPE] = ACTIONS(9841),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9849),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(9841),
    [anon_sym_STAR_STAR] = ACTIONS(9833),
    [anon_sym_PIPE] = ACTIONS(9851),
    [anon_sym_DOT_DOT] = ACTIONS(9853),
    [anon_sym_AMP_AMP] = ACTIONS(9841),
    [anon_sym_LT_EQ_GT] = ACTIONS(9841),
    [anon_sym_LT_EQ] = ACTIONS(9831),
    [sym__binary_minus] = ACTIONS(9843),
    [anon_sym_CARET] = ACTIONS(9855),
  },
  [11599] = {
    [anon_sym_LT] = ACTIONS(9865),
    [anon_sym_SLASH] = ACTIONS(9867),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9869),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9871),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9873),
    [anon_sym_LT_LT] = ACTIONS(9871),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9875),
    [anon_sym_EQ_TILDE] = ACTIONS(9875),
    [anon_sym_PLUS] = ACTIONS(9877),
    [anon_sym_AMP] = ACTIONS(9879),
    [anon_sym_GT] = ACTIONS(9865),
    [anon_sym_PERCENT] = ACTIONS(9867),
    [sym__binary_star] = ACTIONS(9867),
    [anon_sym_EQ_EQ] = ACTIONS(9881),
    [anon_sym_BANG_TILDE] = ACTIONS(9875),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9875),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9883),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9875),
    [anon_sym_STAR_STAR] = ACTIONS(9867),
    [anon_sym_PIPE] = ACTIONS(9885),
    [anon_sym_DOT_DOT] = ACTIONS(9887),
    [anon_sym_AMP_AMP] = ACTIONS(9875),
    [anon_sym_LT_EQ_GT] = ACTIONS(9875),
    [anon_sym_LT_EQ] = ACTIONS(9865),
    [sym__binary_minus] = ACTIONS(9877),
    [anon_sym_CARET] = ACTIONS(9889),
  },
  [11600] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11601] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11602] = {
    [aux_sym_exceptions_repeat1] = STATE(12121),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [11603] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11604] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11605] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11606] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11607] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11608] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11609] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [11610] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11611] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11612] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11613] = {
    [aux_sym_exceptions_repeat1] = STATE(11613),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17152),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11614] = {
    [anon_sym_LT] = ACTIONS(9919),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(9921),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9923),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(9927),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9927),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9925),
    [anon_sym_EQ_TILDE] = ACTIONS(9925),
    [anon_sym_PLUS] = ACTIONS(9933),
    [anon_sym_AMP] = ACTIONS(9935),
    [anon_sym_GT] = ACTIONS(9919),
    [anon_sym_PERCENT] = ACTIONS(9921),
    [sym__binary_star] = ACTIONS(9921),
    [anon_sym_EQ_EQ] = ACTIONS(9937),
    [anon_sym_BANG_TILDE] = ACTIONS(9925),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(9925),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(9939),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(9925),
    [anon_sym_STAR_STAR] = ACTIONS(9921),
    [anon_sym_PIPE] = ACTIONS(9943),
    [anon_sym_DOT_DOT] = ACTIONS(9941),
    [anon_sym_AMP_AMP] = ACTIONS(9925),
    [anon_sym_LT_EQ_GT] = ACTIONS(9925),
    [anon_sym_LT_EQ] = ACTIONS(9919),
    [sym__binary_minus] = ACTIONS(9933),
    [anon_sym_CARET] = ACTIONS(9945),
  },
  [11615] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_then] = ACTIONS(9736),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11616] = {
    [aux_sym_undef_repeat1] = STATE(12123),
    [sym__line_break] = ACTIONS(3500),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(3500),
    [anon_sym_until] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [sym__heredoc_body_start] = ACTIONS(3500),
    [anon_sym_rescue] = ACTIONS(3500),
    [anon_sym_end] = ACTIONS(3500),
    [anon_sym_when] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(1055),
  },
  [11617] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [11618] = {
    [aux_sym_chained_string_repeat1] = STATE(11670),
    [sym_string] = STATE(11670),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [11619] = {
    [sym_assignment] = STATE(12124),
    [sym_unary] = STATE(12124),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12124),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12124),
    [sym_conditional] = STATE(12124),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12124),
    [sym_binary] = STATE(12124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11620] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [11621] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym__line_break] = ACTIONS(2055),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [sym__symbol_array_start] = ACTIONS(2055),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_rescue] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [anon_sym_when] = ACTIONS(2053),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [anon_sym_CARET] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_EQ_GT] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [11622] = {
    [sym_assignment] = STATE(12125),
    [sym_unary] = STATE(12125),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12125),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12125),
    [sym_conditional] = STATE(12125),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12125),
    [sym_binary] = STATE(12125),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11623] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(17155),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_when] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [11624] = {
    [anon_sym_COLON] = ACTIONS(17157),
    [sym_comment] = ACTIONS(49),
  },
  [11625] = {
    [sym_assignment] = STATE(12128),
    [sym_unary] = STATE(12128),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12128),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12128),
    [sym_conditional] = STATE(12128),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12128),
    [sym_binary] = STATE(12128),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11626] = {
    [sym_assignment] = STATE(12129),
    [sym_unary] = STATE(12129),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12129),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12129),
    [sym_conditional] = STATE(12129),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12129),
    [sym_binary] = STATE(12129),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11627] = {
    [sym_assignment] = STATE(12130),
    [sym_unary] = STATE(12130),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12130),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12130),
    [sym_conditional] = STATE(12130),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12130),
    [sym_binary] = STATE(12130),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11628] = {
    [sym_heredoc_body] = STATE(12132),
    [aux_sym_call_repeat1] = STATE(12132),
    [aux_sym_argument_list_repeat1] = STATE(12133),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(17159),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [11629] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [11630] = {
    [aux_sym_chained_string_repeat1] = STATE(11670),
    [sym_string] = STATE(11670),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(17161),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym__string_start] = ACTIONS(527),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [11631] = {
    [sym_heredoc_body] = STATE(12132),
    [aux_sym_call_repeat1] = STATE(12132),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [11632] = {
    [sym__argument] = STATE(12134),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(12134),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(12134),
    [sym_hash_splat_argument] = STATE(12134),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(401),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(12135),
    [sym_block_argument] = STATE(12134),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(751),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(753),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(751),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [11633] = {
    [sym__argument] = STATE(12134),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(12134),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(12134),
    [sym_hash_splat_argument] = STATE(12134),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(347),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(12135),
    [sym_block_argument] = STATE(12134),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(645),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(645),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(647),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(645),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(645),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(645),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [11634] = {
    [sym_assignment] = STATE(12136),
    [sym_unary] = STATE(12136),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12136),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12136),
    [sym_conditional] = STATE(12136),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12136),
    [sym_binary] = STATE(12136),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11635] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11636] = {
    [sym__argument] = STATE(12134),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(12134),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(12134),
    [sym_hash_splat_argument] = STATE(12134),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(393),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(12135),
    [sym_block_argument] = STATE(12134),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(735),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(735),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(735),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(735),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [11637] = {
    [sym_assignment] = STATE(12137),
    [sym_unary] = STATE(12137),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12137),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12137),
    [sym_conditional] = STATE(12137),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12137),
    [sym_binary] = STATE(12137),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11638] = {
    [sym__argument] = STATE(12134),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(12134),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(12134),
    [sym_hash_splat_argument] = STATE(12134),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_argument_list] = STATE(307),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym__argument_list_with_parens] = STATE(12135),
    [sym_block_argument] = STATE(12134),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [anon_sym_SLASH] = ACTIONS(495),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(15341),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(15343),
    [sym_self] = ACTIONS(15345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(511),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(515),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_not] = ACTIONS(15365),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(495),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(15375),
  },
  [11639] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(17163),
    [anon_sym_GT_GT_EQ] = ACTIONS(17163),
    [anon_sym_SLASH_EQ] = ACTIONS(17163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(17163),
    [anon_sym_LT_LT_EQ] = ACTIONS(17163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(17163),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(17163),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(17165),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(17163),
    [anon_sym_PLUS_EQ] = ACTIONS(17163),
    [anon_sym_STAR_EQ] = ACTIONS(17163),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(17163),
    [anon_sym_DASH_EQ] = ACTIONS(17163),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(17163),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11640] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_when] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [11641] = {
    [anon_sym_EQ] = ACTIONS(17193),
    [sym_comment] = ACTIONS(3),
  },
  [11642] = {
    [aux_sym_chained_string_repeat1] = STATE(12149),
    [sym_string] = STATE(12149),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_PERCENT] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(743),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(743),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(743),
    [sym__binary_minus] = ACTIONS(743),
  },
  [11643] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_when] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [11644] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [11645] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_heredoc_body] = STATE(12150),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym_float] = ACTIONS(15341),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(15345),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(15353),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(15365),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17195),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11646] = {
    [sym_heredoc_body] = STATE(12151),
    [aux_sym_call_repeat1] = STATE(12151),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11647] = {
    [sym_heredoc_body] = STATE(12152),
    [aux_sym_call_repeat1] = STATE(12152),
    [aux_sym_argument_list_repeat1] = STATE(12153),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16539),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11648] = {
    [sym_assignment] = STATE(12154),
    [sym_unary] = STATE(12154),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12154),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12154),
    [sym_conditional] = STATE(12154),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12154),
    [sym_binary] = STATE(12154),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11649] = {
    [sym_assignment] = STATE(12155),
    [sym_unary] = STATE(12155),
    [sym_right_assignment_list] = STATE(3297),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12155),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(12156),
    [sym_operator_assignment] = STATE(12155),
    [sym_conditional] = STATE(12155),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_subshell] = STATE(10623),
    [sym__arg_or_splat_arg] = STATE(12156),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12155),
    [sym_binary] = STATE(12155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(15345),
    [sym_character] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11650] = {
    [sym_assignment] = STATE(12157),
    [sym_unary] = STATE(12157),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12157),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12157),
    [sym_conditional] = STATE(12157),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12157),
    [sym_binary] = STATE(12157),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11651] = {
    [sym_assignment] = STATE(12158),
    [sym_unary] = STATE(12158),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12158),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12158),
    [sym_conditional] = STATE(12158),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12158),
    [sym_binary] = STATE(12158),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11652] = {
    [sym_assignment] = STATE(12159),
    [sym_unary] = STATE(12159),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12159),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12159),
    [sym_conditional] = STATE(12159),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12159),
    [sym_binary] = STATE(12159),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [11653] = {
    [sym_assignment] = STATE(12160),
    [sym_unary] = STATE(12160),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12160),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12160),
    [sym_conditional] = STATE(12160),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12160),
    [sym_binary] = STATE(12160),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11654] = {
    [sym_assignment] = STATE(12161),
    [sym_unary] = STATE(12161),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12161),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12161),
    [sym_conditional] = STATE(12161),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12161),
    [sym_binary] = STATE(12161),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11655] = {
    [sym_assignment] = STATE(12162),
    [sym_unary] = STATE(12162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12162),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12162),
    [sym_conditional] = STATE(12162),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12162),
    [sym_binary] = STATE(12162),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11656] = {
    [sym_assignment] = STATE(12164),
    [sym_unary] = STATE(12164),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12164),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12164),
    [sym_conditional] = STATE(12164),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12164),
    [sym_binary] = STATE(12164),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11657] = {
    [sym_assignment] = STATE(12165),
    [sym_unary] = STATE(12165),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12165),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12165),
    [sym_conditional] = STATE(12165),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12165),
    [sym_binary] = STATE(12165),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11658] = {
    [sym_assignment] = STATE(12166),
    [sym_unary] = STATE(12166),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12166),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12166),
    [sym_conditional] = STATE(12166),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12166),
    [sym_binary] = STATE(12166),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [11659] = {
    [sym_heredoc_body] = STATE(12171),
    [sym__argument_list_with_parens] = STATE(12170),
    [aux_sym_call_repeat1] = STATE(12171),
    [sym_argument_list_with_parens] = STATE(12169),
    [sym_operator] = STATE(12169),
    [anon_sym_LT] = ACTIONS(17197),
    [anon_sym_SLASH] = ACTIONS(17199),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17199),
    [anon_sym_PLUS_AT] = ACTIONS(17199),
    [anon_sym_LPAREN2] = ACTIONS(17201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17199),
    [anon_sym_GT_GT] = ACTIONS(17199),
    [anon_sym_EQ_TILDE] = ACTIONS(17199),
    [anon_sym_LT_LT] = ACTIONS(17199),
    [anon_sym_TILDE] = ACTIONS(17199),
    [anon_sym_PLUS] = ACTIONS(17197),
    [anon_sym_AMP] = ACTIONS(17199),
    [anon_sym_GT] = ACTIONS(17197),
    [anon_sym_PERCENT] = ACTIONS(17199),
    [anon_sym_DASH_AT] = ACTIONS(17199),
    [anon_sym_EQ_EQ] = ACTIONS(17197),
    [anon_sym_STAR] = ACTIONS(17197),
    [anon_sym_BANG_TILDE] = ACTIONS(17199),
    [sym_constant] = ACTIONS(17203),
    [anon_sym_DASH] = ACTIONS(17197),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17199),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17197),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17199),
    [anon_sym_STAR_STAR] = ACTIONS(17199),
    [anon_sym_PIPE] = ACTIONS(17199),
    [anon_sym_DOT_DOT] = ACTIONS(17199),
    [anon_sym_LT_EQ_GT] = ACTIONS(17199),
    [anon_sym_LT_EQ] = ACTIONS(17197),
    [anon_sym_BANG] = ACTIONS(17197),
    [sym_identifier] = ACTIONS(17203),
    [anon_sym_CARET] = ACTIONS(17199),
  },
  [11660] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(17205),
    [sym_identifier] = ACTIONS(17205),
  },
  [11661] = {
    [anon_sym_SLASH] = ACTIONS(1349),
    [sym__line_break] = ACTIONS(1351),
    [anon_sym_AMP_EQ] = ACTIONS(1351),
    [anon_sym_SLASH_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [sym__binary_star] = ACTIONS(1351),
    [anon_sym_unless] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [sym__symbol_array_start] = ACTIONS(1351),
    [sym_complex] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1351),
    [anon_sym_nil] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1349),
    [anon_sym_BANG_TILDE] = ACTIONS(1351),
    [sym_constant] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(17207),
    [anon_sym_defined_QMARK] = ACTIONS(1351),
    [sym__string_start] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_AMP_DOT] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [sym__identifier_hash_key] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1349),
    [sym_class_variable] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1349),
    [sym__splat_star] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1349),
    [sym__subshell_start] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_when] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_next] = ACTIONS(1349),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [sym__binary_minus] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [sym__string_array_start] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [sym_float] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1351),
    [sym_self] = ACTIONS(1349),
    [anon_sym_EQ_TILDE] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [sym_heredoc_beginning] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [sym__simple_symbol] = ACTIONS(1351),
    [anon_sym_COLON_COLON2] = ACTIONS(1351),
    [sym_super] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1351),
    [anon_sym_LBRACK2] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1351),
    [sym_character] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1349),
    [sym_instance_variable] = ACTIONS(1351),
    [sym__heredoc_body_start] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1351),
    [anon_sym_NIL] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_def] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1349),
    [sym__block_ampersand] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1349),
    [anon_sym_not] = ACTIONS(1349),
    [sym__symbol_start] = ACTIONS(1351),
    [anon_sym_TRUE] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1351),
    [anon_sym_PIPE_EQ] = ACTIONS(1351),
    [anon_sym_STAR_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [sym__unary_minus] = ACTIONS(1351),
    [sym_retry] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1351),
    [sym__regex_start] = ACTIONS(1351),
    [sym_integer] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1351),
    [anon_sym_FALSE] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ_GT] = ACTIONS(1351),
    [sym_redo] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
  },
  [11662] = {
    [anon_sym_COLON] = ACTIONS(17209),
    [sym_comment] = ACTIONS(49),
  },
  [11663] = {
    [sym_assignment] = STATE(12175),
    [sym_unary] = STATE(12175),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12175),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12175),
    [sym_conditional] = STATE(12175),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12175),
    [sym_binary] = STATE(12175),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11664] = {
    [sym_assignment] = STATE(12176),
    [sym_unary] = STATE(12176),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12176),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12176),
    [sym_conditional] = STATE(12176),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12176),
    [sym_binary] = STATE(12176),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11665] = {
    [sym_assignment] = STATE(12177),
    [sym_unary] = STATE(12177),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12177),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12177),
    [sym_conditional] = STATE(12177),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12177),
    [sym_binary] = STATE(12177),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11666] = {
    [sym_heredoc_body] = STATE(12179),
    [aux_sym_call_repeat1] = STATE(12179),
    [aux_sym_argument_list_repeat1] = STATE(12180),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(17211),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [11667] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(1511),
    [anon_sym_until] = ACTIONS(1511),
    [anon_sym_AMP_EQ] = ACTIONS(1511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1511),
    [anon_sym_SLASH_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(1511),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(1511),
    [anon_sym_rescue] = ACTIONS(1511),
    [anon_sym_PERCENT_EQ] = ACTIONS(1511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_DOT] = ACTIONS(2261),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [sym__heredoc_body_start] = ACTIONS(1511),
    [anon_sym_else] = ACTIONS(1511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_CARET_EQ] = ACTIONS(1511),
    [anon_sym_AMP_DOT] = ACTIONS(1511),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(1511),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(1511),
    [anon_sym_when] = ACTIONS(1511),
    [anon_sym_PIPE_EQ] = ACTIONS(1511),
    [anon_sym_PLUS_EQ] = ACTIONS(1511),
    [anon_sym_STAR_EQ] = ACTIONS(1511),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(1511),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1511),
    [anon_sym_DASH_EQ] = ACTIONS(1511),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1511),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [11668] = {
    [aux_sym_chained_string_repeat1] = STATE(11726),
    [sym_string] = STATE(11726),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_COLON] = ACTIONS(17213),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11669] = {
    [sym_heredoc_body] = STATE(12179),
    [aux_sym_call_repeat1] = STATE(12179),
    [anon_sym_SLASH] = ACTIONS(2233),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_AMP_EQ] = ACTIONS(2235),
    [anon_sym_GT_GT_EQ] = ACTIONS(2235),
    [anon_sym_SLASH_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_PERCENT_EQ] = ACTIONS(2235),
    [anon_sym_LT_LT_EQ] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_CARET_EQ] = ACTIONS(2235),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_EQ_GT] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_PIPE_EQ] = ACTIONS(2235),
    [anon_sym_PLUS_EQ] = ACTIONS(2235),
    [anon_sym_STAR_EQ] = ACTIONS(2235),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2235),
    [anon_sym_DASH_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [sym__binary_minus] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
  },
  [11670] = {
    [aux_sym_chained_string_repeat1] = STATE(12181),
    [sym_string] = STATE(12181),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [11671] = {
    [sym__line_break] = ACTIONS(6698),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(6698),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6698),
    [anon_sym_when] = ACTIONS(6698),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6698),
    [sym__heredoc_body_start] = ACTIONS(6698),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6698),
    [anon_sym_else] = ACTIONS(6698),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(6698),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [11672] = {
    [sym__line_break] = ACTIONS(6700),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(6700),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6700),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(6700),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6700),
    [anon_sym_when] = ACTIONS(6700),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6700),
    [sym__heredoc_body_start] = ACTIONS(6700),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6700),
    [anon_sym_else] = ACTIONS(6700),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(6700),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [11673] = {
    [sym__line_break] = ACTIONS(6702),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6702),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(6702),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6702),
    [anon_sym_when] = ACTIONS(6702),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6702),
    [sym__heredoc_body_start] = ACTIONS(6702),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6702),
    [anon_sym_else] = ACTIONS(6702),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(6702),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [11674] = {
    [sym_float] = ACTIONS(6215),
    [anon_sym_until] = ACTIONS(6215),
    [anon_sym_undef] = ACTIONS(6215),
    [sym_self] = ACTIONS(6215),
    [anon_sym_BEGIN] = ACTIONS(6215),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_unless] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [sym__symbol_array_start] = ACTIONS(4446),
    [sym__simple_symbol] = ACTIONS(4446),
    [sym_complex] = ACTIONS(4446),
    [sym_heredoc_beginning] = ACTIONS(4446),
    [sym_super] = ACTIONS(6215),
    [anon_sym_alias] = ACTIONS(6215),
    [anon_sym_LBRACK2] = ACTIONS(4446),
    [anon_sym_nil] = ACTIONS(6215),
    [sym_character] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_END] = ACTIONS(6215),
    [sym_constant] = ACTIONS(6215),
    [anon_sym_while] = ACTIONS(6215),
    [sym_instance_variable] = ACTIONS(4446),
    [anon_sym_defined_QMARK] = ACTIONS(4446),
    [sym__string_start] = ACTIONS(4446),
    [anon_sym_else] = ACTIONS(6215),
    [anon_sym_true] = ACTIONS(6215),
    [anon_sym_for] = ACTIONS(6215),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(4446),
    [anon_sym_NIL] = ACTIONS(6215),
    [anon_sym_COLON_COLON] = ACTIONS(4446),
    [anon_sym_def] = ACTIONS(6215),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_yield] = ACTIONS(6215),
    [sym_class_variable] = ACTIONS(4446),
    [anon_sym_not] = ACTIONS(6215),
    [sym__symbol_start] = ACTIONS(4446),
    [anon_sym_TRUE] = ACTIONS(6215),
    [anon_sym_case] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_break] = ACTIONS(6215),
    [sym_global_variable] = ACTIONS(4446),
    [anon_sym_class] = ACTIONS(6215),
    [sym__subshell_start] = ACTIONS(4446),
    [anon_sym_module] = ACTIONS(6215),
    [anon_sym_begin] = ACTIONS(6215),
    [anon_sym_false] = ACTIONS(6215),
    [anon_sym_when] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(4446),
    [sym__unary_minus] = ACTIONS(4446),
    [anon_sym_next] = ACTIONS(6215),
    [sym_retry] = ACTIONS(6215),
    [sym__regex_start] = ACTIONS(4446),
    [anon_sym_end] = ACTIONS(6215),
    [sym_integer] = ACTIONS(6215),
    [anon_sym_FALSE] = ACTIONS(6215),
    [sym_redo] = ACTIONS(6215),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_if] = ACTIONS(6215),
    [sym__string_array_start] = ACTIONS(4446),
    [anon_sym_return] = ACTIONS(6215),
  },
  [11675] = {
    [aux_sym_heredoc_body_repeat1] = STATE(2609),
    [sym_interpolation] = STATE(2609),
    [sym_comment] = ACTIONS(3),
    [sym__heredoc_content] = ACTIONS(4448),
    [sym_heredoc_end] = ACTIONS(17215),
    [anon_sym_POUND_LBRACE] = ACTIONS(1651),
    [sym_escape_sequence] = ACTIONS(4448),
  },
  [11676] = {
    [sym__line_break] = ACTIONS(6706),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(6706),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6706),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(6706),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6706),
    [anon_sym_when] = ACTIONS(6706),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6706),
    [sym__heredoc_body_start] = ACTIONS(6706),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6706),
    [anon_sym_else] = ACTIONS(6706),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(6706),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [11677] = {
    [sym__line_break] = ACTIONS(6708),
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [anon_sym_until] = ACTIONS(6708),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6708),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(15449),
    [anon_sym_unless] = ACTIONS(6708),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6708),
    [anon_sym_when] = ACTIONS(6708),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(15449),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6708),
    [sym__heredoc_body_start] = ACTIONS(6708),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6708),
    [anon_sym_else] = ACTIONS(6708),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_PIPE] = ACTIONS(15461),
    [sym__binary_minus] = ACTIONS(15451),
    [anon_sym_if] = ACTIONS(6708),
    [anon_sym_CARET] = ACTIONS(15463),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
  },
  [11678] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_rescue] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_when] = ACTIONS(1327),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_end] = ACTIONS(1327),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [11679] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(12184),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(17217),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [11680] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_rescue] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_when] = ACTIONS(6719),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [anon_sym_end] = ACTIONS(6719),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [11681] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_rescue] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_when] = ACTIONS(6727),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [anon_sym_end] = ACTIONS(6727),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [11682] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(11681),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(12185),
    [sym_operator] = STATE(12185),
    [anon_sym_LT] = ACTIONS(16593),
    [anon_sym_SLASH] = ACTIONS(16595),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(16595),
    [anon_sym_PLUS_AT] = ACTIONS(16595),
    [anon_sym_LPAREN2] = ACTIONS(16597),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16595),
    [anon_sym_GT_GT] = ACTIONS(16595),
    [anon_sym_EQ_TILDE] = ACTIONS(16595),
    [anon_sym_LT_LT] = ACTIONS(16595),
    [anon_sym_TILDE] = ACTIONS(16595),
    [anon_sym_PLUS] = ACTIONS(16593),
    [anon_sym_AMP] = ACTIONS(16595),
    [anon_sym_GT] = ACTIONS(16593),
    [anon_sym_PERCENT] = ACTIONS(16595),
    [anon_sym_DASH_AT] = ACTIONS(16595),
    [anon_sym_EQ_EQ] = ACTIONS(16593),
    [anon_sym_STAR] = ACTIONS(16593),
    [anon_sym_BANG_TILDE] = ACTIONS(16595),
    [sym_constant] = ACTIONS(17219),
    [anon_sym_DASH] = ACTIONS(16593),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(16595),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(16593),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(16595),
    [anon_sym_STAR_STAR] = ACTIONS(16595),
    [anon_sym_PIPE] = ACTIONS(16595),
    [anon_sym_DOT_DOT] = ACTIONS(16595),
    [anon_sym_LT_EQ_GT] = ACTIONS(16595),
    [anon_sym_LT_EQ] = ACTIONS(16593),
    [anon_sym_BANG] = ACTIONS(16593),
    [sym_identifier] = ACTIONS(17219),
    [anon_sym_CARET] = ACTIONS(16595),
  },
  [11683] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [anon_sym_end] = ACTIONS(6739),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [11684] = {
    [sym_assignment] = STATE(12186),
    [sym_unary] = STATE(12186),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12186),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12186),
    [sym_conditional] = STATE(12186),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12186),
    [sym_binary] = STATE(12186),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11685] = {
    [sym_assignment] = STATE(12187),
    [sym_unary] = STATE(12187),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12187),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12187),
    [sym_conditional] = STATE(12187),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12187),
    [sym_binary] = STATE(12187),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11686] = {
    [sym_assignment] = STATE(91),
    [sym_unary] = STATE(91),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(91),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(91),
    [sym_conditional] = STATE(91),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(91),
    [sym_binary] = STATE(91),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11687] = {
    [sym_assignment] = STATE(12188),
    [sym_unary] = STATE(12188),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12188),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12188),
    [sym_conditional] = STATE(12188),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12188),
    [sym_binary] = STATE(12188),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [11688] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(17221),
    [anon_sym_GT_GT_EQ] = ACTIONS(17221),
    [anon_sym_SLASH_EQ] = ACTIONS(17221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(17221),
    [anon_sym_LT_LT_EQ] = ACTIONS(17221),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(17221),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(17221),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(17223),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(17221),
    [anon_sym_PLUS_EQ] = ACTIONS(17221),
    [anon_sym_STAR_EQ] = ACTIONS(17221),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(17221),
    [anon_sym_DASH_EQ] = ACTIONS(17221),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(17221),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11689] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_when] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [11690] = {
    [anon_sym_EQ] = ACTIONS(17251),
    [sym_comment] = ACTIONS(3),
  },
  [11691] = {
    [aux_sym_exceptions_repeat1] = STATE(12201),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(17253),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11692] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [11693] = {
    [aux_sym_chained_string_repeat1] = STATE(11726),
    [sym_string] = STATE(11726),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(743),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11694] = {
    [sym_assignment] = STATE(12202),
    [sym_unary] = STATE(12202),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12202),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12202),
    [sym_conditional] = STATE(12202),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12202),
    [sym_binary] = STATE(12202),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [11695] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [11696] = {
    [sym_assignment] = STATE(12203),
    [sym_unary] = STATE(12203),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12203),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12203),
    [sym_conditional] = STATE(12203),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12203),
    [sym_binary] = STATE(12203),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [11697] = {
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(4067),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym__line_break] = ACTIONS(751),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(751),
    [anon_sym_EQ_TILDE] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(753),
    [sym__binary_star] = ACTIONS(751),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(751),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(753),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(751),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_BANG_TILDE] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(753),
    [sym__heredoc_body_start] = ACTIONS(751),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(753),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(753),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(753),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(753),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(753),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(753),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(753),
    [anon_sym_PIPE_PIPE] = ACTIONS(753),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_end] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(751),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(751),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(753),
    [anon_sym_LT_EQ_GT] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(753),
    [sym__binary_minus] = ACTIONS(751),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [11698] = {
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(4078),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(647),
    [sym__line_break] = ACTIONS(645),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(645),
    [anon_sym_GT_GT_EQ] = ACTIONS(645),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(645),
    [anon_sym_EQ_TILDE] = ACTIONS(645),
    [anon_sym_LT_LT] = ACTIONS(647),
    [sym__binary_star] = ACTIONS(645),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_AMP] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(645),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(647),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(645),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(645),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(645),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(647),
    [anon_sym_BANG_TILDE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(647),
    [sym__heredoc_body_start] = ACTIONS(645),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(645),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(647),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(647),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(645),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(647),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(647),
    [anon_sym_PIPE_EQ] = ACTIONS(645),
    [anon_sym_PLUS_EQ] = ACTIONS(645),
    [anon_sym_STAR_EQ] = ACTIONS(645),
    [anon_sym_EQ_EQ] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(645),
    [anon_sym_end] = ACTIONS(647),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(645),
    [anon_sym_DASH_EQ] = ACTIONS(645),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(645),
    [anon_sym_BANG_EQ] = ACTIONS(645),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_LT_EQ_GT] = ACTIONS(645),
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [sym__binary_minus] = ACTIONS(645),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_CARET] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [11699] = {
    [sym_assignment] = STATE(12204),
    [sym_unary] = STATE(12204),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12204),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12204),
    [sym_conditional] = STATE(12204),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12204),
    [sym_binary] = STATE(12204),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [11700] = {
    [sym_assignment] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [11701] = {
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(4103),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(737),
    [sym__line_break] = ACTIONS(735),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(735),
    [anon_sym_EQ_TILDE] = ACTIONS(735),
    [anon_sym_LT_LT] = ACTIONS(737),
    [sym__binary_star] = ACTIONS(735),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(735),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(735),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(735),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(737),
    [sym__heredoc_body_start] = ACTIONS(735),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(737),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(737),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(735),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(737),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(735),
    [anon_sym_end] = ACTIONS(737),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(735),
    [anon_sym_BANG_EQ] = ACTIONS(735),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(735),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [sym__binary_minus] = ACTIONS(735),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [11702] = {
    [sym_assignment] = STATE(12205),
    [sym_unary] = STATE(12205),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12205),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12205),
    [sym_conditional] = STATE(12205),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12205),
    [sym_binary] = STATE(12205),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [11703] = {
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_argument_list] = STATE(4118),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(501),
    [sym__line_break] = ACTIONS(495),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(495),
    [anon_sym_GT_GT_EQ] = ACTIONS(495),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_TILDE] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(501),
    [sym__binary_star] = ACTIONS(495),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(495),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(501),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(495),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(495),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(495),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_BANG_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(501),
    [sym__heredoc_body_start] = ACTIONS(495),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(495),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(501),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(501),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(501),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(501),
    [anon_sym_PIPE_EQ] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(495),
    [anon_sym_STAR_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(501),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(495),
    [anon_sym_DASH_EQ] = ACTIONS(495),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ_GT] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [sym__binary_minus] = ACTIONS(495),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [11704] = {
    [aux_sym__mlhs_repeat1] = STATE(410),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(17255),
    [anon_sym_GT_GT_EQ] = ACTIONS(17255),
    [anon_sym_SLASH_EQ] = ACTIONS(17255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(17255),
    [anon_sym_LT_LT_EQ] = ACTIONS(17255),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(17255),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(17255),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(17257),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(17255),
    [anon_sym_PLUS_EQ] = ACTIONS(17255),
    [anon_sym_STAR_EQ] = ACTIONS(17255),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(17255),
    [anon_sym_DASH_EQ] = ACTIONS(17255),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(17255),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11705] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [11706] = {
    [anon_sym_SLASH] = ACTIONS(775),
    [sym__line_break] = ACTIONS(777),
    [anon_sym_until] = ACTIONS(777),
    [anon_sym_AMP_EQ] = ACTIONS(777),
    [anon_sym_GT_GT_EQ] = ACTIONS(777),
    [anon_sym_SLASH_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(777),
    [anon_sym_EQ_TILDE] = ACTIONS(777),
    [anon_sym_LT_LT] = ACTIONS(775),
    [sym__binary_star] = ACTIONS(777),
    [anon_sym_unless] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_COLON_COLON2] = ACTIONS(15391),
    [anon_sym_rescue] = ACTIONS(777),
    [anon_sym_PERCENT_EQ] = ACTIONS(777),
    [anon_sym_LT_LT_EQ] = ACTIONS(777),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(15393),
    [anon_sym_BANG_TILDE] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [sym__heredoc_body_start] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_CARET_EQ] = ACTIONS(777),
    [anon_sym_AMP_DOT] = ACTIONS(15395),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(777),
    [anon_sym_or] = ACTIONS(777),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_when] = ACTIONS(777),
    [anon_sym_PIPE_EQ] = ACTIONS(777),
    [anon_sym_PLUS_EQ] = ACTIONS(777),
    [anon_sym_STAR_EQ] = ACTIONS(777),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(777),
    [anon_sym_end] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(777),
    [anon_sym_DASH_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(777),
    [anon_sym_BANG_EQ] = ACTIONS(777),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_LT_EQ_GT] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [sym__binary_minus] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_CARET] = ACTIONS(775),
  },
  [11707] = {
    [sym_block] = STATE(451),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym__primary] = STATE(10650),
    [sym_argument_list] = STATE(530),
    [sym_hash_splat_argument] = STATE(10653),
    [sym_method] = STATE(10650),
    [sym_conditional] = STATE(10655),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_subshell] = STATE(10650),
    [sym_unless] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_block_argument] = STATE(10653),
    [sym_range] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_false] = STATE(10654),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_call] = STATE(10652),
    [sym__argument] = STATE(10653),
    [sym_assignment] = STATE(10655),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_pair] = STATE(10653),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(10653),
    [sym_operator_assignment] = STATE(10655),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_rational] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_lambda] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym__argument_list_with_parens] = STATE(10657),
    [sym_do_block] = STATE(451),
    [sym_binary] = STATE(10655),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_nil] = STATE(10654),
    [sym_symbol_array] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_scope_resolution] = STATE(10652),
    [anon_sym_SLASH] = ACTIONS(791),
    [sym__line_break] = ACTIONS(793),
    [sym_float] = ACTIONS(15399),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_until] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(15401),
    [anon_sym_AMP_EQ] = ACTIONS(793),
    [anon_sym_GT_GT_EQ] = ACTIONS(793),
    [sym_self] = ACTIONS(15403),
    [anon_sym_SLASH_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(793),
    [anon_sym_EQ_TILDE] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(791),
    [sym__binary_star] = ACTIONS(793),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_COLON_COLON2] = ACTIONS(793),
    [sym__symbol_array_start] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(791),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PERCENT_EQ] = ACTIONS(793),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_LT_LT_EQ] = ACTIONS(793),
    [sym_super] = ACTIONS(15403),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(793),
    [anon_sym_LBRACK2] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_BANG_TILDE] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(791),
    [sym__heredoc_body_start] = ACTIONS(793),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_CARET_EQ] = ACTIONS(793),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_AMP_DOT] = ACTIONS(793),
    [anon_sym_COLON_COLON] = ACTIONS(15357),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_EQ] = ACTIONS(791),
    [sym_class_variable] = ACTIONS(15411),
    [anon_sym_LT] = ACTIONS(791),
    [sym__block_ampersand] = ACTIONS(15419),
    [anon_sym_not] = ACTIONS(15421),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_LPAREN2] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(791),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_when] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(793),
    [anon_sym_PLUS_EQ] = ACTIONS(793),
    [anon_sym_STAR_EQ] = ACTIONS(793),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [anon_sym_GT_EQ] = ACTIONS(793),
    [anon_sym_end] = ACTIONS(791),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(793),
    [anon_sym_DASH_EQ] = ACTIONS(793),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(793),
    [anon_sym_BANG_EQ] = ACTIONS(793),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_LT_EQ_GT] = ACTIONS(793),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [sym__binary_minus] = ACTIONS(793),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(15431),
  },
  [11708] = {
    [anon_sym_EQ] = ACTIONS(17287),
    [sym_comment] = ACTIONS(3),
  },
  [11709] = {
    [aux_sym_chained_string_repeat1] = STATE(12217),
    [sym_string] = STATE(12217),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym__line_break] = ACTIONS(743),
    [anon_sym_until] = ACTIONS(743),
    [anon_sym_AMP_EQ] = ACTIONS(743),
    [anon_sym_GT_GT_EQ] = ACTIONS(743),
    [anon_sym_SLASH_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(743),
    [anon_sym_EQ_TILDE] = ACTIONS(743),
    [anon_sym_LT_LT] = ACTIONS(741),
    [sym__binary_star] = ACTIONS(743),
    [anon_sym_unless] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [anon_sym_COLON_COLON2] = ACTIONS(743),
    [anon_sym_rescue] = ACTIONS(743),
    [anon_sym_PERCENT_EQ] = ACTIONS(743),
    [anon_sym_LT_LT_EQ] = ACTIONS(743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(741),
    [anon_sym_BANG_TILDE] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [sym__heredoc_body_start] = ACTIONS(743),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_CARET_EQ] = ACTIONS(743),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(743),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(743),
    [anon_sym_or] = ACTIONS(743),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_when] = ACTIONS(743),
    [anon_sym_PIPE_EQ] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(743),
    [anon_sym_STAR_EQ] = ACTIONS(743),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_and] = ACTIONS(743),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(743),
    [anon_sym_end] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(743),
    [anon_sym_DASH_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(743),
    [anon_sym_BANG_EQ] = ACTIONS(743),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_LT_EQ_GT] = ACTIONS(743),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [sym__binary_minus] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_CARET] = ACTIONS(741),
  },
  [11710] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [11711] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [11712] = {
    [sym_assignment] = STATE(12218),
    [sym_unary] = STATE(12218),
    [sym_right_assignment_list] = STATE(4162),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12218),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(12219),
    [sym_operator_assignment] = STATE(12218),
    [sym_conditional] = STATE(12218),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_subshell] = STATE(10650),
    [sym__arg_or_splat_arg] = STATE(12219),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12218),
    [sym_binary] = STATE(12218),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(15403),
    [sym_character] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11713] = {
    [sym__argument] = STATE(4167),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(4167),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(4167),
    [sym_hash_splat_argument] = STATE(4167),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_heredoc_body] = STATE(12220),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_block_argument] = STATE(4167),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(15403),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(15403),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(15411),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [sym__block_ampersand] = ACTIONS(15419),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(15421),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17289),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11714] = {
    [sym_heredoc_body] = STATE(12221),
    [aux_sym_call_repeat1] = STATE(12221),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [11715] = {
    [sym_heredoc_body] = STATE(12222),
    [aux_sym_call_repeat1] = STATE(12222),
    [aux_sym_argument_list_repeat1] = STATE(12223),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16649),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [11716] = {
    [sym_assignment] = STATE(12224),
    [sym_unary] = STATE(12224),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12224),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12224),
    [sym_conditional] = STATE(12224),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12224),
    [sym_binary] = STATE(12224),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11717] = {
    [sym_assignment] = STATE(12225),
    [sym_unary] = STATE(12225),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12225),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12225),
    [sym_conditional] = STATE(12225),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12225),
    [sym_binary] = STATE(12225),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11718] = {
    [sym_assignment] = STATE(12226),
    [sym_unary] = STATE(12226),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12226),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12226),
    [sym_conditional] = STATE(12226),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12226),
    [sym_binary] = STATE(12226),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11719] = {
    [sym_assignment] = STATE(12227),
    [sym_unary] = STATE(12227),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12227),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12227),
    [sym_conditional] = STATE(12227),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12227),
    [sym_binary] = STATE(12227),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [11720] = {
    [sym_assignment] = STATE(12228),
    [sym_unary] = STATE(12228),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12228),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12228),
    [sym_conditional] = STATE(12228),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12228),
    [sym_binary] = STATE(12228),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11721] = {
    [sym_assignment] = STATE(12229),
    [sym_unary] = STATE(12229),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12229),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12229),
    [sym_conditional] = STATE(12229),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12229),
    [sym_binary] = STATE(12229),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11722] = {
    [sym_assignment] = STATE(12230),
    [sym_unary] = STATE(12230),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12230),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12230),
    [sym_conditional] = STATE(12230),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12230),
    [sym_binary] = STATE(12230),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11723] = {
    [sym_assignment] = STATE(12232),
    [sym_unary] = STATE(12232),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12232),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12232),
    [sym_conditional] = STATE(12232),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12232),
    [sym_binary] = STATE(12232),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11724] = {
    [sym_assignment] = STATE(12233),
    [sym_unary] = STATE(12233),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12233),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12233),
    [sym_conditional] = STATE(12233),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12233),
    [sym_binary] = STATE(12233),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11725] = {
    [sym_assignment] = STATE(12234),
    [sym_unary] = STATE(12234),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12234),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12234),
    [sym_conditional] = STATE(12234),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12234),
    [sym_binary] = STATE(12234),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [11726] = {
    [aux_sym_chained_string_repeat1] = STATE(12235),
    [sym_string] = STATE(12235),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [11727] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_when] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11728] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11729] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11730] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11731] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11732] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17291),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11733] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11734] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_when] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11735] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11736] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11737] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [11738] = {
    [aux_sym_chained_string_repeat1] = STATE(11738),
    [sym_string] = STATE(11738),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_when] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [11739] = {
    [sym_heredoc_body] = STATE(10634),
    [sym__terminator] = STATE(10634),
    [sym__line_break] = ACTIONS(15377),
    [anon_sym_unless] = ACTIONS(7198),
    [anon_sym_until] = ACTIONS(7200),
    [anon_sym_while] = ACTIONS(7202),
    [sym__heredoc_body_start] = ACTIONS(15385),
    [anon_sym_rescue] = ACTIONS(7204),
    [anon_sym_SEMI] = ACTIONS(15377),
    [anon_sym_if] = ACTIONS(7206),
    [sym_comment] = ACTIONS(49),
  },
  [11740] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11741] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11742] = {
    [aux_sym_exceptions_repeat1] = STATE(12238),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11743] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11744] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11745] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11746] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11747] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11748] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11749] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [11750] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11751] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11752] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11753] = {
    [aux_sym_chained_string_repeat1] = STATE(11753),
    [sym_string] = STATE(11753),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11754] = {
    [aux_sym_exceptions_repeat1] = STATE(11754),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17295),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11755] = {
    [anon_sym_LT] = ACTIONS(9993),
    [anon_sym_SLASH] = ACTIONS(9995),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(9997),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9999),
    [anon_sym_LT_LT] = ACTIONS(10001),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10001),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10003),
    [anon_sym_AMP] = ACTIONS(10005),
    [anon_sym_EQ_TILDE] = ACTIONS(10003),
    [anon_sym_GT] = ACTIONS(9993),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(10007),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(9995),
    [sym__binary_star] = ACTIONS(9995),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10009),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(10003),
    [anon_sym_PIPE_PIPE] = ACTIONS(10003),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10011),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10003),
    [anon_sym_STAR_STAR] = ACTIONS(9995),
    [anon_sym_PIPE] = ACTIONS(10013),
    [anon_sym_DOT_DOT] = ACTIONS(10015),
    [anon_sym_AMP_AMP] = ACTIONS(10003),
    [anon_sym_LT_EQ_GT] = ACTIONS(10003),
    [anon_sym_LT_EQ] = ACTIONS(9993),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10017),
    [sym__binary_minus] = ACTIONS(10007),
  },
  [11756] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_RPAREN] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [11757] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_RPAREN] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [11758] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(8876),
    [sym_unary] = STATE(8876),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(3496),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(8876),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(3496),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(8876),
    [sym_conditional] = STATE(8876),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(3128),
    [sym_left_assignment_list] = STATE(3494),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(8877),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(3496),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(3496),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(8876),
    [sym_binary] = STATE(8876),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(3496),
    [sym_nil] = STATE(3496),
    [sym_scope_resolution] = STATE(3128),
    [sym_call] = STATE(3128),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(5310),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(5844),
    [anon_sym_TILDE] = ACTIONS(5846),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(5310),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(5318),
    [anon_sym_defined_QMARK] = ACTIONS(5850),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(13415),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(13413),
    [anon_sym_yield] = ACTIONS(5854),
    [sym_class_variable] = ACTIONS(5318),
    [sym__block_ampersand] = ACTIONS(13417),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(5856),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(5862),
    [sym_global_variable] = ACTIONS(5318),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(5864),
    [anon_sym_next] = ACTIONS(5866),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(16699),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(5870),
  },
  [11759] = {
    [sym_heredoc_body] = STATE(11759),
    [aux_sym_call_repeat1] = STATE(11759),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [11760] = {
    [sym_heredoc_body] = STATE(11759),
    [aux_sym_call_repeat1] = STATE(11759),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_RPAREN] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [11761] = {
    [aux_sym_argument_list_repeat1] = STATE(11761),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17298),
    [anon_sym_RPAREN] = ACTIONS(8457),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [11762] = {
    [sym_assignment] = STATE(10716),
    [sym_unary] = STATE(10716),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(10716),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(10716),
    [sym_conditional] = STATE(10716),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_return] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_true] = STATE(6273),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(10716),
    [sym_binary] = STATE(10716),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(13419),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [sym_global_variable] = ACTIONS(9540),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(9532),
    [sym_character] = ACTIONS(5482),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [11763] = {
    [aux_sym_exceptions_repeat1] = STATE(12240),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17301),
    [anon_sym_RPAREN] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11764] = {
    [sym_assignment] = STATE(12241),
    [sym_unary] = STATE(12241),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6273),
    [sym_singleton_class] = STATE(3234),
    [sym_module] = STATE(3234),
    [sym_chained_string] = STATE(3234),
    [sym_until] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_for] = STATE(3234),
    [sym_symbol] = STATE(3234),
    [sym_if] = STATE(3234),
    [sym_begin] = STATE(3234),
    [sym__arg] = STATE(12241),
    [sym__primary] = STATE(3234),
    [sym_method_call] = STATE(6273),
    [sym_operator_assignment] = STATE(12241),
    [sym_conditional] = STATE(12241),
    [sym_method] = STATE(3234),
    [sym_singleton_method] = STATE(3234),
    [sym__variable] = STATE(5889),
    [sym_left_assignment_list] = STATE(6275),
    [sym_rational] = STATE(3234),
    [sym_true] = STATE(6273),
    [sym_return] = STATE(3234),
    [sym_subshell] = STATE(3234),
    [sym_yield] = STATE(3234),
    [sym_string] = STATE(6276),
    [sym_unless] = STATE(3234),
    [sym_lambda] = STATE(3234),
    [sym_parenthesized_statements] = STATE(3234),
    [sym_element_reference] = STATE(6273),
    [sym_range] = STATE(12241),
    [sym_binary] = STATE(12241),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3234),
    [sym_break] = STATE(3234),
    [sym_next] = STATE(3234),
    [sym_string_array] = STATE(3234),
    [sym_while] = STATE(3234),
    [sym_case] = STATE(3234),
    [sym_symbol_array] = STATE(3234),
    [sym_array] = STATE(3234),
    [sym_hash] = STATE(3234),
    [sym_false] = STATE(6273),
    [sym_nil] = STATE(6273),
    [sym_scope_resolution] = STATE(5889),
    [sym_call] = STATE(5889),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(5470),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(10065),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(10067),
    [anon_sym_not] = ACTIONS(10069),
    [sym_self] = ACTIONS(9532),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(10071),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(5482),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(10073),
    [anon_sym_TILDE] = ACTIONS(10067),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(9540),
    [sym_character] = ACTIONS(5482),
    [sym_super] = ACTIONS(9532),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(10075),
    [anon_sym_next] = ACTIONS(10077),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(5470),
    [sym_constant] = ACTIONS(9532),
    [anon_sym_defined_QMARK] = ACTIONS(10079),
    [sym_instance_variable] = ACTIONS(9540),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(5494),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(9532),
    [sym_redo] = ACTIONS(5470),
    [sym_class_variable] = ACTIONS(9540),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(10081),
  },
  [11765] = {
    [aux_sym_exceptions_repeat1] = STATE(11765),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17303),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11766] = {
    [anon_sym_LT] = ACTIONS(10091),
    [anon_sym_SLASH] = ACTIONS(10093),
    [anon_sym_QMARK] = ACTIONS(10095),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10101),
    [anon_sym_LT_LT] = ACTIONS(10099),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10097),
    [anon_sym_EQ_TILDE] = ACTIONS(10097),
    [anon_sym_PLUS] = ACTIONS(10105),
    [anon_sym_AMP] = ACTIONS(10107),
    [anon_sym_GT] = ACTIONS(10091),
    [anon_sym_PERCENT] = ACTIONS(10093),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(10093),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10109),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10097),
    [anon_sym_BANG_TILDE] = ACTIONS(10097),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10111),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10097),
    [anon_sym_STAR_STAR] = ACTIONS(10093),
    [anon_sym_PIPE] = ACTIONS(10115),
    [anon_sym_DOT_DOT] = ACTIONS(10113),
    [anon_sym_AMP_AMP] = ACTIONS(10097),
    [anon_sym_LT_EQ_GT] = ACTIONS(10097),
    [anon_sym_LT_EQ] = ACTIONS(10091),
    [sym__binary_minus] = ACTIONS(10105),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(10117),
  },
  [11767] = {
    [anon_sym_LT] = ACTIONS(10134),
    [anon_sym_SLASH] = ACTIONS(10136),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_LT_LT] = ACTIONS(10142),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10142),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10144),
    [anon_sym_AMP] = ACTIONS(10146),
    [anon_sym_EQ_TILDE] = ACTIONS(10144),
    [anon_sym_GT] = ACTIONS(10134),
    [anon_sym_PLUS] = ACTIONS(10148),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(10136),
    [anon_sym_EQ_EQ] = ACTIONS(10150),
    [anon_sym_BANG_TILDE] = ACTIONS(10144),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10144),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10152),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10144),
    [anon_sym_STAR_STAR] = ACTIONS(10136),
    [anon_sym_PIPE] = ACTIONS(10154),
    [anon_sym_DOT_DOT] = ACTIONS(10156),
    [anon_sym_AMP_AMP] = ACTIONS(10144),
    [anon_sym_LT_EQ_GT] = ACTIONS(10144),
    [anon_sym_LT_EQ] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10158),
    [sym__binary_minus] = ACTIONS(10148),
  },
  [11768] = {
    [aux_sym_exceptions_repeat1] = STATE(11768),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17306),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11769] = {
    [anon_sym_SLASH] = ACTIONS(10168),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10170),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10170),
    [anon_sym_LT_LT] = ACTIONS(10172),
    [sym__binary_star] = ACTIONS(10174),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(10176),
    [anon_sym_AMP] = ACTIONS(10178),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(10170),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(10180),
    [anon_sym_PIPE] = ACTIONS(10182),
    [anon_sym_DOT_DOT] = ACTIONS(10184),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(10180),
    [anon_sym_QMARK] = ACTIONS(10186),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10172),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10188),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(10180),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(10190),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10190),
    [anon_sym_GT_EQ] = ACTIONS(10192),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10170),
    [anon_sym_STAR_STAR] = ACTIONS(10168),
    [anon_sym_LT_EQ_GT] = ACTIONS(10170),
    [anon_sym_AMP_AMP] = ACTIONS(10190),
    [sym__binary_minus] = ACTIONS(10194),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10182),
  },
  [11770] = {
    [aux_sym_exceptions_repeat1] = STATE(11770),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17309),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11771] = {
    [anon_sym_LT] = ACTIONS(10228),
    [anon_sym_SLASH] = ACTIONS(10230),
    [anon_sym_QMARK] = ACTIONS(10232),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10238),
    [anon_sym_LT_LT] = ACTIONS(10236),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10234),
    [sym__binary_star] = ACTIONS(10230),
    [anon_sym_PLUS] = ACTIONS(10242),
    [anon_sym_AMP] = ACTIONS(10244),
    [anon_sym_GT] = ACTIONS(10228),
    [anon_sym_PERCENT] = ACTIONS(10230),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10246),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10234),
    [anon_sym_BANG_TILDE] = ACTIONS(10234),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10248),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10234),
    [anon_sym_STAR_STAR] = ACTIONS(10230),
    [anon_sym_PIPE] = ACTIONS(10252),
    [anon_sym_DOT_DOT] = ACTIONS(10250),
    [anon_sym_AMP_AMP] = ACTIONS(10234),
    [anon_sym_LT_EQ_GT] = ACTIONS(10234),
    [anon_sym_LT_EQ] = ACTIONS(10228),
    [sym__binary_minus] = ACTIONS(10242),
    [anon_sym_CARET] = ACTIONS(10254),
  },
  [11772] = {
    [aux_sym_exceptions_repeat1] = STATE(11772),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17312),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11773] = {
    [anon_sym_LT] = ACTIONS(10276),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(10278),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10280),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10282),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10284),
    [anon_sym_LT_LT] = ACTIONS(10282),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10286),
    [anon_sym_EQ_TILDE] = ACTIONS(10286),
    [anon_sym_PLUS] = ACTIONS(10288),
    [anon_sym_AMP] = ACTIONS(10290),
    [anon_sym_GT] = ACTIONS(10276),
    [anon_sym_PERCENT] = ACTIONS(10278),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(10278),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10292),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(10286),
    [anon_sym_PIPE_PIPE] = ACTIONS(10286),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10294),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10286),
    [anon_sym_STAR_STAR] = ACTIONS(10278),
    [anon_sym_PIPE] = ACTIONS(10296),
    [anon_sym_DOT_DOT] = ACTIONS(10298),
    [anon_sym_AMP_AMP] = ACTIONS(10286),
    [anon_sym_LT_EQ_GT] = ACTIONS(10286),
    [anon_sym_LT_EQ] = ACTIONS(10276),
    [sym__binary_minus] = ACTIONS(10288),
    [anon_sym_CARET] = ACTIONS(10300),
  },
  [11774] = {
    [sym__line_break] = ACTIONS(9738),
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [sym_self] = ACTIONS(9736),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_nil] = ACTIONS(9736),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_then] = ACTIONS(9736),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [anon_sym_next] = ACTIONS(9736),
    [sym_retry] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11775] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [11776] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [11777] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(9007),
    [sym_unary] = STATE(9007),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(9007),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(9007),
    [sym_conditional] = STATE(9007),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(9008),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(9007),
    [sym_binary] = STATE(9007),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(13501),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13499),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(13503),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16719),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [11778] = {
    [sym_heredoc_body] = STATE(11778),
    [aux_sym_call_repeat1] = STATE(11778),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [11779] = {
    [sym_heredoc_body] = STATE(11778),
    [aux_sym_call_repeat1] = STATE(11778),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [11780] = {
    [aux_sym_argument_list_repeat1] = STATE(11780),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17315),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [11781] = {
    [sym_assignment] = STATE(12242),
    [sym_unary] = STATE(12242),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(12242),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(12242),
    [sym_conditional] = STATE(12242),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(12242),
    [sym_binary] = STATE(12242),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [11782] = {
    [sym_assignment] = STATE(12243),
    [sym_unary] = STATE(12243),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(12243),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(12243),
    [sym_conditional] = STATE(12243),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(12243),
    [sym_binary] = STATE(12243),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [11783] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11784] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(4272),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11785] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11786] = {
    [sym__argument] = STATE(3291),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(3291),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(3291),
    [sym_hash_splat_argument] = STATE(3291),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_heredoc_body] = STATE(12244),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(3291),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17318),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [11787] = {
    [sym_heredoc_body] = STATE(12245),
    [aux_sym_call_repeat1] = STATE(12245),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11788] = {
    [sym_heredoc_body] = STATE(12246),
    [aux_sym_call_repeat1] = STATE(12246),
    [aux_sym_argument_list_repeat1] = STATE(12247),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_then] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16725),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [11789] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11790] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11791] = {
    [aux_sym_exceptions_repeat1] = STATE(12249),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_then] = ACTIONS(6745),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [11792] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11793] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11794] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11795] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11796] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17320),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11797] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11798] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(7119),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [11799] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11800] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11801] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_then] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [11802] = {
    [aux_sym_chained_string_repeat1] = STATE(11802),
    [sym_string] = STATE(11802),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_then] = ACTIONS(7123),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [11803] = {
    [sym_assignment] = STATE(10785),
    [sym_unary] = STATE(10785),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10785),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(10785),
    [sym_conditional] = STATE(10785),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(10785),
    [sym_binary] = STATE(10785),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13505),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(6179),
    [sym_character] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [11804] = {
    [aux_sym_exceptions_repeat1] = STATE(12251),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17322),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11805] = {
    [anon_sym_do] = ACTIONS(8575),
    [anon_sym_DOT] = ACTIONS(8575),
    [anon_sym_then] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_AMP_DOT] = ACTIONS(8575),
    [sym__line_break] = ACTIONS(8575),
    [anon_sym_COLON_COLON2] = ACTIONS(8575),
    [sym__heredoc_body_start] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LBRACK] = ACTIONS(8575),
    [sym_comment] = ACTIONS(49),
  },
  [11806] = {
    [anon_sym_do] = ACTIONS(12375),
    [anon_sym_DOT] = ACTIONS(12375),
    [anon_sym_then] = ACTIONS(12375),
    [anon_sym_LBRACE] = ACTIONS(12375),
    [anon_sym_AMP_DOT] = ACTIONS(12375),
    [sym__line_break] = ACTIONS(12375),
    [anon_sym_COLON_COLON2] = ACTIONS(12375),
    [sym__heredoc_body_start] = ACTIONS(12375),
    [anon_sym_COMMA] = ACTIONS(12375),
    [anon_sym_SEMI] = ACTIONS(12375),
    [anon_sym_LBRACK] = ACTIONS(12375),
    [sym_comment] = ACTIONS(49),
  },
  [11807] = {
    [sym_assignment] = STATE(12252),
    [sym_unary] = STATE(12252),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(12252),
    [sym__primary] = STATE(1481),
    [sym_method_call] = STATE(6444),
    [sym_operator_assignment] = STATE(12252),
    [sym_conditional] = STATE(12252),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_rational] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_return] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(8996),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_range] = STATE(12252),
    [sym_binary] = STATE(12252),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2593),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10328),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_not] = ACTIONS(10332),
    [sym_self] = ACTIONS(6179),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10338),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(6187),
    [sym_character] = ACTIONS(2597),
    [sym_super] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2593),
    [sym_constant] = ACTIONS(6179),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym_instance_variable] = ACTIONS(6187),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(6179),
    [sym_redo] = ACTIONS(2593),
    [sym_class_variable] = ACTIONS(6187),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [11808] = {
    [aux_sym_exceptions_repeat1] = STATE(11808),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17324),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11809] = {
    [anon_sym_LT] = ACTIONS(10380),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(10382),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10384),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10386),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10388),
    [anon_sym_LT_LT] = ACTIONS(10386),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10390),
    [anon_sym_EQ_TILDE] = ACTIONS(10390),
    [anon_sym_PLUS] = ACTIONS(10392),
    [anon_sym_AMP] = ACTIONS(10394),
    [anon_sym_GT] = ACTIONS(10380),
    [anon_sym_PERCENT] = ACTIONS(10382),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(10396),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10398),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10398),
    [anon_sym_BANG_TILDE] = ACTIONS(10390),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10400),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10390),
    [anon_sym_STAR_STAR] = ACTIONS(10382),
    [anon_sym_PIPE] = ACTIONS(10402),
    [anon_sym_DOT_DOT] = ACTIONS(10404),
    [anon_sym_AMP_AMP] = ACTIONS(10398),
    [anon_sym_LT_EQ_GT] = ACTIONS(10390),
    [anon_sym_LT_EQ] = ACTIONS(10380),
    [sym__binary_minus] = ACTIONS(10406),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(10402),
  },
  [11810] = {
    [sym_heredoc_body] = STATE(11810),
    [aux_sym_call_repeat1] = STATE(11810),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_ensure] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11811] = {
    [sym_heredoc_body] = STATE(11810),
    [aux_sym_call_repeat1] = STATE(11810),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_ensure] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11812] = {
    [sym_assignment] = STATE(10821),
    [sym_unary] = STATE(10821),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(10821),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(10821),
    [sym_conditional] = STATE(10821),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_return] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_true] = STATE(6521),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(10821),
    [sym_binary] = STATE(10821),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(6253),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [sym_global_variable] = ACTIONS(2647),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(2639),
    [sym_character] = ACTIONS(2641),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [11813] = {
    [aux_sym_exceptions_repeat1] = STATE(12253),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17327),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11814] = {
    [sym_assignment] = STATE(12254),
    [sym_unary] = STATE(12254),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6521),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(12254),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6521),
    [sym_operator_assignment] = STATE(12254),
    [sym_conditional] = STATE(12254),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6523),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6521),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6521),
    [sym_range] = STATE(12254),
    [sym_binary] = STATE(12254),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6521),
    [sym_nil] = STATE(6521),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10436),
    [anon_sym_not] = ACTIONS(10438),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10442),
    [anon_sym_TILDE] = ACTIONS(10436),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10444),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10448),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [11815] = {
    [aux_sym_exceptions_repeat1] = STATE(11815),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17329),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11816] = {
    [anon_sym_LT] = ACTIONS(10458),
    [anon_sym_SLASH] = ACTIONS(10460),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10462),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10464),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10466),
    [anon_sym_LT_LT] = ACTIONS(10464),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10468),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10468),
    [anon_sym_AMP] = ACTIONS(10470),
    [anon_sym_GT] = ACTIONS(10458),
    [anon_sym_PLUS] = ACTIONS(10472),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(10460),
    [sym__binary_star] = ACTIONS(10460),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10474),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(10468),
    [anon_sym_PIPE_PIPE] = ACTIONS(10468),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10476),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10468),
    [anon_sym_STAR_STAR] = ACTIONS(10460),
    [anon_sym_PIPE] = ACTIONS(10478),
    [anon_sym_DOT_DOT] = ACTIONS(10480),
    [anon_sym_AMP_AMP] = ACTIONS(10468),
    [anon_sym_LT_EQ_GT] = ACTIONS(10468),
    [anon_sym_LT_EQ] = ACTIONS(10458),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10482),
    [sym__binary_minus] = ACTIONS(10472),
  },
  [11817] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_ensure] = ACTIONS(9736),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11818] = {
    [sym_assignment] = STATE(12255),
    [sym_unary] = STATE(12255),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6568),
    [sym_singleton_class] = STATE(1502),
    [sym_module] = STATE(1502),
    [sym_chained_string] = STATE(1502),
    [sym_until] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_for] = STATE(1502),
    [sym_symbol] = STATE(1502),
    [sym_if] = STATE(1502),
    [sym_begin] = STATE(1502),
    [sym__arg] = STATE(12255),
    [sym__primary] = STATE(1502),
    [sym_method_call] = STATE(6568),
    [sym_operator_assignment] = STATE(12255),
    [sym_conditional] = STATE(12255),
    [sym_method] = STATE(1502),
    [sym_singleton_method] = STATE(1502),
    [sym__variable] = STATE(1505),
    [sym_left_assignment_list] = STATE(6570),
    [sym_rational] = STATE(1502),
    [sym_true] = STATE(6568),
    [sym_return] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_yield] = STATE(1502),
    [sym_string] = STATE(6524),
    [sym_unless] = STATE(1502),
    [sym_lambda] = STATE(1502),
    [sym_parenthesized_statements] = STATE(1502),
    [sym_element_reference] = STATE(6568),
    [sym_range] = STATE(12255),
    [sym_binary] = STATE(12255),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1502),
    [sym_break] = STATE(1502),
    [sym_next] = STATE(1502),
    [sym_string_array] = STATE(1502),
    [sym_while] = STATE(1502),
    [sym_case] = STATE(1502),
    [sym_symbol_array] = STATE(1502),
    [sym_array] = STATE(1502),
    [sym_hash] = STATE(1502),
    [sym_false] = STATE(6568),
    [sym_nil] = STATE(6568),
    [sym_scope_resolution] = STATE(1505),
    [sym_call] = STATE(1505),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(2635),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10434),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(10512),
    [anon_sym_not] = ACTIONS(10514),
    [sym_self] = ACTIONS(2639),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(10440),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(10518),
    [anon_sym_TILDE] = ACTIONS(10512),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(2647),
    [sym_character] = ACTIONS(2641),
    [sym_super] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(10520),
    [anon_sym_next] = ACTIONS(10446),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(2635),
    [sym_constant] = ACTIONS(2639),
    [anon_sym_defined_QMARK] = ACTIONS(10522),
    [sym_instance_variable] = ACTIONS(2647),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(2639),
    [sym_redo] = ACTIONS(2635),
    [sym_class_variable] = ACTIONS(2647),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(10450),
  },
  [11819] = {
    [sym_assignment] = STATE(10861),
    [sym_unary] = STATE(10861),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(10861),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(10861),
    [sym_conditional] = STATE(10861),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_return] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_true] = STATE(6584),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(10861),
    [sym_binary] = STATE(10861),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(6311),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [sym_global_variable] = ACTIONS(10548),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(10540),
    [sym_character] = ACTIONS(10544),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [11820] = {
    [aux_sym_exceptions_repeat1] = STATE(12256),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17332),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_ensure] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11821] = {
    [sym_assignment] = STATE(12257),
    [sym_unary] = STATE(12257),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6584),
    [sym_singleton_class] = STATE(6586),
    [sym_module] = STATE(6586),
    [sym_chained_string] = STATE(6586),
    [sym_until] = STATE(6586),
    [sym_regex] = STATE(6586),
    [sym_for] = STATE(6586),
    [sym_symbol] = STATE(6586),
    [sym_if] = STATE(6586),
    [sym_begin] = STATE(6586),
    [sym__arg] = STATE(12257),
    [sym__primary] = STATE(6586),
    [sym_method_call] = STATE(6584),
    [sym_operator_assignment] = STATE(12257),
    [sym_conditional] = STATE(12257),
    [sym_method] = STATE(6586),
    [sym_singleton_method] = STATE(6586),
    [sym__variable] = STATE(6587),
    [sym_left_assignment_list] = STATE(6588),
    [sym_rational] = STATE(6586),
    [sym_true] = STATE(6584),
    [sym_return] = STATE(6586),
    [sym_subshell] = STATE(6586),
    [sym_yield] = STATE(6586),
    [sym_string] = STATE(6589),
    [sym_unless] = STATE(6586),
    [sym_lambda] = STATE(6586),
    [sym_parenthesized_statements] = STATE(6586),
    [sym_element_reference] = STATE(6584),
    [sym_range] = STATE(12257),
    [sym_binary] = STATE(12257),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6586),
    [sym_break] = STATE(6586),
    [sym_next] = STATE(6586),
    [sym_string_array] = STATE(6586),
    [sym_while] = STATE(6586),
    [sym_case] = STATE(6586),
    [sym_symbol_array] = STATE(6586),
    [sym_array] = STATE(6586),
    [sym_hash] = STATE(6586),
    [sym_false] = STATE(6584),
    [sym_nil] = STATE(6584),
    [sym_scope_resolution] = STATE(6587),
    [sym_call] = STATE(6587),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(10532),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(10534),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(10536),
    [anon_sym_not] = ACTIONS(10538),
    [sym_self] = ACTIONS(10540),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(10542),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(10544),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(10544),
    [anon_sym_PLUS] = ACTIONS(10546),
    [anon_sym_TILDE] = ACTIONS(10536),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(10548),
    [sym_character] = ACTIONS(10544),
    [sym_super] = ACTIONS(10540),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(10550),
    [anon_sym_next] = ACTIONS(10552),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(10532),
    [sym_constant] = ACTIONS(10540),
    [anon_sym_defined_QMARK] = ACTIONS(10554),
    [sym_instance_variable] = ACTIONS(10548),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(10540),
    [sym_redo] = ACTIONS(10532),
    [sym_class_variable] = ACTIONS(10548),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(10556),
  },
  [11822] = {
    [aux_sym_exceptions_repeat1] = STATE(11822),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17334),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11823] = {
    [anon_sym_SLASH] = ACTIONS(10566),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [sym__binary_star] = ACTIONS(10572),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(10574),
    [anon_sym_AMP] = ACTIONS(10576),
    [anon_sym_PERCENT] = ACTIONS(10566),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(10578),
    [anon_sym_PIPE] = ACTIONS(10580),
    [anon_sym_DOT_DOT] = ACTIONS(10582),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(10578),
    [anon_sym_QMARK] = ACTIONS(10584),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10586),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(10578),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(10588),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10588),
    [anon_sym_GT_EQ] = ACTIONS(10590),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(10592),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10580),
  },
  [11824] = {
    [aux_sym_exceptions_repeat1] = STATE(11824),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17337),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11825] = {
    [anon_sym_LT] = ACTIONS(10611),
    [anon_sym_SLASH] = ACTIONS(10613),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10615),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10617),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10619),
    [anon_sym_LT_LT] = ACTIONS(10617),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10621),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10621),
    [anon_sym_AMP] = ACTIONS(10623),
    [anon_sym_GT] = ACTIONS(10611),
    [anon_sym_PLUS] = ACTIONS(10625),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(10613),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(10613),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10627),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(10621),
    [anon_sym_PIPE_PIPE] = ACTIONS(10621),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10621),
    [anon_sym_STAR_STAR] = ACTIONS(10613),
    [anon_sym_PIPE] = ACTIONS(10631),
    [anon_sym_DOT_DOT] = ACTIONS(10633),
    [anon_sym_AMP_AMP] = ACTIONS(10621),
    [anon_sym_LT_EQ_GT] = ACTIONS(10621),
    [anon_sym_LT_EQ] = ACTIONS(10611),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10635),
    [sym__binary_minus] = ACTIONS(10625),
  },
  [11826] = {
    [anon_sym_LT] = ACTIONS(10667),
    [anon_sym_SLASH] = ACTIONS(10669),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10671),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10673),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10677),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10677),
    [anon_sym_AMP] = ACTIONS(10679),
    [anon_sym_GT] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10681),
    [anon_sym_PERCENT] = ACTIONS(10669),
    [sym__binary_star] = ACTIONS(10669),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(10683),
    [anon_sym_BANG_TILDE] = ACTIONS(10677),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10677),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10685),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10677),
    [anon_sym_STAR_STAR] = ACTIONS(10669),
    [anon_sym_PIPE] = ACTIONS(10687),
    [anon_sym_DOT_DOT] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10677),
    [anon_sym_LT_EQ_GT] = ACTIONS(10677),
    [anon_sym_LT_EQ] = ACTIONS(10667),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10691),
    [sym__binary_minus] = ACTIONS(10681),
  },
  [11827] = {
    [aux_sym_exceptions_repeat1] = STATE(11827),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17340),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11828] = {
    [anon_sym_SLASH] = ACTIONS(10707),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10709),
    [anon_sym_EQ_TILDE] = ACTIONS(10709),
    [anon_sym_LT_LT] = ACTIONS(10711),
    [sym__binary_star] = ACTIONS(10713),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(10715),
    [anon_sym_AMP] = ACTIONS(10717),
    [anon_sym_PERCENT] = ACTIONS(10707),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(10709),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(10719),
    [anon_sym_PIPE] = ACTIONS(10721),
    [anon_sym_DOT_DOT] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(10719),
    [anon_sym_QMARK] = ACTIONS(10725),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10711),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(10719),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(10729),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10729),
    [anon_sym_GT_EQ] = ACTIONS(10731),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10709),
    [anon_sym_STAR_STAR] = ACTIONS(10707),
    [anon_sym_LT_EQ_GT] = ACTIONS(10709),
    [anon_sym_AMP_AMP] = ACTIONS(10729),
    [sym__binary_minus] = ACTIONS(10733),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10721),
  },
  [11829] = {
    [aux_sym_exceptions_repeat1] = STATE(11829),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17343),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11830] = {
    [anon_sym_LT] = ACTIONS(10765),
    [anon_sym_SLASH] = ACTIONS(10767),
    [anon_sym_QMARK] = ACTIONS(10769),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(10773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10775),
    [anon_sym_LT_LT] = ACTIONS(10773),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10771),
    [sym__binary_star] = ACTIONS(10767),
    [anon_sym_PLUS] = ACTIONS(10779),
    [anon_sym_AMP] = ACTIONS(10781),
    [anon_sym_GT] = ACTIONS(10765),
    [anon_sym_PERCENT] = ACTIONS(10767),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(10783),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10771),
    [anon_sym_BANG_TILDE] = ACTIONS(10771),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10785),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(10771),
    [anon_sym_STAR_STAR] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(10789),
    [anon_sym_DOT_DOT] = ACTIONS(10787),
    [anon_sym_AMP_AMP] = ACTIONS(10771),
    [anon_sym_LT_EQ_GT] = ACTIONS(10771),
    [anon_sym_LT_EQ] = ACTIONS(10765),
    [sym__binary_minus] = ACTIONS(10779),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(10791),
  },
  [11831] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_elsif] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [11832] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_elsif] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [11833] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(6809),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9297),
    [sym_rational] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym_float] = ACTIONS(10799),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(10803),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(10803),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10805),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(13775),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(10811),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(13777),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(13775),
    [anon_sym_yield] = ACTIONS(10819),
    [sym_class_variable] = ACTIONS(10811),
    [sym__block_ampersand] = ACTIONS(13779),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10823),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [sym_retry] = ACTIONS(10799),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16783),
    [sym_redo] = ACTIONS(10799),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [11834] = {
    [sym_heredoc_body] = STATE(11834),
    [aux_sym_call_repeat1] = STATE(11834),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_elsif] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11835] = {
    [sym_heredoc_body] = STATE(11834),
    [aux_sym_call_repeat1] = STATE(11834),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_elsif] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11836] = {
    [aux_sym_argument_list_repeat1] = STATE(11836),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17346),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [11837] = {
    [sym_heredoc_body] = STATE(12258),
    [aux_sym_call_repeat1] = STATE(12258),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11838] = {
    [sym_heredoc_body] = STATE(12259),
    [aux_sym_call_repeat1] = STATE(12259),
    [aux_sym_argument_list_repeat1] = STATE(10933),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(13801),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_elsif] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [11839] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11840] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_elsif] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11841] = {
    [aux_sym_exceptions_repeat1] = STATE(12261),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11842] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11843] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11844] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11845] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11846] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17349),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11847] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11848] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11849] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11850] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11851] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [11852] = {
    [aux_sym_chained_string_repeat1] = STATE(11852),
    [sym_string] = STATE(11852),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_elsif] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [11853] = {
    [sym_assignment] = STATE(10935),
    [sym_unary] = STATE(10935),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(10935),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(10935),
    [sym_conditional] = STATE(10935),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_return] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_true] = STATE(6807),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(10935),
    [sym_binary] = STATE(10935),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(13781),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [sym_global_variable] = ACTIONS(10811),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(10803),
    [sym_character] = ACTIONS(10805),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [11854] = {
    [aux_sym_exceptions_repeat1] = STATE(12263),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17351),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_elsif] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11855] = {
    [sym_assignment] = STATE(12264),
    [sym_unary] = STATE(12264),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6807),
    [sym_singleton_class] = STATE(6809),
    [sym_module] = STATE(6809),
    [sym_chained_string] = STATE(6809),
    [sym_until] = STATE(6809),
    [sym_regex] = STATE(6809),
    [sym_for] = STATE(6809),
    [sym_symbol] = STATE(6809),
    [sym_if] = STATE(6809),
    [sym_begin] = STATE(6809),
    [sym__arg] = STATE(12264),
    [sym__primary] = STATE(6809),
    [sym_method_call] = STATE(6807),
    [sym_operator_assignment] = STATE(12264),
    [sym_conditional] = STATE(12264),
    [sym_method] = STATE(6809),
    [sym_singleton_method] = STATE(6809),
    [sym__variable] = STATE(6810),
    [sym_left_assignment_list] = STATE(6811),
    [sym_rational] = STATE(6809),
    [sym_true] = STATE(6807),
    [sym_return] = STATE(6809),
    [sym_subshell] = STATE(6809),
    [sym_yield] = STATE(6809),
    [sym_string] = STATE(9285),
    [sym_unless] = STATE(6809),
    [sym_lambda] = STATE(6809),
    [sym_parenthesized_statements] = STATE(6809),
    [sym_element_reference] = STATE(6807),
    [sym_range] = STATE(12264),
    [sym_binary] = STATE(12264),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6809),
    [sym_break] = STATE(6809),
    [sym_next] = STATE(6809),
    [sym_string_array] = STATE(6809),
    [sym_while] = STATE(6809),
    [sym_case] = STATE(6809),
    [sym_symbol_array] = STATE(6809),
    [sym_array] = STATE(6809),
    [sym_hash] = STATE(6809),
    [sym_false] = STATE(6807),
    [sym_nil] = STATE(6807),
    [sym_scope_resolution] = STATE(6810),
    [sym_call] = STATE(6810),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(10799),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10819),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(10807),
    [anon_sym_not] = ACTIONS(10823),
    [sym_self] = ACTIONS(10803),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(10827),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10805),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(10805),
    [anon_sym_PLUS] = ACTIONS(13765),
    [anon_sym_TILDE] = ACTIONS(10807),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10811),
    [sym_character] = ACTIONS(10805),
    [sym_super] = ACTIONS(10803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(10829),
    [anon_sym_next] = ACTIONS(10831),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(10799),
    [sym_constant] = ACTIONS(10803),
    [anon_sym_defined_QMARK] = ACTIONS(10813),
    [sym_instance_variable] = ACTIONS(10811),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(10803),
    [sym_redo] = ACTIONS(10799),
    [sym_class_variable] = ACTIONS(10811),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10801),
  },
  [11856] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_elsif] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11857] = {
    [anon_sym_RPAREN] = ACTIONS(17353),
    [sym_comment] = ACTIONS(49),
  },
  [11858] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_elsif] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11859] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_elsif] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11860] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_elsif] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [11861] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(6836),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9335),
    [sym_rational] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym_float] = ACTIONS(10857),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(10861),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(10861),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(13839),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(10869),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [sym__identifier_hash_key] = ACTIONS(13841),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(13839),
    [anon_sym_yield] = ACTIONS(10875),
    [sym_class_variable] = ACTIONS(10869),
    [sym__block_ampersand] = ACTIONS(13845),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(10879),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_break] = ACTIONS(10883),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [sym_retry] = ACTIONS(10857),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(16794),
    [sym_redo] = ACTIONS(10857),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [11862] = {
    [sym_heredoc_body] = STATE(11862),
    [aux_sym_call_repeat1] = STATE(11862),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_elsif] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [11863] = {
    [sym_heredoc_body] = STATE(11862),
    [aux_sym_call_repeat1] = STATE(11862),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_elsif] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [11864] = {
    [aux_sym_argument_list_repeat1] = STATE(11864),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17355),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_elsif] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [11865] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_elsif] = ACTIONS(9736),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11866] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11867] = {
    [aux_sym_exceptions_repeat1] = STATE(10981),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [11868] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11869] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11870] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11871] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11872] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17358),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11873] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11874] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11875] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [11876] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11877] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [11878] = {
    [aux_sym_exceptions_repeat1] = STATE(11878),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17360),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11879] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_elsif] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11880] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_elsif] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11881] = {
    [aux_sym_exceptions_repeat1] = STATE(12268),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_elsif] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [11882] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11883] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11884] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11885] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11886] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17363),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [11887] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11888] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_elsif] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [11889] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11890] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11891] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_elsif] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [11892] = {
    [aux_sym_chained_string_repeat1] = STATE(11892),
    [sym_string] = STATE(11892),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_elsif] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [11893] = {
    [sym_assignment] = STATE(10998),
    [sym_unary] = STATE(10998),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(10998),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(10998),
    [sym_conditional] = STATE(10998),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_return] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_true] = STATE(6840),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(10998),
    [sym_binary] = STATE(10998),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(13843),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [sym_global_variable] = ACTIONS(10869),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(10861),
    [sym_character] = ACTIONS(10863),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [11894] = {
    [aux_sym_exceptions_repeat1] = STATE(12270),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17365),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_elsif] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11895] = {
    [sym_assignment] = STATE(12271),
    [sym_unary] = STATE(12271),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6840),
    [sym_singleton_class] = STATE(6836),
    [sym_module] = STATE(6836),
    [sym_chained_string] = STATE(6836),
    [sym_until] = STATE(6836),
    [sym_regex] = STATE(6836),
    [sym_for] = STATE(6836),
    [sym_symbol] = STATE(6836),
    [sym_if] = STATE(6836),
    [sym_begin] = STATE(6836),
    [sym__arg] = STATE(12271),
    [sym__primary] = STATE(6836),
    [sym_method_call] = STATE(6840),
    [sym_operator_assignment] = STATE(12271),
    [sym_conditional] = STATE(12271),
    [sym_method] = STATE(6836),
    [sym_singleton_method] = STATE(6836),
    [sym__variable] = STATE(6838),
    [sym_left_assignment_list] = STATE(6837),
    [sym_rational] = STATE(6836),
    [sym_true] = STATE(6840),
    [sym_return] = STATE(6836),
    [sym_subshell] = STATE(6836),
    [sym_yield] = STATE(6836),
    [sym_string] = STATE(9360),
    [sym_unless] = STATE(6836),
    [sym_lambda] = STATE(6836),
    [sym_parenthesized_statements] = STATE(6836),
    [sym_element_reference] = STATE(6840),
    [sym_range] = STATE(12271),
    [sym_binary] = STATE(12271),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(6836),
    [sym_break] = STATE(6836),
    [sym_next] = STATE(6836),
    [sym_string_array] = STATE(6836),
    [sym_while] = STATE(6836),
    [sym_case] = STATE(6836),
    [sym_symbol_array] = STATE(6836),
    [sym_array] = STATE(6836),
    [sym_hash] = STATE(6836),
    [sym_false] = STATE(6840),
    [sym_nil] = STATE(6840),
    [sym_scope_resolution] = STATE(6838),
    [sym_call] = STATE(6838),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(10857),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(10875),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(10865),
    [anon_sym_not] = ACTIONS(10879),
    [sym_self] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(10883),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(10863),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(10863),
    [anon_sym_PLUS] = ACTIONS(13877),
    [anon_sym_TILDE] = ACTIONS(10865),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(10869),
    [sym_character] = ACTIONS(10863),
    [sym_super] = ACTIONS(10861),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(10885),
    [anon_sym_next] = ACTIONS(10887),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(10857),
    [sym_constant] = ACTIONS(10861),
    [anon_sym_defined_QMARK] = ACTIONS(10871),
    [sym_instance_variable] = ACTIONS(10869),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(13767),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(10861),
    [sym_redo] = ACTIONS(10857),
    [sym_class_variable] = ACTIONS(10869),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(10859),
  },
  [11896] = {
    [anon_sym_LT] = ACTIONS(10895),
    [anon_sym_SLASH] = ACTIONS(10897),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(10899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10901),
    [anon_sym_GT_GT] = ACTIONS(10903),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10905),
    [anon_sym_LT_LT] = ACTIONS(10903),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(10901),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(10909),
    [anon_sym_AMP] = ACTIONS(10911),
    [anon_sym_GT] = ACTIONS(10895),
    [anon_sym_PERCENT] = ACTIONS(10897),
    [sym__binary_star] = ACTIONS(10897),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(10913),
    [anon_sym_BANG_TILDE] = ACTIONS(10901),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(10901),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(10915),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10901),
    [anon_sym_STAR_STAR] = ACTIONS(10897),
    [anon_sym_PIPE] = ACTIONS(10919),
    [anon_sym_DOT_DOT] = ACTIONS(10917),
    [anon_sym_AMP_AMP] = ACTIONS(10901),
    [anon_sym_LT_EQ_GT] = ACTIONS(10901),
    [anon_sym_LT_EQ] = ACTIONS(10895),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(10921),
    [sym__binary_minus] = ACTIONS(10909),
  },
  [11897] = {
    [sym_assignment] = STATE(12272),
    [sym_unary] = STATE(12272),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6911),
    [sym_singleton_class] = STATE(1669),
    [sym_module] = STATE(1669),
    [sym_chained_string] = STATE(1669),
    [sym_until] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_for] = STATE(1669),
    [sym_symbol] = STATE(1669),
    [sym_if] = STATE(1669),
    [sym_begin] = STATE(1669),
    [sym__arg] = STATE(12272),
    [sym__primary] = STATE(1669),
    [sym_method_call] = STATE(6911),
    [sym_operator_assignment] = STATE(12272),
    [sym_conditional] = STATE(12272),
    [sym_method] = STATE(1669),
    [sym_singleton_method] = STATE(1669),
    [sym__variable] = STATE(1671),
    [sym_left_assignment_list] = STATE(6913),
    [sym_rational] = STATE(1669),
    [sym_true] = STATE(6911),
    [sym_return] = STATE(1669),
    [sym_subshell] = STATE(1669),
    [sym_yield] = STATE(1669),
    [sym_string] = STATE(4427),
    [sym_unless] = STATE(1669),
    [sym_lambda] = STATE(1669),
    [sym_parenthesized_statements] = STATE(1669),
    [sym_element_reference] = STATE(6911),
    [sym_range] = STATE(12272),
    [sym_binary] = STATE(12272),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1669),
    [sym_break] = STATE(1669),
    [sym_next] = STATE(1669),
    [sym_string_array] = STATE(1669),
    [sym_while] = STATE(1669),
    [sym_case] = STATE(1669),
    [sym_symbol_array] = STATE(1669),
    [sym_array] = STATE(1669),
    [sym_hash] = STATE(1669),
    [sym_false] = STATE(6911),
    [sym_nil] = STATE(6911),
    [sym_scope_resolution] = STATE(1671),
    [sym_call] = STATE(1671),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(2939),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(3520),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(11013),
    [anon_sym_not] = ACTIONS(11015),
    [sym_self] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(3528),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(11019),
    [anon_sym_TILDE] = ACTIONS(11013),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(2953),
    [sym_character] = ACTIONS(2945),
    [sym_super] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(11021),
    [anon_sym_next] = ACTIONS(3532),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(2939),
    [sym_constant] = ACTIONS(2941),
    [anon_sym_defined_QMARK] = ACTIONS(11023),
    [sym_instance_variable] = ACTIONS(2953),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(2941),
    [sym_redo] = ACTIONS(2939),
    [sym_class_variable] = ACTIONS(2953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(3508),
  },
  [11898] = {
    [anon_sym_SLASH] = ACTIONS(15289),
    [sym__line_break] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_AMP_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT_EQ] = ACTIONS(15291),
    [anon_sym_SLASH_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15289),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15289),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15289),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_PERCENT_EQ] = ACTIONS(15291),
    [anon_sym_LT_LT_EQ] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [anon_sym_else] = ACTIONS(15291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_CARET_EQ] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_EQ] = ACTIONS(15289),
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_then] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15289),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_when] = ACTIONS(15291),
    [anon_sym_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_PLUS_EQ] = ACTIONS(15291),
    [anon_sym_STAR_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym___END__] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15289),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_end] = ACTIONS(15291),
    [anon_sym_ensure] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_elsif] = ACTIONS(15291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15291),
    [ts_builtin_sym_end] = ACTIONS(15291),
    [anon_sym_DASH_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15289),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [anon_sym_AMP_AMP] = ACTIONS(15289),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15289),
  },
  [11899] = {
    [anon_sym_end] = ACTIONS(17367),
    [sym_comment] = ACTIONS(49),
  },
  [11900] = {
    [anon_sym_SLASH] = ACTIONS(15829),
    [sym__line_break] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_AMP_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT_EQ] = ACTIONS(15831),
    [anon_sym_SLASH_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15829),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15829),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15829),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_PERCENT_EQ] = ACTIONS(15831),
    [anon_sym_LT_LT_EQ] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [anon_sym_else] = ACTIONS(15831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_CARET_EQ] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_EQ] = ACTIONS(15829),
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_then] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15829),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_when] = ACTIONS(15831),
    [anon_sym_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_PLUS_EQ] = ACTIONS(15831),
    [anon_sym_STAR_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym___END__] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15829),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_end] = ACTIONS(15831),
    [anon_sym_ensure] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_elsif] = ACTIONS(15831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15831),
    [ts_builtin_sym_end] = ACTIONS(15831),
    [anon_sym_DASH_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15829),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [anon_sym_AMP_AMP] = ACTIONS(15829),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15829),
  },
  [11901] = {
    [anon_sym_SLASH] = ACTIONS(15674),
    [sym__line_break] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_AMP_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT_EQ] = ACTIONS(15676),
    [anon_sym_SLASH_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15674),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15674),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15674),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_PERCENT_EQ] = ACTIONS(15676),
    [anon_sym_LT_LT_EQ] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [anon_sym_else] = ACTIONS(15676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_CARET_EQ] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_EQ] = ACTIONS(15674),
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_then] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15674),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_when] = ACTIONS(15676),
    [anon_sym_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_PLUS_EQ] = ACTIONS(15676),
    [anon_sym_STAR_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym___END__] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15674),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_end] = ACTIONS(15676),
    [anon_sym_ensure] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_elsif] = ACTIONS(15676),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15676),
    [ts_builtin_sym_end] = ACTIONS(15676),
    [anon_sym_DASH_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15674),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [anon_sym_AMP_AMP] = ACTIONS(15674),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15674),
  },
  [11902] = {
    [anon_sym_SLASH] = ACTIONS(14594),
    [sym__line_break] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_AMP_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT_EQ] = ACTIONS(14596),
    [anon_sym_SLASH_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14594),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14594),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14594),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_PERCENT_EQ] = ACTIONS(14596),
    [anon_sym_LT_LT_EQ] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [anon_sym_else] = ACTIONS(14596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_CARET_EQ] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_EQ] = ACTIONS(14594),
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_then] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14594),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_when] = ACTIONS(14596),
    [anon_sym_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_PLUS_EQ] = ACTIONS(14596),
    [anon_sym_STAR_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym___END__] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14594),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_end] = ACTIONS(14596),
    [anon_sym_ensure] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_elsif] = ACTIONS(14596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14596),
    [ts_builtin_sym_end] = ACTIONS(14596),
    [anon_sym_DASH_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14594),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [anon_sym_AMP_AMP] = ACTIONS(14594),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14594),
  },
  [11903] = {
    [anon_sym_SLASH] = ACTIONS(15027),
    [sym__line_break] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_AMP_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT_EQ] = ACTIONS(15029),
    [anon_sym_SLASH_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15027),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15027),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15027),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_PERCENT_EQ] = ACTIONS(15029),
    [anon_sym_LT_LT_EQ] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [anon_sym_else] = ACTIONS(15029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_CARET_EQ] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_EQ] = ACTIONS(15027),
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_then] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15027),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_when] = ACTIONS(15029),
    [anon_sym_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_PLUS_EQ] = ACTIONS(15029),
    [anon_sym_STAR_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym___END__] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15027),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_end] = ACTIONS(15029),
    [anon_sym_ensure] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_elsif] = ACTIONS(15029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15029),
    [ts_builtin_sym_end] = ACTIONS(15029),
    [anon_sym_DASH_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15027),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [anon_sym_AMP_AMP] = ACTIONS(15027),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15027),
  },
  [11904] = {
    [anon_sym_SLASH] = ACTIONS(15207),
    [sym__line_break] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_AMP_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT_EQ] = ACTIONS(15209),
    [anon_sym_SLASH_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15207),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15207),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15207),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_PERCENT_EQ] = ACTIONS(15209),
    [anon_sym_LT_LT_EQ] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [anon_sym_else] = ACTIONS(15209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_CARET_EQ] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_EQ] = ACTIONS(15207),
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_then] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15207),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_when] = ACTIONS(15209),
    [anon_sym_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_PLUS_EQ] = ACTIONS(15209),
    [anon_sym_STAR_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym___END__] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15207),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_end] = ACTIONS(15209),
    [anon_sym_ensure] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_elsif] = ACTIONS(15209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15209),
    [ts_builtin_sym_end] = ACTIONS(15209),
    [anon_sym_DASH_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15207),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [anon_sym_AMP_AMP] = ACTIONS(15207),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15207),
  },
  [11905] = {
    [anon_sym_SLASH] = ACTIONS(16492),
    [sym__line_break] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_AMP_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT_EQ] = ACTIONS(16494),
    [anon_sym_SLASH_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16492),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16492),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16492),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_PERCENT_EQ] = ACTIONS(16494),
    [anon_sym_LT_LT_EQ] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_else] = ACTIONS(16494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_CARET_EQ] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_EQ] = ACTIONS(16492),
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_then] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16492),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_EQ_GT] = ACTIONS(16494),
    [anon_sym_when] = ACTIONS(16494),
    [anon_sym_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_PLUS_EQ] = ACTIONS(16494),
    [anon_sym_STAR_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym___END__] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16492),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_end] = ACTIONS(16494),
    [anon_sym_ensure] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_elsif] = ACTIONS(16494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16494),
    [ts_builtin_sym_end] = ACTIONS(16494),
    [anon_sym_DASH_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16492),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_AMP_AMP] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16492),
  },
  [11906] = {
    [sym_heredoc_body] = STATE(11906),
    [aux_sym_call_repeat1] = STATE(11906),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_COLON2] = ACTIONS(9772),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [11907] = {
    [sym_heredoc_body] = STATE(11906),
    [aux_sym_call_repeat1] = STATE(11906),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_COLON2] = ACTIONS(9779),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [11908] = {
    [sym_assignment] = STATE(11075),
    [sym_unary] = STATE(11075),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(11075),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(11075),
    [sym_conditional] = STATE(11075),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_return] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_true] = STATE(7054),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(11075),
    [sym_binary] = STATE(11075),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(7031),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [sym_global_variable] = ACTIONS(11186),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(11178),
    [sym_character] = ACTIONS(11182),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [11909] = {
    [aux_sym_exceptions_repeat1] = STATE(12274),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17369),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_COLON2] = ACTIONS(10971),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [11910] = {
    [sym_assignment] = STATE(12275),
    [sym_unary] = STATE(12275),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7054),
    [sym_singleton_class] = STATE(7056),
    [sym_module] = STATE(7056),
    [sym_chained_string] = STATE(7056),
    [sym_until] = STATE(7056),
    [sym_regex] = STATE(7056),
    [sym_for] = STATE(7056),
    [sym_symbol] = STATE(7056),
    [sym_if] = STATE(7056),
    [sym_begin] = STATE(7056),
    [sym__arg] = STATE(12275),
    [sym__primary] = STATE(7056),
    [sym_method_call] = STATE(7054),
    [sym_operator_assignment] = STATE(12275),
    [sym_conditional] = STATE(12275),
    [sym_method] = STATE(7056),
    [sym_singleton_method] = STATE(7056),
    [sym__variable] = STATE(7057),
    [sym_left_assignment_list] = STATE(7058),
    [sym_rational] = STATE(7056),
    [sym_true] = STATE(7054),
    [sym_return] = STATE(7056),
    [sym_subshell] = STATE(7056),
    [sym_yield] = STATE(7056),
    [sym_string] = STATE(7059),
    [sym_unless] = STATE(7056),
    [sym_lambda] = STATE(7056),
    [sym_parenthesized_statements] = STATE(7056),
    [sym_element_reference] = STATE(7054),
    [sym_range] = STATE(12275),
    [sym_binary] = STATE(12275),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7056),
    [sym_break] = STATE(7056),
    [sym_next] = STATE(7056),
    [sym_string_array] = STATE(7056),
    [sym_while] = STATE(7056),
    [sym_case] = STATE(7056),
    [sym_symbol_array] = STATE(7056),
    [sym_array] = STATE(7056),
    [sym_hash] = STATE(7056),
    [sym_false] = STATE(7054),
    [sym_nil] = STATE(7054),
    [sym_scope_resolution] = STATE(7057),
    [sym_call] = STATE(7057),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(11170),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11172),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(11174),
    [anon_sym_not] = ACTIONS(11176),
    [sym_self] = ACTIONS(11178),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(11180),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11182),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(11182),
    [anon_sym_PLUS] = ACTIONS(11184),
    [anon_sym_TILDE] = ACTIONS(11174),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11186),
    [sym_character] = ACTIONS(11182),
    [sym_super] = ACTIONS(11178),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(11188),
    [anon_sym_next] = ACTIONS(11190),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(11170),
    [sym_constant] = ACTIONS(11178),
    [anon_sym_defined_QMARK] = ACTIONS(11192),
    [sym_instance_variable] = ACTIONS(11186),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(11178),
    [sym_redo] = ACTIONS(11170),
    [sym_class_variable] = ACTIONS(11186),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(11196),
  },
  [11911] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_COLON2] = ACTIONS(5452),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [11912] = {
    [anon_sym_RPAREN] = ACTIONS(17371),
    [sym_comment] = ACTIONS(49),
  },
  [11913] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10960),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [11914] = {
    [aux_sym_exceptions_repeat1] = STATE(11914),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17373),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11915] = {
    [anon_sym_LT] = ACTIONS(11204),
    [anon_sym_SLASH] = ACTIONS(11206),
    [anon_sym_QMARK] = ACTIONS(11208),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11214),
    [anon_sym_LT_LT] = ACTIONS(11210),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(11212),
    [sym__binary_star] = ACTIONS(11206),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_AMP] = ACTIONS(11218),
    [anon_sym_GT] = ACTIONS(11204),
    [anon_sym_PERCENT] = ACTIONS(11206),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11220),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(15271),
    [anon_sym_PIPE_PIPE] = ACTIONS(11212),
    [anon_sym_BANG_TILDE] = ACTIONS(11212),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11212),
    [anon_sym_STAR_STAR] = ACTIONS(11206),
    [anon_sym_PIPE] = ACTIONS(11224),
    [anon_sym_DOT_DOT] = ACTIONS(11226),
    [anon_sym_AMP_AMP] = ACTIONS(11212),
    [anon_sym_LT_EQ_GT] = ACTIONS(11212),
    [anon_sym_LT_EQ] = ACTIONS(11204),
    [sym__binary_minus] = ACTIONS(11216),
    [anon_sym_CARET] = ACTIONS(11228),
  },
  [11916] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11917] = {
    [sym_assignment] = STATE(12277),
    [sym_unary] = STATE(12277),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7097),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12277),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(7097),
    [sym_operator_assignment] = STATE(12277),
    [sym_conditional] = STATE(12277),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(7099),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(7097),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(7100),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(7097),
    [sym_range] = STATE(12277),
    [sym_binary] = STATE(12277),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(7097),
    [sym_nil] = STATE(7097),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(11250),
    [anon_sym_not] = ACTIONS(11252),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(11256),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(11258),
    [anon_sym_TILDE] = ACTIONS(11250),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(11260),
    [anon_sym_next] = ACTIONS(11262),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(11264),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(11266),
  },
  [11918] = {
    [sym_assignment] = STATE(11124),
    [sym_unary] = STATE(11124),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(11124),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(11124),
    [sym_conditional] = STATE(11124),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_return] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_true] = STATE(7132),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(11124),
    [sym_binary] = STATE(11124),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(7107),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [sym_global_variable] = ACTIONS(11302),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(11294),
    [sym_character] = ACTIONS(11298),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [11919] = {
    [aux_sym_exceptions_repeat1] = STATE(12278),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17376),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_COLON2] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11920] = {
    [sym_assignment] = STATE(12279),
    [sym_unary] = STATE(12279),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7132),
    [sym_singleton_class] = STATE(7134),
    [sym_module] = STATE(7134),
    [sym_chained_string] = STATE(7134),
    [sym_until] = STATE(7134),
    [sym_regex] = STATE(7134),
    [sym_for] = STATE(7134),
    [sym_symbol] = STATE(7134),
    [sym_if] = STATE(7134),
    [sym_begin] = STATE(7134),
    [sym__arg] = STATE(12279),
    [sym__primary] = STATE(7134),
    [sym_method_call] = STATE(7132),
    [sym_operator_assignment] = STATE(12279),
    [sym_conditional] = STATE(12279),
    [sym_method] = STATE(7134),
    [sym_singleton_method] = STATE(7134),
    [sym__variable] = STATE(7135),
    [sym_left_assignment_list] = STATE(7136),
    [sym_rational] = STATE(7134),
    [sym_true] = STATE(7132),
    [sym_return] = STATE(7134),
    [sym_subshell] = STATE(7134),
    [sym_yield] = STATE(7134),
    [sym_string] = STATE(7137),
    [sym_unless] = STATE(7134),
    [sym_lambda] = STATE(7134),
    [sym_parenthesized_statements] = STATE(7134),
    [sym_element_reference] = STATE(7132),
    [sym_range] = STATE(12279),
    [sym_binary] = STATE(12279),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7134),
    [sym_break] = STATE(7134),
    [sym_next] = STATE(7134),
    [sym_string_array] = STATE(7134),
    [sym_while] = STATE(7134),
    [sym_case] = STATE(7134),
    [sym_symbol_array] = STATE(7134),
    [sym_array] = STATE(7134),
    [sym_hash] = STATE(7134),
    [sym_false] = STATE(7132),
    [sym_nil] = STATE(7132),
    [sym_scope_resolution] = STATE(7135),
    [sym_call] = STATE(7135),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(11286),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(11288),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(11290),
    [anon_sym_not] = ACTIONS(11292),
    [sym_self] = ACTIONS(11294),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(11296),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(11298),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(11298),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_TILDE] = ACTIONS(11290),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(11302),
    [sym_character] = ACTIONS(11298),
    [sym_super] = ACTIONS(11294),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(11304),
    [anon_sym_next] = ACTIONS(11306),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(11286),
    [sym_constant] = ACTIONS(11294),
    [anon_sym_defined_QMARK] = ACTIONS(11308),
    [sym_instance_variable] = ACTIONS(11302),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(11194),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(11294),
    [sym_redo] = ACTIONS(11286),
    [sym_class_variable] = ACTIONS(11302),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(11310),
  },
  [11921] = {
    [aux_sym_exceptions_repeat1] = STATE(11921),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17378),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11922] = {
    [anon_sym_LT] = ACTIONS(11320),
    [anon_sym_SLASH] = ACTIONS(11322),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11324),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11330),
    [anon_sym_LT_LT] = ACTIONS(11326),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(11328),
    [sym__binary_star] = ACTIONS(11332),
    [anon_sym_PLUS] = ACTIONS(11334),
    [anon_sym_AMP] = ACTIONS(11336),
    [anon_sym_GT] = ACTIONS(11320),
    [anon_sym_PERCENT] = ACTIONS(11322),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11338),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(15271),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(11338),
    [anon_sym_BANG_TILDE] = ACTIONS(11328),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11340),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11328),
    [anon_sym_STAR_STAR] = ACTIONS(11322),
    [anon_sym_PIPE] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11338),
    [anon_sym_LT_EQ_GT] = ACTIONS(11328),
    [anon_sym_LT_EQ] = ACTIONS(11320),
    [sym__binary_minus] = ACTIONS(11346),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(11342),
  },
  [11923] = {
    [sym_heredoc_body] = STATE(11923),
    [aux_sym_call_repeat1] = STATE(11923),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11924] = {
    [sym_heredoc_body] = STATE(11923),
    [aux_sym_call_repeat1] = STATE(11923),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11925] = {
    [sym_assignment] = STATE(11149),
    [sym_unary] = STATE(11149),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(11149),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11149),
    [sym_conditional] = STATE(11149),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_return] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_true] = STATE(7179),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(11149),
    [sym_binary] = STATE(11149),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7188),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_global_variable] = ACTIONS(7148),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(7140),
    [sym_character] = ACTIONS(7144),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [11926] = {
    [aux_sym_exceptions_repeat1] = STATE(12280),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17381),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11927] = {
    [sym_assignment] = STATE(12281),
    [sym_unary] = STATE(12281),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7179),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(12281),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7179),
    [sym_operator_assignment] = STATE(12281),
    [sym_conditional] = STATE(12281),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7181),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7179),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7179),
    [sym_range] = STATE(12281),
    [sym_binary] = STATE(12281),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7179),
    [sym_nil] = STATE(7179),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_not] = ACTIONS(11374),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11378),
    [anon_sym_TILDE] = ACTIONS(11372),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11380),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11384),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [11928] = {
    [aux_sym_exceptions_repeat1] = STATE(11928),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17383),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11929] = {
    [anon_sym_LT] = ACTIONS(11394),
    [anon_sym_SLASH] = ACTIONS(11396),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11398),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11402),
    [anon_sym_LT_LT] = ACTIONS(11400),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11404),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(11404),
    [anon_sym_AMP] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11394),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11396),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11410),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(11404),
    [anon_sym_PIPE_PIPE] = ACTIONS(11404),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11412),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11404),
    [anon_sym_STAR_STAR] = ACTIONS(11396),
    [anon_sym_PIPE] = ACTIONS(11414),
    [anon_sym_DOT_DOT] = ACTIONS(11416),
    [anon_sym_AMP_AMP] = ACTIONS(11404),
    [anon_sym_LT_EQ_GT] = ACTIONS(11404),
    [anon_sym_LT_EQ] = ACTIONS(11394),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11418),
    [sym__binary_minus] = ACTIONS(11408),
  },
  [11930] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11931] = {
    [sym_assignment] = STATE(12282),
    [sym_unary] = STATE(12282),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7226),
    [sym_singleton_class] = STATE(1820),
    [sym_module] = STATE(1820),
    [sym_chained_string] = STATE(1820),
    [sym_until] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_for] = STATE(1820),
    [sym_symbol] = STATE(1820),
    [sym_if] = STATE(1820),
    [sym_begin] = STATE(1820),
    [sym__arg] = STATE(12282),
    [sym__primary] = STATE(1820),
    [sym_method_call] = STATE(7226),
    [sym_operator_assignment] = STATE(12282),
    [sym_conditional] = STATE(12282),
    [sym_method] = STATE(1820),
    [sym_singleton_method] = STATE(1820),
    [sym__variable] = STATE(1822),
    [sym_left_assignment_list] = STATE(7228),
    [sym_rational] = STATE(1820),
    [sym_true] = STATE(7226),
    [sym_return] = STATE(1820),
    [sym_subshell] = STATE(1820),
    [sym_yield] = STATE(1820),
    [sym_string] = STATE(7182),
    [sym_unless] = STATE(1820),
    [sym_lambda] = STATE(1820),
    [sym_parenthesized_statements] = STATE(1820),
    [sym_element_reference] = STATE(7226),
    [sym_range] = STATE(12282),
    [sym_binary] = STATE(12282),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1820),
    [sym_break] = STATE(1820),
    [sym_next] = STATE(1820),
    [sym_string_array] = STATE(1820),
    [sym_while] = STATE(1820),
    [sym_case] = STATE(1820),
    [sym_symbol_array] = STATE(1820),
    [sym_array] = STATE(1820),
    [sym_hash] = STATE(1820),
    [sym_false] = STATE(7226),
    [sym_nil] = STATE(7226),
    [sym_scope_resolution] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(7132),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11370),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [sym_self] = ACTIONS(7140),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11376),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(7144),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(7144),
    [anon_sym_PLUS] = ACTIONS(11454),
    [anon_sym_TILDE] = ACTIONS(11448),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(7148),
    [sym_character] = ACTIONS(7144),
    [sym_super] = ACTIONS(7140),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11456),
    [anon_sym_next] = ACTIONS(11382),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(7132),
    [sym_constant] = ACTIONS(7140),
    [anon_sym_defined_QMARK] = ACTIONS(11458),
    [sym_instance_variable] = ACTIONS(7148),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(7140),
    [sym_redo] = ACTIONS(7132),
    [sym_class_variable] = ACTIONS(7148),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11386),
  },
  [11932] = {
    [sym_assignment] = STATE(11189),
    [sym_unary] = STATE(11189),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(11189),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(11189),
    [sym_conditional] = STATE(11189),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_return] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_true] = STATE(7242),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(11189),
    [sym_binary] = STATE(11189),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(7240),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [sym_global_variable] = ACTIONS(11482),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11474),
    [sym_character] = ACTIONS(11478),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [11933] = {
    [aux_sym_exceptions_repeat1] = STATE(12283),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17386),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11934] = {
    [sym_assignment] = STATE(12284),
    [sym_unary] = STATE(12284),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7242),
    [sym_singleton_class] = STATE(7244),
    [sym_module] = STATE(7244),
    [sym_chained_string] = STATE(7244),
    [sym_until] = STATE(7244),
    [sym_regex] = STATE(7244),
    [sym_for] = STATE(7244),
    [sym_symbol] = STATE(7244),
    [sym_if] = STATE(7244),
    [sym_begin] = STATE(7244),
    [sym__arg] = STATE(12284),
    [sym__primary] = STATE(7244),
    [sym_method_call] = STATE(7242),
    [sym_operator_assignment] = STATE(12284),
    [sym_conditional] = STATE(12284),
    [sym_method] = STATE(7244),
    [sym_singleton_method] = STATE(7244),
    [sym__variable] = STATE(7245),
    [sym_left_assignment_list] = STATE(7246),
    [sym_rational] = STATE(7244),
    [sym_true] = STATE(7242),
    [sym_return] = STATE(7244),
    [sym_subshell] = STATE(7244),
    [sym_yield] = STATE(7244),
    [sym_string] = STATE(7247),
    [sym_unless] = STATE(7244),
    [sym_lambda] = STATE(7244),
    [sym_parenthesized_statements] = STATE(7244),
    [sym_element_reference] = STATE(7242),
    [sym_range] = STATE(12284),
    [sym_binary] = STATE(12284),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7244),
    [sym_break] = STATE(7244),
    [sym_next] = STATE(7244),
    [sym_string_array] = STATE(7244),
    [sym_while] = STATE(7244),
    [sym_case] = STATE(7244),
    [sym_symbol_array] = STATE(7244),
    [sym_array] = STATE(7244),
    [sym_hash] = STATE(7244),
    [sym_false] = STATE(7242),
    [sym_nil] = STATE(7242),
    [sym_scope_resolution] = STATE(7245),
    [sym_call] = STATE(7245),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11466),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11468),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11470),
    [anon_sym_not] = ACTIONS(11472),
    [sym_self] = ACTIONS(11474),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11476),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11478),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11478),
    [anon_sym_PLUS] = ACTIONS(11480),
    [anon_sym_TILDE] = ACTIONS(11470),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11482),
    [sym_character] = ACTIONS(11478),
    [sym_super] = ACTIONS(11474),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11484),
    [anon_sym_next] = ACTIONS(11486),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11466),
    [sym_constant] = ACTIONS(11474),
    [anon_sym_defined_QMARK] = ACTIONS(11488),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(7156),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11474),
    [sym_redo] = ACTIONS(11466),
    [sym_class_variable] = ACTIONS(11482),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11490),
  },
  [11935] = {
    [aux_sym_exceptions_repeat1] = STATE(11935),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17388),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11936] = {
    [anon_sym_SLASH] = ACTIONS(11500),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11502),
    [anon_sym_EQ_TILDE] = ACTIONS(11502),
    [anon_sym_LT_LT] = ACTIONS(11504),
    [sym__binary_star] = ACTIONS(11506),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(11508),
    [anon_sym_AMP] = ACTIONS(11510),
    [anon_sym_PERCENT] = ACTIONS(11500),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(11502),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(11512),
    [anon_sym_PIPE] = ACTIONS(11514),
    [anon_sym_DOT_DOT] = ACTIONS(11516),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(11512),
    [anon_sym_QMARK] = ACTIONS(11518),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11504),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11520),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(11512),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(11522),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(11522),
    [anon_sym_GT_EQ] = ACTIONS(11524),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11502),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_LT_EQ_GT] = ACTIONS(11502),
    [anon_sym_AMP_AMP] = ACTIONS(11522),
    [sym__binary_minus] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11514),
  },
  [11937] = {
    [aux_sym_exceptions_repeat1] = STATE(11937),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17391),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11938] = {
    [anon_sym_LT] = ACTIONS(11558),
    [anon_sym_SLASH] = ACTIONS(11560),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11562),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11564),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11566),
    [anon_sym_LT_LT] = ACTIONS(11564),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11568),
    [anon_sym_AMP] = ACTIONS(11570),
    [anon_sym_EQ_TILDE] = ACTIONS(11568),
    [anon_sym_GT] = ACTIONS(11558),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(11572),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(11560),
    [sym__binary_star] = ACTIONS(11560),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11574),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(11568),
    [anon_sym_PIPE_PIPE] = ACTIONS(11568),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11576),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11568),
    [anon_sym_STAR_STAR] = ACTIONS(11560),
    [anon_sym_PIPE] = ACTIONS(11578),
    [anon_sym_DOT_DOT] = ACTIONS(11580),
    [anon_sym_AMP_AMP] = ACTIONS(11568),
    [anon_sym_LT_EQ_GT] = ACTIONS(11568),
    [anon_sym_LT_EQ] = ACTIONS(11558),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11582),
    [sym__binary_minus] = ACTIONS(11572),
  },
  [11939] = {
    [anon_sym_LT] = ACTIONS(11598),
    [anon_sym_SLASH] = ACTIONS(11600),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11602),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11604),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11606),
    [anon_sym_LT_LT] = ACTIONS(11604),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11608),
    [anon_sym_AMP] = ACTIONS(11610),
    [anon_sym_EQ_TILDE] = ACTIONS(11608),
    [anon_sym_GT] = ACTIONS(11598),
    [anon_sym_PLUS] = ACTIONS(11612),
    [anon_sym_PERCENT] = ACTIONS(11600),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(11600),
    [anon_sym_EQ_EQ] = ACTIONS(11614),
    [anon_sym_BANG_TILDE] = ACTIONS(11608),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(11608),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11616),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(11608),
    [anon_sym_STAR_STAR] = ACTIONS(11600),
    [anon_sym_PIPE] = ACTIONS(11618),
    [anon_sym_DOT_DOT] = ACTIONS(11620),
    [anon_sym_AMP_AMP] = ACTIONS(11608),
    [anon_sym_LT_EQ_GT] = ACTIONS(11608),
    [anon_sym_LT_EQ] = ACTIONS(11598),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11622),
    [sym__binary_minus] = ACTIONS(11612),
  },
  [11940] = {
    [aux_sym_exceptions_repeat1] = STATE(11940),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17394),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11941] = {
    [anon_sym_SLASH] = ACTIONS(11632),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11634),
    [anon_sym_EQ_TILDE] = ACTIONS(11634),
    [anon_sym_LT_LT] = ACTIONS(11636),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(11638),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_AMP] = ACTIONS(11642),
    [anon_sym_PERCENT] = ACTIONS(11632),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(11634),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(11644),
    [anon_sym_PIPE] = ACTIONS(11646),
    [anon_sym_DOT_DOT] = ACTIONS(11648),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(11644),
    [anon_sym_QMARK] = ACTIONS(11650),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11636),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11652),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(11644),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(11654),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(11654),
    [anon_sym_GT_EQ] = ACTIONS(11656),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11634),
    [anon_sym_STAR_STAR] = ACTIONS(11632),
    [anon_sym_LT_EQ_GT] = ACTIONS(11634),
    [anon_sym_AMP_AMP] = ACTIONS(11654),
    [sym__binary_minus] = ACTIONS(11658),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11646),
  },
  [11942] = {
    [sym_heredoc_body] = STATE(11942),
    [aux_sym_call_repeat1] = STATE(11942),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [11943] = {
    [sym_heredoc_body] = STATE(11942),
    [aux_sym_call_repeat1] = STATE(11942),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [11944] = {
    [sym_assignment] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_return] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_true] = STATE(7494),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(7684),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [sym_global_variable] = ACTIONS(3724),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(3716),
    [sym_character] = ACTIONS(3718),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [11945] = {
    [aux_sym_exceptions_repeat1] = STATE(12285),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17397),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [11946] = {
    [sym_assignment] = STATE(12286),
    [sym_unary] = STATE(12286),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7494),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(12286),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7494),
    [sym_operator_assignment] = STATE(12286),
    [sym_conditional] = STATE(12286),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7496),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7494),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7494),
    [sym_range] = STATE(12286),
    [sym_binary] = STATE(12286),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7494),
    [sym_nil] = STATE(7494),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11699),
    [anon_sym_not] = ACTIONS(11701),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11705),
    [anon_sym_TILDE] = ACTIONS(11699),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11707),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11711),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [11947] = {
    [aux_sym_exceptions_repeat1] = STATE(11947),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17399),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11948] = {
    [anon_sym_LT] = ACTIONS(11721),
    [anon_sym_SLASH] = ACTIONS(11723),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11725),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11729),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11731),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(11731),
    [anon_sym_AMP] = ACTIONS(11733),
    [anon_sym_GT] = ACTIONS(11721),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(11723),
    [sym__binary_star] = ACTIONS(11723),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11737),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(11731),
    [anon_sym_PIPE_PIPE] = ACTIONS(11731),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11739),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11731),
    [anon_sym_STAR_STAR] = ACTIONS(11723),
    [anon_sym_PIPE] = ACTIONS(11741),
    [anon_sym_DOT_DOT] = ACTIONS(11743),
    [anon_sym_AMP_AMP] = ACTIONS(11731),
    [anon_sym_LT_EQ_GT] = ACTIONS(11731),
    [anon_sym_LT_EQ] = ACTIONS(11721),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11745),
    [sym__binary_minus] = ACTIONS(11735),
  },
  [11949] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11950] = {
    [sym_assignment] = STATE(12287),
    [sym_unary] = STATE(12287),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7543),
    [sym_singleton_class] = STATE(2083),
    [sym_module] = STATE(2083),
    [sym_chained_string] = STATE(2083),
    [sym_until] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_for] = STATE(2083),
    [sym_symbol] = STATE(2083),
    [sym_if] = STATE(2083),
    [sym_begin] = STATE(2083),
    [sym__arg] = STATE(12287),
    [sym__primary] = STATE(2083),
    [sym_method_call] = STATE(7543),
    [sym_operator_assignment] = STATE(12287),
    [sym_conditional] = STATE(12287),
    [sym_method] = STATE(2083),
    [sym_singleton_method] = STATE(2083),
    [sym__variable] = STATE(2085),
    [sym_left_assignment_list] = STATE(7545),
    [sym_rational] = STATE(2083),
    [sym_true] = STATE(7543),
    [sym_return] = STATE(2083),
    [sym_subshell] = STATE(2083),
    [sym_yield] = STATE(2083),
    [sym_string] = STATE(7497),
    [sym_unless] = STATE(2083),
    [sym_lambda] = STATE(2083),
    [sym_parenthesized_statements] = STATE(2083),
    [sym_element_reference] = STATE(7543),
    [sym_range] = STATE(12287),
    [sym_binary] = STATE(12287),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(2083),
    [sym_break] = STATE(2083),
    [sym_next] = STATE(2083),
    [sym_string_array] = STATE(2083),
    [sym_while] = STATE(2083),
    [sym_case] = STATE(2083),
    [sym_symbol_array] = STATE(2083),
    [sym_array] = STATE(2083),
    [sym_hash] = STATE(2083),
    [sym_false] = STATE(7543),
    [sym_nil] = STATE(7543),
    [sym_scope_resolution] = STATE(2085),
    [sym_call] = STATE(2085),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(3712),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11697),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(11779),
    [anon_sym_not] = ACTIONS(11781),
    [sym_self] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(11703),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(3718),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(3718),
    [anon_sym_PLUS] = ACTIONS(11785),
    [anon_sym_TILDE] = ACTIONS(11779),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(3724),
    [sym_character] = ACTIONS(3718),
    [sym_super] = ACTIONS(3716),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(11787),
    [anon_sym_next] = ACTIONS(11709),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(3712),
    [sym_constant] = ACTIONS(3716),
    [anon_sym_defined_QMARK] = ACTIONS(11789),
    [sym_instance_variable] = ACTIONS(3724),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(3716),
    [sym_redo] = ACTIONS(3712),
    [sym_class_variable] = ACTIONS(3724),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(11713),
  },
  [11951] = {
    [sym_assignment] = STATE(11275),
    [sym_unary] = STATE(11275),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(11275),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(11275),
    [sym_conditional] = STATE(11275),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_return] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_true] = STATE(7559),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(11275),
    [sym_binary] = STATE(11275),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(7740),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [sym_global_variable] = ACTIONS(11813),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(11805),
    [sym_character] = ACTIONS(11809),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [11952] = {
    [aux_sym_exceptions_repeat1] = STATE(12288),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17402),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [11953] = {
    [sym_assignment] = STATE(12289),
    [sym_unary] = STATE(12289),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(7559),
    [sym_singleton_class] = STATE(7561),
    [sym_module] = STATE(7561),
    [sym_chained_string] = STATE(7561),
    [sym_until] = STATE(7561),
    [sym_regex] = STATE(7561),
    [sym_for] = STATE(7561),
    [sym_symbol] = STATE(7561),
    [sym_if] = STATE(7561),
    [sym_begin] = STATE(7561),
    [sym__arg] = STATE(12289),
    [sym__primary] = STATE(7561),
    [sym_method_call] = STATE(7559),
    [sym_operator_assignment] = STATE(12289),
    [sym_conditional] = STATE(12289),
    [sym_method] = STATE(7561),
    [sym_singleton_method] = STATE(7561),
    [sym__variable] = STATE(7562),
    [sym_left_assignment_list] = STATE(7563),
    [sym_rational] = STATE(7561),
    [sym_true] = STATE(7559),
    [sym_return] = STATE(7561),
    [sym_subshell] = STATE(7561),
    [sym_yield] = STATE(7561),
    [sym_string] = STATE(7564),
    [sym_unless] = STATE(7561),
    [sym_lambda] = STATE(7561),
    [sym_parenthesized_statements] = STATE(7561),
    [sym_element_reference] = STATE(7559),
    [sym_range] = STATE(12289),
    [sym_binary] = STATE(12289),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(7561),
    [sym_break] = STATE(7561),
    [sym_next] = STATE(7561),
    [sym_string_array] = STATE(7561),
    [sym_while] = STATE(7561),
    [sym_case] = STATE(7561),
    [sym_symbol_array] = STATE(7561),
    [sym_array] = STATE(7561),
    [sym_hash] = STATE(7561),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_scope_resolution] = STATE(7562),
    [sym_call] = STATE(7562),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(11797),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(11799),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(11801),
    [anon_sym_not] = ACTIONS(11803),
    [sym_self] = ACTIONS(11805),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(11807),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(11809),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(11809),
    [anon_sym_PLUS] = ACTIONS(11811),
    [anon_sym_TILDE] = ACTIONS(11801),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(11813),
    [sym_character] = ACTIONS(11809),
    [sym_super] = ACTIONS(11805),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(11815),
    [anon_sym_next] = ACTIONS(11817),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(11797),
    [sym_constant] = ACTIONS(11805),
    [anon_sym_defined_QMARK] = ACTIONS(11819),
    [sym_instance_variable] = ACTIONS(11813),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(3730),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(11805),
    [sym_redo] = ACTIONS(11797),
    [sym_class_variable] = ACTIONS(11813),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(11821),
  },
  [11954] = {
    [aux_sym_exceptions_repeat1] = STATE(11954),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17404),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11955] = {
    [anon_sym_SLASH] = ACTIONS(11831),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11833),
    [anon_sym_EQ_TILDE] = ACTIONS(11833),
    [anon_sym_LT_LT] = ACTIONS(11835),
    [sym__binary_star] = ACTIONS(11837),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(11839),
    [anon_sym_AMP] = ACTIONS(11841),
    [anon_sym_PERCENT] = ACTIONS(11831),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(11833),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(11843),
    [anon_sym_PIPE] = ACTIONS(11845),
    [anon_sym_DOT_DOT] = ACTIONS(11847),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(11843),
    [anon_sym_QMARK] = ACTIONS(11849),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11835),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11851),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(11843),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(11853),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(11853),
    [anon_sym_GT_EQ] = ACTIONS(11855),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11833),
    [anon_sym_STAR_STAR] = ACTIONS(11831),
    [anon_sym_LT_EQ_GT] = ACTIONS(11833),
    [anon_sym_AMP_AMP] = ACTIONS(11853),
    [sym__binary_minus] = ACTIONS(11857),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11845),
  },
  [11956] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_while] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
  },
  [11957] = {
    [aux_sym_exceptions_repeat1] = STATE(11957),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17407),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [11958] = {
    [anon_sym_LT] = ACTIONS(11939),
    [anon_sym_SLASH] = ACTIONS(11941),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(11945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11949),
    [anon_sym_LT_LT] = ACTIONS(11945),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11939),
    [anon_sym_PLUS] = ACTIONS(11953),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(11941),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(11941),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(11955),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(11947),
    [anon_sym_PIPE_PIPE] = ACTIONS(11947),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(11957),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(11947),
    [anon_sym_STAR_STAR] = ACTIONS(11941),
    [anon_sym_PIPE] = ACTIONS(11959),
    [anon_sym_DOT_DOT] = ACTIONS(11961),
    [anon_sym_AMP_AMP] = ACTIONS(11947),
    [anon_sym_LT_EQ_GT] = ACTIONS(11947),
    [anon_sym_LT_EQ] = ACTIONS(11939),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(11963),
    [sym__binary_minus] = ACTIONS(11953),
  },
  [11959] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [11960] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_COLON2] = ACTIONS(16492),
    [anon_sym_while] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
    [sym__binary_minus] = ACTIONS(16494),
  },
  [11961] = {
    [anon_sym_LT] = ACTIONS(12037),
    [anon_sym_SLASH] = ACTIONS(12039),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12041),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12047),
    [anon_sym_LT_LT] = ACTIONS(12043),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12045),
    [anon_sym_AMP] = ACTIONS(12049),
    [anon_sym_GT] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12051),
    [anon_sym_PERCENT] = ACTIONS(12039),
    [sym__binary_star] = ACTIONS(12039),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(12053),
    [anon_sym_BANG_TILDE] = ACTIONS(12045),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12045),
    [anon_sym_while] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12055),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12045),
    [anon_sym_STAR_STAR] = ACTIONS(12039),
    [anon_sym_PIPE] = ACTIONS(12057),
    [anon_sym_DOT_DOT] = ACTIONS(12059),
    [anon_sym_AMP_AMP] = ACTIONS(12045),
    [anon_sym_LT_EQ_GT] = ACTIONS(12045),
    [anon_sym_LT_EQ] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(12061),
    [sym__binary_minus] = ACTIONS(12051),
  },
  [11962] = {
    [anon_sym_SLASH] = ACTIONS(16422),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_while] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11963] = {
    [anon_sym_SLASH] = ACTIONS(11543),
    [anon_sym_RBRACK] = ACTIONS(11545),
    [anon_sym_until] = ACTIONS(11545),
    [anon_sym_AMP_EQ] = ACTIONS(11545),
    [anon_sym_GT_GT_EQ] = ACTIONS(11545),
    [anon_sym_SLASH_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11545),
    [anon_sym_RPAREN] = ACTIONS(11545),
    [anon_sym_EQ_TILDE] = ACTIONS(11545),
    [anon_sym_LT_LT] = ACTIONS(11543),
    [anon_sym_RBRACE] = ACTIONS(11545),
    [sym__binary_star] = ACTIONS(11545),
    [anon_sym_unless] = ACTIONS(11545),
    [anon_sym_PLUS] = ACTIONS(11543),
    [anon_sym_AMP] = ACTIONS(11543),
    [anon_sym_PERCENT] = ACTIONS(11543),
    [anon_sym_COLON_COLON2] = ACTIONS(11545),
    [anon_sym_rescue] = ACTIONS(11545),
    [anon_sym_PERCENT_EQ] = ACTIONS(11545),
    [anon_sym_LT_LT_EQ] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_DOT] = ACTIONS(11543),
    [anon_sym_BANG_TILDE] = ACTIONS(11545),
    [anon_sym_LBRACE] = ACTIONS(11545),
    [anon_sym_COLON2] = ACTIONS(11543),
    [anon_sym_while] = ACTIONS(11545),
    [sym__heredoc_body_start] = ACTIONS(11545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11545),
    [anon_sym_CARET_EQ] = ACTIONS(11545),
    [anon_sym_AMP_DOT] = ACTIONS(11545),
    [anon_sym_LT_EQ] = ACTIONS(11543),
    [anon_sym_PIPE] = ACTIONS(11543),
    [anon_sym_DOT_DOT] = ACTIONS(11543),
    [anon_sym_EQ] = ACTIONS(11543),
    [anon_sym_LT] = ACTIONS(11543),
    [anon_sym_in] = ACTIONS(11545),
    [anon_sym_QMARK] = ACTIONS(11545),
    [anon_sym_COMMA] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11543),
    [anon_sym_SEMI] = ACTIONS(11545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11545),
    [anon_sym_or] = ACTIONS(11545),
    [anon_sym_GT] = ACTIONS(11543),
    [anon_sym_PIPE_EQ] = ACTIONS(11545),
    [anon_sym_PLUS_EQ] = ACTIONS(11545),
    [anon_sym_STAR_EQ] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_and] = ACTIONS(11545),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_GT_EQ] = ACTIONS(11545),
    [anon_sym_LBRACK] = ACTIONS(11545),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11545),
    [anon_sym_DASH_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11545),
    [anon_sym_BANG_EQ] = ACTIONS(11545),
    [anon_sym_STAR_STAR] = ACTIONS(11543),
    [anon_sym_LT_EQ_GT] = ACTIONS(11545),
    [sym__binary_minus] = ACTIONS(11545),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_if] = ACTIONS(11545),
    [anon_sym_CARET] = ACTIONS(11543),
  },
  [11964] = {
    [anon_sym_SLASH] = ACTIONS(13274),
    [anon_sym_RBRACK] = ACTIONS(13276),
    [anon_sym_until] = ACTIONS(13276),
    [anon_sym_AMP_EQ] = ACTIONS(13276),
    [anon_sym_GT_GT_EQ] = ACTIONS(13276),
    [anon_sym_SLASH_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13276),
    [anon_sym_RPAREN] = ACTIONS(13276),
    [anon_sym_EQ_TILDE] = ACTIONS(13276),
    [anon_sym_LT_LT] = ACTIONS(13274),
    [anon_sym_RBRACE] = ACTIONS(13276),
    [sym__binary_star] = ACTIONS(13276),
    [anon_sym_unless] = ACTIONS(13276),
    [anon_sym_PLUS] = ACTIONS(13274),
    [anon_sym_AMP] = ACTIONS(13274),
    [anon_sym_PERCENT] = ACTIONS(13274),
    [anon_sym_COLON_COLON2] = ACTIONS(13276),
    [anon_sym_rescue] = ACTIONS(13276),
    [anon_sym_PERCENT_EQ] = ACTIONS(13276),
    [anon_sym_LT_LT_EQ] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_DOT] = ACTIONS(13274),
    [anon_sym_BANG_TILDE] = ACTIONS(13276),
    [anon_sym_LBRACE] = ACTIONS(13276),
    [anon_sym_COLON2] = ACTIONS(13274),
    [anon_sym_while] = ACTIONS(13276),
    [sym__heredoc_body_start] = ACTIONS(13276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13276),
    [anon_sym_CARET_EQ] = ACTIONS(13276),
    [anon_sym_AMP_DOT] = ACTIONS(13276),
    [anon_sym_LT_EQ] = ACTIONS(13274),
    [anon_sym_PIPE] = ACTIONS(13274),
    [anon_sym_DOT_DOT] = ACTIONS(13274),
    [anon_sym_EQ] = ACTIONS(13274),
    [anon_sym_LT] = ACTIONS(13274),
    [anon_sym_in] = ACTIONS(13276),
    [anon_sym_QMARK] = ACTIONS(13276),
    [anon_sym_COMMA] = ACTIONS(13276),
    [anon_sym_GT_GT] = ACTIONS(13274),
    [anon_sym_SEMI] = ACTIONS(13276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13276),
    [anon_sym_or] = ACTIONS(13276),
    [anon_sym_GT] = ACTIONS(13274),
    [anon_sym_PIPE_EQ] = ACTIONS(13276),
    [anon_sym_PLUS_EQ] = ACTIONS(13276),
    [anon_sym_STAR_EQ] = ACTIONS(13276),
    [anon_sym_EQ_EQ] = ACTIONS(13274),
    [anon_sym_and] = ACTIONS(13276),
    [anon_sym_PIPE_PIPE] = ACTIONS(13274),
    [anon_sym_GT_EQ] = ACTIONS(13276),
    [anon_sym_LBRACK] = ACTIONS(13276),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13276),
    [anon_sym_DASH_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13276),
    [anon_sym_BANG_EQ] = ACTIONS(13276),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_LT_EQ_GT] = ACTIONS(13276),
    [sym__binary_minus] = ACTIONS(13276),
    [anon_sym_AMP_AMP] = ACTIONS(13274),
    [anon_sym_if] = ACTIONS(13276),
    [anon_sym_CARET] = ACTIONS(13274),
  },
  [11965] = {
    [anon_sym_end] = ACTIONS(17410),
    [sym_comment] = ACTIONS(49),
  },
  [11966] = {
    [sym_when] = STATE(3422),
    [sym_else] = STATE(12291),
    [aux_sym_case_repeat2] = STATE(3422),
    [anon_sym_when] = ACTIONS(2375),
    [anon_sym_end] = ACTIONS(17410),
    [anon_sym_else] = ACTIONS(2379),
    [sym_comment] = ACTIONS(49),
  },
  [11967] = {
    [anon_sym_SLASH] = ACTIONS(13956),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_until] = ACTIONS(13958),
    [anon_sym_AMP_EQ] = ACTIONS(13958),
    [anon_sym_GT_GT_EQ] = ACTIONS(13958),
    [anon_sym_SLASH_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13958),
    [anon_sym_RPAREN] = ACTIONS(13958),
    [anon_sym_EQ_TILDE] = ACTIONS(13958),
    [anon_sym_LT_LT] = ACTIONS(13956),
    [anon_sym_RBRACE] = ACTIONS(13958),
    [sym__binary_star] = ACTIONS(13958),
    [anon_sym_unless] = ACTIONS(13958),
    [anon_sym_PLUS] = ACTIONS(13956),
    [anon_sym_AMP] = ACTIONS(13956),
    [anon_sym_PERCENT] = ACTIONS(13956),
    [anon_sym_COLON_COLON2] = ACTIONS(13958),
    [anon_sym_rescue] = ACTIONS(13958),
    [anon_sym_PERCENT_EQ] = ACTIONS(13958),
    [anon_sym_LT_LT_EQ] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_DOT] = ACTIONS(13956),
    [anon_sym_BANG_TILDE] = ACTIONS(13958),
    [anon_sym_LBRACE] = ACTIONS(13958),
    [anon_sym_COLON2] = ACTIONS(13956),
    [anon_sym_while] = ACTIONS(13958),
    [sym__heredoc_body_start] = ACTIONS(13958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13958),
    [anon_sym_CARET_EQ] = ACTIONS(13958),
    [anon_sym_AMP_DOT] = ACTIONS(13958),
    [anon_sym_LT_EQ] = ACTIONS(13956),
    [anon_sym_PIPE] = ACTIONS(13956),
    [anon_sym_DOT_DOT] = ACTIONS(13956),
    [anon_sym_EQ] = ACTIONS(13956),
    [anon_sym_LT] = ACTIONS(13956),
    [anon_sym_in] = ACTIONS(13958),
    [anon_sym_QMARK] = ACTIONS(13958),
    [anon_sym_COMMA] = ACTIONS(13958),
    [anon_sym_GT_GT] = ACTIONS(13956),
    [anon_sym_SEMI] = ACTIONS(13958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13958),
    [anon_sym_or] = ACTIONS(13958),
    [anon_sym_GT] = ACTIONS(13956),
    [anon_sym_PIPE_EQ] = ACTIONS(13958),
    [anon_sym_PLUS_EQ] = ACTIONS(13958),
    [anon_sym_STAR_EQ] = ACTIONS(13958),
    [anon_sym_EQ_EQ] = ACTIONS(13956),
    [anon_sym_and] = ACTIONS(13958),
    [anon_sym_PIPE_PIPE] = ACTIONS(13956),
    [anon_sym_GT_EQ] = ACTIONS(13958),
    [anon_sym_LBRACK] = ACTIONS(13958),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13958),
    [anon_sym_DASH_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13958),
    [anon_sym_BANG_EQ] = ACTIONS(13958),
    [anon_sym_STAR_STAR] = ACTIONS(13956),
    [anon_sym_LT_EQ_GT] = ACTIONS(13958),
    [sym__binary_minus] = ACTIONS(13958),
    [anon_sym_AMP_AMP] = ACTIONS(13956),
    [anon_sym_if] = ACTIONS(13958),
    [anon_sym_CARET] = ACTIONS(13956),
  },
  [11968] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(3973),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(17412),
  },
  [11969] = {
    [anon_sym_SLASH] = ACTIONS(13962),
    [anon_sym_RBRACK] = ACTIONS(13964),
    [anon_sym_until] = ACTIONS(13964),
    [anon_sym_AMP_EQ] = ACTIONS(13964),
    [anon_sym_GT_GT_EQ] = ACTIONS(13964),
    [anon_sym_SLASH_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13964),
    [anon_sym_RPAREN] = ACTIONS(13964),
    [anon_sym_EQ_TILDE] = ACTIONS(13964),
    [anon_sym_LT_LT] = ACTIONS(13962),
    [anon_sym_RBRACE] = ACTIONS(13964),
    [sym__binary_star] = ACTIONS(13964),
    [anon_sym_unless] = ACTIONS(13964),
    [anon_sym_PLUS] = ACTIONS(13962),
    [anon_sym_AMP] = ACTIONS(13962),
    [anon_sym_PERCENT] = ACTIONS(13962),
    [anon_sym_COLON_COLON2] = ACTIONS(13964),
    [anon_sym_rescue] = ACTIONS(13964),
    [anon_sym_PERCENT_EQ] = ACTIONS(13964),
    [anon_sym_LT_LT_EQ] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_DOT] = ACTIONS(13962),
    [anon_sym_BANG_TILDE] = ACTIONS(13964),
    [anon_sym_LBRACE] = ACTIONS(13964),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_while] = ACTIONS(13964),
    [sym__heredoc_body_start] = ACTIONS(13964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13964),
    [anon_sym_CARET_EQ] = ACTIONS(13964),
    [anon_sym_AMP_DOT] = ACTIONS(13964),
    [anon_sym_LT_EQ] = ACTIONS(13962),
    [anon_sym_PIPE] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(13962),
    [anon_sym_EQ] = ACTIONS(13962),
    [anon_sym_LT] = ACTIONS(13962),
    [anon_sym_in] = ACTIONS(13964),
    [anon_sym_QMARK] = ACTIONS(13964),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_GT_GT] = ACTIONS(13962),
    [anon_sym_SEMI] = ACTIONS(13964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13964),
    [anon_sym_or] = ACTIONS(13964),
    [anon_sym_GT] = ACTIONS(13962),
    [anon_sym_PIPE_EQ] = ACTIONS(13964),
    [anon_sym_PLUS_EQ] = ACTIONS(13964),
    [anon_sym_STAR_EQ] = ACTIONS(13964),
    [anon_sym_EQ_EQ] = ACTIONS(13962),
    [anon_sym_and] = ACTIONS(13964),
    [anon_sym_PIPE_PIPE] = ACTIONS(13962),
    [anon_sym_GT_EQ] = ACTIONS(13964),
    [anon_sym_LBRACK] = ACTIONS(13964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13964),
    [anon_sym_DASH_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13964),
    [anon_sym_BANG_EQ] = ACTIONS(13964),
    [anon_sym_STAR_STAR] = ACTIONS(13962),
    [anon_sym_LT_EQ_GT] = ACTIONS(13964),
    [sym__binary_minus] = ACTIONS(13964),
    [anon_sym_AMP_AMP] = ACTIONS(13962),
    [anon_sym_if] = ACTIONS(13964),
    [anon_sym_CARET] = ACTIONS(13962),
  },
  [11970] = {
    [anon_sym_SLASH] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11868),
    [anon_sym_until] = ACTIONS(11868),
    [anon_sym_AMP_EQ] = ACTIONS(11868),
    [anon_sym_GT_GT_EQ] = ACTIONS(11868),
    [anon_sym_SLASH_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11868),
    [anon_sym_RPAREN] = ACTIONS(11868),
    [anon_sym_EQ_TILDE] = ACTIONS(11868),
    [anon_sym_LT_LT] = ACTIONS(11866),
    [anon_sym_RBRACE] = ACTIONS(11868),
    [sym__binary_star] = ACTIONS(11868),
    [anon_sym_unless] = ACTIONS(11868),
    [anon_sym_PLUS] = ACTIONS(11866),
    [anon_sym_AMP] = ACTIONS(11866),
    [anon_sym_PERCENT] = ACTIONS(11866),
    [anon_sym_COLON_COLON2] = ACTIONS(11868),
    [anon_sym_rescue] = ACTIONS(11868),
    [anon_sym_PERCENT_EQ] = ACTIONS(11868),
    [anon_sym_LT_LT_EQ] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_BANG_TILDE] = ACTIONS(11868),
    [anon_sym_LBRACE] = ACTIONS(11868),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11868),
    [sym__heredoc_body_start] = ACTIONS(11868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11868),
    [anon_sym_CARET_EQ] = ACTIONS(11868),
    [anon_sym_AMP_DOT] = ACTIONS(11868),
    [anon_sym_LT_EQ] = ACTIONS(11866),
    [anon_sym_PIPE] = ACTIONS(11866),
    [anon_sym_DOT_DOT] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_LT] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(11868),
    [anon_sym_QMARK] = ACTIONS(11868),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_GT_GT] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11868),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11868),
    [anon_sym_or] = ACTIONS(11868),
    [anon_sym_GT] = ACTIONS(11866),
    [anon_sym_PIPE_EQ] = ACTIONS(11868),
    [anon_sym_PLUS_EQ] = ACTIONS(11868),
    [anon_sym_STAR_EQ] = ACTIONS(11868),
    [anon_sym_EQ_EQ] = ACTIONS(11866),
    [anon_sym_and] = ACTIONS(11868),
    [anon_sym_PIPE_PIPE] = ACTIONS(11866),
    [anon_sym_GT_EQ] = ACTIONS(11868),
    [anon_sym_LBRACK] = ACTIONS(11868),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11868),
    [anon_sym_DASH_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11868),
    [anon_sym_BANG_EQ] = ACTIONS(11868),
    [anon_sym_STAR_STAR] = ACTIONS(11866),
    [anon_sym_LT_EQ_GT] = ACTIONS(11868),
    [sym__binary_minus] = ACTIONS(11868),
    [anon_sym_AMP_AMP] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11868),
    [anon_sym_CARET] = ACTIONS(11866),
  },
  [11971] = {
    [anon_sym_SLASH] = ACTIONS(13462),
    [anon_sym_RBRACK] = ACTIONS(13464),
    [anon_sym_until] = ACTIONS(13464),
    [anon_sym_AMP_EQ] = ACTIONS(13464),
    [anon_sym_GT_GT_EQ] = ACTIONS(13464),
    [anon_sym_SLASH_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13464),
    [anon_sym_RPAREN] = ACTIONS(13464),
    [anon_sym_EQ_TILDE] = ACTIONS(13464),
    [anon_sym_LT_LT] = ACTIONS(13462),
    [anon_sym_RBRACE] = ACTIONS(13464),
    [sym__binary_star] = ACTIONS(13464),
    [anon_sym_unless] = ACTIONS(13464),
    [anon_sym_PLUS] = ACTIONS(13462),
    [anon_sym_AMP] = ACTIONS(13462),
    [anon_sym_PERCENT] = ACTIONS(13462),
    [anon_sym_COLON_COLON2] = ACTIONS(13464),
    [anon_sym_rescue] = ACTIONS(13464),
    [anon_sym_PERCENT_EQ] = ACTIONS(13464),
    [anon_sym_LT_LT_EQ] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_DOT] = ACTIONS(13462),
    [anon_sym_BANG_TILDE] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(13464),
    [anon_sym_COLON2] = ACTIONS(13462),
    [anon_sym_while] = ACTIONS(13464),
    [sym__heredoc_body_start] = ACTIONS(13464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13464),
    [anon_sym_CARET_EQ] = ACTIONS(13464),
    [anon_sym_AMP_DOT] = ACTIONS(13464),
    [anon_sym_LT_EQ] = ACTIONS(13462),
    [anon_sym_PIPE] = ACTIONS(13462),
    [anon_sym_DOT_DOT] = ACTIONS(13462),
    [anon_sym_EQ] = ACTIONS(13462),
    [anon_sym_LT] = ACTIONS(13462),
    [anon_sym_in] = ACTIONS(13464),
    [anon_sym_QMARK] = ACTIONS(13464),
    [anon_sym_COMMA] = ACTIONS(13464),
    [anon_sym_GT_GT] = ACTIONS(13462),
    [anon_sym_SEMI] = ACTIONS(13464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13464),
    [anon_sym_or] = ACTIONS(13464),
    [anon_sym_GT] = ACTIONS(13462),
    [anon_sym_PIPE_EQ] = ACTIONS(13464),
    [anon_sym_PLUS_EQ] = ACTIONS(13464),
    [anon_sym_STAR_EQ] = ACTIONS(13464),
    [anon_sym_EQ_EQ] = ACTIONS(13462),
    [anon_sym_and] = ACTIONS(13464),
    [anon_sym_PIPE_PIPE] = ACTIONS(13462),
    [anon_sym_GT_EQ] = ACTIONS(13464),
    [anon_sym_LBRACK] = ACTIONS(13464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13464),
    [anon_sym_DASH_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13464),
    [anon_sym_BANG_EQ] = ACTIONS(13464),
    [anon_sym_STAR_STAR] = ACTIONS(13462),
    [anon_sym_LT_EQ_GT] = ACTIONS(13464),
    [sym__binary_minus] = ACTIONS(13464),
    [anon_sym_AMP_AMP] = ACTIONS(13462),
    [anon_sym_if] = ACTIONS(13464),
    [anon_sym_CARET] = ACTIONS(13462),
  },
  [11972] = {
    [anon_sym_SLASH] = ACTIONS(13466),
    [anon_sym_RBRACK] = ACTIONS(13468),
    [anon_sym_until] = ACTIONS(13468),
    [anon_sym_AMP_EQ] = ACTIONS(13468),
    [anon_sym_GT_GT_EQ] = ACTIONS(13468),
    [anon_sym_SLASH_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13468),
    [anon_sym_RPAREN] = ACTIONS(13468),
    [anon_sym_EQ_TILDE] = ACTIONS(13468),
    [anon_sym_LT_LT] = ACTIONS(13466),
    [anon_sym_RBRACE] = ACTIONS(13468),
    [sym__binary_star] = ACTIONS(13468),
    [anon_sym_unless] = ACTIONS(13468),
    [anon_sym_PLUS] = ACTIONS(13466),
    [anon_sym_AMP] = ACTIONS(13466),
    [anon_sym_PERCENT] = ACTIONS(13466),
    [anon_sym_COLON_COLON2] = ACTIONS(13468),
    [anon_sym_rescue] = ACTIONS(13468),
    [anon_sym_PERCENT_EQ] = ACTIONS(13468),
    [anon_sym_LT_LT_EQ] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_DOT] = ACTIONS(13466),
    [anon_sym_BANG_TILDE] = ACTIONS(13468),
    [anon_sym_LBRACE] = ACTIONS(13468),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_while] = ACTIONS(13468),
    [sym__heredoc_body_start] = ACTIONS(13468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13468),
    [anon_sym_CARET_EQ] = ACTIONS(13468),
    [anon_sym_AMP_DOT] = ACTIONS(13468),
    [anon_sym_LT_EQ] = ACTIONS(13466),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(13466),
    [anon_sym_EQ] = ACTIONS(13466),
    [anon_sym_LT] = ACTIONS(13466),
    [anon_sym_in] = ACTIONS(13468),
    [anon_sym_QMARK] = ACTIONS(13468),
    [anon_sym_COMMA] = ACTIONS(13468),
    [anon_sym_GT_GT] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(13468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13468),
    [anon_sym_or] = ACTIONS(13468),
    [anon_sym_GT] = ACTIONS(13466),
    [anon_sym_PIPE_EQ] = ACTIONS(13468),
    [anon_sym_PLUS_EQ] = ACTIONS(13468),
    [anon_sym_STAR_EQ] = ACTIONS(13468),
    [anon_sym_EQ_EQ] = ACTIONS(13466),
    [anon_sym_and] = ACTIONS(13468),
    [anon_sym_PIPE_PIPE] = ACTIONS(13466),
    [anon_sym_GT_EQ] = ACTIONS(13468),
    [anon_sym_LBRACK] = ACTIONS(13468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13468),
    [anon_sym_DASH_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13468),
    [anon_sym_BANG_EQ] = ACTIONS(13468),
    [anon_sym_STAR_STAR] = ACTIONS(13466),
    [anon_sym_LT_EQ_GT] = ACTIONS(13468),
    [sym__binary_minus] = ACTIONS(13468),
    [anon_sym_AMP_AMP] = ACTIONS(13466),
    [anon_sym_if] = ACTIONS(13468),
    [anon_sym_CARET] = ACTIONS(13466),
  },
  [11973] = {
    [anon_sym_SLASH] = ACTIONS(13737),
    [anon_sym_RBRACK] = ACTIONS(13739),
    [anon_sym_until] = ACTIONS(13739),
    [anon_sym_AMP_EQ] = ACTIONS(13739),
    [anon_sym_GT_GT_EQ] = ACTIONS(13739),
    [anon_sym_SLASH_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13739),
    [anon_sym_RPAREN] = ACTIONS(13739),
    [anon_sym_EQ_TILDE] = ACTIONS(13739),
    [anon_sym_LT_LT] = ACTIONS(13737),
    [anon_sym_RBRACE] = ACTIONS(13739),
    [sym__binary_star] = ACTIONS(13739),
    [anon_sym_unless] = ACTIONS(13739),
    [anon_sym_PLUS] = ACTIONS(13737),
    [anon_sym_AMP] = ACTIONS(13737),
    [anon_sym_PERCENT] = ACTIONS(13737),
    [anon_sym_COLON_COLON2] = ACTIONS(13739),
    [anon_sym_rescue] = ACTIONS(13739),
    [anon_sym_PERCENT_EQ] = ACTIONS(13739),
    [anon_sym_LT_LT_EQ] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_DOT] = ACTIONS(13737),
    [anon_sym_BANG_TILDE] = ACTIONS(13739),
    [anon_sym_LBRACE] = ACTIONS(13739),
    [anon_sym_COLON2] = ACTIONS(13737),
    [anon_sym_while] = ACTIONS(13739),
    [sym__heredoc_body_start] = ACTIONS(13739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13739),
    [anon_sym_CARET_EQ] = ACTIONS(13739),
    [anon_sym_AMP_DOT] = ACTIONS(13739),
    [anon_sym_LT_EQ] = ACTIONS(13737),
    [anon_sym_PIPE] = ACTIONS(13737),
    [anon_sym_DOT_DOT] = ACTIONS(13737),
    [anon_sym_EQ] = ACTIONS(13737),
    [anon_sym_LT] = ACTIONS(13737),
    [anon_sym_in] = ACTIONS(13739),
    [anon_sym_QMARK] = ACTIONS(13739),
    [anon_sym_COMMA] = ACTIONS(13739),
    [anon_sym_GT_GT] = ACTIONS(13737),
    [anon_sym_SEMI] = ACTIONS(13739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13739),
    [anon_sym_or] = ACTIONS(13739),
    [anon_sym_GT] = ACTIONS(13737),
    [anon_sym_PIPE_EQ] = ACTIONS(13739),
    [anon_sym_PLUS_EQ] = ACTIONS(13739),
    [anon_sym_STAR_EQ] = ACTIONS(13739),
    [anon_sym_EQ_EQ] = ACTIONS(13737),
    [anon_sym_and] = ACTIONS(13739),
    [anon_sym_PIPE_PIPE] = ACTIONS(13737),
    [anon_sym_GT_EQ] = ACTIONS(13739),
    [anon_sym_LBRACK] = ACTIONS(13739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13739),
    [anon_sym_DASH_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13739),
    [anon_sym_BANG_EQ] = ACTIONS(13739),
    [anon_sym_STAR_STAR] = ACTIONS(13737),
    [anon_sym_LT_EQ_GT] = ACTIONS(13739),
    [sym__binary_minus] = ACTIONS(13739),
    [anon_sym_AMP_AMP] = ACTIONS(13737),
    [anon_sym_if] = ACTIONS(13739),
    [anon_sym_CARET] = ACTIONS(13737),
  },
  [11974] = {
    [anon_sym_end] = ACTIONS(17414),
    [sym_comment] = ACTIONS(49),
  },
  [11975] = {
    [anon_sym_SLASH] = ACTIONS(11877),
    [anon_sym_RBRACK] = ACTIONS(11879),
    [anon_sym_until] = ACTIONS(11879),
    [anon_sym_AMP_EQ] = ACTIONS(11879),
    [anon_sym_GT_GT_EQ] = ACTIONS(11879),
    [anon_sym_SLASH_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11879),
    [anon_sym_RPAREN] = ACTIONS(11879),
    [anon_sym_EQ_TILDE] = ACTIONS(11879),
    [anon_sym_LT_LT] = ACTIONS(11877),
    [anon_sym_RBRACE] = ACTIONS(11879),
    [sym__binary_star] = ACTIONS(11879),
    [anon_sym_unless] = ACTIONS(11879),
    [anon_sym_PLUS] = ACTIONS(11877),
    [anon_sym_AMP] = ACTIONS(11877),
    [anon_sym_PERCENT] = ACTIONS(11877),
    [anon_sym_COLON_COLON2] = ACTIONS(11879),
    [anon_sym_rescue] = ACTIONS(11879),
    [anon_sym_PERCENT_EQ] = ACTIONS(11879),
    [anon_sym_LT_LT_EQ] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_DOT] = ACTIONS(11877),
    [anon_sym_BANG_TILDE] = ACTIONS(11879),
    [anon_sym_LBRACE] = ACTIONS(11879),
    [anon_sym_COLON2] = ACTIONS(11877),
    [anon_sym_while] = ACTIONS(11879),
    [sym__heredoc_body_start] = ACTIONS(11879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(11879),
    [anon_sym_CARET_EQ] = ACTIONS(11879),
    [anon_sym_AMP_DOT] = ACTIONS(11879),
    [anon_sym_LT_EQ] = ACTIONS(11877),
    [anon_sym_PIPE] = ACTIONS(11877),
    [anon_sym_DOT_DOT] = ACTIONS(11877),
    [anon_sym_EQ] = ACTIONS(11877),
    [anon_sym_LT] = ACTIONS(11877),
    [anon_sym_in] = ACTIONS(11879),
    [anon_sym_QMARK] = ACTIONS(11879),
    [anon_sym_COMMA] = ACTIONS(11879),
    [anon_sym_GT_GT] = ACTIONS(11877),
    [anon_sym_SEMI] = ACTIONS(11879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11879),
    [anon_sym_or] = ACTIONS(11879),
    [anon_sym_GT] = ACTIONS(11877),
    [anon_sym_PIPE_EQ] = ACTIONS(11879),
    [anon_sym_PLUS_EQ] = ACTIONS(11879),
    [anon_sym_STAR_EQ] = ACTIONS(11879),
    [anon_sym_EQ_EQ] = ACTIONS(11877),
    [anon_sym_and] = ACTIONS(11879),
    [anon_sym_PIPE_PIPE] = ACTIONS(11877),
    [anon_sym_GT_EQ] = ACTIONS(11879),
    [anon_sym_LBRACK] = ACTIONS(11879),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11879),
    [anon_sym_DASH_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11879),
    [anon_sym_BANG_EQ] = ACTIONS(11879),
    [anon_sym_STAR_STAR] = ACTIONS(11877),
    [anon_sym_LT_EQ_GT] = ACTIONS(11879),
    [sym__binary_minus] = ACTIONS(11879),
    [anon_sym_AMP_AMP] = ACTIONS(11877),
    [anon_sym_if] = ACTIONS(11879),
    [anon_sym_CARET] = ACTIONS(11877),
  },
  [11976] = {
    [sym_interpolation] = STATE(96),
    [sym__literal_contents] = STATE(2298),
    [aux_sym__literal_contents_repeat1] = STATE(96),
    [sym_escape_sequence] = ACTIONS(173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND_LBRACE] = ACTIONS(177),
    [sym__string_content] = ACTIONS(173),
    [sym__string_end] = ACTIONS(17416),
  },
  [11977] = {
    [anon_sym_SLASH] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_EQ_TILDE] = ACTIONS(12166),
    [anon_sym_LT_LT] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [sym__binary_star] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_PLUS] = ACTIONS(12164),
    [anon_sym_AMP] = ACTIONS(12164),
    [anon_sym_PERCENT] = ACTIONS(12164),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12164),
    [anon_sym_BANG_TILDE] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_while] = ACTIONS(12166),
    [sym__heredoc_body_start] = ACTIONS(12166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_LT_EQ] = ACTIONS(12164),
    [anon_sym_PIPE] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(12164),
    [anon_sym_LT] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_GT_GT] = ACTIONS(12164),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_GT] = ACTIONS(12164),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_EQ_EQ] = ACTIONS(12164),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12164),
    [anon_sym_GT_EQ] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_BANG_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12164),
    [anon_sym_LT_EQ_GT] = ACTIONS(12166),
    [sym__binary_minus] = ACTIONS(12166),
    [anon_sym_AMP_AMP] = ACTIONS(12164),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_CARET] = ACTIONS(12164),
  },
  [11978] = {
    [anon_sym_SLASH] = ACTIONS(12630),
    [anon_sym_RBRACK] = ACTIONS(12632),
    [anon_sym_until] = ACTIONS(12632),
    [anon_sym_AMP_EQ] = ACTIONS(12632),
    [anon_sym_GT_GT_EQ] = ACTIONS(12632),
    [anon_sym_SLASH_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12632),
    [anon_sym_RPAREN] = ACTIONS(12632),
    [anon_sym_EQ_TILDE] = ACTIONS(12632),
    [anon_sym_LT_LT] = ACTIONS(12630),
    [anon_sym_RBRACE] = ACTIONS(12632),
    [sym__binary_star] = ACTIONS(12632),
    [anon_sym_unless] = ACTIONS(12632),
    [anon_sym_PLUS] = ACTIONS(12630),
    [anon_sym_AMP] = ACTIONS(12630),
    [anon_sym_PERCENT] = ACTIONS(12630),
    [anon_sym_COLON_COLON2] = ACTIONS(12632),
    [anon_sym_rescue] = ACTIONS(12632),
    [anon_sym_PERCENT_EQ] = ACTIONS(12632),
    [anon_sym_LT_LT_EQ] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_DOT] = ACTIONS(12630),
    [anon_sym_BANG_TILDE] = ACTIONS(12632),
    [anon_sym_LBRACE] = ACTIONS(12632),
    [anon_sym_COLON2] = ACTIONS(12630),
    [anon_sym_while] = ACTIONS(12632),
    [sym__heredoc_body_start] = ACTIONS(12632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12632),
    [anon_sym_CARET_EQ] = ACTIONS(12632),
    [anon_sym_AMP_DOT] = ACTIONS(12632),
    [anon_sym_LT_EQ] = ACTIONS(12630),
    [anon_sym_PIPE] = ACTIONS(12630),
    [anon_sym_DOT_DOT] = ACTIONS(12630),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_LT] = ACTIONS(12630),
    [anon_sym_in] = ACTIONS(12632),
    [anon_sym_QMARK] = ACTIONS(12632),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_GT_GT] = ACTIONS(12630),
    [anon_sym_SEMI] = ACTIONS(12632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12632),
    [anon_sym_or] = ACTIONS(12632),
    [anon_sym_GT] = ACTIONS(12630),
    [anon_sym_PIPE_EQ] = ACTIONS(12632),
    [anon_sym_PLUS_EQ] = ACTIONS(12632),
    [anon_sym_STAR_EQ] = ACTIONS(12632),
    [anon_sym_EQ_EQ] = ACTIONS(12630),
    [anon_sym_and] = ACTIONS(12632),
    [anon_sym_PIPE_PIPE] = ACTIONS(12630),
    [anon_sym_GT_EQ] = ACTIONS(12632),
    [anon_sym_LBRACK] = ACTIONS(12632),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12632),
    [anon_sym_DASH_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12632),
    [anon_sym_BANG_EQ] = ACTIONS(12632),
    [anon_sym_STAR_STAR] = ACTIONS(12630),
    [anon_sym_LT_EQ_GT] = ACTIONS(12632),
    [sym__binary_minus] = ACTIONS(12632),
    [anon_sym_AMP_AMP] = ACTIONS(12630),
    [anon_sym_if] = ACTIONS(12632),
    [anon_sym_CARET] = ACTIONS(12630),
  },
  [11979] = {
    [anon_sym_SLASH] = ACTIONS(12795),
    [anon_sym_RBRACK] = ACTIONS(12797),
    [anon_sym_until] = ACTIONS(12797),
    [anon_sym_AMP_EQ] = ACTIONS(12797),
    [anon_sym_GT_GT_EQ] = ACTIONS(12797),
    [anon_sym_SLASH_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12797),
    [anon_sym_RPAREN] = ACTIONS(12797),
    [anon_sym_EQ_TILDE] = ACTIONS(12797),
    [anon_sym_LT_LT] = ACTIONS(12795),
    [anon_sym_RBRACE] = ACTIONS(12797),
    [sym__binary_star] = ACTIONS(12797),
    [anon_sym_unless] = ACTIONS(12797),
    [anon_sym_PLUS] = ACTIONS(12795),
    [anon_sym_AMP] = ACTIONS(12795),
    [anon_sym_PERCENT] = ACTIONS(12795),
    [anon_sym_COLON_COLON2] = ACTIONS(12797),
    [anon_sym_rescue] = ACTIONS(12797),
    [anon_sym_PERCENT_EQ] = ACTIONS(12797),
    [anon_sym_LT_LT_EQ] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_DOT] = ACTIONS(12795),
    [anon_sym_BANG_TILDE] = ACTIONS(12797),
    [anon_sym_LBRACE] = ACTIONS(12797),
    [anon_sym_COLON2] = ACTIONS(12795),
    [anon_sym_while] = ACTIONS(12797),
    [sym__heredoc_body_start] = ACTIONS(12797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(12797),
    [anon_sym_CARET_EQ] = ACTIONS(12797),
    [anon_sym_AMP_DOT] = ACTIONS(12797),
    [anon_sym_LT_EQ] = ACTIONS(12795),
    [anon_sym_PIPE] = ACTIONS(12795),
    [anon_sym_DOT_DOT] = ACTIONS(12795),
    [anon_sym_EQ] = ACTIONS(12795),
    [anon_sym_LT] = ACTIONS(12795),
    [anon_sym_in] = ACTIONS(12797),
    [anon_sym_QMARK] = ACTIONS(12797),
    [anon_sym_COMMA] = ACTIONS(12797),
    [anon_sym_GT_GT] = ACTIONS(12795),
    [anon_sym_SEMI] = ACTIONS(12797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12797),
    [anon_sym_or] = ACTIONS(12797),
    [anon_sym_GT] = ACTIONS(12795),
    [anon_sym_PIPE_EQ] = ACTIONS(12797),
    [anon_sym_PLUS_EQ] = ACTIONS(12797),
    [anon_sym_STAR_EQ] = ACTIONS(12797),
    [anon_sym_EQ_EQ] = ACTIONS(12795),
    [anon_sym_and] = ACTIONS(12797),
    [anon_sym_PIPE_PIPE] = ACTIONS(12795),
    [anon_sym_GT_EQ] = ACTIONS(12797),
    [anon_sym_LBRACK] = ACTIONS(12797),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12797),
    [anon_sym_DASH_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12797),
    [anon_sym_BANG_EQ] = ACTIONS(12797),
    [anon_sym_STAR_STAR] = ACTIONS(12795),
    [anon_sym_LT_EQ_GT] = ACTIONS(12797),
    [sym__binary_minus] = ACTIONS(12797),
    [anon_sym_AMP_AMP] = ACTIONS(12795),
    [anon_sym_if] = ACTIONS(12797),
    [anon_sym_CARET] = ACTIONS(12795),
  },
  [11980] = {
    [anon_sym_end] = ACTIONS(17418),
    [sym_comment] = ACTIONS(49),
  },
  [11981] = {
    [sym__method_name] = STATE(7816),
    [sym_setter] = STATE(7816),
    [sym_symbol] = STATE(7816),
    [sym_operator] = STATE(7816),
    [sym__method_rest] = STATE(12296),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [sym_class_variable] = ACTIONS(16092),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(481),
    [anon_sym_PLUS_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_EQ_TILDE] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(16092),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(489),
    [anon_sym_DASH_AT] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_BANG_TILDE] = ACTIONS(481),
    [sym_constant] = ACTIONS(16092),
    [anon_sym_DASH] = ACTIONS(479),
    [sym_instance_variable] = ACTIONS(16092),
    [anon_sym_GT_EQ] = ACTIONS(481),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(479),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_LT_EQ_GT] = ACTIONS(481),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(479),
    [sym_identifier] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(481),
    [sym__symbol_start] = ACTIONS(493),
  },
  [11982] = {
    [anon_sym_SLASH] = ACTIONS(13952),
    [anon_sym_RBRACK] = ACTIONS(13954),
    [anon_sym_until] = ACTIONS(13954),
    [anon_sym_AMP_EQ] = ACTIONS(13954),
    [anon_sym_GT_GT_EQ] = ACTIONS(13954),
    [anon_sym_SLASH_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13954),
    [anon_sym_RPAREN] = ACTIONS(13954),
    [anon_sym_EQ_TILDE] = ACTIONS(13954),
    [anon_sym_LT_LT] = ACTIONS(13952),
    [anon_sym_RBRACE] = ACTIONS(13954),
    [sym__binary_star] = ACTIONS(13954),
    [anon_sym_unless] = ACTIONS(13954),
    [anon_sym_PLUS] = ACTIONS(13952),
    [anon_sym_AMP] = ACTIONS(13952),
    [anon_sym_PERCENT] = ACTIONS(13952),
    [anon_sym_COLON_COLON2] = ACTIONS(13954),
    [anon_sym_rescue] = ACTIONS(13954),
    [anon_sym_PERCENT_EQ] = ACTIONS(13954),
    [anon_sym_LT_LT_EQ] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_DOT] = ACTIONS(13952),
    [anon_sym_BANG_TILDE] = ACTIONS(13954),
    [anon_sym_LBRACE] = ACTIONS(13954),
    [anon_sym_COLON2] = ACTIONS(13952),
    [anon_sym_while] = ACTIONS(13954),
    [sym__heredoc_body_start] = ACTIONS(13954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13954),
    [anon_sym_CARET_EQ] = ACTIONS(13954),
    [anon_sym_AMP_DOT] = ACTIONS(13954),
    [anon_sym_LT_EQ] = ACTIONS(13952),
    [anon_sym_PIPE] = ACTIONS(13952),
    [anon_sym_DOT_DOT] = ACTIONS(13952),
    [anon_sym_EQ] = ACTIONS(13952),
    [anon_sym_LT] = ACTIONS(13952),
    [anon_sym_in] = ACTIONS(13954),
    [anon_sym_QMARK] = ACTIONS(13954),
    [anon_sym_COMMA] = ACTIONS(13954),
    [anon_sym_GT_GT] = ACTIONS(13952),
    [anon_sym_SEMI] = ACTIONS(13954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13954),
    [anon_sym_or] = ACTIONS(13954),
    [anon_sym_GT] = ACTIONS(13952),
    [anon_sym_PIPE_EQ] = ACTIONS(13954),
    [anon_sym_PLUS_EQ] = ACTIONS(13954),
    [anon_sym_STAR_EQ] = ACTIONS(13954),
    [anon_sym_EQ_EQ] = ACTIONS(13952),
    [anon_sym_and] = ACTIONS(13954),
    [anon_sym_PIPE_PIPE] = ACTIONS(13952),
    [anon_sym_GT_EQ] = ACTIONS(13954),
    [anon_sym_LBRACK] = ACTIONS(13954),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13954),
    [anon_sym_DASH_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13954),
    [anon_sym_BANG_EQ] = ACTIONS(13954),
    [anon_sym_STAR_STAR] = ACTIONS(13952),
    [anon_sym_LT_EQ_GT] = ACTIONS(13954),
    [sym__binary_minus] = ACTIONS(13954),
    [anon_sym_AMP_AMP] = ACTIONS(13952),
    [anon_sym_if] = ACTIONS(13954),
    [anon_sym_CARET] = ACTIONS(13952),
  },
  [11983] = {
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11984] = {
    [aux_sym_exceptions_repeat1] = STATE(11984),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17420),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11985] = {
    [anon_sym_SLASH] = ACTIONS(12119),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12121),
    [anon_sym_EQ_TILDE] = ACTIONS(12121),
    [anon_sym_LT_LT] = ACTIONS(12123),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(12125),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(12127),
    [anon_sym_AMP] = ACTIONS(12129),
    [anon_sym_PERCENT] = ACTIONS(12119),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(12121),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(12131),
    [anon_sym_PIPE] = ACTIONS(12133),
    [anon_sym_DOT_DOT] = ACTIONS(12135),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(12131),
    [anon_sym_QMARK] = ACTIONS(12137),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12139),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(12131),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(12141),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12141),
    [anon_sym_GT_EQ] = ACTIONS(12143),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12121),
    [anon_sym_STAR_STAR] = ACTIONS(12119),
    [anon_sym_LT_EQ_GT] = ACTIONS(12121),
    [sym__binary_minus] = ACTIONS(12145),
    [anon_sym_AMP_AMP] = ACTIONS(12141),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(12133),
  },
  [11986] = {
    [aux_sym_exceptions_repeat1] = STATE(11986),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17423),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11987] = {
    [anon_sym_LT] = ACTIONS(12206),
    [anon_sym_SLASH] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_LT_LT] = ACTIONS(12212),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12214),
    [sym__binary_star] = ACTIONS(12208),
    [anon_sym_PLUS] = ACTIONS(12218),
    [anon_sym_AMP] = ACTIONS(12220),
    [anon_sym_GT] = ACTIONS(12206),
    [anon_sym_PERCENT] = ACTIONS(12208),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(12214),
    [anon_sym_PIPE_PIPE] = ACTIONS(12214),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12224),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12214),
    [anon_sym_STAR_STAR] = ACTIONS(12208),
    [anon_sym_PIPE] = ACTIONS(12226),
    [anon_sym_DOT_DOT] = ACTIONS(12228),
    [anon_sym_AMP_AMP] = ACTIONS(12214),
    [anon_sym_LT_EQ_GT] = ACTIONS(12214),
    [anon_sym_LT_EQ] = ACTIONS(12206),
    [sym__binary_minus] = ACTIONS(12218),
    [anon_sym_CARET] = ACTIONS(12230),
  },
  [11988] = {
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_SLASH] = ACTIONS(16494),
    [anon_sym_RBRACK] = ACTIONS(16494),
    [anon_sym_in] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16494),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16494),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_COLON2] = ACTIONS(16492),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16494),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_AMP_AMP] = ACTIONS(16494),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16494),
    [anon_sym_EQ] = ACTIONS(16492),
  },
  [11989] = {
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_SLASH] = ACTIONS(16424),
    [anon_sym_RBRACK] = ACTIONS(16424),
    [anon_sym_in] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16424),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16424),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_AMP_AMP] = ACTIONS(16424),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16424),
    [anon_sym_EQ] = ACTIONS(16422),
  },
  [11990] = {
    [anon_sym_SLASH] = ACTIONS(16422),
    [anon_sym_RBRACK] = ACTIONS(16424),
    [anon_sym_until] = ACTIONS(16424),
    [anon_sym_AMP_EQ] = ACTIONS(16424),
    [anon_sym_GT_GT_EQ] = ACTIONS(16424),
    [anon_sym_SLASH_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16424),
    [anon_sym_RPAREN] = ACTIONS(16424),
    [anon_sym_EQ_TILDE] = ACTIONS(16424),
    [anon_sym_LT_LT] = ACTIONS(16422),
    [sym__binary_star] = ACTIONS(16424),
    [anon_sym_RBRACE] = ACTIONS(16424),
    [anon_sym_unless] = ACTIONS(16424),
    [anon_sym_PLUS] = ACTIONS(16422),
    [anon_sym_AMP] = ACTIONS(16422),
    [anon_sym_PERCENT] = ACTIONS(16422),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [anon_sym_rescue] = ACTIONS(16424),
    [anon_sym_PERCENT_EQ] = ACTIONS(16424),
    [anon_sym_LT_LT_EQ] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16422),
    [anon_sym_BANG_TILDE] = ACTIONS(16424),
    [anon_sym_LBRACE] = ACTIONS(16424),
    [anon_sym_COLON2] = ACTIONS(16422),
    [anon_sym_while] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16424),
    [anon_sym_CARET_EQ] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_LT_EQ] = ACTIONS(16422),
    [anon_sym_PIPE] = ACTIONS(16422),
    [anon_sym_DOT_DOT] = ACTIONS(16422),
    [anon_sym_EQ] = ACTIONS(16422),
    [anon_sym_LT] = ACTIONS(16422),
    [anon_sym_in] = ACTIONS(16424),
    [anon_sym_QMARK] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_GT_GT] = ACTIONS(16422),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16424),
    [anon_sym_or] = ACTIONS(16424),
    [anon_sym_GT] = ACTIONS(16422),
    [anon_sym_PIPE_EQ] = ACTIONS(16424),
    [anon_sym_PLUS_EQ] = ACTIONS(16424),
    [anon_sym_STAR_EQ] = ACTIONS(16424),
    [anon_sym_EQ_EQ] = ACTIONS(16422),
    [anon_sym_and] = ACTIONS(16424),
    [anon_sym_PIPE_PIPE] = ACTIONS(16422),
    [anon_sym_GT_EQ] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16424),
    [anon_sym_DASH_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16424),
    [anon_sym_BANG_EQ] = ACTIONS(16424),
    [anon_sym_STAR_STAR] = ACTIONS(16422),
    [anon_sym_LT_EQ_GT] = ACTIONS(16424),
    [anon_sym_AMP_AMP] = ACTIONS(16422),
    [sym__binary_minus] = ACTIONS(16424),
    [anon_sym_if] = ACTIONS(16424),
    [anon_sym_CARET] = ACTIONS(16422),
  },
  [11991] = {
    [aux_sym_exceptions_repeat1] = STATE(11991),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_RBRACK] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17426),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11992] = {
    [anon_sym_LT] = ACTIONS(12320),
    [anon_sym_SLASH] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12330),
    [anon_sym_LT_LT] = ACTIONS(12326),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12328),
    [sym__binary_star] = ACTIONS(12332),
    [anon_sym_PLUS] = ACTIONS(12334),
    [anon_sym_AMP] = ACTIONS(12336),
    [anon_sym_GT] = ACTIONS(12320),
    [anon_sym_PERCENT] = ACTIONS(12322),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12338),
    [anon_sym_BANG_TILDE] = ACTIONS(12328),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12340),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12328),
    [anon_sym_STAR_STAR] = ACTIONS(12322),
    [anon_sym_PIPE] = ACTIONS(12342),
    [anon_sym_DOT_DOT] = ACTIONS(12344),
    [anon_sym_AMP_AMP] = ACTIONS(12338),
    [anon_sym_LT_EQ_GT] = ACTIONS(12328),
    [anon_sym_LT_EQ] = ACTIONS(12320),
    [sym__binary_minus] = ACTIONS(12346),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(12342),
  },
  [11993] = {
    [anon_sym_SLASH] = ACTIONS(16492),
    [anon_sym_RBRACK] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_AMP_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT_EQ] = ACTIONS(16494),
    [anon_sym_SLASH_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16492),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16492),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16492),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_PERCENT_EQ] = ACTIONS(16494),
    [anon_sym_LT_LT_EQ] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_COLON2] = ACTIONS(16492),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_CARET_EQ] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_EQ] = ACTIONS(16492),
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_in] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16492),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_EQ_GT] = ACTIONS(16494),
    [anon_sym_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_PLUS_EQ] = ACTIONS(16494),
    [anon_sym_STAR_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16492),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16494),
    [anon_sym_DASH_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16492),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_AMP_AMP] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16492),
  },
  [11994] = {
    [aux_sym_exceptions_repeat1] = STATE(11994),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17429),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [11995] = {
    [anon_sym_LT] = ACTIONS(12513),
    [anon_sym_SLASH] = ACTIONS(12515),
    [anon_sym_QMARK] = ACTIONS(12517),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12523),
    [anon_sym_LT_LT] = ACTIONS(12519),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12521),
    [anon_sym_PLUS] = ACTIONS(12525),
    [anon_sym_AMP] = ACTIONS(12527),
    [anon_sym_GT] = ACTIONS(12513),
    [anon_sym_PERCENT] = ACTIONS(12515),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(12515),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(12529),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(12521),
    [anon_sym_PIPE_PIPE] = ACTIONS(12521),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12531),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12521),
    [anon_sym_STAR_STAR] = ACTIONS(12515),
    [anon_sym_PIPE] = ACTIONS(12533),
    [anon_sym_DOT_DOT] = ACTIONS(12535),
    [anon_sym_AMP_AMP] = ACTIONS(12521),
    [anon_sym_LT_EQ_GT] = ACTIONS(12521),
    [anon_sym_LT_EQ] = ACTIONS(12513),
    [sym__binary_minus] = ACTIONS(12525),
    [anon_sym_CARET] = ACTIONS(12537),
  },
  [11996] = {
    [aux_sym_exceptions_repeat1] = STATE(11996),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17432),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_RBRACE] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [11997] = {
    [anon_sym_LT] = ACTIONS(12571),
    [anon_sym_SLASH] = ACTIONS(12573),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12575),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12581),
    [anon_sym_LT_LT] = ACTIONS(12577),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12579),
    [anon_sym_PLUS] = ACTIONS(12583),
    [anon_sym_AMP] = ACTIONS(12585),
    [anon_sym_GT] = ACTIONS(12571),
    [anon_sym_PERCENT] = ACTIONS(12573),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(12587),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(12589),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12589),
    [anon_sym_BANG_TILDE] = ACTIONS(12579),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12591),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12579),
    [anon_sym_STAR_STAR] = ACTIONS(12573),
    [anon_sym_PIPE] = ACTIONS(12593),
    [anon_sym_DOT_DOT] = ACTIONS(12595),
    [anon_sym_AMP_AMP] = ACTIONS(12589),
    [anon_sym_LT_EQ_GT] = ACTIONS(12579),
    [anon_sym_LT_EQ] = ACTIONS(12571),
    [sym__binary_minus] = ACTIONS(12597),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(12593),
  },
  [11998] = {
    [sym_assignment] = STATE(11405),
    [sym_unary] = STATE(11405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(11405),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(11405),
    [sym_conditional] = STATE(11405),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_return] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_true] = STATE(8222),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(11405),
    [sym_binary] = STATE(11405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(8930),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [sym_global_variable] = ACTIONS(6023),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(6017),
    [sym_character] = ACTIONS(12666),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [11999] = {
    [aux_sym_exceptions_repeat1] = STATE(12297),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17435),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12000] = {
    [sym_assignment] = STATE(12298),
    [sym_unary] = STATE(12298),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8222),
    [sym_singleton_class] = STATE(8224),
    [sym_module] = STATE(8224),
    [sym_chained_string] = STATE(8224),
    [sym_until] = STATE(8224),
    [sym_regex] = STATE(8224),
    [sym_for] = STATE(8224),
    [sym_symbol] = STATE(8224),
    [sym_if] = STATE(8224),
    [sym_begin] = STATE(8224),
    [sym__arg] = STATE(12298),
    [sym__primary] = STATE(8224),
    [sym_method_call] = STATE(8222),
    [sym_operator_assignment] = STATE(12298),
    [sym_conditional] = STATE(12298),
    [sym_method] = STATE(8224),
    [sym_singleton_method] = STATE(8224),
    [sym__variable] = STATE(3605),
    [sym_left_assignment_list] = STATE(8225),
    [sym_rational] = STATE(8224),
    [sym_true] = STATE(8222),
    [sym_return] = STATE(8224),
    [sym_subshell] = STATE(8224),
    [sym_yield] = STATE(8224),
    [sym_string] = STATE(8226),
    [sym_unless] = STATE(8224),
    [sym_lambda] = STATE(8224),
    [sym_parenthesized_statements] = STATE(8224),
    [sym_element_reference] = STATE(8222),
    [sym_range] = STATE(12298),
    [sym_binary] = STATE(12298),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8224),
    [sym_break] = STATE(8224),
    [sym_next] = STATE(8224),
    [sym_string_array] = STATE(8224),
    [sym_while] = STATE(8224),
    [sym_case] = STATE(8224),
    [sym_symbol_array] = STATE(8224),
    [sym_array] = STATE(8224),
    [sym_hash] = STATE(8224),
    [sym_false] = STATE(8222),
    [sym_nil] = STATE(8222),
    [sym_scope_resolution] = STATE(3605),
    [sym_call] = STATE(3605),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12656),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12658),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12660),
    [anon_sym_not] = ACTIONS(12662),
    [sym_self] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12664),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12666),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12666),
    [anon_sym_PLUS] = ACTIONS(12668),
    [anon_sym_TILDE] = ACTIONS(12660),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(6023),
    [sym_character] = ACTIONS(12666),
    [sym_super] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12670),
    [anon_sym_next] = ACTIONS(12672),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12656),
    [sym_constant] = ACTIONS(6017),
    [anon_sym_defined_QMARK] = ACTIONS(12674),
    [sym_instance_variable] = ACTIONS(6023),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4804),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(6017),
    [sym_redo] = ACTIONS(12656),
    [sym_class_variable] = ACTIONS(6023),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12676),
  },
  [12001] = {
    [sym_assignment] = STATE(11424),
    [sym_unary] = STATE(11424),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(11424),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(11424),
    [sym_conditional] = STATE(11424),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_return] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_true] = STATE(8302),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(11424),
    [sym_binary] = STATE(11424),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(9079),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [sym_global_variable] = ACTIONS(4936),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(4928),
    [sym_character] = ACTIONS(12768),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [12002] = {
    [aux_sym_exceptions_repeat1] = STATE(12299),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_in] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17437),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12003] = {
    [sym_assignment] = STATE(12300),
    [sym_unary] = STATE(12300),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8302),
    [sym_singleton_class] = STATE(8304),
    [sym_module] = STATE(8304),
    [sym_chained_string] = STATE(8304),
    [sym_until] = STATE(8304),
    [sym_regex] = STATE(8304),
    [sym_for] = STATE(8304),
    [sym_symbol] = STATE(8304),
    [sym_if] = STATE(8304),
    [sym_begin] = STATE(8304),
    [sym__arg] = STATE(12300),
    [sym__primary] = STATE(8304),
    [sym_method_call] = STATE(8302),
    [sym_operator_assignment] = STATE(12300),
    [sym_conditional] = STATE(12300),
    [sym_method] = STATE(8304),
    [sym_singleton_method] = STATE(8304),
    [sym__variable] = STATE(2927),
    [sym_left_assignment_list] = STATE(8305),
    [sym_rational] = STATE(8304),
    [sym_true] = STATE(8302),
    [sym_return] = STATE(8304),
    [sym_subshell] = STATE(8304),
    [sym_yield] = STATE(8304),
    [sym_string] = STATE(8306),
    [sym_unless] = STATE(8304),
    [sym_lambda] = STATE(8304),
    [sym_parenthesized_statements] = STATE(8304),
    [sym_element_reference] = STATE(8302),
    [sym_range] = STATE(12300),
    [sym_binary] = STATE(12300),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8304),
    [sym_break] = STATE(8304),
    [sym_next] = STATE(8304),
    [sym_string_array] = STATE(8304),
    [sym_while] = STATE(8304),
    [sym_case] = STATE(8304),
    [sym_symbol_array] = STATE(8304),
    [sym_array] = STATE(8304),
    [sym_hash] = STATE(8304),
    [sym_false] = STATE(8302),
    [sym_nil] = STATE(8302),
    [sym_scope_resolution] = STATE(2927),
    [sym_call] = STATE(2927),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(12758),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(12760),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(12762),
    [anon_sym_not] = ACTIONS(12764),
    [sym_self] = ACTIONS(4928),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(12766),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(12768),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(12768),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_TILDE] = ACTIONS(12762),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(4936),
    [sym_character] = ACTIONS(12768),
    [sym_super] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(12772),
    [anon_sym_next] = ACTIONS(12774),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(12758),
    [sym_constant] = ACTIONS(4928),
    [anon_sym_defined_QMARK] = ACTIONS(12776),
    [sym_instance_variable] = ACTIONS(4936),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(4944),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(4928),
    [sym_redo] = ACTIONS(12758),
    [sym_class_variable] = ACTIONS(4936),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(12778),
  },
  [12004] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12005] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12006] = {
    [sym_assignment] = STATE(12301),
    [sym_unary] = STATE(12301),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12301),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12301),
    [sym_conditional] = STATE(12301),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12301),
    [sym_binary] = STATE(12301),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12007] = {
    [sym_assignment] = STATE(12302),
    [sym_unary] = STATE(12302),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12302),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12302),
    [sym_conditional] = STATE(12302),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12302),
    [sym_binary] = STATE(12302),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12008] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12009] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12010] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12011] = {
    [sym__argument] = STATE(4976),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(4976),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(4976),
    [sym_hash_splat_argument] = STATE(4976),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_heredoc_body] = STATE(12303),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_block_argument] = STATE(4976),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym_float] = ACTIONS(15031),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(15055),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17439),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12012] = {
    [sym_heredoc_body] = STATE(12304),
    [aux_sym_call_repeat1] = STATE(12304),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [12013] = {
    [sym_heredoc_body] = STATE(12305),
    [aux_sym_call_repeat1] = STATE(12305),
    [aux_sym_argument_list_repeat1] = STATE(12306),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(17003),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
  },
  [12014] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
  },
  [12015] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12016] = {
    [anon_sym_SLASH] = ACTIONS(2053),
    [sym_float] = ACTIONS(2053),
    [sym__string_array_start] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(2055),
    [anon_sym_until] = ACTIONS(2053),
    [anon_sym_AMP_EQ] = ACTIONS(2055),
    [anon_sym_GT_GT_EQ] = ACTIONS(2055),
    [sym_self] = ACTIONS(2053),
    [anon_sym_SLASH_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2055),
    [anon_sym_EQ_TILDE] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2053),
    [sym__binary_star] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_unless] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [sym_complex] = ACTIONS(2055),
    [anon_sym_COLON_COLON2] = ACTIONS(2055),
    [sym_super] = ACTIONS(2053),
    [sym__simple_symbol] = ACTIONS(2055),
    [sym__symbol_array_start] = ACTIONS(2055),
    [anon_sym_PERCENT_EQ] = ACTIONS(2055),
    [anon_sym_LBRACK2] = ACTIONS(2053),
    [anon_sym_LT_LT_EQ] = ACTIONS(2055),
    [anon_sym_nil] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2055),
    [sym_character] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [sym_heredoc_beginning] = ACTIONS(2055),
    [sym_constant] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [sym_instance_variable] = ACTIONS(2055),
    [sym__heredoc_body_start] = ACTIONS(2055),
    [anon_sym_defined_QMARK] = ACTIONS(2055),
    [sym__string_start] = ACTIONS(2055),
    [anon_sym_true] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_DASH_GT] = ACTIONS(2055),
    [anon_sym_CARET_EQ] = ACTIONS(2055),
    [anon_sym_NIL] = ACTIONS(2053),
    [anon_sym_AMP_DOT] = ACTIONS(2055),
    [anon_sym_COLON_COLON] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2053),
    [anon_sym_DOT_DOT] = ACTIONS(2053),
    [anon_sym_def] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [sym_class_variable] = ACTIONS(2055),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_not] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [sym__symbol_start] = ACTIONS(2055),
    [anon_sym_TRUE] = ACTIONS(2053),
    [sym__block_ampersand] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [sym_global_variable] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_GT] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_begin] = ACTIONS(2053),
    [anon_sym_false] = ACTIONS(2053),
    [sym__subshell_start] = ACTIONS(2055),
    [sym__splat_star] = ACTIONS(2055),
    [anon_sym_PIPE_EQ] = ACTIONS(2055),
    [anon_sym_PLUS_EQ] = ACTIONS(2055),
    [anon_sym_STAR_EQ] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_next] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym_retry] = ACTIONS(2053),
    [anon_sym_GT_EQ] = ACTIONS(2055),
    [sym__regex_start] = ACTIONS(2055),
    [sym_integer] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2055),
    [anon_sym_DASH_EQ] = ACTIONS(2055),
    [anon_sym_FALSE] = ACTIONS(2053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2055),
    [anon_sym_BANG_EQ] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2055),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [sym_redo] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
  },
  [12017] = {
    [sym_assignment] = STATE(12307),
    [sym_unary] = STATE(12307),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12307),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12307),
    [sym_conditional] = STATE(12307),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12307),
    [sym_binary] = STATE(12307),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12018] = {
    [sym_assignment] = STATE(12308),
    [sym_unary] = STATE(12308),
    [sym_right_assignment_list] = STATE(5062),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12308),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_splat_argument] = STATE(12309),
    [sym_operator_assignment] = STATE(12308),
    [sym_conditional] = STATE(12308),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_return] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_subshell] = STATE(11464),
    [sym__arg_or_splat_arg] = STATE(12309),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12308),
    [sym_binary] = STATE(12308),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [sym_global_variable] = ACTIONS(16246),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(16238),
    [sym_character] = ACTIONS(16242),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12019] = {
    [sym_assignment] = STATE(12310),
    [sym_unary] = STATE(12310),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12310),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12310),
    [sym_conditional] = STATE(12310),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12310),
    [sym_binary] = STATE(12310),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12020] = {
    [sym_assignment] = STATE(12311),
    [sym_unary] = STATE(12311),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12311),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12311),
    [sym_conditional] = STATE(12311),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12311),
    [sym_binary] = STATE(12311),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12021] = {
    [sym_assignment] = STATE(12313),
    [sym_unary] = STATE(12313),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12313),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12313),
    [sym_conditional] = STATE(12313),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12313),
    [sym_binary] = STATE(12313),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12022] = {
    [sym_assignment] = STATE(12314),
    [sym_unary] = STATE(12314),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12314),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12314),
    [sym_conditional] = STATE(12314),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12314),
    [sym_binary] = STATE(12314),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [12023] = {
    [sym_assignment] = STATE(12315),
    [sym_unary] = STATE(12315),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12315),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12315),
    [sym_conditional] = STATE(12315),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12315),
    [sym_binary] = STATE(12315),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12024] = {
    [sym_assignment] = STATE(12316),
    [sym_unary] = STATE(12316),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12316),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12316),
    [sym_conditional] = STATE(12316),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12316),
    [sym_binary] = STATE(12316),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12025] = {
    [sym_assignment] = STATE(12317),
    [sym_unary] = STATE(12317),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12317),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12317),
    [sym_conditional] = STATE(12317),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12317),
    [sym_binary] = STATE(12317),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12026] = {
    [sym_assignment] = STATE(12318),
    [sym_unary] = STATE(12318),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12318),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12318),
    [sym_conditional] = STATE(12318),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12318),
    [sym_binary] = STATE(12318),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12027] = {
    [sym_assignment] = STATE(12319),
    [sym_unary] = STATE(12319),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12319),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12319),
    [sym_conditional] = STATE(12319),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12319),
    [sym_binary] = STATE(12319),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12028] = {
    [sym_heredoc_body] = STATE(12324),
    [sym__argument_list_with_parens] = STATE(12323),
    [aux_sym_call_repeat1] = STATE(12324),
    [sym_argument_list_with_parens] = STATE(12322),
    [sym_operator] = STATE(12322),
    [anon_sym_LT] = ACTIONS(17441),
    [anon_sym_SLASH] = ACTIONS(17443),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17443),
    [anon_sym_PLUS_AT] = ACTIONS(17443),
    [anon_sym_LPAREN2] = ACTIONS(17445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17443),
    [anon_sym_GT_GT] = ACTIONS(17443),
    [anon_sym_EQ_TILDE] = ACTIONS(17443),
    [anon_sym_LT_LT] = ACTIONS(17443),
    [anon_sym_TILDE] = ACTIONS(17443),
    [anon_sym_PLUS] = ACTIONS(17441),
    [anon_sym_AMP] = ACTIONS(17443),
    [anon_sym_GT] = ACTIONS(17441),
    [anon_sym_PERCENT] = ACTIONS(17443),
    [anon_sym_DASH_AT] = ACTIONS(17443),
    [anon_sym_EQ_EQ] = ACTIONS(17441),
    [anon_sym_STAR] = ACTIONS(17441),
    [anon_sym_BANG_TILDE] = ACTIONS(17443),
    [sym_constant] = ACTIONS(17447),
    [anon_sym_DASH] = ACTIONS(17441),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17443),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17441),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17443),
    [anon_sym_STAR_STAR] = ACTIONS(17443),
    [anon_sym_PIPE] = ACTIONS(17443),
    [anon_sym_DOT_DOT] = ACTIONS(17443),
    [anon_sym_LT_EQ_GT] = ACTIONS(17443),
    [anon_sym_LT_EQ] = ACTIONS(17441),
    [anon_sym_BANG] = ACTIONS(17441),
    [sym_identifier] = ACTIONS(17447),
    [anon_sym_CARET] = ACTIONS(17443),
  },
  [12029] = {
    [sym_comment] = ACTIONS(49),
    [sym_constant] = ACTIONS(17449),
    [sym_identifier] = ACTIONS(17449),
  },
  [12030] = {
    [aux_sym_chained_string_repeat1] = STATE(12326),
    [sym_string] = STATE(12326),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
  },
  [12031] = {
    [sym__argument] = STATE(9977),
    [sym_assignment] = STATE(10345),
    [sym_unary] = STATE(10345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(10345),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(9977),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(9977),
    [sym_hash_splat_argument] = STATE(9977),
    [sym_operator_assignment] = STATE(10345),
    [sym_conditional] = STATE(10345),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(10349),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_block_argument] = STATE(9977),
    [sym_range] = STATE(10345),
    [sym_binary] = STATE(10345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym_float] = ACTIONS(15031),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(15041),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(15049),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15041),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(15053),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(15055),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17047),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12032] = {
    [sym_heredoc_body] = STATE(12032),
    [aux_sym_call_repeat1] = STATE(12032),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14639),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [12033] = {
    [sym_heredoc_body] = STATE(12032),
    [aux_sym_call_repeat1] = STATE(12032),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(7974),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [12034] = {
    [aux_sym_argument_list_repeat1] = STATE(12034),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17451),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [12035] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12036] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12037] = {
    [aux_sym_exceptions_repeat1] = STATE(12328),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [12038] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12039] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12040] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17454),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12041] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12042] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12043] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12044] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12045] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12046] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12047] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12048] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [12049] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(12331),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(17456),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [12050] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [12051] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [12052] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(12051),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(12332),
    [sym_operator] = STATE(12332),
    [anon_sym_LT] = ACTIONS(17049),
    [anon_sym_SLASH] = ACTIONS(17051),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17051),
    [anon_sym_PLUS_AT] = ACTIONS(17051),
    [anon_sym_LPAREN2] = ACTIONS(17053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17051),
    [anon_sym_GT_GT] = ACTIONS(17051),
    [anon_sym_EQ_TILDE] = ACTIONS(17051),
    [anon_sym_LT_LT] = ACTIONS(17051),
    [anon_sym_TILDE] = ACTIONS(17051),
    [anon_sym_PLUS] = ACTIONS(17049),
    [anon_sym_AMP] = ACTIONS(17051),
    [anon_sym_GT] = ACTIONS(17049),
    [anon_sym_PERCENT] = ACTIONS(17051),
    [anon_sym_DASH_AT] = ACTIONS(17051),
    [anon_sym_EQ_EQ] = ACTIONS(17049),
    [anon_sym_STAR] = ACTIONS(17049),
    [anon_sym_BANG_TILDE] = ACTIONS(17051),
    [sym_constant] = ACTIONS(17458),
    [anon_sym_DASH] = ACTIONS(17049),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17051),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17051),
    [anon_sym_STAR_STAR] = ACTIONS(17051),
    [anon_sym_PIPE] = ACTIONS(17051),
    [anon_sym_DOT_DOT] = ACTIONS(17051),
    [anon_sym_LT_EQ_GT] = ACTIONS(17051),
    [anon_sym_LT_EQ] = ACTIONS(17049),
    [anon_sym_BANG] = ACTIONS(17049),
    [sym_identifier] = ACTIONS(17458),
    [anon_sym_CARET] = ACTIONS(17051),
  },
  [12053] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [12054] = {
    [sym_assignment] = STATE(12333),
    [sym_unary] = STATE(12333),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12333),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12333),
    [sym_conditional] = STATE(12333),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12333),
    [sym_binary] = STATE(12333),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12055] = {
    [sym_assignment] = STATE(12334),
    [sym_unary] = STATE(12334),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12334),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12334),
    [sym_conditional] = STATE(12334),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12334),
    [sym_binary] = STATE(12334),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12056] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12057] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12058] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12059] = {
    [sym__argument] = STATE(5207),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(5207),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(5207),
    [sym_hash_splat_argument] = STATE(5207),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_heredoc_body] = STATE(12335),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_block_argument] = STATE(5207),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym_float] = ACTIONS(15107),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(15111),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(15119),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [sym_class_variable] = ACTIONS(15119),
    [sym__block_ampersand] = ACTIONS(16300),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(15129),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17460),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12060] = {
    [sym_heredoc_body] = STATE(12336),
    [aux_sym_call_repeat1] = STATE(12336),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [12061] = {
    [sym_heredoc_body] = STATE(12337),
    [aux_sym_call_repeat1] = STATE(12337),
    [aux_sym_argument_list_repeat1] = STATE(12338),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5590),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(17063),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [12062] = {
    [aux_sym_chained_string_repeat1] = STATE(12062),
    [sym_string] = STATE(12062),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(8550),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [12063] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [12064] = {
    [sym_assignment] = STATE(11498),
    [sym_unary] = STATE(11498),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(11498),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_splat_argument] = STATE(10015),
    [sym_operator_assignment] = STATE(11498),
    [sym_conditional] = STATE(11498),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_return] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_true] = STATE(8349),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym__arg_or_splat_arg] = STATE(10015),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(11498),
    [sym_binary] = STATE(11498),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [sym__splat_star] = ACTIONS(16310),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [anon_sym_class] = ACTIONS(1295),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [sym_global_variable] = ACTIONS(12811),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_super] = ACTIONS(12803),
    [sym_character] = ACTIONS(12805),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [12065] = {
    [aux_sym_exceptions_repeat1] = STATE(12339),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17462),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [12066] = {
    [sym_assignment] = STATE(12340),
    [sym_unary] = STATE(12340),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8349),
    [sym_singleton_class] = STATE(8351),
    [sym_module] = STATE(8351),
    [sym_chained_string] = STATE(8351),
    [sym_until] = STATE(8351),
    [sym_regex] = STATE(8351),
    [sym_for] = STATE(8351),
    [sym_symbol] = STATE(8351),
    [sym_if] = STATE(8351),
    [sym_begin] = STATE(8351),
    [sym__arg] = STATE(12340),
    [sym__primary] = STATE(8351),
    [sym_method_call] = STATE(8349),
    [sym_operator_assignment] = STATE(12340),
    [sym_conditional] = STATE(12340),
    [sym_method] = STATE(8351),
    [sym_singleton_method] = STATE(8351),
    [sym__variable] = STATE(8352),
    [sym_left_assignment_list] = STATE(8353),
    [sym_rational] = STATE(8351),
    [sym_true] = STATE(8349),
    [sym_return] = STATE(8351),
    [sym_subshell] = STATE(8351),
    [sym_yield] = STATE(8351),
    [sym_string] = STATE(8354),
    [sym_unless] = STATE(8351),
    [sym_lambda] = STATE(8351),
    [sym_parenthesized_statements] = STATE(8351),
    [sym_element_reference] = STATE(8349),
    [sym_range] = STATE(12340),
    [sym_binary] = STATE(12340),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8351),
    [sym_break] = STATE(8351),
    [sym_next] = STATE(8351),
    [sym_string_array] = STATE(8351),
    [sym_while] = STATE(8351),
    [sym_case] = STATE(8351),
    [sym_symbol_array] = STATE(8351),
    [sym_array] = STATE(8351),
    [sym_hash] = STATE(8351),
    [sym_false] = STATE(8349),
    [sym_nil] = STATE(8349),
    [sym_scope_resolution] = STATE(8352),
    [sym_call] = STATE(8352),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(12801),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(12817),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(12809),
    [anon_sym_not] = ACTIONS(12819),
    [sym_self] = ACTIONS(12803),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(12821),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(12805),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(12805),
    [anon_sym_PLUS] = ACTIONS(12807),
    [anon_sym_TILDE] = ACTIONS(12809),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(12811),
    [sym_character] = ACTIONS(12805),
    [sym_super] = ACTIONS(12803),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(12823),
    [anon_sym_next] = ACTIONS(12825),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(12801),
    [sym_constant] = ACTIONS(12803),
    [anon_sym_defined_QMARK] = ACTIONS(12813),
    [sym_instance_variable] = ACTIONS(12811),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(12815),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(12803),
    [sym_redo] = ACTIONS(12801),
    [sym_class_variable] = ACTIONS(12811),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(12827),
  },
  [12067] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [12068] = {
    [anon_sym_RPAREN] = ACTIONS(17464),
    [sym_comment] = ACTIONS(49),
  },
  [12069] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [12070] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12071] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12072] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [12073] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12074] = {
    [sym_assignment] = STATE(12342),
    [sym_unary] = STATE(12342),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12342),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12342),
    [sym_conditional] = STATE(12342),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12342),
    [sym_binary] = STATE(12342),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12075] = {
    [sym_assignment] = STATE(12343),
    [sym_unary] = STATE(12343),
    [sym_right_assignment_list] = STATE(10068),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12343),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_splat_argument] = STATE(12344),
    [sym_operator_assignment] = STATE(12343),
    [sym_conditional] = STATE(12343),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_return] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_subshell] = STATE(11530),
    [sym__arg_or_splat_arg] = STATE(12344),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12343),
    [sym_binary] = STATE(12343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [sym_global_variable] = ACTIONS(16344),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(16336),
    [sym_character] = ACTIONS(16340),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12076] = {
    [sym_assignment] = STATE(12345),
    [sym_unary] = STATE(12345),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12345),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12345),
    [sym_conditional] = STATE(12345),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12345),
    [sym_binary] = STATE(12345),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12077] = {
    [sym_assignment] = STATE(12346),
    [sym_unary] = STATE(12346),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12346),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12346),
    [sym_conditional] = STATE(12346),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12346),
    [sym_binary] = STATE(12346),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12078] = {
    [sym_assignment] = STATE(12348),
    [sym_unary] = STATE(12348),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12348),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12348),
    [sym_conditional] = STATE(12348),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12348),
    [sym_binary] = STATE(12348),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12079] = {
    [sym_assignment] = STATE(12349),
    [sym_unary] = STATE(12349),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12349),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12349),
    [sym_conditional] = STATE(12349),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12349),
    [sym_binary] = STATE(12349),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [12080] = {
    [sym_assignment] = STATE(12350),
    [sym_unary] = STATE(12350),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12350),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12350),
    [sym_conditional] = STATE(12350),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12350),
    [sym_binary] = STATE(12350),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12081] = {
    [sym_assignment] = STATE(12351),
    [sym_unary] = STATE(12351),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12351),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12351),
    [sym_conditional] = STATE(12351),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12351),
    [sym_binary] = STATE(12351),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12082] = {
    [sym_assignment] = STATE(12352),
    [sym_unary] = STATE(12352),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12352),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12352),
    [sym_conditional] = STATE(12352),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12352),
    [sym_binary] = STATE(12352),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12083] = {
    [sym_assignment] = STATE(12353),
    [sym_unary] = STATE(12353),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12353),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12353),
    [sym_conditional] = STATE(12353),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12353),
    [sym_binary] = STATE(12353),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12084] = {
    [sym_assignment] = STATE(12354),
    [sym_unary] = STATE(12354),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12354),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12354),
    [sym_conditional] = STATE(12354),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12354),
    [sym_binary] = STATE(12354),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12085] = {
    [aux_sym_chained_string_repeat1] = STATE(12355),
    [sym_string] = STATE(12355),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(8164),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [12086] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12087] = {
    [aux_sym_exceptions_repeat1] = STATE(12357),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [12088] = {
    [sym__argument] = STATE(10085),
    [sym_assignment] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(10085),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10085),
    [sym_hash_splat_argument] = STATE(10085),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(10386),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_block_argument] = STATE(10085),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym_float] = ACTIONS(15107),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(15111),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(15117),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(15123),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15117),
    [anon_sym_yield] = ACTIONS(15125),
    [sym_class_variable] = ACTIONS(15119),
    [sym__block_ampersand] = ACTIONS(15127),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(15129),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17107),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12089] = {
    [sym_heredoc_body] = STATE(12089),
    [aux_sym_call_repeat1] = STATE(12089),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(14739),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [12090] = {
    [sym_heredoc_body] = STATE(12089),
    [aux_sym_call_repeat1] = STATE(12089),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(8184),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [12091] = {
    [aux_sym_argument_list_repeat1] = STATE(12091),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17466),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [12092] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12093] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12094] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12095] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17469),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12096] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12097] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12098] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12099] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12100] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12101] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12102] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12103] = {
    [aux_sym_chained_string_repeat1] = STATE(12103),
    [sym_string] = STATE(12103),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12457),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [12104] = {
    [sym__line_break] = ACTIONS(17471),
    [sym_float] = ACTIONS(17473),
    [anon_sym_until] = ACTIONS(17473),
    [anon_sym_undef] = ACTIONS(17473),
    [sym_self] = ACTIONS(17473),
    [anon_sym_BEGIN] = ACTIONS(17473),
    [anon_sym_TILDE] = ACTIONS(17471),
    [anon_sym_unless] = ACTIONS(17473),
    [anon_sym_PLUS] = ACTIONS(17473),
    [sym__symbol_array_start] = ACTIONS(17471),
    [sym__simple_symbol] = ACTIONS(17471),
    [sym_complex] = ACTIONS(17471),
    [sym_heredoc_beginning] = ACTIONS(17471),
    [sym_super] = ACTIONS(17473),
    [anon_sym_alias] = ACTIONS(17473),
    [anon_sym_LBRACK2] = ACTIONS(17471),
    [anon_sym_nil] = ACTIONS(17473),
    [sym_character] = ACTIONS(17471),
    [anon_sym_LBRACE] = ACTIONS(17471),
    [anon_sym_END] = ACTIONS(17473),
    [sym_constant] = ACTIONS(17473),
    [anon_sym_while] = ACTIONS(17473),
    [sym_instance_variable] = ACTIONS(17471),
    [sym__heredoc_body_start] = ACTIONS(17471),
    [anon_sym_defined_QMARK] = ACTIONS(17471),
    [sym__string_start] = ACTIONS(17471),
    [anon_sym_true] = ACTIONS(17473),
    [anon_sym_for] = ACTIONS(17473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17471),
    [anon_sym_NIL] = ACTIONS(17473),
    [anon_sym_COLON_COLON] = ACTIONS(17471),
    [anon_sym_def] = ACTIONS(17473),
    [sym_identifier] = ACTIONS(17473),
    [anon_sym_yield] = ACTIONS(17473),
    [sym_class_variable] = ACTIONS(17471),
    [sym__symbol_start] = ACTIONS(17471),
    [anon_sym_not] = ACTIONS(17473),
    [anon_sym_TRUE] = ACTIONS(17473),
    [anon_sym_case] = ACTIONS(17473),
    [anon_sym_SEMI] = ACTIONS(17471),
    [anon_sym_LPAREN] = ACTIONS(17471),
    [anon_sym_break] = ACTIONS(17473),
    [sym_global_variable] = ACTIONS(17471),
    [anon_sym_class] = ACTIONS(17473),
    [sym__subshell_start] = ACTIONS(17471),
    [anon_sym_module] = ACTIONS(17473),
    [anon_sym_begin] = ACTIONS(17473),
    [anon_sym_false] = ACTIONS(17473),
    [anon_sym_STAR] = ACTIONS(17471),
    [sym__unary_minus] = ACTIONS(17471),
    [anon_sym_next] = ACTIONS(17473),
    [sym_retry] = ACTIONS(17473),
    [sym__regex_start] = ACTIONS(17471),
    [anon_sym_end] = ACTIONS(17473),
    [sym_integer] = ACTIONS(17473),
    [anon_sym_FALSE] = ACTIONS(17473),
    [sym_redo] = ACTIONS(17473),
    [anon_sym_BANG] = ACTIONS(17471),
    [anon_sym_if] = ACTIONS(17473),
    [sym__string_array_start] = ACTIONS(17471),
    [anon_sym_return] = ACTIONS(17473),
  },
  [12105] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(17475),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [12106] = {
    [aux_sym_exceptions_repeat1] = STATE(12106),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17477),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12107] = {
    [anon_sym_LT] = ACTIONS(12855),
    [anon_sym_SLASH] = ACTIONS(12857),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12859),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12861),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12863),
    [anon_sym_LT_LT] = ACTIONS(12861),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12865),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12865),
    [anon_sym_AMP] = ACTIONS(12867),
    [anon_sym_GT] = ACTIONS(12855),
    [anon_sym_PLUS] = ACTIONS(12869),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(12857),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(12857),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(12871),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(12865),
    [anon_sym_PIPE_PIPE] = ACTIONS(12865),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12873),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12865),
    [anon_sym_STAR_STAR] = ACTIONS(12857),
    [anon_sym_PIPE] = ACTIONS(12875),
    [anon_sym_DOT_DOT] = ACTIONS(12877),
    [anon_sym_AMP_AMP] = ACTIONS(12865),
    [anon_sym_LT_EQ_GT] = ACTIONS(12865),
    [anon_sym_LT_EQ] = ACTIONS(12855),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(12879),
    [sym__binary_minus] = ACTIONS(12869),
  },
  [12108] = {
    [anon_sym_LT] = ACTIONS(12917),
    [anon_sym_SLASH] = ACTIONS(12919),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(12921),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12923),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12925),
    [anon_sym_LT_LT] = ACTIONS(12923),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12927),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(12927),
    [anon_sym_AMP] = ACTIONS(12929),
    [anon_sym_GT] = ACTIONS(12917),
    [anon_sym_PLUS] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12919),
    [sym__binary_star] = ACTIONS(12919),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(12933),
    [anon_sym_BANG_TILDE] = ACTIONS(12927),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12927),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(12927),
    [anon_sym_STAR_STAR] = ACTIONS(12919),
    [anon_sym_PIPE] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_AMP_AMP] = ACTIONS(12927),
    [anon_sym_LT_EQ_GT] = ACTIONS(12927),
    [anon_sym_LT_EQ] = ACTIONS(12917),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(12941),
    [sym__binary_minus] = ACTIONS(12931),
  },
  [12109] = {
    [aux_sym_exceptions_repeat1] = STATE(12109),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17480),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12110] = {
    [anon_sym_SLASH] = ACTIONS(12953),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12955),
    [anon_sym_EQ_TILDE] = ACTIONS(12955),
    [anon_sym_LT_LT] = ACTIONS(12957),
    [sym__binary_star] = ACTIONS(12959),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(12961),
    [anon_sym_AMP] = ACTIONS(12963),
    [anon_sym_PERCENT] = ACTIONS(12953),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(12955),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(12965),
    [anon_sym_PIPE] = ACTIONS(12967),
    [anon_sym_DOT_DOT] = ACTIONS(12969),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(12965),
    [anon_sym_QMARK] = ACTIONS(12971),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(12957),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12973),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(12965),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(12975),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(12975),
    [anon_sym_GT_EQ] = ACTIONS(12977),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(12955),
    [anon_sym_STAR_STAR] = ACTIONS(12953),
    [anon_sym_LT_EQ_GT] = ACTIONS(12955),
    [anon_sym_AMP_AMP] = ACTIONS(12975),
    [sym__binary_minus] = ACTIONS(12979),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(12967),
  },
  [12111] = {
    [sym_float] = ACTIONS(17473),
    [anon_sym_until] = ACTIONS(17473),
    [anon_sym_undef] = ACTIONS(17473),
    [sym_self] = ACTIONS(17473),
    [anon_sym_BEGIN] = ACTIONS(17473),
    [anon_sym_RBRACE] = ACTIONS(17471),
    [anon_sym_TILDE] = ACTIONS(17471),
    [anon_sym_unless] = ACTIONS(17473),
    [anon_sym_PLUS] = ACTIONS(17473),
    [sym__symbol_array_start] = ACTIONS(17471),
    [sym__simple_symbol] = ACTIONS(17471),
    [sym_complex] = ACTIONS(17471),
    [sym_heredoc_beginning] = ACTIONS(17471),
    [sym_super] = ACTIONS(17473),
    [anon_sym_alias] = ACTIONS(17473),
    [anon_sym_LBRACK2] = ACTIONS(17471),
    [anon_sym_nil] = ACTIONS(17473),
    [sym_character] = ACTIONS(17471),
    [anon_sym_LBRACE] = ACTIONS(17471),
    [anon_sym_END] = ACTIONS(17473),
    [sym_constant] = ACTIONS(17473),
    [anon_sym_while] = ACTIONS(17473),
    [sym_instance_variable] = ACTIONS(17471),
    [anon_sym_defined_QMARK] = ACTIONS(17471),
    [sym__string_start] = ACTIONS(17471),
    [anon_sym_true] = ACTIONS(17473),
    [anon_sym_for] = ACTIONS(17473),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17471),
    [anon_sym_NIL] = ACTIONS(17473),
    [anon_sym_COLON_COLON] = ACTIONS(17471),
    [anon_sym_def] = ACTIONS(17473),
    [sym_identifier] = ACTIONS(17473),
    [anon_sym_yield] = ACTIONS(17473),
    [sym_class_variable] = ACTIONS(17471),
    [sym__symbol_start] = ACTIONS(17471),
    [anon_sym_not] = ACTIONS(17473),
    [anon_sym_TRUE] = ACTIONS(17473),
    [anon_sym_case] = ACTIONS(17473),
    [anon_sym_SEMI] = ACTIONS(17471),
    [anon_sym_LPAREN] = ACTIONS(17471),
    [anon_sym_break] = ACTIONS(17473),
    [sym_global_variable] = ACTIONS(17471),
    [anon_sym_class] = ACTIONS(17473),
    [sym__subshell_start] = ACTIONS(17471),
    [anon_sym_module] = ACTIONS(17473),
    [anon_sym_begin] = ACTIONS(17473),
    [anon_sym_false] = ACTIONS(17473),
    [anon_sym_STAR] = ACTIONS(17471),
    [sym__unary_minus] = ACTIONS(17471),
    [anon_sym_next] = ACTIONS(17473),
    [sym_retry] = ACTIONS(17473),
    [sym__regex_start] = ACTIONS(17471),
    [sym_integer] = ACTIONS(17473),
    [anon_sym_FALSE] = ACTIONS(17473),
    [sym_redo] = ACTIONS(17473),
    [anon_sym_BANG] = ACTIONS(17471),
    [anon_sym_if] = ACTIONS(17473),
    [sym__string_array_start] = ACTIONS(17471),
    [anon_sym_return] = ACTIONS(17473),
  },
  [12112] = {
    [aux_sym_block_parameters_repeat1] = STATE(10392),
    [anon_sym_PIPE] = ACTIONS(17483),
    [sym_comment] = ACTIONS(49),
    [anon_sym_COMMA] = ACTIONS(12837),
  },
  [12113] = {
    [anon_sym_LT] = ACTIONS(13025),
    [anon_sym_SLASH] = ACTIONS(13027),
    [anon_sym_QMARK] = ACTIONS(13029),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13033),
    [anon_sym_LT_LT] = ACTIONS(13035),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13031),
    [anon_sym_EQ_TILDE] = ACTIONS(13031),
    [anon_sym_PLUS] = ACTIONS(13039),
    [anon_sym_AMP] = ACTIONS(13041),
    [anon_sym_GT] = ACTIONS(13025),
    [anon_sym_PERCENT] = ACTIONS(13027),
    [sym__binary_star] = ACTIONS(13027),
    [anon_sym_EQ_EQ] = ACTIONS(13043),
    [anon_sym_BANG_TILDE] = ACTIONS(13031),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13031),
    [anon_sym_GT_EQ] = ACTIONS(13045),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13031),
    [anon_sym_STAR_STAR] = ACTIONS(13027),
    [anon_sym_PIPE] = ACTIONS(13049),
    [anon_sym_DOT_DOT] = ACTIONS(13047),
    [anon_sym_AMP_AMP] = ACTIONS(13031),
    [anon_sym_LT_EQ_GT] = ACTIONS(13031),
    [anon_sym_LT_EQ] = ACTIONS(13025),
    [sym__binary_minus] = ACTIONS(13039),
    [anon_sym_CARET] = ACTIONS(13051),
  },
  [12114] = {
    [aux_sym_exceptions_repeat1] = STATE(12114),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17485),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12115] = {
    [anon_sym_LT] = ACTIONS(13070),
    [anon_sym_SLASH] = ACTIONS(13072),
    [anon_sym_QMARK] = ACTIONS(13074),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13078),
    [anon_sym_LT_LT] = ACTIONS(13076),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13080),
    [anon_sym_EQ_TILDE] = ACTIONS(13080),
    [anon_sym_PLUS] = ACTIONS(13082),
    [anon_sym_AMP] = ACTIONS(13084),
    [anon_sym_GT] = ACTIONS(13070),
    [anon_sym_PERCENT] = ACTIONS(13072),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(13072),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13086),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(13080),
    [anon_sym_PIPE_PIPE] = ACTIONS(13080),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13088),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13080),
    [anon_sym_STAR_STAR] = ACTIONS(13072),
    [anon_sym_PIPE] = ACTIONS(13090),
    [anon_sym_DOT_DOT] = ACTIONS(13092),
    [anon_sym_AMP_AMP] = ACTIONS(13080),
    [anon_sym_LT_EQ_GT] = ACTIONS(13080),
    [anon_sym_LT_EQ] = ACTIONS(13070),
    [sym__binary_minus] = ACTIONS(13082),
    [anon_sym_CARET] = ACTIONS(13094),
  },
  [12116] = {
    [aux_sym_exceptions_repeat1] = STATE(12116),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17488),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12117] = {
    [anon_sym_LT] = ACTIONS(13112),
    [anon_sym_SLASH] = ACTIONS(13114),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13116),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13120),
    [anon_sym_LT_LT] = ACTIONS(13118),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13122),
    [anon_sym_EQ_TILDE] = ACTIONS(13122),
    [anon_sym_PLUS] = ACTIONS(13124),
    [anon_sym_AMP] = ACTIONS(13126),
    [anon_sym_GT] = ACTIONS(13112),
    [anon_sym_PERCENT] = ACTIONS(13114),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(13128),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13130),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13130),
    [anon_sym_BANG_TILDE] = ACTIONS(13122),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13132),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13122),
    [anon_sym_STAR_STAR] = ACTIONS(13114),
    [anon_sym_PIPE] = ACTIONS(13134),
    [anon_sym_DOT_DOT] = ACTIONS(13136),
    [anon_sym_AMP_AMP] = ACTIONS(13130),
    [anon_sym_LT_EQ_GT] = ACTIONS(13122),
    [anon_sym_LT_EQ] = ACTIONS(13112),
    [sym__binary_minus] = ACTIONS(13138),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(13134),
  },
  [12118] = {
    [sym__line_break] = ACTIONS(15175),
    [anon_sym_DOT] = ACTIONS(15175),
    [anon_sym_then] = ACTIONS(15175),
    [anon_sym_AMP_DOT] = ACTIONS(15175),
    [anon_sym_COLON_COLON2] = ACTIONS(15175),
    [sym__heredoc_body_start] = ACTIONS(15175),
    [anon_sym_COMMA] = ACTIONS(15175),
    [anon_sym_SEMI] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [sym_comment] = ACTIONS(49),
  },
  [12119] = {
    [anon_sym_end] = ACTIONS(17491),
    [sym_comment] = ACTIONS(49),
  },
  [12120] = {
    [sym_assignment] = STATE(11601),
    [sym_unary] = STATE(11601),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11601),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11601),
    [sym_conditional] = STATE(11601),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_true] = STATE(8749),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(11601),
    [sym_binary] = STATE(11601),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(9909),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [sym_global_variable] = ACTIONS(5732),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(5722),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [12121] = {
    [aux_sym_exceptions_repeat1] = STATE(12362),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17493),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [12122] = {
    [sym_assignment] = STATE(12363),
    [sym_unary] = STATE(12363),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8749),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(12363),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(8749),
    [sym_operator_assignment] = STATE(12363),
    [sym_conditional] = STATE(12363),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(3418),
    [sym_left_assignment_list] = STATE(8751),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(8749),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(3420),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(8749),
    [sym_range] = STATE(12363),
    [sym_binary] = STATE(12363),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(8749),
    [sym_nil] = STATE(8749),
    [sym_scope_resolution] = STATE(3418),
    [sym_call] = STATE(3418),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(5716),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13284),
    [anon_sym_not] = ACTIONS(13286),
    [sym_self] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(5726),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13288),
    [anon_sym_TILDE] = ACTIONS(13284),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(5732),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(5722),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13290),
    [anon_sym_next] = ACTIONS(5736),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(5722),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [sym_instance_variable] = ACTIONS(5732),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(5722),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(5732),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(5742),
  },
  [12123] = {
    [aux_sym_undef_repeat1] = STATE(12123),
    [sym__line_break] = ACTIONS(7428),
    [sym_comment] = ACTIONS(49),
    [anon_sym_unless] = ACTIONS(7428),
    [anon_sym_until] = ACTIONS(7428),
    [anon_sym_while] = ACTIONS(7428),
    [sym__heredoc_body_start] = ACTIONS(7428),
    [anon_sym_rescue] = ACTIONS(7428),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_COMMA] = ACTIONS(7430),
    [anon_sym_when] = ACTIONS(7428),
    [anon_sym_SEMI] = ACTIONS(7428),
    [anon_sym_if] = ACTIONS(7428),
    [anon_sym_else] = ACTIONS(7428),
  },
  [12124] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_when] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12125] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_when] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12126] = {
    [sym_assignment] = STATE(12364),
    [sym_unary] = STATE(12364),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12364),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12364),
    [sym_conditional] = STATE(12364),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12364),
    [sym_binary] = STATE(12364),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12127] = {
    [sym_assignment] = STATE(12365),
    [sym_unary] = STATE(12365),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12365),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12365),
    [sym_conditional] = STATE(12365),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12365),
    [sym_binary] = STATE(12365),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12128] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_when] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12129] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_when] = ACTIONS(4272),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12130] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12131] = {
    [sym__argument] = STATE(5949),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(5949),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(5949),
    [sym_hash_splat_argument] = STATE(5949),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_heredoc_body] = STATE(12366),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_block_argument] = STATE(5949),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym_float] = ACTIONS(15341),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(15345),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(15353),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(15365),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17495),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12132] = {
    [sym_heredoc_body] = STATE(12367),
    [aux_sym_call_repeat1] = STATE(12367),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [12133] = {
    [sym_heredoc_body] = STATE(12368),
    [aux_sym_call_repeat1] = STATE(12368),
    [aux_sym_argument_list_repeat1] = STATE(12369),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(17159),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [12134] = {
    [sym_heredoc_body] = STATE(12370),
    [aux_sym_call_repeat1] = STATE(12370),
    [aux_sym_argument_list_repeat1] = STATE(12371),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(16539),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [12135] = {
    [sym_heredoc_body] = STATE(12370),
    [aux_sym_call_repeat1] = STATE(12370),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2235),
    [sym__line_break] = ACTIONS(2235),
    [anon_sym_until] = ACTIONS(2235),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_GT_GT] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2235),
    [anon_sym_LT_LT] = ACTIONS(2235),
    [anon_sym_or] = ACTIONS(2235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2235),
    [anon_sym_unless] = ACTIONS(2235),
    [anon_sym_EQ_TILDE] = ACTIONS(2235),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_COLON_COLON2] = ACTIONS(2235),
    [anon_sym_PERCENT] = ACTIONS(2235),
    [anon_sym_rescue] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [sym__binary_star] = ACTIONS(2235),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2235),
    [anon_sym_BANG_TILDE] = ACTIONS(2235),
    [anon_sym_PIPE_PIPE] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2235),
    [anon_sym_end] = ACTIONS(2235),
    [anon_sym_else] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(2235),
    [anon_sym_BANG_EQ] = ACTIONS(2235),
    [anon_sym_STAR_STAR] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2235),
    [anon_sym_LT_EQ_GT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2235),
    [sym__binary_minus] = ACTIONS(2235),
  },
  [12136] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [12137] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12138] = {
    [sym_assignment] = STATE(12372),
    [sym_unary] = STATE(12372),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12372),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12372),
    [sym_conditional] = STATE(12372),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12372),
    [sym_binary] = STATE(12372),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12139] = {
    [sym_assignment] = STATE(12373),
    [sym_unary] = STATE(12373),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12373),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_splat_argument] = STATE(12374),
    [sym_operator_assignment] = STATE(12373),
    [sym_conditional] = STATE(12373),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_return] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_subshell] = STATE(8790),
    [sym__arg_or_splat_arg] = STATE(12374),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12373),
    [sym_binary] = STATE(12373),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13318),
    [sym_character] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12140] = {
    [sym_assignment] = STATE(12375),
    [sym_unary] = STATE(12375),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12375),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12375),
    [sym_conditional] = STATE(12375),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12375),
    [sym_binary] = STATE(12375),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12141] = {
    [sym_assignment] = STATE(12376),
    [sym_unary] = STATE(12376),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12376),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12376),
    [sym_conditional] = STATE(12376),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12376),
    [sym_binary] = STATE(12376),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12142] = {
    [sym_assignment] = STATE(12378),
    [sym_unary] = STATE(12378),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12378),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12378),
    [sym_conditional] = STATE(12378),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12378),
    [sym_binary] = STATE(12378),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12143] = {
    [sym_assignment] = STATE(12379),
    [sym_unary] = STATE(12379),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12379),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12379),
    [sym_conditional] = STATE(12379),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12379),
    [sym_binary] = STATE(12379),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [12144] = {
    [sym_assignment] = STATE(12380),
    [sym_unary] = STATE(12380),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12380),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12380),
    [sym_conditional] = STATE(12380),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12380),
    [sym_binary] = STATE(12380),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12145] = {
    [sym_assignment] = STATE(12381),
    [sym_unary] = STATE(12381),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12381),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12381),
    [sym_conditional] = STATE(12381),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12381),
    [sym_binary] = STATE(12381),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12146] = {
    [sym_assignment] = STATE(12382),
    [sym_unary] = STATE(12382),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12382),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12382),
    [sym_conditional] = STATE(12382),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12382),
    [sym_binary] = STATE(12382),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12147] = {
    [sym_assignment] = STATE(12383),
    [sym_unary] = STATE(12383),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12383),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12383),
    [sym_conditional] = STATE(12383),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12383),
    [sym_binary] = STATE(12383),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12148] = {
    [sym_assignment] = STATE(12384),
    [sym_unary] = STATE(12384),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12384),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12384),
    [sym_conditional] = STATE(12384),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12384),
    [sym_binary] = STATE(12384),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12149] = {
    [aux_sym_chained_string_repeat1] = STATE(12385),
    [sym_string] = STATE(12385),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_when] = ACTIONS(3165),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [sym__binary_minus] = ACTIONS(3165),
  },
  [12150] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(10626),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym_float] = ACTIONS(15341),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(15345),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15351),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(15359),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15351),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(15363),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(15365),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17195),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12151] = {
    [sym_heredoc_body] = STATE(12151),
    [aux_sym_call_repeat1] = STATE(12151),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_when] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [12152] = {
    [sym_heredoc_body] = STATE(12151),
    [aux_sym_call_repeat1] = STATE(12151),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_when] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [12153] = {
    [aux_sym_argument_list_repeat1] = STATE(12153),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17497),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [12154] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_when] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12155] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_when] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12156] = {
    [aux_sym_exceptions_repeat1] = STATE(12387),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [12157] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12158] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12159] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17500),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12160] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12161] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12162] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_when] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12163] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12164] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12165] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12166] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12167] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym__line_break] = ACTIONS(1045),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [sym__symbol_array_start] = ACTIONS(1045),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_when] = ACTIONS(1327),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [anon_sym_CARET] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [12168] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(12390),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(17502),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [12169] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym__line_break] = ACTIONS(6721),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [sym__symbol_array_start] = ACTIONS(6721),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_rescue] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_else] = ACTIONS(6719),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_LT] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [anon_sym_when] = ACTIONS(6719),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [anon_sym_end] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [anon_sym_CARET] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [12170] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym__line_break] = ACTIONS(6729),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [sym__symbol_array_start] = ACTIONS(6729),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_rescue] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_else] = ACTIONS(6727),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_LT] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [anon_sym_when] = ACTIONS(6727),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [anon_sym_end] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [anon_sym_CARET] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_EQ_GT] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [12171] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(12170),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(12391),
    [sym_operator] = STATE(12391),
    [anon_sym_LT] = ACTIONS(17197),
    [anon_sym_SLASH] = ACTIONS(17199),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17199),
    [anon_sym_PLUS_AT] = ACTIONS(17199),
    [anon_sym_LPAREN2] = ACTIONS(17201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17199),
    [anon_sym_GT_GT] = ACTIONS(17199),
    [anon_sym_EQ_TILDE] = ACTIONS(17199),
    [anon_sym_LT_LT] = ACTIONS(17199),
    [anon_sym_TILDE] = ACTIONS(17199),
    [anon_sym_PLUS] = ACTIONS(17197),
    [anon_sym_AMP] = ACTIONS(17199),
    [anon_sym_GT] = ACTIONS(17197),
    [anon_sym_PERCENT] = ACTIONS(17199),
    [anon_sym_DASH_AT] = ACTIONS(17199),
    [anon_sym_EQ_EQ] = ACTIONS(17197),
    [anon_sym_STAR] = ACTIONS(17197),
    [anon_sym_BANG_TILDE] = ACTIONS(17199),
    [sym_constant] = ACTIONS(17504),
    [anon_sym_DASH] = ACTIONS(17197),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17199),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17197),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17199),
    [anon_sym_STAR_STAR] = ACTIONS(17199),
    [anon_sym_PIPE] = ACTIONS(17199),
    [anon_sym_DOT_DOT] = ACTIONS(17199),
    [anon_sym_LT_EQ_GT] = ACTIONS(17199),
    [anon_sym_LT_EQ] = ACTIONS(17197),
    [anon_sym_BANG] = ACTIONS(17197),
    [sym_identifier] = ACTIONS(17504),
    [anon_sym_CARET] = ACTIONS(17199),
  },
  [12172] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym__line_break] = ACTIONS(6741),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [sym__symbol_array_start] = ACTIONS(6741),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_LT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [anon_sym_CARET] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [12173] = {
    [sym_assignment] = STATE(12392),
    [sym_unary] = STATE(12392),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12392),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12392),
    [sym_conditional] = STATE(12392),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12392),
    [sym_binary] = STATE(12392),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12174] = {
    [sym_assignment] = STATE(12393),
    [sym_unary] = STATE(12393),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12393),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12393),
    [sym_conditional] = STATE(12393),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12393),
    [sym_binary] = STATE(12393),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12175] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(4214),
    [anon_sym_until] = ACTIONS(4214),
    [anon_sym_AMP_EQ] = ACTIONS(4214),
    [anon_sym_GT_GT_EQ] = ACTIONS(4214),
    [anon_sym_SLASH_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(4214),
    [anon_sym_rescue] = ACTIONS(4214),
    [anon_sym_PERCENT_EQ] = ACTIONS(4214),
    [anon_sym_LT_LT_EQ] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [sym__heredoc_body_start] = ACTIONS(4214),
    [anon_sym_else] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_CARET_EQ] = ACTIONS(4214),
    [anon_sym_AMP_DOT] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(4214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(4214),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(4214),
    [anon_sym_when] = ACTIONS(4214),
    [anon_sym_PIPE_EQ] = ACTIONS(4214),
    [anon_sym_PLUS_EQ] = ACTIONS(4214),
    [anon_sym_STAR_EQ] = ACTIONS(4214),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(4214),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4214),
    [anon_sym_DASH_EQ] = ACTIONS(4214),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12176] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_AMP_EQ] = ACTIONS(4272),
    [anon_sym_GT_GT_EQ] = ACTIONS(4272),
    [anon_sym_SLASH_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(4272),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_PERCENT_EQ] = ACTIONS(4272),
    [anon_sym_LT_LT_EQ] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_DOT] = ACTIONS(5554),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(4272),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4272),
    [anon_sym_CARET_EQ] = ACTIONS(4272),
    [anon_sym_AMP_DOT] = ACTIONS(4272),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(4272),
    [anon_sym_when] = ACTIONS(4272),
    [anon_sym_PIPE_EQ] = ACTIONS(4272),
    [anon_sym_PLUS_EQ] = ACTIONS(4272),
    [anon_sym_STAR_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4272),
    [anon_sym_DASH_EQ] = ACTIONS(4272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12177] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(4288),
    [anon_sym_until] = ACTIONS(4288),
    [anon_sym_AMP_EQ] = ACTIONS(4288),
    [anon_sym_GT_GT_EQ] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(4288),
    [anon_sym_rescue] = ACTIONS(4288),
    [anon_sym_PERCENT_EQ] = ACTIONS(4288),
    [anon_sym_LT_LT_EQ] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5570),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_while] = ACTIONS(4288),
    [sym__heredoc_body_start] = ACTIONS(4288),
    [anon_sym_else] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(4288),
    [anon_sym_CARET_EQ] = ACTIONS(4288),
    [anon_sym_AMP_DOT] = ACTIONS(4288),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(4288),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_PLUS_EQ] = ACTIONS(4288),
    [anon_sym_STAR_EQ] = ACTIONS(4288),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(4288),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4288),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4288),
    [anon_sym_DASH_EQ] = ACTIONS(4288),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4288),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(4288),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12178] = {
    [sym__argument] = STATE(6074),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(6074),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(6074),
    [sym_hash_splat_argument] = STATE(6074),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_heredoc_body] = STATE(12394),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_block_argument] = STATE(6074),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(15403),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(15403),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(15411),
    [sym__heredoc_body_start] = ACTIONS(5586),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [sym__block_ampersand] = ACTIONS(16583),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(15421),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17506),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12179] = {
    [sym_heredoc_body] = STATE(12395),
    [aux_sym_call_repeat1] = STATE(12395),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [12180] = {
    [sym_heredoc_body] = STATE(12396),
    [aux_sym_call_repeat1] = STATE(12396),
    [aux_sym_argument_list_repeat1] = STATE(12397),
    [anon_sym_SLASH] = ACTIONS(5590),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_AMP_EQ] = ACTIONS(5592),
    [anon_sym_GT_GT_EQ] = ACTIONS(5592),
    [anon_sym_SLASH_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5590),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5590),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_PERCENT_EQ] = ACTIONS(5592),
    [anon_sym_LT_LT_EQ] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5592),
    [anon_sym_CARET_EQ] = ACTIONS(5592),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(17211),
    [anon_sym_GT_GT] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [anon_sym_PIPE_EQ] = ACTIONS(5592),
    [anon_sym_PLUS_EQ] = ACTIONS(5592),
    [anon_sym_STAR_EQ] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5590),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5592),
    [anon_sym_DASH_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5590),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_AMP_AMP] = ACTIONS(5590),
    [sym__binary_minus] = ACTIONS(5592),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5590),
  },
  [12181] = {
    [aux_sym_chained_string_repeat1] = STATE(12181),
    [sym_string] = STATE(12181),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_when] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(9816),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [12182] = {
    [sym_float] = ACTIONS(10412),
    [anon_sym_until] = ACTIONS(10412),
    [anon_sym_undef] = ACTIONS(10412),
    [sym_self] = ACTIONS(10412),
    [anon_sym_BEGIN] = ACTIONS(10412),
    [anon_sym_TILDE] = ACTIONS(8575),
    [anon_sym_unless] = ACTIONS(10412),
    [anon_sym_PLUS] = ACTIONS(10412),
    [sym__symbol_array_start] = ACTIONS(8575),
    [sym__simple_symbol] = ACTIONS(8575),
    [sym_complex] = ACTIONS(8575),
    [sym_heredoc_beginning] = ACTIONS(8575),
    [sym_super] = ACTIONS(10412),
    [anon_sym_alias] = ACTIONS(10412),
    [anon_sym_LBRACK2] = ACTIONS(8575),
    [anon_sym_nil] = ACTIONS(10412),
    [sym_character] = ACTIONS(8575),
    [anon_sym_LBRACE] = ACTIONS(8575),
    [anon_sym_END] = ACTIONS(10412),
    [sym_constant] = ACTIONS(10412),
    [anon_sym_while] = ACTIONS(10412),
    [sym_instance_variable] = ACTIONS(8575),
    [anon_sym_defined_QMARK] = ACTIONS(8575),
    [sym__string_start] = ACTIONS(8575),
    [anon_sym_else] = ACTIONS(10412),
    [anon_sym_true] = ACTIONS(10412),
    [anon_sym_for] = ACTIONS(10412),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(8575),
    [anon_sym_NIL] = ACTIONS(10412),
    [anon_sym_COLON_COLON] = ACTIONS(8575),
    [anon_sym_def] = ACTIONS(10412),
    [sym_identifier] = ACTIONS(10412),
    [anon_sym_yield] = ACTIONS(10412),
    [sym_class_variable] = ACTIONS(8575),
    [anon_sym_not] = ACTIONS(10412),
    [sym__symbol_start] = ACTIONS(8575),
    [anon_sym_TRUE] = ACTIONS(10412),
    [anon_sym_case] = ACTIONS(10412),
    [anon_sym_SEMI] = ACTIONS(8575),
    [anon_sym_LPAREN] = ACTIONS(8575),
    [anon_sym_break] = ACTIONS(10412),
    [sym_global_variable] = ACTIONS(8575),
    [anon_sym_class] = ACTIONS(10412),
    [sym__subshell_start] = ACTIONS(8575),
    [anon_sym_module] = ACTIONS(10412),
    [anon_sym_begin] = ACTIONS(10412),
    [anon_sym_false] = ACTIONS(10412),
    [anon_sym_when] = ACTIONS(10412),
    [anon_sym_STAR] = ACTIONS(8575),
    [sym__unary_minus] = ACTIONS(8575),
    [anon_sym_next] = ACTIONS(10412),
    [sym_retry] = ACTIONS(10412),
    [sym__regex_start] = ACTIONS(8575),
    [anon_sym_end] = ACTIONS(10412),
    [sym_integer] = ACTIONS(10412),
    [anon_sym_FALSE] = ACTIONS(10412),
    [sym_redo] = ACTIONS(10412),
    [anon_sym_BANG] = ACTIONS(8575),
    [anon_sym_if] = ACTIONS(10412),
    [sym__string_array_start] = ACTIONS(8575),
    [anon_sym_return] = ACTIONS(10412),
  },
  [12183] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_rescue] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_end] = ACTIONS(5452),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [12184] = {
    [anon_sym_RPAREN] = ACTIONS(17508),
    [sym_comment] = ACTIONS(49),
  },
  [12185] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_when] = ACTIONS(10960),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [12186] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(4272),
    [anon_sym_until] = ACTIONS(4272),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(4272),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(4272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(4272),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(4272),
    [anon_sym_when] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(4272),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(4272),
    [sym__heredoc_body_start] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_else] = ACTIONS(4272),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(4272),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12187] = {
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [sym__binary_minus] = ACTIONS(1223),
  },
  [12188] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12189] = {
    [sym_assignment] = STATE(12399),
    [sym_unary] = STATE(12399),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12399),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12399),
    [sym_conditional] = STATE(12399),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12399),
    [sym_binary] = STATE(12399),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12190] = {
    [sym_assignment] = STATE(11689),
    [sym_unary] = STATE(11689),
    [sym_right_assignment_list] = STATE(1641),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11689),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_splat_argument] = STATE(12400),
    [sym_operator_assignment] = STATE(11689),
    [sym_conditional] = STATE(11689),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_return] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_subshell] = STATE(8790),
    [sym__arg_or_splat_arg] = STATE(12400),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(11689),
    [sym_binary] = STATE(11689),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(16607),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13318),
    [sym_character] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12191] = {
    [sym_assignment] = STATE(12401),
    [sym_unary] = STATE(12401),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12401),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12401),
    [sym_conditional] = STATE(12401),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12401),
    [sym_binary] = STATE(12401),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12192] = {
    [sym_assignment] = STATE(12402),
    [sym_unary] = STATE(12402),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12402),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12402),
    [sym_conditional] = STATE(12402),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12402),
    [sym_binary] = STATE(12402),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12193] = {
    [sym_assignment] = STATE(12404),
    [sym_unary] = STATE(12404),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12404),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12404),
    [sym_conditional] = STATE(12404),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12404),
    [sym_binary] = STATE(12404),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12194] = {
    [sym_assignment] = STATE(12405),
    [sym_unary] = STATE(12405),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12405),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12405),
    [sym_conditional] = STATE(12405),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12405),
    [sym_binary] = STATE(12405),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [12195] = {
    [sym_assignment] = STATE(12406),
    [sym_unary] = STATE(12406),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12406),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12406),
    [sym_conditional] = STATE(12406),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12406),
    [sym_binary] = STATE(12406),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12196] = {
    [sym_assignment] = STATE(12407),
    [sym_unary] = STATE(12407),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12407),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12407),
    [sym_conditional] = STATE(12407),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12407),
    [sym_binary] = STATE(12407),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12197] = {
    [sym_assignment] = STATE(12408),
    [sym_unary] = STATE(12408),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12408),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12408),
    [sym_conditional] = STATE(12408),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12408),
    [sym_binary] = STATE(12408),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12198] = {
    [sym_assignment] = STATE(12409),
    [sym_unary] = STATE(12409),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12409),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12409),
    [sym_conditional] = STATE(12409),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12409),
    [sym_binary] = STATE(12409),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12199] = {
    [sym_assignment] = STATE(12410),
    [sym_unary] = STATE(12410),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12410),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12410),
    [sym_conditional] = STATE(12410),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12410),
    [sym_binary] = STATE(12410),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12200] = {
    [sym_assignment] = STATE(11689),
    [sym_unary] = STATE(11689),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(11689),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11689),
    [sym_conditional] = STATE(11689),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_return] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_true] = STATE(11688),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(11689),
    [sym_binary] = STATE(11689),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(16607),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13318),
    [sym_character] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12201] = {
    [aux_sym_exceptions_repeat1] = STATE(12411),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17253),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_when] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [12202] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12203] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12204] = {
    [anon_sym_SLASH] = ACTIONS(1221),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_TILDE] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [sym__binary_star] = ACTIONS(1223),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1221),
    [sym__binary_minus] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1221),
  },
  [12205] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(1223),
    [anon_sym_until] = ACTIONS(1223),
    [anon_sym_AMP_EQ] = ACTIONS(1223),
    [anon_sym_GT_GT_EQ] = ACTIONS(1223),
    [anon_sym_SLASH_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(1223),
    [anon_sym_rescue] = ACTIONS(1223),
    [anon_sym_PERCENT_EQ] = ACTIONS(1223),
    [anon_sym_LT_LT_EQ] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [sym__heredoc_body_start] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1223),
    [anon_sym_CARET_EQ] = ACTIONS(1223),
    [anon_sym_AMP_DOT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(1223),
    [anon_sym_PIPE_EQ] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(1223),
    [anon_sym_STAR_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1223),
    [anon_sym_DASH_EQ] = ACTIONS(1223),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12206] = {
    [sym_assignment] = STATE(12412),
    [sym_unary] = STATE(12412),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12412),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12412),
    [sym_conditional] = STATE(12412),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12412),
    [sym_binary] = STATE(12412),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12207] = {
    [sym_assignment] = STATE(12413),
    [sym_unary] = STATE(12413),
    [sym_right_assignment_list] = STATE(6991),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12413),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_splat_argument] = STATE(12414),
    [sym_operator_assignment] = STATE(12413),
    [sym_conditional] = STATE(12413),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_return] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_subshell] = STATE(11706),
    [sym__arg_or_splat_arg] = STATE(12414),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12413),
    [sym_binary] = STATE(12413),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [sym_global_variable] = ACTIONS(16637),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(16629),
    [sym_character] = ACTIONS(16633),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12208] = {
    [sym_assignment] = STATE(12415),
    [sym_unary] = STATE(12415),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12415),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12415),
    [sym_conditional] = STATE(12415),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12415),
    [sym_binary] = STATE(12415),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12209] = {
    [sym_assignment] = STATE(12416),
    [sym_unary] = STATE(12416),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12416),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12416),
    [sym_conditional] = STATE(12416),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12416),
    [sym_binary] = STATE(12416),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12210] = {
    [sym_assignment] = STATE(12418),
    [sym_unary] = STATE(12418),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12418),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12418),
    [sym_conditional] = STATE(12418),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12418),
    [sym_binary] = STATE(12418),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12211] = {
    [sym_assignment] = STATE(12419),
    [sym_unary] = STATE(12419),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1797),
    [sym_singleton_class] = STATE(1799),
    [sym_module] = STATE(1799),
    [sym_chained_string] = STATE(1799),
    [sym_until] = STATE(1799),
    [sym_regex] = STATE(1799),
    [sym_for] = STATE(1799),
    [sym_symbol] = STATE(1799),
    [sym_if] = STATE(1799),
    [sym_begin] = STATE(1799),
    [sym__arg] = STATE(12419),
    [sym__primary] = STATE(1799),
    [sym_method_call] = STATE(1797),
    [sym_operator_assignment] = STATE(12419),
    [sym_conditional] = STATE(12419),
    [sym_method] = STATE(1799),
    [sym_singleton_method] = STATE(1799),
    [sym__variable] = STATE(1800),
    [sym_left_assignment_list] = STATE(1801),
    [sym_rational] = STATE(1799),
    [sym_true] = STATE(1797),
    [sym_return] = STATE(1799),
    [sym_subshell] = STATE(1799),
    [sym_yield] = STATE(1799),
    [sym_string] = STATE(1802),
    [sym_unless] = STATE(1799),
    [sym_lambda] = STATE(1799),
    [sym_parenthesized_statements] = STATE(1799),
    [sym_element_reference] = STATE(1797),
    [sym_range] = STATE(12419),
    [sym_binary] = STATE(12419),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1799),
    [sym_break] = STATE(1799),
    [sym_next] = STATE(1799),
    [sym_string_array] = STATE(1799),
    [sym_while] = STATE(1799),
    [sym_case] = STATE(1799),
    [sym_symbol_array] = STATE(1799),
    [sym_array] = STATE(1799),
    [sym_hash] = STATE(1799),
    [sym_false] = STATE(1797),
    [sym_nil] = STATE(1797),
    [sym_scope_resolution] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym__symbol_start] = ACTIONS(1285),
    [sym_float] = ACTIONS(3135),
    [anon_sym_TRUE] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_until] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_not] = ACTIONS(3141),
    [sym_self] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_unless] = ACTIONS(1245),
    [sym__symbol_array_start] = ACTIONS(1251),
    [sym__subshell_start] = ACTIONS(1297),
    [sym__simple_symbol] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1303),
    [sym_heredoc_beginning] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(1299),
    [anon_sym_begin] = ACTIONS(1301),
    [sym_complex] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_nil] = ACTIONS(1259),
    [sym_global_variable] = ACTIONS(3151),
    [sym_character] = ACTIONS(3147),
    [sym_super] = ACTIONS(3143),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [sym__unary_minus] = ACTIONS(3153),
    [anon_sym_next] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(1265),
    [sym_retry] = ACTIONS(3135),
    [sym_constant] = ACTIONS(3143),
    [anon_sym_defined_QMARK] = ACTIONS(3157),
    [sym_instance_variable] = ACTIONS(3151),
    [sym_integer] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1275),
    [sym__string_start] = ACTIONS(1271),
    [sym__regex_start] = ACTIONS(1309),
    [anon_sym_DASH_GT] = ACTIONS(1277),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1259),
    [anon_sym_FALSE] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(3159),
    [anon_sym_def] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(3143),
    [sym_redo] = ACTIONS(3135),
    [sym_class_variable] = ACTIONS(3151),
    [sym__string_array_start] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(3161),
  },
  [12212] = {
    [sym_assignment] = STATE(12420),
    [sym_unary] = STATE(12420),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12420),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12420),
    [sym_conditional] = STATE(12420),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12420),
    [sym_binary] = STATE(12420),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12213] = {
    [sym_assignment] = STATE(12421),
    [sym_unary] = STATE(12421),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12421),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12421),
    [sym_conditional] = STATE(12421),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12421),
    [sym_binary] = STATE(12421),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12214] = {
    [sym_assignment] = STATE(12422),
    [sym_unary] = STATE(12422),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12422),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12422),
    [sym_conditional] = STATE(12422),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12422),
    [sym_binary] = STATE(12422),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12215] = {
    [sym_assignment] = STATE(12423),
    [sym_unary] = STATE(12423),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12423),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12423),
    [sym_conditional] = STATE(12423),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12423),
    [sym_binary] = STATE(12423),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12216] = {
    [sym_assignment] = STATE(12424),
    [sym_unary] = STATE(12424),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12424),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12424),
    [sym_conditional] = STATE(12424),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12424),
    [sym_binary] = STATE(12424),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12217] = {
    [aux_sym_chained_string_repeat1] = STATE(12425),
    [sym_string] = STATE(12425),
    [anon_sym_SLASH] = ACTIONS(3163),
    [sym__line_break] = ACTIONS(3165),
    [anon_sym_until] = ACTIONS(3165),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_TILDE] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [sym__binary_star] = ACTIONS(3165),
    [anon_sym_unless] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_COLON_COLON2] = ACTIONS(3165),
    [anon_sym_rescue] = ACTIONS(3165),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_BANG_TILDE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [sym__heredoc_body_start] = ACTIONS(3165),
    [sym__string_start] = ACTIONS(3045),
    [anon_sym_else] = ACTIONS(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_AMP_DOT] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3163),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_or] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_when] = ACTIONS(3165),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_and] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_end] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3165),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3163),
    [anon_sym_LT_EQ_GT] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [sym__binary_minus] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
  },
  [12218] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(6135),
    [anon_sym_when] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12219] = {
    [aux_sym_exceptions_repeat1] = STATE(12427),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [12220] = {
    [sym__argument] = STATE(7028),
    [sym_assignment] = STATE(10655),
    [sym_unary] = STATE(10655),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(10655),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(7028),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(7028),
    [sym_hash_splat_argument] = STATE(7028),
    [sym_operator_assignment] = STATE(10655),
    [sym_conditional] = STATE(10655),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(10656),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_block_argument] = STATE(7028),
    [sym_range] = STATE(10655),
    [sym_binary] = STATE(10655),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(15403),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(15403),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(15409),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(15415),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15409),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [sym__block_ampersand] = ACTIONS(15419),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(15421),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17289),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12221] = {
    [sym_heredoc_body] = STATE(12221),
    [aux_sym_call_repeat1] = STATE(12221),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(11139),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_when] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [12222] = {
    [sym_heredoc_body] = STATE(12221),
    [aux_sym_call_repeat1] = STATE(12221),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_when] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [12223] = {
    [aux_sym_argument_list_repeat1] = STATE(12223),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17510),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [12224] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(6999),
    [anon_sym_when] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12225] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12226] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12227] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17513),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12228] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12229] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12230] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(7119),
    [anon_sym_when] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12231] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12232] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12233] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12234] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_EQ_GT] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12235] = {
    [aux_sym_chained_string_repeat1] = STATE(12235),
    [sym_string] = STATE(12235),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(11147),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_EQ_GT] = ACTIONS(7123),
    [anon_sym_when] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [12236] = {
    [sym_assignment] = STATE(12429),
    [sym_unary] = STATE(12429),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8793),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12429),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(8793),
    [sym_operator_assignment] = STATE(12429),
    [sym_conditional] = STATE(12429),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(8791),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(8793),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(8795),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(8793),
    [sym_range] = STATE(12429),
    [sym_binary] = STATE(12429),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(8793),
    [sym_nil] = STATE(8793),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13332),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13324),
    [anon_sym_not] = ACTIONS(13334),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13338),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(13322),
    [anon_sym_TILDE] = ACTIONS(13324),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13340),
    [anon_sym_next] = ACTIONS(13342),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(13328),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13344),
  },
  [12237] = {
    [sym_assignment] = STATE(11741),
    [sym_unary] = STATE(11741),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(11741),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(11741),
    [sym_conditional] = STATE(11741),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_return] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_true] = STATE(8811),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(11741),
    [sym_binary] = STATE(11741),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(9967),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [sym_global_variable] = ACTIONS(13374),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13366),
    [sym_character] = ACTIONS(13370),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [12238] = {
    [aux_sym_exceptions_repeat1] = STATE(12430),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17515),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12239] = {
    [sym_assignment] = STATE(12431),
    [sym_unary] = STATE(12431),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(8811),
    [sym_singleton_class] = STATE(8813),
    [sym_module] = STATE(8813),
    [sym_chained_string] = STATE(8813),
    [sym_until] = STATE(8813),
    [sym_regex] = STATE(8813),
    [sym_for] = STATE(8813),
    [sym_symbol] = STATE(8813),
    [sym_if] = STATE(8813),
    [sym_begin] = STATE(8813),
    [sym__arg] = STATE(12431),
    [sym__primary] = STATE(8813),
    [sym_method_call] = STATE(8811),
    [sym_operator_assignment] = STATE(12431),
    [sym_conditional] = STATE(12431),
    [sym_method] = STATE(8813),
    [sym_singleton_method] = STATE(8813),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(8815),
    [sym_rational] = STATE(8813),
    [sym_true] = STATE(8811),
    [sym_return] = STATE(8813),
    [sym_subshell] = STATE(8813),
    [sym_yield] = STATE(8813),
    [sym_string] = STATE(8816),
    [sym_unless] = STATE(8813),
    [sym_lambda] = STATE(8813),
    [sym_parenthesized_statements] = STATE(8813),
    [sym_element_reference] = STATE(8811),
    [sym_range] = STATE(12431),
    [sym_binary] = STATE(12431),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8813),
    [sym_break] = STATE(8813),
    [sym_next] = STATE(8813),
    [sym_string_array] = STATE(8813),
    [sym_while] = STATE(8813),
    [sym_case] = STATE(8813),
    [sym_symbol_array] = STATE(8813),
    [sym_array] = STATE(8813),
    [sym_hash] = STATE(8813),
    [sym_false] = STATE(8811),
    [sym_nil] = STATE(8811),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13358),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13360),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13362),
    [anon_sym_not] = ACTIONS(13364),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13368),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13370),
    [anon_sym_PLUS] = ACTIONS(13372),
    [anon_sym_TILDE] = ACTIONS(13362),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(13370),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13376),
    [anon_sym_next] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13358),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13380),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(13358),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13382),
  },
  [12240] = {
    [aux_sym_exceptions_repeat1] = STATE(12240),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17517),
    [anon_sym_RPAREN] = ACTIONS(13577),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12241] = {
    [anon_sym_LT] = ACTIONS(13425),
    [anon_sym_SLASH] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_RPAREN] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_LT_LT] = ACTIONS(13433),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13431),
    [anon_sym_EQ_TILDE] = ACTIONS(13431),
    [anon_sym_PLUS] = ACTIONS(13439),
    [anon_sym_AMP] = ACTIONS(13441),
    [anon_sym_GT] = ACTIONS(13425),
    [anon_sym_PERCENT] = ACTIONS(13427),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(13427),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13431),
    [anon_sym_BANG_TILDE] = ACTIONS(13431),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13431),
    [anon_sym_STAR_STAR] = ACTIONS(13427),
    [anon_sym_PIPE] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(13447),
    [anon_sym_AMP_AMP] = ACTIONS(13431),
    [anon_sym_LT_EQ_GT] = ACTIONS(13431),
    [anon_sym_LT_EQ] = ACTIONS(13425),
    [sym__binary_minus] = ACTIONS(13439),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(13451),
  },
  [12242] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(8253),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [12243] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(8267),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [12244] = {
    [sym__argument] = STATE(6055),
    [sym_assignment] = STATE(10766),
    [sym_unary] = STATE(10766),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(6444),
    [sym_singleton_class] = STATE(1481),
    [sym_module] = STATE(1481),
    [sym_chained_string] = STATE(1481),
    [sym_until] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_for] = STATE(1481),
    [sym_symbol] = STATE(1481),
    [sym_if] = STATE(1481),
    [sym_begin] = STATE(1481),
    [sym__arg] = STATE(10766),
    [sym__primary] = STATE(1481),
    [sym_pair] = STATE(6055),
    [sym_method_call] = STATE(6444),
    [sym_splat_argument] = STATE(6055),
    [sym_hash_splat_argument] = STATE(6055),
    [sym_operator_assignment] = STATE(10766),
    [sym_conditional] = STATE(10766),
    [sym_method] = STATE(1481),
    [sym_singleton_method] = STATE(1481),
    [sym__variable] = STATE(3689),
    [sym_left_assignment_list] = STATE(6442),
    [sym_return] = STATE(1481),
    [sym_yield] = STATE(1481),
    [sym_string] = STATE(10767),
    [sym_rational] = STATE(1481),
    [sym_subshell] = STATE(1481),
    [sym_true] = STATE(6444),
    [sym_unless] = STATE(1481),
    [sym_lambda] = STATE(1481),
    [sym_parenthesized_statements] = STATE(1481),
    [sym_element_reference] = STATE(6444),
    [sym_block_argument] = STATE(6055),
    [sym_range] = STATE(10766),
    [sym_binary] = STATE(10766),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1481),
    [sym_break] = STATE(1481),
    [sym_next] = STATE(1481),
    [sym_string_array] = STATE(1481),
    [sym_while] = STATE(1481),
    [sym_case] = STATE(1481),
    [sym_symbol_array] = STATE(1481),
    [sym_array] = STATE(1481),
    [sym_hash] = STATE(1481),
    [sym_false] = STATE(6444),
    [sym_nil] = STATE(6444),
    [sym_scope_resolution] = STATE(3689),
    [sym_call] = STATE(3689),
    [sym_float] = ACTIONS(2593),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(6179),
    [sym_heredoc_beginning] = ACTIONS(2597),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(10316),
    [anon_sym_TILDE] = ACTIONS(10318),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(2597),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(6179),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(15574),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(6187),
    [anon_sym_defined_QMARK] = ACTIONS(10324),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(2609),
    [sym__identifier_hash_key] = ACTIONS(15576),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15574),
    [anon_sym_yield] = ACTIONS(10328),
    [sym_class_variable] = ACTIONS(6187),
    [sym__block_ampersand] = ACTIONS(15578),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(10332),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(10338),
    [sym_global_variable] = ACTIONS(6187),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(10340),
    [anon_sym_next] = ACTIONS(10342),
    [sym_retry] = ACTIONS(2593),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17318),
    [sym_redo] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(10318),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(10346),
  },
  [12245] = {
    [sym_heredoc_body] = STATE(12245),
    [aux_sym_call_repeat1] = STATE(12245),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_then] = ACTIONS(9774),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [12246] = {
    [sym_heredoc_body] = STATE(12245),
    [aux_sym_call_repeat1] = STATE(12245),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_then] = ACTIONS(9781),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [12247] = {
    [aux_sym_argument_list_repeat1] = STATE(12247),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_then] = ACTIONS(8457),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17520),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [12248] = {
    [sym_assignment] = STATE(11790),
    [sym_unary] = STATE(11790),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(11790),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11790),
    [sym_conditional] = STATE(11790),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_return] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_true] = STATE(9017),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(11790),
    [sym_binary] = STATE(11790),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(15580),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [sym_global_variable] = ACTIONS(13374),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13366),
    [sym_character] = ACTIONS(5728),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [12249] = {
    [aux_sym_exceptions_repeat1] = STATE(12432),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_then] = ACTIONS(10973),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17523),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [12250] = {
    [sym_assignment] = STATE(12433),
    [sym_unary] = STATE(12433),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9017),
    [sym_singleton_class] = STATE(3415),
    [sym_module] = STATE(3415),
    [sym_chained_string] = STATE(3415),
    [sym_until] = STATE(3415),
    [sym_regex] = STATE(3415),
    [sym_for] = STATE(3415),
    [sym_symbol] = STATE(3415),
    [sym_if] = STATE(3415),
    [sym_begin] = STATE(3415),
    [sym__arg] = STATE(12433),
    [sym__primary] = STATE(3415),
    [sym_method_call] = STATE(9017),
    [sym_operator_assignment] = STATE(12433),
    [sym_conditional] = STATE(12433),
    [sym_method] = STATE(3415),
    [sym_singleton_method] = STATE(3415),
    [sym__variable] = STATE(8814),
    [sym_left_assignment_list] = STATE(9019),
    [sym_rational] = STATE(3415),
    [sym_true] = STATE(9017),
    [sym_return] = STATE(3415),
    [sym_subshell] = STATE(3415),
    [sym_yield] = STATE(3415),
    [sym_string] = STATE(9020),
    [sym_unless] = STATE(3415),
    [sym_lambda] = STATE(3415),
    [sym_parenthesized_statements] = STATE(3415),
    [sym_element_reference] = STATE(9017),
    [sym_range] = STATE(12433),
    [sym_binary] = STATE(12433),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3415),
    [sym_break] = STATE(3415),
    [sym_next] = STATE(3415),
    [sym_string_array] = STATE(3415),
    [sym_while] = STATE(3415),
    [sym_case] = STATE(3415),
    [sym_symbol_array] = STATE(3415),
    [sym_array] = STATE(3415),
    [sym_hash] = STATE(3415),
    [sym_false] = STATE(9017),
    [sym_nil] = STATE(9017),
    [sym_scope_resolution] = STATE(8814),
    [sym_call] = STATE(8814),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(5714),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13509),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13511),
    [anon_sym_not] = ACTIONS(13513),
    [sym_self] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13515),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(5728),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(13517),
    [anon_sym_TILDE] = ACTIONS(13511),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13374),
    [sym_character] = ACTIONS(5728),
    [sym_super] = ACTIONS(13366),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13519),
    [anon_sym_next] = ACTIONS(13521),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(5714),
    [sym_constant] = ACTIONS(13366),
    [anon_sym_defined_QMARK] = ACTIONS(13523),
    [sym_instance_variable] = ACTIONS(13374),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(5740),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13366),
    [sym_redo] = ACTIONS(5714),
    [sym_class_variable] = ACTIONS(13374),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13525),
  },
  [12251] = {
    [aux_sym_exceptions_repeat1] = STATE(12251),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17525),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12252] = {
    [anon_sym_LT] = ACTIONS(13539),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(13541),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13543),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13547),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13549),
    [anon_sym_LT_LT] = ACTIONS(13547),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13545),
    [anon_sym_EQ_TILDE] = ACTIONS(13545),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13555),
    [anon_sym_GT] = ACTIONS(13539),
    [anon_sym_PERCENT] = ACTIONS(13541),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(13541),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13557),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13545),
    [anon_sym_BANG_TILDE] = ACTIONS(13545),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13559),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13545),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_PIPE] = ACTIONS(13563),
    [anon_sym_DOT_DOT] = ACTIONS(13561),
    [anon_sym_AMP_AMP] = ACTIONS(13545),
    [anon_sym_LT_EQ_GT] = ACTIONS(13545),
    [anon_sym_LT_EQ] = ACTIONS(13539),
    [sym__binary_minus] = ACTIONS(13553),
    [anon_sym_CARET] = ACTIONS(13565),
  },
  [12253] = {
    [aux_sym_exceptions_repeat1] = STATE(12253),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17528),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12254] = {
    [anon_sym_LT] = ACTIONS(13598),
    [anon_sym_SLASH] = ACTIONS(13600),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13604),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_LT_LT] = ACTIONS(13604),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13608),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(13608),
    [anon_sym_AMP] = ACTIONS(13610),
    [anon_sym_GT] = ACTIONS(13598),
    [anon_sym_PLUS] = ACTIONS(13612),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(13600),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(13600),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13614),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(13608),
    [anon_sym_PIPE_PIPE] = ACTIONS(13608),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13616),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13608),
    [anon_sym_STAR_STAR] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(13618),
    [anon_sym_DOT_DOT] = ACTIONS(13620),
    [anon_sym_AMP_AMP] = ACTIONS(13608),
    [anon_sym_LT_EQ_GT] = ACTIONS(13608),
    [anon_sym_LT_EQ] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(13622),
    [sym__binary_minus] = ACTIONS(13612),
  },
  [12255] = {
    [anon_sym_LT] = ACTIONS(13654),
    [anon_sym_SLASH] = ACTIONS(13656),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13664),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(13664),
    [anon_sym_AMP] = ACTIONS(13666),
    [anon_sym_GT] = ACTIONS(13654),
    [anon_sym_PLUS] = ACTIONS(13668),
    [anon_sym_PERCENT] = ACTIONS(13656),
    [sym__binary_star] = ACTIONS(13656),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(13670),
    [anon_sym_BANG_TILDE] = ACTIONS(13664),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13672),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13664),
    [anon_sym_STAR_STAR] = ACTIONS(13656),
    [anon_sym_PIPE] = ACTIONS(13674),
    [anon_sym_DOT_DOT] = ACTIONS(13676),
    [anon_sym_AMP_AMP] = ACTIONS(13664),
    [anon_sym_LT_EQ_GT] = ACTIONS(13664),
    [anon_sym_LT_EQ] = ACTIONS(13654),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(13678),
    [sym__binary_minus] = ACTIONS(13668),
  },
  [12256] = {
    [aux_sym_exceptions_repeat1] = STATE(12256),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17531),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_ensure] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12257] = {
    [anon_sym_SLASH] = ACTIONS(13688),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13690),
    [anon_sym_EQ_TILDE] = ACTIONS(13690),
    [anon_sym_LT_LT] = ACTIONS(13692),
    [sym__binary_star] = ACTIONS(13694),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(13696),
    [anon_sym_AMP] = ACTIONS(13698),
    [anon_sym_PERCENT] = ACTIONS(13688),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(13690),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(13700),
    [anon_sym_PIPE] = ACTIONS(13702),
    [anon_sym_DOT_DOT] = ACTIONS(13704),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(13700),
    [anon_sym_QMARK] = ACTIONS(13706),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13692),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13708),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(13700),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(13710),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13710),
    [anon_sym_GT_EQ] = ACTIONS(13712),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_ensure] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13690),
    [anon_sym_STAR_STAR] = ACTIONS(13688),
    [anon_sym_LT_EQ_GT] = ACTIONS(13690),
    [anon_sym_AMP_AMP] = ACTIONS(13710),
    [sym__binary_minus] = ACTIONS(13714),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(13702),
  },
  [12258] = {
    [sym_heredoc_body] = STATE(12258),
    [aux_sym_call_repeat1] = STATE(12258),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_elsif] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [12259] = {
    [sym_heredoc_body] = STATE(12258),
    [aux_sym_call_repeat1] = STATE(12258),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_elsif] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [12260] = {
    [sym_assignment] = STATE(11840),
    [sym_unary] = STATE(11840),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(11840),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(11840),
    [sym_conditional] = STATE(11840),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_return] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_true] = STATE(9306),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(11840),
    [sym_binary] = STATE(11840),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(10825),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [sym_global_variable] = ACTIONS(6646),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(6638),
    [sym_character] = ACTIONS(6640),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [12261] = {
    [aux_sym_exceptions_repeat1] = STATE(12434),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17534),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_elsif] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [12262] = {
    [sym_assignment] = STATE(12435),
    [sym_unary] = STATE(12435),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9306),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(12435),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9306),
    [sym_operator_assignment] = STATE(12435),
    [sym_conditional] = STATE(12435),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9308),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9306),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9306),
    [sym_range] = STATE(12435),
    [sym_binary] = STATE(12435),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9306),
    [sym_nil] = STATE(9306),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13785),
    [anon_sym_not] = ACTIONS(13787),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13791),
    [anon_sym_TILDE] = ACTIONS(13785),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13793),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13797),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [12263] = {
    [aux_sym_exceptions_repeat1] = STATE(12263),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17536),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12264] = {
    [anon_sym_LT] = ACTIONS(13807),
    [anon_sym_SLASH] = ACTIONS(13809),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13811),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13813),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13815),
    [anon_sym_LT_LT] = ACTIONS(13813),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13817),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(13817),
    [anon_sym_AMP] = ACTIONS(13819),
    [anon_sym_GT] = ACTIONS(13807),
    [anon_sym_PLUS] = ACTIONS(13821),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(13809),
    [sym__binary_star] = ACTIONS(13809),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(13823),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(13817),
    [anon_sym_PIPE_PIPE] = ACTIONS(13817),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(13825),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13817),
    [anon_sym_STAR_STAR] = ACTIONS(13809),
    [anon_sym_PIPE] = ACTIONS(13827),
    [anon_sym_DOT_DOT] = ACTIONS(13829),
    [anon_sym_AMP_AMP] = ACTIONS(13817),
    [anon_sym_LT_EQ_GT] = ACTIONS(13817),
    [anon_sym_LT_EQ] = ACTIONS(13807),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(13831),
    [sym__binary_minus] = ACTIONS(13821),
  },
  [12265] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_elsif] = ACTIONS(9736),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12266] = {
    [sym_assignment] = STATE(12436),
    [sym_unary] = STATE(12436),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9355),
    [sym_singleton_class] = STATE(3955),
    [sym_module] = STATE(3955),
    [sym_chained_string] = STATE(3955),
    [sym_until] = STATE(3955),
    [sym_regex] = STATE(3955),
    [sym_for] = STATE(3955),
    [sym_symbol] = STATE(3955),
    [sym_if] = STATE(3955),
    [sym_begin] = STATE(3955),
    [sym__arg] = STATE(12436),
    [sym__primary] = STATE(3955),
    [sym_method_call] = STATE(9355),
    [sym_operator_assignment] = STATE(12436),
    [sym_conditional] = STATE(12436),
    [sym_method] = STATE(3955),
    [sym_singleton_method] = STATE(3955),
    [sym__variable] = STATE(3957),
    [sym_left_assignment_list] = STATE(9357),
    [sym_rational] = STATE(3955),
    [sym_true] = STATE(9355),
    [sym_return] = STATE(3955),
    [sym_subshell] = STATE(3955),
    [sym_yield] = STATE(3955),
    [sym_string] = STATE(9309),
    [sym_unless] = STATE(3955),
    [sym_lambda] = STATE(3955),
    [sym_parenthesized_statements] = STATE(3955),
    [sym_element_reference] = STATE(9355),
    [sym_range] = STATE(12436),
    [sym_binary] = STATE(12436),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(3955),
    [sym_break] = STATE(3955),
    [sym_next] = STATE(3955),
    [sym_string_array] = STATE(3955),
    [sym_while] = STATE(3955),
    [sym_case] = STATE(3955),
    [sym_symbol_array] = STATE(3955),
    [sym_array] = STATE(3955),
    [sym_hash] = STATE(3955),
    [sym_false] = STATE(9355),
    [sym_nil] = STATE(9355),
    [sym_scope_resolution] = STATE(3957),
    [sym_call] = STATE(3957),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(6634),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13783),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(13865),
    [anon_sym_not] = ACTIONS(13867),
    [sym_self] = ACTIONS(6638),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(13789),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(6640),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(13871),
    [anon_sym_TILDE] = ACTIONS(13865),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(6646),
    [sym_character] = ACTIONS(6640),
    [sym_super] = ACTIONS(6638),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(13873),
    [anon_sym_next] = ACTIONS(13795),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(6634),
    [sym_constant] = ACTIONS(6638),
    [anon_sym_defined_QMARK] = ACTIONS(13875),
    [sym_instance_variable] = ACTIONS(6646),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(6638),
    [sym_redo] = ACTIONS(6634),
    [sym_class_variable] = ACTIONS(6646),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(13799),
  },
  [12267] = {
    [sym_assignment] = STATE(11880),
    [sym_unary] = STATE(11880),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(11880),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(11880),
    [sym_conditional] = STATE(11880),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_return] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_true] = STATE(9371),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(11880),
    [sym_binary] = STATE(11880),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(10881),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [sym_global_variable] = ACTIONS(13899),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13891),
    [sym_character] = ACTIONS(13895),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [12268] = {
    [aux_sym_exceptions_repeat1] = STATE(12437),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17539),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_elsif] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12269] = {
    [sym_assignment] = STATE(12438),
    [sym_unary] = STATE(12438),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(9371),
    [sym_singleton_class] = STATE(9373),
    [sym_module] = STATE(9373),
    [sym_chained_string] = STATE(9373),
    [sym_until] = STATE(9373),
    [sym_regex] = STATE(9373),
    [sym_for] = STATE(9373),
    [sym_symbol] = STATE(9373),
    [sym_if] = STATE(9373),
    [sym_begin] = STATE(9373),
    [sym__arg] = STATE(12438),
    [sym__primary] = STATE(9373),
    [sym_method_call] = STATE(9371),
    [sym_operator_assignment] = STATE(12438),
    [sym_conditional] = STATE(12438),
    [sym_method] = STATE(9373),
    [sym_singleton_method] = STATE(9373),
    [sym__variable] = STATE(9374),
    [sym_left_assignment_list] = STATE(9375),
    [sym_rational] = STATE(9373),
    [sym_true] = STATE(9371),
    [sym_return] = STATE(9373),
    [sym_subshell] = STATE(9373),
    [sym_yield] = STATE(9373),
    [sym_string] = STATE(9376),
    [sym_unless] = STATE(9373),
    [sym_lambda] = STATE(9373),
    [sym_parenthesized_statements] = STATE(9373),
    [sym_element_reference] = STATE(9371),
    [sym_range] = STATE(12438),
    [sym_binary] = STATE(12438),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(9373),
    [sym_break] = STATE(9373),
    [sym_next] = STATE(9373),
    [sym_string_array] = STATE(9373),
    [sym_while] = STATE(9373),
    [sym_case] = STATE(9373),
    [sym_symbol_array] = STATE(9373),
    [sym_array] = STATE(9373),
    [sym_hash] = STATE(9373),
    [sym_false] = STATE(9371),
    [sym_nil] = STATE(9371),
    [sym_scope_resolution] = STATE(9374),
    [sym_call] = STATE(9374),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(13883),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(13885),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(13887),
    [anon_sym_not] = ACTIONS(13889),
    [sym_self] = ACTIONS(13891),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(13893),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13895),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(13895),
    [anon_sym_PLUS] = ACTIONS(13897),
    [anon_sym_TILDE] = ACTIONS(13887),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13899),
    [sym_character] = ACTIONS(13895),
    [sym_super] = ACTIONS(13891),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(13901),
    [anon_sym_next] = ACTIONS(13903),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(13883),
    [sym_constant] = ACTIONS(13891),
    [anon_sym_defined_QMARK] = ACTIONS(13905),
    [sym_instance_variable] = ACTIONS(13899),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(6650),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(13891),
    [sym_redo] = ACTIONS(13883),
    [sym_class_variable] = ACTIONS(13899),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(13907),
  },
  [12270] = {
    [aux_sym_exceptions_repeat1] = STATE(12270),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17541),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12271] = {
    [anon_sym_SLASH] = ACTIONS(13917),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13919),
    [anon_sym_EQ_TILDE] = ACTIONS(13919),
    [anon_sym_LT_LT] = ACTIONS(13921),
    [sym__binary_star] = ACTIONS(13923),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(13925),
    [anon_sym_AMP] = ACTIONS(13927),
    [anon_sym_PERCENT] = ACTIONS(13917),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(13919),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(13933),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(13929),
    [anon_sym_QMARK] = ACTIONS(13935),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13921),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13937),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(13929),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(13939),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(13939),
    [anon_sym_GT_EQ] = ACTIONS(13941),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(13919),
    [anon_sym_STAR_STAR] = ACTIONS(13917),
    [anon_sym_LT_EQ_GT] = ACTIONS(13919),
    [anon_sym_AMP_AMP] = ACTIONS(13939),
    [sym__binary_minus] = ACTIONS(13943),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(13931),
  },
  [12272] = {
    [anon_sym_LT] = ACTIONS(13993),
    [anon_sym_SLASH] = ACTIONS(13995),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(13997),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(13999),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14001),
    [anon_sym_LT_LT] = ACTIONS(13999),
    [anon_sym_RBRACE] = ACTIONS(14222),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14003),
    [anon_sym_AMP] = ACTIONS(14005),
    [anon_sym_EQ_TILDE] = ACTIONS(14003),
    [anon_sym_GT] = ACTIONS(13993),
    [anon_sym_PLUS] = ACTIONS(14007),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(13995),
    [sym__binary_star] = ACTIONS(13995),
    [anon_sym_EQ_EQ] = ACTIONS(14009),
    [anon_sym_BANG_TILDE] = ACTIONS(14003),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14003),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14011),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14003),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_PIPE] = ACTIONS(14013),
    [anon_sym_DOT_DOT] = ACTIONS(14015),
    [anon_sym_AMP_AMP] = ACTIONS(14003),
    [anon_sym_LT_EQ_GT] = ACTIONS(14003),
    [anon_sym_LT_EQ] = ACTIONS(13993),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14017),
    [sym__binary_minus] = ACTIONS(14007),
  },
  [12273] = {
    [anon_sym_SLASH] = ACTIONS(16492),
    [sym__line_break] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_AMP_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT_EQ] = ACTIONS(16494),
    [anon_sym_SLASH_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16492),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16492),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16492),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_PERCENT_EQ] = ACTIONS(16494),
    [anon_sym_LT_LT_EQ] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [anon_sym_else] = ACTIONS(16494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_CARET_EQ] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_EQ] = ACTIONS(16492),
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_then] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16492),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_when] = ACTIONS(16494),
    [anon_sym_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_PLUS_EQ] = ACTIONS(16494),
    [anon_sym_STAR_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym___END__] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16492),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_end] = ACTIONS(16494),
    [anon_sym_ensure] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_elsif] = ACTIONS(16494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16494),
    [ts_builtin_sym_end] = ACTIONS(16494),
    [anon_sym_DASH_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16492),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [anon_sym_AMP_AMP] = ACTIONS(16492),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16492),
  },
  [12274] = {
    [aux_sym_exceptions_repeat1] = STATE(12274),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17544),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12275] = {
    [anon_sym_LT] = ACTIONS(14132),
    [anon_sym_SLASH] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(14136),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14138),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14140),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14142),
    [anon_sym_LT_LT] = ACTIONS(14138),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14140),
    [sym__binary_star] = ACTIONS(14134),
    [anon_sym_PLUS] = ACTIONS(14144),
    [anon_sym_AMP] = ACTIONS(14146),
    [anon_sym_GT] = ACTIONS(14132),
    [anon_sym_PERCENT] = ACTIONS(14134),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(15271),
    [anon_sym_PIPE_PIPE] = ACTIONS(14140),
    [anon_sym_BANG_TILDE] = ACTIONS(14140),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14150),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14140),
    [anon_sym_STAR_STAR] = ACTIONS(14134),
    [anon_sym_PIPE] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(14154),
    [anon_sym_AMP_AMP] = ACTIONS(14140),
    [anon_sym_LT_EQ_GT] = ACTIONS(14140),
    [anon_sym_LT_EQ] = ACTIONS(14132),
    [sym__binary_minus] = ACTIONS(14144),
    [anon_sym_CARET] = ACTIONS(14156),
  },
  [12276] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9736),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12277] = {
    [anon_sym_LT] = ACTIONS(14190),
    [anon_sym_SLASH] = ACTIONS(14192),
    [anon_sym_QMARK] = ACTIONS(14194),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14200),
    [anon_sym_LT_LT] = ACTIONS(14196),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14198),
    [sym__binary_star] = ACTIONS(14192),
    [anon_sym_PLUS] = ACTIONS(14202),
    [anon_sym_AMP] = ACTIONS(14204),
    [anon_sym_GT] = ACTIONS(14190),
    [anon_sym_PERCENT] = ACTIONS(14192),
    [anon_sym_EQ_EQ] = ACTIONS(14206),
    [anon_sym_BANG_TILDE] = ACTIONS(14198),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14198),
    [anon_sym_GT_EQ] = ACTIONS(14208),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14198),
    [anon_sym_STAR_STAR] = ACTIONS(14192),
    [anon_sym_PIPE] = ACTIONS(14210),
    [anon_sym_DOT_DOT] = ACTIONS(14212),
    [anon_sym_AMP_AMP] = ACTIONS(14198),
    [anon_sym_LT_EQ_GT] = ACTIONS(14198),
    [anon_sym_LT_EQ] = ACTIONS(14190),
    [sym__binary_minus] = ACTIONS(14202),
    [anon_sym_CARET] = ACTIONS(14214),
  },
  [12278] = {
    [aux_sym_exceptions_repeat1] = STATE(12278),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17547),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_COLON2] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12279] = {
    [anon_sym_LT] = ACTIONS(14234),
    [anon_sym_SLASH] = ACTIONS(14236),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14238),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14244),
    [anon_sym_LT_LT] = ACTIONS(14240),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14242),
    [sym__binary_star] = ACTIONS(14246),
    [anon_sym_PLUS] = ACTIONS(14248),
    [anon_sym_AMP] = ACTIONS(14250),
    [anon_sym_GT] = ACTIONS(14234),
    [anon_sym_PERCENT] = ACTIONS(14236),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(14252),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_COLON2] = ACTIONS(15271),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14252),
    [anon_sym_BANG_TILDE] = ACTIONS(14242),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14254),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14242),
    [anon_sym_STAR_STAR] = ACTIONS(14236),
    [anon_sym_PIPE] = ACTIONS(14256),
    [anon_sym_DOT_DOT] = ACTIONS(14258),
    [anon_sym_AMP_AMP] = ACTIONS(14252),
    [anon_sym_LT_EQ_GT] = ACTIONS(14242),
    [anon_sym_LT_EQ] = ACTIONS(14234),
    [sym__binary_minus] = ACTIONS(14260),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(14256),
  },
  [12280] = {
    [aux_sym_exceptions_repeat1] = STATE(12280),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17550),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12281] = {
    [anon_sym_LT] = ACTIONS(14278),
    [anon_sym_SLASH] = ACTIONS(14280),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14282),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14284),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14286),
    [anon_sym_LT_LT] = ACTIONS(14284),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14288),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14288),
    [anon_sym_AMP] = ACTIONS(14290),
    [anon_sym_GT] = ACTIONS(14278),
    [anon_sym_PLUS] = ACTIONS(14292),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(14280),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(14280),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(14294),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(14288),
    [anon_sym_PIPE_PIPE] = ACTIONS(14288),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14296),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14288),
    [anon_sym_STAR_STAR] = ACTIONS(14280),
    [anon_sym_PIPE] = ACTIONS(14298),
    [anon_sym_DOT_DOT] = ACTIONS(14300),
    [anon_sym_AMP_AMP] = ACTIONS(14288),
    [anon_sym_LT_EQ_GT] = ACTIONS(14288),
    [anon_sym_LT_EQ] = ACTIONS(14278),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14302),
    [sym__binary_minus] = ACTIONS(14292),
  },
  [12282] = {
    [anon_sym_LT] = ACTIONS(14334),
    [anon_sym_SLASH] = ACTIONS(14336),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14338),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14340),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14342),
    [anon_sym_LT_LT] = ACTIONS(14340),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14344),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14344),
    [anon_sym_AMP] = ACTIONS(14346),
    [anon_sym_GT] = ACTIONS(14334),
    [anon_sym_PLUS] = ACTIONS(14348),
    [anon_sym_PERCENT] = ACTIONS(14336),
    [sym__binary_star] = ACTIONS(14336),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(14350),
    [anon_sym_BANG_TILDE] = ACTIONS(14344),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14344),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14352),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14344),
    [anon_sym_STAR_STAR] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(14354),
    [anon_sym_DOT_DOT] = ACTIONS(14356),
    [anon_sym_AMP_AMP] = ACTIONS(14344),
    [anon_sym_LT_EQ_GT] = ACTIONS(14344),
    [anon_sym_LT_EQ] = ACTIONS(14334),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14358),
    [sym__binary_minus] = ACTIONS(14348),
  },
  [12283] = {
    [aux_sym_exceptions_repeat1] = STATE(12283),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17553),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12284] = {
    [anon_sym_SLASH] = ACTIONS(14368),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14370),
    [anon_sym_EQ_TILDE] = ACTIONS(14370),
    [anon_sym_LT_LT] = ACTIONS(14372),
    [sym__binary_star] = ACTIONS(14374),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(14376),
    [anon_sym_AMP] = ACTIONS(14378),
    [anon_sym_PERCENT] = ACTIONS(14368),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(14370),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(14380),
    [anon_sym_PIPE] = ACTIONS(14382),
    [anon_sym_DOT_DOT] = ACTIONS(14384),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(14380),
    [anon_sym_QMARK] = ACTIONS(14386),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14372),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14388),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(14380),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(14390),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14390),
    [anon_sym_GT_EQ] = ACTIONS(14392),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14370),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_LT_EQ_GT] = ACTIONS(14370),
    [sym__binary_minus] = ACTIONS(14394),
    [anon_sym_AMP_AMP] = ACTIONS(14390),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14382),
  },
  [12285] = {
    [aux_sym_exceptions_repeat1] = STATE(12285),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17556),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12286] = {
    [anon_sym_LT] = ACTIONS(14459),
    [anon_sym_SLASH] = ACTIONS(14461),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14463),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14467),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14469),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14469),
    [anon_sym_AMP] = ACTIONS(14471),
    [anon_sym_GT] = ACTIONS(14459),
    [anon_sym_PLUS] = ACTIONS(14473),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(14461),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(14461),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(14475),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(14469),
    [anon_sym_PIPE_PIPE] = ACTIONS(14469),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14477),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14469),
    [anon_sym_STAR_STAR] = ACTIONS(14461),
    [anon_sym_PIPE] = ACTIONS(14479),
    [anon_sym_DOT_DOT] = ACTIONS(14481),
    [anon_sym_AMP_AMP] = ACTIONS(14469),
    [anon_sym_LT_EQ_GT] = ACTIONS(14469),
    [anon_sym_LT_EQ] = ACTIONS(14459),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14483),
    [sym__binary_minus] = ACTIONS(14473),
  },
  [12287] = {
    [anon_sym_LT] = ACTIONS(14517),
    [anon_sym_SLASH] = ACTIONS(14519),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14521),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14523),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14525),
    [anon_sym_LT_LT] = ACTIONS(14523),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14527),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14527),
    [anon_sym_AMP] = ACTIONS(14529),
    [anon_sym_GT] = ACTIONS(14517),
    [anon_sym_PLUS] = ACTIONS(14531),
    [anon_sym_PERCENT] = ACTIONS(14519),
    [sym__binary_star] = ACTIONS(14519),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(14533),
    [anon_sym_BANG_TILDE] = ACTIONS(14527),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14527),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14535),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(14527),
    [anon_sym_STAR_STAR] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(14537),
    [anon_sym_DOT_DOT] = ACTIONS(14539),
    [anon_sym_AMP_AMP] = ACTIONS(14527),
    [anon_sym_LT_EQ_GT] = ACTIONS(14527),
    [anon_sym_LT_EQ] = ACTIONS(14517),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14541),
    [sym__binary_minus] = ACTIONS(14531),
  },
  [12288] = {
    [aux_sym_exceptions_repeat1] = STATE(12288),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17559),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12289] = {
    [anon_sym_SLASH] = ACTIONS(14551),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14553),
    [anon_sym_EQ_TILDE] = ACTIONS(14553),
    [anon_sym_LT_LT] = ACTIONS(14555),
    [sym__binary_star] = ACTIONS(14557),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(14559),
    [anon_sym_AMP] = ACTIONS(14561),
    [anon_sym_PERCENT] = ACTIONS(14551),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(14553),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(14563),
    [anon_sym_PIPE] = ACTIONS(14565),
    [anon_sym_DOT_DOT] = ACTIONS(14567),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(14563),
    [anon_sym_QMARK] = ACTIONS(14569),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14555),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14571),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(14563),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(14573),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14573),
    [anon_sym_GT_EQ] = ACTIONS(14575),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14553),
    [anon_sym_STAR_STAR] = ACTIONS(14551),
    [anon_sym_LT_EQ_GT] = ACTIONS(14553),
    [anon_sym_AMP_AMP] = ACTIONS(14573),
    [sym__binary_minus] = ACTIONS(14577),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(14565),
  },
  [12290] = {
    [anon_sym_SLASH] = ACTIONS(15289),
    [anon_sym_RBRACK] = ACTIONS(15291),
    [anon_sym_until] = ACTIONS(15291),
    [anon_sym_AMP_EQ] = ACTIONS(15291),
    [anon_sym_GT_GT_EQ] = ACTIONS(15291),
    [anon_sym_SLASH_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15291),
    [anon_sym_RPAREN] = ACTIONS(15291),
    [anon_sym_EQ_TILDE] = ACTIONS(15291),
    [anon_sym_LT_LT] = ACTIONS(15289),
    [anon_sym_RBRACE] = ACTIONS(15291),
    [sym__binary_star] = ACTIONS(15291),
    [anon_sym_unless] = ACTIONS(15291),
    [anon_sym_PLUS] = ACTIONS(15289),
    [anon_sym_AMP] = ACTIONS(15289),
    [anon_sym_PERCENT] = ACTIONS(15289),
    [anon_sym_COLON_COLON2] = ACTIONS(15291),
    [anon_sym_rescue] = ACTIONS(15291),
    [anon_sym_PERCENT_EQ] = ACTIONS(15291),
    [anon_sym_LT_LT_EQ] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_DOT] = ACTIONS(15289),
    [anon_sym_BANG_TILDE] = ACTIONS(15291),
    [anon_sym_LBRACE] = ACTIONS(15291),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_while] = ACTIONS(15291),
    [sym__heredoc_body_start] = ACTIONS(15291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15291),
    [anon_sym_CARET_EQ] = ACTIONS(15291),
    [anon_sym_AMP_DOT] = ACTIONS(15291),
    [anon_sym_LT_EQ] = ACTIONS(15289),
    [anon_sym_PIPE] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(15289),
    [anon_sym_EQ] = ACTIONS(15289),
    [anon_sym_LT] = ACTIONS(15289),
    [anon_sym_in] = ACTIONS(15291),
    [anon_sym_QMARK] = ACTIONS(15291),
    [anon_sym_COMMA] = ACTIONS(15291),
    [anon_sym_GT_GT] = ACTIONS(15289),
    [anon_sym_SEMI] = ACTIONS(15291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15291),
    [anon_sym_or] = ACTIONS(15291),
    [anon_sym_GT] = ACTIONS(15289),
    [anon_sym_PIPE_EQ] = ACTIONS(15291),
    [anon_sym_PLUS_EQ] = ACTIONS(15291),
    [anon_sym_STAR_EQ] = ACTIONS(15291),
    [anon_sym_EQ_EQ] = ACTIONS(15289),
    [anon_sym_and] = ACTIONS(15291),
    [anon_sym_PIPE_PIPE] = ACTIONS(15289),
    [anon_sym_GT_EQ] = ACTIONS(15291),
    [anon_sym_LBRACK] = ACTIONS(15291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15291),
    [anon_sym_DASH_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15291),
    [anon_sym_BANG_EQ] = ACTIONS(15291),
    [anon_sym_STAR_STAR] = ACTIONS(15289),
    [anon_sym_LT_EQ_GT] = ACTIONS(15291),
    [sym__binary_minus] = ACTIONS(15291),
    [anon_sym_AMP_AMP] = ACTIONS(15289),
    [anon_sym_if] = ACTIONS(15291),
    [anon_sym_CARET] = ACTIONS(15289),
  },
  [12291] = {
    [anon_sym_end] = ACTIONS(17562),
    [sym_comment] = ACTIONS(49),
  },
  [12292] = {
    [anon_sym_SLASH] = ACTIONS(15829),
    [anon_sym_RBRACK] = ACTIONS(15831),
    [anon_sym_until] = ACTIONS(15831),
    [anon_sym_AMP_EQ] = ACTIONS(15831),
    [anon_sym_GT_GT_EQ] = ACTIONS(15831),
    [anon_sym_SLASH_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15831),
    [anon_sym_RPAREN] = ACTIONS(15831),
    [anon_sym_EQ_TILDE] = ACTIONS(15831),
    [anon_sym_LT_LT] = ACTIONS(15829),
    [anon_sym_RBRACE] = ACTIONS(15831),
    [sym__binary_star] = ACTIONS(15831),
    [anon_sym_unless] = ACTIONS(15831),
    [anon_sym_PLUS] = ACTIONS(15829),
    [anon_sym_AMP] = ACTIONS(15829),
    [anon_sym_PERCENT] = ACTIONS(15829),
    [anon_sym_COLON_COLON2] = ACTIONS(15831),
    [anon_sym_rescue] = ACTIONS(15831),
    [anon_sym_PERCENT_EQ] = ACTIONS(15831),
    [anon_sym_LT_LT_EQ] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_DOT] = ACTIONS(15829),
    [anon_sym_BANG_TILDE] = ACTIONS(15831),
    [anon_sym_LBRACE] = ACTIONS(15831),
    [anon_sym_COLON2] = ACTIONS(15829),
    [anon_sym_while] = ACTIONS(15831),
    [sym__heredoc_body_start] = ACTIONS(15831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15831),
    [anon_sym_CARET_EQ] = ACTIONS(15831),
    [anon_sym_AMP_DOT] = ACTIONS(15831),
    [anon_sym_LT_EQ] = ACTIONS(15829),
    [anon_sym_PIPE] = ACTIONS(15829),
    [anon_sym_DOT_DOT] = ACTIONS(15829),
    [anon_sym_EQ] = ACTIONS(15829),
    [anon_sym_LT] = ACTIONS(15829),
    [anon_sym_in] = ACTIONS(15831),
    [anon_sym_QMARK] = ACTIONS(15831),
    [anon_sym_COMMA] = ACTIONS(15831),
    [anon_sym_GT_GT] = ACTIONS(15829),
    [anon_sym_SEMI] = ACTIONS(15831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15831),
    [anon_sym_or] = ACTIONS(15831),
    [anon_sym_GT] = ACTIONS(15829),
    [anon_sym_PIPE_EQ] = ACTIONS(15831),
    [anon_sym_PLUS_EQ] = ACTIONS(15831),
    [anon_sym_STAR_EQ] = ACTIONS(15831),
    [anon_sym_EQ_EQ] = ACTIONS(15829),
    [anon_sym_and] = ACTIONS(15831),
    [anon_sym_PIPE_PIPE] = ACTIONS(15829),
    [anon_sym_GT_EQ] = ACTIONS(15831),
    [anon_sym_LBRACK] = ACTIONS(15831),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15831),
    [anon_sym_DASH_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15831),
    [anon_sym_BANG_EQ] = ACTIONS(15831),
    [anon_sym_STAR_STAR] = ACTIONS(15829),
    [anon_sym_LT_EQ_GT] = ACTIONS(15831),
    [sym__binary_minus] = ACTIONS(15831),
    [anon_sym_AMP_AMP] = ACTIONS(15829),
    [anon_sym_if] = ACTIONS(15831),
    [anon_sym_CARET] = ACTIONS(15829),
  },
  [12293] = {
    [anon_sym_SLASH] = ACTIONS(15674),
    [anon_sym_RBRACK] = ACTIONS(15676),
    [anon_sym_until] = ACTIONS(15676),
    [anon_sym_AMP_EQ] = ACTIONS(15676),
    [anon_sym_GT_GT_EQ] = ACTIONS(15676),
    [anon_sym_SLASH_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15676),
    [anon_sym_RPAREN] = ACTIONS(15676),
    [anon_sym_EQ_TILDE] = ACTIONS(15676),
    [anon_sym_LT_LT] = ACTIONS(15674),
    [anon_sym_RBRACE] = ACTIONS(15676),
    [sym__binary_star] = ACTIONS(15676),
    [anon_sym_unless] = ACTIONS(15676),
    [anon_sym_PLUS] = ACTIONS(15674),
    [anon_sym_AMP] = ACTIONS(15674),
    [anon_sym_PERCENT] = ACTIONS(15674),
    [anon_sym_COLON_COLON2] = ACTIONS(15676),
    [anon_sym_rescue] = ACTIONS(15676),
    [anon_sym_PERCENT_EQ] = ACTIONS(15676),
    [anon_sym_LT_LT_EQ] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_DOT] = ACTIONS(15674),
    [anon_sym_BANG_TILDE] = ACTIONS(15676),
    [anon_sym_LBRACE] = ACTIONS(15676),
    [anon_sym_COLON2] = ACTIONS(15674),
    [anon_sym_while] = ACTIONS(15676),
    [sym__heredoc_body_start] = ACTIONS(15676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15676),
    [anon_sym_CARET_EQ] = ACTIONS(15676),
    [anon_sym_AMP_DOT] = ACTIONS(15676),
    [anon_sym_LT_EQ] = ACTIONS(15674),
    [anon_sym_PIPE] = ACTIONS(15674),
    [anon_sym_DOT_DOT] = ACTIONS(15674),
    [anon_sym_EQ] = ACTIONS(15674),
    [anon_sym_LT] = ACTIONS(15674),
    [anon_sym_in] = ACTIONS(15676),
    [anon_sym_QMARK] = ACTIONS(15676),
    [anon_sym_COMMA] = ACTIONS(15676),
    [anon_sym_GT_GT] = ACTIONS(15674),
    [anon_sym_SEMI] = ACTIONS(15676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15676),
    [anon_sym_or] = ACTIONS(15676),
    [anon_sym_GT] = ACTIONS(15674),
    [anon_sym_PIPE_EQ] = ACTIONS(15676),
    [anon_sym_PLUS_EQ] = ACTIONS(15676),
    [anon_sym_STAR_EQ] = ACTIONS(15676),
    [anon_sym_EQ_EQ] = ACTIONS(15674),
    [anon_sym_and] = ACTIONS(15676),
    [anon_sym_PIPE_PIPE] = ACTIONS(15674),
    [anon_sym_GT_EQ] = ACTIONS(15676),
    [anon_sym_LBRACK] = ACTIONS(15676),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15676),
    [anon_sym_DASH_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15676),
    [anon_sym_BANG_EQ] = ACTIONS(15676),
    [anon_sym_STAR_STAR] = ACTIONS(15674),
    [anon_sym_LT_EQ_GT] = ACTIONS(15676),
    [sym__binary_minus] = ACTIONS(15676),
    [anon_sym_AMP_AMP] = ACTIONS(15674),
    [anon_sym_if] = ACTIONS(15676),
    [anon_sym_CARET] = ACTIONS(15674),
  },
  [12294] = {
    [anon_sym_SLASH] = ACTIONS(14594),
    [anon_sym_RBRACK] = ACTIONS(14596),
    [anon_sym_until] = ACTIONS(14596),
    [anon_sym_AMP_EQ] = ACTIONS(14596),
    [anon_sym_GT_GT_EQ] = ACTIONS(14596),
    [anon_sym_SLASH_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14596),
    [anon_sym_RPAREN] = ACTIONS(14596),
    [anon_sym_EQ_TILDE] = ACTIONS(14596),
    [anon_sym_LT_LT] = ACTIONS(14594),
    [anon_sym_RBRACE] = ACTIONS(14596),
    [sym__binary_star] = ACTIONS(14596),
    [anon_sym_unless] = ACTIONS(14596),
    [anon_sym_PLUS] = ACTIONS(14594),
    [anon_sym_AMP] = ACTIONS(14594),
    [anon_sym_PERCENT] = ACTIONS(14594),
    [anon_sym_COLON_COLON2] = ACTIONS(14596),
    [anon_sym_rescue] = ACTIONS(14596),
    [anon_sym_PERCENT_EQ] = ACTIONS(14596),
    [anon_sym_LT_LT_EQ] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_DOT] = ACTIONS(14594),
    [anon_sym_BANG_TILDE] = ACTIONS(14596),
    [anon_sym_LBRACE] = ACTIONS(14596),
    [anon_sym_COLON2] = ACTIONS(14594),
    [anon_sym_while] = ACTIONS(14596),
    [sym__heredoc_body_start] = ACTIONS(14596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14596),
    [anon_sym_CARET_EQ] = ACTIONS(14596),
    [anon_sym_AMP_DOT] = ACTIONS(14596),
    [anon_sym_LT_EQ] = ACTIONS(14594),
    [anon_sym_PIPE] = ACTIONS(14594),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_EQ] = ACTIONS(14594),
    [anon_sym_LT] = ACTIONS(14594),
    [anon_sym_in] = ACTIONS(14596),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_COMMA] = ACTIONS(14596),
    [anon_sym_GT_GT] = ACTIONS(14594),
    [anon_sym_SEMI] = ACTIONS(14596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_or] = ACTIONS(14596),
    [anon_sym_GT] = ACTIONS(14594),
    [anon_sym_PIPE_EQ] = ACTIONS(14596),
    [anon_sym_PLUS_EQ] = ACTIONS(14596),
    [anon_sym_STAR_EQ] = ACTIONS(14596),
    [anon_sym_EQ_EQ] = ACTIONS(14594),
    [anon_sym_and] = ACTIONS(14596),
    [anon_sym_PIPE_PIPE] = ACTIONS(14594),
    [anon_sym_GT_EQ] = ACTIONS(14596),
    [anon_sym_LBRACK] = ACTIONS(14596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14596),
    [anon_sym_DASH_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14596),
    [anon_sym_BANG_EQ] = ACTIONS(14596),
    [anon_sym_STAR_STAR] = ACTIONS(14594),
    [anon_sym_LT_EQ_GT] = ACTIONS(14596),
    [sym__binary_minus] = ACTIONS(14596),
    [anon_sym_AMP_AMP] = ACTIONS(14594),
    [anon_sym_if] = ACTIONS(14596),
    [anon_sym_CARET] = ACTIONS(14594),
  },
  [12295] = {
    [anon_sym_SLASH] = ACTIONS(15027),
    [anon_sym_RBRACK] = ACTIONS(15029),
    [anon_sym_until] = ACTIONS(15029),
    [anon_sym_AMP_EQ] = ACTIONS(15029),
    [anon_sym_GT_GT_EQ] = ACTIONS(15029),
    [anon_sym_SLASH_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15029),
    [anon_sym_RPAREN] = ACTIONS(15029),
    [anon_sym_EQ_TILDE] = ACTIONS(15029),
    [anon_sym_LT_LT] = ACTIONS(15027),
    [anon_sym_RBRACE] = ACTIONS(15029),
    [sym__binary_star] = ACTIONS(15029),
    [anon_sym_unless] = ACTIONS(15029),
    [anon_sym_PLUS] = ACTIONS(15027),
    [anon_sym_AMP] = ACTIONS(15027),
    [anon_sym_PERCENT] = ACTIONS(15027),
    [anon_sym_COLON_COLON2] = ACTIONS(15029),
    [anon_sym_rescue] = ACTIONS(15029),
    [anon_sym_PERCENT_EQ] = ACTIONS(15029),
    [anon_sym_LT_LT_EQ] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_DOT] = ACTIONS(15027),
    [anon_sym_BANG_TILDE] = ACTIONS(15029),
    [anon_sym_LBRACE] = ACTIONS(15029),
    [anon_sym_COLON2] = ACTIONS(15027),
    [anon_sym_while] = ACTIONS(15029),
    [sym__heredoc_body_start] = ACTIONS(15029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15029),
    [anon_sym_CARET_EQ] = ACTIONS(15029),
    [anon_sym_AMP_DOT] = ACTIONS(15029),
    [anon_sym_LT_EQ] = ACTIONS(15027),
    [anon_sym_PIPE] = ACTIONS(15027),
    [anon_sym_DOT_DOT] = ACTIONS(15027),
    [anon_sym_EQ] = ACTIONS(15027),
    [anon_sym_LT] = ACTIONS(15027),
    [anon_sym_in] = ACTIONS(15029),
    [anon_sym_QMARK] = ACTIONS(15029),
    [anon_sym_COMMA] = ACTIONS(15029),
    [anon_sym_GT_GT] = ACTIONS(15027),
    [anon_sym_SEMI] = ACTIONS(15029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15029),
    [anon_sym_or] = ACTIONS(15029),
    [anon_sym_GT] = ACTIONS(15027),
    [anon_sym_PIPE_EQ] = ACTIONS(15029),
    [anon_sym_PLUS_EQ] = ACTIONS(15029),
    [anon_sym_STAR_EQ] = ACTIONS(15029),
    [anon_sym_EQ_EQ] = ACTIONS(15027),
    [anon_sym_and] = ACTIONS(15029),
    [anon_sym_PIPE_PIPE] = ACTIONS(15027),
    [anon_sym_GT_EQ] = ACTIONS(15029),
    [anon_sym_LBRACK] = ACTIONS(15029),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15029),
    [anon_sym_DASH_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15029),
    [anon_sym_BANG_EQ] = ACTIONS(15029),
    [anon_sym_STAR_STAR] = ACTIONS(15027),
    [anon_sym_LT_EQ_GT] = ACTIONS(15029),
    [sym__binary_minus] = ACTIONS(15029),
    [anon_sym_AMP_AMP] = ACTIONS(15027),
    [anon_sym_if] = ACTIONS(15029),
    [anon_sym_CARET] = ACTIONS(15027),
  },
  [12296] = {
    [anon_sym_SLASH] = ACTIONS(15207),
    [anon_sym_RBRACK] = ACTIONS(15209),
    [anon_sym_until] = ACTIONS(15209),
    [anon_sym_AMP_EQ] = ACTIONS(15209),
    [anon_sym_GT_GT_EQ] = ACTIONS(15209),
    [anon_sym_SLASH_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15209),
    [anon_sym_RPAREN] = ACTIONS(15209),
    [anon_sym_EQ_TILDE] = ACTIONS(15209),
    [anon_sym_LT_LT] = ACTIONS(15207),
    [anon_sym_RBRACE] = ACTIONS(15209),
    [sym__binary_star] = ACTIONS(15209),
    [anon_sym_unless] = ACTIONS(15209),
    [anon_sym_PLUS] = ACTIONS(15207),
    [anon_sym_AMP] = ACTIONS(15207),
    [anon_sym_PERCENT] = ACTIONS(15207),
    [anon_sym_COLON_COLON2] = ACTIONS(15209),
    [anon_sym_rescue] = ACTIONS(15209),
    [anon_sym_PERCENT_EQ] = ACTIONS(15209),
    [anon_sym_LT_LT_EQ] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_DOT] = ACTIONS(15207),
    [anon_sym_BANG_TILDE] = ACTIONS(15209),
    [anon_sym_LBRACE] = ACTIONS(15209),
    [anon_sym_COLON2] = ACTIONS(15207),
    [anon_sym_while] = ACTIONS(15209),
    [sym__heredoc_body_start] = ACTIONS(15209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(15209),
    [anon_sym_CARET_EQ] = ACTIONS(15209),
    [anon_sym_AMP_DOT] = ACTIONS(15209),
    [anon_sym_LT_EQ] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(15207),
    [anon_sym_DOT_DOT] = ACTIONS(15207),
    [anon_sym_EQ] = ACTIONS(15207),
    [anon_sym_LT] = ACTIONS(15207),
    [anon_sym_in] = ACTIONS(15209),
    [anon_sym_QMARK] = ACTIONS(15209),
    [anon_sym_COMMA] = ACTIONS(15209),
    [anon_sym_GT_GT] = ACTIONS(15207),
    [anon_sym_SEMI] = ACTIONS(15209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15209),
    [anon_sym_or] = ACTIONS(15209),
    [anon_sym_GT] = ACTIONS(15207),
    [anon_sym_PIPE_EQ] = ACTIONS(15209),
    [anon_sym_PLUS_EQ] = ACTIONS(15209),
    [anon_sym_STAR_EQ] = ACTIONS(15209),
    [anon_sym_EQ_EQ] = ACTIONS(15207),
    [anon_sym_and] = ACTIONS(15209),
    [anon_sym_PIPE_PIPE] = ACTIONS(15207),
    [anon_sym_GT_EQ] = ACTIONS(15209),
    [anon_sym_LBRACK] = ACTIONS(15209),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15209),
    [anon_sym_DASH_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15209),
    [anon_sym_BANG_EQ] = ACTIONS(15209),
    [anon_sym_STAR_STAR] = ACTIONS(15207),
    [anon_sym_LT_EQ_GT] = ACTIONS(15209),
    [sym__binary_minus] = ACTIONS(15209),
    [anon_sym_AMP_AMP] = ACTIONS(15207),
    [anon_sym_if] = ACTIONS(15209),
    [anon_sym_CARET] = ACTIONS(15207),
  },
  [12297] = {
    [aux_sym_exceptions_repeat1] = STATE(12297),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17564),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12298] = {
    [anon_sym_LT] = ACTIONS(14925),
    [anon_sym_SLASH] = ACTIONS(14927),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14929),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14935),
    [anon_sym_LT_LT] = ACTIONS(14931),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14933),
    [sym__binary_star] = ACTIONS(14937),
    [anon_sym_PLUS] = ACTIONS(14939),
    [anon_sym_AMP] = ACTIONS(14941),
    [anon_sym_GT] = ACTIONS(14925),
    [anon_sym_PERCENT] = ACTIONS(14927),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(14943),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(14943),
    [anon_sym_BANG_TILDE] = ACTIONS(14933),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(14945),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14933),
    [anon_sym_STAR_STAR] = ACTIONS(14927),
    [anon_sym_PIPE] = ACTIONS(14947),
    [anon_sym_DOT_DOT] = ACTIONS(14949),
    [anon_sym_AMP_AMP] = ACTIONS(14943),
    [anon_sym_LT_EQ_GT] = ACTIONS(14933),
    [anon_sym_LT_EQ] = ACTIONS(14925),
    [sym__binary_minus] = ACTIONS(14951),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(14947),
  },
  [12299] = {
    [aux_sym_exceptions_repeat1] = STATE(12299),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_in] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17567),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12300] = {
    [anon_sym_LT] = ACTIONS(14986),
    [anon_sym_SLASH] = ACTIONS(14988),
    [anon_sym_in] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(14990),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(14992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14996),
    [anon_sym_LT_LT] = ACTIONS(14992),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(14994),
    [sym__binary_star] = ACTIONS(14998),
    [anon_sym_PLUS] = ACTIONS(15000),
    [anon_sym_AMP] = ACTIONS(15002),
    [anon_sym_GT] = ACTIONS(14986),
    [anon_sym_PERCENT] = ACTIONS(14988),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(15004),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15004),
    [anon_sym_BANG_TILDE] = ACTIONS(14994),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15006),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(14994),
    [anon_sym_STAR_STAR] = ACTIONS(14988),
    [anon_sym_PIPE] = ACTIONS(15008),
    [anon_sym_DOT_DOT] = ACTIONS(15010),
    [anon_sym_AMP_AMP] = ACTIONS(15004),
    [anon_sym_LT_EQ_GT] = ACTIONS(14994),
    [anon_sym_LT_EQ] = ACTIONS(14986),
    [sym__binary_minus] = ACTIONS(15012),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(15008),
  },
  [12301] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12302] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12303] = {
    [sym__argument] = STATE(7871),
    [sym_assignment] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(10346),
    [sym_pair] = STATE(7871),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(7871),
    [sym_hash_splat_argument] = STATE(7871),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11452),
    [sym_rational] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_block_argument] = STATE(7871),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym_float] = ACTIONS(15031),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(15035),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(15035),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15037),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(16222),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(15043),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(16224),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(16222),
    [anon_sym_yield] = ACTIONS(15051),
    [sym_class_variable] = ACTIONS(15043),
    [sym__block_ampersand] = ACTIONS(16226),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(15055),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [sym_retry] = ACTIONS(15031),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17439),
    [sym_redo] = ACTIONS(15031),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12304] = {
    [sym_heredoc_body] = STATE(12304),
    [aux_sym_call_repeat1] = STATE(12304),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12194),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
  },
  [12305] = {
    [sym_heredoc_body] = STATE(12304),
    [aux_sym_call_repeat1] = STATE(12304),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4116),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
  },
  [12306] = {
    [aux_sym_argument_list_repeat1] = STATE(12306),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17570),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
  },
  [12307] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12308] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12309] = {
    [aux_sym_exceptions_repeat1] = STATE(12441),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
  },
  [12310] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12311] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12312] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12313] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12314] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17573),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12315] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12316] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12317] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12318] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12319] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(7003),
  },
  [12320] = {
    [anon_sym_SLASH] = ACTIONS(1327),
    [sym_float] = ACTIONS(1327),
    [sym__string_array_start] = ACTIONS(1045),
    [sym__binary_minus] = ACTIONS(1045),
    [anon_sym_until] = ACTIONS(1327),
    [anon_sym_AMP_EQ] = ACTIONS(1045),
    [anon_sym_GT_GT_EQ] = ACTIONS(1045),
    [sym_self] = ACTIONS(1327),
    [anon_sym_SLASH_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_EQ_TILDE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [sym__binary_star] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_unless] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [sym_complex] = ACTIONS(1045),
    [anon_sym_COLON_COLON2] = ACTIONS(1045),
    [sym_super] = ACTIONS(1327),
    [sym__simple_symbol] = ACTIONS(1045),
    [sym__symbol_array_start] = ACTIONS(1045),
    [anon_sym_PERCENT_EQ] = ACTIONS(1045),
    [anon_sym_LBRACK2] = ACTIONS(1327),
    [anon_sym_LT_LT_EQ] = ACTIONS(1045),
    [anon_sym_nil] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1045),
    [sym_character] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_BANG_TILDE] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [sym_heredoc_beginning] = ACTIONS(1045),
    [sym_constant] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1045),
    [sym__heredoc_body_start] = ACTIONS(1045),
    [anon_sym_defined_QMARK] = ACTIONS(1045),
    [sym__string_start] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_DASH_GT] = ACTIONS(1045),
    [anon_sym_CARET_EQ] = ACTIONS(1045),
    [anon_sym_NIL] = ACTIONS(1327),
    [anon_sym_AMP_DOT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_DOT_DOT] = ACTIONS(1327),
    [anon_sym_def] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1327),
    [sym_class_variable] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [sym__symbol_start] = ACTIONS(1045),
    [anon_sym_TRUE] = ACTIONS(1327),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__identifier_hash_key] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [sym_global_variable] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_begin] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [sym__subshell_start] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1045),
    [anon_sym_PIPE_EQ] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1045),
    [anon_sym_STAR_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [anon_sym_next] = ACTIONS(1327),
    [sym__unary_minus] = ACTIONS(1045),
    [sym_retry] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [sym__regex_start] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1045),
    [anon_sym_DASH_EQ] = ACTIONS(1045),
    [anon_sym_FALSE] = ACTIONS(1327),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1327),
    [anon_sym_LT_EQ_GT] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [sym_redo] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
  },
  [12321] = {
    [sym__argument] = STATE(1245),
    [sym_assignment] = STATE(1247),
    [sym_unary] = STATE(1247),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(1246),
    [sym_singleton_class] = STATE(1248),
    [sym_module] = STATE(1248),
    [sym_chained_string] = STATE(1248),
    [sym_until] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_for] = STATE(1248),
    [sym_symbol] = STATE(1248),
    [sym_if] = STATE(1248),
    [sym_begin] = STATE(1248),
    [sym__arg] = STATE(1247),
    [sym__primary] = STATE(1248),
    [sym_pair] = STATE(1245),
    [sym_method_call] = STATE(1246),
    [sym_splat_argument] = STATE(1245),
    [sym_hash_splat_argument] = STATE(1245),
    [sym_operator_assignment] = STATE(1247),
    [sym_conditional] = STATE(1247),
    [sym_method] = STATE(1248),
    [sym_singleton_method] = STATE(1248),
    [sym__variable] = STATE(1249),
    [sym_left_assignment_list] = STATE(1250),
    [sym_return] = STATE(1248),
    [sym_yield] = STATE(1248),
    [sym_string] = STATE(1251),
    [sym_rational] = STATE(1248),
    [sym_subshell] = STATE(1248),
    [sym_true] = STATE(1246),
    [sym_unless] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_parenthesized_statements] = STATE(1248),
    [sym_element_reference] = STATE(1246),
    [sym_block_argument] = STATE(1245),
    [sym_range] = STATE(1247),
    [sym_binary] = STATE(1247),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(1248),
    [sym_break] = STATE(1248),
    [sym_next] = STATE(1248),
    [sym_string_array] = STATE(1248),
    [sym_while] = STATE(1248),
    [sym_case] = STATE(1248),
    [sym_symbol_array] = STATE(1248),
    [sym_array] = STATE(1248),
    [sym_hash] = STATE(1248),
    [sym_false] = STATE(1246),
    [sym_nil] = STATE(1246),
    [sym_scope_resolution] = STATE(1249),
    [sym_call] = STATE(1249),
    [sym__argument_list_with_trailing_comma] = STATE(12444),
    [sym_float] = ACTIONS(2171),
    [anon_sym_until] = ACTIONS(201),
    [sym_self] = ACTIONS(2173),
    [anon_sym_RPAREN] = ACTIONS(17575),
    [sym_heredoc_beginning] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym_complex] = ACTIONS(2177),
    [sym__simple_symbol] = ACTIONS(215),
    [sym_super] = ACTIONS(2173),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym_constant] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(225),
    [sym_instance_variable] = ACTIONS(2185),
    [anon_sym_defined_QMARK] = ACTIONS(2187),
    [sym__string_start] = ACTIONS(231),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [sym__identifier_hash_key] = ACTIONS(2191),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2185),
    [sym__block_ampersand] = ACTIONS(2195),
    [sym__symbol_start] = ACTIONS(249),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [sym_global_variable] = ACTIONS(2185),
    [anon_sym_class] = ACTIONS(261),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(2203),
    [anon_sym_next] = ACTIONS(2205),
    [sym_retry] = ACTIONS(2171),
    [sym__regex_start] = ACTIONS(277),
    [sym_integer] = ACTIONS(279),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [sym_redo] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(283),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(2209),
  },
  [12322] = {
    [anon_sym_SLASH] = ACTIONS(6719),
    [sym_float] = ACTIONS(6719),
    [sym__string_array_start] = ACTIONS(6721),
    [sym__binary_minus] = ACTIONS(6721),
    [anon_sym_until] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6721),
    [anon_sym_GT_GT_EQ] = ACTIONS(6721),
    [sym_self] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6721),
    [anon_sym_EQ_TILDE] = ACTIONS(6721),
    [anon_sym_LT_LT] = ACTIONS(6719),
    [sym__binary_star] = ACTIONS(6721),
    [anon_sym_TILDE] = ACTIONS(6721),
    [anon_sym_unless] = ACTIONS(6719),
    [anon_sym_PLUS] = ACTIONS(6719),
    [anon_sym_AMP] = ACTIONS(6719),
    [anon_sym_PERCENT] = ACTIONS(6719),
    [sym_complex] = ACTIONS(6721),
    [anon_sym_COLON_COLON2] = ACTIONS(6721),
    [sym_super] = ACTIONS(6719),
    [sym__simple_symbol] = ACTIONS(6721),
    [sym__symbol_array_start] = ACTIONS(6721),
    [anon_sym_PERCENT_EQ] = ACTIONS(6721),
    [anon_sym_LBRACK2] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6721),
    [anon_sym_nil] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6721),
    [sym_character] = ACTIONS(6721),
    [anon_sym_DOT] = ACTIONS(6719),
    [anon_sym_BANG_TILDE] = ACTIONS(6721),
    [anon_sym_LBRACE] = ACTIONS(6721),
    [sym_heredoc_beginning] = ACTIONS(6721),
    [sym_constant] = ACTIONS(6719),
    [anon_sym_while] = ACTIONS(6719),
    [sym_instance_variable] = ACTIONS(6721),
    [sym__heredoc_body_start] = ACTIONS(6721),
    [anon_sym_defined_QMARK] = ACTIONS(6721),
    [sym__string_start] = ACTIONS(6721),
    [anon_sym_true] = ACTIONS(6719),
    [anon_sym_for] = ACTIONS(6719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6719),
    [anon_sym_DASH_GT] = ACTIONS(6721),
    [anon_sym_CARET_EQ] = ACTIONS(6721),
    [anon_sym_NIL] = ACTIONS(6719),
    [anon_sym_AMP_DOT] = ACTIONS(6721),
    [anon_sym_COLON_COLON] = ACTIONS(6719),
    [anon_sym_LT_EQ] = ACTIONS(6719),
    [anon_sym_PIPE] = ACTIONS(6719),
    [anon_sym_DOT_DOT] = ACTIONS(6719),
    [anon_sym_def] = ACTIONS(6719),
    [sym_identifier] = ACTIONS(6719),
    [anon_sym_yield] = ACTIONS(6719),
    [sym_class_variable] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(6719),
    [anon_sym_not] = ACTIONS(6719),
    [anon_sym_LT] = ACTIONS(6719),
    [sym__symbol_start] = ACTIONS(6721),
    [anon_sym_TRUE] = ACTIONS(6719),
    [sym__block_ampersand] = ACTIONS(6721),
    [sym__identifier_hash_key] = ACTIONS(6721),
    [anon_sym_case] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(6719),
    [anon_sym_LPAREN2] = ACTIONS(6721),
    [anon_sym_COMMA] = ACTIONS(6721),
    [anon_sym_GT_GT] = ACTIONS(6719),
    [anon_sym_SEMI] = ACTIONS(6721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6721),
    [anon_sym_LPAREN] = ACTIONS(6719),
    [anon_sym_or] = ACTIONS(6719),
    [anon_sym_break] = ACTIONS(6719),
    [sym_global_variable] = ACTIONS(6721),
    [anon_sym_class] = ACTIONS(6719),
    [anon_sym_GT] = ACTIONS(6719),
    [anon_sym_module] = ACTIONS(6719),
    [anon_sym_begin] = ACTIONS(6719),
    [anon_sym_false] = ACTIONS(6719),
    [sym__subshell_start] = ACTIONS(6721),
    [sym__splat_star] = ACTIONS(6721),
    [anon_sym_PIPE_EQ] = ACTIONS(6721),
    [anon_sym_PLUS_EQ] = ACTIONS(6721),
    [anon_sym_STAR_EQ] = ACTIONS(6721),
    [anon_sym_EQ_EQ] = ACTIONS(6719),
    [anon_sym_STAR] = ACTIONS(6719),
    [anon_sym_and] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE] = ACTIONS(6719),
    [anon_sym_next] = ACTIONS(6719),
    [sym__unary_minus] = ACTIONS(6721),
    [sym_retry] = ACTIONS(6719),
    [anon_sym_GT_EQ] = ACTIONS(6721),
    [sym__regex_start] = ACTIONS(6721),
    [sym_integer] = ACTIONS(6719),
    [anon_sym_LBRACK] = ACTIONS(6721),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6721),
    [anon_sym_DASH_EQ] = ACTIONS(6721),
    [anon_sym_FALSE] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6721),
    [anon_sym_BANG_EQ] = ACTIONS(6721),
    [anon_sym_STAR_STAR] = ACTIONS(6719),
    [anon_sym_LT_EQ_GT] = ACTIONS(6721),
    [anon_sym_AMP_AMP] = ACTIONS(6719),
    [sym_redo] = ACTIONS(6719),
    [anon_sym_BANG] = ACTIONS(6719),
    [anon_sym_if] = ACTIONS(6719),
    [anon_sym_CARET] = ACTIONS(6719),
    [anon_sym_return] = ACTIONS(6719),
  },
  [12323] = {
    [anon_sym_SLASH] = ACTIONS(6727),
    [sym_float] = ACTIONS(6727),
    [sym__string_array_start] = ACTIONS(6729),
    [sym__binary_minus] = ACTIONS(6729),
    [anon_sym_until] = ACTIONS(6727),
    [anon_sym_AMP_EQ] = ACTIONS(6729),
    [anon_sym_GT_GT_EQ] = ACTIONS(6729),
    [sym_self] = ACTIONS(6727),
    [anon_sym_SLASH_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6729),
    [anon_sym_EQ_TILDE] = ACTIONS(6729),
    [anon_sym_LT_LT] = ACTIONS(6727),
    [sym__binary_star] = ACTIONS(6729),
    [anon_sym_TILDE] = ACTIONS(6729),
    [anon_sym_unless] = ACTIONS(6727),
    [anon_sym_PLUS] = ACTIONS(6727),
    [anon_sym_AMP] = ACTIONS(6727),
    [anon_sym_PERCENT] = ACTIONS(6727),
    [sym_complex] = ACTIONS(6729),
    [anon_sym_COLON_COLON2] = ACTIONS(6729),
    [sym_super] = ACTIONS(6727),
    [sym__simple_symbol] = ACTIONS(6729),
    [sym__symbol_array_start] = ACTIONS(6729),
    [anon_sym_PERCENT_EQ] = ACTIONS(6729),
    [anon_sym_LBRACK2] = ACTIONS(6727),
    [anon_sym_LT_LT_EQ] = ACTIONS(6729),
    [anon_sym_nil] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6729),
    [sym_character] = ACTIONS(6729),
    [anon_sym_DOT] = ACTIONS(6727),
    [anon_sym_BANG_TILDE] = ACTIONS(6729),
    [anon_sym_LBRACE] = ACTIONS(6729),
    [sym_heredoc_beginning] = ACTIONS(6729),
    [sym_constant] = ACTIONS(6727),
    [anon_sym_while] = ACTIONS(6727),
    [sym_instance_variable] = ACTIONS(6729),
    [sym__heredoc_body_start] = ACTIONS(6729),
    [anon_sym_defined_QMARK] = ACTIONS(6729),
    [sym__string_start] = ACTIONS(6729),
    [anon_sym_true] = ACTIONS(6727),
    [anon_sym_for] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6727),
    [anon_sym_DASH_GT] = ACTIONS(6729),
    [anon_sym_CARET_EQ] = ACTIONS(6729),
    [anon_sym_NIL] = ACTIONS(6727),
    [anon_sym_AMP_DOT] = ACTIONS(6729),
    [anon_sym_COLON_COLON] = ACTIONS(6727),
    [anon_sym_LT_EQ] = ACTIONS(6727),
    [anon_sym_PIPE] = ACTIONS(6727),
    [anon_sym_DOT_DOT] = ACTIONS(6727),
    [anon_sym_def] = ACTIONS(6727),
    [sym_identifier] = ACTIONS(6727),
    [anon_sym_yield] = ACTIONS(6727),
    [sym_class_variable] = ACTIONS(6729),
    [anon_sym_EQ] = ACTIONS(6727),
    [anon_sym_not] = ACTIONS(6727),
    [anon_sym_LT] = ACTIONS(6727),
    [sym__symbol_start] = ACTIONS(6729),
    [anon_sym_TRUE] = ACTIONS(6727),
    [sym__block_ampersand] = ACTIONS(6729),
    [sym__identifier_hash_key] = ACTIONS(6729),
    [anon_sym_case] = ACTIONS(6727),
    [anon_sym_QMARK] = ACTIONS(6727),
    [anon_sym_LPAREN2] = ACTIONS(6729),
    [anon_sym_COMMA] = ACTIONS(6729),
    [anon_sym_GT_GT] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6729),
    [anon_sym_LPAREN] = ACTIONS(6727),
    [anon_sym_or] = ACTIONS(6727),
    [anon_sym_break] = ACTIONS(6727),
    [sym_global_variable] = ACTIONS(6729),
    [anon_sym_class] = ACTIONS(6727),
    [anon_sym_GT] = ACTIONS(6727),
    [anon_sym_module] = ACTIONS(6727),
    [anon_sym_begin] = ACTIONS(6727),
    [anon_sym_false] = ACTIONS(6727),
    [sym__subshell_start] = ACTIONS(6729),
    [sym__splat_star] = ACTIONS(6729),
    [anon_sym_PIPE_EQ] = ACTIONS(6729),
    [anon_sym_PLUS_EQ] = ACTIONS(6729),
    [anon_sym_STAR_EQ] = ACTIONS(6729),
    [anon_sym_EQ_EQ] = ACTIONS(6727),
    [anon_sym_STAR] = ACTIONS(6727),
    [anon_sym_and] = ACTIONS(6727),
    [anon_sym_PIPE_PIPE] = ACTIONS(6727),
    [anon_sym_next] = ACTIONS(6727),
    [sym__unary_minus] = ACTIONS(6729),
    [sym_retry] = ACTIONS(6727),
    [anon_sym_GT_EQ] = ACTIONS(6729),
    [sym__regex_start] = ACTIONS(6729),
    [sym_integer] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6729),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6729),
    [anon_sym_DASH_EQ] = ACTIONS(6729),
    [anon_sym_FALSE] = ACTIONS(6727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6729),
    [anon_sym_BANG_EQ] = ACTIONS(6729),
    [anon_sym_STAR_STAR] = ACTIONS(6727),
    [anon_sym_LT_EQ_GT] = ACTIONS(6729),
    [anon_sym_AMP_AMP] = ACTIONS(6727),
    [sym_redo] = ACTIONS(6727),
    [anon_sym_BANG] = ACTIONS(6727),
    [anon_sym_if] = ACTIONS(6727),
    [anon_sym_CARET] = ACTIONS(6727),
    [anon_sym_return] = ACTIONS(6727),
  },
  [12324] = {
    [sym_heredoc_body] = STATE(3983),
    [sym__argument_list_with_parens] = STATE(12323),
    [aux_sym_call_repeat1] = STATE(3983),
    [sym_argument_list_with_parens] = STATE(12445),
    [sym_operator] = STATE(12445),
    [anon_sym_LT] = ACTIONS(17441),
    [anon_sym_SLASH] = ACTIONS(17443),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(17443),
    [anon_sym_PLUS_AT] = ACTIONS(17443),
    [anon_sym_LPAREN2] = ACTIONS(17445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17443),
    [anon_sym_GT_GT] = ACTIONS(17443),
    [anon_sym_EQ_TILDE] = ACTIONS(17443),
    [anon_sym_LT_LT] = ACTIONS(17443),
    [anon_sym_TILDE] = ACTIONS(17443),
    [anon_sym_PLUS] = ACTIONS(17441),
    [anon_sym_AMP] = ACTIONS(17443),
    [anon_sym_GT] = ACTIONS(17441),
    [anon_sym_PERCENT] = ACTIONS(17443),
    [anon_sym_DASH_AT] = ACTIONS(17443),
    [anon_sym_EQ_EQ] = ACTIONS(17441),
    [anon_sym_STAR] = ACTIONS(17441),
    [anon_sym_BANG_TILDE] = ACTIONS(17443),
    [sym_constant] = ACTIONS(17577),
    [anon_sym_DASH] = ACTIONS(17441),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [anon_sym_GT_EQ] = ACTIONS(17443),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(17441),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BQUOTE] = ACTIONS(17443),
    [anon_sym_STAR_STAR] = ACTIONS(17443),
    [anon_sym_PIPE] = ACTIONS(17443),
    [anon_sym_DOT_DOT] = ACTIONS(17443),
    [anon_sym_LT_EQ_GT] = ACTIONS(17443),
    [anon_sym_LT_EQ] = ACTIONS(17441),
    [anon_sym_BANG] = ACTIONS(17441),
    [sym_identifier] = ACTIONS(17577),
    [anon_sym_CARET] = ACTIONS(17443),
  },
  [12325] = {
    [anon_sym_SLASH] = ACTIONS(6739),
    [sym_float] = ACTIONS(6739),
    [sym__string_array_start] = ACTIONS(6741),
    [sym__binary_minus] = ACTIONS(6741),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6741),
    [anon_sym_GT_GT_EQ] = ACTIONS(6741),
    [sym_self] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6741),
    [anon_sym_EQ_TILDE] = ACTIONS(6741),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [sym__binary_star] = ACTIONS(6741),
    [anon_sym_TILDE] = ACTIONS(6741),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_complex] = ACTIONS(6741),
    [anon_sym_COLON_COLON2] = ACTIONS(6741),
    [sym_super] = ACTIONS(6739),
    [sym__simple_symbol] = ACTIONS(6741),
    [sym__symbol_array_start] = ACTIONS(6741),
    [anon_sym_PERCENT_EQ] = ACTIONS(6741),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6741),
    [anon_sym_nil] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6741),
    [sym_character] = ACTIONS(6741),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6741),
    [anon_sym_LBRACE] = ACTIONS(6741),
    [sym_heredoc_beginning] = ACTIONS(6741),
    [sym_constant] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [sym_instance_variable] = ACTIONS(6741),
    [sym__heredoc_body_start] = ACTIONS(6741),
    [anon_sym_defined_QMARK] = ACTIONS(6741),
    [sym__string_start] = ACTIONS(6741),
    [anon_sym_true] = ACTIONS(6739),
    [anon_sym_for] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6741),
    [anon_sym_CARET_EQ] = ACTIONS(6741),
    [anon_sym_NIL] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6741),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_yield] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6741),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(6739),
    [sym__symbol_start] = ACTIONS(6741),
    [anon_sym_TRUE] = ACTIONS(6739),
    [sym__block_ampersand] = ACTIONS(6741),
    [sym__identifier_hash_key] = ACTIONS(6741),
    [anon_sym_case] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_LPAREN2] = ACTIONS(6741),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6741),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_break] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6741),
    [anon_sym_class] = ACTIONS(6739),
    [anon_sym_GT] = ACTIONS(6739),
    [anon_sym_module] = ACTIONS(6739),
    [anon_sym_begin] = ACTIONS(6739),
    [anon_sym_false] = ACTIONS(6739),
    [sym__subshell_start] = ACTIONS(6741),
    [sym__splat_star] = ACTIONS(6741),
    [anon_sym_PIPE_EQ] = ACTIONS(6741),
    [anon_sym_PLUS_EQ] = ACTIONS(6741),
    [anon_sym_STAR_EQ] = ACTIONS(6741),
    [anon_sym_EQ_EQ] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_next] = ACTIONS(6739),
    [sym__unary_minus] = ACTIONS(6741),
    [sym_retry] = ACTIONS(6739),
    [anon_sym_GT_EQ] = ACTIONS(6741),
    [sym__regex_start] = ACTIONS(6741),
    [sym_integer] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6741),
    [anon_sym_DASH_EQ] = ACTIONS(6741),
    [anon_sym_FALSE] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6741),
    [anon_sym_BANG_EQ] = ACTIONS(6741),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6741),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [sym_redo] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_return] = ACTIONS(6739),
  },
  [12326] = {
    [aux_sym_chained_string_repeat1] = STATE(12326),
    [sym_string] = STATE(12326),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(12354),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
  },
  [12327] = {
    [sym_assignment] = STATE(12036),
    [sym_unary] = STATE(12036),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12036),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_splat_argument] = STATE(7984),
    [sym_operator_assignment] = STATE(12036),
    [sym_conditional] = STATE(12036),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_return] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_true] = STATE(10344),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym__arg_or_splat_arg] = STATE(7984),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12036),
    [sym_binary] = STATE(12036),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [sym__splat_star] = ACTIONS(16228),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [anon_sym_class] = ACTIONS(261),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [sym_global_variable] = ACTIONS(15043),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(15035),
    [sym_character] = ACTIONS(15037),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12328] = {
    [aux_sym_exceptions_repeat1] = STATE(12446),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17579),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [12329] = {
    [sym_assignment] = STATE(12447),
    [sym_unary] = STATE(12447),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10344),
    [sym_singleton_class] = STATE(10346),
    [sym_module] = STATE(10346),
    [sym_chained_string] = STATE(10346),
    [sym_until] = STATE(10346),
    [sym_regex] = STATE(10346),
    [sym_for] = STATE(10346),
    [sym_symbol] = STATE(10346),
    [sym_if] = STATE(10346),
    [sym_begin] = STATE(10346),
    [sym__arg] = STATE(12447),
    [sym__primary] = STATE(10346),
    [sym_method_call] = STATE(10344),
    [sym_operator_assignment] = STATE(12447),
    [sym_conditional] = STATE(12447),
    [sym_method] = STATE(10346),
    [sym_singleton_method] = STATE(10346),
    [sym__variable] = STATE(10347),
    [sym_left_assignment_list] = STATE(10348),
    [sym_rational] = STATE(10346),
    [sym_true] = STATE(10344),
    [sym_return] = STATE(10346),
    [sym_subshell] = STATE(10346),
    [sym_yield] = STATE(10346),
    [sym_string] = STATE(11440),
    [sym_unless] = STATE(10346),
    [sym_lambda] = STATE(10346),
    [sym_parenthesized_statements] = STATE(10346),
    [sym_element_reference] = STATE(10344),
    [sym_range] = STATE(12447),
    [sym_binary] = STATE(12447),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10346),
    [sym_break] = STATE(10346),
    [sym_next] = STATE(10346),
    [sym_string_array] = STATE(10346),
    [sym_while] = STATE(10346),
    [sym_case] = STATE(10346),
    [sym_symbol_array] = STATE(10346),
    [sym_array] = STATE(10346),
    [sym_hash] = STATE(10346),
    [sym_false] = STATE(10344),
    [sym_nil] = STATE(10344),
    [sym_scope_resolution] = STATE(10347),
    [sym_call] = STATE(10347),
    [sym__symbol_start] = ACTIONS(249),
    [sym_float] = ACTIONS(15031),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15051),
    [anon_sym_until] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(15039),
    [anon_sym_not] = ACTIONS(15055),
    [sym_self] = ACTIONS(15035),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(207),
    [sym__symbol_array_start] = ACTIONS(213),
    [sym__subshell_start] = ACTIONS(263),
    [sym__simple_symbol] = ACTIONS(215),
    [anon_sym_class] = ACTIONS(261),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15037),
    [anon_sym_module] = ACTIONS(265),
    [anon_sym_begin] = ACTIONS(267),
    [sym_complex] = ACTIONS(15037),
    [anon_sym_PLUS] = ACTIONS(16212),
    [anon_sym_TILDE] = ACTIONS(15039),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15043),
    [sym_character] = ACTIONS(15037),
    [sym_super] = ACTIONS(15035),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(221),
    [sym__unary_minus] = ACTIONS(15061),
    [anon_sym_next] = ACTIONS(15063),
    [anon_sym_while] = ACTIONS(225),
    [sym_retry] = ACTIONS(15031),
    [sym_constant] = ACTIONS(15035),
    [anon_sym_defined_QMARK] = ACTIONS(15045),
    [sym_instance_variable] = ACTIONS(15043),
    [sym_integer] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(235),
    [sym__string_start] = ACTIONS(231),
    [sym__regex_start] = ACTIONS(277),
    [anon_sym_DASH_GT] = ACTIONS(237),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(243),
    [sym_identifier] = ACTIONS(15035),
    [sym_redo] = ACTIONS(15031),
    [sym_class_variable] = ACTIONS(15043),
    [sym__string_array_start] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(15033),
  },
  [12330] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [12331] = {
    [anon_sym_RPAREN] = ACTIONS(17581),
    [sym_comment] = ACTIONS(49),
  },
  [12332] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [12333] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12334] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12335] = {
    [sym__argument] = STATE(8031),
    [sym_assignment] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(10380),
    [sym_pair] = STATE(8031),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(8031),
    [sym_hash_splat_argument] = STATE(8031),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11493),
    [sym_rational] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_block_argument] = STATE(8031),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym_float] = ACTIONS(15107),
    [anon_sym_until] = ACTIONS(1549),
    [sym_self] = ACTIONS(15111),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_unless] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym_complex] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [sym_super] = ACTIONS(15111),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_nil] = ACTIONS(219),
    [sym_character] = ACTIONS(15113),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym_constant] = ACTIONS(16296),
    [anon_sym_while] = ACTIONS(1571),
    [sym_instance_variable] = ACTIONS(15119),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym__string_start] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [sym__identifier_hash_key] = ACTIONS(16298),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(16296),
    [anon_sym_yield] = ACTIONS(15125),
    [sym_class_variable] = ACTIONS(15119),
    [sym__block_ampersand] = ACTIONS(16300),
    [sym__symbol_start] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(15129),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_class] = ACTIONS(1607),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [sym_retry] = ACTIONS(15107),
    [sym__regex_start] = ACTIONS(1619),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(17460),
    [sym_redo] = ACTIONS(15107),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_if] = ACTIONS(1625),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12336] = {
    [sym_heredoc_body] = STATE(12336),
    [aux_sym_call_repeat1] = STATE(12336),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9772),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(12449),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [12337] = {
    [sym_heredoc_body] = STATE(12336),
    [aux_sym_call_repeat1] = STATE(12336),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9779),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(4388),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [12338] = {
    [aux_sym_argument_list_repeat1] = STATE(12338),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17583),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [12339] = {
    [aux_sym_exceptions_repeat1] = STATE(12339),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17586),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12340] = {
    [anon_sym_LT] = ACTIONS(15073),
    [anon_sym_SLASH] = ACTIONS(15075),
    [anon_sym_QMARK] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15083),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_PLUS] = ACTIONS(15087),
    [anon_sym_AMP] = ACTIONS(15089),
    [anon_sym_GT] = ACTIONS(15073),
    [anon_sym_PERCENT] = ACTIONS(15075),
    [sym__binary_star] = ACTIONS(15075),
    [anon_sym_EQ_EQ] = ACTIONS(15091),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_GT_EQ] = ACTIONS(15093),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_STAR_STAR] = ACTIONS(15075),
    [anon_sym_PIPE] = ACTIONS(16308),
    [anon_sym_DOT_DOT] = ACTIONS(15097),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15073),
    [sym__binary_minus] = ACTIONS(15087),
    [anon_sym_CARET] = ACTIONS(15099),
  },
  [12341] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12342] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12343] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12344] = {
    [aux_sym_exceptions_repeat1] = STATE(12450),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6743),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [12345] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12346] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12347] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12348] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7001),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12349] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17589),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12350] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12351] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12352] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12353] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12354] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12355] = {
    [aux_sym_chained_string_repeat1] = STATE(12355),
    [sym_string] = STATE(12355),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7121),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(16100),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [12356] = {
    [sym_assignment] = STATE(12086),
    [sym_unary] = STATE(12086),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12086),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_splat_argument] = STATE(10180),
    [sym_operator_assignment] = STATE(12086),
    [sym_conditional] = STATE(12086),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_return] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_true] = STATE(10384),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym__arg_or_splat_arg] = STATE(10180),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12086),
    [sym_binary] = STATE(12086),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [sym__splat_star] = ACTIONS(16302),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1607),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [sym_global_variable] = ACTIONS(15119),
    [anon_sym_nil] = ACTIONS(219),
    [sym_super] = ACTIONS(15111),
    [sym_character] = ACTIONS(15113),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12357] = {
    [aux_sym_exceptions_repeat1] = STATE(12452),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17591),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12358] = {
    [sym_assignment] = STATE(12453),
    [sym_unary] = STATE(12453),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10384),
    [sym_singleton_class] = STATE(10380),
    [sym_module] = STATE(10380),
    [sym_chained_string] = STATE(10380),
    [sym_until] = STATE(10380),
    [sym_regex] = STATE(10380),
    [sym_for] = STATE(10380),
    [sym_symbol] = STATE(10380),
    [sym_if] = STATE(10380),
    [sym_begin] = STATE(10380),
    [sym__arg] = STATE(12453),
    [sym__primary] = STATE(10380),
    [sym_method_call] = STATE(10384),
    [sym_operator_assignment] = STATE(12453),
    [sym_conditional] = STATE(12453),
    [sym_method] = STATE(10380),
    [sym_singleton_method] = STATE(10380),
    [sym__variable] = STATE(10382),
    [sym_left_assignment_list] = STATE(10381),
    [sym_rational] = STATE(10380),
    [sym_true] = STATE(10384),
    [sym_return] = STATE(10380),
    [sym_subshell] = STATE(10380),
    [sym_yield] = STATE(10380),
    [sym_string] = STATE(11517),
    [sym_unless] = STATE(10380),
    [sym_lambda] = STATE(10380),
    [sym_parenthesized_statements] = STATE(10380),
    [sym_element_reference] = STATE(10384),
    [sym_range] = STATE(12453),
    [sym_binary] = STATE(12453),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10380),
    [sym_break] = STATE(10380),
    [sym_next] = STATE(10380),
    [sym_string_array] = STATE(10380),
    [sym_while] = STATE(10380),
    [sym_case] = STATE(10380),
    [sym_symbol_array] = STATE(10380),
    [sym_array] = STATE(10380),
    [sym_hash] = STATE(10380),
    [sym_false] = STATE(10384),
    [sym_nil] = STATE(10384),
    [sym_scope_resolution] = STATE(10382),
    [sym_call] = STATE(10382),
    [sym__symbol_start] = ACTIONS(1595),
    [sym_float] = ACTIONS(15107),
    [anon_sym_TRUE] = ACTIONS(233),
    [anon_sym_yield] = ACTIONS(15125),
    [anon_sym_until] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(15115),
    [anon_sym_not] = ACTIONS(15129),
    [sym_self] = ACTIONS(15111),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_break] = ACTIONS(15133),
    [anon_sym_unless] = ACTIONS(1557),
    [sym__symbol_array_start] = ACTIONS(1561),
    [sym__subshell_start] = ACTIONS(1609),
    [sym__simple_symbol] = ACTIONS(1563),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(269),
    [sym_heredoc_beginning] = ACTIONS(15113),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_begin] = ACTIONS(1613),
    [sym_complex] = ACTIONS(15113),
    [anon_sym_PLUS] = ACTIONS(16322),
    [anon_sym_TILDE] = ACTIONS(15115),
    [anon_sym_nil] = ACTIONS(219),
    [sym_global_variable] = ACTIONS(15119),
    [sym_character] = ACTIONS(15113),
    [sym_super] = ACTIONS(15111),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [sym__unary_minus] = ACTIONS(15135),
    [anon_sym_next] = ACTIONS(15137),
    [anon_sym_while] = ACTIONS(1571),
    [sym_retry] = ACTIONS(15107),
    [sym_constant] = ACTIONS(15111),
    [anon_sym_defined_QMARK] = ACTIONS(15121),
    [sym_instance_variable] = ACTIONS(15119),
    [sym_integer] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(233),
    [anon_sym_for] = ACTIONS(1579),
    [sym__string_start] = ACTIONS(1577),
    [sym__regex_start] = ACTIONS(1619),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(269),
    [anon_sym_COLON_COLON] = ACTIONS(16214),
    [anon_sym_def] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(15111),
    [sym_redo] = ACTIONS(15107),
    [sym_class_variable] = ACTIONS(15119),
    [sym__string_array_start] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(15109),
  },
  [12359] = {
    [sym__line_break] = ACTIONS(17593),
    [sym_float] = ACTIONS(17595),
    [anon_sym_until] = ACTIONS(17595),
    [anon_sym_undef] = ACTIONS(17595),
    [sym_self] = ACTIONS(17595),
    [anon_sym_BEGIN] = ACTIONS(17595),
    [anon_sym_TILDE] = ACTIONS(17593),
    [anon_sym_unless] = ACTIONS(17595),
    [anon_sym_PLUS] = ACTIONS(17595),
    [sym__symbol_array_start] = ACTIONS(17593),
    [sym__simple_symbol] = ACTIONS(17593),
    [sym_complex] = ACTIONS(17593),
    [sym_heredoc_beginning] = ACTIONS(17593),
    [sym_super] = ACTIONS(17595),
    [anon_sym_alias] = ACTIONS(17595),
    [anon_sym_LBRACK2] = ACTIONS(17593),
    [anon_sym_nil] = ACTIONS(17595),
    [sym_character] = ACTIONS(17593),
    [anon_sym_LBRACE] = ACTIONS(17593),
    [anon_sym_END] = ACTIONS(17595),
    [sym_constant] = ACTIONS(17595),
    [anon_sym_while] = ACTIONS(17595),
    [sym_instance_variable] = ACTIONS(17593),
    [sym__heredoc_body_start] = ACTIONS(17593),
    [anon_sym_defined_QMARK] = ACTIONS(17593),
    [sym__string_start] = ACTIONS(17593),
    [anon_sym_true] = ACTIONS(17595),
    [anon_sym_for] = ACTIONS(17595),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17593),
    [anon_sym_NIL] = ACTIONS(17595),
    [anon_sym_COLON_COLON] = ACTIONS(17593),
    [anon_sym_def] = ACTIONS(17595),
    [sym_identifier] = ACTIONS(17595),
    [anon_sym_yield] = ACTIONS(17595),
    [sym_class_variable] = ACTIONS(17593),
    [sym__symbol_start] = ACTIONS(17593),
    [anon_sym_not] = ACTIONS(17595),
    [anon_sym_TRUE] = ACTIONS(17595),
    [anon_sym_case] = ACTIONS(17595),
    [anon_sym_SEMI] = ACTIONS(17593),
    [anon_sym_LPAREN] = ACTIONS(17593),
    [anon_sym_break] = ACTIONS(17595),
    [sym_global_variable] = ACTIONS(17593),
    [anon_sym_class] = ACTIONS(17595),
    [sym__subshell_start] = ACTIONS(17593),
    [anon_sym_module] = ACTIONS(17595),
    [anon_sym_begin] = ACTIONS(17595),
    [anon_sym_false] = ACTIONS(17595),
    [anon_sym_STAR] = ACTIONS(17593),
    [sym__unary_minus] = ACTIONS(17593),
    [anon_sym_next] = ACTIONS(17595),
    [sym_retry] = ACTIONS(17595),
    [sym__regex_start] = ACTIONS(17593),
    [anon_sym_end] = ACTIONS(17595),
    [sym_integer] = ACTIONS(17595),
    [anon_sym_FALSE] = ACTIONS(17595),
    [sym_redo] = ACTIONS(17595),
    [anon_sym_BANG] = ACTIONS(17593),
    [anon_sym_if] = ACTIONS(17595),
    [sym__string_array_start] = ACTIONS(17593),
    [anon_sym_return] = ACTIONS(17595),
  },
  [12360] = {
    [sym_float] = ACTIONS(17595),
    [anon_sym_until] = ACTIONS(17595),
    [anon_sym_undef] = ACTIONS(17595),
    [sym_self] = ACTIONS(17595),
    [anon_sym_BEGIN] = ACTIONS(17595),
    [anon_sym_RBRACE] = ACTIONS(17593),
    [anon_sym_TILDE] = ACTIONS(17593),
    [anon_sym_unless] = ACTIONS(17595),
    [anon_sym_PLUS] = ACTIONS(17595),
    [sym__symbol_array_start] = ACTIONS(17593),
    [sym__simple_symbol] = ACTIONS(17593),
    [sym_complex] = ACTIONS(17593),
    [sym_heredoc_beginning] = ACTIONS(17593),
    [sym_super] = ACTIONS(17595),
    [anon_sym_alias] = ACTIONS(17595),
    [anon_sym_LBRACK2] = ACTIONS(17593),
    [anon_sym_nil] = ACTIONS(17595),
    [sym_character] = ACTIONS(17593),
    [anon_sym_LBRACE] = ACTIONS(17593),
    [anon_sym_END] = ACTIONS(17595),
    [sym_constant] = ACTIONS(17595),
    [anon_sym_while] = ACTIONS(17595),
    [sym_instance_variable] = ACTIONS(17593),
    [anon_sym_defined_QMARK] = ACTIONS(17593),
    [sym__string_start] = ACTIONS(17593),
    [anon_sym_true] = ACTIONS(17595),
    [anon_sym_for] = ACTIONS(17595),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(17593),
    [anon_sym_NIL] = ACTIONS(17595),
    [anon_sym_COLON_COLON] = ACTIONS(17593),
    [anon_sym_def] = ACTIONS(17595),
    [sym_identifier] = ACTIONS(17595),
    [anon_sym_yield] = ACTIONS(17595),
    [sym_class_variable] = ACTIONS(17593),
    [sym__symbol_start] = ACTIONS(17593),
    [anon_sym_not] = ACTIONS(17595),
    [anon_sym_TRUE] = ACTIONS(17595),
    [anon_sym_case] = ACTIONS(17595),
    [anon_sym_SEMI] = ACTIONS(17593),
    [anon_sym_LPAREN] = ACTIONS(17593),
    [anon_sym_break] = ACTIONS(17595),
    [sym_global_variable] = ACTIONS(17593),
    [anon_sym_class] = ACTIONS(17595),
    [sym__subshell_start] = ACTIONS(17593),
    [anon_sym_module] = ACTIONS(17595),
    [anon_sym_begin] = ACTIONS(17595),
    [anon_sym_false] = ACTIONS(17595),
    [anon_sym_STAR] = ACTIONS(17593),
    [sym__unary_minus] = ACTIONS(17593),
    [anon_sym_next] = ACTIONS(17595),
    [sym_retry] = ACTIONS(17595),
    [sym__regex_start] = ACTIONS(17593),
    [sym_integer] = ACTIONS(17595),
    [anon_sym_FALSE] = ACTIONS(17595),
    [sym_redo] = ACTIONS(17595),
    [anon_sym_BANG] = ACTIONS(17593),
    [anon_sym_if] = ACTIONS(17595),
    [sym__string_array_start] = ACTIONS(17593),
    [anon_sym_return] = ACTIONS(17595),
  },
  [12361] = {
    [sym__line_break] = ACTIONS(16424),
    [anon_sym_DOT] = ACTIONS(16424),
    [anon_sym_then] = ACTIONS(16424),
    [anon_sym_AMP_DOT] = ACTIONS(16424),
    [anon_sym_COLON_COLON2] = ACTIONS(16424),
    [sym__heredoc_body_start] = ACTIONS(16424),
    [anon_sym_COMMA] = ACTIONS(16424),
    [anon_sym_SEMI] = ACTIONS(16424),
    [anon_sym_LBRACK] = ACTIONS(16424),
    [sym_comment] = ACTIONS(49),
  },
  [12362] = {
    [aux_sym_exceptions_repeat1] = STATE(12362),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17597),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12363] = {
    [anon_sym_LT] = ACTIONS(15299),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(15301),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15303),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15305),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15307),
    [anon_sym_LT_LT] = ACTIONS(15305),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15309),
    [anon_sym_EQ_TILDE] = ACTIONS(15309),
    [anon_sym_PLUS] = ACTIONS(15311),
    [anon_sym_AMP] = ACTIONS(15313),
    [anon_sym_GT] = ACTIONS(15299),
    [anon_sym_PERCENT] = ACTIONS(15301),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(15301),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(15315),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(15309),
    [anon_sym_PIPE_PIPE] = ACTIONS(15309),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15317),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(15309),
    [anon_sym_STAR_STAR] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(15319),
    [anon_sym_DOT_DOT] = ACTIONS(15321),
    [anon_sym_AMP_AMP] = ACTIONS(15309),
    [anon_sym_LT_EQ_GT] = ACTIONS(15309),
    [anon_sym_LT_EQ] = ACTIONS(15299),
    [sym__binary_minus] = ACTIONS(15311),
    [anon_sym_CARET] = ACTIONS(15323),
  },
  [12364] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_when] = ACTIONS(8253),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12365] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_when] = ACTIONS(8267),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12366] = {
    [sym__argument] = STATE(8629),
    [sym_assignment] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(10623),
    [sym_pair] = STATE(8629),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(8629),
    [sym_hash_splat_argument] = STATE(8629),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11630),
    [sym_rational] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_block_argument] = STATE(8629),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym_float] = ACTIONS(15341),
    [anon_sym_until] = ACTIONS(913),
    [sym_self] = ACTIONS(15345),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_unless] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym_complex] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [sym_super] = ACTIONS(15345),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15347),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym_constant] = ACTIONS(16513),
    [anon_sym_while] = ACTIONS(927),
    [sym_instance_variable] = ACTIONS(15353),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym__string_start] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(16515),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(16513),
    [anon_sym_yield] = ACTIONS(15361),
    [sym_class_variable] = ACTIONS(15353),
    [sym__block_ampersand] = ACTIONS(16517),
    [sym__symbol_start] = ACTIONS(547),
    [anon_sym_not] = ACTIONS(15365),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_class] = ACTIONS(559),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [sym_retry] = ACTIONS(15341),
    [sym__regex_start] = ACTIONS(573),
    [sym_integer] = ACTIONS(575),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17495),
    [sym_redo] = ACTIONS(15341),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_if] = ACTIONS(953),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12367] = {
    [sym_heredoc_body] = STATE(12367),
    [aux_sym_call_repeat1] = STATE(12367),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_when] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13190),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [12368] = {
    [sym_heredoc_body] = STATE(12367),
    [aux_sym_call_repeat1] = STATE(12367),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_when] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [12369] = {
    [aux_sym_argument_list_repeat1] = STATE(12369),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_SLASH] = ACTIONS(8457),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17600),
    [anon_sym_GT_GT] = ACTIONS(8457),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_PLUS] = ACTIONS(8457),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_PERCENT] = ACTIONS(8457),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(8457),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_AMP_AMP] = ACTIONS(8457),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(8457),
    [sym__binary_minus] = ACTIONS(8457),
  },
  [12370] = {
    [sym_heredoc_body] = STATE(12454),
    [aux_sym_call_repeat1] = STATE(12454),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [12371] = {
    [sym_heredoc_body] = STATE(12455),
    [aux_sym_call_repeat1] = STATE(12455),
    [aux_sym_argument_list_repeat1] = STATE(12153),
    [anon_sym_LT] = ACTIONS(5590),
    [anon_sym_SLASH] = ACTIONS(5592),
    [sym__line_break] = ACTIONS(5592),
    [anon_sym_until] = ACTIONS(5592),
    [anon_sym_QMARK] = ACTIONS(5592),
    [anon_sym_COMMA] = ACTIONS(16539),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5592),
    [anon_sym_unless] = ACTIONS(5592),
    [anon_sym_EQ_TILDE] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5590),
    [anon_sym_GT] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_COLON_COLON2] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_rescue] = ACTIONS(5592),
    [anon_sym_when] = ACTIONS(5592),
    [sym__binary_star] = ACTIONS(5592),
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_EQ_EQ] = ACTIONS(5590),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_BANG_TILDE] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5592),
    [anon_sym_while] = ACTIONS(5592),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(5592),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_else] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(5592),
    [anon_sym_BANG_EQ] = ACTIONS(5592),
    [anon_sym_STAR_STAR] = ACTIONS(5592),
    [anon_sym_PIPE] = ACTIONS(5590),
    [anon_sym_DOT_DOT] = ACTIONS(5590),
    [anon_sym_AMP_AMP] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5592),
    [anon_sym_LT_EQ] = ACTIONS(5590),
    [anon_sym_if] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [sym__binary_minus] = ACTIONS(5592),
  },
  [12372] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_when] = ACTIONS(6999),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12373] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_when] = ACTIONS(6135),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12374] = {
    [aux_sym_exceptions_repeat1] = STATE(12457),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [12375] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12376] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12377] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12378] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12379] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17603),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12380] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12381] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_when] = ACTIONS(7119),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12382] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12383] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12384] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12385] = {
    [aux_sym_chained_string_repeat1] = STATE(12385),
    [sym_string] = STATE(12385),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_SLASH] = ACTIONS(7123),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7123),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_PLUS] = ACTIONS(7123),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_PERCENT] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_when] = ACTIONS(7123),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(7125),
    [anon_sym_else] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7123),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_AMP_AMP] = ACTIONS(7123),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7123),
    [sym__binary_minus] = ACTIONS(7123),
  },
  [12386] = {
    [sym_assignment] = STATE(12155),
    [sym_unary] = STATE(12155),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12155),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_splat_argument] = STATE(8693),
    [sym_operator_assignment] = STATE(12155),
    [sym_conditional] = STATE(12155),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_return] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_true] = STATE(10621),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym__arg_or_splat_arg] = STATE(8693),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12155),
    [sym_binary] = STATE(12155),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [sym__splat_star] = ACTIONS(16519),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(559),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [sym_global_variable] = ACTIONS(15353),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(15345),
    [sym_character] = ACTIONS(15347),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12387] = {
    [aux_sym_exceptions_repeat1] = STATE(12459),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17605),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_when] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [12388] = {
    [sym_assignment] = STATE(12460),
    [sym_unary] = STATE(12460),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10621),
    [sym_singleton_class] = STATE(10623),
    [sym_module] = STATE(10623),
    [sym_chained_string] = STATE(10623),
    [sym_until] = STATE(10623),
    [sym_regex] = STATE(10623),
    [sym_for] = STATE(10623),
    [sym_symbol] = STATE(10623),
    [sym_if] = STATE(10623),
    [sym_begin] = STATE(10623),
    [sym__arg] = STATE(12460),
    [sym__primary] = STATE(10623),
    [sym_method_call] = STATE(10621),
    [sym_operator_assignment] = STATE(12460),
    [sym_conditional] = STATE(12460),
    [sym_method] = STATE(10623),
    [sym_singleton_method] = STATE(10623),
    [sym__variable] = STATE(10624),
    [sym_left_assignment_list] = STATE(10625),
    [sym_rational] = STATE(10623),
    [sym_true] = STATE(10621),
    [sym_return] = STATE(10623),
    [sym_subshell] = STATE(10623),
    [sym_yield] = STATE(10623),
    [sym_string] = STATE(11618),
    [sym_unless] = STATE(10623),
    [sym_lambda] = STATE(10623),
    [sym_parenthesized_statements] = STATE(10623),
    [sym_element_reference] = STATE(10621),
    [sym_range] = STATE(12460),
    [sym_binary] = STATE(12460),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10623),
    [sym_break] = STATE(10623),
    [sym_next] = STATE(10623),
    [sym_string_array] = STATE(10623),
    [sym_while] = STATE(10623),
    [sym_case] = STATE(10623),
    [sym_symbol_array] = STATE(10623),
    [sym_array] = STATE(10623),
    [sym_hash] = STATE(10623),
    [sym_false] = STATE(10621),
    [sym_nil] = STATE(10621),
    [sym_scope_resolution] = STATE(10624),
    [sym_call] = STATE(10624),
    [sym__symbol_start] = ACTIONS(547),
    [sym_float] = ACTIONS(15341),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15361),
    [anon_sym_until] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(549),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(15349),
    [anon_sym_not] = ACTIONS(15365),
    [sym_self] = ACTIONS(15345),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(15369),
    [anon_sym_unless] = ACTIONS(921),
    [sym__symbol_array_start] = ACTIONS(511),
    [sym__subshell_start] = ACTIONS(561),
    [sym__simple_symbol] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15347),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [sym_complex] = ACTIONS(15347),
    [anon_sym_PLUS] = ACTIONS(16503),
    [anon_sym_TILDE] = ACTIONS(15349),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15353),
    [sym_character] = ACTIONS(15347),
    [sym_super] = ACTIONS(15345),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(519),
    [sym__unary_minus] = ACTIONS(15371),
    [anon_sym_next] = ACTIONS(15373),
    [anon_sym_while] = ACTIONS(927),
    [sym_retry] = ACTIONS(15341),
    [sym_constant] = ACTIONS(15345),
    [anon_sym_defined_QMARK] = ACTIONS(15355),
    [sym_instance_variable] = ACTIONS(15353),
    [sym_integer] = ACTIONS(575),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(531),
    [sym__string_start] = ACTIONS(527),
    [sym__regex_start] = ACTIONS(573),
    [anon_sym_DASH_GT] = ACTIONS(533),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(539),
    [sym_identifier] = ACTIONS(15345),
    [sym_redo] = ACTIONS(15341),
    [sym_class_variable] = ACTIONS(15353),
    [sym__string_array_start] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(15343),
  },
  [12389] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym__line_break] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [sym__symbol_array_start] = ACTIONS(5454),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_rescue] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_EQ_GT] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [12390] = {
    [anon_sym_RPAREN] = ACTIONS(17607),
    [sym_comment] = ACTIONS(49),
  },
  [12391] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym__line_break] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [sym__symbol_array_start] = ACTIONS(10962),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [anon_sym_when] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [12392] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(8253),
    [anon_sym_until] = ACTIONS(8253),
    [anon_sym_AMP_EQ] = ACTIONS(8253),
    [anon_sym_GT_GT_EQ] = ACTIONS(8253),
    [anon_sym_SLASH_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(8253),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(8253),
    [anon_sym_rescue] = ACTIONS(8253),
    [anon_sym_PERCENT_EQ] = ACTIONS(8253),
    [anon_sym_LT_LT_EQ] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_DOT] = ACTIONS(9628),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(8253),
    [anon_sym_while] = ACTIONS(8253),
    [sym__heredoc_body_start] = ACTIONS(8253),
    [anon_sym_else] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8253),
    [anon_sym_CARET_EQ] = ACTIONS(8253),
    [anon_sym_AMP_DOT] = ACTIONS(8253),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(9628),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(8253),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(8253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(8253),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [anon_sym_when] = ACTIONS(8253),
    [anon_sym_PIPE_EQ] = ACTIONS(8253),
    [anon_sym_PLUS_EQ] = ACTIONS(8253),
    [anon_sym_STAR_EQ] = ACTIONS(8253),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(8253),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(8253),
    [anon_sym_LBRACK] = ACTIONS(8253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8253),
    [anon_sym_DASH_EQ] = ACTIONS(8253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8253),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(8253),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12393] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(8267),
    [anon_sym_until] = ACTIONS(8267),
    [anon_sym_AMP_EQ] = ACTIONS(8267),
    [anon_sym_GT_GT_EQ] = ACTIONS(8267),
    [anon_sym_SLASH_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(8267),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(8267),
    [anon_sym_rescue] = ACTIONS(8267),
    [anon_sym_PERCENT_EQ] = ACTIONS(8267),
    [anon_sym_LT_LT_EQ] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(8267),
    [anon_sym_while] = ACTIONS(8267),
    [sym__heredoc_body_start] = ACTIONS(8267),
    [anon_sym_else] = ACTIONS(8267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8267),
    [anon_sym_CARET_EQ] = ACTIONS(8267),
    [anon_sym_AMP_DOT] = ACTIONS(8267),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(8267),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(8267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(8267),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(8267),
    [anon_sym_when] = ACTIONS(8267),
    [anon_sym_PIPE_EQ] = ACTIONS(8267),
    [anon_sym_PLUS_EQ] = ACTIONS(8267),
    [anon_sym_STAR_EQ] = ACTIONS(8267),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(8267),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(8267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8267),
    [anon_sym_DASH_EQ] = ACTIONS(8267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8267),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(8267),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12394] = {
    [sym__argument] = STATE(8702),
    [sym_assignment] = STATE(11667),
    [sym_unary] = STATE(11667),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(11667),
    [sym__primary] = STATE(10650),
    [sym_pair] = STATE(8702),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(8702),
    [sym_hash_splat_argument] = STATE(8702),
    [sym_operator_assignment] = STATE(11667),
    [sym_conditional] = STATE(11667),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11668),
    [sym_rational] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_block_argument] = STATE(8702),
    [sym_range] = STATE(11667),
    [sym_binary] = STATE(11667),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym_float] = ACTIONS(15399),
    [anon_sym_until] = ACTIONS(1001),
    [sym_self] = ACTIONS(15403),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_unless] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym_complex] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [sym_super] = ACTIONS(15403),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_nil] = ACTIONS(517),
    [sym_character] = ACTIONS(15405),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym_constant] = ACTIONS(16577),
    [anon_sym_while] = ACTIONS(1017),
    [sym_instance_variable] = ACTIONS(15411),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym__string_start] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym_comment] = ACTIONS(49),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [sym__identifier_hash_key] = ACTIONS(16579),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(16577),
    [anon_sym_yield] = ACTIONS(15417),
    [sym_class_variable] = ACTIONS(15411),
    [sym__block_ampersand] = ACTIONS(16583),
    [sym__symbol_start] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(15421),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_break] = ACTIONS(15425),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_class] = ACTIONS(851),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(271),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [sym_retry] = ACTIONS(15399),
    [sym__regex_start] = ACTIONS(863),
    [sym_integer] = ACTIONS(865),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(17506),
    [sym_redo] = ACTIONS(15399),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_if] = ACTIONS(1041),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12395] = {
    [sym_heredoc_body] = STATE(12395),
    [aux_sym_call_repeat1] = STATE(12395),
    [anon_sym_SLASH] = ACTIONS(9772),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_AMP_EQ] = ACTIONS(9774),
    [anon_sym_GT_GT_EQ] = ACTIONS(9774),
    [anon_sym_SLASH_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9772),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_PLUS] = ACTIONS(9772),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_PERCENT] = ACTIONS(9772),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_PERCENT_EQ] = ACTIONS(9774),
    [anon_sym_LT_LT_EQ] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_LBRACE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(13261),
    [anon_sym_else] = ACTIONS(9774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9774),
    [anon_sym_CARET_EQ] = ACTIONS(9774),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9772),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9772),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_EQ_GT] = ACTIONS(9774),
    [anon_sym_when] = ACTIONS(9774),
    [anon_sym_PIPE_EQ] = ACTIONS(9774),
    [anon_sym_PLUS_EQ] = ACTIONS(9774),
    [anon_sym_STAR_EQ] = ACTIONS(9774),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9772),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9774),
    [anon_sym_DASH_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9772),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_AMP_AMP] = ACTIONS(9772),
    [sym__binary_minus] = ACTIONS(9774),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9772),
  },
  [12396] = {
    [sym_heredoc_body] = STATE(12395),
    [aux_sym_call_repeat1] = STATE(12395),
    [anon_sym_SLASH] = ACTIONS(9779),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_AMP_EQ] = ACTIONS(9781),
    [anon_sym_GT_GT_EQ] = ACTIONS(9781),
    [anon_sym_SLASH_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9779),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_PLUS] = ACTIONS(9779),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_PERCENT] = ACTIONS(9779),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_PERCENT_EQ] = ACTIONS(9781),
    [anon_sym_LT_LT_EQ] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_LBRACE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_else] = ACTIONS(9781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9781),
    [anon_sym_CARET_EQ] = ACTIONS(9781),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_EQ] = ACTIONS(9779),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9779),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_EQ_GT] = ACTIONS(9781),
    [anon_sym_when] = ACTIONS(9781),
    [anon_sym_PIPE_EQ] = ACTIONS(9781),
    [anon_sym_PLUS_EQ] = ACTIONS(9781),
    [anon_sym_STAR_EQ] = ACTIONS(9781),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9779),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9781),
    [anon_sym_DASH_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9779),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_AMP_AMP] = ACTIONS(9779),
    [sym__binary_minus] = ACTIONS(9781),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9779),
  },
  [12397] = {
    [aux_sym_argument_list_repeat1] = STATE(12397),
    [anon_sym_SLASH] = ACTIONS(9770),
    [sym__line_break] = ACTIONS(8457),
    [anon_sym_until] = ACTIONS(8457),
    [anon_sym_AMP_EQ] = ACTIONS(8457),
    [anon_sym_GT_GT_EQ] = ACTIONS(8457),
    [anon_sym_SLASH_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8457),
    [anon_sym_EQ_TILDE] = ACTIONS(8457),
    [anon_sym_LT_LT] = ACTIONS(9770),
    [sym__binary_star] = ACTIONS(8457),
    [anon_sym_unless] = ACTIONS(8457),
    [anon_sym_PLUS] = ACTIONS(9770),
    [anon_sym_AMP] = ACTIONS(9770),
    [anon_sym_PERCENT] = ACTIONS(9770),
    [anon_sym_COLON_COLON2] = ACTIONS(8457),
    [anon_sym_rescue] = ACTIONS(8457),
    [anon_sym_PERCENT_EQ] = ACTIONS(8457),
    [anon_sym_LT_LT_EQ] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_DOT] = ACTIONS(9770),
    [anon_sym_BANG_TILDE] = ACTIONS(8457),
    [anon_sym_LBRACE] = ACTIONS(8457),
    [anon_sym_while] = ACTIONS(8457),
    [sym__heredoc_body_start] = ACTIONS(8457),
    [anon_sym_else] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(8457),
    [anon_sym_CARET_EQ] = ACTIONS(8457),
    [anon_sym_AMP_DOT] = ACTIONS(8457),
    [anon_sym_LT_EQ] = ACTIONS(9770),
    [anon_sym_PIPE] = ACTIONS(9770),
    [anon_sym_DOT_DOT] = ACTIONS(9770),
    [anon_sym_EQ] = ACTIONS(9770),
    [anon_sym_LT] = ACTIONS(9770),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_COMMA] = ACTIONS(17609),
    [anon_sym_GT_GT] = ACTIONS(9770),
    [anon_sym_SEMI] = ACTIONS(8457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8457),
    [anon_sym_or] = ACTIONS(8457),
    [anon_sym_GT] = ACTIONS(9770),
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [anon_sym_when] = ACTIONS(8457),
    [anon_sym_PIPE_EQ] = ACTIONS(8457),
    [anon_sym_PLUS_EQ] = ACTIONS(8457),
    [anon_sym_STAR_EQ] = ACTIONS(8457),
    [anon_sym_EQ_EQ] = ACTIONS(9770),
    [anon_sym_and] = ACTIONS(8457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9770),
    [anon_sym_GT_EQ] = ACTIONS(8457),
    [anon_sym_end] = ACTIONS(8457),
    [anon_sym_LBRACK] = ACTIONS(8457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8457),
    [anon_sym_DASH_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8457),
    [anon_sym_BANG_EQ] = ACTIONS(8457),
    [anon_sym_STAR_STAR] = ACTIONS(9770),
    [anon_sym_LT_EQ_GT] = ACTIONS(8457),
    [anon_sym_AMP_AMP] = ACTIONS(9770),
    [sym__binary_minus] = ACTIONS(8457),
    [anon_sym_if] = ACTIONS(8457),
    [anon_sym_CARET] = ACTIONS(9770),
  },
  [12398] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_rescue] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_when] = ACTIONS(9736),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9736),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12399] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_when] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12400] = {
    [aux_sym_exceptions_repeat1] = STATE(12201),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_SLASH] = ACTIONS(6745),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6745),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_PLUS] = ACTIONS(6745),
    [anon_sym_PERCENT] = ACTIONS(6745),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6745),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_AMP_AMP] = ACTIONS(6745),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6745),
    [sym__binary_minus] = ACTIONS(6745),
  },
  [12401] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12402] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12403] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12404] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12405] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17612),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12406] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12407] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_when] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12408] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7003),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(7003),
  },
  [12409] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12410] = {
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_AMP_AMP] = ACTIONS(7003),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7003),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12411] = {
    [aux_sym_exceptions_repeat1] = STATE(12411),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17614),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12412] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(6999),
    [anon_sym_until] = ACTIONS(6999),
    [anon_sym_AMP_EQ] = ACTIONS(6999),
    [anon_sym_GT_GT_EQ] = ACTIONS(6999),
    [anon_sym_SLASH_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(6999),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(6999),
    [anon_sym_rescue] = ACTIONS(6999),
    [anon_sym_PERCENT_EQ] = ACTIONS(6999),
    [anon_sym_LT_LT_EQ] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_DOT] = ACTIONS(9786),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_while] = ACTIONS(6999),
    [sym__heredoc_body_start] = ACTIONS(6999),
    [anon_sym_else] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6999),
    [anon_sym_CARET_EQ] = ACTIONS(6999),
    [anon_sym_AMP_DOT] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(9786),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(6999),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(6999),
    [anon_sym_PIPE_EQ] = ACTIONS(6999),
    [anon_sym_PLUS_EQ] = ACTIONS(6999),
    [anon_sym_STAR_EQ] = ACTIONS(6999),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(6999),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(6999),
    [anon_sym_LBRACK] = ACTIONS(6999),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6999),
    [anon_sym_DASH_EQ] = ACTIONS(6999),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(6999),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12413] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(6135),
    [anon_sym_until] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(6135),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(6135),
    [anon_sym_rescue] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_while] = ACTIONS(6135),
    [sym__heredoc_body_start] = ACTIONS(6135),
    [anon_sym_else] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_AMP_DOT] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(6135),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12414] = {
    [aux_sym_exceptions_repeat1] = STATE(12464),
    [anon_sym_SLASH] = ACTIONS(6743),
    [sym__line_break] = ACTIONS(6745),
    [anon_sym_until] = ACTIONS(6745),
    [anon_sym_AMP_EQ] = ACTIONS(6745),
    [anon_sym_GT_GT_EQ] = ACTIONS(6745),
    [anon_sym_SLASH_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6745),
    [anon_sym_EQ_TILDE] = ACTIONS(6745),
    [anon_sym_LT_LT] = ACTIONS(6743),
    [sym__binary_star] = ACTIONS(6745),
    [anon_sym_unless] = ACTIONS(6745),
    [anon_sym_PLUS] = ACTIONS(6743),
    [anon_sym_AMP] = ACTIONS(6743),
    [anon_sym_PERCENT] = ACTIONS(6743),
    [anon_sym_COLON_COLON2] = ACTIONS(6745),
    [anon_sym_rescue] = ACTIONS(6745),
    [anon_sym_PERCENT_EQ] = ACTIONS(6745),
    [anon_sym_LT_LT_EQ] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_DOT] = ACTIONS(6743),
    [anon_sym_BANG_TILDE] = ACTIONS(6745),
    [anon_sym_LBRACE] = ACTIONS(6745),
    [anon_sym_while] = ACTIONS(6745),
    [sym__heredoc_body_start] = ACTIONS(6745),
    [anon_sym_else] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(6745),
    [anon_sym_CARET_EQ] = ACTIONS(6745),
    [anon_sym_AMP_DOT] = ACTIONS(6745),
    [anon_sym_LT_EQ] = ACTIONS(6743),
    [anon_sym_PIPE] = ACTIONS(6743),
    [anon_sym_DOT_DOT] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6743),
    [anon_sym_LT] = ACTIONS(6743),
    [anon_sym_QMARK] = ACTIONS(6745),
    [anon_sym_COMMA] = ACTIONS(6745),
    [anon_sym_GT_GT] = ACTIONS(6743),
    [anon_sym_SEMI] = ACTIONS(6745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6745),
    [anon_sym_or] = ACTIONS(6745),
    [anon_sym_GT] = ACTIONS(6743),
    [anon_sym_when] = ACTIONS(6745),
    [anon_sym_PIPE_EQ] = ACTIONS(6745),
    [anon_sym_PLUS_EQ] = ACTIONS(6745),
    [anon_sym_STAR_EQ] = ACTIONS(6745),
    [anon_sym_EQ_EQ] = ACTIONS(6743),
    [anon_sym_and] = ACTIONS(6745),
    [anon_sym_PIPE_PIPE] = ACTIONS(6743),
    [anon_sym_GT_EQ] = ACTIONS(6745),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_LBRACK] = ACTIONS(6745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6745),
    [anon_sym_DASH_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6745),
    [anon_sym_BANG_EQ] = ACTIONS(6745),
    [anon_sym_STAR_STAR] = ACTIONS(6743),
    [anon_sym_LT_EQ_GT] = ACTIONS(6745),
    [anon_sym_AMP_AMP] = ACTIONS(6743),
    [sym__binary_minus] = ACTIONS(6745),
    [anon_sym_if] = ACTIONS(6745),
    [anon_sym_CARET] = ACTIONS(6743),
  },
  [12415] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12416] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12417] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12418] = {
    [anon_sym_SLASH] = ACTIONS(7001),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(7003),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(7001),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12419] = {
    [anon_sym_LT] = ACTIONS(7047),
    [anon_sym_SLASH] = ACTIONS(7049),
    [anon_sym_QMARK] = ACTIONS(7051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7053),
    [anon_sym_GT_GT] = ACTIONS(7055),
    [anon_sym_EQ_TILDE] = ACTIONS(7053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7057),
    [sym__binary_star] = ACTIONS(7049),
    [anon_sym_or] = ACTIONS(7059),
    [anon_sym_LT_LT] = ACTIONS(7055),
    [anon_sym_PLUS] = ACTIONS(7061),
    [anon_sym_GT] = ACTIONS(7047),
    [anon_sym_AMP] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7049),
    [anon_sym_EQ_EQ] = ACTIONS(7065),
    [anon_sym_BANG_TILDE] = ACTIONS(7053),
    [anon_sym_and] = ACTIONS(7059),
    [anon_sym_COLON2] = ACTIONS(17617),
    [anon_sym_PIPE_PIPE] = ACTIONS(7053),
    [anon_sym_GT_EQ] = ACTIONS(7069),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(7053),
    [anon_sym_LT_EQ] = ACTIONS(7047),
    [anon_sym_LT_EQ_GT] = ACTIONS(7053),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_AMP_AMP] = ACTIONS(7053),
    [anon_sym_PIPE] = ACTIONS(7073),
    [sym__binary_minus] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7049),
    [anon_sym_CARET] = ACTIONS(7075),
  },
  [12420] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12421] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7119),
    [anon_sym_until] = ACTIONS(7119),
    [anon_sym_AMP_EQ] = ACTIONS(7119),
    [anon_sym_GT_GT_EQ] = ACTIONS(7119),
    [anon_sym_SLASH_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7119),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7119),
    [anon_sym_rescue] = ACTIONS(7119),
    [anon_sym_PERCENT_EQ] = ACTIONS(7119),
    [anon_sym_LT_LT_EQ] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_DOT] = ACTIONS(9792),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(7119),
    [anon_sym_while] = ACTIONS(7119),
    [sym__heredoc_body_start] = ACTIONS(7119),
    [anon_sym_else] = ACTIONS(7119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7119),
    [anon_sym_CARET_EQ] = ACTIONS(7119),
    [anon_sym_AMP_DOT] = ACTIONS(7119),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(9792),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(7119),
    [anon_sym_COMMA] = ACTIONS(7119),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(7119),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(7119),
    [anon_sym_PIPE_EQ] = ACTIONS(7119),
    [anon_sym_PLUS_EQ] = ACTIONS(7119),
    [anon_sym_STAR_EQ] = ACTIONS(7119),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(7119),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(7119),
    [anon_sym_LBRACK] = ACTIONS(7119),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7119),
    [anon_sym_DASH_EQ] = ACTIONS(7119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7119),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7119),
    [anon_sym_CARET] = ACTIONS(17273),
  },
  [12422] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(7001),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(7001),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(7001),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(7003),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12423] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(7001),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12424] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(7003),
    [anon_sym_until] = ACTIONS(7003),
    [anon_sym_AMP_EQ] = ACTIONS(7003),
    [anon_sym_GT_GT_EQ] = ACTIONS(7003),
    [anon_sym_SLASH_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7003),
    [anon_sym_EQ_TILDE] = ACTIONS(7003),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(7003),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(7003),
    [anon_sym_rescue] = ACTIONS(7003),
    [anon_sym_PERCENT_EQ] = ACTIONS(7003),
    [anon_sym_LT_LT_EQ] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_DOT] = ACTIONS(7001),
    [anon_sym_BANG_TILDE] = ACTIONS(7003),
    [anon_sym_LBRACE] = ACTIONS(7003),
    [anon_sym_while] = ACTIONS(7003),
    [sym__heredoc_body_start] = ACTIONS(7003),
    [anon_sym_else] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7003),
    [anon_sym_CARET_EQ] = ACTIONS(7003),
    [anon_sym_AMP_DOT] = ACTIONS(7003),
    [anon_sym_LT_EQ] = ACTIONS(7001),
    [anon_sym_PIPE] = ACTIONS(7001),
    [anon_sym_DOT_DOT] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7001),
    [anon_sym_LT] = ACTIONS(7001),
    [anon_sym_QMARK] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7003),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7003),
    [anon_sym_or] = ACTIONS(7003),
    [anon_sym_GT] = ACTIONS(7001),
    [anon_sym_when] = ACTIONS(7003),
    [anon_sym_PIPE_EQ] = ACTIONS(7003),
    [anon_sym_PLUS_EQ] = ACTIONS(7003),
    [anon_sym_STAR_EQ] = ACTIONS(7003),
    [anon_sym_EQ_EQ] = ACTIONS(7001),
    [anon_sym_and] = ACTIONS(7003),
    [anon_sym_PIPE_PIPE] = ACTIONS(7001),
    [anon_sym_GT_EQ] = ACTIONS(7003),
    [anon_sym_end] = ACTIONS(7003),
    [anon_sym_LBRACK] = ACTIONS(7003),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7003),
    [anon_sym_DASH_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7003),
    [anon_sym_BANG_EQ] = ACTIONS(7003),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(7003),
    [anon_sym_AMP_AMP] = ACTIONS(7001),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(7003),
    [anon_sym_CARET] = ACTIONS(7001),
  },
  [12425] = {
    [aux_sym_chained_string_repeat1] = STATE(12425),
    [sym_string] = STATE(12425),
    [anon_sym_SLASH] = ACTIONS(7121),
    [sym__line_break] = ACTIONS(7123),
    [anon_sym_until] = ACTIONS(7123),
    [anon_sym_AMP_EQ] = ACTIONS(7123),
    [anon_sym_GT_GT_EQ] = ACTIONS(7123),
    [anon_sym_SLASH_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7123),
    [anon_sym_EQ_TILDE] = ACTIONS(7123),
    [anon_sym_LT_LT] = ACTIONS(7121),
    [sym__binary_star] = ACTIONS(7123),
    [anon_sym_unless] = ACTIONS(7123),
    [anon_sym_PLUS] = ACTIONS(7121),
    [anon_sym_AMP] = ACTIONS(7121),
    [anon_sym_PERCENT] = ACTIONS(7121),
    [anon_sym_COLON_COLON2] = ACTIONS(7123),
    [anon_sym_rescue] = ACTIONS(7123),
    [anon_sym_PERCENT_EQ] = ACTIONS(7123),
    [anon_sym_LT_LT_EQ] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_DOT] = ACTIONS(7121),
    [anon_sym_BANG_TILDE] = ACTIONS(7123),
    [anon_sym_LBRACE] = ACTIONS(7123),
    [anon_sym_while] = ACTIONS(7123),
    [sym__heredoc_body_start] = ACTIONS(7123),
    [sym__string_start] = ACTIONS(14095),
    [anon_sym_else] = ACTIONS(7123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(7123),
    [anon_sym_CARET_EQ] = ACTIONS(7123),
    [anon_sym_AMP_DOT] = ACTIONS(7123),
    [anon_sym_LT_EQ] = ACTIONS(7121),
    [anon_sym_PIPE] = ACTIONS(7121),
    [anon_sym_DOT_DOT] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7121),
    [anon_sym_LT] = ACTIONS(7121),
    [anon_sym_QMARK] = ACTIONS(7123),
    [anon_sym_COMMA] = ACTIONS(7123),
    [anon_sym_GT_GT] = ACTIONS(7121),
    [anon_sym_SEMI] = ACTIONS(7123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7123),
    [anon_sym_or] = ACTIONS(7123),
    [anon_sym_GT] = ACTIONS(7121),
    [anon_sym_when] = ACTIONS(7123),
    [anon_sym_PIPE_EQ] = ACTIONS(7123),
    [anon_sym_PLUS_EQ] = ACTIONS(7123),
    [anon_sym_STAR_EQ] = ACTIONS(7123),
    [anon_sym_EQ_EQ] = ACTIONS(7121),
    [anon_sym_and] = ACTIONS(7123),
    [anon_sym_PIPE_PIPE] = ACTIONS(7121),
    [anon_sym_GT_EQ] = ACTIONS(7123),
    [anon_sym_end] = ACTIONS(7123),
    [anon_sym_LBRACK] = ACTIONS(7123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7123),
    [anon_sym_DASH_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7123),
    [anon_sym_BANG_EQ] = ACTIONS(7123),
    [anon_sym_STAR_STAR] = ACTIONS(7121),
    [anon_sym_LT_EQ_GT] = ACTIONS(7123),
    [anon_sym_AMP_AMP] = ACTIONS(7121),
    [sym__binary_minus] = ACTIONS(7123),
    [anon_sym_if] = ACTIONS(7123),
    [anon_sym_CARET] = ACTIONS(7121),
  },
  [12426] = {
    [sym_assignment] = STATE(12218),
    [sym_unary] = STATE(12218),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12218),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_splat_argument] = STATE(9504),
    [sym_operator_assignment] = STATE(12218),
    [sym_conditional] = STATE(12218),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_return] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_true] = STATE(10654),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym__arg_or_splat_arg] = STATE(9504),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12218),
    [sym_binary] = STATE(12218),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [sym__splat_star] = ACTIONS(16581),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(851),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_false] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [sym_global_variable] = ACTIONS(15411),
    [anon_sym_nil] = ACTIONS(517),
    [sym_super] = ACTIONS(15403),
    [sym_character] = ACTIONS(15405),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12427] = {
    [aux_sym_exceptions_repeat1] = STATE(12466),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17619),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_EQ_GT] = ACTIONS(10973),
    [anon_sym_when] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12428] = {
    [sym_assignment] = STATE(12467),
    [sym_unary] = STATE(12467),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(10654),
    [sym_singleton_class] = STATE(10650),
    [sym_module] = STATE(10650),
    [sym_chained_string] = STATE(10650),
    [sym_until] = STATE(10650),
    [sym_regex] = STATE(10650),
    [sym_for] = STATE(10650),
    [sym_symbol] = STATE(10650),
    [sym_if] = STATE(10650),
    [sym_begin] = STATE(10650),
    [sym__arg] = STATE(12467),
    [sym__primary] = STATE(10650),
    [sym_method_call] = STATE(10654),
    [sym_operator_assignment] = STATE(12467),
    [sym_conditional] = STATE(12467),
    [sym_method] = STATE(10650),
    [sym_singleton_method] = STATE(10650),
    [sym__variable] = STATE(10652),
    [sym_left_assignment_list] = STATE(10651),
    [sym_rational] = STATE(10650),
    [sym_true] = STATE(10654),
    [sym_return] = STATE(10650),
    [sym_subshell] = STATE(10650),
    [sym_yield] = STATE(10650),
    [sym_string] = STATE(11693),
    [sym_unless] = STATE(10650),
    [sym_lambda] = STATE(10650),
    [sym_parenthesized_statements] = STATE(10650),
    [sym_element_reference] = STATE(10654),
    [sym_range] = STATE(12467),
    [sym_binary] = STATE(12467),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(10650),
    [sym_break] = STATE(10650),
    [sym_next] = STATE(10650),
    [sym_string_array] = STATE(10650),
    [sym_while] = STATE(10650),
    [sym_case] = STATE(10650),
    [sym_symbol_array] = STATE(10650),
    [sym_array] = STATE(10650),
    [sym_hash] = STATE(10650),
    [sym_false] = STATE(10654),
    [sym_nil] = STATE(10654),
    [sym_scope_resolution] = STATE(10652),
    [sym_call] = STATE(10652),
    [sym__symbol_start] = ACTIONS(839),
    [sym_float] = ACTIONS(15399),
    [anon_sym_TRUE] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(15417),
    [anon_sym_until] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(15407),
    [anon_sym_not] = ACTIONS(15421),
    [sym_self] = ACTIONS(15403),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(15425),
    [anon_sym_unless] = ACTIONS(1009),
    [sym__symbol_array_start] = ACTIONS(807),
    [sym__subshell_start] = ACTIONS(853),
    [sym__simple_symbol] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(567),
    [sym_heredoc_beginning] = ACTIONS(15405),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_begin] = ACTIONS(857),
    [sym_complex] = ACTIONS(15405),
    [anon_sym_PLUS] = ACTIONS(16615),
    [anon_sym_TILDE] = ACTIONS(15407),
    [anon_sym_nil] = ACTIONS(517),
    [sym_global_variable] = ACTIONS(15411),
    [sym_character] = ACTIONS(15405),
    [sym_super] = ACTIONS(15403),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [sym__unary_minus] = ACTIONS(15427),
    [anon_sym_next] = ACTIONS(15429),
    [anon_sym_while] = ACTIONS(1017),
    [sym_retry] = ACTIONS(15399),
    [sym_constant] = ACTIONS(15403),
    [anon_sym_defined_QMARK] = ACTIONS(15413),
    [sym_instance_variable] = ACTIONS(15411),
    [sym_integer] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(823),
    [sym__string_start] = ACTIONS(821),
    [sym__regex_start] = ACTIONS(863),
    [anon_sym_DASH_GT] = ACTIONS(827),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(517),
    [anon_sym_FALSE] = ACTIONS(567),
    [anon_sym_COLON_COLON] = ACTIONS(16505),
    [anon_sym_def] = ACTIONS(831),
    [sym_identifier] = ACTIONS(15403),
    [sym_redo] = ACTIONS(15399),
    [sym_class_variable] = ACTIONS(15411),
    [sym__string_array_start] = ACTIONS(797),
    [anon_sym_return] = ACTIONS(15401),
  },
  [12429] = {
    [anon_sym_LT] = ACTIONS(15437),
    [anon_sym_SLASH] = ACTIONS(15439),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15443),
    [anon_sym_GT_GT] = ACTIONS(15445),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15447),
    [anon_sym_LT_LT] = ACTIONS(15445),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(15443),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(15451),
    [anon_sym_AMP] = ACTIONS(15453),
    [anon_sym_GT] = ACTIONS(15437),
    [anon_sym_PERCENT] = ACTIONS(15439),
    [sym__binary_star] = ACTIONS(15439),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_when] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(15455),
    [anon_sym_BANG_TILDE] = ACTIONS(15443),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15443),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15457),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15443),
    [anon_sym_STAR_STAR] = ACTIONS(15439),
    [anon_sym_PIPE] = ACTIONS(15461),
    [anon_sym_DOT_DOT] = ACTIONS(15459),
    [anon_sym_AMP_AMP] = ACTIONS(15443),
    [anon_sym_LT_EQ_GT] = ACTIONS(15443),
    [anon_sym_LT_EQ] = ACTIONS(15437),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(15463),
    [sym__binary_minus] = ACTIONS(15451),
  },
  [12430] = {
    [aux_sym_exceptions_repeat1] = STATE(12430),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17621),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12431] = {
    [anon_sym_LT] = ACTIONS(15478),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(15480),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15482),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15484),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15486),
    [anon_sym_LT_LT] = ACTIONS(15484),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15488),
    [anon_sym_EQ_TILDE] = ACTIONS(15488),
    [anon_sym_PLUS] = ACTIONS(15490),
    [anon_sym_AMP] = ACTIONS(15492),
    [anon_sym_GT] = ACTIONS(15478),
    [anon_sym_PERCENT] = ACTIONS(15480),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(15494),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(15496),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15496),
    [anon_sym_BANG_TILDE] = ACTIONS(15488),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15498),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(15488),
    [anon_sym_STAR_STAR] = ACTIONS(15480),
    [anon_sym_PIPE] = ACTIONS(15500),
    [anon_sym_DOT_DOT] = ACTIONS(15502),
    [anon_sym_AMP_AMP] = ACTIONS(15496),
    [anon_sym_LT_EQ_GT] = ACTIONS(15488),
    [anon_sym_LT_EQ] = ACTIONS(15478),
    [sym__binary_minus] = ACTIONS(15504),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(15500),
  },
  [12432] = {
    [aux_sym_exceptions_repeat1] = STATE(12432),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_then] = ACTIONS(13577),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17624),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12433] = {
    [anon_sym_LT] = ACTIONS(15586),
    [anon_sym_then] = ACTIONS(14222),
    [anon_sym_SLASH] = ACTIONS(15588),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15590),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15594),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15596),
    [anon_sym_LT_LT] = ACTIONS(15594),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15592),
    [anon_sym_EQ_TILDE] = ACTIONS(15592),
    [anon_sym_PLUS] = ACTIONS(15600),
    [anon_sym_AMP] = ACTIONS(15602),
    [anon_sym_GT] = ACTIONS(15586),
    [anon_sym_PERCENT] = ACTIONS(15588),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(15588),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(15604),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15592),
    [anon_sym_BANG_TILDE] = ACTIONS(15592),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15606),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(15592),
    [anon_sym_STAR_STAR] = ACTIONS(15588),
    [anon_sym_PIPE] = ACTIONS(15610),
    [anon_sym_DOT_DOT] = ACTIONS(15608),
    [anon_sym_AMP_AMP] = ACTIONS(15592),
    [anon_sym_LT_EQ_GT] = ACTIONS(15592),
    [anon_sym_LT_EQ] = ACTIONS(15586),
    [sym__binary_minus] = ACTIONS(15600),
    [anon_sym_CARET] = ACTIONS(15612),
  },
  [12434] = {
    [aux_sym_exceptions_repeat1] = STATE(12434),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17627),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12435] = {
    [anon_sym_LT] = ACTIONS(15699),
    [anon_sym_SLASH] = ACTIONS(15701),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15703),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15705),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15707),
    [anon_sym_LT_LT] = ACTIONS(15705),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15709),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(15709),
    [anon_sym_AMP] = ACTIONS(15711),
    [anon_sym_GT] = ACTIONS(15699),
    [anon_sym_PLUS] = ACTIONS(15713),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(15701),
    [anon_sym_rescue] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(15701),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(15715),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(15709),
    [anon_sym_PIPE_PIPE] = ACTIONS(15709),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15717),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(15709),
    [anon_sym_STAR_STAR] = ACTIONS(15701),
    [anon_sym_PIPE] = ACTIONS(15719),
    [anon_sym_DOT_DOT] = ACTIONS(15721),
    [anon_sym_AMP_AMP] = ACTIONS(15709),
    [anon_sym_LT_EQ_GT] = ACTIONS(15709),
    [anon_sym_LT_EQ] = ACTIONS(15699),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(15723),
    [sym__binary_minus] = ACTIONS(15713),
  },
  [12436] = {
    [anon_sym_LT] = ACTIONS(15757),
    [anon_sym_SLASH] = ACTIONS(15759),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(15761),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15763),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15765),
    [anon_sym_LT_LT] = ACTIONS(15763),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15767),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(15767),
    [anon_sym_AMP] = ACTIONS(15769),
    [anon_sym_GT] = ACTIONS(15757),
    [anon_sym_PLUS] = ACTIONS(15771),
    [anon_sym_PERCENT] = ACTIONS(15759),
    [sym__binary_star] = ACTIONS(15759),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(15773),
    [anon_sym_BANG_TILDE] = ACTIONS(15767),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15767),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(15775),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(15767),
    [anon_sym_STAR_STAR] = ACTIONS(15759),
    [anon_sym_PIPE] = ACTIONS(15777),
    [anon_sym_DOT_DOT] = ACTIONS(15779),
    [anon_sym_AMP_AMP] = ACTIONS(15767),
    [anon_sym_LT_EQ_GT] = ACTIONS(15767),
    [anon_sym_LT_EQ] = ACTIONS(15757),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(15781),
    [sym__binary_minus] = ACTIONS(15771),
  },
  [12437] = {
    [aux_sym_exceptions_repeat1] = STATE(12437),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17630),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_elsif] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12438] = {
    [anon_sym_SLASH] = ACTIONS(15791),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15793),
    [anon_sym_EQ_TILDE] = ACTIONS(15793),
    [anon_sym_LT_LT] = ACTIONS(15795),
    [sym__binary_star] = ACTIONS(15797),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(15799),
    [anon_sym_AMP] = ACTIONS(15801),
    [anon_sym_PERCENT] = ACTIONS(15791),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(15793),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(15803),
    [anon_sym_PIPE] = ACTIONS(15805),
    [anon_sym_DOT_DOT] = ACTIONS(15807),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(15803),
    [anon_sym_QMARK] = ACTIONS(15809),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(15795),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15811),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(15803),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(15813),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(15813),
    [anon_sym_GT_EQ] = ACTIONS(15815),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_elsif] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(15793),
    [anon_sym_STAR_STAR] = ACTIONS(15791),
    [anon_sym_LT_EQ_GT] = ACTIONS(15793),
    [anon_sym_AMP_AMP] = ACTIONS(15813),
    [sym__binary_minus] = ACTIONS(15817),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(15805),
  },
  [12439] = {
    [anon_sym_SLASH] = ACTIONS(16492),
    [anon_sym_RBRACK] = ACTIONS(16494),
    [anon_sym_until] = ACTIONS(16494),
    [anon_sym_AMP_EQ] = ACTIONS(16494),
    [anon_sym_GT_GT_EQ] = ACTIONS(16494),
    [anon_sym_SLASH_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16494),
    [anon_sym_RPAREN] = ACTIONS(16494),
    [anon_sym_EQ_TILDE] = ACTIONS(16494),
    [anon_sym_LT_LT] = ACTIONS(16492),
    [anon_sym_RBRACE] = ACTIONS(16494),
    [sym__binary_star] = ACTIONS(16494),
    [anon_sym_unless] = ACTIONS(16494),
    [anon_sym_PLUS] = ACTIONS(16492),
    [anon_sym_AMP] = ACTIONS(16492),
    [anon_sym_PERCENT] = ACTIONS(16492),
    [anon_sym_COLON_COLON2] = ACTIONS(16494),
    [anon_sym_rescue] = ACTIONS(16494),
    [anon_sym_PERCENT_EQ] = ACTIONS(16494),
    [anon_sym_LT_LT_EQ] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_DOT] = ACTIONS(16492),
    [anon_sym_BANG_TILDE] = ACTIONS(16494),
    [anon_sym_LBRACE] = ACTIONS(16494),
    [anon_sym_COLON2] = ACTIONS(16492),
    [anon_sym_while] = ACTIONS(16494),
    [sym__heredoc_body_start] = ACTIONS(16494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(16494),
    [anon_sym_CARET_EQ] = ACTIONS(16494),
    [anon_sym_AMP_DOT] = ACTIONS(16494),
    [anon_sym_LT_EQ] = ACTIONS(16492),
    [anon_sym_PIPE] = ACTIONS(16492),
    [anon_sym_DOT_DOT] = ACTIONS(16492),
    [anon_sym_EQ] = ACTIONS(16492),
    [anon_sym_LT] = ACTIONS(16492),
    [anon_sym_in] = ACTIONS(16494),
    [anon_sym_QMARK] = ACTIONS(16494),
    [anon_sym_COMMA] = ACTIONS(16494),
    [anon_sym_GT_GT] = ACTIONS(16492),
    [anon_sym_SEMI] = ACTIONS(16494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16494),
    [anon_sym_or] = ACTIONS(16494),
    [anon_sym_GT] = ACTIONS(16492),
    [anon_sym_PIPE_EQ] = ACTIONS(16494),
    [anon_sym_PLUS_EQ] = ACTIONS(16494),
    [anon_sym_STAR_EQ] = ACTIONS(16494),
    [anon_sym_EQ_EQ] = ACTIONS(16492),
    [anon_sym_and] = ACTIONS(16494),
    [anon_sym_PIPE_PIPE] = ACTIONS(16492),
    [anon_sym_GT_EQ] = ACTIONS(16494),
    [anon_sym_LBRACK] = ACTIONS(16494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(16494),
    [anon_sym_DASH_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(16494),
    [anon_sym_BANG_EQ] = ACTIONS(16494),
    [anon_sym_STAR_STAR] = ACTIONS(16492),
    [anon_sym_LT_EQ_GT] = ACTIONS(16494),
    [sym__binary_minus] = ACTIONS(16494),
    [anon_sym_AMP_AMP] = ACTIONS(16492),
    [anon_sym_if] = ACTIONS(16494),
    [anon_sym_CARET] = ACTIONS(16492),
  },
  [12440] = {
    [sym_assignment] = STATE(12308),
    [sym_unary] = STATE(12308),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12308),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_splat_argument] = STATE(10132),
    [sym_operator_assignment] = STATE(12308),
    [sym_conditional] = STATE(12308),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_return] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_true] = STATE(11462),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym__arg_or_splat_arg] = STATE(10132),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12308),
    [sym_binary] = STATE(12308),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [sym__splat_star] = ACTIONS(15057),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [anon_sym_class] = ACTIONS(1427),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [sym_global_variable] = ACTIONS(16246),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(16238),
    [sym_character] = ACTIONS(16242),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12441] = {
    [aux_sym_exceptions_repeat1] = STATE(12468),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17633),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
  },
  [12442] = {
    [sym_assignment] = STATE(12469),
    [sym_unary] = STATE(12469),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11462),
    [sym_singleton_class] = STATE(11464),
    [sym_module] = STATE(11464),
    [sym_chained_string] = STATE(11464),
    [sym_until] = STATE(11464),
    [sym_regex] = STATE(11464),
    [sym_for] = STATE(11464),
    [sym_symbol] = STATE(11464),
    [sym_if] = STATE(11464),
    [sym_begin] = STATE(11464),
    [sym__arg] = STATE(12469),
    [sym__primary] = STATE(11464),
    [sym_method_call] = STATE(11462),
    [sym_operator_assignment] = STATE(12469),
    [sym_conditional] = STATE(12469),
    [sym_method] = STATE(11464),
    [sym_singleton_method] = STATE(11464),
    [sym__variable] = STATE(11465),
    [sym_left_assignment_list] = STATE(11466),
    [sym_rational] = STATE(11464),
    [sym_true] = STATE(11462),
    [sym_return] = STATE(11464),
    [sym_subshell] = STATE(11464),
    [sym_yield] = STATE(11464),
    [sym_string] = STATE(11467),
    [sym_unless] = STATE(11464),
    [sym_lambda] = STATE(11464),
    [sym_parenthesized_statements] = STATE(11464),
    [sym_element_reference] = STATE(11462),
    [sym_range] = STATE(12469),
    [sym_binary] = STATE(12469),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11464),
    [sym_break] = STATE(11464),
    [sym_next] = STATE(11464),
    [sym_string_array] = STATE(11464),
    [sym_while] = STATE(11464),
    [sym_case] = STATE(11464),
    [sym_symbol_array] = STATE(11464),
    [sym_array] = STATE(11464),
    [sym_hash] = STATE(11464),
    [sym_false] = STATE(11462),
    [sym_nil] = STATE(11462),
    [sym_scope_resolution] = STATE(11465),
    [sym_call] = STATE(11465),
    [sym__symbol_start] = ACTIONS(1395),
    [sym_float] = ACTIONS(16230),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16232),
    [anon_sym_until] = ACTIONS(1403),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(16234),
    [anon_sym_not] = ACTIONS(16236),
    [sym_self] = ACTIONS(16238),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(16240),
    [anon_sym_unless] = ACTIONS(1419),
    [sym__symbol_array_start] = ACTIONS(1421),
    [sym__subshell_start] = ACTIONS(1423),
    [sym__simple_symbol] = ACTIONS(1425),
    [anon_sym_class] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16242),
    [anon_sym_module] = ACTIONS(1433),
    [anon_sym_begin] = ACTIONS(1435),
    [sym_complex] = ACTIONS(16242),
    [anon_sym_PLUS] = ACTIONS(16244),
    [anon_sym_TILDE] = ACTIONS(16234),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16246),
    [sym_character] = ACTIONS(16242),
    [sym_super] = ACTIONS(16238),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [sym__unary_minus] = ACTIONS(16248),
    [anon_sym_next] = ACTIONS(16250),
    [anon_sym_while] = ACTIONS(1451),
    [sym_retry] = ACTIONS(16230),
    [sym_constant] = ACTIONS(16238),
    [anon_sym_defined_QMARK] = ACTIONS(16252),
    [sym_instance_variable] = ACTIONS(16246),
    [sym_integer] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1457),
    [sym__string_start] = ACTIONS(1459),
    [sym__regex_start] = ACTIONS(1461),
    [anon_sym_DASH_GT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(16238),
    [sym_redo] = ACTIONS(16230),
    [sym_class_variable] = ACTIONS(16246),
    [sym__string_array_start] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(16256),
  },
  [12443] = {
    [anon_sym_SLASH] = ACTIONS(5452),
    [sym_float] = ACTIONS(5452),
    [sym__string_array_start] = ACTIONS(5454),
    [sym__binary_minus] = ACTIONS(5454),
    [anon_sym_until] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [sym_self] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5454),
    [anon_sym_EQ_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [sym__binary_star] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_unless] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_complex] = ACTIONS(5454),
    [anon_sym_COLON_COLON2] = ACTIONS(5454),
    [sym_super] = ACTIONS(5452),
    [sym__simple_symbol] = ACTIONS(5454),
    [sym__symbol_array_start] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_LBRACK2] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_nil] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5454),
    [sym_character] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_BANG_TILDE] = ACTIONS(5454),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [sym_heredoc_beginning] = ACTIONS(5454),
    [sym_constant] = ACTIONS(5452),
    [anon_sym_while] = ACTIONS(5452),
    [sym_instance_variable] = ACTIONS(5454),
    [sym__heredoc_body_start] = ACTIONS(5454),
    [anon_sym_defined_QMARK] = ACTIONS(5454),
    [sym__string_start] = ACTIONS(5454),
    [anon_sym_true] = ACTIONS(5452),
    [anon_sym_for] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_NIL] = ACTIONS(5452),
    [anon_sym_AMP_DOT] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_def] = ACTIONS(5452),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_yield] = ACTIONS(5452),
    [sym_class_variable] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_not] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [sym__symbol_start] = ACTIONS(5454),
    [anon_sym_TRUE] = ACTIONS(5452),
    [sym__block_ampersand] = ACTIONS(5454),
    [sym__identifier_hash_key] = ACTIONS(5454),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_break] = ACTIONS(5452),
    [sym_global_variable] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5452),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_module] = ACTIONS(5452),
    [anon_sym_begin] = ACTIONS(5452),
    [anon_sym_false] = ACTIONS(5452),
    [sym__subshell_start] = ACTIONS(5454),
    [sym__splat_star] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_next] = ACTIONS(5452),
    [sym__unary_minus] = ACTIONS(5454),
    [sym_retry] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [sym__regex_start] = ACTIONS(5454),
    [sym_integer] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_FALSE] = ACTIONS(5452),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [sym_redo] = ACTIONS(5452),
    [anon_sym_BANG] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_return] = ACTIONS(5452),
  },
  [12444] = {
    [anon_sym_RPAREN] = ACTIONS(17635),
    [sym_comment] = ACTIONS(49),
  },
  [12445] = {
    [anon_sym_SLASH] = ACTIONS(10960),
    [sym_float] = ACTIONS(10960),
    [sym__string_array_start] = ACTIONS(10962),
    [sym__binary_minus] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [sym_self] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10962),
    [anon_sym_TILDE] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_complex] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [sym_super] = ACTIONS(10960),
    [sym__simple_symbol] = ACTIONS(10962),
    [sym__symbol_array_start] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_LBRACK2] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_nil] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [sym_character] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [sym_heredoc_beginning] = ACTIONS(10962),
    [sym_constant] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [sym_instance_variable] = ACTIONS(10962),
    [sym__heredoc_body_start] = ACTIONS(10962),
    [anon_sym_defined_QMARK] = ACTIONS(10962),
    [sym__string_start] = ACTIONS(10962),
    [anon_sym_true] = ACTIONS(10960),
    [anon_sym_for] = ACTIONS(10960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_DASH_GT] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_NIL] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_COLON_COLON] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10960),
    [anon_sym_def] = ACTIONS(10960),
    [sym_identifier] = ACTIONS(10960),
    [anon_sym_yield] = ACTIONS(10960),
    [sym_class_variable] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10960),
    [anon_sym_not] = ACTIONS(10960),
    [anon_sym_LT] = ACTIONS(10960),
    [sym__symbol_start] = ACTIONS(10962),
    [anon_sym_TRUE] = ACTIONS(10960),
    [sym__block_ampersand] = ACTIONS(10962),
    [sym__identifier_hash_key] = ACTIONS(10962),
    [anon_sym_case] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_LPAREN2] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_LPAREN] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_break] = ACTIONS(10960),
    [sym_global_variable] = ACTIONS(10962),
    [anon_sym_class] = ACTIONS(10960),
    [anon_sym_GT] = ACTIONS(10960),
    [anon_sym_module] = ACTIONS(10960),
    [anon_sym_begin] = ACTIONS(10960),
    [anon_sym_false] = ACTIONS(10960),
    [sym__subshell_start] = ACTIONS(10962),
    [sym__splat_star] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10960),
    [anon_sym_STAR] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_next] = ACTIONS(10960),
    [sym__unary_minus] = ACTIONS(10962),
    [sym_retry] = ACTIONS(10960),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [sym__regex_start] = ACTIONS(10962),
    [sym_integer] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_FALSE] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [sym_redo] = ACTIONS(10960),
    [anon_sym_BANG] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_return] = ACTIONS(10960),
  },
  [12446] = {
    [aux_sym_exceptions_repeat1] = STATE(12446),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17637),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12447] = {
    [anon_sym_LT] = ACTIONS(16264),
    [anon_sym_SLASH] = ACTIONS(16266),
    [anon_sym_QMARK] = ACTIONS(16268),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(16270),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16272),
    [anon_sym_LT_LT] = ACTIONS(16270),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16274),
    [anon_sym_EQ_TILDE] = ACTIONS(16274),
    [anon_sym_PLUS] = ACTIONS(16276),
    [anon_sym_AMP] = ACTIONS(16278),
    [anon_sym_GT] = ACTIONS(16264),
    [anon_sym_PERCENT] = ACTIONS(16266),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(16266),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(16280),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(16274),
    [anon_sym_PIPE_PIPE] = ACTIONS(16274),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(16282),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(16274),
    [anon_sym_STAR_STAR] = ACTIONS(16266),
    [anon_sym_PIPE] = ACTIONS(16284),
    [anon_sym_DOT_DOT] = ACTIONS(16286),
    [anon_sym_AMP_AMP] = ACTIONS(16274),
    [anon_sym_LT_EQ_GT] = ACTIONS(16274),
    [anon_sym_LT_EQ] = ACTIONS(16264),
    [sym__binary_minus] = ACTIONS(16276),
    [anon_sym_CARET] = ACTIONS(16288),
  },
  [12448] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12449] = {
    [sym_assignment] = STATE(12343),
    [sym_unary] = STATE(12343),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12343),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_splat_argument] = STATE(11983),
    [sym_operator_assignment] = STATE(12343),
    [sym_conditional] = STATE(12343),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_return] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_true] = STATE(11528),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym__arg_or_splat_arg] = STATE(11983),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12343),
    [sym_binary] = STATE(12343),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [sym__splat_star] = ACTIONS(15131),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [anon_sym_class] = ACTIONS(8136),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [sym_global_variable] = ACTIONS(16344),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_super] = ACTIONS(16336),
    [sym_character] = ACTIONS(16340),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12450] = {
    [aux_sym_exceptions_repeat1] = STATE(12471),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10971),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17640),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12451] = {
    [sym_assignment] = STATE(12472),
    [sym_unary] = STATE(12472),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11528),
    [sym_singleton_class] = STATE(11530),
    [sym_module] = STATE(11530),
    [sym_chained_string] = STATE(11530),
    [sym_until] = STATE(11530),
    [sym_regex] = STATE(11530),
    [sym_for] = STATE(11530),
    [sym_symbol] = STATE(11530),
    [sym_if] = STATE(11530),
    [sym_begin] = STATE(11530),
    [sym__arg] = STATE(12472),
    [sym__primary] = STATE(11530),
    [sym_method_call] = STATE(11528),
    [sym_operator_assignment] = STATE(12472),
    [sym_conditional] = STATE(12472),
    [sym_method] = STATE(11530),
    [sym_singleton_method] = STATE(11530),
    [sym__variable] = STATE(11531),
    [sym_left_assignment_list] = STATE(11532),
    [sym_rational] = STATE(11530),
    [sym_true] = STATE(11528),
    [sym_return] = STATE(11530),
    [sym_subshell] = STATE(11530),
    [sym_yield] = STATE(11530),
    [sym_string] = STATE(11533),
    [sym_unless] = STATE(11530),
    [sym_lambda] = STATE(11530),
    [sym_parenthesized_statements] = STATE(11530),
    [sym_element_reference] = STATE(11528),
    [sym_range] = STATE(12472),
    [sym_binary] = STATE(12472),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11530),
    [sym_break] = STATE(11530),
    [sym_next] = STATE(11530),
    [sym_string_array] = STATE(11530),
    [sym_while] = STATE(11530),
    [sym_case] = STATE(11530),
    [sym_symbol_array] = STATE(11530),
    [sym_array] = STATE(11530),
    [sym_hash] = STATE(11530),
    [sym_false] = STATE(11528),
    [sym_nil] = STATE(11528),
    [sym_scope_resolution] = STATE(11531),
    [sym_call] = STATE(11531),
    [sym__symbol_start] = ACTIONS(8106),
    [sym_float] = ACTIONS(16328),
    [anon_sym_TRUE] = ACTIONS(1399),
    [anon_sym_yield] = ACTIONS(16330),
    [anon_sym_until] = ACTIONS(8112),
    [anon_sym_case] = ACTIONS(8114),
    [anon_sym_if] = ACTIONS(8116),
    [anon_sym_BANG] = ACTIONS(16332),
    [anon_sym_not] = ACTIONS(16334),
    [sym_self] = ACTIONS(16336),
    [anon_sym_LPAREN] = ACTIONS(8124),
    [anon_sym_break] = ACTIONS(16338),
    [anon_sym_unless] = ACTIONS(8128),
    [sym__symbol_array_start] = ACTIONS(8130),
    [sym__subshell_start] = ACTIONS(8132),
    [sym__simple_symbol] = ACTIONS(8134),
    [anon_sym_class] = ACTIONS(8136),
    [anon_sym_false] = ACTIONS(1429),
    [sym_heredoc_beginning] = ACTIONS(16340),
    [anon_sym_module] = ACTIONS(8140),
    [anon_sym_begin] = ACTIONS(8142),
    [sym_complex] = ACTIONS(16340),
    [anon_sym_PLUS] = ACTIONS(16342),
    [anon_sym_TILDE] = ACTIONS(16332),
    [anon_sym_nil] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(16344),
    [sym_character] = ACTIONS(16340),
    [sym_super] = ACTIONS(16336),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(8148),
    [anon_sym_LBRACE] = ACTIONS(8150),
    [sym__unary_minus] = ACTIONS(16346),
    [anon_sym_next] = ACTIONS(16348),
    [anon_sym_while] = ACTIONS(8156),
    [sym_retry] = ACTIONS(16328),
    [sym_constant] = ACTIONS(16336),
    [anon_sym_defined_QMARK] = ACTIONS(16350),
    [sym_instance_variable] = ACTIONS(16344),
    [sym_integer] = ACTIONS(8160),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(8162),
    [sym__string_start] = ACTIONS(8164),
    [sym__regex_start] = ACTIONS(8166),
    [anon_sym_DASH_GT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(1439),
    [anon_sym_FALSE] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(16254),
    [anon_sym_def] = ACTIONS(8170),
    [sym_identifier] = ACTIONS(16336),
    [sym_redo] = ACTIONS(16328),
    [sym_class_variable] = ACTIONS(16344),
    [sym__string_array_start] = ACTIONS(8172),
    [anon_sym_return] = ACTIONS(16352),
  },
  [12452] = {
    [aux_sym_exceptions_repeat1] = STATE(12452),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17642),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12453] = {
    [anon_sym_LT] = ACTIONS(16362),
    [anon_sym_SLASH] = ACTIONS(16364),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(16366),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(16368),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16370),
    [anon_sym_LT_LT] = ACTIONS(16368),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16372),
    [anon_sym_EQ_TILDE] = ACTIONS(16372),
    [anon_sym_PLUS] = ACTIONS(16374),
    [anon_sym_AMP] = ACTIONS(16376),
    [anon_sym_GT] = ACTIONS(16362),
    [anon_sym_PERCENT] = ACTIONS(16364),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(16378),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(16380),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(16380),
    [anon_sym_BANG_TILDE] = ACTIONS(16372),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(16382),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(16372),
    [anon_sym_STAR_STAR] = ACTIONS(16364),
    [anon_sym_PIPE] = ACTIONS(16384),
    [anon_sym_DOT_DOT] = ACTIONS(16386),
    [anon_sym_AMP_AMP] = ACTIONS(16380),
    [anon_sym_LT_EQ_GT] = ACTIONS(16372),
    [anon_sym_LT_EQ] = ACTIONS(16362),
    [sym__binary_minus] = ACTIONS(16388),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(16384),
  },
  [12454] = {
    [sym_heredoc_body] = STATE(12454),
    [aux_sym_call_repeat1] = STATE(12454),
    [anon_sym_LT] = ACTIONS(9772),
    [anon_sym_SLASH] = ACTIONS(9774),
    [sym__line_break] = ACTIONS(9774),
    [anon_sym_until] = ACTIONS(9774),
    [anon_sym_QMARK] = ACTIONS(9774),
    [anon_sym_COMMA] = ACTIONS(9774),
    [anon_sym_GT_GT] = ACTIONS(9774),
    [anon_sym_SEMI] = ACTIONS(9774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9774),
    [anon_sym_LT_LT] = ACTIONS(9774),
    [anon_sym_or] = ACTIONS(9774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9774),
    [anon_sym_unless] = ACTIONS(9774),
    [anon_sym_EQ_TILDE] = ACTIONS(9774),
    [anon_sym_AMP] = ACTIONS(9772),
    [anon_sym_GT] = ACTIONS(9772),
    [anon_sym_PLUS] = ACTIONS(9774),
    [anon_sym_COLON_COLON2] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_rescue] = ACTIONS(9774),
    [anon_sym_when] = ACTIONS(9774),
    [sym__binary_star] = ACTIONS(9774),
    [anon_sym_DOT] = ACTIONS(9772),
    [anon_sym_EQ_EQ] = ACTIONS(9772),
    [anon_sym_and] = ACTIONS(9774),
    [anon_sym_BANG_TILDE] = ACTIONS(9774),
    [anon_sym_PIPE_PIPE] = ACTIONS(9774),
    [anon_sym_while] = ACTIONS(9774),
    [sym__heredoc_body_start] = ACTIONS(9776),
    [anon_sym_GT_EQ] = ACTIONS(9774),
    [anon_sym_end] = ACTIONS(9774),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_LBRACK] = ACTIONS(9774),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9774),
    [anon_sym_BANG_EQ] = ACTIONS(9774),
    [anon_sym_STAR_STAR] = ACTIONS(9774),
    [anon_sym_PIPE] = ACTIONS(9772),
    [anon_sym_DOT_DOT] = ACTIONS(9772),
    [anon_sym_AMP_AMP] = ACTIONS(9774),
    [anon_sym_LT_EQ_GT] = ACTIONS(9774),
    [anon_sym_LT_EQ] = ACTIONS(9772),
    [anon_sym_if] = ACTIONS(9774),
    [anon_sym_CARET] = ACTIONS(9774),
    [sym__binary_minus] = ACTIONS(9774),
  },
  [12455] = {
    [sym_heredoc_body] = STATE(12454),
    [aux_sym_call_repeat1] = STATE(12454),
    [anon_sym_LT] = ACTIONS(9779),
    [anon_sym_SLASH] = ACTIONS(9781),
    [sym__line_break] = ACTIONS(9781),
    [anon_sym_until] = ACTIONS(9781),
    [anon_sym_QMARK] = ACTIONS(9781),
    [anon_sym_COMMA] = ACTIONS(9781),
    [anon_sym_GT_GT] = ACTIONS(9781),
    [anon_sym_SEMI] = ACTIONS(9781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9781),
    [anon_sym_LT_LT] = ACTIONS(9781),
    [anon_sym_or] = ACTIONS(9781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9781),
    [anon_sym_unless] = ACTIONS(9781),
    [anon_sym_EQ_TILDE] = ACTIONS(9781),
    [anon_sym_AMP] = ACTIONS(9779),
    [anon_sym_GT] = ACTIONS(9779),
    [anon_sym_PLUS] = ACTIONS(9781),
    [anon_sym_COLON_COLON2] = ACTIONS(9781),
    [anon_sym_PERCENT] = ACTIONS(9781),
    [anon_sym_rescue] = ACTIONS(9781),
    [anon_sym_when] = ACTIONS(9781),
    [sym__binary_star] = ACTIONS(9781),
    [anon_sym_DOT] = ACTIONS(9779),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_and] = ACTIONS(9781),
    [anon_sym_BANG_TILDE] = ACTIONS(9781),
    [anon_sym_PIPE_PIPE] = ACTIONS(9781),
    [anon_sym_while] = ACTIONS(9781),
    [sym__heredoc_body_start] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_end] = ACTIONS(9781),
    [anon_sym_else] = ACTIONS(9781),
    [anon_sym_LBRACK] = ACTIONS(9781),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(9781),
    [anon_sym_BANG_EQ] = ACTIONS(9781),
    [anon_sym_STAR_STAR] = ACTIONS(9781),
    [anon_sym_PIPE] = ACTIONS(9779),
    [anon_sym_DOT_DOT] = ACTIONS(9779),
    [anon_sym_AMP_AMP] = ACTIONS(9781),
    [anon_sym_LT_EQ_GT] = ACTIONS(9781),
    [anon_sym_LT_EQ] = ACTIONS(9779),
    [anon_sym_if] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9781),
    [sym__binary_minus] = ACTIONS(9781),
  },
  [12456] = {
    [sym_assignment] = STATE(12373),
    [sym_unary] = STATE(12373),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12373),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_splat_argument] = STATE(6879),
    [sym_operator_assignment] = STATE(12373),
    [sym_conditional] = STATE(12373),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_return] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_true] = STATE(11639),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym__arg_or_splat_arg] = STATE(6879),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12373),
    [sym_binary] = STATE(12373),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [sym__splat_star] = ACTIONS(15367),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(71),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [sym_global_variable] = ACTIONS(13326),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(13318),
    [sym_character] = ACTIONS(13320),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12457] = {
    [aux_sym_exceptions_repeat1] = STATE(12473),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_SLASH] = ACTIONS(10973),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17645),
    [anon_sym_GT_GT] = ACTIONS(10973),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_PLUS] = ACTIONS(10973),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_PERCENT] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_when] = ACTIONS(10973),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10973),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_AMP_AMP] = ACTIONS(10973),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10973),
    [sym__binary_minus] = ACTIONS(10973),
  },
  [12458] = {
    [sym_assignment] = STATE(12474),
    [sym_unary] = STATE(12474),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11639),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12474),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11639),
    [sym_operator_assignment] = STATE(12474),
    [sym_conditional] = STATE(12474),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11641),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11639),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11639),
    [sym_range] = STATE(12474),
    [sym_binary] = STATE(12474),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11639),
    [sym_nil] = STATE(11639),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16523),
    [anon_sym_not] = ACTIONS(16525),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16529),
    [anon_sym_TILDE] = ACTIONS(16523),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16531),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16535),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12459] = {
    [aux_sym_exceptions_repeat1] = STATE(12459),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17647),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12460] = {
    [anon_sym_LT] = ACTIONS(16545),
    [anon_sym_SLASH] = ACTIONS(16547),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(16549),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(16551),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16553),
    [anon_sym_LT_LT] = ACTIONS(16551),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16555),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(16555),
    [anon_sym_AMP] = ACTIONS(16557),
    [anon_sym_GT] = ACTIONS(16545),
    [anon_sym_PLUS] = ACTIONS(16559),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_when] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(16547),
    [sym__binary_star] = ACTIONS(16547),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(16561),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(16555),
    [anon_sym_PIPE_PIPE] = ACTIONS(16555),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(16563),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(16555),
    [anon_sym_STAR_STAR] = ACTIONS(16547),
    [anon_sym_PIPE] = ACTIONS(16565),
    [anon_sym_DOT_DOT] = ACTIONS(16567),
    [anon_sym_AMP_AMP] = ACTIONS(16555),
    [anon_sym_LT_EQ_GT] = ACTIONS(16555),
    [anon_sym_LT_EQ] = ACTIONS(16545),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(16569),
    [sym__binary_minus] = ACTIONS(16559),
  },
  [12461] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym__line_break] = ACTIONS(9738),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [sym__symbol_array_start] = ACTIONS(9738),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_rescue] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_LT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [anon_sym_when] = ACTIONS(9736),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [anon_sym_CARET] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12462] = {
    [sym_assignment] = STATE(12475),
    [sym_unary] = STATE(12475),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11688),
    [sym_singleton_class] = STATE(8790),
    [sym_module] = STATE(8790),
    [sym_chained_string] = STATE(8790),
    [sym_until] = STATE(8790),
    [sym_regex] = STATE(8790),
    [sym_for] = STATE(8790),
    [sym_symbol] = STATE(8790),
    [sym_if] = STATE(8790),
    [sym_begin] = STATE(8790),
    [sym__arg] = STATE(12475),
    [sym__primary] = STATE(8790),
    [sym_method_call] = STATE(11688),
    [sym_operator_assignment] = STATE(12475),
    [sym_conditional] = STATE(12475),
    [sym_method] = STATE(8790),
    [sym_singleton_method] = STATE(8790),
    [sym__variable] = STATE(8792),
    [sym_left_assignment_list] = STATE(11690),
    [sym_rational] = STATE(8790),
    [sym_true] = STATE(11688),
    [sym_return] = STATE(8790),
    [sym_subshell] = STATE(8790),
    [sym_yield] = STATE(8790),
    [sym_string] = STATE(11642),
    [sym_unless] = STATE(8790),
    [sym_lambda] = STATE(8790),
    [sym_parenthesized_statements] = STATE(8790),
    [sym_element_reference] = STATE(11688),
    [sym_range] = STATE(12475),
    [sym_binary] = STATE(12475),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(8790),
    [sym_break] = STATE(8790),
    [sym_next] = STATE(8790),
    [sym_string_array] = STATE(8790),
    [sym_while] = STATE(8790),
    [sym_case] = STATE(8790),
    [sym_symbol_array] = STATE(8790),
    [sym_array] = STATE(8790),
    [sym_hash] = STATE(8790),
    [sym_false] = STATE(11688),
    [sym_nil] = STATE(11688),
    [sym_scope_resolution] = STATE(8792),
    [sym_call] = STATE(8792),
    [sym__symbol_start] = ACTIONS(59),
    [sym_float] = ACTIONS(13314),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16521),
    [anon_sym_until] = ACTIONS(7),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(16603),
    [anon_sym_not] = ACTIONS(16605),
    [sym_self] = ACTIONS(13318),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(16527),
    [anon_sym_unless] = ACTIONS(17),
    [sym__symbol_array_start] = ACTIONS(23),
    [sym__subshell_start] = ACTIONS(73),
    [sym__simple_symbol] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(75),
    [anon_sym_begin] = ACTIONS(77),
    [sym_complex] = ACTIONS(13320),
    [anon_sym_PLUS] = ACTIONS(16609),
    [anon_sym_TILDE] = ACTIONS(16603),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(13326),
    [sym_character] = ACTIONS(13320),
    [sym_super] = ACTIONS(13318),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [sym__unary_minus] = ACTIONS(16611),
    [anon_sym_next] = ACTIONS(16533),
    [anon_sym_while] = ACTIONS(37),
    [sym_retry] = ACTIONS(13314),
    [sym_constant] = ACTIONS(13318),
    [anon_sym_defined_QMARK] = ACTIONS(16613),
    [sym_instance_variable] = ACTIONS(13326),
    [sym_integer] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(47),
    [sym__string_start] = ACTIONS(43),
    [sym__regex_start] = ACTIONS(89),
    [anon_sym_DASH_GT] = ACTIONS(51),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(55),
    [sym_identifier] = ACTIONS(13318),
    [sym_redo] = ACTIONS(13314),
    [sym_class_variable] = ACTIONS(13326),
    [sym__string_array_start] = ACTIONS(97),
    [anon_sym_return] = ACTIONS(16537),
  },
  [12463] = {
    [sym_assignment] = STATE(12413),
    [sym_unary] = STATE(12413),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12413),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_splat_argument] = STATE(11058),
    [sym_operator_assignment] = STATE(12413),
    [sym_conditional] = STATE(12413),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_return] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_true] = STATE(11704),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym__arg_or_splat_arg] = STATE(11058),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12413),
    [sym_binary] = STATE(12413),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__splat_star] = ACTIONS(15423),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3017),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_false] = ACTIONS(79),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [sym_global_variable] = ACTIONS(16637),
    [anon_sym_nil] = ACTIONS(31),
    [sym_super] = ACTIONS(16629),
    [sym_character] = ACTIONS(16633),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12464] = {
    [aux_sym_exceptions_repeat1] = STATE(12476),
    [anon_sym_SLASH] = ACTIONS(10971),
    [sym__line_break] = ACTIONS(10973),
    [anon_sym_until] = ACTIONS(10973),
    [anon_sym_AMP_EQ] = ACTIONS(10973),
    [anon_sym_GT_GT_EQ] = ACTIONS(10973),
    [anon_sym_SLASH_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10973),
    [anon_sym_EQ_TILDE] = ACTIONS(10973),
    [anon_sym_LT_LT] = ACTIONS(10971),
    [sym__binary_star] = ACTIONS(10973),
    [anon_sym_unless] = ACTIONS(10973),
    [anon_sym_PLUS] = ACTIONS(10971),
    [anon_sym_AMP] = ACTIONS(10971),
    [anon_sym_PERCENT] = ACTIONS(10971),
    [anon_sym_COLON_COLON2] = ACTIONS(10973),
    [anon_sym_rescue] = ACTIONS(10973),
    [anon_sym_PERCENT_EQ] = ACTIONS(10973),
    [anon_sym_LT_LT_EQ] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_DOT] = ACTIONS(10971),
    [anon_sym_BANG_TILDE] = ACTIONS(10973),
    [anon_sym_LBRACE] = ACTIONS(10973),
    [anon_sym_while] = ACTIONS(10973),
    [sym__heredoc_body_start] = ACTIONS(10973),
    [anon_sym_else] = ACTIONS(10973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(10973),
    [anon_sym_CARET_EQ] = ACTIONS(10973),
    [anon_sym_AMP_DOT] = ACTIONS(10973),
    [anon_sym_LT_EQ] = ACTIONS(10971),
    [anon_sym_PIPE] = ACTIONS(10971),
    [anon_sym_DOT_DOT] = ACTIONS(10971),
    [anon_sym_EQ] = ACTIONS(10971),
    [anon_sym_LT] = ACTIONS(10971),
    [anon_sym_QMARK] = ACTIONS(10973),
    [anon_sym_COMMA] = ACTIONS(17650),
    [anon_sym_GT_GT] = ACTIONS(10971),
    [anon_sym_SEMI] = ACTIONS(10973),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10973),
    [anon_sym_or] = ACTIONS(10973),
    [anon_sym_GT] = ACTIONS(10971),
    [anon_sym_when] = ACTIONS(10973),
    [anon_sym_PIPE_EQ] = ACTIONS(10973),
    [anon_sym_PLUS_EQ] = ACTIONS(10973),
    [anon_sym_STAR_EQ] = ACTIONS(10973),
    [anon_sym_EQ_EQ] = ACTIONS(10971),
    [anon_sym_and] = ACTIONS(10973),
    [anon_sym_PIPE_PIPE] = ACTIONS(10971),
    [anon_sym_GT_EQ] = ACTIONS(10973),
    [anon_sym_end] = ACTIONS(10973),
    [anon_sym_LBRACK] = ACTIONS(10973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10973),
    [anon_sym_DASH_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10973),
    [anon_sym_BANG_EQ] = ACTIONS(10973),
    [anon_sym_STAR_STAR] = ACTIONS(10971),
    [anon_sym_LT_EQ_GT] = ACTIONS(10973),
    [anon_sym_AMP_AMP] = ACTIONS(10971),
    [sym__binary_minus] = ACTIONS(10973),
    [anon_sym_if] = ACTIONS(10973),
    [anon_sym_CARET] = ACTIONS(10971),
  },
  [12465] = {
    [sym_assignment] = STATE(12477),
    [sym_unary] = STATE(12477),
    [sym_rest_assignment] = STATE(43),
    [sym__lhs] = STATE(11704),
    [sym_singleton_class] = STATE(11706),
    [sym_module] = STATE(11706),
    [sym_chained_string] = STATE(11706),
    [sym_until] = STATE(11706),
    [sym_regex] = STATE(11706),
    [sym_for] = STATE(11706),
    [sym_symbol] = STATE(11706),
    [sym_if] = STATE(11706),
    [sym_begin] = STATE(11706),
    [sym__arg] = STATE(12477),
    [sym__primary] = STATE(11706),
    [sym_method_call] = STATE(11704),
    [sym_operator_assignment] = STATE(12477),
    [sym_conditional] = STATE(12477),
    [sym_method] = STATE(11706),
    [sym_singleton_method] = STATE(11706),
    [sym__variable] = STATE(11707),
    [sym_left_assignment_list] = STATE(11708),
    [sym_rational] = STATE(11706),
    [sym_true] = STATE(11704),
    [sym_return] = STATE(11706),
    [sym_subshell] = STATE(11706),
    [sym_yield] = STATE(11706),
    [sym_string] = STATE(11709),
    [sym_unless] = STATE(11706),
    [sym_lambda] = STATE(11706),
    [sym_parenthesized_statements] = STATE(11706),
    [sym_element_reference] = STATE(11704),
    [sym_range] = STATE(12477),
    [sym_binary] = STATE(12477),
    [sym__mlhs] = STATE(46),
    [sym_destructured_left_assignment] = STATE(43),
    [sym_class] = STATE(11706),
    [sym_break] = STATE(11706),
    [sym_next] = STATE(11706),
    [sym_string_array] = STATE(11706),
    [sym_while] = STATE(11706),
    [sym_case] = STATE(11706),
    [sym_symbol_array] = STATE(11706),
    [sym_array] = STATE(11706),
    [sym_hash] = STATE(11706),
    [sym_false] = STATE(11704),
    [sym_nil] = STATE(11704),
    [sym_scope_resolution] = STATE(11707),
    [sym_call] = STATE(11707),
    [sym__symbol_start] = ACTIONS(2987),
    [sym_float] = ACTIONS(16621),
    [anon_sym_TRUE] = ACTIONS(45),
    [anon_sym_yield] = ACTIONS(16623),
    [anon_sym_until] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(16625),
    [anon_sym_not] = ACTIONS(16627),
    [sym_self] = ACTIONS(16629),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(16631),
    [anon_sym_unless] = ACTIONS(3009),
    [sym__symbol_array_start] = ACTIONS(3011),
    [sym__subshell_start] = ACTIONS(3013),
    [sym__simple_symbol] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_false] = ACTIONS(79),
    [sym_heredoc_beginning] = ACTIONS(16633),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3023),
    [sym_complex] = ACTIONS(16633),
    [anon_sym_PLUS] = ACTIONS(16635),
    [anon_sym_TILDE] = ACTIONS(16625),
    [anon_sym_nil] = ACTIONS(31),
    [sym_global_variable] = ACTIONS(16637),
    [sym_character] = ACTIONS(16633),
    [sym_super] = ACTIONS(16629),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [sym__unary_minus] = ACTIONS(16639),
    [anon_sym_next] = ACTIONS(16641),
    [anon_sym_while] = ACTIONS(3037),
    [sym_retry] = ACTIONS(16621),
    [sym_constant] = ACTIONS(16629),
    [anon_sym_defined_QMARK] = ACTIONS(16643),
    [sym_instance_variable] = ACTIONS(16637),
    [sym_integer] = ACTIONS(3041),
    [anon_sym_true] = ACTIONS(45),
    [anon_sym_for] = ACTIONS(3043),
    [sym__string_start] = ACTIONS(3045),
    [sym__regex_start] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3049),
    [sym_comment] = ACTIONS(49),
    [anon_sym_NIL] = ACTIONS(31),
    [anon_sym_FALSE] = ACTIONS(79),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_def] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(16629),
    [sym_redo] = ACTIONS(16621),
    [sym_class_variable] = ACTIONS(16637),
    [sym__string_array_start] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(16645),
  },
  [12466] = {
    [aux_sym_exceptions_repeat1] = STATE(12466),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17652),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_EQ_GT] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12467] = {
    [anon_sym_SLASH] = ACTIONS(16655),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(16657),
    [anon_sym_EQ_TILDE] = ACTIONS(16657),
    [anon_sym_LT_LT] = ACTIONS(16659),
    [sym__binary_star] = ACTIONS(16661),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(16663),
    [anon_sym_AMP] = ACTIONS(16665),
    [anon_sym_PERCENT] = ACTIONS(16655),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(16657),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(16667),
    [anon_sym_PIPE] = ACTIONS(16669),
    [anon_sym_DOT_DOT] = ACTIONS(16671),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(16667),
    [anon_sym_QMARK] = ACTIONS(16673),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(16659),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(16675),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(16667),
    [anon_sym_EQ_GT] = ACTIONS(14222),
    [anon_sym_when] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(16677),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(16677),
    [anon_sym_GT_EQ] = ACTIONS(16679),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(16657),
    [anon_sym_STAR_STAR] = ACTIONS(16655),
    [anon_sym_LT_EQ_GT] = ACTIONS(16657),
    [anon_sym_AMP_AMP] = ACTIONS(16677),
    [sym__binary_minus] = ACTIONS(16681),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(16669),
  },
  [12468] = {
    [aux_sym_exceptions_repeat1] = STATE(12468),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17655),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
  },
  [12469] = {
    [anon_sym_LT] = ACTIONS(17013),
    [anon_sym_SLASH] = ACTIONS(17015),
    [anon_sym_QMARK] = ACTIONS(17017),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(17019),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17021),
    [anon_sym_LT_LT] = ACTIONS(17019),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17023),
    [anon_sym_EQ_TILDE] = ACTIONS(17023),
    [anon_sym_PLUS] = ACTIONS(17025),
    [anon_sym_AMP] = ACTIONS(17027),
    [anon_sym_GT] = ACTIONS(17013),
    [anon_sym_PERCENT] = ACTIONS(17015),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(17015),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(17029),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(17023),
    [anon_sym_PIPE_PIPE] = ACTIONS(17023),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(17031),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(17023),
    [anon_sym_STAR_STAR] = ACTIONS(17015),
    [anon_sym_PIPE] = ACTIONS(17033),
    [anon_sym_DOT_DOT] = ACTIONS(17035),
    [anon_sym_AMP_AMP] = ACTIONS(17023),
    [anon_sym_LT_EQ_GT] = ACTIONS(17023),
    [anon_sym_LT_EQ] = ACTIONS(17013),
    [sym__binary_minus] = ACTIONS(17025),
    [anon_sym_CARET] = ACTIONS(17037),
  },
  [12470] = {
    [anon_sym_SLASH] = ACTIONS(9736),
    [sym_float] = ACTIONS(9736),
    [sym__string_array_start] = ACTIONS(9738),
    [sym__binary_minus] = ACTIONS(9738),
    [anon_sym_until] = ACTIONS(9736),
    [anon_sym_AMP_EQ] = ACTIONS(9738),
    [anon_sym_GT_GT_EQ] = ACTIONS(9738),
    [sym_self] = ACTIONS(9736),
    [anon_sym_SLASH_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9738),
    [anon_sym_EQ_TILDE] = ACTIONS(9738),
    [anon_sym_LT_LT] = ACTIONS(9736),
    [sym__binary_star] = ACTIONS(9738),
    [anon_sym_TILDE] = ACTIONS(9738),
    [anon_sym_unless] = ACTIONS(9736),
    [anon_sym_PLUS] = ACTIONS(9736),
    [anon_sym_AMP] = ACTIONS(9736),
    [anon_sym_PERCENT] = ACTIONS(9736),
    [sym_complex] = ACTIONS(9738),
    [anon_sym_COLON_COLON2] = ACTIONS(9738),
    [sym_super] = ACTIONS(9736),
    [sym__simple_symbol] = ACTIONS(9738),
    [sym__symbol_array_start] = ACTIONS(9738),
    [anon_sym_PERCENT_EQ] = ACTIONS(9738),
    [anon_sym_LBRACK2] = ACTIONS(9736),
    [anon_sym_LT_LT_EQ] = ACTIONS(9738),
    [anon_sym_nil] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9738),
    [sym_character] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_BANG_TILDE] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [sym_heredoc_beginning] = ACTIONS(9738),
    [sym_constant] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_instance_variable] = ACTIONS(9738),
    [sym__heredoc_body_start] = ACTIONS(9738),
    [anon_sym_defined_QMARK] = ACTIONS(9738),
    [sym__string_start] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_CARET_EQ] = ACTIONS(9738),
    [anon_sym_NIL] = ACTIONS(9736),
    [anon_sym_AMP_DOT] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_LT_EQ] = ACTIONS(9736),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_DOT_DOT] = ACTIONS(9736),
    [anon_sym_def] = ACTIONS(9736),
    [sym_identifier] = ACTIONS(9736),
    [anon_sym_yield] = ACTIONS(9736),
    [sym_class_variable] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_not] = ACTIONS(9736),
    [anon_sym_LT] = ACTIONS(9736),
    [sym__symbol_start] = ACTIONS(9738),
    [anon_sym_TRUE] = ACTIONS(9736),
    [sym__block_ampersand] = ACTIONS(9738),
    [sym__identifier_hash_key] = ACTIONS(9738),
    [anon_sym_case] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_LPAREN2] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_GT_GT] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_or] = ACTIONS(9736),
    [anon_sym_break] = ACTIONS(9736),
    [sym_global_variable] = ACTIONS(9738),
    [anon_sym_class] = ACTIONS(9736),
    [anon_sym_GT] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [sym__subshell_start] = ACTIONS(9738),
    [sym__splat_star] = ACTIONS(9738),
    [anon_sym_PIPE_EQ] = ACTIONS(9738),
    [anon_sym_PLUS_EQ] = ACTIONS(9738),
    [anon_sym_STAR_EQ] = ACTIONS(9738),
    [anon_sym_EQ_EQ] = ACTIONS(9736),
    [anon_sym_STAR] = ACTIONS(9736),
    [anon_sym_and] = ACTIONS(9736),
    [anon_sym_PIPE_PIPE] = ACTIONS(9736),
    [anon_sym_next] = ACTIONS(9736),
    [sym__unary_minus] = ACTIONS(9738),
    [sym_retry] = ACTIONS(9736),
    [anon_sym_GT_EQ] = ACTIONS(9738),
    [sym__regex_start] = ACTIONS(9738),
    [sym_integer] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9738),
    [anon_sym_DASH_EQ] = ACTIONS(9738),
    [anon_sym_FALSE] = ACTIONS(9736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9738),
    [anon_sym_BANG_EQ] = ACTIONS(9738),
    [anon_sym_STAR_STAR] = ACTIONS(9736),
    [anon_sym_LT_EQ_GT] = ACTIONS(9738),
    [anon_sym_AMP_AMP] = ACTIONS(9736),
    [sym_redo] = ACTIONS(9736),
    [anon_sym_BANG] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_CARET] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
  },
  [12471] = {
    [aux_sym_exceptions_repeat1] = STATE(12471),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13968),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17658),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12472] = {
    [anon_sym_LT] = ACTIONS(17077),
    [anon_sym_SLASH] = ACTIONS(17079),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(17081),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(17083),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17085),
    [anon_sym_LT_LT] = ACTIONS(17083),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17087),
    [anon_sym_EQ_TILDE] = ACTIONS(17087),
    [anon_sym_PLUS] = ACTIONS(17089),
    [anon_sym_AMP] = ACTIONS(17091),
    [anon_sym_GT] = ACTIONS(17077),
    [anon_sym_PERCENT] = ACTIONS(17079),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(17093),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(17095),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(17095),
    [anon_sym_BANG_TILDE] = ACTIONS(17087),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(17097),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(17087),
    [anon_sym_STAR_STAR] = ACTIONS(17079),
    [anon_sym_PIPE] = ACTIONS(17099),
    [anon_sym_DOT_DOT] = ACTIONS(17101),
    [anon_sym_AMP_AMP] = ACTIONS(17095),
    [anon_sym_LT_EQ_GT] = ACTIONS(17087),
    [anon_sym_LT_EQ] = ACTIONS(17077),
    [sym__binary_minus] = ACTIONS(17103),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_CARET] = ACTIONS(17099),
  },
  [12473] = {
    [aux_sym_exceptions_repeat1] = STATE(12473),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_SLASH] = ACTIONS(13577),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17661),
    [anon_sym_GT_GT] = ACTIONS(13577),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_PLUS] = ACTIONS(13577),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_PERCENT] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_when] = ACTIONS(13577),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13577),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_AMP_AMP] = ACTIONS(13577),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13577),
    [sym__binary_minus] = ACTIONS(13577),
  },
  [12474] = {
    [anon_sym_LT] = ACTIONS(17167),
    [anon_sym_SLASH] = ACTIONS(17169),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(17171),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(17173),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17175),
    [anon_sym_LT_LT] = ACTIONS(17173),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17177),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(17177),
    [anon_sym_AMP] = ACTIONS(17179),
    [anon_sym_GT] = ACTIONS(17167),
    [anon_sym_PLUS] = ACTIONS(17181),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_PERCENT] = ACTIONS(17169),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_when] = ACTIONS(14222),
    [sym__binary_star] = ACTIONS(17169),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_EQ_EQ] = ACTIONS(17183),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_BANG_TILDE] = ACTIONS(17177),
    [anon_sym_PIPE_PIPE] = ACTIONS(17177),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(17185),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(17177),
    [anon_sym_STAR_STAR] = ACTIONS(17169),
    [anon_sym_PIPE] = ACTIONS(17187),
    [anon_sym_DOT_DOT] = ACTIONS(17189),
    [anon_sym_AMP_AMP] = ACTIONS(17177),
    [anon_sym_LT_EQ_GT] = ACTIONS(17177),
    [anon_sym_LT_EQ] = ACTIONS(17167),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(17191),
    [sym__binary_minus] = ACTIONS(17181),
  },
  [12475] = {
    [anon_sym_LT] = ACTIONS(17225),
    [anon_sym_SLASH] = ACTIONS(17227),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_QMARK] = ACTIONS(17229),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(17231),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17233),
    [anon_sym_LT_LT] = ACTIONS(17231),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17235),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_EQ_TILDE] = ACTIONS(17235),
    [anon_sym_AMP] = ACTIONS(17237),
    [anon_sym_GT] = ACTIONS(17225),
    [anon_sym_PLUS] = ACTIONS(17239),
    [anon_sym_PERCENT] = ACTIONS(17227),
    [sym__binary_star] = ACTIONS(17227),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_when] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(17241),
    [anon_sym_BANG_TILDE] = ACTIONS(17235),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(17235),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_GT_EQ] = ACTIONS(17243),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(49),
    [anon_sym_BANG_EQ] = ACTIONS(17235),
    [anon_sym_STAR_STAR] = ACTIONS(17227),
    [anon_sym_PIPE] = ACTIONS(17245),
    [anon_sym_DOT_DOT] = ACTIONS(17247),
    [anon_sym_AMP_AMP] = ACTIONS(17235),
    [anon_sym_LT_EQ_GT] = ACTIONS(17235),
    [anon_sym_LT_EQ] = ACTIONS(17225),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(17249),
    [sym__binary_minus] = ACTIONS(17239),
  },
  [12476] = {
    [aux_sym_exceptions_repeat1] = STATE(12476),
    [anon_sym_SLASH] = ACTIONS(13968),
    [sym__line_break] = ACTIONS(13577),
    [anon_sym_until] = ACTIONS(13577),
    [anon_sym_AMP_EQ] = ACTIONS(13577),
    [anon_sym_GT_GT_EQ] = ACTIONS(13577),
    [anon_sym_SLASH_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13577),
    [anon_sym_EQ_TILDE] = ACTIONS(13577),
    [anon_sym_LT_LT] = ACTIONS(13968),
    [sym__binary_star] = ACTIONS(13577),
    [anon_sym_unless] = ACTIONS(13577),
    [anon_sym_PLUS] = ACTIONS(13968),
    [anon_sym_AMP] = ACTIONS(13968),
    [anon_sym_PERCENT] = ACTIONS(13968),
    [anon_sym_COLON_COLON2] = ACTIONS(13577),
    [anon_sym_rescue] = ACTIONS(13577),
    [anon_sym_PERCENT_EQ] = ACTIONS(13577),
    [anon_sym_LT_LT_EQ] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_DOT] = ACTIONS(13968),
    [anon_sym_BANG_TILDE] = ACTIONS(13577),
    [anon_sym_LBRACE] = ACTIONS(13577),
    [anon_sym_while] = ACTIONS(13577),
    [sym__heredoc_body_start] = ACTIONS(13577),
    [anon_sym_else] = ACTIONS(13577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(13577),
    [anon_sym_CARET_EQ] = ACTIONS(13577),
    [anon_sym_AMP_DOT] = ACTIONS(13577),
    [anon_sym_LT_EQ] = ACTIONS(13968),
    [anon_sym_PIPE] = ACTIONS(13968),
    [anon_sym_DOT_DOT] = ACTIONS(13968),
    [anon_sym_EQ] = ACTIONS(13968),
    [anon_sym_LT] = ACTIONS(13968),
    [anon_sym_QMARK] = ACTIONS(13577),
    [anon_sym_COMMA] = ACTIONS(17664),
    [anon_sym_GT_GT] = ACTIONS(13968),
    [anon_sym_SEMI] = ACTIONS(13577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13577),
    [anon_sym_or] = ACTIONS(13577),
    [anon_sym_GT] = ACTIONS(13968),
    [anon_sym_when] = ACTIONS(13577),
    [anon_sym_PIPE_EQ] = ACTIONS(13577),
    [anon_sym_PLUS_EQ] = ACTIONS(13577),
    [anon_sym_STAR_EQ] = ACTIONS(13577),
    [anon_sym_EQ_EQ] = ACTIONS(13968),
    [anon_sym_and] = ACTIONS(13577),
    [anon_sym_PIPE_PIPE] = ACTIONS(13968),
    [anon_sym_GT_EQ] = ACTIONS(13577),
    [anon_sym_end] = ACTIONS(13577),
    [anon_sym_LBRACK] = ACTIONS(13577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13577),
    [anon_sym_DASH_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13577),
    [anon_sym_BANG_EQ] = ACTIONS(13577),
    [anon_sym_STAR_STAR] = ACTIONS(13968),
    [anon_sym_LT_EQ_GT] = ACTIONS(13577),
    [anon_sym_AMP_AMP] = ACTIONS(13968),
    [sym__binary_minus] = ACTIONS(13577),
    [anon_sym_if] = ACTIONS(13577),
    [anon_sym_CARET] = ACTIONS(13968),
  },
  [12477] = {
    [anon_sym_SLASH] = ACTIONS(17259),
    [sym__line_break] = ACTIONS(14222),
    [anon_sym_until] = ACTIONS(14222),
    [anon_sym_AMP_EQ] = ACTIONS(14222),
    [anon_sym_GT_GT_EQ] = ACTIONS(14222),
    [anon_sym_SLASH_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(17261),
    [anon_sym_EQ_TILDE] = ACTIONS(17261),
    [anon_sym_LT_LT] = ACTIONS(17263),
    [sym__binary_star] = ACTIONS(17265),
    [anon_sym_unless] = ACTIONS(14222),
    [anon_sym_PLUS] = ACTIONS(17267),
    [anon_sym_AMP] = ACTIONS(17269),
    [anon_sym_PERCENT] = ACTIONS(17259),
    [anon_sym_COLON_COLON2] = ACTIONS(14222),
    [anon_sym_rescue] = ACTIONS(14222),
    [anon_sym_PERCENT_EQ] = ACTIONS(14222),
    [anon_sym_LT_LT_EQ] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_DOT] = ACTIONS(15271),
    [anon_sym_BANG_TILDE] = ACTIONS(17261),
    [anon_sym_LBRACE] = ACTIONS(14222),
    [anon_sym_while] = ACTIONS(14222),
    [sym__heredoc_body_start] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(14222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(14222),
    [anon_sym_CARET_EQ] = ACTIONS(14222),
    [anon_sym_AMP_DOT] = ACTIONS(14222),
    [anon_sym_LT_EQ] = ACTIONS(17271),
    [anon_sym_PIPE] = ACTIONS(17273),
    [anon_sym_DOT_DOT] = ACTIONS(17275),
    [anon_sym_EQ] = ACTIONS(15271),
    [anon_sym_LT] = ACTIONS(17271),
    [anon_sym_QMARK] = ACTIONS(17277),
    [anon_sym_COMMA] = ACTIONS(14222),
    [anon_sym_GT_GT] = ACTIONS(17263),
    [anon_sym_SEMI] = ACTIONS(14222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(17279),
    [anon_sym_or] = ACTIONS(14222),
    [anon_sym_GT] = ACTIONS(17271),
    [anon_sym_when] = ACTIONS(14222),
    [anon_sym_PIPE_EQ] = ACTIONS(14222),
    [anon_sym_PLUS_EQ] = ACTIONS(14222),
    [anon_sym_STAR_EQ] = ACTIONS(14222),
    [anon_sym_EQ_EQ] = ACTIONS(17281),
    [anon_sym_and] = ACTIONS(14222),
    [anon_sym_PIPE_PIPE] = ACTIONS(17281),
    [anon_sym_GT_EQ] = ACTIONS(17283),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_LBRACK] = ACTIONS(14222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14222),
    [anon_sym_DASH_EQ] = ACTIONS(14222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14222),
    [anon_sym_BANG_EQ] = ACTIONS(17261),
    [anon_sym_STAR_STAR] = ACTIONS(17259),
    [anon_sym_LT_EQ_GT] = ACTIONS(17261),
    [anon_sym_AMP_AMP] = ACTIONS(17281),
    [sym__binary_minus] = ACTIONS(17285),
    [anon_sym_if] = ACTIONS(14222),
    [anon_sym_CARET] = ACTIONS(17273),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(44),
  [7] = {.count = 1, .reusable = false}, SHIFT(2),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = false}, SHIFT(47),
  [13] = {.count = 1, .reusable = false}, SHIFT(4),
  [15] = {.count = 1, .reusable = true}, SHIFT(44),
  [17] = {.count = 1, .reusable = false}, SHIFT(5),
  [19] = {.count = 1, .reusable = false}, SHIFT(6),
  [21] = {.count = 1, .reusable = true}, SHIFT(7),
  [23] = {.count = 1, .reusable = true}, SHIFT(8),
  [25] = {.count = 1, .reusable = true}, SHIFT(9),
  [27] = {.count = 1, .reusable = false}, SHIFT(10),
  [29] = {.count = 1, .reusable = true}, SHIFT(11),
  [31] = {.count = 1, .reusable = false}, SHIFT(12),
  [33] = {.count = 1, .reusable = true}, SHIFT(13),
  [35] = {.count = 1, .reusable = false}, SHIFT(14),
  [37] = {.count = 1, .reusable = false}, SHIFT(15),
  [39] = {.count = 1, .reusable = true}, SHIFT(47),
  [41] = {.count = 1, .reusable = true}, SHIFT(16),
  [43] = {.count = 1, .reusable = true}, SHIFT(17),
  [45] = {.count = 1, .reusable = false}, SHIFT(18),
  [47] = {.count = 1, .reusable = false}, SHIFT(19),
  [49] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [51] = {.count = 1, .reusable = true}, SHIFT(20),
  [53] = {.count = 1, .reusable = true}, SHIFT(21),
  [55] = {.count = 1, .reusable = false}, SHIFT(22),
  [57] = {.count = 1, .reusable = false}, SHIFT(23),
  [59] = {.count = 1, .reusable = true}, SHIFT(24),
  [61] = {.count = 1, .reusable = false}, SHIFT(16),
  [63] = {.count = 1, .reusable = false}, SHIFT(25),
  [65] = {.count = 1, .reusable = true}, SHIFT(26),
  [67] = {.count = 1, .reusable = true}, SHIFT(27),
  [69] = {.count = 1, .reusable = false}, SHIFT(28),
  [71] = {.count = 1, .reusable = false}, SHIFT(29),
  [73] = {.count = 1, .reusable = true}, SHIFT(30),
  [75] = {.count = 1, .reusable = false}, SHIFT(31),
  [77] = {.count = 1, .reusable = false}, SHIFT(32),
  [79] = {.count = 1, .reusable = false}, SHIFT(33),
  [81] = {.count = 1, .reusable = true}, SHIFT(34),
  [83] = {.count = 1, .reusable = false}, SHIFT(35),
  [85] = {.count = 1, .reusable = true}, SHIFT(6),
  [87] = {.count = 1, .reusable = false}, SHIFT(36),
  [89] = {.count = 1, .reusable = true}, SHIFT(37),
  [91] = {.count = 1, .reusable = false}, SHIFT(38),
  [93] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [95] = {.count = 1, .reusable = false}, SHIFT(39),
  [97] = {.count = 1, .reusable = true}, SHIFT(40),
  [99] = {.count = 1, .reusable = false}, SHIFT(41),
  [101] = {.count = 1, .reusable = false}, SHIFT(64),
  [103] = {.count = 1, .reusable = false}, SHIFT(61),
  [105] = {.count = 1, .reusable = true}, SHIFT(57),
  [107] = {.count = 1, .reusable = false}, SHIFT(59),
  [109] = {.count = 1, .reusable = false}, SHIFT(65),
  [111] = {.count = 1, .reusable = false}, SHIFT(55),
  [113] = {.count = 1, .reusable = true}, SHIFT(64),
  [115] = {.count = 1, .reusable = false}, SHIFT(56),
  [117] = {.count = 1, .reusable = true}, SHIFT(65),
  [119] = {.count = 1, .reusable = true}, SHIFT(56),
  [121] = {.count = 1, .reusable = false}, SHIFT(58),
  [123] = {.count = 1, .reusable = true}, SHIFT(59),
  [125] = {.count = 1, .reusable = true}, SHIFT(60),
  [127] = {.count = 1, .reusable = false}, SHIFT(54),
  [129] = {.count = 1, .reusable = false}, SHIFT(68),
  [131] = {.count = 1, .reusable = true}, SHIFT(68),
  [133] = {.count = 1, .reusable = true}, SHIFT(72),
  [135] = {.count = 1, .reusable = true}, SHIFT(70),
  [137] = {.count = 1, .reusable = true}, SHIFT(71),
  [139] = {.count = 1, .reusable = true}, SHIFT(69),
  [141] = {.count = 1, .reusable = true}, SHIFT(73),
  [143] = {.count = 1, .reusable = false}, SHIFT(84),
  [145] = {.count = 1, .reusable = false}, SHIFT(74),
  [147] = {.count = 1, .reusable = false}, SHIFT(86),
  [149] = {.count = 1, .reusable = true}, SHIFT(84),
  [151] = {.count = 1, .reusable = false}, SHIFT(75),
  [153] = {.count = 1, .reusable = true}, SHIFT(76),
  [155] = {.count = 1, .reusable = true}, SHIFT(86),
  [157] = {.count = 1, .reusable = true}, SHIFT(77),
  [159] = {.count = 1, .reusable = true}, SHIFT(78),
  [161] = {.count = 1, .reusable = false}, SHIFT(79),
  [163] = {.count = 1, .reusable = false}, SHIFT(77),
  [165] = {.count = 1, .reusable = false}, SHIFT(80),
  [167] = {.count = 1, .reusable = true}, SHIFT(75),
  [169] = {.count = 1, .reusable = false}, SHIFT(81),
  [171] = {.count = 1, .reusable = false}, SHIFT(82),
  [173] = {.count = 1, .reusable = true}, SHIFT(96),
  [175] = {.count = 1, .reusable = true}, SHIFT(93),
  [177] = {.count = 1, .reusable = false}, SHIFT(94),
  [179] = {.count = 1, .reusable = true}, SHIFT(92),
  [181] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [183] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [185] = {.count = 1, .reusable = false}, SHIFT(97),
  [187] = {.count = 1, .reusable = true}, SHIFT(97),
  [189] = {.count = 1, .reusable = true}, SHIFT(101),
  [191] = {.count = 1, .reusable = true}, SHIFT(99),
  [193] = {.count = 1, .reusable = true}, SHIFT(100),
  [195] = {.count = 1, .reusable = true}, SHIFT(98),
  [197] = {.count = 1, .reusable = false}, SHIFT(144),
  [199] = {.count = 1, .reusable = true}, SHIFT(102),
  [201] = {.count = 1, .reusable = false}, SHIFT(103),
  [203] = {.count = 1, .reusable = false}, SHIFT(145),
  [205] = {.count = 1, .reusable = true}, SHIFT(144),
  [207] = {.count = 1, .reusable = false}, SHIFT(104),
  [209] = {.count = 1, .reusable = false}, SHIFT(105),
  [211] = {.count = 1, .reusable = true}, SHIFT(106),
  [213] = {.count = 1, .reusable = true}, SHIFT(107),
  [215] = {.count = 1, .reusable = true}, SHIFT(108),
  [217] = {.count = 1, .reusable = true}, SHIFT(109),
  [219] = {.count = 1, .reusable = false}, SHIFT(110),
  [221] = {.count = 1, .reusable = true}, SHIFT(111),
  [223] = {.count = 1, .reusable = false}, SHIFT(112),
  [225] = {.count = 1, .reusable = false}, SHIFT(113),
  [227] = {.count = 1, .reusable = true}, SHIFT(145),
  [229] = {.count = 1, .reusable = true}, SHIFT(114),
  [231] = {.count = 1, .reusable = true}, SHIFT(115),
  [233] = {.count = 1, .reusable = false}, SHIFT(116),
  [235] = {.count = 1, .reusable = false}, SHIFT(117),
  [237] = {.count = 1, .reusable = true}, SHIFT(118),
  [239] = {.count = 1, .reusable = true}, SHIFT(119),
  [241] = {.count = 1, .reusable = true}, SHIFT(120),
  [243] = {.count = 1, .reusable = false}, SHIFT(121),
  [245] = {.count = 1, .reusable = false}, SHIFT(122),
  [247] = {.count = 1, .reusable = true}, SHIFT(123),
  [249] = {.count = 1, .reusable = true}, SHIFT(124),
  [251] = {.count = 1, .reusable = false}, SHIFT(114),
  [253] = {.count = 1, .reusable = false}, SHIFT(125),
  [255] = {.count = 1, .reusable = true}, SHIFT(126),
  [257] = {.count = 1, .reusable = true}, SHIFT(127),
  [259] = {.count = 1, .reusable = false}, SHIFT(128),
  [261] = {.count = 1, .reusable = false}, SHIFT(129),
  [263] = {.count = 1, .reusable = true}, SHIFT(130),
  [265] = {.count = 1, .reusable = false}, SHIFT(131),
  [267] = {.count = 1, .reusable = false}, SHIFT(132),
  [269] = {.count = 1, .reusable = false}, SHIFT(133),
  [271] = {.count = 1, .reusable = false}, SHIFT(34),
  [273] = {.count = 1, .reusable = true}, SHIFT(105),
  [275] = {.count = 1, .reusable = false}, SHIFT(134),
  [277] = {.count = 1, .reusable = true}, SHIFT(135),
  [279] = {.count = 1, .reusable = false}, SHIFT(136),
  [281] = {.count = 1, .reusable = true}, SHIFT(137),
  [283] = {.count = 1, .reusable = false}, SHIFT(138),
  [285] = {.count = 1, .reusable = true}, SHIFT(139),
  [287] = {.count = 1, .reusable = false}, SHIFT(140),
  [289] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [291] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [293] = {.count = 1, .reusable = false}, SHIFT(189),
  [295] = {.count = 1, .reusable = false}, SHIFT(149),
  [297] = {.count = 1, .reusable = false}, SHIFT(193),
  [299] = {.count = 1, .reusable = true}, SHIFT(150),
  [301] = {.count = 1, .reusable = true}, SHIFT(189),
  [303] = {.count = 1, .reusable = false}, SHIFT(151),
  [305] = {.count = 1, .reusable = false}, SHIFT(152),
  [307] = {.count = 1, .reusable = true}, SHIFT(153),
  [309] = {.count = 1, .reusable = true}, SHIFT(154),
  [311] = {.count = 1, .reusable = true}, SHIFT(155),
  [313] = {.count = 1, .reusable = true}, SHIFT(156),
  [315] = {.count = 1, .reusable = false}, SHIFT(157),
  [317] = {.count = 1, .reusable = true}, SHIFT(158),
  [319] = {.count = 1, .reusable = false}, SHIFT(159),
  [321] = {.count = 1, .reusable = false}, SHIFT(160),
  [323] = {.count = 1, .reusable = true}, SHIFT(193),
  [325] = {.count = 1, .reusable = true}, SHIFT(161),
  [327] = {.count = 1, .reusable = true}, SHIFT(162),
  [329] = {.count = 1, .reusable = true}, SHIFT(163),
  [331] = {.count = 1, .reusable = false}, SHIFT(164),
  [333] = {.count = 1, .reusable = false}, SHIFT(165),
  [335] = {.count = 1, .reusable = true}, SHIFT(166),
  [337] = {.count = 1, .reusable = true}, SHIFT(167),
  [339] = {.count = 1, .reusable = true}, SHIFT(168),
  [341] = {.count = 1, .reusable = false}, SHIFT(169),
  [343] = {.count = 1, .reusable = false}, SHIFT(170),
  [345] = {.count = 1, .reusable = false}, SHIFT(162),
  [347] = {.count = 1, .reusable = true}, SHIFT(171),
  [349] = {.count = 1, .reusable = false}, SHIFT(172),
  [351] = {.count = 1, .reusable = true}, SHIFT(173),
  [353] = {.count = 1, .reusable = false}, SHIFT(174),
  [355] = {.count = 1, .reusable = false}, SHIFT(175),
  [357] = {.count = 1, .reusable = true}, SHIFT(176),
  [359] = {.count = 1, .reusable = false}, SHIFT(177),
  [361] = {.count = 1, .reusable = false}, SHIFT(178),
  [363] = {.count = 1, .reusable = false}, SHIFT(179),
  [365] = {.count = 1, .reusable = true}, SHIFT(152),
  [367] = {.count = 1, .reusable = false}, SHIFT(180),
  [369] = {.count = 1, .reusable = true}, SHIFT(181),
  [371] = {.count = 1, .reusable = false}, SHIFT(182),
  [373] = {.count = 1, .reusable = true}, SHIFT(183),
  [375] = {.count = 1, .reusable = false}, SHIFT(184),
  [377] = {.count = 1, .reusable = true}, SHIFT(185),
  [379] = {.count = 1, .reusable = false}, SHIFT(186),
  [381] = {.count = 1, .reusable = true}, SHIFT(197),
  [383] = {.count = 1, .reusable = true}, SHIFT(203),
  [385] = {.count = 1, .reusable = false}, SHIFT(201),
  [387] = {.count = 1, .reusable = true}, SHIFT(200),
  [389] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [393] = {.count = 1, .reusable = false}, SHIFT(204),
  [395] = {.count = 1, .reusable = false}, SHIFT(237),
  [397] = {.count = 1, .reusable = false}, SHIFT(205),
  [399] = {.count = 1, .reusable = false}, SHIFT(234),
  [401] = {.count = 1, .reusable = false}, SHIFT(207),
  [403] = {.count = 1, .reusable = false}, SHIFT(208),
  [405] = {.count = 1, .reusable = false}, SHIFT(238),
  [407] = {.count = 1, .reusable = true}, SHIFT(210),
  [409] = {.count = 1, .reusable = false}, SHIFT(211),
  [411] = {.count = 1, .reusable = false}, SHIFT(212),
  [413] = {.count = 1, .reusable = false}, SHIFT(213),
  [415] = {.count = 1, .reusable = true}, SHIFT(237),
  [417] = {.count = 1, .reusable = false}, SHIFT(214),
  [419] = {.count = 1, .reusable = false}, SHIFT(215),
  [421] = {.count = 1, .reusable = true}, SHIFT(238),
  [423] = {.count = 1, .reusable = false}, SHIFT(216),
  [425] = {.count = 1, .reusable = true}, SHIFT(217),
  [427] = {.count = 1, .reusable = true}, SHIFT(221),
  [429] = {.count = 1, .reusable = true}, SHIFT(218),
  [431] = {.count = 1, .reusable = false}, SHIFT(220),
  [433] = {.count = 1, .reusable = true}, SHIFT(219),
  [435] = {.count = 1, .reusable = true}, SHIFT(222),
  [437] = {.count = 1, .reusable = true}, SHIFT(223),
  [439] = {.count = 1, .reusable = false}, SHIFT(224),
  [441] = {.count = 1, .reusable = false}, SHIFT(225),
  [443] = {.count = 1, .reusable = true}, SHIFT(226),
  [445] = {.count = 1, .reusable = false}, SHIFT(227),
  [447] = {.count = 1, .reusable = false}, SHIFT(228),
  [449] = {.count = 1, .reusable = true}, SHIFT(229),
  [451] = {.count = 1, .reusable = true}, SHIFT(230),
  [453] = {.count = 1, .reusable = true}, SHIFT(231),
  [455] = {.count = 1, .reusable = false}, SHIFT(232),
  [457] = {.count = 1, .reusable = false}, SHIFT(233),
  [459] = {.count = 1, .reusable = true}, SHIFT(206),
  [461] = {.count = 1, .reusable = true}, SHIFT(209),
  [463] = {.count = 1, .reusable = false}, SHIFT(242),
  [465] = {.count = 1, .reusable = false}, SHIFT(243),
  [467] = {.count = 1, .reusable = true}, SHIFT(246),
  [469] = {.count = 1, .reusable = true}, SHIFT(245),
  [471] = {.count = 1, .reusable = true}, SHIFT(241),
  [473] = {.count = 1, .reusable = false}, SHIFT(244),
  [475] = {.count = 1, .reusable = true}, SHIFT(247),
  [477] = {.count = 1, .reusable = true}, SHIFT(251),
  [479] = {.count = 1, .reusable = false}, SHIFT(252),
  [481] = {.count = 1, .reusable = true}, SHIFT(252),
  [483] = {.count = 1, .reusable = false}, SHIFT(260),
  [485] = {.count = 1, .reusable = true}, SHIFT(254),
  [487] = {.count = 1, .reusable = true}, SHIFT(255),
  [489] = {.count = 1, .reusable = true}, SHIFT(256),
  [491] = {.count = 1, .reusable = false}, SHIFT(257),
  [493] = {.count = 1, .reusable = true}, SHIFT(253),
  [495] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [497] = {.count = 1, .reusable = false}, SHIFT(303),
  [499] = {.count = 1, .reusable = true}, SHIFT(298),
  [501] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [503] = {.count = 1, .reusable = false}, SHIFT(299),
  [505] = {.count = 1, .reusable = false}, SHIFT(304),
  [507] = {.count = 1, .reusable = true}, SHIFT(303),
  [509] = {.count = 1, .reusable = true}, SHIFT(264),
  [511] = {.count = 1, .reusable = true}, SHIFT(265),
  [513] = {.count = 1, .reusable = true}, SHIFT(266),
  [515] = {.count = 1, .reusable = false}, SHIFT(267),
  [517] = {.count = 1, .reusable = false}, SHIFT(268),
  [519] = {.count = 1, .reusable = true}, SHIFT(269),
  [521] = {.count = 1, .reusable = false}, SHIFT(270),
  [523] = {.count = 1, .reusable = true}, SHIFT(304),
  [525] = {.count = 1, .reusable = true}, SHIFT(272),
  [527] = {.count = 1, .reusable = true}, SHIFT(273),
  [529] = {.count = 1, .reusable = false}, SHIFT(274),
  [531] = {.count = 1, .reusable = false}, SHIFT(275),
  [533] = {.count = 1, .reusable = true}, SHIFT(276),
  [535] = {.count = 1, .reusable = false}, SHIFT(277),
  [537] = {.count = 1, .reusable = true}, SHIFT(278),
  [539] = {.count = 1, .reusable = false}, SHIFT(279),
  [541] = {.count = 1, .reusable = false}, SHIFT(280),
  [543] = {.count = 1, .reusable = true}, SHIFT(281),
  [545] = {.count = 1, .reusable = false}, SHIFT(272),
  [547] = {.count = 1, .reusable = true}, SHIFT(282),
  [549] = {.count = 1, .reusable = false}, SHIFT(283),
  [551] = {.count = 1, .reusable = true}, SHIFT(284),
  [553] = {.count = 1, .reusable = false}, SHIFT(285),
  [555] = {.count = 1, .reusable = true}, SHIFT(286),
  [557] = {.count = 1, .reusable = false}, SHIFT(287),
  [559] = {.count = 1, .reusable = false}, SHIFT(288),
  [561] = {.count = 1, .reusable = true}, SHIFT(289),
  [563] = {.count = 1, .reusable = false}, SHIFT(290),
  [565] = {.count = 1, .reusable = false}, SHIFT(291),
  [567] = {.count = 1, .reusable = false}, SHIFT(292),
  [569] = {.count = 1, .reusable = true}, SHIFT(263),
  [571] = {.count = 1, .reusable = false}, SHIFT(293),
  [573] = {.count = 1, .reusable = true}, SHIFT(294),
  [575] = {.count = 1, .reusable = false}, SHIFT(295),
  [577] = {.count = 1, .reusable = false}, SHIFT(264),
  [579] = {.count = 1, .reusable = true}, SHIFT(309),
  [581] = {.count = 1, .reusable = true}, SHIFT(323),
  [583] = {.count = 1, .reusable = false}, SHIFT(320),
  [585] = {.count = 1, .reusable = false}, SHIFT(313),
  [587] = {.count = 1, .reusable = true}, SHIFT(314),
  [589] = {.count = 1, .reusable = true}, SHIFT(320),
  [591] = {.count = 1, .reusable = true}, SHIFT(316),
  [593] = {.count = 1, .reusable = false}, SHIFT(317),
  [595] = {.count = 1, .reusable = false}, SHIFT(316),
  [597] = {.count = 1, .reusable = false}, SHIFT(312),
  [599] = {.count = 1, .reusable = true}, SHIFT(313),
  [601] = {.count = 1, .reusable = false}, SHIFT(315),
  [603] = {.count = 1, .reusable = false}, SHIFT(311),
  [605] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [607] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [609] = {.count = 1, .reusable = false}, SHIFT(338),
  [611] = {.count = 1, .reusable = false}, SHIFT(324),
  [613] = {.count = 1, .reusable = false}, SHIFT(341),
  [615] = {.count = 1, .reusable = true}, SHIFT(325),
  [617] = {.count = 1, .reusable = true}, SHIFT(338),
  [619] = {.count = 1, .reusable = false}, SHIFT(326),
  [621] = {.count = 1, .reusable = true}, SHIFT(327),
  [623] = {.count = 1, .reusable = true}, SHIFT(341),
  [625] = {.count = 1, .reusable = true}, SHIFT(328),
  [627] = {.count = 1, .reusable = true}, SHIFT(329),
  [629] = {.count = 1, .reusable = false}, SHIFT(330),
  [631] = {.count = 1, .reusable = false}, SHIFT(328),
  [633] = {.count = 1, .reusable = true}, SHIFT(331),
  [635] = {.count = 1, .reusable = false}, SHIFT(332),
  [637] = {.count = 1, .reusable = true}, SHIFT(333),
  [639] = {.count = 1, .reusable = true}, SHIFT(326),
  [641] = {.count = 1, .reusable = false}, SHIFT(334),
  [643] = {.count = 1, .reusable = false}, SHIFT(335),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [647] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [649] = {.count = 1, .reusable = false}, SHIFT(352),
  [651] = {.count = 1, .reusable = false}, SHIFT(353),
  [653] = {.count = 1, .reusable = true}, SHIFT(348),
  [655] = {.count = 1, .reusable = true}, SHIFT(352),
  [657] = {.count = 1, .reusable = true}, SHIFT(353),
  [659] = {.count = 1, .reusable = true}, SHIFT(349),
  [661] = {.count = 1, .reusable = false}, SHIFT(350),
  [663] = {.count = 1, .reusable = true}, SHIFT(351),
  [665] = {.count = 1, .reusable = true}, SHIFT(355),
  [667] = {.count = 1, .reusable = false}, SHIFT(359),
  [669] = {.count = 1, .reusable = true}, SHIFT(359),
  [671] = {.count = 1, .reusable = false}, SHIFT(357),
  [673] = {.count = 1, .reusable = true}, SHIFT(358),
  [675] = {.count = 1, .reusable = true}, SHIFT(379),
  [677] = {.count = 1, .reusable = false}, SHIFT(376),
  [679] = {.count = 1, .reusable = false}, SHIFT(361),
  [681] = {.count = 1, .reusable = false}, SHIFT(381),
  [683] = {.count = 1, .reusable = true}, SHIFT(376),
  [685] = {.count = 1, .reusable = false}, SHIFT(362),
  [687] = {.count = 1, .reusable = true}, SHIFT(363),
  [689] = {.count = 1, .reusable = false}, SHIFT(364),
  [691] = {.count = 1, .reusable = true}, SHIFT(381),
  [693] = {.count = 1, .reusable = true}, SHIFT(365),
  [695] = {.count = 1, .reusable = true}, SHIFT(366),
  [697] = {.count = 1, .reusable = false}, SHIFT(367),
  [699] = {.count = 1, .reusable = true}, SHIFT(368),
  [701] = {.count = 1, .reusable = false}, SHIFT(369),
  [703] = {.count = 1, .reusable = false}, SHIFT(366),
  [705] = {.count = 1, .reusable = false}, SHIFT(370),
  [707] = {.count = 1, .reusable = true}, SHIFT(362),
  [709] = {.count = 1, .reusable = false}, SHIFT(371),
  [711] = {.count = 1, .reusable = false}, SHIFT(380),
  [713] = {.count = 1, .reusable = false}, SHIFT(372),
  [715] = {.count = 1, .reusable = false}, SHIFT(373),
  [717] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [719] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [721] = {.count = 1, .reusable = false}, SHIFT(390),
  [723] = {.count = 1, .reusable = false}, SHIFT(391),
  [725] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [727] = {.count = 1, .reusable = true}, SHIFT(390),
  [729] = {.count = 1, .reusable = true}, SHIFT(391),
  [731] = {.count = 1, .reusable = true}, SHIFT(388),
  [733] = {.count = 1, .reusable = true}, SHIFT(392),
  [735] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [737] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [739] = {.count = 1, .reusable = true}, SHIFT(394),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [743] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [745] = {.count = 1, .reusable = false}, SHIFT(396),
  [747] = {.count = 1, .reusable = true}, SHIFT(399),
  [749] = {.count = 1, .reusable = true}, SHIFT(398),
  [751] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [753] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [755] = {.count = 1, .reusable = true}, SHIFT(408),
  [757] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [759] = {.count = 1, .reusable = true}, SHIFT(402),
  [761] = {.count = 1, .reusable = true}, SHIFT(403),
  [763] = {.count = 1, .reusable = true}, SHIFT(404),
  [765] = {.count = 1, .reusable = true}, SHIFT(405),
  [767] = {.count = 1, .reusable = true}, SHIFT(406),
  [769] = {.count = 1, .reusable = true}, SHIFT(407),
  [771] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [773] = {.count = 1, .reusable = true}, SHIFT(409),
  [775] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [777] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [779] = {.count = 1, .reusable = true}, SHIFT(413),
  [781] = {.count = 1, .reusable = false}, SHIFT(411),
  [783] = {.count = 1, .reusable = true}, SHIFT(412),
  [785] = {.count = 1, .reusable = true}, SHIFT(411),
  [787] = {.count = 1, .reusable = true}, SHIFT(414),
  [789] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [791] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [793] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [795] = {.count = 1, .reusable = false}, SHIFT(452),
  [797] = {.count = 1, .reusable = true}, SHIFT(449),
  [799] = {.count = 1, .reusable = false}, SHIFT(450),
  [801] = {.count = 1, .reusable = false}, SHIFT(455),
  [803] = {.count = 1, .reusable = true}, SHIFT(452),
  [805] = {.count = 1, .reusable = true}, SHIFT(418),
  [807] = {.count = 1, .reusable = true}, SHIFT(419),
  [809] = {.count = 1, .reusable = true}, SHIFT(420),
  [811] = {.count = 1, .reusable = false}, SHIFT(421),
  [813] = {.count = 1, .reusable = true}, SHIFT(422),
  [815] = {.count = 1, .reusable = false}, SHIFT(423),
  [817] = {.count = 1, .reusable = true}, SHIFT(455),
  [819] = {.count = 1, .reusable = true}, SHIFT(425),
  [821] = {.count = 1, .reusable = true}, SHIFT(426),
  [823] = {.count = 1, .reusable = false}, SHIFT(427),
  [825] = {.count = 1, .reusable = false}, SHIFT(428),
  [827] = {.count = 1, .reusable = true}, SHIFT(429),
  [829] = {.count = 1, .reusable = true}, SHIFT(430),
  [831] = {.count = 1, .reusable = false}, SHIFT(431),
  [833] = {.count = 1, .reusable = false}, SHIFT(432),
  [835] = {.count = 1, .reusable = true}, SHIFT(433),
  [837] = {.count = 1, .reusable = false}, SHIFT(425),
  [839] = {.count = 1, .reusable = true}, SHIFT(434),
  [841] = {.count = 1, .reusable = false}, SHIFT(435),
  [843] = {.count = 1, .reusable = true}, SHIFT(436),
  [845] = {.count = 1, .reusable = false}, SHIFT(437),
  [847] = {.count = 1, .reusable = true}, SHIFT(438),
  [849] = {.count = 1, .reusable = false}, SHIFT(439),
  [851] = {.count = 1, .reusable = false}, SHIFT(440),
  [853] = {.count = 1, .reusable = true}, SHIFT(441),
  [855] = {.count = 1, .reusable = false}, SHIFT(442),
  [857] = {.count = 1, .reusable = false}, SHIFT(443),
  [859] = {.count = 1, .reusable = true}, SHIFT(417),
  [861] = {.count = 1, .reusable = false}, SHIFT(444),
  [863] = {.count = 1, .reusable = true}, SHIFT(445),
  [865] = {.count = 1, .reusable = false}, SHIFT(446),
  [867] = {.count = 1, .reusable = false}, SHIFT(418),
  [869] = {.count = 1, .reusable = true}, SHIFT(461),
  [871] = {.count = 1, .reusable = false}, SHIFT(414),
  [873] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [875] = {.count = 1, .reusable = false}, SHIFT(462),
  [877] = {.count = 1, .reusable = true}, SHIFT(465),
  [879] = {.count = 1, .reusable = true}, SHIFT(466),
  [881] = {.count = 1, .reusable = true}, SHIFT(463),
  [883] = {.count = 1, .reusable = true}, SHIFT(467),
  [885] = {.count = 1, .reusable = true}, SHIFT(468),
  [887] = {.count = 1, .reusable = true}, SHIFT(464),
  [889] = {.count = 1, .reusable = true}, SHIFT(469),
  [891] = {.count = 1, .reusable = false}, SHIFT(470),
  [893] = {.count = 1, .reusable = false}, SHIFT(463),
  [895] = {.count = 1, .reusable = true}, SHIFT(462),
  [897] = {.count = 1, .reusable = false}, SHIFT(468),
  [899] = {.count = 1, .reusable = false}, SHIFT(471),
  [901] = {.count = 1, .reusable = true}, SHIFT(471),
  [903] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [905] = {.count = 1, .reusable = true}, SHIFT(473),
  [907] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [909] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [911] = {.count = 1, .reusable = false}, SHIFT(492),
  [913] = {.count = 1, .reusable = false}, SHIFT(261),
  [915] = {.count = 1, .reusable = false}, SHIFT(488),
  [917] = {.count = 1, .reusable = false}, SHIFT(493),
  [919] = {.count = 1, .reusable = true}, SHIFT(492),
  [921] = {.count = 1, .reusable = false}, SHIFT(262),
  [923] = {.count = 1, .reusable = true}, SHIFT(477),
  [925] = {.count = 1, .reusable = false}, SHIFT(478),
  [927] = {.count = 1, .reusable = false}, SHIFT(271),
  [929] = {.count = 1, .reusable = true}, SHIFT(493),
  [931] = {.count = 1, .reusable = true}, SHIFT(479),
  [933] = {.count = 1, .reusable = false}, SHIFT(480),
  [935] = {.count = 1, .reusable = true}, SHIFT(481),
  [937] = {.count = 1, .reusable = false}, SHIFT(482),
  [939] = {.count = 1, .reusable = true}, SHIFT(483),
  [941] = {.count = 1, .reusable = false}, SHIFT(479),
  [943] = {.count = 1, .reusable = true}, SHIFT(484),
  [945] = {.count = 1, .reusable = false}, SHIFT(485),
  [947] = {.count = 1, .reusable = true}, SHIFT(476),
  [949] = {.count = 1, .reusable = false}, SHIFT(486),
  [951] = {.count = 1, .reusable = false}, SHIFT(477),
  [953] = {.count = 1, .reusable = false}, SHIFT(297),
  [955] = {.count = 1, .reusable = true}, SHIFT(499),
  [957] = {.count = 1, .reusable = true}, SHIFT(500),
  [959] = {.count = 1, .reusable = false}, SHIFT(501),
  [961] = {.count = 1, .reusable = true}, SHIFT(513),
  [963] = {.count = 1, .reusable = false}, SHIFT(502),
  [965] = {.count = 1, .reusable = true}, SHIFT(503),
  [967] = {.count = 1, .reusable = true}, SHIFT(504),
  [969] = {.count = 1, .reusable = true}, SHIFT(505),
  [971] = {.count = 1, .reusable = true}, SHIFT(506),
  [973] = {.count = 1, .reusable = true}, SHIFT(507),
  [975] = {.count = 1, .reusable = true}, SHIFT(508),
  [977] = {.count = 1, .reusable = true}, SHIFT(509),
  [979] = {.count = 1, .reusable = false}, SHIFT(510),
  [981] = {.count = 1, .reusable = false}, SHIFT(505),
  [983] = {.count = 1, .reusable = true}, SHIFT(511),
  [985] = {.count = 1, .reusable = true}, SHIFT(502),
  [987] = {.count = 1, .reusable = false}, SHIFT(507),
  [989] = {.count = 1, .reusable = false}, SHIFT(512),
  [991] = {.count = 1, .reusable = true}, SHIFT(512),
  [993] = {.count = 1, .reusable = true}, SHIFT(515),
  [995] = {.count = 1, .reusable = false}, SHIFT(514),
  [997] = {.count = 1, .reusable = true}, SHIFT(514),
  [999] = {.count = 1, .reusable = false}, SHIFT(529),
  [1001] = {.count = 1, .reusable = false}, SHIFT(415),
  [1003] = {.count = 1, .reusable = false}, SHIFT(528),
  [1005] = {.count = 1, .reusable = false}, SHIFT(532),
  [1007] = {.count = 1, .reusable = true}, SHIFT(529),
  [1009] = {.count = 1, .reusable = false}, SHIFT(416),
  [1011] = {.count = 1, .reusable = true}, SHIFT(517),
  [1013] = {.count = 1, .reusable = true}, SHIFT(518),
  [1015] = {.count = 1, .reusable = false}, SHIFT(519),
  [1017] = {.count = 1, .reusable = false}, SHIFT(424),
  [1019] = {.count = 1, .reusable = true}, SHIFT(532),
  [1021] = {.count = 1, .reusable = true}, SHIFT(520),
  [1023] = {.count = 1, .reusable = true}, SHIFT(521),
  [1025] = {.count = 1, .reusable = false}, SHIFT(522),
  [1027] = {.count = 1, .reusable = true}, SHIFT(523),
  [1029] = {.count = 1, .reusable = false}, SHIFT(520),
  [1031] = {.count = 1, .reusable = true}, SHIFT(524),
  [1033] = {.count = 1, .reusable = false}, SHIFT(525),
  [1035] = {.count = 1, .reusable = true}, SHIFT(516),
  [1037] = {.count = 1, .reusable = false}, SHIFT(526),
  [1039] = {.count = 1, .reusable = false}, SHIFT(517),
  [1041] = {.count = 1, .reusable = false}, SHIFT(448),
  [1043] = {.count = 1, .reusable = true}, SHIFT(501),
  [1045] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [1047] = {.count = 1, .reusable = true}, SHIFT(539),
  [1049] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [1051] = {.count = 1, .reusable = true}, SHIFT(541),
  [1053] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [1055] = {.count = 1, .reusable = true}, SHIFT(542),
  [1057] = {.count = 1, .reusable = false}, SHIFT(556),
  [1059] = {.count = 1, .reusable = false}, SHIFT(544),
  [1061] = {.count = 1, .reusable = false}, SHIFT(558),
  [1063] = {.count = 1, .reusable = true}, SHIFT(545),
  [1065] = {.count = 1, .reusable = true}, SHIFT(556),
  [1067] = {.count = 1, .reusable = false}, SHIFT(546),
  [1069] = {.count = 1, .reusable = true}, SHIFT(547),
  [1071] = {.count = 1, .reusable = true}, SHIFT(558),
  [1073] = {.count = 1, .reusable = true}, SHIFT(548),
  [1075] = {.count = 1, .reusable = true}, SHIFT(549),
  [1077] = {.count = 1, .reusable = false}, SHIFT(550),
  [1079] = {.count = 1, .reusable = false}, SHIFT(548),
  [1081] = {.count = 1, .reusable = true}, SHIFT(551),
  [1083] = {.count = 1, .reusable = false}, SHIFT(552),
  [1085] = {.count = 1, .reusable = true}, SHIFT(546),
  [1087] = {.count = 1, .reusable = false}, SHIFT(553),
  [1089] = {.count = 1, .reusable = false}, SHIFT(554),
  [1091] = {.count = 1, .reusable = true}, SHIFT(564),
  [1093] = {.count = 1, .reusable = true}, SHIFT(567),
  [1095] = {.count = 1, .reusable = false}, SHIFT(584),
  [1097] = {.count = 1, .reusable = false}, SHIFT(580),
  [1099] = {.count = 1, .reusable = false}, SHIFT(585),
  [1101] = {.count = 1, .reusable = true}, SHIFT(584),
  [1103] = {.count = 1, .reusable = true}, SHIFT(569),
  [1105] = {.count = 1, .reusable = false}, SHIFT(570),
  [1107] = {.count = 1, .reusable = true}, SHIFT(585),
  [1109] = {.count = 1, .reusable = true}, SHIFT(571),
  [1111] = {.count = 1, .reusable = false}, SHIFT(572),
  [1113] = {.count = 1, .reusable = true}, SHIFT(573),
  [1115] = {.count = 1, .reusable = false}, SHIFT(574),
  [1117] = {.count = 1, .reusable = true}, SHIFT(575),
  [1119] = {.count = 1, .reusable = false}, SHIFT(571),
  [1121] = {.count = 1, .reusable = true}, SHIFT(576),
  [1123] = {.count = 1, .reusable = false}, SHIFT(577),
  [1125] = {.count = 1, .reusable = true}, SHIFT(568),
  [1127] = {.count = 1, .reusable = false}, SHIFT(578),
  [1129] = {.count = 1, .reusable = false}, SHIFT(569),
  [1131] = {.count = 1, .reusable = true}, SHIFT(596),
  [1133] = {.count = 1, .reusable = true}, SHIFT(589),
  [1135] = {.count = 1, .reusable = true}, SHIFT(590),
  [1137] = {.count = 1, .reusable = true}, SHIFT(591),
  [1139] = {.count = 1, .reusable = true}, SHIFT(592),
  [1141] = {.count = 1, .reusable = true}, SHIFT(593),
  [1143] = {.count = 1, .reusable = true}, SHIFT(594),
  [1145] = {.count = 1, .reusable = true}, SHIFT(595),
  [1147] = {.count = 1, .reusable = true}, SHIFT(599),
  [1149] = {.count = 1, .reusable = false}, SHIFT(598),
  [1151] = {.count = 1, .reusable = true}, SHIFT(598),
  [1153] = {.count = 1, .reusable = true}, SHIFT(600),
  [1155] = {.count = 1, .reusable = false}, SHIFT(613),
  [1157] = {.count = 1, .reusable = false}, SHIFT(612),
  [1159] = {.count = 1, .reusable = false}, SHIFT(615),
  [1161] = {.count = 1, .reusable = true}, SHIFT(613),
  [1163] = {.count = 1, .reusable = true}, SHIFT(602),
  [1165] = {.count = 1, .reusable = false}, SHIFT(603),
  [1167] = {.count = 1, .reusable = true}, SHIFT(615),
  [1169] = {.count = 1, .reusable = true}, SHIFT(604),
  [1171] = {.count = 1, .reusable = true}, SHIFT(605),
  [1173] = {.count = 1, .reusable = false}, SHIFT(606),
  [1175] = {.count = 1, .reusable = true}, SHIFT(607),
  [1177] = {.count = 1, .reusable = false}, SHIFT(604),
  [1179] = {.count = 1, .reusable = true}, SHIFT(608),
  [1181] = {.count = 1, .reusable = false}, SHIFT(609),
  [1183] = {.count = 1, .reusable = true}, SHIFT(601),
  [1185] = {.count = 1, .reusable = false}, SHIFT(610),
  [1187] = {.count = 1, .reusable = false}, SHIFT(602),
  [1189] = {.count = 1, .reusable = true}, SHIFT(621),
  [1191] = {.count = 1, .reusable = false}, SHIFT(600),
  [1193] = {.count = 1, .reusable = false}, SHIFT(622),
  [1195] = {.count = 1, .reusable = true}, SHIFT(625),
  [1197] = {.count = 1, .reusable = true}, SHIFT(626),
  [1199] = {.count = 1, .reusable = true}, SHIFT(623),
  [1201] = {.count = 1, .reusable = true}, SHIFT(627),
  [1203] = {.count = 1, .reusable = true}, SHIFT(628),
  [1205] = {.count = 1, .reusable = true}, SHIFT(624),
  [1207] = {.count = 1, .reusable = true}, SHIFT(629),
  [1209] = {.count = 1, .reusable = false}, SHIFT(630),
  [1211] = {.count = 1, .reusable = false}, SHIFT(623),
  [1213] = {.count = 1, .reusable = true}, SHIFT(622),
  [1215] = {.count = 1, .reusable = false}, SHIFT(628),
  [1217] = {.count = 1, .reusable = false}, SHIFT(631),
  [1219] = {.count = 1, .reusable = true}, SHIFT(631),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [1225] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 1),
  [1227] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 1),
  [1229] = {.count = 1, .reusable = true}, SHIFT(634),
  [1231] = {.count = 1, .reusable = true}, SHIFT(633),
  [1233] = {.count = 1, .reusable = false}, SHIFT(674),
  [1235] = {.count = 1, .reusable = false}, SHIFT(636),
  [1237] = {.count = 1, .reusable = false}, SHIFT(637),
  [1239] = {.count = 1, .reusable = false}, SHIFT(676),
  [1241] = {.count = 1, .reusable = false}, SHIFT(638),
  [1243] = {.count = 1, .reusable = true}, SHIFT(674),
  [1245] = {.count = 1, .reusable = false}, SHIFT(639),
  [1247] = {.count = 1, .reusable = false}, SHIFT(640),
  [1249] = {.count = 1, .reusable = true}, SHIFT(641),
  [1251] = {.count = 1, .reusable = true}, SHIFT(642),
  [1253] = {.count = 1, .reusable = true}, SHIFT(643),
  [1255] = {.count = 1, .reusable = false}, SHIFT(644),
  [1257] = {.count = 1, .reusable = true}, SHIFT(645),
  [1259] = {.count = 1, .reusable = false}, SHIFT(646),
  [1261] = {.count = 1, .reusable = true}, SHIFT(647),
  [1263] = {.count = 1, .reusable = false}, SHIFT(648),
  [1265] = {.count = 1, .reusable = false}, SHIFT(649),
  [1267] = {.count = 1, .reusable = true}, SHIFT(676),
  [1269] = {.count = 1, .reusable = true}, SHIFT(650),
  [1271] = {.count = 1, .reusable = true}, SHIFT(651),
  [1273] = {.count = 1, .reusable = false}, SHIFT(652),
  [1275] = {.count = 1, .reusable = false}, SHIFT(653),
  [1277] = {.count = 1, .reusable = true}, SHIFT(654),
  [1279] = {.count = 1, .reusable = true}, SHIFT(655),
  [1281] = {.count = 1, .reusable = false}, SHIFT(656),
  [1283] = {.count = 1, .reusable = false}, SHIFT(657),
  [1285] = {.count = 1, .reusable = true}, SHIFT(658),
  [1287] = {.count = 1, .reusable = false}, SHIFT(650),
  [1289] = {.count = 1, .reusable = false}, SHIFT(659),
  [1291] = {.count = 1, .reusable = true}, SHIFT(660),
  [1293] = {.count = 1, .reusable = false}, SHIFT(661),
  [1295] = {.count = 1, .reusable = false}, SHIFT(662),
  [1297] = {.count = 1, .reusable = true}, SHIFT(663),
  [1299] = {.count = 1, .reusable = false}, SHIFT(664),
  [1301] = {.count = 1, .reusable = false}, SHIFT(665),
  [1303] = {.count = 1, .reusable = false}, SHIFT(666),
  [1305] = {.count = 1, .reusable = true}, SHIFT(640),
  [1307] = {.count = 1, .reusable = false}, SHIFT(667),
  [1309] = {.count = 1, .reusable = true}, SHIFT(668),
  [1311] = {.count = 1, .reusable = false}, SHIFT(669),
  [1313] = {.count = 1, .reusable = false}, SHIFT(670),
  [1315] = {.count = 1, .reusable = true}, SHIFT(671),
  [1317] = {.count = 1, .reusable = false}, SHIFT(672),
  [1319] = {.count = 1, .reusable = true}, SHIFT(680),
  [1321] = {.count = 1, .reusable = true}, SHIFT(681),
  [1323] = {.count = 1, .reusable = true}, SHIFT(683),
  [1325] = {.count = 1, .reusable = true}, REDUCE(sym__literal_contents, 1),
  [1327] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [1329] = {.count = 1, .reusable = true}, SHIFT(684),
  [1331] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [1333] = {.count = 1, .reusable = false}, SHIFT(686),
  [1335] = {.count = 1, .reusable = true}, SHIFT(687),
  [1337] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [1339] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [1341] = {.count = 1, .reusable = true}, SHIFT(694),
  [1343] = {.count = 1, .reusable = true}, SHIFT(693),
  [1345] = {.count = 1, .reusable = true}, SHIFT(696),
  [1347] = {.count = 1, .reusable = true}, SHIFT(698),
  [1349] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [1351] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [1353] = {.count = 1, .reusable = false}, SHIFT(701),
  [1355] = {.count = 1, .reusable = true}, SHIFT(704),
  [1357] = {.count = 1, .reusable = false}, SHIFT(707),
  [1359] = {.count = 1, .reusable = true}, SHIFT(708),
  [1361] = {.count = 1, .reusable = true}, SHIFT(711),
  [1363] = {.count = 1, .reusable = true}, SHIFT(712),
  [1365] = {.count = 1, .reusable = false}, SHIFT(716),
  [1367] = {.count = 1, .reusable = true}, SHIFT(713),
  [1369] = {.count = 1, .reusable = true}, SHIFT(718),
  [1371] = {.count = 1, .reusable = false}, SHIFT(109),
  [1373] = {.count = 1, .reusable = false}, SHIFT(719),
  [1375] = {.count = 1, .reusable = true}, SHIFT(720),
  [1377] = {.count = 1, .reusable = false}, SHIFT(119),
  [1379] = {.count = 1, .reusable = true}, SHIFT(721),
  [1381] = {.count = 1, .reusable = true}, SHIFT(722),
  [1383] = {.count = 1, .reusable = false}, SHIFT(720),
  [1385] = {.count = 1, .reusable = true}, SHIFT(723),
  [1387] = {.count = 1, .reusable = false}, SHIFT(126),
  [1389] = {.count = 1, .reusable = true}, SHIFT(724),
  [1391] = {.count = 1, .reusable = true}, SHIFT(717),
  [1393] = {.count = 1, .reusable = false}, SHIFT(718),
  [1395] = {.count = 1, .reusable = true}, SHIFT(738),
  [1397] = {.count = 1, .reusable = false}, SHIFT(768),
  [1399] = {.count = 1, .reusable = false}, SHIFT(736),
  [1401] = {.count = 1, .reusable = false}, SHIFT(764),
  [1403] = {.count = 1, .reusable = false}, SHIFT(734),
  [1405] = {.count = 1, .reusable = false}, SHIFT(735),
  [1407] = {.count = 1, .reusable = false}, SHIFT(765),
  [1409] = {.count = 1, .reusable = true}, SHIFT(746),
  [1411] = {.count = 1, .reusable = false}, SHIFT(756),
  [1413] = {.count = 1, .reusable = false}, SHIFT(769),
  [1415] = {.count = 1, .reusable = true}, SHIFT(739),
  [1417] = {.count = 1, .reusable = false}, SHIFT(740),
  [1419] = {.count = 1, .reusable = false}, SHIFT(741),
  [1421] = {.count = 1, .reusable = true}, SHIFT(750),
  [1423] = {.count = 1, .reusable = true}, SHIFT(748),
  [1425] = {.count = 1, .reusable = true}, SHIFT(751),
  [1427] = {.count = 1, .reusable = false}, SHIFT(742),
  [1429] = {.count = 1, .reusable = false}, SHIFT(747),
  [1431] = {.count = 1, .reusable = true}, SHIFT(768),
  [1433] = {.count = 1, .reusable = false}, SHIFT(743),
  [1435] = {.count = 1, .reusable = false}, SHIFT(744),
  [1437] = {.count = 1, .reusable = false}, SHIFT(745),
  [1439] = {.count = 1, .reusable = false}, SHIFT(749),
  [1441] = {.count = 1, .reusable = true}, SHIFT(769),
  [1443] = {.count = 1, .reusable = true}, SHIFT(752),
  [1445] = {.count = 1, .reusable = true}, SHIFT(753),
  [1447] = {.count = 1, .reusable = true}, SHIFT(745),
  [1449] = {.count = 1, .reusable = false}, SHIFT(754),
  [1451] = {.count = 1, .reusable = false}, SHIFT(755),
  [1453] = {.count = 1, .reusable = true}, SHIFT(756),
  [1455] = {.count = 1, .reusable = false}, SHIFT(757),
  [1457] = {.count = 1, .reusable = false}, SHIFT(758),
  [1459] = {.count = 1, .reusable = true}, SHIFT(759),
  [1461] = {.count = 1, .reusable = true}, SHIFT(760),
  [1463] = {.count = 1, .reusable = true}, SHIFT(761),
  [1465] = {.count = 1, .reusable = true}, SHIFT(762),
  [1467] = {.count = 1, .reusable = false}, SHIFT(763),
  [1469] = {.count = 1, .reusable = true}, SHIFT(737),
  [1471] = {.count = 1, .reusable = false}, SHIFT(733),
  [1473] = {.count = 1, .reusable = true}, SHIFT(772),
  [1475] = {.count = 1, .reusable = true}, SHIFT(775),
  [1477] = {.count = 1, .reusable = true}, SHIFT(776),
  [1479] = {.count = 1, .reusable = true}, SHIFT(780),
  [1481] = {.count = 1, .reusable = false}, SHIFT(781),
  [1483] = {.count = 1, .reusable = true}, SHIFT(783),
  [1485] = {.count = 1, .reusable = false}, SHIFT(785),
  [1487] = {.count = 1, .reusable = true}, SHIFT(789),
  [1489] = {.count = 1, .reusable = false}, SHIFT(790),
  [1491] = {.count = 1, .reusable = true}, SHIFT(794),
  [1493] = {.count = 1, .reusable = true}, SHIFT(796),
  [1495] = {.count = 1, .reusable = true}, SHIFT(800),
  [1497] = {.count = 1, .reusable = true}, SHIFT(799),
  [1499] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [1501] = {.count = 1, .reusable = true}, SHIFT(803),
  [1503] = {.count = 1, .reusable = true}, SHIFT(806),
  [1505] = {.count = 1, .reusable = false}, SHIFT(807),
  [1507] = {.count = 1, .reusable = false}, SHIFT(808),
  [1509] = {.count = 1, .reusable = true}, SHIFT(809),
  [1511] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [1513] = {.count = 1, .reusable = true}, SHIFT(810),
  [1515] = {.count = 1, .reusable = true}, SHIFT(811),
  [1517] = {.count = 1, .reusable = true}, SHIFT(812),
  [1519] = {.count = 1, .reusable = true}, SHIFT(814),
  [1521] = {.count = 1, .reusable = true}, SHIFT(813),
  [1523] = {.count = 1, .reusable = true}, SHIFT(815),
  [1525] = {.count = 1, .reusable = false}, SHIFT(816),
  [1527] = {.count = 1, .reusable = false}, SHIFT(811),
  [1529] = {.count = 1, .reusable = true}, SHIFT(808),
  [1531] = {.count = 1, .reusable = false}, SHIFT(813),
  [1533] = {.count = 1, .reusable = false}, SHIFT(817),
  [1535] = {.count = 1, .reusable = true}, SHIFT(817),
  [1537] = {.count = 1, .reusable = true}, SHIFT(820),
  [1539] = {.count = 1, .reusable = false}, SHIFT(818),
  [1541] = {.count = 1, .reusable = true}, SHIFT(819),
  [1543] = {.count = 1, .reusable = true}, SHIFT(818),
  [1545] = {.count = 1, .reusable = false}, SHIFT(858),
  [1547] = {.count = 1, .reusable = true}, SHIFT(855),
  [1549] = {.count = 1, .reusable = false}, SHIFT(821),
  [1551] = {.count = 1, .reusable = false}, SHIFT(856),
  [1553] = {.count = 1, .reusable = false}, SHIFT(861),
  [1555] = {.count = 1, .reusable = true}, SHIFT(858),
  [1557] = {.count = 1, .reusable = false}, SHIFT(822),
  [1559] = {.count = 1, .reusable = true}, SHIFT(824),
  [1561] = {.count = 1, .reusable = true}, SHIFT(825),
  [1563] = {.count = 1, .reusable = true}, SHIFT(826),
  [1565] = {.count = 1, .reusable = false}, SHIFT(827),
  [1567] = {.count = 1, .reusable = true}, SHIFT(828),
  [1569] = {.count = 1, .reusable = false}, SHIFT(829),
  [1571] = {.count = 1, .reusable = false}, SHIFT(830),
  [1573] = {.count = 1, .reusable = true}, SHIFT(861),
  [1575] = {.count = 1, .reusable = true}, SHIFT(831),
  [1577] = {.count = 1, .reusable = true}, SHIFT(832),
  [1579] = {.count = 1, .reusable = false}, SHIFT(833),
  [1581] = {.count = 1, .reusable = false}, SHIFT(834),
  [1583] = {.count = 1, .reusable = true}, SHIFT(835),
  [1585] = {.count = 1, .reusable = true}, SHIFT(836),
  [1587] = {.count = 1, .reusable = false}, SHIFT(837),
  [1589] = {.count = 1, .reusable = false}, SHIFT(838),
  [1591] = {.count = 1, .reusable = true}, SHIFT(839),
  [1593] = {.count = 1, .reusable = false}, SHIFT(831),
  [1595] = {.count = 1, .reusable = true}, SHIFT(840),
  [1597] = {.count = 1, .reusable = false}, SHIFT(841),
  [1599] = {.count = 1, .reusable = true}, SHIFT(842),
  [1601] = {.count = 1, .reusable = false}, SHIFT(843),
  [1603] = {.count = 1, .reusable = true}, SHIFT(844),
  [1605] = {.count = 1, .reusable = false}, SHIFT(845),
  [1607] = {.count = 1, .reusable = false}, SHIFT(846),
  [1609] = {.count = 1, .reusable = true}, SHIFT(847),
  [1611] = {.count = 1, .reusable = false}, SHIFT(848),
  [1613] = {.count = 1, .reusable = false}, SHIFT(849),
  [1615] = {.count = 1, .reusable = true}, SHIFT(823),
  [1617] = {.count = 1, .reusable = false}, SHIFT(850),
  [1619] = {.count = 1, .reusable = true}, SHIFT(851),
  [1621] = {.count = 1, .reusable = false}, SHIFT(852),
  [1623] = {.count = 1, .reusable = false}, SHIFT(824),
  [1625] = {.count = 1, .reusable = false}, SHIFT(854),
  [1627] = {.count = 1, .reusable = true}, SHIFT(807),
  [1629] = {.count = 1, .reusable = false}, SHIFT(712),
  [1631] = {.count = 1, .reusable = true}, SHIFT(868),
  [1633] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [1635] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [1637] = {.count = 1, .reusable = true}, SHIFT(875),
  [1639] = {.count = 1, .reusable = true}, SHIFT(874),
  [1641] = {.count = 1, .reusable = true}, SHIFT(877),
  [1643] = {.count = 1, .reusable = true}, SHIFT(879),
  [1645] = {.count = 1, .reusable = false}, SHIFT(882),
  [1647] = {.count = 1, .reusable = true}, SHIFT(886),
  [1649] = {.count = 1, .reusable = true}, SHIFT(884),
  [1651] = {.count = 1, .reusable = false}, SHIFT(885),
  [1653] = {.count = 1, .reusable = true}, SHIFT(888),
  [1655] = {.count = 1, .reusable = false}, SHIFT(891),
  [1657] = {.count = 1, .reusable = true}, SHIFT(892),
  [1659] = {.count = 1, .reusable = true}, SHIFT(895),
  [1661] = {.count = 1, .reusable = true}, SHIFT(896),
  [1663] = {.count = 1, .reusable = false}, SHIFT(900),
  [1665] = {.count = 1, .reusable = true}, SHIFT(897),
  [1667] = {.count = 1, .reusable = false}, SHIFT(917),
  [1669] = {.count = 1, .reusable = false}, SHIFT(913),
  [1671] = {.count = 1, .reusable = false}, SHIFT(918),
  [1673] = {.count = 1, .reusable = true}, SHIFT(917),
  [1675] = {.count = 1, .reusable = true}, SHIFT(902),
  [1677] = {.count = 1, .reusable = false}, SHIFT(903),
  [1679] = {.count = 1, .reusable = true}, SHIFT(918),
  [1681] = {.count = 1, .reusable = true}, SHIFT(904),
  [1683] = {.count = 1, .reusable = false}, SHIFT(905),
  [1685] = {.count = 1, .reusable = true}, SHIFT(906),
  [1687] = {.count = 1, .reusable = false}, SHIFT(907),
  [1689] = {.count = 1, .reusable = true}, SHIFT(908),
  [1691] = {.count = 1, .reusable = false}, SHIFT(904),
  [1693] = {.count = 1, .reusable = true}, SHIFT(909),
  [1695] = {.count = 1, .reusable = false}, SHIFT(910),
  [1697] = {.count = 1, .reusable = true}, SHIFT(901),
  [1699] = {.count = 1, .reusable = false}, SHIFT(911),
  [1701] = {.count = 1, .reusable = false}, SHIFT(902),
  [1703] = {.count = 1, .reusable = true}, SHIFT(923),
  [1705] = {.count = 1, .reusable = true}, SHIFT(926),
  [1707] = {.count = 1, .reusable = true}, SHIFT(927),
  [1709] = {.count = 1, .reusable = true}, SHIFT(930),
  [1711] = {.count = 1, .reusable = false}, SHIFT(931),
  [1713] = {.count = 1, .reusable = true}, SHIFT(933),
  [1715] = {.count = 1, .reusable = false}, SHIFT(935),
  [1717] = {.count = 1, .reusable = true}, SHIFT(939),
  [1719] = {.count = 1, .reusable = false}, SHIFT(940),
  [1721] = {.count = 1, .reusable = true}, SHIFT(944),
  [1723] = {.count = 1, .reusable = true}, SHIFT(946),
  [1725] = {.count = 1, .reusable = false}, SHIFT(957),
  [1727] = {.count = 1, .reusable = false}, SHIFT(954),
  [1729] = {.count = 1, .reusable = true}, SHIFT(950),
  [1731] = {.count = 1, .reusable = false}, SHIFT(952),
  [1733] = {.count = 1, .reusable = false}, SHIFT(958),
  [1735] = {.count = 1, .reusable = false}, SHIFT(948),
  [1737] = {.count = 1, .reusable = true}, SHIFT(957),
  [1739] = {.count = 1, .reusable = false}, SHIFT(949),
  [1741] = {.count = 1, .reusable = true}, SHIFT(958),
  [1743] = {.count = 1, .reusable = true}, SHIFT(949),
  [1745] = {.count = 1, .reusable = false}, SHIFT(951),
  [1747] = {.count = 1, .reusable = true}, SHIFT(952),
  [1749] = {.count = 1, .reusable = true}, SHIFT(953),
  [1751] = {.count = 1, .reusable = false}, SHIFT(947),
  [1753] = {.count = 1, .reusable = true}, SHIFT(963),
  [1755] = {.count = 1, .reusable = true}, SHIFT(962),
  [1757] = {.count = 1, .reusable = true}, SHIFT(966),
  [1759] = {.count = 1, .reusable = false}, SHIFT(967),
  [1761] = {.count = 1, .reusable = false}, SHIFT(968),
  [1763] = {.count = 1, .reusable = true}, SHIFT(969),
  [1765] = {.count = 1, .reusable = true}, SHIFT(970),
  [1767] = {.count = 1, .reusable = true}, SHIFT(971),
  [1769] = {.count = 1, .reusable = true}, SHIFT(972),
  [1771] = {.count = 1, .reusable = true}, SHIFT(973),
  [1773] = {.count = 1, .reusable = true}, SHIFT(974),
  [1775] = {.count = 1, .reusable = true}, SHIFT(975),
  [1777] = {.count = 1, .reusable = false}, SHIFT(976),
  [1779] = {.count = 1, .reusable = false}, SHIFT(971),
  [1781] = {.count = 1, .reusable = true}, SHIFT(968),
  [1783] = {.count = 1, .reusable = false}, SHIFT(973),
  [1785] = {.count = 1, .reusable = false}, SHIFT(977),
  [1787] = {.count = 1, .reusable = true}, SHIFT(977),
  [1789] = {.count = 1, .reusable = true}, SHIFT(980),
  [1791] = {.count = 1, .reusable = false}, SHIFT(978),
  [1793] = {.count = 1, .reusable = true}, SHIFT(979),
  [1795] = {.count = 1, .reusable = true}, SHIFT(978),
  [1797] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 1),
  [1799] = {.count = 1, .reusable = true}, SHIFT(981),
  [1801] = {.count = 1, .reusable = true}, SHIFT(982),
  [1803] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 1),
  [1805] = {.count = 1, .reusable = false}, SHIFT(999),
  [1807] = {.count = 1, .reusable = false}, SHIFT(997),
  [1809] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1811] = {.count = 1, .reusable = true}, SHIFT(999),
  [1813] = {.count = 1, .reusable = true}, SHIFT(985),
  [1815] = {.count = 1, .reusable = true}, SHIFT(986),
  [1817] = {.count = 1, .reusable = false}, SHIFT(987),
  [1819] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1821] = {.count = 1, .reusable = true}, SHIFT(988),
  [1823] = {.count = 1, .reusable = false}, SHIFT(989),
  [1825] = {.count = 1, .reusable = true}, SHIFT(990),
  [1827] = {.count = 1, .reusable = false}, SHIFT(991),
  [1829] = {.count = 1, .reusable = true}, SHIFT(992),
  [1831] = {.count = 1, .reusable = false}, SHIFT(988),
  [1833] = {.count = 1, .reusable = true}, SHIFT(993),
  [1835] = {.count = 1, .reusable = false}, SHIFT(994),
  [1837] = {.count = 1, .reusable = true}, SHIFT(984),
  [1839] = {.count = 1, .reusable = false}, SHIFT(995),
  [1841] = {.count = 1, .reusable = false}, SHIFT(985),
  [1843] = {.count = 1, .reusable = true}, SHIFT(967),
  [1845] = {.count = 1, .reusable = false}, SHIFT(896),
  [1847] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1849] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1851] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .alias_sequence_id = 2),
  [1853] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .alias_sequence_id = 2),
  [1855] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1859] = {.count = 1, .reusable = false}, SHIFT(901),
  [1861] = {.count = 1, .reusable = false}, SHIFT(1015),
  [1863] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1865] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1867] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1869] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1871] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1873] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1875] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1877] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1879] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1881] = {.count = 1, .reusable = true}, SHIFT(1034),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1038),
  [1885] = {.count = 1, .reusable = false}, SHIFT(1039),
  [1887] = {.count = 1, .reusable = false}, SHIFT(1041),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1891] = {.count = 1, .reusable = false}, SHIFT(1046),
  [1893] = {.count = 1, .reusable = true}, SHIFT(1049),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1052),
  [1897] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1054),
  [1901] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1056),
  [1905] = {.count = 1, .reusable = true}, SHIFT(1061),
  [1907] = {.count = 1, .reusable = true}, SHIFT(1063),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1065),
  [1911] = {.count = 1, .reusable = false}, SHIFT(1067),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1068),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1917] = {.count = 1, .reusable = false}, SHIFT(1075),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1921] = {.count = 1, .reusable = true}, SHIFT(1078),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1080),
  [1925] = {.count = 1, .reusable = true}, SHIFT(1081),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1082),
  [1929] = {.count = 1, .reusable = false}, SHIFT(1098),
  [1931] = {.count = 1, .reusable = false}, SHIFT(1101),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1098),
  [1935] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1084),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1085),
  [1941] = {.count = 1, .reusable = false}, SHIFT(1086),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1101),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1087),
  [1947] = {.count = 1, .reusable = false}, SHIFT(1088),
  [1949] = {.count = 1, .reusable = true}, SHIFT(1089),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1090),
  [1953] = {.count = 1, .reusable = true}, SHIFT(1091),
  [1955] = {.count = 1, .reusable = false}, SHIFT(1087),
  [1957] = {.count = 1, .reusable = true}, SHIFT(1092),
  [1959] = {.count = 1, .reusable = false}, SHIFT(1093),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1963] = {.count = 1, .reusable = false}, SHIFT(1094),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1095),
  [1967] = {.count = 1, .reusable = false}, SHIFT(1096),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1108),
  [1971] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [1973] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [1975] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1127),
  [1979] = {.count = 1, .reusable = false}, SHIFT(1125),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1111),
  [1983] = {.count = 1, .reusable = false}, SHIFT(1128),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1125),
  [1987] = {.count = 1, .reusable = false}, SHIFT(1112),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1113),
  [1991] = {.count = 1, .reusable = true}, SHIFT(1128),
  [1993] = {.count = 1, .reusable = true}, SHIFT(1114),
  [1995] = {.count = 1, .reusable = true}, SHIFT(1115),
  [1997] = {.count = 1, .reusable = true}, SHIFT(1116),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2003] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2005] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2011] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2013] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2015] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [2017] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [2019] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2021] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2035] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2037] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2043] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2),
  [2045] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2),
  [2047] = {.count = 1, .reusable = true}, SHIFT(242),
  [2049] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2053] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2),
  [2055] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2),
  [2057] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2059] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2061] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2065] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2069] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2073] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2079] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2093] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2101] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2),
  [2103] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2107] = {.count = 1, .reusable = true}, SHIFT(285),
  [2109] = {.count = 1, .reusable = false}, SHIFT(263),
  [2111] = {.count = 1, .reusable = true}, SHIFT(267),
  [2113] = {.count = 1, .reusable = true}, SHIFT(277),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2119] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2123] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2125] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2127] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2129] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2133] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2135] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2137] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2139] = {.count = 1, .reusable = false}, SHIFT(1205),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2145] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2147] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2151] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2153] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2161] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2165] = {.count = 1, .reusable = false}, SHIFT(1216),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2169] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2173] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2179] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2193] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2195] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2197] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2201] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2205] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2209] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2215] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2219] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2223] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2231] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2233] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 1),
  [2235] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 1),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2243] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2245] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2247] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2257] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2261] = {.count = 1, .reusable = false}, REDUCE(sym__argument, 1),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2267] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2275] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2281] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2285] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2287] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2289] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2291] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2293] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2295] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2299] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [2301] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [2303] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .alias_sequence_id = 2),
  [2305] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .alias_sequence_id = 2),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2311] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1319),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1317),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1323),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1315),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2341] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2343] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1342),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1345),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2385] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [2387] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2391] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2395] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2401] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2403] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2405] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2407] = {.count = 1, .reusable = false}, SHIFT(1364),
  [2409] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2413] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2415] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2417] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2423] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2425] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2427] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2429] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2433] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2455] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2457] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2459] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2461] = {.count = 1, .reusable = true}, SHIFT(1396),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2465] = {.count = 1, .reusable = false}, SHIFT(1408),
  [2467] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2469] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2473] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2475] = {.count = 1, .reusable = true}, SHIFT(1411),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2479] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2481] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2485] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2489] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2495] = {.count = 1, .reusable = false}, SHIFT(1398),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1417),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2501] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1421),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1424),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2517] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2519] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1424),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2531] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [2533] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1438),
  [2545] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1442),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2557] = {.count = 1, .reusable = false}, SHIFT(1445),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1446),
  [2561] = {.count = 1, .reusable = false}, SHIFT(1443),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2565] = {.count = 1, .reusable = false}, SHIFT(1448),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1439),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1449),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1450),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1451),
  [2575] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .alias_sequence_id = 3),
  [2577] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .alias_sequence_id = 3),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1458),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1460),
  [2583] = {.count = 1, .reusable = false}, SHIFT(1459),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1461),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1462),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1487),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1481),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1483),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1481),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1465),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1483),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1467),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1468),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1469),
  [2611] = {.count = 1, .reusable = false}, SHIFT(1470),
  [2613] = {.count = 1, .reusable = false}, SHIFT(1468),
  [2615] = {.count = 1, .reusable = false}, SHIFT(1471),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1472),
  [2619] = {.count = 1, .reusable = false}, SHIFT(1473),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1474),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1475),
  [2627] = {.count = 1, .reusable = false}, SHIFT(1476),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1489),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1488),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1502),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1491),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1505),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1502),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1492),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1493),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1505),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1494),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1495),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1496),
  [2655] = {.count = 1, .reusable = false}, SHIFT(1497),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1495),
  [2659] = {.count = 1, .reusable = false}, SHIFT(1498),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1492),
  [2663] = {.count = 1, .reusable = false}, SHIFT(1499),
  [2665] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [2667] = {.count = 1, .reusable = false}, SHIFT(1500),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1511),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1528),
  [2673] = {.count = 1, .reusable = false}, SHIFT(1524),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1529),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1528),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1513),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1514),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1529),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1515),
  [2687] = {.count = 1, .reusable = false}, SHIFT(1516),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1517),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1518),
  [2693] = {.count = 1, .reusable = true}, SHIFT(1519),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1515),
  [2697] = {.count = 1, .reusable = true}, SHIFT(1520),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1521),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1512),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1522),
  [2705] = {.count = 1, .reusable = false}, SHIFT(1513),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1533),
  [2709] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1540),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1535),
  [2715] = {.count = 1, .reusable = true}, SHIFT(1536),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1537),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1538),
  [2721] = {.count = 1, .reusable = true}, SHIFT(1539),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1541),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1543),
  [2727] = {.count = 1, .reusable = false}, SHIFT(1542),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1542),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1544),
  [2733] = {.count = 1, .reusable = true}, SHIFT(372),
  [2735] = {.count = 1, .reusable = true}, SHIFT(367),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1547),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1548),
  [2741] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [2743] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [2745] = {.count = 1, .reusable = false}, SHIFT(1561),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1560),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1563),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1561),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1550),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1551),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1563),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1552),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1553),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1554),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1555),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1552),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1556),
  [2771] = {.count = 1, .reusable = false}, SHIFT(1557),
  [2773] = {.count = 1, .reusable = true}, SHIFT(1549),
  [2775] = {.count = 1, .reusable = false}, SHIFT(1558),
  [2777] = {.count = 1, .reusable = false}, SHIFT(1550),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1569),
  [2781] = {.count = 1, .reusable = false}, SHIFT(1544),
  [2783] = {.count = 1, .reusable = false}, SHIFT(1570),
  [2785] = {.count = 1, .reusable = true}, SHIFT(1573),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1574),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1571),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1575),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1576),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1572),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1577),
  [2799] = {.count = 1, .reusable = false}, SHIFT(1578),
  [2801] = {.count = 1, .reusable = false}, SHIFT(1571),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1570),
  [2805] = {.count = 1, .reusable = false}, SHIFT(1576),
  [2807] = {.count = 1, .reusable = false}, SHIFT(1579),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1579),
  [2811] = {.count = 1, .reusable = true}, SHIFT(364),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1584),
  [2815] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1585),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1586),
  [2821] = {.count = 1, .reusable = false}, SHIFT(1587),
  [2823] = {.count = 1, .reusable = true}, SHIFT(1588),
  [2825] = {.count = 1, .reusable = false}, SHIFT(1589),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1590),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1591),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1592),
  [2833] = {.count = 1, .reusable = false}, SHIFT(1590),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1593),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1594),
  [2839] = {.count = 1, .reusable = false}, SHIFT(1595),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1587),
  [2843] = {.count = 1, .reusable = false}, SHIFT(1596),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1597),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1598),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1605),
  [2851] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [2853] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [2855] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .alias_sequence_id = 4),
  [2857] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .alias_sequence_id = 4),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1606),
  [2861] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [2863] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1609),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1607),
  [2869] = {.count = 1, .reusable = true}, SHIFT(1608),
  [2871] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .alias_sequence_id = 1),
  [2873] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .alias_sequence_id = 1),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1612),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1611),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1614),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1615),
  [2883] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [2885] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1621),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1620),
  [2891] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [2893] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [2895] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1626),
  [2899] = {.count = 1, .reusable = false}, SHIFT(1628),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1628),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1629),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1630),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1631),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1634),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1636),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1639),
  [2915] = {.count = 1, .reusable = false}, SHIFT(1640),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1637),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1638),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1638),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1640),
  [2925] = {.count = 1, .reusable = true}, SHIFT(437),
  [2927] = {.count = 1, .reusable = false}, SHIFT(417),
  [2929] = {.count = 1, .reusable = true}, SHIFT(421),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1648),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1653),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1652),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1655),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1669),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1671),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1657),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1669),
  [2947] = {.count = 1, .reusable = false}, SHIFT(1658),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1659),
  [2951] = {.count = 1, .reusable = false}, SHIFT(1660),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1671),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1661),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1662),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1663),
  [2961] = {.count = 1, .reusable = false}, SHIFT(1661),
  [2963] = {.count = 1, .reusable = false}, SHIFT(1664),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1658),
  [2967] = {.count = 1, .reusable = false}, SHIFT(1665),
  [2969] = {.count = 1, .reusable = false}, SHIFT(1666),
  [2971] = {.count = 1, .reusable = false}, SHIFT(1677),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1680),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1685),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1683),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1687),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1690),
  [2983] = {.count = 1, .reusable = false}, SHIFT(1694),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1691),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1700),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1727),
  [2991] = {.count = 1, .reusable = false}, SHIFT(1723),
  [2993] = {.count = 1, .reusable = false}, SHIFT(1697),
  [2995] = {.count = 1, .reusable = false}, SHIFT(1698),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1724),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3003] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3005] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3007] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3009] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3011] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3013] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3015] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3017] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3019] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3021] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3023] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3025] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3029] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3035] = {.count = 1, .reusable = false}, SHIFT(1714),
  [3037] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3041] = {.count = 1, .reusable = false}, SHIFT(1717),
  [3043] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3045] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3051] = {.count = 1, .reusable = false}, SHIFT(1722),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3055] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3061] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1742),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3071] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3075] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3079] = {.count = 1, .reusable = false}, SHIFT(1757),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3083] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3085] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2),
  [3087] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3091] = {.count = 1, .reusable = true}, SHIFT(428),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3103] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1778),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1779),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1777),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1799),
  [3137] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1794),
  [3143] = {.count = 1, .reusable = false}, SHIFT(1800),
  [3145] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1793),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1789),
  [3163] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [3165] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3169] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [3171] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1820),
  [3174] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [3177] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1810),
  [3180] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1822),
  [3183] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [3186] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1812),
  [3189] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [3192] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1811),
  [3195] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [3198] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [3201] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1820),
  [3204] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [3207] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [3210] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [3213] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [3216] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [3219] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [3222] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1822),
  [3225] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1813),
  [3228] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [3231] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [3234] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(19),
  [3237] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [3240] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1814),
  [3243] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [3246] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1815),
  [3249] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [3252] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1813),
  [3255] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [3258] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(26),
  [3261] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(27),
  [3264] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1816),
  [3267] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(29),
  [3270] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(30),
  [3273] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(31),
  [3276] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(32),
  [3279] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(33),
  [3282] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(34),
  [3285] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1811),
  [3288] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1817),
  [3291] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(37),
  [3294] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(38),
  [3297] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(39),
  [3300] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(40),
  [3303] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1818),
  [3306] = {.count = 1, .reusable = false}, SHIFT(476),
  [3308] = {.count = 1, .reusable = true}, SHIFT(480),
  [3310] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3316] = {.count = 1, .reusable = false}, SHIFT(1832),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1833),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1847),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3328] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3330] = {.count = 1, .reusable = false}, SHIFT(1842),
  [3332] = {.count = 1, .reusable = false}, SHIFT(1843),
  [3334] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3336] = {.count = 1, .reusable = false}, SHIFT(1845),
  [3338] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1841),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3344] = {.count = 1, .reusable = true}, SHIFT(1857),
  [3346] = {.count = 1, .reusable = false}, SHIFT(1858),
  [3348] = {.count = 1, .reusable = false}, SHIFT(1859),
  [3350] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3354] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3362] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3364] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1859),
  [3368] = {.count = 1, .reusable = false}, SHIFT(1867),
  [3370] = {.count = 1, .reusable = false}, SHIFT(1864),
  [3372] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3376] = {.count = 1, .reusable = false}, SHIFT(1868),
  [3378] = {.count = 1, .reusable = true}, SHIFT(1868),
  [3380] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3382] = {.count = 1, .reusable = false}, SHIFT(1871),
  [3384] = {.count = 1, .reusable = true}, SHIFT(1872),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3388] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3390] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3392] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3394] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3396] = {.count = 1, .reusable = false}, SHIFT(1885),
  [3398] = {.count = 1, .reusable = true}, SHIFT(1882),
  [3400] = {.count = 1, .reusable = false}, SHIFT(1883),
  [3402] = {.count = 1, .reusable = true}, SHIFT(1883),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1885),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1900),
  [3408] = {.count = 1, .reusable = true}, SHIFT(1899),
  [3410] = {.count = 1, .reusable = false}, SHIFT(1902),
  [3412] = {.count = 1, .reusable = false}, SHIFT(1904),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1904),
  [3416] = {.count = 1, .reusable = true}, SHIFT(1905),
  [3418] = {.count = 1, .reusable = true}, SHIFT(1906),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1909),
  [3422] = {.count = 1, .reusable = false}, SHIFT(516),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1912),
  [3426] = {.count = 1, .reusable = false}, SHIFT(1913),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1915),
  [3430] = {.count = 1, .reusable = false}, SHIFT(1925),
  [3432] = {.count = 1, .reusable = false}, SHIFT(1922),
  [3434] = {.count = 1, .reusable = true}, SHIFT(1919),
  [3436] = {.count = 1, .reusable = false}, SHIFT(1921),
  [3438] = {.count = 1, .reusable = false}, SHIFT(1926),
  [3440] = {.count = 1, .reusable = false}, SHIFT(1917),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1925),
  [3444] = {.count = 1, .reusable = false}, SHIFT(1918),
  [3446] = {.count = 1, .reusable = true}, SHIFT(1926),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1918),
  [3450] = {.count = 1, .reusable = false}, SHIFT(1920),
  [3452] = {.count = 1, .reusable = true}, SHIFT(1921),
  [3454] = {.count = 1, .reusable = false}, SHIFT(1916),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1931),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1932),
  [3460] = {.count = 1, .reusable = true}, SHIFT(1935),
  [3462] = {.count = 1, .reusable = false}, SHIFT(1931),
  [3464] = {.count = 1, .reusable = false}, SHIFT(1936),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1937),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1938),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1940),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1941),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1939),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1942),
  [3478] = {.count = 1, .reusable = false}, SHIFT(1943),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1937),
  [3482] = {.count = 1, .reusable = false}, SHIFT(1939),
  [3484] = {.count = 1, .reusable = true}, SHIFT(1936),
  [3486] = {.count = 1, .reusable = false}, SHIFT(1944),
  [3488] = {.count = 1, .reusable = false}, SHIFT(1941),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1942),
  [3492] = {.count = 1, .reusable = false}, SHIFT(1915),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3496] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [3498] = {.count = 1, .reusable = true}, SHIFT(1948),
  [3500] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1950),
  [3504] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1953),
  [3508] = {.count = 1, .reusable = false}, SHIFT(1965),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1955),
  [3512] = {.count = 1, .reusable = false}, SHIFT(1956),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1957),
  [3516] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1958),
  [3520] = {.count = 1, .reusable = false}, SHIFT(1959),
  [3522] = {.count = 1, .reusable = true}, SHIFT(1960),
  [3524] = {.count = 1, .reusable = false}, SHIFT(1957),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1961),
  [3528] = {.count = 1, .reusable = false}, SHIFT(1962),
  [3530] = {.count = 1, .reusable = true}, SHIFT(1954),
  [3532] = {.count = 1, .reusable = false}, SHIFT(1963),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1955),
  [3536] = {.count = 1, .reusable = true}, SHIFT(1978),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1972),
  [3540] = {.count = 1, .reusable = true}, SHIFT(1973),
  [3542] = {.count = 1, .reusable = true}, SHIFT(1974),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1975),
  [3546] = {.count = 1, .reusable = true}, SHIFT(1976),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1977),
  [3550] = {.count = 1, .reusable = true}, SHIFT(1980),
  [3552] = {.count = 1, .reusable = false}, SHIFT(1979),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1979),
  [3556] = {.count = 1, .reusable = true}, SHIFT(1981),
  [3558] = {.count = 1, .reusable = false}, SHIFT(1994),
  [3560] = {.count = 1, .reusable = false}, SHIFT(1993),
  [3562] = {.count = 1, .reusable = false}, SHIFT(1996),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1994),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1983),
  [3568] = {.count = 1, .reusable = false}, SHIFT(1984),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1996),
  [3572] = {.count = 1, .reusable = true}, SHIFT(1985),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1986),
  [3576] = {.count = 1, .reusable = false}, SHIFT(1987),
  [3578] = {.count = 1, .reusable = true}, SHIFT(1988),
  [3580] = {.count = 1, .reusable = false}, SHIFT(1985),
  [3582] = {.count = 1, .reusable = true}, SHIFT(1989),
  [3584] = {.count = 1, .reusable = false}, SHIFT(1990),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1982),
  [3588] = {.count = 1, .reusable = false}, SHIFT(1991),
  [3590] = {.count = 1, .reusable = false}, SHIFT(1983),
  [3592] = {.count = 1, .reusable = true}, SHIFT(2002),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1981),
  [3596] = {.count = 1, .reusable = false}, SHIFT(2003),
  [3598] = {.count = 1, .reusable = true}, SHIFT(2006),
  [3600] = {.count = 1, .reusable = true}, SHIFT(2007),
  [3602] = {.count = 1, .reusable = true}, SHIFT(2004),
  [3604] = {.count = 1, .reusable = true}, SHIFT(2008),
  [3606] = {.count = 1, .reusable = true}, SHIFT(2009),
  [3608] = {.count = 1, .reusable = true}, SHIFT(2005),
  [3610] = {.count = 1, .reusable = true}, SHIFT(2010),
  [3612] = {.count = 1, .reusable = false}, SHIFT(2011),
  [3614] = {.count = 1, .reusable = false}, SHIFT(2004),
  [3616] = {.count = 1, .reusable = true}, SHIFT(2003),
  [3618] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3620] = {.count = 1, .reusable = false}, SHIFT(2012),
  [3622] = {.count = 1, .reusable = true}, SHIFT(2012),
  [3624] = {.count = 1, .reusable = true}, SHIFT(2014),
  [3626] = {.count = 1, .reusable = false}, SHIFT(568),
  [3628] = {.count = 1, .reusable = true}, SHIFT(572),
  [3630] = {.count = 1, .reusable = false}, SHIFT(2020),
  [3632] = {.count = 1, .reusable = true}, SHIFT(2022),
  [3634] = {.count = 1, .reusable = true}, SHIFT(2023),
  [3636] = {.count = 1, .reusable = false}, SHIFT(2024),
  [3638] = {.count = 1, .reusable = true}, SHIFT(2025),
  [3640] = {.count = 1, .reusable = true}, SHIFT(2026),
  [3642] = {.count = 1, .reusable = true}, SHIFT(2027),
  [3644] = {.count = 1, .reusable = false}, SHIFT(2039),
  [3646] = {.count = 1, .reusable = true}, SHIFT(2036),
  [3648] = {.count = 1, .reusable = false}, SHIFT(2038),
  [3650] = {.count = 1, .reusable = false}, SHIFT(2034),
  [3652] = {.count = 1, .reusable = false}, SHIFT(2035),
  [3654] = {.count = 1, .reusable = true}, SHIFT(2035),
  [3656] = {.count = 1, .reusable = false}, SHIFT(2037),
  [3658] = {.count = 1, .reusable = true}, SHIFT(2038),
  [3660] = {.count = 1, .reusable = false}, SHIFT(2033),
  [3662] = {.count = 1, .reusable = true}, SHIFT(2046),
  [3664] = {.count = 1, .reusable = true}, SHIFT(2049),
  [3666] = {.count = 1, .reusable = false}, SHIFT(2050),
  [3668] = {.count = 1, .reusable = false}, SHIFT(2051),
  [3670] = {.count = 1, .reusable = true}, SHIFT(2052),
  [3672] = {.count = 1, .reusable = true}, SHIFT(2053),
  [3674] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3676] = {.count = 1, .reusable = true}, SHIFT(2056),
  [3678] = {.count = 1, .reusable = true}, SHIFT(2054),
  [3680] = {.count = 1, .reusable = false}, SHIFT(2058),
  [3682] = {.count = 1, .reusable = true}, SHIFT(2057),
  [3684] = {.count = 1, .reusable = false}, SHIFT(2054),
  [3686] = {.count = 1, .reusable = true}, SHIFT(2051),
  [3688] = {.count = 1, .reusable = false}, SHIFT(2059),
  [3690] = {.count = 1, .reusable = false}, SHIFT(2056),
  [3692] = {.count = 1, .reusable = true}, SHIFT(2059),
  [3694] = {.count = 1, .reusable = true}, SHIFT(2061),
  [3696] = {.count = 1, .reusable = false}, SHIFT(2060),
  [3698] = {.count = 1, .reusable = true}, SHIFT(2060),
  [3700] = {.count = 1, .reusable = false}, SHIFT(2062),
  [3702] = {.count = 1, .reusable = true}, SHIFT(2063),
  [3704] = {.count = 1, .reusable = true}, SHIFT(2064),
  [3706] = {.count = 1, .reusable = true}, SHIFT(2065),
  [3708] = {.count = 1, .reusable = true}, SHIFT(2050),
  [3710] = {.count = 1, .reusable = false}, SHIFT(2023),
  [3712] = {.count = 1, .reusable = false}, SHIFT(2083),
  [3714] = {.count = 1, .reusable = false}, SHIFT(2072),
  [3716] = {.count = 1, .reusable = false}, SHIFT(2085),
  [3718] = {.count = 1, .reusable = true}, SHIFT(2083),
  [3720] = {.count = 1, .reusable = false}, SHIFT(2073),
  [3722] = {.count = 1, .reusable = true}, SHIFT(2074),
  [3724] = {.count = 1, .reusable = true}, SHIFT(2085),
  [3726] = {.count = 1, .reusable = true}, SHIFT(2075),
  [3728] = {.count = 1, .reusable = false}, REDUCE(sym_then, 1),
  [3730] = {.count = 1, .reusable = true}, SHIFT(2076),
  [3732] = {.count = 1, .reusable = false}, SHIFT(2077),
  [3734] = {.count = 1, .reusable = false}, SHIFT(2075),
  [3736] = {.count = 1, .reusable = true}, SHIFT(2078),
  [3738] = {.count = 1, .reusable = false}, SHIFT(2079),
  [3740] = {.count = 1, .reusable = true}, SHIFT(2073),
  [3742] = {.count = 1, .reusable = false}, SHIFT(2080),
  [3744] = {.count = 1, .reusable = false}, SHIFT(2081),
  [3746] = {.count = 1, .reusable = true}, SHIFT(2095),
  [3748] = {.count = 1, .reusable = true}, SHIFT(2094),
  [3750] = {.count = 1, .reusable = false}, SHIFT(1351),
  [3752] = {.count = 1, .reusable = false}, SHIFT(2098),
  [3754] = {.count = 1, .reusable = false}, SHIFT(2099),
  [3756] = {.count = 1, .reusable = true}, SHIFT(2099),
  [3758] = {.count = 1, .reusable = false}, SHIFT(2101),
  [3760] = {.count = 1, .reusable = true}, SHIFT(2101),
  [3762] = {.count = 1, .reusable = true}, SHIFT(2102),
  [3764] = {.count = 1, .reusable = true}, SHIFT(2103),
  [3766] = {.count = 1, .reusable = true}, SHIFT(2106),
  [3768] = {.count = 1, .reusable = true}, SHIFT(2109),
  [3770] = {.count = 1, .reusable = false}, SHIFT(2110),
  [3772] = {.count = 1, .reusable = true}, SHIFT(2107),
  [3774] = {.count = 1, .reusable = false}, SHIFT(2108),
  [3776] = {.count = 1, .reusable = true}, SHIFT(2108),
  [3778] = {.count = 1, .reusable = true}, SHIFT(2110),
  [3780] = {.count = 1, .reusable = false}, SHIFT(601),
  [3782] = {.count = 1, .reusable = false}, SHIFT(2117),
  [3784] = {.count = 1, .reusable = true}, SHIFT(2119),
  [3786] = {.count = 1, .reusable = false}, SHIFT(2129),
  [3788] = {.count = 1, .reusable = false}, SHIFT(2126),
  [3790] = {.count = 1, .reusable = true}, SHIFT(2123),
  [3792] = {.count = 1, .reusable = false}, SHIFT(2125),
  [3794] = {.count = 1, .reusable = false}, SHIFT(2130),
  [3796] = {.count = 1, .reusable = false}, SHIFT(2121),
  [3798] = {.count = 1, .reusable = true}, SHIFT(2129),
  [3800] = {.count = 1, .reusable = false}, SHIFT(2122),
  [3802] = {.count = 1, .reusable = true}, SHIFT(2130),
  [3804] = {.count = 1, .reusable = true}, SHIFT(2122),
  [3806] = {.count = 1, .reusable = false}, SHIFT(2124),
  [3808] = {.count = 1, .reusable = true}, SHIFT(2125),
  [3810] = {.count = 1, .reusable = false}, SHIFT(2120),
  [3812] = {.count = 1, .reusable = true}, SHIFT(2135),
  [3814] = {.count = 1, .reusable = true}, SHIFT(2136),
  [3816] = {.count = 1, .reusable = true}, SHIFT(2139),
  [3818] = {.count = 1, .reusable = false}, SHIFT(2135),
  [3820] = {.count = 1, .reusable = false}, SHIFT(2141),
  [3822] = {.count = 1, .reusable = true}, SHIFT(2143),
  [3824] = {.count = 1, .reusable = false}, SHIFT(2144),
  [3826] = {.count = 1, .reusable = true}, SHIFT(2141),
  [3828] = {.count = 1, .reusable = false}, SHIFT(2146),
  [3830] = {.count = 1, .reusable = false}, SHIFT(2147),
  [3832] = {.count = 1, .reusable = false}, SHIFT(2140),
  [3834] = {.count = 1, .reusable = false}, SHIFT(2148),
  [3836] = {.count = 1, .reusable = false}, SHIFT(2145),
  [3838] = {.count = 1, .reusable = true}, SHIFT(2142),
  [3840] = {.count = 1, .reusable = true}, SHIFT(2145),
  [3842] = {.count = 1, .reusable = false}, SHIFT(2143),
  [3844] = {.count = 1, .reusable = true}, SHIFT(2140),
  [3846] = {.count = 1, .reusable = true}, SHIFT(2146),
  [3848] = {.count = 1, .reusable = false}, SHIFT(2119),
  [3850] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 5),
  [3852] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 5),
  [3854] = {.count = 1, .reusable = true}, SHIFT(2162),
  [3856] = {.count = 1, .reusable = true}, SHIFT(2163),
  [3858] = {.count = 1, .reusable = true}, SHIFT(2164),
  [3860] = {.count = 1, .reusable = false}, SHIFT(2167),
  [3862] = {.count = 1, .reusable = true}, SHIFT(2167),
  [3864] = {.count = 1, .reusable = true}, SHIFT(2169),
  [3866] = {.count = 1, .reusable = true}, SHIFT(2168),
  [3868] = {.count = 1, .reusable = true}, SHIFT(2170),
  [3870] = {.count = 1, .reusable = true}, SHIFT(2175),
  [3872] = {.count = 1, .reusable = true}, SHIFT(2174),
  [3874] = {.count = 1, .reusable = true}, SHIFT(2177),
  [3876] = {.count = 1, .reusable = true}, SHIFT(2178),
  [3878] = {.count = 1, .reusable = true}, SHIFT(2180),
  [3880] = {.count = 1, .reusable = true}, SHIFT(2183),
  [3882] = {.count = 1, .reusable = true}, SHIFT(2186),
  [3884] = {.count = 1, .reusable = false}, SHIFT(2189),
  [3886] = {.count = 1, .reusable = true}, SHIFT(2190),
  [3888] = {.count = 1, .reusable = true}, SHIFT(2193),
  [3890] = {.count = 1, .reusable = false}, SHIFT(2197),
  [3892] = {.count = 1, .reusable = true}, SHIFT(2194),
  [3894] = {.count = 1, .reusable = false}, SHIFT(2215),
  [3896] = {.count = 1, .reusable = false}, SHIFT(2211),
  [3898] = {.count = 1, .reusable = false}, SHIFT(2216),
  [3900] = {.count = 1, .reusable = true}, SHIFT(2215),
  [3902] = {.count = 1, .reusable = true}, SHIFT(2199),
  [3904] = {.count = 1, .reusable = false}, SHIFT(2200),
  [3906] = {.count = 1, .reusable = true}, SHIFT(2216),
  [3908] = {.count = 1, .reusable = true}, SHIFT(2201),
  [3910] = {.count = 1, .reusable = false}, SHIFT(2202),
  [3912] = {.count = 1, .reusable = true}, SHIFT(2203),
  [3914] = {.count = 1, .reusable = false}, SHIFT(2204),
  [3916] = {.count = 1, .reusable = true}, SHIFT(2205),
  [3918] = {.count = 1, .reusable = false}, SHIFT(2201),
  [3920] = {.count = 1, .reusable = true}, SHIFT(2206),
  [3922] = {.count = 1, .reusable = true}, SHIFT(2207),
  [3924] = {.count = 1, .reusable = false}, SHIFT(2208),
  [3926] = {.count = 1, .reusable = true}, SHIFT(2198),
  [3928] = {.count = 1, .reusable = false}, SHIFT(2209),
  [3930] = {.count = 1, .reusable = false}, SHIFT(2199),
  [3932] = {.count = 1, .reusable = true}, SHIFT(2221),
  [3934] = {.count = 1, .reusable = true}, SHIFT(2224),
  [3936] = {.count = 1, .reusable = true}, SHIFT(2225),
  [3938] = {.count = 1, .reusable = true}, SHIFT(2228),
  [3940] = {.count = 1, .reusable = false}, SHIFT(2229),
  [3942] = {.count = 1, .reusable = true}, SHIFT(2231),
  [3944] = {.count = 1, .reusable = false}, SHIFT(2233),
  [3946] = {.count = 1, .reusable = true}, SHIFT(2237),
  [3948] = {.count = 1, .reusable = false}, SHIFT(2238),
  [3950] = {.count = 1, .reusable = true}, SHIFT(2242),
  [3952] = {.count = 1, .reusable = false}, SHIFT(2244),
  [3954] = {.count = 1, .reusable = true}, SHIFT(2247),
  [3956] = {.count = 1, .reusable = true}, SHIFT(2246),
  [3958] = {.count = 1, .reusable = true}, SHIFT(2250),
  [3960] = {.count = 1, .reusable = true}, SHIFT(2251),
  [3962] = {.count = 1, .reusable = true}, SHIFT(2252),
  [3964] = {.count = 1, .reusable = true}, SHIFT(2253),
  [3966] = {.count = 1, .reusable = true}, SHIFT(2254),
  [3968] = {.count = 1, .reusable = true}, SHIFT(2255),
  [3970] = {.count = 1, .reusable = true}, SHIFT(2258),
  [3972] = {.count = 1, .reusable = false}, SHIFT(2256),
  [3974] = {.count = 1, .reusable = true}, SHIFT(2257),
  [3976] = {.count = 1, .reusable = true}, SHIFT(2256),
  [3978] = {.count = 1, .reusable = true}, SHIFT(2259),
  [3980] = {.count = 1, .reusable = false}, SHIFT(2276),
  [3982] = {.count = 1, .reusable = false}, SHIFT(2274),
  [3984] = {.count = 1, .reusable = false}, SHIFT(2279),
  [3986] = {.count = 1, .reusable = true}, SHIFT(2276),
  [3988] = {.count = 1, .reusable = true}, SHIFT(2261),
  [3990] = {.count = 1, .reusable = true}, SHIFT(2262),
  [3992] = {.count = 1, .reusable = false}, SHIFT(2263),
  [3994] = {.count = 1, .reusable = true}, SHIFT(2279),
  [3996] = {.count = 1, .reusable = true}, SHIFT(2264),
  [3998] = {.count = 1, .reusable = false}, SHIFT(2265),
  [4000] = {.count = 1, .reusable = true}, SHIFT(2266),
  [4002] = {.count = 1, .reusable = false}, SHIFT(2267),
  [4004] = {.count = 1, .reusable = true}, SHIFT(2268),
  [4006] = {.count = 1, .reusable = false}, SHIFT(2264),
  [4008] = {.count = 1, .reusable = true}, SHIFT(2269),
  [4010] = {.count = 1, .reusable = true}, SHIFT(2270),
  [4012] = {.count = 1, .reusable = false}, SHIFT(2271),
  [4014] = {.count = 1, .reusable = true}, SHIFT(2260),
  [4016] = {.count = 1, .reusable = false}, SHIFT(2272),
  [4018] = {.count = 1, .reusable = false}, SHIFT(2261),
  [4020] = {.count = 1, .reusable = false}, SHIFT(2259),
  [4022] = {.count = 1, .reusable = true}, SHIFT(2285),
  [4024] = {.count = 1, .reusable = false}, SHIFT(2286),
  [4026] = {.count = 1, .reusable = true}, SHIFT(2289),
  [4028] = {.count = 1, .reusable = true}, SHIFT(2290),
  [4030] = {.count = 1, .reusable = true}, SHIFT(2287),
  [4032] = {.count = 1, .reusable = true}, SHIFT(2291),
  [4034] = {.count = 1, .reusable = true}, SHIFT(2292),
  [4036] = {.count = 1, .reusable = true}, SHIFT(2288),
  [4038] = {.count = 1, .reusable = true}, SHIFT(2293),
  [4040] = {.count = 1, .reusable = false}, SHIFT(2294),
  [4042] = {.count = 1, .reusable = false}, SHIFT(2287),
  [4044] = {.count = 1, .reusable = true}, SHIFT(2286),
  [4046] = {.count = 1, .reusable = false}, SHIFT(2292),
  [4048] = {.count = 1, .reusable = false}, SHIFT(2295),
  [4050] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4052] = {.count = 1, .reusable = true}, SHIFT(2297),
  [4054] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 6),
  [4056] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 6),
  [4058] = {.count = 1, .reusable = true}, SHIFT(2299),
  [4060] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [4062] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(94),
  [4065] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(683),
  [4068] = {.count = 1, .reusable = true}, SHIFT(2301),
  [4070] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [4072] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3),
  [4074] = {.count = 1, .reusable = true}, SHIFT(2302),
  [4076] = {.count = 1, .reusable = true}, SHIFT(2303),
  [4078] = {.count = 1, .reusable = true}, SHIFT(2306),
  [4080] = {.count = 1, .reusable = true}, SHIFT(2305),
  [4082] = {.count = 1, .reusable = true}, SHIFT(2308),
  [4084] = {.count = 1, .reusable = true}, SHIFT(2309),
  [4086] = {.count = 1, .reusable = true}, SHIFT(2311),
  [4088] = {.count = 1, .reusable = true}, SHIFT(2312),
  [4090] = {.count = 1, .reusable = true}, SHIFT(2315),
  [4092] = {.count = 1, .reusable = true}, SHIFT(2316),
  [4094] = {.count = 1, .reusable = true}, SHIFT(2320),
  [4096] = {.count = 1, .reusable = false}, SHIFT(2318),
  [4098] = {.count = 1, .reusable = true}, SHIFT(2322),
  [4100] = {.count = 1, .reusable = true}, SHIFT(707),
  [4102] = {.count = 1, .reusable = true}, SHIFT(2328),
  [4104] = {.count = 1, .reusable = true}, SHIFT(2329),
  [4106] = {.count = 1, .reusable = false}, SHIFT(717),
  [4108] = {.count = 1, .reusable = false}, SHIFT(2331),
  [4110] = {.count = 1, .reusable = true}, SHIFT(2333),
  [4112] = {.count = 1, .reusable = true}, SHIFT(2335),
  [4114] = {.count = 1, .reusable = true}, SHIFT(2340),
  [4116] = {.count = 1, .reusable = true}, SHIFT(2339),
  [4118] = {.count = 1, .reusable = true}, SHIFT(2343),
  [4120] = {.count = 1, .reusable = false}, SHIFT(2344),
  [4122] = {.count = 1, .reusable = false}, SHIFT(2345),
  [4124] = {.count = 1, .reusable = true}, SHIFT(2346),
  [4126] = {.count = 1, .reusable = true}, SHIFT(2347),
  [4128] = {.count = 1, .reusable = true}, SHIFT(2349),
  [4130] = {.count = 1, .reusable = true}, SHIFT(2348),
  [4132] = {.count = 1, .reusable = true}, SHIFT(2350),
  [4134] = {.count = 1, .reusable = true}, SHIFT(2351),
  [4136] = {.count = 1, .reusable = false}, SHIFT(2352),
  [4138] = {.count = 1, .reusable = false}, SHIFT(2348),
  [4140] = {.count = 1, .reusable = true}, SHIFT(2345),
  [4142] = {.count = 1, .reusable = false}, SHIFT(2353),
  [4144] = {.count = 1, .reusable = false}, SHIFT(2350),
  [4146] = {.count = 1, .reusable = true}, SHIFT(2353),
  [4148] = {.count = 1, .reusable = true}, SHIFT(2344),
  [4150] = {.count = 1, .reusable = false}, SHIFT(2333),
  [4152] = {.count = 1, .reusable = false}, SHIFT(2354),
  [4154] = {.count = 1, .reusable = true}, SHIFT(2355),
  [4156] = {.count = 1, .reusable = true}, SHIFT(2356),
  [4158] = {.count = 1, .reusable = true}, SHIFT(2357),
  [4160] = {.count = 1, .reusable = true}, SHIFT(2366),
  [4162] = {.count = 1, .reusable = true}, SHIFT(2368),
  [4164] = {.count = 1, .reusable = true}, SHIFT(2367),
  [4166] = {.count = 1, .reusable = true}, SHIFT(2370),
  [4168] = {.count = 1, .reusable = true}, SHIFT(2372),
  [4170] = {.count = 1, .reusable = true}, SHIFT(2376),
  [4172] = {.count = 1, .reusable = false}, SHIFT(2377),
  [4174] = {.count = 1, .reusable = false}, SHIFT(2379),
  [4176] = {.count = 1, .reusable = true}, SHIFT(2383),
  [4178] = {.count = 1, .reusable = false}, SHIFT(2384),
  [4180] = {.count = 1, .reusable = true}, SHIFT(2389),
  [4182] = {.count = 1, .reusable = true}, SHIFT(2392),
  [4184] = {.count = 1, .reusable = true}, SHIFT(2391),
  [4186] = {.count = 1, .reusable = true}, SHIFT(2394),
  [4188] = {.count = 1, .reusable = true}, SHIFT(2396),
  [4190] = {.count = 1, .reusable = true}, SHIFT(2402),
  [4192] = {.count = 1, .reusable = true}, SHIFT(2404),
  [4194] = {.count = 1, .reusable = true}, SHIFT(2406),
  [4196] = {.count = 1, .reusable = false}, SHIFT(2408),
  [4198] = {.count = 1, .reusable = true}, SHIFT(2409),
  [4200] = {.count = 1, .reusable = true}, SHIFT(2412),
  [4202] = {.count = 1, .reusable = false}, SHIFT(2416),
  [4204] = {.count = 1, .reusable = true}, SHIFT(2413),
  [4206] = {.count = 1, .reusable = true}, SHIFT(2419),
  [4208] = {.count = 1, .reusable = false}, SHIFT(2420),
  [4210] = {.count = 1, .reusable = false}, SHIFT(2421),
  [4212] = {.count = 1, .reusable = true}, SHIFT(2424),
  [4214] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [4216] = {.count = 1, .reusable = true}, SHIFT(2425),
  [4218] = {.count = 1, .reusable = true}, SHIFT(2422),
  [4220] = {.count = 1, .reusable = true}, SHIFT(2426),
  [4222] = {.count = 1, .reusable = true}, SHIFT(2427),
  [4224] = {.count = 1, .reusable = true}, SHIFT(2423),
  [4226] = {.count = 1, .reusable = true}, SHIFT(2428),
  [4228] = {.count = 1, .reusable = false}, SHIFT(2429),
  [4230] = {.count = 1, .reusable = false}, SHIFT(2422),
  [4232] = {.count = 1, .reusable = true}, SHIFT(2421),
  [4234] = {.count = 1, .reusable = false}, SHIFT(2427),
  [4236] = {.count = 1, .reusable = false}, SHIFT(2430),
  [4238] = {.count = 1, .reusable = true}, SHIFT(2430),
  [4240] = {.count = 1, .reusable = true}, SHIFT(2433),
  [4242] = {.count = 1, .reusable = false}, SHIFT(2431),
  [4244] = {.count = 1, .reusable = true}, SHIFT(2432),
  [4246] = {.count = 1, .reusable = true}, SHIFT(2431),
  [4248] = {.count = 1, .reusable = true}, SHIFT(2434),
  [4250] = {.count = 1, .reusable = false}, SHIFT(2435),
  [4252] = {.count = 1, .reusable = false}, SHIFT(2436),
  [4254] = {.count = 1, .reusable = true}, SHIFT(2437),
  [4256] = {.count = 1, .reusable = true}, SHIFT(2438),
  [4258] = {.count = 1, .reusable = true}, SHIFT(2439),
  [4260] = {.count = 1, .reusable = true}, SHIFT(2420),
  [4262] = {.count = 1, .reusable = true}, SHIFT(2448),
  [4264] = {.count = 1, .reusable = true}, SHIFT(2449),
  [4266] = {.count = 1, .reusable = true}, SHIFT(2450),
  [4268] = {.count = 1, .reusable = true}, SHIFT(2453),
  [4270] = {.count = 1, .reusable = true}, SHIFT(2454),
  [4272] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [4274] = {.count = 1, .reusable = true}, SHIFT(2456),
  [4276] = {.count = 1, .reusable = true}, SHIFT(2458),
  [4278] = {.count = 1, .reusable = true}, SHIFT(2460),
  [4280] = {.count = 1, .reusable = false}, SHIFT(2459),
  [4282] = {.count = 1, .reusable = true}, SHIFT(2461),
  [4284] = {.count = 1, .reusable = false}, SHIFT(2464),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2466),
  [4288] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [4290] = {.count = 1, .reusable = true}, SHIFT(2467),
  [4292] = {.count = 1, .reusable = true}, SHIFT(2470),
  [4294] = {.count = 1, .reusable = true}, SHIFT(2469),
  [4296] = {.count = 1, .reusable = true}, SHIFT(2472),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2473),
  [4300] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [4302] = {.count = 1, .reusable = true}, SHIFT(2475),
  [4304] = {.count = 1, .reusable = true}, SHIFT(2478),
  [4306] = {.count = 1, .reusable = true}, SHIFT(2482),
  [4308] = {.count = 1, .reusable = false}, SHIFT(2496),
  [4310] = {.count = 1, .reusable = true}, SHIFT(2496),
  [4312] = {.count = 1, .reusable = true}, SHIFT(2497),
  [4314] = {.count = 1, .reusable = true}, SHIFT(2498),
  [4316] = {.count = 1, .reusable = true}, SHIFT(2501),
  [4318] = {.count = 1, .reusable = true}, SHIFT(2503),
  [4320] = {.count = 1, .reusable = true}, SHIFT(843),
  [4322] = {.count = 1, .reusable = false}, SHIFT(823),
  [4324] = {.count = 1, .reusable = true}, SHIFT(827),
  [4326] = {.count = 1, .reusable = true}, SHIFT(2506),
  [4328] = {.count = 1, .reusable = true}, SHIFT(2511),
  [4330] = {.count = 1, .reusable = true}, SHIFT(2510),
  [4332] = {.count = 1, .reusable = true}, SHIFT(2513),
  [4334] = {.count = 1, .reusable = true}, SHIFT(2515),
  [4336] = {.count = 1, .reusable = false}, SHIFT(2520),
  [4338] = {.count = 1, .reusable = true}, SHIFT(2523),
  [4340] = {.count = 1, .reusable = true}, SHIFT(2528),
  [4342] = {.count = 1, .reusable = false}, SHIFT(2526),
  [4344] = {.count = 1, .reusable = true}, SHIFT(2530),
  [4346] = {.count = 1, .reusable = true}, SHIFT(2533),
  [4348] = {.count = 1, .reusable = false}, SHIFT(2537),
  [4350] = {.count = 1, .reusable = true}, SHIFT(2534),
  [4352] = {.count = 1, .reusable = true}, SHIFT(2540),
  [4354] = {.count = 1, .reusable = true}, SHIFT(2543),
  [4356] = {.count = 1, .reusable = true}, SHIFT(2544),
  [4358] = {.count = 1, .reusable = true}, SHIFT(2546),
  [4360] = {.count = 1, .reusable = true}, SHIFT(2550),
  [4362] = {.count = 1, .reusable = false}, SHIFT(2551),
  [4364] = {.count = 1, .reusable = true}, SHIFT(2553),
  [4366] = {.count = 1, .reusable = false}, SHIFT(2555),
  [4368] = {.count = 1, .reusable = true}, SHIFT(2559),
  [4370] = {.count = 1, .reusable = false}, SHIFT(2560),
  [4372] = {.count = 1, .reusable = true}, SHIFT(2564),
  [4374] = {.count = 1, .reusable = true}, SHIFT(2566),
  [4376] = {.count = 1, .reusable = true}, SHIFT(2570),
  [4378] = {.count = 1, .reusable = true}, SHIFT(2569),
  [4380] = {.count = 1, .reusable = true}, SHIFT(834),
  [4382] = {.count = 1, .reusable = true}, SHIFT(2574),
  [4384] = {.count = 1, .reusable = true}, SHIFT(2575),
  [4386] = {.count = 1, .reusable = true}, SHIFT(2578),
  [4388] = {.count = 1, .reusable = true}, SHIFT(2577),
  [4390] = {.count = 1, .reusable = true}, SHIFT(2581),
  [4392] = {.count = 1, .reusable = false}, SHIFT(2574),
  [4394] = {.count = 1, .reusable = false}, SHIFT(2582),
  [4396] = {.count = 1, .reusable = false}, SHIFT(2583),
  [4398] = {.count = 1, .reusable = true}, SHIFT(2584),
  [4400] = {.count = 1, .reusable = false}, SHIFT(2586),
  [4402] = {.count = 1, .reusable = true}, SHIFT(2585),
  [4404] = {.count = 1, .reusable = true}, SHIFT(2587),
  [4406] = {.count = 1, .reusable = true}, SHIFT(2583),
  [4408] = {.count = 1, .reusable = false}, SHIFT(2588),
  [4410] = {.count = 1, .reusable = false}, SHIFT(2589),
  [4412] = {.count = 1, .reusable = false}, SHIFT(2585),
  [4414] = {.count = 1, .reusable = true}, SHIFT(2582),
  [4416] = {.count = 1, .reusable = false}, SHIFT(2590),
  [4418] = {.count = 1, .reusable = false}, SHIFT(2587),
  [4420] = {.count = 1, .reusable = true}, SHIFT(2588),
  [4422] = {.count = 1, .reusable = false}, SHIFT(2533),
  [4424] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [4426] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [4428] = {.count = 1, .reusable = true}, SHIFT(2593),
  [4430] = {.count = 1, .reusable = true}, SHIFT(2594),
  [4432] = {.count = 1, .reusable = true}, SHIFT(2597),
  [4434] = {.count = 1, .reusable = true}, SHIFT(2596),
  [4436] = {.count = 1, .reusable = true}, SHIFT(2599),
  [4438] = {.count = 1, .reusable = true}, SHIFT(2600),
  [4440] = {.count = 1, .reusable = true}, SHIFT(2602),
  [4442] = {.count = 1, .reusable = true}, SHIFT(2603),
  [4444] = {.count = 1, .reusable = true}, SHIFT(2606),
  [4446] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [4448] = {.count = 1, .reusable = true}, SHIFT(2609),
  [4450] = {.count = 1, .reusable = true}, SHIFT(2608),
  [4452] = {.count = 1, .reusable = true}, SHIFT(2610),
  [4454] = {.count = 1, .reusable = true}, SHIFT(2614),
  [4456] = {.count = 1, .reusable = false}, SHIFT(2612),
  [4458] = {.count = 1, .reusable = true}, SHIFT(2616),
  [4460] = {.count = 1, .reusable = true}, SHIFT(891),
  [4462] = {.count = 1, .reusable = true}, SHIFT(2622),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2623),
  [4466] = {.count = 1, .reusable = true}, SHIFT(905),
  [4468] = {.count = 1, .reusable = false}, SHIFT(2626),
  [4470] = {.count = 1, .reusable = true}, SHIFT(2628),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2629),
  [4474] = {.count = 1, .reusable = true}, SHIFT(2635),
  [4476] = {.count = 1, .reusable = true}, SHIFT(2638),
  [4478] = {.count = 1, .reusable = false}, SHIFT(2639),
  [4480] = {.count = 1, .reusable = false}, SHIFT(2640),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2641),
  [4484] = {.count = 1, .reusable = true}, SHIFT(2642),
  [4486] = {.count = 1, .reusable = true}, SHIFT(2644),
  [4488] = {.count = 1, .reusable = true}, SHIFT(2643),
  [4490] = {.count = 1, .reusable = true}, SHIFT(2645),
  [4492] = {.count = 1, .reusable = true}, SHIFT(2647),
  [4494] = {.count = 1, .reusable = false}, SHIFT(2648),
  [4496] = {.count = 1, .reusable = false}, SHIFT(2643),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2640),
  [4500] = {.count = 1, .reusable = false}, SHIFT(2649),
  [4502] = {.count = 1, .reusable = false}, SHIFT(2645),
  [4504] = {.count = 1, .reusable = true}, SHIFT(2649),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2651),
  [4508] = {.count = 1, .reusable = false}, SHIFT(2650),
  [4510] = {.count = 1, .reusable = true}, SHIFT(2650),
  [4512] = {.count = 1, .reusable = true}, SHIFT(2639),
  [4514] = {.count = 1, .reusable = false}, SHIFT(2629),
  [4516] = {.count = 1, .reusable = true}, SHIFT(2653),
  [4518] = {.count = 1, .reusable = true}, SHIFT(2654),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2655),
  [4522] = {.count = 1, .reusable = true}, SHIFT(2658),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2659),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2661),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2663),
  [4530] = {.count = 1, .reusable = true}, SHIFT(2665),
  [4532] = {.count = 1, .reusable = false}, SHIFT(2664),
  [4534] = {.count = 1, .reusable = true}, SHIFT(2666),
  [4536] = {.count = 1, .reusable = false}, SHIFT(2669),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2671),
  [4540] = {.count = 1, .reusable = false}, SHIFT(2688),
  [4542] = {.count = 1, .reusable = false}, SHIFT(2684),
  [4544] = {.count = 1, .reusable = false}, SHIFT(2689),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2688),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2673),
  [4550] = {.count = 1, .reusable = false}, SHIFT(2674),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2689),
  [4554] = {.count = 1, .reusable = true}, SHIFT(2675),
  [4556] = {.count = 1, .reusable = false}, SHIFT(2676),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2677),
  [4560] = {.count = 1, .reusable = false}, SHIFT(2678),
  [4562] = {.count = 1, .reusable = true}, SHIFT(2679),
  [4564] = {.count = 1, .reusable = false}, SHIFT(2675),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2680),
  [4568] = {.count = 1, .reusable = false}, SHIFT(2681),
  [4570] = {.count = 1, .reusable = true}, SHIFT(2672),
  [4572] = {.count = 1, .reusable = false}, SHIFT(2682),
  [4574] = {.count = 1, .reusable = false}, SHIFT(2673),
  [4576] = {.count = 1, .reusable = true}, SHIFT(2695),
  [4578] = {.count = 1, .reusable = true}, SHIFT(2696),
  [4580] = {.count = 1, .reusable = false}, SHIFT(2697),
  [4582] = {.count = 1, .reusable = false}, SHIFT(2698),
  [4584] = {.count = 1, .reusable = true}, SHIFT(2701),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2702),
  [4588] = {.count = 1, .reusable = true}, SHIFT(2699),
  [4590] = {.count = 1, .reusable = true}, SHIFT(2703),
  [4592] = {.count = 1, .reusable = true}, SHIFT(2704),
  [4594] = {.count = 1, .reusable = true}, SHIFT(2700),
  [4596] = {.count = 1, .reusable = true}, SHIFT(2705),
  [4598] = {.count = 1, .reusable = false}, SHIFT(2706),
  [4600] = {.count = 1, .reusable = false}, SHIFT(2699),
  [4602] = {.count = 1, .reusable = true}, SHIFT(2698),
  [4604] = {.count = 1, .reusable = false}, SHIFT(2704),
  [4606] = {.count = 1, .reusable = false}, SHIFT(2707),
  [4608] = {.count = 1, .reusable = true}, SHIFT(2707),
  [4610] = {.count = 1, .reusable = true}, SHIFT(2709),
  [4612] = {.count = 1, .reusable = false}, SHIFT(2708),
  [4614] = {.count = 1, .reusable = true}, SHIFT(2708),
  [4616] = {.count = 1, .reusable = false}, SHIFT(2722),
  [4618] = {.count = 1, .reusable = false}, SHIFT(2721),
  [4620] = {.count = 1, .reusable = false}, SHIFT(2724),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2722),
  [4624] = {.count = 1, .reusable = true}, SHIFT(2711),
  [4626] = {.count = 1, .reusable = false}, SHIFT(2712),
  [4628] = {.count = 1, .reusable = true}, SHIFT(2724),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2713),
  [4632] = {.count = 1, .reusable = true}, SHIFT(2714),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2715),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2716),
  [4638] = {.count = 1, .reusable = false}, SHIFT(2713),
  [4640] = {.count = 1, .reusable = true}, SHIFT(2717),
  [4642] = {.count = 1, .reusable = false}, SHIFT(2718),
  [4644] = {.count = 1, .reusable = true}, SHIFT(2710),
  [4646] = {.count = 1, .reusable = false}, SHIFT(2719),
  [4648] = {.count = 1, .reusable = false}, SHIFT(2711),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2697),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2731),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2734),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2733),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2736),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2737),
  [4662] = {.count = 1, .reusable = false}, SHIFT(2747),
  [4664] = {.count = 1, .reusable = true}, SHIFT(2744),
  [4666] = {.count = 1, .reusable = false}, SHIFT(2746),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2741),
  [4670] = {.count = 1, .reusable = false}, SHIFT(2742),
  [4672] = {.count = 1, .reusable = false}, SHIFT(2743),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2743),
  [4676] = {.count = 1, .reusable = false}, SHIFT(2745),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2746),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2740),
  [4682] = {.count = 1, .reusable = false}, SHIFT(2764),
  [4684] = {.count = 1, .reusable = true}, SHIFT(2764),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2765),
  [4688] = {.count = 1, .reusable = true}, SHIFT(2766),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2769),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2771),
  [4694] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 2),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2772),
  [4698] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [4700] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2775),
  [4704] = {.count = 1, .reusable = false}, SHIFT(984),
  [4706] = {.count = 1, .reusable = true}, SHIFT(2778),
  [4708] = {.count = 1, .reusable = false}, SHIFT(2781),
  [4710] = {.count = 1, .reusable = true}, SHIFT(2785),
  [4712] = {.count = 1, .reusable = false}, SHIFT(2783),
  [4714] = {.count = 1, .reusable = true}, SHIFT(2787),
  [4716] = {.count = 1, .reusable = true}, SHIFT(2791),
  [4718] = {.count = 1, .reusable = true}, SHIFT(989),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2793),
  [4722] = {.count = 1, .reusable = true}, SHIFT(2794),
  [4724] = {.count = 1, .reusable = true}, SHIFT(2797),
  [4726] = {.count = 1, .reusable = false}, SHIFT(2793),
  [4728] = {.count = 1, .reusable = false}, SHIFT(2798),
  [4730] = {.count = 1, .reusable = false}, SHIFT(2799),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2800),
  [4734] = {.count = 1, .reusable = false}, SHIFT(2802),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2801),
  [4738] = {.count = 1, .reusable = true}, SHIFT(2803),
  [4740] = {.count = 1, .reusable = true}, SHIFT(2799),
  [4742] = {.count = 1, .reusable = false}, SHIFT(2804),
  [4744] = {.count = 1, .reusable = false}, SHIFT(2805),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2801),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2798),
  [4750] = {.count = 1, .reusable = false}, SHIFT(2806),
  [4752] = {.count = 1, .reusable = false}, SHIFT(2803),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2804),
  [4756] = {.count = 1, .reusable = false}, SHIFT(2787),
  [4758] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2809),
  [4762] = {.count = 1, .reusable = false}, SHIFT(2810),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2812),
  [4766] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .alias_sequence_id = 7),
  [4768] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .alias_sequence_id = 7),
  [4770] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(201),
  [4773] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(1014),
  [4776] = {.count = 1, .reusable = false}, SHIFT(2813),
  [4778] = {.count = 1, .reusable = true}, SHIFT(2814),
  [4780] = {.count = 1, .reusable = false}, SHIFT(2825),
  [4782] = {.count = 1, .reusable = false}, SHIFT(2822),
  [4784] = {.count = 1, .reusable = true}, SHIFT(2818),
  [4786] = {.count = 1, .reusable = false}, SHIFT(2820),
  [4788] = {.count = 1, .reusable = false}, SHIFT(2826),
  [4790] = {.count = 1, .reusable = false}, SHIFT(2816),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2825),
  [4794] = {.count = 1, .reusable = false}, SHIFT(2817),
  [4796] = {.count = 1, .reusable = true}, SHIFT(2826),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2817),
  [4800] = {.count = 1, .reusable = false}, SHIFT(2819),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2820),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2821),
  [4806] = {.count = 1, .reusable = false}, SHIFT(2815),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2829),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2833),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2834),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2646),
  [4816] = {.count = 1, .reusable = false}, SHIFT(2814),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2838),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2837),
  [4822] = {.count = 1, .reusable = true}, SHIFT(2840),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2841),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2843),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2844),
  [4830] = {.count = 1, .reusable = true}, SHIFT(2845),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2848),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2849),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2850),
  [4838] = {.count = 1, .reusable = true}, SHIFT(2851),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2854),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2857),
  [4844] = {.count = 1, .reusable = false}, SHIFT(2856),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2858),
  [4848] = {.count = 1, .reusable = false}, SHIFT(2861),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2863),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2865),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2864),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2867),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2868),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2870),
  [4862] = {.count = 1, .reusable = true}, SHIFT(2871),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2873),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2874),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2876),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2879),
  [4872] = {.count = 1, .reusable = false}, SHIFT(2877),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2881),
  [4876] = {.count = 1, .reusable = true}, SHIFT(1067),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2886),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2887),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2888),
  [4884] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2890),
  [4888] = {.count = 1, .reusable = false}, SHIFT(2892),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2892),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2893),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2894),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2897),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2899),
  [4900] = {.count = 1, .reusable = true}, SHIFT(1088),
  [4902] = {.count = 1, .reusable = true}, SHIFT(2902),
  [4904] = {.count = 1, .reusable = false}, SHIFT(2903),
  [4906] = {.count = 1, .reusable = true}, SHIFT(2905),
  [4908] = {.count = 1, .reusable = true}, SHIFT(2906),
  [4910] = {.count = 1, .reusable = false}, SHIFT(2907),
  [4912] = {.count = 1, .reusable = true}, SHIFT(2908),
  [4914] = {.count = 1, .reusable = true}, SHIFT(2909),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2910),
  [4918] = {.count = 1, .reusable = false}, SHIFT(1084),
  [4920] = {.count = 1, .reusable = false}, SHIFT(2926),
  [4922] = {.count = 1, .reusable = false}, SHIFT(2923),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2919),
  [4926] = {.count = 1, .reusable = false}, SHIFT(2921),
  [4928] = {.count = 1, .reusable = false}, SHIFT(2927),
  [4930] = {.count = 1, .reusable = false}, SHIFT(2917),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2926),
  [4934] = {.count = 1, .reusable = false}, SHIFT(2918),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2927),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2918),
  [4940] = {.count = 1, .reusable = false}, SHIFT(2920),
  [4942] = {.count = 1, .reusable = true}, SHIFT(2921),
  [4944] = {.count = 1, .reusable = true}, SHIFT(2922),
  [4946] = {.count = 1, .reusable = false}, SHIFT(2916),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2933),
  [4950] = {.count = 1, .reusable = false}, SHIFT(2932),
  [4952] = {.count = 1, .reusable = true}, SHIFT(2932),
  [4954] = {.count = 1, .reusable = true}, SHIFT(2935),
  [4956] = {.count = 1, .reusable = false}, SHIFT(2948),
  [4958] = {.count = 1, .reusable = false}, SHIFT(2947),
  [4960] = {.count = 1, .reusable = true}, SHIFT(2948),
  [4962] = {.count = 1, .reusable = true}, SHIFT(2937),
  [4964] = {.count = 1, .reusable = false}, SHIFT(2938),
  [4966] = {.count = 1, .reusable = true}, SHIFT(2939),
  [4968] = {.count = 1, .reusable = true}, SHIFT(2940),
  [4970] = {.count = 1, .reusable = false}, SHIFT(2941),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2942),
  [4974] = {.count = 1, .reusable = false}, SHIFT(2939),
  [4976] = {.count = 1, .reusable = true}, SHIFT(2943),
  [4978] = {.count = 1, .reusable = false}, SHIFT(2944),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2936),
  [4982] = {.count = 1, .reusable = false}, SHIFT(2945),
  [4984] = {.count = 1, .reusable = false}, SHIFT(2937),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2955),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2958),
  [4990] = {.count = 1, .reusable = false}, SHIFT(2935),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2959),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2960),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2961),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2962),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2963),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2964),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2965),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2966),
  [5008] = {.count = 1, .reusable = false}, SHIFT(2967),
  [5010] = {.count = 1, .reusable = false}, SHIFT(2962),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2959),
  [5014] = {.count = 1, .reusable = false}, SHIFT(2964),
  [5016] = {.count = 1, .reusable = false}, SHIFT(2968),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2968),
  [5020] = {.count = 1, .reusable = false}, SHIFT(2906),
  [5022] = {.count = 1, .reusable = true}, SHIFT(2972),
  [5024] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2973),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2976),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2975),
  [5032] = {.count = 1, .reusable = true}, SHIFT(2978),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2979),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2980),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2981),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2982),
  [5042] = {.count = 1, .reusable = false}, SHIFT(3000),
  [5044] = {.count = 1, .reusable = false}, SHIFT(2996),
  [5046] = {.count = 1, .reusable = false}, SHIFT(3001),
  [5048] = {.count = 1, .reusable = true}, SHIFT(3000),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2985),
  [5052] = {.count = 1, .reusable = false}, SHIFT(2986),
  [5054] = {.count = 1, .reusable = true}, SHIFT(3001),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2987),
  [5058] = {.count = 1, .reusable = false}, SHIFT(2988),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2989),
  [5062] = {.count = 1, .reusable = false}, SHIFT(2990),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2991),
  [5066] = {.count = 1, .reusable = false}, SHIFT(2987),
  [5068] = {.count = 1, .reusable = true}, SHIFT(2992),
  [5070] = {.count = 1, .reusable = false}, SHIFT(2993),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2984),
  [5074] = {.count = 1, .reusable = false}, SHIFT(2994),
  [5076] = {.count = 1, .reusable = false}, SHIFT(2985),
  [5078] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [5080] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [5082] = {.count = 1, .reusable = true}, SHIFT(3010),
  [5084] = {.count = 1, .reusable = true}, SHIFT(3005),
  [5086] = {.count = 1, .reusable = true}, SHIFT(3006),
  [5088] = {.count = 1, .reusable = true}, SHIFT(3007),
  [5090] = {.count = 1, .reusable = true}, SHIFT(3008),
  [5092] = {.count = 1, .reusable = true}, SHIFT(3009),
  [5094] = {.count = 1, .reusable = true}, SHIFT(3012),
  [5096] = {.count = 1, .reusable = false}, SHIFT(3011),
  [5098] = {.count = 1, .reusable = true}, SHIFT(3015),
  [5100] = {.count = 1, .reusable = false}, SHIFT(3014),
  [5102] = {.count = 1, .reusable = true}, SHIFT(3014),
  [5104] = {.count = 1, .reusable = true}, SHIFT(3016),
  [5106] = {.count = 1, .reusable = false}, SHIFT(3030),
  [5108] = {.count = 1, .reusable = false}, SHIFT(3029),
  [5110] = {.count = 1, .reusable = false}, SHIFT(3032),
  [5112] = {.count = 1, .reusable = true}, SHIFT(3030),
  [5114] = {.count = 1, .reusable = true}, SHIFT(3019),
  [5116] = {.count = 1, .reusable = false}, SHIFT(3020),
  [5118] = {.count = 1, .reusable = true}, SHIFT(3032),
  [5120] = {.count = 1, .reusable = true}, SHIFT(3021),
  [5122] = {.count = 1, .reusable = true}, SHIFT(3022),
  [5124] = {.count = 1, .reusable = false}, SHIFT(3023),
  [5126] = {.count = 1, .reusable = true}, SHIFT(3024),
  [5128] = {.count = 1, .reusable = false}, SHIFT(3021),
  [5130] = {.count = 1, .reusable = true}, SHIFT(3025),
  [5132] = {.count = 1, .reusable = false}, SHIFT(3026),
  [5134] = {.count = 1, .reusable = true}, SHIFT(3018),
  [5136] = {.count = 1, .reusable = false}, SHIFT(3027),
  [5138] = {.count = 1, .reusable = false}, SHIFT(3019),
  [5140] = {.count = 1, .reusable = true}, SHIFT(3038),
  [5142] = {.count = 1, .reusable = false}, SHIFT(3016),
  [5144] = {.count = 1, .reusable = false}, SHIFT(3039),
  [5146] = {.count = 1, .reusable = true}, SHIFT(3042),
  [5148] = {.count = 1, .reusable = true}, SHIFT(3043),
  [5150] = {.count = 1, .reusable = true}, SHIFT(3040),
  [5152] = {.count = 1, .reusable = true}, SHIFT(3044),
  [5154] = {.count = 1, .reusable = true}, SHIFT(3045),
  [5156] = {.count = 1, .reusable = true}, SHIFT(3041),
  [5158] = {.count = 1, .reusable = true}, SHIFT(3046),
  [5160] = {.count = 1, .reusable = false}, SHIFT(3047),
  [5162] = {.count = 1, .reusable = false}, SHIFT(3040),
  [5164] = {.count = 1, .reusable = true}, SHIFT(3039),
  [5166] = {.count = 1, .reusable = false}, SHIFT(3045),
  [5168] = {.count = 1, .reusable = false}, SHIFT(3048),
  [5170] = {.count = 1, .reusable = true}, SHIFT(3048),
  [5172] = {.count = 1, .reusable = true}, SHIFT(3011),
  [5174] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2),
  [5176] = {.count = 1, .reusable = false}, SHIFT(3062),
  [5178] = {.count = 1, .reusable = false}, SHIFT(3059),
  [5180] = {.count = 1, .reusable = true}, SHIFT(3055),
  [5182] = {.count = 1, .reusable = false}, SHIFT(3057),
  [5184] = {.count = 1, .reusable = false}, SHIFT(3063),
  [5186] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2),
  [5188] = {.count = 1, .reusable = false}, SHIFT(3053),
  [5190] = {.count = 1, .reusable = true}, SHIFT(3062),
  [5192] = {.count = 1, .reusable = false}, SHIFT(3054),
  [5194] = {.count = 1, .reusable = true}, SHIFT(3063),
  [5196] = {.count = 1, .reusable = true}, SHIFT(3054),
  [5198] = {.count = 1, .reusable = false}, SHIFT(3056),
  [5200] = {.count = 1, .reusable = true}, SHIFT(3057),
  [5202] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2),
  [5204] = {.count = 1, .reusable = true}, SHIFT(3058),
  [5206] = {.count = 1, .reusable = false}, SHIFT(3052),
  [5208] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2),
  [5210] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [5212] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [5214] = {.count = 1, .reusable = true}, SHIFT(3067),
  [5216] = {.count = 1, .reusable = true}, SHIFT(3068),
  [5218] = {.count = 1, .reusable = true}, SHIFT(3069),
  [5220] = {.count = 1, .reusable = true}, SHIFT(3071),
  [5222] = {.count = 1, .reusable = true}, SHIFT(1110),
  [5224] = {.count = 1, .reusable = true}, SHIFT(1134),
  [5226] = {.count = 1, .reusable = true}, SHIFT(3073),
  [5228] = {.count = 1, .reusable = true}, SHIFT(3074),
  [5230] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 2),
  [5232] = {.count = 1, .reusable = true}, SHIFT(3076),
  [5234] = {.count = 1, .reusable = true}, SHIFT(3077),
  [5236] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3),
  [5238] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [5240] = {.count = 1, .reusable = true}, SHIFT(244),
  [5242] = {.count = 1, .reusable = true}, SHIFT(3081),
  [5244] = {.count = 1, .reusable = true}, SHIFT(3083),
  [5246] = {.count = 1, .reusable = false}, SHIFT(3084),
  [5248] = {.count = 1, .reusable = true}, SHIFT(3085),
  [5250] = {.count = 1, .reusable = false}, SHIFT(1236),
  [5252] = {.count = 1, .reusable = true}, SHIFT(3086),
  [5254] = {.count = 1, .reusable = true}, SHIFT(3087),
  [5256] = {.count = 1, .reusable = false}, SHIFT(3085),
  [5258] = {.count = 1, .reusable = true}, SHIFT(3088),
  [5260] = {.count = 1, .reusable = true}, SHIFT(3082),
  [5262] = {.count = 1, .reusable = false}, SHIFT(3083),
  [5264] = {.count = 1, .reusable = true}, SHIFT(3098),
  [5266] = {.count = 1, .reusable = true}, SHIFT(3099),
  [5268] = {.count = 1, .reusable = false}, SHIFT(3100),
  [5270] = {.count = 1, .reusable = false}, SHIFT(3101),
  [5272] = {.count = 1, .reusable = true}, SHIFT(3102),
  [5274] = {.count = 1, .reusable = true}, SHIFT(3103),
  [5276] = {.count = 1, .reusable = true}, SHIFT(3104),
  [5278] = {.count = 1, .reusable = true}, SHIFT(3108),
  [5280] = {.count = 1, .reusable = true}, SHIFT(3105),
  [5282] = {.count = 1, .reusable = true}, SHIFT(3107),
  [5284] = {.count = 1, .reusable = true}, SHIFT(3106),
  [5286] = {.count = 1, .reusable = true}, SHIFT(3109),
  [5288] = {.count = 1, .reusable = false}, SHIFT(3110),
  [5290] = {.count = 1, .reusable = false}, SHIFT(3104),
  [5292] = {.count = 1, .reusable = true}, SHIFT(3101),
  [5294] = {.count = 1, .reusable = false}, SHIFT(3106),
  [5296] = {.count = 1, .reusable = false}, SHIFT(3111),
  [5298] = {.count = 1, .reusable = true}, SHIFT(3111),
  [5300] = {.count = 1, .reusable = true}, SHIFT(3113),
  [5302] = {.count = 1, .reusable = false}, SHIFT(3112),
  [5304] = {.count = 1, .reusable = true}, SHIFT(3112),
  [5306] = {.count = 1, .reusable = false}, SHIFT(3126),
  [5308] = {.count = 1, .reusable = false}, SHIFT(3125),
  [5310] = {.count = 1, .reusable = false}, SHIFT(3128),
  [5312] = {.count = 1, .reusable = true}, SHIFT(3126),
  [5314] = {.count = 1, .reusable = true}, SHIFT(3115),
  [5316] = {.count = 1, .reusable = false}, SHIFT(3116),
  [5318] = {.count = 1, .reusable = true}, SHIFT(3128),
  [5320] = {.count = 1, .reusable = true}, SHIFT(3117),
  [5322] = {.count = 1, .reusable = true}, SHIFT(3118),
  [5324] = {.count = 1, .reusable = false}, SHIFT(3119),
  [5326] = {.count = 1, .reusable = true}, SHIFT(3120),
  [5328] = {.count = 1, .reusable = false}, SHIFT(3117),
  [5330] = {.count = 1, .reusable = true}, SHIFT(3121),
  [5332] = {.count = 1, .reusable = false}, SHIFT(3122),
  [5334] = {.count = 1, .reusable = true}, SHIFT(3114),
  [5336] = {.count = 1, .reusable = false}, SHIFT(3123),
  [5338] = {.count = 1, .reusable = false}, SHIFT(3115),
  [5340] = {.count = 1, .reusable = true}, SHIFT(3100),
  [5342] = {.count = 1, .reusable = true}, SHIFT(3135),
  [5344] = {.count = 1, .reusable = true}, SHIFT(3136),
  [5346] = {.count = 1, .reusable = true}, SHIFT(3137),
  [5348] = {.count = 1, .reusable = true}, SHIFT(3138),
  [5350] = {.count = 1, .reusable = true}, SHIFT(3139),
  [5352] = {.count = 1, .reusable = true}, SHIFT(3140),
  [5354] = {.count = 1, .reusable = true}, SHIFT(3141),
  [5356] = {.count = 1, .reusable = false}, SHIFT(3143),
  [5358] = {.count = 1, .reusable = true}, SHIFT(3145),
  [5360] = {.count = 1, .reusable = true}, SHIFT(3144),
  [5362] = {.count = 1, .reusable = true}, SHIFT(258),
  [5364] = {.count = 1, .reusable = true}, SHIFT(3146),
  [5366] = {.count = 1, .reusable = true}, SHIFT(3148),
  [5368] = {.count = 1, .reusable = true}, SHIFT(3149),
  [5370] = {.count = 1, .reusable = true}, SHIFT(3152),
  [5372] = {.count = 1, .reusable = true}, SHIFT(3151),
  [5374] = {.count = 1, .reusable = true}, SHIFT(3154),
  [5376] = {.count = 1, .reusable = true}, SHIFT(3155),
  [5378] = {.count = 1, .reusable = true}, SHIFT(3157),
  [5380] = {.count = 1, .reusable = true}, SHIFT(3158),
  [5382] = {.count = 1, .reusable = true}, SHIFT(3161),
  [5384] = {.count = 1, .reusable = true}, SHIFT(3162),
  [5386] = {.count = 1, .reusable = true}, SHIFT(3166),
  [5388] = {.count = 1, .reusable = false}, SHIFT(3164),
  [5390] = {.count = 1, .reusable = true}, SHIFT(3168),
  [5392] = {.count = 1, .reusable = true}, SHIFT(1195),
  [5394] = {.count = 1, .reusable = true}, SHIFT(3174),
  [5396] = {.count = 1, .reusable = true}, SHIFT(3175),
  [5398] = {.count = 1, .reusable = false}, SHIFT(3176),
  [5400] = {.count = 1, .reusable = true}, SHIFT(3177),
  [5402] = {.count = 1, .reusable = true}, SHIFT(3179),
  [5404] = {.count = 1, .reusable = true}, SHIFT(3184),
  [5406] = {.count = 1, .reusable = true}, SHIFT(3183),
  [5408] = {.count = 1, .reusable = false}, SHIFT(3177),
  [5410] = {.count = 1, .reusable = true}, SHIFT(3191),
  [5412] = {.count = 1, .reusable = false}, SHIFT(3192),
  [5414] = {.count = 1, .reusable = false}, SHIFT(3193),
  [5416] = {.count = 1, .reusable = true}, SHIFT(3195),
  [5418] = {.count = 1, .reusable = true}, SHIFT(3196),
  [5420] = {.count = 1, .reusable = true}, SHIFT(3197),
  [5422] = {.count = 1, .reusable = true}, SHIFT(3198),
  [5424] = {.count = 1, .reusable = true}, SHIFT(3194),
  [5426] = {.count = 1, .reusable = false}, SHIFT(3200),
  [5428] = {.count = 1, .reusable = true}, SHIFT(3199),
  [5430] = {.count = 1, .reusable = false}, REDUCE(sym_block_argument, 2),
  [5432] = {.count = 1, .reusable = false}, SHIFT(3194),
  [5434] = {.count = 1, .reusable = true}, SHIFT(3193),
  [5436] = {.count = 1, .reusable = false}, SHIFT(3201),
  [5438] = {.count = 1, .reusable = false}, SHIFT(3198),
  [5440] = {.count = 1, .reusable = true}, SHIFT(3201),
  [5442] = {.count = 1, .reusable = true}, SHIFT(3192),
  [5444] = {.count = 1, .reusable = true}, SHIFT(3203),
  [5446] = {.count = 1, .reusable = true}, SHIFT(3204),
  [5448] = {.count = 1, .reusable = true}, SHIFT(3205),
  [5450] = {.count = 1, .reusable = true}, SHIFT(3208),
  [5452] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 2),
  [5454] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 2),
  [5456] = {.count = 1, .reusable = false}, SHIFT(3211),
  [5458] = {.count = 1, .reusable = true}, SHIFT(3213),
  [5460] = {.count = 1, .reusable = true}, SHIFT(3214),
  [5462] = {.count = 1, .reusable = false}, SHIFT(3215),
  [5464] = {.count = 1, .reusable = true}, SHIFT(3216),
  [5466] = {.count = 1, .reusable = true}, SHIFT(3217),
  [5468] = {.count = 1, .reusable = true}, SHIFT(3218),
  [5470] = {.count = 1, .reusable = false}, SHIFT(3234),
  [5472] = {.count = 1, .reusable = false}, SHIFT(3231),
  [5474] = {.count = 1, .reusable = true}, SHIFT(3227),
  [5476] = {.count = 1, .reusable = false}, SHIFT(3229),
  [5478] = {.count = 1, .reusable = false}, SHIFT(3235),
  [5480] = {.count = 1, .reusable = false}, SHIFT(3225),
  [5482] = {.count = 1, .reusable = true}, SHIFT(3234),
  [5484] = {.count = 1, .reusable = false}, SHIFT(3226),
  [5486] = {.count = 1, .reusable = true}, SHIFT(3235),
  [5488] = {.count = 1, .reusable = true}, SHIFT(3226),
  [5490] = {.count = 1, .reusable = false}, SHIFT(3228),
  [5492] = {.count = 1, .reusable = true}, SHIFT(3229),
  [5494] = {.count = 1, .reusable = true}, SHIFT(3230),
  [5496] = {.count = 1, .reusable = false}, SHIFT(3224),
  [5498] = {.count = 1, .reusable = true}, SHIFT(3240),
  [5500] = {.count = 1, .reusable = true}, SHIFT(3242),
  [5502] = {.count = 1, .reusable = false}, SHIFT(3243),
  [5504] = {.count = 1, .reusable = false}, SHIFT(3244),
  [5506] = {.count = 1, .reusable = true}, SHIFT(3245),
  [5508] = {.count = 1, .reusable = true}, SHIFT(3246),
  [5510] = {.count = 1, .reusable = true}, SHIFT(3247),
  [5512] = {.count = 1, .reusable = true}, SHIFT(3249),
  [5514] = {.count = 1, .reusable = true}, SHIFT(3248),
  [5516] = {.count = 1, .reusable = true}, SHIFT(3250),
  [5518] = {.count = 1, .reusable = true}, SHIFT(3251),
  [5520] = {.count = 1, .reusable = false}, SHIFT(3252),
  [5522] = {.count = 1, .reusable = false}, SHIFT(3247),
  [5524] = {.count = 1, .reusable = true}, SHIFT(3244),
  [5526] = {.count = 1, .reusable = false}, SHIFT(3249),
  [5528] = {.count = 1, .reusable = false}, SHIFT(3253),
  [5530] = {.count = 1, .reusable = true}, SHIFT(3253),
  [5532] = {.count = 1, .reusable = true}, SHIFT(3255),
  [5534] = {.count = 1, .reusable = false}, SHIFT(3254),
  [5536] = {.count = 1, .reusable = true}, SHIFT(3254),
  [5538] = {.count = 1, .reusable = false}, SHIFT(3256),
  [5540] = {.count = 1, .reusable = true}, SHIFT(3257),
  [5542] = {.count = 1, .reusable = true}, SHIFT(3258),
  [5544] = {.count = 1, .reusable = true}, SHIFT(3259),
  [5546] = {.count = 1, .reusable = true}, SHIFT(3243),
  [5548] = {.count = 1, .reusable = false}, SHIFT(3214),
  [5550] = {.count = 1, .reusable = true}, SHIFT(3266),
  [5552] = {.count = 1, .reusable = true}, SHIFT(3267),
  [5554] = {.count = 1, .reusable = false}, REDUCE(sym_splat_argument, 2),
  [5556] = {.count = 1, .reusable = true}, SHIFT(3269),
  [5558] = {.count = 1, .reusable = true}, SHIFT(3271),
  [5560] = {.count = 1, .reusable = true}, SHIFT(3273),
  [5562] = {.count = 1, .reusable = false}, SHIFT(3272),
  [5564] = {.count = 1, .reusable = true}, SHIFT(3274),
  [5566] = {.count = 1, .reusable = false}, SHIFT(3277),
  [5568] = {.count = 1, .reusable = true}, SHIFT(3279),
  [5570] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_argument, 2),
  [5572] = {.count = 1, .reusable = true}, SHIFT(3280),
  [5574] = {.count = 1, .reusable = true}, SHIFT(3283),
  [5576] = {.count = 1, .reusable = true}, SHIFT(3282),
  [5578] = {.count = 1, .reusable = true}, SHIFT(3285),
  [5580] = {.count = 1, .reusable = true}, SHIFT(3286),
  [5582] = {.count = 1, .reusable = true}, SHIFT(3289),
  [5584] = {.count = 1, .reusable = true}, SHIFT(3288),
  [5586] = {.count = 1, .reusable = true}, SHIFT(3290),
  [5588] = {.count = 1, .reusable = true}, SHIFT(296),
  [5590] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [5592] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [5594] = {.count = 1, .reusable = false}, SHIFT(3310),
  [5596] = {.count = 1, .reusable = true}, SHIFT(3310),
  [5598] = {.count = 1, .reusable = true}, SHIFT(3311),
  [5600] = {.count = 1, .reusable = true}, SHIFT(3312),
  [5602] = {.count = 1, .reusable = true}, SHIFT(3315),
  [5604] = {.count = 1, .reusable = true}, SHIFT(3317),
  [5606] = {.count = 1, .reusable = true}, SHIFT(3318),
  [5608] = {.count = 1, .reusable = false}, SHIFT(3321),
  [5610] = {.count = 1, .reusable = true}, SHIFT(3324),
  [5612] = {.count = 1, .reusable = false}, SHIFT(3322),
  [5614] = {.count = 1, .reusable = true}, SHIFT(3326),
  [5616] = {.count = 1, .reusable = true}, SHIFT(3328),
  [5618] = {.count = 1, .reusable = true}, SHIFT(1300),
  [5620] = {.count = 1, .reusable = true}, SHIFT(3333),
  [5622] = {.count = 1, .reusable = true}, SHIFT(3334),
  [5624] = {.count = 1, .reusable = false}, SHIFT(3326),
  [5626] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .alias_sequence_id = 7),
  [5628] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .alias_sequence_id = 7),
  [5630] = {.count = 1, .reusable = false}, SHIFT(1314),
  [5632] = {.count = 1, .reusable = false}, SHIFT(3340),
  [5634] = {.count = 1, .reusable = true}, SHIFT(3342),
  [5636] = {.count = 1, .reusable = false}, SHIFT(3343),
  [5638] = {.count = 1, .reusable = true}, SHIFT(3344),
  [5640] = {.count = 1, .reusable = true}, SHIFT(3345),
  [5642] = {.count = 1, .reusable = true}, SHIFT(3346),
  [5644] = {.count = 1, .reusable = false}, SHIFT(3358),
  [5646] = {.count = 1, .reusable = true}, SHIFT(3355),
  [5648] = {.count = 1, .reusable = false}, SHIFT(3357),
  [5650] = {.count = 1, .reusable = false}, SHIFT(3353),
  [5652] = {.count = 1, .reusable = false}, SHIFT(3354),
  [5654] = {.count = 1, .reusable = true}, SHIFT(3354),
  [5656] = {.count = 1, .reusable = false}, SHIFT(3356),
  [5658] = {.count = 1, .reusable = true}, SHIFT(3357),
  [5660] = {.count = 1, .reusable = false}, SHIFT(3352),
  [5662] = {.count = 1, .reusable = true}, SHIFT(3365),
  [5664] = {.count = 1, .reusable = true}, SHIFT(3368),
  [5666] = {.count = 1, .reusable = false}, SHIFT(3369),
  [5668] = {.count = 1, .reusable = false}, SHIFT(3370),
  [5670] = {.count = 1, .reusable = true}, SHIFT(3371),
  [5672] = {.count = 1, .reusable = true}, SHIFT(3372),
  [5674] = {.count = 1, .reusable = true}, SHIFT(3374),
  [5676] = {.count = 1, .reusable = true}, SHIFT(3375),
  [5678] = {.count = 1, .reusable = true}, SHIFT(3373),
  [5680] = {.count = 1, .reusable = true}, SHIFT(3376),
  [5682] = {.count = 1, .reusable = false}, SHIFT(3377),
  [5684] = {.count = 1, .reusable = false}, SHIFT(3373),
  [5686] = {.count = 1, .reusable = true}, SHIFT(3370),
  [5688] = {.count = 1, .reusable = false}, SHIFT(3378),
  [5690] = {.count = 1, .reusable = false}, SHIFT(3375),
  [5692] = {.count = 1, .reusable = true}, SHIFT(3378),
  [5694] = {.count = 1, .reusable = true}, SHIFT(3369),
  [5696] = {.count = 1, .reusable = false}, SHIFT(3342),
  [5698] = {.count = 1, .reusable = true}, SHIFT(3383),
  [5700] = {.count = 1, .reusable = false}, SHIFT(3384),
  [5702] = {.count = 1, .reusable = true}, SHIFT(3381),
  [5704] = {.count = 1, .reusable = false}, SHIFT(3382),
  [5706] = {.count = 1, .reusable = true}, SHIFT(3382),
  [5708] = {.count = 1, .reusable = true}, SHIFT(3384),
  [5710] = {.count = 1, .reusable = true}, SHIFT(3399),
  [5712] = {.count = 1, .reusable = true}, SHIFT(3402),
  [5714] = {.count = 1, .reusable = false}, SHIFT(3415),
  [5716] = {.count = 1, .reusable = false}, SHIFT(3412),
  [5718] = {.count = 1, .reusable = true}, SHIFT(3408),
  [5720] = {.count = 1, .reusable = false}, SHIFT(3410),
  [5722] = {.count = 1, .reusable = false}, SHIFT(3418),
  [5724] = {.count = 1, .reusable = true}, SHIFT(3405),
  [5726] = {.count = 1, .reusable = false}, SHIFT(3406),
  [5728] = {.count = 1, .reusable = true}, SHIFT(3415),
  [5730] = {.count = 1, .reusable = false}, SHIFT(3407),
  [5732] = {.count = 1, .reusable = true}, SHIFT(3418),
  [5734] = {.count = 1, .reusable = true}, SHIFT(3407),
  [5736] = {.count = 1, .reusable = false}, SHIFT(3409),
  [5738] = {.count = 1, .reusable = true}, SHIFT(3410),
  [5740] = {.count = 1, .reusable = true}, SHIFT(3411),
  [5742] = {.count = 1, .reusable = false}, SHIFT(3404),
  [5744] = {.count = 1, .reusable = false}, REDUCE(sym_case, 3),
  [5746] = {.count = 1, .reusable = true}, REDUCE(sym_case, 3),
  [5748] = {.count = 1, .reusable = true}, SHIFT(3421),
  [5750] = {.count = 1, .reusable = true}, SHIFT(3423),
  [5752] = {.count = 1, .reusable = false}, SHIFT(1360),
  [5754] = {.count = 1, .reusable = true}, SHIFT(1364),
  [5756] = {.count = 1, .reusable = false}, SHIFT(3427),
  [5758] = {.count = 1, .reusable = true}, SHIFT(3429),
  [5760] = {.count = 1, .reusable = true}, SHIFT(3430),
  [5762] = {.count = 1, .reusable = false}, SHIFT(3431),
  [5764] = {.count = 1, .reusable = true}, SHIFT(3432),
  [5766] = {.count = 1, .reusable = true}, SHIFT(3433),
  [5768] = {.count = 1, .reusable = true}, SHIFT(3434),
  [5770] = {.count = 1, .reusable = false}, SHIFT(3446),
  [5772] = {.count = 1, .reusable = true}, SHIFT(3443),
  [5774] = {.count = 1, .reusable = false}, SHIFT(3445),
  [5776] = {.count = 1, .reusable = false}, SHIFT(3441),
  [5778] = {.count = 1, .reusable = false}, SHIFT(3442),
  [5780] = {.count = 1, .reusable = true}, SHIFT(3442),
  [5782] = {.count = 1, .reusable = false}, SHIFT(3444),
  [5784] = {.count = 1, .reusable = true}, SHIFT(3445),
  [5786] = {.count = 1, .reusable = false}, SHIFT(3440),
  [5788] = {.count = 1, .reusable = true}, SHIFT(3453),
  [5790] = {.count = 1, .reusable = true}, SHIFT(3456),
  [5792] = {.count = 1, .reusable = false}, SHIFT(3457),
  [5794] = {.count = 1, .reusable = false}, SHIFT(3458),
  [5796] = {.count = 1, .reusable = true}, SHIFT(3459),
  [5798] = {.count = 1, .reusable = true}, SHIFT(3460),
  [5800] = {.count = 1, .reusable = true}, SHIFT(3463),
  [5802] = {.count = 1, .reusable = true}, SHIFT(3462),
  [5804] = {.count = 1, .reusable = true}, SHIFT(3461),
  [5806] = {.count = 1, .reusable = false}, SHIFT(3465),
  [5808] = {.count = 1, .reusable = true}, SHIFT(3464),
  [5810] = {.count = 1, .reusable = false}, SHIFT(3461),
  [5812] = {.count = 1, .reusable = true}, SHIFT(3458),
  [5814] = {.count = 1, .reusable = false}, SHIFT(3466),
  [5816] = {.count = 1, .reusable = false}, SHIFT(3463),
  [5818] = {.count = 1, .reusable = true}, SHIFT(3466),
  [5820] = {.count = 1, .reusable = true}, SHIFT(3468),
  [5822] = {.count = 1, .reusable = false}, SHIFT(3467),
  [5824] = {.count = 1, .reusable = true}, SHIFT(3467),
  [5826] = {.count = 1, .reusable = false}, SHIFT(3469),
  [5828] = {.count = 1, .reusable = true}, SHIFT(3470),
  [5830] = {.count = 1, .reusable = true}, SHIFT(3471),
  [5832] = {.count = 1, .reusable = true}, SHIFT(3472),
  [5834] = {.count = 1, .reusable = true}, SHIFT(3457),
  [5836] = {.count = 1, .reusable = false}, SHIFT(3430),
  [5838] = {.count = 1, .reusable = true}, SHIFT(3479),
  [5840] = {.count = 1, .reusable = true}, SHIFT(3480),
  [5842] = {.count = 1, .reusable = true}, SHIFT(3481),
  [5844] = {.count = 1, .reusable = false}, SHIFT(3482),
  [5846] = {.count = 1, .reusable = true}, SHIFT(3483),
  [5848] = {.count = 1, .reusable = false}, SHIFT(3484),
  [5850] = {.count = 1, .reusable = true}, SHIFT(3485),
  [5852] = {.count = 1, .reusable = true}, SHIFT(3486),
  [5854] = {.count = 1, .reusable = false}, SHIFT(3487),
  [5856] = {.count = 1, .reusable = false}, SHIFT(3485),
  [5858] = {.count = 1, .reusable = true}, SHIFT(3488),
  [5860] = {.count = 1, .reusable = true}, SHIFT(3489),
  [5862] = {.count = 1, .reusable = false}, SHIFT(3490),
  [5864] = {.count = 1, .reusable = true}, SHIFT(3482),
  [5866] = {.count = 1, .reusable = false}, SHIFT(3491),
  [5868] = {.count = 1, .reusable = true}, SHIFT(3492),
  [5870] = {.count = 1, .reusable = false}, SHIFT(3493),
  [5872] = {.count = 1, .reusable = true}, SHIFT(3504),
  [5874] = {.count = 1, .reusable = true}, SHIFT(3503),
  [5876] = {.count = 1, .reusable = true}, SHIFT(3507),
  [5878] = {.count = 1, .reusable = false}, SHIFT(3509),
  [5880] = {.count = 1, .reusable = true}, SHIFT(3509),
  [5882] = {.count = 1, .reusable = true}, SHIFT(3510),
  [5884] = {.count = 1, .reusable = true}, SHIFT(3511),
  [5886] = {.count = 1, .reusable = true}, SHIFT(3514),
  [5888] = {.count = 1, .reusable = true}, SHIFT(3517),
  [5890] = {.count = 1, .reusable = false}, SHIFT(3518),
  [5892] = {.count = 1, .reusable = true}, SHIFT(3515),
  [5894] = {.count = 1, .reusable = false}, SHIFT(3516),
  [5896] = {.count = 1, .reusable = true}, SHIFT(3516),
  [5898] = {.count = 1, .reusable = true}, SHIFT(3518),
  [5900] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [5902] = {.count = 1, .reusable = false}, SHIFT(1397),
  [5904] = {.count = 1, .reusable = false}, SHIFT(3525),
  [5906] = {.count = 1, .reusable = true}, SHIFT(3527),
  [5908] = {.count = 1, .reusable = false}, SHIFT(3537),
  [5910] = {.count = 1, .reusable = false}, SHIFT(3534),
  [5912] = {.count = 1, .reusable = true}, SHIFT(3531),
  [5914] = {.count = 1, .reusable = false}, SHIFT(3533),
  [5916] = {.count = 1, .reusable = false}, SHIFT(3538),
  [5918] = {.count = 1, .reusable = false}, SHIFT(3529),
  [5920] = {.count = 1, .reusable = true}, SHIFT(3537),
  [5922] = {.count = 1, .reusable = false}, SHIFT(3530),
  [5924] = {.count = 1, .reusable = true}, SHIFT(3538),
  [5926] = {.count = 1, .reusable = true}, SHIFT(3530),
  [5928] = {.count = 1, .reusable = false}, SHIFT(3532),
  [5930] = {.count = 1, .reusable = true}, SHIFT(3533),
  [5932] = {.count = 1, .reusable = false}, SHIFT(3528),
  [5934] = {.count = 1, .reusable = true}, SHIFT(3543),
  [5936] = {.count = 1, .reusable = true}, SHIFT(3544),
  [5938] = {.count = 1, .reusable = true}, SHIFT(3547),
  [5940] = {.count = 1, .reusable = false}, SHIFT(3543),
  [5942] = {.count = 1, .reusable = false}, SHIFT(3549),
  [5944] = {.count = 1, .reusable = true}, SHIFT(3551),
  [5946] = {.count = 1, .reusable = false}, SHIFT(3552),
  [5948] = {.count = 1, .reusable = true}, SHIFT(3549),
  [5950] = {.count = 1, .reusable = false}, SHIFT(3554),
  [5952] = {.count = 1, .reusable = false}, SHIFT(3555),
  [5954] = {.count = 1, .reusable = false}, SHIFT(3548),
  [5956] = {.count = 1, .reusable = false}, SHIFT(3556),
  [5958] = {.count = 1, .reusable = false}, SHIFT(3553),
  [5960] = {.count = 1, .reusable = true}, SHIFT(3550),
  [5962] = {.count = 1, .reusable = true}, SHIFT(3553),
  [5964] = {.count = 1, .reusable = false}, SHIFT(3551),
  [5966] = {.count = 1, .reusable = true}, SHIFT(3548),
  [5968] = {.count = 1, .reusable = true}, SHIFT(3554),
  [5970] = {.count = 1, .reusable = false}, SHIFT(3527),
  [5972] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [5976] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(331),
  [5979] = {.count = 1, .reusable = true}, SHIFT(3571),
  [5981] = {.count = 1, .reusable = false}, SHIFT(3573),
  [5983] = {.count = 1, .reusable = true}, SHIFT(3574),
  [5985] = {.count = 1, .reusable = false}, SHIFT(3575),
  [5987] = {.count = 1, .reusable = true}, SHIFT(3575),
  [5989] = {.count = 1, .reusable = true}, SHIFT(3576),
  [5991] = {.count = 1, .reusable = true}, SHIFT(3577),
  [5993] = {.count = 1, .reusable = true}, SHIFT(3580),
  [5995] = {.count = 1, .reusable = true}, SHIFT(3583),
  [5997] = {.count = 1, .reusable = false}, SHIFT(3584),
  [5999] = {.count = 1, .reusable = true}, SHIFT(3586),
  [6001] = {.count = 1, .reusable = false}, SHIFT(3587),
  [6003] = {.count = 1, .reusable = true}, SHIFT(3588),
  [6005] = {.count = 1, .reusable = true}, SHIFT(3589),
  [6007] = {.count = 1, .reusable = true}, SHIFT(3590),
  [6009] = {.count = 1, .reusable = false}, SHIFT(1440),
  [6011] = {.count = 1, .reusable = false}, SHIFT(3602),
  [6013] = {.count = 1, .reusable = true}, SHIFT(3599),
  [6015] = {.count = 1, .reusable = false}, SHIFT(3601),
  [6017] = {.count = 1, .reusable = false}, SHIFT(3605),
  [6019] = {.count = 1, .reusable = false}, SHIFT(3597),
  [6021] = {.count = 1, .reusable = false}, SHIFT(3598),
  [6023] = {.count = 1, .reusable = true}, SHIFT(3605),
  [6025] = {.count = 1, .reusable = true}, SHIFT(3598),
  [6027] = {.count = 1, .reusable = false}, SHIFT(3600),
  [6029] = {.count = 1, .reusable = true}, SHIFT(3601),
  [6031] = {.count = 1, .reusable = false}, SHIFT(3596),
  [6033] = {.count = 1, .reusable = true}, SHIFT(3610),
  [6035] = {.count = 1, .reusable = true}, SHIFT(3611),
  [6037] = {.count = 1, .reusable = true}, SHIFT(3614),
  [6039] = {.count = 1, .reusable = false}, SHIFT(3610),
  [6041] = {.count = 1, .reusable = false}, SHIFT(3615),
  [6043] = {.count = 1, .reusable = true}, SHIFT(3616),
  [6045] = {.count = 1, .reusable = true}, SHIFT(3617),
  [6047] = {.count = 1, .reusable = true}, SHIFT(3618),
  [6049] = {.count = 1, .reusable = true}, SHIFT(3619),
  [6051] = {.count = 1, .reusable = true}, SHIFT(3620),
  [6053] = {.count = 1, .reusable = true}, SHIFT(3621),
  [6055] = {.count = 1, .reusable = true}, SHIFT(3622),
  [6057] = {.count = 1, .reusable = false}, SHIFT(3623),
  [6059] = {.count = 1, .reusable = false}, SHIFT(3618),
  [6061] = {.count = 1, .reusable = true}, SHIFT(3615),
  [6063] = {.count = 1, .reusable = false}, SHIFT(3620),
  [6065] = {.count = 1, .reusable = false}, SHIFT(3624),
  [6067] = {.count = 1, .reusable = true}, SHIFT(3624),
  [6069] = {.count = 1, .reusable = false}, SHIFT(3586),
  [6071] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .alias_sequence_id = 8),
  [6073] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .alias_sequence_id = 8),
  [6075] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [6077] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [6079] = {.count = 1, .reusable = false}, SHIFT(3626),
  [6081] = {.count = 1, .reusable = true}, SHIFT(3627),
  [6083] = {.count = 1, .reusable = true}, SHIFT(3631),
  [6085] = {.count = 1, .reusable = true}, SHIFT(3630),
  [6087] = {.count = 1, .reusable = true}, SHIFT(3633),
  [6089] = {.count = 1, .reusable = true}, SHIFT(3635),
  [6091] = {.count = 1, .reusable = false}, SHIFT(3636),
  [6093] = {.count = 1, .reusable = true}, SHIFT(3637),
  [6095] = {.count = 1, .reusable = false}, SHIFT(1469),
  [6097] = {.count = 1, .reusable = true}, SHIFT(3638),
  [6099] = {.count = 1, .reusable = true}, SHIFT(3639),
  [6101] = {.count = 1, .reusable = false}, SHIFT(3637),
  [6103] = {.count = 1, .reusable = true}, SHIFT(3640),
  [6105] = {.count = 1, .reusable = true}, SHIFT(3634),
  [6107] = {.count = 1, .reusable = false}, SHIFT(3635),
  [6109] = {.count = 1, .reusable = false}, SHIFT(3654),
  [6111] = {.count = 1, .reusable = false}, SHIFT(3649),
  [6113] = {.count = 1, .reusable = false}, SHIFT(3655),
  [6115] = {.count = 1, .reusable = true}, SHIFT(3654),
  [6117] = {.count = 1, .reusable = true}, SHIFT(3655),
  [6119] = {.count = 1, .reusable = false}, SHIFT(3650),
  [6121] = {.count = 1, .reusable = false}, SHIFT(3651),
  [6123] = {.count = 1, .reusable = true}, SHIFT(3652),
  [6125] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 2),
  [6127] = {.count = 1, .reusable = true}, SHIFT(1471),
  [6129] = {.count = 1, .reusable = true}, SHIFT(3657),
  [6131] = {.count = 1, .reusable = true}, SHIFT(3659),
  [6133] = {.count = 1, .reusable = false}, SHIFT(3660),
  [6135] = {.count = 1, .reusable = true}, REDUCE(sym__arg_or_splat_arg, 1),
  [6137] = {.count = 1, .reusable = false}, SHIFT(3661),
  [6139] = {.count = 1, .reusable = true}, SHIFT(3664),
  [6141] = {.count = 1, .reusable = true}, SHIFT(3665),
  [6143] = {.count = 1, .reusable = true}, SHIFT(3662),
  [6145] = {.count = 1, .reusable = true}, SHIFT(3666),
  [6147] = {.count = 1, .reusable = true}, SHIFT(3667),
  [6149] = {.count = 1, .reusable = true}, SHIFT(3663),
  [6151] = {.count = 1, .reusable = true}, SHIFT(3668),
  [6153] = {.count = 1, .reusable = false}, SHIFT(3669),
  [6155] = {.count = 1, .reusable = false}, SHIFT(3662),
  [6157] = {.count = 1, .reusable = true}, SHIFT(3661),
  [6159] = {.count = 1, .reusable = false}, SHIFT(3667),
  [6161] = {.count = 1, .reusable = false}, SHIFT(3670),
  [6163] = {.count = 1, .reusable = true}, SHIFT(3670),
  [6165] = {.count = 1, .reusable = true}, SHIFT(3672),
  [6167] = {.count = 1, .reusable = false}, SHIFT(3671),
  [6169] = {.count = 1, .reusable = true}, SHIFT(3671),
  [6171] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [6173] = {.count = 1, .reusable = true}, SHIFT(3673),
  [6175] = {.count = 1, .reusable = false}, SHIFT(3687),
  [6177] = {.count = 1, .reusable = false}, SHIFT(3686),
  [6179] = {.count = 1, .reusable = false}, SHIFT(3689),
  [6181] = {.count = 1, .reusable = true}, SHIFT(3687),
  [6183] = {.count = 1, .reusable = true}, SHIFT(3676),
  [6185] = {.count = 1, .reusable = false}, SHIFT(3677),
  [6187] = {.count = 1, .reusable = true}, SHIFT(3689),
  [6189] = {.count = 1, .reusable = true}, SHIFT(3678),
  [6191] = {.count = 1, .reusable = true}, SHIFT(3679),
  [6193] = {.count = 1, .reusable = false}, SHIFT(3680),
  [6195] = {.count = 1, .reusable = true}, SHIFT(3681),
  [6197] = {.count = 1, .reusable = false}, SHIFT(3678),
  [6199] = {.count = 1, .reusable = true}, SHIFT(3682),
  [6201] = {.count = 1, .reusable = false}, SHIFT(3683),
  [6203] = {.count = 1, .reusable = true}, SHIFT(3675),
  [6205] = {.count = 1, .reusable = false}, SHIFT(3684),
  [6207] = {.count = 1, .reusable = false}, SHIFT(3676),
  [6209] = {.count = 1, .reusable = true}, SHIFT(3660),
  [6211] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [6213] = {.count = 1, .reusable = false}, SHIFT(3697),
  [6215] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [6217] = {.count = 1, .reusable = true}, SHIFT(3698),
  [6219] = {.count = 1, .reusable = true}, SHIFT(3699),
  [6221] = {.count = 1, .reusable = true}, SHIFT(3702),
  [6223] = {.count = 1, .reusable = true}, SHIFT(3701),
  [6225] = {.count = 1, .reusable = true}, SHIFT(3704),
  [6227] = {.count = 1, .reusable = false}, SHIFT(3721),
  [6229] = {.count = 1, .reusable = false}, SHIFT(3717),
  [6231] = {.count = 1, .reusable = false}, SHIFT(3722),
  [6233] = {.count = 1, .reusable = true}, SHIFT(3721),
  [6235] = {.count = 1, .reusable = true}, SHIFT(3706),
  [6237] = {.count = 1, .reusable = false}, SHIFT(3707),
  [6239] = {.count = 1, .reusable = true}, SHIFT(3722),
  [6241] = {.count = 1, .reusable = true}, SHIFT(3708),
  [6243] = {.count = 1, .reusable = false}, SHIFT(3709),
  [6245] = {.count = 1, .reusable = true}, SHIFT(3710),
  [6247] = {.count = 1, .reusable = false}, SHIFT(3711),
  [6249] = {.count = 1, .reusable = true}, SHIFT(3712),
  [6251] = {.count = 1, .reusable = false}, SHIFT(3708),
  [6253] = {.count = 1, .reusable = true}, SHIFT(3713),
  [6255] = {.count = 1, .reusable = false}, SHIFT(3714),
  [6257] = {.count = 1, .reusable = true}, SHIFT(3705),
  [6259] = {.count = 1, .reusable = false}, SHIFT(3715),
  [6261] = {.count = 1, .reusable = false}, SHIFT(3706),
  [6263] = {.count = 1, .reusable = true}, SHIFT(3731),
  [6265] = {.count = 1, .reusable = true}, SHIFT(3726),
  [6267] = {.count = 1, .reusable = true}, SHIFT(3727),
  [6269] = {.count = 1, .reusable = true}, SHIFT(3728),
  [6271] = {.count = 1, .reusable = true}, SHIFT(3729),
  [6273] = {.count = 1, .reusable = true}, SHIFT(3730),
  [6275] = {.count = 1, .reusable = true}, SHIFT(3733),
  [6277] = {.count = 1, .reusable = false}, SHIFT(3732),
  [6279] = {.count = 1, .reusable = true}, SHIFT(3732),
  [6281] = {.count = 1, .reusable = true}, SHIFT(3734),
  [6283] = {.count = 1, .reusable = true}, SHIFT(3735),
  [6285] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2),
  [6287] = {.count = 1, .reusable = false}, SHIFT(3749),
  [6289] = {.count = 1, .reusable = false}, SHIFT(3748),
  [6291] = {.count = 1, .reusable = false}, SHIFT(3751),
  [6293] = {.count = 1, .reusable = true}, SHIFT(3749),
  [6295] = {.count = 1, .reusable = true}, SHIFT(3738),
  [6297] = {.count = 1, .reusable = false}, SHIFT(3739),
  [6299] = {.count = 1, .reusable = true}, SHIFT(3751),
  [6301] = {.count = 1, .reusable = true}, SHIFT(3740),
  [6303] = {.count = 1, .reusable = true}, SHIFT(3741),
  [6305] = {.count = 1, .reusable = false}, SHIFT(3742),
  [6307] = {.count = 1, .reusable = true}, SHIFT(3743),
  [6309] = {.count = 1, .reusable = false}, SHIFT(3740),
  [6311] = {.count = 1, .reusable = true}, SHIFT(3744),
  [6313] = {.count = 1, .reusable = false}, SHIFT(3745),
  [6315] = {.count = 1, .reusable = true}, SHIFT(3737),
  [6317] = {.count = 1, .reusable = false}, SHIFT(3746),
  [6319] = {.count = 1, .reusable = false}, SHIFT(3738),
  [6321] = {.count = 1, .reusable = true}, SHIFT(3757),
  [6323] = {.count = 1, .reusable = false}, SHIFT(3734),
  [6325] = {.count = 1, .reusable = false}, SHIFT(3758),
  [6327] = {.count = 1, .reusable = true}, SHIFT(3761),
  [6329] = {.count = 1, .reusable = true}, SHIFT(3762),
  [6331] = {.count = 1, .reusable = true}, SHIFT(3759),
  [6333] = {.count = 1, .reusable = true}, SHIFT(3763),
  [6335] = {.count = 1, .reusable = true}, SHIFT(3764),
  [6337] = {.count = 1, .reusable = true}, SHIFT(3760),
  [6339] = {.count = 1, .reusable = true}, SHIFT(3765),
  [6341] = {.count = 1, .reusable = false}, SHIFT(3766),
  [6343] = {.count = 1, .reusable = false}, SHIFT(3759),
  [6345] = {.count = 1, .reusable = true}, SHIFT(3758),
  [6347] = {.count = 1, .reusable = false}, SHIFT(3764),
  [6349] = {.count = 1, .reusable = false}, SHIFT(3767),
  [6351] = {.count = 1, .reusable = true}, SHIFT(3767),
  [6353] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [6355] = {.count = 1, .reusable = false}, SHIFT(1512),
  [6357] = {.count = 1, .reusable = true}, SHIFT(1516),
  [6359] = {.count = 1, .reusable = false}, SHIFT(3773),
  [6361] = {.count = 1, .reusable = true}, SHIFT(3775),
  [6363] = {.count = 1, .reusable = true}, SHIFT(3776),
  [6365] = {.count = 1, .reusable = false}, SHIFT(3777),
  [6367] = {.count = 1, .reusable = true}, SHIFT(3778),
  [6369] = {.count = 1, .reusable = true}, SHIFT(3779),
  [6371] = {.count = 1, .reusable = true}, SHIFT(3780),
  [6373] = {.count = 1, .reusable = false}, SHIFT(3792),
  [6375] = {.count = 1, .reusable = true}, SHIFT(3789),
  [6377] = {.count = 1, .reusable = false}, SHIFT(3791),
  [6379] = {.count = 1, .reusable = false}, SHIFT(3787),
  [6381] = {.count = 1, .reusable = false}, SHIFT(3788),
  [6383] = {.count = 1, .reusable = true}, SHIFT(3788),
  [6385] = {.count = 1, .reusable = false}, SHIFT(3790),
  [6387] = {.count = 1, .reusable = true}, SHIFT(3791),
  [6389] = {.count = 1, .reusable = false}, SHIFT(3786),
  [6391] = {.count = 1, .reusable = true}, SHIFT(3799),
  [6393] = {.count = 1, .reusable = true}, SHIFT(3802),
  [6395] = {.count = 1, .reusable = false}, SHIFT(3803),
  [6397] = {.count = 1, .reusable = false}, SHIFT(3804),
  [6399] = {.count = 1, .reusable = true}, SHIFT(3805),
  [6401] = {.count = 1, .reusable = true}, SHIFT(3806),
  [6403] = {.count = 1, .reusable = true}, SHIFT(3808),
  [6405] = {.count = 1, .reusable = true}, SHIFT(3809),
  [6407] = {.count = 1, .reusable = true}, SHIFT(3807),
  [6409] = {.count = 1, .reusable = false}, SHIFT(3811),
  [6411] = {.count = 1, .reusable = true}, SHIFT(3810),
  [6413] = {.count = 1, .reusable = false}, SHIFT(3807),
  [6415] = {.count = 1, .reusable = true}, SHIFT(3804),
  [6417] = {.count = 1, .reusable = false}, SHIFT(3812),
  [6419] = {.count = 1, .reusable = false}, SHIFT(3809),
  [6421] = {.count = 1, .reusable = true}, SHIFT(3812),
  [6423] = {.count = 1, .reusable = true}, SHIFT(3814),
  [6425] = {.count = 1, .reusable = false}, SHIFT(3813),
  [6427] = {.count = 1, .reusable = true}, SHIFT(3813),
  [6429] = {.count = 1, .reusable = false}, SHIFT(3815),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3816),
  [6433] = {.count = 1, .reusable = true}, SHIFT(3818),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3817),
  [6437] = {.count = 1, .reusable = true}, SHIFT(3803),
  [6439] = {.count = 1, .reusable = false}, SHIFT(3776),
  [6441] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [6443] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [6445] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [6447] = {.count = 1, .reusable = false}, SHIFT(3830),
  [6449] = {.count = 1, .reusable = true}, SHIFT(3830),
  [6451] = {.count = 1, .reusable = true}, SHIFT(3831),
  [6453] = {.count = 1, .reusable = true}, SHIFT(3832),
  [6455] = {.count = 1, .reusable = true}, SHIFT(3835),
  [6457] = {.count = 1, .reusable = true}, SHIFT(3838),
  [6459] = {.count = 1, .reusable = false}, SHIFT(3839),
  [6461] = {.count = 1, .reusable = true}, SHIFT(3836),
  [6463] = {.count = 1, .reusable = false}, SHIFT(3837),
  [6465] = {.count = 1, .reusable = true}, SHIFT(3837),
  [6467] = {.count = 1, .reusable = true}, SHIFT(3839),
  [6469] = {.count = 1, .reusable = true}, SHIFT(3844),
  [6471] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [6473] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [6475] = {.count = 1, .reusable = false}, SHIFT(1549),
  [6477] = {.count = 1, .reusable = false}, SHIFT(3848),
  [6479] = {.count = 1, .reusable = true}, SHIFT(3850),
  [6481] = {.count = 1, .reusable = false}, SHIFT(3860),
  [6483] = {.count = 1, .reusable = false}, SHIFT(3857),
  [6485] = {.count = 1, .reusable = true}, SHIFT(3854),
  [6487] = {.count = 1, .reusable = false}, SHIFT(3856),
  [6489] = {.count = 1, .reusable = false}, SHIFT(3861),
  [6491] = {.count = 1, .reusable = false}, SHIFT(3852),
  [6493] = {.count = 1, .reusable = true}, SHIFT(3860),
  [6495] = {.count = 1, .reusable = false}, SHIFT(3853),
  [6497] = {.count = 1, .reusable = true}, SHIFT(3861),
  [6499] = {.count = 1, .reusable = true}, SHIFT(3853),
  [6501] = {.count = 1, .reusable = false}, SHIFT(3855),
  [6503] = {.count = 1, .reusable = true}, SHIFT(3856),
  [6505] = {.count = 1, .reusable = false}, SHIFT(3851),
  [6507] = {.count = 1, .reusable = true}, SHIFT(3866),
  [6509] = {.count = 1, .reusable = true}, SHIFT(3867),
  [6511] = {.count = 1, .reusable = true}, SHIFT(3870),
  [6513] = {.count = 1, .reusable = false}, SHIFT(3866),
  [6515] = {.count = 1, .reusable = false}, SHIFT(3872),
  [6517] = {.count = 1, .reusable = true}, SHIFT(3874),
  [6519] = {.count = 1, .reusable = false}, SHIFT(3875),
  [6521] = {.count = 1, .reusable = true}, SHIFT(3872),
  [6523] = {.count = 1, .reusable = false}, SHIFT(3877),
  [6525] = {.count = 1, .reusable = false}, SHIFT(3878),
  [6527] = {.count = 1, .reusable = false}, SHIFT(3871),
  [6529] = {.count = 1, .reusable = false}, SHIFT(3879),
  [6531] = {.count = 1, .reusable = false}, SHIFT(3876),
  [6533] = {.count = 1, .reusable = true}, SHIFT(3873),
  [6535] = {.count = 1, .reusable = true}, SHIFT(3876),
  [6537] = {.count = 1, .reusable = false}, SHIFT(3874),
  [6539] = {.count = 1, .reusable = true}, SHIFT(3871),
  [6541] = {.count = 1, .reusable = true}, SHIFT(3877),
  [6543] = {.count = 1, .reusable = false}, SHIFT(3850),
  [6545] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1547),
  [6548] = {.count = 1, .reusable = false}, SHIFT(3895),
  [6550] = {.count = 1, .reusable = true}, SHIFT(3895),
  [6552] = {.count = 1, .reusable = true}, SHIFT(3896),
  [6554] = {.count = 1, .reusable = true}, SHIFT(3897),
  [6556] = {.count = 1, .reusable = true}, SHIFT(3900),
  [6558] = {.count = 1, .reusable = false}, SHIFT(3903),
  [6560] = {.count = 1, .reusable = true}, SHIFT(3905),
  [6562] = {.count = 1, .reusable = false}, SHIFT(3906),
  [6564] = {.count = 1, .reusable = true}, SHIFT(3907),
  [6566] = {.count = 1, .reusable = true}, SHIFT(3908),
  [6568] = {.count = 1, .reusable = true}, SHIFT(3909),
  [6570] = {.count = 1, .reusable = false}, SHIFT(1588),
  [6572] = {.count = 1, .reusable = false}, SHIFT(3921),
  [6574] = {.count = 1, .reusable = true}, SHIFT(3918),
  [6576] = {.count = 1, .reusable = false}, SHIFT(3920),
  [6578] = {.count = 1, .reusable = false}, SHIFT(3916),
  [6580] = {.count = 1, .reusable = false}, SHIFT(3917),
  [6582] = {.count = 1, .reusable = true}, SHIFT(3917),
  [6584] = {.count = 1, .reusable = false}, SHIFT(3919),
  [6586] = {.count = 1, .reusable = true}, SHIFT(3920),
  [6588] = {.count = 1, .reusable = false}, SHIFT(3915),
  [6590] = {.count = 1, .reusable = true}, SHIFT(3928),
  [6592] = {.count = 1, .reusable = true}, SHIFT(3929),
  [6594] = {.count = 1, .reusable = true}, SHIFT(3932),
  [6596] = {.count = 1, .reusable = false}, SHIFT(3928),
  [6598] = {.count = 1, .reusable = false}, SHIFT(3933),
  [6600] = {.count = 1, .reusable = true}, SHIFT(3934),
  [6602] = {.count = 1, .reusable = true}, SHIFT(3935),
  [6604] = {.count = 1, .reusable = true}, SHIFT(3936),
  [6606] = {.count = 1, .reusable = true}, SHIFT(3937),
  [6608] = {.count = 1, .reusable = true}, SHIFT(3938),
  [6610] = {.count = 1, .reusable = true}, SHIFT(3939),
  [6612] = {.count = 1, .reusable = true}, SHIFT(3940),
  [6614] = {.count = 1, .reusable = false}, SHIFT(3941),
  [6616] = {.count = 1, .reusable = false}, SHIFT(3936),
  [6618] = {.count = 1, .reusable = true}, SHIFT(3933),
  [6620] = {.count = 1, .reusable = false}, SHIFT(3938),
  [6622] = {.count = 1, .reusable = false}, SHIFT(3942),
  [6624] = {.count = 1, .reusable = true}, SHIFT(3942),
  [6626] = {.count = 1, .reusable = false}, SHIFT(3905),
  [6628] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [6630] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .alias_sequence_id = 9),
  [6632] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .alias_sequence_id = 9),
  [6634] = {.count = 1, .reusable = false}, SHIFT(3955),
  [6636] = {.count = 1, .reusable = false}, SHIFT(3944),
  [6638] = {.count = 1, .reusable = false}, SHIFT(3957),
  [6640] = {.count = 1, .reusable = true}, SHIFT(3955),
  [6642] = {.count = 1, .reusable = false}, SHIFT(3945),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3946),
  [6646] = {.count = 1, .reusable = true}, SHIFT(3957),
  [6648] = {.count = 1, .reusable = true}, SHIFT(3947),
  [6650] = {.count = 1, .reusable = true}, SHIFT(3948),
  [6652] = {.count = 1, .reusable = false}, SHIFT(3949),
  [6654] = {.count = 1, .reusable = false}, SHIFT(3947),
  [6656] = {.count = 1, .reusable = true}, SHIFT(3950),
  [6658] = {.count = 1, .reusable = false}, SHIFT(3951),
  [6660] = {.count = 1, .reusable = true}, SHIFT(3945),
  [6662] = {.count = 1, .reusable = false}, SHIFT(3952),
  [6664] = {.count = 1, .reusable = false}, SHIFT(3953),
  [6666] = {.count = 1, .reusable = true}, SHIFT(3963),
  [6668] = {.count = 1, .reusable = true}, SHIFT(3962),
  [6670] = {.count = 1, .reusable = false}, SHIFT(3964),
  [6672] = {.count = 1, .reusable = false}, SHIFT(3965),
  [6674] = {.count = 1, .reusable = false}, SHIFT(3966),
  [6676] = {.count = 1, .reusable = true}, SHIFT(3965),
  [6678] = {.count = 1, .reusable = true}, SHIFT(3966),
  [6680] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 5),
  [6682] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 5),
  [6684] = {.count = 1, .reusable = true}, SHIFT(3968),
  [6686] = {.count = 1, .reusable = true}, SHIFT(3969),
  [6688] = {.count = 1, .reusable = true}, SHIFT(3970),
  [6690] = {.count = 1, .reusable = true}, SHIFT(3972),
  [6692] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 10),
  [6694] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 10),
  [6696] = {.count = 1, .reusable = true}, SHIFT(3974),
  [6698] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3),
  [6700] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3),
  [6702] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3),
  [6704] = {.count = 1, .reusable = true}, SHIFT(3976),
  [6706] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3),
  [6708] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3),
  [6710] = {.count = 1, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2),
  [6712] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [6714] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(3977),
  [6717] = {.count = 1, .reusable = true}, SHIFT(3978),
  [6719] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3),
  [6721] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3),
  [6723] = {.count = 1, .reusable = true}, SHIFT(3981),
  [6725] = {.count = 1, .reusable = true}, SHIFT(3980),
  [6727] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list_with_parens, 1),
  [6729] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list_with_parens, 1),
  [6731] = {.count = 1, .reusable = true}, SHIFT(3982),
  [6733] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3),
  [6735] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3),
  [6737] = {.count = 1, .reusable = true}, SHIFT(3984),
  [6739] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3),
  [6741] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3),
  [6743] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3),
  [6745] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [6747] = {.count = 1, .reusable = true}, SHIFT(3988),
  [6749] = {.count = 1, .reusable = false}, SHIFT(3989),
  [6751] = {.count = 1, .reusable = false}, SHIFT(3990),
  [6753] = {.count = 1, .reusable = true}, SHIFT(3992),
  [6755] = {.count = 1, .reusable = true}, SHIFT(3993),
  [6757] = {.count = 1, .reusable = true}, SHIFT(3994),
  [6759] = {.count = 1, .reusable = true}, SHIFT(3995),
  [6761] = {.count = 1, .reusable = true}, SHIFT(3991),
  [6763] = {.count = 1, .reusable = false}, SHIFT(3997),
  [6765] = {.count = 1, .reusable = true}, SHIFT(3996),
  [6767] = {.count = 1, .reusable = false}, SHIFT(3991),
  [6769] = {.count = 1, .reusable = true}, SHIFT(3990),
  [6771] = {.count = 1, .reusable = false}, SHIFT(3998),
  [6773] = {.count = 1, .reusable = false}, SHIFT(3995),
  [6775] = {.count = 1, .reusable = true}, SHIFT(3998),
  [6777] = {.count = 1, .reusable = true}, SHIFT(3989),
  [6779] = {.count = 1, .reusable = true}, SHIFT(3999),
  [6781] = {.count = 1, .reusable = true}, SHIFT(4001),
  [6783] = {.count = 1, .reusable = true}, SHIFT(4002),
  [6785] = {.count = 1, .reusable = true}, SHIFT(4004),
  [6787] = {.count = 1, .reusable = true}, SHIFT(4006),
  [6789] = {.count = 1, .reusable = true}, SHIFT(4005),
  [6791] = {.count = 1, .reusable = true}, SHIFT(4008),
  [6793] = {.count = 1, .reusable = true}, SHIFT(4009),
  [6795] = {.count = 1, .reusable = true}, SHIFT(4011),
  [6797] = {.count = 1, .reusable = true}, SHIFT(4015),
  [6799] = {.count = 1, .reusable = false}, SHIFT(4016),
  [6801] = {.count = 1, .reusable = true}, SHIFT(4017),
  [6803] = {.count = 1, .reusable = true}, SHIFT(4018),
  [6805] = {.count = 1, .reusable = true}, SHIFT(4019),
  [6807] = {.count = 1, .reusable = true}, SHIFT(4025),
  [6809] = {.count = 1, .reusable = true}, SHIFT(4027),
  [6811] = {.count = 1, .reusable = true}, SHIFT(4030),
  [6813] = {.count = 1, .reusable = false}, SHIFT(4029),
  [6815] = {.count = 1, .reusable = true}, SHIFT(4029),
  [6817] = {.count = 1, .reusable = true}, SHIFT(4031),
  [6819] = {.count = 1, .reusable = false}, SHIFT(4032),
  [6821] = {.count = 1, .reusable = true}, SHIFT(4033),
  [6823] = {.count = 1, .reusable = true}, SHIFT(4034),
  [6825] = {.count = 1, .reusable = true}, SHIFT(4035),
  [6827] = {.count = 1, .reusable = true}, SHIFT(4041),
  [6829] = {.count = 1, .reusable = false}, SHIFT(4031),
  [6831] = {.count = 1, .reusable = false}, SHIFT(4042),
  [6833] = {.count = 1, .reusable = true}, SHIFT(4043),
  [6835] = {.count = 1, .reusable = true}, SHIFT(4044),
  [6837] = {.count = 1, .reusable = true}, SHIFT(4045),
  [6839] = {.count = 1, .reusable = true}, SHIFT(4046),
  [6841] = {.count = 1, .reusable = true}, SHIFT(4047),
  [6843] = {.count = 1, .reusable = true}, SHIFT(4048),
  [6845] = {.count = 1, .reusable = true}, SHIFT(4049),
  [6847] = {.count = 1, .reusable = false}, SHIFT(4050),
  [6849] = {.count = 1, .reusable = false}, SHIFT(4045),
  [6851] = {.count = 1, .reusable = true}, SHIFT(4042),
  [6853] = {.count = 1, .reusable = false}, SHIFT(4047),
  [6855] = {.count = 1, .reusable = false}, SHIFT(4051),
  [6857] = {.count = 1, .reusable = true}, SHIFT(4051),
  [6859] = {.count = 1, .reusable = true}, SHIFT(4054),
  [6861] = {.count = 1, .reusable = true}, SHIFT(4055),
  [6863] = {.count = 1, .reusable = true}, SHIFT(4058),
  [6865] = {.count = 1, .reusable = false}, SHIFT(4057),
  [6867] = {.count = 1, .reusable = true}, SHIFT(4057),
  [6869] = {.count = 1, .reusable = true}, SHIFT(4061),
  [6871] = {.count = 1, .reusable = true}, SHIFT(4065),
  [6873] = {.count = 1, .reusable = true}, SHIFT(4066),
  [6875] = {.count = 1, .reusable = true}, SHIFT(4070),
  [6877] = {.count = 1, .reusable = true}, SHIFT(4072),
  [6879] = {.count = 1, .reusable = true}, SHIFT(4071),
  [6881] = {.count = 1, .reusable = true}, SHIFT(4074),
  [6883] = {.count = 1, .reusable = true}, SHIFT(4076),
  [6885] = {.count = 1, .reusable = true}, SHIFT(4080),
  [6887] = {.count = 1, .reusable = false}, SHIFT(4081),
  [6889] = {.count = 1, .reusable = false}, SHIFT(4083),
  [6891] = {.count = 1, .reusable = true}, SHIFT(4087),
  [6893] = {.count = 1, .reusable = false}, SHIFT(4088),
  [6895] = {.count = 1, .reusable = true}, SHIFT(4093),
  [6897] = {.count = 1, .reusable = true}, SHIFT(4096),
  [6899] = {.count = 1, .reusable = true}, SHIFT(4095),
  [6901] = {.count = 1, .reusable = true}, SHIFT(4098),
  [6903] = {.count = 1, .reusable = true}, SHIFT(4100),
  [6905] = {.count = 1, .reusable = false}, SHIFT(4106),
  [6907] = {.count = 1, .reusable = true}, SHIFT(4108),
  [6909] = {.count = 1, .reusable = true}, SHIFT(4110),
  [6911] = {.count = 1, .reusable = false}, SHIFT(4117),
  [6913] = {.count = 1, .reusable = true}, SHIFT(4114),
  [6915] = {.count = 1, .reusable = true}, SHIFT(4120),
  [6917] = {.count = 1, .reusable = false}, SHIFT(4121),
  [6919] = {.count = 1, .reusable = false}, SHIFT(4124),
  [6921] = {.count = 1, .reusable = true}, SHIFT(4123),
  [6923] = {.count = 1, .reusable = false}, SHIFT(4126),
  [6925] = {.count = 1, .reusable = true}, SHIFT(4124),
  [6927] = {.count = 1, .reusable = false}, SHIFT(4128),
  [6929] = {.count = 1, .reusable = false}, SHIFT(4129),
  [6931] = {.count = 1, .reusable = false}, SHIFT(4122),
  [6933] = {.count = 1, .reusable = false}, SHIFT(4130),
  [6935] = {.count = 1, .reusable = false}, SHIFT(4127),
  [6937] = {.count = 1, .reusable = true}, SHIFT(4125),
  [6939] = {.count = 1, .reusable = true}, SHIFT(4127),
  [6941] = {.count = 1, .reusable = false}, SHIFT(4123),
  [6943] = {.count = 1, .reusable = true}, SHIFT(4122),
  [6945] = {.count = 1, .reusable = true}, SHIFT(4128),
  [6947] = {.count = 1, .reusable = true}, SHIFT(4131),
  [6949] = {.count = 1, .reusable = true}, SHIFT(4121),
  [6951] = {.count = 1, .reusable = true}, SHIFT(4133),
  [6953] = {.count = 1, .reusable = true}, SHIFT(4134),
  [6955] = {.count = 1, .reusable = true}, SHIFT(4135),
  [6957] = {.count = 1, .reusable = true}, SHIFT(4138),
  [6959] = {.count = 1, .reusable = true}, SHIFT(4139),
  [6961] = {.count = 1, .reusable = true}, SHIFT(4140),
  [6963] = {.count = 1, .reusable = true}, SHIFT(4142),
  [6965] = {.count = 1, .reusable = true}, SHIFT(4144),
  [6967] = {.count = 1, .reusable = true}, SHIFT(4146),
  [6969] = {.count = 1, .reusable = false}, SHIFT(4145),
  [6971] = {.count = 1, .reusable = true}, SHIFT(4147),
  [6973] = {.count = 1, .reusable = false}, SHIFT(4150),
  [6975] = {.count = 1, .reusable = true}, SHIFT(4152),
  [6977] = {.count = 1, .reusable = true}, SHIFT(4153),
  [6979] = {.count = 1, .reusable = true}, SHIFT(4156),
  [6981] = {.count = 1, .reusable = true}, SHIFT(4155),
  [6983] = {.count = 1, .reusable = true}, SHIFT(4158),
  [6985] = {.count = 1, .reusable = true}, SHIFT(4159),
  [6987] = {.count = 1, .reusable = true}, SHIFT(4161),
  [6989] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3),
  [6991] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3),
  [6993] = {.count = 1, .reusable = true}, SHIFT(4166),
  [6995] = {.count = 1, .reusable = true}, SHIFT(4165),
  [6997] = {.count = 1, .reusable = true}, SHIFT(447),
  [6999] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3),
  [7001] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3),
  [7003] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3),
  [7005] = {.count = 1, .reusable = false}, SHIFT(4200),
  [7007] = {.count = 1, .reusable = false}, SHIFT(4196),
  [7009] = {.count = 1, .reusable = false}, SHIFT(4201),
  [7011] = {.count = 1, .reusable = true}, SHIFT(4200),
  [7013] = {.count = 1, .reusable = true}, SHIFT(4185),
  [7015] = {.count = 1, .reusable = false}, SHIFT(4186),
  [7017] = {.count = 1, .reusable = true}, SHIFT(4201),
  [7019] = {.count = 1, .reusable = true}, SHIFT(4187),
  [7021] = {.count = 1, .reusable = false}, SHIFT(4188),
  [7023] = {.count = 1, .reusable = true}, SHIFT(4189),
  [7025] = {.count = 1, .reusable = false}, SHIFT(4190),
  [7027] = {.count = 1, .reusable = true}, SHIFT(4191),
  [7029] = {.count = 1, .reusable = false}, SHIFT(4187),
  [7031] = {.count = 1, .reusable = true}, SHIFT(4192),
  [7033] = {.count = 1, .reusable = false}, SHIFT(4193),
  [7035] = {.count = 1, .reusable = true}, SHIFT(4184),
  [7037] = {.count = 1, .reusable = false}, SHIFT(4194),
  [7039] = {.count = 1, .reusable = false}, SHIFT(4185),
  [7041] = {.count = 1, .reusable = true}, SHIFT(4207),
  [7043] = {.count = 1, .reusable = true}, SHIFT(4208),
  [7045] = {.count = 1, .reusable = false}, SHIFT(4209),
  [7047] = {.count = 1, .reusable = false}, SHIFT(4210),
  [7049] = {.count = 1, .reusable = true}, SHIFT(4211),
  [7051] = {.count = 1, .reusable = true}, SHIFT(4212),
  [7053] = {.count = 1, .reusable = true}, SHIFT(4213),
  [7055] = {.count = 1, .reusable = true}, SHIFT(4214),
  [7057] = {.count = 1, .reusable = true}, SHIFT(4215),
  [7059] = {.count = 1, .reusable = true}, SHIFT(4216),
  [7061] = {.count = 1, .reusable = true}, SHIFT(4217),
  [7063] = {.count = 1, .reusable = false}, SHIFT(4218),
  [7065] = {.count = 1, .reusable = false}, SHIFT(4213),
  [7067] = {.count = 1, .reusable = true}, SHIFT(4219),
  [7069] = {.count = 1, .reusable = true}, SHIFT(4210),
  [7071] = {.count = 1, .reusable = false}, SHIFT(4215),
  [7073] = {.count = 1, .reusable = false}, SHIFT(4220),
  [7075] = {.count = 1, .reusable = true}, SHIFT(4220),
  [7077] = {.count = 1, .reusable = true}, SHIFT(4222),
  [7079] = {.count = 1, .reusable = false}, SHIFT(4221),
  [7081] = {.count = 1, .reusable = true}, SHIFT(4221),
  [7083] = {.count = 1, .reusable = false}, SHIFT(4235),
  [7085] = {.count = 1, .reusable = false}, SHIFT(4234),
  [7087] = {.count = 1, .reusable = false}, SHIFT(4237),
  [7089] = {.count = 1, .reusable = true}, SHIFT(4235),
  [7091] = {.count = 1, .reusable = true}, SHIFT(4224),
  [7093] = {.count = 1, .reusable = false}, SHIFT(4225),
  [7095] = {.count = 1, .reusable = true}, SHIFT(4237),
  [7097] = {.count = 1, .reusable = true}, SHIFT(4226),
  [7099] = {.count = 1, .reusable = true}, SHIFT(4227),
  [7101] = {.count = 1, .reusable = false}, SHIFT(4228),
  [7103] = {.count = 1, .reusable = true}, SHIFT(4229),
  [7105] = {.count = 1, .reusable = false}, SHIFT(4226),
  [7107] = {.count = 1, .reusable = true}, SHIFT(4230),
  [7109] = {.count = 1, .reusable = false}, SHIFT(4231),
  [7111] = {.count = 1, .reusable = true}, SHIFT(4223),
  [7113] = {.count = 1, .reusable = false}, SHIFT(4232),
  [7115] = {.count = 1, .reusable = false}, SHIFT(4224),
  [7117] = {.count = 1, .reusable = true}, SHIFT(4209),
  [7119] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [7121] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [7123] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [7125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(17),
  [7128] = {.count = 1, .reusable = true}, SHIFT(4244),
  [7130] = {.count = 1, .reusable = true}, SHIFT(4245),
  [7132] = {.count = 1, .reusable = false}, SHIFT(1820),
  [7134] = {.count = 1, .reusable = false}, SHIFT(1815),
  [7136] = {.count = 1, .reusable = true}, SHIFT(1812),
  [7138] = {.count = 1, .reusable = false}, SHIFT(1813),
  [7140] = {.count = 1, .reusable = false}, SHIFT(1822),
  [7142] = {.count = 1, .reusable = false}, SHIFT(1816),
  [7144] = {.count = 1, .reusable = true}, SHIFT(1820),
  [7146] = {.count = 1, .reusable = false}, SHIFT(1811),
  [7148] = {.count = 1, .reusable = true}, SHIFT(1822),
  [7150] = {.count = 1, .reusable = true}, SHIFT(1811),
  [7152] = {.count = 1, .reusable = false}, SHIFT(1817),
  [7154] = {.count = 1, .reusable = true}, SHIFT(1813),
  [7156] = {.count = 1, .reusable = true}, SHIFT(1814),
  [7158] = {.count = 1, .reusable = false}, SHIFT(1818),
  [7160] = {.count = 1, .reusable = true}, SHIFT(4248),
  [7162] = {.count = 1, .reusable = false}, SHIFT(4265),
  [7164] = {.count = 1, .reusable = false}, SHIFT(4261),
  [7166] = {.count = 1, .reusable = false}, SHIFT(4266),
  [7168] = {.count = 1, .reusable = true}, SHIFT(4265),
  [7170] = {.count = 1, .reusable = true}, SHIFT(4250),
  [7172] = {.count = 1, .reusable = false}, SHIFT(4251),
  [7174] = {.count = 1, .reusable = true}, SHIFT(4266),
  [7176] = {.count = 1, .reusable = true}, SHIFT(4252),
  [7178] = {.count = 1, .reusable = false}, SHIFT(4253),
  [7180] = {.count = 1, .reusable = true}, SHIFT(4254),
  [7182] = {.count = 1, .reusable = false}, SHIFT(4255),
  [7184] = {.count = 1, .reusable = true}, SHIFT(4256),
  [7186] = {.count = 1, .reusable = false}, SHIFT(4252),
  [7188] = {.count = 1, .reusable = true}, SHIFT(4257),
  [7190] = {.count = 1, .reusable = false}, SHIFT(4258),
  [7192] = {.count = 1, .reusable = true}, SHIFT(4249),
  [7194] = {.count = 1, .reusable = false}, SHIFT(4259),
  [7196] = {.count = 1, .reusable = false}, SHIFT(4250),
  [7198] = {.count = 1, .reusable = true}, SHIFT(4270),
  [7200] = {.count = 1, .reusable = true}, SHIFT(4271),
  [7202] = {.count = 1, .reusable = true}, SHIFT(4272),
  [7204] = {.count = 1, .reusable = true}, SHIFT(4273),
  [7206] = {.count = 1, .reusable = true}, SHIFT(4274),
  [7208] = {.count = 1, .reusable = true}, SHIFT(4276),
  [7210] = {.count = 1, .reusable = false}, SHIFT(4275),
  [7212] = {.count = 1, .reusable = true}, SHIFT(4275),
  [7214] = {.count = 1, .reusable = true}, SHIFT(4277),
  [7216] = {.count = 1, .reusable = false}, SHIFT(4290),
  [7218] = {.count = 1, .reusable = false}, SHIFT(4289),
  [7220] = {.count = 1, .reusable = false}, SHIFT(4292),
  [7222] = {.count = 1, .reusable = true}, SHIFT(4290),
  [7224] = {.count = 1, .reusable = true}, SHIFT(4279),
  [7226] = {.count = 1, .reusable = false}, SHIFT(4280),
  [7228] = {.count = 1, .reusable = true}, SHIFT(4292),
  [7230] = {.count = 1, .reusable = true}, SHIFT(4281),
  [7232] = {.count = 1, .reusable = true}, SHIFT(4282),
  [7234] = {.count = 1, .reusable = false}, SHIFT(4283),
  [7236] = {.count = 1, .reusable = true}, SHIFT(4284),
  [7238] = {.count = 1, .reusable = false}, SHIFT(4281),
  [7240] = {.count = 1, .reusable = true}, SHIFT(4285),
  [7242] = {.count = 1, .reusable = false}, SHIFT(4286),
  [7244] = {.count = 1, .reusable = true}, SHIFT(4278),
  [7246] = {.count = 1, .reusable = false}, SHIFT(4287),
  [7248] = {.count = 1, .reusable = false}, SHIFT(4279),
  [7250] = {.count = 1, .reusable = false}, SHIFT(4277),
  [7252] = {.count = 1, .reusable = true}, SHIFT(4298),
  [7254] = {.count = 1, .reusable = false}, SHIFT(4299),
  [7256] = {.count = 1, .reusable = true}, SHIFT(4302),
  [7258] = {.count = 1, .reusable = true}, SHIFT(4303),
  [7260] = {.count = 1, .reusable = true}, SHIFT(4300),
  [7262] = {.count = 1, .reusable = true}, SHIFT(4304),
  [7264] = {.count = 1, .reusable = true}, SHIFT(4305),
  [7266] = {.count = 1, .reusable = true}, SHIFT(4301),
  [7268] = {.count = 1, .reusable = true}, SHIFT(4306),
  [7270] = {.count = 1, .reusable = false}, SHIFT(4307),
  [7272] = {.count = 1, .reusable = false}, SHIFT(4300),
  [7274] = {.count = 1, .reusable = true}, SHIFT(4299),
  [7276] = {.count = 1, .reusable = false}, SHIFT(4305),
  [7278] = {.count = 1, .reusable = false}, SHIFT(4308),
  [7280] = {.count = 1, .reusable = true}, SHIFT(4308),
  [7282] = {.count = 1, .reusable = false}, SHIFT(4312),
  [7284] = {.count = 1, .reusable = true}, SHIFT(4313),
  [7286] = {.count = 1, .reusable = true}, SHIFT(4317),
  [7288] = {.count = 1, .reusable = false}, SHIFT(4313),
  [7290] = {.count = 1, .reusable = true}, SHIFT(4324),
  [7292] = {.count = 1, .reusable = false}, SHIFT(4325),
  [7294] = {.count = 1, .reusable = false}, SHIFT(4326),
  [7296] = {.count = 1, .reusable = true}, SHIFT(4328),
  [7298] = {.count = 1, .reusable = true}, SHIFT(4329),
  [7300] = {.count = 1, .reusable = true}, SHIFT(4330),
  [7302] = {.count = 1, .reusable = true}, SHIFT(4331),
  [7304] = {.count = 1, .reusable = true}, SHIFT(4327),
  [7306] = {.count = 1, .reusable = true}, SHIFT(4332),
  [7308] = {.count = 1, .reusable = false}, SHIFT(4333),
  [7310] = {.count = 1, .reusable = false}, SHIFT(4327),
  [7312] = {.count = 1, .reusable = true}, SHIFT(4326),
  [7314] = {.count = 1, .reusable = false}, SHIFT(4334),
  [7316] = {.count = 1, .reusable = false}, SHIFT(4331),
  [7318] = {.count = 1, .reusable = true}, SHIFT(4334),
  [7320] = {.count = 1, .reusable = true}, SHIFT(4325),
  [7322] = {.count = 1, .reusable = true}, SHIFT(487),
  [7324] = {.count = 1, .reusable = false}, SHIFT(4353),
  [7326] = {.count = 1, .reusable = true}, SHIFT(4353),
  [7328] = {.count = 1, .reusable = true}, SHIFT(4354),
  [7330] = {.count = 1, .reusable = true}, SHIFT(4355),
  [7332] = {.count = 1, .reusable = true}, SHIFT(4358),
  [7334] = {.count = 1, .reusable = true}, SHIFT(4359),
  [7336] = {.count = 1, .reusable = false}, SHIFT(4360),
  [7338] = {.count = 1, .reusable = true}, SHIFT(4361),
  [7340] = {.count = 1, .reusable = true}, SHIFT(4365),
  [7342] = {.count = 1, .reusable = false}, SHIFT(4361),
  [7344] = {.count = 1, .reusable = true}, SHIFT(4372),
  [7346] = {.count = 1, .reusable = false}, SHIFT(4373),
  [7348] = {.count = 1, .reusable = false}, SHIFT(4374),
  [7350] = {.count = 1, .reusable = true}, SHIFT(4376),
  [7352] = {.count = 1, .reusable = true}, SHIFT(4377),
  [7354] = {.count = 1, .reusable = true}, SHIFT(4378),
  [7356] = {.count = 1, .reusable = true}, SHIFT(4379),
  [7358] = {.count = 1, .reusable = true}, SHIFT(4375),
  [7360] = {.count = 1, .reusable = true}, SHIFT(4380),
  [7362] = {.count = 1, .reusable = false}, SHIFT(4381),
  [7364] = {.count = 1, .reusable = false}, SHIFT(4375),
  [7366] = {.count = 1, .reusable = true}, SHIFT(4374),
  [7368] = {.count = 1, .reusable = false}, SHIFT(4382),
  [7370] = {.count = 1, .reusable = false}, SHIFT(4379),
  [7372] = {.count = 1, .reusable = true}, SHIFT(4382),
  [7374] = {.count = 1, .reusable = true}, SHIFT(4373),
  [7376] = {.count = 1, .reusable = true}, SHIFT(4383),
  [7378] = {.count = 1, .reusable = true}, SHIFT(4385),
  [7380] = {.count = 1, .reusable = true}, SHIFT(4386),
  [7382] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4),
  [7384] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4),
  [7386] = {.count = 1, .reusable = true}, SHIFT(4387),
  [7388] = {.count = 1, .reusable = true}, SHIFT(4388),
  [7390] = {.count = 1, .reusable = true}, SHIFT(4390),
  [7392] = {.count = 1, .reusable = true}, SHIFT(4395),
  [7394] = {.count = 1, .reusable = false}, SHIFT(4396),
  [7396] = {.count = 1, .reusable = false}, SHIFT(4397),
  [7398] = {.count = 1, .reusable = false}, SHIFT(4399),
  [7400] = {.count = 1, .reusable = true}, SHIFT(4400),
  [7402] = {.count = 1, .reusable = false}, SHIFT(4401),
  [7404] = {.count = 1, .reusable = true}, SHIFT(4402),
  [7406] = {.count = 1, .reusable = true}, SHIFT(4398),
  [7408] = {.count = 1, .reusable = false}, SHIFT(4403),
  [7410] = {.count = 1, .reusable = false}, SHIFT(4404),
  [7412] = {.count = 1, .reusable = true}, SHIFT(4399),
  [7414] = {.count = 1, .reusable = false}, SHIFT(4398),
  [7416] = {.count = 1, .reusable = true}, SHIFT(4397),
  [7418] = {.count = 1, .reusable = false}, SHIFT(4405),
  [7420] = {.count = 1, .reusable = false}, SHIFT(4402),
  [7422] = {.count = 1, .reusable = true}, SHIFT(4403),
  [7424] = {.count = 1, .reusable = true}, SHIFT(4396),
  [7426] = {.count = 1, .reusable = true}, SHIFT(527),
  [7428] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [7430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(542),
  [7433] = {.count = 1, .reusable = false}, SHIFT(1954),
  [7435] = {.count = 1, .reusable = false}, SHIFT(4428),
  [7437] = {.count = 1, .reusable = true}, SHIFT(4430),
  [7439] = {.count = 1, .reusable = false}, SHIFT(4439),
  [7441] = {.count = 1, .reusable = true}, SHIFT(4436),
  [7443] = {.count = 1, .reusable = false}, SHIFT(4438),
  [7445] = {.count = 1, .reusable = false}, SHIFT(4434),
  [7447] = {.count = 1, .reusable = false}, SHIFT(4435),
  [7449] = {.count = 1, .reusable = true}, SHIFT(4435),
  [7451] = {.count = 1, .reusable = false}, SHIFT(4437),
  [7453] = {.count = 1, .reusable = true}, SHIFT(4438),
  [7455] = {.count = 1, .reusable = false}, SHIFT(4433),
  [7457] = {.count = 1, .reusable = true}, SHIFT(4446),
  [7459] = {.count = 1, .reusable = true}, SHIFT(4449),
  [7461] = {.count = 1, .reusable = false}, SHIFT(4450),
  [7463] = {.count = 1, .reusable = false}, SHIFT(4451),
  [7465] = {.count = 1, .reusable = true}, SHIFT(4452),
  [7467] = {.count = 1, .reusable = true}, SHIFT(4453),
  [7469] = {.count = 1, .reusable = true}, SHIFT(4455),
  [7471] = {.count = 1, .reusable = true}, SHIFT(4456),
  [7473] = {.count = 1, .reusable = true}, SHIFT(4454),
  [7475] = {.count = 1, .reusable = false}, SHIFT(4458),
  [7477] = {.count = 1, .reusable = true}, SHIFT(4457),
  [7479] = {.count = 1, .reusable = false}, SHIFT(4454),
  [7481] = {.count = 1, .reusable = true}, SHIFT(4451),
  [7483] = {.count = 1, .reusable = false}, SHIFT(4459),
  [7485] = {.count = 1, .reusable = false}, SHIFT(4456),
  [7487] = {.count = 1, .reusable = true}, SHIFT(4459),
  [7489] = {.count = 1, .reusable = true}, SHIFT(4450),
  [7491] = {.count = 1, .reusable = false}, SHIFT(4430),
  [7493] = {.count = 1, .reusable = true}, SHIFT(4465),
  [7495] = {.count = 1, .reusable = true}, SHIFT(4464),
  [7497] = {.count = 1, .reusable = false}, SHIFT(4468),
  [7499] = {.count = 1, .reusable = true}, SHIFT(4468),
  [7501] = {.count = 1, .reusable = true}, SHIFT(4469),
  [7503] = {.count = 1, .reusable = true}, SHIFT(4470),
  [7505] = {.count = 1, .reusable = true}, SHIFT(4473),
  [7507] = {.count = 1, .reusable = true}, SHIFT(4476),
  [7509] = {.count = 1, .reusable = false}, SHIFT(4477),
  [7511] = {.count = 1, .reusable = true}, SHIFT(4474),
  [7513] = {.count = 1, .reusable = false}, SHIFT(4475),
  [7515] = {.count = 1, .reusable = true}, SHIFT(4475),
  [7517] = {.count = 1, .reusable = true}, SHIFT(4477),
  [7519] = {.count = 1, .reusable = false}, SHIFT(1982),
  [7521] = {.count = 1, .reusable = false}, SHIFT(4484),
  [7523] = {.count = 1, .reusable = true}, SHIFT(4486),
  [7525] = {.count = 1, .reusable = false}, SHIFT(4496),
  [7527] = {.count = 1, .reusable = false}, SHIFT(4493),
  [7529] = {.count = 1, .reusable = true}, SHIFT(4490),
  [7531] = {.count = 1, .reusable = false}, SHIFT(4492),
  [7533] = {.count = 1, .reusable = false}, SHIFT(4497),
  [7535] = {.count = 1, .reusable = false}, SHIFT(4488),
  [7537] = {.count = 1, .reusable = true}, SHIFT(4496),
  [7539] = {.count = 1, .reusable = false}, SHIFT(4489),
  [7541] = {.count = 1, .reusable = true}, SHIFT(4497),
  [7543] = {.count = 1, .reusable = true}, SHIFT(4489),
  [7545] = {.count = 1, .reusable = false}, SHIFT(4491),
  [7547] = {.count = 1, .reusable = true}, SHIFT(4492),
  [7549] = {.count = 1, .reusable = false}, SHIFT(4487),
  [7551] = {.count = 1, .reusable = true}, SHIFT(4502),
  [7553] = {.count = 1, .reusable = true}, SHIFT(4503),
  [7555] = {.count = 1, .reusable = true}, SHIFT(4506),
  [7557] = {.count = 1, .reusable = false}, SHIFT(4502),
  [7559] = {.count = 1, .reusable = false}, SHIFT(4508),
  [7561] = {.count = 1, .reusable = true}, SHIFT(4510),
  [7563] = {.count = 1, .reusable = false}, SHIFT(4511),
  [7565] = {.count = 1, .reusable = true}, SHIFT(4508),
  [7567] = {.count = 1, .reusable = false}, SHIFT(4513),
  [7569] = {.count = 1, .reusable = false}, SHIFT(4514),
  [7571] = {.count = 1, .reusable = false}, SHIFT(4507),
  [7573] = {.count = 1, .reusable = false}, SHIFT(4515),
  [7575] = {.count = 1, .reusable = false}, SHIFT(4512),
  [7577] = {.count = 1, .reusable = true}, SHIFT(4509),
  [7579] = {.count = 1, .reusable = true}, SHIFT(4512),
  [7581] = {.count = 1, .reusable = false}, SHIFT(4510),
  [7583] = {.count = 1, .reusable = true}, SHIFT(4507),
  [7585] = {.count = 1, .reusable = true}, SHIFT(4513),
  [7587] = {.count = 1, .reusable = false}, SHIFT(4486),
  [7589] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [7591] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(551),
  [7594] = {.count = 1, .reusable = false}, SHIFT(4533),
  [7596] = {.count = 1, .reusable = true}, SHIFT(4534),
  [7598] = {.count = 1, .reusable = true}, SHIFT(4538),
  [7600] = {.count = 1, .reusable = false}, SHIFT(4534),
  [7602] = {.count = 1, .reusable = true}, SHIFT(4545),
  [7604] = {.count = 1, .reusable = false}, SHIFT(4546),
  [7606] = {.count = 1, .reusable = false}, SHIFT(4547),
  [7608] = {.count = 1, .reusable = true}, SHIFT(4549),
  [7610] = {.count = 1, .reusable = true}, SHIFT(4550),
  [7612] = {.count = 1, .reusable = true}, SHIFT(4551),
  [7614] = {.count = 1, .reusable = true}, SHIFT(4552),
  [7616] = {.count = 1, .reusable = true}, SHIFT(4548),
  [7618] = {.count = 1, .reusable = false}, SHIFT(4554),
  [7620] = {.count = 1, .reusable = true}, SHIFT(4553),
  [7622] = {.count = 1, .reusable = false}, SHIFT(4548),
  [7624] = {.count = 1, .reusable = true}, SHIFT(4547),
  [7626] = {.count = 1, .reusable = false}, SHIFT(4555),
  [7628] = {.count = 1, .reusable = false}, SHIFT(4552),
  [7630] = {.count = 1, .reusable = true}, SHIFT(4555),
  [7632] = {.count = 1, .reusable = true}, SHIFT(4546),
  [7634] = {.count = 1, .reusable = true}, SHIFT(579),
  [7636] = {.count = 1, .reusable = false}, SHIFT(4574),
  [7638] = {.count = 1, .reusable = true}, SHIFT(4574),
  [7640] = {.count = 1, .reusable = true}, SHIFT(4575),
  [7642] = {.count = 1, .reusable = true}, SHIFT(4576),
  [7644] = {.count = 1, .reusable = true}, SHIFT(4579),
  [7646] = {.count = 1, .reusable = false}, SHIFT(4580),
  [7648] = {.count = 1, .reusable = true}, SHIFT(4581),
  [7650] = {.count = 1, .reusable = true}, SHIFT(4585),
  [7652] = {.count = 1, .reusable = false}, SHIFT(4581),
  [7654] = {.count = 1, .reusable = true}, SHIFT(4589),
  [7656] = {.count = 1, .reusable = true}, SHIFT(4592),
  [7658] = {.count = 1, .reusable = false}, SHIFT(4609),
  [7660] = {.count = 1, .reusable = false}, SHIFT(4605),
  [7662] = {.count = 1, .reusable = false}, SHIFT(4610),
  [7664] = {.count = 1, .reusable = true}, SHIFT(4609),
  [7666] = {.count = 1, .reusable = true}, SHIFT(4594),
  [7668] = {.count = 1, .reusable = false}, SHIFT(4595),
  [7670] = {.count = 1, .reusable = true}, SHIFT(4610),
  [7672] = {.count = 1, .reusable = true}, SHIFT(4596),
  [7674] = {.count = 1, .reusable = false}, SHIFT(4597),
  [7676] = {.count = 1, .reusable = true}, SHIFT(4598),
  [7678] = {.count = 1, .reusable = false}, SHIFT(4599),
  [7680] = {.count = 1, .reusable = true}, SHIFT(4600),
  [7682] = {.count = 1, .reusable = false}, SHIFT(4596),
  [7684] = {.count = 1, .reusable = true}, SHIFT(4601),
  [7686] = {.count = 1, .reusable = false}, SHIFT(4602),
  [7688] = {.count = 1, .reusable = true}, SHIFT(4593),
  [7690] = {.count = 1, .reusable = false}, SHIFT(4603),
  [7692] = {.count = 1, .reusable = false}, SHIFT(4594),
  [7694] = {.count = 1, .reusable = true}, SHIFT(4620),
  [7696] = {.count = 1, .reusable = true}, SHIFT(4614),
  [7698] = {.count = 1, .reusable = true}, SHIFT(4615),
  [7700] = {.count = 1, .reusable = true}, SHIFT(4616),
  [7702] = {.count = 1, .reusable = true}, SHIFT(4617),
  [7704] = {.count = 1, .reusable = true}, SHIFT(4618),
  [7706] = {.count = 1, .reusable = true}, SHIFT(4619),
  [7708] = {.count = 1, .reusable = true}, SHIFT(4622),
  [7710] = {.count = 1, .reusable = false}, SHIFT(4621),
  [7712] = {.count = 1, .reusable = true}, SHIFT(4621),
  [7714] = {.count = 1, .reusable = true}, SHIFT(4623),
  [7716] = {.count = 1, .reusable = false}, SHIFT(4636),
  [7718] = {.count = 1, .reusable = false}, SHIFT(4635),
  [7720] = {.count = 1, .reusable = false}, SHIFT(4638),
  [7722] = {.count = 1, .reusable = true}, SHIFT(4636),
  [7724] = {.count = 1, .reusable = true}, SHIFT(4625),
  [7726] = {.count = 1, .reusable = false}, SHIFT(4626),
  [7728] = {.count = 1, .reusable = true}, SHIFT(4638),
  [7730] = {.count = 1, .reusable = true}, SHIFT(4627),
  [7732] = {.count = 1, .reusable = true}, SHIFT(4628),
  [7734] = {.count = 1, .reusable = false}, SHIFT(4629),
  [7736] = {.count = 1, .reusable = true}, SHIFT(4630),
  [7738] = {.count = 1, .reusable = false}, SHIFT(4627),
  [7740] = {.count = 1, .reusable = true}, SHIFT(4631),
  [7742] = {.count = 1, .reusable = false}, SHIFT(4632),
  [7744] = {.count = 1, .reusable = true}, SHIFT(4624),
  [7746] = {.count = 1, .reusable = false}, SHIFT(4633),
  [7748] = {.count = 1, .reusable = false}, SHIFT(4625),
  [7750] = {.count = 1, .reusable = true}, SHIFT(4644),
  [7752] = {.count = 1, .reusable = false}, SHIFT(4623),
  [7754] = {.count = 1, .reusable = false}, SHIFT(4645),
  [7756] = {.count = 1, .reusable = true}, SHIFT(4648),
  [7758] = {.count = 1, .reusable = true}, SHIFT(4649),
  [7760] = {.count = 1, .reusable = true}, SHIFT(4646),
  [7762] = {.count = 1, .reusable = true}, SHIFT(4650),
  [7764] = {.count = 1, .reusable = true}, SHIFT(4651),
  [7766] = {.count = 1, .reusable = true}, SHIFT(4647),
  [7768] = {.count = 1, .reusable = true}, SHIFT(4652),
  [7770] = {.count = 1, .reusable = false}, SHIFT(4653),
  [7772] = {.count = 1, .reusable = false}, SHIFT(4646),
  [7774] = {.count = 1, .reusable = true}, SHIFT(4645),
  [7776] = {.count = 1, .reusable = false}, SHIFT(4651),
  [7778] = {.count = 1, .reusable = false}, SHIFT(4654),
  [7780] = {.count = 1, .reusable = true}, SHIFT(4654),
  [7782] = {.count = 1, .reusable = true}, REDUCE(sym_then, 2),
  [7784] = {.count = 1, .reusable = true}, SHIFT(4658),
  [7786] = {.count = 1, .reusable = false}, REDUCE(sym_then, 2),
  [7788] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4),
  [7790] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4),
  [7792] = {.count = 1, .reusable = true}, SHIFT(4660),
  [7794] = {.count = 1, .reusable = true}, SHIFT(4661),
  [7796] = {.count = 1, .reusable = true}, SHIFT(4663),
  [7798] = {.count = 1, .reusable = true}, SHIFT(4667),
  [7800] = {.count = 1, .reusable = false}, SHIFT(4668),
  [7802] = {.count = 1, .reusable = false}, SHIFT(4669),
  [7804] = {.count = 1, .reusable = true}, SHIFT(4671),
  [7806] = {.count = 1, .reusable = true}, SHIFT(4672),
  [7808] = {.count = 1, .reusable = true}, SHIFT(4673),
  [7810] = {.count = 1, .reusable = true}, SHIFT(4674),
  [7812] = {.count = 1, .reusable = true}, SHIFT(4670),
  [7814] = {.count = 1, .reusable = false}, SHIFT(4676),
  [7816] = {.count = 1, .reusable = true}, SHIFT(4675),
  [7818] = {.count = 1, .reusable = false}, SHIFT(4670),
  [7820] = {.count = 1, .reusable = true}, SHIFT(4669),
  [7822] = {.count = 1, .reusable = false}, SHIFT(4677),
  [7824] = {.count = 1, .reusable = false}, SHIFT(4674),
  [7826] = {.count = 1, .reusable = true}, SHIFT(4677),
  [7828] = {.count = 1, .reusable = true}, SHIFT(4668),
  [7830] = {.count = 1, .reusable = true}, SHIFT(4678),
  [7832] = {.count = 1, .reusable = true}, SHIFT(4684),
  [7834] = {.count = 1, .reusable = false}, SHIFT(4685),
  [7836] = {.count = 1, .reusable = false}, SHIFT(4688),
  [7838] = {.count = 1, .reusable = true}, SHIFT(4687),
  [7840] = {.count = 1, .reusable = false}, SHIFT(4690),
  [7842] = {.count = 1, .reusable = true}, SHIFT(4688),
  [7844] = {.count = 1, .reusable = false}, SHIFT(4692),
  [7846] = {.count = 1, .reusable = false}, SHIFT(4693),
  [7848] = {.count = 1, .reusable = false}, SHIFT(4686),
  [7850] = {.count = 1, .reusable = false}, SHIFT(4694),
  [7852] = {.count = 1, .reusable = false}, SHIFT(4691),
  [7854] = {.count = 1, .reusable = true}, SHIFT(4689),
  [7856] = {.count = 1, .reusable = true}, SHIFT(4691),
  [7858] = {.count = 1, .reusable = false}, SHIFT(4687),
  [7860] = {.count = 1, .reusable = true}, SHIFT(4686),
  [7862] = {.count = 1, .reusable = true}, SHIFT(4692),
  [7864] = {.count = 1, .reusable = true}, SHIFT(4685),
  [7866] = {.count = 1, .reusable = true}, SHIFT(611),
  [7868] = {.count = 1, .reusable = true}, SHIFT(4714),
  [7870] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [7872] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [7874] = {.count = 1, .reusable = true}, SHIFT(4715),
  [7876] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 12),
  [7878] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 12),
  [7880] = {.count = 1, .reusable = true}, SHIFT(4716),
  [7882] = {.count = 1, .reusable = true}, SHIFT(4717),
  [7884] = {.count = 1, .reusable = true}, SHIFT(4718),
  [7886] = {.count = 1, .reusable = true}, SHIFT(4719),
  [7888] = {.count = 1, .reusable = true}, SHIFT(4721),
  [7890] = {.count = 1, .reusable = true}, SHIFT(4723),
  [7892] = {.count = 1, .reusable = true}, SHIFT(4726),
  [7894] = {.count = 1, .reusable = true}, SHIFT(4725),
  [7896] = {.count = 1, .reusable = true}, SHIFT(4728),
  [7898] = {.count = 1, .reusable = true}, SHIFT(4729),
  [7900] = {.count = 1, .reusable = true}, SHIFT(4731),
  [7902] = {.count = 1, .reusable = true}, SHIFT(4732),
  [7904] = {.count = 1, .reusable = true}, SHIFT(4733),
  [7906] = {.count = 1, .reusable = true}, SHIFT(4735),
  [7908] = {.count = 1, .reusable = true}, SHIFT(4737),
  [7910] = {.count = 1, .reusable = true}, SHIFT(4738),
  [7912] = {.count = 1, .reusable = true}, SHIFT(4742),
  [7914] = {.count = 1, .reusable = false}, SHIFT(4740),
  [7916] = {.count = 1, .reusable = true}, SHIFT(4744),
  [7918] = {.count = 1, .reusable = true}, SHIFT(2189),
  [7920] = {.count = 1, .reusable = true}, SHIFT(4749),
  [7922] = {.count = 1, .reusable = true}, SHIFT(4750),
  [7924] = {.count = 1, .reusable = false}, SHIFT(2198),
  [7926] = {.count = 1, .reusable = true}, SHIFT(2202),
  [7928] = {.count = 1, .reusable = false}, SHIFT(4753),
  [7930] = {.count = 1, .reusable = true}, SHIFT(4755),
  [7932] = {.count = 1, .reusable = true}, SHIFT(4756),
  [7934] = {.count = 1, .reusable = false}, SHIFT(4757),
  [7936] = {.count = 1, .reusable = true}, SHIFT(4758),
  [7938] = {.count = 1, .reusable = true}, SHIFT(4759),
  [7940] = {.count = 1, .reusable = true}, SHIFT(4760),
  [7942] = {.count = 1, .reusable = false}, SHIFT(4776),
  [7944] = {.count = 1, .reusable = false}, SHIFT(4773),
  [7946] = {.count = 1, .reusable = true}, SHIFT(4769),
  [7948] = {.count = 1, .reusable = false}, SHIFT(4771),
  [7950] = {.count = 1, .reusable = false}, SHIFT(4777),
  [7952] = {.count = 1, .reusable = false}, SHIFT(4767),
  [7954] = {.count = 1, .reusable = true}, SHIFT(4776),
  [7956] = {.count = 1, .reusable = false}, SHIFT(4768),
  [7958] = {.count = 1, .reusable = true}, SHIFT(4777),
  [7960] = {.count = 1, .reusable = true}, SHIFT(4768),
  [7962] = {.count = 1, .reusable = false}, SHIFT(4770),
  [7964] = {.count = 1, .reusable = true}, SHIFT(4771),
  [7966] = {.count = 1, .reusable = true}, SHIFT(4772),
  [7968] = {.count = 1, .reusable = false}, SHIFT(4766),
  [7970] = {.count = 1, .reusable = true}, SHIFT(4780),
  [7972] = {.count = 1, .reusable = true}, SHIFT(4785),
  [7974] = {.count = 1, .reusable = true}, SHIFT(4784),
  [7976] = {.count = 1, .reusable = false}, SHIFT(4789),
  [7978] = {.count = 1, .reusable = true}, SHIFT(4788),
  [7980] = {.count = 1, .reusable = false}, SHIFT(4790),
  [7982] = {.count = 1, .reusable = true}, SHIFT(4791),
  [7984] = {.count = 1, .reusable = true}, SHIFT(4792),
  [7986] = {.count = 1, .reusable = true}, SHIFT(4794),
  [7988] = {.count = 1, .reusable = true}, SHIFT(4793),
  [7990] = {.count = 1, .reusable = true}, SHIFT(4795),
  [7992] = {.count = 1, .reusable = false}, SHIFT(4797),
  [7994] = {.count = 1, .reusable = true}, SHIFT(4796),
  [7996] = {.count = 1, .reusable = false}, SHIFT(4793),
  [7998] = {.count = 1, .reusable = true}, SHIFT(4790),
  [8000] = {.count = 1, .reusable = false}, SHIFT(4798),
  [8002] = {.count = 1, .reusable = false}, SHIFT(4795),
  [8004] = {.count = 1, .reusable = true}, SHIFT(4798),
  [8006] = {.count = 1, .reusable = true}, SHIFT(4800),
  [8008] = {.count = 1, .reusable = false}, SHIFT(4799),
  [8010] = {.count = 1, .reusable = true}, SHIFT(4799),
  [8012] = {.count = 1, .reusable = false}, SHIFT(4801),
  [8014] = {.count = 1, .reusable = true}, SHIFT(4802),
  [8016] = {.count = 1, .reusable = true}, SHIFT(4803),
  [8018] = {.count = 1, .reusable = true}, SHIFT(4804),
  [8020] = {.count = 1, .reusable = true}, SHIFT(4789),
  [8022] = {.count = 1, .reusable = false}, SHIFT(4756),
  [8024] = {.count = 1, .reusable = true}, SHIFT(4811),
  [8026] = {.count = 1, .reusable = true}, SHIFT(4812),
  [8028] = {.count = 1, .reusable = true}, SHIFT(4813),
  [8030] = {.count = 1, .reusable = true}, SHIFT(4816),
  [8032] = {.count = 1, .reusable = true}, SHIFT(4817),
  [8034] = {.count = 1, .reusable = true}, SHIFT(4819),
  [8036] = {.count = 1, .reusable = true}, SHIFT(4821),
  [8038] = {.count = 1, .reusable = true}, SHIFT(4823),
  [8040] = {.count = 1, .reusable = false}, SHIFT(4822),
  [8042] = {.count = 1, .reusable = true}, SHIFT(4824),
  [8044] = {.count = 1, .reusable = false}, SHIFT(4827),
  [8046] = {.count = 1, .reusable = true}, SHIFT(4829),
  [8048] = {.count = 1, .reusable = true}, SHIFT(4830),
  [8050] = {.count = 1, .reusable = true}, SHIFT(4833),
  [8052] = {.count = 1, .reusable = true}, SHIFT(4832),
  [8054] = {.count = 1, .reusable = true}, SHIFT(4835),
  [8056] = {.count = 1, .reusable = true}, SHIFT(4836),
  [8058] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [8060] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [8062] = {.count = 1, .reusable = false}, SHIFT(4843),
  [8064] = {.count = 1, .reusable = true}, SHIFT(4843),
  [8066] = {.count = 1, .reusable = true}, SHIFT(4844),
  [8068] = {.count = 1, .reusable = true}, SHIFT(4845),
  [8070] = {.count = 1, .reusable = true}, SHIFT(4848),
  [8072] = {.count = 1, .reusable = true}, SHIFT(4850),
  [8074] = {.count = 1, .reusable = false}, SHIFT(4858),
  [8076] = {.count = 1, .reusable = true}, SHIFT(4855),
  [8078] = {.count = 1, .reusable = false}, SHIFT(4857),
  [8080] = {.count = 1, .reusable = true}, SHIFT(4852),
  [8082] = {.count = 1, .reusable = false}, SHIFT(4853),
  [8084] = {.count = 1, .reusable = false}, SHIFT(4854),
  [8086] = {.count = 1, .reusable = true}, SHIFT(4854),
  [8088] = {.count = 1, .reusable = false}, SHIFT(4856),
  [8090] = {.count = 1, .reusable = true}, SHIFT(4857),
  [8092] = {.count = 1, .reusable = false}, SHIFT(4851),
  [8094] = {.count = 1, .reusable = false}, SHIFT(2260),
  [8096] = {.count = 1, .reusable = true}, SHIFT(4867),
  [8098] = {.count = 1, .reusable = false}, SHIFT(4870),
  [8100] = {.count = 1, .reusable = true}, SHIFT(4874),
  [8102] = {.count = 1, .reusable = false}, SHIFT(4872),
  [8104] = {.count = 1, .reusable = true}, SHIFT(4876),
  [8106] = {.count = 1, .reusable = true}, SHIFT(4881),
  [8108] = {.count = 1, .reusable = false}, SHIFT(4908),
  [8110] = {.count = 1, .reusable = false}, SHIFT(4904),
  [8112] = {.count = 1, .reusable = false}, SHIFT(4878),
  [8114] = {.count = 1, .reusable = false}, SHIFT(4879),
  [8116] = {.count = 1, .reusable = false}, SHIFT(4905),
  [8118] = {.count = 1, .reusable = true}, SHIFT(4889),
  [8120] = {.count = 1, .reusable = false}, SHIFT(4897),
  [8122] = {.count = 1, .reusable = false}, SHIFT(4909),
  [8124] = {.count = 1, .reusable = true}, SHIFT(4882),
  [8126] = {.count = 1, .reusable = false}, SHIFT(4883),
  [8128] = {.count = 1, .reusable = false}, SHIFT(4884),
  [8130] = {.count = 1, .reusable = true}, SHIFT(4891),
  [8132] = {.count = 1, .reusable = true}, SHIFT(4890),
  [8134] = {.count = 1, .reusable = true}, SHIFT(4892),
  [8136] = {.count = 1, .reusable = false}, SHIFT(4885),
  [8138] = {.count = 1, .reusable = true}, SHIFT(4908),
  [8140] = {.count = 1, .reusable = false}, SHIFT(4886),
  [8142] = {.count = 1, .reusable = false}, SHIFT(4887),
  [8144] = {.count = 1, .reusable = false}, SHIFT(4888),
  [8146] = {.count = 1, .reusable = true}, SHIFT(4909),
  [8148] = {.count = 1, .reusable = true}, SHIFT(4893),
  [8150] = {.count = 1, .reusable = true}, SHIFT(4894),
  [8152] = {.count = 1, .reusable = true}, SHIFT(4888),
  [8154] = {.count = 1, .reusable = false}, SHIFT(4895),
  [8156] = {.count = 1, .reusable = false}, SHIFT(4896),
  [8158] = {.count = 1, .reusable = true}, SHIFT(4897),
  [8160] = {.count = 1, .reusable = false}, SHIFT(4898),
  [8162] = {.count = 1, .reusable = false}, SHIFT(4899),
  [8164] = {.count = 1, .reusable = true}, SHIFT(4900),
  [8166] = {.count = 1, .reusable = true}, SHIFT(4901),
  [8168] = {.count = 1, .reusable = true}, SHIFT(4902),
  [8170] = {.count = 1, .reusable = false}, SHIFT(4903),
  [8172] = {.count = 1, .reusable = true}, SHIFT(4880),
  [8174] = {.count = 1, .reusable = false}, SHIFT(4877),
  [8176] = {.count = 1, .reusable = true}, SHIFT(4912),
  [8178] = {.count = 1, .reusable = true}, SHIFT(4916),
  [8180] = {.count = 1, .reusable = true}, SHIFT(2265),
  [8182] = {.count = 1, .reusable = true}, SHIFT(4918),
  [8184] = {.count = 1, .reusable = true}, SHIFT(4919),
  [8186] = {.count = 1, .reusable = true}, SHIFT(4920),
  [8188] = {.count = 1, .reusable = true}, SHIFT(4923),
  [8190] = {.count = 1, .reusable = false}, SHIFT(4918),
  [8192] = {.count = 1, .reusable = false}, SHIFT(4925),
  [8194] = {.count = 1, .reusable = true}, SHIFT(4927),
  [8196] = {.count = 1, .reusable = false}, SHIFT(4928),
  [8198] = {.count = 1, .reusable = true}, SHIFT(4925),
  [8200] = {.count = 1, .reusable = false}, SHIFT(4930),
  [8202] = {.count = 1, .reusable = false}, SHIFT(4931),
  [8204] = {.count = 1, .reusable = false}, SHIFT(4924),
  [8206] = {.count = 1, .reusable = false}, SHIFT(4932),
  [8208] = {.count = 1, .reusable = false}, SHIFT(4929),
  [8210] = {.count = 1, .reusable = true}, SHIFT(4926),
  [8212] = {.count = 1, .reusable = true}, SHIFT(4929),
  [8214] = {.count = 1, .reusable = false}, SHIFT(4927),
  [8216] = {.count = 1, .reusable = true}, SHIFT(4924),
  [8218] = {.count = 1, .reusable = true}, SHIFT(4930),
  [8220] = {.count = 1, .reusable = false}, SHIFT(4876),
  [8222] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 13),
  [8224] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 13),
  [8226] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .alias_sequence_id = 14),
  [8228] = {.count = 1, .reusable = true}, SHIFT(4946),
  [8230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(4947),
  [8233] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [8235] = {.count = 1, .reusable = false}, SHIFT(4948),
  [8237] = {.count = 1, .reusable = false}, SHIFT(4950),
  [8239] = {.count = 1, .reusable = true}, SHIFT(4950),
  [8241] = {.count = 1, .reusable = true}, SHIFT(4952),
  [8243] = {.count = 1, .reusable = true}, SHIFT(4953),
  [8245] = {.count = 1, .reusable = true}, SHIFT(4954),
  [8247] = {.count = 1, .reusable = true}, SHIFT(4956),
  [8249] = {.count = 1, .reusable = true}, SHIFT(4957),
  [8251] = {.count = 1, .reusable = true}, SHIFT(4958),
  [8253] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .alias_sequence_id = 15),
  [8255] = {.count = 1, .reusable = false}, SHIFT(4959),
  [8257] = {.count = 1, .reusable = true}, SHIFT(4961),
  [8259] = {.count = 1, .reusable = true}, SHIFT(4963),
  [8261] = {.count = 1, .reusable = false}, SHIFT(4962),
  [8263] = {.count = 1, .reusable = true}, SHIFT(4962),
  [8265] = {.count = 1, .reusable = true}, SHIFT(4966),
  [8267] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [8269] = {.count = 1, .reusable = true}, SHIFT(4968),
  [8271] = {.count = 1, .reusable = false}, SHIFT(4969),
  [8273] = {.count = 1, .reusable = true}, SHIFT(714),
  [8275] = {.count = 1, .reusable = true}, SHIFT(4973),
  [8277] = {.count = 1, .reusable = true}, SHIFT(4975),
  [8279] = {.count = 1, .reusable = true}, SHIFT(4974),
  [8281] = {.count = 1, .reusable = true}, SHIFT(725),
  [8283] = {.count = 1, .reusable = false}, SHIFT(4994),
  [8285] = {.count = 1, .reusable = true}, SHIFT(4995),
  [8287] = {.count = 1, .reusable = true}, SHIFT(4997),
  [8289] = {.count = 1, .reusable = false}, SHIFT(4998),
  [8291] = {.count = 1, .reusable = false}, SHIFT(4996),
  [8293] = {.count = 1, .reusable = true}, SHIFT(4996),
  [8295] = {.count = 1, .reusable = true}, SHIFT(4998),
  [8297] = {.count = 1, .reusable = true}, SHIFT(5004),
  [8299] = {.count = 1, .reusable = false}, SHIFT(4995),
  [8301] = {.count = 1, .reusable = true}, SHIFT(5007),
  [8303] = {.count = 1, .reusable = true}, SHIFT(5008),
  [8305] = {.count = 1, .reusable = true}, SHIFT(5009),
  [8307] = {.count = 1, .reusable = true}, SHIFT(5012),
  [8309] = {.count = 1, .reusable = true}, SHIFT(5014),
  [8311] = {.count = 1, .reusable = true}, SHIFT(5013),
  [8313] = {.count = 1, .reusable = true}, SHIFT(5016),
  [8315] = {.count = 1, .reusable = true}, SHIFT(5017),
  [8317] = {.count = 1, .reusable = true}, SHIFT(5019),
  [8319] = {.count = 1, .reusable = true}, SHIFT(5020),
  [8321] = {.count = 1, .reusable = true}, SHIFT(5021),
  [8323] = {.count = 1, .reusable = true}, SHIFT(5024),
  [8325] = {.count = 1, .reusable = true}, SHIFT(5027),
  [8327] = {.count = 1, .reusable = false}, SHIFT(5026),
  [8329] = {.count = 1, .reusable = true}, SHIFT(5028),
  [8331] = {.count = 1, .reusable = false}, SHIFT(5031),
  [8333] = {.count = 1, .reusable = true}, SHIFT(5033),
  [8335] = {.count = 1, .reusable = true}, SHIFT(5035),
  [8337] = {.count = 1, .reusable = true}, SHIFT(5034),
  [8339] = {.count = 1, .reusable = true}, SHIFT(5037),
  [8341] = {.count = 1, .reusable = true}, SHIFT(5038),
  [8343] = {.count = 1, .reusable = true}, SHIFT(5040),
  [8345] = {.count = 1, .reusable = true}, SHIFT(5041),
  [8347] = {.count = 1, .reusable = true}, SHIFT(5043),
  [8349] = {.count = 1, .reusable = true}, SHIFT(5045),
  [8351] = {.count = 1, .reusable = true}, SHIFT(5046),
  [8353] = {.count = 1, .reusable = true}, SHIFT(5049),
  [8355] = {.count = 1, .reusable = false}, SHIFT(5047),
  [8357] = {.count = 1, .reusable = true}, SHIFT(5051),
  [8359] = {.count = 1, .reusable = true}, SHIFT(2408),
  [8361] = {.count = 1, .reusable = true}, SHIFT(5056),
  [8363] = {.count = 1, .reusable = true}, SHIFT(5057),
  [8365] = {.count = 1, .reusable = true}, SHIFT(5058),
  [8367] = {.count = 1, .reusable = true}, SHIFT(5061),
  [8369] = {.count = 1, .reusable = false}, SHIFT(5075),
  [8371] = {.count = 1, .reusable = true}, SHIFT(5075),
  [8373] = {.count = 1, .reusable = true}, SHIFT(5076),
  [8375] = {.count = 1, .reusable = true}, SHIFT(5077),
  [8377] = {.count = 1, .reusable = true}, SHIFT(5080),
  [8379] = {.count = 1, .reusable = true}, SHIFT(5082),
  [8381] = {.count = 1, .reusable = true}, SHIFT(5083),
  [8383] = {.count = 1, .reusable = false}, SHIFT(5086),
  [8385] = {.count = 1, .reusable = true}, SHIFT(5089),
  [8387] = {.count = 1, .reusable = false}, SHIFT(5087),
  [8389] = {.count = 1, .reusable = true}, SHIFT(5091),
  [8391] = {.count = 1, .reusable = false}, SHIFT(5101),
  [8393] = {.count = 1, .reusable = false}, SHIFT(5098),
  [8395] = {.count = 1, .reusable = true}, SHIFT(5095),
  [8397] = {.count = 1, .reusable = false}, SHIFT(5097),
  [8399] = {.count = 1, .reusable = false}, SHIFT(5102),
  [8401] = {.count = 1, .reusable = false}, SHIFT(5093),
  [8403] = {.count = 1, .reusable = true}, SHIFT(5101),
  [8405] = {.count = 1, .reusable = false}, SHIFT(5094),
  [8407] = {.count = 1, .reusable = true}, SHIFT(5102),
  [8409] = {.count = 1, .reusable = true}, SHIFT(5094),
  [8411] = {.count = 1, .reusable = false}, SHIFT(5096),
  [8413] = {.count = 1, .reusable = true}, SHIFT(5097),
  [8415] = {.count = 1, .reusable = false}, SHIFT(5092),
  [8417] = {.count = 1, .reusable = true}, SHIFT(5107),
  [8419] = {.count = 1, .reusable = true}, SHIFT(2436),
  [8421] = {.count = 1, .reusable = true}, SHIFT(5109),
  [8423] = {.count = 1, .reusable = false}, SHIFT(5091),
  [8425] = {.count = 1, .reusable = true}, SHIFT(5113),
  [8427] = {.count = 1, .reusable = true}, SHIFT(5116),
  [8429] = {.count = 1, .reusable = true}, SHIFT(5117),
  [8431] = {.count = 1, .reusable = false}, SHIFT(5118),
  [8433] = {.count = 1, .reusable = true}, SHIFT(5119),
  [8435] = {.count = 1, .reusable = false}, SHIFT(5120),
  [8437] = {.count = 1, .reusable = true}, SHIFT(5121),
  [8439] = {.count = 1, .reusable = false}, SHIFT(5124),
  [8441] = {.count = 1, .reusable = true}, SHIFT(5124),
  [8443] = {.count = 1, .reusable = true}, SHIFT(5126),
  [8445] = {.count = 1, .reusable = true}, SHIFT(5127),
  [8447] = {.count = 1, .reusable = true}, SHIFT(5128),
  [8449] = {.count = 1, .reusable = true}, SHIFT(5130),
  [8451] = {.count = 1, .reusable = true}, SHIFT(5131),
  [8453] = {.count = 1, .reusable = true}, SHIFT(5133),
  [8455] = {.count = 1, .reusable = true}, SHIFT(5132),
  [8457] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [8459] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [8461] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5136),
  [8464] = {.count = 1, .reusable = true}, SHIFT(5140),
  [8466] = {.count = 1, .reusable = true}, SHIFT(5141),
  [8468] = {.count = 1, .reusable = true}, SHIFT(5143),
  [8470] = {.count = 1, .reusable = true}, SHIFT(5144),
  [8472] = {.count = 1, .reusable = true}, SHIFT(5145),
  [8474] = {.count = 1, .reusable = true}, SHIFT(5146),
  [8476] = {.count = 1, .reusable = true}, SHIFT(5148),
  [8478] = {.count = 1, .reusable = true}, SHIFT(5150),
  [8480] = {.count = 1, .reusable = true}, SHIFT(5149),
  [8482] = {.count = 1, .reusable = true}, SHIFT(5152),
  [8484] = {.count = 1, .reusable = true}, SHIFT(5153),
  [8486] = {.count = 1, .reusable = true}, SHIFT(5155),
  [8488] = {.count = 1, .reusable = true}, SHIFT(5156),
  [8490] = {.count = 1, .reusable = true}, SHIFT(5158),
  [8492] = {.count = 1, .reusable = true}, SHIFT(5161),
  [8494] = {.count = 1, .reusable = true}, SHIFT(5162),
  [8496] = {.count = 1, .reusable = true}, SHIFT(5165),
  [8498] = {.count = 1, .reusable = false}, SHIFT(5164),
  [8500] = {.count = 1, .reusable = true}, SHIFT(5164),
  [8502] = {.count = 1, .reusable = true}, SHIFT(5168),
  [8504] = {.count = 1, .reusable = true}, SHIFT(5172),
  [8506] = {.count = 1, .reusable = true}, SHIFT(5173),
  [8508] = {.count = 1, .reusable = true}, SHIFT(5174),
  [8510] = {.count = 1, .reusable = true}, SHIFT(5175),
  [8512] = {.count = 1, .reusable = true}, SHIFT(5176),
  [8514] = {.count = 1, .reusable = true}, SHIFT(5179),
  [8516] = {.count = 1, .reusable = true}, SHIFT(5180),
  [8518] = {.count = 1, .reusable = true}, SHIFT(5181),
  [8520] = {.count = 1, .reusable = true}, SHIFT(5183),
  [8522] = {.count = 1, .reusable = true}, SHIFT(5185),
  [8524] = {.count = 1, .reusable = true}, SHIFT(5187),
  [8526] = {.count = 1, .reusable = false}, SHIFT(5186),
  [8528] = {.count = 1, .reusable = true}, SHIFT(5188),
  [8530] = {.count = 1, .reusable = false}, SHIFT(5191),
  [8532] = {.count = 1, .reusable = true}, SHIFT(5193),
  [8534] = {.count = 1, .reusable = true}, SHIFT(5194),
  [8536] = {.count = 1, .reusable = true}, SHIFT(5197),
  [8538] = {.count = 1, .reusable = true}, SHIFT(5196),
  [8540] = {.count = 1, .reusable = true}, SHIFT(5199),
  [8542] = {.count = 1, .reusable = true}, SHIFT(5200),
  [8544] = {.count = 1, .reusable = true}, SHIFT(5206),
  [8546] = {.count = 1, .reusable = true}, SHIFT(5205),
  [8548] = {.count = 1, .reusable = true}, SHIFT(853),
  [8550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(115),
  [8553] = {.count = 1, .reusable = false}, SHIFT(5224),
  [8555] = {.count = 1, .reusable = false}, SHIFT(5226),
  [8557] = {.count = 1, .reusable = true}, SHIFT(5226),
  [8559] = {.count = 1, .reusable = true}, SHIFT(5228),
  [8561] = {.count = 1, .reusable = true}, SHIFT(5229),
  [8563] = {.count = 1, .reusable = true}, SHIFT(5230),
  [8565] = {.count = 1, .reusable = true}, SHIFT(5232),
  [8567] = {.count = 1, .reusable = true}, SHIFT(5233),
  [8569] = {.count = 1, .reusable = true}, SHIFT(5234),
  [8571] = {.count = 1, .reusable = false}, SHIFT(5235),
  [8573] = {.count = 1, .reusable = true}, SHIFT(5237),
  [8575] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [8577] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2609),
  [8580] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [8582] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(885),
  [8585] = {.count = 1, .reusable = true}, SHIFT(5238),
  [8587] = {.count = 1, .reusable = true}, SHIFT(5240),
  [8589] = {.count = 1, .reusable = false}, SHIFT(5239),
  [8591] = {.count = 1, .reusable = true}, SHIFT(5239),
  [8593] = {.count = 1, .reusable = true}, SHIFT(5243),
  [8595] = {.count = 1, .reusable = true}, SHIFT(5245),
  [8597] = {.count = 1, .reusable = false}, SHIFT(5246),
  [8599] = {.count = 1, .reusable = true}, SHIFT(898),
  [8601] = {.count = 1, .reusable = true}, SHIFT(912),
  [8603] = {.count = 1, .reusable = false}, SHIFT(5269),
  [8605] = {.count = 1, .reusable = true}, SHIFT(5269),
  [8607] = {.count = 1, .reusable = true}, SHIFT(5270),
  [8609] = {.count = 1, .reusable = true}, SHIFT(5271),
  [8611] = {.count = 1, .reusable = true}, SHIFT(5274),
  [8613] = {.count = 1, .reusable = true}, SHIFT(5276),
  [8615] = {.count = 1, .reusable = true}, SHIFT(5279),
  [8617] = {.count = 1, .reusable = true}, SHIFT(5280),
  [8619] = {.count = 1, .reusable = false}, SHIFT(5281),
  [8621] = {.count = 1, .reusable = true}, SHIFT(5282),
  [8623] = {.count = 1, .reusable = false}, SHIFT(5283),
  [8625] = {.count = 1, .reusable = true}, SHIFT(5284),
  [8627] = {.count = 1, .reusable = false}, SHIFT(2672),
  [8629] = {.count = 1, .reusable = true}, SHIFT(2676),
  [8631] = {.count = 1, .reusable = false}, SHIFT(5289),
  [8633] = {.count = 1, .reusable = true}, SHIFT(5291),
  [8635] = {.count = 1, .reusable = true}, SHIFT(5292),
  [8637] = {.count = 1, .reusable = false}, SHIFT(5293),
  [8639] = {.count = 1, .reusable = true}, SHIFT(5294),
  [8641] = {.count = 1, .reusable = true}, SHIFT(5295),
  [8643] = {.count = 1, .reusable = true}, SHIFT(5296),
  [8645] = {.count = 1, .reusable = true}, SHIFT(5303),
  [8647] = {.count = 1, .reusable = false}, SHIFT(5304),
  [8649] = {.count = 1, .reusable = false}, SHIFT(5302),
  [8651] = {.count = 1, .reusable = true}, SHIFT(5302),
  [8653] = {.count = 1, .reusable = true}, SHIFT(5304),
  [8655] = {.count = 1, .reusable = true}, SHIFT(5310),
  [8657] = {.count = 1, .reusable = true}, SHIFT(5313),
  [8659] = {.count = 1, .reusable = false}, SHIFT(5314),
  [8661] = {.count = 1, .reusable = false}, SHIFT(5315),
  [8663] = {.count = 1, .reusable = true}, SHIFT(5316),
  [8665] = {.count = 1, .reusable = true}, SHIFT(5317),
  [8667] = {.count = 1, .reusable = true}, SHIFT(5319),
  [8669] = {.count = 1, .reusable = true}, SHIFT(5318),
  [8671] = {.count = 1, .reusable = true}, SHIFT(5320),
  [8673] = {.count = 1, .reusable = true}, SHIFT(5321),
  [8675] = {.count = 1, .reusable = false}, SHIFT(5322),
  [8677] = {.count = 1, .reusable = false}, SHIFT(5318),
  [8679] = {.count = 1, .reusable = true}, SHIFT(5315),
  [8681] = {.count = 1, .reusable = false}, SHIFT(5323),
  [8683] = {.count = 1, .reusable = false}, SHIFT(5320),
  [8685] = {.count = 1, .reusable = true}, SHIFT(5323),
  [8687] = {.count = 1, .reusable = true}, SHIFT(5325),
  [8689] = {.count = 1, .reusable = false}, SHIFT(5324),
  [8691] = {.count = 1, .reusable = true}, SHIFT(5324),
  [8693] = {.count = 1, .reusable = false}, SHIFT(5326),
  [8695] = {.count = 1, .reusable = true}, SHIFT(5327),
  [8697] = {.count = 1, .reusable = true}, SHIFT(5328),
  [8699] = {.count = 1, .reusable = true}, SHIFT(5329),
  [8701] = {.count = 1, .reusable = true}, SHIFT(5314),
  [8703] = {.count = 1, .reusable = false}, SHIFT(5292),
  [8705] = {.count = 1, .reusable = true}, SHIFT(5337),
  [8707] = {.count = 1, .reusable = false}, SHIFT(5350),
  [8709] = {.count = 1, .reusable = true}, SHIFT(5350),
  [8711] = {.count = 1, .reusable = true}, SHIFT(5351),
  [8713] = {.count = 1, .reusable = true}, SHIFT(5352),
  [8715] = {.count = 1, .reusable = true}, SHIFT(5355),
  [8717] = {.count = 1, .reusable = false}, SHIFT(2710),
  [8719] = {.count = 1, .reusable = false}, SHIFT(5358),
  [8721] = {.count = 1, .reusable = true}, SHIFT(5360),
  [8723] = {.count = 1, .reusable = false}, SHIFT(5370),
  [8725] = {.count = 1, .reusable = false}, SHIFT(5367),
  [8727] = {.count = 1, .reusable = true}, SHIFT(5364),
  [8729] = {.count = 1, .reusable = false}, SHIFT(5366),
  [8731] = {.count = 1, .reusable = false}, SHIFT(5371),
  [8733] = {.count = 1, .reusable = false}, SHIFT(5362),
  [8735] = {.count = 1, .reusable = true}, SHIFT(5370),
  [8737] = {.count = 1, .reusable = false}, SHIFT(5363),
  [8739] = {.count = 1, .reusable = true}, SHIFT(5371),
  [8741] = {.count = 1, .reusable = true}, SHIFT(5363),
  [8743] = {.count = 1, .reusable = false}, SHIFT(5365),
  [8745] = {.count = 1, .reusable = true}, SHIFT(5366),
  [8747] = {.count = 1, .reusable = false}, SHIFT(5361),
  [8749] = {.count = 1, .reusable = true}, SHIFT(5376),
  [8751] = {.count = 1, .reusable = true}, SHIFT(5377),
  [8753] = {.count = 1, .reusable = true}, SHIFT(5380),
  [8755] = {.count = 1, .reusable = false}, SHIFT(5376),
  [8757] = {.count = 1, .reusable = false}, SHIFT(5381),
  [8759] = {.count = 1, .reusable = false}, SHIFT(5382),
  [8761] = {.count = 1, .reusable = true}, SHIFT(5383),
  [8763] = {.count = 1, .reusable = false}, SHIFT(5385),
  [8765] = {.count = 1, .reusable = true}, SHIFT(5384),
  [8767] = {.count = 1, .reusable = true}, SHIFT(5386),
  [8769] = {.count = 1, .reusable = false}, SHIFT(5387),
  [8771] = {.count = 1, .reusable = false}, SHIFT(5388),
  [8773] = {.count = 1, .reusable = true}, SHIFT(5382),
  [8775] = {.count = 1, .reusable = false}, SHIFT(5384),
  [8777] = {.count = 1, .reusable = true}, SHIFT(5381),
  [8779] = {.count = 1, .reusable = false}, SHIFT(5389),
  [8781] = {.count = 1, .reusable = false}, SHIFT(5386),
  [8783] = {.count = 1, .reusable = true}, SHIFT(5387),
  [8785] = {.count = 1, .reusable = false}, SHIFT(5360),
  [8787] = {.count = 1, .reusable = false}, SHIFT(5392),
  [8789] = {.count = 1, .reusable = true}, SHIFT(5392),
  [8791] = {.count = 1, .reusable = true}, SHIFT(5394),
  [8793] = {.count = 1, .reusable = true}, SHIFT(5395),
  [8795] = {.count = 1, .reusable = true}, SHIFT(5396),
  [8797] = {.count = 1, .reusable = true}, SHIFT(5398),
  [8799] = {.count = 1, .reusable = true}, SHIFT(5399),
  [8801] = {.count = 1, .reusable = true}, SHIFT(5403),
  [8803] = {.count = 1, .reusable = false}, SHIFT(5404),
  [8805] = {.count = 1, .reusable = false}, SHIFT(5405),
  [8807] = {.count = 1, .reusable = true}, SHIFT(5407),
  [8809] = {.count = 1, .reusable = true}, SHIFT(5408),
  [8811] = {.count = 1, .reusable = true}, SHIFT(5409),
  [8813] = {.count = 1, .reusable = true}, SHIFT(5406),
  [8815] = {.count = 1, .reusable = true}, SHIFT(5410),
  [8817] = {.count = 1, .reusable = true}, SHIFT(5411),
  [8819] = {.count = 1, .reusable = false}, SHIFT(5412),
  [8821] = {.count = 1, .reusable = false}, SHIFT(5406),
  [8823] = {.count = 1, .reusable = true}, SHIFT(5405),
  [8825] = {.count = 1, .reusable = false}, SHIFT(5413),
  [8827] = {.count = 1, .reusable = false}, SHIFT(5410),
  [8829] = {.count = 1, .reusable = true}, SHIFT(5413),
  [8831] = {.count = 1, .reusable = true}, SHIFT(5404),
  [8833] = {.count = 1, .reusable = true}, SHIFT(5415),
  [8835] = {.count = 1, .reusable = true}, SHIFT(5417),
  [8837] = {.count = 1, .reusable = true}, SHIFT(5418),
  [8839] = {.count = 1, .reusable = true}, SHIFT(5420),
  [8841] = {.count = 1, .reusable = true}, SHIFT(5421),
  [8843] = {.count = 1, .reusable = true}, SHIFT(5423),
  [8845] = {.count = 1, .reusable = true}, SHIFT(5422),
  [8847] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 3),
  [8849] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [8851] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [8853] = {.count = 1, .reusable = true}, SHIFT(5425),
  [8855] = {.count = 1, .reusable = true}, SHIFT(5429),
  [8857] = {.count = 1, .reusable = false}, SHIFT(5428),
  [8859] = {.count = 1, .reusable = true}, SHIFT(5428),
  [8861] = {.count = 1, .reusable = true}, SHIFT(5433),
  [8863] = {.count = 1, .reusable = true}, SHIFT(996),
  [8865] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(163),
  [8868] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [8870] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4),
  [8872] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4),
  [8874] = {.count = 1, .reusable = true}, SHIFT(5452),
  [8876] = {.count = 1, .reusable = false}, SHIFT(5455),
  [8878] = {.count = 1, .reusable = true}, SHIFT(5456),
  [8880] = {.count = 1, .reusable = true}, SHIFT(5457),
  [8882] = {.count = 1, .reusable = true}, SHIFT(5458),
  [8884] = {.count = 1, .reusable = true}, SHIFT(5466),
  [8886] = {.count = 1, .reusable = true}, SHIFT(5467),
  [8888] = {.count = 1, .reusable = false}, SHIFT(5468),
  [8890] = {.count = 1, .reusable = false}, SHIFT(5469),
  [8892] = {.count = 1, .reusable = true}, SHIFT(5472),
  [8894] = {.count = 1, .reusable = true}, SHIFT(5473),
  [8896] = {.count = 1, .reusable = true}, SHIFT(5470),
  [8898] = {.count = 1, .reusable = true}, SHIFT(5474),
  [8900] = {.count = 1, .reusable = true}, SHIFT(5475),
  [8902] = {.count = 1, .reusable = true}, SHIFT(5471),
  [8904] = {.count = 1, .reusable = true}, SHIFT(5476),
  [8906] = {.count = 1, .reusable = false}, SHIFT(5477),
  [8908] = {.count = 1, .reusable = false}, SHIFT(5470),
  [8910] = {.count = 1, .reusable = true}, SHIFT(5469),
  [8912] = {.count = 1, .reusable = false}, SHIFT(5475),
  [8914] = {.count = 1, .reusable = false}, SHIFT(5478),
  [8916] = {.count = 1, .reusable = true}, SHIFT(5478),
  [8918] = {.count = 1, .reusable = true}, SHIFT(5480),
  [8920] = {.count = 1, .reusable = false}, SHIFT(5479),
  [8922] = {.count = 1, .reusable = true}, SHIFT(5479),
  [8924] = {.count = 1, .reusable = false}, SHIFT(5481),
  [8926] = {.count = 1, .reusable = true}, SHIFT(5482),
  [8928] = {.count = 1, .reusable = true}, SHIFT(5483),
  [8930] = {.count = 1, .reusable = true}, SHIFT(5484),
  [8932] = {.count = 1, .reusable = true}, SHIFT(5468),
  [8934] = {.count = 1, .reusable = true}, SHIFT(5491),
  [8936] = {.count = 1, .reusable = true}, SHIFT(5493),
  [8938] = {.count = 1, .reusable = true}, SHIFT(5492),
  [8940] = {.count = 1, .reusable = true}, SHIFT(5498),
  [8942] = {.count = 1, .reusable = true}, SHIFT(5499),
  [8944] = {.count = 1, .reusable = true}, SHIFT(5500),
  [8946] = {.count = 1, .reusable = true}, SHIFT(5502),
  [8948] = {.count = 1, .reusable = true}, SHIFT(5503),
  [8950] = {.count = 1, .reusable = false}, SHIFT(5504),
  [8952] = {.count = 1, .reusable = true}, SHIFT(5506),
  [8954] = {.count = 1, .reusable = true}, SHIFT(5509),
  [8956] = {.count = 1, .reusable = false}, SHIFT(5510),
  [8958] = {.count = 1, .reusable = true}, SHIFT(5510),
  [8960] = {.count = 1, .reusable = true}, SHIFT(5512),
  [8962] = {.count = 1, .reusable = false}, SHIFT(5513),
  [8964] = {.count = 1, .reusable = true}, SHIFT(5514),
  [8966] = {.count = 1, .reusable = false}, SHIFT(5515),
  [8968] = {.count = 1, .reusable = true}, SHIFT(5516),
  [8970] = {.count = 1, .reusable = true}, SHIFT(5519),
  [8972] = {.count = 1, .reusable = true}, SHIFT(5520),
  [8974] = {.count = 1, .reusable = true}, SHIFT(5521),
  [8976] = {.count = 1, .reusable = true}, SHIFT(5523),
  [8978] = {.count = 1, .reusable = true}, SHIFT(5524),
  [8980] = {.count = 1, .reusable = true}, SHIFT(5525),
  [8982] = {.count = 1, .reusable = false}, SHIFT(5526),
  [8984] = {.count = 1, .reusable = true}, SHIFT(5528),
  [8986] = {.count = 1, .reusable = true}, SHIFT(5530),
  [8988] = {.count = 1, .reusable = false}, SHIFT(5529),
  [8990] = {.count = 1, .reusable = true}, SHIFT(5529),
  [8992] = {.count = 1, .reusable = true}, SHIFT(5533),
  [8994] = {.count = 1, .reusable = true}, SHIFT(5535),
  [8996] = {.count = 1, .reusable = false}, SHIFT(5536),
  [8998] = {.count = 1, .reusable = true}, SHIFT(1073),
  [9000] = {.count = 1, .reusable = false}, SHIFT(5538),
  [9002] = {.count = 1, .reusable = true}, SHIFT(5538),
  [9004] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 3),
  [9006] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(5540),
  [9009] = {.count = 1, .reusable = true}, SHIFT(5541),
  [9011] = {.count = 1, .reusable = true}, SHIFT(5543),
  [9013] = {.count = 1, .reusable = true}, SHIFT(5544),
  [9015] = {.count = 1, .reusable = false}, SHIFT(5547),
  [9017] = {.count = 1, .reusable = true}, SHIFT(5548),
  [9019] = {.count = 1, .reusable = true}, SHIFT(5552),
  [9021] = {.count = 1, .reusable = false}, SHIFT(5548),
  [9023] = {.count = 1, .reusable = false}, SHIFT(5555),
  [9025] = {.count = 1, .reusable = true}, SHIFT(5556),
  [9027] = {.count = 1, .reusable = true}, SHIFT(5557),
  [9029] = {.count = 1, .reusable = true}, SHIFT(5558),
  [9031] = {.count = 1, .reusable = true}, SHIFT(5566),
  [9033] = {.count = 1, .reusable = true}, SHIFT(5567),
  [9035] = {.count = 1, .reusable = false}, SHIFT(5568),
  [9037] = {.count = 1, .reusable = false}, SHIFT(5569),
  [9039] = {.count = 1, .reusable = true}, SHIFT(5572),
  [9041] = {.count = 1, .reusable = true}, SHIFT(5573),
  [9043] = {.count = 1, .reusable = true}, SHIFT(5570),
  [9045] = {.count = 1, .reusable = true}, SHIFT(5574),
  [9047] = {.count = 1, .reusable = true}, SHIFT(5575),
  [9049] = {.count = 1, .reusable = true}, SHIFT(5571),
  [9051] = {.count = 1, .reusable = true}, SHIFT(5576),
  [9053] = {.count = 1, .reusable = false}, SHIFT(5577),
  [9055] = {.count = 1, .reusable = false}, SHIFT(5570),
  [9057] = {.count = 1, .reusable = true}, SHIFT(5569),
  [9059] = {.count = 1, .reusable = false}, SHIFT(5575),
  [9061] = {.count = 1, .reusable = false}, SHIFT(5578),
  [9063] = {.count = 1, .reusable = true}, SHIFT(5578),
  [9065] = {.count = 1, .reusable = true}, SHIFT(5580),
  [9067] = {.count = 1, .reusable = false}, SHIFT(5579),
  [9069] = {.count = 1, .reusable = true}, SHIFT(5579),
  [9071] = {.count = 1, .reusable = true}, SHIFT(5581),
  [9073] = {.count = 1, .reusable = false}, SHIFT(5582),
  [9075] = {.count = 1, .reusable = true}, SHIFT(5583),
  [9077] = {.count = 1, .reusable = true}, SHIFT(5584),
  [9079] = {.count = 1, .reusable = true}, SHIFT(5585),
  [9081] = {.count = 1, .reusable = true}, SHIFT(5568),
  [9083] = {.count = 1, .reusable = false}, SHIFT(5593),
  [9085] = {.count = 1, .reusable = true}, SHIFT(5593),
  [9087] = {.count = 1, .reusable = true}, SHIFT(5594),
  [9089] = {.count = 1, .reusable = true}, SHIFT(5595),
  [9091] = {.count = 1, .reusable = true}, SHIFT(5598),
  [9093] = {.count = 1, .reusable = false}, SHIFT(2936),
  [9095] = {.count = 1, .reusable = false}, SHIFT(5603),
  [9097] = {.count = 1, .reusable = true}, SHIFT(5605),
  [9099] = {.count = 1, .reusable = true}, SHIFT(5609),
  [9101] = {.count = 1, .reusable = true}, SHIFT(5610),
  [9103] = {.count = 1, .reusable = true}, SHIFT(5613),
  [9105] = {.count = 1, .reusable = false}, SHIFT(5609),
  [9107] = {.count = 1, .reusable = false}, SHIFT(5614),
  [9109] = {.count = 1, .reusable = false}, SHIFT(5615),
  [9111] = {.count = 1, .reusable = true}, SHIFT(5616),
  [9113] = {.count = 1, .reusable = false}, SHIFT(5618),
  [9115] = {.count = 1, .reusable = true}, SHIFT(5617),
  [9117] = {.count = 1, .reusable = true}, SHIFT(5619),
  [9119] = {.count = 1, .reusable = true}, SHIFT(5615),
  [9121] = {.count = 1, .reusable = false}, SHIFT(5620),
  [9123] = {.count = 1, .reusable = false}, SHIFT(5621),
  [9125] = {.count = 1, .reusable = false}, SHIFT(5617),
  [9127] = {.count = 1, .reusable = true}, SHIFT(5614),
  [9129] = {.count = 1, .reusable = false}, SHIFT(5622),
  [9131] = {.count = 1, .reusable = false}, SHIFT(5619),
  [9133] = {.count = 1, .reusable = true}, SHIFT(5620),
  [9135] = {.count = 1, .reusable = false}, SHIFT(5605),
  [9137] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(226),
  [9140] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [9142] = {.count = 1, .reusable = false}, SHIFT(5640),
  [9144] = {.count = 1, .reusable = true}, SHIFT(5643),
  [9146] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [9148] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [9150] = {.count = 1, .reusable = true}, SHIFT(5644),
  [9152] = {.count = 1, .reusable = true}, SHIFT(5645),
  [9154] = {.count = 1, .reusable = true}, SHIFT(5646),
  [9156] = {.count = 1, .reusable = true}, SHIFT(5647),
  [9158] = {.count = 1, .reusable = true}, SHIFT(5648),
  [9160] = {.count = 1, .reusable = true}, SHIFT(5649),
  [9162] = {.count = 1, .reusable = false}, SHIFT(2984),
  [9164] = {.count = 1, .reusable = true}, SHIFT(2988),
  [9166] = {.count = 1, .reusable = false}, SHIFT(5653),
  [9168] = {.count = 1, .reusable = true}, SHIFT(5655),
  [9170] = {.count = 1, .reusable = true}, SHIFT(5656),
  [9172] = {.count = 1, .reusable = false}, SHIFT(5657),
  [9174] = {.count = 1, .reusable = true}, SHIFT(5658),
  [9176] = {.count = 1, .reusable = true}, SHIFT(5659),
  [9178] = {.count = 1, .reusable = true}, SHIFT(5660),
  [9180] = {.count = 1, .reusable = false}, SHIFT(5672),
  [9182] = {.count = 1, .reusable = true}, SHIFT(5669),
  [9184] = {.count = 1, .reusable = false}, SHIFT(5671),
  [9186] = {.count = 1, .reusable = false}, SHIFT(5667),
  [9188] = {.count = 1, .reusable = false}, SHIFT(5668),
  [9190] = {.count = 1, .reusable = true}, SHIFT(5668),
  [9192] = {.count = 1, .reusable = false}, SHIFT(5670),
  [9194] = {.count = 1, .reusable = true}, SHIFT(5671),
  [9196] = {.count = 1, .reusable = false}, SHIFT(5666),
  [9198] = {.count = 1, .reusable = true}, SHIFT(5679),
  [9200] = {.count = 1, .reusable = true}, SHIFT(5682),
  [9202] = {.count = 1, .reusable = false}, SHIFT(5683),
  [9204] = {.count = 1, .reusable = false}, SHIFT(5684),
  [9206] = {.count = 1, .reusable = true}, SHIFT(5685),
  [9208] = {.count = 1, .reusable = true}, SHIFT(5686),
  [9210] = {.count = 1, .reusable = true}, SHIFT(5688),
  [9212] = {.count = 1, .reusable = true}, SHIFT(5689),
  [9214] = {.count = 1, .reusable = true}, SHIFT(5687),
  [9216] = {.count = 1, .reusable = false}, SHIFT(5691),
  [9218] = {.count = 1, .reusable = true}, SHIFT(5690),
  [9220] = {.count = 1, .reusable = false}, SHIFT(5687),
  [9222] = {.count = 1, .reusable = true}, SHIFT(5684),
  [9224] = {.count = 1, .reusable = false}, SHIFT(5692),
  [9226] = {.count = 1, .reusable = false}, SHIFT(5689),
  [9228] = {.count = 1, .reusable = true}, SHIFT(5692),
  [9230] = {.count = 1, .reusable = true}, SHIFT(5694),
  [9232] = {.count = 1, .reusable = false}, SHIFT(5693),
  [9234] = {.count = 1, .reusable = true}, SHIFT(5693),
  [9236] = {.count = 1, .reusable = false}, SHIFT(5695),
  [9238] = {.count = 1, .reusable = true}, SHIFT(5696),
  [9240] = {.count = 1, .reusable = true}, SHIFT(5697),
  [9242] = {.count = 1, .reusable = true}, SHIFT(5698),
  [9244] = {.count = 1, .reusable = true}, SHIFT(5683),
  [9246] = {.count = 1, .reusable = false}, SHIFT(5656),
  [9248] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [9250] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [9252] = {.count = 1, .reusable = false}, SHIFT(5710),
  [9254] = {.count = 1, .reusable = true}, SHIFT(5710),
  [9256] = {.count = 1, .reusable = false}, SHIFT(5712),
  [9258] = {.count = 1, .reusable = true}, SHIFT(5712),
  [9260] = {.count = 1, .reusable = true}, SHIFT(5713),
  [9262] = {.count = 1, .reusable = true}, SHIFT(5714),
  [9264] = {.count = 1, .reusable = true}, SHIFT(5717),
  [9266] = {.count = 1, .reusable = true}, SHIFT(5720),
  [9268] = {.count = 1, .reusable = false}, SHIFT(5721),
  [9270] = {.count = 1, .reusable = true}, SHIFT(5718),
  [9272] = {.count = 1, .reusable = false}, SHIFT(5719),
  [9274] = {.count = 1, .reusable = true}, SHIFT(5719),
  [9276] = {.count = 1, .reusable = true}, SHIFT(5721),
  [9278] = {.count = 1, .reusable = true}, SHIFT(5726),
  [9280] = {.count = 1, .reusable = false}, SHIFT(3018),
  [9282] = {.count = 1, .reusable = false}, SHIFT(5729),
  [9284] = {.count = 1, .reusable = true}, SHIFT(5731),
  [9286] = {.count = 1, .reusable = false}, SHIFT(5741),
  [9288] = {.count = 1, .reusable = false}, SHIFT(5738),
  [9290] = {.count = 1, .reusable = true}, SHIFT(5735),
  [9292] = {.count = 1, .reusable = false}, SHIFT(5737),
  [9294] = {.count = 1, .reusable = false}, SHIFT(5742),
  [9296] = {.count = 1, .reusable = false}, SHIFT(5733),
  [9298] = {.count = 1, .reusable = true}, SHIFT(5741),
  [9300] = {.count = 1, .reusable = false}, SHIFT(5734),
  [9302] = {.count = 1, .reusable = true}, SHIFT(5742),
  [9304] = {.count = 1, .reusable = true}, SHIFT(5734),
  [9306] = {.count = 1, .reusable = false}, SHIFT(5736),
  [9308] = {.count = 1, .reusable = true}, SHIFT(5737),
  [9310] = {.count = 1, .reusable = false}, SHIFT(5732),
  [9312] = {.count = 1, .reusable = true}, SHIFT(5747),
  [9314] = {.count = 1, .reusable = true}, SHIFT(5748),
  [9316] = {.count = 1, .reusable = true}, SHIFT(5751),
  [9318] = {.count = 1, .reusable = false}, SHIFT(5747),
  [9320] = {.count = 1, .reusable = false}, SHIFT(5753),
  [9322] = {.count = 1, .reusable = true}, SHIFT(5755),
  [9324] = {.count = 1, .reusable = false}, SHIFT(5756),
  [9326] = {.count = 1, .reusable = true}, SHIFT(5753),
  [9328] = {.count = 1, .reusable = false}, SHIFT(5758),
  [9330] = {.count = 1, .reusable = false}, SHIFT(5759),
  [9332] = {.count = 1, .reusable = false}, SHIFT(5752),
  [9334] = {.count = 1, .reusable = false}, SHIFT(5760),
  [9336] = {.count = 1, .reusable = false}, SHIFT(5757),
  [9338] = {.count = 1, .reusable = true}, SHIFT(5754),
  [9340] = {.count = 1, .reusable = true}, SHIFT(5757),
  [9342] = {.count = 1, .reusable = false}, SHIFT(5755),
  [9344] = {.count = 1, .reusable = true}, SHIFT(5752),
  [9346] = {.count = 1, .reusable = true}, SHIFT(5758),
  [9348] = {.count = 1, .reusable = false}, SHIFT(5731),
  [9350] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1533),
  [9353] = {.count = 1, .reusable = false}, SHIFT(5775),
  [9355] = {.count = 1, .reusable = true}, SHIFT(5776),
  [9357] = {.count = 1, .reusable = true}, SHIFT(5777),
  [9359] = {.count = 1, .reusable = true}, SHIFT(5778),
  [9361] = {.count = 1, .reusable = true}, SHIFT(5786),
  [9363] = {.count = 1, .reusable = true}, SHIFT(5787),
  [9365] = {.count = 1, .reusable = false}, SHIFT(5788),
  [9367] = {.count = 1, .reusable = false}, SHIFT(5789),
  [9369] = {.count = 1, .reusable = true}, SHIFT(5792),
  [9371] = {.count = 1, .reusable = true}, SHIFT(5793),
  [9373] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3),
  [9375] = {.count = 1, .reusable = true}, SHIFT(5790),
  [9377] = {.count = 1, .reusable = true}, SHIFT(5794),
  [9379] = {.count = 1, .reusable = true}, SHIFT(5795),
  [9381] = {.count = 1, .reusable = true}, SHIFT(5791),
  [9383] = {.count = 1, .reusable = true}, SHIFT(5796),
  [9385] = {.count = 1, .reusable = false}, SHIFT(5797),
  [9387] = {.count = 1, .reusable = false}, SHIFT(5790),
  [9389] = {.count = 1, .reusable = true}, SHIFT(5789),
  [9391] = {.count = 1, .reusable = false}, SHIFT(5795),
  [9393] = {.count = 1, .reusable = false}, SHIFT(5798),
  [9395] = {.count = 1, .reusable = true}, SHIFT(5798),
  [9397] = {.count = 1, .reusable = true}, SHIFT(5800),
  [9399] = {.count = 1, .reusable = false}, SHIFT(5799),
  [9401] = {.count = 1, .reusable = true}, SHIFT(5799),
  [9403] = {.count = 1, .reusable = true}, SHIFT(5801),
  [9405] = {.count = 1, .reusable = true}, SHIFT(5788),
  [9407] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [9409] = {.count = 1, .reusable = true}, SHIFT(5804),
  [9411] = {.count = 1, .reusable = true}, SHIFT(5805),
  [9413] = {.count = 1, .reusable = true}, SHIFT(5806),
  [9415] = {.count = 1, .reusable = true}, SHIFT(5807),
  [9417] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [9419] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [9421] = {.count = 1, .reusable = true}, SHIFT(5809),
  [9423] = {.count = 1, .reusable = false}, SHIFT(5816),
  [9425] = {.count = 1, .reusable = true}, SHIFT(5813),
  [9427] = {.count = 1, .reusable = false}, SHIFT(5815),
  [9429] = {.count = 1, .reusable = false}, SHIFT(5811),
  [9431] = {.count = 1, .reusable = false}, SHIFT(5812),
  [9433] = {.count = 1, .reusable = true}, SHIFT(5812),
  [9435] = {.count = 1, .reusable = false}, SHIFT(5814),
  [9437] = {.count = 1, .reusable = true}, SHIFT(5815),
  [9439] = {.count = 1, .reusable = false}, SHIFT(5810),
  [9441] = {.count = 1, .reusable = true}, SHIFT(5822),
  [9443] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 3),
  [9445] = {.count = 1, .reusable = true}, SHIFT(5825),
  [9447] = {.count = 1, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2),
  [9449] = {.count = 2, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2), SHIFT_REPEAT(1149),
  [9452] = {.count = 1, .reusable = false}, SHIFT(3082),
  [9454] = {.count = 1, .reusable = false}, SHIFT(5828),
  [9456] = {.count = 1, .reusable = true}, SHIFT(5830),
  [9458] = {.count = 1, .reusable = true}, SHIFT(5832),
  [9460] = {.count = 1, .reusable = false}, SHIFT(5833),
  [9462] = {.count = 1, .reusable = false}, SHIFT(5831),
  [9464] = {.count = 1, .reusable = true}, SHIFT(5831),
  [9466] = {.count = 1, .reusable = true}, SHIFT(5833),
  [9468] = {.count = 1, .reusable = true}, SHIFT(5839),
  [9470] = {.count = 1, .reusable = true}, SHIFT(5842),
  [9472] = {.count = 1, .reusable = false}, SHIFT(5843),
  [9474] = {.count = 1, .reusable = false}, SHIFT(5844),
  [9476] = {.count = 1, .reusable = true}, SHIFT(5845),
  [9478] = {.count = 1, .reusable = true}, SHIFT(5846),
  [9480] = {.count = 1, .reusable = true}, SHIFT(5848),
  [9482] = {.count = 1, .reusable = true}, SHIFT(5849),
  [9484] = {.count = 1, .reusable = true}, SHIFT(5847),
  [9486] = {.count = 1, .reusable = true}, SHIFT(5850),
  [9488] = {.count = 1, .reusable = false}, SHIFT(5851),
  [9490] = {.count = 1, .reusable = false}, SHIFT(5847),
  [9492] = {.count = 1, .reusable = true}, SHIFT(5844),
  [9494] = {.count = 1, .reusable = false}, SHIFT(5852),
  [9496] = {.count = 1, .reusable = false}, SHIFT(5849),
  [9498] = {.count = 1, .reusable = true}, SHIFT(5852),
  [9500] = {.count = 1, .reusable = true}, SHIFT(5843),
  [9502] = {.count = 1, .reusable = false}, SHIFT(5830),
  [9504] = {.count = 1, .reusable = true}, SHIFT(5854),
  [9506] = {.count = 1, .reusable = true}, SHIFT(5864),
  [9508] = {.count = 1, .reusable = false}, SHIFT(5868),
  [9510] = {.count = 1, .reusable = true}, SHIFT(5868),
  [9512] = {.count = 1, .reusable = true}, SHIFT(5869),
  [9514] = {.count = 1, .reusable = true}, SHIFT(5870),
  [9516] = {.count = 1, .reusable = true}, SHIFT(5873),
  [9518] = {.count = 1, .reusable = false}, SHIFT(3114),
  [9520] = {.count = 1, .reusable = false}, SHIFT(5876),
  [9522] = {.count = 1, .reusable = true}, SHIFT(5878),
  [9524] = {.count = 1, .reusable = false}, SHIFT(5888),
  [9526] = {.count = 1, .reusable = false}, SHIFT(5885),
  [9528] = {.count = 1, .reusable = true}, SHIFT(5882),
  [9530] = {.count = 1, .reusable = false}, SHIFT(5884),
  [9532] = {.count = 1, .reusable = false}, SHIFT(5889),
  [9534] = {.count = 1, .reusable = false}, SHIFT(5880),
  [9536] = {.count = 1, .reusable = true}, SHIFT(5888),
  [9538] = {.count = 1, .reusable = false}, SHIFT(5881),
  [9540] = {.count = 1, .reusable = true}, SHIFT(5889),
  [9542] = {.count = 1, .reusable = true}, SHIFT(5881),
  [9544] = {.count = 1, .reusable = false}, SHIFT(5883),
  [9546] = {.count = 1, .reusable = true}, SHIFT(5884),
  [9548] = {.count = 1, .reusable = false}, SHIFT(5879),
  [9550] = {.count = 1, .reusable = true}, SHIFT(5894),
  [9552] = {.count = 1, .reusable = true}, SHIFT(5895),
  [9554] = {.count = 1, .reusable = true}, SHIFT(5898),
  [9556] = {.count = 1, .reusable = false}, SHIFT(5894),
  [9558] = {.count = 1, .reusable = false}, SHIFT(5899),
  [9560] = {.count = 1, .reusable = false}, SHIFT(5900),
  [9562] = {.count = 1, .reusable = true}, SHIFT(5901),
  [9564] = {.count = 1, .reusable = false}, SHIFT(5903),
  [9566] = {.count = 1, .reusable = true}, SHIFT(5904),
  [9568] = {.count = 1, .reusable = true}, SHIFT(5902),
  [9570] = {.count = 1, .reusable = false}, SHIFT(5905),
  [9572] = {.count = 1, .reusable = false}, SHIFT(5906),
  [9574] = {.count = 1, .reusable = true}, SHIFT(5900),
  [9576] = {.count = 1, .reusable = false}, SHIFT(5902),
  [9578] = {.count = 1, .reusable = true}, SHIFT(5899),
  [9580] = {.count = 1, .reusable = false}, SHIFT(5907),
  [9582] = {.count = 1, .reusable = false}, SHIFT(5904),
  [9584] = {.count = 1, .reusable = true}, SHIFT(5905),
  [9586] = {.count = 1, .reusable = false}, SHIFT(5878),
  [9588] = {.count = 1, .reusable = false}, SHIFT(5910),
  [9590] = {.count = 1, .reusable = true}, SHIFT(5911),
  [9592] = {.count = 1, .reusable = true}, SHIFT(5916),
  [9594] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 2),
  [9596] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 2),
  [9598] = {.count = 1, .reusable = true}, SHIFT(5917),
  [9600] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3),
  [9602] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3),
  [9604] = {.count = 1, .reusable = true}, SHIFT(5919),
  [9606] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4),
  [9608] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4),
  [9610] = {.count = 1, .reusable = false}, SHIFT(5921),
  [9612] = {.count = 1, .reusable = false}, SHIFT(5923),
  [9614] = {.count = 1, .reusable = true}, SHIFT(5923),
  [9616] = {.count = 1, .reusable = true}, SHIFT(5925),
  [9618] = {.count = 1, .reusable = true}, SHIFT(5926),
  [9620] = {.count = 1, .reusable = true}, SHIFT(5927),
  [9622] = {.count = 1, .reusable = true}, SHIFT(5929),
  [9624] = {.count = 1, .reusable = true}, SHIFT(5930),
  [9626] = {.count = 1, .reusable = true}, SHIFT(5931),
  [9628] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3, .alias_sequence_id = 15),
  [9630] = {.count = 1, .reusable = false}, SHIFT(5932),
  [9632] = {.count = 1, .reusable = true}, SHIFT(5934),
  [9634] = {.count = 1, .reusable = true}, SHIFT(5936),
  [9636] = {.count = 1, .reusable = false}, SHIFT(5935),
  [9638] = {.count = 1, .reusable = true}, SHIFT(5935),
  [9640] = {.count = 1, .reusable = true}, SHIFT(5939),
  [9642] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3),
  [9644] = {.count = 1, .reusable = true}, SHIFT(5941),
  [9646] = {.count = 1, .reusable = false}, SHIFT(5942),
  [9648] = {.count = 1, .reusable = true}, SHIFT(1202),
  [9650] = {.count = 1, .reusable = true}, SHIFT(5946),
  [9652] = {.count = 1, .reusable = true}, SHIFT(5948),
  [9654] = {.count = 1, .reusable = true}, SHIFT(5947),
  [9656] = {.count = 1, .reusable = true}, SHIFT(1210),
  [9658] = {.count = 1, .reusable = true}, SHIFT(5970),
  [9660] = {.count = 1, .reusable = true}, SHIFT(5973),
  [9662] = {.count = 1, .reusable = false}, SHIFT(5976),
  [9664] = {.count = 1, .reusable = true}, SHIFT(5977),
  [9666] = {.count = 1, .reusable = true}, SHIFT(5981),
  [9668] = {.count = 1, .reusable = false}, SHIFT(5977),
  [9670] = {.count = 1, .reusable = true}, SHIFT(5988),
  [9672] = {.count = 1, .reusable = true}, SHIFT(5989),
  [9674] = {.count = 1, .reusable = false}, SHIFT(5990),
  [9676] = {.count = 1, .reusable = false}, SHIFT(5991),
  [9678] = {.count = 1, .reusable = true}, SHIFT(5994),
  [9680] = {.count = 1, .reusable = true}, SHIFT(5995),
  [9682] = {.count = 1, .reusable = true}, SHIFT(5992),
  [9684] = {.count = 1, .reusable = true}, SHIFT(5996),
  [9686] = {.count = 1, .reusable = true}, SHIFT(5997),
  [9688] = {.count = 1, .reusable = true}, SHIFT(5993),
  [9690] = {.count = 1, .reusable = true}, SHIFT(5998),
  [9692] = {.count = 1, .reusable = false}, SHIFT(5999),
  [9694] = {.count = 1, .reusable = false}, SHIFT(5992),
  [9696] = {.count = 1, .reusable = true}, SHIFT(5991),
  [9698] = {.count = 1, .reusable = false}, SHIFT(5997),
  [9700] = {.count = 1, .reusable = false}, SHIFT(6000),
  [9702] = {.count = 1, .reusable = true}, SHIFT(6000),
  [9704] = {.count = 1, .reusable = true}, SHIFT(6002),
  [9706] = {.count = 1, .reusable = false}, SHIFT(6001),
  [9708] = {.count = 1, .reusable = true}, SHIFT(6001),
  [9710] = {.count = 1, .reusable = true}, SHIFT(5990),
  [9712] = {.count = 1, .reusable = true}, SHIFT(6004),
  [9714] = {.count = 1, .reusable = true}, SHIFT(6006),
  [9716] = {.count = 1, .reusable = true}, SHIFT(6009),
  [9718] = {.count = 1, .reusable = false}, SHIFT(6022),
  [9720] = {.count = 1, .reusable = true}, SHIFT(6022),
  [9722] = {.count = 1, .reusable = true}, SHIFT(6023),
  [9724] = {.count = 1, .reusable = true}, SHIFT(6024),
  [9726] = {.count = 1, .reusable = true}, SHIFT(6027),
  [9728] = {.count = 1, .reusable = false}, SHIFT(6028),
  [9730] = {.count = 1, .reusable = true}, SHIFT(6029),
  [9732] = {.count = 1, .reusable = true}, SHIFT(6033),
  [9734] = {.count = 1, .reusable = false}, SHIFT(6029),
  [9736] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 3),
  [9738] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 3),
  [9740] = {.count = 1, .reusable = true}, SHIFT(6037),
  [9742] = {.count = 1, .reusable = false}, SHIFT(6038),
  [9744] = {.count = 1, .reusable = true}, SHIFT(6039),
  [9746] = {.count = 1, .reusable = false}, SHIFT(6040),
  [9748] = {.count = 1, .reusable = true}, SHIFT(6041),
  [9750] = {.count = 1, .reusable = false}, SHIFT(6044),
  [9752] = {.count = 1, .reusable = true}, SHIFT(6044),
  [9754] = {.count = 1, .reusable = true}, SHIFT(6046),
  [9756] = {.count = 1, .reusable = true}, SHIFT(6047),
  [9758] = {.count = 1, .reusable = true}, SHIFT(6048),
  [9760] = {.count = 1, .reusable = true}, SHIFT(6050),
  [9762] = {.count = 1, .reusable = true}, SHIFT(6051),
  [9764] = {.count = 1, .reusable = true}, SHIFT(6052),
  [9766] = {.count = 1, .reusable = true}, SHIFT(6054),
  [9768] = {.count = 1, .reusable = true}, SHIFT(6053),
  [9770] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [9772] = {.count = 1, .reusable = false}, REDUCE(aux_sym_call_repeat1, 2),
  [9774] = {.count = 1, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2),
  [9776] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1280),
  [9779] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [9781] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [9783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1281),
  [9786] = {.count = 1, .reusable = false}, REDUCE(sym_operator_assignment, 3),
  [9788] = {.count = 1, .reusable = false}, REDUCE(sym__arg_or_splat_arg, 1),
  [9790] = {.count = 1, .reusable = true}, SHIFT(6058),
  [9792] = {.count = 1, .reusable = false}, REDUCE(sym_range, 3),
  [9794] = {.count = 1, .reusable = true}, SHIFT(6059),
  [9796] = {.count = 1, .reusable = true}, SHIFT(6061),
  [9798] = {.count = 1, .reusable = true}, SHIFT(6062),
  [9800] = {.count = 1, .reusable = true}, SHIFT(6063),
  [9802] = {.count = 1, .reusable = true}, SHIFT(6067),
  [9804] = {.count = 1, .reusable = false}, SHIFT(6066),
  [9806] = {.count = 1, .reusable = true}, SHIFT(6066),
  [9808] = {.count = 1, .reusable = true}, SHIFT(6071),
  [9810] = {.count = 1, .reusable = true}, SHIFT(6073),
  [9812] = {.count = 1, .reusable = true}, SHIFT(6072),
  [9814] = {.count = 1, .reusable = true}, SHIFT(1305),
  [9816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(273),
  [9819] = {.count = 1, .reusable = false}, SHIFT(6081),
  [9821] = {.count = 1, .reusable = true}, SHIFT(6082),
  [9823] = {.count = 1, .reusable = true}, SHIFT(6086),
  [9825] = {.count = 1, .reusable = false}, SHIFT(6082),
  [9827] = {.count = 1, .reusable = true}, SHIFT(6093),
  [9829] = {.count = 1, .reusable = false}, SHIFT(6094),
  [9831] = {.count = 1, .reusable = false}, SHIFT(6095),
  [9833] = {.count = 1, .reusable = true}, SHIFT(6097),
  [9835] = {.count = 1, .reusable = true}, SHIFT(6098),
  [9837] = {.count = 1, .reusable = true}, SHIFT(6099),
  [9839] = {.count = 1, .reusable = true}, SHIFT(6100),
  [9841] = {.count = 1, .reusable = true}, SHIFT(6096),
  [9843] = {.count = 1, .reusable = true}, SHIFT(6101),
  [9845] = {.count = 1, .reusable = false}, SHIFT(6102),
  [9847] = {.count = 1, .reusable = false}, SHIFT(6096),
  [9849] = {.count = 1, .reusable = true}, SHIFT(6095),
  [9851] = {.count = 1, .reusable = false}, SHIFT(6103),
  [9853] = {.count = 1, .reusable = false}, SHIFT(6100),
  [9855] = {.count = 1, .reusable = true}, SHIFT(6103),
  [9857] = {.count = 1, .reusable = true}, SHIFT(6094),
  [9859] = {.count = 1, .reusable = true}, SHIFT(1324),
  [9861] = {.count = 1, .reusable = true}, SHIFT(6126),
  [9863] = {.count = 1, .reusable = false}, SHIFT(6127),
  [9865] = {.count = 1, .reusable = false}, SHIFT(6128),
  [9867] = {.count = 1, .reusable = true}, SHIFT(6131),
  [9869] = {.count = 1, .reusable = true}, SHIFT(6132),
  [9871] = {.count = 1, .reusable = true}, SHIFT(6133),
  [9873] = {.count = 1, .reusable = true}, SHIFT(6134),
  [9875] = {.count = 1, .reusable = true}, SHIFT(6129),
  [9877] = {.count = 1, .reusable = true}, SHIFT(6135),
  [9879] = {.count = 1, .reusable = false}, SHIFT(6136),
  [9881] = {.count = 1, .reusable = false}, SHIFT(6129),
  [9883] = {.count = 1, .reusable = true}, SHIFT(6128),
  [9885] = {.count = 1, .reusable = false}, SHIFT(6137),
  [9887] = {.count = 1, .reusable = false}, SHIFT(6134),
  [9889] = {.count = 1, .reusable = true}, SHIFT(6137),
  [9891] = {.count = 1, .reusable = true}, SHIFT(6127),
  [9893] = {.count = 1, .reusable = true}, SHIFT(6138),
  [9895] = {.count = 1, .reusable = true}, SHIFT(6140),
  [9897] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [9899] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [9901] = {.count = 1, .reusable = true}, SHIFT(6141),
  [9903] = {.count = 1, .reusable = false}, SHIFT(6144),
  [9905] = {.count = 1, .reusable = true}, SHIFT(6145),
  [9907] = {.count = 1, .reusable = true}, SHIFT(6146),
  [9909] = {.count = 1, .reusable = true}, SHIFT(6147),
  [9911] = {.count = 1, .reusable = true}, SHIFT(6156),
  [9913] = {.count = 1, .reusable = true}, SHIFT(6157),
  [9915] = {.count = 1, .reusable = false}, SHIFT(6158),
  [9917] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [9919] = {.count = 1, .reusable = false}, SHIFT(6159),
  [9921] = {.count = 1, .reusable = true}, SHIFT(6162),
  [9923] = {.count = 1, .reusable = true}, SHIFT(6163),
  [9925] = {.count = 1, .reusable = true}, SHIFT(6160),
  [9927] = {.count = 1, .reusable = true}, SHIFT(6164),
  [9929] = {.count = 1, .reusable = true}, SHIFT(6165),
  [9931] = {.count = 1, .reusable = true}, SHIFT(6161),
  [9933] = {.count = 1, .reusable = true}, SHIFT(6166),
  [9935] = {.count = 1, .reusable = false}, SHIFT(6167),
  [9937] = {.count = 1, .reusable = false}, SHIFT(6160),
  [9939] = {.count = 1, .reusable = true}, SHIFT(6159),
  [9941] = {.count = 1, .reusable = false}, SHIFT(6165),
  [9943] = {.count = 1, .reusable = false}, SHIFT(6168),
  [9945] = {.count = 1, .reusable = true}, SHIFT(6168),
  [9947] = {.count = 1, .reusable = true}, SHIFT(6170),
  [9949] = {.count = 1, .reusable = false}, SHIFT(6169),
  [9951] = {.count = 1, .reusable = true}, SHIFT(6169),
  [9953] = {.count = 1, .reusable = true}, SHIFT(6171),
  [9955] = {.count = 1, .reusable = true}, SHIFT(6172),
  [9957] = {.count = 1, .reusable = true}, SHIFT(6174),
  [9959] = {.count = 1, .reusable = true}, SHIFT(6173),
  [9961] = {.count = 1, .reusable = false}, SHIFT(6177),
  [9963] = {.count = 1, .reusable = true}, SHIFT(6178),
  [9965] = {.count = 1, .reusable = true}, SHIFT(6179),
  [9967] = {.count = 1, .reusable = true}, SHIFT(6180),
  [9969] = {.count = 1, .reusable = true}, SHIFT(6158),
  [9971] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2),
  [9973] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat2, 2), SHIFT_REPEAT(1349),
  [9976] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [9978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(3423),
  [9981] = {.count = 1, .reusable = false}, SHIFT(6190),
  [9983] = {.count = 1, .reusable = true}, SHIFT(6191),
  [9985] = {.count = 1, .reusable = true}, SHIFT(6195),
  [9987] = {.count = 1, .reusable = false}, SHIFT(6191),
  [9989] = {.count = 1, .reusable = true}, SHIFT(6202),
  [9991] = {.count = 1, .reusable = false}, SHIFT(6203),
  [9993] = {.count = 1, .reusable = false}, SHIFT(6204),
  [9995] = {.count = 1, .reusable = true}, SHIFT(6206),
  [9997] = {.count = 1, .reusable = true}, SHIFT(6207),
  [9999] = {.count = 1, .reusable = true}, SHIFT(6209),
  [10001] = {.count = 1, .reusable = true}, SHIFT(6208),
  [10003] = {.count = 1, .reusable = true}, SHIFT(6205),
  [10005] = {.count = 1, .reusable = false}, SHIFT(6211),
  [10007] = {.count = 1, .reusable = true}, SHIFT(6210),
  [10009] = {.count = 1, .reusable = false}, SHIFT(6205),
  [10011] = {.count = 1, .reusable = true}, SHIFT(6204),
  [10013] = {.count = 1, .reusable = false}, SHIFT(6212),
  [10015] = {.count = 1, .reusable = false}, SHIFT(6209),
  [10017] = {.count = 1, .reusable = true}, SHIFT(6212),
  [10019] = {.count = 1, .reusable = true}, SHIFT(6203),
  [10021] = {.count = 1, .reusable = true}, SHIFT(1371),
  [10023] = {.count = 1, .reusable = false}, SHIFT(6231),
  [10025] = {.count = 1, .reusable = true}, SHIFT(6231),
  [10027] = {.count = 1, .reusable = true}, SHIFT(6232),
  [10029] = {.count = 1, .reusable = true}, SHIFT(6233),
  [10031] = {.count = 1, .reusable = true}, SHIFT(6236),
  [10033] = {.count = 1, .reusable = false}, SHIFT(6237),
  [10035] = {.count = 1, .reusable = true}, SHIFT(6238),
  [10037] = {.count = 1, .reusable = true}, SHIFT(6242),
  [10039] = {.count = 1, .reusable = false}, SHIFT(6238),
  [10041] = {.count = 1, .reusable = false}, SHIFT(6246),
  [10043] = {.count = 1, .reusable = true}, SHIFT(6246),
  [10045] = {.count = 1, .reusable = true}, SHIFT(6247),
  [10047] = {.count = 1, .reusable = true}, SHIFT(6248),
  [10049] = {.count = 1, .reusable = true}, SHIFT(6251),
  [10051] = {.count = 1, .reusable = false}, SHIFT(6254),
  [10053] = {.count = 1, .reusable = true}, SHIFT(6256),
  [10055] = {.count = 1, .reusable = false}, SHIFT(6257),
  [10057] = {.count = 1, .reusable = true}, SHIFT(6258),
  [10059] = {.count = 1, .reusable = true}, SHIFT(6259),
  [10061] = {.count = 1, .reusable = true}, SHIFT(6260),
  [10063] = {.count = 1, .reusable = false}, SHIFT(3483),
  [10065] = {.count = 1, .reusable = false}, SHIFT(6272),
  [10067] = {.count = 1, .reusable = true}, SHIFT(6269),
  [10069] = {.count = 1, .reusable = false}, SHIFT(6271),
  [10071] = {.count = 1, .reusable = false}, SHIFT(6267),
  [10073] = {.count = 1, .reusable = false}, SHIFT(6268),
  [10075] = {.count = 1, .reusable = true}, SHIFT(6268),
  [10077] = {.count = 1, .reusable = false}, SHIFT(6270),
  [10079] = {.count = 1, .reusable = true}, SHIFT(6271),
  [10081] = {.count = 1, .reusable = false}, SHIFT(6266),
  [10083] = {.count = 1, .reusable = true}, SHIFT(6279),
  [10085] = {.count = 1, .reusable = true}, SHIFT(6280),
  [10087] = {.count = 1, .reusable = true}, SHIFT(6283),
  [10089] = {.count = 1, .reusable = false}, SHIFT(6279),
  [10091] = {.count = 1, .reusable = false}, SHIFT(6284),
  [10093] = {.count = 1, .reusable = true}, SHIFT(6285),
  [10095] = {.count = 1, .reusable = true}, SHIFT(6286),
  [10097] = {.count = 1, .reusable = true}, SHIFT(6287),
  [10099] = {.count = 1, .reusable = true}, SHIFT(6288),
  [10101] = {.count = 1, .reusable = true}, SHIFT(6289),
  [10103] = {.count = 1, .reusable = true}, SHIFT(6290),
  [10105] = {.count = 1, .reusable = true}, SHIFT(6291),
  [10107] = {.count = 1, .reusable = false}, SHIFT(6292),
  [10109] = {.count = 1, .reusable = false}, SHIFT(6287),
  [10111] = {.count = 1, .reusable = true}, SHIFT(6284),
  [10113] = {.count = 1, .reusable = false}, SHIFT(6289),
  [10115] = {.count = 1, .reusable = false}, SHIFT(6293),
  [10117] = {.count = 1, .reusable = true}, SHIFT(6293),
  [10119] = {.count = 1, .reusable = false}, SHIFT(6256),
  [10121] = {.count = 1, .reusable = true}, SHIFT(6295),
  [10123] = {.count = 2, .reusable = true}, REDUCE(aux_sym__mlhs_repeat1, 2), SHIFT_REPEAT(6296),
  [10126] = {.count = 1, .reusable = true}, SHIFT(6297),
  [10128] = {.count = 1, .reusable = true}, SHIFT(6299),
  [10130] = {.count = 1, .reusable = true}, SHIFT(6303),
  [10132] = {.count = 1, .reusable = false}, SHIFT(6304),
  [10134] = {.count = 1, .reusable = false}, SHIFT(6305),
  [10136] = {.count = 1, .reusable = true}, SHIFT(6307),
  [10138] = {.count = 1, .reusable = true}, SHIFT(6308),
  [10140] = {.count = 1, .reusable = true}, SHIFT(6310),
  [10142] = {.count = 1, .reusable = true}, SHIFT(6309),
  [10144] = {.count = 1, .reusable = true}, SHIFT(6306),
  [10146] = {.count = 1, .reusable = false}, SHIFT(6312),
  [10148] = {.count = 1, .reusable = true}, SHIFT(6311),
  [10150] = {.count = 1, .reusable = false}, SHIFT(6306),
  [10152] = {.count = 1, .reusable = true}, SHIFT(6305),
  [10154] = {.count = 1, .reusable = false}, SHIFT(6313),
  [10156] = {.count = 1, .reusable = false}, SHIFT(6310),
  [10158] = {.count = 1, .reusable = true}, SHIFT(6313),
  [10160] = {.count = 1, .reusable = true}, SHIFT(6304),
  [10162] = {.count = 1, .reusable = true}, SHIFT(6314),
  [10164] = {.count = 1, .reusable = true}, SHIFT(6320),
  [10166] = {.count = 1, .reusable = false}, SHIFT(6321),
  [10168] = {.count = 1, .reusable = false}, SHIFT(6324),
  [10170] = {.count = 1, .reusable = true}, SHIFT(6323),
  [10172] = {.count = 1, .reusable = false}, SHIFT(6326),
  [10174] = {.count = 1, .reusable = true}, SHIFT(6324),
  [10176] = {.count = 1, .reusable = false}, SHIFT(6328),
  [10178] = {.count = 1, .reusable = false}, SHIFT(6329),
  [10180] = {.count = 1, .reusable = false}, SHIFT(6322),
  [10182] = {.count = 1, .reusable = false}, SHIFT(6330),
  [10184] = {.count = 1, .reusable = false}, SHIFT(6327),
  [10186] = {.count = 1, .reusable = true}, SHIFT(6325),
  [10188] = {.count = 1, .reusable = true}, SHIFT(6327),
  [10190] = {.count = 1, .reusable = false}, SHIFT(6323),
  [10192] = {.count = 1, .reusable = true}, SHIFT(6322),
  [10194] = {.count = 1, .reusable = true}, SHIFT(6328),
  [10196] = {.count = 1, .reusable = true}, SHIFT(6321),
  [10198] = {.count = 1, .reusable = true}, SHIFT(1407),
  [10200] = {.count = 1, .reusable = true}, SHIFT(6350),
  [10202] = {.count = 1, .reusable = false}, SHIFT(6351),
  [10204] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [10206] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4),
  [10208] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4),
  [10210] = {.count = 1, .reusable = false}, SHIFT(6352),
  [10212] = {.count = 1, .reusable = true}, SHIFT(6353),
  [10214] = {.count = 1, .reusable = true}, SHIFT(6355),
  [10216] = {.count = 1, .reusable = false}, SHIFT(6358),
  [10218] = {.count = 1, .reusable = true}, SHIFT(6359),
  [10220] = {.count = 1, .reusable = true}, SHIFT(6363),
  [10222] = {.count = 1, .reusable = false}, SHIFT(6359),
  [10224] = {.count = 1, .reusable = true}, SHIFT(6368),
  [10226] = {.count = 1, .reusable = false}, SHIFT(6369),
  [10228] = {.count = 1, .reusable = false}, SHIFT(6370),
  [10230] = {.count = 1, .reusable = true}, SHIFT(6373),
  [10232] = {.count = 1, .reusable = true}, SHIFT(6374),
  [10234] = {.count = 1, .reusable = true}, SHIFT(6371),
  [10236] = {.count = 1, .reusable = true}, SHIFT(6375),
  [10238] = {.count = 1, .reusable = true}, SHIFT(6376),
  [10240] = {.count = 1, .reusable = true}, SHIFT(6372),
  [10242] = {.count = 1, .reusable = true}, SHIFT(6377),
  [10244] = {.count = 1, .reusable = false}, SHIFT(6378),
  [10246] = {.count = 1, .reusable = false}, SHIFT(6371),
  [10248] = {.count = 1, .reusable = true}, SHIFT(6370),
  [10250] = {.count = 1, .reusable = false}, SHIFT(6376),
  [10252] = {.count = 1, .reusable = false}, SHIFT(6379),
  [10254] = {.count = 1, .reusable = true}, SHIFT(6379),
  [10256] = {.count = 1, .reusable = true}, SHIFT(6369),
  [10258] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [10260] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [10262] = {.count = 1, .reusable = true}, SHIFT(6400),
  [10264] = {.count = 1, .reusable = false}, SHIFT(3634),
  [10266] = {.count = 1, .reusable = false}, SHIFT(6402),
  [10268] = {.count = 1, .reusable = true}, SHIFT(6404),
  [10270] = {.count = 1, .reusable = true}, SHIFT(6408),
  [10272] = {.count = 1, .reusable = true}, SHIFT(6411),
  [10274] = {.count = 1, .reusable = false}, SHIFT(6412),
  [10276] = {.count = 1, .reusable = false}, SHIFT(6413),
  [10278] = {.count = 1, .reusable = true}, SHIFT(6414),
  [10280] = {.count = 1, .reusable = true}, SHIFT(6415),
  [10282] = {.count = 1, .reusable = true}, SHIFT(6417),
  [10284] = {.count = 1, .reusable = true}, SHIFT(6418),
  [10286] = {.count = 1, .reusable = true}, SHIFT(6416),
  [10288] = {.count = 1, .reusable = true}, SHIFT(6419),
  [10290] = {.count = 1, .reusable = false}, SHIFT(6420),
  [10292] = {.count = 1, .reusable = false}, SHIFT(6416),
  [10294] = {.count = 1, .reusable = true}, SHIFT(6413),
  [10296] = {.count = 1, .reusable = false}, SHIFT(6421),
  [10298] = {.count = 1, .reusable = false}, SHIFT(6418),
  [10300] = {.count = 1, .reusable = true}, SHIFT(6421),
  [10302] = {.count = 1, .reusable = true}, SHIFT(6412),
  [10304] = {.count = 1, .reusable = false}, SHIFT(6404),
  [10306] = {.count = 1, .reusable = true}, SHIFT(6422),
  [10308] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [10310] = {.count = 1, .reusable = true}, SHIFT(6423),
  [10312] = {.count = 1, .reusable = true}, SHIFT(6424),
  [10314] = {.count = 1, .reusable = true}, SHIFT(6425),
  [10316] = {.count = 1, .reusable = false}, SHIFT(6426),
  [10318] = {.count = 1, .reusable = true}, SHIFT(6427),
  [10320] = {.count = 1, .reusable = true}, SHIFT(6428),
  [10322] = {.count = 1, .reusable = false}, SHIFT(6429),
  [10324] = {.count = 1, .reusable = true}, SHIFT(6430),
  [10326] = {.count = 1, .reusable = true}, SHIFT(6431),
  [10328] = {.count = 1, .reusable = false}, SHIFT(6432),
  [10330] = {.count = 1, .reusable = true}, SHIFT(6433),
  [10332] = {.count = 1, .reusable = false}, SHIFT(6430),
  [10334] = {.count = 1, .reusable = true}, SHIFT(6434),
  [10336] = {.count = 1, .reusable = true}, SHIFT(6435),
  [10338] = {.count = 1, .reusable = false}, SHIFT(6436),
  [10340] = {.count = 1, .reusable = true}, SHIFT(6426),
  [10342] = {.count = 1, .reusable = false}, SHIFT(6437),
  [10344] = {.count = 1, .reusable = true}, SHIFT(6438),
  [10346] = {.count = 1, .reusable = false}, SHIFT(6439),
  [10348] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3),
  [10350] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3),
  [10352] = {.count = 1, .reusable = true}, SHIFT(6450),
  [10354] = {.count = 1, .reusable = false}, SHIFT(6463),
  [10356] = {.count = 1, .reusable = true}, SHIFT(6463),
  [10358] = {.count = 1, .reusable = true}, SHIFT(6464),
  [10360] = {.count = 1, .reusable = true}, SHIFT(6465),
  [10362] = {.count = 1, .reusable = true}, SHIFT(6468),
  [10364] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [10366] = {.count = 1, .reusable = false}, SHIFT(3675),
  [10368] = {.count = 1, .reusable = false}, SHIFT(6473),
  [10370] = {.count = 1, .reusable = true}, SHIFT(6475),
  [10372] = {.count = 1, .reusable = true}, SHIFT(6479),
  [10374] = {.count = 1, .reusable = true}, SHIFT(6480),
  [10376] = {.count = 1, .reusable = true}, SHIFT(6483),
  [10378] = {.count = 1, .reusable = false}, SHIFT(6479),
  [10380] = {.count = 1, .reusable = false}, SHIFT(6484),
  [10382] = {.count = 1, .reusable = false}, SHIFT(6485),
  [10384] = {.count = 1, .reusable = true}, SHIFT(6486),
  [10386] = {.count = 1, .reusable = false}, SHIFT(6488),
  [10388] = {.count = 1, .reusable = true}, SHIFT(6489),
  [10390] = {.count = 1, .reusable = true}, SHIFT(6487),
  [10392] = {.count = 1, .reusable = false}, SHIFT(6490),
  [10394] = {.count = 1, .reusable = false}, SHIFT(6491),
  [10396] = {.count = 1, .reusable = true}, SHIFT(6485),
  [10398] = {.count = 1, .reusable = false}, SHIFT(6487),
  [10400] = {.count = 1, .reusable = true}, SHIFT(6484),
  [10402] = {.count = 1, .reusable = false}, SHIFT(6492),
  [10404] = {.count = 1, .reusable = false}, SHIFT(6489),
  [10406] = {.count = 1, .reusable = true}, SHIFT(6490),
  [10408] = {.count = 1, .reusable = false}, SHIFT(6475),
  [10410] = {.count = 1, .reusable = true}, SHIFT(6495),
  [10412] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [10414] = {.count = 1, .reusable = true}, SHIFT(6498),
  [10416] = {.count = 1, .reusable = false}, SHIFT(3705),
  [10418] = {.count = 1, .reusable = true}, SHIFT(3709),
  [10420] = {.count = 1, .reusable = false}, SHIFT(6501),
  [10422] = {.count = 1, .reusable = true}, SHIFT(6503),
  [10424] = {.count = 1, .reusable = true}, SHIFT(6504),
  [10426] = {.count = 1, .reusable = false}, SHIFT(6505),
  [10428] = {.count = 1, .reusable = true}, SHIFT(6506),
  [10430] = {.count = 1, .reusable = true}, SHIFT(6507),
  [10432] = {.count = 1, .reusable = true}, SHIFT(6508),
  [10434] = {.count = 1, .reusable = false}, SHIFT(6520),
  [10436] = {.count = 1, .reusable = true}, SHIFT(6517),
  [10438] = {.count = 1, .reusable = false}, SHIFT(6519),
  [10440] = {.count = 1, .reusable = false}, SHIFT(6515),
  [10442] = {.count = 1, .reusable = false}, SHIFT(6516),
  [10444] = {.count = 1, .reusable = true}, SHIFT(6516),
  [10446] = {.count = 1, .reusable = false}, SHIFT(6518),
  [10448] = {.count = 1, .reusable = true}, SHIFT(6519),
  [10450] = {.count = 1, .reusable = false}, SHIFT(6514),
  [10452] = {.count = 1, .reusable = true}, SHIFT(6527),
  [10454] = {.count = 1, .reusable = true}, SHIFT(6530),
  [10456] = {.count = 1, .reusable = false}, SHIFT(6531),
  [10458] = {.count = 1, .reusable = false}, SHIFT(6532),
  [10460] = {.count = 1, .reusable = true}, SHIFT(6533),
  [10462] = {.count = 1, .reusable = true}, SHIFT(6534),
  [10464] = {.count = 1, .reusable = true}, SHIFT(6536),
  [10466] = {.count = 1, .reusable = true}, SHIFT(6537),
  [10468] = {.count = 1, .reusable = true}, SHIFT(6535),
  [10470] = {.count = 1, .reusable = false}, SHIFT(6539),
  [10472] = {.count = 1, .reusable = true}, SHIFT(6538),
  [10474] = {.count = 1, .reusable = false}, SHIFT(6535),
  [10476] = {.count = 1, .reusable = true}, SHIFT(6532),
  [10478] = {.count = 1, .reusable = false}, SHIFT(6540),
  [10480] = {.count = 1, .reusable = false}, SHIFT(6537),
  [10482] = {.count = 1, .reusable = true}, SHIFT(6540),
  [10484] = {.count = 1, .reusable = true}, SHIFT(6542),
  [10486] = {.count = 1, .reusable = false}, SHIFT(6541),
  [10488] = {.count = 1, .reusable = true}, SHIFT(6541),
  [10490] = {.count = 1, .reusable = false}, SHIFT(6543),
  [10492] = {.count = 1, .reusable = true}, SHIFT(6544),
  [10494] = {.count = 1, .reusable = true}, SHIFT(6545),
  [10496] = {.count = 1, .reusable = true}, SHIFT(6546),
  [10498] = {.count = 1, .reusable = true}, SHIFT(6531),
  [10500] = {.count = 1, .reusable = false}, SHIFT(6504),
  [10502] = {.count = 1, .reusable = false}, SHIFT(6558),
  [10504] = {.count = 1, .reusable = true}, SHIFT(6558),
  [10506] = {.count = 1, .reusable = true}, SHIFT(6559),
  [10508] = {.count = 1, .reusable = true}, SHIFT(6560),
  [10510] = {.count = 1, .reusable = true}, SHIFT(6563),
  [10512] = {.count = 1, .reusable = true}, SHIFT(6566),
  [10514] = {.count = 1, .reusable = false}, SHIFT(6567),
  [10516] = {.count = 1, .reusable = true}, SHIFT(6564),
  [10518] = {.count = 1, .reusable = false}, SHIFT(6565),
  [10520] = {.count = 1, .reusable = true}, SHIFT(6565),
  [10522] = {.count = 1, .reusable = true}, SHIFT(6567),
  [10524] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3),
  [10526] = {.count = 1, .reusable = false}, SHIFT(3737),
  [10528] = {.count = 1, .reusable = false}, SHIFT(6574),
  [10530] = {.count = 1, .reusable = true}, SHIFT(6576),
  [10532] = {.count = 1, .reusable = false}, SHIFT(6586),
  [10534] = {.count = 1, .reusable = false}, SHIFT(6583),
  [10536] = {.count = 1, .reusable = true}, SHIFT(6580),
  [10538] = {.count = 1, .reusable = false}, SHIFT(6582),
  [10540] = {.count = 1, .reusable = false}, SHIFT(6587),
  [10542] = {.count = 1, .reusable = false}, SHIFT(6578),
  [10544] = {.count = 1, .reusable = true}, SHIFT(6586),
  [10546] = {.count = 1, .reusable = false}, SHIFT(6579),
  [10548] = {.count = 1, .reusable = true}, SHIFT(6587),
  [10550] = {.count = 1, .reusable = true}, SHIFT(6579),
  [10552] = {.count = 1, .reusable = false}, SHIFT(6581),
  [10554] = {.count = 1, .reusable = true}, SHIFT(6582),
  [10556] = {.count = 1, .reusable = false}, SHIFT(6577),
  [10558] = {.count = 1, .reusable = true}, SHIFT(6592),
  [10560] = {.count = 1, .reusable = true}, SHIFT(6593),
  [10562] = {.count = 1, .reusable = true}, SHIFT(6596),
  [10564] = {.count = 1, .reusable = false}, SHIFT(6592),
  [10566] = {.count = 1, .reusable = false}, SHIFT(6598),
  [10568] = {.count = 1, .reusable = true}, SHIFT(6600),
  [10570] = {.count = 1, .reusable = false}, SHIFT(6601),
  [10572] = {.count = 1, .reusable = true}, SHIFT(6598),
  [10574] = {.count = 1, .reusable = false}, SHIFT(6603),
  [10576] = {.count = 1, .reusable = false}, SHIFT(6604),
  [10578] = {.count = 1, .reusable = false}, SHIFT(6597),
  [10580] = {.count = 1, .reusable = false}, SHIFT(6605),
  [10582] = {.count = 1, .reusable = false}, SHIFT(6602),
  [10584] = {.count = 1, .reusable = true}, SHIFT(6599),
  [10586] = {.count = 1, .reusable = true}, SHIFT(6602),
  [10588] = {.count = 1, .reusable = false}, SHIFT(6600),
  [10590] = {.count = 1, .reusable = true}, SHIFT(6597),
  [10592] = {.count = 1, .reusable = true}, SHIFT(6603),
  [10594] = {.count = 1, .reusable = false}, SHIFT(6576),
  [10596] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3735),
  [10599] = {.count = 1, .reusable = false}, SHIFT(6622),
  [10601] = {.count = 1, .reusable = true}, SHIFT(6623),
  [10603] = {.count = 1, .reusable = true}, SHIFT(6627),
  [10605] = {.count = 1, .reusable = false}, SHIFT(6623),
  [10607] = {.count = 1, .reusable = true}, SHIFT(6634),
  [10609] = {.count = 1, .reusable = false}, SHIFT(6635),
  [10611] = {.count = 1, .reusable = false}, SHIFT(6636),
  [10613] = {.count = 1, .reusable = true}, SHIFT(6638),
  [10615] = {.count = 1, .reusable = true}, SHIFT(6639),
  [10617] = {.count = 1, .reusable = true}, SHIFT(6640),
  [10619] = {.count = 1, .reusable = true}, SHIFT(6641),
  [10621] = {.count = 1, .reusable = true}, SHIFT(6637),
  [10623] = {.count = 1, .reusable = false}, SHIFT(6643),
  [10625] = {.count = 1, .reusable = true}, SHIFT(6642),
  [10627] = {.count = 1, .reusable = false}, SHIFT(6637),
  [10629] = {.count = 1, .reusable = true}, SHIFT(6636),
  [10631] = {.count = 1, .reusable = false}, SHIFT(6644),
  [10633] = {.count = 1, .reusable = false}, SHIFT(6641),
  [10635] = {.count = 1, .reusable = true}, SHIFT(6644),
  [10637] = {.count = 1, .reusable = true}, SHIFT(6635),
  [10639] = {.count = 1, .reusable = true}, SHIFT(1523),
  [10641] = {.count = 1, .reusable = false}, SHIFT(6663),
  [10643] = {.count = 1, .reusable = true}, SHIFT(6663),
  [10645] = {.count = 1, .reusable = true}, SHIFT(6664),
  [10647] = {.count = 1, .reusable = true}, SHIFT(6665),
  [10649] = {.count = 1, .reusable = true}, SHIFT(6668),
  [10651] = {.count = 1, .reusable = false}, SHIFT(6669),
  [10653] = {.count = 1, .reusable = true}, SHIFT(6670),
  [10655] = {.count = 1, .reusable = true}, SHIFT(6674),
  [10657] = {.count = 1, .reusable = false}, SHIFT(6670),
  [10659] = {.count = 1, .reusable = true}, SHIFT(6678),
  [10661] = {.count = 1, .reusable = true}, SHIFT(6680),
  [10663] = {.count = 1, .reusable = true}, SHIFT(6684),
  [10665] = {.count = 1, .reusable = false}, SHIFT(6685),
  [10667] = {.count = 1, .reusable = false}, SHIFT(6686),
  [10669] = {.count = 1, .reusable = true}, SHIFT(6688),
  [10671] = {.count = 1, .reusable = true}, SHIFT(6689),
  [10673] = {.count = 1, .reusable = true}, SHIFT(6690),
  [10675] = {.count = 1, .reusable = true}, SHIFT(6691),
  [10677] = {.count = 1, .reusable = true}, SHIFT(6687),
  [10679] = {.count = 1, .reusable = false}, SHIFT(6693),
  [10681] = {.count = 1, .reusable = true}, SHIFT(6692),
  [10683] = {.count = 1, .reusable = false}, SHIFT(6687),
  [10685] = {.count = 1, .reusable = true}, SHIFT(6686),
  [10687] = {.count = 1, .reusable = false}, SHIFT(6694),
  [10689] = {.count = 1, .reusable = false}, SHIFT(6691),
  [10691] = {.count = 1, .reusable = true}, SHIFT(6694),
  [10693] = {.count = 1, .reusable = true}, SHIFT(6685),
  [10695] = {.count = 1, .reusable = true}, SHIFT(6695),
  [10697] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [10699] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [10701] = {.count = 1, .reusable = true}, SHIFT(6697),
  [10703] = {.count = 1, .reusable = true}, SHIFT(6702),
  [10705] = {.count = 1, .reusable = false}, SHIFT(6703),
  [10707] = {.count = 1, .reusable = false}, SHIFT(6706),
  [10709] = {.count = 1, .reusable = true}, SHIFT(6705),
  [10711] = {.count = 1, .reusable = false}, SHIFT(6708),
  [10713] = {.count = 1, .reusable = true}, SHIFT(6706),
  [10715] = {.count = 1, .reusable = false}, SHIFT(6710),
  [10717] = {.count = 1, .reusable = false}, SHIFT(6711),
  [10719] = {.count = 1, .reusable = false}, SHIFT(6704),
  [10721] = {.count = 1, .reusable = false}, SHIFT(6712),
  [10723] = {.count = 1, .reusable = false}, SHIFT(6709),
  [10725] = {.count = 1, .reusable = true}, SHIFT(6707),
  [10727] = {.count = 1, .reusable = true}, SHIFT(6709),
  [10729] = {.count = 1, .reusable = false}, SHIFT(6705),
  [10731] = {.count = 1, .reusable = true}, SHIFT(6704),
  [10733] = {.count = 1, .reusable = true}, SHIFT(6710),
  [10735] = {.count = 1, .reusable = true}, SHIFT(6703),
  [10737] = {.count = 1, .reusable = true}, SHIFT(1559),
  [10739] = {.count = 1, .reusable = true}, SHIFT(6732),
  [10741] = {.count = 1, .reusable = true}, SHIFT(6734),
  [10743] = {.count = 1, .reusable = true}, SHIFT(6736),
  [10745] = {.count = 1, .reusable = false}, SHIFT(6739),
  [10747] = {.count = 1, .reusable = true}, SHIFT(6740),
  [10749] = {.count = 1, .reusable = true}, SHIFT(6744),
  [10751] = {.count = 1, .reusable = false}, SHIFT(6740),
  [10753] = {.count = 1, .reusable = false}, SHIFT(6747),
  [10755] = {.count = 1, .reusable = true}, SHIFT(6748),
  [10757] = {.count = 1, .reusable = true}, SHIFT(6749),
  [10759] = {.count = 1, .reusable = true}, SHIFT(6750),
  [10761] = {.count = 1, .reusable = true}, SHIFT(6758),
  [10763] = {.count = 1, .reusable = false}, SHIFT(6759),
  [10765] = {.count = 1, .reusable = false}, SHIFT(6760),
  [10767] = {.count = 1, .reusable = true}, SHIFT(6763),
  [10769] = {.count = 1, .reusable = true}, SHIFT(6764),
  [10771] = {.count = 1, .reusable = true}, SHIFT(6761),
  [10773] = {.count = 1, .reusable = true}, SHIFT(6765),
  [10775] = {.count = 1, .reusable = true}, SHIFT(6766),
  [10777] = {.count = 1, .reusable = true}, SHIFT(6762),
  [10779] = {.count = 1, .reusable = true}, SHIFT(6767),
  [10781] = {.count = 1, .reusable = false}, SHIFT(6768),
  [10783] = {.count = 1, .reusable = false}, SHIFT(6761),
  [10785] = {.count = 1, .reusable = true}, SHIFT(6760),
  [10787] = {.count = 1, .reusable = false}, SHIFT(6766),
  [10789] = {.count = 1, .reusable = false}, SHIFT(6769),
  [10791] = {.count = 1, .reusable = true}, SHIFT(6769),
  [10793] = {.count = 1, .reusable = true}, SHIFT(6759),
  [10795] = {.count = 1, .reusable = true}, SHIFT(6789),
  [10797] = {.count = 1, .reusable = true}, SHIFT(6792),
  [10799] = {.count = 1, .reusable = false}, SHIFT(6809),
  [10801] = {.count = 1, .reusable = false}, SHIFT(6805),
  [10803] = {.count = 1, .reusable = false}, SHIFT(6810),
  [10805] = {.count = 1, .reusable = true}, SHIFT(6809),
  [10807] = {.count = 1, .reusable = true}, SHIFT(6794),
  [10809] = {.count = 1, .reusable = false}, SHIFT(6795),
  [10811] = {.count = 1, .reusable = true}, SHIFT(6810),
  [10813] = {.count = 1, .reusable = true}, SHIFT(6796),
  [10815] = {.count = 1, .reusable = false}, SHIFT(6797),
  [10817] = {.count = 1, .reusable = true}, SHIFT(6798),
  [10819] = {.count = 1, .reusable = false}, SHIFT(6799),
  [10821] = {.count = 1, .reusable = true}, SHIFT(6800),
  [10823] = {.count = 1, .reusable = false}, SHIFT(6796),
  [10825] = {.count = 1, .reusable = true}, SHIFT(6801),
  [10827] = {.count = 1, .reusable = false}, SHIFT(6802),
  [10829] = {.count = 1, .reusable = true}, SHIFT(6793),
  [10831] = {.count = 1, .reusable = false}, SHIFT(6803),
  [10833] = {.count = 1, .reusable = false}, SHIFT(6794),
  [10835] = {.count = 1, .reusable = true}, SHIFT(6820),
  [10837] = {.count = 1, .reusable = true}, SHIFT(6814),
  [10839] = {.count = 1, .reusable = true}, SHIFT(6815),
  [10841] = {.count = 1, .reusable = true}, SHIFT(6816),
  [10843] = {.count = 1, .reusable = true}, SHIFT(6817),
  [10845] = {.count = 1, .reusable = true}, SHIFT(6818),
  [10847] = {.count = 1, .reusable = true}, SHIFT(6819),
  [10849] = {.count = 1, .reusable = true}, SHIFT(6822),
  [10851] = {.count = 1, .reusable = false}, SHIFT(6821),
  [10853] = {.count = 1, .reusable = true}, SHIFT(6821),
  [10855] = {.count = 1, .reusable = true}, SHIFT(6823),
  [10857] = {.count = 1, .reusable = false}, SHIFT(6836),
  [10859] = {.count = 1, .reusable = false}, SHIFT(6835),
  [10861] = {.count = 1, .reusable = false}, SHIFT(6838),
  [10863] = {.count = 1, .reusable = true}, SHIFT(6836),
  [10865] = {.count = 1, .reusable = true}, SHIFT(6825),
  [10867] = {.count = 1, .reusable = false}, SHIFT(6826),
  [10869] = {.count = 1, .reusable = true}, SHIFT(6838),
  [10871] = {.count = 1, .reusable = true}, SHIFT(6827),
  [10873] = {.count = 1, .reusable = true}, SHIFT(6828),
  [10875] = {.count = 1, .reusable = false}, SHIFT(6829),
  [10877] = {.count = 1, .reusable = true}, SHIFT(6830),
  [10879] = {.count = 1, .reusable = false}, SHIFT(6827),
  [10881] = {.count = 1, .reusable = true}, SHIFT(6831),
  [10883] = {.count = 1, .reusable = false}, SHIFT(6832),
  [10885] = {.count = 1, .reusable = true}, SHIFT(6824),
  [10887] = {.count = 1, .reusable = false}, SHIFT(6833),
  [10889] = {.count = 1, .reusable = false}, SHIFT(6825),
  [10891] = {.count = 1, .reusable = true}, SHIFT(6844),
  [10893] = {.count = 1, .reusable = false}, SHIFT(6823),
  [10895] = {.count = 1, .reusable = false}, SHIFT(6845),
  [10897] = {.count = 1, .reusable = true}, SHIFT(6848),
  [10899] = {.count = 1, .reusable = true}, SHIFT(6849),
  [10901] = {.count = 1, .reusable = true}, SHIFT(6846),
  [10903] = {.count = 1, .reusable = true}, SHIFT(6850),
  [10905] = {.count = 1, .reusable = true}, SHIFT(6851),
  [10907] = {.count = 1, .reusable = true}, SHIFT(6847),
  [10909] = {.count = 1, .reusable = true}, SHIFT(6852),
  [10911] = {.count = 1, .reusable = false}, SHIFT(6853),
  [10913] = {.count = 1, .reusable = false}, SHIFT(6846),
  [10915] = {.count = 1, .reusable = true}, SHIFT(6845),
  [10917] = {.count = 1, .reusable = false}, SHIFT(6851),
  [10919] = {.count = 1, .reusable = false}, SHIFT(6854),
  [10921] = {.count = 1, .reusable = true}, SHIFT(6854),
  [10923] = {.count = 1, .reusable = true}, SHIFT(6858),
  [10925] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4),
  [10927] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4),
  [10929] = {.count = 1, .reusable = true}, SHIFT(6860),
  [10931] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [10933] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [10935] = {.count = 1, .reusable = true}, SHIFT(6861),
  [10937] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 16),
  [10939] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 16),
  [10941] = {.count = 1, .reusable = true}, SHIFT(6862),
  [10943] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 17),
  [10945] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 17),
  [10947] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .alias_sequence_id = 18),
  [10949] = {.count = 1, .reusable = true}, SHIFT(6863),
  [10951] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(6864),
  [10954] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [10956] = {.count = 1, .reusable = true}, SHIFT(6865),
  [10958] = {.count = 1, .reusable = true}, SHIFT(6866),
  [10960] = {.count = 1, .reusable = false}, REDUCE(sym_call, 4),
  [10962] = {.count = 1, .reusable = true}, REDUCE(sym_call, 4),
  [10964] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1631),
  [10967] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4),
  [10969] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4),
  [10971] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [10973] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [10975] = {.count = 1, .reusable = false}, SHIFT(6881),
  [10977] = {.count = 1, .reusable = false}, SHIFT(6883),
  [10979] = {.count = 1, .reusable = true}, SHIFT(6883),
  [10981] = {.count = 1, .reusable = true}, SHIFT(6885),
  [10983] = {.count = 1, .reusable = true}, SHIFT(6886),
  [10985] = {.count = 1, .reusable = true}, SHIFT(6887),
  [10987] = {.count = 1, .reusable = true}, SHIFT(6889),
  [10989] = {.count = 1, .reusable = true}, SHIFT(6890),
  [10991] = {.count = 1, .reusable = false}, SHIFT(6891),
  [10993] = {.count = 1, .reusable = true}, SHIFT(6892),
  [10995] = {.count = 1, .reusable = true}, SHIFT(6896),
  [10997] = {.count = 1, .reusable = false}, SHIFT(6892),
  [10999] = {.count = 1, .reusable = true}, SHIFT(6899),
  [11001] = {.count = 1, .reusable = true}, SHIFT(6900),
  [11003] = {.count = 1, .reusable = false}, SHIFT(6901),
  [11005] = {.count = 1, .reusable = true}, SHIFT(6901),
  [11007] = {.count = 1, .reusable = true}, SHIFT(6902),
  [11009] = {.count = 1, .reusable = true}, SHIFT(6903),
  [11011] = {.count = 1, .reusable = true}, SHIFT(6906),
  [11013] = {.count = 1, .reusable = true}, SHIFT(6909),
  [11015] = {.count = 1, .reusable = false}, SHIFT(6910),
  [11017] = {.count = 1, .reusable = true}, SHIFT(6907),
  [11019] = {.count = 1, .reusable = false}, SHIFT(6908),
  [11021] = {.count = 1, .reusable = true}, SHIFT(6908),
  [11023] = {.count = 1, .reusable = true}, SHIFT(6910),
  [11025] = {.count = 1, .reusable = false}, SHIFT(6915),
  [11027] = {.count = 1, .reusable = true}, SHIFT(6916),
  [11029] = {.count = 1, .reusable = true}, SHIFT(6920),
  [11031] = {.count = 1, .reusable = false}, SHIFT(6916),
  [11033] = {.count = 1, .reusable = false}, SHIFT(6935),
  [11035] = {.count = 1, .reusable = true}, SHIFT(6937),
  [11037] = {.count = 1, .reusable = false}, SHIFT(6938),
  [11039] = {.count = 1, .reusable = true}, SHIFT(6938),
  [11041] = {.count = 1, .reusable = true}, SHIFT(6940),
  [11043] = {.count = 1, .reusable = true}, SHIFT(6941),
  [11045] = {.count = 1, .reusable = false}, SHIFT(6942),
  [11047] = {.count = 1, .reusable = true}, SHIFT(1692),
  [11049] = {.count = 1, .reusable = true}, SHIFT(6944),
  [11051] = {.count = 1, .reusable = true}, SHIFT(6945),
  [11053] = {.count = 1, .reusable = true}, SHIFT(6946),
  [11055] = {.count = 1, .reusable = true}, SHIFT(6949),
  [11057] = {.count = 1, .reusable = true}, SHIFT(6951),
  [11059] = {.count = 1, .reusable = true}, SHIFT(6950),
  [11061] = {.count = 1, .reusable = true}, SHIFT(6953),
  [11063] = {.count = 1, .reusable = true}, SHIFT(6954),
  [11065] = {.count = 1, .reusable = true}, SHIFT(6956),
  [11067] = {.count = 1, .reusable = true}, SHIFT(6957),
  [11069] = {.count = 1, .reusable = true}, SHIFT(6958),
  [11071] = {.count = 1, .reusable = true}, SHIFT(6961),
  [11073] = {.count = 1, .reusable = true}, SHIFT(6964),
  [11075] = {.count = 1, .reusable = false}, SHIFT(6963),
  [11077] = {.count = 1, .reusable = true}, SHIFT(6965),
  [11079] = {.count = 1, .reusable = false}, SHIFT(6968),
  [11081] = {.count = 1, .reusable = true}, SHIFT(6970),
  [11083] = {.count = 1, .reusable = true}, SHIFT(6972),
  [11085] = {.count = 1, .reusable = true}, SHIFT(6971),
  [11087] = {.count = 1, .reusable = true}, SHIFT(6974),
  [11089] = {.count = 1, .reusable = true}, SHIFT(6975),
  [11091] = {.count = 1, .reusable = true}, SHIFT(6977),
  [11093] = {.count = 1, .reusable = true}, SHIFT(6978),
  [11095] = {.count = 1, .reusable = true}, SHIFT(6980),
  [11097] = {.count = 1, .reusable = true}, SHIFT(6982),
  [11099] = {.count = 1, .reusable = true}, SHIFT(6983),
  [11101] = {.count = 1, .reusable = true}, SHIFT(6986),
  [11103] = {.count = 1, .reusable = true}, SHIFT(6987),
  [11105] = {.count = 1, .reusable = true}, SHIFT(6988),
  [11107] = {.count = 1, .reusable = true}, SHIFT(7004),
  [11109] = {.count = 1, .reusable = true}, SHIFT(7006),
  [11111] = {.count = 1, .reusable = true}, SHIFT(7009),
  [11113] = {.count = 1, .reusable = true}, SHIFT(7010),
  [11115] = {.count = 1, .reusable = false}, SHIFT(7011),
  [11117] = {.count = 1, .reusable = true}, SHIFT(7012),
  [11119] = {.count = 1, .reusable = false}, SHIFT(7013),
  [11121] = {.count = 1, .reusable = true}, SHIFT(7014),
  [11123] = {.count = 1, .reusable = false}, SHIFT(7017),
  [11125] = {.count = 1, .reusable = true}, SHIFT(7017),
  [11127] = {.count = 1, .reusable = true}, SHIFT(7019),
  [11129] = {.count = 1, .reusable = true}, SHIFT(7020),
  [11131] = {.count = 1, .reusable = true}, SHIFT(7021),
  [11133] = {.count = 1, .reusable = true}, SHIFT(7023),
  [11135] = {.count = 1, .reusable = true}, SHIFT(7024),
  [11137] = {.count = 1, .reusable = true}, SHIFT(7027),
  [11139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1769),
  [11142] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1770),
  [11145] = {.count = 1, .reusable = true}, SHIFT(7029),
  [11147] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(426),
  [11150] = {.count = 1, .reusable = false}, SHIFT(4184),
  [11152] = {.count = 1, .reusable = true}, SHIFT(7030),
  [11154] = {.count = 1, .reusable = true}, SHIFT(4188),
  [11156] = {.count = 1, .reusable = false}, SHIFT(7033),
  [11158] = {.count = 1, .reusable = true}, SHIFT(7035),
  [11160] = {.count = 1, .reusable = true}, SHIFT(7036),
  [11162] = {.count = 1, .reusable = false}, SHIFT(7037),
  [11164] = {.count = 1, .reusable = true}, SHIFT(7038),
  [11166] = {.count = 1, .reusable = true}, SHIFT(7039),
  [11168] = {.count = 1, .reusable = true}, SHIFT(7040),
  [11170] = {.count = 1, .reusable = false}, SHIFT(7056),
  [11172] = {.count = 1, .reusable = false}, SHIFT(7053),
  [11174] = {.count = 1, .reusable = true}, SHIFT(7049),
  [11176] = {.count = 1, .reusable = false}, SHIFT(7051),
  [11178] = {.count = 1, .reusable = false}, SHIFT(7057),
  [11180] = {.count = 1, .reusable = false}, SHIFT(7047),
  [11182] = {.count = 1, .reusable = true}, SHIFT(7056),
  [11184] = {.count = 1, .reusable = false}, SHIFT(7048),
  [11186] = {.count = 1, .reusable = true}, SHIFT(7057),
  [11188] = {.count = 1, .reusable = true}, SHIFT(7048),
  [11190] = {.count = 1, .reusable = false}, SHIFT(7050),
  [11192] = {.count = 1, .reusable = true}, SHIFT(7051),
  [11194] = {.count = 1, .reusable = true}, SHIFT(7052),
  [11196] = {.count = 1, .reusable = false}, SHIFT(7046),
  [11198] = {.count = 1, .reusable = true}, SHIFT(7062),
  [11200] = {.count = 1, .reusable = true}, SHIFT(7065),
  [11202] = {.count = 1, .reusable = false}, SHIFT(7066),
  [11204] = {.count = 1, .reusable = false}, SHIFT(7067),
  [11206] = {.count = 1, .reusable = true}, SHIFT(7068),
  [11208] = {.count = 1, .reusable = true}, SHIFT(7069),
  [11210] = {.count = 1, .reusable = true}, SHIFT(7071),
  [11212] = {.count = 1, .reusable = true}, SHIFT(7070),
  [11214] = {.count = 1, .reusable = true}, SHIFT(7072),
  [11216] = {.count = 1, .reusable = true}, SHIFT(7073),
  [11218] = {.count = 1, .reusable = false}, SHIFT(7074),
  [11220] = {.count = 1, .reusable = false}, SHIFT(7070),
  [11222] = {.count = 1, .reusable = true}, SHIFT(7067),
  [11224] = {.count = 1, .reusable = false}, SHIFT(7075),
  [11226] = {.count = 1, .reusable = false}, SHIFT(7072),
  [11228] = {.count = 1, .reusable = true}, SHIFT(7075),
  [11230] = {.count = 1, .reusable = true}, SHIFT(7077),
  [11232] = {.count = 1, .reusable = false}, SHIFT(7076),
  [11234] = {.count = 1, .reusable = true}, SHIFT(7076),
  [11236] = {.count = 1, .reusable = false}, SHIFT(7078),
  [11238] = {.count = 1, .reusable = true}, SHIFT(7079),
  [11240] = {.count = 1, .reusable = true}, SHIFT(7080),
  [11242] = {.count = 1, .reusable = true}, SHIFT(7081),
  [11244] = {.count = 1, .reusable = true}, SHIFT(7066),
  [11246] = {.count = 1, .reusable = false}, SHIFT(7036),
  [11248] = {.count = 1, .reusable = false}, SHIFT(7096),
  [11250] = {.count = 1, .reusable = true}, SHIFT(7093),
  [11252] = {.count = 1, .reusable = false}, SHIFT(7095),
  [11254] = {.count = 1, .reusable = true}, SHIFT(7090),
  [11256] = {.count = 1, .reusable = false}, SHIFT(7091),
  [11258] = {.count = 1, .reusable = false}, SHIFT(7092),
  [11260] = {.count = 1, .reusable = true}, SHIFT(7092),
  [11262] = {.count = 1, .reusable = false}, SHIFT(7094),
  [11264] = {.count = 1, .reusable = true}, SHIFT(7095),
  [11266] = {.count = 1, .reusable = false}, SHIFT(7089),
  [11268] = {.count = 1, .reusable = false}, SHIFT(7113),
  [11270] = {.count = 1, .reusable = true}, SHIFT(7113),
  [11272] = {.count = 1, .reusable = true}, SHIFT(7114),
  [11274] = {.count = 1, .reusable = true}, SHIFT(7115),
  [11276] = {.count = 1, .reusable = true}, SHIFT(7118),
  [11278] = {.count = 1, .reusable = false}, SHIFT(4223),
  [11280] = {.count = 1, .reusable = true}, SHIFT(7119),
  [11282] = {.count = 1, .reusable = false}, SHIFT(7122),
  [11284] = {.count = 1, .reusable = true}, SHIFT(7124),
  [11286] = {.count = 1, .reusable = false}, SHIFT(7134),
  [11288] = {.count = 1, .reusable = false}, SHIFT(7131),
  [11290] = {.count = 1, .reusable = true}, SHIFT(7128),
  [11292] = {.count = 1, .reusable = false}, SHIFT(7130),
  [11294] = {.count = 1, .reusable = false}, SHIFT(7135),
  [11296] = {.count = 1, .reusable = false}, SHIFT(7126),
  [11298] = {.count = 1, .reusable = true}, SHIFT(7134),
  [11300] = {.count = 1, .reusable = false}, SHIFT(7127),
  [11302] = {.count = 1, .reusable = true}, SHIFT(7135),
  [11304] = {.count = 1, .reusable = true}, SHIFT(7127),
  [11306] = {.count = 1, .reusable = false}, SHIFT(7129),
  [11308] = {.count = 1, .reusable = true}, SHIFT(7130),
  [11310] = {.count = 1, .reusable = false}, SHIFT(7125),
  [11312] = {.count = 1, .reusable = true}, SHIFT(7140),
  [11314] = {.count = 1, .reusable = true}, SHIFT(7141),
  [11316] = {.count = 1, .reusable = true}, SHIFT(7144),
  [11318] = {.count = 1, .reusable = false}, SHIFT(7140),
  [11320] = {.count = 1, .reusable = false}, SHIFT(7145),
  [11322] = {.count = 1, .reusable = false}, SHIFT(7146),
  [11324] = {.count = 1, .reusable = true}, SHIFT(7147),
  [11326] = {.count = 1, .reusable = false}, SHIFT(7149),
  [11328] = {.count = 1, .reusable = true}, SHIFT(7148),
  [11330] = {.count = 1, .reusable = true}, SHIFT(7150),
  [11332] = {.count = 1, .reusable = true}, SHIFT(7146),
  [11334] = {.count = 1, .reusable = false}, SHIFT(7151),
  [11336] = {.count = 1, .reusable = false}, SHIFT(7152),
  [11338] = {.count = 1, .reusable = false}, SHIFT(7148),
  [11340] = {.count = 1, .reusable = true}, SHIFT(7145),
  [11342] = {.count = 1, .reusable = false}, SHIFT(7153),
  [11344] = {.count = 1, .reusable = false}, SHIFT(7150),
  [11346] = {.count = 1, .reusable = true}, SHIFT(7151),
  [11348] = {.count = 1, .reusable = false}, SHIFT(7124),
  [11350] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [11352] = {.count = 1, .reusable = false}, SHIFT(4249),
  [11354] = {.count = 1, .reusable = true}, SHIFT(4253),
  [11356] = {.count = 1, .reusable = false}, SHIFT(7159),
  [11358] = {.count = 1, .reusable = true}, SHIFT(7161),
  [11360] = {.count = 1, .reusable = true}, SHIFT(7162),
  [11362] = {.count = 1, .reusable = false}, SHIFT(7163),
  [11364] = {.count = 1, .reusable = true}, SHIFT(7164),
  [11366] = {.count = 1, .reusable = true}, SHIFT(7165),
  [11368] = {.count = 1, .reusable = true}, SHIFT(7166),
  [11370] = {.count = 1, .reusable = false}, SHIFT(7178),
  [11372] = {.count = 1, .reusable = true}, SHIFT(7175),
  [11374] = {.count = 1, .reusable = false}, SHIFT(7177),
  [11376] = {.count = 1, .reusable = false}, SHIFT(7173),
  [11378] = {.count = 1, .reusable = false}, SHIFT(7174),
  [11380] = {.count = 1, .reusable = true}, SHIFT(7174),
  [11382] = {.count = 1, .reusable = false}, SHIFT(7176),
  [11384] = {.count = 1, .reusable = true}, SHIFT(7177),
  [11386] = {.count = 1, .reusable = false}, SHIFT(7172),
  [11388] = {.count = 1, .reusable = true}, SHIFT(7185),
  [11390] = {.count = 1, .reusable = true}, SHIFT(7188),
  [11392] = {.count = 1, .reusable = false}, SHIFT(7189),
  [11394] = {.count = 1, .reusable = false}, SHIFT(7190),
  [11396] = {.count = 1, .reusable = true}, SHIFT(7191),
  [11398] = {.count = 1, .reusable = true}, SHIFT(7192),
  [11400] = {.count = 1, .reusable = true}, SHIFT(7194),
  [11402] = {.count = 1, .reusable = true}, SHIFT(7195),
  [11404] = {.count = 1, .reusable = true}, SHIFT(7193),
  [11406] = {.count = 1, .reusable = false}, SHIFT(7197),
  [11408] = {.count = 1, .reusable = true}, SHIFT(7196),
  [11410] = {.count = 1, .reusable = false}, SHIFT(7193),
  [11412] = {.count = 1, .reusable = true}, SHIFT(7190),
  [11414] = {.count = 1, .reusable = false}, SHIFT(7198),
  [11416] = {.count = 1, .reusable = false}, SHIFT(7195),
  [11418] = {.count = 1, .reusable = true}, SHIFT(7198),
  [11420] = {.count = 1, .reusable = true}, SHIFT(7200),
  [11422] = {.count = 1, .reusable = false}, SHIFT(7199),
  [11424] = {.count = 1, .reusable = true}, SHIFT(7199),
  [11426] = {.count = 1, .reusable = false}, SHIFT(7201),
  [11428] = {.count = 1, .reusable = true}, SHIFT(7202),
  [11430] = {.count = 1, .reusable = true}, SHIFT(7203),
  [11432] = {.count = 1, .reusable = true}, SHIFT(7204),
  [11434] = {.count = 1, .reusable = true}, SHIFT(7189),
  [11436] = {.count = 1, .reusable = false}, SHIFT(7162),
  [11438] = {.count = 1, .reusable = false}, SHIFT(7216),
  [11440] = {.count = 1, .reusable = true}, SHIFT(7216),
  [11442] = {.count = 1, .reusable = true}, SHIFT(7217),
  [11444] = {.count = 1, .reusable = true}, SHIFT(7218),
  [11446] = {.count = 1, .reusable = true}, SHIFT(7221),
  [11448] = {.count = 1, .reusable = true}, SHIFT(7224),
  [11450] = {.count = 1, .reusable = false}, SHIFT(7225),
  [11452] = {.count = 1, .reusable = true}, SHIFT(7222),
  [11454] = {.count = 1, .reusable = false}, SHIFT(7223),
  [11456] = {.count = 1, .reusable = true}, SHIFT(7223),
  [11458] = {.count = 1, .reusable = true}, SHIFT(7225),
  [11460] = {.count = 1, .reusable = false}, SHIFT(4278),
  [11462] = {.count = 1, .reusable = false}, SHIFT(7232),
  [11464] = {.count = 1, .reusable = true}, SHIFT(7234),
  [11466] = {.count = 1, .reusable = false}, SHIFT(7244),
  [11468] = {.count = 1, .reusable = false}, SHIFT(7241),
  [11470] = {.count = 1, .reusable = true}, SHIFT(7238),
  [11472] = {.count = 1, .reusable = false}, SHIFT(7240),
  [11474] = {.count = 1, .reusable = false}, SHIFT(7245),
  [11476] = {.count = 1, .reusable = false}, SHIFT(7236),
  [11478] = {.count = 1, .reusable = true}, SHIFT(7244),
  [11480] = {.count = 1, .reusable = false}, SHIFT(7237),
  [11482] = {.count = 1, .reusable = true}, SHIFT(7245),
  [11484] = {.count = 1, .reusable = true}, SHIFT(7237),
  [11486] = {.count = 1, .reusable = false}, SHIFT(7239),
  [11488] = {.count = 1, .reusable = true}, SHIFT(7240),
  [11490] = {.count = 1, .reusable = false}, SHIFT(7235),
  [11492] = {.count = 1, .reusable = true}, SHIFT(7250),
  [11494] = {.count = 1, .reusable = true}, SHIFT(7251),
  [11496] = {.count = 1, .reusable = true}, SHIFT(7254),
  [11498] = {.count = 1, .reusable = false}, SHIFT(7250),
  [11500] = {.count = 1, .reusable = false}, SHIFT(7256),
  [11502] = {.count = 1, .reusable = true}, SHIFT(7258),
  [11504] = {.count = 1, .reusable = false}, SHIFT(7259),
  [11506] = {.count = 1, .reusable = true}, SHIFT(7256),
  [11508] = {.count = 1, .reusable = false}, SHIFT(7261),
  [11510] = {.count = 1, .reusable = false}, SHIFT(7262),
  [11512] = {.count = 1, .reusable = false}, SHIFT(7255),
  [11514] = {.count = 1, .reusable = false}, SHIFT(7263),
  [11516] = {.count = 1, .reusable = false}, SHIFT(7260),
  [11518] = {.count = 1, .reusable = true}, SHIFT(7257),
  [11520] = {.count = 1, .reusable = true}, SHIFT(7260),
  [11522] = {.count = 1, .reusable = false}, SHIFT(7258),
  [11524] = {.count = 1, .reusable = true}, SHIFT(7255),
  [11526] = {.count = 1, .reusable = true}, SHIFT(7261),
  [11528] = {.count = 1, .reusable = false}, SHIFT(7234),
  [11530] = {.count = 1, .reusable = true}, SHIFT(1836),
  [11532] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1854),
  [11535] = {.count = 1, .reusable = true}, SHIFT(7301),
  [11537] = {.count = 1, .reusable = true}, SHIFT(7302),
  [11539] = {.count = 1, .reusable = true}, SHIFT(7304),
  [11541] = {.count = 1, .reusable = true}, SHIFT(1875),
  [11543] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5),
  [11545] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5),
  [11547] = {.count = 1, .reusable = true}, SHIFT(7325),
  [11549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1932),
  [11552] = {.count = 1, .reusable = true}, SHIFT(7342),
  [11554] = {.count = 1, .reusable = true}, SHIFT(7352),
  [11556] = {.count = 1, .reusable = false}, SHIFT(7353),
  [11558] = {.count = 1, .reusable = false}, SHIFT(7354),
  [11560] = {.count = 1, .reusable = true}, SHIFT(7356),
  [11562] = {.count = 1, .reusable = true}, SHIFT(7357),
  [11564] = {.count = 1, .reusable = true}, SHIFT(7358),
  [11566] = {.count = 1, .reusable = true}, SHIFT(7359),
  [11568] = {.count = 1, .reusable = true}, SHIFT(7355),
  [11570] = {.count = 1, .reusable = false}, SHIFT(7361),
  [11572] = {.count = 1, .reusable = true}, SHIFT(7360),
  [11574] = {.count = 1, .reusable = false}, SHIFT(7355),
  [11576] = {.count = 1, .reusable = true}, SHIFT(7354),
  [11578] = {.count = 1, .reusable = false}, SHIFT(7362),
  [11580] = {.count = 1, .reusable = false}, SHIFT(7359),
  [11582] = {.count = 1, .reusable = true}, SHIFT(7362),
  [11584] = {.count = 1, .reusable = true}, SHIFT(7353),
  [11586] = {.count = 1, .reusable = true}, SHIFT(1964),
  [11588] = {.count = 1, .reusable = true}, SHIFT(7382),
  [11590] = {.count = 1, .reusable = true}, SHIFT(7383),
  [11592] = {.count = 1, .reusable = true}, SHIFT(7385),
  [11594] = {.count = 1, .reusable = true}, SHIFT(7389),
  [11596] = {.count = 1, .reusable = false}, SHIFT(7390),
  [11598] = {.count = 1, .reusable = false}, SHIFT(7391),
  [11600] = {.count = 1, .reusable = true}, SHIFT(7393),
  [11602] = {.count = 1, .reusable = true}, SHIFT(7394),
  [11604] = {.count = 1, .reusable = true}, SHIFT(7395),
  [11606] = {.count = 1, .reusable = true}, SHIFT(7396),
  [11608] = {.count = 1, .reusable = true}, SHIFT(7392),
  [11610] = {.count = 1, .reusable = false}, SHIFT(7398),
  [11612] = {.count = 1, .reusable = true}, SHIFT(7397),
  [11614] = {.count = 1, .reusable = false}, SHIFT(7392),
  [11616] = {.count = 1, .reusable = true}, SHIFT(7391),
  [11618] = {.count = 1, .reusable = false}, SHIFT(7399),
  [11620] = {.count = 1, .reusable = false}, SHIFT(7396),
  [11622] = {.count = 1, .reusable = true}, SHIFT(7399),
  [11624] = {.count = 1, .reusable = true}, SHIFT(7390),
  [11626] = {.count = 1, .reusable = true}, SHIFT(7400),
  [11628] = {.count = 1, .reusable = true}, SHIFT(7406),
  [11630] = {.count = 1, .reusable = false}, SHIFT(7407),
  [11632] = {.count = 1, .reusable = false}, SHIFT(7410),
  [11634] = {.count = 1, .reusable = true}, SHIFT(7409),
  [11636] = {.count = 1, .reusable = false}, SHIFT(7412),
  [11638] = {.count = 1, .reusable = true}, SHIFT(7410),
  [11640] = {.count = 1, .reusable = false}, SHIFT(7414),
  [11642] = {.count = 1, .reusable = false}, SHIFT(7415),
  [11644] = {.count = 1, .reusable = false}, SHIFT(7408),
  [11646] = {.count = 1, .reusable = false}, SHIFT(7416),
  [11648] = {.count = 1, .reusable = false}, SHIFT(7413),
  [11650] = {.count = 1, .reusable = true}, SHIFT(7411),
  [11652] = {.count = 1, .reusable = true}, SHIFT(7413),
  [11654] = {.count = 1, .reusable = false}, SHIFT(7409),
  [11656] = {.count = 1, .reusable = true}, SHIFT(7408),
  [11658] = {.count = 1, .reusable = true}, SHIFT(7414),
  [11660] = {.count = 1, .reusable = true}, SHIFT(7407),
  [11662] = {.count = 1, .reusable = true}, SHIFT(1992),
  [11664] = {.count = 1, .reusable = true}, SHIFT(7436),
  [11666] = {.count = 1, .reusable = true}, SHIFT(2028),
  [11668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2046),
  [11671] = {.count = 1, .reusable = true}, SHIFT(7461),
  [11673] = {.count = 1, .reusable = true}, SHIFT(7462),
  [11675] = {.count = 1, .reusable = true}, SHIFT(7464),
  [11677] = {.count = 1, .reusable = true}, SHIFT(2066),
  [11679] = {.count = 1, .reusable = false}, SHIFT(4593),
  [11681] = {.count = 1, .reusable = true}, SHIFT(4597),
  [11683] = {.count = 1, .reusable = false}, SHIFT(7474),
  [11685] = {.count = 1, .reusable = true}, SHIFT(7476),
  [11687] = {.count = 1, .reusable = true}, SHIFT(7477),
  [11689] = {.count = 1, .reusable = false}, SHIFT(7478),
  [11691] = {.count = 1, .reusable = true}, SHIFT(7479),
  [11693] = {.count = 1, .reusable = true}, SHIFT(7480),
  [11695] = {.count = 1, .reusable = true}, SHIFT(7481),
  [11697] = {.count = 1, .reusable = false}, SHIFT(7493),
  [11699] = {.count = 1, .reusable = true}, SHIFT(7490),
  [11701] = {.count = 1, .reusable = false}, SHIFT(7492),
  [11703] = {.count = 1, .reusable = false}, SHIFT(7488),
  [11705] = {.count = 1, .reusable = false}, SHIFT(7489),
  [11707] = {.count = 1, .reusable = true}, SHIFT(7489),
  [11709] = {.count = 1, .reusable = false}, SHIFT(7491),
  [11711] = {.count = 1, .reusable = true}, SHIFT(7492),
  [11713] = {.count = 1, .reusable = false}, SHIFT(7487),
  [11715] = {.count = 1, .reusable = true}, SHIFT(7500),
  [11717] = {.count = 1, .reusable = true}, SHIFT(7503),
  [11719] = {.count = 1, .reusable = false}, SHIFT(7504),
  [11721] = {.count = 1, .reusable = false}, SHIFT(7505),
  [11723] = {.count = 1, .reusable = true}, SHIFT(7506),
  [11725] = {.count = 1, .reusable = true}, SHIFT(7507),
  [11727] = {.count = 1, .reusable = true}, SHIFT(7509),
  [11729] = {.count = 1, .reusable = true}, SHIFT(7510),
  [11731] = {.count = 1, .reusable = true}, SHIFT(7508),
  [11733] = {.count = 1, .reusable = false}, SHIFT(7512),
  [11735] = {.count = 1, .reusable = true}, SHIFT(7511),
  [11737] = {.count = 1, .reusable = false}, SHIFT(7508),
  [11739] = {.count = 1, .reusable = true}, SHIFT(7505),
  [11741] = {.count = 1, .reusable = false}, SHIFT(7513),
  [11743] = {.count = 1, .reusable = false}, SHIFT(7510),
  [11745] = {.count = 1, .reusable = true}, SHIFT(7513),
  [11747] = {.count = 1, .reusable = true}, SHIFT(7515),
  [11749] = {.count = 1, .reusable = false}, SHIFT(7514),
  [11751] = {.count = 1, .reusable = true}, SHIFT(7514),
  [11753] = {.count = 1, .reusable = false}, SHIFT(7516),
  [11755] = {.count = 1, .reusable = true}, SHIFT(7517),
  [11757] = {.count = 1, .reusable = true}, SHIFT(7518),
  [11759] = {.count = 1, .reusable = true}, SHIFT(7519),
  [11761] = {.count = 1, .reusable = true}, SHIFT(7504),
  [11763] = {.count = 1, .reusable = false}, SHIFT(7477),
  [11765] = {.count = 1, .reusable = true}, SHIFT(7530),
  [11767] = {.count = 1, .reusable = true}, SHIFT(7529),
  [11769] = {.count = 1, .reusable = false}, SHIFT(7533),
  [11771] = {.count = 1, .reusable = true}, SHIFT(7533),
  [11773] = {.count = 1, .reusable = true}, SHIFT(7534),
  [11775] = {.count = 1, .reusable = true}, SHIFT(7535),
  [11777] = {.count = 1, .reusable = true}, SHIFT(7538),
  [11779] = {.count = 1, .reusable = true}, SHIFT(7541),
  [11781] = {.count = 1, .reusable = false}, SHIFT(7542),
  [11783] = {.count = 1, .reusable = true}, SHIFT(7539),
  [11785] = {.count = 1, .reusable = false}, SHIFT(7540),
  [11787] = {.count = 1, .reusable = true}, SHIFT(7540),
  [11789] = {.count = 1, .reusable = true}, SHIFT(7542),
  [11791] = {.count = 1, .reusable = false}, SHIFT(4624),
  [11793] = {.count = 1, .reusable = false}, SHIFT(7549),
  [11795] = {.count = 1, .reusable = true}, SHIFT(7551),
  [11797] = {.count = 1, .reusable = false}, SHIFT(7561),
  [11799] = {.count = 1, .reusable = false}, SHIFT(7558),
  [11801] = {.count = 1, .reusable = true}, SHIFT(7555),
  [11803] = {.count = 1, .reusable = false}, SHIFT(7557),
  [11805] = {.count = 1, .reusable = false}, SHIFT(7562),
  [11807] = {.count = 1, .reusable = false}, SHIFT(7553),
  [11809] = {.count = 1, .reusable = true}, SHIFT(7561),
  [11811] = {.count = 1, .reusable = false}, SHIFT(7554),
  [11813] = {.count = 1, .reusable = true}, SHIFT(7562),
  [11815] = {.count = 1, .reusable = true}, SHIFT(7554),
  [11817] = {.count = 1, .reusable = false}, SHIFT(7556),
  [11819] = {.count = 1, .reusable = true}, SHIFT(7557),
  [11821] = {.count = 1, .reusable = false}, SHIFT(7552),
  [11823] = {.count = 1, .reusable = true}, SHIFT(7567),
  [11825] = {.count = 1, .reusable = true}, SHIFT(7568),
  [11827] = {.count = 1, .reusable = true}, SHIFT(7571),
  [11829] = {.count = 1, .reusable = false}, SHIFT(7567),
  [11831] = {.count = 1, .reusable = false}, SHIFT(7573),
  [11833] = {.count = 1, .reusable = true}, SHIFT(7575),
  [11835] = {.count = 1, .reusable = false}, SHIFT(7576),
  [11837] = {.count = 1, .reusable = true}, SHIFT(7573),
  [11839] = {.count = 1, .reusable = false}, SHIFT(7578),
  [11841] = {.count = 1, .reusable = false}, SHIFT(7579),
  [11843] = {.count = 1, .reusable = false}, SHIFT(7572),
  [11845] = {.count = 1, .reusable = false}, SHIFT(7580),
  [11847] = {.count = 1, .reusable = false}, SHIFT(7577),
  [11849] = {.count = 1, .reusable = true}, SHIFT(7574),
  [11851] = {.count = 1, .reusable = true}, SHIFT(7577),
  [11853] = {.count = 1, .reusable = false}, SHIFT(7575),
  [11855] = {.count = 1, .reusable = true}, SHIFT(7572),
  [11857] = {.count = 1, .reusable = true}, SHIFT(7578),
  [11859] = {.count = 1, .reusable = false}, SHIFT(7551),
  [11861] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2078),
  [11864] = {.count = 1, .reusable = true}, REDUCE(sym_then, 3),
  [11866] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5),
  [11868] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5),
  [11870] = {.count = 1, .reusable = true}, SHIFT(7595),
  [11872] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2136),
  [11875] = {.count = 1, .reusable = true}, SHIFT(7625),
  [11877] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 19),
  [11879] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 19),
  [11881] = {.count = 1, .reusable = true}, SHIFT(7627),
  [11883] = {.count = 1, .reusable = false}, SHIFT(7628),
  [11885] = {.count = 1, .reusable = true}, SHIFT(7630),
  [11887] = {.count = 1, .reusable = true}, SHIFT(7632),
  [11889] = {.count = 1, .reusable = false}, SHIFT(7633),
  [11891] = {.count = 1, .reusable = true}, SHIFT(7633),
  [11893] = {.count = 1, .reusable = true}, SHIFT(7635),
  [11895] = {.count = 1, .reusable = true}, SHIFT(7636),
  [11897] = {.count = 1, .reusable = true}, SHIFT(7637),
  [11899] = {.count = 1, .reusable = true}, SHIFT(7639),
  [11901] = {.count = 1, .reusable = true}, SHIFT(7640),
  [11903] = {.count = 1, .reusable = true}, SHIFT(7641),
  [11905] = {.count = 1, .reusable = true}, SHIFT(7642),
  [11907] = {.count = 1, .reusable = false}, SHIFT(7643),
  [11909] = {.count = 1, .reusable = true}, SHIFT(7645),
  [11911] = {.count = 1, .reusable = true}, SHIFT(7647),
  [11913] = {.count = 1, .reusable = false}, SHIFT(7646),
  [11915] = {.count = 1, .reusable = true}, SHIFT(7646),
  [11917] = {.count = 1, .reusable = true}, SHIFT(7650),
  [11919] = {.count = 1, .reusable = true}, SHIFT(7652),
  [11921] = {.count = 1, .reusable = false}, SHIFT(7653),
  [11923] = {.count = 1, .reusable = true}, SHIFT(2195),
  [11925] = {.count = 1, .reusable = false}, SHIFT(7657),
  [11927] = {.count = 1, .reusable = true}, SHIFT(7658),
  [11929] = {.count = 1, .reusable = true}, SHIFT(7662),
  [11931] = {.count = 1, .reusable = false}, SHIFT(7658),
  [11933] = {.count = 1, .reusable = true}, SHIFT(7669),
  [11935] = {.count = 1, .reusable = false}, SHIFT(7671),
  [11937] = {.count = 1, .reusable = true}, SHIFT(7670),
  [11939] = {.count = 1, .reusable = false}, SHIFT(7672),
  [11941] = {.count = 1, .reusable = true}, SHIFT(7674),
  [11943] = {.count = 1, .reusable = true}, SHIFT(7675),
  [11945] = {.count = 1, .reusable = true}, SHIFT(7676),
  [11947] = {.count = 1, .reusable = true}, SHIFT(7673),
  [11949] = {.count = 1, .reusable = true}, SHIFT(7677),
  [11951] = {.count = 1, .reusable = false}, SHIFT(7679),
  [11953] = {.count = 1, .reusable = true}, SHIFT(7678),
  [11955] = {.count = 1, .reusable = false}, SHIFT(7673),
  [11957] = {.count = 1, .reusable = true}, SHIFT(7672),
  [11959] = {.count = 1, .reusable = false}, SHIFT(7680),
  [11961] = {.count = 1, .reusable = false}, SHIFT(7677),
  [11963] = {.count = 1, .reusable = true}, SHIFT(7680),
  [11965] = {.count = 1, .reusable = true}, SHIFT(7682),
  [11967] = {.count = 1, .reusable = false}, SHIFT(7681),
  [11969] = {.count = 1, .reusable = true}, SHIFT(7681),
  [11971] = {.count = 1, .reusable = true}, SHIFT(7671),
  [11973] = {.count = 1, .reusable = true}, SHIFT(7684),
  [11975] = {.count = 1, .reusable = true}, SHIFT(7686),
  [11977] = {.count = 1, .reusable = true}, SHIFT(7685),
  [11979] = {.count = 1, .reusable = true}, SHIFT(2210),
  [11981] = {.count = 1, .reusable = false}, SHIFT(7705),
  [11983] = {.count = 1, .reusable = true}, SHIFT(7705),
  [11985] = {.count = 1, .reusable = true}, SHIFT(7706),
  [11987] = {.count = 1, .reusable = true}, SHIFT(7707),
  [11989] = {.count = 1, .reusable = true}, SHIFT(7710),
  [11991] = {.count = 1, .reusable = false}, SHIFT(7711),
  [11993] = {.count = 1, .reusable = true}, SHIFT(7712),
  [11995] = {.count = 1, .reusable = true}, SHIFT(7716),
  [11997] = {.count = 1, .reusable = false}, SHIFT(7712),
  [11999] = {.count = 1, .reusable = true}, SHIFT(7720),
  [12001] = {.count = 1, .reusable = true}, SHIFT(7723),
  [12003] = {.count = 1, .reusable = true}, SHIFT(7724),
  [12005] = {.count = 1, .reusable = false}, SHIFT(7725),
  [12007] = {.count = 1, .reusable = true}, SHIFT(7726),
  [12009] = {.count = 1, .reusable = false}, SHIFT(7727),
  [12011] = {.count = 1, .reusable = true}, SHIFT(7728),
  [12013] = {.count = 1, .reusable = false}, SHIFT(7731),
  [12015] = {.count = 1, .reusable = true}, SHIFT(7731),
  [12017] = {.count = 1, .reusable = true}, SHIFT(7733),
  [12019] = {.count = 1, .reusable = true}, SHIFT(7734),
  [12021] = {.count = 1, .reusable = true}, SHIFT(7735),
  [12023] = {.count = 1, .reusable = true}, SHIFT(7737),
  [12025] = {.count = 1, .reusable = true}, SHIFT(7738),
  [12027] = {.count = 1, .reusable = true}, SHIFT(7739),
  [12029] = {.count = 1, .reusable = true}, SHIFT(7741),
  [12031] = {.count = 1, .reusable = true}, SHIFT(7742),
  [12033] = {.count = 1, .reusable = false}, SHIFT(7747),
  [12035] = {.count = 1, .reusable = true}, SHIFT(7746),
  [12037] = {.count = 1, .reusable = false}, SHIFT(7748),
  [12039] = {.count = 1, .reusable = true}, SHIFT(7750),
  [12041] = {.count = 1, .reusable = true}, SHIFT(7751),
  [12043] = {.count = 1, .reusable = true}, SHIFT(7752),
  [12045] = {.count = 1, .reusable = true}, SHIFT(7749),
  [12047] = {.count = 1, .reusable = true}, SHIFT(7753),
  [12049] = {.count = 1, .reusable = false}, SHIFT(7755),
  [12051] = {.count = 1, .reusable = true}, SHIFT(7754),
  [12053] = {.count = 1, .reusable = false}, SHIFT(7749),
  [12055] = {.count = 1, .reusable = true}, SHIFT(7748),
  [12057] = {.count = 1, .reusable = false}, SHIFT(7756),
  [12059] = {.count = 1, .reusable = false}, SHIFT(7753),
  [12061] = {.count = 1, .reusable = true}, SHIFT(7756),
  [12063] = {.count = 1, .reusable = true}, SHIFT(7747),
  [12065] = {.count = 1, .reusable = true}, SHIFT(7758),
  [12067] = {.count = 1, .reusable = true}, SHIFT(7760),
  [12069] = {.count = 1, .reusable = true}, SHIFT(7764),
  [12071] = {.count = 1, .reusable = false}, SHIFT(7763),
  [12073] = {.count = 1, .reusable = true}, SHIFT(7763),
  [12075] = {.count = 1, .reusable = true}, SHIFT(7771),
  [12077] = {.count = 1, .reusable = true}, SHIFT(7773),
  [12079] = {.count = 1, .reusable = true}, SHIFT(7772),
  [12081] = {.count = 1, .reusable = true}, SHIFT(7775),
  [12083] = {.count = 1, .reusable = true}, SHIFT(7777),
  [12085] = {.count = 1, .reusable = true}, SHIFT(7781),
  [12087] = {.count = 1, .reusable = false}, SHIFT(7782),
  [12089] = {.count = 1, .reusable = false}, SHIFT(7784),
  [12091] = {.count = 1, .reusable = true}, SHIFT(7788),
  [12093] = {.count = 1, .reusable = false}, SHIFT(7789),
  [12095] = {.count = 1, .reusable = true}, SHIFT(7794),
  [12097] = {.count = 1, .reusable = true}, SHIFT(7797),
  [12099] = {.count = 1, .reusable = true}, SHIFT(7796),
  [12101] = {.count = 1, .reusable = true}, SHIFT(7799),
  [12103] = {.count = 1, .reusable = true}, SHIFT(7801),
  [12105] = {.count = 1, .reusable = false}, SHIFT(7807),
  [12107] = {.count = 1, .reusable = true}, SHIFT(7809),
  [12109] = {.count = 1, .reusable = true}, SHIFT(7811),
  [12111] = {.count = 1, .reusable = false}, SHIFT(7818),
  [12113] = {.count = 1, .reusable = true}, SHIFT(7815),
  [12115] = {.count = 1, .reusable = true}, SHIFT(7821),
  [12117] = {.count = 1, .reusable = false}, SHIFT(7822),
  [12119] = {.count = 1, .reusable = false}, SHIFT(7825),
  [12121] = {.count = 1, .reusable = true}, SHIFT(7824),
  [12123] = {.count = 1, .reusable = false}, SHIFT(7827),
  [12125] = {.count = 1, .reusable = true}, SHIFT(7825),
  [12127] = {.count = 1, .reusable = false}, SHIFT(7829),
  [12129] = {.count = 1, .reusable = false}, SHIFT(7830),
  [12131] = {.count = 1, .reusable = false}, SHIFT(7823),
  [12133] = {.count = 1, .reusable = false}, SHIFT(7831),
  [12135] = {.count = 1, .reusable = false}, SHIFT(7828),
  [12137] = {.count = 1, .reusable = true}, SHIFT(7826),
  [12139] = {.count = 1, .reusable = true}, SHIFT(7828),
  [12141] = {.count = 1, .reusable = false}, SHIFT(7824),
  [12143] = {.count = 1, .reusable = true}, SHIFT(7823),
  [12145] = {.count = 1, .reusable = true}, SHIFT(7829),
  [12147] = {.count = 1, .reusable = true}, SHIFT(7822),
  [12149] = {.count = 1, .reusable = true}, SHIFT(7833),
  [12151] = {.count = 1, .reusable = true}, SHIFT(7834),
  [12153] = {.count = 1, .reusable = true}, SHIFT(7838),
  [12155] = {.count = 1, .reusable = true}, SHIFT(7837),
  [12157] = {.count = 1, .reusable = true}, SHIFT(2273),
  [12159] = {.count = 1, .reusable = true}, SHIFT(7856),
  [12161] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(651),
  [12164] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 20),
  [12166] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 20),
  [12168] = {.count = 1, .reusable = true}, SHIFT(7857),
  [12170] = {.count = 1, .reusable = true}, SHIFT(7858),
  [12172] = {.count = 1, .reusable = true}, SHIFT(7859),
  [12174] = {.count = 1, .reusable = true}, SHIFT(7860),
  [12176] = {.count = 1, .reusable = true}, SHIFT(7861),
  [12178] = {.count = 1, .reusable = true}, SHIFT(7862),
  [12180] = {.count = 1, .reusable = false}, SHIFT(7863),
  [12182] = {.count = 1, .reusable = false}, SHIFT(7865),
  [12184] = {.count = 1, .reusable = true}, SHIFT(7865),
  [12186] = {.count = 1, .reusable = true}, SHIFT(7867),
  [12188] = {.count = 1, .reusable = true}, SHIFT(7868),
  [12190] = {.count = 1, .reusable = true}, SHIFT(7869),
  [12192] = {.count = 1, .reusable = true}, SHIFT(7870),
  [12194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2339),
  [12197] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2340),
  [12200] = {.count = 1, .reusable = true}, SHIFT(7874),
  [12202] = {.count = 1, .reusable = true}, SHIFT(7879),
  [12204] = {.count = 1, .reusable = false}, SHIFT(7880),
  [12206] = {.count = 1, .reusable = false}, SHIFT(7881),
  [12208] = {.count = 1, .reusable = true}, SHIFT(7883),
  [12210] = {.count = 1, .reusable = true}, SHIFT(7884),
  [12212] = {.count = 1, .reusable = true}, SHIFT(7885),
  [12214] = {.count = 1, .reusable = true}, SHIFT(7882),
  [12216] = {.count = 1, .reusable = true}, SHIFT(7886),
  [12218] = {.count = 1, .reusable = true}, SHIFT(7887),
  [12220] = {.count = 1, .reusable = false}, SHIFT(7888),
  [12222] = {.count = 1, .reusable = false}, SHIFT(7882),
  [12224] = {.count = 1, .reusable = true}, SHIFT(7881),
  [12226] = {.count = 1, .reusable = false}, SHIFT(7889),
  [12228] = {.count = 1, .reusable = false}, SHIFT(7886),
  [12230] = {.count = 1, .reusable = true}, SHIFT(7889),
  [12232] = {.count = 1, .reusable = true}, SHIFT(7880),
  [12234] = {.count = 1, .reusable = true}, SHIFT(2358),
  [12236] = {.count = 1, .reusable = false}, SHIFT(7894),
  [12238] = {.count = 1, .reusable = true}, SHIFT(7896),
  [12240] = {.count = 1, .reusable = true}, SHIFT(7899),
  [12242] = {.count = 1, .reusable = true}, SHIFT(7900),
  [12244] = {.count = 1, .reusable = true}, SHIFT(7901),
  [12246] = {.count = 1, .reusable = true}, SHIFT(7902),
  [12248] = {.count = 1, .reusable = true}, SHIFT(7904),
  [12250] = {.count = 1, .reusable = true}, SHIFT(7905),
  [12252] = {.count = 1, .reusable = false}, SHIFT(7906),
  [12254] = {.count = 1, .reusable = true}, SHIFT(7906),
  [12256] = {.count = 1, .reusable = true}, SHIFT(7908),
  [12258] = {.count = 1, .reusable = false}, SHIFT(7909),
  [12260] = {.count = 1, .reusable = true}, SHIFT(7910),
  [12262] = {.count = 1, .reusable = false}, SHIFT(7911),
  [12264] = {.count = 1, .reusable = true}, SHIFT(7912),
  [12266] = {.count = 1, .reusable = true}, SHIFT(7915),
  [12268] = {.count = 1, .reusable = true}, SHIFT(7916),
  [12270] = {.count = 1, .reusable = true}, SHIFT(7917),
  [12272] = {.count = 1, .reusable = true}, SHIFT(7919),
  [12274] = {.count = 1, .reusable = true}, SHIFT(7920),
  [12276] = {.count = 1, .reusable = true}, SHIFT(7921),
  [12278] = {.count = 1, .reusable = false}, SHIFT(7922),
  [12280] = {.count = 1, .reusable = true}, SHIFT(7924),
  [12282] = {.count = 1, .reusable = true}, SHIFT(7926),
  [12284] = {.count = 1, .reusable = false}, SHIFT(7925),
  [12286] = {.count = 1, .reusable = true}, SHIFT(7925),
  [12288] = {.count = 1, .reusable = true}, SHIFT(7929),
  [12290] = {.count = 1, .reusable = true}, SHIFT(7931),
  [12292] = {.count = 1, .reusable = false}, SHIFT(7932),
  [12294] = {.count = 1, .reusable = true}, SHIFT(2414),
  [12296] = {.count = 1, .reusable = false}, SHIFT(7934),
  [12298] = {.count = 1, .reusable = true}, SHIFT(7934),
  [12300] = {.count = 1, .reusable = true}, SHIFT(7939),
  [12302] = {.count = 1, .reusable = true}, SHIFT(7940),
  [12304] = {.count = 1, .reusable = true}, SHIFT(7942),
  [12306] = {.count = 1, .reusable = true}, SHIFT(7943),
  [12308] = {.count = 1, .reusable = true}, SHIFT(7944),
  [12310] = {.count = 1, .reusable = true}, SHIFT(7948),
  [12312] = {.count = 1, .reusable = false}, SHIFT(7947),
  [12314] = {.count = 1, .reusable = true}, SHIFT(7947),
  [12316] = {.count = 1, .reusable = true}, SHIFT(7954),
  [12318] = {.count = 1, .reusable = false}, SHIFT(7955),
  [12320] = {.count = 1, .reusable = false}, SHIFT(7956),
  [12322] = {.count = 1, .reusable = false}, SHIFT(7958),
  [12324] = {.count = 1, .reusable = true}, SHIFT(7959),
  [12326] = {.count = 1, .reusable = false}, SHIFT(7960),
  [12328] = {.count = 1, .reusable = true}, SHIFT(7957),
  [12330] = {.count = 1, .reusable = true}, SHIFT(7961),
  [12332] = {.count = 1, .reusable = true}, SHIFT(7958),
  [12334] = {.count = 1, .reusable = false}, SHIFT(7962),
  [12336] = {.count = 1, .reusable = false}, SHIFT(7963),
  [12338] = {.count = 1, .reusable = false}, SHIFT(7957),
  [12340] = {.count = 1, .reusable = true}, SHIFT(7956),
  [12342] = {.count = 1, .reusable = false}, SHIFT(7964),
  [12344] = {.count = 1, .reusable = false}, SHIFT(7961),
  [12346] = {.count = 1, .reusable = true}, SHIFT(7962),
  [12348] = {.count = 1, .reusable = true}, SHIFT(7955),
  [12350] = {.count = 1, .reusable = true}, SHIFT(7966),
  [12352] = {.count = 1, .reusable = true}, SHIFT(2440),
  [12354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(759),
  [12357] = {.count = 1, .reusable = true}, SHIFT(7971),
  [12359] = {.count = 1, .reusable = false}, SHIFT(7974),
  [12361] = {.count = 1, .reusable = false}, SHIFT(7975),
  [12363] = {.count = 1, .reusable = true}, SHIFT(7976),
  [12365] = {.count = 1, .reusable = true}, SHIFT(7978),
  [12367] = {.count = 1, .reusable = true}, SHIFT(7979),
  [12369] = {.count = 1, .reusable = true}, SHIFT(7980),
  [12371] = {.count = 1, .reusable = true}, SHIFT(7981),
  [12373] = {.count = 1, .reusable = true}, SHIFT(7982),
  [12375] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [12377] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 4),
  [12379] = {.count = 1, .reusable = true}, SHIFT(5138),
  [12381] = {.count = 1, .reusable = true}, SHIFT(7987),
  [12383] = {.count = 1, .reusable = false}, SHIFT(7988),
  [12385] = {.count = 1, .reusable = false}, SHIFT(7990),
  [12387] = {.count = 1, .reusable = true}, SHIFT(7990),
  [12389] = {.count = 1, .reusable = true}, SHIFT(7992),
  [12391] = {.count = 1, .reusable = true}, SHIFT(7993),
  [12393] = {.count = 1, .reusable = true}, SHIFT(7994),
  [12395] = {.count = 1, .reusable = true}, SHIFT(7996),
  [12397] = {.count = 1, .reusable = true}, SHIFT(7997),
  [12399] = {.count = 1, .reusable = true}, SHIFT(7998),
  [12401] = {.count = 1, .reusable = true}, SHIFT(7999),
  [12403] = {.count = 1, .reusable = false}, SHIFT(8000),
  [12405] = {.count = 1, .reusable = true}, SHIFT(8002),
  [12407] = {.count = 1, .reusable = false}, SHIFT(8003),
  [12409] = {.count = 1, .reusable = true}, SHIFT(8003),
  [12411] = {.count = 1, .reusable = true}, SHIFT(8005),
  [12413] = {.count = 1, .reusable = true}, SHIFT(8006),
  [12415] = {.count = 1, .reusable = false}, SHIFT(8007),
  [12417] = {.count = 1, .reusable = true}, SHIFT(2535),
  [12419] = {.count = 1, .reusable = true}, SHIFT(8009),
  [12421] = {.count = 1, .reusable = true}, SHIFT(8012),
  [12423] = {.count = 1, .reusable = true}, SHIFT(8013),
  [12425] = {.count = 1, .reusable = false}, SHIFT(8014),
  [12427] = {.count = 1, .reusable = true}, SHIFT(8015),
  [12429] = {.count = 1, .reusable = false}, SHIFT(8016),
  [12431] = {.count = 1, .reusable = true}, SHIFT(8017),
  [12433] = {.count = 1, .reusable = false}, SHIFT(8020),
  [12435] = {.count = 1, .reusable = true}, SHIFT(8020),
  [12437] = {.count = 1, .reusable = true}, SHIFT(8022),
  [12439] = {.count = 1, .reusable = true}, SHIFT(8023),
  [12441] = {.count = 1, .reusable = true}, SHIFT(8024),
  [12443] = {.count = 1, .reusable = true}, SHIFT(8026),
  [12445] = {.count = 1, .reusable = true}, SHIFT(8027),
  [12447] = {.count = 1, .reusable = true}, SHIFT(8030),
  [12449] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2577),
  [12452] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2578),
  [12455] = {.count = 1, .reusable = true}, SHIFT(8032),
  [12457] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(832),
  [12460] = {.count = 1, .reusable = true}, SHIFT(8033),
  [12462] = {.count = 1, .reusable = true}, SHIFT(8034),
  [12464] = {.count = 1, .reusable = true}, SHIFT(8035),
  [12466] = {.count = 1, .reusable = true}, SHIFT(8036),
  [12468] = {.count = 1, .reusable = true}, SHIFT(8037),
  [12470] = {.count = 1, .reusable = true}, SHIFT(8038),
  [12472] = {.count = 1, .reusable = false}, SHIFT(8039),
  [12474] = {.count = 1, .reusable = false}, SHIFT(8041),
  [12476] = {.count = 1, .reusable = true}, SHIFT(8041),
  [12478] = {.count = 1, .reusable = true}, SHIFT(8043),
  [12480] = {.count = 1, .reusable = true}, SHIFT(8044),
  [12482] = {.count = 1, .reusable = true}, SHIFT(8045),
  [12484] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2635),
  [12487] = {.count = 1, .reusable = true}, SHIFT(8050),
  [12489] = {.count = 1, .reusable = true}, SHIFT(8051),
  [12491] = {.count = 1, .reusable = true}, SHIFT(8053),
  [12493] = {.count = 1, .reusable = true}, SHIFT(8054),
  [12495] = {.count = 1, .reusable = false}, SHIFT(8057),
  [12497] = {.count = 1, .reusable = false}, SHIFT(8058),
  [12499] = {.count = 1, .reusable = true}, SHIFT(8059),
  [12501] = {.count = 1, .reusable = false}, SHIFT(8063),
  [12503] = {.count = 1, .reusable = true}, SHIFT(8064),
  [12505] = {.count = 1, .reusable = true}, SHIFT(8068),
  [12507] = {.count = 1, .reusable = false}, SHIFT(8064),
  [12509] = {.count = 1, .reusable = true}, SHIFT(8073),
  [12511] = {.count = 1, .reusable = false}, SHIFT(8074),
  [12513] = {.count = 1, .reusable = false}, SHIFT(8075),
  [12515] = {.count = 1, .reusable = true}, SHIFT(8077),
  [12517] = {.count = 1, .reusable = true}, SHIFT(8078),
  [12519] = {.count = 1, .reusable = true}, SHIFT(8079),
  [12521] = {.count = 1, .reusable = true}, SHIFT(8076),
  [12523] = {.count = 1, .reusable = true}, SHIFT(8080),
  [12525] = {.count = 1, .reusable = true}, SHIFT(8081),
  [12527] = {.count = 1, .reusable = false}, SHIFT(8082),
  [12529] = {.count = 1, .reusable = false}, SHIFT(8076),
  [12531] = {.count = 1, .reusable = true}, SHIFT(8075),
  [12533] = {.count = 1, .reusable = false}, SHIFT(8083),
  [12535] = {.count = 1, .reusable = false}, SHIFT(8080),
  [12537] = {.count = 1, .reusable = true}, SHIFT(8083),
  [12539] = {.count = 1, .reusable = true}, SHIFT(8074),
  [12541] = {.count = 1, .reusable = true}, SHIFT(2683),
  [12543] = {.count = 1, .reusable = false}, SHIFT(8101),
  [12545] = {.count = 1, .reusable = true}, SHIFT(8101),
  [12547] = {.count = 1, .reusable = true}, SHIFT(8102),
  [12549] = {.count = 1, .reusable = true}, SHIFT(8103),
  [12551] = {.count = 1, .reusable = true}, SHIFT(8106),
  [12553] = {.count = 1, .reusable = false}, SHIFT(8107),
  [12555] = {.count = 1, .reusable = true}, SHIFT(8108),
  [12557] = {.count = 1, .reusable = true}, SHIFT(8112),
  [12559] = {.count = 1, .reusable = false}, SHIFT(8108),
  [12561] = {.count = 1, .reusable = true}, SHIFT(8119),
  [12563] = {.count = 1, .reusable = true}, SHIFT(8120),
  [12565] = {.count = 1, .reusable = true}, SHIFT(8122),
  [12567] = {.count = 1, .reusable = true}, SHIFT(8127),
  [12569] = {.count = 1, .reusable = false}, SHIFT(8128),
  [12571] = {.count = 1, .reusable = false}, SHIFT(8129),
  [12573] = {.count = 1, .reusable = false}, SHIFT(8131),
  [12575] = {.count = 1, .reusable = true}, SHIFT(8132),
  [12577] = {.count = 1, .reusable = false}, SHIFT(8133),
  [12579] = {.count = 1, .reusable = true}, SHIFT(8130),
  [12581] = {.count = 1, .reusable = true}, SHIFT(8134),
  [12583] = {.count = 1, .reusable = false}, SHIFT(8135),
  [12585] = {.count = 1, .reusable = false}, SHIFT(8136),
  [12587] = {.count = 1, .reusable = true}, SHIFT(8131),
  [12589] = {.count = 1, .reusable = false}, SHIFT(8130),
  [12591] = {.count = 1, .reusable = true}, SHIFT(8129),
  [12593] = {.count = 1, .reusable = false}, SHIFT(8137),
  [12595] = {.count = 1, .reusable = false}, SHIFT(8134),
  [12597] = {.count = 1, .reusable = true}, SHIFT(8135),
  [12599] = {.count = 1, .reusable = true}, SHIFT(8128),
  [12601] = {.count = 1, .reusable = true}, SHIFT(2720),
  [12603] = {.count = 1, .reusable = true}, SHIFT(8157),
  [12605] = {.count = 1, .reusable = true}, SHIFT(8158),
  [12607] = {.count = 1, .reusable = true}, SHIFT(8159),
  [12609] = {.count = 1, .reusable = true}, SHIFT(8160),
  [12611] = {.count = 1, .reusable = true}, SHIFT(8177),
  [12613] = {.count = 1, .reusable = true}, SHIFT(8178),
  [12615] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 4),
  [12617] = {.count = 1, .reusable = true}, SHIFT(8179),
  [12619] = {.count = 1, .reusable = false}, SHIFT(8180),
  [12621] = {.count = 1, .reusable = true}, SHIFT(8180),
  [12623] = {.count = 1, .reusable = true}, SHIFT(8182),
  [12625] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2794),
  [12628] = {.count = 1, .reusable = true}, SHIFT(8185),
  [12630] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5),
  [12632] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5),
  [12634] = {.count = 1, .reusable = false}, SHIFT(8186),
  [12636] = {.count = 1, .reusable = true}, SHIFT(8187),
  [12638] = {.count = 1, .reusable = true}, SHIFT(8191),
  [12640] = {.count = 1, .reusable = false}, SHIFT(8187),
  [12642] = {.count = 1, .reusable = false}, SHIFT(8207),
  [12644] = {.count = 1, .reusable = true}, SHIFT(8207),
  [12646] = {.count = 1, .reusable = true}, SHIFT(8208),
  [12648] = {.count = 1, .reusable = true}, SHIFT(8209),
  [12650] = {.count = 1, .reusable = true}, SHIFT(8212),
  [12652] = {.count = 1, .reusable = false}, SHIFT(8213),
  [12654] = {.count = 1, .reusable = true}, SHIFT(8214),
  [12656] = {.count = 1, .reusable = false}, SHIFT(8224),
  [12658] = {.count = 1, .reusable = false}, SHIFT(8221),
  [12660] = {.count = 1, .reusable = true}, SHIFT(8218),
  [12662] = {.count = 1, .reusable = false}, SHIFT(8220),
  [12664] = {.count = 1, .reusable = false}, SHIFT(8216),
  [12666] = {.count = 1, .reusable = true}, SHIFT(8224),
  [12668] = {.count = 1, .reusable = false}, SHIFT(8217),
  [12670] = {.count = 1, .reusable = true}, SHIFT(8217),
  [12672] = {.count = 1, .reusable = false}, SHIFT(8219),
  [12674] = {.count = 1, .reusable = true}, SHIFT(8220),
  [12676] = {.count = 1, .reusable = false}, SHIFT(8215),
  [12678] = {.count = 1, .reusable = true}, SHIFT(8229),
  [12680] = {.count = 1, .reusable = false}, SHIFT(8214),
  [12682] = {.count = 1, .reusable = true}, SHIFT(8233),
  [12684] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2833),
  [12687] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2834),
  [12690] = {.count = 1, .reusable = true}, SHIFT(8234),
  [12692] = {.count = 1, .reusable = true}, SHIFT(8235),
  [12694] = {.count = 1, .reusable = true}, SHIFT(8236),
  [12696] = {.count = 1, .reusable = true}, SHIFT(8237),
  [12698] = {.count = 1, .reusable = true}, SHIFT(8238),
  [12700] = {.count = 1, .reusable = true}, SHIFT(8241),
  [12702] = {.count = 1, .reusable = false}, SHIFT(8242),
  [12704] = {.count = 1, .reusable = false}, SHIFT(8243),
  [12706] = {.count = 1, .reusable = true}, SHIFT(8244),
  [12708] = {.count = 1, .reusable = true}, SHIFT(8246),
  [12710] = {.count = 1, .reusable = true}, SHIFT(8247),
  [12712] = {.count = 1, .reusable = true}, SHIFT(8248),
  [12714] = {.count = 1, .reusable = true}, SHIFT(8249),
  [12716] = {.count = 1, .reusable = false}, SHIFT(8250),
  [12718] = {.count = 1, .reusable = false}, SHIFT(8252),
  [12720] = {.count = 1, .reusable = true}, SHIFT(8252),
  [12722] = {.count = 1, .reusable = true}, SHIFT(8254),
  [12724] = {.count = 1, .reusable = true}, SHIFT(8255),
  [12726] = {.count = 1, .reusable = true}, SHIFT(8256),
  [12728] = {.count = 1, .reusable = true}, SHIFT(8257),
  [12730] = {.count = 1, .reusable = true}, SHIFT(8258),
  [12732] = {.count = 1, .reusable = true}, SHIFT(2911),
  [12734] = {.count = 1, .reusable = false}, SHIFT(8265),
  [12736] = {.count = 1, .reusable = true}, SHIFT(8266),
  [12738] = {.count = 1, .reusable = true}, SHIFT(8270),
  [12740] = {.count = 1, .reusable = false}, SHIFT(8266),
  [12742] = {.count = 1, .reusable = false}, SHIFT(8286),
  [12744] = {.count = 1, .reusable = true}, SHIFT(8286),
  [12746] = {.count = 1, .reusable = true}, SHIFT(8287),
  [12748] = {.count = 1, .reusable = true}, SHIFT(8288),
  [12750] = {.count = 1, .reusable = true}, SHIFT(8291),
  [12752] = {.count = 1, .reusable = true}, SHIFT(8292),
  [12754] = {.count = 1, .reusable = false}, SHIFT(8293),
  [12756] = {.count = 1, .reusable = true}, SHIFT(8294),
  [12758] = {.count = 1, .reusable = false}, SHIFT(8304),
  [12760] = {.count = 1, .reusable = false}, SHIFT(8301),
  [12762] = {.count = 1, .reusable = true}, SHIFT(8298),
  [12764] = {.count = 1, .reusable = false}, SHIFT(8300),
  [12766] = {.count = 1, .reusable = false}, SHIFT(8296),
  [12768] = {.count = 1, .reusable = true}, SHIFT(8304),
  [12770] = {.count = 1, .reusable = false}, SHIFT(8297),
  [12772] = {.count = 1, .reusable = true}, SHIFT(8297),
  [12774] = {.count = 1, .reusable = false}, SHIFT(8299),
  [12776] = {.count = 1, .reusable = true}, SHIFT(8300),
  [12778] = {.count = 1, .reusable = false}, SHIFT(8295),
  [12780] = {.count = 1, .reusable = true}, SHIFT(8309),
  [12782] = {.count = 1, .reusable = false}, SHIFT(8294),
  [12784] = {.count = 1, .reusable = true}, SHIFT(8313),
  [12786] = {.count = 1, .reusable = true}, SHIFT(8315),
  [12788] = {.count = 1, .reusable = true}, SHIFT(2946),
  [12790] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2955),
  [12793] = {.count = 1, .reusable = true}, SHIFT(8338),
  [12795] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5),
  [12797] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5),
  [12799] = {.count = 1, .reusable = true}, SHIFT(8339),
  [12801] = {.count = 1, .reusable = false}, SHIFT(8351),
  [12803] = {.count = 1, .reusable = false}, SHIFT(8352),
  [12805] = {.count = 1, .reusable = true}, SHIFT(8351),
  [12807] = {.count = 1, .reusable = false}, SHIFT(8343),
  [12809] = {.count = 1, .reusable = true}, SHIFT(8344),
  [12811] = {.count = 1, .reusable = true}, SHIFT(8352),
  [12813] = {.count = 1, .reusable = true}, SHIFT(8346),
  [12815] = {.count = 1, .reusable = true}, SHIFT(8347),
  [12817] = {.count = 1, .reusable = false}, SHIFT(8348),
  [12819] = {.count = 1, .reusable = false}, SHIFT(8346),
  [12821] = {.count = 1, .reusable = false}, SHIFT(8342),
  [12823] = {.count = 1, .reusable = true}, SHIFT(8343),
  [12825] = {.count = 1, .reusable = false}, SHIFT(8345),
  [12827] = {.count = 1, .reusable = false}, SHIFT(8341),
  [12829] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [12831] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [12833] = {.count = 1, .reusable = true}, SHIFT(8356),
  [12835] = {.count = 1, .reusable = true}, SHIFT(8357),
  [12837] = {.count = 1, .reusable = true}, SHIFT(8358),
  [12839] = {.count = 1, .reusable = true}, SHIFT(8360),
  [12841] = {.count = 1, .reusable = true}, SHIFT(8361),
  [12843] = {.count = 1, .reusable = false}, SHIFT(8365),
  [12845] = {.count = 1, .reusable = true}, SHIFT(8366),
  [12847] = {.count = 1, .reusable = true}, SHIFT(8370),
  [12849] = {.count = 1, .reusable = false}, SHIFT(8366),
  [12851] = {.count = 1, .reusable = true}, SHIFT(8377),
  [12853] = {.count = 1, .reusable = false}, SHIFT(8378),
  [12855] = {.count = 1, .reusable = false}, SHIFT(8379),
  [12857] = {.count = 1, .reusable = true}, SHIFT(8381),
  [12859] = {.count = 1, .reusable = true}, SHIFT(8382),
  [12861] = {.count = 1, .reusable = true}, SHIFT(8383),
  [12863] = {.count = 1, .reusable = true}, SHIFT(8384),
  [12865] = {.count = 1, .reusable = true}, SHIFT(8380),
  [12867] = {.count = 1, .reusable = false}, SHIFT(8386),
  [12869] = {.count = 1, .reusable = true}, SHIFT(8385),
  [12871] = {.count = 1, .reusable = false}, SHIFT(8380),
  [12873] = {.count = 1, .reusable = true}, SHIFT(8379),
  [12875] = {.count = 1, .reusable = false}, SHIFT(8387),
  [12877] = {.count = 1, .reusable = false}, SHIFT(8384),
  [12879] = {.count = 1, .reusable = true}, SHIFT(8387),
  [12881] = {.count = 1, .reusable = true}, SHIFT(8378),
  [12883] = {.count = 1, .reusable = true}, SHIFT(2995),
  [12885] = {.count = 1, .reusable = false}, SHIFT(8406),
  [12887] = {.count = 1, .reusable = true}, SHIFT(8406),
  [12889] = {.count = 1, .reusable = true}, SHIFT(8407),
  [12891] = {.count = 1, .reusable = true}, SHIFT(8408),
  [12893] = {.count = 1, .reusable = true}, SHIFT(8411),
  [12895] = {.count = 1, .reusable = false}, SHIFT(8412),
  [12897] = {.count = 1, .reusable = true}, SHIFT(8413),
  [12899] = {.count = 1, .reusable = true}, SHIFT(8417),
  [12901] = {.count = 1, .reusable = false}, SHIFT(8413),
  [12903] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [12905] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [12907] = {.count = 1, .reusable = true}, SHIFT(8421),
  [12909] = {.count = 1, .reusable = true}, SHIFT(8422),
  [12911] = {.count = 1, .reusable = true}, SHIFT(8424),
  [12913] = {.count = 1, .reusable = true}, SHIFT(8428),
  [12915] = {.count = 1, .reusable = false}, SHIFT(8429),
  [12917] = {.count = 1, .reusable = false}, SHIFT(8430),
  [12919] = {.count = 1, .reusable = true}, SHIFT(8432),
  [12921] = {.count = 1, .reusable = true}, SHIFT(8433),
  [12923] = {.count = 1, .reusable = true}, SHIFT(8434),
  [12925] = {.count = 1, .reusable = true}, SHIFT(8435),
  [12927] = {.count = 1, .reusable = true}, SHIFT(8431),
  [12929] = {.count = 1, .reusable = false}, SHIFT(8437),
  [12931] = {.count = 1, .reusable = true}, SHIFT(8436),
  [12933] = {.count = 1, .reusable = false}, SHIFT(8431),
  [12935] = {.count = 1, .reusable = true}, SHIFT(8430),
  [12937] = {.count = 1, .reusable = false}, SHIFT(8438),
  [12939] = {.count = 1, .reusable = false}, SHIFT(8435),
  [12941] = {.count = 1, .reusable = true}, SHIFT(8438),
  [12943] = {.count = 1, .reusable = true}, SHIFT(8429),
  [12945] = {.count = 1, .reusable = true}, SHIFT(8439),
  [12947] = {.count = 1, .reusable = false}, SHIFT(8421),
  [12949] = {.count = 1, .reusable = true}, SHIFT(8446),
  [12951] = {.count = 1, .reusable = false}, SHIFT(8447),
  [12953] = {.count = 1, .reusable = false}, SHIFT(8450),
  [12955] = {.count = 1, .reusable = true}, SHIFT(8449),
  [12957] = {.count = 1, .reusable = false}, SHIFT(8452),
  [12959] = {.count = 1, .reusable = true}, SHIFT(8450),
  [12961] = {.count = 1, .reusable = false}, SHIFT(8454),
  [12963] = {.count = 1, .reusable = false}, SHIFT(8455),
  [12965] = {.count = 1, .reusable = false}, SHIFT(8448),
  [12967] = {.count = 1, .reusable = false}, SHIFT(8456),
  [12969] = {.count = 1, .reusable = false}, SHIFT(8453),
  [12971] = {.count = 1, .reusable = true}, SHIFT(8451),
  [12973] = {.count = 1, .reusable = true}, SHIFT(8453),
  [12975] = {.count = 1, .reusable = false}, SHIFT(8449),
  [12977] = {.count = 1, .reusable = true}, SHIFT(8448),
  [12979] = {.count = 1, .reusable = true}, SHIFT(8454),
  [12981] = {.count = 1, .reusable = true}, SHIFT(8447),
  [12983] = {.count = 1, .reusable = true}, SHIFT(3028),
  [12985] = {.count = 1, .reusable = true}, SHIFT(8476),
  [12987] = {.count = 1, .reusable = false}, SHIFT(8477),
  [12989] = {.count = 1, .reusable = true}, SHIFT(8478),
  [12991] = {.count = 1, .reusable = true}, SHIFT(8482),
  [12993] = {.count = 1, .reusable = false}, SHIFT(8478),
  [12995] = {.count = 1, .reusable = true}, SHIFT(8486),
  [12997] = {.count = 1, .reusable = false}, SHIFT(8499),
  [12999] = {.count = 1, .reusable = true}, SHIFT(8499),
  [13001] = {.count = 1, .reusable = true}, SHIFT(8500),
  [13003] = {.count = 1, .reusable = true}, SHIFT(8501),
  [13005] = {.count = 1, .reusable = true}, SHIFT(8504),
  [13007] = {.count = 1, .reusable = true}, SHIFT(8505),
  [13009] = {.count = 1, .reusable = true}, SHIFT(8507),
  [13011] = {.count = 1, .reusable = true}, SHIFT(8508),
  [13013] = {.count = 1, .reusable = true}, SHIFT(8510),
  [13015] = {.count = 1, .reusable = true}, SHIFT(8511),
  [13017] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [13019] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [13021] = {.count = 1, .reusable = true}, SHIFT(8514),
  [13023] = {.count = 1, .reusable = false}, SHIFT(8515),
  [13025] = {.count = 1, .reusable = false}, SHIFT(8516),
  [13027] = {.count = 1, .reusable = true}, SHIFT(8519),
  [13029] = {.count = 1, .reusable = true}, SHIFT(8520),
  [13031] = {.count = 1, .reusable = true}, SHIFT(8517),
  [13033] = {.count = 1, .reusable = true}, SHIFT(8522),
  [13035] = {.count = 1, .reusable = true}, SHIFT(8521),
  [13037] = {.count = 1, .reusable = true}, SHIFT(8518),
  [13039] = {.count = 1, .reusable = true}, SHIFT(8523),
  [13041] = {.count = 1, .reusable = false}, SHIFT(8524),
  [13043] = {.count = 1, .reusable = false}, SHIFT(8517),
  [13045] = {.count = 1, .reusable = true}, SHIFT(8516),
  [13047] = {.count = 1, .reusable = false}, SHIFT(8522),
  [13049] = {.count = 1, .reusable = false}, SHIFT(8525),
  [13051] = {.count = 1, .reusable = true}, SHIFT(8525),
  [13053] = {.count = 1, .reusable = true}, SHIFT(8515),
  [13055] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 3),
  [13057] = {.count = 1, .reusable = true}, SHIFT(8527),
  [13059] = {.count = 1, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2),
  [13061] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 4),
  [13063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(3077),
  [13066] = {.count = 1, .reusable = true}, SHIFT(8532),
  [13068] = {.count = 1, .reusable = false}, SHIFT(8533),
  [13070] = {.count = 1, .reusable = false}, SHIFT(8534),
  [13072] = {.count = 1, .reusable = true}, SHIFT(8536),
  [13074] = {.count = 1, .reusable = true}, SHIFT(8537),
  [13076] = {.count = 1, .reusable = true}, SHIFT(8538),
  [13078] = {.count = 1, .reusable = true}, SHIFT(8539),
  [13080] = {.count = 1, .reusable = true}, SHIFT(8535),
  [13082] = {.count = 1, .reusable = true}, SHIFT(8540),
  [13084] = {.count = 1, .reusable = false}, SHIFT(8541),
  [13086] = {.count = 1, .reusable = false}, SHIFT(8535),
  [13088] = {.count = 1, .reusable = true}, SHIFT(8534),
  [13090] = {.count = 1, .reusable = false}, SHIFT(8542),
  [13092] = {.count = 1, .reusable = false}, SHIFT(8539),
  [13094] = {.count = 1, .reusable = true}, SHIFT(8542),
  [13096] = {.count = 1, .reusable = true}, SHIFT(8533),
  [13098] = {.count = 1, .reusable = true}, SHIFT(3089),
  [13100] = {.count = 1, .reusable = true}, SHIFT(8561),
  [13102] = {.count = 1, .reusable = true}, SHIFT(8563),
  [13104] = {.count = 1, .reusable = true}, SHIFT(8565),
  [13106] = {.count = 1, .reusable = true}, SHIFT(8567),
  [13108] = {.count = 1, .reusable = true}, SHIFT(8572),
  [13110] = {.count = 1, .reusable = false}, SHIFT(8573),
  [13112] = {.count = 1, .reusable = false}, SHIFT(8574),
  [13114] = {.count = 1, .reusable = false}, SHIFT(8576),
  [13116] = {.count = 1, .reusable = true}, SHIFT(8577),
  [13118] = {.count = 1, .reusable = false}, SHIFT(8578),
  [13120] = {.count = 1, .reusable = true}, SHIFT(8579),
  [13122] = {.count = 1, .reusable = true}, SHIFT(8575),
  [13124] = {.count = 1, .reusable = false}, SHIFT(8580),
  [13126] = {.count = 1, .reusable = false}, SHIFT(8581),
  [13128] = {.count = 1, .reusable = true}, SHIFT(8576),
  [13130] = {.count = 1, .reusable = false}, SHIFT(8575),
  [13132] = {.count = 1, .reusable = true}, SHIFT(8574),
  [13134] = {.count = 1, .reusable = false}, SHIFT(8582),
  [13136] = {.count = 1, .reusable = false}, SHIFT(8579),
  [13138] = {.count = 1, .reusable = true}, SHIFT(8580),
  [13140] = {.count = 1, .reusable = true}, SHIFT(8573),
  [13142] = {.count = 1, .reusable = true}, SHIFT(3124),
  [13144] = {.count = 1, .reusable = true}, SHIFT(8604),
  [13146] = {.count = 1, .reusable = false}, SHIFT(8602),
  [13148] = {.count = 1, .reusable = true}, SHIFT(8606),
  [13150] = {.count = 1, .reusable = true}, SHIFT(5910),
  [13152] = {.count = 1, .reusable = true}, SHIFT(6130),
  [13154] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 3),
  [13156] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 3),
  [13158] = {.count = 1, .reusable = true}, SHIFT(8610),
  [13160] = {.count = 1, .reusable = true}, SHIFT(8611),
  [13162] = {.count = 1, .reusable = true}, SHIFT(8613),
  [13164] = {.count = 1, .reusable = true}, SHIFT(8615),
  [13166] = {.count = 1, .reusable = true}, SHIFT(8616),
  [13168] = {.count = 1, .reusable = true}, SHIFT(8617),
  [13170] = {.count = 1, .reusable = true}, SHIFT(8618),
  [13172] = {.count = 1, .reusable = true}, SHIFT(8619),
  [13174] = {.count = 1, .reusable = true}, SHIFT(8620),
  [13176] = {.count = 1, .reusable = false}, SHIFT(8621),
  [13178] = {.count = 1, .reusable = false}, SHIFT(8623),
  [13180] = {.count = 1, .reusable = true}, SHIFT(8623),
  [13182] = {.count = 1, .reusable = true}, SHIFT(8625),
  [13184] = {.count = 1, .reusable = true}, SHIFT(8626),
  [13186] = {.count = 1, .reusable = true}, SHIFT(8627),
  [13188] = {.count = 1, .reusable = true}, SHIFT(8628),
  [13190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(3183),
  [13193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3184),
  [13196] = {.count = 1, .reusable = true}, SHIFT(8634),
  [13198] = {.count = 1, .reusable = true}, SHIFT(8635),
  [13200] = {.count = 1, .reusable = true}, SHIFT(3219),
  [13202] = {.count = 1, .reusable = true}, SHIFT(8647),
  [13204] = {.count = 1, .reusable = false}, SHIFT(8660),
  [13206] = {.count = 1, .reusable = true}, SHIFT(8660),
  [13208] = {.count = 1, .reusable = true}, SHIFT(8661),
  [13210] = {.count = 1, .reusable = true}, SHIFT(8662),
  [13212] = {.count = 1, .reusable = true}, SHIFT(8665),
  [13214] = {.count = 1, .reusable = true}, SHIFT(8668),
  [13216] = {.count = 1, .reusable = true}, SHIFT(8667),
  [13218] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8670),
  [13221] = {.count = 1, .reusable = true}, SHIFT(8674),
  [13223] = {.count = 1, .reusable = true}, SHIFT(8675),
  [13225] = {.count = 1, .reusable = true}, SHIFT(8677),
  [13227] = {.count = 1, .reusable = true}, SHIFT(3260),
  [13229] = {.count = 1, .reusable = false}, SHIFT(8684),
  [13231] = {.count = 1, .reusable = false}, SHIFT(8685),
  [13233] = {.count = 1, .reusable = true}, SHIFT(8686),
  [13235] = {.count = 1, .reusable = true}, SHIFT(8688),
  [13237] = {.count = 1, .reusable = true}, SHIFT(8689),
  [13239] = {.count = 1, .reusable = true}, SHIFT(8690),
  [13241] = {.count = 1, .reusable = true}, SHIFT(8691),
  [13243] = {.count = 1, .reusable = true}, SHIFT(8692),
  [13245] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [13247] = {.count = 1, .reusable = true}, SHIFT(6056),
  [13249] = {.count = 1, .reusable = true}, SHIFT(8696),
  [13251] = {.count = 1, .reusable = true}, SHIFT(8697),
  [13253] = {.count = 1, .reusable = false}, SHIFT(8698),
  [13255] = {.count = 1, .reusable = true}, SHIFT(8698),
  [13257] = {.count = 1, .reusable = true}, SHIFT(8700),
  [13259] = {.count = 1, .reusable = true}, SHIFT(8701),
  [13261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(3333),
  [13264] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3334),
  [13267] = {.count = 1, .reusable = true}, SHIFT(3347),
  [13269] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3365),
  [13272] = {.count = 1, .reusable = true}, SHIFT(8727),
  [13274] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [13276] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [13278] = {.count = 1, .reusable = true}, SHIFT(8742),
  [13280] = {.count = 1, .reusable = false}, SHIFT(8744),
  [13282] = {.count = 1, .reusable = true}, SHIFT(8745),
  [13284] = {.count = 1, .reusable = true}, SHIFT(8747),
  [13286] = {.count = 1, .reusable = false}, SHIFT(8748),
  [13288] = {.count = 1, .reusable = false}, SHIFT(8746),
  [13290] = {.count = 1, .reusable = true}, SHIFT(8746),
  [13292] = {.count = 1, .reusable = true}, SHIFT(8748),
  [13294] = {.count = 1, .reusable = true}, SHIFT(8754),
  [13296] = {.count = 1, .reusable = false}, SHIFT(8745),
  [13298] = {.count = 1, .reusable = true}, SHIFT(8758),
  [13300] = {.count = 1, .reusable = false}, SHIFT(8771),
  [13302] = {.count = 1, .reusable = true}, SHIFT(8771),
  [13304] = {.count = 1, .reusable = true}, SHIFT(8772),
  [13306] = {.count = 1, .reusable = true}, SHIFT(8773),
  [13308] = {.count = 1, .reusable = true}, SHIFT(8776),
  [13310] = {.count = 1, .reusable = true}, SHIFT(8778),
  [13312] = {.count = 1, .reusable = true}, SHIFT(8777),
  [13314] = {.count = 1, .reusable = false}, SHIFT(8790),
  [13316] = {.count = 1, .reusable = false}, SHIFT(8779),
  [13318] = {.count = 1, .reusable = false}, SHIFT(8792),
  [13320] = {.count = 1, .reusable = true}, SHIFT(8790),
  [13322] = {.count = 1, .reusable = false}, SHIFT(8780),
  [13324] = {.count = 1, .reusable = true}, SHIFT(8781),
  [13326] = {.count = 1, .reusable = true}, SHIFT(8792),
  [13328] = {.count = 1, .reusable = true}, SHIFT(8782),
  [13330] = {.count = 1, .reusable = true}, SHIFT(8783),
  [13332] = {.count = 1, .reusable = false}, SHIFT(8784),
  [13334] = {.count = 1, .reusable = false}, SHIFT(8782),
  [13336] = {.count = 1, .reusable = true}, SHIFT(8785),
  [13338] = {.count = 1, .reusable = false}, SHIFT(8786),
  [13340] = {.count = 1, .reusable = true}, SHIFT(8780),
  [13342] = {.count = 1, .reusable = false}, SHIFT(8787),
  [13344] = {.count = 1, .reusable = false}, SHIFT(8788),
  [13346] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3),
  [13348] = {.count = 1, .reusable = false}, SHIFT(8798),
  [13350] = {.count = 1, .reusable = true}, REDUCE(sym_when, 3),
  [13352] = {.count = 1, .reusable = true}, SHIFT(8799),
  [13354] = {.count = 1, .reusable = false}, SHIFT(8802),
  [13356] = {.count = 1, .reusable = true}, SHIFT(8803),
  [13358] = {.count = 1, .reusable = false}, SHIFT(8813),
  [13360] = {.count = 1, .reusable = false}, SHIFT(8810),
  [13362] = {.count = 1, .reusable = true}, SHIFT(8807),
  [13364] = {.count = 1, .reusable = false}, SHIFT(8809),
  [13366] = {.count = 1, .reusable = false}, SHIFT(8814),
  [13368] = {.count = 1, .reusable = false}, SHIFT(8805),
  [13370] = {.count = 1, .reusable = true}, SHIFT(8813),
  [13372] = {.count = 1, .reusable = false}, SHIFT(8806),
  [13374] = {.count = 1, .reusable = true}, SHIFT(8814),
  [13376] = {.count = 1, .reusable = true}, SHIFT(8806),
  [13378] = {.count = 1, .reusable = false}, SHIFT(8808),
  [13380] = {.count = 1, .reusable = true}, SHIFT(8809),
  [13382] = {.count = 1, .reusable = false}, SHIFT(8804),
  [13384] = {.count = 1, .reusable = true}, SHIFT(8819),
  [13386] = {.count = 1, .reusable = false}, SHIFT(8803),
  [13388] = {.count = 1, .reusable = true}, SHIFT(3435),
  [13390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3453),
  [13393] = {.count = 1, .reusable = true}, SHIFT(8847),
  [13395] = {.count = 1, .reusable = true}, SHIFT(8848),
  [13397] = {.count = 1, .reusable = true}, SHIFT(8850),
  [13399] = {.count = 1, .reusable = true}, SHIFT(3473),
  [13401] = {.count = 1, .reusable = true}, SHIFT(8857),
  [13403] = {.count = 1, .reusable = true}, SHIFT(8859),
  [13405] = {.count = 1, .reusable = false}, SHIFT(8862),
  [13407] = {.count = 1, .reusable = true}, SHIFT(8863),
  [13409] = {.count = 1, .reusable = true}, SHIFT(8867),
  [13411] = {.count = 1, .reusable = false}, SHIFT(8863),
  [13413] = {.count = 1, .reusable = false}, SHIFT(8870),
  [13415] = {.count = 1, .reusable = true}, SHIFT(8871),
  [13417] = {.count = 1, .reusable = true}, SHIFT(8872),
  [13419] = {.count = 1, .reusable = true}, SHIFT(8873),
  [13421] = {.count = 1, .reusable = true}, SHIFT(8881),
  [13423] = {.count = 1, .reusable = false}, SHIFT(8882),
  [13425] = {.count = 1, .reusable = false}, SHIFT(8883),
  [13427] = {.count = 1, .reusable = true}, SHIFT(8886),
  [13429] = {.count = 1, .reusable = true}, SHIFT(8887),
  [13431] = {.count = 1, .reusable = true}, SHIFT(8884),
  [13433] = {.count = 1, .reusable = true}, SHIFT(8888),
  [13435] = {.count = 1, .reusable = true}, SHIFT(8889),
  [13437] = {.count = 1, .reusable = true}, SHIFT(8885),
  [13439] = {.count = 1, .reusable = true}, SHIFT(8890),
  [13441] = {.count = 1, .reusable = false}, SHIFT(8891),
  [13443] = {.count = 1, .reusable = false}, SHIFT(8884),
  [13445] = {.count = 1, .reusable = true}, SHIFT(8883),
  [13447] = {.count = 1, .reusable = false}, SHIFT(8889),
  [13449] = {.count = 1, .reusable = false}, SHIFT(8892),
  [13451] = {.count = 1, .reusable = true}, SHIFT(8892),
  [13453] = {.count = 1, .reusable = true}, SHIFT(8882),
  [13455] = {.count = 1, .reusable = true}, SHIFT(8912),
  [13457] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3544),
  [13460] = {.count = 1, .reusable = true}, SHIFT(8942),
  [13462] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5),
  [13464] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5),
  [13466] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5),
  [13468] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5),
  [13470] = {.count = 1, .reusable = true}, SHIFT(8944),
  [13472] = {.count = 1, .reusable = true}, SHIFT(3591),
  [13474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3611),
  [13477] = {.count = 1, .reusable = true}, SHIFT(8967),
  [13479] = {.count = 1, .reusable = true}, SHIFT(3641),
  [13481] = {.count = 1, .reusable = false}, SHIFT(8987),
  [13483] = {.count = 1, .reusable = true}, SHIFT(8987),
  [13485] = {.count = 1, .reusable = true}, SHIFT(8988),
  [13487] = {.count = 1, .reusable = true}, SHIFT(8989),
  [13489] = {.count = 1, .reusable = true}, SHIFT(8992),
  [13491] = {.count = 1, .reusable = true}, SHIFT(8994),
  [13493] = {.count = 1, .reusable = true}, SHIFT(8997),
  [13495] = {.count = 1, .reusable = false}, SHIFT(8998),
  [13497] = {.count = 1, .reusable = true}, SHIFT(9000),
  [13499] = {.count = 1, .reusable = false}, SHIFT(9001),
  [13501] = {.count = 1, .reusable = true}, SHIFT(9002),
  [13503] = {.count = 1, .reusable = true}, SHIFT(9003),
  [13505] = {.count = 1, .reusable = true}, SHIFT(9004),
  [13507] = {.count = 1, .reusable = false}, SHIFT(6427),
  [13509] = {.count = 1, .reusable = false}, SHIFT(9016),
  [13511] = {.count = 1, .reusable = true}, SHIFT(9013),
  [13513] = {.count = 1, .reusable = false}, SHIFT(9015),
  [13515] = {.count = 1, .reusable = false}, SHIFT(9011),
  [13517] = {.count = 1, .reusable = false}, SHIFT(9012),
  [13519] = {.count = 1, .reusable = true}, SHIFT(9012),
  [13521] = {.count = 1, .reusable = false}, SHIFT(9014),
  [13523] = {.count = 1, .reusable = true}, SHIFT(9015),
  [13525] = {.count = 1, .reusable = false}, SHIFT(9010),
  [13527] = {.count = 1, .reusable = true}, SHIFT(9021),
  [13529] = {.count = 1, .reusable = true}, SHIFT(9026),
  [13531] = {.count = 1, .reusable = true}, SHIFT(9027),
  [13533] = {.count = 1, .reusable = true}, SHIFT(9028),
  [13535] = {.count = 1, .reusable = true}, SHIFT(9031),
  [13537] = {.count = 1, .reusable = false}, SHIFT(9026),
  [13539] = {.count = 1, .reusable = false}, SHIFT(9032),
  [13541] = {.count = 1, .reusable = true}, SHIFT(9033),
  [13543] = {.count = 1, .reusable = true}, SHIFT(9034),
  [13545] = {.count = 1, .reusable = true}, SHIFT(9035),
  [13547] = {.count = 1, .reusable = true}, SHIFT(9036),
  [13549] = {.count = 1, .reusable = true}, SHIFT(9037),
  [13551] = {.count = 1, .reusable = true}, SHIFT(9038),
  [13553] = {.count = 1, .reusable = true}, SHIFT(9039),
  [13555] = {.count = 1, .reusable = false}, SHIFT(9040),
  [13557] = {.count = 1, .reusable = false}, SHIFT(9035),
  [13559] = {.count = 1, .reusable = true}, SHIFT(9032),
  [13561] = {.count = 1, .reusable = false}, SHIFT(9037),
  [13563] = {.count = 1, .reusable = false}, SHIFT(9041),
  [13565] = {.count = 1, .reusable = true}, SHIFT(9041),
  [13567] = {.count = 1, .reusable = false}, SHIFT(9000),
  [13569] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4),
  [13571] = {.count = 1, .reusable = true}, SHIFT(9046),
  [13573] = {.count = 1, .reusable = true}, SHIFT(9047),
  [13575] = {.count = 1, .reusable = true}, SHIFT(9049),
  [13577] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [13579] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3673),
  [13582] = {.count = 1, .reusable = true}, SHIFT(3685),
  [13584] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4),
  [13586] = {.count = 1, .reusable = false}, SHIFT(9074),
  [13588] = {.count = 1, .reusable = true}, SHIFT(9075),
  [13590] = {.count = 1, .reusable = true}, SHIFT(9079),
  [13592] = {.count = 1, .reusable = false}, SHIFT(9075),
  [13594] = {.count = 1, .reusable = true}, SHIFT(9086),
  [13596] = {.count = 1, .reusable = false}, SHIFT(9087),
  [13598] = {.count = 1, .reusable = false}, SHIFT(9088),
  [13600] = {.count = 1, .reusable = true}, SHIFT(9090),
  [13602] = {.count = 1, .reusable = true}, SHIFT(9091),
  [13604] = {.count = 1, .reusable = true}, SHIFT(9092),
  [13606] = {.count = 1, .reusable = true}, SHIFT(9093),
  [13608] = {.count = 1, .reusable = true}, SHIFT(9089),
  [13610] = {.count = 1, .reusable = false}, SHIFT(9095),
  [13612] = {.count = 1, .reusable = true}, SHIFT(9094),
  [13614] = {.count = 1, .reusable = false}, SHIFT(9089),
  [13616] = {.count = 1, .reusable = true}, SHIFT(9088),
  [13618] = {.count = 1, .reusable = false}, SHIFT(9096),
  [13620] = {.count = 1, .reusable = false}, SHIFT(9093),
  [13622] = {.count = 1, .reusable = true}, SHIFT(9096),
  [13624] = {.count = 1, .reusable = true}, SHIFT(9087),
  [13626] = {.count = 1, .reusable = true}, SHIFT(3716),
  [13628] = {.count = 1, .reusable = false}, SHIFT(9115),
  [13630] = {.count = 1, .reusable = true}, SHIFT(9115),
  [13632] = {.count = 1, .reusable = true}, SHIFT(9116),
  [13634] = {.count = 1, .reusable = true}, SHIFT(9117),
  [13636] = {.count = 1, .reusable = true}, SHIFT(9120),
  [13638] = {.count = 1, .reusable = false}, SHIFT(9121),
  [13640] = {.count = 1, .reusable = true}, SHIFT(9122),
  [13642] = {.count = 1, .reusable = true}, SHIFT(9126),
  [13644] = {.count = 1, .reusable = false}, SHIFT(9122),
  [13646] = {.count = 1, .reusable = true}, SHIFT(9130),
  [13648] = {.count = 1, .reusable = true}, SHIFT(9132),
  [13650] = {.count = 1, .reusable = true}, SHIFT(9136),
  [13652] = {.count = 1, .reusable = false}, SHIFT(9137),
  [13654] = {.count = 1, .reusable = false}, SHIFT(9138),
  [13656] = {.count = 1, .reusable = true}, SHIFT(9140),
  [13658] = {.count = 1, .reusable = true}, SHIFT(9141),
  [13660] = {.count = 1, .reusable = true}, SHIFT(9142),
  [13662] = {.count = 1, .reusable = true}, SHIFT(9143),
  [13664] = {.count = 1, .reusable = true}, SHIFT(9139),
  [13666] = {.count = 1, .reusable = false}, SHIFT(9145),
  [13668] = {.count = 1, .reusable = true}, SHIFT(9144),
  [13670] = {.count = 1, .reusable = false}, SHIFT(9139),
  [13672] = {.count = 1, .reusable = true}, SHIFT(9138),
  [13674] = {.count = 1, .reusable = false}, SHIFT(9146),
  [13676] = {.count = 1, .reusable = false}, SHIFT(9143),
  [13678] = {.count = 1, .reusable = true}, SHIFT(9146),
  [13680] = {.count = 1, .reusable = true}, SHIFT(9137),
  [13682] = {.count = 1, .reusable = true}, SHIFT(9147),
  [13684] = {.count = 1, .reusable = true}, SHIFT(9153),
  [13686] = {.count = 1, .reusable = false}, SHIFT(9154),
  [13688] = {.count = 1, .reusable = false}, SHIFT(9157),
  [13690] = {.count = 1, .reusable = true}, SHIFT(9156),
  [13692] = {.count = 1, .reusable = false}, SHIFT(9159),
  [13694] = {.count = 1, .reusable = true}, SHIFT(9157),
  [13696] = {.count = 1, .reusable = false}, SHIFT(9161),
  [13698] = {.count = 1, .reusable = false}, SHIFT(9162),
  [13700] = {.count = 1, .reusable = false}, SHIFT(9155),
  [13702] = {.count = 1, .reusable = false}, SHIFT(9163),
  [13704] = {.count = 1, .reusable = false}, SHIFT(9160),
  [13706] = {.count = 1, .reusable = true}, SHIFT(9158),
  [13708] = {.count = 1, .reusable = true}, SHIFT(9160),
  [13710] = {.count = 1, .reusable = false}, SHIFT(9156),
  [13712] = {.count = 1, .reusable = true}, SHIFT(9155),
  [13714] = {.count = 1, .reusable = true}, SHIFT(9161),
  [13716] = {.count = 1, .reusable = true}, SHIFT(9154),
  [13718] = {.count = 1, .reusable = true}, SHIFT(3747),
  [13720] = {.count = 1, .reusable = true}, SHIFT(9183),
  [13722] = {.count = 1, .reusable = true}, SHIFT(3781),
  [13724] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3799),
  [13727] = {.count = 1, .reusable = true}, SHIFT(9208),
  [13729] = {.count = 1, .reusable = true}, SHIFT(9209),
  [13731] = {.count = 1, .reusable = true}, SHIFT(9211),
  [13733] = {.count = 1, .reusable = true}, SHIFT(3819),
  [13735] = {.count = 1, .reusable = true}, SHIFT(9218),
  [13737] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 4),
  [13739] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 4),
  [13741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3867),
  [13744] = {.count = 1, .reusable = true}, SHIFT(9248),
  [13746] = {.count = 1, .reusable = true}, SHIFT(9250),
  [13748] = {.count = 1, .reusable = true}, SHIFT(9251),
  [13750] = {.count = 1, .reusable = true}, SHIFT(3910),
  [13752] = {.count = 1, .reusable = false}, SHIFT(9258),
  [13754] = {.count = 1, .reusable = true}, SHIFT(9259),
  [13756] = {.count = 1, .reusable = true}, SHIFT(9263),
  [13758] = {.count = 1, .reusable = false}, SHIFT(9259),
  [13760] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3929),
  [13763] = {.count = 1, .reusable = true}, SHIFT(9282),
  [13765] = {.count = 1, .reusable = false}, SHIFT(6793),
  [13767] = {.count = 1, .reusable = true}, SHIFT(6797),
  [13769] = {.count = 1, .reusable = false}, SHIFT(9286),
  [13771] = {.count = 1, .reusable = true}, SHIFT(9288),
  [13773] = {.count = 1, .reusable = true}, SHIFT(9289),
  [13775] = {.count = 1, .reusable = false}, SHIFT(9290),
  [13777] = {.count = 1, .reusable = true}, SHIFT(9291),
  [13779] = {.count = 1, .reusable = true}, SHIFT(9292),
  [13781] = {.count = 1, .reusable = true}, SHIFT(9293),
  [13783] = {.count = 1, .reusable = false}, SHIFT(9305),
  [13785] = {.count = 1, .reusable = true}, SHIFT(9302),
  [13787] = {.count = 1, .reusable = false}, SHIFT(9304),
  [13789] = {.count = 1, .reusable = false}, SHIFT(9300),
  [13791] = {.count = 1, .reusable = false}, SHIFT(9301),
  [13793] = {.count = 1, .reusable = true}, SHIFT(9301),
  [13795] = {.count = 1, .reusable = false}, SHIFT(9303),
  [13797] = {.count = 1, .reusable = true}, SHIFT(9304),
  [13799] = {.count = 1, .reusable = false}, SHIFT(9299),
  [13801] = {.count = 1, .reusable = true}, SHIFT(9312),
  [13803] = {.count = 1, .reusable = true}, SHIFT(9315),
  [13805] = {.count = 1, .reusable = false}, SHIFT(9316),
  [13807] = {.count = 1, .reusable = false}, SHIFT(9317),
  [13809] = {.count = 1, .reusable = true}, SHIFT(9318),
  [13811] = {.count = 1, .reusable = true}, SHIFT(9319),
  [13813] = {.count = 1, .reusable = true}, SHIFT(9321),
  [13815] = {.count = 1, .reusable = true}, SHIFT(9322),
  [13817] = {.count = 1, .reusable = true}, SHIFT(9320),
  [13819] = {.count = 1, .reusable = false}, SHIFT(9324),
  [13821] = {.count = 1, .reusable = true}, SHIFT(9323),
  [13823] = {.count = 1, .reusable = false}, SHIFT(9320),
  [13825] = {.count = 1, .reusable = true}, SHIFT(9317),
  [13827] = {.count = 1, .reusable = false}, SHIFT(9325),
  [13829] = {.count = 1, .reusable = false}, SHIFT(9322),
  [13831] = {.count = 1, .reusable = true}, SHIFT(9325),
  [13833] = {.count = 1, .reusable = true}, SHIFT(9327),
  [13835] = {.count = 1, .reusable = false}, SHIFT(9326),
  [13837] = {.count = 1, .reusable = true}, SHIFT(9326),
  [13839] = {.count = 1, .reusable = false}, SHIFT(9328),
  [13841] = {.count = 1, .reusable = true}, SHIFT(9329),
  [13843] = {.count = 1, .reusable = true}, SHIFT(9331),
  [13845] = {.count = 1, .reusable = true}, SHIFT(9330),
  [13847] = {.count = 1, .reusable = true}, SHIFT(9316),
  [13849] = {.count = 1, .reusable = false}, SHIFT(9289),
  [13851] = {.count = 1, .reusable = true}, SHIFT(9342),
  [13853] = {.count = 1, .reusable = true}, SHIFT(9341),
  [13855] = {.count = 1, .reusable = false}, SHIFT(9345),
  [13857] = {.count = 1, .reusable = true}, SHIFT(9345),
  [13859] = {.count = 1, .reusable = true}, SHIFT(9346),
  [13861] = {.count = 1, .reusable = true}, SHIFT(9347),
  [13863] = {.count = 1, .reusable = true}, SHIFT(9350),
  [13865] = {.count = 1, .reusable = true}, SHIFT(9353),
  [13867] = {.count = 1, .reusable = false}, SHIFT(9354),
  [13869] = {.count = 1, .reusable = true}, SHIFT(9351),
  [13871] = {.count = 1, .reusable = false}, SHIFT(9352),
  [13873] = {.count = 1, .reusable = true}, SHIFT(9352),
  [13875] = {.count = 1, .reusable = true}, SHIFT(9354),
  [13877] = {.count = 1, .reusable = false}, SHIFT(6824),
  [13879] = {.count = 1, .reusable = false}, SHIFT(9361),
  [13881] = {.count = 1, .reusable = true}, SHIFT(9363),
  [13883] = {.count = 1, .reusable = false}, SHIFT(9373),
  [13885] = {.count = 1, .reusable = false}, SHIFT(9370),
  [13887] = {.count = 1, .reusable = true}, SHIFT(9367),
  [13889] = {.count = 1, .reusable = false}, SHIFT(9369),
  [13891] = {.count = 1, .reusable = false}, SHIFT(9374),
  [13893] = {.count = 1, .reusable = false}, SHIFT(9365),
  [13895] = {.count = 1, .reusable = true}, SHIFT(9373),
  [13897] = {.count = 1, .reusable = false}, SHIFT(9366),
  [13899] = {.count = 1, .reusable = true}, SHIFT(9374),
  [13901] = {.count = 1, .reusable = true}, SHIFT(9366),
  [13903] = {.count = 1, .reusable = false}, SHIFT(9368),
  [13905] = {.count = 1, .reusable = true}, SHIFT(9369),
  [13907] = {.count = 1, .reusable = false}, SHIFT(9364),
  [13909] = {.count = 1, .reusable = true}, SHIFT(9379),
  [13911] = {.count = 1, .reusable = true}, SHIFT(9380),
  [13913] = {.count = 1, .reusable = true}, SHIFT(9383),
  [13915] = {.count = 1, .reusable = false}, SHIFT(9379),
  [13917] = {.count = 1, .reusable = false}, SHIFT(9385),
  [13919] = {.count = 1, .reusable = true}, SHIFT(9387),
  [13921] = {.count = 1, .reusable = false}, SHIFT(9388),
  [13923] = {.count = 1, .reusable = true}, SHIFT(9385),
  [13925] = {.count = 1, .reusable = false}, SHIFT(9390),
  [13927] = {.count = 1, .reusable = false}, SHIFT(9391),
  [13929] = {.count = 1, .reusable = false}, SHIFT(9384),
  [13931] = {.count = 1, .reusable = false}, SHIFT(9392),
  [13933] = {.count = 1, .reusable = false}, SHIFT(9389),
  [13935] = {.count = 1, .reusable = true}, SHIFT(9386),
  [13937] = {.count = 1, .reusable = true}, SHIFT(9389),
  [13939] = {.count = 1, .reusable = false}, SHIFT(9387),
  [13941] = {.count = 1, .reusable = true}, SHIFT(9384),
  [13943] = {.count = 1, .reusable = true}, SHIFT(9390),
  [13945] = {.count = 1, .reusable = false}, SHIFT(9363),
  [13947] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3950),
  [13950] = {.count = 1, .reusable = true}, SHIFT(9407),
  [13952] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5),
  [13954] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5),
  [13956] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 21),
  [13958] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 21),
  [13960] = {.count = 1, .reusable = true}, SHIFT(9409),
  [13962] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 22),
  [13964] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 22),
  [13966] = {.count = 1, .reusable = true}, SHIFT(9410),
  [13968] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [13970] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3999),
  [13973] = {.count = 1, .reusable = true}, SHIFT(9411),
  [13975] = {.count = 1, .reusable = true}, SHIFT(9412),
  [13977] = {.count = 1, .reusable = true}, SHIFT(9413),
  [13979] = {.count = 1, .reusable = true}, SHIFT(9414),
  [13981] = {.count = 1, .reusable = true}, SHIFT(9415),
  [13983] = {.count = 1, .reusable = true}, SHIFT(4020),
  [13985] = {.count = 1, .reusable = true}, SHIFT(9422),
  [13987] = {.count = 1, .reusable = true}, SHIFT(9424),
  [13989] = {.count = 1, .reusable = true}, SHIFT(9428),
  [13991] = {.count = 1, .reusable = false}, SHIFT(9429),
  [13993] = {.count = 1, .reusable = false}, SHIFT(9430),
  [13995] = {.count = 1, .reusable = true}, SHIFT(9432),
  [13997] = {.count = 1, .reusable = true}, SHIFT(9433),
  [13999] = {.count = 1, .reusable = true}, SHIFT(9434),
  [14001] = {.count = 1, .reusable = true}, SHIFT(9435),
  [14003] = {.count = 1, .reusable = true}, SHIFT(9431),
  [14005] = {.count = 1, .reusable = false}, SHIFT(9437),
  [14007] = {.count = 1, .reusable = true}, SHIFT(9436),
  [14009] = {.count = 1, .reusable = false}, SHIFT(9431),
  [14011] = {.count = 1, .reusable = true}, SHIFT(9430),
  [14013] = {.count = 1, .reusable = false}, SHIFT(9438),
  [14015] = {.count = 1, .reusable = false}, SHIFT(9435),
  [14017] = {.count = 1, .reusable = true}, SHIFT(9438),
  [14019] = {.count = 1, .reusable = true}, SHIFT(9429),
  [14021] = {.count = 1, .reusable = true}, SHIFT(9439),
  [14023] = {.count = 1, .reusable = true}, SHIFT(4036),
  [14025] = {.count = 1, .reusable = true}, SHIFT(9447),
  [14027] = {.count = 1, .reusable = true}, SHIFT(9448),
  [14029] = {.count = 1, .reusable = false}, SHIFT(9449),
  [14031] = {.count = 1, .reusable = true}, SHIFT(9451),
  [14033] = {.count = 1, .reusable = false}, SHIFT(9451),
  [14035] = {.count = 1, .reusable = true}, SHIFT(9453),
  [14037] = {.count = 1, .reusable = false}, SHIFT(9454),
  [14039] = {.count = 1, .reusable = true}, SHIFT(9456),
  [14041] = {.count = 1, .reusable = true}, SHIFT(9459),
  [14043] = {.count = 1, .reusable = true}, SHIFT(9460),
  [14045] = {.count = 1, .reusable = true}, SHIFT(9461),
  [14047] = {.count = 1, .reusable = true}, SHIFT(9462),
  [14049] = {.count = 1, .reusable = true}, SHIFT(9464),
  [14051] = {.count = 1, .reusable = true}, SHIFT(9465),
  [14053] = {.count = 1, .reusable = false}, SHIFT(9466),
  [14055] = {.count = 1, .reusable = true}, SHIFT(9466),
  [14057] = {.count = 1, .reusable = true}, SHIFT(9468),
  [14059] = {.count = 1, .reusable = false}, SHIFT(9469),
  [14061] = {.count = 1, .reusable = true}, SHIFT(9470),
  [14063] = {.count = 1, .reusable = false}, SHIFT(9471),
  [14065] = {.count = 1, .reusable = true}, SHIFT(9472),
  [14067] = {.count = 1, .reusable = true}, SHIFT(9475),
  [14069] = {.count = 1, .reusable = true}, SHIFT(9476),
  [14071] = {.count = 1, .reusable = true}, SHIFT(9477),
  [14073] = {.count = 1, .reusable = true}, SHIFT(9479),
  [14075] = {.count = 1, .reusable = true}, SHIFT(9480),
  [14077] = {.count = 1, .reusable = true}, SHIFT(9481),
  [14079] = {.count = 1, .reusable = false}, SHIFT(9482),
  [14081] = {.count = 1, .reusable = true}, SHIFT(9484),
  [14083] = {.count = 1, .reusable = true}, SHIFT(9485),
  [14085] = {.count = 1, .reusable = false}, SHIFT(9486),
  [14087] = {.count = 1, .reusable = true}, SHIFT(4115),
  [14089] = {.count = 1, .reusable = false}, SHIFT(9488),
  [14091] = {.count = 1, .reusable = true}, SHIFT(9488),
  [14093] = {.count = 1, .reusable = true}, SHIFT(9492),
  [14095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1719),
  [14098] = {.count = 1, .reusable = true}, SHIFT(9493),
  [14100] = {.count = 1, .reusable = false}, SHIFT(9496),
  [14102] = {.count = 1, .reusable = false}, SHIFT(9497),
  [14104] = {.count = 1, .reusable = true}, SHIFT(9498),
  [14106] = {.count = 1, .reusable = true}, SHIFT(9500),
  [14108] = {.count = 1, .reusable = true}, SHIFT(9501),
  [14110] = {.count = 1, .reusable = true}, SHIFT(9502),
  [14112] = {.count = 1, .reusable = true}, SHIFT(9503),
  [14114] = {.count = 1, .reusable = true}, SHIFT(7025),
  [14116] = {.count = 1, .reusable = true}, SHIFT(9507),
  [14118] = {.count = 1, .reusable = false}, SHIFT(9511),
  [14120] = {.count = 1, .reusable = true}, SHIFT(9512),
  [14122] = {.count = 1, .reusable = true}, SHIFT(9516),
  [14124] = {.count = 1, .reusable = false}, SHIFT(9512),
  [14126] = {.count = 1, .reusable = true}, SHIFT(9523),
  [14128] = {.count = 1, .reusable = true}, SHIFT(9524),
  [14130] = {.count = 1, .reusable = false}, SHIFT(9525),
  [14132] = {.count = 1, .reusable = false}, SHIFT(9526),
  [14134] = {.count = 1, .reusable = true}, SHIFT(9528),
  [14136] = {.count = 1, .reusable = true}, SHIFT(9529),
  [14138] = {.count = 1, .reusable = true}, SHIFT(9530),
  [14140] = {.count = 1, .reusable = true}, SHIFT(9527),
  [14142] = {.count = 1, .reusable = true}, SHIFT(9531),
  [14144] = {.count = 1, .reusable = true}, SHIFT(9532),
  [14146] = {.count = 1, .reusable = false}, SHIFT(9533),
  [14148] = {.count = 1, .reusable = false}, SHIFT(9527),
  [14150] = {.count = 1, .reusable = true}, SHIFT(9526),
  [14152] = {.count = 1, .reusable = false}, SHIFT(9534),
  [14154] = {.count = 1, .reusable = false}, SHIFT(9531),
  [14156] = {.count = 1, .reusable = true}, SHIFT(9534),
  [14158] = {.count = 1, .reusable = true}, SHIFT(9536),
  [14160] = {.count = 1, .reusable = false}, SHIFT(9535),
  [14162] = {.count = 1, .reusable = true}, SHIFT(9535),
  [14164] = {.count = 1, .reusable = true}, SHIFT(9525),
  [14166] = {.count = 1, .reusable = true}, SHIFT(4195),
  [14168] = {.count = 1, .reusable = false}, SHIFT(9555),
  [14170] = {.count = 1, .reusable = true}, SHIFT(9555),
  [14172] = {.count = 1, .reusable = true}, SHIFT(9556),
  [14174] = {.count = 1, .reusable = true}, SHIFT(9557),
  [14176] = {.count = 1, .reusable = true}, SHIFT(9560),
  [14178] = {.count = 1, .reusable = false}, SHIFT(9561),
  [14180] = {.count = 1, .reusable = true}, SHIFT(9562),
  [14182] = {.count = 1, .reusable = true}, SHIFT(9566),
  [14184] = {.count = 1, .reusable = false}, SHIFT(9562),
  [14186] = {.count = 1, .reusable = true}, SHIFT(9573),
  [14188] = {.count = 1, .reusable = false}, SHIFT(9574),
  [14190] = {.count = 1, .reusable = false}, SHIFT(9575),
  [14192] = {.count = 1, .reusable = true}, SHIFT(9577),
  [14194] = {.count = 1, .reusable = true}, SHIFT(9578),
  [14196] = {.count = 1, .reusable = true}, SHIFT(9579),
  [14198] = {.count = 1, .reusable = true}, SHIFT(9576),
  [14200] = {.count = 1, .reusable = true}, SHIFT(9580),
  [14202] = {.count = 1, .reusable = true}, SHIFT(9581),
  [14204] = {.count = 1, .reusable = false}, SHIFT(9582),
  [14206] = {.count = 1, .reusable = false}, SHIFT(9576),
  [14208] = {.count = 1, .reusable = true}, SHIFT(9575),
  [14210] = {.count = 1, .reusable = false}, SHIFT(9583),
  [14212] = {.count = 1, .reusable = false}, SHIFT(9580),
  [14214] = {.count = 1, .reusable = true}, SHIFT(9583),
  [14216] = {.count = 1, .reusable = true}, SHIFT(9574),
  [14218] = {.count = 1, .reusable = true}, SHIFT(9585),
  [14220] = {.count = 1, .reusable = true}, SHIFT(9587),
  [14222] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5),
  [14224] = {.count = 1, .reusable = true}, SHIFT(9588),
  [14226] = {.count = 1, .reusable = true}, SHIFT(9590),
  [14228] = {.count = 1, .reusable = true}, SHIFT(9591),
  [14230] = {.count = 1, .reusable = true}, SHIFT(9597),
  [14232] = {.count = 1, .reusable = false}, SHIFT(9598),
  [14234] = {.count = 1, .reusable = false}, SHIFT(9599),
  [14236] = {.count = 1, .reusable = false}, SHIFT(9601),
  [14238] = {.count = 1, .reusable = true}, SHIFT(9602),
  [14240] = {.count = 1, .reusable = false}, SHIFT(9603),
  [14242] = {.count = 1, .reusable = true}, SHIFT(9600),
  [14244] = {.count = 1, .reusable = true}, SHIFT(9604),
  [14246] = {.count = 1, .reusable = true}, SHIFT(9601),
  [14248] = {.count = 1, .reusable = false}, SHIFT(9605),
  [14250] = {.count = 1, .reusable = false}, SHIFT(9606),
  [14252] = {.count = 1, .reusable = false}, SHIFT(9600),
  [14254] = {.count = 1, .reusable = true}, SHIFT(9599),
  [14256] = {.count = 1, .reusable = false}, SHIFT(9607),
  [14258] = {.count = 1, .reusable = false}, SHIFT(9604),
  [14260] = {.count = 1, .reusable = true}, SHIFT(9605),
  [14262] = {.count = 1, .reusable = true}, SHIFT(9598),
  [14264] = {.count = 1, .reusable = true}, SHIFT(4233),
  [14266] = {.count = 1, .reusable = false}, SHIFT(9630),
  [14268] = {.count = 1, .reusable = true}, SHIFT(9631),
  [14270] = {.count = 1, .reusable = true}, SHIFT(9635),
  [14272] = {.count = 1, .reusable = false}, SHIFT(9631),
  [14274] = {.count = 1, .reusable = false}, SHIFT(9643),
  [14276] = {.count = 1, .reusable = true}, SHIFT(9642),
  [14278] = {.count = 1, .reusable = false}, SHIFT(9644),
  [14280] = {.count = 1, .reusable = true}, SHIFT(9646),
  [14282] = {.count = 1, .reusable = true}, SHIFT(9647),
  [14284] = {.count = 1, .reusable = true}, SHIFT(9648),
  [14286] = {.count = 1, .reusable = true}, SHIFT(9649),
  [14288] = {.count = 1, .reusable = true}, SHIFT(9645),
  [14290] = {.count = 1, .reusable = false}, SHIFT(9651),
  [14292] = {.count = 1, .reusable = true}, SHIFT(9650),
  [14294] = {.count = 1, .reusable = false}, SHIFT(9645),
  [14296] = {.count = 1, .reusable = true}, SHIFT(9644),
  [14298] = {.count = 1, .reusable = false}, SHIFT(9652),
  [14300] = {.count = 1, .reusable = false}, SHIFT(9649),
  [14302] = {.count = 1, .reusable = true}, SHIFT(9652),
  [14304] = {.count = 1, .reusable = true}, SHIFT(9643),
  [14306] = {.count = 1, .reusable = true}, SHIFT(4260),
  [14308] = {.count = 1, .reusable = false}, SHIFT(9671),
  [14310] = {.count = 1, .reusable = true}, SHIFT(9671),
  [14312] = {.count = 1, .reusable = true}, SHIFT(9672),
  [14314] = {.count = 1, .reusable = true}, SHIFT(9673),
  [14316] = {.count = 1, .reusable = true}, SHIFT(9676),
  [14318] = {.count = 1, .reusable = false}, SHIFT(9677),
  [14320] = {.count = 1, .reusable = true}, SHIFT(9678),
  [14322] = {.count = 1, .reusable = true}, SHIFT(9682),
  [14324] = {.count = 1, .reusable = false}, SHIFT(9678),
  [14326] = {.count = 1, .reusable = true}, SHIFT(9686),
  [14328] = {.count = 1, .reusable = true}, SHIFT(9688),
  [14330] = {.count = 1, .reusable = false}, SHIFT(9693),
  [14332] = {.count = 1, .reusable = true}, SHIFT(9692),
  [14334] = {.count = 1, .reusable = false}, SHIFT(9694),
  [14336] = {.count = 1, .reusable = true}, SHIFT(9696),
  [14338] = {.count = 1, .reusable = true}, SHIFT(9697),
  [14340] = {.count = 1, .reusable = true}, SHIFT(9698),
  [14342] = {.count = 1, .reusable = true}, SHIFT(9699),
  [14344] = {.count = 1, .reusable = true}, SHIFT(9695),
  [14346] = {.count = 1, .reusable = false}, SHIFT(9701),
  [14348] = {.count = 1, .reusable = true}, SHIFT(9700),
  [14350] = {.count = 1, .reusable = false}, SHIFT(9695),
  [14352] = {.count = 1, .reusable = true}, SHIFT(9694),
  [14354] = {.count = 1, .reusable = false}, SHIFT(9702),
  [14356] = {.count = 1, .reusable = false}, SHIFT(9699),
  [14358] = {.count = 1, .reusable = true}, SHIFT(9702),
  [14360] = {.count = 1, .reusable = true}, SHIFT(9693),
  [14362] = {.count = 1, .reusable = true}, SHIFT(9703),
  [14364] = {.count = 1, .reusable = true}, SHIFT(9709),
  [14366] = {.count = 1, .reusable = false}, SHIFT(9710),
  [14368] = {.count = 1, .reusable = false}, SHIFT(9713),
  [14370] = {.count = 1, .reusable = true}, SHIFT(9712),
  [14372] = {.count = 1, .reusable = false}, SHIFT(9715),
  [14374] = {.count = 1, .reusable = true}, SHIFT(9713),
  [14376] = {.count = 1, .reusable = false}, SHIFT(9717),
  [14378] = {.count = 1, .reusable = false}, SHIFT(9718),
  [14380] = {.count = 1, .reusable = false}, SHIFT(9711),
  [14382] = {.count = 1, .reusable = false}, SHIFT(9719),
  [14384] = {.count = 1, .reusable = false}, SHIFT(9716),
  [14386] = {.count = 1, .reusable = true}, SHIFT(9714),
  [14388] = {.count = 1, .reusable = true}, SHIFT(9716),
  [14390] = {.count = 1, .reusable = false}, SHIFT(9712),
  [14392] = {.count = 1, .reusable = true}, SHIFT(9711),
  [14394] = {.count = 1, .reusable = true}, SHIFT(9717),
  [14396] = {.count = 1, .reusable = true}, SHIFT(9710),
  [14398] = {.count = 1, .reusable = true}, SHIFT(4288),
  [14400] = {.count = 1, .reusable = true}, SHIFT(9739),
  [14402] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4317),
  [14405] = {.count = 1, .reusable = true}, SHIFT(9744),
  [14407] = {.count = 1, .reusable = true}, SHIFT(7299),
  [14409] = {.count = 1, .reusable = true}, SHIFT(9747),
  [14411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4365),
  [14414] = {.count = 1, .reusable = true}, SHIFT(9748),
  [14416] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4383),
  [14419] = {.count = 1, .reusable = true}, SHIFT(9751),
  [14421] = {.count = 1, .reusable = true}, SHIFT(7340),
  [14423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4446),
  [14426] = {.count = 1, .reusable = true}, SHIFT(9774),
  [14428] = {.count = 1, .reusable = true}, SHIFT(9775),
  [14430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4503),
  [14433] = {.count = 1, .reusable = true}, SHIFT(9805),
  [14435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4538),
  [14438] = {.count = 1, .reusable = true}, SHIFT(9811),
  [14440] = {.count = 1, .reusable = true}, SHIFT(7459),
  [14442] = {.count = 1, .reusable = true}, SHIFT(9814),
  [14444] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4585),
  [14447] = {.count = 1, .reusable = false}, SHIFT(9818),
  [14449] = {.count = 1, .reusable = true}, SHIFT(9819),
  [14451] = {.count = 1, .reusable = true}, SHIFT(9823),
  [14453] = {.count = 1, .reusable = false}, SHIFT(9819),
  [14455] = {.count = 1, .reusable = true}, SHIFT(9830),
  [14457] = {.count = 1, .reusable = false}, SHIFT(9831),
  [14459] = {.count = 1, .reusable = false}, SHIFT(9832),
  [14461] = {.count = 1, .reusable = true}, SHIFT(9834),
  [14463] = {.count = 1, .reusable = true}, SHIFT(9835),
  [14465] = {.count = 1, .reusable = true}, SHIFT(9836),
  [14467] = {.count = 1, .reusable = true}, SHIFT(9837),
  [14469] = {.count = 1, .reusable = true}, SHIFT(9833),
  [14471] = {.count = 1, .reusable = false}, SHIFT(9839),
  [14473] = {.count = 1, .reusable = true}, SHIFT(9838),
  [14475] = {.count = 1, .reusable = false}, SHIFT(9833),
  [14477] = {.count = 1, .reusable = true}, SHIFT(9832),
  [14479] = {.count = 1, .reusable = false}, SHIFT(9840),
  [14481] = {.count = 1, .reusable = false}, SHIFT(9837),
  [14483] = {.count = 1, .reusable = true}, SHIFT(9840),
  [14485] = {.count = 1, .reusable = true}, SHIFT(9831),
  [14487] = {.count = 1, .reusable = true}, SHIFT(4604),
  [14489] = {.count = 1, .reusable = false}, SHIFT(9859),
  [14491] = {.count = 1, .reusable = true}, SHIFT(9859),
  [14493] = {.count = 1, .reusable = true}, SHIFT(9860),
  [14495] = {.count = 1, .reusable = true}, SHIFT(9861),
  [14497] = {.count = 1, .reusable = true}, SHIFT(9864),
  [14499] = {.count = 1, .reusable = false}, SHIFT(9865),
  [14501] = {.count = 1, .reusable = true}, SHIFT(9866),
  [14503] = {.count = 1, .reusable = true}, SHIFT(9870),
  [14505] = {.count = 1, .reusable = false}, SHIFT(9866),
  [14507] = {.count = 1, .reusable = true}, SHIFT(9874),
  [14509] = {.count = 1, .reusable = true}, SHIFT(9875),
  [14511] = {.count = 1, .reusable = true}, SHIFT(9877),
  [14513] = {.count = 1, .reusable = true}, SHIFT(9881),
  [14515] = {.count = 1, .reusable = false}, SHIFT(9882),
  [14517] = {.count = 1, .reusable = false}, SHIFT(9883),
  [14519] = {.count = 1, .reusable = true}, SHIFT(9885),
  [14521] = {.count = 1, .reusable = true}, SHIFT(9886),
  [14523] = {.count = 1, .reusable = true}, SHIFT(9887),
  [14525] = {.count = 1, .reusable = true}, SHIFT(9888),
  [14527] = {.count = 1, .reusable = true}, SHIFT(9884),
  [14529] = {.count = 1, .reusable = false}, SHIFT(9890),
  [14531] = {.count = 1, .reusable = true}, SHIFT(9889),
  [14533] = {.count = 1, .reusable = false}, SHIFT(9884),
  [14535] = {.count = 1, .reusable = true}, SHIFT(9883),
  [14537] = {.count = 1, .reusable = false}, SHIFT(9891),
  [14539] = {.count = 1, .reusable = false}, SHIFT(9888),
  [14541] = {.count = 1, .reusable = true}, SHIFT(9891),
  [14543] = {.count = 1, .reusable = true}, SHIFT(9882),
  [14545] = {.count = 1, .reusable = true}, SHIFT(9892),
  [14547] = {.count = 1, .reusable = true}, SHIFT(9898),
  [14549] = {.count = 1, .reusable = false}, SHIFT(9899),
  [14551] = {.count = 1, .reusable = false}, SHIFT(9902),
  [14553] = {.count = 1, .reusable = true}, SHIFT(9901),
  [14555] = {.count = 1, .reusable = false}, SHIFT(9904),
  [14557] = {.count = 1, .reusable = true}, SHIFT(9902),
  [14559] = {.count = 1, .reusable = false}, SHIFT(9906),
  [14561] = {.count = 1, .reusable = false}, SHIFT(9907),
  [14563] = {.count = 1, .reusable = false}, SHIFT(9900),
  [14565] = {.count = 1, .reusable = false}, SHIFT(9908),
  [14567] = {.count = 1, .reusable = false}, SHIFT(9905),
  [14569] = {.count = 1, .reusable = true}, SHIFT(9903),
  [14571] = {.count = 1, .reusable = true}, SHIFT(9905),
  [14573] = {.count = 1, .reusable = false}, SHIFT(9901),
  [14575] = {.count = 1, .reusable = true}, SHIFT(9900),
  [14577] = {.count = 1, .reusable = true}, SHIFT(9906),
  [14579] = {.count = 1, .reusable = true}, SHIFT(9899),
  [14581] = {.count = 1, .reusable = true}, SHIFT(4634),
  [14583] = {.count = 1, .reusable = true}, SHIFT(9928),
  [14585] = {.count = 1, .reusable = true}, SHIFT(9929),
  [14587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4678),
  [14590] = {.count = 1, .reusable = true}, SHIFT(9932),
  [14592] = {.count = 1, .reusable = true}, SHIFT(7623),
  [14594] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 23),
  [14596] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 23),
  [14598] = {.count = 1, .reusable = true}, SHIFT(9935),
  [14600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(4719),
  [14603] = {.count = 1, .reusable = true}, SHIFT(9936),
  [14605] = {.count = 1, .reusable = true}, SHIFT(9937),
  [14607] = {.count = 1, .reusable = true}, SHIFT(9938),
  [14609] = {.count = 1, .reusable = true}, SHIFT(9939),
  [14611] = {.count = 1, .reusable = true}, SHIFT(9940),
  [14613] = {.count = 1, .reusable = false}, SHIFT(9941),
  [14615] = {.count = 1, .reusable = false}, SHIFT(9943),
  [14617] = {.count = 1, .reusable = true}, SHIFT(9943),
  [14619] = {.count = 1, .reusable = true}, SHIFT(9945),
  [14621] = {.count = 1, .reusable = true}, SHIFT(9946),
  [14623] = {.count = 1, .reusable = true}, SHIFT(9947),
  [14625] = {.count = 1, .reusable = true}, SHIFT(4761),
  [14627] = {.count = 1, .reusable = false}, SHIFT(9969),
  [14629] = {.count = 1, .reusable = true}, SHIFT(9969),
  [14631] = {.count = 1, .reusable = true}, SHIFT(9970),
  [14633] = {.count = 1, .reusable = true}, SHIFT(9971),
  [14635] = {.count = 1, .reusable = true}, SHIFT(9974),
  [14637] = {.count = 1, .reusable = true}, SHIFT(9976),
  [14639] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(4784),
  [14642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4785),
  [14645] = {.count = 1, .reusable = true}, SHIFT(9980),
  [14647] = {.count = 1, .reusable = true}, SHIFT(9981),
  [14649] = {.count = 1, .reusable = true}, SHIFT(9983),
  [14651] = {.count = 1, .reusable = true}, SHIFT(4805),
  [14653] = {.count = 1, .reusable = true}, SHIFT(9990),
  [14655] = {.count = 1, .reusable = false}, SHIFT(9993),
  [14657] = {.count = 1, .reusable = false}, SHIFT(9994),
  [14659] = {.count = 1, .reusable = true}, SHIFT(9995),
  [14661] = {.count = 1, .reusable = true}, SHIFT(9997),
  [14663] = {.count = 1, .reusable = true}, SHIFT(9998),
  [14665] = {.count = 1, .reusable = true}, SHIFT(9999),
  [14667] = {.count = 1, .reusable = true}, SHIFT(10000),
  [14669] = {.count = 1, .reusable = true}, SHIFT(10001),
  [14671] = {.count = 1, .reusable = true}, SHIFT(10017),
  [14673] = {.count = 1, .reusable = false}, SHIFT(10018),
  [14675] = {.count = 1, .reusable = true}, SHIFT(10018),
  [14677] = {.count = 1, .reusable = true}, SHIFT(10020),
  [14679] = {.count = 1, .reusable = true}, SHIFT(10021),
  [14681] = {.count = 1, .reusable = true}, SHIFT(10022),
  [14683] = {.count = 1, .reusable = true}, SHIFT(10023),
  [14685] = {.count = 1, .reusable = true}, SHIFT(10026),
  [14687] = {.count = 1, .reusable = true}, SHIFT(10028),
  [14689] = {.count = 1, .reusable = true}, SHIFT(10027),
  [14691] = {.count = 1, .reusable = true}, SHIFT(10030),
  [14693] = {.count = 1, .reusable = true}, SHIFT(10031),
  [14695] = {.count = 1, .reusable = true}, SHIFT(10033),
  [14697] = {.count = 1, .reusable = true}, SHIFT(10034),
  [14699] = {.count = 1, .reusable = true}, SHIFT(10035),
  [14701] = {.count = 1, .reusable = true}, SHIFT(10038),
  [14703] = {.count = 1, .reusable = true}, SHIFT(10041),
  [14705] = {.count = 1, .reusable = false}, SHIFT(10040),
  [14707] = {.count = 1, .reusable = true}, SHIFT(10042),
  [14709] = {.count = 1, .reusable = false}, SHIFT(10045),
  [14711] = {.count = 1, .reusable = true}, SHIFT(10047),
  [14713] = {.count = 1, .reusable = true}, SHIFT(10049),
  [14715] = {.count = 1, .reusable = true}, SHIFT(10048),
  [14717] = {.count = 1, .reusable = true}, SHIFT(10051),
  [14719] = {.count = 1, .reusable = true}, SHIFT(10052),
  [14721] = {.count = 1, .reusable = true}, SHIFT(10054),
  [14723] = {.count = 1, .reusable = true}, SHIFT(10055),
  [14725] = {.count = 1, .reusable = true}, SHIFT(10057),
  [14727] = {.count = 1, .reusable = true}, SHIFT(10059),
  [14729] = {.count = 1, .reusable = true}, SHIFT(10060),
  [14731] = {.count = 1, .reusable = true}, SHIFT(10063),
  [14733] = {.count = 1, .reusable = true}, SHIFT(10064),
  [14735] = {.count = 1, .reusable = true}, SHIFT(10065),
  [14737] = {.count = 1, .reusable = true}, SHIFT(10084),
  [14739] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(4919),
  [14742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4920),
  [14745] = {.count = 1, .reusable = true}, SHIFT(10086),
  [14747] = {.count = 1, .reusable = true}, SHIFT(10088),
  [14749] = {.count = 1, .reusable = true}, SHIFT(10089),
  [14751] = {.count = 1, .reusable = true}, SHIFT(10090),
  [14753] = {.count = 1, .reusable = false}, SHIFT(10090),
  [14755] = {.count = 1, .reusable = true}, SHIFT(7872),
  [14757] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5004),
  [14760] = {.count = 1, .reusable = true}, SHIFT(10108),
  [14762] = {.count = 1, .reusable = true}, SHIFT(10109),
  [14764] = {.count = 1, .reusable = true}, SHIFT(10112),
  [14766] = {.count = 1, .reusable = true}, SHIFT(10113),
  [14768] = {.count = 1, .reusable = true}, SHIFT(10114),
  [14770] = {.count = 1, .reusable = true}, SHIFT(10115),
  [14772] = {.count = 1, .reusable = false}, SHIFT(10116),
  [14774] = {.count = 1, .reusable = false}, SHIFT(10117),
  [14776] = {.count = 1, .reusable = true}, SHIFT(10118),
  [14778] = {.count = 1, .reusable = true}, SHIFT(10120),
  [14780] = {.count = 1, .reusable = true}, SHIFT(10121),
  [14782] = {.count = 1, .reusable = true}, SHIFT(10122),
  [14784] = {.count = 1, .reusable = true}, SHIFT(10123),
  [14786] = {.count = 1, .reusable = false}, SHIFT(10124),
  [14788] = {.count = 1, .reusable = false}, SHIFT(10126),
  [14790] = {.count = 1, .reusable = true}, SHIFT(10126),
  [14792] = {.count = 1, .reusable = true}, SHIFT(10128),
  [14794] = {.count = 1, .reusable = true}, SHIFT(10129),
  [14796] = {.count = 1, .reusable = true}, SHIFT(10130),
  [14798] = {.count = 1, .reusable = true}, SHIFT(10131),
  [14800] = {.count = 1, .reusable = true}, SHIFT(7937),
  [14802] = {.count = 1, .reusable = true}, SHIFT(10135),
  [14804] = {.count = 1, .reusable = true}, SHIFT(10136),
  [14806] = {.count = 1, .reusable = false}, SHIFT(10137),
  [14808] = {.count = 1, .reusable = true}, SHIFT(10137),
  [14810] = {.count = 1, .reusable = true}, SHIFT(10139),
  [14812] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5109),
  [14815] = {.count = 1, .reusable = true}, SHIFT(10154),
  [14817] = {.count = 1, .reusable = true}, SHIFT(10156),
  [14819] = {.count = 1, .reusable = true}, SHIFT(10157),
  [14821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5138),
  [14824] = {.count = 1, .reusable = true}, SHIFT(10158),
  [14826] = {.count = 1, .reusable = true}, SHIFT(10159),
  [14828] = {.count = 1, .reusable = true}, SHIFT(10160),
  [14830] = {.count = 1, .reusable = true}, SHIFT(10161),
  [14832] = {.count = 1, .reusable = true}, SHIFT(10162),
  [14834] = {.count = 1, .reusable = true}, SHIFT(10163),
  [14836] = {.count = 1, .reusable = false}, SHIFT(10164),
  [14838] = {.count = 1, .reusable = true}, SHIFT(10166),
  [14840] = {.count = 1, .reusable = false}, SHIFT(10166),
  [14842] = {.count = 1, .reusable = true}, SHIFT(10168),
  [14844] = {.count = 1, .reusable = true}, SHIFT(10169),
  [14846] = {.count = 1, .reusable = false}, SHIFT(10172),
  [14848] = {.count = 1, .reusable = false}, SHIFT(10173),
  [14850] = {.count = 1, .reusable = true}, SHIFT(10174),
  [14852] = {.count = 1, .reusable = true}, SHIFT(10176),
  [14854] = {.count = 1, .reusable = true}, SHIFT(10177),
  [14856] = {.count = 1, .reusable = true}, SHIFT(10178),
  [14858] = {.count = 1, .reusable = true}, SHIFT(10179),
  [14860] = {.count = 1, .reusable = true}, SHIFT(8028),
  [14862] = {.count = 1, .reusable = true}, SHIFT(10183),
  [14864] = {.count = 1, .reusable = true}, SHIFT(10184),
  [14866] = {.count = 1, .reusable = true}, SHIFT(10185),
  [14868] = {.count = 1, .reusable = false}, SHIFT(10185),
  [14870] = {.count = 1, .reusable = true}, SHIFT(8048),
  [14872] = {.count = 1, .reusable = true}, SHIFT(10190),
  [14874] = {.count = 1, .reusable = true}, SHIFT(10191),
  [14876] = {.count = 1, .reusable = true}, SHIFT(10193),
  [14878] = {.count = 1, .reusable = true}, SHIFT(5297),
  [14880] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5310),
  [14883] = {.count = 1, .reusable = true}, SHIFT(10215),
  [14885] = {.count = 1, .reusable = true}, SHIFT(10216),
  [14887] = {.count = 1, .reusable = true}, SHIFT(10218),
  [14889] = {.count = 1, .reusable = true}, SHIFT(5330),
  [14891] = {.count = 1, .reusable = true}, SHIFT(8117),
  [14893] = {.count = 1, .reusable = true}, SHIFT(10227),
  [14895] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5377),
  [14898] = {.count = 1, .reusable = true}, SHIFT(10244),
  [14900] = {.count = 1, .reusable = true}, SHIFT(10245),
  [14902] = {.count = 1, .reusable = true}, SHIFT(10246),
  [14904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5415),
  [14907] = {.count = 1, .reusable = true}, SHIFT(10247),
  [14909] = {.count = 1, .reusable = false}, SHIFT(10247),
  [14911] = {.count = 1, .reusable = true}, SHIFT(8183),
  [14913] = {.count = 1, .reusable = true}, SHIFT(5459),
  [14915] = {.count = 1, .reusable = true}, SHIFT(10259),
  [14917] = {.count = 1, .reusable = true}, SHIFT(10260),
  [14919] = {.count = 1, .reusable = true}, SHIFT(10262),
  [14921] = {.count = 1, .reusable = true}, SHIFT(10267),
  [14923] = {.count = 1, .reusable = false}, SHIFT(10268),
  [14925] = {.count = 1, .reusable = false}, SHIFT(10269),
  [14927] = {.count = 1, .reusable = false}, SHIFT(10271),
  [14929] = {.count = 1, .reusable = true}, SHIFT(10272),
  [14931] = {.count = 1, .reusable = false}, SHIFT(10273),
  [14933] = {.count = 1, .reusable = true}, SHIFT(10270),
  [14935] = {.count = 1, .reusable = true}, SHIFT(10274),
  [14937] = {.count = 1, .reusable = true}, SHIFT(10271),
  [14939] = {.count = 1, .reusable = false}, SHIFT(10275),
  [14941] = {.count = 1, .reusable = false}, SHIFT(10276),
  [14943] = {.count = 1, .reusable = false}, SHIFT(10270),
  [14945] = {.count = 1, .reusable = true}, SHIFT(10269),
  [14947] = {.count = 1, .reusable = false}, SHIFT(10277),
  [14949] = {.count = 1, .reusable = false}, SHIFT(10274),
  [14951] = {.count = 1, .reusable = true}, SHIFT(10275),
  [14953] = {.count = 1, .reusable = true}, SHIFT(10268),
  [14955] = {.count = 1, .reusable = true}, SHIFT(5485),
  [14957] = {.count = 1, .reusable = true}, SHIFT(10283),
  [14959] = {.count = 1, .reusable = true}, SHIFT(10284),
  [14961] = {.count = 1, .reusable = true}, SHIFT(10286),
  [14963] = {.count = 1, .reusable = true}, SHIFT(10287),
  [14965] = {.count = 1, .reusable = true}, SHIFT(10288),
  [14967] = {.count = 1, .reusable = true}, SHIFT(10289),
  [14969] = {.count = 1, .reusable = false}, SHIFT(10289),
  [14971] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5552),
  [14974] = {.count = 1, .reusable = true}, SHIFT(5559),
  [14976] = {.count = 1, .reusable = true}, SHIFT(10300),
  [14978] = {.count = 1, .reusable = true}, SHIFT(10301),
  [14980] = {.count = 1, .reusable = true}, SHIFT(10303),
  [14982] = {.count = 1, .reusable = true}, SHIFT(10308),
  [14984] = {.count = 1, .reusable = false}, SHIFT(10309),
  [14986] = {.count = 1, .reusable = false}, SHIFT(10310),
  [14988] = {.count = 1, .reusable = false}, SHIFT(10312),
  [14990] = {.count = 1, .reusable = true}, SHIFT(10313),
  [14992] = {.count = 1, .reusable = false}, SHIFT(10314),
  [14994] = {.count = 1, .reusable = true}, SHIFT(10311),
  [14996] = {.count = 1, .reusable = true}, SHIFT(10315),
  [14998] = {.count = 1, .reusable = true}, SHIFT(10312),
  [15000] = {.count = 1, .reusable = false}, SHIFT(10316),
  [15002] = {.count = 1, .reusable = false}, SHIFT(10317),
  [15004] = {.count = 1, .reusable = false}, SHIFT(10311),
  [15006] = {.count = 1, .reusable = true}, SHIFT(10310),
  [15008] = {.count = 1, .reusable = false}, SHIFT(10318),
  [15010] = {.count = 1, .reusable = false}, SHIFT(10315),
  [15012] = {.count = 1, .reusable = true}, SHIFT(10316),
  [15014] = {.count = 1, .reusable = true}, SHIFT(10309),
  [15016] = {.count = 1, .reusable = true}, SHIFT(5586),
  [15018] = {.count = 1, .reusable = true}, SHIFT(10324),
  [15020] = {.count = 1, .reusable = true}, SHIFT(8316),
  [15022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5610),
  [15025] = {.count = 1, .reusable = true}, SHIFT(10328),
  [15027] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6),
  [15029] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6),
  [15031] = {.count = 1, .reusable = false}, SHIFT(10346),
  [15033] = {.count = 1, .reusable = false}, SHIFT(10342),
  [15035] = {.count = 1, .reusable = false}, SHIFT(10347),
  [15037] = {.count = 1, .reusable = true}, SHIFT(10346),
  [15039] = {.count = 1, .reusable = true}, SHIFT(10331),
  [15041] = {.count = 1, .reusable = false}, SHIFT(10332),
  [15043] = {.count = 1, .reusable = true}, SHIFT(10347),
  [15045] = {.count = 1, .reusable = true}, SHIFT(10333),
  [15047] = {.count = 1, .reusable = false}, SHIFT(10334),
  [15049] = {.count = 1, .reusable = true}, SHIFT(10335),
  [15051] = {.count = 1, .reusable = false}, SHIFT(10336),
  [15053] = {.count = 1, .reusable = true}, SHIFT(10337),
  [15055] = {.count = 1, .reusable = false}, SHIFT(10333),
  [15057] = {.count = 1, .reusable = true}, SHIFT(10338),
  [15059] = {.count = 1, .reusable = false}, SHIFT(10339),
  [15061] = {.count = 1, .reusable = true}, SHIFT(10330),
  [15063] = {.count = 1, .reusable = false}, SHIFT(10340),
  [15065] = {.count = 1, .reusable = false}, SHIFT(10331),
  [15067] = {.count = 1, .reusable = true}, SHIFT(10353),
  [15069] = {.count = 1, .reusable = true}, SHIFT(10354),
  [15071] = {.count = 1, .reusable = false}, SHIFT(10355),
  [15073] = {.count = 1, .reusable = false}, SHIFT(10356),
  [15075] = {.count = 1, .reusable = true}, SHIFT(10359),
  [15077] = {.count = 1, .reusable = true}, SHIFT(10360),
  [15079] = {.count = 1, .reusable = true}, SHIFT(10357),
  [15081] = {.count = 1, .reusable = true}, SHIFT(10361),
  [15083] = {.count = 1, .reusable = true}, SHIFT(10362),
  [15085] = {.count = 1, .reusable = true}, SHIFT(10358),
  [15087] = {.count = 1, .reusable = true}, SHIFT(10363),
  [15089] = {.count = 1, .reusable = false}, SHIFT(10364),
  [15091] = {.count = 1, .reusable = false}, SHIFT(10357),
  [15093] = {.count = 1, .reusable = true}, SHIFT(10356),
  [15095] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3),
  [15097] = {.count = 1, .reusable = false}, SHIFT(10362),
  [15099] = {.count = 1, .reusable = true}, SHIFT(10365),
  [15101] = {.count = 1, .reusable = true}, SHIFT(10367),
  [15103] = {.count = 1, .reusable = false}, SHIFT(10366),
  [15105] = {.count = 1, .reusable = true}, SHIFT(10366),
  [15107] = {.count = 1, .reusable = false}, SHIFT(10380),
  [15109] = {.count = 1, .reusable = false}, SHIFT(10379),
  [15111] = {.count = 1, .reusable = false}, SHIFT(10382),
  [15113] = {.count = 1, .reusable = true}, SHIFT(10380),
  [15115] = {.count = 1, .reusable = true}, SHIFT(10369),
  [15117] = {.count = 1, .reusable = false}, SHIFT(10370),
  [15119] = {.count = 1, .reusable = true}, SHIFT(10382),
  [15121] = {.count = 1, .reusable = true}, SHIFT(10371),
  [15123] = {.count = 1, .reusable = true}, SHIFT(10372),
  [15125] = {.count = 1, .reusable = false}, SHIFT(10373),
  [15127] = {.count = 1, .reusable = true}, SHIFT(10374),
  [15129] = {.count = 1, .reusable = false}, SHIFT(10371),
  [15131] = {.count = 1, .reusable = true}, SHIFT(10375),
  [15133] = {.count = 1, .reusable = false}, SHIFT(10376),
  [15135] = {.count = 1, .reusable = true}, SHIFT(10368),
  [15137] = {.count = 1, .reusable = false}, SHIFT(10377),
  [15139] = {.count = 1, .reusable = false}, SHIFT(10369),
  [15141] = {.count = 1, .reusable = true}, SHIFT(10355),
  [15143] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3),
  [15145] = {.count = 1, .reusable = true}, SHIFT(10389),
  [15147] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [15149] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [15151] = {.count = 1, .reusable = true}, SHIFT(10391),
  [15153] = {.count = 1, .reusable = true}, SHIFT(10393),
  [15155] = {.count = 1, .reusable = true}, SHIFT(10394),
  [15157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(10395),
  [15160] = {.count = 1, .reusable = true}, SHIFT(5661),
  [15162] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5679),
  [15165] = {.count = 1, .reusable = true}, SHIFT(10420),
  [15167] = {.count = 1, .reusable = true}, SHIFT(10421),
  [15169] = {.count = 1, .reusable = true}, SHIFT(10423),
  [15171] = {.count = 1, .reusable = true}, SHIFT(5699),
  [15173] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [15175] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [15177] = {.count = 1, .reusable = true}, SHIFT(10430),
  [15179] = {.count = 1, .reusable = true}, SHIFT(10444),
  [15181] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5748),
  [15184] = {.count = 1, .reusable = true}, SHIFT(10461),
  [15186] = {.count = 1, .reusable = true}, SHIFT(5779),
  [15188] = {.count = 1, .reusable = true}, SHIFT(10472),
  [15190] = {.count = 1, .reusable = true}, SHIFT(10473),
  [15192] = {.count = 1, .reusable = true}, SHIFT(10475),
  [15194] = {.count = 1, .reusable = true}, SHIFT(10476),
  [15196] = {.count = 1, .reusable = true}, SHIFT(10478),
  [15198] = {.count = 1, .reusable = true}, SHIFT(10479),
  [15200] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 4),
  [15202] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5839),
  [15205] = {.count = 1, .reusable = true}, SHIFT(10508),
  [15207] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6),
  [15209] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6),
  [15211] = {.count = 1, .reusable = true}, SHIFT(10511),
  [15213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5895),
  [15216] = {.count = 1, .reusable = true}, SHIFT(10528),
  [15218] = {.count = 1, .reusable = true}, SHIFT(10530),
  [15220] = {.count = 1, .reusable = false}, SHIFT(10529),
  [15222] = {.count = 1, .reusable = true}, SHIFT(10529),
  [15224] = {.count = 1, .reusable = true}, SHIFT(10533),
  [15226] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 4),
  [15228] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 4),
  [15230] = {.count = 1, .reusable = true}, SHIFT(10535),
  [15232] = {.count = 1, .reusable = true}, SHIFT(10536),
  [15234] = {.count = 1, .reusable = true}, SHIFT(10540),
  [15236] = {.count = 1, .reusable = true}, SHIFT(10541),
  [15238] = {.count = 1, .reusable = true}, SHIFT(10542),
  [15240] = {.count = 1, .reusable = false}, SHIFT(10542),
  [15242] = {.count = 1, .reusable = true}, SHIFT(8632),
  [15244] = {.count = 1, .reusable = true}, SHIFT(10547),
  [15246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5981),
  [15249] = {.count = 1, .reusable = true}, SHIFT(10554),
  [15251] = {.count = 1, .reusable = true}, SHIFT(10555),
  [15253] = {.count = 1, .reusable = true}, SHIFT(10557),
  [15255] = {.count = 1, .reusable = true}, SHIFT(10558),
  [15257] = {.count = 1, .reusable = true}, SHIFT(8672),
  [15259] = {.count = 1, .reusable = true}, SHIFT(10562),
  [15261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6033),
  [15264] = {.count = 1, .reusable = true}, SHIFT(10563),
  [15266] = {.count = 1, .reusable = true}, SHIFT(10564),
  [15268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6056),
  [15271] = {.count = 1, .reusable = false}, REDUCE(sym_conditional, 5),
  [15273] = {.count = 1, .reusable = true}, SHIFT(10565),
  [15275] = {.count = 1, .reusable = false}, SHIFT(10565),
  [15277] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6086),
  [15280] = {.count = 1, .reusable = true}, SHIFT(10571),
  [15282] = {.count = 1, .reusable = true}, SHIFT(8725),
  [15284] = {.count = 1, .reusable = true}, SHIFT(10574),
  [15286] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6138),
  [15289] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [15291] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [15293] = {.count = 1, .reusable = true}, SHIFT(10575),
  [15295] = {.count = 1, .reusable = true}, SHIFT(10580),
  [15297] = {.count = 1, .reusable = false}, SHIFT(10581),
  [15299] = {.count = 1, .reusable = false}, SHIFT(10582),
  [15301] = {.count = 1, .reusable = true}, SHIFT(10584),
  [15303] = {.count = 1, .reusable = true}, SHIFT(10585),
  [15305] = {.count = 1, .reusable = true}, SHIFT(10586),
  [15307] = {.count = 1, .reusable = true}, SHIFT(10587),
  [15309] = {.count = 1, .reusable = true}, SHIFT(10583),
  [15311] = {.count = 1, .reusable = true}, SHIFT(10588),
  [15313] = {.count = 1, .reusable = false}, SHIFT(10589),
  [15315] = {.count = 1, .reusable = false}, SHIFT(10583),
  [15317] = {.count = 1, .reusable = true}, SHIFT(10582),
  [15319] = {.count = 1, .reusable = false}, SHIFT(10590),
  [15321] = {.count = 1, .reusable = false}, SHIFT(10587),
  [15323] = {.count = 1, .reusable = true}, SHIFT(10590),
  [15325] = {.count = 1, .reusable = true}, SHIFT(10581),
  [15327] = {.count = 1, .reusable = true}, SHIFT(6148),
  [15329] = {.count = 1, .reusable = true}, SHIFT(10598),
  [15331] = {.count = 1, .reusable = true}, SHIFT(10599),
  [15333] = {.count = 1, .reusable = true}, SHIFT(10601),
  [15335] = {.count = 1, .reusable = true}, SHIFT(10602),
  [15337] = {.count = 1, .reusable = true}, SHIFT(10603),
  [15339] = {.count = 1, .reusable = true}, SHIFT(10606),
  [15341] = {.count = 1, .reusable = false}, SHIFT(10623),
  [15343] = {.count = 1, .reusable = false}, SHIFT(10619),
  [15345] = {.count = 1, .reusable = false}, SHIFT(10624),
  [15347] = {.count = 1, .reusable = true}, SHIFT(10623),
  [15349] = {.count = 1, .reusable = true}, SHIFT(10608),
  [15351] = {.count = 1, .reusable = false}, SHIFT(10609),
  [15353] = {.count = 1, .reusable = true}, SHIFT(10624),
  [15355] = {.count = 1, .reusable = true}, SHIFT(10610),
  [15357] = {.count = 1, .reusable = false}, SHIFT(10611),
  [15359] = {.count = 1, .reusable = true}, SHIFT(10612),
  [15361] = {.count = 1, .reusable = false}, SHIFT(10613),
  [15363] = {.count = 1, .reusable = true}, SHIFT(10614),
  [15365] = {.count = 1, .reusable = false}, SHIFT(10610),
  [15367] = {.count = 1, .reusable = true}, SHIFT(10615),
  [15369] = {.count = 1, .reusable = false}, SHIFT(10616),
  [15371] = {.count = 1, .reusable = true}, SHIFT(10607),
  [15373] = {.count = 1, .reusable = false}, SHIFT(10617),
  [15375] = {.count = 1, .reusable = false}, SHIFT(10608),
  [15377] = {.count = 1, .reusable = true}, SHIFT(10634),
  [15379] = {.count = 1, .reusable = true}, SHIFT(10628),
  [15381] = {.count = 1, .reusable = true}, SHIFT(10629),
  [15383] = {.count = 1, .reusable = true}, SHIFT(10630),
  [15385] = {.count = 1, .reusable = true}, SHIFT(10631),
  [15387] = {.count = 1, .reusable = true}, SHIFT(10632),
  [15389] = {.count = 1, .reusable = true}, SHIFT(10633),
  [15391] = {.count = 1, .reusable = true}, SHIFT(10636),
  [15393] = {.count = 1, .reusable = false}, SHIFT(10635),
  [15395] = {.count = 1, .reusable = true}, SHIFT(10635),
  [15397] = {.count = 1, .reusable = true}, SHIFT(10637),
  [15399] = {.count = 1, .reusable = false}, SHIFT(10650),
  [15401] = {.count = 1, .reusable = false}, SHIFT(10649),
  [15403] = {.count = 1, .reusable = false}, SHIFT(10652),
  [15405] = {.count = 1, .reusable = true}, SHIFT(10650),
  [15407] = {.count = 1, .reusable = true}, SHIFT(10639),
  [15409] = {.count = 1, .reusable = false}, SHIFT(10640),
  [15411] = {.count = 1, .reusable = true}, SHIFT(10652),
  [15413] = {.count = 1, .reusable = true}, SHIFT(10641),
  [15415] = {.count = 1, .reusable = true}, SHIFT(10642),
  [15417] = {.count = 1, .reusable = false}, SHIFT(10643),
  [15419] = {.count = 1, .reusable = true}, SHIFT(10644),
  [15421] = {.count = 1, .reusable = false}, SHIFT(10641),
  [15423] = {.count = 1, .reusable = true}, SHIFT(10645),
  [15425] = {.count = 1, .reusable = false}, SHIFT(10646),
  [15427] = {.count = 1, .reusable = true}, SHIFT(10638),
  [15429] = {.count = 1, .reusable = false}, SHIFT(10647),
  [15431] = {.count = 1, .reusable = false}, SHIFT(10639),
  [15433] = {.count = 1, .reusable = true}, SHIFT(10658),
  [15435] = {.count = 1, .reusable = false}, SHIFT(10637),
  [15437] = {.count = 1, .reusable = false}, SHIFT(10659),
  [15439] = {.count = 1, .reusable = true}, SHIFT(10662),
  [15441] = {.count = 1, .reusable = true}, SHIFT(10663),
  [15443] = {.count = 1, .reusable = true}, SHIFT(10660),
  [15445] = {.count = 1, .reusable = true}, SHIFT(10664),
  [15447] = {.count = 1, .reusable = true}, SHIFT(10665),
  [15449] = {.count = 1, .reusable = true}, SHIFT(10661),
  [15451] = {.count = 1, .reusable = true}, SHIFT(10666),
  [15453] = {.count = 1, .reusable = false}, SHIFT(10667),
  [15455] = {.count = 1, .reusable = false}, SHIFT(10660),
  [15457] = {.count = 1, .reusable = true}, SHIFT(10659),
  [15459] = {.count = 1, .reusable = false}, SHIFT(10665),
  [15461] = {.count = 1, .reusable = false}, SHIFT(10668),
  [15463] = {.count = 1, .reusable = true}, SHIFT(10668),
  [15465] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [15467] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4),
  [15469] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4),
  [15471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(6173),
  [15474] = {.count = 1, .reusable = true}, SHIFT(10676),
  [15476] = {.count = 1, .reusable = false}, SHIFT(10677),
  [15478] = {.count = 1, .reusable = false}, SHIFT(10678),
  [15480] = {.count = 1, .reusable = false}, SHIFT(10680),
  [15482] = {.count = 1, .reusable = true}, SHIFT(10681),
  [15484] = {.count = 1, .reusable = false}, SHIFT(10682),
  [15486] = {.count = 1, .reusable = true}, SHIFT(10683),
  [15488] = {.count = 1, .reusable = true}, SHIFT(10679),
  [15490] = {.count = 1, .reusable = false}, SHIFT(10684),
  [15492] = {.count = 1, .reusable = false}, SHIFT(10685),
  [15494] = {.count = 1, .reusable = true}, SHIFT(10680),
  [15496] = {.count = 1, .reusable = false}, SHIFT(10679),
  [15498] = {.count = 1, .reusable = true}, SHIFT(10678),
  [15500] = {.count = 1, .reusable = false}, SHIFT(10686),
  [15502] = {.count = 1, .reusable = false}, SHIFT(10683),
  [15504] = {.count = 1, .reusable = true}, SHIFT(10684),
  [15506] = {.count = 1, .reusable = true}, SHIFT(10677),
  [15508] = {.count = 1, .reusable = true}, SHIFT(6181),
  [15510] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6195),
  [15513] = {.count = 1, .reusable = true}, SHIFT(10696),
  [15515] = {.count = 1, .reusable = true}, SHIFT(8845),
  [15517] = {.count = 1, .reusable = true}, SHIFT(10699),
  [15519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6242),
  [15522] = {.count = 1, .reusable = true}, SHIFT(10700),
  [15524] = {.count = 1, .reusable = true}, SHIFT(6261),
  [15526] = {.count = 1, .reusable = false}, SHIFT(10707),
  [15528] = {.count = 1, .reusable = true}, SHIFT(10708),
  [15530] = {.count = 1, .reusable = true}, SHIFT(10712),
  [15532] = {.count = 1, .reusable = false}, SHIFT(10708),
  [15534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6280),
  [15537] = {.count = 1, .reusable = true}, SHIFT(10731),
  [15539] = {.count = 1, .reusable = true}, SHIFT(10732),
  [15541] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6314),
  [15544] = {.count = 1, .reusable = true}, SHIFT(10735),
  [15546] = {.count = 1, .reusable = true}, SHIFT(8940),
  [15548] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6363),
  [15551] = {.count = 1, .reusable = true}, SHIFT(10740),
  [15553] = {.count = 1, .reusable = true}, SHIFT(8965),
  [15555] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6408),
  [15558] = {.count = 1, .reusable = true}, SHIFT(10745),
  [15560] = {.count = 1, .reusable = true}, SHIFT(10746),
  [15562] = {.count = 1, .reusable = true}, SHIFT(10748),
  [15564] = {.count = 1, .reusable = true}, SHIFT(10749),
  [15566] = {.count = 1, .reusable = false}, SHIFT(10752),
  [15568] = {.count = 1, .reusable = true}, SHIFT(10753),
  [15570] = {.count = 1, .reusable = true}, SHIFT(10757),
  [15572] = {.count = 1, .reusable = false}, SHIFT(10753),
  [15574] = {.count = 1, .reusable = false}, SHIFT(10760),
  [15576] = {.count = 1, .reusable = true}, SHIFT(10761),
  [15578] = {.count = 1, .reusable = true}, SHIFT(10762),
  [15580] = {.count = 1, .reusable = true}, SHIFT(10763),
  [15582] = {.count = 1, .reusable = true}, SHIFT(10771),
  [15584] = {.count = 1, .reusable = false}, SHIFT(10772),
  [15586] = {.count = 1, .reusable = false}, SHIFT(10773),
  [15588] = {.count = 1, .reusable = true}, SHIFT(10776),
  [15590] = {.count = 1, .reusable = true}, SHIFT(10777),
  [15592] = {.count = 1, .reusable = true}, SHIFT(10774),
  [15594] = {.count = 1, .reusable = true}, SHIFT(10778),
  [15596] = {.count = 1, .reusable = true}, SHIFT(10779),
  [15598] = {.count = 1, .reusable = true}, SHIFT(10775),
  [15600] = {.count = 1, .reusable = true}, SHIFT(10780),
  [15602] = {.count = 1, .reusable = false}, SHIFT(10781),
  [15604] = {.count = 1, .reusable = false}, SHIFT(10774),
  [15606] = {.count = 1, .reusable = true}, SHIFT(10773),
  [15608] = {.count = 1, .reusable = false}, SHIFT(10779),
  [15610] = {.count = 1, .reusable = false}, SHIFT(10782),
  [15612] = {.count = 1, .reusable = true}, SHIFT(10782),
  [15614] = {.count = 1, .reusable = true}, SHIFT(10772),
  [15616] = {.count = 1, .reusable = true}, SHIFT(10784),
  [15618] = {.count = 1, .reusable = true}, SHIFT(10788),
  [15620] = {.count = 1, .reusable = true}, SHIFT(10787),
  [15622] = {.count = 1, .reusable = true}, SHIFT(9044),
  [15624] = {.count = 1, .reusable = true}, SHIFT(10808),
  [15626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6480),
  [15629] = {.count = 1, .reusable = true}, SHIFT(10811),
  [15631] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 5),
  [15633] = {.count = 1, .reusable = true}, SHIFT(6509),
  [15635] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6527),
  [15638] = {.count = 1, .reusable = true}, SHIFT(10836),
  [15640] = {.count = 1, .reusable = true}, SHIFT(10837),
  [15642] = {.count = 1, .reusable = true}, SHIFT(10839),
  [15644] = {.count = 1, .reusable = true}, SHIFT(6547),
  [15646] = {.count = 1, .reusable = true}, SHIFT(10846),
  [15648] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6593),
  [15651] = {.count = 1, .reusable = true}, SHIFT(10876),
  [15653] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6627),
  [15656] = {.count = 1, .reusable = true}, SHIFT(10882),
  [15658] = {.count = 1, .reusable = true}, SHIFT(9206),
  [15660] = {.count = 1, .reusable = true}, SHIFT(10885),
  [15662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6674),
  [15665] = {.count = 1, .reusable = true}, SHIFT(10886),
  [15667] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6695),
  [15670] = {.count = 1, .reusable = true}, SHIFT(10889),
  [15672] = {.count = 1, .reusable = true}, SHIFT(9246),
  [15674] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 5),
  [15676] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 5),
  [15678] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6744),
  [15681] = {.count = 1, .reusable = true}, SHIFT(6751),
  [15683] = {.count = 1, .reusable = true}, SHIFT(10900),
  [15685] = {.count = 1, .reusable = true}, SHIFT(9280),
  [15687] = {.count = 1, .reusable = false}, SHIFT(10906),
  [15689] = {.count = 1, .reusable = true}, SHIFT(10907),
  [15691] = {.count = 1, .reusable = true}, SHIFT(10911),
  [15693] = {.count = 1, .reusable = false}, SHIFT(10907),
  [15695] = {.count = 1, .reusable = true}, SHIFT(10918),
  [15697] = {.count = 1, .reusable = false}, SHIFT(10919),
  [15699] = {.count = 1, .reusable = false}, SHIFT(10920),
  [15701] = {.count = 1, .reusable = true}, SHIFT(10922),
  [15703] = {.count = 1, .reusable = true}, SHIFT(10923),
  [15705] = {.count = 1, .reusable = true}, SHIFT(10924),
  [15707] = {.count = 1, .reusable = true}, SHIFT(10925),
  [15709] = {.count = 1, .reusable = true}, SHIFT(10921),
  [15711] = {.count = 1, .reusable = false}, SHIFT(10927),
  [15713] = {.count = 1, .reusable = true}, SHIFT(10926),
  [15715] = {.count = 1, .reusable = false}, SHIFT(10921),
  [15717] = {.count = 1, .reusable = true}, SHIFT(10920),
  [15719] = {.count = 1, .reusable = false}, SHIFT(10928),
  [15721] = {.count = 1, .reusable = false}, SHIFT(10925),
  [15723] = {.count = 1, .reusable = true}, SHIFT(10928),
  [15725] = {.count = 1, .reusable = true}, SHIFT(10919),
  [15727] = {.count = 1, .reusable = true}, SHIFT(6804),
  [15729] = {.count = 1, .reusable = false}, SHIFT(10947),
  [15731] = {.count = 1, .reusable = true}, SHIFT(10947),
  [15733] = {.count = 1, .reusable = true}, SHIFT(10948),
  [15735] = {.count = 1, .reusable = true}, SHIFT(10949),
  [15737] = {.count = 1, .reusable = true}, SHIFT(10952),
  [15739] = {.count = 1, .reusable = false}, SHIFT(10953),
  [15741] = {.count = 1, .reusable = true}, SHIFT(10954),
  [15743] = {.count = 1, .reusable = true}, SHIFT(10958),
  [15745] = {.count = 1, .reusable = false}, SHIFT(10954),
  [15747] = {.count = 1, .reusable = true}, SHIFT(10962),
  [15749] = {.count = 1, .reusable = true}, SHIFT(10963),
  [15751] = {.count = 1, .reusable = true}, SHIFT(10965),
  [15753] = {.count = 1, .reusable = true}, SHIFT(10969),
  [15755] = {.count = 1, .reusable = false}, SHIFT(10970),
  [15757] = {.count = 1, .reusable = false}, SHIFT(10971),
  [15759] = {.count = 1, .reusable = true}, SHIFT(10973),
  [15761] = {.count = 1, .reusable = true}, SHIFT(10974),
  [15763] = {.count = 1, .reusable = true}, SHIFT(10975),
  [15765] = {.count = 1, .reusable = true}, SHIFT(10976),
  [15767] = {.count = 1, .reusable = true}, SHIFT(10972),
  [15769] = {.count = 1, .reusable = false}, SHIFT(10978),
  [15771] = {.count = 1, .reusable = true}, SHIFT(10977),
  [15773] = {.count = 1, .reusable = false}, SHIFT(10972),
  [15775] = {.count = 1, .reusable = true}, SHIFT(10971),
  [15777] = {.count = 1, .reusable = false}, SHIFT(10979),
  [15779] = {.count = 1, .reusable = false}, SHIFT(10976),
  [15781] = {.count = 1, .reusable = true}, SHIFT(10979),
  [15783] = {.count = 1, .reusable = true}, SHIFT(10970),
  [15785] = {.count = 1, .reusable = true}, SHIFT(10980),
  [15787] = {.count = 1, .reusable = true}, SHIFT(10986),
  [15789] = {.count = 1, .reusable = false}, SHIFT(10987),
  [15791] = {.count = 1, .reusable = false}, SHIFT(10990),
  [15793] = {.count = 1, .reusable = true}, SHIFT(10989),
  [15795] = {.count = 1, .reusable = false}, SHIFT(10992),
  [15797] = {.count = 1, .reusable = true}, SHIFT(10990),
  [15799] = {.count = 1, .reusable = false}, SHIFT(10994),
  [15801] = {.count = 1, .reusable = false}, SHIFT(10995),
  [15803] = {.count = 1, .reusable = false}, SHIFT(10988),
  [15805] = {.count = 1, .reusable = false}, SHIFT(10996),
  [15807] = {.count = 1, .reusable = false}, SHIFT(10993),
  [15809] = {.count = 1, .reusable = true}, SHIFT(10991),
  [15811] = {.count = 1, .reusable = true}, SHIFT(10993),
  [15813] = {.count = 1, .reusable = false}, SHIFT(10989),
  [15815] = {.count = 1, .reusable = true}, SHIFT(10988),
  [15817] = {.count = 1, .reusable = true}, SHIFT(10994),
  [15819] = {.count = 1, .reusable = true}, SHIFT(10987),
  [15821] = {.count = 1, .reusable = true}, SHIFT(6834),
  [15823] = {.count = 1, .reusable = true}, SHIFT(11016),
  [15825] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3),
  [15827] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 3),
  [15829] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .alias_sequence_id = 24),
  [15831] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .alias_sequence_id = 24),
  [15833] = {.count = 1, .reusable = true}, SHIFT(11019),
  [15835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6896),
  [15838] = {.count = 1, .reusable = true}, SHIFT(11020),
  [15840] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6920),
  [15843] = {.count = 1, .reusable = true}, SHIFT(11035),
  [15845] = {.count = 1, .reusable = true}, SHIFT(11036),
  [15847] = {.count = 1, .reusable = true}, SHIFT(11038),
  [15849] = {.count = 1, .reusable = true}, SHIFT(11039),
  [15851] = {.count = 1, .reusable = true}, SHIFT(11042),
  [15853] = {.count = 1, .reusable = true}, SHIFT(11043),
  [15855] = {.count = 1, .reusable = true}, SHIFT(11044),
  [15857] = {.count = 1, .reusable = true}, SHIFT(11045),
  [15859] = {.count = 1, .reusable = false}, SHIFT(11046),
  [15861] = {.count = 1, .reusable = false}, SHIFT(11047),
  [15863] = {.count = 1, .reusable = true}, SHIFT(11048),
  [15865] = {.count = 1, .reusable = true}, SHIFT(11050),
  [15867] = {.count = 1, .reusable = true}, SHIFT(11051),
  [15869] = {.count = 1, .reusable = true}, SHIFT(11052),
  [15871] = {.count = 1, .reusable = true}, SHIFT(11053),
  [15873] = {.count = 1, .reusable = false}, SHIFT(11054),
  [15875] = {.count = 1, .reusable = true}, SHIFT(11056),
  [15877] = {.count = 1, .reusable = true}, SHIFT(11057),
  [15879] = {.count = 1, .reusable = true}, SHIFT(9490),
  [15881] = {.count = 1, .reusable = true}, SHIFT(11061),
  [15883] = {.count = 1, .reusable = true}, SHIFT(11063),
  [15885] = {.count = 1, .reusable = true}, SHIFT(11064),
  [15887] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7025),
  [15890] = {.count = 1, .reusable = true}, SHIFT(11065),
  [15892] = {.count = 1, .reusable = true}, SHIFT(7041),
  [15894] = {.count = 1, .reusable = false}, SHIFT(11087),
  [15896] = {.count = 1, .reusable = true}, SHIFT(11087),
  [15898] = {.count = 1, .reusable = true}, SHIFT(11088),
  [15900] = {.count = 1, .reusable = true}, SHIFT(11089),
  [15902] = {.count = 1, .reusable = true}, SHIFT(11092),
  [15904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7062),
  [15907] = {.count = 1, .reusable = true}, SHIFT(11096),
  [15909] = {.count = 1, .reusable = true}, SHIFT(11097),
  [15911] = {.count = 1, .reusable = true}, SHIFT(11099),
  [15913] = {.count = 1, .reusable = true}, SHIFT(7082),
  [15915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(7030),
  [15918] = {.count = 1, .reusable = true}, SHIFT(11121),
  [15920] = {.count = 1, .reusable = true}, SHIFT(11122),
  [15922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7141),
  [15925] = {.count = 1, .reusable = true}, SHIFT(11139),
  [15927] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(7119),
  [15930] = {.count = 1, .reusable = true}, SHIFT(7167),
  [15932] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7185),
  [15935] = {.count = 1, .reusable = true}, SHIFT(11164),
  [15937] = {.count = 1, .reusable = true}, SHIFT(11165),
  [15939] = {.count = 1, .reusable = true}, SHIFT(11167),
  [15941] = {.count = 1, .reusable = true}, SHIFT(7205),
  [15943] = {.count = 1, .reusable = true}, SHIFT(11174),
  [15945] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7251),
  [15948] = {.count = 1, .reusable = true}, SHIFT(11204),
  [15950] = {.count = 1, .reusable = true}, SHIFT(9742),
  [15952] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7299),
  [15955] = {.count = 1, .reusable = true}, SHIFT(9749),
  [15957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7340),
  [15960] = {.count = 1, .reusable = true}, SHIFT(11215),
  [15962] = {.count = 1, .reusable = true}, SHIFT(9772),
  [15964] = {.count = 1, .reusable = true}, SHIFT(11218),
  [15966] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7400),
  [15969] = {.count = 1, .reusable = true}, SHIFT(11221),
  [15971] = {.count = 1, .reusable = true}, SHIFT(9803),
  [15973] = {.count = 1, .reusable = true}, SHIFT(9809),
  [15975] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7459),
  [15978] = {.count = 1, .reusable = true}, SHIFT(7482),
  [15980] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7500),
  [15983] = {.count = 1, .reusable = true}, SHIFT(11250),
  [15985] = {.count = 1, .reusable = true}, SHIFT(11251),
  [15987] = {.count = 1, .reusable = true}, SHIFT(11253),
  [15989] = {.count = 1, .reusable = true}, SHIFT(7520),
  [15991] = {.count = 1, .reusable = true}, SHIFT(11260),
  [15993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7568),
  [15996] = {.count = 1, .reusable = true}, SHIFT(11290),
  [15998] = {.count = 1, .reusable = true}, SHIFT(9930),
  [16000] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7623),
  [16003] = {.count = 1, .reusable = true}, SHIFT(11295),
  [16005] = {.count = 1, .reusable = true}, SHIFT(11296),
  [16007] = {.count = 1, .reusable = true}, SHIFT(11297),
  [16009] = {.count = 1, .reusable = false}, SHIFT(11297),
  [16011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7662),
  [16014] = {.count = 1, .reusable = true}, SHIFT(11304),
  [16016] = {.count = 1, .reusable = true}, SHIFT(11305),
  [16018] = {.count = 1, .reusable = true}, SHIFT(11307),
  [16020] = {.count = 1, .reusable = true}, SHIFT(9978),
  [16022] = {.count = 1, .reusable = true}, SHIFT(11310),
  [16024] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7716),
  [16027] = {.count = 1, .reusable = true}, SHIFT(11311),
  [16029] = {.count = 1, .reusable = true}, SHIFT(11313),
  [16031] = {.count = 1, .reusable = true}, SHIFT(11314),
  [16033] = {.count = 1, .reusable = true}, SHIFT(11315),
  [16035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7758),
  [16038] = {.count = 1, .reusable = true}, SHIFT(11316),
  [16040] = {.count = 1, .reusable = false}, SHIFT(11316),
  [16042] = {.count = 1, .reusable = false}, SHIFT(11318),
  [16044] = {.count = 1, .reusable = true}, SHIFT(11320),
  [16046] = {.count = 1, .reusable = true}, SHIFT(11323),
  [16048] = {.count = 1, .reusable = true}, SHIFT(11324),
  [16050] = {.count = 1, .reusable = true}, SHIFT(11325),
  [16052] = {.count = 1, .reusable = true}, SHIFT(11326),
  [16054] = {.count = 1, .reusable = true}, SHIFT(11328),
  [16056] = {.count = 1, .reusable = true}, SHIFT(11329),
  [16058] = {.count = 1, .reusable = false}, SHIFT(11330),
  [16060] = {.count = 1, .reusable = true}, SHIFT(11330),
  [16062] = {.count = 1, .reusable = true}, SHIFT(11332),
  [16064] = {.count = 1, .reusable = false}, SHIFT(11333),
  [16066] = {.count = 1, .reusable = true}, SHIFT(11334),
  [16068] = {.count = 1, .reusable = false}, SHIFT(11335),
  [16070] = {.count = 1, .reusable = true}, SHIFT(11336),
  [16072] = {.count = 1, .reusable = true}, SHIFT(11339),
  [16074] = {.count = 1, .reusable = true}, SHIFT(11340),
  [16076] = {.count = 1, .reusable = true}, SHIFT(11341),
  [16078] = {.count = 1, .reusable = true}, SHIFT(11343),
  [16080] = {.count = 1, .reusable = true}, SHIFT(11344),
  [16082] = {.count = 1, .reusable = true}, SHIFT(11345),
  [16084] = {.count = 1, .reusable = false}, SHIFT(11346),
  [16086] = {.count = 1, .reusable = true}, SHIFT(11348),
  [16088] = {.count = 1, .reusable = true}, SHIFT(11349),
  [16090] = {.count = 1, .reusable = false}, SHIFT(11350),
  [16092] = {.count = 1, .reusable = true}, SHIFT(7816),
  [16094] = {.count = 1, .reusable = false}, SHIFT(11352),
  [16096] = {.count = 1, .reusable = true}, SHIFT(11352),
  [16098] = {.count = 1, .reusable = true}, SHIFT(11356),
  [16100] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(4900),
  [16103] = {.count = 1, .reusable = true}, SHIFT(10082),
  [16105] = {.count = 1, .reusable = true}, SHIFT(11359),
  [16107] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7872),
  [16110] = {.count = 1, .reusable = true}, SHIFT(11362),
  [16112] = {.count = 1, .reusable = true}, SHIFT(11363),
  [16114] = {.count = 1, .reusable = true}, SHIFT(11365),
  [16116] = {.count = 1, .reusable = true}, SHIFT(11366),
  [16118] = {.count = 1, .reusable = true}, SHIFT(11367),
  [16120] = {.count = 1, .reusable = true}, SHIFT(11368),
  [16122] = {.count = 1, .reusable = true}, SHIFT(11369),
  [16124] = {.count = 1, .reusable = false}, SHIFT(11369),
  [16126] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7937),
  [16129] = {.count = 1, .reusable = true}, SHIFT(11372),
  [16131] = {.count = 1, .reusable = false}, SHIFT(11372),
  [16133] = {.count = 1, .reusable = true}, SHIFT(11376),
  [16135] = {.count = 1, .reusable = true}, SHIFT(11377),
  [16137] = {.count = 1, .reusable = true}, SHIFT(11378),
  [16139] = {.count = 1, .reusable = true}, SHIFT(11379),
  [16141] = {.count = 1, .reusable = true}, SHIFT(11380),
  [16143] = {.count = 1, .reusable = true}, SHIFT(11382),
  [16145] = {.count = 1, .reusable = true}, SHIFT(11384),
  [16147] = {.count = 1, .reusable = true}, SHIFT(11385),
  [16149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8028),
  [16152] = {.count = 1, .reusable = true}, SHIFT(11386),
  [16154] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8048),
  [16157] = {.count = 1, .reusable = true}, SHIFT(11387),
  [16159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8068),
  [16162] = {.count = 1, .reusable = true}, SHIFT(11390),
  [16164] = {.count = 1, .reusable = true}, SHIFT(10213),
  [16166] = {.count = 1, .reusable = true}, SHIFT(11393),
  [16168] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8112),
  [16171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8117),
  [16174] = {.count = 1, .reusable = true}, SHIFT(11396),
  [16176] = {.count = 1, .reusable = true}, SHIFT(10242),
  [16178] = {.count = 1, .reusable = true}, SHIFT(11400),
  [16180] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8183),
  [16183] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8191),
  [16186] = {.count = 1, .reusable = true}, SHIFT(10257),
  [16188] = {.count = 1, .reusable = true}, SHIFT(11403),
  [16190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8229),
  [16193] = {.count = 1, .reusable = true}, SHIFT(11418),
  [16195] = {.count = 1, .reusable = true}, SHIFT(11419),
  [16197] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8270),
  [16200] = {.count = 1, .reusable = true}, SHIFT(10298),
  [16202] = {.count = 1, .reusable = true}, SHIFT(11422),
  [16204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8309),
  [16207] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8316),
  [16210] = {.count = 1, .reusable = true}, SHIFT(10326),
  [16212] = {.count = 1, .reusable = false}, SHIFT(10330),
  [16214] = {.count = 1, .reusable = true}, SHIFT(10334),
  [16216] = {.count = 1, .reusable = false}, SHIFT(11441),
  [16218] = {.count = 1, .reusable = true}, SHIFT(11443),
  [16220] = {.count = 1, .reusable = true}, SHIFT(11444),
  [16222] = {.count = 1, .reusable = false}, SHIFT(11445),
  [16224] = {.count = 1, .reusable = true}, SHIFT(11446),
  [16226] = {.count = 1, .reusable = true}, SHIFT(11447),
  [16228] = {.count = 1, .reusable = true}, SHIFT(11448),
  [16230] = {.count = 1, .reusable = false}, SHIFT(11464),
  [16232] = {.count = 1, .reusable = false}, SHIFT(11461),
  [16234] = {.count = 1, .reusable = true}, SHIFT(11457),
  [16236] = {.count = 1, .reusable = false}, SHIFT(11459),
  [16238] = {.count = 1, .reusable = false}, SHIFT(11465),
  [16240] = {.count = 1, .reusable = false}, SHIFT(11455),
  [16242] = {.count = 1, .reusable = true}, SHIFT(11464),
  [16244] = {.count = 1, .reusable = false}, SHIFT(11456),
  [16246] = {.count = 1, .reusable = true}, SHIFT(11465),
  [16248] = {.count = 1, .reusable = true}, SHIFT(11456),
  [16250] = {.count = 1, .reusable = false}, SHIFT(11458),
  [16252] = {.count = 1, .reusable = true}, SHIFT(11459),
  [16254] = {.count = 1, .reusable = true}, SHIFT(11460),
  [16256] = {.count = 1, .reusable = false}, SHIFT(11454),
  [16258] = {.count = 1, .reusable = true}, SHIFT(11470),
  [16260] = {.count = 1, .reusable = true}, SHIFT(11473),
  [16262] = {.count = 1, .reusable = false}, SHIFT(11474),
  [16264] = {.count = 1, .reusable = false}, SHIFT(11475),
  [16266] = {.count = 1, .reusable = true}, SHIFT(11476),
  [16268] = {.count = 1, .reusable = true}, SHIFT(11477),
  [16270] = {.count = 1, .reusable = true}, SHIFT(11479),
  [16272] = {.count = 1, .reusable = true}, SHIFT(11480),
  [16274] = {.count = 1, .reusable = true}, SHIFT(11478),
  [16276] = {.count = 1, .reusable = true}, SHIFT(11481),
  [16278] = {.count = 1, .reusable = false}, SHIFT(11482),
  [16280] = {.count = 1, .reusable = false}, SHIFT(11478),
  [16282] = {.count = 1, .reusable = true}, SHIFT(11475),
  [16284] = {.count = 1, .reusable = false}, SHIFT(11483),
  [16286] = {.count = 1, .reusable = false}, SHIFT(11480),
  [16288] = {.count = 1, .reusable = true}, SHIFT(11483),
  [16290] = {.count = 1, .reusable = true}, SHIFT(11485),
  [16292] = {.count = 1, .reusable = false}, SHIFT(11484),
  [16294] = {.count = 1, .reusable = true}, SHIFT(11484),
  [16296] = {.count = 1, .reusable = false}, SHIFT(11486),
  [16298] = {.count = 1, .reusable = true}, SHIFT(11487),
  [16300] = {.count = 1, .reusable = true}, SHIFT(11488),
  [16302] = {.count = 1, .reusable = true}, SHIFT(11489),
  [16304] = {.count = 1, .reusable = true}, SHIFT(11474),
  [16306] = {.count = 1, .reusable = false}, SHIFT(11444),
  [16308] = {.count = 1, .reusable = false}, SHIFT(10365),
  [16310] = {.count = 1, .reusable = true}, SHIFT(11497),
  [16312] = {.count = 1, .reusable = false}, SHIFT(11510),
  [16314] = {.count = 1, .reusable = true}, SHIFT(11510),
  [16316] = {.count = 1, .reusable = true}, SHIFT(11511),
  [16318] = {.count = 1, .reusable = true}, SHIFT(11512),
  [16320] = {.count = 1, .reusable = true}, SHIFT(11515),
  [16322] = {.count = 1, .reusable = false}, SHIFT(10368),
  [16324] = {.count = 1, .reusable = false}, SHIFT(11518),
  [16326] = {.count = 1, .reusable = true}, SHIFT(11520),
  [16328] = {.count = 1, .reusable = false}, SHIFT(11530),
  [16330] = {.count = 1, .reusable = false}, SHIFT(11527),
  [16332] = {.count = 1, .reusable = true}, SHIFT(11524),
  [16334] = {.count = 1, .reusable = false}, SHIFT(11526),
  [16336] = {.count = 1, .reusable = false}, SHIFT(11531),
  [16338] = {.count = 1, .reusable = false}, SHIFT(11522),
  [16340] = {.count = 1, .reusable = true}, SHIFT(11530),
  [16342] = {.count = 1, .reusable = false}, SHIFT(11523),
  [16344] = {.count = 1, .reusable = true}, SHIFT(11531),
  [16346] = {.count = 1, .reusable = true}, SHIFT(11523),
  [16348] = {.count = 1, .reusable = false}, SHIFT(11525),
  [16350] = {.count = 1, .reusable = true}, SHIFT(11526),
  [16352] = {.count = 1, .reusable = false}, SHIFT(11521),
  [16354] = {.count = 1, .reusable = true}, SHIFT(11536),
  [16356] = {.count = 1, .reusable = true}, SHIFT(11537),
  [16358] = {.count = 1, .reusable = true}, SHIFT(11540),
  [16360] = {.count = 1, .reusable = false}, SHIFT(11536),
  [16362] = {.count = 1, .reusable = false}, SHIFT(11541),
  [16364] = {.count = 1, .reusable = false}, SHIFT(11542),
  [16366] = {.count = 1, .reusable = true}, SHIFT(11543),
  [16368] = {.count = 1, .reusable = false}, SHIFT(11545),
  [16370] = {.count = 1, .reusable = true}, SHIFT(11546),
  [16372] = {.count = 1, .reusable = true}, SHIFT(11544),
  [16374] = {.count = 1, .reusable = false}, SHIFT(11547),
  [16376] = {.count = 1, .reusable = false}, SHIFT(11548),
  [16378] = {.count = 1, .reusable = true}, SHIFT(11542),
  [16380] = {.count = 1, .reusable = false}, SHIFT(11544),
  [16382] = {.count = 1, .reusable = true}, SHIFT(11541),
  [16384] = {.count = 1, .reusable = false}, SHIFT(11549),
  [16386] = {.count = 1, .reusable = false}, SHIFT(11546),
  [16388] = {.count = 1, .reusable = true}, SHIFT(11547),
  [16390] = {.count = 1, .reusable = false}, SHIFT(11520),
  [16392] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [16394] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [16396] = {.count = 1, .reusable = true}, SHIFT(11552),
  [16398] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [16400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(8358),
  [16403] = {.count = 1, .reusable = true}, SHIFT(11554),
  [16405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8370),
  [16408] = {.count = 1, .reusable = true}, SHIFT(11559),
  [16410] = {.count = 1, .reusable = true}, SHIFT(10418),
  [16412] = {.count = 1, .reusable = true}, SHIFT(11562),
  [16414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8417),
  [16417] = {.count = 1, .reusable = true}, SHIFT(11563),
  [16419] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8439),
  [16422] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 6),
  [16424] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 6),
  [16426] = {.count = 1, .reusable = true}, SHIFT(11566),
  [16428] = {.count = 1, .reusable = true}, SHIFT(10459),
  [16430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8482),
  [16433] = {.count = 1, .reusable = true}, SHIFT(10470),
  [16435] = {.count = 1, .reusable = true}, SHIFT(11571),
  [16437] = {.count = 1, .reusable = true}, SHIFT(11572),
  [16439] = {.count = 1, .reusable = true}, SHIFT(11574),
  [16441] = {.count = 1, .reusable = true}, SHIFT(11575),
  [16443] = {.count = 1, .reusable = true}, SHIFT(11578),
  [16445] = {.count = 1, .reusable = true}, SHIFT(10506),
  [16447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8561),
  [16450] = {.count = 1, .reusable = true}, SHIFT(11583),
  [16452] = {.count = 1, .reusable = true}, SHIFT(10526),
  [16454] = {.count = 1, .reusable = false}, SHIFT(11586),
  [16456] = {.count = 1, .reusable = true}, SHIFT(11586),
  [16458] = {.count = 1, .reusable = true}, SHIFT(11588),
  [16460] = {.count = 1, .reusable = true}, SHIFT(11589),
  [16462] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 5),
  [16464] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 5),
  [16466] = {.count = 1, .reusable = true}, SHIFT(11590),
  [16468] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(8613),
  [16471] = {.count = 1, .reusable = true}, SHIFT(11591),
  [16473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8632),
  [16476] = {.count = 1, .reusable = true}, SHIFT(11592),
  [16478] = {.count = 1, .reusable = true}, SHIFT(10552),
  [16480] = {.count = 1, .reusable = true}, SHIFT(11595),
  [16482] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8672),
  [16485] = {.count = 1, .reusable = true}, SHIFT(11596),
  [16487] = {.count = 1, .reusable = true}, SHIFT(10569),
  [16489] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8725),
  [16492] = {.count = 1, .reusable = false}, REDUCE(sym_case, 7),
  [16494] = {.count = 1, .reusable = true}, REDUCE(sym_case, 7),
  [16496] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8754),
  [16499] = {.count = 1, .reusable = true}, SHIFT(10596),
  [16501] = {.count = 1, .reusable = true}, SHIFT(11615),
  [16503] = {.count = 1, .reusable = false}, SHIFT(10607),
  [16505] = {.count = 1, .reusable = true}, SHIFT(10611),
  [16507] = {.count = 1, .reusable = false}, SHIFT(11619),
  [16509] = {.count = 1, .reusable = true}, SHIFT(11621),
  [16511] = {.count = 1, .reusable = true}, SHIFT(11622),
  [16513] = {.count = 1, .reusable = false}, SHIFT(11623),
  [16515] = {.count = 1, .reusable = true}, SHIFT(11624),
  [16517] = {.count = 1, .reusable = true}, SHIFT(11625),
  [16519] = {.count = 1, .reusable = true}, SHIFT(11626),
  [16521] = {.count = 1, .reusable = false}, SHIFT(11638),
  [16523] = {.count = 1, .reusable = true}, SHIFT(11635),
  [16525] = {.count = 1, .reusable = false}, SHIFT(11637),
  [16527] = {.count = 1, .reusable = false}, SHIFT(11633),
  [16529] = {.count = 1, .reusable = false}, SHIFT(11634),
  [16531] = {.count = 1, .reusable = true}, SHIFT(11634),
  [16533] = {.count = 1, .reusable = false}, SHIFT(11636),
  [16535] = {.count = 1, .reusable = true}, SHIFT(11637),
  [16537] = {.count = 1, .reusable = false}, SHIFT(11632),
  [16539] = {.count = 1, .reusable = true}, SHIFT(11645),
  [16541] = {.count = 1, .reusable = true}, SHIFT(11648),
  [16543] = {.count = 1, .reusable = false}, SHIFT(11649),
  [16545] = {.count = 1, .reusable = false}, SHIFT(11650),
  [16547] = {.count = 1, .reusable = true}, SHIFT(11651),
  [16549] = {.count = 1, .reusable = true}, SHIFT(11652),
  [16551] = {.count = 1, .reusable = true}, SHIFT(11654),
  [16553] = {.count = 1, .reusable = true}, SHIFT(11655),
  [16555] = {.count = 1, .reusable = true}, SHIFT(11653),
  [16557] = {.count = 1, .reusable = false}, SHIFT(11657),
  [16559] = {.count = 1, .reusable = true}, SHIFT(11656),
  [16561] = {.count = 1, .reusable = false}, SHIFT(11653),
  [16563] = {.count = 1, .reusable = true}, SHIFT(11650),
  [16565] = {.count = 1, .reusable = false}, SHIFT(11658),
  [16567] = {.count = 1, .reusable = false}, SHIFT(11655),
  [16569] = {.count = 1, .reusable = true}, SHIFT(11658),
  [16571] = {.count = 1, .reusable = true}, SHIFT(11660),
  [16573] = {.count = 1, .reusable = false}, SHIFT(11659),
  [16575] = {.count = 1, .reusable = true}, SHIFT(11659),
  [16577] = {.count = 1, .reusable = false}, SHIFT(11661),
  [16579] = {.count = 1, .reusable = true}, SHIFT(11662),
  [16581] = {.count = 1, .reusable = true}, SHIFT(11664),
  [16583] = {.count = 1, .reusable = true}, SHIFT(11663),
  [16585] = {.count = 1, .reusable = true}, SHIFT(11649),
  [16587] = {.count = 1, .reusable = false}, SHIFT(11622),
  [16589] = {.count = 1, .reusable = true}, SHIFT(11675),
  [16591] = {.count = 1, .reusable = true}, SHIFT(11674),
  [16593] = {.count = 1, .reusable = false}, SHIFT(11678),
  [16595] = {.count = 1, .reusable = true}, SHIFT(11678),
  [16597] = {.count = 1, .reusable = true}, SHIFT(11679),
  [16599] = {.count = 1, .reusable = true}, SHIFT(11680),
  [16601] = {.count = 1, .reusable = true}, SHIFT(11683),
  [16603] = {.count = 1, .reusable = true}, SHIFT(11686),
  [16605] = {.count = 1, .reusable = false}, SHIFT(11687),
  [16607] = {.count = 1, .reusable = true}, SHIFT(11684),
  [16609] = {.count = 1, .reusable = false}, SHIFT(11685),
  [16611] = {.count = 1, .reusable = true}, SHIFT(11685),
  [16613] = {.count = 1, .reusable = true}, SHIFT(11687),
  [16615] = {.count = 1, .reusable = false}, SHIFT(10638),
  [16617] = {.count = 1, .reusable = false}, SHIFT(11694),
  [16619] = {.count = 1, .reusable = true}, SHIFT(11696),
  [16621] = {.count = 1, .reusable = false}, SHIFT(11706),
  [16623] = {.count = 1, .reusable = false}, SHIFT(11703),
  [16625] = {.count = 1, .reusable = true}, SHIFT(11700),
  [16627] = {.count = 1, .reusable = false}, SHIFT(11702),
  [16629] = {.count = 1, .reusable = false}, SHIFT(11707),
  [16631] = {.count = 1, .reusable = false}, SHIFT(11698),
  [16633] = {.count = 1, .reusable = true}, SHIFT(11706),
  [16635] = {.count = 1, .reusable = false}, SHIFT(11699),
  [16637] = {.count = 1, .reusable = true}, SHIFT(11707),
  [16639] = {.count = 1, .reusable = true}, SHIFT(11699),
  [16641] = {.count = 1, .reusable = false}, SHIFT(11701),
  [16643] = {.count = 1, .reusable = true}, SHIFT(11702),
  [16645] = {.count = 1, .reusable = false}, SHIFT(11697),
  [16647] = {.count = 1, .reusable = true}, SHIFT(11712),
  [16649] = {.count = 1, .reusable = true}, SHIFT(11713),
  [16651] = {.count = 1, .reusable = true}, SHIFT(11716),
  [16653] = {.count = 1, .reusable = false}, SHIFT(11712),
  [16655] = {.count = 1, .reusable = false}, SHIFT(11718),
  [16657] = {.count = 1, .reusable = true}, SHIFT(11720),
  [16659] = {.count = 1, .reusable = false}, SHIFT(11721),
  [16661] = {.count = 1, .reusable = true}, SHIFT(11718),
  [16663] = {.count = 1, .reusable = false}, SHIFT(11723),
  [16665] = {.count = 1, .reusable = false}, SHIFT(11724),
  [16667] = {.count = 1, .reusable = false}, SHIFT(11717),
  [16669] = {.count = 1, .reusable = false}, SHIFT(11725),
  [16671] = {.count = 1, .reusable = false}, SHIFT(11722),
  [16673] = {.count = 1, .reusable = true}, SHIFT(11719),
  [16675] = {.count = 1, .reusable = true}, SHIFT(11722),
  [16677] = {.count = 1, .reusable = false}, SHIFT(11720),
  [16679] = {.count = 1, .reusable = true}, SHIFT(11717),
  [16681] = {.count = 1, .reusable = true}, SHIFT(11723),
  [16683] = {.count = 1, .reusable = false}, SHIFT(11696),
  [16685] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8785),
  [16688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8819),
  [16691] = {.count = 1, .reusable = true}, SHIFT(10694),
  [16693] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8845),
  [16696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8867),
  [16699] = {.count = 1, .reusable = true}, SHIFT(8874),
  [16701] = {.count = 1, .reusable = true}, SHIFT(11764),
  [16703] = {.count = 1, .reusable = true}, SHIFT(10729),
  [16705] = {.count = 1, .reusable = true}, SHIFT(10733),
  [16707] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8940),
  [16710] = {.count = 1, .reusable = true}, SHIFT(10738),
  [16712] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8965),
  [16715] = {.count = 1, .reusable = true}, SHIFT(10743),
  [16717] = {.count = 1, .reusable = true}, SHIFT(11774),
  [16719] = {.count = 1, .reusable = true}, SHIFT(9005),
  [16721] = {.count = 1, .reusable = false}, SHIFT(11781),
  [16723] = {.count = 1, .reusable = true}, SHIFT(11782),
  [16725] = {.count = 1, .reusable = true}, SHIFT(11786),
  [16727] = {.count = 1, .reusable = false}, SHIFT(11782),
  [16729] = {.count = 1, .reusable = true}, SHIFT(11805),
  [16731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(9027),
  [16734] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9028),
  [16737] = {.count = 1, .reusable = true}, SHIFT(11807),
  [16739] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9044),
  [16742] = {.count = 1, .reusable = true}, SHIFT(10809),
  [16744] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9079),
  [16747] = {.count = 1, .reusable = true}, SHIFT(11814),
  [16749] = {.count = 1, .reusable = true}, SHIFT(10834),
  [16751] = {.count = 1, .reusable = true}, SHIFT(11817),
  [16753] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9126),
  [16756] = {.count = 1, .reusable = true}, SHIFT(11818),
  [16758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9147),
  [16761] = {.count = 1, .reusable = true}, SHIFT(11821),
  [16763] = {.count = 1, .reusable = true}, SHIFT(10874),
  [16765] = {.count = 1, .reusable = true}, SHIFT(10880),
  [16767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9206),
  [16770] = {.count = 1, .reusable = true}, SHIFT(10887),
  [16772] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9246),
  [16775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9263),
  [16778] = {.count = 1, .reusable = true}, SHIFT(10898),
  [16780] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9280),
  [16783] = {.count = 1, .reusable = true}, SHIFT(9294),
  [16785] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9312),
  [16788] = {.count = 1, .reusable = true}, SHIFT(11855),
  [16790] = {.count = 1, .reusable = true}, SHIFT(11856),
  [16792] = {.count = 1, .reusable = true}, SHIFT(11858),
  [16794] = {.count = 1, .reusable = true}, SHIFT(9332),
  [16796] = {.count = 1, .reusable = true}, SHIFT(11865),
  [16798] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9380),
  [16801] = {.count = 1, .reusable = true}, SHIFT(11895),
  [16803] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4),
  [16805] = {.count = 1, .reusable = true}, SHIFT(11897),
  [16807] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9439),
  [16810] = {.count = 1, .reusable = true}, SHIFT(11898),
  [16812] = {.count = 1, .reusable = true}, SHIFT(11900),
  [16814] = {.count = 1, .reusable = true}, SHIFT(11901),
  [16816] = {.count = 1, .reusable = true}, SHIFT(11902),
  [16818] = {.count = 1, .reusable = true}, SHIFT(11903),
  [16820] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9490),
  [16823] = {.count = 1, .reusable = true}, SHIFT(11905),
  [16825] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9516),
  [16828] = {.count = 1, .reusable = true}, SHIFT(11910),
  [16830] = {.count = 1, .reusable = true}, SHIFT(11911),
  [16832] = {.count = 1, .reusable = true}, SHIFT(11913),
  [16834] = {.count = 1, .reusable = true}, SHIFT(11094),
  [16836] = {.count = 1, .reusable = true}, SHIFT(11916),
  [16838] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9566),
  [16841] = {.count = 1, .reusable = true}, SHIFT(11917),
  [16843] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9585),
  [16846] = {.count = 1, .reusable = true}, SHIFT(11920),
  [16848] = {.count = 1, .reusable = true}, SHIFT(11137),
  [16850] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9635),
  [16853] = {.count = 1, .reusable = true}, SHIFT(11927),
  [16855] = {.count = 1, .reusable = true}, SHIFT(11162),
  [16857] = {.count = 1, .reusable = true}, SHIFT(11930),
  [16859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9682),
  [16862] = {.count = 1, .reusable = true}, SHIFT(11931),
  [16864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9703),
  [16867] = {.count = 1, .reusable = true}, SHIFT(11934),
  [16869] = {.count = 1, .reusable = true}, SHIFT(11202),
  [16871] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9742),
  [16874] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9749),
  [16877] = {.count = 1, .reusable = true}, SHIFT(11213),
  [16879] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9772),
  [16882] = {.count = 1, .reusable = true}, SHIFT(11219),
  [16884] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9803),
  [16887] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9809),
  [16890] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9823),
  [16893] = {.count = 1, .reusable = true}, SHIFT(11946),
  [16895] = {.count = 1, .reusable = true}, SHIFT(11248),
  [16897] = {.count = 1, .reusable = true}, SHIFT(11949),
  [16899] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9870),
  [16902] = {.count = 1, .reusable = true}, SHIFT(11950),
  [16904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9892),
  [16907] = {.count = 1, .reusable = true}, SHIFT(11953),
  [16909] = {.count = 1, .reusable = true}, SHIFT(11288),
  [16911] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9930),
  [16914] = {.count = 1, .reusable = true}, SHIFT(11956),
  [16916] = {.count = 1, .reusable = true}, SHIFT(11302),
  [16918] = {.count = 1, .reusable = true}, SHIFT(11959),
  [16920] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9978),
  [16923] = {.count = 1, .reusable = true}, SHIFT(11960),
  [16925] = {.count = 1, .reusable = true}, SHIFT(11962),
  [16927] = {.count = 1, .reusable = true}, SHIFT(11963),
  [16929] = {.count = 1, .reusable = true}, SHIFT(11964),
  [16931] = {.count = 1, .reusable = true}, SHIFT(11967),
  [16933] = {.count = 1, .reusable = true}, SHIFT(11968),
  [16935] = {.count = 1, .reusable = true}, SHIFT(11969),
  [16937] = {.count = 1, .reusable = true}, SHIFT(11970),
  [16939] = {.count = 1, .reusable = false}, SHIFT(11971),
  [16941] = {.count = 1, .reusable = false}, SHIFT(11972),
  [16943] = {.count = 1, .reusable = true}, SHIFT(11973),
  [16945] = {.count = 1, .reusable = true}, SHIFT(11975),
  [16947] = {.count = 1, .reusable = true}, SHIFT(11976),
  [16949] = {.count = 1, .reusable = true}, SHIFT(11977),
  [16951] = {.count = 1, .reusable = true}, SHIFT(11978),
  [16953] = {.count = 1, .reusable = false}, SHIFT(11979),
  [16955] = {.count = 1, .reusable = true}, SHIFT(11981),
  [16957] = {.count = 1, .reusable = true}, SHIFT(11982),
  [16959] = {.count = 1, .reusable = true}, SHIFT(11354),
  [16961] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10082),
  [16964] = {.count = 1, .reusable = true}, SHIFT(11360),
  [16966] = {.count = 1, .reusable = true}, SHIFT(11988),
  [16968] = {.count = 1, .reusable = true}, SHIFT(11989),
  [16970] = {.count = 1, .reusable = true}, SHIFT(11990),
  [16972] = {.count = 1, .reusable = true}, SHIFT(11374),
  [16974] = {.count = 1, .reusable = true}, SHIFT(11993),
  [16976] = {.count = 1, .reusable = true}, SHIFT(11388),
  [16978] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10213),
  [16981] = {.count = 1, .reusable = true}, SHIFT(11394),
  [16983] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10242),
  [16986] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10257),
  [16989] = {.count = 1, .reusable = true}, SHIFT(12000),
  [16991] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10298),
  [16994] = {.count = 1, .reusable = true}, SHIFT(12003),
  [16996] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10326),
  [16999] = {.count = 1, .reusable = false}, SHIFT(12006),
  [17001] = {.count = 1, .reusable = true}, SHIFT(12007),
  [17003] = {.count = 1, .reusable = true}, SHIFT(12011),
  [17005] = {.count = 1, .reusable = false}, SHIFT(12007),
  [17007] = {.count = 1, .reusable = true}, SHIFT(12016),
  [17009] = {.count = 1, .reusable = true}, SHIFT(12017),
  [17011] = {.count = 1, .reusable = false}, SHIFT(12018),
  [17013] = {.count = 1, .reusable = false}, SHIFT(12019),
  [17015] = {.count = 1, .reusable = true}, SHIFT(12021),
  [17017] = {.count = 1, .reusable = true}, SHIFT(12022),
  [17019] = {.count = 1, .reusable = true}, SHIFT(12023),
  [17021] = {.count = 1, .reusable = true}, SHIFT(12024),
  [17023] = {.count = 1, .reusable = true}, SHIFT(12020),
  [17025] = {.count = 1, .reusable = true}, SHIFT(12025),
  [17027] = {.count = 1, .reusable = false}, SHIFT(12026),
  [17029] = {.count = 1, .reusable = false}, SHIFT(12020),
  [17031] = {.count = 1, .reusable = true}, SHIFT(12019),
  [17033] = {.count = 1, .reusable = false}, SHIFT(12027),
  [17035] = {.count = 1, .reusable = false}, SHIFT(12024),
  [17037] = {.count = 1, .reusable = true}, SHIFT(12027),
  [17039] = {.count = 1, .reusable = true}, SHIFT(12029),
  [17041] = {.count = 1, .reusable = false}, SHIFT(12028),
  [17043] = {.count = 1, .reusable = true}, SHIFT(12028),
  [17045] = {.count = 1, .reusable = true}, SHIFT(12018),
  [17047] = {.count = 1, .reusable = true}, SHIFT(10341),
  [17049] = {.count = 1, .reusable = false}, SHIFT(12048),
  [17051] = {.count = 1, .reusable = true}, SHIFT(12048),
  [17053] = {.count = 1, .reusable = true}, SHIFT(12049),
  [17055] = {.count = 1, .reusable = true}, SHIFT(12050),
  [17057] = {.count = 1, .reusable = true}, SHIFT(12053),
  [17059] = {.count = 1, .reusable = false}, SHIFT(12054),
  [17061] = {.count = 1, .reusable = true}, SHIFT(12055),
  [17063] = {.count = 1, .reusable = true}, SHIFT(12059),
  [17065] = {.count = 1, .reusable = false}, SHIFT(12055),
  [17067] = {.count = 1, .reusable = true}, SHIFT(12066),
  [17069] = {.count = 1, .reusable = true}, SHIFT(12067),
  [17071] = {.count = 1, .reusable = true}, SHIFT(12069),
  [17073] = {.count = 1, .reusable = true}, SHIFT(12074),
  [17075] = {.count = 1, .reusable = false}, SHIFT(12075),
  [17077] = {.count = 1, .reusable = false}, SHIFT(12076),
  [17079] = {.count = 1, .reusable = false}, SHIFT(12078),
  [17081] = {.count = 1, .reusable = true}, SHIFT(12079),
  [17083] = {.count = 1, .reusable = false}, SHIFT(12080),
  [17085] = {.count = 1, .reusable = true}, SHIFT(12081),
  [17087] = {.count = 1, .reusable = true}, SHIFT(12077),
  [17089] = {.count = 1, .reusable = false}, SHIFT(12082),
  [17091] = {.count = 1, .reusable = false}, SHIFT(12083),
  [17093] = {.count = 1, .reusable = true}, SHIFT(12078),
  [17095] = {.count = 1, .reusable = false}, SHIFT(12077),
  [17097] = {.count = 1, .reusable = true}, SHIFT(12076),
  [17099] = {.count = 1, .reusable = false}, SHIFT(12084),
  [17101] = {.count = 1, .reusable = false}, SHIFT(12081),
  [17103] = {.count = 1, .reusable = true}, SHIFT(12082),
  [17105] = {.count = 1, .reusable = true}, SHIFT(12075),
  [17107] = {.count = 1, .reusable = true}, SHIFT(10378),
  [17109] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [17111] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [17113] = {.count = 1, .reusable = true}, SHIFT(12104),
  [17115] = {.count = 1, .reusable = true}, SHIFT(11557),
  [17117] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10418),
  [17120] = {.count = 1, .reusable = true}, SHIFT(11564),
  [17122] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10459),
  [17125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10470),
  [17128] = {.count = 1, .reusable = true}, SHIFT(12111),
  [17130] = {.count = 1, .reusable = true}, SHIFT(11576),
  [17132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10506),
  [17135] = {.count = 1, .reusable = true}, SHIFT(11581),
  [17137] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10526),
  [17140] = {.count = 1, .reusable = true}, SHIFT(12118),
  [17142] = {.count = 1, .reusable = false}, SHIFT(12118),
  [17144] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10552),
  [17147] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10569),
  [17150] = {.count = 1, .reusable = true}, SHIFT(12122),
  [17152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10596),
  [17155] = {.count = 1, .reusable = false}, SHIFT(12126),
  [17157] = {.count = 1, .reusable = true}, SHIFT(12127),
  [17159] = {.count = 1, .reusable = true}, SHIFT(12131),
  [17161] = {.count = 1, .reusable = false}, SHIFT(12127),
  [17163] = {.count = 1, .reusable = true}, SHIFT(12138),
  [17165] = {.count = 1, .reusable = false}, SHIFT(12139),
  [17167] = {.count = 1, .reusable = false}, SHIFT(12140),
  [17169] = {.count = 1, .reusable = true}, SHIFT(12142),
  [17171] = {.count = 1, .reusable = true}, SHIFT(12143),
  [17173] = {.count = 1, .reusable = true}, SHIFT(12144),
  [17175] = {.count = 1, .reusable = true}, SHIFT(12145),
  [17177] = {.count = 1, .reusable = true}, SHIFT(12141),
  [17179] = {.count = 1, .reusable = false}, SHIFT(12147),
  [17181] = {.count = 1, .reusable = true}, SHIFT(12146),
  [17183] = {.count = 1, .reusable = false}, SHIFT(12141),
  [17185] = {.count = 1, .reusable = true}, SHIFT(12140),
  [17187] = {.count = 1, .reusable = false}, SHIFT(12148),
  [17189] = {.count = 1, .reusable = false}, SHIFT(12145),
  [17191] = {.count = 1, .reusable = true}, SHIFT(12148),
  [17193] = {.count = 1, .reusable = true}, SHIFT(12139),
  [17195] = {.count = 1, .reusable = true}, SHIFT(10618),
  [17197] = {.count = 1, .reusable = false}, SHIFT(12167),
  [17199] = {.count = 1, .reusable = true}, SHIFT(12167),
  [17201] = {.count = 1, .reusable = true}, SHIFT(12168),
  [17203] = {.count = 1, .reusable = true}, SHIFT(12169),
  [17205] = {.count = 1, .reusable = true}, SHIFT(12172),
  [17207] = {.count = 1, .reusable = false}, SHIFT(12173),
  [17209] = {.count = 1, .reusable = true}, SHIFT(12174),
  [17211] = {.count = 1, .reusable = true}, SHIFT(12178),
  [17213] = {.count = 1, .reusable = false}, SHIFT(12174),
  [17215] = {.count = 1, .reusable = true}, SHIFT(12182),
  [17217] = {.count = 1, .reusable = true}, SHIFT(12183),
  [17219] = {.count = 1, .reusable = true}, SHIFT(12185),
  [17221] = {.count = 1, .reusable = true}, SHIFT(12189),
  [17223] = {.count = 1, .reusable = false}, SHIFT(12190),
  [17225] = {.count = 1, .reusable = false}, SHIFT(12191),
  [17227] = {.count = 1, .reusable = true}, SHIFT(12193),
  [17229] = {.count = 1, .reusable = true}, SHIFT(12194),
  [17231] = {.count = 1, .reusable = true}, SHIFT(12195),
  [17233] = {.count = 1, .reusable = true}, SHIFT(12196),
  [17235] = {.count = 1, .reusable = true}, SHIFT(12192),
  [17237] = {.count = 1, .reusable = false}, SHIFT(12198),
  [17239] = {.count = 1, .reusable = true}, SHIFT(12197),
  [17241] = {.count = 1, .reusable = false}, SHIFT(12192),
  [17243] = {.count = 1, .reusable = true}, SHIFT(12191),
  [17245] = {.count = 1, .reusable = false}, SHIFT(12199),
  [17247] = {.count = 1, .reusable = false}, SHIFT(12196),
  [17249] = {.count = 1, .reusable = true}, SHIFT(12199),
  [17251] = {.count = 1, .reusable = true}, SHIFT(12190),
  [17253] = {.count = 1, .reusable = true}, SHIFT(12200),
  [17255] = {.count = 1, .reusable = true}, SHIFT(12206),
  [17257] = {.count = 1, .reusable = false}, SHIFT(12207),
  [17259] = {.count = 1, .reusable = false}, SHIFT(12210),
  [17261] = {.count = 1, .reusable = true}, SHIFT(12209),
  [17263] = {.count = 1, .reusable = false}, SHIFT(12212),
  [17265] = {.count = 1, .reusable = true}, SHIFT(12210),
  [17267] = {.count = 1, .reusable = false}, SHIFT(12214),
  [17269] = {.count = 1, .reusable = false}, SHIFT(12215),
  [17271] = {.count = 1, .reusable = false}, SHIFT(12208),
  [17273] = {.count = 1, .reusable = false}, SHIFT(12216),
  [17275] = {.count = 1, .reusable = false}, SHIFT(12213),
  [17277] = {.count = 1, .reusable = true}, SHIFT(12211),
  [17279] = {.count = 1, .reusable = true}, SHIFT(12213),
  [17281] = {.count = 1, .reusable = false}, SHIFT(12209),
  [17283] = {.count = 1, .reusable = true}, SHIFT(12208),
  [17285] = {.count = 1, .reusable = true}, SHIFT(12214),
  [17287] = {.count = 1, .reusable = true}, SHIFT(12207),
  [17289] = {.count = 1, .reusable = true}, SHIFT(10648),
  [17291] = {.count = 1, .reusable = true}, SHIFT(12236),
  [17293] = {.count = 1, .reusable = true}, SHIFT(12239),
  [17295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10694),
  [17298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10712),
  [17301] = {.count = 1, .reusable = true}, SHIFT(11762),
  [17303] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10729),
  [17306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10733),
  [17309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10738),
  [17312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10743),
  [17315] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10757),
  [17318] = {.count = 1, .reusable = true}, SHIFT(10764),
  [17320] = {.count = 1, .reusable = true}, SHIFT(12250),
  [17322] = {.count = 1, .reusable = true}, SHIFT(11803),
  [17324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10809),
  [17327] = {.count = 1, .reusable = true}, SHIFT(11812),
  [17329] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10834),
  [17332] = {.count = 1, .reusable = true}, SHIFT(11819),
  [17334] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10874),
  [17337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10880),
  [17340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10887),
  [17343] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10898),
  [17346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10911),
  [17349] = {.count = 1, .reusable = true}, SHIFT(12262),
  [17351] = {.count = 1, .reusable = true}, SHIFT(11853),
  [17353] = {.count = 1, .reusable = true}, SHIFT(12265),
  [17355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10958),
  [17358] = {.count = 1, .reusable = true}, SHIFT(12266),
  [17360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10980),
  [17363] = {.count = 1, .reusable = true}, SHIFT(12269),
  [17365] = {.count = 1, .reusable = true}, SHIFT(11893),
  [17367] = {.count = 1, .reusable = true}, SHIFT(12273),
  [17369] = {.count = 1, .reusable = true}, SHIFT(11908),
  [17371] = {.count = 1, .reusable = true}, SHIFT(12276),
  [17373] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11094),
  [17376] = {.count = 1, .reusable = true}, SHIFT(11918),
  [17378] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11137),
  [17381] = {.count = 1, .reusable = true}, SHIFT(11925),
  [17383] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11162),
  [17386] = {.count = 1, .reusable = true}, SHIFT(11932),
  [17388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11202),
  [17391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11213),
  [17394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11219),
  [17397] = {.count = 1, .reusable = true}, SHIFT(11944),
  [17399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11248),
  [17402] = {.count = 1, .reusable = true}, SHIFT(11951),
  [17404] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11288),
  [17407] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11302),
  [17410] = {.count = 1, .reusable = true}, SHIFT(12290),
  [17412] = {.count = 1, .reusable = true}, SHIFT(12292),
  [17414] = {.count = 1, .reusable = true}, SHIFT(12293),
  [17416] = {.count = 1, .reusable = true}, SHIFT(12294),
  [17418] = {.count = 1, .reusable = true}, SHIFT(12295),
  [17420] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11354),
  [17423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11360),
  [17426] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11374),
  [17429] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11388),
  [17432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11394),
  [17435] = {.count = 1, .reusable = true}, SHIFT(11998),
  [17437] = {.count = 1, .reusable = true}, SHIFT(12001),
  [17439] = {.count = 1, .reusable = true}, SHIFT(11449),
  [17441] = {.count = 1, .reusable = false}, SHIFT(12320),
  [17443] = {.count = 1, .reusable = true}, SHIFT(12320),
  [17445] = {.count = 1, .reusable = true}, SHIFT(12321),
  [17447] = {.count = 1, .reusable = true}, SHIFT(12322),
  [17449] = {.count = 1, .reusable = true}, SHIFT(12325),
  [17451] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11470),
  [17454] = {.count = 1, .reusable = true}, SHIFT(12329),
  [17456] = {.count = 1, .reusable = true}, SHIFT(12330),
  [17458] = {.count = 1, .reusable = true}, SHIFT(12332),
  [17460] = {.count = 1, .reusable = true}, SHIFT(11490),
  [17462] = {.count = 1, .reusable = true}, SHIFT(12064),
  [17464] = {.count = 1, .reusable = true}, SHIFT(12341),
  [17466] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11537),
  [17469] = {.count = 1, .reusable = true}, SHIFT(12358),
  [17471] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [17473] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [17475] = {.count = 1, .reusable = true}, SHIFT(12359),
  [17477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11557),
  [17480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11564),
  [17483] = {.count = 1, .reusable = true}, SHIFT(12360),
  [17485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11576),
  [17488] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11581),
  [17491] = {.count = 1, .reusable = true}, SHIFT(12361),
  [17493] = {.count = 1, .reusable = true}, SHIFT(12120),
  [17495] = {.count = 1, .reusable = true}, SHIFT(11627),
  [17497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11645),
  [17500] = {.count = 1, .reusable = true}, SHIFT(12388),
  [17502] = {.count = 1, .reusable = true}, SHIFT(12389),
  [17504] = {.count = 1, .reusable = true}, SHIFT(12391),
  [17506] = {.count = 1, .reusable = true}, SHIFT(11665),
  [17508] = {.count = 1, .reusable = true}, SHIFT(12398),
  [17510] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11713),
  [17513] = {.count = 1, .reusable = true}, SHIFT(12428),
  [17515] = {.count = 1, .reusable = true}, SHIFT(12237),
  [17517] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11762),
  [17520] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11786),
  [17523] = {.count = 1, .reusable = true}, SHIFT(12248),
  [17525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11803),
  [17528] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11812),
  [17531] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11819),
  [17534] = {.count = 1, .reusable = true}, SHIFT(12260),
  [17536] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11853),
  [17539] = {.count = 1, .reusable = true}, SHIFT(12267),
  [17541] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11893),
  [17544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11908),
  [17547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11918),
  [17550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11925),
  [17553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11932),
  [17556] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11944),
  [17559] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11951),
  [17562] = {.count = 1, .reusable = true}, SHIFT(12439),
  [17564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11998),
  [17567] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12001),
  [17570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(12011),
  [17573] = {.count = 1, .reusable = true}, SHIFT(12442),
  [17575] = {.count = 1, .reusable = true}, SHIFT(12443),
  [17577] = {.count = 1, .reusable = true}, SHIFT(12445),
  [17579] = {.count = 1, .reusable = true}, SHIFT(12327),
  [17581] = {.count = 1, .reusable = true}, SHIFT(12448),
  [17583] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(12059),
  [17586] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12064),
  [17589] = {.count = 1, .reusable = true}, SHIFT(12451),
  [17591] = {.count = 1, .reusable = true}, SHIFT(12356),
  [17593] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [17595] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [17597] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12120),
  [17600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(12131),
  [17603] = {.count = 1, .reusable = true}, SHIFT(12458),
  [17605] = {.count = 1, .reusable = true}, SHIFT(12386),
  [17607] = {.count = 1, .reusable = true}, SHIFT(12461),
  [17609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(12178),
  [17612] = {.count = 1, .reusable = true}, SHIFT(12462),
  [17614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12200),
  [17617] = {.count = 1, .reusable = true}, SHIFT(12465),
  [17619] = {.count = 1, .reusable = true}, SHIFT(12426),
  [17621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12237),
  [17624] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12248),
  [17627] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12260),
  [17630] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12267),
  [17633] = {.count = 1, .reusable = true}, SHIFT(12440),
  [17635] = {.count = 1, .reusable = true}, SHIFT(12470),
  [17637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12327),
  [17640] = {.count = 1, .reusable = true}, SHIFT(12449),
  [17642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12356),
  [17645] = {.count = 1, .reusable = true}, SHIFT(12456),
  [17647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12386),
  [17650] = {.count = 1, .reusable = true}, SHIFT(12463),
  [17652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12426),
  [17655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12440),
  [17658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12449),
  [17661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12456),
  [17664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(12463),
};

void *tree_sitter_ruby_external_scanner_create();
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
